/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(V){for(var e=[],C=0,L=V.length;C<L;C++)e[C]=se[V[C]];return e};define(se[134],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function C(p,m,g){const d=L(p,m);if(d!==-1)return p[d]}e.findLast=C;function L(p,m,g=p.length-1){for(let d=g;d>=0;d--){const a=p[d];if(m(a))return d}return-1}e.findLastIdx=L;function r(p,m){const g=O(p,m);return g===-1?void 0:p[g]}e.findLastMonotonous=r;function O(p,m,g=0,d=p.length){let a=g,P=d;for(;a<P;){const h=Math.floor((a+P)/2);m(p[h])?a=h+1:P=h}return a-1}e.findLastIdxMonotonous=O;function D(p,m){const g=I(p,m);return g===p.length?void 0:p[g]}e.findFirstMonotonous=D;function I(p,m,g=0,d=p.length){let a=g,P=d;for(;a<P;){const h=Math.floor((a+P)/2);m(p[h])?P=h:a=h+1}return a}e.findFirstIdxMonotonousOrArrLen=I;function f(p,m,g=0,d=p.length){const a=I(p,m,g,d);return a===p.length?-1:a}e.findFirstIdxMonotonous=f;class u{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(u.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!m(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const g=O(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=g+1,g===-1?void 0:this._array[g]}}e.MonotonousArray=u;function y(p,m){if(p.length===0)return;let g=p[0];for(let d=1;d<p.length;d++){const a=p[d];m(a,g)>0&&(g=a)}return g}e.findFirstMaxBy=y;function b(p,m){if(p.length===0)return;let g=p[0];for(let d=1;d<p.length;d++){const a=p[d];m(a,g)>=0&&(g=a)}return g}e.findLastMaxBy=b;function w(p,m){return y(p,(g,d)=>-m(g,d))}e.findFirstMinBy=w;function l(p,m){if(p.length===0)return-1;let g=0;for(let d=1;d<p.length;d++){const a=p[d];m(a,p[g])>0&&(g=d)}return g}e.findMaxIdxBy=l;function S(p,m){for(const g of p){const d=m(g);if(d!==void 0)return d}}e.mapFindFirst=S}),define(se[135],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function C(D,I){const f=Object.create(null);for(const u of D){const y=I(u);let b=f[y];b||(b=f[y]=[]),b.push(u)}return f}e.groupBy=C;function L(D,I){const f=[],u=[];for(const y of D)I.has(y)||f.push(y);for(const y of I)D.has(y)||u.push(y);return{removed:f,added:u}}e.diffSets=L;function r(D,I){const f=[],u=[];for(const[y,b]of D)I.has(y)||f.push(b);for(const[y,b]of I)D.has(y)||u.push(b);return{removed:f,added:u}}e.diffMaps=r;function O(D,I){const f=new Set;for(const u of I)D.has(u)&&f.add(u);return f}e.intersection=O}),define(se[136],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function C(I,f){const u=Math.pow(10,f);return Math.round(I*u)/u}class L{constructor(f,u,y,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=C(Math.max(Math.min(1,b),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}e.RGBA=L;class r{constructor(f,u,y,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=C(Math.max(Math.min(1,u),0),3),this.l=C(Math.max(Math.min(1,y),0),3),this.a=C(Math.max(Math.min(1,b),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,y=f.g/255,b=f.b/255,w=f.a,l=Math.max(u,y,b),S=Math.min(u,y,b);let p=0,m=0;const g=(S+l)/2,d=l-S;if(d>0){switch(m=Math.min(g<=.5?d/(2*g):d/(2-2*g),1),l){case u:p=(y-b)/d+(y<b?6:0);break;case y:p=(b-u)/d+2;break;case b:p=(u-y)/d+4;break}p*=60,p=Math.round(p)}return new r(p,m,g,w)}static _hue2rgb(f,u,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?f+(u-f)*6*y:y<1/2?u:y<2/3?f+(u-f)*(2/3-y)*6:f}static toRGBA(f){const u=f.h/360,{s:y,l:b,a:w}=f;let l,S,p;if(y===0)l=S=p=b;else{const m=b<.5?b*(1+y):b+y-b*y,g=2*b-m;l=r._hue2rgb(g,m,u+1/3),S=r._hue2rgb(g,m,u),p=r._hue2rgb(g,m,u-1/3)}return new L(Math.round(l*255),Math.round(S*255),Math.round(p*255),w)}}e.HSLA=r;class O{constructor(f,u,y,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=C(Math.max(Math.min(1,u),0),3),this.v=C(Math.max(Math.min(1,y),0),3),this.a=C(Math.max(Math.min(1,b),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,y=f.g/255,b=f.b/255,w=Math.max(u,y,b),l=Math.min(u,y,b),S=w-l,p=w===0?0:S/w;let m;return S===0?m=0:w===u?m=((y-b)/S%6+6)%6:w===y?m=(b-u)/S+2:m=(u-y)/S+4,new O(Math.round(m*60),p,w,f.a)}static toRGBA(f){const{h:u,s:y,v:b,a:w}=f,l=b*y,S=l*(1-Math.abs(u/60%2-1)),p=b-l;let[m,g,d]=[0,0,0];return u<60?(m=l,g=S):u<120?(m=S,g=l):u<180?(g=l,d=S):u<240?(g=S,d=l):u<300?(m=S,d=l):u<=360&&(m=l,d=S),m=Math.round((m+p)*255),g=Math.round((g+p)*255),d=Math.round((d+p)*255),new L(m,g,d,w)}}e.HSVA=O;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this._hsla?this._hsla:r.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:O.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof L)this.rgba=f;else if(f instanceof r)this._hsla=f,this.rgba=r.toRGBA(f);else if(f instanceof O)this._hsva=f,this.rgba=O.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&L.equals(this.rgba,f.rgba)&&r.equals(this.hsla,f.hsla)&&O.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D._relativeLuminanceForComponent(this.rgba.r),u=D._relativeLuminanceForComponent(this.rgba.g),y=D._relativeLuminanceForComponent(this.rgba.b),b=.2126*f+.7152*u+.0722*y;return C(b,4)}static _relativeLuminanceForComponent(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),y=f.getRelativeLuminance();return u>y?(u+.05)/(y+.05):(y+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),y=f.getRelativeLuminance();return u>y}isDarkerThan(f){const u=this.getRelativeLuminance(),y=f.getRelativeLuminance();return u<y}lighten(f){return new D(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:y,b,a:w}=this.rgba;return new D(new L(u,y,b,w*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new L(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,y=this.rgba.a,b=u.a,w=y+b*(1-y);if(w<1e-6)return D.transparent;const l=this.rgba.r*y/w+u.r*b*(1-y)/w,S=this.rgba.g*y/w+u.g*b*(1-y)/w,p=this.rgba.b*y/w+u.b*b*(1-y)/w;return new D(new L(l,S,p,w))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:y,b,a:w}=this.rgba;return new D(new L(f.rgba.r-w*(f.rgba.r-u),f.rgba.g-w*(f.rgba.g-y),f.rgba.b-w*(f.rgba.b-b),1))}flatten(...f){const u=f.reduceRight((y,b)=>D._flatten(b,y));return D._flatten(this,u)}static _flatten(f,u){const y=1-f.rgba.a;return new D(new L(y*u.rgba.r+f.rgba.a*f.rgba.r,y*u.rgba.g+f.rgba.a*f.rgba.g,y*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(f,u,y){if(f.isLighterThan(u))return f;y=y||.5;const b=f.getRelativeLuminance(),w=u.getRelativeLuminance();return y=y*(w-b)/w,f.lighten(y)}static getDarkerColor(f,u,y){if(f.isDarkerThan(u))return f;y=y||.5;const b=f.getRelativeLuminance(),w=u.getRelativeLuminance();return y=y*(b-w)/b,f.darken(y)}static{this.white=new D(new L(255,255,255,1))}static{this.black=new D(new L(0,0,0,1))}static{this.red=new D(new L(255,0,0,1))}static{this.blue=new D(new L(0,0,255,1))}static{this.green=new D(new L(0,255,0,1))}static{this.cyan=new D(new L(0,255,255,1))}static{this.lightgrey=new D(new L(211,211,211,1))}static{this.transparent=new D(new L(0,0,0,0))}}e.Color=D,function(I){let f;(function(u){let y;(function(b){function w(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:I.Format.CSS.formatRGBA(i)}b.formatRGB=w;function l(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}b.formatRGBA=l;function S(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(i)}b.formatHSL=S;function p(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}b.formatHSLA=p;function m(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function g(i){return`#${m(i.rgba.r)}${m(i.rgba.g)}${m(i.rgba.b)}`}b.formatHex=g;function d(i,o=!1){return o&&i.rgba.a===1?I.Format.CSS.formatHex(i):`#${m(i.rgba.r)}${m(i.rgba.g)}${m(i.rgba.b)}${m(Math.round(i.rgba.a*255))}`}b.formatHexA=d;function a(i){return i.isOpaque()?I.Format.CSS.formatHex(i):I.Format.CSS.formatRGBA(i)}b.format=a;function P(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const s=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6));return new I(new L(s,t,n,1))}if(o===9){const s=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6)),c=16*h(i.charCodeAt(7))+h(i.charCodeAt(8));return new I(new L(s,t,n,c/255))}if(o===4){const s=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3));return new I(new L(16*s+s,16*t+t,16*n+n))}if(o===5){const s=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3)),c=h(i.charCodeAt(4));return new I(new L(16*s+s,16*t+t,16*n+n,(16*c+c)/255))}return null}b.parseHex=P;function h(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=u.CSS||(u.CSS={}))})(f=I.Format||(I.Format={}))}(D||(e.Color=D={}))}),define(se[56],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function C(D){return(I,f,u)=>{let y=null,b=null;if(typeof u.value=="function"?(y="value",b=u.value):typeof u.get=="function"&&(y="get",b=u.get),!b)throw new Error("not supported");u[y]=D(b,f)}}function L(D,I,f){let u=null,y=null;if(typeof f.value=="function"?(u="value",y=f.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",y=f.get),!y)throw new Error("not supported");const b=`$memoize$${I}`;f[u]=function(...w){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,w)}),this[b]}}e.memoize=L;function r(D,I,f){return C((u,y)=>{const b=`$debounce$${y}`,w=`$debounce$result$${y}`;return function(...l){this[w]||(this[w]=f?f():void 0),clearTimeout(this[b]),I&&(this[w]=I(this[w],...l),l=[this[w]]),this[b]=setTimeout(()=>{u.apply(this,l),this[w]=f?f():void 0},D)}})}e.debounce=r;function O(D,I,f){return C((u,y)=>{const b=`$throttle$timer$${y}`,w=`$throttle$result$${y}`,l=`$throttle$lastRun$${y}`,S=`$throttle$pending$${y}`;return function(...p){if(this[w]||(this[w]=f?f():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),I&&(this[w]=I(this[w],...p)),this[S])return;const m=this[l]+D;m<=Date.now()?(this[l]=Date.now(),u.apply(this,[this[w]]),this[w]=f?f():void 0):(this[S]=!0,this[b]=setTimeout(()=>{this[S]=!1,this[l]=Date.now(),u.apply(this,[this[w]]),this[w]=f?f():void 0},m-Date.now()))}})}e.throttle=O}),define(se[14],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class C{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=C,e.errorHandler=new C;function L(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=L;function r(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=r;function O(h){u(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=O;function D(h){u(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=D;function I(h){if(h instanceof Error){const{name:i,message:o}=h,s=h.stacktrace||h.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:a.isErrorNoTelemetry(h)}}return h}e.transformErrorForSerialization=I;const f="Canceled";function u(h){return h instanceof y?!0:h instanceof Error&&h.name===f&&h.message===f}e.isCancellationError=u;class y extends Error{constructor(){super(f),this.name=this.message}}e.CancellationError=y;function b(){const h=new Error(f);return h.name=h.message,h}e.canceled=b;function w(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=w;function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=l;class S extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=S;function p(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=p;class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=m;class g extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=g;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const o=new a;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class P extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,P.prototype)}}e.BugIndicatingError=P}),define(se[23],oe([0,1,14,134]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(z,K=0){return z[z.length-(1+K)]}e.tail=r;function O(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=O;function D(z,K,N=($,ee)=>$===ee){if(z===K)return!0;if(!z||!K||z.length!==K.length)return!1;for(let $=0,ee=z.length;$<ee;$++)if(!N(z[$],K[$]))return!1;return!0}e.equals=D;function I(z,K){const N=z.length-1;K<N&&(z[K]=z[N]),z.pop()}e.removeFastWithoutKeepingOrder=I;function f(z,K,N){return u(z.length,$=>N(z[$],K))}e.binarySearch=f;function u(z,K){let N=0,$=z-1;for(;N<=$;){const ee=(N+$)/2|0,ae=K(ee);if(ae<0)N=ee+1;else if(ae>0)$=ee-1;else return ee}return-(N+1)}e.binarySearch2=u;function y(z,K,N){if(z=z|0,z>=K.length)throw new TypeError("invalid index");const $=K[Math.floor(K.length*Math.random())],ee=[],ae=[],re=[];for(const me of K){const pe=N(me,$);pe<0?ee.push(me):pe>0?ae.push(me):re.push(me)}return z<ee.length?y(z,ee,N):z<ee.length+re.length?re[0]:y(z-(ee.length+re.length),ae,N)}e.quickSelect=y;function b(z,K){const N=[];let $;for(const ee of z.slice(0).sort(K))!$||K($[0],ee)!==0?($=[ee],N.push($)):$.push(ee);return N}e.groupBy=b;function*w(z,K){let N,$;for(const ee of z)$!==void 0&&K($,ee)?N.push(ee):(N&&(yield N),N=[ee]),$=ee;N&&(yield N)}e.groupAdjacentBy=w;function l(z,K){for(let N=0;N<=z.length;N++)K(N===0?void 0:z[N-1],N===z.length?void 0:z[N])}e.forEachAdjacent=l;function S(z,K){for(let N=0;N<z.length;N++)K(N===0?void 0:z[N-1],z[N],N+1===z.length?void 0:z[N+1])}e.forEachWithNeighbors=S;function p(z,K,N){const $=[];function ee(me,pe,ye){if(pe===0&&ye.length===0)return;const Ie=$[$.length-1];Ie&&Ie.start+Ie.deleteCount===me?(Ie.deleteCount+=pe,Ie.toInsert.push(...ye)):$.push({start:me,deleteCount:pe,toInsert:ye})}let ae=0,re=0;for(;;){if(ae===z.length){ee(ae,0,K.slice(re));break}if(re===K.length){ee(ae,z.length-ae,[]);break}const me=z[ae],pe=K[re],ye=N(me,pe);ye===0?(ae+=1,re+=1):ye<0?(ee(ae,1,[]),ae+=1):ye>0&&(ee(ae,0,[pe]),re+=1)}return $}e.sortedDiff=p;function m(z,K,N){const $=p(z,K,N),ee=[],ae=[];for(const re of $)ee.push(...z.slice(re.start,re.start+re.deleteCount)),ae.push(...re.toInsert);return{removed:ee,added:ae}}e.delta=m;function g(z,K,N){if(N===0)return[];const $=z.slice(0,N).sort(K);return a(z,K,$,N,z.length),$}e.top=g;function d(z,K,N,$,ee){return N===0?Promise.resolve([]):new Promise((ae,re)=>{(async()=>{const me=z.length,pe=z.slice(0,N).sort(K);for(let ye=N,Ie=Math.min(N+$,me);ye<me;ye=Ie,Ie=Math.min(Ie+$,me)){if(ye>N&&await new Promise(We=>setTimeout(We)),ee&&ee.isCancellationRequested)throw new C.CancellationError;a(z,K,pe,ye,Ie)}return pe})().then(ae,re)})}e.topAsync=d;function a(z,K,N,$,ee){for(const ae=N.length;$<ee;$++){const re=z[$];if(K(re,N[ae-1])<0){N.pop();const me=(0,L.findFirstIdxMonotonousOrArrLen)(N,pe=>K(re,pe)<0);N.splice(me,0,re)}}}function P(z){return z.filter(K=>!!K)}e.coalesce=P;function h(z){let K=0;for(let N=0;N<z.length;N++)z[N]&&(z[K]=z[N],K+=1);z.length=K}e.coalesceInPlace=h;function i(z,K,N){z.splice(N,0,z.splice(K,1)[0])}e.move=i;function o(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=o;function s(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=s;function t(z,K=N=>N){const N=new Set;return z.filter($=>{const ee=K($);return N.has(ee)?!1:(N.add(ee),!0)})}e.distinct=t;function n(z){const K=new Set;return N=>{const $=z(N);return K.has($)?!1:(K.add($),!0)}}e.uniqueFilter=n;function c(z,K){return z.length>0?z[0]:K}e.firstOrDefault=c;function v(z,K){return z.length>0?z[z.length-1]:K}e.lastOrDefault=v;function R(z,K,N=($,ee)=>$===ee){let $=0;for(let ee=0,ae=Math.min(z.length,K.length);ee<ae&&N(z[ee],K[ee]);ee++)$++;return $}e.commonPrefixLength=R;function k(z){return[].concat(...z)}e.flatten=k;function E(z,K){let N=typeof K=="number"?z:0;typeof K=="number"?N=z:(N=0,K=z);const $=[];if(N<=K)for(let ee=N;ee<K;ee++)$.push(ee);else for(let ee=N;ee>K;ee--)$.push(ee);return $}e.range=E;function M(z,K,N){return z.reduce(($,ee)=>($[K(ee)]=N?N(ee):ee,$),Object.create(null))}e.index=M;function _(z,K){return z.push(K),()=>T(z,K)}e.insert=_;function T(z,K){const N=z.indexOf(K);if(N>-1)return z.splice(N,1),K}e.remove=T;function U(z,K,N){const $=z.slice(0,K),ee=z.slice(K);return $.concat(N,ee)}e.arrayInsert=U;function X(z,K){let N;if(typeof K=="number"){let $=K;N=()=>{const ee=Math.sin($++)*179426549;return ee-Math.floor(ee)}}else N=Math.random;for(let $=z.length-1;$>0;$-=1){const ee=Math.floor(N()*($+1)),ae=z[$];z[$]=z[ee],z[ee]=ae}}e.shuffle=X;function Y(z,K){const N=z.indexOf(K);N>-1&&(z.splice(N,1),z.unshift(K))}e.pushToStart=Y;function le(z,K){const N=z.indexOf(K);N>-1&&(z.splice(N,1),z.push(K))}e.pushToEnd=le;function ce(z,K){for(const N of K)z.push(N)}e.pushMany=ce;function ue(z,K){return Array.isArray(z)?z.map(K):K(z)}e.mapArrayOrNot=ue;function Q(z){return Array.isArray(z)?z:[z]}e.asArray=Q;function G(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=G;function x(z,K,N){const $=B(z,K),ee=z.length,ae=N.length;z.length=ee+ae;for(let re=ee-1;re>=$;re--)z[re+ae]=z[re];for(let re=0;re<ae;re++)z[re+$]=N[re]}e.insertInto=x;function W(z,K,N,$){const ee=B(z,K);let ae=z.splice(ee,N);return ae===void 0&&(ae=[]),x(z,ee,$),ae}e.splice=W;function B(z,K){return K<0?Math.max(K+z.length,0):Math.min(K,z.length)}var H;(function(z){function K(ae){return ae<0}z.isLessThan=K;function N(ae){return ae<=0}z.isLessThanOrEqual=N;function $(ae){return ae>0}z.isGreaterThan=$;function ee(ae){return ae===0}z.isNeitherLessOrGreaterThan=ee,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function q(z,K){return(N,$)=>K(z(N),z($))}e.compareBy=q;function Z(...z){return(K,N)=>{for(const $ of z){const ee=$(K,N);if(!H.isNeitherLessOrGreaterThan(ee))return ee}return H.neitherLessOrGreaterThan}}e.tieBreakComparators=Z;const de=(z,K)=>z-K;e.numberComparator=de;const j=(z,K)=>(0,e.numberComparator)(z?1:0,K?1:0);e.booleanComparator=j;function A(z){return(K,N)=>-z(K,N)}e.reverseOrder=A;class F{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let N=this.firstIdx;for(;N<this.items.length&&K(this.items[N]);)N++;const $=N===this.firstIdx?null:this.items.slice(this.firstIdx,N);return this.firstIdx=N,$}takeFromEndWhile(K){let N=this.lastIdx;for(;N>=0&&K(this.items[N]);)N--;const $=N===this.lastIdx?null:this.items.slice(N+1,this.lastIdx+1);return this.lastIdx=N,$}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const N=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,N}}e.ArrayQueue=F;class J{static{this.empty=new J(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(N=>(K(N),!0))}toArray(){const K=[];return this.iterate(N=>(K.push(N),!0)),K}filter(K){return new J(N=>this.iterate($=>K($)?N($):!0))}map(K){return new J(N=>this.iterate($=>N(K($))))}some(K){let N=!1;return this.iterate($=>(N=K($),!N)),N}findFirst(K){let N;return this.iterate($=>K($)?(N=$,!1):!0),N}findLast(K){let N;return this.iterate($=>(K($)&&(N=$),!0)),N}findLastMaxBy(K){let N,$=!0;return this.iterate(ee=>(($||H.isGreaterThan(K(ee,N)))&&($=!1,N=ee),!0)),N}}e.CallbackIterable=J}),define(se[137],oe([0,1,14]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=L;function r(f,u="Unreachable"){throw new Error(u)}e.assertNever=r;function O(f){if(!f)throw new C.BugIndicatingError("Assertion Failed")}e.assert=O;function D(f){if(!f()){debugger;f(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function I(f,u){let y=0;for(;y<f.length-1;){const b=f[y],w=f[y+1];if(!u(b,w))return!1;y++}return!0}e.checkAdjacentItems=I}),define(se[84],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function C(L,r){const O=this;let D=!1,I;return function(){if(D)return I;if(D=!0,r)try{I=L.apply(O,arguments)}finally{r()}else I=L.apply(O,arguments);return I}}e.createSingleCallFunction=C}),define(se[72],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(L){function r(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}L.is=r;const O=Object.freeze([]);function D(){return O}L.empty=D;function*I(h){yield h}L.single=I;function f(h){return r(h)?h:I(h)}L.wrap=f;function u(h){return h||O}L.from=u;function*y(h){for(let i=h.length-1;i>=0;i--)yield h[i]}L.reverse=y;function b(h){return!h||h[Symbol.iterator]().next().done===!0}L.isEmpty=b;function w(h){return h[Symbol.iterator]().next().value}L.first=w;function l(h,i){for(const o of h)if(i(o))return!0;return!1}L.some=l;function S(h,i){for(const o of h)if(i(o))return o}L.find=S;function*p(h,i){for(const o of h)i(o)&&(yield o)}L.filter=p;function*m(h,i){let o=0;for(const s of h)yield i(s,o++)}L.map=m;function*g(...h){for(const i of h)yield*i}L.concat=g;function d(h,i,o){let s=o;for(const t of h)s=i(s,t);return s}L.reduce=d;function*a(h,i,o=h.length){for(i<0&&(i+=h.length),o<0?o+=h.length:o>h.length&&(o=h.length);i<o;i++)yield h[i]}L.slice=a;function P(h,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,h];const s=h[Symbol.iterator]();for(let t=0;t<i;t++){const n=s.next();if(n.done)return[o,L.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return s}}]}L.consume=P})(C||(e.Iterable=C={}))}),define(se[44],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var r;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function D(i,o=!1){let s=0;const t=i.length;let n="",c=0,v=16,R=0;function k(Y){let le=0,ce=0;for(;le<Y;){const ue=i.charCodeAt(s);if(ue>=48&&ue<=57)ce=ce*16+ue-48;else if(ue>=65&&ue<=70)ce=ce*16+ue-65+10;else if(ue>=97&&ue<=102)ce=ce*16+ue-97+10;else break;s++,le++}return le<Y&&(ce=-1),ce}function E(Y){s=Y,n="",c=0,v=16,R=0}function M(){const Y=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&u(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&u(i.charCodeAt(s)))for(s++;s<i.length&&u(i.charCodeAt(s));)s++;else return R=3,i.substring(Y,s);let le=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&u(i.charCodeAt(s))){for(s++;s<i.length&&u(i.charCodeAt(s));)s++;le=s}else R=3;return i.substring(Y,le)}function _(){let Y="",le=s;for(;;){if(s>=t){Y+=i.substring(le,s),R=2;break}const ce=i.charCodeAt(s);if(ce===34){Y+=i.substring(le,s),s++;break}if(ce===92){if(Y+=i.substring(le,s),s++,s>=t){R=2;break}switch(i.charCodeAt(s++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const Q=k(4);Q>=0?Y+=String.fromCharCode(Q):R=4;break}default:R=5}le=s;continue}if(ce>=0&&ce<=31)if(f(ce)){Y+=i.substring(le,s),R=2;break}else R=6;s++}return Y}function T(){if(n="",R=0,c=s,s>=t)return c=t,v=17;let Y=i.charCodeAt(s);if(I(Y)){do s++,n+=String.fromCharCode(Y),Y=i.charCodeAt(s);while(I(Y));return v=15}if(f(Y))return s++,n+=String.fromCharCode(Y),Y===13&&i.charCodeAt(s)===10&&(s++,n+=`
`),v=14;switch(Y){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,n=_(),v=10;case 47:{const le=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<t&&!f(i.charCodeAt(s));)s++;return n=i.substring(le,s),v=12}if(i.charCodeAt(s+1)===42){s+=2;const ce=t-1;let ue=!1;for(;s<ce;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,ue=!0;break}s++}return ue||(s++,R=1),n=i.substring(le,s),v=13}return n+=String.fromCharCode(Y),s++,v=16}case 45:if(n+=String.fromCharCode(Y),s++,s===t||!u(i.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=M(),v=11;default:for(;s<t&&U(Y);)s++,Y=i.charCodeAt(s);if(c!==s){switch(n=i.substring(c,s),n){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return n+=String.fromCharCode(Y),s++,v=16}}function U(Y){if(I(Y)||f(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let Y;do Y=T();while(Y>=12&&Y<=15);return Y}return{setPosition:E,getPosition:()=>s,scan:o?X:T,getToken:()=>v,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>R}}e.createScanner=D;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function u(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function b(i,o){const s=[],t=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function R(k,E,M,_){c.value=k,c.offset=E,c.length=M,c.type=_,c.colonOffset=void 0,n=c}try{a(i,{onObjectBegin:(k,E)=>{if(o<=k)throw t;n=void 0,v=o>k,s.push("")},onObjectProperty:(k,E,M)=>{if(o<E||(R(k,E,M,"property"),s[s.length-1]=k,o<=E+M))throw t},onObjectEnd:(k,E)=>{if(o<=k)throw t;n=void 0,s.pop()},onArrayBegin:(k,E)=>{if(o<=k)throw t;n=void 0,s.push(0)},onArrayEnd:(k,E)=>{if(o<=k)throw t;n=void 0,s.pop()},onLiteralValue:(k,E,M)=>{if(o<E||(R(k,E,M,h(k)),o<=E+M))throw t},onSeparator:(k,E,M)=>{if(o<=E)throw t;if(k===":"&&n&&n.type==="property")n.colonOffset=E,v=!1,n=void 0;else if(k===","){const _=s[s.length-1];typeof _=="number"?s[s.length-1]=_+1:(v=!0,s[s.length-1]=""),n=void 0}}})}catch(k){if(k!==t)throw k}return{path:s,previousNode:n,isAtPropertyKey:v,matches:k=>{let E=0;for(let M=0;E<k.length&&M<s.length;M++)if(k[E]===s[M]||k[E]==="*")E++;else if(k[E]!=="**")return!1;return E===k.length}}}e.getLocation=b;function w(i,o=[],s=O.DEFAULT){let t=null,n=[];const c=[];function v(k){Array.isArray(n)?n.push(k):t!==null&&(n[t]=k)}return a(i,{onObjectBegin:()=>{const k={};v(k),c.push(n),n=k,t=null},onObjectProperty:k=>{t=k},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const k=[];v(k),c.push(n),n=k,t=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:v,onError:(k,E,M)=>{o.push({error:k,offset:E,length:M})}},s),n[0]}e.parse=w;function l(i,o=[],s=O.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(k){t.type==="property"&&(t.length=k-t.offset,t=t.parent)}function c(k){return t.children.push(k),k}a(i,{onObjectBegin:k=>{t=c({type:"object",offset:k,length:-1,parent:t,children:[]})},onObjectProperty:(k,E,M)=>{t=c({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:k,offset:E,length:M,parent:t})},onObjectEnd:(k,E)=>{t.length=k+E-t.offset,t=t.parent,n(k+E)},onArrayBegin:(k,E)=>{t=c({type:"array",offset:k,length:-1,parent:t,children:[]})},onArrayEnd:(k,E)=>{t.length=k+E-t.offset,t=t.parent,n(k+E)},onLiteralValue:(k,E,M)=>{c({type:h(k),offset:E,length:M,parent:t,value:k}),n(E+M)},onSeparator:(k,E,M)=>{t.type==="property"&&(k===":"?t.colonOffset=E:k===","&&n(E))},onError:(k,E,M)=>{o.push({error:k,offset:E,length:M})}},s);const R=t.children[0];return R&&delete R.parent,R}e.parseTree=l;function S(i,o){if(!i)return;let s=i;for(const t of o)if(typeof t=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===t){s=c.children[1],n=!0;break}if(!n)return}else{const n=t;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}e.findNodeAtLocation=S;function p(i){if(!i.parent||!i.parent.children)return[];const o=p(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}e.getNodePath=p;function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const o=Object.create(null);for(const s of i.children){const t=s.children[1];t&&(o[s.children[0].value]=m(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=m;function g(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}e.contains=g;function d(i,o,s=!1){if(g(i,o,s)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const c=d(t[n],o,s);if(c)return c}return i}}e.findNodeAtOffset=d;function a(i,o,s=O.DEFAULT){const t=D(i,!1);function n(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(q){return q?Z=>q(Z,t.getTokenOffset(),t.getTokenLength()):()=>!0}const v=n(o.onObjectBegin),R=c(o.onObjectProperty),k=n(o.onObjectEnd),E=n(o.onArrayBegin),M=n(o.onArrayEnd),_=c(o.onLiteralValue),T=c(o.onSeparator),U=n(o.onComment),X=c(o.onError),Y=s&&s.disallowComments,le=s&&s.allowTrailingComma;function ce(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:Y||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:Y?ue(10):U();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,Z=[],de=[]){if(X(q),Z.length+de.length>0){let j=t.getToken();for(;j!==17;){if(Z.indexOf(j)!==-1){ce();break}else if(de.indexOf(j)!==-1)break;j=ce()}}}function Q(q){const Z=t.getTokenValue();return q?_(Z):R(Z),ce(),!0}function G(){switch(t.getToken()){case 11:{let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}_(q);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return ce(),!0}function x(){return t.getToken()!==10?(ue(3,[],[2,5]),!1):(Q(!1),t.getToken()===6?(T(":"),ce(),H()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function W(){v(),ce();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||ue(4,[],[]),T(","),ce(),t.getToken()===2&&le)break}else q&&ue(6,[],[]);x()||ue(4,[],[2,5]),q=!0}return k(),t.getToken()!==2?ue(7,[2],[]):ce(),!0}function B(){E(),ce();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||ue(4,[],[]),T(","),ce(),t.getToken()===4&&le)break}else q&&ue(6,[],[]);H()||ue(4,[],[4,5]),q=!0}return M(),t.getToken()!==4?ue(8,[4],[]):ce(),!0}function H(){switch(t.getToken()){case 3:return B();case 1:return W();case 10:return Q(!0);default:return G()}}return ce(),t.getToken()===17?s.allowEmptyContent?!0:(ue(4,[],[]),!1):H()?(t.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.visit=a;function P(i,o){const s=D(i),t=[];let n,c=0,v;do switch(v=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:c!==v&&t.push(i.substring(c,v)),o!==void 0&&t.push(s.getTokenValue().replace(/[^\r\n]/g,o)),c=s.getPosition();break}while(n!==17);return t.join("")}e.stripComments=P;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(se[138],oe([0,1,44]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(u,y,b){let w,l,S,p,m;if(y){for(p=y.offset,m=p+y.length,S=p;S>0&&!f(u,S-1);)S--;let v=m;for(;v<u.length&&!f(u,v);)v++;l=u.substring(S,v),w=D(l,b)}else l=u,w=0,S=0,p=0,m=u.length;const g=I(b,u);let d=!1,a=0,P;b.insertSpaces?P=O(" ",b.tabSize||4):P="	";const h=(0,C.createScanner)(l,!1);let i=!1;function o(){return g+O(P,w+a)}function s(){let v=h.scan();for(d=!1;v===15||v===14;)d=d||v===14,v=h.scan();return i=v===16||h.getTokenError()!==0,v}const t=[];function n(v,R,k){!i&&R<m&&k>p&&u.substring(R,k)!==v&&t.push({offset:R,length:k-R,content:v})}let c=s();if(c!==17){const v=h.getTokenOffset()+S,R=O(P,w);n(R,S,v)}for(;c!==17;){let v=h.getTokenOffset()+h.getTokenLength()+S,R=s(),k="";for(;!d&&(R===12||R===13);){const M=h.getTokenOffset()+S;n(" ",v,M),v=h.getTokenOffset()+h.getTokenLength()+S,k=R===12?o():"",R=s()}if(R===2)c!==1&&(a--,k=o());else if(R===4)c!==3&&(a--,k=o());else{switch(c){case 3:case 1:a++,k=o();break;case 5:case 12:k=o();break;case 13:d?k=o():k=" ";break;case 6:k=" ";break;case 10:if(R===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?k=" ":R!==5&&R!==17&&(i=!0);break;case 16:i=!0;break}d&&(R===12||R===13)&&(k=o())}const E=h.getTokenOffset()+S;n(k,v,E),c=R}return t}e.format=L;function r(u,y){const b=JSON.stringify(u,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?b.replace(/\r\n|\r|\n/g,y.eol):b}e.toFormattedString=r;function O(u,y){let b="";for(let w=0;w<y;w++)b+=u;return b}function D(u,y){let b=0,w=0;const l=y.tabSize||4;for(;b<u.length;){const S=u.charAt(b);if(S===" ")w++;else if(S==="	")w+=l;else break;b++}return Math.floor(w/l)}function I(u,y){for(let b=0;b<y.length;b++){const w=y.charAt(b);if(w==="\r")return b+1<y.length&&y.charAt(b+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return u&&u.eol||`
`}e.getEOL=I;function f(u,y){return`\r
`.indexOf(u.charAt(y))!==-1}e.isEOL=f}),define(se[139],oe([0,1,44,138]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function r(u,y,b){return O(u,y,void 0,b)}e.removeProperty=r;function O(u,y,b,w,l){const S=y.slice(),p=[],m=(0,C.parseTree)(u,p);let g,d;for(;S.length>0&&(d=S.pop(),g=(0,C.findNodeAtLocation)(m,S),g===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(g)if(g.type==="object"&&typeof d=="string"&&Array.isArray(g.children)){const a=(0,C.findNodeAtLocation)(g,[d]);if(a!==void 0)if(b===void 0){if(!a.parent)throw new Error("Malformed AST");const P=g.children.indexOf(a.parent);let h,i=a.parent.offset+a.parent.length;if(P>0){const o=g.children[P-1];h=o.offset+o.length}else h=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return D(u,{offset:h,length:i-h,content:""},w)}else return D(u,{offset:a.offset,length:a.length,content:JSON.stringify(b)},w);else{if(b===void 0)return[];const P=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,h=l?l(g.children.map(o=>o.children[0].value)):g.children.length;let i;if(h>0){const o=g.children[h-1];i={offset:o.offset+o.length,length:0,content:","+P}}else g.children.length===0?i={offset:g.offset+1,length:0,content:P}:i={offset:g.offset+1,length:0,content:P+","};return D(u,i,w)}}else if(g.type==="array"&&typeof d=="number"&&Array.isArray(g.children))if(b!==void 0){const a=`${JSON.stringify(b)}`;let P;if(g.children.length===0||d===0)P={offset:g.offset+1,length:0,content:g.children.length===0?a:a+","};else{const h=d===-1||d>g.children.length?g.children.length:d,i=g.children[h-1];P={offset:i.offset+i.length,length:0,content:","+a}}return D(u,P,w)}else{const a=d,P=g.children[a];let h;if(g.children.length===1)h={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===a){const i=g.children[a-1],o=i.offset+i.length,s=g.offset+g.length;h={offset:o,length:s-2-o,content:""}}else h={offset:P.offset,length:g.children[a+1].offset-P.offset,content:""};return D(u,h,w)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${g.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return D(u,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(b)},w)}}e.setProperty=O;function D(u,y,b){let w=I(u,y),l=y.offset,S=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;l>0&&!(0,L.isEOL)(w,l-1);)l--;for(;S<w.length&&!(0,L.isEOL)(w,S);)S++}const p=(0,L.format)(w,{offset:l,length:S-l},b);for(let g=p.length-1;g>=0;g--){const d=p[g];w=I(w,d),l=Math.min(l,d.offset),S=Math.max(S,d.offset+d.length),S+=d.content.length-d.length}const m=u.length-(w.length-S)-l;return[{offset:l,length:m,content:w.substring(l,S)}]}e.withFormatting=D;function I(u,y){return u.substring(0,y.offset)+y.content+u.substring(y.offset+y.length)}e.applyEdit=I;function f(u,y){const b=y.slice(0).sort((l,S)=>{const p=l.offset-S.offset;return p===0?l.length-S.length:p});let w=u.length;for(let l=b.length-1;l>=0;l--){const S=b[l];if(S.offset+S.length<=w)u=I(u,S);else throw new Error("Overlapping edit");w=S.offset}return u}e.applyEdits=f}),define(se[62],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class C{constructor(r){this.executor=r,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(r){this._error=r}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=C}),define(se[101],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class C{static{this.Undefined=new C(void 0)}constructor(O){this.element=O,this.next=C.Undefined,this.prev=C.Undefined}}class L{constructor(){this._first=C.Undefined,this._last=C.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===C.Undefined}clear(){let O=this._first;for(;O!==C.Undefined;){const D=O.next;O.prev=C.Undefined,O.next=C.Undefined,O=D}this._first=C.Undefined,this._last=C.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,D){const I=new C(O);if(this._first===C.Undefined)this._first=I,this._last=I;else if(D){const u=this._last;this._last=I,I.prev=u,u.next=I}else{const u=this._first;this._first=I,I.next=u,u.prev=I}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(I))}}shift(){if(this._first!==C.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==C.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==C.Undefined&&O.next!==C.Undefined){const D=O.prev;D.next=O.next,O.next.prev=D}else O.prev===C.Undefined&&O.next===C.Undefined?(this._first=C.Undefined,this._last=C.Undefined):O.next===C.Undefined?(this._last=this._last.prev,this._last.next=C.Undefined):O.prev===C.Undefined&&(this._first=this._first.next,this._first.prev=C.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==C.Undefined;)yield O.element,O=O.next}}e.LinkedList=L}),define(se[31],oe([0,1]),function(V,e){"use strict";var C,L,r;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(d,a,P){let h=d.get(a);return h===void 0&&(h=P,d.set(a,h)),h}e.getOrSet=O;function D(d){const a=[];return d.forEach((P,h)=>{a.push(`${h} => ${P}`)}),`Map(${d.size}) {${a.join(", ")}}`}e.mapToString=D;function I(d){const a=[];return d.forEach(P=>{a.push(P)}),`Set(${d.size}) {${a.join(", ")}}`}e.setToString=I;class f{constructor(a,P){this.uri=a,this.value=P}}function u(d){return Array.isArray(d)}class y{static{this.defaultToKey=a=>a.toString()}constructor(a,P){if(this[C]="ResourceMap",a instanceof y)this.map=new Map(a.map),this.toKey=P??y.defaultToKey;else if(u(a)){this.map=new Map,this.toKey=P??y.defaultToKey;for(const[h,i]of a)this.set(h,i)}else this.map=new Map,this.toKey=a??y.defaultToKey}set(a,P){return this.map.set(this.toKey(a),new f(a,P)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,P){typeof P<"u"&&(a=a.bind(P));for(const[h,i]of this.map)a(i.value,i.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=y;class b{constructor(a,P){this[L]="ResourceSet",!a||typeof a=="function"?this._map=new y(a):(this._map=new y(P),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,P){this._map.forEach((h,i)=>a.call(P,i,i,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var w;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class l{constructor(){this[r]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,P=0){const h=this._map.get(a);if(h)return P!==0&&this.touch(h,P),h.value}set(a,P,h=0){let i=this._map.get(a);if(i)i.value=P,h!==0&&this.touch(i,h);else{switch(i={key:a,value:P,next:void 0,previous:void 0},h){case 0:this.addItemLast(i);break;case 1:this.addItemFirst(i);break;case 2:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(a,i),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const P=this._map.get(a);if(P)return this._map.delete(a),this.removeItem(P),this._size--,P.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,P){const h=this._state;let i=this._head;for(;i;){if(P?a.bind(P)(i.value,i.key,this):a(i.value,i.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const a=this,P=this._state;let h=this._head;const i={[Symbol.iterator](){return i},next(){if(a._state!==P)throw new Error("LinkedMap got modified during iteration.");if(h){const o={value:h.key,done:!1};return h=h.next,o}else return{value:void 0,done:!0}}};return i}values(){const a=this,P=this._state;let h=this._head;const i={[Symbol.iterator](){return i},next(){if(a._state!==P)throw new Error("LinkedMap got modified during iteration.");if(h){const o={value:h.value,done:!1};return h=h.next,o}else return{value:void 0,done:!0}}};return i}entries(){const a=this,P=this._state;let h=this._head;const i={[Symbol.iterator](){return i},next(){if(a._state!==P)throw new Error("LinkedMap got modified during iteration.");if(h){const o={value:[h.key,h.value],done:!1};return h=h.next,o}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let P=this._head,h=this.size;for(;P&&h>a;)this._map.delete(P.key),P=P.next,h--;this._head=P,this._size=h,P&&(P.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const P=a.next,h=a.previous;if(!P||!h)throw new Error("Invalid list");P.previous=h,h.next=P}a.next=void 0,a.previous=void 0,this._state++}touch(a,P){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(P!==1&&P!==2)){if(P===1){if(a===this._head)return;const h=a.next,i=a.previous;a===this._tail?(i.next=void 0,this._tail=i):(h.previous=i,i.next=h),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(P===2){if(a===this._tail)return;const h=a.next,i=a.previous;a===this._head?(h.previous=void 0,this._head=h):(h.previous=i,i.next=h),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((P,h)=>{a.push([h,P])}),a}fromJSON(a){this.clear();for(const[P,h]of a)this.set(P,h)}}e.LinkedMap=l;class S extends l{constructor(a,P=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,P),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,P=2){return super.get(a,P)}peek(a){return super.get(a,0)}set(a,P){return super.set(a,P,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=S;class p{constructor(){this.map=new Map}add(a){return this.map.set(a,(this.map.get(a)||0)+1),this}delete(a){let P=this.map.get(a)||0;return P===0?!1:(P--,P===0?this.map.delete(a):this.map.set(a,P),!0)}has(a){return this.map.has(a)}}e.CounterSet=p;class m{constructor(a){if(this._m1=new Map,this._m2=new Map,a)for(const[P,h]of a)this.set(P,h)}clear(){this._m1.clear(),this._m2.clear()}set(a,P){this._m1.set(a,P),this._m2.set(P,a)}get(a){return this._m1.get(a)}getKey(a){return this._m2.get(a)}delete(a){const P=this._m1.get(a);return P===void 0?!1:(this._m1.delete(a),this._m2.delete(P),!0)}forEach(a,P){this._m1.forEach((h,i)=>{a.call(P,h,i,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=m;class g{constructor(){this.map=new Map}add(a,P){let h=this.map.get(a);h||(h=new Set,this.map.set(a,h)),h.add(P)}delete(a,P){const h=this.map.get(a);h&&(h.delete(P),h.size===0&&this.map.delete(a))}forEach(a,P){const h=this.map.get(a);h&&h.forEach(P)}get(a){const P=this.map.get(a);return P||new Set}}e.SetMap=g}),define(se[2],oe([0,1,23,135,31,84,72]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const I=!1;let f=null;class u{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(_){let T=this.livingDisposables.get(_);return T||(T={parent:null,source:null,isSingleton:!1,value:_,idx:u.idx++},this.livingDisposables.set(_,T)),T}trackDisposable(_){const T=this.getDisposableData(_);T.source||(T.source=new Error().stack)}setParent(_,T){const U=this.getDisposableData(_);U.parent=T}markAsDisposed(_){this.livingDisposables.delete(_)}markAsSingleton(_){this.getDisposableData(_).isSingleton=!0}getRootParent(_,T){const U=T.get(_);if(U)return U;const X=_.parent?this.getRootParent(this.getDisposableData(_.parent),T):_;return T.set(_,X),X}getTrackedDisposables(){const _=new Map;return[...this.livingDisposables.entries()].filter(([,U])=>U.source!==null&&!this.getRootParent(U,_).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(_=10,T){let U;if(T)U=T;else{const ue=new Map,Q=[...this.livingDisposables.values()].filter(x=>x.source!==null&&!this.getRootParent(x,ue).isSingleton);if(Q.length===0)return;const G=new Set(Q.map(x=>x.value));if(U=Q.filter(x=>!(x.parent&&G.has(x.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function X(ue){function Q(x,W){for(;x.length>0&&W.some(B=>typeof B=="string"?B===x[0]:x[0].match(B));)x.shift()}const G=ue.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return Q(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const Y=new r.SetMap;for(const ue of U){const Q=X(ue);for(let G=0;G<=Q.length;G++)Y.add(Q.slice(0,G).join(`
`),ue)}U.sort((0,C.compareBy)(ue=>ue.idx,C.numberComparator));let le="",ce=0;for(const ue of U.slice(0,_)){ce++;const Q=X(ue),G=[];for(let x=0;x<Q.length;x++){let W=Q[x];W=`(shared with ${Y.get(Q.slice(0,x+1).join(`
`)).size}/${U.length} leaks) at ${W}`;const H=Y.get(Q.slice(0,x).join(`
`)),q=(0,L.groupBy)([...H].map(Z=>X(Z)[x]),Z=>Z);delete q[Q[x]];for(const[Z,de]of Object.entries(q))G.unshift(`    - stacktraces of ${de.length} other leaks continue with ${Z}`);G.unshift(W)}le+=`


==================== Leaking disposable ${ce}/${U.length}: ${ue.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return U.length>_&&(le+=`


... and ${U.length-_} more leaking disposables

`),{leaks:U,details:le}}}e.DisposableTracker=u;function y(M){f=M}if(e.setDisposableTracker=y,I){const M="__is_disposable_tracked__";y(new class{trackDisposable(_){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[M]||console.log(T)},3e3)}setParent(_,T){if(_&&_!==i.None)try{_[M]=!0}catch{}}markAsDisposed(_){if(_&&_!==i.None)try{_[M]=!0}catch{}}markAsSingleton(_){}})}function b(M){return f?.trackDisposable(M),M}e.trackDisposable=b;function w(M){f?.markAsDisposed(M)}e.markAsDisposed=w;function l(M,_){f?.setParent(M,_)}function S(M,_){if(f)for(const T of M)f.setParent(T,_)}function p(M){return f?.markAsSingleton(M),M}e.markAsSingleton=p;function m(M){return typeof M.dispose=="function"&&M.dispose.length===0}e.isDisposable=m;function g(M){if(D.Iterable.is(M)){const _=[];for(const T of M)if(T)try{T.dispose()}catch(U){_.push(U)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(M)?[]:M}else if(M)return M.dispose(),M}e.dispose=g;function d(M){for(const _ of M)m(_)&&_.dispose();return[]}e.disposeIfDisposable=d;function a(...M){const _=P(()=>g(M));return S(M,_),_}e.combinedDisposable=a;function P(M){const _=b({dispose:(0,O.createSingleCallFunction)(()=>{w(_),M()})});return _}e.toDisposable=P;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{g(this._toDispose)}finally{this._toDispose.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return l(_,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(_),_}delete(_){if(_){if(_===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(_),_.dispose()}}deleteAndLeak(_){_&&this._toDispose.has(_)&&(this._toDispose.delete(_),l(_,null))}}e.DisposableStore=h;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new h,b(this),l(this._store,this)}dispose(){w(this),this._store.dispose()}_register(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(_)}}e.Disposable=i;class o{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(_){this._isDisposed||_===this._value||(this._value?.dispose(),_&&l(_,this),this._value=_)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const _=this._value;return this._value=void 0,_&&l(_,null),_}}e.MutableDisposable=o;class s{constructor(_){this._disposable=new o,this._isDisposed=!1,this._disposable.value=_}get value(){return this._disposable.value}set value(_){this._isDisposed||_===this._disposable.value||(this._disposable.value=_)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class t{constructor(_){this._disposable=_,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=t;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(_){let T=_;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,w(this))},this}}e.SafeDisposable=n;class c{constructor(){this.references=new Map}acquire(_,...T){let U=this.references.get(_);U||(U={counter:0,object:this.createReferencedObject(_,...T)},this.references.set(_,U));const{object:X}=U,Y=(0,O.createSingleCallFunction)(()=>{--U.counter===0&&(this.destroyReferencedObject(_,U.object),this.references.delete(_))});return U.counter++,{object:X,dispose:Y}}}e.ReferenceCollection=c;class v{constructor(_){this.referenceCollection=_}async acquire(_,...T){const U=this.referenceCollection.acquire(_,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(X){throw U.dispose(),X}}}e.AsyncReferenceCollection=v;class R{constructor(_){this.object=_}dispose(){}}e.ImmortalReference=R;function k(M){const _=new h;try{M(_)}finally{_.dispose()}}e.disposeOnReturn=k;class E{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){w(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{g(this._store.values())}finally{this._store.clear()}}has(_){return this._store.has(_)}get size(){return this._store.size}get(_){return this._store.get(_)}set(_,T,U=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this._store.get(_)?.dispose(),this._store.set(_,T)}deleteAndDispose(_){this._store.get(_)?.dispose(),this._store.delete(_)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=E}),define(se[85],oe([0,1,31]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new C.LRUCache(1e4);function r(u){return f(u,"NFC",L)}e.normalizeNFC=r;const O=new C.LRUCache(1e4);function D(u){return f(u,"NFD",O)}e.normalizeNFD=D;const I=/[^\u0000-\u0080]/;function f(u,y,b){if(!u)return u;const w=b.get(u);if(w)return w;let l;return I.test(u)?l=u.normalize(y):l=u,b.set(u,l),l}e.removeAccents=function(){const u=/[\u0300-\u036f]/g;return function(y){return D(y).replace(u,"")}}()}),define(se[140],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function C(I,f,u){return Math.min(Math.max(I,f),u)}e.clamp=C;function L(I,f){return(f+I%f)%f}e.rot=L;class r{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=r;class O{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class D{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const u=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=u,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function V(r){const O=[];typeof r=="number"&&O.push("code/timeOrigin",r);function D(f){O.push(f,Date.now())}function I(){const f=[];for(let u=0;u<O.length;u+=2)f.push({name:O[u],startTime:O[u+1]});return f}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const D of performance.getEntriesByType("mark"))O.push({name:D.name,startTime:Math.round(r+D.startTime)});return O}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function C(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=C(L))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var L in C)(typeof exports=="object"?exports:V)[L]=C[L]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function C(L){if(e[L])return e[L].exports;var r=e[L]={i:L,l:!1,exports:{}};return V[L].call(r.exports,r,r.exports,C),r.l=!0,r.exports}return C.m=V,C.c=e,C.d=function(L,r,O){C.o(L,r)||Object.defineProperty(L,r,{enumerable:!0,get:O})},C.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},C.t=function(L,r){if(1&r&&(L=C(L)),8&r||4&r&&typeof L=="object"&&L&&L.__esModule)return L;var O=Object.create(null);if(C.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:L}),2&r&&typeof L!="string")for(var D in L)C.d(O,D,function(I){return L[I]}.bind(null,D));return O},C.n=function(L){var r=L&&L.__esModule?function(){return L.default}:function(){return L};return C.d(r,"a",r),r},C.o=function(L,r){return Object.prototype.hasOwnProperty.call(L,r)},C.p="",C(C.s=0)}([function(V,e,C){(function(L){var r;e=V.exports=de,r=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],f=e.src=[],u=0,y=u++;f[y]="0|[1-9]\\d*";var b=u++;f[b]="[0-9]+";var w=u++;f[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=u++;f[l]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var S=u++;f[S]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var p=u++;f[p]="(?:"+f[y]+"|"+f[w]+")";var m=u++;f[m]="(?:"+f[b]+"|"+f[w]+")";var g=u++;f[g]="(?:-("+f[p]+"(?:\\."+f[p]+")*))";var d=u++;f[d]="(?:-?("+f[m]+"(?:\\."+f[m]+")*))";var a=u++;f[a]="[0-9A-Za-z-]+";var P=u++;f[P]="(?:\\+("+f[a]+"(?:\\."+f[a]+")*))";var h=u++,i="v?"+f[l]+f[g]+"?"+f[P]+"?";f[h]="^"+i+"$";var o="[v=\\s]*"+f[S]+f[d]+"?"+f[P]+"?",s=u++;f[s]="^"+o+"$";var t=u++;f[t]="((?:<|>)?=?)";var n=u++;f[n]=f[b]+"|x|X|\\*";var c=u++;f[c]=f[y]+"|x|X|\\*";var v=u++;f[v]="[v=\\s]*("+f[c]+")(?:\\.("+f[c]+")(?:\\.("+f[c]+")(?:"+f[g]+")?"+f[P]+"?)?)?";var R=u++;f[R]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[d]+")?"+f[P]+"?)?)?";var k=u++;f[k]="^"+f[t]+"\\s*"+f[v]+"$";var E=u++;f[E]="^"+f[t]+"\\s*"+f[R]+"$";var M=u++;f[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=u++;f[_]="(?:~>?)";var T=u++;f[T]="(\\s*)"+f[_]+"\\s+",I[T]=new RegExp(f[T],"g");var U=u++;f[U]="^"+f[_]+f[v]+"$";var X=u++;f[X]="^"+f[_]+f[R]+"$";var Y=u++;f[Y]="(?:\\^)";var le=u++;f[le]="(\\s*)"+f[Y]+"\\s+",I[le]=new RegExp(f[le],"g");var ce=u++;f[ce]="^"+f[Y]+f[v]+"$";var ue=u++;f[ue]="^"+f[Y]+f[R]+"$";var Q=u++;f[Q]="^"+f[t]+"\\s*("+o+")$|^$";var G=u++;f[G]="^"+f[t]+"\\s*("+i+")$|^$";var x=u++;f[x]="(\\s*)"+f[t]+"\\s*("+o+"|"+f[v]+")",I[x]=new RegExp(f[x],"g");var W=u++;f[W]="^\\s*("+f[v]+")\\s+-\\s+("+f[v]+")\\s*$";var B=u++;f[B]="^\\s*("+f[R]+")\\s+-\\s+("+f[R]+")\\s*$";var H=u++;f[H]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)r(q,f[q]),I[q]||(I[q]=new RegExp(f[q]));function Z(te,he){if(te instanceof de)return te;if(typeof te!="string"||te.length>O||!(he?I[s]:I[h]).test(te))return null;try{return new de(te,he)}catch{return null}}function de(te,he){if(te instanceof de){if(te.loose===he)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof de))return new de(te,he);r("SemVer",te,he),this.loose=he;var ge=te.trim().match(he?I[s]:I[h]);if(!ge)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Oe=+Me;if(Oe>=0&&Oe<D)return Oe}return Me}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Z,e.valid=function(te,he){var ge=Z(te,he);return ge?ge.version:null},e.clean=function(te,he){var ge=Z(te.trim().replace(/^[=v]+/,""),he);return ge?ge.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(te){return r("SemVer.compare",this.version,this.loose,te),te instanceof de||(te=new de(te,this.loose)),this.compareMain(te)||this.comparePre(te)},de.prototype.compareMain=function(te){return te instanceof de||(te=new de(te,this.loose)),A(this.major,te.major)||A(this.minor,te.minor)||A(this.patch,te.patch)},de.prototype.comparePre=function(te){if(te instanceof de||(te=new de(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var he=0;do{var ge=this.prerelease[he],Me=te.prerelease[he];if(r("prerelease compare",he,ge,Me),ge===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ge===void 0)return-1;if(ge!==Me)return A(ge,Me)}while(++he)},de.prototype.inc=function(te,he){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,he,ge,Me){typeof ge=="string"&&(Me=ge,ge=void 0);try{return new de(te,ge).inc(he,Me).version}catch{return null}},e.diff=function(te,he){if(K(te,he))return null;var ge=Z(te),Me=Z(he);if(ge.prerelease.length||Me.prerelease.length){for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Me[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Me[Oe])return Oe},e.compareIdentifiers=A;var j=/^[0-9]+$/;function A(te,he){var ge=j.test(te),Me=j.test(he);return ge&&Me&&(te=+te,he=+he),ge&&!Me?-1:Me&&!ge?1:te<he?-1:te>he?1:0}function F(te,he,ge){return new de(te,ge).compare(new de(he,ge))}function J(te,he,ge){return F(te,he,ge)>0}function z(te,he,ge){return F(te,he,ge)<0}function K(te,he,ge){return F(te,he,ge)===0}function N(te,he,ge){return F(te,he,ge)!==0}function $(te,he,ge){return F(te,he,ge)>=0}function ee(te,he,ge){return F(te,he,ge)<=0}function ae(te,he,ge,Me){var Oe;switch(he){case"===":typeof te=="object"&&(te=te.version),typeof ge=="object"&&(ge=ge.version),Oe=te===ge;break;case"!==":typeof te=="object"&&(te=te.version),typeof ge=="object"&&(ge=ge.version),Oe=te!==ge;break;case"":case"=":case"==":Oe=K(te,ge,Me);break;case"!=":Oe=N(te,ge,Me);break;case">":Oe=J(te,ge,Me);break;case">=":Oe=$(te,ge,Me);break;case"<":Oe=z(te,ge,Me);break;case"<=":Oe=ee(te,ge,Me);break;default:throw new TypeError("Invalid operator: "+he)}return Oe}function re(te,he){if(te instanceof re){if(te.loose===he)return te;te=te.value}if(!(this instanceof re))return new re(te,he);r("comparator",te,he),this.loose=he,this.parse(te),this.semver===me?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(te,he){return A(he,te)},e.major=function(te,he){return new de(te,he).major},e.minor=function(te,he){return new de(te,he).minor},e.patch=function(te,he){return new de(te,he).patch},e.compare=F,e.compareLoose=function(te,he){return F(te,he,!0)},e.rcompare=function(te,he,ge){return F(he,te,ge)},e.sort=function(te,he){return te.sort(function(ge,Me){return e.compare(ge,Me,he)})},e.rsort=function(te,he){return te.sort(function(ge,Me){return e.rcompare(ge,Me,he)})},e.gt=J,e.lt=z,e.eq=K,e.neq=N,e.gte=$,e.lte=ee,e.cmp=ae,e.Comparator=re;var me={};function pe(te,he){if(te instanceof pe)return te.loose===he?te:new pe(te.raw,he);if(te instanceof re)return new pe(te.value,he);if(!(this instanceof pe))return new pe(te,he);if(this.loose=he,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function ye(te){return!te||te.toLowerCase()==="x"||te==="*"}function Ie(te,he,ge,Me,Oe,Ne,_e,He,ze,Ve,ie,fe,ve){return((he=ye(ge)?"":ye(Me)?">="+ge+".0.0":ye(Oe)?">="+ge+"."+Me+".0":">="+he)+" "+(He=ye(ze)?"":ye(Ve)?"<"+(+ze+1)+".0.0":ye(ie)?"<"+ze+"."+(+Ve+1)+".0":fe?"<="+ze+"."+Ve+"."+ie+"-"+fe:"<="+He)).trim()}function We(te,he){for(var ge=0;ge<te.length;ge++)if(!te[ge].test(he))return!1;if(he.prerelease.length){for(ge=0;ge<te.length;ge++)if(r(te[ge].semver),te[ge].semver!==me&&te[ge].semver.prerelease.length>0){var Me=te[ge].semver;if(Me.major===he.major&&Me.minor===he.minor&&Me.patch===he.patch)return!0}return!1}return!0}function be(te,he,ge){try{he=new pe(he,ge)}catch{return!1}return he.test(te)}function Se(te,he,ge,Me){var Oe,Ne,_e,He,ze;switch(te=new de(te,Me),he=new pe(he,Me),ge){case">":Oe=J,Ne=ee,_e=z,He=">",ze=">=";break;case"<":Oe=z,Ne=$,_e=J,He="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(te,he,Me))return!1;for(var Ve=0;Ve<he.set.length;++Ve){var ie=he.set[Ve],fe=null,ve=null;if(ie.forEach(function(Pe){Pe.semver===me&&(Pe=new re(">=0.0.0")),fe=fe||Pe,ve=ve||Pe,Oe(Pe.semver,fe.semver,Me)?fe=Pe:_e(Pe.semver,ve.semver,Me)&&(ve=Pe)}),fe.operator===He||fe.operator===ze||(!ve.operator||ve.operator===He)&&Ne(te,ve.semver)||ve.operator===ze&&_e(te,ve.semver))return!1}return!0}re.prototype.parse=function(te){var he=this.loose?I[Q]:I[G],ge=te.match(he);if(!ge)throw new TypeError("Invalid comparator: "+te);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new de(ge[2],this.loose):this.semver=me},re.prototype.toString=function(){return this.value},re.prototype.test=function(te){return r("Comparator.test",te,this.loose),this.semver===me||(typeof te=="string"&&(te=new de(te,this.loose)),ae(te,this.operator,this.semver,this.loose))},re.prototype.intersects=function(te,he){if(!(te instanceof re))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new pe(te.value,he),be(this.value,ge,he);if(te.operator==="")return ge=new pe(this.value,he),be(te.semver,ge,he);var Me=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),Ne=this.semver.version===te.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),He=ae(this.semver,"<",te.semver,he)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),ze=ae(this.semver,">",te.semver,he)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return Me||Oe||Ne&&_e||He||ze},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(te){var he=this.loose;te=te.trim(),r("range",te,he);var ge=he?I[B]:I[W];te=te.replace(ge,Ie),r("hyphen replace",te),te=te.replace(I[x],"$1$2$3"),r("comparator trim",te,I[x]),te=(te=(te=te.replace(I[T],"$1~")).replace(I[le],"$1^")).split(/\s+/).join(" ");var Me=he?I[Q]:I[G],Oe=te.split(" ").map(function(Ne){return function(_e,He){return r("comp",_e),_e=function(ze,Ve){return ze.trim().split(/\s+/).map(function(ie){return function(fe,ve){r("caret",fe,ve);var Pe=ve?I[ue]:I[ce];return fe.replace(Pe,function(Re,De,Te,qe,xe){var Ke;return r("caret",fe,Re,De,Te,qe,xe),ye(De)?Ke="":ye(Te)?Ke=">="+De+".0.0 <"+(+De+1)+".0.0":ye(qe)?Ke=De==="0"?">="+De+"."+Te+".0 <"+De+"."+(+Te+1)+".0":">="+De+"."+Te+".0 <"+(+De+1)+".0.0":xe?(r("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ke=De==="0"?Te==="0"?">="+De+"."+Te+"."+qe+xe+" <"+De+"."+Te+"."+(+qe+1):">="+De+"."+Te+"."+qe+xe+" <"+De+"."+(+Te+1)+".0":">="+De+"."+Te+"."+qe+xe+" <"+(+De+1)+".0.0"):(r("no pr"),Ke=De==="0"?Te==="0"?">="+De+"."+Te+"."+qe+" <"+De+"."+Te+"."+(+qe+1):">="+De+"."+Te+"."+qe+" <"+De+"."+(+Te+1)+".0":">="+De+"."+Te+"."+qe+" <"+(+De+1)+".0.0"),r("caret return",Ke),Ke})}(ie,Ve)}).join(" ")}(_e,He),r("caret",_e),_e=function(ze,Ve){return ze.trim().split(/\s+/).map(function(ie){return function(fe,ve){var Pe=ve?I[X]:I[U];return fe.replace(Pe,function(Re,De,Te,qe,xe){var Ke;return r("tilde",fe,Re,De,Te,qe,xe),ye(De)?Ke="":ye(Te)?Ke=">="+De+".0.0 <"+(+De+1)+".0.0":ye(qe)?Ke=">="+De+"."+Te+".0 <"+De+"."+(+Te+1)+".0":xe?(r("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ke=">="+De+"."+Te+"."+qe+xe+" <"+De+"."+(+Te+1)+".0"):Ke=">="+De+"."+Te+"."+qe+" <"+De+"."+(+Te+1)+".0",r("tilde return",Ke),Ke})}(ie,Ve)}).join(" ")}(_e,He),r("tildes",_e),_e=function(ze,Ve){return r("replaceXRanges",ze,Ve),ze.split(/\s+/).map(function(ie){return function(fe,ve){fe=fe.trim();var Pe=ve?I[E]:I[k];return fe.replace(Pe,function(Re,De,Te,qe,xe,Ke){r("xRange",fe,Re,De,Te,qe,xe,Ke);var Ye=ye(Te),Xe=Ye||ye(qe),Je=Xe||ye(xe);return De==="="&&Je&&(De=""),Ye?Re=De===">"||De==="<"?"<0.0.0":"*":De&&Je?(Xe&&(qe=0),Je&&(xe=0),De===">"?(De=">=",Xe?(Te=+Te+1,qe=0,xe=0):Je&&(qe=+qe+1,xe=0)):De==="<="&&(De="<",Xe?Te=+Te+1:qe=+qe+1),Re=De+Te+"."+qe+"."+xe):Xe?Re=">="+Te+".0.0 <"+(+Te+1)+".0.0":Je&&(Re=">="+Te+"."+qe+".0 <"+Te+"."+(+qe+1)+".0"),r("xRange return",Re),Re})}(ie,Ve)}).join(" ")}(_e,He),r("xrange",_e),_e=function(ze,Ve){return r("replaceStars",ze,Ve),ze.trim().replace(I[H],"")}(_e,He),r("stars",_e),_e}(Ne,he)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Ne){return!!Ne.match(Me)})),Oe=Oe.map(function(Ne){return new re(Ne,he)})},pe.prototype.intersects=function(te,he){if(!(te instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Me){return te.set.some(function(Oe){return Oe.every(function(Ne){return Me.intersects(Ne,he)})})})})},e.toComparators=function(te,he){return new pe(te,he).set.map(function(ge){return ge.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new de(te,this.loose));for(var he=0;he<this.set.length;he++)if(We(this.set[he],te))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(te,he,ge){var Me=null,Oe=null;try{var Ne=new pe(he,ge)}catch{return null}return te.forEach(function(_e){Ne.test(_e)&&(Me&&Oe.compare(_e)!==-1||(Oe=new de(Me=_e,ge)))}),Me},e.minSatisfying=function(te,he,ge){var Me=null,Oe=null;try{var Ne=new pe(he,ge)}catch{return null}return te.forEach(function(_e){Ne.test(_e)&&(Me&&Oe.compare(_e)!==1||(Oe=new de(Me=_e,ge)))}),Me},e.validRange=function(te,he){try{return new pe(te,he).range||"*"}catch{return null}},e.ltr=function(te,he,ge){return Se(te,he,"<",ge)},e.gtr=function(te,he,ge){return Se(te,he,">",ge)},e.outside=Se,e.prerelease=function(te,he){var ge=Z(te,he);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(te,he,ge){return te=new pe(te,ge),he=new pe(he,ge),te.intersects(he)},e.coerce=function(te){if(te instanceof de)return te;if(typeof te!="string")return null;var he=te.match(I[M]);return he==null?null:Z((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,C(1))},function(V,e){var C,L,r=V.exports={};function O(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I(m){if(C===setTimeout)return setTimeout(m,0);if((C===O||!C)&&setTimeout)return C=setTimeout,setTimeout(m,0);try{return C(m,0)}catch{try{return C.call(null,m,0)}catch{return C.call(this,m,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:O}catch{C=O}try{L=typeof clearTimeout=="function"?clearTimeout:D}catch{L=D}})();var f,u=[],y=!1,b=-1;function w(){y&&f&&(y=!1,f.length?u=f.concat(u):b=-1,u.length&&l())}function l(){if(!y){var m=I(w);y=!0;for(var g=u.length;g;){for(f=u,u=[];++b<g;)f&&f[b].run();b=-1,g=u.length}f=null,y=!1,function(d){if(L===clearTimeout)return clearTimeout(d);if((L===D||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(d);try{L(d)}catch{try{return L.call(null,d)}catch{return L.call(this,d)}}}(m)}}function S(m,g){this.fun=m,this.array=g}function p(){}r.nextTick=function(m){var g=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)g[d-1]=arguments[d];u.push(new S(m,g)),u.length!==1||y||I(l)},S.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=p,r.addListener=p,r.once=p,r.off=p,r.removeListener=p,r.removeAllListeners=p,r.emit=p,r.prependListener=p,r.prependOnceListener=p,r.listeners=function(m){return[]},r.binding=function(m){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(m){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(se[141],oe([0,1]),function(V,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(I,f,u){this.level=I,this.key=f,this.value=u,this.forward=[]}}const r=void 0;class O{constructor(I,f=2**16){this.comparator=I,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new L(this._maxLevel,r,r)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,r,r),this._size=0}has(I){return!!O._search(this,I,this.comparator)}get(I){return O._search(this,I,this.comparator)?.value}set(I,f){return O._insert(this,I,f,this.comparator)&&(this._size+=1),this}delete(I){const f=O._delete(this,I,this.comparator);return f&&(this._size-=1),f}forEach(I,f){let u=this._header.forward[0];for(;u;)I.call(f,u.value,u.key,this),u=u.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",f=this._header.forward[0];for(;f;)I+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return I}static _search(I,f,u){let y=I._header;for(let b=I._level-1;b>=0;b--)for(;y.forward[b]&&u(y.forward[b].key,f)<0;)y=y.forward[b];if(y=y.forward[0],y&&u(y.key,f)===0)return y}static _insert(I,f,u,y){const b=[];let w=I._header;for(let l=I._level-1;l>=0;l--){for(;w.forward[l]&&y(w.forward[l].key,f)<0;)w=w.forward[l];b[l]=w}if(w=w.forward[0],w&&y(w.key,f)===0)return w.value=u,!1;{const l=O._randomLevel(I);if(l>I._level){for(let S=I._level;S<l;S++)b[S]=I._header;I._level=l}w=new L(l,f,u);for(let S=0;S<l;S++)w.forward[S]=b[S].forward[S],b[S].forward[S]=w;return!0}}static _randomLevel(I,f=.5){let u=1;for(;Math.random()<f&&u<I._maxLevel;)u+=1;return u}static _delete(I,f,u){const y=[];let b=I._header;for(let w=I._level-1;w>=0;w--){for(;b.forward[w]&&u(b.forward[w].key,f)<0;)b=b.forward[w];y[w]=b}if(b=b.forward[0],!b||u(b.key,f)!==0)return!1;for(let w=0;w<I._level&&y[w].forward[w]===b;w++)y[w].forward[w]=b.forward[w];for(;I._level>0&&I._header.forward[I._level-1]===r;)I._level-=1;return!0}}e.SkipList=O}),define(se[73],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(O){return new L(O)}constructor(O){this._now=C&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=L}),define(se[3],oe([0,1,14,84,2,101,73]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,f=!1;var u;(function(k){k.None=()=>r.Disposable.None;function E(ae){if(f){const{onDidAddListener:re}=ae,me=S.create();let pe=0;ae.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),re?.()}}}function M(ae,re){return G(ae,()=>{},0,void 0,!0,void 0,re)}k.defer=M;function _(ae){return(re,me=null,pe)=>{let ye=!1,Ie;return Ie=ae(We=>{if(!ye)return Ie?Ie.dispose():ye=!0,re.call(me,We)},null,pe),ye&&Ie.dispose(),Ie}}k.once=_;function T(ae,re,me){return ue((pe,ye=null,Ie)=>ae(We=>pe.call(ye,re(We)),null,Ie),me)}k.map=T;function U(ae,re,me){return ue((pe,ye=null,Ie)=>ae(We=>{re(We),pe.call(ye,We)},null,Ie),me)}k.forEach=U;function X(ae,re,me){return ue((pe,ye=null,Ie)=>ae(We=>re(We)&&pe.call(ye,We),null,Ie),me)}k.filter=X;function Y(ae){return ae}k.signal=Y;function le(...ae){return(re,me=null,pe)=>{const ye=(0,r.combinedDisposable)(...ae.map(Ie=>Ie(We=>re.call(me,We))));return Q(ye,pe)}}k.any=le;function ce(ae,re,me,pe){let ye=me;return T(ae,Ie=>(ye=re(ye,Ie),ye),pe)}k.reduce=ce;function ue(ae,re){let me;const pe={onWillAddFirstListener(){me=ae(ye.fire,ye)},onDidRemoveLastListener(){me?.dispose()}};re||E(pe);const ye=new a(pe);return re?.add(ye),ye.event}function Q(ae,re){return re instanceof Array?re.push(ae):re&&re.add(ae),ae}function G(ae,re,me=100,pe=!1,ye=!1,Ie,We){let be,Se,te,he=0,ge;const Me={leakWarningThreshold:Ie,onWillAddFirstListener(){be=ae(Ne=>{he++,Se=re(Se,Ne),pe&&!te&&(Oe.fire(Se),Se=void 0),ge=()=>{const _e=Se;Se=void 0,te=void 0,(!pe||he>1)&&Oe.fire(_e),he=0},typeof me=="number"?(clearTimeout(te),te=setTimeout(ge,me)):te===void 0&&(te=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&he>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,be.dispose()}};We||E(Me);const Oe=new a(Me);return We?.add(Oe),Oe.event}k.debounce=G;function x(ae,re=0,me){return k.debounce(ae,(pe,ye)=>pe?(pe.push(ye),pe):[ye],re,void 0,!0,void 0,me)}k.accumulate=x;function W(ae,re=(pe,ye)=>pe===ye,me){let pe=!0,ye;return X(ae,Ie=>{const We=pe||!re(Ie,ye);return pe=!1,ye=Ie,We},me)}k.latch=W;function B(ae,re,me){return[k.filter(ae,re,me),k.filter(ae,pe=>!re(pe),me)]}k.split=B;function H(ae,re=!1,me=[],pe){let ye=me.slice(),Ie=ae(Se=>{ye?ye.push(Se):be.fire(Se)});pe&&pe.add(Ie);const We=()=>{ye?.forEach(Se=>be.fire(Se)),ye=null},be=new a({onWillAddFirstListener(){Ie||(Ie=ae(Se=>be.fire(Se)),pe&&pe.add(Ie))},onDidAddFirstListener(){ye&&(re?setTimeout(We):We())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return pe&&pe.add(be),be.event}k.buffer=H;function q(ae,re){return(pe,ye,Ie)=>{const We=re(new de);return ae(function(be){const Se=We.evaluate(be);Se!==Z&&pe.call(ye,Se)},void 0,Ie)}}k.chain=q;const Z=Symbol("HaltChainable");class de{constructor(){this.steps=[]}map(re){return this.steps.push(re),this}forEach(re){return this.steps.push(me=>(re(me),me)),this}filter(re){return this.steps.push(me=>re(me)?me:Z),this}reduce(re,me){let pe=me;return this.steps.push(ye=>(pe=re(pe,ye),pe)),this}latch(re=(me,pe)=>me===pe){let me=!0,pe;return this.steps.push(ye=>{const Ie=me||!re(ye,pe);return me=!1,pe=ye,Ie?ye:Z}),this}evaluate(re){for(const me of this.steps)if(re=me(re),re===Z)break;return re}}function j(ae,re,me=pe=>pe){const pe=(...be)=>We.fire(me(...be)),ye=()=>ae.on(re,pe),Ie=()=>ae.removeListener(re,pe),We=new a({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return We.event}k.fromNodeEventEmitter=j;function A(ae,re,me=pe=>pe){const pe=(...be)=>We.fire(me(...be)),ye=()=>ae.addEventListener(re,pe),Ie=()=>ae.removeEventListener(re,pe),We=new a({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return We.event}k.fromDOMEventEmitter=A;function F(ae){return new Promise(re=>_(ae)(re))}k.toPromise=F;function J(ae){const re=new a;return ae.then(me=>{re.fire(me)},()=>{re.fire(void 0)}).finally(()=>{re.dispose()}),re.event}k.fromPromise=J;function z(ae,re,me){return re(me),ae(pe=>re(pe))}k.runAndSubscribe=z;function K(ae,re){let me=null;function pe(Ie){me?.dispose(),me=new r.DisposableStore,re(Ie,me)}pe(void 0);const ye=ae(Ie=>pe(Ie));return(0,r.toDisposable)(()=>{ye.dispose(),me?.dispose()})}k.runAndSubscribeWithStore=K;class N{constructor(re,me){this._observable=re,this._counter=0,this._hasChanged=!1;const pe={onWillAddFirstListener:()=>{re.addObserver(this)},onDidRemoveLastListener:()=>{re.removeObserver(this)}};me||E(pe),this.emitter=new a(pe),me&&me.add(this.emitter)}beginUpdate(re){this._counter++}handlePossibleChange(re){}handleChange(re,me){this._hasChanged=!0}endUpdate(re){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function $(ae,re){return new N(ae,re).emitter.event}k.fromObservable=$;function ee(ae){return(re,me,pe)=>{let ye=0,Ie=!1;const We={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ae.reportChanges(),Ie&&(Ie=!1,re.call(me)))},handlePossibleChange(){},handleChange(){Ie=!0}};ae.addObserver(We),ae.reportChanges();const be={dispose(){ae.removeObserver(We)}};return pe instanceof r.DisposableStore?pe.add(be):Array.isArray(pe)&&pe.push(be),be}}k.fromObservableLight=ee})(u||(e.Event=u={}));class y{static{this.all=new Set}static{this._idPool=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${y._idPool++}`,y.all.add(this)}start(E){this._stopWatch=new D.StopWatch,this.listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=y;let b=-1;function w(k){const E=b;return b=k,{dispose(){b=E}}}e.setGlobalLeakWarningThreshold=w;class l{constructor(E,M=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=M,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(E,M){const _=this.threshold;if(_<=0||M<_)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(E.value)||0;if(this._stacks.set(E.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let U,X=0;for(const[Y,le]of this._stacks)(!U||X<le)&&(U=Y,X=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${X}):`),console.warn(U)}return()=>{const U=this._stacks.get(E.value)||0;this._stacks.set(E.value,U-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class m{constructor(E){this.value=E,this.id=p++}}const g=2,d=(k,E)=>{if(k instanceof m)E(k);else for(let M=0;M<k.length;M++){const _=k[M];_&&E(_)}};class a{constructor(E){this._size=0,this._options=E,this._leakageMon=b>0||this._options?.leakWarningThreshold?new l(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(I){const E=this._listeners;queueMicrotask(()=>{d(E,M=>M.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(E,M,_)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.Disposable.None;if(this._disposed)return r.Disposable.None;M&&(E=E.bind(M));const T=new m(E);let U,X;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(T.stack=S.create(),U=this._leakageMon.check(T.stack,this._size+1)),I&&(T.stack=X??S.create()),this._listeners?this._listeners instanceof m?(this._deliveryQueue??=new h,this._listeners=[this._listeners,T]):this._listeners.push(T):(this._options?.onWillAddFirstListener?.(this),this._listeners=T,this._options?.onDidAddFirstListener?.(this)),this._size++;const Y=(0,r.toDisposable)(()=>{U?.(),this._removeListener(T)});return _ instanceof r.DisposableStore?_.add(Y):Array.isArray(_)&&_.push(Y),Y},this._event}_removeListener(E){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const M=this._listeners,_=M.indexOf(E);if(_===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,M[_]=void 0;const T=this._deliveryQueue.current===this;if(this._size*g<=M.length){let U=0;for(let X=0;X<M.length;X++)M[X]?M[U++]=M[X]:T&&(this._deliveryQueue.end--,U<this._deliveryQueue.i&&this._deliveryQueue.i--);M.length=U}}_deliver(E,M){if(!E)return;const _=this._options?.onListenerError||C.onUnexpectedError;if(!_){E.value(M);return}try{E.value(M)}catch(T){_(T)}}_deliverQueue(E){const M=E.current._listeners;for(;E.i<E.end;)this._deliver(M[E.i++],E.value);E.reset()}fire(E){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof m)this._deliver(this._listeners,E);else{const M=this._deliveryQueue;M.enqueue(this,E,this._listeners.length),this._deliverQueue(M)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=a;const P=()=>new h;e.createEventDeliveryQueue=P;class h{constructor(){this.i=-1,this.end=0}enqueue(E,M,_){this.i=0,this.end=_,this.current=E,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends a{async fireAsync(E,M,_){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList),d(this._listeners,T=>this._asyncDeliveryQueue.push([T.value,E]));this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[T,U]=this._asyncDeliveryQueue.shift(),X=[],Y={...U,token:M,waitUntil:le=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");_&&(le=_(le,T)),X.push(le)}};try{T(Y)}catch(le){(0,C.onUnexpectedError)(le);continue}Object.freeze(X),await Promise.allSettled(X).then(le=>{for(const ce of le)ce.status==="rejected"&&(0,C.onUnexpectedError)(ce.reason)})}}}e.AsyncEmitter=i;class o extends a{get isPaused(){return this._isPaused!==0}constructor(E){super(E),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=E?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._size&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=o;class s extends o{constructor(E){super(E),this._delay=E.delay??100}fire(E){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(E)}}e.DebounceEmitter=s;class t extends a{constructor(E){super(E),this._queuedEvents=[],this._mergeFn=E?.merge}fire(E){this.hasListeners()&&(this._queuedEvents.push(E),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(M=>super.fire(M)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=t;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const M={event:E,listener:null};this.events.push(M),this.hasListeners&&this.hook(M);const _=()=>{this.hasListeners&&this.unhook(M);const T=this.events.indexOf(M);this.events.splice(T,1)};return(0,r.toDisposable)((0,L.createSingleCallFunction)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(M=>this.emitter.fire(M))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class c{constructor(E,M,_,T){this._store=new r.DisposableStore;const U=this._store.add(new n),X=this._store.add(new r.DisposableMap);function Y(le){X.set(le,U.add(T(le)))}for(const le of E)Y(le);this._store.add(M(le=>{Y(le)})),this._store.add(_(le=>{X.deleteAndDispose(le)})),this.event=U.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=c;class v{constructor(){this.buffers=[]}wrapEvent(E){return(M,_,T)=>E(U=>{const X=this.buffers[this.buffers.length-1];X?X.push(()=>M.call(_,U)):M.call(_,U)},void 0,T)}bufferEvents(E){const M=[];this.buffers.push(M);const _=E();return this.buffers.pop(),M.forEach(T=>T()),_}}e.EventBufferer=v;class R{constructor(){this.listening=!1,this.inputEvent=u.None,this.inputEventListener=r.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=R}),define(se[22],oe([0,1,3]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(I,f){const u=setTimeout(I.bind(f),0);return{dispose(){clearTimeout(u)}}});var r;(function(I){function f(u){return u===I.None||u===I.Cancelled||u instanceof O?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}I.isCancellationToken=f,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(r||(e.CancellationToken=r={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new C.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=r.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=r.None}}e.CancellationTokenSource=D}),define(se[142],oe([0,1,22]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new C.CancellationTokenSource,f=this.task(I.token);return this.result={promise:f,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=L;class r{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const f=JSON.stringify(I);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=r;class O{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const f=this.fn(I);return this._map.set(I,f),f}}e.CachedFunction=O}),define(se[63],oe([0,1,14,2]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function r(P){const h=P;return h?typeof h.read=="function":!1}e.isReadable=r;function O(P){const h=P;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=O;function D(P){const h=P;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=D;function I(P,h){return new f(P,h)}e.newWriteableStream=I;class f{constructor(h,i){this.reducer=h,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h<"u"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(i=>i(h))}emitError(h){this.listeners.error.length===0?(0,C.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(i=>i(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,i){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(h,i){if(this.state.destroyed)return;let o;switch(h){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(P,h){const i=[];let o;for(;(o=P.read())!==null;)i.push(o);return h(i)}e.consumeReadable=u;function y(P,h,i){const o=[];let s;for(;(s=P.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?h(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return P.read()}}}e.peekReadable=y;function b(P,h){return new Promise((i,o)=>{const s=[];w(P,{onData:t=>{h&&s.push(t)},onError:t=>{h?o(t):i(void 0)},onEnd:()=>{i(h?h(s):void 0)}})})}e.consumeStream=b;function w(P,h,i){P.on("error",o=>{i?.isCancellationRequested||h.onError(o)}),P.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),P.on("data",o=>{i?.isCancellationRequested||h.onData(o)})}e.listenStream=w;function l(P,h){return new Promise((i,o)=>{const s=new L.DisposableStore,t=[],n=R=>{if(t.push(R),t.length>h)return s.dispose(),P.pause(),i({stream:P,buffer:t,ended:!1})},c=R=>(s.dispose(),o(R)),v=()=>(s.dispose(),i({stream:P,buffer:t,ended:!0}));s.add((0,L.toDisposable)(()=>P.removeListener("error",c))),P.on("error",c),s.add((0,L.toDisposable)(()=>P.removeListener("end",v))),P.on("end",v),s.add((0,L.toDisposable)(()=>P.removeListener("data",n))),P.on("data",n)})}e.peekStream=l;function S(P,h){const i=I(h);return i.end(P),i}e.toStream=S;function p(){const P=I(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=p;function m(P){let h=!1;return{read:()=>h?null:(h=!0,P)}}e.toReadable=m;function g(P,h,i){const o=I(i);return w(P,{onData:s=>o.write(h.data(s)),onError:s=>o.error(h.error?h.error(s):s),onEnd:()=>o.end()}),o}e.transform=g;function d(P,h,i){let o=!1;return{read:()=>{const s=h.read();return o?s:(o=!0,s!==null?i([P,s]):P)}}}e.prefixedReadable=d;function a(P,h,i){let o=!1;const s=I(i);return w(h,{onData:t=>o?s.write(t):(o=!0,s.write(i([P,t]))),onError:t=>s.error(t),onEnd:()=>{o||(o=!0,s.write(P)),s.end()}}),s}e.prefixedStream=a}),define(se[18],oe([0,1,62,63]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const r=typeof Buffer<"u",O=new C.Lazy(()=>new Uint8Array(256));let D,I;class f{static alloc(M){return r?new f(Buffer.allocUnsafe(M)):new f(new Uint8Array(M))}static wrap(M){return r&&!Buffer.isBuffer(M)&&(M=Buffer.from(M.buffer,M.byteOffset,M.byteLength)),new f(M)}static fromString(M,_){return!(_?.dontUseNodeBuffer||!1)&&r?new f(Buffer.from(M)):(D||(D=new TextEncoder),new f(D.encode(M)))}static fromByteArray(M){const _=f.alloc(M.length);for(let T=0,U=M.length;T<U;T++)_.buffer[T]=M[T];return _}static concat(M,_){if(typeof _>"u"){_=0;for(let X=0,Y=M.length;X<Y;X++)_+=M[X].byteLength}const T=f.alloc(_);let U=0;for(let X=0,Y=M.length;X<Y;X++){const le=M[X];T.set(le,U),U+=le.byteLength}return T}constructor(M){this.buffer=M,this.byteLength=this.buffer.byteLength}clone(){const M=f.alloc(this.byteLength);return M.set(this),M}toString(){return r?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(M,_){return new f(this.buffer.subarray(M,_))}set(M,_){if(M instanceof f)this.buffer.set(M.buffer,_);else if(M instanceof Uint8Array)this.buffer.set(M,_);else if(M instanceof ArrayBuffer)this.buffer.set(new Uint8Array(M),_);else if(ArrayBuffer.isView(M))this.buffer.set(new Uint8Array(M.buffer,M.byteOffset,M.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(M){return w(this.buffer,M)}writeUInt32BE(M,_){l(this.buffer,M,_)}readUInt32LE(M){return S(this.buffer,M)}writeUInt32LE(M,_){p(this.buffer,M,_)}readUInt8(M){return m(this.buffer,M)}writeUInt8(M,_){g(this.buffer,M,_)}indexOf(M,_=0){return u(this.buffer,M instanceof f?M.buffer:M,_)}}e.VSBuffer=f;function u(E,M,_=0){const T=M.byteLength,U=E.byteLength;if(T===0)return 0;if(T===1)return E.indexOf(M[0]);if(T>U-_)return-1;const X=O.value;X.fill(M.length);for(let ue=0;ue<M.length;ue++)X[M[ue]]=M.length-ue-1;let Y=_+M.length-1,le=Y,ce=-1;for(;Y<U;)if(E[Y]===M[le]){if(le===0){ce=Y;break}Y--,le--}else Y+=Math.max(M.length-le,X[E[Y]]),le=M.length-1;return ce}e.binaryIndexOf=u;function y(E,M){return E[M+0]<<0>>>0|E[M+1]<<8>>>0}e.readUInt16LE=y;function b(E,M,_){E[_+0]=M&255,M=M>>>8,E[_+1]=M&255}e.writeUInt16LE=b;function w(E,M){return E[M]*2**24+E[M+1]*2**16+E[M+2]*2**8+E[M+3]}e.readUInt32BE=w;function l(E,M,_){E[_+3]=M,M=M>>>8,E[_+2]=M,M=M>>>8,E[_+1]=M,M=M>>>8,E[_]=M}e.writeUInt32BE=l;function S(E,M){return E[M+0]<<0>>>0|E[M+1]<<8>>>0|E[M+2]<<16>>>0|E[M+3]<<24>>>0}e.readUInt32LE=S;function p(E,M,_){E[_+0]=M&255,M=M>>>8,E[_+1]=M&255,M=M>>>8,E[_+2]=M&255,M=M>>>8,E[_+3]=M&255}e.writeUInt32LE=p;function m(E,M){return E[M]}e.readUInt8=m;function g(E,M,_){E[_]=M}e.writeUInt8=g;function d(E){return L.consumeReadable(E,M=>f.concat(M))}e.readableToBuffer=d;function a(E){return L.toReadable(E)}e.bufferToReadable=a;function P(E){return L.consumeStream(E,M=>f.concat(M))}e.streamToBuffer=P;async function h(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await P(E.stream)])}e.bufferedStreamToBuffer=h;function i(E){return L.toStream(E,M=>f.concat(M))}e.bufferToStream=i;function o(E){return L.transform(E,{data:M=>typeof M=="string"?f.fromString(M):f.wrap(M)},M=>f.concat(M))}e.streamToBufferReadableStream=o;function s(E){return L.newWriteableStream(M=>f.concat(M),E)}e.newWriteableBufferStream=s;function t(E,M){return L.prefixedReadable(E,M,_=>f.concat(_))}e.prefixedBufferReadable=t;function n(E,M){return L.prefixedStream(E,M,_=>f.concat(_))}e.prefixedBufferStream=n;function c(E){let M=0,_=0,T=0;const U=new Uint8Array(Math.floor(E.length/4*3)),X=le=>{switch(_){case 3:U[T++]=M|le,_=0;break;case 2:U[T++]=M|le>>>2,M=le<<6,_=3;break;case 1:U[T++]=M|le>>>4,M=le<<4,_=2;break;default:M=le<<2,_=1}};for(let le=0;le<E.length;le++){const ce=E.charCodeAt(le);if(ce>=65&&ce<=90)X(ce-65);else if(ce>=97&&ce<=122)X(ce-97+26);else if(ce>=48&&ce<=57)X(ce-48+52);else if(ce===43||ce===45)X(62);else if(ce===47||ce===95)X(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const Y=T;for(;_>0;)X(0);return f.wrap(U).slice(0,Y)}e.decodeBase64=c;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:E},M=!0,_=!1){const T=_?R:v;let U="";const X=E.byteLength%3;let Y=0;for(;Y<E.byteLength-X;Y+=3){const le=E[Y+0],ce=E[Y+1],ue=E[Y+2];U+=T[le>>>2],U+=T[(le<<4|ce>>>4)&63],U+=T[(ce<<2|ue>>>6)&63],U+=T[ue&63]}if(X===1){const le=E[Y+0];U+=T[le>>>2],U+=T[le<<4&63],M&&(U+="==")}else if(X===2){const le=E[Y+0],ce=E[Y+1];U+=T[le>>>2],U+=T[(le<<4|ce>>>4)&63],U+=T[ce<<2&63],M&&(U+="=")}return U}e.encodeBase64=k}),define(se[25],oe([0,1,142,62]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=r;const O=/{(\d+)}/g;function D(ie,...fe){return fe.length===0?ie:ie.replace(O,function(ve,Pe){const Re=parseInt(Pe,10);return isNaN(Re)||Re<0||Re>=fe.length?ve:fe[Re]})}e.format=D;const I=/{([^}]+)}/g;function f(ie,fe){return Object.keys(fe).length===0?ie:ie.replace(I,(ve,Pe)=>fe[Pe]??ve)}e.format2=f;function u(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.escape=u;function y(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function b(ie,fe){let ve=0;const Pe=fe.charCodeAt(0);for(let Re=ie.length-1;Re>=0;Re--)ie.charCodeAt(Re)===Pe&&ve++;return ve}e.count=b;function w(ie,fe,ve="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${ve}`}e.truncate=w;function l(ie,fe,ve="\u2026"){if(ie.length<=fe)return ie;const Pe=Math.ceil(fe/2)-ve.length/2,Re=Math.floor(fe/2)-ve.length/2;return`${ie.substr(0,Pe)}${ve}${ie.substr(ie.length-Re)}`}e.truncateMiddle=l;function S(ie,fe=" "){const ve=p(ie,fe);return m(ve,fe)}e.trim=S;function p(ie,fe){if(!ie||!fe)return ie;const ve=fe.length;if(ve===0||ie.length===0)return ie;let Pe=0;for(;ie.indexOf(fe,Pe)===Pe;)Pe=Pe+ve;return ie.substring(Pe)}e.ltrim=p;function m(ie,fe){if(!ie||!fe)return ie;const ve=fe.length,Pe=ie.length;if(ve===0||Pe===0)return ie;let Re=Pe,De=-1;for(;De=ie.lastIndexOf(fe,Re-1),!(De===-1||De+ve!==Re);){if(De===0)return"";Re=De}return ie.substring(0,Re)}e.rtrim=m;function g(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function d(ie){return ie.replace(/\*/g,"")}e.stripWildcards=d;function a(ie,fe,ve={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=y(ie)),ve.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Pe="";return ve.global&&(Pe+="g"),ve.matchCase||(Pe+="i"),ve.multiline&&(Pe+="m"),ve.unicode&&(Pe+="u"),new RegExp(ie,Pe)}e.createRegExp=a;function P(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function h(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=h;function i(ie){for(let fe=0,ve=ie.length;fe<ve;fe++){const Pe=ie.charCodeAt(fe);if(Pe!==32&&Pe!==9)return fe}return-1}e.firstNonWhitespaceIndex=i;function o(ie,fe=0,ve=ie.length){for(let Pe=fe;Pe<ve;Pe++){const Re=ie.charCodeAt(Pe);if(Re!==32&&Re!==9)return ie.substring(fe,Pe)}return ie.substring(fe,ve)}e.getLeadingWhitespace=o;function s(ie,fe=ie.length-1){for(let ve=fe;ve>=0;ve--){const Pe=ie.charCodeAt(ve);if(Pe!==32&&Pe!==9)return ve}return-1}e.lastNonWhitespaceIndex=s;function t(ie,fe,ve){const Pe=[];let Re=0;for(const De of ie.matchAll(fe)){if(Pe.push(ie.slice(Re,De.index)),De.index===void 0)throw new Error("match.index should be defined");Re=De.index+De[0].length,Pe.push(ve(De[0],...De.slice(1),De.index,ie,De.groups))}return Pe.push(ie.slice(Re)),Promise.all(Pe).then(De=>De.join(""))}e.replaceAsync=t;function n(ie,fe){return ie<fe?-1:ie>fe?1:0}e.compare=n;function c(ie,fe,ve=0,Pe=ie.length,Re=0,De=fe.length){for(;ve<Pe&&Re<De;ve++,Re++){const xe=ie.charCodeAt(ve),Ke=fe.charCodeAt(Re);if(xe<Ke)return-1;if(xe>Ke)return 1}const Te=Pe-ve,qe=De-Re;return Te<qe?-1:Te>qe?1:0}e.compareSubstring=c;function v(ie,fe){return R(ie,fe,0,ie.length,0,fe.length)}e.compareIgnoreCase=v;function R(ie,fe,ve=0,Pe=ie.length,Re=0,De=fe.length){for(;ve<Pe&&Re<De;ve++,Re++){let xe=ie.charCodeAt(ve),Ke=fe.charCodeAt(Re);if(xe===Ke)continue;if(xe>=128||Ke>=128)return c(ie.toLowerCase(),fe.toLowerCase(),ve,Pe,Re,De);E(xe)&&(xe-=32),E(Ke)&&(Ke-=32);const Ye=xe-Ke;if(Ye!==0)return Ye}const Te=Pe-ve,qe=De-Re;return Te<qe?-1:Te>qe?1:0}e.compareSubstringIgnoreCase=R;function k(ie){return ie>=48&&ie<=57}e.isAsciiDigit=k;function E(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=E;function M(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=M;function _(ie,fe){return ie.length===fe.length&&R(ie,fe)===0}e.equalsIgnoreCase=_;function T(ie,fe){const ve=fe.length;return fe.length>ie.length?!1:R(ie,fe,0,ve)===0}e.startsWithIgnoreCase=T;function U(ie,fe){const ve=Math.min(ie.length,fe.length);let Pe;for(Pe=0;Pe<ve;Pe++)if(ie.charCodeAt(Pe)!==fe.charCodeAt(Pe))return Pe;return ve}e.commonPrefixLength=U;function X(ie,fe){const ve=Math.min(ie.length,fe.length);let Pe;const Re=ie.length-1,De=fe.length-1;for(Pe=0;Pe<ve;Pe++)if(ie.charCodeAt(Re-Pe)!==fe.charCodeAt(De-Pe))return Pe;return ve}e.commonSuffixLength=X;function Y(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=Y;function le(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=le;function ce(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.computeCodePoint=ce;function ue(ie,fe,ve){const Pe=ie.charCodeAt(ve);if(Y(Pe)&&ve+1<fe){const Re=ie.charCodeAt(ve+1);if(le(Re))return ce(Pe,Re)}return Pe}e.getNextCodePoint=ue;function Q(ie,fe){const ve=ie.charCodeAt(fe-1);if(le(ve)&&fe>1){const Pe=ie.charCodeAt(fe-2);if(Y(Pe))return ce(Pe,ve)}return ve}class G{get offset(){return this._offset}constructor(fe,ve=0){this._str=fe,this._len=fe.length,this._offset=ve}setOffset(fe){this._offset=fe}prevCodePoint(){const fe=Q(this._str,this._offset);return this._offset-=fe>=65536?2:1,fe}nextCodePoint(){const fe=ue(this._str,this._len,this._offset);return this._offset+=fe>=65536?2:1,fe}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class x{get offset(){return this._iterator.offset}constructor(fe,ve=0){this._iterator=new G(fe,ve)}nextGraphemeLength(){const fe=ge.getInstance(),ve=this._iterator,Pe=ve.offset;let Re=fe.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const De=ve.offset,Te=fe.getGraphemeBreakType(ve.nextCodePoint());if(te(Re,Te)){ve.setOffset(De);break}Re=Te}return ve.offset-Pe}prevGraphemeLength(){const fe=ge.getInstance(),ve=this._iterator,Pe=ve.offset;let Re=fe.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const De=ve.offset,Te=fe.getGraphemeBreakType(ve.prevCodePoint());if(te(Te,Re)){ve.setOffset(De);break}Re=Te}return Pe-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function W(ie,fe){return new x(ie,fe).nextGraphemeLength()}e.nextCharLength=W;function B(ie,fe){return new x(ie,fe).prevGraphemeLength()}e.prevCharLength=B;function H(ie,fe){fe>0&&le(ie.charCodeAt(fe))&&fe--;const ve=fe+W(ie,fe);return[ve-B(ie,ve),ve]}e.getCharContainingOffset=H;function q(ie){const fe=new x(ie);let ve=0;for(;!fe.eol();)ve++,fe.nextGraphemeLength();return ve}e.charCount=q;let Z;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(ie){return Z||(Z=de()),Z.test(ie)}e.containsRTL=j;const A=/^[\t\n\r\x20-\x7E]*$/;function F(ie){return A.test(ie)}e.isBasicASCII=F,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=J;function z(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=z;function K(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=K;function N(ie,fe){if(ie.length<fe)return ie;const ve=/\b/g;let Pe=0;for(;ve.test(ie)&&!(ie.length-ve.lastIndex<fe);)Pe=ve.lastIndex,ve.lastIndex+=1;return ie.substring(Pe).replace(/^\s/,"")}e.lcut=N;const $=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ee=/\x1b\].*?\x07/g;function ae(ie){return ie&&(ie=ie.replace($,"").replace(ee,"")),ie}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function re(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=re;function me(ie){return re(ie)?ie.substr(1):ie}e.stripUTF8BOM=me;function pe(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const ve=fe.length,Pe=ie.toLowerCase();let Re=0,De=-1;for(;Re<ve;){const Te=Pe.indexOf(fe[Re],De+1);if(Te<0)return!1;De=Te,Re++}return!0}e.fuzzyContains=pe;function ye(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=ye;function Ie(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Ie;function We(ie,fe=1){if(fe===0)return"";let ve=-1;do ve=ie.indexOf(`
`,ve+1),fe--;while(fe>0&&ve>=0);return ve===-1?ie:(ie[ve-1]==="\r"&&ve--,ie.substr(0,ve))}e.getNLines=We;function be(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=be;function Se(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=Se;function te(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var he;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class ge{static{this._INSTANCE=null}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const ve=this._data,Pe=ve.length/3;let Re=1;for(;Re<=Pe;)if(fe<ve[3*Re])Re=2*Re;else if(fe>ve[3*Re+1])Re=2*Re+1;else return ve[3*Re+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(ie,fe){if(ie===0)return 0;const ve=Ne(ie,fe);if(ve!==void 0)return ve;const Pe=new G(fe,ie);return Pe.prevCodePoint(),Pe.offset}e.getLeftDeleteOffset=Oe;function Ne(ie,fe){const ve=new G(fe,ie);let Pe=ve.prevCodePoint();for(;_e(Pe)||Pe===65039||Pe===8419;){if(ve.offset===0)return;Pe=ve.prevCodePoint()}if(!K(Pe))return;let Re=ve.offset;return Re>0&&ve.prevCodePoint()===8205&&(Re=ve.offset),Re}function _e(ie){return 127995<=ie&&ie<=127999}var He;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.noBreakWhitespace="\xA0";class ze{static{this.ambiguousCharacterData=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new C.LRUCachedFunction(fe=>{function ve(Ye){const Xe=new Map;for(let Je=0;Je<Ye.length;Je+=2)Xe.set(Ye[Je],Ye[Je+1]);return Xe}function Pe(Ye,Xe){const Je=new Map(Ye);for(const[st,nt]of Xe)Je.set(st,nt);return Je}function Re(Ye,Xe){if(!Ye)return Xe;const Je=new Map;for(const[st,nt]of Ye)Xe.has(st)&&Je.set(st,nt);return Je}const De=this.ambiguousCharacterData.value;let Te=fe.filter(Ye=>!Ye.startsWith("_")&&Ye in De);Te.length===0&&(Te=["_default"]);let qe;for(const Ye of Te){const Xe=ve(De[Ye]);qe=Re(qe,Xe)}const xe=ve(De._common),Ke=Pe(xe,qe);return new ze(Ke)})}static getInstance(fe){return ze.cache.get(Array.from(fe))}static{this._locales=new L.Lazy(()=>Object.keys(ze.ambiguousCharacterData.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return ze._locales.value}constructor(fe){this.confusableDictionary=fe}isAmbiguous(fe){return this.confusableDictionary.has(fe)}getPrimaryConfusable(fe){return this.confusableDictionary.get(fe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze;class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(fe){return Ve.getData().has(fe)}static get codePoints(){return Ve.getData()}}e.InvisibleCharacters=Ve}),define(se[45],oe([0,1,25]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(g){return r(g,0)}e.hash=L;function r(g,d){switch(typeof g){case"object":return g===null?O(349,d):Array.isArray(g)?f(g,d):u(g,d);case"string":return I(g,d);case"boolean":return D(g,d);case"number":return O(g,d);case"undefined":return O(937,d);default:return O(617,d)}}e.doHash=r;function O(g,d){return(d<<5)-d+g|0}e.numberHash=O;function D(g,d){return O(g?433:863,d)}function I(g,d){d=O(149417,d);for(let a=0,P=g.length;a<P;a++)d=O(g.charCodeAt(a),d);return d}e.stringHash=I;function f(g,d){return d=O(104579,d),g.reduce((a,P)=>r(P,a),d)}function u(g,d){return d=O(181387,d),Object.keys(g).sort().reduce((a,P)=>(a=I(P,a),r(g[P],a)),d)}class y{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=r(d,this._value),this._value}}e.Hasher=y;var b;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function w(g,d,a=32){const P=a-d,h=~((1<<P)-1);return(g<<d|(h&g)>>>P)>>>0}function l(g,d=0,a=g.byteLength,P=0){for(let h=0;h<a;h++)g[d+h]=P}function S(g,d,a="0"){for(;g.length<d;)g=a+g;return g}function p(g,d=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(a=>a.toString(16).padStart(2,"0")).join(""):S((g>>>0).toString(16),d/4)}e.toHexString=p;class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const a=d.length;if(a===0)return;const P=this._buff;let h=this._buffLen,i=this._leftoverHighSurrogate,o,s;for(i!==0?(o=i,s=-1,i=0):(o=d.charCodeAt(0),s=0);;){let t=o;if(C.isHighSurrogate(o))if(s+1<a){const n=d.charCodeAt(s+1);C.isLowSurrogate(n)?(s++,t=C.computeCodePoint(o,n)):t=65533}else{i=o;break}else C.isLowSurrogate(o)&&(t=65533);if(h=this._push(P,h,t),s++,s<a)o=d.charCodeAt(s);else break}this._buffLen=h,this._leftoverHighSurrogate=i}_push(d,a,P){return P<128?d[a++]=P:P<2048?(d[a++]=192|(P&1984)>>>6,d[a++]=128|(P&63)>>>0):P<65536?(d[a++]=224|(P&61440)>>>12,d[a++]=128|(P&4032)>>>6,d[a++]=128|(P&63)>>>0):(d[a++]=240|(P&1835008)>>>18,d[a++]=128|(P&258048)>>>12,d[a++]=128|(P&4032)>>>6,d[a++]=128|(P&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,l(this._buff,this._buffLen),this._buffLen>56&&(this._step(),l(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=m._bigBlock32,a=this._buffDV;for(let v=0;v<64;v+=4)d.setUint32(v,a.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)d.setUint32(v,w(d.getUint32(v-12,!1)^d.getUint32(v-32,!1)^d.getUint32(v-56,!1)^d.getUint32(v-64,!1),1),!1);let P=this._h0,h=this._h1,i=this._h2,o=this._h3,s=this._h4,t,n,c;for(let v=0;v<80;v++)v<20?(t=h&i|~h&o,n=1518500249):v<40?(t=h^i^o,n=1859775393):v<60?(t=h&i|h&o|i&o,n=2400959708):(t=h^i^o,n=3395469782),c=w(P,5)+t+s+n+d.getUint32(v*4,!1)&4294967295,s=o,o=i,i=w(h,30),h=P,P=c;this._h0=this._h0+P&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m}),define(se[74],oe([0,1,25]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(L||(L={})),function(r){const O="error",D="warning",I="warn",f="info",u="ignore";function y(w){return w?C.equalsIgnoreCase(O,w)?r.Error:C.equalsIgnoreCase(D,w)||C.equalsIgnoreCase(I,w)?r.Warning:C.equalsIgnoreCase(f,w)?r.Info:r.Ignore:r.Ignore}r.fromValue=y;function b(w){switch(w){case r.Error:return O;case r.Warning:return D;case r.Info:return f;default:return u}}r.toString=b}(L||(L={})),e.default=L}),define(se[143],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(se[57],oe([0,1,23,25]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class r{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const S=l.charCodeAt(0),p=this._value.charCodeAt(this._pos);return S-p}value(){return this._value[this._pos]}}e.StringIterator=r;class O{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,L.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class D{constructor(l=!0,S=!0){this._splitOnBackslash=l,this._caseSensitive=S}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let S=l.length-1;S>=0;S--,this._valueLen--){const p=this._value.charCodeAt(S);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const S=this._value.charCodeAt(this._to);if(S===47||this._splitOnBackslash&&S===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,L.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var I;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(I||(I={}));class f{constructor(l,S){this._ignorePathCasing=l,this._ignoreQueryAndFragment=S,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,L.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(y||(y={}));class b{static forUris(l=()=>!1,S=()=>!1){return new b(new f(l,S))}static forPaths(l=!1){return new b(new D(void 0,!l))}static forStrings(){return new b(new r)}static forConfigKeys(){return new b(new O)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,S){if(S){const p=S.slice(0);(0,C.shuffle)(p);for(const m of p)this.set(m,l)}else{const p=l.slice(0);(0,C.shuffle)(p);for(const m of p)this.set(m[0],m[1])}}set(l,S){const p=this._iter.reset(l);let m;this._root||(this._root=new u,this._root.segment=p.value());const g=[];for(m=this._root;;){const a=p.cmp(m.segment);if(a>0)m.left||(m.left=new u,m.left.segment=p.value()),g.push([-1,m]),m=m.left;else if(a<0)m.right||(m.right=new u,m.right.segment=p.value()),g.push([1,m]),m=m.right;else if(p.hasNext())p.next(),m.mid||(m.mid=new u,m.mid.segment=p.value()),g.push([0,m]),m=m.mid;else break}const d=m.value;m.value=S,m.key=l;for(let a=g.length-1;a>=0;a--){const P=g[a][1];P.updateHeight();const h=P.balanceFactor();if(h<-1||h>1){const i=g[a][0],o=g[a+1][0];if(i===1&&o===1)g[a][1]=P.rotateLeft();else if(i===-1&&o===-1)g[a][1]=P.rotateRight();else if(i===1&&o===-1)P.right=g[a+1][1]=g[a+1][1].rotateRight(),g[a][1]=P.rotateLeft();else if(i===-1&&o===1)P.left=g[a+1][1]=g[a+1][1].rotateLeft(),g[a][1]=P.rotateRight();else throw new Error;if(a>0)switch(g[a-1][0]){case-1:g[a-1][1].left=g[a][1];break;case 1:g[a-1][1].right=g[a][1];break;case 0:g[a-1][1].mid=g[a][1];break}else this._root=g[0][1]}}return d}get(l){return this._getNode(l)?.value}_getNode(l){const S=this._iter.reset(l);let p=this._root;for(;p;){const m=S.cmp(p.segment);if(m>0)p=p.left;else if(m<0)p=p.right;else if(S.hasNext())S.next(),p=p.mid;else break}return p}has(l){const S=this._getNode(l);return!(S?.value===void 0&&S?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,S){const p=this._iter.reset(l),m=[];let g=this._root;for(;g;){const d=p.cmp(g.segment);if(d>0)m.push([-1,g]),g=g.left;else if(d<0)m.push([1,g]),g=g.right;else if(p.hasNext())p.next(),m.push([0,g]),g=g.mid;else break}if(g){if(S?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const d=this._min(g.right);if(d.key){const{key:a,value:P,segment:h}=d;this._delete(d.key,!1),g.key=a,g.value=P,g.segment=h}}else{const d=g.left??g.right;if(m.length>0){const[a,P]=m[m.length-1];switch(a){case-1:P.left=d;break;case 0:P.mid=d;break;case 1:P.right=d;break}}else this._root=d}for(let d=m.length-1;d>=0;d--){const a=m[d][1];a.updateHeight();const P=a.balanceFactor();if(P>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),m[d][1]=a.rotateLeft()):P<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),m[d][1]=a.rotateRight()),d>0)switch(m[d-1][0]){case-1:m[d-1][1].left=m[d][1];break;case 1:m[d-1][1].right=m[d][1];break;case 0:m[d-1][1].mid=m[d][1];break}else this._root=m[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const S=this._iter.reset(l);let p=this._root,m;for(;p;){const g=S.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(S.hasNext())S.next(),m=p.value||m,p=p.mid;else break}return p&&p.value||m}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,S){const p=this._iter.reset(l);let m=this._root;for(;m;){const g=p.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(p.hasNext())p.next(),m=m.mid;else return m.mid?this._entries(m.mid):S?m.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[S,p]of this)l(p,S)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const S=[];return this._dfsEntries(l,S),S[Symbol.iterator]()}_dfsEntries(l,S){l&&(l.left&&this._dfsEntries(l.left,S),l.value&&S.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,S),l.right&&this._dfsEntries(l.right,S))}_isBalanced(){const l=S=>{if(!S)return!0;const p=S.balanceFactor();return p<-1||p>1?!1:l(S.left)&&l(S.right)};return l(this._root)}}e.TernarySearchTree=b}),define(se[12],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function C(h){return typeof h=="string"}e.isString=C;function L(h){return Array.isArray(h)&&h.every(i=>C(i))}e.isStringArray=L;function r(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=r;function O(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}e.isTypedArray=O;function D(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=D;function I(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=I;function f(h){return h===!0||h===!1}e.isBoolean=f;function u(h){return typeof h>"u"}e.isUndefined=u;function y(h){return!b(h)}e.isDefined=y;function b(h){return u(h)||h===null}e.isUndefinedOrNull=b;function w(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=w;function l(h){if(b(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=l;function S(...h){const i=[];for(let o=0;o<h.length;o++){const s=h[o];if(b(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(s)}return i}e.assertAllDefined=S;const p=Object.prototype.hasOwnProperty;function m(h){if(!r(h))return!1;for(const i in h)if(p.call(h,i))return!1;return!0}e.isEmptyObject=m;function g(h){return typeof h=="function"}e.isFunction=g;function d(...h){return h.length>0&&h.every(g)}e.areFunctions=d;function a(h,i){const o=Math.min(h.length,i.length);for(let s=0;s<o;s++)P(h[s],i[s])}e.validateConstraints=a;function P(h,i){if(C(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(h instanceof i)return}catch{}if(!b(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=P}),define(se[75],oe([0,1,12]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function r(I,f){if((0,C.isString)(f)){const u=L[f];if(u===void 0)throw new Error(`${I} references an unknown codicon: ${f}`);f=u}return L[I]=f,{id:I}}function O(){return L}e.getCodiconFontCharacters=O;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(se[38],oe([0,1,12]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const d=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([a,P])=>{d[a]=P&&typeof P=="object"?L(P):P}),d}e.deepClone=L;function r(g){if(!g||typeof g!="object")return g;const d=[g];for(;d.length>0;){const a=d.shift();Object.freeze(a);for(const P in a)if(O.call(a,P)){const h=a[P];typeof h=="object"&&!Object.isFrozen(h)&&!(0,C.isTypedArray)(h)&&d.push(h)}}return g}e.deepFreeze=r;const O=Object.prototype.hasOwnProperty;function D(g,d){return I(g,d,new Set)}e.cloneAndChange=D;function I(g,d,a){if((0,C.isUndefinedOrNull)(g))return g;const P=d(g);if(typeof P<"u")return P;if(Array.isArray(g)){const h=[];for(const i of g)h.push(I(i,d,a));return h}if((0,C.isObject)(g)){if(a.has(g))throw new Error("Cannot clone recursive data-structure");a.add(g);const h={};for(const i in g)O.call(g,i)&&(h[i]=I(g[i],d,a));return a.delete(g),h}return g}function f(g,d,a=!0){return(0,C.isObject)(g)?((0,C.isObject)(d)&&Object.keys(d).forEach(P=>{P in g?a&&((0,C.isObject)(g[P])&&(0,C.isObject)(d[P])?f(g[P],d[P],a):g[P]=d[P]):g[P]=d[P]}),g):d}e.mixin=f;function u(g,d){if(g===d)return!0;if(g==null||d===null||d===void 0||typeof g!=typeof d||typeof g!="object"||Array.isArray(g)!==Array.isArray(d))return!1;let a,P;if(Array.isArray(g)){if(g.length!==d.length)return!1;for(a=0;a<g.length;a++)if(!u(g[a],d[a]))return!1}else{const h=[];for(P in g)h.push(P);h.sort();const i=[];for(P in d)i.push(P);if(i.sort(),!u(h,i))return!1;for(a=0;a<h.length;a++)if(!u(g[h[a]],d[h[a]]))return!1}return!0}e.equals=u;function y(g){const d=new Set;return JSON.stringify(g,(a,P)=>{if((0,C.isObject)(P)||Array.isArray(P)){if(d.has(P))return"[Circular]";d.add(P)}return P})}e.safeStringify=y;function b(g,d){const a=Object.create(null);return!g||!d||Object.keys(d).forEach(h=>{const i=g[h],o=d[h];u(i,o)||(a[h]=o)}),a}e.distinct=b;function w(g,d){const a=d.toLowerCase(),P=Object.keys(g).find(h=>h.toLowerCase()===a);return P?g[P]:g[d]}e.getCaseInsensitive=w;function l(g,d){const a=Object.create(null);for(const[P,h]of Object.entries(g))d(P,h)&&(a[P]=h);return a}e.filter=l;function S(g){let d=[];for(;Object.prototype!==g;)d=d.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return d}e.getAllPropertyNames=S;function p(g){const d=[];for(const a of S(g))typeof g[a]=="function"&&d.push(a);return d}e.getAllMethodNames=p;function m(g,d){const a=h=>function(){const i=Array.prototype.slice.call(arguments,0);return d(h,i)},P={};for(const h of g)P[h]=a(h);return P}e.createProxyObject=m}),define(se[102],oe([0,1,75]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(D){function I(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=I})(L||(e.ThemeColor=L={}));function r(D){return{id:D}}e.themeColorFromId=r;var O;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(d){const a=I.exec(d.id);if(!a)return f(C.Codicon.error);const[,P,h]=a,i=["codicon","codicon-"+P];return h&&i.push("codicon-modifier-"+h.substring(1)),i}D.asClassNameArray=f;function u(d){return f(d).join(" ")}D.asClassName=u;function y(d){return"."+f(d).join(".")}D.asCSSSelector=y;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||L.isThemeColor(d.color))}D.isThemeIcon=b;const w=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function l(d){const a=w.exec(d);if(!a)return;const[,P]=a;return{id:P}}D.fromString=l;function S(d){return{id:d}}D.fromId=S;function p(d,a){let P=d.id;const h=P.lastIndexOf("~");return h!==-1&&(P=P.substring(0,h)),a&&(P=`${P}~${a}`),{id:P}}D.modify=p;function m(d){const a=d.id.lastIndexOf("~");if(a!==-1)return d.id.substring(a+1)}D.getModifier=m;function g(d,a){return d.id===a.id&&d.color?.id===a.color?.id}D.isEqual=g})(O||(e.ThemeIcon=O={}))}),define(se[32],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(r){return C.test(r)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(I){for(let f=0;f<I.length;f++)I[f]=Math.floor(Math.random()*256);return I};const O=new Uint8Array(16),D=[];for(let I=0;I<256;I++)D.push(I.toString(16).padStart(2,"0"));return function(){r(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,u="";return u+=D[O[f++]],u+=D[O[f++]],u+=D[O[f++]],u+=D[O[f++]],u+="-",u+=D[O[f++]],u+=D[O[f++]],u+="-",u+=D[O[f++]],u+=D[O[f++]],u+="-",u+=D[O[f++]],u+=D[O[f++]],u+="-",u+=D[O[f++]],u+=D[O[f++]],u+=D[O[f++]],u+=D[O[f++]],u+=D[O[f++]],u+=D[O[f++]],u}}()}),define(se[144],oe([0,1,86,46,84]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function O(D,I){if(await new Promise((y,b)=>{const w=L.createReadStream(D),l=C.createHash("sha1");w.pipe(l);const S=(0,r.createSingleCallFunction)((p,m)=>{w.removeAllListeners(),l.removeAllListeners(),p?b(p):y(m)});w.once("error",S),w.once("end",S),l.once("error",S),l.once("data",p=>S(void 0,p.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=O}),define(se[145],oe([0,1,26]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(D){const I=D.replace(/\-/g,":").toLowerCase();return!L.has(I)}function O(){const D=(0,C.networkInterfaces)();for(const I in D){const f=D[I];if(f){for(const{mac:u}of f)if(r(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(se[103],oe([0,1,87]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(I,f,u,y=1){let b=!1;return new Promise(w=>{const l=setTimeout(()=>{if(!b)return b=!0,w(0)},u);r(I,f,y,S=>{if(!b)return b=!0,clearTimeout(l),w(S)})})}e.findFreePort=L;function r(I,f,u,y){if(f===0)return y(0);const b=new C.Socket;b.once("connect",()=>(D(b),r(I+u,f-1,u,y))),b.once("data",()=>{}),b.once("error",w=>(D(b),w.code!=="ECONNREFUSED"?r(I+u,f-1,u,y):y(I))),b.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(I,f,u,y="127.0.0.1"){let b=!1,w,l=1;const S=C.createServer({pauseOnConnect:!0});function p(m,g){b||(b=!0,S.removeAllListeners(),S.close(),w&&clearTimeout(w),g(m))}return new Promise(m=>{w=setTimeout(()=>{p(0,m)},u),S.on("listening",()=>{p(I,m)}),S.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&l<f?(I++,l++,S.listen(I,y)):p(0,m)}),S.on("close",()=>{p(0,m)}),S.listen(I,y)})}e.findFreePortFaster=O;function D(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(f){console.error(f)}}}),function(){function V(){function e(){return process.uncHostAllowlist}function C(f){const u=new Set;if(Array.isArray(f))for(const y of f)typeof y=="string"&&u.add(y);return Array.from(u)}function L(){const f=e();return f?Array.from(f):[]}function r(f){if(process.platform!=="win32")return;const u=e();if(u)if(typeof f=="string")u.add(f.toLowerCase());else for(const y of C(f))r(y)}function O(f){if(typeof f!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const b of u){if(f.indexOf(b)!==0)continue;const l=f.indexOf("\\",b.length);if(l===-1)continue;const S=f.substring(b.length,l);if(S){y=S;break}}return y}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:r,getUNCHost:O,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(se[146],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(se[147],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class C{constructor(r,O){this.sender=r,this.onMessage=O}send(r){try{this.sender.send("vscode:message",r.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=C}),define(se[148],oe([11,10]),function(V,e){return V.create("vs/base/common/date",e)}),define(se[149],oe([0,1,148]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,r=L*60,O=r*24,D=O*7,I=O*30,f=O*365;function u(b,w,l,S){typeof b!="number"&&(b=b.getTime());const p=Math.round((new Date().getTime()-b)/1e3);if(p<-30)return(0,C.localize)(0,null,u(new Date().getTime()+p*1e3,!1));if(!S&&p<30)return(0,C.localize)(1,null);let m;return p<L?(m=p,w?m===1?l?(0,C.localize)(2,null,m):(0,C.localize)(3,null,m):l?(0,C.localize)(4,null,m):(0,C.localize)(5,null,m):m===1?l?(0,C.localize)(6,null,m):(0,C.localize)(7,null,m):l?(0,C.localize)(8,null,m):(0,C.localize)(9,null,m)):p<r?(m=Math.floor(p/L),w?m===1?l?(0,C.localize)(10,null,m):(0,C.localize)(11,null,m):l?(0,C.localize)(12,null,m):(0,C.localize)(13,null,m):m===1?l?(0,C.localize)(14,null,m):(0,C.localize)(15,null,m):l?(0,C.localize)(16,null,m):(0,C.localize)(17,null,m)):p<O?(m=Math.floor(p/r),w?m===1?l?(0,C.localize)(18,null,m):(0,C.localize)(19,null,m):l?(0,C.localize)(20,null,m):(0,C.localize)(21,null,m):m===1?l?(0,C.localize)(22,null,m):(0,C.localize)(23,null,m):l?(0,C.localize)(24,null,m):(0,C.localize)(25,null,m)):p<D?(m=Math.floor(p/O),w?m===1?(0,C.localize)(26,null,m):(0,C.localize)(27,null,m):m===1?(0,C.localize)(28,null,m):(0,C.localize)(29,null,m)):p<I?(m=Math.floor(p/D),w?m===1?l?(0,C.localize)(30,null,m):(0,C.localize)(31,null,m):l?(0,C.localize)(32,null,m):(0,C.localize)(33,null,m):m===1?l?(0,C.localize)(34,null,m):(0,C.localize)(35,null,m):l?(0,C.localize)(36,null,m):(0,C.localize)(37,null,m)):p<f?(m=Math.floor(p/I),w?m===1?l?(0,C.localize)(38,null,m):(0,C.localize)(39,null,m):l?(0,C.localize)(40,null,m):(0,C.localize)(41,null,m):m===1?l?(0,C.localize)(42,null,m):(0,C.localize)(43,null,m):l?(0,C.localize)(44,null,m):(0,C.localize)(45,null,m)):(m=Math.floor(p/f),w?m===1?l?(0,C.localize)(46,null,m):(0,C.localize)(47,null,m):l?(0,C.localize)(48,null,m):(0,C.localize)(49,null,m):m===1?l?(0,C.localize)(50,null,m):(0,C.localize)(51,null,m):l?(0,C.localize)(52,null,m):(0,C.localize)(53,null,m))}e.fromNow=u;function y(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(se[150],oe([11,10]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(se[50],oe([0,1,23,12,150]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(b,w){return w&&(b.stack||b.stacktrace)?r.localize(0,null,I(b),D(b.stack)||D(b.stacktrace)):I(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function I(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?r.localize(1,null,b.message):b.message||r.localize(2,null)}function f(b=null,w=!1){if(!b)return r.localize(3,null);if(Array.isArray(b)){const l=C.coalesce(b),S=f(l[0],w);return l.length>1?r.localize(4,null,S,l.length):S}if(L.isString(b))return b;if(b.detail){const l=b.detail;if(l.error)return O(l.error,w);if(l.exception)return O(l.exception,w)}return b.stack?O(b,w):b.message?b.message:r.localize(5,null)}e.toErrorMessage=f;function u(b){const w=b;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=u;function y(b,w){let l;return typeof b=="string"?l=new Error(b):l=b,l.actions=w,l}e.createErrorWithActions=y}),define(se[151],oe([11,10]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(se[152],oe([0,1,151]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(r){switch(r){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(se[153],oe([11,10]),function(V,e){return V.create("vs/base/common/platform",e)}),define(se[4],oe([0,1,153]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,r=!1,O=!1,D=!1,I=!1,f=!1,u=!1,y=!1,b=!1,w=!1,l,S=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,m,g;const d=globalThis;let a;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?a=d.vscode.process:typeof process<"u"&&(a=process);const P=typeof a?.versions?.electron=="string",h=P&&a?.type==="renderer";if(typeof navigator=="object"&&!h)g=navigator.userAgent,L=g.indexOf("Windows")>=0,r=g.indexOf("Macintosh")>=0,y=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=g.indexOf("Linux")>=0,w=g?.indexOf("Mobi")>=0,f=!0,l=C.getConfiguredDefaultLocale(C.localize(0,null))||e.LANGUAGE_DEFAULT,S=l,p=navigator.language;else if(typeof a=="object"){L=a.platform==="win32",r=a.platform==="darwin",O=a.platform==="linux",D=O&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,u=P,b=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const E=a.env.VSCODE_NLS_CONFIG;if(E)try{const M=JSON.parse(E),_=M.availableLanguages["*"];l=M.locale,p=M.osLocale,S=_||e.LANGUAGE_DEFAULT,m=M._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var i;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let s=0;r?s=1:L?s=3:O&&(s=2),e.isWindows=L,e.isMacintosh=r,e.isLinux=O,e.isLinuxSnap=D,e.isNative=I,e.isElectron=u,e.isWeb=f,e.isWebWorker=f&&typeof d.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?d.origin:void 0,e.isIOS=y,e.isMobile=w,e.isCI=b,e.platform=s,e.userAgent=g,e.language=S;var t;(function(E){function M(){return e.language}E.value=M;function _(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}E.isDefaultVariant=_;function T(){return e.language==="en"}E.isDefault=T})(t||(e.Language=t={})),e.locale=l,e.platformLocale=p,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof d.postMessage=="function"&&!d.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const E=[];d.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let T=0,U=E.length;T<U;T++){const X=E[T];if(X.id===_.data.vscodeScheduleAsyncWork){E.splice(T,1),X.callback();return}}});let M=0;return _=>{const T=++M;E.push({id:T,callback:_}),d.postMessage({vscodeScheduleAsyncWork:T},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||y?2:L?1:3;let c=!0,v=!1;function R(){if(!v){v=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,c=new Uint16Array(E.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=R,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function k(E){return parseFloat(E)>=20}e.isBigSurOrNewer=k}),define(se[35],oe([0,1,4]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const O=r.process;L={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return C.isWindows?"win32":C.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(se[9],oe([0,1,35]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,r=97,O=90,D=122,I=46,f=47,u=92,y=58,b=63;class w extends Error{constructor(o,s,t){let n;typeof s=="string"&&s.indexOf("not ")===0?(n="must not be",s=s.replace(/^not /,"")):n="must be";const c=o.indexOf(".")!==-1?"property":"argument";let v=`The "${o}" ${c} ${n} of type ${s}`;v+=`. Received type ${typeof t}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function l(i,o){if(i===null||typeof i!="object")throw new w(o,"Object",i)}function S(i,o){if(typeof i!="string")throw new w(o,"string",i)}const p=C.platform==="win32";function m(i){return i===f||i===u}function g(i){return i===f}function d(i){return i>=L&&i<=O||i>=r&&i<=D}function a(i,o,s,t){let n="",c=0,v=-1,R=0,k=0;for(let E=0;E<=i.length;++E){if(E<i.length)k=i.charCodeAt(E);else{if(t(k))break;k=f}if(t(k)){if(!(v===E-1||R===1))if(R===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const M=n.lastIndexOf(s);M===-1?(n="",c=0):(n=n.slice(0,M),c=n.length-1-n.lastIndexOf(s)),v=E,R=0;continue}else if(n.length!==0){n="",c=0,v=E,R=0;continue}}o&&(n+=n.length>0?`${s}..`:"..",c=2)}else n.length>0?n+=`${s}${i.slice(v+1,E)}`:n=i.slice(v+1,E),c=E-v-1;v=E,R=0}else k===I&&R!==-1?++R:R=-1}return n}function P(i,o){l(o,"pathObject");const s=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${t}`:`${s}${i}${t}`:t}e.win32={resolve(...i){let o="",s="",t=!1;for(let n=i.length-1;n>=-1;n--){let c;if(n>=0){if(c=i[n],S(c,"path"),c.length===0)continue}else o.length===0?c=C.cwd():(c=C.env[`=${o}`]||C.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===u)&&(c=`${o}\\`));const v=c.length;let R=0,k="",E=!1;const M=c.charCodeAt(0);if(v===1)m(M)&&(R=1,E=!0);else if(m(M))if(E=!0,m(c.charCodeAt(1))){let _=2,T=_;for(;_<v&&!m(c.charCodeAt(_));)_++;if(_<v&&_!==T){const U=c.slice(T,_);for(T=_;_<v&&m(c.charCodeAt(_));)_++;if(_<v&&_!==T){for(T=_;_<v&&!m(c.charCodeAt(_));)_++;(_===v||_!==T)&&(k=`\\\\${U}\\${c.slice(T,_)}`,R=_)}}}else R=1;else d(M)&&c.charCodeAt(1)===y&&(k=c.slice(0,2),R=2,v>2&&m(c.charCodeAt(2))&&(E=!0,R=3));if(k.length>0)if(o.length>0){if(k.toLowerCase()!==o.toLowerCase())continue}else o=k;if(t){if(o.length>0)break}else if(s=`${c.slice(R)}\\${s}`,t=E,E&&o.length>0)break}return s=a(s,!t,"\\",m),t?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){S(i,"path");const o=i.length;if(o===0)return".";let s=0,t,n=!1;const c=i.charCodeAt(0);if(o===1)return g(c)?"\\":i;if(m(c))if(n=!0,m(i.charCodeAt(1))){let R=2,k=R;for(;R<o&&!m(i.charCodeAt(R));)R++;if(R<o&&R!==k){const E=i.slice(k,R);for(k=R;R<o&&m(i.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&!m(i.charCodeAt(R));)R++;if(R===o)return`\\\\${E}\\${i.slice(k)}\\`;R!==k&&(t=`\\\\${E}\\${i.slice(k,R)}`,s=R)}}}else s=1;else d(c)&&i.charCodeAt(1)===y&&(t=i.slice(0,2),s=2,o>2&&m(i.charCodeAt(2))&&(n=!0,s=3));let v=s<o?a(i.slice(s),!n,"\\",m):"";return v.length===0&&!n&&(v="."),v.length>0&&m(i.charCodeAt(o-1))&&(v+="\\"),t===void 0?n?`\\${v}`:v:n?`${t}\\${v}`:`${t}${v}`},isAbsolute(i){S(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return m(s)||o>2&&d(s)&&i.charCodeAt(1)===y&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let c=0;c<i.length;++c){const v=i[c];S(v,"path"),v.length>0&&(o===void 0?o=s=v:o+=`\\${v}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof s=="string"&&m(s.charCodeAt(0))){++n;const c=s.length;c>1&&m(s.charCodeAt(1))&&(++n,c>2&&(m(s.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&m(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(i,o){if(S(i,"from"),S(o,"to"),i===o)return"";const s=e.win32.resolve(i),t=e.win32.resolve(o);if(s===t||(i=s.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===u;)n++;let c=i.length;for(;c-1>n&&i.charCodeAt(c-1)===u;)c--;const v=c-n;let R=0;for(;R<o.length&&o.charCodeAt(R)===u;)R++;let k=o.length;for(;k-1>R&&o.charCodeAt(k-1)===u;)k--;const E=k-R,M=v<E?v:E;let _=-1,T=0;for(;T<M;T++){const X=i.charCodeAt(n+T);if(X!==o.charCodeAt(R+T))break;X===u&&(_=T)}if(T!==M){if(_===-1)return t}else{if(E>M){if(o.charCodeAt(R+T)===u)return t.slice(R+T+1);if(T===2)return t.slice(R+T)}v>M&&(i.charCodeAt(n+T)===u?_=T:T===2&&(_=3)),_===-1&&(_=0)}let U="";for(T=n+_+1;T<=c;++T)(T===c||i.charCodeAt(T)===u)&&(U+=U.length===0?"..":"\\..");return R+=_,U.length>0?`${U}${t.slice(R,k)}`:(t.charCodeAt(R)===u&&++R,t.slice(R,k))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===u){if(o.charCodeAt(1)===u){const s=o.charCodeAt(2);if(s!==b&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===u)return`\\\\?\\${o}`;return i},dirname(i){S(i,"path");const o=i.length;if(o===0)return".";let s=-1,t=0;const n=i.charCodeAt(0);if(o===1)return m(n)?i:".";if(m(n)){if(s=t=1,m(i.charCodeAt(1))){let R=2,k=R;for(;R<o&&!m(i.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&m(i.charCodeAt(R));)R++;if(R<o&&R!==k){for(k=R;R<o&&!m(i.charCodeAt(R));)R++;if(R===o)return i;R!==k&&(s=t=R+1)}}}}else d(n)&&i.charCodeAt(1)===y&&(s=o>2&&m(i.charCodeAt(2))?3:2,t=s);let c=-1,v=!0;for(let R=o-1;R>=t;--R)if(m(i.charCodeAt(R))){if(!v){c=R;break}}else v=!1;if(c===-1){if(s===-1)return".";c=s}return i.slice(0,c)},basename(i,o){o!==void 0&&S(o,"ext"),S(i,"path");let s=0,t=-1,n=!0,c;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===y&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let v=o.length-1,R=-1;for(c=i.length-1;c>=s;--c){const k=i.charCodeAt(c);if(m(k)){if(!n){s=c+1;break}}else R===-1&&(n=!1,R=c+1),v>=0&&(k===o.charCodeAt(v)?--v===-1&&(t=c):(v=-1,t=R))}return s===t?t=R:t===-1&&(t=i.length),i.slice(s,t)}for(c=i.length-1;c>=s;--c)if(m(i.charCodeAt(c))){if(!n){s=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(s,t)},extname(i){S(i,"path");let o=0,s=-1,t=0,n=-1,c=!0,v=0;i.length>=2&&i.charCodeAt(1)===y&&d(i.charCodeAt(0))&&(o=t=2);for(let R=i.length-1;R>=o;--R){const k=i.charCodeAt(R);if(m(k)){if(!c){t=R+1;break}continue}n===-1&&(c=!1,n=R+1),k===I?s===-1?s=R:v!==1&&(v=1):s!==-1&&(v=-1)}return s===-1||n===-1||v===0||v===1&&s===n-1&&s===t+1?"":i.slice(s,n)},format:P.bind(null,"\\"),parse(i){S(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let t=0,n=i.charCodeAt(0);if(s===1)return m(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(m(n)){if(t=1,m(i.charCodeAt(1))){let _=2,T=_;for(;_<s&&!m(i.charCodeAt(_));)_++;if(_<s&&_!==T){for(T=_;_<s&&m(i.charCodeAt(_));)_++;if(_<s&&_!==T){for(T=_;_<s&&!m(i.charCodeAt(_));)_++;_===s?t=_:_!==T&&(t=_+1)}}}}else if(d(n)&&i.charCodeAt(1)===y){if(s<=2)return o.root=o.dir=i,o;if(t=2,m(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let c=-1,v=t,R=-1,k=!0,E=i.length-1,M=0;for(;E>=t;--E){if(n=i.charCodeAt(E),m(n)){if(!k){v=E+1;break}continue}R===-1&&(k=!1,R=E+1),n===I?c===-1?c=E:M!==1&&(M=1):c!==-1&&(M=-1)}return R!==-1&&(c===-1||M===0||M===1&&c===R-1&&c===v+1?o.base=o.name=i.slice(v,R):(o.name=i.slice(v,c),o.base=i.slice(v,R),o.ext=i.slice(c,R))),v>0&&v!==t?o.dir=i.slice(0,v-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(p){const i=/\\/g;return()=>{const o=C.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>C.cwd()})();e.posix={resolve(...i){let o="",s=!1;for(let t=i.length-1;t>=-1&&!s;t--){const n=t>=0?i[t]:h();S(n,"path"),n.length!==0&&(o=`${n}/${o}`,s=n.charCodeAt(0)===f)}return o=a(o,!s,"/",g),s?`/${o}`:o.length>0?o:"."},normalize(i){if(S(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===f,s=i.charCodeAt(i.length-1)===f;return i=a(i,!o,"/",g),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return S(i,"path"),i.length>0&&i.charCodeAt(0)===f},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const t=i[s];S(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(S(i,"from"),S(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const s=1,t=i.length,n=t-s,c=1,v=o.length-c,R=n<v?n:v;let k=-1,E=0;for(;E<R;E++){const _=i.charCodeAt(s+E);if(_!==o.charCodeAt(c+E))break;_===f&&(k=E)}if(E===R)if(v>R){if(o.charCodeAt(c+E)===f)return o.slice(c+E+1);if(E===0)return o.slice(c+E)}else n>R&&(i.charCodeAt(s+E)===f?k=E:E===0&&(k=0));let M="";for(E=s+k+1;E<=t;++E)(E===t||i.charCodeAt(E)===f)&&(M+=M.length===0?"..":"/..");return`${M}${o.slice(c+k)}`},toNamespacedPath(i){return i},dirname(i){if(S(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===f;let s=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===f){if(!t){s=n;break}}else t=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&S(o,"ext"),S(i,"path");let s=0,t=-1,n=!0,c;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let v=o.length-1,R=-1;for(c=i.length-1;c>=0;--c){const k=i.charCodeAt(c);if(k===f){if(!n){s=c+1;break}}else R===-1&&(n=!1,R=c+1),v>=0&&(k===o.charCodeAt(v)?--v===-1&&(t=c):(v=-1,t=R))}return s===t?t=R:t===-1&&(t=i.length),i.slice(s,t)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===f){if(!n){s=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(s,t)},extname(i){S(i,"path");let o=-1,s=0,t=-1,n=!0,c=0;for(let v=i.length-1;v>=0;--v){const R=i.charCodeAt(v);if(R===f){if(!n){s=v+1;break}continue}t===-1&&(n=!1,t=v+1),R===I?o===-1?o=v:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||t===-1||c===0||c===1&&o===t-1&&o===s+1?"":i.slice(o,t)},format:P.bind(null,"/"),parse(i){S(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===f;let t;s?(o.root="/",t=1):t=0;let n=-1,c=0,v=-1,R=!0,k=i.length-1,E=0;for(;k>=t;--k){const M=i.charCodeAt(k);if(M===f){if(!R){c=k+1;break}continue}v===-1&&(R=!1,v=k+1),M===I?n===-1?n=k:E!==1&&(E=1):n!==-1&&(E=-1)}if(v!==-1){const M=c===0&&s?1:c;n===-1||E===0||E===1&&n===v-1&&n===c+1?o.base=o.name=i.slice(M,v):(o.name=i.slice(M,n),o.base=i.slice(M,v),o.ext=i.slice(n,v))}return c>0?o.dir=i.slice(0,c-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(se[33],oe([0,1,9,4,25,12]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(c){return c===47||c===92}e.isPathSeparator=D;function I(c){return c.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=I;function f(c){return c.indexOf("/")===-1&&(c=I(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=f;function u(c,v=C.posix.sep){if(!c)return"";const R=c.length,k=c.charCodeAt(0);if(D(k)){if(D(c.charCodeAt(1))&&!D(c.charCodeAt(2))){let M=3;const _=M;for(;M<R&&!D(c.charCodeAt(M));M++);if(_!==M&&!D(c.charCodeAt(M+1))){for(M+=1;M<R;M++)if(D(c.charCodeAt(M)))return c.slice(0,M+1).replace(/[\\/]/g,v)}}return v}else if(g(k)&&c.charCodeAt(1)===58)return D(c.charCodeAt(2))?c.slice(0,2)+v:c.slice(0,2);let E=c.indexOf("://");if(E!==-1){for(E+=3;E<R;E++)if(D(c.charCodeAt(E)))return c.slice(0,E+1)}return""}e.getRoot=u;function y(c){if(!L.isWindows||!c||c.length<5)return!1;let v=c.charCodeAt(0);if(v!==92||(v=c.charCodeAt(1),v!==92))return!1;let R=2;const k=R;for(;R<c.length&&(v=c.charCodeAt(R),v!==92);R++);return!(k===R||(v=c.charCodeAt(R+1),isNaN(v)||v===92))}e.isUNC=y;const b=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(c,v=L.isWindows){const R=v?b:w;return!(!c||c.length===0||/^\s+$/.test(c)||(R.lastIndex=0,R.test(c))||v&&l.test(c)||c==="."||c===".."||v&&c[c.length-1]==="."||v&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=S;function p(c,v,R){const k=c===v;return!R||k?k:!c||!v?!1:(0,r.equalsIgnoreCase)(c,v)}e.isEqual=p;function m(c,v,R,k=C.sep){if(c===v)return!0;if(!c||!v||v.length>c.length)return!1;if(R){if(!(0,r.startsWithIgnoreCase)(c,v))return!1;if(v.length===c.length)return!0;let M=v.length;return v.charAt(v.length-1)===k&&M--,c.charAt(M)===k}return v.charAt(v.length-1)!==k&&(v+=k),c.indexOf(v)===0}e.isEqualOrParent=m;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=g;function d(c,v){return L.isWindows&&c.endsWith(":")&&(c+=C.sep),(0,C.isAbsolute)(c)||(c=(0,C.join)(v,c)),c=(0,C.normalize)(c),L.isWindows?(c=(0,r.rtrim)(c,C.sep),c.endsWith(":")&&(c+=C.sep)):(c=(0,r.rtrim)(c,C.sep),c||(c=C.sep)),c}e.sanitizeFilePath=d;function a(c){const v=(0,C.normalize)(c);return L.isWindows?c.length>3?!1:P(v)&&(c.length===2||v.charCodeAt(2)===92):v===C.posix.sep}e.isRootOrDriveLetter=a;function P(c,v=L.isWindows){return v?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function h(c,v=L.isWindows){return P(c,v)?c[0]:void 0}e.getDriveLetter=h;function i(c,v,R){return v.length>c.length?-1:c===v?0:(R&&(c=c.toLowerCase(),v=v.toLowerCase()),c.indexOf(v))}e.indexOfPath=i;function o(c){const v=c.split(":");let R,k,E;for(const M of v){const _=Number(M);(0,O.isNumber)(_)?k===void 0?k=_:E===void 0&&(E=_):R=R?[R,M].join(":"):M}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:k!==void 0?k:void 0,column:E!==void 0?E:k!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,v,R=8){let k="";for(let M=0;M<R;M++){let _;M===0&&L.isWindows&&!v&&(R===3||R===4)?_=t:_=s,k+=_.charAt(Math.floor(Math.random()*_.length))}let E;return v?E=`${v}-${k}`:E=k,c?(0,C.join)(c,E):E}e.randomPath=n}),define(se[76],oe([0,1,4]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var r;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function O(I,...f){const u=f.reduce((w,l)=>(w[l]=!0,w),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(w=>!u[w]).forEach(w=>{for(let l=0;l<y.length;l++)if(w.search(y[l])!==-1){delete I[w];break}})}e.sanitizeProcessEnvironment=O;function D(I){I&&(delete I.DEBUG,C.isMacintosh&&delete I.DYLD_LIBRARY_PATH,C.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(se[7],oe([0,1,9,4]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,O=/^\//,D=/^\/\//;function I(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!r.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!O.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(t,n){return!t&&!n?"file":t}function u(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const y="",b="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(n){return n instanceof l?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,v,R,k,E=!1){typeof n=="object"?(this.scheme=n.scheme||y,this.authority=n.authority||y,this.path=n.path||y,this.query=n.query||y,this.fragment=n.fragment||y):(this.scheme=f(n,E),this.authority=c||y,this.path=u(this.scheme,v||y),this.query=R||y,this.fragment=k||y,I(this,E))}get fsPath(){return P(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:v,path:R,query:k,fragment:E}=n;return c===void 0?c=this.scheme:c===null&&(c=y),v===void 0?v=this.authority:v===null&&(v=y),R===void 0?R=this.path:R===null&&(R=y),k===void 0?k=this.query:k===null&&(k=y),E===void 0?E=this.fragment:E===null&&(E=y),c===this.scheme&&v===this.authority&&R===this.path&&k===this.query&&E===this.fragment?this:new m(c,v,R,k,E)}static parse(n,c=!1){const v=w.exec(n);return v?new m(v[2]||y,s(v[4]||y),s(v[5]||y),s(v[7]||y),s(v[9]||y),c):new m(y,y,y,y,y)}static file(n){let c=y;if(L.isWindows&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const v=n.indexOf(b,2);v===-1?(c=n.substring(2),n=b):(c=n.substring(2,v),n=n.substring(v)||b)}return new m("file",c,n,y,y)}static from(n,c){return new m(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return L.isWindows&&n.scheme==="file"?v=l.file(C.win32.join(P(n,!0),...c)).path:v=C.posix.join(n.path,...c),n.with({path:v})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof l)return n;{const c=new m(n);return c._formatted=n.external??null,c._fsPath=n._sep===p?n.fsPath??null:null,c}}else return n}}e.URI=l;function S(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.isUriComponents=S;const p=L.isWindows?1:void 0;class m extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=P(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=p),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(t,n,c){let v,R=-1;for(let k=0;k<t.length;k++){const E=t.charCodeAt(k);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||c&&E===91||c&&E===93||c&&E===58)R!==-1&&(v+=encodeURIComponent(t.substring(R,k)),R=-1),v!==void 0&&(v+=t.charAt(k));else{v===void 0&&(v=t.substr(0,k));const M=g[E];M!==void 0?(R!==-1&&(v+=encodeURIComponent(t.substring(R,k)),R=-1),v+=M):R===-1&&(R=k)}}return R!==-1&&(v+=encodeURIComponent(t.substring(R))),v!==void 0?v:t}function a(t){let n;for(let c=0;c<t.length;c++){const v=t.charCodeAt(c);v===35||v===63?(n===void 0&&(n=t.substr(0,c)),n+=g[v]):n!==void 0&&(n+=t[c])}return n!==void 0?n:t}function P(t,n){let c;return t.authority&&t.path.length>1&&t.scheme==="file"?c=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?c=t.path.substr(1):c=t.path[1].toLowerCase()+t.path.substr(2):c=t.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=P;function h(t,n){const c=n?a:d;let v="",{scheme:R,authority:k,path:E,query:M,fragment:_}=t;if(R&&(v+=R,v+=":"),(k||R==="file")&&(v+=b,v+=b),k){let T=k.indexOf("@");if(T!==-1){const U=k.substr(0,T);k=k.substr(T+1),T=U.lastIndexOf(":"),T===-1?v+=c(U,!1,!1):(v+=c(U.substr(0,T),!1,!1),v+=":",v+=c(U.substr(T+1),!1,!0)),v+="@"}k=k.toLowerCase(),T=k.lastIndexOf(":"),T===-1?v+=c(k,!1,!0):(v+=c(k.substr(0,T),!1,!0),v+=k.substr(T))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const T=E.charCodeAt(1);T>=65&&T<=90&&(E=`/${String.fromCharCode(T+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const T=E.charCodeAt(0);T>=65&&T<=90&&(E=`${String.fromCharCode(T+32)}:${E.substr(2)}`)}v+=c(E,!0,!1)}return M&&(v+="?",v+=c(M,!1,!1)),_&&(v+="#",v+=n?_:d(_,!1,!1)),v}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(se[154],oe([0,1,7]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(u){const y=u;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=L;function r(u){const y=[];let b;try{const w=JSON.parse(u.arguments),l=w[w.length-1];l&&l.__$stack&&(w.pop(),b=l.__$stack),y.push(...w)}catch{y.push("Unable to log remote console arguments",u.arguments)}return{args:y,stack:b}}e.parse=r;function O(u){if(typeof u!="string")return O(r(u).stack);const y=u;if(y){const b=D(y),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(w&&w.length===4)return{uri:C.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=O;function D(u){if(!u)return u;const y=u.indexOf(`
`);return y===-1?u:u.substring(0,y)}function I(u,y){const{args:b,stack:w}=r(u),l=typeof b[0]=="string"&&b.length===1;let S=D(w);S&&(S=`(${S.trim()})`);let p=[];if(typeof b[0]=="string"?S&&l?p=[`%c[${y}] %c${b[0]} %c${S}`,f("blue"),f(""),f("grey")]:p=[`%c[${y}] %c${b[0]}`,f("blue"),f(""),...b.slice(1)]:p=[`%c[${y}]%`,f("blue"),...b],S&&!l&&p.push(S),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,p)}e.log=I;function f(u){return`color: ${u}`}}),define(se[77],oe([0,1,18,7]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function r(f){return JSON.stringify(f,D)}e.stringify=r;function O(f){let u=JSON.parse(f);return u=I(u),u}e.parse=O;function D(f,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function I(f,u=0){if(!f||u>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return L.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof C.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let y=0;y<f.length;++y)f[y]=I(f[y],u+1);else for(const y in f)Object.hasOwnProperty.call(f,y)&&(f[y]=I(f[y],u+1))}return f}e.revive=I}),define(se[13],oe([0,1,14,4,25,7]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var D;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function I(w,l){return O.URI.isUri(w)?(0,r.equalsIgnoreCase)(w.scheme,l):(0,r.startsWithIgnoreCase)(w,l+":")}e.matchesScheme=I;function f(w,...l){return l.some(S=>I(w,S))}e.matchesSomeScheme=f,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class u{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(l){this._preferredWebSchema=l}setDelegate(l){this._delegate=l}setServerRootPath(l){this._remoteResourcesPath=`${l}/${D.vscodeRemoteResource}`}set(l,S,p){this._hosts[l]=S,this._ports[l]=p}setConnectionToken(l,S){this._connectionTokens[l]=S}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(l){if(this._delegate)try{return this._delegate(l)}catch(a){return C.onUnexpectedError(a),l}const S=l.authority;let p=this._hosts[S];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const m=this._ports[S],g=this._connectionTokens[S];let d=`path=${encodeURIComponent(l.path)}`;return typeof g=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),O.URI.from({scheme:L.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${p}:${m}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new u,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class y{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(l){const S=this.toUri(l,V);return this.uriToBrowserUri(S)}uriToBrowserUri(l){return l.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(l):l.scheme===D.file&&(L.isNative||L.webWorkerOrigin===`${D.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?l.with({scheme:D.vscodeFileResource,authority:l.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):l}asFileUri(l){const S=this.toUri(l,V);return this.uriToFileUri(S)}uriToFileUri(l){return l.scheme===D.vscodeFileResource?l.with({scheme:D.file,authority:l.authority!==y.FALLBACK_AUTHORITY?l.authority:null,query:null,fragment:null}):l}toUri(l,S){return O.URI.isUri(l)?l:O.URI.parse(S.toUrl(l))}}e.FileAccess=new y;var b;(function(w){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(l.get("3"));const S="vscode-coi";function p(g){let d;typeof g=="string"?d=new URL(g).searchParams:g instanceof URL?d=g.searchParams:O.URI.isUri(g)&&(d=new URL(g.toString(!0)).searchParams);const a=d?.get(S);if(a)return l.get(a)}w.getHeadersFromQuery=p;function m(g,d,a){if(!globalThis.crossOriginIsolated)return;const P=d&&a?"3":a?"2":"1";g instanceof URLSearchParams?g.set(S,P):g[S]=P}w.addSearchParam=m})(b||(e.COI=b={}))}),define(se[19],oe([0,1,33,13,9,4,25,7]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(l){return(0,I.uriToFsPath)(l,!0)}e.originalFSPath=f;class u{constructor(S){this._ignorePathCasing=S}compare(S,p,m=!1){return S===p?0:(0,D.compare)(this.getComparisonKey(S,m),this.getComparisonKey(p,m))}isEqual(S,p,m=!1){return S===p?!0:!S||!p?!1:this.getComparisonKey(S,m)===this.getComparisonKey(p,m)}getComparisonKey(S,p=!1){return S.with({path:this._ignorePathCasing(S)?S.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(S){return this._ignorePathCasing(S)}isEqualOrParent(S,p,m=!1){if(S.scheme===p.scheme){if(S.scheme===L.Schemas.file)return C.isEqualOrParent(f(S),f(p),this._ignorePathCasing(S))&&S.query===p.query&&(m||S.fragment===p.fragment);if((0,e.isEqualAuthority)(S.authority,p.authority))return C.isEqualOrParent(S.path,p.path,this._ignorePathCasing(S),"/")&&S.query===p.query&&(m||S.fragment===p.fragment)}return!1}joinPath(S,...p){return I.URI.joinPath(S,...p)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return r.posix.basename(S.path)}extname(S){return r.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let p;return S.scheme===L.Schemas.file?p=I.URI.file(r.dirname(f(S))).path:(p=r.posix.dirname(S.path),S.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),p="/")),S.with({path:p})}normalizePath(S){if(!S.path.length)return S;let p;return S.scheme===L.Schemas.file?p=I.URI.file(r.normalize(f(S))).path:p=r.posix.normalize(S.path),S.with({path:p})}relativePath(S,p){if(S.scheme!==p.scheme||!(0,e.isEqualAuthority)(S.authority,p.authority))return;if(S.scheme===L.Schemas.file){const d=r.relative(f(S),f(p));return O.isWindows?C.toSlashes(d):d}let m=S.path||"/";const g=p.path||"/";if(this._ignorePathCasing(S)){let d=0;for(const a=Math.min(m.length,g.length);d<a&&!(m.charCodeAt(d)!==g.charCodeAt(d)&&m.charAt(d).toLowerCase()!==g.charAt(d).toLowerCase());d++);m=g.substr(0,d)+m.substr(d)}return r.posix.relative(m,g)}resolvePath(S,p){if(S.scheme===L.Schemas.file){const m=I.URI.file(r.resolve(f(S),p));return S.with({authority:m.authority,path:m.path})}return p=C.toPosixPath(p),S.with({path:r.posix.resolve(S.path,p)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,p){return S===p||S!==void 0&&p!==void 0&&(0,D.equalsIgnoreCase)(S,p)}hasTrailingPathSeparator(S,p=r.sep){if(S.scheme===L.Schemas.file){const m=f(S);return m.length>C.getRoot(m).length&&m[m.length-1]===p}else{const m=S.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,p=r.sep){return(0,e.hasTrailingPathSeparator)(S,p)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,p=r.sep){let m=!1;if(S.scheme===L.Schemas.file){const g=f(S);m=g!==void 0&&g.length===C.getRoot(g).length&&g[g.length-1]===p}else{p="/";const g=S.path;m=g.length===1&&g.charCodeAt(g.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(S,p)?S.with({path:S.path+"/"}):S}}e.ExtUri=u,e.extUri=new u(()=>!1),e.extUriBiasedIgnorePathCase=new u(l=>l.scheme===L.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new u(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(l,S){const p=[];for(let m=0;m<l.length;m++){const g=S(l[m]);l.some((d,a)=>a===m?!1:(0,e.isEqualOrParent)(g,S(d)))||p.push(l[m])}return p}e.distinctParents=y;var b;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function S(p){const m=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[P,h]=a.split(":");P&&h&&m.set(P,h)});const d=p.path.substring(0,p.path.indexOf(";"));return d&&m.set(l.META_DATA_MIME,d),m}l.parseMetaData=S})(b||(e.DataUri=b={}));function w(l,S,p){if(S){let m=l.path;return m&&m[0]!==r.posix.sep&&(m=r.posix.sep+m),l.with({scheme:p,authority:S,path:m})}return l.with({scheme:p})}e.toLocalResource=w}),define(se[8],oe([0,1,22,14,3,2,19,4,143,62]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(N){return!!N&&typeof N.then=="function"}e.isThenable=y;function b(N){const $=new C.CancellationTokenSource,ee=N($.token),ae=new Promise((re,me)=>{const pe=$.token.onCancellationRequested(()=>{pe.dispose(),$.dispose(),me(new L.CancellationError)});Promise.resolve(ee).then(ye=>{pe.dispose(),$.dispose(),re(ye)},ye=>{pe.dispose(),$.dispose(),me(ye)})});return new class{cancel(){$.cancel()}then(re,me){return ae.then(re,me)}catch(re){return this.then(void 0,re)}finally(re){return ae.finally(re)}}}e.createCancelablePromise=b;function w(N,$,ee){return new Promise((ae,re)=>{const me=$.onCancellationRequested(()=>{me.dispose(),ae(ee)});N.then(ae,re).finally(()=>me.dispose())})}e.raceCancellation=w;function l(N,$){return new Promise((ee,ae)=>{const re=$.onCancellationRequested(()=>{re.dispose(),ae(new L.CancellationError)});N.then(ee,ae).finally(()=>re.dispose())})}e.raceCancellationError=l;async function S(N){let $=-1;const ee=N.map((ae,re)=>ae.then(me=>($=re,me)));try{return await Promise.race(ee)}finally{N.forEach((ae,re)=>{re!==$&&ae.cancel()})}}e.raceCancellablePromises=S;function p(N,$,ee){let ae;const re=setTimeout(()=>{ae?.(void 0),ee?.()},$);return Promise.race([N.finally(()=>clearTimeout(re)),new Promise(me=>ae=me)])}e.raceTimeout=p;function m(N){return new Promise(($,ee)=>{const ae=N();y(ae)?ae.then($,ee):$(ae)})}e.asPromise=m;class g{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const ee=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ae};this.queuedPromise=new Promise(ae=>{this.activePromise.then(ee,ee).then(ae)})}return new Promise((ee,ae)=>{this.queuedPromise.then(ee,ae)})}return this.activePromise=$(),new Promise((ee,ae)=>{this.activePromise.then(re=>{this.activePromise=null,ee(re)},re=>{this.activePromise=null,ae(re)})})}dispose(){this.isDisposed=!0}}e.Throttler=g;class d{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=d;class a{constructor(){this.promiseMap=new Map}queue($,ee){const re=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get($)===re&&this.promiseMap.delete($)});return this.promiseMap.set($,re),re}}e.SequencerByKey=a;const P=(N,$)=>{let ee=!0;const ae=setTimeout(()=>{ee=!1,$()},N);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(ae),ee=!1}}},h=N=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,N())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class i{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,ee=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((re,me)=>{this.doResolve=re,this.doReject=me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const re=this.task;return this.task=null,re()}}));const ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ee===f.MicrotaskDelay?h(ae):P(ee,ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class o{constructor($){this.delayer=new i($),this.throttler=new g}trigger($,ee){return this.delayer.trigger(()=>this.throttler.queue($),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=o;class s{constructor(){this._isOpen=!1,this._promise=new Promise(($,ee)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class t extends s{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=t;function n(N,$){return $?new Promise((ee,ae)=>{const re=setTimeout(()=>{me.dispose(),ee()},N),me=$.onCancellationRequested(()=>{clearTimeout(re),me.dispose(),ae(new L.CancellationError)})}):b(ee=>n(N,ee))}e.timeout=n;function c(N,$=0,ee){const ae=setTimeout(()=>{N(),ee&&re.dispose()},$),re=(0,O.toDisposable)(()=>{clearTimeout(ae),ee?.deleteAndLeak(re)});return ee?.add(re),re}e.disposableTimeout=c;function v(N){const $=[];let ee=0;const ae=N.length;function re(){return ee<ae?N[ee++]():null}function me(pe){pe!=null&&$.push(pe);const ye=re();return ye?ye.then(me):Promise.resolve($)}return Promise.resolve(null).then(me)}e.sequence=v;function R(N,$=ae=>!!ae,ee=null){let ae=0;const re=N.length,me=()=>{if(ae>=re)return Promise.resolve(ee);const pe=N[ae++];return Promise.resolve(pe()).then(Ie=>$(Ie)?Promise.resolve(Ie):me())};return me()}e.first=R;function k(N,$=ae=>!!ae,ee=null){if(N.length===0)return Promise.resolve(ee);let ae=N.length;const re=()=>{ae=-1;for(const me of N)me.cancel?.()};return new Promise((me,pe)=>{for(const ye of N)ye.then(Ie=>{--ae>=0&&$(Ie)?(re(),me(Ie)):ae===0&&me(ee)}).catch(Ie=>{--ae>=0&&(re(),pe(Ie))})})}e.firstParallel=k;class E{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new r.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){return this._size++,new Promise((ee,ae)=>{this.outstandingPromises.push({factory:$,c:ee,e:ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const ee=$.factory();ee.then($.c,$.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=E;class M extends E{constructor(){super(1)}}e.Queue=M;class _{constructor(){this.sequentializer=new W,this.tasks=0}queue($){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,$())):this.sequentializer.run(this.tasks++,$())}}e.LimitedQueue=_;class T{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const $=new q;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueFor($,ee=D.extUri){const ae=ee.getComparisonKey($);let re=this.queues.get(ae);if(!re){re=new M;const me=this.drainListenerCount++,pe=r.Event.once(re.onDrained)(()=>{re?.dispose(),this.queues.delete(ae),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(me),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(me,pe),this.queues.set(ae,re)}return re}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=T;class U{constructor($,ee){this._token=-1,typeof $=="function"&&typeof ee=="number"&&this.setIfNotSet($,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},ee)}setIfNotSet($,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},ee))}}e.TimeoutTimer=U;class X{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet($,ee,ae=globalThis){this.cancel();const re=ae.setInterval(()=>{$()},ee);this.disposable=(0,O.toDisposable)(()=>{ae.clearInterval(re),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=X;class Y{constructor($,ee){this.timeoutToken=-1,this.runner=$,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Y;class le{constructor($,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=le;class ce extends Y{constructor($,ee){super($,ee),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ce;class ue extends O.Disposable{constructor($,ee){super(),this.options=$,this.handler=ee,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ee of $)this.pendingWork.push(ee);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Y(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(N,$)=>{(0,I.setTimeout0)(()=>{if(ee)return;const ae=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e._runWhenIdle=(N,$,ee)=>{const ae=N.requestIdleCallback($,typeof ee=="number"?{timeout:ee}:void 0);let re=!1;return{dispose(){re||(re=!0,N.cancelIdleCallback(ae))}}},e.runWhenGlobalIdle=N=>(0,e._runWhenIdle)(globalThis,N)}();class Q{constructor($,ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)($,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=Q;class G extends Q{constructor($){super(globalThis,$)}}e.GlobalIdleValue=G;async function x(N,$,ee){let ae;for(let re=0;re<ee;re++)try{return await N()}catch(me){ae=me,await n($)}throw ae}e.retry=x;class W{isRunning($){return typeof $=="number"?this._running?.taskId===$:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run($,ee,ae){return this._running={taskId:$,cancel:()=>ae?.(),promise:ee},ee.then(()=>this.doneRunning($),()=>this.doneRunning($)),ee}doneRunning($){this._running&&$===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const $=this._queued;this._queued=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this._queued)this._queued.run=$;else{let ee,ae;const re=new Promise((me,pe)=>{ee=me,ae=pe});this._queued={run:$,promise:re,promiseResolve:ee,promiseReject:ae}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=W;class B{constructor($,ee=()=>Date.now()){this.interval=$,this.nowFn=ee,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=B;var H;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(H||(H={}));class q{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise(($,ee)=>{this.completeCallback=$,this.errorCallback=ee})}complete($){return new Promise(ee=>{this.completeCallback($),this.outcome={outcome:0,value:$},ee()})}error($){return new Promise(ee=>{this.errorCallback($),this.outcome={outcome:1,value:$},ee()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=q;var Z;(function(N){async function $(ae){let re;const me=await Promise.all(ae.map(pe=>pe.then(ye=>ye,ye=>{re||(re=ye)})));if(typeof re<"u")throw re;return me}N.settled=$;function ee(ae){return new Promise(async(re,me)=>{try{await ae(re,me)}catch(pe){me(pe)}})}N.withAsyncBody=ee})(Z||(e.Promises=Z={}));class de{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor($){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=$.then(ee=>(this._value=ee,this._isResolved=!0,ee),ee=>{throw this._error=ee,this._isResolved=!0,ee})}requireValue(){if(!this._isResolved)throw new L.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=de;class j{constructor($){this._compute=$,this._promise=new u.Lazy(()=>new de(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}}e.LazyStatefulPromise=j;var A;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(A||(A={}));class F{static fromArray($){return new F(ee=>{ee.emitMany($)})}static fromPromise($){return new F(async ee=>{ee.emitMany(await $)})}static fromPromises($){return new F(async ee=>{await Promise.all($.map(async ae=>ee.emitOne(await ae)))})}static merge($){return new F(async ee=>{await Promise.all($.map(async ae=>{for await(const re of ae)ee.emitOne(re)}))})}static{this.EMPTY=F.fromArray([])}constructor($){this._state=0,this._results=[],this._error=null,this._onStateChanged=new r.Emitter,queueMicrotask(async()=>{const ee={emitOne:ae=>this.emitOne(ae),emitMany:ae=>this.emitMany(ae),reject:ae=>this.reject(ae)};try{await Promise.resolve($(ee)),this.resolve()}catch(ae){this.reject(ae)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===2)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===1)return{done:!0,value:void 0};await r.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map($,ee){return new F(async ae=>{for await(const re of $)ae.emitOne(ee(re))})}map($){return F.map(this,$)}static filter($,ee){return new F(async ae=>{for await(const re of $)ee(re)&&ae.emitOne(re)})}filter($){return F.filter(this,$)}static coalesce($){return F.filter($,ee=>!!ee)}coalesce(){return F.coalesce(this)}static async toPromise($){const ee=[];for await(const ae of $)ee.push(ae);return ee}toPromise(){return F.toPromise(this)}emitOne($){this._state===0&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===0&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject($){this._state===0&&(this._state=2,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=F;class J extends F{constructor($,ee){super(ee),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function z(N){const $=new C.CancellationTokenSource,ee=N($.token);return new J($,async ae=>{const re=$.token.onCancellationRequested(()=>{re.dispose(),$.dispose(),ae.reject(new L.CancellationError)});try{for await(const me of ee){if($.token.isCancellationRequested)return;ae.emitOne(me)}re.dispose(),$.dispose()}catch(me){re.dispose(),$.dispose(),ae.reject(me)}})}e.createCancelableAsyncIterable=z;class K{constructor(){this._deferred=new q,this._asyncIterable=new F(ae=>{if($){ae.reject($);return}return ee&&ae.emitMany(ee),this._errorFn=re=>ae.reject(re),this._emitFn=re=>ae.emitOne(re),this._deferred.p});let $,ee;this._emitFn=ae=>{ee||(ee=[]),ee.push(ae)},this._errorFn=ae=>{$||($=ae)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject($){this._errorFn($),this._deferred.complete()}emitOne($){this._emitFn($)}}e.AsyncIterableSource=K}),define(se[104],oe([0,1,23,8,33,31,9,4,25]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function u(){return Object.create(null)}e.getEmptyExpression=u,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",b="[^/\\\\]",w=/\//g;function l(G,x){switch(G){case 0:return"";case 1:return`${b}*?`;default:return`(?:${y}|${b}+${y}${x?`|${y}${b}+`:""})*?`}}function S(G,x){if(!G)return[];const W=[];let B=!1,H=!1,q="";for(const Z of G){switch(Z){case x:if(!B&&!H){W.push(q),q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":H=!0;break;case"]":H=!1;break}q+=Z}return q&&W.push(q),W}e.splitGlobAware=S;function p(G){if(!G)return"";let x="";const W=S(G,e.GLOB_SPLIT);if(W.every(B=>B===e.GLOBSTAR))x=".*";else{let B=!1;W.forEach((H,q)=>{if(H===e.GLOBSTAR){if(B)return;x+=l(2,q===W.length-1)}else{let Z=!1,de="",j=!1,A="";for(const F of H){if(F!=="}"&&Z){de+=F;continue}if(j&&(F!=="]"||!A)){let J;F==="-"?J=F:(F==="^"||F==="!")&&!A?J="^":F===e.GLOB_SPLIT?J="":J=(0,f.escapeRegExpCharacters)(F),A+=J;continue}switch(F){case"{":Z=!0;continue;case"[":j=!0;continue;case"}":{const z=`(?:${S(de,",").map(K=>p(K)).join("|")})`;x+=z,Z=!1,de="";break}case"]":{x+="["+A+"]",j=!1,A="";break}case"?":x+=b;continue;case"*":x+=l(1);continue;default:x+=(0,f.escapeRegExpCharacters)(F)}}q<W.length-1&&(W[q+1]!==e.GLOBSTAR||q+2<W.length)&&(x+=y)}B=H===e.GLOBSTAR})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.LRUCache(1e4),o=function(){return!1},s=function(){return null};function t(G,x){if(!G)return s;let W;typeof G!="string"?W=G.pattern:W=G,W=W.trim();const B=`${W}_${!!x.trimForExclusions}`;let H=i.get(B);if(H)return n(H,G);let q;return m.test(W)?H=v(W.substr(4),W):(q=g.exec(c(W,x)))?H=R(q[1],W):(x.trimForExclusions?a:d).test(W)?H=k(W,x):(q=P.exec(c(W,x)))?H=E(q[1].substr(1),W,!0):(q=h.exec(c(W,x)))?H=E(q[1],W,!1):H=M(W),i.set(B,H),n(H,G)}function n(G,x){if(typeof x=="string")return G;const W=function(B,H){return(0,r.isEqualOrParent)(B,x.base,!I.isLinux)?G((0,f.ltrim)(B.substr(x.base.length),D.sep),H):null};return W.allBasenames=G.allBasenames,W.allPaths=G.allPaths,W.basenames=G.basenames,W.patterns=G.patterns,W}function c(G,x){return x.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function v(G,x){return function(W,B){return typeof W=="string"&&W.endsWith(G)?x:null}}function R(G,x){const W=`/${G}`,B=`\\${G}`,H=function(Z,de){return typeof Z!="string"?null:de?de===G?x:null:Z===G||Z.endsWith(W)||Z.endsWith(B)?x:null},q=[G];return H.basenames=q,H.patterns=[x],H.allBasenames=q,H}function k(G,x){const W=ue(G.slice(1,-1).split(",").map(de=>t(de,x)).filter(de=>de!==s),G),B=W.length;if(!B)return s;if(B===1)return W[0];const H=function(de,j){for(let A=0,F=W.length;A<F;A++)if(W[A](de,j))return G;return null},q=W.find(de=>!!de.allBasenames);q&&(H.allBasenames=q.allBasenames);const Z=W.reduce((de,j)=>j.allPaths?de.concat(j.allPaths):de,[]);return Z.length&&(H.allPaths=Z),H}function E(G,x,W){const B=D.sep===D.posix.sep,H=B?G:G.replace(w,D.sep),q=D.sep+H,Z=D.posix.sep+G;let de;return W?de=function(j,A){return typeof j=="string"&&(j===H||j.endsWith(q)||!B&&(j===G||j.endsWith(Z)))?x:null}:de=function(j,A){return typeof j=="string"&&(j===H||!B&&j===G)?x:null},de.allPaths=[(W?"*/":"./")+G],de}function M(G){try{const x=new RegExp(`^${p(G)}$`);return function(W){return x.lastIndex=0,typeof W=="string"&&x.test(W)?G:null}}catch{return s}}function _(G,x,W){return!G||typeof x!="string"?!1:T(G)(x,void 0,W)}e.match=_;function T(G,x={}){if(!G)return o;if(typeof G=="string"||U(G)){const W=t(G,x);if(W===s)return o;const B=function(H,q){return!!W(H,q)};return W.allBasenames&&(B.allBasenames=W.allBasenames),W.allPaths&&(B.allPaths=W.allPaths),B}return le(G,x)}e.parse=T;function U(G){const x=G;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=U;function X(G){return G.allBasenames||[]}e.getBasenameTerms=X;function Y(G){return G.allPaths||[]}e.getPathTerms=Y;function le(G,x){const W=ue(Object.getOwnPropertyNames(G).map(de=>ce(de,G[de],x)).filter(de=>de!==s)),B=W.length;if(!B)return s;if(!W.some(de=>!!de.requiresSiblings)){if(B===1)return W[0];const de=function(F,J){let z;for(let K=0,N=W.length;K<N;K++){const $=W[K](F,J);if(typeof $=="string")return $;(0,L.isThenable)($)&&(z||(z=[]),z.push($))}return z?(async()=>{for(const K of z){const N=await K;if(typeof N=="string")return N}return null})():null},j=W.find(F=>!!F.allBasenames);j&&(de.allBasenames=j.allBasenames);const A=W.reduce((F,J)=>J.allPaths?F.concat(J.allPaths):F,[]);return A.length&&(de.allPaths=A),de}const H=function(de,j,A){let F,J;for(let z=0,K=W.length;z<K;z++){const N=W[z];N.requiresSiblings&&A&&(j||(j=(0,D.basename)(de)),F||(F=j.substr(0,j.length-(0,D.extname)(de).length)));const $=N(de,j,F,A);if(typeof $=="string")return $;(0,L.isThenable)($)&&(J||(J=[]),J.push($))}return J?(async()=>{for(const z of J){const K=await z;if(typeof K=="string")return K}return null})():null},q=W.find(de=>!!de.allBasenames);q&&(H.allBasenames=q.allBasenames);const Z=W.reduce((de,j)=>j.allPaths?de.concat(j.allPaths):de,[]);return Z.length&&(H.allPaths=Z),H}function ce(G,x,W){if(x===!1)return s;const B=t(G,W);if(B===s)return s;if(typeof x=="boolean")return B;if(x){const H=x.when;if(typeof H=="string"){const q=(Z,de,j,A)=>{if(!A||!B(Z,de))return null;const F=H.replace("$(basename)",()=>j),J=A(F);return(0,L.isThenable)(J)?J.then(z=>z?G:null):J?G:null};return q.requiresSiblings=!0,q}}return B}function ue(G,x){const W=G.filter(de=>!!de.basenames);if(W.length<2)return G;const B=W.reduce((de,j)=>{const A=j.basenames;return A?de.concat(A):de},[]);let H;if(x){H=[];for(let de=0,j=B.length;de<j;de++)H.push(x)}else H=W.reduce((de,j)=>{const A=j.patterns;return A?de.concat(A):de},[]);const q=function(de,j){if(typeof de!="string")return null;if(!j){let F;for(F=de.length;F>0;F--){const J=de.charCodeAt(F-1);if(J===47||J===92)break}j=de.substr(F)}const A=B.indexOf(j);return A!==-1?H[A]:null};q.basenames=B,q.patterns=H,q.allBasenames=B;const Z=G.filter(de=>!de.basenames);return Z.push(q),Z}function Q(G,x){return(0,C.equals)(G,x,(W,B)=>typeof W=="string"&&typeof B=="string"?W===B:typeof W!="string"&&typeof B!="string"?W.base===B.base&&W.pattern===B.pattern:!1)}e.patternsEquals=Q}),define(se[47],oe([0,1,23,33,9,4,19,25]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function f(t,n){const{os:c,tildify:v,relative:R}=n;if(R){const M=u(t,R,c);if(typeof M=="string")return M}let k=t.fsPath;if(c===1&&!O.isWindows?k=k.replace(/\//g,"\\"):c!==1&&O.isWindows&&(k=k.replace(/\\/g,"/")),c!==1&&v?.userHome){const M=v.userHome.fsPath;let _;t.scheme!==v.userHome.scheme&&t.path[0]===r.posix.sep&&t.path[1]!==r.posix.sep?_=v.userHome.with({path:t.path}).fsPath:_=k,k=w(_,M,c)}return(c===1?r.win32:r.posix).normalize(y(k,c===1))}e.getPathLabel=f;function u(t,n,c){const v=c===1?r.win32:r.posix,R=c===3?D.extUri:D.extUriIgnorePathCase,k=n.getWorkspace(),E=(0,C.firstOrDefault)(k.folders);if(!E)return;t.scheme!==E.uri.scheme&&t.path[0]===r.posix.sep&&t.path[1]!==r.posix.sep&&(t=E.uri.with({path:t.path}));const M=n.getWorkspaceFolder(t);if(!M)return;let _;if(R.isEqual(M.uri,t)?_="":_=R.relativePath(M.uri,t)??"",_&&(_=v.normalize(_)),k.folders.length>1&&!n.noPrefix){const T=M.name?M.name:R.basenameOrAuthority(M.uri);_=_?`${T} \u2022 ${_}`:T}return _}function y(t,n=O.isWindows){return(0,L.hasDriveLetter)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=y;let b=Object.create(null);function w(t,n,c=O.OS){if(c===1||!t||!n)return t;let v=b.original===n?b.normalized:void 0;v||(v=n,O.isWindows&&(v=(0,L.toSlashes)(v)),v=`${(0,I.rtrim)(v,r.posix.sep)}${r.posix.sep}`,b={original:n,normalized:v});let R=t;return O.isWindows&&(R=(0,L.toSlashes)(R)),(c===3?R.startsWith(v):(0,I.startsWithIgnoreCase)(R,v))?`~/${R.substr(v.length)}`:t}e.tildify=w;function l(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=l;const S="\u2026",p="\\\\",m="~";function g(t,n=r.sep){const c=new Array(t.length);let v=!1;for(let R=0;R<t.length;R++){const k=t[R];if(k===""){c[R]=`.${n}`;continue}if(!k){c[R]=k;continue}v=!0;let E="",M=k;M.indexOf(p)===0?(E=M.substr(0,M.indexOf(p)+p.length),M=M.substr(M.indexOf(p)+p.length)):M.indexOf(n)===0?(E=M.substr(0,M.indexOf(n)+n.length),M=M.substr(M.indexOf(n)+n.length)):M.indexOf(m)===0&&(E=M.substr(0,M.indexOf(m)+m.length),M=M.substr(M.indexOf(m)+m.length));const _=M.split(n);for(let T=1;v&&T<=_.length;T++)for(let U=_.length-T;v&&U>=0;U--){v=!1;let X=_.slice(U,U+T).join(n);for(let Y=0;!v&&Y<t.length;Y++)if(Y!==R&&t[Y]&&t[Y].indexOf(X)>-1){const le=U+T===_.length,ce=U>0&&t[Y].indexOf(n)>-1?n+X:X,ue=t[Y].endsWith(ce);v=!le||ue}if(!v){let Y="";(_[0].endsWith(":")||E!=="")&&(U===1&&(U=0,T++,X=_[0]+n+X),U>0&&(Y=_[0]+n),Y=E+Y),U>0&&(Y=Y+S+n),Y=Y+X,U+T<_.length&&(Y=Y+n+S),c[R]=Y}}v&&(c[R]=k)}return c}e.shorten=g;var d;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function a(t,n=Object.create(null)){const c=[];let v=!1,R="";for(const k of t)if(k==="$"||v&&k==="{")R&&c.push({value:R,type:d.TEXT}),R="",v=!0;else if(k==="}"&&v){const E=n[R];if(typeof E=="string")E.length&&c.push({value:E,type:d.VARIABLE});else if(E){const M=c[c.length-1];(!M||M.type!==d.SEPARATOR)&&c.push({value:E.label,type:d.SEPARATOR})}R="",v=!1}else R+=k;return R&&!v&&c.push({value:R,type:d.TEXT}),c.filter((k,E)=>{if(k.type===d.SEPARATOR){const M=c[E-1],_=c[E+1];return[M,_].every(T=>T&&(T.type===d.VARIABLE||T.type===d.TEXT)&&T.value.length>0)}return!0}).map(k=>k.value).join("")}e.template=a;function P(t,n){return O.isMacintosh||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):t.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function h(t,n){return O.isMacintosh||n?t.replace(/\(&&\w\)|&&/g,""):O.isWindows?t.replace(/&&|&/g,c=>c==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=h;function i(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const c=s(t.substring(0,n));return{name:c.name,parentPath:c.parentPath+t.substring(n)}}}return s(t)}e.splitRecentLabel=o;function s(t){const n=t.indexOf("/")!==-1?r.posix:r.win32,c=n.basename(t),v=n.dirname(t);return c.length?{name:c,parentPath:v}:{name:v,parentPath:""}}}),define(se[155],oe([0,1,18,7]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(b){return b.toJSON()}class O{constructor(w){this._uriTransformer=w}transformIncoming(w){const l=this._uriTransformer.transformIncoming(w);return l===w?w:r(L.URI.from(l))}transformOutgoing(w){const l=this._uriTransformer.transformOutgoing(w);return l===w?w:r(L.URI.from(l))}transformOutgoingURI(w){const l=this._uriTransformer.transformOutgoing(w);return l===w?w:L.URI.from(l)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function D(b,w,l){if(!b||l>200)return null;if(typeof b=="object"){if(b instanceof L.URI)return w.transformOutgoing(b);for(const S in b)if(Object.hasOwnProperty.call(b,S)){const p=D(b[S],w,l+1);p!==null&&(b[S]=p)}}return null}function I(b,w){const l=D(b,w,0);return l===null?b:l}e.transformOutgoingURIs=I;function f(b,w,l,S){if(!b||S>200)return null;if(typeof b=="object"){if(b.$mid===1)return l?L.URI.revive(w.transformIncoming(b)):w.transformIncoming(b);if(b instanceof C.VSBuffer)return null;for(const p in b)if(Object.hasOwnProperty.call(b,p)){const m=f(b[p],w,l,S+1);m!==null&&(b[p]=m)}}return null}function u(b,w){const l=f(b,w,!1,0);return l===null?b:l}e.transformIncomingURIs=u;function y(b,w){const l=f(b,w,!0,0);return l===null?b:l}e.transformAndReviveIncomingURIs=y}),define(se[88],oe([0,1,26,57,32,145,4]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(w){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(w)}value(){if(this._value===void 0){let w=0,l=0;const S=(0,C.networkInterfaces)();for(const p in S){const m=S[p];if(m)for(const{mac:g,internal:d}of m)d||(l+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(w+=1))}this._value=l>0?w/l:0}return this._value}};let I;async function f(w){return I||(I=(async()=>await u(w)||r.generateUuid())()),I}e.getMachineId=f;async function u(w){try{const l=await new Promise((p,m)=>{V(["crypto"],p,m)}),S=(0,O.getMac)();return l.createHash("sha256").update(S,"utf8").digest("hex")}catch(l){w(l);return}}const y="Software\\Microsoft\\SQMClient";async function b(w){if(D.isWindows){const l=await new Promise((S,p)=>{V(["@vscode/windows-registry"],S,p)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(S){return w(S),""}}return""}e.getSqmMachineId=b}),define(se[21],oe([0,1,46,26,156,8,33,85,9,4,19,7]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(ce){ce[ce.UNLINK=0]="UNLINK",ce[ce.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function l(ce,ue=w.UNLINK,Q){if((0,D.isRootOrDriveLetter)(ce))throw new Error("rimraf - will refuse to recursively delete root");return ue===w.UNLINK?p(ce):S(ce,Q)}async function S(ce,ue=(0,D.randomPath)((0,L.tmpdir)())){try{try{await C.promises.rename(ce,ue)}catch(Q){return Q.code==="ENOENT"?void 0:p(ce)}p(ue).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function p(ce){return(0,r.promisify)(C.rm)(ce,{recursive:!0,force:!0,maxRetries:3})}function m(ce){if((0,D.isRootOrDriveLetter)(ce))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(ce,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function g(ce,ue){return P(await(ue?d(ce):(0,r.promisify)(C.readdir)(ce)))}async function d(ce){try{return await(0,r.promisify)(C.readdir)(ce,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const ue=[],Q=await g(ce);for(const G of Q){let x=!1,W=!1,B=!1;try{const H=await e.Promises.lstat((0,f.join)(ce,G));x=H.isFile(),W=H.isDirectory(),B=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ue.push({name:G,isFile:()=>x,isDirectory:()=>W,isSymbolicLink:()=>B})}return ue}function a(ce){return P(C.readdirSync(ce))}e.readdirSync=a;function P(ce){return ce.map(ue=>typeof ue=="string"?u.isMacintosh?(0,I.normalizeNFC)(ue):ue:(ue.name=u.isMacintosh?(0,I.normalizeNFC)(ue.name):ue.name,ue))}async function h(ce){const ue=await g(ce),Q=[];for(const G of ue)await o.existsDirectory((0,f.join)(ce,G))&&Q.push(G);return Q}function i(ce,ue=1e3){return new Promise(Q=>{let G=!1;const x=setInterval(()=>{G||(G=!0,C.access(ce,W=>{G=!1,W&&(clearInterval(x),Q(void 0))}))},ue)})}e.whenDeleted=i;var o;(function(ce){async function ue(x){let W;try{if(W=await e.Promises.lstat(x),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(u.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw H}throw B}}ce.stat=ue;async function Q(x){try{const{stat:W,symbolicLink:B}=await ce.stat(x);return W.isFile()&&B?.dangling!==!0}catch{}return!1}ce.existsFile=Q;async function G(x){try{const{stat:W,symbolicLink:B}=await ce.stat(x);return W.isDirectory()&&B?.dangling!==!0}catch{}return!1}ce.existsDirectory=G})(o||(e.SymlinkSupport=o={}));const s=new O.ResourceQueue;function t(ce,ue,Q){return s.queueFor(b.URI.file(ce),y.extUriBiasedIgnorePathCase).queue(()=>{const G=k(Q);return new Promise((x,W)=>v(ce,ue,G,B=>B?W(B):x()))})}let n=!0;function c(ce){n=ce}e.configureFlushOnWrite=c;function v(ce,ue,Q,G){if(!n)return C.writeFile(ce,ue,{mode:Q.mode,flag:Q.flag},G);C.open(ce,Q.flag,Q.mode,(x,W)=>{if(x)return G(x);C.writeFile(W,ue,B=>{if(B)return C.close(W,()=>G(B));C.fdatasync(W,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),c(!1)),C.close(W,q=>G(q))))})})}function R(ce,ue,Q){const G=k(Q);if(!n)return C.writeFileSync(ce,ue,{mode:G.mode,flag:G.flag});const x=C.openSync(ce,G.flag,G.mode);try{C.writeFileSync(x,ue);try{C.fdatasyncSync(x)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),c(!1)}}finally{C.closeSync(x)}}e.writeFileSync=R;function k(ce){return ce?{mode:typeof ce.mode=="number"?ce.mode:438,flag:typeof ce.flag=="string"?ce.flag:"w"}:{mode:438,flag:"w"}}async function E(ce,ue,Q=6e4){if(ce!==ue)try{u.isWindows&&typeof Q=="number"?await M(ce,ue,Date.now(),Q):await(0,r.promisify)(C.rename)(ce,ue)}catch(G){if(ce.toLowerCase()!==ue.toLowerCase()&&G.code==="EXDEV"||ce.endsWith("."))await _(ce,ue,{preserveSymlinks:!1}),await l(ce,w.MOVE);else throw G}}async function M(ce,ue,Q,G,x=0){try{return await(0,r.promisify)(C.rename)(ce,ue)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-Q>=G)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${W}`),W;if(x===0){let B=!1;try{const{stat:H}=await o.stat(ue);H.isFile()||(B=!0)}catch{}if(B)throw W}return await(0,O.timeout)(Math.min(100,x*10)),M(ce,ue,Q,G,x+1)}}async function _(ce,ue,Q){return U(ce,ue,{root:{source:ce,target:ue},options:Q,handledSourcePaths:new Set})}const T=511;async function U(ce,ue,Q){if(Q.handledSourcePaths.has(ce))return;Q.handledSourcePaths.add(ce);const{stat:G,symbolicLink:x}=await o.stat(ce);if(x){if(Q.options.preserveSymlinks)try{return await le(ce,ue,Q)}catch{}if(x.dangling)return}return G.isDirectory()?X(ce,ue,G.mode&T,Q):Y(ce,ue,G.mode&T)}async function X(ce,ue,Q,G){await e.Promises.mkdir(ue,{recursive:!0,mode:Q});const x=await g(ce);for(const W of x)await U((0,f.join)(ce,W),(0,f.join)(ue,W),G)}async function Y(ce,ue,Q){await e.Promises.copyFile(ce,ue),await e.Promises.chmod(ue,Q)}async function le(ce,ue,Q){let G=await e.Promises.readlink(ce);(0,D.isEqualOrParent)(G,Q.root.source,!u.isLinux)&&(G=(0,f.join)(Q.root.target,G.substr(Q.root.source.length+1))),await e.Promises.symlink(G,ue)}e.Promises=new class{get access(){return(0,r.promisify)(C.access)}get stat(){return(0,r.promisify)(C.stat)}get lstat(){return(0,r.promisify)(C.lstat)}get utimes(){return(0,r.promisify)(C.utimes)}get read(){return(ce,ue,Q,G,x)=>new Promise((W,B)=>{C.read(ce,ue,Q,G,x,(H,q,Z)=>H?B(H):W({bytesRead:q,buffer:Z}))})}get readFile(){return(0,r.promisify)(C.readFile)}get write(){return(ce,ue,Q,G,x)=>new Promise((W,B)=>{C.write(ce,ue,Q,G,x,(H,q,Z)=>H?B(H):W({bytesWritten:q,buffer:Z}))})}get appendFile(){return(0,r.promisify)(C.appendFile)}get fdatasync(){return(0,r.promisify)(C.fdatasync)}get truncate(){return(0,r.promisify)(C.truncate)}get copyFile(){return(0,r.promisify)(C.copyFile)}get open(){return(0,r.promisify)(C.open)}get close(){return(0,r.promisify)(C.close)}get symlink(){return(0,r.promisify)(C.symlink)}get readlink(){return(0,r.promisify)(C.readlink)}get chmod(){return(0,r.promisify)(C.chmod)}get mkdir(){return(0,r.promisify)(C.mkdir)}get unlink(){return(0,r.promisify)(C.unlink)}get rmdir(){return(0,r.promisify)(C.rmdir)}get realpath(){return(0,r.promisify)(C.realpath)}async exists(ce){try{return await e.Promises.access(ce),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return h}get writeFile(){return t}get rm(){return l}get rename(){return E}get copy(){return _}}}),define(se[105],oe([0,1,46,9,4,25,21]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(w){if(r.isLinux)return w;const l=(0,L.dirname)(w);if(w===l)return w;const S=((0,L.basename)(w)||w).toLowerCase();try{const m=(0,D.readdirSync)(l).filter(g=>g.toLowerCase()===S);if(m.length===1){const g=I(l);if(g)return(0,L.join)(g,m[0])}else if(m.length>1){const g=m.indexOf(S);if(g>=0){const d=I(l);if(d)return(0,L.join)(d,m[g])}}}catch{}return null}e.realcaseSync=I;async function f(w){if(r.isLinux)return w;const l=(0,L.dirname)(w);if(w===l)return w;const S=((0,L.basename)(w)||w).toLowerCase();try{const m=(await D.Promises.readdir(l)).filter(g=>g.toLowerCase()===S);if(m.length===1){const g=await f(l);if(g)return(0,L.join)(g,m[0])}else if(m.length>1){const g=m.indexOf(S);if(g>=0){const d=await f(l);if(d)return(0,L.join)(d,m[g])}}}catch{}return null}e.realcase=f;async function u(w){try{return await D.Promises.realpath(w)}catch{const S=b(w);return await D.Promises.access(S,C.constants.R_OK),S}}e.realpath=u;function y(w){try{return C.realpathSync(w)}catch{const S=b(w);return C.accessSync(S,C.constants.R_OK),S}}e.realpathSync=y;function b(w){return(0,O.rtrim)((0,L.normalize)(w),L.sep)}}),define(se[106],oe([0,1,26,9,21]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,D=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var f;(function(P){P[P.x64=0]="x64",P[P.x86=1]="x86",P[P.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class b{constructor(h,i,o){this.exePath=h,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await r.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:P=!1}={}){return P?u===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function l({useAlternateBitness:P=!1,findPreview:h=!1}={}){const i=w({useAlternateBitness:P});if(!i)return null;const o=L.join(i,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(o))return null;let s=-1,t=null;for(const v of await r.Promises.readdir(o)){let R=-1;if(h){const E=v.indexOf("-");if(E<0)continue;const M=v.substring(0,E);if(!O.test(M)||v.substring(E+1)!=="preview")continue;R=parseInt(M,10)}else{if(!O.test(v))continue;R=parseInt(v,10)}if(R<=s)continue;const k=L.join(o,v,"pwsh.exe");await r.SymlinkSupport.existsFile(k)&&(t=k,s=R)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",c=h?" Preview":"";return new b(t,`PowerShell${c}${n}`,!0)}async function S({findPreview:P}={}){if(!process.env.LOCALAPPDATA)return null;const h=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=P?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(h))if(i.test(s)){const t=L.join(h,s,"pwsh.exe");return new b(t,o)}return null}function p(){const P=L.join(C.homedir(),".dotnet","tools","pwsh.exe");return new b(P,".NET Core PowerShell Global Tool")}function m(){const P=L.join(process.env.windir,u===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(P,"Windows PowerShell",!0)}async function*g(){let P=await l();P&&(yield P),P=await l({useAlternateBitness:!0}),P&&(yield P),P=await S(),P&&(yield P),P=p(),P&&(yield P),P=await l({findPreview:!0}),P&&(yield P),P=await S({findPreview:!0}),P&&(yield P),P=await l({useAlternateBitness:!0,findPreview:!0}),P&&(yield P),P=m(),P&&(yield P)}async function*d(){for await(const P of g())await P.exists()&&(yield P)}e.enumeratePowerShellInstallations=d;async function a(){for await(const P of d())return P;return null}e.getFirstAvailablePowerShellInstallation=a}),define(se[89],oe([0,1,9,4,35,76,12,21]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function f(b=r.env){return b.comspec||"cmd.exe"}e.getWindowsShell=f;function u(b){let w=[],l=!1;const S=function(p){if(l){w.push(p);return}(!b.send(p,g=>{if(g&&console.error(g),l=!1,w.length>0){const d=w.slice(0);w=[],d.forEach(a=>S(a))}})||L.isWindows)&&(l=!0)};return{send:S}}e.createQueuedSender=u;var y;(function(b){async function w(l,S,p){if(C.isAbsolute(l))return l;if(S===void 0&&(S=r.cwd()),C.dirname(l)!=="."||(p===void 0&&D.isString(r.env.PATH)&&(p=r.env.PATH.split(C.delimiter)),p===void 0||p.length===0))return C.join(S,l);async function g(d){if(await I.Promises.exists(d)){let a;try{a=await I.Promises.stat(d)}catch(P){P.message.startsWith("EACCES")&&(a=await I.Promises.lstat(d))}return a?!a.isDirectory():!1}return!1}for(const d of p){let a;if(C.isAbsolute(d)?a=C.join(d,l):a=C.join(S,d,l),await g(a))return a;let P=a+".com";if(await g(P)||(P=a+".exe",await g(P)))return P}return C.join(S,l)}b.findExecutable=w})(y||(e.win32=y={}))}),define(se[107],oe([0,1,48,13]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function r(D){return new Promise((I,f)=>{let u;const y=new Map;function b(l,S,p,m,g){const d=y.get(S);if(l===D||d){const a={name:w(p),cmd:p,pid:l,ppid:S,load:m,mem:g};y.set(l,a),l===D&&(u=a),d&&(d.children||(d.children=[]),d.children.push(a),d.children.length>1&&(d.children=d.children.sort((P,h)=>P.pid-h.pid)))}}function w(l){const S=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,m=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,a=/--type=([a-zA-Z-]+)/;if(m.exec(l))return"electron-crash-reporter";if(g.exec(l))return"winpty-agent";if(d.exec(l))return"conpty-agent";let P=a.exec(l);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?S.exec(l)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const h=/[a-zA-Z-]+\.js/g;let i="";do P=h.exec(l),P&&(i+=P+" ");while(P);return i&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${i})`:p.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=S=>S.indexOf("\\\\?\\")===0||S.indexOf("\\??\\")===0?S.substring(4):S.indexOf('"\\\\?\\')===0||S.indexOf('"\\??\\')===0?'"'+S.substring(5):S;new Promise((S,p)=>{V(["@vscode/windows-process-tree"],S,p)}).then(S=>{S.getProcessList(D,p=>{if(!p){f(new Error(`Root process ${D} not found`));return}S.getProcessCpuUsage(p,m=>{const g=new Map;m.forEach(d=>{const a=l(d.commandLine||"");g.set(d.pid,{name:w(a),cmd:a,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),u=g.get(D),u?(g.forEach(d=>{const a=g.get(d.ppid);a&&(a.children||(a.children=[]),a.children.push(d))}),g.forEach(d=>{d.children&&(d.children=d.children.sort((a,P)=>a.pid-P.pid))}),I(u)):f(new Error(`Root process ${D} not found`))})},S.ProcessDataFlag.CommandLine|S.ProcessDataFlag.Memory)})}else{let l=function(){let S=[u];const p=[];for(;S.length;){const g=S.shift();g&&(p.push(g.pid),g.children&&(S=S.concat(g.children)))}let m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+p.join(" "),(0,C.exec)(m,{},(g,d,a)=>{if(g||a)f(g||new Error(a.toString()));else{const P=d.toString().split(`
`);for(let h=0;h<p.length;h++){const i=y.get(p[h]);i.load=parseFloat(P[h])}if(!u){f(new Error(`Root process ${D} not found`));return}I(u)}})};(0,C.exec)("which ps",{},(S,p,m)=>{if(S||m)if(process.platform!=="linux")f(S||new Error(m.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,C.exec)(g,{},(d,a,P)=>{d||P?f(d||new Error(P.toString())):(O(a,b),l())})}else{const g=p.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,C.exec)(`${g} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,P,h)=>{a||h&&!h.includes("screen size is bogus")?f(a||new Error(h.toString())):(O(P,b),process.platform==="linux"?l():u?I(u):f(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=r;function O(D,I){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=D.toString().split(`
`);for(const y of u){const b=f.exec(y.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(se[108],oe([0,1,26,4,106,89]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(b,w){return b===1?L.isWindows?y():O.getWindowsShell(w):f(b,w)}e.getSystemShell=D;let I=null;function f(b,w){if(L.isLinux&&b===2||L.isMacintosh&&b===3)return"/bin/bash";if(!I){let l;if(L.isWindows)l="/bin/bash";else{if(l=w.SHELL,!l)try{l=(0,C.userInfo)().shell}catch{}l||(l="sh"),l==="/bin/false"&&(l="/bin/bash")}I=l}return I}let u=null;async function y(){return u||(u=(await(0,r.getFirstAvailablePowerShellInstallation)()).exePath),u}});var Ee=this&&this.__decorate||function(V,e,C,L){var r=arguments.length,O=r<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,C):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(V,e,C,L);else for(var I=V.length-1;I>=0;I--)(D=V[I])&&(O=(r<3?D(O):r>3?D(e,C,O):D(e,C))||O);return r>3&&O&&Object.defineProperty(e,C,O),O};define(se[42],oe([0,1,23,8,18,22,56,14,3,2,77,25,12]),function(V,e,C,L,r,O,D,I,f,u,y,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var l;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(l||(l={}));function S(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p||(p={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(g||(g={}));function d(x){let W=0;for(let B=0;;B+=7){const H=x.read(1);if(W|=(H.buffer[0]&127)<<B,!(H.buffer[0]&128))return W}}const a=s(0);function P(x,W){if(W===0){x.write(a);return}let B=0;for(let q=W;q!==0;q=q>>>7)B++;const H=r.VSBuffer.alloc(B);for(let q=0;W!==0;q++)H.buffer[q]=W&127,W=W>>>7,W>0&&(H.buffer[q]|=128);x.write(H)}class h{constructor(W){this.buffer=W,this.pos=0}read(W){const B=this.buffer.slice(this.pos,this.pos+W);return this.pos+=B.byteLength,B}}e.BufferReader=h;class i{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=i;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function s(x){const W=r.VSBuffer.alloc(1);return W.writeUInt8(x,0),W}const t={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},n=typeof Buffer<"u";function c(x,W){if(typeof W>"u")x.write(t.Undefined);else if(typeof W=="string"){const B=r.VSBuffer.fromString(W);x.write(t.String),P(x,B.byteLength),x.write(B)}else if(n&&Buffer.isBuffer(W)){const B=r.VSBuffer.wrap(W);x.write(t.Buffer),P(x,B.byteLength),x.write(B)}else if(W instanceof r.VSBuffer)x.write(t.VSBuffer),P(x,W.byteLength),x.write(W);else if(Array.isArray(W)){x.write(t.Array),P(x,W.length);for(const B of W)c(x,B)}else if(typeof W=="number"&&(W|0)===W)x.write(t.Uint),P(x,W);else{const B=r.VSBuffer.fromString(JSON.stringify(W));x.write(t.Object),P(x,B.byteLength),x.write(B)}}e.serialize=c;function v(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(d(x)).toString();case o.Buffer:return x.read(d(x)).buffer;case o.VSBuffer:return x.read(d(x));case o.Array:{const B=d(x),H=[];for(let q=0;q<B;q++)H.push(v(x));return H}case o.Object:return JSON.parse(x.read(d(x)).toString());case o.Int:return d(x)}}e.deserialize=v;class R{constructor(W,B,H=null,q=1e3){this.protocol=W,this.ctx=B,this.logger=H,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(W,B){this.channels.set(W,B),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const B=this.send([W.type]);this.logger?.logOutgoing(B,0,1,m(W.type));return}case 201:case 202:case 204:case 203:{const B=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(B,W.id,1,m(W.type),W.data);return}}}send(W,B=void 0){const H=new i;return c(H,W),c(H,B),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const B=new h(W),H=v(B),q=v(B),Z=H[0];switch(Z){case 100:return this.logger?.logIncoming(W.byteLength,H[1],1,`${S(Z)}: ${H[2]}.${H[3]}`,q),this.onPromise({type:Z,id:H[1],channelName:H[2],name:H[3],arg:q});case 102:return this.logger?.logIncoming(W.byteLength,H[1],1,`${S(Z)}: ${H[2]}.${H[3]}`,q),this.onEventListen({type:Z,id:H[1],channelName:H[2],name:H[3],arg:q});case 101:return this.logger?.logIncoming(W.byteLength,H[1],1,`${S(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]});case 103:return this.logger?.logIncoming(W.byteLength,H[1],1,`${S(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]})}}onPromise(W){const B=this.channels.get(W.channelName);if(!B){this.collectPendingRequest(W);return}const H=new O.CancellationTokenSource;let q;try{q=B.call(this.ctx,W.name,W.arg,H.token)}catch(j){q=Promise.reject(j)}const Z=W.id;q.then(j=>{this.sendResponse({id:Z,data:j,type:201})},j=>{j instanceof Error?this.sendResponse({id:Z,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:Z,data:j,type:203})}).finally(()=>{de.dispose(),this.activeRequests.delete(W.id)});const de=(0,u.toDisposable)(()=>H.cancel());this.activeRequests.set(W.id,de)}onEventListen(W){const B=this.channels.get(W.channelName);if(!B){this.collectPendingRequest(W);return}const H=W.id,Z=B.listen(this.ctx,W.name,W.arg)(de=>this.sendResponse({id:H,data:de,type:204}));this.activeRequests.set(W.id,Z)}disposeActiveRequest(W){const B=this.activeRequests.get(W.id);B&&(B.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let B=this.pendingRequests.get(W.channelName);B||(B=[],this.pendingRequests.set(W.channelName,B));const H=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:W,timeoutTimer:H})}flushPendingRequests(W){const B=this.pendingRequests.get(W);if(B){for(const H of B)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=R;var k;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class E{constructor(W,B=null){this.protocol=W,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=B}getChannel(W){const B=this;return{call(H,q,Z){return B.isDisposed?Promise.reject(new I.CancellationError):B.requestPromise(W,H,q,Z)},listen(H,q){return B.isDisposed?f.Event.None:B.requestEvent(W,H,q)}}}requestPromise(W,B,H,q=O.CancellationToken.None){const Z=this.lastRequestId++,j={id:Z,type:100,channelName:W,name:B,arg:H};if(q.isCancellationRequested)return Promise.reject(new I.CancellationError);let A;return new Promise((J,z)=>{if(q.isCancellationRequested)return z(new I.CancellationError);const K=()=>{const ae=re=>{switch(re.type){case 201:this.handlers.delete(Z),J(re.data);break;case 202:{this.handlers.delete(Z);const me=new Error(re.data.message);me.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,me.name=re.data.name,z(me);break}case 203:this.handlers.delete(Z),z(re.data);break}};this.handlers.set(Z,ae),this.sendRequest(j)};let N=null;this.state===g.Idle?K():(N=(0,L.createCancelablePromise)(ae=>this.whenInitialized()),N.then(()=>{N=null,K()}));const $=()=>{N?(N.cancel(),N=null):this.sendRequest({id:Z,type:101}),z(new I.CancellationError)},ee=q.onCancellationRequested($);A=(0,u.combinedDisposable)((0,u.toDisposable)($),ee),this.activeRequests.add(A)}).finally(()=>{A.dispose(),this.activeRequests.delete(A)})}requestEvent(W,B,H){const q=this.lastRequestId++,de={id:q,type:102,channelName:W,name:B,arg:H};let j=null;const A=new f.Emitter({onWillAddFirstListener:()=>{j=(0,L.createCancelablePromise)(J=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(A),this.sendRequest(de)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(A),this.sendRequest({id:q,type:103}))}}),F=J=>A.fire(J.data);return this.handlers.set(q,F),A.event}sendRequest(W){switch(W.type){case 100:case 102:{const B=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(B,W.id,0,`${S(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const B=this.send([W.type,W.id]);this.logger?.logOutgoing(B,W.id,0,S(W.type));return}}}send(W,B=void 0){const H=new i;return c(H,W),c(H,B),this.sendBuffer(H.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const B=new h(W),H=v(B),q=v(B),Z=H[0];switch(Z){case 200:return this.logger?.logIncoming(W.byteLength,0,0,m(Z)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,H[1],0,m(Z),q),this.onResponse({type:H[0],id:H[1],data:q})}}onResponse(W){if(W.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=E,Ee([D.memoize],E.prototype,"onDidInitializePromise",null);class M{get connections(){const W=[];return this._connections.forEach(B=>W.push(B)),W}constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new u.DisposableStore,this.disposables.add(W(({protocol:B,onDidClientDisconnect:H})=>{const q=f.Event.once(B.onMessage);this.disposables.add(q(Z=>{const de=new h(Z),j=v(de),A=new R(B,j),F=new E(B);this.channels.forEach((z,K)=>A.registerChannel(K,z));const J={channelServer:A,channelClient:F,ctx:j};this._connections.add(J),this._onDidAddConnection.fire(J),this.disposables.add(H(()=>{A.dispose(),F.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)}))}))}))}getChannel(W,B){const H=this;return{call(q,Z,de){let j;if((0,w.isFunction)(B)){const F=(0,C.getRandomElement)(H.connections.filter(B));j=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,B))}else j=B.routeCall(H,q,Z);const A=j.then(F=>F.channelClient.getChannel(W));return T(A).call(q,Z,de)},listen(q,Z){if((0,w.isFunction)(B))return H.getMulticastEvent(W,B,q,Z);const de=B.routeEvent(H,q,Z).then(j=>j.channelClient.getChannel(W));return T(de).listen(q,Z)}}}getMulticastEvent(W,B,H,q){const Z=this;let de;const j=new f.Emitter({onWillAddFirstListener:()=>{de=new u.DisposableStore;const A=new f.EventMultiplexer,F=new Map,J=K=>{const $=K.channelClient.getChannel(W).listen(H,q),ee=A.add($);F.set(K,ee)},z=K=>{const N=F.get(K);N&&(N.dispose(),F.delete(K))};Z.connections.filter(B).forEach(J),f.Event.filter(Z.onDidAddConnection,B)(J,void 0,de),Z.onDidRemoveConnection(z,void 0,de),A.event(j.fire,j,de),de.add(A)},onDidRemoveLastListener:()=>{de?.dispose(),de=void 0}});return j.event}registerChannel(W,B){this.channels.set(W,B);for(const H of this._connections)H.channelServer.registerChannel(W,B)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=M;class _{constructor(W,B,H=null){const q=new i;c(q,B),W.send(q.buffer),this.channelClient=new E(W,H),this.channelServer=new R(W,B,H)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,B){this.channelServer.registerChannel(W,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function T(x){return{call(W,B,H){return x.then(q=>q.call(W,B,H))},listen(W,B){const H=new f.Relay;return x.then(q=>H.input=q.listen(W,B)),H.event}}}e.getDelayedChannel=T;function U(x){let W=!1;return{call(B,H,q){return W?x.call(B,H,q):(0,L.timeout)(0).then(()=>W=!0).then(()=>x.call(B,H,q))},listen(B,H){if(W)return x.listen(B,H);const q=new f.Relay;return(0,L.timeout)(0).then(()=>W=!0).then(()=>q.input=x.listen(B,H)),q.event}}}e.getNextTickChannel=U;class X{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const B of W.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await f.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=X;var Y;(function(x){function W(Z,de,j){const A=Z,F=j&&j.disableMarshalling,J=new Map;for(const z in A)H(z)&&J.set(z,f.Event.buffer(A[z],!0,void 0,de));return new class{listen(z,K,N){const $=J.get(K);if($)return $;if(q(K)){const ee=A[K];if(typeof ee=="function")return ee.call(A,N)}throw new I.ErrorNoTelemetry(`Event not found: ${K}`)}call(z,K,N){const $=A[K];if(typeof $=="function"){if(!F&&Array.isArray(N))for(let ae=0;ae<N.length;ae++)N[ae]=(0,y.revive)(N[ae]);let ee=$.apply(A,N);return ee instanceof Promise||(ee=Promise.resolve(ee)),ee}throw new I.ErrorNoTelemetry(`Method not found: ${K}`)}}}x.fromService=W;function B(Z,de){const j=de&&de.disableMarshalling;return new Proxy({},{get(A,F){if(typeof F=="string")return de?.properties?.has(F)?de.properties.get(F):q(F)?function(J){return Z.listen(F,J)}:H(F)?Z.listen(F):async function(...J){let z;de&&!(0,w.isUndefinedOrNull)(de.context)?z=[de.context,...J]:z=J;const K=await Z.call(F,z);return j?K:(0,y.revive)(K)};throw new I.ErrorNoTelemetry(`Property not found: ${String(F)}`)}})}x.toService=B;function H(Z){return Z[0]==="o"&&Z[1]==="n"&&b.isUpperAsciiLetter(Z.charCodeAt(2))}function q(Z){return/^onDynamic/.test(Z)&&b.isUpperAsciiLetter(Z.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const W=x.toString();if(W!=="[object Object]")return W}return x}function ue(x){return Array.isArray(x)?x.map(ce):ce(x)}function Q(x,W,B,H,q,Z,de){de=ue(de);const j=le[q],A=j[H%j.length];let F=[`%c[${x}]%c[${String(W).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(Z)?(F=F.concat(de),F.push(")")):F.push(de),console.log.apply(console,F)}class G{constructor(W,B){this._outgoingPrefix=W,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,B,H,q,Z){this._totalOutgoing+=W,Q(this._outgoingPrefix,this._totalOutgoing,W,B,H,q,Z)}logIncoming(W,B,H,q,Z){this._totalIncoming+=W,Q(this._incomingPrefix,this._totalIncoming,W,B,H,q,Z)}}e.IPCLogger=G}),define(se[157],oe([0,1,18,3,42]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class O{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",u=>C.VSBuffer.wrap(u.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=O;class D extends r.IPCClient{constructor(f,u){const y=new O(f);super(y,u),this.protocol=y}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=D}),define(se[109],oe([0,1,18,3,2,42]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var I;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let c=0;function v(k,E){if(!n.has(k)){const M=String(++c);n.set(k,M)}return n.get(k)}function R(k,E,M,_){if(!t.enableDiagnostics)return;const T=v(k,E);if(_ instanceof C.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const U=C.VSBuffer.alloc(_.byteLength);U.set(_),t.records.push({timestamp:Date.now(),id:T,label:E,type:M,buff:U})}else t.records.push({timestamp:Date.now(),id:T,label:E,type:M,data:_})}t.traceSocketEvent=R})(I||(e.SocketDiagnostics=I={}));var f;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let u=null;function y(){return u||(u=C.VSBuffer.alloc(0)),u}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,c){if(n===0)return y();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return c&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}const v=C.VSBuffer.alloc(n);let R=0,k=0;for(;n>0;){const E=this._chunks[k];if(E.byteLength>n){const M=E.slice(0,n);v.set(M,R),R+=n,c&&(this._chunks[k]=E.slice(n),this._totalLength-=n),n-=n}else v.set(E,R),R+=E.byteLength,c?(this._chunks.shift(),this._totalLength-=E.byteLength):k++,n-=E.byteLength}return v}}e.ChunkStream=b;var w;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(w||(w={}));function l(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class p{constructor(n,c,v,R){this.type=n,this.id=c,this.ack=v,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends r.Disposable{constructor(n){super(),this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:l(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const v=this._state.messageType,R=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new p(v,R,k,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=C.VSBuffer.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:l(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(c,n.data)}_bufferAdd(n,c){const v=this._totalLength===0;return this._data.push(n,c),this._totalLength+=n.byteLength+c.byteLength,v}_bufferTake(){const n=C.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,c){this._bufferAdd(n,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class d extends r.Disposable{constructor(n){super(),this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new p(1,0,0,n))}}e.Protocol=d;class a extends O.IPCClient{static fromSocket(n,c){return new a(new d(n),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(n,c,v=null){super(n,c,v),this.protocol=n}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=a;class P{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=P;class h{constructor(n){this.data=n,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let n=0,c=this._first;for(;c;)c=c.next,n++;return n}peek(){return this._first?this._first.data:null}toArray(){const n=[];let c=0,v=this._first;for(;v;)n[c++]=v.data,v=v.next;return n}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const c=new h(n);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const n=Date.now();for(let c=0;c<o._HISTORY_LENGTH;c++)this.lastRuns[c]=n-1e3*c;setInterval(()=>{for(let c=o._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const n=Date.now(),c=(1+o._HISTORY_LENGTH)*1e3;let v=0;for(let R=0;R<o._HISTORY_LENGTH;R++)n-this.lastRuns[R]<=c&&v++;return 1-v/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(n){this._onControlMessage=new P,this.onControlMessage=this._onControlMessage.event,this._onMessage=new P,this.onMessage=this._onMessage.event,this._onDidDispose=new P,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new P,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new P,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=n.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new r.DisposableStore,this._socket=n.socket,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.add(this._socket.onClose(c=>this._onSocketClose.fire(c))),n.initialChunk&&this._socketReader.acceptChunk(n.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new p(5,0,0,y());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new p(7,0,0,y());this._socketWriter.write(n)}sendResume(){const n=new p(8,0,0,y());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,c){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new r.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=this._socketDisposables.add(new g(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.add(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new p(3,0,this._incomingAckId,y());this._socketWriter.write(n);const c=this._outgoingUnackMsg.toArray();for(let v=0,R=c.length;v<R;v++)this._socketWriter.write(c[v]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new p(6,0,0,y())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let v=0,R=c.length;v<R;v++)this._socketWriter.write(c[v]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new p(1,c,this._incomingAckId,n);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(n){const c=new p(2,0,0,n);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),c=Date.now()-n.writtenTime,v=Date.now()-this._socketReader.lastReadTime,R=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&v>=2e4&&R>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:v});return}const k=Math.max(2e4-c,2e4-v,2e4-R,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new p(3,0,this._incomingAckId,y());this._socketWriter.write(n)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const n=new p(9,0,this._incomingAckId,y());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(se[36],oe([0,1,15,14,13]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class O{constructor(){this.mapListenerToWrapper=new WeakMap}on(I,f){const u=(y,...b)=>{this.validateEvent(I,y)&&f(y,...b)};return this.mapListenerToWrapper.set(f,u),C.ipcMain.on(I,u),this}once(I,f){return C.ipcMain.once(I,(u,...y)=>{this.validateEvent(I,u)&&f(u,...y)}),this}handle(I,f){return C.ipcMain.handle(I,(u,...y)=>this.validateEvent(I,u)?f(u,...y):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return C.ipcMain.removeHandler(I),this}removeListener(I,f){const u=this.mapListenerToWrapper.get(f);return u&&(C.ipcMain.removeListener(I,u),this.mapListenerToWrapper.delete(f)),this}validateEvent(I,f){if(!I||!I.startsWith("vscode:"))return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const u=f.senderFrame,y=u.url;if(!y||y==="about:blank")return!0;let b="unknown";try{b=new URL(y).host}catch{return(0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${y}'.`),!1}return b!==r.VSCODE_AUTHORITY?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${b}'.`),!1):u.parent!==null?((0,L.onUnexpectedError)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new O}),define(se[158],oe([0,1,15,36,146]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function O(){L.validatedIpcMain.on(r.CONTEXT_MENU_CHANNEL,(I,f,u,y,b)=>{const w=D(I,y,u);w.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{w&&I.sender.send(r.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=O;function D(I,f,u){const y=new C.Menu;return u.forEach(b=>{let w;b.type==="separator"?w=new C.MenuItem({type:b.type}):Array.isArray(b.submenu)?w=new C.MenuItem({submenu:D(I,f,b.submenu),label:b.label}):w=new C.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(l,S,p)=>I.sender.send(f,b.id,p)}),y.append(w)}),y}}),define(se[159],oe([0,1,36,18,3,2,42,147]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(y,b){const w=r.Event.fromNodeEventEmitter(C.validatedIpcMain,b,(S,p)=>({event:S,message:p})),l=r.Event.filter(w,({event:S})=>S.sender.id===y);return r.Event.map(l,({message:S})=>S&&L.VSBuffer.wrap(S))}class u extends D.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const b=r.Event.fromNodeEventEmitter(C.validatedIpcMain,"vscode:hello",({sender:w})=>w);return r.Event.map(b,w=>{const l=w.id;u.Clients.get(l)?.dispose();const p=new r.Emitter;u.Clients.set(l,(0,O.toDisposable)(()=>p.fire()));const m=f(l,"vscode:message"),g=r.Event.any(r.Event.signal(f(l,"vscode:disconnect")),p.event);return{protocol:new I.Protocol(w,m),onDidClientDisconnect:g}})}constructor(){super(u.getOnDidClientConnect())}}e.Server=u}),define(se[110],oe([0,1,36,3,32,157]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends O.Client{constructor(u,y){super({addEventListener:(b,w)=>u.addListener(b,w),removeEventListener:(b,w)=>u.removeListener(b,w),postMessage:b=>u.postMessage(b),start:()=>u.start(),close:()=>u.close()},y)}}e.Client=D;async function I(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,r.generateUuid)();f.webContents.send("vscode:createMessageChannel",u);const y=L.Event.fromNodeEventEmitter(C.validatedIpcMain,"vscode:createMessageChannelResult",(w,l)=>({nonce:l,port:w.ports[0]})),{port:b}=await L.Event.toPromise(L.Event.once(L.Event.filter(y,w=>w.nonce===u)));return b}e.connect=I}),define(se[160],oe([0,1,48,8,18,22,154,14,3,2,38,89,76,42]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends l.ChannelServer{constructor(g){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",d=>r.VSBuffer.wrap(Buffer.from(d,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=S;class p{constructor(g,d){this.modulePath=g,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new L.Delayer(a),this.child=null,this._client=null}getChannel(g){const d=this;return{call(a,P,h){return d.requestPromise(g,a,P,h)},listen(a,P){return d.requestEvent(g,a,P)}}}requestPromise(g,d,a,P=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(P.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const h=this.getCachedChannel(g),i=(0,L.createCancelablePromise)(t=>h.call(d,a,t)),o=P.onCancellationRequested(()=>i.cancel()),s=(0,u.toDisposable)(()=>i.cancel());return this.activeRequests.add(s),i.finally(()=>{o.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(g,d,a){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let P;const h=new f.Emitter({onWillAddFirstListener:()=>{P=this.getCachedChannel(g).listen(d,a)(h.fire,h),this.activeRequests.add(P)},onDidRemoveLastListener:()=>{this.activeRequests.delete(P),P.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return h.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,w.removeDangerousEnvVariables)(d.env),this.child=(0,C.fork)(this.modulePath,g,d);const a=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,D.isRemoteConsoleLog)(n)){(0,D.log)(n,`IPC Library: ${this.options.serverName}`);return}a.fire(r.VSBuffer.wrap(Buffer.from(n,"base64")))});const h=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=n=>this.child&&this.child.connected&&h.send(n.buffer.toString("base64")),o=a.event,s={send:i,onMessage:o};this._client=new l.ChannelClient(s);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,c)=>{process.removeListener("exit",t),this.activeRequests.forEach(v=>(0,u.dispose)(v)),this.activeRequests.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:c})})}return this._client}getCachedChannel(g){let d=this.channels.get(g);return d||(d=this.client.getChannel(g),this.channels.set(g,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(se[111],oe([0,1,8,3,2,77,12]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function f(w){const l=w;return l?.changed instanceof Map||l?.deleted instanceof Set}e.isStorageItemsChangeEvent=f;var u;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(u||(e.StorageState=u={}));class y extends r.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(l,S=Object.create(null)){super(),this.database=l,this.options=S,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=this._register(new C.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(l=>this.onDidChangeItemsExternal(l)))}onDidChangeItemsExternal(l){this._onDidChangeStorage.pause();try{l.changed?.forEach((S,p)=>this.acceptExternal(p,S)),l.deleted?.forEach(S=>this.acceptExternal(S,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(l,S){if(this.state===u.Closed)return;let p=!1;(0,D.isUndefinedOrNull)(S)?p=this.cache.delete(l):this.cache.get(l)!==S&&(this.cache.set(l,S),p=!0),p&&this._onDidChangeStorage.fire({key:l,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(l,S){const p=this.cache.get(l);return(0,D.isUndefinedOrNull)(p)?S:p}getBoolean(l,S){const p=this.get(l);return(0,D.isUndefinedOrNull)(p)?S:p==="true"}getNumber(l,S){const p=this.get(l);return(0,D.isUndefinedOrNull)(p)?S:parseInt(p,10)}getObject(l,S){const p=this.get(l);return(0,D.isUndefinedOrNull)(p)?S:(0,O.parse)(p)}async set(l,S,p=!1){if(this.state===u.Closed)return;if((0,D.isUndefinedOrNull)(S))return this.delete(l,p);const m=(0,D.isObject)(S)||Array.isArray(S)?(0,O.stringify)(S):String(S);if(this.cache.get(l)!==m)return this.cache.set(l,m),this.pendingInserts.set(l,m),this.pendingDeletes.delete(l),this._onDidChangeStorage.fire({key:l,external:p}),this.doFlush()}async delete(l,S=!1){if(!(this.state===u.Closed||!this.cache.delete(l)))return this.pendingDeletes.has(l)||this.pendingDeletes.add(l),this.pendingInserts.delete(l),this._onDidChangeStorage.fire({key:l,external:S}),this.doFlush()}async optimize(){if(this.state!==u.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const l={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(l).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(l){if(this.hasPending)return this.doFlush(l)}async doFlush(l){return this.options.hint===I.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),l)}async whenFlushed(){if(this.hasPending)return new Promise(l=>this.whenFlushedCallbacks.push(l))}isInMemory(){return this.options.hint===I.STORAGE_IN_MEMORY}}e.Storage=y;class b{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(l){l.insert?.forEach((S,p)=>this.items.set(p,S)),l.delete?.forEach(S=>this.items.delete(S))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=b}),define(se[161],oe([0,1,8,3,31,9,21]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return L.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(y,b=Object.create(null)){this.path=y,this.options=b,this.name=(0,O.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const y=await this.whenConnected,b=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(l=>b.set(l.key,l.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(y){const b=await this.whenConnected;return this.doUpdateItems(b,y)}doUpdateItems(y,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,r.mapToString)(b.insert):"0"}), delete(${b.delete?(0,r.setToString)(b.delete):"0"})`),this.transaction(y,()=>{const w=b.insert,l=b.delete;if(w&&w.size>0){const S=[];S.push([]);let p=0;w.forEach((m,g)=>{let d=S[p];d.length>I.MAX_HOST_PARAMETERS&&(p++,d=[],S.push(d)),d.push(g,m)}),S.forEach(m=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,g=>g.run(m),()=>{const g=[];let d=0;return w.forEach((a,P)=>{g.push(P),d+=a.length}),`Keys: ${g.join(", ")} Length: ${d}`})})}if(l&&l.size){const S=[];S.push([]);let p=0;l.forEach(m=>{let g=S[p];g.length>I.MAX_HOST_PARAMETERS&&(p++,g=[],S.push(g)),g.push(m)}),S.forEach(m=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,g=>g.run(m),()=>{const g=[];return l.forEach(d=>{g.push(d)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const y=await this.whenConnected;return this.exec(y,"VACUUM")}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,y)}doClose(y,b){return new Promise((w,l)=>{y.db.close(S=>(S&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${S}`),this.path===I.IN_MEMORY_PATH?w():!y.isErroneous&&!y.isInMemory?this.backup().then(w,p=>(this.logger.error(`[storage ${this.name}] backup(): ${p}`),w())):typeof b=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(p=>{const m=()=>this.doClose(p,void 0);return this.doUpdateItems(p,{insert:b()}).then(()=>m(),g=>(m(),Promise.reject(g)))})).then(w,l):l(S||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return D.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const b=await this.whenConnected,w=await this.get(b,y?"PRAGMA integrity_check":"PRAGMA quick_check"),l=y?w.integrity_check:w.quick_check;return b.isErroneous?`${l} (last error: ${b.lastError})`:b.isInMemory?`${l} (in-memory!)`:l}async connect(y,b=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${b})`);try{return await this.doConnect(y)}catch(w){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&b)return await(0,C.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await D.Promises.unlink(y);try{await D.Promises.rename(this.toBackupPath(y),y,!1)}catch{}return await this.doConnect(y)}catch(l){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${l}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,b){y.isErroneous=!0,y.lastError=b,this.logger.error(b)}doConnect(y){return new Promise((b,w)=>{new Promise((l,S)=>{V(["@vscode/sqlite3"],l,S)}).then(l=>{const S={db:new(this.logger.isTracing?l.verbose().Database:l.Database)(y,p=>p?S.db&&p.code!=="SQLITE_CANTOPEN"?S.db.close(()=>w(p)):w(p):this.exec(S,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(S),m=>S.db.close(()=>w(m)))),isInMemory:y===I.IN_MEMORY_PATH};S.db.on("error",p=>this.handleSQLiteError(S,`[storage ${this.name}] Error (event): ${p}`)),this.logger.isTracing&&S.db.on("trace",p=>this.logger.trace(`[storage ${this.name}] Trace (event): ${p}`))},w)})}exec(y,b){return new Promise((w,l)=>{y.db.exec(b,S=>S?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${S}`),l(S)):w())})}get(y,b){return new Promise((w,l)=>{y.db.get(b,(S,p)=>S?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${S}`),l(S)):w(p))})}all(y,b){return new Promise((w,l)=>{y.db.all(b,(S,p)=>S?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${S}`),l(S)):w(p))})}transaction(y,b){return new Promise((w,l)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),b(),y.db.run("END TRANSACTION",S=>S?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${S}`),l(S)):w())})})}prepare(y,b,w,l){const S=y.db.prepare(b),p=m=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${m} (${b}). Details: ${l()}`)};S.on("error",p),w(S),S.finalize(m=>{m&&p(m),S.removeListener("error",p)})}}e.SQLiteStorageDatabase=I;class f{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(y){y&&typeof y.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace?.(y)}error(y){this.logError?.(y)}}}),define(se[162],oe([11,10]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(se[163],oe([11,10]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[164],oe([11,10]),function(V,e){return V.create("vs/platform/contextkey/common/contextkey",e)}),define(se[165],oe([11,10]),function(V,e){return V.create("vs/platform/contextkey/common/scanner",e)}),define(se[166],oe([11,10]),function(V,e){return V.create("vs/platform/dialogs/common/dialogs",e)}),define(se[167],oe([11,10]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(se[168],oe([11,10]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(se[169],oe([11,10]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(se[170],oe([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[171],oe([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[172],oe([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[173],oe([11,10]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[174],oe([11,10]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(se[175],oe([11,10]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(se[176],oe([11,10]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(se[177],oe([11,10]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(se[178],oe([11,10]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(se[179],oe([11,10]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[180],oe([11,10]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(se[181],oe([11,10]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(se[182],oe([11,10]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(se[183],oe([11,10]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(se[184],oe([11,10]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(se[185],oe([11,10]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[186],oe([11,10]),function(V,e){return V.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[187],oe([11,10]),function(V,e){return V.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[188],oe([11,10]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(se[189],oe([11,10]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[190],oe([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(se[191],oe([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(se[192],oe([11,10]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(se[193],oe([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(se[194],oe([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(se[195],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function C(r){return r&&r.hasOwnProperty("folderUri")}e.isFolderBackupInfo=C;function L(r){return r&&r.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=L}),define(se[196],oe([0,1,7]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function L(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=L;function r(D){let I=[];try{Array.isArray(D.workspaces)&&(I=D.workspaces.map(f=>({workspace:{id:f.id,configPath:C.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=r;function O(D){let I=[];try{Array.isArray(D.folders)&&(I=D.folders.map(f=>({folderUri:C.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=O}),define(se[197],oe([0,1,14,165]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var r;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(r||(e.TokenType=r={}));function O(...u){switch(u.length){case 1:return(0,L.localize)(0,null,u[0]);case 2:return(0,L.localize)(1,null,u[0],u[1]);case 3:return(0,L.localize)(2,null,u[0],u[1],u[2]);default:return}}const D=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,C.illegalState)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(y){return this._input=y,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(y){return this._isAtEnd()||this._input.charCodeAt(this._current)!==y?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(y){this._tokens.push({type:y,offset:this._start})}_error(y){const b=this._start,w=this._input.substring(this._start,this._current),l={type:19,offset:this._start,lexeme:w};this._errors.push({offset:b,lexeme:w,additionalInfo:y}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const y=this.stringRe.exec(this._input);if(y){this._current=this._start+y[0].length;const b=this._input.substring(this._start,this._current),w=f._keywords.get(b);w?this._addToken(w):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(D);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let y=this._current,b=!1,w=!1;for(;;){if(y>=this._input.length){this._current=y,this._error(I);return}const S=this._input.charCodeAt(y);if(b)b=!1;else if(S===47&&!w){y++;break}else S===91?w=!0:S===92?b=!0:S===93&&(w=!1);y++}for(;y<this._input.length&&f._regexFlags.has(this._input.charCodeAt(y));)y++;this._current=y;const l=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f}),define(se[198],oe([0,1,3,2]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new C.Emitter,this._onReloadEmitter=new C.Emitter,this._onTerminateEmitter=new C.Emitter,this._onAttachEmitter=new C.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(I,f,u){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(I,f,u){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=r;class O extends L.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,f,u){this.channel.call("attach",[I,f,u])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,f){this.channel.call("terminate",[I,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,f){return this.channel.call("openExtensionDevelopmentHostWindow",[I,f])}}e.ExtensionHostDebugChannelClient=O}),define(se[199],oe([0,1,149,56,13,9,35,19,7]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,O.dirname)(r.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",l)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(f.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?f.URI.file((0,O.join)(l,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,O.resolve)(l):(0,O.normalize)((0,O.join)(r.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?f.URI.file((0,O.resolve)(l)):f.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,O.resolve)(l);const S=D.env.VSCODE_EXTENSIONS;if(S)return S;const p=D.env.VSCODE_PORTABLE;return p?(0,O.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(S=>/^[^:/?#]+?:\/\//.test(S)?f.URI.parse(S):f.URI.file((0,O.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?f.URI.parse(l):f.URI.file((0,O.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(l))}get extensionLogLevel(){const l=[];for(const S of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);p&&p[1]&&p[2]&&l.push([p[1],p[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=D.env.VSCODE_PORTABLE;return l?f.URI.file((0,O.join)(l,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this._args}constructor(l,S,p){this._args=l,this.paths=S,this.productService=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=u,Ee([L.memoize],u.prototype,"appRoot",null),Ee([L.memoize],u.prototype,"userHome",null),Ee([L.memoize],u.prototype,"userDataPath",null),Ee([L.memoize],u.prototype,"appSettingsHome",null),Ee([L.memoize],u.prototype,"tmpDir",null),Ee([L.memoize],u.prototype,"cacheHome",null),Ee([L.memoize],u.prototype,"stateResource",null),Ee([L.memoize],u.prototype,"userRoamingDataHome",null),Ee([L.memoize],u.prototype,"userDataSyncHome",null),Ee([L.memoize],u.prototype,"sync",null),Ee([L.memoize],u.prototype,"machineSettingsResource",null),Ee([L.memoize],u.prototype,"workspaceStorageHome",null),Ee([L.memoize],u.prototype,"localHistoryHome",null),Ee([L.memoize],u.prototype,"keyboardLayoutResource",null),Ee([L.memoize],u.prototype,"argvResource",null),Ee([L.memoize],u.prototype,"isExtensionDevelopment",null),Ee([L.memoize],u.prototype,"untitledWorkspacesHome",null),Ee([L.memoize],u.prototype,"builtinExtensionsPath",null),Ee([L.memoize],u.prototype,"extensionsPath",null),Ee([L.memoize],u.prototype,"extensionDevelopmentLocationURI",null),Ee([L.memoize],u.prototype,"extensionDevelopmentKind",null),Ee([L.memoize],u.prototype,"extensionTestsLocationURI",null),Ee([L.memoize],u.prototype,"debugExtensionHost",null),Ee([L.memoize],u.prototype,"logLevel",null),Ee([L.memoize],u.prototype,"extensionLogLevel",null),Ee([L.memoize],u.prototype,"serviceMachineIdResource",null),Ee([L.memoize],u.prototype,"disableTelemetry",null),Ee([L.memoize],u.prototype,"disableWorkspaceTrust",null),Ee([L.memoize],u.prototype,"useInMemorySecretStorage",null),Ee([L.memoize],u.prototype,"policyFile",null);function y(w,l){return b(w["inspect-extensions"],w["inspect-brk-extensions"],5870,l,w.debugId,w.extensionEnvironment)}e.parseExtensionHostDebugPort=y;function b(w,l,S,p,m,g){const a=Number(l||w)||(p?null:S),P=a?!!l:!1;let h;if(g)try{h=JSON.parse(g)}catch{}return{port:a,break:P,debugId:m,env:h}}e.parseDebugParams=b}),define(se[112],oe([0,1,309,4,168]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0;const O={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(p,m,g=D){const d=p.find(c=>c.length>0&&c[0]!=="-"),a={},P=["_"],h=[],i={};let o;for(const c in m){const v=m[c];v.type==="subcommand"?c===d&&(o=v):(v.alias&&(a[c]=v.alias),v.type==="string"||v.type==="string[]"?(P.push(c),v.deprecates&&P.push(...v.deprecates)):v.type==="boolean"&&(h.push(c),v.deprecates&&h.push(...v.deprecates)),v.global&&(i[c]=v))}if(o&&d){const c=i;for(const E in o.options)c[E]=o.options[E];const v=p.filter(E=>E!==d),R=g.getSubcommandReporter?g.getSubcommandReporter(d):void 0,k=I(v,c,R);return{[d]:k,_:[]}}const s=C(p,{string:P,boolean:h,alias:a}),t={},n=s;t._=s._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in m){const v=m[c];if(v.type==="subcommand")continue;v.alias&&delete n[v.alias];let R=n[c];if(v.deprecates)for(const k of v.deprecates)n.hasOwnProperty(k)&&(R||(R=n[k],R&&g.onDeprecatedOption(k,v.deprecationMessage||(0,r.localize)(37,null,c))),delete n[k]);if(typeof R<"u"){if(v.type==="string[]"){if(Array.isArray(R)||(R=[R]),!v.allowEmptyValue){const k=R.filter(E=>E.length>0);k.length!==R.length&&(g.onEmptyValue(c),R=k.length>0?k:void 0)}}else v.type==="string"&&(Array.isArray(R)?(R=R.pop(),g.onMultipleValues(c,R)):!R&&!v.allowEmptyValue&&(g.onEmptyValue(c),R=void 0));t[c]=R,v.deprecationMessage&&g.onDeprecatedOption(c,v.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return t}e.parseArgs=I;function f(p,m){let g="";return m.args&&(Array.isArray(m.args)?g=` <${m.args.join("> <")}>`:g=` <${m.args}>`),m.alias?`-${m.alias} --${p}${g}`:`--${p}${g}`}function u(p,m){const g=[];for(const d in p){const a=p[d],P=f(d,a);g.push([P,a.description])}return y(g,m)}e.formatOptions=u;function y(p,m){const d=p.reduce((h,i)=>Math.max(h,i[0].length),12)+2+1;if(m-d<25)return p.reduce((h,i)=>h.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=m-d-1,P=[];for(const h of p){const i=h[0],o=w(h[1],a),s=b(d-i.length-2);P.push("  "+i+s+o[0]);for(let t=1;t<o.length;t++)P.push(b(d)+o[t])}return P}function b(p){return" ".repeat(p)}function w(p,m){const g=[];for(;p.length;){const d=p.length<m?p.length:p.lastIndexOf(" ",m),a=p.slice(0,d).trim();p=p.slice(d),g.push(a)}return g}function l(p,m,g,d,a){const P=process.stdout.isTTY&&process.stdout.columns||80,h=a?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",i=[`${p} ${g}`];i.push(""),i.push(`${(0,r.localize)(39,null)}: ${m} [${(0,r.localize)(40,null)}]${h}`),i.push(""),a?.noPipe!==!0&&(L.isWindows?i.push((0,r.localize)(41,null,m)):i.push((0,r.localize)(42,null,m)),i.push(""));const o={},s=[];for(const t in d){const n=d[t];if(n.type==="subcommand")n.description&&s.push({command:t,description:n.description});else if(n.description&&n.cat){let c=o[n.cat];c||(o[n.cat]=c={}),c[t]=n}}for(const t in o){const n=t,c=o[n];c&&(i.push(O[n]),i.push(...u(c,P)),i.push(""))}return s.length&&(i.push((0,r.localize)(43,null)),i.push(...y(s.map(t=>[t.command,t.description]),P)),i.push("")),i.join(`
`)}e.buildHelpMessage=l;function S(p,m){return`${p||(0,r.localize)(44,null)}
${m||(0,r.localize)(45,null)}
${process.arch}`}e.buildVersionMessage=S}),define(se[200],oe([0,1,87,198,112]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class O extends L.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.windowsMainService=I}call(I,f,u){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(u[0],u[1]):super.call(I,f,u)}async openExtensionDevelopmentHostWindow(I,f){const u=(0,r.parseArgs)(I,r.OPTIONS);u.debugRenderer=f;const y=u.extensionDevelopmentPath;if(!y)return{success:!1};const[b]=await this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!f)return{success:!0};const w=b.win;if(!w)return{success:!0};const l=w.webContents.debugger;let S=l.isAttached()?1/0:0;const p=(0,C.createServer)(m=>{S++===0&&l.attach();let g=!1;const d=h=>{g||m.write(JSON.stringify(h)+"\0")},a=(h,i,o,s)=>d({method:i,params:o,sessionId:s});w.on("close",()=>{l.removeListener("message",a),m.end(),g=!0}),l.addListener("message",a);let P=Buffer.alloc(0);m.on("data",h=>{P=Buffer.concat([P,h]);for(let i=P.indexOf(0);i!==-1;i=P.indexOf(0)){let o;try{const s=P.slice(0,i).toString("utf8");P=P.slice(i+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}l.sendCommand(o.method,o.params,o.sessionId).then(s=>d({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>d({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),m.on("error",h=>{console.error("error on cdp pipe:",h)}),m.on("close",()=>{g=!0,--S===0&&l.detach()})});return await new Promise(m=>p.listen(0,m)),w.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=O}),define(se[64],oe([0,1,310,169,112]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function O(b,w){const l=(a,P)=>{console.warn((0,L.localize)(0,null,a,P))},S=a=>{console.warn((0,L.localize)(1,null,a))},p=(a,P)=>{console.warn((0,L.localize)(2,null,a,P))},m=a=>({onUnknownOption:P=>{r.NATIVE_CLI_COMMANDS.includes(a)||console.warn((0,L.localize)(3,null,P,a))},onMultipleValues:l,onEmptyValue:S,onDeprecatedOption:p,getSubcommandReporter:r.NATIVE_CLI_COMMANDS.includes(a)?m:void 0}),g={onUnknownOption:a=>{console.warn((0,L.localize)(4,null,a))},onMultipleValues:l,onEmptyValue:S,onDeprecatedOption:p,getSubcommandReporter:m},d=(0,r.parseArgs)(b,r.OPTIONS,w?g:void 0);return d.goto&&d._.forEach(a=>C(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(a),(0,L.localize)(5,null))),d}function D(b){const w=b.findIndex(l=>!/^-/.test(l));if(w>-1)return[...b.slice(0,w),...b.slice(w+1)]}function I(b){let[,...w]=b;process.env.VSCODE_DEV&&(w=D(w)||[]);const l=!y(process.env);return O(w,l)}e.parseMainProcessArgv=I;function f(b){let[,,...w]=b;return process.env.VSCODE_DEV&&(w=D(w)||[]),O(w,!0)}e.parseCLIProcessArgv=f;function u(b,...w){const l=b.indexOf("--");return l===-1?b.push(...w):b.splice(l,0,...w),b}e.addArg=u;function y(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function V(e,C,L){function r(D,I){const f=O(D,I),u=[f];return e.isAbsolute(f)||u.unshift(L),e.resolve(...u)}function O(D,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,I);const y=D["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(b,"AppData","Roaming")}break;case"darwin":u=e.join(C.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,I)}return{getUserDataPath:r}}if(typeof define=="function")define(se[201],oe([113,26,35]),function(e,C,L){return V(e,C,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),C=require("os");module.exports=V(e,C,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[90],oe([0,1,26,199,201]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends L.AbstractNativeEnvironmentService{constructor(u,y){super(u,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,r.getUserDataPath)(u,y.nameShort)},y)}}e.NativeEnvironmentService=O;function D(f,u){return(0,L.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.parsePtyHostDebugPort=D;function I(f,u){return(0,L.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.parseSharedProcessDebugPort=I}),define(se[202],oe([0,1,46,26,33]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function O(D){const I=(0,r.randomPath)((0,L.tmpdir)());try{return(0,C.writeFileSync)(I,""),D&&console.log(`Marker file for --wait created: ${I}`),I}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFileSync=O}),define(se[203],oe([0,1,12,171]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function r(D,I,f,u){try{O(D,I,f,u)}catch(y){D.error(y?.message??y)}return I}e.localizeManifest=r;function O(D,I,f,u){const y=(b,w,l)=>{const S=b[w];if((0,C.isString)(S)){const p=S,m=p.length;if(m>1&&p[0]==="%"&&p[m-1]==="%"){const g=p.substr(1,m-2);let d=f[g];d===void 0&&u&&(d=u[g]);const a=typeof d=="string"?d:d?.message,P=u?.[g],h=typeof P=="string"?P:P?.message;if(!a){h||D.warn(`[${I.name}]: ${(0,L.localize)(0,null,g)}`);return}if(l&&(w==="title"||w==="category")&&h&&h!==a){const i={value:a,original:h};b[w]=i}else b[w]=a}}else if((0,C.isObject)(S))for(const p in S)S.hasOwnProperty(p)&&(p==="commands"?y(S,p,!0):y(S,p,l));else if(Array.isArray(S))for(let p=0;p<S.length;p++)y(S,p,l)};for(const b in I)I.hasOwnProperty(b)&&y(I,b)}}),define(se[204],oe([0,1,19,74,173,205]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||D.test(g)}e.isValidVersionStr=f;function u(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=g.match(D);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=u;function y(g){if(!g)return null;const d=g.majorBase,a=g.majorMustEqual,P=g.minorBase;let h=g.minorMustEqual;const i=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(d===0||(h=!1),o=!1);let s=0;if(g.preRelease){const t=I.exec(g.preRelease);if(t){const[,n,c,v]=t;s=Date.UTC(Number(n),Number(c)-1,Number(v))}}return{majorBase:d,majorMustEqual:a,minorBase:P,minorMustEqual:h,patchBase:i,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:s}}e.normalizeVersion=y;function b(g,d,a){let P;typeof g=="string"?P=y(u(g)):P=g;let h;d instanceof Date?h=d.getTime():typeof d=="string"&&(h=new Date(d).getTime());let i;if(typeof a=="string"?i=y(u(a)):i=a,!P||!i)return!1;const o=P.majorBase,s=P.minorBase,t=P.patchBase;let n=i.majorBase,c=i.minorBase,v=i.patchBase;const R=i.notBefore;let k=i.majorMustEqual,E=i.minorMustEqual,M=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:s>c?!0:s<c||h&&h<R?!1:t>=v:(o===1&&n===0&&(!k||!E||!M)&&(n=1,c=0,v=0,k=!0,E=!1,M=!1),o<n?!1:o>n?!k:s<c?!1:s>c?!E:t<v?!1:t>v?!M:!(h&&h<R))}e.isValidVersion=b;function w(g,d,a,P,h){const i=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return i.push([L.default.Error,r.localize(0,null)]),i;if(typeof P.name!="string")return i.push([L.default.Error,r.localize(1,null,"name")]),i;if(typeof P.version!="string")return i.push([L.default.Error,r.localize(2,null,"version")]),i;if(!P.engines)return i.push([L.default.Error,r.localize(3,null,"engines")]),i;if(typeof P.engines.vscode!="string")return i.push([L.default.Error,r.localize(4,null,"engines.vscode")]),i;if(typeof P.extensionDependencies<"u"&&!m(P.extensionDependencies))return i.push([L.default.Error,r.localize(5,null,"extensionDependencies")]),i;if(typeof P.activationEvents<"u"){if(!m(P.activationEvents))return i.push([L.default.Error,r.localize(6,null,"activationEvents")]),i;if(typeof P.main>"u"&&typeof P.browser>"u")return i.push([L.default.Error,r.localize(7,null,"activationEvents","main","browser")]),i}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&i.push([L.default.Warning,r.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return i.push([L.default.Error,r.localize(9,null,"main")]),i;{const t=(0,C.joinPath)(a,P.main);(0,C.isEqualOrParent)(t,a)||i.push([L.default.Warning,r.localize(10,null,t.path,a.path)])}}if(typeof P.browser<"u"){if(typeof P.browser!="string")return i.push([L.default.Error,r.localize(11,null,"browser")]),i;{const t=(0,C.joinPath)(a,P.browser);(0,C.isEqualOrParent)(t,a)||i.push([L.default.Warning,r.localize(12,null,t.path,a.path)])}}if(!O.valid(P.version))return i.push([L.default.Error,r.localize(13,null)]),i;const o=[];if(!l(g,d,P,h,o))for(const t of o)i.push([L.default.Error,t]);return i}e.validateExtensionManifest=w;function l(g,d,a,P,h){return P||typeof a.main>"u"&&typeof a.browser>"u"?!0:p(g,d,a.engines.vscode,h)}e.isValidExtensionVersion=l;function S(g,d,a){return g==="*"||p(d,a,g)}e.isEngineValid=S;function p(g,d,a,P=[]){const h=y(u(a));if(!h)return P.push(r.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return P.push(r.localize(15,null,a)),!1}else if(!h.majorMustEqual)return P.push(r.localize(16,null,a)),!1;return b(g,d,h)?!0:(P.push(r.localize(17,null,g,a)),!1)}function m(g){if(!Array.isArray(g))return!1;for(let d=0,a=g.length;d<a;d++)if(typeof g[d]!="string")return!1;return!0}}),define(se[206],oe([0,1,18,32]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function r(O,D,I){let f=I&&I.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const y=(await D.readFile(O.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(y)?y:null}catch{f=null}if(!f){f=(0,L.generateUuid)();try{await D.writeFile(O.serviceMachineIdResource,C.VSBuffer.fromString(f))}catch{}}return I?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=r}),define(se[78],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(r,O=[],D=!1){this.ctor=r,this.staticArguments=O,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=C}),define(se[207],oe([0,1,78]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var r;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function O(I,f,u){f instanceof C.SyncDescriptor||(f=new C.SyncDescriptor(f,[],!!u)),L.push([I,f])}e.registerSingleton=O;function D(){return L}e.getSingletonServiceDescriptors=D}),define(se[208],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(O,D){this.key=O,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=C;class L{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const D of this._nodes.values())D.outgoing.size===0&&O.push(D);return O}insertEdge(O,D){const I=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(D);I.outgoing.set(f.key,f),f.incoming.set(I.key,I)}removeNode(O){const D=this._hashFn(O);this._nodes.delete(D);for(const I of this._nodes.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(O){const D=this._hashFn(O);let I=this._nodes.get(D);return I||(I=new C(D,O),this._nodes.set(D,I)),I}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[D,I]of this._nodes)O.push(`${D}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,D]of this._nodes){const I=new Set([O]),f=this._findCycle(D,I);if(f)return f}}_findCycle(O,D){for(const[I,f]of O.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const u=this._findCycle(f,D);if(u)return u;D.delete(I)}}}e.Graph=L}),define(se[6],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var C;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function I(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=I})(C||(e._util=C={})),e.IInstantiationService=r("instantiationService");function L(D,I,f){I[C.DI_TARGET]===I?I[C.DI_DEPENDENCIES].push({id:D,index:f}):(I[C.DI_DEPENDENCIES]=[{id:D,index:f}],I[C.DI_TARGET]=I)}function r(D){if(C.serviceIds.has(D))return C.serviceIds.get(D);const I=function(f,u,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(I,f,y)};return I.toString=()=>D,C.serviceIds.set(D,I),I}e.createDecorator=r;function O(D){return D}e.refineServiceDecorator=O}),define(se[65],oe([0,1,13,6]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAuxiliaryWindow=e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,L.createDecorator)("auxiliaryWindowsMainService");function r(O){return O?.opener?.url.startsWith(`${C.Schemas.vscodeFileResource}://${C.VSCODE_AUTHORITY}/`)}e.isAuxiliaryWindow=r}),define(se[66],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,C.createDecorator)("backupMainService")}),define(se[17],oe([0,1,12,7,6]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function O(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationOverrides=O;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=D;var I;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function f(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function u(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.isConfigured=u;function y(g,d){const a=Object.create(null);for(const P in g)b(a,P,g[P],d);return a}e.toValuesTree=y;function b(g,d,a,P){const h=d.split("."),i=h.pop();let o=g;for(let s=0;s<h.length;s++){const t=h[s];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:P(`Ignoring ${d} as ${h.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=a}catch{P(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(o)}`)}else P(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function w(g,d){const a=d.split(".");l(g,a)}e.removeFromValueTree=w;function l(g,d){const a=d.shift();if(d.length===0){delete g[a];return}if(Object.keys(g).indexOf(a)!==-1){const P=g[a];typeof P=="object"&&!Array.isArray(P)&&(l(P,d),Object.keys(P).length===0&&delete g[a])}}function S(g,d,a){function P(o,s){let t=o;for(const n of s){if(typeof t!="object"||t===null)return;t=t[n]}return t}const h=d.split("."),i=P(g,h);return typeof i>"u"?a:i}e.getConfigurationValue=S;function p(g,d,a){Object.keys(d).forEach(P=>{P!=="__proto__"&&(P in g?C.isObject(g[P])&&C.isObject(d[P])?p(g[P],d[P],a):a&&(g[P]=d[P]):g[P]=d[P])})}e.merge=p;function m(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(se[114],oe([0,1,4,25,197,6,164,14]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",C.isMacintosh),f.set("isLinux",C.isLinux),f.set("isWindows",C.isWindows),f.set("isWeb",C.isWeb),f.set("isMacNative",C.isMacintosh&&!C.isWeb),f.set("isEdge",C.isEdge),f.set("isFirefox",C.isFirefox),f.set("isChrome",C.isChrome),f.set("isSafari",C.isSafari);function u(j,A){if(f.get(j)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(j,A)}e.setConstant=u;const y=Object.prototype.hasOwnProperty;var b;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const w={regexParsingWithErrorRecovery:!0},l=(0,D.localize)(0,null),S=(0,D.localize)(1,null),p=(0,D.localize)(2,null),m=(0,D.localize)(3,null),g=(0,D.localize)(4,null),d=(0,D.localize)(5,null),a=(0,D.localize)(6,null),P=(0,D.localize)(7,null);class h{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(A=w){this._config=A,this._scanner=new r.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(A){if(A===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:S});return}this._tokens=this._scanner.reset(A).scan(),this._current=0,this._parsingErrors=[];try{const F=this._expr();if(!this._isAtEnd()){const J=this._peek(),z=J.type===17?d:void 0;throw this._parsingErrors.push({message:g,offset:J.offset,lexeme:r.Scanner.getLexeme(J),additionalInfo:z}),h._parseError}return F}catch(F){if(F!==h._parseError)throw F;return}}_expr(){return this._or()}_or(){const A=[this._and()];for(;this._matchOne(16);){const F=this._and();A.push(F)}return A.length===1?A[0]:i.or(...A)}_and(){const A=[this._term()];for(;this._matchOne(15);){const F=this._term();A.push(F)}return A.length===1?A[0]:i.and(...A)}_term(){if(this._matchOne(2)){const A=this._peek();switch(A.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),c.INSTANCE;case 0:{this._advance();const F=this._expr();return this._consume(1,m),F?.negate()}case 17:return this._advance(),_.create(A.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",A)}}return this._primary()}_primary(){const A=this._peek();switch(A.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const F=this._expr();return this._consume(1,m),F}case 17:{const F=A.lexeme;if(this._advance(),this._matchOne(9)){const z=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),z.type!==10)throw this._errExpectedButGot("REGEX",z);const K=z.lexeme,N=K.lastIndexOf("/"),$=N===K.length-1?void 0:this._removeFlagsGY(K.substring(N+1));let ee;try{ee=new RegExp(K.substring(1,N),$)}catch{throw this._errExpectedButGot("REGEX",z)}return ce.create(F,ee)}switch(z.type){case 10:case 19:{const K=[z.lexeme];this._advance();let N=this._peek(),$=0;for(let pe=0;pe<z.lexeme.length;pe++)z.lexeme.charCodeAt(pe)===40?$++:z.lexeme.charCodeAt(pe)===41&&$--;for(;!this._isAtEnd()&&N.type!==15&&N.type!==16;){switch(N.type){case 0:$++;break;case 1:$--;break;case 10:case 18:for(let pe=0;pe<N.lexeme.length;pe++)N.lexeme.charCodeAt(pe)===40?$++:z.lexeme.charCodeAt(pe)===41&&$--}if($<0)break;K.push(r.Scanner.getLexeme(N)),this._advance(),N=this._peek()}const ee=K.join(""),ae=ee.lastIndexOf("/"),re=ae===ee.length-1?void 0:this._removeFlagsGY(ee.substring(ae+1));let me;try{me=new RegExp(ee.substring(1,ae),re)}catch{throw this._errExpectedButGot("REGEX",z)}return i.regex(F,me)}case 18:{const K=z.lexeme;this._advance();let N=null;if(!(0,L.isFalsyOrWhitespace)(K)){const $=K.indexOf("/"),ee=K.lastIndexOf("/");if($!==ee&&$>=0){const ae=K.slice($+1,ee),re=K[ee+1]==="i"?"i":"";try{N=new RegExp(ae,re)}catch{throw this._errExpectedButGot("REGEX",z)}}}if(N===null)throw this._errExpectedButGot("REGEX",z);return ce.create(F,N)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,p);const z=this._value();return i.notIn(F,z)}switch(this._peek().type){case 3:{this._advance();const z=this._value();if(this._previous().type===18)return i.equals(F,z);switch(z){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,z)}}case 4:{this._advance();const z=this._value();if(this._previous().type===18)return i.notEquals(F,z);switch(z){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,z)}}case 5:return this._advance(),Y.create(F,this._value());case 6:return this._advance(),le.create(F,this._value());case 7:return this._advance(),U.create(F,this._value());case 8:return this._advance(),X.create(F,this._value());case 13:return this._advance(),i.in(F,this._value());default:return i.has(F)}}case 20:throw this._parsingErrors.push({message:a,offset:A.offset,lexeme:"",additionalInfo:P}),h._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const A=this._peek();switch(A.type){case 17:case 18:return this._advance(),A.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(A){return A.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(A){return this._check(A)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(A,F){if(this._check(A))return this._advance();throw this._errExpectedButGot(F,this._peek())}_errExpectedButGot(A,F,J){const z=(0,D.localize)(8,null,A,r.Scanner.getLexeme(F)),K=F.offset,N=r.Scanner.getLexeme(F);return this._parsingErrors.push({message:z,offset:K,lexeme:N,additionalInfo:J}),h._parseError}_check(A){return this._peek().type===A}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=h;class i{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(A){return v.create(A)}static equals(A,F){return R.create(A,F)}static notEquals(A,F){return M.create(A,F)}static regex(A,F){return ce.create(A,F)}static in(A,F){return k.create(A,F)}static notIn(A,F){return E.create(A,F)}static not(A){return _.create(A)}static and(...A){return G.create(A,null,!0)}static or(...A){return x.create(A,null,!0)}static greater(A,F){return U.create(A,F)}static greaterEquals(A,F){return X.create(A,F)}static smaller(A,F){return Y.create(A,F)}static smallerEquals(A,F){return le.create(A,F)}static{this._parser=new h({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this._parser.parse(A)}}e.ContextKeyExpr=i;function o(j){const A=new h({regexParsingWithErrorRecovery:!1});return j.map(F=>(A.parse(F),A.lexingErrors.length>0?A.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,D.localize)(9,null,J.additionalInfo):(0,D.localize)(10,null),offset:J.offset,length:J.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}e.validateWhenClauses=o;function s(j,A){const F=j?j.substituteConstants():void 0,J=A?A.substituteConstants():void 0;return!F&&!J?!0:!F||!J?!1:F.equals(J)}e.expressionsAreEqualWithConstantSubstitution=s;function t(j,A){return j.cmp(A)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=n;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=c;class v{static create(A,F=null){const J=f.get(A);return typeof J=="boolean"?J?c.INSTANCE:n.INSTANCE:new v(A,F)}constructor(A,F){this.key=A,this.negated=F,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:B(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=f.get(this.key);return typeof A=="boolean"?A?c.INSTANCE:n.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class R{static create(A,F,J=null){if(typeof F=="boolean")return F?v.create(A,J):_.create(A,J);const z=f.get(A);return typeof z=="boolean"?F===(z?"true":"false")?c.INSTANCE:n.INSTANCE:new R(A,F,J)}constructor(A,F,J){this.key=A,this.value=F,this.negated=J,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=f.get(this.key);if(typeof A=="boolean"){const F=A?"true":"false";return this.value===F?c.INSTANCE:n.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=R;class k{static create(A,F){return new k(A,F)}constructor(A,F){this.key=A,this.valueKey=F,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.valueKey),J=A.getValue(this.key);return Array.isArray(F)?F.includes(J):typeof J=="string"&&typeof F=="object"&&F!==null?y.call(F,J):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=E.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=k;class E{static create(A,F){return new E(A,F)}constructor(A,F){this.key=A,this.valueKey=F,this.type=11,this._negated=k.create(A,F)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=E;class M{static create(A,F,J=null){if(typeof F=="boolean")return F?_.create(A,J):v.create(A,J);const z=f.get(A);return typeof z=="boolean"?F===(z?"true":"false")?n.INSTANCE:c.INSTANCE:new M(A,F,J)}constructor(A,F,J){this.key=A,this.value=F,this.negated=J,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=f.get(this.key);if(typeof A=="boolean"){const F=A?"true":"false";return this.value===F?n.INSTANCE:c.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=M;class _{static create(A,F=null){const J=f.get(A);return typeof J=="boolean"?J?n.INSTANCE:c.INSTANCE:new _(A,F)}constructor(A,F){this.key=A,this.negated=F,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:B(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=f.get(this.key);return typeof A=="boolean"?A?n.INSTANCE:c.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function T(j,A){if(typeof j=="string"){const F=parseFloat(j);isNaN(F)||(j=F)}return typeof j=="string"||typeof j=="number"?A(j):n.INSTANCE}class U{static create(A,F,J=null){return T(F,z=>new U(A,z,J))}constructor(A,F,J){this.key=A,this.value=F,this.negated=J,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=le.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=U;class X{static create(A,F,J=null){return T(F,z=>new X(A,z,J))}constructor(A,F,J){this.key=A,this.value=F,this.negated=J,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=X;class Y{static create(A,F,J=null){return T(F,z=>new Y(A,z,J))}constructor(A,F,J){this.key=A,this.value=F,this.negated=J,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=X.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=Y;class le{static create(A,F,J=null){return T(F,z=>new le(A,z,J))}constructor(A,F,J){this.key=A,this.value=F,this.negated=J,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:H(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=le;class ce{static create(A,F){return new ce(A,F)}constructor(A,F){this.key=A,this.regexp=F,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const F=this.regexp?this.regexp.source:"",J=A.regexp?A.regexp.source:"";return F<J?-1:F>J?1:0}equals(A){if(A.type===this.type){const F=this.regexp?this.regexp.source:"",J=A.regexp?A.regexp.source:"";return this.key===A.key&&F===J}return!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ue.create(this)),this.negated}}e.ContextKeyRegexExpr=ce;class ue{static create(A){return new ue(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(A){return new ue(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ue;function Q(j){let A=null;for(let F=0,J=j.length;F<J;F++){const z=j[F].substituteConstants();if(j[F]!==z&&A===null){A=[];for(let K=0;K<F;K++)A[K]=j[K]}A!==null&&(A[F]=z)}return A===null?j:A}class G{static create(A,F,J){return G._normalizeArr(A,F,J)}constructor(A,F){this.expr=A,this.negated=F,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,J=this.expr.length;F<J;F++){const z=t(this.expr[F],A.expr[F]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,J=this.expr.length;F<J;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=Q(this.expr);return A===this.expr?this:G.create(A,this.negated,!1)}evaluate(A){for(let F=0,J=this.expr.length;F<J;F++)if(!this.expr[F].evaluate(A))return!1;return!0}static _normalizeArr(A,F,J){const z=[];let K=!1;for(const N of A)if(N){if(N.type===1){K=!0;continue}if(N.type===0)return n.INSTANCE;if(N.type===6){z.push(...N.expr);continue}z.push(N)}if(z.length===0&&K)return c.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(t);for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];for(;z.length>1;){const N=z[z.length-1];if(N.type!==9)break;z.pop();const $=z.pop(),ee=z.length===0,ae=x.create(N.expr.map(re=>G.create([re,$],null,J)),null,ee);ae&&(z.push(ae),z.sort(t))}if(z.length===1)return z[0];if(J){for(let N=0;N<z.length;N++)for(let $=N+1;$<z.length;$++)if(z[N].negate().equals(z[$]))return n.INSTANCE;if(z.length===1)return z[0]}return new G(z,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new G(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.negated){const A=[];for(const F of this.expr)A.push(F.negate());this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyAndExpr=G;class x{static create(A,F,J){return x._normalizeArr(A,F,J)}constructor(A,F){this.expr=A,this.negated=F,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,J=this.expr.length;F<J;F++){const z=t(this.expr[F],A.expr[F]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,J=this.expr.length;F<J;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=Q(this.expr);return A===this.expr?this:x.create(A,this.negated,!1)}evaluate(A){for(let F=0,J=this.expr.length;F<J;F++)if(this.expr[F].evaluate(A))return!0;return!1}static _normalizeArr(A,F,J){let z=[],K=!1;if(A){for(let N=0,$=A.length;N<$;N++){const ee=A[N];if(ee){if(ee.type===0){K=!0;continue}if(ee.type===1)return c.INSTANCE;if(ee.type===9){z=z.concat(ee.expr);continue}z.push(ee)}}if(z.length===0&&K)return n.INSTANCE;z.sort(t)}if(z.length!==0){if(z.length===1)return z[0];for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];if(J){for(let N=0;N<z.length;N++)for(let $=N+1;$<z.length;$++)if(z[N].negate().equals(z[$]))return c.INSTANCE;if(z.length===1)return z[0]}return new x(z,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new x(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.negated){const A=[];for(const F of this.expr)A.push(F.negate());for(;A.length>1;){const F=A.shift(),J=A.shift(),z=[];for(const K of de(F))for(const N of de(J))z.push(G.create([K,N],null,!1));A.unshift(x.create(z,null,!1))}this.negated=x.create(A,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class W extends v{static{this._info=[]}static all(){return W._info.values()}constructor(A,F,J){super(A,null),this._defaultValue=F,typeof J=="object"?W._info.push({...J,key:A}):J!==!0&&W._info.push({key:A,description:J,type:F!=null?typeof F:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return R.create(this.key,A)}notEqualsTo(A){return M.create(this.key,A)}}e.RawContextKey=W,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function B(j,A){return j<A?-1:j>A?1:0}function H(j,A,F,J){return j<F?-1:j>F?1:A<J?-1:A>J?1:0}function q(j,A){if(j.type===0||A.type===1)return!0;if(j.type===9)return A.type===9?Z(j.expr,A.expr):!1;if(A.type===9){for(const F of A.expr)if(q(j,F))return!0;return!1}if(j.type===6){if(A.type===6)return Z(A.expr,j.expr);for(const F of j.expr)if(q(F,A))return!0;return!1}return j.equals(A)}e.implies=q;function Z(j,A){let F=0,J=0;for(;F<j.length&&J<A.length;){const z=j[F].cmp(A[J]);if(z<0)return!1;z===0&&F++,J++}return F===j.length}function de(j){return j.type===9?j.expr:[j]}}),define(se[91],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,C.createDecorator)(e.ID);function L(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=L;class r{async getPerformanceInfo(D,I){return{}}async getSystemInfo(D,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,I){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=r}),define(se[115],oe([0,1,19,74,166,6,47,4,38]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,O.createDecorator)("dialogService");var u;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(u||(u={}));class y{getConfirmationButtons(m){return this.getButtons(m,u.Confirmation)}getPromptButtons(m){return this.getButtons(m,u.Prompt)}getInputButtons(m){return this.getButtons(m,u.Input)}getButtons(m,g){const d=[];switch(g){case u.Confirmation:{const a=m;a.primaryButton?d.push(a.primaryButton):d.push((0,r.localize)(0,null)),a.cancelButton?d.push(a.cancelButton):d.push((0,r.localize)(1,null));break}case u.Prompt:{const a=m;Array.isArray(a.buttons)&&a.buttons.length>0&&d.push(...a.buttons.map(P=>P.label)),a.cancelButton&&(a.cancelButton===!0?d.push((0,r.localize)(2,null)):typeof a.cancelButton=="string"?d.push(a.cancelButton):a.cancelButton.label?d.push(a.cancelButton.label):d.push((0,r.localize)(3,null))),d.length===0&&d.push((0,r.localize)(4,null));break}case u.Input:{const a=m;a.primaryButton?d.push(a.primaryButton):d.push((0,r.localize)(5,null)),a.cancelButton?d.push(a.cancelButton):d.push((0,r.localize)(6,null));break}}return d}getDialogType(m){if(typeof m=="string")return m;if(typeof m=="number")return m===L.default.Info?"info":m===L.default.Error?"error":m===L.default.Warning?"warning":"none"}getPromptResult(m,g,d){const a=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&a.push(m.cancelButton);let P=a[g]?.run({checkboxChecked:d});return P instanceof Promise||(P=Promise.resolve(P)),{result:P,checkboxChecked:d}}}e.AbstractDialogHandler=y,e.IFileDialogService=(0,O.createDecorator)("fileDialogService");var b;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const w=10;function l(p){const m=[];return m.push(...p.slice(0,w).map(g=>typeof g=="string"?g:(0,C.basename)(g))),p.length>w&&(p.length-w===1?m.push((0,r.localize)(7,null)):m.push((0,r.localize)(8,null,p.length-w))),m.push(""),m.join(`
`)}e.getFileNamesMessage=l;function S(p,m){const g=(0,f.deepClone)(p);let d=(g.buttons??[]).map(i=>(0,D.mnemonicButtonLabel)(i)),a=(p.buttons||[]).map((i,o)=>o),P=0,h=g.cancelId??d.length-1;if(d.length>1){const i=typeof h=="number"?d[h]:void 0;if(I.isLinux||I.isMacintosh){if(typeof i=="string"&&d.length>1&&h!==1){d.splice(h,1),d.splice(1,0,i);const o=a[h];a.splice(h,1),a.splice(1,0,o),h=1}I.isLinux&&d.length>1&&(d=d.reverse(),a=a.reverse(),P=d.length-1,typeof i=="string"&&(h=P-1))}else if(I.isWindows&&typeof i=="string"&&d.length>1&&h!==d.length-1){d.splice(h,1),d.push(i);const o=a[h];a.splice(h,1),a.push(o),h=d.length-1}}return g.buttons=d,g.defaultId=P,g.cancelId=h,g.noLink=!0,g.title=g.title||m.nameLong,{options:g,buttonIndeces:a}}e.massageMessageBoxOptions=S}),define(se[116],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isGnome=e.isKwallet=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.IEncryptionService=(0,C.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,C.createDecorator)("encryptionMainService");var L;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnome="gnome",I.gnomeKeyring="gnome-keyring",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(L||(e.PasswordStoreCLIOption=L={}));var r;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function O(I){return I==="kwallet"||I==="kwallet5"||I==="kwallet6"}e.isKwallet=O;function D(I){return I==="gnome_any"||I==="gnome_libsecret"||I==="gnome_keyring"}e.isGnome=D}),define(se[37],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(se[117],oe([0,1,170,6]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function r(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function O(g){switch(g){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function D(g,d){switch(g){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":d==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function I(g,d){return d==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function f(g,d,a){return I(d,a)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===a}e.isTargetPlatformCompatible=f;function u(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=u;var y;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var b;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var w;(function(g){g.Install="install",g.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var l;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var S;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Signature="Signature",g.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var p;(function(g){g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class m extends Error{constructor(d,a){super(d),this.code=a,this.name=a}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,C.localize)(1,null),original:"Preferences"}}),define(se[209],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,C.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(se[210],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,C.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(se[211],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,C.createDecorator)("externalTerminal")}),define(se[212],oe([0,1,48,13,9,4,76,21,89,174,210]),function(V,e,C,L,r,O,D,I,f,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=u.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:l.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class l extends w{static{this.CMD="cmd.exe"}openTerminal(P,h){return this.spawnTerminal(C,P,f.getWindowsShell(),h)}spawnTerminal(P,h,i,o){const s=h.windowsExec||l.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=r.basename(s,".exe").toLowerCase();if(t==="cmder")return P.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),t==="wt"&&n.push("-d ."),new Promise((c,v)=>{const R=m(process),k=P.spawn(i,n,{cwd:o,env:R});k.on("error",v),k.on("exit",()=>c())})}runInTerminal(P,h,i,o,s){const t="windowsExec"in s&&s.windowsExec?s.windowsExec:l.getDefaultTerminalWindows();return new Promise((n,c)=>{const v=`"${h} - ${b}"`,R=`""${i.join('" "')}" & pause"`,k=Object.assign({},m(process),o);Object.keys(k).filter(U=>k[U]===null).forEach(U=>delete k[U]);const E={cwd:h,env:k,windowsVerbatimArguments:!0};let M,_;r.basename(t,".exe")==="wt"?(M=t,_=["-d",".",l.CMD,"/c",R]):(M=l.CMD,_=["/c","start",v,"/wait",t,"/c",R]),C.spawn(M,_,E).on("error",U=>{c(g(U))}),n(void 0)})}static getDefaultTerminalWindows(){if(!l._DEFAULT_TERMINAL_WINDOWS){const P=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");l._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${P?"Sysnative":"System32"}\\cmd.exe`}return l._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=l;class S extends w{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(P,h){return this.spawnTerminal(C,P,h)}runInTerminal(P,h,i,o,s){const t=s.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((n,c)=>{if(t===y.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const v=t===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",P||b,"-w",h];for(const _ of i)k.push("-a"),k.push(_);if(o){const _=Object.assign({},m(process),o);for(const T in _){const U=_[T];U===null?(k.push("-u"),k.push(T)):(k.push("-e"),k.push(`${T}=${U}`))}}let E="";const M=C.spawn(S.OSASCRIPT,k);M.on("error",_=>{c(g(_))}),M.stderr.on("data",_=>{E+=_.toString()}),M.on("exit",_=>{if(_===0)n(void 0);else if(E){const T=E.split(`
`,1);c(new Error(T[0]))}else c(new Error(u.localize(1,null,v,_)))})}else c(new Error(u.localize(2,null,t)))})}spawnTerminal(P,h,i){const o=h.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((s,t)=>{const n=["-a",o];i&&n.push(i);const c=m(process),v=P.spawn("/usr/bin/open",n,{cwd:i,env:c});v.on("error",t),v.on("exit",()=>s())})}}e.MacExternalTerminalService=S;class p extends w{static{this.WAIT_MESSAGE=u.localize(3,null)}openTerminal(P,h){return this.spawnTerminal(C,P,h)}runInTerminal(P,h,i,o,s){const t=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{const v=[];t.then(R=>{R.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const k=`${d(i)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;v.push(`''${k}''`);const E=Object.assign({},m(process),o);Object.keys(E).filter(U=>E[U]===null).forEach(U=>delete E[U]);const M={cwd:h,env:E};let _="";const T=C.spawn(R,v,M);T.on("error",U=>{c(g(U))}),T.stderr.on("data",U=>{_+=U.toString()}),T.on("exit",U=>{if(U===0)n(void 0);else if(_){const X=_.split(`
`,1);c(new Error(X[0]))}else c(new Error(u.localize(4,null,R,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!O.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const P=await I.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(h=>{P?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(P,h,i){const o=h.linuxExec?Promise.resolve(h.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,t)=>{o.then(n=>{const c=m(process),v=P.spawn(n,[],{cwd:i,env:c});v.on("error",t),v.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=p;function m(a){const P={...a.env};return(0,D.sanitizeProcessEnvironment)(P),P}function g(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(u.localize(5,null,a.path)):a}function d(a){let P="";for(const h of a)h.indexOf(" ")>=0?P+='"'+h+'"':P+=h,P+=" ";return P}}),define(se[16],oe([0,1,57,9,25,12,7,176,6,4,13,62]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(q){return q.create===!0}e.isFileOpenForWriteOptions=w;var l;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var S;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function p(q){const Z=q;return!!Z&&typeof Z.onDidChange=="function"}e.isFileSystemWatcher=p;var m;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function g(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=g;function d(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=d;function a(q){return!!(q.capabilities&131072)}e.hasFileCloneCapability=a;function P(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=P;function h(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=h;function i(q){return g(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=i;function o(q){return g(q)?!!(q.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function s(q){return!!(q.capabilities&65536)}e.hasFileAtomicDeleteCapability=s;function t(q){return!!(q.capabilities&2048)}e.hasReadonlyCapability=t;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(Z,de){const j=new c(Z.toString(),de);return k(j,de),j}constructor(Z,de){super(Z),this.code=de}}e.FileSystemProviderError=c;function v(q,Z){return c.create(q,Z)}e.createFileSystemProviderError=v;function R(q){return q||v((0,I.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=R;function k(q,Z){return q.name=Z?`${Z} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=k;function E(q){if(!q)return n.Unknown;if(q instanceof c)return q.code;const Z=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Z)return n.Unknown;switch(Z[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=E;function M(q){if(q instanceof le)return q.fileOperationResult;switch(E(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=M;var _;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(_||(e.FileOperation=_={}));class T{constructor(Z,de,j){this.resource=Z,this.operation=de,this.target=j}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=T;var U;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class X{static{this.MIXED_CORRELATION=null}constructor(Z,de){this.ignorePathCasing=de,this.correlationId=void 0,this.added=new b.Lazy(()=>{const j=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawAdded.map(A=>[A,!0])),j}),this.updated=new b.Lazy(()=>{const j=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawUpdated.map(A=>[A,!0])),j}),this.deleted=new b.Lazy(()=>{const j=C.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawDeleted.map(A=>[A,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of Z){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.correlationId!==X.MIXED_CORRELATION&&(typeof j.cId=="number"?this.correlationId===void 0?this.correlationId=j.cId:this.correlationId!==j.cId&&(this.correlationId=X.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=X.MIXED_CORRELATION))}}contains(Z,...de){return this.doContains(Z,{includeChildren:!1},...de)}affects(Z,...de){return this.doContains(Z,{includeChildren:!0},...de)}doContains(Z,de,...j){if(!Z)return!1;const A=j.length>0;return!!((!A||j.includes(1))&&(this.added.value.get(Z)||de.includeChildren&&this.added.value.findSuperstr(Z))||(!A||j.includes(0))&&(this.updated.value.get(Z)||de.includeChildren&&this.updated.value.findSuperstr(Z))||(!A||j.includes(2))&&(this.deleted.value.findSubstr(Z)||de.includeChildren&&this.deleted.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.correlationId===Z}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=X;function Y(q,Z,de){return!q||!Z||q===Z||Z.length>q.length?!1:(Z.charAt(Z.length-1)!==L.sep&&(Z+=L.sep),de?(0,r.startsWithIgnoreCase)(q,Z):q.indexOf(Z)===0)}e.isParent=Y;class le extends Error{constructor(Z,de,j){super(Z),this.fileOperationResult=de,this.options=j}}e.FileOperationError=le;class ce extends le{constructor(Z,de,j,A){super(Z,de,A),this.fileOperationResult=de,this.size=j}}e.TooLargeFileOperationError=ce;class ue extends le{constructor(Z,de,j){super(Z,2,j),this.stat=de}}e.NotModifiedSinceFileOperationError=ue;var Q;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var G;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(G||(e.FileKind=G={})),e.ETAG_DISABLED="";function x(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=x;async function W(q,Z){if(!Z.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise(de=>{const j=Z.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===q.scheme&&A.added&&(j.dispose(),de())})})}e.whenProviderRegistered=W;class B{static{this.KB=1024}static{this.MB=B.KB*B.KB}static{this.GB=B.MB*B.KB}static{this.TB=B.GB*B.KB}static formatSize(Z){return(0,O.isNumber)(Z)||(Z=0),Z<B.KB?(0,I.localize)(1,null,Z.toFixed(0)):Z<B.MB?(0,I.localize)(2,null,(Z/B.KB).toFixed(2)):Z<B.GB?(0,I.localize)(3,null,(Z/B.MB).toFixed(2)):Z<B.TB?(0,I.localize)(4,null,(Z/B.GB).toFixed(2)):(0,I.localize)(5,null,(Z/B.TB).toFixed(2))}}e.ByteSize=B;function H(q){const Z=typeof q=="string"||q?.scheme===y.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===y.Schemas.file?1024*B.MB:Z?10*B.MB:u.isWeb?50*B.MB:1024*B.MB}e.getLargeFileConfirmationLimit=H}),define(se[118],oe([0,1,18,14,177,16]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(y,b,w,l,S,p){let m;try{await I(y,b,w,l,S,p)}catch(g){m=g}finally{m&&S.errorTransformer&&(m=S.errorTransformer(m)),typeof m<"u"&&w.error(m),w.end()}}e.readFileIntoStream=D;async function I(y,b,w,l,S,p){f(p);const m=await y.open(b,{create:!1});try{f(p);let g=0,d=0,a=S&&typeof S.length=="number"?S.length:void 0,P=C.VSBuffer.alloc(Math.min(S.bufferSize,typeof a=="number"?a:S.bufferSize)),h=S&&typeof S.position=="number"?S.position:0,i=0;do d=await y.read(m,h,P.buffer,i,P.byteLength-i),h+=d,i+=d,g+=d,typeof a=="number"&&(a-=d),i===P.byteLength&&(await w.write(l(P)),P=C.VSBuffer.alloc(Math.min(S.bufferSize,typeof a=="number"?a:S.bufferSize)),i=0);while(d>0&&(typeof a!="number"||a>0)&&f(p)&&u(g,S));if(i>0){let o=i;typeof a=="number"&&(o=Math.min(i,a)),w.write(l(P.slice(0,o)))}}catch(g){throw(0,O.ensureFileSystemProviderError)(g)}finally{await y.close(m)}}function f(y){if(y.isCancellationRequested)throw(0,L.canceled)();return!0}function u(y,b){if(typeof b?.limits?.size=="number"&&y>b.limits.size)throw(0,O.createFileSystemProviderError)((0,r.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[67],oe([0,1,104,2,9,4,7,16]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(g){return g.recursive===!0}e.isRecursiveWatchRequest=f;class u extends L.Disposable{static{this.MAX_RESTARTS=5}constructor(d,a,P,h){super(),this.onFileChanges=d,this.onLogMessage=a,this.verboseLogging=P,this.options=h,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new L.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),d.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),d.add(this.watcher.onDidError(a=>this.onError(a)))}onError(d){this.options.restartOnError?this.restartCounter<u.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}trace(d){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=u;class y extends u{constructor(d,a,P){super(d,a,P,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class b extends u{constructor(d,a,P){super(d,a,P,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function w(g){return g.map(d=>({type:d.type,resource:D.URI.revive(d.resource),cId:d.cId}))}e.reviveFileChanges=w;function l(g){const d=new m;for(const a of g)d.processEvent(a);return d.coalesce()}e.coalesceEvents=l;function S(g,d){return typeof d=="string"&&!d.startsWith(C.GLOBSTAR)&&!(0,r.isAbsolute)(d)?{base:g,pattern:d}:d}e.normalizeWatcherPattern=S;function p(g,d){const a=[];for(const P of d)a.push((0,C.parse)(S(g,P)));return a}e.parseWatcherPatterns=p;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return O.isLinux?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const a=this.mapPathToChange.get(this.toKey(d));let P=!1;if(a){const h=a.type,i=d.type;a.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?P=!0:h===1&&i===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(a)):h===2&&i===1?a.type=0:h===1&&i===0||(a.type=i)}else P=!0;P&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],a=[];return Array.from(this.coalesced).filter(P=>P.type!==2?(d.push(P),!1):!0).sort((P,h)=>P.resource.fsPath.length-h.resource.fsPath.length).filter(P=>a.some(h=>(0,I.isParent)(P.resource.fsPath,h,!O.isLinux))?!1:(a.push(P.resource.fsPath),!0)).concat(d)}}}),define(se[213],oe([0,1,18,50,14,3,2,63,32,16,67]),function(V,e,C,L,r,O,D,I,f,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends D.Disposable{constructor(l,S){super(),this.channel=l,this.extraCapabilities=S,this.onDidChangeCapabilities=O.Event.None,this._onDidChange=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,f.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(l){return this.channel.call("stat",[l])}readdir(l){return this.channel.call("readdir",[l])}async readFile(l,S){const{buffer:p}=await this.channel.call("readFile",[l,S]);return p}readFileStream(l,S,p){const m=(0,I.newWriteableStream)(d=>C.VSBuffer.concat(d.map(a=>C.VSBuffer.wrap(a))).buffer),g=new D.DisposableStore;return g.add(this.channel.listen("readFileStream",[l,S])(d=>{if(d instanceof C.VSBuffer)m.write(d.buffer);else{if(d==="end")m.end();else{let a;if(d instanceof Error)a=d;else{const P=d;a=(0,u.createFileSystemProviderError)(P.message??(0,L.toErrorMessage)(P),P.code??u.FileSystemProviderErrorCode.Unknown)}m.error(a),m.end()}g.dispose()}})),g.add(p.onCancellationRequested(()=>{m.error((0,r.canceled)()),m.end(),g.dispose()})),m}writeFile(l,S,p){return this.channel.call("writeFile",[l,C.VSBuffer.wrap(S),p])}open(l,S){return this.channel.call("open",[l,S])}close(l){return this.channel.call("close",[l])}async read(l,S,p,m,g){const[d,a]=await this.channel.call("read",[l,S,g]);return p.set(d.buffer.slice(0,a),m),a}write(l,S,p,m,g){return this.channel.call("write",[l,S,C.VSBuffer.wrap(p),m,g])}mkdir(l){return this.channel.call("mkdir",[l])}delete(l,S){return this.channel.call("delete",[l,S])}rename(l,S,p){return this.channel.call("rename",[l,S,p])}copy(l,S,p){return this.channel.call("copy",[l,S,p])}cloneFile(l,S){return this.channel.call("cloneFile",[l,S])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(l=>{if(Array.isArray(l)){const S=l;this._onDidChange.fire((0,y.reviveFileChanges)(S))}else{const S=l;this._onDidWatchError.fire(S)}}))}watch(l,S){const p=(0,f.generateUuid)();return this.channel.call("watch",[this.sessionId,p,l,S]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=b}),define(se[214],oe([0,1,46,8,22,33,2,85,9,4,19,7,105,21,67]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends D.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(d,a,P,h){super(),this.request=d,this.onDidFilesChange=a,this.onLogMessage=P,this.verboseLogging=h,this.throttledFileChangesEmitter=this._register(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.onDidFilesChange(i))),this.fileChangesAggregator=this._register(new L.RunOnceWorker(i=>this.handleFileChanges(i),p.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new r.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const a=await l.Promises.stat(d);this._register(await this.doWatch(d,a.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let a=d.path;try{a=await l.Promises.realpath(d.path),d.path===a&&(a=await(0,w.realcase)(d.path)??d.path),d.path!==a&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${a})`)}catch{}return a}async doWatch(d,a){if(u.isMacintosh&&(0,O.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const P=new r.CancellationTokenSource(this.cts.token),h=new D.DisposableStore;try{const i=b.URI.file(this.request.path),o=(0,f.basename)(d),s=(0,C.watch)(d);h.add((0,D.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${d}'`);const t=new Set;if(a)try{for(const c of await l.Promises.readdir(d))t.add(c)}catch(c){this.error(c)}const n=new Map;h.add((0,D.toDisposable)(()=>{for(const[,c]of n)c.dispose();n.clear()})),s.on("error",(c,v)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${c}, ${v})`),this.dispose()}),s.on("change",(c,v)=>{if(P.token.isCancellationRequested)return;this.trace(`[raw] ["${c}"] ${v}`);let R="";if(v&&(R=v.toString(),u.isMacintosh&&(R=(0,I.normalizeNFC)(R))),!(!R||c!=="change"&&c!=="rename"))if(a)if(c==="rename"){n.get(R)?.dispose();const k=setTimeout(async()=>{if(n.delete(R),R===o&&!await l.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.existsChildStrictCase((0,f.join)(d,R));if(P.token.isCancellationRequested)return;let M;E?t.has(R)?M=0:(M=1,t.add(R)):(t.delete(R),M=2),this.onFileChange({resource:(0,y.joinPath)(i,R),type:M,cId:this.request.correlationId})},p.FILE_DELETE_HANDLER_DELAY);n.set(R,(0,D.toDisposable)(()=>clearTimeout(k)))}else{let k;t.has(R)?k=0:(k=1,t.add(R)),this.onFileChange({resource:(0,y.joinPath)(i,R),type:k,cId:this.request.correlationId})}else if(c==="rename"||R!==o){const k=setTimeout(async()=>{const E=await l.Promises.exists(d);P.token.isCancellationRequested||(E?(this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0),h.add(await this.doWatch(d,!1))):(this.onFileChange({resource:i,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},p.FILE_DELETE_HANDLER_DELAY);h.clear(),h.add((0,D.toDisposable)(()=>clearTimeout(k)))}else this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0)})}catch(i){await l.Promises.exists(d)&&!P.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,D.toDisposable)(()=>{P.dispose(!0),h.dispose()})}onFileChange(d,a=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!a&&this.excludes.some(P=>P(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${d.resource.fsPath}`):!a&&this.includes&&this.includes.length>0&&!this.includes.some(P=>P(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${d.resource.fsPath}`):this.fileChangesAggregator.work(d))}handleFileChanges(d){const a=(0,S.coalesceEvents)(d);if(a.length>0){if(this.verboseLogging)for(const h of a)this.trace(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.throttledFileChangesEmitter.work(a)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(d){if(u.isLinux)return l.Promises.exists(d);try{const a=(0,f.basename)(d);return(await l.Promises.readdir((0,f.dirname)(d))).some(h=>h===a)}catch(a){return this.trace(a),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p;async function m(g,d,a,P,h=512){const i=await l.Promises.open(g,"r"),o=Buffer.allocUnsafe(h),s=new r.CancellationTokenSource(P);let t,n=!1;const c={path:g,excludes:[],recursive:!1},v=new p(c,R=>{(async()=>{for(const{type:k}of R)if(k===0){if(n)return;n=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:E}=await l.Promises.read(i,o,0,h,null);if(!E||s.token.isCancellationRequested)break;d(o.slice(0,E))}}catch(E){t=new Error(E),s.dispose(!0)}finally{n=!1}}})()});return await v.ready,a(),new Promise((R,k)=>{s.token.onCancellationRequested(async()=>{v.dispose();try{await l.Promises.close(i)}catch(E){t=new Error(E)}t?k(t):R()})})}e.watchFileContents=m}),define(se[215],oe([0,1,3,104,2,4,214]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends r.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(u){const y=this.normalizeRequests(u),b=y.filter(l=>{const S=this.watchers.get(l.path);return S?!(0,L.patternsEquals)(S.request.excludes,l.excludes)||!(0,L.patternsEquals)(S.request.includes,l.includes):!0}),w=Array.from(this.watchers.values()).filter(({request:l})=>!y.find(S=>S.path===l.path&&(0,L.patternsEquals)(S.excludes,l.excludes)&&(0,L.patternsEquals)(S.includes,l.includes))).map(({request:l})=>l.path);b.length&&this.trace(`Request to start watching: ${b.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),w.length&&this.trace(`Request to stop watching: ${w.join(",")}`);for(const l of w)this.stopWatching(l);for(const l of b)this.startWatching(l)}startWatching(u){const y=new D.NodeJSFileWatcherLibrary(u,w=>this._onDidChangeFile.fire(w),w=>this._onDidLogMessage.fire(w),this.verboseLogging),b={request:u,instance:y};this.watchers.set(u.path,b)}async stop(){for(const[u]of this.watchers)this.stopWatching(u);this.watchers.clear()}stopWatching(u){const y=this.watchers.get(u);y&&(this.watchers.delete(u),y.instance.dispose())}normalizeRequests(u){const y=new Map;for(const b of u){const w=O.isLinux?b.path:b.path.toLowerCase();let l=y.get(b.correlationId);l||(l=new Map,y.set(b.correlationId,l)),l.set(w,b)}return Array.from(y.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(u){this.verboseLogging=u;for(const[,y]of this.watchers)y.instance.setVerboseLogging(u)}trace(u){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(u)})}toMessage(u,y){return y?`[File Watcher (node.js)] ${u} (path: ${y.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=I}),define(se[216],oe([0,1,67,215]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class r extends C.AbstractNonRecursiveWatcherClient{constructor(D,I,f){super(D,I,f),this.init()}createWatcher(D){return D.add(new L.NodeJSWatcher)}}e.NodeJSWatcherClient=r}),define(se[217],oe([0,1,13,42,160,67]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends O.AbstractUniversalWatcherClient{constructor(f,u,y){super(f,u,y),this.init()}createWatcher(f){const u=f.add(new r.Client(C.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(u.onDidProcessExit(({code:y,signal:b})=>this.onError(`terminated by itself with code ${y}, signal: ${b}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(se[92],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...r){this._entries=new Map;for(const[O,D]of r)this.set(O,D)}set(r,O){const D=this._entries.get(r);return this._entries.set(r,O),D}has(r){return this._entries.has(r)}get(r){return this._entries.get(r)}}e.ServiceCollection=C}),define(se[218],oe([0,1,8,14,2,78,208,6,92,101]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class b extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class w{constructor(m=new f.ServiceCollection,g=!1,d,a=y){this._services=m,this._strict=g,this._parent=d,this._enableTracing=a,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=a?d?._globalGraph??new D.Graph(P=>P):void 0}createChild(m){return new w(m,this._strict,this,this._enableTracing)}invokeFunction(m,...g){const d=S.traceInvocation(this._enableTracing,m);let a=!1;try{return m({get:h=>{if(a)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(h,d);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...g)}finally{a=!0,d.stop()}}createInstance(m,...g){let d,a;return m instanceof O.SyncDescriptor?(d=S.traceCreation(this._enableTracing,m.ctor),a=this._createInstance(m.ctor,m.staticArguments.concat(g),d)):(d=S.traceCreation(this._enableTracing,m),a=this._createInstance(m,g,d)),d.stop(),a}_createInstance(m,g=[],d){const a=I._util.getServiceDependencies(m).sort((i,o)=>i.index-o.index),P=[];for(const i of a){const o=this._getOrCreateServiceInstance(i.id,d);o||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),P.push(o)}const h=a.length>0?a[0].index:g.length;if(g.length!==h){console.trace(`[createInstance] First service dependency of ${m.name} at position ${h+1} conflicts with ${g.length} static arguments`);const i=h-g.length;i>0?g=g.concat(new Array(i)):g=g.slice(0,h)}return Reflect.construct(m,g.concat(P))}_setServiceInstance(m,g){if(this._services.get(m)instanceof O.SyncDescriptor)this._services.set(m,g);else if(this._parent)this._parent._setServiceInstance(m,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const g=this._services.get(m);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):g}_getOrCreateServiceInstance(m,g){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const d=this._getServiceInstanceOrDescriptor(m);return d instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,d,g.branch(m,!0)):(g.branch(m,!1),d)}_safeCreateAndCacheServiceInstance(m,g,d){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,g,d)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,g,d){const a=new D.Graph(i=>i.id.toString());let P=0;const h=[{id:m,desc:g,_trace:d}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),P++>1e3)throw new b(a);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${m} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof O.SyncDescriptor){const t={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};a.insertEdge(i,t),h.push(t)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new b(a);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof O.SyncDescriptor){const t=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,t)}a.removeNode(o)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,g,d=[],a,P){if(this._services.get(m)instanceof O.SyncDescriptor)return this._createServiceInstance(m,g,d,a,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,g,d,a,P);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(m,g,d=[],a,P){if(a){const h=new w(void 0,this._strict,this,this._enableTracing);h._globalGraphImplicitDependency=String(m);const i=new Map,o=new C.GlobalIdleValue(()=>{const s=h._createInstance(g,d,P);for(const[t,n]of i){const c=s[t];if(typeof c=="function")for(const v of n)c.apply(s,v)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let v=i.get(t);return v||(v=new u.LinkedList,i.set(t,v)),(k,E,M)=>{const _=v.push([k,E,M]);return(0,r.toDisposable)(_)}}if(t in s)return s[t];const n=o.value;let c=n[t];return typeof c!="function"||(c=c.bind(n),s[t]=c),c},set(s,t,n){return o.value[t]=n,!0},getPrototypeOf(s){return g.prototype}})}else return this._createInstance(g,d,P)}_throwIfStrict(m,g){if(g&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=w;var l;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(l||(l={}));class S{static{this.all=new Set}static{this._None=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,g){return m?new S(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(m,g){return m?new S(1,g.name):S._None}static{this._totals=0}constructor(m,g){this.type=m,this.name=g,this._start=Date.now(),this._dep=[]}branch(m,g){const d=new S(3,m.toString());return this._dep.push([m,g,d]),d}stop(){const m=Date.now()-this._start;S._totals+=m;let g=!1;function d(P,h){const i=[],o=new Array(P+1).join("	");for(const[s,t,n]of h._dep)if(t&&n){g=!0,i.push(`${o}CREATES -> ${s}`);const c=d(P+1,n);c&&i.push(c)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(m>2||g)&&S.all.add(a.join(`
`))}}e.Trace=S}),define(se[219],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var L;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(L||(e.IssueType=L={})),e.IIssueMainService=(0,C.createDecorator)("issueService")}),define(se[5],oe([0,1,50,3,45,2,31,4,19,12,7,114,6]),function(V,e,C,L,r,O,D,I,f,u,y,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function l(){return new Date().toISOString()}function S(k){return(0,u.isNumber)(k)}e.isLogLevel=S;var p;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function m(k,E,M){switch(E){case p.Trace:k.trace(M);break;case p.Debug:k.debug(M);break;case p.Info:k.info(M);break;case p.Warning:k.warn(M);break;case p.Error:k.error(M);break;case p.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=m;function g(k,E=!1){let M="";for(let _=0;_<k.length;_++){let T=k[_];if(T instanceof Error&&(T=(0,C.toErrorMessage)(T,E)),typeof T=="object")try{T=JSON.stringify(T)}catch{}M+=(_>0?" ":"")+T}return M}class d extends O.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(E){this.level!==E&&(this.level=E,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(E){return this.level!==p.Off&&this.level<=E}}e.AbstractLogger=d;class a extends d{constructor(E){super(),this.logAlways=E}checkLogLevel(E){return this.logAlways||super.checkLogLevel(E)}trace(E,...M){this.checkLogLevel(p.Trace)&&this.log(p.Trace,g([E,...M],!0))}debug(E,...M){this.checkLogLevel(p.Debug)&&this.log(p.Debug,g([E,...M]))}info(E,...M){this.checkLogLevel(p.Info)&&this.log(p.Info,g([E,...M]))}warn(E,...M){this.checkLogLevel(p.Warning)&&this.log(p.Warning,g([E,...M]))}error(E,...M){if(this.checkLogLevel(p.Error))if(E instanceof Error){const _=Array.prototype.slice.call(arguments);_[0]=E.stack,this.log(p.Error,g(_))}else this.log(p.Error,g([E,...M]))}flush(){}}e.AbstractMessageLogger=a;class P extends d{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.useColors=!I.isWindows}trace(E,...M){this.checkLogLevel(p.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...M):console.log(`[main ${l()}]`,E,...M))}debug(E,...M){this.checkLogLevel(p.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...M):console.log(`[main ${l()}]`,E,...M))}info(E,...M){this.checkLogLevel(p.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...M):console.log(`[main ${l()}]`,E,...M))}warn(E,...M){this.checkLogLevel(p.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,E,...M):console.warn(`[main ${l()}]`,E,...M))}error(E,...M){this.checkLogLevel(p.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,E,...M):console.error(`[main ${l()}]`,E,...M))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class h extends d{constructor(E=e.DEFAULT_LOG_LEVEL,M=!0){super(),this.useColors=M,this.setLevel(E)}trace(E,...M){this.checkLogLevel(p.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",E,...M):console.log(E,...M))}debug(E,...M){this.checkLogLevel(p.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",E,...M):console.log(E,...M))}info(E,...M){this.checkLogLevel(p.Info)&&(this.useColors?console.log("%c INFO","color: #33f",E,...M):console.log(E,...M))}warn(E,...M){this.checkLogLevel(p.Warning)&&(this.useColors?console.log("%c WARN","color: #993",E,...M):console.log(E,...M))}error(E,...M){this.checkLogLevel(p.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",E,...M):console.error(E,...M))}dispose(){}flush(){}}e.ConsoleLogger=h;class i extends d{constructor(E,M=e.DEFAULT_LOG_LEVEL){super(),this.adapter=E,this.setLevel(M)}trace(E,...M){this.checkLogLevel(p.Trace)&&this.adapter.log(p.Trace,[this.extractMessage(E),...M])}debug(E,...M){this.checkLogLevel(p.Debug)&&this.adapter.log(p.Debug,[this.extractMessage(E),...M])}info(E,...M){this.checkLogLevel(p.Info)&&this.adapter.log(p.Info,[this.extractMessage(E),...M])}warn(E,...M){this.checkLogLevel(p.Warning)&&this.adapter.log(p.Warning,[this.extractMessage(E),...M])}error(E,...M){this.checkLogLevel(p.Error)&&this.adapter.log(p.Error,[this.extractMessage(E),...M])}extractMessage(E){return typeof E=="string"?E:(0,C.toErrorMessage)(E,this.checkLogLevel(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class o extends d{constructor(E){super(),this.loggers=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const M of this.loggers)M.setLevel(E);super.setLevel(E)}trace(E,...M){for(const _ of this.loggers)_.trace(E,...M)}debug(E,...M){for(const _ of this.loggers)_.debug(E,...M)}info(E,...M){for(const _ of this.loggers)_.info(E,...M)}warn(E,...M){for(const _ of this.loggers)_.warn(E,...M)}error(E,...M){for(const _ of this.loggers)_.error(E,...M)}flush(){for(const E of this.loggers)E.flush()}dispose(){for(const E of this.loggers)E.dispose()}}e.MultiplexLogger=o;class s extends O.Disposable{constructor(E,M,_){if(super(),this.logLevel=E,this.logsHome=M,this._loggers=new D.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,_)for(const T of _)this._loggers.set(T.resource,{logger:void 0,info:T})}getLoggerEntry(E){return(0,u.isString)(E)?[...this._loggers.values()].find(M=>M.info.id===E):this._loggers.get(E)}getLogger(E){return this.getLoggerEntry(E)?.logger}createLogger(E,M){const _=this.toResource(E),T=(0,u.isString)(E)?E:M?.id??(0,r.hash)(_.toString()).toString(16);let U=this._loggers.get(_)?.logger;const X=M?.logLevel==="always"?p.Trace:M?.logLevel;U||(U=this.doCreateLogger(_,X??this.getLogLevel(_)??this.logLevel,{...M,id:T}));const Y={logger:U,info:{resource:_,id:T,logLevel:X,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(Y.info),this._loggers.set(_,Y),U}toResource(E){return(0,u.isString)(E)?(0,f.joinPath)(this.logsHome,`${E}.log`):E}setLogLevel(E,M){if(y.URI.isUri(E)){const _=E,T=M,U=this._loggers.get(_);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.logLevel?void 0:T,U.logger?.setLevel(T),this._loggers.set(U.info.resource,U),this._onDidChangeLogLevel.fire([_,T]))}else{this.logLevel=E;for(const[_,T]of this._loggers.entries())this._loggers.get(_)?.info.logLevel===void 0&&T.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(E,M){const _=this.getLoggerEntry(E);_&&M!==!_.info.hidden&&(_.info.hidden=!M,this._loggers.set(_.info.resource,_),this._onDidChangeVisibility.fire([_.info.resource,M]))}getLogLevel(E){let M;return E&&(M=this._loggers.get(E)?.info.logLevel),M??this.logLevel}registerLogger(E){const M=this._loggers.get(E.resource);M?M.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this._loggers.set(E.resource,{info:E,logger:void 0}),this._onDidChangeLoggers.fire({added:[E],removed:[]}))}deregisterLogger(E){const M=this._loggers.get(E);M&&(M.logger&&M.logger.dispose(),this._loggers.delete(E),this._onDidChangeLoggers.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const E of this._loggers.values())yield E.info}getRegisteredLogger(E){return this._loggers.get(E)?.info}dispose(){this._loggers.forEach(E=>E.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class t{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(E){}getLevel(){return p.Info}trace(E,...M){}debug(E,...M){}info(E,...M){}warn(E,...M){}error(E,...M){}critical(E,...M){}dispose(){}flush(){}}e.NullLogger=t;class n extends t{}e.NullLogService=n;function c(k){if(k.verbose)return p.Trace;if(typeof k.logLevel=="string"){const E=R(k.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function v(k){switch(k){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=v;function R(k){switch(k){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=R,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",v(p.Info))});var ne=this&&this.__param||function(V,e){return function(C,L){e(C,L,V)}};define(se[220],oe([0,1,15,4,5]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const O=C.safeStorage;let D=class{constructor(f){this.logService=f,C.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(O.encryptString(f));return this.logService.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.logService.error(u),u}}async decrypt(f){let u;try{if(u=JSON.parse(f),!u.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const y=Buffer.from(u.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const b=O.decryptString(y);return this.logService.trace("[EncryptionMainService] Decrypted value."),b}catch(y){throw this.logService.error(y),y}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(L.isWindows)return Promise.resolve("dpapi");if(L.isMacintosh)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const f=O.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.logService.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(L.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(L.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=D,e.EncryptionMainService=D=Ee([ne(0,r.ILogService)],D)}),define(se[221],oe([0,1,23,8,14,3,2,9,67,5]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends D.Disposable{constructor(w,l){super(),this.logService=w,this.options=l,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(w,l){return l.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(w,l):this.watchNonRecursive(w,l)}watchUniversal(w,l){const S={path:this.toFilePath(w),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},p=(0,C.insert)(this.universalPathsToWatch,S);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(w=>(0,r.onUnexpectedError)(w))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(l=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)})));const w=this.options?.watcher?.recursive?.usePolling;if(w===!0)for(const l of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(l)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const l of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(l)&&w.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(w,l){const S={path:this.toFilePath(w),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},p=(0,C.insert)(this.nonRecursivePathsToWatch,S);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(w=>(0,r.onUnexpectedError)(w))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(w=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(w){w.type==="error"&&this._onDidWatchError.fire(w.message),this.logService[w.type](w.message)}toFilePath(w){return(0,I.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(se[222],oe([0,1,23,8,18,22,3,45,72,2,57,13,68,19,63,175,16,118,5,14]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends u.Disposable{static{P=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new D.Emitter),this._onDidUncorrelatedFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${o}`);const t=new u.DisposableStore;return this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s}),t.add(s.onDidChangeFile(n=>{const c=new m.FileChangesEvent(n,!this.isPathCaseSensitive(s));this.internalOnDidFilesChange.fire(c),c.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(c)})),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,u.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){s.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return f.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,l.isAbsolutePath)(o))throw new m.FileOperationError((0,p.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const t=new a.ErrorNoTelemetry;throw t.message=(0,p.localize)(1,null,o.toString()),t}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)||(0,m.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(t){throw(0,m.toFileSystemProviderErrorCode)(t)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,p.localize)(2,null,this.resourceForError(o)),1):(0,m.ensureFileSystemProviderError)(t)}}async doResolveFile(o,s){const t=await this.withProvider(o),n=this.isPathCaseSensitive(t),c=s?.resolveTo,v=s?.resolveSingleChildDescendants,R=s?.resolveMetadata,k=await t.stat(o);let E;return this.toFileStat(t,o,k,void 0,!!R,(M,_)=>(E||(E=y.TernarySearchTree.forUris(()=>!n),E.set(o,!0),c&&E.fill(!0,c)),E.get(M.resource)||E.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&v?_===1:!1))}async toFileStat(o,s,t,n,c,v){const{providerExtUri:R}=this.getExtUri(o),k={resource:s,name:R.basename(s),isFile:(t.type&m.FileType.File)!==0,isDirectory:(t.type&m.FileType.Directory)!==0,isSymbolicLink:(t.type&m.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&m.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&m.FilePermission.Locked),etag:(0,m.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(k.isDirectory&&v(k,n)){try{const E=await o.readdir(s),M=await L.Promises.settled(E.map(async([_,T])=>{try{const U=R.joinPath(s,_),X=c?await o.stat(U):{type:T};return await this.toFileStat(o,U,X,E.length,c,v)}catch(U){return this.logService.trace(U),null}}));k.children=(0,C.coalesce)(M)}catch(E){this.logService.trace(E),k.children=[]}return k}return k}async resolveAll(o){return L.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.withProvider(o),t=await s.stat(o);return this.toFileStat(s,o,t,void 0,!0,()=>!1)}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(t){return t}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new m.FileOperationError((0,p.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=r.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const n=await this.writeFile(o,s);return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,n)),n}async writeFile(o,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:c}=this.getExtUri(n);let v=t;if((0,m.hasFileAtomicWriteCapability)(n)&&!v?.atomic){const R=n.enforceAtomicWriteFile?.(o);R&&(v={...t,atomic:R})}try{await this.validateWriteFile(n,o,v)||await this.mkdirp(n,c.dirname(o));let k;if((0,m.hasReadWriteCapability)(n)&&!(s instanceof r.VSBuffer))if((0,S.isReadableStream)(s)){const E=await(0,S.peekStream)(s,3);E.ended?k=r.VSBuffer.concat(E.buffer):k=E}else k=(0,S.peekReadable)(s,E=>r.VSBuffer.concat(E),3);else k=s;!(0,m.hasOpenReadWriteCloseCapability)(n)||(0,m.hasReadWriteCapability)(n)&&k instanceof r.VSBuffer||(0,m.hasReadWriteCapability)(n)&&(0,m.hasFileAtomicWriteCapability)(n)&&v?.atomic?await this.doWriteUnbuffered(n,o,v,k):await this.doWriteBuffered(n,o,v,k instanceof r.VSBuffer?(0,r.bufferToReadable)(k):k),this._onDidRunOperation.fire(new m.FileOperationEvent(o,4))}catch(R){throw new m.FileOperationError((0,p.localize)(4,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(R).toString()),(0,m.toFileOperationResult)(R),v)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(s)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.resourceForError(s)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.resourceForError(s)));if(n)throw new Error((0,p.localize)(8,null,this.resourceForError(s)))}let v;try{v=await o.stat(s)}catch{return}if(v.type&m.FileType.Directory)throw new m.FileOperationError((0,p.localize)(9,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,v),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==m.ETAG_DISABLED&&typeof v.mtime=="number"&&typeof v.size=="number"&&t.mtime<v.mtime&&t.etag!==(0,m.etag)({mtime:t.mtime,size:v.size}))throw new m.FileOperationError((0,p.localize)(10,null),3,t);return v}async readFile(o,s,t){const n=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(n,o,s,t):this.doReadFile(n,o,s,t)}async doReadFileAtomic(o,s,t,n){return new Promise((c,v)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const R=await this.doReadFile(o,s,t,n);c(R)}catch(R){v(R)}})})}async doReadFile(o,s,t,n){const c=await this.doReadFileStream(o,s,{...t,preferUnbuffered:!0},n);return{...c,value:await(0,r.streamToBuffer)(c.value)}}async readFileStream(o,s,t){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,s,t)}async doReadFileStream(o,s,t,n){const c=new O.CancellationTokenSource(n);let v=t;(0,m.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(s)&&(v={...t,atomic:!0});const R=this.validateReadFile(s,v).then(E=>E,E=>{throw c.dispose(!0),E});let k;try{return typeof v?.etag=="string"&&v.etag!==m.ETAG_DISABLED&&await R,v?.atomic&&(0,m.hasFileAtomicReadCapability)(o)||!((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasFileReadStreamCapability)(o))||(0,m.hasReadWriteCapability)(o)&&v?.preferUnbuffered?k=this.readFileUnbuffered(o,s,v):(0,m.hasFileReadStreamCapability)(o)?k=this.readFileStreamed(o,s,c.token,v):k=this.readFileBuffered(o,s,c.token,v),k.on("end",()=>c.dispose()),k.on("error",()=>c.dispose()),{...await R,value:k}}catch(E){throw k&&await(0,S.consumeStream)(k),this.restoreReadError(E,s,v)}}restoreReadError(o,s,t){const n=(0,p.localize)(11,null,this.resourceForError(s),(0,m.ensureFileSystemProviderError)(o).toString());return o instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(n,o.stat,t):o instanceof m.TooLargeFileOperationError?new m.TooLargeFileOperationError(n,o.fileOperationResult,o.size,o.options):new m.FileOperationError(n,(0,m.toFileOperationResult)(o),t)}readFileStreamed(o,s,t,n=Object.create(null)){const c=o.readFileStream(s,n,t);return(0,S.transform)(c,{data:v=>v instanceof r.VSBuffer?v:r.VSBuffer.wrap(v),error:v=>this.restoreReadError(v,s,n)},v=>r.VSBuffer.concat(v))}readFileBuffered(o,s,t,n=Object.create(null)){const c=(0,r.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,s,c,v=>v,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:v=>this.restoreReadError(v,s,n)},t),c}readFileUnbuffered(o,s,t){const n=(0,S.newWriteableStream)(c=>r.VSBuffer.concat(c));return(async()=>{try{let c;t?.atomic&&(0,m.hasFileAtomicReadCapability)(o)?c=await o.readFile(s,{atomic:!0}):c=await o.readFile(s),typeof t?.position=="number"&&(c=c.slice(t.position)),typeof t?.length=="number"&&(c=c.slice(0,t.length)),this.validateReadFileLimits(s,c.byteLength,t),n.end(r.VSBuffer.wrap(c))}catch(c){n.error(c),n.end()}})(),n}async validateReadFile(o,s){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new m.FileOperationError((0,p.localize)(12,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==m.ETAG_DISABLED&&s.etag===t.etag)throw new m.NotModifiedSinceFileOperationError((0,p.localize)(13,null),t,s);return this.validateReadFileLimits(o,t.size,s),t}validateReadFileLimits(o,s,t){if(typeof t?.limits?.size=="number"&&s>t.limits.size)throw new m.TooLargeFileOperationError((0,p.localize)(14,null,this.resourceForError(o)),7,s,t)}async canMove(o,s,t){return this.doCanMoveCopy(o,s,"move",t)}async canCopy(o,s,t){return this.doCanMoveCopy(o,s,"copy",t)}async doCanMoveCopy(o,s,t,n){if(o.toString()!==s.toString())try{const c=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),v=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(c,o,v,s,t,n)}catch(c){return c}return!0}async move(o,s,t){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),v=await this.doMoveCopy(n,o,c,s,"move",!!t),R=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,v==="move"?2:3,R)),R}async copy(o,s,t){const n=await this.withReadProvider(o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),v=await this.doMoveCopy(n,o,c,s,"copy",!!t),R=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,v==="copy"?3:2,R)),R}async doMoveCopy(o,s,t,n,c,v){if(s.toString()===n.toString())return c;const{exists:R,isSameResourceWithDifferentPathCase:k}=await this.doValidateMoveCopy(o,s,t,n,c,v);if(R&&!k&&v&&await this.del(n,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),c==="copy"){if(o===t&&(0,m.hasFileFolderCopyCapability)(o))await o.copy(s,n,{overwrite:v});else{const E=await this.resolve(s);E.isDirectory?await this.doCopyFolder(o,E,t,n):await this.doCopyFile(o,s,t,n)}return c}else return o===t?(await o.rename(s,n,{overwrite:v}),c):(await this.doMoveCopy(o,s,t,n,"copy",v),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,t,n){if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,s,t,n);if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,s,t,n);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,s,t,n);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,s,t,n)}async doCopyFolder(o,s,t,n){await t.mkdir(n),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async c=>{const v=this.getExtUri(t).providerExtUri.joinPath(n,c.name);return c.isDirectory?this.doCopyFolder(o,await this.resolve(c.resource),t,v):this.doCopyFile(o,c.resource,t,v)}))}async doValidateMoveCopy(o,s,t,n,c,v){let R=!1;if(o===t){const{providerExtUri:E,isPathCaseSensitive:M}=this.getExtUri(o);if(M||(R=E.isEqual(s,n)),R&&c==="copy")throw new Error((0,p.localize)(15,null,this.resourceForError(s),this.resourceForError(n)));if(!R&&E.isEqualOrParent(n,s))throw new Error((0,p.localize)(16,null,this.resourceForError(s),this.resourceForError(n)))}const k=await this.exists(n);if(k&&!R){if(!v)throw new m.FileOperationError((0,p.localize)(17,null,this.resourceForError(s),this.resourceForError(n)),4);if(o===t){const{providerExtUri:E}=this.getExtUri(o);if(E.isEqualOrParent(s,n))throw new Error((0,p.localize)(18,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:R}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?l.extUri:l.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,t)),t}async mkdirp(o,s){const t=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await o.stat(s)).type&m.FileType.Directory))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));break}catch(c){if((0,m.toFileSystemProviderErrorCode)(c)!==m.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(n.basename(s)),s=n.dirname(s)}for(let c=t.length-1;c>=0;c--){s=n.joinPath(s,t[c]);try{await o.mkdir(s)}catch(v){if((0,m.toFileSystemProviderErrorCode)(v)!==m.FileSystemProviderErrorCode.FileExists)throw v}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(t){return t}return!0}async doValidateDelete(o,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),n=!!s?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,p.localize)(20,null,this.resourceForError(o)));const c=s?.atomic;if(c&&!(t.capabilities&65536))throw new Error((0,p.localize)(21,null,this.resourceForError(o)));if(n&&c)throw new Error((0,p.localize)(22,null,this.resourceForError(o)));let v;try{v=await t.stat(o)}catch{}if(v)this.throwIfFileIsReadonly(o,v);else throw new m.FileOperationError((0,p.localize)(23,null,this.resourceForError(o)),1);if(!!!s?.recursive){const k=await this.resolve(o);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,p.localize)(24,null,this.resourceForError(o)))}return t}async del(o,s){const t=await this.doValidateDelete(o,s);let n=s;if((0,m.hasFileAtomicDeleteCapability)(t)&&!n?.atomic){const k=t.enforceAtomicDelete?.(o);k&&(n={...s,atomic:k})}const c=!!n?.useTrash,v=!!n?.recursive,R=n?.atomic??!1;await t.delete(o,{recursive:v,useTrash:c,atomic:R}),this._onDidRunOperation.fire(new m.FileOperationEvent(o,1))}async cloneFile(o,s){const t=await this.withProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(t===n&&this.getExtUri(t).providerExtUri.isEqual(o,s))return;if(t===n&&(0,m.hasFileCloneCapability)(t))return t.cloneFile(o,s);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s));const c=this.writeQueue.queueFor(o,this.getExtUri(t).providerExtUri);return t===n&&(0,m.hasFileFolderCopyCapability)(t)?c.queue(()=>t.copy(o,s,{overwrite:!0})):c.queue(()=>this.doCopyFile(t,o,n,s))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:P.WATCHER_CORRELATION_IDS++})}watch(o,s={recursive:!1,excludes:[]}){const t=new u.DisposableStore;let n=!1,c=()=>{n=!0};t.add((0,u.toDisposable)(()=>c())),(async()=>{try{const R=await this.doWatch(o,s);n?(0,u.dispose)(R):c=()=>(0,u.dispose)(R)}catch(R){this.logService.error(R)}})();const v=s.correlationId;if(typeof v=="number"){const R=t.add(new D.Emitter);return t.add(this.internalOnDidFilesChange.event(E=>{E.correlates(v)&&R.fire(E)})),{onDidChange:R.event,dispose:()=>t.dispose()}}return t}async doWatch(o,s){const t=await this.withProvider(o),n=(0,I.hash)([this.getExtUri(t).providerExtUri.getComparisonKey(o),s]);let c=this.activeWatchers.get(n);return c||(c={count:0,disposable:t.watch(o,s)},this.activeWatchers.set(n,c)),c.count+=1,(0,u.toDisposable)(()=>{c&&(c.count--,c.count===0&&((0,u.dispose)(c.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,u.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const c=await o.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,S.isReadableStream)(n)||(0,S.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,c,n):await this.doWriteReadableBufferedQueued(o,c,n)}catch(v){throw(0,m.ensureFileSystemProviderError)(v)}finally{await o.close(c)}})}async doWriteStreamBufferedQueued(o,s,t){let n=0,c;if((0,S.isReadableBufferedStream)(t)){if(t.buffer.length>0){const v=r.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,s,v,v.byteLength,n,0),n+=v.byteLength}if(t.ended)return;c=t.stream}else c=t;return new Promise((v,R)=>{(0,S.listenStream)(c,{onData:async k=>{c.pause();try{await this.doWriteBuffer(o,s,k,k.byteLength,n,0)}catch(E){return R(E)}n+=k.byteLength,setTimeout(()=>c.resume())},onError:k=>R(k),onEnd:()=>v()})})}async doWriteReadableBufferedQueued(o,s,t){let n=0,c;for(;(c=t.read())!==null;)await this.doWriteBuffer(o,s,c,c.byteLength,n,0),n+=c.byteLength}async doWriteBuffer(o,s,t,n,c,v){let R=0;for(;R<n;){const k=await o.write(s,c+R,t.buffer,v+R,n-R);R+=k}}async doWriteUnbuffered(o,s,t,n){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,t,n))}async doWriteUnbufferedQueued(o,s,t,n){let c;n instanceof r.VSBuffer?c=n:(0,S.isReadableStream)(n)?c=await(0,r.streamToBuffer)(n):(0,S.isReadableBufferedStream)(n)?c=await(0,r.bufferedStreamToBuffer)(n):c=(0,r.readableToBuffer)(n),await o.writeFile(s,c.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async doPipeBuffered(o,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,t,n))}async doPipeBufferedQueued(o,s,t,n){let c,v;try{c=await o.open(s,{create:!1}),v=await t.open(n,{create:!0,unlock:!1});const R=r.VSBuffer.alloc(this.BUFFER_SIZE);let k=0,E=0,M=0;do M=await o.read(c,k,R.buffer,E,R.byteLength-E),await this.doWriteBuffer(t,v,R,M,k,E),k+=M,E+=M,E===R.byteLength&&(E=0);while(M>0)}catch(R){throw(0,m.ensureFileSystemProviderError)(R)}finally{await L.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof v=="number"?t.close(v):Promise.resolve()])}}async doPipeUnbuffered(o,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,t,n))}async doPipeUnbufferedQueued(o,s,t,n){return t.writeFile(n,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,s,t,n){return this.writeQueue.queueFor(n,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,t,n))}async doPipeUnbufferedToBufferedQueued(o,s,t,n){const c=await t.open(n,{create:!0,unlock:!1});try{const v=await o.readFile(s);await this.doWriteBuffer(t,c,r.VSBuffer.wrap(v),v.byteLength,0,0)}catch(v){throw(0,m.ensureFileSystemProviderError)(v)}finally{await t.close(c)}}async doPipeBufferedToUnbuffered(o,s,t,n){const c=await(0,r.streamToBuffer)(this.readFileBuffered(o,s,O.CancellationToken.None));await this.doWriteUnbuffered(t,n,void 0,c)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new m.FileOperationError((0,p.localize)(25,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,p.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=h,e.FileService=h=P=Ee([ne(0,d.ILogService)],h)}),define(se[93],oe([0,1,46,311,8,31,18,3,33,2,9,4,19,63,21,179,16,118,221,50,217,216]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(C)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class i extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,t){super(s,t),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new O.ResourceMap(n=>w.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:t,symbolicLink:n}=await S.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:m.FilePermission.Locked}}catch(t){throw this.toFileSystemProviderError(t)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const t=await S.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async c=>{try{let v;c.isSymbolicLink()?v=(await this.stat((0,w.joinPath)(s,c.name))).type:v=this.toType(c),n.push([c.name,v])}catch(v){this.logService.trace(v)}})),n}catch(t){throw this.toFileSystemProviderError(t)}}toType(s,t){let n;return t?.dangling?n=m.FileType.Unknown:s.isFile()?n=m.FileType.File:s.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,t&&(n|=m.FileType.SymbolicLink),n}async createResourceLock(s){const t=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const c=new r.Barrier;return this.resourceLocks.set(s,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,u.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(s)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),c.open()})}async readFile(s,t){let n;try{t?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),n=await this.createResourceLock(s));const c=this.toFilePath(s);return await S.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{n?.dispose()}}traceLock(s){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,t,n){const c=(0,l.newWriteableStream)(v=>D.VSBuffer.concat(v.map(R=>D.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,s,c,v=>v.buffer,{...t,bufferSize:256*1024},n),c}async writeFile(s,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,w.joinPath)((0,w.dirname)(s),`${(0,w.basename)(s)}${n.atomic.postfix}`),t,n):this.doWriteFile(s,t,n)}async canWriteFileAtomic(s){try{const t=this.toFilePath(s),{symbolicLink:n}=await S.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async doWriteFileAtomic(s,t,n,c){const v=new u.DisposableStore;try{v.add(await this.createResourceLock(s)),v.add(await this.createResourceLock(t)),await this.doWriteFile(t,n,c,!0);try{await this.rename(t,s,{overwrite:!0})}catch(R){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{v.dispose()}}async doWriteFile(s,t,n,c){let v;try{const R=this.toFilePath(s);if(!n.create||!n.overwrite){if(await S.Promises.exists(R)){if(!n.overwrite)throw(0,m.createFileSystemProviderError)((0,p.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.createFileSystemProviderError)((0,p.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(s,{create:!0,unlock:n.unlock},c),await this.write(v,0,t,0,t.byteLength)}catch(R){throw await this.toFileSystemProviderWriteError(s,R)}finally{typeof v=="number"&&await this.close(v)}}static{this.canFlush=!0}static configureFlushOnWrite(s){i.canFlush=s}async open(s,t,n){const c=this.toFilePath(s);let v;(0,m.isFileOpenForWriteOptions)(t)&&!n&&(v=await this.createResourceLock(s));let R;try{if((0,m.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:E}=await S.SymlinkSupport.stat(c);E.mode&128||await S.Promises.chmod(c,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}let k;if((0,m.isFileOpenForWriteOptions)(t)){if(b.isWindows)try{await S.Promises.truncate(c,0),k="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}k||(k="w")}else k="r";R=await S.Promises.open(c,k)}catch(k){throw v?.dispose(),(0,m.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(s,k):this.toFileSystemProviderError(k)}if(this.mapHandleToPos.set(R,0),(0,m.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(R,s),v){const k=this.mapHandleToLock.get(R);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${c})`),this.mapHandleToLock.set(R,v),k&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${c})`),k.dispose())}return R}async close(s){const t=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&i.canFlush)try{await S.Promises.fdatasync(s)}catch(n){i.configureFlushOnWrite(!1),this.logService.error(n)}return await S.Promises.close(s)}catch(n){throw this.toFileSystemProviderError(n)}finally{t&&(this.mapHandleToLock.get(s)===t&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),t.dispose())}}async read(s,t,n,c,v){const R=this.normalizePos(s,t);let k=null;try{k=(await S.Promises.read(s,n,c,v,R)).bytesRead}catch(E){throw this.toFileSystemProviderError(E)}finally{this.updatePos(s,R,k)}return k}normalizePos(s,t){return t===this.mapHandleToPos.get(s)?null:t}updatePos(s,t,n){const c=this.mapHandleToPos.get(s);typeof c=="number"&&(typeof t=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,c+n):this.mapHandleToPos.delete(s)))}async write(s,t,n,c,v){return(0,r.retry)(()=>this.doWrite(s,t,n,c,v),100,3)}async doWrite(s,t,n,c,v){const R=this.normalizePos(s,t);let k=null;try{k=(await S.Promises.write(s,n,c,v,R)).bytesWritten}catch(E){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),E)}finally{this.updatePos(s,R,k)}return k}async mkdir(s){try{await S.Promises.mkdir(this.toFilePath(s))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(s,t){try{const n=this.toFilePath(s);if(t.recursive){let c;t?.atomic!==!1&&t.atomic.postfix&&(c=(0,y.join)((0,y.dirname)(n),`${(0,y.basename)(n)}${t.atomic.postfix}`)),await S.Promises.rm(n,S.RimRafMode.MOVE,c)}else try{await S.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let v=!1;try{const{stat:R,symbolicLink:k}=await S.SymlinkSupport.stat(n);v=R.isDirectory()&&!k}catch{}if(v)await S.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,t,n){const c=this.toFilePath(s),v=this.toFilePath(t);if(c!==v)try{await this.validateMoveCopy(s,t,"move",n.overwrite),await S.Promises.rename(c,v)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(2,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(v)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,t,n){const c=this.toFilePath(s),v=this.toFilePath(t);if(c!==v)try{await this.validateMoveCopy(s,t,"copy",n.overwrite),await S.Promises.copy(c,v,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(3,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(v)),R.toString()))),this.toFileSystemProviderError(R)}}async validateMoveCopy(s,t,n,c){const v=this.toFilePath(s),R=this.toFilePath(t);let k=!1;if(!!(this.capabilities&1024)||(k=(0,f.isEqual)(v,R,!0)),k){if(n==="copy")throw(0,m.createFileSystemProviderError)((0,p.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const M=await this.statIgnoreError(s);if(!M)throw(0,m.createFileSystemProviderError)((0,p.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const _=await this.statIgnoreError(t);if(_){if(!c)throw(0,m.createFileSystemProviderError)((0,p.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);M.type&m.FileType.File&&_.type&m.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,t){return this.doCloneFile(s,t,!1)}async doCloneFile(s,t,n){const c=this.toFilePath(s),v=this.toFilePath(t),R=!!(this.capabilities&1024);if((0,f.isEqual)(c,v,!R))return;const k=new u.DisposableStore;try{k.add(await this.createResourceLock(s)),k.add(await this.createResourceLock(t)),n&&await S.Promises.mkdir((0,y.dirname)(v),{recursive:!0}),await S.Promises.copyFile(c,v)}catch(E){if(E.code==="ENOENT"&&!n)return this.doCloneFile(s,t,!0);throw this.toFileSystemProviderError(E)}finally{k.dispose()}}createUniversalWatcher(s,t,n){return new P.UniversalWatcherClient(c=>s(c),c=>t(c),n)}createNonRecursiveWatcher(s,t,n){return new h.NodeJSWatcherClient(c=>s(c),c=>t(c),n)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let t=s,n;switch(s.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(s,t){let n=this.toFileSystemProviderError(t);if(s&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await S.SymlinkSupport.stat(this.toFilePath(s));c.mode&128||(n=(0,m.createFileSystemProviderError)(t,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return n}}e.DiskFileSystemProvider=i}),define(se[223],oe([0,1,3,93,2,18,63,22]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends r.Disposable{constructor(b,w){super(),this.provider=b,this.logService=w,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(b,w,l){const S=this.getUriTransformer(b);switch(w){case"stat":return this.stat(S,l[0]);case"readdir":return this.readdir(S,l[0]);case"open":return this.open(S,l[0],l[1]);case"close":return this.close(l[0]);case"read":return this.read(l[0],l[1],l[2]);case"readFile":return this.readFile(S,l[0],l[1]);case"write":return this.write(l[0],l[1],l[2],l[3],l[4]);case"writeFile":return this.writeFile(S,l[0],l[1],l[2]);case"rename":return this.rename(S,l[0],l[1],l[2]);case"copy":return this.copy(S,l[0],l[1],l[2]);case"cloneFile":return this.cloneFile(S,l[0],l[1]);case"mkdir":return this.mkdir(S,l[0]);case"delete":return this.delete(S,l[0],l[1]);case"watch":return this.watch(S,l[0],l[1],l[2],l[3]);case"unwatch":return this.unwatch(l[0],l[1])}throw new Error(`IPC Command ${w} not found`)}listen(b,w,l){const S=this.getUriTransformer(b);switch(w){case"fileChange":return this.onFileChange(S,l[0]);case"readFileStream":return this.onReadFileStream(S,l[0],l[1])}throw new Error(`Unknown event ${w}`)}stat(b,w){const l=this.transformIncoming(b,w,!0);return this.provider.stat(l)}readdir(b,w){const l=this.transformIncoming(b,w);return this.provider.readdir(l)}async readFile(b,w,l){const S=this.transformIncoming(b,w,!0),p=await this.provider.readFile(S,l);return O.VSBuffer.wrap(p)}onReadFileStream(b,w,l){const S=this.transformIncoming(b,w,!0),p=new I.CancellationTokenSource,m=new C.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),g=this.provider.readFileStream(S,l,p.token);return(0,D.listenStream)(g,{onData:d=>m.fire(O.VSBuffer.wrap(d)),onError:d=>m.fire(d),onEnd:()=>{m.fire("end"),m.dispose(),p.dispose()}}),m.event}writeFile(b,w,l,S){const p=this.transformIncoming(b,w);return this.provider.writeFile(p,l.buffer,S)}open(b,w,l){const S=this.transformIncoming(b,w,!0);return this.provider.open(S,l)}close(b){return this.provider.close(b)}async read(b,w,l){const S=O.VSBuffer.alloc(l),p=0,m=await this.provider.read(b,w,S.buffer,p,l);return[S,m]}write(b,w,l,S,p){return this.provider.write(b,w,l.buffer,S,p)}mkdir(b,w){const l=this.transformIncoming(b,w);return this.provider.mkdir(l)}delete(b,w,l){const S=this.transformIncoming(b,w);return this.provider.delete(S,l)}rename(b,w,l,S){const p=this.transformIncoming(b,w),m=this.transformIncoming(b,l);return this.provider.rename(p,m,S)}copy(b,w,l,S){const p=this.transformIncoming(b,w),m=this.transformIncoming(b,l);return this.provider.copy(p,m,S)}cloneFile(b,w,l){const S=this.transformIncoming(b,w),p=this.transformIncoming(b,l);return this.provider.cloneFile(S,p)}onFileChange(b,w){const l=new C.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(w,this.createSessionFileWatcher(b,l))},onDidRemoveLastListener:()=>{(0,r.dispose)(this.sessionToWatcher.get(w)),this.sessionToWatcher.delete(w)}});return l.event}async watch(b,w,l,S,p){const m=this.sessionToWatcher.get(w);if(m){const g=this.transformIncoming(b,S),d=m.watch(l,g,p);this.watchRequests.set(w+l,d)}}async unwatch(b,w){const l=b+w,S=this.watchRequests.get(l);S&&((0,r.dispose)(S),this.watchRequests.delete(l))}dispose(){super.dispose();for(const[,b]of this.watchRequests)b.dispose();this.watchRequests.clear();for(const[,b]of this.sessionToWatcher)b.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class u extends r.Disposable{constructor(b,w,l,S){super(),this.uriTransformer=b,this.logService=l,this.environmentService=S,this.watcherRequests=new Map,this.fileWatcher=this._register(new L.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(w)}registerListeners(b){const w=this._register(new C.Emitter);this._register(w.event(l=>{b.fire(l.map(S=>({resource:this.uriTransformer.transformOutgoingURI(S.resource),type:S.type,cId:S.cId})))})),this._register(this.fileWatcher.onDidChangeFile(l=>w.fire(l))),this._register(this.fileWatcher.onDidWatchError(l=>b.fire(l)))}getRecursiveWatcherOptions(b){}getExtraExcludes(b){}watch(b,w,l){const S=this.getExtraExcludes(this.environmentService);return Array.isArray(S)&&(l.excludes=[...l.excludes,...S]),this.watcherRequests.set(b,this.fileWatcher.watch(w,l)),(0,r.toDisposable)(()=>{(0,r.dispose)(this.watcherRequests.get(b)),this.watcherRequests.delete(b)})}dispose(){for(const[,b]of this.watcherRequests)b.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=u}),define(se[224],oe([0,1,15,178,4,7,16,9,223,155]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends f.AbstractDiskFileSystemProviderChannel{constructor(l,S,p){super(l,S),this.environmentService=p}getUriTransformer(l){return u.DefaultURITransformer}transformIncoming(l,S){return O.URI.revive(S)}async delete(l,S,p){if(!p.useTrash)return super.delete(l,S,p);const m=this.transformIncoming(l,S),g=(0,I.normalize)(m.fsPath);try{await C.shell.trashItem(g)}catch{throw(0,D.createFileSystemProviderError)(r.isWindows?(0,L.localize)(0,null,(0,I.basename)(g)):(0,L.localize)(1,null,(0,I.basename)(g)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(l,S){return new b(l,S,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=y;class b extends f.AbstractSessionFileWatcher{watch(l,S,p){if(p.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(l,S,p)}}}),define(se[225],oe([0,1,5]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class L extends C.AbstractMessageLogger{constructor(O=C.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(O),this._register(this.onDidChangeLogLevel(D=>{this._logger?.setLevel(D)}))}set logger(O){this._logger=O;for(const{level:D,message:I}of this.buffer)(0,C.log)(O,D,I);this.buffer=[]}log(O,D){this._logger?(0,C.log)(this._logger,O,D):this.getLevel()<=O&&this.buffer.push({level:O,message:D})}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=L}),define(se[226],oe([0,1,7,3,5,2]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class D extends r.AbstractLoggerService{constructor(b,w,l,S,p){super(w,l,S),this.windowId=b,this.channel=p,this._register(p.listen("onDidChangeLogLevel",b)(m=>{(0,r.isLogLevel)(m)?super.setLogLevel(m):super.setLogLevel(C.URI.revive(m[0]),m[1])})),this._register(p.listen("onDidChangeVisibility",b)(([m,g])=>super.setVisibility(C.URI.revive(m),g))),this._register(p.listen("onDidChangeLoggers",b)(({added:m,removed:g})=>{for(const d of m)super.registerLogger({...d,resource:C.URI.revive(d.resource)});for(const d of g)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new r.AdapterLogger({log:(b,w)=>{this.channel.call("consoleLog",[b,w])}})}registerLogger(b){super.registerLogger(b),this.channel.call("registerLogger",[b,this.windowId])}deregisterLogger(b){super.deregisterLogger(b),this.channel.call("deregisterLogger",[b,this.windowId])}setLogLevel(b,w){super.setLogLevel(b,w),this.channel.call("setLogLevel",[b,w])}setVisibility(b,w){super.setVisibility(b,w),this.channel.call("setVisibility",[this.toResource(b),w])}doCreateLogger(b,w,l){return new I(this.channel,b,w,l,this.windowId)}static setLogLevel(b,w,l){return b.call("setLogLevel",[w,l])}}e.LoggerChannelClient=D;class I extends r.AbstractMessageLogger{constructor(b,w,l,S,p){super(S?.logLevel==="always"),this.channel=b,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.channel.call("createLogger",[w,S,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,w){const l=[[b,w]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(b){this.channel.call("log",[this.file,b])}}class f{constructor(b,w){this.loggerService=b,this.getUriTransformer=w}listen(b,w){const l=this.getUriTransformer(b);switch(w){case"onDidChangeLoggers":return L.Event.map(this.loggerService.onDidChangeLoggers,S=>({added:[...S.added].map(p=>this.transformLogger(p,l)),removed:[...S.removed].map(p=>this.transformLogger(p,l))}));case"onDidChangeVisibility":return L.Event.map(this.loggerService.onDidChangeVisibility,S=>[l.transformOutgoingURI(S[0]),S[1]]);case"onDidChangeLogLevel":return L.Event.map(this.loggerService.onDidChangeLogLevel,S=>(0,r.isLogLevel)(S)?S:[l.transformOutgoingURI(S[0]),S[1]])}throw new Error(`Event not found: ${w}`)}async call(b,w,l){const S=this.getUriTransformer(b);switch(w){case"setLogLevel":return(0,r.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(C.URI.revive(S.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(p=>this.transformLogger(p,S)))}throw new Error(`Call not found: ${w}`)}transformLogger(b,w){return{...b,resource:w.transformOutgoingURI(b.resource)}}}e.LoggerChannel=f;class u extends O.Disposable{constructor(b,w){super(),w.call("setLogLevel",[b.getLogLevel()]),this._register(b.onDidChangeLogLevel(l=>w.call("setLogLevel",[l]))),w.call("getRegisteredLoggers").then(l=>{for(const S of l)b.registerLogger({...S,resource:C.URI.revive(S.resource)})}),this._register(w.listen("onDidChangeVisibility")(([l,S])=>b.setVisibility(C.URI.revive(l),S))),this._register(w.listen("onDidChangeLoggers")(({added:l,removed:S})=>{for(const p of l)b.registerLogger({...p,resource:C.URI.revive(p.resource)});for(const p of S)b.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=u}),define(se[227],oe([0,1,2,5]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class r extends C.Disposable{constructor(D,I=[]){super(),this.logger=new L.MultiplexLogger([D,...I]),this._register(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(D){this.logger.setLevel(D)}getLevel(){return this.logger.getLevel()}trace(D,...I){this.logger.trace(D,...I)}debug(D,...I){this.logger.debug(D,...I)}info(D,...I){this.logger.info(D,...I)}warn(D,...I){this.logger.warn(D,...I)}error(D,...I){this.logger.error(D,...I)}flush(){this.logger.flush()}}e.LogService=r}),define(se[228],oe([0,1,31,7,5]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class O{constructor(I){this.loggerService=I,this.loggers=new C.ResourceMap}listen(I,f,u){switch(f){case"onDidChangeLoggers":return u?this.loggerService.getOnDidChangeLoggersEvent(u):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.loggerService.getOnDidChangeLogLevelEvent(u):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.loggerService.getOnDidChangeVisibilityEvent(u):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(I,f,u){switch(f){case"createLogger":this.createLogger(L.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.log(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1]);case"setLogLevel":return(0,r.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(L.URI.revive(u[0]),u[1]);case"setVisibility":return this.loggerService.setVisibility(L.URI.revive(u[0]),u[1]);case"registerLogger":return this.loggerService.registerLogger({...u[0],resource:L.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(L.URI.revive(u[0]))}throw new Error(`Call not found: ${f}`)}createLogger(I,f,u){this.loggers.set(I,this.loggerService.createLogger(I,f,u))}consoleLog(I,f){let u=console.log;switch(I){case r.LogLevel.Error:u=console.error;break;case r.LogLevel.Warning:u=console.warn;break;case r.LogLevel.Info:u=console.info;break}u.call(console,...f)}log(I,f){const u=this.loggers.get(I);if(!u)throw new Error("Create the logger before logging");for(const[y,b]of f)(0,r.log)(u,y,b)}}e.LoggerChannel=O}),define(se[229],oe([0,1,16,5]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var r;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(r||(r={}));async function O(u,y,b,w,l){try{const S=await new Promise((m,g)=>{V(["@vscode/spdlog"],m,g)});S.setFlushOn(r.Trace);const p=await S.createAsyncRotatingLogger(u,y,b,w);return l?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(S){console.error(S)}return null}function D(u,y,b){switch(y){case L.LogLevel.Trace:u.trace(b);break;case L.LogLevel.Debug:u.debug(b);break;case L.LogLevel.Info:u.info(b);break;case L.LogLevel.Warning:u.warn(b);break;case L.LogLevel.Error:u.error(b);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function I(u,y){switch(y){case L.LogLevel.Trace:u.setLevel(r.Trace);break;case L.LogLevel.Debug:u.setLevel(r.Debug);break;case L.LogLevel.Info:u.setLevel(r.Info);break;case L.LogLevel.Warning:u.setLevel(r.Warning);break;case L.LogLevel.Error:u.setLevel(r.Error);break;case L.LogLevel.Off:u.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class f extends L.AbstractMessageLogger{constructor(y,b,w,l,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(y,b,w,l),this._register(this.onDidChangeLogLevel(p=>{this._logger&&I(this._logger,p)}))}async _createSpdLogLogger(y,b,w,l){const S=w?6:1,p=30/S*C.ByteSize.MB,m=await O(y,b,p,S,l);if(m){this._logger=m,I(this._logger,this.getLevel());for(const{level:g,message:d}of this.buffer)D(this._logger,g,d);this.buffer=[]}}log(y,b){this._logger?D(this._logger,y,b):this.getLevel()<=y&&this.buffer.push({level:y,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(se[230],oe([0,1,32,5,229]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class O extends L.AbstractLoggerService{doCreateLogger(I,f,u){return new r.SpdLogLogger((0,C.generateUuid)(),I.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.LoggerService=O}),define(se[69],oe([0,1,31,3,6,5,230]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,r.refineServiceDecorator)(O.ILoggerService);class I extends D.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new C.ResourceMap}createLogger(u,y,b){b!==void 0&&this.loggerResourcesByWindow.set(this.toResource(u),b);try{return super.createLogger(u,y)}catch(w){throw this.loggerResourcesByWindow.delete(this.toResource(u)),w}}registerLogger(u,y){y!==void 0&&this.loggerResourcesByWindow.set(u.resource,y),super.registerLogger(u)}deregisterLogger(u){this.loggerResourcesByWindow.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const y=[];for(const b of super.getRegisteredLoggers())u===this.loggerResourcesByWindow.get(b.resource)&&y.push(b);return y}getOnDidChangeLogLevelEvent(u){return L.Event.filter(this.onDidChangeLogLevel,y=>(0,O.isLogLevel)(y)||this.isInterestedLoggerResource(y[0],u))}getOnDidChangeVisibilityEvent(u){return L.Event.filter(this.onDidChangeVisibility,([y])=>this.isInterestedLoggerResource(y,u))}getOnDidChangeLoggersEvent(u){return L.Event.filter(L.Event.map(this.onDidChangeLoggers,y=>({added:[...y.added].filter(w=>this.isInterestedLoggerResource(w.resource,u)),removed:[...y.removed].filter(w=>this.isInterestedLoggerResource(w.resource,u))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggers(u){for(const[y,b]of this.loggerResourcesByWindow)b===u&&this.deregisterLogger(y)}isInterestedLoggerResource(u,y){const b=this.loggerResourcesByWindow.get(u);return b===void 0||b===y}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=I}),define(se[231],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function C(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=C;function L(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function r(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=r;function O(D){return!C(D)&&!L(D)&&!r(D)}e.isMenubarMenuItemAction=O}),define(se[39],oe([0,1,3,72,2,6]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class D extends r.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(u){const y=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...u,...this.policyDefinitions},y!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(u),L.Iterable.reduce(this.policies.entries(),(b,[w,l])=>({...b,[w]:l}),{})}getPolicyValue(u){return this.policies.get(u)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(u,[y,b])=>({...u,[y]:{definition:b,value:this.policies.get(y)}}),{})}}e.AbstractPolicyService=D;class I{constructor(){this.onDidChange=C.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(se[232],oe([0,1,8,3,72,12,16,5,39]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(b,w){const l=[];for(const S of new Set(r.Iterable.concat(b.keys(),w.keys())))b.get(S)!==w.get(S)&&l.push(S);return l}let y=class extends f.AbstractPolicyService{constructor(w,l,S){super(),this.file=w,this.fileService=l,this.logService=S,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const p=L.Event.filter(l.onDidFilesChange,m=>m.affects(w));this._register(l.watch(w)),this._register(p(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const w=new Map;try{const l=await this.fileService.readFile(this.file),S=JSON.parse(l.value.toString());if(!(0,O.isObject)(S))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(S))this.policyDefinitions[p]&&w.set(p,S[p])}catch(l){l.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",l)}return w}async refresh(){const w=await this.read(),l=u(this.policies,w);this.policies=w,l.length>0&&this._onDidChange.fire(l)}};e.FilePolicyService=y,e.FilePolicyService=y=Ee([ne(1,D.IFileService),ne(2,I.ILogService)],y)}),define(se[233],oe([0,1,3,2,39]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(f){this.service=f,this.disposables=new L.DisposableStore}listen(f,u){switch(u){case"onDidChange":return C.Event.map(this.service.onDidChange,y=>y.reduce((b,w)=>({...b,[w]:this.service.getPolicyValue(w)??null}),{}),this.disposables)}throw new Error(`Event not found: ${u}`)}call(f,u,y){switch(u){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${u}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=O;class D extends r.AbstractPolicyService{constructor(f,u){super(),this.channel=u;for(const y in f){const{definition:b,value:w}=f[y];this.policyDefinitions[y]=b,w!==void 0&&this.policies.set(y,w)}this.channel.listen("onDidChange")(y=>{for(const b in y){const w=y[b];w===null?this.policies.delete(b):this.policies.set(b,w)}this._onDidChange.fire(Object.keys(y))})}async _updatePolicyDefinitions(f){const u=await this.channel.call("updatePolicyDefinitions",f);for(const y in u)this.policies.set(y,u[y])}}e.PolicyChannelClient=D}),define(se[234],oe([0,1,39,8,2,5]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let D=class extends C.AbstractPolicyService{constructor(f,u){super(),this.logService=f,this.productName=u,this.throttler=new L.Throttler,this.watcher=this._register(new r.MutableDisposable)}async _updatePolicyDefinitions(f){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:u}=await new Promise((y,b)=>{V(["@vscode/policy-watcher"],y,b)});await this.throttler.queue(()=>new Promise((y,b)=>{try{this.watcher.value=u(this.productName,f,w=>{this._onDidPolicyChange(w),y()})}catch(w){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",w),b(w)}}))}_onDidPolicyChange(f){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const u in f){const y=f[u];y===void 0?this.policies.delete(u):this.policies.set(u,y)}this._onDidChange.fire(Object.keys(f))}};e.NativePolicyService=D,e.NativePolicyService=D=Ee([ne(0,O.ILogService)],D)}),define(se[79],oe([0,1,35]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.context<"u"){const O=r.context.configuration();if(O)L=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){L=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:O,searchUrl:D,itemUrl:I,controlUrl:f}=L.extensionsGallery||{};Object.assign(L,{extensionsGallery:{serviceUrl:C.env.VSCODE_GALLERY_SERVICE_URL||O,searchUrl:C.env.VSCODE_GALLERY_SEARCH_URL||D,itemUrl:C.env.VSCODE_GALLERY_ITEM_URL||I,controlUrl:C.env.VSCODE_GALLERY_CONTROL_URL||f}});try{const u=(...b)=>b.reduce((w,l)=>(Object.keys(l).forEach(S=>{Array.isArray(w[S])&&Array.isArray(l[S])?w[S]=l[S]:typeof w[S]=="object"&&typeof l[S]=="object"?w[S]=u(w[S],l[S]):w[S]=l[S]}),w),{}),y=globalThis._VSCODE_USER_PRODUCT_JSON||{};L=u(L,y)}catch{}if(C.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const u=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:u.version,release:u.release})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(se[27],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(se[235],oe([0,1,8,5]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let r=class{constructor(D,I,f){this._window=D,this._sessionId=I,this._logService=f}async inspect(D){await this._connect();const I=this._window.webContents.debugger;await I.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,C.timeout)(D);const f=await I.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),f.profile}async _connect(){const D=this._window.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async _disconnect(){const D=this._window.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.WindowProfiler=r,e.WindowProfiler=r=Ee([ne(2,L.ILogService)],r)}),define(se[80],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,C.createDecorator)("protocolMainService")}),define(se[43],oe([0,1,137,12]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class r{constructor(){this.data=new Map}add(D,I){C.ok(L.isString(D)),C.ok(L.isObject(I)),C.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,I)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new r}),define(se[236],oe([0,1,3,43]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function r(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class O{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,u){this.schemasById[r(f)]=u,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new O;L.Registry.add(e.Extensions.JSONContribution,D)}),define(se[58],oe([0,1,23,3,12,163,17,236,43]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=f.Registry.as(I.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.doRegisterConfigurations(i,o,s),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(i,!1,s),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const s=[];for(const{overrides:t,source:n}of i)for(const c in t)if(o.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const v=this.configurationDefaultsOverrides.get(c),R=v?.valuesSources??new Map;if(n)for(const _ of Object.keys(t[c]))R.set(_,n);const k={...v?.value||{},...t[c]};this.configurationDefaultsOverrides.set(c,{source:n,value:k,valuesSources:R});const E=(0,D.getLanguageTagSettingPlainKey)(c),M={type:"object",default:k,description:O.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:r.isString(n)?void 0:n,defaultValueSource:n};s.push(...p(c)),this.configurationProperties[c]=M,this.defaultLanguageConfigurationOverridesNode.properties[c]=M}else{this.configurationDefaultsOverrides.set(c,{value:t[c],source:n});const v=this.configurationProperties[c];v&&(this.updatePropertyDefaultValue(c,v),this.updateSchema(c,v))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:s,source:t}of i)for(const n in s){const c=this.configurationDefaultsOverrides.get(n),v=r.isString(t)?t:t?.id,R=r.isString(c?.source)?c?.source:c?.source?.id;if(v===R)if(o.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const k=this.configurationProperties[n];k&&(this.updatePropertyDefaultValue(n,k),this.updateSchema(n,k))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,s),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,s){i.forEach(t=>{this.validateAndRegisterProperties(t,o,t.extensionInfo,t.restrictedProperties,void 0,s),this.configurationContributors.push(t),this.registerJSONConfiguration(t)})}doDeregisterConfigurations(i,o){const s=t=>{if(t.properties)for(const n in t.properties){o.add(n);const c=this.configurationProperties[n];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,t.properties[n])}t.allOf?.forEach(n=>s(n))};for(const t of i){s(t);const n=this.configurationContributors.indexOf(t);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(i,o=!0,s,t,n=3,c){n=r.isUndefinedOrNull(i.scope)?n:i.scope;const v=i.properties;if(v)for(const k in v){const E=v[k];if(o&&a(k,E)){delete v[k];continue}if(E.source=s,E.defaultDefaultValue=v[k].default,this.updatePropertyDefaultValue(k,E),e.OVERRIDE_PROPERTY_REGEX.test(k)?E.scope=void 0:(E.scope=r.isUndefinedOrNull(E.scope)?n:E.scope,E.restricted=r.isUndefinedOrNull(E.restricted)?!!t?.includes(k):E.restricted),v[k].hasOwnProperty("included")&&!v[k].included){this.excludedConfigurationProperties[k]=v[k],delete v[k];continue}else this.configurationProperties[k]=v[k],v[k].policy?.name&&this.policyConfigurations.set(v[k].policy.name,k);!v[k].deprecationMessage&&v[k].markdownDeprecationMessage&&(v[k].deprecationMessage=v[k].markdownDeprecationMessage),c.add(k)}const R=i.allOf;if(R)for(const k of R)this.validateAndRegisterProperties(k,o,s,t,n,c)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=s=>{const t=s.properties;if(t)for(const c in t)this.updateSchema(c,t[c]);s.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,s={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const s=this.configurationDefaultsOverrides.get(i);let t=s?.value,n=s?.source;r.isUndefined(t)&&(t=o.defaultDefaultValue,n=void 0),r.isUndefined(t)&&(t=g(o.type)),o.default=t,o.defaultValueSource=n}}const l="\\[([^\\]]+)\\]",S=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(h){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let o=S.exec(h);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=S.exec(h)}}return(0,C.distinct)(i)}e.overrideIdentifiersFromKey=p;function m(h){return h.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=m;function g(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const d=new w;f.Registry.add(e.Extensions.Configuration,d);function a(h,i){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?O.localize(7,null,h):d.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,h,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}e.validateProperty=a;function P(){const h=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))h.push([o,i[o].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=P}),define(se[119],oe([0,1,23,3,44,2,31,38,12,7,17,58,43]),function(V,e,C,L,r,O,D,I,f,u,y,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function l(o){return Object.isFrozen(o)?o:I.deepFreeze(o)}class S{constructor(s={},t=[],n=[],c){this._contents=s,this._keys=t,this._overrides=n,this.raw=c,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(t=>{if(t instanceof S)return t;const n=new p("");return n.parseRaw(t),n.configurationModel});this._rawConfiguration=s.reduce((t,n)=>n===t?n:t.merge(n),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,y.getConfigurationValue)(this.contents,s):this.contents}inspect(s,t){const n=this.rawConfiguration.getValue(s),c=t?this.rawConfiguration.getOverrideValue(s,t):void 0,v=t?this.rawConfiguration.override(t).getValue(s):n;return{value:n,override:c,merged:v}}getOverrideValue(s,t){const n=this.getContentsForOverrideIdentifer(t);return n?s?(0,y.getConfigurationValue)(n,s):n:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const n of this.overrides)n.identifiers.includes(s)&&t.push(...n.keys);return C.distinct(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return C.distinct(s)}override(s){let t=this.overrideConfigurations.get(s);return t||(t=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,t)),t}merge(...s){const t=I.deepClone(this.contents),n=I.deepClone(this.overrides),c=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const R of s)if(v.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.mergeContents(t,R.contents);for(const k of R.overrides){const[E]=n.filter(M=>C.equals(M.identifiers,k.identifiers));E?(this.mergeContents(E.contents,k.contents),E.keys.push(...k.keys),E.keys=C.distinct(E.keys)):n.push(I.deepClone(k))}for(const k of R.keys)c.indexOf(k)===-1&&c.push(k)}return new S(t,c,n,v.every(R=>R instanceof S)?void 0:v)}createOverrideConfigurationModel(s){const t=this.getContentsForOverrideIdentifer(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const c of C.distinct([...Object.keys(this.contents),...Object.keys(t)])){let v=this.contents[c];const R=t[c];R&&(typeof v=="object"&&typeof R=="object"?(v=I.deepClone(v),this.mergeContents(v,R)):v=R),n[c]=v}return new S(n,this.keys,this.overrides)}mergeContents(s,t){for(const n of Object.keys(t)){if(n in s&&f.isObject(s[n])&&f.isObject(t[n])){this.mergeContents(s[n],t[n]);continue}s[n]=I.deepClone(t[n])}}getContentsForOverrideIdentifer(s){let t=null,n=null;const c=v=>{v&&(n?this.mergeContents(n,v):n=I.deepClone(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===s?t=v.contents:v.identifiers.includes(s)&&c(v.contents);return c(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,t){this.updateValue(s,t,!0)}setValue(s,t){this.updateValue(s,t,!1)}removeValue(s){const t=this.keys.indexOf(s);t!==-1&&(this.keys.splice(t,1),(0,y.removeFromValueTree)(this.contents,s),b.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(n=>C.equals(n.identifiers,(0,b.overrideIdentifiersFromKey)(s))),1))}updateValue(s,t,n){(0,y.addToValueTree)(this.contents,s,t,c=>console.error(c)),n=n||this.keys.indexOf(s)===-1,n&&this.keys.push(s),b.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,y.toValuesTree)(this.contents[s],c=>console.error(c))})}}e.ConfigurationModel=S;class p{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,t){if(!f.isUndefinedOrNull(s)){const n=this.doParseContent(s);this.parseRaw(n,t)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,t){this._raw=s;const{contents:n,keys:c,overrides:v,restricted:R,hasExcludedProperties:k}=this.doParseRaw(s,t);this._configurationModel=new S(n,c,v,k?[s]:void 0),this._restrictedConfigurations=R||[]}doParseContent(s){let t={},n=null,c=[];const v=[],R=[];function k(M){Array.isArray(c)?c.push(M):n!==null&&(c[n]=M)}const E={onObjectBegin:()=>{const M={};k(M),v.push(c),c=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{c=v.pop()},onArrayBegin:()=>{const M=[];k(M),v.push(c),c=M,n=null},onArrayEnd:()=>{c=v.pop()},onLiteralValue:k,onError:(M,_,T)=>{R.push({error:M,offset:_,length:T})}};if(s)try{r.visit(s,E),t=c[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return t}doParseRaw(s,t){const n=w.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),c=this.filter(s,n,!0,t);s=c.raw;const v=(0,y.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),R=Object.keys(s),k=this.toOverrides(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:v,keys:R,overrides:k,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}filter(s,t,n,c){let v=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:v};const R={},k=[];for(const E in s)if(b.OVERRIDE_PROPERTY_REGEX.test(E)&&n){const M=this.filter(s[E],t,!1,c);R[E]=M.raw,v=v||M.hasExcludedProperties,k.push(...M.restricted)}else{const M=t[E],_=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&k.push(E),!c.exclude?.includes(E)&&(c.include?.includes(E)||(_===void 0||c.scopes===void 0||c.scopes.includes(_))&&!(c.skipRestricted&&M?.restricted))?R[E]=s[E]:v=!0}return{raw:R,restricted:k,hasExcludedProperties:v}}toOverrides(s,t){const n=[];for(const c of Object.keys(s))if(b.OVERRIDE_PROPERTY_REGEX.test(c)){const v={};for(const R in s[c])v[R]=s[c][R];n.push({identifiers:(0,b.overrideIdentifiersFromKey)(c),keys:Object.keys(v),contents:(0,y.toValuesTree)(v,t)})}return n}}e.ConfigurationModelParser=p;class m extends O.Disposable{constructor(s,t,n,c){super(),this.userSettingsResource=s,this.parseOptions=t,this.fileService=c,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&n.isEqual(v.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class g{constructor(s,t,n,c,v,R,k,E,M,_,T,U,X){this.key=s,this.overrides=t,this._value=n,this.overrideIdentifiers=c,this.defaultConfiguration=v,this.policyConfiguration=R,this.applicationConfiguration=k,this.userConfiguration=E,this.localUserConfiguration=M,this.remoteUserConfiguration=_,this.workspaceConfiguration=T,this.folderConfigurationModel=U,this.memoryConfigurationModel=X}get value(){return l(this._value)}inspect(s,t,n){const c=s.inspect(t,n);return{get value(){return l(c.value)},get override(){return l(c.override)},get merged(){return l(c.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(s,t,n,c,v=new S,R=new S,k=new D.ResourceMap,E=new S,M=new D.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=t,this._applicationConfiguration=n,this._localUserConfiguration=c,this._remoteUserConfiguration=v,this._workspaceConfiguration=R,this._folderConfigurations=k,this._memoryConfiguration=E,this._memoryConfigurationByResource=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(s,t,n){return this.getConsolidatedConfigurationModel(s,t,n).getValue(s)}updateValue(s,t,n={}){let c;n.resource?(c=this._memoryConfigurationByResource.get(n.resource),c||(c=new S,this._memoryConfigurationByResource.set(n.resource,c))):c=this._memoryConfiguration,t===void 0?c.removeValue(s):c.setValue(s,t),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,t,n){const c=this.getConsolidatedConfigurationModel(s,t,n),v=this.getFolderConfigurationModelForResource(t.resource,n),R=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,k=new Set;for(const E of c.overrides)for(const M of E.identifiers)c.getOverrideValue(s,M)!==void 0&&k.add(M);return new g(s,t,c.getValue(s),k.size?[...k]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,v||void 0,R)}keys(s){const t=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,t){this._folderConfigurations.set(s,t),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const n=[];if(!t){const{added:c,updated:v,removed:R}=h(this._defaultConfiguration,s);t=[...c,...v,...R]}for(const c of t)for(const v of(0,b.overrideIdentifiersFromKey)(c)){const R=this._defaultConfiguration.getKeysForOverrideIdentifier(v),k=s.getKeysForOverrideIdentifier(v),E=[...k.filter(M=>R.indexOf(M)===-1),...R.filter(M=>k.indexOf(M)===-1),...R.filter(M=>!I.equals(this._defaultConfiguration.override(v).getValue(M),s.override(v).getValue(M)))];n.push([v,E])}return this.updateDefaultConfiguration(s),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(s){const{added:t,updated:n,removed:c}=h(this._policyConfiguration,s),v=[...t,...n,...c];return v.length&&this.updatePolicyConfiguration(s),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:t,updated:n,removed:c,overrides:v}=h(this.applicationConfiguration,s),R=[...t,...n,...c];return R.length&&this.updateApplicationConfiguration(s),{keys:R,overrides:v}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:n,removed:c,overrides:v}=h(this.localUserConfiguration,s),R=[...t,...n,...c];return R.length&&this.updateLocalUserConfiguration(s),{keys:R,overrides:v}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:n,removed:c,overrides:v}=h(this.remoteUserConfiguration,s),R=[...t,...n,...c];return R.length&&this.updateRemoteUserConfiguration(s),{keys:R,overrides:v}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:n,removed:c,overrides:v}=h(this.workspaceConfiguration,s),R=[...t,...n,...c];return R.length&&this.updateWorkspaceConfiguration(s),{keys:R,overrides:v}}compareAndUpdateFolderConfiguration(s,t){const n=this.folderConfigurations.get(s),{added:c,updated:v,removed:R,overrides:k}=h(n,t),E=[...c,...v,...R];return(E.length||!n)&&this.updateFolderConfiguration(s,t),{keys:E,overrides:k}}compareAndDeleteFolderConfiguration(s){const t=this.folderConfigurations.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:n,updated:c,removed:v,overrides:R}=h(t,void 0);return{keys:[...n,...c,...v],overrides:R}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,t,n){let c=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier&&(c=c.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:s},t){let n=this.getWorkspaceConsolidatedConfiguration();if(t&&s){const c=t.getFolder(s);c&&(n=this.getFolderConsolidatedConfiguration(c.uri)||n);const v=this._memoryConfigurationByResource.get(s);v&&(n=n.merge(v))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let t=this._foldersConsolidatedConfigurations.get(s);if(!t){const n=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(s);c?(t=n.merge(c),this._foldersConsolidatedConfigurations.set(s,t)):t=n}return t}getFolderConfigurationModelForResource(s,t){if(t&&s){const n=t.getFolder(s);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,t)=>{const{contents:n,overrides:c,keys:v}=this._folderConfigurations.get(t);return s.push([t,{contents:n,overrides:c,keys:v}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(t=>s.add(t)),this.userConfiguration.keys.forEach(t=>s.add(t)),this._workspaceConfiguration.keys.forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.keys.forEach(n=>s.add(n))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>s.add(n))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>t.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(s).forEach(c=>t.add(c))),[...t.values()]}static parse(s){const t=this.parseConfigurationModel(s.defaults),n=this.parseConfigurationModel(s.policy),c=this.parseConfigurationModel(s.application),v=this.parseConfigurationModel(s.user),R=this.parseConfigurationModel(s.workspace),k=s.folders.reduce((E,M)=>(E.set(u.URI.revive(M[0]),this.parseConfigurationModel(M[1])),E),new D.ResourceMap);return new d(t,n,c,v,new S,R,k,new S,new D.ResourceMap)}static parseConfigurationModel(s){return new S(s.contents,s.keys,s.overrides)}}e.Configuration=d;function a(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,t=new Map;for(const c of o)c.keys.forEach(v=>s.add(v)),c.overrides.forEach(([v,R])=>{const k=(0,D.getOrSet)(t,v,new Set);R.forEach(E=>k.add(E))});const n=[];return t.forEach((c,v)=>n.push([v,[...c.values()]])),{keys:[...s.values()],overrides:n}}e.mergeChanges=a;class P{constructor(s,t,n,c){this.change=s,this.previous=t,this.currentConfiguraiton=n,this.currentWorkspace=c,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const v of s.keys)this.affectedKeys.add(v);for(const[,v]of s.overrides)for(const R of v)this.affectedKeys.add(R);this._affectsConfigStr=this._marker;for(const v of this.affectedKeys)this._affectsConfigStr+=v+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,t){const n=this._marker+s,c=this._affectsConfigStr.indexOf(n);if(c<0)return!1;const v=c+n.length;if(v>=this._affectsConfigStr.length)return!1;const R=this._affectsConfigStr.charCodeAt(v);if(R!==this._markerCode1&&R!==this._markerCode2)return!1;if(t){const k=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.previous?.workspace):void 0,E=this.currentConfiguraiton.getValue(s,t,this.currentWorkspace);return!I.equals(k,E)}return!0}}e.ConfigurationChangeEvent=P;function h(o,s){const{added:t,removed:n,updated:c}=i(s?.rawConfiguration,o?.rawConfiguration),v=[],R=o?.getAllOverrideIdentifiers()||[],k=s?.getAllOverrideIdentifiers()||[];if(s){const E=k.filter(M=>!R.includes(M));for(const M of E)v.push([M,s.getKeysForOverrideIdentifier(M)])}if(o){const E=R.filter(M=>!k.includes(M));for(const M of E)v.push([M,o.getKeysForOverrideIdentifier(M)])}if(s&&o){for(const E of R)if(k.includes(E)){const M=i({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});v.push([E,[...M.added,...M.removed,...M.updated]])}}return{added:t,removed:n,updated:c,overrides:v}}function i(o,s){const t=o?s?o.keys.filter(v=>s.keys.indexOf(v)===-1):[...o.keys]:[],n=s?o?s.keys.filter(v=>o.keys.indexOf(v)===-1):[...s.keys]:[],c=[];if(o&&s){for(const v of s.keys)if(o.keys.indexOf(v)!==-1){const R=(0,y.getConfigurationValue)(s.contents,v),k=(0,y.getConfigurationValue)(o.contents,v);I.equals(R,k)||c.push(v)}}return{added:t,removed:n,updated:c}}}),define(se[237],oe([0,1,23,3,2,38,12,119,58,5,39,43]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class w extends r.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(b.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:g})=>this.onDidUpdateConfiguration(Array.from(m),g))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(m,g){this.updateConfigurationModel(m,b.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const m=b.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(m),m)}updateConfigurationModel(m,g){const d=this.getConfigurationDefaultOverrides();for(const a of m){const P=d[a],h=g[a];P!==void 0?this._configurationModel.addValue(a,P):h?this._configurationModel.addValue(a,h.default):this._configurationModel.removeValue(a)}}}e.DefaultConfiguration=w;class l{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=l;let S=class extends r.Disposable{get configurationModel(){return this._configurationModel}constructor(m,g,d){super(),this.defaultConfiguration=m,this.policyService=g,this.logService=d,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.updatePolicyDefinitions(m),!0))),this._configurationModel}async updatePolicyDefinitions(m){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",m);const g={},d=[],a=b.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const P of m){const h=a[P];if(!h){d.push(P);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.logService.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}d.push(P),g[h.policy.name]={type:h.type}}}return(0,D.isEmptyObject)(g)||await this.policyService.updatePolicyDefinitions(g),d}onDidChangePolicies(m){this.logService.trace("PolicyConfiguration#onDidChangePolicies",m);const g=b.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),d=(0,C.coalesce)(m.map(a=>g.get(a)));this.update(d,!0)}update(m,g){this.logService.trace("PolicyConfiguration#update",m);const d=b.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),a=[],P=this._configurationModel.isEmpty();for(const h of m){const i=d[h]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(P?o!==void 0:!(0,O.equals)(this._configurationModel.getValue(h),o))&&a.push([h,o])}else this._configurationModel.getValue(h)!==void 0&&a.push([h,void 0])}if(a.length){this.logService.trace("PolicyConfiguration#changed",a);const h=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const i of h.keys)this._configurationModel.setValue(i,h.getValue(i));for(const[i,o]of a)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=S,e.PolicyConfiguration=S=Ee([ne(1,y.IPolicyService),ne(2,u.ILogService)],S)}),define(se[238],oe([0,1,8,3,2,19,17,119,237,39]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends r.Disposable{constructor(w,l,S,p){super(),this.settingsResource=w,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration),this.policyConfiguration=S instanceof u.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,S,p)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,{},O.extUriBiasedIgnorePathCase,l)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:m,properties:g})=>this.onDidDefaultConfigurationChange(m,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(m=>this.onDidPolicyConfigurationChange(m))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[w,l,S]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(w,l,new I.ConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(w,l){const S=typeof w=="string"?w:void 0,p=(0,D.isConfigurationOverrides)(w)?w:(0,D.isConfigurationOverrides)(l)?l:{};return this.configuration.getValue(S,p,void 0)}updateValue(w,l,S,p){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const l=this.configuration.toData(),S=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(S,l,2)}onDidDefaultConfigurationChange(w,l){const S=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(w,l);this.trigger(p,S,7)}onDidPolicyConfigurationChange(w){const l=this.configuration.toData(),S=this.configuration.compareAndUpdatePolicyConfiguration(w);this.trigger(S,l,7)}trigger(w,l,S){const p=new I.ConfigurationChangeEvent(w,{data:l},this.configuration);p.source=S,p.sourceConfig=this.getTargetConfiguration(S),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(w){switch(w){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(se[239],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class C{async routeCall(r,O,D){if(O!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${O}`);const I=D[0];if(I?.authority){const f=r.connections.find(u=>u.ctx===I.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(r,O){throw new Error(`Event not found: ${O}`)}}e.NodeRemoteResourceRouter=C}),define(se[240],oe([0,1,14,6]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var r;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class O{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class D{constructor(b,w){this.host=b,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=D;var I;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class f extends C.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof f&&b._code===I.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof f&&b._code===I.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof f&&b._code===I.NoResolverFound}static isInvalidAuthority(b){return b instanceof f&&b._code===I.InvalidAuthority}static isHandled(b){return b instanceof f&&b.isHandled}constructor(b,w=I.Unknown,l){super(b),this._message=b,this._code=w,this._detail=l,this.isHandled=w===I.NotAvailable&&l===!0,Object.setPrototypeOf(this,f.prototype)}}e.RemoteAuthorityResolverError=f;function u(y){const b=y.indexOf("+");return b===-1?y:y.substring(0,b)}e.getRemoteAuthorityPrefix=u}),define(se[59],oe([0,1,13]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(u){return u.scheme===C.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=L;function r(u){if(!u)return;const y=u.indexOf("+");return y<0?u:u.substr(0,y)}e.getRemoteName=r;function O(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=O;function D(u){const{host:y,port:b}=f(u);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:b}}e.parseAuthorityWithPort=D;function I(u,y){let{host:b,port:w}=f(u);return typeof w>"u"&&(w=y),{host:b,port:w}}e.parseAuthorityWithOptionalPort=I;function f(u){const y=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const b=u.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const w=u.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:u,port:void 0}}}),define(se[120],oe([0,1,25,6,59]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(D||(e.ExtensionType=D={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class f{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,g){if(typeof m>"u"||m===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof m=="string"||typeof g=="string"){const d=typeof m=="string"?m:m.value,a=typeof g=="string"?g:g.value;return C.equalsIgnoreCase(d,a)}return m._lower===g._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=f;class u{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const g of m)this.add(g)}add(m){this._set.add(f.toKey(m))}delete(m){return this._set.delete(f.toKey(m))}has(m){return this._set.has(f.toKey(m))}}e.ExtensionIdentifierSet=u;class y{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(f.toKey(m))}get(m){return this._map.get(f.toKey(m))}has(m){return this._map.has(f.toKey(m))}set(m,g){this._map.set(f.toKey(m),g)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=y;function b(p){return w(p)}e.isApplicationScopedExtension=b;function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function l(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=l;function S(p,m){if(m){const g=`onResolveRemoteAuthority:${(0,r.getRemoteName)(m)}`;return!!p.activationEvents?.includes(g)}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(se[241],oe([0,1,8,18,22,14,3,2,68,73,32,109,240,59]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var p;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function m(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(j){const A=new r.CancellationTokenSource;return setTimeout(()=>A.cancel(),j),A.token}function d(j,A){if(j.isCancellationRequested||A.isCancellationRequested)return r.CancellationToken.Cancelled;const F=new r.CancellationTokenSource;return j.onCancellationRequested(()=>F.cancel()),A.onCancellationRequested(()=>F.cancel()),F.token}class a{get didTimeout(){return this._state==="timedout"}constructor(A){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((F,J)=>{this._resolvePromise=F,this._rejectPromise=J}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function P(j,A){const F=new a(A);return F.registerDisposable(j.onControlMessage(J=>{const z=JSON.parse(J.toString()),K=W(z);K?F.reject(K):F.resolve(z)})),F.promise}function h(j,A,F,J,z,K,N,$){const ee=new a($),ae=u.StopWatch.create(!1);return j.info(`Creating a socket (${N})...`),f.mark(`code/willCreateSocket/${K}`),A.connect(F,J,z,N).then(re=>{ee.didTimeout?(f.mark(`code/didCreateSocketError/${K}`),j.info(`Creating a socket (${N}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),re?.dispose()):(f.mark(`code/didCreateSocketOK/${K}`),j.info(`Creating a socket (${N}) was successful after ${ae.elapsed()} ms.`),ee.resolve(re))},re=>{f.mark(`code/didCreateSocketError/${K}`),j.info(`Creating a socket (${N}) returned an error after ${ae.elapsed()} ms.`),j.error(re),ee.reject(re)}),ee.promise}function i(j,A){const F=new a(A);return j.then(J=>{F.didTimeout||F.resolve(J)},J=>{F.didTimeout||F.reject(J)}),F.promise}async function o(j,A,F,J){const z=Z(j,A);j.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let K;try{K=await h(j.logService,j.remoteSocketFactoryService,j.connectTo,(0,l.getRemoteServerRootPath)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,m(A),`renderer-${m(A)}-${j.reconnectionToken}`,J)}catch(re){throw j.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),j.logService.error(re),re}j.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let N,$;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(K,null),N=j.reconnectionProtocol,$=!1):(N=new b.PersistentProtocol({socket:K}),$=!0),j.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const ee=await i(j.signService.createNewMessage((0,y.generateUuid)()),J),ae={type:"auth",auth:j.connectionToken||"00000000000000000000",data:ee.data};N.sendControl(L.VSBuffer.fromString(JSON.stringify(ae)));try{const re=await P(N,d(J,g(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(j.logService.trace(`${z} 4/6. received SignRequest control message.`),!await i(j.signService.validate(ee,re.signedData),J)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const pe=await i(j.signService.sign(re.data),J),ye={type:"connectionType",commit:j.commit,signedData:pe,desiredConnectionType:A};return F&&(ye.args=F),j.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(ye))),{protocol:N,ownsProtocol:$}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(j.logService.error(`${z} the handshake timed out. Error:`),j.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${z} received error control message when negotiating connection. Error:`),j.logService.error(re)),$&&x(N),re}}async function s(j,A,F,J){const z=Date.now(),K=Z(j,A),{protocol:N,ownsProtocol:$}=await o(j,A,F,J),ee=new a(J);return ee.registerDisposable(N.onControlMessage(ae=>{const re=JSON.parse(ae.toString()),me=W(re);me?(j.logService.error(`${K} received error control message when negotiating connection. Error:`),j.logService.error(me),$&&x(N),ee.reject(me)):(j.reconnectionProtocol?.endAcceptReconnection(),j.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${de(z)}!`),ee.resolve({protocol:N,firstMessage:re}))})),ee.promise}async function t(j,A){const{protocol:F}=await s(j,1,void 0,A);return{protocol:F}}async function n(j,A,F){const{protocol:J,firstMessage:z}=await s(j,2,A,F),K=z&&z.debugPort;return{protocol:J,debugPort:K}}async function c(j,A,F){const J=Date.now(),z=Z(j,3),{protocol:K}=await o(j,3,A,F);return j.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${de(J)}!`),K}async function v(j,A,F){const{connectTo:J,connectionToken:z}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,connectTo:J,connectionToken:z,reconnectionToken:A,reconnectionProtocol:F,remoteSocketFactoryService:j.remoteSocketFactoryService,signService:j.signService,logService:j.logService}}async function R(j,A,F){return E(j,async J=>{const{protocol:z}=await t(J,r.CancellationToken.None);return new Q(j,A,F,J.reconnectionToken,z)})}e.connectRemoteAgentManagement=R;async function k(j,A){return E(j,async F=>{const{protocol:J,debugPort:z}=await n(F,A,r.CancellationToken.None);return new G(j,A,F.reconnectionToken,J,z)})}e.connectRemoteAgentExtensionHost=k;async function E(j,A){for(let J=1;;J++)try{const z=(0,y.generateUuid)(),K=await v(j,z,null);return await A(K)}catch(z){if(J<5)j.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),j.logService.error(z);else throw j.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),j.logService.error(z),ue.triggerPermanentFailure(0,0,w.RemoteAuthorityResolverError.isHandled(z)),z}}async function M(j,A,F){const J=await v(j,(0,y.generateUuid)(),null);return await c(J,{host:A,port:F},r.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function _(j){return(0,C.createCancelablePromise)(A=>new Promise((F,J)=>{const z=setTimeout(F,j*1e3);A.onCancellationRequested(()=>{clearTimeout(z),F()})}))}var T;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(A,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.type=0}}e.ConnectionLostEvent=U;class X{constructor(A,F,J,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.durationSeconds=J,this.cancellableTimer=z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=X;class Y{constructor(A,F,J){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=J,this.type=2}}e.ReconnectionRunningEvent=Y;class le{constructor(A,F,J){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=J,this.type=4}}e.ConnectionGainEvent=le;class ce{constructor(A,F,J,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=J,this.handled=z,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class ue extends I.Disposable{static triggerPermanentFailure(A,F,J){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=F,this._permanentFailureHandled=J,this._instances.forEach(z=>z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(A=>A._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(A=>A._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ue._permanentFailure}constructor(A,F,J,z,K){super(),this._connectionType=A,this._options=F,this.reconnectionToken=J,this.protocol=z,this._reconnectionFailureIsFatal=K,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(z.onSocketClose(N=>{const $=q(this._connectionType,this.reconnectionToken,!0);N?N.type===0?(this._options.logService.info(`${$} received socket close event (hadError: ${N.hadError}).`),N.error&&this._options.logService.error(N.error)):(this._options.logService.info(`${$} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this._options.logService.error(N.event)):this._options.logService.info(`${$} received socket close event.`),this._beginReconnecting()})),this._register(z.onSocketTimeout(N=>{const $=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} received socket timeout event (unacknowledgedMsgCount: ${N.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${N.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${N.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ue._instances.push(this),this._register((0,I.toDisposable)(()=>{const N=ue._instances.indexOf(this);N>=0&&ue._instances.splice(N,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ue._permanentFailureMillisSinceLastIncomingData,ue._permanentFailureAttempt,ue._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const A=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const z=J<F.length?F[J]:F[F.length-1];try{if(z>0){const N=_(z);this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,N)),this._options.logService.info(`${A} waiting for ${z} seconds before reconnecting...`);try{await N}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this._options.logService.info(`${A} resolving connection...`);const K=await v(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${K.connectTo}...`),await this._reconnect(K,g(S)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(w.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((0,O.isCancellationError)(K)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if(K instanceof w.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,w.RemoteAuthorityResolverError.isHandled(K));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(K),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(A,F,J){this._reconnectionFailureIsFatal?ue.triggerPermanentFailure(A,F,J):this._gotoPermanentFailure(A,F,J)}_gotoPermanentFailure(A,F,J){this._onDidStateChange.fire(new ce(this.reconnectionToken,A,F,J)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ue;class Q extends ue{constructor(A,F,J,z,K){super(1,A,z,K,!0),this.client=this._register(new b.Client(K,{remoteAuthority:F,clientId:J},A.ipcLogger))}async _reconnect(A,F){await t(A,F)}}e.ManagementPersistentConnection=Q;class G extends ue{constructor(A,F,J,z,K){super(2,A,J,z,!1),this._startArguments=F,this.debugPort=K}async _reconnect(A,F){await n(A,this._startArguments,F)}}e.ExtensionHostPersistentConnection=G;function x(j){try{j.acceptDisconnect();const A=j.getSocket();j.dispose(),A.dispose()}catch(A){(0,O.onUnexpectedError)(A)}}function W(j){if(j&&j.type==="error"){const A=new Error(`Connection error: ${j.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function B(j,A){for(;j.length<A;)j+=" ";return j}function H(j,A){return`[remote-connection][${B(m(j),13)}][${A.substr(0,5)}\u2026]`}function q(j,A,F){return`${H(j,A)}[${F?"reconnect":"initial"}]`}function Z(j,A){return`${q(A,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.connectTo}]`}function de(j){return`${Date.now()-j} ms`}}),define(se[242],oe([0,1,2,6]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,L.createDecorator)("remoteSocketFactoryService");class r{constructor(){this.factories={}}register(D,I){return this.factories[D]??=[],this.factories[D].push(I),(0,C.toDisposable)(()=>{const f=this.factories[D]?.indexOf(I);typeof f=="number"&&f>=0&&this.factories[D]?.splice(f,1)})}getSocketFactory(D){return(this.factories[D.type]||[]).find(f=>f.supports(D))}connect(D,I,f,u){const y=this.getSocketFactory(D);if(!y)throw new Error(`No socket factory found for ${D}`);return y.connect(D,I,f,u)}}e.RemoteSocketFactoryService=r}),define(se[243],oe([0,1,26,48,21,113]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function I(l=!1){return(D===void 0||l)&&(D=f()),D}e.hasWSLFeatureInstalled=I;async function f(){const l=u();if(l===void 0)return!1;if(l>=22e3){const S=b();if(S)return new Promise(p=>{L.execFile(S,["--status"],m=>p(!m))})}else{const S=w();if(S)try{if((await r.Promises.stat(S)).isFile())return!0}catch{}}return!1}function u(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(C.release());if(l)return parseInt(l[3])}function y(l){const S=process.env.SystemRoot;if(S){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(S,p?"Sysnative":"System32",l)}}function b(){return y("wsl.exe")}function w(){return y("lxss\\LxssManager.dll")}}),define(se[51],oe([0,1,18,14,2,183,58,6,5,43]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");class y{constructor(h){this.original=h}toJSON(){if(!this.headers){const h=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?h[i]="*****":h[i]=this.original[i];this.headers=h}return this.headers}}class b extends r.Disposable{constructor(h){super(),this.counter=0,this.logger=h.createLogger("network",{name:(0,O.localize)(0,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async logAndRequest(h,i,o){const s=`${h} #${++this.counter}: ${i.url}`;this.logger.trace(`${s} - begin`,i.type,new y(i.headers??{}));try{const t=await o();return this.logger.trace(`${s} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.logger.error(`${s} - error`,i.type,(0,L.getErrorMessage)(t)),t}}}e.AbstractRequestService=b;function w(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=w;function l(P){return P.res.statusCode===204}e.hasNoContent=l;async function S(P){return l(P)?null:(await(0,C.streamToBuffer)(P.stream)).toString()}e.asText=S;async function p(P){if(!w(P))throw new Error("Server returned "+P.res.statusCode);return S(P)}e.asTextOrError=p;async function m(P){if(!w(P))throw new Error("Server returned "+P.res.statusCode);if(l(P))return null;const i=(await(0,C.streamToBuffer)(P.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.asJson=m;function g(P){a(P)}e.updateProxyConfigurationsScope=g;let d;function a(P){const h=u.Registry.as(D.Extensions.Configuration),i=d;d={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[d],remove:i?[i]:[]})}a(1)}),define(se[244],oe([0,1,18,22]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class r{constructor(I){this.service=I}listen(I,f){throw new Error("Invalid listen")}call(I,f,u,y=L.CancellationToken.None){switch(f){case"request":return this.service.request(u[0],y).then(async({res:b,stream:w})=>{const l=await(0,C.streamToBuffer)(w);return[{statusCode:b.statusCode,headers:b.headers},l]});case"resolveProxy":return this.service.resolveProxy(u[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=r;class O{constructor(I){this.channel=I}async request(I,f){const[u,y]=await this.channel.call("request",[I],f);return{res:u,stream:(0,C.bufferToStream)(y)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=O}),define(se[245],oe([0,1,246,12]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function r(D,I){return D.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:D.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function O(D,I,f={}){const u=(0,C.parse)(D),y=f.proxyUrl||r(u,I);if(!y)return null;const b=(0,C.parse)(y);if(!/^https?:$/.test(b.protocol||""))return null;const w={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((l,S)=>{V(["http-proxy-agent"],l,S)})).HttpProxyAgent(y,w):new(await new Promise((l,S)=>{V(["https-proxy-agent"],l,S)})).HttpsProxyAgent(y,w)}e.getProxyAgent=O}),define(se[247],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(se[94],oe([0,1,48,9,184,22,50,14,4,32,108,64,8,140]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let S;async function p(g,d,a,P){return a["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(P)&&!a["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(P)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=w.Promises.withAsyncBody(async(h,i)=>{const o=new O.CancellationTokenSource;let s=1e4;const t=g.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(s=(0,l.clamp)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,r.localize)(0,null)))},s);try{h(await m(d,o.token))}catch(c){!(0,I.isCancellationError)(c)&&!o.token.isCancellationRequested?i(new Error((0,r.localize)(1,null,(0,D.toErrorMessage)(c)))):h({})}finally{clearTimeout(n),o.dispose()}})),S)}e.getResolvedShellEnv=p;async function m(g,d){const a=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",a);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",P);const h=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(h+"({.*})"+h),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const s=await(0,y.getSystemShell)(f.OS,o);return g.trace("getUnixShellEnvironment#shell",s),new Promise((t,n)=>{if(d.isCancellationRequested)return n(new I.CancellationError);const c=(0,L.basename)(s);let v,R;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(v=`& '${process.execPath}' ${k} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,R=["-Login","-Command"]):c==="nu"?(v=`^'${process.execPath}' ${k} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,R=["-i","-l","-c"]):(v=`'${process.execPath}' ${k} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,c==="tcsh"||c==="csh"?R=["-ic"]:R=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),v);const E=(0,C.spawn)(s,[...R,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(E.kill(),n(new I.CancellationError))),E.on("error",T=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(T)),n(T)});const M=[];E.stdout.on("data",T=>M.push(T));const _=[];E.stderr.on("data",T=>_.push(T)),E.on("close",(T,U)=>{const X=Buffer.concat(M).toString("utf8");g.trace("getUnixShellEnvironment#raw",X);const Y=Buffer.concat(_).toString("utf8");if(Y.trim()&&g.trace("getUnixShellEnvironment#stderr",Y),T||U)return n(new Error((0,r.localize)(2,null,T,U)));const le=i.exec(X),ce=le?le[1]:"{}";try{const ue=JSON.parse(ce);a?ue.ELECTRON_RUN_AS_NODE=a:delete ue.ELECTRON_RUN_AS_NODE,P?ue.ELECTRON_NO_ATTACH_CONSOLE=P:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),t(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(ue)),n(ue)}})})}}),define(se[248],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class C{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(r){try{const O=await this.getValidator();if(O){const D=String(C._nextId++);return this.validators.set(D,O),{id:D,data:O.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,O){if(!r.id)return!0;const D=this.validators.get(r.id);if(!D)return!1;this.validators.delete(r.id);try{return D.validate(O)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(r){try{return await this.signValue(r)}catch{}return r}}e.AbstractSignService=C}),define(se[95],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,C.createDecorator)(e.SIGN_SERVICE_ID)}),define(se[249],oe([0,1,248]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L extends C.AbstractSignService{getValidator(){return this.vsda().then(O=>new O.validator)}signValue(O){return this.vsda().then(D=>new D.signer().sign(O))}vsda(){return new Promise((O,D)=>V(["vsda"],O,D))}}e.SignService=L}),define(se[34],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,C.createDecorator)("stateReadService"),e.IStateService=(0,C.createDecorator)("stateService")}),define(se[121],oe([0,1,8,18,2,12,37,16,5]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var u;(function(l){l[l.IMMEDIATE=0]="IMMEDIATE",l[l.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class y extends r.Disposable{constructor(S,p,m,g){super(),this.storagePath=S,this.saveStrategy=p,this.logService=m,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new C.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,p){const m=this.storage[S];return(0,O.isUndefinedOrNull)(m)?p:m}setItem(S,p){this.setItems([{key:S,data:p}])}setItems(S){let p=!1;for(const{key:m,data:g}of S)this.storage[m]!==g&&((0,O.isUndefinedOrNull)(g)?(0,O.isUndefined)(this.storage[m])||(this.storage[m]=void 0,p=!0):(this.storage[m]=g,p=!0));p&&this.save()}removeItem(S){(0,O.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(S),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=S}catch(p){this.logService.error(p)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let b=class extends r.Disposable{constructor(S,p,m,g){super(),this.fileStorage=this._register(new y(p.stateResource,S,m,g))}async init(){await this.fileStorage.init()}getItem(S,p){return this.fileStorage.getItem(S,p)}};e.StateReadonlyService=b,e.StateReadonlyService=b=Ee([ne(1,D.IEnvironmentService),ne(2,f.ILogService),ne(3,I.IFileService)],b);class w extends b{setItem(S,p){this.fileStorage.setItem(S,p)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}}e.StateService=w}),define(se[122],oe([0,1,4,35,32]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(f){if(C.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,u,y,b,w,l,S,p,m){const g=Object.create(null);g["common.machineId"]=l,g["common.sqmId"]=S,g.sessionID=(0,r.generateUuid)()+Date.now(),g.commitHash=b,g.version=w,g["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,C.PlatformToString)(C.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=y,g["common.product"]=m||"desktop",p&&(g["common.msftInternal"]=p);let d=0;const a=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),C.isLinuxSnap&&(g["common.snap"]="true");const P=O(u);return P&&(g["common.platformDetail"]=P),g}e.resolveCommonProperties=D;function I(f){const u=L.env.USERDNSDOMAIN;if(!u)return!1;const y=u.toLowerCase();return f.some(b=>y===b)}e.verifyMicrosoftInternalDomain=I}),define(se[28],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var r;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(se[250],oe([0,1,26,8,44,13,9,4,7,88,21,107,91,16,27,28]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function g(i,o){const s=`${i}::${o.join(":")}`,t=m.get(s);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,v=new Map,R=2e4;function k(M,_,T,U){const X=_.substring(M.length+1);return L.Promises.withAsyncBody(async Y=>{let le;try{le=await y.Promises.readdir(_,{withFileTypes:!0})}catch{Y();return}if(U.count>=R){U.count+=le.length,U.maxReached=!0,Y();return}let ce=le.length;if(ce===0){Y();return}let ue=le;U.count+le.length>R&&(U.maxReached=!0,ce=R-U.count,ue=le.slice(0,ce)),U.count+=le.length;for(const Q of ue)if(Q.isDirectory()){if(T.includes(Q.name)||await k(M,(0,D.join)(_,Q.name),T,U),--ce===0){Y();return}}else{const G=Q.name.lastIndexOf(".");if(G>=0){const x=Q.name.substring(G+1);x&&c.set(x,(c.get(x)??0)+1)}for(const x of n)x.relativePathPattern?.test(X)!==!1&&x.filePattern.test(Q.name)&&v.set(x.tag,(v.get(x.tag)??0)+1);if(--ce===0){Y();return}}})}const E=L.Promises.withAsyncBody(async M=>{const _={count:0,maxReached:!1};await k(i,i,o,_);const T=await P(i);M({configFiles:d(v),fileTypes:d(c),fileCount:_.count,maxFilesReached:_.maxReached,launchConfigFiles:T})});return m.set(s,E),E}e.collectWorkspaceStats=g;function d(i){return Array.from(i.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function a(){const i={os:`${C.type()} ${C.arch()} ${C.release()}`,memory:`${(C.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.virtualMachineHint.value()*100)}%`},o=C.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.getMachineInfo=a;async function P(i){try{const o=new Map,s=(0,D.join)(i,".vscode","launch.json"),t=await y.Promises.readFile(s),n=[],c=(0,r.parse)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${s}`),[];if((0,r.getNodeType)(c)==="object"&&c.configurations)for(const v of c.configurations){const R=v.type;R&&(o.has(R)?o.set(R,o.get(R)+1):o.set(R,1))}return d(o)}catch{return[]}}e.collectLaunchConfigs=P;let h=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${C.type()} ${C.arch()} ${C.release()}`);const t=C.cpus();return t&&t.length>0&&s.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),s.push(`Memory (System):  ${(C.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(C.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||s.push(`Load (avg):       ${C.loadavg().map(n=>Math.round(n)).join(", ")}`),s.push(`VM:               ${Math.round(u.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,b.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async t=>{let[n,c]=t,v=this.formatProcessList(o,n);return s.forEach(R=>{if((0,w.isRemoteDiagnosticError)(R))v+=`
${R.errorMessage}`,c+=`
${R.errorMessage}`;else if(v+=`

Remote: ${R.hostName}`,R.processes&&(v+=`
${this.formatProcessList(o,R.processes)}`),R.workspaceMetadata){c+=`
|  Remote: ${R.hostName}`;for(const k of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[k];let M=`${E.fileCount} files`;E.maxFilesReached&&(M=`more than ${M}`),c+=`|    Folder (${k}): ${M}`,c+=this.formatWorkspaceStats(E)}}}),{processInfo:v,workspaceInfo:c}})}async getSystemInfo(o,s){const{memory:t,vmHint:n,os:c,cpus:v}=a(),R={os:c,memory:t,cpus:v,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return I.isWindows||(R.load=`${C.loadavg().map(k=>Math.round(k)).join(", ")}`),I.isLinux&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(o,s){const t=[];return(0,b.listProcesses)(o.mainPID).then(async n=>(t.push(""),t.push(this.formatEnvironment(o)),t.push(""),t.push(this.formatProcessList(o,n)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(o))),s.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))t.push(`
${c.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${c.hostName}`),t.push(this.formatMachineInfo(c.machineInfo)),c.processes&&t.push(this.formatProcessList(o,c.processes)),c.workspaceMetadata)for(const v of Object.keys(c.workspaceMetadata)){const R=c.workspaceMetadata[v];let k=`${R.fileCount} files`;R.maxFilesReached&&(k=`more than ${k}`),t.push(`Folder (${v}): ${k}`),t.push(this.formatWorkspaceStats(R))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(o){const s=[];let n=0;const c=(E,M)=>{const _=` ${E}(${M})`;n+_.length>60?(s.push(v),v="|                 ",n=v.length):n+=_.length,v+=_};let v="|      File types:";const R=10,k=o.fileTypes.length>R?R:o.fileTypes.length;for(let E=0;E<k;E++){const M=o.fileTypes[E];c(M.name,M.count)}if(s.push(v),o.configFiles.length>=0&&(v="|      Conf files:",n=0,o.configFiles.forEach(E=>{c(E.name,E.count)}),s.push(v)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(M=>{const _=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;E+=_}),s.push(E)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(s-t.length)}  ${o[t]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(s.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const v=f.URI.revive(c);if(v.scheme===O.Schemas.file){const R=v.fsPath;t.push(g(R,["node_modules",".git"]).then(k=>{let E=`${k.fileCount} files`;k.maxFilesReached&&(E=`more than ${E}`),s.push(`|    Folder (${(0,D.basename)(R)}): ${E}`),s.push(this.formatWorkspaceStats(k))}).catch(k=>{s.push(`|      Error: Unable to collect workspace stats for folder ${R} (${k.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>s.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}formatProcessList(o,s){const t=new Map;o.windows.forEach(c=>t.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:v})=>t.set(c,v));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,t,n,s,0),n.join(`
`)}formatProcessItem(o,s,t,n,c){const v=c===0;let R;v?R=n.pid===o?`${this.productService.applicationName} main`:"remote agent":s.has(n.pid)?R=s.get(n.pid):R=`${"  ".repeat(c)} ${n.name}`;const k=process.platform==="win32"?n.mem:C.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(k/l.ByteSize.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(n.children)&&n.children.forEach(E=>this.formatProcessItem(o,s,t,E,c+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:t}of o.folders){const n=f.URI.revive(t);if(n.scheme!==O.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(R=>s.add(R.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const t=f.URI.revive(s);if(t.scheme!==O.Schemas.file)continue;const n=t.fsPath;try{const c=await g(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:v.name,count:v.count})}),c.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:v.name,count:v.count})}),c.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};e.DiagnosticsService=h,e.DiagnosticsService=h=Ee([ne(0,p.ITelemetryService),ne(1,S.IProductService)],h)}),define(se[251],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class C{constructor(O){this.appenders=O}listen(O,D){throw new Error(`Event not found: ${D}`)}call(O,D,{eventName:I,data:f}){return this.appenders.forEach(u=>u.log(I,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=C;class L{constructor(O){this.channel=O}log(O,D){return this.channel.call("log",{eventName:O,data:D}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(se[52],oe([0,1,38,12,3,17,59,122,28]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class u{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=u;class y{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class b{async publicLog(n,c,v){}async publicLogError(n,c,v){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(t,n){return r.Event.debounce(n.onDidChangeConfiguration,(v,R)=>{const k=v?new Set([...v.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:k}},1e3,!0)(v=>{v.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.configurationTelemetry=w;function l(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.supportsTelemetry=l;function S(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.isLoggingOnly=S;function p(t){const n=t.getValue(f.TELEMETRY_SETTING_ID),c=t.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function m(t){const n={},c={},v={};a(t,v);for(let R in v){R=R.length>150?R.substr(R.length-149):R;const k=v[R];typeof k=="number"?c[R]=k:typeof k=="boolean"?c[R]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${k.length}`),n[R]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(n[R]=k)}return{properties:n,measurements:c}}e.validateTelemetryData=m;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const n=(0,D.getRemoteName)(t);return g.has(n)?n:"other"}e.cleanRemoteAuthority=d;function a(t,n,c=0,v){if(t)for(const R of Object.getOwnPropertyNames(t)){const k=t[R],E=v?v+R:R;Array.isArray(k)?n[E]=(0,C.safeStringify)(k):k instanceof Date?n[E]=k.toISOString():(0,L.isObject)(k)?c<2?a(k,n,c+1,E+"."):n[E]=(0,C.safeStringify)(k):n[E]=k}}function P(t,n){const c=t.msftInternalDomains||[],v=n.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(c)||v}e.isInternalTelemetry=P;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=h;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const v=[];for(const M of n)for(;;){const _=M.exec(t);if(!_)break;v.push([_.index,M.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(c="";;){const M=k.exec(t);if(!M)break;const _=v.some(([T,U])=>M.index<U&&T<k.lastIndex);!R.test(M[0])&&!_&&(c+=t.substring(E,M.index)+"<REDACTED: user-file-path>",E=k.lastIndex)}return E<t.length&&(c+=t.substr(E)),c}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of n)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function s(t,n){return(0,C.cloneAndChange)(t,c=>{if(c instanceof u||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let v=c.replaceAll("%20"," ");v=i(v,n);for(const R of n)v=v.replace(R,"");return v=o(v),v}})}e.cleanData=s}),define(se[123],oe([0,1,25,117,120,4,7,14,35,52]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,C.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=y;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const n=t.manifest?t.manifest.version:t.version,c=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,n,c)}static parse(t){const n=b.exec(t);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?y(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const t=l.exec(s);return t&&t[1]?[m(t[1]),t[2]]:[m(s),void 0]}e.getIdAndVersion=S;function p(s,t){return`${s}.${t}`}e.getExtensionId=p;function m(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=m;function g(s,t){return m(p(s??r.UNDEFINED_PUBLISHER,t))}e.getGalleryExtensionId=g;function d(s,t){const n=[],c=v=>{for(const R of n)if(R.some(k=>y(t(k),t(v))))return R;return null};for(const v of s){const R=c(v);R?R.push(v):n.push([v])}return n}e.groupByExtension=d;function a(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=a;function P(s){return{id:new u.TelemetryTrustedValue(s.identifier.id),name:new u.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function h(s,t){const n=[],c=t.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const v=c.shift();if(v&&n.every(R=>!y(R.identifier,{id:v}))){const R=s.filter(k=>y(k.identifier,{id:v}));R.length===1&&(n.push(R[0]),c.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=h;async function i(s,t){if(!O.isLinux)return!1;let n;try{n=(await s.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(v))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,t){const n=await i(s,t),c=(0,L.getTargetPlatform)(n?"alpine":O.platform,f.arch);return t.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=o}),define(se[252],oe([0,1,206,52]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function r(O,D,I,f,u,y,b){const w={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${D.nameShort})`};if((0,L.supportsTelemetry)(D,I)&&(0,L.getTelemetryLevel)(f)===3){const l=await(0,C.getServiceMachineId)(I,u,y);w["X-Market-User-Id"]=l,w["VSCode-SessionId"]=b.machineId||l}return w}e.resolveMarketplaceHeaders=r}),define(se[253],oe([0,1,2,38,4,25,185,17,58,79,27,43,28,52]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,d,a){this._configurationService=d,this._productService=a,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(P),"gi")),P.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(P.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(P=>{(P.affectsConfiguration(w.TELEMETRY_SETTING_ID)||P.affectsConfiguration(w.TELEMETRY_OLD_SETTING_ID)||P.affectsConfiguration(w.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(g,d){this._experimentProperties[g]=d}_updateTelemetryLevel(){let g=(0,l.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const a=d.usage?3:d.error?2:0;g=Math.min(g,a)}this._telemetryLevel=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(g,d,a){this._telemetryLevel<d||(a=(0,L.mixin)(a,this._experimentProperties),a=(0,l.cleanData)(a,this._cleanupPatterns),a=(0,L.mixin)(a,this._commonProperties),this._appenders.forEach(P=>P.log(g,a)))}publicLog(g,d){this._log(g,3,d)}publicLog2(g,d){this.publicLog(g,d)}publicLogError(g,d){this._sendErrorTelemetry&&this._log(g,2,d)}publicLogError2(g,d){this.publicLogError(g,d)}};e.TelemetryService=S,e.TelemetryService=S=Ee([ne(1,I.IConfigurationService),ne(2,y.IProductService)],S);function p(){const m=(0,D.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=r.isWeb?"":(0,D.localize)(3,null),a=(0,D.localize)(4,null),P=(0,D.localize)(5,null),h=(0,D.localize)(6,null),i=(0,D.localize)(7,null),o=`
|       | ${a} | ${P} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,D.localize)(8,null);return`
${m} ${g} ${d}

&nbsp;

${i}
${o}

&nbsp;

${s}
`}b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:p(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(f.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,D.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,D.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[254],oe([0,1,4,88,28]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function O(I,f){let u=I.getItem(r.machineIdKey);return(typeof u!="string"||C.isMacintosh&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,L.getMachineId)(f.error.bind(f))),u}e.resolveMachineId=O;async function D(I,f){let u=I.getItem(r.sqmIdKey);return typeof u!="string"&&(u=await(0,L.getSqmMachineId)(f.error.bind(f))),u}e.resolveSqmId=D}),define(se[255],oe([0,1,28,254]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function r(D,I){const f=await(0,L.resolveMachineId)(D,I);return D.setItem(C.machineIdKey,f),f}e.resolveMachineId=r;async function O(D,I){const f=await(0,L.resolveSqmId)(D,I);return D.setItem(C.sqmIdKey,f),f}e.resolveSqmId=O}),define(se[124],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var C;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(C||(e.EnvironmentVariableMutatorType=C={}))}),define(se[256],oe([0,1,4,124]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const r=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(y){this.collections=y,this.map=new Map,this.descriptionMap=new Map,y.forEach((b,w)=>{this.populateDescriptionMap(b,w);const l=b.map.entries();let S=l.next();for(;!S.done;){const p=S.value[1],m=S.value[0];let g=this.map.get(m);if(g||(g=[],this.map.set(m,g)),g.length>0&&g[0].type===L.EnvironmentVariableMutatorType.Replace){S=l.next();continue}const d={extensionIdentifier:w,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};d.scope||delete d.scope,g.unshift(d),S=l.next()}})}async applyToProcessEnvironment(y,b,w){let l;C.isWindows&&(l={},Object.keys(y).forEach(S=>l[S.toLowerCase()]=S));for(const[S,p]of this.getVariableMap(b)){const m=C.isWindows&&l[S.toLowerCase()]||S;for(const g of p){const d=w?await w(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case L.EnvironmentVariableMutatorType.Append:y[m]=(y[m]||"")+d;break;case L.EnvironmentVariableMutatorType.Prepend:y[m]=d+(y[m]||"");break;case L.EnvironmentVariableMutatorType.Replace:y[m]=d;break}if(g.options?.applyAtShellIntegration??!1){const a=`VSCODE_ENV_${r.get(g.type)}`;y[a]=(y[a]?y[a]+":":"")+S+"="+this._encodeColons(d)}}}}_encodeColons(y){return y.replaceAll(":","\\x3a")}diff(y,b){const w=new Map,l=new Map,S=new Map;if(y.getVariableMap(b).forEach((p,m)=>{const g=this.getVariableMap(b).get(m),d=I(p,g);d&&w.set(m,d)}),this.getVariableMap(b).forEach((p,m)=>{const g=y.getVariableMap(b).get(m),d=I(p,g);d&&S.set(m,d)}),this.getVariableMap(b).forEach((p,m)=>{const g=y.getVariableMap(b).get(m),d=f(p,g);d&&l.set(m,d)}),!(w.size===0&&l.size===0&&S.size===0))return{added:w,changed:l,removed:S}}getVariableMap(y){const b=new Map;for(const w of this.map.values()){const l=w.filter(S=>D(S,y));l.length>0&&b.set(l[0].variable,l)}return b}getDescriptionMap(y){const b=new Map;for(const w of this.descriptionMap.values()){const l=w.filter(S=>D(S,y,!0));for(const S of l)b.set(S.extensionIdentifier,S.description)}return b}populateDescriptionMap(y,b){if(!y.descriptionMap)return;const w=y.descriptionMap.entries();let l=w.next();for(;!l.done;){const S=l.value[1],p=l.value[0];let m=this.descriptionMap.get(p);m||(m=[],this.descriptionMap.set(p,m));const g={extensionIdentifier:b,scope:S.scope,description:S.description};g.scope||delete g.scope,m.push(g),l=w.next()}}}e.MergedEnvironmentVariableCollection=O;function D(u,y,b=!1){return u.scope?!!(u.scope.workspaceFolder&&y?.workspaceFolder&&u.scope.workspaceFolder.index===y.workspaceFolder.index):b?y===u.scope:!0}function I(u,y){if(!y)return u;const b=new Set;y.forEach(l=>b.add(l.extensionIdentifier));const w=[];return u.forEach(l=>{b.has(l.extensionIdentifier)||w.push(l)}),w.length===0?void 0:w}function f(u,y){if(!y)return;const b=new Map;y.forEach(l=>b.set(l.extensionIdentifier,l));const w=[];return u.forEach(l=>{const S=b.get(l.extensionIdentifier);S&&(l.type!==S.type||l.value!==S.value||l.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index)&&w.push(S)}),w.length===0?void 0:w}}),define(se[257],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function C(f){return[...f.entries()]}e.serializeEnvironmentVariableCollection=C;function L(f){return f?[...f.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function r(f){return new Map(f)}e.deserializeEnvironmentVariableCollection=r;function O(f){return new Map(f??[])}e.deserializeEnvironmentDescriptionMap=O;function D(f){return Array.from(f.entries()).map(u=>[u[0],C(u[1].map),L(u[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=D;function I(f){return new Map(f.map(u=>[u[0],{map:r(u[1]),descriptionMap:O(u[2])}]))}e.deserializeEnvironmentVariableCollections=I}),define(se[258],oe([0,1,8,22,3,2,5]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends O.Disposable{constructor(u,y){super(),this._logService=y,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new r.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=u===void 0?15e3:u,this._register((0,O.toDisposable)(()=>{for(const b of this._pendingRequestDisposables.values())(0,O.dispose)(b)}))}createRequest(u){return new Promise((y,b)=>{const w=++this._lastRequestId;this._pendingRequests.set(w,y),this._onCreateRequest.fire({requestId:w,...u});const l=new L.CancellationTokenSource;(0,C.timeout)(this._timeout,l.token).then(()=>b(`Request ${w} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(w,[(0,O.toDisposable)(()=>l.cancel())])})}acceptReply(u,y){const b=this._pendingRequests.get(u);b?(this._pendingRequests.delete(u),(0,O.dispose)(this._pendingRequestDisposables.get(u)||[]),this._pendingRequestDisposables.delete(u),b(y)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.RequestStore=I,e.RequestStore=I=Ee([ne(1,D.ILogService)],I)}),define(se[125],oe([0,1,6,114,43]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var D;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",h.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",h.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var I;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(I||(e.PosixShellType=I={}));var f;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var u;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var y;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var b;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.IPtyService=(0,C.createDecorator)("ptyService");var w;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var l;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(l||(e.TerminalLocation=l={}));var S;(function(h){h.TerminalView="view",h.Editor="editor"})(S||(e.TerminalLocationString=S={}));var p;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var m;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var g;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var d;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var a;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class P{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(i){const o=this._sanitizeRemoteAuthority(i.remoteAuthority);if(this._backends.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this._backends.set(o,i)}getTerminalBackend(i){return this._backends.get(this._sanitizeRemoteAuthority(i))}_sanitizeRemoteAuthority(i){return i?.toLowerCase()??""}}r.Registry.add(e.TerminalExtensions.Backend,new P),e.ILocalPtyService=(0,C.createDecorator)("localPtyService"),e.ITerminalLogService=(0,C.createDecorator)("terminalLogService")}),define(se[259],oe([0,1,75,7,187,102]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function D(w,l){const S=[{name:null,description:(0,r.localize)(0,null)}];return S.push(...w.map(p=>({name:p.profileName,description:I(p)}))),l&&S.push(...l.map(p=>({name:p.title,description:f(p)}))),{values:S.map(p=>p.name),markdownDescriptions:S.map(p=>p.description)}}e.createProfileSchemaEnums=D;function I(w){let l=`$(${O.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:C.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?l+=`
- args: "${w.args}"`:l+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(l+=`
- overrideName: ${w.overrideName}`),w.color&&(l+=`
- color: ${w.color}`),w.env&&(l+=`
- env: ${JSON.stringify(w.env)}`),l}function f(w){return`$(${O.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:C.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function u(w,l){if(!w&&!l)return!0;if(typeof w=="string"&&typeof l=="string")return w===l;if(Array.isArray(w)&&Array.isArray(l)){if(w.length!==l.length)return!1;for(let S=0;S<w.length;S++)if(w[S]!==l[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=u;function y(w,l){if(!w&&!l)return!0;if(!w||!l)return!1;if(O.ThemeIcon.isThemeIcon(w)&&O.ThemeIcon.isThemeIcon(l))return w.id===l.id&&w.color===l.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof l=="object"&&"light"in l&&"dark"in l){const S=w,p=l;if((L.URI.isUri(S.light)||b(S.light))&&(L.URI.isUri(S.dark)||b(S.dark))&&(L.URI.isUri(p.light)||b(p.light))&&(L.URI.isUri(p.dark)||b(p.dark)))return S.light.path===p.light.path&&S.dark.path===p.dark.path}if(L.URI.isUri(w)&&L.URI.isUri(l)||b(w)||b(l)){const S=w,p=l;return S.path===p.path&&S.scheme===p.scheme}return!1}e.terminalIconsEqual=y;function b(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=b}),define(se[260],oe([0,1,75,4,186,58,43,259]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,C.getAllCodicons)(),m=>m.id),markdownEnumDescriptions:Array.from((0,C.getAllCodicons)(),m=>`$(${m.id})`)};const f={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},y={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function b(m){const g=m===2?"linux":m===1?"osx":"windows";return(0,r.localize)(7,null,(0,L.PlatformToString)(m),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){D.Registry.as(O.Extensions.Configuration).registerConfiguration(w),p()}e.registerTerminalPlatformConfiguration=l;let S;function p(m,g){const d=D.Registry.as(O.Extensions.Configuration);let a;m&&(a=(0,I.createProfileSchemaEnums)(m?.profiles,g));const P=S;S={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:m?.os===3?a?.values:void 0,markdownEnumDescriptions:m?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:m?.os===2?a?.values:void 0,markdownEnumDescriptions:m?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:m?.os===1?a?.values:void 0,markdownEnumDescriptions:m?.os===1?a?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[S],remove:P?[P]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(se[261],oe([0,1,26,13,38,9,4,35,25,12,21,124,257,256]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function S(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(C.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.getWindowsBuildNumber=S;async function p(t,n,c,v=I.env,R=y.Promises.exists){if(O.isAbsolute(t))return await R(t)?t:void 0;if(n===void 0&&(n=I.cwd()),O.dirname(t)!=="."){const _=O.join(n,t);return await R(_)?_:void 0}const E=(0,r.getCaseInsensitive)(v,"PATH");if(c===void 0&&(0,u.isString)(E)&&(c=E.split(O.delimiter)),c===void 0||c.length===0){const _=O.join(n,t);return await R(_)?_:void 0}for(const _ of c){let T;if(O.isAbsolute(_)?T=O.join(_,t):T=O.join(n,_,t),await R(T))return T;if(D.isWindows){let U=T+".com";if(await R(U)||(U=T+".exe",await R(U)))return U}}const M=O.join(n,t);return await R(M)?M:void 0}e.findExecutable=p;function m(t,n,c,v,R){const k=D.isWindows&&(!n.windowsEnableConpty||S()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||k)return;const E=t.args,M=I.platform==="win32"?O.basename(t.executable).toLowerCase():O.basename(t.executable),_=O.dirname(L.FileAccess.asFileUri("").fsPath);let T;const U={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(U.VSCODE_NONCE=n.shellIntegration.nonce),D.isWindows){if(M==="pwsh.exe"||M==="powershell.exe")return!E||o(E)?T=a.get(d.WindowsPwsh):i(E)&&(T=a.get(d.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.format)(T[T.length-1],_,""),{newArgs:T,envMixin:U}):void 0;v.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(M){case"bash":return!E||E.length===0?T=a.get(d.Bash):s(E)&&(U.VSCODE_SHELL_LOGIN="1",g(n,U),T=a.get(d.Bash)),T?(T=[...T],T[T.length-1]=(0,f.format)(T[T.length-1],_),{newArgs:T,envMixin:U}):void 0;case"fish":{const X=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Y=O.join(_,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${X}:${Y}`,g(n,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!E||o(E)?T=a.get(d.Pwsh):i(E)&&(T=a.get(d.PwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.format)(T[T.length-1],_,""),{newArgs:T,envMixin:U}):void 0;case"zsh":{if(!E||E.length===0?T=a.get(d.Zsh):s(E)?(T=a.get(d.ZshLogin),g(n,U)):(E===a.get(d.Zsh)||E===a.get(d.ZshLogin))&&(T=E),!T)return;T=[...T],T[T.length-1]=(0,f.format)(T[T.length-1],_);let X;try{X=C.userInfo().username}catch{X="unknown"}const Y=O.join(C.tmpdir(),`${X}-${R.applicationName}-zsh`);U.ZDOTDIR=Y;const le=c?.ZDOTDIR??C.homedir()??"~";U.USER_ZDOTDIR=le;const ce=[];return ce.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(Y,".zshrc")}),ce.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(Y,".zprofile")}),ce.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(Y,".zshenv")}),ce.push({source:O.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(Y,".zlogin")}),{newArgs:T,envMixin:U,filesToCopy:ce}}}v.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.getShellIntegrationInjection=m;function g(t,n){if(D.isMacintosh&&t.environmentVariableCollections){const c=(0,w.deserializeEnvironmentVariableCollections)(t.environmentVariableCollections),R=new l.MergedEnvironmentVariableCollection(c).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),k=[];if(R)for(const E of R)E.type===b.EnvironmentVariableMutatorType.Prepend&&k.push(E.value);k.length>0&&(n.VSCODE_PATH_PREFIX=k.join(""))}}var d;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(d||(d={}));const a=new Map;a.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),a.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),a.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),a.set(d.Zsh,["-i"]),a.set(d.ZshLogin,["-il"]),a.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const P=["-login","-l"],h=["-nol","-nologo"];function i(t){return typeof t=="string"?P.includes(t.toLowerCase()):t.length===1&&P.includes(t[0].toLowerCase())||t.length===2&&(P.includes(t[0].toLowerCase())||P.includes(t[1].toLowerCase()))&&(h.includes(t[0].toLowerCase())||h.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?h.includes(t.toLowerCase()):t.length===0||t?.length===1&&h.includes(t[0].toLowerCase())}function s(t){return t==="string"&&P.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&P.includes(t[0].toLowerCase())}}),define(se[262],oe([0,1,48,75,9,4,12,21,106,261,113]),function(V,e,C,L,r,O,D,I,f,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;var b;(function(c){c.UnixShellsPath="/etc/shells"})(b||(b={}));let w,l=!0;function S(c,v,R,k,E=process.env,M,_,T,U){return M=M||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},O.isWindows?p(R,M,E,_,k.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:k.getValue("terminal.integrated.profiles.windows"),typeof v=="string"?v:k.getValue("terminal.integrated.defaultProfile.windows"),U,T):s(M,_,R,c&&typeof c=="object"?{...c}:k.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof v=="string"?v:k.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,T,E)}e.detectAvailableProfiles=S;async function p(c,v,R,k,E,M,_,T,U){const X=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=`${process.env.windir}\\${X?"Sysnative":"System32"}`;let le=!1;(0,u.getWindowsBuildNumber)()>=16299&&(le=!0),await a(T);const ce=new Map;if(c){ce.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${Y}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ce.set("Command Prompt",{path:`${Y}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${Y}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}t(M,ce);const ue=await m(ce.entries(),_,v,R,k,U);if(c&&E)try{const Q=await i(`${Y}\\${le?"wsl":"bash"}.exe`,_);for(const G of Q)(!M||!(G.profileName in M))&&ue.push(G)}catch{l&&(k?.info("WSL is not installed, so could not detect WSL profiles"),l=!1)}return ue}async function m(c,v,R,k=process.env,E,M){const _=[];for(const[T,U]of c)_.push(g(T,U,v,R,k,E,M));return(await Promise.all(_)).filter(T=>!!T)}async function g(c,v,R,k,E=process.env,M,_){if(v===null)return;let T,U,X;if("source"in v&&!("path"in v)){const ue=w?.get(v.source);if(!ue)return;T=ue.paths,U=v.args||ue.args,v.icon?X=d(v.icon):ue.icon&&(X=ue.icon)}else T=Array.isArray(v.path)?v.path:[v.path],U=O.isWindows||Array.isArray(v.args)?v.args:void 0,X=d(v.icon);let Y;if(_){const ue=T.map(G=>typeof G=="string"?G:G.path),Q=await _(ue);Y=new Array(T.length);for(let G=0;G<T.length;G++)typeof T[G]=="string"?Y[G]=Q[G]:Y[G]={path:Q[G],isUnsafe:!0}}else Y=T.slice();let le;if(v.requiresPath){let ue;if((0,D.isString)(v.requiresPath)?ue=v.requiresPath:(ue=v.requiresPath.path,v.requiresPath.isUnsafe&&(le=ue)),!await k.existsFile(ue))return}const ce=await n(c,R,Y,k,E,U,v.env,v.overrideName,v.isAutoDetected,le);if(!ce){M?.debug("Terminal profile not validated",c,T);return}return ce.isAutoDetected=v.isAutoDetected,ce.icon=X,ce.color=v.color,ce}function d(c){return typeof c=="string"?{id:c}:c}async function a(c){if(w&&!c)return;const[v,R]=await Promise.all([P(),c||h()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:v,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:R,icon:L.Codicon.terminalPowershell})}async function P(){const c=new Set,v=await(0,u.findExecutable)("git.exe");if(v){const E=(0,y.dirname)(v);c.add((0,y.resolve)(E,"../.."))}function R(E,M){M&&E.add(M)}R(c,process.env.ProgramW6432),R(c,process.env.ProgramFiles),R(c,process.env["ProgramFiles(X86)"]),R(c,`${process.env.LocalAppData}\\Program`);const k=[];for(const E of c)k.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return k.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),k.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),k}async function h(){const c=[];for await(const v of(0,f.enumeratePowerShellInstallations)())c.push(v.exePath);return c}async function i(c,v){const R=[],k=await new Promise((_,T)=>{C.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,X)=>{if(U)return T("Problem occurred when getting wsl distros");_(X)})});if(!k)return[];const E=new RegExp(/[\r?\n]/),M=k.split(E).filter(_=>_.trim().length>0&&_!=="");for(const _ of M){if(_===""||_.startsWith("docker-desktop"))continue;const T=`${_} (WSL)`,U={profileName:T,path:c,args:["-d",`${_}`],isDefault:T===v,icon:o(_),isAutoDetected:!1};R.push(U)}return R}function o(c){return c.includes("Ubuntu")?L.Codicon.terminalUbuntu:c.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function s(c,v,R,k,E,M,_,T){const U=new Map;if(R&&await c.existsFile("/etc/shells")){const X=(await c.readFile("/etc/shells")).toString(),Y=(M||X.split(`
`)).map(ce=>{const ue=ce.indexOf("#");return ue===-1?ce:ce.substring(0,ue)}).filter(ce=>ce.trim().length>0),le=new Map;for(const ce of Y){let ue=(0,r.basename)(ce),Q=le.get(ue)||0;Q++,Q>1&&(ue=`${ue} (${Q})`),le.set(ue,Q),U.set(ue,{path:ce,isAutoDetected:!0})}}return t(k,U),await m(U.entries(),E,c,T,v,_)}function t(c,v){if(c)for(const[R,k]of Object.entries(c))k===null||typeof k!="object"||!("path"in k)&&!("source"in k)?v.delete(R):(k.icon=k.icon||v.get(R)?.icon,v.set(R,k))}async function n(c,v,R,k,E,M,_,T,U,X){if(R.length===0)return Promise.resolve(void 0);const Y=R.shift();if(Y==="")return n(c,v,R,k,E,M,_,T,U);const le=typeof Y!="string"&&Y.isUnsafe,ce=typeof Y=="string"?Y:Y.path,ue={profileName:c,path:ce,args:M,env:_,overrideName:T,isAutoDetected:U,isDefault:c===v,isUnsafePath:le,requiresUnsafePath:X};if((0,r.basename)(ce)===ce){const G=E.PATH?E.PATH.split(r.delimiter):void 0,x=await(0,u.findExecutable)(ce,void 0,G,void 0,k.existsFile);return x?(ue.path=x,ue.isFromPath=!0,ue):n(c,v,R,k,E,M)}return await k.existsFile((0,r.normalize)(ce))?ue:n(c,v,R,k,E,M,_,T,U)}}),define(se[263],oe([0,1,3,2,4,42,17,5,226,94,258,125,260,262,108,73]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let g=class extends L.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(a,P,h,i){super(),this._ptyHostStarter=a,this._configurationService=P,this._logService=h,this._loggerService=i,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new C.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new C.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new C.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new C.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new C.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new C.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new C.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new C.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new C.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new C.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new C.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new C.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&C.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(r.isWindows)return process.env;try{return await(0,u.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a=this._ptyHostStarter.start(),P=a.client;this._logService.getLevel()===I.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(P.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(a.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=O.ProxyChannel.toService(P.getChannel(b.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(o=>this._onProcessData.fire(o))),this._register(i.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(i.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(i.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(i.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(i.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(i.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),this._register(new f.RemoteLoggerChannelClient(this._loggerService,P.getChannel(b.TerminalIpcChannels.Logger))),this.__connection=a,this.__proxy=i,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[a,i]}async createProcess(a,P,h,i,o,s,t,n,c,v,R){const k=setTimeout(()=>this._handleUnresponsiveCreateProcess(),b.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(a,P,h,i,o,s,t,n,c,v,R);return clearTimeout(k),E}updateTitle(a,P,h){return this._proxy.updateTitle(a,P,h)}updateIcon(a,P,h,i){return this._proxy.updateIcon(a,P,h,i)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a,P){return this._proxy.detachFromProcess(a,P)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,P){return this._proxy.shutdown(a,P)}input(a,P){return this._proxy.input(a,P)}processBinary(a,P){return this._proxy.processBinary(a,P)}resize(a,P,h){return this._proxy.resize(a,P,h)}clearBuffer(a){return this._proxy.clearBuffer(a)}acknowledgeDataEvent(a,P){return this._proxy.acknowledgeDataEvent(a,P)}setUnicodeVersion(a,P){return this._proxy.setUnicodeVersion(a,P)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}async getLatency(){const a=new p.StopWatch,P=await this._proxy.getLatency();return a.stop(),[{label:"ptyhostservice<->ptyhost",latency:a.elapsed()},...P]}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,P){return this._proxy.installAutoReply(a,P)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._optionalProxy?.getDefaultSystemShell(a)??(0,S.getSystemShell)(a??r.OS,process.env)}async getProfiles(a,P,h,i=!1){const o=await this._resolveShellEnv();return(0,l.detectAvailableProfiles)(P,h,i,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(a,P){return this._proxy.getWslPath(a,P)}getRevivedPtyNewId(a,P){return this._proxy.getRevivedPtyNewId(a,P)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return this._optionalProxy?.getTerminalLayoutInfo(a)}async requestDetachInstance(a,P){return this._proxy.requestDetachInstance(a,P)}async acceptDetachInstanceReply(a,P){return this._proxy.acceptDetachInstanceReply(a,P)}async freePortKillProcess(a){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(a)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,P,h){return this._proxy.reviveTerminalProcesses(a,P,h)}async refreshProperty(a,P){return this._proxy.refreshProperty(a,P)}async updateProperty(a,P,h){return this._proxy.updateProperty(a,P,h)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(a){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),a?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,P){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:P})}async acceptPtyHostResolvedVariables(a,P){this._resolveVariablesRequestStore.acceptReply(a,P)}};e.PtyHostService=g,e.PtyHostService=g=Ee([ne(1,D.IConfigurationService),ne(2,I.ILogService),ne(3,I.ILoggerService)],g)}),define(se[70],oe([0,1,15,3,2,4,17,6,34]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const u="#FFFFFF",y="#1E1E1E",b="#000000",w="#FFFFFF",l="theme",S="themeBackground",p="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let m=class extends r.Disposable{constructor(d,a){super(),this.stateService=d,this.configurationService=a,this._onDidChangeColorScheme=this._register(new L.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,C.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(O.isWindows){if(C.nativeTheme.shouldUseHighContrastColors)return{dark:C.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.isMacintosh){if(C.nativeTheme.shouldUseInvertedColorScheme||C.nativeTheme.shouldUseHighContrastColors)return{dark:C.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.isLinux&&C.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:C.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return d.dark?b:w;let a=this.stateService.getItem(S,null);if(!a)switch(this.stateService.getItem(l,"vs-dark").split(" ")[0]){case"vs":a=u;break;case"hc-black":a=b;break;case"hc-light":a=w;break;default:a=y}return O.isMacintosh&&a.toUpperCase()===y&&(a="#171717"),a}saveWindowSplash(d,a){this.stateService.setItems([{key:l,data:a.baseTheme},{key:S,data:a.colorInfo.background},{key:p,data:a}]),typeof d=="number"&&this.updateBackgroundColor(d,a)}updateBackgroundColor(d,a){for(const P of C.BrowserWindow.getAllWindows())if(P.id===d){P.setBackgroundColor(a.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(p)}};e.ThemeMainService=m,e.ThemeMainService=m=Ee([ne(0,f.IStateService),ne(1,D.IConfigurationService)],m)}),define(se[126],oe([0,1,3,17,6,5]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,r.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,r.createDecorator)("sharedTunnelsService");var D;(function(m){m.Http="http",m.Https="https"})(D||(e.TunnelProtocol=D={}));var I;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(I||(e.TunnelPrivacyId=I={}));function f(m){return!!m.forwardPort}e.isTunnelProvider=f;var u;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function y(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=w;function l(m,g,d,a){if(d===1)return!1;if(d===2&&w(g)){const P=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(P?.length===4&&parseInt(P[1])>=18)return!1}return m<1024}e.isPortPrivileged=l;class S{constructor(g,d,a){this.remoteAddress=g,this.localAddress=d,this._dispose=a,this._onDispose=new C.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=S;let p=class{constructor(g,d){this.logService=g,this.configurationService=d,this._onTunnelOpened=new C.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new C.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new C.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],d=Array.from(this._tunnels.values());for(const a of d){const P=Array.from(a.values());for(const h of P){const i=await h.value;i&&typeof i!="string"&&g.push(i)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:d}of g.values())await d.then(a=>typeof a!="string"?a?.dispose():void 0);g.clear()}this._tunnels.clear()}setEnvironmentTunnel(g,d,a,P,h){this.addTunnelToMap(g,d,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:d,localAddress:a,privacy:P,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,d){(w(g)||b(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const a=this.getTunnelFromMap(g,d);if(a)return++a.refcount,a.value}openTunnel(g,d,a,P,h,i=!1,o,s){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${a} on local port ${h}.`);const t=this._tunnelProvider??g;if(!t)return;if(d||(d="localhost"),P||(P=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(a)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(t,d,a,P,h,i,o,s);return n?n.then(c=>{if(c){if(typeof c=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(d,a),c}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(d,a);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.makeTunnel(c);return(c.tunnelRemoteHost!==d||c.tunnelRemotePort!==a)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&c.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(v),v}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const d=this._tunnels.get(g.tunnelRemoteHost);if(d){const a=d.get(g.tunnelRemotePort);a&&(a.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,a))}}}}async tryDisposeTunnel(g,d,a){if(a.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${d}.`);const P=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(d),P}}async closeTunnel(g,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${d} `);const a=this._tunnels.get(g);if(a&&a.has(d)){const P=a.get(d);P.refcount=0,await this.tryDisposeTunnel(g,d,P)}}addTunnelToMap(g,d,a){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(d,{refcount:1,value:a})}async removeEmptyOrErrorTunnelFromMap(g,d){const a=this._tunnels.get(g);if(a){const P=a.get(d),h=P?await P.value:void 0;(!h||typeof h=="string")&&a.delete(d),a.size===0&&this._tunnels.delete(g)}}getTunnelFromMap(g,d){const a=[g];b(g)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):w(g)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const P=a.map(h=>this._tunnels.get(h));for(const h of P){const i=h?.get(d);if(i)return i}}canTunnel(g){return!!y(g)}createWithProvider(g,d,a,P,h,i,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${a} on local port ${P}.`);const s=a;this._factoryInProgress.add(s);const t=P===void 0?a:P,n={elevationRequired:h?this.isPortPrivileged(t):!1},c={remoteAddress:{host:d,port:a},localAddressPort:P,privacy:i,public:i?i!==I.Private:void 0,protocol:o},v=g.forwardPort(c,n);return v?(this.addTunnelToMap(d,a,v),v.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),v}};e.AbstractTunnelService=p,e.AbstractTunnelService=p=Ee([ne(0,O.ILogService),ne(1,L.IConfigurationService)],p)}),define(se[49],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var L;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(L||(e.StateType=L={}));var r;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap",D[D.WindowsInstaller=3]="WindowsInstaller"})(r||(e.UpdateType=r={}));var O;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,I)=>({type:"idle",updateType:D,error:I}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,C.createDecorator)("updateService")}),define(se[264],oe([0,1,4,188,58,43]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:C.isWindows&&!C.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(se[265],oe([0,1,3,49]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class r{constructor(I){this.service=I}listen(I,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(I,f,u){switch(f){case"checkForUpdates":return this.service.checkForUpdates(u);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(u)}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=r;class O{get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}constructor(I){this.channel=I,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(I){return this.channel.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=O}),define(se[40],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(se[266],oe([0,1,40,207,16,19,141,3,2]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{static{this._clock=0}constructor(w){this.uri=w,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let y=class{constructor(w){this._fileService=w,this._dispooables=new f.DisposableStore,this._limit=2**16;const l=new Map,S=p=>{let m=l.get(p.scheme);return m===void 0&&(m=w.hasProvider(p)&&!this._fileService.hasCapability(p,1024),l.set(p.scheme,m)),m};this._dispooables.add(I.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(p=>{l.delete(p.scheme)})),this.extUri=new O.ExtUri(S),this._canonicalUris=new D.SkipList((p,m)=>this.extUri.compare(p,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(w){this._fileService.hasProvider(w)&&(w=(0,O.normalizePath)(w));const l=this._canonicalUris.get(w);return l?l.touch().uri.with({fragment:w.fragment}):(this._canonicalUris.set(w,new u(w)),this._checkTrim(),w)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const w=[...this._canonicalUris.entries()].sort((S,p)=>S[1].time<p[1].time?1:S[1].time>p[1].time?-1:0);u._clock=0,this._canonicalUris.clear();const l=this._limit*.5;for(let S=0;S<l;S++)this._canonicalUris.set(w[S][0],w[S][1].touch())}};e.UriIdentityService=y,e.UriIdentityService=y=Ee([ne(0,r.IFileService)],y),(0,L.registerSingleton)(C.IUriIdentityService,y,1)}),define(se[127],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,C.createDecorator)("urlService")}),define(se[267],oe([0,1,7]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(I){this.handler=I}listen(I,f){throw new Error(`Event not found: ${f}`)}call(I,f,u){switch(f){case"handleURL":return this.handler.handleURL(C.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class r{constructor(I){this.channel=I}handleURL(I,f){return this.channel.call("handleURL",[I.toJSON(),f])}}e.URLHandlerChannelClient=r;class O{constructor(I,f){this.next=I,this.logService=f}async routeCall(I,f,u,y){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(u)&&u.length>0){const b=C.URI.revive(u[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const w=/\bwindowId=(\d+)/.exec(b.query);if(w){const l=w[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${l}"`,b.toString(!0));const S=new RegExp(`window:${l}`),p=I.connections.find(m=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",m.ctx),S.test(m.ctx)));if(p)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),p;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(I,f,u,y)}routeEvent(I,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=O}),define(se[268],oe([0,1,8,2,7,27]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends L.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(u,y){const b=[...this.handlers.values()];return(0,C.first)(b.map(w=>()=>w.handleURL(u,y)),void 0,!1).then(w=>w||!1)}registerHandler(u){return this.handlers.add(u),(0,L.toDisposable)(()=>this.handlers.delete(u))}}e.AbstractURLService=D;let I=class extends D{constructor(u){super(),this.productService=u}create(u){let{authority:y,path:b,query:w,fragment:l}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&b&&b.indexOf("/")!==0&&(b=`/${b}`),r.URI.from({scheme:this.productService.urlProtocol,authority:y,path:b,query:w,fragment:l})}};e.NativeURLService=I,e.NativeURLService=I=Ee([ne(0,O.IProductService)],I)}),define(se[269],oe([0,1,15,8,3,2,4,7]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class f extends O.Disposable{constructor(y,b,w,l,S,p){if(super(),this.urlService=b,this.logService=p,this.uris=[],this.retryCount=0,y&&(p.trace("ElectronURLListener initialUrisToHandle:",y.map(d=>d.originalUrl)),this.uris=y),D.isWindows){const d=l.isBuilt?[]:[`"${l.appRoot}"`];d.push("--open-url","--"),C.app.setAsDefaultProtocolClient(S.urlProtocol,process.execPath,d)}const m=r.Event.map(r.Event.fromNodeEventEmitter(C.app,"open-url",(d,a)=>({event:d,url:a})),({event:d,url:a})=>(d.preventDefault(),a));this._register(m(d=>{const a=this.uriFromRawUrl(d);a&&this.urlService.open(a,{originalUrl:d})})),w.getWindows().filter(d=>d.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(r.Event.once(w.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(y){try{return I.URI.parse(y)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),y.push(b));y.length!==0&&(this.uris=y,(0,L.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=f}),define(se[270],oe([0,1,3,2,16,57,31]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends L.Disposable{constructor(u,y,b,w,l,S){super(),this.fileSystemScheme=u,this.fileSystemProvider=y,this.userDataScheme=b,this.userDataProfilesService=w,this.uriIdentityService=l,this.logService=S,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new D.ResourceSet(p=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(p))),this.updateAtomicReadWritesResources(),this._register(w.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const u of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(u.settingsResource),this.atomicReadWriteResources.add(u.keybindingsResource),this.atomicReadWriteResources.add(u.tasksResource),this.atomicReadWriteResources.add(u.extensionsResource)}open(u,y){return this.fileSystemProvider.open(this.toFileSystemResource(u),y)}close(u){return this.fileSystemProvider.close(u)}read(u,y,b,w,l){return this.fileSystemProvider.read(u,y,b,w,l)}write(u,y,b,w,l){return this.fileSystemProvider.write(u,y,b,w,l)}watch(u,y){this.watchResources.set(u,u);const b=this.fileSystemProvider.watch(this.toFileSystemResource(u),y);return(0,L.toDisposable)(()=>{this.watchResources.delete(u),b.dispose()})}stat(u){return this.fileSystemProvider.stat(this.toFileSystemResource(u))}mkdir(u){return this.fileSystemProvider.mkdir(this.toFileSystemResource(u))}rename(u,y,b){return this.fileSystemProvider.rename(this.toFileSystemResource(u),this.toFileSystemResource(y),b)}readFile(u,y){return this.fileSystemProvider.readFile(this.toFileSystemResource(u),y)}readFileStream(u,y,b){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(u),y,b)}readdir(u){return this.fileSystemProvider.readdir(this.toFileSystemResource(u))}enforceAtomicReadFile(u){return this.atomicReadWriteResources.has(u)}writeFile(u,y,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(u),y,b)}enforceAtomicWriteFile(u){return this.atomicReadWriteResources.has(u)?{postfix:".vsctmp"}:!1}delete(u,y){return this.fileSystemProvider.delete(this.toFileSystemResource(u),y)}copy(u,y,b){if((0,r.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(u),this.toFileSystemResource(y),b);throw new Error("copy not supported")}cloneFile(u,y){if((0,r.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(u),this.toFileSystemResource(y));throw new Error("clone not supported")}handleFileChanges(u){const y=[];for(const b of u){if(b.resource.scheme!==this.fileSystemScheme)continue;const w=this.toUserDataResource(b.resource);this.watchResources.findSubstr(w)&&y.push({resource:w,type:b.type,cId:b.cId})}y.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(y))}toFileSystemResource(u){return u.with({scheme:this.fileSystemScheme})}toUserDataResource(u){return u.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(se[271],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(se[272],oe([0,1,6]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,C.createDecorator)("webviewManagerService")}),define(se[273],oe([0,1,15,2,13,7]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends L.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.handleWebviewRequest.bind(this);C.protocol.registerFileProtocol(r.Schemas.vscodeWebview,f)}handleWebviewRequest(f,u){try{const y=O.URI.parse(f.url),b=D.validWebviewFilePaths.get(y.path);if(typeof b=="string"){const w=`vs/workbench/contrib/webview/browser/pre/${b}`,l=r.FileAccess.asFileUri(w);return u({path:l.fsPath,headers:{...r.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.WebviewProtocolProvider=D}),define(se[60],oe([0,1,4]),function(V,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useNativeFullScreen=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.isOpenedAuxiliaryWindow=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return typeof w.parentId=="number"}e.isOpenedAuxiliaryWindow=L;function r(w){return!!w.workspaceUri}e.isWorkspaceToOpen=r;function O(w){return!!w.folderUri}e.isFolderToOpen=O;function D(w){return!!w.fileUri}e.isFileToOpen=D;function I(w){const l=f(w),S=w.getValue("window.menuBarVisibility");return S==="default"||l==="native"&&S==="compact"||C.isMacintosh&&C.isNative?"classic":S}e.getMenuBarVisibility=I;function f(w){if(C.isWeb)return"custom";const l=w.getValue("window");if(l){if(C.isMacintosh&&l.nativeTabs===!0||C.isMacintosh&&l.nativeFullScreen===!1)return"native";const m=l.titleBarStyle;if(m==="native"||m==="custom")return m}return C.isLinux?"native":"custom"}e.getTitleBarStyle=f;function u(w){return!(!C.isWindows||C.isWeb||f(w)==="native")}e.useWindowControlsOverlay=u;function y(w){const l=w.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}e.useNativeFullScreen=y;function b(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=b}),define(se[128],oe([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var C;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var L;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(L||(e.UnloadReason=L={}));const r=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=r;var O;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(O||(e.WindowMode=O={}));var D;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(se[274],oe([0,1,8,3,2]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends r.Disposable{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:f,getActiveWindowId:u}){super(),this.disposables=this._register(new r.DisposableStore),L.Event.latch(L.Event.any(I,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,C.createCancelablePromise)(()=>u()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=O}),define(se[30],oe([0,1,192,9,57,19,7,6,13]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function u(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=u;function y(t){return typeof t?.id=="string"&&!u(t)&&!w(t)}e.isEmptyWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,L.basename)(t)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=t;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=b;function w(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=w;function l(t){const n=t;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const c=t;if(c?.configPath)return{id:c.id,configPath:D.URI.revive(c.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=l;var S;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=p;function m(t){const n=t;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=m;class g{constructor(n,c,v,R,k){this._id=n,this._transient=v,this._configuration=R,this._ignorePathCasing=k,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=c}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class d{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function a(t){return new d({uri:t,index:0,name:(0,O.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=a,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(t,n){return O.extUriBiasedIgnorePathCase.isEqualOrParent(t,n.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function h(t){let n;return D.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=h,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function o(t,n){return!P(t,n)&&!h(t)}e.isSavedWorkspace=o;function s(t){return(typeof t=="string"?(0,L.extname)(t):(0,O.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(se[53],oe([0,1,15,8,45,47,2,85,4,21,167,115,6,5,27,30]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let m=class{constructor(d,a){this.logService=d,this.productService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(d,a){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},a)}pickFolder(d,a){return this.doPick({...d,pickFolders:!0,title:(0,y.localize)(1,null)},a)}pickFile(d,a){return this.doPick({...d,pickFiles:!0,title:(0,y.localize)(2,null)},a)}pickWorkspace(d,a){const P=(0,y.localize)(3,null),h=(0,O.mnemonicButtonLabel)((0,y.localize)(4,null)),i=p.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:P,filters:i,buttonLabel:h},a)}async doPick(d,a){const P={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(P.properties=void 0,d.pickFiles&&d.pickFolders&&(P.properties=["multiSelections","openDirectory","openFile","createDirectory"])),P.properties||(P.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&P.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(P,(a||C.BrowserWindow.getFocusedWindow())??void 0);if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(d){if(d){let a=this.windowDialogQueues.get(d.id);return a||(a=new L.Queue,this.windowDialogQueues.set(d.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(d,a){return this.getWindowDialogQueue(a).queue(async()=>{const{options:P,buttonIndeces:h}=(0,b.massageMessageBoxOptions)(d,this.productService);let i;return a?i=await C.dialog.showMessageBox(a,P):i=await C.dialog.showMessageBox(P),{response:h[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(d,a){const P=this.acquireFileDialogLock(d,a);if(!P)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let h;return a?h=await C.dialog.showSaveDialog(a,d):h=await C.dialog.showSaveDialog(d),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,D.dispose)(P)}}normalizePath(d){return d&&f.isMacintosh&&(d=(0,I.normalizeNFC)(d)),d}normalizePaths(d){return d.map(a=>this.normalizePath(a))}async showOpenDialog(d,a){d.defaultPath&&(await u.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const P=this.acquireFileDialogLock(d,a);if(!P)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let h;return a?h=await C.dialog.showOpenDialog(a,d):h=await C.dialog.showOpenDialog(d),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,D.dispose)(P)}}acquireFileDialogLock(d,a){if(!a)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let P=this.windowFileDialogLocks.get(a.id);P||(P=new Set,this.windowFileDialogLocks.set(a.id,P));const h=(0,r.hash)(d);if(!P.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),P.add(h),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),P?.delete(h),P?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};e.DialogMainService=m,e.DialogMainService=m=Ee([ne(0,l.ILogService),ne(1,S.IProductService)],m)}),define(se[275],oe([0,1,3,2,77,30]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends L.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(f,u){super(),this.logService=f,this.storageMainService=u,this.onDidChangeApplicationStorageEmitter=this._register(new C.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(u.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(f,u){this._register(C.Event.debounce(f.onDidChangeStorage,(y,b)=>(y?y.push(b):y=[b],y),D.STORAGE_CHANGE_DEBOUNCE_TIME)(y=>{y.length&&u.fire(this.serializeStorageChangeEvents(y,f))}))}serializeStorageChangeEvents(f,u){const y=new Map,b=new Set;return f.forEach(w=>{const l=u.get(w.key);typeof l=="string"?y.set(w.key,l):b.add(w.key)}),{changed:Array.from(y.entries()),deleted:Array.from(b.values())}}listen(f,u,y){switch(u){case"onDidChangeStorage":{const b=y.profile?(0,r.revive)(y.profile):void 0;if(!b)return this.onDidChangeApplicationStorageEmitter.event;let w=this.mapProfileToOnDidChangeProfileStorageEmitter.get(b.id);return w||(w=this._register(new C.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(b),w),this.mapProfileToOnDidChangeProfileStorageEmitter.set(b.id,w)),w.event}}throw new Error(`Event not found: ${u}`)}async call(f,u,y){const b=y.profile?(0,r.revive)(y.profile):void 0,w=(0,O.reviveIdentifier)(y.workspace),l=await this.withStorageInitialized(b,w);switch(u){case"getItems":return Array.from(l.items.entries());case"updateItems":{const S=y;if(S.insert)for(const[p,m]of S.insert)l.set(p,m);S.delete?.forEach(p=>l.delete(p));break}case"optimize":return l.optimize();case"isUsed":{const S=y.payload;if(typeof S=="string")return this.storageMainService.isUsed(S)}default:throw new Error(`Call not found: ${u}`)}}async withStorageInitialized(f,u){let y;u?y=this.storageMainService.workspaceStorage(u):f?y=this.storageMainService.profileStorage(f):y=this.storageMainService.applicationStorage;try{await y.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${u?"workspace":f?"profile":"application"} storage due to ${b}`)}return y}}e.StorageDatabaseChannel=D}),define(se[41],oe([0,1,45,3,2,19,7,189,37,16,6,5,30,31,40,8,32,25,12]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var a;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(a||(e.ProfileResourceType=a={}));function P(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.isUserDataProfile=P,e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function h(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:D.URI.revive(t.location).with({scheme:n}),globalStorageHome:D.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=h;function i(t,n,c,v,R,k){return{id:t,name:n,location:c,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:k&&R?.useDefaultFlags?.globalState?k.globalStorageHome:(0,O.joinPath)(c,"globalStorage"),settingsResource:k&&R?.useDefaultFlags?.settings?k.settingsResource:(0,O.joinPath)(c,"settings.json"),keybindingsResource:k&&R?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,O.joinPath)(c,"keybindings.json"),tasksResource:k&&R?.useDefaultFlags?.tasks?k.tasksResource:(0,O.joinPath)(c,"tasks.json"),snippetsHome:k&&R?.useDefaultFlags?.snippets?k.snippetsHome:(0,O.joinPath)(c,"snippets"),extensionsResource:k&&R?.useDefaultFlags?.extensions?k.extensionsResource:(0,O.joinPath)(c,"extensions.json"),cacheHome:(0,O.joinPath)(v,t),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.toUserDataProfile=i;let o=class extends r.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,c,v,R){super(),this.environmentService=n,this.fileService=c,this.uriIdentityService=v,this.logService=R,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new l.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),c=[n];if(this.enabled)try{for(const k of this.getStoredProfiles()){if(!k.name||!(0,d.isString)(k.name)||!k.location){this.logService.warn("Skipping the invalid stored profile",k.location||k.name);continue}c.push(i((0,O.basename)(k.location),k.name,k.location,this.profilesCacheHome,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},n))}}catch(k){this.logService.error(k)}const v=new l.ResourceMap,R=new Map;if(c.length)try{const k=this.getStoredProfileAssociations();if(k.workspaces)for(const[E,M]of Object.entries(k.workspaces)){const _=D.URI.parse(E),T=c.find(U=>U.id===M);T&&v.set(_,T)}if(k.emptyWindows)for(const[E,M]of Object.entries(k.emptyWindows)){const _=c.find(T=>T.id===M);_&&R.set(E,_)}}catch(k){this.logService.error(k)}this._profilesObject={profiles:c,workspaces:v,emptyWindows:R}}return this._profilesObject}createDefaultProfile(){const n=i("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const c="Temp",v=new RegExp(`${(0,g.escapeRegExpCharacters)(c)}\\s(\\d+)`);let R=0;for(const E of this.profiles){const M=v.exec(E.name),_=M?parseInt(M[1]):0;R=_>R?_:R}const k=`${c} ${R+1}`;return this.createProfile((0,C.hash)((0,m.generateUuid)()).toString(16),k,{transient:!0},n)}async createNamedProfile(n,c,v){return this.createProfile((0,C.hash)((0,m.generateUuid)()).toString(16),n,c,v)}async createProfile(n,c,v,R){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const k=await this.doCreateProfile(n,c,v);return R&&await this.setProfileForWorkspace(R,k),k}async doCreateProfile(n,c,v){if(!(0,d.isString)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.profileCreationPromises.get(c);return R||(R=(async()=>{try{const k=this.profiles.find(_=>_.name===c||_.id===n);if(k)return k;const E=i(n,c,(0,O.joinPath)(this.profilesHome,n),this.profilesCacheHome,v,this.defaultProfile);await this.fileService.createFolder(E.location);const M=[];return this._onWillCreateProfile.fire({profile:E,join(_){M.push(_)}}),await p.Promises.settled(M),this.updateProfiles([E],[],[]),E}finally{this.profileCreationPromises.delete(c)}})(),this.profileCreationPromises.set(c,R)),R}async updateProfile(n,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(R=>R.id===n.id);if(!v)throw new Error(`Profile '${n.name}' does not exist`);return v=i(v.id,c.name??v.name,v.location,this.profilesCacheHome,{shortName:c.shortName??v.shortName,icon:c.icon===null?void 0:c.icon??v.icon,transient:c.transient??v.isTransient,useDefaultFlags:c.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[v]),v}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(R=>R.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);const v=[];this._onWillRemoveProfile.fire({profile:c,join(R){v.push(R)}});try{await Promise.allSettled(v)}catch(R){this.logService.error(R)}for(const R of[...this.profilesObject.emptyWindows.keys()])c.id===this.profilesObject.emptyWindows.get(R)?.id&&this.profilesObject.emptyWindows.delete(R);for(const R of[...this.profilesObject.workspaces.keys()])c.id===this.profilesObject.workspaces.get(R)?.id&&this.profilesObject.workspaces.delete(R);this.updateStoredProfileAssociations(),this.updateProfiles([],[c],[]);try{await this.fileService.del(c.cacheHome,{recursive:!0})}catch(R){(0,u.toFileOperationResult)(R)!==1&&this.logService.error(R)}}async setProfileForWorkspace(n,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(R=>R.id===c.id);if(!v)throw new Error(`Profile '${c.name}' does not exist`);this.updateWorkspaceAssociation(n,v)}unsetWorkspace(n,c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,c)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(c=>c.isDirectory&&this.profiles.every(v=>!this.uriIdentityService.extUri.isEqual(v.location,c.resource))).map(c=>this.fileService.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(c=>!this.isProfileAssociatedToWorkspace(c));await Promise.allSettled(n.map(c=>this.removeProfile(c)))}getProfileForWorkspace(n){const c=this.getWorkspace(n);return D.URI.isUri(c)?this.transientProfilesObject.workspaces.get(c)??this.profilesObject.workspaces.get(c):this.transientProfilesObject.emptyWindows.get(c)??this.profilesObject.emptyWindows.get(c)}getWorkspace(n){return(0,w.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,w.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location))||[...this.profilesObject.workspaces.values()].some(c=>this.uriIdentityService.extUri.isEqual(c.location,n.location)))}updateProfiles(n,c,v){const R=[...this.profiles,...n],k=[];this.transientProfilesObject.profiles=[];for(let E of R)E.isDefault||c.some(M=>E.id===M.id)||(E=v.find(M=>E.id===M.id)??E,E.isTransient?this.transientProfilesObject.profiles.push(E):k.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.saveStoredProfiles(k),this._profilesObject=void 0,this.triggerProfilesChanges(n,c,v)}triggerProfilesChanges(n,c,v){this._onDidChangeProfiles.fire({added:n,removed:c,updated:v,all:this.profiles})}updateWorkspaceAssociation(n,c,v){v=c?.isTransient?!0:v,v||this.updateWorkspaceAssociation(n,void 0,!0);const R=this.getWorkspace(n),k=v?this.transientProfilesObject:this.profilesObject;D.URI.isUri(R)?(k.workspaces.delete(R),c&&k.workspaces.set(R,c)):(k.emptyWindows.delete(R),c&&k.emptyWindows.set(R,c)),v||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[v,R]of this.profilesObject.workspaces.entries())n[v.toString()]=R.id;const c={};for(const[v,R]of this.profilesObject.emptyWindows.entries())c[v.toString()]=R.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:c}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const c={},v=this.createDefaultProfile();if(n.workspaces)for(const[k,E]of Object.entries(n.workspaces)){const M=D.URI.parse(E);c[k]=this.uriIdentityService.extUri.isEqual(M,v.location)?v.id:this.uriIdentityService.extUri.basename(M)}const R={};if(n.emptyWindows)for(const[k,E]of Object.entries(n.emptyWindows)){const M=D.URI.parse(E);R[k]=this.uriIdentityService.extUri.isEqual(M,v.location)?v.id:this.uriIdentityService.extUri.basename(M)}return{workspaces:c,emptyWindows:R}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=Ee([ne(0,f.IEnvironmentService),ne(1,u.IFileService),ne(2,S.IUriIdentityService),ne(3,b.ILogService)],o);class s extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=s}),define(se[81],oe([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,28]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class a extends Error{constructor(s,t){super(s),this.code=t}}e.ExtensionsProfileScanningError=a,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let P=class extends r.Disposable{constructor(s,t,n,c,v,R){super(),this.extensionsLocation=s,this.fileService=t,this.userDataProfilesService=n,this.uriIdentityService=c,this.telemetryService=v,this.logService=R,this._onAddExtensions=this._register(new O.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new O.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new O.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new O.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new D.ResourceMap}scanProfileExtensions(s,t){return this.withProfileExtensions(s,void 0,t)}async addExtensionsToProfile(s,t){const n=[],c=[];try{return await this.withProfileExtensions(t,v=>{const R=[];for(const k of v)s.some(([E])=>(0,u.areSameExtensions)(E.identifier,k.identifier)&&E.manifest.version!==k.version)?n.push(k):R.push(k);for(const[k,E]of s){const M=R.findIndex(T=>(0,u.areSameExtensions)(T.identifier,k.identifier)&&T.version===k.manifest.version),_={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:E};M===-1?(c.push(_),R.push(_)):R.splice(M,1,_)}return c.length&&this._onAddExtensions.fire({extensions:c,profileLocation:t}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:t}),R}),c.length&&this._onDidAddExtensions.fire({extensions:c,profileLocation:t}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:t}),c}catch(v){throw c.length&&this._onDidAddExtensions.fire({extensions:c,error:v,profileLocation:t}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:v,profileLocation:t}),v}}async updateMetadata(s,t){const n=[];return await this.withProfileExtensions(t,c=>{const v=[];for(const R of c){const k=s.find(([E])=>(0,u.areSameExtensions)(E.identifier,R.identifier)&&E.manifest.version===R.version);k&&(R.metadata={...R.metadata,...k[1]},n.push(R)),v.push(R)}return v}),n}async removeExtensionFromProfile(s,t){const n=[];try{await this.withProfileExtensions(t,c=>{const v=[];for(const R of c)(0,u.areSameExtensions)(R.identifier,s.identifier)?n.push(R):v.push(R);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:t}),v}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:t})}catch(c){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:c,profileLocation:t}),c}}async withProfileExtensions(s,t,n){return this.getResourceAccessQueue(s).queue(async()=>{let c=[],v;try{const R=await this.fileService.readFile(s);v=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,y.toFileOperationResult)(R)!==1)throw R;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(v=await this.migrateFromOldDefaultProfileExtensionsLocation()),!v&&n?.bailOutWhenFileNotFound)throw new a((0,m.getErrorMessage)(R),"ERROR_PROFILE_NOT_FOUND")}if(v){Array.isArray(v)||this.reportAndThrowInvalidConentError(s);let R=!1;for(const k of v){h(k)||this.reportAndThrowInvalidConentError(s);let E;if((0,p.isString)(k.relativeLocation)&&k.relativeLocation)E=this.resolveExtensionLocation(k.relativeLocation);else if((0,p.isString)(k.location))E=this.resolveExtensionLocation(k.location),R=!0,k.relativeLocation=k.location,k.location=E.toJSON();else{E=I.URI.revive(k.location);const M=this.toRelativePath(E);M&&(R=!0,k.relativeLocation=M)}c.push({identifier:k.identifier,location:E,version:k.version,metadata:k.metadata})}R&&await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(v)))}if(t){c=t(c);const R=c.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.toRelativePath(k.location),metadata:k.metadata}));await this.fileService.writeFile(s,L.VSBuffer.fromString(JSON.stringify(R)))}return c})}reportAndThrowInvalidConentError(s){const t=new a(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),t=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(s)).value.toString()}catch(v){if((0,y.toFileOperationResult)(v)===1)return;throw v}this.logService.info("Migrating extensions from old default profile location",s.toString());let c;try{const v=JSON.parse(n);Array.isArray(v)&&v.every(R=>h(R))?c=v:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",v)}catch(v){this.logService.error(v)}if(c)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(v){if((0,y.toFileOperationResult)(v)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw v}try{await this.fileService.del(s)}catch(v){(0,y.toFileOperationResult)(v)!==1&&this.logService.error(v)}try{await this.fileService.del(t)}catch(v){(0,y.toFileOperationResult)(v)!==1&&this.logService.error(v)}return c})()),this._migrationPromise}getResourceAccessQueue(s){let t=this.resourcesAccessQueueMap.get(s);return t||(t=new C.Queue,this.resourcesAccessQueueMap.set(s,t)),t}};e.AbstractExtensionsProfileScannerService=P,e.AbstractExtensionsProfileScannerService=P=Ee([ne(1,y.IFileService),ne(2,l.IUserDataProfilesService),ne(3,S.IUriIdentityService),ne(4,g.ITelemetryService),ne(5,w.ILogService)],P);function h(o){return(0,p.isObject)(o)&&(0,f.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,p.isString)(o.location)&&o.location)&&((0,p.isUndefined)(o.relativeLocation)||(0,p.isString)(o.relativeLocation))&&o.version&&(0,p.isString)(o.version)}function i(o){return o?(0,p.isString)(o.path)&&(0,p.isString)(o.scheme):!1}}),define(se[129],oe([0,1,23,8,38,18,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,6,5,27,3,77,81,41,40,203]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o,s,t,n,c,v,R,k,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(ue){function Q(G,x){if(G===x)return!0;const W=Object.keys(G),B=new Set;for(const H of Object.keys(x))B.add(H);if(W.length!==B.size)return!1;for(const H of W){if(G[H]!==x[H])return!1;B.delete(H)}return B.size===0}ue.equals=Q})(_||(e.Translations=_={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let T=class extends u.Disposable{constructor(Q,G,x,W,B,H,q,Z,de,j,A,F){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=G,this.extensionsControlLocation=x,this.currentProfile=W,this.userDataProfilesService=B,this.extensionsProfileScannerService=H,this.fileService=q,this.logService=Z,this.environmentService=de,this.productService=j,this.uriIdentityService=A,this.instantiationService=F,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,l.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Y,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(X,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,P.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(Q,G,x){const[W,B]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(G)]),H=x?await this.scanExtensionsUnderDevelopment(Q,[...W,...B]):[];return this.dedupExtensions(W,B,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const G=[];G.push(this.scanDefaultSystemExtensions(!!Q.useCache,Q.language)),G.push(this.scanDevSystemExtensions(Q.language,!!Q.checkControlFile));const[x,W]=await Promise.all(G);return this.applyScanOptions([...x,...W],0,Q,!1)}async scanUserExtensions(Q){const G=Q.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",G);const x=this.uriIdentityService.extUri.isEqual(Q.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(G,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,x),B=Q.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let H;try{H=await B.scanExtensions(W)}catch(q){if(q instanceof R.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),H=await B.scanExtensions(W);else throw q}return H=await this.applyScanOptions(H,1,Q,!0),this.logService.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(Q,G){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===y.Schemas.file).map(async W=>{const B=await this.createExtensionScannerInput(W,!1,1,!0,Q.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(B)).map(q=>(q.type=G.find(Z=>(0,P.areSameExtensions)(Z.identifier,q.identifier))?.type??q.type,this.extensionsScanner.validate(q,B)))}))).flat();return this.applyScanOptions(x,"development",Q,!0)}return[]}async scanExistingExtension(Q,G,x){const W=await this.createExtensionScannerInput(Q,!1,G,!0,x.language,!0,void 0),B=await this.extensionsScanner.scanExtension(W);return!B||!x.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(Q,G,x){const W=await this.createExtensionScannerInput(Q,!1,G,!0,x.language,!0,void 0),B=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(B,G,x,!0)}async scanMetadata(Q){const G=(0,l.joinPath)(Q,"package.json"),x=(await this.fileService.readFile(G)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(Q,G){const x=(0,l.joinPath)(Q,"package.json"),W=(await this.fileService.readFile(x)).value.toString(),B=JSON.parse(W);G.isMachineScoped===!1&&delete G.isMachineScoped,G.isBuiltin===!1&&delete G.isBuiltin,B.__metadata={...B.__metadata,...G},await this.fileService.writeFile((0,l.joinPath)(Q,"package.json"),O.VSBuffer.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof R.ExtensionsProfileScanningError&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw Q}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.extensionsProfileScannerService.addExtensionsToProfile(Q.map(G=>[G,G.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(G){(0,o.toFileOperationResult)(G)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(G))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.logService.error(Q)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(Q,G,x,W){return x.includeAllVersions||(Q=this.dedupExtensions(G===0?Q:void 0,G===1?Q:void 0,G==="development"?Q:void 0,await this.getTargetPlatform(),W)),x.includeInvalid||(Q=Q.filter(B=>B.isValid)),Q.sort((B,H)=>{const q=b.basename(B.location.fsPath),Z=b.basename(H.location.fsPath);return q<Z?-1:q>Z?1:0})}dedupExtensions(Q,G,x,W,B){const H=(Z,de,j)=>{if(Z.isValid&&!de.isValid)return!1;if(Z.isValid===de.isValid){if(B&&S.gt(Z.manifest.version,de.manifest.version))return this.logService.debug(`Skipping extension ${de.location.path} with lower version ${de.manifest.version} in favour of ${Z.location.path} with version ${Z.manifest.version}`),!1;if(S.eq(Z.manifest.version,de.manifest.version)){if(Z.type===0)return this.logService.debug(`Skipping extension ${de.location.path} in favour of system extension ${Z.location.path} with same version`),!1;if(Z.targetPlatform===W)return this.logService.debug(`Skipping extension ${de.location.path} from different target platform ${de.targetPlatform}`),!1}}return j?this.logService.warn(`Overwriting user extension ${Z.location.path} with ${de.location.path}.`):this.logService.debug(`Overwriting user extension ${Z.location.path} with ${de.location.path}.`),!0},q=new h.ExtensionIdentifierMap;return Q?.forEach(Z=>{const de=q.get(Z.identifier.id);(!de||H(de,Z,!1))&&q.set(Z.identifier.id,Z)}),G?.forEach(Z=>{const de=q.get(Z.identifier.id);if(!de&&Q&&Z.type===0){this.logService.debug(`Skipping obsolete system extension ${Z.location.path}.`);return}(!de||H(de,Z,!1))&&q.set(Z.identifier.id,Z)}),x?.forEach(Z=>{const de=q.get(Z.identifier.id);(!de||H(de,Z,!0))&&q.set(Z.identifier.id,Z),q.set(Z.identifier.id,Z)}),[...q.values()]}async scanDefaultSystemExtensions(Q,G){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(Q&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",B.length),B}async scanDevSystemExtensions(Q,G){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=G?await this.getBuiltInExtensionControl():{},B=[],H=g.URI.file(b.normalize(b.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Z of x){const de=W[Z.name]||"marketplace";switch(de){case"disabled":break;case"marketplace":B.push((0,l.joinPath)(H,Z.name));break;default:B.push(g.URI.file(de));break}}const q=await Promise.all(B.map(async Z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(Z,!1,0,!0,Q,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",q.length),(0,C.coalesce)(q)}async getBuiltInExtensionControl(){try{const Q=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(Q.value.toString())}catch{return{}}}async createExtensionScannerInput(Q,G,x,W,B,H,q){const Z=await this.getTranslations(B??w.language),de=await this.getMtime(Q),j=G&&!this.uriIdentityService.extUri.isEqual(Q,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,A=j?await this.getMtime(j):void 0;return new U(Q,de,j,A,G,q,x,W,H,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,B,Z)}async getMtime(Q){try{const G=await this.fileService.stat(Q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.AbstractExtensionsScannerService=T,e.AbstractExtensionsScannerService=T=Ee([ne(4,k.IUserDataProfilesService),ne(5,R.IExtensionsProfileScannerService),ne(6,o.IFileService),ne(7,t.ILogService),ne(8,a.IEnvironmentService),ne(9,n.IProductService),ne(10,E.IUriIdentityService),ne(11,s.IInstantiationService)],T);class U{constructor(Q,G,x,W,B,H,q,Z,de,j,A,F,J,z,K){this.location=Q,this.mtime=G,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=W,this.profile=B,this.profileScanOptions=H,this.type=q,this.excludeObsolete=Z,this.validate=de,this.productVersion=j,this.productDate=A,this.productCommit=F,this.devMode=J,this.language=z,this.translations=K}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,G){return(0,l.isEqual)(Q.location,G.location)&&Q.mtime===G.mtime&&(0,l.isEqual)(Q.applicationExtensionslocation,G.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&Q.profile===G.profile&&r.equals(Q.profileScanOptions,G.profileScanOptions)&&Q.type===G.type&&Q.excludeObsolete===G.excludeObsolete&&Q.validate===G.validate&&Q.productVersion===G.productVersion&&Q.productDate===G.productDate&&Q.productCommit===G.productCommit&&Q.devMode===G.devMode&&Q.language===G.language&&_.equals(Q.translations,G.translations)}}e.ExtensionScannerInput=U;let X=class extends u.Disposable{constructor(Q,G,x,W,B){super(),this.obsoleteFile=Q,this.extensionsProfileScannerService=G,this.uriIdentityService=x,this.fileService=W,this.logService=B}async scanExtensions(Q){const G=Q.profile?await this.scanExtensionsFromProfile(Q):await this.scanExtensionsFromLocation(Q);let x={};if(Q.excludeObsolete&&Q.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(W)}catch{}return(0,m.isEmptyObject)(x)?G:G.filter(W=>!x[P.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(Q){const G=await this.fileService.resolve(Q.location);if(!G.children?.length)return[];const x=await Promise.all(G.children.map(async W=>{if(!W.isDirectory||Q.type===1&&(0,l.basename)(W.resource).indexOf(".")===0)return null;const B=new U(W.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(B)}));return(0,C.coalesce)(x).sort((W,B)=>W.location.path<B.location.path?-1:1)}async scanExtensionsFromProfile(Q){let G=await this.scanExtensionsFromProfileResource(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){G=G.filter(W=>!W.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(Q.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,Q);G.push(...x)}return G}async scanExtensionsFromProfileResource(Q,G,x){const W=await this.extensionsProfileScannerService.scanProfileExtensions(Q,x.profileScanOptions);if(!W.length)return[];const B=await Promise.all(W.map(async H=>{if(G(H)){const q=new U(H.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(q,H.metadata)}return null}));return(0,C.coalesce)(B)}async scanOneOrMultipleExtensions(Q){try{if(await this.fileService.exists((0,l.joinPath)(Q.location,"package.json"))){const G=await this.scanExtension(Q);return G?[G]:[]}else return await this.scanExtensions(Q)}catch(G){return this.logService.error(`Error scanning extensions at ${Q.location.path}:`,(0,D.getErrorMessage)(G)),[]}}async scanExtension(Q,G){try{let x=await this.scanExtensionManifest(Q.location);if(x){x.publisher||(x.publisher=h.UNDEFINED_PUBLISHER),G=G??x.__metadata,delete x.__metadata;const W=(0,P.getGalleryExtensionId)(x.publisher,x.name),B=G?.id?{id:W,uuid:G.id}:{id:W},H=G?.isSystem?0:Q.type,q=H===0||!!G?.isBuiltin;x=await this.translateManifest(Q.location,x,U.createNlsConfiguration(Q));const Z={type:H,identifier:B,manifest:x,location:Q.location,isBuiltin:q,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return Q.validate?this.validate(Z,Q):Z}}catch(x){Q.type!==0&&this.logService.error(x)}return null}validate(Q,G){let x=!0;const W=(0,i.validateExtensionManifest)(G.productVersion,G.productDate,G.location,Q.manifest,Q.isBuiltin);for(const[B,H]of W)B===p.default.Error&&(x=!1,this.logService.error(this.formatMessage(G.location,H)));return Q.isValid=x,Q.validations=W,Q}async scanExtensionManifest(Q){const G=(0,l.joinPath)(Q,"package.json");let x;try{x=(await this.fileService.readFile(G)).value.toString()}catch(B){return(0,o.toFileOperationResult)(B)!==1&&this.logService.error(this.formatMessage(Q,(0,d.localize)(0,null,G.path,B.message))),null}let W;try{W=JSON.parse(x)}catch{const H=[];(0,I.parse)(x,H);for(const q of H)this.logService.error(this.formatMessage(Q,(0,d.localize)(1,null,G.path,q.offset,q.length,(0,f.getParseErrorMessage)(q.error))));return null}return(0,I.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(Q,(0,d.localize)(2,null,G.path))),null):W}async translateManifest(Q,G,x){const W=await this.getLocalizedMessages(Q,G,x);if(W)try{const B=[],H=await this.resolveOriginalMessageBundle(W.default,B);if(B.length>0)return B.forEach(Z=>{this.logService.error(this.formatMessage(Q,(0,d.localize)(3,null,W.default?.path,(0,f.getParseErrorMessage)(Z.error))))}),G;if((0,I.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(Q,(0,d.localize)(4,null,W.default?.path))),G;const q=W.values||Object.create(null);return(0,M.localizeManifest)(this.logService,G,q,H)}catch{}return G}async getLocalizedMessages(Q,G,x){const W=(0,l.joinPath)(Q,"package.nls.json"),B=(de,j)=>{j.forEach(A=>{this.logService.error(this.formatMessage(Q,(0,d.localize)(5,null,de?.path,(0,f.getParseErrorMessage)(A.error))))})},H=de=>{this.logService.error(this.formatMessage(Q,(0,d.localize)(6,null,de?.path)))},q=`${G.publisher}.${G.name}`,Z=x.translations[q];if(Z)try{const de=g.URI.file(Z),j=(await this.fileService.readFile(de)).value.toString(),A=[],F=(0,I.parse)(j,A);return A.length>0?(B(de,A),{values:void 0,default:W}):(0,I.getNodeType)(F)!=="object"?(H(de),{values:void 0,default:W}):{values:F.contents?F.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let j;try{j=await this.findMessageBundles(Q,x)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const A=(await this.fileService.readFile(j.localized)).value.toString(),F=[],J=(0,I.parse)(A,F);return F.length>0?(B(j.localized,F),{values:void 0,default:j.original}):(0,I.getNodeType)(J)!=="object"?(H(j.localized),{values:void 0,default:j.original}):{values:J,default:j.original}}catch{return{values:void 0,default:j.original}}}}async resolveOriginalMessageBundle(Q,G){if(Q)try{const x=(await this.fileService.readFile(Q)).value.toString();return(0,I.parse)(x,G)}catch{}}findMessageBundles(Q,G){return new Promise((x,W)=>{const B=H=>{const q=(0,l.joinPath)(Q,`package.nls.${H}.json`);this.fileService.exists(q).then(Z=>{Z&&x({localized:q,original:(0,l.joinPath)(Q,"package.nls.json")});const de=H.lastIndexOf("-");de===-1?x({localized:(0,l.joinPath)(Q,"package.nls.json"),original:null}):(H=H.substring(0,de),B(H))})};if(G.devMode||G.pseudo||!G.language)return x({localized:(0,l.joinPath)(Q,"package.nls.json"),original:null});B(G.language)})}formatMessage(Q,G){return`[${Q.path}]: ${G}`}};X=Ee([ne(1,R.IExtensionsProfileScannerService),ne(2,E.IUriIdentityService),ne(3,o.IFileService),ne(4,t.ILogService)],X);let Y=class extends X{constructor(Q,G,x,W,B,H,q){super(G,W,B,H,q),this.currentProfile=Q,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(Q){const G=this.getCacheFile(Q),x=await this.readExtensionCache(G);if(this.input=Q,x&&x.input&&U.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",Q.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(B=>(B.location=g.URI.revive(B.location),B));const W=await super.scanExtensions(Q);return await this.writeExtensionCache(G,{input:Q,result:W}),W}async readExtensionCache(Q){try{const G=await this.fileService.readFile(Q),x=JSON.parse(G.value.toString());return{result:x.result,input:(0,v.revive)(x.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",Q.path,(0,D.getErrorMessage)(G))}return null}async writeExtensionCache(Q,G){try{await this.fileService.writeFile(Q,O.VSBuffer.fromString(JSON.stringify(G)))}catch(x){this.logService.debug("Error while writing the extension cache file:",Q.path,(0,D.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const Q=this.getCacheFile(this.input),G=await this.readExtensionCache(Q);if(!G)return;const x=G.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!r.equals(W,x))try{this.logService.info("Invalidating Cache",x,W),await this.fileService.del(Q),this._onDidChangeCache.fire()}catch(B){this.logService.error(B)}}getCacheFile(Q){const G=this.getProfile(Q);return this.uriIdentityService.extUri.joinPath(G.cacheHome,Q.type===0?h.BUILTIN_MANIFEST_CACHE_FILE:h.USER_MANIFEST_CACHE_FILE)}getProfile(Q){return Q.type===0?this.userDataProfilesService.defaultProfile:Q.profile?this.uriIdentityService.extUri.isEqual(Q.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(G=>this.uriIdentityService.extUri.isEqual(Q.location,G.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};Y=Ee([ne(2,k.IUserDataProfilesService),ne(3,R.IExtensionsProfileScannerService),ne(4,E.IUriIdentityService),ne(5,o.IFileService),ne(6,t.ILogService)],Y);function le(ue,Q){const G=(0,P.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:G,identifier:new h.ExtensionIdentifier(G),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Q,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=le;class ce extends T{constructor(Q,G,x,W,B,H,q,Z,de,j,A,F){super(Q,G,(0,l.joinPath)(x,".vscode-oss-dev","extensions","control.json"),W,B,H,q,Z,de,j,A,F),this.translationsPromise=(async()=>{if(w.translationsConfigFile)try{const J=await this.fileService.readFile(g.URI.file(w.translationsConfigFile));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}getTranslations(Q){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(se[276],oe([0,1,5,41,40,28,81,16,37,7]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let y=class extends D.AbstractExtensionsProfileScannerService{constructor(w,l,S,p,m,g){super(u.URI.file(w.extensionsPath),l,S,p,m,g)}};e.ExtensionsProfileScannerService=y,e.ExtensionsProfileScannerService=y=Ee([ne(0,f.INativeEnvironmentService),ne(1,I.IFileService),ne(2,L.IUserDataProfilesService),ne(3,r.IUriIdentityService),ne(4,O.ITelemetryService),ne(5,C.ILogService)],y)}),define(se[277],oe([0,1,7,37,81,129,16,6,5,27,40,41]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends O.NativeExtensionsScannerService{constructor(S,p,m,g,d,a,P,h){super(C.URI.file(d.builtinExtensionsPath),C.URI.file(d.extensionsPath),d.userHome,S.defaultProfile,S,p,m,g,d,a,P,h)}};e.ExtensionsScannerService=w,e.ExtensionsScannerService=w=Ee([ne(0,b.IUserDataProfilesService),ne(1,r.IExtensionsProfileScannerService),ne(2,D.IFileService),ne(3,f.ILogService),ne(4,L.INativeEnvironmentService),ne(5,u.IProductService),ne(6,y.IUriIdentityService),ne(7,I.IInstantiationService)],w)}),define(se[278],oe([0,1,15,2,13,9,4,57,7,32,36,37,5,41]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends L.Disposable{constructor(m,g,d){super(),this.environmentService=m,this.logService=d,this.validRoots=I.TernarySearchTree.forPaths(!D.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(m.appRoot),this.addValidFileRoot(m.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:r.Schemas.file}).fsPath),this.addValidFileRoot(m.workspaceStorageHome.with({scheme:r.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:m}=C.session;m.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(g,d)=>this.handleResourceRequest(g,d)),m.protocol.interceptFileProtocol(r.Schemas.file,(g,d)=>this.handleFileRequest(g,d)),this._register((0,L.toDisposable)(()=>{m.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),m.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(m){const g=(0,O.normalize)(m);return this.validRoots.get(g)?L.Disposable.None:(this.validRoots.set(g,!0),(0,L.toDisposable)(()=>this.validRoots.delete(g)))}handleFileRequest(m,g){const d=f.URI.parse(m.url);return this.logService.error(`Refused to load resource ${d.fsPath} from ${r.Schemas.file}: protocol (original URL: ${m.url})`),g({error:-3})}handleResourceRequest(m,g){const d=this.requestToNormalizedFilePath(m);let a;return this.environmentService.crossOriginIsolated&&((0,O.basename)(d)==="workbench.html"||(0,O.basename)(d)==="workbench-dev.html"?a=r.COI.CoopAndCoep:a=r.COI.getHeadersFromQuery(m.url)),this.validRoots.findSubstr(d)?g({path:d,headers:a}):this.validExtensions.has((0,O.extname)(d).toLowerCase())?g({path:d}):(this.logService.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${m.url})`),g({error:-3}))}requestToNormalizedFilePath(m){const g=f.URI.parse(m.url),d=r.FileAccess.uriToFileUri(g);return(0,O.normalize)(d.fsPath)}createIPCObjectUrl(){let m;const g=f.URI.from({scheme:"vscode",path:(0,u.generateUuid)()}),d=g.toString(),a=async()=>m;return y.validatedIpcMain.handle(d,a),this.logService.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:g,update:P=>m=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${d}.`),y.validatedIpcMain.removeHandler(d)}}}};e.ProtocolMainService=S,e.ProtocolMainService=S=Ee([ne(0,b.INativeEnvironmentService),ne(1,l.IUserDataProfilesService),ne(2,w.ILogService)],S)}),define(se[96],oe([0,1,8,3,2,68,12,111,6,41]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var y;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var w;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function l(d){const a=d.get(e.TARGET_KEY);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.loadKeyTargets=l;class S extends r.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(a={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super(),this.options=a,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new r.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(a,P,h){return L.Event.filter(this._onDidChangeValue.event,i=>i.scope===a&&(P===void 0||i.key===P),h)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,r.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,P){const{key:h,external:i}=P;if(h===e.TARGET_KEY){switch(a){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:a})}else this._onDidChangeValue.fire({scope:a,key:h,target:this.getKeyTargets(a)[h],external:i})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,P,h){return this.getStorage(P)?.get(a,h)}getBoolean(a,P,h){return this.getStorage(P)?.getBoolean(a,h)}getNumber(a,P,h){return this.getStorage(P)?.getNumber(a,h)}getObject(a,P,h){return this.getStorage(P)?.getObject(a,h)}storeAll(a,P){this.withPausedEmitters(()=>{for(const h of a)this.store(h.key,h.value,h.scope,h.target,P)})}store(a,P,h,i,o=!1){if((0,D.isUndefinedOrNull)(P)){this.remove(a,h,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,h,i),this.getStorage(h)?.set(a,P,o)})}remove(a,P,h=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(a,P,void 0),this.getStorage(P)?.delete(a,h)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,P){const h=[],i=this.getKeyTargets(a);for(const o of Object.keys(i))i[o]===P&&h.push(o);return h}updateKeyTarget(a,P,h,i=!1){const o=this.getKeyTargets(P);typeof h=="number"?o[a]!==h&&(o[a]=h,this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(o),i)):typeof o[a]=="number"&&(delete o[a],this.getStorage(P)?.set(e.TARGET_KEY,JSON.stringify(o),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(a){switch(a){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(a){const P=this.getStorage(a);return P?l(P):Object.create(null)}isNew(a){return this.getBoolean(e.IS_NEW_KEY,a)===!0}async flush(a=y.NONE){this._onWillSaveState.fire({reason:a});const P=this.getStorage(-1),h=this.getStorage(0),i=this.getStorage(1);switch(a){case y.NONE:await C.Promises.settled([P?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await C.Promises.settled([P?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.getStorage(-1)?.items??new Map,P=this.getStorage(0)?.items??new Map,h=this.getStorage(1)?.items??new Map;return g(a,P,h,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(a){return await this.flush(),this.getStorage(a)?.optimize()}async switch(a,P){return this.emitWillSaveState(y.NONE),(0,u.isUserDataProfile)(a)?this.switchToProfile(a,P):this.switchToWorkspace(a,P)}canSwitchProfile(a,P){return!(a.id===P.id||p(P)&&p(a))}switchData(a,P,h){this.withPausedEmitters(()=>{const i=new Set;for(const[o,s]of a)i.add(o),P.get(o)!==s&&this.emitDidChangeValue(h,{key:o,external:!0});for(const[o]of P.items)i.has(o)||this.emitDidChangeValue(h,{key:o,external:!0})})}}e.AbstractStorageService=S;function p(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=p;class m extends S{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.profileStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a))),this._register(this.applicationStorage.onDidChangeStorage(a=>this.emitDidChangeValue(-1,a)))}getStorage(a){switch(a){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(a){return!1}}e.InMemoryStorageService=m;async function g(d,a,P,h,i,o){const s=_=>{try{return JSON.parse(_)}catch{return _}},t=new Map,n=new Map;d.forEach((_,T)=>{t.set(T,_),n.set(T,s(_))});const c=new Map,v=new Map;a.forEach((_,T)=>{c.set(T,_),v.set(T,s(_))});const R=new Map,k=new Map;P.forEach((_,T)=>{R.set(T,_),k.set(T,s(_))}),console.group(h!==i?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const E=[];if(t.forEach((_,T)=>{E.push({key:T,value:_})}),console.table(E),console.groupEnd(),console.log(n),h!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const _=[];c.forEach((T,U)=>{_.push({key:U,value:T})}),console.table(_),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${o})`);const M=[];R.forEach((_,T)=>{M.push({key:T,value:_})}),console.table(M),console.groupEnd(),console.log(k)}e.logStorage=g}),define(se[279],oe([0,1,23,8,3,2,9,73,7,21,111,161,5,96,28,30,13]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class g extends O.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(s,t){super(),this.logService=s,this.fileService=t,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new L.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=y.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===y.StorageState.None)try{const s=this._register(await this.doCreate());this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(n=>this._onDidChangeStorage.fire(n))),await this.doInit(s);const t=s.getBoolean(l.IS_NEW_KEY);t===void 0?s.set(l.IS_NEW_KEY,!0):t&&s.set(l.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=y.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,t){return this._storage.get(s,t)}set(s,t){return this._storage.set(s,t)}delete(s){return this._storage.delete(s)}optimize(){return this._storage.optimize()}async close(){const s=new I.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>g.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(this.path)try{const t=(0,C.top)(Array.from(this._storage.items.entries()).map(([c,v])=>({key:c,length:v.length})),(c,v)=>v.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),n=(await this.fileService.stat(f.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=y.StorageState.Closed,await this._storage.close()}}class d extends g{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,d.STORAGE_NAME)}constructor(s,t,n,c){super(n,c),this.profile=s,this.options=t}async doCreate(){return new y.Storage(new b.SQLiteStorageDatabase(this.path??b.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}class a extends d{constructor(s,t,n,c){super(s,t,n,c)}}e.ProfileStorageMain=a;class P extends d{constructor(s,t,n,c){super(t.defaultProfile,s,n,c)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(S.firstSessionDateStorageKey,void 0)===void 0&&s.set(S.firstSessionDateStorageKey,new Date().toUTCString());const n=s.get(S.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();s.set(S.lastSessionDateStorageKey,typeof n>"u"?null:n),s.set(S.currentSessionDateStorageKey,c)}}e.ApplicationStorageMain=P;class h extends g{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}constructor(s,t,n,c,v){super(n,v),this.workspace=s,this.options=t,this.environmentService=c}async doCreate(){const{storageFilePath:s,wasCreated:t}=await this.prepareWorkspaceStorageFolder();return new y.Storage(new b.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:t?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:b.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,D.join)(this.environmentService.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,this.workspace.id),t=(0,D.join)(s,h.WORKSPACE_STORAGE_NAME);return await u.Promises.exists(s)?{storageFilePath:t,wasCreated:!1}:(await u.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:t,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let t;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?t={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(t={workspace:this.workspace.configPath.toString()}),t)try{const n=(0,D.join)(s,h.WORKSPACE_META_NAME);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=h;class i extends g{get path(){}async doCreate(){return new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=i}),define(se[280],oe([0,1,3,2,96]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class O extends L.Disposable{constructor(I,f,u){super(),this.storageMainService=I,this.userDataProfilesService=f,this.logService=u;const y=this._register(new L.MutableDisposable);this._onDidChange=this._register(new C.Emitter({onWillAddFirstListener:()=>y.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>y.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new L.DisposableStore;return I.add(C.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(f,u)=>(f?f.push(u.key):f=[u.key],f),100)(f=>this.onDidChangeApplicationStorage(f))),I.add(C.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(f,u)=>{f||(f=new Map);let y=f.get(u.profile.id);return y||f.set(u.profile.id,y={profile:u.profile,keys:[],storage:u.storage}),y.keys.push(u.key),f},100)(f=>this.onDidChangeProfileStorage(f))),I}onDidChangeApplicationStorage(I){const f=I.includes(r.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],u=[];if(I=I.filter(y=>y!==r.TARGET_KEY),I.length){const y=(0,r.loadKeyTargets)(this.storageMainService.applicationStorage.storage);u.push({profile:this.userDataProfilesService.defaultProfile,changes:I.map(b=>({key:b,scope:0,target:y[b]}))})}this.triggerEvents(f,u)}onDidChangeProfileStorage(I){const f=[],u=new Map;for(const[y,b]of I.entries()){b.keys.includes(r.TARGET_KEY)&&f.push(b.profile);const w=b.keys.filter(l=>l!==r.TARGET_KEY);if(w.length){const l=(0,r.loadKeyTargets)(b.storage.storage);u.set(y,{profile:b.profile,changes:w.map(S=>({key:S,scope:0,target:l[S]}))})}}this.triggerEvents(f,[...u.values()])}triggerEvents(I,f){(I.length||f.length)&&this._onDidChange.fire({valueChanges:f,targetChanges:I})}listen(I,f,u){switch(f){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${f}`)}async call(I,f){throw new Error(`Call not found: ${f}`)}}e.ProfileStorageChangesListenerChannel=O}),define(se[281],oe([0,1,7,37,16,5,34,40,41,12,121]),function(V,e,C,L,r,O,D,I,f,u,y){"use strict";var b,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let l=class extends f.UserDataProfilesService{static{b=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(g,d,a,P,h){super(a,P,d,h),this.stateReadonlyService=g,this.nativeEnvironmentService=a}getStoredProfiles(){return this.stateReadonlyService.getItem(b.PROFILES_KEY,[]).map(d=>({...d,location:(0,u.isString)(d.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,d.location):C.URI.revive(d.location)}))}getStoredProfileAssociations(){const g=this.stateReadonlyService.getItem(b.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(b.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?g:this.migrateStoredProfileAssociations(g)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(C.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=l,e.UserDataProfilesReadonlyService=l=b=Ee([ne(0,D.IStateReadService),ne(1,I.IUriIdentityService),ne(2,L.INativeEnvironmentService),ne(3,r.IFileService),ne(4,O.ILogService)],l);let S=w=class extends l{constructor(g,d,a,P,h){super(g,d,a,P,h),this.stateService=g}saveStoredProfiles(g){g.length?this.stateService.setItem(w.PROFILES_KEY,g.map(d=>({...d,location:this.uriIdentityService.extUri.basename(d.location)}))):this.stateService.removeItem(w.PROFILES_KEY)}getStoredProfiles(){const g=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(g),this.stateService.setItem("userDataProfilesMigration",!0)),g}saveStoredProfileAssociations(g){g.emptyWindows||g.workspaces?this.stateService.setItem(w.PROFILE_ASSOCIATIONS_KEY,g):this.stateService.removeItem(w.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const g="workspaceAndProfileInfo",d=this.stateService.getItem(g,void 0);if(d){this.stateService.removeItem(g);const P=d.reduce((h,{workspace:i,profile:o})=>(h[C.URI.revive(i).toString()]=C.URI.revive(o).toString(),h),{});this.stateService.setItem(w.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}const a=super.getStoredProfileAssociations();return this.stateService.getItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(a),this.stateService.setItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),a}};e.UserDataProfilesService=S,e.UserDataProfilesService=S=w=Ee([ne(0,D.IStateService),ne(1,I.IUriIdentityService),ne(2,L.INativeEnvironmentService),ne(3,r.IFileService),ne(4,O.ILogService)],S);let p=class extends S{constructor(g,d,a,P){super(new y.StateService(0,d,P,a),g,d,a,P)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=p,e.ServerUserDataProfilesService=p=Ee([ne(0,I.IUriIdentityService),ne(1,L.INativeEnvironmentService),ne(2,r.IFileService),ne(3,O.ILogService)],p)}),define(se[54],oe([0,1,37,16,6,5,40,41,281,34]),function(V,e,C,L,r,O,D,I,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,r.refineServiceDecorator)(I.IUserDataProfilesService);let y=class extends f.UserDataProfilesService{constructor(w,l,S,p,m){super(w,l,S,p,m)}getAssociatedEmptyWindows(){const w=[];for(const l of this.profilesObject.emptyWindows.keys())w.push({id:l});return w}};e.UserDataProfilesMainService=y,e.UserDataProfilesMainService=y=Ee([ne(0,u.IStateService),ne(1,D.IUriIdentityService),ne(2,C.INativeEnvironmentService),ne(3,L.IFileService),ne(4,O.ILogService)],y)}),define(se[130],oe([0,1,19,7,30]),function(V,e,C,L,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function O(f,u,y){for(const w of f){const l=w.openedWorkspace;if((0,r.isWorkspaceIdentifier)(l)){const S=await y(l);if(S){if(S.folders.some(p=>C.extUriBiasedIgnorePathCase.isEqualOrParent(u,p.uri)))return w}else if(C.extUriBiasedIgnorePathCase.isEqualOrParent(u,l.configPath))return w}}const b=f.filter(w=>(0,r.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqualOrParent(u,w.openedWorkspace.uri));if(b.length)return b.sort((w,l)=>-(w.openedWorkspace.uri.path.length-l.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=O;function D(f,u){for(const y of f)if((0,r.isWorkspaceIdentifier)(y.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,u)||(0,r.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&C.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,u))return y}e.findWindowOnWorkspaceOrFolder=D;function I(f,u){const y=b=>u.some(w=>C.extUriBiasedIgnorePathCase.isEqual(L.URI.file(w),L.URI.file(b)));for(const b of f)if(b.config?.extensionDevelopmentPath?.some(w=>y(w)))return b}e.findWindowOnExtensionDevelopmentPath=I}),define(se[97],oe([0,1,33,44,139,47,13,9,4,19,7,6,59,30]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function S(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function p(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=p;function m(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=m;function g(k){return d(k)||a(k)}e.isStoredWorkspaceFolder=g;function d(k){const E=k;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function a(k){const E=k;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function P(k,E,M,_,T){if(k.scheme!==_.scheme)return{name:M,uri:k.toString(!0)};let U=E?void 0:T.relativePath(_,k);if(U!==void 0)U.length===0?U=".":f.isWindows&&(U=h(U));else if(k.scheme===D.Schemas.file)U=k.fsPath,f.isWindows&&(U=h(U));else if(T.isEqualAuthority(k.authority,_.authority))U=k.path;else return{name:M,uri:k.toString(!0)};return{name:M,path:U}}e.getStoredWorkspaceFolder=P;function h(k){return k=(0,O.normalizeDriveLetter)(k),(0,C.isUNC)(k)||(k=(0,C.toSlashes)(k)),k}function i(k,E,M){const _=[],T=new Set,U=M.dirname(E);for(const X of k){let Y;if(d(X))X.path&&(Y=M.resolvePath(U,X.path));else if(a(X))try{Y=y.URI.parse(X.uri),Y.path[0]!==I.posix.sep&&(Y=Y.with({path:I.posix.sep+Y.path}))}catch(le){console.warn(le)}if(Y){const le=M.getComparisonKey(Y);if(!T.has(le)){T.add(le);const ce=X.name||M.basenameOrAuthority(Y);_.push(new l.WorkspaceFolder({uri:Y,name:ce,index:_.length},X))}}}return _}e.toWorkspaceFolders=i;function o(k,E,M,_,T){const U=s(E,k),X=T.dirname(E),Y=T.dirname(_),le=[];for(const G of U.folders){const x=d(G)?T.resolvePath(X,G.path):y.URI.parse(G.uri);let W;M?W=!1:W=!d(G)||(0,I.isAbsolute)(G.path),le.push(P(x,W,G.name,Y,T))}const ce={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},ue=r.setProperty(k,["folders"],le,ce);let Q=r.applyEdits(k,ue);return(0,u.isEqualAuthority)(U.remoteAuthority,(0,w.getRemoteAuthority)(_))&&(Q=r.applyEdits(Q,r.removeProperty(Q,["remoteAuthority"],ce))),Q}e.rewriteWorkspaceFileForNewLocation=o;function s(k,E){const M=L.parse(E);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(_=>g(_));else throw new Error(`${k} looks like an invalid workspace file.`);return M}function t(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function n(k){return typeof k.folderUri=="string"}function c(k){return typeof k.fileUri=="string"}function v(k,E){const M={workspaces:[],files:[]};if(k){const _=function(U,X){for(let Y=0;Y<U.length;Y++)try{X(U[Y],Y)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(U[Y])}: ${le.toString()}. Skip entry.`)}},T=k;Array.isArray(T.entries)&&_(T.entries,U=>{const X=U.label,Y=U.remoteAuthority;t(U)?M.workspaces.push({label:X,remoteAuthority:Y,workspace:{id:U.workspace.id,configPath:y.URI.parse(U.workspace.configPath)}}):n(U)?M.workspaces.push({label:X,remoteAuthority:Y,folderUri:y.URI.parse(U.folderUri)}):c(U)&&M.files.push({label:X,remoteAuthority:Y,fileUri:y.URI.parse(U.fileUri)})})}return M}e.restoreRecentlyOpened=v;function R(k){const E={entries:[]};for(const M of k.workspaces)p(M)?E.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):E.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of k.files)E.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return E}e.toStoreData=R}),define(se[98],oe([0,1,86,13,4,19]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(u){function y(){let b=u.scheme===L.Schemas.file?(0,O.originalFSPath)(u):u.toString();return r.isLinux||(b=b.toLowerCase()),(0,C.createHash)("md5").update(b).digest("hex")}return{id:y(),configPath:u}}e.getWorkspaceIdentifier=D;function I(u,y){function b(){if(u.scheme!==L.Schemas.file)return(0,C.createHash)("md5").update(u.toString()).digest("hex");if(!y)return;let l;return r.isLinux?l=y.ino:r.isMacintosh?l=y.birthtime.getTime():r.isWindows&&(typeof y.birthtimeMs=="number"?l=Math.floor(y.birthtimeMs):l=y.birthtime.getTime()),(0,C.createHash)("md5").update(u.fsPath).update(l?String(l):"").digest("hex")}const w=b();if(typeof w=="string")return{id:w,uri:u}}e.getSingleFolderWorkspaceIdentifier=I;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=f}),define(se[99],oe([0,1,86,87,26,282,18,14,3,2,9,4,32,42,109]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(E,M){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,M)}constructor(E,M=""){this._canWrite=!0,this.debugLabel=M,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,I.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener),this._closeListener=_=>{this.traceSocketEvent("close",{hadError:_}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(E){const M=_=>{this.traceSocketEvent("read",_),E(D.VSBuffer.wrap(_))};return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(E){const M=_=>{E({type:0,hadError:_,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(E){const M=()=>{E()};return this.socket.on("end",M),{dispose:()=>this.socket.off("end",M)}}write(E){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,I.onUnexpectedError)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,I.onUnexpectedError)(M)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,M)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=p;var m;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var g;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(g||(g={}));class d extends u.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(E,M){this.socket.traceSocketEvent(E,M)}constructor(E,M,_,T){super(),this._onData=this._register(new f.Emitter),this._onClose=this._register(new f.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:M,inflateBytesLength:_?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new a(this,M,_,T,this._onData,(U,X)=>this._write(U,X))),this._register(this._flowManager.onError(U=>{console.error(U),(0,I.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(async U=>{this._flowManager.isProcessingReadQueue()&&await f.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(U)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let M=0;for(;M<E.byteLength;)this._flowManager.writeMessage(E.slice(M,Math.min(M+262144,E.byteLength)),{compressed:!0,opcode:2}),M+=262144}_write(E,{compressed:M,opcode:_}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let T=2;E.byteLength<126?T+=0:E.byteLength<2**16?T+=2:T+=8;const U=D.VSBuffer.alloc(T),X=M?64:0,Y=_&15;if(U.writeUInt8(128|X|Y,0),E.byteLength<126)U.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){U.writeUInt8(126,1);let le=1;U.writeUInt8(E.byteLength>>>8&255,++le),U.writeUInt8(E.byteLength>>>0&255,++le)}else{U.writeUInt8(127,1);let le=1;U.writeUInt8(0,++le),U.writeUInt8(0,++le),U.writeUInt8(0,++le),U.writeUInt8(0,++le),U.writeUInt8(E.byteLength>>>24&255,++le),U.writeUInt8(E.byteLength>>>16&255,++le),U.writeUInt8(E.byteLength>>>8&255,++le),U.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(D.VSBuffer.concat([U,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),_=M.readUInt8(0),T=(_&128)>>>7,U=(_&64)>>>6,X=_&15,Y=M.readUInt8(1),le=(Y&128)>>>7,ce=Y&127;this._state.state=2,this._state.readLen=2+(le?4:0)+(ce===126?2:0)+(ce===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=!!U),this._state.firstFrameOfMessage=!!T,this._state.mask=0,this._state.opcode=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),_=M.readUInt8(1),T=(_&128)>>>7;let U=_&127,X=1;U===126?U=M.readUInt8(++X)*2**8+M.readUInt8(++X):U===127&&(U=M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*2**24+M.readUInt8(++X)*2**16+M.readUInt8(++X)*2**8+M.readUInt8(++X));let Y=0;T&&(Y=M.readUInt8(++X)*2**24+M.readUInt8(++X)*2**16+M.readUInt8(++X)*2**8+M.readUInt8(++X)),this._state.state=3,this._state.readLen=U,this._state.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",M),i(M,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",M),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(M,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(M,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await f.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class a extends u.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(E,M,_,T,U,X){super(),this._tracer=E,this._onData=U,this._writeFn=X,this._onError=this._register(new f.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new f.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new f.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,M?(this._zlibInflateStream=this._register(new P(this._tracer,T,_,{windowBits:15})),this._zlibDeflateStream=this._register(new h(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Y=>this._onError.fire(Y))),this._register(this._zlibDeflateStream.onError(Y=>this._onError.fire(Y)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(E,M){this._writeQueue.push({data:E,options:M}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:E,options:M}=this._writeQueue.shift();if(this._zlibDeflateStream&&M.compressed){const _=await this._deflateMessage(this._zlibDeflateStream,E);this._writeFn(_,M)}else this._writeFn(E,{...M,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(E,M){return new Promise((_,T)=>{E.write(M),E.flush(U=>_(U))})}acceptFrame(E,M,_){this._readQueue.push({data:E,isCompressed:M,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const E=this._readQueue.shift();if(this._zlibInflateStream&&E.isCompressed){const M=await this._inflateFrame(this._zlibInflateStream,E.data,E.isLastFrameOfMessage);this._onData.fire(M)}else this._onData.fire(E.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(E,M,_){return new Promise((T,U)=>{E.write(M),_&&E.write(D.VSBuffer.fromByteArray([0,0,255,255])),E.flush(X=>T(X))})}}class P extends u.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(E,M,_,T){super(),this._tracer=E,this._recordInflateBytes=M,this._onError=this._register(new f.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,O.createInflateRaw)(T),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(D.VSBuffer.wrap(U))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(E){this._recordInflateBytes&&this._recordedInflateBytes.push(E.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",E),this._zlibInflate.write(E.buffer)}flush(E){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const M=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,E(M)})}}class h extends u.Disposable{constructor(E,M){super(),this._tracer=E,this._onError=this._register(new f.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,O.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(D.VSBuffer.wrap(_))})}write(E){this._tracer.traceSocketEvent("zlibDeflateWrite",E.buffer),this._zlibDeflate.write(E.buffer)}flush(E){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let M=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.byteLength-4),E(M)})}}function i(k,E){if(E===0)return;const M=k.byteLength>>>2;for(let le=0;le<M;le++){const ce=k.readUInt32BE(le*4);k.writeUInt32BE(ce^E,le*4)}const _=M*4,T=k.byteLength-_,U=E>>>24&255,X=E>>>16&255,Y=E>>>8&255;T>=1&&k.writeUInt8(k.readUInt8(_)^U,_),T>=2&&k.writeUInt8(k.readUInt8(_+1)^X,_+1),T>=3&&k.writeUInt8(k.readUInt8(_+2)^Y,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const k=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const E=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,r.tmpdir)(),M=(0,y.join)(E,`vscode-ipc-${k}.sock`);return n(M),M}e.createRandomIPCHandle=s;function t(k,E,M){const _=(0,C.createHash)("md5").update(k).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${M}-${E}-sock`;const T=M.substr(0,4),U=E.substr(0,6),X=_.substr(0,8);let Y;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Y=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${X}-${T}-${U}.sock`):Y=(0,y.join)(k,`${T}-${U}.sock`),n(Y),Y}e.createStaticIPCHandle=t;function n(k){const E=o[b.platform];typeof E=="number"&&k.length>=E&&console.warn(`WARNING: IPC handle "${k}" is longer than ${E} chars, try a shorter --user-data-dir`)}class c extends l.IPCServer{static toClientConnectionEvent(E){const M=f.Event.fromNodeEventEmitter(E,"connection");return f.Event.map(M,_=>({protocol:new S.Protocol(new p(_,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(_,"close"))}))}constructor(E){super(c.toClientConnectionEvent(E)),this.server=E}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=c;function v(k){return new Promise((E,M)=>{const _=(0,L.createServer)();_.on("error",M),_.listen(k,()=>{_.removeListener("error",M),E(new c(_))})})}e.serve=v;function R(k,E){return new Promise((M,_)=>{const T=(0,L.createConnection)(k,()=>{T.removeListener("error",_),M(S.Client.fromSocket(new p(T,`ipc-client${E}`),E))});T.once("error",_)})}e.connect=R}),define(se[24],oe([0,1,56,9,4,99,37,90,6]),function(V,e,C,L,r,O,D,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,f.refineServiceDecorator)(D.IEnvironmentService);class u extends I.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.isLinux){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const w=b.slice(0,-17);if(this._snapEnv[w])continue;process.env[w]&&(this._snapEnv[w]=process.env[w]),process.env[b]?process.env[w]=process.env[b]:delete process.env[w]}}}restoreSnapExportedVariables(){if(r.isLinux)for(const b in this._snapEnv)process.env[b]=this._snapEnv[b],delete this._snapEnv[b]}}e.EnvironmentMainService=u,Ee([C.memoize],u.prototype,"cachedLanguagesPath",null),Ee([C.memoize],u.prototype,"backupHome",null),Ee([C.memoize],u.prototype,"mainIPCHandle",null),Ee([C.memoize],u.prototype,"mainLockfile",null),Ee([C.memoize],u.prototype,"disableUpdates",null),Ee([C.memoize],u.prototype,"crossOriginIsolated",null),Ee([C.memoize],u.prototype,"codeCachePath",null),Ee([C.memoize],u.prototype,"useCodeCache",null)}),define(se[283],oe([0,1,86,33,13,9,4,19,21,196,17,24,34,16,5,195,30,98]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let a=class{static{d=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(h,i,o,s){this.environmentMainService=h,this.configurationService=i,this.logService=o,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,n)=>(0,L.isEqual)(t,n,!D.isLinux)}}async initialize(){const h=this.stateService.getItem(d.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWindows),this.workspaces=await this.validateWorkspaces((0,u.deserializeWorkspaceInfos)(h)),this.folders=await this.validateFolders((0,u.deserializeFolderInfos)(h)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==l.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===l.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||l.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(h,i){this.workspaces.some(s=>h.workspace.id===s.workspace.id)||(this.workspaces.push(h),this.storeWorkspacesMetadata());const o=(0,O.join)(this.backupHome,h.workspace.id);return i?this.moveBackupFolder(o,i).then(()=>o):o}async moveBackupFolder(h,i){if(await f.Promises.exists(h)&&await this.convertToEmptyWindowBackup(h),await f.Promises.exists(i))try{await f.Promises.rename(i,h,!1)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(h){return this.folders.some(i=>this.backupUriComparer.isEqual(h.folderUri,i.folderUri))||(this.folders.push(h),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,this.getFolderHash(h))}registerEmptyWindowBackup(h){return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,h.backupFolder))||(this.emptyWindows.push(h),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,h.backupFolder)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const i=new Set,o=[];for(const s of h){const t=s.workspace;if(!(0,m.isWorkspaceIdentifier)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,O.join)(this.backupHome,t.id);await this.doHasBackups(n)?t.configPath.scheme!==r.Schemas.file||await f.Promises.exists(t.configPath.fsPath)?o.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return o}async validateFolders(h){if(!Array.isArray(h))return[];const i=[],o=new Set;for(const s of h){const t=s.folderUri,n=this.backupUriComparer.getComparisonKey(t);if(!o.has(n)){o.add(n);const c=(0,O.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(c)?t.scheme!==r.Schemas.file||await f.Promises.exists(t.fsPath)?i.push(s):await this.convertToEmptyWindowBackup(c):await this.deleteStaleBackup(c)}}return i}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const i=[],o=new Set;for(const s of h){const t=s.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,O.join)(this.backupHome,t);await this.doHasBackups(n)?i.push(s):await this.deleteStaleBackup(n)}}return i}async deleteStaleBackup(h){try{await f.Promises.rm(h,f.RimRafMode.MOVE)}catch(i){this.logService.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}prepareNewEmptyWindowBackup(){let h=(0,g.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,h.id));)h=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:h.id}}async convertToEmptyWindowBackup(h){const i=this.prepareNewEmptyWindowBackup(),o=(0,O.join)(this.backupHome,i.backupFolder);try{await f.Promises.rename(h,o,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(i),!0}async getDirtyWorkspaces(){const h=[];for(const i of this.workspaces)await this.hasBackups(i)&&h.push(i);for(const i of this.folders)await this.hasBackups(i)&&h.push(i);return h}hasBackups(h){let i;return(0,u.isEmptyWindowBackupInfo)(h)?i=(0,O.join)(this.backupHome,h.backupFolder):(0,p.isFolderBackupInfo)(h)?i=(0,O.join)(this.backupHome,this.getFolderHash(h)):i=(0,O.join)(this.backupHome,h.workspace.id),this.doHasBackups(i)}async doHasBackups(h){try{const i=await f.Promises.readdir(h);for(const o of i)try{if((await f.Promises.readdir((0,O.join)(h,o))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const h={workspaces:this.workspaces.map(({workspace:i,remoteAuthority:o})=>{const s={id:i.id,configURIPath:i.configPath.toString()};return o&&(s.remoteAuthority=o),s}),folders:this.folders.map(({folderUri:i,remoteAuthority:o})=>{const s={folderUri:i.toString()};return o&&(s.remoteAuthority=o),s}),emptyWindows:this.emptyWindows.map(({backupFolder:i,remoteAuthority:o})=>{const s={backupFolder:i};return o&&(s.remoteAuthority=o),s})};this.stateService.setItem(d.backupWorkspacesMetadataStorageKey,h)}getFolderHash(h){const i=h.folderUri;let o;return i.scheme===r.Schemas.file?o=D.isLinux?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,C.createHash)("md5").update(o).digest("hex")}};e.BackupMainService=a,e.BackupMainService=a=d=Ee([ne(0,b.IEnvironmentMainService),ne(1,y.IConfigurationService),ne(2,S.ILogService),ne(3,w.IStateService)],a)}),define(se[20],oe([0,1,15,36,8,3,2,4,35,12,6,5,34,24]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var p;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(p||(e.ShutdownReason=p={}));var m;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(m||(e.LifecycleMainPhase=m={}));let g=class extends D.Disposable{static{S=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(a,P,h){super(),this.logService=a,this.stateService=P,this.environmentMainService=h,this._onBeforeShutdown=this._register(new O.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new O.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new O.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new O.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(S.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(S.QUIT_AND_RESTART_KEY)}registerListeners(){const a=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};C.app.addListener("before-quit",a);const P=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&C.app.quit()};C.app.addListener("window-all-closed",P),C.app.once("will-quit",h=>{this.trace("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),C.app.removeListener("before-quit",a),C.app.removeListener("window-all-closed",P),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),C.app.quit()})})}fireOnWillShutdown(a){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const P=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const h=[];return this._onWillShutdown.fire({reason:a,join(i,o){P.trace(`Lifecycle#onWillShutdown - begin '${i}'`),h.push(o.finally(()=>{P.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(h)}catch(i){this.logService.error(i)}try{await this.stateService.close()}catch(i){this.logService.error(i)}})(),this.pendingWillShutdownPromise}set phase(a){if(a<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===a)return;this.trace(`lifecycle (main): phase changed (value: ${a})`),this._phase=a;const P=this.phaseWhen.get(this._phase);P&&(P.open(),this.phaseWhen.delete(this._phase))}async when(a){if(a<=this._phase)return;let P=this.phaseWhen.get(a);P||(P=new r.Barrier,this.phaseWhen.set(a,P)),await P.wait()}registerWindow(a){const P=new D.DisposableStore;this.windowCounter++,P.add(a.onWillLoad(i=>this._onWillLoadWindow.fire({window:a,workspace:i.workspace,reason:i.reason})));const h=(0,u.assertIsDefined)(a.win);h.on("close",i=>{const o=a.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.trace(`Lifecycle#window.on('close') - window ID ${a.id}`),i.preventDefault(),this.unload(a,1).then(s=>{if(s){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(a),a.close()})}),h.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${a.id}`),this.windowCounter--,P.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(a,P){await this.unload(a,3)||a.reload(P)}unload(a,P){const h=this.mapWindowIdToPendingUnload.get(a.id);if(h)return h;const i=this.doUnload(a,P).finally(()=>{this.mapWindowIdToPendingUnload.delete(a.id)});return this.mapWindowIdToPendingUnload.set(a.id,i),i}async doUnload(a,P){if(!a.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${a.id}`);const h=this._quitRequested?2:P,i=await this.onBeforeUnloadWindowInRenderer(a,h);return i?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${a.id})`),this.handleWindowUnloadVeto(i)):(await this.onWillUnloadWindowInRenderer(a,h),!1)}handleWindowUnloadVeto(a){return a?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(a){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(a),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(a,P){return new Promise(h=>{const i=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${i}`,s=`vscode:cancel${i}`;L.validatedIpcMain.once(o,()=>{h(!1)}),L.validatedIpcMain.once(s,()=>{h(!0)}),a.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:P})})}onWillUnloadWindowInRenderer(a,P){return new Promise(h=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;L.validatedIpcMain.once(o,()=>h()),a.send("vscode:onWillUnload",{replyChannel:o,reason:P})})}quit(a){return this.doQuit(a).then(P=>{if(!P&&a)try{if(I.isWindows){const h=(0,f.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.logService.error(h)}return P})}doQuit(a){return this.trace(`Lifecycle#quit() - begin (willRestart: ${a})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(a&&this.stateService.setItem(S.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(P=>{this.pendingQuitPromiseResolve=P,this.trace("Lifecycle#quit() - calling app.quit()"),C.app.quit()}),this.pendingQuitPromise)}trace(a){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(a):this.logService.trace(a)}setRelaunchHandler(a){this.relaunchHandler=a}async relaunch(a){this.trace("Lifecycle#relaunch()");const P=process.argv.slice(1);if(a?.addArgs&&P.push(...a.addArgs),a?.removeArgs)for(const o of a.removeArgs){const s=P.indexOf(o);s>=0&&P.splice(s,1)}const h=()=>{this.relaunchHandler?.handleRelaunch(a)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),C.app.relaunch({args:P}))};C.app.once("quit",h),await this.quit(!0)&&C.app.removeListener("quit",h)}async kill(a){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const P of C.BrowserWindow.getAllWindows())if(P&&!P.isDestroyed()){let h;P.webContents&&!P.webContents.isDestroyed()?h=new Promise(i=>P.once("closed",i)):h=Promise.resolve(),P.destroy(),await h}})()]),C.app.exit(a)}};e.LifecycleMainService=g,e.LifecycleMainService=g=S=Ee([ne(0,b.ILogService),ne(1,w.IStateService),ne(2,l.IEnvironmentMainService)],g)}),define(se[284],oe([0,1,4,3,2,6,20]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,O.createDecorator)("keyboardLayoutMainService");let I=class extends r.Disposable{constructor(y){super(),this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((b,w)=>{V(["native-keymap"],b,w)});this._keyboardLayoutData=f(y),C.isCI||y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=f(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=I,e.KeyboardLayoutMainService=I=Ee([ne(0,D.ILifecycleMainService)],I);function f(u){const y=u.getKeyMap(),b=u.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:b}}}),define(se[285],oe([0,1,246,8,18,14,12,17,37,94,5,51,245,282]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let S=class extends b.AbstractRequestService{constructor(d,a,P,h){super(h),this.configurationService=d,this.environmentService=a,this.logService=P,this.configure(),this._register(d.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.configure()}))}configure(){const d=this.configurationService.getValue("http");this.proxyUrl=d?.proxy,this.strictSSL=!!d?.proxyStrictSSL,this.authorization=d?.proxyAuthorization}async request(d,a){const{proxyUrl:P,strictSSL:h}=this;let i;try{i=await(0,u.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(t){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,O.getErrorMessage)(t)))}const o={...process.env,...i},s=d.agent?d.agent:await(0,w.getProxyAgent)(d.url||"",o,{proxyUrl:P,strictSSL:h});return d.agent=s,d.strictSSL=h,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(d.isChromiumNetwork?"electron":"node",d,()=>m(d,a))}async resolveProxy(d){}async loadCertificates(){return(await new Promise((a,P)=>{V(["@vscode/proxy-agent"],a,P)})).loadSystemCertificates({log:this.logService})}};e.RequestService=S,e.RequestService=S=Ee([ne(0,I.IConfigurationService),ne(1,f.INativeEnvironmentService),ne(2,y.ILogService),ne(3,y.ILoggerService)],S);async function p(g){return((0,C.parse)(g.url).protocol==="https:"?await new Promise((P,h)=>{V(["https"],P,h)}):await new Promise((P,h)=>{V(["http"],P,h)})).request}async function m(g,d){return L.Promises.withAsyncBody(async(a,P)=>{const h=(0,C.parse)(g.url),i=g.getRawRequest?g.getRawRequest(g):await p(g),o={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const s=i(o,t=>{const n=(0,D.isNumber)(g.followRedirects)?g.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)m({...g,url:t.headers.location,followRedirects:n-1},d).then(a,P);else{let c=t;!g.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(c=t.pipe((0,l.createGunzip)())),a({res:t,stream:(0,r.streamToBufferReadableStream)(c)})}});s.on("error",P),g.timeout&&s.setTimeout(g.timeout),g.isChromiumNetwork&&s.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&s.write(g.data),s.end(),d.onCancellationRequested(()=>{s.abort(),P(new O.CancellationError)})})}e.nodeRequest=m}),define(se[286],oe([0,1,15,285]),function(V,e,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function r(D){return C.net.request}class O extends L.RequestService{request(I,f){return super.request({...I||{},getRawRequest:r,isChromiumNetwork:!0},f)}}e.RequestMainService=O}),define(se[82],oe([0,1,7,3,2,37,16,6,20,5,96,279,41,54,40,13]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,I.createDecorator)("storageMainService");let m=class extends r.Disposable{constructor(a,P,h,i,o,s){super(),this.logService=a,this.environmentService=P,this.userDataProfilesService=h,this.lifecycleMainService=i,this.fileService=o,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new L.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(a=>{a.window.profile&&this.profileStorage(a.window.profile).init(),a.workspace&&this.workspaceStorage(a.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(a=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=a.reason,a.join("applicationStorage",this.applicationStorage.close());for(const[,P]of this.mapProfileToStorage)a.join("profileStorage",P.close());for(const[,P]of this.mapWorkspaceToStorage)a.join("workspaceStorage",P.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(a=>{a.join((async()=>{await this.fileService.exists(a.profile.globalStorageHome)||await this.fileService.createFolder(a.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(a=>{const P=this.mapProfileToStorage.get(a.profile.id);P&&a.join(P.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const a=new b.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(L.Event.once(a.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),a}profileStorage(a){if((0,y.isProfileUsingDefaultStorage)(a))return this.applicationStorage;let P=this.mapProfileToStorage.get(a.id);if(!P){this.logService.trace(`StorageMainService: creating profile storage (${a.name})`),P=this._register(this.createProfileStorage(a)),this.mapProfileToStorage.set(a.id,P);const h=this._register(P.onDidChangeStorage(i=>this._onDidChangeProfileStorage.fire({...i,storage:P,profile:a})));this._register(L.Event.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${a.name})`),this.mapProfileToStorage.delete(a.id),h.dispose()}))}return P}createProfileStorage(a){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.ProfileStorageMain(a,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(a){let P=this.mapWorkspaceToStorage.get(a.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${a.id})`),P=this._register(this.createWorkspaceStorage(a)),this.mapWorkspaceToStorage.set(a.id,P),this._register(L.Event.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${a.id})`),this.mapWorkspaceToStorage.delete(a.id)}))),P}createWorkspaceStorage(a){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.WorkspaceStorageMain(a,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(a){const P=C.URI.file(a);for(const h of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(h.path&&this.uriIdentityService.extUri.isEqualOrParent(C.URI.file(h.path),P))return!0;return!1}};e.StorageMainService=m,e.StorageMainService=m=Ee([ne(0,u.ILogService),ne(1,O.IEnvironmentService),ne(2,l.IUserDataProfilesMainService),ne(3,f.ILifecycleMainService),ne(4,D.IFileService),ne(5,S.IUriIdentityService)],m),e.IApplicationStorageMainService=(0,I.createDecorator)("applicationStorageMainService");let g=class extends y.AbstractStorageService{constructor(a,P){super(),this.userDataProfilesService=a,this.storageMainService=P,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(a){if(a===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(a){if(a===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=g,e.ApplicationStorageMainService=g=Ee([ne(0,w.IUserDataProfilesService),ne(1,e.IStorageMainService)],g)}),define(se[287],oe([0,1,87,26,103,99,8,2,4,17,5,27,241,242,95,126,18]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function g(i,o,s,t,n){let c;for(let v=3;v&&(c?.dispose(),c=await new d(i,o,s,t,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));v--);return c}class d extends I.Disposable{constructor(o,s,t,n,c){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=c,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=C.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=v=>this._onConnection(v),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,p.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let t=await(0,r.findFreePortFaster)(o,2,1e3,s),n=null;return this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(t=0,this._server.listen(t,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(o){o.pause();const s=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,w.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=t.getSocket(),c=t.readEntireBuffer();t.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),n instanceof O.NodeSocket?n.socket.destroy():n.end()}),n instanceof O.NodeSocket?this._mirrorNodeSocket(o,n):this._mirrorGenericSocket(o,n),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),n.end()})}_mirrorGenericSocket(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(t=>o.write(t.buffer)),o.on("data",t=>s.write(m.VSBuffer.wrap(t))),o.resume()}_mirrorNodeSocket(o,s){const t=s.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.NodeRemoteTunnel=d;let a=class extends p.AbstractTunnelService{constructor(o,s,t,n,c){super(s,c),this.remoteSocketFactoryService=o,this.signService=t,this.productService=n}isPortPrivileged(o){return(0,p.isPortPrivileged)(o,this.defaultTunnelHost,f.OS,L.release())}retainOrCreateTunnel(o,s,t,n,c,v,R,k){const E=this.getTunnelFromMap(s,t);if(E)return++E.refcount,E.value;if((0,p.isTunnelProvider)(o))return this.createWithProvider(o,s,t,c,v,R,k);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${t} on local port ${c}.`);const M={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},_=g(M,n,s,t,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,t,_),_}}};e.BaseTunnelService=a,e.BaseTunnelService=a=Ee([ne(0,l.IRemoteSocketFactoryService),ne(1,y.ILogService),ne(2,S.ISignService),ne(3,b.IProductService),ne(4,u.IConfigurationService)],a);let P=class extends a{constructor(o,s,t,n,c){super(o,s,t,n,c)}};e.TunnelService=P,e.TunnelService=P=Ee([ne(0,l.IRemoteSocketFactoryService),ne(1,y.ILogService),ne(2,S.ISignService),ne(3,b.IProductService),ne(4,u.IConfigurationService)],P);let h=class extends I.Disposable{constructor(o,s,t,n,c){super(),this.remoteSocketFactoryService=o,this.logService=s,this.productService=t,this.signService=n,this.configurationService=c,this._tunnelServices=new Map}async openTunnel(o,s,t,n,c,v,R,k,E){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${v}.`),!this._tunnelServices.has(o)){const M=new P(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(M),this._tunnelServices.set(o,M),M.onTunnelClosed(async()=>{(await M.tunnels).length===0&&(M.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(s,t,n,c,v,R,k,E)}};e.SharedTunnelsService=h,e.SharedTunnelsService=h=Ee([ne(0,l.IRemoteSocketFactoryService),ne(1,y.ILogService),ne(2,b.IProductService),ne(3,S.ISignService),ne(4,u.IConfigurationService)],h)}),define(se[100],oe([0,1,8,22,3,17,24,20,5,27,51,49]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function w(S,p,m){return`${m.updateUrl}/api/update/${S}/${p}/${m.commit}`}e.createUpdateURL=w;let l=class{get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}constructor(p,m,g,d,a,P){this.lifecycleMainService=p,this.configurationService=m,this.environmentMainService=g,this.requestService=d,this.logService=a,this.productService=P,this._state=b.State.Uninitialized,this._onStateChange=new r.Emitter,this.onStateChange=this._onStateChange.event,p.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(b.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(b.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(b.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.configurationService.getValue("update.mode"),m=this.getProductQuality(p);if(!m){this.setState(b.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.setState(b.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const g=new URL(this.url);g.searchParams.set("prss","true"),this.url=g.toString()}if(this.setState(b.State.Idle(this.getUpdateType())),p==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,g=>this.logService.error(g))}getProductQuality(p){return p==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(p=60*60*1e3){return(0,C.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(p){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}catch(m){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(m);return}}async _applySpecificUpdate(p){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=l,e.AbstractUpdateService=l=Ee([ne(0,I.ILifecycleMainService),ne(1,O.IConfigurationService),ne(2,D.IEnvironmentMainService),ne(3,y.IRequestService),ne(4,f.ILogService),ne(5,u.IProductService)],l)}),define(se[288],oe([0,1,15,56,3,45,2,17,24,20,5,27,51,28,49,100]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends p.AbstractUpdateService{get onRawError(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"error",(d,a)=>a)}get onRawUpdateNotAvailable(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-available",(d,a,P)=>({url:a,version:P,productVersion:P}))}get onRawUpdateDownloaded(){return r.Event.fromNodeEventEmitter(C.autoUpdater,"update-downloaded",(d,a,P,h)=>({releaseNotes:a,version:P,productVersion:P,date:h}))}constructor(d,a,P,h,i,o,s){super(d,a,h,i,o,s),this.telemetryService=P,this.disposables=new D.DisposableStore,d.setRelaunchHandler(this)}handleRelaunch(d){return d?.addArgs||d?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(d){this.telemetryService.publicLog2("update:error",{messageHash:String((0,O.hash)(String(d)))}),this.logService.error("UpdateService error:",d);const a=this.state.type==="checking for updates"&&this.state.explicit?d:void 0;this.setState(S.State.Idle(1,a))}buildUpdateFeedUrl(d){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const P=(0,p.createUpdateURL)(a,d,this.productService);try{C.autoUpdater.setFeedURL({url:P})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return P}doCheckForUpdates(d){this.setState(S.State.CheckingForUpdates(d)),C.autoUpdater.checkForUpdates()}onUpdateAvailable(d){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(d))}onUpdateDownloaded(d){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:d.version}),this.setState(S.State.Ready(d)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),C.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=m,Ee([L.memoize],m.prototype,"onRawError",null),Ee([L.memoize],m.prototype,"onRawUpdateNotAvailable",null),Ee([L.memoize],m.prototype,"onRawUpdateAvailable",null),Ee([L.memoize],m.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=m=Ee([ne(0,u.ILifecycleMainService),ne(1,I.IConfigurationService),ne(2,l.ITelemetryService),ne(3,f.IEnvironmentMainService),ne(4,w.IRequestService),ne(5,y.ILogService),ne(6,b.IProductService)],m)}),define(se[289],oe([0,1,48,46,8,3,9,24,20,5,28,49]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let w=class{get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}constructor(p,m,g){if(this.lifecycleMainService=p,this.logService=g,this._state=b.State.Uninitialized,this._onStateChange=new O.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}scheduleCheckForUpdates(p=60*60*1e3){return(0,r.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(p){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(p){}};w=Ee([ne(0,f.ILifecycleMainService),ne(1,I.IEnvironmentMainService),ne(2,u.ILogService)],w);let l=class extends w{constructor(p,m,g,d,a,P){super(g,d,a),this.snap=p,this.snapRevision=m,this.telemetryService=P;const h=(0,L.watch)(D.dirname(this.snap)),i=O.Event.fromNodeEventEmitter(h,"change",(n,c)=>c),o=O.Event.filter(i,n=>n==="current"),t=O.Event.debounce(o,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{t.dispose(),h.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(p=>{p?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,p.message||p))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,C.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const p=await new Promise((g,d)=>(0,L.realpath)(`${D.dirname(this.snap)}/current`,(a,P)=>a?d(a):g(P))),m=D.basename(p);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,p=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=l,e.SnapUpdateService=l=Ee([ne(2,f.ILifecycleMainService),ne(3,I.IEnvironmentMainService),ne(4,u.ILogService),ne(5,y.ITelemetryService)],l)}),define(se[29],oe([0,1,4,6,60,70,27,17,24,9,65,136]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLastFocused=e.getFocusedOrLastActiveWindow=e.defaultBrowserWindowOptions=e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,L.createDecorator)("windowsMainService");var w;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(w||(e.OpenContext=w={}));function l(m,g,d){const a=m.get(O.IThemeMainService),P=m.get(D.IProductService),h=m.get(I.IConfigurationService),i=m.get(f.IEnvironmentMainService),o=h.getValue("window"),s={backgroundColor:a.getBackgroundColor(),minWidth:r.WindowMinimumSize.WIDTH,minHeight:r.WindowMinimumSize.HEIGHT,title:P.nameLong,...d,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,r.zoomLevelToZoomFactor)(o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...d?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(g&&(s.x=g.x,s.y=g.y,s.width=g.width,s.height=g.height),C.isLinux?s.icon=(0,u.join)(i.appRoot,"resources/linux/code.png"):C.isWindows&&!i.isBuilt&&(s.icon=(0,u.join)(i.appRoot,"resources/win32/code_150x150.png")),C.isMacintosh&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),C.isMacintosh&&!(0,r.useNativeFullScreen)(h)&&(s.fullscreenable=!1),C.isMacintosh&&o?.nativeTabs===!0&&(s.tabbingIdentifier=P.nameShort),(0,r.getTitleBarStyle)(h)==="custom"&&(s.titleBarStyle="hidden",C.isMacintosh||(s.frame=!1),(0,r.useWindowControlsOverlay)(h))){const c=a.getWindowSplash()?.colorInfo.titleBarBackground??a.getBackgroundColor(),v=b.Color.fromHex(c).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:c,symbolColor:v}}return s}e.defaultBrowserWindowOptions=l;function S(m){const g=m.get(e.IWindowsMainService),d=m.get(y.IAuxiliaryWindowsMainService),a=g.getFocusedWindow()??d.getFocusedWindow();if(a)return a;const P=g.getLastActiveWindow(),h=d.getLastActiveWindow();return P&&h?P.lastFocusTime<h.lastFocusTime?h:P:P??h}e.getFocusedOrLastActiveWindow=S;function p(m){let g,d=Number.MIN_VALUE;for(const a of m)a.lastFocusTime>d&&(d=a.lastFocusTime,g=a);return g}e.getLastFocused=p}),define(se[290],oe([0,1,15,22,3,45,2,32,116,5,82,29]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(S){S[S.Initial=1]="Initial",S[S.StoredCredentialsUsed=2]="StoredCredentialsUsed",S[S.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let l=class extends D.Disposable{constructor(p,m,g,d){super(),this.logService=p,this.windowsMainService=m,this.encryptionMainService=g,this.applicationStorageMainService=d,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const p=r.Event.fromNodeEventEmitter(C.app,"login",(m,g,d,a,P)=>({event:m,webContents:g,req:d,authInfo:a,callback:P}));this._register(p(this.onLogin,this))}async onLogin({event:p,authInfo:m,req:g,callback:d}){if(!m.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&g.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(m);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(a?.username,a?.password)}async resolveProxyCredentials(p){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const m=await this.doResolveProxyCredentials(p);if(m)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),m;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(p){this.logService.trace("auth#doResolveProxyCredentials - enter",p);const m=String((0,O.hash)({scheme:p.scheme,host:p.host,port:p.port}));let g,d;try{const i=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+m,-1);if(i){const o=JSON.parse(await this.encryptionMainService.decrypt(i));g=o.username,d=o.password}}catch(i){this.logService.error(i)}if(this.state!==w.StoredCredentialsUsed&&typeof g=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:g,password:d};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const P={authInfo:p,username:this.sessionCredentials?.username??g,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,P),this.state=w.LoginDialogShown;const h=await new Promise(i=>{const o=async(s,t,n)=>{if(t===P.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",o),n){const c={username:n.username,password:n.password};try{if(n.remember){const v=await this.encryptionMainService.encrypt(JSON.stringify(c));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+m,v,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+m,-1)}catch(v){this.logService.error(v)}i({username:c.username,password:c.password})}else i(void 0)};a.win?.webContents.on("ipc-message",o)});return this.sessionCredentials=h,h}};e.ProxyAuthHandler=l,e.ProxyAuthHandler=l=Ee([ne(0,u.ILogService),ne(1,b.IWindowsMainService),ne(2,f.IEncryptionMainService),ne(3,y.IApplicationStorageMainService)],l)}),define(se[291],oe([0,1,15,23,4,7,21,17,64,6,5,127,29]),function(V,e,C,L,r,O,D,I,f,u,y,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,u.createDecorator)(e.ID);let l=class{constructor(p,m,g,d){this.logService=p,this.windowsMainService=m,this.urlService=g,this.configurationService=d}async start(p,m){this.logService.trace("Received data from other instance: ",p,m),r.isMacintosh&&C.app.focus({steal:!0});const g=this.parseOpenUrl(p);if(g.length){let d=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const a=(0,L.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));a&&(d=a.ready())}d.then(()=>{for(const{uri:a,originalUrl:P}of g)this.urlService.open(a,{originalUrl:P})})}else return this.startOpenWindow(p,m)}parseOpenUrl(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,L.coalesce)(p._urls.map(m=>{try{return{uri:O.URI.parse(m),originalUrl:m}}catch{return null}})):[]}async startOpenWindow(p,m){const g=(0,f.isLaunchedFromCli)(m)?0:4;let d=[];const a=p.wait&&p.waitMarkerFilePath?O.URI.file(p.waitMarkerFilePath):void 0,P=p.remote||void 0,h={context:g,cli:p,userEnv:m,waitMarkerFileURI:a,remoteAuthority:P,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,h);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let i=!1;if(p["new-window"]||p["unity-launch"]||h.forceProfile||h.forceTempProfile)i=!0;else if(p["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!r.isMacintosh}if(i)d=await this.windowsMainService.open({...h,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,h),d=[o]):d=await this.windowsMainService.open({...h,forceEmpty:!0})}}else d=await this.windowsMainService.open({...h,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(a&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,D.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=l,e.LaunchMainService=l=Ee([ne(0,y.ILogService),ne(1,w.IWindowsMainService),ne(2,b.IURLService),ne(3,I.IConfigurationService)],l)}),define(se[292],oe([0,1,2,20,54,30,8,29]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let f=class extends C.Disposable{constructor(y,b,w){super(),this.userDataProfilesService=b,this.windowsMainService=w,this._register(y.onWillLoadWindow(l=>{l.reason===2&&this.unsetProfileForWorkspace(l.window)})),this._register(y.onBeforeCloseWindow(l=>this.unsetProfileForWorkspace(l))),this._register(new D.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(y){const b=this.getWorkspace(y),w=this.userDataProfilesService.getProfileForWorkspace(b);w?.isTransient&&(this.userDataProfilesService.unsetWorkspace(b,w.isTransient),w.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(y){return y.openedWorkspace??(0,O.toWorkspaceIdentifier)(y.backupPath,y.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const y=this.userDataProfilesService.getAssociatedEmptyWindows();if(y.length===0)return;const b=this.windowsMainService.getWindows().map(w=>this.getWorkspace(w));for(const w of y)b.some(l=>l.id===w.id)||this.userDataProfilesService.unsetWorkspace(w,!1)}};e.UserDataProfilesHandler=f,e.UserDataProfilesHandler=f=Ee([ne(0,L.ILifecycleMainService),ne(1,r.IUserDataProfilesMainService),ne(2,I.IWindowsMainService)],f)}),define(se[61],oe([0,1,15,2,3,5,312,8,13,29,74,28,20,76,38,4,131]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function d(h){return typeof h.responseWindowId=="number"}let a=class extends L.Disposable{static{g=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(g.all.values())}constructor(i,o,s){super(),this.logService=i,this.telemetryService=o,this.lifecycleMainService=s,this.id=String(++g.ID_COUNTER),this._onStdout=this._register(new r.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new r.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new r.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new r.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new r.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(i,o){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${i}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${i}`,o){case y.default.Error:this.logService.error(s);break;case y.default.Warning:this.logService.warn(s);break;case y.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(i){const o=this.doStart(i);return o&&i.payload&&this.postMessage(i.payload),o}doStart(i){if(!this.validateCanStart())return!1;this.configuration=i;const o=`${this.configuration.type}-${this.id}`,s=f.FileAccess.asFileUri("bootstrap-fork.js").fsPath,t=this.configuration.args??[],n=this.configuration.execArgv??[],c=this.configuration.allowLoadingUnsignedLibraries,v=this.configuration.forceAllocationsToV8Sandbox,R="pipe",k=this.createEnv(i);return this.log("creating new...",y.default.Info),this.process=C.utilityProcess.fork(s,t,{serviceName:o,env:k,execArgv:n,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:v,stdio:R}),this.registerListeners(this.process,this.configuration,o),!0}createEnv(i){const o=i.env?{...i.env}:{...(0,S.deepClone)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,p.isWindows&&((0,m.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,m.getUNCHostAllowlist)().join("\\")),(0,l.removeDangerousEnvVariables)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}registerListeners(i,o,s){if(i.stdout){const t=new D.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this._onStdout.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new D.StringDecoder("utf-8");this._register(r.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this._onStderr.fire(typeof n=="string"?n:t.write(n))))}this._register(r.Event.fromNodeEventEmitter(i,"message")(t=>this._onMessage.fire(t))),this._register(r.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.processPid=i.pid,typeof i.pid=="number"&&g.all.set(i.pid,{pid:i.pid,name:d(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.log("successfully created",y.default.Info),this._onSpawn.fire(i.pid)})),this._register(r.Event.fromNodeEventEmitter(i,"exit")(t=>{this.log(`received exit event with code ${t}`,y.default.Info),this._onExit.fire({pid:this.processPid,code:t,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(r.Event.fromNodeEventEmitter(C.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===s&&(this.log(`crashed with code ${t.exitCode} and reason '${t.reason}'`,y.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this._onCrash.fire({pid:this.processPid,code:t.exitCode,reason:t.reason}),this.onDidExitOrCrashOrKill())}))}once(i,o){const s=this._register(this._onMessage.event(t=>{t===i&&(s.dispose(),o())}))}postMessage(i,o){this.process&&this.process.postMessage(i,o)}connect(i){const{port1:o,port2:s}=new C.MessageChannelMain;return this.postMessage(i,[s]),o}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",y.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",y.default.Info),this.process.kill()?(this.log("successfully killed the process",y.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",y.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&g.all.delete(this.processPid),this.process=void 0}async waitForExit(i){this.process&&(this.log("waiting to exit...",y.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,I.timeout)(i)]),this.process&&(this.log(`did not exit within ${i}ms, will kill it now...`,y.default.Info),this.kill()))}};e.UtilityProcess=a,e.UtilityProcess=a=g=Ee([ne(0,O.ILogService),ne(1,b.ITelemetryService),ne(2,w.ILifecycleMainService)],a);let P=class extends a{constructor(i,o,s,t){super(i,s,t),this.windowsMainService=o}start(i){const o=this.windowsMainService.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.doStart(i))return!1;this.registerWindowListeners(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}registerWindowListeners(i,o){o.windowLifecycleBound&&(this._register(r.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===i)(()=>this.kill())),this._register(r.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=P,e.WindowUtilityProcess=P=Ee([ne(0,O.ILogService),ne(1,u.IWindowsMainService),ne(2,b.ITelemetryService),ne(3,w.ILifecycleMainService)],P)}),define(se[293],oe([0,1,14,3,5,20,8,61,29,28]),function(V,e,C,L,r,O,D,I,f,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let b=class{static{y=this}static{this._lastId=0}constructor(l,S,p,m){this._logService=l,this._lifecycleMainService=S,this._windowsMainService=p,this._telemetryService=m,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(g=>{this._shutdown=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(l){const S=this._extHosts.get(l);if(!S)throw new Error("Unknown extension host!");return S}onDynamicStdout(l){return this._getExtHost(l).onStdout}onDynamicStderr(l){return this._getExtHost(l).onStderr}onDynamicMessage(l){return this._getExtHost(l).onMessage}onDynamicExit(l){return this._getExtHost(l).onExit}async createExtensionHost(){if(this._shutdown)throw(0,C.canceled)();const l=String(++y._lastId),S=new I.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(l,S),S.onExit(({pid:p,code:m,signal:g})=>{this._logService.info(`Extension host with pid ${p} exited with code: ${m}, signal: ${g}.`),setTimeout(()=>{S.dispose(),this._extHosts.delete(l)}),setTimeout(()=>{try{process.kill(p,0),this._logService.error(`Extension host with pid ${p} still exists, forcefully killing it...`),process.kill(p)}catch{}},1e3)}),{id:l}}async start(l,S){if(this._shutdown)throw(0,C.canceled)();const p=this._getExtHost(l);return p.start({...S,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:S.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:l}),{pid:await L.Event.toPromise(p.onSpawn)}}async enableInspectPort(l){if(this._shutdown)throw(0,C.canceled)();const S=this._extHosts.get(l);return S?S.enableInspectPort():!1}async kill(l){if(this._shutdown)throw(0,C.canceled)();const S=this._extHosts.get(l);S&&S.kill()}async _killAllNow(){for(const[,l]of this._extHosts)l.kill()}async _waitForAllExit(l){const S=[];for(const[,p]of this._extHosts)S.push(p.waitForExit(l));return D.Promises.settled(S).then(()=>{})}};e.ExtensionHostStarter=b,e.ExtensionHostStarter=b=y=Ee([ne(0,r.ILogService),ne(1,O.ILifecycleMainService),ne(2,f.IWindowsMainService),ne(3,u.ITelemetryService)],b)}),define(se[294],oe([0,1,36,8,2,24,20,5,41,39,69,61,52,90,12,247]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends r.Disposable{constructor(d,a,P,h,i,o,s,t){super(),this.machineId=d,this.sqmId=a,this.environmentMainService=P,this.userDataProfilesService=h,this.lifecycleMainService=i,this.logService=o,this.loggerMainService=s,this.policyService=t,this.firstWindowConnectionBarrier=new L.Barrier,this.utilityProcess=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){C.validatedIpcMain.on(p.SharedProcessChannelConnection.request,(d,a)=>this.onWindowConnection(d,a,p.SharedProcessChannelConnection.response)),C.validatedIpcMain.on(p.SharedProcessRawConnection.request,(d,a)=>this.onWindowConnection(d,a,p.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(d,a,P){this.logService.trace(`[SharedProcess] onWindowConnection for: ${P}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect(P);if(d.sender.isDestroyed())return h.close();d.sender.postMessage(P,a,[h])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(p.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const d=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(p.SharedProcessLifecycle.initDone,()=>d.complete()):C.validatedIpcMain.once(p.SharedProcessLifecycle.initDone,()=>d.complete()),await d.p,this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const d=new L.DeferredPromise;this.utilityProcess?this.utilityProcess.once(p.SharedProcessLifecycle.ipcReady,()=>d.complete()):C.validatedIpcMain.once(p.SharedProcessLifecycle.ipcReady,()=>d.complete()),await d.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new b.UtilityProcess(this.logService,w.NullTelemetryService,this.lifecycleMainService));const d=(0,l.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let a;d.port&&(a=["--nolazy"],d.break?a.push(`--inspect-brk=${d.port}`):a.push(`--inspect=${d.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:a})}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(d){return await this.whenIpcReady,(0,S.assertIsDefined)(this.utilityProcess).connect(d)}};e.SharedProcess=m,e.SharedProcess=m=Ee([ne(2,O.IEnvironmentMainService),ne(3,f.IUserDataProfilesService),ne(4,D.ILifecycleMainService),ne(5,I.ILogService),ne(6,y.ILoggerMainService),ne(7,u.IPolicyService)],m)}),define(se[295],oe([0,1,24,90,20,5,52,61,110,36,2,3,38,17,13]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let p=class extends y.Disposable{constructor(g,d,a,P,h){super(),this._reconnectConstants=g,this._configurationService=d,this._environmentMainService=a,this._lifecycleMainService=P,this._logService=h,this.utilityProcess=void 0,this._onRequestConnection=new b.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new b.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),u.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(i,o)=>this._onWindowConnection(i,o)),this._register((0,y.toDisposable)(()=>{u.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new I.UtilityProcess(this._logService,D.NullTelemetryService,this._lifecycleMainService);const g=(0,L.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),d=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:S.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const a=this.utilityProcess.connect(),P=new f.Client(a,"ptyHost"),h=new y.DisposableStore;return h.add(P),h.add((0,y.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:P,store:h,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const g={...(0,w.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},d=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&(g.VSCODE_LATENCY=String(d));const a=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return a&&typeof a=="number"&&(g.VSCODE_STARTUP_DELAY=String(a)),this._environmentMainService.restoreSnapExportedVariables(),g}_onWindowConnection(g,d){this._onRequestConnection.fire();const a=this.utilityProcess.connect();if(g.sender.isDestroyed()){a.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[a])}};e.ElectronPtyHostStarter=p,e.ElectronPtyHostStarter=p=Ee([ne(1,l.IConfigurationService),ne(2,C.IEnvironmentMainService),ne(3,r.ILifecycleMainService),ne(4,O.ILogService)],p)}),define(se[296],oe([0,1,2,6,5,29,61,28,45,3,8,20]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,L.createDecorator)("utilityProcessWorker");let w=class extends C.Disposable{constructor(p,m,g,d){super(),this.logService=p,this.windowsMainService=m,this.telemetryService=g,this.lifecycleMainService=d,this.workers=new Map}async createWorker(p){const m=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${m})`);const g=this.hash(p);this.workers.has(g)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${m})`),this.disposeWorker(p));const d=new l(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,p);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(g,d);const a=new y.DeferredPromise;return u.Event.once(d.onDidTerminate)(P=>{P.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${P.code}, signal: ${P.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${P.code}, signal: ${P.signal}`),this.workers.delete(g),a.complete({reason:P})}),a.p}hash(p){return(0,f.hash)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const m=this.hash(p),g=this.workers.get(m);g&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),g.kill(),this.workers.delete(m))}};e.UtilityProcessWorkerMainService=w,e.UtilityProcessWorkerMainService=w=Ee([ne(0,r.ILogService),ne(1,O.IWindowsMainService),ne(2,I.ITelemetryService),ne(3,b.ILifecycleMainService)],w);let l=class extends C.Disposable{constructor(p,m,g,d,a){super(),this.logService=p,this.windowsMainService=m,this.telemetryService=g,this.lifecycleMainService=d,this.configuration=a,this._onDidTerminate=this._register(new u.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new D.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(p=>this._onDidTerminate.fire({code:p.code,signal:p.signal}))),this._register(this.utilityProcess.onCrash(p=>this._onDidTerminate.fire({code:p.code,signal:"ECRASH"})))}spawn(){const m=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:m,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};l=Ee([ne(0,r.ILogService),ne(1,O.IWindowsMainService),ne(2,I.ITelemetryService),ne(3,b.ILifecycleMainService)],l)}),define(se[297],oe([0,1,15,3,2,273,29]),function(V,e,C,L,r,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends r.Disposable{constructor(u){super(),this.windowsMainService=u,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new O.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(u,y){let b;if(typeof u.windowId=="number"){const{windowId:w}=u,l=this.windowsMainService.getWindowById(w);if(!l?.win)throw new Error(`Invalid windowId: ${w}`);b=l.win.webContents}else{const{webContentsId:w}=u;if(b=C.webContents.fromId(w),!b)throw new Error(`Invalid webContentsId: ${w}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(y)}async findInFrame(u,y,b,w){const S=this.getFrameByName(u,y);if(typeof S.findInFrame=="function"){S.findInFrame(b,{findNext:w.findNext,forward:w.forward});const p=(m,g)=>{g.finalUpdate&&(this._onFoundInFrame.fire(g),S.removeListener("found-in-frame",p))};S.on("found-in-frame",p)}}async stopFindInFrame(u,y,b){const l=this.getFrameByName(u,y);typeof l.stopFindInFrame=="function"&&l.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(u,y){const b=this.windowsMainService.getWindowById(u.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${u}`);const w=b.win.webContents.mainFrame.framesInSubtree.find(l=>l.name===y);if(!w)throw new Error(`Unknown frame: ${y}`);return w}};e.WebviewMainService=I,e.WebviewMainService=I=Ee([ne(0,D.IWindowsMainService)],I)}),define(se[298],oe([0,1,15,2,4,19,7,17,20,5,34,29,128,30]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class extends L.Disposable{static{S=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(h,i,o,s,t){super(),this.windowsMainService=h,this.stateService=i,this.lifecycleMainService=o,this.logService=s,this.configurationService=t,this._state=m(this.stateService.getItem(S.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){C.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!i.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.toWindowState(t),i.lastActiveWindow.uiState.mode===3&&h.add(i.lastActiveWindow.uiState.display))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.toWindowState(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(i.lastPluginDevelopmentHostWindow.uiState.display)?r.isMacintosh&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(i.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.toWindowState(t);return n.uiState.mode===3&&(h.has(n.uiState.display)?r.isMacintosh&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):h.add(n.uiState.display)),n}));const s=d(i);this.stateService.setItem(S.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const i=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=i:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(o=>{const s=(0,l.isWorkspaceIdentifier)(h.openedWorkspace)&&o.workspace?.id===h.openedWorkspace.id,t=(0,l.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&o.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(o.folderUri,h.openedWorkspace.uri);(s||t)&&(o.uiState=i.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=i)}toWindowState(h){return{windowId:h.id,workspace:(0,l.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,l.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const i=this.doGetNewWindowState(h),o=this.configurationService.getValue("window");if(i.mode===3){let s;i.hasDefaultState?s=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||o?.restoreFullscreen),s||(i.mode=1)}return i}doGetNewWindowState(h){const i=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const v=h.workspace;if((0,l.isWorkspaceIdentifier)(v)){const k=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===v.id).map(E=>E.uiState);if(k.length)return k[0]}if((0,l.isSingleFolderWorkspaceIdentifier)(v)){const k=this.state.openedWindows.filter(E=>E.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(E.folderUri,v.uri)).map(E=>E.uiState);if(k.length)return k[0]}else if(h.backupPath){const k=this.state.openedWindows.filter(E=>E.backupPath===h.backupPath).map(E=>E.uiState);if(k.length)return k[0]}const R=this.lastClosedState||this.state.lastActiveWindow;if(!i&&R)return R.uiState}let o;const s=C.screen.getAllDisplays();if(s.length===1)o=s[0];else{if(r.isMacintosh){const v=C.screen.getCursorScreenPoint();o=C.screen.getDisplayNearestPoint(v)}!o&&i&&(o=C.screen.getDisplayMatching(i.getBounds())),o||(o=C.screen.getPrimaryDisplay()||s[0])}let t=(0,w.defaultWindowState)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.configurationService.getValue("window");let c=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,c=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,c=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const v=i.serializeWindowState();v.mode===3?t.mode=3:t=v,c=t.mode!==3&&n.newWindowDimensions==="offset"}}return c&&(t=this.ensureNoOverlap(t)),t.hasDefaultState=!0,t}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const i=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===h.x||o.y===h.y);)h.x+=30,h.y+=30;return h}};e.WindowsStateHandler=p,e.WindowsStateHandler=p=S=Ee([ne(0,b.IWindowsMainService),ne(1,y.IStateService),ne(2,f.ILifecycleMainService),ne(3,u.ILogService),ne(4,I.IConfigurationService)],p);function m(P){const h={openedWindows:[]},i=P||{openedWindows:[]};return i.lastActiveWindow&&(h.lastActiveWindow=g(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(h.openedWindows=i.openedWindows.map(o=>g(o))),h}e.restoreWindowsState=m;function g(P){const h={uiState:P.uiState};return P.backupPath&&(h.backupPath=P.backupPath),P.remoteAuthority&&(h.remoteAuthority=P.remoteAuthority),P.folder&&(h.folderUri=D.URI.parse(P.folder)),P.workspaceIdentifier&&(h.workspace={id:P.workspaceIdentifier.id,configPath:D.URI.parse(P.workspaceIdentifier.configURIPath)}),h}function d(P){return{lastActiveWindow:P.lastActiveWindow&&a(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&a(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(h=>a(h))}}e.getWindowsStateStoreData=d;function a(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(se[55],oe([0,1,15,3,44,2,13,9,19,21,194,66,53,24,6,5,54,130,30,97,98]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,S.createDecorator)("workspacesManagementMainService");let h=class extends O.Disposable{constructor(o,s,t,n,c){super(),this.environmentMainService=o,this.logService=s,this.userDataProfilesMainService=t,this.backupMainService=n,this.dialogMainService=c,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const o=(await u.Promises.readdir(this.untitledWorkspacesHome.with({scheme:D.Schemas.file}).fsPath)).map(s=>(0,f.joinPath)(this.untitledWorkspacesHome,s,d.UNTITLED_WORKSPACE_NAME));for(const s of o){const t=(0,P.getWorkspaceIdentifier)(s),n=await this.resolveLocalWorkspace(s);n?this.untitledWorkspaces.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${o}).`)}}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,s=>u.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(o,s){if(this.isWorkspacePath(o)&&o.scheme===D.Schemas.file)try{const t=s(o.fsPath);return t instanceof Promise?t.then(n=>this.doResolveWorkspace(o,n),n=>{}):this.doResolveWorkspace(o,t)}catch{return}}isWorkspacePath(o){return(0,d.isUntitledWorkspace)(o,this.environmentMainService)||(0,d.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,s){try{const t=this.doParseStoredWorkspace(o,s),n=(0,P.getWorkspaceIdentifier)(o);return{id:n.id,configPath:n.configPath,folders:(0,a.toWorkspaceFolders)(t.folders,n.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.logService.warn(t.toString())}}doParseStoredWorkspace(o,s){const t=(0,r.parse)(s);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,a.isStoredWorkspaceFolder)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,s){const{workspace:t,storedWorkspace:n}=this.newUntitledWorkspace(o,s),c=t.configPath.fsPath;return await u.Promises.mkdir((0,I.dirname)(c),{recursive:!0}),await u.Promises.writeFile(c,JSON.stringify(n,null,"	")),this.untitledWorkspaces.push({workspace:t,remoteAuthority:s}),t}newUntitledWorkspace(o=[],s){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.joinPath)(this.untitledWorkspacesHome,t),c=(0,f.joinPath)(n,d.UNTITLED_WORKSPACE_NAME),v=[];for(const R of o)v.push((0,a.getStoredWorkspaceFolder)(R.uri,!0,R.name,n,f.extUriBiasedIgnorePathCase));return{workspace:(0,P.getWorkspaceIdentifier)(c),storedWorkspace:{folders:v,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,P.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,d.isUntitledWorkspace)(o.configPath,this.environmentMainService)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.doDeleteUntitledWorkspace(o),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(o),this._onDidDeleteUntitledWorkspace.fire(o))}async doDeleteUntitledWorkspace(o){const s=(0,f.originalFSPath)(o.configPath);try{await u.Promises.rm((0,I.dirname)(s));const t=(0,I.join)(this.environmentMainService.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,o.id);await u.Promises.exists(t)&&await u.Promises.writeFile((0,I.join)(t,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(n=>n.workspace.id!==o.id)}catch(t){this.logService.warn(`Unable to delete untitled workspace ${s} (${t}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(o,s,t){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,s,t))return;const c=await this.doEnterWorkspace(o,(0,P.getWorkspaceIdentifier)(t));if(c)return this._onDidEnterWorkspace.fire({window:o,workspace:c.workspace}),c}async isValidTargetWorkspacePath(o,s,t){return t?(0,d.isWorkspaceIdentifier)(o.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,t)?!1:(0,g.findWindowOnWorkspaceOrFolder)(s,t)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,f.basename)(t)),detail:(0,y.localize)(2,null)},C.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(o,s){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,d.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=t,{workspace:s,backupPath:t}}};e.WorkspacesManagementMainService=h,e.WorkspacesManagementMainService=h=Ee([ne(0,l.IEnvironmentMainService),ne(1,p.ILogService),ne(2,m.IUserDataProfilesMainService),ne(3,b.IBackupMainService),ne(4,w.IDialogMainService)],h)}),define(se[132],oe([0,1,15,36,22,6,29,30,55,12,5,61]),function(V,e,C,L,r,O,D,I,f,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,O.createDecorator)(e.ID);let w=class{constructor(S,p,m){this.windowsMainService=S,this.workspacesManagementMainService=p,this.logService=m}async getRemoteDiagnostics(S){const p=this.windowsMainService.getWindows();return(await Promise.all(p.map(async g=>{const d=g.remoteAuthority;if(!d)return;const a=`vscode:getDiagnosticInfoResponse${g.id}`,P={includeProcesses:S.includeProcesses,folders:S.includeWorkspaceMetadata?await this.getFolderURIs(g):void 0};return new Promise(h=>{g.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:a,args:P}),L.validatedIpcMain.once(a,(i,o)=>{o||h({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),h(o)}),setTimeout(()=>{h({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const S=[];for(const m of C.BrowserWindow.getAllWindows()){const g=this.windowsMainService.getWindowById(m.id);g?S.push(await this.codeWindowToInfo(g)):S.push(this.browserWindowToInfo(m))}const p=[];for(const{pid:m,name:g}of b.UtilityProcess.getAll())p.push({pid:m,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:S,pidToNames:p,screenReader:!!C.app.accessibilitySupportEnabled,gpuFeatureStatus:C.app.getGPUFeatureStatus()}}async codeWindowToInfo(S){const p=await this.getFolderURIs(S),m=(0,u.assertIsDefined)(S.win);return this.browserWindowToInfo(m,p,S.remoteAuthority)}browserWindowToInfo(S,p=[],m){return{id:S.id,pid:S.webContents.getOSProcessId(),title:S.getTitle(),folderURIs:p,remoteAuthority:m}}async getFolderURIs(S){const p=[],m=S.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(m))p.push(m.uri);else if((0,I.isWorkspaceIdentifier)(m)){const g=await this.workspacesManagementMainService.resolveLocalWorkspace(m.configPath);g&&g.folders.forEach(a=>{p.push(a.uri)})}return p}};e.DiagnosticsMainService=w,e.DiagnosticsMainService=w=Ee([ne(0,D.IWindowsMainService),ne(1,f.IWorkspacesManagementMainService),ne(2,y.ILogService)],w)}),define(se[71],oe([0,1,48,15,26,156,56,3,2,13,9,4,7,105,88,21,103,182,53,24,6,20,5,27,70,29,30,55,18,243,235,65]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o,s,t,n,c,v,R,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,P.createDecorator)("nativeHostMainService");let M=class extends f.Disposable{constructor(T,U,X,Y,le,ce,ue,Q,G,x){super(),this.windowsMainService=T,this.auxiliaryWindowsMainService=U,this.dialogMainService=X,this.lifecycleMainService=Y,this.environmentMainService=le,this.logService=ce,this.productService=ue,this.themeMainService=Q,this.workspacesManagementMainService=G,this.instantiationService=x,this.onDidOpenMainWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,W=>W.id),this.onDidTriggerWindowSystemContextMenu=I.Event.any(I.Event.filter(I.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:W,x:B,y:H})=>({windowId:W.id,x:B,y:H})),({windowId:W})=>!!this.windowsMainService.getWindowById(W)),I.Event.filter(I.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:W,x:B,y:H})=>({windowId:W.id,x:B,y:H})),({windowId:W})=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidMaximizeWindow=I.Event.any(I.Event.filter(I.Event.map(this.windowsMainService.onDidMaximizeWindow,W=>W.id),W=>!!this.windowsMainService.getWindowById(W)),I.Event.filter(I.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,W=>W.id),W=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidUnmaximizeWindow=I.Event.any(I.Event.filter(I.Event.map(this.windowsMainService.onDidUnmaximizeWindow,W=>W.id),W=>!!this.windowsMainService.getWindowById(W)),I.Event.filter(I.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,W=>W.id),W=>!!this.auxiliaryWindowsMainService.getWindowById(W))),this.onDidBlurMainWindow=I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(W,B)=>B.id),W=>!!this.windowsMainService.getWindowById(W)),this.onDidFocusMainWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),W=>!!W),W=>W.id),I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(W,B)=>B.id),W=>!!this.windowsMainService.getWindowById(W))),this.onDidBlurMainOrAuxiliaryWindow=I.Event.any(this.onDidBlurMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(W,B)=>B),W=>(0,E.isAuxiliaryWindow)(W.webContents)),W=>W.id)),this.onDidFocusMainOrAuxiliaryWindow=I.Event.any(this.onDidFocusMainWindow,I.Event.map(I.Event.filter(I.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(W,B)=>B),W=>(0,E.isAuxiliaryWindow)(W.webContents)),W=>W.id)),this.onDidResumeOS=I.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(W,B,H)=>H),W=>!(Array.isArray(W)&&W.length===1&&W[0]==="workArea")),I.Event.fromNodeEventEmitter(L.screen,"display-added"),I.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(T,U){const X=this.windowsMainService.getWindows().map(le=>({id:le.id,workspace:le.openedWorkspace??(0,n.toWorkspaceIdentifier)(le.backupPath,le.isExtensionDevelopmentHost),title:le.win?.getTitle()??"",filename:le.getRepresentedFilename(),dirty:le.isDocumentEdited()})),Y=[];return U.includeAuxiliaryWindows&&Y.push(...this.auxiliaryWindowsMainService.getWindows().map(le=>({id:le.id,parentId:le.parentId,title:le.win?.getTitle()??"",filename:le.getRepresentedFilename()}))),[...X,...Y]}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const U=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(T,U,X){return Array.isArray(U)?this.doOpenWindow(T,U,X):this.doOpenEmptyWindow(T,U)}async doOpenWindow(T,U,X=Object.create(null)){U.length>0&&await this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:X.forceNewWindow,forceReuseWindow:X.forceReuseWindow,preferNewWindow:X.preferNewWindow,diffMode:X.diffMode,mergeMode:X.mergeMode,addMode:X.addMode,gotoLineMode:X.gotoLineMode,noRecentEntry:X.noRecentEntry,waitMarkerFileURI:X.waitMarkerFileURI,remoteAuthority:X.remoteAuthority||void 0,forceProfile:X.forceProfile,forceTempProfile:X.forceTempProfile})}async doOpenEmptyWindow(T,U){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},U)}async toggleFullScreen(T,U){this.windowById(U?.targetWindowId,T)?.toggleFullScreen()}async handleTitleDoubleClick(T,U){this.windowById(U?.targetWindowId,T)?.handleTitleDoubleClick()}async getCursorScreenPoint(T){const U=L.screen.getCursorScreenPoint(),X=L.screen.getDisplayNearestPoint(U);return{point:U,display:X.bounds}}async isMaximized(T,U){return this.windowById(U?.targetWindowId,T)?.win?.isMaximized()??!1}async maximizeWindow(T,U){this.windowById(U?.targetWindowId,T)?.win?.maximize()}async unmaximizeWindow(T,U){this.windowById(U?.targetWindowId,T)?.win?.unmaximize()}async minimizeWindow(T,U){this.windowById(U?.targetWindowId,T)?.win?.minimize()}async moveWindowTop(T,U){this.windowById(U?.targetWindowId,T)?.win?.moveTop()}async positionWindow(T,U,X){const Y=this.windowById(X?.targetWindowId,T);if(Y?.win){if(Y.win.isFullScreen()){const le=I.Event.toPromise(I.Event.once(I.Event.fromNodeEventEmitter(Y.win,"leave-full-screen")));Y.win.setFullScreen(!1),await le}Y.win.setBounds(U)}}async updateWindowControls(T,U){this.windowById(U?.targetWindowId,T)?.updateWindowControls(U)}async focusWindow(T,U){this.windowById(U?.targetWindowId,T)?.focus({force:U?.force??!1})}async setMinimumSize(T,U,X){const Y=this.codeWindowById(T);if(Y?.win){const[le,ce]=Y.win.getSize(),[ue,Q]=Y.win.getMinimumSize(),[G,x]=[U??ue,X??Q],[W,B]=[Math.max(le,G),Math.max(ce,x)];(ue!==G||Q!==x)&&Y.win.setMinimumSize(G,x),(le!==W||ce!==B)&&Y.win.setSize(W,B)}}async saveWindowSplash(T,U){this.themeMainService.saveWindowSplash(T,U)}async installShellCommand(T){const{source:U,target:X}=await this.getShellCommandLink();try{const{symbolicLink:Y}=await p.SymlinkSupport.stat(U);if(Y&&!Y.dangling){const le=await(0,l.realpath)(U);if(X===le)return}await p.Promises.unlink(U)}catch(Y){if(Y.code!=="ENOENT")throw Y}try{await p.Promises.symlink(X,U)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="ENOENT")throw Y;const{response:le}=await this.showMessageBox(T,{type:"info",message:(0,g.localize)(0,null,this.productService.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(le===0)try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${X}' '${U}'\\" with administrator privileges"`;await(0,O.promisify)(C.exec)(ce)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(T){const{source:U}=await this.getShellCommandLink();try{await p.Promises.unlink(U)}catch(X){switch(X.code){case"EACCES":{const{response:Y}=await this.showMessageBox(T,{type:"info",message:(0,g.localize)(4,null,this.productService.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(Y===0)try{const le=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,O.promisify)(C.exec)(le)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw X}}}async getShellCommandLink(){const T=(0,y.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(T))throw new Error((0,g.localize)(8,null,T));return{source:U,target:T}}async showMessageBox(T,U){const X=this.getTargetWindow(T);return this.dialogMainService.showMessageBox(U,X?.win??void 0)}async showSaveDialog(T,U){const X=this.getTargetWindow(T);return this.dialogMainService.showSaveDialog(U,X?.win??void 0)}async showOpenDialog(T,U){const X=this.getTargetWindow(T);return this.dialogMainService.showOpenDialog(U,X?.win??void 0)}async pickFileFolderAndOpen(T,U){const X=await this.dialogMainService.pickFileFolder(U);X&&await this.doOpenPicked(await Promise.all(X.map(async Y=>await p.SymlinkSupport.existsDirectory(Y)?{folderUri:w.URI.file(Y)}:{fileUri:w.URI.file(Y)})),U,T)}async pickFolderAndOpen(T,U){const X=await this.dialogMainService.pickFolder(U);X&&await this.doOpenPicked(X.map(Y=>({folderUri:w.URI.file(Y)})),U,T)}async pickFileAndOpen(T,U){const X=await this.dialogMainService.pickFile(U);X&&await this.doOpenPicked(X.map(Y=>({fileUri:w.URI.file(Y)})),U,T)}async pickWorkspaceAndOpen(T,U){const X=await this.dialogMainService.pickWorkspace(U);X&&await this.doOpenPicked(X.map(Y=>({workspaceUri:w.URI.file(Y)})),U,T)}async doOpenPicked(T,U,X){await this.windowsMainService.open({context:3,contextWindowId:X,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:U.forceNewWindow})}async showItemInFolder(T,U){L.shell.showItemInFolder(U)}async setRepresentedFilename(T,U,X){this.windowById(X?.targetWindowId,T)?.setRepresentedFilename(U)}async setDocumentEdited(T,U,X){this.windowById(X?.targetWindowId,T)?.setDocumentEdited(U)}async openExternal(T,U){return this.environmentMainService.unsetSnapExportedVariables(),L.shell.openExternal(U),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(T,U){return L.shell.trashItem(U)}async isAdmin(){let T;return b.isWindows?T=(await new Promise((U,X)=>{V(["native-is-elevated"],U,X)}))():T=process.getuid?.()===0,T}async writeElevated(T,U,X,Y){const le=await new Promise((ce,ue)=>{V(["@vscode/sudo-prompt"],ce,ue)});return new Promise((ce,ue)=>{const Q=[`"${this.cliPath}"`];Y?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${U.fsPath}"`,`"${X.fsPath}"`);const G={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};le.exec(Q.join(" "),G,(x,W,B)=>{W&&this.logService.trace(`[sudo-prompt] received stdout: ${W}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),x?ue(x):ce(void 0)})})}async isRunningUnderARM64Translation(){return b.isLinux||b.isWindows?!1:L.app.runningUnderARM64Translation}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,y.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return S.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,R.hasWSLFeatureInstalled)()}async killProcess(T,U,X){process.kill(U,X)}async readClipboardText(T,U){return L.clipboard.readText(U)}async writeClipboardText(T,U,X){return L.clipboard.writeText(U,X)}async readClipboardFindText(T){return L.clipboard.readFindText()}async writeClipboardFindText(T,U){return L.clipboard.writeFindText(U)}async writeClipboardBuffer(T,U,X,Y){return L.clipboard.writeBuffer(U,Buffer.from(X.buffer),Y)}async readClipboardBuffer(T,U){return v.VSBuffer.wrap(L.clipboard.readBuffer(U))}async hasClipboard(T,U,X){return L.clipboard.has(U,X)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,U){this.codeWindowById(T)?.updateTouchBar(U)}async notifyReady(T){this.codeWindowById(T)?.setReady()}async relaunch(T,U){return this.lifecycleMainService.relaunch(U)}async reload(T,U){const X=this.codeWindowById(T);if(X){if((0,n.isWorkspaceIdentifier)(X.openedWorkspace)){const Y=X.openedWorkspace.configPath;if(Y.scheme===u.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Y))?.transient)return this.openWindow(X.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(X,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(T,U){return this.windowById(U?.targetWindowId,T)?.win?.close()}async quit(T){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(T,U){await this.lifecycleMainService.kill(U)}async resolveProxy(T,U){return this.codeWindowById(T)?.win?.webContents?.session?.resolveProxy(U)}async loadCertificates(T){return(await new Promise((X,Y)=>{V(["@vscode/proxy-agent"],X,Y)})).loadSystemCertificates({log:this.logService})}findFreePort(T,U,X,Y,le=1){return(0,m.findFreePort)(U,X,Y,le)}async openDevTools(T,U){this.getTargetWindow(T)?.win?.webContents.openDevTools(U)}async toggleDevTools(T){this.getTargetWindow(T)?.win?.webContents.toggleDevTools()}async profileRenderer(T,U,X){const Y=this.codeWindowById(T);if(!Y||!Y.win)throw new Error;return await new k.WindowProfiler(Y.win,U,this.logService).inspect(X)}async windowsGetStringRegKey(T,U,X,Y){if(!b.isWindows)return;const le=await new Promise((ce,ue)=>{V(["@vscode/windows-registry"],ce,ue)});try{return le.GetStringRegKey(U,X,Y)}catch{return}}windowById(T,U){return this.codeWindowById(T)??this.auxiliaryWindowById(T)??this.codeWindowById(U)}codeWindowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}auxiliaryWindowById(T){if(typeof T=="number")return this.auxiliaryWindowsMainService.getWindowById(T)}getTargetWindow(T){let U=this.instantiationService.invokeFunction(t.getFocusedOrLastActiveWindow);return U||(U=this.windowById(T)),U}};e.NativeHostMainService=M,Ee([D.memoize],M.prototype,"cliPath",null),e.NativeHostMainService=M=Ee([ne(0,t.IWindowsMainService),ne(1,E.IAuxiliaryWindowsMainService),ne(2,d.IDialogMainService),ne(3,h.ILifecycleMainService),ne(4,a.IEnvironmentMainService),ne(5,i.ILogService),ne(6,o.IProductService),ne(7,s.IThemeMainService),ne(8,c.IWorkspacesManagementMainService),ne(9,P.IInstantiationService)],M)}),define(se[299],oe([0,1,15,26,8,22,33,2,13,4,7,107,36,180,91,132,53,24,5,71,79,27,80,34,61,60,29]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o,s,t,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const v="issue.processExplorerWindowState";let R=class{static{c=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(M,_,T,U,X,Y,le,ce,ue,Q,G){this.userEnv=M,this.environmentMainService=_,this.logService=T,this.diagnosticsService=U,this.diagnosticsMainService=X,this.dialogMainService=Y,this.nativeHostMainService=le,this.protocolMainService=ce,this.productService=ue,this.stateService=Q,this.windowsMainService=G,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.validatedIpcMain.on("vscode:listProcesses",async M=>{const _=[];try{_.push({name:(0,l.localize)(0,null),rootProcess:await(0,b.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(U=>{(0,S.isRemoteDiagnosticError)(U)?_.push({name:U.hostName,rootProcess:U}):U.processes&&_.push({name:U.hostName,rootProcess:U.processes})})}catch(T){this.logService.error(`Listing processes failed: ${T}`)}this.safeSend(M,"vscode:listProcessesResponse",_)}),w.validatedIpcMain.on("vscode:workbenchCommand",(M,_)=>{const{id:T,from:U,args:X}=_;let Y;switch(U){case"processExplorer":Y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${U}`)}Y?.webContents.send("vscode:runAction",{id:T,from:U,args:X})}),w.validatedIpcMain.on("vscode:closeProcessExplorer",M=>{this.processExplorerWindow?.close()}),w.validatedIpcMain.on("vscode:pidToNameRequest",async M=>{const _=await this.diagnosticsMainService.getMainDiagnostics(),T=[];for(const U of _.windows)T.push([U.pid,`window [${U.id}] (${U.title})`]);for(const{pid:U,name:X}of s.UtilityProcess.getAll())T.push([U,X]);this.safeSend(M,"vscode:pidToNameResponse",T)})}async openReporter(M){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=C.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const _=new I.DisposableStore,T=_.add(this.protocolMainService.createIPCObjectUrl()),U=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(U,T,{backgroundColor:M.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:M.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:M,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:P.default}),this.issueReporterWindow.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,_.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,_.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(M){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=C.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const _=new I.DisposableStore,T=_.add(this.protocolMainService.createIPCObjectUrl()),U=this.stateService.getItem(v,void 0),X=k(U)?U:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(X,T,{backgroundColor:M.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:M.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:M,product:P.default}),this.processExplorerWindow.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,_.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,_.dispose())});const Y=()=>{if(!this.processExplorerWindow)return;const le=this.processExplorerWindow.getSize(),ce=this.processExplorerWindow.getPosition();if(!le||!ce)return;const ue={width:le[0],height:le[1],x:ce[0],y:ce[1]};this.stateService.setItem(v,ue)};this.processExplorerWindow.on("moved",Y),this.processExplorerWindow.on("resized",Y)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const M=await C.contentTracing.stopRecording(`${(0,D.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,M),buttons:[(0,l.localize)(5,null)]},C.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,M)}async getSystemStatus(){const[M,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(M,_)}async $getSystemInfo(){const[M,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(M,_)}async $getPerformanceInfo(){try{const[M,_]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(M,_)}catch(M){throw this.logService.warn("issueService#getPerformanceInfo ",M.message),M}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(M){this.logService.error(M)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:M}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.issueReporterWindow);M===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:M}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.issueReporterWindow);return M===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const M=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!M)throw new Error("Window not found");return M}async $getIssueReporterUri(M){const _=this.issueReporterWindowCheck(),T=`vscode:triggerIssueUriRequestHandlerResponse${_.id}`;return r.Promises.withAsyncBody(async(U,X)=>{const Y=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueUriRequestHandler",Y.token,{replyChannel:T,extensionId:M}),w.validatedIpcMain.once(T,(le,ce)=>{U(y.URI.parse(ce))});try{await(0,r.timeout)(5e3),Y.cancel(),X(new Error("Timed out waiting for issue reporter URI"))}finally{w.validatedIpcMain.removeHandler(T)}})}async $getIssueReporterData(M){const _=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataProviderResponse${_.id}`;return r.Promises.withAsyncBody(async U=>{const X=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueDataProvider",X.token,{replyChannel:T,extensionId:M}),w.validatedIpcMain.once(T,(Y,le)=>{U(le)});try{await(0,r.timeout)(5e3),X.cancel(),U("Error: Extension timed out waiting for issue reporter data")}finally{w.validatedIpcMain.removeHandler(T)}})}async $getIssueReporterTemplate(M){const _=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataTemplateResponse${_.id}`;return r.Promises.withAsyncBody(async U=>{const X=new O.CancellationTokenSource;_.sendWhenReady("vscode:triggerIssueDataTemplate",X.token,{replyChannel:T,extensionId:M}),w.validatedIpcMain.once(T,(Y,le)=>{U(le)});try{await(0,r.timeout)(5e3),X.cancel(),U("Error: Extension timed out waiting for issue reporter template")}finally{w.validatedIpcMain.removeHandler(T)}})}async $getReporterStatus(M,_){const T=[!1,!1],U=this.issueReporterWindowCheck(),X="vscode:triggerReporterStatus",Y=new O.CancellationTokenSource;return U.sendWhenReady(X,Y.token,{replyChannel:X,extensionId:M,extensionName:_}),await(0,r.raceTimeout)(new Promise(ce=>w.validatedIpcMain.once("vscode:triggerReporterStatusResponse",(ue,Q)=>ce(Q))),2e3,()=>{this.logService.error("Error: Extension timed out waiting for reporter status"),Y.cancel()})??T}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(M){M.isMinimized()&&M.restore(),M.focus()}safeSend(M,_,...T){M.sender.isDestroyed()||M.sender.send(_,...T)}createBrowserWindow(M,_,T,U){const X=new C.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:M.width,height:M.height,minWidth:300,minHeight:200,x:M.x,y:M.y,title:T.title,backgroundColor:T.backgroundColor||c.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${_.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.zoomLevelToZoomFactor)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return X.setMenuBarVisibility(!1),X}getWindowPosition(M,_,T){let U;const X=C.screen.getAllDisplays();if(X.length===1)U=X[0];else{if(u.isMacintosh){const ce=C.screen.getCursorScreenPoint();U=C.screen.getDisplayNearestPoint(ce)}!U&&M&&(U=C.screen.getDisplayMatching(M.getBounds())),U||(U=C.screen.getPrimaryDisplay()||X[0])}const Y=U.bounds,le={width:_,height:T,x:Y.x+Y.width/2-_/2,y:Y.y+Y.height/2-T/2};return Y.width>0&&Y.height>0&&(le.x<Y.x&&(le.x=Y.x),le.y<Y.y&&(le.y=Y.y),le.x>Y.x+Y.width&&(le.x=Y.x),le.y>Y.y+Y.height&&(le.y=Y.y),le.width>Y.width&&(le.width=Y.width),le.height>Y.height&&(le.height=Y.height)),le}};e.IssueMainService=R,e.IssueMainService=R=c=Ee([ne(1,g.IEnvironmentMainService),ne(2,d.ILogService),ne(3,S.IDiagnosticsService),ne(4,p.IDiagnosticsMainService),ne(5,m.IDialogMainService),ne(6,a.INativeHostMainService),ne(7,i.IProtocolMainService),ne(8,h.IProductService),ne(9,o.IStateService),ne(10,n.IWindowsMainService)],R);function k(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(se[300],oe([0,1,22,17,24,20,5,71,27,51,28,49,100]),function(V,e,C,L,r,O,D,I,f,u,y,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let l=class extends w.AbstractUpdateService{constructor(p,m,g,d,a,P,h,i){super(p,m,d,a,P,i),this.telemetryService=g,this.nativeHostMainService=h}buildUpdateFeedUrl(p){return(0,w.createUpdateURL)(`linux-${process.arch}`,p,this.productService)}doCheckForUpdates(p){this.url&&(this.setState(b.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},C.CancellationToken.None).then(u.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m);const g=p?m.message||m:void 0;this.setState(b.State.Idle(1,g))}))}async doDownloadUpdate(p){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(b.State.Idle(1))}};e.LinuxUpdateService=l,e.LinuxUpdateService=l=Ee([ne(0,O.ILifecycleMainService),ne(1,L.IConfigurationService),ne(2,y.ITelemetryService),ne(3,r.IEnvironmentMainService),ne(4,u.IRequestService),ne(5,D.ILogService),ne(6,I.INativeHostMainService),ne(7,f.IProductService)],l)}),define(se[301],oe([0,1,48,46,26,8,22,56,45,9,7,144,21,17,24,16,20,5,71,27,51,28,49,100]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(v,R=1e3){for(;!v();)await(0,O.timeout)(R)}let t;function n(){return typeof t>"u"&&(L.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?t=0:u.basename(u.normalize(u.join(process.execPath,"..","..")))==="Program Files"?t=3:t=1),t}let c=class extends o.AbstractUpdateService{get cachePath(){const R=u.join((0,r.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return w.Promises.mkdir(R,{recursive:!0}).then(()=>R)}constructor(R,k,E,M,_,T,U,X,Y){super(R,k,M,_,T,Y),this.telemetryService=E,this.fileService=U,this.nativeHostMainService=X,R.setRelaunchHandler(this)}handleRelaunch(R){return R?.addArgs||R?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(i.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(R){let k=`win32-${process.arch}`;switch(n()){case 1:k+="-archive";break;case 3:k+="-msi";break;default:this.productService.target==="user"?k+="-user":k+="-system"}return(0,o.createUpdateURL)(k,R,this.productService)}doCheckForUpdates(R){this.url&&(this.setState(i.State.CheckingForUpdates(R)),this.requestService.request({url:this.url},D.CancellationToken.None).then(P.asJson).then(k=>{const E=n();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!R}),this.setState(i.State.Idle(E)),Promise.resolve(null)):E===1?(this.setState(i.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(i.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(M=>w.Promises.exists(M).then(_=>{if(_)return Promise.resolve(M);const T=k.url,U=k.hash,X=`${M}.tmp`;return this.requestService.request({url:T},D.CancellationToken.None).then(Y=>this.fileService.writeFile(y.URI.file(X),Y.stream)).then(U?()=>(0,b.checksum)(X,k.hash):()=>{}).then(()=>w.Promises.rename(X,M,!1)).then(()=>M)})).then(M=>{const _=n()==0&&this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:M},_?this.productService.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(k)):this.setState(i.State.Ready(k))})))}).then(void 0,k=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,f.hash)(String(k)))}),this.logService.error(k);const E=R?k.message||k:void 0;this.setState(i.State.Idle(n(),E))}))}async doDownloadUpdate(R){R.update.url&&this.nativeHostMainService.openExternal(void 0,R.update.url),this.setState(i.State.Idle(n()))}async getUpdatePackagePath(R){const k=await this.cachePath;return u.join(k,`CodeSetup-${this.productService.quality}-${R}.exe`)}async cleanup(R=null){const k=R?T=>!new RegExp(`${this.productService.quality}-${R}\\.exe$`).test(T):()=>!0,E=await this.cachePath,_=(await w.Promises.readdir(E)).filter(k).map(async T=>{try{await w.Promises.unlink(u.join(E,T))}catch{}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const R=this.state.update;this.setState(i.State.Updating(R));const k=await this.cachePath;this.availableUpdate.updateFilePath=u.join(k,`CodeSetup-${this.productService.quality}-${R.version}.flag`),await w.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,C.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(n()))});const M=`${this.productService.win32MutexName}-ready`,_=await new Promise((T,U)=>{V(["@vscode/windows-mutex"],T,U)});s(()=>_.isActive(M)).then(()=>this.setState(i.State.Ready(R)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):n()==3?(0,C.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,C.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(R){if(this.state.type!=="idle")return;const k=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.setState(i.State.Downloading(E)),this.availableUpdate={packagePath:R},k?this.productService.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(E)):this.setState(i.State.Ready(E))}};e.Win32UpdateService=c,Ee([I.memoize],c.prototype,"cachePath",null),e.Win32UpdateService=c=Ee([ne(0,m.ILifecycleMainService),ne(1,l.IConfigurationService),ne(2,h.ITelemetryService),ne(3,S.IEnvironmentMainService),ne(4,P.IRequestService),ne(5,g.ILogService),ne(6,p.IFileService),ne(7,d.INativeHostMainService),ne(8,a.IProductService)],c)}),define(se[133],oe([0,1,15,8,22,50,3,2,13,68,4,7,190,26,66,17,53,24,64,16,20,5,27,80,252,82,28,102,70,60,29,30,55,128,39,34,54,69,23,6]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o,s,t,n,c,v,R,k,E,M,_,T,U,X,Y,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var ue;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(ue||(ue={}));class Q extends I.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(W){this._win=W,this._register(D.Event.fromNodeEventEmitter(W,"maximize")(()=>this._onDidMaximize.fire())),this._register(D.Event.fromNodeEventEmitter(W,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(D.Event.fromNodeEventEmitter(W,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(D.Event.fromNodeEventEmitter(W,"focus")(()=>{this._lastFocusTime=Date.now()}));const B=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(y.isMacintosh&&B&&W.setSheetOffset((0,y.isBigSurOrNewer)((0,l.release)())?28:22),B&&(y.isWindows&&(0,R.useWindowControlsOverlay)(this.configurationService)||y.isMacintosh)){const H=this.stateService.getItem(Q.windowControlHeightStateStorageKey);H&&this.updateWindowControls({height:H})}y.isWindows&&B&&W.hookWindowMessage(278,()=>{const[q,Z]=W.getPosition(),de=C.screen.getCursorScreenPoint(),j=de.x-q,A=de.y-Z;return(()=>!(j>30&&A>=0&&A<=Math.max(W.getBounds().height*.15,35)))()||(W.setEnabled(!1),W.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:j,y:A})),0}),this.environmentMainService.args["open-devtools"]===!0&&W.webContents.openDevTools()}constructor(W,B,H){super(),this.configurationService=W,this.stateService=B,this.environmentMainService=H,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new D.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new D.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,R.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}setRepresentedFilename(W){y.isMacintosh?this.win?.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return y.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){y.isMacintosh&&this.win?.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return y.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(W){y.isMacintosh&&W?.force&&C.app.focus({steal:!0});const B=this.win;B&&(B.isMinimized()&&B.restore(),B.focus())}handleTitleDoubleClick(){const W=this.win;if(W)if(y.isMacintosh)switch(C.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":W.minimize();break;case"None":break;case"Maximize":default:W.isMaximized()?W.unmaximize():W.maximize()}else W.isMaximized()?W.unmaximize():W.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(W){const B=this.win;if(B){if(W.height&&this.stateService.setItem(G.windowControlHeightStateStorageKey,W.height),y.isWindows&&this.hasWindowControlOverlay)B.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(y.isMacintosh&&W.height!==void 0){const H=(W.height-15)/2;H?B.setWindowButtonPosition({x:H,y:H}):B.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){(0,R.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(W):this.setSimpleFullScreen(W)}get isFullScreen(){if(y.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const W=this.win,B=W?.isFullScreen(),H=W?.isSimpleFullScreen();return!!(B||H)}setNativeFullScreen(W){const B=this.win;B?.isSimpleFullScreen()&&B?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(W)}doSetNativeFullScreen(W){y.isMacintosh&&(this.transientIsNativeFullScreen=W,this.joinNativeFullScreenTransition=new L.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,L.timeout)(1e4)]).finally(()=>{this.transientIsNativeFullScreen=void 0})),this.win?.setFullScreen(W)}setSimpleFullScreen(W){const B=this.win;B?.isFullScreen()&&this.doSetNativeFullScreen(!1),B?.setSimpleFullScreen(W),B?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=Q;let G=class extends Q{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const W=this.userDataProfilesService.profiles.find(B=>B.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,E.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(W,B,H,q,Z,de,j,A,F,J,z,K,N,$,ee,ae,re,me,pe,ye,Ie){super(J,ye,q),this.logService=B,this.loggerMainService=H,this.policyService=Z,this.userDataProfilesService=de,this.fileService=j,this.applicationStorageMainService=A,this.storageMainService=F,this.themeMainService=z,this.workspacesManagementMainService=K,this.backupMainService=N,this.telemetryService=$,this.dialogMainService=ee,this.lifecycleMainService=ae,this.productService=re,this.protocolMainService=me,this.windowsMainService=pe,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[We,be]=this.restoreWindowState(W.state);this.windowState=We,this.logService.trace("window#ctor: using window state",We);const Se=this.windowState.mode===0||this.windowState.mode===3,te=Ie.invokeFunction(k.defaultBrowserWindowOptions,this.windowState,{show:!Se,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"}});(0,u.mark)("code/willCreateCodeBrowserWindow"),this._win=new C.BrowserWindow(te),(0,u.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win);const he=this.configurationService.getValue("window"),ge=y.isMacintosh&&he?.nativeTabs===!0;(y.isMacintosh||y.isWindows)&&be&&(!ge||C.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Me=>typeof Me=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Se&&((0,u.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,u.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(W=>{function B(){H.dispose(),q.dispose(),W()}const H=this.onDidClose(()=>B()),q=this.onWillLoad(()=>B())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(B,H)=>this.onWindowError(2,{...H})),this._win.webContents.on("did-fail-load",(B,H,q)=>this.onWindowError(3,{reason:q,exitCode:H})),this._win.webContents.on("will-prevent-unload",B=>{B.preventDefault()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(D.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0})),this._register(D.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0})),this._register(this.configurationService.onDidChangeConfiguration(B=>this.onConfigurationUpdated(B))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(B=>this.onDidDeleteUntitledWorkspace(B)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(B,H)=>{const q=await this.getMarketplaceHeaders();H({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(W,B){switch(W){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:W,reason:B?.reason,code:B?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:q}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,w.localize)(0,null),(0,w.localize)(1,null),(0,w.localize)(2,null)],message:(0,w.localize)(3,null),detail:(0,w.localize)(4,null),checkboxLabel:this._config?.workspace?(0,w.localize)(5,null):void 0},this._win);if(H!==2){const Z=H===0;await this.destroyWindow(Z,q)}}else if(W===2){let H;B?H=(0,w.localize)(7,null,B.reason,B.exitCode??"<unknown>"):H=(0,w.localize)(6,null);const{response:q,checkboxChecked:Z}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,w.localize)(8,null):(0,w.localize)(9,null),(0,w.localize)(10,null)],message:H,detail:this._config?.workspace?(0,w.localize)(11,null):(0,w.localize)(12,null),checkboxLabel:this._config?.workspace?(0,w.localize)(13,null):void 0},this._win),de=q===0;await this.destroyWindow(de,Z)}break}}async destroyWindow(W,B){const H=this._config?.workspace;if(B&&H)try{const q=this.storageMainService.workspaceStorage(H);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.logService.error(q)}if(this._onDidDestroy.fire(),this._win?.destroy(),W&&this._config){let q,Z;(0,E.isSingleFolderWorkspaceIdentifier)(H)?q={folderUri:H.uri}:(0,E.isWorkspaceIdentifier)(H)?q={workspaceUri:H.configPath}:Z=!0,(0,le.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:Z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}onDidDeleteUntitledWorkspace(W){this._config?.workspace?.id===W.id&&(this._config.workspace=void 0)}onConfigurationUpdated(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B))}if(!W||W.affectsConfiguration("http.proxy")){let B=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=B,this.currentNoProxy=H;const q=B||"",Z=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${Z}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:Z,pacScript:""})}}}addTabbedWindow(W){y.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,B=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!B.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,B),this.readyState===0?this._config=W:this.pendingLoadConfig=W,this.readyState=1,this._win.loadURL(f.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:W.workspace,reason:B.isReload?3:H?2:1})}updateConfiguration(W,B){const H=(this._config??this.pendingLoadConfig)?.userEnv;if(H){const q=(0,d.isLaunchedFromCli)(H)&&!(0,d.isLaunchedFromCli)(W.userEnv),Z=this.isExtensionDevelopmentHost;(q||Z)&&(W.userEnv={...H,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(W["disable-extensions"]=B.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),(0,u.mark)("code/willOpenNewWindow"),W.perfMarks=(0,u.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const B=Object.assign({},this._config);B.workspace=await this.validateWorkspaceBeforeReload(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToMerge,delete B.filesToWait,this.isExtensionDevelopmentHost&&W&&(B.verbose=W.verbose,B.debugId=W.debugId,B.extensionEnvironment=W.extensionEnvironment,B["inspect-extensions"]=W["inspect-extensions"],B["inspect-brk-extensions"]=W["inspect-brk-extensions"],B["extensions-dir"]=W["extensions-dir"]),B.accessibilitySupport=C.app.isAccessibilitySupportEnabled(),B.isInitialStartup=!1,B.policiesData=this.policyService.serialize(),B.continueOn=this.environmentMainService.continueOn,B.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},B.logLevel=this.loggerMainService.getLogLevel(),B.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(B,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async validateWorkspaceBeforeReload(W){if((0,E.isWorkspaceIdentifier)(W.workspace)){const B=W.workspace.configPath;if(B.scheme===f.Schemas.file&&!await this.fileService.exists(B))return}else if((0,E.isSingleFolderWorkspaceIdentifier)(W.workspace)){const B=W.workspace.uri;if(B.scheme===f.Schemas.file&&!await this.fileService.exists(B))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,_.defaultWindowState)();if(this.isFullScreen){let H;try{H=C.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,_.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const W=Object.create(null);let B;if(!y.isMacintosh&&this._win.isMaximized()?B=0:B=1,B===0?W.mode=0:W.mode=1,B===1||B===0){let H;B===1?H=this.getBounds():H=this._win.getNormalBounds(),W.x=H.x,W.y=H.y,W.width=H.width,W.height=H.height}return W}restoreWindowState(W){(0,u.mark)("code/willRestoreCodeWindowState");let B=!1;if(W)try{const H=C.screen.getAllDisplays();B=H.length>1,W=this.validateWindowState(W,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,u.mark)("code/didRestoreCodeWindowState"),[W||(0,_.defaultWindowState)(),B]}validateWindowState(W,B){if(this.logService.trace(`window#validateWindowState: validating window state on ${B.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(B.length===1){const Z=this.getWorkingArea(B[0]);if(Z){let de=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!Z||(W.x<Z.x&&(W.x=Z.x),W.y<Z.y&&(W.y=Z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Z),de(),W.width>Z.width&&(W.width=Z.width),W.height>Z.height&&(W.height=Z.height),W.x>Z.x+Z.width-128&&(W.x=Z.x+Z.width-W.width),W.y>Z.y+Z.height-128&&(W.y=Z.y+Z.height-W.height),de()}return W}if(W.display&&W.mode===3){const Z=B.find(de=>de.id===W.display);if(Z&&typeof Z.bounds?.x=="number"&&typeof Z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const de=(0,_.defaultWindowState)(3);return de.x=Z.bounds.x,de.y=Z.bounds.y,de}}let H,q;try{H=C.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),q=this.getWorkingArea(H)}catch{}if(H&&q&&W.x+W.width>q.x&&W.y+W.height>q.y&&W.x<q.x+q.width&&W.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,B]=this._win.getPosition(),[H,q]=this._win.getSize();return{x:W,y:B,width:H,height:q}}setFullScreen(W){super.setFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let W=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,B=!0){y.isMacintosh||(W==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,w.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const B=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!B),this._win.autoHideMenuBar=B;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}close(){this._win?.close()}sendWhenReady(W,B,...H){this.isReady?this.send(W,...H):this.ready().then(()=>{B.isCancellationRequested||this.send(W,...H)})}send(W,...B){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this._win.webContents.send(W,...B)}catch(H){this.logService.warn(`Error sending IPC message to channel '${W}' of window ${this._id}: ${(0,O.toErrorMessage)(H)}`)}}}updateTouchBar(W){y.isMacintosh&&this.touchBarGroups.forEach((B,H)=>{const q=W[H];B.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(y.isMacintosh){for(let W=0;W<10;W++){const B=this.createTouchBarGroup();this.touchBarGroups.push(B)}this._win.setTouchBar(new C.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const B=this.createTouchBarGroupSegments(W),H=new C.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:H.segments[q].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(W=[]){return W.map(H=>{let q;H.icon&&!c.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(q=C.nativeImage.createFromPath(b.URI.revive(H.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let Z;return typeof H.title=="string"?Z=H.title:Z=H.title.value,{id:H.id,label:q?void 0:Z,icon:q}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=G,e.CodeWindow=G=Ee([ne(1,h.ILogService),ne(2,Y.ILoggerMainService),ne(3,g.IEnvironmentMainService),ne(4,T.IPolicyService),ne(5,X.IUserDataProfilesMainService),ne(6,a.IFileService),ne(7,t.IApplicationStorageMainService),ne(8,t.IStorageMainService),ne(9,p.IConfigurationService),ne(10,v.IThemeMainService),ne(11,M.IWorkspacesManagementMainService),ne(12,S.IBackupMainService),ne(13,n.ITelemetryService),ne(14,m.IDialogMainService),ne(15,P.ILifecycleMainService),ne(16,i.IProductService),ne(17,o.IProtocolMainService),ne(18,k.IWindowsMainService),ne(19,U.IStateService),ne(20,ce.IInstantiationService)],G)}),define(se[302],oe([0,1,15,17,24,5,34,133]),function(V,e,C,L,r,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let f=class extends I.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(y,b,w,l,S){super(l,S,b),this.contents=y,this.logService=w,this.id=this.contents.id,this.parentId=-1,y.removeAllListeners("devtools-reload-page"),this.tryClaimWindow()}tryClaimWindow(){if(this._win||this._store.isDisposed||this.contents.isDestroyed())return;const y=C.BrowserWindow.fromWebContents(this.contents);y&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(y),y.setMenu(null))}};e.AuxiliaryWindow=f,e.AuxiliaryWindow=f=Ee([ne(1,r.IEnvironmentMainService),ne(2,O.ILogService),ne(3,L.IConfigurationService),ne(4,D.IStateService)],f)}),define(se[303],oe([0,1,15,3,2,13,36,302,6,5,29]),function(V,e,C,L,r,O,D,I,f,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let b=class extends r.Disposable{constructor(l,S){super(),this.instantiationService=l,this.logService=S,this._onDidMaximizeWindow=this._register(new L.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new L.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidTriggerSystemContextMenu=this._register(new L.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){C.app.on("browser-window-created",(l,S)=>{const p=this.getWindowById(S.id);p&&(this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow())}),D.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(l,S)=>{const p=this.getWindowById(l.sender.id);return p&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=S),l.sender.id})}createWindow(){return this.instantiationService.invokeFunction(y.defaultBrowserWindowOptions,void 0,{webPreferences:{preload:O.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(l){const S=new r.DisposableStore,p=this.instantiationService.createInstance(I.AuxiliaryWindow,l);this.windows.set(p.id,p),S.add((0,r.toDisposable)(()=>this.windows.delete(p.id))),S.add(p.onDidMaximize(()=>this._onDidMaximizeWindow.fire(p))),S.add(p.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(p))),S.add(p.onDidTriggerSystemContextMenu(({x:m,y:g})=>this._onDidTriggerSystemContextMenu.fire({window:p,x:m,y:g}))),L.Event.once(p.onDidClose)(()=>S.dispose())}getWindowById(l){return this.windows.get(l)}getFocusedWindow(){const l=C.BrowserWindow.getFocusedWindow();if(l)return this.getWindowById(l.id)}getLastActiveWindow(){return(0,y.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=b,e.AuxiliaryWindowsMainService=b=Ee([ne(0,f.IInstantiationService),ne(1,u.ILogService)],b)}),define(se[83],oe([0,1,15,23,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,55,31,53]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,S.createDecorator)("workspacesHistoryMainService");let s=class extends I.Disposable{static{o=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(n,c,v,R,k){super(),this.logService=n,this.workspacesManagementMainService=c,this.lifecycleMainService=v,this.applicationStorageMainService=R,this.dialogMainService=k,this._onDidChangeRecentlyOpened=this._register(new O.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new r.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let c=[],v=[];for(const k of n)if((0,d.isRecentWorkspace)(k))!this.workspacesManagementMainService.isUntitledWorkspace(k.workspace)&&!this.containsWorkspace(c,k.workspace)&&c.push(k);else if((0,d.isRecentFolder)(k))this.containsFolder(c,k.folderUri)||c.push(k);else{const E=this.containsFile(v,k.fileUri),M=k.fileUri.scheme===f.Schemas.file&&o.COMMON_FILES_FILTER.indexOf((0,y.basename)(k.fileUri))>=0;!E&&!M&&(v.push(k),u.isWindows&&k.fileUri.scheme===f.Schemas.file&&C.app.addRecentDocument(k.fileUri.fsPath))}const R=await this.mergeEntriesFromStorage({workspaces:c,files:v});c=R.workspaces,v=R.files,c.length>o.MAX_TOTAL_RECENT_ENTRIES&&(c.length=o.MAX_TOTAL_RECENT_ENTRIES),v.length>o.MAX_TOTAL_RECENT_ENTRIES&&(v.length=o.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:c,files:v}),this._onDidChangeRecentlyOpened.fire(),u.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const c=E=>{const M=this.location(E);for(const _ of n)if(y.extUriBiasedIgnorePathCase.isEqual(_,M))return!1;return!0},v=await this.getRecentlyOpened(),R=v.workspaces.filter(c),k=v.files.filter(c);(R.length!==v.workspaces.length||k.length!==v.files.length)&&(await this.saveRecentlyOpened({files:k,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),u.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:c}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,l.localize)(0,null),(0,l.localize)(1,null)],message:(0,l.localize)(2,null),detail:(0,l.localize)(3,null),cancelId:1});if(c!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),C.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(n){const c=new h.ResourceMap(k=>y.extUriBiasedIgnorePathCase.getComparisonKey(k));if(n?.workspaces)for(const k of n.workspaces)c.set(this.location(k),k);const v=new h.ResourceMap(k=>y.extUriBiasedIgnorePathCase.getComparisonKey(k));if(n?.files)for(const k of n.files)v.set(this.location(k),k);const R=await this.getRecentlyOpenedFromStorage();for(const k of R.workspaces){const E=c.get(this.location(k));E?E.label=E.label??k.label:c.set(this.location(k),k)}for(const k of R.files){const E=v.get(this.location(k));E?E.label=E.label??k.label:v.set(this.location(k),k)}return{workspaces:[...c.values()],files:[...v.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const c=this.applicationStorageMainService.get(o.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof c=="string")try{n=JSON.parse(c)}catch(v){this.logService.error("Unexpected error parsing opened paths list",v)}return(0,d.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(o.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,d.toStoreData)(n)),-1,1)}location(n){return(0,d.isRecentFolder)(n)?n.folderUri:(0,d.isRecentFile)(n)?n.fileUri:n.workspace.configPath}containsWorkspace(n,c){return!!n.find(v=>(0,d.isRecentWorkspace)(v)&&v.workspace.id===c.id)}containsFolder(n,c){return!!n.find(v=>(0,d.isRecentFolder)(v)&&y.extUriBiasedIgnorePathCase.isEqual(v.folderUri,c))}containsFile(n,c){return!!n.find(v=>y.extUriBiasedIgnorePathCase.isEqual(v.fileUri,c))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){u.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!u.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,l.localize)(4,null),description:(0,l.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const k of C.app.getJumpListSettings().removedItems){const E=k.args;if(E){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);M&&c.push(b.URI.parse(M[2]))}}await this.removeRecentlyOpened(c);let v=!1;const R=(0,L.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,o.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(k=>{const E=(0,d.isRecentWorkspace)(k)?k.workspace:k.folderUri,{title:M,description:_}=this.getWindowsJumpListLabel(E,k.label);let T;return b.URI.isUri(E)?T=`--folder-uri "${E.toString()}"`:(v=!0,T=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:_.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&n.push({type:"custom",name:v?(0,l.localize)(6,null):(0,l.localize)(7,null),items:R})}n.push({type:"recent"});try{const c=C.app.setJumpList(n);c&&c!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.logService.warn("updateWindowsJumpList#setJumpList",c)}}getWindowsJumpListLabel(n,c){if(c)return{title:(0,D.splitRecentLabel)(c).name,description:c};if(b.URI.isUri(n))return{title:(0,y.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,l.localize)(8,null),description:""};let v=(0,y.basename)(n.configPath);return v.endsWith(a.WORKSPACE_EXTENSION)&&(v=v.substr(0,v.length-a.WORKSPACE_EXTENSION.length-1)),{title:(0,l.localize)(9,null,v),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,D.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!u.isMacintosh)return;C.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),c=[];let v=0;for(let k=0;k<n.workspaces.length&&v<o.MAX_MACOS_DOCK_RECENT_WORKSPACES;k++){const E=this.location(n.workspaces[k]);if(E.scheme===f.Schemas.file){const M=(0,y.originalFSPath)(E);await w.Promises.exists(M)&&(c.push(M),v++)}}const R=[];for(let k=0;k<n.files.length&&v<o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;k++){const E=this.location(n.files[k]);if(E.scheme===f.Schemas.file){const M=(0,y.originalFSPath)(E);if(o.COMMON_FILES_FILTER.includes((0,y.basename)(E))||c.includes(M))continue;await w.Promises.exists(M)&&(R.push(M),v++)}}R.reverse().forEach(k=>C.app.addRecentDocument(k)),c.reverse().forEach(k=>C.app.addRecentDocument(k))}};e.WorkspacesHistoryMainService=s,e.WorkspacesHistoryMainService=s=o=Ee([ne(0,m.ILogService),ne(1,P.IWorkspacesManagementMainService),ne(2,p.ILifecycleMainService),ne(3,g.IApplicationStorageMainService),ne(4,i.IDialogMainService)],s)}),define(se[304],oe([0,1,15,8,22,47,4,7,181,65,17,24,20,5,231,71,27,34,28,49,60,29,83]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let t=class{static{o=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(v,R,k,E,M,_,T,U,X,Y,le,ce){this.updateService=v,this.configurationService=R,this.windowsMainService=k,this.environmentMainService=E,this.telemetryService=M,this.workspacesHistoryMainService=_,this.stateService=T,this.lifecycleMainService=U,this.logService=X,this.nativeHostMainService=Y,this.productService=le,this.auxiliaryWindowsMainService=ce,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,P.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const v=this.stateService.getItem(o.lastKnownMenubarStorageKey);v&&(v.menus&&(this.menubarMenus=v.menus),v.keybindings&&(this.keybindings=v.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,T,U)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,T,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,T,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(_,T,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,T,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const v=this.productService.youTubeUrl;v&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(v,"openYouTubeUrl"));const R=this.productService.requestFeatureUrl;R&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(R,"openUserVoiceUrl"));const k=this.productService.reportIssueUrl;k&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(k,"openReportIssues"));const E=this.productService.licenseUrl;E&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const _=E.indexOf("?")>0?"&":"?";this.openUrl(`${E}${_}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(E,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&E&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(v=>this.onDidChangeWindowsCount(v)),this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const v=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof v!="boolean"?!0:v}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const v=this.configurationService.getValue("window.nativeTabs");return typeof v!="boolean"?!1:v}updateMenu(v,R){this.menubarMenus=v.menus,this.keybindings=v.keybindings,this.stateService.setItem(o.lastKnownMenubarStorageKey,v),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(v){D.isMacintosh&&(v.oldCount===0&&v.newCount>0||v.oldCount>0&&v.newCount===0)&&(this.closedLastWindow=v.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!D.isMacintosh)return;const v=C.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!v||!!this.auxiliaryWindowsMainService.getWindowById(v.id),this.scheduleUpdateMenu()}install(){const v=C.Menu.getApplicationMenu();if(v&&this.oldMenus.push(v),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(D.isMacintosh?new C.Menu:null);return}const R=new C.Menu;let k;if(D.isMacintosh){const M=new C.Menu;k=new C.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),R.append(k)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new C.Menu;M.append(new C.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),C.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:M});this.setMenuById(M,"File"),R.append(_)}if(this.shouldDrawMenu("Edit")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),R.append(_)}if(this.shouldDrawMenu("Selection")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),R.append(_)}if(this.shouldDrawMenu("View")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:M});this.setMenuById(M,"View"),R.append(_)}if(this.shouldDrawMenu("Go")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),R.append(_)}if(this.shouldDrawMenu("Run")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),R.append(_)}if(this.shouldDrawMenu("Terminal")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),R.append(_)}let E;if(this.shouldDrawMenu("Window")){const M=new C.Menu;E=new C.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(E&&R.append(E),this.shouldDrawMenu("Help")){const M=new C.Menu,_=new C.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),R.append(_)}R.items&&R.items.length>0?this.doSetApplicationMenu(R):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(v){if(C.Menu.setApplicationMenu(v),v)for(const R of this.auxiliaryWindowsMainService.getWindows())R.win?.setMenu(null)}setMacApplicationMenu(v){const R=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),k=this.getUpdateMenuItems();let E;if(this.shouldDrawMenu("Preferences")){const ce=new C.Menu;this.setMenuById(ce,"Preferences"),E=new C.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:ce})}const M=new C.Menu,_=new C.MenuItem({label:f.localize(12,null),role:"services",submenu:M}),T=new C.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new C.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),X=new C.MenuItem({label:f.localize(15,null),role:"unhide"}),Y=new C.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:async(ce,ue,Q)=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||C.BrowserWindow.getFocusedWindow()||G?.win?.isMinimized())&&await this.confirmBeforeQuit(Q)&&this.nativeHostMainService.quit(void 0)}})),le=[R];le.push(...k),E&&le.push(n(),E),le.push(n(),_,n(),T,U,X,n(),Y),le.forEach(ce=>v.append(ce))}async confirmBeforeQuit(v){if(this.windowsMainService.getWindowCount()===0)return!0;const R=this.configurationService.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.isKeyboardEvent(v)){const{response:k}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return k===0}return!0}shouldDrawMenu(v){if(!D.isMacintosh&&(0,P.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(v){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[v];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[v]}}setMenu(v,R){R.forEach(k=>{if((0,S.isMenubarMenuItemSeparator)(k))v.append(n());else if((0,S.isMenubarMenuItemSubmenu)(k)){const E=new C.Menu,M=new C.MenuItem({label:this.mnemonicLabel(k.label),submenu:E});this.setMenu(E,k.submenu.items),v.append(M)}else(0,S.isMenubarMenuItemRecentAction)(k)?v.append(this.createOpenRecentMenuItem(k)):(0,S.isMenubarMenuItemAction)(k)&&(k.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(v),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[k.id]?v.append(new C.MenuItem(this.likeAction(k.id,{label:this.mnemonicLabel(k.label),click:this.fallbackMenuHandlers[k.id]}))):v.append(this.createMenuItem(k.label,k.id,!1,k.checked)):v.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)):v.append(this.createMenuItem(k.label,k.id,k.enabled!==!1,!!k.checked)))})}setMenuById(v,R){this.menubarMenus&&this.menubarMenus[R]&&this.setMenu(v,this.menubarMenus[R].items)}insertCheckForUpdatesItems(v){const R=this.getUpdateMenuItems();R.length&&(R.forEach(k=>v.append(k)),v.append(n()))}createOpenRecentMenuItem(v){const R=I.URI.revive(v.uri),k=v.id,E=k==="openRecentFile"?{fileUri:R}:k==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new C.MenuItem(this.likeAction(k,{label:v.label,click:async(M,_,T)=>{const U=this.isOptionClick(T);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[E],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:v.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([R])}},!1))}isOptionClick(v){return!!(v&&(!D.isMacintosh&&(v.ctrlKey||v.shiftKey)||D.isMacintosh&&(v.metaKey||v.altKey)))}isKeyboardEvent(v){return!!(v.triggeredByAccelerator||v.altKey||v.ctrlKey||v.metaKey||v.shiftKey)}createRoleMenuItem(v,R,k){const E={label:this.mnemonicLabel(v),role:k,enabled:!0};return new C.MenuItem(this.withKeybinding(R,E))}setMacWindowMenu(v){const R=new C.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),k=new C.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),E=new C.MenuItem({label:f.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(f.localize(23,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(n()),_.push(this.createMenuItem(f.localize(24,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,k,n(),M,..._,n(),E].forEach(T=>v.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new C.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new C.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new C.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new C.MenuItem({label:this.mnemonicLabel(f.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(v,R,k,E){const M=this.mnemonicLabel(v),_=typeof R=="function"?R:(le,ce,ue)=>{const Q=le?le.userSettingsLabel:null;let G=R;Array.isArray(R)&&(G=this.isOptionClick(ue)?R[1]:R[0]),Q&&ue.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:Q}):this.runActionInRenderer({type:"commandId",commandId:G})},T=typeof k=="boolean"?k:this.windowsMainService.getWindowCount()>0,U=typeof E=="boolean"?E:!1,X={label:M,click:_,enabled:T};U&&(X.type="checkbox",X.checked=U);let Y;return typeof R=="string"?Y=R:Array.isArray(R)&&(Y=R[0]),D.isMacintosh&&(Y==="editor.action.clipboardCutAction"?X.role="cut":Y==="editor.action.clipboardCopyAction"?X.role="copy":Y==="editor.action.clipboardPasteAction"&&(X.role="paste"),Y==="undo"?X.click=this.makeContextAwareClickHandler(_,{inDevTools:le=>le.undo(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?X.click=this.makeContextAwareClickHandler(_,{inDevTools:le=>le.redo(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&(X.click=this.makeContextAwareClickHandler(_,{inDevTools:le=>le.selectAll(),inNoWindow:()=>C.Menu.sendActionToFirstResponder("selectAll:")}))),new C.MenuItem(this.withKeybinding(Y,X))}makeContextAwareClickHandler(v,R){return(k,E,M)=>{const _=C.BrowserWindow.getFocusedWindow();if(!_)return R.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return R.inDevTools(_.webContents.devToolsWebContents);v(k,E||_,M)}}runActionInRenderer(v){let R=C.BrowserWindow.getFocusedWindow();if(R){const E=this.auxiliaryWindowsMainService.getWindowById(R.id);E&&(R=this.windowsMainService.getWindowById(E.parentId)?.win??null)}if(!R){const E=this.windowsMainService.getLastActiveWindow();E?.win?.isMinimized()&&(R=E.win)}const k=R?this.windowsMainService.getWindowById(R.id):void 0;if(k){if(this.logService.trace("menubar#runActionInRenderer",v),D.isMacintosh&&!this.environmentMainService.isBuilt&&!k.isReady&&(v.type==="commandId"&&v.commandId==="workbench.action.toggleDevTools"||v.type!=="commandId"&&v.userSettingsLabel==="alt+cmd+i"))return!1;if(v.type==="commandId"){const E={id:v.commandId,from:"menu"};k.sendWhenReady("vscode:runAction",r.CancellationToken.None,E)}else{const E={userSettingsLabel:v.userSettingsLabel};k.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,E)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",v),!1}withKeybinding(v,R){const k=typeof v=="string"?this.keybindings[v]:void 0;if(k?.label){if(k.isNative!==!1)R.accelerator=k.label,R.userSettingsLabel=k.userSettingsLabel;else if(typeof R.label=="string"){const E=R.label.indexOf("[");E>=0?R.label=`${R.label.substr(0,E)} [${k.label}]`:R.label=`${R.label} [${k.label}]`}}else R.accelerator=void 0;return R}likeAction(v,R,k=!R.accelerator){k&&(R=this.withKeybinding(v,R));const E=R.click;return R.click=(M,_,T)=>{this.reportMenuActionTelemetry(v),E?.(M,_,T)},R}openUrl(v,R){this.nativeHostMainService.openExternal(void 0,v),this.reportMenuActionTelemetry(R)}reportMenuActionTelemetry(v){this.telemetryService.publicLog2("workbenchActionExecuted",{id:v,from:s})}mnemonicLabel(v){return(0,O.mnemonicMenuLabel)(v,!this.currentEnableMenuBarMnemonics)}};e.Menubar=t,e.Menubar=t=o=Ee([ne(0,a.IUpdateService),ne(1,y.IConfigurationService),ne(2,h.IWindowsMainService),ne(3,b.IEnvironmentMainService),ne(4,d.ITelemetryService),ne(5,i.IWorkspacesHistoryMainService),ne(6,g.IStateService),ne(7,w.ILifecycleMainService),ne(8,l.ILogService),ne(9,p.INativeHostMainService),ne(10,m.IProductService),ne(11,u.IAuxiliaryWindowsMainService)],t);function n(){return new C.MenuItem({type:"separator"})}}),define(se[305],oe([0,1,6,20,5,304]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,C.createDecorator)("menubarMainService");let D=class{constructor(f,u,y){this.instantiationService=f,this.lifecycleMainService=u,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(O.Menubar)}async updateMenubar(f,u){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(u,f)}};e.MenubarMainService=D,e.MenubarMainService=D=Ee([ne(0,C.IInstantiationService),ne(1,L.ILifecycleMainService),ne(2,r.ILogService)],D)}),define(se[306],oe([0,1,15,21,131,26,23,22,3,33,47,2,13,9,68,4,35,19,12,7,191,66,17,53,24,16,6,20,5,79,80,59,34,60,133,29,130,298,30,98,83,55,70,39,54,69,65]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o,s,t,n,c,v,R,k,E,M,_,T,U,X,Y,le,ce,ue,Q,G,x,W,B,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(j){return(0,le.isWorkspaceIdentifier)(j?.workspace)}function Z(j){return(0,le.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let de=class extends b.Disposable{constructor(A,F,J,z,K,N,$,ee,ae,re,me,pe,ye,Ie,We,be,Se,te,he,ge){super(),this.machineId=A,this.sqmId=F,this.initialUserEnv=J,this.logService=z,this.loggerService=K,this.stateService=N,this.policyService=$,this.environmentMainService=ee,this.userDataProfilesMainService=ae,this.lifecycleMainService=re,this.backupMainService=me,this.configurationService=pe,this.workspacesHistoryMainService=ye,this.workspacesManagementMainService=Ie,this.instantiationService=We,this.dialogMainService=be,this.fileService=Se,this.protocolMainService=te,this.themeMainService=he,this.auxiliaryWindowsMainService=ge,this._onDidOpenWindow=this._register(new f.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new f.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new f.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new f.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new f.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new f.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidTriggerSystemContextMenu=this._register(new f.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new Y.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new b.DisposableStore;if(F.add(f.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const J of A.config.extensionDevelopmentPath)F.add(this.protocolMainService.addValidFileRoot(J));A.config.extensionTestsPath&&F.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,F){const J=this.environmentMainService.args,z=F?.remoteAuthority||void 0,K=!0,N=F?.forceReuseWindow,$=!N;return this.open({...A,cli:J,forceEmpty:K,forceNewWindow:$,forceReuseWindow:N,remoteAuthority:z})}openExistingWindow(A,F){A.focus(),this.handleWaitMarkerFile(F,[A])}async open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],J=[],z=[],K=[],N=[];let $,ee=0;const ae=await this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const Ie of ae)Z(Ie)?A.addMode?F.push(Ie):J.push(Ie):q(Ie)?z.push(Ie):Ie.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ie.remoteAuthority}),$.filesToOpenOrCreate.push(Ie)):Ie.backupPath?N.push({backupFolder:(0,l.basename)(Ie.backupPath),remoteAuthority:Ie.remoteAuthority}):ee++;A.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),A.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&A.waitMarkerFileURI&&($.filesToWait={paths:(0,D.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(K.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),z.push(...K),N.push(...this.backupMainService.getEmptyWindowBackups())):N.length=0;const{windows:re,filesOpenedInWindow:me}=await this.doOpen(A,z,J,N,ee,$,F);if(this.logService.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${J.length}, emptyToRestore: ${N.length}, emptyToOpen: ${ee})`),re.length>1)if(me)me.focus();else{const Ie=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let We=!0,be=!0;if(Ie){const Se=re.filter(te=>this.windowsStateHandler.state.lastActiveWindow&&te.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Se.length&&(Se[0].focus(),We=!1,be=!1)}if(We)for(let Se=re.length-1;Se>=0;Se--){const te=re[Se];if(!(te.openedWorkspace&&K.some(he=>te.openedWorkspace&&he.workspace.id===te.openedWorkspace.id)||te.backupPath&&N.some(he=>te.backupPath&&he.backupFolder===(0,l.basename)(te.backupPath)))){te.focus(),be=!1;break}}be&&re[re.length-1].focus()}const pe=$&&$.filesToDiff.length>0,ye=$&&$.filesToMerge.length>0;if(!re.some(Ie=>Ie.isExtensionDevelopmentHost)&&!pe&&!ye&&!A.noRecentEntry){const Ie=[];for(const We of ae)q(We)&&!We.transient?Ie.push({label:We.label,workspace:We.workspace,remoteAuthority:We.remoteAuthority}):Z(We)?Ie.push({label:We.label,folderUri:We.workspace.uri,remoteAuthority:We.remoteAuthority}):We.fileUri&&Ie.push({label:We.label,fileUri:We.fileUri,remoteAuthority:We.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ie)}return this.handleWaitMarkerFile(A,re),re}handleWaitMarkerFile(A,F){const J=A.waitMarkerFileURI;A.context===0&&J&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.fileService.del(J)}catch{}})()}async doOpen(A,F,J,z,K,N,$){const ee=[];let ae;function re(Se,te){ee.push(Se),te&&(ae=Se,N=void 0)}let{openFolderInNewWindow:me,openFilesInNewWindow:pe}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&$.length>0){const Se=$[0].remoteAuthority,te=this.getLastActiveWindowForAuthority(Se);te&&re(this.doAddFoldersToExistingWindow(te,$.map(he=>he.workspace.uri)))}const ye=J.length+F.length+z.length;if(N&&ye===0){const Se=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],te=this.getWindows().filter(ge=>N&&(0,g.isEqualAuthority)(ge.remoteAuthority,N.remoteAuthority));let he;Se?.fileUri&&!pe&&((A.context===4||A.context===0||A.context===1)&&(he=await(0,X.findWindowOnFile)(te,Se.fileUri,async ge=>ge.configPath.scheme===w.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(ge.configPath):void 0)),he||(he=this.doGetLastActiveWindow(te))),he?(0,le.isWorkspaceIdentifier)(he.openedWorkspace)?F.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):(0,le.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)?J.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):re(this.doOpenFilesInExistingWindow(A,he,N),!0):re(await this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Ie=(0,D.distinct)(F,Se=>Se.workspace.id);if(Ie.length>0){const Se=(0,D.coalesce)(Ie.map(te=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),te.workspace.configPath)));if(Se.length>0){const te=Se[0],he=(0,g.isEqualAuthority)(N?.remoteAuthority,te.remoteAuthority)?N:void 0;re(this.doOpenFilesInExistingWindow(A,te,he),!!he),me=!0}for(const te of Ie){if(Se.some(Me=>Me.openedWorkspace&&Me.openedWorkspace.id===te.workspace.id))continue;const he=te.remoteAuthority,ge=(0,g.isEqualAuthority)(N?.remoteAuthority,he)?N:void 0;re(await this.doOpenFolderOrWorkspace(A,te,me,ge),!!ge),me=!0}}const We=(0,D.distinct)(J,Se=>g.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(We.length>0){const Se=(0,D.coalesce)(We.map(te=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),te.workspace.uri)));if(Se.length>0){const te=Se[0],he=(0,g.isEqualAuthority)(N?.remoteAuthority,te.remoteAuthority)?N:void 0;re(this.doOpenFilesInExistingWindow(A,te,he),!!he),me=!0}for(const te of We){if(Se.some(Me=>(0,le.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(Me.openedWorkspace.uri,te.workspace.uri)))continue;const he=te.remoteAuthority,ge=(0,g.isEqualAuthority)(N?.remoteAuthority,he)?N:void 0;re(await this.doOpenFolderOrWorkspace(A,te,me,ge),!!ge),me=!0}}const be=(0,D.distinct)(z,Se=>Se.backupFolder);if(be.length>0)for(const Se of be){const te=Se.remoteAuthority,he=(0,g.isEqualAuthority)(N?.remoteAuthority,te)?N:void 0;re(await this.doOpenEmpty(A,!0,te,he,Se),!!he),me=!0}if(ee.length===0||N){N&&!K&&K++;const Se=N?N.remoteAuthority:A.remoteAuthority;for(let te=0;te<K;te++)re(await this.doOpenEmpty(A,me,Se,N),!!N),me=!0}return{windows:(0,D.distinct)(ee),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(A,F,J){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:J}),this.focusMainOrChildWindow(F);const z={filesToOpenOrCreate:J?.filesToOpenOrCreate,filesToDiff:J?.filesToDiff,filesToMerge:J?.filesToMerge,filesToWait:J?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",I.CancellationToken.None,z),F}focusMainOrChildWindow(A){let F=A;const J=C.BrowserWindow.getFocusedWindow();if(J&&J.id!==A.id){const z=this.auxiliaryWindowsMainService.getWindowById(J.id);z&&z.parentId===A.id&&(F=z)}F.focus()}doAddFoldersToExistingWindow(A,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),A.focus();const J={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",I.CancellationToken.None,J),A}doOpenEmpty(A,F,J,z,K){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!K,remoteAuthority:J,filesToOpen:z,forceNewWindow:F});let N;return!F&&typeof A.contextWindowId=="number"&&(N=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:J,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:N,emptyWindowBackupInfo:K,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}doOpenFolderOrWorkspace(A,F,J,z,K){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:z}),!J&&!K&&typeof A.contextWindowId=="number"&&(K=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:J,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:K,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async getPathsToOpen(A){let F,J=!1,z=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=await this.doExtractPathsFromAPI(A),J=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=await this.doExtractPathsFromCLI(A.cli),F.length===0&&F.push(Object.create(null)),J=!0):(F=await this.doGetPathsFromLastSession(),F.length===0&&F.push(Object.create(null)),z=!0),!A.addMode&&J){const K=F.filter(N=>Z(N));if(K.length>1){const N=K[0].remoteAuthority;if(K.every($=>(0,g.isEqualAuthority)($.remoteAuthority,N))){const $=await this.workspacesManagementMainService.createUntitledWorkspace(K.map(ee=>({uri:ee.workspace.uri})));F.push({workspace:$,remoteAuthority:N}),F=F.filter(ee=>!Z(ee))}}}if(A.initialStartup&&!z&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const K=await this.doGetPathsFromLastSession();F.unshift(...K.filter(N=>q(N)||Z(N)||N.backupPath))}return F}async doExtractPathsFromAPI(A){const F={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},J=await Promise.all((0,D.coalesce)(A.urisToOpen||[]).map(async z=>{const K=await this.resolveOpenable(z,F);if(K)return K.label=z.label,K;const N=this.resourceFromOpenable(z);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,P.localize)(0,null)],message:N.scheme===w.Schemas.file?(0,P.localize)(1,null):(0,P.localize)(2,null),detail:N.scheme===w.Schemas.file?(0,P.localize)(3,null,(0,y.getPathLabel)(N,{os:p.OS,tildify:this.environmentMainService})):(0,P.localize)(4,null,N.toString(!0))},C.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.coalesce)(J)}async doExtractPathsFromCLI(A){const F=[],J={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},z=A["folder-uri"];if(z){const $=await Promise.all(z.map(ee=>{const ae=this.cliArgToUri(ee);if(ae)return this.resolveOpenable({folderUri:ae},J)}));F.push(...(0,D.coalesce)($))}const K=A["file-uri"];if(K){const $=await Promise.all(K.map(ee=>{const ae=this.cliArgToUri(ee);if(ae)return this.resolveOpenable((0,le.hasWorkspaceFileExtension)(ee)?{workspaceUri:ae}:{fileUri:ae},J)}));F.push(...(0,D.coalesce)($))}const N=await Promise.all(A._.map($=>J.remoteAuthority?this.doResolveRemotePath($,J):this.doResolveFilePath($,J)));return F.push(...(0,D.coalesce)(N)),F}cliArgToUri(A){try{const F=a.URI.parse(A);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.logService.error(`Invalid URI input string: ${A}, ${F.message}`)}}async doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];A!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const J=await Promise.all(F.map(async z=>{if(z.workspace){const K=await this.resolveOpenable({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(K))return K}else if(z.folderUri){const K=await this.resolveOpenable({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(Z(K))return K}else if(A!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,D.coalesce)(J)}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async resolveOpenable(A,F=Object.create(null)){const J=this.resourceFromOpenable(A);return J.scheme===w.Schemas.file?((0,_.isFileToOpen)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(J.fsPath,F)):this.doResolveRemoteOpenable(A,F)}doResolveRemoteOpenable(A,F){let J=this.resourceFromOpenable(A);const z=(0,E.getRemoteAuthority)(J)||F.remoteAuthority;if(J=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(J)),(0,_.isFileToOpen)(A)){if(F.gotoLineMode){const{path:K,line:N,column:$}=(0,u.parseLineAndColumnAware)(J.path);return{fileUri:J.with({path:K}),options:{selection:N?{startLineNumber:N,startColumn:$||1}:void 0},remoteAuthority:z}}return{fileUri:J,remoteAuthority:z}}else if((0,_.isWorkspaceToOpen)(A))return{workspace:(0,ce.getWorkspaceIdentifier)(J),remoteAuthority:z};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(J),remoteAuthority:z}}resourceFromOpenable(A){return(0,_.isWorkspaceToOpen)(A)?A.workspaceUri:(0,_.isFolderToOpen)(A)?A.folderUri:A.fileUri}async doResolveFilePath(A,F,J){let z,K;F.gotoLineMode&&({path:A,line:z,column:K}=(0,u.parseLineAndColumnAware)(A)),A=(0,u.sanitizeFilePath)((0,l.normalize)(A),(0,m.cwd)());try{const N=await L.Promises.stat(A);if(N.isFile()){if(!F.forceOpenWorkspaceAsFile){const $=await this.workspacesManagementMainService.resolveLocalWorkspace(a.URI.file(A));if($)return $.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:$.id,configPath:$.configPath},type:t.FileType.File,exists:!0,remoteAuthority:$.remoteAuthority,transient:$.transient}}return{fileUri:a.URI.file(A),type:t.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:K||1}:void 0}}}else{if(N.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(a.URI.file(A),N),type:t.FileType.Directory,exists:!0};if(!p.isWindows&&A==="/dev/null")return{fileUri:a.URI.file(A),type:t.FileType.File,exists:!0}}}catch(N){if(N.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!J)return this.onUNCHostNotAllowed(A,F);const $=a.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([$]),F.ignoreFileNotFound)return{fileUri:$,type:t.FileType.File,exists:!1}}}async onUNCHostNotAllowed(A,F){const J=a.URI.file(A),{response:z,checkboxChecked:K}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],message:(0,P.localize)(8,null,J.authority),detail:(0,P.localize)(9,null,(0,y.getPathLabel)(J,{os:p.OS,tildify:this.environmentMainService})),checkboxLabel:(0,P.localize)(10,null,J.authority),cancelId:1});if(z===0){if((0,r.addUNCHostToAllowlist)(J.authority),K){const N={channel:"vscode:configureAllowedUNCHost",args:J.authority};this.sendToFocused(N.channel,N.args),this.sendToOpeningWindow(N.channel,N.args)}return this.doResolveFilePath(A,F,!0)}if(z===2)return C.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(A,F)}doResolveRemotePath(A,F){const J=A.charCodeAt(0),z=F.remoteAuthority;let K,N;F.gotoLineMode&&({path:A,line:K,column:N}=(0,u.parseLineAndColumnAware)(A)),J!==47&&((0,u.isWindowsDriveLetter)(J)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,u.toSlashes)(A)),A=`/${A}`);const $=a.URI.from({scheme:w.Schemas.vscodeRemote,authority:z,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,le.hasWorkspaceFileExtension)(A))return F.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:K?{startLineNumber:K,startColumn:N||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)($),remoteAuthority:z};if(F.gotoLineMode||l.posix.basename(A).indexOf(".")!==-1)return{fileUri:$,options:{selection:K?{startLineNumber:K,startColumn:N||1}:void 0},remoteAuthority:z}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:z}}shouldOpenNewWindow(A){const F=this.configurationService.getValue("window"),J=F?.openFoldersInNewWindow||"default",z=F?.openFilesInNewWindow||"off";let K=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(J==="on"||J==="off")&&(K=J==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(p.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(N=z==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(A,F){const J=(0,X.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(J)return this.lifecycleMainService.reload(J,F.cli),J.focus(),[J];let z=F.cli["folder-uri"]||[],K=F.cli["file-uri"]||[],N=F.cli._;if(!N.length&&!z.length&&!K.length&&!F.cli.extensionTestsPath){const ae=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=ae?.workspace??ae?.folderUri;re&&(a.URI.isUri(re)?re.scheme===w.Schemas.file?N=[re.fsPath]:z=[re.toString()]:re.configPath.scheme===w.Schemas.file?N=[(0,g.originalFSPath)(re.configPath)]:K=[re.configPath.toString()])}let $=F.remoteAuthority;for(const ae of A)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=a.URI.parse(ae),me=(0,E.getRemoteAuthority)(re);me&&($?(0,g.isEqualAuthority)(me,$)||this.logService.error("more than one extension development path authority"):$=me)}N=N.filter(ae=>{const re=a.URI.file(ae);return(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,g.isEqualAuthority)((0,E.getRemoteAuthority)(re),$)}),z=z.filter(ae=>{const re=this.cliArgToUri(ae);return re&&(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,g.isEqualAuthority)((0,E.getRemoteAuthority)(re),$):!1}),K=K.filter(ae=>{const re=this.cliArgToUri(ae);return re&&(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,g.isEqualAuthority)((0,E.getRemoteAuthority)(re),$):!1}),F.cli._=N,F.cli["folder-uri"]=z,F.cli["file-uri"]=K;const ee={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!N.length&&!z.length&&!K.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:$,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(ee)}async openInBrowserWindow(A){const F=this.configurationService.getValue("window"),J=this.getLastActiveWindow(),z=J?.profile??this.userDataProfilesMainService.defaultProfile;let K;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(K=A.windowToUse||J,K&&K.focus());const N={...this.environmentMainService.args,...A.cli,machineId:this.machineId,sqmId:this.sqmId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,l.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:z},homeDir:this.environmentMainService.userHome.with({scheme:w.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:w.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:w.Schemas.file}).fsPath,product:R.default,isInitialStartup:A.initialStartup,perfMarks:(0,S.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:C.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(K){const $=K.config;!N.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(N.extensionDevelopmentPath=$.extensionDevelopmentPath,N.extensionDevelopmentKind=$.extensionDevelopmentKind,N["enable-proposed-api"]=$["enable-proposed-api"],N.verbose=$.verbose,N["inspect-extensions"]=$["inspect-extensions"],N["inspect-brk-extensions"]=$["inspect-brk-extensions"],N.debugId=$.debugId,N.extensionEnvironment=$.extensionEnvironment,N["extensions-dir"]=$["extensions-dir"],N["disable-extensions"]=$["disable-extensions"]),N.loggers={global:N.loggers.global,window:$?.loggers.window??N.loggers.window}}else{const $=this.windowsStateHandler.getNewWindowState(N);(0,S.mark)("code/willCreateCodeWindow");const ee=K=this.instantiationService.createInstance(T.CodeWindow,{state:$,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,S.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ee),this.windows.set(ee.id,ee),this._onDidOpenWindow.fire(ee),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ae=new b.DisposableStore;ae.add(ee.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire(ee))),ae.add(f.Event.once(ee.onDidClose)(()=>this.onWindowClosed(ee,ae))),ae.add(f.Event.once(ee.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ee))),ae.add(ee.onDidMaximize(()=>this._onDidMaximizeWindow.fire(ee))),ae.add(ee.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(ee))),ae.add(ee.onDidTriggerSystemContextMenu(({x:me,y:pe})=>this._onDidTriggerSystemContextMenu.fire({window:ee,x:me,y:pe})));const re=(0,d.assertIsDefined)(ee.win?.webContents);re.removeAllListeners("devtools-reload-page"),re.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ee)),this.lifecycleMainService.registerWindow(ee)}return N.windowId=K.id,K.isReady?this.lifecycleMainService.unload(K,4).then(async $=>{$||await this.doOpenInBrowserWindow(K,N,A,z)}):await this.doOpenInBrowserWindow(K,N,A,z),K}async doOpenInBrowserWindow(A,F,J,z){if(F.extensionDevelopmentPath||((0,le.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,le.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.backupMainService.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:J.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const K=F.workspace??(0,le.toWorkspaceIdentifier)(F.backupPath,!1),N=this.resolveProfileForBrowserWindow(J,K,z),$=N instanceof Promise?await N:N;F.profiles.profile=$,F.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(K,$)}A.load(F)}resolveProfileForBrowserWindow(A,F,J){return A.forceProfile?this.userDataProfilesMainService.profiles.find(z=>z.name===A.forceProfile)??this.userDataProfilesMainService.createNamedProfile(A.forceProfile):A.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(F)??J}onWindowClosed(A,F){this.windows.delete(A.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}getFocusedWindow(){const A=C.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(F=>(0,g.isEqualAuthority)(F.remoteAuthority,A)))}doGetLastActiveWindow(A){return(0,U.getLastFocused)(A)}sendToFocused(A,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,I.CancellationToken.None,...F)}sendToOpeningWindow(A,...F){this._register(f.Event.once(this.onDidSignalReadyWindow)(J=>{J.sendWhenReady(A,I.CancellationToken.None,...F)}))}sendToAll(A,F,J){for(const z of this.getWindows())J&&J.indexOf(z.id)>=0||z.sendWhenReady(A,I.CancellationToken.None,F)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(A){return this.windows.get(A)}getWindowByWebContents(A){const F=C.BrowserWindow.fromWebContents(A);if(F)return this.getWindowById(F.id)}};e.WindowsMainService=de,e.WindowsMainService=de=Ee([ne(3,v.ILogService),ne(4,B.ILoggerMainService),ne(5,M.IStateService),ne(6,x.IPolicyService),ne(7,s.IEnvironmentMainService),ne(8,W.IUserDataProfilesMainService),ne(9,c.ILifecycleMainService),ne(10,h.IBackupMainService),ne(11,i.IConfigurationService),ne(12,ue.IWorkspacesHistoryMainService),ne(13,Q.IWorkspacesManagementMainService),ne(14,n.IInstantiationService),ne(15,o.IDialogMainService),ne(16,t.IFileService),ne(17,k.IProtocolMainService),ne(18,G.IThemeMainService),ne(19,H.IAuxiliaryWindowsMainService)],de)}),define(se[307],oe([0,1,66,29,83,55]),function(V,e,C,L,r,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(f,u,y,b){this.workspacesManagementMainService=f,this.windowsMainService=u,this.workspacesHistoryMainService=y,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,u){const y=this.windowsMainService.getWindowById(f);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),u)}createUntitledWorkspace(f,u,y){return this.workspacesManagementMainService.createUntitledWorkspace(u,y)}deleteUntitledWorkspace(f,u){return this.workspacesManagementMainService.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(f,u){return this.workspacesManagementMainService.getWorkspaceIdentifier(u)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(f,u){return this.workspacesHistoryMainService.addRecentlyOpened(u)}removeRecentlyOpened(f,u){return this.workspacesHistoryMainService.removeRecentlyOpened(u)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=D,e.WorkspacesMainService=D=Ee([ne(0,O.IWorkspacesManagementMainService),ne(1,L.IWindowsMainService),ne(2,r.IWorkspacesHistoryMainService),ne(3,C.IBackupMainService)],D)}),define(se[308],oe([0,1,15,131,36,26,18,50,14,33,3,44,47,2,13,9,4,12,7,32,158,42,159,110,290,162,66,283,17,200,91,132,53,116,220,24,64,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,71,27,59,294,95,34,275,82,122,28,251,253,52,49,265,288,300,289,301,127,267,268,269,272,297,60,29,306,274,30,97,83,307,55,39,233,54,244,51,81,129,277,292,280,8,255,276,228,69,296,271,23,125,295,263,239,62,65,303]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o,s,t,n,c,v,R,k,E,M,_,T,U,X,Y,le,ce,ue,Q,G,x,W,B,H,q,Z,de,j,A,F,J,z,K,N,$,ee,ae,re,me,pe,ye,Ie,We,be,Se,te,he,ge,Me,Oe,Ne,_e,He,ze,Ve,ie,fe,ve,Pe,Re,De,Te,qe,xe,Ke,Ye,Xe,Je,st,nt,wt,St,yt,bt,Et,Pt,It,ot,ft,Ct,kt,Mt,at,Dt,gt,ct,Rt,Lt,lt,At,ut,Ot){"use strict";var dt;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ht=class extends l.Disposable{static{dt=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[S.Schemas.file]:"security.promptForLocalFileProtocolHandling",[S.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,ke,Ae,we,Le,Be,$e,Ge,Fe,Ue,je,Qe){super(),this.mainProcessNodeIpcServer=Ce,this.userEnv=ke,this.mainInstantiationService=Ae,this.logService=we,this.loggerService=Le,this.environmentMainService=Be,this.lifecycleMainService=$e,this.configurationService=Ge,this.stateService=Fe,this.fileService=Ue,this.productService=je,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const Ce=Fe=>Fe?.startsWith(`${S.Schemas.vscodeWebview}://`),ke=new Set(["clipboard-read","clipboard-sanitized-write"]);C.session.defaultSession.setPermissionRequestHandler((Fe,Ue,je,Qe)=>Ce(Qe.requestingUrl)?je(ke.has(Ue)):je(!1)),C.session.defaultSession.setPermissionCheckHandler((Fe,Ue,je,Qe)=>Ce(Qe.requestingUrl)?ke.has(Ue):!1);const Ae=new Set([S.Schemas.file,S.Schemas.vscodeFileResource,S.Schemas.vscodeRemoteResource,S.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Fe=>{for(let Ue=Fe;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${S.Schemas.vscodeWebview}://`))return!0;return!1},Le=Fe=>Fe.resourceType==="xhr"||we(Fe.frame),Be=Fe=>{const Ue=Fe.frame;if(!Ue||!this.windowsMainService)return!1;const je=C.BrowserWindow.getAllWindows();for(const Qe of je)if(Ue.processId===Qe.webContents.mainFrame.processId)return!0;return!1},$e=(Fe,Ue)=>{if(Fe.path!=="/index.html")return!0;const je=Ue.frame;if(!je||!this.windowsMainService)return!1;for(const Qe of this.windowsMainService.getWindows())if(Qe.win&&je.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};C.session.defaultSession.webRequest.onBeforeRequest((Fe,Ue)=>{const je=d.URI.parse(Fe.url);return je.scheme===S.Schemas.vscodeWebview&&!$e(je,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),Ue({cancel:!0})):je.scheme===S.Schemas.vscodeFileResource&&!Be(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),Ue({cancel:!0})):je.path.endsWith(".svg")&&!Ae.has(je.scheme)?Ue({cancel:!Le(Fe)}):Ue({cancel:!1})}),C.session.defaultSession.webRequest.onHeadersReceived((Fe,Ue)=>{const je=Fe.responseHeaders,Qe=je["content-type"]||je["Content-Type"];if(Qe&&Array.isArray(Qe)){const Ze=d.URI.parse(Fe.url);if(Ze.path.endsWith(".svg")&&Ae.has(Ze.scheme))return je["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:je});if(!Ze.path.endsWith(S.Schemas.vscodeRemoteResource)&&Qe.some(tt=>tt.toLowerCase().includes("image/svg")))return Ue({cancel:!Le(Fe)})}return Ue({cancel:!1})}),C.session.defaultSession.webRequest.onHeadersReceived((Fe,Ue)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const je=Fe.responseHeaders??Object.create(null);if(je["Access-Control-Allow-Origin"]===void 0)return je["Access-Control-Allow-Origin"]=["*"],Ue({cancel:!1,responseHeaders:je})}return Ue({cancel:!1})});const Ge=C.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ge.setCodeCachePath((0,p.join)(this.environmentMainService.codeCachePath,"chrome")),m.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,L.disableUNCAccessRestrictions)():(0,L.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,f.setUnexpectedErrorHandler)(Ae=>this.onUnexpectedError(Ae)),process.on("uncaughtException",Ae=>{(0,f.isSigPipeError)(Ae)||(0,f.onUnexpectedError)(Ae)}),process.on("unhandledRejection",Ae=>(0,f.onUnexpectedError)(Ae)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,P.registerContextMenuListener)(),C.app.on("accessibility-support-changed",(Ae,we)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",we)}),C.app.on("activate",async(Ae,we)=>{this.logService.trace("app#activate"),we||await this.windowsMainService?.openEmptyWindow({context:1})}),C.app.on("web-contents-created",(Ae,we)=>{(0,ut.isAuxiliaryWindow)(we)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(we)),we.on("will-navigate",Le=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Le.preventDefault()}),we.setWindowOpenHandler(Le=>Le.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow()}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Le.url}}`),this.nativeHostMainService?.openExternal(void 0,Le.url),{action:"deny"}))});let Ce=[],ke;C.app.on("open-file",(Ae,we)=>{this.logService.trace("app#open-file: ",we),Ae.preventDefault(),Ce.push((0,qe.hasWorkspaceFileExtension)(we)?{workspaceUri:d.URI.file(we)}:{fileUri:d.URI.file(we)}),ke!==void 0&&(clearTimeout(ke),ke=void 0),ke=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],ke=void 0},100)}),C.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),r.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const we=this.windowsMainService?.getWindowByWebContents(Ae.sender);let Le,Be;return we?.config?(Le=we.config,Be={...process.env,...we.config.userEnv}):(Le=this.environmentMainService.args,Be=process.env),this.resolveShellEnvironment(Le,Be,!1)}),r.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,we,Le)=>{const Be=this.validateNlsPath([we]);if(!Be||typeof Le!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Be,D.VSBuffer.fromString(Le))}),r.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...we)=>{const Le=this.validateNlsPath(we);if(!Le)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Le)).value.toString()}),r.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),r.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),r.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}validateNlsPath(Ce){let ke;for(const Ae of Ce)typeof Ae=="string"&&(typeof ke!="string"?ke=Ae:ke=(0,p.join)(ke,Ae));if(!(typeof ke!="string"||!(0,p.isAbsolute)(ke)||!(0,u.isEqualOrParent)(ke,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return d.URI.file(ke)}onUnexpectedError(Ce){if(Ce){const ke={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ke))}this.logService.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.logService.error(Ce.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ce=this.productService.win32AppUserModelId;m.isWindows&&Ce&&C.app.setAppUserModelId(Ce);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!C.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&C.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.logService.error(Ue)}const ke=new i.Server;this.lifecycleMainService.onWillShutdown(Ue=>{Ue.reason===2&&ke.dispose()}),this.logService.trace("Resolving machine identifier...");const[Ae,we]=await Promise.all([(0,ft.resolveMachineId)(this.stateService,this.logService),(0,ft.resolveSqmId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Le,sharedProcessClient:Be}=this.setupSharedProcess(Ae,we),$e=await this.initServices(Ae,we,Le);this._register($e.createInstance(s.ProxyAuthHandler)),this._register($e.createInstance(Pt.UserDataProfilesHandler)),$e.invokeFunction(Ue=>this.initChannels(Ue,ke,Be));const Ge=await $e.invokeFunction(Ue=>this.setupProtocolUrlHandlers(Ue,ke));this.setupManagedRemoteResourceUrlHandler(ke),this.lifecycleMainService.phase=2,await $e.invokeFunction(Ue=>this.openFirstWindow(Ue,Ge)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new ot.RunOnceScheduler(()=>{this._register((0,ot.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}async setupProtocolUrlHandlers(Ce,ke){const Ae=this.windowsMainService=Ce.get(Re.IWindowsMainService),we=Ce.get(He.IURLService),Le=this.nativeHostMainService=Ce.get(N.INativeHostMainService),Be=Ce.get(M.IDialogMainService),$e=this;we.registerHandler({async handleURL(Ze,tt){return $e.handleProtocolUrl(Ae,Be,we,Ze,tt)}});const Ge=this._register(new Te.ActiveWindowManager({onDidOpenMainWindow:Le.onDidOpenMainWindow,onDidFocusMainWindow:Le.onDidFocusMainWindow,getActiveWindowId:()=>Le.getActiveWindowId(-1)})),Fe=new h.StaticRouter(Ze=>Ge.getActiveClientId().then(tt=>Ze===tt)),Ue=new ze.URLHandlerRouter(Fe,this.logService),je=ke.getChannel("urlHandler",Ue);we.registerHandler(new ze.URLHandlerChannelClient(je));const Qe=await this.resolveInitialProtocolUrls(Ae,Be);return this._register(new ie.ElectronURLListener(Qe?.urls,we,Ae,this.environmentMainService,this.productService,this.logService)),Qe}setupManagedRemoteResourceUrlHandler(Ce){const ke=()=>({statusCode:404,data:"Not found"}),Ae=new At.Lazy(()=>Ce.getChannel(lt.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new lt.NodeRemoteResourceRouter));C.protocol.registerBufferProtocol(S.Schemas.vscodeManagedRemoteResource,(we,Le)=>{const Be=d.URI.parse(we.url);if(!Be.authority.startsWith("window:"))return Le(ke());Ae.value.call(lt.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Be]).then($e=>Le({...$e,data:Buffer.from($e.body,"base64")}),$e=>{this.logService.warn("error dispatching remote resource call",$e),Le({statusCode:500,data:String($e)})})})}async resolveInitialProtocolUrls(Ce,ke){const Ae=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Ae.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const we=global.getOpenUrls()||[];if(we.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Ae.length+we.length===0)return;const Le=[...Ae,...we].map(Ge=>{try{return{uri:d.URI.parse(Ge),originalUrl:Ge}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),Be=[],$e=[];for(const Ge of Le){if(!Ge)continue;const Fe=this.getWindowOpenableFromProtocolUrl(Ge.uri);if(Fe)if(await this.shouldBlockOpenable(Fe,Ce,ke)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Fe),Be.push(Fe);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),$e.push(Ge)}return{urls:$e,openables:Be}}async shouldBlockOpenable(Ce,ke,Ae){let we,Le;if((0,Pe.isWorkspaceToOpen)(Ce)?(we=Ce.workspaceUri,Le=(0,t.localize)(0,null,we.scheme===S.Schemas.file?(0,w.getPathLabel)(we,{os:m.OS,tildify:this.environmentMainService}):we.toString(!0),this.productService.nameShort)):(0,Pe.isFolderToOpen)(Ce)?(we=Ce.folderUri,Le=(0,t.localize)(1,null,we.scheme===S.Schemas.file?(0,w.getPathLabel)(we,{os:m.OS,tildify:this.environmentMainService}):we.toString(!0),this.productService.nameShort)):(we=Ce.fileUri,Le=(0,t.localize)(2,null,we.scheme===S.Schemas.file?(0,w.getPathLabel)(we,{os:m.OS,tildify:this.environmentMainService}):we.toString(!0),this.productService.nameShort)),we.scheme!==S.Schemas.file&&we.scheme!==S.Schemas.vscodeRemote||this.configurationService.getValue(dt.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[we.scheme])===!1)return!1;const{response:$e,checkboxChecked:Ge}=await Ae.showMessageBox({type:"warning",buttons:[(0,t.localize)(3,null),(0,t.localize)(4,null)],message:Le,detail:(0,t.localize)(5,null),checkboxLabel:we.scheme===S.Schemas.file?(0,t.localize)(6,null):(0,t.localize)(7,null),cancelId:1});if($e!==0)return!0;if(Ge){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===S.Schemas.file?"local":"remote"};ke.sendToFocused(Fe.channel,Fe.args),ke.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}getWindowOpenableFromProtocolUrl(Ce){if(Ce.path){if(Ce.authority===S.Schemas.file){const ke=d.URI.file(Ce.fsPath);return(0,qe.hasWorkspaceFileExtension)(ke)?{workspaceUri:ke}:{fileUri:ke}}else if(Ce.authority===S.Schemas.vscodeRemote){const ke=Ce.path.indexOf(p.posix.sep,1);if(ke!==-1){const Ae=Ce.path.substring(1,ke),we=Ce.path.substring(ke);let Le=Ce.query;const Be=new URLSearchParams(Ce.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Le=Be.toString());const $e=d.URI.from({scheme:S.Schemas.vscodeRemote,authority:Ae,path:we,query:Le,fragment:Ce.fragment});return(0,qe.hasWorkspaceFileExtension)(we)?{workspaceUri:$e}:/:[\d]+$/.test(we)?{fileUri:$e}:{folderUri:$e}}}}}async handleProtocolUrl(Ce,ke,Ae,we,Le){this.logService.trace("app#handleProtocolUrl():",we.toString(!0),Le),we.scheme===this.productService.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:d.URI.parse(we.query).path,query:""}));let Be=!1;const $e=new URLSearchParams(we.query);$e.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),$e.delete("windowId"),we=we.with({query:$e.toString()}),Be=!0):m.isMacintosh&&Ce.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Be=!0);const Ge=$e.get("continueOn");Ge!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),$e.delete("continueOn"),we=we.with({query:$e.toString()}),this.environmentMainService.continueOn=Ge??void 0);const Fe=this.getWindowOpenableFromProtocolUrl(we);return Fe?await this.shouldBlockOpenable(Fe,Ce,ke)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,we.toString(!0)),(0,gt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Fe],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,gt.firstOrDefault)(await Ce.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ee.getRemoteAuthority)(we)}))?.ready(),Ae.open(we,Le)):(this.logService.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Le),!1)}setupSharedProcess(Ce,ke){const Ae=this._register(this.mainInstantiationService.createInstance(ae.SharedProcess,Ce,ke)),we=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Be=await Ae.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Be,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),we))(),sharedProcessClient:we}}async initServices(Ce,ke,Ae){const we=new Z.ServiceCollection;switch(process.platform){case"win32":we.set(he.IUpdateService,new H.SyncDescriptor(_e.Win32UpdateService));break;case"linux":m.isLinuxSnap?we.set(he.IUpdateService,new H.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(he.IUpdateService,new H.SyncDescriptor(Oe.LinuxUpdateService));break;case"darwin":we.set(he.IUpdateService,new H.SyncDescriptor(Me.DarwinUpdateService));break}we.set(Re.IWindowsMainService,new H.SyncDescriptor(De.WindowsMainService,[Ce,ke,this.userEnv],!1)),we.set(ut.IAuxiliaryWindowsMainService,new H.SyncDescriptor(Ot.AuxiliaryWindowsMainService,void 0,!1));const Le=new M.DialogMainService(this.logService,this.productService);we.set(M.IDialogMainService,Le),we.set(F.ILaunchMainService,new H.SyncDescriptor(F.LaunchMainService,void 0,!1)),we.set(E.IDiagnosticsMainService,new H.SyncDescriptor(E.DiagnosticsMainService,void 0,!1)),we.set(k.IDiagnosticsService,h.ProxyChannel.toService((0,h.getDelayedChannel)(Ae.then(Ue=>Ue.getChannel("diagnostics"))))),we.set(de.IIssueMainService,new H.SyncDescriptor(j.IssueMainService,[this.userEnv])),we.set(_.IEncryptionMainService,new H.SyncDescriptor(T.EncryptionMainService)),we.set(A.IKeyboardLayoutMainService,new H.SyncDescriptor(A.KeyboardLayoutMainService)),we.set(N.INativeHostMainService,new H.SyncDescriptor(N.NativeHostMainService,void 0,!1)),we.set(fe.IWebviewManagerService,new H.SyncDescriptor(ve.WebviewMainService)),we.set(K.IMenubarMainService,new H.SyncDescriptor(K.MenubarMainService)),we.set(le.IExtensionHostStarter,new H.SyncDescriptor(ce.ExtensionHostStarter)),we.set(ye.IStorageMainService,new H.SyncDescriptor(ye.StorageMainService)),we.set(ye.IApplicationStorageMainService,new H.SyncDescriptor(ye.ApplicationStorageMainService));const Be=new Rt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),$e=new Lt.PtyHostService(Be,this.configurationService,this.logService,this.loggerService);we.set(ct.ILocalPtyService,$e),m.isWindows?we.set(ue.IExternalTerminalMainService,new H.SyncDescriptor(Q.WindowsExternalTerminalService)):m.isMacintosh?we.set(ue.IExternalTerminalMainService,new H.SyncDescriptor(Q.MacExternalTerminalService)):m.isLinux&&we.set(ue.IExternalTerminalMainService,new H.SyncDescriptor(Q.LinuxExternalTerminalService));const Ge=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);we.set(n.IBackupMainService,Ge);const Fe=new Xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ge,Le);if(we.set(Xe.IWorkspacesManagementMainService,Fe),we.set(xe.IWorkspacesService,new H.SyncDescriptor(Ye.WorkspacesMainService,void 0,!1)),we.set(Ke.IWorkspacesHistoryMainService,new H.SyncDescriptor(Ke.WorkspacesHistoryMainService,void 0,!1)),we.set(He.IURLService,new H.SyncDescriptor(Ve.NativeURLService,void 0,!1)),(0,te.supportsTelemetry)(this.productService,this.environmentMainService)){const Ue=(0,te.isInternalTelemetry)(this.productService,this.configurationService),je=(0,h.getDelayedChannel)(Ae.then(rt=>rt.getChannel("telemetryAppender"))),Qe=new be.TelemetryAppenderClient(je),Ze=(0,Ie.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,this.productService.commit,this.productService.version,Ce,ke,Ue),tt=(0,te.getPiiPathsFromEnvironment)(this.environmentMainService),it={appenders:[Qe],commonProperties:Ze,piiPaths:tt,sendErrorTelemetry:!0};we.set(We.ITelemetryService,new H.SyncDescriptor(Se.TelemetryService,[it],!1))}else we.set(We.ITelemetryService,te.NullTelemetryService);return we.set(yt.IExtensionsProfileScannerService,new H.SyncDescriptor(Ct.ExtensionsProfileScannerService,void 0,!0)),we.set(bt.IExtensionsScannerService,new H.SyncDescriptor(Et.ExtensionsScannerService,void 0,!0)),we.set(at.IUtilityProcessWorkerMainService,new H.SyncDescriptor(at.UtilityProcessWorkerMainService,void 0,!0)),await ot.Promises.settled([Ge.initialize(),Fe.initialize()]),this.mainInstantiationService.createChild(we)}initChannels(Ce,ke,Ae){const we=this._register(new l.DisposableStore),Le=h.ProxyChannel.fromService(Ce.get(F.ILaunchMainService),we,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Le);const Be=h.ProxyChannel.fromService(Ce.get(E.IDiagnosticsMainService),we,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Be);const $e=new st.PolicyChannel(Ce.get(Je.IPolicyService));ke.registerChannel("policy",$e),Ae.then(et=>et.registerChannel("policy",$e));const Ge=this.fileService.getProvider(S.Schemas.file);(0,g.assertType)(Ge instanceof B.DiskFileSystemProvider);const Fe=new W.DiskFileSystemProviderChannel(Ge,this.logService,this.environmentMainService);ke.registerChannel(G.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe),Ae.then(et=>et.registerChannel(G.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe));const Ue=h.ProxyChannel.fromService(Ce.get(nt.IUserDataProfilesMainService),we);ke.registerChannel("userDataProfiles",Ue),Ae.then(et=>et.registerChannel("userDataProfiles",Ue));const je=new wt.RequestChannel(Ce.get(St.IRequestService));Ae.then(et=>et.registerChannel("request",je));const Qe=new ge.UpdateChannel(Ce.get(he.IUpdateService));ke.registerChannel("update",Qe);const Ze=h.ProxyChannel.fromService(Ce.get(de.IIssueMainService),we);ke.registerChannel("issue",Ze);const tt=h.ProxyChannel.fromService(Ce.get(_.IEncryptionMainService),we);ke.registerChannel("encryption",tt);const it=h.ProxyChannel.fromService(Ce.get(re.ISignService),we);ke.registerChannel("sign",it);const rt=h.ProxyChannel.fromService(Ce.get(A.IKeyboardLayoutMainService),we);ke.registerChannel("keyboardLayout",rt),this.nativeHostMainService=Ce.get(N.INativeHostMainService);const mt=h.ProxyChannel.fromService(this.nativeHostMainService,we);ke.registerChannel("nativeHost",mt),Ae.then(et=>et.registerChannel("nativeHost",mt));const _t=h.ProxyChannel.fromService(Ce.get(xe.IWorkspacesService),we);ke.registerChannel("workspaces",_t);const Wt=h.ProxyChannel.fromService(Ce.get(K.IMenubarMainService),we);ke.registerChannel("menubar",Wt);const Tt=h.ProxyChannel.fromService(Ce.get(He.IURLService),we);ke.registerChannel("url",Tt);const Ft=h.ProxyChannel.fromService(Ce.get(fe.IWebviewManagerService),we);ke.registerChannel("webview",Ft);const pt=this._register(new pe.StorageDatabaseChannel(this.logService,Ce.get(ye.IStorageMainService)));ke.registerChannel("storage",pt),Ae.then(et=>et.registerChannel("storage",pt));const Ut=this._register(new It.ProfileStorageChangesListenerChannel(Ce.get(ye.IStorageMainService),Ce.get(nt.IUserDataProfilesMainService),this.logService));Ae.then(et=>et.registerChannel("profileStorageListener",Ut));const Nt=h.ProxyChannel.fromService(Ce.get(ct.ILocalPtyService),we);ke.registerChannel(ct.TerminalIpcChannels.LocalPty,Nt);const Bt=h.ProxyChannel.fromService(Ce.get(ue.IExternalTerminalMainService),we);ke.registerChannel("externalTerminal",Bt);const vt=new kt.LoggerChannel(Ce.get(Mt.ILoggerMainService));ke.registerChannel("logger",vt),Ae.then(et=>et.registerChannel("logger",vt));const zt=new R.ElectronExtensionHostDebugBroadcastChannel(Ce.get(Re.IWindowsMainService));ke.registerChannel("extensionhostdebugservice",zt);const $t=h.ProxyChannel.fromService(Ce.get(le.IExtensionHostStarter),we);ke.registerChannel(le.ipcExtensionHostStarterChannelName,$t);const qt=h.ProxyChannel.fromService(Ce.get(at.IUtilityProcessWorkerMainService),we);ke.registerChannel(Dt.ipcUtilityProcessWorkerChannelName,qt)}async openFirstWindow(Ce,ke){const Ae=this.windowsMainService=Ce.get(Re.IWindowsMainService);this.auxiliaryWindowsMainService=Ce.get(ut.IAuxiliaryWindowsMainService);const we=(0,X.isLaunchedFromCli)(process.env)?0:4,Le=this.environmentMainService.args;if(ke){if(ke.openables.length>0)return Ae.open({context:we,cli:Le,urisToOpen:ke.openables,gotoLineMode:!0,initialStartup:!0});if(ke.urls.length>0)for(const it of ke.urls){const rt=new URLSearchParams(it.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:rt.toString()}),Ae.open({context:we,cli:Le,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,$e=Le._.length,Ge=!!Le["folder-uri"],Fe=!!Le["file-uri"],Ue=Le["skip-add-to-recently-opened"]===!0,je=Le.wait&&Le.waitMarkerFilePath?d.URI.file(Le.waitMarkerFilePath):void 0,Qe=Le.remote||void 0,Ze=Le.profile,tt=Le["profile-temp"];if(!$e&&!Ge&&!Fe){if(Le["new-window"]||Ze||tt)return Ae.open({context:we,cli:Le,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ue,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:tt});if(Be.length)return Ae.open({context:1,cli:Le,urisToOpen:Be.map(it=>(0,qe.hasWorkspaceFileExtension)(it)?{workspaceUri:d.URI.file(it)}:{fileUri:d.URI.file(it)}),noRecentEntry:Ue,waitMarkerFileURI:je,initialStartup:!0})}return Ae.open({context:we,cli:Le,forceNewWindow:Le["new-window"]||!$e&&Le["unity-launch"],diffMode:Le.diff,mergeMode:Le.merge,noRecentEntry:Ue,waitMarkerFileURI:je,gotoLineMode:Le.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:tt})}afterWindowOpen(){this.installMutex(),C.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Ce,ke)=>{ke({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),m.isMacintosh&&C.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const Ce=this.productService.win32MutexName;if(m.isWindows&&Ce)try{const ke=await new Promise((we,Le)=>{V(["@vscode/windows-mutex"],we,Le)}),Ae=new ke.Mutex(Ce);y.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(ke){this.logService.error(ke)}}async resolveShellEnvironment(Ce,ke,Ae){try{return await(0,Y.getResolvedShellEnv)(this.configurationService,this.logService,Ce,ke)}catch(we){const Le=(0,I.toErrorMessage)(we);Ae?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Le):this.logService.error(Le)}return{}}async updateCrashReporterEnablement(){try{const ke=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Ae=JSON.parse((0,b.stripComments)(ke)),Le=(0,te.getTelemetryLevel)(this.configurationService)>=1;if(Ae["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Le},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,a.generateUuid)()}"`,"}"],$e=ke.substring(0,ke.length-2).concat(`,
`,Be.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString($e))}else{const Be=ke.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Le},`);Be!==ke&&await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(Be))}}catch(Ce){this.logService.error(Ce)}}};e.CodeApplication=ht,e.CodeApplication=ht=dt=Ee([ne(2,q.IInstantiationService),ne(3,z.ILogService),ne(4,z.ILoggerService),ne(5,U.IEnvironmentMainService),ne(6,J.ILifecycleMainService),ne(7,v.IConfigurationService),ne(8,me.IStateService),ne(9,x.IFileService),ne(10,$.IProductService),ne(11,nt.IUserDataProfilesMainService)],ht)}),define(se[313],oe([0,1,15,46,7,23,8,50,14,33,3,47,13,9,68,4,35,25,21,42,99,308,10,17,238,250,24,64,202,16,222,93,78,218,92,20,225,5,79,27,80,278,126,287,51,286,95,249,34,52,70,54,39,234,232,2,40,266,69,227,115,121,270,264]),function(V,e,C,L,r,O,D,I,f,u,y,b,w,l,S,p,m,g,d,a,P,h,i,o,s,t,n,c,v,R,k,E,M,_,T,U,X,Y,le,ce,ue,Q,G,x,W,B,H,q,Z,de,j,A,F,J,z,K,N,$,ee,ae,re,me,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.startup()}catch(be){console.error(be.message),C.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(_e=>console.error(_e));const[be,Se,te,he,ge,Me,Oe,Ne]=this.createServices();try{try{await this.initServices(te,Ne,he,ge,Oe)}catch(_e){throw this.handleStartupDataDirError(te,Oe,_e),_e}await be.invokeFunction(async _e=>{const He=_e.get(Y.ILogService),ze=_e.get(U.ILifecycleMainService),Ve=_e.get(R.IFileService),ie=_e.get(Y.ILoggerService),fe=await this.claimInstance(He,te,ze,be,Oe,!0);return d.Promises.writeFile(te.mainLockfile,String(process.pid)).catch(ve=>{He.warn(`app#startup(): Error writing main lockfile: ${ve.stack}`)}),Me.logger=ie.createLogger("main",{name:(0,i.localize)(0,null)}),y.Event.once(ze.onWillShutdown)(ve=>{Ve.dispose(),he.dispose(),ve.join("instanceLockfile",d.Promises.unlink(te.mainLockfile).catch(()=>{}))}),be.createInstance(h.CodeApplication,fe,Se).startup()})}catch(_e){be.invokeFunction(this.quit,_e)}}createServices(){const be=new T.ServiceCollection,Se=new K.DisposableStore;process.once("exit",()=>Se.dispose());const te={_serviceBrand:void 0,...le.default};be.set(ce.IProductService,te);const he=new n.EnvironmentMainService(this.resolveArgs(),te),ge=this.patchEnvironment(he);be.set(n.IEnvironmentMainService,he);const Me=new ee.LoggerMainService((0,Y.getLogLevel)(he),he.logsHome);be.set(ee.ILoggerMainService,Me);const Oe=new X.BufferLogger(Me.getLogLevel()),Ne=Se.add(new ae.LogService(Oe,[new Y.ConsoleMainLogger(Me.getLogLevel())]));be.set(Y.ILogService,Ne);const _e=new k.FileService(Ne);be.set(R.IFileService,_e);const He=new E.DiskFileSystemProvider(Ne);_e.registerProvider(w.Schemas.file,He);const ze=new $.UriIdentityService(_e);be.set(N.IUriIdentityService,ze);const Ve=new me.StateService(1,he,Ne,_e);be.set(Z.IStateReadService,Ve),be.set(Z.IStateService,Ve);const ie=new A.UserDataProfilesMainService(Ve,ze,he,_e,Ne);be.set(A.IUserDataProfilesMainService,ie),_e.registerProvider(w.Schemas.vscodeUserData,new pe.FileUserDataProvider(w.Schemas.file,He,w.Schemas.vscodeUserData,ie,ze,Ne));const fe=p.isWindows&&te.win32RegValueName?Se.add(new J.NativePolicyService(Ne,te.win32RegValueName)):he.policyFile?Se.add(new z.FilePolicyService(he.policyFile,_e,Ne)):new F.NullPolicyService;be.set(F.IPolicyService,fe);const ve=new s.ConfigurationService(ie.defaultProfile.settingsResource,_e,fe,Ne);return be.set(o.IConfigurationService,ve),be.set(U.ILifecycleMainService,new M.SyncDescriptor(U.LifecycleMainService,void 0,!1)),be.set(W.IRequestService,new M.SyncDescriptor(B.RequestMainService,void 0,!0)),be.set(j.IThemeMainService,new M.SyncDescriptor(j.ThemeMainService)),be.set(H.ISignService,new M.SyncDescriptor(q.SignService,void 0,!1)),be.set(G.ITunnelService,new M.SyncDescriptor(x.TunnelService)),be.set(ue.IProtocolMainService,new Q.ProtocolMainService(he,ie,Ne)),[new _.InstantiationService(be,!0),ge,he,ve,Ve,Oe,te,ie]}patchEnvironment(be){const Se={VSCODE_IPC_HOOK:be.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const he=process.env[te];typeof he=="string"&&(Se[te]=he)}),Object.assign(process.env,Se),Se}async initServices(be,Se,te,he,ge){await D.Promises.settled([Promise.all([be.extensionsPath,be.codeCachePath,be.logsHome.with({scheme:w.Schemas.file}).fsPath,Se.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,be.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,be.localHistoryHome.with({scheme:w.Schemas.file}).fsPath,be.backupHome].map(Me=>Me?d.Promises.mkdir(Me,{recursive:!0}):void 0)),he.init(),te.initialize()]),Se.init()}async claimInstance(be,Se,te,he,ge,Me){let Oe;try{(0,S.mark)("code/willStartMainServer"),Oe=await(0,P.serve)(Se.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),y.Event.once(te.onWillShutdown)(()=>Oe.dispose())}catch(Ne){if(Ne.code!=="EADDRINUSE")throw this.handleStartupDataDirError(Se,ge,Ne),Ne;let _e;try{_e=await(0,P.connect)(Se.mainIPCHandle,"main")}catch(ie){if(!Me||p.isWindows||ie.code!=="ECONNREFUSED")throw ie.code==="EPERM"&&this.showStartupWarningDialog((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),ie;try{(0,L.unlinkSync)(Se.mainIPCHandle)}catch(fe){throw be.warn("Could not delete obsolete instance handle",fe),fe}return this.claimInstance(be,Se,te,he,ge,!1)}if(Se.extensionTestsLocationURI&&!Se.debugExtensionHost.break){const ie=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw be.error(ie),_e.dispose(),new Error(ie)}let He;!Se.args.wait&&!Se.args.status&&(He=setTimeout(()=>{this.showStartupWarningDialog((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=a.ProxyChannel.toService(_e.getChannel("launch"),{disableMarshalling:!0}),Ve=a.ProxyChannel.toService(_e.getChannel("diagnostics"),{disableMarshalling:!0});if(Se.args.status)return he.invokeFunction(async()=>{const ie=new t.DiagnosticsService(de.NullTelemetryService,ge),fe=await Ve.getMainDiagnostics(),ve=await Ve.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Pe=await ie.getDiagnostics(fe,ve);throw console.log(Pe),new f.ExpectedError});throw p.isWindows&&await this.windowsAllowSetForegroundWindow(ze,be),be.trace("Sending env to running instance..."),await ze.start(Se.args,process.env),_e.dispose(),He&&clearTimeout(He),new f.ExpectedError("Sent env to running instance. Terminating...")}if(Se.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Oe}handleStartupDataDirError(be,Se,te){if(te.code==="EACCES"||te.code==="EPERM"){const he=(0,O.coalesce)([be.userDataPath,be.extensionsPath,P.XDG_RUNTIME_DIR]).map(ge=>(0,b.getPathLabel)(r.URI.file(ge),{os:p.OS,tildify:be}));this.showStartupWarningDialog((0,i.localize)(6,null),(0,i.localize)(7,null,(0,I.toErrorMessage)(te),he.join(`
`)),Se)}}showStartupWarningDialog(be,Se,te){C.dialog.showMessageBoxSync((0,re.massageMessageBoxOptions)({type:"warning",buttons:[(0,i.localize)(8,null)],message:be,detail:Se},te).options)}async windowsAllowSetForegroundWindow(be,Se){if(p.isWindows){const te=await be.getMainProcessId();Se.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((he,ge)=>{V(["windows-foreground-love"],he,ge)})).allowSetForegroundWindow(te)}catch(he){Se.error(he)}}}quit(be,Se){const te=be.get(Y.ILogService),he=be.get(U.ILifecycleMainService);let ge=0;Se&&(Se.isExpected?Se.message&&te.trace(Se.message):(ge=1,Se.stack?te.error(Se.stack):te.error(`Startup error: ${Se.toString()}`))),he.kill(ge)}resolveArgs(){const be=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(be.wait&&!be.waitMarkerFilePath){const Se=(0,v.createWaitMarkerFileSync)(be.verbose);Se&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",Se),be.waitMarkerFilePath=Se)}return be}validatePaths(be){if(be["open-url"]&&(be._urls=be._,be._=[]),!be.remote){const Se=this.doValidatePaths(be._,be.goto);be._=Se}return be}doValidatePaths(be,Se){const te=(0,m.cwd)(),he=be.map(Oe=>{let Ne=String(Oe),_e;Se&&(_e=(0,u.parseLineAndColumnAware)(Ne),Ne=_e.path),Ne&&(Ne=this.preparePath(te,Ne));const He=(0,u.sanitizeFilePath)(Ne,te),ze=(0,l.basename)(He);return ze&&!(0,u.isValidBasename)(ze)?null:Se&&_e?(_e.path=He,this.toPath(_e)):He}),ge=p.isWindows||p.isMacintosh,Me=(0,O.distinct)(he,Oe=>Oe&&ge?Oe.toLowerCase():Oe||"");return(0,O.coalesce)(Me)}preparePath(be,Se){return p.isWindows&&(Se=(0,g.rtrim)(Se,'"')),Se=(0,g.trim)((0,g.trim)(Se," "),"	"),p.isWindows&&(Se=(0,l.resolve)(be,Se),Se=(0,g.rtrim)(Se,".")),Se}toPath(be){const Se=[be.path];return typeof be.line=="number"&&Se.push(String(be.line)),typeof be.column=="number"&&Se.push(String(be.column)),Se.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c8a36a69377856369f139f39ee56dd3838130fbf/core/vs/code/electron-main/main.js.map
