/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(B){for(var e=[],N=0,O=B.length;N<O;N++)e[N]=te[B[N]];return e};define(te[70],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class N{static get(){const L=new Map,A=new Map,T=new Map,P=new Map;function f(h,I){h.has(I.detail)||h.set(I.detail,-I.timestamp)}function l(h,I){const E=h.get(I.detail);E&&(E>=0||h.set(I.detail,E+I.timestamp))}let D=[];typeof B=="function"&&typeof B.getStats=="function"&&(D=B.getStats().slice(0).sort((h,I)=>h.timestamp-I.timestamp));for(const h of D)switch(h.type){case 10:f(L,h);break;case 11:case 12:l(L,h);break;case 21:f(A,h);break;case 22:l(A,h);break;case 33:f(T,h);break;case 34:l(T,h);break;case 31:f(P,h);break;case 32:l(P,h);break}let C=0;T.forEach(h=>C+=h);function d(h){const I=[];return h.forEach((E,v)=>I.push([v,E])),I}return{amdLoad:d(L),amdInvoke:d(A),nodeRequire:d(T),nodeEval:d(P),nodeRequireTotal:C}}static toMarkdownTable(L,A){let T="";const P=[];return L.forEach((f,l)=>{P[l]=f.length}),A.forEach(f=>{f.forEach((l,D)=>{typeof l>"u"&&(l=f[D]="-");const C=l.toString().length;P[D]=Math.max(C,P[D])})}),L.forEach((f,l)=>{T+=`| ${f+" ".repeat(P[l]-f.toString().length)} `}),T+=`|
`,L.forEach((f,l)=>{T+=`| ${"-".repeat(P[l])} `}),T+=`|
`,A.forEach(f=>{f.forEach((l,D)=>{typeof l<"u"&&(T+=`| ${l+" ".repeat(P[D]-l.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=N}),define(te[52],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function N(T){return(P,f,l)=>{let D=null,C=null;if(typeof l.value=="function"?(D="value",C=l.value):typeof l.get=="function"&&(D="get",C=l.get),!C)throw new Error("not supported");l[D]=T(C,f)}}function O(T,P,f){let l=null,D=null;if(typeof f.value=="function"?(l="value",D=f.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",D=f.get),!D)throw new Error("not supported");const C=`$memoize$${P}`;f[l]=function(...d){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,d)}),this[C]}}e.memoize=O;function L(T,P,f){return N((l,D)=>{const C=`$debounce$${D}`,d=`$debounce$result$${D}`;return function(...h){this[d]||(this[d]=f?f():void 0),clearTimeout(this[C]),P&&(this[d]=P(this[d],...h),h=[this[d]]),this[C]=setTimeout(()=>{l.apply(this,h),this[d]=f?f():void 0},T)}})}e.debounce=L;function A(T,P,f){return N((l,D)=>{const C=`$throttle$timer$${D}`,d=`$throttle$result$${D}`,h=`$throttle$lastRun$${D}`,I=`$throttle$pending$${D}`;return function(...E){if(this[d]||(this[d]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...E)),this[I])return;const v=this[h]+T;v<=Date.now()?(this[h]=Date.now(),l.apply(this,[this[d]]),this[d]=f?f():void 0):(this[I]=!0,this[C]=setTimeout(()=>{this[I]=!1,this[h]=Date.now(),l.apply(this,[this[d]]),this[d]=f?f():void 0},v-Date.now()))}})}e.throttle=A}),define(te[71],ne([0,1,9]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function L(f,l="Unreachable"){throw new Error(l)}e.assertNever=L;function A(f){if(!f)throw new N.BugIndicatingError("Assertion Failed")}e.assert=A;function T(f){if(!f()){debugger;f(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(f,l){let D=0;for(;D<f.length-1;){const C=f[D],d=f[D+1];if(!l(C,d))return!1;D++}return!0}e.checkAdjacentItems=P}),define(te[53],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var O;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(r){r.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function T(r,o=!1){let t=0;const i=r.length;let n="",s=0,u=16,b=0;function w(re){let ue=0,le=0;for(;ue<re;){const oe=r.charCodeAt(t);if(oe>=48&&oe<=57)le=le*16+oe-48;else if(oe>=65&&oe<=70)le=le*16+oe-65+10;else if(oe>=97&&oe<=102)le=le*16+oe-97+10;else break;t++,ue++}return ue<re&&(le=-1),le}function S(re){t=re,n="",s=0,u=16,b=0}function k(){const re=t;if(r.charCodeAt(t)===48)t++;else for(t++;t<r.length&&l(r.charCodeAt(t));)t++;if(t<r.length&&r.charCodeAt(t)===46)if(t++,t<r.length&&l(r.charCodeAt(t)))for(t++;t<r.length&&l(r.charCodeAt(t));)t++;else return b=3,r.substring(re,t);let ue=t;if(t<r.length&&(r.charCodeAt(t)===69||r.charCodeAt(t)===101))if(t++,(t<r.length&&r.charCodeAt(t)===43||r.charCodeAt(t)===45)&&t++,t<r.length&&l(r.charCodeAt(t))){for(t++;t<r.length&&l(r.charCodeAt(t));)t++;ue=t}else b=3;return r.substring(re,ue)}function $(){let re="",ue=t;for(;;){if(t>=i){re+=r.substring(ue,t),b=2;break}const le=r.charCodeAt(t);if(le===34){re+=r.substring(ue,t),t++;break}if(le===92){if(re+=r.substring(ue,t),t++,t>=i){b=2;break}switch(r.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const W=w(4);W>=0?re+=String.fromCharCode(W):b=4;break}default:b=5}ue=t;continue}if(le>=0&&le<=31)if(f(le)){re+=r.substring(ue,t),b=2;break}else b=6;t++}return re}function ee(){if(n="",b=0,s=t,t>=i)return s=i,u=17;let re=r.charCodeAt(t);if(P(re)){do t++,n+=String.fromCharCode(re),re=r.charCodeAt(t);while(P(re));return u=15}if(f(re))return t++,n+=String.fromCharCode(re),re===13&&r.charCodeAt(t)===10&&(t++,n+=`
`),u=14;switch(re){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,n=$(),u=10;case 47:{const ue=t-1;if(r.charCodeAt(t+1)===47){for(t+=2;t<i&&!f(r.charCodeAt(t));)t++;return n=r.substring(ue,t),u=12}if(r.charCodeAt(t+1)===42){t+=2;const le=i-1;let oe=!1;for(;t<le;){if(r.charCodeAt(t)===42&&r.charCodeAt(t+1)===47){t+=2,oe=!0;break}t++}return oe||(t++,b=1),n=r.substring(ue,t),u=13}return n+=String.fromCharCode(re),t++,u=16}case 45:if(n+=String.fromCharCode(re),t++,t===i||!l(r.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=k(),u=11;default:for(;t<i&&Z(re);)t++,re=r.charCodeAt(t);if(s!==t){switch(n=r.substring(s,t),n){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return n+=String.fromCharCode(re),t++,u=16}}function Z(re){if(P(re)||f(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let re;do re=ee();while(re>=12&&re<=15);return re}return{setPosition:S,getPosition:()=>t,scan:o?se:ee,getToken:()=>u,getTokenValue:()=>n,getTokenOffset:()=>s,getTokenLength:()=>t-s,getTokenError:()=>b}}e.createScanner=T;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function f(r){return r===10||r===13||r===8232||r===8233}function l(r){return r>=48&&r<=57}var D;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(D||(D={}));function C(r,o){const t=[],i=new Object;let n;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function b(w,S,k,$){s.value=w,s.offset=S,s.length=k,s.type=$,s.colonOffset=void 0,n=s}try{R(r,{onObjectBegin:(w,S)=>{if(o<=w)throw i;n=void 0,u=o>w,t.push("")},onObjectProperty:(w,S,k)=>{if(o<S||(b(w,S,k,"property"),t[t.length-1]=w,o<=S+k))throw i},onObjectEnd:(w,S)=>{if(o<=w)throw i;n=void 0,t.pop()},onArrayBegin:(w,S)=>{if(o<=w)throw i;n=void 0,t.push(0)},onArrayEnd:(w,S)=>{if(o<=w)throw i;n=void 0,t.pop()},onLiteralValue:(w,S,k)=>{if(o<S||(b(w,S,k,y(w)),o<=S+k))throw i},onSeparator:(w,S,k)=>{if(o<=S)throw i;if(w===":"&&n&&n.type==="property")n.colonOffset=S,u=!1,n=void 0;else if(w===","){const $=t[t.length-1];typeof $=="number"?t[t.length-1]=$+1:(u=!0,t[t.length-1]=""),n=void 0}}})}catch(w){if(w!==i)throw w}return{path:t,previousNode:n,isAtPropertyKey:u,matches:w=>{let S=0;for(let k=0;S<w.length&&k<t.length;k++)if(w[S]===t[k]||w[S]==="*")S++;else if(w[S]!=="**")return!1;return S===w.length}}}e.getLocation=C;function d(r,o=[],t=A.DEFAULT){let i=null,n=[];const s=[];function u(w){Array.isArray(n)?n.push(w):i!==null&&(n[i]=w)}return R(r,{onObjectBegin:()=>{const w={};u(w),s.push(n),n=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const w=[];u(w),s.push(n),n=w,i=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:u,onError:(w,S,k)=>{o.push({error:w,offset:S,length:k})}},t),n[0]}e.parse=d;function h(r,o=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function s(w){return i.children.push(w),w}R(r,{onObjectBegin:w=>{i=s({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,S,k)=>{i=s({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:S,length:k,parent:i})},onObjectEnd:(w,S)=>{i.length=w+S-i.offset,i=i.parent,n(w+S)},onArrayBegin:(w,S)=>{i=s({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,S)=>{i.length=w+S-i.offset,i=i.parent,n(w+S)},onLiteralValue:(w,S,k)=>{s({type:y(w),offset:S,length:k,parent:i,value:w}),n(S+k)},onSeparator:(w,S,k)=>{i.type==="property"&&(w===":"?i.colonOffset=S:w===","&&n(S))},onError:(w,S,k)=>{o.push({error:w,offset:S,length:k})}},t);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=h;function I(r,o){if(!r)return;let t=r;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const s of t.children)if(Array.isArray(s.children)&&s.children[0].value===i){t=s.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.findNodeAtLocation=I;function E(r){if(!r.parent||!r.parent.children)return[];const o=E(r.parent);if(r.parent.type==="property"){const t=r.parent.children[0].value;o.push(t)}else if(r.parent.type==="array"){const t=r.parent.children.indexOf(r);t!==-1&&o.push(t)}return o}e.getNodePath=E;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":{const o=Object.create(null);for(const t of r.children){const i=t.children[1];i&&(o[t.children[0].value]=v(i))}return o}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function c(r,o,t=!1){return o>=r.offset&&o<r.offset+r.length||t&&o===r.offset+r.length}e.contains=c;function p(r,o,t=!1){if(c(r,o,t)){const i=r.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const s=p(i[n],o,t);if(s)return s}return r}}e.findNodeAtOffset=p;function R(r,o,t=A.DEFAULT){const i=T(r,!1);function n(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function s(X){return X?J=>X(J,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=n(o.onObjectBegin),b=s(o.onObjectProperty),w=n(o.onObjectEnd),S=n(o.onArrayBegin),k=n(o.onArrayEnd),$=s(o.onLiteralValue),ee=s(o.onSeparator),Z=n(o.onComment),se=s(o.onError),re=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function le(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:re||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(X){case 12:case 13:re?oe(10):Z();break;case 16:oe(1);break;case 15:case 14:break;default:return X}}}function oe(X,J=[],M=[]){if(se(X),J.length+M.length>0){let F=i.getToken();for(;F!==17;){if(J.indexOf(F)!==-1){le();break}else if(M.indexOf(F)!==-1)break;F=le()}}}function W(X){const J=i.getTokenValue();return X?$(J):b(J),le(),!0}function K(){switch(i.getToken()){case 11:{let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(oe(2),X=0)}catch{oe(2)}$(X);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return le(),!0}function V(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(W(!1),i.getToken()===6?(ee(":"),le(),G()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function _(){u(),le();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||oe(4,[],[]),ee(","),le(),i.getToken()===2&&ue)break}else X&&oe(6,[],[]);V()||oe(4,[],[2,5]),X=!0}return w(),i.getToken()!==2?oe(7,[2],[]):le(),!0}function j(){S(),le();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||oe(4,[],[]),ee(","),le(),i.getToken()===4&&ue)break}else X&&oe(6,[],[]);G()||oe(4,[],[4,5]),X=!0}return k(),i.getToken()!==4?oe(8,[4],[]):le(),!0}function G(){switch(i.getToken()){case 3:return j();case 1:return _();case 10:return W(!0);default:return K()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(oe(4,[],[]),!1):G()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.visit=R;function g(r,o){const t=T(r),i=[];let n,s=0,u;do switch(u=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:s!==u&&i.push(r.substring(s,u)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),s=t.getPosition();break}while(n!==17);return i.join("")}e.stripComments=g;function y(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(te[72],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function N(P,f,l){return Math.min(Math.max(P,f),l)}e.clamp=N;function O(P,f){return(f+P%f)%f}e.rot=O;class L{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=L;class A{constructor(){this._n=1,this._val=0}update(f){return this._val=this._val+(f-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class T{constructor(f){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(f),this._values.fill(0,0,f)}update(f){const l=this._values[this._index];return this._values[this._index]=f,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=f,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function B(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function T(f){A.push(f,Date.now())}function P(){const f=[];for(let l=0;l<A.length;l+=2)f.push({name:A[l],startTime:A[l+1]});return f}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(L+T.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function N(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=N(O))}(),function(B,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var O in N)(typeof exports=="object"?exports:B)[O]=N[O]}}(typeof self<"u"?self:this,function(){return function(B){var e={};function N(O){if(e[O])return e[O].exports;var L=e[O]={i:O,l:!1,exports:{}};return B[O].call(L.exports,L,L.exports,N),L.l=!0,L.exports}return N.m=B,N.c=e,N.d=function(O,L,A){N.o(O,L)||Object.defineProperty(O,L,{enumerable:!0,get:A})},N.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},N.t=function(O,L){if(1&L&&(O=N(O)),8&L||4&L&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(N.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&L&&typeof O!="string")for(var T in O)N.d(A,T,function(P){return O[P]}.bind(null,T));return A},N.n=function(O){var L=O&&O.__esModule?function(){return O.default}:function(){return O};return N.d(L,"a",L),L},N.o=function(O,L){return Object.prototype.hasOwnProperty.call(O,L)},N.p="",N(N.s=0)}([function(B,e,N){(function(O){var L;e=B.exports=M,L=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],l=0,D=l++;f[D]="0|[1-9]\\d*";var C=l++;f[C]="[0-9]+";var d=l++;f[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=l++;f[h]="("+f[D]+")\\.("+f[D]+")\\.("+f[D]+")";var I=l++;f[I]="("+f[C]+")\\.("+f[C]+")\\.("+f[C]+")";var E=l++;f[E]="(?:"+f[D]+"|"+f[d]+")";var v=l++;f[v]="(?:"+f[C]+"|"+f[d]+")";var c=l++;f[c]="(?:-("+f[E]+"(?:\\."+f[E]+")*))";var p=l++;f[p]="(?:-?("+f[v]+"(?:\\."+f[v]+")*))";var R=l++;f[R]="[0-9A-Za-z-]+";var g=l++;f[g]="(?:\\+("+f[R]+"(?:\\."+f[R]+")*))";var y=l++,r="v?"+f[h]+f[c]+"?"+f[g]+"?";f[y]="^"+r+"$";var o="[v=\\s]*"+f[I]+f[p]+"?"+f[g]+"?",t=l++;f[t]="^"+o+"$";var i=l++;f[i]="((?:<|>)?=?)";var n=l++;f[n]=f[C]+"|x|X|\\*";var s=l++;f[s]=f[D]+"|x|X|\\*";var u=l++;f[u]="[v=\\s]*("+f[s]+")(?:\\.("+f[s]+")(?:\\.("+f[s]+")(?:"+f[c]+")?"+f[g]+"?)?)?";var b=l++;f[b]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[p]+")?"+f[g]+"?)?)?";var w=l++;f[w]="^"+f[i]+"\\s*"+f[u]+"$";var S=l++;f[S]="^"+f[i]+"\\s*"+f[b]+"$";var k=l++;f[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=l++;f[$]="(?:~>?)";var ee=l++;f[ee]="(\\s*)"+f[$]+"\\s+",P[ee]=new RegExp(f[ee],"g");var Z=l++;f[Z]="^"+f[$]+f[u]+"$";var se=l++;f[se]="^"+f[$]+f[b]+"$";var re=l++;f[re]="(?:\\^)";var ue=l++;f[ue]="(\\s*)"+f[re]+"\\s+",P[ue]=new RegExp(f[ue],"g");var le=l++;f[le]="^"+f[re]+f[u]+"$";var oe=l++;f[oe]="^"+f[re]+f[b]+"$";var W=l++;f[W]="^"+f[i]+"\\s*("+o+")$|^$";var K=l++;f[K]="^"+f[i]+"\\s*("+r+")$|^$";var V=l++;f[V]="(\\s*)"+f[i]+"\\s*("+o+"|"+f[u]+")",P[V]=new RegExp(f[V],"g");var _=l++;f[_]="^\\s*("+f[u]+")\\s+-\\s+("+f[u]+")\\s*$";var j=l++;f[j]="^\\s*("+f[b]+")\\s+-\\s+("+f[b]+")\\s*$";var G=l++;f[G]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)L(X,f[X]),P[X]||(P[X]=new RegExp(f[X]));function J(z,Y){if(z instanceof M)return z;if(typeof z!="string"||z.length>A||!(Y?P[t]:P[y]).test(z))return null;try{return new M(z,Y)}catch{return null}}function M(z,Y){if(z instanceof M){if(z.loose===Y)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof M))return new M(z,Y);L("SemVer",z,Y),this.loose=Y;var Q=z.trim().match(Y?P[t]:P[y]);if(!Q)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ye=+pe;if(ye>=0&&ye<T)return ye}return pe}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=J,e.valid=function(z,Y){var Q=J(z,Y);return Q?Q.version:null},e.clean=function(z,Y){var Q=J(z.trim().replace(/^[=v]+/,""),Y);return Q?Q.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(z){return L("SemVer.compare",this.version,this.loose,z),z instanceof M||(z=new M(z,this.loose)),this.compareMain(z)||this.comparePre(z)},M.prototype.compareMain=function(z){return z instanceof M||(z=new M(z,this.loose)),a(this.major,z.major)||a(this.minor,z.minor)||a(this.patch,z.patch)},M.prototype.comparePre=function(z){if(z instanceof M||(z=new M(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var Y=0;do{var Q=this.prerelease[Y],pe=z.prerelease[Y];if(L("prerelease compare",Y,Q,pe),Q===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(Q===void 0)return-1;if(Q!==pe)return a(Q,pe)}while(++Y)},M.prototype.inc=function(z,Y){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,Y,Q,pe){typeof Q=="string"&&(pe=Q,Q=void 0);try{return new M(z,Q).inc(Y,pe).version}catch{return null}},e.diff=function(z,Y){if(H(z,Y))return null;var Q=J(z),pe=J(Y);if(Q.prerelease.length||pe.prerelease.length){for(var ye in Q)if((ye==="major"||ye==="minor"||ye==="patch")&&Q[ye]!==pe[ye])return"pre"+ye;return"prerelease"}for(var ye in Q)if((ye==="major"||ye==="minor"||ye==="patch")&&Q[ye]!==pe[ye])return ye},e.compareIdentifiers=a;var F=/^[0-9]+$/;function a(z,Y){var Q=F.test(z),pe=F.test(Y);return Q&&pe&&(z=+z,Y=+Y),Q&&!pe?-1:pe&&!Q?1:z<Y?-1:z>Y?1:0}function m(z,Y,Q){return new M(z,Q).compare(new M(Y,Q))}function x(z,Y,Q){return m(z,Y,Q)>0}function U(z,Y,Q){return m(z,Y,Q)<0}function H(z,Y,Q){return m(z,Y,Q)===0}function q(z,Y,Q){return m(z,Y,Q)!==0}function ce(z,Y,Q){return m(z,Y,Q)>=0}function ae(z,Y,Q){return m(z,Y,Q)<=0}function me(z,Y,Q,pe){var ye;switch(Y){case"===":typeof z=="object"&&(z=z.version),typeof Q=="object"&&(Q=Q.version),ye=z===Q;break;case"!==":typeof z=="object"&&(z=z.version),typeof Q=="object"&&(Q=Q.version),ye=z!==Q;break;case"":case"=":case"==":ye=H(z,Q,pe);break;case"!=":ye=q(z,Q,pe);break;case">":ye=x(z,Q,pe);break;case">=":ye=ce(z,Q,pe);break;case"<":ye=U(z,Q,pe);break;case"<=":ye=ae(z,Q,pe);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(z,Y){if(z instanceof de){if(z.loose===Y)return z;z=z.value}if(!(this instanceof de))return new de(z,Y);L("comparator",z,Y),this.loose=Y,this.parse(z),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(z,Y){return a(Y,z)},e.major=function(z,Y){return new M(z,Y).major},e.minor=function(z,Y){return new M(z,Y).minor},e.patch=function(z,Y){return new M(z,Y).patch},e.compare=m,e.compareLoose=function(z,Y){return m(z,Y,!0)},e.rcompare=function(z,Y,Q){return m(Y,z,Q)},e.sort=function(z,Y){return z.sort(function(Q,pe){return e.compare(Q,pe,Y)})},e.rsort=function(z,Y){return z.sort(function(Q,pe){return e.rcompare(Q,pe,Y)})},e.gt=x,e.lt=U,e.eq=H,e.neq=q,e.gte=ce,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function he(z,Y){if(z instanceof he)return z.loose===Y?z:new he(z.raw,Y);if(z instanceof de)return new he(z.value,Y);if(!(this instanceof he))return new he(z,Y);if(this.loose=Y,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function fe(z){return!z||z.toLowerCase()==="x"||z==="*"}function Se(z,Y,Q,pe,ye,Le,Ie,Ne,Ce,Te,_e,Re,Oe){return((Y=fe(Q)?"":fe(pe)?">="+Q+".0.0":fe(ye)?">="+Q+"."+pe+".0":">="+Y)+" "+(Ne=fe(Ce)?"":fe(Te)?"<"+(+Ce+1)+".0.0":fe(_e)?"<"+Ce+"."+(+Te+1)+".0":Re?"<="+Ce+"."+Te+"."+_e+"-"+Re:"<="+Ne)).trim()}function we(z,Y){for(var Q=0;Q<z.length;Q++)if(!z[Q].test(Y))return!1;if(Y.prerelease.length){for(Q=0;Q<z.length;Q++)if(L(z[Q].semver),z[Q].semver!==ge&&z[Q].semver.prerelease.length>0){var pe=z[Q].semver;if(pe.major===Y.major&&pe.minor===Y.minor&&pe.patch===Y.patch)return!0}return!1}return!0}function be(z,Y,Q){try{Y=new he(Y,Q)}catch{return!1}return Y.test(z)}function Me(z,Y,Q,pe){var ye,Le,Ie,Ne,Ce;switch(z=new M(z,pe),Y=new he(Y,pe),Q){case">":ye=x,Le=ae,Ie=U,Ne=">",Ce=">=";break;case"<":ye=U,Le=ce,Ie=x,Ne="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(z,Y,pe))return!1;for(var Te=0;Te<Y.set.length;++Te){var _e=Y.set[Te],Re=null,Oe=null;if(_e.forEach(function(xe){xe.semver===ge&&(xe=new de(">=0.0.0")),Re=Re||xe,Oe=Oe||xe,ye(xe.semver,Re.semver,pe)?Re=xe:Ie(xe.semver,Oe.semver,pe)&&(Oe=xe)}),Re.operator===Ne||Re.operator===Ce||(!Oe.operator||Oe.operator===Ne)&&Le(z,Oe.semver)||Oe.operator===Ce&&Ie(z,Oe.semver))return!1}return!0}de.prototype.parse=function(z){var Y=this.loose?P[W]:P[K],Q=z.match(Y);if(!Q)throw new TypeError("Invalid comparator: "+z);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new M(Q[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(z){return L("Comparator.test",z,this.loose),this.semver===ge||(typeof z=="string"&&(z=new M(z,this.loose)),me(z,this.operator,this.semver,this.loose))},de.prototype.intersects=function(z,Y){if(!(z instanceof de))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new he(z.value,Y),be(this.value,Q,Y);if(z.operator==="")return Q=new he(this.value,Y),be(z.semver,Q,Y);var pe=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Le=this.semver.version===z.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ne=me(this.semver,"<",z.semver,Y)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ce=me(this.semver,">",z.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return pe||ye||Le&&Ie||Ne||Ce},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(z){var Y=this.loose;z=z.trim(),L("range",z,Y);var Q=Y?P[j]:P[_];z=z.replace(Q,Se),L("hyphen replace",z),z=z.replace(P[V],"$1$2$3"),L("comparator trim",z,P[V]),z=(z=(z=z.replace(P[ee],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var pe=Y?P[W]:P[K],ye=z.split(" ").map(function(Le){return function(Ie,Ne){return L("comp",Ie),Ie=function(Ce,Te){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Oe){L("caret",Re,Oe);var xe=Oe?P[oe]:P[le];return Re.replace(xe,function(Ae,Ee,Pe,De,ke){var Fe;return L("caret",Re,Ae,Ee,Pe,De,ke),fe(Ee)?Fe="":fe(Pe)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?Fe=Ee==="0"?">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+".0 <"+(+Ee+1)+".0.0":ke?(L("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+ke+" <"+(+Ee+1)+".0.0"):(L("no pr"),Fe=Ee==="0"?Pe==="0"?">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+Pe+"."+(+De+1):">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0":">="+Ee+"."+Pe+"."+De+" <"+(+Ee+1)+".0.0"),L("caret return",Fe),Fe})}(_e,Te)}).join(" ")}(Ie,Ne),L("caret",Ie),Ie=function(Ce,Te){return Ce.trim().split(/\s+/).map(function(_e){return function(Re,Oe){var xe=Oe?P[se]:P[Z];return Re.replace(xe,function(Ae,Ee,Pe,De,ke){var Fe;return L("tilde",Re,Ae,Ee,Pe,De,ke),fe(Ee)?Fe="":fe(Pe)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":fe(De)?Fe=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0":ke?(L("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=">="+Ee+"."+Pe+"."+De+ke+" <"+Ee+"."+(+Pe+1)+".0"):Fe=">="+Ee+"."+Pe+"."+De+" <"+Ee+"."+(+Pe+1)+".0",L("tilde return",Fe),Fe})}(_e,Te)}).join(" ")}(Ie,Ne),L("tildes",Ie),Ie=function(Ce,Te){return L("replaceXRanges",Ce,Te),Ce.split(/\s+/).map(function(_e){return function(Re,Oe){Re=Re.trim();var xe=Oe?P[S]:P[w];return Re.replace(xe,function(Ae,Ee,Pe,De,ke,Fe){L("xRange",Re,Ae,Ee,Pe,De,ke,Fe);var We=fe(Pe),Ue=We||fe(De),Ve=Ue||fe(ke);return Ee==="="&&Ve&&(Ee=""),We?Ae=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(Ue&&(De=0),Ve&&(ke=0),Ee===">"?(Ee=">=",Ue?(Pe=+Pe+1,De=0,ke=0):Ve&&(De=+De+1,ke=0)):Ee==="<="&&(Ee="<",Ue?Pe=+Pe+1:De=+De+1),Ae=Ee+Pe+"."+De+"."+ke):Ue?Ae=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ve&&(Ae=">="+Pe+"."+De+".0 <"+Pe+"."+(+De+1)+".0"),L("xRange return",Ae),Ae})}(_e,Te)}).join(" ")}(Ie,Ne),L("xrange",Ie),Ie=function(Ce,Te){return L("replaceStars",Ce,Te),Ce.trim().replace(P[G],"")}(Ie,Ne),L("stars",Ie),Ie}(Le,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Le){return!!Le.match(pe)})),ye=ye.map(function(Le){return new de(Le,Y)})},he.prototype.intersects=function(z,Y){if(!(z instanceof he))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(pe){return z.set.some(function(ye){return ye.every(function(Le){return pe.intersects(Le,Y)})})})})},e.toComparators=function(z,Y){return new he(z,Y).set.map(function(Q){return Q.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},he.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new M(z,this.loose));for(var Y=0;Y<this.set.length;Y++)if(we(this.set[Y],z))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(z,Y,Q){var pe=null,ye=null;try{var Le=new he(Y,Q)}catch{return null}return z.forEach(function(Ie){Le.test(Ie)&&(pe&&ye.compare(Ie)!==-1||(ye=new M(pe=Ie,Q)))}),pe},e.minSatisfying=function(z,Y,Q){var pe=null,ye=null;try{var Le=new he(Y,Q)}catch{return null}return z.forEach(function(Ie){Le.test(Ie)&&(pe&&ye.compare(Ie)!==1||(ye=new M(pe=Ie,Q)))}),pe},e.validRange=function(z,Y){try{return new he(z,Y).range||"*"}catch{return null}},e.ltr=function(z,Y,Q){return Me(z,Y,"<",Q)},e.gtr=function(z,Y,Q){return Me(z,Y,">",Q)},e.outside=Me,e.prerelease=function(z,Y){var Q=J(z,Y);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(z,Y,Q){return z=new he(z,Q),Y=new he(Y,Q),z.intersects(Y)},e.coerce=function(z){if(z instanceof M)return z;if(typeof z!="string")return null;var Y=z.match(P[k]);return Y==null?null:J((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,N(1))},function(B,e){var N,O,L=B.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(v){if(N===setTimeout)return setTimeout(v,0);if((N===A||!N)&&setTimeout)return N=setTimeout,setTimeout(v,0);try{return N(v,0)}catch{try{return N.call(null,v,0)}catch{return N.call(this,v,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:A}catch{N=A}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch{O=T}})();var f,l=[],D=!1,C=-1;function d(){D&&f&&(D=!1,f.length?l=f.concat(l):C=-1,l.length&&h())}function h(){if(!D){var v=P(d);D=!0;for(var c=l.length;c;){for(f=l,l=[];++C<c;)f&&f[C].run();C=-1,c=l.length}f=null,D=!1,function(p){if(O===clearTimeout)return clearTimeout(p);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(p);try{O(p)}catch{try{return O.call(null,p)}catch{return O.call(this,p)}}}(v)}}function I(v,c){this.fun=v,this.array=c}function E(){}L.nextTick=function(v){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];l.push(new I(v,c)),l.length!==1||D||P(h)},I.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=E,L.addListener=E,L.once=E,L.off=E,L.removeListener=E,L.removeAllListeners=E,L.emit=E,L.prependListener=E,L.prependOnceListener=E,L.listeners=function(v){return[]},L.binding=function(v){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(v){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(B,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(P,f,l){this.level=P,this.key=f,this.value=l,this.forward=[]}}const L=void 0;class A{constructor(P,f=2**16){this.comparator=P,this[N]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(f)|0),this._header=new O(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new O(this._maxLevel,L,L),this._size=0}has(P){return!!A._search(this,P,this.comparator)}get(P){return A._search(this,P,this.comparator)?.value}set(P,f){return A._insert(this,P,f,this.comparator)&&(this._size+=1),this}delete(P){const f=A._delete(this,P,this.comparator);return f&&(this._size-=1),f}forEach(P,f){let l=this._header.forward[0];for(;l;)P.call(f,l.value,l.key,this),l=l.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this._header.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static _search(P,f,l){let D=P._header;for(let C=P._level-1;C>=0;C--)for(;D.forward[C]&&l(D.forward[C].key,f)<0;)D=D.forward[C];if(D=D.forward[0],D&&l(D.key,f)===0)return D}static _insert(P,f,l,D){const C=[];let d=P._header;for(let h=P._level-1;h>=0;h--){for(;d.forward[h]&&D(d.forward[h].key,f)<0;)d=d.forward[h];C[h]=d}if(d=d.forward[0],d&&D(d.key,f)===0)return d.value=l,!1;{const h=A._randomLevel(P);if(h>P._level){for(let I=P._level;I<h;I++)C[I]=P._header;P._level=h}d=new O(h,f,l);for(let I=0;I<h;I++)d.forward[I]=C[I].forward[I],C[I].forward[I]=d;return!0}}static _randomLevel(P,f=.5){let l=1;for(;Math.random()<f&&l<P._maxLevel;)l+=1;return l}static _delete(P,f,l){const D=[];let C=P._header;for(let d=P._level-1;d>=0;d--){for(;C.forward[d]&&l(C.forward[d].key,f)<0;)C=C.forward[d];D[d]=C}if(C=C.forward[0],!C||l(C.key,f)!==0)return!1;for(let d=0;d<P._level&&D[d].forward[d]===C;d++)D[d].forward[d]=C.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===L;)P._level-=1;return!0}}e.SkipList=A}),define(te[45],ne([0,1,9,2]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function L(g){const y=g;return y?typeof y.read=="function":!1}e.isReadable=L;function A(g){const y=g;return y?[y.on,y.pause,y.resume,y.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=A;function T(g){const y=g;return y?A(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(g,y){return new f(g,y)}e.newWriteableStream=P;class f{constructor(y,r){this.reducer=y,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(y){if(!this.state.destroyed){if(this.state.flowing)this.emitData(y);else if(this.buffer.data.push(y),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(y){this.state.destroyed||(this.state.flowing?this.emitError(y):this.buffer.error.push(y))}end(y){this.state.destroyed||(typeof y<"u"&&this.write(y),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(y){this.listeners.data.slice(0).forEach(r=>r(y))}emitError(y){this.listeners.error.length===0?(0,N.onUnexpectedError)(y):this.listeners.error.slice(0).forEach(r=>r(y))}emitEnd(){this.listeners.end.slice(0).forEach(y=>y())}on(y,r){if(!this.state.destroyed)switch(y){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(y,r){if(this.state.destroyed)return;let o;switch(y){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(r);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const y=this.reducer(this.buffer.data);this.emitData(y),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const y of this.buffer.error)this.emitError(y);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(g,y){const r=[];let o;for(;(o=g.read())!==null;)r.push(o);return y(r)}e.consumeReadable=l;function D(g,y,r){const o=[];let t;for(;(t=g.read())!==null&&o.length<r;)o.push(t);return t===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return g.read()}}}e.peekReadable=D;function C(g,y){return new Promise((r,o)=>{const t=[];d(g,{onData:i=>{y&&t.push(i)},onError:i=>{y?o(i):r(void 0)},onEnd:()=>{r(y?y(t):void 0)}})})}e.consumeStream=C;function d(g,y,r){g.on("error",o=>{r?.isCancellationRequested||y.onError(o)}),g.on("end",()=>{r?.isCancellationRequested||y.onEnd()}),g.on("data",o=>{r?.isCancellationRequested||y.onData(o)})}e.listenStream=d;function h(g,y){return new Promise((r,o)=>{const t=new O.DisposableStore,i=[],n=b=>{if(i.push(b),i.length>y)return t.dispose(),g.pause(),r({stream:g,buffer:i,ended:!1})},s=b=>(t.dispose(),o(b)),u=()=>(t.dispose(),r({stream:g,buffer:i,ended:!0}));t.add((0,O.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),t.add((0,O.toDisposable)(()=>g.removeListener("end",u))),g.on("end",u),t.add((0,O.toDisposable)(()=>g.removeListener("data",n))),g.on("data",n)})}e.peekStream=h;function I(g,y){const r=P(y);return r.end(g),r}e.toStream=I;function E(){const g=P(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=E;function v(g){let y=!1;return{read:()=>y?null:(y=!0,g)}}e.toReadable=v;function c(g,y,r){const o=P(r);return d(g,{onData:t=>o.write(y.data(t)),onError:t=>o.error(y.error?y.error(t):t),onEnd:()=>o.end()}),o}e.transform=c;function p(g,y,r){let o=!1;return{read:()=>{const t=y.read();return o?t:(o=!0,t!==null?r([g,t]):g)}}}e.prefixedReadable=p;function R(g,y,r){let o=!1;const t=P(r);return d(y,{onData:i=>o?t.write(i):(o=!0,t.write(r([g,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(g)),t.end()}}),t}e.prefixedStream=R}),define(te[14],ne([0,1,164,45]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const L=typeof Buffer<"u",A=new N.Lazy(()=>new Uint8Array(256));let T,P;class f{static alloc(k){return L?new f(Buffer.allocUnsafe(k)):new f(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new f(k)}static fromString(k,$){return!($?.dontUseNodeBuffer||!1)&&L?new f(Buffer.from(k)):(T||(T=new TextEncoder),new f(T.encode(k)))}static fromByteArray(k){const $=f.alloc(k.length);for(let ee=0,Z=k.length;ee<Z;ee++)$.buffer[ee]=k[ee];return $}static concat(k,$){if(typeof $>"u"){$=0;for(let se=0,re=k.length;se<re;se++)$+=k[se].byteLength}const ee=f.alloc($);let Z=0;for(let se=0,re=k.length;se<re;se++){const ue=k[se];ee.set(ue,Z),Z+=ue.byteLength}return ee}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=f.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(k,$){return new f(this.buffer.subarray(k,$))}set(k,$){if(k instanceof f)this.buffer.set(k.buffer,$);else if(k instanceof Uint8Array)this.buffer.set(k,$);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),$);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),$);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return d(this.buffer,k)}writeUInt32BE(k,$){h(this.buffer,k,$)}readUInt32LE(k){return I(this.buffer,k)}writeUInt32LE(k,$){E(this.buffer,k,$)}readUInt8(k){return v(this.buffer,k)}writeUInt8(k,$){c(this.buffer,k,$)}indexOf(k,$=0){return l(this.buffer,k instanceof f?k.buffer:k,$)}}e.VSBuffer=f;function l(S,k,$=0){const ee=k.byteLength,Z=S.byteLength;if(ee===0)return 0;if(ee===1)return S.indexOf(k[0]);if(ee>Z-$)return-1;const se=A.value;se.fill(k.length);for(let oe=0;oe<k.length;oe++)se[k[oe]]=k.length-oe-1;let re=$+k.length-1,ue=re,le=-1;for(;re<Z;)if(S[re]===k[ue]){if(ue===0){le=re;break}re--,ue--}else re+=Math.max(k.length-ue,se[S[re]]),ue=k.length-1;return le}e.binaryIndexOf=l;function D(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0}e.readUInt16LE=D;function C(S,k,$){S[$+0]=k&255,k=k>>>8,S[$+1]=k&255}e.writeUInt16LE=C;function d(S,k){return S[k]*2**24+S[k+1]*2**16+S[k+2]*2**8+S[k+3]}e.readUInt32BE=d;function h(S,k,$){S[$+3]=k,k=k>>>8,S[$+2]=k,k=k>>>8,S[$+1]=k,k=k>>>8,S[$]=k}e.writeUInt32BE=h;function I(S,k){return S[k+0]<<0>>>0|S[k+1]<<8>>>0|S[k+2]<<16>>>0|S[k+3]<<24>>>0}e.readUInt32LE=I;function E(S,k,$){S[$+0]=k&255,k=k>>>8,S[$+1]=k&255,k=k>>>8,S[$+2]=k&255,k=k>>>8,S[$+3]=k&255}e.writeUInt32LE=E;function v(S,k){return S[k]}e.readUInt8=v;function c(S,k,$){S[$]=k}e.writeUInt8=c;function p(S){return O.consumeReadable(S,k=>f.concat(k))}e.readableToBuffer=p;function R(S){return O.toReadable(S)}e.bufferToReadable=R;function g(S){return O.consumeStream(S,k=>f.concat(k))}e.streamToBuffer=g;async function y(S){return S.ended?f.concat(S.buffer):f.concat([...S.buffer,await g(S.stream)])}e.bufferedStreamToBuffer=y;function r(S){return O.toStream(S,k=>f.concat(k))}e.bufferToStream=r;function o(S){return O.transform(S,{data:k=>typeof k=="string"?f.fromString(k):f.wrap(k)},k=>f.concat(k))}e.streamToBufferReadableStream=o;function t(S){return O.newWriteableStream(k=>f.concat(k),S)}e.newWriteableBufferStream=t;function i(S,k){return O.prefixedReadable(S,k,$=>f.concat($))}e.prefixedBufferReadable=i;function n(S,k){return O.prefixedStream(S,k,$=>f.concat($))}e.prefixedBufferStream=n;function s(S){let k=0,$=0,ee=0;const Z=new Uint8Array(Math.floor(S.length/4*3)),se=ue=>{switch($){case 3:Z[ee++]=k|ue,$=0;break;case 2:Z[ee++]=k|ue>>>2,k=ue<<6,$=3;break;case 1:Z[ee++]=k|ue>>>4,k=ue<<4,$=2;break;default:k=ue<<2,$=1}};for(let ue=0;ue<S.length;ue++){const le=S.charCodeAt(ue);if(le>=65&&le<=90)se(le-65);else if(le>=97&&le<=122)se(le-97+26);else if(le>=48&&le<=57)se(le-48+52);else if(le===43||le===45)se(62);else if(le===47||le===95)se(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${S[ue]}`)}}const re=ee;for(;$>0;)se(0);return f.wrap(Z).slice(0,re)}e.decodeBase64=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:S},k=!0,$=!1){const ee=$?b:u;let Z="";const se=S.byteLength%3;let re=0;for(;re<S.byteLength-se;re+=3){const ue=S[re+0],le=S[re+1],oe=S[re+2];Z+=ee[ue>>>2],Z+=ee[(ue<<4|le>>>4)&63],Z+=ee[(le<<2|oe>>>6)&63],Z+=ee[oe&63]}if(se===1){const ue=S[re+0];Z+=ee[ue>>>2],Z+=ee[ue<<4&63],k&&(Z+="==")}else if(se===2){const ue=S[re+0],le=S[re+1];Z+=ee[ue>>>2],Z+=ee[(ue<<4|le>>>4)&63],Z+=ee[le<<2&63],k&&(Z+="=")}return Z}e.encodeBase64=w}),define(te[41],ne([0,1,29]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(c){return L(c,0)}e.hash=O;function L(c,p){switch(typeof c){case"object":return c===null?A(349,p):Array.isArray(c)?f(c,p):l(c,p);case"string":return P(c,p);case"boolean":return T(c,p);case"number":return A(c,p);case"undefined":return A(937,p);default:return A(617,p)}}e.doHash=L;function A(c,p){return(p<<5)-p+c|0}e.numberHash=A;function T(c,p){return A(c?433:863,p)}function P(c,p){p=A(149417,p);for(let R=0,g=c.length;R<g;R++)p=A(c.charCodeAt(R),p);return p}e.stringHash=P;function f(c,p){return p=A(104579,p),c.reduce((R,g)=>L(g,R),p)}function l(c,p){return p=A(181387,p),Object.keys(c).sort().reduce((R,g)=>(R=P(g,R),L(c[g],R)),p)}class D{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=L(p,this._value),this._value}}e.Hasher=D;var C;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function d(c,p,R=32){const g=R-p,y=~((1<<g)-1);return(c<<p|(y&c)>>>g)>>>0}function h(c,p=0,R=c.byteLength,g=0){for(let y=0;y<R;y++)c[p+y]=g}function I(c,p,R="0"){for(;c.length<p;)c=R+c;return c}function E(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(R=>R.toString(16).padStart(2,"0")).join(""):I((c>>>0).toString(16),p/4)}e.toHexString=E;class v{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const R=p.length;if(R===0)return;const g=this._buff;let y=this._buffLen,r=this._leftoverHighSurrogate,o,t;for(r!==0?(o=r,t=-1,r=0):(o=p.charCodeAt(0),t=0);;){let i=o;if(N.isHighSurrogate(o))if(t+1<R){const n=p.charCodeAt(t+1);N.isLowSurrogate(n)?(t++,i=N.computeCodePoint(o,n)):i=65533}else{r=o;break}else N.isLowSurrogate(o)&&(i=65533);if(y=this._push(g,y,i),t++,t<R)o=p.charCodeAt(t);else break}this._buffLen=y,this._leftoverHighSurrogate=r}_push(p,R,g){return g<128?p[R++]=g:g<2048?(p[R++]=192|(g&1984)>>>6,p[R++]=128|(g&63)>>>0):g<65536?(p[R++]=224|(g&61440)>>>12,p[R++]=128|(g&4032)>>>6,p[R++]=128|(g&63)>>>0):(p[R++]=240|(g&1835008)>>>18,p[R++]=128|(g&258048)>>>12,p[R++]=128|(g&4032)>>>6,p[R++]=128|(g&63)>>>0),R>=64&&(this._step(),R-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),R}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=v._bigBlock32,R=this._buffDV;for(let u=0;u<64;u+=4)p.setUint32(u,R.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)p.setUint32(u,d(p.getUint32(u-12,!1)^p.getUint32(u-32,!1)^p.getUint32(u-56,!1)^p.getUint32(u-64,!1),1),!1);let g=this._h0,y=this._h1,r=this._h2,o=this._h3,t=this._h4,i,n,s;for(let u=0;u<80;u++)u<20?(i=y&r|~y&o,n=1518500249):u<40?(i=y^r^o,n=1859775393):u<60?(i=y&r|y&o|r&o,n=2400959708):(i=y^r^o,n=3395469782),s=d(g,5)+i+t+n+p.getUint32(u*4,!1)&4294967295,t=o,o=r,r=d(y,30),y=g,g=s;this._h0=this._h0+g&4294967295,this._h1=this._h1+y&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=v}),define(te[54],ne([0,1,29]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(O||(O={})),function(L){const A="error",T="warning",P="warn",f="info",l="ignore";function D(d){return d?N.equalsIgnoreCase(A,d)?L.Error:N.equalsIgnoreCase(T,d)||N.equalsIgnoreCase(P,d)?L.Warning:N.equalsIgnoreCase(f,d)?L.Info:L.Ignore:L.Ignore}L.fromValue=D;function C(d){switch(d){case L.Error:return A;case L.Warning:return T;case L.Info:return f;default:return l}}L.toString=C}(O||(O={})),e.default=O}),define(te[30],ne([0,1,3]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([R,g])=>{p[R]=g&&typeof g=="object"?O(g):g}),p}e.deepClone=O;function L(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const R=p.shift();Object.freeze(R);for(const g in R)if(A.call(R,g)){const y=R[g];typeof y=="object"&&!Object.isFrozen(y)&&!(0,N.isTypedArray)(y)&&p.push(y)}}return c}e.deepFreeze=L;const A=Object.prototype.hasOwnProperty;function T(c,p){return P(c,p,new Set)}e.cloneAndChange=T;function P(c,p,R){if((0,N.isUndefinedOrNull)(c))return c;const g=p(c);if(typeof g<"u")return g;if(Array.isArray(c)){const y=[];for(const r of c)y.push(P(r,p,R));return y}if((0,N.isObject)(c)){if(R.has(c))throw new Error("Cannot clone recursive data-structure");R.add(c);const y={};for(const r in c)A.call(c,r)&&(y[r]=P(c[r],p,R));return R.delete(c),y}return c}function f(c,p,R=!0){return(0,N.isObject)(c)?((0,N.isObject)(p)&&Object.keys(p).forEach(g=>{g in c?R&&((0,N.isObject)(c[g])&&(0,N.isObject)(p[g])?f(c[g],p[g],R):c[g]=p[g]):c[g]=p[g]}),c):p}e.mixin=f;function l(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let R,g;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(R=0;R<c.length;R++)if(!l(c[R],p[R]))return!1}else{const y=[];for(g in c)y.push(g);y.sort();const r=[];for(g in p)r.push(g);if(r.sort(),!l(y,r))return!1;for(R=0;R<y.length;R++)if(!l(c[y[R]],p[y[R]]))return!1}return!0}e.equals=l;function D(c){const p=new Set;return JSON.stringify(c,(R,g)=>{if((0,N.isObject)(g)||Array.isArray(g)){if(p.has(g))return"[Circular]";p.add(g)}return g})}e.safeStringify=D;function C(c,p){const R=Object.create(null);return!c||!p||Object.keys(p).forEach(y=>{const r=c[y],o=p[y];l(r,o)||(R[y]=o)}),R}e.distinct=C;function d(c,p){const R=p.toLowerCase(),g=Object.keys(c).find(y=>y.toLowerCase()===R);return g?c[g]:c[p]}e.getCaseInsensitive=d;function h(c,p){const R=Object.create(null);for(const[g,y]of Object.entries(c))p(g,y)&&(R[g]=y);return R}e.filter=h;function I(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.getAllPropertyNames=I;function E(c){const p=[];for(const R of I(c))typeof c[R]=="function"&&p.push(R);return p}e.getAllMethodNames=E;function v(c,p){const R=y=>function(){const r=Array.prototype.slice.call(arguments,0);return p(y,r)},g={};for(const y of c)g[y]=R(y);return g}e.createProxyObject=v}),define(te[28],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(L){return N.test(L)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let f=0,l="";return l+=T[A[f++]],l+=T[A[f++]],l+=T[A[f++]],l+=T[A[f++]],l+="-",l+=T[A[f++]],l+=T[A[f++]],l+="-",l+=T[A[f++]],l+=T[A[f++]],l+="-",l+=T[A[f++]],l+=T[A[f++]],l+="-",l+=T[A[f++]],l+=T[A[f++]],l+=T[A[f++]],l+=T[A[f++]],l+=T[A[f++]],l+=T[A[f++]],l}}()}),define(te[74],ne([0,1,33]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(T){const P=T.replace(/\-/g,":").toLowerCase();return!O.has(P)}function A(){const T=(0,N.networkInterfaces)();for(const P in T){const f=T[P];if(f){for(const{mac:l}of f)if(L(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(te[75],ne([7,5]),function(B,e){return B.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,L=O*60,A=L*24,T=A*7,P=A*30,f=A*365;function l(C,d,h,I){typeof C!="number"&&(C=C.getTime());const E=Math.round((new Date().getTime()-C)/1e3);if(E<-30)return(0,N.localize)(0,null,l(new Date().getTime()+E*1e3,!1));if(!I&&E<30)return(0,N.localize)(1,null);let v;return E<O?(v=E,d?v===1?h?(0,N.localize)(2,null,v):(0,N.localize)(3,null,v):h?(0,N.localize)(4,null,v):(0,N.localize)(5,null,v):v===1?h?(0,N.localize)(6,null,v):(0,N.localize)(7,null,v):h?(0,N.localize)(8,null,v):(0,N.localize)(9,null,v)):E<L?(v=Math.floor(E/O),d?v===1?h?(0,N.localize)(10,null,v):(0,N.localize)(11,null,v):h?(0,N.localize)(12,null,v):(0,N.localize)(13,null,v):v===1?h?(0,N.localize)(14,null,v):(0,N.localize)(15,null,v):h?(0,N.localize)(16,null,v):(0,N.localize)(17,null,v)):E<A?(v=Math.floor(E/L),d?v===1?h?(0,N.localize)(18,null,v):(0,N.localize)(19,null,v):h?(0,N.localize)(20,null,v):(0,N.localize)(21,null,v):v===1?h?(0,N.localize)(22,null,v):(0,N.localize)(23,null,v):h?(0,N.localize)(24,null,v):(0,N.localize)(25,null,v)):E<T?(v=Math.floor(E/A),d?v===1?(0,N.localize)(26,null,v):(0,N.localize)(27,null,v):v===1?(0,N.localize)(28,null,v):(0,N.localize)(29,null,v)):E<P?(v=Math.floor(E/T),d?v===1?h?(0,N.localize)(30,null,v):(0,N.localize)(31,null,v):h?(0,N.localize)(32,null,v):(0,N.localize)(33,null,v):v===1?h?(0,N.localize)(34,null,v):(0,N.localize)(35,null,v):h?(0,N.localize)(36,null,v):(0,N.localize)(37,null,v)):E<f?(v=Math.floor(E/P),d?v===1?h?(0,N.localize)(38,null,v):(0,N.localize)(39,null,v):h?(0,N.localize)(40,null,v):(0,N.localize)(41,null,v):v===1?h?(0,N.localize)(42,null,v):(0,N.localize)(43,null,v):h?(0,N.localize)(44,null,v):(0,N.localize)(45,null,v)):(v=Math.floor(E/f),d?v===1?h?(0,N.localize)(46,null,v):(0,N.localize)(47,null,v):h?(0,N.localize)(48,null,v):(0,N.localize)(49,null,v):v===1?h?(0,N.localize)(50,null,v):(0,N.localize)(51,null,v):h?(0,N.localize)(52,null,v):(0,N.localize)(53,null,v))}e.fromNow=l;function D(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(te[77],ne([7,5]),function(B,e){return B.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(C,d){return d&&(C.stack||C.stacktrace)?L.localize(0,null,P(C),T(C.stack)||T(C.stacktrace)):P(C)}function T(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function f(C=null,d=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const h=N.coalesce(C),I=f(h[0],d);return h.length>1?L.localize(4,null,I,h.length):I}if(O.isString(C))return C;if(C.detail){const h=C.detail;if(h.error)return A(h.error,d);if(h.exception)return A(h.exception,d)}return C.stack?A(C,d):C.message?C.message:L.localize(5,null)}e.toErrorMessage=f;function l(C){const d=C;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=l;function D(C,d){let h;return typeof C=="string"?h=new Error(C):h=C,h.actions=d,h}e.createErrorWithActions=D}),define(te[78],ne([7,5]),function(B,e){return B.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(L){switch(L){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(te[55],ne([0,1,13]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(O||(e.Source=O={}));var L;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(P,...f){const l=f.reduce((d,h)=>(d[h]=!0,d),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(d=>!l[d]).forEach(d=>{for(let h=0;h<D.length;h++)if(d.search(D[h])!==-1){delete P[d];break}})}e.sanitizeProcessEnvironment=A;function T(P){P&&(delete P.DEBUG,N.isMacintosh&&delete P.DYLD_LIBRARY_PATH,N.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(te[80],ne([0,1,11]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(l){const D=l;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=O;function L(l){const D=[];let C;try{const d=JSON.parse(l.arguments),h=d[d.length-1];h&&h.__$stack&&(d.pop(),C=h.__$stack),D.push(...d)}catch{D.push("Unable to log remote console arguments",l.arguments)}return{args:D,stack:C}}e.parse=L;function A(l){if(typeof l!="string")return A(L(l).stack);const D=l;if(D){const C=T(D),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(d&&d.length===4)return{uri:N.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=A;function T(l){if(!l)return l;const D=l.indexOf(`
`);return D===-1?l:l.substring(0,D)}function P(l,D){const{args:C,stack:d}=L(l),h=typeof C[0]=="string"&&C.length===1;let I=T(d);I&&(I=`(${I.trim()})`);let E=[];if(typeof C[0]=="string"?I&&h?E=[`%c[${D}] %c${C[0]} %c${I}`,f("blue"),f(""),f("grey")]:E=[`%c[${D}] %c${C[0]}`,f("blue"),f(""),...C.slice(1)]:E=[`%c[${D}]%`,f("blue"),...C],I&&!h&&E.push(I),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,E)}e.log=P;function f(l){return`color: ${l}`}}),define(te[46],ne([0,1,14,11]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(f){return JSON.stringify(f,T)}e.stringify=L;function A(f){let l=JSON.parse(f);return l=P(l),l}e.parse=A;function T(f,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function P(f,l=0){if(!f||l>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return O.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof N.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let D=0;D<f.length;++D)f[D]=P(f[D],l+1);else for(const D in f)Object.hasOwnProperty.call(f,D)&&(f[D]=P(f[D],l+1))}return f}e.revive=P}),define(te[81],ne([0,1,70,15,13,11]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class T{constructor(d,h,I){this.id=d,this.dependencies=h,this.callback=I}}class P{static{this.INSTANCE=new P}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(d,h,I)=>{typeof d!="string"&&(I=h,h=d,d=null),(typeof h!="object"||!Array.isArray(h))&&(I=h,h=null),this._defineCalls.push(new T(d,h,I))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this._initialize();const h=await(this._isWebWorker?this._workerLoadScript(d):this._isRenderer?this._rendererLoadScript(d):this._nodeJSLoadScript(d));if(!h)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}_rendererLoadScript(d){return new Promise((h,I)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const v=()=>{E.removeEventListener("load",c),E.removeEventListener("error",p)},c=R=>{v(),h(this._defineCalls.pop())},p=R=>{v(),I(R)};E.addEventListener("load",c),E.addEventListener("error",p),this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),E.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(E)})}_workerLoadScript(d){return new Promise((h,I)=>{try{this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),importScripts(d),h(this._defineCalls.pop())}catch(E){I(E)}})}async _nodeJSLoadScript(d){try{const h=globalThis._VSCODE_NODE_MODULES.fs,I=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,v=A.URI.parse(d).fsPath,c=h.readFileSync(v).toString(),p=E.wrap(c.replace(/^#!.*/,""));return new I.Script(p).runInThisContext().apply(),this._defineCalls.pop()}catch(h){throw h}}}const f=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function D(C,d,h){if(N.isESM){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[C]&&(C=l[C]);const I=`${C}/${d}`;if(f.has(I))return f.get(I);let E;if(/^\w[\w\d+.-]*:\/\//.test(I))E=I;else{const R=`${h&&!L.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${I}`;E=O.FileAccess.asBrowserUri(R).toString(!0)}const v=P.INSTANCE.load(E);return f.set(I,v),v}else return await new Promise((I,E)=>{B([C],I,E)})}e.importAMDNodeModule=D}),define(te[82],ne([0,1,33,47,28,74,13]),function(B,e,N,O,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(d){return this._virtualMachineOUIs||(this._virtualMachineOUIs=O.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(d)}value(){if(this._value===void 0){let d=0,h=0;const I=(0,N.networkInterfaces)();for(const E in I){const v=I[E];if(v)for(const{mac:c,internal:p}of v)p||(h+=1,this._isVirtualMachineMacAddress(c.toUpperCase())&&(d+=1))}this._value=h>0?d/h:0}return this._value}};let P;async function f(d){return P||(P=(async()=>await l(d)||L.generateUuid())()),P}e.getMachineId=f;async function l(d){try{const h=await new Promise((E,v)=>{B(["crypto"],E,v)}),I=(0,A.getMac)();return h.createHash("sha256").update(I,"utf8").digest("hex")}catch(h){d(h);return}}const D="Software\\Microsoft\\SQMClient";async function C(d){if(T.isWindows){const h=await new Promise((I,E)=>{B(["@vscode/windows-registry"],I,E)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch(I){return d(I),""}}return""}e.getSqmMachineId=C}),define(te[83],ne([0,1,33,16,24]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class C{constructor(y,r,o){this.exePath=y,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:g=!1}={}){return g?l===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:g=!1,findPreview:y=!1}={}){const r=d({useAlternateBitness:g});if(!r)return null;const o=O.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const u of await L.Promises.readdir(o)){let b=-1;if(y){const S=u.indexOf("-");if(S<0)continue;const k=u.substring(0,S);if(!A.test(k)||u.substring(S+1)!=="preview")continue;b=parseInt(k,10)}else{if(!A.test(u))continue;b=parseInt(u,10)}if(b<=t)continue;const w=O.join(o,u,"pwsh.exe");await L.SymlinkSupport.existsFile(w)&&(i=w,t=b)}if(!i)return null;const n=r.includes("x86")?" (x86)":"",s=y?" Preview":"";return new C(i,`PowerShell${s}${n}`,!0)}async function I({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const y=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=g?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await L.Promises.readdir(y))if(r.test(t)){const i=O.join(y,t,"pwsh.exe");return new C(i,o)}return null}function E(){const g=O.join(N.homedir(),".dotnet","tools","pwsh.exe");return new C(g,".NET Core PowerShell Global Tool")}function v(){const g=O.join(process.env.windir,l===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(g,"Windows PowerShell",!0)}async function*c(){let g=await h();g&&(yield g),g=await h({useAlternateBitness:!0}),g&&(yield g),g=await I(),g&&(yield g),g=E(),g&&(yield g),g=await h({findPreview:!0}),g&&(yield g),g=await I({findPreview:!0}),g&&(yield g),g=await h({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=v(),g&&(yield g)}async function*p(){for await(const g of c())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=p;async function R(){for await(const g of p())return g;return null}e.getFirstAvailablePowerShellInstallation=R}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(B,e,N,O,L,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function f(C=L.env){return C.comspec||"cmd.exe"}e.getWindowsShell=f;function l(C){let d=[],h=!1;const I=function(E){if(h){d.push(E);return}(!C.send(E,c=>{if(c&&console.error(c),h=!1,d.length>0){const p=d.slice(0);d=[],p.forEach(R=>I(R))}})||O.isWindows)&&(h=!0)};return{send:I}}e.createQueuedSender=l;var D;(function(C){async function d(h,I,E){if(N.isAbsolute(h))return h;if(I===void 0&&(I=L.cwd()),N.dirname(h)!=="."||(E===void 0&&T.isString(L.env.PATH)&&(E=L.env.PATH.split(N.delimiter)),E===void 0||E.length===0))return N.join(I,h);async function c(p){if(await P.Promises.exists(p)){let R;try{R=await P.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(R=await P.Promises.lstat(p))}return R?!R.isDirectory():!1}return!1}for(const p of E){let R;if(N.isAbsolute(p)?R=N.join(p,h):R=N.join(I,p,h),await c(R))return R;let g=R+".com";if(await c(g)||(g=R+".exe",await c(g)))return g}return N.join(I,h)}C.findExecutable=d})(D||(e.win32=D={}))}),define(te[84],ne([0,1,33,13,83,56]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(C,d){return C===1?O.isWindows?D():A.getWindowsShell(d):f(C,d)}e.getSystemShell=T;let P=null;function f(C,d){if(O.isLinux&&C===2||O.isMacintosh&&C===3)return"/bin/bash";if(!P){let h;if(O.isWindows)h="/bin/bash";else{if(h=d.SHELL,!h)try{h=(0,N.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}P=h}return P}let l=null;async function D(){return l||(l=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),l}});var ve=this&&this.__decorate||function(B,e,N,O){var L=arguments.length,A=L<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,N):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(B,e,N,O);else for(var P=B.length-1;P>=0;P--)(T=B[P])&&(A=(L<3?T(A):L>3?T(e,N,A):T(e,N))||A);return L>3&&A&&Object.defineProperty(e,N,A),A};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(B,e,N,O,L,A,T,P,f,l,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(h||(h={}));function I(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(E||(E={}));function v(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(c||(c={}));function p(V){let _=0;for(let j=0;;j+=7){const G=V.read(1);if(_|=(G.buffer[0]&127)<<j,!(G.buffer[0]&128))return _}}const R=t(0);function g(V,_){if(_===0){V.write(R);return}let j=0;for(let X=_;X!==0;X=X>>>7)j++;const G=L.VSBuffer.alloc(j);for(let X=0;_!==0;X++)G.buffer[X]=_&127,_=_>>>7,_>0&&(G.buffer[X]|=128);V.write(G)}class y{constructor(_){this.buffer=_,this.pos=0}read(_){const j=this.buffer.slice(this.pos,this.pos+_);return this.pos+=j.byteLength,j}}e.BufferReader=y;class r{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}e.BufferWriter=r;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function t(V){const _=L.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function s(V,_){if(typeof _>"u")V.write(i.Undefined);else if(typeof _=="string"){const j=L.VSBuffer.fromString(_);V.write(i.String),g(V,j.byteLength),V.write(j)}else if(n&&Buffer.isBuffer(_)){const j=L.VSBuffer.wrap(_);V.write(i.Buffer),g(V,j.byteLength),V.write(j)}else if(_ instanceof L.VSBuffer)V.write(i.VSBuffer),g(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(i.Array),g(V,_.length);for(const j of _)s(V,j)}else if(typeof _=="number"&&(_|0)===_)V.write(i.Uint),g(V,_);else{const j=L.VSBuffer.fromString(JSON.stringify(_));V.write(i.Object),g(V,j.byteLength),V.write(j)}}e.serialize=s;function u(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(p(V)).toString();case o.Buffer:return V.read(p(V)).buffer;case o.VSBuffer:return V.read(p(V));case o.Array:{const j=p(V),G=[];for(let X=0;X<j;X++)G.push(u(V));return G}case o.Object:return JSON.parse(V.read(p(V)).toString());case o.Int:return p(V)}}e.deserialize=u;class b{constructor(_,j,G=null,X=1e3){this.protocol=_,this.ctx=j,this.logger=G,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(_,j){this.channels.set(_,j),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const j=this.send([_.type]);this.logger?.logOutgoing(j,0,1,v(_.type));return}case 201:case 202:case 204:case 203:{const j=this.send([_.type,_.id],_.data);this.logger?.logOutgoing(j,_.id,1,v(_.type),_.data);return}}}send(_,j=void 0){const G=new r;return s(G,_),s(G,j),this.sendBuffer(G.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const j=new y(_),G=u(j),X=u(j),J=G[0];switch(J){case 100:return this.logger?.logIncoming(_.byteLength,G[1],1,`${I(J)}: ${G[2]}.${G[3]}`,X),this.onPromise({type:J,id:G[1],channelName:G[2],name:G[3],arg:X});case 102:return this.logger?.logIncoming(_.byteLength,G[1],1,`${I(J)}: ${G[2]}.${G[3]}`,X),this.onEventListen({type:J,id:G[1],channelName:G[2],name:G[3],arg:X});case 101:return this.logger?.logIncoming(_.byteLength,G[1],1,`${I(J)}`),this.disposeActiveRequest({type:J,id:G[1]});case 103:return this.logger?.logIncoming(_.byteLength,G[1],1,`${I(J)}`),this.disposeActiveRequest({type:J,id:G[1]})}}onPromise(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const G=new A.CancellationTokenSource;let X;try{X=j.call(this.ctx,_.name,_.arg,G.token)}catch(F){X=Promise.reject(F)}const J=_.id;X.then(F=>{this.sendResponse({id:J,data:F,type:201})},F=>{F instanceof Error?this.sendResponse({id:J,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.sendResponse({id:J,data:F,type:203})}).finally(()=>{M.dispose(),this.activeRequests.delete(_.id)});const M=(0,l.toDisposable)(()=>G.cancel());this.activeRequests.set(_.id,M)}onEventListen(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const G=_.id,J=j.listen(this.ctx,_.name,_.arg)(M=>this.sendResponse({id:G,data:M,type:204}));this.activeRequests.set(_.id,J)}disposeActiveRequest(_){const j=this.activeRequests.get(_.id);j&&(j.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let j=this.pendingRequests.get(_.channelName);j||(j=[],this.pendingRequests.set(_.channelName,j));const G=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:_,timeoutTimer:G})}flushPendingRequests(_){const j=this.pendingRequests.get(_);if(j){for(const G of j)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=b;var w;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class S{constructor(_,j=null){this.protocol=_,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=j}getChannel(_){const j=this;return{call(G,X,J){return j.isDisposed?Promise.reject(new P.CancellationError):j.requestPromise(_,G,X,J)},listen(G,X){return j.isDisposed?f.Event.None:j.requestEvent(_,G,X)}}}requestPromise(_,j,G,X=A.CancellationToken.None){const J=this.lastRequestId++,F={id:J,type:100,channelName:_,name:j,arg:G};if(X.isCancellationRequested)return Promise.reject(new P.CancellationError);let a;return new Promise((x,U)=>{if(X.isCancellationRequested)return U(new P.CancellationError);const H=()=>{const me=de=>{switch(de.type){case 201:this.handlers.delete(J),x(de.data);break;case 202:{this.handlers.delete(J);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.handlers.delete(J),U(de.data);break}};this.handlers.set(J,me),this.sendRequest(F)};let q=null;this.state===c.Idle?H():(q=(0,O.createCancelablePromise)(me=>this.whenInitialized()),q.then(()=>{q=null,H()}));const ce=()=>{q?(q.cancel(),q=null):this.sendRequest({id:J,type:101}),U(new P.CancellationError)},ae=X.onCancellationRequested(ce);a=(0,l.combinedDisposable)((0,l.toDisposable)(ce),ae),this.activeRequests.add(a)}).finally(()=>{a.dispose(),this.activeRequests.delete(a)})}requestEvent(_,j,G){const X=this.lastRequestId++,M={id:X,type:102,channelName:_,name:j,arg:G};let F=null;const a=new f.Emitter({onWillAddFirstListener:()=>{F=(0,O.createCancelablePromise)(x=>this.whenInitialized()),F.then(()=>{F=null,this.activeRequests.add(a),this.sendRequest(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.activeRequests.delete(a),this.sendRequest({id:X,type:103}))}}),m=x=>a.fire(x.data);return this.handlers.set(X,m),a.event}sendRequest(_){switch(_.type){case 100:case 102:{const j=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing(j,_.id,0,`${I(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const j=this.send([_.type,_.id]);this.logger?.logOutgoing(j,_.id,0,I(_.type));return}}}send(_,j=void 0){const G=new r;return s(G,_),s(G,j),this.sendBuffer(G.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const j=new y(_),G=u(j),X=u(j),J=G[0];switch(J){case 200:return this.logger?.logIncoming(_.byteLength,0,0,v(J)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(_.byteLength,G[1],0,v(J),X),this.onResponse({type:G[0],id:G[1],data:X})}}onResponse(_){if(_.type===200){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=S,ve([T.memoize],S.prototype,"onDidInitializePromise",null);class k{get connections(){const _=[];return this._connections.forEach(j=>_.push(j)),_}constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(_(({protocol:j,onDidClientDisconnect:G})=>{const X=f.Event.once(j.onMessage);this.disposables.add(X(J=>{const M=new y(J),F=u(M),a=new b(j,F),m=new S(j);this.channels.forEach((U,H)=>a.registerChannel(H,U));const x={channelServer:a,channelClient:m,ctx:F};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(G(()=>{a.dispose(),m.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel(_,j){const G=this;return{call(X,J,M){let F;if((0,d.isFunction)(j)){const m=(0,N.getRandomElement)(G.connections.filter(j));F=m?Promise.resolve(m):f.Event.toPromise(f.Event.filter(G.onDidAddConnection,j))}else F=j.routeCall(G,X,J);const a=F.then(m=>m.channelClient.getChannel(_));return ee(a).call(X,J,M)},listen(X,J){if((0,d.isFunction)(j))return G.getMulticastEvent(_,j,X,J);const M=j.routeEvent(G,X,J).then(F=>F.channelClient.getChannel(_));return ee(M).listen(X,J)}}}getMulticastEvent(_,j,G,X){const J=this;let M;const F=new f.Emitter({onWillAddFirstListener:()=>{M=new l.DisposableStore;const a=new f.EventMultiplexer,m=new Map,x=H=>{const ce=H.channelClient.getChannel(_).listen(G,X),ae=a.add(ce);m.set(H,ae)},U=H=>{const q=m.get(H);q&&(q.dispose(),m.delete(H))};J.connections.filter(j).forEach(x),f.Event.filter(J.onDidAddConnection,j)(x,void 0,M),J.onDidRemoveConnection(U,void 0,M),a.event(F.fire,F,M),M.add(a)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(_,j){this.channels.set(_,j);for(const G of this._connections)G.channelServer.registerChannel(_,j)}dispose(){this.disposables.dispose();for(const _ of this._connections)_.channelClient.dispose(),_.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class ${constructor(_,j,G=null){const X=new r;s(X,j),_.send(X.buffer),this.channelClient=new S(_,G),this.channelServer=new b(_,j,G)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,j){this.channelServer.registerChannel(_,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function ee(V){return{call(_,j,G){return V.then(X=>X.call(_,j,G))},listen(_,j){const G=new f.Relay;return V.then(X=>G.input=X.listen(_,j)),G.event}}}e.getDelayedChannel=ee;function Z(V){let _=!1;return{call(j,G,X){return _?V.call(j,G,X):(0,O.timeout)(0).then(()=>_=!0).then(()=>V.call(j,G,X))},listen(j,G){if(_)return V.listen(j,G);const X=new f.Relay;return(0,O.timeout)(0).then(()=>_=!0).then(()=>X.input=V.listen(j,G)),X.event}}}e.getNextTickChannel=Z;class se{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const j of _.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=se;var re;(function(V){function _(J,M,F){const a=J,m=F&&F.disableMarshalling,x=new Map;for(const U in a)G(U)&&x.set(U,f.Event.buffer(a[U],!0,void 0,M));return new class{listen(U,H,q){const ce=x.get(H);if(ce)return ce;if(X(H)){const ae=a[H];if(typeof ae=="function")return ae.call(a,q)}throw new P.ErrorNoTelemetry(`Event not found: ${H}`)}call(U,H,q){const ce=a[H];if(typeof ce=="function"){if(!m&&Array.isArray(q))for(let me=0;me<q.length;me++)q[me]=(0,D.revive)(q[me]);let ae=ce.apply(a,q);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new P.ErrorNoTelemetry(`Method not found: ${H}`)}}}V.fromService=_;function j(J,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return M?.properties?.has(m)?M.properties.get(m):X(m)?function(x){return J.listen(m,x)}:G(m)?J.listen(m):async function(...x){let U;M&&!(0,d.isUndefinedOrNull)(M.context)?U=[M.context,...x]:U=x;const H=await J.call(m,U);return F?H:(0,D.revive)(H)};throw new P.ErrorNoTelemetry(`Property not found: ${String(m)}`)}})}V.toService=j;function G(J){return J[0]==="o"&&J[1]==="n"&&C.isUpperAsciiLetter(J.charCodeAt(2))}function X(J){return/^onDynamic/.test(J)&&C.isUpperAsciiLetter(J.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function oe(V){return Array.isArray(V)?V.map(le):le(V)}function W(V,_,j,G,X,J,M){M=oe(M);const F=ue[X],a=F[G%F.length];let m=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(J)?(m=m.concat(M),m.push(")")):m.push(M),console.log.apply(console,m)}class K{constructor(_,j){this._outgoingPrefix=_,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,j,G,X,J){this._totalOutgoing+=_,W(this._outgoingPrefix,this._totalOutgoing,_,j,G,X,J)}logIncoming(_,j,G,X,J){this._totalIncoming+=_,W(this._incomingPrefix,this._totalIncoming,_,j,G,X,J)}}e.IPCLogger=K}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class I extends h.ChannelServer{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",p=>L.VSBuffer.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=I;class E{constructor(c,p){this.modulePath=c,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const R=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new O.Delayer(R),this.child=null,this._client=null}getChannel(c){const p=this;return{call(R,g,y){return p.requestPromise(c,R,g,y)},listen(R,g){return p.requestEvent(c,R,g)}}}requestPromise(c,p,R,g=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const y=this.getCachedChannel(c),r=(0,O.createCancelablePromise)(i=>y.call(p,R,i)),o=g.onCancellationRequested(()=>r.cancel()),t=(0,l.toDisposable)(()=>r.cancel());return this.activeRequests.add(t),r.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),r}requestEvent(c,p,R){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let g;const y=new f.Emitter({onWillAddFirstListener:()=>{g=this.getCachedChannel(c).listen(p,R)(y.fire,y),this.activeRequests.add(g)},onDidRemoveLastListener:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return y.event}get client(){if(!this._client){const c=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.removeDangerousEnvVariables)(p.env),this.child=(0,N.fork)(this.modulePath,c,p);const R=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}R.fire(L.VSBuffer.wrap(Buffer.from(n,"base64")))});const y=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,r=n=>this.child&&this.child.connected&&y.send(n.buffer.toString("base64")),o=R.event,t={send:r,onMessage:o};this._client=new h.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",i),this.activeRequests.forEach(u=>(0,l.dispose)(u)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(c){let p=this.channels.get(c);return p||(p=this.client.getChannel(c),this.channels.set(c,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(te[86],ne([0,1,8,4,2,46,3]),function(B,e,N,O,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(d){const h=d;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=f;var l;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(l||(e.StorageState=l={}));class D extends L.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(h,I=Object.create(null)){super(),this.database=h,this.options=I,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new N.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){this._onDidChangeStorage.pause();try{h.changed?.forEach((I,E)=>this.acceptExternal(E,I)),h.deleted?.forEach(I=>this.acceptExternal(I,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(h,I){if(this.state===l.Closed)return;let E=!1;(0,T.isUndefinedOrNull)(I)?E=this.cache.delete(h):this.cache.get(h)!==I&&(this.cache.set(h,I),E=!0),E&&this._onDidChangeStorage.fire({key:h,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,I){const E=this.cache.get(h);return(0,T.isUndefinedOrNull)(E)?I:E}getBoolean(h,I){const E=this.get(h);return(0,T.isUndefinedOrNull)(E)?I:E==="true"}getNumber(h,I){const E=this.get(h);return(0,T.isUndefinedOrNull)(E)?I:parseInt(E,10)}getObject(h,I){const E=this.get(h);return(0,T.isUndefinedOrNull)(E)?I:(0,A.parse)(E)}async set(h,I,E=!1){if(this.state===l.Closed)return;if((0,T.isUndefinedOrNull)(I))return this.delete(h,E);const v=(0,T.isObject)(I)||Array.isArray(I)?(0,A.stringify)(I):String(I);if(this.cache.get(h)!==v)return this.cache.set(h,v),this.pendingInserts.set(h,v),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire({key:h,external:E}),this.doFlush()}async delete(h,I=!1){if(!(this.state===l.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire({key:h,external:I}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(this.hasPending)return this.doFlush(h)}async doFlush(h){return this.options.hint===P.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===P.STORAGE_IN_MEMORY}}e.Storage=D;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((I,E)=>this.items.set(E,I)),h.delete?.forEach(I=>this.items.delete(I))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=C}),define(te[87],ne([7,5]),function(B,e){return B.create("vs/base/node/zip",e)}),define(te[48],ne([0,1,88,8,16,3,24,87]),function(B,e,N,O,L,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const f=new RegExp(e.CorruptZipMessage);class l extends Error{constructor(y,r){let o=r.message;switch(y){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=y,this.cause=r}}e.ExtractError=l;function D(g){const y=g.externalFileAttributes>>16||33188;return[448,56,7].map(r=>y&r).reduce((r,o)=>r+o,y&61440)}function C(g){if(g instanceof l)return g;let y;return f.test(g.message)&&(y="CorruptZip"),new l(y,g)}function d(g,y,r,o,t,i){const n=L.dirname(y),s=L.join(o,n);if(!s.startsWith(o))return Promise.reject(new Error(P.localize(0,null,y)));const u=L.join(o,y);let b;return i.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(T.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((w,S)=>{if(!i.isCancellationRequested)try{b=(0,N.createWriteStream)(u,{mode:r}),b.once("close",()=>w()),b.once("error",S),g.once("error",S),g.pipe(b)}catch(k){S(k)}}))}function h(g,y,r,o){let t=(0,O.createCancelablePromise)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{t.cancel(),g.close()});return new Promise((s,u)=>{const b=new O.Sequencer,w=S=>{S.isCancellationRequested||(i++,g.readEntry())};g.once("error",u),g.once("close",()=>t.then(()=>{o.isCancellationRequested||g.entryCount===i?s():u(new l("Incomplete",new Error(P.localize(1,null,i,g.entryCount))))},u)),g.readEntry(),g.on("entry",S=>{if(o.isCancellationRequested)return;if(!r.sourcePathRegex.test(S.fileName)){w(o);return}const k=S.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(k)){const Z=L.join(y,k);t=(0,O.createCancelablePromise)(se=>T.Promises.mkdir(Z,{recursive:!0}).then(()=>w(se)).then(void 0,u));return}const $=E(g,S),ee=D(S);t=(0,O.createCancelablePromise)(Z=>b.queue(()=>$.then(se=>d(se,k,ee,y,r,Z).then(()=>w(Z)))).then(null,u))})}).finally(()=>n.dispose())}async function I(g,y=!1){const{open:r}=await new Promise((o,t)=>{B(["yauzl"],o,t)});return new Promise((o,t)=>{r(g,y?{lazyEntries:!0}:void 0,(i,n)=>{i?t(C(i)):o((0,A.assertIsDefined)(n))})})}function E(g,y){return new Promise((r,o)=>{g.openReadStream(y,(t,i)=>{t?o(C(t)):r((0,A.assertIsDefined)(i))})})}async function v(g,y){const{ZipFile:r}=await new Promise((o,t)=>{B(["yazl"],o,t)});return new Promise((o,t)=>{const i=new r;y.forEach(s=>{s.contents?i.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&i.addFile(s.localPath,s.path)}),i.end();const n=(0,N.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",t),n.once("error",t),n.once("finish",()=>o(g))})}e.zip=v;function c(g,y,r={},o){const t=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let i=I(g,!0);return r.overwrite&&(i=i.then(n=>T.Promises.rm(y).then(()=>n))),i.then(n=>h(n,y,{sourcePathRegex:t},o))}e.extract=c;function p(g,y){return I(g).then(r=>new Promise((o,t)=>{r.on("entry",i=>{i.fileName===y&&E(r,i).then(n=>o(n),n=>t(n))}),r.once("close",()=>t(new Error(P.localize(2,null,y))))}))}function R(g,y){return p(g,y).then(r=>new Promise((o,t)=>{const i=[];r.once("error",t),r.on("data",n=>i.push(n)),r.on("end",()=>o(Buffer.concat(i)))}))}e.buffer=R}),define(te[89],ne([7,5]),function(B,e){return B.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[90],ne([7,5]),function(B,e){return B.create("vs/platform/contextkey/common/contextkey",e)}),define(te[91],ne([7,5]),function(B,e){return B.create("vs/platform/contextkey/common/scanner",e)}),define(te[92],ne([7,5]),function(B,e){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[93],ne([7,5]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[94],ne([7,5]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[95],ne([7,5]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[96],ne([7,5]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[97],ne([7,5]),function(B,e){return B.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[98],ne([7,5]),function(B,e){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[99],ne([7,5]),function(B,e){return B.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[100],ne([7,5]),function(B,e){return B.create("vs/platform/files/common/fileService",e)}),define(te[101],ne([7,5]),function(B,e){return B.create("vs/platform/files/common/io",e)}),define(te[102],ne([7,5]),function(B,e){return B.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[103],ne([7,5]),function(B,e){return B.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[104],ne([7,5]),function(B,e){return B.create("vs/platform/request/common/request",e)}),define(te[105],ne([7,5]),function(B,e){return B.create("vs/platform/shell/node/shellEnv",e)}),define(te[106],ne([7,5]),function(B,e){return B.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[107],ne([7,5]),function(B,e){return B.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[108],ne([7,5]),function(B,e){return B.create("vs/platform/workspace/common/workspace",e)}),define(te[109],ne([0,1,9,91]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...l){switch(l.length){case 1:return(0,O.localize)(0,null,l[0]);case 2:return(0,O.localize)(1,null,l[0],l[1]);case 3:return(0,O.localize)(2,null,l[0],l[1],l[2]);default:return}}const T=(0,O.localize)(3,null),P=(0,O.localize)(4,null);class f{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,N.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(D=>D.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(D){return this._input=D,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const C=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:C})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const C=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:C})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(D){return this._isAtEnd()||this._input.charCodeAt(this._current)!==D?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(D){this._tokens.push({type:D,offset:this._start})}_error(D){const C=this._start,d=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:d};this._errors.push({offset:C,lexeme:d,additionalInfo:D}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const D=this.stringRe.exec(this._input);if(D){this._current=this._start+D[0].length;const C=this._input.substring(this._start,this._current),d=f._keywords.get(C);d?this._addToken(d):this._tokens.push({type:17,lexeme:C,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let D=this._current,C=!1,d=!1;for(;;){if(D>=this._input.length){this._current=D,this._error(P);return}const I=this._input.charCodeAt(D);if(C)C=!1;else if(I===47&&!d){D++;break}else I===91?d=!0:I===92?C=!0:I===93&&(d=!1);D++}for(;D<this._input.length&&f._regexFlags.has(this._input.charCodeAt(D));)D++;this._current=D;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=f}),define(te[110],ne([0,1,76,52,15,16,35,17,11]),function(B,e,N,O,L,A,T,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.dirname)(L.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(f.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?f.URI.file((0,A.join)(h,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(L.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?f.URI.file((0,A.resolve)(h)):f.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const I=T.env.VSCODE_EXTENSIONS;if(I)return I;const E=T.env.VSCODE_PORTABLE;return E?(0,A.join)(E,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(I=>/^[^:/?#]+?:\/\//.test(I)?f.URI.parse(I):f.URI.file((0,A.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const I of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(I);E&&E[1]&&E[2]&&h.push([E[1],E[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?f.URI.file((0,A.join)(h,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,I,E){this._args=h,this.paths=I,this.productService=E,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,ve([O.memoize],l.prototype,"appRoot",null),ve([O.memoize],l.prototype,"userHome",null),ve([O.memoize],l.prototype,"userDataPath",null),ve([O.memoize],l.prototype,"appSettingsHome",null),ve([O.memoize],l.prototype,"tmpDir",null),ve([O.memoize],l.prototype,"cacheHome",null),ve([O.memoize],l.prototype,"stateResource",null),ve([O.memoize],l.prototype,"userRoamingDataHome",null),ve([O.memoize],l.prototype,"userDataSyncHome",null),ve([O.memoize],l.prototype,"sync",null),ve([O.memoize],l.prototype,"machineSettingsResource",null),ve([O.memoize],l.prototype,"workspaceStorageHome",null),ve([O.memoize],l.prototype,"localHistoryHome",null),ve([O.memoize],l.prototype,"keyboardLayoutResource",null),ve([O.memoize],l.prototype,"argvResource",null),ve([O.memoize],l.prototype,"isExtensionDevelopment",null),ve([O.memoize],l.prototype,"untitledWorkspacesHome",null),ve([O.memoize],l.prototype,"builtinExtensionsPath",null),ve([O.memoize],l.prototype,"extensionsPath",null),ve([O.memoize],l.prototype,"extensionDevelopmentLocationURI",null),ve([O.memoize],l.prototype,"extensionDevelopmentKind",null),ve([O.memoize],l.prototype,"extensionTestsLocationURI",null),ve([O.memoize],l.prototype,"debugExtensionHost",null),ve([O.memoize],l.prototype,"logLevel",null),ve([O.memoize],l.prototype,"extensionLogLevel",null),ve([O.memoize],l.prototype,"serviceMachineIdResource",null),ve([O.memoize],l.prototype,"disableTelemetry",null),ve([O.memoize],l.prototype,"disableWorkspaceTrust",null),ve([O.memoize],l.prototype,"useInMemorySecretStorage",null),ve([O.memoize],l.prototype,"policyFile",null);function D(d,h){return C(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId,d.extensionEnvironment)}e.parseExtensionHostDebugPort=D;function C(d,h,I,E,v,c){const R=Number(h||d)||(E?null:I),g=R?!!h:!1;let y;if(c)try{y=JSON.parse(c)}catch{}return{port:R,break:g,debugId:v,env:y}}e.parseDebugParams=C}),function(){"use strict";function B(e,N,O){function L(T,P){const f=A(T,P),l=[f];return e.isAbsolute(f)||l.unshift(O),e.resolve(...l)}function A(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const D=T["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(C,"AppData","Roaming")}break;case"darwin":l=e.join(N.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:L}}if(typeof define=="function")define(te[111],ne([165,33,35]),function(e,N,O){return B(e,N,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=B(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[112],ne([0,1,33,110,111]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends O.AbstractNativeEnvironmentService{constructor(l,D){super(l,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,L.getUserDataPath)(l,D.nameShort)},D)}}e.NativeEnvironmentService=A;function T(f,l){return(0,O.parseDebugParams)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.parsePtyHostDebugPort=T;function P(f,l){return(0,O.parseDebugParams)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(te[113],ne([0,1,3,95]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function L(T,P,f,l){try{A(T,P,f,l)}catch(D){T.error(D?.message??D)}return P}e.localizeManifest=L;function A(T,P,f,l){const D=(C,d,h)=>{const I=C[d];if((0,N.isString)(I)){const E=I,v=E.length;if(v>1&&E[0]==="%"&&E[v-1]==="%"){const c=E.substr(1,v-2);let p=f[c];p===void 0&&l&&(p=l[c]);const R=typeof p=="string"?p:p?.message,g=l?.[c],y=typeof g=="string"?g:g?.message;if(!R){y||T.warn(`[${P.name}]: ${(0,O.localize)(0,null,c)}`);return}if(h&&(d==="title"||d==="category")&&y&&y!==R){const r={value:R,original:y};C[d]=r}else C[d]=R}}else if((0,N.isObject)(I))for(const E in I)I.hasOwnProperty(E)&&(E==="commands"?D(I,E,!0):D(I,E,h));else if(Array.isArray(I))for(let E=0;E<I.length;E++)D(I,E,h)};for(const C in P)P.hasOwnProperty(C)&&D(P,C)}}),define(te[114],ne([0,1,48,98]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(A){return(0,N.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=L}),define(te[49],ne([0,1,17,54,99,42]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(c){return c=c.trim(),c==="*"||T.test(c)}e.isValidVersionStr=f;function l(c){if(!f(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(T);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=l;function D(c){if(!c)return null;const p=c.majorBase,R=c.majorMustEqual,g=c.minorBase;let y=c.minorMustEqual;const r=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(p===0||(y=!1),o=!1);let t=0;if(c.preRelease){const i=P.exec(c.preRelease);if(i){const[,n,s,u]=i;t=Date.UTC(Number(n),Number(s)-1,Number(u))}}return{majorBase:p,majorMustEqual:R,minorBase:g,minorMustEqual:y,patchBase:r,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:t}}e.normalizeVersion=D;function C(c,p,R){let g;typeof c=="string"?g=D(l(c)):g=c;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let r;if(typeof R=="string"?r=D(l(R)):r=R,!g||!r)return!1;const o=g.majorBase,t=g.minorBase,i=g.patchBase;let n=r.majorBase,s=r.minorBase,u=r.patchBase;const b=r.notBefore;let w=r.majorMustEqual,S=r.minorMustEqual,k=r.patchMustEqual;return r.isMinimum?o>n?!0:o<n?!1:t>s?!0:t<s||y&&y<b?!1:i>=u:(o===1&&n===0&&(!w||!S||!k)&&(n=1,s=0,u=0,w=!0,S=!1,k=!1),o<n?!1:o>n?!w:t<s?!1:t>s?!S:i<u?!1:i>u?!k:!(y&&y<b))}e.isValidVersion=C;function d(c,p,R,g,y){const r=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return r.push([O.default.Error,L.localize(0,null)]),r;if(typeof g.name!="string")return r.push([O.default.Error,L.localize(1,null,"name")]),r;if(typeof g.version!="string")return r.push([O.default.Error,L.localize(2,null,"version")]),r;if(!g.engines)return r.push([O.default.Error,L.localize(3,null,"engines")]),r;if(typeof g.engines.vscode!="string")return r.push([O.default.Error,L.localize(4,null,"engines.vscode")]),r;if(typeof g.extensionDependencies<"u"&&!v(g.extensionDependencies))return r.push([O.default.Error,L.localize(5,null,"extensionDependencies")]),r;if(typeof g.activationEvents<"u"){if(!v(g.activationEvents))return r.push([O.default.Error,L.localize(6,null,"activationEvents")]),r;if(typeof g.main>"u"&&typeof g.browser>"u")return r.push([O.default.Error,L.localize(7,null,"activationEvents","main","browser")]),r}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&r.push([O.default.Warning,L.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return r.push([O.default.Error,L.localize(9,null,"main")]),r;{const i=(0,N.joinPath)(R,g.main);(0,N.isEqualOrParent)(i,R)||r.push([O.default.Warning,L.localize(10,null,i.path,R.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return r.push([O.default.Error,L.localize(11,null,"browser")]),r;{const i=(0,N.joinPath)(R,g.browser);(0,N.isEqualOrParent)(i,R)||r.push([O.default.Warning,L.localize(12,null,i.path,R.path)])}}if(!A.valid(g.version))return r.push([O.default.Error,L.localize(13,null)]),r;const o=[];if(!h(c,p,g,y,o))for(const i of o)r.push([O.default.Error,i]);return r}e.validateExtensionManifest=d;function h(c,p,R,g,y){return g||typeof R.main>"u"&&typeof R.browser>"u"?!0:E(c,p,R.engines.vscode,y)}e.isValidExtensionVersion=h;function I(c,p,R){return c==="*"||E(p,R,c)}e.isEngineValid=I;function E(c,p,R,g=[]){const y=D(l(R));if(!y)return g.push(L.localize(14,null,R)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return g.push(L.localize(15,null,R)),!1}else if(!y.majorMustEqual)return g.push(L.localize(16,null,R)),!1;return C(c,p,y)?!0:(g.push(L.localize(17,null,c,R)),!1)}function v(c){if(!Array.isArray(c))return!1;for(let p=0,R=c.length;p<R;p++)if(typeof c[p]!="string")return!1;return!0}}),define(te[115],ne([0,1,14,28]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(A,T,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const D=(await T.readFile(A.serviceMachineIdResource)).value.toString();f=(0,O.isUUID)(D)?D:null}catch{f=null}if(!f){f=(0,O.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,N.VSBuffer.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=L}),define(te[50],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class N{constructor(L,A=[],T=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=N}),define(te[116],ne([0,1,50]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var L;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(P,f,l){f instanceof N.SyncDescriptor||(f=new N.SyncDescriptor(f,[],!!l)),O.push([P,f])}e.registerSingleton=A;function T(){return O}e.getSingletonServiceDescriptors=T}),define(te[117],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class N{constructor(A,T){this.key=A,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=N;class O{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const P=this.lookupOrInsertNode(A),f=this.lookupOrInsertNode(T);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let P=this._nodes.get(T);return P||(P=new N(T,A),this._nodes.set(T,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[T,P]of this._nodes)A.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,T]of this._nodes){const P=new Set([A]),f=this._findCycle(T,P);if(f)return f}}_findCycle(A,T){for(const[P,f]of A.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const l=this._findCycle(f,T);if(l)return l;T.delete(P)}}}e.Graph=O}),define(te[25],ne([0,1,3,11,10]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=A;function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function l(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.isConfigured=l;function D(c,p){const R=Object.create(null);for(const g in c)C(R,g,c[g],p);return R}e.toValuesTree=D;function C(c,p,R,g){const y=p.split("."),r=y.pop();let o=c;for(let t=0;t<y.length;t++){const i=y[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${p} as ${y.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[r]=R}catch{g(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=C;function d(c,p){const R=p.split(".");h(c,R)}e.removeFromValueTree=d;function h(c,p){const R=p.shift();if(p.length===0){delete c[R];return}if(Object.keys(c).indexOf(R)!==-1){const g=c[R];typeof g=="object"&&!Array.isArray(g)&&(h(g,p),Object.keys(g).length===0&&delete c[R])}}function I(c,p,R){function g(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const y=p.split("."),r=g(c,y);return typeof r>"u"?R:r}e.getConfigurationValue=I;function E(c,p,R){Object.keys(p).forEach(g=>{g!=="__proto__"&&(g in c?N.isObject(c[g])&&N.isObject(p[g])?E(c[g],p[g],R):R&&(c[g]=p[g]):c[g]=p[g])})}e.merge=E;function v(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(te[118],ne([0,1,13,29,109,10,90,9]),function(B,e,N,O,L,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",N.isMacintosh),f.set("isLinux",N.isLinux),f.set("isWindows",N.isWindows),f.set("isWeb",N.isWeb),f.set("isMacNative",N.isMacintosh&&!N.isWeb),f.set("isEdge",N.isEdge),f.set("isFirefox",N.isFirefox),f.set("isChrome",N.isChrome),f.set("isSafari",N.isSafari);function l(F,a){if(f.get(F)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(F,a)}e.setConstant=l;const D=Object.prototype.hasOwnProperty;var C;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const d={regexParsingWithErrorRecovery:!0},h=(0,T.localize)(0,null),I=(0,T.localize)(1,null),E=(0,T.localize)(2,null),v=(0,T.localize)(3,null),c=(0,T.localize)(4,null),p=(0,T.localize)(5,null),R=(0,T.localize)(6,null),g=(0,T.localize)(7,null);class y{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(a=d){this._config=a,this._scanner=new L.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(a){if(a===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:I});return}this._tokens=this._scanner.reset(a).scan(),this._current=0,this._parsingErrors=[];try{const m=this._expr();if(!this._isAtEnd()){const x=this._peek(),U=x.type===17?p:void 0;throw this._parsingErrors.push({message:c,offset:x.offset,lexeme:L.Scanner.getLexeme(x),additionalInfo:U}),y._parseError}return m}catch(m){if(m!==y._parseError)throw m;return}}_expr(){return this._or()}_or(){const a=[this._and()];for(;this._matchOne(16);){const m=this._and();a.push(m)}return a.length===1?a[0]:r.or(...a)}_and(){const a=[this._term()];for(;this._matchOne(15);){const m=this._term();a.push(m)}return a.length===1?a[0]:r.and(...a)}_term(){if(this._matchOne(2)){const a=this._peek();switch(a.type){case 11:return this._advance(),n.INSTANCE;case 12:return this._advance(),s.INSTANCE;case 0:{this._advance();const m=this._expr();return this._consume(1,v),m?.negate()}case 17:return this._advance(),$.create(a.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",a)}}return this._primary()}_primary(){const a=this._peek();switch(a.type){case 11:return this._advance(),r.true();case 12:return this._advance(),r.false();case 0:{this._advance();const m=this._expr();return this._consume(1,v),m}case 17:{const m=a.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const H=U.lexeme,q=H.lastIndexOf("/"),ce=q===H.length-1?void 0:this._removeFlagsGY(H.substring(q+1));let ae;try{ae=new RegExp(H.substring(1,q),ce)}catch{throw this._errExpectedButGot("REGEX",U)}return le.create(m,ae)}switch(U.type){case 10:case 19:{const H=[U.lexeme];this._advance();let q=this._peek(),ce=0;for(let he=0;he<U.lexeme.length;he++)U.lexeme.charCodeAt(he)===40?ce++:U.lexeme.charCodeAt(he)===41&&ce--;for(;!this._isAtEnd()&&q.type!==15&&q.type!==16;){switch(q.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let he=0;he<q.lexeme.length;he++)q.lexeme.charCodeAt(he)===40?ce++:U.lexeme.charCodeAt(he)===41&&ce--}if(ce<0)break;H.push(L.Scanner.getLexeme(q)),this._advance(),q=this._peek()}const ae=H.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this._removeFlagsGY(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this._errExpectedButGot("REGEX",U)}return r.regex(m,ge)}case 18:{const H=U.lexeme;this._advance();let q=null;if(!(0,O.isFalsyOrWhitespace)(H)){const ce=H.indexOf("/"),ae=H.lastIndexOf("/");if(ce!==ae&&ce>=0){const me=H.slice(ce+1,ae),de=H[ae+1]==="i"?"i":"";try{q=new RegExp(me,de)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(q===null)throw this._errExpectedButGot("REGEX",U);return le.create(m,q)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,E);const U=this._value();return r.notIn(m,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return r.equals(m,U);switch(U){case"true":return r.has(m);case"false":return r.not(m);default:return r.equals(m,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return r.notEquals(m,U);switch(U){case"true":return r.not(m);case"false":return r.has(m);default:return r.notEquals(m,U)}}case 5:return this._advance(),re.create(m,this._value());case 6:return this._advance(),ue.create(m,this._value());case 7:return this._advance(),Z.create(m,this._value());case 8:return this._advance(),se.create(m,this._value());case 13:return this._advance(),r.in(m,this._value());default:return r.has(m)}}case 20:throw this._parsingErrors.push({message:R,offset:a.offset,lexeme:"",additionalInfo:g}),y._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const a=this._peek();switch(a.type){case 17:case 18:return this._advance(),a.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(a){return a.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(a){return this._check(a)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(a,m){if(this._check(a))return this._advance();throw this._errExpectedButGot(m,this._peek())}_errExpectedButGot(a,m,x){const U=(0,T.localize)(8,null,a,L.Scanner.getLexeme(m)),H=m.offset,q=L.Scanner.getLexeme(m);return this._parsingErrors.push({message:U,offset:H,lexeme:q,additionalInfo:x}),y._parseError}_check(a){return this._peek().type===a}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=y;class r{static false(){return n.INSTANCE}static true(){return s.INSTANCE}static has(a){return u.create(a)}static equals(a,m){return b.create(a,m)}static notEquals(a,m){return k.create(a,m)}static regex(a,m){return le.create(a,m)}static in(a,m){return w.create(a,m)}static notIn(a,m){return S.create(a,m)}static not(a){return $.create(a)}static and(...a){return K.create(a,null,!0)}static or(...a){return V.create(a,null,!0)}static greater(a,m){return Z.create(a,m)}static greaterEquals(a,m){return se.create(a,m)}static smaller(a,m){return re.create(a,m)}static smallerEquals(a,m){return ue.create(a,m)}static{this._parser=new y({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this._parser.parse(a)}}e.ContextKeyExpr=r;function o(F){const a=new y({regexParsingWithErrorRecovery:!1});return F.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,T.localize)(9,null,x.additionalInfo):(0,T.localize)(10,null),offset:x.offset,length:x.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.validateWhenClauses=o;function t(F,a){const m=F?F.substituteConstants():void 0,x=a?a.substituteConstants():void 0;return!m&&!x?!0:!m||!x?!1:m.equals(x)}e.expressionsAreEqualWithConstantSubstitution=t;function i(F,a){return F.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return s.INSTANCE}}e.ContextKeyFalseExpr=n;class s{static{this.INSTANCE=new s}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=s;class u{static create(a,m=null){const x=f.get(a);return typeof x=="boolean"?x?s.INSTANCE:n.INSTANCE:new u(a,m)}constructor(a,m){this.key=a,this.negated=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:j(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=f.get(this.key);return typeof a=="boolean"?a?s.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.negated||(this.negated=$.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class b{static create(a,m,x=null){if(typeof m=="boolean")return m?u.create(a,x):$.create(a,x);const U=f.get(a);return typeof U=="boolean"?m===(U?"true":"false")?s.INSTANCE:n.INSTANCE:new b(a,m,x)}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:G(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){const a=f.get(this.key);if(typeof a=="boolean"){const m=a?"true":"false";return this.value===m?s.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=b;class w{static create(a,m){return new w(a,m)}constructor(a,m){this.key=a,this.valueKey=m,this.type=10,this.negated=null}cmp(a){return a.type!==this.type?this.type-a.type:G(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.valueKey),x=a.getValue(this.key);return Array.isArray(m)?m.includes(x):typeof x=="string"&&typeof m=="object"&&m!==null?D.call(m,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=w;class S{static create(a,m){return new S(a,m)}constructor(a,m){this.key=a,this.valueKey=m,this.type=11,this._negated=w.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this._negated.cmp(a._negated)}equals(a){return a.type===this.type?this._negated.equals(a._negated):!1}substituteConstants(){return this}evaluate(a){return!this._negated.evaluate(a)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(a){return a.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=S;class k{static create(a,m,x=null){if(typeof m=="boolean")return m?$.create(a,x):u.create(a,x);const U=f.get(a);return typeof U=="boolean"?m===(U?"true":"false")?n.INSTANCE:s.INSTANCE:new k(a,m,x)}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:G(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){const a=f.get(this.key);if(typeof a=="boolean"){const m=a?"true":"false";return this.value===m?n.INSTANCE:s.INSTANCE}return this}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class ${static create(a,m=null){const x=f.get(a);return typeof x=="boolean"?x?n.INSTANCE:s.INSTANCE:new $(a,m)}constructor(a,m){this.key=a,this.negated=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:j(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=f.get(this.key);return typeof a=="boolean"?a?n.INSTANCE:s.INSTANCE:this}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=$;function ee(F,a){if(typeof F=="string"){const m=parseFloat(F);isNaN(m)||(F=m)}return typeof F=="string"||typeof F=="number"?a(F):n.INSTANCE}class Z{static create(a,m,x=null){return ee(m,U=>new Z(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:G(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=Z;class se{static create(a,m,x=null){return ee(m,U=>new se(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:G(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=se;class re{static create(a,m,x=null){return ee(m,U=>new re(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:G(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=re;class ue{static create(a,m,x=null){return ee(m,U=>new ue(a,U,x))}constructor(a,m,x){this.key=a,this.value=m,this.negated=x,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:G(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}substituteConstants(){return this}evaluate(a){return typeof this.value=="string"?!1:parseFloat(a.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ue;class le{static create(a,m){return new le(a,m)}constructor(a,m){this.key=a,this.regexp=m,this.type=7,this.negated=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const m=this.regexp?this.regexp.source:"",x=a.regexp?a.regexp.source:"";return m<x?-1:m>x?1:0}equals(a){if(a.type===this.type){const m=this.regexp?this.regexp.source:"",x=a.regexp?a.regexp.source:"";return this.key===a.key&&m===x}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.key);return this.regexp?this.regexp.test(m):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=oe.create(this)),this.negated}}e.ContextKeyRegexExpr=le;class oe{static create(a){return new oe(a)}constructor(a){this._actual=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}substituteConstants(){return this}evaluate(a){return!this._actual.evaluate(a)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(a){return new oe(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=oe;function W(F){let a=null;for(let m=0,x=F.length;m<x;m++){const U=F[m].substituteConstants();if(F[m]!==U&&a===null){a=[];for(let H=0;H<m;H++)a[H]=F[H]}a!==null&&(a[m]=U)}return a===null?F:a}class K{static create(a,m,x){return K._normalizeArr(a,m,x)}constructor(a,m){this.expr=a,this.negated=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,x=this.expr.length;m<x;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,x=this.expr.length;m<x;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=W(this.expr);return a===this.expr?this:K.create(a,this.negated,!1)}evaluate(a){for(let m=0,x=this.expr.length;m<x;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static _normalizeArr(a,m,x){const U=[];let H=!1;for(const q of a)if(q){if(q.type===1){H=!0;continue}if(q.type===0)return n.INSTANCE;if(q.type===6){U.push(...q.expr);continue}U.push(q)}if(U.length===0&&H)return s.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let q=1;q<U.length;q++)U[q-1].equals(U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0];for(;U.length>1;){const q=U[U.length-1];if(q.type!==9)break;U.pop();const ce=U.pop(),ae=U.length===0,me=V.create(q.expr.map(de=>K.create([de,ce],null,x)),null,ae);me&&(U.push(me),U.sort(i))}if(U.length===1)return U[0];if(x){for(let q=0;q<U.length;q++)for(let ce=q+1;ce<U.length;ce++)if(U[q].negate().equals(U[ce]))return n.INSTANCE;if(U.length===1)return U[0]}return new K(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new K(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.negated){const a=[];for(const m of this.expr)a.push(m.negate());this.negated=V.create(a,this,!0)}return this.negated}}e.ContextKeyAndExpr=K;class V{static create(a,m,x){return V._normalizeArr(a,m,x)}constructor(a,m){this.expr=a,this.negated=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,x=this.expr.length;m<x;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,x=this.expr.length;m<x;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=W(this.expr);return a===this.expr?this:V.create(a,this.negated,!1)}evaluate(a){for(let m=0,x=this.expr.length;m<x;m++)if(this.expr[m].evaluate(a))return!0;return!1}static _normalizeArr(a,m,x){let U=[],H=!1;if(a){for(let q=0,ce=a.length;q<ce;q++){const ae=a[q];if(ae){if(ae.type===0){H=!0;continue}if(ae.type===1)return s.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&H)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let q=1;q<U.length;q++)U[q-1].equals(U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0];if(x){for(let q=0;q<U.length;q++)for(let ce=q+1;ce<U.length;ce++)if(U[q].negate().equals(U[ce]))return s.INSTANCE;if(U.length===1)return U[0]}return new V(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new V(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.negated){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),x=a.shift(),U=[];for(const H of M(m))for(const q of M(x))U.push(K.create([H,q],null,!1));a.unshift(V.create(U,null,!1))}this.negated=V.create(a,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class _ extends u{static{this._info=[]}static all(){return _._info.values()}constructor(a,m,x){super(a,null),this._defaultValue=m,typeof x=="object"?_._info.push({...x,key:a}):x!==!0&&_._info.push({key:a,description:x,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return b.create(this.key,a)}notEqualsTo(a){return k.create(this.key,a)}}e.RawContextKey=_,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function j(F,a){return F<a?-1:F>a?1:0}function G(F,a,m,x){return F<m?-1:F>m?1:a<x?-1:a>x?1:0}function X(F,a){if(F.type===0||a.type===1)return!0;if(F.type===9)return a.type===9?J(F.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(X(F,m))return!0;return!1}if(F.type===6){if(a.type===6)return J(a.expr,F.expr);for(const m of F.expr)if(X(m,a))return!0;return!1}return F.equals(a)}e.implies=X;function J(F,a){let m=0,x=0;for(;m<F.length&&x<a.length;){const U=F[m].cmp(a[x]);if(U<0)return!1;U===0&&m++,x++}return m===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(te[59],ne([0,1,10]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,N.createDecorator)("downloadService")}),define(te[18],ne([0,1,10]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,N.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,N.refineServiceDecorator)(e.IEnvironmentService)}),define(te[21],ne([0,1,93,10]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function L(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function T(c,p){switch(c){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":p==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(c,p){return p==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function f(c,p,R){return P(p,R)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===R}e.isTargetPlatformCompatible=f;function l(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=l;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var C;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var d;(function(c){c.Install="install",c.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var h;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var I;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));var E;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(E||(e.ExtensionSignaturetErrorCode=E={}));class v extends Error{constructor(p,R){super(p),this.code=R,this.name=R}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,N.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,N.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,N.createDecorator)("IExtensionSignatureVerificationService");class O{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((A,T)=>B(["node-vsce-sign"],async P=>A(P),T))),this.moduleLoadingPromise}async verify(A,T,P){let f;try{f=await this.vsceSign()}catch{return!1}return f.verify(A,T,P)}}e.ExtensionSignatureVerificationService=O}),define(te[61],ne([0,1,14,9,101,12]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(D,C,d,h,I,E){let v;try{await P(D,C,d,h,I,E)}catch(c){v=c}finally{v&&I.errorTransformer&&(v=I.errorTransformer(v)),typeof v<"u"&&d.error(v),d.end()}}e.readFileIntoStream=T;async function P(D,C,d,h,I,E){f(E);const v=await D.open(C,{create:!1});try{f(E);let c=0,p=0,R=I&&typeof I.length=="number"?I.length:void 0,g=N.VSBuffer.alloc(Math.min(I.bufferSize,typeof R=="number"?R:I.bufferSize)),y=I&&typeof I.position=="number"?I.position:0,r=0;do p=await D.read(v,y,g.buffer,r,g.byteLength-r),y+=p,r+=p,c+=p,typeof R=="number"&&(R-=p),r===g.byteLength&&(await d.write(h(g)),g=N.VSBuffer.alloc(Math.min(I.bufferSize,typeof R=="number"?R:I.bufferSize)),r=0);while(p>0&&(typeof R!="number"||R>0)&&f(E)&&l(c,I));if(r>0){let o=r;typeof R=="number"&&(o=Math.min(r,R)),d.write(h(g.slice(0,o)))}}catch(c){throw(0,A.ensureFileSystemProviderError)(c)}finally{await D.close(v)}}function f(D){if(D.isCancellationRequested)throw(0,O.canceled)();return!0}function l(D,C){if(typeof C?.limits?.size=="number"&&D>C.limits.size)throw(0,A.createFileSystemProviderError)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[119],ne([0,1,4,166,2,13,167]),function(B,e,N,O,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends L.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new N.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=N.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(l){const D=this.normalizeRequests(l),C=D.filter(h=>{const I=this.watchers.get(h.path);return I?!(0,O.patternsEquals)(I.request.excludes,h.excludes)||!(0,O.patternsEquals)(I.request.includes,h.includes):!0}),d=Array.from(this.watchers.values()).filter(({request:h})=>!D.find(I=>I.path===h.path&&(0,O.patternsEquals)(I.excludes,h.excludes)&&(0,O.patternsEquals)(I.includes,h.includes))).map(({request:h})=>h.path);C.length&&this.trace(`Request to start watching: ${C.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const h of d)this.stopWatching(h);for(const h of C)this.startWatching(h)}startWatching(l){const D=new T.NodeJSFileWatcherLibrary(l,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),C={request:l,instance:D};this.watchers.set(l.path,C)}async stop(){for(const[l]of this.watchers)this.stopWatching(l);this.watchers.clear()}stopWatching(l){const D=this.watchers.get(l);D&&(this.watchers.delete(l),D.instance.dispose())}normalizeRequests(l){const D=new Map;for(const C of l){const d=A.isLinux?C.path:C.path.toLowerCase();let h=D.get(C.correlationId);h||(h=new Map,D.set(C.correlationId,h)),h.set(d,C)}return Array.from(D.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(l){this.verboseLogging=l;for(const[,D]of this.watchers)D.instance.setVerboseLogging(l)}trace(l){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(l)})}toMessage(l,D){return D?`[File Watcher (node.js)] ${l} (path: ${D.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=P}),define(te[120],ne([0,1,62,119]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends N.AbstractNonRecursiveWatcherClient{constructor(T,P,f){super(T,P,f),this.init()}createWatcher(T){return T.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=L}),define(te[121],ne([0,1,15,57,85,62]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(f,l,D){super(f,l,D),this.init()}createWatcher(f){const l=f.add(new L.Client(N.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:D,signal:C})=>this.onError(`terminated by itself with code ${D}, signal: ${C}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(te[63],ne([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class N{constructor(...L){this._entries=new Map;for(const[A,T]of L)this.set(A,T)}set(L,A){const T=this._entries.get(L);return this._entries.set(L,A),T}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=N}),define(te[122],ne([0,1,8,9,2,50,117,10,63,168]),function(B,e,N,O,L,A,T,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class C extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class d{constructor(v=new f.ServiceCollection,c=!1,p,R=D){this._services=v,this._strict=c,this._parent=p,this._enableTracing=R,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=R?p?._globalGraph??new T.Graph(g=>g):void 0}createChild(v){return new d(v,this._strict,this,this._enableTracing)}invokeFunction(v,...c){const p=I.traceInvocation(this._enableTracing,v);let R=!1;try{return v({get:y=>{if(R)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(y,p);if(!r)throw new Error(`[invokeFunction] unknown service '${y}'`);return r}},...c)}finally{R=!0,p.stop()}}createInstance(v,...c){let p,R;return v instanceof A.SyncDescriptor?(p=I.traceCreation(this._enableTracing,v.ctor),R=this._createInstance(v.ctor,v.staticArguments.concat(c),p)):(p=I.traceCreation(this._enableTracing,v),R=this._createInstance(v,c,p)),p.stop(),R}_createInstance(v,c=[],p){const R=P._util.getServiceDependencies(v).sort((r,o)=>r.index-o.index),g=[];for(const r of R){const o=this._getOrCreateServiceInstance(r.id,p);o||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${r.id}.`,!1),g.push(o)}const y=R.length>0?R[0].index:c.length;if(c.length!==y){console.trace(`[createInstance] First service dependency of ${v.name} at position ${y+1} conflicts with ${c.length} static arguments`);const r=y-c.length;r>0?c=c.concat(new Array(r)):c=c.slice(0,y)}return Reflect.construct(v,c.concat(g))}_setServiceInstance(v,c){if(this._services.get(v)instanceof A.SyncDescriptor)this._services.set(v,c);else if(this._parent)this._parent._setServiceInstance(v,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const c=this._services.get(v);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):c}_getOrCreateServiceInstance(v,c){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const p=this._getServiceInstanceOrDescriptor(v);return p instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,p,c.branch(v,!0)):(c.branch(v,!1),p)}_safeCreateAndCacheServiceInstance(v,c,p){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,c,p)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,c,p){const R=new T.Graph(r=>r.id.toString());let g=0;const y=[{id:v,desc:c,_trace:p}];for(;y.length;){const r=y.pop();if(R.lookupOrInsertNode(r),g++>1e3)throw new C(R);for(const o of P._util.getServiceDependencies(r.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(o.id)),t instanceof A.SyncDescriptor){const i={id:o.id,desc:t,_trace:r._trace.branch(o.id,!0)};R.insertEdge(r,i),y.push(i)}}}for(;;){const r=R.roots();if(r.length===0){if(!R.isEmpty())throw new C(R);break}for(const{data:o}of r){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}R.removeNode(o)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,c,p=[],R,g){if(this._services.get(v)instanceof A.SyncDescriptor)return this._createServiceInstance(v,c,p,R,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,c,p,R,g);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(v,c,p=[],R,g){if(R){const y=new d(void 0,this._strict,this,this._enableTracing);y._globalGraphImplicitDependency=String(v);const r=new Map,o=new N.GlobalIdleValue(()=>{const t=y._createInstance(c,p,g);for(const[i,n]of r){const s=t[i];if(typeof s=="function")for(const u of n)s.apply(t,u)}return r.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let u=r.get(i);return u||(u=new l.LinkedList,r.set(i,u)),(w,S,k)=>{const $=u.push([w,S,k]);return(0,L.toDisposable)($)}}if(i in t)return t[i];const n=o.value;let s=n[i];return typeof s!="function"||(s=s.bind(n),t[i]=s),s},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return c.prototype}})}else return this._createInstance(c,p,g)}_throwIfStrict(v,c){if(c&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=d;var h;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(h||(h={}));class I{static{this.all=new Set}static{this._None=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(v,c){return v?new I(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I._None}static traceCreation(v,c){return v?new I(1,c.name):I._None}static{this._totals=0}constructor(v,c){this.type=v,this.name=c,this._start=Date.now(),this._dep=[]}branch(v,c){const p=new I(3,v.toString());return this._dep.push([v,c,p]),p}stop(){const v=Date.now()-this._start;I._totals+=v;let c=!1;function p(g,y){const r=[],o=new Array(g+1).join("	");for(const[t,i,n]of y._dep)if(i&&n){c=!0,r.push(`${o}CREATES -> ${t}`);const s=p(g+1,n);s&&r.push(s)}else r.push(`${o}uses -> ${t}`);return r.join(`
`)}const R=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(v>2||c)&&I.all.add(R.join(`
`))}}e.Trace=I});var ie=this&&this.__param||function(B,e){return function(N,O){e(N,O,B)}};define(te[64],ne([0,1,20,2,13,103,21,10]),function(B,e,N,O,L,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function f(D){return D.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=f,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let l=class extends O.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new N.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let d;try{d=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const I=d.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(v=>v.startsWith("lp-"))).map(E=>{const v=E.properties.localizedLanguages?.[0],c=f(E);return{...this.createQuickPickItem(c,v,E),extensionId:E.identifier.id,galleryExtension:E}});return I.push(this.createQuickPickItem("en","English")),I}createQuickPickItem(C,d,h){const I=d??C;let E;if(I!==C&&(E=`(${C})`),C.toLowerCase()===L.language.toLowerCase()&&(E??="",E+=(0,A.localize)(0,null)),h?.installCount){E??="";const v=h.installCount;let c;v>1e6?c=`${Math.floor(v/1e5)/10}M`:v>1e3?c=`${Math.floor(v/1e3)}K`:c=String(v),E+=` $(cloud-download) ${c}`}return{id:C,label:I,description:E}}};e.LanguagePackBaseService=l,e.LanguagePackBaseService=l=ve([ie(0,T.IExtensionGalleryService)],l)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,118,10]),function(B,e,N,O,L,A,T,P,f,l,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function h(){return new Date().toISOString()}function I(w){return(0,l.isNumber)(w)}e.isLogLevel=I;var E;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function v(w,S,k){switch(S){case E.Trace:w.trace(k);break;case E.Debug:w.debug(k);break;case E.Info:w.info(k);break;case E.Warning:w.warn(k);break;case E.Error:w.error(k);break;case E.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=v;function c(w,S=!1){let k="";for(let $=0;$<w.length;$++){let ee=w[$];if(ee instanceof Error&&(ee=(0,N.toErrorMessage)(ee,S)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}k+=($>0?" ":"")+ee}return k}class p extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(S){this.level!==S&&(this.level=S,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(S){return this.level!==E.Off&&this.level<=S}}e.AbstractLogger=p;class R extends p{constructor(S){super(),this.logAlways=S}checkLogLevel(S){return this.logAlways||super.checkLogLevel(S)}trace(S,...k){this.checkLogLevel(E.Trace)&&this.log(E.Trace,c([S,...k],!0))}debug(S,...k){this.checkLogLevel(E.Debug)&&this.log(E.Debug,c([S,...k]))}info(S,...k){this.checkLogLevel(E.Info)&&this.log(E.Info,c([S,...k]))}warn(S,...k){this.checkLogLevel(E.Warning)&&this.log(E.Warning,c([S,...k]))}error(S,...k){if(this.checkLogLevel(E.Error))if(S instanceof Error){const $=Array.prototype.slice.call(arguments);$[0]=S.stack,this.log(E.Error,c($))}else this.log(E.Error,c([S,...k]))}flush(){}}e.AbstractMessageLogger=R;class g extends p{constructor(S=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(S),this.useColors=!P.isWindows}trace(S,...k){this.checkLogLevel(E.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...k):console.log(`[main ${h()}]`,S,...k))}debug(S,...k){this.checkLogLevel(E.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...k):console.log(`[main ${h()}]`,S,...k))}info(S,...k){this.checkLogLevel(E.Info)&&(this.useColors?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...k):console.log(`[main ${h()}]`,S,...k))}warn(S,...k){this.checkLogLevel(E.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,S,...k):console.warn(`[main ${h()}]`,S,...k))}error(S,...k){this.checkLogLevel(E.Error)&&(this.useColors?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,S,...k):console.error(`[main ${h()}]`,S,...k))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class y extends p{constructor(S=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(S)}trace(S,...k){this.checkLogLevel(E.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",S,...k):console.log(S,...k))}debug(S,...k){this.checkLogLevel(E.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",S,...k):console.log(S,...k))}info(S,...k){this.checkLogLevel(E.Info)&&(this.useColors?console.log("%c INFO","color: #33f",S,...k):console.log(S,...k))}warn(S,...k){this.checkLogLevel(E.Warning)&&(this.useColors?console.log("%c WARN","color: #993",S,...k):console.log(S,...k))}error(S,...k){this.checkLogLevel(E.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",S,...k):console.error(S,...k))}dispose(){}flush(){}}e.ConsoleLogger=y;class r extends p{constructor(S,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=S,this.setLevel(k)}trace(S,...k){this.checkLogLevel(E.Trace)&&this.adapter.log(E.Trace,[this.extractMessage(S),...k])}debug(S,...k){this.checkLogLevel(E.Debug)&&this.adapter.log(E.Debug,[this.extractMessage(S),...k])}info(S,...k){this.checkLogLevel(E.Info)&&this.adapter.log(E.Info,[this.extractMessage(S),...k])}warn(S,...k){this.checkLogLevel(E.Warning)&&this.adapter.log(E.Warning,[this.extractMessage(S),...k])}error(S,...k){this.checkLogLevel(E.Error)&&this.adapter.log(E.Error,[this.extractMessage(S),...k])}extractMessage(S){return typeof S=="string"?S:(0,N.toErrorMessage)(S,this.checkLogLevel(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=r;class o extends p{constructor(S){super(),this.loggers=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const k of this.loggers)k.setLevel(S);super.setLevel(S)}trace(S,...k){for(const $ of this.loggers)$.trace(S,...k)}debug(S,...k){for(const $ of this.loggers)$.debug(S,...k)}info(S,...k){for(const $ of this.loggers)$.info(S,...k)}warn(S,...k){for(const $ of this.loggers)$.warn(S,...k)}error(S,...k){for(const $ of this.loggers)$.error(S,...k)}flush(){for(const S of this.loggers)S.flush()}dispose(){for(const S of this.loggers)S.dispose()}}e.MultiplexLogger=o;class t extends A.Disposable{constructor(S,k,$){if(super(),this.logLevel=S,this.logsHome=k,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,$)for(const ee of $)this._loggers.set(ee.resource,{logger:void 0,info:ee})}getLoggerEntry(S){return(0,l.isString)(S)?[...this._loggers.values()].find(k=>k.info.id===S):this._loggers.get(S)}getLogger(S){return this.getLoggerEntry(S)?.logger}createLogger(S,k){const $=this.toResource(S),ee=(0,l.isString)(S)?S:k?.id??(0,L.hash)($.toString()).toString(16);let Z=this._loggers.get($)?.logger;const se=k?.logLevel==="always"?E.Trace:k?.logLevel;Z||(Z=this.doCreateLogger($,se??this.getLogLevel($)??this.logLevel,{...k,id:ee}));const re={logger:Z,info:{resource:$,id:ee,logLevel:se,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(re.info),this._loggers.set($,re),Z}toResource(S){return(0,l.isString)(S)?(0,f.joinPath)(this.logsHome,`${S}.log`):S}setLogLevel(S,k){if(D.URI.isUri(S)){const $=S,ee=k,Z=this._loggers.get($);Z&&ee!==Z.info.logLevel&&(Z.info.logLevel=ee===this.logLevel?void 0:ee,Z.logger?.setLevel(ee),this._loggers.set(Z.info.resource,Z),this._onDidChangeLogLevel.fire([$,ee]))}else{this.logLevel=S;for(const[$,ee]of this._loggers.entries())this._loggers.get($)?.info.logLevel===void 0&&ee.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(S,k){const $=this.getLoggerEntry(S);$&&k!==!$.info.hidden&&($.info.hidden=!k,this._loggers.set($.info.resource,$),this._onDidChangeVisibility.fire([$.info.resource,k]))}getLogLevel(S){let k;return S&&(k=this._loggers.get(S)?.info.logLevel),k??this.logLevel}registerLogger(S){const k=this._loggers.get(S.resource);k?k.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this._loggers.set(S.resource,{info:S,logger:void 0}),this._onDidChangeLoggers.fire({added:[S],removed:[]}))}deregisterLogger(S){const k=this._loggers.get(S);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(S),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const S of this._loggers.values())yield S.info}getRegisteredLogger(S){return this._loggers.get(S)?.info}dispose(){this._loggers.forEach(S=>S.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(S){}getLevel(){return E.Info}trace(S,...k){}debug(S,...k){}info(S,...k){}warn(S,...k){}error(S,...k){}critical(S,...k){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function s(w){if(w.verbose)return E.Trace;if(typeof w.logLevel=="string"){const S=b(w.logLevel.toLowerCase());if(S!==void 0)return S}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function u(w){switch(w){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=u;function b(w){switch(w){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=b,e.CONTEXT_LOG_LEVEL=new C.RawContextKey("logLevel",u(E.Info))}),define(te[123],ne([0,1,19,8,9,4,2,16,62,6]),function(B,e,N,O,L,A,T,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends T.Disposable{constructor(d,h){super(),this.logService=d,this.options=h,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(d,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,h):this.watchNonRecursive(d,h)}watchUniversal(d,h){const I={path:this.toFilePath(d),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},E=(0,N.insert)(this.universalPathsToWatch,I);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,L.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const h of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const h of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(h)&&d.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,h){const I={path:this.toFilePath(d),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},E=(0,N.insert)(this.nonRecursivePathsToWatch,I);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,L.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,f.reviveFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(te[124],ne([0,1,19,8,14,20,4,41,65,2,47,15,125,17,45,100,12,61,6,9]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p,R){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends l.Disposable{static{g=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new T.Emitter),this._onDidUncorrelatedFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(o,t){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new l.DisposableStore;return this.provider.set(o,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const s=new v.FileChangesEvent(n,!this.isPathCaseSensitive(t));this.internalOnDidFilesChange.fire(s),s.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(s)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:o}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:t}),this.provider.delete(o),(0,l.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){t.push(i)}}),!this.provider.has(o)&&await O.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,t){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return f.Iterable.map(this.provider,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new v.FileOperationError((0,E.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const t=this.provider.get(o.scheme);if(!t){const i=new R.ErrorNoTelemetry;throw i.message=(0,E.localize)(1,null,o.toString()),i}return t}async withReadProvider(o){const t=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)||(0,v.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const t=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.doResolveFile(o,t)}catch(i){throw(0,v.toFileSystemProviderErrorCode)(i)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,E.localize)(2,null,this.resourceForError(o)),1):(0,v.ensureFileSystemProviderError)(i)}}async doResolveFile(o,t){const i=await this.withProvider(o),n=this.isPathCaseSensitive(i),s=t?.resolveTo,u=t?.resolveSingleChildDescendants,b=t?.resolveMetadata,w=await i.stat(o);let S;return this.toFileStat(i,o,w,void 0,!!b,(k,$)=>(S||(S=D.TernarySearchTree.forUris(()=>!n),S.set(o,!0),s&&S.fill(!0,s)),S.get(k.resource)||S.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&u?$===1:!1))}async toFileStat(o,t,i,n,s,u){const{providerExtUri:b}=this.getExtUri(o),w={resource:t,name:b.basename(t),isFile:(i.type&v.FileType.File)!==0,isDirectory:(i.type&v.FileType.Directory)!==0,isSymbolicLink:(i.type&v.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&v.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&v.FilePermission.Locked),etag:(0,v.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&u(w,n)){try{const S=await o.readdir(t),k=await O.Promises.settled(S.map(async([$,ee])=>{try{const Z=b.joinPath(t,$),se=s?await o.stat(Z):{type:ee};return await this.toFileStat(o,Z,se,S.length,s,u)}catch(Z){return this.logService.trace(Z),null}}));w.children=(0,N.coalesce)(k)}catch(S){this.logService.trace(S),w.children=[]}return w}return w}async resolveAll(o){return O.Promises.settled(o.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.withProvider(o),i=await t.stat(o);return this.toFileStat(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.withProvider(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.doValidateCreateFile(o,t)}catch(i){return i}return!0}async doValidateCreateFile(o,t){if(!t?.overwrite&&await this.exists(o))throw new v.FileOperationError((0,E.localize)(3,null,this.resourceForError(o)),3,t)}async createFile(o,t=L.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const n=await this.writeFile(o,t);return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,n)),n}async writeFile(o,t,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(n);let u=i;if((0,v.hasFileAtomicWriteCapability)(n)&&!u?.atomic){const b=n.enforceAtomicWriteFile?.(o);b&&(u={...i,atomic:b})}try{await this.validateWriteFile(n,o,u)||await this.mkdirp(n,s.dirname(o));let w;if((0,v.hasReadWriteCapability)(n)&&!(t instanceof L.VSBuffer))if((0,I.isReadableStream)(t)){const S=await(0,I.peekStream)(t,3);S.ended?w=L.VSBuffer.concat(S.buffer):w=S}else w=(0,I.peekReadable)(t,S=>L.VSBuffer.concat(S),3);else w=t;!(0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)&&w instanceof L.VSBuffer||(0,v.hasReadWriteCapability)(n)&&(0,v.hasFileAtomicWriteCapability)(n)&&u?.atomic?await this.doWriteUnbuffered(n,o,u,w):await this.doWriteBuffered(n,o,u,w instanceof L.VSBuffer?(0,L.bufferToReadable)(w):w),this._onDidRunOperation.fire(new v.FileOperationEvent(o,4))}catch(b){throw new v.FileOperationError((0,E.localize)(4,null,this.resourceForError(o),(0,v.ensureFileSystemProviderError)(b).toString()),(0,v.toFileOperationResult)(b),u)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,E.localize)(6,null,this.resourceForError(t)));if(!(o.capabilities&2))throw new Error((0,E.localize)(7,null,this.resourceForError(t)));if(n)throw new Error((0,E.localize)(8,null,this.resourceForError(t)))}let u;try{u=await o.stat(t)}catch{return}if(u.type&v.FileType.Directory)throw new v.FileOperationError((0,E.localize)(9,null,this.resourceForError(t)),0,i);if(this.throwIfFileIsReadonly(t,u),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==v.ETAG_DISABLED&&typeof u.mtime=="number"&&typeof u.size=="number"&&i.mtime<u.mtime&&i.etag!==(0,v.etag)({mtime:i.mtime,size:u.size}))throw new v.FileOperationError((0,E.localize)(10,null),3,i);return u}async readFile(o,t,i){const n=await this.withReadProvider(o);return t?.atomic?this.doReadFileAtomic(n,o,t,i):this.doReadFile(n,o,t,i)}async doReadFileAtomic(o,t,i,n){return new Promise((s,u)=>{this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{try{const b=await this.doReadFile(o,t,i,n);s(b)}catch(b){u(b)}})})}async doReadFile(o,t,i,n){const s=await this.doReadFileStream(o,t,{...i,preferUnbuffered:!0},n);return{...s,value:await(0,L.streamToBuffer)(s.value)}}async readFileStream(o,t,i){const n=await this.withReadProvider(o);return this.doReadFileStream(n,o,t,i)}async doReadFileStream(o,t,i,n){const s=new A.CancellationTokenSource(n);let u=i;(0,v.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(t)&&(u={...i,atomic:!0});const b=this.validateReadFile(t,u).then(S=>S,S=>{throw s.dispose(!0),S});let w;try{return typeof u?.etag=="string"&&u.etag!==v.ETAG_DISABLED&&await b,u?.atomic&&(0,v.hasFileAtomicReadCapability)(o)||!((0,v.hasOpenReadWriteCloseCapability)(o)||(0,v.hasFileReadStreamCapability)(o))||(0,v.hasReadWriteCapability)(o)&&u?.preferUnbuffered?w=this.readFileUnbuffered(o,t,u):(0,v.hasFileReadStreamCapability)(o)?w=this.readFileStreamed(o,t,s.token,u):w=this.readFileBuffered(o,t,s.token,u),w.on("end",()=>s.dispose()),w.on("error",()=>s.dispose()),{...await b,value:w}}catch(S){throw w&&await(0,I.consumeStream)(w),this.restoreReadError(S,t,u)}}restoreReadError(o,t,i){const n=(0,E.localize)(11,null,this.resourceForError(t),(0,v.ensureFileSystemProviderError)(o).toString());return o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(n,o.stat,i):o instanceof v.TooLargeFileOperationError?new v.TooLargeFileOperationError(n,o.fileOperationResult,o.size,o.options):new v.FileOperationError(n,(0,v.toFileOperationResult)(o),i)}readFileStreamed(o,t,i,n=Object.create(null)){const s=o.readFileStream(t,n,i);return(0,I.transform)(s,{data:u=>u instanceof L.VSBuffer?u:L.VSBuffer.wrap(u),error:u=>this.restoreReadError(u,t,n)},u=>L.VSBuffer.concat(u))}readFileBuffered(o,t,i,n=Object.create(null)){const s=(0,L.newWriteableBufferStream)();return(0,c.readFileIntoStream)(o,t,s,u=>u,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:u=>this.restoreReadError(u,t,n)},i),s}readFileUnbuffered(o,t,i){const n=(0,I.newWriteableStream)(s=>L.VSBuffer.concat(s));return(async()=>{try{let s;i?.atomic&&(0,v.hasFileAtomicReadCapability)(o)?s=await o.readFile(t,{atomic:!0}):s=await o.readFile(t),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.validateReadFileLimits(t,s.byteLength,i),n.end(L.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new v.FileOperationError((0,E.localize)(12,null,this.resourceForError(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==v.ETAG_DISABLED&&t.etag===i.etag)throw new v.NotModifiedSinceFileOperationError((0,E.localize)(13,null),i,t);return this.validateReadFileLimits(o,i.size,t),i}validateReadFileLimits(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new v.TooLargeFileOperationError((0,E.localize)(14,null,this.resourceForError(o)),7,t,i)}async canMove(o,t,i){return this.doCanMoveCopy(o,t,"move",i)}async canCopy(o,t,i){return this.doCanMoveCopy(o,t,"copy",i)}async doCanMoveCopy(o,t,i,n){if(o.toString()!==t.toString())try{const s=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(s,o,u,t,i,n)}catch(s){return s}return!0}async move(o,t,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),u=await this.doMoveCopy(n,o,s,t,"move",!!i),b=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,u==="move"?2:3,b)),b}async copy(o,t,i){const n=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),u=await this.doMoveCopy(n,o,s,t,"copy",!!i),b=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,u==="copy"?3:2,b)),b}async doMoveCopy(o,t,i,n,s,u){if(t.toString()===n.toString())return s;const{exists:b,isSameResourceWithDifferentPathCase:w}=await this.doValidateMoveCopy(o,t,i,n,s,u);if(b&&!w&&u&&await this.del(n,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),s==="copy"){if(o===i&&(0,v.hasFileFolderCopyCapability)(o))await o.copy(t,n,{overwrite:u});else{const S=await this.resolve(t);S.isDirectory?await this.doCopyFolder(o,S,i,n):await this.doCopyFile(o,t,i,n)}return s}else return o===i?(await o.rename(t,n,{overwrite:u}),s):(await this.doMoveCopy(o,t,i,n,"copy",u),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(o,t,i,n){if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,t,i,n);if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,t,i,n);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,t,i,n);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,t,i,n)}async doCopyFolder(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async s=>{const u=this.getExtUri(i).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),i,u):this.doCopyFile(o,s.resource,i,u)}))}async doValidateMoveCopy(o,t,i,n,s,u){let b=!1;if(o===i){const{providerExtUri:S,isPathCaseSensitive:k}=this.getExtUri(o);if(k||(b=S.isEqual(t,n)),b&&s==="copy")throw new Error((0,E.localize)(15,null,this.resourceForError(t),this.resourceForError(n)));if(!b&&S.isEqualOrParent(n,t))throw new Error((0,E.localize)(16,null,this.resourceForError(t),this.resourceForError(n)))}const w=await this.exists(n);if(w&&!b){if(!u)throw new v.FileOperationError((0,E.localize)(17,null,this.resourceForError(t),this.resourceForError(n)),4);if(o===i){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(t,n))throw new Error((0,E.localize)(18,null,this.resourceForError(t),this.resourceForError(n)))}}return{exists:w,isSameResourceWithDifferentPathCase:b}}getExtUri(o){const t=this.isPathCaseSensitive(o);return{providerExtUri:t?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,i)),i}async mkdirp(o,t){const i=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&v.FileType.Directory))throw new Error((0,E.localize)(19,null,this.resourceForError(t)));break}catch(s){if((0,v.toFileSystemProviderErrorCode)(s)!==v.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(n.basename(t)),t=n.dirname(t)}for(let s=i.length-1;s>=0;s--){t=n.joinPath(t,i[s]);try{await o.mkdir(t)}catch(u){if((0,v.toFileSystemProviderErrorCode)(u)!==v.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(o,t){try{await this.doValidateDelete(o,t)}catch(i){return i}return!0}async doValidateDelete(o,t){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,E.localize)(20,null,this.resourceForError(o)));const s=t?.atomic;if(s&&!(i.capabilities&65536))throw new Error((0,E.localize)(21,null,this.resourceForError(o)));if(n&&s)throw new Error((0,E.localize)(22,null,this.resourceForError(o)));let u;try{u=await i.stat(o)}catch{}if(u)this.throwIfFileIsReadonly(o,u);else throw new v.FileOperationError((0,E.localize)(23,null,this.resourceForError(o)),1);if(!!!t?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,E.localize)(24,null,this.resourceForError(o)))}return i}async del(o,t){const i=await this.doValidateDelete(o,t);let n=t;if((0,v.hasFileAtomicDeleteCapability)(i)&&!n?.atomic){const w=i.enforceAtomicDelete?.(o);w&&(n={...t,atomic:w})}const s=!!n?.useTrash,u=!!n?.recursive,b=n?.atomic??!1;await i.delete(o,{recursive:u,useTrash:s,atomic:b}),this._onDidRunOperation.fire(new v.FileOperationEvent(o,1))}async cloneFile(o,t){const i=await this.withProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(i===n&&this.getExtUri(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,v.hasFileCloneCapability)(i))return i.cloneFile(o,t);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t));const s=this.writeQueue.queueFor(o,this.getExtUri(i).providerExtUri);return i===n&&(0,v.hasFileFolderCopyCapability)(i)?s.queue(()=>i.copy(o,t,{overwrite:!0})):s.queue(()=>this.doCopyFile(i,o,n,t))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:g.WATCHER_CORRELATION_IDS++})}watch(o,t={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,s=()=>{n=!0};i.add((0,l.toDisposable)(()=>s())),(async()=>{try{const b=await this.doWatch(o,t);n?(0,l.dispose)(b):s=()=>(0,l.dispose)(b)}catch(b){this.logService.error(b)}})();const u=t.correlationId;if(typeof u=="number"){const b=i.add(new T.Emitter);return i.add(this.internalOnDidFilesChange.event(S=>{S.correlates(u)&&b.fire(S)})),{onDidChange:b.event,dispose:()=>i.dispose()}}return i}async doWatch(o,t){const i=await this.withProvider(o),n=(0,P.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(o),t]);let s=this.activeWatchers.get(n);return s||(s={count:0,disposable:i.watch(o,t)},this.activeWatchers.set(n,s)),s.count+=1,(0,l.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,l.dispose)(s.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,t,i,n){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{const s=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,I.isReadableStream)(n)||(0,I.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,s,n):await this.doWriteReadableBufferedQueued(o,s,n)}catch(u){throw(0,v.ensureFileSystemProviderError)(u)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,t,i){let n=0,s;if((0,I.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=L.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,t,u,u.byteLength,n,0),n+=u.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((u,b)=>{(0,I.listenStream)(s,{onData:async w=>{s.pause();try{await this.doWriteBuffer(o,t,w,w.byteLength,n,0)}catch(S){return b(S)}n+=w.byteLength,setTimeout(()=>s.resume())},onError:w=>b(w),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(o,t,i){let n=0,s;for(;(s=i.read())!==null;)await this.doWriteBuffer(o,t,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(o,t,i,n,s,u){let b=0;for(;b<n;){const w=await o.write(t,s+b,i.buffer,u+b,n-b);b+=w}}async doWriteUnbuffered(o,t,i,n){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,t,i,n))}async doWriteUnbufferedQueued(o,t,i,n){let s;n instanceof L.VSBuffer?s=n:(0,I.isReadableStream)(n)?s=await(0,L.streamToBuffer)(n):(0,I.isReadableBufferedStream)(n)?s=await(0,L.bufferedStreamToBuffer)(n):s=(0,L.readableToBuffer)(n),await o.writeFile(t,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(o,t,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,t,i,n))}async doPipeBufferedQueued(o,t,i,n){let s,u;try{s=await o.open(t,{create:!1}),u=await i.open(n,{create:!0,unlock:!1});const b=L.VSBuffer.alloc(this.BUFFER_SIZE);let w=0,S=0,k=0;do k=await o.read(s,w,b.buffer,S,b.byteLength-S),await this.doWriteBuffer(i,u,b,k,w,S),w+=k,S+=k,S===b.byteLength&&(S=0);while(k>0)}catch(b){throw(0,v.ensureFileSystemProviderError)(b)}finally{await O.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async doPipeUnbuffered(o,t,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,t,i,n))}async doPipeUnbufferedQueued(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,t,i,n){return this.writeQueue.queueFor(n,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,t,i,n))}async doPipeUnbufferedToBufferedQueued(o,t,i,n){const s=await i.open(n,{create:!0,unlock:!1});try{const u=await o.readFile(t);await this.doWriteBuffer(i,s,L.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,v.ensureFileSystemProviderError)(u)}finally{await i.close(s)}}async doPipeBufferedToUnbuffered(o,t,i,n){const s=await(0,L.streamToBuffer)(this.readFileBuffered(o,t,A.CancellationToken.None));await this.doWriteUnbuffered(i,n,void 0,s)}throwIfFileSystemIsReadonly(o,t){if(o.capabilities&2048)throw new v.FileOperationError((0,E.localize)(25,null,this.resourceForError(t)),6);return o}throwIfFileIsReadonly(o,t){if((t.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,E.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===C.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=y,e.FileService=y=g=ve([ie(0,p.ILogService)],y)}),define(te[126],ne([0,1,88,169,8,31,14,4,170,2,16,13,17,45,24,102,12,61,123,34,121,120]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(N)}catch(o){console.error(`Error enabling graceful-fs: ${(0,R.toErrorMessage)(o)}`)}})();class r extends p.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new A.ResourceMap(n=>d.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:n}=await I.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:v.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await I.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async s=>{try{let u;s.isSymbolicLink()?u=(await this.stat((0,d.joinPath)(t,s.name))).type:u=this.toType(s),n.push([s.name,u])}catch(u){this.logService.trace(u)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let n;return i?.dangling?n=v.FileType.Unknown:t.isFile()?n=v.FileType.File:t.isDirectory()?n=v.FileType.Directory:n=v.FileType.Unknown,i&&(n|=v.FileType.SymbolicLink),n}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const s=new L.Barrier;return this.resourceLocks.set(t,s),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===s&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),s.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),n=await this.createResourceLock(t));const s=this.toFilePath(t);return await I.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{n?.dispose()}}traceLock(t){r.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,n){const s=(0,h.newWriteableStream)(u=>T.VSBuffer.concat(u.map(b=>T.VSBuffer.wrap(b))).buffer);return(0,c.readFileIntoStream)(this,t,s,u=>u.buffer,{...i,bufferSize:256*1024},n),s}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,d.joinPath)((0,d.dirname)(t),`${(0,d.basename)(t)}${n.atomic.postfix}`),i,n):this.doWriteFile(t,i,n)}async canWriteFileAtomic(t){try{const i=this.toFilePath(t),{symbolicLink:n}=await I.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async doWriteFileAtomic(t,i,n,s){const u=new l.DisposableStore;try{u.add(await this.createResourceLock(t)),u.add(await this.createResourceLock(i)),await this.doWriteFile(i,n,s,!0);try{await this.rename(i,t,{overwrite:!0})}catch(b){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{u.dispose()}}async doWriteFile(t,i,n,s){let u;try{const b=this.toFilePath(t);if(!n.create||!n.overwrite){if(await I.Promises.exists(b)){if(!n.overwrite)throw(0,v.createFileSystemProviderError)((0,E.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,v.createFileSystemProviderError)((0,E.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:n.unlock},s),await this.write(u,0,i,0,i.byteLength)}catch(b){throw await this.toFileSystemProviderWriteError(t,b)}finally{typeof u=="number"&&await this.close(u)}}static{this.canFlush=!0}static configureFlushOnWrite(t){r.canFlush=t}async open(t,i,n){const s=this.toFilePath(t);let u;(0,v.isFileOpenForWriteOptions)(i)&&!n&&(u=await this.createResourceLock(t));let b;try{if((0,v.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await I.SymlinkSupport.stat(s);S.mode&128||await I.Promises.chmod(s,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}let w;if((0,v.isFileOpenForWriteOptions)(i)){if(C.isWindows)try{await I.Promises.truncate(s,0),w="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}w||(w="w")}else w="r";b=await I.Promises.open(s,w)}catch(w){throw u?.dispose(),(0,v.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,w):this.toFileSystemProviderError(w)}if(this.mapHandleToPos.set(b,0),(0,v.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(b,t),u){const w=this.mapHandleToLock.get(b);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${s})`),this.mapHandleToLock.set(b,u),w&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${s})`),w.dispose())}return b}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&r.canFlush)try{await I.Promises.fdatasync(t)}catch(n){r.configureFlushOnWrite(!1),this.logService.error(n)}return await I.Promises.close(t)}catch(n){throw this.toFileSystemProviderError(n)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,s,u){const b=this.normalizePos(t,i);let w=null;try{w=(await I.Promises.read(t,n,s,u,b)).bytesRead}catch(S){throw this.toFileSystemProviderError(S)}finally{this.updatePos(t,b,w)}return w}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,n){const s=this.mapHandleToPos.get(t);typeof s=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(t,s+n):this.mapHandleToPos.delete(t)))}async write(t,i,n,s,u){return(0,L.retry)(()=>this.doWrite(t,i,n,s,u),100,3)}async doWrite(t,i,n,s,u){const b=this.normalizePos(t,i);let w=null;try{w=(await I.Promises.write(t,n,s,u,b)).bytesWritten}catch(S){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),S)}finally{this.updatePos(t,b,w)}return w}async mkdir(t){try{await I.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const n=this.toFilePath(t);if(i.recursive){let s;i?.atomic!==!1&&i.atomic.postfix&&(s=(0,D.join)((0,D.dirname)(n),`${(0,D.basename)(n)}${i.atomic.postfix}`)),await I.Promises.rm(n,I.RimRafMode.MOVE,s)}else try{await I.Promises.unlink(n)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let u=!1;try{const{stat:b,symbolicLink:w}=await I.SymlinkSupport.stat(n);u=b.isDirectory()&&!w}catch{}if(u)await I.Promises.rmdir(n);else throw s}else throw s}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(t,i,n){const s=this.toFilePath(t),u=this.toFilePath(i);if(s!==u)try{await this.validateMoveCopy(t,i,"move",n.overwrite),await I.Promises.rename(s,u)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,E.localize)(2,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(u)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(t,i,n){const s=this.toFilePath(t),u=this.toFilePath(i);if(s!==u)try{await this.validateMoveCopy(t,i,"copy",n.overwrite),await I.Promises.copy(s,u,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,E.localize)(3,null,(0,D.basename)(s),(0,D.basename)((0,D.dirname)(u)),b.toString()))),this.toFileSystemProviderError(b)}}async validateMoveCopy(t,i,n,s){const u=this.toFilePath(t),b=this.toFilePath(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,f.isEqual)(u,b,!0)),w){if(n==="copy")throw(0,v.createFileSystemProviderError)((0,E.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const k=await this.statIgnoreError(t);if(!k)throw(0,v.createFileSystemProviderError)((0,E.localize)(5,null),v.FileSystemProviderErrorCode.FileNotFound);const $=await this.statIgnoreError(i);if($){if(!s)throw(0,v.createFileSystemProviderError)((0,E.localize)(6,null),v.FileSystemProviderErrorCode.FileExists);k.type&v.FileType.File&&$.type&v.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,n){const s=this.toFilePath(t),u=this.toFilePath(i),b=!!(this.capabilities&1024);if((0,f.isEqual)(s,u,!b))return;const w=new l.DisposableStore;try{w.add(await this.createResourceLock(t)),w.add(await this.createResourceLock(i)),n&&await I.Promises.mkdir((0,D.dirname)(u),{recursive:!0}),await I.Promises.copyFile(s,u)}catch(S){if(S.code==="ENOENT"&&!n)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(S)}finally{w.dispose()}}createUniversalWatcher(t,i,n){return new g.UniversalWatcherClient(s=>t(s),s=>i(s),n)}createNonRecursiveWatcher(t,i,n){return new y.NodeJSWatcherClient(s=>t(s),s=>i(s),n)}toFileSystemProviderError(t){if(t instanceof v.FileSystemProviderError)return t;let i=t,n;switch(t.code){case"ENOENT":n=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=v.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=v.FileSystemProviderErrorCode.Unknown;break;default:n=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(t,i){let n=this.toFileSystemProviderError(i);if(t&&n.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await I.SymlinkSupport.stat(this.toFilePath(t));s.mode&128||(n=(0,v.createFileSystemProviderError)(i,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return n}}e.DiskFileSystemProvider=r}),define(te[127],ne([0,1,2,6]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class L extends N.Disposable{constructor(T,P=[]){super(),this.logger=new O.MultiplexLogger([T,...P]),this._register(T.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}flush(){this.logger.flush()}}e.LogService=L}),define(te[128],ne([0,1,12,6]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var L;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(L||(L={}));async function A(l,D,C,d,h){try{const I=await new Promise((v,c)=>{B(["@vscode/spdlog"],v,c)});I.setFlushOn(L.Trace);const E=await I.createAsyncRotatingLogger(l,D,C,d);return h?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(I){console.error(I)}return null}function T(l,D,C){switch(D){case O.LogLevel.Trace:l.trace(C);break;case O.LogLevel.Debug:l.debug(C);break;case O.LogLevel.Info:l.info(C);break;case O.LogLevel.Warning:l.warn(C);break;case O.LogLevel.Error:l.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function P(l,D){switch(D){case O.LogLevel.Trace:l.setLevel(L.Trace);break;case O.LogLevel.Debug:l.setLevel(L.Debug);break;case O.LogLevel.Info:l.setLevel(L.Info);break;case O.LogLevel.Warning:l.setLevel(L.Warning);break;case O.LogLevel.Error:l.setLevel(L.Error);break;case O.LogLevel.Off:l.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class f extends O.AbstractMessageLogger{constructor(D,C,d,h,I){super(),this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(D,C,d,h),this._register(this.onDidChangeLogLevel(E=>{this._logger&&P(this._logger,E)}))}async _createSpdLogLogger(D,C,d,h){const I=d?6:1,E=30/I*N.ByteSize.MB,v=await A(D,C,E,I,h);if(v){this._logger=v,P(this._logger,this.getLevel());for(const{level:c,message:p}of this.buffer)T(this._logger,c,p);this.buffer=[]}}log(D,C){this._logger?T(this._logger,D,C):this.getLevel()<=D&&this.buffer.push({level:D,message:C})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=f}),define(te[129],ne([0,1,28,6,128]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends O.AbstractLoggerService{doCreateLogger(P,f,l){return new L.SpdLogLogger((0,N.generateUuid)(),P.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.LoggerService=A}),define(te[38],ne([0,1,4,65,2,10]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class T extends L.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),O.Iterable.reduce(this.policies.entries(),(C,[d,h])=>({...C,[d]:h}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[D,C])=>({...l,[D]:{definition:C,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=T;class P{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(te[130],ne([0,1,8,4,65,3,12,6,38]),function(B,e,N,O,L,A,T,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(C,d){const h=[];for(const I of new Set(L.Iterable.concat(C.keys(),d.keys())))C.get(I)!==d.get(I)&&h.push(I);return h}let D=class extends f.AbstractPolicyService{constructor(d,h,I){super(),this.file=d,this.fileService=h,this.logService=I,this.throttledDelayer=this._register(new N.ThrottledDelayer(500));const E=O.Event.filter(h.onDidFilesChange,v=>v.affects(d));this._register(h.watch(d)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const d=new Map;try{const h=await this.fileService.readFile(this.file),I=JSON.parse(h.value.toString());if(!(0,A.isObject)(I))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(I))this.policyDefinitions[E]&&d.set(E,I[E])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return d}async refresh(){const d=await this.read(),h=l(this.policies,d);this.policies=d,h.length>0&&this._onDidChange.fire(h)}};e.FilePolicyService=D,e.FilePolicyService=D=ve([ie(1,T.IFileService),ie(2,P.ILogService)],D)}),define(te[131],ne([0,1,38,8,2,6]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let T=class extends N.AbstractPolicyService{constructor(f,l){super(),this.logService=f,this.productName=l,this.throttler=new O.Throttler,this.watcher=this._register(new L.MutableDisposable)}async _updatePolicyDefinitions(f){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:l}=await new Promise((D,C)=>{B(["@vscode/policy-watcher"],D,C)});await this.throttler.queue(()=>new Promise((D,C)=>{try{this.watcher.value=l(this.productName,f,d=>{this._onDidPolicyChange(d),D()})}catch(d){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),C(d)}}))}_onDidPolicyChange(f){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const l in f){const D=f[l];D===void 0?this.policies.delete(l):this.policies.set(l,D)}this._onDidChange.fire(Object.keys(f))}};e.NativePolicyService=T,e.NativePolicyService=T=ve([ie(0,A.ILogService)],T)}),define(te[32],ne([0,1,10]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,N.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(T,P){N.ok(O.isString(T)),N.ok(O.isObject(P)),N.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new L}),define(te[132],ne([0,1,4,36]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new N.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,l){this.schemasById[L(f)]=l,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;O.Registry.add(e.Extensions.JSONContribution,T)}),define(te[43],ne([0,1,19,4,3,89,25,132,36]),function(B,e,N,O,L,A,T,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=f.Registry.as(P.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,o=!0){this.registerConfigurations([r],o)}registerConfigurations(r,o=!0){const t=new Set;this.doRegisterConfigurations(r,o,t),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(r){const o=new Set;this.doDeregisterConfigurations(r,o),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:r,remove:o}){const t=new Set;this.doDeregisterConfigurations(o,t),this.doRegisterConfigurations(r,!1,t),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(r){const o=new Set;this.doRegisterDefaultConfigurations(r,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(r,o){const t=[];for(const{overrides:i,source:n}of r)for(const s in i)if(o.add(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const u=this.configurationDefaultsOverrides.get(s),b=u?.valuesSources??new Map;if(n)for(const $ of Object.keys(i[s]))b.set($,n);const w={...u?.value||{},...i[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:w,valuesSources:b});const S=(0,T.getLanguageTagSettingPlainKey)(s),k={type:"object",default:w,description:A.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:L.isString(n)?void 0:n,defaultValueSource:n};t.push(...E(s)),this.configurationProperties[s]=k,this.defaultLanguageConfigurationOverridesNode.properties[s]=k}else{this.configurationDefaultsOverrides.set(s,{value:i[s],source:n});const u=this.configurationProperties[s];u&&(this.updatePropertyDefaultValue(s,u),this.updateSchema(s,u))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(r){const o=new Set;this.doDeregisterDefaultConfigurations(r,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(r,o){for(const{overrides:t,source:i}of r)for(const n in t){const s=this.configurationDefaultsOverrides.get(n),u=L.isString(i)?i:i?.id,b=L.isString(s?.source)?s?.source:s?.source?.id;if(u===b)if(o.add(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const w=this.configurationProperties[n];w&&(this.updatePropertyDefaultValue(n,w),this.updateSchema(n,w))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(r){let o=!1;const t=new Set;r.removedDefaults&&(this.doDeregisterDefaultConfigurations(r.removedDefaults,t),o=!0),r.addedDefaults&&(this.doRegisterDefaultConfigurations(r.addedDefaults,t),o=!0),r.removedConfigurations&&this.doDeregisterConfigurations(r.removedConfigurations,t),r.addedConfigurations&&this.doRegisterConfigurations(r.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){this.doRegisterOverrideIdentifiers(r),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(r){for(const o of r)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,o,t){r.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(r,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const s=this.configurationProperties[n];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of r){t(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}}validateAndRegisterProperties(r,o=!0,t,i,n=3,s){n=L.isUndefinedOrNull(r.scope)?n:r.scope;const u=r.properties;if(u)for(const w in u){const S=u[w];if(o&&R(w,S)){delete u[w];continue}if(S.source=t,S.defaultDefaultValue=u[w].default,this.updatePropertyDefaultValue(w,S),e.OVERRIDE_PROPERTY_REGEX.test(w)?S.scope=void 0:(S.scope=L.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=L.isUndefinedOrNull(S.restricted)?!!i?.includes(w):S.restricted),u[w].hasOwnProperty("included")&&!u[w].included){this.excludedConfigurationProperties[w]=u[w],delete u[w];continue}else this.configurationProperties[w]=u[w],u[w].policy?.name&&this.policyConfigurations.set(u[w].policy.name,w);!u[w].deprecationMessage&&u[w].markdownDeprecationMessage&&(u[w].deprecationMessage=u[w].markdownDeprecationMessage),s.add(w)}const b=r.allOf;if(b)for(const w of b)this.validateAndRegisterProperties(w,o,t,i,n,s)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const o=t=>{const i=t.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);t.allOf?.forEach(o)};o(r)}updateSchema(r,o){switch(e.allSettings.properties[r]=o,o.scope){case 1:e.applicationSettings.properties[r]=o;break;case 2:e.machineSettings.properties[r]=o;break;case 6:e.machineOverridableSettings.properties[r]=o;break;case 3:e.windowSettings.properties[r]=o;break;case 4:e.resourceSettings.properties[r]=o;break;case 5:e.resourceSettings.properties[r]=o,this.resourceLanguageSettingsSchema.properties[r]=o;break}}removeFromSchema(r,o){switch(delete e.allSettings.properties[r],o.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const o=`[${r}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}}registerOverridePropertyPatternKey(){const r={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,o){const t=this.configurationDefaultsOverrides.get(r);let i=t?.value,n=t?.source;L.isUndefined(i)&&(i=o.defaultDefaultValue,n=void 0),L.isUndefined(i)&&(i=c(o.type)),o.default=i,o.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",I=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(y){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(y)){let o=I.exec(y);for(;o?.length;){const t=o[1].trim();t&&r.push(t),o=I.exec(y)}}return(0,N.distinct)(r)}e.overrideIdentifiersFromKey=E;function v(y){return y.reduce((r,o)=>`${r}[${o}]`,"")}e.keyFromOverrideIdentifiers=v;function c(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const p=new d;f.Registry.add(e.Extensions.Configuration,p);function R(y,r){return y.trim()?e.OVERRIDE_PROPERTY_REGEX.test(y)?A.localize(7,null,y):p.getConfigurationProperties()[y]!==void 0?A.localize(8,null,y):r.policy?.name&&p.getPolicyConfigurations().get(r.policy?.name)!==void 0?A.localize(9,null,y,r.policy?.name,p.getPolicyConfigurations().get(r.policy?.name)):null:A.localize(6,null)}e.validateProperty=R;function g(){const y=[],r=p.getConfigurationProperties();for(const o of Object.keys(r))y.push([o,r[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=g}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(B,e,N,O,L,A,T,P,f,l,D,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(o){return Object.isFrozen(o)?o:P.deepFreeze(o)}class I{constructor(t={},i=[],n=[],s){this._contents=t,this._keys=i,this._overrides=n,this.raw=s,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof I)return i;const n=new E("");return n.parseRaw(i),n.configurationModel});this._rawConfiguration=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,D.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),s=i?this.rawConfiguration.getOverrideValue(t,i):void 0,u=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:s,merged:u}}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,D.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return N.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return N.distinct(t)}override(t){let i=this.overrideConfigurations.get(t);return i||(i=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,i)),i}merge(...t){const i=P.deepClone(this.contents),n=P.deepClone(this.overrides),s=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const b of t)if(u.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.mergeContents(i,b.contents);for(const w of b.overrides){const[S]=n.filter(k=>N.equals(k.identifiers,w.identifiers));S?(this.mergeContents(S.contents,w.contents),S.keys.push(...w.keys),S.keys=N.distinct(S.keys)):n.push(P.deepClone(w))}for(const w of b.keys)s.indexOf(w)===-1&&s.push(w)}return new I(i,s,n,u.every(b=>b instanceof I)?void 0:u)}createOverrideConfigurationModel(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const s of N.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[s];const b=i[s];b&&(typeof u=="object"&&typeof b=="object"?(u=P.deepClone(u),this.mergeContents(u,b)):u=b),n[s]=u}return new I(n,this.keys,this.overrides)}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&f.isObject(t[n])&&f.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=P.deepClone(i[n])}}getContentsForOverrideIdentifer(t){let i=null,n=null;const s=u=>{u&&(n?this.mergeContents(n,u):n=P.deepClone(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?i=u.contents:u.identifiers.includes(t)&&s(u.contents);return s(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.updateValue(t,i,!0)}setValue(t,i){this.updateValue(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,D.removeFromValueTree)(this.contents,t),C.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>N.equals(n.identifiers,(0,C.overrideIdentifiersFromKey)(t))),1))}updateValue(t,i,n){(0,D.addToValueTree)(this.contents,t,i,s=>console.error(s)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),C.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,C.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,D.toValuesTree)(this.contents[t],s=>console.error(s))})}}e.ConfigurationModel=I;class E{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!f.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:s,overrides:u,restricted:b,hasExcludedProperties:w}=this.doParseRaw(t,i);this._configurationModel=new I(n,s,u,w?[t]:void 0),this._restrictedConfigurations=b||[]}doParseContent(t){let i={},n=null,s=[];const u=[],b=[];function w(k){Array.isArray(s)?s.push(k):n!==null&&(s[n]=k)}const S={onObjectBegin:()=>{const k={};w(k),u.push(s),s=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const k=[];w(k),u.push(s),s=k,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:w,onError:(k,$,ee)=>{b.push({error:k,offset:$,length:ee})}};if(t)try{L.visit(t,S),i=s[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return i}doParseRaw(t,i){const n=d.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,n,!0,i);t=s.raw;const u=(0,D.toValuesTree)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),b=Object.keys(t),w=this.toOverrides(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:u,keys:b,overrides:w,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(t,i,n,s){let u=!1;if(!s?.scopes&&!s?.skipRestricted&&!s?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const b={},w=[];for(const S in t)if(C.OVERRIDE_PROPERTY_REGEX.test(S)&&n){const k=this.filter(t[S],i,!1,s);b[S]=k.raw,u=u||k.hasExcludedProperties,w.push(...k.restricted)}else{const k=i[S],$=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&w.push(S),!s.exclude?.includes(S)&&(s.include?.includes(S)||($===void 0||s.scopes===void 0||s.scopes.includes($))&&!(s.skipRestricted&&k?.restricted))?b[S]=t[S]:u=!0}return{raw:b,restricted:w,hasExcludedProperties:u}}toOverrides(t,i){const n=[];for(const s of Object.keys(t))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const u={};for(const b in t[s])u[b]=t[s][b];n.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(u),contents:(0,D.toValuesTree)(u,i)})}return n}}e.ConfigurationModelParser=E;class v extends A.Disposable{constructor(t,i,n,s){super(),this.userSettingsResource=t,this.parseOptions=i,this.fileService=s,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&n.isEqual(u.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class c{constructor(t,i,n,s,u,b,w,S,k,$,ee,Z,se){this.key=t,this.overrides=i,this._value=n,this.overrideIdentifiers=s,this.defaultConfiguration=u,this.policyConfiguration=b,this.applicationConfiguration=w,this.userConfiguration=S,this.localUserConfiguration=k,this.remoteUserConfiguration=$,this.workspaceConfiguration=ee,this.folderConfigurationModel=Z,this.memoryConfigurationModel=se}get value(){return h(this._value)}inspect(t,i,n){const s=t.inspect(i,n);return{get value(){return h(s.value)},get override(){return h(s.override)},get merged(){return h(s.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class p{constructor(t,i,n,s,u=new I,b=new I,w=new T.ResourceMap,S=new I,k=new T.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=s,this._remoteUserConfiguration=u,this._workspaceConfiguration=b,this._folderConfigurations=w,this._memoryConfiguration=S,this._memoryConfigurationByResource=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidatedConfigurationModel(t,i,n).getValue(t)}updateValue(t,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new I,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(t):s.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const s=this.getConsolidatedConfigurationModel(t,i,n),u=this.getFolderConfigurationModelForResource(i.resource,n),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=new Set;for(const S of s.overrides)for(const k of S.identifiers)s.getOverrideValue(t,k)!==void 0&&w.add(k);return new c(t,i,s.getValue(t),w.size?[...w]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this._workspaceConfiguration:void 0,u||void 0,b)}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:s,updated:u,removed:b}=y(this._defaultConfiguration,t);i=[...s,...u,...b]}for(const s of i)for(const u of(0,C.overrideIdentifiersFromKey)(s)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(u),w=t.getKeysForOverrideIdentifier(u),S=[...w.filter(k=>b.indexOf(k)===-1),...b.filter(k=>w.indexOf(k)===-1),...b.filter(k=>!P.equals(this._defaultConfiguration.override(u).getValue(k),t.override(u).getValue(k)))];n.push([u,S])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:s}=y(this._policyConfiguration,t),u=[...i,...n,...s];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:s,overrides:u}=y(this.applicationConfiguration,t),b=[...i,...n,...s];return b.length&&this.updateApplicationConfiguration(t),{keys:b,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:s,overrides:u}=y(this.localUserConfiguration,t),b=[...i,...n,...s];return b.length&&this.updateLocalUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:s,overrides:u}=y(this.remoteUserConfiguration,t),b=[...i,...n,...s];return b.length&&this.updateRemoteUserConfiguration(t),{keys:b,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:s,overrides:u}=y(this.workspaceConfiguration,t),b=[...i,...n,...s];return b.length&&this.updateWorkspaceConfiguration(t),{keys:b,overrides:u}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:s,updated:u,removed:b,overrides:w}=y(n,i),S=[...s,...u,...b];return(S.length||!n)&&this.updateFolderConfiguration(t,i),{keys:S,overrides:w}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:s,removed:u,overrides:b}=y(i,void 0);return{keys:[...n,...s,...u],overrides:b}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,i,n){let s=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const s=i.getFolder(t);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const u=this._memoryConfigurationByResource.get(t);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(i=n.merge(s),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:s,keys:u}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this._workspaceConfiguration.keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.policy),s=this.parseConfigurationModel(t.application),u=this.parseConfigurationModel(t.user),b=this.parseConfigurationModel(t.workspace),w=t.folders.reduce((S,k)=>(S.set(l.URI.revive(k[0]),this.parseConfigurationModel(k[1])),S),new T.ResourceMap);return new p(i,n,s,u,new I,b,w,new I,new T.ResourceMap)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides)}}e.Configuration=p;function R(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const s of o)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,b])=>{const w=(0,T.getOrSet)(i,u,new Set);b.forEach(S=>w.add(S))});const n=[];return i.forEach((s,u)=>n.push([u,[...s.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=R;class g{constructor(t,i,n,s){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const u of t.keys)this.affectedKeys.add(u);for(const[,u]of t.overrides)for(const b of u)this.affectedKeys.add(b);this._affectsConfigStr=this._marker;for(const u of this.affectedKeys)this._affectsConfigStr+=u+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){const n=this._marker+t,s=this._affectsConfigStr.indexOf(n);if(s<0)return!1;const u=s+n.length;if(u>=this._affectsConfigStr.length)return!1;const b=this._affectsConfigStr.charCodeAt(u);if(b!==this._markerCode1&&b!==this._markerCode2)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.previous?.workspace):void 0,S=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!P.equals(w,S)}return!0}}e.ConfigurationChangeEvent=g;function y(o,t){const{added:i,removed:n,updated:s}=r(t?.rawConfiguration,o?.rawConfiguration),u=[],b=o?.getAllOverrideIdentifiers()||[],w=t?.getAllOverrideIdentifiers()||[];if(t){const S=w.filter(k=>!b.includes(k));for(const k of S)u.push([k,t.getKeysForOverrideIdentifier(k)])}if(o){const S=b.filter(k=>!w.includes(k));for(const k of S)u.push([k,o.getKeysForOverrideIdentifier(k)])}if(t&&o){for(const S of b)if(w.includes(S)){const k=r({contents:o.getOverrideValue(void 0,S)||{},keys:o.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});u.push([S,[...k.added,...k.removed,...k.updated]])}}return{added:i,removed:n,updated:s,overrides:u}}function r(o,t){const i=o?t?o.keys.filter(u=>t.keys.indexOf(u)===-1):[...o.keys]:[],n=t?o?t.keys.filter(u=>o.keys.indexOf(u)===-1):[...t.keys]:[],s=[];if(o&&t){for(const u of t.keys)if(o.keys.indexOf(u)!==-1){const b=(0,D.getConfigurationValue)(t.contents,u),w=(0,D.getConfigurationValue)(o.contents,u);P.equals(b,w)||s.push(u)}}return{added:i,removed:n,updated:s}}}),define(te[133],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(B,e,N,O,L,A,T,P,f,l,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends L.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(C.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:c})=>this.onDidUpdateConfiguration(Array.from(v),c))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(v,c){this.updateConfigurationModel(v,C.Registry.as(f.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new P.ConfigurationModel;const v=C.Registry.as(f.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(v),v)}updateConfigurationModel(v,c){const p=this.getConfigurationDefaultOverrides();for(const R of v){const g=p[R],y=c[R];g!==void 0?this._configurationModel.addValue(R,g):y?this._configurationModel.addValue(R,y.default):this._configurationModel.removeValue(R)}}}e.DefaultConfiguration=d;class h{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let I=class extends L.Disposable{get configurationModel(){return this._configurationModel}constructor(v,c,p){super(),this.defaultConfiguration=v,this.policyService=c,this.logService=p,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.updatePolicyDefinitions(v),!0))),this._configurationModel}async updatePolicyDefinitions(v){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",v);const c={},p=[],R=C.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const g of v){const y=R[g];if(!y){p.push(g);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.logService.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}p.push(g),c[y.policy.name]={type:y.type}}}return(0,T.isEmptyObject)(c)||await this.policyService.updatePolicyDefinitions(c),p}onDidChangePolicies(v){this.logService.trace("PolicyConfiguration#onDidChangePolicies",v);const c=C.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),p=(0,N.coalesce)(v.map(R=>c.get(R)));this.update(p,!0)}update(v,c){this.logService.trace("PolicyConfiguration#update",v);const p=C.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),R=[],g=this._configurationModel.isEmpty();for(const y of v){const r=p[y]?.policy?.name;if(r){const o=this.policyService.getPolicyValue(r);(g?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(y),o))&&R.push([y,o])}else this._configurationModel.getValue(y)!==void 0&&R.push([y,void 0])}if(R.length){this.logService.trace("PolicyConfiguration#changed",R);const y=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const r of y.keys)this._configurationModel.setValue(r,y.getValue(r));for(const[r,o]of R)o===void 0?this._configurationModel.removeValue(r):this._configurationModel.setValue(r,o);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=I,e.PolicyConfiguration=I=ve([ie(1,D.IPolicyService),ie(2,l.ILogService)],I)}),define(te[134],ne([0,1,8,4,2,17,25,66,133,38]),function(B,e,N,O,L,A,T,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends L.Disposable{constructor(d,h,I,E){super(),this.settingsResource=d,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration),this.policyConfiguration=I instanceof l.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,I,E)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,{},A.extUriBiasedIgnorePathCase,h)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new N.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:c})=>this.onDidDefaultConfigurationChange(v,c))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[d,h,I]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(d,h,new P.ConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(d,h){const I=typeof d=="string"?d:void 0,E=(0,T.isConfigurationOverrides)(d)?d:(0,T.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(I,E,void 0)}updateValue(d,h,I,E){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const h=this.configuration.toData(),I=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(I,h,2)}onDidDefaultConfigurationChange(d,h){const I=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(d,h);this.trigger(E,I,7)}onDidPolicyConfigurationChange(d){const h=this.configuration.toData(),I=this.configuration.compareAndUpdatePolicyConfiguration(d);this.trigger(I,h,7)}trigger(d,h,I){const E=new P.ConfigurationChangeEvent(d,{data:h},this.configuration);E.source=I,E.sourceConfig=this.getTargetConfiguration(I),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(d){switch(d){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(te[67],ne([0,1,15]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(l){return l.scheme===N.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=O;function L(l){if(!l)return;const D=l.indexOf("+");return D<0?l:l.substr(0,D)}e.getRemoteName=L;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=A;function T(l){const{host:D,port:C}=f(l);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:C}}e.parseAuthorityWithPort=T;function P(l,D){let{host:C,port:d}=f(l);return typeof d>"u"&&(d=D),{host:C,port:d}}e.parseAuthorityWithOptionalPort=P;function f(l){const D=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const C=l.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const d=l.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:l,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(T||(e.ExtensionType=T={}));var P;(function(E){E.WIN32_X64="win32-x64",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.LINUX_PPC64LE="linux-ppc64le",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,c){if(typeof v>"u"||v===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof v=="string"||typeof c=="string"){const p=typeof v=="string"?v:v.value,R=typeof c=="string"?c:c.value;return N.equalsIgnoreCase(p,R)}return v._lower===c._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=f;class l{get size(){return this._set.size}constructor(v){if(this._set=new Set,v)for(const c of v)this.add(c)}add(v){this._set.add(f.toKey(v))}delete(v){return this._set.delete(f.toKey(v))}has(v){return this._set.has(f.toKey(v))}}e.ExtensionIdentifierSet=l;class D{constructor(){this._map=new Map}clear(){this._map.clear()}delete(v){this._map.delete(f.toKey(v))}get(v){return this._map.get(f.toKey(v))}has(v){return this._map.has(f.toKey(v))}set(v,c){this._map.set(f.toKey(v),c)}values(){return this._map.values()}forEach(v){this._map.forEach(v)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=D;function C(E){return d(E)}e.isApplicationScopedExtension=C;function d(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function h(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function I(E,v){if(v){const c=`onResolveRemoteAuthority:${(0,L.getRemoteName)(v)}`;return!!E.activationEvents?.includes(c)}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[135],ne([0,1,2,37,12]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends N.Disposable{constructor(P,f,l,D,C){super(),this.userDataProfilesService=P,this.fileService=f,this.uriIdentityService=l,this.logService=C,this._register(D.onDidInstallExtensions(d=>this.onDidInstallExtensions(d))),this._register(D.onDidUninstallExtension(d=>this.onDidUnInstallExtension(d)))}onDidInstallExtensions(P){for(const f of P)f.local&&this.invalidate(f.profileLocation)}onDidUnInstallExtension(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const f of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(f.extensionsResource,P)&&await this.deleteUserCacheFile(f);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(P){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(P.cacheHome,O.USER_MANIFEST_CACHE_FILE))}catch(f){(0,L.toFileOperationResult)(f)!==1&&this.logService.error(f)}}}e.ExtensionsManifestCache=A}),define(te[44],ne([0,1,14,9,2,104,43,10,6,36]),function(B,e,N,O,L,A,T,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");class D{constructor(y){this.original=y}toJSON(){if(!this.headers){const y=Object.create(null);for(const r in this.original)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?y[r]="*****":y[r]=this.original[r];this.headers=y}return this.headers}}class C extends L.Disposable{constructor(y){super(),this.counter=0,this.logger=y.createLogger("network",{name:(0,A.localize)(0,null),when:f.CONTEXT_LOG_LEVEL.isEqualTo((0,f.LogLevelToString)(f.LogLevel.Trace)).serialize()})}async logAndRequest(y,r,o){const t=`${y} #${++this.counter}: ${r.url}`;this.logger.trace(`${t} - begin`,r.type,new D(r.headers??{}));try{const i=await o();return this.logger.trace(`${t} - end`,r.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${t} - error`,r.type,(0,O.getErrorMessage)(i)),i}}}e.AbstractRequestService=C;function d(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=d;function h(g){return g.res.statusCode===204}e.hasNoContent=h;async function I(g){return h(g)?null:(await(0,N.streamToBuffer)(g.stream)).toString()}e.asText=I;async function E(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);return I(g)}e.asTextOrError=E;async function v(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);if(h(g))return null;const r=(await(0,N.streamToBuffer)(g.stream)).toString();try{return JSON.parse(r)}catch(o){throw o.message+=`:
`+r,o}}e.asJson=v;function c(g){R(g)}e.updateProxyConfigurationsScope=c;let p;function R(g){const y=l.Registry.as(T.Extensions.Configuration),r=p;p={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},y.updateConfigurations({add:[p],remove:r?[r]:[]})}R(1)}),define(te[136],ne([0,1,20,15,12,44]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(f,l){this.requestService=f,this.fileService=l}async download(f,l,D=N.CancellationToken.None){if(f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote){await this.fileService.copy(f,l);return}const C={type:"GET",url:f.toString(!0)},d=await this.requestService.request(C,D);if(d.res.statusCode===200)await this.fileService.writeFile(l,d.stream);else{const h=await(0,A.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${h}`)}}};e.DownloadService=T,e.DownloadService=T=ve([ie(0,A.IRequestService),ie(1,L.IFileService)],T)}),define(te[137],ne([0,1,138,3]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(T,P){return T.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:T.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function A(T,P,f={}){const l=(0,N.parse)(T),D=f.proxyUrl||L(l,P);if(!D)return null;const C=(0,N.parse)(D);if(!/^https?:$/.test(C.protocol||""))return null;const d={host:C.hostname||"",port:(C.port?+C.port:0)||(C.protocol==="https"?443:80),auth:C.auth,rejectUnauthorized:(0,O.isBoolean)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((h,I)=>{B(["http-proxy-agent"],h,I)})).HttpProxyAgent(D,d):new(await new Promise((h,I)=>{B(["https-proxy-agent"],h,I)})).HttpsProxyAgent(D,d)}e.getProxyAgent=A}),define(te[139],ne([0,1,58,16,105,20,34,9,13,28,84,171,8,72]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let I;async function E(c,p,R,g){return R["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(g)&&!R["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(g)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=d.Promises.withAsyncBody(async(y,r)=>{const o=new A.CancellationTokenSource;let t=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,h.clamp)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),r(new Error((0,L.localize)(0,null)))},t);try{y(await v(p,o.token))}catch(s){!(0,P.isCancellationError)(s)&&!o.token.isCancellationRequested?r(new Error((0,L.localize)(1,null,(0,T.toErrorMessage)(s)))):y({})}finally{clearTimeout(n),o.dispose()}})),I)}e.getResolvedShellEnv=E;async function v(c,p){const R=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",R);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",g);const y=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(y+"({.*})"+y),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",o);const t=await(0,D.getSystemShell)(f.OS,o);return c.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(p.isCancellationRequested)return n(new P.CancellationError);const s=(0,O.basename)(t);let u,b;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(u=`& '${process.execPath}' ${w} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,b=["-Login","-Command"]):s==="nu"?(u=`^'${process.execPath}' ${w} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,b=["-i","-l","-c"]):(u=`'${process.execPath}' ${w} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,s==="tcsh"||s==="csh"?b=["-ic"]:b=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),u);const S=(0,N.spawn)(t,[...b,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(S.kill(),n(new P.CancellationError))),S.on("error",ee=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(ee)),n(ee)});const k=[];S.stdout.on("data",ee=>k.push(ee));const $=[];S.stderr.on("data",ee=>$.push(ee)),S.on("close",(ee,Z)=>{const se=Buffer.concat(k).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const re=Buffer.concat($).toString("utf8");if(re.trim()&&c.trace("getUnixShellEnvironment#stderr",re),ee||Z)return n(new Error((0,L.localize)(2,null,ee,Z)));const ue=r.exec(se),le=ue?ue[1]:"{}";try{const oe=JSON.parse(le);R?oe.ELECTRON_RUN_AS_NODE=R:delete oe.ELECTRON_RUN_AS_NODE,g?oe.ELECTRON_NO_ATTACH_CONSOLE=g:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){c.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(oe)),n(oe)}})})}}),define(te[140],ne([0,1,10]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,N.createDecorator)("stateReadService"),e.IStateService=(0,N.createDecorator)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(B,e,N,O,L,A,T,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var l;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class D extends L.Disposable{constructor(I,E,v,c){super(),this.storagePath=I,this.saveStrategy=E,this.logService=v,this.fileService=c,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new N.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(I){I.fileOperationResult!==1&&this.logService.error(I)}}getItem(I,E){const v=this.storage[I];return(0,A.isUndefinedOrNull)(v)?E:v}setItem(I,E){this.setItems([{key:I,data:E}])}setItems(I){let E=!1;for(const{key:v,data:c}of I)this.storage[v]!==c&&((0,A.isUndefinedOrNull)(c)?(0,A.isUndefined)(this.storage[v])||(this.storage[v]=void 0,E=!0):(this.storage[v]=c,E=!0));E&&this.save()}removeItem(I){(0,A.isUndefined)(this.storage[I])||(this.storage[I]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const I=JSON.stringify(this.storage,null,4);if(I!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,O.VSBuffer.fromString(I),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=I}catch(E){this.logService.error(E)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=D;let C=class extends L.Disposable{constructor(I,E,v,c){super(),this.fileStorage=this._register(new D(E.stateResource,I,v,c))}async init(){await this.fileStorage.init()}getItem(I,E){return this.fileStorage.getItem(I,E)}};e.StateReadonlyService=C,e.StateReadonlyService=C=ve([ie(1,T.IEnvironmentService),ie(2,f.ILogService),ie(3,P.IFileService)],C);class d extends C{setItem(I,E){this.fileStorage.setItem(I,E)}setItems(I){this.fileStorage.setItems(I)}removeItem(I){this.fileStorage.removeItem(I)}close(){return this.fileStorage.close()}}e.StateService=d}),define(te[69],ne([0,1,13,35,28]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(f){if(N.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function T(f,l,D,C,d,h,I,E,v){const c=Object.create(null);c["common.machineId"]=h,c["common.sqmId"]=I,c.sessionID=(0,L.generateUuid)()+Date.now(),c.commitHash=C,c.version=d,c["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,N.PlatformToString)(N.platform),c["common.nodePlatform"]=O.platform,c["common.nodeArch"]=D,c["common.product"]=v||"desktop",E&&(c["common.msftInternal"]=E);let p=0;const R=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),N.isLinuxSnap&&(c["common.snap"]="true");const g=A(l);return g&&(c["common.platformDetail"]=g),c}e.resolveCommonProperties=T;function P(f){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const D=l.toLowerCase();return f.some(C=>D===C)}e.verifyMicrosoftInternalDomain=P}),define(te[26],ne([0,1,10]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,N.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(B,e,N,O,L,A,T,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class D{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class C{async publicLog(n,s,u){}async publicLogError(n,s,u){}}e.NullEndpointTelemetryService=C,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,n){return L.Event.debounce(n.onDidChangeConfiguration,(u,b)=>{const w=u?new Set([...u.affectedKeys,...b.affectedKeys]):b.affectedKeys;return{...b,affectedKeys:w}},1e3,!0)(u=>{u.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(u.source),configurationKeys:Array.from(u.affectedKeys)})})}e.configurationTelemetry=d;function h(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=h;function I(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=I;function E(i){const n=i.getValue(f.TELEMETRY_SETTING_ID),s=i.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function v(i){const n={},s={},u={};R(i,u);for(let b in u){b=b.length>150?b.substr(b.length-149):b;const w=u[b];typeof w=="number"?s[b]=w:typeof w=="boolean"?s[b]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${w.length}`),n[b]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(n[b]=w)}return{properties:n,measurements:s}}e.validateTelemetryData=v;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const n=(0,T.getRemoteName)(i);return c.has(n)?n:"other"}e.cleanRemoteAuthority=p;function R(i,n,s=0,u){if(i)for(const b of Object.getOwnPropertyNames(i)){const w=i[b],S=u?u+b:b;Array.isArray(w)?n[S]=(0,N.safeStringify)(w):w instanceof Date?n[S]=w.toISOString():(0,O.isObject)(w)?s<2?R(w,n,s+1,S+"."):n[S]=(0,N.safeStringify)(w):n[S]=w}}function g(i,n){const s=i.msftInternalDomains||[],u=n.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(s)||u}e.isInternalTelemetry=g;function y(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=y;function r(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let s=i;const u=[];for(const k of n)for(;;){const $=k.exec(i);if(!$)break;u.push([$.index,k.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(s="";;){const k=w.exec(i);if(!k)break;const $=u.some(([ee,Z])=>k.index<Z&&ee<w.lastIndex);!b.test(k[0])&&!$&&(s+=i.substring(S,k.index)+"<REDACTED: user-file-path>",S=w.lastIndex)}return S<i.length&&(s+=i.substr(S)),s}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of n)if(s.regex.test(i))return`<REDACTED: ${s.label}>`;return i}function t(i,n){return(0,N.cloneAndChange)(i,s=>{if(s instanceof l||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let u=s.replaceAll("%20"," ");u=r(u,n);for(const b of n)u=u.replace(b,"");return u=o(u),u}})}e.cleanData=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(B,e,N,O,L,A,T,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,N.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=D;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const n=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,n,s)}static parse(i){const n=C.exec(i);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?D(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=d;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(t){const i=h.exec(t);return i&&i[1]?[v(i[1]),i[2]]:[v(t),void 0]}e.getIdAndVersion=I;function E(t,i){return`${t}.${i}`}e.getExtensionId=E;function v(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=v;function c(t,i){return v(E(t??L.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=c;function p(t,i){const n=[],s=u=>{for(const b of n)if(b.some(w=>D(i(w),i(u))))return b;return null};for(const u of t){const b=s(u);b?b.push(u):n.push([u])}return n}e.groupByExtension=p;function R(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function g(t){return{id:new l.TelemetryTrustedValue(t.identifier.id),name:new l.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function y(t,i){const n=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const u=s.shift();if(u&&n.every(b=>!D(b.identifier,{id:u}))){const b=t.filter(w=>D(w.identifier,{id:u}));b.length===1&&(n.push(b[0]),s.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=y;async function r(t,i){if(!A.isLinux)return!1;let n;try{n=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await r(t,i),s=(0,O.getTargetPlatform)(n?"alpine":A.platform,f.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=o}),define(te[141],ne([0,1,20,9,15,17,42,11,94,21,27,37]),function(B,e,N,O,L,A,T,P,f,l,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=v=>(0,f.localize)(0,null,v),h=(0,f.localize)(1,null,"ms-dotnettools.csharp");function I(v,c){return c?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}let E=class{constructor(c,p,R){this.logger=c,this.extensionManagementService=p,this.extensionGalleryService=R}get location(){}async listExtensions(c,p,R){let g=await this.extensionManagementService.getInstalled(1,R);const y=C.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(p&&p!==""){if(y.indexOf(p.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}g=g.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){this.logger.info("Possible Categories: "),y.forEach(o=>{this.logger.info(o)});return}this.location&&this.logger.info((0,f.localize)(2,null,this.location)),g=g.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let r;for(const o of g)r!==o.identifier.id&&(r=o.identifier.id,this.logger.info(I(o.manifest,c)))}async installExtensions(c,p,R,g){const y=[];try{const r=[];c.length&&this.logger.info(this.location?(0,f.localize)(3,null,this.location):(0,f.localize)(4,null));const o=[];let t=[];const i=(s,u,b)=>{t.push({id:s,version:u!=="prerelease"?u:void 0,installOptions:{...R,isBuiltin:b,installPreReleaseVersion:u==="prerelease"||R.installPreReleaseVersion}})};for(const s of c)if(s instanceof P.URI)o.push({vsix:s,installOptions:R});else{const[u,b]=(0,D.getIdAndVersion)(s);i(u,b,!1)}for(const s of p)if(s instanceof P.URI)o.push({vsix:s,installOptions:{...R,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[u,b]=(0,D.getIdAndVersion)(s);i(u,b,!0)}const n=await this.extensionManagementService.getInstalled(1,R.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:s,installOptions:u})=>{try{const b=await this.installVSIX(s,u,g,n);b&&r.push(b)}catch(b){this.logger.error(b),y.push(s.toString())}})),t.length&&(t=t.filter(({id:s,version:u})=>{const b=n.find(w=>(0,D.areSameExtensions)(w.identifier,{id:s}));if(b){if(!g&&(!u||u==="prerelease"&&b.preRelease))return this.logger.info((0,f.localize)(5,null,s,b.manifest.version,s)),!1;if(u&&b.manifest.version===u)return this.logger.info((0,f.localize)(6,null,`${s}@${u}`)),!1}return!0}),t.length)){const s=await this.getGalleryExtensions(t);await Promise.all(t.map(async u=>{const b=s.get(u.id.toLowerCase());if(b)try{const w=await this.installFromGallery(u,b,n);w&&r.push(w)}catch(w){this.logger.error(w.message||w.stack||w),y.push(u.id)}else this.logger.error(`${d(u.version?`${u.id}@${u.version}`:u.id)}
${h}`),y.push(u.id)}))}}catch(r){throw this.logger.error((0,f.localize)(7,null,(0,O.getErrorMessage)(r))),r}if(y.length)throw new Error((0,f.localize)(8,null,y.join(", ")))}async installVSIX(c,p,R,g){const y=await this.extensionManagementService.getManifest(c);if(!y)throw new Error("Invalid vsix");if(await this.validateVSIX(y,R,p.profileLocation,g))try{return await this.extensionManagementService.install(c,p),this.logger.info((0,f.localize)(9,null,(0,A.basename)(c))),y}catch(o){if((0,O.isCancellationError)(o))return this.logger.info((0,f.localize)(10,null,(0,A.basename)(c))),null;throw o}return null}async getGalleryExtensions(c){const p=new Map,R=c.some(r=>r.installOptions.installPreReleaseVersion),g=await this.extensionManagementService.getTargetPlatform(),y=[];for(const r of c)l.EXTENSION_IDENTIFIER_REGEX.test(r.id)&&y.push({...r,preRelease:R});if(y.length){const r=await this.extensionGalleryService.getExtensions(y,{targetPlatform:g},N.CancellationToken.None);for(const o of r)p.set(o.identifier.id.toLowerCase(),o)}return p}async installFromGallery({id:c,version:p,installOptions:R},g,y){const r=await this.extensionGalleryService.getManifest(g,N.CancellationToken.None);if(r&&!this.validateExtensionKind(r))return null;const o=y.find(t=>(0,D.areSameExtensions)(t.identifier,g.identifier));if(o){if(g.version===o.manifest.version)return this.logger.info((0,f.localize)(11,null,p?`${c}@${p}`:c)),null;this.logger.info((0,f.localize)(12,null,c,g.version))}try{R.isBuiltin?this.logger.info(p?(0,f.localize)(13,null,c,p):(0,f.localize)(14,null,c)):this.logger.info(p?(0,f.localize)(15,null,c,p):(0,f.localize)(16,null,c));const t=await this.extensionManagementService.installFromGallery(g,{...R,installGivenVersion:!!p});return this.logger.info((0,f.localize)(17,null,c,t.manifest.version)),r}catch(t){if((0,O.isCancellationError)(t))return this.logger.info((0,f.localize)(18,null,c)),null;throw t}}validateExtensionKind(c){return!0}async validateVSIX(c,p,R,g){if(!p){const y={id:(0,D.getGalleryExtensionId)(c.publisher,c.name)},r=g.find(o=>(0,D.areSameExtensions)(y,o.identifier)&&(0,T.gt)(o.manifest.version,c.version));if(r)return this.logger.info((0,f.localize)(19,null,r.identifier.id,r.manifest.version,c.version)),!1}return this.validateExtensionKind(c)}async uninstallExtensions(c,p,R){const g=async r=>{if(r instanceof P.URI){const o=await this.extensionManagementService.getManifest(r);return I(o)}return r},y=[];for(const r of c){const o=await g(r),i=(await this.extensionManagementService.getInstalled(void 0,R)).filter(n=>(0,D.areSameExtensions)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.notInstalled(o)}
${h}`);if(i.some(n=>n.type===0)){this.logger.info((0,f.localize)(20,null,o));return}if(!p&&i.some(n=>n.isBuiltin)){this.logger.info((0,f.localize)(21,null,o));return}this.logger.info((0,f.localize)(22,null,o));for(const n of i)await this.extensionManagementService.uninstall(n,{profileLocation:R}),y.push(n);this.location?this.logger.info((0,f.localize)(23,null,o,this.location)):this.logger.info((0,f.localize)(24,null,o))}}async locateExtension(c){const p=await this.extensionManagementService.getInstalled();c.forEach(R=>{p.forEach(g=>{if(g.identifier.id===R&&g.location.scheme===L.Schemas.file){this.logger.info(g.location.fsPath);return}})})}notInstalled(c){return this.location?(0,f.localize)(25,null,c,this.location):(0,f.localize)(26,null,c)}};e.ExtensionManagementCLI=E,e.ExtensionManagementCLI=E=ve([ie(1,l.IExtensionManagementService),ie(2,l.IExtensionGalleryService)],E)}),define(te[142],ne([0,1,8,9,2,15,17,42,3,28,24,48,25,18,21,27,60,12,6]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let g=class extends L.Disposable{static{R=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(r,o,t,i,n,s){super(),this.fileService=o,this.extensionGalleryService=t,this.configurationService=i,this.extensionSignatureVerificationService=n,this.logService=s,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(r,o,t){await this.cleanUpPromise;const i=(0,T.joinPath)(this.extensionsDownloadDir,this.getName(r));try{await this.downloadFile(r,i,s=>this.extensionGalleryService.download(r,s,o))}catch(s){throw new I.ExtensionManagementError(s.message,I.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.shouldVerifySignature(r)){const s=await this.downloadSignatureArchive(r);try{n=await this.extensionSignatureVerificationService.verify(i.fsPath,s.fsPath,this.logService.getLevel()===p.LogLevel.Trace)}catch(u){const b=u;if(n=b.code,b.output&&this.logService.trace(`Extension signature verification details for ${r.identifier.id} ${r.version}:
${b.output}`),n===I.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===I.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(w){this.logService.error(w)}throw new I.ExtensionManagementError(C.CorruptZipMessage,I.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(s)}catch(u){this.logService.error(u)}}}return n===!0?this.logService.info(`Extension signature is verified: ${r.identifier.id}`):n===!1?this.logService.info(`Extension signature verification is not done: ${r.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${n}': ${r.identifier.id}`),{location:i,verificationStatus:n}}shouldVerifySignature(r){if(!r.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,f.isBoolean)(o)?o:!0}async downloadSignatureArchive(r){await this.cleanUpPromise;const o=(0,T.joinPath)(this.extensionsDownloadDir,`${this.getName(r)}${R.SignatureArchiveExtension}`);return await this.downloadFile(r,o,t=>this.extensionGalleryService.downloadSignatureArchive(r,t)),o}async downloadFile(r,o,t){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,l.generateUuid)()}`);await this.fileService.exists(i)||await t(i);try{await D.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(r){await this.cleanUpPromise,await this.fileService.del(r)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const o=[],t=[],i=[];for(const u of r.children)if(u.name.endsWith(R.SignatureArchiveExtension))i.push(u.resource);else{const b=E.ExtensionKey.parse(u.name);b&&t.push([b,u])}const n=(0,E.groupByExtension)(t,([u])=>u),s=[];for(const u of n)u.sort((b,w)=>P.rcompare(b[0].version,w[0].version)),o.push(...u.slice(1).map(b=>b[1].resource)),s.push(u[0][1]);s.sort((u,b)=>u.mtime-b.mtime),o.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(u=>u.resource)),o.push(...i),await N.Promises.settled(o.map(u=>(this.logService.trace("Deleting from cache",u.path),this.fileService.del(u))))}}catch(r){this.logService.error(r)}}getName(r){return this.cache?E.ExtensionKey.create(r).toString().toLowerCase():(0,l.generateUuid)()}};e.ExtensionsDownloader=g,e.ExtensionsDownloader=g=R=ve([ie(0,h.INativeEnvironmentService),ie(1,c.IFileService),ie(2,I.IExtensionGalleryService),ie(3,d.IConfigurationService),ie(4,v.IExtensionSignatureVerificationService),ie(5,p.ILogService)],g)}),define(te[143],ne([0,1,4,2,31,27,37]),function(B,e,N,O,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends O.Disposable{constructor(l,D,C,d,h,I,E){super(),this.extensionManagementService=l,this.extensionsScannerService=D,this.userDataProfilesService=C,this.extensionsProfileScannerService=d,this.uriIdentityService=h,this.fileService=I,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new O.DisposableMap),this.initialize().then(null,v=>E.error(v))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(l=>this.onDidChangeProfiles(l.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(l=>this.onAddExtensions(l))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(l=>this.onDidAddExtensions(l))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(l=>this.onRemoveExtensions(l))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(l=>this.onDidRemoveExtensions(l))),this._register(this.fileService.onDidFilesChange(l=>this.onDidFilesChange(l)))}async onDidChangeProfiles(l){try{l.length&&await Promise.all(l.map(D=>(this.extensionsProfileWatchDisposables.set(D.id,(0,O.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(D.extensionsResource)),this.fileService.watch(D.extensionsResource))),this.populateExtensionsFromProfile(D.extensionsResource))))}catch(D){throw this.logService.error(D),D}}async onAddExtensions(l){for(const D of l.extensions)this.addExtensionWithKey(this.getKey(D.identifier,D.version),l.profileLocation)}async onDidAddExtensions(l){for(const D of l.extensions){const C=this.getKey(D.identifier,D.version);l.error?this.removeExtensionWithKey(C,l.profileLocation):this.addExtensionWithKey(C,l.profileLocation)}}async onRemoveExtensions(l){for(const D of l.extensions)this.removeExtensionWithKey(this.getKey(D.identifier,D.version),l.profileLocation)}async onDidRemoveExtensions(l){const D=[],C=[];for(const d of l.extensions){const h=this.getKey(d.identifier,d.version);l.error?this.addExtensionWithKey(h,l.profileLocation):(this.removeExtensionWithKey(h,l.profileLocation),this.allExtensions.has(h)||(this.logService.debug("Extension is removed from all profiles",d.identifier.id,d.version),C.push(this.extensionManagementService.scanInstalledExtensionAtLocation(d.location).then(I=>{I?D.push(I):this.logService.info("Extension not found at the location",d.location.toString())},I=>this.logService.error(I)))))}try{await Promise.all(C),D.length&&await this.uninstallExtensionsNotInProfiles(D)}catch(d){this.logService.error(d)}}onDidFilesChange(l){for(const D of this.userDataProfilesService.profiles)l.contains(D.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(D.extensionsResource)}async onDidExtensionsProfileChange(l){const D=[],C=[],d=await this.extensionsProfileScannerService.scanProfileExtensions(l),h=new Set,I=new Set;for(const[E,v]of this.allExtensions)v.has(l)&&I.add(E);for(const E of d){const v=this.getKey(E.identifier,E.version);h.add(v),I.has(v)||(D.push(E.identifier),this.addExtensionWithKey(v,l))}for(const E of I)if(!h.has(E)){const v=this.fromKey(E);v&&(C.push(v.identifier),this.removeExtensionWithKey(E,l))}(D.length||C.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D.length?{extensions:D,profileLocation:l}:void 0,removed:C.length?{extensions:C,profileLocation:l}:void 0})}async populateExtensionsFromProfile(l){const D=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const C of D)this.addExtensionWithKey(this.getKey(C.identifier,C.version),l)}async uninstallExtensionsNotInProfiles(l){l||(l=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(C=>!this.allExtensions.has(this.getKey(C.identifier,C.manifest.version)))),l.length&&await this.extensionManagementService.markAsUninstalled(...l)}addExtensionWithKey(l,D){let C=this.allExtensions.get(l);C||this.allExtensions.set(l,C=new L.ResourceSet(d=>this.uriIdentityService.extUri.getComparisonKey(d))),C.add(D)}removeExtensionWithKey(l,D){const C=this.allExtensions.get(l);C&&C.delete(D),C?.size||this.allExtensions.delete(l)}getKey(l,D){return`${T.ExtensionIdentifier.toKey(l.id)}@${D}`}fromKey(l){const[D,C]=(0,A.getIdAndVersion)(l);return C?{identifier:{id:D},version:C}:void 0}}e.ExtensionsWatcher=P}),define(te[144],ne([0,1,115,39]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(A,T,P,f,l,D,C){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${T.nameShort})`};if((0,O.supportsTelemetry)(T,P)&&(0,O.getTelemetryLevel)(f)===3){const h=await(0,N.getServiceMachineId)(P,l,D);d["X-Market-User-Id"]=h,d["VSCode-SessionId"]=C.machineId||h}return d}e.resolveMarketplaceHeaders=L}),define(te[145],ne([0,1,172,19,8,2,15,16,24,18,21,27,6,64,11]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends h.LanguagePackBaseService{constructor(R,g,y,r){super(y),this.extensionManagementService=R,this.logService=r,this.cache=this._register(new v(g,r)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(R,g){const r=(await this.cache.getLanguagePacks())[g];if(!r){this.logService.warn(`No language pack found for ${g}`);return}const o=r.translations[R];return o?I.URI.file(o):void 0}async getInstalledLanguages(){const R=await this.cache.getLanguagePacks(),g=Object.keys(R).map(y=>{const r=R[y];return{...this.createQuickPickItem(y,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return g.push(this.createQuickPickItem("en","English")),g.sort((y,r)=>y.label.localeCompare(r.label)),g}async postInstallExtension(R){R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",R.identifier.id),await this.update())}async postUninstallExtension(R){const g=await this.cache.getLanguagePacks();Object.keys(g).some(y=>g[y]&&g[y].extensions.some(r=>(0,C.areSameExtensions)(r.extensionIdentifier,R.identifier)))&&(this.logService.info("Removing language packs from the extension",R.identifier.id),await this.update())}async update(){const[R,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(g);return!(0,O.equals)(Object.keys(R),Object.keys(y))}};e.NativeLanguagePackService=E,e.NativeLanguagePackService=E=ve([ie(0,D.IExtensionManagementService),ie(1,l.INativeEnvironmentService),ie(2,D.IExtensionGalleryService),ie(3,d.ILogService)],E);let v=class extends A.Disposable{constructor(R,g){super(),this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(R.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(R){return this.withLanguagePacks(g=>{Object.keys(g).forEach(y=>delete g[y]),this.createLanguagePacksFromExtensions(g,...R)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(R,...g){for(const y of g)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(R,y);Object.keys(R).forEach(y=>this.updateHash(R[y]))}createLanguagePacksFromExtension(R,g){const y=g.identifier,r=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const o of r)if(g.location.scheme===T.Schemas.file&&c(o)){let t=R[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},R[o.languageId]=t);const i=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,y))[0];i?i.version=g.manifest.version:t.extensions.push({extensionIdentifier:y,version:g.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,P.join)(g.location.fsPath,n.path)}}updateHash(R){if(R){const g=(0,N.createHash)("md5");for(const y of R.extensions)g.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);R.hash=g.digest("hex")}}withLanguagePacks(R=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return f.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(g=R(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.languagePacks=y,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),f.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>g,y=>this.logService.error(y))})}};v=ve([ie(0,l.INativeEnvironmentService),ie(1,d.ILogService)],v);function c(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const R of p.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(te[146],ne([0,1,81,9,30,39]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://0.0.0.0/OneCollector/1.0",P="https://0.0.0.0/ping";async function f(D,C,d){const h=await(0,N.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),I=await(0,N.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),E=new h.AppInsightsCore,v=new I.PostChannel,c={instrumentationKey:D,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(d){c.extensionConfig={};const p={alwaysUseXhrOverride:!0,httpXHROverride:d};c.extensionConfig[v.identifier]=p}return E.initialize(c,[]),E.addTelemetryInitializer(p=>{C&&(p.ext=p.ext??{},p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),E}class l{constructor(C,d,h,I,E){this._isInternalTelemetry=C,this._eventPrefix=d,this._defaultData=h,this._xhrOverride=E,this.endPointUrl=T,this.endPointHealthUrl=P,this._defaultData||(this._defaultData={}),typeof I=="function"?this._aiCoreOrKey=I():this._aiCoreOrKey=I,this._asyncAiCore=null}_withAIClient(C){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){C(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=f(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(d=>{C(d)},d=>{(0,O.onUnexpectedError)(d),console.error(d)})}}log(C,d){if(!this._aiCoreOrKey)return;d=(0,L.mixin)(d,this._defaultData),d=(0,A.validateTelemetryData)(d);const h=this._eventPrefix+"/"+C;try{this._withAIClient(I=>{I.pluginVersionString=d?.properties.version??"Unknown",I.track({name:h,baseData:{name:h,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(C=>{this._withAIClient(d=>{d.unload(!0,()=>{this._aiCoreOrKey=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=l}),define(te[147],ne([0,1,2,30,13,29,106,25,43,148,32,36,26,39]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,p,R){this._configurationService=p,this._productService=R,this._experimentProperties={},this._disposables=new N.DisposableStore,this._cleanupPatterns=[],this._appenders=c.appenders,this._commonProperties=c.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=c.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(g),"gi")),g.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(g.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(g=>{(g.affectsConfiguration(d.TELEMETRY_SETTING_ID)||g.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||g.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(c,p){this._experimentProperties[c]=p}_updateTelemetryLevel(){let c=(0,h.getTelemetryLevel)(this._configurationService);const p=this._productService.enabledTelemetryLevels;if(p){this._sendErrorTelemetry=this.sendErrorTelemetry?p.error:!1;const R=p.usage?3:p.error?2:0;c=Math.min(c,R)}this._telemetryLevel=c}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(c,p,R){this._telemetryLevel<p||(R=(0,O.mixin)(R,this._experimentProperties),R=(0,h.cleanData)(R,this._cleanupPatterns),R=(0,O.mixin)(R,this._commonProperties),this._appenders.forEach(g=>g.log(c,R)))}publicLog(c,p){this._log(c,3,p)}publicLog2(c,p){this.publicLog(c,p)}publicLogError(c,p){this._sendErrorTelemetry&&this._log(c,2,p)}publicLogError2(c,p){this.publicLogError(c,p)}};e.TelemetryService=I,e.TelemetryService=I=ve([ie(1,P.IConfigurationService),ie(2,D.IProductService)],I);function E(){const v=(0,T.localize)(0,null,l.default.nameLong),c=l.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=L.isWeb?"":(0,T.localize)(3,null),R=(0,T.localize)(4,null),g=(0,T.localize)(5,null),y=(0,T.localize)(6,null),r=(0,T.localize)(7,null),o=`
|       | ${R} | ${g} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${v} ${c} ${p}

&nbsp;

${r}
${o}

&nbsp;

${t}
`}C.Registry.as(f.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:E(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(f.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,T.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,T.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[149],ne([0,1,14,20,173,146]),function(B,e,N,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function T(D,C){const d=await C.request(D,O.CancellationToken.None),h=(await(0,N.streamToBuffer)(d.stream)).toString(),I=d.res.statusCode??200;return{headers:d.res.headers,statusCode:I,responseData:h}}async function P(D){const C={method:D.type,headers:D.headers};return new Promise((h,I)=>{const E=L.request(D.url??"",C,v=>{v.on("data",function(c){h({headers:v.headers,statusCode:v.statusCode??200,responseData:c.toString()})}),v.on("error",function(c){I(c)})});E.write(D.data,v=>{v&&I(v)}),E.end()})}async function f(D,C,d){const h=typeof C.data=="string"?C.data:new TextDecoder().decode(C.data),I={type:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data).toString()},url:C.urlString,data:h};try{const E=D?await T(I,D):await P(I);d(E.statusCode,E.headers,E.responseData)}catch{d(0,{})}}class l extends A.AbstractOneDataSystemAppender{constructor(C,d,h,I,E){const v={sendPOST:(c,p)=>{f(C,c,p)}};super(d,h,I,E,v)}}e.OneDataSystemAppender=l}),define(te[150],ne([0,1,16,24]),function(B,e,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function L(A,T){const P=Object.create(null),f=(D,C)=>{const d=JSON.parse(D);P[C]=d};if(T){const D=[],C=await O.Promises.readdir(T);for(const h of C)try{(await O.Promises.stat((0,N.join)(T,h))).isDirectory()&&D.push(h)}catch{}const d=[];for(const h of D)(await O.Promises.readdir((0,N.join)(T,h))).filter(E=>E==="telemetry.json").length===1&&d.push(h);for(const h of d){const I=(await O.Promises.readFile((0,N.join)(T,h,"telemetry.json"))).toString();f(I,h)}}let l=(await O.Promises.readFile((0,N.join)(A,"telemetry-core.json"))).toString();return f(l,"vscode-core"),l=(await O.Promises.readFile((0,N.join)(A,"telemetry-extensions.json"))).toString(),f(l,"vscode-extensions"),JSON.stringify(P,null,4)}e.buildTelemetryMessage=L}),define(te[151],ne([0,1,13,82,26]),function(B,e,N,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveSqmId=e.resolveMachineId=void 0;async function A(P,f){let l=P.getItem(L.machineIdKey);return(typeof l!="string"||N.isMacintosh&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,O.getMachineId)(f.error.bind(f))),l}e.resolveMachineId=A;async function T(P,f){let l=P.getItem(L.sqmIdKey);return typeof l!="string"&&(l=await(0,O.getSqmMachineId)(f.error.bind(f))),l}e.resolveSqmId=T}),define(te[22],ne([0,1,10]),function(B,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,N.createDecorator)("IUriIdentityService")}),define(te[152],ne([0,1,22,116,12,17,73,4,2]),function(B,e,N,O,L,A,T,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(d){this.uri=d,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let D=class{constructor(d){this._fileService=d,this._dispooables=new f.DisposableStore,this._limit=2**16;const h=new Map,I=E=>{let v=h.get(E.scheme);return v===void 0&&(v=d.hasProvider(E)&&!this._fileService.hasCapability(E,1024),h.set(E.scheme,v)),v};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(E=>{h.delete(E.scheme)})),this.extUri=new A.ExtUri(I),this._canonicalUris=new T.SkipList((E,v)=>this.extUri.compare(E,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,A.normalizePath)(d));const h=this._canonicalUris.get(d);return h?h.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new l(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((I,E)=>I[1].time<E[1].time?1:I[1].time>E[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let I=0;I<h;I++)this._canonicalUris.set(d[I][0],d[I][1].touch())}};e.UriIdentityService=D,e.UriIdentityService=D=ve([ie(0,L.IFileService)],D),(0,O.registerSingleton)(N.IUriIdentityService,D,1)}),define(te[153],ne([0,1,4,2,12,47,31]),function(B,e,N,O,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends O.Disposable{constructor(l,D,C,d,h,I){super(),this.fileSystemScheme=l,this.fileSystemProvider=D,this.userDataScheme=C,this.userDataProfilesService=d,this.uriIdentityService=h,this.logService=I,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new N.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new T.ResourceSet(E=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(E))),this.updateAtomicReadWritesResources(),this._register(d.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(E=>this.handleFileChanges(E)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,D){return this.fileSystemProvider.open(this.toFileSystemResource(l),D)}close(l){return this.fileSystemProvider.close(l)}read(l,D,C,d,h){return this.fileSystemProvider.read(l,D,C,d,h)}write(l,D,C,d,h){return this.fileSystemProvider.write(l,D,C,d,h)}watch(l,D){this.watchResources.set(l,l);const C=this.fileSystemProvider.watch(this.toFileSystemResource(l),D);return(0,O.toDisposable)(()=>{this.watchResources.delete(l),C.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,D,C){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(D),C)}readFile(l,D){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),D)}readFileStream(l,D,C){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),D,C)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,D,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),D,C)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,D){return this.fileSystemProvider.delete(this.toFileSystemResource(l),D)}copy(l,D,C){if((0,L.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(D),C);throw new Error("copy not supported")}cloneFile(l,D){if((0,L.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(D));throw new Error("clone not supported")}handleFileChanges(l){const D=[];for(const C of l){if(C.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(C.resource);this.watchResources.findSubstr(d)&&D.push({resource:d,type:C.type,cId:C.cId})}D.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(D))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(te[154],ne([0,1,108,16,47,17,11,10,15]),function(B,e,N,O,L,A,T,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=l;function D(i){return typeof i?.id=="string"&&!l(i)&&!d(i)}e.isEmptyWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function C(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=i;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=C;function d(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=d;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const s=i;if(s?.configPath)return{id:s.id,configPath:T.URI.revive(s.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=h;var I;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(I||(e.WorkbenchState=I={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=E;function v(i){const n=i;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=v;class c{constructor(n,s,u,b,w){this._id=n,this._transient=u,this._configuration=b,this._ignorePathCasing=w,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class p{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function R(i){return new p({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=R,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,N.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(i,n){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function y(i){let n;return T.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=y,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=r;function o(i,n){return!g(i,n)&&!y(i)}e.isSavedWorkspace=o;function t(i){return(typeof i=="string"?(0,O.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(te[23],ne([0,1,41,4,2,17,11,107,18,12,10,6,154,31,22,8,28,29,3]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var R;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.isUserDataProfile=g,e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function y(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:T.URI.revive(i.location).with({scheme:n}),globalStorageHome:T.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:T.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=y;function r(i,n,s,u,b,w){return{id:i,name:n,location:s,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:w&&b?.useDefaultFlags?.globalState?w.globalStorageHome:(0,A.joinPath)(s,"globalStorage"),settingsResource:w&&b?.useDefaultFlags?.settings?w.settingsResource:(0,A.joinPath)(s,"settings.json"),keybindingsResource:w&&b?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,A.joinPath)(s,"keybindings.json"),tasksResource:w&&b?.useDefaultFlags?.tasks?w.tasksResource:(0,A.joinPath)(s,"tasks.json"),snippetsHome:w&&b?.useDefaultFlags?.snippets?w.snippetsHome:(0,A.joinPath)(s,"snippets"),extensionsResource:w&&b?.useDefaultFlags?.extensions?w.extensionsResource:(0,A.joinPath)(s,"extensions.json"),cacheHome:(0,A.joinPath)(u,i),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}e.toUserDataProfile=r;let o=class extends L.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,s,u,b){super(),this.environmentService=n,this.fileService=s,this.uriIdentityService=u,this.logService=b,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const n=this.createDefaultProfile(),s=[n];if(this.enabled)try{for(const w of this.getStoredProfiles()){if(!w.name||!(0,p.isString)(w.name)||!w.location){this.logService.warn("Skipping the invalid stored profile",w.location||w.name);continue}s.push(r((0,A.basename)(w.location),w.name,w.location,this.profilesCacheHome,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},n))}}catch(w){this.logService.error(w)}const u=new h.ResourceMap,b=new Map;if(s.length)try{const w=this.getStoredProfileAssociations();if(w.workspaces)for(const[S,k]of Object.entries(w.workspaces)){const $=T.URI.parse(S),ee=s.find(Z=>Z.id===k);ee&&u.set($,ee)}if(w.emptyWindows)for(const[S,k]of Object.entries(w.emptyWindows)){const $=s.find(ee=>ee.id===k);$&&b.set(S,$)}}catch(w){this.logService.error(w)}this._profilesObject={profiles:s,workspaces:u,emptyWindows:b}}return this._profilesObject}createDefaultProfile(){const n=r("__default__profile__",(0,P.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...n,extensionsResource:this.getDefaultProfileExtensionsLocation()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const s="Temp",u=new RegExp(`${(0,c.escapeRegExpCharacters)(s)}\\s(\\d+)`);let b=0;for(const S of this.profiles){const k=u.exec(S.name),$=k?parseInt(k[1]):0;b=$>b?$:b}const w=`${s} ${b+1}`;return this.createProfile((0,N.hash)((0,v.generateUuid)()).toString(16),w,{transient:!0},n)}async createNamedProfile(n,s,u){return this.createProfile((0,N.hash)((0,v.generateUuid)()).toString(16),n,s,u)}async createProfile(n,s,u,b){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const w=await this.doCreateProfile(n,s,u);return b&&await this.setProfileForWorkspace(b,w),w}async doCreateProfile(n,s,u){if(!(0,p.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.profileCreationPromises.get(s);return b||(b=(async()=>{try{const w=this.profiles.find($=>$.name===s||$.id===n);if(w)return w;const S=r(n,s,(0,A.joinPath)(this.profilesHome,n),this.profilesCacheHome,u,this.defaultProfile);await this.fileService.createFolder(S.location);const k=[];return this._onWillCreateProfile.fire({profile:S,join($){k.push($)}}),await E.Promises.settled(k),this.updateProfiles([S],[],[]),S}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,b)),b}async updateProfile(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(b=>b.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=r(u.id,s.name??u.name,u.location,this.profilesCacheHome,{shortName:s.shortName??u.shortName,icon:s.icon===null?void 0:s.icon??u.icon,transient:s.transient??u.isTransient,useDefaultFlags:s.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[u]),u}async removeProfile(n){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(b=>b.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:s,join(b){u.push(b)}});try{await Promise.allSettled(u)}catch(b){this.logService.error(b)}for(const b of[...this.profilesObject.emptyWindows.keys()])s.id===this.profilesObject.emptyWindows.get(b)?.id&&this.profilesObject.emptyWindows.delete(b);for(const b of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(b)?.id&&this.profilesObject.workspaces.delete(b);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{await this.fileService.del(s.cacheHome,{recursive:!0})}catch(b){(0,l.toFileOperationResult)(b)!==1&&this.logService.error(b)}}async setProfileForWorkspace(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(b=>b.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(n,u)}unsetWorkspace(n,s){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(n,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.getWorkspace(n);return T.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindows.get(s)??this.profilesObject.emptyWindows.get(s)}getWorkspace(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:n.id}isProfileAssociatedToWorkspace(n){return!!([...this.transientProfilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.profilesObject.emptyWindows.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location)))}updateProfiles(n,s,u){const b=[...this.profiles,...n],w=[];this.transientProfilesObject.profiles=[];for(let S of b)S.isDefault||s.some(k=>S.id===k.id)||(S=u.find(k=>S.id===k.id)??S,S.isTransient?this.transientProfilesObject.profiles.push(S):w.push({location:S.location,name:S.name,shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags}));this.saveStoredProfiles(w),this._profilesObject=void 0,this.triggerProfilesChanges(n,s,u)}triggerProfilesChanges(n,s,u){this._onDidChangeProfiles.fire({added:n,removed:s,updated:u,all:this.profiles})}updateWorkspaceAssociation(n,s,u){u=s?.isTransient?!0:u,u||this.updateWorkspaceAssociation(n,void 0,!0);const b=this.getWorkspace(n),w=u?this.transientProfilesObject:this.profilesObject;T.URI.isUri(b)?(w.workspaces.delete(b),s&&w.workspaces.set(b,s)):(w.emptyWindows.delete(b),s&&w.emptyWindows.set(b,s)),u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[u,b]of this.profilesObject.workspaces.entries())n[u.toString()]=b.id;const s={};for(const[u,b]of this.profilesObject.emptyWindows.entries())s[u.toString()]=b.id;this.saveStoredProfileAssociations({workspaces:n,emptyWindows:s}),this._profilesObject=void 0}migrateStoredProfileAssociations(n){const s={},u=this.createDefaultProfile();if(n.workspaces)for(const[w,S]of Object.entries(n.workspaces)){const k=T.URI.parse(S);s[w]=this.uriIdentityService.extUri.isEqual(k,u.location)?u.id:this.uriIdentityService.extUri.basename(k)}const b={};if(n.emptyWindows)for(const[w,S]of Object.entries(n.emptyWindows)){const k=T.URI.parse(S);b[w]=this.uriIdentityService.extUri.isEqual(k,u.location)?u.id:this.uriIdentityService.extUri.basename(k)}return{workspaces:s,emptyWindows:b}}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=ve([ie(0,f.IEnvironmentService),ie(1,l.IFileService),ie(2,I.IUriIdentityService),ie(3,C.ILogService)],o);class t extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=t}),define(te[155],ne([0,1,19,8,20,9,4,2,13,3,11,92,21,27,37,6,32,26,22,23]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(n,s,u,b,w,S){super(),this.galleryService=n,this.telemetryService=s,this.uriIdentityService=u,this.logService=b,this.productService=w,this.userDataProfilesService=S,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this._onDidUpdateExtensionMetadata=this._register(new T.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:k})=>k.cancel()),this.uninstallingExtensions.forEach(k=>k.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(u=>(0,d.isTargetPlatformCompatible)(u,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{const b=(await this.installGalleryExtensions([{extension:n,options:s}])).find(({identifier:w})=>(0,h.areSameExtensions)(w,n.identifier));if(b?.local)return b?.local;throw b?.error?b.error:r(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(u){throw r(u)}}async installGalleryExtensions(n){if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(C.localize(0,null),d.ExtensionManagementErrorCode.Internal);const s=[],u=[];await Promise.allSettled(n.map(async({extension:b,options:w})=>{try{const S=await this.checkAndGetCompatibleVersion(b,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);u.push({...S,options:w})}catch(S){s.push({identifier:b.identifier,operation:2,source:b,error:S})}})),u.length&&s.push(...await this.installExtensions(u));for(const b of s)b.error&&(this.logService.error("Failed to install extension.",b.identifier.id),this.logService.error(b.error),b.source&&!D.URI.isUri(b.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(b.source),error:b.error}));return s}async uninstall(n,s={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,s)}async toggleAppliationScope(n,s){if((0,I.isApplicationScopedExtension)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let u=await this.updateMetadata(n,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)||(u=await this.copyExtension(n,this.userDataProfilesService.defaultProfile.extensionsResource,s));for(const b of this.userDataProfilesService.profiles){const w=(await this.getInstalled(1,b.extensionsResource)).find(S=>(0,h.areSameExtensions)(S.identifier,n.identifier));w?this._onDidUpdateExtensionMetadata.fire(w):this._onDidUninstallExtension.fire({identifier:n.identifier,profileLocation:b.extensionsResource})}return u}else{const u=this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(n,s,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:u.identifier,operation:2,local:u,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtensions(n){const s=[];return await Promise.allSettled(n.map(async u=>{try{const b=await this.installExtension(u,(w,S)=>n.some(k=>(0,h.adoptToGalleryExtensionId)(S.identifier.id)===(0,h.getGalleryExtensionId)(k.manifest.publisher,k.manifest.name))?!1:this.canWaitForTask(w,S));s.push(...b)}catch(b){s.push({identifier:{id:(0,h.getGalleryExtensionId)(u.manifest.publisher,u.manifest.name)},operation:2,source:u.extension,error:b})}})),this._onDidInstallExtensions.fire(s),s}async installExtension({manifest:n,extension:s,options:u},b){const w=u.isApplicationScoped||u.isBuiltin||(0,I.isApplicationScopedExtension)(n),S={...u,installOnlyNewlyAddedFromExtensionPack:D.URI.isUri(s)?u.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.userDataProfilesService.defaultProfile.extensionsResource:u.profileLocation??this.getCurrentExtensionsManifestLocation()},k=ue=>`${h.ExtensionKey.create(ue).toString()}${S.profileLocation?`-${S.profileLocation.toString()}`:""}`;if(!D.URI.isUri(s)){const ue=this.installingExtensions.get(k(s));if(ue)return this.logService.info("Extensions is already requested to install",s.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const $=[],ee=[],Z=[],se=this.createInstallExtensionTask(n,s,S);D.URI.isUri(s)||this.installingExtensions.set(k(s),{task:se,waitingTasks:[]}),this._onInstallExtension.fire({identifier:se.identifier,source:s,profileLocation:S.profileLocation}),this.logService.info("Installing extension:",se.identifier.id),$.push({task:se,manifest:n});let re=!1;try{if(S.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",se.identifier.id);else try{const le=await this.getAllDepsAndPackExtensions(se.identifier,n,!!S.installOnlyNewlyAddedFromExtensionPack,!!S.installPreReleaseVersion,S.profileLocation),oe=await this.getInstalled(void 0,S.profileLocation),W={...S,donotIncludePackAndDependencies:!0,context:{...S.context,[d.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:K,manifest:V}of(0,N.distinct)(le,({gallery:_})=>_.identifier.id)){re=re||!!V.extensionDependencies?.some(G=>(0,h.areSameExtensions)({id:G},se.identifier));const _=k(K),j=this.installingExtensions.get(_);if(j){if(b(se,j.task)){const G=j.task.identifier;this.logService.info("Waiting for already requested installing extension",G.id,se.identifier.id),j.waitingTasks.push(se),ee.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,X=>X.some(J=>(0,h.areSameExtensions)(J.identifier,G)))).then(X=>{if(this.logService.info("Finished waiting for already requested installing extension",G.id,se.identifier.id),!X.find(M=>(0,h.areSameExtensions)(M.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!oe.some(({identifier:G})=>(0,h.areSameExtensions)(G,K.identifier))){const G=this.createInstallExtensionTask(V,K,W);this.installingExtensions.set(_,{task:G,waitingTasks:[se]}),this._onInstallExtension.fire({identifier:G.identifier,source:K,profileLocation:S.profileLocation}),this.logService.info("Installing extension:",G.identifier.id,se.identifier.id),$.push({task:G,manifest:V})}}}catch(le){if(D.URI.isUri(se.source))(0,N.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",se.identifier.id,le.message),(0,N.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",se.identifier.id,le.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",se.identifier.id),le}const ue=$.reduce((le,{task:oe,manifest:W})=>(le.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:W}),le),new Map);for(;ue.size;){let le;const oe=[...ue.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(K=>ue.has(K.toLowerCase())));oe.length?le=ue.size===1?oe:oe.filter(({task:W})=>!(W===se&&!re)):(this.logService.info("Found extensions with circular dependencies",oe.map(({task:W})=>W.identifier.id)),le=[...ue.values()]),await this.joinAllSettled(le.map(async({task:W})=>{const K=new Date().getTime();try{const V=await W.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(V,W.source,S,L.CancellationToken.None))),!D.URI.isUri(W.source)){const _=W.operation===3,j=_?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(o(this.telemetryService,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-K,durationSinceUpdate:j}),f.isWeb&&W.operation!==3)try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}Z.push({local:V,identifier:W.identifier,operation:W.operation,source:W.source,context:W.options.context,profileLocation:W.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw D.URI.isUri(W.source)||o(this.telemetryService,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-K,error:V}),this.logService.error("Error while installing the extension:",W.identifier.id),V}finally{ue.delete(W.identifier.id.toLowerCase())}}))}return ee.length&&await this.joinAllSettled(ee),Z.forEach(({identifier:le})=>this.logService.info("Extension installed successfully:",le.id)),Z}catch(ue){if($.forEach(({task:le})=>le.cancel()),Z.length)try{const le=await Promise.allSettled(Z.map(({local:oe})=>this.createUninstallExtensionTask(oe,{versionOnly:!0,profileLocation:S.profileLocation}).run()));for(let oe=0;oe<le.length;oe++){const W=le[oe],{identifier:K}=Z[oe];W.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",K.id):this.logService.warn("Rollback: Error while uninstalling extension",K.id,(0,A.getErrorMessage)(W.reason))}}catch(le){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(le),Z.map(({identifier:oe})=>oe.id))}return $.map(({task:le})=>({identifier:le.identifier,operation:2,source:le.source,context:S.context,profileLocation:S.profileLocation,error:ue}))}finally{for(const{task:ue}of $)ue.source&&!D.URI.isUri(ue.source)&&this.installingExtensions.delete(k(ue.source))}}canWaitForTask(n,s){for(const[,{task:u,waitingTasks:b}]of this.installingExtensions.entries())if(u===n&&(b.includes(s)||b.some(w=>this.canWaitForTask(w,s)))||u===s&&b[0]&&!this.canWaitForTask(n,b[0]))return!1;return!0}async joinAllSettled(n){const s=[],u=[],b=await Promise.allSettled(n);for(const w of b)w.status==="fulfilled"?s.push(w.value):u.push(w.reason);if(u.length)throw y(u);return s}async getAllDepsAndPackExtensions(n,s,u,b,w){if(!this.galleryService.isEnabled())return[];const S=await this.getInstalled(void 0,w),k=[],$=[],ee=async(Z,se)=>{k.push(Z);const re=se.extensionDependencies||[],ue=[...re];if(se.extensionPack){const le=u?S.find(oe=>(0,h.areSameExtensions)(oe.identifier,Z)):void 0;for(const oe of se.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(W=>(0,h.areSameExtensions)({id:W},{id:oe}))||ue.every(W=>!(0,h.areSameExtensions)({id:W},{id:oe}))&&ue.push(oe)}if(ue.length){const le=ue.filter(oe=>k.every(W=>!(0,h.areSameExtensions)(W,{id:oe})));if(le.length){const oe=await this.galleryService.getExtensions(le.map(W=>({id:W,preRelease:b})),L.CancellationToken.None);for(const W of oe){if(k.find(_=>(0,h.areSameExtensions)(_,W.identifier)))continue;const K=re.some(_=>(0,h.areSameExtensions)({id:_},W.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(W,!1,b)}catch(_){if(K)throw _;this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.getErrorMessage)(_));continue}$.push({gallery:V.extension,manifest:V.manifest}),await ee(V.extension.identifier,V.manifest)}}}};return await ee(n,s),$}async checkAndGetCompatibleVersion(n,s,u){let b;const w=await this.getExtensionsControlManifest();if(w.malicious.some($=>(0,h.areSameExtensions)(n.identifier,$)))throw new d.ExtensionManagementError(C.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const S=w.deprecated[n.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.logService.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),b=(await this.galleryService.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!b)throw new d.ExtensionManagementError(C.localize(2,null,n.identifier.id,S.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const $=await this.getTargetPlatform();throw new d.ExtensionManagementError(C.localize(3,null,n.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)($)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.getCompatibleVersion(n,s,u),!b)throw!u&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],L.CancellationToken.None))[0]?new d.ExtensionManagementError(C.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(C.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",b.identifier.id);const k=await this.galleryService.getManifest(b,L.CancellationToken.None);if(k===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${b.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(k.version!==b.version)throw new d.ExtensionManagementError(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:k}}async getCompatibleVersion(n,s,u){const b=await this.getTargetPlatform();let w=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==u&&(w=(await this.galleryService.getExtensions([{...n.identifier,preRelease:u}],{targetPlatform:b,compatible:!0},L.CancellationToken.None))[0]||null),!w&&await this.galleryService.isExtensionCompatible(n,u,b)&&(w=n),w||(s?w=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:b,compatible:!0},L.CancellationToken.None))[0]||null:w=await this.galleryService.getCompatibleExtension(n,u,b)),w}async uninstallExtension(n,s){const u={...s,profileLocation:n.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation??this.getCurrentExtensionsManifestLocation()},b=Z=>`${Z.id.toLowerCase()}${u.versionOnly?`-${n.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,w=this.uninstallingExtensions.get(b(n.identifier));if(w)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),w.waitUntilTaskIsFinished();const S=Z=>{const se=this.createUninstallExtensionTask(Z,u);return this.uninstallingExtensions.set(b(se.extension.identifier),se),u.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,u.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this._onUninstallExtension.fire({identifier:Z.identifier,profileLocation:u.profileLocation,applicationScoped:Z.isApplicationScoped}),se},k=(Z,se)=>{se?u.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,u.profileLocation.toString(),se.message):this.logService.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,se.message):u.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,u.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(Z),error:se}),this._onDidUninstallExtension.fire({identifier:Z.identifier,error:se?.code,profileLocation:u.profileLocation,applicationScoped:Z.isApplicationScoped})},$=[],ee=[];try{$.push(S(n));const Z=await this.getInstalled(1,u.profileLocation);if(u.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const se=this.getAllPackExtensionsToUninstall(n,Z);for(const re of se)this.uninstallingExtensions.has(b(re.identifier))?this.logService.info("Extensions is already requested to uninstall",re.identifier.id):$.push(S(re))}u.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents($.map(se=>se.extension),Z,n),await this.joinAllSettled($.map(async se=>{try{if(await se.run(),await this.joinAllSettled(this.participants.map(re=>re.postUninstall(se.extension,u,L.CancellationToken.None))),se.extension.identifier.uuid)try{await this.galleryService.reportStatistic(se.extension.manifest.publisher,se.extension.manifest.name,se.extension.manifest.version,"uninstall")}catch{}k(se.extension)}catch(re){const ue=re instanceof d.ExtensionManagementError?re:new d.ExtensionManagementError((0,A.getErrorMessage)(re),d.ExtensionManagementErrorCode.Internal);throw k(se.extension,ue),ue}finally{ee.push(se)}}))}catch(Z){const se=Z instanceof d.ExtensionManagementError?Z:new d.ExtensionManagementError((0,A.getErrorMessage)(Z),d.ExtensionManagementErrorCode.Internal);for(const re of $){try{re.cancel()}catch{}ee.includes(re)||k(re.extension,se)}throw se}finally{for(const Z of $)this.uninstallingExtensions.delete(b(Z.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}checkForDependents(n,s,u){for(const b of n){const w=this.getDependents(b,s);if(w.length){const S=w.filter(k=>!n.some($=>(0,h.areSameExtensions)($.identifier,k.identifier)));if(S.length)throw new Error(this.getDependentsErrorMessage(b,S,u))}}}getDependentsErrorMessage(n,s,u){return u===n?s.length===1?C.localize(6,null,u.manifest.displayName||u.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(7,null,u.manifest.displayName||u.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(8,null,u.manifest.displayName||u.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?C.localize(9,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?C.localize(10,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):C.localize(11,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(n,s,u=[]){if(u.indexOf(n)!==-1)return[];u.push(n);const b=n.manifest.extensionPack?n.manifest.extensionPack:[];if(b.length){const w=s.filter(k=>!k.isBuiltin&&b.some($=>(0,h.areSameExtensions)({id:$},k.identifier))),S=[];for(const k of w)S.push(...this.getAllPackExtensionsToUninstall(k,s,u));return[...w,...S]}return[]}getDependents(n,s){return s.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(b=>(0,h.areSameExtensions)({id:b},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=g,e.AbstractExtensionManagementService=g=ve([ie(0,d.IExtensionGalleryService),ie(1,c.ITelemetryService),ie(2,p.IUriIdentityService),ie(3,E.ILogService),ie(4,v.IProductService),ie(5,R.IUserDataProfilesService)],g);function y(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,u)=>new Error(`${s.message}${s.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}e.joinErrors=y;function r(i){if(i instanceof d.ExtensionManagementError)return i;const n=new d.ExtensionManagementError(i.message,d.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.toExtensionManagementError=r;function o(i,n,{extensionData:s,verificationStatus:u,duration:b,error:w,durationSinceUpdate:S}){let k,$;(0,l.isDefined)(u)&&(u===!0?u="Verified":(u===!1||(k=d.ExtensionManagementErrorCode.Signature,$=u),u="Unverified")),w&&(w instanceof d.ExtensionManagementError?(k=w.code,w.code===d.ExtensionManagementErrorCode.Signature&&($=w.message)):k=d.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...s,verificationStatus:u,success:!w,duration:b,errorcode:k,errorcodeDetail:$,durationSinceUpdate:S})}class t{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(n=>new Promise((s,u)=>{const b=n.onCancellationRequested(()=>{b.dispose(),u(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class R extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=R,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let g=class extends L.Disposable{constructor(t,i,n,s,u,b){super(),this.extensionsLocation=t,this.fileService=i,this.userDataProfilesService=n,this.uriIdentityService=s,this.telemetryService=u,this.logService=b,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(t,i){return this.withProfileExtensions(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],s=[];try{return await this.withProfileExtensions(i,u=>{const b=[];for(const w of u)t.some(([S])=>(0,l.areSameExtensions)(S.identifier,w.identifier)&&S.manifest.version!==w.version)?n.push(w):b.push(w);for(const[w,S]of t){const k=b.findIndex(ee=>(0,l.areSameExtensions)(ee.identifier,w.identifier)&&ee.version===w.manifest.version),$={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:S};k===-1?(s.push($),b.push($)):b.splice(k,1,$)}return s.length&&this._onAddExtensions.fire({extensions:s,profileLocation:i}),n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),b}),s.length&&this._onDidAddExtensions.fire({extensions:s,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i}),s}catch(u){throw s.length&&this._onDidAddExtensions.fire({extensions:s,error:u,profileLocation:i}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:u,profileLocation:i}),u}}async updateMetadata(t,i){const n=[];return await this.withProfileExtensions(i,s=>{const u=[];for(const b of s){const w=t.find(([S])=>(0,l.areSameExtensions)(S.identifier,b.identifier)&&S.manifest.version===b.version);w&&(b.metadata={...b.metadata,...w[1]},n.push(b)),u.push(b)}return u}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.withProfileExtensions(i,s=>{const u=[];for(const b of s)(0,l.areSameExtensions)(b.identifier,t.identifier)?n.push(b):u.push(b);return n.length&&this._onRemoveExtensions.fire({extensions:n,profileLocation:i}),u}),n.length&&this._onDidRemoveExtensions.fire({extensions:n,profileLocation:i})}catch(s){throw n.length&&this._onDidRemoveExtensions.fire({extensions:n,error:s,profileLocation:i}),s}}async withProfileExtensions(t,i,n){return this.getResourceAccessQueue(t).queue(async()=>{let s=[],u;try{const b=await this.fileService.readFile(t);u=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,D.toFileOperationResult)(b)!==1)throw b;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(u=await this.migrateFromOldDefaultProfileExtensionsLocation()),!u&&n?.bailOutWhenFileNotFound)throw new R((0,v.getErrorMessage)(b),"ERROR_PROFILE_NOT_FOUND")}if(u){Array.isArray(u)||this.reportAndThrowInvalidConentError(t);let b=!1;for(const w of u){y(w)||this.reportAndThrowInvalidConentError(t);let S;if((0,E.isString)(w.relativeLocation)&&w.relativeLocation)S=this.resolveExtensionLocation(w.relativeLocation);else if((0,E.isString)(w.location))S=this.resolveExtensionLocation(w.location),b=!0,w.relativeLocation=w.location,w.location=S.toJSON();else{S=P.URI.revive(w.location);const k=this.toRelativePath(S);k&&(b=!0,w.relativeLocation=k)}s.push({identifier:w.identifier,location:S,version:w.version,metadata:w.metadata})}b&&await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(u)))}if(i){s=i(s);const b=s.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.toRelativePath(w.location),metadata:w.metadata}));await this.fileService.writeFile(t,O.VSBuffer.fromString(JSON.stringify(b)))}return s})}reportAndThrowInvalidConentError(t){const i=new R(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let n;try{n=(await this.fileService.readFile(t)).value.toString()}catch(u){if((0,D.toFileOperationResult)(u)===1)return;throw u}this.logService.info("Migrating extensions from old default profile location",t.toString());let s;try{const u=JSON.parse(n);Array.isArray(u)&&u.every(b=>y(b))?s=u:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.logService.error(u)}if(s)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(u){if((0,D.toFileOperationResult)(u)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw u}try{await this.fileService.del(t)}catch(u){(0,D.toFileOperationResult)(u)!==1&&this.logService.error(u)}try{await this.fileService.del(i)}catch(u){(0,D.toFileOperationResult)(u)!==1&&this.logService.error(u)}return s})()),this._migrationPromise}getResourceAccessQueue(t){let i=this.resourcesAccessQueueMap.get(t);return i||(i=new N.Queue,this.resourcesAccessQueueMap.set(t,i)),i}};e.AbstractExtensionsProfileScannerService=g,e.AbstractExtensionsProfileScannerService=g=ve([ie(1,D.IFileService),ie(2,h.IUserDataProfilesService),ie(3,I.IUriIdentityService),ie(4,c.ITelemetryService),ie(5,d.ILogService)],g);function y(o){return(0,E.isObject)(o)&&(0,f.isIExtensionIdentifier)(o.identifier)&&(r(o.location)||(0,E.isString)(o.location)&&o.location)&&((0,E.isUndefined)(o.relativeLocation)||(0,E.isString)(o.relativeLocation))&&o.version&&(0,E.isString)(o.version)}function r(o){return o?(0,E.isString)(o.path)&&(0,E.isString)(o.scheme):!1}}),define(te[51],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,96,18,27,37,49,12,10,6,32,4,46,40,23,22,113]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p,R,g,y,r,o,t,i,n,s,u,b,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var $;(function(oe){function W(K,V){if(K===V)return!0;const _=Object.keys(K),j=new Set;for(const G of Object.keys(V))j.add(G);if(_.length!==j.size)return!1;for(const G of _){if(K[G]!==V[G])return!1;j.delete(G)}return j.size===0}oe.equals=W})($||(e.Translations=$={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let ee=class extends l.Disposable{constructor(W,K,V,_,j,G,X,J,M,F,a,m){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=K,this.extensionsControlLocation=V,this.currentProfile=_,this.userDataProfilesService=j,this.extensionsProfileScannerService=G,this.fileService=X,this.logService=J,this.environmentService=M,this.productService=F,this.uriIdentityService=a,this.instantiationService=m,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(se,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,K,V){const[_,j]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(K)]),G=V?await this.scanExtensionsUnderDevelopment(W,[..._,...j]):[];return this.dedupExtensions(_,j,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const K=[];K.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),K.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[V,_]=await Promise.all(K);return this.applyScanOptions([...V,..._],0,W,!1)}async scanUserExtensions(W){const K=W.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",K);const V=this.uriIdentityService.extUri.isEqual(W.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,_=await this.createExtensionScannerInput(K,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V),j=W.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let G;try{G=await j.scanExtensions(_)}catch(X){if(X instanceof b.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),G=await j.scanExtensions(_);else throw X}return G=await this.applyScanOptions(G,1,W,!0),this.logService.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(W,K){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(_=>_.scheme===D.Schemas.file).map(async _=>{const j=await this.createExtensionScannerInput(_,!1,1,!0,W.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(j)).map(X=>(X.type=K.find(J=>(0,g.areSameExtensions)(J.identifier,X.identifier))?.type??X.type,this.extensionsScanner.validate(X,j)))}))).flat();return this.applyScanOptions(V,"development",W,!0)}return[]}async scanExistingExtension(W,K,V){const _=await this.createExtensionScannerInput(W,!1,K,!0,V.language,!0,void 0),j=await this.extensionsScanner.scanExtension(_);return!j||!V.includeInvalid&&!j.isValid?null:j}async scanOneOrMultipleExtensions(W,K,V){const _=await this.createExtensionScannerInput(W,!1,K,!0,V.language,!0,void 0),j=await this.extensionsScanner.scanOneOrMultipleExtensions(_);return this.applyScanOptions(j,K,V,!0)}async scanMetadata(W){const K=(0,h.joinPath)(W,"package.json"),V=(await this.fileService.readFile(K)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,K){const V=(0,h.joinPath)(W,"package.json"),_=(await this.fileService.readFile(V)).value.toString(),j=JSON.parse(_);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,j.__metadata={...j.__metadata,...K},await this.fileService.writeFile((0,h.joinPath)(W,"package.json"),A.VSBuffer.fromString(JSON.stringify(j,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof b.ExtensionsProfileScanningError&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw W}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.extensionsProfileScannerService.addExtensionsToProfile(W.map(K=>[K,K.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(K){(0,o.toFileOperationResult)(K)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(K))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.logService.error(W)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(W,K,V,_){return V.includeAllVersions||(W=this.dedupExtensions(K===0?W:void 0,K===1?W:void 0,K==="development"?W:void 0,await this.getTargetPlatform(),_)),V.includeInvalid||(W=W.filter(j=>j.isValid)),W.sort((j,G)=>{const X=C.basename(j.location.fsPath),J=C.basename(G.location.fsPath);return X<J?-1:X>J?1:0})}dedupExtensions(W,K,V,_,j){const G=(J,M,F)=>{if(J.isValid&&!M.isValid)return!1;if(J.isValid===M.isValid){if(j&&I.gt(J.manifest.version,M.manifest.version))return this.logService.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(I.eq(J.manifest.version,M.manifest.version)){if(J.type===0)return this.logService.debug(`Skipping extension ${M.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===_)return this.logService.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.logService.warn(`Overwriting user extension ${J.location.path} with ${M.location.path}.`):this.logService.debug(`Overwriting user extension ${J.location.path} with ${M.location.path}.`),!0},X=new y.ExtensionIdentifierMap;return W?.forEach(J=>{const M=X.get(J.identifier.id);(!M||G(M,J,!1))&&X.set(J.identifier.id,J)}),K?.forEach(J=>{const M=X.get(J.identifier.id);if(!M&&W&&J.type===0){this.logService.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!M||G(M,J,!1))&&X.set(J.identifier.id,J)}),V?.forEach(J=>{const M=X.get(J.identifier.id);(!M||G(M,J,!0))&&X.set(J.identifier.id,J),X.set(J.identifier.id,J)}),[...X.values()]}async scanDefaultSystemExtensions(W,K){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),j=await(W&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",j.length),j}async scanDevSystemExtensions(W,K){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const _=K?await this.getBuiltInExtensionControl():{},j=[],G=c.URI.file(C.normalize(C.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of V){const M=_[J.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":j.push((0,h.joinPath)(G,J.name));break;default:j.push(c.URI.file(M));break}}const X=await Promise.all(j.map(async J=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(J,!1,0,!0,W,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",X.length),(0,N.coalesce)(X)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,K,V,_,j,G,X){const J=await this.getTranslations(j??d.language),M=await this.getMtime(W),F=K&&!this.uriIdentityService.extUri.isEqual(W,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,a=F?await this.getMtime(F):void 0;return new Z(W,M,F,a,K,X,V,_,G,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,j,J)}async getMtime(W){try{const K=await this.fileService.stat(W);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.AbstractExtensionsScannerService=ee,e.AbstractExtensionsScannerService=ee=ve([ie(4,w.IUserDataProfilesService),ie(5,b.IExtensionsProfileScannerService),ie(6,o.IFileService),ie(7,i.ILogService),ie(8,R.IEnvironmentService),ie(9,n.IProductService),ie(10,S.IUriIdentityService),ie(11,t.IInstantiationService)],ee);class Z{constructor(W,K,V,_,j,G,X,J,M,F,a,m,x,U,H){this.location=W,this.mtime=K,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=_,this.profile=j,this.profileScanOptions=G,this.type=X,this.excludeObsolete=J,this.validate=M,this.productVersion=F,this.productDate=a,this.productCommit=m,this.devMode=x,this.language=U,this.translations=H}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,K){return(0,h.isEqual)(W.location,K.location)&&W.mtime===K.mtime&&(0,h.isEqual)(W.applicationExtensionslocation,K.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&W.profile===K.profile&&L.equals(W.profileScanOptions,K.profileScanOptions)&&W.type===K.type&&W.excludeObsolete===K.excludeObsolete&&W.validate===K.validate&&W.productVersion===K.productVersion&&W.productDate===K.productDate&&W.productCommit===K.productCommit&&W.devMode===K.devMode&&W.language===K.language&&$.equals(W.translations,K.translations)}}e.ExtensionScannerInput=Z;let se=class extends l.Disposable{constructor(W,K,V,_,j){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=K,this.uriIdentityService=V,this.fileService=_,this.logService=j}async scanExtensions(W){const K=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let V={};if(W.excludeObsolete&&W.type===1)try{const _=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(_)}catch{}return(0,v.isEmptyObject)(V)?K:K.filter(_=>!V[g.ExtensionKey.create(_).toString()])}async scanExtensionsFromLocation(W){const K=await this.fileService.resolve(W.location);if(!K.children?.length)return[];const V=await Promise.all(K.children.map(async _=>{if(!_.isDirectory||W.type===1&&(0,h.basename)(_.resource).indexOf(".")===0)return null;const j=new Z(_.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(j)}));return(0,N.coalesce)(V).sort((_,j)=>_.location.path<j.location.path?-1:1)}async scanExtensionsFromProfile(W){let K=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){K=K.filter(_=>!_.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,_=>!!_.metadata?.isBuiltin||!!_.metadata?.isApplicationScoped,W);K.push(...V)}return K}async scanExtensionsFromProfileResource(W,K,V){const _=await this.extensionsProfileScannerService.scanProfileExtensions(W,V.profileScanOptions);if(!_.length)return[];const j=await Promise.all(_.map(async G=>{if(K(G)){const X=new Z(G.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(X,G.metadata)}return null}));return(0,N.coalesce)(j)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,h.joinPath)(W.location,"package.json"))){const K=await this.scanExtension(W);return K?[K]:[]}else return await this.scanExtensions(W)}catch(K){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,T.getErrorMessage)(K)),[]}}async scanExtension(W,K){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=y.UNDEFINED_PUBLISHER),K=K??V.__metadata,delete V.__metadata;const _=(0,g.getGalleryExtensionId)(V.publisher,V.name),j=K?.id?{id:_,uuid:K.id}:{id:_},G=K?.isSystem?0:W.type,X=G===0||!!K?.isBuiltin;V=await this.translateManifest(W.location,V,Z.createNlsConfiguration(W));const J={type:G,identifier:j,manifest:V,location:W.location,isBuiltin:X,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return W.validate?this.validate(J,W):J}}catch(V){W.type!==0&&this.logService.error(V)}return null}validate(W,K){let V=!0;const _=(0,r.validateExtensionManifest)(K.productVersion,K.productDate,K.location,W.manifest,W.isBuiltin);for(const[j,G]of _)j===E.default.Error&&(V=!1,this.logService.error(this.formatMessage(K.location,G)));return W.isValid=V,W.validations=_,W}async scanExtensionManifest(W){const K=(0,h.joinPath)(W,"package.json");let V;try{V=(await this.fileService.readFile(K)).value.toString()}catch(j){return(0,o.toFileOperationResult)(j)!==1&&this.logService.error(this.formatMessage(W,(0,p.localize)(0,null,K.path,j.message))),null}let _;try{_=JSON.parse(V)}catch{const G=[];(0,P.parse)(V,G);for(const X of G)this.logService.error(this.formatMessage(W,(0,p.localize)(1,null,K.path,X.offset,X.length,(0,f.getParseErrorMessage)(X.error))));return null}return(0,P.getNodeType)(_)!=="object"?(this.logService.error(this.formatMessage(W,(0,p.localize)(2,null,K.path))),null):_}async translateManifest(W,K,V){const _=await this.getLocalizedMessages(W,K,V);if(_)try{const j=[],G=await this.resolveOriginalMessageBundle(_.default,j);if(j.length>0)return j.forEach(J=>{this.logService.error(this.formatMessage(W,(0,p.localize)(3,null,_.default?.path,(0,f.getParseErrorMessage)(J.error))))}),K;if((0,P.getNodeType)(_)!=="object")return this.logService.error(this.formatMessage(W,(0,p.localize)(4,null,_.default?.path))),K;const X=_.values||Object.create(null);return(0,k.localizeManifest)(this.logService,K,X,G)}catch{}return K}async getLocalizedMessages(W,K,V){const _=(0,h.joinPath)(W,"package.nls.json"),j=(M,F)=>{F.forEach(a=>{this.logService.error(this.formatMessage(W,(0,p.localize)(5,null,M?.path,(0,f.getParseErrorMessage)(a.error))))})},G=M=>{this.logService.error(this.formatMessage(W,(0,p.localize)(6,null,M?.path)))},X=`${K.publisher}.${K.name}`,J=V.translations[X];if(J)try{const M=c.URI.file(J),F=(await this.fileService.readFile(M)).value.toString(),a=[],m=(0,P.parse)(F,a);return a.length>0?(j(M,a),{values:void 0,default:_}):(0,P.getNodeType)(m)!=="object"?(G(M),{values:void 0,default:_}):{values:m.contents?m.contents.package:void 0,default:_}}catch{return{values:void 0,default:_}}else{if(!await this.fileService.exists(_))return;let F;try{F=await this.findMessageBundles(W,V)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const a=(await this.fileService.readFile(F.localized)).value.toString(),m=[],x=(0,P.parse)(a,m);return m.length>0?(j(F.localized,m),{values:void 0,default:F.original}):(0,P.getNodeType)(x)!=="object"?(G(F.localized),{values:void 0,default:F.original}):{values:x,default:F.original}}catch{return{values:void 0,default:F.original}}}}async resolveOriginalMessageBundle(W,K){if(W)try{const V=(await this.fileService.readFile(W)).value.toString();return(0,P.parse)(V,K)}catch{}}findMessageBundles(W,K){return new Promise((V,_)=>{const j=G=>{const X=(0,h.joinPath)(W,`package.nls.${G}.json`);this.fileService.exists(X).then(J=>{J&&V({localized:X,original:(0,h.joinPath)(W,"package.nls.json")});const M=G.lastIndexOf("-");M===-1?V({localized:(0,h.joinPath)(W,"package.nls.json"),original:null}):(G=G.substring(0,M),j(G))})};if(K.devMode||K.pseudo||!K.language)return V({localized:(0,h.joinPath)(W,"package.nls.json"),original:null});j(K.language)})}formatMessage(W,K){return`[${W.path}]: ${K}`}};se=ve([ie(1,b.IExtensionsProfileScannerService),ie(2,S.IUriIdentityService),ie(3,o.IFileService),ie(4,i.ILogService)],se);let re=class extends se{constructor(W,K,V,_,j,G,X){super(K,_,j,G,X),this.currentProfile=W,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new O.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const K=this.getCacheFile(W),V=await this.readExtensionCache(K);if(this.input=W,V&&V.input&&Z.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",W.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(j=>(j.location=c.URI.revive(j.location),j));const _=await super.scanExtensions(W);return await this.writeExtensionCache(K,{input:W,result:_}),_}async readExtensionCache(W){try{const K=await this.fileService.readFile(W),V=JSON.parse(K.value.toString());return{result:V.result,input:(0,u.revive)(V.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",W.path,(0,T.getErrorMessage)(K))}return null}async writeExtensionCache(W,K){try{await this.fileService.writeFile(W,A.VSBuffer.fromString(JSON.stringify(K)))}catch(V){this.logService.debug("Error while writing the extension cache file:",W.path,(0,T.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const W=this.getCacheFile(this.input),K=await this.readExtensionCache(W);if(!K)return;const V=K.result,_=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!L.equals(_,V))try{this.logService.info("Invalidating Cache",V,_),await this.fileService.del(W),this._onDidChangeCache.fire()}catch(j){this.logService.error(j)}}getCacheFile(W){const K=this.getProfile(W);return this.uriIdentityService.extUri.joinPath(K.cacheHome,W.type===0?y.BUILTIN_MANIFEST_CACHE_FILE:y.USER_MANIFEST_CACHE_FILE)}getProfile(W){return W.type===0?this.userDataProfilesService.defaultProfile:W.profile?this.uriIdentityService.extUri.isEqual(W.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(K=>this.uriIdentityService.extUri.isEqual(W.location,K.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};re=ve([ie(2,w.IUserDataProfilesService),ie(3,b.IExtensionsProfileScannerService),ie(4,S.IUriIdentityService),ie(5,o.IFileService),ie(6,i.ILogService)],re);function ue(oe,W){const K=(0,g.getExtensionId)(oe.manifest.publisher,oe.manifest.name);return{id:K,identifier:new y.ExtensionIdentifier(K),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:W,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.toExtensionDescription=ue;class le extends ee{constructor(W,K,V,_,j,G,X,J,M,F,a,m){super(W,K,(0,h.joinPath)(V,".vscode-oss-dev","extensions","control.json"),_,j,G,X,J,M,F,a,m),this.translationsPromise=(async()=>{if(d.translationsConfigFile)try{const x=await this.fileService.readFile(c.URI.file(d.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}e.NativeExtensionsScannerService=le}),define(te[156],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(B,e,N,O,L,A,T,P,f,l,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends T.Disposable{constructor(I,E){super(),this.userDataProfilesService=I,this.logService=E,this.processesLimiter=new O.Limiter(5)}async postUninstall(I){const E=this.parseScript(I,"uninstall");E&&(this.logService.info(I.identifier.id,I.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(E.script,"uninstall",E.args,!0,I),this.logService.info("Finished running post uninstall script",I.identifier.id,I.manifest.version)}catch(v){this.logService.error("Failed to run post uninstall script",I.identifier.id,I.manifest.version),this.logService.error(v)}}));try{await l.Promises.rm(this.getExtensionStoragePath(I))}catch(v){this.logService.error("Error while removing extension storage path",I.identifier.id),this.logService.error(v)}}parseScript(I,E){const v=`vscode:${E}`;if(I.location.scheme===P.Schemas.file&&I.manifest&&I.manifest.scripts&&typeof I.manifest.scripts[v]=="string"){const c=I.manifest.scripts[v].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.logService.warn(I.identifier.id,I.manifest.version,`${v} should be a node script`),null):{script:(0,f.join)(I.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}runLifecycleHook(I,E,v,c,p){return new Promise((R,g)=>{const y=this.start(I,E,v,p);let r;const o=t=>{r&&(clearTimeout(r),r=null),t?g(t):R(void 0)};y.on("error",t=>{o((0,L.toErrorMessage)(t)||"Unknown")}),y.on("exit",(t,i)=>{o(t?`post-${E} process exited with code ${t}`:void 0)}),c&&(r=setTimeout(()=>{r=null,y.kill(),g("timed out")},5e3))})}start(I,E,v,c){const p={silent:!0,execArgv:void 0},R=(0,N.fork)(I,[`--type=extension-post-${E}`,...v],p);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const g=A.Event.fromNodeEventEmitter(R.stdout,"data"),y=A.Event.fromNodeEventEmitter(R.stderr,"data");g(t=>this.logService.info(c.identifier.id,c.manifest.version,`post-${E}`,t)),y(t=>this.logService.error(c.identifier.id,c.manifest.version,`post-${E}`,t));const r=A.Event.any(A.Event.map(g,t=>({data:`%c${t}`,format:[""]})),A.Event.map(y,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(r,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),R}getExtensionStoragePath(I){return(0,f.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,I.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=d,e.ExtensionsLifecycle=d=ve([ie(0,C.IUserDataProfilesService),ie(1,D.ILogService)],d)}),define(te[157],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,48,97,59,18,155,21,27,40,51,142,156,114,135,143,49,12,10,6,32,26,22,23]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p,R,g,y,r,o,t,i,n,s,u,b,w,S,k,$,ee,Z,se,re,ue,le,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,Z.refineServiceDecorator)(t.IExtensionManagementService);const W=".vsctmp";let K=class extends o.AbstractExtensionManagementService{constructor(M,F,a,m,x,U,H,q,ce,ae,me,de){super(M,F,me,a,ae,de),this.extensionsScannerService=x,this.extensionsProfileScannerService=U,this.downloadService=H,this.fileService=ce,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new D.ResourceSet;const ge=this._register(q.createInstance(b.ExtensionsLifecycle));this.extensionsScanner=this._register(q.createInstance(V,fe=>ge.postUninstall(fe))),this.manifestCache=this._register(new S.ExtensionsManifestCache(de,ce,me,this,this.logService)),this.extensionsDownloader=this._register(q.createInstance(u.ExtensionsDownloader));const he=this._register(new k.ExtensionsWatcher(this,this.extensionsScannerService,de,U,me,ce,a));this._register(he.onDidChangeExtensionsByAnotherSource(fe=>this.onDidChangeExtensionsFromAnotherSource(fe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.collectFiles(M),a=await(0,R.zip)((0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)()).fsPath,F);return v.URI.file(a)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:a}=await this.downloadVsix(M),m=d.resolve(F.fsPath);try{return await(0,w.getManifest)(m)}finally{await a()}}getInstalled(M,F=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(M??null,F)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.extensionsScanner.scanUserExtensionAtLocation(M)}async install(M,F={}){this.logService.trace("ExtensionManagementService#install",M.toString());const{location:a,cleanup:m}=await this.downloadVsix(M);try{const x=await(0,w.getManifest)(d.resolve(a.fsPath)),U=(0,i.getGalleryExtensionId)(x.publisher,x.name);if(x.engines&&x.engines.vscode&&!(0,$.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,U,this.productService.version));const q=(await this.installExtensions([{manifest:x,extension:a,options:F}])).find(({identifier:ce})=>(0,i.areSameExtensions)(ce,{id:U}));if(q?.local)return q.local;throw q?.error?q.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await m()}}async installFromLocation(M,F){this.logService.trace("ExtensionManagementService#installFromLocation",M.toString());const a=await this.extensionsScanner.scanUserExtensionAtLocation(M);if(!a)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.addExtensionsToProfile([[a,void 0]],F),this.logService.info("Successfully installed extension",a.identifier.id,F.toString()),a}async installExtensionsFromProfile(M,F,a){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),a.toString());const m=(await this.extensionsScanner.scanExtensions(1,F)).filter(x=>M.some(U=>(0,i.areSameExtensions)(U,x.identifier)));if(m.length){const x=await Promise.all(m.map(U=>this.extensionsScanner.scanMetadata(U,F)));await this.addExtensionsToProfile(m.map((U,H)=>[U,x[H]]),a),this.logService.info("Successfully installed extensions",m.map(U=>U.identifier.id),a.toString())}return m}async updateMetadata(M,F,a=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.extensionsScanner.updateMetadata(M,F,a),this.manifestCache.invalidate(a),this._onDidUpdateExtensionMetadata.fire(M),M}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(1,null));const F=await this.getTargetPlatform(),[a]=await this.galleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},L.CancellationToken.None);if(!a)throw new Error(g.localize(2,null));await this.extensionsScanner.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(m){throw new Error(g.localize(3,null,(0,A.toErrorMessage)(m)))}return this.installFromGallery(a)}copyExtension(M,F,a,m){return this.extensionsScanner.copyExtension(M,F,a,m)}copyExtensions(M,F){return this.extensionsScanner.copyExtensions(M,F)}markAsUninstalled(...M){return this.extensionsScanner.setUninstalled(...M)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(M){this.logService.error(M)}}async download(M,F,a){const{location:m}=await this.extensionsDownloader.download(M,F,!a);return m}async downloadVsix(M){if(M.scheme===C.Schemas.file)return{location:M,async cleanup(){}};this.logService.trace("Downloading extension from",M.toString());const F=(0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,c.generateUuid)());return await this.downloadService.download(M,F),this.logService.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.fileService.del(F)}catch(m){this.logService.error(m)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(M,F,a){if(v.URI.isUri(F))return new G(M,F,a,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const m=i.ExtensionKey.create(F).toString();let x=this.installGalleryExtensionsTasks.get(m);return x||(this.installGalleryExtensionsTasks.set(m,x=new j(M,F,a,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),x.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(m))),x}createUninstallExtensionTask(M,F){return new X(M,F.profileLocation,this.extensionsProfileScannerService)}async collectFiles(M){const F=async m=>{let x=await p.Promises.readdir(m);x=x.map(q=>d.join(m,q));const U=await Promise.all(x.map(q=>p.Promises.stat(q)));let H=Promise.resolve([]);return U.forEach((q,ce)=>{const ae=x[ce];q.isFile()&&(H=H.then(me=>[...me,ae])),q.isDirectory()&&(H=H.then(me=>F(ae).then(de=>[...me,...de])))}),H};return(await F(M.location.fsPath)).map(m=>({path:`extension/${d.relative(M.location.fsPath,m)}`,localPath:m}))}async onDidChangeExtensionsFromAnotherSource({added:M,removed:F}){if(F){const a=M&&this.uriIdentityService.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(m=>M.extensions.every(x=>!(0,i.areSameExtensions)(x,m))):F.extensions;for(const m of a)this.logService.info("Extensions removed from another source",m.id,F.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:m,profileLocation:F.profileLocation})}if(M){const m=(await this.extensionsScanner.scanExtensions(1,M.profileLocation)).filter(x=>M.extensions.some(U=>(0,i.areSameExtensions)(U,x.identifier)));this._onDidInstallExtensions.fire(m.map(x=>(this.logService.info("Extensions added from another source",x.identifier.id,M.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:M.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(F=>this.knownDirectories.add(F)));const M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.knownDirectories.add(F.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(F=>this.onDidFilesChange(F)))}async onDidFilesChange(M){if(!M.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const F=[];for(const a of M.rawAdded){if(this.knownDirectories.has(a)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(a),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(a,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(a).startsWith(".")||!(await this.fileService.stat(a)).isDirectory)continue;const m=await this.extensionsScanner.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.knownDirectories.add(a),F.push(m))}F.length&&(await this.addExtensionsToProfile(F.map(a=>[a,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",F.map(a=>a.identifier.id)))}async addExtensionsToProfile(M,F){const a=M.map(m=>m[0]);await this.setInstalled(a),await this.extensionsProfileScannerService.addExtensionsToProfile(M,F),this._onDidInstallExtensions.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:F})))}async setInstalled(M){const F=await this.extensionsScanner.getUninstalledExtensions();for(const a of M){const m=i.ExtensionKey.create(a);F[m.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",m.id),await this.extensionsScanner.setInstalled(m),this.logService.info("Removed the extension from uninstalled list:",m.id))}}};e.ExtensionManagementService=K,e.ExtensionManagementService=K=ve([ie(0,t.IExtensionGalleryService),ie(1,ue.ITelemetryService),ie(2,se.ILogService),ie(3,r.INativeEnvironmentService),ie(4,s.IExtensionsScannerService),ie(5,n.IExtensionsProfileScannerService),ie(6,y.IDownloadService),ie(7,Z.IInstantiationService),ie(8,ee.IFileService),ie(9,re.IProductService),ie(10,le.IUriIdentityService),ie(11,oe.IUserDataProfilesService)],K);let V=class extends l.Disposable{constructor(M,F,a,m,x,U){super(),this.beforeRemovingExtension=M,this.fileService=F,this.extensionsScannerService=a,this.extensionsProfileScannerService=m,this.uriIdentityService=x,this.logService=U,this._onExtract=this._register(new P.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new N.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(M,F){const a={includeInvalid:!0,profileLocation:F};let m=[];return M===null||M===0?m.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},a,!1)):M===1&&m.push(...await this.extensionsScannerService.scanUserExtensions(a)),m=M!==null?m.filter(x=>x.type===M):m,Promise.all(m.map(x=>this.toLocalExtension(x)))}async scanAllUserExtensions(M){const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(a=>this.toLocalExtension(a)))}async scanUserExtensionAtLocation(M){try{const F=await this.extensionsScannerService.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.toLocalExtension(F)}catch(F){this.logService.error(F)}return null}async extractUserExtension(M,F,a,m,x){const U=M.toString(),H=v.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,c.generateUuid)()}`)),q=v.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let ce=await this.fileService.exists(q);if(ce&&m){try{await this.deleteExtensionFromLocation(M.id,q,"removeExisting")}catch{throw new t.ExtensionManagementError(g.localize(4,null,q.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.logService.trace(`Started extracting the extension from ${F} to ${q.fsPath}`),await(0,R.extract)(F,H.fsPath,{sourcePath:"extension",overwrite:!0},x),this.logService.info(`Extracted extension to ${q}:`,M.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof R.ExtractError&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ae.message,me)}await this.extensionsScannerService.updateMetadata(H,a);try{this.logService.trace(`Started renaming the extension from ${H.fsPath} to ${q.fsPath}`),await this.rename(H.fsPath,q.fsPath),this.logService.info("Renamed to",q.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(ae)}. Deleted from extracted location`,H),ae}this._onExtract.fire(q)}catch(ae){try{await this.fileService.del(H,{recursive:!0})}catch{}throw ae}return this.scanLocalExtension(q,1)}async scanMetadata(M,F){return F?(await this.getScannedExtension(M,F))?.metadata:this.extensionsScannerService.scanMetadata(M.location)}async getScannedExtension(M,F){return(await this.extensionsProfileScannerService.scanProfileExtensions(F)).find(m=>(0,i.areSameExtensions)(m.identifier,M.identifier))}async updateMetadata(M,F,a){return a?await this.extensionsProfileScannerService.updateMetadata([[M,F]],a):await this.extensionsScannerService.updateMetadata(M.location,F),this.scanLocalExtension(M.location,M.type,a)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...M){const F=M.map(a=>i.ExtensionKey.create(a));await this.withUninstalledExtensions(a=>F.forEach(m=>{a[m.toString()]=!0,this.logService.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(M){await this.withUninstalledExtensions(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.uriIdentityService.extUri.isEqualOrParent(M.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.withUninstalledExtensions(F=>delete F[i.ExtensionKey.create(M).toString()])}async copyExtension(M,F,a,m){const x=await this.getScannedExtension(M,F),U=await this.getScannedExtension(M,a);return m={...x?.metadata,...m},U?await this.extensionsProfileScannerService.updateMetadata([[M,{...U.metadata,...m}]],a):await this.extensionsProfileScannerService.addExtensionsToProfile([[M,m]],a),this.scanLocalExtension(M.location,M.type,a)}async copyExtensions(M,F){const a=await this.scanExtensions(1,M),m=await Promise.all(a.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,M)]));await this.extensionsProfileScannerService.addExtensionsToProfile(m,F)}async deleteExtensionFromLocation(M,F,a){this.logService.trace(`Deleting ${a} extension from disk`,M,F.fsPath);const m=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(F),`${this.uriIdentityService.extUri.basename(F)}.${(0,f.hash)((0,c.generateUuid)()).toString(16)}${W}`);await this.rename(F.fsPath,m.fsPath),await this.fileService.del(m,{recursive:!0}),this.logService.info(`Deleted ${a} extension from disk`,M,F.fsPath)}async withUninstalledExtensions(M){return this.uninstalledFileLimiter.queue(async()=>{let F;try{F=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(m){if((0,ee.toFileOperationResult)(m)!==1)throw m}let a={};if(F)try{a=JSON.parse(F)}catch{}return M&&(M(a),Object.keys(a).length?await this.fileService.writeFile(this.uninstalledResource,O.VSBuffer.fromString(JSON.stringify(a))):await this.fileService.del(this.uninstalledResource)),a})}async rename(M,F){try{await p.Promises.rename(M,F,2*60*1e3)}catch(a){throw new t.ExtensionManagementError(a.message||g.localize(5,null,M,F),a.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(M,F,a){if(a){const x=(await this.extensionsScannerService.scanUserExtensions({profileLocation:a})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,M));if(x)return this.toLocalExtension(x)}else{const m=await this.extensionsScannerService.scanExistingExtension(M,F,{includeInvalid:!0});if(m)return this.toLocalExtension(m)}throw new Error(g.localize(6,null,M.path))}async toLocalExtension(M){const F=await this.fileService.resolve(M.location);let a,m;return F.children&&(a=F.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,m=F.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned}}async removeUninstalledExtensions(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const x of F)M[i.ExtensionKey.create(x).toString()]||a.add(x.identifier.id.toLowerCase());try{const x=(0,i.groupByExtension)(F,U=>U.identifier);await N.Promises.settled(x.map(async U=>{const H=U.sort((q,ce)=>I.rcompare(q.manifest.version,ce.manifest.version))[0];a.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(x){this.logService.error(x)}const m=F.filter(x=>x.metadata&&M[i.ExtensionKey.create(x).toString()]);await Promise.allSettled(m.map(x=>this.removeUninstalledExtension(x)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(F){(0,ee.toFileOperationResult)(F)!==1&&this.logService.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(W))){this.logService.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.fileService.del(F.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(a){(0,ee.toFileOperationResult)(a)!==1&&this.logService.error(a)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=ve([ie(1,ee.IFileService),ie(2,s.IExtensionsScannerService),ie(3,n.IExtensionsProfileScannerService),ie(4,le.IUriIdentityService),ie(5,se.ILogService)],V);class _ extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(M,F,a,m,x,U,H,q,ce){super(),this.identifier=M,this.source=F,this.options=a,this.extensionsScanner=m,this.uriIdentityService=x,this.userDataProfilesService=U,this.extensionsScannerService=H,this.extensionsProfileScannerService=q,this.logService=ce,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(M){const[F,a]=await this.install(M);return this._profileLocation=F.isBuiltin||F.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,a]],this._profileLocation),F}async extractExtension({zipPath:M,key:F,metadata:a},m,x){let U=await this.unsetIfUninstalled(F);return U||(this.logService.trace("Extracting extension...",F.id),U=await this.extensionsScanner.extractUserExtension(F,M,a,m,x),this.logService.info("Extracting extension completed.",F.id)),U}async unsetIfUninstalled(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.extensionsScanner.setInstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(m=>i.ExtensionKey.create(m).equals(M))):void 0}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.toString()]}}class j extends _{constructor(M,F,a,m,x,U,H,q,ce,ae){super(F.identifier,F,a,x,U,H,q,ce,ae),this.gallery=F,this.extensionsDownloader=m}async install(M){const a=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(H.identifier,this.gallery.identifier));a&&(this._operation=3);const m={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??a?.pinned,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(a,m),m];const{location:x,verificationStatus:U}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=U,this.validateManifest(x.fsPath),[await this.extractExtension({zipPath:x.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:m},!1,M),m]}catch(H){try{await this.extensionsDownloader.delete(x)}catch(q){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,T.getErrorMessage)(q))}throw H}}async validateManifest(M){try{await(0,w.getManifest)(M)}catch(F){throw new t.ExtensionManagementError((0,o.joinErrors)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class G extends _{constructor(M,F,a,m,x,U,H,q,ce,ae){super({id:(0,i.getGalleryExtensionId)(M.publisher,M.name)},F,a,x,U,H,q,ce,ae),this.manifest=M,this.location=F,this.galleryService=m}async doRun(M){const F=await super.doRun(M);return this.updateMetadata(F,M),F}async install(M){const F=new i.ExtensionKey(this.identifier,this.manifest.version),m=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(H=>(0,i.areSameExtensions)(this.identifier,H.identifier)),x={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??m?.pinned};if(m)if(this._operation=3,F.equals(new i.ExtensionKey(m.identifier,m.manifest.version)))try{await this.extensionsScanner.removeExtension(m,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(m.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(m);else{const H=await this.unsetIfUninstalled(F);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(g.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:d.resolve(this.location.fsPath),key:F,metadata:x},!0,M),x]}async updateMetadata(M,F){try{let[a]=await this.galleryService.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(a||([a]=await this.galleryService.getExtensions([{id:M.identifier.id}],F)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(M,m,this.options.profileLocation)}}catch{}}}class X extends o.AbstractExtensionTask{constructor(M,F,a){super(),this.extension=M,this.profileLocation=F,this.extensionsProfileScannerService=a}async doRun(M){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(te[158],ne([0,1,6,23,22,26,40,12,18,11]),function(B,e,N,O,L,A,T,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let D=class extends T.AbstractExtensionsProfileScannerService{constructor(d,h,I,E,v,c){super(l.URI.file(d.extensionsPath),h,I,E,v,c)}};e.ExtensionsProfileScannerService=D,e.ExtensionsProfileScannerService=D=ve([ie(0,f.INativeEnvironmentService),ie(1,P.IFileService),ie(2,O.IUserDataProfilesService),ie(3,L.IUriIdentityService),ie(4,A.ITelemetryService),ie(5,N.ILogService)],D)}),define(te[159],ne([0,1,11,18,40,51,12,10,6,32,22,23]),function(B,e,N,O,L,A,T,P,f,l,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends A.NativeExtensionsScannerService{constructor(I,E,v,c,p,R,g,y){super(N.URI.file(p.builtinExtensionsPath),N.URI.file(p.extensionsPath),p.userHome,I.defaultProfile,I,E,v,c,p,R,g,y)}};e.ExtensionsScannerService=d,e.ExtensionsScannerService=d=ve([ie(0,C.IUserDataProfilesService),ie(1,L.IExtensionsProfileScannerService),ie(2,T.IFileService),ie(3,f.ILogService),ie(4,O.INativeEnvironmentService),ie(5,l.IProductService),ie(6,D.IUriIdentityService),ie(7,P.IInstantiationService)],d)}),define(te[160],ne([0,1,8,4,2,125,3,86,10,23]),function(B,e,N,O,L,A,T,P,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var D;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var C;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function h(p){const R=p.get(e.TARGET_KEY);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}e.loadKeyTargets=h;class I extends L.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(R={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super(),this.options=R,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new N.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(R,g,y){return O.Event.filter(this._onDidChangeValue.event,r=>r.scope===R&&(g===void 0||r.key===g),y)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,N.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(R,g){const{key:y,external:r}=g;if(y===e.TARGET_KEY){switch(R){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:R})}else this._onDidChangeValue.fire({scope:R,key:y,target:this.getKeyTargets(R)[y],external:r})}emitWillSaveState(R){this._onWillSaveState.fire({reason:R})}get(R,g,y){return this.getStorage(g)?.get(R,y)}getBoolean(R,g,y){return this.getStorage(g)?.getBoolean(R,y)}getNumber(R,g,y){return this.getStorage(g)?.getNumber(R,y)}getObject(R,g,y){return this.getStorage(g)?.getObject(R,y)}storeAll(R,g){this.withPausedEmitters(()=>{for(const y of R)this.store(y.key,y.value,y.scope,y.target,g)})}store(R,g,y,r,o=!1){if((0,T.isUndefinedOrNull)(g)){this.remove(R,y,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(R,y,r),this.getStorage(y)?.set(R,g,o)})}remove(R,g,y=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(R,g,void 0),this.getStorage(g)?.delete(R,y)})}withPausedEmitters(R){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{R()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(R,g){const y=[],r=this.getKeyTargets(R);for(const o of Object.keys(r))r[o]===g&&y.push(o);return y}updateKeyTarget(R,g,y,r=!1){const o=this.getKeyTargets(g);typeof y=="number"?o[R]!==y&&(o[R]=y,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(o),r)):typeof o[R]=="number"&&(delete o[R],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(o),r))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(R){switch(R){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(R){const g=this.getStorage(R);return g?h(g):Object.create(null)}isNew(R){return this.getBoolean(e.IS_NEW_KEY,R)===!0}async flush(R=D.NONE){this._onWillSaveState.fire({reason:R});const g=this.getStorage(-1),y=this.getStorage(0),r=this.getStorage(1);switch(R){case D.NONE:await N.Promises.settled([g?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await N.Promises.settled([g?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return c(R,g,y,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(R){return await this.flush(),this.getStorage(R)?.optimize()}async switch(R,g){return this.emitWillSaveState(D.NONE),(0,l.isUserDataProfile)(R)?this.switchToProfile(R,g):this.switchToWorkspace(R,g)}canSwitchProfile(R,g){return!(R.id===g.id||E(g)&&E(R))}switchData(R,g,y){this.withPausedEmitters(()=>{const r=new Set;for(const[o,t]of R)r.add(o),g.get(o)!==t&&this.emitDidChangeValue(y,{key:o,external:!0});for(const[o]of g.items)r.has(o)||this.emitDidChangeValue(y,{key:o,external:!0})})}}e.AbstractStorageService=I;function E(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=E;class v extends I{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(R=>this.emitDidChangeValue(1,R))),this._register(this.profileStorage.onDidChangeStorage(R=>this.emitDidChangeValue(0,R))),this._register(this.applicationStorage.onDidChangeStorage(R=>this.emitDidChangeValue(-1,R)))}getStorage(R){switch(R){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(R){switch(R){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(R){return!1}}e.InMemoryStorageService=v;async function c(p,R,g,y,r,o){const t=$=>{try{return JSON.parse($)}catch{return $}},i=new Map,n=new Map;p.forEach(($,ee)=>{i.set(ee,$),n.set(ee,t($))});const s=new Map,u=new Map;R.forEach(($,ee)=>{s.set(ee,$),u.set(ee,t($))});const b=new Map,w=new Map;g.forEach(($,ee)=>{b.set(ee,$),w.set(ee,t($))}),console.group(y!==r?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const S=[];if(i.forEach(($,ee)=>{S.push({key:ee,value:$})}),console.table(S),console.groupEnd(),console.log(n),y!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const $=[];s.forEach((ee,Z)=>{$.push({key:Z,value:ee})}),console.table($),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const k=[];b.forEach(($,ee)=>{k.push({key:ee,value:$})}),console.table(k),console.groupEnd(),console.log(w)}e.logStorage=c}),define(te[161],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,49,12,6,32,44,144,160,26,174]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=A.isWeb?"web":(0,C.getTargetPlatform)(A.platform,T.arch),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((m,x)=>m|x,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class S{constructor(m=w){this.state=m}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(m,x=this.state.pageSize){return new S({...this.state,pageNumber:m,pageSize:x})}withFilter(m,...x){const U=[...this.state.criteria,...x.length?x.map(H=>({filterType:m,value:H})):[{filterType:m}]];return new S({...this.state,criteria:U})}withSortBy(m){return new S({...this.state,sortBy:m})}withSortOrder(m){return new S({...this.state,sortOrder:m})}withFlags(...m){return new S({...this.state,flags:m.reduce((x,U)=>x|U,0)})}withAssetTypes(...m){return new S({...this.state,assetTypes:m})}withSource(m){return new S({...this.state,source:m})}get raw(){const{criteria:m,pageNumber:x,pageSize:U,sortBy:H,sortOrder:q,flags:ce,assetTypes:ae}=this.state;return{filters:[{criteria:m,pageNumber:x,pageSize:U,sortBy:H,sortOrder:q}],assetTypes:ae,flags:ce}}get searchText(){const m=this.state.criteria.filter(x=>x.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(m=>String(m.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(a,m){const x=(a||[]).filter(U=>U.statisticName===m)[0];return x?x.value:0}function $(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf(m)===0).reduce((U,H)=>{const q=se(a,H.assetType);return q&&U.push([H.assetType.substring(m.length),q]),U},[])}function ee(a){if(a.properties){const m=a.properties.filter(H=>H.key===s.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=m.filter(H=>x.test(H.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return se(a,s.Repository)}function Z(a){return{uri:`${a.fallbackAssetUri}/${s.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${s.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function se(a,m){return a.files.filter(U=>U.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function re(a,m){const x=a.properties?a.properties.filter(H=>H.key===m):[],U=x.length>0&&x[0].value;return U?U.split(",").map(H=>(0,d.adoptToGalleryExtensionId)(H)):[]}function ue(a){const m=a.properties?a.properties.filter(x=>x.key===u.Engine):[];return m.length>0&&m[0].value||""}function le(a){const m=a.properties?a.properties.filter(x=>x.key===u.PreRelease):[];return m.length>0&&m[0].value==="true"}function oe(a){const m=a.properties?a.properties.filter(U=>U.key===u.LocalizedLanguages):[],x=m.length>0&&m[0].value||"";return x?x.split(","):[]}function W(a){return a.properties?.find(m=>m.key===u.SponsorLink)?.value}function K(a){return a.indexOf("preview")!==-1}function V(a){return a.targetPlatform?(0,C.toTargetPlatform)(a.targetPlatform):"undefined"}function _(a){const m=(0,N.distinct)(a.versions.map(V)),x=!!a.tags?.includes(C.WEB_EXTENSION_TAG),U=m.indexOf("web");return x?U===-1&&m.push("web"):U!==-1&&m.splice(U,1),m}function j(a,m){for(let x=0;x<a.length;x++){const U=a[x];if(U.version===a[x-1]?.version){let H=x;if(V(U)===m)for(;H>0&&a[H-1].version===U.version;)H--;H!==x&&(a.splice(x,1),a.splice(H,0,U))}}return a}e.sortExtensionVersions=j;function G(a,m,x){a.telemetryData={index:m,querySource:x,queryActivityId:a.queryContext?.[o]}}function X(a,m,x,U){const H=a.versions[0],q={manifest:se(m,s.Manifest),readme:se(m,s.Details),changelog:se(m,s.Changelog),license:se(m,s.License),repository:ee(m),download:Z(m),icon:se(m,s.Icon),signature:se(m,s.Signature),coreTranslations:$(m)};return{identifier:{id:(0,d.getGalleryExtensionId)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(H),description:a.shortDescription||"",installCount:k(a.statistics,"install"),rating:k(a.statistics,"averagerating"),ratingCount:k(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:x,assets:q,properties:{dependencies:re(m,u.Dependency),extensionPack:re(m,u.ExtensionPack),engine:ue(m),localizedLanguages:oe(m),targetPlatform:V(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(H),hasReleaseVersion:!0,preview:K(a.flags),isSigned:!!q.signature,queryContext:U}}let J=class{constructor(m,x,U,H,q,ce,ae,me){this.requestService=x,this.logService=U,this.environmentService=H,this.telemetryService=q,this.fileService=ce,this.productService=ae,this.configurationService=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ge?de.servicePPEUrl:de?.serviceUrl,this.extensionsGallerySearchUrl=ge?void 0:de?.searchUrl,this.extensionsControlUrl=de?.controlUrl,this.commonHeadersPromise=(0,p.resolveMarketplaceHeaders)(ae.version,ae,this.environmentService,this.configurationService,this.fileService,m,this.telemetryService)}api(m=""){return`${this.extensionsGalleryUrl}${m}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(m,x,U){const H=O.CancellationToken.isCancellationToken(x)?{}:x,q=O.CancellationToken.isCancellationToken(x)?x:U,ce=[],ae=[],me=[],de=[];let ge=!0;for(const Se of m){Se.uuid?ae.push(Se.uuid):ce.push(Se.id);const we=!!(Se.version||Se.preRelease);me.push({id:Se.id,uuid:Se.uuid,includePreRelease:we}),Se.version&&de.push({id:Se.id,uuid:Se.uuid,version:Se.version}),ge=ge&&!!Se.hasPreRelease&&!we}if(!ae.length&&!ce.length)return[];let he=new S().withPage(1,m.length);ae.length&&(he=he.withFilter(n.ExtensionId,...ae)),ce.length&&(he=he.withFilter(n.ExtensionName,...ce)),(H.queryAllVersions||ge)&&(he=he.withFlags(he.flags,t.IncludeVersions)),H.source&&(he=he.withSource(H.source));const{extensions:fe}=await this.queryGalleryExtensions(he,{targetPlatform:H.targetPlatform??r,includePreRelease:me,versions:de,compatible:!!H.compatible},q);return H.source&&fe.forEach((Se,we)=>G(Se,we,H.source)),fe}async getCompatibleExtension(m,x,U){if((0,C.isNotWebExtensionInWebTargetPlatform)(m.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(m,x,U))return m;const H=new S().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:q}=await this.queryGalleryExtensions(H,{targetPlatform:U,compatible:!0,includePreRelease:x},O.CancellationToken.None);return q[0]||null}async isExtensionCompatible(m,x,U){if(!(0,C.isTargetPlatformCompatible)(m.properties.targetPlatform,m.allTargetPlatforms,U)||!x&&m.properties.isPreReleaseVersion)return!1;let H=m.properties.engine;if(!H){const q=await this.getManifest(m,O.CancellationToken.None);if(!q)throw new Error("Manifest was not found");H=q.engines.vscode}return(0,h.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(m,x,U,H,q){if(!(0,C.isTargetPlatformCompatible)(V(m),H,q)||x!=="any"&&le(m)!==(x==="prerelease"))return!1;if(U)try{const ce=await this.getEngine(m);if(!(0,h.isEngineValid)(ce,this.productService.version,this.productService.date))return!1}catch(ce){return this.logService.error(`Error while getting the engine for the version ${m.version}.`,(0,L.getErrorMessage)(ce)),!1}return!0}async query(m,x){let U=m.text||"";const H=m.pageSize??50;let q=new S().withPage(1,H);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(q=q.withFilter(n.Category,fe||he),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,he,fe)=>(q=q.withFilter(n.Tag,fe||he),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(q=q.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),q=q.withFilter(n.SearchText,U)),q=q.withSortBy(0)):m.ids?q=q.withFilter(n.ExtensionId,...m.ids):m.names?q=q.withFilter(n.ExtensionName,...m.names):q=q.withSortBy(4),typeof m.sortBy=="number"&&(q=q.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(q=q.withSortOrder(m.sortOrder)),m.source&&(q=q.withSource(m.source));const ce=async(ge,he)=>{const{extensions:fe,total:Se}=await this.queryGalleryExtensions(ge,{targetPlatform:r,compatible:!1,includePreRelease:!!m.includePreRelease},he);return fe.forEach((we,be)=>G(we,(ge.pageNumber-1)*ge.pageSize+be,m.source)),{extensions:fe,total:Se}},{extensions:ae,total:me}=await ce(q,x),de=async(ge,he)=>{if(he.isCancellationRequested)throw new L.CancellationError;const{extensions:fe}=await ce(q.withPage(ge+1),he);return fe};return{firstPage:ae,total:me,pageSize:q.pageSize,getPage:de}}async queryGalleryExtensions(m,x,U){const H=m.flags;m.flags&t.IncludeLatestVersionOnly&&m.flags&t.IncludeVersions&&(m=m.withFlags(m.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(m.flags&t.IncludeLatestVersionOnly)&&!(m.flags&t.IncludeVersions)&&(m=m.withFlags(m.flags,t.IncludeLatestVersionOnly)),x.versions?.length&&(m=m.withFlags(m.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),m=m.withFlags(m.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:q,total:ce,context:ae}=await this.queryRawGalleryExtensions(m,U);if(!(m.flags&t.IncludeLatestVersionOnly)){const he=[];for(const fe of q){const Se=await this.toGalleryExtensionWithCriteria(fe,x,ae);Se&&he.push(Se)}return{extensions:he,total:ce}}const de=[],ge=new Map;for(let he=0;he<q.length;he++){const fe=q[he],Se={id:(0,d.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),uuid:fe.extensionId},we=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Me=>(0,d.areSameExtensions)(Me,Se))?.includePreRelease;if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(_(fe),x.targetPlatform))continue;const be=await this.toGalleryExtensionWithCriteria(fe,x,ae);!be||be.properties.isPreReleaseVersion&&(!we||!be.hasReleaseVersion)||!be.properties.isPreReleaseVersion&&be.properties.targetPlatform!==x.targetPlatform&&be.hasPreReleaseVersion?ge.set(fe.extensionId,he):de.push([he,be])}if(ge.size){const he=new y.StopWatch,fe=new S().withFlags(H&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:Se}=await this.queryGalleryExtensions(fe,x,U);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:he.elapsed(),count:ge.size});for(const we of Se){const be=ge.get(we.identifier.uuid);de.push([be,we])}}return{extensions:de.sort((he,fe)=>he[0]-fe[0]).map(([,he])=>he),total:ce}}async toGalleryExtensionWithCriteria(m,x,U){const H={id:(0,d.getGalleryExtensionId)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},q=x.versions?.find(de=>(0,d.areSameExtensions)(de,H))?.version,ce=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(de=>(0,d.areSameExtensions)(de,H))?.includePreRelease,ae=_(m),me=j(m.versions,x.targetPlatform);if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(ae,x.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(q&&ge.version!==q)){if(await this.isValidVersion(ge,ce?"any":"release",x.compatible,ae,x.targetPlatform))return X(m,ge,ae,U);if(q&&ge.version===q)return null}}return q||x.compatible?null:X(m,m.versions[0],ae)}async queryRawGalleryExtensions(m,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const U=await this.commonHeadersPromise,H=JSON.stringify(m.raw),q={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ce=new y.StopWatch;let ae,me,de=0;try{if(ae=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&m.criteria.some(he=>he.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:H,headers:q},x),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,c.asJson)(ae);if(ge){const he=ge.results[0],fe=he.extensions,Se=he.resultMetadata&&he.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return de=Se&&Se.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(H.length),duration:ce.elapsed(),success:!!ae&&(0,c.isSuccess)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,L.isCancellationError)(me)?"canceled":(0,L.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,x,U,H){if(!this.isEnabled())return;const q=A.isWeb?this.api(`/itemName/${m}.${x}/version/${U}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${m}/extensions/${x}/${U}/stats?statType=${H}`),ce=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:q,headers:me},O.CancellationToken.None)}catch{}}async download(m,x,U){this.logService.trace("ExtensionGalleryService#download",m.identifier.id);const H=(0,d.getGalleryExtensionTelemetryData)(m),q=new Date().getTime(),ce=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:he}),ae=U===2?"install":U===3?"update":"",me=ae?{uri:`${m.assets.download.uri}${f.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${f.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[o]?{[o]:m.queryContext[o]}:void 0,ge=await this.getAsset(me,de?{headers:de}:void 0);await this.fileService.writeFile(x,ge.stream),ce(new Date().getTime()-q)}async downloadSignatureArchive(m,x){if(!m.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const U=await this.getAsset(m.assets.signature);await this.fileService.writeFile(x,U.stream)}async getReadme(m,x){if(m.assets.readme){const U=await this.getAsset(m.assets.readme,{},x);return await(0,c.asTextOrError)(U)||""}return""}async getManifest(m,x){if(m.assets.manifest){const U=await this.getAsset(m.assets.manifest,{},x),H=await(0,c.asTextOrError)(U);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(m,x){const U=se(m,s.Manifest);if(!U)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},q=await this.getAsset(U,{headers:H});return await(0,c.asJson)(q)}async getCoreTranslation(m,x){const U=m.assets.coreTranslations.filter(H=>H[0]===x.toUpperCase())[0];if(U){const H=await this.getAsset(U[1]),q=await(0,c.asTextOrError)(H);return q?JSON.parse(q):null}return null}async getChangelog(m,x){if(m.assets.changelog){const U=await this.getAsset(m.assets.changelog,{},x);return await(0,c.asTextOrError)(U)||""}return""}async getAllCompatibleVersions(m,x,U){let H=new S().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?H=H.withFilter(n.ExtensionId,m.identifier.uuid):H=H.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:q}=await this.queryRawGalleryExtensions(H,O.CancellationToken.None);if(!q.length)return[];const ce=_(q[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ce,U))return[];const ae=[];await Promise.all(q[0].versions.map(async ge=>{try{await this.isValidVersion(ge,x?"any":"release",!0,ce,U)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of j(ae,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return me}async getAsset(m,x={},U=O.CancellationToken.None){const H=await this.commonHeadersPromise,q={type:"GET"},ce={...H,...x.headers||{}};x={...x,...q,headers:ce};const ae=m.uri,me=m.fallbackUri,de={...x,url:ae};try{const ge=await this.requestService.request(de,U);if(ge.res.statusCode===200)return ge;const he=await(0,c.asTextOrError)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${he}`)}catch(ge){if((0,L.isCancellationError)(ge))throw ge;const he=(0,L.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:he});const fe={...x,url:me};return this.requestService.request(fe,U)}}async getEngine(m){let x=ue(m);if(!x){const U=await this.getManifestFromRawExtensionVersion(m,O.CancellationToken.None);if(!U)throw new Error("Manifest was not found");x=U.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const m=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,c.asJson)(m),U=[],H={},q=[];if(x){for(const ce of x.malicious)U.push({id:ce});if(x.migrateToPreRelease)for(const[ce,ae]of Object.entries(x.migrateToPreRelease))(!ae.engine||(0,h.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(H[ce.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[ce,ae]of Object.entries(x.deprecated))ae&&(H[ce.toLowerCase()]=(0,P.isBoolean)(ae)?{}:ae);if(x.search)for(const ce of x.search)q.push(ce)}return{malicious:U,deprecated:H,search:q}}};J=ve([ie(1,c.IRequestService),ie(2,E.ILogService),ie(3,D.IEnvironmentService),ie(4,g.ITelemetryService),ie(5,I.IFileService),ie(6,v.IProductService),ie(7,l.IConfigurationService)],J);let M=class extends J{constructor(m,x,U,H,q,ce,ae,me){super(m,x,U,H,q,ce,ae,me)}};e.ExtensionGalleryService=M,e.ExtensionGalleryService=M=ve([ie(0,R.IStorageService),ie(1,c.IRequestService),ie(2,E.ILogService),ie(3,D.IEnvironmentService),ie(4,g.ITelemetryService),ie(5,I.IFileService),ie(6,v.IProductService),ie(7,l.IConfigurationService)],M);let F=class extends J{constructor(m,x,U,H,q,ce,ae){super(void 0,m,x,U,H,q,ce,ae)}};e.ExtensionGalleryServiceWithNoStorageService=F,e.ExtensionGalleryServiceWithNoStorageService=F=ve([ie(0,c.IRequestService),ie(1,E.ILogService),ie(2,D.IEnvironmentService),ie(3,g.ITelemetryService),ie(4,I.IFileService),ie(5,v.IProductService),ie(6,l.IConfigurationService)],F)}),define(te[162],ne([0,1,11,18,12,6,140,22,23,3,68]),function(B,e,N,O,L,A,T,P,f,l,D){"use strict";var C,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let h=class extends f.UserDataProfilesService{static{C=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(c,p,R,g,y){super(R,g,p,y),this.stateReadonlyService=c,this.nativeEnvironmentService=R}getStoredProfiles(){return this.stateReadonlyService.getItem(C.PROFILES_KEY,[]).map(p=>({...p,location:(0,l.isString)(p.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,p.location):N.URI.revive(p.location)}))}getStoredProfileAssociations(){const c=this.stateReadonlyService.getItem(C.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(C.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?c:this.migrateStoredProfileAssociations(c)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(N.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=h,e.UserDataProfilesReadonlyService=h=C=ve([ie(0,T.IStateReadService),ie(1,P.IUriIdentityService),ie(2,O.INativeEnvironmentService),ie(3,L.IFileService),ie(4,A.ILogService)],h);let I=d=class extends h{constructor(c,p,R,g,y){super(c,p,R,g,y),this.stateService=c}saveStoredProfiles(c){c.length?this.stateService.setItem(d.PROFILES_KEY,c.map(p=>({...p,location:this.uriIdentityService.extUri.basename(p.location)}))):this.stateService.removeItem(d.PROFILES_KEY)}getStoredProfiles(){const c=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(c),this.stateService.setItem("userDataProfilesMigration",!0)),c}saveStoredProfileAssociations(c){c.emptyWindows||c.workspaces?this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,c):this.stateService.removeItem(d.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const c="workspaceAndProfileInfo",p=this.stateService.getItem(c,void 0);if(p){this.stateService.removeItem(c);const g=p.reduce((y,{workspace:r,profile:o})=>(y[N.URI.revive(r).toString()]=N.URI.revive(o).toString(),y),{});this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,{workspaces:g})}const R=super.getStoredProfileAssociations();return this.stateService.getItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(R),this.stateService.setItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),R}};e.UserDataProfilesService=I,e.UserDataProfilesService=I=d=ve([ie(0,T.IStateService),ie(1,P.IUriIdentityService),ie(2,O.INativeEnvironmentService),ie(3,L.IFileService),ie(4,A.ILogService)],I);let E=class extends I{constructor(c,p,R,g){super(new D.StateService(0,p,g,R),c,p,R,g)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=E,e.ServerUserDataProfilesService=E=ve([ie(0,P.IUriIdentityService),ie(1,O.INativeEnvironmentService),ie(2,L.IFileService),ie(3,A.ILogService)],E)}),define(te[163],ne([0,1,138,8,14,9,3,25,18,139,6,44,137,175]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let I=class extends C.AbstractRequestService{constructor(p,R,g,y){super(y),this.configurationService=p,this.environmentService=R,this.logService=g,this.configure(),this._register(p.onDidChangeConfiguration(r=>{r.affectsConfiguration("http")&&this.configure()}))}configure(){const p=this.configurationService.getValue("http");this.proxyUrl=p?.proxy,this.strictSSL=!!p?.proxyStrictSSL,this.authorization=p?.proxyAuthorization}async request(p,R){const{proxyUrl:g,strictSSL:y}=this;let r;try{r=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const o={...process.env,...r},t=p.agent?p.agent:await(0,d.getProxyAgent)(p.url||"",o,{proxyUrl:g,strictSSL:y});return p.agent=t,p.strictSSL=y,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(p.isChromiumNetwork?"electron":"node",p,()=>v(p,R))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((R,g)=>{B(["@vscode/proxy-agent"],R,g)})).loadSystemCertificates({log:this.logService})}};e.RequestService=I,e.RequestService=I=ve([ie(0,P.IConfigurationService),ie(1,f.INativeEnvironmentService),ie(2,D.ILogService),ie(3,D.ILoggerService)],I);async function E(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((g,y)=>{B(["https"],g,y)}):await new Promise((g,y)=>{B(["http"],g,y)})).request}async function v(c,p){return O.Promises.withAsyncBody(async(R,g)=>{const y=(0,N.parse)(c.url),r=c.getRawRequest?c.getRawRequest(c):await E(c),o={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,T.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(o.auth=c.user+":"+c.password);const t=r(o,i=>{const n=(0,T.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)v({...c,url:i.headers.location,followRedirects:n-1},p).then(R,g);else{let s=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,h.createGunzip)())),R({res:i,stream:(0,L.streamToBufferReadableStream)(s)})}});t.on("error",g),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),p.onCancellationRequested(()=>{t.abort(),g(new A.CancellationError)})})}e.nodeRequest=v}),define(te[176],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,134,59,136,18,112,161,21,60,141,40,51,157,159,12,124,126,50,122,63,64,145,6,130,38,131,148,32,44,163,68,69,26,147,39,149,150,22,152,23,162,151,158,127,129,5,153]),function(B,e,N,O,L,A,T,P,f,l,D,C,d,h,I,E,v,c,p,R,g,y,r,o,t,i,n,s,u,b,w,S,k,$,ee,Z,se,re,ue,le,oe,W,K,V,_,j,G,X,J,M,F,a,m,x,U,H,q,ce,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends T.Disposable{constructor(fe){super(),this.argv=fe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[fe,Se]=await this.initServices();return fe.invokeFunction(async we=>{const be=we.get(Z.ILogService),Me=we.get(s.IFileService),z=we.get(c.INativeEnvironmentService),Y=we.get(m.IUserDataProfilesService);be.info("CLI main",this.argv),this.registerErrorHandler(be),await this.doRun(z,Me,Y,fe),await Promise.all(Se.map(Q=>{(0,O.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const fe=new k.ServiceCollection,Se={_serviceBrand:void 0,...le.default};fe.set(oe.IProductService,Se);const we=new p.NativeEnvironmentService(this.argv,Se);fe.set(c.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.with({scheme:P.Schemas.file}).fsPath,we.extensionsPath].map(Ae=>Ae?d.Promises.mkdir(Ae,{recursive:!0}):void 0));const be=new ce.LoggerService((0,Z.getLogLevel)(we),we.logsHome);fe.set(Z.ILoggerService,be);const Me=this._register(be.createLogger("cli",{name:(0,ae.localize)(0,null)})),z=[];be.getLogLevel()===Z.LogLevel.Trace&&z.push(new Z.ConsoleLogger(be.getLogLevel()));const Y=this._register(new q.LogService(Me,z));fe.set(Z.ILogService,Y);const Q=this._register(new u.FileService(Y));fe.set(s.IFileService,Q);const pe=this._register(new b.DiskFileSystemProvider(Y));Q.registerProvider(P.Schemas.file,pe);const ye=new a.UriIdentityService(Q);fe.set(F.IUriIdentityService,ye);const Le=new V.StateReadonlyService(1,we,Y,Q),Ie=new x.UserDataProfilesReadonlyService(Le,ye,we,Q,Y);fe.set(m.IUserDataProfilesService,Ie),Q.registerProvider(P.Schemas.vscodeUserData,new me.FileUserDataProvider(P.Schemas.file,pe,P.Schemas.vscodeUserData,Ie,ye,Y));const Ne=l.isWindows&&Se.win32RegValueName?this._register(new ue.NativePolicyService(Y,Se.win32RegValueName)):we.policyFile?this._register(new se.FilePolicyService(we.policyFile,Q,Y)):new re.NullPolicyService;fe.set(re.IPolicyService,Ne);const Ce=this._register(new I.ConfigurationService(Ie.defaultProfile.settingsResource,Q,Ne,Y));fe.set(h.IConfigurationService,Ce),await Promise.all([Le.init(),Ce.initialize()]);let Te;try{Te=await(0,U.resolveMachineId)(Le,Y)}catch(Ae){Ae.code!=="ENOENT"&&Y.error(Ae)}const _e=await(0,U.resolveSqmId)(Le,Y);Ie.init(),fe.set(F.IUriIdentityService,new a.UriIdentityService(Q));const Re=new K.RequestService(Ce,we,Y,be);fe.set(W.IRequestService,Re),fe.set(E.IDownloadService,new w.SyncDescriptor(v.DownloadService,void 0,!0)),fe.set(o.IExtensionsProfileScannerService,new w.SyncDescriptor(H.ExtensionsProfileScannerService,void 0,!0)),fe.set(t.IExtensionsScannerService,new w.SyncDescriptor(n.ExtensionsScannerService,void 0,!0)),fe.set(y.IExtensionSignatureVerificationService,new w.SyncDescriptor(y.ExtensionSignatureVerificationService,void 0,!0)),fe.set(i.INativeServerExtensionManagementService,new w.SyncDescriptor(i.ExtensionManagementService,void 0,!0)),fe.set(g.IExtensionGalleryService,new w.SyncDescriptor(R.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),fe.set($.ILanguagePackService,new w.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Oe=[],xe=(0,X.isInternalTelemetry)(Se,Ce);if((0,X.supportsTelemetry)(Se,we)){Se.aiConfig&&Se.aiConfig.ariaKey&&Oe.push(new J.OneDataSystemAppender(Re,xe,"monacoworkbench",null,Se.aiConfig.ariaKey));const Ae={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,_.resolveCommonProperties)((0,N.release)(),(0,N.hostname)(),process.arch,Se.commit,Se.version,Te,_e,xe),piiPaths:(0,X.getPiiPathsFromEnvironment)(we)};fe.set(j.ITelemetryService,new w.SyncDescriptor(G.TelemetryService,[Ae],!1))}else fe.set(j.ITelemetryService,X.NullTelemetryService);return[new S.InstantiationService(fe),Oe]}registerErrorHandler(fe){(0,A.setUnexpectedErrorHandler)(Se=>{const we=(0,L.toErrorMessage)(Se,!0);we&&fe.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",Se=>{(0,A.isSigPipeError)(Se)||(0,A.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,A.onUnexpectedError)(Se))}async doRun(fe,Se,we,be){let Me;if(fe.args.profile&&(Me=we.profiles.find(Y=>Y.name===fe.args.profile),!Me))throw new Error(`Profile '${fe.args.profile}' not found.`);const z=(Me??we.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return be.createInstance(r.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,z);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Y={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:z};return be.createInstance(r.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),Y,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return be.createInstance(r.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,z);if(this.argv["locate-extension"])return be.createInstance(r.ExtensionManagementCLI,new Z.ConsoleLogger(Z.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(fe.appRoot,fe.extensionsPath))}}asExtensionIdOrVSIX(fe){return fe.map(Se=>/\.vsix$/i.test(Se)?C.URI.file((0,f.isAbsolute)(Se)?Se:(0,f.join)((0,D.cwd)(),Se)):Se)}}async function ge(he){const fe=new de(he);try{await fe.run()}finally{fe.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c8a36a69377856369f139f39ee56dd3838130fbf/core/vs/code/node/cliProcessMain.js.map
