/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(ne){for(var e=[],k=0,U=ne.length;k<U;k++)e[k]=le[ne[k]];return e};define(le[123],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class k{static get(){const A=new Map,T=new Map,_=new Map,R=new Map;function I(c,f){c.has(f.detail)||c.set(f.detail,-f.timestamp)}function S(c,f){const y=c.get(f.detail);y&&(y>=0||c.set(f.detail,y+f.timestamp))}let D=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(D=ne.getStats().slice(0).sort((c,f)=>c.timestamp-f.timestamp));for(const c of D)switch(c.type){case 10:I(A,c);break;case 11:case 12:S(A,c);break;case 21:I(T,c);break;case 22:S(T,c);break;case 33:I(_,c);break;case 34:S(_,c);break;case 31:I(R,c);break;case 32:S(R,c);break}let b=0;_.forEach(c=>b+=c);function g(c){const f=[];return c.forEach((y,v)=>f.push([v,y])),f}return{amdLoad:g(A),amdInvoke:g(T),nodeRequire:g(_),nodeEval:g(R),nodeRequireTotal:b}}static toMarkdownTable(A,T){let _="";const R=[];return A.forEach((I,S)=>{R[S]=I.length}),T.forEach(I=>{I.forEach((S,D)=>{typeof S>"u"&&(S=I[D]="-");const b=S.toString().length;R[D]=Math.max(b,R[D])})}),A.forEach((I,S)=>{_+=`| ${I+" ".repeat(R[S]-I.toString().length)} `}),_+=`|
`,A.forEach((I,S)=>{_+=`| ${"-".repeat(R[S])} `}),_+=`|
`,T.forEach(I=>{I.forEach((S,D)=>{typeof S<"u"&&(_+=`| ${S+" ".repeat(R[D]-S.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=k}),define(le[124],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function k(y,v,l){const h=U(y,v);if(h!==-1)return y[h]}e.findLast=k;function U(y,v,l=y.length-1){for(let h=l;h>=0;h--){const u=y[h];if(v(u))return h}return-1}e.findLastIdx=U;function A(y,v){const l=T(y,v);return l===-1?void 0:y[l]}e.findLastMonotonous=A;function T(y,v,l=0,h=y.length){let u=l,m=h;for(;u<m;){const C=Math.floor((u+m)/2);v(y[C])?u=C+1:m=C}return u-1}e.findLastIdxMonotonous=T;function _(y,v){const l=R(y,v);return l===y.length?void 0:y[l]}e.findFirstMonotonous=_;function R(y,v,l=0,h=y.length){let u=l,m=h;for(;u<m;){const C=Math.floor((u+m)/2);v(y[C])?m=C:u=C+1}return u}e.findFirstIdxMonotonousOrArrLen=R;function I(y,v,l=0,h=y.length){const u=R(y,v,l,h);return u===y.length?-1:u}e.findFirstIdxMonotonous=I;class S{static{this.assertInvariants=!1}constructor(v){this._array=v,this._findLastMonotonousLastIdx=0}findLastMonotonous(v){if(S.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!v(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=v}const l=T(this._array,v,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=l+1,l===-1?void 0:this._array[l]}}e.MonotonousArray=S;function D(y,v){if(y.length===0)return;let l=y[0];for(let h=1;h<y.length;h++){const u=y[h];v(u,l)>0&&(l=u)}return l}e.findFirstMaxBy=D;function b(y,v){if(y.length===0)return;let l=y[0];for(let h=1;h<y.length;h++){const u=y[h];v(u,l)>=0&&(l=u)}return l}e.findLastMaxBy=b;function g(y,v){return D(y,(l,h)=>-v(l,h))}e.findFirstMinBy=g;function c(y,v){if(y.length===0)return-1;let l=0;for(let h=1;h<y.length;h++){const u=y[h];v(u,y[l])>0&&(l=h)}return l}e.findMaxIdxBy=c;function f(y,v){for(const l of y){const h=v(l);if(h!==void 0)return h}}e.mapFindFirst=f}),define(le[125],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function k(_,R){const I=Object.create(null);for(const S of _){const D=R(S);let b=I[D];b||(b=I[D]=[]),b.push(S)}return I}e.groupBy=k;function U(_,R){const I=[],S=[];for(const D of _)R.has(D)||I.push(D);for(const D of R)_.has(D)||S.push(D);return{removed:I,added:S}}e.diffSets=U;function A(_,R){const I=[],S=[];for(const[D,b]of _)R.has(D)||I.push(b);for(const[D,b]of R)_.has(D)||S.push(b);return{removed:I,added:S}}e.diffMaps=A;function T(_,R){const I=new Set;for(const S of R)_.has(S)&&I.add(S);return I}e.intersection=T}),define(le[84],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(_){return(R,I,S)=>{let D=null,b=null;if(typeof S.value=="function"?(D="value",b=S.value):typeof S.get=="function"&&(D="get",b=S.get),!b)throw new Error("not supported");S[D]=_(b,I)}}function U(_,R,I){let S=null,D=null;if(typeof I.value=="function"?(S="value",D=I.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(S="get",D=I.get),!D)throw new Error("not supported");const b=`$memoize$${R}`;I[S]=function(...g){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,g)}),this[b]}}e.memoize=U;function A(_,R,I){return k((S,D)=>{const b=`$debounce$${D}`,g=`$debounce$result$${D}`;return function(...c){this[g]||(this[g]=I?I():void 0),clearTimeout(this[b]),R&&(this[g]=R(this[g],...c),c=[this[g]]),this[b]=setTimeout(()=>{S.apply(this,c),this[g]=I?I():void 0},_)}})}e.debounce=A;function T(_,R,I){return k((S,D)=>{const b=`$throttle$timer$${D}`,g=`$throttle$result$${D}`,c=`$throttle$lastRun$${D}`,f=`$throttle$pending$${D}`;return function(...y){if(this[g]||(this[g]=I?I():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...y)),this[f])return;const v=this[c]+_;v<=Date.now()?(this[c]=Date.now(),S.apply(this,[this[g]]),this[g]=I?I():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[c]=Date.now(),S.apply(this,[this[g]]),this[g]=I?I():void 0},v-Date.now()))}})}e.throttle=T}),define(le[7],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?u.isErrorNoTelemetry(s)?new u(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(o=>{o(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=k,e.errorHandler=new k;function U(C){e.errorHandler.setUnexpectedErrorHandler(C)}e.setUnexpectedErrorHandler=U;function A(C){if(!C||typeof C!="object")return!1;const s=C;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=A;function T(C){S(C)||e.errorHandler.onUnexpectedError(C)}e.onUnexpectedError=T;function _(C){S(C)||e.errorHandler.onUnexpectedExternalError(C)}e.onUnexpectedExternalError=_;function R(C){if(C instanceof Error){const{name:s,message:o}=C,n=C.stacktrace||C.stack;return{$isError:!0,name:s,message:o,stack:n,noTelemetry:u.isErrorNoTelemetry(C)}}return C}e.transformErrorForSerialization=R;const I="Canceled";function S(C){return C instanceof D?!0:C instanceof Error&&C.name===I&&C.message===I}e.isCancellationError=S;class D extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=D;function b(){const C=new Error(I);return C.name=C.message,C}e.canceled=b;function g(C){return C?new Error(`Illegal argument: ${C}`):new Error("Illegal argument")}e.illegalArgument=g;function c(C){return C?new Error(`Illegal state: ${C}`):new Error("Illegal state")}e.illegalState=c;class f extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=f;function y(C){return C?C.message?C.message:C.stack?C.stack.split(`
`)[0]:String(C):"Error"}e.getErrorMessage=y;class v extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=v;class l extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=l;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=h;class u extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof u)return s;const o=new u;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class m extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.BugIndicatingError=m}),define(le[18],ue([0,1,7,124]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(j,ee=0){return j[j.length-(1+ee)]}e.tail=A;function T(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=T;function _(j,ee,V=(K,ie)=>K===ie){if(j===ee)return!0;if(!j||!ee||j.length!==ee.length)return!1;for(let K=0,ie=j.length;K<ie;K++)if(!V(j[K],ee[K]))return!1;return!0}e.equals=_;function R(j,ee){const V=j.length-1;ee<V&&(j[ee]=j[V]),j.pop()}e.removeFastWithoutKeepingOrder=R;function I(j,ee,V){return S(j.length,K=>V(j[K],ee))}e.binarySearch=I;function S(j,ee){let V=0,K=j-1;for(;V<=K;){const ie=(V+K)/2|0,ce=ee(ie);if(ce<0)V=ie+1;else if(ce>0)K=ie-1;else return ie}return-(V+1)}e.binarySearch2=S;function D(j,ee,V){if(j=j|0,j>=ee.length)throw new TypeError("invalid index");const K=ee[Math.floor(ee.length*Math.random())],ie=[],ce=[],oe=[];for(const de of ee){const fe=V(de,K);fe<0?ie.push(de):fe>0?ce.push(de):oe.push(de)}return j<ie.length?D(j,ie,V):j<ie.length+oe.length?oe[0]:D(j-(ie.length+oe.length),ce,V)}e.quickSelect=D;function b(j,ee){const V=[];let K;for(const ie of j.slice(0).sort(ee))!K||ee(K[0],ie)!==0?(K=[ie],V.push(K)):K.push(ie);return V}e.groupBy=b;function*g(j,ee){let V,K;for(const ie of j)K!==void 0&&ee(K,ie)?V.push(ie):(V&&(yield V),V=[ie]),K=ie;V&&(yield V)}e.groupAdjacentBy=g;function c(j,ee){for(let V=0;V<=j.length;V++)ee(V===0?void 0:j[V-1],V===j.length?void 0:j[V])}e.forEachAdjacent=c;function f(j,ee){for(let V=0;V<j.length;V++)ee(V===0?void 0:j[V-1],j[V],V+1===j.length?void 0:j[V+1])}e.forEachWithNeighbors=f;function y(j,ee,V){const K=[];function ie(de,fe,pe){if(fe===0&&pe.length===0)return;const we=K[K.length-1];we&&we.start+we.deleteCount===de?(we.deleteCount+=fe,we.toInsert.push(...pe)):K.push({start:de,deleteCount:fe,toInsert:pe})}let ce=0,oe=0;for(;;){if(ce===j.length){ie(ce,0,ee.slice(oe));break}if(oe===ee.length){ie(ce,j.length-ce,[]);break}const de=j[ce],fe=ee[oe],pe=V(de,fe);pe===0?(ce+=1,oe+=1):pe<0?(ie(ce,1,[]),ce+=1):pe>0&&(ie(ce,0,[fe]),oe+=1)}return K}e.sortedDiff=y;function v(j,ee,V){const K=y(j,ee,V),ie=[],ce=[];for(const oe of K)ie.push(...j.slice(oe.start,oe.start+oe.deleteCount)),ce.push(...oe.toInsert);return{removed:ie,added:ce}}e.delta=v;function l(j,ee,V){if(V===0)return[];const K=j.slice(0,V).sort(ee);return u(j,ee,K,V,j.length),K}e.top=l;function h(j,ee,V,K,ie){return V===0?Promise.resolve([]):new Promise((ce,oe)=>{(async()=>{const de=j.length,fe=j.slice(0,V).sort(ee);for(let pe=V,we=Math.min(V+K,de);pe<de;pe=we,we=Math.min(we+K,de)){if(pe>V&&await new Promise(Le=>setTimeout(Le)),ie&&ie.isCancellationRequested)throw new k.CancellationError;u(j,ee,fe,pe,we)}return fe})().then(ce,oe)})}e.topAsync=h;function u(j,ee,V,K,ie){for(const ce=V.length;K<ie;K++){const oe=j[K];if(ee(oe,V[ce-1])<0){V.pop();const de=(0,U.findFirstIdxMonotonousOrArrLen)(V,fe=>ee(oe,fe)<0);V.splice(de,0,oe)}}}function m(j){return j.filter(ee=>!!ee)}e.coalesce=m;function C(j){let ee=0;for(let V=0;V<j.length;V++)j[V]&&(j[ee]=j[V],ee+=1);j.length=ee}e.coalesceInPlace=C;function s(j,ee,V){j.splice(V,0,j.splice(ee,1)[0])}e.move=s;function o(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=o;function n(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=n;function i(j,ee=V=>V){const V=new Set;return j.filter(K=>{const ie=ee(K);return V.has(ie)?!1:(V.add(ie),!0)})}e.distinct=i;function t(j){const ee=new Set;return V=>{const K=j(V);return ee.has(K)?!1:(ee.add(K),!0)}}e.uniqueFilter=t;function r(j,ee){return j.length>0?j[0]:ee}e.firstOrDefault=r;function a(j,ee){return j.length>0?j[j.length-1]:ee}e.lastOrDefault=a;function w(j,ee,V=(K,ie)=>K===ie){let K=0;for(let ie=0,ce=Math.min(j.length,ee.length);ie<ce&&V(j[ie],ee[ie]);ie++)K++;return K}e.commonPrefixLength=w;function p(j){return[].concat(...j)}e.flatten=p;function d(j,ee){let V=typeof ee=="number"?j:0;typeof ee=="number"?V=j:(V=0,ee=j);const K=[];if(V<=ee)for(let ie=V;ie<ee;ie++)K.push(ie);else for(let ie=V;ie>ee;ie--)K.push(ie);return K}e.range=d;function E(j,ee,V){return j.reduce((K,ie)=>(K[ee(ie)]=V?V(ie):ie,K),Object.create(null))}e.index=E;function L(j,ee){return j.push(ee),()=>N(j,ee)}e.insert=L;function N(j,ee){const V=j.indexOf(ee);if(V>-1)return j.splice(V,1),ee}e.remove=N;function F(j,ee,V){const K=j.slice(0,ee),ie=j.slice(ee);return K.concat(V,ie)}e.arrayInsert=F;function M(j,ee){let V;if(typeof ee=="number"){let K=ee;V=()=>{const ie=Math.sin(K++)*179426549;return ie-Math.floor(ie)}}else V=Math.random;for(let K=j.length-1;K>0;K-=1){const ie=Math.floor(V()*(K+1)),ce=j[K];j[K]=j[ie],j[ie]=ce}}e.shuffle=M;function W(j,ee){const V=j.indexOf(ee);V>-1&&(j.splice(V,1),j.unshift(ee))}e.pushToStart=W;function Q(j,ee){const V=j.indexOf(ee);V>-1&&(j.splice(V,1),j.push(ee))}e.pushToEnd=Q;function H(j,ee){for(const V of ee)j.push(V)}e.pushMany=H;function X(j,ee){return Array.isArray(j)?j.map(ee):ee(j)}e.mapArrayOrNot=X;function z(j){return Array.isArray(j)?j:[j]}e.asArray=z;function Y(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=Y;function x(j,ee,V){const K=te(j,ee),ie=j.length,ce=V.length;j.length=ie+ce;for(let oe=ie-1;oe>=K;oe--)j[oe+ce]=j[oe];for(let oe=0;oe<ce;oe++)j[oe+K]=V[oe]}e.insertInto=x;function q(j,ee,V,K){const ie=te(j,ee);let ce=j.splice(ie,V);return ce===void 0&&(ce=[]),x(j,ie,K),ce}e.splice=q;function te(j,ee){return ee<0?Math.max(ee+j.length,0):Math.min(ee,j.length)}var se;(function(j){function ee(ce){return ce<0}j.isLessThan=ee;function V(ce){return ce<=0}j.isLessThanOrEqual=V;function K(ce){return ce>0}j.isGreaterThan=K;function ie(ce){return ce===0}j.isNeitherLessOrGreaterThan=ie,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function Z(j,ee){return(V,K)=>ee(j(V),j(K))}e.compareBy=Z;function re(...j){return(ee,V)=>{for(const K of j){const ie=K(ee,V);if(!se.isNeitherLessOrGreaterThan(ie))return ie}return se.neitherLessOrGreaterThan}}e.tieBreakComparators=re;const G=(j,ee)=>j-ee;e.numberComparator=G;const $=(j,ee)=>(0,e.numberComparator)(j?1:0,ee?1:0);e.booleanComparator=$;function P(j){return(ee,V)=>-j(ee,V)}e.reverseOrder=P;class O{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let V=this.firstIdx;for(;V<this.items.length&&ee(this.items[V]);)V++;const K=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,K}takeFromEndWhile(ee){let V=this.lastIdx;for(;V>=0&&ee(this.items[V]);)V--;const K=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,K}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const V=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,V}}e.ArrayQueue=O;class B{static{this.empty=new B(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(V=>(ee(V),!0))}toArray(){const ee=[];return this.iterate(V=>(ee.push(V),!0)),ee}filter(ee){return new B(V=>this.iterate(K=>ee(K)?V(K):!0))}map(ee){return new B(V=>this.iterate(K=>V(ee(K))))}some(ee){let V=!1;return this.iterate(K=>(V=ee(K),!V)),V}findFirst(ee){let V;return this.iterate(K=>ee(K)?(V=K,!1):!0),V}findLast(ee){let V;return this.iterate(K=>(ee(K)&&(V=K),!0)),V}findLastMaxBy(ee){let V,K=!0;return this.iterate(ie=>((K||se.isGreaterThan(ee(ie,V)))&&(K=!1,V=ie),!0)),V}}e.CallbackIterable=B}),define(le[126],ue([0,1,7]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function U(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=U;function A(I,S="Unreachable"){throw new Error(S)}e.assertNever=A;function T(I){if(!I)throw new k.BugIndicatingError("Assertion Failed")}e.assert=T;function _(I){if(!I()){debugger;I(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function R(I,S){let D=0;for(;D<I.length-1;){const b=I[D],g=I[D+1];if(!S(b,g))return!1;D++}return!0}e.checkAdjacentItems=R}),define(le[85],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function k(U,A){const T=this;let _=!1,R;return function(){if(_)return R;if(_=!0,A)try{R=U.apply(T,arguments)}finally{A()}else R=U.apply(T,arguments);return R}}e.createSingleCallFunction=k}),define(le[61],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(U){function A(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}U.is=A;const T=Object.freeze([]);function _(){return T}U.empty=_;function*R(C){yield C}U.single=R;function I(C){return A(C)?C:R(C)}U.wrap=I;function S(C){return C||T}U.from=S;function*D(C){for(let s=C.length-1;s>=0;s--)yield C[s]}U.reverse=D;function b(C){return!C||C[Symbol.iterator]().next().done===!0}U.isEmpty=b;function g(C){return C[Symbol.iterator]().next().value}U.first=g;function c(C,s){for(const o of C)if(s(o))return!0;return!1}U.some=c;function f(C,s){for(const o of C)if(s(o))return o}U.find=f;function*y(C,s){for(const o of C)s(o)&&(yield o)}U.filter=y;function*v(C,s){let o=0;for(const n of C)yield s(n,o++)}U.map=v;function*l(...C){for(const s of C)yield*s}U.concat=l;function h(C,s,o){let n=o;for(const i of C)n=s(n,i);return n}U.reduce=h;function*u(C,s,o=C.length){for(s<0&&(s+=C.length),o<0?o+=C.length:o>C.length&&(o=C.length);s<o;s++)yield C[s]}U.slice=u;function m(C,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,C];const n=C[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[o,U.empty()];o.push(t.value)}return[o,{[Symbol.iterator](){return n}}]}U.consume=m})(k||(e.Iterable=k={}))}),define(le[35],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var U;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(U||(e.SyntaxKind=U={}));var A;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var T;(function(s){s.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function _(s,o=!1){let n=0;const i=s.length;let t="",r=0,a=16,w=0;function p(W){let Q=0,H=0;for(;Q<W;){const X=s.charCodeAt(n);if(X>=48&&X<=57)H=H*16+X-48;else if(X>=65&&X<=70)H=H*16+X-65+10;else if(X>=97&&X<=102)H=H*16+X-97+10;else break;n++,Q++}return Q<W&&(H=-1),H}function d(W){n=W,t="",r=0,a=16,w=0}function E(){const W=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&S(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&S(s.charCodeAt(n)))for(n++;n<s.length&&S(s.charCodeAt(n));)n++;else return w=3,s.substring(W,n);let Q=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&S(s.charCodeAt(n))){for(n++;n<s.length&&S(s.charCodeAt(n));)n++;Q=n}else w=3;return s.substring(W,Q)}function L(){let W="",Q=n;for(;;){if(n>=i){W+=s.substring(Q,n),w=2;break}const H=s.charCodeAt(n);if(H===34){W+=s.substring(Q,n),n++;break}if(H===92){if(W+=s.substring(Q,n),n++,n>=i){w=2;break}switch(s.charCodeAt(n++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const z=p(4);z>=0?W+=String.fromCharCode(z):w=4;break}default:w=5}Q=n;continue}if(H>=0&&H<=31)if(I(H)){W+=s.substring(Q,n),w=2;break}else w=6;n++}return W}function N(){if(t="",w=0,r=n,n>=i)return r=i,a=17;let W=s.charCodeAt(n);if(R(W)){do n++,t+=String.fromCharCode(W),W=s.charCodeAt(n);while(R(W));return a=15}if(I(W))return n++,t+=String.fromCharCode(W),W===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(W){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=L(),a=10;case 47:{const Q=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!I(s.charCodeAt(n));)n++;return t=s.substring(Q,n),a=12}if(s.charCodeAt(n+1)===42){n+=2;const H=i-1;let X=!1;for(;n<H;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,w=1),t=s.substring(Q,n),a=13}return t+=String.fromCharCode(W),n++,a=16}case 45:if(t+=String.fromCharCode(W),n++,n===i||!S(s.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=E(),a=11;default:for(;n<i&&F(W);)n++,W=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(W),n++,a=16}}function F(W){if(R(W)||I(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let W;do W=N();while(W>=12&&W<=15);return W}return{setPosition:d,getPosition:()=>n,scan:o?M:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>w}}e.createScanner=_;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function I(s){return s===10||s===13||s===8232||s===8233}function S(s){return s>=48&&s<=57}var D;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(D||(D={}));function b(s,o){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function w(p,d,E,L){r.value=p,r.offset=d,r.length=E,r.type=L,r.colonOffset=void 0,t=r}try{u(s,{onObjectBegin:(p,d)=>{if(o<=p)throw i;t=void 0,a=o>p,n.push("")},onObjectProperty:(p,d,E)=>{if(o<d||(w(p,d,E,"property"),n[n.length-1]=p,o<=d+E))throw i},onObjectEnd:(p,d)=>{if(o<=p)throw i;t=void 0,n.pop()},onArrayBegin:(p,d)=>{if(o<=p)throw i;t=void 0,n.push(0)},onArrayEnd:(p,d)=>{if(o<=p)throw i;t=void 0,n.pop()},onLiteralValue:(p,d,E)=>{if(o<d||(w(p,d,E,C(p)),o<=d+E))throw i},onSeparator:(p,d,E)=>{if(o<=d)throw i;if(p===":"&&t&&t.type==="property")t.colonOffset=d,a=!1,t=void 0;else if(p===","){const L=n[n.length-1];typeof L=="number"?n[n.length-1]=L+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(p){if(p!==i)throw p}return{path:n,previousNode:t,isAtPropertyKey:a,matches:p=>{let d=0;for(let E=0;d<p.length&&E<n.length;E++)if(p[d]===n[E]||p[d]==="*")d++;else if(p[d]!=="**")return!1;return d===p.length}}}e.getLocation=b;function g(s,o=[],n=T.DEFAULT){let i=null,t=[];const r=[];function a(p){Array.isArray(t)?t.push(p):i!==null&&(t[i]=p)}return u(s,{onObjectBegin:()=>{const p={};a(p),r.push(t),t=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const p=[];a(p),r.push(t),t=p,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(p,d,E)=>{o.push({error:p,offset:d,length:E})}},n),t[0]}e.parse=g;function c(s,o=[],n=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function r(p){return i.children.push(p),p}u(s,{onObjectBegin:p=>{i=r({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,d,E)=>{i=r({type:"property",offset:d,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:d,length:E,parent:i})},onObjectEnd:(p,d)=>{i.length=p+d-i.offset,i=i.parent,t(p+d)},onArrayBegin:(p,d)=>{i=r({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,d)=>{i.length=p+d-i.offset,i=i.parent,t(p+d)},onLiteralValue:(p,d,E)=>{r({type:C(p),offset:d,length:E,parent:i,value:p}),t(d+E)},onSeparator:(p,d,E)=>{i.type==="property"&&(p===":"?i.colonOffset=d:p===","&&t(d))},onError:(p,d,E)=>{o.push({error:p,offset:d,length:E})}},n);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=c;function f(s,o){if(!s)return;let n=s;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.findNodeAtLocation=f;function y(s){if(!s.parent||!s.parent.children)return[];const o=y(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;o.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&o.push(n)}return o}e.getNodePath=y;function v(s){switch(s.type){case"array":return s.children.map(v);case"object":{const o=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(o[n.children[0].value]=v(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=v;function l(s,o,n=!1){return o>=s.offset&&o<s.offset+s.length||n&&o===s.offset+s.length}e.contains=l;function h(s,o,n=!1){if(l(s,o,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=h(i[t],o,n);if(r)return r}return s}}e.findNodeAtOffset=h;function u(s,o,n=T.DEFAULT){const i=_(s,!1);function t(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Z){return Z?re=>Z(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),w=r(o.onObjectProperty),p=t(o.onObjectEnd),d=t(o.onArrayBegin),E=t(o.onArrayEnd),L=r(o.onLiteralValue),N=r(o.onSeparator),F=t(o.onComment),M=r(o.onError),W=n&&n.disallowComments,Q=n&&n.allowTrailingComma;function H(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:W||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(Z){case 12:case 13:W?X(10):F();break;case 16:X(1);break;case 15:case 14:break;default:return Z}}}function X(Z,re=[],G=[]){if(M(Z),re.length+G.length>0){let $=i.getToken();for(;$!==17;){if(re.indexOf($)!==-1){H();break}else if(G.indexOf($)!==-1)break;$=H()}}}function z(Z){const re=i.getTokenValue();return Z?L(re):w(re),H(),!0}function Y(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(X(2),Z=0)}catch{X(2)}L(Z);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return H(),!0}function x(){return i.getToken()!==10?(X(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(N(":"),H(),se()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function q(){a(),H();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||X(4,[],[]),N(","),H(),i.getToken()===2&&Q)break}else Z&&X(6,[],[]);x()||X(4,[],[2,5]),Z=!0}return p(),i.getToken()!==2?X(7,[2],[]):H(),!0}function te(){d(),H();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||X(4,[],[]),N(","),H(),i.getToken()===4&&Q)break}else Z&&X(6,[],[]);se()||X(4,[],[4,5]),Z=!0}return E(),i.getToken()!==4?X(8,[4],[]):H(),!0}function se(){switch(i.getToken()){case 3:return te();case 1:return q();case 10:return z(!0);default:return Y()}}return H(),i.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):se()?(i.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=u;function m(s,o){const n=_(s),i=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&i.push(s.substring(r,a)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return i.join("")}e.stripComments=m;function C(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(le[42],ue([0,1,35]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function U(S,D,b){let g,c,f,y,v;if(D){for(y=D.offset,v=y+D.length,f=y;f>0&&!I(S,f-1);)f--;let a=v;for(;a<S.length&&!I(S,a);)a++;c=S.substring(f,a),g=_(c,b)}else c=S,g=0,f=0,y=0,v=S.length;const l=R(b,S);let h=!1,u=0,m;b.insertSpaces?m=T(" ",b.tabSize||4):m="	";const C=(0,k.createScanner)(c,!1);let s=!1;function o(){return l+T(m,g+u)}function n(){let a=C.scan();for(h=!1;a===15||a===14;)h=h||a===14,a=C.scan();return s=a===16||C.getTokenError()!==0,a}const i=[];function t(a,w,p){!s&&w<v&&p>y&&S.substring(w,p)!==a&&i.push({offset:w,length:p-w,content:a})}let r=n();if(r!==17){const a=C.getTokenOffset()+f,w=T(m,g);t(w,f,a)}for(;r!==17;){let a=C.getTokenOffset()+C.getTokenLength()+f,w=n(),p="";for(;!h&&(w===12||w===13);){const E=C.getTokenOffset()+f;t(" ",a,E),a=C.getTokenOffset()+C.getTokenLength()+f,p=w===12?o():"",w=n()}if(w===2)r!==1&&(u--,p=o());else if(w===4)r!==3&&(u--,p=o());else{switch(r){case 3:case 1:u++,p=o();break;case 5:case 12:p=o();break;case 13:h?p=o():p=" ";break;case 6:p=" ";break;case 10:if(w===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?p=" ":w!==5&&w!==17&&(s=!0);break;case 16:s=!0;break}h&&(w===12||w===13)&&(p=o())}const d=C.getTokenOffset()+f;t(p,a,d),r=w}return i}e.format=U;function A(S,D){const b=JSON.stringify(S,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?b.replace(/\r\n|\r|\n/g,D.eol):b}e.toFormattedString=A;function T(S,D){let b="";for(let g=0;g<D;g++)b+=S;return b}function _(S,D){let b=0,g=0;const c=D.tabSize||4;for(;b<S.length;){const f=S.charAt(b);if(f===" ")g++;else if(f==="	")g+=c;else break;b++}return Math.floor(g/c)}function R(S,D){for(let b=0;b<D.length;b++){const g=D.charAt(b);if(g==="\r")return b+1<D.length&&D.charAt(b+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function I(S,D){return`\r
`.indexOf(S.charAt(D))!==-1}e.isEOL=I}),define(le[86],ue([0,1,35,42]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(S,D,b){return T(S,D,void 0,b)}e.removeProperty=A;function T(S,D,b,g,c){const f=D.slice(),y=[],v=(0,k.parseTree)(S,y);let l,h;for(;f.length>0&&(h=f.pop(),l=(0,k.findNodeAtLocation)(v,f),l===void 0&&b!==void 0);)typeof h=="string"?b={[h]:b}:b=[b];if(l)if(l.type==="object"&&typeof h=="string"&&Array.isArray(l.children)){const u=(0,k.findNodeAtLocation)(l,[h]);if(u!==void 0)if(b===void 0){if(!u.parent)throw new Error("Malformed AST");const m=l.children.indexOf(u.parent);let C,s=u.parent.offset+u.parent.length;if(m>0){const o=l.children[m-1];C=o.offset+o.length}else C=l.offset+1,l.children.length>1&&(s=l.children[1].offset);return _(S,{offset:C,length:s-C,content:""},g)}else return _(S,{offset:u.offset,length:u.length,content:JSON.stringify(b)},g);else{if(b===void 0)return[];const m=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,C=c?c(l.children.map(o=>o.children[0].value)):l.children.length;let s;if(C>0){const o=l.children[C-1];s={offset:o.offset+o.length,length:0,content:","+m}}else l.children.length===0?s={offset:l.offset+1,length:0,content:m}:s={offset:l.offset+1,length:0,content:m+","};return _(S,s,g)}}else if(l.type==="array"&&typeof h=="number"&&Array.isArray(l.children))if(b!==void 0){const u=`${JSON.stringify(b)}`;let m;if(l.children.length===0||h===0)m={offset:l.offset+1,length:0,content:l.children.length===0?u:u+","};else{const C=h===-1||h>l.children.length?l.children.length:h,s=l.children[C-1];m={offset:s.offset+s.length,length:0,content:","+u}}return _(S,m,g)}else{const u=h,m=l.children[u];let C;if(l.children.length===1)C={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===u){const s=l.children[u-1],o=s.offset+s.length,n=l.offset+l.length;C={offset:o,length:n-2-o,content:""}}else C={offset:m.offset,length:l.children[u+1].offset-m.offset,content:""};return _(S,C,g)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${l.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return _(S,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(b)},g)}}e.setProperty=T;function _(S,D,b){let g=R(S,D),c=D.offset,f=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;c>0&&!(0,U.isEOL)(g,c-1);)c--;for(;f<g.length&&!(0,U.isEOL)(g,f);)f++}const y=(0,U.format)(g,{offset:c,length:f-c},b);for(let l=y.length-1;l>=0;l--){const h=y[l];g=R(g,h),c=Math.min(c,h.offset),f=Math.max(f,h.offset+h.length),f+=h.content.length-h.length}const v=S.length-(g.length-f)-c;return[{offset:c,length:v,content:g.substring(c,f)}]}e.withFormatting=_;function R(S,D){return S.substring(0,D.offset)+D.content+S.substring(D.offset+D.length)}e.applyEdit=R;function I(S,D){const b=D.slice(0).sort((c,f)=>{const y=c.offset-f.offset;return y===0?c.length-f.length:y});let g=S.length;for(let c=b.length-1;c>=0;c--){const f=b[c];if(f.offset+f.length<=g)S=R(S,f);else throw new Error("Overlapping edit");g=f.offset}return S}e.applyEdits=I}),define(le[52],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(A){this.executor=A,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=k}),define(le[87],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{static{this.Undefined=new k(void 0)}constructor(T){this.element=T,this.next=k.Undefined,this.prev=k.Undefined}}class U{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let T=this._first;for(;T!==k.Undefined;){const _=T.next;T.prev=k.Undefined,T.next=k.Undefined,T=_}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,_){const R=new k(T);if(this._first===k.Undefined)this._first=R,this._last=R;else if(_){const S=this._last;this._last=R,R.prev=S,S.next=R}else{const S=this._first;this._first=R,R.next=S,S.prev=R}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(R))}}shift(){if(this._first!==k.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==k.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==k.Undefined&&T.next!==k.Undefined){const _=T.prev;_.next=T.next,T.next.prev=_}else T.prev===k.Undefined&&T.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):T.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):T.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==k.Undefined;)yield T.element,T=T.next}}e.LinkedList=U}),define(le[34],ue([0,1]),function(ne,e){"use strict";var k,U,A;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function T(h,u,m){let C=h.get(u);return C===void 0&&(C=m,h.set(u,C)),C}e.getOrSet=T;function _(h){const u=[];return h.forEach((m,C)=>{u.push(`${C} => ${m}`)}),`Map(${h.size}) {${u.join(", ")}}`}e.mapToString=_;function R(h){const u=[];return h.forEach(m=>{u.push(m)}),`Set(${h.size}) {${u.join(", ")}}`}e.setToString=R;class I{constructor(u,m){this.uri=u,this.value=m}}function S(h){return Array.isArray(h)}class D{static{this.defaultToKey=u=>u.toString()}constructor(u,m){if(this[k]="ResourceMap",u instanceof D)this.map=new Map(u.map),this.toKey=m??D.defaultToKey;else if(S(u)){this.map=new Map,this.toKey=m??D.defaultToKey;for(const[C,s]of u)this.set(C,s)}else this.map=new Map,this.toKey=u??D.defaultToKey}set(u,m){return this.map.set(this.toKey(u),new I(u,m)),this}get(u){return this.map.get(this.toKey(u))?.value}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,m){typeof m<"u"&&(u=u.bind(m));for(const[C,s]of this.map)u(s.value,s.uri,this)}*values(){for(const u of this.map.values())yield u.value}*keys(){for(const u of this.map.values())yield u.uri}*entries(){for(const u of this.map.values())yield[u.uri,u.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.map)yield[u.uri,u.value]}}e.ResourceMap=D;class b{constructor(u,m){this[U]="ResourceSet",!u||typeof u=="function"?this._map=new D(u):(this._map=new D(m),u.forEach(this.add,this))}get size(){return this._map.size}add(u){return this._map.set(u,u),this}clear(){this._map.clear()}delete(u){return this._map.delete(u)}forEach(u,m){this._map.forEach((C,s)=>u.call(m,s,s,this))}has(u){return this._map.has(u)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var g;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class c{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(u){return this._map.has(u)}get(u,m=0){const C=this._map.get(u);if(C)return m!==0&&this.touch(C,m),C.value}set(u,m,C=0){let s=this._map.get(u);if(s)s.value=m,C!==0&&this.touch(s,C);else{switch(s={key:u,value:m,next:void 0,previous:void 0},C){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(u,s),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const m=this._map.get(u);if(m)return this._map.delete(u),this.removeItem(m),this._size--,m.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}forEach(u,m){const C=this._state;let s=this._head;for(;s;){if(m?u.bind(m)(s.value,s.key,this):u(s.value,s.key,this),this._state!==C)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,m=this._state;let C=this._head;const s={[Symbol.iterator](){return s},next(){if(u._state!==m)throw new Error("LinkedMap got modified during iteration.");if(C){const o={value:C.key,done:!1};return C=C.next,o}else return{value:void 0,done:!0}}};return s}values(){const u=this,m=this._state;let C=this._head;const s={[Symbol.iterator](){return s},next(){if(u._state!==m)throw new Error("LinkedMap got modified during iteration.");if(C){const o={value:C.value,done:!1};return C=C.next,o}else return{value:void 0,done:!0}}};return s}entries(){const u=this,m=this._state;let C=this._head;const s={[Symbol.iterator](){return s},next(){if(u._state!==m)throw new Error("LinkedMap got modified during iteration.");if(C){const o={value:[C.key,C.value],done:!1};return C=C.next,o}else return{value:void 0,done:!0}}};return s}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(u>=this.size)return;if(u===0){this.clear();return}let m=this._head,C=this.size;for(;m&&C>u;)this._map.delete(m.key),m=m.next,C--;this._head=m,this._size=C,m&&(m.previous=void 0),this._state++}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const m=u.next,C=u.previous;if(!m||!C)throw new Error("Invalid list");m.previous=C,C.next=m}u.next=void 0,u.previous=void 0,this._state++}touch(u,m){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(u===this._head)return;const C=u.next,s=u.previous;u===this._tail?(s.next=void 0,this._tail=s):(C.previous=s,s.next=C),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(m===2){if(u===this._tail)return;const C=u.next,s=u.previous;u===this._head?(C.previous=void 0,this._head=C):(C.previous=s,s.next=C),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((m,C)=>{u.push([C,m])}),u}fromJSON(u){this.clear();for(const[m,C]of u)this.set(m,C)}}e.LinkedMap=c;class f extends c{constructor(u,m=1){super(),this._limit=u,this._ratio=Math.min(Math.max(0,m),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,m=2){return super.get(u,m)}peek(u){return super.get(u,0)}set(u,m){return super.set(u,m,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class y{constructor(){this.map=new Map}add(u){return this.map.set(u,(this.map.get(u)||0)+1),this}delete(u){let m=this.map.get(u)||0;return m===0?!1:(m--,m===0?this.map.delete(u):this.map.set(u,m),!0)}has(u){return this.map.has(u)}}e.CounterSet=y;class v{constructor(u){if(this._m1=new Map,this._m2=new Map,u)for(const[m,C]of u)this.set(m,C)}clear(){this._m1.clear(),this._m2.clear()}set(u,m){this._m1.set(u,m),this._m2.set(m,u)}get(u){return this._m1.get(u)}getKey(u){return this._m2.get(u)}delete(u){const m=this._m1.get(u);return m===void 0?!1:(this._m1.delete(u),this._m2.delete(m),!0)}forEach(u,m){this._m1.forEach((C,s)=>{u.call(m,C,s,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=v;class l{constructor(){this.map=new Map}add(u,m){let C=this.map.get(u);C||(C=new Set,this.map.set(u,C)),C.add(m)}delete(u,m){const C=this.map.get(u);C&&(C.delete(m),C.size===0&&this.map.delete(u))}forEach(u,m){const C=this.map.get(u);C&&C.forEach(m)}get(u){const m=this.map.get(u);return m||new Set}}e.SetMap=l}),define(le[2],ue([0,1,18,125,34,85,61]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const R=!1;let I=null;class S{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(L){let N=this.livingDisposables.get(L);return N||(N={parent:null,source:null,isSingleton:!1,value:L,idx:S.idx++},this.livingDisposables.set(L,N)),N}trackDisposable(L){const N=this.getDisposableData(L);N.source||(N.source=new Error().stack)}setParent(L,N){const F=this.getDisposableData(L);F.parent=N}markAsDisposed(L){this.livingDisposables.delete(L)}markAsSingleton(L){this.getDisposableData(L).isSingleton=!0}getRootParent(L,N){const F=N.get(L);if(F)return F;const M=L.parent?this.getRootParent(this.getDisposableData(L.parent),N):L;return N.set(L,M),M}getTrackedDisposables(){const L=new Map;return[...this.livingDisposables.entries()].filter(([,F])=>F.source!==null&&!this.getRootParent(F,L).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(L=10,N){let F;if(N)F=N;else{const X=new Map,z=[...this.livingDisposables.values()].filter(x=>x.source!==null&&!this.getRootParent(x,X).isSingleton);if(z.length===0)return;const Y=new Set(z.map(x=>x.value));if(F=z.filter(x=>!(x.parent&&Y.has(x.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(X){function z(x,q){for(;x.length>0&&q.some(te=>typeof te=="string"?te===x[0]:x[0].match(te));)x.shift()}const Y=X.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return z(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const W=new A.SetMap;for(const X of F){const z=M(X);for(let Y=0;Y<=z.length;Y++)W.add(z.slice(0,Y).join(`
`),X)}F.sort((0,k.compareBy)(X=>X.idx,k.numberComparator));let Q="",H=0;for(const X of F.slice(0,L)){H++;const z=M(X),Y=[];for(let x=0;x<z.length;x++){let q=z[x];q=`(shared with ${W.get(z.slice(0,x+1).join(`
`)).size}/${F.length} leaks) at ${q}`;const se=W.get(z.slice(0,x).join(`
`)),Z=(0,U.groupBy)([...se].map(re=>M(re)[x]),re=>re);delete Z[z[x]];for(const[re,G]of Object.entries(Z))Y.unshift(`    - stacktraces of ${G.length} other leaks continue with ${re}`);Y.unshift(q)}Q+=`


==================== Leaking disposable ${H}/${F.length}: ${X.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return F.length>L&&(Q+=`


... and ${F.length-L} more leaking disposables

`),{leaks:F,details:Q}}}e.DisposableTracker=S;function D(E){I=E}if(e.setDisposableTracker=D,R){const E="__is_disposable_tracked__";D(new class{trackDisposable(L){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[E]||console.log(N)},3e3)}setParent(L,N){if(L&&L!==s.None)try{L[E]=!0}catch{}}markAsDisposed(L){if(L&&L!==s.None)try{L[E]=!0}catch{}}markAsSingleton(L){}})}function b(E){return I?.trackDisposable(E),E}e.trackDisposable=b;function g(E){I?.markAsDisposed(E)}e.markAsDisposed=g;function c(E,L){I?.setParent(E,L)}function f(E,L){if(I)for(const N of E)I.setParent(N,L)}function y(E){return I?.markAsSingleton(E),E}e.markAsSingleton=y;function v(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.isDisposable=v;function l(E){if(_.Iterable.is(E)){const L=[];for(const N of E)if(N)try{N.dispose()}catch(F){L.push(F)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.dispose=l;function h(E){for(const L of E)v(L)&&L.dispose();return[]}e.disposeIfDisposable=h;function u(...E){const L=m(()=>l(E));return f(E,L),L}e.combinedDisposable=u;function m(E){const L=b({dispose:(0,T.createSingleCallFunction)(()=>{g(L),E()})});return L}e.toDisposable=m;class C{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{l(this._toDispose)}finally{this._toDispose.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return c(L,this),this._isDisposed?C.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(L),L.dispose()}}deleteAndLeak(L){L&&this._toDispose.has(L)&&(this._toDispose.delete(L),c(L,null))}}e.DisposableStore=C;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new C,b(this),c(this._store,this)}dispose(){g(this),this._store.dispose()}_register(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(L)}}e.Disposable=s;class o{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(L){this._isDisposed||L===this._value||(this._value?.dispose(),L&&c(L,this),this._value=L)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const L=this._value;return this._value=void 0,L&&c(L,null),L}}e.MutableDisposable=o;class n{constructor(L){this._disposable=new o,this._isDisposed=!1,this._disposable.value=L}get value(){return this._disposable.value}set value(L){this._isDisposed||L===this._disposable.value||(this._disposable.value=L)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=n;class i{constructor(L){this._disposable=L,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=i;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(L){let N=L;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,g(this))},this}}e.SafeDisposable=t;class r{constructor(){this.references=new Map}acquire(L,...N){let F=this.references.get(L);F||(F={counter:0,object:this.createReferencedObject(L,...N)},this.references.set(L,F));const{object:M}=F,W=(0,T.createSingleCallFunction)(()=>{--F.counter===0&&(this.destroyReferencedObject(L,F.object),this.references.delete(L))});return F.counter++,{object:M,dispose:W}}}e.ReferenceCollection=r;class a{constructor(L){this.referenceCollection=L}async acquire(L,...N){const F=this.referenceCollection.acquire(L,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.AsyncReferenceCollection=a;class w{constructor(L){this.object=L}dispose(){}}e.ImmortalReference=w;function p(E){const L=new C;try{E(L)}finally{L.dispose()}}e.disposeOnReturn=p;class d{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{l(this._store.values())}finally{this._store.clear()}}has(L){return this._store.has(L)}get size(){return this._store.size}get(L){return this._store.get(L)}set(L,N,F=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this._store.get(L)?.dispose(),this._store.set(L,N)}deleteAndDispose(L){this._store.get(L)?.dispose(),this._store.delete(L)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=d}),define(le[88],ue([0,1,34]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const U=new k.LRUCache(1e4);function A(S){return I(S,"NFC",U)}e.normalizeNFC=A;const T=new k.LRUCache(1e4);function _(S){return I(S,"NFD",T)}e.normalizeNFD=_;const R=/[^\u0000-\u0080]/;function I(S,D,b){if(!S)return S;const g=b.get(S);if(g)return g;let c;return R.test(S)?c=S.normalize(D):c=S,b.set(S,c),c}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(D){return _(D).replace(S,"")}}()}),function(){function ne(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function _(I){T.push(I,Date.now())}function R(){const I=[];for(let S=0;S<T.length;S+=2)I.push({name:T[S],startTime:T[S+1]});return I}return{mark:_,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const _ of performance.getEntriesByType("mark"))T.push({name:_.name,startTime:Math.round(A+_.startTime)});return T}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function k(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=k(U))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var U in k)(typeof exports=="object"?exports:ne)[U]=k[U]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function k(U){if(e[U])return e[U].exports;var A=e[U]={i:U,l:!1,exports:{}};return ne[U].call(A.exports,A,A.exports,k),A.l=!0,A.exports}return k.m=ne,k.c=e,k.d=function(U,A,T){k.o(U,A)||Object.defineProperty(U,A,{enumerable:!0,get:T})},k.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},k.t=function(U,A){if(1&A&&(U=k(U)),8&A||4&A&&typeof U=="object"&&U&&U.__esModule)return U;var T=Object.create(null);if(k.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:U}),2&A&&typeof U!="string")for(var _ in U)k.d(T,_,function(R){return U[R]}.bind(null,_));return T},k.n=function(U){var A=U&&U.__esModule?function(){return U.default}:function(){return U};return k.d(A,"a",A),A},k.o=function(U,A){return Object.prototype.hasOwnProperty.call(U,A)},k.p="",k(k.s=0)}([function(ne,e,k){(function(U){var A;e=ne.exports=G,A=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],I=e.src=[],S=0,D=S++;I[D]="0|[1-9]\\d*";var b=S++;I[b]="[0-9]+";var g=S++;I[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=S++;I[c]="("+I[D]+")\\.("+I[D]+")\\.("+I[D]+")";var f=S++;I[f]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var y=S++;I[y]="(?:"+I[D]+"|"+I[g]+")";var v=S++;I[v]="(?:"+I[b]+"|"+I[g]+")";var l=S++;I[l]="(?:-("+I[y]+"(?:\\."+I[y]+")*))";var h=S++;I[h]="(?:-?("+I[v]+"(?:\\."+I[v]+")*))";var u=S++;I[u]="[0-9A-Za-z-]+";var m=S++;I[m]="(?:\\+("+I[u]+"(?:\\."+I[u]+")*))";var C=S++,s="v?"+I[c]+I[l]+"?"+I[m]+"?";I[C]="^"+s+"$";var o="[v=\\s]*"+I[f]+I[h]+"?"+I[m]+"?",n=S++;I[n]="^"+o+"$";var i=S++;I[i]="((?:<|>)?=?)";var t=S++;I[t]=I[b]+"|x|X|\\*";var r=S++;I[r]=I[D]+"|x|X|\\*";var a=S++;I[a]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[l]+")?"+I[m]+"?)?)?";var w=S++;I[w]="[v=\\s]*("+I[t]+")(?:\\.("+I[t]+")(?:\\.("+I[t]+")(?:"+I[h]+")?"+I[m]+"?)?)?";var p=S++;I[p]="^"+I[i]+"\\s*"+I[a]+"$";var d=S++;I[d]="^"+I[i]+"\\s*"+I[w]+"$";var E=S++;I[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=S++;I[L]="(?:~>?)";var N=S++;I[N]="(\\s*)"+I[L]+"\\s+",R[N]=new RegExp(I[N],"g");var F=S++;I[F]="^"+I[L]+I[a]+"$";var M=S++;I[M]="^"+I[L]+I[w]+"$";var W=S++;I[W]="(?:\\^)";var Q=S++;I[Q]="(\\s*)"+I[W]+"\\s+",R[Q]=new RegExp(I[Q],"g");var H=S++;I[H]="^"+I[W]+I[a]+"$";var X=S++;I[X]="^"+I[W]+I[w]+"$";var z=S++;I[z]="^"+I[i]+"\\s*("+o+")$|^$";var Y=S++;I[Y]="^"+I[i]+"\\s*("+s+")$|^$";var x=S++;I[x]="(\\s*)"+I[i]+"\\s*("+o+"|"+I[a]+")",R[x]=new RegExp(I[x],"g");var q=S++;I[q]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var te=S++;I[te]="^\\s*("+I[w]+")\\s+-\\s+("+I[w]+")\\s*$";var se=S++;I[se]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)A(Z,I[Z]),R[Z]||(R[Z]=new RegExp(I[Z]));function re(he,me){if(he instanceof G)return he;if(typeof he!="string"||he.length>T||!(me?R[n]:R[C]).test(he))return null;try{return new G(he,me)}catch{return null}}function G(he,me){if(he instanceof G){if(he.loose===me)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof G))return new G(he,me);A("SemVer",he,me),this.loose=me;var Se=he.trim().match(me?R[n]:R[C]);if(!Se)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+Se[1],this.minor=+Se[2],this.patch=+Se[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");Se[4]?this.prerelease=Se[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<_)return Re}return Pe}):this.prerelease=[],this.build=Se[5]?Se[5].split("."):[],this.format()}e.parse=re,e.valid=function(he,me){var Se=re(he,me);return Se?Se.version:null},e.clean=function(he,me){var Se=re(he.trim().replace(/^[=v]+/,""),me);return Se?Se.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(he){return A("SemVer.compare",this.version,this.loose,he),he instanceof G||(he=new G(he,this.loose)),this.compareMain(he)||this.comparePre(he)},G.prototype.compareMain=function(he){return he instanceof G||(he=new G(he,this.loose)),P(this.major,he.major)||P(this.minor,he.minor)||P(this.patch,he.patch)},G.prototype.comparePre=function(he){if(he instanceof G||(he=new G(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var me=0;do{var Se=this.prerelease[me],Pe=he.prerelease[me];if(A("prerelease compare",me,Se,Pe),Se===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(Se===void 0)return-1;if(Se!==Pe)return P(Se,Pe)}while(++me)},G.prototype.inc=function(he,me){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Se=this.prerelease.length;--Se>=0;)typeof this.prerelease[Se]=="number"&&(this.prerelease[Se]++,Se=-2);Se===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,me,Se,Pe){typeof Se=="string"&&(Pe=Se,Se=void 0);try{return new G(he,Se).inc(me,Pe).version}catch{return null}},e.diff=function(he,me){if(ee(he,me))return null;var Se=re(he),Pe=re(me);if(Se.prerelease.length||Pe.prerelease.length){for(var Re in Se)if((Re==="major"||Re==="minor"||Re==="patch")&&Se[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in Se)if((Re==="major"||Re==="minor"||Re==="patch")&&Se[Re]!==Pe[Re])return Re},e.compareIdentifiers=P;var $=/^[0-9]+$/;function P(he,me){var Se=$.test(he),Pe=$.test(me);return Se&&Pe&&(he=+he,me=+me),Se&&!Pe?-1:Pe&&!Se?1:he<me?-1:he>me?1:0}function O(he,me,Se){return new G(he,Se).compare(new G(me,Se))}function B(he,me,Se){return O(he,me,Se)>0}function j(he,me,Se){return O(he,me,Se)<0}function ee(he,me,Se){return O(he,me,Se)===0}function V(he,me,Se){return O(he,me,Se)!==0}function K(he,me,Se){return O(he,me,Se)>=0}function ie(he,me,Se){return O(he,me,Se)<=0}function ce(he,me,Se,Pe){var Re;switch(me){case"===":typeof he=="object"&&(he=he.version),typeof Se=="object"&&(Se=Se.version),Re=he===Se;break;case"!==":typeof he=="object"&&(he=he.version),typeof Se=="object"&&(Se=Se.version),Re=he!==Se;break;case"":case"=":case"==":Re=ee(he,Se,Pe);break;case"!=":Re=V(he,Se,Pe);break;case">":Re=B(he,Se,Pe);break;case">=":Re=K(he,Se,Pe);break;case"<":Re=j(he,Se,Pe);break;case"<=":Re=ie(he,Se,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function oe(he,me){if(he instanceof oe){if(he.loose===me)return he;he=he.value}if(!(this instanceof oe))return new oe(he,me);A("comparator",he,me),this.loose=me,this.parse(he),this.semver===de?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(he,me){return P(me,he)},e.major=function(he,me){return new G(he,me).major},e.minor=function(he,me){return new G(he,me).minor},e.patch=function(he,me){return new G(he,me).patch},e.compare=O,e.compareLoose=function(he,me){return O(he,me,!0)},e.rcompare=function(he,me,Se){return O(me,he,Se)},e.sort=function(he,me){return he.sort(function(Se,Pe){return e.compare(Se,Pe,me)})},e.rsort=function(he,me){return he.sort(function(Se,Pe){return e.rcompare(Se,Pe,me)})},e.gt=B,e.lt=j,e.eq=ee,e.neq=V,e.gte=K,e.lte=ie,e.cmp=ce,e.Comparator=oe;var de={};function fe(he,me){if(he instanceof fe)return he.loose===me?he:new fe(he.raw,me);if(he instanceof oe)return new fe(he.value,me);if(!(this instanceof fe))return new fe(he,me);if(this.loose=me,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(Se){return this.parseRange(Se.trim())},this).filter(function(Se){return Se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function pe(he){return!he||he.toLowerCase()==="x"||he==="*"}function we(he,me,Se,Pe,Re,Me,Te,je,Ue,$e,ae,ge,ve){return((me=pe(Se)?"":pe(Pe)?">="+Se+".0.0":pe(Re)?">="+Se+"."+Pe+".0":">="+me)+" "+(je=pe(Ue)?"":pe($e)?"<"+(+Ue+1)+".0.0":pe(ae)?"<"+Ue+"."+(+$e+1)+".0":ge?"<="+Ue+"."+$e+"."+ae+"-"+ge:"<="+je)).trim()}function Le(he,me){for(var Se=0;Se<he.length;Se++)if(!he[Se].test(me))return!1;if(me.prerelease.length){for(Se=0;Se<he.length;Se++)if(A(he[Se].semver),he[Se].semver!==de&&he[Se].semver.prerelease.length>0){var Pe=he[Se].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function ke(he,me,Se){try{me=new fe(me,Se)}catch{return!1}return me.test(he)}function Fe(he,me,Se,Pe){var Re,Me,Te,je,Ue;switch(he=new G(he,Pe),me=new fe(me,Pe),Se){case">":Re=B,Me=ie,Te=j,je=">",Ue=">=";break;case"<":Re=j,Me=K,Te=B,je="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(he,me,Pe))return!1;for(var $e=0;$e<me.set.length;++$e){var ae=me.set[$e],ge=null,ve=null;if(ae.forEach(function(Ee){Ee.semver===de&&(Ee=new oe(">=0.0.0")),ge=ge||Ee,ve=ve||Ee,Re(Ee.semver,ge.semver,Pe)?ge=Ee:Te(Ee.semver,ve.semver,Pe)&&(ve=Ee)}),ge.operator===je||ge.operator===Ue||(!ve.operator||ve.operator===je)&&Me(he,ve.semver)||ve.operator===Ue&&Te(he,ve.semver))return!1}return!0}oe.prototype.parse=function(he){var me=this.loose?R[z]:R[Y],Se=he.match(me);if(!Se)throw new TypeError("Invalid comparator: "+he);this.operator=Se[1],this.operator==="="&&(this.operator=""),Se[2]?this.semver=new G(Se[2],this.loose):this.semver=de},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(he){return A("Comparator.test",he,this.loose),this.semver===de||(typeof he=="string"&&(he=new G(he,this.loose)),ce(he,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(he,me){if(!(he instanceof oe))throw new TypeError("a Comparator is required");var Se;if(this.operator==="")return Se=new fe(he.value,me),ke(this.value,Se,me);if(he.operator==="")return Se=new fe(this.value,me),ke(he.semver,Se,me);var Pe=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),Me=this.semver.version===he.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),je=ce(this.semver,"<",he.semver,me)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Ue=ce(this.semver,">",he.semver,me)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Pe||Re||Me&&Te||je||Ue},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(he){var me=this.loose;he=he.trim(),A("range",he,me);var Se=me?R[te]:R[q];he=he.replace(Se,we),A("hyphen replace",he),he=he.replace(R[x],"$1$2$3"),A("comparator trim",he,R[x]),he=(he=(he=he.replace(R[N],"$1~")).replace(R[Q],"$1^")).split(/\s+/).join(" ");var Pe=me?R[z]:R[Y],Re=he.split(" ").map(function(Me){return function(Te,je){return A("comp",Te),Te=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(ae){return function(ge,ve){A("caret",ge,ve);var Ee=ve?R[X]:R[H];return ge.replace(Ee,function(Ie,be,De,_e,Oe){var Ne;return A("caret",ge,Ie,be,De,_e,Oe),pe(be)?Ne="":pe(De)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":pe(_e)?Ne=be==="0"?">="+be+"."+De+".0 <"+be+"."+(+De+1)+".0":">="+be+"."+De+".0 <"+(+be+1)+".0.0":Oe?(A("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=be==="0"?De==="0"?">="+be+"."+De+"."+_e+Oe+" <"+be+"."+De+"."+(+_e+1):">="+be+"."+De+"."+_e+Oe+" <"+be+"."+(+De+1)+".0":">="+be+"."+De+"."+_e+Oe+" <"+(+be+1)+".0.0"):(A("no pr"),Ne=be==="0"?De==="0"?">="+be+"."+De+"."+_e+" <"+be+"."+De+"."+(+_e+1):">="+be+"."+De+"."+_e+" <"+be+"."+(+De+1)+".0":">="+be+"."+De+"."+_e+" <"+(+be+1)+".0.0"),A("caret return",Ne),Ne})}(ae,$e)}).join(" ")}(Te,je),A("caret",Te),Te=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(ae){return function(ge,ve){var Ee=ve?R[M]:R[F];return ge.replace(Ee,function(Ie,be,De,_e,Oe){var Ne;return A("tilde",ge,Ie,be,De,_e,Oe),pe(be)?Ne="":pe(De)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":pe(_e)?Ne=">="+be+"."+De+".0 <"+be+"."+(+De+1)+".0":Oe?(A("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+be+"."+De+"."+_e+Oe+" <"+be+"."+(+De+1)+".0"):Ne=">="+be+"."+De+"."+_e+" <"+be+"."+(+De+1)+".0",A("tilde return",Ne),Ne})}(ae,$e)}).join(" ")}(Te,je),A("tildes",Te),Te=function(Ue,$e){return A("replaceXRanges",Ue,$e),Ue.split(/\s+/).map(function(ae){return function(ge,ve){ge=ge.trim();var Ee=ve?R[d]:R[p];return ge.replace(Ee,function(Ie,be,De,_e,Oe,Ne){A("xRange",ge,Ie,be,De,_e,Oe,Ne);var We=pe(De),ze=We||pe(_e),qe=ze||pe(Oe);return be==="="&&qe&&(be=""),We?Ie=be===">"||be==="<"?"<0.0.0":"*":be&&qe?(ze&&(_e=0),qe&&(Oe=0),be===">"?(be=">=",ze?(De=+De+1,_e=0,Oe=0):qe&&(_e=+_e+1,Oe=0)):be==="<="&&(be="<",ze?De=+De+1:_e=+_e+1),Ie=be+De+"."+_e+"."+Oe):ze?Ie=">="+De+".0.0 <"+(+De+1)+".0.0":qe&&(Ie=">="+De+"."+_e+".0 <"+De+"."+(+_e+1)+".0"),A("xRange return",Ie),Ie})}(ae,$e)}).join(" ")}(Te,je),A("xrange",Te),Te=function(Ue,$e){return A("replaceStars",Ue,$e),Ue.trim().replace(R[se],"")}(Te,je),A("stars",Te),Te}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Me){return!!Me.match(Pe)})),Re=Re.map(function(Me){return new oe(Me,me)})},fe.prototype.intersects=function(he,me){if(!(he instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(Se){return Se.every(function(Pe){return he.set.some(function(Re){return Re.every(function(Me){return Pe.intersects(Me,me)})})})})},e.toComparators=function(he,me){return new fe(he,me).set.map(function(Se){return Se.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new G(he,this.loose));for(var me=0;me<this.set.length;me++)if(Le(this.set[me],he))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(he,me,Se){var Pe=null,Re=null;try{var Me=new fe(me,Se)}catch{return null}return he.forEach(function(Te){Me.test(Te)&&(Pe&&Re.compare(Te)!==-1||(Re=new G(Pe=Te,Se)))}),Pe},e.minSatisfying=function(he,me,Se){var Pe=null,Re=null;try{var Me=new fe(me,Se)}catch{return null}return he.forEach(function(Te){Me.test(Te)&&(Pe&&Re.compare(Te)!==1||(Re=new G(Pe=Te,Se)))}),Pe},e.validRange=function(he,me){try{return new fe(he,me).range||"*"}catch{return null}},e.ltr=function(he,me,Se){return Fe(he,me,"<",Se)},e.gtr=function(he,me,Se){return Fe(he,me,">",Se)},e.outside=Fe,e.prerelease=function(he,me){var Se=re(he,me);return Se&&Se.prerelease.length?Se.prerelease:null},e.intersects=function(he,me,Se){return he=new fe(he,Se),me=new fe(me,Se),he.intersects(me)},e.coerce=function(he){if(he instanceof G)return he;if(typeof he!="string")return null;var me=he.match(R[E]);return me==null?null:re((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,k(1))},function(ne,e){var k,U,A=ne.exports={};function T(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function R(v){if(k===setTimeout)return setTimeout(v,0);if((k===T||!k)&&setTimeout)return k=setTimeout,setTimeout(v,0);try{return k(v,0)}catch{try{return k.call(null,v,0)}catch{return k.call(this,v,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:T}catch{k=T}try{U=typeof clearTimeout=="function"?clearTimeout:_}catch{U=_}})();var I,S=[],D=!1,b=-1;function g(){D&&I&&(D=!1,I.length?S=I.concat(S):b=-1,S.length&&c())}function c(){if(!D){var v=R(g);D=!0;for(var l=S.length;l;){for(I=S,S=[];++b<l;)I&&I[b].run();b=-1,l=S.length}I=null,D=!1,function(h){if(U===clearTimeout)return clearTimeout(h);if((U===_||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(h);try{U(h)}catch{try{return U.call(null,h)}catch{return U.call(this,h)}}}(v)}}function f(v,l){this.fun=v,this.array=l}function y(){}A.nextTick=function(v){var l=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)l[h-1]=arguments[h];S.push(new f(v,l)),S.length!==1||D||R(c)},f.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=y,A.addListener=y,A.once=y,A.off=y,A.removeListener=y,A.removeAllListeners=y,A.emit=y,A.prependListener=y,A.prependOnceListener=y,A.listeners=function(v){return[]},A.binding=function(v){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(v){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[127],ue([0,1]),function(ne,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(R,I,S){this.level=R,this.key=I,this.value=S,this.forward=[]}}const A=void 0;class T{constructor(R,I=2**16){this.comparator=R,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new U(this._maxLevel,A,A)}get size(){return this._size}clear(){this._header=new U(this._maxLevel,A,A),this._size=0}has(R){return!!T._search(this,R,this.comparator)}get(R){return T._search(this,R,this.comparator)?.value}set(R,I){return T._insert(this,R,I,this.comparator)&&(this._size+=1),this}delete(R){const I=T._delete(this,R,this.comparator);return I&&(this._size-=1),I}forEach(R,I){let S=this._header.forward[0];for(;S;)R.call(I,S.value,S.key,this),S=S.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",I=this._header.forward[0];for(;I;)R+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return R}static _search(R,I,S){let D=R._header;for(let b=R._level-1;b>=0;b--)for(;D.forward[b]&&S(D.forward[b].key,I)<0;)D=D.forward[b];if(D=D.forward[0],D&&S(D.key,I)===0)return D}static _insert(R,I,S,D){const b=[];let g=R._header;for(let c=R._level-1;c>=0;c--){for(;g.forward[c]&&D(g.forward[c].key,I)<0;)g=g.forward[c];b[c]=g}if(g=g.forward[0],g&&D(g.key,I)===0)return g.value=S,!1;{const c=T._randomLevel(R);if(c>R._level){for(let f=R._level;f<c;f++)b[f]=R._header;R._level=c}g=new U(c,I,S);for(let f=0;f<c;f++)g.forward[f]=b[f].forward[f],b[f].forward[f]=g;return!0}}static _randomLevel(R,I=.5){let S=1;for(;Math.random()<I&&S<R._maxLevel;)S+=1;return S}static _delete(R,I,S){const D=[];let b=R._header;for(let g=R._level-1;g>=0;g--){for(;b.forward[g]&&S(b.forward[g].key,I)<0;)b=b.forward[g];D[g]=b}if(b=b.forward[0],!b||S(b.key,I)!==0)return!1;for(let g=0;g<R._level&&D[g].forward[g]===b;g++)D[g].forward[g]=b.forward[g];for(;R._level>0&&R._header.forward[R._level-1]===A;)R._level-=1;return!0}}e.SkipList=T}),define(le[62],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class U{static create(T){return new U(T)}constructor(T){this._now=k&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=U}),define(le[3],ue([0,1,7,85,2,87,62]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,I=!1;var S;(function(p){p.None=()=>A.Disposable.None;function d(ce){if(I){const{onDidAddListener:oe}=ce,de=f.create();let fe=0;ce.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),oe?.()}}}function E(ce,oe){return Y(ce,()=>{},0,void 0,!0,void 0,oe)}p.defer=E;function L(ce){return(oe,de=null,fe)=>{let pe=!1,we;return we=ce(Le=>{if(!pe)return we?we.dispose():pe=!0,oe.call(de,Le)},null,fe),pe&&we.dispose(),we}}p.once=L;function N(ce,oe,de){return X((fe,pe=null,we)=>ce(Le=>fe.call(pe,oe(Le)),null,we),de)}p.map=N;function F(ce,oe,de){return X((fe,pe=null,we)=>ce(Le=>{oe(Le),fe.call(pe,Le)},null,we),de)}p.forEach=F;function M(ce,oe,de){return X((fe,pe=null,we)=>ce(Le=>oe(Le)&&fe.call(pe,Le),null,we),de)}p.filter=M;function W(ce){return ce}p.signal=W;function Q(...ce){return(oe,de=null,fe)=>{const pe=(0,A.combinedDisposable)(...ce.map(we=>we(Le=>oe.call(de,Le))));return z(pe,fe)}}p.any=Q;function H(ce,oe,de,fe){let pe=de;return N(ce,we=>(pe=oe(pe,we),pe),fe)}p.reduce=H;function X(ce,oe){let de;const fe={onWillAddFirstListener(){de=ce(pe.fire,pe)},onDidRemoveLastListener(){de?.dispose()}};oe||d(fe);const pe=new u(fe);return oe?.add(pe),pe.event}function z(ce,oe){return oe instanceof Array?oe.push(ce):oe&&oe.add(ce),ce}function Y(ce,oe,de=100,fe=!1,pe=!1,we,Le){let ke,Fe,he,me=0,Se;const Pe={leakWarningThreshold:we,onWillAddFirstListener(){ke=ce(Me=>{me++,Fe=oe(Fe,Me),fe&&!he&&(Re.fire(Fe),Fe=void 0),Se=()=>{const Te=Fe;Fe=void 0,he=void 0,(!fe||me>1)&&Re.fire(Te),me=0},typeof de=="number"?(clearTimeout(he),he=setTimeout(Se,de)):he===void 0&&(he=0,queueMicrotask(Se))})},onWillRemoveListener(){pe&&me>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,ke.dispose()}};Le||d(Pe);const Re=new u(Pe);return Le?.add(Re),Re.event}p.debounce=Y;function x(ce,oe=0,de){return p.debounce(ce,(fe,pe)=>fe?(fe.push(pe),fe):[pe],oe,void 0,!0,void 0,de)}p.accumulate=x;function q(ce,oe=(fe,pe)=>fe===pe,de){let fe=!0,pe;return M(ce,we=>{const Le=fe||!oe(we,pe);return fe=!1,pe=we,Le},de)}p.latch=q;function te(ce,oe,de){return[p.filter(ce,oe,de),p.filter(ce,fe=>!oe(fe),de)]}p.split=te;function se(ce,oe=!1,de=[],fe){let pe=de.slice(),we=ce(Fe=>{pe?pe.push(Fe):ke.fire(Fe)});fe&&fe.add(we);const Le=()=>{pe?.forEach(Fe=>ke.fire(Fe)),pe=null},ke=new u({onWillAddFirstListener(){we||(we=ce(Fe=>ke.fire(Fe)),fe&&fe.add(we))},onDidAddFirstListener(){pe&&(oe?setTimeout(Le):Le())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return fe&&fe.add(ke),ke.event}p.buffer=se;function Z(ce,oe){return(fe,pe,we)=>{const Le=oe(new G);return ce(function(ke){const Fe=Le.evaluate(ke);Fe!==re&&fe.call(pe,Fe)},void 0,we)}}p.chain=Z;const re=Symbol("HaltChainable");class G{constructor(){this.steps=[]}map(oe){return this.steps.push(oe),this}forEach(oe){return this.steps.push(de=>(oe(de),de)),this}filter(oe){return this.steps.push(de=>oe(de)?de:re),this}reduce(oe,de){let fe=de;return this.steps.push(pe=>(fe=oe(fe,pe),fe)),this}latch(oe=(de,fe)=>de===fe){let de=!0,fe;return this.steps.push(pe=>{const we=de||!oe(pe,fe);return de=!1,fe=pe,we?pe:re}),this}evaluate(oe){for(const de of this.steps)if(oe=de(oe),oe===re)break;return oe}}function $(ce,oe,de=fe=>fe){const fe=(...ke)=>Le.fire(de(...ke)),pe=()=>ce.on(oe,fe),we=()=>ce.removeListener(oe,fe),Le=new u({onWillAddFirstListener:pe,onDidRemoveLastListener:we});return Le.event}p.fromNodeEventEmitter=$;function P(ce,oe,de=fe=>fe){const fe=(...ke)=>Le.fire(de(...ke)),pe=()=>ce.addEventListener(oe,fe),we=()=>ce.removeEventListener(oe,fe),Le=new u({onWillAddFirstListener:pe,onDidRemoveLastListener:we});return Le.event}p.fromDOMEventEmitter=P;function O(ce){return new Promise(oe=>L(ce)(oe))}p.toPromise=O;function B(ce){const oe=new u;return ce.then(de=>{oe.fire(de)},()=>{oe.fire(void 0)}).finally(()=>{oe.dispose()}),oe.event}p.fromPromise=B;function j(ce,oe,de){return oe(de),ce(fe=>oe(fe))}p.runAndSubscribe=j;function ee(ce,oe){let de=null;function fe(we){de?.dispose(),de=new A.DisposableStore,oe(we,de)}fe(void 0);const pe=ce(we=>fe(we));return(0,A.toDisposable)(()=>{pe.dispose(),de?.dispose()})}p.runAndSubscribeWithStore=ee;class V{constructor(oe,de){this._observable=oe,this._counter=0,this._hasChanged=!1;const fe={onWillAddFirstListener:()=>{oe.addObserver(this)},onDidRemoveLastListener:()=>{oe.removeObserver(this)}};de||d(fe),this.emitter=new u(fe),de&&de.add(this.emitter)}beginUpdate(oe){this._counter++}handlePossibleChange(oe){}handleChange(oe,de){this._hasChanged=!0}endUpdate(oe){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function K(ce,oe){return new V(ce,oe).emitter.event}p.fromObservable=K;function ie(ce){return(oe,de,fe)=>{let pe=0,we=!1;const Le={beginUpdate(){pe++},endUpdate(){pe--,pe===0&&(ce.reportChanges(),we&&(we=!1,oe.call(de)))},handlePossibleChange(){},handleChange(){we=!0}};ce.addObserver(Le),ce.reportChanges();const ke={dispose(){ce.removeObserver(Le)}};return fe instanceof A.DisposableStore?fe.add(ke):Array.isArray(fe)&&fe.push(ke),ke}}p.fromObservableLight=ie})(S||(e.Event=S={}));class D{static{this.all=new Set}static{this._idPool=0}constructor(d){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${d}_${D._idPool++}`,D.all.add(this)}start(d){this._stopWatch=new _.StopWatch,this.listenerCount=d}stop(){if(this._stopWatch){const d=this._stopWatch.elapsed();this.durations.push(d),this.elapsedOverall+=d,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=D;let b=-1;function g(p){const d=b;return b=p,{dispose(){b=d}}}e.setGlobalLeakWarningThreshold=g;class c{constructor(d,E=Math.random().toString(18).slice(2,5)){this.threshold=d,this.name=E,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(d,E){const L=this.threshold;if(L<=0||E<L)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(d.value)||0;if(this._stacks.set(d.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=L*.5;let F,M=0;for(const[W,Q]of this._stacks)(!F||M<Q)&&(F=W,M=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this._stacks.get(d.value)||0;this._stacks.set(d.value,F-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(d){this.value=d}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class v{constructor(d){this.value=d,this.id=y++}}const l=2,h=(p,d)=>{if(p instanceof v)d(p);else for(let E=0;E<p.length;E++){const L=p[E];L&&d(L)}};class u{constructor(d){this._size=0,this._options=d,this._leakageMon=b>0||this._options?.leakWarningThreshold?new c(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(R){const d=this._listeners;queueMicrotask(()=>{h(d,E=>E.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(d,E,L)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;E&&(d=d.bind(E));const N=new v(d);let F,M;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(N.stack=f.create(),F=this._leakageMon.check(N.stack,this._size+1)),R&&(N.stack=M??f.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new C,this._listeners=[this._listeners,N]):this._listeners.push(N):(this._options?.onWillAddFirstListener?.(this),this._listeners=N,this._options?.onDidAddFirstListener?.(this)),this._size++;const W=(0,A.toDisposable)(()=>{F?.(),this._removeListener(N)});return L instanceof A.DisposableStore?L.add(W):Array.isArray(L)&&L.push(W),W},this._event}_removeListener(d){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const E=this._listeners,L=E.indexOf(d);if(L===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,E[L]=void 0;const N=this._deliveryQueue.current===this;if(this._size*l<=E.length){let F=0;for(let M=0;M<E.length;M++)E[M]?E[F++]=E[M]:N&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);E.length=F}}_deliver(d,E){if(!d)return;const L=this._options?.onListenerError||k.onUnexpectedError;if(!L){d.value(E);return}try{d.value(E)}catch(N){L(N)}}_deliverQueue(d){const E=d.current._listeners;for(;d.i<d.end;)this._deliver(E[d.i++],d.value);d.reset()}fire(d){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,d);else{const E=this._deliveryQueue;E.enqueue(this,d,this._listeners.length),this._deliverQueue(E)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=u;const m=()=>new C;e.createEventDeliveryQueue=m;class C{constructor(){this.i=-1,this.end=0}enqueue(d,E,L){this.i=0,this.end=L,this.current=d,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends u{async fireAsync(d,E,L){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList),h(this._listeners,N=>this._asyncDeliveryQueue.push([N.value,d]));this._asyncDeliveryQueue.size>0&&!E.isCancellationRequested;){const[N,F]=this._asyncDeliveryQueue.shift(),M=[],W={...F,token:E,waitUntil:Q=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");L&&(Q=L(Q,N)),M.push(Q)}};try{N(W)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(M),await Promise.allSettled(M).then(Q=>{for(const H of Q)H.status==="rejected"&&(0,k.onUnexpectedError)(H.reason)})}}}e.AsyncEmitter=s;class o extends u{get isPaused(){return this._isPaused!==0}constructor(d){super(d),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=d?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const d=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(d))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(d){this._size&&(this._isPaused!==0?this._eventQueue.push(d):super.fire(d))}}e.PauseableEmitter=o;class n extends o{constructor(d){super(d),this._delay=d.delay??100}fire(d){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(d)}}e.DebounceEmitter=n;class i extends u{constructor(d){super(d),this._queuedEvents=[],this._mergeFn=d?.merge}fire(d){this.hasListeners()&&(this._queuedEvents.push(d),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(E=>super.fire(E)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=i;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(d){const E={event:d,listener:null};this.events.push(E),this.hasListeners&&this.hook(E);const L=()=>{this.hasListeners&&this.unhook(E);const N=this.events.indexOf(E);this.events.splice(N,1)};return(0,A.toDisposable)((0,U.createSingleCallFunction)(L))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(d=>this.hook(d))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(d=>this.unhook(d))}hook(d){d.listener=d.event(E=>this.emitter.fire(E))}unhook(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class r{constructor(d,E,L,N){this._store=new A.DisposableStore;const F=this._store.add(new t),M=this._store.add(new A.DisposableMap);function W(Q){M.set(Q,F.add(N(Q)))}for(const Q of d)W(Q);this._store.add(E(Q=>{W(Q)})),this._store.add(L(Q=>{M.deleteAndDispose(Q)})),this.event=F.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(d){return(E,L,N)=>d(F=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>E.call(L,F)):E.call(L,F)},void 0,N)}bufferEvents(d){const E=[];this.buffers.push(E);const L=d();return this.buffers.pop(),E.forEach(N=>N()),L}}e.EventBufferer=a;class w{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=A.Disposable.None,this.emitter=new u({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(d){this.inputEvent=d,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=d(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(le[26],ue([0,1,3]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(R,I){const S=setTimeout(R.bind(I),0);return{dispose(){clearTimeout(S)}}});var A;(function(R){function I(S){return S===R.None||S===R.Cancelled||S instanceof T?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=I,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(A||(e.CancellationToken=A={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=_}),define(le[128],ue([0,1,26]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class U{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new k.CancellationTokenSource,I=this.task(R.token);return this.result={promise:I,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=U;class A{constructor(R){this.fn=R,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const I=JSON.stringify(R);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(R)),this.lastCache}}e.LRUCachedFunction=A;class T{get cachedValues(){return this._map}constructor(R){this.fn=R,this._map=new Map}get(R){if(this._map.has(R))return this._map.get(R);const I=this.fn(R);return this._map.set(R,I),I}}e.CachedFunction=T}),define(le[46],ue([0,1,7,2]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function A(m){const C=m;return C?typeof C.read=="function":!1}e.isReadable=A;function T(m){const C=m;return C?[C.on,C.pause,C.resume,C.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=T;function _(m){const C=m;return C?T(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=_;function R(m,C){return new I(m,C)}e.newWriteableStream=R;class I{constructor(C,s){this.reducer=C,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(s=>s(C))}emitError(C){this.listeners.error.length===0?(0,k.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(s=>s(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,s){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(C,s){if(this.state.destroyed)return;let o;switch(C){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(s);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(m,C){const s=[];let o;for(;(o=m.read())!==null;)s.push(o);return C(s)}e.consumeReadable=S;function D(m,C,s){const o=[];let n;for(;(n=m.read())!==null&&o.length<s;)o.push(n);return n===null&&o.length>0?C(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return m.read()}}}e.peekReadable=D;function b(m,C){return new Promise((s,o)=>{const n=[];g(m,{onData:i=>{C&&n.push(i)},onError:i=>{C?o(i):s(void 0)},onEnd:()=>{s(C?C(n):void 0)}})})}e.consumeStream=b;function g(m,C,s){m.on("error",o=>{s?.isCancellationRequested||C.onError(o)}),m.on("end",()=>{s?.isCancellationRequested||C.onEnd()}),m.on("data",o=>{s?.isCancellationRequested||C.onData(o)})}e.listenStream=g;function c(m,C){return new Promise((s,o)=>{const n=new U.DisposableStore,i=[],t=w=>{if(i.push(w),i.length>C)return n.dispose(),m.pause(),s({stream:m,buffer:i,ended:!1})},r=w=>(n.dispose(),o(w)),a=()=>(n.dispose(),s({stream:m,buffer:i,ended:!0}));n.add((0,U.toDisposable)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,U.toDisposable)(()=>m.removeListener("end",a))),m.on("end",a),n.add((0,U.toDisposable)(()=>m.removeListener("data",t))),m.on("data",t)})}e.peekStream=c;function f(m,C){const s=R(C);return s.end(m),s}e.toStream=f;function y(){const m=R(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=y;function v(m){let C=!1;return{read:()=>C?null:(C=!0,m)}}e.toReadable=v;function l(m,C,s){const o=R(s);return g(m,{onData:n=>o.write(C.data(n)),onError:n=>o.error(C.error?C.error(n):n),onEnd:()=>o.end()}),o}e.transform=l;function h(m,C,s){let o=!1;return{read:()=>{const n=C.read();return o?n:(o=!0,n!==null?s([m,n]):m)}}}e.prefixedReadable=h;function u(m,C,s){let o=!1;const n=R(s);return g(C,{onData:i=>o?n.write(i):(o=!0,n.write(s([m,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(m)),n.end()}}),n}e.prefixedStream=u}),define(le[15],ue([0,1,52,46]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const A=typeof Buffer<"u",T=new k.Lazy(()=>new Uint8Array(256));let _,R;class I{static alloc(E){return A?new I(Buffer.allocUnsafe(E)):new I(new Uint8Array(E))}static wrap(E){return A&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new I(E)}static fromString(E,L){return!(L?.dontUseNodeBuffer||!1)&&A?new I(Buffer.from(E)):(_||(_=new TextEncoder),new I(_.encode(E)))}static fromByteArray(E){const L=I.alloc(E.length);for(let N=0,F=E.length;N<F;N++)L.buffer[N]=E[N];return L}static concat(E,L){if(typeof L>"u"){L=0;for(let M=0,W=E.length;M<W;M++)L+=E[M].byteLength}const N=I.alloc(L);let F=0;for(let M=0,W=E.length;M<W;M++){const Q=E[M];N.set(Q,F),F+=Q.byteLength}return N}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=I.alloc(this.byteLength);return E.set(this),E}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(E,L){return new I(this.buffer.subarray(E,L))}set(E,L){if(E instanceof I)this.buffer.set(E.buffer,L);else if(E instanceof Uint8Array)this.buffer.set(E,L);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),L);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return g(this.buffer,E)}writeUInt32BE(E,L){c(this.buffer,E,L)}readUInt32LE(E){return f(this.buffer,E)}writeUInt32LE(E,L){y(this.buffer,E,L)}readUInt8(E){return v(this.buffer,E)}writeUInt8(E,L){l(this.buffer,E,L)}indexOf(E,L=0){return S(this.buffer,E instanceof I?E.buffer:E,L)}}e.VSBuffer=I;function S(d,E,L=0){const N=E.byteLength,F=d.byteLength;if(N===0)return 0;if(N===1)return d.indexOf(E[0]);if(N>F-L)return-1;const M=T.value;M.fill(E.length);for(let X=0;X<E.length;X++)M[E[X]]=E.length-X-1;let W=L+E.length-1,Q=W,H=-1;for(;W<F;)if(d[W]===E[Q]){if(Q===0){H=W;break}W--,Q--}else W+=Math.max(E.length-Q,M[d[W]]),Q=E.length-1;return H}e.binaryIndexOf=S;function D(d,E){return d[E+0]<<0>>>0|d[E+1]<<8>>>0}e.readUInt16LE=D;function b(d,E,L){d[L+0]=E&255,E=E>>>8,d[L+1]=E&255}e.writeUInt16LE=b;function g(d,E){return d[E]*2**24+d[E+1]*2**16+d[E+2]*2**8+d[E+3]}e.readUInt32BE=g;function c(d,E,L){d[L+3]=E,E=E>>>8,d[L+2]=E,E=E>>>8,d[L+1]=E,E=E>>>8,d[L]=E}e.writeUInt32BE=c;function f(d,E){return d[E+0]<<0>>>0|d[E+1]<<8>>>0|d[E+2]<<16>>>0|d[E+3]<<24>>>0}e.readUInt32LE=f;function y(d,E,L){d[L+0]=E&255,E=E>>>8,d[L+1]=E&255,E=E>>>8,d[L+2]=E&255,E=E>>>8,d[L+3]=E&255}e.writeUInt32LE=y;function v(d,E){return d[E]}e.readUInt8=v;function l(d,E,L){d[L]=E}e.writeUInt8=l;function h(d){return U.consumeReadable(d,E=>I.concat(E))}e.readableToBuffer=h;function u(d){return U.toReadable(d)}e.bufferToReadable=u;function m(d){return U.consumeStream(d,E=>I.concat(E))}e.streamToBuffer=m;async function C(d){return d.ended?I.concat(d.buffer):I.concat([...d.buffer,await m(d.stream)])}e.bufferedStreamToBuffer=C;function s(d){return U.toStream(d,E=>I.concat(E))}e.bufferToStream=s;function o(d){return U.transform(d,{data:E=>typeof E=="string"?I.fromString(E):I.wrap(E)},E=>I.concat(E))}e.streamToBufferReadableStream=o;function n(d){return U.newWriteableStream(E=>I.concat(E),d)}e.newWriteableBufferStream=n;function i(d,E){return U.prefixedReadable(d,E,L=>I.concat(L))}e.prefixedBufferReadable=i;function t(d,E){return U.prefixedStream(d,E,L=>I.concat(L))}e.prefixedBufferStream=t;function r(d){let E=0,L=0,N=0;const F=new Uint8Array(Math.floor(d.length/4*3)),M=Q=>{switch(L){case 3:F[N++]=E|Q,L=0;break;case 2:F[N++]=E|Q>>>2,E=Q<<6,L=3;break;case 1:F[N++]=E|Q>>>4,E=Q<<4,L=2;break;default:E=Q<<2,L=1}};for(let Q=0;Q<d.length;Q++){const H=d.charCodeAt(Q);if(H>=65&&H<=90)M(H-65);else if(H>=97&&H<=122)M(H-97+26);else if(H>=48&&H<=57)M(H-48+52);else if(H===43||H===45)M(62);else if(H===47||H===95)M(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${d[Q]}`)}}const W=N;for(;L>0;)M(0);return I.wrap(F).slice(0,W)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:d},E=!0,L=!1){const N=L?w:a;let F="";const M=d.byteLength%3;let W=0;for(;W<d.byteLength-M;W+=3){const Q=d[W+0],H=d[W+1],X=d[W+2];F+=N[Q>>>2],F+=N[(Q<<4|H>>>4)&63],F+=N[(H<<2|X>>>6)&63],F+=N[X&63]}if(M===1){const Q=d[W+0];F+=N[Q>>>2],F+=N[Q<<4&63],E&&(F+="==")}else if(M===2){const Q=d[W+0],H=d[W+1];F+=N[Q>>>2],F+=N[(Q<<4|H>>>4)&63],F+=N[H<<2&63],E&&(F+="=")}return F}e.encodeBase64=p}),define(le[27],ue([0,1,128,52]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function _(ae,...ge){return ge.length===0?ae:ae.replace(T,function(ve,Ee){const Ie=parseInt(Ee,10);return isNaN(Ie)||Ie<0||Ie>=ge.length?ve:ge[Ie]})}e.format=_;const R=/{([^}]+)}/g;function I(ae,ge){return Object.keys(ge).length===0?ae:ae.replace(R,(ve,Ee)=>ge[Ee]??ve)}e.format2=I;function S(ae){return ae.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=S;function D(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function b(ae,ge){let ve=0;const Ee=ge.charCodeAt(0);for(let Ie=ae.length-1;Ie>=0;Ie--)ae.charCodeAt(Ie)===Ee&&ve++;return ve}e.count=b;function g(ae,ge,ve="\u2026"){return ae.length<=ge?ae:`${ae.substr(0,ge)}${ve}`}e.truncate=g;function c(ae,ge,ve="\u2026"){if(ae.length<=ge)return ae;const Ee=Math.ceil(ge/2)-ve.length/2,Ie=Math.floor(ge/2)-ve.length/2;return`${ae.substr(0,Ee)}${ve}${ae.substr(ae.length-Ie)}`}e.truncateMiddle=c;function f(ae,ge=" "){const ve=y(ae,ge);return v(ve,ge)}e.trim=f;function y(ae,ge){if(!ae||!ge)return ae;const ve=ge.length;if(ve===0||ae.length===0)return ae;let Ee=0;for(;ae.indexOf(ge,Ee)===Ee;)Ee=Ee+ve;return ae.substring(Ee)}e.ltrim=y;function v(ae,ge){if(!ae||!ge)return ae;const ve=ge.length,Ee=ae.length;if(ve===0||Ee===0)return ae;let Ie=Ee,be=-1;for(;be=ae.lastIndexOf(ge,Ie-1),!(be===-1||be+ve!==Ie);){if(be===0)return"";Ie=be}return ae.substring(0,Ie)}e.rtrim=v;function l(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function h(ae){return ae.replace(/\*/g,"")}e.stripWildcards=h;function u(ae,ge,ve={}){if(!ae)throw new Error("Cannot create regex from empty string");ge||(ae=D(ae)),ve.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let Ee="";return ve.global&&(Ee+="g"),ve.matchCase||(Ee+="i"),ve.multiline&&(Ee+="m"),ve.unicode&&(Ee+="u"),new RegExp(ae,Ee)}e.createRegExp=u;function m(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function C(ae){return ae.split(/\r\n|\r|\n/)}e.splitLines=C;function s(ae){for(let ge=0,ve=ae.length;ge<ve;ge++){const Ee=ae.charCodeAt(ge);if(Ee!==32&&Ee!==9)return ge}return-1}e.firstNonWhitespaceIndex=s;function o(ae,ge=0,ve=ae.length){for(let Ee=ge;Ee<ve;Ee++){const Ie=ae.charCodeAt(Ee);if(Ie!==32&&Ie!==9)return ae.substring(ge,Ee)}return ae.substring(ge,ve)}e.getLeadingWhitespace=o;function n(ae,ge=ae.length-1){for(let ve=ge;ve>=0;ve--){const Ee=ae.charCodeAt(ve);if(Ee!==32&&Ee!==9)return ve}return-1}e.lastNonWhitespaceIndex=n;function i(ae,ge,ve){const Ee=[];let Ie=0;for(const be of ae.matchAll(ge)){if(Ee.push(ae.slice(Ie,be.index)),be.index===void 0)throw new Error("match.index should be defined");Ie=be.index+be[0].length,Ee.push(ve(be[0],...be.slice(1),be.index,ae,be.groups))}return Ee.push(ae.slice(Ie)),Promise.all(Ee).then(be=>be.join(""))}e.replaceAsync=i;function t(ae,ge){return ae<ge?-1:ae>ge?1:0}e.compare=t;function r(ae,ge,ve=0,Ee=ae.length,Ie=0,be=ge.length){for(;ve<Ee&&Ie<be;ve++,Ie++){const Oe=ae.charCodeAt(ve),Ne=ge.charCodeAt(Ie);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const De=Ee-ve,_e=be-Ie;return De<_e?-1:De>_e?1:0}e.compareSubstring=r;function a(ae,ge){return w(ae,ge,0,ae.length,0,ge.length)}e.compareIgnoreCase=a;function w(ae,ge,ve=0,Ee=ae.length,Ie=0,be=ge.length){for(;ve<Ee&&Ie<be;ve++,Ie++){let Oe=ae.charCodeAt(ve),Ne=ge.charCodeAt(Ie);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return r(ae.toLowerCase(),ge.toLowerCase(),ve,Ee,Ie,be);d(Oe)&&(Oe-=32),d(Ne)&&(Ne-=32);const We=Oe-Ne;if(We!==0)return We}const De=Ee-ve,_e=be-Ie;return De<_e?-1:De>_e?1:0}e.compareSubstringIgnoreCase=w;function p(ae){return ae>=48&&ae<=57}e.isAsciiDigit=p;function d(ae){return ae>=97&&ae<=122}e.isLowerAsciiLetter=d;function E(ae){return ae>=65&&ae<=90}e.isUpperAsciiLetter=E;function L(ae,ge){return ae.length===ge.length&&w(ae,ge)===0}e.equalsIgnoreCase=L;function N(ae,ge){const ve=ge.length;return ge.length>ae.length?!1:w(ae,ge,0,ve)===0}e.startsWithIgnoreCase=N;function F(ae,ge){const ve=Math.min(ae.length,ge.length);let Ee;for(Ee=0;Ee<ve;Ee++)if(ae.charCodeAt(Ee)!==ge.charCodeAt(Ee))return Ee;return ve}e.commonPrefixLength=F;function M(ae,ge){const ve=Math.min(ae.length,ge.length);let Ee;const Ie=ae.length-1,be=ge.length-1;for(Ee=0;Ee<ve;Ee++)if(ae.charCodeAt(Ie-Ee)!==ge.charCodeAt(be-Ee))return Ee;return ve}e.commonSuffixLength=M;function W(ae){return 55296<=ae&&ae<=56319}e.isHighSurrogate=W;function Q(ae){return 56320<=ae&&ae<=57343}e.isLowSurrogate=Q;function H(ae,ge){return(ae-55296<<10)+(ge-56320)+65536}e.computeCodePoint=H;function X(ae,ge,ve){const Ee=ae.charCodeAt(ve);if(W(Ee)&&ve+1<ge){const Ie=ae.charCodeAt(ve+1);if(Q(Ie))return H(Ee,Ie)}return Ee}e.getNextCodePoint=X;function z(ae,ge){const ve=ae.charCodeAt(ge-1);if(Q(ve)&&ge>1){const Ee=ae.charCodeAt(ge-2);if(W(Ee))return H(Ee,ve)}return ve}class Y{get offset(){return this._offset}constructor(ge,ve=0){this._str=ge,this._len=ge.length,this._offset=ve}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=z(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=X(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class x{get offset(){return this._iterator.offset}constructor(ge,ve=0){this._iterator=new Y(ge,ve)}nextGraphemeLength(){const ge=Se.getInstance(),ve=this._iterator,Ee=ve.offset;let Ie=ge.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const be=ve.offset,De=ge.getGraphemeBreakType(ve.nextCodePoint());if(he(Ie,De)){ve.setOffset(be);break}Ie=De}return ve.offset-Ee}prevGraphemeLength(){const ge=Se.getInstance(),ve=this._iterator,Ee=ve.offset;let Ie=ge.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const be=ve.offset,De=ge.getGraphemeBreakType(ve.prevCodePoint());if(he(De,Ie)){ve.setOffset(be);break}Ie=De}return Ee-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function q(ae,ge){return new x(ae,ge).nextGraphemeLength()}e.nextCharLength=q;function te(ae,ge){return new x(ae,ge).prevGraphemeLength()}e.prevCharLength=te;function se(ae,ge){ge>0&&Q(ae.charCodeAt(ge))&&ge--;const ve=ge+q(ae,ge);return[ve-te(ae,ve),ve]}e.getCharContainingOffset=se;function Z(ae){const ge=new x(ae);let ve=0;for(;!ge.eol();)ve++,ge.nextGraphemeLength();return ve}e.charCount=Z;let re;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(ae){return re||(re=G()),re.test(ae)}e.containsRTL=$;const P=/^[\t\n\r\x20-\x7E]*$/;function O(ae){return P.test(ae)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(ae){return e.UNUSUAL_LINE_TERMINATORS.test(ae)}e.containsUnusualLineTerminators=B;function j(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.isFullWidthCharacter=j;function ee(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.isEmojiImprecise=ee;function V(ae,ge){if(ae.length<ge)return ae;const ve=/\b/g;let Ee=0;for(;ve.test(ae)&&!(ae.length-ve.lastIndex<ge);)Ee=ve.lastIndex,ve.lastIndex+=1;return ae.substring(Ee).replace(/^\s/,"")}e.lcut=V;const K=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function ce(ae){return ae&&(ae=ae.replace(K,"").replace(ie,"")),ae}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function de(ae){return oe(ae)?ae.substr(1):ae}e.stripUTF8BOM=de;function fe(ae,ge){if(!ae||!ge||ae.length<ge.length)return!1;const ve=ge.length,Ee=ae.toLowerCase();let Ie=0,be=-1;for(;Ie<ve;){const De=Ee.indexOf(ge[Ie],be+1);if(De<0)return!1;be=De,Ie++}return!0}e.fuzzyContains=fe;function pe(ae,ge=!1){return ae?(ge&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.containsUppercaseCharacter=pe;function we(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.uppercaseFirstLetter=we;function Le(ae,ge=1){if(ge===0)return"";let ve=-1;do ve=ae.indexOf(`
`,ve+1),ge--;while(ge>0&&ve>=0);return ve===-1?ae:(ae[ve-1]==="\r"&&ve--,ae.substr(0,ve))}e.getNLines=Le;function ke(ae){return ae=ae%(2*26),ae<26?String.fromCharCode(97+ae):String.fromCharCode(65+ae-26)}e.singleLetterHash=ke;function Fe(ae){return Se.getInstance().getGraphemeBreakType(ae)}e.getGraphemeBreakType=Fe;function he(ae,ge){return ae===0?ge!==5&&ge!==7:ae===2&&ge===3?!1:ae===4||ae===2||ae===3||ge===4||ge===2||ge===3?!0:!(ae===8&&(ge===8||ge===9||ge===11||ge===12)||(ae===11||ae===9)&&(ge===9||ge===10)||(ae===12||ae===10)&&ge===10||ge===5||ge===13||ge===7||ae===1||ae===13&&ge===14||ae===6&&ge===6)}var me;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(me||(e.GraphemeBreakType=me={}));class Se{static{this._INSTANCE=null}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}constructor(){this._data=Pe()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const ve=this._data,Ee=ve.length/3;let Ie=1;for(;Ie<=Ee;)if(ge<ve[3*Ie])Ie=2*Ie;else if(ge>ve[3*Ie+1])Ie=2*Ie+1;else return ve[3*Ie+2];return 0}}function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(ae,ge){if(ae===0)return 0;const ve=Me(ae,ge);if(ve!==void 0)return ve;const Ee=new Y(ge,ae);return Ee.prevCodePoint(),Ee.offset}e.getLeftDeleteOffset=Re;function Me(ae,ge){const ve=new Y(ge,ae);let Ee=ve.prevCodePoint();for(;Te(Ee)||Ee===65039||Ee===8419;){if(ve.offset===0)return;Ee=ve.prevCodePoint()}if(!ee(Ee))return;let Ie=ve.offset;return Ie>0&&ve.prevCodePoint()===8205&&(Ie=ve.offset),Ie}function Te(ae){return 127995<=ae&&ae<=127999}var je;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class Ue{static{this.ambiguousCharacterData=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new k.LRUCachedFunction(ge=>{function ve(We){const ze=new Map;for(let qe=0;qe<We.length;qe+=2)ze.set(We[qe],We[qe+1]);return ze}function Ee(We,ze){const qe=new Map(We);for(const[Xe,Ze]of ze)qe.set(Xe,Ze);return qe}function Ie(We,ze){if(!We)return ze;const qe=new Map;for(const[Xe,Ze]of We)ze.has(Xe)&&qe.set(Xe,Ze);return qe}const be=this.ambiguousCharacterData.value;let De=ge.filter(We=>!We.startsWith("_")&&We in be);De.length===0&&(De=["_default"]);let _e;for(const We of De){const ze=ve(be[We]);_e=Ie(_e,ze)}const Oe=ve(be._common),Ne=Ee(Oe,_e);return new Ue(Ne)})}static getInstance(ge){return Ue.cache.get(Array.from(ge))}static{this._locales=new U.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ue._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue;class $e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set($e.getRawData())),this._data}static isInvisibleCharacter(ge){return $e.getData().has(ge)}static get codePoints(){return $e.getData()}}e.InvisibleCharacters=$e}),define(le[53],ue([0,1,27]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function U(l){return A(l,0)}e.hash=U;function A(l,h){switch(typeof l){case"object":return l===null?T(349,h):Array.isArray(l)?I(l,h):S(l,h);case"string":return R(l,h);case"boolean":return _(l,h);case"number":return T(l,h);case"undefined":return T(937,h);default:return T(617,h)}}e.doHash=A;function T(l,h){return(h<<5)-h+l|0}e.numberHash=T;function _(l,h){return T(l?433:863,h)}function R(l,h){h=T(149417,h);for(let u=0,m=l.length;u<m;u++)h=T(l.charCodeAt(u),h);return h}e.stringHash=R;function I(l,h){return h=T(104579,h),l.reduce((u,m)=>A(m,u),h)}function S(l,h){return h=T(181387,h),Object.keys(l).sort().reduce((u,m)=>(u=R(m,u),A(l[m],u)),h)}class D{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=A(h,this._value),this._value}}e.Hasher=D;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function g(l,h,u=32){const m=u-h,C=~((1<<m)-1);return(l<<h|(C&l)>>>m)>>>0}function c(l,h=0,u=l.byteLength,m=0){for(let C=0;C<u;C++)l[h+C]=m}function f(l,h,u="0"){for(;l.length<h;)l=u+l;return l}function y(l,h=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(u=>u.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),h/4)}e.toHexString=y;class v{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const u=h.length;if(u===0)return;const m=this._buff;let C=this._buffLen,s=this._leftoverHighSurrogate,o,n;for(s!==0?(o=s,n=-1,s=0):(o=h.charCodeAt(0),n=0);;){let i=o;if(k.isHighSurrogate(o))if(n+1<u){const t=h.charCodeAt(n+1);k.isLowSurrogate(t)?(n++,i=k.computeCodePoint(o,t)):i=65533}else{s=o;break}else k.isLowSurrogate(o)&&(i=65533);if(C=this._push(m,C,i),n++,n<u)o=h.charCodeAt(n);else break}this._buffLen=C,this._leftoverHighSurrogate=s}_push(h,u,m){return m<128?h[u++]=m:m<2048?(h[u++]=192|(m&1984)>>>6,h[u++]=128|(m&63)>>>0):m<65536?(h[u++]=224|(m&61440)>>>12,h[u++]=128|(m&4032)>>>6,h[u++]=128|(m&63)>>>0):(h[u++]=240|(m&1835008)>>>18,h[u++]=128|(m&258048)>>>12,h[u++]=128|(m&4032)>>>6,h[u++]=128|(m&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=v._bigBlock32,u=this._buffDV;for(let a=0;a<64;a+=4)h.setUint32(a,u.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)h.setUint32(a,g(h.getUint32(a-12,!1)^h.getUint32(a-32,!1)^h.getUint32(a-56,!1)^h.getUint32(a-64,!1),1),!1);let m=this._h0,C=this._h1,s=this._h2,o=this._h3,n=this._h4,i,t,r;for(let a=0;a<80;a++)a<20?(i=C&s|~C&o,t=1518500249):a<40?(i=C^s^o,t=1859775393):a<60?(i=C&s|C&o|s&o,t=2400959708):(i=C^s^o,t=3395469782),r=g(m,5)+i+n+t+h.getUint32(a*4,!1)&4294967295,n=o,o=s,s=g(C,30),C=m,m=r;this._h0=this._h0+m&4294967295,this._h1=this._h1+C&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v}),define(le[89],ue([0,1,27]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(U||(U={})),function(A){const T="error",_="warning",R="warn",I="info",S="ignore";function D(g){return g?k.equalsIgnoreCase(T,g)?A.Error:k.equalsIgnoreCase(_,g)||k.equalsIgnoreCase(R,g)?A.Warning:k.equalsIgnoreCase(I,g)?A.Info:A.Ignore:A.Ignore}A.fromValue=D;function b(g){switch(g){case A.Error:return T;case A.Warning:return _;case A.Info:return I;default:return S}}A.toString=b}(U||(U={})),e.default=U}),define(le[129],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[47],ue([0,1,18,27]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this._value="",this._pos=0}reset(c){return this._value=c,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(c){const f=c.charCodeAt(0),y=this._value.charCodeAt(this._pos);return f-y}value(){return this._value[this._pos]}}e.StringIterator=A;class T{constructor(c=!0){this._caseSensitive=c}reset(c){return this._value=c,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let c=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(c)this._from++;else break;else c=!1;return this}cmp(c){return this._caseSensitive?(0,U.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class _{constructor(c=!0,f=!0){this._splitOnBackslash=c,this._caseSensitive=f}reset(c){this._from=0,this._to=0,this._value=c,this._valueLen=c.length;for(let f=c.length-1;f>=0;f--,this._valueLen--){const y=this._value.charCodeAt(f);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let c=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(c)this._from++;else break;else c=!1}return this}cmp(c){return this._caseSensitive?(0,U.compareSubstring)(c,this._value,0,c.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(c,this._value,0,c.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var R;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(R||(R={}));class I{constructor(c,f){this._ignorePathCasing=c,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(c){return this._value=c,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(c)),this._pathIterator.reset(c.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(c)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(c){if(this._states[this._stateIdx]===1)return(0,U.compareIgnoreCase)(c,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,U.compareIgnoreCase)(c,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(c);if(this._states[this._stateIdx]===4)return(0,U.compare)(c,this._value.query);if(this._states[this._stateIdx]===5)return(0,U.compare)(c,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(D||(D={}));class b{static forUris(c=()=>!1,f=()=>!1){return new b(new I(c,f))}static forPaths(c=!1){return new b(new _(void 0,!c))}static forStrings(){return new b(new A)}static forConfigKeys(){return new b(new T)}constructor(c){this._iter=c}clear(){this._root=void 0}fill(c,f){if(f){const y=f.slice(0);(0,k.shuffle)(y);for(const v of y)this.set(v,c)}else{const y=c.slice(0);(0,k.shuffle)(y);for(const v of y)this.set(v[0],v[1])}}set(c,f){const y=this._iter.reset(c);let v;this._root||(this._root=new S,this._root.segment=y.value());const l=[];for(v=this._root;;){const u=y.cmp(v.segment);if(u>0)v.left||(v.left=new S,v.left.segment=y.value()),l.push([-1,v]),v=v.left;else if(u<0)v.right||(v.right=new S,v.right.segment=y.value()),l.push([1,v]),v=v.right;else if(y.hasNext())y.next(),v.mid||(v.mid=new S,v.mid.segment=y.value()),l.push([0,v]),v=v.mid;else break}const h=v.value;v.value=f,v.key=c;for(let u=l.length-1;u>=0;u--){const m=l[u][1];m.updateHeight();const C=m.balanceFactor();if(C<-1||C>1){const s=l[u][0],o=l[u+1][0];if(s===1&&o===1)l[u][1]=m.rotateLeft();else if(s===-1&&o===-1)l[u][1]=m.rotateRight();else if(s===1&&o===-1)m.right=l[u+1][1]=l[u+1][1].rotateRight(),l[u][1]=m.rotateLeft();else if(s===-1&&o===1)m.left=l[u+1][1]=l[u+1][1].rotateLeft(),l[u][1]=m.rotateRight();else throw new Error;if(u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this._root=l[0][1]}}return h}get(c){return this._getNode(c)?.value}_getNode(c){const f=this._iter.reset(c);let y=this._root;for(;y;){const v=f.cmp(y.segment);if(v>0)y=y.left;else if(v<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has(c){const f=this._getNode(c);return!(f?.value===void 0&&f?.mid===void 0)}delete(c){return this._delete(c,!1)}deleteSuperstr(c){return this._delete(c,!0)}_delete(c,f){const y=this._iter.reset(c),v=[];let l=this._root;for(;l;){const h=y.cmp(l.segment);if(h>0)v.push([-1,l]),l=l.left;else if(h<0)v.push([1,l]),l=l.right;else if(y.hasNext())y.next(),v.push([0,l]),l=l.mid;else break}if(l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const h=this._min(l.right);if(h.key){const{key:u,value:m,segment:C}=h;this._delete(h.key,!1),l.key=u,l.value=m,l.segment=C}}else{const h=l.left??l.right;if(v.length>0){const[u,m]=v[v.length-1];switch(u){case-1:m.left=h;break;case 0:m.mid=h;break;case 1:m.right=h;break}}else this._root=h}for(let h=v.length-1;h>=0;h--){const u=v[h][1];u.updateHeight();const m=u.balanceFactor();if(m>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),v[h][1]=u.rotateLeft()):m<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),v[h][1]=u.rotateRight()),h>0)switch(v[h-1][0]){case-1:v[h-1][1].left=v[h][1];break;case 1:v[h-1][1].right=v[h][1];break;case 0:v[h-1][1].mid=v[h][1];break}else this._root=v[0][1]}}}_min(c){for(;c.left;)c=c.left;return c}findSubstr(c){const f=this._iter.reset(c);let y=this._root,v;for(;y;){const l=f.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(f.hasNext())f.next(),v=y.value||v,y=y.mid;else break}return y&&y.value||v}findSuperstr(c){return this._findSuperstrOrElement(c,!1)}_findSuperstrOrElement(c,f){const y=this._iter.reset(c);let v=this._root;for(;v;){const l=y.cmp(v.segment);if(l>0)v=v.left;else if(l<0)v=v.right;else if(y.hasNext())y.next(),v=v.mid;else return v.mid?this._entries(v.mid):f?v.value:void 0}}hasElementOrSubtree(c){return this._findSuperstrOrElement(c,!0)!==void 0}forEach(c){for(const[f,y]of this)c(y,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(c){const f=[];return this._dfsEntries(c,f),f[Symbol.iterator]()}_dfsEntries(c,f){c&&(c.left&&this._dfsEntries(c.left,f),c.value&&f.push([c.key,c.value]),c.mid&&this._dfsEntries(c.mid,f),c.right&&this._dfsEntries(c.right,f))}_isBalanced(){const c=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:c(f.left)&&c(f.right)};return c(this._root)}}e.TernarySearchTree=b}),define(le[12],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(C){return typeof C=="string"}e.isString=k;function U(C){return Array.isArray(C)&&C.every(s=>k(s))}e.isStringArray=U;function A(C){return typeof C=="object"&&C!==null&&!Array.isArray(C)&&!(C instanceof RegExp)&&!(C instanceof Date)}e.isObject=A;function T(C){const s=Object.getPrototypeOf(Uint8Array);return typeof C=="object"&&C instanceof s}e.isTypedArray=T;function _(C){return typeof C=="number"&&!isNaN(C)}e.isNumber=_;function R(C){return!!C&&typeof C[Symbol.iterator]=="function"}e.isIterable=R;function I(C){return C===!0||C===!1}e.isBoolean=I;function S(C){return typeof C>"u"}e.isUndefined=S;function D(C){return!b(C)}e.isDefined=D;function b(C){return S(C)||C===null}e.isUndefinedOrNull=b;function g(C,s){if(!C)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=g;function c(C){if(b(C))throw new Error("Assertion Failed: argument is undefined or null");return C}e.assertIsDefined=c;function f(...C){const s=[];for(let o=0;o<C.length;o++){const n=C[o];if(b(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);s.push(n)}return s}e.assertAllDefined=f;const y=Object.prototype.hasOwnProperty;function v(C){if(!A(C))return!1;for(const s in C)if(y.call(C,s))return!1;return!0}e.isEmptyObject=v;function l(C){return typeof C=="function"}e.isFunction=l;function h(...C){return C.length>0&&C.every(l)}e.areFunctions=h;function u(C,s){const o=Math.min(C.length,s.length);for(let n=0;n<o;n++)m(C[n],s[n])}e.validateConstraints=u;function m(C,s){if(k(s)){if(typeof C!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(l(s)){try{if(C instanceof s)return}catch{}if(!b(C)&&C.constructor===s||s.length===1&&s.call(void 0,C)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m}),define(le[30],ue([0,1,12]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function U(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const h=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([u,m])=>{h[u]=m&&typeof m=="object"?U(m):m}),h}e.deepClone=U;function A(l){if(!l||typeof l!="object")return l;const h=[l];for(;h.length>0;){const u=h.shift();Object.freeze(u);for(const m in u)if(T.call(u,m)){const C=u[m];typeof C=="object"&&!Object.isFrozen(C)&&!(0,k.isTypedArray)(C)&&h.push(C)}}return l}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function _(l,h){return R(l,h,new Set)}e.cloneAndChange=_;function R(l,h,u){if((0,k.isUndefinedOrNull)(l))return l;const m=h(l);if(typeof m<"u")return m;if(Array.isArray(l)){const C=[];for(const s of l)C.push(R(s,h,u));return C}if((0,k.isObject)(l)){if(u.has(l))throw new Error("Cannot clone recursive data-structure");u.add(l);const C={};for(const s in l)T.call(l,s)&&(C[s]=R(l[s],h,u));return u.delete(l),C}return l}function I(l,h,u=!0){return(0,k.isObject)(l)?((0,k.isObject)(h)&&Object.keys(h).forEach(m=>{m in l?u&&((0,k.isObject)(l[m])&&(0,k.isObject)(h[m])?I(l[m],h[m],u):l[m]=h[m]):l[m]=h[m]}),l):h}e.mixin=I;function S(l,h){if(l===h)return!0;if(l==null||h===null||h===void 0||typeof l!=typeof h||typeof l!="object"||Array.isArray(l)!==Array.isArray(h))return!1;let u,m;if(Array.isArray(l)){if(l.length!==h.length)return!1;for(u=0;u<l.length;u++)if(!S(l[u],h[u]))return!1}else{const C=[];for(m in l)C.push(m);C.sort();const s=[];for(m in h)s.push(m);if(s.sort(),!S(C,s))return!1;for(u=0;u<C.length;u++)if(!S(l[C[u]],h[C[u]]))return!1}return!0}e.equals=S;function D(l){const h=new Set;return JSON.stringify(l,(u,m)=>{if((0,k.isObject)(m)||Array.isArray(m)){if(h.has(m))return"[Circular]";h.add(m)}return m})}e.safeStringify=D;function b(l,h){const u=Object.create(null);return!l||!h||Object.keys(h).forEach(C=>{const s=l[C],o=h[C];S(s,o)||(u[C]=o)}),u}e.distinct=b;function g(l,h){const u=h.toLowerCase(),m=Object.keys(l).find(C=>C.toLowerCase()===u);return m?l[m]:l[h]}e.getCaseInsensitive=g;function c(l,h){const u=Object.create(null);for(const[m,C]of Object.entries(l))h(m,C)&&(u[m]=C);return u}e.filter=c;function f(l){let h=[];for(;Object.prototype!==l;)h=h.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return h}e.getAllPropertyNames=f;function y(l){const h=[];for(const u of f(l))typeof l[u]=="function"&&h.push(u);return h}e.getAllMethodNames=y;function v(l,h){const u=C=>function(){const s=Array.prototype.slice.call(arguments,0);return h(C,s)},m={};for(const C of l)m[C]=u(C);return m}e.createProxyObject=v}),define(le[32],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(A){return k.test(A)}e.isUUID=U,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let I=0;I<R.length;I++)R[I]=Math.floor(Math.random()*256);return R};const T=new Uint8Array(16),_=[];for(let R=0;R<256;R++)_.push(R.toString(16).padStart(2,"0"));return function(){A(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let I=0,S="";return S+=_[T[I++]],S+=_[T[I++]],S+=_[T[I++]],S+=_[T[I++]],S+="-",S+=_[T[I++]],S+=_[T[I++]],S+="-",S+=_[T[I++]],S+=_[T[I++]],S+="-",S+=_[T[I++]],S+=_[T[I++]],S+="-",S+=_[T[I++]],S+=_[T[I++]],S+=_[T[I++]],S+=_[T[I++]],S+=_[T[I++]],S+=_[T[I++]],S}}()}),define(le[130],ue([0,1,36]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(_){const R=_.replace(/\-/g,":").toLowerCase();return!U.has(R)}function T(){const _=(0,k.networkInterfaces)();for(const R in _){const I=_[R];if(I){for(const{mac:S}of I)if(A(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(le[131],ue([0,1,267,15]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class A extends k.Transform{constructor(_){if(super(),typeof _=="number")this.splitter=_,this.spitterLen=1;else{const R=Buffer.isBuffer(_)?_:Buffer.from(_);this.splitter=R.length===1?R[0]:R,this.spitterLen=R.length}}_transform(_,R,I){this.buffer?this.buffer=Buffer.concat([this.buffer,_]):this.buffer=_;let S=0;for(;S<this.buffer.length;){const D=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,S):(0,U.binaryIndexOf)(this.buffer,this.splitter,S);if(D===-1)break;this.push(this.buffer.slice(S,D+this.spitterLen)),S=D+this.spitterLen}this.buffer=S===this.buffer.length?void 0:this.buffer.slice(S),I()}_flush(_){this.buffer&&this.push(this.buffer),_()}}e.StreamSplitter=A}),define(le[132],ue([0,1,63]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function U(R,I,S,D=1){let b=!1;return new Promise(g=>{const c=setTimeout(()=>{if(!b)return b=!0,g(0)},S);A(R,I,D,f=>{if(!b)return b=!0,clearTimeout(c),g(f)})})}e.findFreePort=U;function A(R,I,S,D){if(I===0)return D(0);const b=new k.Socket;b.once("connect",()=>(_(b),A(R+S,I-1,S,D))),b.once("data",()=>{}),b.once("error",g=>(_(b),g.code!=="ECONNREFUSED"?A(R+S,I-1,S,D):D(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,I,S,D="127.0.0.1"){let b=!1,g,c=1;const f=k.createServer({pauseOnConnect:!0});function y(v,l){b||(b=!0,f.removeAllListeners(),f.close(),g&&clearTimeout(g),l(v))}return new Promise(v=>{g=setTimeout(()=>{y(0,v)},S),f.on("listening",()=>{y(R,v)}),f.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&c<I?(R++,c++,f.listen(R,D)):y(0,v)}),f.on("close",()=>{y(0,v)}),f.listen(R,D)})}e.findFreePortFaster=T;function _(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(I){console.error(I)}}}),define(le[133],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function k(U){return!!U.parentPort}e.isUtilityProcess=k}),define(le[134],ue([13,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[64],ue([0,1,134]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const U=60,A=U*60,T=A*24,_=T*7,R=T*30,I=T*365;function S(b,g,c,f){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,k.localize)(0,null,S(new Date().getTime()+y*1e3,!1));if(!f&&y<30)return(0,k.localize)(1,null);let v;return y<U?(v=y,g?v===1?c?(0,k.localize)(2,null,v):(0,k.localize)(3,null,v):c?(0,k.localize)(4,null,v):(0,k.localize)(5,null,v):v===1?c?(0,k.localize)(6,null,v):(0,k.localize)(7,null,v):c?(0,k.localize)(8,null,v):(0,k.localize)(9,null,v)):y<A?(v=Math.floor(y/U),g?v===1?c?(0,k.localize)(10,null,v):(0,k.localize)(11,null,v):c?(0,k.localize)(12,null,v):(0,k.localize)(13,null,v):v===1?c?(0,k.localize)(14,null,v):(0,k.localize)(15,null,v):c?(0,k.localize)(16,null,v):(0,k.localize)(17,null,v)):y<T?(v=Math.floor(y/A),g?v===1?c?(0,k.localize)(18,null,v):(0,k.localize)(19,null,v):c?(0,k.localize)(20,null,v):(0,k.localize)(21,null,v):v===1?c?(0,k.localize)(22,null,v):(0,k.localize)(23,null,v):c?(0,k.localize)(24,null,v):(0,k.localize)(25,null,v)):y<_?(v=Math.floor(y/T),g?v===1?(0,k.localize)(26,null,v):(0,k.localize)(27,null,v):v===1?(0,k.localize)(28,null,v):(0,k.localize)(29,null,v)):y<R?(v=Math.floor(y/_),g?v===1?c?(0,k.localize)(30,null,v):(0,k.localize)(31,null,v):c?(0,k.localize)(32,null,v):(0,k.localize)(33,null,v):v===1?c?(0,k.localize)(34,null,v):(0,k.localize)(35,null,v):c?(0,k.localize)(36,null,v):(0,k.localize)(37,null,v)):y<I?(v=Math.floor(y/R),g?v===1?c?(0,k.localize)(38,null,v):(0,k.localize)(39,null,v):c?(0,k.localize)(40,null,v):(0,k.localize)(41,null,v):v===1?c?(0,k.localize)(42,null,v):(0,k.localize)(43,null,v):c?(0,k.localize)(44,null,v):(0,k.localize)(45,null,v)):(v=Math.floor(y/I),g?v===1?c?(0,k.localize)(46,null,v):(0,k.localize)(47,null,v):c?(0,k.localize)(48,null,v):(0,k.localize)(49,null,v):v===1?c?(0,k.localize)(50,null,v):(0,k.localize)(51,null,v):c?(0,k.localize)(52,null,v):(0,k.localize)(53,null,v))}e.fromNow=S;function D(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(le[135],ue([13,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[38],ue([0,1,18,12,135]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(b,g){return g&&(b.stack||b.stacktrace)?A.localize(0,null,R(b),_(b.stack)||_(b.stacktrace)):R(b)}function _(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?A.localize(1,null,b.message):b.message||A.localize(2,null)}function I(b=null,g=!1){if(!b)return A.localize(3,null);if(Array.isArray(b)){const c=k.coalesce(b),f=I(c[0],g);return c.length>1?A.localize(4,null,f,c.length):f}if(U.isString(b))return b;if(b.detail){const c=b.detail;if(c.error)return T(c.error,g);if(c.exception)return T(c.exception,g)}return b.stack?T(b,g):b.message?b.message:A.localize(5,null)}e.toErrorMessage=I;function S(b){const g=b;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=S;function D(b,g){let c;return typeof b=="string"?c=new Error(b):c=b,c.actions=g,c}e.createErrorWithActions=D}),define(le[136],ue([13,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[137],ue([0,1,136]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function U(A){switch(A){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=U}),define(le[138],ue([13,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],ue([0,1,138]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let U=!1,A=!1,T=!1,_=!1,R=!1,I=!1,S=!1,D=!1,b=!1,g=!1,c,f=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,v,l;const h=globalThis;let u;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?u=h.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",C=m&&u?.type==="renderer";if(typeof navigator=="object"&&!C)l=navigator.userAgent,U=l.indexOf("Windows")>=0,A=l.indexOf("Macintosh")>=0,D=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=l.indexOf("Linux")>=0,g=l?.indexOf("Mobi")>=0,I=!0,c=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,f=c,y=navigator.language;else if(typeof u=="object"){U=u.platform==="win32",A=u.platform==="darwin",T=u.platform==="linux",_=T&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=m,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const d=u.env.VSCODE_NLS_CONFIG;if(d)try{const E=JSON.parse(d),L=E.availableLanguages["*"];c=E.locale,y=E.osLocale,f=L||e.LANGUAGE_DEFAULT,v=E._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var s;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(s||(e.Platform=s={}));function o(d){switch(d){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let n=0;A?n=1:U?n=3:T&&(n=2),e.isWindows=U,e.isMacintosh=A,e.isLinux=T,e.isLinuxSnap=_,e.isNative=R,e.isElectron=S,e.isWeb=I,e.isWebWorker=I&&typeof h.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?h.origin:void 0,e.isIOS=D,e.isMobile=g,e.isCI=b,e.platform=n,e.userAgent=l,e.language=f;var i;(function(d){function E(){return e.language}d.value=E;function L(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}d.isDefaultVariant=L;function N(){return e.language==="en"}d.isDefault=N})(i||(e.Language=i={})),e.locale=c,e.platformLocale=y,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof h.postMessage=="function"&&!h.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const d=[];h.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let N=0,F=d.length;N<F;N++){const M=d[N];if(M.id===L.data.vscodeScheduleAsyncWork){d.splice(N,1),M.callback();return}}});let E=0;return L=>{const N=++E;d.push({id:N,callback:L}),h.postMessage({vscodeScheduleAsyncWork:N},"*")}}return d=>setTimeout(d)})();var t;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=A||D?2:U?1:3;let r=!0,a=!1;function w(){if(!a){a=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,r=new Uint16Array(d.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=w,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function p(d){return parseFloat(d)>=20}e.isBigSurOrNewer=p}),define(le[37],ue([0,1,5]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const T=A.process;U={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(le[16],ue([0,1,37]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,A=97,T=90,_=122,R=46,I=47,S=92,D=58,b=63;class g extends Error{constructor(o,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,o){if(s===null||typeof s!="object")throw new g(o,"Object",s)}function f(s,o){if(typeof s!="string")throw new g(o,"string",s)}const y=k.platform==="win32";function v(s){return s===I||s===S}function l(s){return s===I}function h(s){return s>=U&&s<=T||s>=A&&s<=_}function u(s,o,n,i){let t="",r=0,a=-1,w=0,p=0;for(let d=0;d<=s.length;++d){if(d<s.length)p=s.charCodeAt(d);else{if(i(p))break;p=I}if(i(p)){if(!(a===d-1||w===1))if(w===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const E=t.lastIndexOf(n);E===-1?(t="",r=0):(t=t.slice(0,E),r=t.length-1-t.lastIndexOf(n)),a=d,w=0;continue}else if(t.length!==0){t="",r=0,a=d,w=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(a+1,d)}`:t=s.slice(a+1,d),r=d-a-1;a=d,w=0}else p===R&&w!==-1?++w:w=-1}return t}function m(s,o){c(o,"pathObject");const n=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${i}`:`${n}${s}${i}`:i}e.win32={resolve(...s){let o="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],f(r,"path"),r.length===0)continue}else o.length===0?r=k.cwd():(r=k.env[`=${o}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===S)&&(r=`${o}\\`));const a=r.length;let w=0,p="",d=!1;const E=r.charCodeAt(0);if(a===1)v(E)&&(w=1,d=!0);else if(v(E))if(d=!0,v(r.charCodeAt(1))){let L=2,N=L;for(;L<a&&!v(r.charCodeAt(L));)L++;if(L<a&&L!==N){const F=r.slice(N,L);for(N=L;L<a&&v(r.charCodeAt(L));)L++;if(L<a&&L!==N){for(N=L;L<a&&!v(r.charCodeAt(L));)L++;(L===a||L!==N)&&(p=`\\\\${F}\\${r.slice(N,L)}`,w=L)}}}else w=1;else h(E)&&r.charCodeAt(1)===D&&(p=r.slice(0,2),w=2,a>2&&v(r.charCodeAt(2))&&(d=!0,w=3));if(p.length>0)if(o.length>0){if(p.toLowerCase()!==o.toLowerCase())continue}else o=p;if(i){if(o.length>0)break}else if(n=`${r.slice(w)}\\${n}`,i=d,d&&o.length>0)break}return n=u(n,!i,"\\",v),i?`${o}\\${n}`:`${o}${n}`||"."},normalize(s){f(s,"path");const o=s.length;if(o===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(o===1)return l(r)?"\\":s;if(v(r))if(t=!0,v(s.charCodeAt(1))){let w=2,p=w;for(;w<o&&!v(s.charCodeAt(w));)w++;if(w<o&&w!==p){const d=s.slice(p,w);for(p=w;w<o&&v(s.charCodeAt(w));)w++;if(w<o&&w!==p){for(p=w;w<o&&!v(s.charCodeAt(w));)w++;if(w===o)return`\\\\${d}\\${s.slice(p)}\\`;w!==p&&(i=`\\\\${d}\\${s.slice(p,w)}`,n=w)}}}else n=1;else h(r)&&s.charCodeAt(1)===D&&(i=s.slice(0,2),n=2,o>2&&v(s.charCodeAt(2))&&(t=!0,n=3));let a=n<o?u(s.slice(n),!t,"\\",v):"";return a.length===0&&!t&&(a="."),a.length>0&&v(s.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(s){f(s,"path");const o=s.length;if(o===0)return!1;const n=s.charCodeAt(0);return v(n)||o>2&&h(n)&&s.charCodeAt(1)===D&&v(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,n;for(let r=0;r<s.length;++r){const a=s[r];f(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&v(n.charCodeAt(0))){++t;const r=n.length;r>1&&v(n.charCodeAt(1))&&(++t,r>2&&(v(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&v(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.win32.normalize(o)},relative(s,o){if(f(s,"from"),f(o,"to"),s===o)return"";const n=e.win32.resolve(s),i=e.win32.resolve(o);if(n===i||(s=n.toLowerCase(),o=i.toLowerCase(),s===o))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===S;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===S;)r--;const a=r-t;let w=0;for(;w<o.length&&o.charCodeAt(w)===S;)w++;let p=o.length;for(;p-1>w&&o.charCodeAt(p-1)===S;)p--;const d=p-w,E=a<d?a:d;let L=-1,N=0;for(;N<E;N++){const M=s.charCodeAt(t+N);if(M!==o.charCodeAt(w+N))break;M===S&&(L=N)}if(N!==E){if(L===-1)return i}else{if(d>E){if(o.charCodeAt(w+N)===S)return i.slice(w+N+1);if(N===2)return i.slice(w+N)}a>E&&(s.charCodeAt(t+N)===S?L=N:N===2&&(L=3)),L===-1&&(L=0)}let F="";for(N=t+L+1;N<=r;++N)(N===r||s.charCodeAt(N)===S)&&(F+=F.length===0?"..":"\\..");return w+=L,F.length>0?`${F}${i.slice(w,p)}`:(i.charCodeAt(w)===S&&++w,i.slice(w,p))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===S){if(o.charCodeAt(1)===S){const n=o.charCodeAt(2);if(n!==b&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===D&&o.charCodeAt(2)===S)return`\\\\?\\${o}`;return s},dirname(s){f(s,"path");const o=s.length;if(o===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(o===1)return v(t)?s:".";if(v(t)){if(n=i=1,v(s.charCodeAt(1))){let w=2,p=w;for(;w<o&&!v(s.charCodeAt(w));)w++;if(w<o&&w!==p){for(p=w;w<o&&v(s.charCodeAt(w));)w++;if(w<o&&w!==p){for(p=w;w<o&&!v(s.charCodeAt(w));)w++;if(w===o)return s;w!==p&&(n=i=w+1)}}}}else h(t)&&s.charCodeAt(1)===D&&(n=o>2&&v(s.charCodeAt(2))?3:2,i=n);let r=-1,a=!0;for(let w=o-1;w>=i;--w)if(v(s.charCodeAt(w))){if(!a){r=w;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,o){o!==void 0&&f(o,"ext"),f(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&h(s.charCodeAt(0))&&s.charCodeAt(1)===D&&(n=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,w=-1;for(r=s.length-1;r>=n;--r){const p=s.charCodeAt(r);if(v(p)){if(!t){n=r+1;break}}else w===-1&&(t=!1,w=r+1),a>=0&&(p===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=w))}return n===i?i=w:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(v(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){f(s,"path");let o=0,n=-1,i=0,t=-1,r=!0,a=0;s.length>=2&&s.charCodeAt(1)===D&&h(s.charCodeAt(0))&&(o=i=2);for(let w=s.length-1;w>=o;--w){const p=s.charCodeAt(w);if(v(p)){if(!r){i=w+1;break}continue}t===-1&&(r=!1,t=w+1),p===R?n===-1?n=w:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:m.bind(null,"\\"),parse(s){f(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return v(t)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(v(t)){if(i=1,v(s.charCodeAt(1))){let L=2,N=L;for(;L<n&&!v(s.charCodeAt(L));)L++;if(L<n&&L!==N){for(N=L;L<n&&v(s.charCodeAt(L));)L++;if(L<n&&L!==N){for(N=L;L<n&&!v(s.charCodeAt(L));)L++;L===n?i=L:L!==N&&(i=L+1)}}}}else if(h(t)&&s.charCodeAt(1)===D){if(n<=2)return o.root=o.dir=s,o;if(i=2,v(s.charCodeAt(2))){if(n===3)return o.root=o.dir=s,o;i=3}}i>0&&(o.root=s.slice(0,i));let r=-1,a=i,w=-1,p=!0,d=s.length-1,E=0;for(;d>=i;--d){if(t=s.charCodeAt(d),v(t)){if(!p){a=d+1;break}continue}w===-1&&(p=!1,w=d+1),t===R?r===-1?r=d:E!==1&&(E=1):r!==-1&&(E=-1)}return w!==-1&&(r===-1||E===0||E===1&&r===w-1&&r===a+1?o.base=o.name=s.slice(a,w):(o.name=s.slice(a,r),o.base=s.slice(a,w),o.ext=s.slice(r,w))),a>0&&a!==i?o.dir=s.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(y){const s=/\\/g;return()=>{const o=k.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...s){let o="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:C();f(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===I)}return o=u(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(s){if(f(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===I,n=s.charCodeAt(s.length-1)===I;return s=u(s,!o,"/",l),s.length===0?o?"/":n?"./":".":(n&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return f(s,"path"),s.length>0&&s.charCodeAt(0)===I},join(...s){if(s.length===0)return".";let o;for(let n=0;n<s.length;++n){const i=s[n];f(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(f(s,"from"),f(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const n=1,i=s.length,t=i-n,r=1,a=o.length-r,w=t<a?t:a;let p=-1,d=0;for(;d<w;d++){const L=s.charCodeAt(n+d);if(L!==o.charCodeAt(r+d))break;L===I&&(p=d)}if(d===w)if(a>w){if(o.charCodeAt(r+d)===I)return o.slice(r+d+1);if(d===0)return o.slice(r+d)}else t>w&&(s.charCodeAt(n+d)===I?p=d:d===0&&(p=0));let E="";for(d=n+p+1;d<=i;++d)(d===i||s.charCodeAt(d)===I)&&(E+=E.length===0?"..":"/..");return`${E}${o.slice(r+p)}`},toNamespacedPath(s){return s},dirname(s){if(f(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===I;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===I){if(!i){n=t;break}}else i=!1;return n===-1?o?"/":".":o&&n===1?"//":s.slice(0,n)},basename(s,o){o!==void 0&&f(o,"ext"),f(s,"path");let n=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,w=-1;for(r=s.length-1;r>=0;--r){const p=s.charCodeAt(r);if(p===I){if(!t){n=r+1;break}}else w===-1&&(t=!1,w=r+1),a>=0&&(p===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=w))}return n===i?i=w:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===I){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){f(s,"path");let o=-1,n=0,i=-1,t=!0,r=0;for(let a=s.length-1;a>=0;--a){const w=s.charCodeAt(a);if(w===I){if(!t){n=a+1;break}continue}i===-1&&(t=!1,i=a+1),w===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===n+1?"":s.slice(o,i)},format:m.bind(null,"/"),parse(s){f(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.charCodeAt(0)===I;let i;n?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,w=!0,p=s.length-1,d=0;for(;p>=i;--p){const E=s.charCodeAt(p);if(E===I){if(!w){r=p+1;break}continue}a===-1&&(w=!1,a=p+1),E===R?t===-1?t=p:d!==1&&(d=1):t!==-1&&(d=-1)}if(a!==-1){const E=r===0&&n?1:r;t===-1||d===0||d===1&&t===a-1&&t===r+1?o.base=o.name=s.slice(E,a):(o.name=s.slice(E,t),o.base=s.slice(E,a),o.ext=s.slice(t,a))}return r>0?o.dir=s.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(le[48],ue([0,1,16,5,27,12]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function R(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function I(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function S(r,a=k.posix.sep){if(!r)return"";const w=r.length,p=r.charCodeAt(0);if(_(p)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let E=3;const L=E;for(;E<w&&!_(r.charCodeAt(E));E++);if(L!==E&&!_(r.charCodeAt(E+1))){for(E+=1;E<w;E++)if(_(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,a)}}return a}else if(l(p)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<w;d++)if(_(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=S;function D(r){if(!U.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let w=2;const p=w;for(;w<r.length&&(a=r.charCodeAt(w),a!==92);w++);return!(p===w||(a=r.charCodeAt(w+1),isNaN(a)||a===92))}e.isUNC=D;const b=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,a=U.isWindows){const w=a?b:g;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function y(r,a,w){const p=r===a;return!w||p?p:!r||!a?!1:(0,A.equalsIgnoreCase)(r,a)}e.isEqual=y;function v(r,a,w,p=k.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(w){if(!(0,A.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let E=a.length;return a.charAt(a.length-1)===p&&E--,r.charAt(E)===p}return a.charAt(a.length-1)!==p&&(a+=p),r.indexOf(a)===0}e.isEqualOrParent=v;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=l;function h(r,a){return U.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(a,r)),r=(0,k.normalize)(r),U.isWindows?(r=(0,A.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,A.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=h;function u(r){const a=(0,k.normalize)(r);return U.isWindows?r.length>3?!1:m(a)&&(r.length===2||a.charCodeAt(2)===92):a===k.posix.sep}e.isRootOrDriveLetter=u;function m(r,a=U.isWindows){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function C(r,a=U.isWindows){return m(r,a)?r[0]:void 0}e.getDriveLetter=C;function s(r,a,w){return a.length>r.length?-1:r===a?0:(w&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=s;function o(r){const a=r.split(":");let w,p,d;for(const E of a){const L=Number(E);(0,T.isNumber)(L)?p===void 0?p=L:d===void 0&&(d=L):w=w?[w,E].join(":"):E}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:p!==void 0?p:void 0,column:d!==void 0?d:p!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,w=8){let p="";for(let E=0;E<w;E++){let L;E===0&&U.isWindows&&!a&&(w===3||w===4)?L=i:L=n,p+=L.charAt(Math.floor(Math.random()*L.length))}let d;return a?d=`${a}-${p}`:d=p,r?(0,k.join)(r,d):d}e.randomPath=t}),define(le[139],ue([0,1,16]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(D){const b=(0,k.extname)(D),g=U[b.toLowerCase()];return g!==void 0?g:_(D)}e.getMediaOrTextMime=T;function _(D){const b=(0,k.extname)(D);return A[b.toLowerCase()]}e.getMediaMime=_;function R(D){for(const b in A)if(A[b]===D)return b}e.getExtensionForMimeType=R;const I=/^(.+)\/(.+?)(;.+)?$/;function S(D,b){const g=I.exec(D);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:b?void 0:D}e.normalizeMimeType=S}),define(le[90],ue([0,1,5]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var U;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(U||(e.Source=U={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function T(R,...I){const S=I.reduce((g,c)=>(g[c]=!0,g),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!S[g]).forEach(g=>{for(let c=0;c<D.length;c++)if(g.search(D[c])!==-1){delete R[g];break}})}e.sanitizeProcessEnvironment=T;function _(R){R&&(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(le[10],ue([0,1,16,5]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,_=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!A.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,t){return!i&&!t?"file":i}function S(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const D="",b="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,w,p,d=!1){typeof t=="object"?(this.scheme=t.scheme||D,this.authority=t.authority||D,this.path=t.path||D,this.query=t.query||D,this.fragment=t.fragment||D):(this.scheme=I(t,d),this.authority=r||D,this.path=S(this.scheme,a||D),this.query=w||D,this.fragment=p||D,R(this,d))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:w,query:p,fragment:d}=t;return r===void 0?r=this.scheme:r===null&&(r=D),a===void 0?a=this.authority:a===null&&(a=D),w===void 0?w=this.path:w===null&&(w=D),p===void 0?p=this.query:p===null&&(p=D),d===void 0?d=this.fragment:d===null&&(d=D),r===this.scheme&&a===this.authority&&w===this.path&&p===this.query&&d===this.fragment?this:new v(r,a,w,p,d)}static parse(t,r=!1){const a=g.exec(t);return a?new v(a[2]||D,n(a[4]||D),n(a[5]||D),n(a[7]||D),n(a[9]||D),r):new v(D,D,D,D,D)}static file(t){let r=D;if(U.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const a=t.indexOf(b,2);a===-1?(r=t.substring(2),t=b):(r=t.substring(2,a),t=t.substring(a)||b)}return new v("file",r,t,D,D)}static from(t,r){return new v(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return U.isWindows&&t.scheme==="file"?a=c.file(k.win32.join(m(t,!0),...r)).path:a=k.posix.join(t.path,...r),t.with({path:a})}toString(t=!1){return C(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new v(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=c;function f(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=f;const y=U.isWindows?1:void 0;class v extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,t,r){let a,w=-1;for(let p=0;p<i.length;p++){const d=i.charCodeAt(p);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||t&&d===47||r&&d===91||r&&d===93||r&&d===58)w!==-1&&(a+=encodeURIComponent(i.substring(w,p)),w=-1),a!==void 0&&(a+=i.charAt(p));else{a===void 0&&(a=i.substr(0,p));const E=l[d];E!==void 0?(w!==-1&&(a+=encodeURIComponent(i.substring(w,p)),w=-1),a+=E):w===-1&&(w=p)}}return w!==-1&&(a+=encodeURIComponent(i.substring(w))),a!==void 0?a:i}function u(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=l[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function m(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,U.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function C(i,t){const r=t?u:h;let a="",{scheme:w,authority:p,path:d,query:E,fragment:L}=i;if(w&&(a+=w,a+=":"),(p||w==="file")&&(a+=b,a+=b),p){let N=p.indexOf("@");if(N!==-1){const F=p.substr(0,N);p=p.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,N),!1,!1),a+=":",a+=r(F.substr(N+1),!1,!0)),a+="@"}p=p.toLowerCase(),N=p.lastIndexOf(":"),N===-1?a+=r(p,!1,!0):(a+=r(p.substr(0,N),!1,!0),a+=p.substr(N))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const N=d.charCodeAt(1);N>=65&&N<=90&&(d=`/${String.fromCharCode(N+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const N=d.charCodeAt(0);N>=65&&N<=90&&(d=`${String.fromCharCode(N+32)}:${d.substr(2)}`)}a+=r(d,!0,!1)}return E&&(a+="?",a+=r(E,!1,!1)),L&&(a+="#",a+=t?L:h(L,!1,!1)),a}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(o)?i.replace(o,t=>s(t)):i}}),define(le[140],ue([0,1,10]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function U(S){const D=S;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=U;function A(S){const D=[];let b;try{const g=JSON.parse(S.arguments),c=g[g.length-1];c&&c.__$stack&&(g.pop(),b=c.__$stack),D.push(...g)}catch{D.push("Unable to log remote console arguments",S.arguments)}return{args:D,stack:b}}e.parse=A;function T(S){if(typeof S!="string")return T(A(S).stack);const D=S;if(D){const b=_(D),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(g&&g.length===4)return{uri:k.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function _(S){if(!S)return S;const D=S.indexOf(`
`);return D===-1?S:S.substring(0,D)}function R(S,D){const{args:b,stack:g}=A(S),c=typeof b[0]=="string"&&b.length===1;let f=_(g);f&&(f=`(${f.trim()})`);let y=[];if(typeof b[0]=="string"?f&&c?y=[`%c[${D}] %c${b[0]} %c${f}`,I("blue"),I(""),I("grey")]:y=[`%c[${D}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:y=[`%c[${D}]%`,I("blue"),...b],f&&!c&&y.push(f),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,y)}e.log=R;function I(S){return`color: ${S}`}}),define(le[65],ue([0,1,15,10]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(I){return JSON.stringify(I,_)}e.stringify=A;function T(I){let S=JSON.parse(I);return S=R(S),S}e.parse=T;function _(I,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function R(I,S=0){if(!I||S>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return U.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 17:return new Date(I.source)}if(I instanceof k.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let D=0;D<I.length;++D)I[D]=R(I[D],S+1);else for(const D in I)Object.hasOwnProperty.call(I,D)&&(I[D]=R(I[D],S+1))}return I}e.revive=R}),define(le[23],ue([0,1,7,5,27,10]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var _;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(_||(e.Schemas=_={}));function R(g,c){return T.URI.isUri(g)?(0,A.equalsIgnoreCase)(g.scheme,c):(0,A.startsWithIgnoreCase)(g,c+":")}e.matchesScheme=R;function I(g,...c){return c.some(f=>R(g,f))}e.matchesSomeScheme=I,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(c){this._preferredWebSchema=c}setDelegate(c){this._delegate=c}setServerRootPath(c){this._remoteResourcesPath=`${c}/${_.vscodeRemoteResource}`}set(c,f,y){this._hosts[c]=f,this._ports[c]=y}setConnectionToken(c,f){this._connectionTokens[c]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(c){if(this._delegate)try{return this._delegate(c)}catch(u){return k.onUnexpectedError(u),c}const f=c.authority;let y=this._hosts[f];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const v=this._ports[f],l=this._connectionTokens[f];let h=`path=${encodeURIComponent(c.path)}`;return typeof l=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(l)}`),T.URI.from({scheme:U.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${y}:${v}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class D{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(c){const f=this.toUri(c,ne);return this.uriToBrowserUri(f)}uriToBrowserUri(c){return c.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(c):c.scheme===_.file&&(U.isNative||U.webWorkerOrigin===`${_.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?c.with({scheme:_.vscodeFileResource,authority:c.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):c}asFileUri(c){const f=this.toUri(c,ne);return this.uriToFileUri(f)}uriToFileUri(c){return c.scheme===_.vscodeFileResource?c.with({scheme:_.file,authority:c.authority!==D.FALLBACK_AUTHORITY?c.authority:null,query:null,fragment:null}):c}toUri(c,f){return T.URI.isUri(c)?c:T.URI.parse(f.toUrl(c))}}e.FileAccess=new D;var b;(function(g){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(c.get("3"));const f="vscode-coi";function y(l){let h;typeof l=="string"?h=new URL(l).searchParams:l instanceof URL?h=l.searchParams:T.URI.isUri(l)&&(h=new URL(l.toString(!0)).searchParams);const u=h?.get(f);if(u)return c.get(u)}g.getHeadersFromQuery=y;function v(l,h,u){if(!globalThis.crossOriginIsolated)return;const m=h&&u?"3":u?"2":"1";l instanceof URLSearchParams?l.set(f,m):l[f]=m}g.addSearchParam=v})(b||(e.COI=b={}))}),define(le[141],ue([0,1,123,23,5,10]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class _{constructor(g,c,f){this.id=g,this.dependencies=c,this.callback=f}}class R{static{this.INSTANCE=new R}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,c,f)=>{typeof g!="string"&&(f=c,c=g,g=null),(typeof c!="object"||!Array.isArray(c))&&(f=c,c=null),this._defineCalls.push(new _(g,c,f))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const c=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!c)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}_rendererLoadScript(g){return new Promise((c,f)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const v=()=>{y.removeEventListener("load",l),y.removeEventListener("error",h)},l=u=>{v(),c(this._defineCalls.pop())},h=u=>{v(),f(u)};y.addEventListener("load",l),y.addEventListener("error",h),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),y.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(y)})}_workerLoadScript(g){return new Promise((c,f)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),c(this._defineCalls.pop())}catch(y){f(y)}})}async _nodeJSLoadScript(g){try{const c=globalThis._VSCODE_NODE_MODULES.fs,f=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,v=T.URI.parse(g).fsPath,l=c.readFileSync(v).toString(),h=y.wrap(l.replace(/^#!.*/,""));return new f.Script(h).runInThisContext().apply(),this._defineCalls.pop()}catch(c){throw c}}}const I=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function D(b,g,c){if(k.isESM){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[b]&&(b=S[b]);const f=`${b}/${g}`;if(I.has(f))return I.get(f);let y;if(/^\w[\w\d+.-]*:\/\//.test(f))y=f;else{const u=`${c&&!A.isWeb?U.nodeModulesAsarPath:U.nodeModulesPath}/${f}`;y=U.FileAccess.asBrowserUri(u).toString(!0)}const v=R.INSTANCE.load(y);return I.set(f,v),v}else return await new Promise((f,y)=>{ne([b],f,y)})}e.importAMDNodeModule=D}),define(le[19],ue([0,1,48,23,16,5,27,10]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(c){return(0,R.uriToFsPath)(c,!0)}e.originalFSPath=I;class S{constructor(f){this._ignorePathCasing=f}compare(f,y,v=!1){return f===y?0:(0,_.compare)(this.getComparisonKey(f,v),this.getComparisonKey(y,v))}isEqual(f,y,v=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,v)===this.getComparisonKey(y,v)}getComparisonKey(f,y=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,y,v=!1){if(f.scheme===y.scheme){if(f.scheme===U.Schemas.file)return k.isEqualOrParent(I(f),I(y),this._ignorePathCasing(f))&&f.query===y.query&&(v||f.fragment===y.fragment);if((0,e.isEqualAuthority)(f.authority,y.authority))return k.isEqualOrParent(f.path,y.path,this._ignorePathCasing(f),"/")&&f.query===y.query&&(v||f.fragment===y.fragment)}return!1}joinPath(f,...y){return R.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return A.posix.basename(f.path)}extname(f){return A.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===U.Schemas.file?y=R.URI.file(A.dirname(I(f))).path:(y=A.posix.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===U.Schemas.file?y=R.URI.file(A.normalize(I(f))).path:y=A.posix.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.isEqualAuthority)(f.authority,y.authority))return;if(f.scheme===U.Schemas.file){const h=A.relative(I(f),I(y));return T.isWindows?k.toSlashes(h):h}let v=f.path||"/";const l=y.path||"/";if(this._ignorePathCasing(f)){let h=0;for(const u=Math.min(v.length,l.length);h<u&&!(v.charCodeAt(h)!==l.charCodeAt(h)&&v.charAt(h).toLowerCase()!==l.charAt(h).toLowerCase());h++);v=l.substr(0,h)+v.substr(h)}return A.posix.relative(v,l)}resolvePath(f,y){if(f.scheme===U.Schemas.file){const v=R.URI.file(A.resolve(I(f),y));return f.with({authority:v.authority,path:v.path})}return y=k.toPosixPath(y),f.with({path:A.posix.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,_.equalsIgnoreCase)(f,y)}hasTrailingPathSeparator(f,y=A.sep){if(f.scheme===U.Schemas.file){const v=I(f);return v.length>k.getRoot(v).length&&v[v.length-1]===y}else{const v=f.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=A.sep){return(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=A.sep){let v=!1;if(f.scheme===U.Schemas.file){const l=I(f);v=l!==void 0&&l.length===k.getRoot(l).length&&l[l.length-1]===y}else{y="/";const l=f.path;v=l.length===1&&l.charCodeAt(l.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path+"/"}):f}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(c=>c.scheme===U.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new S(c=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(c,f){const y=[];for(let v=0;v<c.length;v++){const l=f(c[v]);c.some((h,u)=>u===v?!1:(0,e.isEqualOrParent)(l,f(h)))||y.push(c[v])}return y}e.distinctParents=D;var b;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function f(y){const v=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(u=>{const[m,C]=u.split(":");m&&C&&v.set(m,C)});const h=y.path.substring(0,y.path.indexOf(";"));return h&&v.set(c.META_DATA_MIME,h),v}c.parseMetaData=f})(b||(e.DataUri=b={}));function g(c,f,y){if(f){let v=c.path;return v&&v[0]!==A.posix.sep&&(v=A.posix.sep+v),c.with({scheme:y,authority:f,path:v})}return c.with({scheme:y})}e.toLocalResource=g}),define(le[6],ue([0,1,26,7,3,2,19,5,129,52]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(V){return!!V&&typeof V.then=="function"}e.isThenable=D;function b(V){const K=new k.CancellationTokenSource,ie=V(K.token),ce=new Promise((oe,de)=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),K.dispose(),de(new U.CancellationError)});Promise.resolve(ie).then(pe=>{fe.dispose(),K.dispose(),oe(pe)},pe=>{fe.dispose(),K.dispose(),de(pe)})});return new class{cancel(){K.cancel()}then(oe,de){return ce.then(oe,de)}catch(oe){return this.then(void 0,oe)}finally(oe){return ce.finally(oe)}}}e.createCancelablePromise=b;function g(V,K,ie){return new Promise((ce,oe)=>{const de=K.onCancellationRequested(()=>{de.dispose(),ce(ie)});V.then(ce,oe).finally(()=>de.dispose())})}e.raceCancellation=g;function c(V,K){return new Promise((ie,ce)=>{const oe=K.onCancellationRequested(()=>{oe.dispose(),ce(new U.CancellationError)});V.then(ie,ce).finally(()=>oe.dispose())})}e.raceCancellationError=c;async function f(V){let K=-1;const ie=V.map((ce,oe)=>ce.then(de=>(K=oe,de)));try{return await Promise.race(ie)}finally{V.forEach((ce,oe)=>{oe!==K&&ce.cancel()})}}e.raceCancellablePromises=f;function y(V,K,ie){let ce;const oe=setTimeout(()=>{ce?.(void 0),ie?.()},K);return Promise.race([V.finally(()=>clearTimeout(oe)),new Promise(de=>ce=de)])}e.raceTimeout=y;function v(V){return new Promise((K,ie)=>{const ce=V();D(ce)?ce.then(K,ie):K(ce)})}e.asPromise=v;class l{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const ie=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ce=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ce};this.queuedPromise=new Promise(ce=>{this.activePromise.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.queuedPromise.then(ie,ce)})}return this.activePromise=K(),new Promise((ie,ce)=>{this.activePromise.then(oe=>{this.activePromise=null,ie(oe)},oe=>{this.activePromise=null,ce(oe)})})}dispose(){this.isDisposed=!0}}e.Throttler=l;class h{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=h;class u{constructor(){this.promiseMap=new Map}queue(K,ie){const oe=(this.promiseMap.get(K)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(K)===oe&&this.promiseMap.delete(K)});return this.promiseMap.set(K,oe),oe}}e.SequencerByKey=u;const m=(V,K)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,K()},V);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},C=V=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,V())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class s{constructor(K){this.defaultDelay=K,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,ie=this.defaultDelay){this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((oe,de)=>{this.doResolve=oe,this.doReject=de}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const oe=this.task;return this.task=null,oe()}}));const ce=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ie===I.MicrotaskDelay?C(ce):m(ie,ce),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new U.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class o{constructor(K){this.delayer=new s(K),this.throttler=new l}trigger(K,ie){return this.delayer.trigger(()=>this.throttler.queue(K),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=o;class n{constructor(){this._isOpen=!1,this._promise=new Promise((K,ie)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class i extends n{constructor(K){super(),this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function t(V,K){return K?new Promise((ie,ce)=>{const oe=setTimeout(()=>{de.dispose(),ie()},V),de=K.onCancellationRequested(()=>{clearTimeout(oe),de.dispose(),ce(new U.CancellationError)})}):b(ie=>t(V,ie))}e.timeout=t;function r(V,K=0,ie){const ce=setTimeout(()=>{V(),ie&&oe.dispose()},K),oe=(0,T.toDisposable)(()=>{clearTimeout(ce),ie?.deleteAndLeak(oe)});return ie?.add(oe),oe}e.disposableTimeout=r;function a(V){const K=[];let ie=0;const ce=V.length;function oe(){return ie<ce?V[ie++]():null}function de(fe){fe!=null&&K.push(fe);const pe=oe();return pe?pe.then(de):Promise.resolve(K)}return Promise.resolve(null).then(de)}e.sequence=a;function w(V,K=ce=>!!ce,ie=null){let ce=0;const oe=V.length,de=()=>{if(ce>=oe)return Promise.resolve(ie);const fe=V[ce++];return Promise.resolve(fe()).then(we=>K(we)?Promise.resolve(we):de())};return de()}e.first=w;function p(V,K=ce=>!!ce,ie=null){if(V.length===0)return Promise.resolve(ie);let ce=V.length;const oe=()=>{ce=-1;for(const de of V)de.cancel?.()};return new Promise((de,fe)=>{for(const pe of V)pe.then(we=>{--ce>=0&&K(we)?(oe(),de(we)):ce===0&&de(ie)}).catch(we=>{--ce>=0&&(oe(),fe(we))})})}e.firstParallel=p;class d{constructor(K){this._size=0,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new A.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(K){return this._size++,new Promise((ie,ce)=>{this.outstandingPromises.push({factory:K,c:ie,e:ce}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const ie=K.factory();ie.then(K.c,K.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class E extends d{constructor(){super(1)}}e.Queue=E;class L{constructor(){this.sequentializer=new q,this.tasks=0}queue(K){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,K())):this.sequentializer.run(this.tasks++,K())}}e.LimitedQueue=L;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const K=new Z;return this.drainers.add(K),K.p}isDrained(){for(const[,K]of this.queues)if(K.size>0)return!1;return!0}queueFor(K,ie=_.extUri){const ce=ie.getComparisonKey(K);let oe=this.queues.get(ce);if(!oe){oe=new E;const de=this.drainListenerCount++,fe=A.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.queues.delete(ce),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(de),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new T.DisposableMap),this.drainListeners.set(de,fe),this.queues.set(ce,oe)}return oe}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const K of this.drainers)K.complete();this.drainers.clear()}dispose(){for(const[,K]of this.queues)K.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class F{constructor(K,ie){this._token=-1,typeof K=="function"&&typeof ie=="number"&&this.setIfNotSet(K,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},ie)}setIfNotSet(K,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},ie))}}e.TimeoutTimer=F;class M{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(K,ie,ce=globalThis){this.cancel();const oe=ce.setInterval(()=>{K()},ie);this.disposable=(0,T.toDisposable)(()=>{ce.clearInterval(oe),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=M;class W{constructor(K,ie){this.timeoutToken=-1,this.runner=K,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=W;class Q{constructor(K,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=K,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(K=this.timeout){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(K/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Q;class H extends W{constructor(K,ie){super(K,ie),this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner?.(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class X extends T.Disposable{constructor(K,ie){super(),this.options=K,this.handler=ie,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(K){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+K.length>this.options.maxBufferedWork)return!1}else if(this.pending+K.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ie of K)this.pendingWork.push(ie);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(V,K)=>{(0,R.setTimeout0)(()=>{if(ie)return;const ce=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e._runWhenIdle=(V,K,ie)=>{const ce=V.requestIdleCallback(K,typeof ie=="number"?{timeout:ie}:void 0);let oe=!1;return{dispose(){oe||(oe=!0,V.cancelIdleCallback(ce))}}},e.runWhenGlobalIdle=V=>(0,e._runWhenIdle)(globalThis,V)}();class z{constructor(K,ie){this._didRun=!1,this._executor=()=>{try{this._value=ie()}catch(ce){this._error=ce}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(K,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=z;class Y extends z{constructor(K){super(globalThis,K)}}e.GlobalIdleValue=Y;async function x(V,K,ie){let ce;for(let oe=0;oe<ie;oe++)try{return await V()}catch(de){ce=de,await t(K)}throw ce}e.retry=x;class q{isRunning(K){return typeof K=="number"?this._running?.taskId===K:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(K,ie,ce){return this._running={taskId:K,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.doneRunning(K),()=>this.doneRunning(K)),ie}doneRunning(K){this._running&&K===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const K=this._queued;this._queued=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this._queued)this._queued.run=K;else{let ie,ce;const oe=new Promise((de,fe)=>{ie=de,ce=fe});this._queued={run:K,promise:oe,promiseResolve:ie,promiseReject:ce}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=q;class te{constructor(K,ie=()=>Date.now()){this.interval=K,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const K=this.nowFn();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=te;var se;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(se||(se={}));class Z{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((K,ie)=>{this.completeCallback=K,this.errorCallback=ie})}complete(K){return new Promise(ie=>{this.completeCallback(K),this.outcome={outcome:0,value:K},ie()})}error(K){return new Promise(ie=>{this.errorCallback(K),this.outcome={outcome:1,value:K},ie()})}cancel(){return this.error(new U.CancellationError)}}e.DeferredPromise=Z;var re;(function(V){async function K(ce){let oe;const de=await Promise.all(ce.map(fe=>fe.then(pe=>pe,pe=>{oe||(oe=pe)})));if(typeof oe<"u")throw oe;return de}V.settled=K;function ie(ce){return new Promise(async(oe,de)=>{try{await ce(oe,de)}catch(fe){de(fe)}})}V.withAsyncBody=ie})(re||(e.Promises=re={}));class G{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(K){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=K.then(ie=>(this._value=ie,this._isResolved=!0,ie),ie=>{throw this._error=ie,this._isResolved=!0,ie})}requireValue(){if(!this._isResolved)throw new U.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=G;class ${constructor(K){this._compute=K,this._promise=new S.Lazy(()=>new G(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}}e.LazyStatefulPromise=$;var P;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(P||(P={}));class O{static fromArray(K){return new O(ie=>{ie.emitMany(K)})}static fromPromise(K){return new O(async ie=>{ie.emitMany(await K)})}static fromPromises(K){return new O(async ie=>{await Promise.all(K.map(async ce=>ie.emitOne(await ce)))})}static merge(K){return new O(async ie=>{await Promise.all(K.map(async ce=>{for await(const oe of ce)ie.emitOne(oe)}))})}static{this.EMPTY=O.fromArray([])}constructor(K){this._state=0,this._results=[],this._error=null,this._onStateChanged=new A.Emitter,queueMicrotask(async()=>{const ie={emitOne:ce=>this.emitOne(ce),emitMany:ce=>this.emitMany(ce),reject:ce=>this.reject(ce)};try{await Promise.resolve(K(ie)),this.resolve()}catch(ce){this.reject(ce)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(K<this._results.length)return{done:!1,value:this._results[K++]};if(this._state===1)return{done:!0,value:void 0};await A.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(K,ie){return new O(async ce=>{for await(const oe of K)ce.emitOne(ie(oe))})}map(K){return O.map(this,K)}static filter(K,ie){return new O(async ce=>{for await(const oe of K)ie(oe)&&ce.emitOne(oe)})}filter(K){return O.filter(this,K)}static coalesce(K){return O.filter(K,ie=>!!ie)}coalesce(){return O.coalesce(this)}static async toPromise(K){const ie=[];for await(const ce of K)ie.push(ce);return ie}toPromise(){return O.toPromise(this)}emitOne(K){this._state===0&&(this._results.push(K),this._onStateChanged.fire())}emitMany(K){this._state===0&&(this._results=this._results.concat(K),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(K){this._state===0&&(this._state=2,this._error=K,this._onStateChanged.fire())}}e.AsyncIterableObject=O;class B extends O{constructor(K,ie){super(ie),this._source=K}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=B;function j(V){const K=new k.CancellationTokenSource,ie=V(K.token);return new B(K,async ce=>{const oe=K.token.onCancellationRequested(()=>{oe.dispose(),K.dispose(),ce.reject(new U.CancellationError)});try{for await(const de of ie){if(K.token.isCancellationRequested)return;ce.emitOne(de)}oe.dispose(),K.dispose()}catch(de){oe.dispose(),K.dispose(),ce.reject(de)}})}e.createCancelableAsyncIterable=j;class ee{constructor(){this._deferred=new Z,this._asyncIterable=new O(ce=>{if(K){ce.reject(K);return}return ie&&ce.emitMany(ie),this._errorFn=oe=>ce.reject(oe),this._emitFn=oe=>ce.emitOne(oe),this._deferred.p});let K,ie;this._emitFn=ce=>{ie||(ie=[]),ie.push(ce)},this._errorFn=ce=>{K||(K=ce)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(K){this._errorFn(K),this._deferred.complete()}emitOne(K){this._emitFn(K)}}e.AsyncIterableSource=ee}),define(le[91],ue([0,1,18,6,48,34,16,5,27]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",b="[^/\\\\]",g=/\//g;function c(Y,x){switch(Y){case 0:return"";case 1:return`${b}*?`;default:return`(?:${D}|${b}+${D}${x?`|${D}${b}+`:""})*?`}}function f(Y,x){if(!Y)return[];const q=[];let te=!1,se=!1,Z="";for(const re of Y){switch(re){case x:if(!te&&!se){q.push(Z),Z="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":se=!0;break;case"]":se=!1;break}Z+=re}return Z&&q.push(Z),q}e.splitGlobAware=f;function y(Y){if(!Y)return"";let x="";const q=f(Y,e.GLOB_SPLIT);if(q.every(te=>te===e.GLOBSTAR))x=".*";else{let te=!1;q.forEach((se,Z)=>{if(se===e.GLOBSTAR){if(te)return;x+=c(2,Z===q.length-1)}else{let re=!1,G="",$=!1,P="";for(const O of se){if(O!=="}"&&re){G+=O;continue}if($&&(O!=="]"||!P)){let B;O==="-"?B=O:(O==="^"||O==="!")&&!P?B="^":O===e.GLOB_SPLIT?B="":B=(0,I.escapeRegExpCharacters)(O),P+=B;continue}switch(O){case"{":re=!0;continue;case"[":$=!0;continue;case"}":{const j=`(?:${f(G,",").map(ee=>y(ee)).join("|")})`;x+=j,re=!1,G="";break}case"]":{x+="["+P+"]",$=!1,P="";break}case"?":x+=b;continue;case"*":x+=c(1);continue;default:x+=(0,I.escapeRegExpCharacters)(O)}}Z<q.length-1&&(q[Z+1]!==e.GLOBSTAR||Z+2<q.length)&&(x+=D)}te=se===e.GLOBSTAR})}return x}const v=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.LRUCache(1e4),o=function(){return!1},n=function(){return null};function i(Y,x){if(!Y)return n;let q;typeof Y!="string"?q=Y.pattern:q=Y,q=q.trim();const te=`${q}_${!!x.trimForExclusions}`;let se=s.get(te);if(se)return t(se,Y);let Z;return v.test(q)?se=a(q.substr(4),q):(Z=l.exec(r(q,x)))?se=w(Z[1],q):(x.trimForExclusions?u:h).test(q)?se=p(q,x):(Z=m.exec(r(q,x)))?se=d(Z[1].substr(1),q,!0):(Z=C.exec(r(q,x)))?se=d(Z[1],q,!1):se=E(q),s.set(te,se),t(se,Y)}function t(Y,x){if(typeof x=="string")return Y;const q=function(te,se){return(0,A.isEqualOrParent)(te,x.base,!R.isLinux)?Y((0,I.ltrim)(te.substr(x.base.length),_.sep),se):null};return q.allBasenames=Y.allBasenames,q.allPaths=Y.allPaths,q.basenames=Y.basenames,q.patterns=Y.patterns,q}function r(Y,x){return x.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function a(Y,x){return function(q,te){return typeof q=="string"&&q.endsWith(Y)?x:null}}function w(Y,x){const q=`/${Y}`,te=`\\${Y}`,se=function(re,G){return typeof re!="string"?null:G?G===Y?x:null:re===Y||re.endsWith(q)||re.endsWith(te)?x:null},Z=[Y];return se.basenames=Z,se.patterns=[x],se.allBasenames=Z,se}function p(Y,x){const q=X(Y.slice(1,-1).split(",").map(G=>i(G,x)).filter(G=>G!==n),Y),te=q.length;if(!te)return n;if(te===1)return q[0];const se=function(G,$){for(let P=0,O=q.length;P<O;P++)if(q[P](G,$))return Y;return null},Z=q.find(G=>!!G.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const re=q.reduce((G,$)=>$.allPaths?G.concat($.allPaths):G,[]);return re.length&&(se.allPaths=re),se}function d(Y,x,q){const te=_.sep===_.posix.sep,se=te?Y:Y.replace(g,_.sep),Z=_.sep+se,re=_.posix.sep+Y;let G;return q?G=function($,P){return typeof $=="string"&&($===se||$.endsWith(Z)||!te&&($===Y||$.endsWith(re)))?x:null}:G=function($,P){return typeof $=="string"&&($===se||!te&&$===Y)?x:null},G.allPaths=[(q?"*/":"./")+Y],G}function E(Y){try{const x=new RegExp(`^${y(Y)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?Y:null}}catch{return n}}function L(Y,x,q){return!Y||typeof x!="string"?!1:N(Y)(x,void 0,q)}e.match=L;function N(Y,x={}){if(!Y)return o;if(typeof Y=="string"||F(Y)){const q=i(Y,x);if(q===n)return o;const te=function(se,Z){return!!q(se,Z)};return q.allBasenames&&(te.allBasenames=q.allBasenames),q.allPaths&&(te.allPaths=q.allPaths),te}return Q(Y,x)}e.parse=N;function F(Y){const x=Y;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=F;function M(Y){return Y.allBasenames||[]}e.getBasenameTerms=M;function W(Y){return Y.allPaths||[]}e.getPathTerms=W;function Q(Y,x){const q=X(Object.getOwnPropertyNames(Y).map(G=>H(G,Y[G],x)).filter(G=>G!==n)),te=q.length;if(!te)return n;if(!q.some(G=>!!G.requiresSiblings)){if(te===1)return q[0];const G=function(O,B){let j;for(let ee=0,V=q.length;ee<V;ee++){const K=q[ee](O,B);if(typeof K=="string")return K;(0,U.isThenable)(K)&&(j||(j=[]),j.push(K))}return j?(async()=>{for(const ee of j){const V=await ee;if(typeof V=="string")return V}return null})():null},$=q.find(O=>!!O.allBasenames);$&&(G.allBasenames=$.allBasenames);const P=q.reduce((O,B)=>B.allPaths?O.concat(B.allPaths):O,[]);return P.length&&(G.allPaths=P),G}const se=function(G,$,P){let O,B;for(let j=0,ee=q.length;j<ee;j++){const V=q[j];V.requiresSiblings&&P&&($||($=(0,_.basename)(G)),O||(O=$.substr(0,$.length-(0,_.extname)(G).length)));const K=V(G,$,O,P);if(typeof K=="string")return K;(0,U.isThenable)(K)&&(B||(B=[]),B.push(K))}return B?(async()=>{for(const j of B){const ee=await j;if(typeof ee=="string")return ee}return null})():null},Z=q.find(G=>!!G.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const re=q.reduce((G,$)=>$.allPaths?G.concat($.allPaths):G,[]);return re.length&&(se.allPaths=re),se}function H(Y,x,q){if(x===!1)return n;const te=i(Y,q);if(te===n)return n;if(typeof x=="boolean")return te;if(x){const se=x.when;if(typeof se=="string"){const Z=(re,G,$,P)=>{if(!P||!te(re,G))return null;const O=se.replace("$(basename)",()=>$),B=P(O);return(0,U.isThenable)(B)?B.then(j=>j?Y:null):B?Y:null};return Z.requiresSiblings=!0,Z}}return te}function X(Y,x){const q=Y.filter(G=>!!G.basenames);if(q.length<2)return Y;const te=q.reduce((G,$)=>{const P=$.basenames;return P?G.concat(P):G},[]);let se;if(x){se=[];for(let G=0,$=te.length;G<$;G++)se.push(x)}else se=q.reduce((G,$)=>{const P=$.patterns;return P?G.concat(P):G},[]);const Z=function(G,$){if(typeof G!="string")return null;if(!$){let O;for(O=G.length;O>0;O--){const B=G.charCodeAt(O-1);if(B===47||B===92)break}$=G.substr(O)}const P=te.indexOf($);return P!==-1?se[P]:null};Z.basenames=te,Z.patterns=se,Z.allBasenames=te;const re=Y.filter(G=>!G.basenames);return re.push(Z),re}function z(Y,x){return(0,k.equals)(Y,x,(q,te)=>typeof q=="string"&&typeof te=="string"?q===te:typeof q!="string"&&typeof te!="string"?q.base===te.base&&q.pattern===te.pattern:!1)}e.patternsEquals=z}),define(le[92],ue([0,1,15,10]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(b){return b.toJSON()}class T{constructor(g){this._uriTransformer=g}transformIncoming(g){const c=this._uriTransformer.transformIncoming(g);return c===g?g:A(U.URI.from(c))}transformOutgoing(g){const c=this._uriTransformer.transformOutgoing(g);return c===g?g:A(U.URI.from(c))}transformOutgoingURI(g){const c=this._uriTransformer.transformOutgoing(g);return c===g?g:U.URI.from(c)}transformOutgoingScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function _(b,g,c){if(!b||c>200)return null;if(typeof b=="object"){if(b instanceof U.URI)return g.transformOutgoing(b);for(const f in b)if(Object.hasOwnProperty.call(b,f)){const y=_(b[f],g,c+1);y!==null&&(b[f]=y)}}return null}function R(b,g){const c=_(b,g,0);return c===null?b:c}e.transformOutgoingURIs=R;function I(b,g,c,f){if(!b||f>200)return null;if(typeof b=="object"){if(b.$mid===1)return c?U.URI.revive(g.transformIncoming(b)):g.transformIncoming(b);if(b instanceof k.VSBuffer)return null;for(const y in b)if(Object.hasOwnProperty.call(b,y)){const v=I(b[y],g,c,f+1);v!==null&&(b[y]=v)}}return null}function S(b,g){const c=I(b,g,!1,0);return c===null?b:c}e.transformIncomingURIs=S;function D(b,g){const c=I(b,g,!0,0);return c===null?b:c}e.transformAndReviveIncomingURIs=D}),define(le[142],ue([0,1,36,47,32,130,5]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSqmMachineId=e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(g){return this._virtualMachineOUIs||(this._virtualMachineOUIs=U.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(g)}value(){if(this._value===void 0){let g=0,c=0;const f=(0,k.networkInterfaces)();for(const y in f){const v=f[y];if(v)for(const{mac:l,internal:h}of v)h||(c+=1,this._isVirtualMachineMacAddress(l.toUpperCase())&&(g+=1))}this._value=c>0?g/c:0}return this._value}};let R;async function I(g){return R||(R=(async()=>await S(g)||A.generateUuid())()),R}e.getMachineId=I;async function S(g){try{const c=await new Promise((y,v)=>{ne(["crypto"],y,v)}),f=(0,T.getMac)();return c.createHash("sha256").update(f,"utf8").digest("hex")}catch(c){g(c);return}}const D="Software\\Microsoft\\SQMClient";async function b(g){if(_.isWindows){const c=await new Promise((f,y)=>{ne(["@vscode/windows-registry"],f,y)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch(f){return g(f),""}}return""}e.getSqmMachineId=b}),define(le[31],ue([0,1,54,36,268,6,48,88,16,5,19,10]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function c(H,X=g.UNLINK,z){if((0,_.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return X===g.UNLINK?y(H):f(H,z)}async function f(H,X=(0,_.randomPath)((0,U.tmpdir)())){try{try{await k.promises.rename(H,X)}catch(z){return z.code==="ENOENT"?void 0:y(H)}y(X).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function y(H){return(0,A.promisify)(k.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function v(H){if((0,_.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function l(H,X){return m(await(X?h(H):(0,A.promisify)(k.readdir)(H)))}async function h(H){try{return await(0,A.promisify)(k.readdir)(H,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const X=[],z=await l(H);for(const Y of z){let x=!1,q=!1,te=!1;try{const se=await e.Promises.lstat((0,I.join)(H,Y));x=se.isFile(),q=se.isDirectory(),te=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}X.push({name:Y,isFile:()=>x,isDirectory:()=>q,isSymbolicLink:()=>te})}return X}function u(H){return m(k.readdirSync(H))}e.readdirSync=u;function m(H){return H.map(X=>typeof X=="string"?S.isMacintosh?(0,R.normalizeNFC)(X):X:(X.name=S.isMacintosh?(0,R.normalizeNFC)(X.name):X.name,X))}async function C(H){const X=await l(H),z=[];for(const Y of X)await o.existsDirectory((0,I.join)(H,Y))&&z.push(Y);return z}function s(H,X=1e3){return new Promise(z=>{let Y=!1;const x=setInterval(()=>{Y||(Y=!0,k.access(H,q=>{Y=!1,q&&(clearInterval(x),z(void 0))}))},X)})}e.whenDeleted=s;var o;(function(H){async function X(x){let q;try{if(q=await e.Promises.lstat(x),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(S.isWindows&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw se}throw te}}H.stat=X;async function z(x){try{const{stat:q,symbolicLink:te}=await H.stat(x);return q.isFile()&&te?.dangling!==!0}catch{}return!1}H.existsFile=z;async function Y(x){try{const{stat:q,symbolicLink:te}=await H.stat(x);return q.isDirectory()&&te?.dangling!==!0}catch{}return!1}H.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const n=new T.ResourceQueue;function i(H,X,z){return n.queueFor(b.URI.file(H),D.extUriBiasedIgnorePathCase).queue(()=>{const Y=p(z);return new Promise((x,q)=>a(H,X,Y,te=>te?q(te):x()))})}let t=!0;function r(H){t=H}e.configureFlushOnWrite=r;function a(H,X,z,Y){if(!t)return k.writeFile(H,X,{mode:z.mode,flag:z.flag},Y);k.open(H,z.flag,z.mode,(x,q)=>{if(x)return Y(x);k.writeFile(q,X,te=>{if(te)return k.close(q,()=>Y(te));k.fdatasync(q,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),r(!1)),k.close(q,Z=>Y(Z))))})})}function w(H,X,z){const Y=p(z);if(!t)return k.writeFileSync(H,X,{mode:Y.mode,flag:Y.flag});const x=k.openSync(H,Y.flag,Y.mode);try{k.writeFileSync(x,X);try{k.fdatasyncSync(x)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{k.closeSync(x)}}e.writeFileSync=w;function p(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function d(H,X,z=6e4){if(H!==X)try{S.isWindows&&typeof z=="number"?await E(H,X,Date.now(),z):await(0,A.promisify)(k.rename)(H,X)}catch(Y){if(H.toLowerCase()!==X.toLowerCase()&&Y.code==="EXDEV"||H.endsWith("."))await L(H,X,{preserveSymlinks:!1}),await c(H,g.MOVE);else throw Y}}async function E(H,X,z,Y,x=0){try{return await(0,A.promisify)(k.rename)(H,X)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-z>=Y)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${q}`),q;if(x===0){let te=!1;try{const{stat:se}=await o.stat(X);se.isFile()||(te=!0)}catch{}if(te)throw q}return await(0,T.timeout)(Math.min(100,x*10)),E(H,X,z,Y,x+1)}}async function L(H,X,z){return F(H,X,{root:{source:H,target:X},options:z,handledSourcePaths:new Set})}const N=511;async function F(H,X,z){if(z.handledSourcePaths.has(H))return;z.handledSourcePaths.add(H);const{stat:Y,symbolicLink:x}=await o.stat(H);if(x){if(z.options.preserveSymlinks)try{return await Q(H,X,z)}catch{}if(x.dangling)return}return Y.isDirectory()?M(H,X,Y.mode&N,z):W(H,X,Y.mode&N)}async function M(H,X,z,Y){await e.Promises.mkdir(X,{recursive:!0,mode:z});const x=await l(H);for(const q of x)await F((0,I.join)(H,q),(0,I.join)(X,q),Y)}async function W(H,X,z){await e.Promises.copyFile(H,X),await e.Promises.chmod(X,z)}async function Q(H,X,z){let Y=await e.Promises.readlink(H);(0,_.isEqualOrParent)(Y,z.root.source,!S.isLinux)&&(Y=(0,I.join)(z.root.target,Y.substr(z.root.source.length+1))),await e.Promises.symlink(Y,X)}e.Promises=new class{get access(){return(0,A.promisify)(k.access)}get stat(){return(0,A.promisify)(k.stat)}get lstat(){return(0,A.promisify)(k.lstat)}get utimes(){return(0,A.promisify)(k.utimes)}get read(){return(H,X,z,Y,x)=>new Promise((q,te)=>{k.read(H,X,z,Y,x,(se,Z,re)=>se?te(se):q({bytesRead:Z,buffer:re}))})}get readFile(){return(0,A.promisify)(k.readFile)}get write(){return(H,X,z,Y,x)=>new Promise((q,te)=>{k.write(H,X,z,Y,x,(se,Z,re)=>se?te(se):q({bytesWritten:Z,buffer:re}))})}get appendFile(){return(0,A.promisify)(k.appendFile)}get fdatasync(){return(0,A.promisify)(k.fdatasync)}get truncate(){return(0,A.promisify)(k.truncate)}get copyFile(){return(0,A.promisify)(k.copyFile)}get open(){return(0,A.promisify)(k.open)}get close(){return(0,A.promisify)(k.close)}get symlink(){return(0,A.promisify)(k.symlink)}get readlink(){return(0,A.promisify)(k.readlink)}get chmod(){return(0,A.promisify)(k.chmod)}get mkdir(){return(0,A.promisify)(k.mkdir)}get unlink(){return(0,A.promisify)(k.unlink)}get rmdir(){return(0,A.promisify)(k.rmdir)}get realpath(){return(0,A.promisify)(k.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return C}get writeFile(){return i}get rm(){return c}get rename(){return d}get copy(){return L}}}),define(le[143],ue([0,1,54,16,5,27,31]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(g){if(A.isLinux)return g;const c=(0,U.dirname)(g);if(g===c)return g;const f=((0,U.basename)(g)||g).toLowerCase();try{const v=(0,_.readdirSync)(c).filter(l=>l.toLowerCase()===f);if(v.length===1){const l=R(c);if(l)return(0,U.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(f);if(l>=0){const h=R(c);if(h)return(0,U.join)(h,v[l])}}}catch{}return null}e.realcaseSync=R;async function I(g){if(A.isLinux)return g;const c=(0,U.dirname)(g);if(g===c)return g;const f=((0,U.basename)(g)||g).toLowerCase();try{const v=(await _.Promises.readdir(c)).filter(l=>l.toLowerCase()===f);if(v.length===1){const l=await I(c);if(l)return(0,U.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(f);if(l>=0){const h=await I(c);if(h)return(0,U.join)(h,v[l])}}}catch{}return null}e.realcase=I;async function S(g){try{return await _.Promises.realpath(g)}catch{const f=b(g);return await _.Promises.access(f,k.constants.R_OK),f}}e.realpath=S;function D(g){try{return k.realpathSync(g)}catch{const f=b(g);return k.accessSync(f,k.constants.R_OK),f}}e.realpathSync=D;function b(g){return(0,T.rtrim)((0,U.normalize)(g),U.sep)}}),define(le[144],ue([0,1,16,5,37,90,12,31]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function I(b=A.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function S(b){let g=[],c=!1;const f=function(y){if(c){g.push(y);return}(!b.send(y,l=>{if(l&&console.error(l),c=!1,g.length>0){const h=g.slice(0);g=[],h.forEach(u=>f(u))}})||U.isWindows)&&(c=!0)};return{send:f}}e.createQueuedSender=S;var D;(function(b){async function g(c,f,y){if(k.isAbsolute(c))return c;if(f===void 0&&(f=A.cwd()),k.dirname(c)!=="."||(y===void 0&&_.isString(A.env.PATH)&&(y=A.env.PATH.split(k.delimiter)),y===void 0||y.length===0))return k.join(f,c);async function l(h){if(await R.Promises.exists(h)){let u;try{u=await R.Promises.stat(h)}catch(m){m.message.startsWith("EACCES")&&(u=await R.Promises.lstat(h))}return u?!u.isDirectory():!1}return!1}for(const h of y){let u;if(k.isAbsolute(h)?u=k.join(h,c):u=k.join(f,h,c),await l(u))return u;let m=u+".com";if(await l(m)||(m=u+".exe",await l(m)))return m}return k.join(f,c)}b.findExecutable=g})(D||(e.win32=D={}))}),define(le[145],ue([0,1,66,23]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(_){return new Promise((R,I)=>{let S;const D=new Map;function b(c,f,y,v,l){const h=D.get(f);if(c===_||h){const u={name:g(y),cmd:y,pid:c,ppid:f,load:v,mem:l};D.set(c,u),c===_&&(S=u),h&&(h.children||(h.children=[]),h.children.push(u),h.children.length>1&&(h.children=h.children.sort((m,C)=>m.pid-C.pid)))}}function g(c){const f=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,v=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(v.exec(c))return"electron-crash-reporter";if(l.exec(c))return"winpty-agent";if(h.exec(c))return"conpty-agent";let m=u.exec(c);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?f.exec(c)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const C=/[a-zA-Z-]+\.js/g;let s="";do m=C.exec(c),m&&(s+=m+" ");while(m);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:y.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,y)=>{ne(["@vscode/windows-process-tree"],f,y)}).then(f=>{f.getProcessList(_,y=>{if(!y){I(new Error(`Root process ${_} not found`));return}f.getProcessCpuUsage(y,v=>{const l=new Map;v.forEach(h=>{const u=c(h.commandLine||"");l.set(h.pid,{name:g(u),cmd:u,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),S=l.get(_),S?(l.forEach(h=>{const u=l.get(h.ppid);u&&(u.children||(u.children=[]),u.children.push(h))}),l.forEach(h=>{h.children&&(h.children=h.children.sort((u,m)=>u.pid-m.pid))}),R(S)):I(new Error(`Root process ${_} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let c=function(){let f=[S];const y=[];for(;f.length;){const l=f.shift();l&&(y.push(l.pid),l.children&&(f=f.concat(l.children)))}let v=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+y.join(" "),(0,k.exec)(v,{},(l,h,u)=>{if(l||u)I(l||new Error(u.toString()));else{const m=h.toString().split(`
`);for(let C=0;C<y.length;C++){const s=D.get(y[C]);s.load=parseFloat(m[C])}if(!S){I(new Error(`Root process ${_} not found`));return}R(S)}})};(0,k.exec)("which ps",{},(f,y,v)=>{if(f||v)if(process.platform!=="linux")I(f||new Error(v.toString()));else{const l=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(l,{},(h,u,m)=>{h||m?I(h||new Error(m.toString())):(T(u,b),c())})}else{const l=y.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${l} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,m,C)=>{u||C&&!C.includes("screen size is bogus")?I(u||new Error(C.toString())):(T(m,b),process.platform==="linux"?c():S?R(S):I(new Error(`Root process ${_} not found`)))})}})}})}e.listProcesses=A;function T(_,R){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=_.toString().split(`
`);for(const D of S){const b=I.exec(D.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var ye=this&&this.__decorate||function(ne,e,k,U){var A=arguments.length,T=A<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,k):U,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ne,e,k,U);else for(var R=ne.length-1;R>=0;R--)(_=ne[R])&&(T=(A<3?_(T):A>3?_(e,k,T):_(e,k))||T);return A>3&&T&&Object.defineProperty(e,k,T),T};define(le[40],ue([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var c;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(c||(c={}));function f(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(y||(y={}));function v(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(l||(l={}));function h(x){let q=0;for(let te=0;;te+=7){const se=x.read(1);if(q|=(se.buffer[0]&127)<<te,!(se.buffer[0]&128))return q}}const u=n(0);function m(x,q){if(q===0){x.write(u);return}let te=0;for(let Z=q;Z!==0;Z=Z>>>7)te++;const se=A.VSBuffer.alloc(te);for(let Z=0;q!==0;Z++)se.buffer[Z]=q&127,q=q>>>7,q>0&&(se.buffer[Z]|=128);x.write(se)}class C{constructor(q){this.buffer=q,this.pos=0}read(q){const te=this.buffer.slice(this.pos,this.pos+q);return this.pos+=te.byteLength,te}}e.BufferReader=C;class s{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=s;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function n(x){const q=A.VSBuffer.alloc(1);return q.writeUInt8(x,0),q}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(x,q){if(typeof q>"u")x.write(i.Undefined);else if(typeof q=="string"){const te=A.VSBuffer.fromString(q);x.write(i.String),m(x,te.byteLength),x.write(te)}else if(t&&Buffer.isBuffer(q)){const te=A.VSBuffer.wrap(q);x.write(i.Buffer),m(x,te.byteLength),x.write(te)}else if(q instanceof A.VSBuffer)x.write(i.VSBuffer),m(x,q.byteLength),x.write(q);else if(Array.isArray(q)){x.write(i.Array),m(x,q.length);for(const te of q)r(x,te)}else if(typeof q=="number"&&(q|0)===q)x.write(i.Uint),m(x,q);else{const te=A.VSBuffer.fromString(JSON.stringify(q));x.write(i.Object),m(x,te.byteLength),x.write(te)}}e.serialize=r;function a(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(h(x)).toString();case o.Buffer:return x.read(h(x)).buffer;case o.VSBuffer:return x.read(h(x));case o.Array:{const te=h(x),se=[];for(let Z=0;Z<te;Z++)se.push(a(x));return se}case o.Object:return JSON.parse(x.read(h(x)).toString());case o.Int:return h(x)}}e.deserialize=a;class w{constructor(q,te,se=null,Z=1e3){this.protocol=q,this.ctx=te,this.logger=se,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel(q,te){this.channels.set(q,te),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const te=this.send([q.type]);this.logger?.logOutgoing(te,0,1,v(q.type));return}case 201:case 202:case 204:case 203:{const te=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(te,q.id,1,v(q.type),q.data);return}}}send(q,te=void 0){const se=new s;return r(se,q),r(se,te),this.sendBuffer(se.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const te=new C(q),se=a(te),Z=a(te),re=se[0];switch(re){case 100:return this.logger?.logIncoming(q.byteLength,se[1],1,`${f(re)}: ${se[2]}.${se[3]}`,Z),this.onPromise({type:re,id:se[1],channelName:se[2],name:se[3],arg:Z});case 102:return this.logger?.logIncoming(q.byteLength,se[1],1,`${f(re)}: ${se[2]}.${se[3]}`,Z),this.onEventListen({type:re,id:se[1],channelName:se[2],name:se[3],arg:Z});case 101:return this.logger?.logIncoming(q.byteLength,se[1],1,`${f(re)}`),this.disposeActiveRequest({type:re,id:se[1]});case 103:return this.logger?.logIncoming(q.byteLength,se[1],1,`${f(re)}`),this.disposeActiveRequest({type:re,id:se[1]})}}onPromise(q){const te=this.channels.get(q.channelName);if(!te){this.collectPendingRequest(q);return}const se=new T.CancellationTokenSource;let Z;try{Z=te.call(this.ctx,q.name,q.arg,se.token)}catch($){Z=Promise.reject($)}const re=q.id;Z.then($=>{this.sendResponse({id:re,data:$,type:201})},$=>{$ instanceof Error?this.sendResponse({id:re,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:re,data:$,type:203})}).finally(()=>{G.dispose(),this.activeRequests.delete(q.id)});const G=(0,S.toDisposable)(()=>se.cancel());this.activeRequests.set(q.id,G)}onEventListen(q){const te=this.channels.get(q.channelName);if(!te){this.collectPendingRequest(q);return}const se=q.id,re=te.listen(this.ctx,q.name,q.arg)(G=>this.sendResponse({id:se,data:G,type:204}));this.activeRequests.set(q.id,re)}disposeActiveRequest(q){const te=this.activeRequests.get(q.id);te&&(te.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let te=this.pendingRequests.get(q.channelName);te||(te=[],this.pendingRequests.set(q.channelName,te));const se=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);te.push({request:q,timeoutTimer:se})}flushPendingRequests(q){const te=this.pendingRequests.get(q);if(te){for(const se of te)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.onPromise(se.request);break;case 102:this.onEventListen(se.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=w;var p;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class d{constructor(q,te=null){this.protocol=q,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(se=>this.onBuffer(se)),this.logger=te}getChannel(q){const te=this;return{call(se,Z,re){return te.isDisposed?Promise.reject(new R.CancellationError):te.requestPromise(q,se,Z,re)},listen(se,Z){return te.isDisposed?I.Event.None:te.requestEvent(q,se,Z)}}}requestPromise(q,te,se,Z=T.CancellationToken.None){const re=this.lastRequestId++,$={id:re,type:100,channelName:q,name:te,arg:se};if(Z.isCancellationRequested)return Promise.reject(new R.CancellationError);let P;return new Promise((B,j)=>{if(Z.isCancellationRequested)return j(new R.CancellationError);const ee=()=>{const ce=oe=>{switch(oe.type){case 201:this.handlers.delete(re),B(oe.data);break;case 202:{this.handlers.delete(re);const de=new Error(oe.data.message);de.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,de.name=oe.data.name,j(de);break}case 203:this.handlers.delete(re),j(oe.data);break}};this.handlers.set(re,ce),this.sendRequest($)};let V=null;this.state===l.Idle?ee():(V=(0,U.createCancelablePromise)(ce=>this.whenInitialized()),V.then(()=>{V=null,ee()}));const K=()=>{V?(V.cancel(),V=null):this.sendRequest({id:re,type:101}),j(new R.CancellationError)},ie=Z.onCancellationRequested(K);P=(0,S.combinedDisposable)((0,S.toDisposable)(K),ie),this.activeRequests.add(P)}).finally(()=>{P.dispose(),this.activeRequests.delete(P)})}requestEvent(q,te,se){const Z=this.lastRequestId++,G={id:Z,type:102,channelName:q,name:te,arg:se};let $=null;const P=new I.Emitter({onWillAddFirstListener:()=>{$=(0,U.createCancelablePromise)(B=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(P),this.sendRequest(G)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(P),this.sendRequest({id:Z,type:103}))}}),O=B=>P.fire(B.data);return this.handlers.set(Z,O),P.event}sendRequest(q){switch(q.type){case 100:case 102:{const te=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(te,q.id,0,`${f(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const te=this.send([q.type,q.id]);this.logger?.logOutgoing(te,q.id,0,f(q.type));return}}}send(q,te=void 0){const se=new s;return r(se,q),r(se,te),this.sendBuffer(se.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const te=new C(q),se=a(te),Z=a(te),re=se[0];switch(re){case 200:return this.logger?.logIncoming(q.byteLength,0,0,v(re)),this.onResponse({type:se[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,se[1],0,v(re),Z),this.onResponse({type:se[0],id:se[1],data:Z})}}onResponse(q){if(q.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=d,ye([_.memoize],d.prototype,"onDidInitializePromise",null);class E{get connections(){const q=[];return this._connections.forEach(te=>q.push(te)),q}constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new S.DisposableStore,this.disposables.add(q(({protocol:te,onDidClientDisconnect:se})=>{const Z=I.Event.once(te.onMessage);this.disposables.add(Z(re=>{const G=new C(re),$=a(G),P=new w(te,$),O=new d(te);this.channels.forEach((j,ee)=>P.registerChannel(ee,j));const B={channelServer:P,channelClient:O,ctx:$};this._connections.add(B),this._onDidAddConnection.fire(B),this.disposables.add(se(()=>{P.dispose(),O.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)}))}))}))}getChannel(q,te){const se=this;return{call(Z,re,G){let $;if((0,g.isFunction)(te)){const O=(0,k.getRandomElement)(se.connections.filter(te));$=O?Promise.resolve(O):I.Event.toPromise(I.Event.filter(se.onDidAddConnection,te))}else $=te.routeCall(se,Z,re);const P=$.then(O=>O.channelClient.getChannel(q));return N(P).call(Z,re,G)},listen(Z,re){if((0,g.isFunction)(te))return se.getMulticastEvent(q,te,Z,re);const G=te.routeEvent(se,Z,re).then($=>$.channelClient.getChannel(q));return N(G).listen(Z,re)}}}getMulticastEvent(q,te,se,Z){const re=this;let G;const $=new I.Emitter({onWillAddFirstListener:()=>{G=new S.DisposableStore;const P=new I.EventMultiplexer,O=new Map,B=ee=>{const K=ee.channelClient.getChannel(q).listen(se,Z),ie=P.add(K);O.set(ee,ie)},j=ee=>{const V=O.get(ee);V&&(V.dispose(),O.delete(ee))};re.connections.filter(te).forEach(B),I.Event.filter(re.onDidAddConnection,te)(B,void 0,G),re.onDidRemoveConnection(j,void 0,G),P.event($.fire,$,G),G.add(P)},onDidRemoveLastListener:()=>{G?.dispose(),G=void 0}});return $.event}registerChannel(q,te){this.channels.set(q,te);for(const se of this._connections)se.channelServer.registerChannel(q,te)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class L{constructor(q,te,se=null){const Z=new s;r(Z,te),q.send(Z.buffer),this.channelClient=new d(q,se),this.channelServer=new w(q,te,se)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,te){this.channelServer.registerChannel(q,te)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function N(x){return{call(q,te,se){return x.then(Z=>Z.call(q,te,se))},listen(q,te){const se=new I.Relay;return x.then(Z=>se.input=Z.listen(q,te)),se.event}}}e.getDelayedChannel=N;function F(x){let q=!1;return{call(te,se,Z){return q?x.call(te,se,Z):(0,U.timeout)(0).then(()=>q=!0).then(()=>x.call(te,se,Z))},listen(te,se){if(q)return x.listen(te,se);const Z=new I.Relay;return(0,U.timeout)(0).then(()=>q=!0).then(()=>Z.input=x.listen(te,se)),Z.event}}}e.getNextTickChannel=F;class M{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const te of q.connections)if(await Promise.resolve(this.fn(te.ctx)))return Promise.resolve(te);return await I.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=M;var W;(function(x){function q(re,G,$){const P=re,O=$&&$.disableMarshalling,B=new Map;for(const j in P)se(j)&&B.set(j,I.Event.buffer(P[j],!0,void 0,G));return new class{listen(j,ee,V){const K=B.get(ee);if(K)return K;if(Z(ee)){const ie=P[ee];if(typeof ie=="function")return ie.call(P,V)}throw new R.ErrorNoTelemetry(`Event not found: ${ee}`)}call(j,ee,V){const K=P[ee];if(typeof K=="function"){if(!O&&Array.isArray(V))for(let ce=0;ce<V.length;ce++)V[ce]=(0,D.revive)(V[ce]);let ie=K.apply(P,V);return ie instanceof Promise||(ie=Promise.resolve(ie)),ie}throw new R.ErrorNoTelemetry(`Method not found: ${ee}`)}}}x.fromService=q;function te(re,G){const $=G&&G.disableMarshalling;return new Proxy({},{get(P,O){if(typeof O=="string")return G?.properties?.has(O)?G.properties.get(O):Z(O)?function(B){return re.listen(O,B)}:se(O)?re.listen(O):async function(...B){let j;G&&!(0,g.isUndefinedOrNull)(G.context)?j=[G.context,...B]:j=B;const ee=await re.call(O,j);return $?ee:(0,D.revive)(ee)};throw new R.ErrorNoTelemetry(`Property not found: ${String(O)}`)}})}x.toService=te;function se(re){return re[0]==="o"&&re[1]==="n"&&b.isUpperAsciiLetter(re.charCodeAt(2))}function Z(re){return/^onDynamic/.test(re)&&b.isUpperAsciiLetter(re.charCodeAt(9))}})(W||(e.ProxyChannel=W={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const q=x.toString();if(q!=="[object Object]")return q}return x}function X(x){return Array.isArray(x)?x.map(H):H(x)}function z(x,q,te,se,Z,re,G){G=X(G);const $=Q[Z],P=$[se%$.length];let O=[`%c[${x}]%c[${String(q).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(re)?(O=O.concat(G),O.push(")")):O.push(G),console.log.apply(console,O)}class Y{constructor(q,te){this._outgoingPrefix=q,this._incomingPrefix=te,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,te,se,Z,re){this._totalOutgoing+=q,z(this._outgoingPrefix,this._totalOutgoing,q,te,se,Z,re)}logIncoming(q,te,se,Z,re){this._totalIncoming+=q,z(this._incomingPrefix,this._totalIncoming,q,te,se,Z,re)}}e.IPCLogger=Y}),define(le[67],ue([0,1,15,3,2,40]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(_||(e.SocketDiagnosticsEventType=_={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(p,d){if(!t.has(p)){const E=String(++r);t.set(p,E)}return t.get(p)}function w(p,d,E,L){if(!i.enableDiagnostics)return;const N=a(p,d);if(L instanceof k.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const F=k.VSBuffer.alloc(L.byteLength);F.set(L),i.records.push({timestamp:Date.now(),id:N,label:d,type:E,buff:F})}else i.records.push({timestamp:Date.now(),id:N,label:d,type:E,data:L})}i.traceSocketEvent=w})(R||(e.SocketDiagnostics=R={}));var I;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I||(e.SocketCloseEventType=I={}));let S=null;function D(){return S||(S=k.VSBuffer.alloc(0)),S}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,r){if(t===0)return D();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const d=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=t),d}if(this._chunks[0].byteLength>t){const d=this._chunks[0].slice(0,t);return r&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),d}const a=k.VSBuffer.alloc(t);let w=0,p=0;for(;t>0;){const d=this._chunks[p];if(d.byteLength>t){const E=d.slice(0,t);a.set(E,w),w+=t,r&&(this._chunks[p]=d.slice(t),this._totalLength-=t),t-=t}else a.set(d,w),w+=d.byteLength,r?(this._chunks.shift(),this._totalLength-=d.byteLength):p++,t-=d.byteLength}return a}}e.ChunkStream=b;var g;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(g||(g={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class y{constructor(t,r,a,w){this.type=t,this.id=r,this.ack=a,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends A.Disposable{constructor(t){super(),this._onMessage=this._register(new U.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:c(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,w=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new y(a,w,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class l{constructor(t){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=k.VSBuffer.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",t.data),this._writeSoon(r,t.data)}_bufferAdd(t,r){const a=this._totalLength===0;return this._data.push(t,r),this._totalLength+=t.byteLength+r.byteLength,a}_bufferTake(){const t=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,r){this._bufferAdd(t,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const t=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this._socket.write(t)}}class h extends A.Disposable{constructor(t){super(),this._onMessage=new U.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new U.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new l(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new y(1,0,0,t))}}e.Protocol=h;class u extends T.IPCClient{static fromSocket(t,r){return new u(new h(t),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.protocol=t}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=u;class m{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new U.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=m;class C{constructor(t){this.data=t,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let t=0,r=this._first;for(;r;)r=r.next,t++;return t}peek(){return this._first?this._first.data:null}toArray(){const t=[];let r=0,a=this._first;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const r=new C(t);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const t=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=t-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const t=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let w=0;w<o._HISTORY_LENGTH;w++)t-this.lastRuns[w]<=r&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(t){this._onControlMessage=new m,this.onControlMessage=this._onControlMessage.event,this._onMessage=new m,this.onMessage=this._onMessage.event,this._onDidDispose=new m,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new m,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new m,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=t.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=t.socket,this._socketWriter=this._socketDisposables.add(new l(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),t.initialChunk&&this._socketReader.acceptChunk(t.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new y(5,0,0,D());this._socketWriter.write(t),this._socketWriter.flush()}sendPause(){const t=new y(7,0,0,D());this._socketWriter.write(t)}sendResume(){const t=new y(8,0,0,D());this._socketWriter.write(t)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=t,this._socketWriter=this._socketDisposables.add(new l(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const t=new y(3,0,this._incomingAckId,D());this._socketWriter.write(t);const r=this._outgoingUnackMsg.toArray();for(let a=0,w=r.length;a<w;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new y(6,0,0,D())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data);break}case 2:{this._onControlMessage.fire(t.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,w=r.length;a<w;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new y(1,r,this._incomingAckId,t);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(t){const r=new y(2,0,0,t);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this._socketReader.lastReadTime,w=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&w>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const p=Math.max(2e4-r,2e4-a,2e4-w,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new y(3,0,this._incomingAckId,D());this._socketWriter.write(t)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const t=new y(9,0,this._incomingAckId,D());this._socketWriter.write(t)}}e.PersistentProtocol=n}),define(le[93],ue([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends c.ChannelServer{constructor(l){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",h=>A.VSBuffer.wrap(Buffer.from(h,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=f;class y{constructor(l,h){this.modulePath=l,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new U.Delayer(u),this.child=null,this._client=null}getChannel(l){const h=this;return{call(u,m,C){return h.requestPromise(l,u,m,C)},listen(u,m){return h.requestEvent(l,u,m)}}}requestPromise(l,h,u,m=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const C=this.getCachedChannel(l),s=(0,U.createCancelablePromise)(i=>C.call(h,u,i)),o=m.onCancellationRequested(()=>s.cancel()),n=(0,S.toDisposable)(()=>s.cancel());return this.activeRequests.add(n),s.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(l,h,u){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let m;const C=new I.Emitter({onWillAddFirstListener:()=>{m=this.getCachedChannel(l).listen(h,u)(C.fire,C),this.activeRequests.add(m)},onDidRemoveLastListener:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return C.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(h.env),this.child=(0,k.fork)(this.modulePath,l,h);const u=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,_.isRemoteConsoleLog)(t)){(0,_.log)(t,`IPC Library: ${this.options.serverName}`);return}u.fire(A.VSBuffer.wrap(Buffer.from(t,"base64")))});const C=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,s=t=>this.child&&this.child.connected&&C.send(t.buffer.toString("base64")),o=u.event,n={send:s,onMessage:o};this._client=new c.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,S.dispose)(a)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(l){let h=this.channels.get(l);return h||(h=this.client.getChannel(l),this.channels.set(l,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(le[146],ue([0,1,133,15,40,3,12,18]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(g){this.port=g,this.onMessage=T.Event.fromNodeEventEmitter(this.port,"message",c=>U.VSBuffer.wrap(c.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}class S extends A.IPCServer{static getOnDidClientConnect(g){(0,_.assertType)((0,k.isUtilityProcess)(process),"Electron Utility Process");const c=new T.Emitter;return process.parentPort.on("message",f=>{if(g?.handledClientConnection(f))return;const y=(0,R.firstOrDefault)(f.ports);y&&c.fire(y)}),T.Event.map(c.event,f=>({protocol:new I(f),onDidClientDisconnect:T.Event.fromNodeEventEmitter(f,"close")}))}constructor(g){super(S.getOnDidClientConnect(g))}}e.Server=S;function D(b,g,c){const f=y=>{y.data===g&&(b.removeListener("message",f),c())};b.on("message",f)}e.once=D}),define(le[68],ue([0,1,6,3,2,65,12]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function I(g){const c=g;return c?.changed instanceof Map||c?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var S;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(S||(e.StorageState=S={}));class D extends A.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(c,f=Object.create(null)){super(),this.database=c,this.options=f,this._onDidChangeStorage=this._register(new U.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=this._register(new k.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){this._onDidChangeStorage.pause();try{c.changed?.forEach((f,y)=>this.acceptExternal(y,f)),c.deleted?.forEach(f=>this.acceptExternal(f,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(c,f){if(this.state===S.Closed)return;let y=!1;(0,_.isUndefinedOrNull)(f)?y=this.cache.delete(c):this.cache.get(c)!==f&&(this.cache.set(c,f),y=!0),y&&this._onDidChangeStorage.fire({key:c,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,f){const y=this.cache.get(c);return(0,_.isUndefinedOrNull)(y)?f:y}getBoolean(c,f){const y=this.get(c);return(0,_.isUndefinedOrNull)(y)?f:y==="true"}getNumber(c,f){const y=this.get(c);return(0,_.isUndefinedOrNull)(y)?f:parseInt(y,10)}getObject(c,f){const y=this.get(c);return(0,_.isUndefinedOrNull)(y)?f:(0,T.parse)(y)}async set(c,f,y=!1){if(this.state===S.Closed)return;if((0,_.isUndefinedOrNull)(f))return this.delete(c,y);const v=(0,_.isObject)(f)||Array.isArray(f)?(0,T.stringify)(f):String(f);if(this.cache.get(c)!==v)return this.cache.set(c,v),this.pendingInserts.set(c,v),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire({key:c,external:y}),this.doFlush()}async delete(c,f=!1){if(!(this.state===S.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire({key:c,external:f}),this.doFlush()}async optimize(){if(this.state!==S.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(this.hasPending)return this.doFlush(c)}async doFlush(c){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=D;class b{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert?.forEach((f,y)=>this.items.set(y,f)),c.delete?.forEach(f=>this.items.delete(f))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=b}),define(le[147],ue([13,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[69],ue([0,1,54,6,16,12,31,147]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class S extends Error{constructor(C,s){let o=s.message;switch(C){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=C,this.cause=s}}e.ExtractError=S;function D(m){const C=m.externalFileAttributes>>16||33188;return[448,56,7].map(s=>C&s).reduce((s,o)=>s+o,C&61440)}function b(m){if(m instanceof S)return m;let C;return I.test(m.message)&&(C="CorruptZip"),new S(C,m)}function g(m,C,s,o,n,i){const t=A.dirname(C),r=A.join(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,C)));const a=A.join(o,C);let w;return i.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(_.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((p,d)=>{if(!i.isCancellationRequested)try{w=(0,k.createWriteStream)(a,{mode:s}),w.once("close",()=>p()),w.once("error",d),m.once("error",d),m.pipe(w)}catch(E){d(E)}}))}function c(m,C,s,o){let n=(0,U.createCancelablePromise)(()=>Promise.resolve()),i=0;const t=o.onCancellationRequested(()=>{n.cancel(),m.close()});return new Promise((r,a)=>{const w=new U.Sequencer,p=d=>{d.isCancellationRequested||(i++,m.readEntry())};m.once("error",a),m.once("close",()=>n.then(()=>{o.isCancellationRequested||m.entryCount===i?r():a(new S("Incomplete",new Error(R.localize(1,null,i,m.entryCount))))},a)),m.readEntry(),m.on("entry",d=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(d.fileName)){p(o);return}const E=d.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(E)){const F=A.join(C,E);n=(0,U.createCancelablePromise)(M=>_.Promises.mkdir(F,{recursive:!0}).then(()=>p(M)).then(void 0,a));return}const L=y(m,d),N=D(d);n=(0,U.createCancelablePromise)(F=>w.queue(()=>L.then(M=>g(M,E,N,C,s,F).then(()=>p(F)))).then(null,a))})}).finally(()=>t.dispose())}async function f(m,C=!1){const{open:s}=await new Promise((o,n)=>{ne(["yauzl"],o,n)});return new Promise((o,n)=>{s(m,C?{lazyEntries:!0}:void 0,(i,t)=>{i?n(b(i)):o((0,T.assertIsDefined)(t))})})}function y(m,C){return new Promise((s,o)=>{m.openReadStream(C,(n,i)=>{n?o(b(n)):s((0,T.assertIsDefined)(i))})})}async function v(m,C){const{ZipFile:s}=await new Promise((o,n)=>{ne(["yazl"],o,n)});return new Promise((o,n)=>{const i=new s;C.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const t=(0,k.createWriteStream)(m);i.outputStream.pipe(t),i.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(m))})}e.zip=v;function l(m,C,s={},o){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=f(m,!0);return s.overwrite&&(i=i.then(t=>_.Promises.rm(C).then(()=>t))),i.then(t=>c(t,C,{sourcePathRegex:n},o))}e.extract=l;function h(m,C){return f(m).then(s=>new Promise((o,n)=>{s.on("entry",i=>{i.fileName===C&&y(s,i).then(t=>o(t),t=>n(t))}),s.once("close",()=>n(new Error(R.localize(2,null,C))))}))}function u(m,C){return h(m,C).then(s=>new Promise((o,n)=>{const i=[];s.once("error",n),s.on("data",t=>i.push(t)),s.on("end",()=>o(Buffer.concat(i)))}))}e.buffer=u}),define(le[148],ue([13,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[149],ue([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[150],ue([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[151],ue([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[152],ue([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[153],ue([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[154],ue([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[155],ue([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[156],ue([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[157],ue([13,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[158],ue([13,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[159],ue([13,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[160],ue([13,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[161],ue([13,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[162],ue([13,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[163],ue([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[164],ue([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[165],ue([13,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[166],ue([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[167],ue([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[168],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[169],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[170],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[171],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[172],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[173],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[174],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[175],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[176],ue([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[177],ue([13,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[178],ue([0,1,7,150]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(A||(e.TokenType=A={}));function T(...S){switch(S.length){case 1:return(0,U.localize)(0,null,S[0]);case 2:return(0,U.localize)(1,null,S[0],S[1]);case 3:return(0,U.localize)(2,null,S[0],S[1],S[2]);default:return}}const _=(0,U.localize)(3,null),R=(0,U.localize)(4,null);class I{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,k.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(D=>D.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(D){return this._input=D,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const b=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:b})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const b=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:b})}else this._match(126)?this._addToken(9):this._error(T("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(T("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(D){return this._isAtEnd()||this._input.charCodeAt(this._current)!==D?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(D){this._tokens.push({type:D,offset:this._start})}_error(D){const b=this._start,g=this._input.substring(this._start,this._current),c={type:19,offset:this._start,lexeme:g};this._errors.push({offset:b,lexeme:g,additionalInfo:D}),this._tokens.push(c)}_string(){this.stringRe.lastIndex=this._start;const D=this.stringRe.exec(this._input);if(D){this._current=this._start+D[0].length;const b=this._input.substring(this._start,this._current),g=I._keywords.get(b);g?this._addToken(g):this._tokens.push({type:17,lexeme:b,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let D=this._current,b=!1,g=!1;for(;;){if(D>=this._input.length){this._current=D,this._error(R);return}const f=this._input.charCodeAt(D);if(b)b=!1;else if(f===47&&!g){D++;break}else f===91?g=!0:f===92?b=!0:f===93&&(g=!1);D++}for(;D<this._input.length&&I._regexFlags.has(this._input.charCodeAt(D));)D++;this._current=D;const c=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:c,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=I}),define(le[179],ue([0,1,64,84,23,16,37,19,10]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,T.dirname)(A.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",c)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(I.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=_.env.VSCODE_PORTABLE;return c?I.URI.file((0,T.join)(c,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,T.resolve)(c):(0,T.normalize)((0,T.join)(A.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?I.URI.file((0,T.resolve)(c)):I.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,T.resolve)(c);const f=_.env.VSCODE_EXTENSIONS;if(f)return f;const y=_.env.VSCODE_PORTABLE;return y?(0,T.join)(y,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(f=>/^[^:/?#]+?:\/\//.test(f)?I.URI.parse(f):I.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?I.URI.parse(c):I.URI.file((0,T.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(c))}get extensionLogLevel(){const c=[];for(const f of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(f);y&&y[1]&&y[2]&&c.push([y[1],y[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=_.env.VSCODE_PORTABLE;return c?I.URI.file((0,T.join)(c,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this._args}constructor(c,f,y){this._args=c,this.paths=f,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=S,ye([U.memoize],S.prototype,"appRoot",null),ye([U.memoize],S.prototype,"userHome",null),ye([U.memoize],S.prototype,"userDataPath",null),ye([U.memoize],S.prototype,"appSettingsHome",null),ye([U.memoize],S.prototype,"tmpDir",null),ye([U.memoize],S.prototype,"cacheHome",null),ye([U.memoize],S.prototype,"stateResource",null),ye([U.memoize],S.prototype,"userRoamingDataHome",null),ye([U.memoize],S.prototype,"userDataSyncHome",null),ye([U.memoize],S.prototype,"sync",null),ye([U.memoize],S.prototype,"machineSettingsResource",null),ye([U.memoize],S.prototype,"workspaceStorageHome",null),ye([U.memoize],S.prototype,"localHistoryHome",null),ye([U.memoize],S.prototype,"keyboardLayoutResource",null),ye([U.memoize],S.prototype,"argvResource",null),ye([U.memoize],S.prototype,"isExtensionDevelopment",null),ye([U.memoize],S.prototype,"untitledWorkspacesHome",null),ye([U.memoize],S.prototype,"builtinExtensionsPath",null),ye([U.memoize],S.prototype,"extensionsPath",null),ye([U.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ye([U.memoize],S.prototype,"extensionDevelopmentKind",null),ye([U.memoize],S.prototype,"extensionTestsLocationURI",null),ye([U.memoize],S.prototype,"debugExtensionHost",null),ye([U.memoize],S.prototype,"logLevel",null),ye([U.memoize],S.prototype,"extensionLogLevel",null),ye([U.memoize],S.prototype,"serviceMachineIdResource",null),ye([U.memoize],S.prototype,"disableTelemetry",null),ye([U.memoize],S.prototype,"disableWorkspaceTrust",null),ye([U.memoize],S.prototype,"useInMemorySecretStorage",null),ye([U.memoize],S.prototype,"policyFile",null);function D(g,c){return b(g["inspect-extensions"],g["inspect-brk-extensions"],5870,c,g.debugId,g.extensionEnvironment)}e.parseExtensionHostDebugPort=D;function b(g,c,f,y,v,l){const u=Number(c||g)||(y?null:f),m=u?!!c:!1;let C;if(l)try{C=JSON.parse(l)}catch{}return{port:u,break:m,debugId:v,env:C}}e.parseDebugParams=b}),function(){"use strict";function ne(e,k,U){function A(_,R){const I=T(_,R),S=[I];return e.isAbsolute(I)||S.unshift(U),e.resolve(...S)}function T(_,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,R);const D=_["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(b,"AppData","Roaming")}break;case"darwin":S=e.join(k.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,R)}return{getUserDataPath:A}}if(typeof define=="function")define(le[180],ue([269,36,37]),function(e,k,U){return ne(e,k,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=ne(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[181],ue([0,1,36,179,180]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class T extends U.AbstractNativeEnvironmentService{constructor(S,D){super(S,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,A.getUserDataPath)(S,D.nameShort)},D)}}e.NativeEnvironmentService=T;function _(I,S){return(0,U.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,S,I.extensionEnvironment)}e.parsePtyHostDebugPort=_;function R(I,S){return(0,U.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,S,I.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(le[182],ue([0,1,12,153]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function A(_,R,I,S){try{T(_,R,I,S)}catch(D){_.error(D?.message??D)}return R}e.localizeManifest=A;function T(_,R,I,S){const D=(b,g,c)=>{const f=b[g];if((0,k.isString)(f)){const y=f,v=y.length;if(v>1&&y[0]==="%"&&y[v-1]==="%"){const l=y.substr(1,v-2);let h=I[l];h===void 0&&S&&(h=S[l]);const u=typeof h=="string"?h:h?.message,m=S?.[l],C=typeof m=="string"?m:m?.message;if(!u){C||_.warn(`[${R.name}]: ${(0,U.localize)(0,null,l)}`);return}if(c&&(g==="title"||g==="category")&&C&&C!==u){const s={value:u,original:C};b[g]=s}else b[g]=u}}else if((0,k.isObject)(f))for(const y in f)f.hasOwnProperty(y)&&(y==="commands"?D(f,y,!0):D(f,y,c));else if(Array.isArray(f))for(let y=0;y<f.length;y++)D(f,y,c)};for(const b in R)R.hasOwnProperty(b)&&D(R,b)}}),define(le[183],ue([0,1,69,156]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(T){return(0,k.buffer)(T,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}e.getManifest=A}),define(le[184],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T){return this.channel.call("promptImportantExtensionsInstallNotification",[T])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class U{constructor(T){this.service=T}listen(T,_){throw new Error(`Event not found: ${_}`)}call(T,_,R){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(le[70],ue([0,1,19,89,157,55]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function I(l){return l=l.trim(),l==="*"||_.test(l)}e.isValidVersionStr=I;function S(l){if(!I(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=l.match(_);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=S;function D(l){if(!l)return null;const h=l.majorBase,u=l.majorMustEqual,m=l.minorBase;let C=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(h===0||(C=!1),o=!1);let n=0;if(l.preRelease){const i=R.exec(l.preRelease);if(i){const[,t,r,a]=i;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:h,majorMustEqual:u,minorBase:m,minorMustEqual:C,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.normalizeVersion=D;function b(l,h,u){let m;typeof l=="string"?m=D(S(l)):m=l;let C;h instanceof Date?C=h.getTime():typeof h=="string"&&(C=new Date(h).getTime());let s;if(typeof u=="string"?s=D(S(u)):s=u,!m||!s)return!1;const o=m.majorBase,n=m.minorBase,i=m.patchBase;let t=s.majorBase,r=s.minorBase,a=s.patchBase;const w=s.notBefore;let p=s.majorMustEqual,d=s.minorMustEqual,E=s.patchMustEqual;return s.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||C&&C<w?!1:i>=a:(o===1&&t===0&&(!p||!d||!E)&&(t=1,r=0,a=0,p=!0,d=!1,E=!1),o<t?!1:o>t?!p:n<r?!1:n>r?!d:i<a?!1:i>a?!E:!(C&&C<w))}e.isValidVersion=b;function g(l,h,u,m,C){const s=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return s.push([U.default.Error,A.localize(0,null)]),s;if(typeof m.name!="string")return s.push([U.default.Error,A.localize(1,null,"name")]),s;if(typeof m.version!="string")return s.push([U.default.Error,A.localize(2,null,"version")]),s;if(!m.engines)return s.push([U.default.Error,A.localize(3,null,"engines")]),s;if(typeof m.engines.vscode!="string")return s.push([U.default.Error,A.localize(4,null,"engines.vscode")]),s;if(typeof m.extensionDependencies<"u"&&!v(m.extensionDependencies))return s.push([U.default.Error,A.localize(5,null,"extensionDependencies")]),s;if(typeof m.activationEvents<"u"){if(!v(m.activationEvents))return s.push([U.default.Error,A.localize(6,null,"activationEvents")]),s;if(typeof m.main>"u"&&typeof m.browser>"u")return s.push([U.default.Error,A.localize(7,null,"activationEvents","main","browser")]),s}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&s.push([U.default.Warning,A.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return s.push([U.default.Error,A.localize(9,null,"main")]),s;{const i=(0,k.joinPath)(u,m.main);(0,k.isEqualOrParent)(i,u)||s.push([U.default.Warning,A.localize(10,null,i.path,u.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return s.push([U.default.Error,A.localize(11,null,"browser")]),s;{const i=(0,k.joinPath)(u,m.browser);(0,k.isEqualOrParent)(i,u)||s.push([U.default.Warning,A.localize(12,null,i.path,u.path)])}}if(!T.valid(m.version))return s.push([U.default.Error,A.localize(13,null)]),s;const o=[];if(!c(l,h,m,C,o))for(const i of o)s.push([U.default.Error,i]);return s}e.validateExtensionManifest=g;function c(l,h,u,m,C){return m||typeof u.main>"u"&&typeof u.browser>"u"?!0:y(l,h,u.engines.vscode,C)}e.isValidExtensionVersion=c;function f(l,h,u){return l==="*"||y(h,u,l)}e.isEngineValid=f;function y(l,h,u,m=[]){const C=D(S(u));if(!C)return m.push(A.localize(14,null,u)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return m.push(A.localize(15,null,u)),!1}else if(!C.majorMustEqual)return m.push(A.localize(16,null,u)),!1;return b(l,h,C)?!0:(m.push(A.localize(17,null,l,u)),!1)}function v(l){if(!Array.isArray(l))return!1;for(let h=0,u=l.length;h<u;h++)if(typeof l[h]!="string")return!1;return!0}}),define(le[43],ue([0,1,15,32]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(T,_,R){let I=R&&R.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const D=(await _.readFile(T.serviceMachineIdResource)).value.toString();I=(0,U.isUUID)(D)?D:null}catch{I=null}if(!I){I=(0,U.generateUuid)();try{await _.writeFile(T.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return R?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=A}),define(le[71],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(A,T=[],_=!1){this.ctor=A,this.staticArguments=T,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=k}),define(le[185],ue([0,1,71]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const U=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function T(R,I,S){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],!!S)),U.push([R,I])}e.registerSingleton=T;function _(){return U}e.getSingletonServiceDescriptors=_}),define(le[186],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(T,_){this.key=T,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class U{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const _ of this._nodes.values())_.outgoing.size===0&&T.push(_);return T}insertEdge(T,_){const R=this.lookupOrInsertNode(T),I=this.lookupOrInsertNode(_);R.outgoing.set(I.key,I),I.incoming.set(R.key,R)}removeNode(T){const _=this._hashFn(T);this._nodes.delete(_);for(const R of this._nodes.values())R.outgoing.delete(_),R.incoming.delete(_)}lookupOrInsertNode(T){const _=this._hashFn(T);let R=this._nodes.get(_);return R||(R=new k(_,T),this._nodes.set(_,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[_,R]of this._nodes)T.push(`${_}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,_]of this._nodes){const R=new Set([T]),I=this._findCycle(_,R);if(I)return I}}_findCycle(T,_){for(const[R,I]of T.outgoing){if(_.has(R))return[..._,R].join(" -> ");_.add(R);const S=this._findCycle(I,_);if(S)return S;_.delete(R)}}}e.Graph=U}),define(le[4],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function R(I){return I[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=R})(k||(e._util=k={})),e.IInstantiationService=A("instantiationService");function U(_,R,I){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:_,index:I}):(R[k.DI_DEPENDENCIES]=[{id:_,index:I}],R[k.DI_TARGET]=R)}function A(_){if(k.serviceIds.has(_))return k.serviceIds.get(_);const R=function(I,S,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(R,I,D)};return R.toString=()=>_,k.serviceIds.set(_,R),R}e.createDecorator=A;function T(_){return _}e.refineServiceDecorator=T}),define(le[187],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(le[20],ue([0,1,12,10,4]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof U.URI)}e.isConfigurationOverrides=T;function _(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof U.URI)}e.isConfigurationUpdateOverrides=_;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function I(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function S(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.isConfigured=S;function D(l,h){const u=Object.create(null);for(const m in l)b(u,m,l[m],h);return u}e.toValuesTree=D;function b(l,h,u,m){const C=h.split("."),s=C.pop();let o=l;for(let n=0;n<C.length;n++){const i=C[n];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${h} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[s]=u}catch{m(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(o)}`)}else m(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function g(l,h){const u=h.split(".");c(l,u)}e.removeFromValueTree=g;function c(l,h){const u=h.shift();if(h.length===0){delete l[u];return}if(Object.keys(l).indexOf(u)!==-1){const m=l[u];typeof m=="object"&&!Array.isArray(m)&&(c(m,h),Object.keys(m).length===0&&delete l[u])}}function f(l,h,u){function m(o,n){let i=o;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const C=h.split("."),s=m(l,C);return typeof s>"u"?u:s}e.getConfigurationValue=f;function y(l,h,u){Object.keys(h).forEach(m=>{m!=="__proto__"&&(m in l?k.isObject(l[m])&&k.isObject(h[m])?y(l[m],h[m],u):u&&(l[m]=h[m]):l[m]=h[m])})}e.merge=y;function v(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(le[94],ue([0,1,5,27,178,4,149,7]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",k.isMacintosh),I.set("isLinux",k.isLinux),I.set("isWindows",k.isWindows),I.set("isWeb",k.isWeb),I.set("isMacNative",k.isMacintosh&&!k.isWeb),I.set("isEdge",k.isEdge),I.set("isFirefox",k.isFirefox),I.set("isChrome",k.isChrome),I.set("isSafari",k.isSafari);function S($,P){if(I.get($)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set($,P)}e.setConstant=S;const D=Object.prototype.hasOwnProperty;var b;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const g={regexParsingWithErrorRecovery:!0},c=(0,_.localize)(0,null),f=(0,_.localize)(1,null),y=(0,_.localize)(2,null),v=(0,_.localize)(3,null),l=(0,_.localize)(4,null),h=(0,_.localize)(5,null),u=(0,_.localize)(6,null),m=(0,_.localize)(7,null);class C{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(P=g){this._config=P,this._scanner=new A.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(P){if(P===""){this._parsingErrors.push({message:c,offset:0,lexeme:"",additionalInfo:f});return}this._tokens=this._scanner.reset(P).scan(),this._current=0,this._parsingErrors=[];try{const O=this._expr();if(!this._isAtEnd()){const B=this._peek(),j=B.type===17?h:void 0;throw this._parsingErrors.push({message:l,offset:B.offset,lexeme:A.Scanner.getLexeme(B),additionalInfo:j}),C._parseError}return O}catch(O){if(O!==C._parseError)throw O;return}}_expr(){return this._or()}_or(){const P=[this._and()];for(;this._matchOne(16);){const O=this._and();P.push(O)}return P.length===1?P[0]:s.or(...P)}_and(){const P=[this._term()];for(;this._matchOne(15);){const O=this._term();P.push(O)}return P.length===1?P[0]:s.and(...P)}_term(){if(this._matchOne(2)){const P=this._peek();switch(P.type){case 11:return this._advance(),t.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const O=this._expr();return this._consume(1,v),O?.negate()}case 17:return this._advance(),L.create(P.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",P)}}return this._primary()}_primary(){const P=this._peek();switch(P.type){case 11:return this._advance(),s.true();case 12:return this._advance(),s.false();case 0:{this._advance();const O=this._expr();return this._consume(1,v),O}case 17:{const O=P.lexeme;if(this._advance(),this._matchOne(9)){const j=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),j.type!==10)throw this._errExpectedButGot("REGEX",j);const ee=j.lexeme,V=ee.lastIndexOf("/"),K=V===ee.length-1?void 0:this._removeFlagsGY(ee.substring(V+1));let ie;try{ie=new RegExp(ee.substring(1,V),K)}catch{throw this._errExpectedButGot("REGEX",j)}return H.create(O,ie)}switch(j.type){case 10:case 19:{const ee=[j.lexeme];this._advance();let V=this._peek(),K=0;for(let fe=0;fe<j.lexeme.length;fe++)j.lexeme.charCodeAt(fe)===40?K++:j.lexeme.charCodeAt(fe)===41&&K--;for(;!this._isAtEnd()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:K++;break;case 1:K--;break;case 10:case 18:for(let fe=0;fe<V.lexeme.length;fe++)V.lexeme.charCodeAt(fe)===40?K++:j.lexeme.charCodeAt(fe)===41&&K--}if(K<0)break;ee.push(A.Scanner.getLexeme(V)),this._advance(),V=this._peek()}const ie=ee.join(""),ce=ie.lastIndexOf("/"),oe=ce===ie.length-1?void 0:this._removeFlagsGY(ie.substring(ce+1));let de;try{de=new RegExp(ie.substring(1,ce),oe)}catch{throw this._errExpectedButGot("REGEX",j)}return s.regex(O,de)}case 18:{const ee=j.lexeme;this._advance();let V=null;if(!(0,U.isFalsyOrWhitespace)(ee)){const K=ee.indexOf("/"),ie=ee.lastIndexOf("/");if(K!==ie&&K>=0){const ce=ee.slice(K+1,ie),oe=ee[ie+1]==="i"?"i":"";try{V=new RegExp(ce,oe)}catch{throw this._errExpectedButGot("REGEX",j)}}}if(V===null)throw this._errExpectedButGot("REGEX",j);return H.create(O,V)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const j=this._value();return s.notIn(O,j)}switch(this._peek().type){case 3:{this._advance();const j=this._value();if(this._previous().type===18)return s.equals(O,j);switch(j){case"true":return s.has(O);case"false":return s.not(O);default:return s.equals(O,j)}}case 4:{this._advance();const j=this._value();if(this._previous().type===18)return s.notEquals(O,j);switch(j){case"true":return s.not(O);case"false":return s.has(O);default:return s.notEquals(O,j)}}case 5:return this._advance(),W.create(O,this._value());case 6:return this._advance(),Q.create(O,this._value());case 7:return this._advance(),F.create(O,this._value());case 8:return this._advance(),M.create(O,this._value());case 13:return this._advance(),s.in(O,this._value());default:return s.has(O)}}case 20:throw this._parsingErrors.push({message:u,offset:P.offset,lexeme:"",additionalInfo:m}),C._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const P=this._peek();switch(P.type){case 17:case 18:return this._advance(),P.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(P){return P.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(P){return this._check(P)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(P,O){if(this._check(P))return this._advance();throw this._errExpectedButGot(O,this._peek())}_errExpectedButGot(P,O,B){const j=(0,_.localize)(8,null,P,A.Scanner.getLexeme(O)),ee=O.offset,V=A.Scanner.getLexeme(O);return this._parsingErrors.push({message:j,offset:ee,lexeme:V,additionalInfo:B}),C._parseError}_check(P){return this._peek().type===P}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=C;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return a.create(P)}static equals(P,O){return w.create(P,O)}static notEquals(P,O){return E.create(P,O)}static regex(P,O){return H.create(P,O)}static in(P,O){return p.create(P,O)}static notIn(P,O){return d.create(P,O)}static not(P){return L.create(P)}static and(...P){return Y.create(P,null,!0)}static or(...P){return x.create(P,null,!0)}static greater(P,O){return F.create(P,O)}static greaterEquals(P,O){return M.create(P,O)}static smaller(P,O){return W.create(P,O)}static smallerEquals(P,O){return Q.create(P,O)}static{this._parser=new C({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this._parser.parse(P)}}e.ContextKeyExpr=s;function o($){const P=new C({regexParsingWithErrorRecovery:!1});return $.map(O=>(P.parse(O),P.lexingErrors.length>0?P.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,_.localize)(9,null,B.additionalInfo):(0,_.localize)(10,null),offset:B.offset,length:B.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.validateWhenClauses=o;function n($,P){const O=$?$.substituteConstants():void 0,B=P?P.substituteConstants():void 0;return!O&&!B?!0:!O||!B?!1:O.equals(B)}e.expressionsAreEqualWithConstantSubstitution=n;function i($,P){return $.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.ContextKeyTrueExpr=r;class a{static create(P,O=null){const B=I.get(P);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(P,O)}constructor(P,O){this.key=P,this.negated=O,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:te(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=I.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=L.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class w{static create(P,O,B=null){if(typeof O=="boolean")return O?a.create(P,B):L.create(P,B);const j=I.get(P);return typeof j=="boolean"?O===(j?"true":"false")?r.INSTANCE:t.INSTANCE:new w(P,O,B)}constructor(P,O,B){this.key=P,this.value=O,this.negated=B,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:se(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=I.get(this.key);if(typeof P=="boolean"){const O=P?"true":"false";return this.value===O?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class p{static create(P,O){return new p(P,O)}constructor(P,O){this.key=P,this.valueKey=O,this.type=10,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:se(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.valueKey),B=P.getValue(this.key);return Array.isArray(O)?O.includes(B):typeof B=="string"&&typeof O=="object"&&O!==null?D.call(O,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class d{static create(P,O){return new d(P,O)}constructor(P,O){this.key=P,this.valueKey=O,this.type=11,this._negated=p.create(P,O)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class E{static create(P,O,B=null){if(typeof O=="boolean")return O?L.create(P,B):a.create(P,B);const j=I.get(P);return typeof j=="boolean"?O===(j?"true":"false")?t.INSTANCE:r.INSTANCE:new E(P,O,B)}constructor(P,O,B){this.key=P,this.value=O,this.negated=B,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:se(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=I.get(this.key);if(typeof P=="boolean"){const O=P?"true":"false";return this.value===O?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class L{static create(P,O=null){const B=I.get(P);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new L(P,O)}constructor(P,O){this.key=P,this.negated=O,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:te(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=I.get(this.key);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=L;function N($,P){if(typeof $=="string"){const O=parseFloat($);isNaN(O)||($=O)}return typeof $=="string"||typeof $=="number"?P($):t.INSTANCE}class F{static create(P,O,B=null){return N(O,j=>new F(P,j,B))}constructor(P,O,B){this.key=P,this.value=O,this.negated=B,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:se(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=Q.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=F;class M{static create(P,O,B=null){return N(O,j=>new M(P,j,B))}constructor(P,O,B){this.key=P,this.value=O,this.negated=B,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:se(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=M;class W{static create(P,O,B=null){return N(O,j=>new W(P,j,B))}constructor(P,O,B){this.key=P,this.value=O,this.negated=B,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:se(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=W;class Q{static create(P,O,B=null){return N(O,j=>new Q(P,j,B))}constructor(P,O,B){this.key=P,this.value=O,this.negated=B,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:se(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=Q;class H{static create(P,O){return new H(P,O)}constructor(P,O){this.key=P,this.regexp=O,this.type=7,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const O=this.regexp?this.regexp.source:"",B=P.regexp?P.regexp.source:"";return O<B?-1:O>B?1:0}equals(P){if(P.type===this.type){const O=this.regexp?this.regexp.source:"",B=P.regexp?P.regexp.source:"";return this.key===P.key&&O===B}return!1}substituteConstants(){return this}evaluate(P){const O=P.getValue(this.key);return this.regexp?this.regexp.test(O):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=X.create(this)),this.negated}}e.ContextKeyRegexExpr=H;class X{static create(P){return new X(P)}constructor(P){this._actual=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(P){return new X(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=X;function z($){let P=null;for(let O=0,B=$.length;O<B;O++){const j=$[O].substituteConstants();if($[O]!==j&&P===null){P=[];for(let ee=0;ee<O;ee++)P[ee]=$[ee]}P!==null&&(P[O]=j)}return P===null?$:P}class Y{static create(P,O,B){return Y._normalizeArr(P,O,B)}constructor(P,O){this.expr=P,this.negated=O,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,B=this.expr.length;O<B;O++){const j=i(this.expr[O],P.expr[O]);if(j!==0)return j}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,B=this.expr.length;O<B;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=z(this.expr);return P===this.expr?this:Y.create(P,this.negated,!1)}evaluate(P){for(let O=0,B=this.expr.length;O<B;O++)if(!this.expr[O].evaluate(P))return!1;return!0}static _normalizeArr(P,O,B){const j=[];let ee=!1;for(const V of P)if(V){if(V.type===1){ee=!0;continue}if(V.type===0)return t.INSTANCE;if(V.type===6){j.push(...V.expr);continue}j.push(V)}if(j.length===0&&ee)return r.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(i);for(let V=1;V<j.length;V++)j[V-1].equals(j[V])&&(j.splice(V,1),V--);if(j.length===1)return j[0];for(;j.length>1;){const V=j[j.length-1];if(V.type!==9)break;j.pop();const K=j.pop(),ie=j.length===0,ce=x.create(V.expr.map(oe=>Y.create([oe,K],null,B)),null,ie);ce&&(j.push(ce),j.sort(i))}if(j.length===1)return j[0];if(B){for(let V=0;V<j.length;V++)for(let K=V+1;K<j.length;K++)if(j[V].negate().equals(j[K]))return t.INSTANCE;if(j.length===1)return j[0]}return new Y(j,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new Y(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.negated){const P=[];for(const O of this.expr)P.push(O.negate());this.negated=x.create(P,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class x{static create(P,O,B){return x._normalizeArr(P,O,B)}constructor(P,O){this.expr=P,this.negated=O,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let O=0,B=this.expr.length;O<B;O++){const j=i(this.expr[O],P.expr[O]);if(j!==0)return j}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let O=0,B=this.expr.length;O<B;O++)if(!this.expr[O].equals(P.expr[O]))return!1;return!0}return!1}substituteConstants(){const P=z(this.expr);return P===this.expr?this:x.create(P,this.negated,!1)}evaluate(P){for(let O=0,B=this.expr.length;O<B;O++)if(this.expr[O].evaluate(P))return!0;return!1}static _normalizeArr(P,O,B){let j=[],ee=!1;if(P){for(let V=0,K=P.length;V<K;V++){const ie=P[V];if(ie){if(ie.type===0){ee=!0;continue}if(ie.type===1)return r.INSTANCE;if(ie.type===9){j=j.concat(ie.expr);continue}j.push(ie)}}if(j.length===0&&ee)return t.INSTANCE;j.sort(i)}if(j.length!==0){if(j.length===1)return j[0];for(let V=1;V<j.length;V++)j[V-1].equals(j[V])&&(j.splice(V,1),V--);if(j.length===1)return j[0];if(B){for(let V=0;V<j.length;V++)for(let K=V+1;K<j.length;K++)if(j[V].negate().equals(j[K]))return r.INSTANCE;if(j.length===1)return j[0]}return new x(j,O)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const O of this.expr)P.push(...O.keys());return P}map(P){return new x(this.expr.map(O=>O.map(P)),null)}negate(){if(!this.negated){const P=[];for(const O of this.expr)P.push(O.negate());for(;P.length>1;){const O=P.shift(),B=P.shift(),j=[];for(const ee of G(O))for(const V of G(B))j.push(Y.create([ee,V],null,!1));P.unshift(x.create(j,null,!1))}this.negated=x.create(P,this,!0)}return this.negated}}e.ContextKeyOrExpr=x;class q extends a{static{this._info=[]}static all(){return q._info.values()}constructor(P,O,B){super(P,null),this._defaultValue=O,typeof B=="object"?q._info.push({...B,key:P}):B!==!0&&q._info.push({key:P,description:B,type:O!=null?typeof O:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return w.create(this.key,P)}notEqualsTo(P){return E.create(this.key,P)}}e.RawContextKey=q,e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function te($,P){return $<P?-1:$>P?1:0}function se($,P,O,B){return $<O?-1:$>O?1:P<B?-1:P>B?1:0}function Z($,P){if($.type===0||P.type===1)return!0;if($.type===9)return P.type===9?re($.expr,P.expr):!1;if(P.type===9){for(const O of P.expr)if(Z($,O))return!0;return!1}if($.type===6){if(P.type===6)return re(P.expr,$.expr);for(const O of $.expr)if(Z(O,P))return!0;return!1}return $.equals(P)}e.implies=Z;function re($,P){let O=0,B=0;for(;O<$.length&&B<P.length;){const j=$[O].cmp(P[B]);if(j<0)return!1;j===0&&O++,B++}return O===$.length}function G($){return $.type===9?$.expr:[$]}}),define(le[95],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function U(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=U;class A{async getPerformanceInfo(_,R){return{}}async getSystemInfo(_,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,R){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=A}),define(le[96],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(le[14],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(le[29],ue([0,1,152,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function A(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function T(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function _(l,h){switch(l){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":h==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function R(l,h){return h==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function I(l,h,u){return R(h,u)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===u}e.isTargetPlatformCompatible=I;function S(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=S;var D;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var b;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var g;(function(l){l.Install="install",l.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var c;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var f;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var y;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class v extends Error{constructor(h,u){super(h),this.code=u,this.name=u}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,k.localize)(1,null),original:"Preferences"}}),define(le[188],ue([0,1,3,2,30,10,92,29]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(v,l){return v?T.URI.revive(l?l.transformIncoming(v):v):void 0}function S(v,l){return l?l.transformOutgoingURI(v):v}function D(v,l){l=l||_.DefaultURITransformer;const h=v.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...v,manifest:void 0},l),manifest:h}}function b(v,l){return v?.profileLocation?(0,_.transformAndReviveIncomingURIs)(v,l??_.DefaultURITransformer):v}function g(v,l){return l?(0,A.cloneAndChange)(v,h=>h instanceof T.URI?l.transformOutgoingURI(h):void 0):v}class c{constructor(l,h){this.service=l,this.getUriTransformer=h,this.onInstallExtension=k.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,h){const u=this.getUriTransformer(l);switch(h){case"onInstallExtension":return k.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?S(m.profileLocation,u):m.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,m=>m.map(C=>({...C,local:C.local?g(C.local,u):C.local,profileLocation:C.profileLocation?S(C.profileLocation,u):C.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?S(m.profileLocation,u):m.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?S(m.profileLocation,u):m.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,m=>g(m,u))}throw new Error("Invalid listen")}async call(l,h,u){const m=this.getUriTransformer(l);switch(h){case"zip":{const C=D(u[0],m),s=await this.service.zip(C);return S(s,m)}case"unzip":return this.service.unzip(I(u[0],m));case"install":return this.service.install(I(u[0],m),b(u[1],m));case"installFromLocation":return this.service.installFromLocation(I(u[0],m),I(u[1],m));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(u[0],I(u[1],m),I(u[2],m));case"getManifest":return this.service.getManifest(I(u[0],m));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],b(u[1],m));case"installGalleryExtensions":{const C=u[0];return this.service.installGalleryExtensions(C.map(({extension:s,options:o})=>({extension:s,options:b(o,m)??{}})))}case"uninstall":return this.service.uninstall(D(u[0],m),b(u[1],m));case"reinstallFromGallery":return this.service.reinstallFromGallery(D(u[0],m));case"getInstalled":return(await this.service.getInstalled(u[0],I(u[1],m))).map(s=>g(s,m));case"toggleAppliationScope":{const C=await this.service.toggleAppliationScope(D(u[0],m),I(u[1],m));return g(C,m)}case"copyExtensions":return this.service.copyExtensions(I(u[0],m),I(u[1],m));case"updateMetadata":{const C=await this.service.updateMetadata(D(u[0],m),u[1],I(u[2],m));return g(C,m)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(u[0],u[1],u[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=c;class f extends U.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(l){super(),this.channel=l,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this._register(this.channel.listen("onInstallExtension")(h=>this.fireEvent(this._onInstallExtension,{...h,source:this.isUriComponents(h.source)?T.URI.revive(h.source):h.source,profileLocation:T.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(h=>this.fireEvent(this._onDidInstallExtensions,h.map(u=>({...u,local:u.local?D(u.local,null):u.local,source:this.isUriComponents(u.source)?T.URI.revive(u.source):u.source,profileLocation:T.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(h=>this.fireEvent(this._onUninstallExtension,{...h,profileLocation:T.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(h=>this.fireEvent(this._onDidUninstallExtension,{...h,profileLocation:T.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(h=>this._onDidUpdateExtensionMetadata.fire(D(h,null))))}fireEvent(l,h){l.fire(h)}isUriComponents(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(l){const h=await this.getTargetPlatform();return l.allTargetPlatforms.some(u=>(0,R.isTargetPlatformCompatible)(u,l.allTargetPlatforms,h))}zip(l){return Promise.resolve(this.channel.call("zip",[l]).then(h=>T.URI.revive(h)))}unzip(l){return Promise.resolve(this.channel.call("unzip",[l]))}install(l,h){return Promise.resolve(this.channel.call("install",[l,h])).then(u=>D(u,null))}installFromLocation(l,h){return Promise.resolve(this.channel.call("installFromLocation",[l,h])).then(u=>D(u,null))}async installExtensionsFromProfile(l,h,u){return(await this.channel.call("installExtensionsFromProfile",[l,h,u])).map(C=>D(C,null))}getManifest(l){return Promise.resolve(this.channel.call("getManifest",[l]))}installFromGallery(l,h){return Promise.resolve(this.channel.call("installFromGallery",[l,h])).then(u=>D(u,null))}async installGalleryExtensions(l){return(await this.channel.call("installGalleryExtensions",[l])).map(u=>({...u,local:u.local?D(u.local,null):u.local,source:this.isUriComponents(u.source)?T.URI.revive(u.source):u.source,profileLocation:T.URI.revive(u.profileLocation)}))}uninstall(l,h){return Promise.resolve(this.channel.call("uninstall",[l,h]))}reinstallFromGallery(l){return Promise.resolve(this.channel.call("reinstallFromGallery",[l])).then(h=>D(h,null))}getInstalled(l=null,h){return Promise.resolve(this.channel.call("getInstalled",[l,h])).then(u=>u.map(m=>D(m,null)))}updateMetadata(l,h,u){return Promise.resolve(this.channel.call("updateMetadata",[l,h,u])).then(m=>D(m,null))}toggleAppliationScope(l,h){return this.channel.call("toggleAppliationScope",[l,h]).then(u=>D(u,null))}copyExtensions(l,h){return this.channel.call("copyExtensions",[l,h])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(l,h,u){const m=await this.channel.call("download",[l,h,u]);return T.URI.revive(m)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class y{constructor(l){this.service=l}listen(l,h){throw new Error("Invalid listen")}call(l,h,u){switch(h){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(le[97],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class U{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((T,_)=>ne(["node-vsce-sign"],async R=>T(R),_))),this.moduleLoadingPromise}async verify(T,_,R){let I;try{I=await this.vsceSign()}catch{return!1}return I.verify(T,_,R)}}e.ExtensionSignatureVerificationService=U}),define(le[98],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var U;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(U||(e.RecommendationSource=U={}));function A(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var T;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(T||(e.RecommendationsNotificationResult=T={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(le[11],ue([0,1,47,16,27,12,10,159,4,5,23,52]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function g(Z){return Z.create===!0}e.isFileOpenForWriteOptions=g;var c;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var f;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(f||(e.FilePermission=f={}));function y(Z){const re=Z;return!!re&&typeof re.onDidChange=="function"}e.isFileSystemWatcher=y;var v;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function l(Z){return!!(Z.capabilities&2)}e.hasReadWriteCapability=l;function h(Z){return!!(Z.capabilities&8)}e.hasFileFolderCopyCapability=h;function u(Z){return!!(Z.capabilities&131072)}e.hasFileCloneCapability=u;function m(Z){return!!(Z.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function C(Z){return!!(Z.capabilities&16)}e.hasFileReadStreamCapability=C;function s(Z){return l(Z)?!!(Z.capabilities&16384):!1}e.hasFileAtomicReadCapability=s;function o(Z){return l(Z)?!!(Z.capabilities&32768):!1}e.hasFileAtomicWriteCapability=o;function n(Z){return!!(Z.capabilities&65536)}e.hasFileAtomicDeleteCapability=n;function i(Z){return!!(Z.capabilities&2048)}e.hasReadonlyCapability=i;var t;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(re,G){const $=new r(re.toString(),G);return p($,G),$}constructor(re,G){super(re),this.code=G}}e.FileSystemProviderError=r;function a(Z,re){return r.create(Z,re)}e.createFileSystemProviderError=a;function w(Z){return Z||a((0,R.localize)(0,null),t.Unknown)}e.ensureFileSystemProviderError=w;function p(Z,re){return Z.name=re?`${re} (FileSystemError)`:"FileSystemError",Z}e.markAsFileSystemProviderError=p;function d(Z){if(!Z)return t.Unknown;if(Z instanceof r)return Z.code;const re=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!re)return t.Unknown;switch(re[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.toFileSystemProviderErrorCode=d;function E(Z){if(Z instanceof Q)return Z.fileOperationResult;switch(d(Z)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=E;var L;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class N{constructor(re,G,$){this.resource=re,this.operation=G,this.target=$}isOperation(re){return this.operation===re}}e.FileOperationEvent=N;var F;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.MIXED_CORRELATION=null}constructor(re,G){this.ignorePathCasing=G,this.correlationId=void 0,this.added=new b.Lazy(()=>{const $=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return $.fill(this.rawAdded.map(P=>[P,!0])),$}),this.updated=new b.Lazy(()=>{const $=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return $.fill(this.rawUpdated.map(P=>[P,!0])),$}),this.deleted=new b.Lazy(()=>{const $=k.TernarySearchTree.forUris(()=>this.ignorePathCasing);return $.fill(this.rawDeleted.map(P=>[P,!0])),$}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const $ of re){switch($.type){case 1:this.rawAdded.push($.resource);break;case 0:this.rawUpdated.push($.resource);break;case 2:this.rawDeleted.push($.resource);break}this.correlationId!==M.MIXED_CORRELATION&&(typeof $.cId=="number"?this.correlationId===void 0?this.correlationId=$.cId:this.correlationId!==$.cId&&(this.correlationId=M.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=M.MIXED_CORRELATION))}}contains(re,...G){return this.doContains(re,{includeChildren:!1},...G)}affects(re,...G){return this.doContains(re,{includeChildren:!0},...G)}doContains(re,G,...$){if(!re)return!1;const P=$.length>0;return!!((!P||$.includes(1))&&(this.added.value.get(re)||G.includeChildren&&this.added.value.findSuperstr(re))||(!P||$.includes(0))&&(this.updated.value.get(re)||G.includeChildren&&this.updated.value.findSuperstr(re))||(!P||$.includes(2))&&(this.deleted.value.findSubstr(re)||G.includeChildren&&this.deleted.value.findSuperstr(re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(re){return this.correlationId===re}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=M;function W(Z,re,G){return!Z||!re||Z===re||re.length>Z.length?!1:(re.charAt(re.length-1)!==U.sep&&(re+=U.sep),G?(0,A.startsWithIgnoreCase)(Z,re):Z.indexOf(re)===0)}e.isParent=W;class Q extends Error{constructor(re,G,$){super(re),this.fileOperationResult=G,this.options=$}}e.FileOperationError=Q;class H extends Q{constructor(re,G,$,P){super(re,G,P),this.fileOperationResult=G,this.size=$}}e.TooLargeFileOperationError=H;class X extends Q{constructor(re,G,$){super(re,2,$),this.stat=G}}e.NotModifiedSinceFileOperationError=X;var z;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Y;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.ETAG_DISABLED="";function x(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.etag=x;async function q(Z,re){if(!re.hasProvider(_.URI.from({scheme:Z.scheme})))return new Promise(G=>{const $=re.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===Z.scheme&&P.added&&($.dispose(),G())})})}e.whenProviderRegistered=q;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(re){return(0,T.isNumber)(re)||(re=0),re<te.KB?(0,R.localize)(1,null,re.toFixed(0)):re<te.MB?(0,R.localize)(2,null,(re/te.KB).toFixed(2)):re<te.GB?(0,R.localize)(3,null,(re/te.MB).toFixed(2)):re<te.TB?(0,R.localize)(4,null,(re/te.GB).toFixed(2)):(0,R.localize)(5,null,(re/te.TB).toFixed(2))}}e.ByteSize=te;function se(Z){const re=typeof Z=="string"||Z?.scheme===D.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===D.Schemas.file?1024*te.MB:re?10*te.MB:S.isWeb?50*te.MB:1024*te.MB}e.getLargeFileConfirmationLimit=se});var J=this&&this.__param||function(ne,e){return function(k,U){e(k,U,ne)}};define(le[189],ue([0,1,72,46,11]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const I=(await this.fileService.readFileStream(R)).value;return new Promise((S,D)=>{const b=(0,k.createHash)("md5");(0,U.listenStream)(I,{onData:g=>b.update(g.buffer),onError:g=>D(g),onEnd:()=>S(b.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=T,e.ChecksumService=T=ye([J(0,A.IFileService)],T)}),define(le[99],ue([0,1,15,7,160,11]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(D,b,g,c,f,y){let v;try{await R(D,b,g,c,f,y)}catch(l){v=l}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&g.error(v),g.end()}}e.readFileIntoStream=_;async function R(D,b,g,c,f,y){I(y);const v=await D.open(b,{create:!1});try{I(y);let l=0,h=0,u=f&&typeof f.length=="number"?f.length:void 0,m=k.VSBuffer.alloc(Math.min(f.bufferSize,typeof u=="number"?u:f.bufferSize)),C=f&&typeof f.position=="number"?f.position:0,s=0;do h=await D.read(v,C,m.buffer,s,m.byteLength-s),C+=h,s+=h,l+=h,typeof u=="number"&&(u-=h),s===m.byteLength&&(await g.write(c(m)),m=k.VSBuffer.alloc(Math.min(f.bufferSize,typeof u=="number"?u:f.bufferSize)),s=0);while(h>0&&(typeof u!="number"||u>0)&&I(y)&&S(l,f));if(s>0){let o=s;typeof u=="number"&&(o=Math.min(s,u)),g.write(c(m.slice(0,o)))}}catch(l){throw(0,T.ensureFileSystemProviderError)(l)}finally{await D.close(v)}}function I(D){if(D.isCancellationRequested)throw(0,U.canceled)();return!0}function S(D,b){if(typeof b?.limits?.size=="number"&&D>b.limits.size)throw(0,T.createFileSystemProviderError)((0,A.localize)(0,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[49],ue([0,1,91,2,16,5,10,11]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(l){return l.recursive===!0}e.isRecursiveWatchRequest=I;class S extends U.Disposable{static{this.MAX_RESTARTS=5}constructor(h,u,m,C){super(),this.onFileChanges=h,this.onLogMessage=u,this.verboseLogging=m,this.options=C,this.watcherDisposables=this._register(new U.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new U.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),h.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),h.add(this.watcher.onDidError(u=>this.onError(u)))}onError(h){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}trace(h){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S;class D extends S{constructor(h,u,m){super(h,u,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class b extends S{constructor(h,u,m){super(h,u,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function g(l){return l.map(h=>({type:h.type,resource:_.URI.revive(h.resource),cId:h.cId}))}e.reviveFileChanges=g;function c(l){const h=new v;for(const u of l)h.processEvent(u);return h.coalesce()}e.coalesceEvents=c;function f(l,h){return typeof h=="string"&&!h.startsWith(k.GLOBSTAR)&&!(0,A.isAbsolute)(h)?{base:l,pattern:h}:h}e.normalizeWatcherPattern=f;function y(l,h){const u=[];for(const m of h)u.push((0,k.parse)(f(l,m)));return u}e.parseWatcherPatterns=y;class v{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return T.isLinux?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const u=this.mapPathToChange.get(this.toKey(h));let m=!1;if(u){const C=u.type,s=h.type;u.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?m=!0:C===1&&s===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(u)):C===2&&s===1?u.type=0:C===1&&s===0||(u.type=s)}else m=!0;m&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],u=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(h.push(m),!1):!0).sort((m,C)=>m.resource.fsPath.length-C.resource.fsPath.length).filter(m=>u.some(C=>(0,R.isParent)(m.resource.fsPath,C,!T.isLinux))?!1:(u.push(m.resource.fsPath),!0)).concat(h)}}}),define(le[190],ue([0,1,15,38,7,3,2,46,32,11,49]),function(ne,e,k,U,A,T,_,R,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends _.Disposable{constructor(c,f){super(),this.channel=c,this.extraCapabilities=f,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(c){return this.channel.call("stat",[c])}readdir(c){return this.channel.call("readdir",[c])}async readFile(c,f){const{buffer:y}=await this.channel.call("readFile",[c,f]);return y}readFileStream(c,f,y){const v=(0,R.newWriteableStream)(h=>k.VSBuffer.concat(h.map(u=>k.VSBuffer.wrap(u))).buffer),l=new _.DisposableStore;return l.add(this.channel.listen("readFileStream",[c,f])(h=>{if(h instanceof k.VSBuffer)v.write(h.buffer);else{if(h==="end")v.end();else{let u;if(h instanceof Error)u=h;else{const m=h;u=(0,S.createFileSystemProviderError)(m.message??(0,U.toErrorMessage)(m),m.code??S.FileSystemProviderErrorCode.Unknown)}v.error(u),v.end()}l.dispose()}})),l.add(y.onCancellationRequested(()=>{v.error((0,A.canceled)()),v.end(),l.dispose()})),v}writeFile(c,f,y){return this.channel.call("writeFile",[c,k.VSBuffer.wrap(f),y])}open(c,f){return this.channel.call("open",[c,f])}close(c){return this.channel.call("close",[c])}async read(c,f,y,v,l){const[h,u]=await this.channel.call("read",[c,f,l]);return y.set(h.buffer.slice(0,u),v),u}write(c,f,y,v,l){return this.channel.call("write",[c,f,k.VSBuffer.wrap(y),v,l])}mkdir(c){return this.channel.call("mkdir",[c])}delete(c,f){return this.channel.call("delete",[c,f])}rename(c,f,y){return this.channel.call("rename",[c,f,y])}copy(c,f,y){return this.channel.call("copy",[c,f,y])}cloneFile(c,f){return this.channel.call("cloneFile",[c,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(c=>{if(Array.isArray(c)){const f=c;this._onDidChange.fire((0,D.reviveFileChanges)(f))}else{const f=c;this._onDidWatchError.fire(f)}}))}watch(c,f){const y=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,y,c,f]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=b}),define(le[191],ue([0,1,54,6,26,48,2,88,16,5,19,10,143,31,49]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends _.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(h,u,m,C){super(),this.request=h,this.onDidFilesChange=u,this.onLogMessage=m,this.verboseLogging=C,this.throttledFileChangesEmitter=this._register(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.onDidFilesChange(s))),this.fileChangesAggregator=this._register(new U.RunOnceWorker(s=>this.handleFileChanges(s),y.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,f.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,f.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new A.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await c.Promises.stat(h);this._register(await this.doWatch(h,u.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(h)}}async normalizePath(h){let u=h.path;try{u=await c.Promises.realpath(h.path),h.path===u&&(u=await(0,g.realcase)(h.path)??h.path),h.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${u})`)}catch{}return u}async doWatch(h,u){if(S.isMacintosh&&(0,T.isEqualOrParent)(h,"/Volumes/",!0))return this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const m=new A.CancellationTokenSource(this.cts.token),C=new _.DisposableStore;try{const s=b.URI.file(this.request.path),o=(0,I.basename)(h),n=(0,k.watch)(h);C.add((0,_.toDisposable)(()=>{n.removeAllListeners(),n.close()})),this.trace(`Started watching: '${h}'`);const i=new Set;if(u)try{for(const r of await c.Promises.readdir(h))i.add(r)}catch(r){this.error(r)}const t=new Map;C.add((0,_.toDisposable)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.error(`Failed to watch ${h} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${a}`);let w="";if(a&&(w=a.toString(),S.isMacintosh&&(w=(0,R.normalizeNFC)(w))),!(!w||r!=="change"&&r!=="rename"))if(u)if(r==="rename"){t.get(w)?.dispose();const p=setTimeout(async()=>{if(t.delete(w),w===o&&!await c.Promises.exists(h)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const d=await this.existsChildStrictCase((0,I.join)(h,w));if(m.token.isCancellationRequested)return;let E;d?i.has(w)?E=0:(E=1,i.add(w)):(i.delete(w),E=2),this.onFileChange({resource:(0,D.joinPath)(s,w),type:E,cId:this.request.correlationId})},y.FILE_DELETE_HANDLER_DELAY);t.set(w,(0,_.toDisposable)(()=>clearTimeout(p)))}else{let p;i.has(w)?p=0:(p=1,i.add(w)),this.onFileChange({resource:(0,D.joinPath)(s,w),type:p,cId:this.request.correlationId})}else if(r==="rename"||w!==o){const p=setTimeout(async()=>{const d=await c.Promises.exists(h);m.token.isCancellationRequested||(d?(this.onFileChange({resource:s,type:0,cId:this.request.correlationId},!0),C.add(await this.doWatch(h,!1))):(this.onFileChange({resource:s,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);C.clear(),C.add((0,_.toDisposable)(()=>clearTimeout(p)))}else this.onFileChange({resource:s,type:0,cId:this.request.correlationId},!0)})}catch(s){await c.Promises.exists(h)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${h} for changes using fs.watch() (${s.toString()})`)}return(0,_.toDisposable)(()=>{m.dispose(!0),C.dispose()})}onFileChange(h,u=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!u&&this.excludes.some(m=>m(h.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${h.resource.fsPath}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(h.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${h.resource.fsPath}`):this.fileChangesAggregator.work(h))}handleFileChanges(h){const u=(0,f.coalesceEvents)(h);if(u.length>0){if(this.verboseLogging)for(const C of u)this.trace(` >> normalized ${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.resource.fsPath}`);this.throttledFileChangesEmitter.work(u)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(h){if(S.isLinux)return c.Promises.exists(h);try{const u=(0,I.basename)(h);return(await c.Promises.readdir((0,I.dirname)(h))).some(C=>C===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y;async function v(l,h,u,m,C=512){const s=await c.Promises.open(l,"r"),o=Buffer.allocUnsafe(C),n=new A.CancellationTokenSource(m);let i,t=!1;const r={path:l,excludes:[],recursive:!1},a=new y(r,w=>{(async()=>{for(const{type:p}of w)if(p===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:d}=await c.Promises.read(s,o,0,C,null);if(!d||n.token.isCancellationRequested)break;h(o.slice(0,d))}}catch(d){i=new Error(d),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,u(),new Promise((w,p)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(s)}catch(d){i=new Error(d)}i?p(i):w()})})}e.watchFileContents=v}),define(le[192],ue([0,1,3,91,2,5,191]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends A.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new k.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=k.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const D=this.normalizeRequests(S),b=D.filter(c=>{const f=this.watchers.get(c.path);return f?!(0,U.patternsEquals)(f.request.excludes,c.excludes)||!(0,U.patternsEquals)(f.request.includes,c.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:c})=>!D.find(f=>f.path===c.path&&(0,U.patternsEquals)(f.excludes,c.excludes)&&(0,U.patternsEquals)(f.includes,c.includes))).map(({request:c})=>c.path);b.length&&this.trace(`Request to start watching: ${b.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const c of g)this.stopWatching(c);for(const c of b)this.startWatching(c)}startWatching(S){const D=new _.NodeJSFileWatcherLibrary(S,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),b={request:S,instance:D};this.watchers.set(S.path,b)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const D=this.watchers.get(S);D&&(this.watchers.delete(S),D.instance.dispose())}normalizeRequests(S){const D=new Map;for(const b of S){const g=T.isLinux?b.path:b.path.toLowerCase();let c=D.get(b.correlationId);c||(c=new Map,D.set(b.correlationId,c)),c.set(g,b)}return Array.from(D.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(S){this.verboseLogging=S;for(const[,D]of this.watchers)D.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,D){return D?`[File Watcher (node.js)] ${S} (path: ${D.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=R}),define(le[193],ue([0,1,49,192]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class A extends k.AbstractNonRecursiveWatcherClient{constructor(_,R,I){super(_,R,I),this.init()}createWatcher(_){return _.add(new U.NodeJSWatcher)}}e.NodeJSWatcherClient=A}),define(le[194],ue([0,1,23,40,93,49]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends T.AbstractUniversalWatcherClient{constructor(I,S,D){super(I,S,D),this.init()}createWatcher(I){const S=I.add(new A.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(S.onDidProcessExit(({code:D,signal:b})=>this.onError(`terminated by itself with code ${D}, signal: ${b}`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(le[73],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...A){this._entries=new Map;for(const[T,_]of A)this.set(T,_)}set(A,T){const _=this._entries.get(A);return this._entries.set(A,T),_}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=k}),define(le[195],ue([0,1,6,7,2,71,186,4,73,87]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class b extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class g{constructor(v=new I.ServiceCollection,l=!1,h,u=D){this._services=v,this._strict=l,this._parent=h,this._enableTracing=u,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=u?h?._globalGraph??new _.Graph(m=>m):void 0}createChild(v){return new g(v,this._strict,this,this._enableTracing)}invokeFunction(v,...l){const h=f.traceInvocation(this._enableTracing,v);let u=!1;try{return v({get:C=>{if(u)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(C,h);if(!s)throw new Error(`[invokeFunction] unknown service '${C}'`);return s}},...l)}finally{u=!0,h.stop()}}createInstance(v,...l){let h,u;return v instanceof T.SyncDescriptor?(h=f.traceCreation(this._enableTracing,v.ctor),u=this._createInstance(v.ctor,v.staticArguments.concat(l),h)):(h=f.traceCreation(this._enableTracing,v),u=this._createInstance(v,l,h)),h.stop(),u}_createInstance(v,l=[],h){const u=R._util.getServiceDependencies(v).sort((s,o)=>s.index-o.index),m=[];for(const s of u){const o=this._getOrCreateServiceInstance(s.id,h);o||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${s.id}.`,!1),m.push(o)}const C=u.length>0?u[0].index:l.length;if(l.length!==C){console.trace(`[createInstance] First service dependency of ${v.name} at position ${C+1} conflicts with ${l.length} static arguments`);const s=C-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,C)}return Reflect.construct(v,l.concat(m))}_setServiceInstance(v,l){if(this._services.get(v)instanceof T.SyncDescriptor)this._services.set(v,l);else if(this._parent)this._parent._setServiceInstance(v,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const l=this._services.get(v);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):l}_getOrCreateServiceInstance(v,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const h=this._getServiceInstanceOrDescriptor(v);return h instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,h,l.branch(v,!0)):(l.branch(v,!1),h)}_safeCreateAndCacheServiceInstance(v,l,h){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,l,h)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,l,h){const u=new _.Graph(s=>s.id.toString());let m=0;const C=[{id:v,desc:l,_trace:h}];for(;C.length;){const s=C.pop();if(u.lookupOrInsertNode(s),m++>1e3)throw new b(u);for(const o of R._util.getServiceDependencies(s.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),n instanceof T.SyncDescriptor){const i={id:o.id,desc:n,_trace:s._trace.branch(o.id,!0)};u.insertEdge(s,i),C.push(i)}}}for(;;){const s=u.roots();if(s.length===0){if(!u.isEmpty())throw new b(u);break}for(const{data:o}of s){if(this._getServiceInstanceOrDescriptor(o.id)instanceof T.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}u.removeNode(o)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,l,h=[],u,m){if(this._services.get(v)instanceof T.SyncDescriptor)return this._createServiceInstance(v,l,h,u,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,l,h,u,m);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(v,l,h=[],u,m){if(u){const C=new g(void 0,this._strict,this,this._enableTracing);C._globalGraphImplicitDependency=String(v);const s=new Map,o=new k.GlobalIdleValue(()=>{const n=C._createInstance(l,h,m);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const a of t)r.apply(n,a)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=s.get(i);return a||(a=new S.LinkedList,s.set(i,a)),(p,d,E)=>{const L=a.push([p,d,E]);return(0,A.toDisposable)(L)}}if(i in n)return n[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return o.value[i]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this._createInstance(l,h,m)}_throwIfStrict(v,l){if(l&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=g;var c;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(c||(c={}));class f{static{this.all=new Set}static{this._None=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(v,l){return v?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(v,l){return v?new f(1,l.name):f._None}static{this._totals=0}constructor(v,l){this.type=v,this.name=l,this._start=Date.now(),this._dep=[]}branch(v,l){const h=new f(3,v.toString());return this._dep.push([v,l,h]),h}stop(){const v=Date.now()-this._start;f._totals+=v;let l=!1;function h(m,C){const s=[],o=new Array(m+1).join("	");for(const[n,i,t]of C._dep)if(i&&t){l=!0,s.push(`${o}CREATES -> ${n}`);const r=h(m+1,t);r&&s.push(r)}else s.push(`${o}uses -> ${n}`);return s.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(v>2||l)&&f.all.add(u.join(`
`))}}e.Trace=f}),define(le[56],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,k.createDecorator)("mainProcessService");class U{constructor(T,_){this.server=T,this.router=_}getChannel(T){return this.server.getChannel(T,this.router)}registerChannel(T,_){this.server.registerChannel(T,_)}}e.MainProcessService=U}),define(le[74],ue([0,1,26,2,5,162,29,4]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(D){return D.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let S=class extends U.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new k.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let g;try{g=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const f=g.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(v=>v.startsWith("lp-"))).map(y=>{const v=y.properties.localizedLanguages?.[0],l=I(y);return{...this.createQuickPickItem(l,v,y),extensionId:y.identifier.id,galleryExtension:y}});return f.push(this.createQuickPickItem("en","English")),f}createQuickPickItem(b,g,c){const f=g??b;let y;if(f!==b&&(y=`(${b})`),b.toLowerCase()===A.language.toLowerCase()&&(y??="",y+=(0,T.localize)(0,null)),c?.installCount){y??="";const v=c.installCount;let l;v>1e6?l=`${Math.floor(v/1e5)/10}M`:v>1e3?l=`${Math.floor(v/1e3)}K`:l=String(v),y+=` $(cloud-download) ${l}`}return{id:b,label:f,description:y}}};e.LanguagePackBaseService=S,e.LanguagePackBaseService=S=ye([J(0,_.IExtensionGalleryService)],S)}),define(le[196],ue([0,1,2,74]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends k.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=A,e.LocalizationsUpdater=A=ye([J(0,U.ILanguagePackService)],A)}),define(le[8],ue([0,1,38,3,53,2,34,5,19,12,10,94,4]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function c(){return new Date().toISOString()}function f(p){return(0,S.isNumber)(p)}e.isLogLevel=f;var y;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(y||(e.LogLevel=y={})),e.DEFAULT_LOG_LEVEL=y.Info;function v(p,d,E){switch(d){case y.Trace:p.trace(E);break;case y.Debug:p.debug(E);break;case y.Info:p.info(E);break;case y.Warning:p.warn(E);break;case y.Error:p.error(E);break;case y.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=v;function l(p,d=!1){let E="";for(let L=0;L<p.length;L++){let N=p[L];if(N instanceof Error&&(N=(0,k.toErrorMessage)(N,d)),typeof N=="object")try{N=JSON.stringify(N)}catch{}E+=(L>0?" ":"")+N}return E}class h extends T.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new U.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(d){this.level!==d&&(this.level=d,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(d){return this.level!==y.Off&&this.level<=d}}e.AbstractLogger=h;class u extends h{constructor(d){super(),this.logAlways=d}checkLogLevel(d){return this.logAlways||super.checkLogLevel(d)}trace(d,...E){this.checkLogLevel(y.Trace)&&this.log(y.Trace,l([d,...E],!0))}debug(d,...E){this.checkLogLevel(y.Debug)&&this.log(y.Debug,l([d,...E]))}info(d,...E){this.checkLogLevel(y.Info)&&this.log(y.Info,l([d,...E]))}warn(d,...E){this.checkLogLevel(y.Warning)&&this.log(y.Warning,l([d,...E]))}error(d,...E){if(this.checkLogLevel(y.Error))if(d instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=d.stack,this.log(y.Error,l(L))}else this.log(y.Error,l([d,...E]))}flush(){}}e.AbstractMessageLogger=u;class m extends h{constructor(d=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(d),this.useColors=!R.isWindows}trace(d,...E){this.checkLogLevel(y.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...E):console.log(`[main ${c()}]`,d,...E))}debug(d,...E){this.checkLogLevel(y.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...E):console.log(`[main ${c()}]`,d,...E))}info(d,...E){this.checkLogLevel(y.Info)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...E):console.log(`[main ${c()}]`,d,...E))}warn(d,...E){this.checkLogLevel(y.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,d,...E):console.warn(`[main ${c()}]`,d,...E))}error(d,...E){this.checkLogLevel(y.Error)&&(this.useColors?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,d,...E):console.error(`[main ${c()}]`,d,...E))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class C extends h{constructor(d=e.DEFAULT_LOG_LEVEL,E=!0){super(),this.useColors=E,this.setLevel(d)}trace(d,...E){this.checkLogLevel(y.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",d,...E):console.log(d,...E))}debug(d,...E){this.checkLogLevel(y.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",d,...E):console.log(d,...E))}info(d,...E){this.checkLogLevel(y.Info)&&(this.useColors?console.log("%c INFO","color: #33f",d,...E):console.log(d,...E))}warn(d,...E){this.checkLogLevel(y.Warning)&&(this.useColors?console.log("%c WARN","color: #993",d,...E):console.log(d,...E))}error(d,...E){this.checkLogLevel(y.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",d,...E):console.error(d,...E))}dispose(){}flush(){}}e.ConsoleLogger=C;class s extends h{constructor(d,E=e.DEFAULT_LOG_LEVEL){super(),this.adapter=d,this.setLevel(E)}trace(d,...E){this.checkLogLevel(y.Trace)&&this.adapter.log(y.Trace,[this.extractMessage(d),...E])}debug(d,...E){this.checkLogLevel(y.Debug)&&this.adapter.log(y.Debug,[this.extractMessage(d),...E])}info(d,...E){this.checkLogLevel(y.Info)&&this.adapter.log(y.Info,[this.extractMessage(d),...E])}warn(d,...E){this.checkLogLevel(y.Warning)&&this.adapter.log(y.Warning,[this.extractMessage(d),...E])}error(d,...E){this.checkLogLevel(y.Error)&&this.adapter.log(y.Error,[this.extractMessage(d),...E])}extractMessage(d){return typeof d=="string"?d:(0,k.toErrorMessage)(d,this.checkLogLevel(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=s;class o extends h{constructor(d){super(),this.loggers=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const E of this.loggers)E.setLevel(d);super.setLevel(d)}trace(d,...E){for(const L of this.loggers)L.trace(d,...E)}debug(d,...E){for(const L of this.loggers)L.debug(d,...E)}info(d,...E){for(const L of this.loggers)L.info(d,...E)}warn(d,...E){for(const L of this.loggers)L.warn(d,...E)}error(d,...E){for(const L of this.loggers)L.error(d,...E)}flush(){for(const d of this.loggers)d.flush()}dispose(){for(const d of this.loggers)d.dispose()}}e.MultiplexLogger=o;class n extends T.Disposable{constructor(d,E,L){if(super(),this.logLevel=d,this.logsHome=E,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new U.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new U.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new U.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,L)for(const N of L)this._loggers.set(N.resource,{logger:void 0,info:N})}getLoggerEntry(d){return(0,S.isString)(d)?[...this._loggers.values()].find(E=>E.info.id===d):this._loggers.get(d)}getLogger(d){return this.getLoggerEntry(d)?.logger}createLogger(d,E){const L=this.toResource(d),N=(0,S.isString)(d)?d:E?.id??(0,A.hash)(L.toString()).toString(16);let F=this._loggers.get(L)?.logger;const M=E?.logLevel==="always"?y.Trace:E?.logLevel;F||(F=this.doCreateLogger(L,M??this.getLogLevel(L)??this.logLevel,{...E,id:N}));const W={logger:F,info:{resource:L,id:N,logLevel:M,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(W.info),this._loggers.set(L,W),F}toResource(d){return(0,S.isString)(d)?(0,I.joinPath)(this.logsHome,`${d}.log`):d}setLogLevel(d,E){if(D.URI.isUri(d)){const L=d,N=E,F=this._loggers.get(L);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.logLevel?void 0:N,F.logger?.setLevel(N),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([L,N]))}else{this.logLevel=d;for(const[L,N]of this._loggers.entries())this._loggers.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(d,E){const L=this.getLoggerEntry(d);L&&E!==!L.info.hidden&&(L.info.hidden=!E,this._loggers.set(L.info.resource,L),this._onDidChangeVisibility.fire([L.info.resource,E]))}getLogLevel(d){let E;return d&&(E=this._loggers.get(d)?.info.logLevel),E??this.logLevel}registerLogger(d){const E=this._loggers.get(d.resource);E?E.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this._loggers.set(d.resource,{info:d,logger:void 0}),this._onDidChangeLoggers.fire({added:[d],removed:[]}))}deregisterLogger(d){const E=this._loggers.get(d);E&&(E.logger&&E.logger.dispose(),this._loggers.delete(d),this._onDidChangeLoggers.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const d of this._loggers.values())yield d.info}getRegisteredLogger(d){return this._loggers.get(d)?.info}dispose(){this._loggers.forEach(d=>d.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class i{constructor(){this.onDidChangeLogLevel=new U.Emitter().event}setLevel(d){}getLevel(){return y.Info}trace(d,...E){}debug(d,...E){}info(d,...E){}warn(d,...E){}error(d,...E){}critical(d,...E){}dispose(){}flush(){}}e.NullLogger=i;class t extends i{}e.NullLogService=t;function r(p){if(p.verbose)return y.Trace;if(typeof p.logLevel=="string"){const d=w(p.logLevel.toLowerCase());if(d!==void 0)return d}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(p){switch(p){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=a;function w(p){switch(p){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=w,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",a(y.Info))}),define(le[197],ue([0,1,6,7,2,23,16,19,31,14,8]),function(ne,e,k,U,A,T,_,R,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends A.Disposable{constructor(c,f){super(),this.environmentService=c,this.logService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,R.basename)(this.environmentService.logsHome),f=(0,R.dirname)(this.environmentService.logsHome.with({scheme:T.Schemas.file})).fsPath,l=(await I.Promises.readdir(f)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==c),h=l.slice(0,Math.max(0,l.length-9));h.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(u=>I.Promises.rm((0,_.join)(f,u)))))}catch(c){(0,U.onUnexpectedError)(c)}}};e.LogsDataCleaner=b,e.LogsDataCleaner=b=ye([J(0,S.IEnvironmentService),J(1,D.ILogService)],b)}),define(le[198],ue([0,1,18,6,7,3,2,16,49,8]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends _.Disposable{constructor(g,c){super(),this.logService=g,this.options=c,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new U.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new U.ThrottledDelayer(0))}watch(g,c){return c.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,c):this.watchNonRecursive(g,c)}watchUniversal(g,c){const f={path:this.toFilePath(g),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},y=(0,k.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,A.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(c=>this._onDidChangeFile.fire((0,I.reviveFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const c of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(c)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const c of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(c)&&g.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,c){const f={path:this.toFilePath(g),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},y=(0,k.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,A.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,I.reviveFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,R.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(le[199],ue([0,1,18,6,15,26,3,53,61,2,47,23,100,19,46,158,11,99,8,7]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends S.Disposable{static{m=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new _.Emitter),this._onDidUncorrelatedFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new U.ResourceQueue)}registerProvider(o,n){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${o}`);const i=new S.DisposableStore;return this.provider.set(o,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new v.FileChangesEvent(t,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(r),r.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:o}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:n}),this.provider.delete(o),(0,S.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){n.push(i)}}),!this.provider.has(o)&&await U.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,n){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return I.Iterable.map(this.provider,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async withProvider(o){if(!(0,c.isAbsolutePath)(o))throw new v.FileOperationError((0,y.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const n=this.provider.get(o.scheme);if(!n){const i=new u.ErrorNoTelemetry;throw i.message=(0,y.localize)(1,null,o.toString()),i}return n}async withReadProvider(o){const n=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)||(0,v.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const n=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.doResolveFile(o,n)}catch(i){throw(0,v.toFileSystemProviderErrorCode)(i)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,y.localize)(2,null,this.resourceForError(o)),1):(0,v.ensureFileSystemProviderError)(i)}}async doResolveFile(o,n){const i=await this.withProvider(o),t=this.isPathCaseSensitive(i),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,w=n?.resolveMetadata,p=await i.stat(o);let d;return this.toFileStat(i,o,p,void 0,!!w,(E,L)=>(d||(d=D.TernarySearchTree.forUris(()=>!t),d.set(o,!0),r&&d.fill(!0,r)),d.get(E.resource)||d.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&a?L===1:!1))}async toFileStat(o,n,i,t,r,a){const{providerExtUri:w}=this.getExtUri(o),p={resource:n,name:w.basename(n),isFile:(i.type&v.FileType.File)!==0,isDirectory:(i.type&v.FileType.Directory)!==0,isSymbolicLink:(i.type&v.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&v.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&v.FilePermission.Locked),etag:(0,v.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(p.isDirectory&&a(p,t)){try{const d=await o.readdir(n),E=await U.Promises.settled(d.map(async([L,N])=>{try{const F=w.joinPath(n,L),M=r?await o.stat(F):{type:N};return await this.toFileStat(o,F,M,d.length,r,a)}catch(F){return this.logService.trace(F),null}}));p.children=(0,k.coalesce)(E)}catch(d){this.logService.trace(d),p.children=[]}return p}return p}async resolveAll(o){return U.Promises.settled(o.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.withProvider(o),i=await n.stat(o);return this.toFileStat(n,o,i,void 0,!0,()=>!1)}async exists(o){const n=await this.withProvider(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.doValidateCreateFile(o,n)}catch(i){return i}return!0}async doValidateCreateFile(o,n){if(!n?.overwrite&&await this.exists(o))throw new v.FileOperationError((0,y.localize)(3,null,this.resourceForError(o)),3,n)}async createFile(o,n=A.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const t=await this.writeFile(o,n);return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,t)),t}async writeFile(o,n,i){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(t);let a=i;if((0,v.hasFileAtomicWriteCapability)(t)&&!a?.atomic){const w=t.enforceAtomicWriteFile?.(o);w&&(a={...i,atomic:w})}try{await this.validateWriteFile(t,o,a)||await this.mkdirp(t,r.dirname(o));let p;if((0,v.hasReadWriteCapability)(t)&&!(n instanceof A.VSBuffer))if((0,f.isReadableStream)(n)){const d=await(0,f.peekStream)(n,3);d.ended?p=A.VSBuffer.concat(d.buffer):p=d}else p=(0,f.peekReadable)(n,d=>A.VSBuffer.concat(d),3);else p=n;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&p instanceof A.VSBuffer||(0,v.hasReadWriteCapability)(t)&&(0,v.hasFileAtomicWriteCapability)(t)&&a?.atomic?await this.doWriteUnbuffered(t,o,a,p):await this.doWriteBuffered(t,o,a,p instanceof A.VSBuffer?(0,A.bufferToReadable)(p):p),this._onDidRunOperation.fire(new v.FileOperationEvent(o,4))}catch(w){throw new v.FileOperationError((0,y.localize)(4,null,this.resourceForError(o),(0,v.ensureFileSystemProviderError)(w).toString()),(0,v.toFileOperationResult)(w),a)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,n,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(n)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(n)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.resourceForError(n)));if(t)throw new Error((0,y.localize)(8,null,this.resourceForError(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&v.FileType.Directory)throw new v.FileOperationError((0,y.localize)(9,null,this.resourceForError(n)),0,i);if(this.throwIfFileIsReadonly(n,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==v.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,v.etag)({mtime:i.mtime,size:a.size}))throw new v.FileOperationError((0,y.localize)(10,null),3,i);return a}async readFile(o,n,i){const t=await this.withReadProvider(o);return n?.atomic?this.doReadFileAtomic(t,o,n,i):this.doReadFile(t,o,n,i)}async doReadFileAtomic(o,n,i,t){return new Promise((r,a)=>{this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{try{const w=await this.doReadFile(o,n,i,t);r(w)}catch(w){a(w)}})})}async doReadFile(o,n,i,t){const r=await this.doReadFileStream(o,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,A.streamToBuffer)(r.value)}}async readFileStream(o,n,i){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,n,i)}async doReadFileStream(o,n,i,t){const r=new T.CancellationTokenSource(t);let a=i;(0,v.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...i,atomic:!0});const w=this.validateReadFile(n,a).then(d=>d,d=>{throw r.dispose(!0),d});let p;try{return typeof a?.etag=="string"&&a.etag!==v.ETAG_DISABLED&&await w,a?.atomic&&(0,v.hasFileAtomicReadCapability)(o)||!((0,v.hasOpenReadWriteCloseCapability)(o)||(0,v.hasFileReadStreamCapability)(o))||(0,v.hasReadWriteCapability)(o)&&a?.preferUnbuffered?p=this.readFileUnbuffered(o,n,a):(0,v.hasFileReadStreamCapability)(o)?p=this.readFileStreamed(o,n,r.token,a):p=this.readFileBuffered(o,n,r.token,a),p.on("end",()=>r.dispose()),p.on("error",()=>r.dispose()),{...await w,value:p}}catch(d){throw p&&await(0,f.consumeStream)(p),this.restoreReadError(d,n,a)}}restoreReadError(o,n,i){const t=(0,y.localize)(11,null,this.resourceForError(n),(0,v.ensureFileSystemProviderError)(o).toString());return o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(t,o.stat,i):o instanceof v.TooLargeFileOperationError?new v.TooLargeFileOperationError(t,o.fileOperationResult,o.size,o.options):new v.FileOperationError(t,(0,v.toFileOperationResult)(o),i)}readFileStreamed(o,n,i,t=Object.create(null)){const r=o.readFileStream(n,t,i);return(0,f.transform)(r,{data:a=>a instanceof A.VSBuffer?a:A.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,n,t)},a=>A.VSBuffer.concat(a))}readFileBuffered(o,n,i,t=Object.create(null)){const r=(0,A.newWriteableBufferStream)();return(0,l.readFileIntoStream)(o,n,r,a=>a,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,n,t)},i),r}readFileUnbuffered(o,n,i){const t=(0,f.newWriteableStream)(r=>A.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,v.hasFileAtomicReadCapability)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(n,r.byteLength,i),t.end(A.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(o,n){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new v.FileOperationError((0,y.localize)(12,null,this.resourceForError(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&n.etag===i.etag)throw new v.NotModifiedSinceFileOperationError((0,y.localize)(13,null),i,n);return this.validateReadFileLimits(o,i.size,n),i}validateReadFileLimits(o,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new v.TooLargeFileOperationError((0,y.localize)(14,null,this.resourceForError(o)),7,n,i)}async canMove(o,n,i){return this.doCanMoveCopy(o,n,"move",i)}async canCopy(o,n,i){return this.doCanMoveCopy(o,n,"copy",i)}async doCanMoveCopy(o,n,i,t){if(o.toString()!==n.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,o,a,n,i,t)}catch(r){return r}return!0}async move(o,n,i){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"move",!!i),w=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,a==="move"?2:3,w)),w}async copy(o,n,i){const t=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"copy",!!i),w=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,a==="copy"?3:2,w)),w}async doMoveCopy(o,n,i,t,r,a){if(n.toString()===t.toString())return r;const{exists:w,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(o,n,i,t,r,a);if(w&&!p&&a&&await this.del(t,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,v.hasFileFolderCopyCapability)(o))await o.copy(n,t,{overwrite:a});else{const d=await this.resolve(n);d.isDirectory?await this.doCopyFolder(o,d,i,t):await this.doCopyFile(o,n,i,t)}return r}else return o===i?(await o.rename(n,t,{overwrite:a}),r):(await this.doMoveCopy(o,n,i,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(o,n,i,t){if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,n,i,t);if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,n,i,t);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,n,i,t);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,n,i,t)}async doCopyFolder(o,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await U.Promises.settled(n.children.map(async r=>{const a=this.getExtUri(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),i,a):this.doCopyFile(o,r.resource,i,a)}))}async doValidateMoveCopy(o,n,i,t,r,a){let w=!1;if(o===i){const{providerExtUri:d,isPathCaseSensitive:E}=this.getExtUri(o);if(E||(w=d.isEqual(n,t)),w&&r==="copy")throw new Error((0,y.localize)(15,null,this.resourceForError(n),this.resourceForError(t)));if(!w&&d.isEqualOrParent(t,n))throw new Error((0,y.localize)(16,null,this.resourceForError(n),this.resourceForError(t)))}const p=await this.exists(t);if(p&&!w){if(!a)throw new v.FileOperationError((0,y.localize)(17,null,this.resourceForError(n),this.resourceForError(t)),4);if(o===i){const{providerExtUri:d}=this.getExtUri(o);if(d.isEqualOrParent(n,t))throw new Error((0,y.localize)(18,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:p,isSameResourceWithDifferentPathCase:w}}getExtUri(o){const n=this.isPathCaseSensitive(o);return{providerExtUri:n?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(n,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,i)),i}async mkdirp(o,n){const i=[],{providerExtUri:t}=this.getExtUri(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&v.FileType.Directory))throw new Error((0,y.localize)(19,null,this.resourceForError(n)));break}catch(r){if((0,v.toFileSystemProviderErrorCode)(r)!==v.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await o.mkdir(n)}catch(a){if((0,v.toFileSystemProviderErrorCode)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.doValidateDelete(o,n)}catch(i){return i}return!0}async doValidateDelete(o,n){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.resourceForError(o)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.resourceForError(o)));if(t&&r)throw new Error((0,y.localize)(22,null,this.resourceForError(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.throwIfFileIsReadonly(o,a);else throw new v.FileOperationError((0,y.localize)(23,null,this.resourceForError(o)),1);if(!!!n?.recursive){const p=await this.resolve(o);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,y.localize)(24,null,this.resourceForError(o)))}return i}async del(o,n){const i=await this.doValidateDelete(o,n);let t=n;if((0,v.hasFileAtomicDeleteCapability)(i)&&!t?.atomic){const p=i.enforceAtomicDelete?.(o);p&&(t={...n,atomic:p})}const r=!!t?.useTrash,a=!!t?.recursive,w=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:w}),this._onDidRunOperation.fire(new v.FileOperationEvent(o,1))}async cloneFile(o,n){const i=await this.withProvider(o),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(i===t&&this.getExtUri(i).providerExtUri.isEqual(o,n))return;if(i===t&&(0,v.hasFileCloneCapability)(i))return i.cloneFile(o,n);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n));const r=this.writeQueue.queueFor(o,this.getExtUri(i).providerExtUri);return i===t&&(0,v.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(o,n,{overwrite:!0})):r.queue(()=>this.doCopyFile(i,o,t,n))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:m.WATCHER_CORRELATION_IDS++})}watch(o,n={recursive:!1,excludes:[]}){const i=new S.DisposableStore;let t=!1,r=()=>{t=!0};i.add((0,S.toDisposable)(()=>r())),(async()=>{try{const w=await this.doWatch(o,n);t?(0,S.dispose)(w):r=()=>(0,S.dispose)(w)}catch(w){this.logService.error(w)}})();const a=n.correlationId;if(typeof a=="number"){const w=i.add(new _.Emitter);return i.add(this.internalOnDidFilesChange.event(d=>{d.correlates(a)&&w.fire(d)})),{onDidChange:w.event,dispose:()=>i.dispose()}}return i}async doWatch(o,n){const i=await this.withProvider(o),t=(0,R.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(o),n]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:i.watch(o,n)},this.activeWatchers.set(t,r)),r.count+=1,(0,S.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,S.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,n,i,t){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(o,r,t):await this.doWriteReadableBufferedQueued(o,r,t)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,n,i){let t=0,r;if((0,f.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=A.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,w)=>{(0,f.listenStream)(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(o,n,p,p.byteLength,t,0)}catch(d){return w(d)}t+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>w(p),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(o,n,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(o,n,i,t,r,a){let w=0;for(;w<t;){const p=await o.write(n,r+w,i.buffer,a+w,t-w);w+=p}}async doWriteUnbuffered(o,n,i,t){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,n,i,t))}async doWriteUnbufferedQueued(o,n,i,t){let r;t instanceof A.VSBuffer?r=t:(0,f.isReadableStream)(t)?r=await(0,A.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?r=await(0,A.bufferedStreamToBuffer)(t):r=(0,A.readableToBuffer)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(o,n,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,n,i,t))}async doPipeBufferedQueued(o,n,i,t){let r,a;try{r=await o.open(n,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const w=A.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,d=0,E=0;do E=await o.read(r,p,w.buffer,d,w.byteLength-d),await this.doWriteBuffer(i,a,w,E,p,d),p+=E,d+=E,d===w.byteLength&&(d=0);while(E>0)}catch(w){throw(0,v.ensureFileSystemProviderError)(w)}finally{await U.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,n,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,n,i,t))}async doPipeUnbufferedQueued(o,n,i,t){return i.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,n,i,t){return this.writeQueue.queueFor(t,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,n,i,t))}async doPipeUnbufferedToBufferedQueued(o,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.doWriteBuffer(i,r,A.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(o,n,i,t){const r=await(0,A.streamToBuffer)(this.readFileBuffered(o,n,T.CancellationToken.None));await this.doWriteUnbuffered(i,t,void 0,r)}throwIfFileSystemIsReadonly(o,n){if(o.capabilities&2048)throw new v.FileOperationError((0,y.localize)(25,null,this.resourceForError(n)),6);return o}throwIfFileIsReadonly(o,n){if((n.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,y.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=C,e.FileService=C=m=ye([J(0,h.ILogService)],C)}),define(le[200],ue([0,1,54,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,198,38,194,193]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(k)}catch(o){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(o)}`)}})();class s extends h.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(t=>g.extUriBiasedIgnorePathCase.getComparisonKey(t)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:t}=await f.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:v.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await f.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,g.joinPath)(n,r.name))).type:a=this.toType(r),t.push([r.name,a])}catch(a){this.logService.trace(a)}})),t}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let t;return i?.dangling?t=v.FileType.Unknown:n.isFile()?t=v.FileType.File:n.isDirectory()?t=v.FileType.Directory:t=v.FileType.Unknown,i&&(t|=v.FileType.SymbolicLink),t}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new A.Barrier;return this.resourceLocks.set(n,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),t=await this.createResourceLock(n));const r=this.toFilePath(n);return await f.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{t?.dispose()}}traceLock(n){s.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,t){const r=(0,c.newWriteableStream)(a=>_.VSBuffer.concat(a.map(w=>_.VSBuffer.wrap(w))).buffer);return(0,l.readFileIntoStream)(this,n,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,g.joinPath)((0,g.dirname)(n),`${(0,g.basename)(n)}${t.atomic.postfix}`),i,t):this.doWriteFile(n,i,t)}async canWriteFileAtomic(n){try{const i=this.toFilePath(n),{symbolicLink:t}=await f.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async doWriteFileAtomic(n,i,t,r){const a=new S.DisposableStore;try{a.add(await this.createResourceLock(n)),a.add(await this.createResourceLock(i)),await this.doWriteFile(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(w){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{a.dispose()}}async doWriteFile(n,i,t,r){let a;try{const w=this.toFilePath(n);if(!t.create||!t.overwrite){if(await f.Promises.exists(w)){if(!t.overwrite)throw(0,v.createFileSystemProviderError)((0,y.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,v.createFileSystemProviderError)((0,y.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(n,w)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(n){s.canFlush=n}async open(n,i,t){const r=this.toFilePath(n);let a;(0,v.isFileOpenForWriteOptions)(i)&&!t&&(a=await this.createResourceLock(n));let w;try{if((0,v.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:d}=await f.SymlinkSupport.stat(r);d.mode&128||await f.Promises.chmod(r,d.mode|128)}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}let p;if((0,v.isFileOpenForWriteOptions)(i)){if(b.isWindows)try{await f.Promises.truncate(r,0),p="r+"}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}p||(p="w")}else p="r";w=await f.Promises.open(r,p)}catch(p){throw a?.dispose(),(0,v.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(w,0),(0,v.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(w,n),a){const p=this.mapHandleToLock.get(w);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${r})`),this.mapHandleToLock.set(w,a),p&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${r})`),p.dispose())}return w}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&s.canFlush)try{await f.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.logService.error(t)}return await f.Promises.close(n)}catch(t){throw this.toFileSystemProviderError(t)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,a){const w=this.normalizePos(n,i);let p=null;try{p=(await f.Promises.read(n,t,r,a,w)).bytesRead}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(n,w,p)}return p}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,t){const r=this.mapHandleToPos.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.mapHandleToPos.set(n,r+t):this.mapHandleToPos.delete(n)))}async write(n,i,t,r,a){return(0,A.retry)(()=>this.doWrite(n,i,t,r,a),100,3)}async doWrite(n,i,t,r,a){const w=this.normalizePos(n,i);let p=null;try{p=(await f.Promises.write(n,t,r,a,w)).bytesWritten}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),d)}finally{this.updatePos(n,w,p)}return p}async mkdir(n){try{await f.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const t=this.toFilePath(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,D.join)((0,D.dirname)(t),`${(0,D.basename)(t)}${i.atomic.postfix}`)),await f.Promises.rm(t,f.RimRafMode.MOVE,r)}else try{await f.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:p}=await f.SymlinkSupport.stat(t);a=w.isDirectory()&&!p}catch{}if(a)await f.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.toFileSystemProviderError(t)}}async rename(n,i,t){const r=this.toFilePath(n),a=this.toFilePath(i);if(r!==a)try{await this.validateMoveCopy(n,i,"move",t.overwrite),await f.Promises.rename(r,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,y.localize)(2,null,(0,D.basename)(r),(0,D.basename)((0,D.dirname)(a)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(n,i,t){const r=this.toFilePath(n),a=this.toFilePath(i);if(r!==a)try{await this.validateMoveCopy(n,i,"copy",t.overwrite),await f.Promises.copy(r,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,y.localize)(3,null,(0,D.basename)(r),(0,D.basename)((0,D.dirname)(a)),w.toString()))),this.toFileSystemProviderError(w)}}async validateMoveCopy(n,i,t,r){const a=this.toFilePath(n),w=this.toFilePath(i);let p=!1;if(!!(this.capabilities&1024)||(p=(0,I.isEqual)(a,w,!0)),p){if(t==="copy")throw(0,v.createFileSystemProviderError)((0,y.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const E=await this.statIgnoreError(n);if(!E)throw(0,v.createFileSystemProviderError)((0,y.localize)(5,null),v.FileSystemProviderErrorCode.FileNotFound);const L=await this.statIgnoreError(i);if(L){if(!r)throw(0,v.createFileSystemProviderError)((0,y.localize)(6,null),v.FileSystemProviderErrorCode.FileExists);E.type&v.FileType.File&&L.type&v.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,t){const r=this.toFilePath(n),a=this.toFilePath(i),w=!!(this.capabilities&1024);if((0,I.isEqual)(r,a,!w))return;const p=new S.DisposableStore;try{p.add(await this.createResourceLock(n)),p.add(await this.createResourceLock(i)),t&&await f.Promises.mkdir((0,D.dirname)(a),{recursive:!0}),await f.Promises.copyFile(r,a)}catch(d){if(d.code==="ENOENT"&&!t)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(d)}finally{p.dispose()}}createUniversalWatcher(n,i,t){return new m.UniversalWatcherClient(r=>n(r),r=>i(r),t)}createNonRecursiveWatcher(n,i,t){return new C.NodeJSWatcherClient(r=>n(r),r=>i(r),t)}toFileSystemProviderError(n){if(n instanceof v.FileSystemProviderError)return n;let i=n,t;switch(n.code){case"ENOENT":t=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=v.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=v.FileSystemProviderErrorCode.Unknown;break;default:t=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(n,i){let t=this.toFileSystemProviderError(i);if(n&&t.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await f.SymlinkSupport.stat(this.toFilePath(n));r.mode&128||(t=(0,v.createFileSystemProviderError)(i,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return t}}e.DiskFileSystemProvider=s}),define(le[101],ue([0,1,3,2,4,8]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("sharedProcessLifecycleService");let _=class extends U.Disposable{constructor(I){super(),this.logService=I,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=_,e.SharedProcessLifecycleService=_=ye([J(0,T.ILogService)],_)}),define(le[201],ue([0,1,10,3,8,2]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends A.AbstractLoggerService{constructor(b,g,c,f,y){super(g,c,f),this.windowId=b,this.channel=y,this._register(y.listen("onDidChangeLogLevel",b)(v=>{(0,A.isLogLevel)(v)?super.setLogLevel(v):super.setLogLevel(k.URI.revive(v[0]),v[1])})),this._register(y.listen("onDidChangeVisibility",b)(([v,l])=>super.setVisibility(k.URI.revive(v),l))),this._register(y.listen("onDidChangeLoggers",b)(({added:v,removed:l})=>{for(const h of v)super.registerLogger({...h,resource:k.URI.revive(h.resource)});for(const h of l)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new A.AdapterLogger({log:(b,g)=>{this.channel.call("consoleLog",[b,g])}})}registerLogger(b){super.registerLogger(b),this.channel.call("registerLogger",[b,this.windowId])}deregisterLogger(b){super.deregisterLogger(b),this.channel.call("deregisterLogger",[b,this.windowId])}setLogLevel(b,g){super.setLogLevel(b,g),this.channel.call("setLogLevel",[b,g])}setVisibility(b,g){super.setVisibility(b,g),this.channel.call("setVisibility",[this.toResource(b),g])}doCreateLogger(b,g,c){return new R(this.channel,b,g,c,this.windowId)}static setLogLevel(b,g,c){return b.call("setLogLevel",[g,c])}}e.LoggerChannelClient=_;class R extends A.AbstractMessageLogger{constructor(b,g,c,f,y){super(f?.logLevel==="always"),this.channel=b,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[g,f,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,g){const c=[[b,g]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(b){this.channel.call("log",[this.file,b])}}class I{constructor(b,g){this.loggerService=b,this.getUriTransformer=g}listen(b,g){const c=this.getUriTransformer(b);switch(g){case"onDidChangeLoggers":return U.Event.map(this.loggerService.onDidChangeLoggers,f=>({added:[...f.added].map(y=>this.transformLogger(y,c)),removed:[...f.removed].map(y=>this.transformLogger(y,c))}));case"onDidChangeVisibility":return U.Event.map(this.loggerService.onDidChangeVisibility,f=>[c.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return U.Event.map(this.loggerService.onDidChangeLogLevel,f=>(0,A.isLogLevel)(f)?f:[c.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${g}`)}async call(b,g,c){const f=this.getUriTransformer(b);switch(g){case"setLogLevel":return(0,A.isLogLevel)(c[0])?this.loggerService.setLogLevel(c[0]):this.loggerService.setLogLevel(k.URI.revive(f.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,f)))}throw new Error(`Call not found: ${g}`)}transformLogger(b,g){return{...b,resource:g.transformOutgoingURI(b.resource)}}}e.LoggerChannel=I;class S extends T.Disposable{constructor(b,g){super(),g.call("setLogLevel",[b.getLogLevel()]),this._register(b.onDidChangeLogLevel(c=>g.call("setLogLevel",[c]))),g.call("getRegisteredLoggers").then(c=>{for(const f of c)b.registerLogger({...f,resource:k.URI.revive(f.resource)})}),this._register(g.listen("onDidChangeVisibility")(([c,f])=>b.setVisibility(k.URI.revive(c),f))),this._register(g.listen("onDidChangeLoggers")(({added:c,removed:f})=>{for(const y of c)b.registerLogger({...y,resource:k.URI.revive(y.resource)});for(const y of f)b.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=S}),define(le[202],ue([0,1,2,8]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class A extends k.Disposable{constructor(_,R=[]){super(),this.logger=new U.MultiplexLogger([_,...R]),this._register(_.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...R){this.logger.trace(_,...R)}debug(_,...R){this.logger.debug(_,...R)}info(_,...R){this.logger.info(_,...R)}warn(_,...R){this.logger.warn(_,...R)}error(_,...R){this.logger.error(_,...R)}flush(){this.logger.flush()}}e.LogService=A}),define(le[57],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(le[203],ue([0,1,40,56]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let A=class{constructor(_,R){return this.windowId=_,k.ProxyChannel.toService(R.getChannel("nativeHost"),{context:_,properties:(()=>{const I=new Map;return I.set("windowId",_),I})()})}};e.NativeHostService=A,e.NativeHostService=A=ye([J(1,U.IMainProcessService)],A)}),define(le[58],ue([0,1,3,61,2,4]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class _ extends A.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(S){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...S,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(S),U.Iterable.reduce(this.policies.entries(),(b,[g,c])=>({...b,[g]:c}),{})}getPolicyValue(S){return this.policies.get(S)}serialize(){return U.Iterable.reduce(Object.entries(this.policyDefinitions),(S,[D,b])=>({...S,[D]:{definition:b,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=_;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(le[204],ue([0,1,3,2,58]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(I){this.service=I,this.disposables=new U.DisposableStore}listen(I,S){switch(S){case"onDidChange":return k.Event.map(this.service.onDidChange,D=>D.reduce((b,g)=>({...b,[g]:this.service.getPolicyValue(g)??null}),{}),this.disposables)}throw new Error(`Event not found: ${S}`)}call(I,S,D){switch(S){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(D)}throw new Error(`Call not found: ${S}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class _ extends A.AbstractPolicyService{constructor(I,S){super(),this.channel=S;for(const D in I){const{definition:b,value:g}=I[D];this.policyDefinitions[D]=b,g!==void 0&&this.policies.set(D,g)}this.channel.listen("onDidChange")(D=>{for(const b in D){const g=D[b];g===null?this.policies.delete(b):this.policies.set(b,g)}this._onDidChange.fire(Object.keys(D))})}async _updatePolicyDefinitions(I){const S=await this.channel.call("updatePolicyDefinitions",I);for(const D in S)this.policies.set(D,S[D])}}e.PolicyChannelClient=_}),define(le[102],ue([0,1,37]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const T=A.context.configuration();if(T)U=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){U=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:T,searchUrl:_,itemUrl:R,controlUrl:I}=U.extensionsGallery||{};Object.assign(U,{extensionsGallery:{serviceUrl:k.env.VSCODE_GALLERY_SERVICE_URL||T,searchUrl:k.env.VSCODE_GALLERY_SEARCH_URL||_,itemUrl:k.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:k.env.VSCODE_GALLERY_CONTROL_URL||I}});try{const S=(...b)=>b.reduce((g,c)=>(Object.keys(c).forEach(f=>{Array.isArray(g[f])&&Array.isArray(c[f])?g[f]=c[f]:typeof g[f]=="object"&&typeof c[f]=="object"?g[f]=S(g[f],c[f]):g[f]=c[f]}),g),{}),D=globalThis._VSCODE_USER_PRODUCT_JSON||{};U=S(U,D)}catch{}if(k.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`,serverDataFolderName:U.serverDataFolderName?`${U.serverDataFolderName}-dev`:void 0}),!U.version){const S=globalThis._VSCODE_PACKAGE_JSON;Object.assign(U,{version:S.version,release:S.release})}}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=U}),define(le[25],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[205],ue([0,1,6,7,2,16,31,8,25]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends A.Disposable{constructor(b,g,c){super(),this.productService=g,this.logService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},3e4)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),c=(0,T.dirname)(b),f=(0,T.basename)(b),y=await _.Promises.readdir(c);await Promise.all(y.map(async v=>{if(v===f)return;const l=(0,T.join)(c,v),h=await _.Promises.stat(l);if(h.isDirectory()&&g-h.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),_.Promises.rm(l)}))}catch(g){(0,U.onUnexpectedError)(g)}}};e.CodeCacheCleaner=S,e.CodeCacheCleaner=S=ye([J(1,I.IProductService),J(2,R.ILogService)],S)}),define(le[206],ue([0,1,6,7,2,16,31,14,8,25]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends A.Disposable{constructor(g,c,f){super(),this.environmentService=g,this.logService=c,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),c=JSON.parse(await _.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(c)){const u=c[h];g[`${u.hash}.${h}`]=!0}const f=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(f))return;const v=await _.Promises.readdir(f);for(const h of v){if(g[h]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await _.Promises.rm((0,T.join)(f,h))}const l=Date.now();for(const h of Object.keys(g)){const u=(0,T.join)(f,h),m=await _.Promises.readdir(u);for(const C of m){if(C==="tcf.json")continue;const s=(0,T.join)(u,C),o=await _.Promises.stat(s);o.isDirectory()&&l-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(h,C)}`),await _.Promises.rm(s))}}}catch(g){(0,U.onUnexpectedError)(g)}}};e.LanguagePackCachedDataCleaner=D,e.LanguagePackCachedDataCleaner=D=ye([J(0,R.INativeEnvironmentService),J(1,I.ILogService),J(2,S.IProductService)],D)}),define(le[207],ue([0,1,16,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var A;(function(T){function _(I){return!!(I.samples&&I.timeDeltas)}T.isValidProfile=_;function R(I,S="noAbsolutePaths"){for(const D of I.nodes)D.callFrame&&D.callFrame.url&&((0,k.isAbsolute)(D.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(D.callFrame.url))&&(D.callFrame.url=(0,k.join)(S,(0,k.basename)(D.callFrame.url)));return I}T.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(le[208],ue([0,1,32]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((S,D)=>{ne(["v8-inspect-profiler"],S,D)})).startProfiling({port:T.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this._sessions.set(I,R),I}async stopProfiling(T){const _=this._sessions.get(T);if(!_)throw new Error(`UNKNOWN session '${T}'`);const R=await _.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=U}),define(le[41],ue([0,1,126,12]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(_,R){k.ok(U.isString(_)),k.ok(U.isObject(R)),k.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,R)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new A}),define(le[103],ue([0,1,3,41]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,S){this.schemasById[A(I)]=S,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new T;U.Registry.add(e.Extensions.JSONContribution,_)}),define(le[50],ue([0,1,18,3,12,148,20,103,41]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(R.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new U.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new U.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const n=new Set;this.doRegisterConfigurations(s,o,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const o=new Set;this.doDeregisterConfigurations(s,o),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:s,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(s,!1,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(s){const o=new Set;this.doRegisterDefaultConfigurations(s,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(s,o){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),w=a?.valuesSources??new Map;if(t)for(const L of Object.keys(i[r]))w.set(L,t);const p={...a?.value||{},...i[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:p,valuesSources:w});const d=(0,_.getLanguageTagSettingPlainKey)(r),E={type:"object",default:p,description:T.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:A.isString(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.configurationProperties[r]=E,this.defaultLanguageConfigurationOverridesNode.properties[r]=E}else{this.configurationDefaultsOverrides.set(r,{value:i[r],source:t});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(s){const o=new Set;this.doDeregisterDefaultConfigurations(s,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(s,o){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.configurationDefaultsOverrides.get(t),a=A.isString(i)?i:i?.id,w=A.isString(r?.source)?r?.source:r?.source?.id;if(a===w)if(o.add(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const p=this.configurationProperties[t];p&&(this.updatePropertyDefaultValue(t,p),this.updateSchema(t,p))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(s){let o=!1;const n=new Set;s.removedDefaults&&(this.doDeregisterDefaultConfigurations(s.removedDefaults,n),o=!0),s.addedDefaults&&(this.doRegisterDefaultConfigurations(s.addedDefaults,n),o=!0),s.removedConfigurations&&this.doDeregisterConfigurations(s.removedConfigurations,n),s.addedConfigurations&&this.doRegisterConfigurations(s.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){this.doRegisterOverrideIdentifiers(s),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(s){for(const o of s)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,o,n){s.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(s,o){const n=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.configurationProperties[t];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}}validateAndRegisterProperties(s,o=!0,n,i,t=3,r){t=A.isUndefinedOrNull(s.scope)?t:s.scope;const a=s.properties;if(a)for(const p in a){const d=a[p];if(o&&u(p,d)){delete a[p];continue}if(d.source=n,d.defaultDefaultValue=a[p].default,this.updatePropertyDefaultValue(p,d),e.OVERRIDE_PROPERTY_REGEX.test(p)?d.scope=void 0:(d.scope=A.isUndefinedOrNull(d.scope)?t:d.scope,d.restricted=A.isUndefinedOrNull(d.restricted)?!!i?.includes(p):d.restricted),a[p].hasOwnProperty("included")&&!a[p].included){this.excludedConfigurationProperties[p]=a[p],delete a[p];continue}else this.configurationProperties[p]=a[p],a[p].policy?.name&&this.policyConfigurations.set(a[p].policy.name,p);!a[p].deprecationMessage&&a[p].markdownDeprecationMessage&&(a[p].deprecationMessage=a[p].markdownDeprecationMessage),r.add(p)}const w=s.allOf;if(w)for(const p of w)this.validateAndRegisterProperties(p,o,n,i,t,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const o=n=>{const i=n.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);n.allOf?.forEach(o)};o(s)}updateSchema(s,o){switch(e.allSettings.properties[s]=o,o.scope){case 1:e.applicationSettings.properties[s]=o;break;case 2:e.machineSettings.properties[s]=o;break;case 6:e.machineOverridableSettings.properties[s]=o;break;case 3:e.windowSettings.properties[s]=o;break;case 4:e.resourceSettings.properties[s]=o;break;case 5:e.resourceSettings.properties[s]=o,this.resourceLanguageSettingsSchema.properties[s]=o;break}}removeFromSchema(s,o){switch(delete e.allSettings.properties[s],o.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const o=`[${s}]`,n={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const s={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,o){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,t=n?.source;A.isUndefined(i)&&(i=o.defaultDefaultValue,t=void 0),A.isUndefined(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",f=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(C){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let o=f.exec(C);for(;o?.length;){const n=o[1].trim();n&&s.push(n),o=f.exec(C)}}return(0,k.distinct)(s)}e.overrideIdentifiersFromKey=y;function v(C){return C.reduce((s,o)=>`${s}[${o}]`,"")}e.keyFromOverrideIdentifiers=v;function l(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const h=new g;I.Registry.add(e.Extensions.Configuration,h);function u(C,s){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?T.localize(7,null,C):h.getConfigurationProperties()[C]!==void 0?T.localize(8,null,C):s.policy?.name&&h.getPolicyConfigurations().get(s.policy?.name)!==void 0?T.localize(9,null,C,s.policy?.name,h.getPolicyConfigurations().get(s.policy?.name)):null:T.localize(6,null)}e.validateProperty=u;function m(){const C=[],s=h.getConfigurationProperties();for(const o of Object.keys(s))C.push([o,s[o].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=m}),define(le[75],ue([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function c(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class f{constructor(n={},i=[],t=[],r){this._contents=n,this._keys=i,this._overrides=t,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof f)return i;const t=new y("");return t.parseRaw(i),t.configurationModel});this._rawConfiguration=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,i){const t=this.getContentsForOverrideIdentifer(i);return t?n?(0,D.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return k.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return k.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=R.deepClone(this.contents),t=R.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const w of n)if(a.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.mergeContents(i,w.contents);for(const p of w.overrides){const[d]=t.filter(E=>k.equals(E.identifiers,p.identifiers));d?(this.mergeContents(d.contents,p.contents),d.keys.push(...p.keys),d.keys=k.distinct(d.keys)):t.push(R.deepClone(p))}for(const p of w.keys)r.indexOf(p)===-1&&r.push(p)}return new f(i,r,t,a.every(w=>w instanceof f)?void 0:a)}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of k.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const w=i[r];w&&(typeof a=="object"&&typeof w=="object"?(a=R.deepClone(a),this.mergeContents(a,w)):a=w),t[r]=a}return new f(t,this.keys,this.overrides)}mergeContents(n,i){for(const t of Object.keys(i)){if(t in n&&I.isObject(n[t])&&I.isObject(i[t])){this.mergeContents(n[t],i[t]);continue}n[t]=R.deepClone(i[t])}}getContentsForOverrideIdentifer(n){let i=null,t=null;const r=a=>{a&&(t?this.mergeContents(t,a):t=R.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?i=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.updateValue(n,i,!0)}setValue(n,i){this.updateValue(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,D.removeFromValueTree)(this.contents,n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>k.equals(t.identifiers,(0,b.overrideIdentifiersFromKey)(n))),1))}updateValue(n,i,t){(0,D.addToValueTree)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,D.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=f;class y{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!I.isUndefinedOrNull(n)){const t=this.doParseContent(n);this.parseRaw(t,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:t,keys:r,overrides:a,restricted:w,hasExcludedProperties:p}=this.doParseRaw(n,i);this._configurationModel=new f(t,r,a,p?[n]:void 0),this._restrictedConfigurations=w||[]}doParseContent(n){let i={},t=null,r=[];const a=[],w=[];function p(E){Array.isArray(r)?r.push(E):t!==null&&(r[t]=E)}const d={onObjectBegin:()=>{const E={};p(E),a.push(r),r=E,t=null},onObjectProperty:E=>{t=E},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const E=[];p(E),a.push(r),r=E,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:p,onError:(E,L,N)=>{w.push({error:E,offset:L,length:N})}};if(n)try{A.visit(n,d),i=r[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return i}doParseRaw(n,i){const t=g.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,t,!0,i);n=r.raw;const a=(0,D.toValuesTree)(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),w=Object.keys(n),p=this.toOverrides(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:w,overrides:p,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(n,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const w={},p=[];for(const d in n)if(b.OVERRIDE_PROPERTY_REGEX.test(d)&&t){const E=this.filter(n[d],i,!1,r);w[d]=E.raw,a=a||E.hasExcludedProperties,p.push(...E.restricted)}else{const E=i[d],L=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&p.push(d),!r.exclude?.includes(d)&&(r.include?.includes(d)||(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&!(r.skipRestricted&&E?.restricted))?w[d]=n[d]:a=!0}return{raw:w,restricted:p,hasExcludedProperties:a}}toOverrides(n,i){const t=[];for(const r of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const w in n[r])a[w]=n[r][w];t.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,D.toValuesTree)(a,i)})}return t}}e.ConfigurationModelParser=y;class v extends T.Disposable{constructor(n,i,t,r){super(),this.userSettingsResource=n,this.parseOptions=i,this.fileService=r,this._onDidChange=this._register(new U.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(U.Event.any(U.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),U.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class l{constructor(n,i,t,r,a,w,p,d,E,L,N,F,M){this.key=n,this.overrides=i,this._value=t,this.overrideIdentifiers=r,this.defaultConfiguration=a,this.policyConfiguration=w,this.applicationConfiguration=p,this.userConfiguration=d,this.localUserConfiguration=E,this.remoteUserConfiguration=L,this.workspaceConfiguration=N,this.folderConfigurationModel=F,this.memoryConfigurationModel=M}get value(){return c(this._value)}inspect(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(n,i,t,r,a=new f,w=new f,p=new _.ResourceMap,d=new f,E=new _.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=w,this._folderConfigurations=p,this._memoryConfiguration=d,this._memoryConfigurationByResource=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,i,t){return this.getConsolidatedConfigurationModel(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new f,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,t){const r=this.getConsolidatedConfigurationModel(n,i,t),a=this.getFolderConfigurationModelForResource(i.resource,t),w=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=new Set;for(const d of r.overrides)for(const E of d.identifiers)r.getOverrideValue(n,E)!==void 0&&p.add(E);return new l(n,i,r.getValue(n),p.size?[...p]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this._workspaceConfiguration:void 0,a||void 0,w)}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:a,removed:w}=C(this._defaultConfiguration,n);i=[...r,...a,...w]}for(const r of i)for(const a of(0,b.overrideIdentifiersFromKey)(r)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=n.getKeysForOverrideIdentifier(a),d=[...p.filter(E=>w.indexOf(E)===-1),...w.filter(E=>p.indexOf(E)===-1),...w.filter(E=>!R.equals(this._defaultConfiguration.override(a).getValue(E),n.override(a).getValue(E)))];t.push([a,d])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=C(this._policyConfiguration,n),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.applicationConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateApplicationConfiguration(n),{keys:w,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.localUserConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateLocalUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.remoteUserConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateRemoteUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=C(this.workspaceConfiguration,n),w=[...i,...t,...r];return w.length&&this.updateWorkspaceConfiguration(n),{keys:w,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:w,overrides:p}=C(t,i),d=[...r,...a,...w];return(d.length||!t)&&this.updateFolderConfiguration(n,i),{keys:d,overrides:p}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:w}=C(i,void 0);return{keys:[...t,...r,...a],overrides:w}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,t){let r=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},i){let t=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const r=i.getFolder(n);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const a=this._memoryConfigurationByResource.get(n);a&&(t=t.merge(a))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(i=t.merge(r),this._foldersConsolidatedConfigurations.set(n,i)):i=t}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:a}=this._folderConfigurations.get(i);return n.push([i,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this._workspaceConfiguration.keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),t=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),w=this.parseConfigurationModel(n.workspace),p=n.folders.reduce((d,E)=>(d.set(S.URI.revive(E[0]),this.parseConfigurationModel(E[1])),d),new _.ResourceMap);return new h(i,t,r,a,new f,w,p,new f,new _.ResourceMap)}static parseConfigurationModel(n){return new f(n.contents,n.keys,n.overrides)}}e.Configuration=h;function u(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,w])=>{const p=(0,_.getOrSet)(i,a,new Set);w.forEach(d=>p.add(d))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.mergeChanges=u;class m{constructor(n,i,t,r){this.change=n,this.previous=i,this.currentConfiguraiton=t,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const w of a)this.affectedKeys.add(w);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){const t=this._marker+n,r=this._affectsConfigStr.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this._affectsConfigStr.length)return!1;const w=this._affectsConfigStr.charCodeAt(a);if(w!==this._markerCode1&&w!==this._markerCode2)return!1;if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!R.equals(p,d)}return!0}}e.ConfigurationChangeEvent=m;function C(o,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,o?.rawConfiguration),a=[],w=o?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const d=p.filter(E=>!w.includes(E));for(const E of d)a.push([E,n.getKeysForOverrideIdentifier(E)])}if(o){const d=w.filter(E=>!p.includes(E));for(const E of d)a.push([E,o.getKeysForOverrideIdentifier(E)])}if(n&&o){for(const d of w)if(p.includes(d)){const E=s({contents:o.getOverrideValue(void 0,d)||{},keys:o.getKeysForOverrideIdentifier(d)},{contents:n.getOverrideValue(void 0,d)||{},keys:n.getKeysForOverrideIdentifier(d)});a.push([d,[...E.added,...E.removed,...E.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function s(o,n){const i=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const w=(0,D.getConfigurationValue)(n.contents,a),p=(0,D.getConfigurationValue)(o.contents,a);R.equals(w,p)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(le[209],ue([0,1,18,3,2,30,12,75,50,8,58,41]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends A.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(b.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:l})=>this.onDidUpdateConfiguration(Array.from(v),l))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(v,l){this.updateConfigurationModel(v,b.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new R.ConfigurationModel;const v=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(v),v)}updateConfigurationModel(v,l){const h=this.getConfigurationDefaultOverrides();for(const u of v){const m=h[u],C=l[u];m!==void 0?this._configurationModel.addValue(u,m):C?this._configurationModel.addValue(u,C.default):this._configurationModel.removeValue(u)}}}e.DefaultConfiguration=g;class c{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=c;let f=class extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(v,l,h){super(),this.defaultConfiguration=v,this.policyService=l,this.logService=h,this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.updatePolicyDefinitions(v),!0))),this._configurationModel}async updatePolicyDefinitions(v){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",v);const l={},h=[],u=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const m of v){const C=u[m];if(!C){h.push(m);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.logService.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}h.push(m),l[C.policy.name]={type:C.type}}}return(0,_.isEmptyObject)(l)||await this.policyService.updatePolicyDefinitions(l),h}onDidChangePolicies(v){this.logService.trace("PolicyConfiguration#onDidChangePolicies",v);const l=b.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),h=(0,k.coalesce)(v.map(u=>l.get(u)));this.update(h,!0)}update(v,l){this.logService.trace("PolicyConfiguration#update",v);const h=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),u=[],m=this._configurationModel.isEmpty();for(const C of v){const s=h[C]?.policy?.name;if(s){const o=this.policyService.getPolicyValue(s);(m?o!==void 0:!(0,T.equals)(this._configurationModel.getValue(C),o))&&u.push([C,o])}else this._configurationModel.getValue(C)!==void 0&&u.push([C,void 0])}if(u.length){this.logService.trace("PolicyConfiguration#changed",u);const C=this._configurationModel;this._configurationModel=new R.ConfigurationModel;for(const s of C.keys)this._configurationModel.setValue(s,C.getValue(s));for(const[s,o]of u)o===void 0?this._configurationModel.removeValue(s):this._configurationModel.setValue(s,o);l&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=f,e.PolicyConfiguration=f=ye([J(1,D.IPolicyService),J(2,S.ILogService)],f)}),define(le[210],ue([0,1,6,3,2,19,20,75,209,58]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends A.Disposable{constructor(g,c,f,y){super(),this.settingsResource=g,this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=f instanceof S.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,f,y)),this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,{},T.extUriBiasedIgnorePathCase,c)),this.configuration=new R.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:l})=>this.onDidDefaultConfigurationChange(v,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,c,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new R.Configuration(g,c,new R.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(g,c){const f=typeof g=="string"?g:void 0,y=(0,_.isConfigurationOverrides)(g)?g:(0,_.isConfigurationOverrides)(c)?c:{};return this.configuration.getValue(f,y,void 0)}updateValue(g,c,f,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const c=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(f,c,2)}onDidDefaultConfigurationChange(g,c){const f=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(g,c);this.trigger(y,f,7)}onDidPolicyConfigurationChange(g){const c=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(f,c,7)}trigger(g,c,f){const y=new R.ConfigurationChangeEvent(g,{data:c},this.configuration);y.source=f,y.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(le[211],ue([0,1,15,3,2,67]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const _=(S,D,b)=>{const g=new Uint8Array(16);for(let y=0;y<16;y++)g[y]=Math.round(Math.random()*256);const c=(0,k.encodeBase64)(k.VSBuffer.wrap(g));return[`GET ws://localhost${S}?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=_,e.socketRawEndHeaderSequence=k.VSBuffer.fromString(`\r
\r
`);async function R(S,D,b,g,c){S.write(k.VSBuffer.fromString((0,e.makeRawSocketHeaders)(D,b,g)));const f=new A.DisposableStore;try{return await new Promise((y,v)=>{let l;f.add(S.onData(h=>{l?l=k.VSBuffer.concat([l,h],l.byteLength+h.byteLength):l=h;const u=l.indexOf(e.socketRawEndHeaderSequence);if(u===-1)return;y(S),S.pauseData();const m=l.slice(u+e.socketRawEndHeaderSequence.byteLength);m.byteLength&&c.onData.fire(m)})),f.add(S.onClose(h=>v(h??new Error("socket closed")))),f.add(S.onEnd(()=>v(new Error("socket ended"))))})}catch(y){throw S.dispose(),y}finally{f.dispose()}}e.connectManagedSocket=R;class I extends A.Disposable{constructor(D,b){super(),this.debugLabel=D,this.pausableDataEmitter=this._register(new U.PauseableEmitter),this.onData=(...g)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...g)),this.didDisposeEmitter=this._register(new U.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(b.onData),this._register(b.onData.event(g=>this.pausableDataEmitter.fire(g))),this.onClose=this._register(b.onClose).event,this.onEnd=this._register(b.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(D,b){T.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,D,b)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=I}),define(le[212],ue([0,1,7,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var A;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class T{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=T;class _{constructor(b,g){this.host=b,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=_;var R;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class I extends k.ErrorNoTelemetry{static isNotAvailable(b){return b instanceof I&&b._code===R.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof I&&b._code===R.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof I&&b._code===R.NoResolverFound}static isInvalidAuthority(b){return b instanceof I&&b._code===R.InvalidAuthority}static isHandled(b){return b instanceof I&&b.isHandled}constructor(b,g=R.Unknown,c){super(b),this._message=b,this._code=g,this._detail=c,this.isHandled=g===R.NotAvailable&&c===!0,Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I;function S(D){const b=D.indexOf("+");return b===-1?D:D.substring(0,b)}e.getRemoteAuthorityPrefix=S}),define(le[76],ue([0,1,23]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function U(S){return S.scheme===k.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=U;function A(S){if(!S)return;const D=S.indexOf("+");return D<0?S:S.substr(0,D)}e.getRemoteName=A;function T(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=T;function _(S){const{host:D,port:b}=I(S);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:b}}e.parseAuthorityWithPort=_;function R(S,D){let{host:b,port:g}=I(S);return typeof g>"u"&&(g=D),{host:b,port:g}}e.parseAuthorityWithOptionalPort=R;function I(S){const D=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const b=S.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const g=S.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:S,port:void 0}}}),define(le[44],ue([0,1,27,4,76]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(_||(e.ExtensionType=_={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class I{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,l){if(typeof v>"u"||v===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof v=="string"||typeof l=="string"){const h=typeof v=="string"?v:v.value,u=typeof l=="string"?l:l.value;return k.equalsIgnoreCase(h,u)}return v._lower===l._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=I;class S{get size(){return this._set.size}constructor(v){if(this._set=new Set,v)for(const l of v)this.add(l)}add(v){this._set.add(I.toKey(v))}delete(v){return this._set.delete(I.toKey(v))}has(v){return this._set.has(I.toKey(v))}}e.ExtensionIdentifierSet=S;class D{constructor(){this._map=new Map}clear(){this._map.clear()}delete(v){this._map.delete(I.toKey(v))}get(v){return this._map.get(I.toKey(v))}has(v){return this._map.has(I.toKey(v))}set(v,l){this._map.set(I.toKey(v),l)}values(){return this._map.values()}forEach(v){this._map.forEach(v)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=D;function b(y){return g(y)}e.isApplicationScopedExtension=b;function g(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function c(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=c;function f(y,v){if(v){const l=`onResolveRemoteAuthority:${(0,A.getRemoteName)(v)}`;return!!y.activationEvents?.includes(l)}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[213],ue([0,1,2,44,11]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends k.Disposable{constructor(R,I,S,D,b){super(),this.userDataProfilesService=R,this.fileService=I,this.uriIdentityService=S,this.logService=b,this._register(D.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(D.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(R){for(const I of R)I.local&&this.invalidate(I.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const I of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(I.extensionsResource,R)&&await this.deleteUserCacheFile(I);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,U.USER_MANIFEST_CACHE_FILE))}catch(I){(0,A.toFileOperationResult)(I)!==1&&this.logService.error(I)}}}e.ExtensionsManifestCache=T}),define(le[214],ue([0,1,6,15,26,7,3,2,100,62,32,67,212,76]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const f=30*1e3;var y;(function($){$[$.Management=1]="Management",$[$.ExtensionHost=2]="ExtensionHost",$[$.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function v($){switch($){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l($){const P=new A.CancellationTokenSource;return setTimeout(()=>P.cancel(),$),P.token}function h($,P){if($.isCancellationRequested||P.isCancellationRequested)return A.CancellationToken.Cancelled;const O=new A.CancellationTokenSource;return $.onCancellationRequested(()=>O.cancel()),P.onCancellationRequested(()=>O.cancel()),O.token}class u{get didTimeout(){return this._state==="timedout"}constructor(P){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((O,B)=>{this._resolvePromise=O,this._rejectPromise=B}),P.isCancellationRequested?this._timeout():this._disposables.add(P.onCancellationRequested(()=>this._timeout()))}registerDisposable(P){this._state==="pending"?this._disposables.add(P):P.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(P))}reject(P){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(P))}}function m($,P){const O=new u(P);return O.registerDisposable($.onControlMessage(B=>{const j=JSON.parse(B.toString()),ee=q(j);ee?O.reject(ee):O.resolve(j)})),O.promise}function C($,P,O,B,j,ee,V,K){const ie=new u(K),ce=S.StopWatch.create(!1);return $.info(`Creating a socket (${V})...`),I.mark(`code/willCreateSocket/${ee}`),P.connect(O,B,j,V).then(oe=>{ie.didTimeout?(I.mark(`code/didCreateSocketError/${ee}`),$.info(`Creating a socket (${V}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),oe?.dispose()):(I.mark(`code/didCreateSocketOK/${ee}`),$.info(`Creating a socket (${V}) was successful after ${ce.elapsed()} ms.`),ie.resolve(oe))},oe=>{I.mark(`code/didCreateSocketError/${ee}`),$.info(`Creating a socket (${V}) returned an error after ${ce.elapsed()} ms.`),$.error(oe),ie.reject(oe)}),ie.promise}function s($,P){const O=new u(P);return $.then(B=>{O.didTimeout||O.resolve(B)},B=>{O.didTimeout||O.reject(B)}),O.promise}async function o($,P,O,B){const j=re($,P);$.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await C($.logService,$.remoteSocketFactoryService,$.connectTo,(0,c.getRemoteServerRootPath)($),`reconnectionToken=${$.reconnectionToken}&reconnection=${$.reconnectionProtocol?"true":"false"}`,v(P),`renderer-${v(P)}-${$.reconnectionToken}`,B)}catch(oe){throw $.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),$.logService.error(oe),oe}$.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let V,K;$.reconnectionProtocol?($.reconnectionProtocol.beginAcceptReconnection(ee,null),V=$.reconnectionProtocol,K=!1):(V=new b.PersistentProtocol({socket:ee}),K=!0),$.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const ie=await s($.signService.createNewMessage((0,D.generateUuid)()),B),ce={type:"auth",auth:$.connectionToken||"00000000000000000000",data:ie.data};V.sendControl(U.VSBuffer.fromString(JSON.stringify(ce)));try{const oe=await m(V,h(B,l(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if($.logService.trace(`${j} 4/6. received SignRequest control message.`),!await s($.signService.validate(ie,oe.signedData),B)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const fe=await s($.signService.sign(oe.data),B),pe={type:"connectionType",commit:$.commit,signedData:fe,desiredConnectionType:P};return O&&(pe.args=O),$.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(U.VSBuffer.fromString(JSON.stringify(pe))),{protocol:V,ownsProtocol:K}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&($.logService.error(`${j} the handshake timed out. Error:`),$.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&($.logService.error(`${j} received error control message when negotiating connection. Error:`),$.logService.error(oe)),K&&x(V),oe}}async function n($,P,O,B){const j=Date.now(),ee=re($,P),{protocol:V,ownsProtocol:K}=await o($,P,O,B),ie=new u(B);return ie.registerDisposable(V.onControlMessage(ce=>{const oe=JSON.parse(ce.toString()),de=q(oe);de?($.logService.error(`${ee} received error control message when negotiating connection. Error:`),$.logService.error(de),K&&x(V),ie.reject(de)):($.reconnectionProtocol?.endAcceptReconnection(),$.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${G(j)}!`),ie.resolve({protocol:V,firstMessage:oe}))})),ie.promise}async function i($,P){const{protocol:O}=await n($,1,void 0,P);return{protocol:O}}async function t($,P,O){const{protocol:B,firstMessage:j}=await n($,2,P,O),ee=j&&j.debugPort;return{protocol:B,debugPort:ee}}async function r($,P,O){const B=Date.now(),j=re($,3),{protocol:ee}=await o($,3,P,O);return $.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${G(B)}!`),ee}async function a($,P,O){const{connectTo:B,connectionToken:j}=await $.addressProvider.getAddress();return{commit:$.commit,quality:$.quality,connectTo:B,connectionToken:j,reconnectionToken:P,reconnectionProtocol:O,remoteSocketFactoryService:$.remoteSocketFactoryService,signService:$.signService,logService:$.logService}}async function w($,P,O){return d($,async B=>{const{protocol:j}=await i(B,A.CancellationToken.None);return new z($,P,O,B.reconnectionToken,j)})}e.connectRemoteAgentManagement=w;async function p($,P){return d($,async O=>{const{protocol:B,debugPort:j}=await t(O,P,A.CancellationToken.None);return new Y($,P,O.reconnectionToken,B,j)})}e.connectRemoteAgentExtensionHost=p;async function d($,P){for(let B=1;;B++)try{const j=(0,D.generateUuid)(),ee=await a($,j,null);return await P(ee)}catch(j){if(B<5)$.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),$.logService.error(j);else throw $.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$.logService.error(j),X.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(j)),j}}async function E($,P,O){const B=await a($,(0,D.generateUuid)(),null);return await r(B,{host:P,port:O},A.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function L($){return(0,k.createCancelablePromise)(P=>new Promise((O,B)=>{const j=setTimeout(O,$*1e3);P.onCancellationRequested(()=>{clearTimeout(j),O()})}))}var N;(function($){$[$.ConnectionLost=0]="ConnectionLost",$[$.ReconnectionWait=1]="ReconnectionWait",$[$.ReconnectionRunning=2]="ReconnectionRunning",$[$.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$[$.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(P,O){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=F;class M{constructor(P,O,B,j){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.durationSeconds=B,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=M;class W{constructor(P,O,B){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=W;class Q{constructor(P,O,B){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=B,this.type=4}}e.ConnectionGainEvent=Q;class H{constructor(P,O,B,j){this.reconnectionToken=P,this.millisSinceLastIncomingData=O,this.attempt=B,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=H;class X extends R.Disposable{static triggerPermanentFailure(P,O,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=P,this._permanentFailureAttempt=O,this._permanentFailureHandled=B,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(P=>P._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(P=>P._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||X._permanentFailure}constructor(P,O,B,j,ee){super(),this._connectionType=P,this._options=O,this.reconnectionToken=B,this.protocol=j,this._reconnectionFailureIsFatal=ee,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(j.onSocketClose(V=>{const K=Z(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${K} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${K} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${K} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(V=>{const K=Z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${K} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),X._instances.push(this),this._register((0,R.toDisposable)(()=>{const V=X._instances.indexOf(this);V>=0&&X._instances.splice(V,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const P=Z(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const j=B<O.length?O[B]:O[O.length-1];try{if(j>0){const V=L(j);this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,V)),this._options.logService.info(`${P} waiting for ${j} seconds before reconnecting...`);try{await V}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${P} resolving connection...`);const ee=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${P} connecting to ${ee.connectTo}...`),await this._reconnect(ee,l(f)),this._options.logService.info(`${P} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,T.isCancellationError)(ee)){this._options.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof g.RemoteAuthorityResolverError){this._options.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,g.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(P,O,B){this._reconnectionFailureIsFatal?X.triggerPermanentFailure(P,O,B):this._gotoPermanentFailure(P,O,B)}_gotoPermanentFailure(P,O,B){this._onDidStateChange.fire(new H(this.reconnectionToken,P,O,B)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X;class z extends X{constructor(P,O,B,j,ee){super(1,P,j,ee,!0),this.client=this._register(new b.Client(ee,{remoteAuthority:O,clientId:B},P.ipcLogger))}async _reconnect(P,O){await i(P,O)}}e.ManagementPersistentConnection=z;class Y extends X{constructor(P,O,B,j,ee){super(2,P,B,j,!1),this._startArguments=O,this.debugPort=ee}async _reconnect(P,O){await t(P,this._startArguments,O)}}e.ExtensionHostPersistentConnection=Y;function x($){try{$.acceptDisconnect();const P=$.getSocket();$.dispose(),P.dispose()}catch(P){(0,T.onUnexpectedError)(P)}}function q($){if($&&$.type==="error"){const P=new Error(`Connection error: ${$.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function te($,P){for(;$.length<P;)$+=" ";return $}function se($,P){return`[remote-connection][${te(v($),13)}][${P.substr(0,5)}\u2026]`}function Z($,P,O){return`${se($,P)}[${O?"reconnect":"initial"}]`}function re($,P){return`${Z(P,$.reconnectionToken,!!$.reconnectionProtocol)}[${$.connectTo}]`}function G($){return`${Date.now()-$} ms`}}),define(le[104],ue([0,1,2,4]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,U.createDecorator)("remoteSocketFactoryService");class A{constructor(){this.factories={}}register(_,R){return this.factories[_]??=[],this.factories[_].push(R),(0,k.toDisposable)(()=>{const I=this.factories[_]?.indexOf(R);typeof I=="number"&&I>=0&&this.factories[_]?.splice(I,1)})}getSocketFactory(_){return(this.factories[_.type]||[]).find(I=>I.supports(_))}connect(_,R,I,S){const D=this.getSocketFactory(_);if(!D)throw new Error(`No socket factory found for ${_}`);return D.connect(_,R,I,S)}}e.RemoteSocketFactoryService=A}),define(le[215],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(le[105],ue([0,1,4,163]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var A;(function(T){T.disconnected=_=>({type:"disconnected",onTokenFailed:_}),T.connected=(_,R)=>({type:"connected",info:_,serviceInstallFailed:R}),T.connecting=_=>({type:"connecting",progress:_}),T.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(le[59],ue([0,1,15,7,2,165,50,4,8,41]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.hasNoContent=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");class D{constructor(C){this.original=C}toJSON(){if(!this.headers){const C=Object.create(null);for(const s in this.original)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?C[s]="*****":C[s]=this.original[s];this.headers=C}return this.headers}}class b extends A.Disposable{constructor(C){super(),this.counter=0,this.logger=C.createLogger("network",{name:(0,T.localize)(0,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async logAndRequest(C,s,o){const n=`${C} #${++this.counter}: ${s.url}`;this.logger.trace(`${n} - begin`,s.type,new D(s.headers??{}));try{const i=await o();return this.logger.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${n} - error`,s.type,(0,U.getErrorMessage)(i)),i}}}e.AbstractRequestService=b;function g(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.isSuccess=g;function c(m){return m.res.statusCode===204}e.hasNoContent=c;async function f(m){return c(m)?null:(await(0,k.streamToBuffer)(m.stream)).toString()}e.asText=f;async function y(m){if(!g(m))throw new Error("Server returned "+m.res.statusCode);return f(m)}e.asTextOrError=y;async function v(m){if(!g(m))throw new Error("Server returned "+m.res.statusCode);if(c(m))return null;const s=(await(0,k.streamToBuffer)(m.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.asJson=v;function l(m){u(m)}e.updateProxyConfigurationsScope=l;let h;function u(m){const C=S.Registry.as(_.Extensions.Configuration),s=h;h={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},C.updateConfigurations({add:[h],remove:s?[s]:[]})}u(1)}),define(le[216],ue([0,1,26,23,11,59]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=class{constructor(I,S){this.requestService=I,this.fileService=S}async download(I,S,D=k.CancellationToken.None){if(I.scheme===U.Schemas.file||I.scheme===U.Schemas.vscodeRemote){await this.fileService.copy(I,S);return}const b={type:"GET",url:I.toString(!0)},g=await this.requestService.request(b,D);if(g.res.statusCode===200)await this.fileService.writeFile(S,g.stream);else{const c=await(0,T.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${c}`)}}};e.DownloadService=_,e.DownloadService=_=ye([J(0,T.IRequestService),J(1,A.IFileService)],_)}),define(le[217],ue([0,1,15,26]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class A{constructor(R){this.service=R}listen(R,I){throw new Error("Invalid listen")}call(R,I,S,D=U.CancellationToken.None){switch(I){case"request":return this.service.request(S[0],D).then(async({res:b,stream:g})=>{const c=await(0,k.streamToBuffer)(g);return[{statusCode:b.statusCode,headers:b.headers},c]});case"resolveProxy":return this.service.resolveProxy(S[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=A;class T{constructor(R){this.channel=R}async request(R,I){const[S,D]=await this.channel.call("request",[R],I);return{res:S,stream:(0,k.bufferToStream)(D)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=T}),define(le[218],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[219],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class k{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(A){try{const T=await this.getValidator();if(T){const _=String(k._nextId++);return this.validators.set(_,T),{id:_,data:T.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,T){if(!A.id)return!0;const _=this.validators.get(A.id);if(!_)return!1;this.validators.delete(A.id);try{return _.validate(T)==="ok"}catch{return!1}finally{_.dispose?.()}}async sign(A){try{return await this.signValue(A)}catch{}return A}}e.AbstractSignService=k}),define(le[106],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[220],ue([0,1,219]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class U extends k.AbstractSignService{getValidator(){return this.vsda().then(T=>new T.validator)}signValue(T){return this.vsda().then(_=>new _.signer().sign(T))}vsda(){return new Promise((T,_)=>ne(["vsda"],T,_))}}e.SignService=U}),define(le[77],ue([0,1,3,2]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class A extends U.Disposable{constructor(b,g,c){super(),this.channel=b,this.profile=g,this.workspace=c}async getItems(){const b={profile:this.profile,workspace:this.workspace},g=await this.channel.call("getItems",b);return new Map(g)}updateItems(b){const g={profile:this.profile,workspace:this.workspace};return b.insert&&(g.insert=Array.from(b.insert.entries())),b.delete&&(g.delete=Array.from(b.delete.values())),this.channel.call("updateItems",g)}optimize(){const b={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",b)}}class T extends A{constructor(b,g){super(b,g,void 0),this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(b=>this.onDidChangeStorage(b)))}onDidChangeStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class _ extends T{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class R extends T{constructor(b,g){super(b,g)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class I extends A{constructor(b,g){super(b,void 0,g),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class S{constructor(b){this.channel=b}isUsed(b){const g={payload:b,profile:void 0,workspace:void 0};return this.channel.call("isUsed",g)}}e.StorageClient=S}),define(le[107],ue([0,1,5,37,32]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(I){if(k.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function _(I,S,D,b,g,c,f,y,v){const l=Object.create(null);l["common.machineId"]=c,l["common.sqmId"]=f,l.sessionID=(0,A.generateUuid)()+Date.now(),l.commitHash=b,l.version=g,l["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,k.PlatformToString)(k.platform),l["common.nodePlatform"]=U.platform,l["common.nodeArch"]=D,l["common.product"]=v||"desktop",y&&(l["common.msftInternal"]=y);let h=0;const u=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),k.isLinuxSnap&&(l["common.snap"]="true");const m=T(S);return m&&(l["common.platformDetail"]=m),l}e.resolveCommonProperties=_;function R(I){const S=U.env.USERDNSDOMAIN;if(!S)return!1;const D=S.toLowerCase();return I.some(b=>D===b)}e.verifyMicrosoftInternalDomain=R}),define(le[22],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(U||(e.TelemetryLevel=U={}));var A;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[221],ue([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function l(s,o){const n=`${s}::${o.join(":")}`,i=v.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,w=2e4;function p(E,L,N,F){const M=L.substring(E.length+1);return U.Promises.withAsyncBody(async W=>{let Q;try{Q=await D.Promises.readdir(L,{withFileTypes:!0})}catch{W();return}if(F.count>=w){F.count+=Q.length,F.maxReached=!0,W();return}let H=Q.length;if(H===0){W();return}let X=Q;F.count+Q.length>w&&(F.maxReached=!0,H=w-F.count,X=Q.slice(0,H)),F.count+=Q.length;for(const z of X)if(z.isDirectory()){if(N.includes(z.name)||await p(E,(0,_.join)(L,z.name),N,F),--H===0){W();return}}else{const Y=z.name.lastIndexOf(".");if(Y>=0){const x=z.name.substring(Y+1);x&&r.set(x,(r.get(x)??0)+1)}for(const x of t)x.relativePathPattern?.test(M)!==!1&&x.filePattern.test(z.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--H===0){W();return}}})}const d=U.Promises.withAsyncBody(async E=>{const L={count:0,maxReached:!1};await p(s,s,o,L);const N=await m(s);E({configFiles:h(a),fileTypes:h(r),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:N})});return v.set(n,d),d}e.collectWorkspaceStats=l;function h(s){return Array.from(s.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function u(){const s={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},o=k.cpus();return o&&o.length>0&&(s.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),s}e.getMachineInfo=u;async function m(s){try{const o=new Map,n=(0,_.join)(s,".vscode","launch.json"),i=await D.Promises.readFile(n),t=[],r=(0,A.parse)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const w=a.type;w&&(o.has(w)?o.set(w,o.get(w)+1):o.set(w,1))}return h(o)}catch{return[]}}e.collectLaunchConfigs=m;let C=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const i=k.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(k.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${k.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,b.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async i=>{let[t,r]=i,a=this.formatProcessList(o,t);return n.forEach(w=>{if((0,g.isRemoteDiagnosticError)(w))a+=`
${w.errorMessage}`,r+=`
${w.errorMessage}`;else if(a+=`

Remote: ${w.hostName}`,w.processes&&(a+=`
${this.formatProcessList(o,w.processes)}`),w.workspaceMetadata){r+=`
|  Remote: ${w.hostName}`;for(const p of Object.keys(w.workspaceMetadata)){const d=w.workspaceMetadata[p];let E=`${d.fileCount} files`;d.maxFilesReached&&(E=`more than ${E}`),r+=`|    Folder (${p}): ${E}`,r+=this.formatWorkspaceStats(d)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:i,vmHint:t,os:r,cpus:a}=u(),w={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(w.load=`${k.loadavg().map(p=>Math.round(p)).join(", ")}`),R.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(o,n){const i=[];return(0,b.listProcesses)(o.mainPID).then(async t=>(i.push(""),i.push(this.formatEnvironment(o)),i.push(""),i.push(this.formatProcessList(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(o))),n.forEach(r=>{if((0,g.isRemoteDiagnosticError)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.formatMachineInfo(r.machineInfo)),r.processes&&i.push(this.formatProcessList(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const w=r.workspaceMetadata[a];let p=`${w.fileCount} files`;w.maxFilesReached&&(p=`more than ${p}`),i.push(`Folder (${a}): ${p}`),i.push(this.formatWorkspaceStats(w))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(o){const n=[];let t=0;const r=(d,E)=>{const L=` ${d}(${E})`;t+L.length>60?(n.push(a),a="|                 ",t=a.length):t+=L.length,a+=L};let a="|      File types:";const w=10,p=o.fileTypes.length>w?w:o.fileTypes.length;for(let d=0;d<p;d++){const E=o.fileTypes[d];r(E.name,E.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(d=>{r(d.name,d.count)}),n.push(a)),o.launchConfigFiles.length>0){let d="|      Launch Configs:";o.launchConfigFiles.forEach(E=>{const L=E.count>1?` ${E.name}(${E.count})`:` ${E.name}`;d+=L}),n.push(d)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${o[i]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=I.URI.revive(r);if(a.scheme===T.Schemas.file){const w=a.fsPath;i.push(l(w,["node_modules",".git"]).then(p=>{let d=`${p.fileCount} files`;p.maxFilesReached&&(d=`more than ${d}`),n.push(`|    Folder (${(0,_.basename)(w)}): ${d}`),n.push(this.formatWorkspaceStats(p))}).catch(p=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${p.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}formatProcessList(o,n){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,i,t,n,0),t.join(`
`)}formatProcessItem(o,n,i,t,r){const a=r===0;let w;a?w=t.pid===o?`${this.productService.applicationName} main`:"remote agent":n.has(t.pid)?w=n.get(t.pid):w=`${"  ".repeat(r)} ${t.name}`;const p=process.platform==="win32"?t.mem:k.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(p/c.ByteSize.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(t.children)&&t.children.forEach(d=>this.formatProcessItem(o,n,i,d,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:i}of o.folders){const t=I.URI.revive(i);if(t.scheme!==T.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const i=I.URI.revive(n);if(i.scheme!==T.Schemas.file)continue;const t=i.fsPath;try{const r=await l(t,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=C,e.DiagnosticsService=C=ye([J(0,y.ITelemetryService),J(1,f.IProductService)],C)}),define(le[108],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(T){this.appenders=T}listen(T,_){throw new Error(`Event not found: ${_}`)}call(T,_,{eventName:R,data:I}){return this.appenders.forEach(S=>S.log(R,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class U{constructor(T){this.channel=T}log(T,_){return this.channel.call("log",{eventName:T,data:_}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(le[45],ue([0,1,30,12,3,20,76,107,22]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=S;class D{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class b{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,t){return A.Event.debounce(t.onDidChangeConfiguration,(a,w)=>{const p=a?new Set([...a.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:p}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=g;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.supportsTelemetry=c;function f(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=f;function y(i){const t=i.getValue(I.TELEMETRY_SETTING_ID),r=i.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function v(i){const t={},r={},a={};u(i,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const p=a[w];typeof p=="number"?r[w]=p:typeof p=="boolean"?r[w]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${p.length}`),t[w]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(t[w]=p)}return{properties:t,measurements:r}}e.validateTelemetryData=v;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const t=(0,_.getRemoteName)(i);return l.has(t)?t:"other"}e.cleanRemoteAuthority=h;function u(i,t,r=0,a){if(i)for(const w of Object.getOwnPropertyNames(i)){const p=i[w],d=a?a+w:w;Array.isArray(p)?t[d]=(0,k.safeStringify)(p):p instanceof Date?t[d]=p.toISOString():(0,U.isObject)(p)?r<2?u(p,t,r+1,d+"."):t[d]=(0,k.safeStringify)(p):t[d]=p}}function m(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(r)||a}e.isInternalTelemetry=m;function C(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=C;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const E of t)for(;;){const L=E.exec(i);if(!L)break;a.push([L.index,E.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(r="";;){const E=p.exec(i);if(!E)break;const L=a.some(([N,F])=>E.index<F&&N<p.lastIndex);!w.test(E[0])&&!L&&(r+=i.substring(d,E.index)+"<REDACTED: user-file-path>",d=p.lastIndex)}return d<i.length&&(r+=i.substr(d)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,k.cloneAndChange)(i,r=>{if(r instanceof S||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=s(a,t);for(const w of t)a=a.replace(w,"");return a=o(a),a}})}e.cleanData=n}),define(le[33],ue([0,1,27,29,44,5,10,7,37,45]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,k.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=D;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new g(i.identifier,t,r)}static parse(i){const t=b.exec(i);return t&&t[1]&&t[2]?new g({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof g?D(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=g;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(n){const i=c.exec(n);return i&&i[1]?[v(i[1]),i[2]]:[v(n),void 0]}e.getIdAndVersion=f;function y(n,i){return`${n}.${i}`}e.getExtensionId=y;function v(n){return n.toLowerCase()}e.adoptToGalleryExtensionId=v;function l(n,i){return v(y(n??A.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=l;function h(n,i){const t=[],r=a=>{for(const w of t)if(w.some(p=>D(i(p),i(a))))return w;return null};for(const a of n){const w=r(a);w?w.push(a):t.push([a])}return t}e.groupByExtension=h;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=u;function m(n){return{id:new S.TelemetryTrustedValue(n.identifier.id),name:new S.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function C(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(w=>!D(w.identifier,{id:a}))){const w=n.filter(p=>D(p.identifier,{id:a}));w.length===1&&(t.push(w[0]),r.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=C;async function s(n,i){if(!T.isLinux)return!1;let t;try{t=(await n.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const t=await s(n,i),r=(0,U.getTargetPlatform)(t?"alpine":T.platform,I.arch);return i.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(le[222],ue([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let f=class extends U.Disposable{constructor(u,m){super(),this.fileService=u,this.productService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,C])=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const m=[];for(const[C,s]of this.allConfigBasedTips)if(!(s.configScheme&&s.configScheme!==u.scheme))try{const o=(await this.fileService.readFile((0,A.joinPath)(u,C))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&m.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return m}};e.ExtensionTipsService=f,e.ExtensionTipsService=f=ye([J(0,_.IFileService),J(1,R.IProductService)],f);const y="extensionTips/promptedExecutableTips",v="extensionTips/lastPromptedMediumImpExeTime";class l extends f{constructor(u,m,C,s,o,n,i,t){super(i,t),this.userHome=u,this.windowEvents=m,this.telemetryService=C,this.extensionManagementService=s,this.storageService=o,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const w=[],p=[],d=[];Object.entries(a.recommendations).forEach(([E,L])=>{L.important?a.important?w.push({extensionId:E,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):p.push({extensionId:E,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):d.push({extensionId:E,extensionName:L.name,isExtensionPack:!!L.isExtensionPack})}),w.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),p.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:p}),d.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:d})}),(0,I.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),m=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...m]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),m=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),C=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,C),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(m,C)}groupImportantTipsByExe(u,m){const C=new Map;u.forEach(t=>C.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:o}=this.groupByInstalled([...C.keys()],m);for(const t of s){const r=C.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=C.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.getPromptedExecutableTips(),i=new Map;for(const t of o){const r=C.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,m]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(C=>{switch(C){case"reacted":this.addToRecommendedExecutables(m[0].exeName,m);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":{const s=S.Event.once(S.Event.latch(S.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(s(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const s=this._register(new U.MutableDisposable);s.value=(0,I.disposableTimeout)(()=>{s.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),m=Date.now()-u,C=7*24*60*60*1e3;if(m<C){const n=this._register(new U.MutableDisposable);n.value=(0,I.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},C-m);return}const[s,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(s),this.addToRecommendedExecutables(o[0].exeName,o);const i=this._register(new U.MutableDisposable);i.value=(0,I.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},C);break}case"ignored":this.mediumImportanceTipsByExe.delete(s),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const i=S.Event.once(S.Event.latch(S.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(i(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const i=this._register(new U.MutableDisposable);i.value=(0,I.disposableTimeout)(()=>{i.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(u){const m=await this.extensionManagementService.getInstalled(1),C=u.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(o=>m.every(n=>!(0,c.areSameExtensions)(n.identifier,{id:o})))).map(({extensionId:s})=>s.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:C,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(v,-1);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(v,u,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(y,-1,"{}"))}addToRecommendedExecutables(u,m){const C=this.getPromptedExecutableTips();C[u]=m.map(({extensionId:s})=>s.toLowerCase()),this.storageService.store(y,JSON.stringify(C),-1,0)}groupByInstalled(u,m){const C=[],s=[],o=m.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return u.forEach(n=>{o.has(n.toLowerCase())?C.push(n):s.push(n)}),{installed:C,uninstalled:s}}async getValidExecutableBasedExtensionTips(u){const m=[],C=new Map;for(const s of u.keys()){const o=u.get(s);if(!o||!(0,k.isNonEmptyArray)(o.recommendations))continue;const n=[];b.isWindows?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>g.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>g.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>g.env.ProgramFiles).replace("%APPDATA%",()=>g.env.APPDATA).replace("%WINDIR%",()=>g.env.WINDIR)):(n.push((0,D.join)("/usr/local/bin",s)),n.push((0,D.join)("/usr/bin",s)),n.push((0,D.join)(this.userHome.fsPath,s)));for(const i of n){let t=C.get(i);if(t===void 0&&(t=await this.fileService.exists(T.URI.file(i)),C.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:w,whenNotInstalled:p}of o.recommendations)m.push({extensionId:r,extensionName:a,isExtensionPack:w,exeName:s,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:p})}}return m}}e.AbstractNativeExtensionTipsService=l}),define(le[223],ue([0,1,26,33]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function A(T,_,R,I,S){try{const D=await T.getExtensionsControlManifest();if(!D.deprecated)return;const b=await T.getInstalled(1);for(const[g,c]of Object.entries(D.deprecated)){if(!c?.extension)continue;const{id:f,autoMigrate:y,preRelease:v}=c.extension;if(!y)continue;const l=b.find(u=>(0,U.areSameExtensions)(u.identifier,{id:g}));if(!l)continue;const h=(await _.getExtensions([{id:f,preRelease:v}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!h){S.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{S.info(`Migrating '${l.identifier.id}' extension to '${f}' extension...`);const u=!I.getDisabledExtensions().some(C=>(0,U.areSameExtensions)(C,l.identifier));await T.uninstall(l),S.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let m=b.find(C=>(0,U.areSameExtensions)(C.identifier,{id:f}));(!m||!m.isPreReleaseVersion&&u)&&(m=await T.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${m.identifier.id}'`),u||(await I.disableExtension(m.identifier),S.info(`Disabled the pre-release extension '${m.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,U.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,U.getExtensionId)(m.manifest.publisher,m.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${l.identifier.id}' extension to '${f}' extension.`)}catch(u){S.error(u)}}}catch(D){S.error(D)}}e.migrateUnsupportedExtensions=A}),define(le[224],ue([0,1,6,7,2,23,19,55,12,32,31,69,20,14,29,33,97,11,8]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let m=class extends A.Disposable{static{u=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(s,o,n,i,t,r){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=i,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(s,o,n){await this.cleanUpPromise;const i=(0,_.joinPath)(this.extensionsDownloadDir,this.getName(s));try{await this.downloadFile(s,i,r=>this.extensionGalleryService.download(s,r,o))}catch(r){throw new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.shouldVerifySignature(s)){const r=await this.downloadSignatureArchive(s);try{t=await this.extensionSignatureVerificationService.verify(i.fsPath,r.fsPath,this.logService.getLevel()===h.LogLevel.Trace)}catch(a){const w=a;if(t=w.code,w.output&&this.logService.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${w.output}`),t===f.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===f.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(p){this.logService.error(p)}throw new f.ExtensionManagementError(b.CorruptZipMessage,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return t===!0?this.logService.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.logService.info(`Extension signature verification is not done: ${s.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}shouldVerifySignature(s){if(!s.isSigned)return!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,I.isBoolean)(o)?o:!0}async downloadSignatureArchive(s){await this.cleanUpPromise;const o=(0,_.joinPath)(this.extensionsDownloadDir,`${this.getName(s)}${u.SignatureArchiveExtension}`);return await this.downloadFile(s,o,n=>this.extensionGalleryService.downloadSignatureArchive(s,n)),o}async downloadFile(s,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==T.Schemas.file){await n(o);return}const i=(0,_.joinPath)(this.extensionsDownloadDir,`.${(0,S.generateUuid)()}`);await this.fileService.exists(i)||await n(i);try{await D.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.fileService.del(i)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,U.getErrorMessage)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.cleanUpPromise,await this.fileService.del(s)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],n=[],i=[];for(const a of s.children)if(a.name.endsWith(u.SignatureArchiveExtension))i.push(a.resource);else{const w=y.ExtensionKey.parse(a.name);w&&n.push([w,a])}const t=(0,y.groupByExtension)(n,([a])=>a),r=[];for(const a of t)a.sort((w,p)=>R.rcompare(w[0].version,p[0].version)),o.push(...a.slice(1).map(w=>w[1].resource)),r.push(a[0][1]);r.sort((a,w)=>a.mtime-w.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),o.push(...i),await k.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(s){this.logService.error(s)}}getName(s){return this.cache?y.ExtensionKey.create(s).toString().toLowerCase():(0,S.generateUuid)()}};e.ExtensionsDownloader=m,e.ExtensionsDownloader=m=u=ye([J(0,c.INativeEnvironmentService),J(1,l.IFileService),J(2,f.IExtensionGalleryService),J(3,g.IConfigurationService),J(4,v.IExtensionSignatureVerificationService),J(5,h.ILogService)],m)}),define(le[225],ue([0,1,3,2,34,33,44]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends U.Disposable{constructor(S,D,b,g,c,f,y){super(),this.extensionManagementService=S,this.extensionsScannerService=D,this.userDataProfilesService=b,this.extensionsProfileScannerService=g,this.uriIdentityService=c,this.fileService=f,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new U.DisposableMap),this.initialize().then(null,v=>y.error(v))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(S=>this.onDidChangeProfiles(S.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(S=>this.onAddExtensions(S))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(S=>this.onDidAddExtensions(S))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(S=>this.onRemoveExtensions(S))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(S=>this.onDidRemoveExtensions(S))),this._register(this.fileService.onDidFilesChange(S=>this.onDidFilesChange(S)))}async onDidChangeProfiles(S){try{S.length&&await Promise.all(S.map(D=>(this.extensionsProfileWatchDisposables.set(D.id,(0,U.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(D.extensionsResource)),this.fileService.watch(D.extensionsResource))),this.populateExtensionsFromProfile(D.extensionsResource))))}catch(D){throw this.logService.error(D),D}}async onAddExtensions(S){for(const D of S.extensions)this.addExtensionWithKey(this.getKey(D.identifier,D.version),S.profileLocation)}async onDidAddExtensions(S){for(const D of S.extensions){const b=this.getKey(D.identifier,D.version);S.error?this.removeExtensionWithKey(b,S.profileLocation):this.addExtensionWithKey(b,S.profileLocation)}}async onRemoveExtensions(S){for(const D of S.extensions)this.removeExtensionWithKey(this.getKey(D.identifier,D.version),S.profileLocation)}async onDidRemoveExtensions(S){const D=[],b=[];for(const g of S.extensions){const c=this.getKey(g.identifier,g.version);S.error?this.addExtensionWithKey(c,S.profileLocation):(this.removeExtensionWithKey(c,S.profileLocation),this.allExtensions.has(c)||(this.logService.debug("Extension is removed from all profiles",g.identifier.id,g.version),b.push(this.extensionManagementService.scanInstalledExtensionAtLocation(g.location).then(f=>{f?D.push(f):this.logService.info("Extension not found at the location",g.location.toString())},f=>this.logService.error(f)))))}try{await Promise.all(b),D.length&&await this.uninstallExtensionsNotInProfiles(D)}catch(g){this.logService.error(g)}}onDidFilesChange(S){for(const D of this.userDataProfilesService.profiles)S.contains(D.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(D.extensionsResource)}async onDidExtensionsProfileChange(S){const D=[],b=[],g=await this.extensionsProfileScannerService.scanProfileExtensions(S),c=new Set,f=new Set;for(const[y,v]of this.allExtensions)v.has(S)&&f.add(y);for(const y of g){const v=this.getKey(y.identifier,y.version);c.add(v),f.has(v)||(D.push(y.identifier),this.addExtensionWithKey(v,S))}for(const y of f)if(!c.has(y)){const v=this.fromKey(y);v&&(b.push(v.identifier),this.removeExtensionWithKey(y,S))}(D.length||b.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D.length?{extensions:D,profileLocation:S}:void 0,removed:b.length?{extensions:b,profileLocation:S}:void 0})}async populateExtensionsFromProfile(S){const D=await this.extensionsProfileScannerService.scanProfileExtensions(S);for(const b of D)this.addExtensionWithKey(this.getKey(b.identifier,b.version),S)}async uninstallExtensionsNotInProfiles(S){S||(S=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(b=>!this.allExtensions.has(this.getKey(b.identifier,b.manifest.version)))),S.length&&await this.extensionManagementService.markAsUninstalled(...S)}addExtensionWithKey(S,D){let b=this.allExtensions.get(S);b||this.allExtensions.set(S,b=new A.ResourceSet(g=>this.uriIdentityService.extUri.getComparisonKey(g))),b.add(D)}removeExtensionWithKey(S,D){const b=this.allExtensions.get(S);b&&b.delete(D),b?.size||this.allExtensions.delete(S)}getKey(S,D){return`${_.ExtensionIdentifier.toKey(S.id)}@${D}`}fromKey(S){const[D,b]=(0,T.getIdAndVersion)(S);return b?{identifier:{id:D},version:b}:void 0}}e.ExtensionsWatcher=R}),define(le[226],ue([0,1,43,45]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function A(T,_,R,I,S,D,b){const g={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${_.nameShort})`};if((0,U.supportsTelemetry)(_,R)&&(0,U.getTelemetryLevel)(I)===3){const c=await(0,k.getServiceMachineId)(R,S,D);g["X-Market-User-Id"]=c,g["VSCode-SessionId"]=b.machineId||c}return g}e.resolveMarketplaceHeaders=A}),define(le[227],ue([0,1,72,18,6,2,23,16,31,14,29,33,8,74,10]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends c.LanguagePackBaseService{constructor(u,m,C,s){super(C),this.extensionManagementService=u,this.logService=s,this.cache=this._register(new v(m,s)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(u,m){const s=(await this.cache.getLanguagePacks())[m];if(!s){this.logService.warn(`No language pack found for ${m}`);return}const o=s.translations[u];return o?f.URI.file(o):void 0}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),m=Object.keys(u).map(C=>{const s=u[C];return{...this.createQuickPickItem(C,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.createQuickPickItem("en","English")),m.sort((C,s)=>C.label.localeCompare(s.label)),m}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const m=await this.cache.getLanguagePacks();Object.keys(m).some(C=>m[C]&&m[C].extensions.some(s=>(0,b.areSameExtensions)(s.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),C=await this.cache.update(m);return!(0,U.equals)(Object.keys(u),Object.keys(C))}};e.NativeLanguagePackService=y,e.NativeLanguagePackService=y=ye([J(0,D.IExtensionManagementService),J(1,S.INativeEnvironmentService),J(2,D.IExtensionGalleryService),J(3,g.ILogService)],y);let v=class extends T.Disposable{constructor(u,m){super(),this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new A.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(m=>{Object.keys(m).forEach(C=>delete m[C]),this.createLanguagePacksFromExtensions(m,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...m){for(const C of m)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,C);Object.keys(u).forEach(C=>this.updateHash(u[C]))}createLanguagePacksFromExtension(u,m){const C=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const o of s)if(m.location.scheme===_.Schemas.file&&l(o)){let n=u[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},u[o.languageId]=n);const i=n.extensions.filter(t=>(0,b.areSameExtensions)(t.extensionIdentifier,C))[0];i?i.version=m.manifest.version:n.extensions.push({extensionIdentifier:C,version:m.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.join)(m.location.fsPath,t.path)}}updateHash(u){if(u){const m=(0,k.createHash)("md5");for(const C of u.extensions)m.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);u.hash=m.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(m=u(C),C)).then(C=>{for(const o of Object.keys(C))C[o]||delete C[o];this.languagePacks=C,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),I.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>m,C=>this.logService.error(C))})}};v=ye([J(0,S.INativeEnvironmentService),J(1,g.ILogService)],v);function l(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const u of h.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(le[228],ue([0,1,141,7,30,45]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const _="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function I(D,b,g){const c=await(0,k.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),f=await(0,k.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new c.AppInsightsCore,v=new f.PostChannel,l={instrumentationKey:D,endpointUrl:_,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(g){l.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:g};l.extensionConfig[v.identifier]=h}return y.initialize(l,[]),y.addTelemetryInitializer(h=>{b&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),y}class S{constructor(b,g,c,f,y){this._isInternalTelemetry=b,this._eventPrefix=g,this._defaultData=c,this._xhrOverride=y,this.endPointUrl=_,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof f=="function"?this._aiCoreOrKey=f():this._aiCoreOrKey=f,this._asyncAiCore=null}_withAIClient(b){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=I(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(g=>{b(g)},g=>{(0,U.onUnexpectedError)(g),console.error(g)})}}log(b,g){if(!this._aiCoreOrKey)return;g=(0,A.mixin)(g,this._defaultData),g=(0,T.validateTelemetryData)(g);const c=this._eventPrefix+"/"+b;try{this._withAIClient(f=>{f.pluginVersionString=g?.properties.version??"Unknown",f.track({name:c,baseData:{name:c,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(g=>{g.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=S}),define(le[109],ue([0,1,2,166,14,8,25,45]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends k.Disposable{constructor(D,b,g,c,f=""){super(),this.prefix=f;const y=b.getLogger(R.telemetryLogId);if(y)this.logger=this._register(y);else{const l=(0,R.isLoggingOnly)(c,g)?" (Not Sent)":"",h=()=>(0,R.supportsTelemetry)(c,g)&&D.getLevel()===T.LogLevel.Trace;this.logger=this._register(b.createLogger(R.telemetryLogId,{name:(0,U.localize)(0,null,l),hidden:!h()})),this._register(D.onDidChangeLogLevel(()=>b.setVisibility(R.telemetryLogId,h()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(D,b){this.logger.trace(`${this.prefix}telemetry/${D}`,(0,R.validateTelemetryData)(b))}};e.TelemetryLogAppender=I,e.TelemetryLogAppender=I=ye([J(0,T.ILogService),J(1,T.ILoggerService),J(2,A.IEnvironmentService),J(3,_.IProductService)],I)}),define(le[110],ue([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,h,u){this._configurationService=h,this._productService=u,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(m),"gi")),m.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(m.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(m=>{(m.affectsConfiguration(g.TELEMETRY_SETTING_ID)||m.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||m.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(l,h){this._experimentProperties[l]=h}_updateTelemetryLevel(){let l=(0,c.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const u=h.usage?3:h.error?2:0;l=Math.min(l,u)}this._telemetryLevel=l}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(l,h,u){this._telemetryLevel<h||(u=(0,U.mixin)(u,this._experimentProperties),u=(0,c.cleanData)(u,this._cleanupPatterns),u=(0,U.mixin)(u,this._commonProperties),this._appenders.forEach(m=>m.log(l,u)))}publicLog(l,h){this._log(l,3,h)}publicLog2(l,h){this.publicLog(l,h)}publicLogError(l,h){this._sendErrorTelemetry&&this._log(l,2,h)}publicLogError2(l,h){this.publicLogError(l,h)}};e.TelemetryService=f,e.TelemetryService=f=ye([J(1,R.IConfigurationService),J(2,D.IProductService)],f);function y(){const v=(0,_.localize)(0,null,S.default.nameLong),l=S.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=A.isWeb?"":(0,_.localize)(3,null),u=(0,_.localize)(4,null),m=(0,_.localize)(5,null),C=(0,_.localize)(6,null),s=(0,_.localize)(7,null),o=`
|       | ${u} | ${m} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,_.localize)(8,null);return`
${v} ${l} ${h}

&nbsp;

${s}
${o}

&nbsp;

${n}
`}b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,_.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,_.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[229],ue([0,1,15,26,271,228]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function _(D,b){const g=await b.request(D,U.CancellationToken.None),c=(await(0,k.streamToBuffer)(g.stream)).toString(),f=g.res.statusCode??200;return{headers:g.res.headers,statusCode:f,responseData:c}}async function R(D){const b={method:D.type,headers:D.headers};return new Promise((c,f)=>{const y=A.request(D.url??"",b,v=>{v.on("data",function(l){c({headers:v.headers,statusCode:v.statusCode??200,responseData:l.toString()})}),v.on("error",function(l){f(l)})});y.write(D.data,v=>{v&&f(v)}),y.end()})}async function I(D,b,g){const c=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),f={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:c};try{const y=D?await _(f,D):await R(f);g(y.statusCode,y.headers,y.responseData)}catch{g(0,{})}}class S extends T.AbstractOneDataSystemAppender{constructor(b,g,c,f,y){const v={sendPOST:(l,h)=>{I(b,l,h)}};super(g,c,f,y,v)}}e.OneDataSystemAppender=S}),define(le[230],ue([0,1,23,93,20,14,8,25,22,108,109,110]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(f,y,v,l,h,u){this.configurationService=f,this.telemetryService=y,this.logService=v,this.loggerService=l,this.environmentService=h,this.productService=u,this.customTelemetryServices=new Map}getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.telemetryService.machineId,y["common.vscodesessionid"]=this.telemetryService.sessionId;const v=[f.id,JSON.stringify(y),f.aiKey],h=new U.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new S.TelemetryAppenderClient(h),new D.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new b.TelemetryService({appenders:u,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}publicLog(f,y,v){this.getCustomTelemetryService(f).publicLog(y,v)}publicLogError(f,y,v){this.getCustomTelemetryService(f).publicLogError(y,v)}};e.CustomEndpointTelemetryService=g,e.CustomEndpointTelemetryService=g=ye([J(0,A.IConfigurationService),J(1,I.ITelemetryService),J(2,_.ILogService),J(3,_.ILoggerService),J(4,T.IEnvironmentService),J(5,R.IProductService)],g)}),define(le[78],ue([0,1,3,20,4,8]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var _;(function(v){v.Http="http",v.Https="https"})(_||(e.TunnelProtocol=_={}));var R;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(R||(e.TunnelPrivacyId=R={}));function I(v){return!!v.forwardPort}e.isTunnelProvider=I;var S;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function D(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=g;function c(v,l,h,u){if(h===1)return!1;if(h===2&&g(l)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(m?.length===4&&parseInt(m[1])>=18)return!1}return v<1024}e.isPortPrivileged=c;class f{constructor(l,h,u){this.remoteAddress=l,this.localAddress=h,this._dispose=u,this._onDispose=new k.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let y=class{constructor(l,h){this.logService=l,this.configurationService=h,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this._tunnelProvider=l,l?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this._canElevate=l.elevation,this._privacyOptions=l.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const l=[],h=Array.from(this._tunnels.values());for(const u of h){const m=Array.from(u.values());for(const C of m){const s=await C.value;s&&typeof s!="string"&&l.push(s)}}return l}async dispose(){for(const l of this._tunnels.values()){for(const{value:h}of l.values())await h.then(u=>typeof u!="string"?u?.dispose():void 0);l.clear()}this._tunnels.clear()}setEnvironmentTunnel(l,h,u,m,C){this.addTunnelToMap(l,h,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:h,localAddress:u,privacy:m,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,h){(g(l)||b(l))&&(l=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(l,h);if(u)return++u.refcount,u.value}openTunnel(l,h,u,m,C,s=!1,o,n){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${C}.`);const i=this._tunnelProvider??l;if(!i)return;if(h||(h="localhost"),m||(m=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(i,h,u,m,C,s,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(h,u),r}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(h,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(r);return(r.tunnelRemoteHost!==h||r.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const h=this._tunnels.get(l.tunnelRemoteHost);if(h){const u=h.get(l.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,u))}}}}async tryDisposeTunnel(l,h,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${h}.`);const m=u.value.then(async C=>{C&&typeof C!="string"&&(await C.dispose(!0),this._onTunnelClosed.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(h),m}}async closeTunnel(l,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${h} `);const u=this._tunnels.get(l);if(u&&u.has(h)){const m=u.get(h);m.refcount=0,await this.tryDisposeTunnel(l,h,m)}}addTunnelToMap(l,h,u){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(h,{refcount:1,value:u})}async removeEmptyOrErrorTunnelFromMap(l,h){const u=this._tunnels.get(l);if(u){const m=u.get(h),C=m?await m.value:void 0;(!C||typeof C=="string")&&u.delete(h),u.size===0&&this._tunnels.delete(l)}}getTunnelFromMap(l,h){const u=[l];b(l)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):g(l)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const m=u.map(C=>this._tunnels.get(C));for(const C of m){const s=C?.get(h);if(s)return s}}canTunnel(l){return!!D(l)}createWithProvider(l,h,u,m,C,s,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${m}.`);const n=u;this._factoryInProgress.add(n);const i=m===void 0?u:m,t={elevationRequired:C?this.isPortPrivileged(i):!1},r={remoteAddress:{host:h,port:u},localAddressPort:m,privacy:s,public:s?s!==R.Private:void 0,protocol:o},a=l.forwardPort(r,t);return a?(this.addTunnelToMap(h,u,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),a}};e.AbstractTunnelService=y,e.AbstractTunnelService=y=ye([J(0,T.ILogService),J(1,U.IConfigurationService)],y)}),define(le[231],ue([0,1,8,78,2,7,6]),function(ne,e,k,U,A,T,_){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends A.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let S=class extends A.Disposable{static{R=this}static{this._lastId=0}constructor(b,g){super(),this._tunnelService=b,this._logService=g,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++R._lastId)}}async startTunnel(b,g,c,f,y,v,l){const h=new I,u=await Promise.resolve(this._tunnelService.openTunnel(b,h,c,f,y,v,l));if(!u||typeof u=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${f} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(g))throw this._disposedTunnels.delete(g),h.dispose(),await u.dispose(),(0,T.canceled)();return h.setTunnel(u),this._tunnels.set(g,h),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${g}: ${u.localAddress} (local) to ${c}:${f} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(b,g){const c=this._tunnels.get(b);c&&c.setAddress(g)}async destroyTunnel(b){const g=this._tunnels.get(b);if(g){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await g.dispose();return}this._disposedTunnels.add(b)}};e.SharedProcessTunnelService=S,e.SharedProcessTunnelService=S=R=ye([J(0,U.ISharedTunnelsService),J(1,k.ILogService)],S)}),define(le[28],ue([0,1,4]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(le[232],ue([0,1,28,185,11,19,127,3,2]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{static{this._clock=0}constructor(g){this.uri=g,this.time=S._clock++}touch(){return this.time=S._clock++,this}}let D=class{constructor(g){this._fileService=g,this._dispooables=new I.DisposableStore,this._limit=2**16;const c=new Map,f=y=>{let v=c.get(y.scheme);return v===void 0&&(v=g.hasProvider(y)&&!this._fileService.hasCapability(y,1024),c.set(y.scheme,v)),v};this._dispooables.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{c.delete(y.scheme)})),this.extUri=new T.ExtUri(f),this._canonicalUris=new _.SkipList((y,v)=>this.extUri.compare(y,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,T.normalizePath)(g));const c=this._canonicalUris.get(g);return c?c.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new S(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((f,y)=>f[1].time<y[1].time?1:f[1].time>y[1].time?-1:0);S._clock=0,this._canonicalUris.clear();const c=this._limit*.5;for(let f=0;f<c;f++)this._canonicalUris.set(g[f][0],g[f][1].touch())}};e.UriIdentityService=D,e.UriIdentityService=D=ye([J(0,A.IFileService)],D),(0,U.registerSingleton)(k.IUriIdentityService,D,1)}),define(le[233],ue([0,1,3,2,11,47,34]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends U.Disposable{constructor(S,D,b,g,c,f){super(),this.fileSystemScheme=S,this.fileSystemProvider=D,this.userDataScheme=b,this.userDataProfilesService=g,this.uriIdentityService=c,this.logService=f,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new _.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(y))),this.updateAtomicReadWritesResources(),this._register(g.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const S of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(S.settingsResource),this.atomicReadWriteResources.add(S.keybindingsResource),this.atomicReadWriteResources.add(S.tasksResource),this.atomicReadWriteResources.add(S.extensionsResource)}open(S,D){return this.fileSystemProvider.open(this.toFileSystemResource(S),D)}close(S){return this.fileSystemProvider.close(S)}read(S,D,b,g,c){return this.fileSystemProvider.read(S,D,b,g,c)}write(S,D,b,g,c){return this.fileSystemProvider.write(S,D,b,g,c)}watch(S,D){this.watchResources.set(S,S);const b=this.fileSystemProvider.watch(this.toFileSystemResource(S),D);return(0,U.toDisposable)(()=>{this.watchResources.delete(S),b.dispose()})}stat(S){return this.fileSystemProvider.stat(this.toFileSystemResource(S))}mkdir(S){return this.fileSystemProvider.mkdir(this.toFileSystemResource(S))}rename(S,D,b){return this.fileSystemProvider.rename(this.toFileSystemResource(S),this.toFileSystemResource(D),b)}readFile(S,D){return this.fileSystemProvider.readFile(this.toFileSystemResource(S),D)}readFileStream(S,D,b){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(S),D,b)}readdir(S){return this.fileSystemProvider.readdir(this.toFileSystemResource(S))}enforceAtomicReadFile(S){return this.atomicReadWriteResources.has(S)}writeFile(S,D,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(S),D,b)}enforceAtomicWriteFile(S){return this.atomicReadWriteResources.has(S)?{postfix:".vsctmp"}:!1}delete(S,D){return this.fileSystemProvider.delete(this.toFileSystemResource(S),D)}copy(S,D,b){if((0,A.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(S),this.toFileSystemResource(D),b);throw new Error("copy not supported")}cloneFile(S,D){if((0,A.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(S),this.toFileSystemResource(D));throw new Error("clone not supported")}handleFileChanges(S){const D=[];for(const b of S){if(b.resource.scheme!==this.fileSystemScheme)continue;const g=this.toUserDataResource(b.resource);this.watchResources.findSubstr(g)&&D.push({resource:g,type:b.type,cId:b.cId})}D.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(D))}toFileSystemResource(S){return S.with({scheme:this.fileSystemScheme})}toUserDataResource(S){return S.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(le[79],ue([0,1,86]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function U(_,R,I,S){const D=(0,k.setProperty)(_,R,I,S)[0];return D&&(_=_.substring(0,D.offset)+D.content+_.substring(D.offset+D.length)),_}e.edit=U;function A(_,R,I){let S=I;for(;S>=0;){if(_.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&_.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=A;function T(_,R,I){let S=I;for(;S>=0;)if(_.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&_.charAt(S)===R.charAt(1)))return S;return _.length-1}e.getLineEndOffset=T}),define(le[234],ue([0,1,30,55,12]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(c,f,y,v,l,h){const u=[],m=[],C=[];if(!f){const W=c.filter(({identifier:Q})=>l.every(H=>H.toLowerCase()!==Q.id.toLowerCase()));return{local:{added:u,removed:m,updated:C},remote:W.length>0?{added:W,updated:[],removed:[],all:W}:null}}c=c.map(b),f=f.map(b),y=y?y.map(b):null;const s=new Map,o=W=>{W.uuid&&s.set(W.id.toLowerCase(),W.uuid)};c.forEach(({identifier:W})=>o(W)),f.forEach(({identifier:W})=>o(W)),y?.forEach(({identifier:W})=>o(W)),v?.forEach(({identifier:W})=>o(W)),h?.forEach(W=>o(W));const n=W=>{const Q=W.identifier.uuid||s.get(W.identifier.id.toLowerCase());return Q?`uuid:${Q}`:`id:${W.identifier.id.toLowerCase()}`},i=(W,Q)=>(W.set(n(Q),Q),W),t=c.reduce(i,new Map),r=f.reduce(i,new Map),a=f.reduce((W,Q)=>i(W,(0,k.deepClone)(Q)),new Map),w=y?y.reduce(i,new Map):null,p=v.reduce(i,new Map),d=l.reduce((W,Q)=>{const H=s.get(Q.toLowerCase());return W.add(H?`uuid:${H}`:`id:${Q.toLowerCase()}`)},new Set),E=h?h.reduce((W,{id:Q,uuid:H})=>(H=H??s.get(Q.toLowerCase()),W.add(H?`uuid:${H}`:`id:${Q.toLowerCase()}`)),new Set):null,L=_(t,r,d,!1);if(L.added.size>0||L.removed.size>0||L.updated.size>0){const W=_(w,t,d,!1),Q=_(w,r,d,!0),H=(X,z,Y,x)=>{let q,te,se;return z.installed?(q=x.pinned,se=x.preRelease,q&&(te=x.version)):(q=Y.pinned,se=Y.preRelease,q&&(te=Y.version)),q===void 0&&(q=z.pinned,q&&(te=z.version)),se===void 0&&(se=z.preRelease),{...x,installed:z.installed||Y.installed,pinned:q,preRelease:se,version:te??(Y.version&&(!z.installed||U.gt(Y.version,z.version))?Y.version:z.version),state:I(z,Y,w?.get(X))}};for(const X of Q.removed.values()){const z=t.get(X);if(!z)continue;const Y=(0,A.assertIsDefined)(w?.get(X)),x=E&&!E.has(X)&&Y.installed;z.installed&&x?m.push(z.identifier):a.set(X,z)}for(const X of Q.added.values()){const z=(0,A.assertIsDefined)(r.get(X)),Y=t.get(X);if(Y){if(L.updated.has(X)){const x=H(X,Y,z,z);R(Y,z,!1,!1)||C.push(g(x,X)),a.set(X,x)}}else z.installed&&u.push(g(z,X))}for(const X of Q.updated.values()){const z=(0,A.assertIsDefined)(r.get(X)),Y=(0,A.assertIsDefined)(w?.get(X)),x=t.get(X);if(x)if(E&&!E.has(X)&&Y.installed&&x.installed&&!z.installed)m.push(x.identifier);else{const te=H(X,x,z,z);C.push(g(te,X)),a.set(X,te)}else z.installed&&u.push(g(z,X))}for(const X of W.added.values())Q.added.has(X)||a.set(X,(0,A.assertIsDefined)(t.get(X)));for(const X of W.updated.values()){if(Q.removed.has(X)||Q.updated.has(X))continue;const z=(0,A.assertIsDefined)(t.get(X)),Y=(0,A.assertIsDefined)(r.get(X));a.set(X,H(X,z,Y,z))}for(const X of W.removed.values())Q.updated.has(X)||Q.removed.has(X)||p.has(X)||(0,A.assertIsDefined)(r.get(X)).installed&&E&&(E.has(X)||!(0,A.assertIsDefined)(w?.get(X)).installed||a.delete(X))}const N=[],F=_(r,a,new Set,!0),M=F.added.size>0||F.updated.size>0||F.removed.size>0;return M&&a.forEach((W,Q)=>N.push(g(W,Q))),{local:{added:u,removed:m,updated:C},remote:M?{added:[...F.added].map(W=>a.get(W)),updated:[...F.updated].map(W=>a.get(W)),removed:[...F.removed].map(W=>r.get(W)),all:N}:null}}e.merge=T;function _(c,f,y,v){const l=c?[...c.keys()].filter(s=>!y.has(s)):[],h=[...f.keys()].filter(s=>!y.has(s)),u=h.filter(s=>!l.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),m=l.filter(s=>!h.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),C=new Set;for(const s of l){if(m.has(s))continue;const o=c.get(s),n=f.get(s);(!n||!R(o,n,v,!0))&&C.add(s)}return{added:u,removed:m,updated:C}}function R(c,f,y,v){return!(c.disabled!==f.disabled||!!c.isApplicationScoped!=!!f.isApplicationScoped||v&&c.installed!==f.installed||c.installed&&f.installed&&(c.preRelease!==f.preRelease||c.pinned!==f.pinned||f.pinned&&c.version!==f.version)||!D(c.state,f.state)||y&&c.version!==f.version)}function I(c,f,y){const v=c.state,l=f.state,h=y?.state;if(!f.version||v&&U.gt(c.version,f.version))return v;if(l&&U.gt(f.version,c.version)||!v)return l;if(!l)return v;const u=(0,k.deepClone)(v),m=h?S(h,l):{added:Object.keys(l).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},C=h?S(h,v):{added:Object.keys(v).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...m.added.values(),...m.updated.values()])u[s]=l[s];for(const s of m.removed.values())C.updated.has(s)||delete u[s];return u}function S(c,f){const y=Object.keys(c),v=Object.keys(f),l=v.filter(m=>!y.includes(m)).reduce((m,C)=>(m.add(C),m),new Set),h=y.filter(m=>!v.includes(m)).reduce((m,C)=>(m.add(C),m),new Set),u=new Set;for(const m of y){if(h.has(m))continue;const C=c[m],s=f[m];(0,k.equals)(C,s)||u.add(m)}return{added:l,removed:h,updated:u}}function D(c={},f={}){const{added:y,removed:v,updated:l}=S(c,f);return y.size===0&&v.size===0&&l.size===0}function b(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function g(c,f){const y={...c,identifier:{id:c.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete y.disabled,c.installed||delete y.installed,c.state||delete y.state,c.isApplicationScoped||delete y.isApplicationScoped,y}}),define(le[111],ue([0,1,18,20,4]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,I){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return S=S.filter(D=>D!==R&&D!==`-${R}`),I&&S.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(R,I){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return S=S.filter(D=>D!==R&&D!==`-${R}`),I&&S.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(R){const I=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),D=[],b=[];if(Array.isArray(S))for(const g of S)g.startsWith("-")?b.push(g.substring(1)):D.push(g);return(0,k.distinct)([...I,...D].filter(g=>!b.includes(g)))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};e.IgnoredExtensionsManagementService=T,e.IgnoredExtensionsManagementService=T=ye([J(0,U.IConfigurationService)],T)}),define(le[235],ue([0,1,18,35,30,94,79]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(m){return(0,U.parse)(m)||[]}async function I(m,C,s,o,n){const i=R(m),t=R(C),r=s?R(s):null,a=[...i,...t,...r||[]].map(H=>H.key),w=await n.resolveUserBindings(a),p=D(i,t,r,w);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:C,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const d=g(i),E=g(t),L=r?g(r):null,N=f(d,E,w),F=L?f(L,d,w):{added:[...d.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},M=L?f(L,E,w):{added:[...E.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},W=S(N,F,M);let Q=m;for(const H of W.removed.values())W.conflicts.has(H)||(Q=h(Q,H,o));for(const H of W.added.values()){if(W.conflicts.has(H))continue;const X=E.get(H);if(X.some(z=>z.command!==`-${H}`&&p.conflicts.has(w[z.key]))){W.conflicts.add(H);continue}Q=l(Q,X,o)}for(const H of W.updated.values()){if(W.conflicts.has(H))continue;const X=E.get(H);if(X.some(z=>z.command!==`-${H}`&&p.conflicts.has(w[z.key]))){W.conflicts.add(H);continue}Q=u(Q,H,X,o)}return{mergeContent:Q,hasChanges:!0,hasConflicts:W.conflicts.size>0}}e.merge=I;function S(m,C,s){const o=new Set,n=new Set,i=new Set,t=new Set;for(const r of C.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(C.updated.has(r)?t.add(r):n.add(r));for(const r of C.added.values())t.has(r)||s.added.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(C.added.has(r)?m.updated.has(r)&&t.add(r):o.add(r));for(const r of C.updated.values())t.has(r)||s.updated.has(r)&&m.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(C.updated.has(r)?m.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:n,updated:i,conflicts:t}}function D(m,C,s,o){const n=new Set,i=b(m,o),t=b(C,o),r=s?b(s,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const w=r?c(r,i):{added:[...i.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=r?c(r,t):{added:[...t.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:d,removed:E,updated:L,conflicts:N}=S(a,w,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:E,updated:L,conflicts:N}}function b(m,C){const s=new Map;for(const o of m){const n=C[o.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(o)}return s}function g(m){const C=new Map;for(const s of m){const o=s.command[0]==="-"?s.command.substring(1):s.command;let n=C.get(o);n||(n=[],C.set(o,n)),n.push(s)}return C}function c(m,C){const s=[...m.keys()],o=[...C.keys()],n=o.filter(r=>!s.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=s.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const a=m.get(r).map(p=>({...p,key:r})),w=C.get(r).map(p=>({...p,key:r}));(0,k.equals)(a,w,(p,d)=>v(p,d))||t.add(r)}return{added:n,removed:i,updated:t}}function f(m,C,s){const o=[...m.keys()],n=[...C.keys()],i=n.filter(a=>!o.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const w=m.get(a).map(d=>({...d,key:s[d.key]})),p=C.get(a).map(d=>({...d,key:s[d.key]}));y(w,p)||r.add(a)}return{added:i,removed:t,updated:r}}function y(m,C){return!(!(0,k.equals)(m.filter(({command:s})=>s[0]!=="-"),C.filter(({command:s})=>s[0]!=="-"),(s,o)=>v(s,o))||!(0,k.equals)(m.filter(({command:s})=>s[0]==="-"),C.filter(({command:s})=>s[0]==="-"),(s,o)=>v(s,o)))}function v(m,C){if(m.command!==C.command||m.key!==C.key)return!1;const s=T.ContextKeyExpr.deserialize(m.when),o=T.ContextKeyExpr.deserialize(C.when);return!(s&&!o||!s&&o||s&&o&&!s.equals(o)||!A.equals(m.args,C.args))}function l(m,C,s){for(const o of C)m=_.edit(m,[-1],o,s);return m}function h(m,C,s){const o=R(m);for(let n=o.length-1;n>=0;n--)(o[n].command===C||o[n].command===`-${C}`)&&(m=_.edit(m,[n],void 0,s));return m}function u(m,C,s,o){const n=R(m),i=n.findIndex(t=>t.command===C||t.command===`-${C}`);for(let t=n.length-1;t>=0;t--)(n[t].command===C||n[t].command===`-${C}`)&&(m=_.edit(m,[t],void 0,o));for(let t=s.length-1;t>=0;t--)m=_.edit(m,[i],s[t],o);return m}}),define(le[236],ue([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(T,_,R){const I={},S={},D=new Set;if(!_)return{local:{added:I,updated:S,removed:[...D.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const b=U(T,_);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:S,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=U(R,T),c=U(R,_),f={},y={},v=new Set,l=new Set;for(const h of g.removed.values())c.updated.has(h)?I[h]=_[h]:v.add(h);for(const h of c.removed.values())l.has(h)||(g.updated.has(h)?l.add(h):D.add(h));for(const h of g.updated.values())l.has(h)||(c.updated.has(h)?b.updated.has(h)&&l.add(h):y[h]=T[h]);for(const h of c.updated.values())l.has(h)||(g.updated.has(h)?b.updated.has(h)&&l.add(h):T[h]!==void 0&&(S[h]=_[h]));for(const h of g.added.values())l.has(h)||(c.added.has(h)?b.updated.has(h)&&l.add(h):f[h]=T[h]);for(const h of c.added.values())l.has(h)||(g.added.has(h)?b.updated.has(h)&&l.add(h):I[h]=_[h]);return{local:{added:I,removed:[...D.values()],updated:S},remote:{added:f,removed:[...v.values()],updated:y},conflicts:[...l.values()]}}e.merge=k;function U(T,_){const R=T?Object.keys(T):[],I=_?Object.keys(_):[],S=I.filter(g=>!R.includes(g)).reduce((g,c)=>(g.add(c),g),new Set),D=R.filter(g=>!I.includes(g)).reduce((g,c)=>(g.add(c),g),new Set),b=new Set;for(const g of R){if(D.has(g))continue;const c=T[g],f=_[g];c!==f&&b.add(g)}return{added:S,removed:D,updated:b}}function A(T,_){const{added:R,removed:I,updated:S}=U(T,_);return R.size===0&&I.size===0&&S.size===0}e.areSame=A}),define(le[237],ue([0,1,30]),function(ne,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function U(T,_,R,I){const S={added:[],removed:[],updated:[]};let D={added:[],removed:[],updated:[]};if(!_){const g=T.filter(({id:c})=>!I.includes(c));return g.length?D.added=g:D=null,{local:S,remote:D}}const b=A(T,_,I);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const g=A(R,T,I),c=A(R,_,I);for(const f of c.removed){const y=T.find(v=>v.id===f);y&&S.removed.push(y)}for(const f of c.added){const y=_.find(v=>v.id===f);g.added.includes(f)?b.updated.includes(f)&&S.updated.push(y):S.added.push(y)}for(const f of c.updated)S.updated.push(_.find(y=>y.id===f));for(const f of g.added)c.added.includes(f)||D.added.push(T.find(y=>y.id===f));for(const f of g.updated)c.removed.includes(f)||c.updated.includes(f)||D.updated.push(T.find(y=>y.id===f));for(const f of g.removed){const y=_.find(v=>v.id===f);y&&D.removed.push(y)}}return D.added.length===0&&D.removed.length===0&&D.updated.length===0&&(D=null),{local:S,remote:D}}e.merge=U;function A(T,_,R){T=T?T.filter(({id:c})=>!R.includes(c)):[],_=_.filter(({id:c})=>!R.includes(c));const I=T.map(({id:c})=>c),S=_.map(({id:c})=>c),D=S.filter(c=>!I.includes(c)),b=I.filter(c=>!S.includes(c)),g=[];for(const{id:c,name:f,shortName:y,icon:v,useDefaultFlags:l}of T){if(b.includes(c))continue;const h=_.find(u=>u.id===c);(!h||h.name!==f||h.shortName!==y||h.icon!==v||!(0,k.equals)(h.useDefaultFlags,l))&&g.push(c)}return{added:D,removed:b,updated:g}}}),define(le[24],ue([0,1,18,12,173,50,29,4,103,41]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=void 0;function D(){const t=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=D;function b(){const t=S.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(p=>!!t[p].ignoreSync),a=Object.keys(t).filter(p=>t[p].scope===2||t[p].scope===6),w=D();return(0,k.distinct)([...r,...a,...w])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function g(){const t="vscode://schemas/ignoredSettings",r=S.Registry.as(T.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=S.Registry.as(I.Extensions.JSONContribution),w=()=>{const p=D(),d=b(),E=Object.keys(T.allSettings.properties).filter(F=>!d.includes(F)),L=d.filter(F=>!p.includes(F)),N={items:{type:"string",enum:[...E,...L.map(F=>`-${F}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=g;function c(t){return t&&(0,U.isObject)(t)&&(0,U.isString)(t.id)&&Array.isArray(t.scopes)}e.isAuthenticationProvider=c;var f;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(f||(e.SyncResource=f={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.getPathSegments=y;function v(t,r,a,w){return w.joinPath(a.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,R.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(t){const r={};return r[e.HEADER_EXECUTION_ID]=t,r}e.createSyncHeaders=l;var h;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(h||(e.UserDataSyncErrorCode=h={}));class u extends Error{constructor(r,a,w,p){super(r),this.code=a,this.resource=w,this.operationId=p,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=u;class m extends u{constructor(r,a,w,p,d){super(r,w,void 0,d),this.url=a,this.serverCode=p}}e.UserDataSyncStoreError=m;class C extends u{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=C,function(t){function r(a){if(a instanceof t)return a;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(w&&w[1]){const p=w[2]==="unknown"?void 0:w[2],d=w[3]==="unknown"?void 0:w[3];return new t(a.message,w[1],p,d)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(u||(e.UserDataSyncError=u={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(le[238],ue([0,1,30,24]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(_,R,I,S,D){if(!R)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const b=T(_,R);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=I?T(I,R):{added:Object.keys(R).reduce((h,u)=>(h.add(u),h),new Set),removed:new Set,updated:new Set},c=I?T(I,_):{added:Object.keys(_).reduce((h,u)=>(h.add(u),h),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},y=k.deepClone(R),v=!I;for(const h of c.added.values())h!==U.SYNC_SERVICE_URL_TYPE&&v&&g.added.has(h)||(y[h]=_[h]);for(const h of c.updated.values())y[h]=_[h];for(const h of c.removed.values())S.unregistered.includes(h)||delete y[h];for(const h of g.added.values()){const u=R[h];if(S.machine.includes(h)){D.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(I&&c.added.has(h))continue;const m=_[h];m&&m.value===u.value||h===U.SYNC_SERVICE_URL_TYPE&&v&&c.added.has(h)||(m?f.updated[h]=u:f.added[h]=u)}for(const h of g.updated.values()){const u=R[h];if(S.machine.includes(h)){D.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(h)||c.removed.has(h))continue;const m=_[h];m&&m.value===u.value||(f.updated[h]=u)}for(const h of g.removed.values()){if(S.machine.includes(h)){D.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}c.updated.has(h)||c.removed.has(h)||f.removed.push(h)}const l=T(R,y);return{local:f,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:y}}}e.merge=A;function T(_,R){const I=Object.keys(_),S=Object.keys(R),D=S.filter(c=>!I.includes(c)).reduce((c,f)=>(c.add(f),c),new Set),b=I.filter(c=>!S.includes(c)).reduce((c,f)=>(c.add(f),c),new Set),g=new Set;for(const c of I){if(b.has(c))continue;const f=_[c],y=R[c];k.equals(f,y)||g.add(c)}return{added:D,removed:b,updated:g}}}),define(le[239],ue([0,1,18,35,86,42,30,79,24]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(a,w,p){let d=[];p?d=b(p):d=D(w);const E=[],L=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(d))for(const N of d)N.startsWith("-")?L.push(N.substring(1)):E.push(N);return(0,k.distinct)([...a,...E].filter(N=>!L.includes(N)))}e.getIgnoredSettings=S;function D(a){let w=a.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=a.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const w=(0,U.parse)(a);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function g(a,w){const p=(0,U.parse)(a)||{};let d="{}";for(const E of Object.keys(p)){const L=(0,A.setProperty)(d,[E],p[E],w);d=(0,A.applyEdits)(d,L)}return d}e.removeComments=g;function c(a,w,p,d){if(p.length){const E=r(w),L=(0,U.parse)(w)||{},N=(0,U.parse)(a);if(!N)return a;const F=[];for(const M of p){const W=L[M],Q=N[M];W===void 0?a=R.edit(a,[M],void 0,d):Q!==void 0?a=R.edit(a,[M],W,d):F.push(s(M,E))}F.sort((M,W)=>M.startOffset-W.startOffset),F.forEach(M=>a=h(M.setting.key,w,a,d))}return a}e.updateIgnoredSettings=c;function f(a,w,p,d,E,L){const N=c(a,w,d,L),F=p!==N,M=p!==w;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:c(w,a,d,L),remoteContent:null,hasConflicts:!1};if(p===null&&v(a)){const O=y(a,w,d)?null:c(w,a,d,L);return{conflictsSettings:[],localContent:O,remoteContent:null,hasConflicts:!1}}let W=a,Q=w;const H=(0,U.parse)(a),X=(0,U.parse)(w),z=p?(0,U.parse)(p):null,Y=d.reduce((O,B)=>(O.add(B),O),new Set),x=l(H,X,Y),q=l(z,H,Y),te=l(z,X,Y),se=new Map,Z=new Set,re=O=>{Z.add(O);const B=E.filter(({key:j})=>j===O)[0];B?(W=R.edit(W,[O],B.value,L),Q=R.edit(Q,[O],B.value,L)):se.set(O,{key:O,localValue:H[O],remoteValue:X[O]})};for(const O of q.removed.values())te.updated.has(O)?re(O):Q=R.edit(Q,[O],void 0,L);for(const O of te.removed.values())Z.has(O)||(q.updated.has(O)?re(O):W=R.edit(W,[O],void 0,L));for(const O of q.updated.values())Z.has(O)||(te.updated.has(O)?x.updated.has(O)&&re(O):Q=R.edit(Q,[O],H[O],L));for(const O of te.updated.values())Z.has(O)||(q.updated.has(O)?x.updated.has(O)&&re(O):W=R.edit(W,[O],X[O],L));for(const O of q.added.values())Z.has(O)||(te.added.has(O)?x.updated.has(O)&&re(O):Q=h(O,W,Q,L));for(const O of te.added.values())Z.has(O)||(q.added.has(O)?x.updated.has(O)&&re(O):W=h(O,Q,W,L));const G=se.size>0||!y(W,Q,d),$=G||!y(W,a,[]),P=G||!y(Q,w,[]);return{localContent:$?W:null,remoteContent:P?Q:null,conflictsSettings:[...se.values()],hasConflicts:G}}e.merge=f;function y(a,w,p){if(a===w)return!0;const d=(0,U.parse)(a),E=(0,U.parse)(w),L=p.reduce((M,W)=>(M.add(W),M),new Set),N=r(a).filter(M=>!(M.setting&&L.has(M.setting.key))),F=r(w).filter(M=>!(M.setting&&L.has(M.setting.key)));if(N.length!==F.length)return!1;for(let M=0;M<N.length;M++){const W=N[M],Q=F[M];if(W.setting&&Q.setting){if(W.setting.key!==Q.setting.key||!_.equals(d[W.setting.key],E[W.setting.key]))return!1}else if(!W.setting&&!Q.setting){if(W.value!==Q.value)return!1}else return!1}return!0}function v(a){return a?r(a).length===0:!0}e.isEmpty=v;function l(a,w,p){const d=a?Object.keys(a).filter(M=>!p.has(M)):[],E=Object.keys(w).filter(M=>!p.has(M)),L=E.filter(M=>!d.includes(M)).reduce((M,W)=>(M.add(W),M),new Set),N=d.filter(M=>!E.includes(M)).reduce((M,W)=>(M.add(W),M),new Set),F=new Set;if(a)for(const M of d){if(N.has(M))continue;const W=a[M],Q=w[M];_.equals(W,Q)||F.add(M)}return{added:L,removed:N,updated:F}}function h(a,w,p,d){const E=(0,U.parse)(w),L=r(w),N=r(p),F=u(a,L,N);return m(p,a,E[a],F,N,d)}e.addSetting=h;function u(a,w,p){const d=w.findIndex(L=>L.setting?.key===a),E=w[d-1];if(E){if(E.setting){const N=s(E.setting.key,p);if(N)return{index:p.indexOf(N),insertAfter:!0}}else{const N=o(d,w);if(N){const F=s(N.setting.key,p);if(F){const M=n(p.indexOf(F),p),W=i(w,N,w[d]);if(M){const Q=i(p,F,M),H=t(W,Q);return H?{index:p.indexOf(H),insertAfter:!0}:{index:p.indexOf(M),insertAfter:!1}}else{const Q=i(p,F,p[p.length-1]),H=t(W,Q);return H?{index:p.indexOf(H),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const L=w[d+1];if(L)if(L.setting){const N=s(L.setting.key,p);if(N)return{index:p.indexOf(N),insertAfter:!1}}else{const N=n(d,w);if(N){const F=s(N.setting.key,p);if(F){const M=o(p.indexOf(F),p),W=i(w,w[d],N);if(M){const Q=i(p,M,F),H=t(W.reverse(),Q.reverse());return H?{index:p.indexOf(H),insertAfter:!1}:{index:p.indexOf(M),insertAfter:!0}}else{const Q=i(p,p[0],F),H=t(W.reverse(),Q.reverse());return H?{index:p.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function m(a,w,p,d,E,L){let N;return d.index===-1?N=(0,A.setProperty)(a,[w],p,L):N=C(a,w,p,d,E,L).map(F=>(0,A.withFormatting)(a,F,L)[0]),(0,A.applyEdits)(a,N)}function C(a,w,p,d,E,L){const N=`${JSON.stringify(w)}: ${JSON.stringify(p)}`,F=(0,T.getEOL)(L,a),M=E[d.index];if(d.insertAfter){const W=[];if(M.setting)W.push({offset:M.endOffset,length:0,content:","+N});else{const Q=n(d.index,E),H=o(d.index,E),X=H?.setting?.commaOffset;H&&X===void 0&&W.push({offset:H.endOffset,length:0,content:","});const z=X!==void 0&&X>M.endOffset;W.push({offset:z?X+1:M.endOffset,length:0,content:Q?F+N+",":F+N})}return W}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const W=(E[d.index-1]&&!E[d.index-1].setting?F:"")+N+(n(d.index,E)?",":"")+F;return[{offset:M.startOffset,length:0,content:W}]}}function s(a,w){return w.filter(p=>p.setting?.key===a)[0]}function o(a,w){for(let p=a-1;p>=0;p--)if(w[p].setting)return w[p]}function n(a,w){for(let p=a+1;p<w.length;p++)if(w[p].setting)return w[p]}function i(a,w,p){const d=a.indexOf(w),E=a.indexOf(p);return a.filter((L,N)=>d<N&&N<E)}function t(a,w){if(a.length&&w.length){let p=0;for(;p<w.length&&p<a.length;p++)if(a[p].value!==w[p].value)return w[p-1];return w[p-1]}}function r(a){const w=[];let p=-1,d,E;const L={onObjectBegin:N=>{p++},onObjectProperty:(N,F,M)=>{p===0&&(d=F,E=N)},onObjectEnd:(N,F)=>{p--,p===0&&w.push({startOffset:d,endOffset:N+F,value:a.substring(d,N+F),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(N,F)=>{p++},onArrayEnd:(N,F)=>{p--,p===0&&w.push({startOffset:d,endOffset:N+F,value:a.substring(d,N+F),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(N,F,M)=>{p===0&&w.push({startOffset:d,endOffset:F+M,value:a.substring(d,F+M),setting:{key:E,commaOffset:void 0}})},onSeparator:(N,F,M)=>{if(p===0&&N===","){let W=w.length-1;for(;W>=0&&!w[W].setting;W--);const Q=w[W];Q&&w.splice(W,1,{startOffset:Q.startOffset,endOffset:Q.endOffset,value:Q.value,setting:{key:Q.setting.key,commaOffset:F}})}},onComment:(N,F)=>{p===0&&w.push({startOffset:N,endOffset:N+F,value:a.substring(N,N+F)})}};return(0,U.visit)(a,L),w}}),define(le[80],ue([0,1,3,2,4,24]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,A.createDecorator)("IUserDataSyncAccountService");let _=class extends U.Disposable{get account(){return this._account}constructor(I,S){super(),this.userDataSyncStoreService=I,this.logService=S,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(D=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,D),this.updateAccount(void 0),D==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};e.UserDataSyncAccountService=_,e.UserDataSyncAccountService=_=ye([J(0,T.IUserDataSyncStoreService),J(1,T.IUserDataSyncLogService)],_)}),define(le[240],ue([0,1,2,10]),function(ne,e,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(g){this.service=g}listen(g,c){switch(c){case"onError":return this.service.onError}throw new Error(`Event not found: ${c}`)}call(g,c,f){switch(c){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class T{constructor(g){this.service=g}listen(g,c){throw new Error(`Event not found: ${c}`)}call(g,c,f){switch(c){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(U.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class _{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=_;class R{constructor(g){this.service=g}listen(g,c){switch(c){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${c}`)}async call(g,c,f){switch(c){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class I{constructor(g){this.service=g}listen(g,c){switch(c){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(g,c,f){switch(c){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class S{constructor(g){this.service=g}listen(g,c){switch(c){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(g,c,f){switch(c){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class D extends k.Disposable{constructor(g){super(),this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:U.URI.revive(g.url),type:g.type,defaultUrl:U.URI.revive(g.defaultUrl),insidersUrl:U.URI.revive(g.insidersUrl),stableUrl:U.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=D}),define(le[241],ue([0,1,19,174,14,8,24]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends T.AbstractLogger{constructor(S,D){super(),this.logger=this._register(S.createLogger((0,k.joinPath)(D.logsHome,`${_.USER_DATA_SYNC_LOG_ID}.log`),{id:_.USER_DATA_SYNC_LOG_ID,name:(0,U.localize)(0,null)}))}trace(S,...D){this.logger.trace(S,...D)}debug(S,...D){this.logger.debug(S,...D)}info(S,...D){this.logger.info(S,...D)}warn(S,...D){this.logger.warn(S,...D)}error(S,...D){this.logger.error(S,...D)}flush(){this.logger.flush()}};e.UserDataSyncLogService=R,e.UserDataSyncLogService=R=ye([J(0,T.ILoggerService),J(1,A.IEnvironmentService)],R)}),define(le[242],ue([0,1,6,3,2]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends A.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:I,getActiveWindowId:S}){super(),this.disposables=this._register(new A.DisposableStore),U.Event.latch(U.Event.any(R,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>S()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(le[112],ue([0,1,177,16,47,19,10,4,23]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function S(i){const t=i;return typeof t?.id=="string"&&_.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=S;function D(i){return typeof i?.id=="string"&&!S(i)&&!g(i)}e.isEmptyWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,U.basename)(i)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=b;function g(i){const t=i;return typeof t?.id=="string"&&_.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=g;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:_.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=c;var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function y(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=y;function v(i){const t=i;return!!(t&&typeof t=="object"&&_.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=v;class l{constructor(t,r,a,w,p){this._id=t,this._transient=a,this._configuration=w,this._ignorePathCasing=p,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class h{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,T.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function u(i){return new h({uri:i,index:0,name:(0,T.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=u,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(i,t){return T.extUriBiasedIgnorePathCase.isEqualOrParent(i,t.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function C(i){let t;return _.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=C,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=s;function o(i,t){return!m(i,t)&&!C(i)}e.isSavedWorkspace=o;function n(i){return(typeof i=="string"?(0,U.extname)(i):(0,T.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(le[17],ue([0,1,53,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var u;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function m(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&_.URI.isUri(t.location)&&_.URI.isUri(t.globalStorageHome)&&_.URI.isUri(t.settingsResource)&&_.URI.isUri(t.keybindingsResource)&&_.URI.isUri(t.tasksResource)&&_.URI.isUri(t.snippetsHome)&&_.URI.isUri(t.extensionsResource))}e.isUserDataProfile=m,e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function C(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:_.URI.revive(i.location).with({scheme:t}),globalStorageHome:_.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:_.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:_.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:_.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:_.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:_.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:_.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=C;function s(i,t,r,a,w,p){return{id:i,name:t,location:r,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:p&&w?.useDefaultFlags?.globalState?p.globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:p&&w?.useDefaultFlags?.settings?p.settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:p&&w?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:p&&w?.useDefaultFlags?.tasks?p.tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:p&&w?.useDefaultFlags?.snippets?p.snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:p&&w?.useDefaultFlags?.extensions?p.extensionsResource:(0,T.joinPath)(r,"extensions.json"),cacheHome:(0,T.joinPath)(a,i),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}e.toUserDataProfile=s;let o=class extends A.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,a,w){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=a,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new U.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new U.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new U.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new U.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new c.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,T.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.createDefaultProfile(),r=[t];if(this.enabled)try{for(const p of this.getStoredProfiles()){if(!p.name||!(0,h.isString)(p.name)||!p.location){this.logService.warn("Skipping the invalid stored profile",p.location||p.name);continue}r.push(s((0,T.basename)(p.location),p.name,p.location,this.profilesCacheHome,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},t))}}catch(p){this.logService.error(p)}const a=new c.ResourceMap,w=new Map;if(r.length)try{const p=this.getStoredProfileAssociations();if(p.workspaces)for(const[d,E]of Object.entries(p.workspaces)){const L=_.URI.parse(d),N=r.find(F=>F.id===E);N&&a.set(L,N)}if(p.emptyWindows)for(const[d,E]of Object.entries(p.emptyWindows)){const L=r.find(N=>N.id===E);L&&w.set(d,L)}}catch(p){this.logService.error(p)}this._profilesObject={profiles:r,workspaces:a,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const t=s("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...t,extensionsResource:this.getDefaultProfileExtensionsLocation()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.escapeRegExpCharacters)(r)}\\s(\\d+)`);let w=0;for(const d of this.profiles){const E=a.exec(d.name),L=E?parseInt(E[1]):0;w=L>w?L:w}const p=`${r} ${w+1}`;return this.createProfile((0,k.hash)((0,v.generateUuid)()).toString(16),p,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,k.hash)((0,v.generateUuid)()).toString(16),t,r,a)}async createProfile(t,r,a,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const p=await this.doCreateProfile(t,r,a);return w&&await this.setProfileForWorkspace(w,p),p}async doCreateProfile(t,r,a){if(!(0,h.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(r);return w||(w=(async()=>{try{const p=this.profiles.find(L=>L.name===r||L.id===t);if(p)return p;const d=s(t,r,(0,T.joinPath)(this.profilesHome,t),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(d.location);const E=[];return this._onWillCreateProfile.fire({profile:d,join(L){E.push(L)}}),await y.Promises.settled(E),this.updateProfiles([d],[],[]),d}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,w)),w}async updateProfile(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(w=>w.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=s(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(t){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(w=>w.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(w){a.push(w)}});try{await Promise.allSettled(a)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(w){(0,S.toFileOperationResult)(w)!==1&&this.logService.error(w)}}async setProfileForWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(w=>w.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,a)}unsetWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return _.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(t){return(0,g.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,g.isWorkspaceIdentifier)(t)?t.configPath:t.id}isProfileAssociatedToWorkspace(t){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,a){const w=[...this.profiles,...t],p=[];this.transientProfilesObject.profiles=[];for(let d of w)d.isDefault||r.some(E=>d.id===E.id)||(d=a.find(E=>d.id===E.id)??d,d.isTransient?this.transientProfilesObject.profiles.push(d):p.push({location:d.location,name:d.name,shortName:d.shortName,icon:d.icon,useDefaultFlags:d.useDefaultFlags}));this.saveStoredProfiles(p),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,a)}triggerProfilesChanges(t,r,a){this._onDidChangeProfiles.fire({added:t,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(t,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(t,void 0,!0);const w=this.getWorkspace(t),p=a?this.transientProfilesObject:this.profilesObject;_.URI.isUri(w)?(p.workspaces.delete(w),r&&p.workspaces.set(w,r)):(p.emptyWindows.delete(w),r&&p.emptyWindows.set(w,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[a,w]of this.profilesObject.workspaces.entries())t[a.toString()]=w.id;const r={};for(const[a,w]of this.profilesObject.emptyWindows.entries())r[a.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:t,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(t){const r={},a=this.createDefaultProfile();if(t.workspaces)for(const[p,d]of Object.entries(t.workspaces)){const E=_.URI.parse(d);r[p]=this.uriIdentityService.extUri.isEqual(E,a.location)?a.id:this.uriIdentityService.extUri.basename(E)}const w={};if(t.emptyWindows)for(const[p,d]of Object.entries(t.emptyWindows)){const E=_.URI.parse(d);w[p]=this.uriIdentityService.extUri.isEqual(E,a.location)?a.id:this.uriIdentityService.extUri.basename(E)}return{workspaces:r,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=ye([J(0,I.IEnvironmentService),J(1,S.IFileService),J(2,f.IUriIdentityService),J(3,b.ILogService)],o);class n extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=n}),define(le[243],ue([0,1,6,2,17]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends U.Disposable{constructor(R){super(),this._register(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=T,e.UserDataProfilesCleaner=T=ye([J(0,A.IUserDataProfilesService)],T)}),define(le[244],ue([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.toExtensionManagementError=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(t,r,a,w,p,d){super(),this.galleryService=t,this.telemetryService=r,this.uriIdentityService=a,this.logService=w,this.productService=p,this.userDataProfilesService=d,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this._onDidUpdateExtensionMetadata=this._register(new _.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:E})=>E.cancel()),this.uninstallingExtensions.forEach(E=>E.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,g.isTargetPlatformCompatible)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const w=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:p})=>(0,c.areSameExtensions)(p,t.identifier));if(w?.local)return w?.local;throw w?.error?w.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw s(a)}}async installGalleryExtensions(t){if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(b.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:w,options:p})=>{try{const d=await this.checkAndGetCompatibleVersion(w,!!p?.installGivenVersion,!!p?.installPreReleaseVersion);a.push({...d,options:p})}catch(d){r.push({identifier:w.identifier,operation:2,source:w,error:d})}})),a.length&&r.push(...await this.installExtensions(a));for(const w of r)w.error&&(this.logService.error("Failed to install extension.",w.identifier.id),this.logService.error(w.error),w.source&&!D.URI.isUri(w.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(w.source),error:w.error}));return r}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async toggleAppliationScope(t,r){if((0,f.isApplicationScopedExtension)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(a=await this.copyExtension(t,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const w of this.userDataProfilesService.profiles){const p=(await this.getInstalled(1,w.extensionsResource)).find(d=>(0,c.areSameExtensions)(d.identifier,t.identifier));p?this._onDidUpdateExtensionMetadata.fire(p):this._onDidUninstallExtension.fire({identifier:t.identifier,profileLocation:w.extensionsResource})}return a}else{const a=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(t,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtensions(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const w=await this.installExtension(a,(p,d)=>t.some(E=>(0,c.adoptToGalleryExtensionId)(d.identifier.id)===(0,c.getGalleryExtensionId)(E.manifest.publisher,E.manifest.name))?!1:this.canWaitForTask(p,d));r.push(...w)}catch(w){r.push({identifier:{id:(0,c.getGalleryExtensionId)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:w})}})),this._onDidInstallExtensions.fire(r),r}async installExtension({manifest:t,extension:r,options:a},w){const p=a.isApplicationScoped||a.isBuiltin||(0,f.isApplicationScopedExtension)(t),d={...a,installOnlyNewlyAddedFromExtensionPack:D.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:p,profileLocation:p?this.userDataProfilesService.defaultProfile.extensionsResource:a.profileLocation??this.getCurrentExtensionsManifestLocation()},E=Q=>`${c.ExtensionKey.create(Q).toString()}${d.profileLocation?`-${d.profileLocation.toString()}`:""}`;if(!D.URI.isUri(r)){const Q=this.installingExtensions.get(E(r));if(Q)return this.logService.info("Extensions is already requested to install",r.identifier.id),await Q.task.waitUntilTaskIsFinished(),[]}const L=[],N=[],F=[],M=this.createInstallExtensionTask(t,r,d);D.URI.isUri(r)||this.installingExtensions.set(E(r),{task:M,waitingTasks:[]}),this._onInstallExtension.fire({identifier:M.identifier,source:r,profileLocation:d.profileLocation}),this.logService.info("Installing extension:",M.identifier.id),L.push({task:M,manifest:t});let W=!1;try{if(d.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const H=await this.getAllDepsAndPackExtensions(M.identifier,t,!!d.installOnlyNewlyAddedFromExtensionPack,!!d.installPreReleaseVersion,d.profileLocation),X=await this.getInstalled(void 0,d.profileLocation),z={...d,donotIncludePackAndDependencies:!0,context:{...d.context,[g.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:Y,manifest:x}of(0,k.distinct)(H,({gallery:q})=>q.identifier.id)){W=W||!!x.extensionDependencies?.some(se=>(0,c.areSameExtensions)({id:se},M.identifier));const q=E(Y),te=this.installingExtensions.get(q);if(te){if(w(M,te.task)){const se=te.task.identifier;this.logService.info("Waiting for already requested installing extension",se.id,M.identifier.id),te.waitingTasks.push(M),N.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,Z=>Z.some(re=>(0,c.areSameExtensions)(re.identifier,se)))).then(Z=>{if(this.logService.info("Finished waiting for already requested installing extension",se.id,M.identifier.id),!Z.find(G=>(0,c.areSameExtensions)(G.identifier,se))?.local)throw new Error(`Extension ${se.id} is not installed`)}))}}else if(!X.some(({identifier:se})=>(0,c.areSameExtensions)(se,Y.identifier))){const se=this.createInstallExtensionTask(x,Y,z);this.installingExtensions.set(q,{task:se,waitingTasks:[M]}),this._onInstallExtension.fire({identifier:se.identifier,source:Y,profileLocation:d.profileLocation}),this.logService.info("Installing extension:",se.identifier.id,M.identifier.id),L.push({task:se,manifest:x})}}}catch(H){if(D.URI.isUri(M.source))(0,k.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,H.message),(0,k.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,H.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),H}const Q=L.reduce((H,{task:X,manifest:z})=>(H.set(X.identifier.id.toLowerCase(),{task:X,manifest:z}),H),new Map);for(;Q.size;){let H;const X=[...Q.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(Y=>Q.has(Y.toLowerCase())));X.length?H=Q.size===1?X:X.filter(({task:z})=>!(z===M&&!W)):(this.logService.info("Found extensions with circular dependencies",X.map(({task:z})=>z.identifier.id)),H=[...Q.values()]),await this.joinAllSettled(H.map(async({task:z})=>{const Y=new Date().getTime();try{const x=await z.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(x,z.source,d,A.CancellationToken.None))),!D.URI.isUri(z.source)){const q=z.operation===3,te=q?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(o(this.telemetryService,q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-Y,durationSinceUpdate:te}),I.isWeb&&z.operation!==3)try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch{}}F.push({local:x,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:x.isApplicationScoped})}catch(x){throw D.URI.isUri(z.source)||o(this.telemetryService,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-Y,error:x}),this.logService.error("Error while installing the extension:",z.identifier.id),x}finally{Q.delete(z.identifier.id.toLowerCase())}}))}return N.length&&await this.joinAllSettled(N),F.forEach(({identifier:H})=>this.logService.info("Extension installed successfully:",H.id)),F}catch(Q){if(L.forEach(({task:H})=>H.cancel()),F.length)try{const H=await Promise.allSettled(F.map(({local:X})=>this.createUninstallExtensionTask(X,{versionOnly:!0,profileLocation:d.profileLocation}).run()));for(let X=0;X<H.length;X++){const z=H[X],{identifier:Y}=F[X];z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Y.id):this.logService.warn("Rollback: Error while uninstalling extension",Y.id,(0,T.getErrorMessage)(z.reason))}}catch(H){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(H),F.map(({identifier:X})=>X.id))}return L.map(({task:H})=>({identifier:H.identifier,operation:2,source:H.source,context:d.context,profileLocation:d.profileLocation,error:Q}))}finally{for(const{task:Q}of L)Q.source&&!D.URI.isUri(Q.source)&&this.installingExtensions.delete(E(Q.source))}}canWaitForTask(t,r){for(const[,{task:a,waitingTasks:w}]of this.installingExtensions.entries())if(a===t&&(w.includes(r)||w.some(p=>this.canWaitForTask(p,r)))||a===r&&w[0]&&!this.canWaitForTask(t,w[0]))return!1;return!0}async joinAllSettled(t){const r=[],a=[],w=await Promise.allSettled(t);for(const p of w)p.status==="fulfilled"?r.push(p.value):a.push(p.reason);if(a.length)throw C(a);return r}async getAllDepsAndPackExtensions(t,r,a,w,p){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,p),E=[],L=[],N=async(F,M)=>{E.push(F);const W=M.extensionDependencies||[],Q=[...W];if(M.extensionPack){const H=a?d.find(X=>(0,c.areSameExtensions)(X.identifier,F)):void 0;for(const X of M.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(z=>(0,c.areSameExtensions)({id:z},{id:X}))||Q.every(z=>!(0,c.areSameExtensions)({id:z},{id:X}))&&Q.push(X)}if(Q.length){const H=Q.filter(X=>E.every(z=>!(0,c.areSameExtensions)(z,{id:X})));if(H.length){const X=await this.galleryService.getExtensions(H.map(z=>({id:z,preRelease:w})),A.CancellationToken.None);for(const z of X){if(E.find(q=>(0,c.areSameExtensions)(q,z.identifier)))continue;const Y=W.some(q=>(0,c.areSameExtensions)({id:q},z.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(z,!1,w)}catch(q){if(Y)throw q;this.logService.info("Skipping the packed extension as it cannot be installed",z.identifier.id,(0,T.getErrorMessage)(q));continue}L.push({gallery:x.extension,manifest:x.manifest}),await N(x.extension.identifier,x.manifest)}}}};return await N(t,r),L}async checkAndGetCompatibleVersion(t,r,a){let w;const p=await this.getExtensionsControlManifest();if(p.malicious.some(L=>(0,c.areSameExtensions)(t.identifier,L)))throw new g.ExtensionManagementError(b.localize(1,null,t.identifier.id),g.ExtensionManagementErrorCode.Malicious);const d=p.deprecated[t.identifier.id.toLowerCase()];if(d?.extension?.autoMigrate){if(this.logService.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${d.extension.id}' extension instead.`),w=(await this.galleryService.getExtensions([{id:d.extension.id,preRelease:d.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!w)throw new g.ExtensionManagementError(b.localize(2,null,t.identifier.id,d.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const L=await this.getTargetPlatform();throw new g.ExtensionManagementError(b.localize(3,null,t.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(L)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(w=await this.getCompatibleVersion(t,r,a),!w)throw!a&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],A.CancellationToken.None))[0]?new g.ExtensionManagementError(b.localize(4,null,t.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",w.identifier.id);const E=await this.galleryService.getManifest(w,A.CancellationToken.None);if(E===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${w.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(E.version!==w.version)throw new g.ExtensionManagementError(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:E}}async getCompatibleVersion(t,r,a){const w=await this.getTargetPlatform();let p=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(p=(await this.galleryService.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:w,compatible:!0},A.CancellationToken.None))[0]||null),!p&&await this.galleryService.isExtensionCompatible(t,a,w)&&(p=t),p||(r?p=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:w,compatible:!0},A.CancellationToken.None))[0]||null:p=await this.galleryService.getCompatibleExtension(t,a,w)),p}async uninstallExtension(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},w=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,p=this.uninstallingExtensions.get(w(t.identifier));if(p)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),p.waitUntilTaskIsFinished();const d=F=>{const M=this.createUninstallExtensionTask(F,a);return this.uninstallingExtensions.set(w(M.extension.identifier),M),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},E=(F,M)=>{M?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,c.getLocalExtensionTelemetryData)(F),error:M}),this._onDidUninstallExtension.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},L=[],N=[];try{L.push(d(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(t,F);for(const W of M)this.uninstallingExtensions.has(w(W.identifier))?this.logService.info("Extensions is already requested to uninstall",W.identifier.id):L.push(d(W))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(L.map(M=>M.extension),F,t),await this.joinAllSettled(L.map(async M=>{try{if(await M.run(),await this.joinAllSettled(this.participants.map(W=>W.postUninstall(M.extension,a,A.CancellationToken.None))),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}E(M.extension)}catch(W){const Q=W instanceof g.ExtensionManagementError?W:new g.ExtensionManagementError((0,T.getErrorMessage)(W),g.ExtensionManagementErrorCode.Internal);throw E(M.extension,Q),Q}finally{N.push(M)}}))}catch(F){const M=F instanceof g.ExtensionManagementError?F:new g.ExtensionManagementError((0,T.getErrorMessage)(F),g.ExtensionManagementErrorCode.Internal);for(const W of L){try{W.cancel()}catch{}N.includes(W)||E(W.extension,M)}throw M}finally{for(const F of L)this.uninstallingExtensions.delete(w(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(t,r,a){for(const w of t){const p=this.getDependents(w,r);if(p.length){const d=p.filter(E=>!t.some(L=>(0,c.areSameExtensions)(L.identifier,E.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(w,d,a))}}}getDependentsErrorMessage(t,r,a){return a===t?r.length===1?b.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const w=t.manifest.extensionPack?t.manifest.extensionPack:[];if(w.length){const p=r.filter(E=>!E.isBuiltin&&w.some(L=>(0,c.areSameExtensions)({id:L},E.identifier))),d=[];for(const E of p)d.push(...this.getAllPackExtensionsToUninstall(E,r,a));return[...p,...d]}return[]}getDependents(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(w=>(0,c.areSameExtensions)({id:w},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=m,e.AbstractExtensionManagementService=m=ye([J(0,g.IExtensionGalleryService),J(1,l.ITelemetryService),J(2,h.IUriIdentityService),J(3,y.ILogService),J(4,v.IProductService),J(5,u.IUserDataProfilesService)],m);function C(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=C;function s(i){if(i instanceof g.ExtensionManagementError)return i;const t=new g.ExtensionManagementError(i.message,g.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.toExtensionManagementError=s;function o(i,t,{extensionData:r,verificationStatus:a,duration:w,error:p,durationSinceUpdate:d}){let E,L;(0,S.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(E=g.ExtensionManagementErrorCode.Signature,L=a),a="Unverified")),p&&(p instanceof g.ExtensionManagementError?(E=p.code,p.code===g.ExtensionManagementErrorCode.Signature&&(L=p.message)):E=g.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!p,duration:w,errorcode:E,errorcodeDetail:L,durationSinceUpdate:d})}class n{constructor(){this.barrier=new U.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(t=>new Promise((r,a)=>{const w=t.onCancellationRequested(()=>{w.dispose(),a(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(le[51],ue([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class u extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=u,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let m=class extends A.Disposable{constructor(n,i,t,r,a,w){super(),this.extensionsLocation=n,this.fileService=i,this.userDataProfilesService=t,this.uriIdentityService=r,this.telemetryService=a,this.logService=w,this._onAddExtensions=this._register(new T.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new T.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new T.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new T.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(n,i){return this.withProfileExtensions(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.withProfileExtensions(i,a=>{const w=[];for(const p of a)n.some(([d])=>(0,S.areSameExtensions)(d.identifier,p.identifier)&&d.manifest.version!==p.version)?t.push(p):w.push(p);for(const[p,d]of n){const E=w.findIndex(N=>(0,S.areSameExtensions)(N.identifier,p.identifier)&&N.version===p.manifest.version),L={identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:d};E===-1?(r.push(L),w.push(L)):w.splice(E,1,L)}return r.length&&this._onAddExtensions.fire({extensions:r,profileLocation:i}),t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:i}),w}),r.length&&this._onDidAddExtensions.fire({extensions:r,profileLocation:i}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this._onDidAddExtensions.fire({extensions:r,error:a,profileLocation:i}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const t=[];return await this.withProfileExtensions(i,r=>{const a=[];for(const w of r){const p=n.find(([d])=>(0,S.areSameExtensions)(d.identifier,w.identifier)&&d.manifest.version===w.version);p&&(w.metadata={...w.metadata,...p[1]},t.push(w)),a.push(w)}return a}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.withProfileExtensions(i,r=>{const a=[];for(const w of r)(0,S.areSameExtensions)(w.identifier,n.identifier)?t.push(w):a.push(w);return t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:i}),a}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:r,profileLocation:i}),r}}async withProfileExtensions(n,i,t){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],a;try{const w=await this.fileService.readFile(n);a=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,D.toFileOperationResult)(w)!==1)throw w;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&t?.bailOutWhenFileNotFound)throw new u((0,v.getErrorMessage)(w),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let w=!1;for(const p of a){C(p)||this.reportAndThrowInvalidConentError(n);let d;if((0,y.isString)(p.relativeLocation)&&p.relativeLocation)d=this.resolveExtensionLocation(p.relativeLocation);else if((0,y.isString)(p.location))d=this.resolveExtensionLocation(p.location),w=!0,p.relativeLocation=p.location,p.location=d.toJSON();else{d=R.URI.revive(p.location);const E=this.toRelativePath(d);E&&(w=!0,p.relativeLocation=E)}r.push({identifier:p.identifier,location:d,version:p.version,metadata:p.metadata})}w&&await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(a)))}if(i){r=i(r);const w=r.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),relativeLocation:this.toRelativePath(p.location),metadata:p.metadata}));await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(w)))}return r})}reportAndThrowInvalidConentError(n){const i=new u(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let t;try{t=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,D.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(w=>C(w))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,D.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,D.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(i)}catch(a){(0,D.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let i=this.resourcesAccessQueueMap.get(n);return i||(i=new k.Queue,this.resourcesAccessQueueMap.set(n,i)),i}};e.AbstractExtensionsProfileScannerService=m,e.AbstractExtensionsProfileScannerService=m=ye([J(1,D.IFileService),J(2,c.IUserDataProfilesService),J(3,f.IUriIdentityService),J(4,l.ITelemetryService),J(5,g.ILogService)],m);function C(o){return(0,y.isObject)(o)&&(0,I.isIExtensionIdentifier)(o.identifier)&&(s(o.location)||(0,y.isString)(o.location)&&o.location)&&((0,y.isUndefined)(o.relativeLocation)||(0,y.isString)(o.relativeLocation))&&o.version&&(0,y.isString)(o.version)}function s(o){return o?(0,y.isString)(o.path)&&(0,y.isString)(o.scheme):!1}}),define(le[81],ue([0,1,18,6,30,15,7,35,137,2,23,16,5,19,55,89,12,10,154,14,33,44,70,11,4,8,25,3,65,51,17,28,182]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C,s,o,n,i,t,r,a,w,p,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var L;(function(X){function z(Y,x){if(Y===x)return!0;const q=Object.keys(Y),te=new Set;for(const se of Object.keys(x))te.add(se);if(q.length!==te.size)return!1;for(const se of q){if(Y[se]!==x[se])return!1;te.delete(se)}return te.size===0}X.equals=z})(L||(e.Translations=L={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let N=class extends S.Disposable{constructor(z,Y,x,q,te,se,Z,re,G,$,P,O){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=Y,this.extensionsControlLocation=x,this.currentProfile=q,this.userDataProfilesService=te,this.extensionsProfileScannerService=se,this.fileService=Z,this.logService=re,this.environmentService=G,this.productService=$,this.uriIdentityService=P,this.instantiationService=O,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,c.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(W,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(W,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(M,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,m.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(z,Y,x){const[q,te]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(Y)]),se=x?await this.scanExtensionsUnderDevelopment(z,[...q,...te]):[];return this.dedupExtensions(q,te,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!z.useCache,z.language)),Y.push(this.scanDevSystemExtensions(z.language,!!z.checkControlFile));const[x,q]=await Promise.all(Y);return this.applyScanOptions([...x,...q],0,z,!1)}async scanUserExtensions(z){const Y=z.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const x=this.uriIdentityService.extUri.isEqual(z.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(Y,!!z.profileLocation,1,!z.includeUninstalled,z.language,!0,x),te=z.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let se;try{se=await te.scanExtensions(q)}catch(Z){if(Z instanceof w.ExtensionsProfileScanningError&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),se=await te.scanExtensions(q);else throw Z}return se=await this.applyScanOptions(se,1,z,!0),this.logService.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(z,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===D.Schemas.file).map(async q=>{const te=await this.createExtensionScannerInput(q,!1,1,!0,z.language,!1,void 0);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(Z=>(Z.type=Y.find(re=>(0,m.areSameExtensions)(re.identifier,Z.identifier))?.type??Z.type,this.extensionsScanner.validate(Z,te)))}))).flat();return this.applyScanOptions(x,"development",z,!0)}return[]}async scanExistingExtension(z,Y,x){const q=await this.createExtensionScannerInput(z,!1,Y,!0,x.language,!0,void 0),te=await this.extensionsScanner.scanExtension(q);return!te||!x.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(z,Y,x){const q=await this.createExtensionScannerInput(z,!1,Y,!0,x.language,!0,void 0),te=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(te,Y,x,!0)}async scanMetadata(z){const Y=(0,c.joinPath)(z,"package.json"),x=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(z,Y){const x=(0,c.joinPath)(z,"package.json"),q=(await this.fileService.readFile(x)).value.toString(),te=JSON.parse(q);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,te.__metadata={...te.__metadata,...Y},await this.fileService.writeFile((0,c.joinPath)(z,"package.json"),T.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(z){if(z instanceof w.ExtensionsProfileScanningError&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw z}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const z=await this.scanUserExtensions({includeInvalid:!0});if(z.length)await this.extensionsProfileScannerService.addExtensionsToProfile(z.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,o.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(z){this.logService.error(z)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(z,Y,x,q){return x.includeAllVersions||(z=this.dedupExtensions(Y===0?z:void 0,Y===1?z:void 0,Y==="development"?z:void 0,await this.getTargetPlatform(),q)),x.includeInvalid||(z=z.filter(te=>te.isValid)),z.sort((te,se)=>{const Z=b.basename(te.location.fsPath),re=b.basename(se.location.fsPath);return Z<re?-1:Z>re?1:0})}dedupExtensions(z,Y,x,q,te){const se=(re,G,$)=>{if(re.isValid&&!G.isValid)return!1;if(re.isValid===G.isValid){if(te&&f.gt(re.manifest.version,G.manifest.version))return this.logService.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(f.eq(re.manifest.version,G.manifest.version)){if(re.type===0)return this.logService.debug(`Skipping extension ${G.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===q)return this.logService.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return $?this.logService.warn(`Overwriting user extension ${re.location.path} with ${G.location.path}.`):this.logService.debug(`Overwriting user extension ${re.location.path} with ${G.location.path}.`),!0},Z=new C.ExtensionIdentifierMap;return z?.forEach(re=>{const G=Z.get(re.identifier.id);(!G||se(G,re,!1))&&Z.set(re.identifier.id,re)}),Y?.forEach(re=>{const G=Z.get(re.identifier.id);if(!G&&z&&re.type===0){this.logService.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!G||se(G,re,!1))&&Z.set(re.identifier.id,re)}),x?.forEach(re=>{const G=Z.get(re.identifier.id);(!G||se(G,re,!0))&&Z.set(re.identifier.id,re),Z.set(re.identifier.id,re)}),[...Z.values()]}async scanDefaultSystemExtensions(z,Y){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),te=await(z&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(z,Y){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=Y?await this.getBuiltInExtensionControl():{},te=[],se=l.URI.file(b.normalize(b.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of x){const G=q[re.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":te.push((0,c.joinPath)(se,re.name));break;default:te.push(l.URI.file(G));break}}const Z=await Promise.all(te.map(async re=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(re,!1,0,!0,z,!0,void 0))));return this.logService.trace("Scanned dev system extensions:",Z.length),(0,k.coalesce)(Z)}async getBuiltInExtensionControl(){try{const z=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(z.value.toString())}catch{return{}}}async createExtensionScannerInput(z,Y,x,q,te,se,Z){const re=await this.getTranslations(te??g.language),G=await this.getMtime(z),$=Y&&!this.uriIdentityService.extUri.isEqual(z,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,P=$?await this.getMtime($):void 0;return new F(z,G,$,P,Y,Z,x,q,se,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,re)}async getMtime(z){try{const Y=await this.fileService.stat(z);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.AbstractExtensionsScannerService=N,e.AbstractExtensionsScannerService=N=ye([J(4,p.IUserDataProfilesService),J(5,w.IExtensionsProfileScannerService),J(6,o.IFileService),J(7,i.ILogService),J(8,u.IEnvironmentService),J(9,t.IProductService),J(10,d.IUriIdentityService),J(11,n.IInstantiationService)],N);class F{constructor(z,Y,x,q,te,se,Z,re,G,$,P,O,B,j,ee){this.location=z,this.mtime=Y,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=q,this.profile=te,this.profileScanOptions=se,this.type=Z,this.excludeObsolete=re,this.validate=G,this.productVersion=$,this.productDate=P,this.productCommit=O,this.devMode=B,this.language=j,this.translations=ee}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,Y){return(0,c.isEqual)(z.location,Y.location)&&z.mtime===Y.mtime&&(0,c.isEqual)(z.applicationExtensionslocation,Y.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&z.profile===Y.profile&&A.equals(z.profileScanOptions,Y.profileScanOptions)&&z.type===Y.type&&z.excludeObsolete===Y.excludeObsolete&&z.validate===Y.validate&&z.productVersion===Y.productVersion&&z.productDate===Y.productDate&&z.productCommit===Y.productCommit&&z.devMode===Y.devMode&&z.language===Y.language&&L.equals(z.translations,Y.translations)}}e.ExtensionScannerInput=F;let M=class extends S.Disposable{constructor(z,Y,x,q,te){super(),this.obsoleteFile=z,this.extensionsProfileScannerService=Y,this.uriIdentityService=x,this.fileService=q,this.logService=te}async scanExtensions(z){const Y=z.profile?await this.scanExtensionsFromProfile(z):await this.scanExtensionsFromLocation(z);let x={};if(z.excludeObsolete&&z.type===1)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(q)}catch{}return(0,v.isEmptyObject)(x)?Y:Y.filter(q=>!x[m.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(z){const Y=await this.fileService.resolve(z.location);if(!Y.children?.length)return[];const x=await Promise.all(Y.children.map(async q=>{if(!q.isDirectory||z.type===1&&(0,c.basename)(q.resource).indexOf(".")===0)return null;const te=new F(q.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(te)}));return(0,k.coalesce)(x).sort((q,te)=>q.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(z){let Y=await this.scanExtensionsFromProfileResource(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(z.location,z.applicationExtensionslocation)){Y=Y.filter(q=>!q.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(z.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,z);Y.push(...x)}return Y}async scanExtensionsFromProfileResource(z,Y,x){const q=await this.extensionsProfileScannerService.scanProfileExtensions(z,x.profileScanOptions);if(!q.length)return[];const te=await Promise.all(q.map(async se=>{if(Y(se)){const Z=new F(se.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(Z,se.metadata)}return null}));return(0,k.coalesce)(te)}async scanOneOrMultipleExtensions(z){try{if(await this.fileService.exists((0,c.joinPath)(z.location,"package.json"))){const Y=await this.scanExtension(z);return Y?[Y]:[]}else return await this.scanExtensions(z)}catch(Y){return this.logService.error(`Error scanning extensions at ${z.location.path}:`,(0,_.getErrorMessage)(Y)),[]}}async scanExtension(z,Y){try{let x=await this.scanExtensionManifest(z.location);if(x){x.publisher||(x.publisher=C.UNDEFINED_PUBLISHER),Y=Y??x.__metadata,delete x.__metadata;const q=(0,m.getGalleryExtensionId)(x.publisher,x.name),te=Y?.id?{id:q,uuid:Y.id}:{id:q},se=Y?.isSystem?0:z.type,Z=se===0||!!Y?.isBuiltin;x=await this.translateManifest(z.location,x,F.createNlsConfiguration(z));const re={type:se,identifier:te,manifest:x,location:z.location,isBuiltin:Z,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return z.validate?this.validate(re,z):re}}catch(x){z.type!==0&&this.logService.error(x)}return null}validate(z,Y){let x=!0;const q=(0,s.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,z.manifest,z.isBuiltin);for(const[te,se]of q)te===y.default.Error&&(x=!1,this.logService.error(this.formatMessage(Y.location,se)));return z.isValid=x,z.validations=q,z}async scanExtensionManifest(z){const Y=(0,c.joinPath)(z,"package.json");let x;try{x=(await this.fileService.readFile(Y)).value.toString()}catch(te){return(0,o.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(z,(0,h.localize)(0,null,Y.path,te.message))),null}let q;try{q=JSON.parse(x)}catch{const se=[];(0,R.parse)(x,se);for(const Z of se)this.logService.error(this.formatMessage(z,(0,h.localize)(1,null,Y.path,Z.offset,Z.length,(0,I.getParseErrorMessage)(Z.error))));return null}return(0,R.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(z,(0,h.localize)(2,null,Y.path))),null):q}async translateManifest(z,Y,x){const q=await this.getLocalizedMessages(z,Y,x);if(q)try{const te=[],se=await this.resolveOriginalMessageBundle(q.default,te);if(te.length>0)return te.forEach(re=>{this.logService.error(this.formatMessage(z,(0,h.localize)(3,null,q.default?.path,(0,I.getParseErrorMessage)(re.error))))}),Y;if((0,R.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(z,(0,h.localize)(4,null,q.default?.path))),Y;const Z=q.values||Object.create(null);return(0,E.localizeManifest)(this.logService,Y,Z,se)}catch{}return Y}async getLocalizedMessages(z,Y,x){const q=(0,c.joinPath)(z,"package.nls.json"),te=(G,$)=>{$.forEach(P=>{this.logService.error(this.formatMessage(z,(0,h.localize)(5,null,G?.path,(0,I.getParseErrorMessage)(P.error))))})},se=G=>{this.logService.error(this.formatMessage(z,(0,h.localize)(6,null,G?.path)))},Z=`${Y.publisher}.${Y.name}`,re=x.translations[Z];if(re)try{const G=l.URI.file(re),$=(await this.fileService.readFile(G)).value.toString(),P=[],O=(0,R.parse)($,P);return P.length>0?(te(G,P),{values:void 0,default:q}):(0,R.getNodeType)(O)!=="object"?(se(G),{values:void 0,default:q}):{values:O.contents?O.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let $;try{$=await this.findMessageBundles(z,x)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const P=(await this.fileService.readFile($.localized)).value.toString(),O=[],B=(0,R.parse)(P,O);return O.length>0?(te($.localized,O),{values:void 0,default:$.original}):(0,R.getNodeType)(B)!=="object"?(se($.localized),{values:void 0,default:$.original}):{values:B,default:$.original}}catch{return{values:void 0,default:$.original}}}}async resolveOriginalMessageBundle(z,Y){if(z)try{const x=(await this.fileService.readFile(z)).value.toString();return(0,R.parse)(x,Y)}catch{}}findMessageBundles(z,Y){return new Promise((x,q)=>{const te=se=>{const Z=(0,c.joinPath)(z,`package.nls.${se}.json`);this.fileService.exists(Z).then(re=>{re&&x({localized:Z,original:(0,c.joinPath)(z,"package.nls.json")});const G=se.lastIndexOf("-");G===-1?x({localized:(0,c.joinPath)(z,"package.nls.json"),original:null}):(se=se.substring(0,G),te(se))})};if(Y.devMode||Y.pseudo||!Y.language)return x({localized:(0,c.joinPath)(z,"package.nls.json"),original:null});te(Y.language)})}formatMessage(z,Y){return`[${z.path}]: ${Y}`}};M=ye([J(1,w.IExtensionsProfileScannerService),J(2,d.IUriIdentityService),J(3,o.IFileService),J(4,i.ILogService)],M);let W=class extends M{constructor(z,Y,x,q,te,se,Z){super(Y,q,te,se,Z),this.currentProfile=z,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new U.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(z){const Y=this.getCacheFile(z),x=await this.readExtensionCache(Y);if(this.input=z,x&&x.input&&F.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",z.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(te=>(te.location=l.URI.revive(te.location),te));const q=await super.scanExtensions(z);return await this.writeExtensionCache(Y,{input:z,result:q}),q}async readExtensionCache(z){try{const Y=await this.fileService.readFile(z),x=JSON.parse(Y.value.toString());return{result:x.result,input:(0,a.revive)(x.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",z.path,(0,_.getErrorMessage)(Y))}return null}async writeExtensionCache(z,Y){try{await this.fileService.writeFile(z,T.VSBuffer.fromString(JSON.stringify(Y)))}catch(x){this.logService.debug("Error while writing the extension cache file:",z.path,(0,_.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const z=this.getCacheFile(this.input),Y=await this.readExtensionCache(z);if(!Y)return;const x=Y.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!A.equals(q,x))try{this.logService.info("Invalidating Cache",x,q),await this.fileService.del(z),this._onDidChangeCache.fire()}catch(te){this.logService.error(te)}}getCacheFile(z){const Y=this.getProfile(z);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,z.type===0?C.BUILTIN_MANIFEST_CACHE_FILE:C.USER_MANIFEST_CACHE_FILE)}getProfile(z){return z.type===0?this.userDataProfilesService.defaultProfile:z.profile?this.uriIdentityService.extUri.isEqual(z.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(z.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};W=ye([J(2,p.IUserDataProfilesService),J(3,w.IExtensionsProfileScannerService),J(4,d.IUriIdentityService),J(5,o.IFileService),J(6,i.ILogService)],W);function Q(X,z){const Y=(0,m.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:Y,identifier:new C.ExtensionIdentifier(Y),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:z,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,...X.manifest}}e.toExtensionDescription=Q;class H extends N{constructor(z,Y,x,q,te,se,Z,re,G,$,P,O){super(z,Y,(0,c.joinPath)(x,".vscode-oss-dev","extensions","control.json"),q,te,se,Z,re,G,$,P,O),this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const B=await this.fileService.readFile(l.URI.file(g.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(z){return this.translationsPromise}}e.NativeExtensionsScannerService=H}),define(le[245],ue([0,1,66,6,38,3,2,23,16,31,8,17]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends _.Disposable{constructor(f,y){super(),this.userDataProfilesService=f,this.logService=y,this.processesLimiter=new U.Limiter(5)}async postUninstall(f){const y=this.parseScript(f,"uninstall");y&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(y.script,"uninstall",y.args,!0,f),this.logService.info("Finished running post uninstall script",f.identifier.id,f.manifest.version)}catch(v){this.logService.error("Failed to run post uninstall script",f.identifier.id,f.manifest.version),this.logService.error(v)}}));try{await S.Promises.rm(this.getExtensionStoragePath(f))}catch(v){this.logService.error("Error while removing extension storage path",f.identifier.id),this.logService.error(v)}}parseScript(f,y){const v=`vscode:${y}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[v]=="string"){const l=f.manifest.scripts[v].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${v} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(f,y,v,l,h){return new Promise((u,m)=>{const C=this.start(f,y,v,h);let s;const o=n=>{s&&(clearTimeout(s),s=null),n?m(n):u(void 0)};C.on("error",n=>{o((0,A.toErrorMessage)(n)||"Unknown")}),C.on("exit",(n,i)=>{o(n?`post-${y} process exited with code ${n}`:void 0)}),l&&(s=setTimeout(()=>{s=null,C.kill(),m("timed out")},5e3))})}start(f,y,v,l){const h={silent:!0,execArgv:void 0},u=(0,k.fork)(f,[`--type=extension-post-${y}`,...v],h);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const m=T.Event.fromNodeEventEmitter(u.stdout,"data"),C=T.Event.fromNodeEventEmitter(u.stderr,"data");m(n=>this.logService.info(l.identifier.id,l.manifest.version,`post-${y}`,n)),C(n=>this.logService.error(l.identifier.id,l.manifest.version,`post-${y}`,n));const s=T.Event.any(T.Event.map(m,n=>({data:`%c${n}`,format:[""]})),T.Event.map(C,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}getExtensionStoragePath(f){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=g,e.ExtensionsLifecycle=g=ye([J(0,b.IUserDataProfilesService),J(1,D.ILogService)],g)}),define(le[113],ue([0,1,6,15,26,38,7,3,53,2,34,23,16,19,55,12,10,32,31,69,155,96,14,244,29,33,51,81,224,245,183,213,225,70,11,4,8,25,22,28,17]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C,s,o,n,i,t,r,a,w,p,d,E,L,N,F,M,W,Q,H,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(n.IExtensionManagementService);const z=".vsctmp";let Y=class extends o.AbstractExtensionManagementService{constructor(G,$,P,O,B,j,ee,V,K,ie,ce,oe){super(G,$,ce,P,ie,oe),this.extensionsScannerService=B,this.extensionsProfileScannerService=j,this.downloadService=ee,this.fileService=K,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new D.ResourceSet;const de=this._register(V.createInstance(w.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(x,pe=>de.postUninstall(pe))),this.manifestCache=this._register(new d.ExtensionsManifestCache(oe,K,ce,this,this.logService)),this.extensionsDownloader=this._register(V.createInstance(a.ExtensionsDownloader));const fe=this._register(new E.ExtensionsWatcher(this,this.extensionsScannerService,oe,j,ce,K,P));this._register(fe.onDidChangeExtensionsByAnotherSource(pe=>this.onDidChangeExtensionsFromAnotherSource(pe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const $=await this.collectFiles(G),P=await(0,u.zip)((0,c.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)()).fsPath,$);return v.URI.file(P)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:$,cleanup:P}=await this.downloadVsix(G),O=g.resolve($.fsPath);try{return await(0,p.getManifest)(O)}finally{await P()}}getInstalled(G,$=this.userDataProfilesService.defaultProfile.extensionsResource){return this.extensionsScanner.scanExtensions(G??null,$)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.extensionsScanner.scanUserExtensionAtLocation(G)}async install(G,$={}){this.logService.trace("ExtensionManagementService#install",G.toString());const{location:P,cleanup:O}=await this.downloadVsix(G);try{const B=await(0,p.getManifest)(g.resolve(P.fsPath)),j=(0,i.getGalleryExtensionId)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,L.isEngineValid)(B.engines.vscode,this.productService.version,this.productService.date))throw new Error(m.localize(0,null,j,this.productService.version));const V=(await this.installExtensions([{manifest:B,extension:P,options:$}])).find(({identifier:K})=>(0,i.areSameExtensions)(K,{id:j}));if(V?.local)return V.local;throw V?.error?V.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${j}`))}finally{await O()}}async installFromLocation(G,$){this.logService.trace("ExtensionManagementService#installFromLocation",G.toString());const P=await this.extensionsScanner.scanUserExtensionAtLocation(G);if(!P)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.addExtensionsToProfile([[P,void 0]],$),this.logService.info("Successfully installed extension",P.identifier.id,$.toString()),P}async installExtensionsFromProfile(G,$,P){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",G,$.toString(),P.toString());const O=(await this.extensionsScanner.scanExtensions(1,$)).filter(B=>G.some(j=>(0,i.areSameExtensions)(j,B.identifier)));if(O.length){const B=await Promise.all(O.map(j=>this.extensionsScanner.scanMetadata(j,$)));await this.addExtensionsToProfile(O.map((j,ee)=>[j,B[ee]]),P),this.logService.info("Successfully installed extensions",O.map(j=>j.identifier.id),P.toString())}return O}async updateMetadata(G,$,P=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),$.isPreReleaseVersion&&($.preRelease=!0),$.isMachineScoped===!1&&($.isMachineScoped=void 0),$.isBuiltin===!1&&($.isBuiltin=void 0),$.pinned===!1&&($.pinned=void 0),G=await this.extensionsScanner.updateMetadata(G,$,P),this.manifestCache.invalidate(P),this._onDidUpdateExtensionMetadata.fire(G),G}async reinstallFromGallery(G){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(1,null));const $=await this.getTargetPlatform(),[P]=await this.galleryService.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:$,compatible:!0},A.CancellationToken.None);if(!P)throw new Error(m.localize(2,null));await this.extensionsScanner.setUninstalled(G);try{await this.extensionsScanner.removeUninstalledExtension(G)}catch(O){throw new Error(m.localize(3,null,(0,T.toErrorMessage)(O)))}return this.installFromGallery(P)}copyExtension(G,$,P,O){return this.extensionsScanner.copyExtension(G,$,P,O)}copyExtensions(G,$){return this.extensionsScanner.copyExtensions(G,$)}markAsUninstalled(...G){return this.extensionsScanner.setUninstalled(...G)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(G){this.logService.error(G)}}async download(G,$,P){const{location:O}=await this.extensionsDownloader.download(G,$,!P);return O}async downloadVsix(G){if(G.scheme===b.Schemas.file)return{location:G,async cleanup(){}};this.logService.trace("Downloading extension from",G.toString());const $=(0,c.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)());return await this.downloadService.download(G,$),this.logService.info("Downloaded extension to",$.toString()),{location:$,cleanup:async()=>{try{await this.fileService.del($)}catch(O){this.logService.error(O)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(G,$,P){if(v.URI.isUri($))return new se(G,$,P,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const O=i.ExtensionKey.create($).toString();let B=this.installGalleryExtensionsTasks.get(O);return B||(this.installGalleryExtensionsTasks.set(O,B=new te(G,$,P,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService)),B.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(O))),B}createUninstallExtensionTask(G,$){return new Z(G,$.profileLocation,this.extensionsProfileScannerService)}async collectFiles(G){const $=async O=>{let B=await h.Promises.readdir(O);B=B.map(V=>g.join(O,V));const j=await Promise.all(B.map(V=>h.Promises.stat(V)));let ee=Promise.resolve([]);return j.forEach((V,K)=>{const ie=B[K];V.isFile()&&(ee=ee.then(ce=>[...ce,ie])),V.isDirectory()&&(ee=ee.then(ce=>$(ie).then(oe=>[...ce,...oe])))}),ee};return(await $(G.location.fsPath)).map(O=>({path:`extension/${g.relative(G.location.fsPath,O)}`,localPath:O}))}async onDidChangeExtensionsFromAnotherSource({added:G,removed:$}){if($){const P=G&&this.uriIdentityService.extUri.isEqual($.profileLocation,G.profileLocation)?$.extensions.filter(O=>G.extensions.every(B=>!(0,i.areSameExtensions)(B,O))):$.extensions;for(const O of P)this.logService.info("Extensions removed from another source",O.id,$.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:O,profileLocation:$.profileLocation})}if(G){const O=(await this.extensionsScanner.scanExtensions(1,G.profileLocation)).filter(B=>G.extensions.some(j=>(0,i.areSameExtensions)(j,B.identifier)));this._onDidInstallExtensions.fire(O.map(B=>(this.logService.info("Extensions added from another source",B.identifier.id,G.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:G.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract($=>this.knownDirectories.add($)));const G=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const $ of G.children??[])$.isDirectory&&this.knownDirectories.add($.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange($=>this.onDidFilesChange($)))}async onDidFilesChange(G){if(!G.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const $=[];for(const P of G.rawAdded){if(this.knownDirectories.has(P)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(P),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(P,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(P).startsWith(".")||!(await this.fileService.stat(P)).isDirectory)continue;const O=await this.extensionsScanner.scanUserExtensionAtLocation(P);O&&O.installedTimestamp===void 0&&(this.knownDirectories.add(P),$.push(O))}$.length&&(await this.addExtensionsToProfile($.map(P=>[P,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",$.map(P=>P.identifier.id)))}async addExtensionsToProfile(G,$){const P=G.map(O=>O[0]);await this.setInstalled(P),await this.extensionsProfileScannerService.addExtensionsToProfile(G,$),this._onDidInstallExtensions.fire(P.map(O=>({local:O,identifier:O.identifier,operation:1,profileLocation:$})))}async setInstalled(G){const $=await this.extensionsScanner.getUninstalledExtensions();for(const P of G){const O=i.ExtensionKey.create(P);$[O.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",O.id),await this.extensionsScanner.setInstalled(O),this.logService.info("Removed the extension from uninstalled list:",O.id))}}};e.ExtensionManagementService=Y,e.ExtensionManagementService=Y=ye([J(0,n.IExtensionGalleryService),J(1,Q.ITelemetryService),J(2,M.ILogService),J(3,s.INativeEnvironmentService),J(4,r.IExtensionsScannerService),J(5,t.IExtensionsProfileScannerService),J(6,C.IDownloadService),J(7,F.IInstantiationService),J(8,N.IFileService),J(9,W.IProductService),J(10,H.IUriIdentityService),J(11,X.IUserDataProfilesService)],Y);let x=class extends S.Disposable{constructor(G,$,P,O,B,j){super(),this.beforeRemovingExtension=G,this.fileService=$,this.extensionsScannerService=P,this.extensionsProfileScannerService=O,this.uriIdentityService=B,this.logService=j,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,c.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(G,$){const P={includeInvalid:!0,profileLocation:$};let O=[];return G===null||G===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},P,!1)):G===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(P)),O=G!==null?O.filter(B=>B.type===G):O,Promise.all(O.map(B=>this.toLocalExtension(B)))}async scanAllUserExtensions(G){const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all($.map(P=>this.toLocalExtension(P)))}async scanUserExtensionAtLocation(G){try{const $=await this.extensionsScannerService.scanExistingExtension(G,1,{includeInvalid:!0});if($)return await this.toLocalExtension($)}catch($){this.logService.error($)}return null}async extractUserExtension(G,$,P,O,B){const j=G.toString(),ee=v.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,l.generateUuid)()}`)),V=v.URI.file(g.join(this.extensionsScannerService.userExtensionsLocation.fsPath,j));let K=await this.fileService.exists(V);if(K&&O){try{await this.deleteExtensionFromLocation(G.id,V,"removeExisting")}catch{throw new n.ExtensionManagementError(m.localize(4,null,V.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}K=!1}if(!K)try{try{this.logService.trace(`Started extracting the extension from ${$} to ${V.fsPath}`),await(0,u.extract)($,ee.fsPath,{sourcePath:"extension",overwrite:!0},B),this.logService.info(`Extracted extension to ${V}:`,G.id)}catch(ie){let ce=n.ExtensionManagementErrorCode.Extract;throw ie instanceof u.ExtractError&&(ie.type==="CorruptZip"?ce=n.ExtensionManagementErrorCode.CorruptZip:ie.type==="Incomplete"&&(ce=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(ie.message,ce)}await this.extensionsScannerService.updateMetadata(ee,P);try{this.logService.trace(`Started renaming the extension from ${ee.fsPath} to ${V.fsPath}`),await this.rename(ee.fsPath,V.fsPath),this.logService.info("Renamed to",V.fsPath)}catch(ie){if(ie.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(ie)}. Deleted from extracted location`,ee),ie}this._onExtract.fire(V)}catch(ie){try{await this.fileService.del(ee,{recursive:!0})}catch{}throw ie}return this.scanLocalExtension(V,1)}async scanMetadata(G,$){return $?(await this.getScannedExtension(G,$))?.metadata:this.extensionsScannerService.scanMetadata(G.location)}async getScannedExtension(G,$){return(await this.extensionsProfileScannerService.scanProfileExtensions($)).find(O=>(0,i.areSameExtensions)(O.identifier,G.identifier))}async updateMetadata(G,$,P){return P?await this.extensionsProfileScannerService.updateMetadata([[G,$]],P):await this.extensionsScannerService.updateMetadata(G.location,$),this.scanLocalExtension(G.location,G.type,P)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...G){const $=G.map(P=>i.ExtensionKey.create(P));await this.withUninstalledExtensions(P=>$.forEach(O=>{P[O.toString()]=!0,this.logService.info("Marked extension as uninstalled",O.toString())}))}async setInstalled(G){await this.withUninstalledExtensions($=>delete $[G.toString()])}async removeExtension(G,$){if(this.uriIdentityService.extUri.isEqualOrParent(G.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(G.identifier.id,G.location,$)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.withUninstalledExtensions($=>delete $[i.ExtensionKey.create(G).toString()])}async copyExtension(G,$,P,O){const B=await this.getScannedExtension(G,$),j=await this.getScannedExtension(G,P);return O={...B?.metadata,...O},j?await this.extensionsProfileScannerService.updateMetadata([[G,{...j.metadata,...O}]],P):await this.extensionsProfileScannerService.addExtensionsToProfile([[G,O]],P),this.scanLocalExtension(G.location,G.type,P)}async copyExtensions(G,$){const P=await this.scanExtensions(1,G),O=await Promise.all(P.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,G)]));await this.extensionsProfileScannerService.addExtensionsToProfile(O,$)}async deleteExtensionFromLocation(G,$,P){this.logService.trace(`Deleting ${P} extension from disk`,G,$.fsPath);const O=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname($),`${this.uriIdentityService.extUri.basename($)}.${(0,I.hash)((0,l.generateUuid)()).toString(16)}${z}`);await this.rename($.fsPath,O.fsPath),await this.fileService.del(O,{recursive:!0}),this.logService.info(`Deleted ${P} extension from disk`,G,$.fsPath)}async withUninstalledExtensions(G){return this.uninstalledFileLimiter.queue(async()=>{let $;try{$=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(O){if((0,N.toFileOperationResult)(O)!==1)throw O}let P={};if($)try{P=JSON.parse($)}catch{}return G&&(G(P),Object.keys(P).length?await this.fileService.writeFile(this.uninstalledResource,U.VSBuffer.fromString(JSON.stringify(P))):await this.fileService.del(this.uninstalledResource)),P})}async rename(G,$){try{await h.Promises.rename(G,$,2*60*1e3)}catch(P){throw new n.ExtensionManagementError(P.message||m.localize(5,null,G,$),P.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(G,$,P){if(P){const B=(await this.extensionsScannerService.scanUserExtensions({profileLocation:P})).find(j=>this.uriIdentityService.extUri.isEqual(j.location,G));if(B)return this.toLocalExtension(B)}else{const O=await this.extensionsScannerService.scanExistingExtension(G,$,{includeInvalid:!0});if(O)return this.toLocalExtension(O)}throw new Error(m.localize(6,null,G.path))}async toLocalExtension(G){const $=await this.fileService.resolve(G.location);let P,O;return $.children&&(P=$.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,O=$.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:P,changelogUrl:O,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async removeUninstalledExtensions(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(G));const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const B of $)G[i.ExtensionKey.create(B).toString()]||P.add(B.identifier.id.toLowerCase());try{const B=(0,i.groupByExtension)($,j=>j.identifier);await k.Promises.settled(B.map(async j=>{const ee=j.sort((V,K)=>f.rcompare(V.manifest.version,K.manifest.version))[0];P.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}))}catch(B){this.logService.error(B)}const O=$.filter(B=>B.metadata&&G[i.ExtensionKey.create(B).toString()]);await Promise.allSettled(O.map(B=>this.removeUninstalledExtension(B)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch($){(0,N.toFileOperationResult)($)!==1&&this.logService.error($);return}if(G?.children)try{await Promise.allSettled(G.children.map(async $=>{if(!(!$.isDirectory||!$.name.endsWith(z))){this.logService.trace("Deleting the temporarily deleted folder",$.resource.toString());try{await this.fileService.del($.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",$.resource.toString())}catch(P){(0,N.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}))}catch{}}};e.ExtensionsScanner=x,e.ExtensionsScanner=x=ye([J(1,N.IFileService),J(2,r.IExtensionsScannerService),J(3,t.IExtensionsProfileScannerService),J(4,H.IUriIdentityService),J(5,M.ILogService)],x);class q extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,y.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(G,$,P,O,B,j,ee,V,K){super(),this.identifier=G,this.source=$,this.options=P,this.extensionsScanner=O,this.uriIdentityService=B,this.userDataProfilesService=j,this.extensionsScannerService=ee,this.extensionsProfileScannerService=V,this.logService=K,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(G){const[$,P]=await this.install(G);return this._profileLocation=$.isBuiltin||$.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[$,P]],this._profileLocation),$}async extractExtension({zipPath:G,key:$,metadata:P},O,B){let j=await this.unsetIfUninstalled($);return j||(this.logService.trace("Extracting extension...",$.id),j=await this.extensionsScanner.extractUserExtension($,G,P,O,B),this.logService.info("Extracting extension completed.",$.id)),j}async unsetIfUninstalled(G){return await this.isUninstalled(G)?(this.logService.trace("Removing the extension from uninstalled list:",G.id),await this.extensionsScanner.setInstalled(G),this.logService.info("Removed the extension from uninstalled list:",G.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(O=>i.ExtensionKey.create(O).equals(G))):void 0}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.toString()]}}class te extends q{constructor(G,$,P,O,B,j,ee,V,K,ie){super($.identifier,$,P,B,j,ee,V,K,ie),this.gallery=$,this.extensionsDownloader=O}async install(G){const P=(await this.extensionsScanner.scanExtensions(null,this.options.profileLocation)).find(ee=>(0,i.areSameExtensions)(ee.identifier,this.gallery.identifier));P&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned,preRelease:this.gallery.properties.isPreReleaseVersion||((0,y.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.gallery.version)return[await this.extensionsScanner.updateMetadata(P,O),O];const{location:B,verificationStatus:j}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=j,this.validateManifest(B.fsPath),[await this.extractExtension({zipPath:B.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:O},!1,G),O]}catch(ee){try{await this.extensionsDownloader.delete(B)}catch(V){this.logService.warn("Error while deleting the downloaded file",B.toString(),(0,_.getErrorMessage)(V))}throw ee}}async validateManifest(G){try{await(0,p.getManifest)(G)}catch($){throw new n.ExtensionManagementError((0,o.joinErrors)($).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=te;class se extends q{constructor(G,$,P,O,B,j,ee,V,K,ie){super({id:(0,i.getGalleryExtensionId)(G.publisher,G.name)},$,P,B,j,ee,V,K,ie),this.manifest=G,this.location=$,this.galleryService=O}async doRun(G){const $=await super.doRun(G);return this.updateMetadata($,G),$}async install(G){const $=new i.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation)).find(ee=>(0,i.areSameExtensions)(this.identifier,ee.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??O?.pinned};if(O)if(this._operation=3,$.equals(new i.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(m.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&f.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const ee=await this.unsetIfUninstalled($);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(m.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:g.resolve(this.location.fsPath),key:$,metadata:B},!0,G),B]}async updateMetadata(G,$){try{let[P]=await this.galleryService.getExtensions([{id:G.identifier.id,version:G.manifest.version}],$);if(P||([P]=await this.galleryService.getExtensions([{id:G.identifier.id}],$)),P){const O={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(G,O,this.options.profileLocation)}}catch{}}}class Z extends o.AbstractExtensionTask{constructor(G,$,P){super(),this.extension=G,this.profileLocation=$,this.extensionsProfileScannerService=P}async doRun(G){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(le[246],ue([0,1,8,17,28,22,51,11,14,10]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let D=class extends _.AbstractExtensionsProfileScannerService{constructor(g,c,f,y,v,l){super(S.URI.file(g.extensionsPath),c,f,y,v,l)}};e.ExtensionsProfileScannerService=D,e.ExtensionsProfileScannerService=D=ye([J(0,I.INativeEnvironmentService),J(1,R.IFileService),J(2,U.IUserDataProfilesService),J(3,A.IUriIdentityService),J(4,T.ITelemetryService),J(5,k.ILogService)],D)}),define(le[247],ue([0,1,10,14,51,81,11,4,8,25,28,17]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends T.NativeExtensionsScannerService{constructor(f,y,v,l,h,u,m,C){super(k.URI.file(h.builtinExtensionsPath),k.URI.file(h.extensionsPath),h.userHome,f.defaultProfile,f,y,v,l,h,u,m,C)}};e.ExtensionsScannerService=g,e.ExtensionsScannerService=g=ye([J(0,b.IUserDataProfilesService),J(1,A.IExtensionsProfileScannerService),J(2,_.IFileService),J(3,I.ILogService),J(4,U.INativeEnvironmentService),J(5,S.IProductService),J(6,D.IUriIdentityService),J(7,R.IInstantiationService)],g)}),define(le[21],ue([0,1,6,3,2,100,12,68,4,17]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var D;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var b;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var g;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function c(h){const u=h.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=c;class f extends A.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(u={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=u,this._onDidChangeValue=this._register(new U.PauseableEmitter),this._onDidChangeTarget=this._register(new U.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new U.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(u,m,C){return U.Event.filter(this._onDidChangeValue.event,s=>s.scope===u&&(m===void 0||s.key===m),C)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,m){const{key:C,external:s}=m;if(C===e.TARGET_KEY){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:C,target:this.getKeyTargets(u)[C],external:s})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,m,C){return this.getStorage(m)?.get(u,C)}getBoolean(u,m,C){return this.getStorage(m)?.getBoolean(u,C)}getNumber(u,m,C){return this.getStorage(m)?.getNumber(u,C)}getObject(u,m,C){return this.getStorage(m)?.getObject(u,C)}storeAll(u,m){this.withPausedEmitters(()=>{for(const C of u)this.store(C.key,C.value,C.scope,C.target,m)})}store(u,m,C,s,o=!1){if((0,_.isUndefinedOrNull)(m)){this.remove(u,C,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,C,s),this.getStorage(C)?.set(u,m,o)})}remove(u,m,C=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(u,m,void 0),this.getStorage(m)?.delete(u,C)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,m){const C=[],s=this.getKeyTargets(u);for(const o of Object.keys(s))s[o]===m&&C.push(o);return C}updateKeyTarget(u,m,C,s=!1){const o=this.getKeyTargets(m);typeof C=="number"?o[u]!==C&&(o[u]=C,this.getStorage(m)?.set(e.TARGET_KEY,JSON.stringify(o),s)):typeof o[u]=="number"&&(delete o[u],this.getStorage(m)?.set(e.TARGET_KEY,JSON.stringify(o),s))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const m=this.getStorage(u);return m?c(m):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=D.NONE){this._onWillSaveState.fire({reason:u});const m=this.getStorage(-1),C=this.getStorage(0),s=this.getStorage(1);switch(u){case D.NONE:await k.Promises.settled([m?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await k.Promises.settled([m?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,m=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return l(u,m,C,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(u){return await this.flush(),this.getStorage(u)?.optimize()}async switch(u,m){return this.emitWillSaveState(D.NONE),(0,S.isUserDataProfile)(u)?this.switchToProfile(u,m):this.switchToWorkspace(u,m)}canSwitchProfile(u,m){return!(u.id===m.id||y(m)&&y(u))}switchData(u,m,C){this.withPausedEmitters(()=>{const s=new Set;for(const[o,n]of u)s.add(o),m.get(o)!==n&&this.emitDidChangeValue(C,{key:o,external:!0});for(const[o]of m.items)s.has(o)||this.emitDidChangeValue(C,{key:o,external:!0})})}}e.AbstractStorageService=f;function y(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=y;class v extends f{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(u){return!1}}e.InMemoryStorageService=v;async function l(h,u,m,C,s,o){const n=L=>{try{return JSON.parse(L)}catch{return L}},i=new Map,t=new Map;h.forEach((L,N)=>{i.set(N,L),t.set(N,n(L))});const r=new Map,a=new Map;u.forEach((L,N)=>{r.set(N,L),a.set(N,n(L))});const w=new Map,p=new Map;m.forEach((L,N)=>{w.set(N,L),p.set(N,n(L))}),console.group(C!==s?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const d=[];if(i.forEach((L,N)=>{d.push({key:N,value:L})}),console.table(d),console.groupEnd(),console.log(t),C!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const L=[];r.forEach((N,F)=>{L.push({key:F,value:N})}),console.table(L),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const E=[];w.forEach((L,N)=>{E.push({key:N,value:L})}),console.table(E),console.groupEnd(),console.log(p)}e.logStorage=l}),define(le[114],ue([0,1,3,2,12,29,33,21]),function(ne,e,k,U,A,T,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends U.Disposable{constructor(b,g){super(),this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(b)),this._register(this.storageManger.onDidChange(c=>this._onDidChangeEnablement.fire({extensions:c,source:"storage"}))),this._register(g.onDidInstallExtensions(c=>c.forEach(({local:f,operation:y})=>{f&&y===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(b,g){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:g}),!0):!1}async disableExtension(b,g){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const g=this.getDisabledExtensions();return g.every(c=>!(0,_.areSameExtensions)(c,b))?(g.push(b),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(b){const g=this.getDisabledExtensions();for(let c=0;c<g.length;c++){const f=g[c];if((0,_.areSameExtensions)(f,b))return g.splice(c,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(b){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,g){this.storageManger.set(b,g,0)}};e.GlobalExtensionEnablementService=I,e.GlobalExtensionEnablementService=I=ye([J(0,R.IStorageService),J(1,T.IExtensionManagementService)],I);class S extends U.Disposable{constructor(b){super(),this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(0,void 0,this._register(new U.DisposableStore))(g=>this.onDidStorageChange(g)))}get(b,g){let c;return g===0?((0,A.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,g)),c=this.storage[b]):c=this._get(b,g),JSON.parse(c)}set(b,g,c){const f=JSON.stringify(g.map(({id:v,uuid:l})=>({id:v,uuid:l})));this._get(b,c)!==f&&(c===0&&(g.length?this.storage[b]=f:delete this.storage[b]),this._set(b,g.length?f:void 0,c))}onDidStorageChange(b){if(!(0,A.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const c=this.get(b.key,b.scope);delete this.storage[b.key];const f=this.get(b.key,b.scope),y=c.filter(l=>!f.some(h=>(0,_.areSameExtensions)(l,h))),v=f.filter(l=>!c.some(h=>(0,_.areSameExtensions)(h,l)));(y.length||v.length)&&this._onDidChange.fire([...y,...v])}}_get(b,g){return this.storageService.get(b,g,"[]")}_set(b,g,c){g?this.storageService.store(b,g,c,1):this.storageService.remove(b,c)}}e.StorageManager=S}),define(le[248],ue([0,1,18,26,7,5,37,12,10,20,14,29,33,70,11,8,25,59,226,21,22,62]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=T.isWeb?"web":(0,b.getTargetPlatform)(T.platform,_.arch),o="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((O,B)=>O|B,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class d{constructor(O=p){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(O,B=this.state.pageSize){return new d({...this.state,pageNumber:O,pageSize:B})}withFilter(O,...B){const j=[...this.state.criteria,...B.length?B.map(ee=>({filterType:O,value:ee})):[{filterType:O}]];return new d({...this.state,criteria:j})}withSortBy(O){return new d({...this.state,sortBy:O})}withSortOrder(O){return new d({...this.state,sortOrder:O})}withFlags(...O){return new d({...this.state,flags:O.reduce((B,j)=>B|j,0)})}withAssetTypes(...O){return new d({...this.state,assetTypes:O})}withSource(O){return new d({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:B,pageSize:j,sortBy:ee,sortOrder:V,flags:K,assetTypes:ie}=this.state;return{filters:[{criteria:O,pageNumber:B,pageSize:j,sortBy:ee,sortOrder:V}],assetTypes:ie,flags:K}}get searchText(){const O=this.state.criteria.filter(B=>B.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function E(P,O){const B=(P||[]).filter(j=>j.statisticName===O)[0];return B?B.value:0}function L(P){const O="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(j=>j.assetType.indexOf(O)===0).reduce((j,ee)=>{const V=M(P,ee.assetType);return V&&j.push([ee.assetType.substring(O.length),V]),j},[])}function N(P){if(P.properties){const O=P.properties.filter(ee=>ee.key===r.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=O.filter(ee=>B.test(ee.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return M(P,r.Repository)}function F(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function M(P,O){return P.files.filter(j=>j.assetType===O)[0]?{uri:`${P.assetUri}/${O}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${O}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function W(P,O){const B=P.properties?P.properties.filter(ee=>ee.key===O):[],j=B.length>0&&B[0].value;return j?j.split(",").map(ee=>(0,g.adoptToGalleryExtensionId)(ee)):[]}function Q(P){const O=P.properties?P.properties.filter(B=>B.key===a.Engine):[];return O.length>0&&O[0].value||""}function H(P){const O=P.properties?P.properties.filter(B=>B.key===a.PreRelease):[];return O.length>0&&O[0].value==="true"}function X(P){const O=P.properties?P.properties.filter(j=>j.key===a.LocalizedLanguages):[],B=O.length>0&&O[0].value||"";return B?B.split(","):[]}function z(P){return P.properties?.find(O=>O.key===a.SponsorLink)?.value}function Y(P){return P.indexOf("preview")!==-1}function x(P){return P.targetPlatform?(0,b.toTargetPlatform)(P.targetPlatform):"undefined"}function q(P){const O=(0,k.distinct)(P.versions.map(x)),B=!!P.tags?.includes(b.WEB_EXTENSION_TAG),j=O.indexOf("web");return B?j===-1&&O.push("web"):j!==-1&&O.splice(j,1),O}function te(P,O){for(let B=0;B<P.length;B++){const j=P[B];if(j.version===P[B-1]?.version){let ee=B;if(x(j)===O)for(;ee>0&&P[ee-1].version===j.version;)ee--;ee!==B&&(P.splice(B,1),P.splice(ee,0,j))}}return P}e.sortExtensionVersions=te;function se(P,O,B){P.telemetryData={index:O,querySource:B,queryActivityId:P.queryContext?.[o]}}function Z(P,O,B,j){const ee=P.versions[0],V={manifest:M(O,r.Manifest),readme:M(O,r.Details),changelog:M(O,r.Changelog),license:M(O,r.License),repository:N(O),download:F(O),icon:M(O,r.Icon),signature:M(O,r.Signature),coreTranslations:L(O)};return{identifier:{id:(0,g.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:O.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(ee),description:P.shortDescription||"",installCount:E(P.statistics,"install"),rating:E(P.statistics,"averagerating"),ratingCount:E(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:B,assets:V,properties:{dependencies:W(O,a.Dependency),extensionPack:W(O,a.ExtensionPack),engine:Q(O),localizedLanguages:X(O),targetPlatform:x(O),isPreReleaseVersion:H(O)},hasPreReleaseVersion:H(ee),hasReleaseVersion:!0,preview:Y(P.flags),isSigned:!!V.signature,queryContext:j}}let re=class{constructor(O,B,j,ee,V,K,ie,ce){this.requestService=B,this.logService=j,this.environmentService=ee,this.telemetryService=V,this.fileService=K,this.productService=ie,this.configurationService=ce;const oe=ie.extensionsGallery,de=oe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=de?oe.servicePPEUrl:oe?.serviceUrl,this.extensionsGallerySearchUrl=de?void 0:oe?.searchUrl,this.extensionsControlUrl=oe?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,B,j){const ee=U.CancellationToken.isCancellationToken(B)?{}:B,V=U.CancellationToken.isCancellationToken(B)?B:j,K=[],ie=[],ce=[],oe=[];let de=!0;for(const we of O){we.uuid?ie.push(we.uuid):K.push(we.id);const Le=!!(we.version||we.preRelease);ce.push({id:we.id,uuid:we.uuid,includePreRelease:Le}),we.version&&oe.push({id:we.id,uuid:we.uuid,version:we.version}),de=de&&!!we.hasPreRelease&&!Le}if(!ie.length&&!K.length)return[];let fe=new d().withPage(1,O.length);ie.length&&(fe=fe.withFilter(t.ExtensionId,...ie)),K.length&&(fe=fe.withFilter(t.ExtensionName,...K)),(ee.queryAllVersions||de)&&(fe=fe.withFlags(fe.flags,n.IncludeVersions)),ee.source&&(fe=fe.withSource(ee.source));const{extensions:pe}=await this.queryGalleryExtensions(fe,{targetPlatform:ee.targetPlatform??s,includePreRelease:ce,versions:oe,compatible:!!ee.compatible},V);return ee.source&&pe.forEach((we,Le)=>se(we,Le,ee.source)),pe}async getCompatibleExtension(O,B,j){if((0,b.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(O,B,j))return O;const ee=new d().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:V}=await this.queryGalleryExtensions(ee,{targetPlatform:j,compatible:!0,includePreRelease:B},U.CancellationToken.None);return V[0]||null}async isExtensionCompatible(O,B,j){if(!(0,b.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,j)||!B&&O.properties.isPreReleaseVersion)return!1;let ee=O.properties.engine;if(!ee){const V=await this.getManifest(O,U.CancellationToken.None);if(!V)throw new Error("Manifest was not found");ee=V.engines.vscode}return(0,c.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(O,B,j,ee,V){if(!(0,b.isTargetPlatformCompatible)(x(O),ee,V)||B!=="any"&&H(O)!==(B==="prerelease"))return!1;if(j)try{const K=await this.getEngine(O);if(!(0,c.isEngineValid)(K,this.productService.version,this.productService.date))return!1}catch(K){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,A.getErrorMessage)(K)),!1}return!0}async query(O,B){let j=O.text||"";const ee=O.pageSize??50;let V=new d().withPage(1,ee);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,pe)=>(V=V.withFilter(t.Category,pe||fe),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,fe,pe)=>(V=V.withFilter(t.Tag,pe||fe),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),V=V.withFilter(t.SearchText,j)),V=V.withSortBy(0)):O.ids?V=V.withFilter(t.ExtensionId,...O.ids):O.names?V=V.withFilter(t.ExtensionName,...O.names):V=V.withSortBy(4),typeof O.sortBy=="number"&&(V=V.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(V=V.withSortOrder(O.sortOrder)),O.source&&(V=V.withSource(O.source));const K=async(de,fe)=>{const{extensions:pe,total:we}=await this.queryGalleryExtensions(de,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},fe);return pe.forEach((Le,ke)=>se(Le,(de.pageNumber-1)*de.pageSize+ke,O.source)),{extensions:pe,total:we}},{extensions:ie,total:ce}=await K(V,B),oe=async(de,fe)=>{if(fe.isCancellationRequested)throw new A.CancellationError;const{extensions:pe}=await K(V.withPage(de+1),fe);return pe};return{firstPage:ie,total:ce,pageSize:V.pageSize,getPage:oe}}async queryGalleryExtensions(O,B,j){const ee=O.flags;O.flags&n.IncludeLatestVersionOnly&&O.flags&n.IncludeVersions&&(O=O.withFlags(O.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(O.flags&n.IncludeLatestVersionOnly)&&!(O.flags&n.IncludeVersions)&&(O=O.withFlags(O.flags,n.IncludeLatestVersionOnly)),B.versions?.length&&(O=O.withFlags(O.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),O=O.withFlags(O.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:V,total:K,context:ie}=await this.queryRawGalleryExtensions(O,j);if(!(O.flags&n.IncludeLatestVersionOnly)){const fe=[];for(const pe of V){const we=await this.toGalleryExtensionWithCriteria(pe,B,ie);we&&fe.push(we)}return{extensions:fe,total:K}}const oe=[],de=new Map;for(let fe=0;fe<V.length;fe++){const pe=V[fe],we={id:(0,g.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Le=(0,R.isBoolean)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Fe=>(0,g.areSameExtensions)(Fe,we))?.includePreRelease;if(B.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(q(pe),B.targetPlatform))continue;const ke=await this.toGalleryExtensionWithCriteria(pe,B,ie);!ke||ke.properties.isPreReleaseVersion&&(!Le||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==B.targetPlatform&&ke.hasPreReleaseVersion?de.set(pe.extensionId,fe):oe.push([fe,ke])}if(de.size){const fe=new C.StopWatch,pe=new d().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:we}=await this.queryGalleryExtensions(pe,B,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:de.size});for(const Le of we){const ke=de.get(Le.identifier.uuid);oe.push([ke,Le])}}return{extensions:oe.sort((fe,pe)=>fe[0]-pe[0]).map(([,fe])=>fe),total:K}}async toGalleryExtensionWithCriteria(O,B,j){const ee={id:(0,g.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},V=B.versions?.find(oe=>(0,g.areSameExtensions)(oe,ee))?.version,K=(0,R.isBoolean)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(oe=>(0,g.areSameExtensions)(oe,ee))?.includePreRelease,ie=q(O),ce=te(O.versions,B.targetPlatform);if(B.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(ie,B.targetPlatform))return null;for(let oe=0;oe<ce.length;oe++){const de=ce[oe];if(!(V&&de.version!==V)){if(await this.isValidVersion(de,K?"any":"release",B.compatible,ie,B.targetPlatform))return Z(O,de,ie,j);if(V&&de.version===V)return null}}return V||B.compatible?null:Z(O,O.versions[0],ie)}async queryRawGalleryExtensions(O,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const j=await this.commonHeadersPromise,ee=JSON.stringify(O.raw),V={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},K=new C.StopWatch;let ie,ce,oe=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&O.criteria.some(fe=>fe.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:V},B),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:oe};const de=await(0,l.asJson)(ie);if(de){const fe=de.results[0],pe=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return oe=we&&we.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:oe,context:{[o]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:oe}}catch(de){throw ce=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(ee.length),duration:K.elapsed(),success:!!ie&&(0,l.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ce?(0,A.isCancellationError)(ce)?"canceled":(0,A.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(oe)})}}async reportStatistic(O,B,j,ee){if(!this.isEnabled())return;const V=T.isWeb?this.api(`/itemName/${O}.${B}/version/${j}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${B}/${j}/stats?statType=${ee}`),K=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:K};try{await this.requestService.request({type:"POST",url:V,headers:ce},U.CancellationToken.None)}catch{}}async download(O,B,j){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const ee=(0,g.getGalleryExtensionTelemetryData)(O),V=new Date().getTime(),K=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:fe}),ie=j===2?"install":j===3?"update":"",ce=ie?{uri:`${O.assets.download.uri}${I.URI.parse(O.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${O.assets.download.fallbackUri}${I.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:O.assets.download,oe=O.queryContext?.[o]?{[o]:O.queryContext[o]}:void 0,de=await this.getAsset(ce,oe?{headers:oe}:void 0);await this.fileService.writeFile(B,de.stream),K(new Date().getTime()-V)}async downloadSignatureArchive(O,B){if(!O.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",O.identifier.id);const j=await this.getAsset(O.assets.signature);await this.fileService.writeFile(B,j.stream)}async getReadme(O,B){if(O.assets.readme){const j=await this.getAsset(O.assets.readme,{},B);return await(0,l.asTextOrError)(j)||""}return""}async getManifest(O,B){if(O.assets.manifest){const j=await this.getAsset(O.assets.manifest,{},B),ee=await(0,l.asTextOrError)(j);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(O,B){const j=M(O,r.Manifest);if(!j)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},V=await this.getAsset(j,{headers:ee});return await(0,l.asJson)(V)}async getCoreTranslation(O,B){const j=O.assets.coreTranslations.filter(ee=>ee[0]===B.toUpperCase())[0];if(j){const ee=await this.getAsset(j[1]),V=await(0,l.asTextOrError)(ee);return V?JSON.parse(V):null}return null}async getChangelog(O,B){if(O.assets.changelog){const j=await this.getAsset(O.assets.changelog,{},B);return await(0,l.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(O,B,j){let ee=new d().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?ee=ee.withFilter(t.ExtensionId,O.identifier.uuid):ee=ee.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:V}=await this.queryRawGalleryExtensions(ee,U.CancellationToken.None);if(!V.length)return[];const K=q(V[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(K,j))return[];const ie=[];await Promise.all(V[0].versions.map(async de=>{try{await this.isValidVersion(de,B?"any":"release",!0,K,j)&&ie.push(de)}catch{}}));const ce=[],oe=new Set;for(const de of te(ie,j))oe.has(de.version)||(oe.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:H(de)}));return ce}async getAsset(O,B={},j=U.CancellationToken.None){const ee=await this.commonHeadersPromise,V={type:"GET"},K={...ee,...B.headers||{}};B={...B,...V,headers:K};const ie=O.uri,ce=O.fallbackUri,oe={...B,url:ie};try{const de=await this.requestService.request(oe,j);if(de.res.statusCode===200)return de;const fe=await(0,l.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${fe}`)}catch(de){if((0,A.isCancellationError)(de))throw de;const fe=(0,A.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:fe});const pe={...B,url:ce};return this.requestService.request(pe,j)}}async getEngine(O){let B=Q(O);if(!B){const j=await this.getManifestFromRawExtensionVersion(O,U.CancellationToken.None);if(!j)throw new Error("Manifest was not found");B=j.engines.vscode}return B}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},U.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,l.asJson)(O),j=[],ee={},V=[];if(B){for(const K of B.malicious)j.push({id:K});if(B.migrateToPreRelease)for(const[K,ie]of Object.entries(B.migrateToPreRelease))(!ie.engine||(0,c.isEngineValid)(ie.engine,this.productService.version,this.productService.date))&&(ee[K.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[K,ie]of Object.entries(B.deprecated))ie&&(ee[K.toLowerCase()]=(0,R.isBoolean)(ie)?{}:ie);if(B.search)for(const K of B.search)V.push(K)}return{malicious:j,deprecated:ee,search:V}}};re=ye([J(1,l.IRequestService),J(2,y.ILogService),J(3,D.IEnvironmentService),J(4,m.ITelemetryService),J(5,f.IFileService),J(6,v.IProductService),J(7,S.IConfigurationService)],re);let G=class extends re{constructor(O,B,j,ee,V,K,ie,ce){super(O,B,j,ee,V,K,ie,ce)}};e.ExtensionGalleryService=G,e.ExtensionGalleryService=G=ye([J(0,u.IStorageService),J(1,l.IRequestService),J(2,y.ILogService),J(3,D.IEnvironmentService),J(4,m.ITelemetryService),J(5,f.IFileService),J(6,v.IProductService),J(7,S.IConfigurationService)],G);let $=class extends re{constructor(O,B,j,ee,V,K,ie){super(void 0,O,B,j,ee,V,K,ie)}};e.ExtensionGalleryServiceWithNoStorageService=$,e.ExtensionGalleryServiceWithNoStorageService=$=ye([J(0,l.IRequestService),J(1,y.ILogService),J(2,D.IEnvironmentService),J(3,m.ITelemetryService),J(4,f.IFileService),J(5,v.IProductService),J(6,S.IConfigurationService)],$)}),define(le[82],ue([0,1,4,3,2,21,33,25,18,8,12]),function(ne,e,k,U,A,T,_,R,I,S,D){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends A.Disposable{static{b=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(y){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const v=g.exec(y);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(y,v){const l=await y.getInstalled(),h=[];for(const[u,m]of b.readAllExtensionsWithKeysForSync(v)){const C=l.find(s=>(0,_.areSameExtensions)(s.identifier,{id:u}))?.manifest.version;for(const s of m)C!==s&&h.push(b.toKey({id:u,version:s}))}for(const u of h)v.remove(u,0)}static readAllExtensionsWithKeysForSync(y){const v=new Map,l=y.keys(0,1);for(const h of l){const u=b.fromKey(h);if(u){let m=v.get(u.id.toLowerCase());m||v.set(u.id.toLowerCase(),m=[]),m.push(u.version)}}return v}constructor(y,v,l){super(),this.storageService=y,this.productService=v,this.logService=l,this._onDidChangeExtensionStorageToSync=this._register(new U.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=b.readAllExtensionsWithKeysForSync(y),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new A.DisposableStore))(h=>this.onDidChangeStorageValue(h)))}onDidChangeStorageValue(y){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=b.fromKey(y.key);if(v){if(this.storageService.get(y.key,0)===void 0)this.extensionsWithKeysForSync.delete(v.id.toLowerCase());else{let l=this.extensionsWithKeysForSync.get(v.id.toLowerCase());l||this.extensionsWithKeysForSync.set(v.id.toLowerCase(),l=[]),l.push(v.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(y){if((0,D.isString)(y))return y;const v=y.manifest?y.manifest.publisher:y.publisher,l=y.manifest?y.manifest.name:y.name;return(0,_.getExtensionId)(v,l)}getExtensionState(y,v){const l=this.getExtensionId(y),h=this.getExtensionStateRaw(y,v);if(h)try{return JSON.parse(h)}catch(u){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${v}): ${u}`)}}getExtensionStateRaw(y,v){const l=this.getExtensionId(y),h=this.storageService.get(l,v?0:1);return h&&h?.length>b.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${v}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(y,v,l){const h=this.getExtensionId(y);v===void 0?this.storageService.remove(h,l?0:1):this.storageService.store(h,JSON.stringify(v),l?0:1,1)}setKeysForSync(y,v){this.storageService.store(b.toKey(y),JSON.stringify(v),0,1)}getKeysForSync(y){const v=this.productService.extensionSyncedKeys?.[y.id.toLowerCase()],l=this.storageService.get(b.toKey(y),0),h=l?JSON.parse(l):void 0;return h&&v?(0,I.distinct)([...h,...v]):h||v}addToMigrationList(y,v){if(y!==v){const l=this.migrationList.filter(h=>!h.includes(y)&&!h.includes(v));l.push([y,v]),this.migrationList=l}}getSourceExtensionToMigrate(y){const v=this.migrationList.find(([,l])=>y===l);return v?v[0]:void 0}get migrationList(){const y=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(y);if(Array.isArray(v))return v}catch{}return[]}set migrationList(y){y.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=c,e.ExtensionStorageService=c=b=ye([J(0,T.IStorageService),J(1,R.IProductService),J(2,S.ILogService)],c)}),define(le[249],ue([0,1,2,29,82,223,113,8,21]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends k.Disposable{constructor(b,g,c,f,y,v){super(),b.cleanUp(),(0,T.migrateUnsupportedExtensions)(b,g,c,f,v),A.ExtensionStorageService.removeOutdatedExtensionVersions(b,y)}};e.ExtensionsContributions=S,e.ExtensionsContributions=S=ye([J(0,_.INativeServerExtensionManagementService),J(1,U.IExtensionGalleryService),J(2,A.IExtensionStorageService),J(3,U.IGlobalExtensionEnablementService),J(4,I.IStorageService),J(5,R.ILogService)],S)}),define(le[250],ue([0,1,29,11,25,14,98,57,21,22,222]),function(ne,e,k,U,A,T,_,R,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends D.AbstractNativeExtensionTipsService{constructor(c,f,y,v,l,h,u,m){super(c.userHome,l,f,y,v,h,u,m)}};e.ExtensionTipsService=b,e.ExtensionTipsService=b=ye([J(0,T.INativeEnvironmentService),J(1,S.ITelemetryService),J(2,k.IExtensionManagementService),J(3,I.IStorageService),J(4,R.INativeHostService),J(5,_.IExtensionRecommendationNotificationService),J(6,U.IFileService),J(7,A.IProductService)],b)}),define(le[251],ue([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const C=[k.CONFIGURATION_KEY_HOST_NAME,k.CONFIGURATION_KEY_PREVENT_SLEEP],s="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends _.Disposable{constructor(a,w,p,d,E,L,N){super(),this.telemetryService=a,this.productService=w,this.environmentService=p,this.configurationService=L,this.storageService=N,this._onDidTokenFailedEmitter=new U.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new U.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new U.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=k.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(F,M)=>{M?this._logger.error(F):this._logger.info(F)},this._logger=this._register(d.createLogger((0,m.joinPath)(p.logsHome,`${k.LOG_ID}.log`),{id:k.LOG_ID,name:k.LOGGER_NAME})),this._startTunnelProcessDelayer=new g.Delayer(100),this._register(this._logger.onDidChangeLogLevel(F=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)(F)))),this._register(E.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(L.onDidChangeConfiguration(F=>{C.some(M=>F.affectsConfiguration(M))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=k.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(a){this._tunnelStatus=a,this._onDidChangeTunnelStatusEmitter.fire(a)}setMode(a){t(this._mode,a)||(this._mode=a,this._storeMode(a),this._onDidChangeModeEmitter.fire(this._mode),a.active?(this._logger.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this._logger.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(a){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(w){this._logger.error(w)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let a;b.isMacintosh?a=this.environmentService.appRoot:a=(0,I.dirname)((0,I.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,I.join)(a,"bin",`${this.productService.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(a){if(t(this._mode,a)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(w){this._logger.error(w)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._mode.active)return;const a=this._mode.asService;this.setMode(k.INACTIVE_TUNNEL_MODE);try{a&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(w){this._logger.error(w)}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(w){this._logger.error(w)}this.setTunnelStatus(k.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let a="",w=!1;const p=(M,W)=>{W?this._logger.error(M):a+=M,!this.environmentService.isBuilt&&M.startsWith("   Compiling")&&this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(0,null)))},d=this.runCodeTunnelCommand("status",["status"],p);this._tunnelProcess=d;try{if(await d,this._tunnelProcess!==d)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(W=>W.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.setTunnelStatus(k.TunnelStates.disconnected());return}if(w=M.service_installed,this._logger.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this._mode.active){this.setTunnelStatus(k.TunnelStates.disconnected());return}}catch(M){this._logger.error(M),this.setTunnelStatus(k.TunnelStates.disconnected());return}finally{this._tunnelProcess===d&&(this._tunnelProcess=void 0)}const E=this._mode.active?this._mode.session:void 0;if(E&&E.token){const M=E.token;this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(1,null,E.accountLabel,E.providerId)));const W=(H,X)=>{H=H.replaceAll(M,"*".repeat(4)),p(H,X)},Q=this.runCodeTunnelCommand("login",["user","login","--provider",E.providerId,"--access-token",M,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],W);this._tunnelProcess=Q;try{if(await Q,this._tunnelProcess!==Q)return}catch(H){this._logger.error(H),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(E),this.setTunnelStatus(k.TunnelStates.disconnected(E));return}}const L=this._getTunnelName();L?this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(2,null,L))):this.setTunnelStatus(k.TunnelStates.connecting((0,y.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];L?N.push("--name",L):N.push("--random-name");let F=!1;return this._mode.active&&this._mode.asService&&!w&&(F=await this.installTunnelService(N)===!1),this.serverOrAttachTunnel(E,N,F)}async installTunnelService(a){let w;try{w=await this.runCodeTunnelCommand("serviceInstall",["service","install",...a])}catch(p){this._logger.error(p),w=1}if(w!==0){const p=(0,y.localize)(4,null);return this._logger.warn(p),this.setTunnelStatus(k.TunnelStates.connecting(p)),!1}return!0}async serverOrAttachTunnel(a,w,p){w.push("--parent-process-id",String(process.pid)),this._preventSleep()&&w.push("--no-sleep");let d=!1;const E=this.runCodeTunnelCommand("tunnel",w,(L,N)=>{N?this._logger.error(L):this._logger.info(L),L.includes("Connected to an existing tunnel process")&&(d=!0);const F=L.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:d};this.setTunnelStatus(k.TunnelStates.connected(M,p))}else L.match(/error refreshing token/)&&(E.cancel(),this._onDidTokenFailedEmitter.fire(a),this.setTunnelStatus(k.TunnelStates.disconnected(a)))});this._tunnelProcess=E,E.finally(()=>{E===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=k.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(k.TunnelStates.disconnected()))})}runCodeTunnelCommand(a,w,p=this.defaultOnOutput){return(0,g.createCancelablePromise)(d=>new Promise((E,L)=>{d.isCancellationRequested&&E(-1);let N;const F=["ignore","pipe","pipe"];if(d.onCancellationRequested(()=>{N&&(this._logger.info(`${a} terminating(${N.pid})`),N.kill())}),!this.environmentService.isBuilt)p(`Building tunnel CLI from sources and run
`,!1),p(`${a} Spawning: cargo run -- tunnel ${w.join(" ")}
`,!1),N=(0,S.spawn)("cargo",["run","--","tunnel",...w],{cwd:(0,I.join)(this.environmentService.appRoot,"cli"),stdio:F});else{p(`Running tunnel CLI
`,!1);const M=this.getTunnelCommandLocation();p(`${a} Spawning: ${M} tunnel ${w.join(" ")}
`,!1),N=(0,S.spawn)(M,["tunnel",...w],{cwd:(0,v.homedir)(),stdio:F})}N.stdout.pipe(new u.StreamSplitter(`
`)).on("data",M=>{if(N){const W=M.toString();p(W,!1)}}),N.stderr.pipe(new u.StreamSplitter(`
`)).on("data",M=>{if(N){const W=M.toString();p(W,!0)}}),N.on("exit",M=>{N&&(p(`${a} exit(${N.pid}): + ${M} `,!1),N=void 0,E(M||0))}),N.on("error",M=>{N&&(p(`${a} error(${N.pid}): + ${M} `,!0),N=void 0,L())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(k.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let a=this.configurationService.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,v.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}_restoreMode(){try{const a=this.storageService.get(s,-1),w=this.storageService.getBoolean(o,-1,!1);if(a){const p=JSON.parse(a);if(p&&(0,h.isString)(p.accountLabel)&&(0,h.isString)(p.sessionId)&&(0,h.isString)(p.providerId))return{active:!0,session:p,asService:w};this._logger.error("Problems restoring session from storage, invalid format",p)}}catch(a){this._logger.error("Problems restoring session from storage",a)}return k.INACTIVE_TUNNEL_MODE}_storeMode(a){if(a.active){const w={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.storageService.store(s,JSON.stringify(w),-1,1),this.storageService.store(o,a.asService,-1,1)}else this.storageService.remove(s,-1),this.storageService.remove(o,-1)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=ye([J(0,A.ITelemetryService),J(1,D.IProductService),J(2,T.INativeEnvironmentService),J(3,R.ILoggerService),J(4,c.ISharedProcessLifecycleService),J(5,f.IConfigurationService),J(6,l.IStorageService)],n);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(le[252],ue([0,1,6,2,23,19,68,21,77,17]),function(ne,e,k,U,A,T,_,R,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class D extends R.AbstractStorageService{constructor(g,c,f,y){super(),this.initialWorkspace=g,this.initialProfiles=c,this.remoteService=f,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new U.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new U.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const g=this._register(new I.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),c=this._register(new _.Storage(g));return this._register(c.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f))),c}createProfileStorage(g){this.profileStorageDisposables.clear(),this.profileStorageProfile=g;let c;if((0,R.isProfileUsingDefaultStorage)(g))c=this.applicationStorage;else{const f=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),g));c=this.profileStorageDisposables.add(new _.Storage(f))}return this.profileStorageDisposables.add(c.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),c}createWorkspaceStorage(g){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=g?.id;let c;if(g){const f=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),g));c=this.workspaceStorageDisposables.add(new _.Storage(f)),this.workspaceStorageDisposables.add(c.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return c}async doInitialize(){await k.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return this.applicationStorageProfile.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(g){if(!this.canSwitchProfile(this.profileStorageProfile,g))return;const c=this.profileStorage,f=c.items;c!==this.applicationStorage&&await c.close(),this.profileStorage=this.createProfileStorage(g),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0)}async switchToWorkspace(g,c){const f=this.workspaceStorage,y=f?.items??new Map;await f?.close(),this.workspaceStorage=this.createWorkspaceStorage(g),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1)}hasScope(g){return(0,S.isUserDataProfile)(g)?this.profileStorageProfile.id===g.id:this.workspaceStorageId===g.id}}e.RemoteStorageService=D}),define(le[253],ue([0,1,3,2,17,92]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(S,D){this.service=S,this.getUriTransformer=D}listen(S,D){const b=this.getUriTransformer(S);switch(D){case"onDidChangeProfiles":return k.Event.map(this.service.onDidChangeProfiles,g=>({all:g.all.map(c=>(0,T.transformOutgoingURIs)({...c},b)),added:g.added.map(c=>(0,T.transformOutgoingURIs)({...c},b)),removed:g.removed.map(c=>(0,T.transformOutgoingURIs)({...c},b)),updated:g.updated.map(c=>(0,T.transformOutgoingURIs)({...c},b))}))}throw new Error(`Invalid listen ${D}`)}async call(S,D,b){const g=this.getUriTransformer(S);switch(D){case"createProfile":{const c=await this.service.createProfile(b[0],b[1],b[2]);return(0,T.transformOutgoingURIs)({...c},g)}case"updateProfile":{let c=(0,A.reviveProfile)((0,T.transformIncomingURIs)(b[0],g),this.service.profilesHome.scheme);return c=await this.service.updateProfile(c,b[1]),(0,T.transformOutgoingURIs)({...c},g)}case"removeProfile":{const c=(0,A.reviveProfile)((0,T.transformIncomingURIs)(b[0],g),this.service.profilesHome.scheme);return this.service.removeProfile(c)}}throw new Error(`Invalid call ${D}`)}}e.RemoteUserDataProfilesServiceChannel=_;class R extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(S,D,b){super(),this.profilesHome=D,this.channel=b,this._profiles=[],this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=S.map(g=>(0,A.reviveProfile)(g,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(g=>{const c=g.added.map(v=>(0,A.reviveProfile)(v,this.profilesHome.scheme)),f=g.removed.map(v=>(0,A.reviveProfile)(v,this.profilesHome.scheme)),y=g.updated.map(v=>(0,A.reviveProfile)(v,this.profilesHome.scheme));this._profiles=g.all.map(v=>(0,A.reviveProfile)(v,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:c,removed:f,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(S){this.enabled=S}isEnabled(){return this.enabled}async createNamedProfile(S,D,b){const g=await this.channel.call("createNamedProfile",[S,D,b]);return(0,A.reviveProfile)(g,this.profilesHome.scheme)}async createProfile(S,D,b,g){const c=await this.channel.call("createProfile",[S,D,b,g]);return(0,A.reviveProfile)(c,this.profilesHome.scheme)}async createTransientProfile(S){const D=await this.channel.call("createTransientProfile",[S]);return(0,A.reviveProfile)(D,this.profilesHome.scheme)}async setProfileForWorkspace(S,D){await this.channel.call("setProfileForWorkspace",[S,D])}removeProfile(S){return this.channel.call("removeProfile",[S])}async updateProfile(S,D){const b=await this.channel.call("updateProfile",[S,D]);return(0,A.reviveProfile)(b,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(le[60],ue([0,1,2,68,4,21,3,77,17]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,A.createDecorator)("IUserDataProfileStorageService");let S=class extends k.Disposable{constructor(c){super(),this.storageService=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async f=>this.getItems(f))}async updateStorageData(c,f,y){return this.withProfileScopedStorageService(c,async v=>this.writeItems(v,f,y))}async withProfileScopedStorageService(c,f){if(this.storageService.hasScope(c))return f(this.storageService);const y=await this.createStorageDatabase(c),v=new b(y);try{await v.initialize();const l=await f(v);return await v.flush(),l}finally{v.dispose(),await this.closeAndDispose(y)}}getItems(c){const f=new Map,y=v=>{for(const l of c.keys(0,v))f.set(l,{value:c.get(l,0),target:v})};return y(0),y(1),f}writeItems(c,f,y){c.storeAll(Array.from(f.entries()).map(([v,l])=>({key:v,value:l,scope:0,target:y})),!0)}async closeAndDispose(c){try{await c.close()}finally{(0,k.isDisposable)(c)&&c.dispose()}}};e.AbstractUserDataProfileStorageService=S,e.AbstractUserDataProfileStorageService=S=ye([J(0,T.IStorageService)],S);class D extends S{constructor(c,f,y,v){super(y),this.remoteService=c;const l=c.getChannel("profileStorageListener"),h=this._register(new k.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{h.value=l.listen("onDidChange")(u=>{v.trace("profile storage changes",u),this._onDidChange.fire({targetChanges:u.targetChanges.map(m=>(0,I.reviveProfile)(m,f.profilesHome.scheme)),valueChanges:u.valueChanges.map(m=>({...m,profile:(0,I.reviveProfile)(m.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(c){const f=this.remoteService.getChannel("storage");return(0,T.isProfileUsingDefaultStorage)(c)?new R.ApplicationStorageDatabaseClient(f):new R.ProfileStorageDatabaseClient(f,c)}}e.RemoteUserDataProfileStorageService=D;class b extends T.AbstractStorageService{constructor(c){super({flushInterval:100}),this.profileStorage=this._register(new U.Storage(c))}doInitialize(){return this.profileStorage.init()}getStorage(c){return c===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(le[254],ue([0,1,21,8,17,56,60]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends _.RemoteUserDataProfileStorageService{constructor(S,D,b,g){super(S,D,b,g)}};e.NativeUserDataProfileStorageService=R,e.NativeUserDataProfileStorageService=R=ye([J(0,T.IMainProcessService),J(1,A.IUserDataProfilesService),J(2,k.IStorageService),J(3,U.ILogService)],R)}),define(le[39],ue([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function s(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||o(w.syncData)))}e.isRemoteUserData=s;function o(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}e.isSyncData=o;function n(w,p){return`${(0,S.uppercaseFirstLetter)(w)}${p.isDefault?"":` (${p.name})`}`}e.getSyncResourceLogLabel=n;let i=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(p,d,E,L,N,F,M,W,Q,H,X,z){super(),this.syncResource=p,this.collection=d,this.fileService=E,this.environmentService=L,this.storageService=N,this.userDataSyncStoreService=F,this.userDataSyncLocalStoreService=M,this.userDataSyncEnablementService=W,this.telemetryService=Q,this.logService=H,this.configurationService=X,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new U.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(p.syncResource,p.profile),this.extUri=z.extUri,this.syncFolder=this.extUri.joinPath(L.userDataSyncHome,...(0,m.getPathSegments)(p.profile.isDefault?void 0:p.profile.id,p.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,m.PREVIEW_DIR_NAME),this.lastSyncResource=(0,m.getLastSyncResourceUri)(p.profile.isDefault?void 0:p.profile.id,p.syncResource,L,this.extUri),this.currentMachineIdPromise=(0,v.getServiceMachineId)(L,E,N)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const p=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(p.remoteUserData,p.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const p=await this.getLastSyncUserData();(p?await this.hasRemoteChanged(p):!0)&&this._onDidChangeLocal.fire()}}setStatus(p){this._status!==p&&(this._status=p,this._onDidChangStatus.fire(p))}async sync(p,d={}){await this._sync(p,!0,this.getUserDataSyncConfiguration(),d)}async preview(p,d,E={}){return this._sync(p,!1,d,E)}async apply(p,d={}){try{this.syncHeaders={...d};const E=await this.doApply(p);return this.setStatus(E),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(p,d,E,L){try{if(this.syncHeaders={...L},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(p,F);return N=await this.performSync(M,F,d,E),N==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(N)}}finally{this.syncHeaders={}}}async replace(p){const d=this.parseSyncData(p);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const E=await this.getLastSyncUserData(),L=await this.getLatestRemoteUserData(null,E),N=await this.isRemoteDataFromCurrentMachine(L),F=await this.generateSyncPreview({ref:L.ref,syncData:d},E,N,this.getUserDataSyncConfiguration(),T.CancellationToken.None),M=[];for(const W of F){const Q=await this.getAcceptResult(W,W.remoteResource,void 0,T.CancellationToken.None),{remoteChange:H}=await this.getAcceptResult(W,W.previewResource,W.remoteContent,T.CancellationToken.None);M.push([W,{...Q,remoteChange:H!==0?H:2}])}await this.applyResult(L,E,M,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(p){const d=await this.currentMachineIdPromise;return!!p.syncData?.machineId&&p.syncData.machineId===d}async getLatestRemoteUserData(p,d){if(d){const E=p?p[this.resource]:void 0;if(d.ref===E||E===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(p,d,E,L){if(p.syncData&&p.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new m.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,p.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(p,d,E,L)}catch(N){if(N instanceof m.UserDataSyncError)switch(N.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(p,d,E,L);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),p=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(p,d,E,L)}throw N}}async doSync(p,d,E,L){try{const N=await this.isRemoteDataFromCurrentMachine(p),F=!N&&d===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,M=E&&!F;this.syncPreviewPromise||(this.syncPreviewPromise=(0,U.createCancelablePromise)(Q=>this.doGenerateSyncResourcePreview(p,d,N,M,L,Q)));let W=await this.syncPreviewPromise;if(E&&F){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Q of W.resourcePreviews)W=await this.accept(Q.remoteResource)||W}return this.updateConflicts(W.resourcePreviews),W.resourcePreviews.some(({mergeState:Q})=>Q==="conflict")?"hasConflicts":E?await this.doApply(!1):"syncing"}catch(N){throw this.syncPreviewPromise=null,N}}async merge(p){return await this.updateSyncResourcePreview(p,async d=>{const E=await this.getMergeResult(d,T.CancellationToken.None);await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(E?.content||""));const L=E&&!E.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,T.CancellationToken.None):void 0;return d.acceptResult=L,d.mergeState=E.hasConflicts?"conflict":L?"accepted":"preview",d.localChange=L?L.localChange:E.localChange,d.remoteChange=L?L.remoteChange:E.remoteChange,d}),this.syncPreviewPromise}async accept(p,d){return await this.updateSyncResourcePreview(p,async E=>{const L=await this.getAcceptResult(E,p,d,T.CancellationToken.None);return E.acceptResult=L,E.mergeState="accepted",E.localChange=L.localChange,E.remoteChange=L.remoteChange,E}),this.syncPreviewPromise}async discard(p){return await this.updateSyncResourcePreview(p,async d=>{const E=await this.getMergeResult(d,T.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(E.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=E.localChange,d.remoteChange=E.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(p,d){if(!this.syncPreviewPromise)return;let E=await this.syncPreviewPromise;const L=E.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:M})=>this.extUri.isEqual(N,p)||this.extUri.isEqual(F,p)||this.extUri.isEqual(M,p));L!==-1&&(this.syncPreviewPromise=(0,U.createCancelablePromise)(async N=>{const F=[...E.resourcePreviews];return F[L]=await d(F[L]),{...E,resourcePreviews:F}}),E=await this.syncPreviewPromise,this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(p){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:E})=>E==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:E})=>E!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(E=>[E,E.acceptResult]),p),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(p){const d=p.filter(({mergeState:E})=>E==="conflict");(0,k.equals)(this._conflicts,d,(E,L)=>this.extUri.isEqual(E.previewResource,L.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const p=await this.getLastSyncUserData();return!!p&&p.syncData!==null}async resolvePreviewContent(p){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const E of d.resourcePreviews){if(this.extUri.isEqual(E.acceptedResource,p))return E.acceptResult?E.acceptResult.content:null;if(this.extUri.isEqual(E.remoteResource,p))return E.remoteContent;if(this.extUri.isEqual(E.localResource,p))return E.localContent;if(this.extUri.isEqual(E.baseResource,p))return E.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(p){(0,f.toFileOperationResult)(p)!==1&&this.logService.error(p)}}async doGenerateSyncResourcePreview(p,d,E,L,N,F){const M=await this.generateSyncPreview(p,d,E,N,F),W=[];for(const Q of M){const H=Q.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(Q.localChange===0&&Q.remoteChange===0)W.push({...Q,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=L?await this.getMergeResult(Q,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile(Q.previewResource,A.VSBuffer.fromString(X?.content||""));const z=X&&!X.hasConflicts?await this.getAcceptResult(Q,Q.previewResource,void 0,F):void 0;W.push({...Q,acceptResult:z,mergeState:X?.hasConflicts?"conflict":z?"accepted":"preview",localChange:z?z.localChange:X?X.localChange:Q.localChange,remoteChange:z?z.remoteChange:X?X.remoteChange:Q.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:p,lastSyncUserData:d,resourcePreviews:W,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let p=this.getStoredLastSyncUserDataStateContent();if(p||(p=await this.migrateLastSyncUserData()),!p)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const d=JSON.parse(p),E=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!d.version&&!!E&&d.version!==E,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let L,N=1;for(;L===void 0&&N++<6;)try{const F=await this.readLastSyncStoredRemoteUserData();F&&(F.ref===d.ref?L=F.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof f.FileOperationError&&F.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(F instanceof m.UserDataSyncError)throw F;this.logService.error(F,N)}}if(L===void 0)try{const F=await this.userDataSyncStoreService.resolveResourceContent(this.resource,d.ref,this.collection,this.syncHeaders);L=F===null?null:this.parseSyncData(F),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:L})}catch(F){if(F instanceof m.UserDataSyncError&&F.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw F}return L===void 0?null:{...d,syncData:L}}async updateLastSyncUserData(p,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const E=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),L={ref:p.ref,version:E,...d};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(L),-1,1),await this.writeLastSyncStoredRemoteUserData(p)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const p=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const d=p?JSON.parse(p):void 0;if(s(d))return d}catch(d){this.logService.error(d)}}async writeLastSyncStoredRemoteUserData(p){await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(p)))}async migrateLastSyncUserData(){try{const p=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(p.value.toString());await this.fileService.del(this.lastSyncResource),d.ref&&d.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...d,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:d.ref,syncData:d.content===null?null:JSON.parse(d.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,d)}catch(p){p instanceof f.FileOperationError&&p.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(p)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(p){const{ref:d,content:E}=await this.getUserData(p);let L=null;return E!==null&&(L=this.parseSyncData(E)),{ref:d,syncData:L}}parseSyncData(p){try{const d=JSON.parse(p);if(o(d))return d}catch(d){this.logService.error(d)}throw new m.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(p){const d=p?{ref:p.ref,content:p.syncData?JSON.stringify(p.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,d,this.collection,this.syncHeaders)}async updateRemoteUserData(p,d){const E=await this.currentMachineIdPromise,L={version:this.version,machineId:E,content:p};try{return d=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(L),d,this.collection,this.syncHeaders),{ref:d,syncData:L}}catch(N){throw N instanceof m.UserDataSyncError&&N.code==="TooLarge"&&(N=new m.UserDataSyncError(N.message,N.code,this.resource)),N}}async backupLocal(p){const d={version:this.version,content:p};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(d),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i,e.AbstractSynchroniser=i=ye([J(2,f.IFileService),J(3,c.IEnvironmentService),J(4,l.IStorageService),J(5,m.IUserDataSyncStoreService),J(6,m.IUserDataSyncLocalStoreService),J(7,m.IUserDataSyncEnablementService),J(8,h.ITelemetryService),J(9,m.IUserDataSyncLogService),J(10,g.IConfigurationService),J(11,u.IUriIdentityService)],i);let t=class extends i{constructor(p,d,E,L,N,F,M,W,Q,H,X,z,Y){super(d,E,L,N,F,M,W,Q,H,X,z,Y),this.file=p,this._register(this.fileService.watch(this.extUri.dirname(p))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(p,d,E){try{d?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(p),E?void 0:d):await this.fileService.createFile(this.file,A.VSBuffer.fromString(p),{overwrite:E})}catch(L){throw L instanceof f.FileOperationError&&L.fileOperationResult===1||L instanceof f.FileOperationError&&L.fileOperationResult===3?new m.UserDataSyncError(L.message,"LocalPreconditionFailed"):L}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(p){if(!(p instanceof f.FileOperationError&&p.fileOperationResult===1))throw p}}onFileChanges(p){p.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=t,e.AbstractFileSynchroniser=t=ye([J(3,f.IFileService),J(4,c.IEnvironmentService),J(5,l.IStorageService),J(6,m.IUserDataSyncStoreService),J(7,m.IUserDataSyncLocalStoreService),J(8,m.IUserDataSyncEnablementService),J(9,h.ITelemetryService),J(10,m.IUserDataSyncLogService),J(11,g.IConfigurationService),J(12,u.IUriIdentityService)],t);let r=class extends t{constructor(p,d,E,L,N,F,M,W,Q,H,X,z,Y,x){super(p,d,E,L,N,F,M,W,Q,H,X,Y,x),this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(p,d){const E=[],L=(0,R.parse)(p,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,D.isUndefined)(L)&&d!==Array.isArray(L)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=ye([J(3,f.IFileService),J(4,c.IEnvironmentService),J(5,l.IStorageService),J(6,m.IUserDataSyncStoreService),J(7,m.IUserDataSyncLocalStoreService),J(8,m.IUserDataSyncEnablementService),J(9,h.ITelemetryService),J(10,m.IUserDataSyncLogService),J(11,m.IUserDataSyncUtilService),J(12,g.IConfigurationService),J(13,u.IUriIdentityService)],r);let a=class{constructor(p,d,E,L,N,F,M){this.resource=p,this.userDataProfilesService=d,this.environmentService=E,this.logService=L,this.fileService=N,this.storageService=F,this.extUri=M.extUri,this.lastSyncResource=(0,m.getLastSyncResourceUri)(void 0,this.resource,E,this.extUri)}async initialize({ref:p,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const E=this.parseSyncData(d);if(E)try{await this.doInitialize({ref:p,syncData:E})}catch(L){this.logService.error(L)}}parseSyncData(p){try{const d=JSON.parse(p);if(o(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(p,d={}){if(d.ref||d.version)throw new Error("Cannot have core properties as additional");const E={ref:p.ref,version:void 0,...d};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),-1,1),await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(p)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=ye([J(1,C.IUserDataProfilesService),J(2,c.IEnvironmentService),J(3,y.ILogService),J(4,f.IFileService),J(5,l.IStorageService),J(6,u.IUriIdentityService)],a)}),define(le[115],ue([0,1,6,26,7,3,42,2,27,20,14,114,29,33,82,44,11,4,73,8,21,22,28,17,39,234,111,24,60]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C,s,o,n,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function w(F,M){const W=JSON.parse(F.content);if(F.version===1||F.version===2){const Q=(await M.getInstalled(0)).filter(H=>H.isBuiltin);for(const H of W)F.version===1&&(H.enabled===!1&&(H.disabled=!0),delete H.enabled),F.version===2&&Q.every(X=>!(0,c.areSameExtensions)(X.identifier,H.identifier))&&(H.installed=!0)}return W}function p(F){return JSON.parse(F.content)}e.parseExtensions=p;function d(F,M){return F.sort((W,Q)=>!W.identifier.uuid&&Q.identifier.uuid?-1:W.identifier.uuid&&!Q.identifier.uuid?1:(0,I.compare)(W.identifier.id,Q.identifier.id)),M?(0,_.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=d;let E=class extends n.AbstractSynchroniser{constructor(M,W,Q,H,X,z,Y,x,q,te,se,Z,re,G,$,P,O){super({syncResource:"extensions",profile:M},W,H,Q,X,z,Y,Z,re,te,se,$),this.extensionManagementService=x,this.ignoredExtensionsManagementService=q,this.instantiationService=O,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(L),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,B=>B.some(({local:j})=>!!j)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,B=>!B.error),T.Event.filter(P.onDidChange,B=>B.valueChanges.some(({profile:j,changes:ee})=>this.syncResource.profile.id===j.id&&ee.some(V=>V.key===g.DISABLED_EXTENSIONS_STORAGE_PATH))),G.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(M,W){const Q=M.syncData?await w(M.syncData,this.extensionManagementService):null,H=W?.skippedExtensions??[],X=W?.builtinExtensions??null,z=W?.syncData?await w(W.syncData,this.extensionManagementService):null,{localExtensions:Y,ignoredExtensions:x}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);Q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:te}=(0,i.merge)(Y,Q,z,H,x,X),se={local:q,remote:te,content:this.getPreviewContent(Y,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:te!==null?2:0},Z=this.stringify(Y,!1);return[{skippedExtensions:H,builtinExtensions:X,baseResource:this.baseResource,baseContent:z?this.stringify(z,!1):Z,localResource:this.localResource,localContent:Z,localExtensions:Y,remoteResource:this.remoteResource,remoteExtensions:Q,remoteContent:Q?this.stringify(Q,!1):null,previewResource:this.previewResource,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(M){const W=M.syncData?await w(M.syncData,this.extensionManagementService):null,{localExtensions:Q,ignoredExtensions:H}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,i.merge)(Q,W,W,M.skippedExtensions||[],H,M.builtinExtensions||[]);return X!==null}getPreviewContent(M,W,Q,H){const X=[...W,...Q],z=new Set,Y=x=>{z.add(x.id.toLowerCase()),x.uuid&&z.add(x.uuid)};X.forEach(({identifier:x})=>Y(x)),H.forEach(Y);for(const x of M)z.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&z.has(x.identifier.uuid)||X.push(x);return this.stringify(X,!1)}async getMergeResult(M,W){return{...M.previewResult,hasConflicts:!1}}async getAcceptResult(M,W,Q,H){if(this.extUri.isEqual(W,this.localResource))return this.acceptLocal(M);if(this.extUri.isEqual(W,this.remoteResource))return this.acceptRemote(M);if(this.extUri.isEqual(W,this.previewResource))return M.previewResult;throw new Error(`Invalid Resource: ${W.toString()}`)}async acceptLocal(M){const W=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(W),H=(0,i.merge)(M.localExtensions,null,null,M.skippedExtensions,Q,M.builtinExtensions),{local:X,remote:z}=H;return{content:M.localContent,local:X,remote:z,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:z!==null?2:0}}async acceptRemote(M){const W=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(W),H=M.remoteContent?JSON.parse(M.remoteContent):null;if(H!==null){const X=(0,i.merge)(M.localExtensions,H,M.localExtensions,[],Q,M.builtinExtensions),{local:z,remote:Y}=X;return{content:M.remoteContent,local:z,remote:Y,localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(M,W,Q,H){let{skippedExtensions:X,builtinExtensions:z,localExtensions:Y}=Q[0][0];const{local:x,remote:q,localChange:te,remoteChange:se}=Q[0][1];if(te===0&&se===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),te!==0&&(await this.backupLocal(JSON.stringify(Y)),X=await this.localExtensionsProvider.updateLocalExtensions(x.added,x.removed,x.updated,X,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const Z=JSON.stringify(q.all);M=await this.updateRemoteUserData(Z,H?null:M.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(re=>re.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(re=>re.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(re=>re.identifier.id))}.`:""}`)}W?.ref!==M.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),z=this.computeBuiltinExtensions(Y,z),await this.updateLastSyncUserData(M,{skippedExtensions:X,builtinExtensions:z}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(Z=>Z.identifier.id))}.`:""}`))}computeBuiltinExtensions(M,W){const Q=new Set,H=[];for(const X of M)Q.add(X.identifier.id.toLowerCase()),X.installed||H.push(X.identifier);if(W)for(const X of W)Q.has(X.id.toLowerCase())||H.push(X);return H}async resolveContent(M){if(this.extUri.isEqual(this.remoteResource,M)||this.extUri.isEqual(this.baseResource,M)||this.extUri.isEqual(this.localResource,M)||this.extUri.isEqual(this.acceptedResource,M)){const W=await this.resolvePreviewContent(M);return W&&this.stringify(JSON.parse(W),!0)}return null}stringify(M,W){return d(M,W)}async hasLocalData(){try{const{localExtensions:M}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(M.some(W=>W.installed||W.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=E,e.ExtensionsSynchroniser=E=ye([J(2,D.IEnvironmentService),J(3,v.IFileService),J(4,m.IStorageService),J(5,r.IUserDataSyncStoreService),J(6,r.IUserDataSyncLocalStoreService),J(7,g.IExtensionManagementService),J(8,t.IIgnoredExtensionsManagementService),J(9,r.IUserDataSyncLogService),J(10,S.IConfigurationService),J(11,r.IUserDataSyncEnablementService),J(12,C.ITelemetryService),J(13,f.IExtensionStorageService),J(14,s.IUriIdentityService),J(15,a.IUserDataProfileStorageService),J(16,l.IInstantiationService)],E);let L=class{constructor(M,W,Q,H,X,z){this.extensionManagementService=M,this.userDataProfileStorageService=W,this.extensionGalleryService=Q,this.ignoredExtensionsManagementService=H,this.instantiationService=X,this.logService=z}async getLocalExtensions(M){const W=await this.extensionManagementService.getInstalled(void 0,M.extensionsResource),Q=this.ignoredExtensionsManagementService.getIgnoredExtensions(W);return{localExtensions:await this.withProfileScopedServices(M,async(X,z)=>{const Y=X.getDisabledExtensions();return W.map(x=>{const{identifier:q,isBuiltin:te,manifest:se,preRelease:Z,pinned:re,isApplicationScoped:G}=x,$={identifier:q,preRelease:Z,version:se.version,pinned:!!re};G&&!(0,y.isApplicationScopedExtension)(se)&&($.isApplicationScoped=G),Y.some(P=>(0,c.areSameExtensions)(P,q))&&($.disabled=!0),te||($.installed=!0);try{const P=z.getKeysForSync({id:q.id,version:se.version});if(P){const O=z.getExtensionState(x,!0)||{};$.state=Object.keys(O).reduce((B,j)=>(P.includes(j)&&(B[j]=O[j]),B),{})}}catch(P){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",M)}: Error while parsing extension state`,(0,A.getErrorMessage)(P))}return $})}),ignoredExtensions:Q}}async updateLocalExtensions(M,W,Q,H,X){const z=(0,n.getSyncResourceLogLabel)("extensions",X),Y=[],x=new Map,q=[],te=[],se=await this.extensionManagementService.getInstalled(void 0,X.extensionsResource);if((M.length||Q.length)&&await this.withProfileScopedServices(X,async(G,$)=>{await k.Promises.settled([...M,...Q].map(async P=>{const O=se.find(ee=>(0,c.areSameExtensions)(ee.identifier,P.identifier));if(O&&O.isBuiltin){P.state&&O.manifest.version===P.version&&this.updateExtensionState(P.state,O,O.manifest.version,$),G.getDisabledExtensions().some(V=>(0,c.areSameExtensions)(V,P.identifier))!==!!P.disabled&&(P.disabled?(this.logService.trace(`${z}: Disabling extension...`,P.identifier.id),await G.disableExtension(P.identifier),this.logService.info(`${z}: Disabled extension`,P.identifier.id)):(this.logService.trace(`${z}: Enabling extension...`,P.identifier.id),await G.enableExtension(P.identifier),this.logService.info(`${z}: Enabled extension`,P.identifier.id))),q.push(P.identifier);return}const B=P.pinned?P.version:void 0,j=(await this.extensionGalleryService.getExtensions([{...P.identifier,version:B,preRelease:B?void 0:P.preRelease}],U.CancellationToken.None))[0];if(P.state&&(O?O.manifest.version===P.version:j)&&this.updateExtensionState(P.state,O||j,O?.manifest.version,$),j)try{G.getDisabledExtensions().some(V=>(0,c.areSameExtensions)(V,P.identifier))!==!!P.disabled&&(P.disabled?(this.logService.trace(`${z}: Disabling extension...`,P.identifier.id,j.version),await G.disableExtension(j.identifier),this.logService.info(`${z}: Disabled extension`,P.identifier.id,j.version)):(this.logService.trace(`${z}: Enabling extension...`,P.identifier.id,j.version),await G.enableExtension(j.identifier),this.logService.info(`${z}: Enabled extension`,P.identifier.id,j.version))),(!O||O.preRelease!==P.preRelease||O.pinned!==P.pinned||B&&O.manifest.version!==B)&&(await this.extensionManagementService.canInstall(j)?(Y.push({extension:j,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[g.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[g.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),x.set(j.identifier.id.toLowerCase(),P)):(this.logService.info(`${z}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),te.push(P)))}catch(ee){te.push(P),this.logService.error(ee),this.logService.info(`${z}: Skipped synchronizing extension`,j.displayName||j.identifier.id)}else te.push(P),this.logService.info(`${z}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),W.length){const G=se.filter(({identifier:$,isBuiltin:P})=>!P&&W.some(O=>(0,c.areSameExtensions)($,O)));await k.Promises.settled(G.map(async $=>{this.logService.trace(`${z}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.logService.info(`${z}: Uninstalled local extension.`,$.identifier.id),q.push($.identifier)}))}const Z=await this.extensionManagementService.installGalleryExtensions(Y);for(const{identifier:G,local:$,error:P,source:O}of Z){const B=O;if($)this.logService.info(`${z}: Installed extension.`,G.id,B.version),q.push(G);else{const j=x.get(G.id.toLowerCase());j&&(te.push(j),this.logService.info(`${z}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),P instanceof g.ExtensionManagementError&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.logService.info(`${z}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):P&&this.logService.error(P)}}const re=[];for(const G of H)q.some($=>(0,c.areSameExtensions)($,G.identifier))||re.push(G);for(const G of te)re.some($=>(0,c.areSameExtensions)($.identifier,G.identifier))||re.push(G);return re}updateExtensionState(M,W,Q,H){const X=H.getExtensionState(W,!0)||{},z=Q?H.getKeysForSync({id:W.identifier.id,version:Q}):void 0;z?z.forEach(Y=>{X[Y]=M[Y]}):Object.keys(M).forEach(Y=>X[Y]=M[Y]),H.setExtensionState(W,X,!0)}async withProfileScopedServices(M,W){return this.userDataProfileStorageService.withProfileScopedStorageService(M,async Q=>{const H=new R.DisposableStore,X=this.instantiationService.createChild(new h.ServiceCollection([m.IStorageService,Q])),z=H.add(X.createInstance(b.GlobalExtensionEnablementService)),Y=H.add(X.createInstance(f.ExtensionStorageService));try{return await W(z,Y)}finally{H.dispose()}})}};e.LocalExtensionsProvider=L,e.LocalExtensionsProvider=L=ye([J(0,g.IExtensionManagementService),J(1,a.IUserDataProfileStorageService),J(2,g.IExtensionGalleryService),J(3,t.IIgnoredExtensionsManagementService),J(4,l.IInstantiationService),J(5,r.IUserDataSyncLogService)],L);let N=class extends n.AbstractInitializer{constructor(M,W,Q,H,X,z,Y,x){super("extensions",H,X,z,Q,Y,x),this.extensionManagementService=M,this.ignoredExtensionsManagementService=W}async parseExtensions(M){return M.syncData?await w(M.syncData,this.extensionManagementService):null}generatePreview(M,W){const Q=[],H=[],X=[];for(const z of M){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(z.identifier.id))continue;const Y=W.find(x=>(0,c.areSameExtensions)(x.identifier,z.identifier));Y?(Q.push(Y),z.disabled&&X.push(z.identifier)):z.installed&&(H.push({...z.identifier,preRelease:!!z.preRelease}),z.disabled&&X.push(z.identifier))}return{installedExtensions:Q,newExtensions:H,disabledExtensions:X,remoteExtensions:M}}};e.AbstractExtensionsInitializer=N,e.AbstractExtensionsInitializer=N=ye([J(0,g.IExtensionManagementService),J(1,t.IIgnoredExtensionsManagementService),J(2,v.IFileService),J(3,o.IUserDataProfilesService),J(4,D.IEnvironmentService),J(5,u.ILogService),J(6,m.IStorageService),J(7,s.IUriIdentityService)],N)}),define(le[116],ue([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,79,238,24,17,60,4]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const n="globalState.argv.",i=["locale"];function t(E,L){const N=E.storage?Object.keys(E.storage).sort():[],F={};return N.forEach(M=>F[M]=E.storage[M]),E.storage=F,L?(0,_.toFormattedString)(E,{}):JSON.stringify(E)}e.stringify=t;const r=1;let a=class extends l.AbstractSynchroniser{constructor(L,N,F,M,W,Q,H,X,z,Y,x,q,te,se){super({syncResource:"globalState",profile:L},N,M,X,q,W,Q,z,Y,H,x,te),this.userDataProfileStorageService=F,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=se.createInstance(w),this._register(M.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(M.onDidFilesChange,Z=>Z.contains(this.environmentService.argvResource)),A.Event.filter(F.onDidChange,Z=>!!(Z.targetChanges.some(re=>this.syncResource.profile.id===re.id)||Z.valueChanges.some(({profile:re,changes:G})=>this.syncResource.profile.id===re.id&&G.some($=>$.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(L,N,F){const M=L.syncData?JSON.parse(L.syncData.content):null;N=N===null&&F?L:N;const W=N&&N.syncData?JSON.parse(N.syncData.content):null,Q=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.getStorageKeys(W),{local:X,remote:z}=(0,u.merge)(Q.storage,M?M.storage:null,W?W.storage:null,H,this.logService),Y={content:null,local:X,remote:z,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:z.all!==null?2:0},x=t(Q,!1);return[{baseResource:this.baseResource,baseContent:W?t(W,!1):x,localResource:this.localResource,localContent:x,localUserData:Q,remoteResource:this.remoteResource,remoteContent:M?t(M,!1):null,previewResource:this.previewResource,previewResult:Y,localChange:Y.localChange,remoteChange:Y.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async hasRemoteChanged(L){const N=L.syncData?JSON.parse(L.syncData.content):null;if(N===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),M=await this.getStorageKeys(N),{remote:W}=(0,u.merge)(F.storage,N.storage,N.storage,M,this.logService);return W.all!==null}async getMergeResult(L,N){return{...L.previewResult,hasConflicts:!1}}async getAcceptResult(L,N,F,M){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(L);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(L);if(this.extUri.isEqual(N,this.previewResource))return L.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(L){return{content:L.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(L.localUserData.storage),removed:[],updated:[],all:L.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(L){if(L.remoteContent!==null){const N=JSON.parse(L.remoteContent),{local:F,remote:M}=(0,u.merge)(L.localUserData.storage,N.storage,null,L.storageKeys,this.logService);return{content:L.remoteContent,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:L.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(L,N,F,M){const{localUserData:W}=F[0][0],{local:Q,remote:H,localChange:X,remoteChange:z}=F[0][1];if(X===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),X!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(W)),await this.localGlobalStateProvider.writeLocalGlobalState(Q,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),z!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const Y=JSON.stringify({storage:H.all});L=await this.updateRemoteUserData(Y,M?null:L.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}N?.ref!==L.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(L),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(L){if(this.extUri.isEqual(this.remoteResource,L)||this.extUri.isEqual(this.baseResource,L)||this.extUri.isEqual(this.localResource,L)||this.extUri.isEqual(this.acceptedResource,L)){const N=await this.resolvePreviewContent(L);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:L}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(L).length>1||L[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(L){const N=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),F=[],M=[];for(const[H,X]of N)X.target===0?F.push(H):X.target===1&&M.push(H);const W=[...F,...M],Q=L?.storage?Object.keys(L.storage).filter(H=>!H.startsWith(n)&&!W.includes(H)&&N.get(H)!==void 0):[];if(!R.isWeb){const H=[...m.ALL_SYNC_RESOURCES.map(X=>(0,m.getEnablementKey)(X)),m.SYNC_SERVICE_URL_TYPE];Q.push(...H),M.push(...H)}return{user:F,machine:M,unregistered:Q}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=ye([J(2,s.IUserDataProfileStorageService),J(3,b.IFileService),J(4,m.IUserDataSyncStoreService),J(5,m.IUserDataSyncLocalStoreService),J(6,m.IUserDataSyncLogService),J(7,D.IEnvironmentService),J(8,m.IUserDataSyncEnablementService),J(9,y.ITelemetryService),J(10,S.IConfigurationService),J(11,f.IStorageService),J(12,v.IUriIdentityService),J(13,o.IInstantiationService)],a);let w=class{constructor(L,N,F,M){this.fileService=L,this.environmentService=N,this.userDataProfileStorageService=F,this.logService=M}async getLocalGlobalState(L){const N={};if(L.isDefault){const M=await this.getLocalArgvContent(),W=(0,T.parse)(M);for(const Q of i)W[Q]!==void 0&&(N[`${n}${Q}`]={version:1,value:W[Q]})}const F=await this.userDataProfileStorageService.readStorageData(L);for(const[M,W]of F)W.value&&W.target===0&&(N[M]={version:1,value:W.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const L=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),L.value.toString()}catch(L){this.logService.debug((0,U.getErrorMessage)(L))}return"{}"}async writeLocalGlobalState({added:L,removed:N,updated:F},M){const W=(0,l.getSyncResourceLogLabel)("globalState",M),Q={},H=new Map,X=await this.userDataProfileStorageService.readStorageData(M),z=(Y,x)=>{for(const q of Y){if(q.startsWith(n)){Q[q.substring(n.length)]=x?x[q].value:void 0;continue}if(x){const te=x[q];te.value!==X.get(q)?.value&&H.set(q,te.value)}else X.get(q)!==void 0&&H.set(q,void 0)}};if(z(Object.keys(L),L),z(Object.keys(F),F),z(N),Object.keys(Q).length){this.logService.trace(`${W}: Updating locale...`);const Y=await this.getLocalArgvContent();let x=Y;for(const q of Object.keys(Q))x=(0,h.edit)(x,[q],Q[q],{});Y!==x&&(this.logService.trace(`${W}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(x)),this.logService.info(`${W}: Updated locale.`)),this.logService.info(`${W}: Updated locale`)}H.size&&(this.logService.trace(`${W}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(M,H,0),this.logService.info(`${W}: Updated global state`,[...H.keys()]))}};e.LocalGlobalStateProvider=w,e.LocalGlobalStateProvider=w=ye([J(0,b.IFileService),J(1,D.IEnvironmentService),J(2,s.IUserDataProfileStorageService),J(3,m.IUserDataSyncLogService)],w);let p=class extends l.AbstractInitializer{constructor(L,N,F,M,W,Q){super("globalState",F,M,W,N,L,Q)}async doInitialize(L){const N=L.syncData?JSON.parse(L.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},M={};for(const W of Object.keys(N.storage))W.startsWith(n)?F[W.substring(n.length)]=N.storage[W].value:this.storageService.get(W,0)===void 0&&(M[W]=N.storage[W].value);if(Object.keys(F).length){let W="{}";try{W=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const Q of Object.keys(F))W=(0,h.edit)(W,[Q],F[Q],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(W))}if(Object.keys(M).length){const W=[];for(const Q of Object.keys(M))W.push({key:Q,value:M[Q],scope:0,target:0});this.storageService.storeAll(W,!0)}}};e.GlobalStateInitializer=p,e.GlobalStateInitializer=p=ye([J(0,f.IStorageService),J(1,b.IFileService),J(2,C.IUserDataProfilesService),J(3,D.IEnvironmentService),J(4,m.IUserDataSyncLogService),J(5,v.IUriIdentityService)],p);let d=class{constructor(L,N,F,M,W){this.userDataSyncStoreClient=L,this.storageService=N,this.environmentService=F,this.fileService=M,this.logService=W}getSyncStoreType(L){return this.parseGlobalState(L)?.storage[m.SYNC_SERVICE_URL_TYPE]?.value}async sync(L){const N=(0,m.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(L,N)}catch(F){if(F instanceof m.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(L,N)}throw F}}async doSync(L,N){const F=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),M=this.parseGlobalState(F)||{storage:{}};M.storage[m.SYNC_SERVICE_URL_TYPE]={value:L,version:r};const W=await(0,c.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),Q={version:r,machineId:W,content:t(M,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(Q),F.ref,void 0,N)}parseGlobalState({content:L}){if(!L)return null;const N=JSON.parse(L);if((0,l.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=d,e.UserDataSyncStoreTypeSynchronizer=d=ye([J(1,f.IStorageService),J(2,D.IEnvironmentService),J(3,b.IFileService),J(4,g.ILogService)],d)}),define(le[117],ue([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,235,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(s,o,n){try{const i=JSON.parse(s);if(!o)return(0,R.isUndefined)(i.all)?null:i.all;switch(_.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.getKeybindingsContentFromSyncContent=u;let m=class extends v.AbstractJsonFileSynchroniser{constructor(o,n,i,t,r,a,w,p,d,E,L,N,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,p,d,E,i,t,w,N,r,L,a,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,n,i,t){const r=o.syncData?u(o.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&i?o:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,w=await this.getLocalFileContent(),p=await this.getFormattingOptions();let d=null,E=!1,L=!1,N=!1;if(r){let W=w?w.value.toString():"[]";if(W=W||"[]",this.hasErrors(W,!0))throw new h.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==W||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const Q=await(0,l.merge)(W,r,a,p,this.userDataSyncUtilService);Q.hasChanges&&(d=Q.mergeContent,N=Q.hasConflicts,E=N||Q.mergeContent!==W,L=N||Q.mergeContent!==r)}}else w&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=w.value.toString(),L=!0);const F={content:N?a:d,localChange:E?w?2:1:0,remoteChange:L?2:0,hasConflicts:N},M=w?w.value.toString():null;return[{fileContent:w,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:M,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getKeybindingsContentFromLastSyncUserData(o);if(n===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",r=await this.getFormattingOptions(),a=await(0,l.merge)(t||"[]",n,n,r,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(o,n){return o.previewResult}async getAcceptResult(o,n,i,t){if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:w,remoteChange:p}=i[0][1];if(w===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new h.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),p!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(d,t?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=(0,T.parse)(o.value.toString());if((0,k.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:u(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=o,_.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=m,e.KeybindingsSynchroniser=m=ye([J(2,h.IUserDataSyncStoreService),J(3,h.IUserDataSyncLocalStoreService),J(4,h.IUserDataSyncLogService),J(5,S.IConfigurationService),J(6,h.IUserDataSyncEnablementService),J(7,b.IFileService),J(8,D.IEnvironmentService),J(9,g.IStorageService),J(10,h.IUserDataSyncUtilService),J(11,c.ITelemetryService),J(12,f.IUriIdentityService)],m);let C=class extends v.AbstractInitializer{constructor(o,n,i,t,r,a){super("keybindings",n,i,t,o,r,a)}async doInitialize(o){const n=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,U.VSBuffer.fromString(n)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,T.parse)(o.value.toString());return!(0,k.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return u(o,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=C,e.KeybindingsInitializer=C=ye([J(0,b.IFileService),J(1,y.IUserDataProfilesService),J(2,D.IEnvironmentService),J(3,h.IUserDataSyncLogService),J(4,g.IStorageService),J(5,f.IUriIdentityService)],C)}),define(le[118],ue([0,1,15,3,171,20,75,14,29,11,21,22,28,17,39,239,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function l(C){return C&&C.settings&&typeof C.settings=="string"&&Object.keys(C).length===1}function h(C){const s=JSON.parse(C);return l(s)?s:{settings:C}}e.parseSettingsSyncContent=h;let u=class extends f.AbstractJsonFileSynchroniser{constructor(s,o,n,i,t,r,a,w,p,d,E,L,N,F){super(s.settingsResource,{syncResource:"settings",profile:s},o,n,i,t,r,a,E,L,w,p,d,F),this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const o=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(s,o),i=this.getSettingsSyncContent(n),t=new _.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,o,n){const i=await this.getLocalFileContent(),t=await this.getFormattingOptions(),r=this.getSettingsSyncContent(s);o=o===null&&n?s:o;const a=o?this.getSettingsSyncContent(o):null,w=await this.getIgnoredSettings();let p=null,d=!1,E=!1,L=!1;if(r){let W=i?i.value.toString().trim():"{}";W=W||"{}",this.validateContent(W),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Q=(0,y.merge)(W,r.settings,a?a.settings:null,w,[],t);p=Q.localContent||Q.remoteContent,d=Q.localContent!==null,E=Q.remoteContent!==null,L=Q.hasConflicts}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),p=i.value.toString().trim()||"{}",this.validateContent(p),E=!0);const N=i?i.value.toString():null,F=a?.settings??null,M={content:L?F:p,localChange:d?2:0,remoteChange:E?2:0,hasConflicts:L};return[{fileContent:i,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:N,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const o=this.getSettingsSyncContent(s);if(o===null)return!0;const n=await this.getLocalFileContent(),i=n?n.value.toString().trim():"",t=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,y.merge)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async getMergeResult(s,o){const n=await this.getFormattingOptions(),i=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,y.updateIgnoredSettings)(s.previewResult.content,"{}",i,n):null}}async getAcceptResult(s,o,n,i){const t=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:s.fileContent?(0,y.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:s.remoteContent!==null?(0,y.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,y.updateIgnoredSettings)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(s,o,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:w}=n[0][1];if(a===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),t&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(t.value.toString()))),await this.updateLocalFileContent(r,t,i),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const p=await this.getFormattingOptions(),d=this.getSettingsSyncContent(s),E=await this.getIgnoredSettings(r);r=(0,y.updateIgnoredSettings)(r,d?d.settings:"{}",E,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),i?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s)return!(0,y.isEmpty)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s)?this.resolvePreviewContent(s):null}async resolvePreviewContent(s){let o=await super.resolvePreviewContent(s);if(o){const n=await this.getFormattingOptions(),i=await this.getIgnoredSettings();o=(0,y.updateIgnoredSettings)(o,"{}",i,n)}return o}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return h(s)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=this._register(U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0}))}const o=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(o,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new v.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=u,e.SettingsSynchroniser=u=ye([J(2,S.IFileService),J(3,R.IEnvironmentService),J(4,D.IStorageService),J(5,v.IUserDataSyncStoreService),J(6,v.IUserDataSyncLocalStoreService),J(7,v.IUserDataSyncLogService),J(8,v.IUserDataSyncUtilService),J(9,T.IConfigurationService),J(10,v.IUserDataSyncEnablementService),J(11,b.ITelemetryService),J(12,I.IExtensionManagementService),J(13,g.IUriIdentityService)],u);let m=class extends f.AbstractInitializer{constructor(s,o,n,i,t,r){super("settings",o,n,i,s,t,r)}async doInitialize(s){const o=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,k.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return h(s)}catch(o){this.logService.error(o)}return null}};e.SettingsInitializer=m,e.SettingsInitializer=m=ye([J(0,S.IFileService),J(1,c.IUserDataProfilesService),J(2,R.IEnvironmentService),J(3,v.IUserDataSyncLogService),J(4,D.IStorageService),J(5,g.IUriIdentityService)],m)}),define(le[119],ue([0,1,15,3,30,20,14,11,21,22,28,17,39,236,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function y(h){return JSON.parse(h.content)}e.parseSnippets=y;let v=class extends g.AbstractSynchroniser{constructor(u,m,C,s,o,n,i,t,r,a,w,p){super({syncResource:"snippets",profile:u},m,s,C,o,n,i,a,w,t,r,p),this.version=1,this.snippetsFolder=u.snippetsHome,this._register(this.fileService.watch(C.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(U.Event.filter(this.fileService.onDidFilesChange,d=>d.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(u,m,C){const s=await this.getSnippetsFileContents(),o=this.toSnippetsContents(s),n=u.syncData?this.parseSnippets(u.syncData):null;m=m===null&&C?u:m;const i=m&&m.syncData?this.parseSnippets(m.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.merge)(o,n,i);return this.getResourcePreviews(t,s,n||{},i||{})}async hasRemoteChanged(u){const m=u.syncData?this.parseSnippets(u.syncData):null;if(m===null)return!0;const C=await this.getSnippetsFileContents(),s=this.toSnippetsContents(C),o=(0,c.merge)(s,m,m);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(u,m){return u.previewResult}async getAcceptResult(u,m,C,s){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder))return C===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:C,localChange:C===null?u.fileContent!==null?3:0:2,remoteChange:C===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(u,m,C,s){const o=C.map(([n,i])=>({...n,acceptResult:i}));o.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,s)),o.some(({remoteChange:n})=>n!==0)&&(u=await this.updateRemoteSnippets(o,u,s)),m?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.fileService.del(n)}catch{}}getResourcePreviews(u,m,C,s){const o=new Map;for(const n of Object.keys(u.local.added)){const i={content:u.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(u.local.updated)){const i={content:u.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=m[n]?m[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of u.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=m[n]?m[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(u.remote.added)){const i={content:u.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=m[n]?m[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(u.remote.updated)){const i={content:u.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=m[n]?m[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of u.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of u.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:C[n]?2:1},t=m[n]?m[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m))if(!o.has(n)){const i={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=m[n]?m[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:s[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(u){return this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(u):null}async hasLocalData(){try{const u=await this.getSnippetsFileContents();if(Object.keys(u).length)return!0}catch{}return!1}async updateLocalBackup(u){const m={};for(const C of u)C.fileContent&&(m[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(m)))}async updateLocalSnippets(u,m){for(const{fileContent:C,acceptResult:s,localResource:o,remoteResource:n,localChange:i}of u)if(i!==0){const t=n?this.extUri.basename(n):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,t);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,k.VSBuffer.fromString(s.content),{overwrite:m}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,k.VSBuffer.fromString(s.content),m?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(u,m,C){const s=m.syncData?this.parseSnippets(m.syncData):{},o=(0,A.deepClone)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of u)if(r!==0){const a=i?this.extUri.basename(i):this.extUri.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,c.areSame)(s,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),m=await this.updateRemoteUserData(JSON.stringify(o),C?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),m}parseSnippets(u){return y(u)}toSnippetsContents(u){const m={};for(const C of Object.keys(u))m[C]=u[C].value.toString();return m}async getSnippetsFileContents(){const u={};let m;try{m=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof R.FileOperationError&&C.fileOperationResult===1)return u;throw C}for(const C of m.children||[]){const s=C.resource,o=this.extUri.extname(s);if(o===".json"||o===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,s),i=await this.fileService.readFile(s);u[n]=i}}return u}};e.SnippetsSynchroniser=v,e.SnippetsSynchroniser=v=ye([J(2,_.IEnvironmentService),J(3,R.IFileService),J(4,I.IStorageService),J(5,f.IUserDataSyncStoreService),J(6,f.IUserDataSyncLocalStoreService),J(7,f.IUserDataSyncLogService),J(8,T.IConfigurationService),J(9,f.IUserDataSyncEnablementService),J(10,S.ITelemetryService),J(11,D.IUriIdentityService)],v);let l=class extends g.AbstractInitializer{constructor(u,m,C,s,o,n){super("snippets",m,C,s,u,o,n)}async doInitialize(u){const m=u.syncData?JSON.parse(u.syncData.content):null;if(!m){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(m)){const o=m[s];if(o){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,s);await this.fileService.createFile(n,k.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(u)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.SnippetsInitializer=l,e.SnippetsInitializer=l=ye([J(0,R.IFileService),J(1,b.IUserDataProfilesService),J(2,_.IEnvironmentService),J(3,f.IUserDataSyncLogService),J(4,I.IStorageService),J(5,D.IUriIdentityService)],l)}),define(le[120],ue([0,1,15,20,14,11,21,22,28,17,39,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function g(v,l){try{return JSON.parse(v).tasks??null}catch(h){return l.error(h),null}}e.getTasksContentFromSyncContent=g;let c=class extends D.AbstractFileSynchroniser{constructor(l,h,u,m,C,s,o,n,i,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},h,n,i,t,u,m,o,r,C,s,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(l,h,u,m){const C=l.syncData?g(l.syncData.content,this.logService):null;h=h===null&&u?l:h;const s=h?.syncData?g(h.syncData.content,this.logService):null,o=await this.getLocalFileContent();let n=null,i=!1,t=!1,r=!1;if(l.syncData){const p=o?o.value.toString():null;if(!s||s!==p||s!==C){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const d=y(p,C,s);n=d.content,r=d.hasConflicts,i=d.hasLocalChanged,t=d.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?s:n,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},w=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:s,localResource:this.localResource,localContent:w,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:C,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(l){const h=l?.syncData?g(l.syncData.content,this.logService):null;if(h===null)return!0;const u=await this.getLocalFileContent(),m=u?u.value.toString():null,C=y(m,h,h);return C.hasLocalChanged||C.hasRemoteChanged}async getMergeResult(l,h){return l.previewResult}async getAcceptResult(l,h,u,m){if(this.extUri.isEqual(h,this.localResource))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(h,this.remoteResource))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(h,this.previewResource))return u===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async applyResult(l,h,u,m){const{fileContent:C}=u[0][0],{content:s,localChange:o,remoteChange:n}=u[0][1];if(o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),C&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(C.value.toString()))),s?await this.updateLocalFileContent(s,C,m):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(s));l=await this.updateRemoteUserData(i,m?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}h?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(l),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(l){return this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.baseResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l)?this.resolvePreviewContent(l):null}toTasksSyncContent(l){return l?{tasks:l}:{}}};e.TasksSynchroniser=c,e.TasksSynchroniser=c=ye([J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncLocalStoreService),J(4,b.IUserDataSyncLogService),J(5,U.IConfigurationService),J(6,b.IUserDataSyncEnablementService),J(7,T.IFileService),J(8,A.IEnvironmentService),J(9,_.IStorageService),J(10,R.ITelemetryService),J(11,I.IUriIdentityService)],c);let f=class extends D.AbstractInitializer{constructor(l,h,u,m,C,s){super("tasks",h,u,m,l,C,s),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(l){const h=l.syncData?g(l.syncData.content,this.logService):null;if(!h){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(h)),await this.updateLastSyncUserData(l)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=f,e.TasksInitializer=f=ye([J(0,T.IFileService),J(1,S.IUserDataProfilesService),J(2,A.IEnvironmentService),J(3,b.IUserDataSyncLogService),J(4,_.IStorageService),J(5,I.IUriIdentityService)],f);function y(v,l,h){if(v===null&&l===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=h!==v,m=h!==l;return!u&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!m?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!u?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],ue([0,1,42,20,14,11,21,22,28,17,39,237,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let c=class extends D.AbstractSynchroniser{constructor(l,h,u,m,C,s,o,n,i,t,r,a,w){super({syncResource:"profiles",profile:l},h,m,C,s,o,n,r,a,i,t,w),this.userDataProfilesService=u,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(u.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?y(l.syncData):null}async getRemoteSyncedProfiles(l){const h=await this.getLastSyncUserData(),u=await this.getLatestRemoteUserData(l,h);return u?.syncData?y(u.syncData):null}async generateSyncPreview(l,h,u){if(!this.userDataProfilesService.isEnabled())throw new g.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const m=l.syncData?y(l.syncData):null,C=h?.syncData?y(h.syncData):null,s=this.getLocalUserDataProfiles(),{local:o,remote:n}=(0,b.merge)(s,m,C,[]),i={local:o,remote:n,content:C?this.stringifyRemoteProfiles(C):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=f(s,!1);return[{baseResource:this.baseResource,baseContent:C?this.stringifyRemoteProfiles(C):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:m?this.stringifyRemoteProfiles(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(l){const h=l?.syncData?y(l.syncData):null,u=this.getLocalUserDataProfiles(),{remote:m}=(0,b.merge)(u,h,h,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async getMergeResult(l,h){return{...l.previewResult,hasConflicts:!1}}async getAcceptResult(l,h,u,m){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(h,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(l){const h=this.getLocalUserDataProfiles(),u=(0,b.merge)(h,null,null,[]),{local:m,remote:C}=u;return{content:l.localContent,local:m,remote:C,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:C!==null?2:0}}async acceptRemote(l){const h=l.remoteContent?JSON.parse(l.remoteContent):null,u=[],m=[];for(const C of this.getLocalUserDataProfiles()){const s=h?.find(o=>o.id===C.id);s&&(u.push({id:C.id,name:C.name,collection:s.collection}),m.push(C))}if(h!==null){const C=(0,b.merge)(m,h,u,[]),{local:s,remote:o}=C;return{content:l.remoteContent,local:s,remote:o,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(l,h,u,m){const{local:C,remote:s,localChange:o,remoteChange:n}=u[0][1];o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const i=u[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new g.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const t=[];for(const r of C.added)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of C.removed)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of C.updated){const a=this.userDataProfilesService.profiles.find(w=>w.id===r.id);a?t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const a of s?.added||[]){const w=await this.userDataSyncStoreService.createCollection(this.syncHeaders);t.push(w),i.push({id:a.id,name:a.name,collection:w,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])i.splice(i.findIndex(({id:w})=>a.id===w),1);for(const a of s?.updated||[]){const w=i.find(({id:p})=>a.id===p);w&&i.splice(i.indexOf(w),1,{...w,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(i,m?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of t)await this.userDataSyncStoreService.deleteCollection(w,this.syncHeaders)}throw a}for(const a of s?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}h?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(l),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,h){return this.updateRemoteUserData(this.stringifyRemoteProfiles(l),h)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(l){if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.baseResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l)){const h=await this.resolvePreviewContent(l);return h&&(0,k.toFormattedString)(JSON.parse(h),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(l=>!l.isDefault&&!l.isTransient)}stringifyRemoteProfiles(l){return JSON.stringify([...l].sort((h,u)=>h.name.localeCompare(u.name)))}};e.UserDataProfilesManifestSynchroniser=c,e.UserDataProfilesManifestSynchroniser=c=ye([J(2,S.IUserDataProfilesService),J(3,T.IFileService),J(4,A.IEnvironmentService),J(5,_.IStorageService),J(6,g.IUserDataSyncStoreService),J(7,g.IUserDataSyncLocalStoreService),J(8,g.IUserDataSyncLogService),J(9,U.IConfigurationService),J(10,g.IUserDataSyncEnablementService),J(11,R.ITelemetryService),J(12,I.IUriIdentityService)],c);function f(v,l){const h=[...v].sort((u,m)=>u.name.localeCompare(m.name)).map(u=>({id:u.id,name:u.name}));return l?(0,k.toFormattedString)(h,{}):JSON.stringify(h)}e.stringifyLocalProfiles=f;function y(v){return JSON.parse(v.content)}e.parseUserDataProfilesManifest=y}),define(le[255],ue([0,1,3,2,5,14,21,22,24]),function(ne,e,k,U,A,T,_,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let D=class extends U.Disposable{constructor(g,c,f,y){super(),this.storageService=g,this.telemetryService=c,this.environmentService=f,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(g.onDidChangeValue(-1,void 0,this._register(new U.DisposableStore))(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(S,{enabled:g}),this.storageService.store(S,g,-1,1))}isResourceEnabled(g){return this.storageService.getBoolean((0,I.getEnablementKey)(g),-1,!0)}setResourceEnablement(g,c){if(this.isResourceEnabled(g)!==c){const f=(0,I.getEnablementKey)(g);this.storeResourceEnablement(f,c)}}getResourceSyncStateVersion(g){}storeResourceEnablement(g,c){this.storageService.store(g,c,-1,A.isWeb?0:1)}onDidStorageChange(g){if(S===g.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const c=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===g.key)[0];if(c){this._onDidChangeResourceEnablement.fire([c,this.isResourceEnabled(c)]);return}}};e.UserDataSyncEnablementService=D,e.UserDataSyncEnablementService=D=ye([J(0,_.IStorageService),J(1,R.ITelemetryService),J(2,T.IEnvironmentService),J(3,I.IUserDataSyncStoreManagementService)],D)}),define(le[256],ue([0,1,6,15,64,2,19,20,14,11,17,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let g=class extends T.Disposable{constructor(f,y,v,l,h){super(),this.environmentService=f,this.fileService=y,this.configurationService=v,this.logService=l,this.userDataProfilesService=h,this.cleanUp()}async cleanUp(){for(const y of this.userDataProfilesService.profiles)for(const v of b.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(v,y.isDefault?void 0:y.id))}catch(l){this.logService.error(l)}let f;try{f=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(y){(0,S.toFileOperationResult)(y)!==1&&this.logService.error(y);return}if(f.children){for(const y of f.children)if(y.isDirectory&&!this.userDataProfilesService.profiles.some(v=>v.id===y.name))try{this.logService.info("Deleting non existing profile from backup",y.resource.path),await this.fileService.del(y.resource,{recursive:!0})}catch(v){this.logService.error(v)}}}async getAllResourceRefs(f,y,v){const l=this.getResourceBackupHome(f,y,v);try{const h=await this.fileService.resolve(l);if(h.children)return h.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)}))}catch(h){if((0,S.toFileOperationResult)(h)!==1)throw h}return[]}async resolveResourceContent(f,y,v,l){const h=this.getResourceBackupHome(f,v,l),u=(0,_.joinPath)(h,y);try{return(await this.fileService.readFile(u)).value.toString()}catch(m){return this.logService.error(m),null}}async writeResource(f,y,v,l,h){const u=this.getResourceBackupHome(f,l,h),m=(0,_.joinPath)(u,`${(0,A.toLocalISOString)(v).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(m,U.VSBuffer.fromString(y))}catch(C){this.logService.error(C)}}getResourceBackupHome(f,y,v=this.environmentService.userDataSyncHome){return(0,_.joinPath)(v,...y?[y,f]:[f])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const y=await this.fileService.resolve(f);if(y.children){const v=y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),l=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let h=v.filter(m=>Date.now()-this.getCreationTime(m)>l);const u=v.length-h.length;u<10&&(h=h.slice(10-u)),await k.Promises.settled(h.map(async m=>{this.logService.info("Deleting from backup",m.resource.path),await this.fileService.del(m.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(f){return new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=g,e.UserDataSyncLocalStoreService=g=ye([J(0,I.IEnvironmentService),J(1,S.IFileService),J(2,R.IConfigurationService),J(3,b.IUserDataSyncLogService),J(4,D.IUserDataProfilesService)],g)}),define(le[83],ue([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const y="sync.currentMachineName",v="Safari",l="Chrome",h="Edge",u="Firefox",m="Android";function C(n){switch(n){case v:case l:case h:case u:case m:case(0,A.PlatformToString)(0):return!0}return!1}e.isWebPlatform=C;function s(){return A.isSafari?v:A.isChrome?l:A.isEdge?h:A.isFirefox?u:A.isAndroid?m:(0,A.PlatformToString)(A.isWeb?0:A.platform)}let o=class extends U.Disposable{static{f=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(i,t,r,a,w,p){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=w,this.productService=p,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(i,t,r)}async getMachines(i){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.computeCurrentMachineName(r.machines),platform:s()}),await this.writeMachinesData(r))}async removeCurrentMachine(i){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(i),a=r.machines.filter(({id:w})=>w!==t);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(i,t,r){const a=await this.readMachinesData(r),w=a.machines.find(({id:p})=>p===i);if(w){w.name=t,await this.writeMachinesData(a);const p=await this.currentMachineIdPromise;i===p&&this.storageService.store(y,t,-1,1)}}async setEnablements(i){const t=await this.readMachinesData();for(const[r,a]of i){const w=t.machines.find(p=>p.id===r);w&&(w.disabled=a?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(i){const t=this.storageService.get(y,-1);if(t)return t;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${s()} (${this.productService.nameShort})`,a=new RegExp(`${(0,T.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let w=0;for(const p of i){const d=a.exec(p.name),E=d?parseInt(d[1]):0;w=E>w?E:w}return`${r} #${w+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const t=this.parse(this.userData);if(t.version!==f.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(i){const t=JSON.stringify(i),r=await this.userDataSyncStoreService.writeResource(f.RESOURCE,t,this.userData?.ref||null);this.userData={ref:r,content:t},this._onDidChange.fire()}async readUserData(i){if(this.userData){const t=i&&i.latest?i.latest[f.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(f.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.logService.error(t)}return{version:f.VERSION,machines:[]}}};e.UserDataSyncMachinesService=o,e.UserDataSyncMachinesService=o=f=ye([J(0,R.IEnvironmentService),J(1,I.IFileService),J(2,g.IStorageService),J(3,c.IUserDataSyncStoreService),J(4,c.IUserDataSyncLogService),J(5,D.IProductService)],o)}),define(le[257],ue([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,80,83]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const h="sync.disableMachineEventually",u="sync.sessionId",m="sync.storeUrl",C="sync.productQuality";let s=class extends R.Disposable{get syncUrl(){const i=this.storageService.get(m,-1);return i?D.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(m,i.toString(),-1,1):this.storageService.remove(m,-1)}get productQuality(){return this.storageService.get(C,-1)}set productQuality(i){i?this.storageService.store(C,i,-1,1):this.storageService.remove(C,-1)}constructor(i,t,r,a,w,p,d,E,L,N){super(),this.userDataSyncStoreManagementService=t,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=a,this.userDataSyncService=w,this.logService=p,this.userDataSyncAccountService=d,this.telemetryService=E,this.userDataSyncMachinesService=L,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(t.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.syncUrl,t.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(d.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(w.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:t}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(t&&this.logService.info(t),this.autoSync.clear()):t&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(t))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,t,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(u,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),t)this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const t=y.UserDataSyncError.toUserDataSyncError(i);t instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:t.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?I.isWeb&&t.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(t),this.successiveFailures++),this._onError.fire(t)}async disableMachineEventually(){this.storageService.store(h,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(h,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(h,-1)}async triggerSync(i,t,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(t&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=s,e.UserDataAutoSyncService=s=ye([J(0,g.IProductService),J(1,y.IUserDataSyncStoreManagementService),J(2,y.IUserDataSyncStoreService),J(3,y.IUserDataSyncEnablementService),J(4,y.IUserDataSyncService),J(5,y.IUserDataSyncLogService),J(6,v.IUserDataSyncAccountService),J(7,f.ITelemetryService),J(8,l.IUserDataSyncMachinesService),J(9,c.IStorageService)],s);class o extends R.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(i,t,r,a,w,p,d,E,L){super(),this.lastSyncUrl=i,this.interval=t,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncService=w,this.userDataSyncMachinesService=p,this.logService=d,this.telemetryService=E,this.storageService=L,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>{this.sync(o.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(i,t){const r=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(w){if((0,T.isCancellationError)(w))return}return this.doSync(i,t,a)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,S.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),t=this.userDataSyncStoreManagementService.userDataSyncStore;return!!t&&!!i&&(!(0,S.isEqual)(t.defaultUrl,i.defaultUrl)||!(0,S.isEqual)(t.insidersUrl,i.insidersUrl)||!(0,S.isEqual)(t.stableUrl,i.stableUrl))}async doSync(i,t,r){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(t,r)}catch(w){if(this.logService.error(w),a=w,y.UserDataSyncError.toUserDataSyncError(w).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(t,r),a=void 0}catch(p){this.logService.error(p),a=p}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(i,t){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,i),t.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const r=this.storageService.get(u,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(t.isCancellationRequested)return;const w=a.find(d=>d.isCurrent);if(w?.disabled)throw new y.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");const p=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-p}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(d){throw new y.UserDataAutoSyncError((0,A.toErrorMessage)(d),d instanceof y.UserDataSyncError?d.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(u,this.manifest.session,-1,1),!t.isCancellationRequested&&(w||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(i){return super._register(i)}}}),define(le[258],ue([0,1,10,176,14,11,43,21,28,24,17,39,119,118,117,20,120,115,116,4,121,42,27]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{o=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(t,r,a,w,p,d,E,L,N,F){this.userDataSyncStoreService=t,this.userDataSyncLocalStoreService=r,this.logService=a,this.environmentService=p,this.storageService=d,this.fileService=E,this.userDataProfilesService=L,this.configurationService=N,this.instantiationService=F,this.extUri=w.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const r=this.parseSyncData(t.content,"profiles");return(0,m.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const w=this.parseSyncData(a,"profiles");return(0,m.parseUserDataProfilesManifest)(w)}}return[]}async getLocalSyncedMachines(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(p=>({...p,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.userDataSyncStoreService.getAllResourceRefs(t,r?.collection)).map(({created:w,ref:p})=>({created:w,uri:this.toUri({remote:!0,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:p,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(t,r?.collection,a)).map(({created:p,ref:d})=>({created:p,uri:this.toUri({remote:!1,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:d,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.resolveUri(t),a=r?this.userDataProfilesService.profiles.find(w=>w.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.resolveUri(t);if(!r)return[];const a=this.userDataProfilesService.profiles.find(w=>w.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(t,a);case"keybindings":return this.getKeybindingsAssociatedResources(t,a);case"tasks":return this.getTasksAssociatedResources(t,a);case"snippets":return this.getSnippetsAssociatedResources(t,a);case"globalState":return this.getGlobalStateAssociatedResources(t,a);case"extensions":return this.getExtensionsAssociatedResources(t,a);case"profiles":return this.getProfilesAssociatedResources(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.resolveUri(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.getUserData(r.syncResource,r.ref,r.collection);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const r=this.resolveUri(t);if(!r||r.node===o.NOT_EXISTING_RESOURCE)return null;if(r.ref){const a=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.resolveNodeContent(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(t,r,a,w,p){if(t){const{content:d}=await this.getUserData(r,w,a);return d}return this.userDataSyncLocalStoreService.resolveResourceContent(r,w,a,p)}resolveNodeContent(t,r,a){const w=this.parseSyncData(r,t);switch(t){case"settings":return this.resolveSettingsNodeContent(w,a);case"keybindings":return this.resolveKeybindingsNodeContent(w,a);case"tasks":return this.resolveTasksNodeContent(w,a);case"snippets":return this.resolveSnippetsNodeContent(w,a);case"globalState":return this.resolveGlobalStateNodeContent(w,a);case"extensions":return this.resolveExtensionsNodeContent(w,a);case"profiles":return this.resolveProfileNodeContent(w,a);case"workspaceState":return null}}async resolveLatestContent(t,r){const a=this.userDataProfilesService.profiles.find(w=>w.id===r);if(!a)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(a);case"extensions":return this.resolveLatestExtensionsContent(a);case"profiles":return this.resolveLatestProfilesContent(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"settings.json"),w=r?r.settingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveSettingsNodeContent(t,r){switch(r){case"settings.json":return(0,c.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"keybindings.json"),w=r?r.keybindingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveKeybindingsNodeContent(t,r){switch(r){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,r){const a=this.extUri.joinPath(t,"tasks.json"),w=r?r.tasksResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveTasksNodeContent(t,r){switch(r){case"tasks.json":return(0,v.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,r){const a=await this.resolveContent(t);if(a){const w=this.parseSyncData(a,"snippets");if(w){const p=(0,g.parseSnippets)(w),d=[];for(const E of Object.keys(p)){const L=this.extUri.joinPath(t,E),N=r?this.extUri.joinPath(r.snippetsHome,E):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);d.push({resource:L,comparableResource:N})}return d}}return[]}resolveSnippetsNodeContent(t,r){return(0,g.parseSnippets)(t)[r]||null}getExtensionsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"extensions.json"),w=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveExtensionsNodeContent(t,r){switch(r){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:r}=await this.instantiationService.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(r,!0)}getGlobalStateAssociatedResources(t,r){const a=this.extUri.joinPath(t,"globalState.json"),w=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:w}]}resolveGlobalStateNodeContent(t,r){switch(r){case"globalState.json":return(0,h.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const r=await this.instantiationService.createInstance(h.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,h.stringify)(r,!0)}getProfilesAssociatedResources(t,r){const a=this.extUri.joinPath(t,"profiles.json"),w=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:w}]}resolveProfileNodeContent(t,r){switch(r){case"profiles.json":return(0,C.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,m.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(t){const r=t.remote?o.REMOTE_BACKUP_AUTHORITY:o.LOCAL_BACKUP_AUTHORITY,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,s.trim)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.extUri.joinPath(k.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}resolveUri(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME)return;const r=[];for(;t.path!=="/";)r.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(r.length<2)return;const a=t.authority===o.REMOTE_BACKUP_AUTHORITY;let w,p;const d=[];let E,L,N,F,M;for(;r.length;){const W=r.shift();W.startsWith("scheme:")?w=W.substring(7):W.startsWith("authority:")?p=W.substring(10):W.startsWith("syncResource:")?E=W.substring(13):W.startsWith("profile:")?L=W.substring(8):W.startsWith("collection:")?N=W.substring(11):W.startsWith("ref:")?F=W.substring(4):E?M=W:d.push(W)}return{remote:a,syncResource:E,profile:L,collection:N,ref:F,node:M,location:w&&p!==void 0?this.extUri.joinPath(k.URI.from({scheme:w,authority:p,query:t.query,fragment:t.fragment,path:"/"}),...d):void 0}}parseSyncData(t,r){try{const a=JSON.parse(t);if((0,b.isSyncData)(a))return a}catch(a){this.logService.error(a)}throw new S.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(t,r,a){const w=await this.userDataSyncStoreService.resolveResourceContent(t,r,a);return{ref:r,content:w}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=o=ye([J(0,S.IUserDataSyncStoreService),J(1,S.IUserDataSyncLocalStoreService),J(2,S.IUserDataSyncLogService),J(3,I.IUriIdentityService),J(4,A.IEnvironmentService),J(5,R.IStorageService),J(6,T.IFileService),J(7,D.IUserDataProfilesService),J(8,y.IConfigurationService),J(9,u.IInstantiationService)],n)}),define(le[259],ue([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(E,L,N,F,M,W,Q,H,X,z,Y){super(),this.fileService=E,this.userDataSyncStoreService=L,this.userDataSyncStoreManagementService=N,this.instantiationService=F,this.logService=M,this.telemetryService=W,this.storageService=Q,this.userDataSyncEnablementService=H,this.userDataProfilesService=X,this.userDataSyncResourceProviderService=z,this.userDataSyncLocalStoreService=Y,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=N.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(t,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(E,L){this.checkEnablement(),this.logService.info("Sync started.");const N=new Date().getTime(),F=(0,D.generateUuid)();try{const H=(0,i.createSyncHeaders)(F);L&&(H["Cache-Control"]="no-cache"),E=await this.userDataSyncStoreService.manifest(E,H)}catch(H){const X=i.UserDataSyncError.toUserDataSyncError(H);throw p(X,F,this.userDataSyncStoreManagementService,this.telemetryService),X}const M=!1,W=this;let Q;return{manifest:E,async run(){if(M)throw new Error("Can run a task only once");Q=(0,U.createCancelablePromise)(H=>W.sync(E,!1,F,H)),await Q.finally(()=>Q=void 0),W.logService.info(`Sync done. Took ${new Date().getTime()-N}ms`),W.updateLastSyncTime()},stop(){return Q?.cancel(),W.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const E=new Date().getTime(),L=(0,D.generateUuid)(),N=(0,i.createSyncHeaders)(L);let F;try{F=await this.userDataSyncStoreService.manifest(null,N)}catch(Q){const H=i.UserDataSyncError.toUserDataSyncError(Q);throw p(H,L,this.userDataSyncStoreManagementService,this.telemetryService),H}await this.resetLocal();const M=this,W=new A.CancellationTokenSource;return{id:L,async merge(){return M.sync(F,!0,L,W.token)},async apply(){try{try{await M.applyManualSync(F,L,W.token)}catch(Q){if(i.UserDataSyncError.toUserDataSyncError(Q).code==="MethodNotFound")M.logService.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.logService.info("Applying manual sync again..."),await M.applyManualSync(F,L,W.token);else throw Q}}catch(Q){throw M.logService.error(Q),Q}M.logService.info(`Sync done. Took ${new Date().getTime()-E}ms`),M.updateLastSyncTime()},async stop(){W.cancel(),await M.stop(),await M.resetLocal()}}}async sync(E,L,N,F){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(M,E,L,N,F));const W=M.enabled.find(Q=>Q.resource==="profiles");if(W){const Q=await W.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.syncRemoteProfiles(Q,E,L,N,F)}}finally{this.status!=="hasConflicts"&&this.setStatus("idle"),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(E,L,N,F,M){for(const W of E){if(M.isCancellationRequested)return;const Q=this.userDataProfilesService.profiles.find(X=>X.id===W.id);if(!Q){this.logService.error(`Profile with id:${W.id} and name: ${W.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",W.name);const H=this.getOrCreateActiveProfileSynchronizer(Q,W);this._syncErrors.push(...await this.syncProfile(H,L,N,F,M))}for(const[W,Q]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(H=>H.id===Q[0].profile.id)||(Q[1].dispose(),this.activeProfileSynchronizers.delete(W))}async applyManualSync(E,L,N){const F=this.getActiveProfileSynchronizers();for(const X of F){if(N.isCancellationRequested)return;await X.apply(L,N)}const M=F.find(X=>X.profile.isDefault);if(!M)return;const W=M.enabled.find(X=>X.resource==="profiles");if(!W)return;const H=(await W.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(X=>F.every(z=>z.profile.id!==X.id));H.length&&await this.syncRemoteProfiles(H,E,!1,L,N)}async syncProfile(E,L,N,F,M){return(await E.sync(L,N,F,M)).map(([Q,H])=>({profile:E.profile,syncResource:Q,error:H}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(E=>E.stop()))}async resolveContent(E){const L=await this.userDataSyncResourceProviderService.resolveContent(E);if(L)return L;for(const N of this.getActiveProfileSynchronizers())for(const F of N.enabled){const M=await F.resolveContent(E);if(M)return M}return null}async replace(E){this.checkEnablement();const L=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(E);if(!L)return;const N=await this.resolveContent(E.uri);N&&await this.performAction(L.profile,async F=>{if(L.syncResource===F.resource)return await F.replace(N),!0})}async accept(E,L,N,F){this.checkEnablement(),await this.performAction(E.profile,async M=>{if(E.syncResource===M.resource)return await M.accept(L,N),F&&await M.apply((0,S.isBoolean)(F)?!1:F.force,(0,i.createSyncHeaders)((0,D.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async L=>{if(L.resource!=="globalState"&&await L.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async L=>{if(await L.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(E){this.logService.error(E)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(t,-1);for(const[E]of this.activeProfileSynchronizers.values())try{await E.resetLocal()}catch(L){this.logService.error(L)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),L=E.map(W=>W.collection),N=await this.userDataSyncStoreService.getAllCollections(),F=N.filter(W=>!L.includes(W));F.length&&(this.logService.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(W=>this.userDataSyncStoreService.deleteCollection(W))),this.logService.info("Deleted redundant collections on server"));const M=E.filter(W=>N.includes(W.collection));if(M.length!==E.length){const W=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await W.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await W.updateRemoteProfiles(M,null),this.logService.info("Updated remote profiles on server")}finally{W.dispose()}}}async saveRemoteActivityData(E){this.checkEnablement();const L=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(E,L)}async extractActivityData(E,L){const N=(await this.fileService.readFile(E)).value.toString(),F=JSON.parse(N);if(F.resources)for(const M in F.resources)for(const W of F.resources[M])await this.userDataSyncLocalStoreService.writeResource(M,W.content,new Date(W.created*1e3),void 0,L);if(F.collections)for(const M in F.collections)for(const W in F.collections[M].resources)for(const Q of F.collections[M].resources?.[W]??[])await this.userDataSyncLocalStoreService.writeResource(W,Q.content,new Date(Q.created*1e3),M,L)}async performAction(E,L){const N=new R.DisposableStore;try{const F=this.activeProfileSynchronizers.get(E.id);if(F){const X=await this.performActionWithProfileSynchronizer(F[0],L,N);return(0,S.isUndefined)(X)?null:X}if(E.isDefault){const X=N.add(this.instantiationService.createInstance(a,E,void 0)),z=await this.performActionWithProfileSynchronizer(X,L,N);return(0,S.isUndefined)(z)?null:z}if(this.userDataProfilesService.isEnabled())return null;const M=N.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,E,void 0)),W=await this.userDataSyncStoreService.manifest(null),H=(await M.getRemoteSyncedProfiles(W?.latest??null)||[]).find(X=>X.id===E.id);if(H){const X=N.add(this.instantiationService.createInstance(a,E,H.collection)),z=await this.performActionWithProfileSynchronizer(X,L,N);return(0,S.isUndefined)(z)?null:z}return null}finally{N.dispose()}}async performActionWithProfileSynchronizer(E,L,N){const F=[...E.enabled,...E.disabled.reduce((M,W)=>(W!=="workspaceState"&&M.push(N.add(E.createSynchronizer(W))),M),[])];for(const M of F){const W=await L(M);if(!(0,S.isUndefined)(W))return W}}setStatus(E){const L=this._status;this._status!==E&&(this._status=E,this._onDidChangeStatus.fire(E),L==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const E=this.getActiveProfileSynchronizers().map(L=>L.conflicts).flat();(0,k.equals)(this._conflicts,E,(L,N)=>L.profile.id===N.profile.id&&L.syncResource===N.syncResource&&(0,k.equals)(L.conflicts,N.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=E,this._onDidChangeConflicts.fire(E))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(E,L){let N=this.activeProfileSynchronizers.get(E.id);if(N&&N[0].collection!==L?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.activeProfileSynchronizers.delete(E.id)),!N){const F=new R.DisposableStore,M=F.add(this.instantiationService.createInstance(a,E,L?.collection));F.add(M.onDidChangeStatus(W=>this.setStatus(W))),F.add(M.onDidChangeConflicts(W=>this.updateConflicts())),F.add(M.onDidChangeLocal(W=>this._onDidChangeLocal.fire(W))),this.activeProfileSynchronizers.set(E.id,N=[M,F])}return N[0]}getActiveProfileSynchronizers(){const E=[];for(const[L]of this.activeProfileSynchronizers.values())E.push(L);return E}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,E])=>E.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=ye([J(0,c.IFileService),J(1,i.IUserDataSyncStoreService),J(2,i.IUserDataSyncStoreManagementService),J(3,f.IInstantiationService),J(4,i.IUserDataSyncLogService),J(5,v.ITelemetryService),J(6,y.IStorageService),J(7,i.IUserDataSyncEnablementService),J(8,l.IUserDataProfilesService),J(9,i.IUserDataSyncResourceProviderService),J(10,i.IUserDataSyncLocalStoreService)],r);let a=class extends R.Disposable{get enabled(){return this._enabled.sort((E,L)=>E[1]-L[1]).map(([E])=>E)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(E=>!this.userDataSyncEnablementService.isResourceEnabled(E))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(E,L,N,F,M,W,Q,H,X,z){super(),this.profile=E,this.collection=L,this.userDataSyncEnablementService=N,this.instantiationService=F,this.extensionGalleryService=M,this.userDataSyncStoreManagementService=W,this.telemetryService=Q,this.logService=H,this.userDataProfilesService=X,this.configurationService=z,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(N.onDidChangeResourceEnablement(([Y,x])=>this.onDidChangeResourceEnablement(Y,x))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,Y])=>Y.dispose())));for(const Y of i.ALL_SYNC_RESOURCES)N.isResourceEnabled(Y)&&this.registerSynchronizer(Y)}onDidChangeResourceEnablement(E,L){L?this.registerSynchronizer(E):this.deRegisterSynchronizer(E)}registerSynchronizer(E){if(this._enabled.some(([M])=>M.resource===E))return;if(E==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||E==="workspaceState")return;if(E!=="profiles"&&this.profile.useDefaultFlags?.[E]){this.logService.debug(`Skipping syncing ${E} in ${this.profile.name} because it is already synced by default profile`);return}const L=new R.DisposableStore,N=L.add(this.createSynchronizer(E));L.add(N.onDidChangeStatus(()=>this.updateStatus())),L.add(N.onDidChangeConflicts(()=>this.updateConflicts())),L.add(N.onDidChangeLocal(()=>this._onDidChangeLocal.fire(E)));const F=this.getOrder(E);this._enabled.push([N,F,L])}deRegisterSynchronizer(E){const L=this._enabled.findIndex(([N])=>N.resource===E);if(L!==-1){const[[N,,F]]=this._enabled.splice(L,1);F.dispose(),this.updateStatus(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.logService.error(M))}}createSynchronizer(E){switch(E){case"settings":return this.instantiationService.createInstance(C.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(s.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(o.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(h.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,L,N,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const W=[],Q=(0,i.createSyncHeaders)(N),H=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,X=L?await this.getUserDataSyncConfiguration(H):{};for(const z of M){if(F.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(z.resource))return[];try{if(L){const Y=await z.preview(H,X,Q);if(Y)for(const x of Y.resourcePreviews)(x.localChange!==0||x.remoteChange!==0)&&x.mergeState==="preview"&&await z.merge(x.previewResource)}else await z.sync(H,Q)}catch(Y){const x=i.UserDataSyncError.toUserDataSyncError(Y);if(p(x,N,this.userDataSyncStoreManagementService,this.telemetryService),w(Y))throw x;this.logService.error(Y),this.logService.error(`${z.resource}: ${(0,T.toErrorMessage)(Y)}`),W.push([z.resource,x])}}return W}finally{this.updateStatus()}}async apply(E,L){const N=(0,i.createSyncHeaders)(E);for(const F of this.enabled){if(L.isCancellationRequested)return;try{await F.apply(!1,N)}catch(M){const W=i.UserDataSyncError.toUserDataSyncError(M);if(p(W,E,this.userDataSyncStoreManagementService,this.telemetryService),w(M))throw W;this.logService.error(M),this.logService.error(`${F.resource}: ${(0,T.toErrorMessage)(M)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(L){this.logService.error(L)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(L){this.logService.error(`${E.resource}: ${(0,T.toErrorMessage)(L)}`),this.logService.error(L)}}async getUserDataSyncConfiguration(E){if(!this.profile.isDefault)return{};const L=this.configurationService.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(F=>F instanceof C.SettingsSynchroniser);if(N){const F=await N.getRemoteUserDataSyncConfiguration(E);return{...L,...F}}return L}setStatus(E){this._status!==E&&(this._status=E,this._onDidChangeStatus.fire(E))}updateStatus(){return this.updateConflicts(),this.enabled.some(E=>E.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const E=this.enabled.filter(L=>L.status==="hasConflicts").filter(L=>L.conflicts.conflicts.length>0).map(L=>L.conflicts);(0,k.equals)(this._conflicts,E,(L,N)=>L.syncResource===N.syncResource&&(0,k.equals)(L.conflicts,N.conflicts,(F,M)=>(0,I.isEqual)(F.previewResource,M.previewResource)))||(this._conflicts=E,this._onDidChangeConflicts.fire(E))}getOrder(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([J(2,i.IUserDataSyncEnablementService),J(3,f.IInstantiationService),J(4,g.IExtensionGalleryService),J(5,i.IUserDataSyncStoreManagementService),J(6,v.ITelemetryService),J(7,i.IUserDataSyncLogService),J(8,l.IUserDataProfilesService),J(9,b.IConfigurationService)],a);function w(d){if(d instanceof i.UserDataSyncError)switch(d.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function p(d,E,L,N){N.publicLog2("sync/error",{code:d.code,serverCode:d instanceof i.UserDataSyncStoreError?String(d.serverCode):void 0,url:d instanceof i.UserDataSyncStoreError?d.url:void 0,resource:d.resource,executionId:E,service:L.userDataSyncStore.url.toString()})}}),define(le[260],ue([0,1,3,2,10,17,24]),function(ne,e,k,U,A,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(g,c){return{...g,profile:(0,T.reviveProfile)(g.profile,c.profilesHome.scheme)}}function I(g){return{created:g.created,uri:A.URI.revive(g.uri)}}class S{constructor(c,f,y){this.service=c,this.userDataProfilesService=f,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(c,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(c,f,y){try{return await this._call(c,f,y)}catch(v){throw this.logService.error(v),v}}async _call(c,f,y){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(A.URI.revive(y[0]));case"accept":return this.service.accept(R(y[0],this.userDataProfilesService),A.URI.revive(y[1]),y[2],y[3]);case"replace":return this.service.replace(I(y[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(A.URI.revive(y[0]));case"extractActivityData":return this.service.extractActivityData(A.URI.revive(y[0]),A.URI.revive(y[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const v=f.substring(11),l=y[0],h=this.getManualSyncTask(l);switch(y=y.slice(1),v){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.manualSyncTasks.delete(this.createKey(h.id)));case"stop":return h.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(h.id)))}}throw new Error("Invalid call")}getManualSyncTask(c){const f=this.manualSyncTasks.get(this.createKey(c));if(!f)throw new Error(`Manual sync taks not found: ${c}`);return f}async createManualSyncTask(){const c=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(c.id),c),c.id}createKey(c){return`manualSyncTask-${c}`}}e.UserDataSyncChannel=S;let D=class extends U.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(c,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,v,l){return c.call(y,v,l).then(null,h=>{throw _.UserDataSyncError.toUserDataSyncError(h)})},listen(y,v){return c.listen(y,v)}},this.channel.call("_getInitialData").then(([y,v,l])=>{this.updateStatus(y),this.updateConflicts(v),l&&this.updateLastSyncTime(l),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(v=>({...v,error:_.UserDataSyncError.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.channel.call("createManualSyncTask"),f=this;return new b(c,{async call(v,l,h){return f.channel.call(`manualSync/${v}`,[c,...Array.isArray(l)?l:[l]],h)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(c,f,y,v){return this.channel.call("accept",[c,f,y,v])}resolveContent(c){return this.channel.call("resolveContent",[c])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(c){return this.channel.call("replace",[c])}saveRemoteActivityData(c){return this.channel.call("getRemoteActivityData",[c])}extractActivityData(c,f){return this.channel.call("extractActivityData",[c,f])}async updateStatus(c){this._status=c,this._onDidChangeStatus.fire(c)}async updateConflicts(c){this._conflicts=c.map(f=>({syncResource:f.syncResource,profile:(0,T.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(y=>({...y,baseResource:A.URI.revive(y.baseResource),localResource:A.URI.revive(y.localResource),remoteResource:A.URI.revive(y.remoteResource),previewResource:A.URI.revive(y.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(c){this._lastSyncTime!==c&&(this._lastSyncTime=c,this._onDidChangeLastSyncTime.fire(c))}};e.UserDataSyncChannelClient=D,e.UserDataSyncChannelClient=D=ye([J(1,T.IUserDataProfilesService)],D);class b extends U.Disposable{constructor(c,f){super(),this.id=c,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(le[261],ue([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,59,43,21,24]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const C="configurationSync.store",s="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(m.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(N){this.storageService.store(m.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,F,M){super(),this.productService=N,this.configurationService=F,this.storageService=M,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const W=this._register(new _.DisposableStore);this._register(T.Event.filter(M.onDidChangeValue(-1,m.SYNC_SERVICE_URL_TYPE,W),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,W)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[C]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(N){if(N&&(N=I.isWeb&&N.web?{...N,...N.web}:N,(0,D.isString)(N.url)&&(0,D.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,M=!!F.canSwitch,W=F.url===F.insidersUrl?"insiders":"stable",Q=(M?this.userDataSyncStoreType:void 0)||W,H=Q==="insiders"?F.insidersUrl:Q==="stable"?F.stableUrl:F.url;return{url:b.URI.parse(H),type:Q,defaultType:W,defaultUrl:b.URI.parse(F.url),stableUrl:b.URI.parse(F.stableUrl),insidersUrl:b.URI.parse(F.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(F.authenticationProviders).reduce((X,z)=>(X.push({id:z,scopes:F.authenticationProviders[z].scopes}),X),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=ye([J(0,v.IProductService),J(1,c.IConfigurationService),J(2,u.IStorageService)],a);let w=class extends a{constructor(N,F,M){super(N,F,M);const W=this.storageService.get(s,-1);W&&(this.previousConfigurationSyncStore=JSON.parse(W));const Q=this.productService[C];Q?this.storageService.store(s,JSON.stringify(Q),-1,1):this.storageService.remove(s,-1)}async switch(N){N!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=N,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=w,e.UserDataSyncStoreManagementService=w=ye([J(0,v.IProductService),J(1,c.IConfigurationService),J(2,u.IStorageService)],w);let p=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(N,F,M,W,Q,H,X){super(),this.requestService=M,this.logService=W,this.storageService=X,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(N),this.commonHeadersPromise=(0,h.getServiceMachineId)(Q,H,X).then(z=>{const Y={"X-Client-Name":`${F.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Y["X-Client-Commit"]=F.commit),Y}),this.session=new E(t,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(N,F){this.authToken={token:N,type:F}}updateUserDataSyncStoreUrl(N){this.userDataSyncStoreUrl=N?(0,S.joinPath)(N,"v1"):void 0}initDonotMakeRequestsUntil(){const N=this.storageService.getNumber(o,-1);N&&Date.now()<N&&this.setDonotMakeRequestsUntil(new Date(N))}setDonotMakeRequestsUntil(N){this._donotMakeRequestsUntil?.getTime()!==N?.getTime()&&(this._donotMakeRequestsUntil=N,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.request(F,{type:"GET",headers:N},[],U.CancellationToken.None);return(await(0,l.asJson)(M))?.map(({id:W})=>W)||[]}async createCollection(N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const M=await this.request(F,{type:"POST",headers:N},[],U.CancellationToken.None),W=await(0,l.asTextOrError)(M);if(!W)throw new m.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[m.HEADER_OPERATION_ID]);return W}async deleteCollection(N,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=N?(0,S.joinPath)(this.userDataSyncStoreUrl,"collection",N).toString():(0,S.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(M,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=this.getResourceUrl(this.userDataSyncStoreUrl,F,N),W={},Q=await this.request(M.toString(),{type:"GET",headers:W},[],U.CancellationToken.None);return(await(0,l.asJson)(Q)||[]).map(({url:X,created:z})=>({ref:(0,S.relativePath)(M,M.with({path:X})),created:z*1e3}))}async resolveResourceContent(N,F,M,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Q=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,N),F).toString();W={...W},W["Cache-Control"]="no-cache";const H=await this.request(Q,{type:"GET",headers:W},[],U.CancellationToken.None);return await(0,l.asTextOrError)(H)}async deleteResource(N,F,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=F!==null?(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,N),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,M,N).toString(),Q={};await this.request(W,{type:"DELETE",headers:Q},[],U.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.request(N,{type:"DELETE",headers:F},[],U.CancellationToken.None)}async readResource(N,F,M,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Q=(0,S.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,M,N),"latest").toString();W={...W},W["Cache-Control"]="no-cache",F&&(W["If-None-Match"]=F.ref);const H=await this.request(Q,{type:"GET",headers:W},[304],U.CancellationToken.None);let X=null;if(H.res.statusCode===304&&(X=F),X===null){const z=H.res.headers.etag;if(!z)throw new m.UserDataSyncStoreError("Server did not return the ref",Q,"NoRef",H.res.statusCode,H.res.headers[m.HEADER_OPERATION_ID]);const Y=await(0,l.asTextOrError)(H);if(!Y&&H.res.statusCode===304)throw new m.UserDataSyncStoreError("Empty response",Q,"EmptyResponse",H.res.statusCode,H.res.headers[m.HEADER_OPERATION_ID]);X={ref:z,content:Y}}return X}async writeResource(N,F,M,W,Q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=this.getResourceUrl(this.userDataSyncStoreUrl,W,N).toString();Q={...Q},Q["Content-Type"]=R.Mimes.text,M&&(Q["If-Match"]=M);const X=await this.request(H,{type:"POST",data:F,headers:Q},[],U.CancellationToken.None),z=X.res.headers.etag;if(!z)throw new m.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",X.res.statusCode,X.res.headers[m.HEADER_OPERATION_ID]);return z}async manifest(N,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const W=await this.request(M,{type:"GET",headers:F},[304],U.CancellationToken.None);let Q=null;if(W.res.statusCode===304&&(Q=N),!Q){const X=W.res.headers.etag;if(!X)throw new m.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",W.res.statusCode,W.res.headers[m.HEADER_OPERATION_ID]);const z=await(0,l.asTextOrError)(W);if(!z&&W.res.statusCode===304)throw new m.UserDataSyncStoreError("Empty response",M,"EmptyResponse",W.res.statusCode,W.res.headers[m.HEADER_OPERATION_ID]);z&&(Q={...JSON.parse(z),ref:X})}const H=this.storageService.get(n,-1);return H&&Q&&H!==Q.session&&this.clearSession(),Q===null&&H&&this.clearSession(),Q&&this.storageService.store(n,Q.session,-1,1),Q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.userDataSyncStoreUrl,"download").toString(),F={},M=await this.request(N,{type:"GET",headers:F},[],U.CancellationToken.None);if(!(0,l.isSuccess)(M))throw new m.UserDataSyncStoreError("Server returned "+M.res.statusCode,N,"EmptyResponse",M.res.statusCode,M.res.headers[m.HEADER_OPERATION_ID]);if((0,l.hasNoContent)(M))throw new m.UserDataSyncStoreError("Empty response",N,"EmptyResponse",M.res.statusCode,M.res.headers[m.HEADER_OPERATION_ID]);return M.stream}getResourceUrl(N,F,M){return F?(0,S.joinPath)(N,"collection",F,"resource",M):(0,S.joinPath)(N,"resource",M)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(i,-1)}async request(N,F,M,W){if(!this.authToken)throw new m.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const Q=await this.commonHeadersPromise;F.headers={...F.headers||{},...Q,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let H;try{H=await this.session.request(N,F,W)}catch(q){if(!(q instanceof m.UserDataSyncStoreError)){let te="RequestFailed";const se=(0,A.getErrorMessage)(q).toLowerCase();se.includes("xhr timeout")?te="RequestTimeout":se.includes("protocol")&&se.includes("not supported")?te="RequestProtocolNotSupported":se.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":se.includes("headers must be an object")?te="RequestHeadersNotObject":(0,A.isCancellationError)(q)&&(te="RequestCanceled"),q=new m.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,te,void 0,void 0)}throw this.logService.info("Request failed",N),q}const X=H.res.headers[m.HEADER_OPERATION_ID],z={url:N,status:H.res.statusCode,"execution-id":F.headers[m.HEADER_EXECUTION_ID],"operation-id":X},Y=(0,l.isSuccess)(H)||H.res.statusCode&&M.includes(H.res.statusCode);let x="";if(Y?this.logService.trace("Request succeeded",z):(x=await(0,l.asText)(H)||"",this.logService.info("Request failed",z,x)),H.res.statusCode===401||H.res.statusCode===403){if(this.authToken=void 0,H.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",H.res.statusCode,X);if(H.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",H.res.statusCode,X)}if(this._onTokenSucceed.fire(),H.res.statusCode===404)throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",H.res.statusCode,X);if(H.res.statusCode===405)throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${x}`,N,"MethodNotFound",H.res.statusCode,X);if(H.res.statusCode===409)throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",H.res.statusCode,X);if(H.res.statusCode===410)throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",H.res.statusCode,X);if(H.res.statusCode===412)throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",H.res.statusCode,X);if(H.res.statusCode===413)throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",H.res.statusCode,X);if(H.res.statusCode===426)throw new m.UserDataSyncStoreError(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",H.res.statusCode,X);if(H.res.statusCode===429){const q=H.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",H.res.statusCode,X)):new m.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",H.res.statusCode,X)}if(!Y)throw new m.UserDataSyncStoreError("Server returned "+H.res.statusCode,N,"Unknown",H.res.statusCode,X);return H}addSessionHeaders(N){let F=this.storageService.get(i,-1);F===void 0&&(F=(0,g.generateUuid)(),this.storageService.store(i,F,-1,1)),N["X-Machine-Session-Id"]=F;const M=this.storageService.get(n,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};e.UserDataSyncStoreClient=p,e.UserDataSyncStoreClient=p=ye([J(1,v.IProductService),J(2,l.IRequestService),J(3,m.IUserDataSyncLogService),J(4,f.IEnvironmentService),J(5,y.IFileService),J(6,u.IStorageService)],p);let d=class extends p{constructor(N,F,M,W,Q,H,X){super(N.userDataSyncStore?.url,F,M,W,Q,H,X),this._register(N.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(N.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=d,e.UserDataSyncStoreService=d=ye([J(0,m.IUserDataSyncStoreManagementService),J(1,v.IProductService),J(2,l.IRequestService),J(3,m.IUserDataSyncLogService),J(4,f.IEnvironmentService),J(5,y.IFileService),J(6,u.IStorageService)],d);class E{constructor(N,F,M,W){this.limit=N,this.interval=F,this.requestService=M,this.logService=W,this.requests=[],this.startTime=void 0}request(N,F,M){if(this.isExpired()&&this.reset(),F.url=N,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new m.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(N),this.requestService.request(F,M)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=E}),define(le[262],ue([0,1,3,57,25,21,22,257,24,80,83]),function(ne,e,k,U,A,T,_,R,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(c,f,y,v,l,h,u,m,C,s,o){super(c,f,y,v,l,u,m,C,s,o),this._register(k.Event.debounce(k.Event.any(k.Event.map(h.onDidFocusMainWindow,()=>"windowFocus"),k.Event.map(h.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=b,e.UserDataAutoSyncService=b=ye([J(0,A.IProductService),J(1,I.IUserDataSyncStoreManagementService),J(2,I.IUserDataSyncStoreService),J(3,I.IUserDataSyncEnablementService),J(4,I.IUserDataSyncService),J(5,U.INativeHostService),J(6,I.IUserDataSyncLogService),J(7,S.IUserDataSyncAccountService),J(8,_.ITelemetryService),J(9,D.IUserDataSyncMachinesService),J(10,T.IStorageService)],b)}),define(le[263],ue([0,1,72,23,5,19]),function(ne,e,k,U,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(S){function D(){let b=S.scheme===U.Schemas.file?(0,T.originalFSPath)(S):S.toString();return A.isLinux||(b=b.toLowerCase()),(0,k.createHash)("md5").update(b).digest("hex")}return{id:D(),configPath:S}}e.getWorkspaceIdentifier=_;function R(S,D){function b(){if(S.scheme!==U.Schemas.file)return(0,k.createHash)("md5").update(S.toString()).digest("hex");if(!D)return;let c;return A.isLinux?c=D.ino:A.isMacintosh?c=D.birthtime.getTime():A.isWindows&&(typeof D.birthtimeMs=="number"?c=Math.floor(D.birthtimeMs):c=D.birthtime.getTime()),(0,k.createHash)("md5").update(S.fsPath).update(c?String(c):"").digest("hex")}const g=b();if(typeof g=="string")return{id:g,uri:S}}e.getSingleFolderWorkspaceIdentifier=R;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(le[264],ue([0,1,6,7,2,16,31,14,8,77,112,263,57,56,23]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let y=class extends A.Disposable{constructor(l,h,u,m){super(),this.environmentService=l,this.logService=h,this.nativeHostService=u,this.mainProcessService=m,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.environmentService.workspaceStorageHome.with({scheme:f.Schemas.file}).fsPath,h=await _.Promises.readdir(l),u=new S.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(h.map(async m=>{const C=(0,T.join)(l,m);m.length===b.NON_EMPTY_WORKSPACE_ID_LENGTH||m===D.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===m)||await u.isUsed(C)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await _.Promises.rm(C))}))}catch(l){(0,U.onUnexpectedError)(l)}}};e.UnusedWorkspaceStorageDataCleaner=y,e.UnusedWorkspaceStorageDataCleaner=y=ye([J(0,R.INativeEnvironmentService),J(1,I.ILogService),J(2,g.INativeHostService),J(3,c.IMainProcessService)],y)}),define(le[122],ue([0,1,72,63,36,272,15,7,3,2,16,5,32,40,67]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{traceSocketEvent(d,E){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,E)}constructor(d,E=""){this._canWrite=!0,this.debugLabel=E,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,R.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener),this._closeListener=L=>{this.traceSocketEvent("close",{hadError:L}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(d){const E=L=>{this.traceSocketEvent("read",L),d(_.VSBuffer.wrap(L))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(d){const E=L=>{d({type:0,hadError:L,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(d){const E=()=>{d()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(d){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,R.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,R.onUnexpectedError)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=y;var v;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(v||(v={}));var l;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(l||(l={}));class h extends S.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(d,E){this.socket.traceSocketEvent(d,E)}constructor(d,E,L,N){super(),this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new u(this,E,L,N,this._onData,(F,M)=>this._write(F,M))),this._register(this._flowManager.onError(F=>{console.error(F),(0,R.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new f.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(async F=>{this._flowManager.isProcessingReadQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(F)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){let E=0;for(;E<d.byteLength;)this._flowManager.writeMessage(d.slice(E,Math.min(E+262144,d.byteLength)),{compressed:!0,opcode:2}),E+=262144}_write(d,{compressed:E,opcode:L}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let N=2;d.byteLength<126?N+=0:d.byteLength<2**16?N+=2:N+=8;const F=_.VSBuffer.alloc(N),M=E?64:0,W=L&15;if(F.writeUInt8(128|M|W,0),d.byteLength<126)F.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){F.writeUInt8(126,1);let Q=1;F.writeUInt8(d.byteLength>>>8&255,++Q),F.writeUInt8(d.byteLength>>>0&255,++Q)}else{F.writeUInt8(127,1);let Q=1;F.writeUInt8(0,++Q),F.writeUInt8(0,++Q),F.writeUInt8(0,++Q),F.writeUInt8(0,++Q),F.writeUInt8(d.byteLength>>>24&255,++Q),F.writeUInt8(d.byteLength>>>16&255,++Q),F.writeUInt8(d.byteLength>>>8&255,++Q),F.writeUInt8(d.byteLength>>>0&255,++Q)}this.socket.write(_.VSBuffer.concat([F,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),L=E.readUInt8(0),N=(L&128)>>>7,F=(L&64)>>>6,M=L&15,W=E.readUInt8(1),Q=(W&128)>>>7,H=W&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=!!F),this._state.firstFrameOfMessage=!!N,this._state.mask=0,this._state.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),L=E.readUInt8(1),N=(L&128)>>>7;let F=L&127,M=1;F===126?F=E.readUInt8(++M)*2**8+E.readUInt8(++M):F===127&&(F=E.readUInt8(++M)*0+E.readUInt8(++M)*0+E.readUInt8(++M)*0+E.readUInt8(++M)*0+E.readUInt8(++M)*2**24+E.readUInt8(++M)*2**16+E.readUInt8(++M)*2**8+E.readUInt8(++M));let W=0;N&&(W=E.readUInt8(++M)*2**24+E.readUInt8(++M)*2**16+E.readUInt8(++M)*2**8+E.readUInt8(++M)),this._state.state=3,this._state.readLen=F,this._state.mask=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),s(E,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(E,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class u extends S.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}constructor(d,E,L,N,F,M){super(),this._tracer=d,this._onData=F,this._writeFn=M,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new I.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,E?(this._zlibInflateStream=this._register(new m(this._tracer,N,L,{windowBits:15})),this._zlibDeflateStream=this._register(new C(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(W=>this._onError.fire(W))),this._register(this._zlibDeflateStream.onError(W=>this._onError.fire(W)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(d,E){this._writeQueue.push({data:d,options:E}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:d,options:E}=this._writeQueue.shift();if(this._zlibDeflateStream&&E.compressed){const L=await this._deflateMessage(this._zlibDeflateStream,d);this._writeFn(L,E)}else this._writeFn(d,{...E,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(d,E){return new Promise((L,N)=>{d.write(E),d.flush(F=>L(F))})}acceptFrame(d,E,L){this._readQueue.push({data:d,isCompressed:E,isLastFrameOfMessage:L}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const d=this._readQueue.shift();if(this._zlibInflateStream&&d.isCompressed){const E=await this._inflateFrame(this._zlibInflateStream,d.data,d.isLastFrameOfMessage);this._onData.fire(E)}else this._onData.fire(d.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(d,E,L){return new Promise((N,F)=>{d.write(E),L&&d.write(_.VSBuffer.fromByteArray([0,0,255,255])),d.flush(M=>N(M))})}}class m extends S.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}constructor(d,E,L,N){super(),this._tracer=d,this._recordInflateBytes=E,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,T.createInflateRaw)(N),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(_.VSBuffer.wrap(F))}),L&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(d){this._recordInflateBytes&&this._recordedInflateBytes.push(d.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",d),this._zlibInflate.write(d.buffer)}flush(d){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const E=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,d(E)})}}class C extends S.Disposable{constructor(d,E){super(),this._tracer=d,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,T.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",L=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibDeflate.on("data",L=>{this._tracer.traceSocketEvent("zlibDeflateData",L),this._pendingDeflateData.push(_.VSBuffer.wrap(L))})}write(d){this._tracer.traceSocketEvent("zlibDeflateWrite",d.buffer),this._zlibDeflate.write(d.buffer)}flush(d){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let E=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.byteLength-4),d(E)})}}function s(p,d){if(d===0)return;const E=p.byteLength>>>2;for(let Q=0;Q<E;Q++){const H=p.readUInt32BE(Q*4);p.writeUInt32BE(H^d,Q*4)}const L=E*4,N=p.byteLength-L,F=d>>>24&255,M=d>>>16&255,W=d>>>8&255;N>=1&&p.writeUInt8(p.readUInt8(L)^F,L),N>=2&&p.writeUInt8(p.readUInt8(L+1)^M,L+1),N>=3&&p.writeUInt8(p.readUInt8(L+2)^W,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const p=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const d=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,A.tmpdir)(),E=(0,D.join)(d,`vscode-ipc-${p}.sock`);return t(E),E}e.createRandomIPCHandle=n;function i(p,d,E){const L=(0,k.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${E}-${d}-sock`;const N=E.substr(0,4),F=d.substr(0,6),M=L.substr(0,8);let W;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M}-${N}-${F}.sock`):W=(0,D.join)(p,`${N}-${F}.sock`),t(W),W}e.createStaticIPCHandle=i;function t(p){const d=o[b.platform];typeof d=="number"&&p.length>=d&&console.warn(`WARNING: IPC handle "${p}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{static toClientConnectionEvent(d){const E=I.Event.fromNodeEventEmitter(d,"connection");return I.Event.map(E,L=>({protocol:new f.Protocol(new y(L,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(L,"close"))}))}constructor(d){super(r.toClientConnectionEvent(d)),this.server=d}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(p){return new Promise((d,E)=>{const L=(0,U.createServer)();L.on("error",E),L.listen(p,()=>{L.removeListener("error",E),d(new r(L))})})}e.serve=a;function w(p,d){return new Promise((E,L)=>{const N=(0,U.createConnection)(p,()=>{N.removeListener("error",L),E(f.Client.fromSocket(new y(N,`ipc-client${d}`),d))});N.once("error",L)})}e.connect=w}),define(le[265],ue([0,1,63,122,211]),function(ne,e,k,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(T){return!0}connect({host:T,port:_},R,I,S){return new Promise((D,b)=>{const g=k.createConnection({host:T,port:_},()=>{g.removeListener("error",b),g.write((0,A.makeRawSocketHeaders)(R,I,S));const c=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",c),D(new U.NodeSocket(g,S)))};g.on("data",c)});g.setNoDelay(!0),g.once("error",b)})}}}),define(le[266],ue([0,1,63,36,132,122,6,2,5,20,8,25,214,104,106,78,15]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function l(s,o,n,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new h(s,o,n,i,t).waitForReady(),!(t&&A.BROWSER_RESTRICTED_PORTS[t]||!A.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));a--);return r}class h extends R.Disposable{constructor(o,n,i,t,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=k.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,A.findFreePortFaster)(o,2,1e3,n),t=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(o){o.pause();const n=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,g.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t instanceof T.NodeSocket?t.socket.destroy():t.end()}),t instanceof T.NodeSocket?this._mirrorNodeSocket(o,t):this._mirrorGenericSocket(o,t),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),t.end()})}_mirrorGenericSocket(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(i=>o.write(i.buffer)),o.on("data",i=>n.write(v.VSBuffer.wrap(i))),o.resume()}_mirrorNodeSocket(o,n){const i=n.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.NodeRemoteTunnel=h;let u=class extends y.AbstractTunnelService{constructor(o,n,i,t,r){super(n,r),this.remoteSocketFactoryService=o,this.signService=i,this.productService=t}isPortPrivileged(o){return(0,y.isPortPrivileged)(o,this.defaultTunnelHost,I.OS,U.release())}retainOrCreateTunnel(o,n,i,t,r,a,w,p){const d=this.getTunnelFromMap(n,i);if(d)return++d.refcount,d.value;if((0,y.isTunnelProvider)(o))return this.createWithProvider(o,n,i,r,a,w,p);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const E={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},L=l(E,t,n,i,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,i,L),L}}};e.BaseTunnelService=u,e.BaseTunnelService=u=ye([J(0,c.IRemoteSocketFactoryService),J(1,D.ILogService),J(2,f.ISignService),J(3,b.IProductService),J(4,S.IConfigurationService)],u);let m=class extends u{constructor(o,n,i,t,r){super(o,n,i,t,r)}};e.TunnelService=m,e.TunnelService=m=ye([J(0,c.IRemoteSocketFactoryService),J(1,D.ILogService),J(2,f.ISignService),J(3,b.IProductService),J(4,S.IConfigurationService)],m);let C=class extends R.Disposable{constructor(o,n,i,t,r){super(),this.remoteSocketFactoryService=o,this.logService=n,this.productService=i,this.signService=t,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(o,n,i,t,r,a,w,p,d){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this._tunnelServices.has(o)){const E=new m(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(E),this._tunnelServices.set(o,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(n,i,t,r,a,w,p,d)}};e.SharedTunnelsService=C,e.SharedTunnelsService=C=ye([J(0,c.IRemoteSocketFactoryService),J(1,D.ILogService),J(2,b.IProductService),J(3,f.ISignService),J(4,S.IConfigurationService)],C)}),define(le[273],ue([0,1,36,38,7,2,23,10,18,3,40,146,205,206,196,197,264,187,189,20,210,95,221,96,216,14,114,248,29,97,188,113,98,11,199,200,71,4,195,73,74,227,8,201,102,25,59,21,107,22,108,109,110,45,230,82,111,24,80,256,240,241,83,255,259,260,261,60,254,242,106,220,78,266,215,231,28,232,5,233,190,208,207,81,247,17,51,204,58,253,229,243,105,258,249,9,202,101,251,246,217,184,57,203,262,250,56,252,104,265,181,218]),function(ne,e,k,U,A,T,_,R,I,S,D,b,g,c,f,y,v,l,h,u,m,C,s,o,n,i,t,r,a,w,p,d,E,L,N,F,M,W,Q,H,X,z,Y,x,q,te,se,Z,re,G,$,P,O,B,j,ee,V,K,ie,ce,oe,de,fe,pe,we,Le,ke,Fe,he,me,Se,Pe,Re,Me,Te,je,Ue,$e,ae,ge,ve,Ee,Ie,be,De,_e,Oe,Ne,We,ze,qe,Xe,Ze,Et,wt,Ct,bt,dt,It,Pt,Dt,Rt,Lt,_t,kt,Tt,ft,At,gt,Ot,Ut,nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Nt extends T.Disposable{constructor(Ce){super(),this.configuration=Ce,this.server=this._register(new b.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new S.Emitter),this.registerListeners()}registerListeners(){let Ce=!1;const Ae=()=>{Ce||(Ce=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,b.once)(process.parentPort,nt.SharedProcessLifecycle.exit,Ae)}async init(){const Ce=await this.initServices();(0,K.registerConfiguration)(),Ce.invokeFunction(Ae=>{const Ge=Ae.get(Y.ILogService),xe=Ae.get(G.ITelemetryService),Ke=Ae.get(_e.IUserDataProfilesService);Ge.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ae),this.registerErrorHandler(Ge),this.reportProfilesInfo(xe,Ke),this._register(Ke.onDidChangeProfiles(()=>this.reportProfilesInfo(xe,Ke)))}),this._register((0,T.combinedDisposable)(Ce.createInstance(g.CodeCacheCleaner,this.configuration.codeCachePath),Ce.createInstance(c.LanguagePackCachedDataCleaner),Ce.createInstance(v.UnusedWorkspaceStorageDataCleaner),Ce.createInstance(y.LogsDataCleaner),Ce.createInstance(f.LocalizationsUpdater),Ce.createInstance(wt.ExtensionsContributions),Ce.createInstance(Xe.UserDataProfilesCleaner)))}async initServices(){const Ce=new H.ServiceCollection,Ae={_serviceBrand:void 0,...q.default};Ce.set(te.IProductService,Ae);const Ge=new D.StaticRouter(Ve=>Ve==="main"),xe=new ft.MainProcessService(this.server,Ge);Ce.set(ft.IMainProcessService,xe);const Ke=this.configuration.policiesData?new Ne.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new We.NullPolicyService;Ce.set(We.IPolicyService,Ke);const Be=new Ut.NativeEnvironmentService(this.configuration.args,Ae);Ce.set(i.INativeEnvironmentService,Be);const et=new x.LoggerChannelClient(void 0,this.configuration.logLevel,Be.logsHome,this.configuration.loggers.map(Ve=>({...Ve,resource:R.URI.revive(Ve.resource)})),xe.getChannel("logger"));Ce.set(Y.ILoggerService,et);const rt=this._register(et.createLogger("sharedprocess",{name:(0,Ct.localize)(0,null)})),lt=this._register(new Y.ConsoleLogger(rt.getLevel())),He=this._register(new bt.LogService(rt,[lt]));Ce.set(Y.ILogService,He),this.lifecycleService=this._register(new dt.SharedProcessLifecycleService(He)),Ce.set(dt.ISharedProcessLifecycleService,this.lifecycleService);const Ye=this._register(new N.FileService(He));Ce.set(L.IFileService,Ye);const ut=this._register(new F.DiskFileSystemProvider(He));Ye.registerProvider(_.Schemas.file,ut);const ot=new $e.UriIdentityService(Ye);Ce.set(Ue.IUriIdentityService,ot);const Je=this._register(new ze.UserDataProfilesService(this.configuration.profiles.all,R.URI.revive(this.configuration.profiles.home).with({scheme:Be.userRoamingDataHome.scheme}),xe.getChannel("userDataProfiles")));Ce.set(_e.IUserDataProfilesService,Je);const ht=this._register(new ge.FileUserDataProvider(_.Schemas.file,this._register(new ve.DiskFileSystemProviderClient(xe.getChannel(ve.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ae.isLinux})),_.Schemas.vscodeUserData,Je,ot,He));Ye.registerProvider(_.Schemas.vscodeUserData,ht);const Qe=this._register(new m.ConfigurationService(Je.defaultProfile.settingsResource,Ye,Ke,He));Ce.set(u.IConfigurationService,Qe);const tt=new At.RemoteStorageService(void 0,{defaultProfile:Je.defaultProfile,currentProfile:Je.defaultProfile},xe,Be);Ce.set(Z.IStorageService,tt),this._register((0,T.toDisposable)(()=>tt.flush())),await Promise.all([Qe.initialize(),tt.initialize()]);const St=new Dt.RequestChannelClient(xe.getChannel("request"));Ce.set(se.IRequestService,St),Ce.set(l.IChecksumService,new M.SyncDescriptor(h.ChecksumService,void 0,!1)),Ce.set(Ie.IV8InspectProfilingService,new M.SyncDescriptor(Ee.InspectProfilingService,void 0,!1));const vt=new _t.NativeHostService(-1,xe);Ce.set(Lt.INativeHostService,vt),Ce.set(o.IDownloadService,new M.SyncDescriptor(n.DownloadService,void 0,!0));const Ft=this._register(new me.ActiveWindowManager(vt)),Mt=new D.StaticRouter(Ve=>Ft.getActiveClientId().then(ct=>Ve===ct));Ce.set(E.IExtensionRecommendationNotificationService,new Rt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let at;const it=[],pt=(0,B.isInternalTelemetry)(Ae,Qe);if((0,B.supportsTelemetry)(Ae,Be)){const Ve=new P.TelemetryLogAppender(He,et,Be,Ae);if(it.push(Ve),!(0,B.isLoggingOnly)(Ae,Be)&&Ae.aiConfig?.ariaKey){const ct=new qe.OneDataSystemAppender(St,pt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>ct.flush())),it.push(ct)}at=new O.TelemetryService({appenders:it,commonProperties:(0,re.resolveCommonProperties)((0,k.release)(),(0,k.hostname)(),process.arch,Ae.commit,Ae.version,this.configuration.machineId,this.configuration.sqmId,pt),sendErrorTelemetry:!0,piiPaths:(0,B.getPiiPathsFromEnvironment)(Be)},Qe,Ae)}else{at=B.NullTelemetryService;const Ve=B.NullAppender;it.push(Ve)}this.server.registerChannel("telemetryAppender",new $.TelemetryAppenderChannel(it)),Ce.set(G.ITelemetryService,at);const $t=new j.CustomEndpointTelemetryService(Qe,at,He,et,Be,Ae);Ce.set(G.ICustomEndpointTelemetryService,$t),Ce.set(Oe.IExtensionsProfileScannerService,new M.SyncDescriptor(Pt.ExtensionsProfileScannerService,void 0,!0)),Ce.set(be.IExtensionsScannerService,new M.SyncDescriptor(De.ExtensionsScannerService,void 0,!0)),Ce.set(w.IExtensionSignatureVerificationService,new M.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),Ce.set(d.INativeServerExtensionManagementService,new M.SyncDescriptor(d.ExtensionManagementService,void 0,!0)),Ce.set(a.IExtensionGalleryService,new M.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),Ce.set(a.IExtensionTipsService,new M.SyncDescriptor(Tt.ExtensionTipsService,void 0,!1)),Ce.set(X.ILanguagePackService,new M.SyncDescriptor(z.NativeLanguagePackService,void 0,!1)),Ce.set(C.IDiagnosticsService,new M.SyncDescriptor(s.DiagnosticsService,void 0,!1)),Ce.set(ie.IUserDataSyncAccountService,new M.SyncDescriptor(ie.UserDataSyncAccountService,void 0,!0)),Ce.set(K.IUserDataSyncLogService,new M.SyncDescriptor(de.UserDataSyncLogService,void 0,!0)),Ce.set(K.IUserDataSyncUtilService,new oe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),Ce.set(a.IGlobalExtensionEnablementService,new M.SyncDescriptor(t.GlobalExtensionEnablementService,void 0,!1)),Ce.set(V.IIgnoredExtensionsManagementService,new M.SyncDescriptor(V.IgnoredExtensionsManagementService,void 0,!0)),Ce.set(ee.IExtensionStorageService,new M.SyncDescriptor(ee.ExtensionStorageService)),Ce.set(K.IUserDataSyncStoreManagementService,new M.SyncDescriptor(ke.UserDataSyncStoreManagementService,void 0,!0)),Ce.set(K.IUserDataSyncStoreService,new M.SyncDescriptor(ke.UserDataSyncStoreService,void 0,!0)),Ce.set(fe.IUserDataSyncMachinesService,new M.SyncDescriptor(fe.UserDataSyncMachinesService,void 0,!0)),Ce.set(K.IUserDataSyncLocalStoreService,new M.SyncDescriptor(ce.UserDataSyncLocalStoreService,void 0,!1)),Ce.set(K.IUserDataSyncEnablementService,new M.SyncDescriptor(pe.UserDataSyncEnablementService,void 0,!0)),Ce.set(K.IUserDataSyncService,new M.SyncDescriptor(we.UserDataSyncService,void 0,!1)),Ce.set(Fe.IUserDataProfileStorageService,new M.SyncDescriptor(he.NativeUserDataProfileStorageService,void 0,!0)),Ce.set(K.IUserDataSyncResourceProviderService,new M.SyncDescriptor(Et.UserDataSyncResourceProviderService,void 0,!0)),Ce.set(Se.ISignService,new M.SyncDescriptor(Pe.SignService,void 0,!1));const yt=new gt.RemoteSocketFactoryService;return Ce.set(gt.IRemoteSocketFactoryService,yt),yt.register(0,Ot.nodeSocketFactory),Ce.set(Re.ISharedTunnelsService,new M.SyncDescriptor(Me.SharedTunnelsService)),Ce.set(Te.ISharedProcessTunnelService,new M.SyncDescriptor(je.SharedProcessTunnelService)),Ce.set(Ze.IRemoteTunnelService,new M.SyncDescriptor(It.RemoteTunnelService)),new Q.InstantiationService(Ce)}initChannels(Ce){const Ae=this._register(new T.DisposableStore),Ge=new p.ExtensionManagementChannel(Ce.get(a.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ge);const xe=D.ProxyChannel.fromService(Ce.get(X.ILanguagePackService),Ae);this.server.registerChannel("languagePacks",xe);const Ke=D.ProxyChannel.fromService(Ce.get(C.IDiagnosticsService),Ae);this.server.registerChannel("diagnostics",Ke);const Be=new p.ExtensionTipsChannel(Ce.get(a.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Be);const et=D.ProxyChannel.fromService(Ce.get(l.IChecksumService),Ae);this.server.registerChannel("checksum",et);const rt=D.ProxyChannel.fromService(Ce.get(Ie.IV8InspectProfilingService),Ae);this.server.registerChannel("v8InspectProfiling",rt);const lt=new oe.UserDataSyncMachinesServiceChannel(Ce.get(fe.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",lt);const He=D.ProxyChannel.fromService(Ce.get(G.ICustomEndpointTelemetryService),Ae);this.server.registerChannel("customEndpointTelemetry",He);const Ye=new oe.UserDataSyncAccountServiceChannel(Ce.get(ie.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ye);const ut=new oe.UserDataSyncStoreManagementServiceChannel(Ce.get(K.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ut);const ot=new Le.UserDataSyncChannel(Ce.get(K.IUserDataSyncService),Ce.get(_e.IUserDataProfilesService),Ce.get(Y.ILogService));this.server.registerChannel("userDataSync",ot);const Je=this._register(Ce.get(W.IInstantiationService).createInstance(kt.UserDataAutoSyncService)),ht=new oe.UserDataAutoSyncChannel(Je);this.server.registerChannel("userDataAutoSync",ht),this.server.registerChannel("IUserDataSyncResourceProviderService",D.ProxyChannel.fromService(Ce.get(K.IUserDataSyncResourceProviderService),Ae));const Qe=D.ProxyChannel.fromService(Ce.get(Te.ISharedProcessTunnelService),Ae);this.server.registerChannel(Te.ipcSharedProcessTunnelChannelName,Qe);const tt=D.ProxyChannel.fromService(Ce.get(Ze.IRemoteTunnelService),Ae);this.server.registerChannel("remoteTunnel",tt)}registerErrorHandler(Ce){process.on("uncaughtException",Ae=>(0,A.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,A.onUnexpectedError)(Ae)),(0,A.setUnexpectedErrorHandler)(Ae=>{const Ge=(0,U.toErrorMessage)(Ae,!0);Ge&&Ce.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}reportProfilesInfo(Ce,Ae){Ce.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(Ce){if(Ce.data!==nt.SharedProcessRawConnection.response)return!1;const Ae=(0,I.firstOrDefault)(Ce.ports);return Ae?(this.onDidWindowConnectRaw.fire(Ae),!0):!1}}async function mt(st){const Ce=new Nt(st);process.parentPort.postMessage(nt.SharedProcessLifecycle.ipcReady),await Ce.init(),process.parentPort.postMessage(nt.SharedProcessLifecycle.initDone)}e.main=mt,process.parentPort.once("message",st=>{mt(st.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c8a36a69377856369f139f39ee56dd3838130fbf/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
