/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ge){for(var e=[],D=0,N=ge.length;D<N;D++)e[D]=ye[ge[D]];return e};define(ye[157],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class D{static get(){const m=new Map,k=new Map,R=new Map,v=new Map;function p(w,C){w.has(C.detail)||w.set(C.detail,-C.timestamp)}function S(w,C){const l=w.get(C.detail);l&&(l>=0||w.set(C.detail,l+C.timestamp))}let L=[];typeof ge=="function"&&typeof ge.getStats=="function"&&(L=ge.getStats().slice(0).sort((w,C)=>w.timestamp-C.timestamp));for(const w of L)switch(w.type){case 10:p(m,w);break;case 11:case 12:S(m,w);break;case 21:p(k,w);break;case 22:S(k,w);break;case 33:p(R,w);break;case 34:S(R,w);break;case 31:p(v,w);break;case 32:S(v,w);break}let I=0;R.forEach(w=>I+=w);function g(w){const C=[];return w.forEach((l,f)=>C.push([f,l])),C}return{amdLoad:g(m),amdInvoke:g(k),nodeRequire:g(R),nodeEval:g(v),nodeRequireTotal:I}}static toMarkdownTable(m,k){let R="";const v=[];return m.forEach((p,S)=>{v[S]=p.length}),k.forEach(p=>{p.forEach((S,L)=>{typeof S>"u"&&(S=p[L]="-");const I=S.toString().length;v[L]=Math.max(I,v[L])})}),m.forEach((p,S)=>{R+=`| ${p+" ".repeat(v[S]-p.toString().length)} `}),R+=`|
`,m.forEach((p,S)=>{R+=`| ${"-".repeat(v[S])} `}),R+=`|
`,k.forEach(p=>{p.forEach((S,L)=>{typeof S<"u"&&(R+=`| ${S+" ".repeat(v[L]-S.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=D}),define(ye[158],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFindFirst=e.findMaxIdxBy=e.findFirstMinBy=e.findLastMaxBy=e.findFirstMaxBy=e.MonotonousArray=e.findFirstIdxMonotonous=e.findFirstIdxMonotonousOrArrLen=e.findFirstMonotonous=e.findLastIdxMonotonous=e.findLastMonotonous=e.findLastIdx=e.findLast=void 0;function D(l,f,s){const i=N(l,f);if(i!==-1)return l[i]}e.findLast=D;function N(l,f,s=l.length-1){for(let i=s;i>=0;i--){const n=l[i];if(f(n))return i}return-1}e.findLastIdx=N;function m(l,f){const s=k(l,f);return s===-1?void 0:l[s]}e.findLastMonotonous=m;function k(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);f(l[a])?n=a+1:o=a}return n-1}e.findLastIdxMonotonous=k;function R(l,f){const s=v(l,f);return s===l.length?void 0:l[s]}e.findFirstMonotonous=R;function v(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);f(l[a])?o=a:n=a+1}return n}e.findFirstIdxMonotonousOrArrLen=v;function p(l,f,s=0,i=l.length){const n=v(l,f,s,i);return n===l.length?-1:n}e.findFirstIdxMonotonous=p;class S{static{this.assertInvariants=!1}constructor(f){this._array=f,this._findLastMonotonousLastIdx=0}findLastMonotonous(f){if(S.assertInvariants){if(this._prevFindLastPredicate){for(const i of this._array)if(this._prevFindLastPredicate(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=f}const s=k(this._array,f,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=s+1,s===-1?void 0:this._array[s]}}e.MonotonousArray=S;function L(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>0&&(s=n)}return s}e.findFirstMaxBy=L;function I(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>=0&&(s=n)}return s}e.findLastMaxBy=I;function g(l,f){return L(l,(s,i)=>-f(s,i))}e.findFirstMinBy=g;function w(l,f){if(l.length===0)return-1;let s=0;for(let i=1;i<l.length;i++){const n=l[i];f(n,l[s])>0&&(s=i)}return s}e.findMaxIdxBy=w;function C(l,f){for(const s of l){const i=f(s);if(i!==void 0)return i}}e.mapFindFirst=C}),define(ye[73],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.intersection=e.diffMaps=e.diffSets=e.groupBy=void 0;function D(R,v){const p=Object.create(null);for(const S of R){const L=v(S);let I=p[L];I||(I=p[L]=[]),I.push(S)}return p}e.groupBy=D;function N(R,v){const p=[],S=[];for(const L of R)v.has(L)||p.push(L);for(const L of v)R.has(L)||S.push(L);return{removed:p,added:S}}e.diffSets=N;function m(R,v){const p=[],S=[];for(const[L,I]of R)v.has(L)||p.push(I);for(const[L,I]of v)R.has(L)||S.push(I);return{removed:p,added:S}}e.diffMaps=m;function k(R,v){const p=new Set;for(const S of v)R.has(S)&&p.add(S);return p}e.intersection=k}),define(ye[59],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(R){return(v,p,S)=>{let L=null,I=null;if(typeof S.value=="function"?(L="value",I=S.value):typeof S.get=="function"&&(L="get",I=S.get),!I)throw new Error("not supported");S[L]=R(I,p)}}function N(R,v,p){let S=null,L=null;if(typeof p.value=="function"?(S="value",L=p.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(S="get",L=p.get),!L)throw new Error("not supported");const I=`$memoize$${v}`;p[S]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,g)}),this[I]}}e.memoize=N;function m(R,v,p){return D((S,L)=>{const I=`$debounce$${L}`,g=`$debounce$result$${L}`;return function(...w){this[g]||(this[g]=p?p():void 0),clearTimeout(this[I]),v&&(this[g]=v(this[g],...w),w=[this[g]]),this[I]=setTimeout(()=>{S.apply(this,w),this[g]=p?p():void 0},R)}})}e.debounce=m;function k(R,v,p){return D((S,L)=>{const I=`$throttle$timer$${L}`,g=`$throttle$result$${L}`,w=`$throttle$lastRun$${L}`,C=`$throttle$pending$${L}`;return function(...l){if(this[g]||(this[g]=p?p():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),v&&(this[g]=v(this[g],...l)),this[C])return;const f=this[w]+R;f<=Date.now()?(this[w]=Date.now(),S.apply(this,[this[g]]),this[g]=p?p():void 0):(this[C]=!0,this[I]=setTimeout(()=>{this[C]=!1,this[w]=Date.now(),S.apply(this,[this[g]]),this[g]=p?p():void 0},f-Date.now()))}})}e.throttle=k}),define(ye[8],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.ReadonlyError=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function N(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=N;function m(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=m;function k(a){S(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=k;function R(a){S(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=R;function v(a){if(a instanceof Error){const{name:t,message:r}=a,h=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:h,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=v;const p="Canceled";function S(a){return a instanceof L?!0:a instanceof Error&&a.name===p&&a.message===p}e.isCancellationError=S;class L extends Error{constructor(){super(p),this.name=this.message}}e.CancellationError=L;function I(){const a=new Error(p);return a.name=a.message,a}e.canceled=I;function g(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=g;function w(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=w;class C extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=C;function l(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=l;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.BugIndicatingError=o}),define(ye[19],Ce([1,0,8,158]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.reverseOrder=e.booleanComparator=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.forEachWithNeighbors=e.forEachAdjacent=e.groupAdjacentBy=e.groupBy=e.quickSelect=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function m(de,me=0){return de[de.length-(1+me)]}e.tail=m;function k(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.tail2=k;function R(de,me,Z=(ie,q)=>ie===q){if(de===me)return!0;if(!de||!me||de.length!==me.length)return!1;for(let ie=0,q=de.length;ie<q;ie++)if(!Z(de[ie],me[ie]))return!1;return!0}e.equals=R;function v(de,me){const Z=de.length-1;me<Z&&(de[me]=de[Z]),de.pop()}e.removeFastWithoutKeepingOrder=v;function p(de,me,Z){return S(de.length,ie=>Z(de[ie],me))}e.binarySearch=p;function S(de,me){let Z=0,ie=de-1;for(;Z<=ie;){const q=(Z+ie)/2|0,te=me(q);if(te<0)Z=q+1;else if(te>0)ie=q-1;else return q}return-(Z+1)}e.binarySearch2=S;function L(de,me,Z){if(de=de|0,de>=me.length)throw new TypeError("invalid index");const ie=me[Math.floor(me.length*Math.random())],q=[],te=[],fe=[];for(const Ee of me){const Te=Z(Ee,ie);Te<0?q.push(Ee):Te>0?te.push(Ee):fe.push(Ee)}return de<q.length?L(de,q,Z):de<q.length+fe.length?fe[0]:L(de-(q.length+fe.length),te,Z)}e.quickSelect=L;function I(de,me){const Z=[];let ie;for(const q of de.slice(0).sort(me))!ie||me(ie[0],q)!==0?(ie=[q],Z.push(ie)):ie.push(q);return Z}e.groupBy=I;function*g(de,me){let Z,ie;for(const q of de)ie!==void 0&&me(ie,q)?Z.push(q):(Z&&(yield Z),Z=[q]),ie=q;Z&&(yield Z)}e.groupAdjacentBy=g;function w(de,me){for(let Z=0;Z<=de.length;Z++)me(Z===0?void 0:de[Z-1],Z===de.length?void 0:de[Z])}e.forEachAdjacent=w;function C(de,me){for(let Z=0;Z<de.length;Z++)me(Z===0?void 0:de[Z-1],de[Z],Z+1===de.length?void 0:de[Z+1])}e.forEachWithNeighbors=C;function l(de,me,Z){const ie=[];function q(Ee,Te,ve){if(Te===0&&ve.length===0)return;const De=ie[ie.length-1];De&&De.start+De.deleteCount===Ee?(De.deleteCount+=Te,De.toInsert.push(...ve)):ie.push({start:Ee,deleteCount:Te,toInsert:ve})}let te=0,fe=0;for(;;){if(te===de.length){q(te,0,me.slice(fe));break}if(fe===me.length){q(te,de.length-te,[]);break}const Ee=de[te],Te=me[fe],ve=Z(Ee,Te);ve===0?(te+=1,fe+=1):ve<0?(q(te,1,[]),te+=1):ve>0&&(q(te,0,[Te]),fe+=1)}return ie}e.sortedDiff=l;function f(de,me,Z){const ie=l(de,me,Z),q=[],te=[];for(const fe of ie)q.push(...de.slice(fe.start,fe.start+fe.deleteCount)),te.push(...fe.toInsert);return{removed:q,added:te}}e.delta=f;function s(de,me,Z){if(Z===0)return[];const ie=de.slice(0,Z).sort(me);return n(de,me,ie,Z,de.length),ie}e.top=s;function i(de,me,Z,ie,q){return Z===0?Promise.resolve([]):new Promise((te,fe)=>{(async()=>{const Ee=de.length,Te=de.slice(0,Z).sort(me);for(let ve=Z,De=Math.min(Z+ie,Ee);ve<Ee;ve=De,De=Math.min(De+ie,Ee)){if(ve>Z&&await new Promise(B=>setTimeout(B)),q&&q.isCancellationRequested)throw new D.CancellationError;n(de,me,Te,ve,De)}return Te})().then(te,fe)})}e.topAsync=i;function n(de,me,Z,ie,q){for(const te=Z.length;ie<q;ie++){const fe=de[ie];if(me(fe,Z[te-1])<0){Z.pop();const Ee=(0,N.findFirstIdxMonotonousOrArrLen)(Z,Te=>me(fe,Te)<0);Z.splice(Ee,0,fe)}}}function o(de){return de.filter(me=>!!me)}e.coalesce=o;function a(de){let me=0;for(let Z=0;Z<de.length;Z++)de[Z]&&(de[me]=de[Z],me+=1);de.length=me}e.coalesceInPlace=a;function t(de,me,Z){de.splice(Z,0,de.splice(me,1)[0])}e.move=t;function r(de){return!Array.isArray(de)||de.length===0}e.isFalsyOrEmpty=r;function h(de){return Array.isArray(de)&&de.length>0}e.isNonEmptyArray=h;function u(de,me=Z=>Z){const Z=new Set;return de.filter(ie=>{const q=me(ie);return Z.has(q)?!1:(Z.add(q),!0)})}e.distinct=u;function c(de){const me=new Set;return Z=>{const ie=de(Z);return me.has(ie)?!1:(me.add(ie),!0)}}e.uniqueFilter=c;function d(de,me){return de.length>0?de[0]:me}e.firstOrDefault=d;function y(de,me){return de.length>0?de[de.length-1]:me}e.lastOrDefault=y;function A(de,me,Z=(ie,q)=>ie===q){let ie=0;for(let q=0,te=Math.min(de.length,me.length);q<te&&Z(de[q],me[q]);q++)ie++;return ie}e.commonPrefixLength=A;function E(de){return[].concat(...de)}e.flatten=E;function b(de,me){let Z=typeof me=="number"?de:0;typeof me=="number"?Z=de:(Z=0,me=de);const ie=[];if(Z<=me)for(let q=Z;q<me;q++)ie.push(q);else for(let q=Z;q>me;q--)ie.push(q);return ie}e.range=b;function _(de,me,Z){return de.reduce((ie,q)=>(ie[me(q)]=Z?Z(q):q,ie),Object.create(null))}e.index=_;function T(de,me){return de.push(me),()=>U(de,me)}e.insert=T;function U(de,me){const Z=de.indexOf(me);if(Z>-1)return de.splice(Z,1),me}e.remove=U;function M(de,me,Z){const ie=de.slice(0,me),q=de.slice(me);return ie.concat(Z,q)}e.arrayInsert=M;function P(de,me){let Z;if(typeof me=="number"){let ie=me;Z=()=>{const q=Math.sin(ie++)*179426549;return q-Math.floor(q)}}else Z=Math.random;for(let ie=de.length-1;ie>0;ie-=1){const q=Math.floor(Z()*(ie+1)),te=de[ie];de[ie]=de[q],de[q]=te}}e.shuffle=P;function x(de,me){const Z=de.indexOf(me);Z>-1&&(de.splice(Z,1),de.unshift(me))}e.pushToStart=x;function F(de,me){const Z=de.indexOf(me);Z>-1&&(de.splice(Z,1),de.push(me))}e.pushToEnd=F;function O(de,me){for(const Z of me)de.push(Z)}e.pushMany=O;function W(de,me){return Array.isArray(de)?de.map(me):me(de)}e.mapArrayOrNot=W;function J(de){return Array.isArray(de)?de:[de]}e.asArray=J;function ce(de){return de[Math.floor(Math.random()*de.length)]}e.getRandomElement=ce;function G(de,me,Z){const ie=Y(de,me),q=de.length,te=Z.length;de.length=q+te;for(let fe=q-1;fe>=ie;fe--)de[fe+te]=de[fe];for(let fe=0;fe<te;fe++)de[fe+ie]=Z[fe]}e.insertInto=G;function X(de,me,Z,ie){const q=Y(de,me);let te=de.splice(q,Z);return te===void 0&&(te=[]),G(de,q,ie),te}e.splice=X;function Y(de,me){return me<0?Math.max(me+de.length,0):Math.min(me,de.length)}var se;(function(de){function me(te){return te<0}de.isLessThan=me;function Z(te){return te<=0}de.isLessThanOrEqual=Z;function ie(te){return te>0}de.isGreaterThan=ie;function q(te){return te===0}de.isNeitherLessOrGreaterThan=q,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function Q(de,me){return(Z,ie)=>me(de(Z),de(ie))}e.compareBy=Q;function we(...de){return(me,Z)=>{for(const ie of de){const q=ie(me,Z);if(!se.isNeitherLessOrGreaterThan(q))return q}return se.neitherLessOrGreaterThan}}e.tieBreakComparators=we;const he=(de,me)=>de-me;e.numberComparator=he;const j=(de,me)=>(0,e.numberComparator)(de?1:0,me?1:0);e.booleanComparator=j;function z(de){return(me,Z)=>-de(me,Z)}e.reverseOrder=z;class ne{constructor(me){this.items=me,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(me){let Z=this.firstIdx;for(;Z<this.items.length&&me(this.items[Z]);)Z++;const ie=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,ie}takeFromEndWhile(me){let Z=this.lastIdx;for(;Z>=0&&me(this.items[Z]);)Z--;const ie=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,ie}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const me=this.items[this.firstIdx];return this.firstIdx++,me}removeLast(){const me=this.items[this.lastIdx];return this.lastIdx--,me}takeCount(me){const Z=this.items.slice(this.firstIdx,this.firstIdx+me);return this.firstIdx+=me,Z}}e.ArrayQueue=ne;class Se{static{this.empty=new Se(me=>{})}constructor(me){this.iterate=me}forEach(me){this.iterate(Z=>(me(Z),!0))}toArray(){const me=[];return this.iterate(Z=>(me.push(Z),!0)),me}filter(me){return new Se(Z=>this.iterate(ie=>me(ie)?Z(ie):!0))}map(me){return new Se(Z=>this.iterate(ie=>Z(me(ie))))}some(me){let Z=!1;return this.iterate(ie=>(Z=me(ie),!Z)),Z}findFirst(me){let Z;return this.iterate(ie=>me(ie)?(Z=ie,!1):!0),Z}findLast(me){let Z;return this.iterate(ie=>(me(ie)&&(Z=ie),!0)),Z}findLastMaxBy(me){let Z,ie=!0;return this.iterate(q=>((ie||se.isGreaterThan(me(q,Z)))&&(ie=!1,Z=q),!0)),Z}}e.CallbackIterable=Se}),define(ye[60],Ce([1,0,8]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function N(p,S){if(!p)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=N;function m(p,S="Unreachable"){throw new Error(S)}e.assertNever=m;function k(p){if(!p)throw new D.BugIndicatingError("Assertion Failed")}e.assert=k;function R(p){if(!p()){debugger;p(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function v(p,S){let L=0;for(;L<p.length-1;){const I=p[L],g=p[L+1];if(!S(I,g))return!1;L++}return!0}e.checkAdjacentItems=v}),define(ye[74],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=void 0;function D(N,m){const k=this;let R=!1,v;return function(){if(R)return v;if(R=!0,m)try{v=N.apply(k,arguments)}finally{m()}else v=N.apply(k,arguments);return v}}e.createSingleCallFunction=D}),define(ye[121],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class D{constructor(m){this._prefix=m,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=D,e.defaultGenerator=new D("id#")}),define(ye[52],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function m(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}N.is=m;const k=Object.freeze([]);function R(){return k}N.empty=R;function*v(a){yield a}N.single=v;function p(a){return m(a)?a:v(a)}N.wrap=p;function S(a){return a||k}N.from=S;function*L(a){for(let t=a.length-1;t>=0;t--)yield a[t]}N.reverse=L;function I(a){return!a||a[Symbol.iterator]().next().done===!0}N.isEmpty=I;function g(a){return a[Symbol.iterator]().next().value}N.first=g;function w(a,t){for(const r of a)if(t(r))return!0;return!1}N.some=w;function C(a,t){for(const r of a)if(t(r))return r}N.find=C;function*l(a,t){for(const r of a)t(r)&&(yield r)}N.filter=l;function*f(a,t){let r=0;for(const h of a)yield t(h,r++)}N.map=f;function*s(...a){for(const t of a)yield*t}N.concat=s;function i(a,t,r){let h=r;for(const u of a)h=t(h,u);return h}N.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}N.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const h=a[Symbol.iterator]();for(let u=0;u<t;u++){const c=h.next();if(c.done)return[r,N.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return h}}]}N.consume=o})(D||(e.Iterable=D={}))}),define(ye[159],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var m;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(m||(e.ParseErrorCode=m={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function R(t,r=!1){let h=0;const u=t.length;let c="",d=0,y=16,A=0;function E(x){let F=0,O=0;for(;F<x;){const W=t.charCodeAt(h);if(W>=48&&W<=57)O=O*16+W-48;else if(W>=65&&W<=70)O=O*16+W-65+10;else if(W>=97&&W<=102)O=O*16+W-97+10;else break;h++,F++}return F<x&&(O=-1),O}function b(x){h=x,c="",d=0,y=16,A=0}function _(){const x=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&S(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&S(t.charCodeAt(h)))for(h++;h<t.length&&S(t.charCodeAt(h));)h++;else return A=3,t.substring(x,h);let F=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&S(t.charCodeAt(h))){for(h++;h<t.length&&S(t.charCodeAt(h));)h++;F=h}else A=3;return t.substring(x,F)}function T(){let x="",F=h;for(;;){if(h>=u){x+=t.substring(F,h),A=2;break}const O=t.charCodeAt(h);if(O===34){x+=t.substring(F,h),h++;break}if(O===92){if(x+=t.substring(F,h),h++,h>=u){A=2;break}switch(t.charCodeAt(h++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const J=E(4);J>=0?x+=String.fromCharCode(J):A=4;break}default:A=5}F=h;continue}if(O>=0&&O<=31)if(p(O)){x+=t.substring(F,h),A=2;break}else A=6;h++}return x}function U(){if(c="",A=0,d=h,h>=u)return d=u,y=17;let x=t.charCodeAt(h);if(v(x)){do h++,c+=String.fromCharCode(x),x=t.charCodeAt(h);while(v(x));return y=15}if(p(x))return h++,c+=String.fromCharCode(x),x===13&&t.charCodeAt(h)===10&&(h++,c+=`
`),y=14;switch(x){case 123:return h++,y=1;case 125:return h++,y=2;case 91:return h++,y=3;case 93:return h++,y=4;case 58:return h++,y=6;case 44:return h++,y=5;case 34:return h++,c=T(),y=10;case 47:{const F=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<u&&!p(t.charCodeAt(h));)h++;return c=t.substring(F,h),y=12}if(t.charCodeAt(h+1)===42){h+=2;const O=u-1;let W=!1;for(;h<O;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,W=!0;break}h++}return W||(h++,A=1),c=t.substring(F,h),y=13}return c+=String.fromCharCode(x),h++,y=16}case 45:if(c+=String.fromCharCode(x),h++,h===u||!S(t.charCodeAt(h)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=_(),y=11;default:for(;h<u&&M(x);)h++,x=t.charCodeAt(h);if(d!==h){switch(c=t.substring(d,h),c){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return c+=String.fromCharCode(x),h++,y=16}}function M(x){if(v(x)||p(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let x;do x=U();while(x>=12&&x<=15);return x}return{setPosition:b,getPosition:()=>h,scan:r?P:U,getToken:()=>y,getTokenValue:()=>c,getTokenOffset:()=>d,getTokenLength:()=>h-d,getTokenError:()=>A}}e.createScanner=R;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function I(t,r){const h=[],u=new Object;let c;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function A(E,b,_,T){d.value=E,d.offset=b,d.length=_,d.type=T,d.colonOffset=void 0,c=d}try{n(t,{onObjectBegin:(E,b)=>{if(r<=E)throw u;c=void 0,y=r>E,h.push("")},onObjectProperty:(E,b,_)=>{if(r<b||(A(E,b,_,"property"),h[h.length-1]=E,r<=b+_))throw u},onObjectEnd:(E,b)=>{if(r<=E)throw u;c=void 0,h.pop()},onArrayBegin:(E,b)=>{if(r<=E)throw u;c=void 0,h.push(0)},onArrayEnd:(E,b)=>{if(r<=E)throw u;c=void 0,h.pop()},onLiteralValue:(E,b,_)=>{if(r<b||(A(E,b,_,a(E)),r<=b+_))throw u},onSeparator:(E,b,_)=>{if(r<=b)throw u;if(E===":"&&c&&c.type==="property")c.colonOffset=b,y=!1,c=void 0;else if(E===","){const T=h[h.length-1];typeof T=="number"?h[h.length-1]=T+1:(y=!0,h[h.length-1]=""),c=void 0}}})}catch(E){if(E!==u)throw E}return{path:h,previousNode:c,isAtPropertyKey:y,matches:E=>{let b=0;for(let _=0;b<E.length&&_<h.length;_++)if(E[b]===h[_]||E[b]==="*")b++;else if(E[b]!=="**")return!1;return b===E.length}}}e.getLocation=I;function g(t,r=[],h=k.DEFAULT){let u=null,c=[];const d=[];function y(E){Array.isArray(c)?c.push(E):u!==null&&(c[u]=E)}return n(t,{onObjectBegin:()=>{const E={};y(E),d.push(c),c=E,u=null},onObjectProperty:E=>{u=E},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const E=[];y(E),d.push(c),c=E,u=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:y,onError:(E,b,_)=>{r.push({error:E,offset:b,length:_})}},h),c[0]}e.parse=g;function w(t,r=[],h=k.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(E){u.type==="property"&&(u.length=E-u.offset,u=u.parent)}function d(E){return u.children.push(E),E}n(t,{onObjectBegin:E=>{u=d({type:"object",offset:E,length:-1,parent:u,children:[]})},onObjectProperty:(E,b,_)=>{u=d({type:"property",offset:b,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:E,offset:b,length:_,parent:u})},onObjectEnd:(E,b)=>{u.length=E+b-u.offset,u=u.parent,c(E+b)},onArrayBegin:(E,b)=>{u=d({type:"array",offset:E,length:-1,parent:u,children:[]})},onArrayEnd:(E,b)=>{u.length=E+b-u.offset,u=u.parent,c(E+b)},onLiteralValue:(E,b,_)=>{d({type:a(E),offset:b,length:_,parent:u,value:E}),c(b+_)},onSeparator:(E,b,_)=>{u.type==="property"&&(E===":"?u.colonOffset=b:E===","&&c(b))},onError:(E,b,_)=>{r.push({error:E,offset:b,length:_})}},h);const A=u.children[0];return A&&delete A.parent,A}e.parseTree=w;function C(t,r){if(!t)return;let h=t;for(const u of r)if(typeof u=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let c=!1;for(const d of h.children)if(Array.isArray(d.children)&&d.children[0].value===u){h=d.children[1],c=!0;break}if(!c)return}else{const c=u;if(h.type!=="array"||c<0||!Array.isArray(h.children)||c>=h.children.length)return;h=h.children[c]}return h}e.findNodeAtLocation=C;function l(t){if(!t.parent||!t.parent.children)return[];const r=l(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;r.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&r.push(h)}return r}e.getNodePath=l;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const r=Object.create(null);for(const h of t.children){const u=h.children[1];u&&(r[h.children[0].value]=f(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function s(t,r,h=!1){return r>=t.offset&&r<t.offset+t.length||h&&r===t.offset+t.length}e.contains=s;function i(t,r,h=!1){if(s(t,r,h)){const u=t.children;if(Array.isArray(u))for(let c=0;c<u.length&&u[c].offset<=r;c++){const d=i(u[c],r,h);if(d)return d}return t}}e.findNodeAtOffset=i;function n(t,r,h=k.DEFAULT){const u=R(t,!1);function c(Q){return Q?()=>Q(u.getTokenOffset(),u.getTokenLength()):()=>!0}function d(Q){return Q?we=>Q(we,u.getTokenOffset(),u.getTokenLength()):()=>!0}const y=c(r.onObjectBegin),A=d(r.onObjectProperty),E=c(r.onObjectEnd),b=c(r.onArrayBegin),_=c(r.onArrayEnd),T=d(r.onLiteralValue),U=d(r.onSeparator),M=c(r.onComment),P=d(r.onError),x=h&&h.disallowComments,F=h&&h.allowTrailingComma;function O(){for(;;){const Q=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:x||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Q){case 12:case 13:x?W(10):M();break;case 16:W(1);break;case 15:case 14:break;default:return Q}}}function W(Q,we=[],he=[]){if(P(Q),we.length+he.length>0){let j=u.getToken();for(;j!==17;){if(we.indexOf(j)!==-1){O();break}else if(he.indexOf(j)!==-1)break;j=O()}}}function J(Q){const we=u.getTokenValue();return Q?T(we):A(we),O(),!0}function ce(){switch(u.getToken()){case 11:{let Q=0;try{Q=JSON.parse(u.getTokenValue()),typeof Q!="number"&&(W(2),Q=0)}catch{W(2)}T(Q);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return O(),!0}function G(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(J(!1),u.getToken()===6?(U(":"),O(),se()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function X(){y(),O();let Q=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(Q||W(4,[],[]),U(","),O(),u.getToken()===2&&F)break}else Q&&W(6,[],[]);G()||W(4,[],[2,5]),Q=!0}return E(),u.getToken()!==2?W(7,[2],[]):O(),!0}function Y(){b(),O();let Q=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(Q||W(4,[],[]),U(","),O(),u.getToken()===4&&F)break}else Q&&W(6,[],[]);se()||W(4,[],[4,5]),Q=!0}return _(),u.getToken()!==4?W(8,[4],[]):O(),!0}function se(){switch(u.getToken()){case 3:return Y();case 1:return X();case 10:return J(!0);default:return ce()}}return O(),u.getToken()===17?h.allowEmptyContent?!0:(W(4,[],[]),!1):se()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=n;function o(t,r){const h=R(t),u=[];let c,d=0,y;do switch(y=h.getPosition(),c=h.scan(),c){case 12:case 13:case 17:d!==y&&u.push(t.substring(d,y)),r!==void 0&&u.push(h.getTokenValue().replace(/[^\r\n]/g,r)),d=h.getPosition();break}while(c!==17);return u.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(ye[43],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(m){this.executor=m,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(m){this._error=m}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=D}),define(ye[75],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{static{this.Undefined=new D(void 0)}constructor(k){this.element=k,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let k=this._first;for(;k!==D.Undefined;){const R=k.next;k.prev=D.Undefined,k.next=D.Undefined,k=R}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,R){const v=new D(k);if(this._first===D.Undefined)this._first=v,this._last=v;else if(R){const S=this._last;this._last=v,v.prev=S,S.next=v}else{const S=this._first;this._first=v,v.next=S,S.prev=v}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(v))}}shift(){if(this._first!==D.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==D.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==D.Undefined&&k.next!==D.Undefined){const R=k.prev;R.next=k.next,k.next.prev=R}else k.prev===D.Undefined&&k.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):k.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):k.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==D.Undefined;)yield k.element,k=k.next}}e.LinkedList=N}),define(ye[28],Ce([1,0]),function(ge,e){"use strict";var D,N,m;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.getOrSet=k;function R(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=R;function v(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=v;class p{constructor(n,o){this.uri=n,this.value=o}}function S(i){return Array.isArray(i)}class L{static{this.defaultToKey=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof L)this.map=new Map(n.map),this.toKey=o??L.defaultToKey;else if(S(n)){this.map=new Map,this.toKey=o??L.defaultToKey;for(const[a,t]of n)this.set(a,t)}else this.map=new Map,this.toKey=n??L.defaultToKey}set(n,o){return this.map.set(this.toKey(n),new p(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.map)n(t.value,t.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=L;class I{constructor(n,o){this[N]="ResourceSet",!n||typeof n=="function"?this._map=new L(n):(this._map=new L(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var g;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class w{constructor(){this[m]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const a=this._map.get(n);if(a)return o!==0&&this.touch(a,o),a.value}set(n,o,a=0){let t=this._map.get(n);if(t)t.value=o,a!==0&&this.touch(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(n,t),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const a=this._state;let t=this._head;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>n;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const a=n.next,t=n.previous;n===this._tail?(t.next=void 0,this._tail=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const a=n.next,t=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.LinkedMap=w;class C extends w{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=C;class l{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let o=this.map.get(n)||0;return o===0?!1:(o--,o===0?this.map.delete(n):this.map.set(n,o),!0)}has(n){return this.map.has(n)}}e.CounterSet=l;class f{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this._m1.clear(),this._m2.clear()}set(n,o){this._m1.set(n,o),this._m2.set(o,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const o=this._m1.get(n);return o===void 0?!1:(this._m1.delete(n),this._m2.delete(o),!0)}forEach(n,o){this._m1.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=f;class s{constructor(){this.map=new Map}add(n,o){let a=this.map.get(n);a||(a=new Set,this.map.set(n,a)),a.add(o)}delete(n,o){const a=this.map.get(n);a&&(a.delete(o),a.size===0&&this.map.delete(n))}forEach(n,o){const a=this.map.get(n);a&&a.forEach(o)}get(n){const o=this.map.get(n);return o||new Set}}e.SetMap=s}),define(ye[3],Ce([1,0,19,73,28,74,52]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.markAsDisposed=e.trackDisposable=e.setDisposableTracker=e.DisposableTracker=void 0;const v=!1;let p=null;class S{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(T){let U=this.livingDisposables.get(T);return U||(U={parent:null,source:null,isSingleton:!1,value:T,idx:S.idx++},this.livingDisposables.set(T,U)),U}trackDisposable(T){const U=this.getDisposableData(T);U.source||(U.source=new Error().stack)}setParent(T,U){const M=this.getDisposableData(T);M.parent=U}markAsDisposed(T){this.livingDisposables.delete(T)}markAsSingleton(T){this.getDisposableData(T).isSingleton=!0}getRootParent(T,U){const M=U.get(T);if(M)return M;const P=T.parent?this.getRootParent(this.getDisposableData(T.parent),U):T;return U.set(T,P),P}getTrackedDisposables(){const T=new Map;return[...this.livingDisposables.entries()].filter(([,M])=>M.source!==null&&!this.getRootParent(M,T).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(T=10,U){let M;if(U)M=U;else{const W=new Map,J=[...this.livingDisposables.values()].filter(G=>G.source!==null&&!this.getRootParent(G,W).isSingleton);if(J.length===0)return;const ce=new Set(J.map(G=>G.value));if(M=J.filter(G=>!(G.parent&&ce.has(G.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function P(W){function J(G,X){for(;G.length>0&&X.some(Y=>typeof Y=="string"?Y===G[0]:G[0].match(Y));)G.shift()}const ce=W.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return J(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const x=new m.SetMap;for(const W of M){const J=P(W);for(let ce=0;ce<=J.length;ce++)x.add(J.slice(0,ce).join(`
`),W)}M.sort((0,D.compareBy)(W=>W.idx,D.numberComparator));let F="",O=0;for(const W of M.slice(0,T)){O++;const J=P(W),ce=[];for(let G=0;G<J.length;G++){let X=J[G];X=`(shared with ${x.get(J.slice(0,G+1).join(`
`)).size}/${M.length} leaks) at ${X}`;const se=x.get(J.slice(0,G).join(`
`)),Q=(0,N.groupBy)([...se].map(we=>P(we)[G]),we=>we);delete Q[J[G]];for(const[we,he]of Object.entries(Q))ce.unshift(`    - stacktraces of ${he.length} other leaks continue with ${we}`);ce.unshift(X)}F+=`


==================== Leaking disposable ${O}/${M.length}: ${W.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return M.length>T&&(F+=`


... and ${M.length-T} more leaking disposables

`),{leaks:M,details:F}}}e.DisposableTracker=S;function L(_){p=_}if(e.setDisposableTracker=L,v){const _="__is_disposable_tracked__";L(new class{trackDisposable(T){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[_]||console.log(U)},3e3)}setParent(T,U){if(T&&T!==t.None)try{T[_]=!0}catch{}}markAsDisposed(T){if(T&&T!==t.None)try{T[_]=!0}catch{}}markAsSingleton(T){}})}function I(_){return p?.trackDisposable(_),_}e.trackDisposable=I;function g(_){p?.markAsDisposed(_)}e.markAsDisposed=g;function w(_,T){p?.setParent(_,T)}function C(_,T){if(p)for(const U of _)p.setParent(U,T)}function l(_){return p?.markAsSingleton(_),_}e.markAsSingleton=l;function f(_){return typeof _.dispose=="function"&&_.dispose.length===0}e.isDisposable=f;function s(_){if(R.Iterable.is(_)){const T=[];for(const U of _)if(U)try{U.dispose()}catch(M){T.push(M)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(_)?[]:_}else if(_)return _.dispose(),_}e.dispose=s;function i(_){for(const T of _)f(T)&&T.dispose();return[]}e.disposeIfDisposable=i;function n(..._){const T=o(()=>s(_));return C(_,T),T}e.combinedDisposable=n;function o(_){const T=I({dispose:(0,k.createSingleCallFunction)(()=>{g(T),_()})});return T}e.toDisposable=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{s(this._toDispose)}finally{this._toDispose.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return w(T,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(T),T.dispose()}}deleteAndLeak(T){T&&this._toDispose.has(T)&&(this._toDispose.delete(T),w(T,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,I(this),w(this._store,this)}dispose(){g(this),this._store.dispose()}_register(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(T)}}e.Disposable=t;class r{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(T){this._isDisposed||T===this._value||(this._value?.dispose(),T&&w(T,this),this._value=T)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const T=this._value;return this._value=void 0,T&&w(T,null),T}}e.MutableDisposable=r;class h{constructor(T){this._disposable=new r,this._isDisposed=!1,this._disposable.value=T}get value(){return this._disposable.value}set value(T){this._isDisposed||T===this._disposable.value||(this._disposable.value=T)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=h;class u{constructor(T){this._disposable=T,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(T){let U=T;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,g(this))},this}}e.SafeDisposable=c;class d{constructor(){this.references=new Map}acquire(T,...U){let M=this.references.get(T);M||(M={counter:0,object:this.createReferencedObject(T,...U)},this.references.set(T,M));const{object:P}=M,x=(0,k.createSingleCallFunction)(()=>{--M.counter===0&&(this.destroyReferencedObject(T,M.object),this.references.delete(T))});return M.counter++,{object:P,dispose:x}}}e.ReferenceCollection=d;class y{constructor(T){this.referenceCollection=T}async acquire(T,...U){const M=this.referenceCollection.acquire(T,...U);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(P){throw M.dispose(),P}}}e.AsyncReferenceCollection=y;class A{constructor(T){this.object=T}dispose(){}}e.ImmortalReference=A;function E(_){const T=new a;try{_(T)}finally{T.dispose()}}e.disposeOnReturn=E;class b{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{s(this._store.values())}finally{this._store.clear()}}has(T){return this._store.has(T)}get size(){return this._store.size}get(T){return this._store.get(T)}set(T,U,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(T)?.dispose(),this._store.set(T,U)}deleteAndDispose(T){this._store.get(T)?.dispose(),this._store.delete(T)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=b}),function(ge,e){typeof define=="function"&&define.amd?define(ye[160],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(me,Z){for(var ie=0;ie<Z.length;ie++){var q=Z[ie];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(me,q.key,q)}}function D(me,Z,ie){return Z&&e(me.prototype,Z),ie&&e(me,ie),Object.defineProperty(me,"prototype",{writable:!1}),me}function N(me,Z){if(me){if(typeof me=="string")return m(me,Z);var ie=Object.prototype.toString.call(me).slice(8,-1);if(ie==="Object"&&me.constructor&&(ie=me.constructor.name),ie==="Map"||ie==="Set")return Array.from(me);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return m(me,Z)}}function m(me,Z){(Z==null||Z>me.length)&&(Z=me.length);for(var ie=0,q=new Array(Z);ie<Z;ie++)q[ie]=me[ie];return q}function k(me,Z){var ie=typeof Symbol<"u"&&me[Symbol.iterator]||me["@@iterator"];if(ie)return(ie=ie.call(me)).next.bind(ie);if(Array.isArray(me)||(ie=N(me))||Z&&me&&typeof me.length=="number"){ie&&(me=ie);var q=0;return function(){return q>=me.length?{done:!0}:{done:!1,value:me[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function v(me){ge.defaults=me}var p=/[&<>"']/,S=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(Z){return g[Z]};function C(me,Z){if(Z){if(p.test(me))return me.replace(S,w)}else if(L.test(me))return me.replace(I,w);return me}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(me){return me.replace(l,function(Z,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(me,Z){me=typeof me=="string"?me:me.source,Z=Z||"";var ie={replace:function(te,fe){return fe=fe.source||fe,fe=fe.replace(s,"$1"),me=me.replace(te,fe),ie},getRegex:function(){return new RegExp(me,Z)}};return ie}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(me,Z,ie){if(me){var q;try{q=decodeURIComponent(f(ie)).replace(n,"").toLowerCase()}catch{return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}Z&&!o.test(ie)&&(ie=c(Z,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},r=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(me,Z){t[" "+me]||(r.test(me)?t[" "+me]=me+"/":t[" "+me]=E(me,"/",!0)),me=t[" "+me];var ie=me.indexOf(":")===-1;return Z.substring(0,2)==="//"?ie?Z:me.replace(h,"$1")+Z:Z.charAt(0)==="/"?ie?Z:me.replace(u,"$1")+Z:me+Z}var d={exec:function(){}};function y(me){for(var Z=1,ie,q;Z<arguments.length;Z++){ie=arguments[Z];for(q in ie)Object.prototype.hasOwnProperty.call(ie,q)&&(me[q]=ie[q])}return me}function A(me,Z){var ie=me.replace(/\|/g,function(fe,Ee,Te){for(var ve=!1,De=Ee;--De>=0&&Te[De]==="\\";)ve=!ve;return ve?"|":" |"}),q=ie.split(/ \|/),te=0;if(q[0].trim()||q.shift(),q.length>0&&!q[q.length-1].trim()&&q.pop(),q.length>Z)q.splice(Z);else for(;q.length<Z;)q.push("");for(;te<q.length;te++)q[te]=q[te].trim().replace(/\\\|/g,"|");return q}function E(me,Z,ie){var q=me.length;if(q===0)return"";for(var te=0;te<q;){var fe=me.charAt(q-te-1);if(fe===Z&&!ie)te++;else if(fe!==Z&&ie)te++;else break}return me.slice(0,q-te)}function b(me,Z){if(me.indexOf(Z[1])===-1)return-1;for(var ie=me.length,q=0,te=0;te<ie;te++)if(me[te]==="\\")te++;else if(me[te]===Z[0])q++;else if(me[te]===Z[1]&&(q--,q<0))return te;return-1}function _(me){me&&me.sanitize&&!me.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(me,Z){if(Z<1)return"";for(var ie="";Z>1;)Z&1&&(ie+=me),Z>>=1,me+=me;return ie+me}function U(me,Z,ie,q){var te=Z.href,fe=Z.title?C(Z.title):null,Ee=me[1].replace(/\\([\[\]])/g,"$1");if(me[0].charAt(0)!=="!"){q.state.inLink=!0;var Te={type:"link",raw:ie,href:te,title:fe,text:Ee,tokens:q.inlineTokens(Ee)};return q.state.inLink=!1,Te}return{type:"image",raw:ie,href:te,title:fe,text:C(Ee)}}function M(me,Z){var ie=me.match(/^(\s+)(?:```)/);if(ie===null)return Z;var q=ie[1];return Z.split(`
`).map(function(te){var fe=te.match(/^\s+/);if(fe===null)return te;var Ee=fe[0];return Ee.length>=q.length?te.slice(q.length):te}).join(`
`)}var P=function(){function me(ie){this.options=ie||ge.defaults}var Z=me.prototype;return Z.space=function(q){var te=this.rules.block.newline.exec(q);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},Z.code=function(q){var te=this.rules.block.code.exec(q);if(te){var fe=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:E(fe,`
`)}}},Z.fences=function(q){var te=this.rules.block.fences.exec(q);if(te){var fe=te[0],Ee=M(fe,te[3]||"");return{type:"code",raw:fe,lang:te[2]?te[2].trim():te[2],text:Ee}}},Z.heading=function(q){var te=this.rules.block.heading.exec(q);if(te){var fe=te[2].trim();if(/#$/.test(fe)){var Ee=E(fe,"#");(this.options.pedantic||!Ee||/ $/.test(Ee))&&(fe=Ee.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:fe,tokens:this.lexer.inline(fe)}}},Z.hr=function(q){var te=this.rules.block.hr.exec(q);if(te)return{type:"hr",raw:te[0]}},Z.blockquote=function(q){var te=this.rules.block.blockquote.exec(q);if(te){var fe=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},Z.list=function(q){var te=this.rules.block.list.exec(q);if(te){var fe,Ee,Te,ve,De,B,K,ee,H,ae,ue,Ae,xe=te[1].trim(),je=xe.length>1,Ke={type:"list",raw:"",ordered:je,start:je?+xe.slice(0,-1):"",loose:!1,items:[]};xe=je?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=je?xe:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");q&&(Ae=!1,!(!(te=Ze.exec(q))||this.rules.block.hr.test(q)));){if(fe=te[0],q=q.substring(fe.length),ee=te[2].split(`
`,1)[0],H=q.split(`
`,1)[0],this.options.pedantic?(ve=2,ue=ee.trimLeft()):(ve=te[2].search(/[^ ]/),ve=ve>4?1:ve,ue=ee.slice(ve),ve+=te[1].length),B=!1,!ee&&/^ *$/.test(H)&&(fe+=H+`
`,q=q.substring(H.length+1),Ae=!0),!Ae)for(var at=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ke=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),Ue=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");q&&(ae=q.split(`
`,1)[0],ee=ae,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ke.test(ee)||Ue.test(ee)||at.test(ee)||ot.test(q)));){if(ee.search(/[^ ]/)>=ve||!ee.trim())ue+=`
`+ee.slice(ve);else if(!B)ue+=`
`+ee;else break;!B&&!ee.trim()&&(B=!0),fe+=ae+`
`,q=q.substring(ae.length+1)}Ke.loose||(K?Ke.loose=!0:/\n *\n *$/.test(fe)&&(K=!0)),this.options.gfm&&(Ee=/^\[[ xX]\] /.exec(ue),Ee&&(Te=Ee[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:fe,task:!!Ee,checked:Te,loose:!1,text:ue}),Ke.raw+=fe}Ke.items[Ke.items.length-1].raw=fe.trimRight(),Ke.items[Ke.items.length-1].text=ue.trimRight(),Ke.raw=Ke.raw.trimRight();var $e=Ke.items.length;for(De=0;De<$e;De++){this.lexer.state.top=!1,Ke.items[De].tokens=this.lexer.blockTokens(Ke.items[De].text,[]);var Re=Ke.items[De].tokens.filter(function(oe){return oe.type==="space"}),et=Re.every(function(oe){for(var le=oe.raw.split(""),Pe=0,Ve=k(le),Qe;!(Qe=Ve()).done;){var it=Qe.value;if(it===`
`&&(Pe+=1),Pe>1)return!0}return!1});!Ke.loose&&Re.length&&et&&(Ke.loose=!0,Ke.items[De].loose=!0)}return Ke}},Z.html=function(q){var te=this.rules.block.html.exec(q);if(te){var fe={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var Ee=this.options.sanitizer?this.options.sanitizer(te[0]):C(te[0]);fe.type="paragraph",fe.text=Ee,fe.tokens=this.lexer.inline(Ee)}return fe}},Z.def=function(q){var te=this.rules.block.def.exec(q);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var fe=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:te[0],href:te[2],title:te[3]}}},Z.table=function(q){var te=this.rules.block.table.exec(q);if(te){var fe={type:"table",header:A(te[1]).map(function(K){return{text:K}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=te[0];var Ee=fe.align.length,Te,ve,De,B;for(Te=0;Te<Ee;Te++)/^ *-+: *$/.test(fe.align[Te])?fe.align[Te]="right":/^ *:-+: *$/.test(fe.align[Te])?fe.align[Te]="center":/^ *:-+ *$/.test(fe.align[Te])?fe.align[Te]="left":fe.align[Te]=null;for(Ee=fe.rows.length,Te=0;Te<Ee;Te++)fe.rows[Te]=A(fe.rows[Te],fe.header.length).map(function(K){return{text:K}});for(Ee=fe.header.length,ve=0;ve<Ee;ve++)fe.header[ve].tokens=this.lexer.inline(fe.header[ve].text);for(Ee=fe.rows.length,ve=0;ve<Ee;ve++)for(B=fe.rows[ve],De=0;De<B.length;De++)B[De].tokens=this.lexer.inline(B[De].text);return fe}}},Z.lheading=function(q){var te=this.rules.block.lheading.exec(q);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},Z.paragraph=function(q){var te=this.rules.block.paragraph.exec(q);if(te){var fe=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:fe,tokens:this.lexer.inline(fe)}}},Z.text=function(q){var te=this.rules.block.text.exec(q);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},Z.escape=function(q){var te=this.rules.inline.escape.exec(q);if(te)return{type:"escape",raw:te[0],text:C(te[1])}},Z.tag=function(q){var te=this.rules.inline.tag.exec(q);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):C(te[0]):te[0]}},Z.link=function(q){var te=this.rules.inline.link.exec(q);if(te){var fe=te[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var Ee=E(fe.slice(0,-1),"\\");if((fe.length-Ee.length)%2===0)return}else{var Te=b(te[2],"()");if(Te>-1){var ve=te[0].indexOf("!")===0?5:4,De=ve+te[1].length+Te;te[2]=te[2].substring(0,Te),te[0]=te[0].substring(0,De).trim(),te[3]=""}}var B=te[2],K="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);ee&&(B=ee[1],K=ee[3])}else K=te[3]?te[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(fe)?B=B.slice(1):B=B.slice(1,-1)),U(te,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},Z.reflink=function(q,te){var fe;if((fe=this.rules.inline.reflink.exec(q))||(fe=this.rules.inline.nolink.exec(q))){var Ee=(fe[2]||fe[1]).replace(/\s+/g," ");if(Ee=te[Ee.toLowerCase()],!Ee||!Ee.href){var Te=fe[0].charAt(0);return{type:"text",raw:Te,text:Te}}return U(fe,Ee,fe[0],this.lexer)}},Z.emStrong=function(q,te,fe){fe===void 0&&(fe="");var Ee=this.rules.inline.emStrong.lDelim.exec(q);if(Ee&&!(Ee[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=Ee[1]||Ee[2]||"";if(!Te||Te&&(fe===""||this.rules.inline.punctuation.exec(fe))){var ve=Ee[0].length-1,De,B,K=ve,ee=0,H=Ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,te=te.slice(-1*q.length+ve);(Ee=H.exec(te))!=null;)if(De=Ee[1]||Ee[2]||Ee[3]||Ee[4]||Ee[5]||Ee[6],!!De){if(B=De.length,Ee[3]||Ee[4]){K+=B;continue}else if((Ee[5]||Ee[6])&&ve%3&&!((ve+B)%3)){ee+=B;continue}if(K-=B,!(K>0)){if(B=Math.min(B,B+K+ee),Math.min(ve,B)%2){var ae=q.slice(1,ve+Ee.index+B);return{type:"em",raw:q.slice(0,ve+Ee.index+B+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var ue=q.slice(2,ve+Ee.index+B-1);return{type:"strong",raw:q.slice(0,ve+Ee.index+B+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},Z.codespan=function(q){var te=this.rules.inline.code.exec(q);if(te){var fe=te[2].replace(/\n/g," "),Ee=/[^ ]/.test(fe),Te=/^ /.test(fe)&&/ $/.test(fe);return Ee&&Te&&(fe=fe.substring(1,fe.length-1)),fe=C(fe,!0),{type:"codespan",raw:te[0],text:fe}}},Z.br=function(q){var te=this.rules.inline.br.exec(q);if(te)return{type:"br",raw:te[0]}},Z.del=function(q){var te=this.rules.inline.del.exec(q);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},Z.autolink=function(q,te){var fe=this.rules.inline.autolink.exec(q);if(fe){var Ee,Te;return fe[2]==="@"?(Ee=C(this.options.mangle?te(fe[1]):fe[1]),Te="mailto:"+Ee):(Ee=C(fe[1]),Te=Ee),{type:"link",raw:fe[0],text:Ee,href:Te,tokens:[{type:"text",raw:Ee,text:Ee}]}}},Z.url=function(q,te){var fe;if(fe=this.rules.inline.url.exec(q)){var Ee,Te;if(fe[2]==="@")Ee=C(this.options.mangle?te(fe[0]):fe[0]),Te="mailto:"+Ee;else{var ve;do ve=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(ve!==fe[0]);Ee=C(fe[0]),fe[1]==="www."?Te="http://"+Ee:Te=Ee}return{type:"link",raw:fe[0],text:Ee,href:Te,tokens:[{type:"text",raw:Ee,text:Ee}]}}},Z.inlineText=function(q,te){var fe=this.rules.inline.text.exec(q);if(fe){var Ee;return this.lexer.state.inRawBlock?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):C(fe[0]):fe[0]:Ee=C(this.options.smartypants?te(fe[0]):fe[0]),{type:"text",raw:fe[0],text:Ee}}},me}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=i(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=i(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=i(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=i(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=i(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=i(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=y({},x),x.gfm=y({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=i(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=i(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=y({},x.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=i(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=i(x._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=i(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=i(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=i(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=i(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=i(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=i(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=i(F.reflink).replace("label",F._label).replace("ref",x._label).getRegex(),F.nolink=i(F.nolink).replace("ref",x._label).getRegex(),F.reflinkSearch=i(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=y({},F),F.pedantic=y({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=y({},F.normal,{escape:i(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=i(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=y({},F.gfm,{br:i(F.br).replace("{2,}","*").getRegex(),text:i(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(me){return me.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(me){var Z="",ie,q,te=me.length;for(ie=0;ie<te;ie++)q=me.charCodeAt(ie),Math.random()>.5&&(q="x"+q.toString(16)),Z+="&#"+q+";";return Z}var J=function(){function me(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||ge.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var q={block:x.normal,inline:F.normal};this.options.pedantic?(q.block=x.pedantic,q.inline=F.pedantic):this.options.gfm&&(q.block=x.gfm,this.options.breaks?q.inline=F.breaks:q.inline=F.gfm),this.tokenizer.rules=q}me.lex=function(q,te){var fe=new me(te);return fe.lex(q)},me.lexInline=function(q,te){var fe=new me(te);return fe.inlineTokens(q)};var Z=me.prototype;return Z.lex=function(q){q=q.replace(/\r\n|\r/g,`
`),this.blockTokens(q,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},Z.blockTokens=function(q,te){var fe=this;te===void 0&&(te=[]),this.options.pedantic?q=q.replace(/\t/g,"    ").replace(/^ +$/gm,""):q=q.replace(/^( *)(\t+)/gm,function(K,ee,H){return ee+"    ".repeat(H.length)});for(var Ee,Te,ve,De;q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(Ee=K.call({lexer:fe},q,te))?(q=q.substring(Ee.raw.length),te.push(Ee),!0):!1}))){if(Ee=this.tokenizer.space(q)){q=q.substring(Ee.raw.length),Ee.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(Ee);continue}if(Ee=this.tokenizer.code(q)){q=q.substring(Ee.raw.length),Te=te[te.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+Ee.raw,Te.text+=`
`+Ee.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):te.push(Ee);continue}if(Ee=this.tokenizer.fences(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.heading(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.hr(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.blockquote(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.list(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.html(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.def(q)){q=q.substring(Ee.raw.length),Te=te[te.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+Ee.raw,Te.text+=`
`+Ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[Ee.tag]||(this.tokens.links[Ee.tag]={href:Ee.href,title:Ee.title});continue}if(Ee=this.tokenizer.table(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.lheading(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(ve=q,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,ee=q.slice(1),H=void 0;fe.options.extensions.startBlock.forEach(function(ae){H=ae.call({lexer:this},ee),typeof H=="number"&&H>=0&&(K=Math.min(K,H))}),K<1/0&&K>=0&&(ve=q.substring(0,K+1))}(),this.state.top&&(Ee=this.tokenizer.paragraph(ve))){Te=te[te.length-1],De&&Te.type==="paragraph"?(Te.raw+=`
`+Ee.raw,Te.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):te.push(Ee),De=ve.length!==q.length,q=q.substring(Ee.raw.length);continue}if(Ee=this.tokenizer.text(q)){q=q.substring(Ee.raw.length),Te=te[te.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+Ee.raw,Te.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):te.push(Ee);continue}if(q){var B="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,te},Z.inline=function(q,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:q,tokens:te}),te},Z.inlineTokens=function(q,te){var fe=this;te===void 0&&(te=[]);var Ee,Te,ve,De=q,B,K,ee;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)H.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,B.index)+"["+T("a",B[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,B.index)+"["+T("a",B[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,B.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;)if(K||(ee=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(Ee=ue.call({lexer:fe},q,te))?(q=q.substring(Ee.raw.length),te.push(Ee),!0):!1}))){if(Ee=this.tokenizer.escape(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.tag(q)){q=q.substring(Ee.raw.length),Te=te[te.length-1],Te&&Ee.type==="text"&&Te.type==="text"?(Te.raw+=Ee.raw,Te.text+=Ee.text):te.push(Ee);continue}if(Ee=this.tokenizer.link(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(Ee.raw.length),Te=te[te.length-1],Te&&Ee.type==="text"&&Te.type==="text"?(Te.raw+=Ee.raw,Te.text+=Ee.text):te.push(Ee);continue}if(Ee=this.tokenizer.emStrong(q,De,ee)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.codespan(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.br(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.del(q)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(Ee=this.tokenizer.autolink(q,W)){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(!this.state.inLink&&(Ee=this.tokenizer.url(q,W))){q=q.substring(Ee.raw.length),te.push(Ee);continue}if(ve=q,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Ae=q.slice(1),xe=void 0;fe.options.extensions.startInline.forEach(function(je){xe=je.call({lexer:this},Ae),typeof xe=="number"&&xe>=0&&(ue=Math.min(ue,xe))}),ue<1/0&&ue>=0&&(ve=q.substring(0,ue+1))}(),Ee=this.tokenizer.inlineText(ve,O)){q=q.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(ee=Ee.raw.slice(-1)),K=!0,Te=te[te.length-1],Te&&Te.type==="text"?(Te.raw+=Ee.raw,Te.text+=Ee.text):te.push(Ee);continue}if(q){var ae="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return te},D(me,null,[{key:"rules",get:function(){return{block:x,inline:F}}}]),me}(),ce=function(){function me(ie){this.options=ie||ge.defaults}var Z=me.prototype;return Z.code=function(q,te,fe){var Ee=(te||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(q,Ee);Te!=null&&Te!==q&&(fe=!0,q=Te)}return q=q.replace(/\n$/,"")+`
`,Ee?'<pre><code class="'+this.options.langPrefix+C(Ee,!0)+'">'+(fe?q:C(q,!0))+`</code></pre>
`:"<pre><code>"+(fe?q:C(q,!0))+`</code></pre>
`},Z.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},Z.html=function(q){return q},Z.heading=function(q,te,fe,Ee){if(this.options.headerIds){var Te=this.options.headerPrefix+Ee.slug(fe);return"<h"+te+' id="'+Te+'">'+q+"</h"+te+`>
`}return"<h"+te+">"+q+"</h"+te+`>
`},Z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Z.list=function(q,te,fe){var Ee=te?"ol":"ul",Te=te&&fe!==1?' start="'+fe+'"':"";return"<"+Ee+Te+`>
`+q+"</"+Ee+`>
`},Z.listitem=function(q){return"<li>"+q+`</li>
`},Z.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Z.paragraph=function(q){return"<p>"+q+`</p>
`},Z.table=function(q,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+te+`</table>
`},Z.tablerow=function(q){return`<tr>
`+q+`</tr>
`},Z.tablecell=function(q,te){var fe=te.header?"th":"td",Ee=te.align?"<"+fe+' align="'+te.align+'">':"<"+fe+">";return Ee+q+("</"+fe+`>
`)},Z.strong=function(q){return"<strong>"+q+"</strong>"},Z.em=function(q){return"<em>"+q+"</em>"},Z.codespan=function(q){return"<code>"+q+"</code>"},Z.br=function(){return this.options.xhtml?"<br/>":"<br>"},Z.del=function(q){return"<del>"+q+"</del>"},Z.link=function(q,te,fe){if(q=a(this.options.sanitize,this.options.baseUrl,q),q===null)return fe;var Ee='<a href="'+C(q)+'"';return te&&(Ee+=' title="'+te+'"'),Ee+=">"+fe+"</a>",Ee},Z.image=function(q,te,fe){if(q=a(this.options.sanitize,this.options.baseUrl,q),q===null)return fe;var Ee='<img src="'+q+'" alt="'+fe+'"';return te&&(Ee+=' title="'+te+'"'),Ee+=this.options.xhtml?"/>":">",Ee},Z.text=function(q){return q},me}(),G=function(){function me(){}var Z=me.prototype;return Z.strong=function(q){return q},Z.em=function(q){return q},Z.codespan=function(q){return q},Z.del=function(q){return q},Z.html=function(q){return q},Z.text=function(q){return q},Z.link=function(q,te,fe){return""+fe},Z.image=function(q,te,fe){return""+fe},Z.br=function(){return""},me}(),X=function(){function me(){this.seen={}}var Z=me.prototype;return Z.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Z.getNextSafeSlug=function(q,te){var fe=q,Ee=0;if(this.seen.hasOwnProperty(fe)){Ee=this.seen[q];do Ee++,fe=q+"-"+Ee;while(this.seen.hasOwnProperty(fe))}return te||(this.seen[q]=Ee,this.seen[fe]=0),fe},Z.slug=function(q,te){te===void 0&&(te={});var fe=this.serialize(q);return this.getNextSafeSlug(fe,te.dryrun)},me}(),Y=function(){function me(ie){this.options=ie||ge.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new X}me.parse=function(q,te){var fe=new me(te);return fe.parse(q)},me.parseInline=function(q,te){var fe=new me(te);return fe.parseInline(q)};var Z=me.prototype;return Z.parse=function(q,te){te===void 0&&(te=!0);var fe="",Ee,Te,ve,De,B,K,ee,H,ae,ue,Ae,xe,je,Ke,Ze,at,ot,ke,Ue,$e=q.length;for(Ee=0;Ee<$e;Ee++){if(ue=q[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(Ue=this.options.extensions.renderers[ue.type].call({parser:this},ue),Ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){fe+=Ue||"";continue}switch(ue.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,f(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(H="",ee="",De=ue.header.length,Te=0;Te<De;Te++)ee+=this.renderer.tablecell(this.parseInline(ue.header[Te].tokens),{header:!0,align:ue.align[Te]});for(H+=this.renderer.tablerow(ee),ae="",De=ue.rows.length,Te=0;Te<De;Te++){for(K=ue.rows[Te],ee="",B=K.length,ve=0;ve<B;ve++)ee+=this.renderer.tablecell(this.parseInline(K[ve].tokens),{header:!1,align:ue.align[ve]});ae+=this.renderer.tablerow(ee)}fe+=this.renderer.table(H,ae);continue}case"blockquote":{ae=this.parse(ue.tokens),fe+=this.renderer.blockquote(ae);continue}case"list":{for(Ae=ue.ordered,xe=ue.start,je=ue.loose,De=ue.items.length,ae="",Te=0;Te<De;Te++)Ze=ue.items[Te],at=Ze.checked,ot=Ze.task,Ke="",Ze.task&&(ke=this.renderer.checkbox(at),je?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=ke+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=ke+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:ke}):Ke+=ke),Ke+=this.parse(Ze.tokens,je),ae+=this.renderer.listitem(Ke,ot,at);fe+=this.renderer.list(ae,Ae,xe);continue}case"html":{fe+=this.renderer.html(ue.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(ae=ue.tokens?this.parseInline(ue.tokens):ue.text;Ee+1<$e&&q[Ee+1].type==="text";)ue=q[++Ee],ae+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);fe+=te?this.renderer.paragraph(ae):ae;continue}default:{var Re='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return fe},Z.parseInline=function(q,te){te=te||this.renderer;var fe="",Ee,Te,ve,De=q.length;for(Ee=0;Ee<De;Ee++){if(Te=q[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(ve=this.options.extensions.renderers[Te.type].call({parser:this},Te),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){fe+=ve||"";continue}switch(Te.type){case"escape":{fe+=te.text(Te.text);break}case"html":{fe+=te.html(Te.text);break}case"link":{fe+=te.link(Te.href,Te.title,this.parseInline(Te.tokens,te));break}case"image":{fe+=te.image(Te.href,Te.title,Te.text);break}case"strong":{fe+=te.strong(this.parseInline(Te.tokens,te));break}case"em":{fe+=te.em(this.parseInline(Te.tokens,te));break}case"codespan":{fe+=te.codespan(Te.text);break}case"br":{fe+=te.br();break}case"del":{fe+=te.del(this.parseInline(Te.tokens,te));break}case"text":{fe+=te.text(Te.text);break}default:{var B='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return fe},me}();function se(me,Z,ie){if(typeof me>"u"||me===null)throw new Error("marked(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");if(typeof Z=="function"&&(ie=Z,Z=null),Z=y({},se.defaults,Z||{}),_(Z),ie){var q=Z.highlight,te;try{te=J.lex(me,Z)}catch(De){return ie(De)}var fe=function(B){var K;if(!B)try{Z.walkTokens&&se.walkTokens(te,Z.walkTokens),K=Y.parse(te,Z)}catch(ee){B=ee}return Z.highlight=q,B?ie(B):ie(null,K)};if(!q||q.length<3||(delete Z.highlight,!te.length))return fe();var Ee=0;se.walkTokens(te,function(De){De.type==="code"&&(Ee++,setTimeout(function(){q(De.text,De.lang,function(B,K){if(B)return fe(B);K!=null&&K!==De.text&&(De.text=K,De.escaped=!0),Ee--,Ee===0&&fe()})},0))}),Ee===0&&fe();return}function Te(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+C(De.message+"",!0)+"</pre>";throw De}try{var ve=J.lex(me,Z);if(Z.walkTokens){if(Z.async)return Promise.all(se.walkTokens(ve,Z.walkTokens)).then(function(){return Y.parse(ve,Z)}).catch(Te);se.walkTokens(ve,Z.walkTokens)}return Y.parse(ve,Z)}catch(De){Te(De)}}se.options=se.setOptions=function(me){return y(se.defaults,me),v(se.defaults),se},se.getDefaults=R,se.defaults=ge.defaults,se.use=function(){for(var me=arguments.length,Z=new Array(me),ie=0;ie<me;ie++)Z[ie]=arguments[ie];var q=y.apply(void 0,[{}].concat(Z)),te=se.defaults.extensions||{renderers:{},childTokens:{}},fe;Z.forEach(function(Ee){if(Ee.extensions&&(fe=!0,Ee.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var De=te.renderers?te.renderers[ve.name]:null;De?te.renderers[ve.name]=function(){for(var B=arguments.length,K=new Array(B),ee=0;ee<B;ee++)K[ee]=arguments[ee];var H=ve.renderer.apply(this,K);return H===!1&&(H=De.apply(this,K)),H}:te.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[ve.level]?te[ve.level].unshift(ve.tokenizer):te[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?te.startBlock?te.startBlock.push(ve.start):te.startBlock=[ve.start]:ve.level==="inline"&&(te.startInline?te.startInline.push(ve.start):te.startInline=[ve.start]))}ve.childTokens&&(te.childTokens[ve.name]=ve.childTokens)})),Ee.renderer&&function(){var ve=se.defaults.renderer||new ce,De=function(ee){var H=ve[ee];ve[ee]=function(){for(var ae=arguments.length,ue=new Array(ae),Ae=0;Ae<ae;Ae++)ue[Ae]=arguments[Ae];var xe=Ee.renderer[ee].apply(ve,ue);return xe===!1&&(xe=H.apply(ve,ue)),xe}};for(var B in Ee.renderer)De(B);q.renderer=ve}(),Ee.tokenizer&&function(){var ve=se.defaults.tokenizer||new P,De=function(ee){var H=ve[ee];ve[ee]=function(){for(var ae=arguments.length,ue=new Array(ae),Ae=0;Ae<ae;Ae++)ue[Ae]=arguments[Ae];var xe=Ee.tokenizer[ee].apply(ve,ue);return xe===!1&&(xe=H.apply(ve,ue)),xe}};for(var B in Ee.tokenizer)De(B);q.tokenizer=ve}(),Ee.walkTokens){var Te=se.defaults.walkTokens;q.walkTokens=function(ve){var De=[];return De.push(Ee.walkTokens.call(this,ve)),Te&&(De=De.concat(Te.call(this,ve))),De}}fe&&(q.extensions=te),se.setOptions(q)})},se.walkTokens=function(me,Z){for(var ie=[],q=function(){var Te=fe.value;switch(ie=ie.concat(Z.call(se,Te)),Te.type){case"table":{for(var ve=k(Te.header),De;!(De=ve()).done;){var B=De.value;ie=ie.concat(se.walkTokens(B.tokens,Z))}for(var K=k(Te.rows),ee;!(ee=K()).done;)for(var H=ee.value,ae=k(H),ue;!(ue=ae()).done;){var Ae=ue.value;ie=ie.concat(se.walkTokens(Ae.tokens,Z))}break}case"list":{ie=ie.concat(se.walkTokens(Te.items,Z));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[Te.type]?se.defaults.extensions.childTokens[Te.type].forEach(function(xe){ie=ie.concat(se.walkTokens(Te[xe],Z))}):Te.tokens&&(ie=ie.concat(se.walkTokens(Te.tokens,Z)))}},te=k(me),fe;!(fe=te()).done;)q();return ie},se.parseInline=function(me,Z){if(typeof me>"u"||me===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");Z=y({},se.defaults,Z||{}),_(Z);try{var ie=J.lexInline(me,Z);return Z.walkTokens&&se.walkTokens(ie,Z.walkTokens),Y.parseInline(ie,Z)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Z.silent)return"<p>An error occurred:</p><pre>"+C(q.message+"",!0)+"</pre>";throw q}},se.Parser=Y,se.parser=Y.parse,se.Renderer=ce,se.TextRenderer=G,se.Lexer=J,se.lexer=J.lex,se.Tokenizer=P,se.Slugger=X,se.parse=se;var Q=se.options,we=se.setOptions,he=se.use,j=se.walkTokens,z=se.parseInline,ne=se,Se=Y.parse,de=J.lex;ge.Lexer=J,ge.Parser=Y,ge.Renderer=ce,ge.Slugger=X,ge.TextRenderer=G,ge.Tokenizer=P,ge.getDefaults=R,ge.lexer=de,ge.marked=se,ge.options=Q,ge.parse=ne,ge.parseInline=z,ge.parser=Se,ge.setOptions=we,ge.use=he,ge.walkTokens=j,Object.defineProperty(ge,"__esModule",{value:!0})}),define(ye[161],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=void 0;function D(l){const f=k(l);if(f&&f.length>0)return new Uint32Array(f)}e.getKoreanAltChars=D;let N=0;const m=new Uint32Array(10);function k(l){if(N=0,R(l,I,4352),N>0||(R(l,g,4449),N>0)||(R(l,w,4520),N>0)||(R(l,C,12593),N))return m.subarray(0,N);if(l>=44032&&l<=55203){const f=l-44032,s=f%588,i=Math.floor(f/588),n=Math.floor(s/28),o=s%28-1;if(i<I.length?R(i,I,0):4352+i-12593<C.length&&R(4352+i,C,12593),n<g.length?R(n,g,0):4449+n-12593<C.length&&R(4449+n-12593,C,12593),o>=0&&(o<w.length?R(o,w,0):4520+o-12593<C.length&&R(4520+o-12593,C,12593)),N>0)return m.subarray(0,N)}}function R(l,f,s){l>=s&&l<s+f.length&&v(f[l-s])}function v(l){l!==0&&(m[N++]=l&255,l>>8&&(m[N++]=l>>8&255),l>>16&&(m[N++]=l>>16&255))}var p;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var S;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(S||(S={}));var L;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(L||(L={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),g=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),C=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ye[76],Ce([1,0,28]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const N=new D.LRUCache(1e4);function m(S){return p(S,"NFC",N)}e.normalizeNFC=m;const k=new D.LRUCache(1e4);function R(S){return p(S,"NFD",k)}e.normalizeNFD=R;const v=/[^\u0000-\u0080]/;function p(S,L,I){if(!S)return S;const g=I.get(S);if(g)return g;let w;return v.test(S)?w=S.normalize(L):w=S,I.set(S,w),w}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(L){return R(L).replace(S,"")}}()}),define(ye[122],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function D(v,p,S){return Math.min(Math.max(v,p),S)}e.clamp=D;function N(v,p){return(p+v%p)%p}e.rot=N;class m{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=m;class k{constructor(){this._n=1,this._val=0}update(p){return this._val=this._val+(p-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=k;class R{constructor(p){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(p),this._values.fill(0,0,p)}update(p){const S=this._values[this._index];return this._values[this._index]=p,this._index=(this._index+1)%this._values.length,this._sum-=S,this._sum+=p,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function ge(m){const k=[];typeof m=="number"&&k.push("code/timeOrigin",m);function R(p){k.push(p,Date.now())}function v(){const p=[];for(let S=0;S<k.length;S+=2)p.push({name:k[S],startTime:k[S+1]});return p}return{mark:R,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(m){performance.mark(m)},getMarks(){let m=performance.timeOrigin;typeof m!="number"&&(m=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(m)}];for(const R of performance.getEntriesByType("mark"))k.push({name:R.name,startTime:Math.round(m+R.startTime)});return k}};if(typeof process=="object"){const m=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(m)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function D(m){return m.MonacoPerformanceMarks||(m.MonacoPerformanceMarks=e()),m.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:ge)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function D(N){if(e[N])return e[N].exports;var m=e[N]={i:N,l:!1,exports:{}};return ge[N].call(m.exports,m,m.exports,D),m.l=!0,m.exports}return D.m=ge,D.c=e,D.d=function(N,m,k){D.o(N,m)||Object.defineProperty(N,m,{enumerable:!0,get:k})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,m){if(1&m&&(N=D(N)),8&m||4&m&&typeof N=="object"&&N&&N.__esModule)return N;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:N}),2&m&&typeof N!="string")for(var R in N)D.d(k,R,function(v){return N[v]}.bind(null,R));return k},D.n=function(N){var m=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(m,"a",m),m},D.o=function(N,m){return Object.prototype.hasOwnProperty.call(N,m)},D.p="",D(D.s=0)}([function(ge,e,D){(function(N){var m;e=ge.exports=he,m=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],p=e.src=[],S=0,L=S++;p[L]="0|[1-9]\\d*";var I=S++;p[I]="[0-9]+";var g=S++;p[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=S++;p[w]="("+p[L]+")\\.("+p[L]+")\\.("+p[L]+")";var C=S++;p[C]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var l=S++;p[l]="(?:"+p[L]+"|"+p[g]+")";var f=S++;p[f]="(?:"+p[I]+"|"+p[g]+")";var s=S++;p[s]="(?:-("+p[l]+"(?:\\."+p[l]+")*))";var i=S++;p[i]="(?:-?("+p[f]+"(?:\\."+p[f]+")*))";var n=S++;p[n]="[0-9A-Za-z-]+";var o=S++;p[o]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var a=S++,t="v?"+p[w]+p[s]+"?"+p[o]+"?";p[a]="^"+t+"$";var r="[v=\\s]*"+p[C]+p[i]+"?"+p[o]+"?",h=S++;p[h]="^"+r+"$";var u=S++;p[u]="((?:<|>)?=?)";var c=S++;p[c]=p[I]+"|x|X|\\*";var d=S++;p[d]=p[L]+"|x|X|\\*";var y=S++;p[y]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[s]+")?"+p[o]+"?)?)?";var A=S++;p[A]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[i]+")?"+p[o]+"?)?)?";var E=S++;p[E]="^"+p[u]+"\\s*"+p[y]+"$";var b=S++;p[b]="^"+p[u]+"\\s*"+p[A]+"$";var _=S++;p[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=S++;p[T]="(?:~>?)";var U=S++;p[U]="(\\s*)"+p[T]+"\\s+",v[U]=new RegExp(p[U],"g");var M=S++;p[M]="^"+p[T]+p[y]+"$";var P=S++;p[P]="^"+p[T]+p[A]+"$";var x=S++;p[x]="(?:\\^)";var F=S++;p[F]="(\\s*)"+p[x]+"\\s+",v[F]=new RegExp(p[F],"g");var O=S++;p[O]="^"+p[x]+p[y]+"$";var W=S++;p[W]="^"+p[x]+p[A]+"$";var J=S++;p[J]="^"+p[u]+"\\s*("+r+")$|^$";var ce=S++;p[ce]="^"+p[u]+"\\s*("+t+")$|^$";var G=S++;p[G]="(\\s*)"+p[u]+"\\s*("+r+"|"+p[y]+")",v[G]=new RegExp(p[G],"g");var X=S++;p[X]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var Y=S++;p[Y]="^\\s*("+p[A]+")\\s+-\\s+("+p[A]+")\\s*$";var se=S++;p[se]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)m(Q,p[Q]),v[Q]||(v[Q]=new RegExp(p[Q]));function we(H,ae){if(H instanceof he)return H;if(typeof H!="string"||H.length>k||!(ae?v[h]:v[a]).test(H))return null;try{return new he(H,ae)}catch{return null}}function he(H,ae){if(H instanceof he){if(H.loose===ae)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof he))return new he(H,ae);m("SemVer",H,ae),this.loose=ae;var ue=H.trim().match(ae?v[h]:v[a]);if(!ue)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ae){if(/^[0-9]+$/.test(Ae)){var xe=+Ae;if(xe>=0&&xe<R)return xe}return Ae}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=we,e.valid=function(H,ae){var ue=we(H,ae);return ue?ue.version:null},e.clean=function(H,ae){var ue=we(H.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(H){return m("SemVer.compare",this.version,this.loose,H),H instanceof he||(H=new he(H,this.loose)),this.compareMain(H)||this.comparePre(H)},he.prototype.compareMain=function(H){return H instanceof he||(H=new he(H,this.loose)),z(this.major,H.major)||z(this.minor,H.minor)||z(this.patch,H.patch)},he.prototype.comparePre=function(H){if(H instanceof he||(H=new he(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],Ae=H.prerelease[ae];if(m("prerelease compare",ae,ue,Ae),ue===void 0&&Ae===void 0)return 0;if(Ae===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ae)return z(ue,Ae)}while(++ae)},he.prototype.inc=function(H,ae){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,ae,ue,Ae){typeof ue=="string"&&(Ae=ue,ue=void 0);try{return new he(H,ue).inc(ae,Ae).version}catch{return null}},e.diff=function(H,ae){if(me(H,ae))return null;var ue=we(H),Ae=we(ae);if(ue.prerelease.length||Ae.prerelease.length){for(var xe in ue)if((xe==="major"||xe==="minor"||xe==="patch")&&ue[xe]!==Ae[xe])return"pre"+xe;return"prerelease"}for(var xe in ue)if((xe==="major"||xe==="minor"||xe==="patch")&&ue[xe]!==Ae[xe])return xe},e.compareIdentifiers=z;var j=/^[0-9]+$/;function z(H,ae){var ue=j.test(H),Ae=j.test(ae);return ue&&Ae&&(H=+H,ae=+ae),ue&&!Ae?-1:Ae&&!ue?1:H<ae?-1:H>ae?1:0}function ne(H,ae,ue){return new he(H,ue).compare(new he(ae,ue))}function Se(H,ae,ue){return ne(H,ae,ue)>0}function de(H,ae,ue){return ne(H,ae,ue)<0}function me(H,ae,ue){return ne(H,ae,ue)===0}function Z(H,ae,ue){return ne(H,ae,ue)!==0}function ie(H,ae,ue){return ne(H,ae,ue)>=0}function q(H,ae,ue){return ne(H,ae,ue)<=0}function te(H,ae,ue,Ae){var xe;switch(ae){case"===":typeof H=="object"&&(H=H.version),typeof ue=="object"&&(ue=ue.version),xe=H===ue;break;case"!==":typeof H=="object"&&(H=H.version),typeof ue=="object"&&(ue=ue.version),xe=H!==ue;break;case"":case"=":case"==":xe=me(H,ue,Ae);break;case"!=":xe=Z(H,ue,Ae);break;case">":xe=Se(H,ue,Ae);break;case">=":xe=ie(H,ue,Ae);break;case"<":xe=de(H,ue,Ae);break;case"<=":xe=q(H,ue,Ae);break;default:throw new TypeError("Invalid operator: "+ae)}return xe}function fe(H,ae){if(H instanceof fe){if(H.loose===ae)return H;H=H.value}if(!(this instanceof fe))return new fe(H,ae);m("comparator",H,ae),this.loose=ae,this.parse(H),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,m("comp",this)}e.rcompareIdentifiers=function(H,ae){return z(ae,H)},e.major=function(H,ae){return new he(H,ae).major},e.minor=function(H,ae){return new he(H,ae).minor},e.patch=function(H,ae){return new he(H,ae).patch},e.compare=ne,e.compareLoose=function(H,ae){return ne(H,ae,!0)},e.rcompare=function(H,ae,ue){return ne(ae,H,ue)},e.sort=function(H,ae){return H.sort(function(ue,Ae){return e.compare(ue,Ae,ae)})},e.rsort=function(H,ae){return H.sort(function(ue,Ae){return e.rcompare(ue,Ae,ae)})},e.gt=Se,e.lt=de,e.eq=me,e.neq=Z,e.gte=ie,e.lte=q,e.cmp=te,e.Comparator=fe;var Ee={};function Te(H,ae){if(H instanceof Te)return H.loose===ae?H:new Te(H.raw,ae);if(H instanceof fe)return new Te(H.value,ae);if(!(this instanceof Te))return new Te(H,ae);if(this.loose=ae,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function ve(H){return!H||H.toLowerCase()==="x"||H==="*"}function De(H,ae,ue,Ae,xe,je,Ke,Ze,at,ot,ke,Ue,$e){return((ae=ve(ue)?"":ve(Ae)?">="+ue+".0.0":ve(xe)?">="+ue+"."+Ae+".0":">="+ae)+" "+(Ze=ve(at)?"":ve(ot)?"<"+(+at+1)+".0.0":ve(ke)?"<"+at+"."+(+ot+1)+".0":Ue?"<="+at+"."+ot+"."+ke+"-"+Ue:"<="+Ze)).trim()}function B(H,ae){for(var ue=0;ue<H.length;ue++)if(!H[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<H.length;ue++)if(m(H[ue].semver),H[ue].semver!==Ee&&H[ue].semver.prerelease.length>0){var Ae=H[ue].semver;if(Ae.major===ae.major&&Ae.minor===ae.minor&&Ae.patch===ae.patch)return!0}return!1}return!0}function K(H,ae,ue){try{ae=new Te(ae,ue)}catch{return!1}return ae.test(H)}function ee(H,ae,ue,Ae){var xe,je,Ke,Ze,at;switch(H=new he(H,Ae),ae=new Te(ae,Ae),ue){case">":xe=Se,je=q,Ke=de,Ze=">",at=">=";break;case"<":xe=de,je=ie,Ke=Se,Ze="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(H,ae,Ae))return!1;for(var ot=0;ot<ae.set.length;++ot){var ke=ae.set[ot],Ue=null,$e=null;if(ke.forEach(function(Re){Re.semver===Ee&&(Re=new fe(">=0.0.0")),Ue=Ue||Re,$e=$e||Re,xe(Re.semver,Ue.semver,Ae)?Ue=Re:Ke(Re.semver,$e.semver,Ae)&&($e=Re)}),Ue.operator===Ze||Ue.operator===at||(!$e.operator||$e.operator===Ze)&&je(H,$e.semver)||$e.operator===at&&Ke(H,$e.semver))return!1}return!0}fe.prototype.parse=function(H){var ae=this.loose?v[J]:v[ce],ue=H.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+H);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new he(ue[2],this.loose):this.semver=Ee},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(H){return m("Comparator.test",H,this.loose),this.semver===Ee||(typeof H=="string"&&(H=new he(H,this.loose)),te(H,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(H,ae){if(!(H instanceof fe))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Te(H.value,ae),K(this.value,ue,ae);if(H.operator==="")return ue=new Te(this.value,ae),K(H.semver,ue,ae);var Ae=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),je=this.semver.version===H.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ze=te(this.semver,"<",H.semver,ae)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),at=te(this.semver,">",H.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Ae||xe||je&&Ke||Ze||at},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(H){var ae=this.loose;H=H.trim(),m("range",H,ae);var ue=ae?v[Y]:v[X];H=H.replace(ue,De),m("hyphen replace",H),H=H.replace(v[G],"$1$2$3"),m("comparator trim",H,v[G]),H=(H=(H=H.replace(v[U],"$1~")).replace(v[F],"$1^")).split(/\s+/).join(" ");var Ae=ae?v[J]:v[ce],xe=H.split(" ").map(function(je){return function(Ke,Ze){return m("comp",Ke),Ke=function(at,ot){return at.trim().split(/\s+/).map(function(ke){return function(Ue,$e){m("caret",Ue,$e);var Re=$e?v[W]:v[O];return Ue.replace(Re,function(et,oe,le,Pe,Ve){var Qe;return m("caret",Ue,et,oe,le,Pe,Ve),ve(oe)?Qe="":ve(le)?Qe=">="+oe+".0.0 <"+(+oe+1)+".0.0":ve(Pe)?Qe=oe==="0"?">="+oe+"."+le+".0 <"+oe+"."+(+le+1)+".0":">="+oe+"."+le+".0 <"+(+oe+1)+".0.0":Ve?(m("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Qe=oe==="0"?le==="0"?">="+oe+"."+le+"."+Pe+Ve+" <"+oe+"."+le+"."+(+Pe+1):">="+oe+"."+le+"."+Pe+Ve+" <"+oe+"."+(+le+1)+".0":">="+oe+"."+le+"."+Pe+Ve+" <"+(+oe+1)+".0.0"):(m("no pr"),Qe=oe==="0"?le==="0"?">="+oe+"."+le+"."+Pe+" <"+oe+"."+le+"."+(+Pe+1):">="+oe+"."+le+"."+Pe+" <"+oe+"."+(+le+1)+".0":">="+oe+"."+le+"."+Pe+" <"+(+oe+1)+".0.0"),m("caret return",Qe),Qe})}(ke,ot)}).join(" ")}(Ke,Ze),m("caret",Ke),Ke=function(at,ot){return at.trim().split(/\s+/).map(function(ke){return function(Ue,$e){var Re=$e?v[P]:v[M];return Ue.replace(Re,function(et,oe,le,Pe,Ve){var Qe;return m("tilde",Ue,et,oe,le,Pe,Ve),ve(oe)?Qe="":ve(le)?Qe=">="+oe+".0.0 <"+(+oe+1)+".0.0":ve(Pe)?Qe=">="+oe+"."+le+".0 <"+oe+"."+(+le+1)+".0":Ve?(m("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Qe=">="+oe+"."+le+"."+Pe+Ve+" <"+oe+"."+(+le+1)+".0"):Qe=">="+oe+"."+le+"."+Pe+" <"+oe+"."+(+le+1)+".0",m("tilde return",Qe),Qe})}(ke,ot)}).join(" ")}(Ke,Ze),m("tildes",Ke),Ke=function(at,ot){return m("replaceXRanges",at,ot),at.split(/\s+/).map(function(ke){return function(Ue,$e){Ue=Ue.trim();var Re=$e?v[b]:v[E];return Ue.replace(Re,function(et,oe,le,Pe,Ve,Qe){m("xRange",Ue,et,oe,le,Pe,Ve,Qe);var it=ve(le),st=it||ve(Pe),Me=st||ve(Ve);return oe==="="&&Me&&(oe=""),it?et=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Me?(st&&(Pe=0),Me&&(Ve=0),oe===">"?(oe=">=",st?(le=+le+1,Pe=0,Ve=0):Me&&(Pe=+Pe+1,Ve=0)):oe==="<="&&(oe="<",st?le=+le+1:Pe=+Pe+1),et=oe+le+"."+Pe+"."+Ve):st?et=">="+le+".0.0 <"+(+le+1)+".0.0":Me&&(et=">="+le+"."+Pe+".0 <"+le+"."+(+Pe+1)+".0"),m("xRange return",et),et})}(ke,ot)}).join(" ")}(Ke,Ze),m("xrange",Ke),Ke=function(at,ot){return m("replaceStars",at,ot),at.trim().replace(v[se],"")}(Ke,Ze),m("stars",Ke),Ke}(je,ae)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(je){return!!je.match(Ae)})),xe=xe.map(function(je){return new fe(je,ae)})},Te.prototype.intersects=function(H,ae){if(!(H instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ae){return H.set.some(function(xe){return xe.every(function(je){return Ae.intersects(je,ae)})})})})},e.toComparators=function(H,ae){return new Te(H,ae).set.map(function(ue){return ue.map(function(Ae){return Ae.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new he(H,this.loose));for(var ae=0;ae<this.set.length;ae++)if(B(this.set[ae],H))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(H,ae,ue){var Ae=null,xe=null;try{var je=new Te(ae,ue)}catch{return null}return H.forEach(function(Ke){je.test(Ke)&&(Ae&&xe.compare(Ke)!==-1||(xe=new he(Ae=Ke,ue)))}),Ae},e.minSatisfying=function(H,ae,ue){var Ae=null,xe=null;try{var je=new Te(ae,ue)}catch{return null}return H.forEach(function(Ke){je.test(Ke)&&(Ae&&xe.compare(Ke)!==1||(xe=new he(Ae=Ke,ue)))}),Ae},e.validRange=function(H,ae){try{return new Te(H,ae).range||"*"}catch{return null}},e.ltr=function(H,ae,ue){return ee(H,ae,"<",ue)},e.gtr=function(H,ae,ue){return ee(H,ae,">",ue)},e.outside=ee,e.prerelease=function(H,ae){var ue=we(H,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(H,ae,ue){return H=new Te(H,ue),ae=new Te(ae,ue),H.intersects(ae)},e.coerce=function(H){if(H instanceof he)return H;if(typeof H!="string")return null;var ae=H.match(v[_]);return ae==null?null:we((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(ge,e){var D,N,m=ge.exports={};function k(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function v(f){if(D===setTimeout)return setTimeout(f,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch{D=k}try{N=typeof clearTimeout=="function"?clearTimeout:R}catch{N=R}})();var p,S=[],L=!1,I=-1;function g(){L&&p&&(L=!1,p.length?S=p.concat(S):I=-1,S.length&&w())}function w(){if(!L){var f=v(g);L=!0;for(var s=S.length;s;){for(p=S,S=[];++I<s;)p&&p[I].run();I=-1,s=S.length}p=null,L=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===R||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(f)}}function C(f,s){this.fun=f,this.array=s}function l(){}m.nextTick=function(f){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];S.push(new C(f,s)),S.length!==1||L||v(w)},C.prototype.run=function(){this.fun.apply(null,this.array)},m.title="browser",m.browser=!0,m.env={},m.argv=[],m.version="",m.versions={},m.on=l,m.addListener=l,m.once=l,m.off=l,m.removeListener=l,m.removeAllListeners=l,m.emit=l,m.prependListener=l,m.prependOnceListener=l,m.listeners=function(f){return[]},m.binding=function(f){throw new Error("process.binding is not supported")},m.cwd=function(){return"/"},m.chdir=function(f){throw new Error("process.chdir is not supported")},m.umask=function(){return 0}}])}),define(ye[38],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(k){return new N(k)}constructor(k){this._now=D&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=N}),define(ye[4],Ce([1,0,8,74,3,75,38]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const v=!1,p=!1;var S;(function(E){E.None=()=>m.Disposable.None;function b(te){if(p){const{onDidAddListener:fe}=te,Ee=C.create();let Te=0;te.onDidAddListener=()=>{++Te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),fe?.()}}}function _(te,fe){return ce(te,()=>{},0,void 0,!0,void 0,fe)}E.defer=_;function T(te){return(fe,Ee=null,Te)=>{let ve=!1,De;return De=te(B=>{if(!ve)return De?De.dispose():ve=!0,fe.call(Ee,B)},null,Te),ve&&De.dispose(),De}}E.once=T;function U(te,fe,Ee){return W((Te,ve=null,De)=>te(B=>Te.call(ve,fe(B)),null,De),Ee)}E.map=U;function M(te,fe,Ee){return W((Te,ve=null,De)=>te(B=>{fe(B),Te.call(ve,B)},null,De),Ee)}E.forEach=M;function P(te,fe,Ee){return W((Te,ve=null,De)=>te(B=>fe(B)&&Te.call(ve,B),null,De),Ee)}E.filter=P;function x(te){return te}E.signal=x;function F(...te){return(fe,Ee=null,Te)=>{const ve=(0,m.combinedDisposable)(...te.map(De=>De(B=>fe.call(Ee,B))));return J(ve,Te)}}E.any=F;function O(te,fe,Ee,Te){let ve=Ee;return U(te,De=>(ve=fe(ve,De),ve),Te)}E.reduce=O;function W(te,fe){let Ee;const Te={onWillAddFirstListener(){Ee=te(ve.fire,ve)},onDidRemoveLastListener(){Ee?.dispose()}};fe||b(Te);const ve=new n(Te);return fe?.add(ve),ve.event}function J(te,fe){return fe instanceof Array?fe.push(te):fe&&fe.add(te),te}function ce(te,fe,Ee=100,Te=!1,ve=!1,De,B){let K,ee,H,ae=0,ue;const Ae={leakWarningThreshold:De,onWillAddFirstListener(){K=te(je=>{ae++,ee=fe(ee,je),Te&&!H&&(xe.fire(ee),ee=void 0),ue=()=>{const Ke=ee;ee=void 0,H=void 0,(!Te||ae>1)&&xe.fire(Ke),ae=0},typeof Ee=="number"?(clearTimeout(H),H=setTimeout(ue,Ee)):H===void 0&&(H=0,queueMicrotask(ue))})},onWillRemoveListener(){ve&&ae>0&&ue?.()},onDidRemoveLastListener(){ue=void 0,K.dispose()}};B||b(Ae);const xe=new n(Ae);return B?.add(xe),xe.event}E.debounce=ce;function G(te,fe=0,Ee){return E.debounce(te,(Te,ve)=>Te?(Te.push(ve),Te):[ve],fe,void 0,!0,void 0,Ee)}E.accumulate=G;function X(te,fe=(Te,ve)=>Te===ve,Ee){let Te=!0,ve;return P(te,De=>{const B=Te||!fe(De,ve);return Te=!1,ve=De,B},Ee)}E.latch=X;function Y(te,fe,Ee){return[E.filter(te,fe,Ee),E.filter(te,Te=>!fe(Te),Ee)]}E.split=Y;function se(te,fe=!1,Ee=[],Te){let ve=Ee.slice(),De=te(ee=>{ve?ve.push(ee):K.fire(ee)});Te&&Te.add(De);const B=()=>{ve?.forEach(ee=>K.fire(ee)),ve=null},K=new n({onWillAddFirstListener(){De||(De=te(ee=>K.fire(ee)),Te&&Te.add(De))},onDidAddFirstListener(){ve&&(fe?setTimeout(B):B())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Te&&Te.add(K),K.event}E.buffer=se;function Q(te,fe){return(Te,ve,De)=>{const B=fe(new he);return te(function(K){const ee=B.evaluate(K);ee!==we&&Te.call(ve,ee)},void 0,De)}}E.chain=Q;const we=Symbol("HaltChainable");class he{constructor(){this.steps=[]}map(fe){return this.steps.push(fe),this}forEach(fe){return this.steps.push(Ee=>(fe(Ee),Ee)),this}filter(fe){return this.steps.push(Ee=>fe(Ee)?Ee:we),this}reduce(fe,Ee){let Te=Ee;return this.steps.push(ve=>(Te=fe(Te,ve),Te)),this}latch(fe=(Ee,Te)=>Ee===Te){let Ee=!0,Te;return this.steps.push(ve=>{const De=Ee||!fe(ve,Te);return Ee=!1,Te=ve,De?ve:we}),this}evaluate(fe){for(const Ee of this.steps)if(fe=Ee(fe),fe===we)break;return fe}}function j(te,fe,Ee=Te=>Te){const Te=(...K)=>B.fire(Ee(...K)),ve=()=>te.on(fe,Te),De=()=>te.removeListener(fe,Te),B=new n({onWillAddFirstListener:ve,onDidRemoveLastListener:De});return B.event}E.fromNodeEventEmitter=j;function z(te,fe,Ee=Te=>Te){const Te=(...K)=>B.fire(Ee(...K)),ve=()=>te.addEventListener(fe,Te),De=()=>te.removeEventListener(fe,Te),B=new n({onWillAddFirstListener:ve,onDidRemoveLastListener:De});return B.event}E.fromDOMEventEmitter=z;function ne(te){return new Promise(fe=>T(te)(fe))}E.toPromise=ne;function Se(te){const fe=new n;return te.then(Ee=>{fe.fire(Ee)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}E.fromPromise=Se;function de(te,fe,Ee){return fe(Ee),te(Te=>fe(Te))}E.runAndSubscribe=de;function me(te,fe){let Ee=null;function Te(De){Ee?.dispose(),Ee=new m.DisposableStore,fe(De,Ee)}Te(void 0);const ve=te(De=>Te(De));return(0,m.toDisposable)(()=>{ve.dispose(),Ee?.dispose()})}E.runAndSubscribeWithStore=me;class Z{constructor(fe,Ee){this._observable=fe,this._counter=0,this._hasChanged=!1;const Te={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};Ee||b(Te),this.emitter=new n(Te),Ee&&Ee.add(this.emitter)}beginUpdate(fe){this._counter++}handlePossibleChange(fe){}handleChange(fe,Ee){this._hasChanged=!0}endUpdate(fe){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function ie(te,fe){return new Z(te,fe).emitter.event}E.fromObservable=ie;function q(te){return(fe,Ee,Te)=>{let ve=0,De=!1;const B={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(te.reportChanges(),De&&(De=!1,fe.call(Ee)))},handlePossibleChange(){},handleChange(){De=!0}};te.addObserver(B),te.reportChanges();const K={dispose(){te.removeObserver(B)}};return Te instanceof m.DisposableStore?Te.add(K):Array.isArray(Te)&&Te.push(K),K}}E.fromObservableLight=q})(S||(e.Event=S={}));class L{static{this.all=new Set}static{this._idPool=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${L._idPool++}`,L.all.add(this)}start(b){this._stopWatch=new R.StopWatch,this.listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=L;let I=-1;function g(E){const b=I;return I=E,{dispose(){I=b}}}e.setGlobalLeakWarningThreshold=g;class w{constructor(b,_=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=_,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(b,_){const T=this.threshold;if(T<=0||_<T)return;this._stacks||(this._stacks=new Map);const U=this._stacks.get(b.value)||0;if(this._stacks.set(b.value,U+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=T*.5;let M,P=0;for(const[x,F]of this._stacks)(!M||P<F)&&(M=x,P=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${P}):`),console.warn(M)}return()=>{const M=this._stacks.get(b.value)||0;this._stacks.set(b.value,M-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class f{constructor(b){this.value=b,this.id=l++}}const s=2,i=(E,b)=>{if(E instanceof f)b(E);else for(let _=0;_<E.length;_++){const T=E[_];T&&b(T)}};class n{constructor(b){this._size=0,this._options=b,this._leakageMon=I>0||this._options?.leakWarningThreshold?new w(this._options?.leakWarningThreshold??I):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(v){const b=this._listeners;queueMicrotask(()=>{i(b,_=>_.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(b,_,T)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),m.Disposable.None;if(this._disposed)return m.Disposable.None;_&&(b=b.bind(_));const U=new f(b);let M,P;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(U.stack=C.create(),M=this._leakageMon.check(U.stack,this._size+1)),v&&(U.stack=P??C.create()),this._listeners?this._listeners instanceof f?(this._deliveryQueue??=new a,this._listeners=[this._listeners,U]):this._listeners.push(U):(this._options?.onWillAddFirstListener?.(this),this._listeners=U,this._options?.onDidAddFirstListener?.(this)),this._size++;const x=(0,m.toDisposable)(()=>{M?.(),this._removeListener(U)});return T instanceof m.DisposableStore?T.add(x):Array.isArray(T)&&T.push(x),x},this._event}_removeListener(b){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const _=this._listeners,T=_.indexOf(b);if(T===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,_[T]=void 0;const U=this._deliveryQueue.current===this;if(this._size*s<=_.length){let M=0;for(let P=0;P<_.length;P++)_[P]?_[M++]=_[P]:U&&(this._deliveryQueue.end--,M<this._deliveryQueue.i&&this._deliveryQueue.i--);_.length=M}}_deliver(b,_){if(!b)return;const T=this._options?.onListenerError||D.onUnexpectedError;if(!T){b.value(_);return}try{b.value(_)}catch(U){T(U)}}_deliverQueue(b){const _=b.current._listeners;for(;b.i<b.end;)this._deliver(_[b.i++],b.value);b.reset()}fire(b){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof f)this._deliver(this._listeners,b);else{const _=this._deliveryQueue;_.enqueue(this,b,this._listeners.length),this._deliverQueue(_)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=n;const o=()=>new a;e.createEventDeliveryQueue=o;class a{constructor(){this.i=-1,this.end=0}enqueue(b,_,T){this.i=0,this.end=T,this.current=b,this.value=_}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(b,_,T){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList),i(this._listeners,U=>this._asyncDeliveryQueue.push([U.value,b]));this._asyncDeliveryQueue.size>0&&!_.isCancellationRequested;){const[U,M]=this._asyncDeliveryQueue.shift(),P=[],x={...M,token:_,waitUntil:F=>{if(Object.isFrozen(P))throw new Error("waitUntil can NOT be called asynchronous");T&&(F=T(F,U)),P.push(F)}};try{U(x)}catch(F){(0,D.onUnexpectedError)(F);continue}Object.freeze(P),await Promise.allSettled(P).then(F=>{for(const O of F)O.status==="rejected"&&(0,D.onUnexpectedError)(O.reason)})}}}e.AsyncEmitter=t;class r extends n{get isPaused(){return this._isPaused!==0}constructor(b){super(b),this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=b?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._size&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=r;class h extends r{constructor(b){super(b),this._delay=b.delay??100}fire(b){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(b)}}e.DebounceEmitter=h;class u extends n{constructor(b){super(b),this._queuedEvents=[],this._mergeFn=b?.merge}fire(b){this.hasListeners()&&(this._queuedEvents.push(b),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(_=>super.fire(_)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const _={event:b,listener:null};this.events.push(_),this.hasListeners&&this.hook(_);const T=()=>{this.hasListeners&&this.unhook(_);const U=this.events.indexOf(_);this.events.splice(U,1)};return(0,m.toDisposable)((0,N.createSingleCallFunction)(T))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(_=>this.emitter.fire(_))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class d{constructor(b,_,T,U){this._store=new m.DisposableStore;const M=this._store.add(new c),P=this._store.add(new m.DisposableMap);function x(F){P.set(F,M.add(U(F)))}for(const F of b)x(F);this._store.add(_(F=>{x(F)})),this._store.add(T(F=>{P.deleteAndDispose(F)})),this.event=M.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=d;class y{constructor(){this.buffers=[]}wrapEvent(b){return(_,T,U)=>b(M=>{const P=this.buffers[this.buffers.length-1];P?P.push(()=>_.call(T,M)):_.call(T,M)},void 0,U)}bufferEvents(b){const _=[];this.buffers.push(_);const T=b();return this.buffers.pop(),_.forEach(U=>U()),T}}e.EventBufferer=y;class A{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=m.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=A}),define(ye[21],Ce([1,0,4]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const N=Object.freeze(function(v,p){const S=setTimeout(v.bind(p),0);return{dispose(){clearTimeout(S)}}});var m;(function(v){function p(S){return S===v.None||S===v.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}v.isCancellationToken=p,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(m||(e.CancellationToken=m={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?N:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=m.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=m.None}}e.CancellationTokenSource=R}),define(ye[162],Ce([1,0,21]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class N{constructor(v){this.task=v,this.result=null}get(){if(this.result)return this.result;const v=new D.CancellationTokenSource,p=this.task(v.token);return this.result={promise:p,dispose:()=>{this.result=null,v.cancel(),v.dispose()}},this.result}}e.Cache=N;class m{constructor(v){this.fn=v,this.lastCache=void 0,this.lastArgKey=void 0}get(v){const p=JSON.stringify(v);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(v)),this.lastCache}}e.LRUCachedFunction=m;class k{get cachedValues(){return this._map}constructor(v){this.fn=v,this._map=new Map}get(v){if(this._map.has(v))return this._map.get(v);const p=this.fn(v);return this._map.set(v,p),p}}e.CachedFunction=k}),define(ye[98],Ce([1,0,8,3]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function m(o){const a=o;return a?typeof a.read=="function":!1}e.isReadable=m;function k(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=k;function R(o){const a=o;return a?k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=R;function v(o,a){return new p(o,a)}e.newWriteableStream=v;class p{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,D.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let r;switch(a){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const h=r.indexOf(t);h>=0&&r.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.consumeReadable=S;function L(o,a,t){const r=[];let h;for(;(h=o.read())!==null&&r.length<t;)r.push(h);return h===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof h<"u"){const u=h;return h=void 0,u}return o.read()}}}e.peekReadable=L;function I(o,a){return new Promise((t,r)=>{const h=[];g(o,{onData:u=>{a&&h.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(h):void 0)}})})}e.consumeStream=I;function g(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.listenStream=g;function w(o,a){return new Promise((t,r)=>{const h=new N.DisposableStore,u=[],c=A=>{if(u.push(A),u.length>a)return h.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},d=A=>(h.dispose(),r(A)),y=()=>(h.dispose(),t({stream:o,buffer:u,ended:!0}));h.add((0,N.toDisposable)(()=>o.removeListener("error",d))),o.on("error",d),h.add((0,N.toDisposable)(()=>o.removeListener("end",y))),o.on("end",y),h.add((0,N.toDisposable)(()=>o.removeListener("data",c))),o.on("data",c)})}e.peekStream=w;function C(o,a){const t=v(a);return t.end(o),t}e.toStream=C;function l(){const o=v(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=l;function f(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.toReadable=f;function s(o,a,t){const r=v(t);return g(o,{onData:h=>r.write(a.data(h)),onError:h=>r.error(a.error?a.error(h):h),onEnd:()=>r.end()}),r}e.transform=s;function i(o,a,t){let r=!1;return{read:()=>{const h=a.read();return r?h:(r=!0,h!==null?t([o,h]):o)}}}e.prefixedReadable=i;function n(o,a,t){let r=!1;const h=v(t);return g(a,{onData:u=>r?h.write(u):(r=!0,h.write(t([o,u]))),onError:u=>h.error(u),onEnd:()=>{r||(r=!0,h.write(o)),h.end()}}),h}e.prefixedStream=n}),define(ye[22],Ce([1,0,43,98]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const m=typeof Buffer<"u",k=new D.Lazy(()=>new Uint8Array(256));let R,v;class p{static alloc(_){return m?new p(Buffer.allocUnsafe(_)):new p(new Uint8Array(_))}static wrap(_){return m&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new p(_)}static fromString(_,T){return!(T?.dontUseNodeBuffer||!1)&&m?new p(Buffer.from(_)):(R||(R=new TextEncoder),new p(R.encode(_)))}static fromByteArray(_){const T=p.alloc(_.length);for(let U=0,M=_.length;U<M;U++)T.buffer[U]=_[U];return T}static concat(_,T){if(typeof T>"u"){T=0;for(let P=0,x=_.length;P<x;P++)T+=_[P].byteLength}const U=p.alloc(T);let M=0;for(let P=0,x=_.length;P<x;P++){const F=_[P];U.set(F,M),M+=F.byteLength}return U}constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}clone(){const _=p.alloc(this.byteLength);return _.set(this),_}toString(){return m?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(_,T){return new p(this.buffer.subarray(_,T))}set(_,T){if(_ instanceof p)this.buffer.set(_.buffer,T);else if(_ instanceof Uint8Array)this.buffer.set(_,T);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),T);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return g(this.buffer,_)}writeUInt32BE(_,T){w(this.buffer,_,T)}readUInt32LE(_){return C(this.buffer,_)}writeUInt32LE(_,T){l(this.buffer,_,T)}readUInt8(_){return f(this.buffer,_)}writeUInt8(_,T){s(this.buffer,_,T)}indexOf(_,T=0){return S(this.buffer,_ instanceof p?_.buffer:_,T)}}e.VSBuffer=p;function S(b,_,T=0){const U=_.byteLength,M=b.byteLength;if(U===0)return 0;if(U===1)return b.indexOf(_[0]);if(U>M-T)return-1;const P=k.value;P.fill(_.length);for(let W=0;W<_.length;W++)P[_[W]]=_.length-W-1;let x=T+_.length-1,F=x,O=-1;for(;x<M;)if(b[x]===_[F]){if(F===0){O=x;break}x--,F--}else x+=Math.max(_.length-F,P[b[x]]),F=_.length-1;return O}e.binaryIndexOf=S;function L(b,_){return b[_+0]<<0>>>0|b[_+1]<<8>>>0}e.readUInt16LE=L;function I(b,_,T){b[T+0]=_&255,_=_>>>8,b[T+1]=_&255}e.writeUInt16LE=I;function g(b,_){return b[_]*2**24+b[_+1]*2**16+b[_+2]*2**8+b[_+3]}e.readUInt32BE=g;function w(b,_,T){b[T+3]=_,_=_>>>8,b[T+2]=_,_=_>>>8,b[T+1]=_,_=_>>>8,b[T]=_}e.writeUInt32BE=w;function C(b,_){return b[_+0]<<0>>>0|b[_+1]<<8>>>0|b[_+2]<<16>>>0|b[_+3]<<24>>>0}e.readUInt32LE=C;function l(b,_,T){b[T+0]=_&255,_=_>>>8,b[T+1]=_&255,_=_>>>8,b[T+2]=_&255,_=_>>>8,b[T+3]=_&255}e.writeUInt32LE=l;function f(b,_){return b[_]}e.readUInt8=f;function s(b,_,T){b[T]=_}e.writeUInt8=s;function i(b){return N.consumeReadable(b,_=>p.concat(_))}e.readableToBuffer=i;function n(b){return N.toReadable(b)}e.bufferToReadable=n;function o(b){return N.consumeStream(b,_=>p.concat(_))}e.streamToBuffer=o;async function a(b){return b.ended?p.concat(b.buffer):p.concat([...b.buffer,await o(b.stream)])}e.bufferedStreamToBuffer=a;function t(b){return N.toStream(b,_=>p.concat(_))}e.bufferToStream=t;function r(b){return N.transform(b,{data:_=>typeof _=="string"?p.fromString(_):p.wrap(_)},_=>p.concat(_))}e.streamToBufferReadableStream=r;function h(b){return N.newWriteableStream(_=>p.concat(_),b)}e.newWriteableBufferStream=h;function u(b,_){return N.prefixedReadable(b,_,T=>p.concat(T))}e.prefixedBufferReadable=u;function c(b,_){return N.prefixedStream(b,_,T=>p.concat(T))}e.prefixedBufferStream=c;function d(b){let _=0,T=0,U=0;const M=new Uint8Array(Math.floor(b.length/4*3)),P=F=>{switch(T){case 3:M[U++]=_|F,T=0;break;case 2:M[U++]=_|F>>>2,_=F<<6,T=3;break;case 1:M[U++]=_|F>>>4,_=F<<4,T=2;break;default:_=F<<2,T=1}};for(let F=0;F<b.length;F++){const O=b.charCodeAt(F);if(O>=65&&O<=90)P(O-65);else if(O>=97&&O<=122)P(O-97+26);else if(O>=48&&O<=57)P(O-48+52);else if(O===43||O===45)P(62);else if(O===47||O===95)P(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${b[F]}`)}}const x=U;for(;T>0;)P(0);return p.wrap(M).slice(0,x)}e.decodeBase64=d;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:b},_=!0,T=!1){const U=T?A:y;let M="";const P=b.byteLength%3;let x=0;for(;x<b.byteLength-P;x+=3){const F=b[x+0],O=b[x+1],W=b[x+2];M+=U[F>>>2],M+=U[(F<<4|O>>>4)&63],M+=U[(O<<2|W>>>6)&63],M+=U[W&63]}if(P===1){const F=b[x+0];M+=U[F>>>2],M+=U[F<<4&63],_&&(M+="==")}else if(P===2){const F=b[x+0],O=b[x+1];M+=U[F>>>2],M+=U[(F<<4|O>>>4)&63],M+=U[O<<2&63],_&&(M+="=")}return M}e.encodeBase64=E}),define(ye[13],Ce([1,0,162,43]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncateMiddle=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(ke){return!ke||typeof ke!="string"?!0:ke.trim().length===0}e.isFalsyOrWhitespace=m;const k=/{(\d+)}/g;function R(ke,...Ue){return Ue.length===0?ke:ke.replace(k,function($e,Re){const et=parseInt(Re,10);return isNaN(et)||et<0||et>=Ue.length?$e:Ue[et]})}e.format=R;const v=/{([^}]+)}/g;function p(ke,Ue){return Object.keys(Ue).length===0?ke:ke.replace(v,($e,Re)=>Ue[Re]??$e)}e.format2=p;function S(ke){return ke.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}e.escape=S;function L(ke){return ke.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=L;function I(ke,Ue){let $e=0;const Re=Ue.charCodeAt(0);for(let et=ke.length-1;et>=0;et--)ke.charCodeAt(et)===Re&&$e++;return $e}e.count=I;function g(ke,Ue,$e="\u2026"){return ke.length<=Ue?ke:`${ke.substr(0,Ue)}${$e}`}e.truncate=g;function w(ke,Ue,$e="\u2026"){if(ke.length<=Ue)return ke;const Re=Math.ceil(Ue/2)-$e.length/2,et=Math.floor(Ue/2)-$e.length/2;return`${ke.substr(0,Re)}${$e}${ke.substr(ke.length-et)}`}e.truncateMiddle=w;function C(ke,Ue=" "){const $e=l(ke,Ue);return f($e,Ue)}e.trim=C;function l(ke,Ue){if(!ke||!Ue)return ke;const $e=Ue.length;if($e===0||ke.length===0)return ke;let Re=0;for(;ke.indexOf(Ue,Re)===Re;)Re=Re+$e;return ke.substring(Re)}e.ltrim=l;function f(ke,Ue){if(!ke||!Ue)return ke;const $e=Ue.length,Re=ke.length;if($e===0||Re===0)return ke;let et=Re,oe=-1;for(;oe=ke.lastIndexOf(Ue,et-1),!(oe===-1||oe+$e!==et);){if(oe===0)return"";et=oe}return ke.substring(0,et)}e.rtrim=f;function s(ke){return ke.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=s;function i(ke){return ke.replace(/\*/g,"")}e.stripWildcards=i;function n(ke,Ue,$e={}){if(!ke)throw new Error("Cannot create regex from empty string");Ue||(ke=L(ke)),$e.wholeWord&&(/\B/.test(ke.charAt(0))||(ke="\\b"+ke),/\B/.test(ke.charAt(ke.length-1))||(ke=ke+"\\b"));let Re="";return $e.global&&(Re+="g"),$e.matchCase||(Re+="i"),$e.multiline&&(Re+="m"),$e.unicode&&(Re+="u"),new RegExp(ke,Re)}e.createRegExp=n;function o(ke){return ke.source==="^"||ke.source==="^$"||ke.source==="$"||ke.source==="^\\s*$"?!1:!!(ke.exec("")&&ke.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function a(ke){return ke.split(/\r\n|\r|\n/)}e.splitLines=a;function t(ke){for(let Ue=0,$e=ke.length;Ue<$e;Ue++){const Re=ke.charCodeAt(Ue);if(Re!==32&&Re!==9)return Ue}return-1}e.firstNonWhitespaceIndex=t;function r(ke,Ue=0,$e=ke.length){for(let Re=Ue;Re<$e;Re++){const et=ke.charCodeAt(Re);if(et!==32&&et!==9)return ke.substring(Ue,Re)}return ke.substring(Ue,$e)}e.getLeadingWhitespace=r;function h(ke,Ue=ke.length-1){for(let $e=Ue;$e>=0;$e--){const Re=ke.charCodeAt($e);if(Re!==32&&Re!==9)return $e}return-1}e.lastNonWhitespaceIndex=h;function u(ke,Ue,$e){const Re=[];let et=0;for(const oe of ke.matchAll(Ue)){if(Re.push(ke.slice(et,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");et=oe.index+oe[0].length,Re.push($e(oe[0],...oe.slice(1),oe.index,ke,oe.groups))}return Re.push(ke.slice(et)),Promise.all(Re).then(oe=>oe.join(""))}e.replaceAsync=u;function c(ke,Ue){return ke<Ue?-1:ke>Ue?1:0}e.compare=c;function d(ke,Ue,$e=0,Re=ke.length,et=0,oe=Ue.length){for(;$e<Re&&et<oe;$e++,et++){const Ve=ke.charCodeAt($e),Qe=Ue.charCodeAt(et);if(Ve<Qe)return-1;if(Ve>Qe)return 1}const le=Re-$e,Pe=oe-et;return le<Pe?-1:le>Pe?1:0}e.compareSubstring=d;function y(ke,Ue){return A(ke,Ue,0,ke.length,0,Ue.length)}e.compareIgnoreCase=y;function A(ke,Ue,$e=0,Re=ke.length,et=0,oe=Ue.length){for(;$e<Re&&et<oe;$e++,et++){let Ve=ke.charCodeAt($e),Qe=Ue.charCodeAt(et);if(Ve===Qe)continue;if(Ve>=128||Qe>=128)return d(ke.toLowerCase(),Ue.toLowerCase(),$e,Re,et,oe);b(Ve)&&(Ve-=32),b(Qe)&&(Qe-=32);const it=Ve-Qe;if(it!==0)return it}const le=Re-$e,Pe=oe-et;return le<Pe?-1:le>Pe?1:0}e.compareSubstringIgnoreCase=A;function E(ke){return ke>=48&&ke<=57}e.isAsciiDigit=E;function b(ke){return ke>=97&&ke<=122}e.isLowerAsciiLetter=b;function _(ke){return ke>=65&&ke<=90}e.isUpperAsciiLetter=_;function T(ke,Ue){return ke.length===Ue.length&&A(ke,Ue)===0}e.equalsIgnoreCase=T;function U(ke,Ue){const $e=Ue.length;return Ue.length>ke.length?!1:A(ke,Ue,0,$e)===0}e.startsWithIgnoreCase=U;function M(ke,Ue){const $e=Math.min(ke.length,Ue.length);let Re;for(Re=0;Re<$e;Re++)if(ke.charCodeAt(Re)!==Ue.charCodeAt(Re))return Re;return $e}e.commonPrefixLength=M;function P(ke,Ue){const $e=Math.min(ke.length,Ue.length);let Re;const et=ke.length-1,oe=Ue.length-1;for(Re=0;Re<$e;Re++)if(ke.charCodeAt(et-Re)!==Ue.charCodeAt(oe-Re))return Re;return $e}e.commonSuffixLength=P;function x(ke){return 55296<=ke&&ke<=56319}e.isHighSurrogate=x;function F(ke){return 56320<=ke&&ke<=57343}e.isLowSurrogate=F;function O(ke,Ue){return(ke-55296<<10)+(Ue-56320)+65536}e.computeCodePoint=O;function W(ke,Ue,$e){const Re=ke.charCodeAt($e);if(x(Re)&&$e+1<Ue){const et=ke.charCodeAt($e+1);if(F(et))return O(Re,et)}return Re}e.getNextCodePoint=W;function J(ke,Ue){const $e=ke.charCodeAt(Ue-1);if(F($e)&&Ue>1){const Re=ke.charCodeAt(Ue-2);if(x(Re))return O(Re,$e)}return $e}class ce{get offset(){return this._offset}constructor(Ue,$e=0){this._str=Ue,this._len=Ue.length,this._offset=$e}setOffset(Ue){this._offset=Ue}prevCodePoint(){const Ue=J(this._str,this._offset);return this._offset-=Ue>=65536?2:1,Ue}nextCodePoint(){const Ue=W(this._str,this._len,this._offset);return this._offset+=Ue>=65536?2:1,Ue}eol(){return this._offset>=this._len}}e.CodePointIterator=ce;class G{get offset(){return this._iterator.offset}constructor(Ue,$e=0){this._iterator=new ce(Ue,$e)}nextGraphemeLength(){const Ue=ue.getInstance(),$e=this._iterator,Re=$e.offset;let et=Ue.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const oe=$e.offset,le=Ue.getGraphemeBreakType($e.nextCodePoint());if(H(et,le)){$e.setOffset(oe);break}et=le}return $e.offset-Re}prevGraphemeLength(){const Ue=ue.getInstance(),$e=this._iterator,Re=$e.offset;let et=Ue.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const oe=$e.offset,le=Ue.getGraphemeBreakType($e.prevCodePoint());if(H(le,et)){$e.setOffset(oe);break}et=le}return Re-$e.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=G;function X(ke,Ue){return new G(ke,Ue).nextGraphemeLength()}e.nextCharLength=X;function Y(ke,Ue){return new G(ke,Ue).prevGraphemeLength()}e.prevCharLength=Y;function se(ke,Ue){Ue>0&&F(ke.charCodeAt(Ue))&&Ue--;const $e=Ue+X(ke,Ue);return[$e-Y(ke,$e),$e]}e.getCharContainingOffset=se;function Q(ke){const Ue=new G(ke);let $e=0;for(;!Ue.eol();)$e++,Ue.nextGraphemeLength();return $e}e.charCount=Q;let we;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(ke){return we||(we=he()),we.test(ke)}e.containsRTL=j;const z=/^[\t\n\r\x20-\x7E]*$/;function ne(ke){return z.test(ke)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Se(ke){return e.UNUSUAL_LINE_TERMINATORS.test(ke)}e.containsUnusualLineTerminators=Se;function de(ke){return ke>=11904&&ke<=55215||ke>=63744&&ke<=64255||ke>=65281&&ke<=65374}e.isFullWidthCharacter=de;function me(ke){return ke>=127462&&ke<=127487||ke===8986||ke===8987||ke===9200||ke===9203||ke>=9728&&ke<=10175||ke===11088||ke===11093||ke>=127744&&ke<=128591||ke>=128640&&ke<=128764||ke>=128992&&ke<=129008||ke>=129280&&ke<=129535||ke>=129648&&ke<=129782}e.isEmojiImprecise=me;function Z(ke,Ue){if(ke.length<Ue)return ke;const $e=/\b/g;let Re=0;for(;$e.test(ke)&&!(ke.length-$e.lastIndex<Ue);)Re=$e.lastIndex,$e.lastIndex+=1;return ke.substring(Re).replace(/^\s/,"")}e.lcut=Z;const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,q=/\x1b\].*?\x07/g;function te(ke){return ke&&(ke=ke.replace(ie,"").replace(q,"")),ke}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function fe(ke){return!!(ke&&ke.length>0&&ke.charCodeAt(0)===65279)}e.startsWithUTF8BOM=fe;function Ee(ke){return fe(ke)?ke.substr(1):ke}e.stripUTF8BOM=Ee;function Te(ke,Ue){if(!ke||!Ue||ke.length<Ue.length)return!1;const $e=Ue.length,Re=ke.toLowerCase();let et=0,oe=-1;for(;et<$e;){const le=Re.indexOf(Ue[et],oe+1);if(le<0)return!1;oe=le,et++}return!0}e.fuzzyContains=Te;function ve(ke,Ue=!1){return ke?(Ue&&(ke=ke.replace(/\\./g,"")),ke.toLowerCase()!==ke):!1}e.containsUppercaseCharacter=ve;function De(ke){return ke.charAt(0).toUpperCase()+ke.slice(1)}e.uppercaseFirstLetter=De;function B(ke,Ue=1){if(Ue===0)return"";let $e=-1;do $e=ke.indexOf(`
`,$e+1),Ue--;while(Ue>0&&$e>=0);return $e===-1?ke:(ke[$e-1]==="\r"&&$e--,ke.substr(0,$e))}e.getNLines=B;function K(ke){return ke=ke%(2*26),ke<26?String.fromCharCode(97+ke):String.fromCharCode(65+ke-26)}e.singleLetterHash=K;function ee(ke){return ue.getInstance().getGraphemeBreakType(ke)}e.getGraphemeBreakType=ee;function H(ke,Ue){return ke===0?Ue!==5&&Ue!==7:ke===2&&Ue===3?!1:ke===4||ke===2||ke===3||Ue===4||Ue===2||Ue===3?!0:!(ke===8&&(Ue===8||Ue===9||Ue===11||Ue===12)||(ke===11||ke===9)&&(Ue===9||Ue===10)||(ke===12||ke===10)&&Ue===10||Ue===5||Ue===13||Ue===7||ke===1||ke===13&&Ue===14||ke===6&&Ue===6)}var ae;(function(ke){ke[ke.Other=0]="Other",ke[ke.Prepend=1]="Prepend",ke[ke.CR=2]="CR",ke[ke.LF=3]="LF",ke[ke.Control=4]="Control",ke[ke.Extend=5]="Extend",ke[ke.Regional_Indicator=6]="Regional_Indicator",ke[ke.SpacingMark=7]="SpacingMark",ke[ke.L=8]="L",ke[ke.V=9]="V",ke[ke.T=10]="T",ke[ke.LV=11]="LV",ke[ke.LVT=12]="LVT",ke[ke.ZWJ=13]="ZWJ",ke[ke.Extended_Pictographic=14]="Extended_Pictographic"})(ae||(e.GraphemeBreakType=ae={}));class ue{static{this._INSTANCE=null}static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}constructor(){this._data=Ae()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===10?3:Ue===13?2:4;if(Ue<127)return 0;const $e=this._data,Re=$e.length/3;let et=1;for(;et<=Re;)if(Ue<$e[3*et])et=2*et;else if(Ue>$e[3*et+1])et=2*et+1;else return $e[3*et+2];return 0}}function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(ke,Ue){if(ke===0)return 0;const $e=je(ke,Ue);if($e!==void 0)return $e;const Re=new ce(Ue,ke);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=xe;function je(ke,Ue){const $e=new ce(Ue,ke);let Re=$e.prevCodePoint();for(;Ke(Re)||Re===65039||Re===8419;){if($e.offset===0)return;Re=$e.prevCodePoint()}if(!me(Re))return;let et=$e.offset;return et>0&&$e.prevCodePoint()===8205&&(et=$e.offset),et}function Ke(ke){return 127995<=ke&&ke<=127999}var Ze;(function(ke){ke[ke.zwj=8205]="zwj",ke[ke.emojiVariantSelector=65039]="emojiVariantSelector",ke[ke.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.noBreakWhitespace="\xA0";class at{static{this.ambiguousCharacterData=new N.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new D.LRUCachedFunction(Ue=>{function $e(it){const st=new Map;for(let Me=0;Me<it.length;Me+=2)st.set(it[Me],it[Me+1]);return st}function Re(it,st){const Me=new Map(it);for(const[wt,Dt]of st)Me.set(wt,Dt);return Me}function et(it,st){if(!it)return st;const Me=new Map;for(const[wt,Dt]of it)st.has(wt)&&Me.set(wt,Dt);return Me}const oe=this.ambiguousCharacterData.value;let le=Ue.filter(it=>!it.startsWith("_")&&it in oe);le.length===0&&(le=["_default"]);let Pe;for(const it of le){const st=$e(oe[it]);Pe=et(Pe,st)}const Ve=$e(oe._common),Qe=Re(Ve,Pe);return new at(Qe)})}static getInstance(Ue){return at.cache.get(Array.from(Ue))}static{this._locales=new N.Lazy(()=>Object.keys(at.ambiguousCharacterData.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return at._locales.value}constructor(Ue){this.confusableDictionary=Ue}isAmbiguous(Ue){return this.confusableDictionary.has(Ue)}getPrimaryConfusable(Ue){return this.confusableDictionary.get(Ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=at;class ot{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(ot.getRawData())),this._data}static isInvisibleCharacter(Ue){return ot.getData().has(Ue)}static get codePoints(){return ot.getData()}}e.InvisibleCharacters=ot}),define(ye[123],Ce([1,0,28,161,13]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...ve){return function(De,B){for(let K=0,ee=ve.length;K<ee;K++){const H=ve[K](De,B);if(H)return H}return null}}e.or=k,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ve,De,B){if(!B||B.length<De.length)return null;let K;return ve?K=m.startsWithIgnoreCase(B,De):K=B.indexOf(De)===0,K?De.length>0?[{start:0,end:De.length}]:[]:null}function v(ve,De){const B=De.toLowerCase().indexOf(ve.toLowerCase());return B===-1?null:[{start:B,end:B+ve.length}]}e.matchesContiguousSubString=v;function p(ve,De){return S(ve.toLowerCase(),De.toLowerCase(),0,0)}e.matchesSubString=p;function S(ve,De,B,K){if(B===ve.length)return[];if(K===De.length)return null;if(ve[B]===De[K]){let ee=null;return(ee=S(ve,De,B+1,K+1))?o({start:K,end:K+1},ee):null}return S(ve,De,B,K+1)}function L(ve){return 97<=ve&&ve<=122}function I(ve){return 65<=ve&&ve<=90}e.isUpper=I;function g(ve){return 48<=ve&&ve<=57}function w(ve){return ve===32||ve===9||ve===10||ve===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>C.add(ve.charCodeAt(0)));function l(ve){return w(ve)||C.has(ve)}function f(ve,De){return ve===De||l(ve)&&l(De)}const s=new Map;function i(ve){if(s.has(ve))return s.get(ve);let De;const B=(0,N.getKoreanAltChars)(ve);return B&&(De=B),s.set(ve,De),De}function n(ve){return L(ve)||I(ve)||g(ve)}function o(ve,De){return De.length===0?De=[ve]:ve.end===De[0].start?De[0].start=ve.start:De.unshift(ve),De}function a(ve,De){for(let B=De;B<ve.length;B++){const K=ve.charCodeAt(B);if(I(K)||g(K)||B>0&&!n(ve.charCodeAt(B-1)))return B}return ve.length}function t(ve,De,B,K){if(B===ve.length)return[];if(K===De.length)return null;if(ve[B]!==De[K].toLowerCase())return null;{let ee=null,H=K+1;for(ee=t(ve,De,B+1,K+1);!ee&&(H=a(De,H))<De.length;)ee=t(ve,De,B+1,H),H++;return ee===null?null:o({start:K,end:K+1},ee)}}function r(ve){let De=0,B=0,K=0,ee=0,H=0;for(let je=0;je<ve.length;je++)H=ve.charCodeAt(je),I(H)&&De++,L(H)&&B++,n(H)&&K++,g(H)&&ee++;const ae=De/ve.length,ue=B/ve.length,Ae=K/ve.length,xe=ee/ve.length;return{upperPercent:ae,lowerPercent:ue,alphaPercent:Ae,numericPercent:xe}}function h(ve){const{upperPercent:De,lowerPercent:B}=ve;return B===0&&De>.6}function u(ve){const{upperPercent:De,lowerPercent:B,alphaPercent:K,numericPercent:ee}=ve;return B>.2&&De<.8&&K>.6&&ee<.2}function c(ve){let De=0,B=0,K=0,ee=0;for(let H=0;H<ve.length;H++)K=ve.charCodeAt(H),I(K)&&De++,L(K)&&B++,w(K)&&ee++;return(De===0||B===0)&&ee===0?ve.length<=30:De<=5}function d(ve,De){if(!De||(De=De.trim(),De.length===0)||!c(ve)||De.length>60)return null;const B=r(De);if(!u(B)){if(!h(B))return null;De=De.toLowerCase()}let K=null,ee=0;for(ve=ve.toLowerCase();ee<De.length&&(K=t(ve,De,0,ee))===null;)ee=a(De,ee+1);return K}e.matchesCamelCase=d;function y(ve,De,B=!1){if(!De||De.length===0)return null;let K=null,ee=0;for(ve=ve.toLowerCase(),De=De.toLowerCase();ee<De.length&&(K=A(ve,De,0,ee,B),K===null);)ee=E(De,ee+1);return K}e.matchesWords=y;function A(ve,De,B,K,ee){let H=0;if(B===ve.length)return[];if(K===De.length)return null;if(!f(ve.charCodeAt(B),De.charCodeAt(K))){const Ae=i(ve.charCodeAt(B));if(!Ae)return null;for(let xe=0;xe<Ae.length;xe++)if(!f(Ae[xe],De.charCodeAt(K+xe)))return null;H+=Ae.length-1}let ae=null,ue=K+H+1;if(ae=A(ve,De,B+1,ue,ee),!ee)for(;!ae&&(ue=E(De,ue))<De.length;)ae=A(ve,De,B+1,ue,ee),ue++;if(!ae)return null;if(ve.charCodeAt(B)!==De.charCodeAt(K)){const Ae=i(ve.charCodeAt(B));if(!Ae)return ae;for(let xe=0;xe<Ae.length;xe++)if(Ae[xe]!==De.charCodeAt(K+xe))return ae}return o({start:K,end:K+H+1},ae)}function E(ve,De){for(let B=De;B<ve.length;B++)if(l(ve.charCodeAt(B))||B>0&&l(ve.charCodeAt(B-1)))return B;return ve.length}const b=k(e.matchesPrefix,d,v),_=k(e.matchesPrefix,d,p),T=new D.LRUCache(1e4);function U(ve,De,B=!1){if(typeof ve!="string"||typeof De!="string")return null;let K=T.get(ve);K||(K=new RegExp(m.convertSimple2RegExpPattern(ve),"i"),T.set(ve,K));const ee=K.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:B?_(ve,De):b(ve,De)}e.matchesFuzzy=U;function M(ve,De){const B=Z(ve,ve.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?x(B):null}e.matchesFuzzy2=M;function P(ve,De,B,K,ee,H){const ae=Math.min(13,ve.length);for(;B<ae;B++){const ue=Z(ve,De,B,K,ee,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ue)return ue}return[0,H]}e.anyScore=P;function x(ve){if(typeof ve>"u")return[];const De=[],B=ve[1];for(let K=ve.length-1;K>1;K--){const ee=ve[K]+B,H=De[De.length-1];H&&H.end===ee?H.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.createMatches=x;const F=128;function O(){const ve=[],De=[];for(let B=0;B<=F;B++)De[B]=0;for(let B=0;B<=F;B++)ve.push(De.slice(0));return ve}function W(ve){const De=[];for(let B=0;B<=ve;B++)De[B]=0;return De}const J=W(2*F),ce=W(2*F),G=O(),X=O(),Y=O(),se=!1;function Q(ve,De,B,K,ee){function H(ue,Ae,xe=" "){for(;ue.length<Ae;)ue=xe+ue;return ue}let ae=` |   |${K.split("").map(ue=>H(ue,3)).join("|")}
`;for(let ue=0;ue<=B;ue++)ue===0?ae+=" |":ae+=`${De[ue-1]}|`,ae+=ve[ue].slice(0,ee+1).map(Ae=>H(Ae.toString(),3)).join("|")+`
`;return ae}function we(ve,De,B,K){ve=ve.substr(De),B=B.substr(K),console.log(Q(X,ve,ve.length,B,B.length)),console.log(Q(Y,ve,ve.length,B,B.length)),console.log(Q(G,ve,ve.length,B,B.length))}function he(ve,De){if(De<0||De>=ve.length)return!1;const B=ve.codePointAt(De);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!m.isEmojiImprecise(B)}}function j(ve,De){if(De<0||De>=ve.length)return!1;switch(ve.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function z(ve,De,B){return De[ve]!==B[ve]}function ne(ve,De,B,K,ee,H,ae=!1){for(;De<B&&ee<H;)ve[De]===K[ee]&&(ae&&(J[De]=ee),De+=1),ee+=1;return De===B}e.isPatternInWord=ne;var Se;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var de;(function(ve){ve.Default=[-100,0];function De(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}ve.isDefault=De})(de||(e.FuzzyScore=de={}));class me{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,B){this.firstMatchCanBeWeak=De,this.boostFullMatch=B}}e.FuzzyScoreOptions=me;function Z(ve,De,B,K,ee,H,ae=me.default){const ue=ve.length>F?F:ve.length,Ae=K.length>F?F:K.length;if(B>=ue||H>=Ae||ue-B>Ae-H||!ne(De,B,ue,ee,H,Ae,!0))return;ie(ue,Ae,B,H,De,ee);let xe=1,je=1,Ke=B,Ze=H;const at=[!1];for(xe=1,Ke=B;Ke<ue;xe++,Ke++){const Re=J[Ke],et=ce[Ke],oe=Ke+1<ue?ce[Ke+1]:Ae;for(je=Re-H+1,Ze=Re;Ze<oe;je++,Ze++){let le=Number.MIN_SAFE_INTEGER,Pe=!1;Ze<=et&&(le=q(ve,De,Ke,B,K,ee,Ze,Ae,H,G[xe-1][je-1]===0,at));let Ve=0;le!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Ve=le+X[xe-1][je-1]);const Qe=Ze>Re,it=Qe?X[xe][je-1]+(G[xe][je-1]>0?-5:0):0,st=Ze>Re+1&&G[xe][je-1]>0,Me=st?X[xe][je-2]+(G[xe][je-2]>0?-5:0):0;if(st&&(!Qe||Me>=it)&&(!Pe||Me>=Ve))X[xe][je]=Me,Y[xe][je]=3,G[xe][je]=0;else if(Qe&&(!Pe||it>=Ve))X[xe][je]=it,Y[xe][je]=2,G[xe][je]=0;else if(Pe)X[xe][je]=Ve,Y[xe][je]=1,G[xe][je]=G[xe-1][je-1]+1;else throw new Error("not possible")}}if(se&&we(ve,B,K,H),!at[0]&&!ae.firstMatchCanBeWeak)return;xe--,je--;const ot=[X[xe][je],H];let ke=0,Ue=0;for(;xe>=1;){let Re=je;do{const et=Y[xe][Re];if(et===3)Re=Re-2;else if(et===2)Re=Re-1;else break}while(Re>=1);ke>1&&De[B+xe-1]===ee[H+je-1]&&!z(Re+H-1,K,ee)&&ke+1>G[xe][Re]&&(Re=je),Re===je?ke++:ke=1,Ue||(Ue=Re),xe--,je=Re-1,ot.push(je)}Ae===ue&&ae.boostFullMatch&&(ot[0]+=2);const $e=Ue-ue;return ot[0]-=$e,ot}e.fuzzyScore=Z;function ie(ve,De,B,K,ee,H){let ae=ve-1,ue=De-1;for(;ae>=B&&ue>=K;)ee[ae]===H[ue]&&(ce[ae]=ue,ae--),ue--}function q(ve,De,B,K,ee,H,ae,ue,Ae,xe,je){if(De[B]!==H[ae])return Number.MIN_SAFE_INTEGER;let Ke=1,Ze=!1;return ae===B-K?Ke=ve[B]===ee[ae]?7:5:z(ae,ee,H)&&(ae===0||!z(ae-1,ee,H))?(Ke=ve[B]===ee[ae]?7:5,Ze=!0):he(H,ae)&&(ae===0||!he(H,ae-1))?Ke=5:(he(H,ae-1)||j(H,ae-1))&&(Ke=5,Ze=!0),Ke>1&&B===K&&(je[0]=!0),Ze||(Ze=z(ae,ee,H)||he(H,ae-1)||j(H,ae-1)),B===K?ae>Ae&&(Ke-=Ze?3:5):xe?Ke+=Ze?2:0:Ke+=Ze?0:1,ae+1===ue&&(Ke-=Ze?3:5),Ke}function te(ve,De,B,K,ee,H,ae){return Ee(ve,De,B,K,ee,H,!0,ae)}e.fuzzyScoreGracefulAggressive=te;function fe(ve,De,B,K,ee,H,ae){return Ee(ve,De,B,K,ee,H,!1,ae)}e.fuzzyScoreGraceful=fe;function Ee(ve,De,B,K,ee,H,ae,ue){let Ae=Z(ve,De,B,K,ee,H,ue);if(Ae&&!ae)return Ae;if(ve.length>=3){const xe=Math.min(7,ve.length-1);for(let je=B+1;je<xe;je++){const Ke=Te(ve,je);if(Ke){const Ze=Z(Ke,Ke.toLowerCase(),B,K,ee,H,ue);Ze&&(Ze[0]-=3,(!Ae||Ze[0]>Ae[0])&&(Ae=Ze))}}}return Ae}function Te(ve,De){if(De+1>=ve.length)return;const B=ve[De],K=ve[De+1];if(B!==K)return ve.slice(0,De)+K+B+ve.slice(De+2)}}),define(ye[53],Ce([1,0,13]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function N(s){return m(s,0)}e.hash=N;function m(s,i){switch(typeof s){case"object":return s===null?k(349,i):Array.isArray(s)?p(s,i):S(s,i);case"string":return v(s,i);case"boolean":return R(s,i);case"number":return k(s,i);case"undefined":return k(937,i);default:return k(617,i)}}e.doHash=m;function k(s,i){return(i<<5)-i+s|0}e.numberHash=k;function R(s,i){return k(s?433:863,i)}function v(s,i){i=k(149417,i);for(let n=0,o=s.length;n<o;n++)i=k(s.charCodeAt(n),i);return i}e.stringHash=v;function p(s,i){return i=k(104579,i),s.reduce((n,o)=>m(o,n),i)}function S(s,i){return i=k(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=v(o,n),m(s[o],n)),i)}class L{constructor(){this._value=0}get value(){return this._value}hash(i){return this._value=m(i,this._value),this._value}}e.Hasher=L;var I;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function g(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function w(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function C(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function l(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):C((s>>>0).toString(16),i/4)}e.toHexString=l;class f{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(i){const n=i.length;if(n===0)return;const o=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,r,h;for(t!==0?(r=t,h=-1,t=0):(r=i.charCodeAt(0),h=0);;){let u=r;if(D.isHighSurrogate(r))if(h+1<n){const c=i.charCodeAt(h+1);D.isLowSurrogate(c)?(h++,u=D.computeCodePoint(r,c)):u=65533}else{t=r;break}else D.isLowSurrogate(r)&&(u=65533);if(a=this._push(o,a,u),h++,h<n)r=i.charCodeAt(h);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this._step(),n-=64,this._totalLen+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const i=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(i/4294967296),!1),this._buffDV.setUint32(60,i%4294967296,!1),this._step()}_step(){const i=f._bigBlock32,n=this._buffDV;for(let y=0;y<64;y+=4)i.setUint32(y,n.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)i.setUint32(y,g(i.getUint32(y-12,!1)^i.getUint32(y-32,!1)^i.getUint32(y-56,!1)^i.getUint32(y-64,!1),1),!1);let o=this._h0,a=this._h1,t=this._h2,r=this._h3,h=this._h4,u,c,d;for(let y=0;y<80;y++)y<20?(u=a&t|~a&r,c=1518500249):y<40?(u=a^t^r,c=1859775393):y<60?(u=a&t|a&r|t&r,c=2400959708):(u=a^t^r,c=3395469782),d=g(o,5)+u+h+c+i.getUint32(y*4,!1)&4294967295,h=r,r=t,t=g(a,30),a=o,o=d;this._h0=this._h0+o&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+h&4294967295}}e.StringSHA1=f}),define(ye[39],Ce([1,0,13]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(m){m[m.Ignore=0]="Ignore",m[m.Info=1]="Info",m[m.Warning=2]="Warning",m[m.Error=3]="Error"})(N||(N={})),function(m){const k="error",R="warning",v="warn",p="info",S="ignore";function L(g){return g?D.equalsIgnoreCase(k,g)?m.Error:D.equalsIgnoreCase(R,g)||D.equalsIgnoreCase(v,g)?m.Warning:D.equalsIgnoreCase(p,g)?m.Info:m.Ignore:m.Ignore}m.fromValue=L;function I(g){switch(g){case m.Error:return k;case m.Warning:return R;case m.Info:return p;default:return S}}m.toString=I}(N||(N={})),e.default=N}),define(ye[163],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[77],Ce([1,0,19,13]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class m{constructor(){this._value="",this._pos=0}reset(w){return this._value=w,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(w){const C=w.charCodeAt(0),l=this._value.charCodeAt(this._pos);return C-l}value(){return this._value[this._pos]}}e.StringIterator=m;class k{constructor(w=!0){this._caseSensitive=w}reset(w){return this._value=w,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let w=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(w)this._from++;else break;else w=!1;return this}cmp(w){return this._caseSensitive?(0,N.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class R{constructor(w=!0,C=!0){this._splitOnBackslash=w,this._caseSensitive=C}reset(w){this._from=0,this._to=0,this._value=w,this._valueLen=w.length;for(let C=w.length-1;C>=0;C--,this._valueLen--){const l=this._value.charCodeAt(C);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let w=!0;for(;this._to<this._valueLen;this._to++){const C=this._value.charCodeAt(this._to);if(C===47||this._splitOnBackslash&&C===92)if(w)this._from++;else break;else w=!1}return this}cmp(w){return this._caseSensitive?(0,N.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var v;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(v||(v={}));class p{constructor(w,C){this._ignorePathCasing=w,this._ignoreQueryAndFragment=C,this._states=[],this._stateIdx=0}reset(w){return this._value=w,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(w)),this._pathIterator.reset(w.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(w)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(w){if(this._states[this._stateIdx]===1)return(0,N.compareIgnoreCase)(w,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,N.compareIgnoreCase)(w,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(w);if(this._states[this._stateIdx]===4)return(0,N.compare)(w,this._value.query);if(this._states[this._stateIdx]===5)return(0,N.compare)(w,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(L||(L={}));class I{static forUris(w=()=>!1,C=()=>!1){return new I(new p(w,C))}static forPaths(w=!1){return new I(new R(void 0,!w))}static forStrings(){return new I(new m)}static forConfigKeys(){return new I(new k)}constructor(w){this._iter=w}clear(){this._root=void 0}fill(w,C){if(C){const l=C.slice(0);(0,D.shuffle)(l);for(const f of l)this.set(f,w)}else{const l=w.slice(0);(0,D.shuffle)(l);for(const f of l)this.set(f[0],f[1])}}set(w,C){const l=this._iter.reset(w);let f;this._root||(this._root=new S,this._root.segment=l.value());const s=[];for(f=this._root;;){const n=l.cmp(f.segment);if(n>0)f.left||(f.left=new S,f.left.segment=l.value()),s.push([-1,f]),f=f.left;else if(n<0)f.right||(f.right=new S,f.right.segment=l.value()),s.push([1,f]),f=f.right;else if(l.hasNext())l.next(),f.mid||(f.mid=new S,f.mid.segment=l.value()),s.push([0,f]),f=f.mid;else break}const i=f.value;f.value=C,f.key=w;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this._root=s[0][1]}}return i}get(w){return this._getNode(w)?.value}_getNode(w){const C=this._iter.reset(w);let l=this._root;for(;l;){const f=C.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(C.hasNext())C.next(),l=l.mid;else break}return l}has(w){const C=this._getNode(w);return!(C?.value===void 0&&C?.mid===void 0)}delete(w){return this._delete(w,!1)}deleteSuperstr(w){return this._delete(w,!0)}_delete(w,C){const l=this._iter.reset(w),f=[];let s=this._root;for(;s;){const i=l.cmp(s.segment);if(i>0)f.push([-1,s]),s=s.left;else if(i<0)f.push([1,s]),s=s.right;else if(l.hasNext())l.next(),f.push([0,s]),s=s.mid;else break}if(s){if(C?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this._min(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this._delete(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(f.length>0){const[n,o]=f[f.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this._root=i}for(let i=f.length-1;i>=0;i--){const n=f[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),f[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),f[i][1]=n.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this._root=f[0][1]}}}_min(w){for(;w.left;)w=w.left;return w}findSubstr(w){const C=this._iter.reset(w);let l=this._root,f;for(;l;){const s=C.cmp(l.segment);if(s>0)l=l.left;else if(s<0)l=l.right;else if(C.hasNext())C.next(),f=l.value||f,l=l.mid;else break}return l&&l.value||f}findSuperstr(w){return this._findSuperstrOrElement(w,!1)}_findSuperstrOrElement(w,C){const l=this._iter.reset(w);let f=this._root;for(;f;){const s=l.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this._entries(f.mid):C?f.value:void 0}}hasElementOrSubtree(w){return this._findSuperstrOrElement(w,!0)!==void 0}forEach(w){for(const[C,l]of this)w(l,C)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(w){const C=[];return this._dfsEntries(w,C),C[Symbol.iterator]()}_dfsEntries(w,C){w&&(w.left&&this._dfsEntries(w.left,C),w.value&&C.push([w.key,w.value]),w.mid&&this._dfsEntries(w.mid,C),w.right&&this._dfsEntries(w.right,C))}_isBalanced(){const w=C=>{if(!C)return!0;const l=C.balanceFactor();return l<-1||l>1?!1:w(C.left)&&w(C.right)};return w(this._root)}}e.TernarySearchTree=I}),define(ye[18],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(a){return typeof a=="string"}e.isString=D;function N(a){return Array.isArray(a)&&a.every(t=>D(t))}e.isStringArray=N;function m(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=m;function k(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.isTypedArray=k;function R(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=R;function v(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=v;function p(a){return a===!0||a===!1}e.isBoolean=p;function S(a){return typeof a>"u"}e.isUndefined=S;function L(a){return!I(a)}e.isDefined=L;function I(a){return S(a)||a===null}e.isUndefinedOrNull=I;function g(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=g;function w(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=w;function C(...a){const t=[];for(let r=0;r<a.length;r++){const h=a[r];if(I(h))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(h)}return t}e.assertAllDefined=C;const l=Object.prototype.hasOwnProperty;function f(a){if(!m(a))return!1;for(const t in a)if(l.call(a,t))return!1;return!0}e.isEmptyObject=f;function s(a){return typeof a=="function"}e.isFunction=s;function i(...a){return a.length>0&&a.every(s)}e.areFunctions=i;function n(a,t){const r=Math.min(a.length,t.length);for(let h=0;h<r;h++)o(a[h],t[h])}e.validateConstraints=n;function o(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!I(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o}),define(ye[78],Ce([1,0,18]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const N=Object.create(null);function m(v,p){if((0,D.isString)(p)){const S=N[p];if(S===void 0)throw new Error(`${v} references an unknown codicon: ${p}`);p=S}return N[v]=p,{id:v}}function k(){return N}e.getCodiconFontCharacters=k;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:m("add",6e4),plus:m("plus",6e4),gistNew:m("gist-new",6e4),repoCreate:m("repo-create",6e4),lightbulb:m("lightbulb",60001),lightBulb:m("light-bulb",60001),repo:m("repo",60002),repoDelete:m("repo-delete",60002),gistFork:m("gist-fork",60003),repoForked:m("repo-forked",60003),gitPullRequest:m("git-pull-request",60004),gitPullRequestAbandoned:m("git-pull-request-abandoned",60004),recordKeys:m("record-keys",60005),keyboard:m("keyboard",60005),tag:m("tag",60006),tagAdd:m("tag-add",60006),tagRemove:m("tag-remove",60006),gitPullRequestLabel:m("git-pull-request-label",60006),person:m("person",60007),personFollow:m("person-follow",60007),personOutline:m("person-outline",60007),personFilled:m("person-filled",60007),gitBranch:m("git-branch",60008),gitBranchCreate:m("git-branch-create",60008),gitBranchDelete:m("git-branch-delete",60008),sourceControl:m("source-control",60008),mirror:m("mirror",60009),mirrorPublic:m("mirror-public",60009),star:m("star",60010),starAdd:m("star-add",60010),starDelete:m("star-delete",60010),starEmpty:m("star-empty",60010),comment:m("comment",60011),commentAdd:m("comment-add",60011),alert:m("alert",60012),warning:m("warning",60012),search:m("search",60013),searchSave:m("search-save",60013),logOut:m("log-out",60014),signOut:m("sign-out",60014),logIn:m("log-in",60015),signIn:m("sign-in",60015),eye:m("eye",60016),eyeUnwatch:m("eye-unwatch",60016),eyeWatch:m("eye-watch",60016),circleFilled:m("circle-filled",60017),primitiveDot:m("primitive-dot",60017),closeDirty:m("close-dirty",60017),debugBreakpoint:m("debug-breakpoint",60017),debugBreakpointDisabled:m("debug-breakpoint-disabled",60017),debugHint:m("debug-hint",60017),primitiveSquare:m("primitive-square",60018),edit:m("edit",60019),pencil:m("pencil",60019),info:m("info",60020),issueOpened:m("issue-opened",60020),gistPrivate:m("gist-private",60021),gitForkPrivate:m("git-fork-private",60021),lock:m("lock",60021),mirrorPrivate:m("mirror-private",60021),close:m("close",60022),removeClose:m("remove-close",60022),x:m("x",60022),repoSync:m("repo-sync",60023),sync:m("sync",60023),clone:m("clone",60024),desktopDownload:m("desktop-download",60024),beaker:m("beaker",60025),microscope:m("microscope",60025),vm:m("vm",60026),deviceDesktop:m("device-desktop",60026),file:m("file",60027),fileText:m("file-text",60027),more:m("more",60028),ellipsis:m("ellipsis",60028),kebabHorizontal:m("kebab-horizontal",60028),mailReply:m("mail-reply",60029),reply:m("reply",60029),organization:m("organization",60030),organizationFilled:m("organization-filled",60030),organizationOutline:m("organization-outline",60030),newFile:m("new-file",60031),fileAdd:m("file-add",60031),newFolder:m("new-folder",60032),fileDirectoryCreate:m("file-directory-create",60032),trash:m("trash",60033),trashcan:m("trashcan",60033),history:m("history",60034),clock:m("clock",60034),folder:m("folder",60035),fileDirectory:m("file-directory",60035),symbolFolder:m("symbol-folder",60035),logoGithub:m("logo-github",60036),markGithub:m("mark-github",60036),github:m("github",60036),terminal:m("terminal",60037),console:m("console",60037),repl:m("repl",60037),zap:m("zap",60038),symbolEvent:m("symbol-event",60038),error:m("error",60039),stop:m("stop",60039),variable:m("variable",60040),symbolVariable:m("symbol-variable",60040),array:m("array",60042),symbolArray:m("symbol-array",60042),symbolModule:m("symbol-module",60043),symbolPackage:m("symbol-package",60043),symbolNamespace:m("symbol-namespace",60043),symbolObject:m("symbol-object",60043),symbolMethod:m("symbol-method",60044),symbolFunction:m("symbol-function",60044),symbolConstructor:m("symbol-constructor",60044),symbolBoolean:m("symbol-boolean",60047),symbolNull:m("symbol-null",60047),symbolNumeric:m("symbol-numeric",60048),symbolNumber:m("symbol-number",60048),symbolStructure:m("symbol-structure",60049),symbolStruct:m("symbol-struct",60049),symbolParameter:m("symbol-parameter",60050),symbolTypeParameter:m("symbol-type-parameter",60050),symbolKey:m("symbol-key",60051),symbolText:m("symbol-text",60051),symbolReference:m("symbol-reference",60052),goToFile:m("go-to-file",60052),symbolEnum:m("symbol-enum",60053),symbolValue:m("symbol-value",60053),symbolRuler:m("symbol-ruler",60054),symbolUnit:m("symbol-unit",60054),activateBreakpoints:m("activate-breakpoints",60055),archive:m("archive",60056),arrowBoth:m("arrow-both",60057),arrowDown:m("arrow-down",60058),arrowLeft:m("arrow-left",60059),arrowRight:m("arrow-right",60060),arrowSmallDown:m("arrow-small-down",60061),arrowSmallLeft:m("arrow-small-left",60062),arrowSmallRight:m("arrow-small-right",60063),arrowSmallUp:m("arrow-small-up",60064),arrowUp:m("arrow-up",60065),bell:m("bell",60066),bold:m("bold",60067),book:m("book",60068),bookmark:m("bookmark",60069),debugBreakpointConditionalUnverified:m("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:m("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:m("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:m("debug-breakpoint-data-unverified",60072),debugBreakpointData:m("debug-breakpoint-data",60073),debugBreakpointDataDisabled:m("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:m("debug-breakpoint-log-unverified",60074),debugBreakpointLog:m("debug-breakpoint-log",60075),debugBreakpointLogDisabled:m("debug-breakpoint-log-disabled",60075),briefcase:m("briefcase",60076),broadcast:m("broadcast",60077),browser:m("browser",60078),bug:m("bug",60079),calendar:m("calendar",60080),caseSensitive:m("case-sensitive",60081),check:m("check",60082),checklist:m("checklist",60083),chevronDown:m("chevron-down",60084),dropDownButton:m("drop-down-button",60084),chevronLeft:m("chevron-left",60085),chevronRight:m("chevron-right",60086),chevronUp:m("chevron-up",60087),chromeClose:m("chrome-close",60088),chromeMaximize:m("chrome-maximize",60089),chromeMinimize:m("chrome-minimize",60090),chromeRestore:m("chrome-restore",60091),circle:m("circle",60092),circleOutline:m("circle-outline",60092),debugBreakpointUnverified:m("debug-breakpoint-unverified",60092),circleSlash:m("circle-slash",60093),circuitBoard:m("circuit-board",60094),clearAll:m("clear-all",60095),clippy:m("clippy",60096),closeAll:m("close-all",60097),cloudDownload:m("cloud-download",60098),cloudUpload:m("cloud-upload",60099),code:m("code",60100),collapseAll:m("collapse-all",60101),colorMode:m("color-mode",60102),commentDiscussion:m("comment-discussion",60103),compareChanges:m("compare-changes",60157),creditCard:m("credit-card",60105),dash:m("dash",60108),dashboard:m("dashboard",60109),database:m("database",60110),debugContinue:m("debug-continue",60111),debugDisconnect:m("debug-disconnect",60112),debugPause:m("debug-pause",60113),debugRestart:m("debug-restart",60114),debugStart:m("debug-start",60115),debugStepInto:m("debug-step-into",60116),debugStepOut:m("debug-step-out",60117),debugStepOver:m("debug-step-over",60118),debugStop:m("debug-stop",60119),debug:m("debug",60120),deviceCameraVideo:m("device-camera-video",60121),deviceCamera:m("device-camera",60122),deviceMobile:m("device-mobile",60123),diffAdded:m("diff-added",60124),diffIgnored:m("diff-ignored",60125),diffModified:m("diff-modified",60126),diffRemoved:m("diff-removed",60127),diffRenamed:m("diff-renamed",60128),diff:m("diff",60129),discard:m("discard",60130),editorLayout:m("editor-layout",60131),emptyWindow:m("empty-window",60132),exclude:m("exclude",60133),extensions:m("extensions",60134),eyeClosed:m("eye-closed",60135),fileBinary:m("file-binary",60136),fileCode:m("file-code",60137),fileMedia:m("file-media",60138),filePdf:m("file-pdf",60139),fileSubmodule:m("file-submodule",60140),fileSymlinkDirectory:m("file-symlink-directory",60141),fileSymlinkFile:m("file-symlink-file",60142),fileZip:m("file-zip",60143),files:m("files",60144),filter:m("filter",60145),flame:m("flame",60146),foldDown:m("fold-down",60147),foldUp:m("fold-up",60148),fold:m("fold",60149),folderActive:m("folder-active",60150),folderOpened:m("folder-opened",60151),gear:m("gear",60152),gift:m("gift",60153),gistSecret:m("gist-secret",60154),gist:m("gist",60155),gitCommit:m("git-commit",60156),gitCompare:m("git-compare",60157),gitMerge:m("git-merge",60158),githubAction:m("github-action",60159),githubAlt:m("github-alt",60160),globe:m("globe",60161),grabber:m("grabber",60162),graph:m("graph",60163),gripper:m("gripper",60164),heart:m("heart",60165),home:m("home",60166),horizontalRule:m("horizontal-rule",60167),hubot:m("hubot",60168),inbox:m("inbox",60169),issueClosed:m("issue-closed",60324),issueReopened:m("issue-reopened",60171),issues:m("issues",60172),italic:m("italic",60173),jersey:m("jersey",60174),json:m("json",60175),bracket:m("bracket",60175),kebabVertical:m("kebab-vertical",60176),key:m("key",60177),law:m("law",60178),lightbulbAutofix:m("lightbulb-autofix",60179),linkExternal:m("link-external",60180),link:m("link",60181),listOrdered:m("list-ordered",60182),listUnordered:m("list-unordered",60183),liveShare:m("live-share",60184),loading:m("loading",60185),location:m("location",60186),mailRead:m("mail-read",60187),mail:m("mail",60188),markdown:m("markdown",60189),megaphone:m("megaphone",60190),mention:m("mention",60191),milestone:m("milestone",60192),gitPullRequestMilestone:m("git-pull-request-milestone",60192),mortarBoard:m("mortar-board",60193),move:m("move",60194),multipleWindows:m("multiple-windows",60195),mute:m("mute",60196),noNewline:m("no-newline",60197),note:m("note",60198),octoface:m("octoface",60199),openPreview:m("open-preview",60200),package:m("package",60201),paintcan:m("paintcan",60202),pin:m("pin",60203),play:m("play",60204),run:m("run",60204),plug:m("plug",60205),preserveCase:m("preserve-case",60206),preview:m("preview",60207),project:m("project",60208),pulse:m("pulse",60209),question:m("question",60210),quote:m("quote",60211),radioTower:m("radio-tower",60212),reactions:m("reactions",60213),references:m("references",60214),refresh:m("refresh",60215),regex:m("regex",60216),remoteExplorer:m("remote-explorer",60217),remote:m("remote",60218),remove:m("remove",60219),replaceAll:m("replace-all",60220),replace:m("replace",60221),repoClone:m("repo-clone",60222),repoForcePush:m("repo-force-push",60223),repoPull:m("repo-pull",60224),repoPush:m("repo-push",60225),report:m("report",60226),requestChanges:m("request-changes",60227),rocket:m("rocket",60228),rootFolderOpened:m("root-folder-opened",60229),rootFolder:m("root-folder",60230),rss:m("rss",60231),ruby:m("ruby",60232),saveAll:m("save-all",60233),saveAs:m("save-as",60234),save:m("save",60235),screenFull:m("screen-full",60236),screenNormal:m("screen-normal",60237),searchStop:m("search-stop",60238),server:m("server",60240),settingsGear:m("settings-gear",60241),settings:m("settings",60242),shield:m("shield",60243),smiley:m("smiley",60244),sortPrecedence:m("sort-precedence",60245),splitHorizontal:m("split-horizontal",60246),splitVertical:m("split-vertical",60247),squirrel:m("squirrel",60248),starFull:m("star-full",60249),starHalf:m("star-half",60250),symbolClass:m("symbol-class",60251),symbolColor:m("symbol-color",60252),symbolCustomColor:m("symbol-customcolor",60252),symbolConstant:m("symbol-constant",60253),symbolEnumMember:m("symbol-enum-member",60254),symbolField:m("symbol-field",60255),symbolFile:m("symbol-file",60256),symbolInterface:m("symbol-interface",60257),symbolKeyword:m("symbol-keyword",60258),symbolMisc:m("symbol-misc",60259),symbolOperator:m("symbol-operator",60260),symbolProperty:m("symbol-property",60261),wrench:m("wrench",60261),wrenchSubaction:m("wrench-subaction",60261),symbolSnippet:m("symbol-snippet",60262),tasklist:m("tasklist",60263),telescope:m("telescope",60264),textSize:m("text-size",60265),threeBars:m("three-bars",60266),thumbsdown:m("thumbsdown",60267),thumbsup:m("thumbsup",60268),tools:m("tools",60269),triangleDown:m("triangle-down",60270),triangleLeft:m("triangle-left",60271),triangleRight:m("triangle-right",60272),triangleUp:m("triangle-up",60273),twitter:m("twitter",60274),unfold:m("unfold",60275),unlock:m("unlock",60276),unmute:m("unmute",60277),unverified:m("unverified",60278),verified:m("verified",60279),versions:m("versions",60280),vmActive:m("vm-active",60281),vmOutline:m("vm-outline",60282),vmRunning:m("vm-running",60283),watch:m("watch",60284),whitespace:m("whitespace",60285),wholeWord:m("whole-word",60286),window:m("window",60287),wordWrap:m("word-wrap",60288),zoomIn:m("zoom-in",60289),zoomOut:m("zoom-out",60290),listFilter:m("list-filter",60291),listFlat:m("list-flat",60292),listSelection:m("list-selection",60293),selection:m("selection",60293),listTree:m("list-tree",60294),debugBreakpointFunctionUnverified:m("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:m("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:m("debug-breakpoint-function-disabled",60296),debugStackframeActive:m("debug-stackframe-active",60297),circleSmallFilled:m("circle-small-filled",60298),debugStackframeDot:m("debug-stackframe-dot",60298),debugStackframe:m("debug-stackframe",60299),debugStackframeFocused:m("debug-stackframe-focused",60299),debugBreakpointUnsupported:m("debug-breakpoint-unsupported",60300),symbolString:m("symbol-string",60301),debugReverseContinue:m("debug-reverse-continue",60302),debugStepBack:m("debug-step-back",60303),debugRestartFrame:m("debug-restart-frame",60304),callIncoming:m("call-incoming",60306),callOutgoing:m("call-outgoing",60307),menu:m("menu",60308),expandAll:m("expand-all",60309),feedback:m("feedback",60310),gitPullRequestReviewer:m("git-pull-request-reviewer",60310),groupByRefType:m("group-by-ref-type",60311),ungroupByRefType:m("ungroup-by-ref-type",60312),account:m("account",60313),gitPullRequestAssignee:m("git-pull-request-assignee",60313),bellDot:m("bell-dot",60314),debugConsole:m("debug-console",60315),library:m("library",60316),output:m("output",60317),runAll:m("run-all",60318),syncIgnored:m("sync-ignored",60319),pinned:m("pinned",60320),githubInverted:m("github-inverted",60321),debugAlt:m("debug-alt",60305),serverProcess:m("server-process",60322),serverEnvironment:m("server-environment",60323),pass:m("pass",60324),stopCircle:m("stop-circle",60325),playCircle:m("play-circle",60326),record:m("record",60327),debugAltSmall:m("debug-alt-small",60328),vmConnect:m("vm-connect",60329),cloud:m("cloud",60330),merge:m("merge",60331),exportIcon:m("export",60332),graphLeft:m("graph-left",60333),magnet:m("magnet",60334),notebook:m("notebook",60335),redo:m("redo",60336),checkAll:m("check-all",60337),pinnedDirty:m("pinned-dirty",60338),passFilled:m("pass-filled",60339),circleLargeFilled:m("circle-large-filled",60340),circleLarge:m("circle-large",60341),circleLargeOutline:m("circle-large-outline",60341),combine:m("combine",60342),gather:m("gather",60342),table:m("table",60343),variableGroup:m("variable-group",60344),typeHierarchy:m("type-hierarchy",60345),typeHierarchySub:m("type-hierarchy-sub",60346),typeHierarchySuper:m("type-hierarchy-super",60347),gitPullRequestCreate:m("git-pull-request-create",60348),runAbove:m("run-above",60349),runBelow:m("run-below",60350),notebookTemplate:m("notebook-template",60351),debugRerun:m("debug-rerun",60352),workspaceTrusted:m("workspace-trusted",60353),workspaceUntrusted:m("workspace-untrusted",60354),workspaceUnspecified:m("workspace-unspecified",60355),terminalCmd:m("terminal-cmd",60356),terminalDebian:m("terminal-debian",60357),terminalLinux:m("terminal-linux",60358),terminalPowershell:m("terminal-powershell",60359),terminalTmux:m("terminal-tmux",60360),terminalUbuntu:m("terminal-ubuntu",60361),terminalBash:m("terminal-bash",60362),arrowSwap:m("arrow-swap",60363),copy:m("copy",60364),personAdd:m("person-add",60365),filterFilled:m("filter-filled",60366),wand:m("wand",60367),debugLineByLine:m("debug-line-by-line",60368),inspect:m("inspect",60369),layers:m("layers",60370),layersDot:m("layers-dot",60371),layersActive:m("layers-active",60372),compass:m("compass",60373),compassDot:m("compass-dot",60374),compassActive:m("compass-active",60375),azure:m("azure",60376),issueDraft:m("issue-draft",60377),gitPullRequestClosed:m("git-pull-request-closed",60378),gitPullRequestDraft:m("git-pull-request-draft",60379),debugAll:m("debug-all",60380),debugCoverage:m("debug-coverage",60381),runErrors:m("run-errors",60382),folderLibrary:m("folder-library",60383),debugContinueSmall:m("debug-continue-small",60384),beakerStop:m("beaker-stop",60385),graphLine:m("graph-line",60386),graphScatter:m("graph-scatter",60387),pieChart:m("pie-chart",60388),bracketDot:m("bracket-dot",60389),bracketError:m("bracket-error",60390),lockSmall:m("lock-small",60391),azureDevops:m("azure-devops",60392),verifiedFilled:m("verified-filled",60393),newLine:m("newline",60394),layout:m("layout",60395),layoutActivitybarLeft:m("layout-activitybar-left",60396),layoutActivitybarRight:m("layout-activitybar-right",60397),layoutPanelLeft:m("layout-panel-left",60398),layoutPanelCenter:m("layout-panel-center",60399),layoutPanelJustify:m("layout-panel-justify",60400),layoutPanelRight:m("layout-panel-right",60401),layoutPanel:m("layout-panel",60402),layoutSidebarLeft:m("layout-sidebar-left",60403),layoutSidebarRight:m("layout-sidebar-right",60404),layoutStatusbar:m("layout-statusbar",60405),layoutMenubar:m("layout-menubar",60406),layoutCentered:m("layout-centered",60407),layoutSidebarRightOff:m("layout-sidebar-right-off",60416),layoutPanelOff:m("layout-panel-off",60417),layoutSidebarLeftOff:m("layout-sidebar-left-off",60418),target:m("target",60408),indent:m("indent",60409),recordSmall:m("record-small",60410),errorSmall:m("error-small",60411),arrowCircleDown:m("arrow-circle-down",60412),arrowCircleLeft:m("arrow-circle-left",60413),arrowCircleRight:m("arrow-circle-right",60414),arrowCircleUp:m("arrow-circle-up",60415),heartFilled:m("heart-filled",60420),map:m("map",60421),mapFilled:m("map-filled",60422),circleSmall:m("circle-small",60423),bellSlash:m("bell-slash",60424),bellSlashDot:m("bell-slash-dot",60425),commentUnresolved:m("comment-unresolved",60426),gitPullRequestGoToChanges:m("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:m("git-pull-request-new-changes",60428),searchFuzzy:m("search-fuzzy",60429),commentDraft:m("comment-draft",60430),send:m("send",60431),sparkle:m("sparkle",60432),insert:m("insert",60433),mic:m("mic",60434),thumbsDownFilled:m("thumbsdown-filled",60435),thumbsUpFilled:m("thumbsup-filled",60436),coffee:m("coffee",60437),snake:m("snake",60438),game:m("game",60439),vr:m("vr",60440),chip:m("chip",60441),piano:m("piano",60442),music:m("music",60443),micFilled:m("mic-filled",60444),gitFetch:m("git-fetch",60445),copilot:m("copilot",60446),lightbulbSparkle:m("lightbulb-sparkle",60447),lightbulbSparkleAutofix:m("lightbulb-sparkle-autofix",60447),robot:m("robot",60448),sparkleFilled:m("sparkle-filled",60449),diffSingle:m("diff-single",60450),diffMultiple:m("diff-multiple",60451),dialogError:m("dialog-error","error"),dialogWarning:m("dialog-warning","warning"),dialogInfo:m("dialog-info","info"),dialogClose:m("dialog-close","close"),treeItemExpanded:m("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:m("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:m("tree-filter-on-type-off","list-selection"),treeFilterClear:m("tree-filter-clear","close"),treeItemLoading:m("tree-item-loading","loading"),menuSelection:m("menu-selection","check"),menuSubmenu:m("menu-submenu","chevron-right"),menuBarMore:m("menubar-more","more"),scrollbarButtonLeft:m("scrollbar-button-left","triangle-left"),scrollbarButtonRight:m("scrollbar-button-right","triangle-right"),scrollbarButtonUp:m("scrollbar-button-up","triangle-up"),scrollbarButtonDown:m("scrollbar-button-down","triangle-down"),toolBarMore:m("toolbar-more","more"),quickInputBack:m("quick-input-back","arrow-left")}}),define(ye[24],Ce([1,0,18]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function N(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?N(o):o}),i}e.deepClone=N;function m(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(k.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.isTypedArray)(a)&&i.push(a)}}return s}e.deepFreeze=m;const k=Object.prototype.hasOwnProperty;function R(s,i){return v(s,i,new Set)}e.cloneAndChange=R;function v(s,i,n){if((0,D.isUndefinedOrNull)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(v(t,i,n));return a}if((0,D.isObject)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)k.call(s,t)&&(a[t]=v(s[t],i,n));return n.delete(s),a}return s}function p(s,i,n=!0){return(0,D.isObject)(s)?((0,D.isObject)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,D.isObject)(s[o])&&(0,D.isObject)(i[o])?p(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.mixin=p;function S(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!S(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!S(a,t))return!1;for(n=0;n<a.length;n++)if(!S(s[a[n]],i[a[n]]))return!1}return!0}e.equals=S;function L(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,D.isObject)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.safeStringify=L;function I(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];S(t,r)||(n[a]=r)}),n}e.distinct=I;function g(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.getCaseInsensitive=g;function w(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.filter=w;function C(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.getAllPropertyNames=C;function l(s){const i=[];for(const n of C(s))typeof s[n]=="function"&&i.push(n);return i}e.getAllMethodNames=l;function f(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.createProxyObject=f}),define(ye[61],Ce([1,0,78]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var N;(function(R){function v(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=v})(N||(e.ThemeColor=N={}));function m(R){return{id:R}}e.themeColorFromId=m;var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(i){const n=v.exec(i.id);if(!n)return p(D.Codicon.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=p;function S(i){return p(i).join(" ")}R.asClassName=S;function L(i){return"."+p(i).join(".")}R.asCSSSelector=L;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}R.isThemeIcon=I;const g=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(i){const n=g.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=w;function C(i){return{id:i}}R.fromId=C;function l(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}R.modify=l;function f(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=f;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(k||(e.ThemeIcon=k={}))}),define(ye[164],Ce([1,0,123,13,61]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const k="$(",R=new RegExp(`\\$\\(${m.ThemeIcon.iconNameExpression}(?:${m.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${R.source}`,"g");function p(s){return s.replace(v,(i,n)=>n?i:`\\${i}`)}e.escapeIcons=p;const S=new RegExp(`\\\\${R.source}`,"g");function L(s){return s.replace(S,i=>`\\${i}`)}e.markdownEscapeEscapedIcons=L;const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function g(s){return s.indexOf(k)===-1?s:s.replace(I,(i,n,o,a)=>o?i:n||a||"")}e.stripIcons=g;function w(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=w;const C=new RegExp(`\\$\\(${m.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(s){C.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=C.lastIndex,t=C.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let h=0;h<r.length;h++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.parseLabelWithIcons=l;function f(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.matchesFuzzy)(s,o,n);const t=(0,N.ltrim)(o," "),r=o.length-t.length,h=(0,D.matchesFuzzy)(s,t,n);if(h)for(const u of h){const c=a[u.start+r]+r;u.start+=c,u.end+=c}return h}e.matchesFuzzyIconAware=f}),define(ye[124],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var D;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function N(k){return k<0?0:k>255?255:k|0}e.toUint8=N;function m(k){return k<0?0:k>4294967295?4294967295:k|0}e.toUint32=m}),define(ye[30],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(m){return D.test(m)}e.isUUID=N,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let m;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?m=crypto.getRandomValues.bind(crypto):m=function(v){for(let p=0;p<v.length;p++)v[p]=Math.floor(Math.random()*256);return v};const k=new Uint8Array(16),R=[];for(let v=0;v<256;v++)R.push(v.toString(16).padStart(2,"0"));return function(){m(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let p=0,S="";return S+=R[k[p++]],S+=R[k[p++]],S+=R[k[p++]],S+=R[k[p++]],S+="-",S+=R[k[p++]],S+=R[k[p++]],S+="-",S+=R[k[p++]],S+=R[k[p++]],S+="-",S+=R[k[p++]],S+=R[k[p++]],S+="-",S+=R[k[p++]],S+=R[k[p++]],S+=R[k[p++]],S+=R[k[p++]],S+=R[k[p++]],S+=R[k[p++]],S}}()}),define(ye[165],Ce([1,0,19,52,30]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.createStringDataTransferItem=k;function R(I,g,w){const C={id:(0,m.generateUuid)(),name:I,uri:g,data:w};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.createFileDataTransferItem=R;class v{constructor(){this._entries=new Map}get size(){let g=0;for(const w of this._entries)g++;return g}has(g){return this._entries.has(this.toKey(g))}matches(g){const w=[...this._entries.keys()];return N.Iterable.some(this,([C,l])=>l.asFile())&&w.push("files"),L(p(g),w)}get(g){return this._entries.get(this.toKey(g))?.[0]}append(g,w){const C=this._entries.get(g);C?C.push(w):this._entries.set(this.toKey(g),[w])}replace(g,w){this._entries.set(this.toKey(g),[w])}delete(g){this._entries.delete(this.toKey(g))}*[Symbol.iterator](){for(const[g,w]of this._entries)for(const C of w)yield[g,C]}toKey(g){return p(g)}}e.VSDataTransfer=v;function p(I){return I.toLowerCase()}function S(I,g){return L(p(I),g.map(p))}e.matchesMimeType=S;function L(I,g){if(I==="*/*")return g.length>0;if(g.includes(I))return!0;const w=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[C,l,f]=w;return f==="*"?g.some(s=>s.startsWith(l+"/")):!1}e.UriList=Object.freeze({create:I=>(0,D.distinct)(I.map(g=>g.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.UriList.split(I).filter(g=>!g.startsWith("#"))})}),define(ye[166],Ce([1,0,62]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function N(v,p,S,L=1){let I=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!I)return I=!0,g(0)},S);m(v,p,L,C=>{if(!I)return I=!0,clearTimeout(w),g(C)})})}e.findFreePort=N;function m(v,p,S,L){if(p===0)return L(0);const I=new D.Socket;I.once("connect",()=>(R(I),m(v+S,p-1,S,L))),I.once("data",()=>{}),I.once("error",g=>(R(I),g.code!=="ECONNREFUSED"?m(v+S,p-1,S,L):L(v))),I.connect(v,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(v,p,S,L="127.0.0.1"){let I=!1,g,w=1;const C=D.createServer({pauseOnConnect:!0});function l(f,s){I||(I=!0,C.removeAllListeners(),C.close(),g&&clearTimeout(g),s(f))}return new Promise(f=>{g=setTimeout(()=>{l(0,f)},S),C.on("listening",()=>{l(v,f)}),C.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&w<p?(v++,w++,C.listen(v,L)):l(0,f)}),C.on("close",()=>{l(0,f)}),C.listen(v,L)})}e.findFreePortFaster=k;function R(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch(p){console.error(p)}}}),define(ye[125],Ce([1,0,124]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class N{constructor(v){const p=(0,D.toUint8)(v);this._defaultValue=p,this._asciiMap=N._createAsciiMap(p),this._map=new Map}static _createAsciiMap(v){const p=new Uint8Array(256);return p.fill(v),p}set(v,p){const S=(0,D.toUint8)(p);v>=0&&v<256?this._asciiMap[v]=S:this._map.set(v,S)}get(v){return v>=0&&v<256?this._asciiMap[v]:this._map.get(v)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=N;var m;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(m||(m={}));class k{constructor(){this._actual=new N(0)}add(v){this._actual.set(v,1)}has(v){return this._actual.get(v)===1}clear(){return this._actual.clear()}}e.CharacterSet=k}),define(ye[167],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var D;(function(m){m[m.Unknown=0]="Unknown",m[m.Invalid=3]="Invalid",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function N(m){let k=0,R=0,v=0,p=0;for(let S=0,L=m.length;S<L;S++){const I=m.charCodeAt(S);I===13?(k===0&&(R=S),k++,S+1<L&&m.charCodeAt(S+1)===10?(p|=2,S++):p|=3,v=S+1):I===10&&(p|=1,k===0&&(R=S),k++,v=S+1)}return k===0&&(R=m.length),[k,R,m.length-v,p]}e.countEOL=N}),define(ye[49],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class D{constructor(m,k){this.lineNumber=m,this.column=k}with(m=this.lineNumber,k=this.column){return m===this.lineNumber&&k===this.column?this:new D(m,k)}delta(m=0,k=0){return this.with(this.lineNumber+m,this.column+k)}equals(m){return D.equals(this,m)}static equals(m,k){return!m&&!k?!0:!!m&&!!k&&m.lineNumber===k.lineNumber&&m.column===k.column}isBefore(m){return D.isBefore(this,m)}static isBefore(m,k){return m.lineNumber<k.lineNumber?!0:k.lineNumber<m.lineNumber?!1:m.column<k.column}isBeforeOrEqual(m){return D.isBeforeOrEqual(this,m)}static isBeforeOrEqual(m,k){return m.lineNumber<k.lineNumber?!0:k.lineNumber<m.lineNumber?!1:m.column<=k.column}static compare(m,k){const R=m.lineNumber|0,v=k.lineNumber|0;if(R===v){const p=m.column|0,S=k.column|0;return p-S}return R-v}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(m){return new D(m.lineNumber,m.column)}static isIPosition(m){return m&&typeof m.lineNumber=="number"&&typeof m.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=D}),define(ye[29],Ce([1,0,49]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class N{constructor(k,R,v,p){k>v||k===v&&R>p?(this.startLineNumber=v,this.startColumn=p,this.endLineNumber=k,this.endColumn=R):(this.startLineNumber=k,this.startColumn=R,this.endLineNumber=v,this.endColumn=p)}isEmpty(){return N.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return N.containsPosition(this,k)}static containsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<k.startColumn||R.lineNumber===k.endLineNumber&&R.column>k.endColumn)}static strictContainsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<=k.startColumn||R.lineNumber===k.endLineNumber&&R.column>=k.endColumn)}containsRange(k){return N.containsRange(this,k)}static containsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>k.endColumn)}strictContainsRange(k){return N.strictContainsRange(this,k)}static strictContainsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<=k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>=k.endColumn)}plusRange(k){return N.plusRange(this,k)}static plusRange(k,R){let v,p,S,L;return R.startLineNumber<k.startLineNumber?(v=R.startLineNumber,p=R.startColumn):R.startLineNumber===k.startLineNumber?(v=R.startLineNumber,p=Math.min(R.startColumn,k.startColumn)):(v=k.startLineNumber,p=k.startColumn),R.endLineNumber>k.endLineNumber?(S=R.endLineNumber,L=R.endColumn):R.endLineNumber===k.endLineNumber?(S=R.endLineNumber,L=Math.max(R.endColumn,k.endColumn)):(S=k.endLineNumber,L=k.endColumn),new N(v,p,S,L)}intersectRanges(k){return N.intersectRanges(this,k)}static intersectRanges(k,R){let v=k.startLineNumber,p=k.startColumn,S=k.endLineNumber,L=k.endColumn;const I=R.startLineNumber,g=R.startColumn,w=R.endLineNumber,C=R.endColumn;return v<I?(v=I,p=g):v===I&&(p=Math.max(p,g)),S>w?(S=w,L=C):S===w&&(L=Math.min(L,C)),v>S||v===S&&p>L?null:new N(v,p,S,L)}equalsRange(k){return N.equalsRange(this,k)}static equalsRange(k,R){return!k&&!R?!0:!!k&&!!R&&k.startLineNumber===R.startLineNumber&&k.startColumn===R.startColumn&&k.endLineNumber===R.endLineNumber&&k.endColumn===R.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(k){return new D.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(k){return new D.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,R){return new N(this.startLineNumber,this.startColumn,k,R)}setStartPosition(k,R){return new N(k,R,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(k){return new N(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(k){return new N(k.endLineNumber,k.endColumn,k.endLineNumber,k.endColumn)}delta(k){return new N(this.startLineNumber+k,this.startColumn,this.endLineNumber+k,this.endColumn)}static fromPositions(k,R=k){return new N(k.lineNumber,k.column,R.lineNumber,R.column)}static lift(k){return k?new N(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn)}static areIntersecting(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,R){if(k&&R){const S=k.startLineNumber|0,L=R.startLineNumber|0;if(S===L){const I=k.startColumn|0,g=R.startColumn|0;if(I===g){const w=k.endLineNumber|0,C=R.endLineNumber|0;if(w===C){const l=k.endColumn|0,f=R.endColumn|0;return l-f}return w-C}return I-g}return S-L}return(k?1:0)-(R?1:0)}static compareRangesUsingEnds(k,R){return k.endLineNumber===R.endLineNumber?k.endColumn===R.endColumn?k.startLineNumber===R.startLineNumber?k.startColumn-R.startColumn:k.startLineNumber-R.startLineNumber:k.endColumn-R.endColumn:k.endLineNumber-R.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}toJSON(){return this}}e.Range=N}),define(ye[168],Ce([1,0,29]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class N{static insert(k,R){return{range:new D.Range(k.lineNumber,k.column,k.lineNumber,k.column),text:R,forceMoveMarkers:!0}}static delete(k){return{range:k,text:null}}static replace(k,R){return{range:k,text:R}}static replaceMove(k,R){return{range:k,text:R,forceMoveMarkers:!0}}}e.EditOperation=N}),define(ye[169],Ce([1,0,49,29]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var m;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(m||(e.SelectionDirection=m={}));class k extends N.Range{constructor(v,p,S,L){super(v,p,S,L),this.selectionStartLineNumber=v,this.selectionStartColumn=p,this.positionLineNumber=S,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return k.selectionsEqual(this,v)}static selectionsEqual(v,p){return v.selectionStartLineNumber===p.selectionStartLineNumber&&v.selectionStartColumn===p.selectionStartColumn&&v.positionLineNumber===p.positionLineNumber&&v.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,p){return this.getDirection()===0?new k(this.startLineNumber,this.startColumn,v,p):new k(v,p,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,p){return this.getDirection()===0?new k(v,p,this.endLineNumber,this.endColumn):new k(this.endLineNumber,this.endColumn,v,p)}static fromPositions(v,p=v){return new k(v.lineNumber,v.column,p.lineNumber,p.column)}static fromRange(v,p){return p===0?new k(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new k(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new k(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,p){if(v&&!p||!v&&p)return!1;if(!v&&!p)return!0;if(v.length!==p.length)return!1;for(let S=0,L=v.length;S<L;S++)if(!this.selectionsEqual(v[S],p[S]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,p,S,L,I){return I===0?new k(v,p,S,L):new k(S,L,v,p)}}e.Selection=k}),define(ye[170],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[171],Ce([1,0,125]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var N;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class m extends D.CharacterClassifier{constructor(v){super(0);for(let p=0,S=v.length;p<S;p++)this.set(v.charCodeAt(p),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=m;function k(R){const v={};return p=>(v.hasOwnProperty(p)||(v[p]=R(p)),v[p])}e.getMapForWordSeparators=k(R=>new m(R))}),define(ye[126],Ce([1,0,52,3,75]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function k(I=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const w of e.USUAL_WORD_SEPARATORS)I.indexOf(w)>=0||(g+="\\"+w);return g+="\\s]+)",new RegExp(g,"g")}e.DEFAULT_WORD_REGEXP=k();function R(I){let g=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)g=I;else{let w="g";I.ignoreCase&&(w+="i"),I.multiline&&(w+="m"),I.unicode&&(w+="u"),g=new RegExp(I.source,w)}return g.lastIndex=0,g}e.ensureValidWordDefinition=R;const v=new m.LinkedList;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(I){const g=v.unshift(I);return(0,N.toDisposable)(g)}e.setDefaultGetWordAtTextConfig=p;function S(I,g,w,C,l){if(g=R(g),l||(l=D.Iterable.first(v)),w.length>l.maxLen){let o=I-l.maxLen/2;return o<0?o=0:C+=o,w=w.substring(o,I+l.maxLen/2),S(I,g,w,C,l)}const f=Date.now(),s=I-1-C;let i=-1,n=null;for(let o=1;!(Date.now()-f>=l.timeBudget);o++){const a=s-l.windowSize*o;g.lastIndex=Math.max(0,a);const t=L(g,w,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:C+1+n.index,endColumn:C+1+n.index+n[0].length};return g.lastIndex=0,o}return null}e.getWordAtText=S;function L(I,g,w,C){let l;for(;l=I.exec(g);){const f=l.index||0;if(f<=w&&I.lastIndex>=w)return l;if(C>0&&f>C)return null}return null}}),define(ye[172],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class N{constructor(v){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=v.open,this.close=v.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(v.notIn))for(let p=0,S=v.notIn.length;p<S;p++)switch(v.notIn[p]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(v){switch(v){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(v,p){if(v.getTokenCount()===0)return!0;const S=v.findTokenIndexAtOffset(p-2),L=v.getStandardTokenType(S);return this.isOK(L)}_findNeutralCharacterInRange(v,p){for(let S=v;S<=p;S++){const L=String.fromCharCode(S);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=N;class m{constructor(v){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of v)k(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),k(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),k(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),k(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&k(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.AutoClosingPairs=m;function k(R,v,p){R.has(v)?R.get(v).push(p):R.set(v,[p])}}),define(ye[173],Ce([1,0,125]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var N;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class m{constructor(C,l,f){const s=new Uint8Array(C*l);for(let i=0,n=C*l;i<n;i++)s[i]=f;this._data=s,this.rows=C,this.cols=l}get(C,l){return this._data[C*this.cols+l]}set(C,l,f){this._data[C*this.cols+l]=f}}class k{constructor(C){let l=0,f=0;for(let i=0,n=C.length;i<n;i++){const[o,a,t]=C[i];a>l&&(l=a),o>f&&(f=o),t>f&&(f=t)}l++,f++;const s=new m(f,l,0);for(let i=0,n=C.length;i<n;i++){const[o,a,t]=C[i];s.set(o,a,t)}this._states=s,this._maxCharCode=l}nextState(C,l){return l<0||l>=this._maxCharCode?0:this._states.get(C,l)}}e.StateMachine=k;let R=null;function v(){return R===null&&(R=new k([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var p;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let S=null;function L(){if(S===null){S=new D.CharacterClassifier(0);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<w.length;l++)S.set(w.charCodeAt(l),1);const C=".,;:";for(let l=0;l<C.length;l++)S.set(C.charCodeAt(l),2)}return S}class I{static _createLink(C,l,f,s,i){let n=i-1;do{const o=l.charCodeAt(n);if(C.get(o)!==2)break;n--}while(n>s);if(s>0){const o=l.charCodeAt(s-1),a=l.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:f,startColumn:s+1,endLineNumber:f,endColumn:n+2},url:l.substring(s,n+1)}}static computeLinks(C,l=v()){const f=L(),s=[];for(let i=1,n=C.getLineCount();i<=n;i++){const o=C.getLineContent(i),a=o.length;let t=0,r=0,h=0,u=1,c=!1,d=!1,y=!1,A=!1;for(;t<a;){let E=!1;const b=o.charCodeAt(t);if(u===13){let _;switch(b){case 40:c=!0,_=0;break;case 41:_=c?0:1;break;case 91:y=!0,d=!0,_=0;break;case 93:y=!1,_=d?0:1;break;case 123:A=!0,_=0;break;case 125:_=A?0:1;break;case 39:case 34:case 96:h===b?_=1:h===39||h===34||h===96?_=0:_=1;break;case 42:_=h===42?1:0;break;case 124:_=h===124?1:0;break;case 32:_=y?0:1;break;default:_=f.get(b)}_===1&&(s.push(I._createLink(f,o,i,r,t)),E=!0)}else if(u===12){let _;b===91?(d=!0,_=0):_=f.get(b),_===1?E=!0:u=13}else u=l.nextState(u,b),u===0&&(E=!0);E&&(u=1,c=!1,d=!1,A=!1,r=t+1,h=b),t++}u===13&&s.push(I._createLink(f,o,i,r,a))}return s}}e.LinkComputer=I;function g(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:I.computeLinks(w)}e.computeLinks=g}),define(ye[79],Ce([1,0,24]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var m;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(m||(e.GlyphMarginLane=m={}));var k;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(k||(e.MinimapPosition=k={}));var R;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var v;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var p;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(p||(e.DefaultEndOfLine=p={}));var S;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(S||(e.EndOfLineSequence=S={}));class L{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,a.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this._indentSizeIsTabSize===a._indentSizeIsTabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=L;class I{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.FindMatch=I;var g;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(g||(e.TrackedRangeStickiness=g={}));function w(o){return o&&typeof o.read=="function"}e.isITextSnapshot=w;var C;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var l;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class f{constructor(a,t,r,h,u,c){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.ValidAnnotatedEditOperation=f;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.SearchData=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.ApplyEditsResult=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.shouldSynchronizeModel=n}),define(ye[174],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.recomputeTreeMetadata=e.updateTreeMetadata=e.fixInsert=e.rbDelete=e.rightRotate=e.leftRotate=e.righttest=e.leftest=e.SENTINEL=e.NodeColor=e.TreeNode=void 0;class D{constructor(f,s){this.piece=f,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return m(this.right);let f=this;for(;f.parent!==e.SENTINEL&&f.parent.left!==f;)f=f.parent;return f.parent===e.SENTINEL?e.SENTINEL:f.parent}prev(){if(this.left!==e.SENTINEL)return k(this.left);let f=this;for(;f.parent!==e.SENTINEL&&f.parent.right!==f;)f=f.parent;return f.parent===e.SENTINEL?e.SENTINEL:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=D;var N;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(N||(e.NodeColor=N={})),e.SENTINEL=new D(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function m(l){for(;l.left!==e.SENTINEL;)l=l.left;return l}e.leftest=m;function k(l){for(;l.right!==e.SENTINEL;)l=l.right;return l}e.righttest=k;function R(l){return l===e.SENTINEL?0:l.size_left+l.piece.length+R(l.right)}function v(l){return l===e.SENTINEL?0:l.lf_left+l.piece.lineFeedCnt+v(l.right)}function p(){e.SENTINEL.parent=e.SENTINEL}function S(l,f){const s=f.right;s.size_left+=f.size_left+(f.piece?f.piece.length:0),s.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=s.left,s.left!==e.SENTINEL&&(s.left.parent=f),s.parent=f.parent,f.parent===e.SENTINEL?l.root=s:f.parent.left===f?f.parent.left=s:f.parent.right=s,s.left=f,f.parent=s}e.leftRotate=S;function L(l,f){const s=f.left;f.left=s.right,s.right!==e.SENTINEL&&(s.right.parent=f),s.parent=f.parent,f.size_left-=s.size_left+(s.piece?s.piece.length:0),f.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),f.parent===e.SENTINEL?l.root=s:f===f.parent.right?f.parent.right=s:f.parent.left=s,s.right=f,f.parent=s}e.rightRotate=L;function I(l,f){let s,i;if(f.left===e.SENTINEL?(i=f,s=i.right):f.right===e.SENTINEL?(i=f,s=i.left):(i=m(f.right),s=i.right),i===l.root){l.root=s,s.color=0,f.detach(),p(),l.root.parent=e.SENTINEL;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===f?(s.parent=i.parent,C(l,s)):(i.parent===f?s.parent=i:s.parent=i.parent,C(l,s),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===l.root?l.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.SENTINEL&&(i.left.parent=i),i.right!==e.SENTINEL&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,C(l,i)),f.detach(),s.parent.left===s){const a=R(s),t=v(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,h=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,w(l,s.parent,r,h)}}if(C(l,s.parent),n){p();return}let o;for(;s!==l.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,S(l,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,L(l,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,S(l,s.parent),s=l.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,L(l,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,S(l,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,L(l,s.parent),s=l.root));s.color=0,p()}e.rbDelete=I;function g(l,f){for(C(l,f);f!==l.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const s=f.parent.parent.right;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,S(l,f)),f.parent.color=0,f.parent.parent.color=1,L(l,f.parent.parent))}else{const s=f.parent.parent.left;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,L(l,f)),f.parent.color=0,f.parent.parent.color=1,S(l,f.parent.parent))}l.root.color=0}e.fixInsert=g;function w(l,f,s,i){for(;f!==l.root&&f!==e.SENTINEL;)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}e.updateTreeMetadata=w;function C(l,f){let s=0,i=0;if(f!==l.root){for(;f!==l.root&&f===f.parent.right;)f=f.parent;if(f!==l.root)for(f=f.parent,s=R(f.left)-f.size_left,i=v(f.left)-f.lf_left,f.size_left+=s,f.lf_left+=i;f!==l.root&&(s!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}}e.recomputeTreeMetadata=C}),define(ye[175],Ce([1,0,19,124]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class m{constructor(p){this.values=p,this.prefixSum=new Uint32Array(p.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(p,S){p=(0,N.toUint32)(p);const L=this.values,I=this.prefixSum,g=S.length;return g===0?!1:(this.values=new Uint32Array(L.length+g),this.values.set(L.subarray(0,p),0),this.values.set(L.subarray(p),p+g),this.values.set(S,p),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(p,S){return p=(0,N.toUint32)(p),S=(0,N.toUint32)(S),this.values[p]===S?!1:(this.values[p]=S,p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),!0)}removeValues(p,S){p=(0,N.toUint32)(p),S=(0,N.toUint32)(S);const L=this.values,I=this.prefixSum;if(p>=L.length)return!1;const g=L.length-p;return S>=g&&(S=g),S===0?!1:(this.values=new Uint32Array(L.length-S),this.values.set(L.subarray(0,p),0),this.values.set(L.subarray(p+S),p),this.prefixSum=new Uint32Array(this.values.length),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(p){return p<0?0:(p=(0,N.toUint32)(p),this._getPrefixSum(p))}_getPrefixSum(p){if(p<=this.prefixSumValidIndex[0])return this.prefixSum[p];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),p>=this.values.length&&(p=this.values.length-1);for(let L=S;L<=p;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],p),this.prefixSum[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let S=0,L=this.values.length-1,I=0,g=0,w=0;for(;S<=L;)if(I=S+(L-S)/2|0,g=this.prefixSum[I],w=g-this.values[I],p<w)L=I-1;else if(p>=g)S=I+1;else break;return new R(I,p-w)}}e.PrefixSumComputer=m;class k{constructor(p){this._values=p,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(p){return this._ensureValid(),p===0?0:this._prefixSum[p-1]}getIndexOf(p){this._ensureValid();const S=this._indexBySum[p],L=S>0?this._prefixSum[S-1]:0;return new R(S,p-L)}removeValues(p,S){this._values.splice(p,S),this._invalidate(p)}insertValues(p,S){this._values=(0,D.arrayInsert)(this._values,p,S),this._invalidate(p)}_invalidate(p){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,p-1)}_ensureValid(){if(!this._isValid){for(let p=this._validEndIndex+1,S=this._values.length;p<S;p++){const L=this._values[p],I=p>0?this._prefixSum[p-1]:0;this._prefixSum[p]=I+L;for(let g=0;g<L;g++)this._indexBySum[I+g]=p}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(p,S){this._values[p]!==S&&(this._values[p]=S,this._invalidate(p))}}e.ConstantTimePrefixSumComputer=k;class R{constructor(p,S){this.index=p,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=S}}e.PrefixSumIndexOfResult=R}),define(ye[176],Ce([1,0,13,49,175]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class k{constructor(v,p,S,L){this._uri=v,this._lines=p,this._eol=S,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(v){v.eol&&v.eol!==this._eol&&(this._eol=v.eol,this._lineStarts=null);const p=v.changes;for(const S of p)this._acceptDeleteRange(S.range),this._acceptInsertText(new N.Position(S.range.startLineNumber,S.range.startColumn),S.text);this._versionId=v.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const v=this._eol.length,p=this._lines.length,S=new Uint32Array(p);for(let L=0;L<p;L++)S[L]=this._lines[L].length+v;this._lineStarts=new m.PrefixSumComputer(S)}}_setLineText(v,p){this._lines[v]=p,this._lineStarts&&this._lineStarts.setValue(v,this._lines[v].length+this._eol.length)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.startLineNumber-1].substring(v.endColumn-1));return}this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.endLineNumber-1].substring(v.endColumn-1)),this._lines.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}_acceptInsertText(v,p){if(p.length===0)return;const S=(0,D.splitLines)(p);if(S.length===1){this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+S[0]+this._lines[v.lineNumber-1].substring(v.column-1));return}S[S.length-1]+=this._lines[v.lineNumber-1].substring(v.column-1),this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+S[0]);const L=new Uint32Array(S.length-1);for(let I=1;I<S.length;I++)this._lines.splice(v.lineNumber+I-1,0,S[I]),L[I-1]=S[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(v.lineNumber,L)}}e.MirrorTextModel=k}),define(ye[99],Ce([1,0,13,171,49,29,79]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const v=999;class p{constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=S(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R.SearchData(n,this.wordSeparators?(0,N.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=p;function S(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.isMultilineRegexSource=S;function L(s,i,n){if(!n)return new R.FindMatch(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new R.FindMatch(s,o)}e.createFindMatch=L;class I{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this._lineFeedsOffsets=n}findLineFeedCountBeforeOffset(i){const n=this._lineFeedsOffsets;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class g{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(i,o,new f(r.wordSeparators,r.regex),a,t):this._doFindMatchesLineByLine(i,o,r,a,t):[]}static _getMultilineMatchRange(i,n,o,a,t,r){let h,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),h=n+t+u):h=n+t;let c;if(a){const E=a.findLineFeedCountBeforeOffset(t+r.length)-u;c=h+r.length+E}else c=h+r.length;const d=i.getPositionAt(h),y=i.getPositionAt(c);return new k.Range(d.lineNumber,d.column,y.lineNumber,y.column)}static _doFindMatchesMultiline(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),h=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new I(h):null,c=[];let d=0,y;for(o.reset(0);y=o.next(h);)if(c[d++]=L(this._getMultilineMatchRange(i,r,h,u,y.index,y[0]),y,a),d>=t)return c;return c}static _doFindMatchesLineByLine(i,n,o,a,t){const r=[];let h=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return h=this._findMatchesInLine(o,c,n.startLineNumber,n.startColumn-1,h,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);h=this._findMatchesInLine(o,u,n.startLineNumber,n.startColumn-1,h,r,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&h<t;c++)h=this._findMatchesInLine(o,i.getLineContent(c),c,0,h,r,a,t);if(h<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);h=this._findMatchesInLine(o,c,n.endLineNumber,0,h,r,a,t)}return r}static _findMatchesInLine(i,n,o,a,t,r,h,u){const c=i.wordSeparators;if(!h&&i.simpleSearch){const A=i.simpleSearch,E=A.length,b=n.length;let _=-E;for(;(_=n.indexOf(A,_+E))!==-1;)if((!c||l(c,n,b,_,E))&&(r[t++]=new R.FindMatch(new k.Range(o,_+1+a,o,_+1+E+a),null),t>=u))return t;return t}const d=new f(i.wordSeparators,i.regex);let y;d.reset(0);do if(y=d.next(n),y&&(r[t++]=L(new k.Range(o,y.index+1+a,o,y.index+1+y[0].length+a),y,h),t>=u))return t;while(y);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(i,o,r,a):this._doFindNextMatchLineByLine(i,o,r,a)}static _doFindNextMatchMultiline(i,n,o,a){const t=new m.Position(n.lineNumber,1),r=i.getOffsetAt(t),h=i.getLineCount(),u=i.getValueInRange(new k.Range(t.lineNumber,t.column,h,i.getLineMaxColumn(h)),1),c=i.getEOL()===`\r
`?new I(u):null;o.reset(n.column-1);const d=o.next(u);return d?L(this._getMultilineMatchRange(i,r,u,c,d.index,d[0]),d,a):n.lineNumber!==1||n.column!==1?this._doFindNextMatchMultiline(i,new m.Position(1,1),o,a):null}static _doFindNextMatchLineByLine(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r),u=this._findFirstMatchInLine(o,h,r,n.column,a);if(u)return u;for(let c=1;c<=t;c++){const d=(r+c-1)%t,y=i.getLineContent(d+1),A=this._findFirstMatchInLine(o,y,d+1,1,a);if(A)return A}return null}static _findFirstMatchInLine(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?L(new k.Range(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(i,o,r,a):this._doFindPreviousMatchLineByLine(i,o,r,a)}static _doFindPreviousMatchMultiline(i,n,o,a){const t=this._doFindMatchesMultiline(i,new k.Range(1,1,n.lineNumber,n.column),o,a,10*v);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(i,new m.Position(r,i.getLineMaxColumn(r)),o,a):null}static _doFindPreviousMatchLineByLine(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r).substring(0,n.column-1),u=this._findLastMatchInLine(o,h,r,a);if(u)return u;for(let c=1;c<=t;c++){const d=(t+r-c-1)%t,y=i.getLineContent(d+1),A=this._findLastMatchInLine(o,y,d+1,a);if(A)return A}return null}static _findLastMatchInLine(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=L(new k.Range(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.TextModelSearch=g;function w(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function C(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function l(s,i,n,o,a){return w(s,i,n,o,a)&&C(s,i,n,o,a)}e.isValidMatch=l;class f{constructor(i,n){this._wordSeparators=i,this._searchRegex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(i){this._searchRegex.lastIndex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(i){const n=i.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===n||(o=this._searchRegex.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){D.getNextCodePoint(i,n,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=t,!this._wordSeparators||l(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.Searcher=f}),define(ye[127],Ce([1,0,49,29,79,174,99]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=e.createLineStarts=e.createLineStartsFast=void 0;const v=65535;function p(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class S{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function L(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?p(n):n}e.createLineStartsFast=L;function I(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let u=0,c=i.length;u<c;u++){const d=i.charCodeAt(u);d===13?u+1<c&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):d===10?(a++,s[n++]=u+1):r&&d!==9&&(d<32||d>126)&&(r=!1)}const h=new S(p(s),o,a,t,r);return s.length=0,h}e.createLineStarts=I;class g{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.Piece=g;class w{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.StringBuffer=w;class C{constructor(i,n){this._pieces=[],this._tree=i,this._BOM=n,this._index=0,i.root!==k.SENTINEL&&i.iterate(i.root,o=>(o!==k.SENTINEL&&this._pieces.push(o.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class l{constructor(i){this._limit=i,this._cache=[]}get(i){for(let n=this._cache.length-1;n>=0;n--){const o=this._cache[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this._cache.length-1;n>=0;n--){const o=this._cache[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let n=!1;const o=this._cache;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this._cache=a}}}class f{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this._buffers=[new w("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=k.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=n,this._EOLLength=n.length,this._EOLNormalized=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const h=new g(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this._buffers.push(i[t]),a=this.rbInsertRight(a,h)}this._searchCache=new l(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const n=v,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const h=[];if(this.iterate(this.root,u=>{const c=this.getNodeContent(u),d=c.length;if(r<=o||r+d<a)return t+=c,r+=d,!0;const y=t.replace(/\r\n|\r|\n/g,i);return h.push(new w(y,L(y))),t=c,r=d,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);h.push(new w(u,L(u)))}this.create(h,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new C(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===k.SENTINEL)return!0;const t=this.getNodeContent(a),r=t.length,h=i.nodeAt(n),u=i.nodeAt(n+r),c=i.getValueInRange2(h,u);return n+=r,t===c})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==k.SENTINEL;)if(a.left!==k.SENTINEL&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.getAccumulatedValue(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==k.SENTINEL;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.getIndexOf(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),h=a-r;return new D.Position(o+1,h+1)}return new D.Position(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===k.SENTINEL){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new D.Position(o+1,r+1)}else n=n.right;return new D.Position(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.nodeAt2(i.startLineNumber,i.startColumn),a=this.nodeAt2(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const h=i.node,u=this._buffers[h.piece.bufferIndex].buffer,c=this.offsetInBuffer(h.piece.bufferIndex,h.piece.start);return u.substring(c+i.remainder,c+n.remainder)}let o=i.node;const a=this._buffers[o.piece.bufferIndex].buffer,t=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==k.SENTINEL;){const h=this._buffers[o.piece.bufferIndex].buffer,u=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=h.substring(u,u+n.remainder);break}else r+=h.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===k.SENTINEL)return!0;const r=t.piece;let h=r.length;if(h===0)return!0;const u=this._buffers[r.bufferIndex].buffer,c=this._buffers[r.bufferIndex].lineStarts,d=r.start.line,y=r.end.line;let A=c[d]+r.start.column;if(a&&(u.charCodeAt(A)===10&&(A++,h--),i[n++]=o,o="",a=!1,h===0))return!0;if(d===y)return!this._EOLNormalized&&u.charCodeAt(A+h-1)===13?(a=!0,o+=u.substr(A,h-1)):o+=u.substr(A,h),!0;o+=this._EOLNormalized?u.substring(A,Math.max(A,c[d+1]-this._EOLLength)):u.substring(A,c[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let E=d+1;E<y;E++)o=this._EOLNormalized?u.substring(c[E],c[E+1]-this._EOLLength):u.substring(c[E],c[E+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this._EOLNormalized&&u.charCodeAt(c[y]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=u.substr(c[y],r.end.column-1)):o=u.substr(c[y],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this._buffers[n.piece.bufferIndex],a=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this._buffers[i.node.piece.bufferIndex],a=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.nodeAt2(i,n+1);return this._getCharCode(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const n=this.nodeAt(i);return this._getCharCode(n)}findMatchesInNode(i,n,o,a,t,r,h,u,c,d,y){const A=this._buffers[i.piece.bufferIndex],E=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),b=this.offsetInBuffer(i.piece.bufferIndex,t),_=this.offsetInBuffer(i.piece.bufferIndex,r);let T;const U={line:0,column:0};let M,P;n._wordSeparators?(M=A.buffer.substring(b,_),P=x=>x+b,n.reset(0)):(M=A.buffer,P=x=>x,n.reset(b));do if(T=n.next(M),T){if(P(T.index)>=_)return d;this.positionInBuffer(i,P(T.index)-E,U);const x=this.getLineFeedCnt(i.piece.bufferIndex,t,U),F=U.line===t.line?U.column-t.column+a:U.column+1,O=F+T[0].length;if(y[d++]=(0,R.createFindMatch)(new N.Range(o+x,F,o+x,O),T,u),P(T.index)+T[0].length>=_||d>=c)return d}while(T);return d}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const h=new R.Searcher(n.wordSeparators,n.regex);let u=this.nodeAt2(i.startLineNumber,i.startColumn);if(u===null)return[];const c=this.nodeAt2(i.endLineNumber,i.endColumn);if(c===null)return[];let d=this.positionInBuffer(u.node,u.remainder);const y=this.positionInBuffer(c.node,c.remainder);if(u.node===c.node)return this.findMatchesInNode(u.node,h,i.startLineNumber,i.startColumn,d,y,n,o,a,r,t),t;let A=i.startLineNumber,E=u.node;for(;E!==c.node;){const _=this.getLineFeedCnt(E.piece.bufferIndex,d,E.piece.end);if(_>=1){const U=this._buffers[E.piece.bufferIndex].lineStarts,M=this.offsetInBuffer(E.piece.bufferIndex,E.piece.start),P=U[d.line+_],x=A===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(E,h,A,x,d,this.positionInBuffer(E,P-M),n,o,a,r,t),r>=a)return t;A+=_}const T=A===i.startLineNumber?i.startColumn-1:0;if(A===i.endLineNumber){const U=this.getLineContent(A).substring(T,i.endColumn-1);return r=this._findMatchesInLine(n,h,U,i.endLineNumber,T,r,t,o,a),t}if(r=this._findMatchesInLine(n,h,this.getLineContent(A).substr(T),A,T,r,t,o,a),r>=a)return t;A++,u=this.nodeAt2(A,1),E=u.node,d=this.positionInBuffer(u.node,u.remainder)}if(A===i.endLineNumber){const _=A===i.startLineNumber?i.startColumn-1:0,T=this.getLineContent(A).substring(_,i.endColumn-1);return r=this._findMatchesInLine(n,h,T,i.endLineNumber,_,r,t,o,a),t}const b=A===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(c.node,h,A,b,d,y,n,o,a,r,t),t}_findMatchesInLine(i,n,o,a,t,r,h,u,c){const d=i.wordSeparators;if(!u&&i.simpleSearch){const A=i.simpleSearch,E=A.length,b=o.length;let _=-E;for(;(_=o.indexOf(A,_+E))!==-1;)if((!d||(0,R.isValidMatch)(d,o,b,_,E))&&(h[r++]=new m.FindMatch(new N.Range(a,_+1+t,a,_+1+E+t),null),r>=c))return r;return r}let y;n.reset(0);do if(y=n.next(o),y&&(h[r++]=(0,R.createFindMatch)(new N.Range(a,y.index+1+t,a,y.index+1+y[0].length+t),y,u),r>=c))return r;while(y);return r}insert(i,n,o=!1){if(this._EOLNormalized=this._EOLNormalized&&o,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==k.SENTINEL){const{node:a,remainder:t,nodeStartOffset:r}=this.nodeAt(i),h=a.piece,u=h.bufferIndex,c=this.positionInBuffer(a,t);if(a.piece.bufferIndex===0&&h.end.line===this._lastChangeBufferPos.line&&h.end.column===this._lastChangeBufferPos.column&&r+h.length===i&&n.length<v){this.appendToNode(a,n),this.computeBufferMetadata();return}if(r===i)this.insertContentToNodeLeft(n,a),this._searchCache.validate(i);else if(r+a.piece.length>i){const d=[];let y=new g(h.bufferIndex,c,h.end,this.getLineFeedCnt(h.bufferIndex,c,h.end),this.offsetInBuffer(u,h.end)-this.offsetInBuffer(u,c));if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.nodeCharCodeAt(a,t)===10){const _={line:y.start.line+1,column:0};y=new g(y.bufferIndex,_,y.end,this.getLineFeedCnt(y.bufferIndex,_,y.end),y.length-1),n+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(n))if(this.nodeCharCodeAt(a,t-1)===13){const _=this.positionInBuffer(a,t-1);this.deleteNodeTail(a,_),n="\r"+n,a.piece.length===0&&d.push(a)}else this.deleteNodeTail(a,c);else this.deleteNodeTail(a,c);const A=this.createNewPieces(n);y.length>0&&this.rbInsertRight(a,y);let E=a;for(let b=0;b<A.length;b++)E=this.rbInsertRight(E,A[b]);this.deleteNodes(d)}else this.insertContentToNodeRight(n,a)}else{const a=this.createNewPieces(n);let t=this.rbInsertLeft(null,a[0]);for(let r=1;r<a.length;r++)t=this.rbInsertRight(t,a[r])}this.computeBufferMetadata()}delete(i,n){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",n<=0||this.root===k.SENTINEL)return;const o=this.nodeAt(i),a=this.nodeAt(i+n),t=o.node,r=a.node;if(t===r){const A=this.positionInBuffer(t,o.remainder),E=this.positionInBuffer(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const b=t.next();(0,k.rbDelete)(this,t),this.validateCRLFWithPrevNode(b),this.computeBufferMetadata();return}this.deleteNodeHead(t,E),this._searchCache.validate(i),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(o.nodeStartOffset+t.piece.length===i+n){this.deleteNodeTail(t,A),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,A,E),this.computeBufferMetadata();return}const h=[],u=this.positionInBuffer(t,o.remainder);this.deleteNodeTail(t,u),this._searchCache.validate(i),t.piece.length===0&&h.push(t);const c=this.positionInBuffer(r,a.remainder);this.deleteNodeHead(r,c),r.piece.length===0&&h.push(r);const d=t.next();for(let A=d;A!==k.SENTINEL&&A!==r;A=A.next())h.push(A);const y=t.piece.length===0?t.prev():t;this.deleteNodes(h),this.validateCRLFWithNextNode(y),this.computeBufferMetadata()}insertContentToNodeLeft(i,n){const o=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(n)){const r=n.piece,h={line:r.start.line+1,column:0},u=new g(r.bufferIndex,h,r.end,this.getLineFeedCnt(r.bufferIndex,h,r.end),r.length-1);n.piece=u,i+=`
`,(0,k.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.createNewPieces(i);let t=this.rbInsertLeft(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.rbInsertLeft(t,a[r]);this.validateCRLFWithPrevNode(t),this.deleteNodes(o)}insertContentToNodeRight(i,n){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const o=this.createNewPieces(i),a=this.rbInsertRight(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.rbInsertRight(t,o[r]);this.validateCRLFWithPrevNode(a)}positionInBuffer(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this._buffers[t].lineStarts,u=r[a.start.line]+a.start.column+n;let c=a.start.line,d=a.end.line,y=0,A=0,E=0;for(;c<=d&&(y=c+(d-c)/2|0,E=r[y],y!==d);)if(A=r[y+1],u<E)d=y-1;else if(u>=A)c=y+1;else break;return o?(o.line=y,o.column=u-E,null):{line:y,column:u-E}}getLineFeedCnt(i,n,o){if(o.column===0)return o.line-n.line;const a=this._buffers[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const h=r-1;return this._buffers[i].buffer.charCodeAt(h)===13?o.line-n.line+1:o.line-n.line}offsetInBuffer(i,n){return this._buffers[i].lineStarts[n.line]+n.column}deleteNodes(i){for(let n=0;n<i.length;n++)(0,k.rbDelete)(this,i[n])}createNewPieces(i){if(i.length>v){const d=[];for(;i.length>v;){const A=i.charCodeAt(v-1);let E;A===13||A>=55296&&A<=56319?(E=i.substring(0,v-1),i=i.substring(v-1)):(E=i.substring(0,v),i=i.substring(v));const b=L(E);d.push(new g(this._buffers.length,{line:0,column:0},{line:b.length-1,column:E.length-b[b.length-1]},b.length-1,E.length)),this._buffers.push(new w(E,b))}const y=L(i);return d.push(new g(this._buffers.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this._buffers.push(new w(i,y)),d}let n=this._buffers[0].buffer.length;const o=L(i,!1);let a=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===n&&n!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},a=this._lastChangeBufferPos;for(let d=0;d<o.length;d++)o[d]+=n+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(o.slice(1)),this._buffers[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let d=0;d<o.length;d++)o[d]+=n;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(o.slice(1)),this._buffers[0].buffer+=i}const t=this._buffers[0].buffer.length,r=this._buffers[0].lineStarts.length-1,h=t-this._buffers[0].lineStarts[r],u={line:r,column:h},c=new g(0,a,u,this.getLineFeedCnt(0,a,u),t-n);return this._lastChangeBufferPos=u,[c]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this._searchCache.get2(i);if(t){o=t.node;const r=this.getAccumulatedValue(o,i-t.nodeStartLineNumber-1),h=this._buffers[o.piece.bufferIndex].buffer,u=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=h.substring(u+r,u+o.piece.length);else{const c=this.getAccumulatedValue(o,i-t.nodeStartLineNumber);return h.substring(u+r,u+c-n)}}else{let r=0;const h=i;for(;o!==k.SENTINEL;)if(o.left!==k.SENTINEL&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.getAccumulatedValue(o,i-o.lf_left-2),c=this.getAccumulatedValue(o,i-o.lf_left-1),d=this._buffers[o.piece.bufferIndex].buffer,y=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this._searchCache.set({node:o,nodeStartOffset:r,nodeStartLineNumber:h-(i-1-o.lf_left)}),d.substring(y+u,y+c-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.getAccumulatedValue(o,i-o.lf_left-2),c=this._buffers[o.piece.bufferIndex].buffer,d=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);a=c.substring(d+u,d+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==k.SENTINEL;){const r=this._buffers[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const h=this.getAccumulatedValue(o,0),u=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);return a+=r.substring(u,u+h-n),a}else{const h=this.offsetInBuffer(o.piece.bufferIndex,o.piece.start);a+=r.substr(h,o.piece.length)}o=o.next()}return a}computeBufferMetadata(){let i=this.root,n=1,o=0;for(;i!==k.SENTINEL;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this._lineCnt=n,this._length=o,this._searchCache.validate(this._length)}getIndexOf(i,n){const o=i.piece,a=this.positionInBuffer(i,n),t=a.line-o.start.line;if(this.offsetInBuffer(o.bufferIndex,o.end)-this.offsetInBuffer(o.bufferIndex,o.start)===n){const r=this.getLineFeedCnt(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}getAccumulatedValue(i,n){if(n<0)return 0;const o=i.piece,a=this._buffers[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}deleteNodeTail(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.offsetInBuffer(o.bufferIndex,o.end),r=n,h=this.offsetInBuffer(o.bufferIndex,r),u=this.getLineFeedCnt(o.bufferIndex,o.start,r),c=u-a,d=h-t,y=o.length+d;i.piece=new g(o.bufferIndex,o.start,r,u,y),(0,k.updateTreeMetadata)(this,i,d,c)}deleteNodeHead(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.offsetInBuffer(o.bufferIndex,o.start),r=n,h=this.getLineFeedCnt(o.bufferIndex,r,o.end),u=this.offsetInBuffer(o.bufferIndex,r),c=h-a,d=t-u,y=o.length+d;i.piece=new g(o.bufferIndex,r,o.end,h,y),(0,k.updateTreeMetadata)(this,i,d,c)}shrinkNode(i,n,o){const a=i.piece,t=a.start,r=a.end,h=a.length,u=a.lineFeedCnt,c=n,d=this.getLineFeedCnt(a.bufferIndex,a.start,c),y=this.offsetInBuffer(a.bufferIndex,n)-this.offsetInBuffer(a.bufferIndex,t);i.piece=new g(a.bufferIndex,a.start,c,d,y),(0,k.updateTreeMetadata)(this,i,y-h,d-u);const A=new g(a.bufferIndex,o,r,this.getLineFeedCnt(a.bufferIndex,o,r),this.offsetInBuffer(a.bufferIndex,r)-this.offsetInBuffer(a.bufferIndex,o)),E=this.rbInsertRight(i,A);this.validateCRLFWithPrevNode(E)}appendToNode(i,n){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const o=this.shouldCheckCRLF()&&this.startWithLF(n)&&this.endWithCR(i),a=this._buffers[0].buffer.length;this._buffers[0].buffer+=n;const t=L(n,!1);for(let E=0;E<t.length;E++)t[E]+=a;if(o){const E=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:a-E}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const r=this._buffers[0].lineStarts.length-1,h=this._buffers[0].buffer.length-this._buffers[0].lineStarts[r],u={line:r,column:h},c=i.piece.length+n.length,d=i.piece.lineFeedCnt,y=this.getLineFeedCnt(0,i.piece.start,u),A=y-d;i.piece=new g(i.piece.bufferIndex,i.piece.start,u,y,c),this._lastChangeBufferPos=u,(0,k.updateTreeMetadata)(this,i,n.length,A)}nodeAt(i){let n=this.root;const o=this._searchCache.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==k.SENTINEL;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this._searchCache.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}nodeAt2(i,n){let o=this.root,a=0;for(;o!==k.SENTINEL;)if(o.left!==k.SENTINEL&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.getAccumulatedValue(o,i-o.lf_left-2),r=this.getAccumulatedValue(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.getAccumulatedValue(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==k.SENTINEL;){if(o.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(o,0),r=this.offsetOfNode(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.offsetOfNode(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}nodeCharCodeAt(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this._buffers[i.piece.bufferIndex],a=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}offsetOfNode(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===k.SENTINEL||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this._buffers[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this._buffers[n.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===k.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const n=i.prev();this.endWithCR(n)&&this.fixCRLF(n,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const n=i.next();this.startWithLF(n)&&this.fixCRLF(i,n)}}fixCRLF(i,n){const o=[],a=this._buffers[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,h=i.piece.lineFeedCnt-1;i.piece=new g(i.piece.bufferIndex,i.piece.start,t,h,r),(0,k.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},c=n.piece.length-1,d=this.getLineFeedCnt(n.piece.bufferIndex,u,n.piece.end);n.piece=new g(n.piece.bufferIndex,u,n.piece.end,d,c),(0,k.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&o.push(n);const y=this.createNewPieces(`\r
`);this.rbInsertRight(i,y[0]);for(let A=0;A<o.length;A++)(0,k.rbDelete)(this,o[A])}adjustCarriageReturnFromNext(i,n){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const o=n.next();if(this.startWithLF(o)){if(i+=`
`,o.piece.length===1)(0,k.rbDelete)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,h=this.getLineFeedCnt(a.bufferIndex,t,a.end);o.piece=new g(a.bufferIndex,t,a.end,h,r),(0,k.updateTreeMetadata)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===k.SENTINEL)return n(k.SENTINEL);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}getNodeContent(i){if(i===k.SENTINEL)return"";const n=this._buffers[i.piece.bufferIndex],o=i.piece,a=this.offsetInBuffer(o.bufferIndex,o.start),t=this.offsetInBuffer(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this._buffers[i.bufferIndex],o=this.offsetInBuffer(i.bufferIndex,i.start),a=this.offsetInBuffer(i.bufferIndex,i.end);return n.buffer.substring(o,a)}rbInsertRight(i,n){const o=new k.TreeNode(n,1);if(o.left=k.SENTINEL,o.right=k.SENTINEL,o.parent=k.SENTINEL,o.size_left=0,o.lf_left=0,this.root===k.SENTINEL)this.root=o,o.color=0;else if(i.right===k.SENTINEL)i.right=o,o.parent=i;else{const t=(0,k.leftest)(i.right);t.left=o,o.parent=t}return(0,k.fixInsert)(this,o),o}rbInsertLeft(i,n){const o=new k.TreeNode(n,1);if(o.left=k.SENTINEL,o.right=k.SENTINEL,o.parent=k.SENTINEL,o.size_left=0,o.lf_left=0,this.root===k.SENTINEL)this.root=o,o.color=0;else if(i.left===k.SENTINEL)i.left=o,o.parent=i;else{const a=(0,k.righttest)(i.left);a.right=o,o.parent=a}return(0,k.fixInsert)(this,o),o}getContentOfSubTree(i){let n="";return this.iterate(i,o=>(n+=this.getNodeContent(o),!0)),n}}e.PieceTreeBase=f}),define(ye[177],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class D{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(k){if(k&&this._dragOperations.has(k)){const R=this._dragOperations.get(k);return this._dragOperations.delete(k),R}}addDragOperationTransfer(k,R){this._dragOperations.set(k,R)}}e.TreeViewsDnDService=D;class N{constructor(k){this.identifier=k}}e.DraggedTreeItemsIdentifier=N}),define(ye[178],Ce([1,0,4,3]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class m{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,p){return this._tokenizationSupports.set(v,p),this.handleChange([v]),(0,N.toDisposable)(()=>{this._tokenizationSupports.get(v)===p&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,p){this._factories.get(v)?.dispose();const S=new k(this,v,p);return this._factories.set(v,S),(0,N.toDisposable)(()=>{const L=this._factories.get(v);!L||L!==S||(this._factories.delete(v),L.dispose())})}async getOrCreate(v){const p=this.get(v);if(p)return p;const S=this._factories.get(v);return!S||S.isResolved?null:(await S.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const S=this._factories.get(v);return!!(!S||S.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=m;class k extends N.Disposable{get isResolved(){return this._isResolved}constructor(v,p,S){super(),this._registry=v,this._languageId=p,this._factory=S,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),define(ye[179],Ce([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(ye[180],Ce([1,0,4,3,179]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class k extends N.Disposable{constructor(g,w="",C="",l=!0,f){super(),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=g,this._label=w,this._cssClass=C,this._enabled=l,this._actionCallback=f}get id(){return this._id}get label(){return this._label}set label(g){this._setLabel(g)}_setLabel(g){this._label!==g&&(this._label=g,this._onDidChange.fire({label:g}))}get tooltip(){return this._tooltip||""}set tooltip(g){this._setTooltip(g)}_setTooltip(g){this._tooltip!==g&&(this._tooltip=g,this._onDidChange.fire({tooltip:g}))}get class(){return this._cssClass}set class(g){this._setClass(g)}_setClass(g){this._cssClass!==g&&(this._cssClass=g,this._onDidChange.fire({class:g}))}get enabled(){return this._enabled}set enabled(g){this._setEnabled(g)}_setEnabled(g){this._enabled!==g&&(this._enabled=g,this._onDidChange.fire({enabled:g}))}get checked(){return this._checked}set checked(g){this._setChecked(g)}_setChecked(g){this._checked!==g&&(this._checked=g,this._onDidChange.fire({checked:g}))}async run(g,w){this._actionCallback&&await this._actionCallback(g)}}e.Action=k;class R extends N.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new D.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new D.Emitter),this.onDidRun=this._onDidRun.event}async run(g,w){if(!g.enabled)return;this._onWillRun.fire({action:g});let C;try{await this.runAction(g,w)}catch(l){C=l}this._onDidRun.fire({action:g,error:C})}async runAction(g,w){await g.run(w)}}e.ActionRunner=R;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...g){let w=[];for(const C of g)C.length&&(w.length?w=[...w,new v,...C]:w=C);return w}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=v;class p{get actions(){return this._actions}constructor(g,w,C,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=g,this.label=w,this.class=l,this._actions=C}async run(){}}e.SubmenuAction=p;class S extends k{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,m.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=S;function L(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...g)=>I.run(...g),tooltip:I.label}}e.toAction=L}),define(ye[181],Ce([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(ye[182],Ce([1,0,181]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const N=60,m=N*60,k=m*24,R=k*7,v=k*30,p=k*365;function S(I,g,w,C){typeof I!="number"&&(I=I.getTime());const l=Math.round((new Date().getTime()-I)/1e3);if(l<-30)return(0,D.localize)(0,null,S(new Date().getTime()+l*1e3,!1));if(!C&&l<30)return(0,D.localize)(1,null);let f;return l<N?(f=l,g?f===1?w?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):w?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?w?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):w?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):l<m?(f=Math.floor(l/N),g?f===1?w?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):w?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?w?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):w?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):l<k?(f=Math.floor(l/m),g?f===1?w?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):w?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?w?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):w?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):l<R?(f=Math.floor(l/k),g?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):l<v?(f=Math.floor(l/R),g?f===1?w?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):w?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?w?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):w?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):l<p?(f=Math.floor(l/v),g?f===1?w?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):w?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?w?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):w?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(l/p),g?f===1?w?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):w?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?w?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):w?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.fromNow=S;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[183],Ce([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(ye[44],Ce([1,0,19,18,183]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(I,g){return g&&(I.stack||I.stacktrace)?m.localize(0,null,v(I),R(I.stack)||R(I.stacktrace)):v(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function v(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?m.localize(1,null,I.message):I.message||m.localize(2,null)}function p(I=null,g=!1){if(!I)return m.localize(3,null);if(Array.isArray(I)){const w=D.coalesce(I),C=p(w[0],g);return w.length>1?m.localize(4,null,C,w.length):C}if(N.isString(I))return I;if(I.detail){const w=I.detail;if(w.error)return k(w.error,g);if(w.exception)return k(w.exception,g)}return I.stack?k(I,g):I.message?I.message:m.localize(5,null)}e.toErrorMessage=p;function S(I){const g=I;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=S;function L(I,g){let w;return typeof I=="string"?w=new Error(I):w=I,w.actions=g,w}e.createErrorWithActions=L}),define(ye[184],Ce([9,10]),function(ge,e){return ge.create("vs/base/common/platform",e)}),define(ye[11],Ce([1,0,184]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isBigSurOrNewer=e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let N=!1,m=!1,k=!1,R=!1,v=!1,p=!1,S=!1,L=!1,I=!1,g=!1,w,C=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT,f,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",a=o&&n?.type==="renderer";if(typeof navigator=="object"&&!a)s=navigator.userAgent,N=s.indexOf("Windows")>=0,m=s.indexOf("Macintosh")>=0,L=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=s.indexOf("Linux")>=0,g=s?.indexOf("Mobi")>=0,p=!0,w=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,C=w,l=navigator.language;else if(typeof n=="object"){N=n.platform==="win32",m=n.platform==="darwin",k=n.platform==="linux",R=k&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,S=o,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const b=n.env.VSCODE_NLS_CONFIG;if(b)try{const _=JSON.parse(b),T=_.availableLanguages["*"];w=_.locale,l=_.osLocale,C=T||e.LANGUAGE_DEFAULT,f=_._translationsConfigFile}catch{}v=!0}else console.error("Unable to resolve platform.");var t;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=r;let h=0;m?h=1:N?h=3:k&&(h=2),e.isWindows=N,e.isMacintosh=m,e.isLinux=k,e.isLinuxSnap=R,e.isNative=v,e.isElectron=S,e.isWeb=p,e.isWebWorker=p&&typeof i.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?i.origin:void 0,e.isIOS=L,e.isMobile=g,e.isCI=I,e.platform=h,e.userAgent=s,e.language=C;var u;(function(b){function _(){return e.language}b.value=_;function T(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}b.isDefaultVariant=T;function U(){return e.language==="en"}b.isDefault=U})(u||(e.Language=u={})),e.locale=w,e.platformLocale=l,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof i.postMessage=="function"&&!i.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const b=[];i.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let U=0,M=b.length;U<M;U++){const P=b[U];if(P.id===T.data.vscodeScheduleAsyncWork){b.splice(U,1),P.callback();return}}});let _=0;return T=>{const U=++_;b.push({id:U,callback:T}),i.postMessage({vscodeScheduleAsyncWork:U},"*")}}return b=>setTimeout(b)})();var c;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=m||L?2:N?1:3;let d=!0,y=!1;function A(){if(!y){y=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,d=new Uint16Array(b.buffer)[0]===(2<<8)+1}return d}e.isLittleEndian=A,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function E(b){return parseFloat(b)>=20}e.isBigSurOrNewer=E}),define(ye[50],Ce([1,0,11]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let N;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.process<"u"){const k=m.process;N={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.platform=N.platform,e.arch=N.arch}),define(ye[16],Ce([1,0,50]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const N=65,m=97,k=90,R=122,v=46,p=47,S=92,L=58,I=63;class g extends Error{constructor(r,h,u){let c;typeof h=="string"&&h.indexOf("not ")===0?(c="must not be",h=h.replace(/^not /,"")):c="must be";const d=r.indexOf(".")!==-1?"property":"argument";let y=`The "${r}" ${d} ${c} of type ${h}`;y+=`. Received type ${typeof u}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function w(t,r){if(t===null||typeof t!="object")throw new g(r,"Object",t)}function C(t,r){if(typeof t!="string")throw new g(r,"string",t)}const l=D.platform==="win32";function f(t){return t===p||t===S}function s(t){return t===p}function i(t){return t>=N&&t<=k||t>=m&&t<=R}function n(t,r,h,u){let c="",d=0,y=-1,A=0,E=0;for(let b=0;b<=t.length;++b){if(b<t.length)E=t.charCodeAt(b);else{if(u(E))break;E=p}if(u(E)){if(!(y===b-1||A===1))if(A===2){if(c.length<2||d!==2||c.charCodeAt(c.length-1)!==v||c.charCodeAt(c.length-2)!==v){if(c.length>2){const _=c.lastIndexOf(h);_===-1?(c="",d=0):(c=c.slice(0,_),d=c.length-1-c.lastIndexOf(h)),y=b,A=0;continue}else if(c.length!==0){c="",d=0,y=b,A=0;continue}}r&&(c+=c.length>0?`${h}..`:"..",d=2)}else c.length>0?c+=`${h}${t.slice(y+1,b)}`:c=t.slice(y+1,b),d=b-y-1;y=b,A=0}else E===v&&A!==-1?++A:A=-1}return c}function o(t,r){w(r,"pathObject");const h=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return h?h===r.root?`${h}${u}`:`${h}${t}${u}`:u}e.win32={resolve(...t){let r="",h="",u=!1;for(let c=t.length-1;c>=-1;c--){let d;if(c>=0){if(d=t[c],C(d,"path"),d.length===0)continue}else r.length===0?d=D.cwd():(d=D.env[`=${r}`]||D.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==r.toLowerCase()&&d.charCodeAt(2)===S)&&(d=`${r}\\`));const y=d.length;let A=0,E="",b=!1;const _=d.charCodeAt(0);if(y===1)f(_)&&(A=1,b=!0);else if(f(_))if(b=!0,f(d.charCodeAt(1))){let T=2,U=T;for(;T<y&&!f(d.charCodeAt(T));)T++;if(T<y&&T!==U){const M=d.slice(U,T);for(U=T;T<y&&f(d.charCodeAt(T));)T++;if(T<y&&T!==U){for(U=T;T<y&&!f(d.charCodeAt(T));)T++;(T===y||T!==U)&&(E=`\\\\${M}\\${d.slice(U,T)}`,A=T)}}}else A=1;else i(_)&&d.charCodeAt(1)===L&&(E=d.slice(0,2),A=2,y>2&&f(d.charCodeAt(2))&&(b=!0,A=3));if(E.length>0)if(r.length>0){if(E.toLowerCase()!==r.toLowerCase())continue}else r=E;if(u){if(r.length>0)break}else if(h=`${d.slice(A)}\\${h}`,u=b,b&&r.length>0)break}return h=n(h,!u,"\\",f),u?`${r}\\${h}`:`${r}${h}`||"."},normalize(t){C(t,"path");const r=t.length;if(r===0)return".";let h=0,u,c=!1;const d=t.charCodeAt(0);if(r===1)return s(d)?"\\":t;if(f(d))if(c=!0,f(t.charCodeAt(1))){let A=2,E=A;for(;A<r&&!f(t.charCodeAt(A));)A++;if(A<r&&A!==E){const b=t.slice(E,A);for(E=A;A<r&&f(t.charCodeAt(A));)A++;if(A<r&&A!==E){for(E=A;A<r&&!f(t.charCodeAt(A));)A++;if(A===r)return`\\\\${b}\\${t.slice(E)}\\`;A!==E&&(u=`\\\\${b}\\${t.slice(E,A)}`,h=A)}}}else h=1;else i(d)&&t.charCodeAt(1)===L&&(u=t.slice(0,2),h=2,r>2&&f(t.charCodeAt(2))&&(c=!0,h=3));let y=h<r?n(t.slice(h),!c,"\\",f):"";return y.length===0&&!c&&(y="."),y.length>0&&f(t.charCodeAt(r-1))&&(y+="\\"),u===void 0?c?`\\${y}`:y:c?`${u}\\${y}`:`${u}${y}`},isAbsolute(t){C(t,"path");const r=t.length;if(r===0)return!1;const h=t.charCodeAt(0);return f(h)||r>2&&i(h)&&t.charCodeAt(1)===L&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,h;for(let d=0;d<t.length;++d){const y=t[d];C(y,"path"),y.length>0&&(r===void 0?r=h=y:r+=`\\${y}`)}if(r===void 0)return".";let u=!0,c=0;if(typeof h=="string"&&f(h.charCodeAt(0))){++c;const d=h.length;d>1&&f(h.charCodeAt(1))&&(++c,d>2&&(f(h.charCodeAt(2))?++c:u=!1))}if(u){for(;c<r.length&&f(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.win32.normalize(r)},relative(t,r){if(C(t,"from"),C(r,"to"),t===r)return"";const h=e.win32.resolve(t),u=e.win32.resolve(r);if(h===u||(t=h.toLowerCase(),r=u.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===S;)c++;let d=t.length;for(;d-1>c&&t.charCodeAt(d-1)===S;)d--;const y=d-c;let A=0;for(;A<r.length&&r.charCodeAt(A)===S;)A++;let E=r.length;for(;E-1>A&&r.charCodeAt(E-1)===S;)E--;const b=E-A,_=y<b?y:b;let T=-1,U=0;for(;U<_;U++){const P=t.charCodeAt(c+U);if(P!==r.charCodeAt(A+U))break;P===S&&(T=U)}if(U!==_){if(T===-1)return u}else{if(b>_){if(r.charCodeAt(A+U)===S)return u.slice(A+U+1);if(U===2)return u.slice(A+U)}y>_&&(t.charCodeAt(c+U)===S?T=U:U===2&&(T=3)),T===-1&&(T=0)}let M="";for(U=c+T+1;U<=d;++U)(U===d||t.charCodeAt(U)===S)&&(M+=M.length===0?"..":"\\..");return A+=T,M.length>0?`${M}${u.slice(A,E)}`:(u.charCodeAt(A)===S&&++A,u.slice(A,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===S){if(r.charCodeAt(1)===S){const h=r.charCodeAt(2);if(h!==I&&h!==v)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===L&&r.charCodeAt(2)===S)return`\\\\?\\${r}`;return t},dirname(t){C(t,"path");const r=t.length;if(r===0)return".";let h=-1,u=0;const c=t.charCodeAt(0);if(r===1)return f(c)?t:".";if(f(c)){if(h=u=1,f(t.charCodeAt(1))){let A=2,E=A;for(;A<r&&!f(t.charCodeAt(A));)A++;if(A<r&&A!==E){for(E=A;A<r&&f(t.charCodeAt(A));)A++;if(A<r&&A!==E){for(E=A;A<r&&!f(t.charCodeAt(A));)A++;if(A===r)return t;A!==E&&(h=u=A+1)}}}}else i(c)&&t.charCodeAt(1)===L&&(h=r>2&&f(t.charCodeAt(2))?3:2,u=h);let d=-1,y=!0;for(let A=r-1;A>=u;--A)if(f(t.charCodeAt(A))){if(!y){d=A;break}}else y=!1;if(d===-1){if(h===-1)return".";d=h}return t.slice(0,d)},basename(t,r){r!==void 0&&C(r,"ext"),C(t,"path");let h=0,u=-1,c=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(h=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let y=r.length-1,A=-1;for(d=t.length-1;d>=h;--d){const E=t.charCodeAt(d);if(f(E)){if(!c){h=d+1;break}}else A===-1&&(c=!1,A=d+1),y>=0&&(E===r.charCodeAt(y)?--y===-1&&(u=d):(y=-1,u=A))}return h===u?u=A:u===-1&&(u=t.length),t.slice(h,u)}for(d=t.length-1;d>=h;--d)if(f(t.charCodeAt(d))){if(!c){h=d+1;break}}else u===-1&&(c=!1,u=d+1);return u===-1?"":t.slice(h,u)},extname(t){C(t,"path");let r=0,h=-1,u=0,c=-1,d=!0,y=0;t.length>=2&&t.charCodeAt(1)===L&&i(t.charCodeAt(0))&&(r=u=2);for(let A=t.length-1;A>=r;--A){const E=t.charCodeAt(A);if(f(E)){if(!d){u=A+1;break}continue}c===-1&&(d=!1,c=A+1),E===v?h===-1?h=A:y!==1&&(y=1):h!==-1&&(y=-1)}return h===-1||c===-1||y===0||y===1&&h===c-1&&h===u+1?"":t.slice(h,c)},format:o.bind(null,"\\"),parse(t){C(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.length;let u=0,c=t.charCodeAt(0);if(h===1)return f(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(f(c)){if(u=1,f(t.charCodeAt(1))){let T=2,U=T;for(;T<h&&!f(t.charCodeAt(T));)T++;if(T<h&&T!==U){for(U=T;T<h&&f(t.charCodeAt(T));)T++;if(T<h&&T!==U){for(U=T;T<h&&!f(t.charCodeAt(T));)T++;T===h?u=T:T!==U&&(u=T+1)}}}}else if(i(c)&&t.charCodeAt(1)===L){if(h<=2)return r.root=r.dir=t,r;if(u=2,f(t.charCodeAt(2))){if(h===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let d=-1,y=u,A=-1,E=!0,b=t.length-1,_=0;for(;b>=u;--b){if(c=t.charCodeAt(b),f(c)){if(!E){y=b+1;break}continue}A===-1&&(E=!1,A=b+1),c===v?d===-1?d=b:_!==1&&(_=1):d!==-1&&(_=-1)}return A!==-1&&(d===-1||_===0||_===1&&d===A-1&&d===y+1?r.base=r.name=t.slice(y,A):(r.name=t.slice(y,d),r.base=t.slice(y,A),r.ext=t.slice(d,A))),y>0&&y!==u?r.dir=t.slice(0,y-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(l){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.posix={resolve(...t){let r="",h=!1;for(let u=t.length-1;u>=-1&&!h;u--){const c=u>=0?t[u]:a();C(c,"path"),c.length!==0&&(r=`${c}/${r}`,h=c.charCodeAt(0)===p)}return r=n(r,!h,"/",s),h?`/${r}`:r.length>0?r:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===p,h=t.charCodeAt(t.length-1)===p;return t=n(t,!r,"/",s),t.length===0?r?"/":h?"./":".":(h&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let r;for(let h=0;h<t.length;++h){const u=t[h];C(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(C(t,"from"),C(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const h=1,u=t.length,c=u-h,d=1,y=r.length-d,A=c<y?c:y;let E=-1,b=0;for(;b<A;b++){const T=t.charCodeAt(h+b);if(T!==r.charCodeAt(d+b))break;T===p&&(E=b)}if(b===A)if(y>A){if(r.charCodeAt(d+b)===p)return r.slice(d+b+1);if(b===0)return r.slice(d+b)}else c>A&&(t.charCodeAt(h+b)===p?E=b:b===0&&(E=0));let _="";for(b=h+E+1;b<=u;++b)(b===u||t.charCodeAt(b)===p)&&(_+=_.length===0?"..":"/..");return`${_}${r.slice(d+E)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===p;let h=-1,u=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===p){if(!u){h=c;break}}else u=!1;return h===-1?r?"/":".":r&&h===1?"//":t.slice(0,h)},basename(t,r){r!==void 0&&C(r,"ext"),C(t,"path");let h=0,u=-1,c=!0,d;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let y=r.length-1,A=-1;for(d=t.length-1;d>=0;--d){const E=t.charCodeAt(d);if(E===p){if(!c){h=d+1;break}}else A===-1&&(c=!1,A=d+1),y>=0&&(E===r.charCodeAt(y)?--y===-1&&(u=d):(y=-1,u=A))}return h===u?u=A:u===-1&&(u=t.length),t.slice(h,u)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===p){if(!c){h=d+1;break}}else u===-1&&(c=!1,u=d+1);return u===-1?"":t.slice(h,u)},extname(t){C(t,"path");let r=-1,h=0,u=-1,c=!0,d=0;for(let y=t.length-1;y>=0;--y){const A=t.charCodeAt(y);if(A===p){if(!c){h=y+1;break}continue}u===-1&&(c=!1,u=y+1),A===v?r===-1?r=y:d!==1&&(d=1):r!==-1&&(d=-1)}return r===-1||u===-1||d===0||d===1&&r===u-1&&r===h+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){C(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.charCodeAt(0)===p;let u;h?(r.root="/",u=1):u=0;let c=-1,d=0,y=-1,A=!0,E=t.length-1,b=0;for(;E>=u;--E){const _=t.charCodeAt(E);if(_===p){if(!A){d=E+1;break}continue}y===-1&&(A=!1,y=E+1),_===v?c===-1?c=E:b!==1&&(b=1):c!==-1&&(b=-1)}if(y!==-1){const _=d===0&&h?1:d;c===-1||b===0||b===1&&c===y-1&&c===d+1?r.base=r.name=t.slice(_,y):(r.name=t.slice(_,c),r.base=t.slice(_,y),r.ext=t.slice(c,y))}return d>0?r.dir=t.slice(0,d-1):h&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l?e.win32.normalize:e.posix.normalize,e.isAbsolute=l?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l?e.win32.join:e.posix.join,e.resolve=l?e.win32.resolve:e.posix.resolve,e.relative=l?e.win32.relative:e.posix.relative,e.dirname=l?e.win32.dirname:e.posix.dirname,e.basename=l?e.win32.basename:e.posix.basename,e.extname=l?e.win32.extname:e.posix.extname,e.format=l?e.win32.format:e.posix.format,e.parse=l?e.win32.parse:e.posix.parse,e.toNamespacedPath=l?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l?e.win32.sep:e.posix.sep,e.delimiter=l?e.win32.delimiter:e.posix.delimiter}),define(ye[128],Ce([1,0,43,16]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const m=new D.Lazy(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),k=new D.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function v(A,E,b=!1){const _=A||"",T=E||"",U=m.value.collator.compare(_,T);return m.value.collatorIsNumeric&&U===0&&_!==T?_<T?-1:1:U}e.compareFileNames=v;function p(A,E){const b=k.value.collator;return A=A||"",E=E||"",o(b,A,E)}e.compareFileNamesDefault=p;function S(A,E){const b=k.value.collator;return A=A||"",E=E||"",h(A,E)||o(b,A,E)}e.compareFileNamesUpper=S;function L(A,E){const b=k.value.collator;return A=A||"",E=E||"",r(A,E)||o(b,A,E)}e.compareFileNamesLower=L;function I(A,E){return A=A||"",E=E||"",A===E?0:A<E?-1:1}e.compareFileNamesUnicode=I;function g(A,E){const[b,_]=i(A),[T,U]=i(E);let M=m.value.collator.compare(_,U);if(M===0){if(m.value.collatorIsNumeric&&_!==U)return _<U?-1:1;if(M=m.value.collator.compare(b,T),m.value.collatorIsNumeric&&M===0&&b!==T)return b<T?-1:1}return M}e.compareFileExtensions=g;function w(A,E){A=A||"",E=E||"";const b=n(A),_=n(E),T=k.value.collator,U=R.value.collator;return o(U,b,_)||o(T,A,E)}e.compareFileExtensionsDefault=w;function C(A,E){A=A||"",E=E||"";const b=n(A),_=n(E),T=k.value.collator,U=R.value.collator;return o(U,b,_)||h(A,E)||o(T,A,E)}e.compareFileExtensionsUpper=C;function l(A,E){A=A||"",E=E||"";const b=n(A),_=n(E),T=k.value.collator,U=R.value.collator;return o(U,b,_)||r(A,E)||o(T,A,E)}e.compareFileExtensionsLower=l;function f(A,E){A=A||"",E=E||"";const b=n(A).toLowerCase(),_=n(E).toLowerCase();return b!==_?b<_?-1:1:A!==E?A<E?-1:1:0}e.compareFileExtensionsUnicode=f;const s=/^(.*?)(\.([^.]*))?$/;function i(A,E=!1){const b=A?s.exec(A):[];let _=[b&&b[1]||"",b&&b[3]||""];return E&&(!_[0]&&_[1]||_[0]&&_[0].charAt(0)===".")&&(_=[_[0]+"."+_[1],""]),_}function n(A){const E=A?s.exec(A):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function o(A,E,b){const _=A.compare(E,b);return _!==0?_:E.length!==b.length?E.length<b.length?-1:1:0}function a(A){const E=A.charAt(0);return E.toLocaleUpperCase()!==E}function t(A){const E=A.charAt(0);return E.toLocaleLowerCase()!==E}function r(A,E){return a(A)&&t(E)?-1:t(A)&&a(E)?1:0}function h(A,E){return t(A)&&a(E)?-1:a(A)&&t(E)?1:0}function u(A,E,b=!1){return b||(A=A&&A.toLowerCase(),E=E&&E.toLowerCase()),A===E?0:A<E?-1:1}function c(A,E,b=!1){const _=A.split(N.sep),T=E.split(N.sep),U=_.length-1,M=T.length-1;let P,x;for(let F=0;;F++){if(P=U===F,x=M===F,P&&x)return v(_[F],T[F],b);if(P)return-1;if(x)return 1;const O=u(_[F],T[F],b);if(O!==0)return O}}e.comparePaths=c;function d(A,E,b){const _=A.toLowerCase(),T=E.toLowerCase(),U=y(A,E,b);if(U)return U;const M=_.endsWith(b),P=T.endsWith(b);if(M!==P)return M?-1:1;const x=v(_,T);return x!==0?x:_.localeCompare(T)}e.compareAnything=d;function y(A,E,b){const _=A.toLowerCase(),T=E.toLowerCase(),U=_.startsWith(b),M=T.startsWith(b);if(U!==M)return U?-1:1;if(U&&M){if(_.length<T.length)return-1;if(_.length>T.length)return 1}return 0}e.compareByPrefix=y}),define(ye[33],Ce([1,0,16,11,13,18]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(d){return d===47||d===92}e.isPathSeparator=R;function v(d){return d.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=v;function p(d){return d.indexOf("/")===-1&&(d=v(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=p;function S(d,y=D.posix.sep){if(!d)return"";const A=d.length,E=d.charCodeAt(0);if(R(E)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let _=3;const T=_;for(;_<A&&!R(d.charCodeAt(_));_++);if(T!==_&&!R(d.charCodeAt(_+1))){for(_+=1;_<A;_++)if(R(d.charCodeAt(_)))return d.slice(0,_+1).replace(/[\\/]/g,y)}}return y}else if(s(E)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+y:d.slice(0,2);let b=d.indexOf("://");if(b!==-1){for(b+=3;b<A;b++)if(R(d.charCodeAt(b)))return d.slice(0,b+1)}return""}e.getRoot=S;function L(d){if(!N.isWindows||!d||d.length<5)return!1;let y=d.charCodeAt(0);if(y!==92||(y=d.charCodeAt(1),y!==92))return!1;let A=2;const E=A;for(;A<d.length&&(y=d.charCodeAt(A),y!==92);A++);return!(E===A||(y=d.charCodeAt(A+1),isNaN(y)||y===92))}e.isUNC=L;const I=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(d,y=N.isWindows){const A=y?I:g;return!(!d||d.length===0||/^\s+$/.test(d)||(A.lastIndex=0,A.test(d))||y&&w.test(d)||d==="."||d===".."||y&&d[d.length-1]==="."||y&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=C;function l(d,y,A){const E=d===y;return!A||E?E:!d||!y?!1:(0,m.equalsIgnoreCase)(d,y)}e.isEqual=l;function f(d,y,A,E=D.sep){if(d===y)return!0;if(!d||!y||y.length>d.length)return!1;if(A){if(!(0,m.startsWithIgnoreCase)(d,y))return!1;if(y.length===d.length)return!0;let _=y.length;return y.charAt(y.length-1)===E&&_--,d.charAt(_)===E}return y.charAt(y.length-1)!==E&&(y+=E),d.indexOf(y)===0}e.isEqualOrParent=f;function s(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=s;function i(d,y){return N.isWindows&&d.endsWith(":")&&(d+=D.sep),(0,D.isAbsolute)(d)||(d=(0,D.join)(y,d)),d=(0,D.normalize)(d),N.isWindows?(d=(0,m.rtrim)(d,D.sep),d.endsWith(":")&&(d+=D.sep)):(d=(0,m.rtrim)(d,D.sep),d||(d=D.sep)),d}e.sanitizeFilePath=i;function n(d){const y=(0,D.normalize)(d);return N.isWindows?d.length>3?!1:o(y)&&(d.length===2||y.charCodeAt(2)===92):y===D.posix.sep}e.isRootOrDriveLetter=n;function o(d,y=N.isWindows){return y?s(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(d,y=N.isWindows){return o(d,y)?d[0]:void 0}e.getDriveLetter=a;function t(d,y,A){return y.length>d.length?-1:d===y?0:(A&&(d=d.toLowerCase(),y=y.toLowerCase()),d.indexOf(y))}e.indexOfPath=t;function r(d){const y=d.split(":");let A,E,b;for(const _ of y){const T=Number(_);(0,k.isNumber)(T)?E===void 0?E=T:b===void 0&&(b=T):A=A?[A,_].join(":"):_}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:E!==void 0?E:void 0,column:b!==void 0?b:E!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(d,y,A=8){let E="";for(let _=0;_<A;_++){let T;_===0&&N.isWindows&&!y&&(A===3||A===4)?T=u:T=h,E+=T.charAt(Math.floor(Math.random()*T.length))}let b;return y?b=`${y}-${E}`:b=E,d?(0,D.join)(d,b):b}e.randomPath=c}),define(ye[129],Ce([1,0,128,123,53,16,11,13]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const p=0,S=[p,[]];function L(W,J,ce,G){if(!W||!J)return S;const X=W.length,Y=J.length;if(X<Y)return S;const se=W.toLowerCase();return I(J,ce,Y,W,se,X,G)}e.scoreFuzzy=L;function I(W,J,ce,G,X,Y,se){const Q=[],we=[];for(let ne=0;ne<ce;ne++){const Se=ne*Y,de=Se-Y,me=ne>0,Z=W[ne],ie=J[ne];for(let q=0;q<Y;q++){const te=q>0,fe=Se+q,Ee=fe-1,Te=de+q-1,ve=te?Q[Ee]:0,De=me&&te?Q[Te]:0,B=me&&te?we[Te]:0;let K;!De&&me?K=0:K=g(Z,ie,G,X,q,B),K&&De+K>=ve&&(se||me||X.startsWith(J,q))?(we[fe]=B+1,Q[fe]=De+K):(we[fe]=p,Q[fe]=ve)}}const he=[];let j=ce-1,z=Y-1;for(;j>=0&&z>=0;){const ne=j*Y+z;we[ne]===p||(he.push(z),j--),z--}return[Q[ce*Y-1],he.reverse()]}function g(W,J,ce,G,X,Y){let se=0;if(!w(J,G[X]))return se;if(se+=1,Y>0&&(se+=Y*5),W===ce[X]&&(se+=1),X===0)se+=8;else{const Q=C(ce.charCodeAt(X-1));Q?se+=Q:(0,N.isUpper)(ce.charCodeAt(X))&&Y===0&&(se+=2)}return se}function w(W,J){return W===J?!0:W==="/"||W==="\\"?J==="/"||J==="\\":!1}function C(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function f(W,J,ce=0,G=0){const X=J;return X.values&&X.values.length>1?s(W,X.values,ce,G):i(W,J,ce,G)}e.scoreFuzzy2=f;function s(W,J,ce,G){let X=0;const Y=[];for(const se of J){const[Q,we]=i(W,se,ce,G);if(typeof Q!="number")return l;X+=Q,Y.push(...we)}return[X,A(Y)]}function i(W,J,ce,G){const X=(0,N.fuzzyScore)(J.original,J.originalLowercase,ce,W,W.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,N.createMatches)(X)]:l}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(W,J,ce,G){const X=G.values?G.values:[G];return(0,m.hash)({[G.normalized]:{values:X.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:W,description:J,allowNonContiguousMatches:ce}})}function h(W,J,ce,G,X){if(!W||!J.normalized)return n;const Y=G.getItemLabel(W);if(!Y)return n;const se=G.getItemDescription(W),Q=r(Y,se,ce,J),we=X[Q];if(we)return we;const he=u(Y,se,G.getItemPath(W),J,ce);return X[Q]=he,he}e.scoreItemFuzzy=h;function u(W,J,ce,G,X){const Y=!ce||!G.containsPathSeparator;return ce&&(R.isLinux?G.pathNormalized===ce:(0,v.equalsIgnoreCase)(G.pathNormalized,ce))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:G.values&&G.values.length>1?c(W,J,ce,G.values,Y,X):d(W,J,ce,G,Y,X)}function c(W,J,ce,G,X,Y){let se=0;const Q=[],we=[];for(const he of G){const{score:j,labelMatch:z,descriptionMatch:ne}=d(W,J,ce,he,X,Y);if(j===p)return n;se+=j,z&&Q.push(...z),ne&&we.push(...ne)}return{score:se,labelMatch:A(Q),descriptionMatch:A(we)}}function d(W,J,ce,G,X,Y){if(X||!J){const[se,Q]=L(W,G.normalized,G.normalizedLowercase,Y&&!G.expectContiguousMatch);if(se){const we=(0,N.matchesPrefix)(G.normalized,W);let he;if(we){he=a;const j=Math.round(G.normalized.length/W.length*100);he+=j}else he=t;return{score:he+se,labelMatch:we||y(Q)}}}if(J){let se=J;ce&&(se=`${J}${k.sep}`);const Q=se.length,we=`${se}${W}`,[he,j]=L(we,G.normalized,G.normalizedLowercase,Y&&!G.expectContiguousMatch);if(he){const z=y(j),ne=[],Se=[];return z.forEach(de=>{de.start<Q&&de.end>Q?(ne.push({start:0,end:de.end-Q}),Se.push({start:de.start,end:Q})):de.start>=Q?ne.push({start:de.start-Q,end:de.end-Q}):Se.push(de)}),{score:he,labelMatch:ne,descriptionMatch:Se}}}return n}function y(W){const J=[];if(!W)return J;let ce;for(const G of W)ce&&ce.end===G?ce.end+=1:(ce={start:G,end:G+1},J.push(ce));return J}function A(W){const J=W.sort((X,Y)=>X.start-Y.start),ce=[];let G;for(const X of J)!G||!E(G,X)?(G=X,ce.push(X)):(G.start=Math.min(G.start,X.start),G.end=Math.max(G.end,X.end));return ce}function E(W,J){return!(W.end<J.start||J.end<W.start)}function b(W,J,ce,G,X,Y){const se=h(W,ce,G,X,Y),Q=h(J,ce,G,X,Y),we=se.score,he=Q.score;if((we===o||he===o)&&we!==he)return we===o?-1:1;if(we>t||he>t){if(we!==he)return we>he?-1:1;if(we<a&&he<a){const Z=T(se.labelMatch,Q.labelMatch);if(Z!==0)return Z}const de=X.getItemLabel(W)||"",me=X.getItemLabel(J)||"";if(de.length!==me.length)return de.length-me.length}if(we!==he)return we>he?-1:1;const j=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,z=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(j&&!z)return-1;if(z&&!j)return 1;const ne=_(W,se,X),Se=_(J,Q,X);return ne&&Se&&ne!==Se?Se>ne?-1:1:U(W,J,ce,X)}e.compareItemsByFuzzyScore=b;function _(W,J,ce){let G=-1,X=-1;if(J.descriptionMatch&&J.descriptionMatch.length?G=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(G=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(X=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const Y=ce.getItemDescription(W);Y&&(X+=Y.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(X=J.descriptionMatch[J.descriptionMatch.length-1].end);return X-G}function T(W,J){if(!W&&!J||(!W||!W.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!W||!W.length)return 1;const ce=W[0].start,X=W[W.length-1].end-ce,Y=J[0].start,Q=J[J.length-1].end-Y;return X===Q?0:Q<X?1:-1}function U(W,J,ce,G){const X=G.getItemLabel(W)||"",Y=G.getItemLabel(J)||"",se=G.getItemDescription(W),Q=G.getItemDescription(J),we=X.length+(se?se.length:0),he=Y.length+(Q?Q.length:0);if(we!==he)return we-he;const j=G.getItemPath(W),z=G.getItemPath(J);return j&&z&&j.length!==z.length?j.length-z.length:X!==Y?(0,D.compareAnything)(X,Y,ce.normalized):se&&Q&&se!==Q?(0,D.compareAnything)(se,Q,ce.normalized):j&&z&&j!==z?(0,D.compareAnything)(j,z,ce.normalized):0}function M(W){return W.startsWith('"')&&W.endsWith('"')}const P=" ";function x(W){typeof W!="string"&&(W="");const J=W.toLowerCase(),{pathNormalized:ce,normalized:G,normalizedLowercase:X}=F(W),Y=ce.indexOf(k.sep)>=0,se=M(W);let Q;const we=W.split(P);if(we.length>1)for(const he of we){const j=M(he),{pathNormalized:z,normalized:ne,normalizedLowercase:Se}=F(he);ne&&(Q||(Q=[]),Q.push({original:he,originalLowercase:he.toLowerCase(),pathNormalized:z,normalized:ne,normalizedLowercase:Se,expectContiguousMatch:j}))}return{original:W,originalLowercase:J,pathNormalized:ce,normalized:G,normalizedLowercase:X,values:Q,containsPathSeparator:Y,expectContiguousMatch:se}}e.prepareQuery=x;function F(W){let J;R.isWindows?J=W.replace(/\//g,k.sep):J=W.replace(/\\/g,k.sep);const ce=(0,v.stripWildcards)(J).replace(/\s|"/g,"");return{pathNormalized:J,normalized:ce,normalizedLowercase:ce.toLowerCase()}}function O(W){return Array.isArray(W)?x(W.map(J=>J.original).join(P)):x(W.original)}e.pieceToQuery=O}),define(ye[100],Ce([1,0,16]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},m={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(L){const I=(0,D.extname)(L),g=N[I.toLowerCase()];return g!==void 0?g:R(L)}e.getMediaOrTextMime=k;function R(L){const I=(0,D.extname)(L);return m[I.toLowerCase()]}e.getMediaMime=R;function v(L){for(const I in m)if(m[I]===L)return I}e.getExtensionForMimeType=v;const p=/^(.+)\/(.+?)(;.+)?$/;function S(L,I){const g=p.exec(L);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:I?void 0:L}e.normalizeMimeType=S}),define(ye[101],Ce([1,0,11]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var N;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(N||(e.Source=N={}));var m;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(m||(e.TerminateResponseCode=m={}));function k(v,...p){const S=p.reduce((g,w)=>(g[w]=!0,g),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(g=>!S[g]).forEach(g=>{for(let w=0;w<L.length;w++)if(g.search(L[w])!==-1){delete v[g];break}})}e.sanitizeProcessEnvironment=k;function R(v){v&&(delete v.DEBUG,D.isMacintosh&&delete v.DYLD_LIBRARY_PATH,D.isLinux&&delete v.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(ye[2],Ce([1,0,16,11]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const m=/^\w[\w\d+.-]*$/,k=/^\//,R=/^\/\//;function v(u,c){if(!u.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!m.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!k.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(u,c){return!u&&!c?"file":u}function S(u,c){switch(u){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const L="",I="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(c){return c instanceof w?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,d,y,A,E,b=!1){typeof c=="object"?(this.scheme=c.scheme||L,this.authority=c.authority||L,this.path=c.path||L,this.query=c.query||L,this.fragment=c.fragment||L):(this.scheme=p(c,b),this.authority=d||L,this.path=S(this.scheme,y||L),this.query=A||L,this.fragment=E||L,v(this,b))}get fsPath(){return o(this,!1)}with(c){if(!c)return this;let{scheme:d,authority:y,path:A,query:E,fragment:b}=c;return d===void 0?d=this.scheme:d===null&&(d=L),y===void 0?y=this.authority:y===null&&(y=L),A===void 0?A=this.path:A===null&&(A=L),E===void 0?E=this.query:E===null&&(E=L),b===void 0?b=this.fragment:b===null&&(b=L),d===this.scheme&&y===this.authority&&A===this.path&&E===this.query&&b===this.fragment?this:new f(d,y,A,E,b)}static parse(c,d=!1){const y=g.exec(c);return y?new f(y[2]||L,h(y[4]||L),h(y[5]||L),h(y[7]||L),h(y[9]||L),d):new f(L,L,L,L,L)}static file(c){let d=L;if(N.isWindows&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const y=c.indexOf(I,2);y===-1?(d=c.substring(2),c=I):(d=c.substring(2,y),c=c.substring(y)||I)}return new f("file",d,c,L,L)}static from(c,d){return new f(c.scheme,c.authority,c.path,c.query,c.fragment,d)}static joinPath(c,...d){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return N.isWindows&&c.scheme==="file"?y=w.file(D.win32.join(o(c,!0),...d)).path:y=D.posix.join(c.path,...d),c.with({path:y})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof w)return c;{const d=new f(c);return d._formatted=c.external??null,d._fsPath=c._sep===l?c.fsPath??null:null,d}}else return c}}e.URI=w;function C(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.isUriComponents=C;const l=N.isWindows?1:void 0;class f extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=l),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,c,d){let y,A=-1;for(let E=0;E<u.length;E++){const b=u.charCodeAt(E);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||c&&b===47||d&&b===91||d&&b===93||d&&b===58)A!==-1&&(y+=encodeURIComponent(u.substring(A,E)),A=-1),y!==void 0&&(y+=u.charAt(E));else{y===void 0&&(y=u.substr(0,E));const _=s[b];_!==void 0?(A!==-1&&(y+=encodeURIComponent(u.substring(A,E)),A=-1),y+=_):A===-1&&(A=E)}}return A!==-1&&(y+=encodeURIComponent(u.substring(A))),y!==void 0?y:u}function n(u){let c;for(let d=0;d<u.length;d++){const y=u.charCodeAt(d);y===35||y===63?(c===void 0&&(c=u.substr(0,d)),c+=s[y]):c!==void 0&&(c+=u[d])}return c!==void 0?c:u}function o(u,c){let d;return u.authority&&u.path.length>1&&u.scheme==="file"?d=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?c?d=u.path.substr(1):d=u.path[1].toLowerCase()+u.path.substr(2):d=u.path,N.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=o;function a(u,c){const d=c?n:i;let y="",{scheme:A,authority:E,path:b,query:_,fragment:T}=u;if(A&&(y+=A,y+=":"),(E||A==="file")&&(y+=I,y+=I),E){let U=E.indexOf("@");if(U!==-1){const M=E.substr(0,U);E=E.substr(U+1),U=M.lastIndexOf(":"),U===-1?y+=d(M,!1,!1):(y+=d(M.substr(0,U),!1,!1),y+=":",y+=d(M.substr(U+1),!1,!0)),y+="@"}E=E.toLowerCase(),U=E.lastIndexOf(":"),U===-1?y+=d(E,!1,!0):(y+=d(E.substr(0,U),!1,!0),y+=E.substr(U))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const U=b.charCodeAt(1);U>=65&&U<=90&&(b=`/${String.fromCharCode(U+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const U=b.charCodeAt(0);U>=65&&U<=90&&(b=`${String.fromCharCode(U+32)}:${b.substr(2)}`)}y+=d(b,!0,!1)}return _&&(y+="?",y+=d(_,!1,!1)),T&&(y+="#",y+=c?T:i(T,!1,!1)),y}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(u){return u.match(r)?u.replace(r,c=>t(c)):u}}),define(ye[185],Ce([1,0,2]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function N(S){const L=S;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.isRemoteConsoleLog=N;function m(S){const L=[];let I;try{const g=JSON.parse(S.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),I=w.__$stack),L.push(...g)}catch{L.push("Unable to log remote console arguments",S.arguments)}return{args:L,stack:I}}e.parse=m;function k(S){if(typeof S!="string")return k(m(S).stack);const L=S;if(L){const I=R(L),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:D.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=k;function R(S){if(!S)return S;const L=S.indexOf(`
`);return L===-1?S:S.substring(0,L)}function v(S,L){const{args:I,stack:g}=m(S),w=typeof I[0]=="string"&&I.length===1;let C=R(g);C&&(C=`(${C.trim()})`);let l=[];if(typeof I[0]=="string"?C&&w?l=[`%c[${L}] %c${I[0]} %c${C}`,p("blue"),p(""),p("grey")]:l=[`%c[${L}] %c${I[0]}`,p("blue"),p(""),...I.slice(1)]:l=[`%c[${L}]%`,p("blue"),...I],C&&!w&&l.push(C),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,l)}e.log=v;function p(S){return`color: ${S}`}}),define(ye[54],Ce([1,0,22,2]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function m(p){return JSON.stringify(p,R)}e.stringify=m;function k(p){let S=JSON.parse(p);return S=v(S),S}e.parse=k;function R(p,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function v(p,S=0){if(!p||S>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return N.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof D.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let L=0;L<p.length;++L)p[L]=v(p[L],S+1);else for(const L in p)Object.hasOwnProperty.call(p,L)&&(p[L]=v(p[L],S+1))}return p}e.revive=v}),define(ye[17],Ce([1,0,8,11,13,2]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var R;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function v(g,w){return k.URI.isUri(g)?(0,m.equalsIgnoreCase)(g.scheme,w):(0,m.startsWithIgnoreCase)(g,w+":")}e.matchesScheme=v;function p(g,...w){return w.some(C=>v(g,C))}e.matchesSomeScheme=p,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${R.vscodeRemoteResource}`}set(w,C,l){this._hosts[w]=C,this._ports[w]=l}setConnectionToken(w,C){this._connectionTokens[w]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)try{return this._delegate(w)}catch(n){return D.onUnexpectedError(n),w}const C=w.authority;let l=this._hosts[C];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this._ports[C],s=this._connectionTokens[C];let i=`path=${encodeURIComponent(w.path)}`;return typeof s=="string"&&(i+=`&${e.connectionTokenQueryName}=${encodeURIComponent(s)}`),k.URI.from({scheme:N.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${l}:${f}`,path:this._remoteResourcesPath,query:i})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class L{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(w){const C=this.toUri(w,ge);return this.uriToBrowserUri(C)}uriToBrowserUri(w){return w.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===R.file&&(N.isNative||N.webWorkerOrigin===`${R.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?w.with({scheme:R.vscodeFileResource,authority:w.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(w){const C=this.toUri(w,ge);return this.uriToFileUri(C)}uriToFileUri(w){return w.scheme===R.vscodeFileResource?w.with({scheme:R.file,authority:w.authority!==L.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(w,C){return k.URI.isUri(w)?w:k.URI.parse(C.toUrl(w))}}e.FileAccess=new L;var I;(function(g){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(w.get("3"));const C="vscode-coi";function l(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:k.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(C);if(n)return w.get(n)}g.getHeadersFromQuery=l;function f(s,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(C,o):s[C]=o}g.addSearchParam=f})(I||(e.COI=I={}))}),define(ye[186],Ce([1,0,157,17,11,2]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class R{constructor(g,w,C){this.id=g,this.dependencies=w,this.callback=C}}class v{static{this.INSTANCE=new v}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(g,w,C)=>{typeof g!="string"&&(C=w,w=g,g=null),(typeof w!="object"||!Array.isArray(w))&&(C=w,w=null),this._defineCalls.push(new R(g,w,C))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this._initialize();const w=await(this._isWebWorker?this._workerLoadScript(g):this._isRenderer?this._rendererLoadScript(g):this._nodeJSLoadScript(g));if(!w)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}_rendererLoadScript(g){return new Promise((w,C)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const f=()=>{l.removeEventListener("load",s),l.removeEventListener("error",i)},s=n=>{f(),w(this._defineCalls.pop())},i=n=>{f(),C(n)};l.addEventListener("load",s),l.addEventListener("error",i),this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),l.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(l)})}_workerLoadScript(g){return new Promise((w,C)=>{try{this._amdPolicy&&(g=this._amdPolicy.createScriptURL(g)),importScripts(g),w(this._defineCalls.pop())}catch(l){C(l)}})}async _nodeJSLoadScript(g){try{const w=globalThis._VSCODE_NODE_MODULES.fs,C=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,f=k.URI.parse(g).fsPath,s=w.readFileSync(f).toString(),i=l.wrap(s.replace(/^#!.*/,""));return new C.Script(i).runInThisContext().apply(),this._defineCalls.pop()}catch(w){throw w}}}const p=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function L(I,g,w){if(D.isESM){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[I]&&(I=S[I]);const C=`${I}/${g}`;if(p.has(C))return p.get(C);let l;if(/^\w[\w\d+.-]*:\/\//.test(C))l=C;else{const n=`${w&&!m.isWeb?N.nodeModulesAsarPath:N.nodeModulesPath}/${C}`;l=N.FileAccess.asBrowserUri(n).toString(!0)}const f=v.INSTANCE.load(l);return p.set(C,f),f}else return await new Promise((C,l)=>{ge([I],C,l)})}e.importAMDNodeModule=L}),define(ye[23],Ce([1,0,33,17,16,11,13,2]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(w){return(0,v.uriToFsPath)(w,!0)}e.originalFSPath=p;class S{constructor(C){this._ignorePathCasing=C}compare(C,l,f=!1){return C===l?0:(0,R.compare)(this.getComparisonKey(C,f),this.getComparisonKey(l,f))}isEqual(C,l,f=!1){return C===l?!0:!C||!l?!1:this.getComparisonKey(C,f)===this.getComparisonKey(l,f)}getComparisonKey(C,l=!1){return C.with({path:this._ignorePathCasing(C)?C.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(C){return this._ignorePathCasing(C)}isEqualOrParent(C,l,f=!1){if(C.scheme===l.scheme){if(C.scheme===N.Schemas.file)return D.isEqualOrParent(p(C),p(l),this._ignorePathCasing(C))&&C.query===l.query&&(f||C.fragment===l.fragment);if((0,e.isEqualAuthority)(C.authority,l.authority))return D.isEqualOrParent(C.path,l.path,this._ignorePathCasing(C),"/")&&C.query===l.query&&(f||C.fragment===l.fragment)}return!1}joinPath(C,...l){return v.URI.joinPath(C,...l)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return m.posix.basename(C.path)}extname(C){return m.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let l;return C.scheme===N.Schemas.file?l=v.URI.file(m.dirname(p(C))).path:(l=m.posix.dirname(C.path),C.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),l="/")),C.with({path:l})}normalizePath(C){if(!C.path.length)return C;let l;return C.scheme===N.Schemas.file?l=v.URI.file(m.normalize(p(C))).path:l=m.posix.normalize(C.path),C.with({path:l})}relativePath(C,l){if(C.scheme!==l.scheme||!(0,e.isEqualAuthority)(C.authority,l.authority))return;if(C.scheme===N.Schemas.file){const i=m.relative(p(C),p(l));return k.isWindows?D.toSlashes(i):i}let f=C.path||"/";const s=l.path||"/";if(this._ignorePathCasing(C)){let i=0;for(const n=Math.min(f.length,s.length);i<n&&!(f.charCodeAt(i)!==s.charCodeAt(i)&&f.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);f=s.substr(0,i)+f.substr(i)}return m.posix.relative(f,s)}resolvePath(C,l){if(C.scheme===N.Schemas.file){const f=v.URI.file(m.resolve(p(C),l));return C.with({authority:f.authority,path:f.path})}return l=D.toPosixPath(l),C.with({path:m.posix.resolve(C.path,l)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,l){return C===l||C!==void 0&&l!==void 0&&(0,R.equalsIgnoreCase)(C,l)}hasTrailingPathSeparator(C,l=m.sep){if(C.scheme===N.Schemas.file){const f=p(C);return f.length>D.getRoot(f).length&&f[f.length-1]===l}else{const f=C.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,l=m.sep){return(0,e.hasTrailingPathSeparator)(C,l)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,l=m.sep){let f=!1;if(C.scheme===N.Schemas.file){const s=p(C);f=s!==void 0&&s.length===D.getRoot(s).length&&s[s.length-1]===l}else{l="/";const s=C.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(C,l)?C.with({path:C.path+"/"}):C}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(w=>w.scheme===N.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new S(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(w,C){const l=[];for(let f=0;f<w.length;f++){const s=C(w[f]);w.some((i,n)=>n===f?!1:(0,e.isEqualOrParent)(s,C(i)))||l.push(w[f])}return l}e.distinctParents=L;var I;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function C(l){const f=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&f.set(o,a)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&f.set(w.META_DATA_MIME,i),f}w.parseMetaData=C})(I||(e.DataUri=I={}));function g(w,C,l){if(C){let f=w.path;return f&&f[0]!==m.posix.sep&&(f=m.posix.sep+f),w.with({scheme:l,authority:C,path:f})}return w.with({scheme:l})}e.toLocalResource=g}),define(ye[12],Ce([1,0,21,8,4,3,23,11,163,43]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function L(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=L;function I(Z){const ie=new D.CancellationTokenSource,q=Z(ie.token),te=new Promise((fe,Ee)=>{const Te=ie.token.onCancellationRequested(()=>{Te.dispose(),ie.dispose(),Ee(new N.CancellationError)});Promise.resolve(q).then(ve=>{Te.dispose(),ie.dispose(),fe(ve)},ve=>{Te.dispose(),ie.dispose(),Ee(ve)})});return new class{cancel(){ie.cancel()}then(fe,Ee){return te.then(fe,Ee)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}e.createCancelablePromise=I;function g(Z,ie,q){return new Promise((te,fe)=>{const Ee=ie.onCancellationRequested(()=>{Ee.dispose(),te(q)});Z.then(te,fe).finally(()=>Ee.dispose())})}e.raceCancellation=g;function w(Z,ie){return new Promise((q,te)=>{const fe=ie.onCancellationRequested(()=>{fe.dispose(),te(new N.CancellationError)});Z.then(q,te).finally(()=>fe.dispose())})}e.raceCancellationError=w;async function C(Z){let ie=-1;const q=Z.map((te,fe)=>te.then(Ee=>(ie=fe,Ee)));try{return await Promise.race(q)}finally{Z.forEach((te,fe)=>{fe!==ie&&te.cancel()})}}e.raceCancellablePromises=C;function l(Z,ie,q){let te;const fe=setTimeout(()=>{te?.(void 0),q?.()},ie);return Promise.race([Z.finally(()=>clearTimeout(fe)),new Promise(Ee=>te=Ee)])}e.raceTimeout=l;function f(Z){return new Promise((ie,q)=>{const te=Z();L(te)?te.then(ie,q):ie(te)})}e.asPromise=f;class s{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ie){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=ie,!this.queuedPromise){const q=()=>{if(this.queuedPromise=null,this.isDisposed)return;const te=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,te};this.queuedPromise=new Promise(te=>{this.activePromise.then(q,q).then(te)})}return new Promise((q,te)=>{this.queuedPromise.then(q,te)})}return this.activePromise=ie(),new Promise((q,te)=>{this.activePromise.then(fe=>{this.activePromise=null,q(fe)},fe=>{this.activePromise=null,te(fe)})})}dispose(){this.isDisposed=!0}}e.Throttler=s;class i{constructor(){this.current=Promise.resolve(null)}queue(ie){return this.current=this.current.then(()=>ie(),()=>ie())}}e.Sequencer=i;class n{constructor(){this.promiseMap=new Map}queue(ie,q){const fe=(this.promiseMap.get(ie)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(ie)===fe&&this.promiseMap.delete(ie)});return this.promiseMap.set(ie,fe),fe}}e.SequencerByKey=n;const o=(Z,ie)=>{let q=!0;const te=setTimeout(()=>{q=!1,ie()},Z);return{isTriggered:()=>q,dispose:()=>{clearTimeout(te),q=!1}}},a=Z=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,Z())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class t{constructor(ie){this.defaultDelay=ie,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ie,q=this.defaultDelay){this.task=ie,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((fe,Ee)=>{this.doResolve=fe,this.doReject=Ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const fe=this.task;return this.task=null,fe()}}));const te=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=q===p.MicrotaskDelay?a(te):o(q,te),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new N.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=t;class r{constructor(ie){this.delayer=new t(ie),this.throttler=new s}trigger(ie,q){return this.delayer.trigger(()=>this.throttler.queue(ie),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=r;class h{constructor(){this._isOpen=!1,this._promise=new Promise((ie,q)=>{this._completePromise=ie})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class u extends h{constructor(ie){super(),this._timeout=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function c(Z,ie){return ie?new Promise((q,te)=>{const fe=setTimeout(()=>{Ee.dispose(),q()},Z),Ee=ie.onCancellationRequested(()=>{clearTimeout(fe),Ee.dispose(),te(new N.CancellationError)})}):I(q=>c(Z,q))}e.timeout=c;function d(Z,ie=0,q){const te=setTimeout(()=>{Z(),q&&fe.dispose()},ie),fe=(0,k.toDisposable)(()=>{clearTimeout(te),q?.deleteAndLeak(fe)});return q?.add(fe),fe}e.disposableTimeout=d;function y(Z){const ie=[];let q=0;const te=Z.length;function fe(){return q<te?Z[q++]():null}function Ee(Te){Te!=null&&ie.push(Te);const ve=fe();return ve?ve.then(Ee):Promise.resolve(ie)}return Promise.resolve(null).then(Ee)}e.sequence=y;function A(Z,ie=te=>!!te,q=null){let te=0;const fe=Z.length,Ee=()=>{if(te>=fe)return Promise.resolve(q);const Te=Z[te++];return Promise.resolve(Te()).then(De=>ie(De)?Promise.resolve(De):Ee())};return Ee()}e.first=A;function E(Z,ie=te=>!!te,q=null){if(Z.length===0)return Promise.resolve(q);let te=Z.length;const fe=()=>{te=-1;for(const Ee of Z)Ee.cancel?.()};return new Promise((Ee,Te)=>{for(const ve of Z)ve.then(De=>{--te>=0&&ie(De)?(fe(),Ee(De)):te===0&&Ee(q)}).catch(De=>{--te>=0&&(fe(),Te(De))})})}e.firstParallel=E;class b{constructor(ie){this._size=0,this.maxDegreeOfParalellism=ie,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new m.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ie){return this._size++,new Promise((q,te)=>{this.outstandingPromises.push({factory:ie,c:q,e:te}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ie=this.outstandingPromises.shift();this.runningPromises++;const q=ie.factory();q.then(ie.c,ie.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=b;class _ extends b{constructor(){super(1)}}e.Queue=_;class T{constructor(){this.sequentializer=new X,this.tasks=0}queue(ie){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,ie())):this.sequentializer.run(this.tasks++,ie())}}e.LimitedQueue=T;class U{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const ie=new Q;return this.drainers.add(ie),ie.p}isDrained(){for(const[,ie]of this.queues)if(ie.size>0)return!1;return!0}queueFor(ie,q=R.extUri){const te=q.getComparisonKey(ie);let fe=this.queues.get(te);if(!fe){fe=new _;const Ee=this.drainListenerCount++,Te=m.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.queues.delete(te),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ee),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new k.DisposableMap),this.drainListeners.set(Ee,Te),this.queues.set(te,fe)}return fe}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const ie of this.drainers)ie.complete();this.drainers.clear()}dispose(){for(const[,ie]of this.queues)ie.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=U;class M{constructor(ie,q){this._token=-1,typeof ie=="function"&&typeof q=="number"&&this.setIfNotSet(ie,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ie,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ie()},q)}setIfNotSet(ie,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ie()},q))}}e.TimeoutTimer=M;class P{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(ie,q,te=globalThis){this.cancel();const fe=te.setInterval(()=>{ie()},q);this.disposable=(0,k.toDisposable)(()=>{te.clearInterval(fe),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=P;class x{constructor(ie,q){this.timeoutToken=-1,this.runner=ie,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ie=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ie)}get delay(){return this.timeout}set delay(ie){this.timeout=ie}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class F{constructor(ie,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=ie,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ie=this.timeout){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ie/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class O extends x{constructor(ie,q){super(ie,q),this.units=[]}work(ie){this.units.push(ie),this.isScheduled()||this.schedule()}doRun(){const ie=this.units;this.units=[],this.runner?.(ie)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class W extends k.Disposable{constructor(ie,q){super(),this.options=ie,this.handler=q,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ie){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ie.length>this.options.maxBufferedWork)return!1}else if(this.pending+ie.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const q of ie)this.pendingWork.push(q);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Z,ie)=>{(0,v.setTimeout0)(()=>{if(q)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e._runWhenIdle=(Z,ie,q)=>{const te=Z.requestIdleCallback(ie,typeof q=="number"?{timeout:q}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,Z.cancelIdleCallback(te))}}},e.runWhenGlobalIdle=Z=>(0,e._runWhenIdle)(globalThis,Z)}();class J{constructor(ie,q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(te){this._error=te}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(ie,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=J;class ce extends J{constructor(ie){super(globalThis,ie)}}e.GlobalIdleValue=ce;async function G(Z,ie,q){let te;for(let fe=0;fe<q;fe++)try{return await Z()}catch(Ee){te=Ee,await c(ie)}throw te}e.retry=G;class X{isRunning(ie){return typeof ie=="number"?this._running?.taskId===ie:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(ie,q,te){return this._running={taskId:ie,cancel:()=>te?.(),promise:q},q.then(()=>this.doneRunning(ie),()=>this.doneRunning(ie)),q}doneRunning(ie){this._running&&ie===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const ie=this._queued;this._queued=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this._queued)this._queued.run=ie;else{let q,te;const fe=new Promise((Ee,Te)=>{q=Ee,te=Te});this._queued={run:ie,promise:fe,promiseResolve:q,promiseReject:te}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=X;class Y{constructor(ie,q=()=>Date.now()){this.interval=ie,this.nowFn=q,this.lastIncrementTime=0,this.value=0}increment(){const ie=this.nowFn();return ie-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ie,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;var se;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(se||(se={}));class Q{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((ie,q)=>{this.completeCallback=ie,this.errorCallback=q})}complete(ie){return new Promise(q=>{this.completeCallback(ie),this.outcome={outcome:0,value:ie},q()})}error(ie){return new Promise(q=>{this.errorCallback(ie),this.outcome={outcome:1,value:ie},q()})}cancel(){return this.error(new N.CancellationError)}}e.DeferredPromise=Q;var we;(function(Z){async function ie(te){let fe;const Ee=await Promise.all(te.map(Te=>Te.then(ve=>ve,ve=>{fe||(fe=ve)})));if(typeof fe<"u")throw fe;return Ee}Z.settled=ie;function q(te){return new Promise(async(fe,Ee)=>{try{await te(fe,Ee)}catch(Te){Ee(Te)}})}Z.withAsyncBody=q})(we||(e.Promises=we={}));class he{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(ie){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=ie.then(q=>(this._value=q,this._isResolved=!0,q),q=>{throw this._error=q,this._isResolved=!0,q})}requireValue(){if(!this._isResolved)throw new N.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=he;class j{constructor(ie){this._compute=ie,this._promise=new S.Lazy(()=>new he(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}}e.LazyStatefulPromise=j;var z;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(z||(z={}));class ne{static fromArray(ie){return new ne(q=>{q.emitMany(ie)})}static fromPromise(ie){return new ne(async q=>{q.emitMany(await ie)})}static fromPromises(ie){return new ne(async q=>{await Promise.all(ie.map(async te=>q.emitOne(await te)))})}static merge(ie){return new ne(async q=>{await Promise.all(ie.map(async te=>{for await(const fe of te)q.emitOne(fe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this._state=0,this._results=[],this._error=null,this._onStateChanged=new m.Emitter,queueMicrotask(async()=>{const q={emitOne:te=>this.emitOne(te),emitMany:te=>this.emitMany(te),reject:te=>this.reject(te)};try{await Promise.resolve(ie(q)),this.resolve()}catch(te){this.reject(te)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ie<this._results.length)return{done:!1,value:this._results[ie++]};if(this._state===1)return{done:!0,value:void 0};await m.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ie,q){return new ne(async te=>{for await(const fe of ie)te.emitOne(q(fe))})}map(ie){return ne.map(this,ie)}static filter(ie,q){return new ne(async te=>{for await(const fe of ie)q(fe)&&te.emitOne(fe)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,q=>!!q)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const q=[];for await(const te of ie)q.push(te);return q}toPromise(){return ne.toPromise(this)}emitOne(ie){this._state===0&&(this._results.push(ie),this._onStateChanged.fire())}emitMany(ie){this._state===0&&(this._results=this._results.concat(ie),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ie){this._state===0&&(this._state=2,this._error=ie,this._onStateChanged.fire())}}e.AsyncIterableObject=ne;class Se extends ne{constructor(ie,q){super(q),this._source=ie}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Se;function de(Z){const ie=new D.CancellationTokenSource,q=Z(ie.token);return new Se(ie,async te=>{const fe=ie.token.onCancellationRequested(()=>{fe.dispose(),ie.dispose(),te.reject(new N.CancellationError)});try{for await(const Ee of q){if(ie.token.isCancellationRequested)return;te.emitOne(Ee)}fe.dispose(),ie.dispose()}catch(Ee){fe.dispose(),ie.dispose(),te.reject(Ee)}})}e.createCancelableAsyncIterable=de;class me{constructor(){this._deferred=new Q,this._asyncIterable=new ne(te=>{if(ie){te.reject(ie);return}return q&&te.emitMany(q),this._errorFn=fe=>te.reject(fe),this._emitFn=fe=>te.emitOne(fe),this._deferred.p});let ie,q;this._emitFn=te=>{q||(q=[]),q.push(te)},this._errorFn=te=>{ie||(ie=te)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(ie){this._errorFn(ie),this._deferred.complete()}emitOne(ie){this._emitFn(ie)}}e.AsyncIterableSource=me}),define(ye[34],Ce([1,0,19,12,33,28,16,11,13]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",I="[^/\\\\]",g=/\//g;function w(ce,G){switch(ce){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${G?`|${L}${I}+`:""})*?`}}function C(ce,G){if(!ce)return[];const X=[];let Y=!1,se=!1,Q="";for(const we of ce){switch(we){case G:if(!Y&&!se){X.push(Q),Q="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":se=!0;break;case"]":se=!1;break}Q+=we}return Q&&X.push(Q),X}e.splitGlobAware=C;function l(ce){if(!ce)return"";let G="";const X=C(ce,e.GLOB_SPLIT);if(X.every(Y=>Y===e.GLOBSTAR))G=".*";else{let Y=!1;X.forEach((se,Q)=>{if(se===e.GLOBSTAR){if(Y)return;G+=w(2,Q===X.length-1)}else{let we=!1,he="",j=!1,z="";for(const ne of se){if(ne!=="}"&&we){he+=ne;continue}if(j&&(ne!=="]"||!z)){let Se;ne==="-"?Se=ne:(ne==="^"||ne==="!")&&!z?Se="^":ne===e.GLOB_SPLIT?Se="":Se=(0,p.escapeRegExpCharacters)(ne),z+=Se;continue}switch(ne){case"{":we=!0;continue;case"[":j=!0;continue;case"}":{const de=`(?:${C(he,",").map(me=>l(me)).join("|")})`;G+=de,we=!1,he="";break}case"]":{G+="["+z+"]",j=!1,z="";break}case"?":G+=I;continue;case"*":G+=w(1);continue;default:G+=(0,p.escapeRegExpCharacters)(ne)}}Q<X.length-1&&(X[Q+1]!==e.GLOBSTAR||Q+2<X.length)&&(G+=L)}Y=se===e.GLOBSTAR})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},h=function(){return null};function u(ce,G){if(!ce)return h;let X;typeof ce!="string"?X=ce.pattern:X=ce,X=X.trim();const Y=`${X}_${!!G.trimForExclusions}`;let se=t.get(Y);if(se)return c(se,ce);let Q;return f.test(X)?se=y(X.substr(4),X):(Q=s.exec(d(X,G)))?se=A(Q[1],X):(G.trimForExclusions?n:i).test(X)?se=E(X,G):(Q=o.exec(d(X,G)))?se=b(Q[1].substr(1),X,!0):(Q=a.exec(d(X,G)))?se=b(Q[1],X,!1):se=_(X),t.set(Y,se),c(se,ce)}function c(ce,G){if(typeof G=="string")return ce;const X=function(Y,se){return(0,m.isEqualOrParent)(Y,G.base,!v.isLinux)?ce((0,p.ltrim)(Y.substr(G.base.length),R.sep),se):null};return X.allBasenames=ce.allBasenames,X.allPaths=ce.allPaths,X.basenames=ce.basenames,X.patterns=ce.patterns,X}function d(ce,G){return G.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function y(ce,G){return function(X,Y){return typeof X=="string"&&X.endsWith(ce)?G:null}}function A(ce,G){const X=`/${ce}`,Y=`\\${ce}`,se=function(we,he){return typeof we!="string"?null:he?he===ce?G:null:we===ce||we.endsWith(X)||we.endsWith(Y)?G:null},Q=[ce];return se.basenames=Q,se.patterns=[G],se.allBasenames=Q,se}function E(ce,G){const X=W(ce.slice(1,-1).split(",").map(he=>u(he,G)).filter(he=>he!==h),ce),Y=X.length;if(!Y)return h;if(Y===1)return X[0];const se=function(he,j){for(let z=0,ne=X.length;z<ne;z++)if(X[z](he,j))return ce;return null},Q=X.find(he=>!!he.allBasenames);Q&&(se.allBasenames=Q.allBasenames);const we=X.reduce((he,j)=>j.allPaths?he.concat(j.allPaths):he,[]);return we.length&&(se.allPaths=we),se}function b(ce,G,X){const Y=R.sep===R.posix.sep,se=Y?ce:ce.replace(g,R.sep),Q=R.sep+se,we=R.posix.sep+ce;let he;return X?he=function(j,z){return typeof j=="string"&&(j===se||j.endsWith(Q)||!Y&&(j===ce||j.endsWith(we)))?G:null}:he=function(j,z){return typeof j=="string"&&(j===se||!Y&&j===ce)?G:null},he.allPaths=[(X?"*/":"./")+ce],he}function _(ce){try{const G=new RegExp(`^${l(ce)}$`);return function(X){return G.lastIndex=0,typeof X=="string"&&G.test(X)?ce:null}}catch{return h}}function T(ce,G,X){return!ce||typeof G!="string"?!1:U(ce)(G,void 0,X)}e.match=T;function U(ce,G={}){if(!ce)return r;if(typeof ce=="string"||M(ce)){const X=u(ce,G);if(X===h)return r;const Y=function(se,Q){return!!X(se,Q)};return X.allBasenames&&(Y.allBasenames=X.allBasenames),X.allPaths&&(Y.allPaths=X.allPaths),Y}return F(ce,G)}e.parse=U;function M(ce){const G=ce;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.isRelativePattern=M;function P(ce){return ce.allBasenames||[]}e.getBasenameTerms=P;function x(ce){return ce.allPaths||[]}e.getPathTerms=x;function F(ce,G){const X=W(Object.getOwnPropertyNames(ce).map(he=>O(he,ce[he],G)).filter(he=>he!==h)),Y=X.length;if(!Y)return h;if(!X.some(he=>!!he.requiresSiblings)){if(Y===1)return X[0];const he=function(ne,Se){let de;for(let me=0,Z=X.length;me<Z;me++){const ie=X[me](ne,Se);if(typeof ie=="string")return ie;(0,N.isThenable)(ie)&&(de||(de=[]),de.push(ie))}return de?(async()=>{for(const me of de){const Z=await me;if(typeof Z=="string")return Z}return null})():null},j=X.find(ne=>!!ne.allBasenames);j&&(he.allBasenames=j.allBasenames);const z=X.reduce((ne,Se)=>Se.allPaths?ne.concat(Se.allPaths):ne,[]);return z.length&&(he.allPaths=z),he}const se=function(he,j,z){let ne,Se;for(let de=0,me=X.length;de<me;de++){const Z=X[de];Z.requiresSiblings&&z&&(j||(j=(0,R.basename)(he)),ne||(ne=j.substr(0,j.length-(0,R.extname)(he).length)));const ie=Z(he,j,ne,z);if(typeof ie=="string")return ie;(0,N.isThenable)(ie)&&(Se||(Se=[]),Se.push(ie))}return Se?(async()=>{for(const de of Se){const me=await de;if(typeof me=="string")return me}return null})():null},Q=X.find(he=>!!he.allBasenames);Q&&(se.allBasenames=Q.allBasenames);const we=X.reduce((he,j)=>j.allPaths?he.concat(j.allPaths):he,[]);return we.length&&(se.allPaths=we),se}function O(ce,G,X){if(G===!1)return h;const Y=u(ce,X);if(Y===h)return h;if(typeof G=="boolean")return Y;if(G){const se=G.when;if(typeof se=="string"){const Q=(we,he,j,z)=>{if(!z||!Y(we,he))return null;const ne=se.replace("$(basename)",()=>j),Se=z(ne);return(0,N.isThenable)(Se)?Se.then(de=>de?ce:null):Se?ce:null};return Q.requiresSiblings=!0,Q}}return Y}function W(ce,G){const X=ce.filter(he=>!!he.basenames);if(X.length<2)return ce;const Y=X.reduce((he,j)=>{const z=j.basenames;return z?he.concat(z):he},[]);let se;if(G){se=[];for(let he=0,j=Y.length;he<j;he++)se.push(G)}else se=X.reduce((he,j)=>{const z=j.patterns;return z?he.concat(z):he},[]);const Q=function(he,j){if(typeof he!="string")return null;if(!j){let ne;for(ne=he.length;ne>0;ne--){const Se=he.charCodeAt(ne-1);if(Se===47||Se===92)break}j=he.substr(ne)}const z=Y.indexOf(j);return z!==-1?se[z]:null};Q.basenames=Y,Q.patterns=se,Q.allBasenames=Y;const we=ce.filter(he=>!he.basenames);return we.push(Q),we}function J(ce,G){return(0,D.equals)(ce,G,(X,Y)=>typeof X=="string"&&typeof Y=="string"?X===Y:typeof X!="string"&&typeof Y!="string"?X.base===Y.base&&X.pattern===Y.pattern:!1)}e.patternsEquals=J}),define(ye[80],Ce([1,0,8,164,23,13,2]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var v;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(v||(e.MarkdownStringTextNewlineStyle=v={}));class p{constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=g(this.supportThemeIcons?(0,N.escapeIcons)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(s),")"),n&&(this.value+=` "${this._escape(this._escape(n,'"'),")")}"`),this.value+=")",this}_escape(s,i){const n=new RegExp((0,k.escapeRegExpCharacters)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.MarkdownString=p;function S(f){return L(f)?!f.value:Array.isArray(f)?f.every(S):!0}e.isEmptyMarkdownString=S;function L(f){return f instanceof p?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function I(f,s){return f===s?!0:!f||!s?!1:f.value===s.value&&f.isTrusted===s.isTrusted&&f.supportThemeIcons===s.supportThemeIcons&&f.supportHtml===s.supportHtml&&(f.baseUri===s.baseUri||!!f.baseUri&&!!s.baseUri&&(0,m.isEqual)(R.URI.from(f.baseUri),R.URI.from(s.baseUri)))}e.markdownStringEqual=I;function g(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function w(f){return f.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=w;function C(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function l(f){const s=[],i=f.split("|").map(o=>o.trim());f=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",h=isFinite(parseInt(r)),u=isFinite(parseInt(t));h&&s.push(`width="${r}"`),u&&s.push(`height="${t}"`)}return{href:f,dimensions:s}}e.parseHrefAndDimensions=l}),define(ye[102],Ce([1,0,19,33,16,11,23,13]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(u,c){const{os:d,tildify:y,relative:A}=c;if(A){const _=S(u,A,d);if(typeof _=="string")return _}let E=u.fsPath;if(d===1&&!k.isWindows?E=E.replace(/\//g,"\\"):d!==1&&k.isWindows&&(E=E.replace(/\\/g,"/")),d!==1&&y?.userHome){const _=y.userHome.fsPath;let T;u.scheme!==y.userHome.scheme&&u.path[0]===m.posix.sep&&u.path[1]!==m.posix.sep?T=y.userHome.with({path:u.path}).fsPath:T=E,E=g(T,_,d)}return(d===1?m.win32:m.posix).normalize(L(E,d===1))}e.getPathLabel=p;function S(u,c,d){const y=d===1?m.win32:m.posix,A=d===3?R.extUri:R.extUriIgnorePathCase,E=c.getWorkspace(),b=(0,D.firstOrDefault)(E.folders);if(!b)return;u.scheme!==b.uri.scheme&&u.path[0]===m.posix.sep&&u.path[1]!==m.posix.sep&&(u=b.uri.with({path:u.path}));const _=c.getWorkspaceFolder(u);if(!_)return;let T;if(A.isEqual(_.uri,u)?T="":T=A.relativePath(_.uri,u)??"",T&&(T=y.normalize(T)),E.folders.length>1&&!c.noPrefix){const U=_.name?_.name:A.basenameOrAuthority(_.uri);T=T?`${U} \u2022 ${T}`:U}return T}function L(u,c=k.isWindows){return(0,N.hasDriveLetter)(u,c)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=L;let I=Object.create(null);function g(u,c,d=k.OS){if(d===1||!u||!c)return u;let y=I.original===c?I.normalized:void 0;y||(y=c,k.isWindows&&(y=(0,N.toSlashes)(y)),y=`${(0,v.rtrim)(y,m.posix.sep)}${m.posix.sep}`,I={original:c,normalized:y});let A=u;return k.isWindows&&(A=(0,N.toSlashes)(A)),(d===3?A.startsWith(y):(0,v.startsWithIgnoreCase)(A,y))?`~/${A.substr(y.length)}`:u}e.tildify=g;function w(u,c){return u.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=w;const C="\u2026",l="\\\\",f="~";function s(u,c=m.sep){const d=new Array(u.length);let y=!1;for(let A=0;A<u.length;A++){const E=u[A];if(E===""){d[A]=`.${c}`;continue}if(!E){d[A]=E;continue}y=!0;let b="",_=E;_.indexOf(l)===0?(b=_.substr(0,_.indexOf(l)+l.length),_=_.substr(_.indexOf(l)+l.length)):_.indexOf(c)===0?(b=_.substr(0,_.indexOf(c)+c.length),_=_.substr(_.indexOf(c)+c.length)):_.indexOf(f)===0&&(b=_.substr(0,_.indexOf(f)+f.length),_=_.substr(_.indexOf(f)+f.length));const T=_.split(c);for(let U=1;y&&U<=T.length;U++)for(let M=T.length-U;y&&M>=0;M--){y=!1;let P=T.slice(M,M+U).join(c);for(let x=0;!y&&x<u.length;x++)if(x!==A&&u[x]&&u[x].indexOf(P)>-1){const F=M+U===T.length,O=M>0&&u[x].indexOf(c)>-1?c+P:P,W=u[x].endsWith(O);y=!F||W}if(!y){let x="";(T[0].endsWith(":")||b!=="")&&(M===1&&(M=0,U++,P=T[0]+c+P),M>0&&(x=T[0]+c),x=b+x),M>0&&(x=x+C+c),x=x+P,M+U<T.length&&(x=x+c+C),d[A]=x}}y&&(d[A]=E)}return d}e.shorten=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,c=Object.create(null)){const d=[];let y=!1,A="";for(const E of u)if(E==="$"||y&&E==="{")A&&d.push({value:A,type:i.TEXT}),A="",y=!0;else if(E==="}"&&y){const b=c[A];if(typeof b=="string")b.length&&d.push({value:b,type:i.VARIABLE});else if(b){const _=d[d.length-1];(!_||_.type!==i.SEPARATOR)&&d.push({value:b.label,type:i.SEPARATOR})}A="",y=!1}else A+=E;return A&&!y&&d.push({value:A,type:i.TEXT}),d.filter((E,b)=>{if(E.type===i.SEPARATOR){const _=d[b-1],T=d[b+1];return[_,T].every(U=>U&&(U.type===i.VARIABLE||U.type===i.TEXT)&&U.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=n;function o(u,c){return k.isMacintosh||c?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):u.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function a(u,c){return k.isMacintosh||c?u.replace(/\(&&\w\)|&&/g,""):k.isWindows?u.replace(/&&|&/g,d=>d==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function t(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=t;function r(u){if(u.endsWith("]")){const c=u.lastIndexOf(" [",u.length-2);if(c!==-1){const d=h(u.substring(0,c));return{name:d.name,parentPath:d.parentPath+u.substring(c)}}}return h(u)}e.splitRecentLabel=r;function h(u){const c=u.indexOf("/")!==-1?m.posix:m.win32,d=c.basename(u),y=c.dirname(u);return d.length?{name:d,parentPath:y}:{name:y,parentPath:""}}}),define(ye[130],Ce([1,0,22,2]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function m(I){return I.toJSON()}class k{constructor(g){this._uriTransformer=g}transformIncoming(g){const w=this._uriTransformer.transformIncoming(g);return w===g?g:m(N.URI.from(w))}transformOutgoing(g){const w=this._uriTransformer.transformOutgoing(g);return w===g?g:m(N.URI.from(w))}transformOutgoingURI(g){const w=this._uriTransformer.transformOutgoing(g);return w===g?g:N.URI.from(w)}transformOutgoingScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,g,w){if(!I||w>200)return null;if(typeof I=="object"){if(I instanceof N.URI)return g.transformOutgoing(I);for(const C in I)if(Object.hasOwnProperty.call(I,C)){const l=R(I[C],g,w+1);l!==null&&(I[C]=l)}}return null}function v(I,g){const w=R(I,g,0);return w===null?I:w}e.transformOutgoingURIs=v;function p(I,g,w,C){if(!I||C>200)return null;if(typeof I=="object"){if(I.$mid===1)return w?N.URI.revive(g.transformIncoming(I)):g.transformIncoming(I);if(I instanceof D.VSBuffer)return null;for(const l in I)if(Object.hasOwnProperty.call(I,l)){const f=p(I[l],g,w,C+1);f!==null&&(I[l]=f)}}return null}function S(I,g){const w=p(I,g,!1,0);return w===null?I:w}e.transformIncomingURIs=S;function L(I,g){const w=p(I,g,!0,0);return w===null?I:w}e.transformAndReviveIncomingURIs=L}),define(ye[31],Ce([1,0,55,63,385,12,33,76,16,11,23,2]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function w(O,W=g.UNLINK,J){if((0,R.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return W===g.UNLINK?l(O):C(O,J)}async function C(O,W=(0,R.randomPath)((0,N.tmpdir)())){try{try{await D.promises.rename(O,W)}catch(J){return J.code==="ENOENT"?void 0:l(O)}l(W).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function l(O){return(0,m.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function f(O){if((0,R.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function s(O,W){return o(await(W?i(O):(0,m.promisify)(D.readdir)(O)))}async function i(O){try{return await(0,m.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const W=[],J=await s(O);for(const ce of J){let G=!1,X=!1,Y=!1;try{const se=await e.Promises.lstat((0,p.join)(O,ce));G=se.isFile(),X=se.isDirectory(),Y=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}W.push({name:ce,isFile:()=>G,isDirectory:()=>X,isSymbolicLink:()=>Y})}return W}function n(O){return o(D.readdirSync(O))}e.readdirSync=n;function o(O){return O.map(W=>typeof W=="string"?S.isMacintosh?(0,v.normalizeNFC)(W):W:(W.name=S.isMacintosh?(0,v.normalizeNFC)(W.name):W.name,W))}async function a(O){const W=await s(O),J=[];for(const ce of W)await r.existsDirectory((0,p.join)(O,ce))&&J.push(ce);return J}function t(O,W=1e3){return new Promise(J=>{let ce=!1;const G=setInterval(()=>{ce||(ce=!0,D.access(O,X=>{ce=!1,X&&(clearInterval(G),J(void 0))}))},W)})}e.whenDeleted=t;var r;(function(O){async function W(G){let X;try{if(X=await e.Promises.lstat(G),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(S.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw se}throw Y}}O.stat=W;async function J(G){try{const{stat:X,symbolicLink:Y}=await O.stat(G);return X.isFile()&&Y?.dangling!==!0}catch{}return!1}O.existsFile=J;async function ce(G){try{const{stat:X,symbolicLink:Y}=await O.stat(G);return X.isDirectory()&&Y?.dangling!==!0}catch{}return!1}O.existsDirectory=ce})(r||(e.SymlinkSupport=r={}));const h=new k.ResourceQueue;function u(O,W,J){return h.queueFor(I.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const ce=E(J);return new Promise((G,X)=>y(O,W,ce,Y=>Y?X(Y):G()))})}let c=!0;function d(O){c=O}e.configureFlushOnWrite=d;function y(O,W,J,ce){if(!c)return D.writeFile(O,W,{mode:J.mode,flag:J.flag},ce);D.open(O,J.flag,J.mode,(G,X)=>{if(G)return ce(G);D.writeFile(X,W,Y=>{if(Y)return D.close(X,()=>ce(Y));D.fdatasync(X,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),d(!1)),D.close(X,Q=>ce(Q))))})})}function A(O,W,J){const ce=E(J);if(!c)return D.writeFileSync(O,W,{mode:ce.mode,flag:ce.flag});const G=D.openSync(O,ce.flag,ce.mode);try{D.writeFileSync(G,W);try{D.fdatasyncSync(G)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),d(!1)}}finally{D.closeSync(G)}}e.writeFileSync=A;function E(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function b(O,W,J=6e4){if(O!==W)try{S.isWindows&&typeof J=="number"?await _(O,W,Date.now(),J):await(0,m.promisify)(D.rename)(O,W)}catch(ce){if(O.toLowerCase()!==W.toLowerCase()&&ce.code==="EXDEV"||O.endsWith("."))await T(O,W,{preserveSymlinks:!1}),await w(O,g.MOVE);else throw ce}}async function _(O,W,J,ce,G=0){try{return await(0,m.promisify)(D.rename)(O,W)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-J>=ce)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${X}`),X;if(G===0){let Y=!1;try{const{stat:se}=await r.stat(W);se.isFile()||(Y=!0)}catch{}if(Y)throw X}return await(0,k.timeout)(Math.min(100,G*10)),_(O,W,J,ce,G+1)}}async function T(O,W,J){return M(O,W,{root:{source:O,target:W},options:J,handledSourcePaths:new Set})}const U=511;async function M(O,W,J){if(J.handledSourcePaths.has(O))return;J.handledSourcePaths.add(O);const{stat:ce,symbolicLink:G}=await r.stat(O);if(G){if(J.options.preserveSymlinks)try{return await F(O,W,J)}catch{}if(G.dangling)return}return ce.isDirectory()?P(O,W,ce.mode&U,J):x(O,W,ce.mode&U)}async function P(O,W,J,ce){await e.Promises.mkdir(W,{recursive:!0,mode:J});const G=await s(O);for(const X of G)await M((0,p.join)(O,X),(0,p.join)(W,X),ce)}async function x(O,W,J){await e.Promises.copyFile(O,W),await e.Promises.chmod(W,J)}async function F(O,W,J){let ce=await e.Promises.readlink(O);(0,R.isEqualOrParent)(ce,J.root.source,!S.isLinux)&&(ce=(0,p.join)(J.root.target,ce.substr(J.root.source.length+1))),await e.Promises.symlink(ce,W)}e.Promises=new class{get access(){return(0,m.promisify)(D.access)}get stat(){return(0,m.promisify)(D.stat)}get lstat(){return(0,m.promisify)(D.lstat)}get utimes(){return(0,m.promisify)(D.utimes)}get read(){return(O,W,J,ce,G)=>new Promise((X,Y)=>{D.read(O,W,J,ce,G,(se,Q,we)=>se?Y(se):X({bytesRead:Q,buffer:we}))})}get readFile(){return(0,m.promisify)(D.readFile)}get write(){return(O,W,J,ce,G)=>new Promise((X,Y)=>{D.write(O,W,J,ce,G,(se,Q,we)=>se?Y(se):X({bytesWritten:Q,buffer:we}))})}get appendFile(){return(0,m.promisify)(D.appendFile)}get fdatasync(){return(0,m.promisify)(D.fdatasync)}get truncate(){return(0,m.promisify)(D.truncate)}get copyFile(){return(0,m.promisify)(D.copyFile)}get open(){return(0,m.promisify)(D.open)}get close(){return(0,m.promisify)(D.close)}get symlink(){return(0,m.promisify)(D.symlink)}get readlink(){return(0,m.promisify)(D.readlink)}get chmod(){return(0,m.promisify)(D.chmod)}get mkdir(){return(0,m.promisify)(D.mkdir)}get unlink(){return(0,m.promisify)(D.unlink)}get rmdir(){return(0,m.promisify)(D.rmdir)}get realpath(){return(0,m.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return w}get rename(){return b}get copy(){return T}}}),define(ye[103],Ce([1,0,55,16,11,13,31]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function v(g){if(m.isLinux)return g;const w=(0,N.dirname)(g);if(g===w)return g;const C=((0,N.basename)(g)||g).toLowerCase();try{const f=(0,R.readdirSync)(w).filter(s=>s.toLowerCase()===C);if(f.length===1){const s=v(w);if(s)return(0,N.join)(s,f[0])}else if(f.length>1){const s=f.indexOf(C);if(s>=0){const i=v(w);if(i)return(0,N.join)(i,f[s])}}}catch{}return null}e.realcaseSync=v;async function p(g){if(m.isLinux)return g;const w=(0,N.dirname)(g);if(g===w)return g;const C=((0,N.basename)(g)||g).toLowerCase();try{const f=(await R.Promises.readdir(w)).filter(s=>s.toLowerCase()===C);if(f.length===1){const s=await p(w);if(s)return(0,N.join)(s,f[0])}else if(f.length>1){const s=f.indexOf(C);if(s>=0){const i=await p(w);if(i)return(0,N.join)(i,f[s])}}}catch{}return null}e.realcase=p;async function S(g){try{return await R.Promises.realpath(g)}catch{const C=I(g);return await R.Promises.access(C,D.constants.R_OK),C}}e.realpath=S;function L(g){try{return D.realpathSync(g)}catch{const C=I(g);return D.accessSync(C,D.constants.R_OK),C}}e.realpathSync=L;function I(g){return(0,k.rtrim)((0,N.normalize)(g),N.sep)}}),define(ye[104],Ce([1,0,16,11,50,101,18,31]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function p(I=m.env){return I.comspec||"cmd.exe"}e.getWindowsShell=p;function S(I){let g=[],w=!1;const C=function(l){if(w){g.push(l);return}(!I.send(l,s=>{if(s&&console.error(s),w=!1,g.length>0){const i=g.slice(0);g=[],i.forEach(n=>C(n))}})||N.isWindows)&&(w=!0)};return{send:C}}e.createQueuedSender=S;var L;(function(I){async function g(w,C,l){if(D.isAbsolute(w))return w;if(C===void 0&&(C=m.cwd()),D.dirname(w)!=="."||(l===void 0&&R.isString(m.env.PATH)&&(l=m.env.PATH.split(D.delimiter)),l===void 0||l.length===0))return D.join(C,w);async function s(i){if(await v.Promises.exists(i)){let n;try{n=await v.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await v.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of l){let n;if(D.isAbsolute(i)?n=D.join(i,w):n=D.join(C,i,w),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return D.join(C,w)}I.findExecutable=g})(L||(e.win32=L={}))});var Ge=this&&this.__decorate||function(ge,e,D,N){var m=arguments.length,k=m<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(ge,e,D,N);else for(var v=ge.length-1;v>=0;v--)(R=ge[v])&&(k=(m<3?R(k):m>3?R(e,D,k):R(e,D))||k);return m>3&&k&&Object.defineProperty(e,D,k),k};define(ye[81],Ce([1,0,19,12,22,21,59,8,4,3,54,13,18]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var w;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(w||(w={}));function C(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(l||(l={}));function f(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(s||(s={}));function i(G){let X=0;for(let Y=0;;Y+=7){const se=G.read(1);if(X|=(se.buffer[0]&127)<<Y,!(se.buffer[0]&128))return X}}const n=h(0);function o(G,X){if(X===0){G.write(n);return}let Y=0;for(let Q=X;Q!==0;Q=Q>>>7)Y++;const se=m.VSBuffer.alloc(Y);for(let Q=0;X!==0;Q++)se.buffer[Q]=X&127,X=X>>>7,X>0&&(se.buffer[Q]|=128);G.write(se)}class a{constructor(X){this.buffer=X,this.pos=0}read(X){const Y=this.buffer.slice(this.pos,this.pos+X);return this.pos+=Y.byteLength,Y}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return m.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}e.BufferWriter=t;var r;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(r||(r={}));function h(G){const X=m.VSBuffer.alloc(1);return X.writeUInt8(G,0),X}const u={Undefined:h(r.Undefined),String:h(r.String),Buffer:h(r.Buffer),VSBuffer:h(r.VSBuffer),Array:h(r.Array),Object:h(r.Object),Uint:h(r.Int)},c=typeof Buffer<"u";function d(G,X){if(typeof X>"u")G.write(u.Undefined);else if(typeof X=="string"){const Y=m.VSBuffer.fromString(X);G.write(u.String),o(G,Y.byteLength),G.write(Y)}else if(c&&Buffer.isBuffer(X)){const Y=m.VSBuffer.wrap(X);G.write(u.Buffer),o(G,Y.byteLength),G.write(Y)}else if(X instanceof m.VSBuffer)G.write(u.VSBuffer),o(G,X.byteLength),G.write(X);else if(Array.isArray(X)){G.write(u.Array),o(G,X.length);for(const Y of X)d(G,Y)}else if(typeof X=="number"&&(X|0)===X)G.write(u.Uint),o(G,X);else{const Y=m.VSBuffer.fromString(JSON.stringify(X));G.write(u.Object),o(G,Y.byteLength),G.write(Y)}}e.serialize=d;function y(G){switch(G.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return G.read(i(G)).toString();case r.Buffer:return G.read(i(G)).buffer;case r.VSBuffer:return G.read(i(G));case r.Array:{const Y=i(G),se=[];for(let Q=0;Q<Y;Q++)se.push(y(G));return se}case r.Object:return JSON.parse(G.read(i(G)).toString());case r.Int:return i(G)}}e.deserialize=y;class A{constructor(X,Y,se=null,Q=1e3){this.protocol=X,this.ctx=Y,this.logger=se,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(we=>this.onRawMessage(we)),this.sendResponse({type:200})}registerChannel(X,Y){this.channels.set(X,Y),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const Y=this.send([X.type]);this.logger?.logOutgoing(Y,0,1,f(X.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(Y,X.id,1,f(X.type),X.data);return}}}send(X,Y=void 0){const se=new t;return d(se,X),d(se,Y),this.sendBuffer(se.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const Y=new a(X),se=y(Y),Q=y(Y),we=se[0];switch(we){case 100:return this.logger?.logIncoming(X.byteLength,se[1],1,`${C(we)}: ${se[2]}.${se[3]}`,Q),this.onPromise({type:we,id:se[1],channelName:se[2],name:se[3],arg:Q});case 102:return this.logger?.logIncoming(X.byteLength,se[1],1,`${C(we)}: ${se[2]}.${se[3]}`,Q),this.onEventListen({type:we,id:se[1],channelName:se[2],name:se[3],arg:Q});case 101:return this.logger?.logIncoming(X.byteLength,se[1],1,`${C(we)}`),this.disposeActiveRequest({type:we,id:se[1]});case 103:return this.logger?.logIncoming(X.byteLength,se[1],1,`${C(we)}`),this.disposeActiveRequest({type:we,id:se[1]})}}onPromise(X){const Y=this.channels.get(X.channelName);if(!Y){this.collectPendingRequest(X);return}const se=new k.CancellationTokenSource;let Q;try{Q=Y.call(this.ctx,X.name,X.arg,se.token)}catch(j){Q=Promise.reject(j)}const we=X.id;Q.then(j=>{this.sendResponse({id:we,data:j,type:201})},j=>{j instanceof Error?this.sendResponse({id:we,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:we,data:j,type:203})}).finally(()=>{he.dispose(),this.activeRequests.delete(X.id)});const he=(0,S.toDisposable)(()=>se.cancel());this.activeRequests.set(X.id,he)}onEventListen(X){const Y=this.channels.get(X.channelName);if(!Y){this.collectPendingRequest(X);return}const se=X.id,we=Y.listen(this.ctx,X.name,X.arg)(he=>this.sendResponse({id:se,data:he,type:204}));this.activeRequests.set(X.id,we)}disposeActiveRequest(X){const Y=this.activeRequests.get(X.id);Y&&(Y.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let Y=this.pendingRequests.get(X.channelName);Y||(Y=[],this.pendingRequests.set(X.channelName,Y));const se=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:X,timeoutTimer:se})}flushPendingRequests(X){const Y=this.pendingRequests.get(X);if(Y){for(const se of Y)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.onPromise(se.request);break;case 102:this.onEventListen(se.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=A;var E;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class b{constructor(X,Y=null){this.protocol=X,this.isDisposed=!1,this.state=s.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(se=>this.onBuffer(se)),this.logger=Y}getChannel(X){const Y=this;return{call(se,Q,we){return Y.isDisposed?Promise.reject(new v.CancellationError):Y.requestPromise(X,se,Q,we)},listen(se,Q){return Y.isDisposed?p.Event.None:Y.requestEvent(X,se,Q)}}}requestPromise(X,Y,se,Q=k.CancellationToken.None){const we=this.lastRequestId++,j={id:we,type:100,channelName:X,name:Y,arg:se};if(Q.isCancellationRequested)return Promise.reject(new v.CancellationError);let z;return new Promise((Se,de)=>{if(Q.isCancellationRequested)return de(new v.CancellationError);const me=()=>{const te=fe=>{switch(fe.type){case 201:this.handlers.delete(we),Se(fe.data);break;case 202:{this.handlers.delete(we);const Ee=new Error(fe.data.message);Ee.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,Ee.name=fe.data.name,de(Ee);break}case 203:this.handlers.delete(we),de(fe.data);break}};this.handlers.set(we,te),this.sendRequest(j)};let Z=null;this.state===s.Idle?me():(Z=(0,N.createCancelablePromise)(te=>this.whenInitialized()),Z.then(()=>{Z=null,me()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:we,type:101}),de(new v.CancellationError)},q=Q.onCancellationRequested(ie);z=(0,S.combinedDisposable)((0,S.toDisposable)(ie),q),this.activeRequests.add(z)}).finally(()=>{z.dispose(),this.activeRequests.delete(z)})}requestEvent(X,Y,se){const Q=this.lastRequestId++,he={id:Q,type:102,channelName:X,name:Y,arg:se};let j=null;const z=new p.Emitter({onWillAddFirstListener:()=>{j=(0,N.createCancelablePromise)(Se=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(z),this.sendRequest(he)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(z),this.sendRequest({id:Q,type:103}))}}),ne=Se=>z.fire(Se.data);return this.handlers.set(Q,ne),z.event}sendRequest(X){switch(X.type){case 100:case 102:{const Y=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger?.logOutgoing(Y,X.id,0,`${C(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const Y=this.send([X.type,X.id]);this.logger?.logOutgoing(Y,X.id,0,C(X.type));return}}}send(X,Y=void 0){const se=new t;return d(se,X),d(se,Y),this.sendBuffer(se.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const Y=new a(X),se=y(Y),Q=y(Y),we=se[0];switch(we){case 200:return this.logger?.logIncoming(X.byteLength,0,0,f(we)),this.onResponse({type:se[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(X.byteLength,se[1],0,f(we),Q),this.onResponse({type:se[0],id:se[1],data:Q})}}onResponse(X){if(X.type===200){this.state=s.Idle,this._onDidInitialize.fire();return}this.handlers.get(X.id)?.(X)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=b,Ge([R.memoize],b.prototype,"onDidInitializePromise",null);class _{get connections(){const X=[];return this._connections.forEach(Y=>X.push(Y)),X}constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new S.DisposableStore,this.disposables.add(X(({protocol:Y,onDidClientDisconnect:se})=>{const Q=p.Event.once(Y.onMessage);this.disposables.add(Q(we=>{const he=new a(we),j=y(he),z=new A(Y,j),ne=new b(Y);this.channels.forEach((de,me)=>z.registerChannel(me,de));const Se={channelServer:z,channelClient:ne,ctx:j};this._connections.add(Se),this._onDidAddConnection.fire(Se),this.disposables.add(se(()=>{z.dispose(),ne.dispose(),this._connections.delete(Se),this._onDidRemoveConnection.fire(Se)}))}))}))}getChannel(X,Y){const se=this;return{call(Q,we,he){let j;if((0,g.isFunction)(Y)){const ne=(0,D.getRandomElement)(se.connections.filter(Y));j=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(se.onDidAddConnection,Y))}else j=Y.routeCall(se,Q,we);const z=j.then(ne=>ne.channelClient.getChannel(X));return U(z).call(Q,we,he)},listen(Q,we){if((0,g.isFunction)(Y))return se.getMulticastEvent(X,Y,Q,we);const he=Y.routeEvent(se,Q,we).then(j=>j.channelClient.getChannel(X));return U(he).listen(Q,we)}}}getMulticastEvent(X,Y,se,Q){const we=this;let he;const j=new p.Emitter({onWillAddFirstListener:()=>{he=new S.DisposableStore;const z=new p.EventMultiplexer,ne=new Map,Se=me=>{const ie=me.channelClient.getChannel(X).listen(se,Q),q=z.add(ie);ne.set(me,q)},de=me=>{const Z=ne.get(me);Z&&(Z.dispose(),ne.delete(me))};we.connections.filter(Y).forEach(Se),p.Event.filter(we.onDidAddConnection,Y)(Se,void 0,he),we.onDidRemoveConnection(de,void 0,he),z.event(j.fire,j,he),he.add(z)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return j.event}registerChannel(X,Y){this.channels.set(X,Y);for(const se of this._connections)se.channelServer.registerChannel(X,Y)}dispose(){this.disposables.dispose();for(const X of this._connections)X.channelClient.dispose(),X.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class T{constructor(X,Y,se=null){const Q=new t;d(Q,Y),X.send(Q.buffer),this.channelClient=new b(X,se),this.channelServer=new A(X,Y,se)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,Y){this.channelServer.registerChannel(X,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function U(G){return{call(X,Y,se){return G.then(Q=>Q.call(X,Y,se))},listen(X,Y){const se=new p.Relay;return G.then(Q=>se.input=Q.listen(X,Y)),se.event}}}e.getDelayedChannel=U;function M(G){let X=!1;return{call(Y,se,Q){return X?G.call(Y,se,Q):(0,N.timeout)(0).then(()=>X=!0).then(()=>G.call(Y,se,Q))},listen(Y,se){if(X)return G.listen(Y,se);const Q=new p.Relay;return(0,N.timeout)(0).then(()=>X=!0).then(()=>Q.input=G.listen(Y,se)),Q.event}}}e.getNextTickChannel=M;class P{constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const Y of X.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await p.Event.toPromise(X.onDidAddConnection),await this.route(X)}}e.StaticRouter=P;var x;(function(G){function X(we,he,j){const z=we,ne=j&&j.disableMarshalling,Se=new Map;for(const de in z)se(de)&&Se.set(de,p.Event.buffer(z[de],!0,void 0,he));return new class{listen(de,me,Z){const ie=Se.get(me);if(ie)return ie;if(Q(me)){const q=z[me];if(typeof q=="function")return q.call(z,Z)}throw new v.ErrorNoTelemetry(`Event not found: ${me}`)}call(de,me,Z){const ie=z[me];if(typeof ie=="function"){if(!ne&&Array.isArray(Z))for(let te=0;te<Z.length;te++)Z[te]=(0,L.revive)(Z[te]);let q=ie.apply(z,Z);return q instanceof Promise||(q=Promise.resolve(q)),q}throw new v.ErrorNoTelemetry(`Method not found: ${me}`)}}}G.fromService=X;function Y(we,he){const j=he&&he.disableMarshalling;return new Proxy({},{get(z,ne){if(typeof ne=="string")return he?.properties?.has(ne)?he.properties.get(ne):Q(ne)?function(Se){return we.listen(ne,Se)}:se(ne)?we.listen(ne):async function(...Se){let de;he&&!(0,g.isUndefinedOrNull)(he.context)?de=[he.context,...Se]:de=Se;const me=await we.call(ne,de);return j?me:(0,L.revive)(me)};throw new v.ErrorNoTelemetry(`Property not found: ${String(ne)}`)}})}G.toService=Y;function se(we){return we[0]==="o"&&we[1]==="n"&&I.isUpperAsciiLetter(we.charCodeAt(2))}function Q(we){return/^onDynamic/.test(we)&&I.isUpperAsciiLetter(we.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const X=G.toString();if(X!=="[object Object]")return X}return G}function W(G){return Array.isArray(G)?G.map(O):O(G)}function J(G,X,Y,se,Q,we,he){he=W(he);const j=F[Q],z=j[se%j.length];let ne=[`%c[${G}]%c[${String(X).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(we)?(ne=ne.concat(he),ne.push(")")):ne.push(he),console.log.apply(console,ne)}class ce{constructor(X,Y){this._outgoingPrefix=X,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,Y,se,Q,we){this._totalOutgoing+=X,J(this._outgoingPrefix,this._totalOutgoing,X,Y,se,Q,we)}logIncoming(X,Y,se,Q,we){this._totalIncoming+=X,J(this._incomingPrefix,this._totalIncoming,X,Y,se,Q,we)}}e.IPCLogger=ce}),define(ye[82],Ce([1,0,22,4,3,81]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var v;(function(u){u.enableDiagnostics=!1,u.records=[];const c=new WeakMap;let d=0;function y(E,b){if(!c.has(E)){const _=String(++d);c.set(E,_)}return c.get(E)}function A(E,b,_,T){if(!u.enableDiagnostics)return;const U=y(E,b);if(T instanceof D.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const M=D.VSBuffer.alloc(T.byteLength);M.set(T),u.records.push({timestamp:Date.now(),id:U,label:b,type:_,buff:M})}else u.records.push({timestamp:Date.now(),id:U,label:b,type:_,data:T})}u.traceSocketEvent=A})(v||(e.SocketDiagnostics=v={}));var p;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let S=null;function L(){return S||(S=D.VSBuffer.alloc(0)),S}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,d){if(c===0)return L();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const b=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=c),b}if(this._chunks[0].byteLength>c){const b=this._chunks[0].slice(0,c);return d&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),b}const y=D.VSBuffer.alloc(c);let A=0,E=0;for(;c>0;){const b=this._chunks[E];if(b.byteLength>c){const _=b.slice(0,c);y.set(_,A),A+=c,d&&(this._chunks[E]=b.slice(c),this._totalLength-=c),c-=c}else y.set(b,A),A+=b.byteLength,d?(this._chunks.shift(),this._totalLength-=b.byteLength):E++,c-=b.byteLength}return y}}e.ChunkStream=I;var g;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(g||(g={}));function w(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var C;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(C||(e.ProtocolConstants=C={}));class l{constructor(c,d,y,A){this.type=c,this.id=d,this.ack=y,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends m.Disposable{constructor(c){super(),this._onMessage=this._register(new N.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const y=this._state.messageType,A=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new l(y,A,E,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class s{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=D.VSBuffer.alloc(13);d.writeUInt8(c.type,0),d.writeUInt32BE(c.id,1),d.writeUInt32BE(c.ack,5),d.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",c.data),this._writeSoon(d,c.data)}_bufferAdd(c,d){const y=this._totalLength===0;return this._data.push(c,d),this._totalLength+=c.byteLength+d.byteLength,y}_bufferTake(){const c=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,d){this._bufferAdd(c,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this._socket.write(c)}}class i extends m.Disposable{constructor(c){super(),this._onMessage=new N.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new N.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new s(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new l(1,0,0,c))}}e.Protocol=i;class n extends k.IPCClient{static fromSocket(c,d){return new n(new i(c),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(c,d,y=null){super(c,d,y),this.protocol=c}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=n;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new N.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let c=0,d=this._first;for(;d;)d=d.next,c++;return c}peek(){return this._first?this._first.data:null}toArray(){const c=[];let d=0,y=this._first;for(;y;)c[d++]=y.data,y=y.next;return c}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const d=new a(c);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class r{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const c=Date.now();for(let d=0;d<r._HISTORY_LENGTH;d++)this.lastRuns[d]=c-1e3*d;setInterval(()=>{for(let d=r._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const c=Date.now(),d=(1+r._HISTORY_LENGTH)*1e3;let y=0;for(let A=0;A<r._HISTORY_LENGTH;A++)c-this.lastRuns[A]<=d&&y++;return 1-y/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class h{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(c){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=c.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new m.DisposableStore,this._socket=c.socket,this._socketWriter=this._socketDisposables.add(new s(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.add(this._socket.onClose(d=>this._onSocketClose.fire(d))),c.initialChunk&&this._socketReader.acceptChunk(c.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new l(5,0,0,L());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new l(7,0,0,L());this._socketWriter.write(c)}sendResume(){const c=new l(8,0,0,L());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,d){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new m.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=this._socketDisposables.add(new s(this._socket)),this._socketReader=this._socketDisposables.add(new f(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.add(this._socket.onClose(y=>this._onSocketClose.fire(y))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new l(3,0,this._incomingAckId,L());this._socketWriter.write(c);const d=this._outgoingUnackMsg.toArray();for(let y=0,A=d.length;y<A;y++)this._socketWriter.write(d[y]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new l(6,0,0,L())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case 2:{this._onControlMessage.fire(c.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let y=0,A=d.length;y<A;y++)this._socketWriter.write(d[y]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const y=new l(1,d,this._incomingAckId,c);this._outgoingUnackMsg.push(y),this._isReconnecting||(this._socketWriter.write(y),this._recvAckCheck())}sendControl(c){const d=new l(2,0,0,c);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),d=Date.now()-c.writtenTime,y=Date.now()-this._socketReader.lastReadTime,A=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&y>=2e4&&A>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:y});return}const E=Math.max(2e4-d,2e4-y,2e4-A,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},E)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new l(3,0,this._incomingAckId,L());this._socketWriter.write(c)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const c=new l(9,0,this._incomingAckId,L());this._socketWriter.write(c)}}e.PersistentProtocol=h}),define(ye[187],Ce([1,0,51,12,22,21,185,8,4,3,24,104,101,81]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class C extends w.ChannelServer{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",i=>m.VSBuffer.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.Server=C;class l{constructor(s,i){this.modulePath=s,this.options=i,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const n=i&&i.timeout?i.timeout:6e4;this.disposeDelayer=new N.Delayer(n),this.child=null,this._client=null}getChannel(s){const i=this;return{call(n,o,a){return i.requestPromise(s,n,o,a)},listen(n,o){return i.requestEvent(s,n,o)}}}requestPromise(s,i,n,o=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(s),t=(0,N.createCancelablePromise)(u=>a.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),h=(0,S.toDisposable)(()=>t.cancel());return this.activeRequests.add(h),t.finally(()=>{r.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(s,i,n){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let o;const a=new p.Emitter({onWillAddFirstListener:()=>{o=this.getCachedChannel(s).listen(i,n)(a.fire,a),this.activeRequests.add(o)},onDidRemoveLastListener:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const s=this.options&&this.options.args?this.options.args:[],i=Object.create(null);i.env={...(0,L.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(i.env={...i.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(i.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,g.removeDangerousEnvVariables)(i.env),this.child=(0,D.fork)(this.modulePath,s,i);const n=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,R.isRemoteConsoleLog)(c)){(0,R.log)(c,`IPC Library: ${this.options.serverName}`);return}n.fire(m.VSBuffer.wrap(Buffer.from(c,"base64")))});const a=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&a.send(c.buffer.toString("base64")),r=n.event,h={send:t,onMessage:r};this._client=new w.ChannelClient(h);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,d)=>{process.removeListener("exit",u),this.activeRequests.forEach(y=>(0,S.dispose)(y)),this.activeRequests.clear(),c!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+d),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:d})})}return this._client}getCachedChannel(s){let i=this.channels.get(s);return i||(i=this.client.getChannel(s),this.channels.set(s,i)),i}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=l}),define(ye[188],Ce([1,0,12,4,3,54,18]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var v;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function p(g){const w=g;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=p;var S;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(S||(e.StorageState=S={}));class L extends m.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(w,C=Object.create(null)){super(),this.database=w,this.options=C,this._onDidChangeStorage=this._register(new N.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=this._register(new D.ThrottledDelayer(L.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){this._onDidChangeStorage.pause();try{w.changed?.forEach((C,l)=>this.acceptExternal(l,C)),w.deleted?.forEach(C=>this.acceptExternal(C,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(w,C){if(this.state===S.Closed)return;let l=!1;(0,R.isUndefinedOrNull)(C)?l=this.cache.delete(w):this.cache.get(w)!==C&&(this.cache.set(w,C),l=!0),l&&this._onDidChangeStorage.fire({key:w,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,C){const l=this.cache.get(w);return(0,R.isUndefinedOrNull)(l)?C:l}getBoolean(w,C){const l=this.get(w);return(0,R.isUndefinedOrNull)(l)?C:l==="true"}getNumber(w,C){const l=this.get(w);return(0,R.isUndefinedOrNull)(l)?C:parseInt(l,10)}getObject(w,C){const l=this.get(w);return(0,R.isUndefinedOrNull)(l)?C:(0,k.parse)(l)}async set(w,C,l=!1){if(this.state===S.Closed)return;if((0,R.isUndefinedOrNull)(C))return this.delete(w,l);const f=(0,R.isObject)(C)||Array.isArray(C)?(0,k.stringify)(C):String(C);if(this.cache.get(w)!==f)return this.cache.set(w,f),this.pendingInserts.set(w,f),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire({key:w,external:l}),this.doFlush()}async delete(w,C=!1){if(!(this.state===S.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire({key:w,external:C}),this.doFlush()}async optimize(){if(this.state!==S.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(w){if(this.hasPending)return this.doFlush(w)}async doFlush(w){return this.options.hint===v.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),w)}async whenFlushed(){if(this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}isInMemory(){return this.options.hint===v.STORAGE_IN_MEMORY}}e.Storage=L;class I{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert?.forEach((C,l)=>this.items.set(l,C)),w.delete?.forEach(C=>this.items.delete(C))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=I}),define(ye[189],Ce([1,0,13,11,22]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=e.decodeUTF16LE=e.getPlatformTextDecoder=void 0;let k;function R(){return k||(k=new TextDecoder("UTF-16LE")),k}let v;function p(){return v||(v=new TextDecoder("UTF-16BE")),v}let S;function L(){return S||(S=N.isLittleEndian()?R():p()),S}e.getPlatformTextDecoder=L;function I(C,l,f){const s=new Uint16Array(C.buffer,l,f);return f>0&&(s[0]===65279||s[0]===65534)?g(C,l,f):R().decode(s)}e.decodeUTF16LE=I;function g(C,l,f){const s=[];let i=0;for(let n=0;n<f;n++){const o=m.readUInt16LE(C,l);l+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class w{constructor(l){this._capacity=l|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const l=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return L().decode(l)}_flushBuffer(){const l=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[l]:this._completedStrings[this._completedStrings.length]=l}appendCharCode(l){const f=this._capacity-this._bufferLength;f<=1&&(f===0||D.isHighSurrogate(l))&&this._flushBuffer(),this._buffer[this._bufferLength++]=l}appendASCIICharCode(l){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=l}appendString(l){const f=l.length;if(this._bufferLength+f>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=l;return}for(let s=0;s<f;s++)this._buffer[this._bufferLength++]=l.charCodeAt(s)}}e.StringBuilder=w}),define(ye[190],Ce([1,0,22,189]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressConsecutiveTextChanges=e.TextChange=void 0;function m(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class k{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,L,I,g){this.oldPosition=S,this.oldText=L,this.newPosition=I,this.newText=g}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${m(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${m(this.oldText)}")`:`(replace@${this.oldPosition} "${m(this.oldText)}" with "${m(this.newText)}")`}static _writeStringSize(S){return 4+2*S.length}static _writeString(S,L,I){const g=L.length;D.writeUInt32BE(S,g,I),I+=4;for(let w=0;w<g;w++)D.writeUInt16LE(S,L.charCodeAt(w),I),I+=2;return I}static _readString(S,L){const I=D.readUInt32BE(S,L);return L+=4,(0,N.decodeUTF16LE)(S,L,I)}writeSize(){return 4+4+k._writeStringSize(this.oldText)+k._writeStringSize(this.newText)}write(S,L){return D.writeUInt32BE(S,this.oldPosition,L),L+=4,D.writeUInt32BE(S,this.newPosition,L),L+=4,L=k._writeString(S,this.oldText,L),L=k._writeString(S,this.newText,L),L}static read(S,L,I){const g=D.readUInt32BE(S,L);L+=4;const w=D.readUInt32BE(S,L);L+=4;const C=k._readString(S,L);L+=k._writeStringSize(C);const l=k._readString(S,L);return L+=k._writeStringSize(l),I.push(new k(g,C,w,l)),L}}e.TextChange=k;function R(p,S){return p===null||p.length===0?S:new v(p,S).compress()}e.compressConsecutiveTextChanges=R;class v{constructor(S,L){this._prevEdits=S,this._currEdits=L,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let S=0,L=0,I=this._getPrev(S),g=this._getCurr(L);for(;S<this._prevLen||L<this._currLen;){if(I===null){this._acceptCurr(g),g=this._getCurr(++L);continue}if(g===null){this._acceptPrev(I),I=this._getPrev(++S);continue}if(g.oldEnd<=I.newPosition){this._acceptCurr(g),g=this._getCurr(++L);continue}if(I.newEnd<=g.oldPosition){this._acceptPrev(I),I=this._getPrev(++S);continue}if(g.oldPosition<I.newPosition){const[s,i]=v._splitCurr(g,I.newPosition-g.oldPosition);this._acceptCurr(s),g=i;continue}if(I.newPosition<g.oldPosition){const[s,i]=v._splitPrev(I,g.oldPosition-I.newPosition);this._acceptPrev(s),I=i;continue}let l,f;if(g.oldEnd===I.newEnd)l=I,f=g,I=this._getPrev(++S),g=this._getCurr(++L);else if(g.oldEnd<I.newEnd){const[s,i]=v._splitPrev(I,g.oldLength);l=s,f=g,I=i,g=this._getCurr(++L)}else{const[s,i]=v._splitCurr(g,I.newLength);l=I,f=s,I=this._getPrev(++S),g=i}this._result[this._resultLen++]=new k(l.oldPosition,l.oldText,f.newPosition,f.newText),this._prevDeltaOffset+=l.newLength-l.oldLength,this._currDeltaOffset+=f.newLength-f.oldLength}const w=v._merge(this._result);return v._removeNoOps(w)}_acceptCurr(S){this._result[this._resultLen++]=v._rebaseCurr(this._prevDeltaOffset,S),this._currDeltaOffset+=S.newLength-S.oldLength}_getCurr(S){return S<this._currLen?this._currEdits[S]:null}_acceptPrev(S){this._result[this._resultLen++]=v._rebasePrev(this._currDeltaOffset,S),this._prevDeltaOffset+=S.newLength-S.oldLength}_getPrev(S){return S<this._prevLen?this._prevEdits[S]:null}static _rebaseCurr(S,L){return new k(L.oldPosition-S,L.oldText,L.newPosition,L.newText)}static _rebasePrev(S,L){return new k(L.oldPosition,L.oldText,L.newPosition+S,L.newText)}static _splitPrev(S,L){const I=S.newText.substr(0,L),g=S.newText.substr(L);return[new k(S.oldPosition,S.oldText,S.newPosition,I),new k(S.oldEnd,"",S.newPosition+L,g)]}static _splitCurr(S,L){const I=S.oldText.substr(0,L),g=S.oldText.substr(L);return[new k(S.oldPosition,I,S.newPosition,S.newText),new k(S.oldPosition+L,g,S.newEnd,"")]}static _merge(S){if(S.length===0)return S;const L=[];let I=0,g=S[0];for(let w=1;w<S.length;w++){const C=S[w];g.oldEnd===C.oldPosition?g=new k(g.oldPosition,g.oldText+C.oldText,g.newPosition,g.newText+C.newText):(L[I++]=g,g=C)}return L[I++]=g,L}static _removeNoOps(S){if(S.length===0)return S;const L=[];let I=0;for(let g=0;g<S.length;g++){const w=S[g];w.oldText!==w.newText&&(L[I++]=w)}return L}}}),define(ye[191],Ce([1,0,34,16]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function m(k,R,v,p,S,L){if(Array.isArray(k)){let I=0;for(const g of k){const w=m(g,R,v,p,S,L);if(w===10)return w;w>I&&(I=w)}return I}else{if(typeof k=="string")return p?k==="*"?5:k===v?10:0:0;if(k){const{language:I,pattern:g,scheme:w,hasAccessToAllModels:C,notebookType:l}=k;if(!p&&!C)return 0;l&&S&&(R=S);let f=0;if(w)if(w===R.scheme)f=10;else if(w==="*")f=5;else return 0;if(I)if(I===v)f=10;else if(I==="*")f=Math.max(f,5);else return 0;if(l)if(l===L)f=10;else if(l==="*"&&L!==void 0)f=Math.max(f,5);else return 0;if(g){let s;if(typeof g=="string"?s=g:s={...g,base:(0,N.normalize)(g.base)},s===R.fsPath||(0,D.match)(s,R.fsPath))f=10;else return 0}return f}else return 0}}e.score=m}),define(ye[192],Ce([1,0,4,13,29,79,127,167,190,3]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class L extends S.Disposable{constructor(g,w,C,l,f,s,i){super(),this._onDidChangeContent=this._register(new D.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=w,this._mightContainNonBasicASCII=!s,this._mightContainRTL=l,this._mightContainUnusualLineTerminators=f,this._pieceTree=new R.PieceTreeBase(g,C,i)}equals(g){return!(g instanceof L)||this._BOM!==g._BOM||this.getEOL()!==g.getEOL()?!1:this._pieceTree.equal(g._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(g){return this._pieceTree.createSnapshot(g?this._BOM:"")}getOffsetAt(g,w){return this._pieceTree.getOffsetAt(g,w)}getPositionAt(g){return this._pieceTree.getPositionAt(g)}getRangeAt(g,w){const C=g+w,l=this.getPositionAt(g),f=this.getPositionAt(C);return new m.Range(l.lineNumber,l.column,f.lineNumber,f.column)}getValueInRange(g,w=0){if(g.isEmpty())return"";const C=this._getEndOfLine(w);return this._pieceTree.getValueInRange(g,C)}getValueLengthInRange(g,w=0){if(g.isEmpty())return 0;if(g.startLineNumber===g.endLineNumber)return g.endColumn-g.startColumn;const C=this.getOffsetAt(g.startLineNumber,g.startColumn),l=this.getOffsetAt(g.endLineNumber,g.endColumn);let f=0;const s=this._getEndOfLine(w),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=g.endLineNumber-g.startLineNumber;f=n*o}return l-C+f}getCharacterCountInRange(g,w=0){if(this._mightContainNonBasicASCII){let C=0;const l=g.startLineNumber,f=g.endLineNumber;for(let s=l;s<=f;s++){const i=this.getLineContent(s),n=s===l?g.startColumn-1:0,o=s===f?g.endColumn-1:i.length;for(let a=n;a<o;a++)N.isHighSurrogate(i.charCodeAt(a))?(C=C+1,a=a+1):C=C+1}return C+=this._getEndOfLine(w).length*(f-l),C}return this.getValueLengthInRange(g,w)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(g){return this._pieceTree.getLineContent(g)}getLineCharCode(g,w){return this._pieceTree.getLineCharCode(g,w)}getCharCode(g){return this._pieceTree.getCharCode(g)}getLineLength(g){return this._pieceTree.getLineLength(g)}getLineMinColumn(g){return 1}getLineMaxColumn(g){return this.getLineLength(g)+1}getLineFirstNonWhitespaceColumn(g){const w=N.firstNonWhitespaceIndex(this.getLineContent(g));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(g){const w=N.lastNonWhitespaceIndex(this.getLineContent(g));return w===-1?0:w+2}_getEndOfLine(g){switch(g){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(g){this._pieceTree.setEOL(g)}applyEdits(g,w,C){let l=this._mightContainRTL,f=this._mightContainUnusualLineTerminators,s=this._mightContainNonBasicASCII,i=!0,n=[];for(let c=0;c<g.length;c++){const d=g[c];i&&d._isTracked&&(i=!1);const y=d.range;if(d.text){let T=!0;s||(T=!N.isBasicASCII(d.text),s=T),!l&&T&&(l=N.containsRTL(d.text)),!f&&T&&(f=N.containsUnusualLineTerminators(d.text))}let A="",E=0,b=0,_=0;if(d.text){let T;[E,b,_,T]=(0,v.countEOL)(d.text);const U=this.getEOL();T===0||T===(U===`\r
`?2:1)?A=d.text:A=d.text.replace(/\r\n|\r|\n/g,U)}n[c]={sortIndex:c,identifier:d.identifier||null,range:y,rangeOffset:this.getOffsetAt(y.startLineNumber,y.startColumn),rangeLength:this.getValueLengthInRange(y),text:A,eolCount:E,firstLineLength:b,lastLineLength:_,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}n.sort(L._sortOpsAscending);let o=!1;for(let c=0,d=n.length-1;c<d;c++){const y=n[c].range.getEndPosition(),A=n[c+1].range.getStartPosition();if(A.isBeforeOrEqual(y)){if(A.isBefore(y))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this._reduceOperations(n));const a=C||w?L._getInverseEditRanges(n):[],t=[];if(w)for(let c=0;c<n.length;c++){const d=n[c],y=a[c];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let A=y.startLineNumber;A<=y.endLineNumber;A++){let E="";A===y.startLineNumber&&(E=this.getLineContent(d.range.startLineNumber),N.firstNonWhitespaceIndex(E)!==-1)||t.push({lineNumber:A,oldContent:E})}}let r=null;if(C){let c=0;r=[];for(let d=0;d<n.length;d++){const y=n[d],A=a[d],E=this.getValueInRange(y.range),b=y.rangeOffset+c;c+=y.text.length-E.length,r[d]={sortIndex:y.sortIndex,identifier:y.identifier,range:A,text:E,textChange:new p.TextChange(y.rangeOffset,E,b,y.text)}}o||r.sort((d,y)=>d.sortIndex-y.sortIndex)}this._mightContainRTL=l,this._mightContainUnusualLineTerminators=f,this._mightContainNonBasicASCII=s;const h=this._doApplyEdits(n);let u=null;if(w&&t.length>0){t.sort((c,d)=>d.lineNumber-c.lineNumber),u=[];for(let c=0,d=t.length;c<d;c++){const y=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===y)continue;const A=t[c].oldContent,E=this.getLineContent(y);E.length===0||E===A||N.firstNonWhitespaceIndex(E)!==-1||u.push(y)}}return this._onDidChangeContent.fire(),new k.ApplyEditsResult(r,h,u)}_reduceOperations(g){return g.length<1e3?g:[this._toSingleEditOperation(g)]}_toSingleEditOperation(g){let w=!1;const C=g[0].range,l=g[g.length-1].range,f=new m.Range(C.startLineNumber,C.startColumn,l.endLineNumber,l.endColumn);let s=C.startLineNumber,i=C.startColumn;const n=[];for(let h=0,u=g.length;h<u;h++){const c=g[h],d=c.range;w=w||c.forceMoveMarkers,n.push(this.getValueInRange(new m.Range(s,i,d.startLineNumber,d.startColumn))),c.text.length>0&&n.push(c.text),s=d.endLineNumber,i=d.endColumn}const o=n.join(""),[a,t,r]=(0,v.countEOL)(o);return{sortIndex:0,identifier:g[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}_doApplyEdits(g){g.sort(L._sortOpsDescending);const w=[];for(let C=0;C<g.length;C++){const l=g[C],f=l.range.startLineNumber,s=l.range.startColumn,i=l.range.endLineNumber,n=l.range.endColumn;if(f===i&&s===n&&l.text.length===0)continue;l.text?(this._pieceTree.delete(l.rangeOffset,l.rangeLength),this._pieceTree.insert(l.rangeOffset,l.text,!0)):this._pieceTree.delete(l.rangeOffset,l.rangeLength);const o=new m.Range(f,s,i,n);w.push({range:o,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return w}findMatchesLineByLine(g,w,C,l){return this._pieceTree.findMatchesLineByLine(g,w,C,l)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(g,w){const C=g.startLineNumber,l=g.startColumn,[f,s,i]=(0,v.countEOL)(w);let n;if(w.length>0){const o=f+1;o===1?n=new m.Range(C,l,C,l+s):n=new m.Range(C,l,C+o-1,i+1)}else n=new m.Range(C,l,C,l);return n}static _getInverseEditRanges(g){const w=[];let C=0,l=0,f=null;for(let s=0,i=g.length;s<i;s++){const n=g[s];let o,a;f?f.range.endLineNumber===n.range.startLineNumber?(o=C,a=l+(n.range.startColumn-f.range.endColumn)):(o=C+(n.range.startLineNumber-f.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new m.Range(o,a,o,a+n.firstLineLength):t=new m.Range(o,a,o+r-1,n.lastLineLength+1)}else t=new m.Range(o,a,o,a);C=t.endLineNumber,l=t.endColumn,w.push(t),f=n}return w}static _sortOpsAscending(g,w){const C=m.Range.compareRangesUsingEnds(g.range,w.range);return C===0?g.sortIndex-w.sortIndex:C}static _sortOpsDescending(g,w){const C=m.Range.compareRangesUsingEnds(g.range,w.range);return C===0?w.sortIndex-g.sortIndex:-C}}e.PieceTreeTextBuffer=L}),define(ye[193],Ce([1,0,13,127,192]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class k{constructor(p,S,L,I,g,w,C,l,f){this._chunks=p,this._bom=S,this._cr=L,this._lf=I,this._crlf=g,this._containsRTL=w,this._containsUnusualLineTerminators=C,this._isBasicASCII=l,this._normalizeEOL=f}_getEOL(p){const S=this._cr+this._lf+this._crlf,L=this._cr+this._crlf;return S===0?p===1?`
`:`\r
`:L>S/2?`\r
`:`
`}create(p){const S=this._getEOL(p),L=this._chunks;if(this._normalizeEOL&&(S===`\r
`&&(this._cr>0||this._lf>0)||S===`
`&&(this._cr>0||this._crlf>0)))for(let g=0,w=L.length;g<w;g++){const C=L[g].buffer.replace(/\r\n|\r|\n/g,S),l=(0,N.createLineStartsFast)(C);L[g]=new N.StringBuffer(C,l)}const I=new m.PieceTreeTextBuffer(L,this._bom,S,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:I,disposable:I}}getFirstLineText(p){return this._chunks[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(p){if(p.length===0)return;this.chunks.length===0&&D.startsWithUTF8BOM(p)&&(this.BOM=D.UTF8_BOM_CHARACTER,p=p.substr(1));const S=p.charCodeAt(p.length-1);S===13||S>=55296&&S<=56319?(this._acceptChunk1(p.substr(0,p.length-1),!1),this._hasPreviousChar=!0,this._previousChar=S):(this._acceptChunk1(p,!1),this._hasPreviousChar=!1,this._previousChar=S)}_acceptChunk1(p,S){!S&&p.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+p):this._acceptChunk2(p))}_acceptChunk2(p){const S=(0,N.createLineStarts)(this._tmpLineStarts,p);this.chunks.push(new N.StringBuffer(p,S.lineStarts)),this.cr+=S.cr,this.lf+=S.lf,this.crlf+=S.crlf,S.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=D.containsRTL(p)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=D.containsUnusualLineTerminators(p)))}finish(p=!0){return this._finish(),new k(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,p)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const p=this.chunks[this.chunks.length-1];p.buffer+=String.fromCharCode(this._previousChar);const S=(0,N.createLineStartsFast)(p.buffer);p.lineStarts=S,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=R}),define(ye[131],Ce([1,0,22,11]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var m;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(m||(m={}));function k(I){for(let g=0,w=I.length;g<w;g+=4){const C=I[g+0],l=I[g+1],f=I[g+2],s=I[g+3];I[g+0]=s,I[g+1]=f,I[g+2]=l,I[g+3]=C}}function R(I){const g=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return N.isLittleEndian()||k(g),D.VSBuffer.wrap(g)}function v(I){const g=I.buffer;if(N.isLittleEndian()||k(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const w=new Uint8Array(g.byteLength);return w.set(g),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function p(I){const g=new Uint32Array(S(I));let w=0;if(g[w++]=I.id,I.type==="full")g[w++]=1,g[w++]=I.data.length,g.set(I.data,w),w+=I.data.length;else{g[w++]=2,g[w++]=I.deltas.length;for(const C of I.deltas)g[w++]=C.start,g[w++]=C.deleteCount,C.data?(g[w++]=C.data.length,g.set(C.data,w),w+=C.data.length):g[w++]=0}return R(g)}e.encodeSemanticTokensDto=p;function S(I){let g=0;if(g+=1+1,I.type==="full")g+=1+I.data.length;else{g+=1,g+=(1+1+1)*I.deltas.length;for(const w of I.deltas)w.data&&(g+=w.data.length)}return g}function L(I){const g=v(I);let w=0;const C=g[w++];if(g[w++]===1){const i=g[w++],n=g.subarray(w,w+i);return w+=i,{id:C,type:"full",data:n}}const f=g[w++],s=[];for(let i=0;i<f;i++){const n=g[w++],o=g[w++],a=g[w++];let t;a>0&&(t=g.subarray(w,w+a),w+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:C,type:"delta",deltas:s}}e.decodeSemanticTokensDto=L}),define(ye[194],Ce([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(ye[132],Ce([1,0,19,24,11,170,126,194]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var p;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(le){this._values=le}hasChanged(le){return this._values[le]}}e.ConfigurationChangedEvent=S;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(le,Pe,Ve,Qe){this.id=le,this.name=Pe,this.defaultValue=Ve,this.schema=Qe}applyUpdate(le,Pe){return w(le,Pe)}compute(le,Pe,Ve){return Ve}}class g{constructor(le,Pe){this.newValue=le,this.didChange=Pe}}e.ApplyUpdateResult=g;function w(oe,le){if(typeof oe!="object"||typeof le!="object"||!oe||!le)return new g(le,oe!==le);if(Array.isArray(oe)||Array.isArray(le)){const Ve=Array.isArray(oe)&&Array.isArray(le)&&D.equals(oe,le);return new g(le,!Ve)}let Pe=!1;for(const Ve in le)if(le.hasOwnProperty(Ve)){const Qe=w(oe[Ve],le[Ve]);Qe.didChange&&(oe[Ve]=Qe.newValue,Pe=!0)}return new g(oe,Pe)}class C{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,Pe){return w(le,Pe)}validate(le){return this.defaultValue}}class l{constructor(le,Pe,Ve,Qe){this.id=le,this.name=Pe,this.defaultValue=Ve,this.schema=Qe}applyUpdate(le,Pe){return w(le,Pe)}validate(le){return typeof le>"u"?this.defaultValue:le}compute(le,Pe,Ve){return Ve}}function f(oe,le){return typeof oe>"u"?le:oe==="false"?!1:!!oe}e.boolean=f;class s extends l{constructor(le,Pe,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Ve),super(le,Pe,Ve,Qe)}validate(le){return f(le,this.defaultValue)}}function i(oe,le,Pe,Ve){if(typeof oe>"u")return le;let Qe=parseInt(oe,10);return isNaN(Qe)?le:(Qe=Math.max(Pe,Qe),Qe=Math.min(Ve,Qe),Qe|0)}e.clampedInt=i;class n extends l{static clampedInt(le,Pe,Ve,Qe){return i(le,Pe,Ve,Qe)}constructor(le,Pe,Ve,Qe,it,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ve,st.minimum=Qe,st.maximum=it),super(le,Pe,Ve,st),this.minimum=Qe,this.maximum=it}validate(le){return n.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}function o(oe,le,Pe,Ve){if(typeof oe>"u")return le;const Qe=a.float(oe,le);return a.clamp(Qe,Pe,Ve)}e.clampedFloat=o;class a extends l{static clamp(le,Pe,Ve){return le<Pe?Pe:le>Ve?Ve:le}static float(le,Pe){if(typeof le=="number")return le;if(typeof le>"u")return Pe;const Ve=parseFloat(le);return isNaN(Ve)?Pe:Ve}constructor(le,Pe,Ve,Qe,it){typeof it<"u"&&(it.type="number",it.default=Ve),super(le,Pe,Ve,it),this.validationFn=Qe}validate(le){return this.validationFn(a.float(le,this.defaultValue))}}class t extends l{static string(le,Pe){return typeof le!="string"?Pe:le}constructor(le,Pe,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Ve),super(le,Pe,Ve,Qe)}validate(le){return t.string(le,this.defaultValue)}}function r(oe,le,Pe,Ve){return typeof oe!="string"?le:Ve&&oe in Ve?Ve[oe]:Pe.indexOf(oe)===-1?le:oe}e.stringSet=r;class h extends l{constructor(le,Pe,Ve,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=Ve),super(le,Pe,Ve,it),this._allowedValues=Qe}validate(le){return r(le,this.defaultValue,this._allowedValues)}}class u extends I{constructor(le,Pe,Ve,Qe,it,st,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=it,Me.default=Qe),super(le,Pe,Ve,Me),this._allowedValues=it,this._convert=st}validate(le){return typeof le!="string"?this.defaultValue:this._allowedValues.indexOf(le)===-1?this.defaultValue:this._convert(le)}}function c(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",tags:["accessibility"],description:v.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,Pe,Ve){return Ve===0?le.accessibilitySupport:Ve}}class y extends I{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:v.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{insertSpace:f(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var A;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(A||(e.TextEditorCursorBlinkingStyle=A={}));function E(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function _(oe){switch(oe){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function T(oe){switch(oe){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class U extends C{constructor(){super(140)}compute(le,Pe,Ve){const Qe=["monaco-editor"];return Pe.get(39)&&Qe.push(Pe.get(39)),le.extraEditorClassName&&Qe.push(le.extraEditorClassName),Pe.get(73)==="default"?Qe.push("mouse-default"):Pe.get(73)==="copy"&&Qe.push("mouse-copy"),Pe.get(110)&&Qe.push("showUnused"),Pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class M extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(le,Pe,Ve){return Ve&&le.emptySelectionClipboard}}class P extends I{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[v.localize(8,null),v.localize(9,null),v.localize(10,null)],description:v.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[v.localize(12,null),v.localize(13,null),v.localize(14,null)],description:v.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:v.localize(16,null),included:m.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:v.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:v.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{cursorMoveOnType:f(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":r(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":r(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Pe.loop,this.defaultValue.loop)}}}class x extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:v.localize(19,null)},{type:"string",description:v.localize(20,null)}],description:v.localize(21,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?x.OFF:le==="true"?x.ON:le:le?x.ON:x.OFF}}e.EditorFontLigatures=x;class F extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:v.localize(22,null)},{type:"string",description:v.localize(23,null)}],description:v.localize(24,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?F.OFF:le==="true"?F.TRANSLATE:le:le?F.TRANSLATE:F.OFF}compute(le,Pe,Ve){return le.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class O extends C{constructor(){super(50)}compute(le,Pe,Ve){return le.fontInfo}}class W extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(25,null)})}validate(le){const Pe=a.float(le,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Pe,6,100)}compute(le,Pe,Ve){return le.fontInfo.fontSize}}class J extends I{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.MINIMUM_VALUE,maximum:J.MAXIMUM_VALUE,errorMessage:v.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(27,null)})}validate(le){return le==="normal"||le==="bold"?le:String(n.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,J.MINIMUM_VALUE,J.MAXIMUM_VALUE))}}class ce extends I{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[v.localize(28,null),v.localize(29,null),v.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:v.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:v.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:v.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:v.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:v.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:Ve,description:v.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:Ve,description:v.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:Ve,description:v.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:Ve,description:v.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:Ve,description:v.localize(41,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{multiple:r(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??r(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??r(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??r(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??r(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??r(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends I{constructor(){const le={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:v.localize(42,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:v.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:v.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:le.hidingDelay,description:v.localize(45,null)},"editor.hover.above":{type:"boolean",default:le.above,description:v.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:f(Pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Pe.above,this.defaultValue.above)}}}var X;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class Y extends C{constructor(){super(143)}compute(le,Pe,Ve){return Y.computeLayout(Pe,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(le){const Pe=le.height/le.lineHeight,Ve=Math.floor(le.paddingTop/le.lineHeight);let Qe=Math.floor(le.paddingBottom/le.lineHeight);le.scrollBeyondLastLine&&(Qe=Math.max(Qe,Pe-1));const it=(Ve+le.viewLineCount+Qe)/(le.pixelRatio*le.height),st=Math.floor(le.viewLineCount/it);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:st}}static _computeMinimapLayout(le,Pe){const Ve=le.outerWidth,Qe=le.outerHeight,it=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const st=Pe.stableMinimapLayoutInput,Me=st&&le.outerHeight===st.outerHeight&&le.lineHeight===st.lineHeight&&le.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&le.pixelRatio===st.pixelRatio&&le.scrollBeyondLastLine===st.scrollBeyondLastLine&&le.paddingTop===st.paddingTop&&le.paddingBottom===st.paddingBottom&&le.minimap.enabled===st.minimap.enabled&&le.minimap.side===st.minimap.side&&le.minimap.size===st.minimap.size&&le.minimap.showSlider===st.minimap.showSlider&&le.minimap.renderCharacters===st.minimap.renderCharacters&&le.minimap.maxColumn===st.minimap.maxColumn&&le.minimap.scale===st.minimap.scale&&le.verticalScrollbarWidth===st.verticalScrollbarWidth&&le.isViewportWrapping===st.isViewportWrapping,wt=le.lineHeight,Dt=le.typicalHalfwidthCharacterWidth,Vt=le.scrollBeyondLastLine,Bt=le.minimap.renderCharacters;let St=it>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const Ht=le.minimap.maxColumn,Ot=le.minimap.size,Kt=le.minimap.side,Mt=le.verticalScrollbarWidth,Pt=le.viewLineCount,tt=le.remainingWidth,jt=le.isViewportWrapping,qt=Bt?2:3;let ut=Math.floor(it*Qe);const pt=ut/it;let xt=!1,zt=!1,yt=qt*St,ht=St/it,Tt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:mt,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:Le,desiredRatio:Ne,minimapLineCount:Ie}=Y.computeContainedMinimapLineCount({viewLineCount:Pt,scrollBeyondLastLine:Vt,paddingTop:le.paddingTop,paddingBottom:le.paddingBottom,height:Qe,lineHeight:wt,pixelRatio:it});if(Pt/Ie>1)xt=!0,zt=!0,St=1,yt=1,ht=St/it;else{let Fe=!1,He=St+1;if(Ot==="fit"){const Je=Math.ceil((Lt+Pt+Le)*yt);jt&&Me&&tt<=Pe.stableFitRemainingWidth?(Fe=!0,He=Pe.stableFitMaxMinimapScale):Fe=Je>ut}if(Ot==="fill"||Fe){xt=!0;const Je=St;yt=Math.min(wt*it,Math.max(1,Math.floor(1/Ne))),jt&&Me&&tt<=Pe.stableFitRemainingWidth&&(He=Pe.stableFitMaxMinimapScale),St=Math.min(He,Math.max(1,Math.floor(yt/qt))),St>Je&&(Tt=Math.min(2,St/Je)),ht=St/it/Tt,ut=Math.ceil(Math.max(mt,Lt+Pt+Le)*yt),jt?(Pe.stableMinimapLayoutInput=le,Pe.stableFitRemainingWidth=tt,Pe.stableFitMaxMinimapScale=St):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Yt=Math.floor(Ht*ht),Ct=Math.min(Yt,Math.max(0,Math.floor((tt-Mt-2)*ht/(Dt+ht)))+e.MINIMAP_GUTTER_WIDTH);let Xe=Math.floor(it*Ct);const Rt=Xe/it;Xe=Math.floor(Xe*Tt);const Wt=Bt?1:2,Gt=Kt==="left"?0:Ve-Ct-Mt;return{renderMinimap:Wt,minimapLeft:Gt,minimapWidth:Ct,minimapHeightIsEditorHeight:xt,minimapIsSampling:zt,minimapScale:St,minimapLineHeight:yt,minimapCanvasInnerWidth:Xe,minimapCanvasInnerHeight:ut,minimapCanvasOuterWidth:Rt,minimapCanvasOuterHeight:pt}}static computeLayout(le,Pe){const Ve=Pe.outerWidth|0,Qe=Pe.outerHeight|0,it=Pe.lineHeight|0,st=Pe.lineNumbersDigitCount|0,Me=Pe.typicalHalfwidthCharacterWidth,wt=Pe.maxDigitWidth,Dt=Pe.pixelRatio,Vt=Pe.viewLineCount,Bt=le.get(135),St=Bt==="inherit"?le.get(134):Bt,Ht=St==="inherit"?le.get(130):St,Ot=le.get(133),Kt=Pe.isDominatedByLongLines,Mt=le.get(57),Pt=le.get(67).renderType!==0,tt=le.get(68),jt=le.get(104),qt=le.get(83),ut=le.get(72),pt=le.get(102),xt=pt.verticalScrollbarSize,zt=pt.verticalHasArrows,yt=pt.arrowSize,ht=pt.horizontalScrollbarSize,Tt=le.get(43),Yt=le.get(109)!=="never";let Ct=le.get(65);Tt&&Yt&&(Ct+=16);let Xe=0;if(Pt){const rt=Math.max(st,tt);Xe=Math.round(rt*wt)}let Rt=0;Mt&&(Rt=it*Pe.glyphMarginDecorationLaneCount);let Wt=0,Gt=Wt+Rt,mt=Gt+Xe,Lt=mt+Ct;const Le=Ve-Rt-Xe-Ct;let Ne=!1,Ie=!1,re=-1;St==="inherit"&&Kt?(Ne=!0,Ie=!0):Ht==="on"||Ht==="bounded"?Ie=!0:Ht==="wordWrapColumn"&&(re=Ot);const Fe=Y._computeMinimapLayout({outerWidth:Ve,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Me,pixelRatio:Dt,scrollBeyondLastLine:jt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:ut,verticalScrollbarWidth:xt,viewLineCount:Vt,remainingWidth:Le,isViewportWrapping:Ie},Pe.memory||new L);Fe.renderMinimap!==0&&Fe.minimapLeft===0&&(Wt+=Fe.minimapWidth,Gt+=Fe.minimapWidth,mt+=Fe.minimapWidth,Lt+=Fe.minimapWidth);const He=Le-Fe.minimapWidth,Je=Math.max(1,Math.floor((He-xt-2)/Me)),qe=zt?yt:0;return Ie&&(re=Math.max(1,Je),Ht==="bounded"&&(re=Math.min(re,Ot))),{width:Ve,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:Rt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Gt,lineNumbersWidth:Xe,decorationsLeft:mt,decorationsWidth:Ct,contentLeft:Lt,contentWidth:He,minimap:Fe,viewportColumn:Je,isWordWrapMinified:Ne,isViewportWrapping:Ie,wrappingColumn:re,verticalScrollbarWidth:xt,horizontalScrollbarHeight:ht,overviewRuler:{top:qe,width:xt,height:Qe-2*qe,right:0}}}}e.EditorLayoutInfoComputer=Y;class se extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[v.localize(47,null),v.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:v.localize(49,null)}})}validate(le){return r(le,"simple",["simple","advanced"])}compute(le,Pe,Ve){return Pe.get(2)===2?"advanced":Ve}}var Q;(function(oe){oe.Off="off",oe.OnCode="onCode",oe.On="on"})(Q||(e.ShowAiIconMode=Q={}));class we extends I{constructor(){const le={enabled:!0,experimental:{showAiIcon:Q.Off}};super(64,"lightbulb",le,{"editor.lightbulb.enabled":{type:"boolean",default:le.enabled,description:v.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[Q.Off,Q.OnCode,Q.On],default:le.experimental.showAiIcon,enumDescriptions:[v.localize(51,null),v.localize(52,null),v.localize(53,null)],description:v.localize(54,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),experimental:{showAiIcon:r(Pe.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[Q.Off,Q.OnCode,Q.On])}}}}class he extends I{constructor(){const le={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",le,{"editor.stickyScroll.enabled":{type:"boolean",default:le.enabled,description:v.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:le.maxLineCount,minimum:1,maximum:10,description:v.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:le.defaultModel,description:v.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:le.scrollWithEditor,description:v.localize(58,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class j extends I{constructor(){const le={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",le,{"editor.inlayHints.enabled":{type:"string",default:le.enabled,description:v.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[v.localize(60,null),v.localize(61,null,m.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),v.localize(62,null,m.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),v.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:v.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:v.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:le.padding,description:v.localize(66,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:r(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:f(Pe.padding,this.defaultValue.padding)}}}class z extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(le){return typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)?-parseFloat(le.substring(0,le.length-2)):n.clampedInt(le,this.defaultValue,0,1e3)}compute(le,Pe,Ve){return Ve<0?n.clampedInt(-Ve*le.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ne extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>a.clamp(le,0,150),{markdownDescription:v.localize(67,null)})}compute(le,Pe,Ve){return le.fontInfo.lineHeight}}class Se extends I{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:v.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:le.autohide,description:v.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(70,null),v.localize(71,null),v.localize(72,null)],default:le.size,description:v.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:v.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:v.localize(75,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:v.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:v.localize(78,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),autohide:f(Pe.autohide,this.defaultValue.autohide),size:r(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Pe.side,this.defaultValue.side,["right","left"]),showSlider:r(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Pe.scale,1,1,3),maxColumn:n.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(oe){return oe==="ctrlCmd"?m.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(80,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{top:n.clampedInt(Pe.top,0,0,1e3),bottom:n.clampedInt(Pe.bottom,0,0,1e3)}}}class Z extends I{constructor(){const le={enabled:!0,cycle:!0};super(85,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:v.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:v.localize(82,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),cycle:f(Pe.cycle,this.defaultValue.cycle)}}}class ie extends C{constructor(){super(141)}compute(le,Pe,Ve){return le.pixelRatio}}class q extends I{constructor(){const le={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[v.localize(83,null),v.localize(84,null),v.localize(85,null)]}];super(88,"quickSuggestions",le,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:le.strings,description:v.localize(86,null)},comments:{anyOf:Pe,default:le.comments,description:v.localize(87,null)},other:{anyOf:Pe,default:le.other,description:v.localize(88,null)}},default:le,markdownDescription:v.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=le}validate(le){if(typeof le=="boolean"){const Dt=le?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!le||typeof le!="object")return this.defaultValue;const{other:Pe,comments:Ve,strings:Qe}=le,it=["on","inline","off"];let st,Me,wt;return typeof Pe=="boolean"?st=Pe?"on":"off":st=r(Pe,this.defaultValue.other,it),typeof Ve=="boolean"?Me=Ve?"on":"off":Me=r(Ve,this.defaultValue.comments,it),typeof Qe=="boolean"?wt=Qe?"on":"off":wt=r(Qe,this.defaultValue.strings,it),{other:st,comments:Me,strings:wt}}}var te;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class fe extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(90,null),v.localize(91,null),v.localize(92,null),v.localize(93,null)],default:"on",description:v.localize(94,null)})}validate(le){let Pe=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof le<"u"&&(typeof le=="function"?(Pe=4,Ve=le):le==="interval"?Pe=3:le==="relative"?Pe=2:le==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:Ve}}}function Ee(oe){const le=oe.get(97);return le==="editable"?oe.get(90):le!=="on"}e.filterValidationDecorations=Ee;class Te extends I{constructor(){const le=[],Pe={type:"number",description:v.localize(95,null)};super(101,"rulers",le,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:v.localize(96,null),format:"color-hex"}}}]},default:le,description:v.localize(97,null)})}validate(le){if(Array.isArray(le)){const Pe=[];for(const Ve of le)if(typeof Ve=="number")Pe.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Qe=Ve;Pe.push({column:n.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return Pe.sort((Ve,Qe)=>Ve.column-Qe.column),Pe}return this.defaultValue}}class ve extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(le){return!le||typeof le!="object"?this.defaultValue:le}}function De(oe,le){if(typeof oe!="string")return le;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(98,null),v.localize(99,null),v.localize(100,null)],default:"auto",description:v.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(102,null),v.localize(103,null),v.localize(104,null)],default:"auto",description:v.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:v.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:v.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:v.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:le.ignoreHorizontalScrollbarInContentHeight,description:v.localize(109,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le,Ve=n.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=n.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Pe.vertical,this.defaultValue.vertical),horizontal:De(Pe.horizontal,this.defaultValue.horizontal),useShadows:f(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(Pe.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:n.clampedInt(Pe.verticalSliderSize,Qe,0,1e3),scrollByPage:f(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends I{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:v.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:v.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:v.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:v.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:v.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:v.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:v.localize(116,null)}})}applyUpdate(le,Pe){let Ve=!1;Pe.allowedCharacters&&le&&(N.equals(le.allowedCharacters,Pe.allowedCharacters)||(le={...le,allowedCharacters:Pe.allowedCharacters},Ve=!0)),Pe.allowedLocales&&le&&(N.equals(le.allowedLocales,Pe.allowedLocales)||(le={...le,allowedLocales:Pe.allowedLocales},Ve=!0));const Qe=super.applyUpdate(le,Pe);return Ve?new g(Qe.newValue,!0):Qe}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{nonBasicASCII:ue(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ue(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ue(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(le.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(le,Pe){if(typeof le!="object"||!le)return Pe;const Ve={};for(const[Qe,it]of Object.entries(le))it===!0&&(Ve[Qe]=!0);return Ve}}class ee extends I{constructor(){const le={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:v.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover","never"],enumDescriptions:[v.localize(118,null),v.localize(119,null),v.localize(120,null)],description:v.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:le.suppressSuggestions,description:v.localize(122,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),mode:r(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class H extends I{constructor(){const le={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,markdownDescription:v.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:le.independentColorPoolPerBracketType,description:v.localize(124,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends I{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(125,null),v.localize(126,null),v.localize(127,null)],default:le.bracketPairs,description:v.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null)],default:le.bracketPairsHorizontal,description:v.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:v.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:v.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null)],default:le.highlightActiveIndentation,description:v.localize(138,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{bracketPairs:ue(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ue(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ue(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ue(oe,le,Pe){const Ve=Pe.indexOf(oe);return Ve===-1?le:Pe[Ve]}class Ae extends I{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(139,null),v.localize(140,null)],default:le.insertMode,description:v.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:v.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:v.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:v.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[v.localize(145,null),v.localize(146,null),v.localize(147,null),v.localize(148,null)],default:le.selectionMode,markdownDescription:v.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:v.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:v.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:v.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:v.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:v.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:v.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(186,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{insertMode:r(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:f(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:f(Pe.preview,this.defaultValue.preview),previewMode:r(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Pe.showMethods,this.defaultValue.showMethods),showFunctions:f(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Pe.showFields,this.defaultValue.showFields),showVariables:f(Pe.showVariables,this.defaultValue.showVariables),showClasses:f(Pe.showClasses,this.defaultValue.showClasses),showStructs:f(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:f(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Pe.showModules,this.defaultValue.showModules),showProperties:f(Pe.showProperties,this.defaultValue.showProperties),showEvents:f(Pe.showEvents,this.defaultValue.showEvents),showOperators:f(Pe.showOperators,this.defaultValue.showOperators),showUnits:f(Pe.showUnits,this.defaultValue.showUnits),showValues:f(Pe.showValues,this.defaultValue.showValues),showConstants:f(Pe.showConstants,this.defaultValue.showConstants),showEnums:f(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Pe.showKeywords,this.defaultValue.showKeywords),showWords:f(Pe.showWords,this.defaultValue.showWords),showColors:f(Pe.showColors,this.defaultValue.showColors),showFiles:f(Pe.showFiles,this.defaultValue.showFiles),showReferences:f(Pe.showReferences,this.defaultValue.showReferences),showFolders:f(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:f(Pe.showUsers,this.defaultValue.showUsers),showIssues:f(Pe.showIssues,this.defaultValue.showIssues)}}}class xe extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:v.localize(188,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(le.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Ke extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[v.localize(189,null),v.localize(190,null),v.localize(191,null),v.localize(192,null)],description:v.localize(193,null),default:"same"}})}validate(le){switch(le){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(le,Pe,Ve){return Pe.get(2)===2?0:Ve}}class Ze extends C{constructor(){super(144)}compute(le,Pe,Ve){const Qe=Pe.get(143);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class at extends I{constructor(){const le={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",le,{"editor.dropIntoEditor.enabled":{type:"boolean",default:le.enabled,markdownDescription:v.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:v.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[v.localize(196,null),v.localize(197,null)],default:"afterDrop"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showDropSelector:r(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends I{constructor(){const le={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",le,{"editor.pasteAs.enabled":{type:"boolean",default:le.enabled,markdownDescription:v.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:v.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[v.localize(200,null),v.localize(201,null)],default:"afterPaste"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showPasteSelector:r(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ke="Consolas, 'Courier New', monospace",Ue="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:m.isMacintosh?Ue:m.isLinux?$e:ke,fontWeight:"normal",fontSize:m.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var et;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.ariaRequired=5]="ariaRequired",oe[oe.autoClosingBrackets=6]="autoClosingBrackets",oe[oe.autoClosingComments=7]="autoClosingComments",oe[oe.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",oe[oe.autoClosingDelete=9]="autoClosingDelete",oe[oe.autoClosingOvertype=10]="autoClosingOvertype",oe[oe.autoClosingQuotes=11]="autoClosingQuotes",oe[oe.autoIndent=12]="autoIndent",oe[oe.automaticLayout=13]="automaticLayout",oe[oe.autoSurround=14]="autoSurround",oe[oe.bracketPairColorization=15]="bracketPairColorization",oe[oe.guides=16]="guides",oe[oe.codeLens=17]="codeLens",oe[oe.codeLensFontFamily=18]="codeLensFontFamily",oe[oe.codeLensFontSize=19]="codeLensFontSize",oe[oe.colorDecorators=20]="colorDecorators",oe[oe.colorDecoratorsLimit=21]="colorDecoratorsLimit",oe[oe.columnSelection=22]="columnSelection",oe[oe.comments=23]="comments",oe[oe.contextmenu=24]="contextmenu",oe[oe.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=26]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=28]="cursorStyle",oe[oe.cursorSurroundingLines=29]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=31]="cursorWidth",oe[oe.disableLayerHinting=32]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",oe[oe.domReadOnly=34]="domReadOnly",oe[oe.dragAndDrop=35]="dragAndDrop",oe[oe.dropIntoEditor=36]="dropIntoEditor",oe[oe.emptySelectionClipboard=37]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=39]="extraEditorClassName",oe[oe.fastScrollSensitivity=40]="fastScrollSensitivity",oe[oe.find=41]="find",oe[oe.fixedOverflowWidgets=42]="fixedOverflowWidgets",oe[oe.folding=43]="folding",oe[oe.foldingStrategy=44]="foldingStrategy",oe[oe.foldingHighlight=45]="foldingHighlight",oe[oe.foldingImportsByDefault=46]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=47]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=49]="fontFamily",oe[oe.fontInfo=50]="fontInfo",oe[oe.fontLigatures=51]="fontLigatures",oe[oe.fontSize=52]="fontSize",oe[oe.fontWeight=53]="fontWeight",oe[oe.fontVariations=54]="fontVariations",oe[oe.formatOnPaste=55]="formatOnPaste",oe[oe.formatOnType=56]="formatOnType",oe[oe.glyphMargin=57]="glyphMargin",oe[oe.gotoLocation=58]="gotoLocation",oe[oe.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",oe[oe.hover=60]="hover",oe[oe.inDiffEditor=61]="inDiffEditor",oe[oe.inlineSuggest=62]="inlineSuggest",oe[oe.letterSpacing=63]="letterSpacing",oe[oe.lightbulb=64]="lightbulb",oe[oe.lineDecorationsWidth=65]="lineDecorationsWidth",oe[oe.lineHeight=66]="lineHeight",oe[oe.lineNumbers=67]="lineNumbers",oe[oe.lineNumbersMinChars=68]="lineNumbersMinChars",oe[oe.linkedEditing=69]="linkedEditing",oe[oe.links=70]="links",oe[oe.matchBrackets=71]="matchBrackets",oe[oe.minimap=72]="minimap",oe[oe.mouseStyle=73]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=75]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=77]="multiCursorModifier",oe[oe.multiCursorPaste=78]="multiCursorPaste",oe[oe.multiCursorLimit=79]="multiCursorLimit",oe[oe.occurrencesHighlight=80]="occurrencesHighlight",oe[oe.overviewRulerBorder=81]="overviewRulerBorder",oe[oe.overviewRulerLanes=82]="overviewRulerLanes",oe[oe.padding=83]="padding",oe[oe.pasteAs=84]="pasteAs",oe[oe.parameterHints=85]="parameterHints",oe[oe.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=88]="quickSuggestions",oe[oe.quickSuggestionsDelay=89]="quickSuggestionsDelay",oe[oe.readOnly=90]="readOnly",oe[oe.readOnlyMessage=91]="readOnlyMessage",oe[oe.renameOnType=92]="renameOnType",oe[oe.renderControlCharacters=93]="renderControlCharacters",oe[oe.renderFinalNewline=94]="renderFinalNewline",oe[oe.renderLineHighlight=95]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=97]="renderValidationDecorations",oe[oe.renderWhitespace=98]="renderWhitespace",oe[oe.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",oe[oe.roundedSelection=100]="roundedSelection",oe[oe.rulers=101]="rulers",oe[oe.scrollbar=102]="scrollbar",oe[oe.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=104]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=105]="scrollPredominantAxis",oe[oe.selectionClipboard=106]="selectionClipboard",oe[oe.selectionHighlight=107]="selectionHighlight",oe[oe.selectOnLineNumbers=108]="selectOnLineNumbers",oe[oe.showFoldingControls=109]="showFoldingControls",oe[oe.showUnused=110]="showUnused",oe[oe.snippetSuggestions=111]="snippetSuggestions",oe[oe.smartSelect=112]="smartSelect",oe[oe.smoothScrolling=113]="smoothScrolling",oe[oe.stickyScroll=114]="stickyScroll",oe[oe.stickyTabStops=115]="stickyTabStops",oe[oe.stopRenderingLineAfter=116]="stopRenderingLineAfter",oe[oe.suggest=117]="suggest",oe[oe.suggestFontSize=118]="suggestFontSize",oe[oe.suggestLineHeight=119]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",oe[oe.suggestSelection=121]="suggestSelection",oe[oe.tabCompletion=122]="tabCompletion",oe[oe.tabIndex=123]="tabIndex",oe[oe.unicodeHighlighting=124]="unicodeHighlighting",oe[oe.unusualLineTerminators=125]="unusualLineTerminators",oe[oe.useShadowDOM=126]="useShadowDOM",oe[oe.useTabStops=127]="useTabStops",oe[oe.wordBreak=128]="wordBreak",oe[oe.wordSeparators=129]="wordSeparators",oe[oe.wordWrap=130]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=133]="wordWrapColumn",oe[oe.wordWrapOverride1=134]="wordWrapOverride1",oe[oe.wordWrapOverride2=135]="wordWrapOverride2",oe[oe.wrappingIndent=136]="wrappingIndent",oe[oe.wrappingStrategy=137]="wrappingStrategy",oe[oe.showDeprecated=138]="showDeprecated",oe[oe.inlayHints=139]="inlayHints",oe[oe.editorClassName=140]="editorClassName",oe[oe.pixelRatio=141]="pixelRatio",oe[oe.tabFocusMode=142]="tabFocusMode",oe[oe.layoutInfo=143]="layoutInfo",oe[oe.wrappingInfo=144]="wrappingInfo",oe[oe.defaultColorDecorators=145]="defaultColorDecorators",oe[oe.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",oe[oe.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(et||(e.EditorOption=et={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(202,null)})),acceptSuggestionOnEnter:Re(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(203,null),""],markdownDescription:v.localize(204,null)})),accessibilitySupport:Re(new d),accessibilityPageSize:Re(new n(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(205,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",v.localize(206,null))),ariaRequired:Re(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:v.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Re(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(208,null),v.localize(209,null),""],description:v.localize(210,null)})),autoClosingComments:Re(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(211,null),v.localize(212,null),""],description:v.localize(213,null)})),autoClosingDelete:Re(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(214,null),""],description:v.localize(215,null)})),autoClosingOvertype:Re(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(216,null),""],description:v.localize(217,null)})),autoClosingQuotes:Re(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(218,null),v.localize(219,null),""],description:v.localize(220,null)})),autoIndent:Re(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),automaticLayout:Re(new s(13,"automaticLayout",!1)),autoSurround:Re(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null),""],description:v.localize(230,null)})),bracketPairColorization:Re(new H),bracketPairGuides:Re(new ae),stickyTabStops:Re(new s(115,"stickyTabStops",!1,{description:v.localize(231,null)})),codeLens:Re(new s(17,"codeLens",!0,{description:v.localize(232,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:v.localize(233,null)})),codeLensFontSize:Re(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(234,null)})),colorDecorators:Re(new s(20,"colorDecorators",!0,{description:v.localize(235,null)})),colorDecoratorActivatedOn:Re(new h(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[v.localize(236,null),v.localize(237,null),v.localize(238,null)],description:v.localize(239,null)})),colorDecoratorsLimit:Re(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:v.localize(240,null)})),columnSelection:Re(new s(22,"columnSelection",!1,{description:v.localize(241,null)})),comments:Re(new y),contextmenu:Re(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new s(25,"copyWithSyntaxHighlighting",!0,{description:v.localize(242,null)})),cursorBlinking:Re(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:v.localize(243,null)})),cursorSmoothCaretAnimation:Re(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[v.localize(244,null),v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),cursorStyle:Re(new u(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:v.localize(248,null)})),cursorSurroundingLines:Re(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(249,null)})),cursorSurroundingLinesStyle:Re(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(250,null),v.localize(251,null)],markdownDescription:v.localize(252,null)})),cursorWidth:Re(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(253,null)})),disableLayerHinting:Re(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new s(34,"domReadOnly",!1)),dragAndDrop:Re(new s(35,"dragAndDrop",!0,{description:v.localize(254,null)})),emptySelectionClipboard:Re(new M),dropIntoEditor:Re(new at),stickyScroll:Re(new he),experimentalWhitespaceRendering:Re(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[v.localize(255,null),v.localize(256,null),v.localize(257,null)],description:v.localize(258,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:v.localize(259,null)})),find:Re(new P),fixedOverflowWidgets:Re(new s(42,"fixedOverflowWidgets",!1)),folding:Re(new s(43,"folding",!0,{description:v.localize(260,null)})),foldingStrategy:Re(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(261,null),v.localize(262,null)],description:v.localize(263,null)})),foldingHighlight:Re(new s(45,"foldingHighlight",!0,{description:v.localize(264,null)})),foldingImportsByDefault:Re(new s(46,"foldingImportsByDefault",!1,{description:v.localize(265,null)})),foldingMaximumRegions:Re(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:v.localize(266,null)})),unfoldOnClickAfterEndOfLine:Re(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(267,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(268,null)})),fontInfo:Re(new O),fontLigatures2:Re(new x),fontSize:Re(new W),fontWeight:Re(new J),fontVariations:Re(new F),formatOnPaste:Re(new s(55,"formatOnPaste",!1,{description:v.localize(269,null)})),formatOnType:Re(new s(56,"formatOnType",!1,{description:v.localize(270,null)})),glyphMargin:Re(new s(57,"glyphMargin",!0,{description:v.localize(271,null)})),gotoLocation:Re(new ce),hideCursorInOverviewRuler:Re(new s(59,"hideCursorInOverviewRuler",!1,{description:v.localize(272,null)})),hover:Re(new G),inDiffEditor:Re(new s(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>a.clamp(oe,-5,20),{description:v.localize(273,null)})),lightbulb:Re(new we),lineDecorationsWidth:Re(new z),lineHeight:Re(new ne),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new s(69,"linkedEditing",!1,{description:v.localize(274,null)})),links:Re(new s(70,"links",!0,{description:v.localize(275,null)})),matchBrackets:Re(new h(71,"matchBrackets","always",["always","near","never"],{description:v.localize(276,null)})),minimap:Re(new Se),mouseStyle:Re(new h(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:v.localize(277,null)})),mouseWheelZoom:Re(new s(75,"mouseWheelZoom",!1,{markdownDescription:v.localize(278,null)})),multiCursorMergeOverlapping:Re(new s(76,"multiCursorMergeOverlapping",!0,{description:v.localize(279,null)})),multiCursorModifier:Re(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[v.localize(280,null),v.localize(281,null)],markdownDescription:v.localize(282,null)})),multiCursorPaste:Re(new h(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(283,null),v.localize(284,null)],markdownDescription:v.localize(285,null)})),multiCursorLimit:Re(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:v.localize(286,null)})),occurrencesHighlight:Re(new h(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[v.localize(287,null),v.localize(288,null),v.localize(289,null)],markdownDescription:v.localize(290,null)})),overviewRulerBorder:Re(new s(81,"overviewRulerBorder",!0,{description:v.localize(291,null)})),overviewRulerLanes:Re(new n(82,"overviewRulerLanes",3,0,3)),padding:Re(new me),pasteAs:Re(new ot),parameterHints:Re(new Z),peekWidgetDefaultFocus:Re(new h(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(292,null),v.localize(293,null)],description:v.localize(294,null)})),definitionLinkOpensInPeek:Re(new s(87,"definitionLinkOpensInPeek",!1,{description:v.localize(295,null)})),quickSuggestions:Re(new q),quickSuggestionsDelay:Re(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(296,null)})),readOnly:Re(new s(90,"readOnly",!1)),readOnlyMessage:Re(new ve),renameOnType:Re(new s(92,"renameOnType",!1,{description:v.localize(297,null),markdownDeprecationMessage:v.localize(298,null)})),renderControlCharacters:Re(new s(93,"renderControlCharacters",!0,{description:v.localize(299,null),restricted:!0})),renderFinalNewline:Re(new h(94,"renderFinalNewline",m.isLinux?"dimmed":"on",["off","on","dimmed"],{description:v.localize(300,null)})),renderLineHighlight:Re(new h(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(301,null)],description:v.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Re(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(303,null)})),renderValidationDecorations:Re(new h(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new h(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(304,null),v.localize(305,null),v.localize(306,null),""],description:v.localize(307,null)})),revealHorizontalRightPadding:Re(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new s(100,"roundedSelection",!0,{description:v.localize(308,null)})),rulers:Re(new Te),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:v.localize(309,null)})),scrollBeyondLastLine:Re(new s(104,"scrollBeyondLastLine",!0,{description:v.localize(310,null)})),scrollPredominantAxis:Re(new s(105,"scrollPredominantAxis",!0,{description:v.localize(311,null)})),selectionClipboard:Re(new s(106,"selectionClipboard",!0,{description:v.localize(312,null),included:m.isLinux})),selectionHighlight:Re(new s(107,"selectionHighlight",!0,{description:v.localize(313,null)})),selectOnLineNumbers:Re(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new h(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[v.localize(314,null),v.localize(315,null),v.localize(316,null)],description:v.localize(317,null)})),showUnused:Re(new s(110,"showUnused",!0,{description:v.localize(318,null)})),showDeprecated:Re(new s(138,"showDeprecated",!0,{description:v.localize(319,null)})),inlayHints:Re(new j),snippetSuggestions:Re(new h(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(320,null),v.localize(321,null),v.localize(322,null),v.localize(323,null)],description:v.localize(324,null)})),smartSelect:Re(new xe),smoothScrolling:Re(new s(113,"smoothScrolling",!1,{description:v.localize(325,null)})),stopRenderingLineAfter:Re(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Ae),inlineSuggest:Re(new ee),inlineCompletionsAccessibilityVerbose:Re(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:v.localize(326,null)})),suggestFontSize:Re(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new s(120,"suggestOnTriggerCharacters",!0,{description:v.localize(329,null)})),suggestSelection:Re(new h(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(330,null),v.localize(331,null),v.localize(332,null)],description:v.localize(333,null)})),tabCompletion:Re(new h(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(334,null),v.localize(335,null),v.localize(336,null)],description:v.localize(337,null)})),tabIndex:Re(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new K),unusualLineTerminators:Re(new h(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(338,null),v.localize(339,null),v.localize(340,null)],description:v.localize(341,null)})),useShadowDOM:Re(new s(126,"useShadowDOM",!0)),useTabStops:Re(new s(127,"useTabStops",!0,{description:v.localize(342,null)})),wordBreak:Re(new h(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[v.localize(343,null),v.localize(344,null)],description:v.localize(345,null)})),wordSeparators:Re(new t(129,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:v.localize(346,null)})),wordWrap:Re(new h(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(347,null),v.localize(348,null),v.localize(349,null),v.localize(350,null)],description:v.localize(351,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(352,null)})),wordWrapOverride1:Re(new h(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new h(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new U),defaultColorDecorators:Re(new s(145,"defaultColorDecorators",!1,{markdownDescription:v.localize(353,null)})),pixelRatio:Re(new ie),tabFocusMode:Re(new s(142,"tabFocusMode",!1,{markdownDescription:v.localize(354,null)})),layoutInfo:Re(new Y),wrappingInfo:Re(new Ze),wrappingIndent:Re(new Ke),wrappingStrategy:Re(new se)}}),define(ye[195],Ce([9,10]),function(ge,e){return ge.create("vs/editor/common/languages",e)}),define(ye[83],Ce([1,0,78,2,168,29,178,195]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.getAriaLabelForSymbol=e.symbolKindNames=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class p{constructor(x,F,O){this.offset=x,this.type=F,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=p;class S{constructor(x,F){this.tokens=x,this.endState=F,this._tokenizationResultBrand=void 0}}e.TokenizationResult=S;class L{constructor(x,F){this.tokens=x,this.endState=F,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=L;var I;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var g;(function(P){const x=new Map;x.set(0,D.Codicon.symbolMethod),x.set(1,D.Codicon.symbolFunction),x.set(2,D.Codicon.symbolConstructor),x.set(3,D.Codicon.symbolField),x.set(4,D.Codicon.symbolVariable),x.set(5,D.Codicon.symbolClass),x.set(6,D.Codicon.symbolStruct),x.set(7,D.Codicon.symbolInterface),x.set(8,D.Codicon.symbolModule),x.set(9,D.Codicon.symbolProperty),x.set(10,D.Codicon.symbolEvent),x.set(11,D.Codicon.symbolOperator),x.set(12,D.Codicon.symbolUnit),x.set(13,D.Codicon.symbolValue),x.set(15,D.Codicon.symbolEnum),x.set(14,D.Codicon.symbolConstant),x.set(15,D.Codicon.symbolEnum),x.set(16,D.Codicon.symbolEnumMember),x.set(17,D.Codicon.symbolKeyword),x.set(27,D.Codicon.symbolSnippet),x.set(18,D.Codicon.symbolText),x.set(19,D.Codicon.symbolColor),x.set(20,D.Codicon.symbolFile),x.set(21,D.Codicon.symbolReference),x.set(22,D.Codicon.symbolCustomColor),x.set(23,D.Codicon.symbolFolder),x.set(24,D.Codicon.symbolTypeParameter),x.set(25,D.Codicon.account),x.set(26,D.Codicon.issues);function F(J){let ce=x.get(J);return ce||(console.info("No codicon found for CompletionItemKind "+J),ce=D.Codicon.symbolProperty),ce}P.toIcon=F;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function W(J,ce){let G=O.get(J);return typeof G>"u"&&!ce&&(G=9),G}P.fromString=W})(g||(e.CompletionItemKinds=g={}));var w;(function(P){P[P.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var C;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(C||(e.CompletionItemInsertTextRule=C={}));var l;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(e.CompletionTriggerKind=l={}));var f;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class s{constructor(x,F,O,W){this.range=x,this.text=F,this.completionKind=O,this.isSnippetText=W}equals(x){return k.Range.lift(this.range).equalsRange(x.range)&&this.text===x.text&&this.completionKind===x.completionKind&&this.isSnippetText===x.isSnippetText}}e.SelectedSuggestionInfo=s;var i;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(P){return P&&N.URI.isUri(P.uri)&&k.Range.isIRange(P.range)&&(k.Range.isIRange(P.originSelectionRange)||k.Range.isIRange(P.targetSelectionRange))}e.isLocationLink=a;var t;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.symbolKindNames={[17]:(0,v.localize)(0,null),[16]:(0,v.localize)(1,null),[4]:(0,v.localize)(2,null),[13]:(0,v.localize)(3,null),[8]:(0,v.localize)(4,null),[9]:(0,v.localize)(5,null),[21]:(0,v.localize)(6,null),[23]:(0,v.localize)(7,null),[7]:(0,v.localize)(8,null),[0]:(0,v.localize)(9,null),[11]:(0,v.localize)(10,null),[10]:(0,v.localize)(11,null),[19]:(0,v.localize)(12,null),[5]:(0,v.localize)(13,null),[1]:(0,v.localize)(14,null),[2]:(0,v.localize)(15,null),[20]:(0,v.localize)(16,null),[15]:(0,v.localize)(17,null),[18]:(0,v.localize)(18,null),[24]:(0,v.localize)(19,null),[3]:(0,v.localize)(20,null),[6]:(0,v.localize)(21,null),[14]:(0,v.localize)(22,null),[22]:(0,v.localize)(23,null),[25]:(0,v.localize)(24,null),[12]:(0,v.localize)(25,null)};function r(P,x){return(0,v.localize)(26,null,P,e.symbolKindNames[x])}e.getAriaLabelForSymbol=r;var h;(function(P){P[P.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var u;(function(P){const x=new Map;x.set(0,D.Codicon.symbolFile),x.set(1,D.Codicon.symbolModule),x.set(2,D.Codicon.symbolNamespace),x.set(3,D.Codicon.symbolPackage),x.set(4,D.Codicon.symbolClass),x.set(5,D.Codicon.symbolMethod),x.set(6,D.Codicon.symbolProperty),x.set(7,D.Codicon.symbolField),x.set(8,D.Codicon.symbolConstructor),x.set(9,D.Codicon.symbolEnum),x.set(10,D.Codicon.symbolInterface),x.set(11,D.Codicon.symbolFunction),x.set(12,D.Codicon.symbolVariable),x.set(13,D.Codicon.symbolConstant),x.set(14,D.Codicon.symbolString),x.set(15,D.Codicon.symbolNumber),x.set(16,D.Codicon.symbolBoolean),x.set(17,D.Codicon.symbolArray),x.set(18,D.Codicon.symbolObject),x.set(19,D.Codicon.symbolKey),x.set(20,D.Codicon.symbolNull),x.set(21,D.Codicon.symbolEnumMember),x.set(22,D.Codicon.symbolStruct),x.set(23,D.Codicon.symbolEvent),x.set(24,D.Codicon.symbolOperator),x.set(25,D.Codicon.symbolTypeParameter);function F(O){let W=x.get(O);return W||(console.info("No codicon found for SymbolKind "+O),W=D.Codicon.symbolProperty),W}P.toIcon=F})(u||(e.SymbolKinds=u={}));class c{static asEditOperation(x){return m.EditOperation.replace(k.Range.lift(x.range),x.text)}}e.TextEdit=c;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(x){switch(x){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(x)}constructor(x){this.value=x}}e.FoldingRangeKind=d;var y;(function(P){function x(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}P.is=x})(y||(e.Command=y={}));var A;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(A||(e.CommentThreadCollapsibleState=A={}));var E;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(E||(e.CommentThreadState=E={}));var b;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(b||(e.CommentMode=b={}));var _;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(_||(e.CommentState=_={}));var T;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class U{constructor(x){this.createSupport=x,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(x=>{x&&x.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=U,e.TokenizationRegistry=new R.TokenizationRegistry;var M;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(M||(e.ExternalUriOpenerPriority=M={}))}),define(ye[196],Ce([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[197],Ce([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[198],Ce([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(ye[199],Ce([9,10]),function(ge,e){return ge.create("vs/platform/dialogs/common/dialogs",e)}),define(ye[200],Ce([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[201],Ce([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[202],Ce([9,10]),function(ge,e){return ge.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[203],Ce([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(ye[204],Ce([9,10]),function(ge,e){return ge.create("vs/platform/files/common/io",e)}),define(ye[205],Ce([9,10]),function(ge,e){return ge.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[206],Ce([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(ye[207],Ce([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[208],Ce([9,10]),function(ge,e){return ge.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[209],Ce([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(ye[210],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ye[211],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[212],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[213],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ye[214],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(ye[215],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(ye[216],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[217],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[218],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[219],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[220],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[221],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ye[222],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[223],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[224],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(ye[225],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(ye[226],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(ye[227],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[228],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[229],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[230],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[231],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[232],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[233],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ye[234],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[235],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ye[236],Ce([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[237],Ce([1,0,8,198]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var m;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(m||(e.TokenType=m={}));function k(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const R=(0,N.localize)(3,null),v=(0,N.localize)(4,null);class p{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,D.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(L){return this._input=L,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(k("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(k("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(k("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(L){return this._isAtEnd()||this._input.charCodeAt(this._current)!==L?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(L){this._tokens.push({type:L,offset:this._start})}_error(L){const I=this._start,g=this._input.substring(this._start,this._current),w={type:19,offset:this._start,lexeme:g};this._errors.push({offset:I,lexeme:g,additionalInfo:L}),this._tokens.push(w)}_string(){this.stringRe.lastIndex=this._start;const L=this.stringRe.exec(this._input);if(L){this._current=this._start+L[0].length;const I=this._input.substring(this._start,this._current),g=p._keywords.get(I);g?this._addToken(g):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let L=this._current,I=!1,g=!1;for(;;){if(L>=this._input.length){this._current=L,this._error(v);return}const C=this._input.charCodeAt(L);if(I)I=!1;else if(C===47&&!g){L++;break}else C===91?g=!0:C===92?I=!0:C===93&&(g=!1);L++}for(;L<this._input.length&&p._regexFlags.has(this._input.charCodeAt(L));)L++;this._current=L;const w=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:w,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=p}),define(ye[238],Ce([1,0,23,39,201,386]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function p(s){return s=s.trim(),s==="*"||R.test(s)}e.isValidVersionStr=p;function S(s){if(!p(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.parseVersion=S;function L(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let h=0;if(s.preRelease){const u=v.exec(s.preRelease);if(u){const[,c,d,y]=u;h=Date.UTC(Number(c),Number(d)-1,Number(y))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:h}}e.normalizeVersion=L;function I(s,i,n){let o;typeof s=="string"?o=L(S(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=L(S(n)):t=n,!o||!t)return!1;const r=o.majorBase,h=o.minorBase,u=o.patchBase;let c=t.majorBase,d=t.minorBase,y=t.patchBase;const A=t.notBefore;let E=t.majorMustEqual,b=t.minorMustEqual,_=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:h>d?!0:h<d||a&&a<A?!1:u>=y:(r===1&&c===0&&(!E||!b||!_)&&(c=1,d=0,y=0,E=!0,b=!1,_=!1),r<c?!1:r>c?!E:h<d?!1:h>d?!b:u<y?!1:u>y?!_:!(a&&a<A))}e.isValidVersion=I;function g(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([N.default.Error,m.localize(0,null)]),t;if(typeof o.name!="string")return t.push([N.default.Error,m.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([N.default.Error,m.localize(2,null,"version")]),t;if(!o.engines)return t.push([N.default.Error,m.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([N.default.Error,m.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!f(o.extensionDependencies))return t.push([N.default.Error,m.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!f(o.activationEvents))return t.push([N.default.Error,m.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([N.default.Error,m.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([N.default.Warning,m.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([N.default.Error,m.localize(9,null,"main")]),t;{const u=(0,D.joinPath)(n,o.main);(0,D.isEqualOrParent)(u,n)||t.push([N.default.Warning,m.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([N.default.Error,m.localize(11,null,"browser")]),t;{const u=(0,D.joinPath)(n,o.browser);(0,D.isEqualOrParent)(u,n)||t.push([N.default.Warning,m.localize(12,null,u.path,n.path)])}}if(!k.valid(o.version))return t.push([N.default.Error,m.localize(13,null)]),t;const r=[];if(!w(s,i,o,a,r))for(const u of r)t.push([N.default.Error,u]);return t}e.validateExtensionManifest=g;function w(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:l(s,i,n.engines.vscode,a)}e.isValidExtensionVersion=w;function C(s,i,n){return s==="*"||l(i,n,s)}e.isEngineValid=C;function l(s,i,n,o=[]){const a=L(S(n));if(!a)return o.push(m.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(m.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(m.localize(16,null,n)),!1;return I(s,i,a)?!0:(o.push(m.localize(17,null,s,n)),!1)}function f(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(ye[105],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(m,k=[],R=!1){this.ctor=m,this.staticArguments=k,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=D}),define(ye[106],Ce([1,0,105]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const N=[];var m;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(m||(e.InstantiationType=m={}));function k(v,p,S){p instanceof D.SyncDescriptor||(p=new D.SyncDescriptor(p,[],!!S)),N.push([v,p])}e.registerSingleton=k;function R(){return N}e.getSingletonServiceDescriptors=R}),define(ye[239],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(k,R){this.key=k,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class N{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const R of this._nodes.values())R.outgoing.size===0&&k.push(R);return k}insertEdge(k,R){const v=this.lookupOrInsertNode(k),p=this.lookupOrInsertNode(R);v.outgoing.set(p.key,p),p.incoming.set(v.key,v)}removeNode(k){const R=this._hashFn(k);this._nodes.delete(R);for(const v of this._nodes.values())v.outgoing.delete(R),v.incoming.delete(R)}lookupOrInsertNode(k){const R=this._hashFn(k);let v=this._nodes.get(R);return v||(v=new D(R,k),this._nodes.set(R,v)),v}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[R,v]of this._nodes)k.push(`${R}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,R]of this._nodes){const v=new Set([k]),p=this._findCycle(R,v);if(p)return p}}_findCycle(k,R){for(const[v,p]of k.outgoing){if(R.has(v))return[...R,v].join(" -> ");R.add(v);const S=this._findCycle(p,R);if(S)return S;R.delete(v)}}}e.Graph=N}),define(ye[5],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function v(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=v})(D||(e._util=D={})),e.IInstantiationService=m("instantiationService");function N(R,v,p){v[D.DI_TARGET]===v?v[D.DI_DEPENDENCIES].push({id:R,index:p}):(v[D.DI_DEPENDENCIES]=[{id:R,index:p}],v[D.DI_TARGET]=v)}function m(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const v=function(p,S,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(v,p,L)};return v.toString=()=>R,D.serviceIds.set(R,v),v}e.createDecorator=m;function k(R){return R}e.refineServiceDecorator=k}),define(ye[45],Ce([1,0,18,2,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,m.createDecorator)("configurationService");function k(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}e.isConfigurationOverrides=k;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}e.isConfigurationUpdateOverrides=R;var v;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function p(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function S(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.isConfigured=S;function L(s,i){const n=Object.create(null);for(const o in s)I(n,o,s[o],i);return n}e.toValuesTree=L;function I(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let h=0;h<a.length;h++){const u=a[h];let c=r[u];switch(typeof c){case"undefined":c=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function g(s,i){const n=i.split(".");w(s,n)}e.removeFromValueTree=g;function w(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(w(o,i),Object.keys(o).length===0&&delete s[n])}}function C(s,i,n){function o(r,h){let u=r;for(const c of h){if(typeof u!="object"||u===null)return;u=u[c]}return u}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.getConfigurationValue=C;function l(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?D.isObject(s[o])&&D.isObject(i[o])?l(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.merge=l;function f(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ye[46],Ce([1,0,11,13,237,5,197,8]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",D.isMacintosh),p.set("isLinux",D.isLinux),p.set("isWindows",D.isWindows),p.set("isWeb",D.isWeb),p.set("isMacNative",D.isMacintosh&&!D.isWeb),p.set("isEdge",D.isEdge),p.set("isFirefox",D.isFirefox),p.set("isChrome",D.isChrome),p.set("isSafari",D.isSafari);function S(j,z){if(p.get(j)!==void 0)throw(0,v.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(j,z)}e.setConstant=S;const L=Object.prototype.hasOwnProperty;var I;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const g={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),C=(0,R.localize)(1,null),l=(0,R.localize)(2,null),f=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(z=g){this._config=z,this._scanner=new m.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(z){if(z===""){this._parsingErrors.push({message:w,offset:0,lexeme:"",additionalInfo:C});return}this._tokens=this._scanner.reset(z).scan(),this._current=0,this._parsingErrors=[];try{const ne=this._expr();if(!this._isAtEnd()){const Se=this._peek(),de=Se.type===17?i:void 0;throw this._parsingErrors.push({message:s,offset:Se.offset,lexeme:m.Scanner.getLexeme(Se),additionalInfo:de}),a._parseError}return ne}catch(ne){if(ne!==a._parseError)throw ne;return}}_expr(){return this._or()}_or(){const z=[this._and()];for(;this._matchOne(16);){const ne=this._and();z.push(ne)}return z.length===1?z[0]:t.or(...z)}_and(){const z=[this._term()];for(;this._matchOne(15);){const ne=this._term();z.push(ne)}return z.length===1?z[0]:t.and(...z)}_term(){if(this._matchOne(2)){const z=this._peek();switch(z.type){case 11:return this._advance(),c.INSTANCE;case 12:return this._advance(),d.INSTANCE;case 0:{this._advance();const ne=this._expr();return this._consume(1,f),ne?.negate()}case 17:return this._advance(),T.create(z.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",z)}}return this._primary()}_primary(){const z=this._peek();switch(z.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const ne=this._expr();return this._consume(1,f),ne}case 17:{const ne=z.lexeme;if(this._advance(),this._matchOne(9)){const de=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),de.type!==10)throw this._errExpectedButGot("REGEX",de);const me=de.lexeme,Z=me.lastIndexOf("/"),ie=Z===me.length-1?void 0:this._removeFlagsGY(me.substring(Z+1));let q;try{q=new RegExp(me.substring(1,Z),ie)}catch{throw this._errExpectedButGot("REGEX",de)}return O.create(ne,q)}switch(de.type){case 10:case 19:{const me=[de.lexeme];this._advance();let Z=this._peek(),ie=0;for(let Te=0;Te<de.lexeme.length;Te++)de.lexeme.charCodeAt(Te)===40?ie++:de.lexeme.charCodeAt(Te)===41&&ie--;for(;!this._isAtEnd()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Te=0;Te<Z.lexeme.length;Te++)Z.lexeme.charCodeAt(Te)===40?ie++:de.lexeme.charCodeAt(Te)===41&&ie--}if(ie<0)break;me.push(m.Scanner.getLexeme(Z)),this._advance(),Z=this._peek()}const q=me.join(""),te=q.lastIndexOf("/"),fe=te===q.length-1?void 0:this._removeFlagsGY(q.substring(te+1));let Ee;try{Ee=new RegExp(q.substring(1,te),fe)}catch{throw this._errExpectedButGot("REGEX",de)}return t.regex(ne,Ee)}case 18:{const me=de.lexeme;this._advance();let Z=null;if(!(0,N.isFalsyOrWhitespace)(me)){const ie=me.indexOf("/"),q=me.lastIndexOf("/");if(ie!==q&&ie>=0){const te=me.slice(ie+1,q),fe=me[q+1]==="i"?"i":"";try{Z=new RegExp(te,fe)}catch{throw this._errExpectedButGot("REGEX",de)}}}if(Z===null)throw this._errExpectedButGot("REGEX",de);return O.create(ne,Z)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,l);const de=this._value();return t.notIn(ne,de)}switch(this._peek().type){case 3:{this._advance();const de=this._value();if(this._previous().type===18)return t.equals(ne,de);switch(de){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,de)}}case 4:{this._advance();const de=this._value();if(this._previous().type===18)return t.notEquals(ne,de);switch(de){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,de)}}case 5:return this._advance(),x.create(ne,this._value());case 6:return this._advance(),F.create(ne,this._value());case 7:return this._advance(),M.create(ne,this._value());case 8:return this._advance(),P.create(ne,this._value());case 13:return this._advance(),t.in(ne,this._value());default:return t.has(ne)}}case 20:throw this._parsingErrors.push({message:n,offset:z.offset,lexeme:"",additionalInfo:o}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const z=this._peek();switch(z.type){case 17:case 18:return this._advance(),z.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(z){return z.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(z){return this._check(z)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(z,ne){if(this._check(z))return this._advance();throw this._errExpectedButGot(ne,this._peek())}_errExpectedButGot(z,ne,Se){const de=(0,R.localize)(8,null,z,m.Scanner.getLexeme(ne)),me=ne.offset,Z=m.Scanner.getLexeme(ne);return this._parsingErrors.push({message:de,offset:me,lexeme:Z,additionalInfo:Se}),a._parseError}_check(z){return this._peek().type===z}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return c.INSTANCE}static true(){return d.INSTANCE}static has(z){return y.create(z)}static equals(z,ne){return A.create(z,ne)}static notEquals(z,ne){return _.create(z,ne)}static regex(z,ne){return O.create(z,ne)}static in(z,ne){return E.create(z,ne)}static notIn(z,ne){return b.create(z,ne)}static not(z){return T.create(z)}static and(...z){return ce.create(z,null,!0)}static or(...z){return G.create(z,null,!0)}static greater(z,ne){return M.create(z,ne)}static greaterEquals(z,ne){return P.create(z,ne)}static smaller(z,ne){return x.create(z,ne)}static smallerEquals(z,ne){return F.create(z,ne)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this._parser.parse(z)}}e.ContextKeyExpr=t;function r(j){const z=new a({regexParsingWithErrorRecovery:!1});return j.map(ne=>(z.parse(ne),z.lexingErrors.length>0?z.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,R.localize)(9,null,Se.additionalInfo):(0,R.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}e.validateWhenClauses=r;function h(j,z){const ne=j?j.substituteConstants():void 0,Se=z?z.substituteConstants():void 0;return!ne&&!Se?!0:!ne||!Se?!1:ne.equals(Se)}e.expressionsAreEqualWithConstantSubstitution=h;function u(j,z){return j.cmp(z)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=c;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=d;class y{static create(z,ne=null){const Se=p.get(z);return typeof Se=="boolean"?Se?d.INSTANCE:c.INSTANCE:new y(z,ne)}constructor(z,ne){this.key=z,this.negated=ne,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=p.get(this.key);return typeof z=="boolean"?z?d.INSTANCE:c.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class A{static create(z,ne,Se=null){if(typeof ne=="boolean")return ne?y.create(z,Se):T.create(z,Se);const de=p.get(z);return typeof de=="boolean"?ne===(de?"true":"false")?d.INSTANCE:c.INSTANCE:new A(z,ne,Se)}constructor(z,ne,Se){this.key=z,this.value=ne,this.negated=Se,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=p.get(this.key);if(typeof z=="boolean"){const ne=z?"true":"false";return this.value===ne?d.INSTANCE:c.INSTANCE}return this}evaluate(z){return z.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(z){return z.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=A;class E{static create(z,ne){return new E(z,ne)}constructor(z,ne){this.key=z,this.valueKey=ne,this.type=10,this.negated=null}cmp(z){return z.type!==this.type?this.type-z.type:se(this.key,this.valueKey,z.key,z.valueKey)}equals(z){return z.type===this.type?this.key===z.key&&this.valueKey===z.valueKey:!1}substituteConstants(){return this}evaluate(z){const ne=z.getValue(this.valueKey),Se=z.getValue(this.key);return Array.isArray(ne)?ne.includes(Se):typeof Se=="string"&&typeof ne=="object"&&ne!==null?L.call(ne,Se):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(z){return z.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=E;class b{static create(z,ne){return new b(z,ne)}constructor(z,ne){this.key=z,this.valueKey=ne,this.type=11,this._negated=E.create(z,ne)}cmp(z){return z.type!==this.type?this.type-z.type:this._negated.cmp(z._negated)}equals(z){return z.type===this.type?this._negated.equals(z._negated):!1}substituteConstants(){return this}evaluate(z){return!this._negated.evaluate(z)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(z){return z.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class _{static create(z,ne,Se=null){if(typeof ne=="boolean")return ne?T.create(z,Se):y.create(z,Se);const de=p.get(z);return typeof de=="boolean"?ne===(de?"true":"false")?c.INSTANCE:d.INSTANCE:new _(z,ne,Se)}constructor(z,ne,Se){this.key=z,this.value=ne,this.negated=Se,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){const z=p.get(this.key);if(typeof z=="boolean"){const ne=z?"true":"false";return this.value===ne?c.INSTANCE:d.INSTANCE}return this}evaluate(z){return z.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(z){return z.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class T{static create(z,ne=null){const Se=p.get(z);return typeof Se=="boolean"?Se?c.INSTANCE:d.INSTANCE:new T(z,ne)}constructor(z,ne){this.key=z,this.negated=ne,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:Y(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=p.get(this.key);return typeof z=="boolean"?z?c.INSTANCE:d.INSTANCE:this}evaluate(z){return!z.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(z){return z.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=T;function U(j,z){if(typeof j=="string"){const ne=parseFloat(j);isNaN(ne)||(j=ne)}return typeof j=="string"||typeof j=="number"?z(j):c.INSTANCE}class M{static create(z,ne,Se=null){return U(ne,de=>new M(z,de,Se))}constructor(z,ne,Se){this.key=z,this.value=ne,this.negated=Se,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=M;class P{static create(z,ne,Se=null){return U(ne,de=>new P(z,de,Se))}constructor(z,ne,Se){this.key=z,this.value=ne,this.negated=Se,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(z){return z.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=P;class x{static create(z,ne,Se=null){return U(ne,de=>new x(z,de,Se))}constructor(z,ne,Se){this.key=z,this.value=ne,this.negated=Se,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class F{static create(z,ne,Se=null){return U(ne,de=>new F(z,de,Se))}constructor(z,ne,Se){this.key=z,this.value=ne,this.negated=Se,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:se(this.key,this.value,z.key,z.value)}equals(z){return z.type===this.type?this.key===z.key&&this.value===z.value:!1}substituteConstants(){return this}evaluate(z){return typeof this.value=="string"?!1:parseFloat(z.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(z){return z.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=F;class O{static create(z,ne){return new O(z,ne)}constructor(z,ne){this.key=z,this.regexp=ne,this.type=7,this.negated=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.key<z.key)return-1;if(this.key>z.key)return 1;const ne=this.regexp?this.regexp.source:"",Se=z.regexp?z.regexp.source:"";return ne<Se?-1:ne>Se?1:0}equals(z){if(z.type===this.type){const ne=this.regexp?this.regexp.source:"",Se=z.regexp?z.regexp.source:"";return this.key===z.key&&ne===Se}return!1}substituteConstants(){return this}evaluate(z){const ne=z.getValue(this.key);return this.regexp?this.regexp.test(ne):!1}serialize(){const z=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${z}`}keys(){return[this.key]}map(z){return z.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=W.create(this)),this.negated}}e.ContextKeyRegexExpr=O;class W{static create(z){return new W(z)}constructor(z){this._actual=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this._actual.cmp(z._actual)}equals(z){return z.type===this.type?this._actual.equals(z._actual):!1}substituteConstants(){return this}evaluate(z){return!this._actual.evaluate(z)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(z){return new W(this._actual.map(z))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=W;function J(j){let z=null;for(let ne=0,Se=j.length;ne<Se;ne++){const de=j[ne].substituteConstants();if(j[ne]!==de&&z===null){z=[];for(let me=0;me<ne;me++)z[me]=j[me]}z!==null&&(z[ne]=de)}return z===null?j:z}class ce{static create(z,ne,Se){return ce._normalizeArr(z,ne,Se)}constructor(z,ne){this.expr=z,this.negated=ne,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let ne=0,Se=this.expr.length;ne<Se;ne++){const de=u(this.expr[ne],z.expr[ne]);if(de!==0)return de}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].equals(z.expr[ne]))return!1;return!0}return!1}substituteConstants(){const z=J(this.expr);return z===this.expr?this:ce.create(z,this.negated,!1)}evaluate(z){for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].evaluate(z))return!1;return!0}static _normalizeArr(z,ne,Se){const de=[];let me=!1;for(const Z of z)if(Z){if(Z.type===1){me=!0;continue}if(Z.type===0)return c.INSTANCE;if(Z.type===6){de.push(...Z.expr);continue}de.push(Z)}if(de.length===0&&me)return d.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(u);for(let Z=1;Z<de.length;Z++)de[Z-1].equals(de[Z])&&(de.splice(Z,1),Z--);if(de.length===1)return de[0];for(;de.length>1;){const Z=de[de.length-1];if(Z.type!==9)break;de.pop();const ie=de.pop(),q=de.length===0,te=G.create(Z.expr.map(fe=>ce.create([fe,ie],null,Se)),null,q);te&&(de.push(te),de.sort(u))}if(de.length===1)return de[0];if(Se){for(let Z=0;Z<de.length;Z++)for(let ie=Z+1;ie<de.length;ie++)if(de[Z].negate().equals(de[ie]))return c.INSTANCE;if(de.length===1)return de[0]}return new ce(de,ne)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const ne of this.expr)z.push(...ne.keys());return z}map(z){return new ce(this.expr.map(ne=>ne.map(z)),null)}negate(){if(!this.negated){const z=[];for(const ne of this.expr)z.push(ne.negate());this.negated=G.create(z,this,!0)}return this.negated}}e.ContextKeyAndExpr=ce;class G{static create(z,ne,Se){return G._normalizeArr(z,ne,Se)}constructor(z,ne){this.expr=z,this.negated=ne,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let ne=0,Se=this.expr.length;ne<Se;ne++){const de=u(this.expr[ne],z.expr[ne]);if(de!==0)return de}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].equals(z.expr[ne]))return!1;return!0}return!1}substituteConstants(){const z=J(this.expr);return z===this.expr?this:G.create(z,this.negated,!1)}evaluate(z){for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(this.expr[ne].evaluate(z))return!0;return!1}static _normalizeArr(z,ne,Se){let de=[],me=!1;if(z){for(let Z=0,ie=z.length;Z<ie;Z++){const q=z[Z];if(q){if(q.type===0){me=!0;continue}if(q.type===1)return d.INSTANCE;if(q.type===9){de=de.concat(q.expr);continue}de.push(q)}}if(de.length===0&&me)return c.INSTANCE;de.sort(u)}if(de.length!==0){if(de.length===1)return de[0];for(let Z=1;Z<de.length;Z++)de[Z-1].equals(de[Z])&&(de.splice(Z,1),Z--);if(de.length===1)return de[0];if(Se){for(let Z=0;Z<de.length;Z++)for(let ie=Z+1;ie<de.length;ie++)if(de[Z].negate().equals(de[ie]))return d.INSTANCE;if(de.length===1)return de[0]}return new G(de,ne)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const ne of this.expr)z.push(...ne.keys());return z}map(z){return new G(this.expr.map(ne=>ne.map(z)),null)}negate(){if(!this.negated){const z=[];for(const ne of this.expr)z.push(ne.negate());for(;z.length>1;){const ne=z.shift(),Se=z.shift(),de=[];for(const me of he(ne))for(const Z of he(Se))de.push(ce.create([me,Z],null,!1));z.unshift(G.create(de,null,!1))}this.negated=G.create(z,this,!0)}return this.negated}}e.ContextKeyOrExpr=G;class X extends y{static{this._info=[]}static all(){return X._info.values()}constructor(z,ne,Se){super(z,null),this._defaultValue=ne,typeof Se=="object"?X._info.push({...Se,key:z}):Se!==!0&&X._info.push({key:z,description:Se,type:ne!=null?typeof ne:void 0})}bindTo(z){return z.createKey(this.key,this._defaultValue)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return A.create(this.key,z)}notEqualsTo(z){return _.create(this.key,z)}}e.RawContextKey=X,e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function Y(j,z){return j<z?-1:j>z?1:0}function se(j,z,ne,Se){return j<ne?-1:j>ne?1:z<Se?-1:z>Se?1:0}function Q(j,z){if(j.type===0||z.type===1)return!0;if(j.type===9)return z.type===9?we(j.expr,z.expr):!1;if(z.type===9){for(const ne of z.expr)if(Q(j,ne))return!0;return!1}if(j.type===6){if(z.type===6)return we(z.expr,j.expr);for(const ne of j.expr)if(Q(ne,z))return!0;return!1}return j.equals(z)}e.implies=Q;function we(j,z){let ne=0,Se=0;for(;ne<j.length&&Se<z.length;){const de=j[ne].cmp(z[Se]);if(de<0)return!1;de===0&&ne++,Se++}return ne===j.length}function he(j){return j.type===9?j.expr:[j]}}),define(ye[240],Ce([1,0,23,39,199,5,102,11,24]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,k.createDecorator)("dialogService");var S;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(S||(S={}));class L{getConfirmationButtons(f){return this.getButtons(f,S.Confirmation)}getPromptButtons(f){return this.getButtons(f,S.Prompt)}getInputButtons(f){return this.getButtons(f,S.Input)}getButtons(f,s){const i=[];switch(s){case S.Confirmation:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(1,null));break}case S.Prompt:{const n=f;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,m.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,m.localize)(3,null))),i.length===0&&i.push((0,m.localize)(4,null));break}case S.Input:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(6,null));break}}return i}getDialogType(f){if(typeof f=="string")return f;if(typeof f=="number")return f===N.default.Info?"info":f===N.default.Error?"error":f===N.default.Warning?"warning":"none"}getPromptResult(f,s,i){const n=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&n.push(f.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.AbstractDialogHandler=L,e.IFileDialogService=(0,k.createDecorator)("fileDialogService");var I;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const g=10;function w(l){const f=[];return f.push(...l.slice(0,g).map(s=>typeof s=="string"?s:(0,D.basename)(s))),l.length>g&&(l.length-g===1?f.push((0,m.localize)(7,null)):f.push((0,m.localize)(8,null,l.length-g))),f.push(""),f.join(`
`)}e.getFileNamesMessage=w;function C(l,f){const s=(0,p.deepClone)(l);let i=(s.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),n=(l.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(v.isLinux||v.isMacintosh){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}v.isLinux&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(v.isWindows&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||f.nameLong,{options:s,buttonIndeces:n}}e.massageMessageBoxOptions=C}),define(ye[133],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[134],Ce([1,0,200,5]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function m(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=m;function k(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function R(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":i==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function v(s,i){return i==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=v;function p(s,i,n){return v(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.isTargetPlatformCompatible=p;function S(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=S;var L;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var I;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var g;(function(s){s.Install="install",s.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var w;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.IExtensionGalleryService=(0,N.createDecorator)("extensionGalleryService");var C;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(C||(e.ExtensionManagementErrorCode=C={}));var l;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,N.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,N.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,N.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ye[241],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,D.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ye[242],Ce([1,0,51,17,16,11,101,31,104,202,241]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=S.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await l.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends g{static{this.CMD="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(D,o,p.getWindowsShell(),a)}spawnTerminal(o,a,t,r){const h=a.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=m.basename(h,".exe").toLowerCase();if(u==="cmder")return o.spawn(h,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return h.indexOf(" ")>=0&&c.push('""'),c.push(h),u==="wt"&&c.push("-d ."),new Promise((d,y)=>{const A=f(process),E=o.spawn(t,c,{cwd:r,env:A});E.on("error",y),E.on("exit",()=>d())})}runInTerminal(o,a,t,r,h){const u="windowsExec"in h&&h.windowsExec?h.windowsExec:w.getDefaultTerminalWindows();return new Promise((c,d)=>{const y=`"${a} - ${I}"`,A=`""${t.join('" "')}" & pause"`,E=Object.assign({},f(process),r);Object.keys(E).filter(M=>E[M]===null).forEach(M=>delete E[M]);const b={cwd:a,env:E,windowsVerbatimArguments:!0};let _,T;m.basename(u,".exe")==="wt"?(_=u,T=["-d",".",w.CMD,"/c",A]):(_=w.CMD,T=["/c","start",y,"/wait",u,"/c",A]),D.spawn(_,T,b).on("error",M=>{d(s(M))}),c(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w;class C extends g{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,h){const u=h.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((c,d)=>{if(u===L.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const y=u===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[N.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",o||I,"-w",a];for(const T of t)E.push("-a"),E.push(T);if(r){const T=Object.assign({},f(process),r);for(const U in T){const M=T[U];M===null?(E.push("-u"),E.push(U)):(E.push("-e"),E.push(`${U}=${M}`))}}let b="";const _=D.spawn(C.OSASCRIPT,E);_.on("error",T=>{d(s(T))}),_.stderr.on("data",T=>{b+=T.toString()}),_.on("exit",T=>{if(T===0)c(void 0);else if(b){const U=b.split(`
`,1);d(new Error(U[0]))}else d(new Error(S.localize(1,null,y,T)))})}else d(new Error(S.localize(2,null,u)))})}spawnTerminal(o,a,t){const r=a.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((h,u)=>{const c=["-a",r];t&&c.push(t);const d=f(process),y=o.spawn("/usr/bin/open",c,{cwd:t,env:d});y.on("error",u),y.on("exit",()=>h())})}}e.MacExternalTerminalService=C;class l extends g{static{this.WAIT_MESSAGE=S.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,h){const u=h.linuxExec?Promise.resolve(h.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((c,d)=>{const y=[];u.then(A=>{A.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const E=`${i(t)}; echo; read -p "${l.WAIT_MESSAGE}" -n1;`;y.push(`''${E}''`);const b=Object.assign({},f(process),r);Object.keys(b).filter(M=>b[M]===null).forEach(M=>delete b[M]);const _={cwd:a,env:b};let T="";const U=D.spawn(A,y,_);U.on("error",M=>{d(s(M))}),U.stderr.on("data",M=>{T+=M.toString()}),U.on("exit",M=>{if(M===0)c(void 0);else if(T){const P=T.split(`
`,1);d(new Error(P[0]))}else d(new Error(S.localize(4,null,A,M)))})})})}static async getDefaultTerminalLinuxReady(){if(!l._DEFAULT_TERMINAL_LINUX_READY)if(!k.isLinux)l._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await v.Promises.exists("/etc/debian_version");l._DEFAULT_TERMINAL_LINUX_READY=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return l._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((h,u)=>{r.then(c=>{const d=f(process),y=o.spawn(c,[],{cwd:t,env:d});y.on("error",u),y.on("exit",()=>h())})})}}e.LinuxExternalTerminalService=l;function f(n){const o={...n.env};return(0,R.sanitizeProcessEnvironment)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(S.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(ye[32],Ce([1,0,77,16,13,18,2,203,5,11,17,43]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function g(Q){return Q.create===!0}e.isFileOpenForWriteOptions=g;var w;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.File=1]="File",Q[Q.Directory=2]="Directory",Q[Q.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var C;(function(Q){Q[Q.Readonly=1]="Readonly",Q[Q.Locked=2]="Locked"})(C||(e.FilePermission=C={}));function l(Q){const we=Q;return!!we&&typeof we.onDidChange=="function"}e.isFileSystemWatcher=l;var f;(function(Q){Q[Q.None=0]="None",Q[Q.FileReadWrite=2]="FileReadWrite",Q[Q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Q[Q.FileReadStream=16]="FileReadStream",Q[Q.FileFolderCopy=8]="FileFolderCopy",Q[Q.PathCaseSensitive=1024]="PathCaseSensitive",Q[Q.Readonly=2048]="Readonly",Q[Q.Trash=4096]="Trash",Q[Q.FileWriteUnlock=8192]="FileWriteUnlock",Q[Q.FileAtomicRead=16384]="FileAtomicRead",Q[Q.FileAtomicWrite=32768]="FileAtomicWrite",Q[Q.FileAtomicDelete=65536]="FileAtomicDelete",Q[Q.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function s(Q){return!!(Q.capabilities&2)}e.hasReadWriteCapability=s;function i(Q){return!!(Q.capabilities&8)}e.hasFileFolderCopyCapability=i;function n(Q){return!!(Q.capabilities&131072)}e.hasFileCloneCapability=n;function o(Q){return!!(Q.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function a(Q){return!!(Q.capabilities&16)}e.hasFileReadStreamCapability=a;function t(Q){return s(Q)?!!(Q.capabilities&16384):!1}e.hasFileAtomicReadCapability=t;function r(Q){return s(Q)?!!(Q.capabilities&32768):!1}e.hasFileAtomicWriteCapability=r;function h(Q){return!!(Q.capabilities&65536)}e.hasFileAtomicDeleteCapability=h;function u(Q){return!!(Q.capabilities&2048)}e.hasReadonlyCapability=u;var c;(function(Q){Q.FileExists="EntryExists",Q.FileNotFound="EntryNotFound",Q.FileNotADirectory="EntryNotADirectory",Q.FileIsADirectory="EntryIsADirectory",Q.FileExceedsStorageQuota="EntryExceedsStorageQuota",Q.FileTooLarge="EntryTooLarge",Q.FileWriteLocked="EntryWriteLocked",Q.NoPermissions="NoPermissions",Q.Unavailable="Unavailable",Q.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class d extends Error{static create(we,he){const j=new d(we.toString(),he);return E(j,he),j}constructor(we,he){super(we),this.code=he}}e.FileSystemProviderError=d;function y(Q,we){return d.create(Q,we)}e.createFileSystemProviderError=y;function A(Q){return Q||y((0,v.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=A;function E(Q,we){return Q.name=we?`${we} (FileSystemError)`:"FileSystemError",Q}e.markAsFileSystemProviderError=E;function b(Q){if(!Q)return c.Unknown;if(Q instanceof d)return Q.code;const we=/^(.+) \(FileSystemError\)$/.exec(Q.name);if(!we)return c.Unknown;switch(we[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=b;function _(Q){if(Q instanceof F)return Q.fileOperationResult;switch(b(Q)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=_;var T;(function(Q){Q[Q.CREATE=0]="CREATE",Q[Q.DELETE=1]="DELETE",Q[Q.MOVE=2]="MOVE",Q[Q.COPY=3]="COPY",Q[Q.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class U{constructor(we,he,j){this.resource=we,this.operation=he,this.target=j}isOperation(we){return this.operation===we}}e.FileOperationEvent=U;var M;(function(Q){Q[Q.UPDATED=0]="UPDATED",Q[Q.ADDED=1]="ADDED",Q[Q.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class P{static{this.MIXED_CORRELATION=null}constructor(we,he){this.ignorePathCasing=he,this.correlationId=void 0,this.added=new I.Lazy(()=>{const j=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawAdded.map(z=>[z,!0])),j}),this.updated=new I.Lazy(()=>{const j=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawUpdated.map(z=>[z,!0])),j}),this.deleted=new I.Lazy(()=>{const j=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return j.fill(this.rawDeleted.map(z=>[z,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of we){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.correlationId!==P.MIXED_CORRELATION&&(typeof j.cId=="number"?this.correlationId===void 0?this.correlationId=j.cId:this.correlationId!==j.cId&&(this.correlationId=P.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=P.MIXED_CORRELATION))}}contains(we,...he){return this.doContains(we,{includeChildren:!1},...he)}affects(we,...he){return this.doContains(we,{includeChildren:!0},...he)}doContains(we,he,...j){if(!we)return!1;const z=j.length>0;return!!((!z||j.includes(1))&&(this.added.value.get(we)||he.includeChildren&&this.added.value.findSuperstr(we))||(!z||j.includes(0))&&(this.updated.value.get(we)||he.includeChildren&&this.updated.value.findSuperstr(we))||(!z||j.includes(2))&&(this.deleted.value.findSubstr(we)||he.includeChildren&&this.deleted.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.correlationId===we}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=P;function x(Q,we,he){return!Q||!we||Q===we||we.length>Q.length?!1:(we.charAt(we.length-1)!==N.sep&&(we+=N.sep),he?(0,m.startsWithIgnoreCase)(Q,we):Q.indexOf(we)===0)}e.isParent=x;class F extends Error{constructor(we,he,j){super(we),this.fileOperationResult=he,this.options=j}}e.FileOperationError=F;class O extends F{constructor(we,he,j,z){super(we,he,z),this.fileOperationResult=he,this.size=j}}e.TooLargeFileOperationError=O;class W extends F{constructor(we,he,j){super(we,2,j),this.stat=he}}e.NotModifiedSinceFileOperationError=W;var J;(function(Q){Q[Q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Q[Q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Q[Q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Q[Q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Q[Q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Q[Q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Q[Q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Q[Q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Q[Q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Q[Q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Q[Q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var ce;(function(Q){Q[Q.FILE=0]="FILE",Q[Q.FOLDER=1]="FOLDER",Q[Q.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.ETAG_DISABLED="";function G(Q){if(!(typeof Q.size!="number"||typeof Q.mtime!="number"))return Q.mtime.toString(29)+Q.size.toString(31)}e.etag=G;async function X(Q,we){if(!we.hasProvider(R.URI.from({scheme:Q.scheme})))return new Promise(he=>{const j=we.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===Q.scheme&&z.added&&(j.dispose(),he())})})}e.whenProviderRegistered=X;class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(we){return(0,k.isNumber)(we)||(we=0),we<Y.KB?(0,v.localize)(1,null,we.toFixed(0)):we<Y.MB?(0,v.localize)(2,null,(we/Y.KB).toFixed(2)):we<Y.GB?(0,v.localize)(3,null,(we/Y.MB).toFixed(2)):we<Y.TB?(0,v.localize)(4,null,(we/Y.GB).toFixed(2)):(0,v.localize)(5,null,(we/Y.TB).toFixed(2))}}e.ByteSize=Y;function se(Q){const we=typeof Q=="string"||Q?.scheme===L.Schemas.vscodeRemote;return typeof Q!="string"&&Q?.scheme===L.Schemas.file?1024*Y.MB:we?10*Y.MB:S.isWeb?50*Y.MB:1024*Y.MB}e.getLargeFileConfirmationLimit=se}),define(ye[243],Ce([1,0,22,8,204,32]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(L,I,g,w,C,l){let f;try{await v(L,I,g,w,C,l)}catch(s){f=s}finally{f&&C.errorTransformer&&(f=C.errorTransformer(f)),typeof f<"u"&&g.error(f),g.end()}}e.readFileIntoStream=R;async function v(L,I,g,w,C,l){p(l);const f=await L.open(I,{create:!1});try{p(l);let s=0,i=0,n=C&&typeof C.length=="number"?C.length:void 0,o=D.VSBuffer.alloc(Math.min(C.bufferSize,typeof n=="number"?n:C.bufferSize)),a=C&&typeof C.position=="number"?C.position:0,t=0;do i=await L.read(f,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await g.write(w(o)),o=D.VSBuffer.alloc(Math.min(C.bufferSize,typeof n=="number"?n:C.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&p(l)&&S(s,C));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),g.write(w(o.slice(0,r)))}}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await L.close(f)}}function p(L){if(L.isCancellationRequested)throw(0,N.canceled)();return!0}function S(L,I){if(typeof I?.limits?.size=="number"&&L>I.limits.size)throw(0,k.createFileSystemProviderError)((0,m.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[84],Ce([1,0,34,3,16,11,2,32]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.reviveFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(s){return s.recursive===!0}e.isRecursiveWatchRequest=p;class S extends N.Disposable{static{this.MAX_RESTARTS=5}constructor(i,n,o,a){super(),this.onFileChanges=i,this.onLogMessage=n,this.verboseLogging=o,this.options=a,this.watcherDisposables=this._register(new N.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const i=new N.DisposableStore;this.watcherDisposables.value=i,this.watcher=this.createWatcher(i),this.watcher.setVerboseLogging(this.verboseLogging),i.add(this.watcher.onDidChangeFile(n=>this.onFileChanges(n))),i.add(this.watcher.onDidLogMessage(n=>this.onLogMessage(n))),i.add(this.watcher.onDidError(n=>this.onError(n)))}onError(i){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${i}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${i}`):this.error(i)}restart(i){this.restartCounter++,this.init(),this.watch(i)}async watch(i){this.requests=i,await this.watcher?.watch(i)}async setVerboseLogging(i){this.verboseLogging=i,await this.watcher?.setVerboseLogging(i)}error(i){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${i}`})}trace(i){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${i}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S;class L extends S{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=L;class I extends S{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function g(s){return s.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.reviveFileChanges=g;function w(s){const i=new f;for(const n of s)i.processEvent(n);return i.coalesce()}e.coalesceEvents=w;function C(s,i){return typeof i=="string"&&!i.startsWith(D.GLOBSTAR)&&!(0,m.isAbsolute)(i)?{base:s,pattern:i}:i}e.normalizeWatcherPattern=C;function l(s,i){const n=[];for(const o of i)n.push((0,D.parse)(C(s,o)));return n}e.parseWatcherPatterns=l;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(i){return k.isLinux?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.mapPathToChange.get(this.toKey(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.mapPathToChange.delete(this.toKey(i)),this.coalesced.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.coalesced.add(i),this.mapPathToChange.set(this.toKey(i),i))}coalesce(){const i=[],n=[];return Array.from(this.coalesced).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,v.isParent)(o.resource.fsPath,a,!k.isLinux))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(ye[244],Ce([1,0,55,12,21,33,3,76,16,11,23,2,103,31,84]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class l extends R.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(i,n,o,a){super(),this.request=i,this.onDidFilesChange=n,this.onLogMessage=o,this.verboseLogging=a,this.throttledFileChangesEmitter=this._register(new N.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.onDidFilesChange(t))),this.fileChangesAggregator=this._register(new N.RunOnceWorker(t=>this.handleFileChanges(t),l.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new m.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const i=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const n=await w.Promises.stat(i);this._register(await this.doWatch(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.error(i):this.trace(i)}}async normalizePath(i){let n=i.path;try{n=await w.Promises.realpath(i.path),i.path===n&&(n=await(0,g.realcase)(i.path)??i.path),i.path!==n&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async doWatch(i,n){if(S.isMacintosh&&(0,k.isEqualOrParent)(i,"/Volumes/",!0))return this.error(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const o=new m.CancellationTokenSource(this.cts.token),a=new R.DisposableStore;try{const t=I.URI.file(this.request.path),r=(0,p.basename)(i),h=(0,D.watch)(i);a.add((0,R.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.trace(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const d of await w.Promises.readdir(i))u.add(d)}catch(d){this.error(d)}const c=new Map;a.add((0,R.toDisposable)(()=>{for(const[,d]of c)d.dispose();c.clear()})),h.on("error",(d,y)=>{this.error(`Failed to watch ${i} for changes using fs.watch() (${d}, ${y})`),this.dispose()}),h.on("change",(d,y)=>{if(o.token.isCancellationRequested)return;this.trace(`[raw] ["${d}"] ${y}`);let A="";if(y&&(A=y.toString(),S.isMacintosh&&(A=(0,v.normalizeNFC)(A))),!(!A||d!=="change"&&d!=="rename"))if(n)if(d==="rename"){c.get(A)?.dispose();const E=setTimeout(async()=>{if(c.delete(A),A===r&&!await w.Promises.exists(i)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.existsChildStrictCase((0,p.join)(i,A));if(o.token.isCancellationRequested)return;let _;b?u.has(A)?_=0:(_=1,u.add(A)):(u.delete(A),_=2),this.onFileChange({resource:(0,L.joinPath)(t,A),type:_,cId:this.request.correlationId})},l.FILE_DELETE_HANDLER_DELAY);c.set(A,(0,R.toDisposable)(()=>clearTimeout(E)))}else{let E;u.has(A)?E=0:(E=1,u.add(A)),this.onFileChange({resource:(0,L.joinPath)(t,A),type:E,cId:this.request.correlationId})}else if(d==="rename"||A!==r){const E=setTimeout(async()=>{const b=await w.Promises.exists(i);o.token.isCancellationRequested||(b?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),a.add(await this.doWatch(i,!1))):(this.onFileChange({resource:t,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.dispose()))},l.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,R.toDisposable)(()=>clearTimeout(E)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){await w.Promises.exists(i)&&!o.token.isCancellationRequested&&this.error(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.toDisposable)(()=>{o.dispose(!0),a.dispose()})}onFileChange(i,n=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.excludes.some(o=>o(i.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.includes&&this.includes.length>0&&!this.includes.some(o=>o(i.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${i.resource.fsPath}`):this.fileChangesAggregator.work(i))}handleFileChanges(i){const n=(0,C.coalesceEvents)(i);if(n.length>0){if(this.verboseLogging)for(const a of n)this.trace(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.throttledFileChangesEmitter.work(n)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(i){if(S.isLinux)return w.Promises.exists(i);try{const n=(0,p.basename)(i);return(await w.Promises.readdir((0,p.dirname)(i))).some(a=>a===n)}catch(n){return this.trace(n),!1}}setVerboseLogging(i){this.verboseLogging=i}error(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}warn(i){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}trace(i){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=l;async function f(s,i,n,o,a=512){const t=await w.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),h=new m.CancellationTokenSource(o);let u,c=!1;const d={path:s,excludes:[],recursive:!1},y=new l(d,A=>{(async()=>{for(const{type:E}of A)if(E===0){if(c)return;c=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:b}=await w.Promises.read(t,r,0,a,null);if(!b||h.token.isCancellationRequested)break;i(r.slice(0,b))}}catch(b){u=new Error(b),h.dispose(!0)}finally{c=!1}}})()});return await y.ready,n(),new Promise((A,E)=>{h.token.onCancellationRequested(async()=>{y.dispose();try{await w.Promises.close(t)}catch(b){u=new Error(b)}u?E(u):A()})})}e.watchFileContents=f}),define(ye[245],Ce([1,0,4,34,3,11,244]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class v extends m.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const L=this.normalizeRequests(S),I=L.filter(w=>{const C=this.watchers.get(w.path);return C?!(0,N.patternsEquals)(C.request.excludes,w.excludes)||!(0,N.patternsEquals)(C.request.includes,w.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:w})=>!L.find(C=>C.path===w.path&&(0,N.patternsEquals)(C.excludes,w.excludes)&&(0,N.patternsEquals)(C.includes,w.includes))).map(({request:w})=>w.path);I.length&&this.trace(`Request to start watching: ${I.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const w of g)this.stopWatching(w);for(const w of I)this.startWatching(w)}startWatching(S){const L=new R.NodeJSFileWatcherLibrary(S,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),I={request:S,instance:L};this.watchers.set(S.path,I)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const L=this.watchers.get(S);L&&(this.watchers.delete(S),L.instance.dispose())}normalizeRequests(S){const L=new Map;for(const I of S){const g=k.isLinux?I.path:I.path.toLowerCase();let w=L.get(I.correlationId);w||(w=new Map,L.set(I.correlationId,w)),w.set(g,I)}return Array.from(L.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(S){this.verboseLogging=S;for(const[,L]of this.watchers)L.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,L){return L?`[File Watcher (node.js)] ${S} (path: ${L.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=v}),define(ye[246],Ce([1,0,84,245]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class m extends D.AbstractNonRecursiveWatcherClient{constructor(R,v,p){super(R,v,p),this.init()}createWatcher(R){return R.add(new N.NodeJSWatcher)}}e.NodeJSWatcherClient=m}),define(ye[247],Ce([1,0,17,81,187,84]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends k.AbstractUniversalWatcherClient{constructor(p,S,L){super(p,S,L),this.init()}createWatcher(p){const S=p.add(new m.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(S.onDidProcessExit(({code:L,signal:I})=>this.onError(`terminated by itself with code ${L}, signal: ${I}`))),N.ProxyChannel.toService((0,N.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ye[107],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...m){this._entries=new Map;for(const[k,R]of m)this.set(k,R)}set(m,k){const R=this._entries.get(m);return this._entries.set(m,k),R}has(m){return this._entries.has(m)}get(m){return this._entries.get(m)}}e.ServiceCollection=D}),define(ye[248],Ce([1,0,12,8,3,105,239,5,107,75]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class I extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class g{constructor(f=new p.ServiceCollection,s=!1,i,n=L){this._services=f,this._strict=s,this._parent=i,this._enableTracing=n,this._activeInstantiations=new Set,this._services.set(v.IInstantiationService,this),this._globalGraph=n?i?._globalGraph??new R.Graph(o=>o):void 0}createChild(f){return new g(f,this._strict,this,this._enableTracing)}invokeFunction(f,...s){const i=C.traceInvocation(this._enableTracing,f);let n=!1;try{return f({get:a=>{if(n)throw(0,N.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(f,...s){let i,n;return f instanceof k.SyncDescriptor?(i=C.traceCreation(this._enableTracing,f.ctor),n=this._createInstance(f.ctor,f.staticArguments.concat(s),i)):(i=C.traceCreation(this._enableTracing,f),n=this._createInstance(f,s,i)),i.stop(),n}_createInstance(f,s=[],i){const n=v._util.getServiceDependencies(f).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this._getOrCreateServiceInstance(t.id,i);r||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${f.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(f,s.concat(o))}_setServiceInstance(f,s){if(this._services.get(f)instanceof k.SyncDescriptor)this._services.set(f,s);else if(this._parent)this._parent._setServiceInstance(f,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const s=this._services.get(f);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):s}_getOrCreateServiceInstance(f,s){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const i=this._getServiceInstanceOrDescriptor(f);return i instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,i,s.branch(f,!0)):(s.branch(f,!1),i)}_safeCreateAndCacheServiceInstance(f,s,i){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,s,i)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,s,i){const n=new R.Graph(t=>t.id.toString());let o=0;const a=[{id:f,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new I(n);for(const r of v._util.getServiceDependencies(t.desc.ctor)){const h=this._getServiceInstanceOrDescriptor(r.id);if(h||this._throwIfStrict(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),h instanceof k.SyncDescriptor){const u={id:r.id,desc:h,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new I(n);break}for(const{data:r}of t){if(this._getServiceInstanceOrDescriptor(r.id)instanceof k.SyncDescriptor){const u=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,u)}n.removeNode(r)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,s,i=[],n,o){if(this._services.get(f)instanceof k.SyncDescriptor)return this._createServiceInstance(f,s,i,n,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(f,s,i=[],n,o){if(n){const a=new g(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(f);const t=new Map,r=new D.GlobalIdleValue(()=>{const h=a._createInstance(s,i,o);for(const[u,c]of t){const d=h[u];if(typeof d=="function")for(const y of c)d.apply(h,y)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let y=t.get(u);return y||(y=new S.LinkedList,t.set(u,y)),(E,b,_)=>{const T=y.push([E,b,_]);return(0,m.toDisposable)(T)}}if(u in h)return h[u];const c=r.value;let d=c[u];return typeof d!="function"||(d=d.bind(c),h[u]=d),d},set(h,u,c){return r.value[u]=c,!0},getPrototypeOf(h){return s.prototype}})}else return this._createInstance(s,i,o)}_throwIfStrict(f,s){if(s&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=g;var w;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(w||(w={}));class C{static{this.all=new Set}static{this._None=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,s){return f?new C(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C._None}static traceCreation(f,s){return f?new C(1,s.name):C._None}static{this._totals=0}constructor(f,s){this.type=f,this.name=s,this._start=Date.now(),this._dep=[]}branch(f,s){const i=new C(3,f.toString());return this._dep.push([f,s,i]),i}stop(){const f=Date.now()-this._start;C._totals+=f;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[h,u,c]of a._dep)if(u&&c){s=!0,t.push(`${r}CREATES -> ${h}`);const d=i(o+1,c);d&&t.push(d)}else t.push(`${r}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(f>2||s)&&C.all.add(n.join(`
`))}}e.Trace=C}),define(ye[14],Ce([1,0,44,4,53,3,28,11,23,18,2,46,5]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function w(){return new Date().toISOString()}function C(E){return(0,S.isNumber)(E)}e.isLogLevel=C;var l;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(l||(e.LogLevel=l={})),e.DEFAULT_LOG_LEVEL=l.Info;function f(E,b,_){switch(b){case l.Trace:E.trace(_);break;case l.Debug:E.debug(_);break;case l.Info:E.info(_);break;case l.Warning:E.warn(_);break;case l.Error:E.error(_);break;case l.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=f;function s(E,b=!1){let _="";for(let T=0;T<E.length;T++){let U=E[T];if(U instanceof Error&&(U=(0,D.toErrorMessage)(U,b)),typeof U=="object")try{U=JSON.stringify(U)}catch{}_+=(T>0?" ":"")+U}return _}class i extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new N.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(b){this.level!==b&&(this.level=b,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(b){return this.level!==l.Off&&this.level<=b}}e.AbstractLogger=i;class n extends i{constructor(b){super(),this.logAlways=b}checkLogLevel(b){return this.logAlways||super.checkLogLevel(b)}trace(b,..._){this.checkLogLevel(l.Trace)&&this.log(l.Trace,s([b,..._],!0))}debug(b,..._){this.checkLogLevel(l.Debug)&&this.log(l.Debug,s([b,..._]))}info(b,..._){this.checkLogLevel(l.Info)&&this.log(l.Info,s([b,..._]))}warn(b,..._){this.checkLogLevel(l.Warning)&&this.log(l.Warning,s([b,..._]))}error(b,..._){if(this.checkLogLevel(l.Error))if(b instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=b.stack,this.log(l.Error,s(T))}else this.log(l.Error,s([b,..._]))}flush(){}}e.AbstractMessageLogger=n;class o extends i{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.useColors=!v.isWindows}trace(b,..._){this.checkLogLevel(l.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,..._):console.log(`[main ${w()}]`,b,..._))}debug(b,..._){this.checkLogLevel(l.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,..._):console.log(`[main ${w()}]`,b,..._))}info(b,..._){this.checkLogLevel(l.Info)&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,..._):console.log(`[main ${w()}]`,b,..._))}warn(b,..._){this.checkLogLevel(l.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,b,..._):console.warn(`[main ${w()}]`,b,..._))}error(b,..._){this.checkLogLevel(l.Error)&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,b,..._):console.error(`[main ${w()}]`,b,..._))}dispose(){}flush(){}}e.ConsoleMainLogger=o;class a extends i{constructor(b=e.DEFAULT_LOG_LEVEL,_=!0){super(),this.useColors=_,this.setLevel(b)}trace(b,..._){this.checkLogLevel(l.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",b,..._):console.log(b,..._))}debug(b,..._){this.checkLogLevel(l.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",b,..._):console.log(b,..._))}info(b,..._){this.checkLogLevel(l.Info)&&(this.useColors?console.log("%c INFO","color: #33f",b,..._):console.log(b,..._))}warn(b,..._){this.checkLogLevel(l.Warning)&&(this.useColors?console.log("%c WARN","color: #993",b,..._):console.log(b,..._))}error(b,..._){this.checkLogLevel(l.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",b,..._):console.error(b,..._))}dispose(){}flush(){}}e.ConsoleLogger=a;class t extends i{constructor(b,_=e.DEFAULT_LOG_LEVEL){super(),this.adapter=b,this.setLevel(_)}trace(b,..._){this.checkLogLevel(l.Trace)&&this.adapter.log(l.Trace,[this.extractMessage(b),..._])}debug(b,..._){this.checkLogLevel(l.Debug)&&this.adapter.log(l.Debug,[this.extractMessage(b),..._])}info(b,..._){this.checkLogLevel(l.Info)&&this.adapter.log(l.Info,[this.extractMessage(b),..._])}warn(b,..._){this.checkLogLevel(l.Warning)&&this.adapter.log(l.Warning,[this.extractMessage(b),..._])}error(b,..._){this.checkLogLevel(l.Error)&&this.adapter.log(l.Error,[this.extractMessage(b),..._])}extractMessage(b){return typeof b=="string"?b:(0,D.toErrorMessage)(b,this.checkLogLevel(l.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class r extends i{constructor(b){super(),this.loggers=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const _ of this.loggers)_.setLevel(b);super.setLevel(b)}trace(b,..._){for(const T of this.loggers)T.trace(b,..._)}debug(b,..._){for(const T of this.loggers)T.debug(b,..._)}info(b,..._){for(const T of this.loggers)T.info(b,..._)}warn(b,..._){for(const T of this.loggers)T.warn(b,..._)}error(b,..._){for(const T of this.loggers)T.error(b,..._)}flush(){for(const b of this.loggers)b.flush()}dispose(){for(const b of this.loggers)b.dispose()}}e.MultiplexLogger=r;class h extends k.Disposable{constructor(b,_,T){if(super(),this.logLevel=b,this.logsHome=_,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new N.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new N.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new N.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,T)for(const U of T)this._loggers.set(U.resource,{logger:void 0,info:U})}getLoggerEntry(b){return(0,S.isString)(b)?[...this._loggers.values()].find(_=>_.info.id===b):this._loggers.get(b)}getLogger(b){return this.getLoggerEntry(b)?.logger}createLogger(b,_){const T=this.toResource(b),U=(0,S.isString)(b)?b:_?.id??(0,m.hash)(T.toString()).toString(16);let M=this._loggers.get(T)?.logger;const P=_?.logLevel==="always"?l.Trace:_?.logLevel;M||(M=this.doCreateLogger(T,P??this.getLogLevel(T)??this.logLevel,{..._,id:U}));const x={logger:M,info:{resource:T,id:U,logLevel:P,name:_?.name,hidden:_?.hidden,extensionId:_?.extensionId,when:_?.when}};return this.registerLogger(x.info),this._loggers.set(T,x),M}toResource(b){return(0,S.isString)(b)?(0,p.joinPath)(this.logsHome,`${b}.log`):b}setLogLevel(b,_){if(L.URI.isUri(b)){const T=b,U=_,M=this._loggers.get(T);M&&U!==M.info.logLevel&&(M.info.logLevel=U===this.logLevel?void 0:U,M.logger?.setLevel(U),this._loggers.set(M.info.resource,M),this._onDidChangeLogLevel.fire([T,U]))}else{this.logLevel=b;for(const[T,U]of this._loggers.entries())this._loggers.get(T)?.info.logLevel===void 0&&U.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(b,_){const T=this.getLoggerEntry(b);T&&_!==!T.info.hidden&&(T.info.hidden=!_,this._loggers.set(T.info.resource,T),this._onDidChangeVisibility.fire([T.info.resource,_]))}getLogLevel(b){let _;return b&&(_=this._loggers.get(b)?.info.logLevel),_??this.logLevel}registerLogger(b){const _=this._loggers.get(b.resource);_?_.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this._loggers.set(b.resource,{info:b,logger:void 0}),this._onDidChangeLoggers.fire({added:[b],removed:[]}))}deregisterLogger(b){const _=this._loggers.get(b);_&&(_.logger&&_.logger.dispose(),this._loggers.delete(b),this._onDidChangeLoggers.fire({added:[],removed:[_.info]}))}*getRegisteredLoggers(){for(const b of this._loggers.values())yield b.info}getRegisteredLogger(b){return this._loggers.get(b)?.info}dispose(){this._loggers.forEach(b=>b.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=h;class u{constructor(){this.onDidChangeLogLevel=new N.Emitter().event}setLevel(b){}getLevel(){return l.Info}trace(b,..._){}debug(b,..._){}info(b,..._){}warn(b,..._){}error(b,..._){}critical(b,..._){}dispose(){}flush(){}}e.NullLogger=u;class c extends u{}e.NullLogService=c;function d(E){if(E.verbose)return l.Trace;if(typeof E.logLevel=="string"){const b=A(E.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function y(E){switch(E){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.LogLevelToString=y;function A(E){switch(E){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.parseLogLevel=A,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",y(l.Info))}),define(ye[249],Ce([1,0,19,12,8,4,3,16,84,14]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class L extends R.Disposable{constructor(g,w){super(),this.logService=g,this.options=w,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new N.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new N.ThrottledDelayer(0))}watch(g,w){return w.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,w):this.watchNonRecursive(g,w)}watchUniversal(g,w){const C={path:this.toFilePath(g),excludes:w.excludes,includes:w.includes,recursive:w.recursive,correlationId:w.correlationId},l=(0,D.insert)(this.universalPathsToWatch,C);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{l(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,m.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(w=>this._onDidChangeFile.fire((0,p.reviveFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const w of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const w of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(w)&&g.includes(w.path)&&(w.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,w){const C={path:this.toFilePath(g),excludes:w.excludes,includes:w.includes,recursive:!1,correlationId:w.correlationId},l=(0,D.insert)(this.nonRecursivePathsToWatch,C);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{l(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,m.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,p.reviveFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,v.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=L}),define(ye[250],Ce([1,0,55,387,12,28,22,4,33,3,16,11,23,98,31,205,32,243,249,44,247,246]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.toErrorMessage)(r)}`)}})();class t extends i.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(h,u){super(h,u),this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new k.ResourceMap(c=>g.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:u,symbolicLink:c}=await C.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(u,c),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:f.FilePermission.Locked}}catch(u){throw this.toFileSystemProviderError(u)}}async statIgnoreError(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const u=await C.Promises.readdir(this.toFilePath(h),{withFileTypes:!0}),c=[];return await Promise.all(u.map(async d=>{try{let y;d.isSymbolicLink()?y=(await this.stat((0,g.joinPath)(h,d.name))).type:y=this.toType(d),c.push([d.name,y])}catch(y){this.logService.trace(y)}})),c}catch(u){throw this.toFileSystemProviderError(u)}}toType(h,u){let c;return u?.dangling?c=f.FileType.Unknown:h.isFile()?c=f.FileType.File:h.isDirectory()?c=f.FileType.Directory:c=f.FileType.Unknown,u&&(c|=f.FileType.SymbolicLink),c}async createResourceLock(h){const u=this.toFilePath(h);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let c;for(;c=this.resourceLocks.get(h);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await c.wait();const d=new m.Barrier;return this.resourceLocks.set(h,d),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.resourceLocks.get(h)===d&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.resourceLocks.delete(h)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),d.open()})}async readFile(h,u){let c;try{u?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(h)})`),c=await this.createResourceLock(h));const d=this.toFilePath(h);return await C.Promises.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}finally{c?.dispose()}}traceLock(h){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(h)}readFileStream(h,u,c){const d=(0,w.newWriteableStream)(y=>R.VSBuffer.concat(y.map(A=>R.VSBuffer.wrap(A))).buffer);return(0,s.readFileIntoStream)(this,h,d,y=>y.buffer,{...u,bufferSize:256*1024},c),d}async writeFile(h,u,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.canWriteFileAtomic(h)?this.doWriteFileAtomic(h,(0,g.joinPath)((0,g.dirname)(h),`${(0,g.basename)(h)}${c.atomic.postfix}`),u,c):this.doWriteFile(h,u,c)}async canWriteFileAtomic(h){try{const u=this.toFilePath(h),{symbolicLink:c}=await C.SymlinkSupport.stat(u);if(c)return!1}catch{}return!0}async doWriteFileAtomic(h,u,c,d){const y=new S.DisposableStore;try{y.add(await this.createResourceLock(h)),y.add(await this.createResourceLock(u)),await this.doWriteFile(u,c,d,!0);try{await this.rename(u,h,{overwrite:!0})}catch(A){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{y.dispose()}}async doWriteFile(h,u,c,d){let y;try{const A=this.toFilePath(h);if(!c.create||!c.overwrite){if(await C.Promises.exists(A)){if(!c.overwrite)throw(0,f.createFileSystemProviderError)((0,l.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,f.createFileSystemProviderError)((0,l.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(h,{create:!0,unlock:c.unlock},d),await this.write(y,0,u,0,u.byteLength)}catch(A){throw await this.toFileSystemProviderWriteError(h,A)}finally{typeof y=="number"&&await this.close(y)}}static{this.canFlush=!0}static configureFlushOnWrite(h){t.canFlush=h}async open(h,u,c){const d=this.toFilePath(h);let y;(0,f.isFileOpenForWriteOptions)(u)&&!c&&(y=await this.createResourceLock(h));let A;try{if((0,f.isFileOpenForWriteOptions)(u)&&u.unlock)try{const{stat:b}=await C.SymlinkSupport.stat(d);b.mode&128||await C.Promises.chmod(d,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}let E;if((0,f.isFileOpenForWriteOptions)(u)){if(I.isWindows)try{await C.Promises.truncate(d,0),E="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}E||(E="w")}else E="r";A=await C.Promises.open(d,E)}catch(E){throw y?.dispose(),(0,f.isFileOpenForWriteOptions)(u)?await this.toFileSystemProviderWriteError(h,E):this.toFileSystemProviderError(E)}if(this.mapHandleToPos.set(A,0),(0,f.isFileOpenForWriteOptions)(u)&&this.writeHandles.set(A,h),y){const E=this.mapHandleToLock.get(A);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${d})`),this.mapHandleToLock.set(A,y),E&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${d})`),E.dispose())}return A}async close(h){const u=this.mapHandleToLock.get(h);try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&t.canFlush)try{await C.Promises.fdatasync(h)}catch(c){t.configureFlushOnWrite(!1),this.logService.error(c)}return await C.Promises.close(h)}catch(c){throw this.toFileSystemProviderError(c)}finally{u&&(this.mapHandleToLock.get(h)===u&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.mapHandleToLock.delete(h)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),u.dispose())}}async read(h,u,c,d,y){const A=this.normalizePos(h,u);let E=null;try{E=(await C.Promises.read(h,c,d,y,A)).bytesRead}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(h,A,E)}return E}normalizePos(h,u){return u===this.mapHandleToPos.get(h)?null:u}updatePos(h,u,c){const d=this.mapHandleToPos.get(h);typeof d=="number"&&(typeof u=="number"||(typeof c=="number"?this.mapHandleToPos.set(h,d+c):this.mapHandleToPos.delete(h)))}async write(h,u,c,d,y){return(0,m.retry)(()=>this.doWrite(h,u,c,d,y),100,3)}async doWrite(h,u,c,d,y){const A=this.normalizePos(h,u);let E=null;try{E=(await C.Promises.write(h,c,d,y,A)).bytesWritten}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),b)}finally{this.updatePos(h,A,E)}return E}async mkdir(h){try{await C.Promises.mkdir(this.toFilePath(h))}catch(u){throw this.toFileSystemProviderError(u)}}async delete(h,u){try{const c=this.toFilePath(h);if(u.recursive){let d;u?.atomic!==!1&&u.atomic.postfix&&(d=(0,L.join)((0,L.dirname)(c),`${(0,L.basename)(c)}${u.atomic.postfix}`)),await C.Promises.rm(c,C.RimRafMode.MOVE,d)}else try{await C.Promises.unlink(c)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let y=!1;try{const{stat:A,symbolicLink:E}=await C.SymlinkSupport.stat(c);y=A.isDirectory()&&!E}catch{}if(y)await C.Promises.rmdir(c);else throw d}else throw d}}catch(c){throw this.toFileSystemProviderError(c)}}async rename(h,u,c){const d=this.toFilePath(h),y=this.toFilePath(u);if(d!==y)try{await this.validateMoveCopy(h,u,"move",c.overwrite),await C.Promises.rename(d,y)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(2,null,(0,L.basename)(d),(0,L.basename)((0,L.dirname)(y)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(h,u,c){const d=this.toFilePath(h),y=this.toFilePath(u);if(d!==y)try{await this.validateMoveCopy(h,u,"copy",c.overwrite),await C.Promises.copy(d,y,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(3,null,(0,L.basename)(d),(0,L.basename)((0,L.dirname)(y)),A.toString()))),this.toFileSystemProviderError(A)}}async validateMoveCopy(h,u,c,d){const y=this.toFilePath(h),A=this.toFilePath(u);let E=!1;if(!!(this.capabilities&1024)||(E=(0,p.isEqual)(y,A,!0)),E){if(c==="copy")throw(0,f.createFileSystemProviderError)((0,l.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const _=await this.statIgnoreError(h);if(!_)throw(0,f.createFileSystemProviderError)((0,l.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const T=await this.statIgnoreError(u);if(T){if(!d)throw(0,f.createFileSystemProviderError)((0,l.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);_.type&f.FileType.File&&T.type&f.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,u){return this.doCloneFile(h,u,!1)}async doCloneFile(h,u,c){const d=this.toFilePath(h),y=this.toFilePath(u),A=!!(this.capabilities&1024);if((0,p.isEqual)(d,y,!A))return;const E=new S.DisposableStore;try{E.add(await this.createResourceLock(h)),E.add(await this.createResourceLock(u)),c&&await C.Promises.mkdir((0,L.dirname)(y),{recursive:!0}),await C.Promises.copyFile(d,y)}catch(b){if(b.code==="ENOENT"&&!c)return this.doCloneFile(h,u,!0);throw this.toFileSystemProviderError(b)}finally{E.dispose()}}createUniversalWatcher(h,u,c){return new o.UniversalWatcherClient(d=>h(d),d=>u(d),c)}createNonRecursiveWatcher(h,u,c){return new a.NodeJSWatcherClient(d=>h(d),d=>u(d),c)}toFileSystemProviderError(h){if(h instanceof f.FileSystemProviderError)return h;let u=h,c;switch(h.code){case"ENOENT":c=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=f.FileSystemProviderErrorCode.Unknown;break;default:c=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(u,c)}async toFileSystemProviderWriteError(h,u){let c=this.toFileSystemProviderError(u);if(h&&c.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await C.SymlinkSupport.stat(this.toFilePath(h));d.mode&128||(c=(0,f.createFileSystemProviderError)(u,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return c}}e.DiskFileSystemProvider=t}),define(ye[251],Ce([1,0,3,14]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class m extends D.Disposable{constructor(R,v=[]){super(),this.logger=new N.MultiplexLogger([R,...v]),this._register(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...v){this.logger.trace(R,...v)}debug(R,...v){this.logger.debug(R,...v)}info(R,...v){this.logger.info(R,...v)}warn(R,...v){this.logger.warn(R,...v)}error(R,...v){this.logger.error(R,...v)}flush(){this.logger.flush()}}e.LogService=m}),define(ye[252],Ce([1,0,32,14]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var m;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(m||(m={}));async function k(S,L,I,g,w){try{const C=await new Promise((f,s)=>{ge(["@vscode/spdlog"],f,s)});C.setFlushOn(m.Trace);const l=await C.createAsyncRotatingLogger(S,L,I,g);return w?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(C){console.error(C)}return null}function R(S,L,I){switch(L){case N.LogLevel.Trace:S.trace(I);break;case N.LogLevel.Debug:S.debug(I);break;case N.LogLevel.Info:S.info(I);break;case N.LogLevel.Warning:S.warn(I);break;case N.LogLevel.Error:S.error(I);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function v(S,L){switch(L){case N.LogLevel.Trace:S.setLevel(m.Trace);break;case N.LogLevel.Debug:S.setLevel(m.Debug);break;case N.LogLevel.Info:S.setLevel(m.Info);break;case N.LogLevel.Warning:S.setLevel(m.Warning);break;case N.LogLevel.Error:S.setLevel(m.Error);break;case N.LogLevel.Off:S.setLevel(m.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class p extends N.AbstractMessageLogger{constructor(L,I,g,w,C){super(),this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(L,I,g,w),this._register(this.onDidChangeLogLevel(l=>{this._logger&&v(this._logger,l)}))}async _createSpdLogLogger(L,I,g,w){const C=g?6:1,l=30/C*D.ByteSize.MB,f=await k(L,I,l,C,w);if(f){this._logger=f,v(this._logger,this.getLevel());for(const{level:s,message:i}of this.buffer)R(this._logger,s,i);this.buffer=[]}}log(L,I){this._logger?R(this._logger,L,I):this.getLevel()<=L&&this.buffer.push({level:L,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=p}),define(ye[135],Ce([1,0,39,206,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(k||(e.MarkerTag=k={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function S(C,l){return l-C}p.compare=S;const L=Object.create(null);L[p.Error]=(0,N.localize)(0,null),L[p.Warning]=(0,N.localize)(1,null),L[p.Info]=(0,N.localize)(2,null);function I(C){return L[C]||""}p.toString=I;function g(C){switch(C){case D.default.Error:return p.Error;case D.default.Warning:return p.Warning;case D.default.Info:return p.Info;case D.default.Ignore:return p.Hint}}p.fromSeverity=g;function w(C){switch(C){case p.Error:return D.default.Error;case p.Warning:return D.default.Warning;case p.Info:return D.default.Info;case p.Hint:return D.default.Ignore}}p.toSeverity=w}(R||(e.MarkerSeverity=R={}));var v;(function(p){const S="";function L(g){return I(g,!0)}p.makeKey=L;function I(g,w){const C=[S];return g.source?C.push(g.source.replace("\xA6","\\\xA6")):C.push(S),g.code?typeof g.code=="string"?C.push(g.code.replace("\xA6","\\\xA6")):C.push(g.code.value.replace("\xA6","\\\xA6")):C.push(S),g.severity!==void 0&&g.severity!==null?C.push(R.toString(g.severity)):C.push(S),g.message&&w?C.push(g.message.replace("\xA6","\\\xA6")):C.push(S),g.startLineNumber!==void 0&&g.startLineNumber!==null?C.push(g.startLineNumber.toString()):C.push(S),g.startColumn!==void 0&&g.startColumn!==null?C.push(g.startColumn.toString()):C.push(S),g.endLineNumber!==void 0&&g.endLineNumber!==null?C.push(g.endLineNumber.toString()):C.push(S),g.endColumn!==void 0&&g.endColumn!==null?C.push(g.endColumn.toString()):C.push(S),C.push(S),C.join("\xA6")}p.makeKeyOptionalMessage=I})(v||(e.IMarkerData=v={})),e.IMarkerService=(0,m.createDecorator)("markerService")}),define(ye[253],Ce([1,0,4,39,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=N.default,e.INotificationService=(0,m.createDecorator)("notificationService");var k;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(k||(e.NotificationPriority=k={}));var R;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var v;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(v||(e.NotificationsFilter=v={}));class p{constructor(){this.progress=new S,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.NoOpNotification=p;class S{infinite(){}done(){}total(I){}worked(I){}}e.NoOpProgress=S}),define(ye[254],Ce([1,0,50]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.context<"u"){const k=m.context.configuration();if(k)N=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){N=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:k,searchUrl:R,itemUrl:v,controlUrl:p}=N.extensionsGallery||{};Object.assign(N,{extensionsGallery:{serviceUrl:D.env.VSCODE_GALLERY_SERVICE_URL||k,searchUrl:D.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:D.env.VSCODE_GALLERY_ITEM_URL||v,controlUrl:D.env.VSCODE_GALLERY_CONTROL_URL||p}});try{const S=(...I)=>I.reduce((g,w)=>(Object.keys(w).forEach(C=>{Array.isArray(g[C])&&Array.isArray(w[C])?g[C]=w[C]:typeof g[C]=="object"&&typeof w[C]=="object"?g[C]=S(g[C],w[C]):g[C]=w[C]}),g),{}),L=globalThis._VSCODE_USER_PRODUCT_JSON||{};N=S(N,L)}catch{}if(D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const S=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:S.version,release:S.release})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ye[136],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ge,e){return function(D,N){e(D,N,ge)}};define(ye[85],Ce([1,0,12,21,3,5]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,k.createDecorator)("progressService");var R;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class v{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(g){this.callback=g}report(g){this._value=g,this.callback(this._value)}}e.Progress=v;class p{get value(){return this._value}constructor(g){this.callback=g}report(g){this._asyncQueue?this._asyncQueue.push(g):this._asyncQueue=[g],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const g=this._asyncQueue.shift();this._value=g,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const g=this._drainListener;this._drainListener=void 0,g?.()}}drain(){return this._processingAsyncQueue?new Promise(g=>{const w=this._drainListener;this._drainListener=()=>{w?.(),g()}}):Promise.resolve()}}e.AsyncProgress=p;let S=class extends m.Disposable{constructor(g,w){super(),this.deferred=new D.DeferredPromise,w.withProgress(g,C=>(this.reporter=C,this.lastStep&&C.report(this.lastStep),this.deferred.p)),this._register((0,m.toDisposable)(()=>this.deferred.complete()))}report(g){this.reporter?this.reporter.report(g):this.lastStep=g}};e.UnmanagedProgress=S,e.UnmanagedProgress=S=Ge([We(1,e.IProgressService)],S);class L extends m.Disposable{constructor(g){super(),this.progressIndicator=g,this.currentOperationId=0,this.currentOperationDisposables=this._register(new m.DisposableStore)}start(g){this.stop();const w=++this.currentOperationId,C=new N.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},g),this.currentOperationDisposables.add((0,m.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,m.toDisposable)(()=>C.cancel())),this.currentOperationDisposables.add((0,m.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:C.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(g){this.currentOperationId===g&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=L,e.IEditorProgressService=(0,k.createDecorator)("editorProgressService")}),define(ye[37],Ce([1,0,60,18]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class m{constructor(){this.data=new Map}add(R,v){D.ok(N.isString(R)),D.ok(N.isObject(v)),D.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,v)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new m}),define(ye[108],Ce([1,0,4,37]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function m(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,S){this.schemasById[m(p)]=S,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new k;N.Registry.add(e.Extensions.JSONContribution,R)}),define(ye[86],Ce([1,0,19,4,18,196,45,108,37]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=p.Registry.as(v.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new N.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new N.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const h=new Set;this.doRegisterConfigurations(t,r,h),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(t){const r=new Set;this.doDeregisterConfigurations(t,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const h=new Set;this.doDeregisterConfigurations(r,h),this.doRegisterConfigurations(t,!1,h),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}registerDefaultConfigurations(t){const r=new Set;this.doRegisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,r){const h=[];for(const{overrides:u,source:c}of t)for(const d in u)if(r.add(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const y=this.configurationDefaultsOverrides.get(d),A=y?.valuesSources??new Map;if(c)for(const T of Object.keys(u[d]))A.set(T,c);const E={...y?.value||{},...u[d]};this.configurationDefaultsOverrides.set(d,{source:c,value:E,valuesSources:A});const b=(0,R.getLanguageTagSettingPlainKey)(d),_={type:"object",default:E,description:k.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:m.isString(c)?void 0:c,defaultValueSource:c};h.push(...l(d)),this.configurationProperties[d]=_,this.defaultLanguageConfigurationOverridesNode.properties[d]=_}else{this.configurationDefaultsOverrides.set(d,{value:u[d],source:c});const y=this.configurationProperties[d];y&&(this.updatePropertyDefaultValue(d,y),this.updateSchema(d,y))}this.doRegisterOverrideIdentifiers(h)}deregisterDefaultConfigurations(t){const r=new Set;this.doDeregisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,r){for(const{overrides:h,source:u}of t)for(const c in h){const d=this.configurationDefaultsOverrides.get(c),y=m.isString(u)?u:u?.id,A=m.isString(d?.source)?d?.source:d?.source?.id;if(y===A)if(r.add(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const E=this.configurationProperties[c];E&&(this.updatePropertyDefaultValue(c,E),this.updateSchema(c,E))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let r=!1;const h=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,h),r=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,h),r=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,h),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r,h){t.forEach(u=>{this.validateAndRegisterProperties(u,r,u.extensionInfo,u.restrictedProperties,void 0,h),this.configurationContributors.push(u),this.registerJSONConfiguration(u)})}doDeregisterConfigurations(t,r){const h=u=>{if(u.properties)for(const c in u.properties){r.add(c);const d=this.configurationProperties[c];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,u.properties[c])}u.allOf?.forEach(c=>h(c))};for(const u of t){h(u);const c=this.configurationContributors.indexOf(u);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(t,r=!0,h,u,c=3,d){c=m.isUndefinedOrNull(t.scope)?c:t.scope;const y=t.properties;if(y)for(const E in y){const b=y[E];if(r&&n(E,b)){delete y[E];continue}if(b.source=h,b.defaultDefaultValue=y[E].default,this.updatePropertyDefaultValue(E,b),e.OVERRIDE_PROPERTY_REGEX.test(E)?b.scope=void 0:(b.scope=m.isUndefinedOrNull(b.scope)?c:b.scope,b.restricted=m.isUndefinedOrNull(b.restricted)?!!u?.includes(E):b.restricted),y[E].hasOwnProperty("included")&&!y[E].included){this.excludedConfigurationProperties[E]=y[E],delete y[E];continue}else this.configurationProperties[E]=y[E],y[E].policy?.name&&this.policyConfigurations.set(y[E].policy.name,E);!y[E].deprecationMessage&&y[E].markdownDeprecationMessage&&(y[E].deprecationMessage=y[E].markdownDeprecationMessage),d.add(E)}const A=t.allOf;if(A)for(const E of A)this.validateAndRegisterProperties(E,r,h,u,c,d)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=h=>{const u=h.properties;if(u)for(const d in u)this.updateSchema(d,u[d]);h.allOf?.forEach(r)};r(t)}updateSchema(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,h={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,h),e.allSettings.properties[r]=h,e.applicationSettings.properties[r]=h,e.machineSettings.properties[r]=h,e.machineOverridableSettings.properties[r]=h,e.windowSettings.properties[r]=h,e.resourceSettings.properties[r]=h}}registerOverridePropertyPatternKey(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const h=this.configurationDefaultsOverrides.get(t);let u=h?.value,c=h?.source;m.isUndefined(u)&&(u=r.defaultDefaultValue,c=void 0),m.isUndefined(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=c}}const w="\\[([^\\]]+)\\]",C=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let r=C.exec(a);for(;r?.length;){const h=r[1].trim();h&&t.push(h),r=C.exec(a)}}return(0,D.distinct)(t)}e.overrideIdentifiersFromKey=l;function f(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=f;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const i=new g;p.Registry.add(e.Extensions.Configuration,i);function n(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?k.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?k.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}e.validateProperty=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=o}),define(ye[255],Ce([1,0,19,4,159,3,28,24,18,2,45,86,37]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function w(r){return Object.isFrozen(r)?r:v.deepFreeze(r)}class C{constructor(h={},u=[],c=[],d){this._contents=h,this._keys=u,this._overrides=c,this.raw=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const h=this.raw.map(u=>{if(u instanceof C)return u;const c=new l("");return c.parseRaw(u),c.configurationModel});this._rawConfiguration=h.reduce((u,c)=>c===u?c:u.merge(c),h[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(h){return h?(0,L.getConfigurationValue)(this.contents,h):this.contents}inspect(h,u){const c=this.rawConfiguration.getValue(h),d=u?this.rawConfiguration.getOverrideValue(h,u):void 0,y=u?this.rawConfiguration.override(u).getValue(h):c;return{value:c,override:d,merged:y}}getOverrideValue(h,u){const c=this.getContentsForOverrideIdentifer(u);return c?h?(0,L.getConfigurationValue)(c,h):c:void 0}getKeysForOverrideIdentifier(h){const u=[];for(const c of this.overrides)c.identifiers.includes(h)&&u.push(...c.keys);return D.distinct(u)}getAllOverrideIdentifiers(){const h=[];for(const u of this.overrides)h.push(...u.identifiers);return D.distinct(h)}override(h){let u=this.overrideConfigurations.get(h);return u||(u=this.createOverrideConfigurationModel(h),this.overrideConfigurations.set(h,u)),u}merge(...h){const u=v.deepClone(this.contents),c=v.deepClone(this.overrides),d=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const A of h)if(y.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.mergeContents(u,A.contents);for(const E of A.overrides){const[b]=c.filter(_=>D.equals(_.identifiers,E.identifiers));b?(this.mergeContents(b.contents,E.contents),b.keys.push(...E.keys),b.keys=D.distinct(b.keys)):c.push(v.deepClone(E))}for(const E of A.keys)d.indexOf(E)===-1&&d.push(E)}return new C(u,d,c,y.every(A=>A instanceof C)?void 0:y)}createOverrideConfigurationModel(h){const u=this.getContentsForOverrideIdentifer(h);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const c={};for(const d of D.distinct([...Object.keys(this.contents),...Object.keys(u)])){let y=this.contents[d];const A=u[d];A&&(typeof y=="object"&&typeof A=="object"?(y=v.deepClone(y),this.mergeContents(y,A)):y=A),c[d]=y}return new C(c,this.keys,this.overrides)}mergeContents(h,u){for(const c of Object.keys(u)){if(c in h&&p.isObject(h[c])&&p.isObject(u[c])){this.mergeContents(h[c],u[c]);continue}h[c]=v.deepClone(u[c])}}getContentsForOverrideIdentifer(h){let u=null,c=null;const d=y=>{y&&(c?this.mergeContents(c,y):c=v.deepClone(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===h?u=y.contents:y.identifiers.includes(h)&&d(y.contents);return d(u),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,u){this.updateValue(h,u,!0)}setValue(h,u){this.updateValue(h,u,!1)}removeValue(h){const u=this.keys.indexOf(h);u!==-1&&(this.keys.splice(u,1),(0,L.removeFromValueTree)(this.contents,h),I.OVERRIDE_PROPERTY_REGEX.test(h)&&this.overrides.splice(this.overrides.findIndex(c=>D.equals(c.identifiers,(0,I.overrideIdentifiersFromKey)(h))),1))}updateValue(h,u,c){(0,L.addToValueTree)(this.contents,h,u,d=>console.error(d)),c=c||this.keys.indexOf(h)===-1,c&&this.keys.push(h),I.OVERRIDE_PROPERTY_REGEX.test(h)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(h),keys:Object.keys(this.contents[h]),contents:(0,L.toValuesTree)(this.contents[h],d=>console.error(d))})}}e.ConfigurationModel=C;class l{constructor(h){this._name=h,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(h,u){if(!p.isUndefinedOrNull(h)){const c=this.doParseContent(h);this.parseRaw(c,u)}}reparse(h){this._raw&&this.parseRaw(this._raw,h)}parseRaw(h,u){this._raw=h;const{contents:c,keys:d,overrides:y,restricted:A,hasExcludedProperties:E}=this.doParseRaw(h,u);this._configurationModel=new C(c,d,y,E?[h]:void 0),this._restrictedConfigurations=A||[]}doParseContent(h){let u={},c=null,d=[];const y=[],A=[];function E(_){Array.isArray(d)?d.push(_):c!==null&&(d[c]=_)}const b={onObjectBegin:()=>{const _={};E(_),y.push(d),d=_,c=null},onObjectProperty:_=>{c=_},onObjectEnd:()=>{d=y.pop()},onArrayBegin:()=>{const _=[];E(_),y.push(d),d=_,c=null},onArrayEnd:()=>{d=y.pop()},onLiteralValue:E,onError:(_,T,U)=>{A.push({error:_,offset:T,length:U})}};if(h)try{m.visit(h,b),u=d[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return u}doParseRaw(h,u){const c=g.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(h,c,!0,u);h=d.raw;const y=(0,L.toValuesTree)(h,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),A=Object.keys(h),E=this.toOverrides(h,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:y,keys:A,overrides:E,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}filter(h,u,c,d){let y=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:y};const A={},E=[];for(const b in h)if(I.OVERRIDE_PROPERTY_REGEX.test(b)&&c){const _=this.filter(h[b],u,!1,d);A[b]=_.raw,y=y||_.hasExcludedProperties,E.push(..._.restricted)}else{const _=u[b],T=_?typeof _.scope<"u"?_.scope:3:void 0;_?.restricted&&E.push(b),!d.exclude?.includes(b)&&(d.include?.includes(b)||(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&!(d.skipRestricted&&_?.restricted))?A[b]=h[b]:y=!0}return{raw:A,restricted:E,hasExcludedProperties:y}}toOverrides(h,u){const c=[];for(const d of Object.keys(h))if(I.OVERRIDE_PROPERTY_REGEX.test(d)){const y={};for(const A in h[d])y[A]=h[d][A];c.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(y),contents:(0,L.toValuesTree)(y,u)})}return c}}e.ConfigurationModelParser=l;class f extends k.Disposable{constructor(h,u,c,d){super(),this.userSettingsResource=h,this.parseOptions=u,this.fileService=d,this._onDidChange=this._register(new N.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(N.Event.any(N.Event.filter(this.fileService.onDidFilesChange,y=>y.contains(this.userSettingsResource)),N.Event.filter(this.fileService.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&c.isEqual(y.resource,h)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const h=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(h.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new C}}reparse(h){return h&&(this.parseOptions=h),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class s{constructor(h,u,c,d,y,A,E,b,_,T,U,M,P){this.key=h,this.overrides=u,this._value=c,this.overrideIdentifiers=d,this.defaultConfiguration=y,this.policyConfiguration=A,this.applicationConfiguration=E,this.userConfiguration=b,this.localUserConfiguration=_,this.remoteUserConfiguration=T,this.workspaceConfiguration=U,this.folderConfigurationModel=M,this.memoryConfigurationModel=P}get value(){return w(this._value)}inspect(h,u,c){const d=h.inspect(u,c);return{get value(){return w(d.value)},get override(){return w(d.override)},get merged(){return w(d.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class i{constructor(h,u,c,d,y=new C,A=new C,E=new R.ResourceMap,b=new C,_=new R.ResourceMap){this._defaultConfiguration=h,this._policyConfiguration=u,this._applicationConfiguration=c,this._localUserConfiguration=d,this._remoteUserConfiguration=y,this._workspaceConfiguration=A,this._folderConfigurations=E,this._memoryConfiguration=b,this._memoryConfigurationByResource=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(h,u,c){return this.getConsolidatedConfigurationModel(h,u,c).getValue(h)}updateValue(h,u,c={}){let d;c.resource?(d=this._memoryConfigurationByResource.get(c.resource),d||(d=new C,this._memoryConfigurationByResource.set(c.resource,d))):d=this._memoryConfiguration,u===void 0?d.removeValue(h):d.setValue(h,u),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(h,u,c){const d=this.getConsolidatedConfigurationModel(h,u,c),y=this.getFolderConfigurationModelForResource(u.resource,c),A=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,E=new Set;for(const b of d.overrides)for(const _ of b.identifiers)d.getOverrideValue(h,_)!==void 0&&E.add(_);return new s(h,u,d.getValue(h),E.size?[...E]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this._workspaceConfiguration:void 0,y||void 0,A)}keys(h){const u=this.getFolderConfigurationModelForResource(void 0,h);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(h){this._defaultConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(h){this._policyConfiguration=h}updateApplicationConfiguration(h){this._applicationConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(h){this._localUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(h){this._remoteUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(h){this._workspaceConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(h,u){this._folderConfigurations.set(h,u),this._foldersConsolidatedConfigurations.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this._foldersConsolidatedConfigurations.delete(h)}compareAndUpdateDefaultConfiguration(h,u){const c=[];if(!u){const{added:d,updated:y,removed:A}=a(this._defaultConfiguration,h);u=[...d,...y,...A]}for(const d of u)for(const y of(0,I.overrideIdentifiersFromKey)(d)){const A=this._defaultConfiguration.getKeysForOverrideIdentifier(y),E=h.getKeysForOverrideIdentifier(y),b=[...E.filter(_=>A.indexOf(_)===-1),...A.filter(_=>E.indexOf(_)===-1),...A.filter(_=>!v.equals(this._defaultConfiguration.override(y).getValue(_),h.override(y).getValue(_)))];c.push([y,b])}return this.updateDefaultConfiguration(h),{keys:u,overrides:c}}compareAndUpdatePolicyConfiguration(h){const{added:u,updated:c,removed:d}=a(this._policyConfiguration,h),y=[...u,...c,...d];return y.length&&this.updatePolicyConfiguration(h),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:u,updated:c,removed:d,overrides:y}=a(this.applicationConfiguration,h),A=[...u,...c,...d];return A.length&&this.updateApplicationConfiguration(h),{keys:A,overrides:y}}compareAndUpdateLocalUserConfiguration(h){const{added:u,updated:c,removed:d,overrides:y}=a(this.localUserConfiguration,h),A=[...u,...c,...d];return A.length&&this.updateLocalUserConfiguration(h),{keys:A,overrides:y}}compareAndUpdateRemoteUserConfiguration(h){const{added:u,updated:c,removed:d,overrides:y}=a(this.remoteUserConfiguration,h),A=[...u,...c,...d];return A.length&&this.updateRemoteUserConfiguration(h),{keys:A,overrides:y}}compareAndUpdateWorkspaceConfiguration(h){const{added:u,updated:c,removed:d,overrides:y}=a(this.workspaceConfiguration,h),A=[...u,...c,...d];return A.length&&this.updateWorkspaceConfiguration(h),{keys:A,overrides:y}}compareAndUpdateFolderConfiguration(h,u){const c=this.folderConfigurations.get(h),{added:d,updated:y,removed:A,overrides:E}=a(c,u),b=[...d,...y,...A];return(b.length||!c)&&this.updateFolderConfiguration(h,u),{keys:b,overrides:E}}compareAndDeleteFolderConfiguration(h){const u=this.folderConfigurations.get(h);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:c,updated:d,removed:y,overrides:A}=a(u,void 0);return{keys:[...c,...d,...y],overrides:A}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(h,u,c){let d=this.getConsolidatedConfigurationModelForResource(u,c);return u.overrideIdentifier&&(d=d.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(h)!==void 0&&(d=d.merge(this._policyConfiguration)),d}getConsolidatedConfigurationModelForResource({resource:h},u){let c=this.getWorkspaceConsolidatedConfiguration();if(u&&h){const d=u.getFolder(h);d&&(c=this.getFolderConsolidatedConfiguration(d.uri)||c);const y=this._memoryConfigurationByResource.get(h);y&&(c=c.merge(y))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(h){let u=this._foldersConsolidatedConfigurations.get(h);if(!u){const c=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(h);d?(u=c.merge(d),this._foldersConsolidatedConfigurations.set(h,u)):u=c}return u}getFolderConfigurationModelForResource(h,u){if(u&&h){const c=u.getFolder(h);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((h,u)=>{const{contents:c,overrides:d,keys:y}=this._folderConfigurations.get(u);return h.push([u,{contents:c,overrides:d,keys:y}]),h},[])}}allKeys(){const h=new Set;return this._defaultConfiguration.keys.forEach(u=>h.add(u)),this.userConfiguration.keys.forEach(u=>h.add(u)),this._workspaceConfiguration.keys.forEach(u=>h.add(u)),this._folderConfigurations.forEach(u=>u.keys.forEach(c=>h.add(c))),[...h.values()]}allOverrideIdentifiers(){const h=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this._folderConfigurations.forEach(u=>u.getAllOverrideIdentifiers().forEach(c=>h.add(c))),[...h.values()]}getAllKeysForOverrideIdentifier(h){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(h).forEach(d=>u.add(d))),[...u.values()]}static parse(h){const u=this.parseConfigurationModel(h.defaults),c=this.parseConfigurationModel(h.policy),d=this.parseConfigurationModel(h.application),y=this.parseConfigurationModel(h.user),A=this.parseConfigurationModel(h.workspace),E=h.folders.reduce((b,_)=>(b.set(S.URI.revive(_[0]),this.parseConfigurationModel(_[1])),b),new R.ResourceMap);return new i(u,c,d,y,new C,A,E,new C,new R.ResourceMap)}static parseConfigurationModel(h){return new C(h.contents,h.keys,h.overrides)}}e.Configuration=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const h=new Set,u=new Map;for(const d of r)d.keys.forEach(y=>h.add(y)),d.overrides.forEach(([y,A])=>{const E=(0,R.getOrSet)(u,y,new Set);A.forEach(b=>E.add(b))});const c=[];return u.forEach((d,y)=>c.push([y,[...d.values()]])),{keys:[...h.values()],overrides:c}}e.mergeChanges=n;class o{constructor(h,u,c,d){this.change=h,this.previous=u,this.currentConfiguraiton=c,this.currentWorkspace=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const y of h.keys)this.affectedKeys.add(y);for(const[,y]of h.overrides)for(const A of y)this.affectedKeys.add(A);this._affectsConfigStr=this._marker;for(const y of this.affectedKeys)this._affectsConfigStr+=y+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(h,u){const c=this._marker+h,d=this._affectsConfigStr.indexOf(c);if(d<0)return!1;const y=d+c.length;if(y>=this._affectsConfigStr.length)return!1;const A=this._affectsConfigStr.charCodeAt(y);if(A!==this._markerCode1&&A!==this._markerCode2)return!1;if(u){const E=this.previousConfiguration?this.previousConfiguration.getValue(h,u,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(h,u,this.currentWorkspace);return!v.equals(E,b)}return!0}}e.ConfigurationChangeEvent=o;function a(r,h){const{added:u,removed:c,updated:d}=t(h?.rawConfiguration,r?.rawConfiguration),y=[],A=r?.getAllOverrideIdentifiers()||[],E=h?.getAllOverrideIdentifiers()||[];if(h){const b=E.filter(_=>!A.includes(_));for(const _ of b)y.push([_,h.getKeysForOverrideIdentifier(_)])}if(r){const b=A.filter(_=>!E.includes(_));for(const _ of b)y.push([_,r.getKeysForOverrideIdentifier(_)])}if(h&&r){for(const b of A)if(E.includes(b)){const _=t({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:h.getOverrideValue(void 0,b)||{},keys:h.getKeysForOverrideIdentifier(b)});y.push([b,[..._.added,..._.removed,..._.updated]])}}return{added:u,removed:c,updated:d,overrides:y}}function t(r,h){const u=r?h?r.keys.filter(y=>h.keys.indexOf(y)===-1):[...r.keys]:[],c=h?r?h.keys.filter(y=>r.keys.indexOf(y)===-1):[...h.keys]:[],d=[];if(r&&h){for(const y of h.keys)if(r.keys.indexOf(y)!==-1){const A=(0,L.getConfigurationValue)(h.contents,y),E=(0,L.getConfigurationValue)(r.contents,y);v.equals(A,E)||d.push(y)}}return{added:u,removed:c,updated:d}}}),define(ye[256],Ce([1,0,22,4,3,82]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.connectManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0;const R=(S,L,I)=>{const g=new Uint8Array(16);for(let l=0;l<16;l++)g[l]=Math.round(Math.random()*256);const w=(0,D.encodeBase64)(D.VSBuffer.wrap(g));return[`GET ws://localhost${S}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${w}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=R,e.socketRawEndHeaderSequence=D.VSBuffer.fromString(`\r
\r
`);async function v(S,L,I,g,w){S.write(D.VSBuffer.fromString((0,e.makeRawSocketHeaders)(L,I,g)));const C=new m.DisposableStore;try{return await new Promise((l,f)=>{let s;C.add(S.onData(i=>{s?s=D.VSBuffer.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.socketRawEndHeaderSequence);if(n===-1)return;l(S),S.pauseData();const o=s.slice(n+e.socketRawEndHeaderSequence.byteLength);o.byteLength&&w.onData.fire(o)})),C.add(S.onClose(i=>f(i??new Error("socket closed")))),C.add(S.onEnd(()=>f(new Error("socket ended"))))})}catch(l){throw S.dispose(),l}finally{C.dispose()}}e.connectManagedSocket=v;class p extends m.Disposable{constructor(L,I){super(),this.debugLabel=L,this.pausableDataEmitter=this._register(new N.PauseableEmitter),this.onData=(...g)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...g)),this.didDisposeEmitter=this._register(new N.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(I.onData),this._register(I.onData.event(g=>this.pausableDataEmitter.fire(g))),this.onClose=this._register(I.onClose).event,this.onEnd=this._register(I.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(L,I){k.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,L,I)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=p}),define(ye[64],Ce([1,0,8,5]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,N.createDecorator)("remoteAuthorityResolverService");var m;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(m||(e.RemoteConnectionType=m={}));class k{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=k;class R{constructor(I,g){this.host=I,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var v;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(v||(e.RemoteAuthorityResolverErrorCode=v={}));class p extends D.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof p&&I._code===v.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof p&&I._code===v.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof p&&I._code===v.NoResolverFound}static isInvalidAuthority(I){return I instanceof p&&I._code===v.InvalidAuthority}static isHandled(I){return I instanceof p&&I.isHandled}constructor(I,g=v.Unknown,w){super(I),this._message=I,this._code=g,this._detail=w,this.isHandled=g===v.NotAvailable&&w===!0,Object.setPrototypeOf(this,p.prototype)}}e.RemoteAuthorityResolverError=p;function S(L){const I=L.indexOf("+");return I===-1?L:L.substring(0,I)}e.getRemoteAuthorityPrefix=S}),define(ye[65],Ce([1,0,17]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function N(S){return S.scheme===D.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=N;function m(S){if(!S)return;const L=S.indexOf("+");return L<0?S:S.substr(0,L)}e.getRemoteName=m;function k(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=k;function R(S){const{host:L,port:I}=p(S);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:I}}e.parseAuthorityWithPort=R;function v(S,L){let{host:I,port:g}=p(S);return typeof g>"u"&&(g=L),{host:I,port:g}}e.parseAuthorityWithOptionalPort=v;function p(S){const L=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=S.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const g=S.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:S,port:void 0}}}),define(ye[26],Ce([1,0,13,5,65]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R||(e.ExtensionType=R={}));var v;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.LINUX_PPC64LE="linux-ppc64le",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class p{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,s){if(typeof f>"u"||f===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof f=="string"||typeof s=="string"){const i=typeof f=="string"?f:f.value,n=typeof s=="string"?s:s.value;return D.equalsIgnoreCase(i,n)}return f._lower===s._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=p;class S{get size(){return this._set.size}constructor(f){if(this._set=new Set,f)for(const s of f)this.add(s)}add(f){this._set.add(p.toKey(f))}delete(f){return this._set.delete(p.toKey(f))}has(f){return this._set.has(p.toKey(f))}}e.ExtensionIdentifierSet=S;class L{constructor(){this._map=new Map}clear(){this._map.clear()}delete(f){this._map.delete(p.toKey(f))}get(f){return this._map.get(p.toKey(f))}has(f){return this._map.has(p.toKey(f))}set(f,s){this._map.set(p.toKey(f),s)}values(){return this._map.values()}forEach(f){this._map.forEach(f)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function I(l){return g(l)}e.isApplicationScopedExtension=I;function g(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function w(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function C(l,f){if(f){const s=`onResolveRemoteAuthority:${(0,m.getRemoteName)(f)}`;return!!l.activationEvents?.includes(s)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,N.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[137],Ce([1,0,8,26]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class m{constructor(){this._generators=new Map,this._cache=new WeakMap}register(R,v){this._generators.set(R,v)}readActivationEvents(R){return this._cache.has(R)||this._cache.set(R,this._readActivationEvents(R)),this._cache.get(R)}createActivationEventsMap(R){const v=Object.create(null);for(const p of R){const S=this.readActivationEvents(p);S.length>0&&(v[N.ExtensionIdentifier.toKey(p.identifier)]=S)}return v}_readActivationEvents(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const v=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<v.length;p++)v[p]==="onUri"&&(v[p]=`onUri:${N.ExtensionIdentifier.toKey(R.identifier)}`);if(!R.contributes)return v;for(const p in R.contributes){const S=this._generators.get(p);if(!S)continue;const L=R.contributes[p],I=Array.isArray(L)?L:[L];try{S(I,v)}catch(g){(0,D.onUnexpectedError)(g)}}return v}}e.ImplicitActivationEventsImpl=m,e.ImplicitActivationEvents=new m}),define(ye[257],Ce([1,0,12,22,21,8,4,3,56,38,30,82,64,65]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var l;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function f(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(j){const z=new m.CancellationTokenSource;return setTimeout(()=>z.cancel(),j),z.token}function i(j,z){if(j.isCancellationRequested||z.isCancellationRequested)return m.CancellationToken.Cancelled;const ne=new m.CancellationTokenSource;return j.onCancellationRequested(()=>ne.cancel()),z.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this._state==="timedout"}constructor(z){this._state="pending",this._disposables=new v.DisposableStore,this.promise=new Promise((ne,Se)=>{this._resolvePromise=ne,this._rejectPromise=Se}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function o(j,z){const ne=new n(z);return ne.registerDisposable(j.onControlMessage(Se=>{const de=JSON.parse(Se.toString()),me=X(de);me?ne.reject(me):ne.resolve(de)})),ne.promise}function a(j,z,ne,Se,de,me,Z,ie){const q=new n(ie),te=S.StopWatch.create(!1);return j.info(`Creating a socket (${Z})...`),p.mark(`code/willCreateSocket/${me}`),z.connect(ne,Se,de,Z).then(fe=>{q.didTimeout?(p.mark(`code/didCreateSocketError/${me}`),j.info(`Creating a socket (${Z}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(p.mark(`code/didCreateSocketOK/${me}`),j.info(`Creating a socket (${Z}) was successful after ${te.elapsed()} ms.`),q.resolve(fe))},fe=>{p.mark(`code/didCreateSocketError/${me}`),j.info(`Creating a socket (${Z}) returned an error after ${te.elapsed()} ms.`),j.error(fe),q.reject(fe)}),q.promise}function t(j,z){const ne=new n(z);return j.then(Se=>{ne.didTimeout||ne.resolve(Se)},Se=>{ne.didTimeout||ne.reject(Se)}),ne.promise}async function r(j,z,ne,Se){const de=we(j,z);j.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let me;try{me=await a(j.logService,j.remoteSocketFactoryService,j.connectTo,(0,w.getRemoteServerRootPath)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,f(z),`renderer-${f(z)}-${j.reconnectionToken}`,Se)}catch(fe){throw j.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),j.logService.error(fe),fe}j.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let Z,ie;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(me,null),Z=j.reconnectionProtocol,ie=!1):(Z=new I.PersistentProtocol({socket:me}),ie=!0),j.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const q=await t(j.signService.createNewMessage((0,L.generateUuid)()),Se),te={type:"auth",auth:j.connectionToken||"00000000000000000000",data:q.data};Z.sendControl(N.VSBuffer.fromString(JSON.stringify(te)));try{const fe=await o(Z,i(Se,s(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(j.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(j.signService.validate(q,fe.signedData),Se)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Te=await t(j.signService.sign(fe.data),Se),ve={type:"connectionType",commit:j.commit,signedData:Te,desiredConnectionType:z};return ne&&(ve.args=ne),j.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(N.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:ie}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(j.logService.error(`${de} the handshake timed out. Error:`),j.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${de} received error control message when negotiating connection. Error:`),j.logService.error(fe)),ie&&G(Z),fe}}async function h(j,z,ne,Se){const de=Date.now(),me=we(j,z),{protocol:Z,ownsProtocol:ie}=await r(j,z,ne,Se),q=new n(Se);return q.registerDisposable(Z.onControlMessage(te=>{const fe=JSON.parse(te.toString()),Ee=X(fe);Ee?(j.logService.error(`${me} received error control message when negotiating connection. Error:`),j.logService.error(Ee),ie&&G(Z),q.reject(Ee)):(j.reconnectionProtocol?.endAcceptReconnection(),j.logService.trace(`${me} 6/6. handshake finished, connection is up and running after ${he(de)}!`),q.resolve({protocol:Z,firstMessage:fe}))})),q.promise}async function u(j,z){const{protocol:ne}=await h(j,1,void 0,z);return{protocol:ne}}async function c(j,z,ne){const{protocol:Se,firstMessage:de}=await h(j,2,z,ne),me=de&&de.debugPort;return{protocol:Se,debugPort:me}}async function d(j,z,ne){const Se=Date.now(),de=we(j,3),{protocol:me}=await r(j,3,z,ne);return j.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${he(Se)}!`),me}async function y(j,z,ne){const{connectTo:Se,connectionToken:de}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,connectTo:Se,connectionToken:de,reconnectionToken:z,reconnectionProtocol:ne,remoteSocketFactoryService:j.remoteSocketFactoryService,signService:j.signService,logService:j.logService}}async function A(j,z,ne){return b(j,async Se=>{const{protocol:de}=await u(Se,m.CancellationToken.None);return new J(j,z,ne,Se.reconnectionToken,de)})}e.connectRemoteAgentManagement=A;async function E(j,z){return b(j,async ne=>{const{protocol:Se,debugPort:de}=await c(ne,z,m.CancellationToken.None);return new ce(j,z,ne.reconnectionToken,Se,de)})}e.connectRemoteAgentExtensionHost=E;async function b(j,z){for(let Se=1;;Se++)try{const de=(0,L.generateUuid)(),me=await y(j,de,null);return await z(me)}catch(de){if(Se<5)j.logService.error(`[remote-connection][attempt ${Se}] An error occurred in initial connection! Will retry... Error:`),j.logService.error(de);else throw j.logService.error(`[remote-connection][attempt ${Se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),j.logService.error(de),W.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(de)),de}}async function _(j,z,ne){const Se=await y(j,(0,L.generateUuid)(),null);return await d(Se,{host:z,port:ne},m.CancellationToken.None)}e.connectRemoteAgentTunnel=_;function T(j){return(0,D.createCancelablePromise)(z=>new Promise((ne,Se)=>{const de=setTimeout(ne,j*1e3);z.onCancellationRequested(()=>{clearTimeout(de),ne()})}))}var U;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class M{constructor(z,ne){this.reconnectionToken=z,this.millisSinceLastIncomingData=ne,this.type=0}}e.ConnectionLostEvent=M;class P{constructor(z,ne,Se,de){this.reconnectionToken=z,this.millisSinceLastIncomingData=ne,this.durationSeconds=Se,this.cancellableTimer=de,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=P;class x{constructor(z,ne,Se){this.reconnectionToken=z,this.millisSinceLastIncomingData=ne,this.attempt=Se,this.type=2}}e.ReconnectionRunningEvent=x;class F{constructor(z,ne,Se){this.reconnectionToken=z,this.millisSinceLastIncomingData=ne,this.attempt=Se,this.type=4}}e.ConnectionGainEvent=F;class O{constructor(z,ne,Se,de){this.reconnectionToken=z,this.millisSinceLastIncomingData=ne,this.attempt=Se,this.handled=de,this.type=3}}e.ReconnectionPermanentFailureEvent=O;class W extends v.Disposable{static triggerPermanentFailure(z,ne,Se){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=ne,this._permanentFailureHandled=Se,this._instances.forEach(de=>de._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(z=>z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(z=>z._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||W._permanentFailure}constructor(z,ne,Se,de,me){super(),this._connectionType=z,this._options=ne,this.reconnectionToken=Se,this.protocol=de,this._reconnectionFailureIsFatal=me,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(de.onSocketClose(Z=>{const ie=Q(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${ie} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${ie} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${ie} received socket close event.`),this._beginReconnecting()})),this._register(de.onSocketTimeout(Z=>{const ie=Q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),W._instances.push(this),this._register((0,v.toDisposable)(()=>{const Z=W._instances.indexOf(this);Z>=0&&W._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(W._permanentFailureMillisSinceLastIncomingData,W._permanentFailureAttempt,W._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const z=Q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let Se=-1;do{Se++;const de=Se<ne.length?ne[Se]:ne[ne.length-1];try{if(de>0){const Z=T(de);this._onDidStateChange.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,Z)),this._options.logService.info(`${z} waiting for ${de} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1)),this._options.logService.info(`${z} resolving connection...`);const me=await y(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${me.connectTo}...`),await this._reconnect(me,s(C)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se+1));break}catch(me){if(me.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(me),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(Se>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(me),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(me)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(me);continue}if((me.code==="ETIMEDOUT"||me.code==="ENETUNREACH"||me.code==="ECONNREFUSED"||me.code==="ECONNRESET")&&me.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(me);continue}if((0,k.isCancellationError)(me)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(me);continue}if(me instanceof g.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(me),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,g.RemoteAuthorityResolverError.isHandled(me));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(me),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Se+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(z,ne,Se){this._reconnectionFailureIsFatal?W.triggerPermanentFailure(z,ne,Se):this._gotoPermanentFailure(z,ne,Se)}_gotoPermanentFailure(z,ne,Se){this._onDidStateChange.fire(new O(this.reconnectionToken,z,ne,Se)),G(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=W;class J extends W{constructor(z,ne,Se,de,me){super(1,z,de,me,!0),this.client=this._register(new I.Client(me,{remoteAuthority:ne,clientId:Se},z.ipcLogger))}async _reconnect(z,ne){await u(z,ne)}}e.ManagementPersistentConnection=J;class ce extends W{constructor(z,ne,Se,de,me){super(2,z,Se,de,!1),this._startArguments=ne,this.debugPort=me}async _reconnect(z,ne){await c(z,this._startArguments,ne)}}e.ExtensionHostPersistentConnection=ce;function G(j){try{j.acceptDisconnect();const z=j.getSocket();j.dispose(),z.dispose()}catch(z){(0,k.onUnexpectedError)(z)}}function X(j){if(j&&j.type==="error"){const z=new Error(`Connection error: ${j.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function Y(j,z){for(;j.length<z;)j+=" ";return j}function se(j,z){return`[remote-connection][${Y(f(j),13)}][${z.substr(0,5)}\u2026]`}function Q(j,z,ne){return`${se(j,z)}[${ne?"reconnect":"initial"}]`}function we(j,z){return`${Q(z,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.connectTo}]`}function he(j){return`${Date.now()-j} ms`}}),define(ye[258],Ce([1,0,3,5]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,N.createDecorator)("remoteSocketFactoryService");class m{constructor(){this.factories={}}register(R,v){return this.factories[R]??=[],this.factories[R].push(v),(0,D.toDisposable)(()=>{const p=this.factories[R]?.indexOf(v);typeof p=="number"&&p>=0&&this.factories[R]?.splice(p,1)})}getSocketFactory(R){return(this.factories[R.type]||[]).find(p=>p.supports(R))}connect(R,v,p,S){const L=this.getSocketFactory(R);if(!L)throw new Error(`No socket factory found for ${R}`);return L.connect(R,v,p,S)}}e.RemoteSocketFactoryService=m}),define(ye[259],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class D{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(m){try{const k=await this.getValidator();if(k){const R=String(D._nextId++);return this.validators.set(R,k),{id:R,data:k.createNewMessage(m)}}}catch{}return{id:"",data:m}}async validate(m,k){if(!m.id)return!0;const R=this.validators.get(m.id);if(!R)return!1;this.validators.delete(m.id);try{return R.validate(k)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(m){try{return await this.signValue(m)}catch{}return m}}e.AbstractSignService=D}),define(ye[109],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ye[138],Ce([1,0,259]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class N extends D.AbstractSignService{getValidator(){return this.vsda().then(k=>new k.validator)}signValue(k){return this.vsda().then(R=>new R.signer().sign(k))}vsda(){return new Promise((k,R)=>ge(["vsda"],k,R))}}e.SignService=N}),define(ye[260],Ce([1,0,11,50,30]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(p){if(D.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,S,L,I,g,w,C,l,f){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=C,s.sessionID=(0,m.generateUuid)()+Date.now(),s.commitHash=I,s.version=g,s["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.PlatformToString)(D.platform),s["common.nodePlatform"]=N.platform,s["common.nodeArch"]=L,s["common.product"]=f||"desktop",l&&(s["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.isLinuxSnap&&(s["common.snap"]="true");const o=k(S);return o&&(s["common.platformDetail"]=o),s}e.resolveCommonProperties=R;function v(p){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const L=S.toLowerCase();return p.some(I=>L===I)}e.verifyMicrosoftInternalDomain=v}),define(ye[261],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var N;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var m;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(m||(e.TelemetryConfiguration=m={}))}),define(ye[87],Ce([1,0,24,18,4,45,65,260,261]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=S;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class I{async publicLog(c,d,y){}async publicLogError(c,d,y){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(u,c){return m.Event.debounce(c.onDidChangeConfiguration,(y,A)=>{const E=y?new Set([...y.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:E}},1e3,!0)(y=>{y.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(y.source),configurationKeys:Array.from(y.affectedKeys)})})}e.configurationTelemetry=g;function w(u,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!u.enableTelemetry)}e.supportsTelemetry=w;function C(u,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=C;function l(u){const c=u.getValue(p.TELEMETRY_SETTING_ID),d=u.getValue(p.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||d===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=l;function f(u){const c={},d={},y={};n(u,y);for(let A in y){A=A.length>150?A.substr(A.length-149):A;const E=y[A];typeof E=="number"?d[A]=E:typeof E=="boolean"?d[A]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${E.length}`),c[A]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(c[A]=E)}return{properties:c,measurements:d}}e.validateTelemetryData=f;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const c=(0,R.getRemoteName)(u);return s.has(c)?c:"other"}e.cleanRemoteAuthority=i;function n(u,c,d=0,y){if(u)for(const A of Object.getOwnPropertyNames(u)){const E=u[A],b=y?y+A:A;Array.isArray(E)?c[b]=(0,D.safeStringify)(E):E instanceof Date?c[b]=E.toISOString():(0,N.isObject)(E)?d<2?n(E,c,d+1,b+"."):c[b]=(0,D.safeStringify)(E):c[b]=E}}function o(u,c){const d=u.msftInternalDomains||[],y=c.getValue("telemetry.internalTesting");return(0,v.verifyMicrosoftInternalDomain)(d)||y}e.isInternalTelemetry=o;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=a;function t(u,c){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let d=u;const y=[];for(const _ of c)for(;;){const T=_.exec(u);if(!T)break;y.push([T.index,_.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(d="";;){const _=E.exec(u);if(!_)break;const T=y.some(([U,M])=>_.index<M&&U<E.lastIndex);!A.test(_[0])&&!T&&(d+=u.substring(b,_.index)+"<REDACTED: user-file-path>",b=E.lastIndex)}return b<u.length&&(d+=u.substr(b)),d}function r(u){if(!u)return u;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of c)if(d.regex.test(u))return`<REDACTED: ${d.label}>`;return u}function h(u,c){return(0,D.cloneAndChange)(u,d=>{if(d instanceof S||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let y=d.replaceAll("%20"," ");y=t(y,c);for(const A of c)y=y.replace(A,"");return y=r(y),y}})}e.cleanData=h}),define(ye[262],Ce([1,0,13,134,26,11,2,8,50,87]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(h,u){return h.uuid&&u.uuid?h.uuid===u.uuid:h.id===u.id?!0:(0,D.compareIgnoreCase)(h.id,u.id)===0}e.areSameExtensions=L;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(u){const c=u.manifest?u.manifest.version:u.version,d=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new g(u.identifier,c,d)}static parse(u){const c=I.exec(u);return c&&c[1]&&c[2]?new g({id:c[1]},c[2],c[4]||void 0):null}constructor(u,c,d="undefined"){this.version=c,this.targetPlatform=d,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof g?L(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=g;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(h){const u=w.exec(h);return u&&u[1]?[f(u[1]),u[2]]:[f(h),void 0]}e.getIdAndVersion=C;function l(h,u){return`${h}.${u}`}e.getExtensionId=l;function f(h){return h.toLowerCase()}e.adoptToGalleryExtensionId=f;function s(h,u){return f(l(h??m.UNDEFINED_PUBLISHER,u))}e.getGalleryExtensionId=s;function i(h,u){const c=[],d=y=>{for(const A of c)if(A.some(E=>L(u(E),u(y))))return A;return null};for(const y of h){const A=d(y);A?A.push(y):c.push([y])}return c}e.groupByExtension=i;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function o(h){return{id:new S.TelemetryTrustedValue(h.identifier.id),name:new S.TelemetryTrustedValue(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.getGalleryExtensionTelemetryData=o,e.BetterMergeId=new m.ExtensionIdentifier("pprice.better-merge");function a(h,u){const c=[],d=u.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const y=d.shift();if(y&&c.every(A=>!L(A.identifier,{id:y}))){const A=h.filter(E=>L(E.identifier,{id:y}));A.length===1&&(c.push(A[0]),d.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=a;async function t(h,u){if(!k.isLinux)return!1;let c;try{c=(await h.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await h.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){u.debug("Error while getting the os-release file.",(0,v.getErrorMessage)(y))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(h,u){const c=await t(h,u),d=(0,N.getTargetPlatform)(c?"alpine":k.platform,p.arch);return u.debug("ComputeTargetPlatform:",d),d}e.computeTargetPlatform=r}),define(ye[263],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function D(p){return[...p.entries()]}e.serializeEnvironmentVariableCollection=D;function N(p){return p?[...p.entries()]:[]}e.serializeEnvironmentDescriptionMap=N;function m(p){return new Map(p)}e.deserializeEnvironmentVariableCollection=m;function k(p){return new Map(p??[])}e.deserializeEnvironmentDescriptionMap=k;function R(p){return Array.from(p.entries()).map(S=>[S[0],D(S[1].map),N(S[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=R;function v(p){return new Map(p.map(S=>[S[0],{map:m(S[1]),descriptionMap:k(S[2])}]))}e.deserializeEnvironmentVariableCollections=v}),define(ye[264],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class D{constructor(m){this._callback=m,this._terminalBufferMap=new Map}dispose(){for(const m of this._terminalBufferMap.values())m.dispose()}startBuffering(m,k,R=5){const v=k(p=>{const S=typeof p=="string"?p:p.data;let L=this._terminalBufferMap.get(m);if(L){L.data.push(S);return}const I=setTimeout(()=>this.flushBuffer(m),R);L={data:[S],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(m),v.dispose()}},this._terminalBufferMap.set(m,L)});return v}stopBuffering(m){this._terminalBufferMap.get(m)?.dispose()}flushBuffer(m){const k=this._terminalBufferMap.get(m);k&&(this._terminalBufferMap.delete(m),this._callback(m,k.data.join("")))}}e.TerminalDataBufferer=D}),define(ye[265],Ce([1,0,12,78,61,4,18,2,207,108,37]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var I;(function(o){function a(t,r){let h=t.defaults;for(;m.ThemeIcon.isThemeIcon(h);){const u=C.getIcon(h.id);if(!u)return;h=u.defaults}return h}o.getDefinition=a})(I||(e.IconContribution=I={}));var g;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(h=>({format:h.format,location:h.location.toString()}))}}o.toJSONObject=a;function t(r){const h=u=>(0,R.isString)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,R.isString)(u.format)&&(0,R.isString)(u.location)))return{weight:h(r.weight),style:h(r.style),src:r.src.map(u=>({format:u.format,location:v.URI.parse(u.location)}))}}o.fromJSONObject=t})(g||(e.IconFontDefinition=g={}));class w{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,p.localize)(0,null)},fontCharacter:{type:"string",description:(0,p.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${m.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(a,t,r,h){const u=this.iconsById[a];if(u){if(r&&!u.description){u.description=r,this.iconSchema.properties[a].markdownDescription=`${r} $(${a})`;const y=this.iconReferenceSchema.enum.indexOf(a);y!==-1&&(this.iconReferenceSchema.enumDescriptions[y]=r),this._onDidChange.fire()}return u}const c={id:a,description:r,defaults:t,deprecationMessage:h};this.iconsById[a]=c;const d={$ref:"#/definitions/icons"};return h&&(d.deprecationMessage=h),r&&(d.markdownDescription=`${r}: $(${a})`),this.iconSchema.properties[a]=d,this.iconReferenceSchema.enum.push(a),this.iconReferenceSchema.enumDescriptions.push(r||""),this._onDidChange.fire(),{id:a}}deregisterIcon(a){delete this.iconsById[a],delete this.iconSchema.properties[a];const t=this.iconReferenceSchema.enum.indexOf(a);t!==-1&&(this.iconReferenceSchema.enum.splice(t,1),this.iconReferenceSchema.enumDescriptions.splice(t,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(a=>this.iconsById[a])}getIcon(a){return this.iconsById[a]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(a,t){const r=this.iconFontsById[a];return r||(this.iconFontsById[a]=t,this._onDidChange.fire(),t)}deregisterIconFont(a){delete this.iconFontsById[a]}getIconFont(a){return this.iconFontsById[a]}toString(){const a=(u,c)=>u.id.localeCompare(c.id),t=u=>{for(;m.ThemeIcon.isThemeIcon(u.defaults);)u=this.iconsById[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(u=>this.iconsById[u]);for(const u of h.filter(c=>!!c.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${m.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of h.filter(c=>!m.ThemeIcon.isThemeIcon(c.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const C=new w;L.Registry.add(e.Extensions.IconContribution,C);function l(o,a,t,r){return C.registerIcon(o,a,t,r)}e.registerIcon=l;function f(){return C}e.getIconRegistry=f;function s(){const o=(0,N.getCodiconFontCharacters)();for(const a in o){const t="\\"+o[a].toString(16);C.registerIcon(a,{fontCharacter:t})}}s(),e.iconsSchemaId="vscode://schemas/icons";const i=L.Registry.as(S.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,C.getIconSchema());const n=new D.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.widgetClose=l("widget-close",N.Codicon.close,(0,p.localize)(2,null)),e.gotoPreviousLocation=l("goto-previous-location",N.Codicon.arrowUp,(0,p.localize)(3,null)),e.gotoNextLocation=l("goto-next-location",N.Codicon.arrowDown,(0,p.localize)(4,null)),e.syncing=m.ThemeIcon.modify(N.Codicon.sync,"spin"),e.spinningLoading=m.ThemeIcon.modify(N.Codicon.loading,"spin")}),define(ye[88],Ce([1,0,4,45,5,14]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,m.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,m.createDecorator)("sharedTunnelsService");var R;(function(f){f.Http="http",f.Https="https"})(R||(e.TunnelProtocol=R={}));var v;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(v||(e.TunnelPrivacyId=v={}));function p(f){return!!f.forwardPort}e.isTunnelProvider=p;var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function L(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=L,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=g;function w(f,s,i,n){if(i===1)return!1;if(i===2&&g(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return f<1024}e.isPortPrivileged=w;class C{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this._dispose=n,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=C;let l=class{constructor(s,i){this.logService=s,this.configurationService=i,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],i=Array.from(this._tunnels.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,i,n,o,a){this.addTunnelToMap(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(g(s)||I(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const n=this.getTunnelFromMap(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,h){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this._tunnelProvider??s;if(!u)return;if(i||(i="localhost"),o||(o=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(n)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.retainOrCreateTunnel(u,i,n,o,a,t,r,h);return c?c.then(d=>{if(d){if(typeof d=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(i,n),d}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(i,n);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const y=this.makeTunnel(d);return(d.tunnelRemoteHost!==i||d.tunnelRemotePort!==n)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&d.privacy!==r&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(y),y}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this._tunnels.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async tryDisposeTunnel(s,i,n){if(n.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(i),o}}async closeTunnel(s,i){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this._tunnels.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.tryDisposeTunnel(s,i,o)}}addTunnelToMap(s,i,n){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(i,{refcount:1,value:n})}async removeEmptyOrErrorTunnelFromMap(s,i){const n=this._tunnels.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this._tunnels.delete(s)}}getTunnelFromMap(s,i){const n=[s];I(s)?(n.push(...e.LOCALHOST_ADDRESSES),n.push(...e.ALL_INTERFACES_ADDRESSES)):g(s)&&n.push(...e.ALL_INTERFACES_ADDRESSES);const o=n.map(a=>this._tunnels.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!L(s)}createWithProvider(s,i,n,o,a,t,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const h=n;this._factoryInProgress.add(h);const u=o===void 0?n:o,c={elevationRequired:a?this.isPortPrivileged(u):!1},d={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==v.Private:void 0,protocol:r},y=s.forwardPort(d,c);return y?(this.addTunnelToMap(i,n,y),y.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(h)})):this._factoryInProgress.delete(h),y}};e.AbstractTunnelService=l,e.AbstractTunnelService=l=Ge([We(0,k.ILogService),We(1,N.IConfigurationService)],l)}),define(ye[266],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ye[267],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,D.createDecorator)("editSessionIdentityService");var N;(function(m){m[m.Complete=100]="Complete",m[m.Partial=50]="Partial",m[m.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ye[268],Ce([1,0,17]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function N(p){return p.scheme!==D.Schemas.file&&p.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=N;function m(p){if(p.folders.length)return p.folders.every(S=>N(S.uri))?p.folders[0].uri:void 0;if(p.configuration&&N(p.configuration))return p.configuration}e.getVirtualWorkspaceLocation=m;function k(p){return m(p)?.scheme}e.getVirtualWorkspaceScheme=k;function R(p){return m(p)?.authority}e.getVirtualWorkspaceAuthority=R;function v(p){return m(p)!==void 0}e.isVirtualWorkspace=v}),define(ye[40],Ce([1,0,209,16,77,23,2,5,17]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,v.createDecorator)("contextService");function S(u){const c=u;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=S;function L(u){return typeof u?.id=="string"&&!S(u)&&!g(u)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(u,c){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,N.basename)(u)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const d=u;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.toWorkspaceIdentifier=I;function g(u){const c=u;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=g;function w(u){const c=u;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const d=u;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=w;var C;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function l(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=l;function f(u){const c=u;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=f;class s{constructor(c,d,y,A,E){this._id=c,this._transient=y,this._configuration=A,this._ignorePathCasing=E,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(c){this._id=c.id,this._configuration=c.configuration,this._transient=c.transient,this._ignorePathCasing=c._ignorePathCasing,this.folders=c.folders}get folders(){return this._folders}set folders(c){this._folders=c,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(c){this._configuration=c}getFolder(c){return c&&this._foldersMap.findSubstr(c)||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const c of this.folders)this._foldersMap.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=s;class i{constructor(c,d){this.raw=d,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,k.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function n(u){return new i({uri:u,index:0,name:(0,k.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=n,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function o(u,c){return k.extUriBiasedIgnorePathCase.isEqualOrParent(u,c.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function a(u){let c;return R.URI.isUri(u)?c=u:c=u.configuration,c?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=a,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function r(u,c){return!o(u,c)&&!a(u)}e.isSavedWorkspace=r;function h(u){return(typeof u=="string"?(0,N.extname)(u):(0,k.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=h}),define(ye[269],Ce([1,0,53,4,3,23,2,208,133,32,5,14,40,28,266,12,30,13,18]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.isUserDataProfile=o,e.IUserDataProfilesService=(0,L.createDecorator)("IUserDataProfilesService");function a(u,c){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:R.URI.revive(u.location).with({scheme:c}),globalStorageHome:R.URI.revive(u.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(u.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(u.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(u.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(u.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(u.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(u.cacheHome).with({scheme:c}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.reviveProfile=a;function t(u,c,d,y,A,E){return{id:u,name:c,location:d,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:E&&A?.useDefaultFlags?.globalState?E.globalStorageHome:(0,k.joinPath)(d,"globalStorage"),settingsResource:E&&A?.useDefaultFlags?.settings?E.settingsResource:(0,k.joinPath)(d,"settings.json"),keybindingsResource:E&&A?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,k.joinPath)(d,"keybindings.json"),tasksResource:E&&A?.useDefaultFlags?.tasks?E.tasksResource:(0,k.joinPath)(d,"tasks.json"),snippetsHome:E&&A?.useDefaultFlags?.snippets?E.snippetsHome:(0,k.joinPath)(d,"snippets"),extensionsResource:E&&A?.useDefaultFlags?.extensions?E.extensionsResource:(0,k.joinPath)(d,"extensions.json"),cacheHome:(0,k.joinPath)(y,u),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.toUserDataProfile=t;let r=class extends m.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(c,d,y,A){super(),this.environmentService=c,this.fileService=d,this.uriIdentityService=y,this.logService=A,this.enabled=!0,this._onDidChangeProfiles=this._register(new N.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new N.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new N.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new N.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new w.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,k.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(c){this.enabled!==c&&(this._profilesObject=void 0,this.enabled=c)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const c=this.createDefaultProfile(),d=[c];if(this.enabled)try{for(const E of this.getStoredProfiles()){if(!E.name||!(0,i.isString)(E.name)||!E.location){this.logService.warn("Skipping the invalid stored profile",E.location||E.name);continue}d.push(t((0,k.basename)(E.location),E.name,E.location,this.profilesCacheHome,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},c))}}catch(E){this.logService.error(E)}const y=new w.ResourceMap,A=new Map;if(d.length)try{const E=this.getStoredProfileAssociations();if(E.workspaces)for(const[b,_]of Object.entries(E.workspaces)){const T=R.URI.parse(b),U=d.find(M=>M.id===_);U&&y.set(T,U)}if(E.emptyWindows)for(const[b,_]of Object.entries(E.emptyWindows)){const T=d.find(U=>U.id===_);T&&A.set(b,T)}}catch(E){this.logService.error(E)}this._profilesObject={profiles:d,workspaces:y,emptyWindows:A}}return this._profilesObject}createDefaultProfile(){const c=t("__default__profile__",(0,v.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...c,extensionsResource:this.getDefaultProfileExtensionsLocation()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const d="Temp",y=new RegExp(`${(0,s.escapeRegExpCharacters)(d)}\\s(\\d+)`);let A=0;for(const b of this.profiles){const _=y.exec(b.name),T=_?parseInt(_[1]):0;A=T>A?T:A}const E=`${d} ${A+1}`;return this.createProfile((0,D.hash)((0,f.generateUuid)()).toString(16),E,{transient:!0},c)}async createNamedProfile(c,d,y){return this.createProfile((0,D.hash)((0,f.generateUuid)()).toString(16),c,d,y)}async createProfile(c,d,y,A){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const E=await this.doCreateProfile(c,d,y);return A&&await this.setProfileForWorkspace(A,E),E}async doCreateProfile(c,d,y){if(!(0,i.isString)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.profileCreationPromises.get(d);return A||(A=(async()=>{try{const E=this.profiles.find(T=>T.name===d||T.id===c);if(E)return E;const b=t(c,d,(0,k.joinPath)(this.profilesHome,c),this.profilesCacheHome,y,this.defaultProfile);await this.fileService.createFolder(b.location);const _=[];return this._onWillCreateProfile.fire({profile:b,join(T){_.push(T)}}),await l.Promises.settled(_),this.updateProfiles([b],[],[]),b}finally{this.profileCreationPromises.delete(d)}})(),this.profileCreationPromises.set(d,A)),A}async updateProfile(c,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let y=this.profiles.find(A=>A.id===c.id);if(!y)throw new Error(`Profile '${c.name}' does not exist`);return y=t(y.id,d.name??y.name,y.location,this.profilesCacheHome,{shortName:d.shortName??y.shortName,icon:d.icon===null?void 0:d.icon??y.icon,transient:d.transient??y.isTransient,useDefaultFlags:d.useDefaultFlags??y.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[y]),y}async removeProfile(c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(A=>A.id===c.id);if(!d)throw new Error(`Profile '${c.name}' does not exist`);const y=[];this._onWillRemoveProfile.fire({profile:d,join(A){y.push(A)}});try{await Promise.allSettled(y)}catch(A){this.logService.error(A)}for(const A of[...this.profilesObject.emptyWindows.keys()])d.id===this.profilesObject.emptyWindows.get(A)?.id&&this.profilesObject.emptyWindows.delete(A);for(const A of[...this.profilesObject.workspaces.keys()])d.id===this.profilesObject.workspaces.get(A)?.id&&this.profilesObject.workspaces.delete(A);this.updateStoredProfileAssociations(),this.updateProfiles([],[d],[]);try{await this.fileService.del(d.cacheHome,{recursive:!0})}catch(A){(0,S.toFileOperationResult)(A)!==1&&this.logService.error(A)}}async setProfileForWorkspace(c,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const y=this.profiles.find(A=>A.id===d.id);if(!y)throw new Error(`Profile '${d.name}' does not exist`);this.updateWorkspaceAssociation(c,y)}unsetWorkspace(c,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(c,void 0,d)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const c=await this.fileService.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(d=>d.isDirectory&&this.profiles.every(y=>!this.uriIdentityService.extUri.isEqual(y.location,d.resource))).map(d=>this.fileService.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const c=this.transientProfilesObject.profiles.filter(d=>!this.isProfileAssociatedToWorkspace(d));await Promise.allSettled(c.map(d=>this.removeProfile(d)))}getProfileForWorkspace(c){const d=this.getWorkspace(c);return R.URI.isUri(d)?this.transientProfilesObject.workspaces.get(d)??this.profilesObject.workspaces.get(d):this.transientProfilesObject.emptyWindows.get(d)??this.profilesObject.emptyWindows.get(d)}getWorkspace(c){return(0,g.isSingleFolderWorkspaceIdentifier)(c)?c.uri:(0,g.isWorkspaceIdentifier)(c)?c.configPath:c.id}isProfileAssociatedToWorkspace(c){return!!([...this.transientProfilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location))||[...this.transientProfilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location))||[...this.profilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location))||[...this.profilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,c.location)))}updateProfiles(c,d,y){const A=[...this.profiles,...c],E=[];this.transientProfilesObject.profiles=[];for(let b of A)b.isDefault||d.some(_=>b.id===_.id)||(b=y.find(_=>b.id===_.id)??b,b.isTransient?this.transientProfilesObject.profiles.push(b):E.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.saveStoredProfiles(E),this._profilesObject=void 0,this.triggerProfilesChanges(c,d,y)}triggerProfilesChanges(c,d,y){this._onDidChangeProfiles.fire({added:c,removed:d,updated:y,all:this.profiles})}updateWorkspaceAssociation(c,d,y){y=d?.isTransient?!0:y,y||this.updateWorkspaceAssociation(c,void 0,!0);const A=this.getWorkspace(c),E=y?this.transientProfilesObject:this.profilesObject;R.URI.isUri(A)?(E.workspaces.delete(A),d&&E.workspaces.set(A,d)):(E.emptyWindows.delete(A),d&&E.emptyWindows.set(A,d)),y||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const c={};for(const[y,A]of this.profilesObject.workspaces.entries())c[y.toString()]=A.id;const d={};for(const[y,A]of this.profilesObject.emptyWindows.entries())d[y.toString()]=A.id;this.saveStoredProfileAssociations({workspaces:c,emptyWindows:d}),this._profilesObject=void 0}migrateStoredProfileAssociations(c){const d={},y=this.createDefaultProfile();if(c.workspaces)for(const[E,b]of Object.entries(c.workspaces)){const _=R.URI.parse(b);d[E]=this.uriIdentityService.extUri.isEqual(_,y.location)?y.id:this.uriIdentityService.extUri.basename(_)}const A={};if(c.emptyWindows)for(const[E,b]of Object.entries(c.emptyWindows)){const _=R.URI.parse(b);A[E]=this.uriIdentityService.extUri.isEqual(_,y.location)?y.id:this.uriIdentityService.extUri.basename(_)}return{workspaces:d,emptyWindows:A}}getStoredProfiles(){return[]}saveStoredProfiles(c){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(c){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=Ge([We(0,p.IEnvironmentService),We(1,S.IFileService),We(2,C.IUriIdentityService),We(3,I.ILogService)],r);class h extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(c){this.storedProfiles=c}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(c){this.storedProfileAssociations=c}}e.InMemoryUserDataProfilesService=h}),define(ye[270],Ce([1,0,12,4,3,56,18,188,5,269]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var L;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var I;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var g;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function w(i){const n=i.get(e.TARGET_KEY);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.loadKeyTargets=w;class C extends m.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(n={flushInterval:C.DEFAULT_FLUSH_INTERVAL}){super(),this.options=n,this._onDidChangeValue=this._register(new N.PauseableEmitter),this._onDidChangeTarget=this._register(new N.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new N.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new m.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(n,o,a){return N.Event.filter(this._onDidChangeValue.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,m.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(n,o){const{key:a,external:t}=o;if(a===e.TARGET_KEY){switch(n){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:n})}else this._onDidChangeValue.fire({scope:n,key:a,target:this.getKeyTargets(n)[a],external:t})}emitWillSaveState(n){this._onWillSaveState.fire({reason:n})}get(n,o,a){return this.getStorage(o)?.get(n,a)}getBoolean(n,o,a){return this.getStorage(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.getStorage(o)?.getNumber(n,a)}getObject(n,o,a){return this.getStorage(o)?.getObject(n,a)}storeAll(n,o){this.withPausedEmitters(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,R.isUndefinedOrNull)(o)){this.remove(n,a,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(n,a,t),this.getStorage(a)?.set(n,o,r)})}remove(n,o,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(n,o,void 0),this.getStorage(o)?.delete(n,a)})}withPausedEmitters(n){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{n()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(n,o){const a=[],t=this.getKeyTargets(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}updateKeyTarget(n,o,a,t=!1){const r=this.getKeyTargets(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.getStorage(o)?.set(e.TARGET_KEY,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.getStorage(o)?.set(e.TARGET_KEY,JSON.stringify(r),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(n){switch(n){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(n){const o=this.getStorage(n);return o?w(o):Object.create(null)}isNew(n){return this.getBoolean(e.IS_NEW_KEY,n)===!0}async flush(n=L.NONE){this._onWillSaveState.fire({reason:n});const o=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(n){case L.NONE:await D.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await D.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.getStorage(-1)?.items??new Map,o=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return s(n,o,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(n){return await this.flush(),this.getStorage(n)?.optimize()}async switch(n,o){return this.emitWillSaveState(L.NONE),(0,S.isUserDataProfile)(n)?this.switchToProfile(n,o):this.switchToWorkspace(n,o)}canSwitchProfile(n,o){return!(n.id===o.id||l(o)&&l(n))}switchData(n,o,a){this.withPausedEmitters(()=>{const t=new Set;for(const[r,h]of n)t.add(r),o.get(r)!==h&&this.emitDidChangeValue(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.emitDidChangeValue(a,{key:r,external:!0})})}}e.AbstractStorageService=C;function l(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.isProfileUsingDefaultStorage=l;class f extends C{constructor(){super(),this.applicationStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(n=>this.emitDidChangeValue(1,n))),this._register(this.profileStorage.onDidChangeStorage(n=>this.emitDidChangeValue(0,n))),this._register(this.applicationStorage.onDidChangeStorage(n=>this.emitDidChangeValue(-1,n)))}getStorage(n){switch(n){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(n){return!1}}e.InMemoryStorageService=f;async function s(i,n,o,a,t,r){const h=T=>{try{return JSON.parse(T)}catch{return T}},u=new Map,c=new Map;i.forEach((T,U)=>{u.set(U,T),c.set(U,h(T))});const d=new Map,y=new Map;n.forEach((T,U)=>{d.set(U,T),y.set(U,h(T))});const A=new Map,E=new Map;o.forEach((T,U)=>{A.set(U,T),E.set(U,h(T))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const b=[];if(u.forEach((T,U)=>{b.push({key:U,value:T})}),console.table(b),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];d.forEach((U,M)=>{T.push({key:M,value:U})}),console.table(T),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${r})`);const _=[];A.forEach((T,U)=>{_.push({key:U,value:T})}),console.table(_),console.groupEnd(),console.log(E)}e.logStorage=s}),define(ye[110],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class D{static{this.enableDebugLogging=!1}constructor(m){this.id=m,this._data=new Map,this._idPool=1}add(m){const k=this._idPool++;return this._data.set(k,m),this.logDebugInfo(),k}get(m,k){return this._data.has(m)?this._data.get(m)[k]:void 0}delete(m){this._data.delete(m),this.logDebugInfo()}logDebugInfo(){D.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=D}),define(ye[57],Ce([1,0,17,23,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(D.Schemas)),this._providerInfo=new Map,this.extUri=new N.ExtUri(v=>{const p=this._providerInfo.get(v.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(v,p){p===null?this._providerInfo.delete(v.scheme):this._providerInfo.set(v.scheme,p)}isFreeScheme(v){return!this._providerInfo.has(v)&&!this._systemSchemes.has(v)}getCapabilities(v){return this._providerInfo.get(v)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,m.createDecorator)("IExtHostFileSystemInfo")}),define(ye[27],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,D.createDecorator)("IExtHostInitDataService")}),define(ye[271],Ce([1,0,214,14,251,27]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends m.LogService{constructor(p,S,L){const I=L.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",g=L.remote.isRemote?(0,D.localize)(0,null):p?(0,D.localize)(1,null):(0,D.localize)(2,null);super(S.createLogger(I,{name:g}))}};e.ExtHostLogService=R,e.ExtHostLogService=R=Ge([We(1,N.ILoggerService),We(2,k.IExtHostInitDataService)],R)}),define(ye[272],Ce([1,0,12]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class N{constructor(R,v,p){this._deferredPromises=new Map,this._id=R,this._shared=v,this._storage=p,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(S=>(this._value=S,this)),this._storageListener=this._storage.onDidChangeStorage(S=>{S.shared===this._shared&&S.key===this._id&&(this._value=S.value)}),this._scheduler=new D.RunOnceScheduler(()=>{const S=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of S.values())L.complete()}catch(L){for(const I of S.values())I.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,v){let p=this._value[R];return typeof p>"u"&&(p=v),p}update(R,v){this._value[R]=v;const p=this._deferredPromises.get(R);if(p!==void 0)return p.p;const S=new D.DeferredPromise;return this._deferredPromises.set(R,S),this._scheduler.isScheduled()||this._scheduler.schedule(),S.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=N;class m extends N{setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}constructor(R,v){super(R.identifier.value,!0,v),this._extension=R}}e.ExtensionGlobalMemento=m}),define(ye[273],Ce([1,0,4,2]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class m{constructor(R){this._notebooksAndEditors=R,this._onDidSaveNotebookDocument=new D.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new D.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(R,v,p,S){const I=this._notebooksAndEditors.getNotebookDocument(N.URI.revive(R)).acceptModelChanged(v.value,p,S);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(R,v){this._notebooksAndEditors.getNotebookDocument(N.URI.revive(R)).acceptDirty(v)}$acceptModelSaved(R){const v=this._notebooksAndEditors.getNotebookDocument(N.URI.revive(R));this._onDidSaveNotebookDocument.fire(v.apiNotebook)}}e.ExtHostNotebookDocuments=m}),define(ye[20],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,D.createDecorator)("IExtHostRpcService");class N{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.dispose=k.dispose.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=N}),define(ye[274],Ce([1,0,26,4]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class m{#e;constructor(R,v){this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this._id=D.ExtensionIdentifier.toKey(R.identifier),this.#e=v,this.#e.onDidChangePassword(p=>{p.extensionId===this._id&&this._onDidChange.fire({key:p.key})})}get(R){return this.#e.get(this._id,R)}store(R,v){return this.#e.store(this._id,R,v)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=m}),define(ye[66],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,D.createDecorator)("IURITransformerService");class N{constructor(k){k?(this.transformIncoming=k.transformIncoming.bind(k),this.transformOutgoing=k.transformOutgoing.bind(k),this.transformOutgoingURI=k.transformOutgoingURI.bind(k),this.transformOutgoingScheme=k.transformOutgoingScheme.bind(k)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=N}),define(ye[275],Ce([1,0,22]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class N{constructor(){this.buffers=[]}add(p){let S=this.buffers.indexOf(p);return S<0&&(S=this.buffers.length,this.buffers.push(p)),S}}function m(v,p){if(p.serializeBuffersForPostMessage){const S=new N,I=JSON.stringify(v,(w,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(C)};if(ArrayBuffer.isView(C)){const l=k(C);if(l)return{$$vscode_array_buffer_reference$$:!0,index:S.add(C.buffer),view:{type:l,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),g=S.buffers.map(w=>{const C=new Uint8Array(w);return D.VSBuffer.wrap(C)});return{message:I,buffers:g}}else return{message:JSON.stringify(v),buffers:[]}}e.serializeWebviewMessage=m;function k(v){switch(v.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(v,p){const S=p.map(g=>{const w=new ArrayBuffer(g.byteLength);return new Uint8Array(w).set(g.buffer),w}),L=p.length?(g,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const C=w,{index:l}=C,f=S[l];if(C.view)switch(C.view.type){case 1:return new Int8Array(f,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return w}:void 0;return{message:JSON.parse(v,L),arrayBuffers:S}}e.deserializeWebviewMessage=R}),define(ye[276],Ce([1,0,277,388,389,62,2,14,390]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;const S=!1;function L(n,o,a,t,r,h){const u=h.environment.useHostProxy,c=typeof u=="boolean"?u:!h.remote.isRemote,d={resolveProxy:E=>n.resolveProxy(E),lookupProxyAuthorization:f.bind(void 0,t,r,o,{},h.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>g(o),addCertificatesV2:()=>w(o),log:t,getLogLevel:()=>{const E=t.getLevel();switch(E){case v.LogLevel.Trace:return p.LogLevel.Trace;case v.LogLevel.Debug:return p.LogLevel.Debug;case v.LogLevel.Info:return p.LogLevel.Info;case v.LogLevel.Warning:return p.LogLevel.Warning;case v.LogLevel.Error:return p.LogLevel.Error;case v.LogLevel.Off:return p.LogLevel.Off;default:return b(E)}function b(_){return t.error("Unknown log level",_),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const E=[];if(h.remote.isRemote&&E.push((0,p.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const b=n.loadCertificates();b.then(_=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",_.length)),E.push(b)}return(await Promise.all(E)).flat()},env:process.env},y=(0,p.createProxyResolver)(d),A=I(d,y);return l(a,A)}e.connectProxyResolver=L;function I(n,o){return{http:Object.assign(D,(0,p.createHttpPatch)(n,D,o)),https:Object.assign(N,(0,p.createHttpPatch)(n,N,o)),net:Object.assign(k,(0,p.createNetPatch)(n,k)),tls:Object.assign(m,(0,p.createTlsPatch)(n,m))}}function g(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",S)&&!!o.get("systemCertificates")}function w(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",S)&&!!o.get("systemCertificates")}const C=new Map;function l(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,c,d){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const y=a.findSubstr(R.URI.file(c.filename));let A=C.get(y);if(A||C.set(y,A={}),!A[u]){const E=o[u];A[u]={...E}}return A[u]}})}async function f(n,o,a,t,r,h,u,c){const d=t[h];u&&(t[h]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${d}`);const y=u||d,A=Array.isArray(y)?y:typeof y=="string"?[y]:[];if(i(o,A,r),A.some(E=>/^(Negotiate|Kerberos)( |$)/i.test(E))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const E=await new Promise((M,P)=>{ge(["kerberos"],M,P)}),b=new URL(h),_=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${b.hostname}`:`HTTP@${b.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${_}`),"Negotiate "+await(await E.initializeClient(_)).step("")}catch(E){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",E)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ye[278],Ce([1,0,130]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function N(k){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:k,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function m(k){return new D.URITransformer(N(k))}e.createURITransformer=m}),define(ye[139],Ce([1,0,225,18,2,3,5,37,32,17,44,180,39]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffListEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var w;(function(he){he[he.PROGRAMMATIC=1]="PROGRAMMATIC",he[he.USER=2]="USER",he[he.EDIT=3]="EDIT",he[he.NAVIGATION=4]="NAVIGATION",he[he.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var C;(function(he){he[he.IDENTICAL=1]="IDENTICAL",he[he.SIMILAR=2]="SIMILAR",he[he.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function l(he){const j=he;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}e.isEditorPaneWithSelection=l;function f(he,j,z){for(const ne of z.visibleEditorPanes)if(ne.group.id===j&&he.matches(ne.input))return ne.getViewState()}e.findViewStateForEditor=f;function s(he){if(y(he))return!1;const j=he;return m.URI.isUri(j?.resource)}e.isResourceEditorInput=s;function i(he){if(y(he))return!1;const j=he;return j?.original!==void 0&&j.modified!==void 0}e.isResourceDiffEditorInput=i;function n(he){if(y(he))return!1;const j=he;return Array.isArray(j?.resources)}e.isResourceDiffListEditorInput=n;function o(he){if(y(he)||i(he))return!1;const j=he;return j?.primary!==void 0&&j.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function a(he){if(y(he))return!1;const j=he;return j?j.resource===void 0||j.resource.scheme===S.Schemas.untitled||j.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;function t(he){if(y(he))return!1;const j=he;return m.URI.isUri(j?.base?.resource)&&m.URI.isUri(j?.input1?.resource)&&m.URI.isUri(j?.input2?.resource)&&m.URI.isUri(j?.result?.resource)}e.isResourceMergeEditorInput=t;var r;(function(he){he[he.SHORT=0]="SHORT",he[he.MEDIUM=1]="MEDIUM",he[he.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var h;(function(he){he[he.EXPLICIT=1]="EXPLICIT",he[he.AUTO=2]="AUTO",he[he.FOCUS_CHANGE=3]="FOCUS_CHANGE",he[he.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(j,z){let ne=this.mapIdToSaveSource.get(j);return ne||(ne={source:j,label:z},this.mapIdToSaveSource.set(j,ne)),ne.source}getSourceLabel(j){return this.mapIdToSaveSource.get(j)?.label??j}}e.SaveSourceRegistry=new u;var c;(function(he){he[he.None=0]="None",he[he.Readonly=2]="Readonly",he[he.Untitled=4]="Untitled",he[he.Singleton=8]="Singleton",he[he.RequiresTrust=16]="RequiresTrust",he[he.CanSplitInGroup=32]="CanSplitInGroup",he[he.ForceDescription=64]="ForceDescription",he[he.CanDropIntoEditor=128]="CanDropIntoEditor",he[he.MultipleEditors=256]="MultipleEditors",he[he.Scratchpad=512]="Scratchpad",he[he.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class d extends k.Disposable{}e.AbstractEditorInput=d;function y(he){return he instanceof d}e.isEditorInput=y;function A(he){const j=he;return m.URI.isUri(j?.preferredResource)}function E(he){const j=he;return y(j?.primary)&&y(j?.secondary)}e.isSideBySideEditorInput=E;function b(he){const j=he;return y(j?.modified)&&y(j?.original)}e.isDiffEditorInput=b;function _(he,j,z,ne,Se){return we(ne,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const de={...z,limits:{size:Number.MAX_VALUE}};he.openEditor(j,de)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>Se.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:g.default.Warning})}e.createTooLargeFileError=_;function T(he){return y(he?.editor)}e.isEditorInputWithOptions=T;function U(he){const j=he;return T(he)&&j?.group!==void 0}e.isEditorInputWithOptionsAndGroup=U;function M(he){const j=he;return typeof j?.groupId=="number"&&y(j.editor)}e.isEditorIdentifier=M;var P;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.REPLACE=1]="REPLACE",he[he.MOVE=2]="MOVE",he[he.UNPIN=3]="UNPIN"})(P||(e.EditorCloseContext=P={}));var x;(function(he){he[he.GROUP_ACTIVE=0]="GROUP_ACTIVE",he[he.GROUP_INDEX=1]="GROUP_INDEX",he[he.GROUP_LABEL=2]="GROUP_LABEL",he[he.GROUP_LOCKED=3]="GROUP_LOCKED",he[he.EDITOR_OPEN=4]="EDITOR_OPEN",he[he.EDITOR_CLOSE=5]="EDITOR_CLOSE",he[he.EDITOR_MOVE=6]="EDITOR_MOVE",he[he.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",he[he.EDITOR_LABEL=8]="EDITOR_LABEL",he[he.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",he[he.EDITOR_PIN=10]="EDITOR_PIN",he[he.EDITOR_STICKY=11]="EDITOR_STICKY",he[he.EDITOR_DIRTY=12]="EDITOR_DIRTY",he[he.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(x||(e.GroupModelChangeKind=x={}));var F;(function(he){he[he.PRIMARY=1]="PRIMARY",he[he.SECONDARY=2]="SECONDARY",he[he.BOTH=3]="BOTH",he[he.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class O{getOriginalUri(j,z){if(!j)return;if(t(j))return e.EditorResourceAccessor.getOriginalUri(j.result,z);if(z?.supportSideBySide){const{primary:Se,secondary:de}=this.getSideEditors(j);if(Se&&de){if(z?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(Se,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===F.ANY)return this.getOriginalUri(Se,{filterByScheme:z.filterByScheme})??this.getOriginalUri(de,{filterByScheme:z.filterByScheme});j=z.supportSideBySide===F.PRIMARY?Se:de}}if(i(j)||n(j)||o(j)||t(j))return;const ne=A(j)?j.preferredResource:j.resource;return!ne||!z||!z.filterByScheme?ne:this.filterUri(ne,z.filterByScheme)}getSideEditors(j){return E(j)||o(j)?{primary:j.primary,secondary:j.secondary}:b(j)||i(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,z){if(!j)return;if(t(j))return e.EditorResourceAccessor.getCanonicalUri(j.result,z);if(z?.supportSideBySide){const{primary:Se,secondary:de}=this.getSideEditors(j);if(Se&&de){if(z?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(Se,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===F.ANY)return this.getCanonicalUri(Se,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:z.filterByScheme});j=z.supportSideBySide===F.PRIMARY?Se:de}}if(i(j)||n(j)||o(j)||t(j))return;const ne=j.resource;return!ne||!z||!z.filterByScheme?ne:this.filterUri(ne,z.filterByScheme)}filterUri(j,z){if(Array.isArray(z)){if(z.some(ne=>j.scheme===ne))return j}else if(z===j.scheme)return j}}var W;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.KEYBOARD=1]="KEYBOARD",he[he.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function J(he,j,z,ne){if(!he.isSticky(j))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return z===W.MOUSE||z===W.KEYBOARD;case"mouse":return z===W.MOUSE;case"keyboard":return z===W.KEYBOARD}return!1}e.preventEditorClose=J,e.EditorResourceAccessor=new O;var ce;(function(he){he[he.LEFT=0]="LEFT",he[he.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class G{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(j){const z=this.instantiationService=j.get(R.IInstantiationService);for(const[ne,Se]of this.editorSerializerConstructors)this.createEditorSerializer(ne,Se,z);this.editorSerializerConstructors.clear()}createEditorSerializer(j,z,ne){const Se=ne.createInstance(z);this.editorSerializerInstances.set(j,Se)}registerFileEditorFactory(j){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=j}getFileEditorFactory(){return(0,N.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(j,z){if(this.editorSerializerConstructors.has(j)||this.editorSerializerInstances.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.instantiationService?this.createEditorSerializer(j,z,this.instantiationService):this.editorSerializerConstructors.set(j,z),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(j),this.editorSerializerInstances.delete(j)})}getEditorSerializer(j){return this.editorSerializerInstances.get(typeof j=="string"?j:j.typeId)}}v.Registry.add(e.EditorExtensions.EditorFactory,new G);async function X(he,j,z){return!he||!he.length?[]:await Promise.all(he.map(async ne=>{const Se=m.URI.revive(ne.fileUri);if(!Se){z.info("Cannot resolve the path because it is not valid.",ne);return}if(!await j.canHandleResource(Se)){z.info("Cannot resolve the path because it cannot be handled",ne);return}let me=ne.exists,Z=ne.type;if(typeof me!="boolean"||typeof Z!="number")try{Z=(await j.stat(Se)).isDirectory?p.FileType.Directory:p.FileType.Unknown,me=!0}catch(q){z.error(q),me=!1}if(!me&&ne.openOnlyIfExists){z.info("Cannot resolve the path because it does not exist",ne);return}if(Z===p.FileType.Directory){z.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return me?{resource:Se,options:ie}:{resource:Se,options:ie,forceUntitled:!0}}))}e.pathsToEditors=X;var Y;(function(he){he[he.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",he[he.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function se(he){const j=he;if(!j)return!1;const z=j;if(z.modified)return se(z.modified);const ne=j;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.isTextEditorViewState=se;function Q(he){return(0,L.isErrorWithActions)(he)}e.isEditorOpenError=Q;function we(he,j,z){const ne=(0,L.createErrorWithActions)(he,j);return ne.forceMessage=z?.forceMessage,ne.forceSeverity=z?.forceSeverity,ne.allowDialog=z?.allowDialog,ne}e.createEditorOpenError=we}),define(ye[279],Ce([1,0,4,226,5,3,28,37,19,24,78,265]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,N.localize)(0,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",L.Codicon.window,(0,N.localize)(1,null));var g;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(g||(e.Extensions=g={}));var w;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.ViewContainerLocations=[0,1,2];function C(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=C;class l extends k.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new D.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new D.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,p.flatten)([...this.viewContainers.values()])}registerViewContainer(h,u,c){const d=this.get(h.id);if(d)return d;const y=h;return y.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,R.getOrSet)(this.viewContainers,u,[]).push(y),c?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:u}),y}deregisterViewContainer(h){for(const u of this.viewContainers.keys()){const c=this.viewContainers.get(u),d=c?.indexOf(h);if(d!==-1){c?.splice(d,1),c.length===0&&this.viewContainers.delete(u),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:u});return}}}get(h){return this.all.filter(u=>u.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(u=>this.getViewContainers(u).filter(c=>c?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(u=>this.getViewContainerLocation(u)===h)}}v.Registry.add(g.ViewContainersRegistry,new l);var f;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(f||(e.ViewContentGroups=f={}));function s(r,h){const u=r.group??f.More,c=h.group??f.More;return u!==c?u.localeCompare(c):(r.order??5)-(h.order??5)}class i extends k.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new D.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new D.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new D.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new D.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(h,u){this.registerViews2([{views:h,viewContainer:u}])}registerViews2(h){h.forEach(({views:u,viewContainer:c})=>this.addViews(u,c)),this._onViewsRegistered.fire(h)}deregisterViews(h,u){const c=this.removeViews(h,u);c.length&&this._onViewsDeregistered.fire({views:c,viewContainer:u})}moveViews(h,u){for(const c of this._views.keys())if(c!==u){const d=this.removeViews(h,c);d.length&&(this.addViews(d,u),this._onDidChangeContainer.fire({views:d,from:c,to:u}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const u of this._viewContainers){const c=(this._views.get(u)||[]).filter(d=>d.id===h)[0];if(c)return c}return null}getViewContainer(h){for(const u of this._viewContainers)if((this._views.get(u)||[]).filter(d=>d.id===h)[0])return u;return null}registerViewWelcomeContent(h,u){return this._viewWelcomeContents.add(h,u),this._onDidChangeViewWelcomeContent.fire(h),(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(h,u),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,u){const c=new Map;for(const[d,y]of u)this._viewWelcomeContents.add(h,y),c.set(d,(0,k.toDisposable)(()=>{this._viewWelcomeContents.delete(h,y),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),c}getViewWelcomeContent(h){const u=[];return this._viewWelcomeContents.forEach(h,c=>u.push(c)),u.sort(s)}addViews(h,u){let c=this._views.get(u);c||(c=[],this._views.set(u,c),this._viewContainers.push(u));for(const d of h){if(this.getView(d.id)!==null)throw new Error((0,N.localize)(2,null,d.id));c.push(d)}}removeViews(h,u){const c=this._views.get(u);if(!c)return[];const d=[],y=[];for(const A of c)h.includes(A)?d.push(A):y.push(A);return d.length&&(y.length?this._views.set(u,y):(this._views.delete(u),this._viewContainers.splice(this._viewContainers.indexOf(u),1))),d}}v.Registry.add(g.ViewsRegistry,new i),e.IViewsService=(0,m.createDecorator)("viewsService"),e.IViewDescriptorService=(0,m.createDecorator)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(h,u){this.resolved=!1,this._hasResolve=!1,(0,S.mixin)(this,h),this._hasResolve=!!u,this.resolve=async c=>{if(u&&!this.resolved){const d=await u(c);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}c.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a;class t extends Error{constructor(h){super((0,N.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(ye[280],Ce([1,0,2,29,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChatService=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function k(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof D.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(N.Range.isIRange)}e.isIDocumentContext=k;function R(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(k)}e.isIUsedContext=R;var v;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(v||(e.InteractiveSessionVoteDirection=v={}));var p;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})(p||(e.InteractiveSessionCopyKind=p={})),e.IChatService=(0,m.createDecorator)("IChatService")}),define(ye[140],Ce([1,0,4,12,227]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class k{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new D.Emitter,this._onExit=new D.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(v){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=v}onEvent(v){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=v}onRequest(v){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=v}sendResponse(v){v.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${v.command}`)):this.internalSend("response",v)}sendRequest(v,p,S,L){const I={command:v};if(p&&Object.keys(p).length>0&&(I.arguments=p),this.internalSend("request",I),typeof L=="number"){const g=setTimeout(()=>{clearTimeout(g);const w=this.pendingRequests.get(I.seq);if(w){this.pendingRequests.delete(I.seq);const C={type:"response",seq:0,request_seq:I.seq,success:!1,command:v,message:(0,m.localize)(0,null,L,v)};w(C)}},L)}return S&&this.pendingRequests.set(I.seq,S),I.seq}acceptMessage(v){this.messageCallback?this.messageCallback(v):(this.queue.push(v),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(v,p){return v.type!=="event"||p.type!=="event"}async processQueue(){let v;for(;this.queue.length;){if((!v||this.needsTaskBoundaryBetween(this.queue[0],v))&&await(0,N.timeout)(0),v=this.queue.shift(),!v)return;switch(v.type){case"event":this.eventCallback?.(v);break;case"request":this.requestCallback?.(v);break;case"response":{const p=v,S=this.pendingRequests.get(p.request_seq);S&&(this.pendingRequests.delete(p.request_seq),S(p));break}}}}internalSend(v,p){p.type=v,p.seq=this.sequence++,this.sendMessage(p)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const v=new Map;this.pendingRequests.forEach((p,S)=>v.set(S,p)),await(0,N.timeout)(500),v.forEach((p,S)=>{p({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(S)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=k}),define(ye[281],Ce([1,0,228,46,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new N.RawContextKey("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new N.RawContextKey("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new N.RawContextKey("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new N.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:D.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new N.RawContextKey("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new N.RawContextKey("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new N.RawContextKey("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new N.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new N.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new N.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new N.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new N.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new N.RawContextKey("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new N.RawContextKey("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new N.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new N.RawContextKey("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new N.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new N.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new N.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new N.RawContextKey("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new N.RawContextKey("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new N.RawContextKey("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new N.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new N.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new N.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new N.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new N.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new N.RawContextKey("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new N.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new N.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new N.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new N.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new N.RawContextKey("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new N.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new N.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new N.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new N.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new N.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new N.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new N.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new N.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new N.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new N.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new N.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new N.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new N.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.CONTEXT_MULTI_SESSION_REPL=new N.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new N.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new N.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new N.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new N.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new N.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const k=g=>D.localize(52,null,g);e.debuggerDisabledMessage=k,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var R;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(R||(e.State=R={}));function v(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=v;var p;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(p||(e.MemoryRangeType=p={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var S;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(S||(e.DebugConfigurationProviderTriggerKind=S={}));var L;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.IDebugService=(0,m.createDecorator)("debugService");var I;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(ye[282],Ce([1,0,13,2,16,24,17,29,21,19]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function I(A,E,b){return A.replace(L,function(_,T){return E&&T.length>0&&T[0]!=="_"?_:b&&b.hasOwnProperty(T)?b[T]:_})}e.formatPII=I;function g(A){const E={};for(const b of Object.keys(A))b.startsWith("!")||(E[b]=A[b]);return E}e.filterExceptionsFromTelemetry=g;function w(A){return A.configuration.request==="attach"&&!C(A)&&(!A.parentSession||w(A.parentSession))}e.isSessionAttach=w;function C(A){let E=A.configuration.type;if(E)return E==="vslsShare"&&(E=A.configuration.adapterProxy.configuration.type),(0,D.equalsIgnoreCase)(E,"extensionhost")||(0,D.equalsIgnoreCase)(E,"pwa-extensionhost")?A:A.parentSession?C(A.parentSession):void 0}e.getExtensionHostDebugSession=C;function l(A){return A.type&&(A.label||A.program||A.runtime)}e.isDebuggerMainContribution=l;function f(A,E,b){let _,T=0;const U=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=U.exec(A);){const P=M.index+1,x=P+M[0].length;if(P<=E&&x>=b){_=M[0],T=P;break}}if(_){const P=/\w+/g;let x=null;for(;(x=P.exec(_))&&!(x.index+1+T+x[0].length>=b););x&&(_=_.substring(0,P.lastIndex))}return _?{start:T,end:T+_.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;async function s(A,E,b,_){if(A.evaluatableExpressionProvider.has(E)){const T=A.evaluatableExpressionProvider.ordered(E),U=(0,S.coalesce)(await Promise.all(T.map(async M=>{try{return await M.provideEvaluatableExpression(E,b,_??p.CancellationToken.None)}catch{return}})));if(U.length>0){let M=U[0].expression;const P=U[0].range;return M||(M=E.getLineContent(b.lineNumber).substring(P.startColumn-1,P.endColumn-1)),{range:P,matchingExpression:M}}}else{const T=E.getLineContent(b.lineNumber),{start:U,end:M}=f(T,b.column,b.column),P=T.substring(U-1,M);return{matchingExpression:P,range:new v.Range(b.lineNumber,U,b.lineNumber,U+P.length)}}return null}e.getEvaluatableExpressionAtPosition=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(A){return!!(A&&A.match(i))}e.isUri=n;function o(A){if(typeof A.path=="string"&&!(typeof A.sourceReference=="number"&&A.sourceReference>0)){if(n(A.path))return N.URI.parse(A.path);if((0,m.isAbsolute)(A.path))return N.URI.file(A.path)}return A.path}function a(A){if(typeof A.path=="object"){const E=N.URI.revive(A.path);if(E)return E.scheme===R.Schemas.file?E.fsPath:E.toString()}return A.path}function t(A,E){const b=E?o:a,_=(0,k.deepClone)(A);return h(_,(T,U)=>{T&&U&&(U.path=b(U))}),_}e.convertToDAPaths=t;function r(A,E){const b=E?o:a,_=(0,k.deepClone)(A);return h(_,(T,U)=>{!T&&U&&(U.path=b(U))}),_}e.convertToVSCPaths=r;function h(A,E){switch(A.type){case"event":{const b=A;switch(b.event){case"output":E(!1,b.body.source);break;case"loadedSource":E(!1,b.body.source);break;case"breakpoint":E(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=A;switch(b.command){case"setBreakpoints":E(!0,b.arguments.source);break;case"breakpointLocations":E(!0,b.arguments.source);break;case"source":E(!0,b.arguments.source);break;case"gotoTargets":E(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(_=>E(!1,_));break;default:break}break}case"response":{const b=A;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(_=>E(!1,_.source));break;case"loadedSources":b.body.sources.forEach(_=>E(!1,_));break;case"scopes":b.body.scopes.forEach(_=>E(!1,_.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(_=>E(!1,_.source));break;case"setBreakpoints":b.body.breakpoints.forEach(_=>E(!1,_.source));break;case"disassemble":b.body?.instructions.forEach(T=>E(!1,T.location));break;default:break}break}}}function u(A){return A.filter(E=>!E.presentation?.hidden).sort((E,b)=>E.presentation?b.presentation?E.presentation.group?b.presentation.group?E.presentation.group!==b.presentation.group?E.presentation.group.localeCompare(b.presentation.group):c(E.presentation.order,b.presentation.order):-1:b.presentation.group?1:c(E.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.getVisibleAndSorted=u;function c(A,E){return typeof A!="number"?typeof E!="number"?0:1:typeof E!="number"?-1:A-E}async function d(A,E){const b=A.getValue("debug.saveBeforeStart",{overrideIdentifier:E.activeTextEditorLanguageId});if(b!=="none"&&(await E.saveAll(),b==="allEditorsInActiveGroup")){const _=E.activeEditorPane;_&&_.input.resource?.scheme===R.Schemas.untitled&&await E.save({editor:_.input,groupId:_.group.id})}await A.reloadConfiguration()}e.saveAllBeforeDebugStart=d;const y=(A,E)=>!A||!E?A===E:A.name===E.name&&A.path===E.path&&A.sourceReference===E.sourceReference;e.sourcesEqual=y}),define(ye[283],Ce([1,0,51,62,24,16,11,13,31,229,140]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends L.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(s,i){this.outputStream=i,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,s.on("data",n=>this.handleData(n))}sendMessage(s){if(this.outputStream){const i=JSON.stringify(s);this.outputStream.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${I.TWO_CRLF}${i}`,"utf8")}}handleData(s){for(this.rawData=Buffer.concat([this.rawData,s]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const i=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this._onError.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.rawData.indexOf(I.TWO_CRLF);if(i!==-1){const o=this.rawData.toString("utf8",0,i).split(I.HEADER_LINESEPARATOR);for(const a of o){const t=a.split(I.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(i+I.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=I;class g extends I{startSession(){return new Promise((s,i)=>{let n=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),s(),n=!0}),this.socket.on("close",()=>{n?this._onError.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.socket.on("error",o=>{n?this._onError.fire(o):i(o)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class w extends g{constructor(s){super(),this.adapterServer=s}createConnection(s){return N.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",s)}}e.SocketDebugAdapter=w;class C extends g{constructor(s){super(),this.adapterServer=s}createConnection(s){return N.createConnection(this.adapterServer.path,s)}}e.NamedPipeDebugAdapter=C;class l extends I{constructor(s,i){super(),this.adapterExecutable=s,this.debugType=i}async startSession(){const s=this.adapterExecutable.command,i=this.adapterExecutable.args,n=this.adapterExecutable.options||{};try{if(s)if(k.isAbsolute(s)){if(!await p.Promises.exists(s))throw new Error(S.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.debugType));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=m.mixin(m.deepClone(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(S.localize(2,null,i[0]));this.serverProcess=r}else throw new Error(S.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.serverProcess=D.spawn(s,i,a)}this.serverProcess.on("error",a=>{this._onError.fire(a)}),this.serverProcess.on("exit",(a,t)=>{this._onExit.fire(a)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stdin.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(o){this._onError.fire(o)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((s,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=k.join(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(k.isAbsolute(s.program)?n.program=s.program:n.program=k.join(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=l.extract(o.win,i)),o.winx86&&(n.winx86=l.extract(o.winx86,i)),o.windows&&(n.windows=l.extract(o.windows,i)),o.osx&&(n.osx=l.extract(o.osx,i)),o.linux&&(n.linux=l.extract(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const c=u.contributes.debuggers;c&&c.length>0&&c.filter(d=>typeof d.type=="string"&&v.equalsIgnoreCase(d.type,i)).forEach(d=>{const y=l.extract(d,u.extensionLocation.fsPath);n=m.mixin(n,y,u.isBuiltin)})}let o;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:R.isWindows?o=n.win||n.windows:R.isMacintosh?o=n.osx:R.isLinux&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,h=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(h||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.ExecutableDebugAdapter=l}),define(ye[284],Ce([1,0,51,33,11]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function k(S,L){return new Promise((I,g)=>{let w="";const C=D.spawn(S,L);C.pid&&C.stdout.on("data",l=>{w+=l.toString()}),C.on("error",l=>{g(l)}),C.on("close",l=>{I(w)})})}async function R(S){if(S)if(m.isWindows){const L=await new Promise((I,g)=>{ge(["@vscode/windows-process-tree"],I,g)});return new Promise(I=>{L.getProcessTree(S,g=>{I(!!g&&g.children.length>0)})})}else return k("/usr/bin/pgrep",["-lP",String(S)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=R;var v;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(v||(v={}));function p(S,L,I,g,w){S=S.trim().toLowerCase();let C;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?C=1:S.indexOf("cmd.exe")>=0?C=0:S.indexOf("bash")>=0?C=2:m.isWindows?C=0:C=2;let l,f=" ";switch(C){case 1:if(l=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),g){const s=(0,N.getDriveLetter)(g);s&&(f+=`${s}:; `),f+=`cd ${l(g)}; `}if(w)for(const s in w){const i=w[s];i===null?f+=`Remove-Item env:${s}; `:f+=`\${env:${s}}='${i}'; `}if(L.length>0){const s=L.shift(),i=I?s:l(s);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of L)f+=n==="<"||n===">"||I?n:l(n),f+=" "}break;case 0:if(l=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),g){const s=(0,N.getDriveLetter)(g);s&&(f+=`${s}: && `),f+=`cd ${l(g)} && `}if(w){f+='cmd /C "';for(const s in w){let i=w[s];i===null?f+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),f+=`set "${s}=${i}" && `)}}for(const s of L)f+=s==="<"||s===">"||I?s:l(s),f+=" ";w&&(f+='"');break;case 2:{l=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(g&&(f+=`cd ${l(g)} ; `),w){f+="/usr/bin/env";for(const i in w){const n=w[i];n===null?f+=` -u ${s(i)}`:f+=` ${s(`${i}=${n}`)}`}f+=" "}for(const i of L)f+=i==="<"||i===">"||I?i:l(i),f+=" ";break}}return f}e.prepareCommand=p}),define(ye[111],Ce([1,0,22,34,52,100,17,16,11,46]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(L||(e.CellKind=L={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",k.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var g;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(g||(e.NotebookCellExecutionState=g={}));var w;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var C;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var l;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var f;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var s;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],J=new RegExp(`^[${W.join("")}]+`),ce=7;function G(he,j){const z=j.toString(ce),Se=`${z.length<W.length?W[z.length-1]:"z"}${z}s${(0,D.encodeBase64)(D.VSBuffer.fromString(he.scheme),!0,!0)}`;return he.with({scheme:O.scheme,fragment:Se})}O.generate=G;function X(he){if(he.scheme!==O.scheme)return;const j=he.fragment.indexOf("s");if(j<0)return;const z=parseInt(he.fragment.substring(0,j).replace(J,""),ce),ne=(0,D.decodeBase64)(he.fragment.substring(j+1)).toString();if(!isNaN(z))return{handle:z,notebook:he.with({scheme:ne,fragment:null})}}O.parse=X;function Y(he,j){return he.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${j??""},${he.scheme!==R.Schemas.file?he.scheme:""}`})}O.generateCellOutputUri=Y;function se(he){if(he.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const j=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!j)return;const z=j[1]&&j[1]!==""?j[1]:void 0,ne=j[2];return{outputId:z,notebook:he.with({scheme:ne||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=se;function Q(he,j,z){return O.generate(he,j).with({scheme:z})}O.generateCellPropertyUri=Q;function we(he,j){if(he.scheme===j)return O.parse(he.with({scheme:O.scheme}))}O.parseCellPropertyUri=we})(n||(e.CellUri=n={}));const o=O=>p.isWindows?O.replace(/\//g,"\\"):O;class a{constructor(W=[],J=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=J,this.order=[...new Set(W)].map(ce=>({pattern:ce,matches:N.parse(o(ce))}))}sort(W){const J=new Map(m.Iterable.map(W,G=>[G,o(G)]));let ce=[];for(const{matches:G}of this.order)for(const[X,Y]of J)if(G(Y)){ce.push(X),J.delete(X);break}return J.size&&(ce=ce.concat([...J.keys()].sort((G,X)=>this.defaultOrder.indexOf(G)-this.defaultOrder.indexOf(X)))),ce}prioritize(W,J){const ce=this.findIndex(W);if(ce===-1){this.order.unshift({pattern:W,matches:N.parse(o(W))});return}const G=new Set(J.map(Y=>this.findIndex(Y,ce)));G.delete(-1);const X=Array.from(G).sort();this.order.splice(ce+1,0,...X.map(Y=>this.order[Y]));for(let Y=X.length-1;Y>=0;Y--)this.order.splice(X[Y],1)}toArray(){return this.order.map(W=>W.pattern)}findIndex(W,J=this.order.length){const ce=o(W);for(let G=0;G<J;G++)if(this.order[G].matches(ce))return G;return-1}}e.MimeTypeDisplayOrder=a;function t(O,W,J,ce=(G,X)=>G===X){const G=[];function X(Q,we,he){if(we===0&&he.length===0)return;const j=G[G.length-1];j&&j.start+j.deleteCount===Q?(j.deleteCount+=we,j.toInsert.push(...he)):G.push({start:Q,deleteCount:we,toInsert:he})}let Y=0,se=0;for(;;){if(Y===O.length){X(Y,0,W.slice(se));break}if(se===W.length){X(Y,O.length-Y,[]);break}const Q=O[Y],we=W[se];if(ce(Q,we)){Y+=1,se+=1;continue}J(we)?(X(Y,1,[]),Y+=1):(X(Y,0,[we]),se+=1)}return G}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function h(O){const W=O;return!!((typeof W.include=="string"||N.isRelativePattern(W.include))&&(typeof W.exclude=="string"||N.isRelativePattern(W.exclude)))}e.isDocumentExcludePattern=h;function u(O,W,J){if(Array.isArray(O.viewType)&&O.viewType.indexOf(W)>=0||O.viewType===W)return!0;if(O.filenamePattern){const ce=h(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,G=h(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(N.match(ce,(0,v.basename)(J.fsPath).toLowerCase()))return!(G&&N.match(G,(0,v.basename)(J.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var c;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class d{static{this._prefix="notebook/"}static create(W){return`${d._prefix}${W}`}static parse(W){if(W.startsWith(d._prefix))return W.substring(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d;function y(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.isTextStreamMime=y;const A=new TextDecoder;function E(O){const W=[];let J=!1;for(const Y of O)(W.length===0||J)&&(W.push(Y),J=!0);let ce=T(W);const G=D.VSBuffer.concat(W.map(Y=>D.VSBuffer.wrap(Y))),X=F(G);return ce=ce||X.byteLength!==G.byteLength,{data:X,didCompression:ce}}e.compressOutputItemStreams=E,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const b=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(O=>O.charCodeAt(0)),_=10;function T(O){let W=!1;return O.forEach((J,ce)=>{if(ce===0||J.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const G=O[ce-1],X=J.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(X[0]===b[0]&&X[1]===b[1]&&X[2]===b[2]){const Y=G.lastIndexOf(_);if(Y===-1)return;W=!0,O[ce-1]=G.subarray(0,Y),O[ce]=J.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),W}function U(O){let W=O;do O=W,W=O.replace(/[^\n]\x08/gm,"");while(W.length<O.length);return O}function M(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const W=O.match(/^(.*)\r+/m)[1];let J=O.match(/\r+(.*)$/m)[1];J=J+W.slice(J.length,W.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,J)}return O}const P="\b".charCodeAt(0),x="\r".charCodeAt(0);function F(O){return!O.buffer.includes(P)&&!O.buffer.includes(x)?O:D.VSBuffer.fromString(M(U(A.decode(O.buffer))))}}),define(ye[7],Ce([1,0,19,8,80,28,100,13,18,2,30,26,32,64,111]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C){"use strict";var l,f,s,i,n,o,a,t,r,h,u,c,d,y,A,E,b;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.ChatMessage=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.ChatAgentCompletionItem=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function _(V){return Object.assign(V,{apply:function(...be){if(be.length===0)return Reflect.construct(V,[]);{const Oe=be.length===1?[]:be[1];return Reflect.construct(V,Oe,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(V,[]);{const[Oe,...Ye]=be;return Reflect.construct(V,Ye,Oe.constructor)}}})}var T;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var U;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(U||(e.TerminalQuickFixType=U={}));let M=l=class{static from(...$){let be=$;return new l(function(){if(be){for(const Oe of be)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();be=void 0}})}#e;constructor($){this.#e=$}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=M,e.Disposable=M=l=Ge([_],M);let P=f=class{static Min(...$){if($.length===0)throw new TypeError;let be=$[0];for(let Oe=1;Oe<$.length;Oe++){const Ye=$[Oe];Ye.isBefore(be)&&(be=Ye)}return be}static Max(...$){if($.length===0)throw new TypeError;let be=$[0];for(let Oe=1;Oe<$.length;Oe++){const Ye=$[Oe];Ye.isAfter(be)&&(be=Ye)}return be}static isPosition($){if(!$)return!1;if($ instanceof f)return!0;const{line:be,character:Oe}=$;return typeof be=="number"&&typeof Oe=="number"}static of($){if($ instanceof f)return $;if(this.isPosition($))return new f($.line,$.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor($,be){if($<0)throw(0,N.illegalArgument)("line must be non-negative");if(be<0)throw(0,N.illegalArgument)("character must be non-negative");this._line=$,this._character=be}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,be=0){if($===null||be===null)throw(0,N.illegalArgument)();let Oe;return typeof $>"u"?Oe=0:typeof $=="number"?Oe=$:(Oe=typeof $.lineDelta=="number"?$.lineDelta:0,be=typeof $.characterDelta=="number"?$.characterDelta:0),Oe===0&&be===0?this:new f(this.line+Oe,this.character+be)}with($,be=this.character){if($===null||be===null)throw(0,N.illegalArgument)();let Oe;return typeof $>"u"?Oe=this.line:typeof $=="number"?Oe=$:(Oe=typeof $.line=="number"?$.line:this.line,be=typeof $.character=="number"?$.character:this.character),Oe===this.line&&be===this.character?this:new f(Oe,be)}toJSON(){return{line:this.line,character:this.character}}};e.Position=P,e.Position=P=f=Ge([_],P);let x=s=class{static isRange($){return $ instanceof s?!0:$?P.isPosition($.start)&&P.isPosition($.end):!1}static of($){if($ instanceof s)return $;if(this.isRange($))return new s($.start,$.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor($,be,Oe,Ye){let nt,lt;if(typeof $=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(nt=new P($,be),lt=new P(Oe,Ye)):P.isPosition($)&&P.isPosition(be)&&(nt=P.of($),lt=P.of(be)),!nt||!lt)throw new Error("Invalid arguments");nt.isBefore(lt)?(this._start=nt,this._end=lt):(this._start=lt,this._end=nt)}contains($){return s.isRange($)?this.contains($.start)&&this.contains($.end):P.isPosition($)?!(P.of($).isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const be=P.Max($.start,this._start),Oe=P.Min($.end,this._end);if(!be.isAfter(Oe))return new s(be,Oe)}union($){if(this.contains($))return this;if($.contains(this))return $;const be=P.Min($.start,this._start),Oe=P.Max($.end,this.end);return new s(be,Oe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,be=this.end){if($===null||be===null)throw(0,N.illegalArgument)();let Oe;return $?P.isPosition($)?Oe=$:(Oe=$.start||this.start,be=$.end||this.end):Oe=this.start,Oe.isEqual(this._start)&&be.isEqual(this.end)?this:new s(Oe,be)}toJSON(){return[this.start,this.end]}};e.Range=x,e.Range=x=s=Ge([_],x);let F=i=class extends x{static isSelection($){return $ instanceof i?!0:$?x.isRange($)&&P.isPosition($.anchor)&&P.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor($,be,Oe,Ye){let nt,lt;if(typeof $=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(nt=new P($,be),lt=new P(Oe,Ye)):P.isPosition($)&&P.isPosition(be)&&(nt=P.of($),lt=P.of(be)),!nt||!lt)throw new Error("Invalid arguments");super(nt,lt),this._anchor=nt,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=F,e.Selection=F=i=Ge([_],F);const O=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,N.illegalArgument)("connectionToken")};class W{static isResolvedAuthority($){return $&&typeof $=="object"&&typeof $.host=="string"&&typeof $.port=="number"&&($.connectionToken===void 0||typeof $.connectionToken=="string")}constructor($,be,Oe){if(typeof $!="string"||$.length===0)throw(0,N.illegalArgument)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,N.illegalArgument)("port");typeof Oe<"u"&&O(Oe),this.host=$,this.port=Math.round(be),this.connectionToken=Oe}}e.ResolvedAuthority=W;class J{static isManagedResolvedAuthority($){return $&&typeof $=="object"&&typeof $.makeConnection=="function"&&($.connectionToken===void 0||typeof $.connectionToken=="string")}constructor($,be){this.makeConnection=$,this.connectionToken=be,typeof be<"u"&&O(be)}}e.ManagedResolvedAuthority=J;class ce extends Error{static NotAvailable($,be){return new ce($,w.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable($){return new ce($,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor($,be=w.RemoteAuthorityResolverErrorCode.Unknown,Oe){super($),this._message=$,this._code=be,this._detail=Oe,Object.setPrototypeOf(this,ce.prototype)}}e.RemoteAuthorityResolverError=ce;var G;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var X;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let Y=n=class{static isTextEdit($){return $ instanceof n?!0:$?x.isRange($)&&typeof $.newText=="string":!1}static replace($,be){return new n($,be)}static insert($,be){return n.replace(new x($,$),be)}static delete($){return n.replace($,"")}static setEndOfLine($){const be=new n(new x(new P(0,0),new P(0,0)),"");return be.newEol=$,be}get range(){return this._range}set range($){if($&&!x.isRange($))throw(0,N.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,N.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,N.illegalArgument)("newEol");this._newEol=$}constructor($,be){this._range=$,this._newText=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Y,e.TextEdit=Y=n=Ge([_],Y);let se=o=class{static isNotebookCellEdit($){return $ instanceof o?!0:$?Zt.isNotebookRange($)&&Array.isArray($.newCells):!1}static replaceCells($,be){return new o($,be)}static insertCells($,be){return new o(new Zt($,$),be)}static deleteCells($){return new o($,[])}static updateCellMetadata($,be){const Oe=new o(new Zt($,$),[]);return Oe.newCellMetadata=be,Oe}static updateNotebookMetadata($){const be=new o(new Zt(0,0),[]);return be.newNotebookMetadata=$,be}constructor($,be){this.range=$,this.newCells=be}};e.NotebookEdit=se,e.NotebookEdit=se=o=Ge([_],se);class Q{static isSnippetTextEdit($){return $ instanceof Q?!0:$?x.isRange($.range)&&j.isSnippetString($.snippet):!1}static replace($,be){return new Q($,be)}static insert($,be){return Q.replace(new x($,$),be)}constructor($,be){this.range=$,this.snippet=be}}e.SnippetTextEdit=Q;var we;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let he=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,be,Oe,Ye){this._edits.push({_type:1,from:$,to:be,options:Oe,metadata:Ye})}createFile($,be,Oe){this._edits.push({_type:1,from:void 0,to:$,options:be,metadata:Oe})}deleteFile($,be,Oe){this._edits.push({_type:1,from:$,to:void 0,options:be,metadata:Oe})}replaceNotebookMetadata($,be,Oe){this._edits.push({_type:3,metadata:Oe,uri:$,edit:{editType:5,metadata:be},notebookMetadata:be})}replaceNotebookCells($,be,Oe,Ye){const nt=be.start,lt=be.end;(nt!==lt||Oe.length>0)&&this._edits.push({_type:5,uri:$,index:nt,count:lt-nt,cells:Oe,metadata:Ye})}replaceNotebookCellMetadata($,be,Oe,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:3,index:be,metadata:Oe}})}replace($,be,Oe,Ye){this._edits.push({_type:2,uri:$,edit:new Y(be,Oe),metadata:Ye})}insert($,be,Oe,Ye){this.replace($,new x(be,be),Oe,Ye)}delete($,be,Oe){this.replace($,be,"",Oe)}has($){return this._edits.some(be=>be._type===2&&be.uri.toString()===$.toString())}set($,be){if(be)for(const Oe of be){if(!Oe)continue;let Ye,nt;Array.isArray(Oe)?(Ye=Oe[0],nt=Oe[1]):Ye=Oe,se.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.replaceNotebookCellMetadata($,Ye.range.start,Ye.newCellMetadata,nt):Ye.newNotebookMetadata?this.replaceNotebookMetadata($,Ye.newNotebookMetadata,nt):this.replaceNotebookCells($,Ye.range,Ye.newCells,nt):Q.isSnippetTextEdit(Ye)?this._edits.push({_type:6,uri:$,range:Ye.range,edit:Ye.snippet,metadata:nt}):this._edits.push({_type:2,uri:$,edit:Ye,metadata:nt})}else{for(let Oe=0;Oe<this._edits.length;Oe++){const Ye=this._edits[Oe];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===$.toString()&&(this._edits[Oe]=void 0);break}}(0,D.coalesceInPlace)(this._edits)}}get($){const be=[];for(const Oe of this._edits)Oe._type===2&&Oe.uri.toString()===$.toString()&&be.push(Oe.edit);return be}entries(){const $=new k.ResourceMap;for(const be of this._edits)if(be._type===2){let Oe=$.get(be.uri);Oe||(Oe=[be.uri,[]],$.set(be.uri,Oe)),Oe[1].push(be.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=he,e.WorkspaceEdit=he=Ge([_],he);let j=a=class{static isSnippetString($){return $ instanceof a?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}constructor($){this._tabstop=1,this.value=$||""}appendText($){return this.value+=a._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,be=this._tabstop++){if(typeof $=="function"){const Oe=new a;Oe._tabstop=this._tabstop,$(Oe),this._tabstop=Oe._tabstop,$=Oe.value}else $=a._escape($);return this.value+="${",this.value+=be,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,be=this._tabstop++){const Oe=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable($,be){if(typeof be=="function"){const Oe=new a;Oe._tabstop=this._tabstop,be(Oe),this._tabstop=Oe._tabstop,be=Oe.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.SnippetString=j,e.SnippetString=j=a=Ge([_],j);var z;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var ne;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Se=t=class{static isLocation($){return $ instanceof t?!0:$?x.isRange($.range)&&S.URI.isUri($.uri):!1}constructor($,be){if(this.uri=$,be)if(x.isRange(be))this.range=x.of(be);else if(P.isPosition(be))this.range=new x(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Se,e.Location=Se=t=Ge([_],Se);let de=class{static is($){return $?typeof $.message=="string"&&$.location&&x.isRange($.location.range)&&S.URI.isUri($.location.uri):!1}constructor($,be){this.location=$,this.message=be}static isEqual($,be){return $===be?!0:!$||!be?!1:$.message===be.message&&$.location.range.isEqual(be.location.range)&&$.location.uri.toString()===be.location.uri.toString()}};e.DiagnosticRelatedInformation=de,e.DiagnosticRelatedInformation=de=Ge([_],de);let me=class{constructor($,be,Oe=ne.Error){if(!x.isRange($))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=$,this.message=be,this.severity=Oe}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,be){return $===be?!0:!$||!be?!1:$.message===be.message&&$.severity===be.severity&&$.code===be.code&&$.severity===be.severity&&$.source===be.source&&$.range.isEqual(be.range)&&(0,D.equals)($.tags,be.tags)&&(0,D.equals)($.relatedInformation,be.relatedInformation,de.isEqual)}};e.Diagnostic=me,e.Diagnostic=me=Ge([_],me);let Z=class{constructor($,be){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=be}};e.Hover=Z,e.Hover=Z=Ge([_],Z);var ie;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let q=class{constructor($,be=ie.Text){this.range=$,this.kind=be}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.DocumentHighlight=q,e.DocumentHighlight=q=Ge([_],q);let te=class{constructor($,be){this.uri=$,this.highlights=be}toJSON(){return{uri:this.uri,highlights:this.highlights.map($=>$.toJSON())}}};e.MultiDocumentHighlight=te,e.MultiDocumentHighlight=te=Ge([_],te);var fe;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var Ee;(function(V){V[V.Deprecated=1]="Deprecated"})(Ee||(e.SymbolTag=Ee={}));let Te=r=class{static validate($){if(!$.name)throw new Error("name must not be falsy")}constructor($,be,Oe,Ye,nt){this.name=$,this.kind=be,this.containerName=nt,typeof Oe=="string"&&(this.containerName=Oe),Ye instanceof Se?this.location=Ye:Oe instanceof x&&(this.location=new Se(Ye,Oe)),r.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Te,e.SymbolInformation=Te=r=Ge([_],Te);let ve=h=class{static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children?.forEach(h.validate)}constructor($,be,Oe,Ye,nt){this.name=$,this.detail=be,this.kind=Oe,this.range=Ye,this.selectionRange=nt,this.children=[],h.validate(this)}};e.DocumentSymbol=ve,e.DocumentSymbol=ve=h=Ge([_],ve);var De;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let B=class{constructor($,be){this.title=$,this.kind=be}};e.CodeAction=B,e.CodeAction=B=Ge([_],B);let K=class{static{u=this}static{this.sep="."}constructor($){this.value=$}append($){return new u(this.value?this.value+u.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+u.sep)}};e.CodeActionKind=K,e.CodeActionKind=K=u=Ge([_],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let ee=class{constructor($,be){if(this.range=$,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=ee,e.SelectionRange=ee=Ge([_],ee);class H{constructor($,be,Oe,Ye,nt,lt){this.kind=$,this.name=be,this.detail=Oe,this.uri=Ye,this.range=nt,this.selectionRange=lt}}e.CallHierarchyItem=H;class ae{constructor($,be){this.fromRanges=be,this.from=$}}e.CallHierarchyIncomingCall=ae;class ue{constructor($,be){this.fromRanges=be,this.to=$}}e.CallHierarchyOutgoingCall=ue;var Ae;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let xe=class{constructor($,be){this.range=$,this.command=be}get isResolved(){return!!this.command}};e.CodeLens=xe,e.CodeLens=xe=Ge([_],xe);let je=c=class{#e;static isMarkdownString($){return $ instanceof c?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}constructor($,be=!1){this.#e=new m.MarkdownString($,{supportThemeIcons:be})}get value(){return this.#e.value}set value($){this.#e.value=$}get isTrusted(){return this.#e.isTrusted}set isTrusted($){this.#e.isTrusted=$}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons($){this.#e.supportThemeIcons=$}get supportHtml(){return this.#e.supportHtml}set supportHtml($){this.#e.supportHtml=$}get baseUri(){return this.#e.baseUri}set baseUri($){this.#e.baseUri=$}appendText($){return this.#e.appendText($),this}appendMarkdown($){return this.#e.appendMarkdown($),this}appendCodeblock($,be){return this.#e.appendCodeblock(be??"",$),this}};e.MarkdownString=je,e.MarkdownString=je=c=Ge([_],je);let Ke=class{constructor($,be){this.label=$,this.documentation=be}};e.ParameterInformation=Ke,e.ParameterInformation=Ke=Ge([_],Ke);let Ze=class{constructor($,be){this.label=$,this.documentation=be,this.parameters=[]}};e.SignatureInformation=Ze,e.SignatureInformation=Ze=Ge([_],Ze);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=at,e.SignatureHelp=at=Ge([_],at);var ot;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var ke;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(ke||(e.InlayHintKind=ke={}));let Ue=class{constructor($){this.value=$}};e.InlayHintLabelPart=Ue,e.InlayHintLabelPart=Ue=Ge([_],Ue);let $e=class{constructor($,be,Oe){this.position=$,this.label=be,this.kind=Oe}};e.InlayHint=$e,e.InlayHint=$e=Ge([_],$e);var Re;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Re||(e.CompletionTriggerKind=Re={}));var et;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(et||(e.CompletionItemKind=et={}));var oe;(function(V){V[V.Deprecated=1]="Deprecated"})(oe||(e.CompletionItemTag=oe={}));let le=class{constructor($,be){this.label=$,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&et[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=le,e.CompletionItem=le=Ge([_],le);let Pe=class{constructor($=[],be=!1){this.items=$,this.isIncomplete=be}};e.CompletionList=Pe,e.CompletionList=Pe=Ge([_],Pe);let Ve=class{constructor($,be,Oe){this.insertText=$,this.range=be,this.command=Oe}};e.InlineSuggestion=Ve,e.InlineSuggestion=Ve=Ge([_],Ve);let Qe=class{constructor($){this.commands=void 0,this.suppressSuggestions=void 0,this.items=$}};e.InlineSuggestionList=Qe,e.InlineSuggestionList=Qe=Ge([_],Qe);var it;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var st;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Me(V,$){return`${I.ExtensionIdentifier.toKey(V)}.${$}`}e.asStatusBarItemIdentifier=Me;var wt;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var Dt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Vt;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var Bt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var St;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var Ht;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(V){function $(be){switch(be){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=$}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Ot;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(V){function $(be){switch(be){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=$}(Ot||(e.SyntaxTokenType=Ot={}));let Kt=class{constructor($,be){if(be&&!S.URI.isUri(be))throw(0,N.illegalArgument)("target");if(!x.isRange($)||$.isEmpty)throw(0,N.illegalArgument)("range");this.range=$,this.target=be}};e.DocumentLink=Kt,e.DocumentLink=Kt=Ge([_],Kt);let Mt=class{constructor($,be,Oe,Ye){this.red=$,this.green=be,this.blue=Oe,this.alpha=Ye}};e.Color=Mt,e.Color=Mt=Ge([_],Mt);let Pt=class{constructor($,be){if(be&&!(be instanceof Mt))throw(0,N.illegalArgument)("color");if(!x.isRange($)||$.isEmpty)throw(0,N.illegalArgument)("range");this.range=$,this.color=be}};e.ColorInformation=Pt,e.ColorInformation=Pt=Ge([_],Pt);let tt=class{constructor($){if(!$||typeof $!="string")throw(0,N.illegalArgument)("label");this.label=$}};e.ColorPresentation=tt,e.ColorPresentation=tt=Ge([_],tt);var jt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var qt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var ut;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class pt{constructor($,be,Oe){if(this.startIndex=$,this.length=be,this.tooltip=Oe,typeof $!="number"||$<0)throw(0,N.illegalArgument)("startIndex");if(typeof be!="number"||be<1)throw(0,N.illegalArgument)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,N.illegalArgument)("tooltip")}}e.TerminalLink=pt;class xt{constructor($){this.uri=$}}e.TerminalQuickFixOpener=xt;class zt{constructor($){this.terminalCommand=$}}e.TerminalQuickFixCommand=zt;var yt;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(yt||(e.TerminalLocation=yt={}));class ht{constructor($){if(this.options=$,typeof $!="object")throw(0,N.illegalArgument)("options")}}e.TerminalProfile=ht;var Tt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Tt||(e.TaskRevealKind=Tt={}));var Yt;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Yt||(e.TaskPanelKind=Yt={}));let Ct=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from($){switch($){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor($,be){if(this.label=be,typeof $!="string"||typeof be!="string")throw(0,N.illegalArgument)("name");this._id=$}get id(){return this._id}};e.TaskGroup=Ct,e.TaskGroup=Ct=d=Ge([_],Ct);function Xe(V){let $="";for(let be=0;be<V.length;be++)$+=V[be].replace(/,/g,",,")+",";return $}let Rt=class{constructor($,be,Oe){if(typeof $!="string")throw(0,N.illegalArgument)("process");this._args=[],this._process=$,be!==void 0&&(Array.isArray(be)?(this._args=be,this._options=Oe):this._options=be)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,N.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(const be of this._args)$.push(be);return Xe($)}};e.ProcessExecution=Rt,e.ProcessExecution=Rt=Ge([_],Rt);let Wt=class{constructor($,be,Oe){if(this._args=[],Array.isArray(be)){if(!$)throw(0,N.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,N.illegalArgument)("command");this._command=$,this._args=be,this._options=Oe}else{if(typeof $!="string")throw(0,N.illegalArgument)("commandLine");this._commandLine=$,this._options=be}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,N.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,N.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const be of this._args)$.push(typeof be=="string"?be:be.value);return Xe($)}};e.ShellExecution=Wt,e.ShellExecution=Wt=Ge([_],Wt);var Gt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Gt||(e.ShellQuoting=Gt={}));var mt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(mt||(e.TaskScope=mt={}));class Lt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Lt;let Le=class{static{y=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor($,be,Oe,Ye,nt,lt){this.__deprecated=!1,this._definition=this.definition=$;let ft;typeof be=="string"?(this._name=this.name=be,this._source=this.source=Oe,this.execution=Ye,ft=nt,this.__deprecated=!0):be===mt.Global||be===mt.Workspace?(this.target=be,this._name=this.name=Oe,this._source=this.source=Ye,this.execution=nt,ft=lt):(this.target=be,this._name=this.name=Oe,this._source=this.source=Ye,this.execution=nt,ft=lt),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Rt?this._definition={type:y.ProcessType,id:this._execution.computeId()}:this._execution instanceof Wt?this._definition={type:y.ShellType,id:this._execution.computeId()}:this._execution instanceof Lt?this._definition={type:y.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:y.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,N.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,N.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const be=this._definition.type;(y.EmptyType===be||y.ProcessType===be||y.ShellType===be||y.ExtensionCallbackType===be)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,N.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};e.Task=Le,e.Task=Le=y=Ge([_],Le);var Ne;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Ne||(e.ProgressLocation=Ne={}));var Ie;(function(V){function $(be){const Oe=be;return(0,p.isNumber)(Oe.value)?Oe.tooltip&&!(0,p.isString)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}V.isViewBadge=$})(Ie||(e.ViewBadge=Ie={}));let re=A=class{static isTreeItem($,be){const Oe=$;if(Oe.checkboxState!==void 0){const Ye=(0,p.isNumber)(Oe.checkboxState)?Oe.checkboxState:(0,p.isObject)(Oe.checkboxState)&&(0,p.isNumber)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,nt=!(0,p.isNumber)(Oe.checkboxState)&&(0,p.isObject)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==He.Checked&&Ye!==He.Unchecked||nt!==void 0&&!(0,p.isString)(nt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if($ instanceof A)return!0;if(Oe.label!==void 0&&!(0,p.isString)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,p.isString)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,p.isString)(Oe.iconPath)&&!S.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,p.isString)(Oe.iconPath.id))){const Ye=Oe.iconPath;if(!Ye||!(0,p.isString)(Ye.light)&&!S.URI.isUri(Ye.light)&&!(0,p.isString)(Ye.dark)&&!S.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,p.isString)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!S.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,p.isString)(Oe.tooltip)&&!(Oe.tooltip instanceof je)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<Fe.None&&Oe.collapsibleState>Fe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,p.isString)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor($,be=Fe.None){this.collapsibleState=be,S.URI.isUri($)?this.resourceUri=$:this.label=$}};e.TreeItem=re,e.TreeItem=re=A=Ge([_],re);var Fe;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Fe||(e.TreeItemCollapsibleState=Fe={}));var He;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(He||(e.TreeItemCheckboxState=He={}));let Je=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor($){this.value=$}};e.DataTransferItem=Je,e.DataTransferItem=Je=Ge([_],Je);class qe extends Je{}e.InternalDataTransferItem=qe;class rt extends qe{#e;constructor($){super(""),this.#e=$}asFile(){return this.#e}}e.InternalFileDataTransferItem=rt;class gt{constructor($,be,Oe,Ye){this.name=$,this.uri=be,this._itemId=Oe,this._getData=Ye}data(){return this._getData()}}e.DataTransferFile=gt;let Ut=class{#e=new Map;constructor($){for(const[be,Oe]of $??[]){const Ye=this.#e.get(this.#t(be));Ye?Ye.push(Oe):this.#e.set(this.#t(be),[Oe])}}get($){return this.#e.get(this.#t($))?.[0]}set($,be){this.#e.set(this.#t($),[be])}forEach($,be){for(const[Oe,Ye]of this.#e)for(const nt of Ye)$.call(be,nt,Oe,this)}*[Symbol.iterator](){for(const[$,be]of this.#e)for(const Oe of be)yield[$,Oe]}#t($){return $.toLowerCase()}};e.DataTransfer=Ut,e.DataTransfer=Ut=Ge([_],Ut);let _t=class{constructor($){this.insertText=$}};e.DocumentDropEdit=_t,e.DocumentDropEdit=_t=Ge([_],_t);let It=class{constructor($,be){this.label=be,this.insertText=$}};e.DocumentPasteEdit=It,e.DocumentPasteEdit=It=Ge([_],It);let Et=class{constructor($,be){this.id=$,this.color=be}static isThemeIcon($){return typeof $.id!="string"?(console.log("INVALID ThemeIcon, invalid id",$.id),!1):!0}};e.ThemeIcon=Et,e.ThemeIcon=Et=Ge([_],Et),Et.File=new Et("file"),Et.Folder=new Et("folder");let gi=class{constructor($){this.id=$}};e.ThemeColor=gi,e.ThemeColor=gi=Ge([_],gi);var At;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Ci=class{get base(){return this._base}set base($){this._base=$,this._baseUri=S.URI.file($)}get baseUri(){return this._baseUri}set baseUri($){this._baseUri=$,this._base=$.fsPath}constructor($,be){if(typeof $!="string"&&(!$||!S.URI.isUri($)&&!S.URI.isUri($.uri)))throw(0,N.illegalArgument)("base");if(typeof be!="string")throw(0,N.illegalArgument)("pattern");typeof $=="string"?this.baseUri=S.URI.file($):S.URI.isUri($)?this.baseUri=$:this.baseUri=$.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ci,e.RelativePattern=Ci=Ge([_],Ci);const $i=new WeakMap;function kt(V,$){$i.set(V,$)}e.setBreakpointId=kt;let ni=class{constructor($,be,Oe,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof be=="string"&&(this.condition=be),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=$i.get(this)??(0,L.generateUuid)()),this._id}};e.Breakpoint=ni,e.Breakpoint=ni=Ge([_],ni);let pi=class extends ni{constructor($,be,Oe,Ye,nt){if(super(be,Oe,Ye,nt),$===null)throw(0,N.illegalArgument)("location");this.location=$}};e.SourceBreakpoint=pi,e.SourceBreakpoint=pi=Ge([_],pi);let ai=class extends ni{constructor($,be,Oe,Ye,nt){super(be,Oe,Ye,nt),this.functionName=$}};e.FunctionBreakpoint=ai,e.FunctionBreakpoint=ai=Ge([_],ai);let Di=class extends ni{constructor($,be,Oe,Ye,nt,lt,ft){if(super(Ye,nt,lt,ft),!be)throw(0,N.illegalArgument)("dataId");this.label=$,this.dataId=be,this.canPersist=Oe}};e.DataBreakpoint=Di,e.DataBreakpoint=Di=Ge([_],Di);let Ii=class{constructor($,be,Oe){this.command=$,this.args=be||[],this.options=Oe}};e.DebugAdapterExecutable=Ii,e.DebugAdapterExecutable=Ii=Ge([_],Ii);let Ft=class{constructor($,be){this.port=$,this.host=be}};e.DebugAdapterServer=Ft,e.DebugAdapterServer=Ft=Ge([_],Ft);let vi=class{constructor($){this.path=$}};e.DebugAdapterNamedPipeServer=vi,e.DebugAdapterNamedPipeServer=vi=Ge([_],vi);let ki=class{constructor($){this.implementation=$}};e.DebugAdapterInlineImplementation=ki,e.DebugAdapterInlineImplementation=ki=Ge([_],ki);let ci=class{constructor($,be,Oe){this.session=$,this.threadId=be,this.frameId=Oe}};e.StackFrameFocus=ci,e.StackFrameFocus=ci=Ge([_],ci);let li=class{constructor($,be){this.session=$,this.threadId=be}};e.ThreadFocus=li,e.ThreadFocus=li=Ge([_],li);let dt=class{constructor($,be){this.range=$,this.expression=be}};e.EvaluatableExpression=dt,e.EvaluatableExpression=dt=Ge([_],dt);var Hi;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Hi||(e.InlineCompletionTriggerKind=Hi={}));let Jt=class{constructor($,be){this.range=$,this.text=be}};e.InlineValueText=Jt,e.InlineValueText=Jt=Ge([_],Jt);let ri=class{constructor($,be,Oe=!0){this.range=$,this.variableName=be,this.caseSensitiveLookup=Oe}};e.InlineValueVariableLookup=ri,e.InlineValueVariableLookup=ri=Ge([_],ri);let hi=class{constructor($,be){this.range=$,this.expression=be}};e.InlineValueEvaluatableExpression=hi,e.InlineValueEvaluatableExpression=hi=Ge([_],hi);let Pi=class{constructor($,be){this.frameId=$,this.stoppedLocation=be}};e.InlineValueContext=Pi,e.InlineValueContext=Pi=Ge([_],Pi);var Vi;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let Ti=E=class extends Error{static FileExists($){return new E($,g.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound($){return new E($,g.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory($){return new E($,g.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory($){return new E($,g.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions($){return new E($,g.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable($){return new E($,g.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}constructor($,be=g.FileSystemProviderErrorCode.Unknown,Oe){super(S.URI.isUri($)?$.toString(!0):$),this.code=Oe?.name??"Unknown",(0,g.markAsFileSystemProviderError)(this,be),Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.FileSystemError=Ti,e.FileSystemError=Ti=E=Ge([_],Ti);let bi=class{constructor($,be,Oe){this.start=$,this.end=be,this.kind=Oe}};e.FoldingRange=bi,e.FoldingRange=bi=Ge([_],bi);var ji;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(ji||(e.FoldingRangeKind=ji={}));var Ai;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var qi;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(qi||(e.CommentState=qi={}));var Ei;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(Ei||(e.CommentThreadState=Ei={}));class Ri{constructor($,be=[]){this.tokenTypes=$,this.tokenModifiers=be}}e.SemanticTokensLegend=Ri;function cn(V){return typeof V>"u"||(0,p.isStringArray)(V)}class Li{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let be=0,Oe=$.tokenTypes.length;be<Oe;be++)this._tokenTypeStrToInt.set($.tokenTypes[be],be);for(let be=0,Oe=$.tokenModifiers.length;be<Oe;be++)this._tokenModifierStrToInt.set($.tokenModifiers[be],be)}}push($,be,Oe,Ye,nt){if(typeof $=="number"&&typeof be=="number"&&typeof Oe=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this._pushEncoded($,be,Oe,Ye,nt);if(x.isRange($)&&typeof be=="string"&&cn(Oe))return this._push($,be,Oe);throw(0,N.illegalArgument)()}_push($,be,Oe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(be))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,nt=$.start.character,lt=$.end.character-$.start.character,ft=this._tokenTypeStrToInt.get(be);let $t=0;if(Oe)for(const Qt of Oe){if(!this._tokenModifierStrToInt.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this._tokenModifierStrToInt.get(Qt);$t|=1<<ti>>>0}this._pushEncoded(Ye,nt,lt,ft,$t)}_pushEncoded($,be,Oe,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&be<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const $t=this._data.length/5|0;let Qt=0,ti=0;for(let ii=0;ii<$t;ii++){let oi=this._data[5*ii],zi=this._data[5*ii+1];oi===0?(oi=Qt,zi+=ti):oi+=Qt,this._data[5*ii]=oi,this._data[5*ii+1]=zi,Qt=oi,ti=zi}}let lt=$,ft=be;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Oe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=$,this._prevChar=be}static _sortAndDeltaEncode($){const be=[],Oe=$.length/5|0;for(let ft=0;ft<Oe;ft++)be[ft]=ft;be.sort((ft,$t)=>{const Qt=$[5*ft],ti=$[5*$t];if(Qt===ti){const ii=$[5*ft+1],oi=$[5*$t+1];return ii-oi}return Qt-ti});const Ye=new Uint32Array($.length);let nt=0,lt=0;for(let ft=0;ft<Oe;ft++){const $t=5*be[ft],Qt=$[$t+0],ti=$[$t+1],ii=$[$t+2],oi=$[$t+3],zi=$[$t+4],Cn=Qt-nt,Mn=Cn===0?ti-lt:ti,Wi=5*ft;Ye[Wi+0]=Cn,Ye[Wi+1]=Mn,Ye[Wi+2]=ii,Ye[Wi+3]=oi,Ye[Wi+4]=zi,nt=Qt,lt=ti}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new si(new Uint32Array(this._data),$):new si(Li._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Li;class si{constructor($,be){this.resultId=be,this.data=$}}e.SemanticTokens=si;class ln{constructor($,be,Oe){this.start=$,this.deleteCount=be,this.data=Oe}}e.SemanticTokensEdit=ln;class un{constructor($,be){this.resultId=be,this.edits=$}}e.SemanticTokensEdits=un;var Gi;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Et("arrow-left")}}constructor(){}};e.QuickInputButtons=fi,e.QuickInputButtons=fi=Ge([_],fi);var Ki;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var Xi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var mi;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(mi||(e.ExtensionKind=mi={}));class Qi{static validate($){if(typeof $.badge=="string"){let be=(0,v.nextCharLength)($.badge,0);if(be<$.badge.length&&(be+=(0,v.nextCharLength)($.badge,be)),$.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if($.badge&&!Et.isThemeIcon($.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}constructor($,be,Oe){this.badge=$,this.tooltip=be,this.color=Oe}}e.FileDecoration=Qi;let Oi=class{constructor($){this.kind=$}};e.ColorTheme=Oi,e.ColorTheme=Oi=Ge([_],Oi);var Fi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(Fi||(e.ColorThemeKind=Fi={}));class Zt{static isNotebookRange($){return $ instanceof Zt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor($,be){if($<0)throw(0,N.illegalArgument)("start must be positive");if(be<0)throw(0,N.illegalArgument)("end must be positive");$<=be?(this._start=$,this._end=be):(this._start=be,this._end=$)}with($){let be=this._start,Oe=this._end;return $.start!==void 0&&(be=$.start),$.end!==void 0&&(Oe=$.end),be===this._start&&Oe===this._end?this:new Zt(be,Oe)}}e.NotebookRange=Zt;class wi{static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(be=>wi.isNotebookCellData(be))}static isNotebookCellData($){return!0}constructor($,be,Oe,Ye,nt,lt,ft){this.kind=$,this.value=be,this.languageId=Oe,this.mime=Ye,this.outputs=nt??[],this.metadata=lt,this.executionSummary=ft,wi.validate(this)}}e.NotebookCellData=wi;class dn{constructor($){this.cells=$}}e.NotebookData=dn;class Xt{static isNotebookCellOutputItem($){return $ instanceof Xt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const be={name:$.name,message:$.message,stack:$.stack};return Xt.json(be,"application/vnd.code.notebook.error")}static stdout($){return Xt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Xt.text($,"application/vnd.code.notebook.stderr")}static bytes($,be="application/octet-stream"){return new Xt($,be)}static#e=new TextEncoder;static text($,be=R.Mimes.text){const Oe=Xt.#e.encode(String($));return new Xt(Oe,be)}static json($,be="text/x-json"){const Oe=JSON.stringify($,void 0,"	");return Xt.text(Oe,be)}constructor($,be){this.data=$,this.mime=be;const Oe=(0,R.normalizeMimeType)(be,!0);if(!Oe)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.NotebookCellOutputItem=Xt;class Si{static isNotebookCellOutput($){return $ instanceof Si?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&Array.isArray($.items)}static ensureUniqueMimeTypes($,be=!1){const Oe=new Set,Ye=new Set;for(let nt=0;nt<$.length;nt++){const lt=$[nt],ft=(0,R.normalizeMimeType)(lt.mime);if(!Oe.has(ft)||(0,C.isTextStreamMime)(ft)){Oe.add(ft);continue}Ye.add(nt),be&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?$:$.filter((nt,lt)=>!Ye.has(lt))}constructor($,be,Oe){this.items=Si.ensureUniqueMimeTypes($,!0),typeof be=="string"?(this.id=be,this.metadata=Oe):(this.id=(0,L.generateUuid)(),this.metadata=be??Oe)}}e.NotebookCellOutput=Si;var _i;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(_i||(e.NotebookCellKind=_i={}));var Ni;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Ni||(e.NotebookCellExecutionState=Ni={}));var ze;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ze||(e.NotebookCellStatusBarAlignment=ze={}));var ei;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Yi{constructor($,be){this.text=$,this.alignment=be}}e.NotebookCellStatusBarItem=Yi;var vt;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(vt||(e.NotebookControllerAffinity=vt={}));var Ji;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(Ji||(e.NotebookControllerAffinity2=Ji={}));class hn{constructor($,be=[]){this.uri=$,this.provides=(0,D.asArray)(be)}}e.NotebookRendererScript=hn;class Zi{constructor($){this.label=$}}e.NotebookKernelSourceAction=Zi;var en;(function(V){V[V.Named=1]="Named",V[V.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let di=class{constructor($,be){this.label=$,this.timestamp=be}};e.TimelineItem=di,e.TimelineItem=di=Ge([_],di);var tn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor($,be){this.ranges=$,this.wordPattern=be}}e.LinkedEditingRanges=sn;class fn{constructor($){this._autoForwardAction=$}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=fn;var on;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Mi=class{constructor($=void 0,be=void 0,Oe=void 0,Ye=!1){this.include=$,this.exclude=be,this.profile=Oe,this.continuous=Ye}};e.TestRunRequest=Mi,e.TestRunRequest=Mi=Ge([_],Mi);let xi=b=class{static diff($,be,Oe){const Ye=new b($);return Ye.expectedOutput=be,Ye.actualOutput=Oe,Ye}constructor($){this.message=$}};e.TestMessage=xi,e.TestMessage=xi=b=Ge([_],xi);let Ui=class{constructor($){this.id=$}};e.TestTag=Ui,e.TestTag=Ui=Ge([_],Ui);class yi{constructor($,be){this.covered=$,this.total=be}}e.CoveredCount=yi;class Bi{static fromDetails($,be){const Oe=new yi(0,0),Ye=new yi(0,0),nt=new yi(0,0);for(const ft of be)if("branches"in ft){Oe.total+=1,Oe.covered+=ft.executionCount>0?1:0;for(const $t of ft.branches)Ye.total+=1,Ye.covered+=$t.executionCount>0?1:0}else nt.total+=1,nt.covered+=ft.executionCount>0?1:0;const lt=new Bi($,Oe,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return lt.detailedCoverage=be,lt}constructor($,be,Oe,Ye){this.uri=$,this.statementCoverage=be,this.branchCoverage=Oe,this.functionCoverage=Ye}}e.FileCoverage=Bi;class mn{constructor($,be,Oe=[]){this.executionCount=$,this.location=be,this.branches=Oe}}e.StatementCoverage=mn;class gn{constructor($,be){this.executionCount=$,this.location=be}}e.BranchCoverage=gn;class pe{constructor($,be,Oe){this.name=$,this.executionCount=be,this.location=Oe}}e.FunctionCoverage=pe;var _e;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(_e||(e.ExternalUriOpenerPriority=_e={}));var Be;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Be||(e.WorkspaceTrustState=Be={}));var ct;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(ct||(e.PortAutoForwardAction=ct={}));class bt{constructor($,be,Oe,Ye,nt,lt){this.kind=$,this.name=be,this.detail=Oe,this.uri=Ye,this.range=nt,this.selectionRange=lt}}e.TypeHierarchyItem=bt;class Nt{constructor($){this.uri=$}}e.TextTabInput=Nt;class Dn{constructor($,be){this.original=$,this.modified=be}}e.TextDiffTabInput=Dn;class In{constructor($,be,Oe,Ye){this.base=$,this.input1=be,this.input2=Oe,this.result=Ye}}e.TextMergeTabInput=In;class kn{constructor($,be){this.uri=$,this.viewType=be}}e.CustomEditorTabInput=kn;class Pn{constructor($){this.viewType=$}}e.WebviewEditorTabInput=Pn;class Tn{constructor($,be){this.uri=$,this.notebookType=be}}e.NotebookEditorTabInput=Tn;class An{constructor($,be,Oe){this.original=$,this.modified=be,this.notebookType=Oe}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class Ln{constructor($,be){this.uri=$,this.inputBoxUri=be}}e.InteractiveWindowInput=Ln;class On{constructor($){this.providerId=$}}e.ChatEditorTabInput=On;var pn;(function(V){V[V.Down=0]="Down",V[V.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var bn;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Fn{constructor($,be){this.label=$,this.values=be}}e.ChatAgentCompletionItem=Fn;var En;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted",V[V.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var wn;(function(V){V[V.System=0]="System",V[V.User=1]="User",V[V.Assistant=2]="Assistant",V[V.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));class Nn{constructor($,be){this.role=$,this.content=be}}e.ChatMessage=Nn;var Sn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var _n;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(_n||(e.RelatedInformationType=_n={}));var yn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(yn||(e.SpeechToTextStatus=yn={}))}),define(ye[141],Ce([1,0,60,17,13,176,126,7,19]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const S=new Map;function L(C,l){l?S.set(C,l):S.delete(C)}e.setWordDefinitionFor=L;function I(C){return S.get(C)}class g extends k.MirrorTextModel{constructor(l,f,s,i,n,o,a,t){super(f,s,i,n),this._proxy=l,this._languageId=o,this._isDirty=a,this.notebook=t,this._isDisposed=!1}dispose(){(0,D.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,p.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===N.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},save(){return l._save()},getText(f){return f?l._getTextInRange(f):l.getText()},get eol(){return l._eol===`
`?v.EndOfLine.LF:v.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(f){return l._lineAt(f)},offsetAt(f){return l._offsetAt(f)},positionAt(f){return l._positionAt(f)},validateRange(f){return l._validateRange(f)},validatePosition(f){return l._validatePosition(f)},getWordRangeAtPosition(f,s){return l._getWordRangeAtPosition(f,s)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,D.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,D.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const f=this._validateRange(l);if(f.isEmpty)return"";if(f.isSingleLine)return this._lines[f.start.line].substring(f.start.character,f.end.character);const s=this._eol,i=f.start.line,n=f.end.line,o=[];o.push(this._lines[i].substring(f.start.character));for(let a=i+1;a<n;a++)o.push(this._lines[a]);return o.push(this._lines[n].substring(0,f.end.character)),o.join(s)}_lineAt(l){let f;if(l instanceof v.Position?f=l.line:typeof l=="number"&&(f=l),typeof f!="number"||f<0||f>=this._lines.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new w(f,this._lines[f],f===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const f=this._lineStarts.getIndexOf(l),s=this._lines[f.index].length;return new v.Position(f.index,Math.min(f.remainder,s))}_validateRange(l){if(!(l instanceof v.Range))throw new Error("Invalid argument");const f=this._validatePosition(l.start),s=this._validatePosition(l.end);return f===l.start&&s===l.end?l:new v.Range(f.line,f.character,s.line,s.character)}_validatePosition(l){if(!(l instanceof v.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:f,character:s}=l,i=!1;if(f<0)f=0,s=0,i=!0;else if(f>=this._lines.length)f=this._lines.length-1,s=this._lines[f].length,i=!0;else{const n=this._lines[f].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new v.Position(f,s):l}_getWordRangeAtPosition(l,f){const s=this._validatePosition(l);if(!f)f=I(this._languageId);else if((0,m.regExpLeadsToEndlessLoop)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,R.getWordAtText)(s.character+1,(0,R.ensureValidWordDefinition)(f),this._lines[s.line],0);if(i)return new v.Range(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.ExtHostDocumentData=g;class w{constructor(l,f,s){this._line=l,this._text=f,this._isLastLine=s}get lineNumber(){return this._line}get text(){return this._text}get range(){return new v.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new v.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=w}),define(ye[285],Ce([1,0,7,20,4]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let k=class{constructor(v){this._actual=new D.ColorTheme(D.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new m.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(v){let p;switch(v){case"light":p=D.ColorThemeKind.Light;break;case"hcDark":p=D.ColorThemeKind.HighContrast;break;case"hcLight":p=D.ColorThemeKind.HighContrastLight;break;default:p=D.ColorThemeKind.Dark}this._actual=new D.ColorTheme(p),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=k,e.ExtHostTheming=k=Ge([We(0,N.IExtHostRpcService)],k)}),define(ye[286],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var N;(function(m){m[m.Output=1]="Output",m[m.OutputItems=2]="OutputItems",m[m.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.INotebookExecutionService=(0,D.createDecorator)("INotebookExecutionService")}),define(ye[287],Ce([1,0,3,29,193,99]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends D.Disposable{constructor(p,S,L){super(),this._source=p,this._inputTextBuffer=S,this._outputs=L,this._outputTextBuffers=void 0}_getFullModelRange(p){const S=p.getLineCount();return new N.Range(1,1,S,this._getLineMaxColumn(p,S))}_getLineMaxColumn(p,S){if(S<1||S>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(S)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const p=new m.PieceTreeTextBufferBuilder;p.acceptChunk(this._source);const S=p.finish(!0),{textBuffer:L,disposable:I}=S.create(1);this._inputTextBuffer=L,this._register(I)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(p=>{const S=new m.PieceTreeTextBufferBuilder;S.acceptChunk(p);const L=S.finish(!0),{textBuffer:I,disposable:g}=L.create(1);return this._register(g),I})),this._outputTextBuffers}findInInputs(p){const L=new k.SearchParams(p,!1,!1,null).parseSearchRequest();if(!L)return[];const I=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,L,!0,5e3)}findInOutputs(p){const L=new k.SearchParams(p,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(I=>{const g=I.findMatchesLineByLine(this._getFullModelRange(I),L,!0,5e3);if(g.length!==0)return{textBuffer:I,matches:g}}).filter(I=>!!I):[]}}e.CellSearchModel=R}),define(ye[67],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(k){k.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var N;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class m{static fromExtHostTestItem(R,v,p=R.parent){if(R._isRoot)return new m([v]);const S=[R.id];for(let L=p;L&&L.id!==v;L=L.parent)S.push(L.id);return S.push(v),new m(S.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const v=R.indexOf("\0");return v===-1?R:R.slice(0,v)}static fromString(R){return new m(R.split("\0"))}static join(R,v){return new m([...R.path,v])}static joinToString(R,v){return R.toString()+"\0"+v}static parentId(R){const v=R.lastIndexOf("\0");return v===-1?void 0:R.slice(0,v)}static localId(R){const v=R.lastIndexOf("\0");return v===-1?R:R.slice(v+1)}static isChild(R,v){return v.startsWith(R)&&v[R.length]==="\0"}static compare(R,v){return R===v?0:m.isChild(R,v)?2:m.isChild(v,R)?3:1}constructor(R,v=R.length){if(this.path=R,this.viewEnd=v,R.length===0||v<1)throw new Error("cannot create test with empty path")}get rootId(){return new m(this.path,1)}get parentId(){return this.viewEnd>1?new m(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new m(this.path,R)}*idsToRoot(){for(let R=this.viewEnd;R>0;R--)yield new m(this.path,R)}compare(R){if(typeof R=="string")return m.compare(this.toString(),R);for(let v=0;v<R.viewEnd&&v<this.viewEnd;v++)if(R.path[v]!==this.path[v])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=m}),define(ye[89],Ce([1,0,2,49,29,67]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(F){F[F.Unset=0]="Unset",F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var v;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(v||(e.ExtTestRunProfileKind=v={}));var p;(function(F){F[F.Run=2]="Run",F[F.Debug=4]="Debug",F[F.Coverage=8]="Coverage",F[F.HasNonDefaultProfile=16]="HasNonDefaultProfile",F[F.HasConfigurable=32]="HasConfigurable",F[F.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const S=F=>"runId"in F;e.isStartControllerTests=S;var L;(function(F){F.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),F.deserialize=O=>({range:m.Range.lift(O.range),uri:D.URI.revive(O.uri)})})(L||(e.IRichLocation=L={}));var I;(function(F){F[F.Error=0]="Error",F[F.Output=1]="Output"})(I||(e.TestMessageType=I={}));var g;(function(F){F.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&L.serialize(O.location)}),F.deserialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&L.deserialize(O.location)})})(g||(e.ITestErrorMessage=g={}));const w=(F,O)=>`${O?"s":"e"}${F}`;e.getMarkId=w;var C;(function(F){F.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&L.serialize(O.location)}),F.deserialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&L.deserialize(O.location)})})(C||(e.ITestOutputMessage=C={}));var l;(function(F){F.serialize=O=>O.type===0?g.serialize(O):C.serialize(O),F.deserialize=O=>O.type===0?g.deserialize(O):C.deserialize(O)})(l||(e.ITestMessage=l={}));var f;(function(F){F.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),F.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(l.serialize)}),F.deserialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(l.deserialize)})})(f||(e.ITestTaskState=f={}));const s="\0",i=(F,O)=>F+s+O;e.namespaceTestTag=i;const n=F=>{const O=F.indexOf(s);return{ctrlId:F.slice(0,O),tagId:F.slice(O+1)}};e.denamespaceTestTag=n;var o;(function(F){F.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),F.deserialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?D.URI.revive(O.uri):void 0,range:O.range?m.Range.lift(O.range):null,description:O.description,error:O.error,sortText:O.sortText})})(o||(e.ITestItem=o={}));var a;(function(F){F[F.NotExpandable=0]="NotExpandable",F[F.Expandable=1]="Expandable",F[F.BusyExpanding=2]="BusyExpanding",F[F.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(F){F.serialize=O=>({expand:O.expand,item:o.serialize(O.item)}),F.deserialize=O=>({controllerId:k.TestId.root(O.item.extId),expand:O.expand,item:o.deserialize(O.item)})})(t||(e.InternalTestItem=t={}));var r;(function(F){F.serialize=O=>{let W;return O.item&&(W={},O.item.label!==void 0&&(W.label=O.item.label),O.item.tags!==void 0&&(W.tags=O.item.tags),O.item.busy!==void 0&&(W.busy=O.item.busy),O.item.uri!==void 0&&(W.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(W.range=O.item.range?.toJSON()),O.item.description!==void 0&&(W.description=O.item.description),O.item.error!==void 0&&(W.error=O.item.error),O.item.sortText!==void 0&&(W.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:W}},F.deserialize=O=>{let W;return O.item&&(W={},O.item.label!==void 0&&(W.label=O.item.label),O.item.tags!==void 0&&(W.tags=O.item.tags),O.item.busy!==void 0&&(W.busy=O.item.busy),O.item.range!==void 0&&(W.range=O.item.range?m.Range.lift(O.item.range):null),O.item.description!==void 0&&(W.description=O.item.description),O.item.error!==void 0&&(W.error=O.item.error),O.item.sortText!==void 0&&(W.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:W}}})(r||(e.ITestItemUpdate=r={}));const h=(F,O)=>{O.expand!==void 0&&(F.expand=O.expand),O.item!==void 0&&(F.item=F.item?Object.assign(F.item,O.item):O.item)};e.applyTestItemUpdate=h;var u;(function(F){F.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(f.serializeWithoutMessages)}),F.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(f.serialize)}),F.deserialize=O=>({...t.deserialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(f.deserialize),retired:!0})})(u||(e.TestResultItem=u={}));var c;(function(F){F.empty=()=>({covered:0,total:0}),F.sum=(O,W)=>{O.covered+=W.covered,O.total+=W.total}})(c||(e.ICoveredCount=c={}));var d;(function(F){F.serialize=O=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(b.serialize),uri:O.uri.toJSON()}),F.deserialize=O=>({statement:O.statement,branch:O.branch,function:O.function,details:O.details?.map(b.deserialize),uri:D.URI.from(O.uri)})})(d||(e.IFileCoverage=d={}));function y(F){return{...F,location:F.location?.toJSON()}}function A(F){return F.location=F.location?N.Position.isIPosition(F.location)?N.Position.lift(F.location):m.Range.lift(F.location):void 0,F}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var E;(function(F){F[F.Function=0]="Function",F[F.Statement=1]="Statement"})(E||(e.DetailType=E={}));var b;(function(F){F.serialize=O=>O.type===0?T.serialize(O):U.serialize(O),F.deserialize=O=>O.type===0?T.deserialize(O):U.deserialize(O)})(b||(e.CoverageDetails=b={}));var _;(function(F){F.serialize=y,F.deserialize=A})(_||(e.IBranchCoverage=_={}));var T;(function(F){F.serialize=y,F.deserialize=A})(T||(e.IFunctionCoverage=T={}));var U;(function(F){F.serialize=O=>({...y(O),branches:O.branches?.map(_.serialize)}),F.deserialize=O=>({...A(O),branches:O.branches?.map(_.deserialize)})})(U||(e.IStatementCoverage=U={}));var M;(function(F){F[F.Add=0]="Add",F[F.Update=1]="Update",F[F.DocumentSynced=2]="DocumentSynced",F[F.Remove=3]="Remove",F[F.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",F[F.Retire=5]="Retire",F[F.AddTag=6]="AddTag",F[F.RemoveTag=7]="RemoveTag"})(M||(e.TestDiffOpType=M={}));var P;(function(F){F.deserialize=O=>O.op===0?{op:O.op,item:t.deserialize(O.item)}:O.op===1?{op:O.op,item:r.deserialize(O.item)}:O.op===2?{op:O.op,uri:D.URI.revive(O.uri),docv:O.docv}:O,F.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:r.serialize(O.item)}:O})(P||(e.TestsDiffOp=P={}));class x{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(O){const W=this.createChangeCollector();for(const J of O)switch(J.op){case 0:this.add(t.deserialize(J.item),W);break;case 1:this.update(r.deserialize(J.item),W);break;case 3:this.remove(J.itemId,W);break;case 5:this.retireTest(J.itemId);break;case 4:this.updatePendingRoots(J.amount);break;case 6:this._tags.set(J.tag.id,J.tag);break;case 7:this._tags.delete(J.id);break}W.complete?.()}add(O,W){const J=k.TestId.parentId(O.item.extId)?.toString();let ce;if(!J)ce=this.createItem(O),this.roots.add(ce),this.items.set(O.item.extId,ce);else if(this.items.has(J)){const G=this.items.get(J);G.children.add(O.item.extId),ce=this.createItem(O,G),this.items.set(O.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return W.add?.(ce),O.expand===2&&this.busyControllerCount++,ce}update(O,W){const J=this.items.get(O.extId);if(J)return O.expand!==void 0&&(J.expand===2&&this.busyControllerCount--,O.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(J,O),W.update?.(J),J}remove(O,W){const J=this.items.get(O);if(!J)return;const ce=k.TestId.parentId(J.item.extId)?.toString();ce?this.items.get(ce).children.delete(J.item.extId):this.roots.delete(J);const G=[[O]];for(;G.length;)for(const X of G.pop()){const Y=this.items.get(X);Y&&(G.push(Y.children),this.items.delete(X),W.remove?.(Y,Y!==J),Y.expand===2&&this.busyControllerCount--)}}retireTest(O){}updatePendingRoots(O){this.pendingRootCount+=O}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=x}),define(ye[112],Ce([1,0,12,4,3,60,89,67]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const S=(i,n)=>i===n,I=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:S,label:S,description:S,error:S,sortText:S,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),g=(i,n)=>{let o;for(const[a,t]of I)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class w extends m.Disposable{get root(){return this.options.root}constructor(n){super(),this.options=n,this.debounceSendDiff=this._register(new D.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new N.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const o of this.tree.values())this.updateExpandability(o)}get resolveHandler(){return this._resolveHandler}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.diff)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.diff[this.diff.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.applyTestItemUpdate)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.applyTestItemUpdate)(o.item,n.item);return}}break}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.resolveChildren(a);return t.isOpen()?this.expandChildren(a,o-1):t.wait().then(()=>this.expandChildren(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,o-1)):this.expandChildren(a,o-1)}}dispose(){for(const n of this.tree.values())this.options.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,o){switch(o.op){case 3:this.removeItem(v.TestId.joinToString(n.fullId,o.id));break;case 0:this.upsertItem(o.item,n);break;case 5:for(const a of o.ops)this.onTestItemEvent(n,a);break;case 1:this.diffTagRefs(o.new,o.old,n.fullId.toString());break;case 2:this.updateExpandability(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.documentSynced(n.actual.uri);break;default:(0,k.assertNever)(o)}}documentSynced(n){n&&this.pushDiff({op:2,uri:n,docv:this.options.getDocumentVersion(n)})}upsertItem(n,o){const a=v.TestId.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.options.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.options.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(n,o),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(n)}}),this.connectItemAndChildren(n,r,o);return}if(r.actual===n){this.connectItem(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.removeItem(a.toString()),this.upsertItem(n,o);const h=this.options.getChildren(r.actual),u=r.actual,c=g(this.options.toITestItem(u),this.options.toITestItem(n));this.options.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.diffTagRefs(n.tags,u.tags,a.toString()),delete c.tags),this.onTestItemEvent(r,{op:4,update:c})),this.connectItemAndChildren(n,r,o);for(const[d,y]of h)this.options.getChildren(n).get(y.id)||this.removeItem(v.TestId.joinToString(a,y.id));this.documentSynced(r.actual.uri)}diffTagRefs(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,R.namespaceTestTag)(this.options.controllerId,r.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const o=this.tags.get(n.id);o?o.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.options.controllerId,n.id)}}))}decrementTagRefs(n){const o=this.tags.get(n);o&&!--o.refCount&&(this.tags.delete(n),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.options.controllerId,n)}))}setItemParent(n,o){this.options.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}connectItem(n,o,a){this.setItemParent(n,a);const t=this.options.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.onTestItemEvent(o,r),this.updateExpandability(o)}connectItemAndChildren(n,o,a){this.connectItem(n,o,a);for(const[t,r]of this.options.getChildren(n))this.upsertItem(r,o)}updateExpandability(n){let o;this._resolveHandler?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,o){if(o<0)return;const a=[];for(const[t,r]of this.options.getChildren(n.actual)){const h=this.expand(v.TestId.joinToString(n.fullId,r.id),o);(0,D.isThenable)(h)&&a.push(h)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const r=new D.Barrier;return r.open(),r}n.expand=2,this.pushExpandStateUpdate(n);const o=n.resolveBarrier=new D.Barrier,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let t;try{t=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,D.isThenable)(t)?t.catch(a).then(()=>{o.open(),this.updateExpandability(n)}):(o.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}removeItem(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(t.fullId.toString());for(const[r,h]of this.options.getChildren(t.actual))a.push(this.tree.get(v.TestId.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.TestItemCollection=w;class C extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.DuplicateTestItemError=C;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;class f extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=f;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const h of a.values())t.call(r,h,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,h=new Set(a.keys()),u={op:5,ops:[]};for(const c of t){if(!(c instanceof o))throw new l(c.id);const d=n(c).controllerId;if(d!==i.controllerId)throw new f(c.id,d,i.controllerId);if(r.has(c.id))throw new C(c.id);r.set(c.id,c),h.delete(c.id),u.ops.push({op:0,item:c})}for(const c of h.keys())u.ops.push({op:3,id:c});i.listener?.(u),a=r},add(t){if(!(t instanceof o))throw new l(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=s}),define(ye[142],Ce([1,0,112]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const N=new WeakMap,m=(R,v)=>{const p={controllerId:v};return N.set(R,p),p};e.createPrivateApiFor=m;const k=R=>{const v=N.get(R);if(!v)throw new D.InvalidTestItemError(R?.id||"<unknown>");return v};e.getPrivateApiFor=k}),define(ye[113],Ce([1,0,17,2]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function m(v,p){return v.scheme===D.Schemas.http||v.scheme===D.Schemas.https?v:(p&&p.authority&&p.isRemote&&v.scheme===D.Schemas.file&&(v=N.URI.from({scheme:D.Schemas.vscodeRemote,authority:p.authority,path:v.path})),N.URI.from({scheme:D.Schemas.https,authority:`${v.scheme}+${k(v.authority)}.${e.webviewRootResourceAuthority}`,path:v.path,fragment:v.fragment,query:v.query}))}e.asWebviewUri=m;function k(v){return v.replace(/./g,p=>{const S=p.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?p:"-"+S.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,(p,S)=>String.fromCharCode(parseInt(S,16)))}e.decodeAuthority=R}),define(ye[288],Ce([1,0,4,3,113]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class k{constructor(v,p,S){this._proxy=v,this._editors=p,this._remoteInfo=S,this._handlePool=0,this._disposables=new N.DisposableStore,this._insets=new Map,this._disposables.add(p.onDidChangeVisibleTextEditors(()=>{const L=p.getVisibleTextEditors();for(const I of this._insets.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(v=>v.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(v,p,S,L,I){let g;for(const n of this._editors.getVisibleTextEditors(!0))if(n.value===v){g=n;break}if(!g)throw new Error("not a visible editor");const w=this,C=this._handlePool++,l=new D.Emitter,f=new D.Emitter,s=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(n){return(0,m.asWebviewUri)(n,w._remoteInfo)}get cspSource(){return m.webviewGenericCspSource}set options(n){this._options=n,w._proxy.$setOptions(C,n)}get options(){return this._options}set html(n){this._html=n,w._proxy.$setHtml(C,n)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(n){return w._proxy.$postMessage(C,n)}},i=new class{constructor(){this.editor=v,this.line=p,this.height=S,this.webview=s,this.onDidDispose=f.event}dispose(){w._insets.has(C)&&(w._insets.delete(C),w._proxy.$disposeEditorInset(C),f.fire(),f.dispose(),l.dispose())}};return this._proxy.$createEditorInset(C,g.id,g.value.document.uri,p+1,S,L||{},I.identifier,I.extensionLocation),this._insets.set(C,{editor:v,inset:i,onDidReceiveMessage:l}),i}$onDidDispose(v){const p=this._insets.get(v);p&&p.inset.dispose()}$onDidReceiveMessage(v,p){this._insets.get(v)?.onDidReceiveMessage.fire(p)}}e.ExtHostEditorInsets=k}),define(ye[289],Ce([1,0,5]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,D.createDecorator)("configurationResolverService");var N;(function(k){k.Unknown="unknown",k.Env="env",k.Config="config",k.Command="command",k.Input="input",k.ExtensionInstallFolder="extensionInstallFolder",k.WorkspaceFolder="workspaceFolder",k.Cwd="cwd",k.WorkspaceFolderBasename="workspaceFolderBasename",k.UserHome="userHome",k.LineNumber="lineNumber",k.SelectedText="selectedText",k.File="file",k.FileWorkspaceFolder="fileWorkspaceFolder",k.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",k.RelativeFile="relativeFile",k.RelativeFileDirname="relativeFileDirname",k.FileDirname="fileDirname",k.FileExtname="fileExtname",k.FileBasename="fileBasename",k.FileBasenameNoExtension="fileBasenameNoExtension",k.FileDirnameBasename="fileDirnameBasename",k.ExecPath="execPath",k.ExecInstallFolder="execInstallFolder",k.PathSeparator="pathSeparator"})(N||(e.VariableKind=N={}));class m extends Error{constructor(R,v){super(v),this.variable=R}}e.VariableError=m}),define(ye[290],Ce([1,0,16,50,18,24,11,102,232,289,13]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,C,l,f){this._contributedVariables=new Map,this._context=w,this._labelService=C,this._userHomePromise=l,f&&(this._envVariablesPromise=f.then(s=>this.prepareEnv(s)))}prepareEnv(w){if(R.isWindows){const C=Object.create(null);return Object.keys(w).forEach(l=>{C[l.toLowerCase()]=w[l]}),C}return w}resolveWithEnvironment(w,C,l){return this.recursiveResolve({env:this.prepareEnv(w),userHome:void 0},C?C.uri:void 0,l)}async resolveAsync(w,C){const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,w?w.uri:void 0,C)}async resolveAnyBase(w,C,l,f){const s=k.deepClone(C);R.isWindows&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.isMacintosh&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.isLinux&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(i,w?w.uri:void 0,s,l,f)}async resolveAnyAsync(w,C,l){return this.resolveAnyBase(w,C,l)}async resolveAnyMap(w,C,l){const f=new Map;return{newConfig:await this.resolveAnyBase(w,C,l,f),resolvedVariables:f}}resolveWithInteractionReplace(w,C,l,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,C,l,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,C){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,C)}async recursiveResolve(w,C,l,f,s){if(m.isString(l))return this.resolveString(w,C,l,f,s);if(Array.isArray(l))return Promise.all(l.map(i=>this.recursiveResolve(w,C,i,f,s)));if(m.isObject(l)){const i=Object.create(null),n=await Promise.all(Object.keys(l).map(async o=>[await this.resolveString(w,C,o,f,s),await this.recursiveResolve(w,C,l[o],f,s)]));for(const[o,a]of n)i[o]=a;return i}return l}resolveString(w,C,l,f,s){return(0,L.replaceAsync)(l,I.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(I.VARIABLE_LHS))return i;let o=await this.evaluateSingleVariable(w,i,n,C,f);return s?.set(n,o),o!==i&&m.isString(o)&&o.match(I.VARIABLE_REGEXP)&&(o=await this.resolveString(w,C,o,f,s)),o})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}async evaluateSingleVariable(w,C,l,f,s){let i;const n=l.split(":");n.length>1&&(l=n[0],i=n[1]);const o=r=>{const h=this._context.getFilePath();if(h)return(0,v.normalizeDriveLetter)(h);throw new S.VariableError(r,(0,p.localize)(0,null,C))},a=r=>{const h=o(r);if(this._context.getWorkspaceFolderPathForFile){const u=this._context.getWorkspaceFolderPathForFile();if(u)return(0,v.normalizeDriveLetter)(u)}throw new S.VariableError(r,(0,p.localize)(1,null,C,D.basename(h)))},t=r=>{if(i){const h=this._context.getFolderUri(i);if(h)return h;throw new S.VariableError(r,(0,p.localize)(2,null,C,i))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new S.VariableError(r,(0,p.localize)(3,null,C)):new S.VariableError(r,(0,p.localize)(4,null,C))};switch(l){case"env":if(i){if(w.env){const r=w.env[R.isWindows?i.toLowerCase():i];if(m.isString(r))return r}return""}throw new S.VariableError(S.VariableKind.Env,(0,p.localize)(5,null,C));case"config":if(i){const r=this._context.getConfigurationValue(f,i);if(m.isUndefinedOrNull(r))throw new S.VariableError(S.VariableKind.Config,(0,p.localize)(6,null,C,i));if(m.isObject(r))throw new S.VariableError(S.VariableKind.Config,(0,p.localize)(7,null,C,i));return r}throw new S.VariableError(S.VariableKind.Config,(0,p.localize)(8,null,C));case"command":return this.resolveFromMap(S.VariableKind.Command,C,i,s,"command");case"input":return this.resolveFromMap(S.VariableKind.Input,C,i,s,"input");case"extensionInstallFolder":if(i){const r=await this._context.getExtension(i);if(!r)throw new S.VariableError(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,C,i));return this.fsPath(r.extensionLocation)}throw new S.VariableError(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,C));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,v.normalizeDriveLetter)(this.fsPath(t(S.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,v.normalizeDriveLetter)(this.fsPath(t(S.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,v.normalizeDriveLetter)(D.basename(this.fsPath(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new S.VariableError(S.VariableKind.UserHome,(0,p.localize)(11,null,C))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new S.VariableError(S.VariableKind.LineNumber,(0,p.localize)(12,null,C))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new S.VariableError(S.VariableKind.SelectedText,(0,p.localize)(13,null,C))}case"file":return o(S.VariableKind.File);case"fileWorkspaceFolder":return a(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.basename(a(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.relative(this.fsPath(t(S.VariableKind.RelativeFile)),o(S.VariableKind.RelativeFile)):o(S.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.dirname(o(S.VariableKind.RelativeFileDirname));if(f||i){const h=D.relative(this.fsPath(t(S.VariableKind.RelativeFileDirname)),r);return h.length===0?".":h}return r}case"fileDirname":return D.dirname(o(S.VariableKind.FileDirname));case"fileExtname":return D.extname(o(S.VariableKind.FileExtname));case"fileBasename":return D.basename(o(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.basename(o(S.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.extname(r).length)}case"fileDirnameBasename":return D.basename(D.dirname(o(S.VariableKind.FileDirnameBasename)));case"execPath":{const r=this._context.getExecPath();return r||C}case"execInstallFolder":{const r=this._context.getAppRoot();return r||C}case"pathSeparator":return D.sep;default:try{const r=i?`${l}:${i}`:l;return this.resolveFromMap(S.VariableKind.Unknown,C,r,s,void 0)}catch{return C}}}}resolveFromMap(w,C,l,f,s){if(l&&f){const i=s===void 0?f[l]:f[s+":"+l];if(typeof i=="string")return i;throw new S.VariableError(w,(0,p.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=I}),define(ye[143],Ce([1,0,5,139]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,D.createDecorator)("editorGroupsService");var m;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(m||(e.GroupDirection=m={}));var k;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(k||(e.GroupOrientation=k={}));var R;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var v;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EXPAND=1]="EXPAND",C[C.EVEN=2]="EVEN"})(v||(e.GroupsArrangement=v={}));var p;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function S(C){const l=C;return(0,N.isEditorInput)(l?.editor)&&(0,N.isEditorInput)(l?.replacement)}e.isEditorReplacement=S;var L;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var I;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function g(C){const l=C;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.isEditorGroup=g;function w(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(ye[291],Ce([1,0,5,143]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,D.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function m(k){const R=k;return typeof k=="number"||(0,N.isEditorGroup)(R)}e.isPreferredGroup=m}),define(ye[144],Ce([1,0,5,133]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,D.refineServiceDecorator)(N.IEnvironmentService)}),define(ye[145],Ce([1,0,26,4,16,3]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.DeltaExtensionsResult=R;class v{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this._activationEventsReader=s,this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new D.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this._extensionsMap.set(s.identifier,s),this._extensionsArr.push(s);const i=this._activationEventsReader.readActivationEvents(s);for(const n of i)this._activationMap.has(n)||this._activationMap.set(n,[]),this._activationMap.get(n).push(s)}}set(s){return this._extensionDescriptions=s,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(s,i){this._extensionDescriptions=l(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(s);const n=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=l(this._extensionDescriptions,n.map(o=>o.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new R(this._versionId,n)}static _findLoopingExtensions(s){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(r){this._nodesSet.has(r)||(this._nodesSet.add(r),this._nodesArr.push(r))}addArc(r,h){this.addNode(r),this.addNode(h),this._arcs.has(r)?this._arcs.get(r).push(h):this._arcs.set(r,[h])}getArcs(r){return this._arcs.has(r)?this._arcs.get(r):[]}hasOnlyGoodArcs(r,h){const u=i.getArcs(r);for(let c=0;c<u.length;c++)if(!h.has(u[c]))return!1;return!0}getNodes(){return this._nodesArr}},n=new D.ExtensionIdentifierMap;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const h of r.extensionDependencies)i.addArc(D.ExtensionIdentifier.toKey(r.identifier),D.ExtensionIdentifier.toKey(h));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const h=a[r];i.hasOnlyGoodArcs(h,o)&&(a.splice(r,1),r--,o.add(h),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this._activationMap.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new p(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this._extensionsMap.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this._extensionsArr)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=v;class p{constructor(s,i){this.versionId=s,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=p;class S{constructor(s){this._lock=new g,this._actual=new v(s,[])}async acquireLock(s){const i=await this._lock.acquire(s);return new L(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,n)}containsActivationEvent(s){return this._actual.containsActivationEvent(s)}containsExtension(s){return this._actual.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this._actual.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(s){return this._actual.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this._actual.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this._actual.getExtensionDescriptionByIdOrUUID(s,i)}}e.LockableExtensionDescriptionRegistry=S;class L extends k.Disposable{constructor(s,i){super(),this._registry=s,this._isDisposed=!1,this._register(i)}isAcquiredFor(s){return!this._isDisposed&&this._registry===s}}e.ExtensionDescriptionRegistryLock=L;class I{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this._resolve=i})}resolve(s){this._resolve(s)}}class g{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(s){const i=new I(s);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const s=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this._isLocked=!1,this._advance())};s.resolve((0,k.toDisposable)(o))}}var w;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(w||(w={}));function C(f,s){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=m.posix.basename(f.extensionLocation.path),a=m.posix.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function l(f,s){const i=new D.ExtensionIdentifierSet(s);return f.filter(n=>!i.has(n.identifier))}}),define(ye[292],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var D;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[N.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=N;class m{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[m.ENV_KEY]="1"}}e.SocketExtHostConnection=m;class k{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[k.ENV_KEY]="1"}}e.MessagePortExtHostConnection=k;function R(L){delete L[N.ENV_KEY],delete L[m.ENV_KEY],delete L[k.ENV_KEY]}function v(L,I){R(I),L.serialize(I)}e.writeExtHostConnection=v;function p(L){if(L[N.ENV_KEY])return S(L,new N(L[N.ENV_KEY]));if(L[m.ENV_KEY])return S(L,new m);if(L[k.ENV_KEY])return S(L,new k);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=p;function S(L,I){return R(L),I}}),define(ye[114],Ce([1,0,22]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(N||(e.UIKind=N={}));var m;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(m||(e.ExtensionHostExitCode=m={}));var k;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(k||(e.MessageType=k={}));function R(S){const L=D.VSBuffer.alloc(1);switch(S){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=R;function v(S,L){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=v;var p;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ye[90],Ce([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let w=class extends I.Disposable{constructor(s,i){super(),this.initData=s,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new N.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new N.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=L.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:p.extensionTelemetryLogChannelId,name:(0,g.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(i.onDidChangeLogLevel(n=>{(0,m.isLogLevel)(n)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===m.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new C(i,n,s,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this._telemetryLoggers.get(s.identifier.value)??[];return this._telemetryLoggers.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this._level=s,this._telemetryIsSupported=i,this._productConfig=n??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=l(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.getRemoteName)((0,p.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(s){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=s;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this._telemetryLoggers.delete(o):this._telemetryLoggers.set(o,a)}),this._telemetryLoggers.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(s,i){const o=this._telemetryLoggers.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this._telemetryLoggers.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.ExtHostTelemetry=w,e.ExtHostTelemetry=w=Ge([We(0,k.IExtHostInitDataService),We(1,m.ILoggerService)],w);class C{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this._extension=n,this._logger=o,this._inLoggingOnlyMode=a,this._commonProperties=t,this._onDidChangeEnableStates=new N.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=s,this._telemetryEnablements={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:s,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,p.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,S.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,S.mixin)(i,this._commonProperties)),"properties"in s?s.properties=i:s=i,s}logEvent(s,i){this._sender&&(this._extension.publisher==="vscode"?s=this._extension.name+"/"+s:s=this._extension.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(s,i),this._logger.trace(s,i))}logUsage(s,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(s,i)}logError(s,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof s=="string")this.logEvent(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,p.cleanData)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(a,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return s._telemetryEnablements.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s._onDidChangeEnableStates.event.bind(s)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let s=this._sender;this._sender=void 0,Promise.resolve(s.flush()).then(s=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=C;function l(f){const s=Date.now()-new Date(f).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.isNewAppInstall=l,e.IExtHostTelemetry=(0,D.createDecorator)("IExtHostTelemetry")}),define(ye[25],Ce([1,0,4,2,262,137,26,5]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,v.createDecorator)("extensionService");class p{constructor(a){this.dependency=a}}e.MissingExtensionDependency=p;var S;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class L{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(a,t,r){this._versionId=a,this._allExtensions=t.slice(0),this._myExtensions=r.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:k.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(a,t,r){if(this._versionId>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this._versionId})`);const h=[],u=[],c=[],d=[],y=I(this._allExtensions),A=I(t),E=(M,P)=>M.extensionLocation.toString()===P.extensionLocation.toString()||M.isBuiltin===P.isBuiltin||M.isUserBuiltin===P.isUserBuiltin||M.isUnderDevelopment===P.isUnderDevelopment;for(const M of this._allExtensions){const P=A.get(M.identifier);if(!P){h.push(M.identifier),y.delete(M.identifier);continue}if(!E(M,P)){h.push(M.identifier),y.delete(M.identifier);continue}}for(const M of t){const P=y.get(M.identifier);if(!P){u.push(M);continue}if(!E(P,M)){h.push(P.identifier),y.delete(P.identifier);continue}}const b=new R.ExtensionIdentifierSet(this._myExtensions),_=new R.ExtensionIdentifierSet(r);for(const M of this._myExtensions)_.has(M)||c.push(M);for(const M of r)b.has(M)||d.push(M);const T=k.ImplicitActivationEvents.createActivationEventsMap(u),U={versionId:a,toRemove:h,toAdd:u,addActivationEvents:T,myToRemove:c,myToAdd:d};return this.delta(U),U}delta(a){if(this._versionId>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:h,myToAdd:u}=a,c=new R.ExtensionIdentifierSet(t),d=new R.ExtensionIdentifierSet(h);for(let y=0;y<this._allExtensions.length;y++)c.has(this._allExtensions[y].identifier)&&(this._allExtensions.splice(y,1),y--);for(let y=0;y<this._myExtensions.length;y++)d.has(this._myExtensions[y])&&(this._myExtensions.splice(y,1),y--);for(const y of r)this._allExtensions.push(y);for(const y of u)this._myExtensions.push(y);return this._myActivationEvents=null,a}containsExtension(a){for(const t of this._myExtensions)if(R.ExtensionIdentifier.equals(t,a))return!0;return!1}containsActivationEvent(a){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(a)}_readMyActivationEvents(){const a=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const r=k.ImplicitActivationEvents.readActivationEvents(t);for(const h of r)a.add(h)}return a}}e.ExtensionHostExtensions=L;function I(o){const a=new R.ExtensionIdentifierMap;for(const t of o)a.set(t.identifier,t);return a}function g(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=g;function w(o,a){if(!g(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=w;class C{constructor(a,t,r,h){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=h}}e.ActivationTimes=C;class l{constructor(a,t){this.description=a,this.value=t}}e.ExtensionPointContribution=l;var f;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,m.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function i(o,a){return{identifier:new R.ExtensionIdentifier((0,m.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=n}),define(ye[293],Ce([1,0,8,145,26,25,14,12]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.ExtensionActivationTimes=p;class S{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,i){return s===-1||i===-1?-1:i-s}build(){return new p(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class L{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.ActivatedExtension=L;class I extends L{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class g extends L{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=g;class w extends L{constructor(s){super(!0,s,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(s,i,n,o){this._logService=o,this._registry=s,this._globalRegistry=i,this._host=n,this._operations=new m.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[s,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this._operations)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this._operations.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this._operations.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this._alreadyActivatedEvents[s])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(s);await this._activateExtensions(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this._alreadyActivatedEvents[s]=!0}activateById(s,i){const n=this._registry.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this._activateExtensions([{id:n.identifier,reason:i}])}async _activateExtensions(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(i.map(n=>n.wait()))}_handleActivationRequest(s){if(this._operations.has(s.id))return this._operations.get(s.id);if(this._isHostExtension(s.id))return this._createAndSaveOperation(s,null,[],null);const i=this._registry.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this._createAndSaveOperation(s,null,[],new w(a));return this._host.onExtensionActivationError(s.id,a,new k.MissingExtensionDependency(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this._isResolvedExtension(a))continue;const t=this._operations.get(a);if(t){n.push(t);continue}if(this._isHostExtension(a)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this._registry.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this._handleActivationRequest({id:r.identifier,reason:s.reason}));continue}const h=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${a}'`),c=this._createAndSaveOperation(s,i.displayName,[],new w(u));return this._host.onExtensionActivationError(i.identifier,u,new k.MissingExtensionDependency(a)),c}return this._createAndSaveOperation(s,i.displayName,n,null)}_createAndSaveOperation(s,i,n,o){const a=new l(s.id,i,s.reason,n,o,this._host,this._logService);return this._operations.set(s.id,a),a}_isHostExtension(s){return N.ExtensionDescriptionRegistry.isHostExtension(s,this._registry,this._globalRegistry)}_isResolvedExtension(s){const i=this._globalRegistry.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=C,e.ExtensionsActivator=C=Ge([We(3,R.ILogService)],C);let l=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(s,i,n,o,a,t,r){this._id=s,this._displayName=i,this._reason=n,this._deps=o,this._value=a,this._host=t,this._logService=r,this._barrier=new v.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let s=0;s<this._deps.length;s++){const i=this._deps[s];if(i.value&&!i.value.activationFailed){this._deps.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this._value=new w(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(s=>s.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this._id.value}' failed: ${s.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this._value=new w(i),this._isDisposed&&D.isCancellationError(s))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(s)}}};l=Ge([We(6,R.ILogService)],l)}),define(ye[15],Ce([1,0,19,22,165,74,80,28,160,54,100,24,18,2,29,83,135,142,139,111,67,89,291,7,25]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Le){function Ne(re){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:Je,positionColumn:qe}=re,rt=new r.Position(Fe-1,He-1),gt=new r.Position(Je-1,qe-1);return new r.Selection(rt,gt)}Le.to=Ne;function Ie(re){const{anchor:Fe,active:He}=re;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Le.from=Ie})(u||(e.Selection=u={}));var c;(function(Le){function Ne(re){if(!re)return;const{start:Fe,end:He}=re;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Le.from=Ne;function Ie(re){if(!re)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:Je,endColumn:qe}=re;return new r.Range(Fe-1,He-1,Je-1,qe-1)}Le.to=Ie})(c||(e.Range=c={}));var d;(function(Le){function Ne(Ie){switch(Ie){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Le.to=Ne})(d||(e.TokenType=d={}));var y;(function(Le){function Ne(re){return new r.Position(re.lineNumber-1,re.column-1)}Le.to=Ne;function Ie(re){return{lineNumber:re.line+1,column:re.character+1}}Le.from=Ie})(y||(e.Position=y={}));var A;(function(Le){function Ne(Fe,He,Je){return(0,D.coalesce)((0,D.asArray)(Fe).map(qe=>Ie(qe,He,Je)))}Le.from=Ne;function Ie(Fe,He,Je){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Je?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:re(Fe.scheme,He),pattern:oe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Je?.isBuiltin}}function re(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(A||(e.DocumentSelector=A={}));var E;(function(Le){function Ne(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Le.from=Ne;function Ie(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Le.to=Ie})(E||(e.DiagnosticTag=E={}));var b;(function(Le){function Ne(re){let Fe;return re.code&&((0,g.isString)(re.code)||(0,g.isNumber)(re.code)?Fe=String(re.code):Fe={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Fe,severity:T.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(_.from),tags:Array.isArray(re.tags)?(0,D.coalesce)(re.tags.map(E.from)):void 0}}Le.from=Ne;function Ie(re){const Fe=new r.Diagnostic(c.to(re),re.message,T.to(re.severity));return Fe.source=re.source,Fe.code=(0,g.isString)(re.code)?re.code:re.code?.value,Fe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(_.to),Fe.tags=re.tags&&(0,D.coalesce)(re.tags.map(E.to)),Fe}Le.to=Ie})(b||(e.Diagnostic=b={}));var _;(function(Le){function Ne(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Le.from=Ne;function Ie(re){return new r.DiagnosticRelatedInformation(new r.Location(re.resource,c.to(re)),re.message)}Le.to=Ie})(_||(e.DiagnosticRelatedInformation=_={}));var T;(function(Le){function Ne(re){switch(re){case r.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Le.from=Ne;function Ie(re){switch(re){case f.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Le.to=Ie})(T||(e.DiagnosticSeverity=T={}));var U;(function(Le){function Ne(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Ne;function Ie(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Ie})(U||(e.ViewColumn=U={}));function M(Le){return typeof Le.range<"u"}function P(Le){return Le.length===0?!0:!!M(Le[0])}e.isDecorationOptionsArr=P;var x;(function(Le){function Ne(qe){return qe.map(Le.from)}Le.fromMany=Ne;function Ie(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function re(qe){let rt;if(Ie(qe)){const{language:It,value:Et}=qe;rt={value:"```"+It+`
`+Et+"\n```\n"}}else r.MarkdownString.isMarkdownString(qe)?rt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?rt={value:qe}:rt={value:""};const gt=Object.create(null);rt.uris=gt;const Ut=It=>{try{let Et=w.URI.parse(It,!0);Et=Et.with({query:Fe(Et.query,gt)}),gt[It]=Et}catch{}return""},_t=new p.marked.Renderer;return _t.link=Ut,_t.image=It=>typeof It=="string"?Ut(R.parseHrefAndDimensions(It).href):"",(0,p.marked)(rt.value,{renderer:_t}),rt}Le.from=re;function Fe(qe,rt){if(!qe)return qe;let gt;try{gt=(0,S.parse)(qe)}catch{}if(!gt)return qe;let Ut=!1;return gt=(0,I.cloneAndChange)(gt,_t=>{if(w.URI.isUri(_t)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[It]=_t,Ut=!0,It}else return}),Ut?JSON.stringify(gt):qe}function He(qe){const rt=new r.MarkdownString(qe.value,qe.supportThemeIcons);return rt.isTrusted=qe.isTrusted,rt.supportHtml=qe.supportHtml,rt.baseUri=qe.baseUri?w.URI.from(qe.baseUri):void 0,rt}Le.to=He;function Je(qe){if(qe)return typeof qe=="string"?qe:Le.from(qe)}Le.fromStrict=Je})(x||(e.MarkdownString=x={}));function F(Le){return P(Le)?Le.map(Ne=>({range:c.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?x.fromMany(Ne.hoverMessage):Ne.hoverMessage?x.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Le.map(Ne=>({range:c.from(Ne)}))}e.fromRangeOrRangeWithMessage=F;function O(Le){return typeof Le>"u"?Le:typeof Le=="string"?w.URI.file(Le):Le}e.pathOrURIToURI=O;var W;(function(Le){function Ne(Ie){return typeof Ie>"u"?Ie:{contentText:Ie.contentText,contentIconPath:Ie.contentIconPath?O(Ie.contentIconPath):void 0,border:Ie.border,borderColor:Ie.borderColor,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,color:Ie.color,backgroundColor:Ie.backgroundColor,margin:Ie.margin,width:Ie.width,height:Ie.height}}Le.from=Ne})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var J;(function(Le){function Ne(Ie){return typeof Ie>"u"?Ie:{backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?O(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?W.from(Ie.before):void 0,after:Ie.after?W.from(Ie.after):void 0}}Le.from=Ne})(J||(e.ThemableDecorationRenderOptions=J={}));var ce;(function(Le){function Ne(Ie){if(typeof Ie>"u")return Ie;switch(Ie){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Ne})(ce||(e.DecorationRangeBehavior=ce={}));var G;(function(Le){function Ne(Ie){return{isWholeLine:Ie.isWholeLine,rangeBehavior:Ie.rangeBehavior?ce.from(Ie.rangeBehavior):void 0,overviewRulerLane:Ie.overviewRulerLane,light:Ie.light?J.from(Ie.light):void 0,dark:Ie.dark?J.from(Ie.dark):void 0,backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?O(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?W.from(Ie.before):void 0,after:Ie.after?W.from(Ie.after):void 0}}Le.from=Ne})(G||(e.DecorationRenderOptions=G={}));var X;(function(Le){function Ne(re){return{text:re.newText,eol:re.newEol&&ke.from(re.newEol),range:c.from(re.range)}}Le.from=Ne;function Ie(re){const Fe=new r.TextEdit(c.to(re.range),re.text);return Fe.newEol=typeof re.eol>"u"?void 0:ke.to(re.eol),Fe}Le.to=Ie})(X||(e.TextEdit=X={}));var Y;(function(Le){function Ne(re,Fe){const He={edits:[]};if(re instanceof r.WorkspaceEdit){const Je=new v.ResourceSet;for(const qe of re._allEntries())qe._type===1&&w.URI.isUri(qe.to)&&qe.from===void 0&&Je.add(qe.to);for(const qe of re._allEntries())if(qe._type===1){let rt;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?rt={type:"base64",value:(0,N.encodeBase64)(N.VSBuffer.wrap(qe.options.contents))}:rt={type:"dataTransferItem",id:qe.options.contents._itemId}),He.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:rt},metadata:qe.metadata})}else qe._type===2?He.edits.push({resource:qe.uri,textEdit:X.from(qe.edit),versionId:Je.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?He.edits.push({resource:qe.uri,textEdit:{range:c.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Je.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?He.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&He.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(wt.from)}})}return He}Le.from=Ne;function Ie(re){const Fe=new r.WorkspaceEdit,He=new v.ResourceMap;for(const Je of re.edits)if(Je.textEdit){const qe=Je,rt=w.URI.revive(qe.resource),gt=c.to(qe.textEdit.range),Ut=qe.textEdit.text,_t=qe.textEdit.insertAsSnippet;let It;_t?It=r.SnippetTextEdit.replace(gt,new r.SnippetString(Ut)):It=r.TextEdit.replace(gt,Ut);const Et=He.get(rt);Et?Et.push(It):He.set(rt,[It])}else Fe.renameFile(w.URI.revive(Je.oldResource),w.URI.revive(Je.newResource),Je.options);for(const[Je,qe]of He)Fe.set(Je,qe);return Fe}Le.to=Ie})(Y||(e.WorkspaceEdit=Y={}));var se;(function(Le){const Ne=Object.create(null);Ne[r.SymbolKind.File]=0,Ne[r.SymbolKind.Module]=1,Ne[r.SymbolKind.Namespace]=2,Ne[r.SymbolKind.Package]=3,Ne[r.SymbolKind.Class]=4,Ne[r.SymbolKind.Method]=5,Ne[r.SymbolKind.Property]=6,Ne[r.SymbolKind.Field]=7,Ne[r.SymbolKind.Constructor]=8,Ne[r.SymbolKind.Enum]=9,Ne[r.SymbolKind.Interface]=10,Ne[r.SymbolKind.Function]=11,Ne[r.SymbolKind.Variable]=12,Ne[r.SymbolKind.Constant]=13,Ne[r.SymbolKind.String]=14,Ne[r.SymbolKind.Number]=15,Ne[r.SymbolKind.Boolean]=16,Ne[r.SymbolKind.Array]=17,Ne[r.SymbolKind.Object]=18,Ne[r.SymbolKind.Key]=19,Ne[r.SymbolKind.Null]=20,Ne[r.SymbolKind.EnumMember]=21,Ne[r.SymbolKind.Struct]=22,Ne[r.SymbolKind.Event]=23,Ne[r.SymbolKind.Operator]=24,Ne[r.SymbolKind.TypeParameter]=25;function Ie(Fe){return typeof Ne[Fe]=="number"?Ne[Fe]:6}Le.from=Ie;function re(Fe){for(const He in Ne)if(Ne[He]===Fe)return Number(He);return r.SymbolKind.Property}Le.to=re})(se||(e.SymbolKind=se={}));var Q;(function(Le){function Ne(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Le.from=Ne;function Ie(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Le.to=Ie})(Q||(e.SymbolTag=Q={}));var we;(function(Le){function Ne(re){return{name:re.name,kind:se.from(re.kind),tags:re.tags&&re.tags.map(Q.from),containerName:re.containerName,location:Se.from(re.location)}}Le.from=Ne;function Ie(re){const Fe=new r.SymbolInformation(re.name,se.to(re.kind),re.containerName,Se.to(re.location));return Fe.tags=re.tags&&re.tags.map(Q.to),Fe}Le.to=Ie})(we||(e.WorkspaceSymbol=we={}));var he;(function(Le){function Ne(re){const Fe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:se.from(re.kind),tags:re.tags?.map(Q.from)??[]};return re.children&&(Fe.children=re.children.map(Ne)),Fe}Le.from=Ne;function Ie(re){const Fe=new r.DocumentSymbol(re.name,re.detail,se.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,D.isNonEmptyArray)(re.tags)&&(Fe.tags=re.tags.map(Q.to)),re.children&&(Fe.children=re.children.map(Ie)),Fe}Le.to=Ie})(he||(e.DocumentSymbol=he={}));var j;(function(Le){function Ne(re){const Fe=new r.CallHierarchyItem(se.to(re.kind),re.name,re.detail||"",w.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Le.to=Ne;function Ie(re,Fe,He){if(Fe=Fe??re._sessionId,He=He??re._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:re.name,detail:re.detail,kind:se.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Q.from)}}Le.from=Ie})(j||(e.CallHierarchyItem=j={}));var z;(function(Le){function Ne(Ie){return new r.CallHierarchyIncomingCall(j.to(Ie.from),Ie.fromRanges.map(re=>c.to(re)))}Le.to=Ne})(z||(e.CallHierarchyIncomingCall=z={}));var ne;(function(Le){function Ne(Ie){return new r.CallHierarchyOutgoingCall(j.to(Ie.to),Ie.fromRanges.map(re=>c.to(re)))}Le.to=Ne})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Se;(function(Le){function Ne(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Le.from=Ne;function Ie(re){return new r.Location(w.URI.revive(re.uri),c.to(re.range))}Le.to=Ie})(Se||(e.location=Se={}));var de;(function(Le){function Ne(re){const Fe=re,He=re;return{originSelectionRange:Fe.originSelectionRange?c.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:c.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?c.from(Fe.targetSelectionRange):void 0}}Le.from=Ne;function Ie(re){return{targetUri:w.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Le.to=Ie})(de||(e.DefinitionLink=de={}));var me;(function(Le){function Ne(re){return{range:c.from(re.range),contents:x.fromMany(re.contents)}}Le.from=Ne;function Ie(re){return new r.Hover(re.contents.map(x.to),c.to(re.range))}Le.to=Ie})(me||(e.Hover=me={}));var Z;(function(Le){function Ne(re){return{range:c.from(re.range),expression:re.expression}}Le.from=Ne;function Ie(re){return new r.EvaluatableExpression(c.to(re.range),re.expression)}Le.to=Ie})(Z||(e.EvaluatableExpression=Z={}));var ie;(function(Le){function Ne(re){if(re instanceof r.InlineValueText)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof r.InlineValueVariableLookup)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Ne;function Ie(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Le.to=Ie})(ie||(e.InlineValue=ie={}));var q;(function(Le){function Ne(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Le.from=Ne;function Ie(re){return new r.InlineValueContext(re.frameId,c.to(re.stoppedLocation))}Le.to=Ie})(q||(e.InlineValueContext=q={}));var te;(function(Le){function Ne(re){return{range:c.from(re.range),kind:re.kind}}Le.from=Ne;function Ie(re){return new r.DocumentHighlight(c.to(re.range),re.kind)}Le.to=Ie})(te||(e.DocumentHighlight=te={}));var fe;(function(Le){function Ne(re){return{uri:re.uri,highlights:re.highlights.map(te.from)}}Le.from=Ne;function Ie(re){return new r.MultiDocumentHighlight(w.URI.revive(re.uri),re.highlights.map(te.to))}Le.to=Ie})(fe||(e.MultiDocumentHighlight=fe={}));var Ee;(function(Le){function Ne(Ie){switch(Ie){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Le.to=Ne})(Ee||(e.CompletionTriggerKind=Ee={}));var Te;(function(Le){function Ne(Ie){return{triggerKind:Ee.to(Ie.triggerKind),triggerCharacter:Ie.triggerCharacter}}Le.to=Ne})(Te||(e.CompletionContext=Te={}));var ve;(function(Le){function Ne(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Le.from=Ne;function Ie(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Le.to=Ie})(ve||(e.CompletionItemTag=ve={}));var De;(function(Le){const Ne=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ie(He){return Ne.get(He)??9}Le.from=Ie;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(He){return re.get(He)??r.CompletionItemKind.Property}Le.to=Fe})(De||(e.CompletionItemKind=De={}));var B;(function(Le){function Ne(Ie,re){const Fe=new r.CompletionItem(Ie.label);return Fe.insertText=Ie.insertText,Fe.kind=De.to(Ie.kind),Fe.tags=Ie.tags?.map(ve.to),Fe.detail=Ie.detail,Fe.documentation=R.isMarkdownString(Ie.documentation)?x.to(Ie.documentation):Ie.documentation,Fe.sortText=Ie.sortText,Fe.filterText=Ie.filterText,Fe.preselect=Ie.preselect,Fe.commitCharacters=Ie.commitCharacters,C.Range.isIRange(Ie.range)?Fe.range=c.to(Ie.range):typeof Ie.range=="object"&&(Fe.range={inserting:c.to(Ie.range.insert),replacing:c.to(Ie.range.replace)}),Fe.keepWhitespace=typeof Ie.insertTextRules>"u"?!1:!!(Ie.insertTextRules&1),typeof Ie.insertTextRules<"u"&&Ie.insertTextRules&4?Fe.insertText=new r.SnippetString(Ie.insertText):(Fe.insertText=Ie.insertText,Fe.textEdit=Fe.range instanceof r.Range?new r.TextEdit(Fe.range,Fe.insertText):void 0),Ie.additionalTextEdits&&Ie.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ie.additionalTextEdits.map(He=>X.to(He))),Fe.command=re&&Ie.command?re.fromInternal(Ie.command):void 0,Fe}Le.to=Ne})(B||(e.CompletionItem=B={}));var K;(function(Le){function Ne(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:x.fromStrict(re.documentation)}}Le.from=Ne;function Ie(re){return{label:re.label,documentation:R.isMarkdownString(re.documentation)?x.to(re.documentation):re.documentation}}Le.to=Ie})(K||(e.ParameterInformation=K={}));var ee;(function(Le){function Ne(re){return{label:re.label,documentation:x.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(K.from):[],activeParameter:re.activeParameter}}Le.from=Ne;function Ie(re){return{label:re.label,documentation:R.isMarkdownString(re.documentation)?x.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(K.to):[],activeParameter:re.activeParameter}}Le.to=Ie})(ee||(e.SignatureInformation=ee={}));var H;(function(Le){function Ne(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.from):[]}}Le.from=Ne;function Ie(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.to):[]}}Le.to=Ie})(H||(e.SignatureHelp=H={}));var ae;(function(Le){function Ne(Ie,re){const Fe=new r.InlayHint(y.to(re.position),typeof re.label=="string"?re.label:re.label.map(ue.to.bind(void 0,Ie)),re.kind&&Ae.to(re.kind));return Fe.textEdits=re.textEdits&&re.textEdits.map(X.to),Fe.tooltip=R.isMarkdownString(re.tooltip)?x.to(re.tooltip):re.tooltip,Fe.paddingLeft=re.paddingLeft,Fe.paddingRight=re.paddingRight,Fe}Le.to=Ne})(ae||(e.InlayHint=ae={}));var ue;(function(Le){function Ne(Ie,re){const Fe=new r.InlayHintLabelPart(re.label);return Fe.tooltip=R.isMarkdownString(re.tooltip)?x.to(re.tooltip):re.tooltip,l.Command.is(re.command)&&(Fe.command=Ie.fromInternal(re.command)),re.location&&(Fe.location=Se.to(re.location)),Fe}Le.to=Ne})(ue||(e.InlayHintLabelPart=ue={}));var Ae;(function(Le){function Ne(re){return re}Le.from=Ne;function Ie(re){return re}Le.to=Ie})(Ae||(e.InlayHintKind=Ae={}));var xe;(function(Le){function Ne(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Le.from=Ne;function Ie(re){let Fe;if(re.url)try{Fe=typeof re.url=="string"?w.URI.parse(re.url,!0):w.URI.revive(re.url)}catch{}return new r.DocumentLink(c.to(re.range),Fe)}Le.to=Ie})(xe||(e.DocumentLink=xe={}));var je;(function(Le){function Ne(re){const Fe=new r.ColorPresentation(re.label);return re.textEdit&&(Fe.textEdit=X.to(re.textEdit)),re.additionalTextEdits&&(Fe.additionalTextEdits=re.additionalTextEdits.map(He=>X.to(He))),Fe}Le.to=Ne;function Ie(re){return{label:re.label,textEdit:re.textEdit?X.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Fe=>X.from(Fe)):void 0}}Le.from=Ie})(je||(e.ColorPresentation=je={}));var Ke;(function(Le){function Ne(re){return new r.Color(re[0],re[1],re[2],re[3])}Le.to=Ne;function Ie(re){return[re.red,re.green,re.blue,re.alpha]}Le.from=Ie})(Ke||(e.Color=Ke={}));var Ze;(function(Le){function Ne(re){return{range:c.from(re.range)}}Le.from=Ne;function Ie(re){return new r.SelectionRange(c.to(re.range))}Le.to=Ie})(Ze||(e.SelectionRange=Ze={}));var at;(function(Le){function Ne(Ie){switch(Ie){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Le.to=Ne})(at||(e.TextDocumentSaveReason=at={}));var ot;(function(Le){function Ne(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Ne;function Ie(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Le.to=Ie})(ot||(e.TextEditorLineNumbersStyle=ot={}));var ke;(function(Le){function Ne(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Le.from=Ne;function Ie(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Le.to=Ie})(ke||(e.EndOfLine=ke={}));var Ue;(function(Le){function Ne(Ie){if(typeof Ie=="object")return Ie.viewId;switch(Ie){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Ne})(Ue||(e.ProgressLocation=Ue={}));var $e;(function(Le){function Ne(re){const Fe={start:re.start+1,end:re.end+1};return re.kind&&(Fe.kind=Re.from(re.kind)),Fe}Le.from=Ne;function Ie(re){const Fe={start:re.start-1,end:re.end-1};return re.kind&&(Fe.kind=Re.to(re.kind)),Fe}Le.to=Ie})($e||(e.FoldingRange=$e={}));var Re;(function(Le){function Ne(re){if(re)switch(re){case r.FoldingRangeKind.Comment:return l.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return l.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return l.FoldingRangeKind.Region}}Le.from=Ne;function Ie(re){if(re)switch(re.value){case l.FoldingRangeKind.Comment.value:return r.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports.value:return r.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region.value:return r.FoldingRangeKind.Region}}Le.to=Ie})(Re||(e.FoldingRangeKind=Re={}));var et;(function(Le){function Ne(Ie){if(Ie)return{pinned:typeof Ie.preview=="boolean"?!Ie.preview:void 0,inactive:Ie.background,preserveFocus:Ie.preserveFocus,selection:typeof Ie.selection=="object"?c.from(Ie.selection):void 0,override:typeof Ie.override=="boolean"?i.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Ne})(et||(e.TextEditorOpenOptions=et={}));var oe;(function(Le){function Ne(He){return He instanceof r.RelativePattern?He.toJSON():typeof He=="string"?He:Ie(He)||re(He)?new r.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Le.from=Ne;function Ie(He){const Je=He;return Je?w.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function re(He){const Je=He;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new r.RelativePattern(w.URI.revive(He.baseUri),He.pattern)}Le.to=Fe})(oe||(e.GlobPattern=oe={}));var le;(function(Le){function Ne(Ie){if(Ie){if(Array.isArray(Ie))return Ie.map(Ne);if(typeof Ie=="string")return Ie;{const re=Ie;return{language:re.language,scheme:re.scheme,pattern:oe.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Le.from=Ne})(le||(e.LanguageSelector=le={}));var Pe;(function(Le){function Ne(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(He=>He&&typeof He=="object"&&"uri"in He&&w.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(Je=>Je instanceof r.Range)))}Le.is=Ne;function Ie(re){return{documents:re.documents.map(Fe=>Fe.map(He=>({uri:w.URI.from(He.uri),version:He.version,ranges:He.ranges.map(Je=>c.from(Je))})))}}Le.from=Ie})(Pe||(e.MappedEditsContext=Pe={}));var Ve;(function(Le){function Ne(re){return{start:re.start,end:re.end}}Le.from=Ne;function Ie(re){return new r.NotebookRange(re.start,re.end)}Le.to=Ie})(Ve||(e.NotebookRange=Ve={}));var Qe;(function(Le){function Ne(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Le.to=Ne;function Ie(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Le.from=Ie})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var it;(function(Le){function Ne(Ie){if(Ie===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ie===n.NotebookCellExecutionState.Pending)return;if(Ie===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ie}`)}Le.to=Ne})(it||(e.NotebookCellExecutionState=it={}));var st;(function(Le){function Ne(re){switch(re){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Le.from=Ne;function Ie(re){switch(re){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Le.to=Ie})(st||(e.NotebookCellKind=st={}));var Me;(function(Le){function Ne(re){const Fe={metadata:re.metadata??Object.create(null),cells:[]};for(const He of re.cells)r.NotebookCellData.validate(He),Fe.cells.push(wt.from(He));return Fe}Le.from=Ne;function Ie(re){const Fe=new r.NotebookData(re.cells.map(wt.to));return(0,g.isEmptyObject)(re.metadata)||(Fe.metadata=re.metadata),Fe}Le.to=Ie})(Me||(e.NotebookData=Me={}));var wt;(function(Le){function Ne(re){return{cellKind:st.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Qe.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(Vt.from):[]}}Le.from=Ne;function Ie(re){return new r.NotebookCellData(st.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(Vt.to):void 0,re.metadata,re.internalMetadata?Qe.to(re.internalMetadata):void 0)}Le.to=Ie})(wt||(e.NotebookCellData=wt={}));var Dt;(function(Le){function Ne(re){return{mime:re.mime,valueBytes:N.VSBuffer.wrap(re.data)}}Le.from=Ne;function Ie(re){return new r.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Le.to=Ie})(Dt||(e.NotebookCellOutputItem=Dt={}));var Vt;(function(Le){function Ne(re){return{outputId:re.id,items:re.items.map(Dt.from),metadata:re.metadata}}Le.from=Ne;function Ie(re){const Fe=re.items.map(Dt.to);return new r.NotebookCellOutput(Fe,re.outputId,re.metadata)}Le.to=Ie})(Vt||(e.NotebookCellOutput=Vt={}));var Bt;(function(Le){function Ne(Fe){return re(Fe)?{include:oe.from(Fe.include)??void 0,exclude:oe.from(Fe.exclude)??void 0}:oe.from(Fe)??void 0}Le.from=Ne;function Ie(Fe){return re(Fe)?{include:oe.to(Fe.include),exclude:oe.to(Fe.exclude)}:oe.to(Fe)}Le.to=Ie;function re(Fe){const He=Fe;return He?!(0,g.isUndefinedOrNull)(He.include)&&!(0,g.isUndefinedOrNull)(He.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var St;(function(Le){function Ne(Ie,re,Fe){const He=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{alignment:Ie.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(He,Fe),text:Ie.text,tooltip:Ie.tooltip,accessibilityInformation:Ie.accessibilityInformation,priority:Ie.priority}}Le.from=Ne})(St||(e.NotebookStatusBarItem=St={}));var Ht;(function(Le){function Ne(Ie,re,Fe){const He=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{command:re.toInternal(He,Fe),label:Ie.label,description:Ie.description,detail:Ie.detail,documentation:Ie.documentation}}Le.from=Ne})(Ht||(e.NotebookKernelSourceAction=Ht={}));var Ot;(function(Le){function Ne(Ie){return{transientOutputs:Ie?.transientOutputs??!1,transientCellMetadata:Ie?.transientCellMetadata??{},transientDocumentMetadata:Ie?.transientDocumentMetadata??{},cellContentMetadata:Ie?.cellContentMetadata??{}}}Le.from=Ne})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Kt;(function(Le){function Ne(re){return{uri:re.uri,provides:re.provides}}Le.from=Ne;function Ie(re){return new r.NotebookRendererScript(w.URI.revive(re.uri),re.provides)}Le.to=Ie})(Kt||(e.NotebookRendererScript=Kt={}));var Mt;(function(Le){function Ne(re){return{message:x.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Le.from=Ne;function Ie(re){const Fe=new r.TestMessage(typeof re.message=="string"?re.message:x.to(re.message));return Fe.actualOutput=re.actual,Fe.expectedOutput=re.expected,Fe.contextValue=re.contextValue,Fe.location=re.location?Se.to(re.location):void 0,Fe}Le.to=Ie})(Mt||(e.TestMessage=Mt={}));var Pt;(function(Le){Le.namespace=a.namespaceTestTag,Le.denamespace=a.denamespaceTestTag})(Pt||(e.TestTag=Pt={}));var tt;(function(Le){function Ne(re){const Fe=(0,s.getPrivateApiFor)(re).controllerId;return{extId:o.TestId.fromExtHostTestItem(re,Fe).toString(),label:re.label,uri:w.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(He=>Pt.namespace(Fe,He.id)),range:C.Range.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&x.fromStrict(re.error)||null}}Le.from=Ne;function Ie(re){return{parent:void 0,error:void 0,id:o.TestId.fromString(re.extId).localId,label:re.label,uri:w.URI.revive(re.uri),tags:(re.tags||[]).map(Fe=>{const{tagId:He}=Pt.denamespace(Fe);return new r.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Le.toPlain=Ie})(tt||(e.TestItem=tt={})),function(Le){function Ne(re){return{id:re.id}}Le.from=Ne;function Ie(re){return new r.TestTag(re.id)}Le.to=Ie}(Pt||(e.TestTag=Pt={}));var jt;(function(Le){const Ne=(re,Fe)=>{const He=[];for(const[qe,rt]of Fe)o.TestId.compare(rt.item.extId,qe)===2&&(Fe.delete(qe),He.push(rt));const Je={...tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(rt=>rt.type===0).map(Mt.to)})),children:He.map(qe=>Ne(qe,Fe))};for(const qe of Je.children)qe.parent=Je;return Je};function Ie(re){const Fe=[],He=new Map;for(const Je of re.items){He.set(Je.item.extId,Je);const qe=o.TestId.root(Je.item.extId);re.request.targets.some(rt=>rt.controllerId===qe&&rt.testIds.includes(Je.item.extId))&&Fe.push(Je)}return{completedAt:re.completedAt,results:Fe.map(Je=>Ne(Je,He))}}Le.to=Ie})(jt||(e.TestResults=jt={}));var qt;(function(Le){function Ne(He){return{covered:He.covered,total:He.total}}function Ie(He){return"line"in He?y.from(He):c.from(He)}function re(He){return"branches"in He?{count:He.executionCount,location:Ie(He.location),type:1,branches:He.branches.length?He.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Ie(Je.location)})):void 0}:{type:0,name:He.name,count:He.executionCount,location:Ie(He.location)}}Le.fromDetailed=re;function Fe(He){return{uri:He.uri,statement:Ne(He.statementCoverage),branch:He.branchCoverage&&Ne(He.branchCoverage),function:He.functionCoverage&&Ne(He.functionCoverage),details:He.detailedCoverage?.map(re)}}Le.fromFile=Fe})(qt||(e.TestCoverage=qt={}));var ut;(function(Le){function Ne(Ie){switch(Ie){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Le.to=Ne})(ut||(e.CodeActionTriggerKind=ut={}));var pt;(function(Le){function Ne(re){const Fe=new r.TypeHierarchyItem(se.to(re.kind),re.name,re.detail||"",w.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Le.to=Ne;function Ie(re,Fe,He){if(Fe=Fe??re._sessionId,He=He??re._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:se.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Q.from)}}Le.from=Ie})(pt||(e.TypeHierarchyItem=pt={}));var xt;(function(Le){function Ne(Ie){if(Ie)return{value:Ie.value,tooltip:Ie.tooltip}}Le.from=Ne})(xt||(e.ViewBadge=xt={}));var zt;(function(Le){function Ne(He,Je,qe){const rt=Je.fileData;return rt?new r.InternalFileDataTransferItem(new r.DataTransferFile(rt.name,w.URI.revive(rt.uri),rt.id,(0,k.createSingleCallFunction)(()=>qe(rt.id)))):He===L.Mimes.uriList&&Je.uriListData?new r.InternalDataTransferItem(Fe(Je.uriListData)):new r.InternalDataTransferItem(Je.asString)}Le.to=Ne;async function Ie(He,Je){const qe=await Je.asString();if(He===L.Mimes.uriList)return{asString:qe,fileData:void 0,uriListData:re(qe)};const rt=Je.asFile();return{asString:qe,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Le.from=Ie;function re(He){return m.UriList.split(He).map(Je=>{if(Je.startsWith("#"))return Je;try{return w.URI.parse(Je)}catch{}return Je})}function Fe(He){return m.UriList.create(He.map(Je=>typeof Je=="string"?Je:w.URI.revive(Je)))}})(zt||(e.DataTransferItem=zt={}));var yt;(function(Le){function Ne(re,Fe){const He=re.items.map(([Je,qe])=>[Je,zt.to(Je,qe,Fe)]);return new r.DataTransfer(He)}Le.toDataTransfer=Ne;async function Ie(re){const Fe={items:[]},He=[];for(const[Je,qe]of re)He.push((async()=>{Fe.items.push([Je,await zt.from(Je,qe)])})());return await Promise.all(He),Fe}Le.from=Ie})(yt||(e.DataTransfer=yt={}));var ht;(function(Le){function Ne(Ie){return{kind:"reply",message:Ie.message,title:Ie.title,tooltip:Ie.tooltip}}Le.from=Ne})(ht||(e.ChatReplyFollowup=ht={}));var Tt;(function(Le){function Ne(Ie){return typeof Ie=="string"?{title:Ie,message:Ie,kind:"reply"}:"commandId"in Ie?{kind:"command",title:Ie.title??"",commandId:Ie.commandId??"",when:Ie.when??"",args:Ie.args}:ht.from(Ie)}Le.from=Ne})(Tt||(e.ChatFollowup=Tt={}));var Yt;(function(Le){function Ne(re){const Fe=new r.ChatMessage(Ct.to(re.role),re.content);return Fe.name=re.name,Fe}Le.to=Ne;function Ie(re){return{role:Ct.from(re.role),content:re.content,name:re.name}}Le.from=Ie})(Yt||(e.ChatMessage=Yt={}));var Ct;(function(Le){function Ne(re){switch(re){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Le.to=Ne;function Ie(re){switch(re){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Le.from=Ie})(Ct||(e.ChatMessageRole=Ct={}));var Xe;(function(Le){function Ne(Fe){const He={};for(const Je of Object.keys(Fe))He[Je]=Fe[Je].map(Le.to);return He}Le.objectTo=Ne;function Ie(Fe){return{level:Rt.to(Fe.level),kind:Fe.kind,value:(0,S.revive)(Fe.value),description:Fe.description}}Le.to=Ie;function re(Fe){return{level:Rt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Le.from=re})(Xe||(e.ChatVariable=Xe={}));var Rt;(function(Le){function Ne(re){switch(re){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Le.to=Ne;function Ie(re){switch(re){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Le.from=Ie})(Rt||(e.ChatVariableLevel=Rt={}));var Wt;(function(Le){function Ne(Ie){switch(Ie){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Le.to=Ne})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Gt;(function(Le){function Ne(Ie,re){return"placeholder"in re&&"resolvedContent"in re?{content:re.placeholder,kind:"asyncContent"}:"markdownContent"in re?((0,h.checkProposedApiEnabled)(Ie,"chatAgents2Additions"),{content:x.from(re.markdownContent),kind:"markdownContent"}):"content"in re?"vulnerabilities"in re&&re.vulnerabilities?((0,h.checkProposedApiEnabled)(Ie,"chatAgents2Additions"),{content:re.content,vulnerabilities:re.vulnerabilities,kind:"vulnerability"}):typeof re.content=="string"?{content:re.content,kind:"content"}:((0,h.checkProposedApiEnabled)(Ie,"chatAgents2Additions"),{content:x.from(re.content),kind:"markdownContent"}):"documents"in re?{documents:re.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(He=>c.from(He))})),kind:"usedContext"}:"reference"in re?{reference:"uri"in re.reference?{uri:re.reference.uri,range:c.from(re.reference.range)}:re.reference,kind:"reference"}:"inlineReference"in re?{inlineReference:"uri"in re.inlineReference?{uri:re.inlineReference.uri,range:c.from(re.inlineReference.range)}:re.inlineReference,name:re.title,kind:"inlineReference"}:"agentName"in re?((0,h.checkProposedApiEnabled)(Ie,"chatAgents2Additions"),{agentName:re.agentName,command:re.command,kind:"agentDetection"}):"treeData"in re?{treeData:re.treeData,kind:"treeData"}:"message"in re?{content:re.message,kind:"progressMessage"}:void 0}Le.from=Ne})(Gt||(e.ChatResponseProgress=Gt={}));var mt;(function(Le){function Ne(Ie){return{label:Ie.label,values:Ie.values.map(Xe.from),insertText:Ie.insertText,detail:Ie.detail,documentation:Ie.documentation}}Le.from=Ne})(mt||(e.ChatAgentCompletionItem=mt={}));var Lt;(function(Le){function Ne(Ie,re,Fe){return"terminalCommand"in Ie?{terminalCommand:Ie.terminalCommand,shouldExecute:Ie.shouldExecute}:"uri"in Ie?{uri:Ie.uri}:re.toInternal(Ie,Fe)}Le.from=Ne})(Lt||(e.TerminalQuickFix=Lt={}))}),define(ye[294],Ce([1,0,2,8,7,15,75]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(S,L,I,g={timeout:1500,errors:3}){this._logService=S,this._documents=L,this._mainThreadBulkEdits=I,this._thresholds=g,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(S){return(L,I,g)=>{const C={dispose:this._callbacks.push([L,I,S])};return Array.isArray(g)&&g.push(C),C}}async $participateInSave(S,L){const I=D.URI.revive(S);let g=!1;const w=setTimeout(()=>g=!0,this._thresholds.timeout),C=[];try{for(const l of[...this._callbacks]){if(g)break;const f=this._documents.getDocument(I),s=await this._deliverEventAsyncAndBlameBadListeners(l,{document:f,reason:k.TextDocumentSaveReason.to(L)});C.push(s)}}finally{clearTimeout(w)}return C}_deliverEventAsyncAndBlameBadListeners([S,L,I],g){const w=this._badListeners.get(S);return typeof w=="number"&&w>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,S,L,g).then(()=>!0,C=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const l=this._badListeners.get(S);this._badListeners.set(S,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(S,L,I,g){const w=[],C=Date.now(),{document:l,reason:f}=g,{version:s}=l,i=Object.freeze({document:l,reason:f,waitUntil(n){if(Object.isFrozen(w))throw(0,N.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(n))}});try{L.apply(I,[i])}catch(n){return Promise.reject(n)}return Object.freeze(w),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(w).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof m.TextEdit))for(const{newText:t,newEol:r,range:h}of a)o.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:h&&k.Range.from(h),text:t,eol:r&&k.EndOfLine.from(r)}});if(o.edits.length!==0)return s===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(ye[295],Ce([1,0,17,2,15,7,111]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class v{constructor(I,g,w,C){this.start=I,this.deletedCount=g,this.deletedItems=w,this.items=C}asApiEvent(){return{range:new k.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(I,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,g,w){this.notebook=I,this._extHostDocument=g,this._cellData=w,this.handle=w.handle,this.uri=N.URI.revive(w.uri),this.cellKind=w.cellKind,this._outputs=w.outputs.map(m.NotebookCellOutput.to),this._internalMetadata=w.internalMetadata??{},this._metadata=Object.freeze(w.metadata??{}),this._previousResult=Object.freeze(m.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:m.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return I._mime},set mime(C){I._mime=C},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(w)}return this._apiCell}setOutputs(I){this._outputs=I.map(m.NotebookCellOutput.to)}setOutputItems(I,g,w){const C=w.map(m.NotebookCellOutputItem.to),l=this._outputs.find(f=>f.id===I);if(l&&(g||(l.items.length=0),l.items.push(...C),l.items.length>1&&l.items.every(f=>R.isTextStreamMime(f.mime)))){const f=new Map,s=[];l.items.forEach(i=>{let n;f.has(i.mime)?n=f.get(i.mime):(n=[],f.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),l.items.length=0,s.forEach(i=>{const n=R.compressOutputItemStreams(f.get(i));l.items.push({mime:i,data:n.data.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(m.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=p;class S{static{this._handlePool=0}constructor(I,g,w,C,l){this._proxy=I,this._textDocumentsAndEditors=g,this._textDocuments=w,this.uri=C,this.handle=S._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0,void 0),this._versionId=l.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const I=this,g={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(w){return w=I._validateIndex(w),I._cells[w].apiCell},getCells(w){return(w?I._getCells(w):I._cells).map(l=>l.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(g)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,g,w){this._versionId=I.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:w});const C={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},l=[];for(const s of I.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1,C.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this._moveCells(s.index,s.length,s.newIdx,C.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this._setCellOutputs(s.index,s.outputs),l.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems),l.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(s.index,s.language),l.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(s.index,s.metadata),l.push({cell:this._cells[s.index].apiCell,metadata:this._cells[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(s.index,s.internalMetadata),l.push({cell:this._cells[s.index].apiCell,executionSummary:this._cells[s.index].apiCell.executionSummary}));const f=new Map;for(let s=0;s<l.length;s++){const i=l[s],n=f.get(i.cell);if(n===void 0){const o=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,o-1)}else C.cellChanges[n]={...C.cellChanges[n],...i}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let g=I.start|0,w=I.end|0;return g<0&&(g=0),w>this._cells.length&&(w=this._cells.length),I.with({start:g,end:w})}_getCells(I){I=this._validateRange(I);const g=[];for(let w=I.start;w<I.end;w++)g.push(this._cells[w]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,g,w){if(this._disposed)return;const C=[],l=[],f=[];if(I.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new p(this,this._textDocumentsAndEditors,t);return g||l.push(p.asModelAddData(this.apiNotebook,t)),r}),o=new v(s[0],s[1],[],n),a=this._cells.splice(s[0],s[1],...n);for(const t of a)f.push(t.uri),o.deletedItems.push(t.apiCell);C.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:f}),w)for(const s of C)w.push(s.asApiEvent())}_moveCells(I,g,w,C){const l=this._cells.splice(I,g);this._cells.splice(w,0,...l);const f=[new v(I,g,l.map(s=>s.apiCell),[]),new v(w,0,[],l)];for(const s of f)C.push(s.asApiEvent())}_setCellOutputs(I,g){this._cells[I].setOutputs(g)}_setCellOutputItems(I,g,w,C){this._cells[I].setOutputItems(g,w,C)}_changeCellLanguage(I,g){const w=this._cells[I];w.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(w.uri,g)}_changeCellMime(I,g){const w=this._cells[I];w.apiCell.mime=g}_changeCellMetadata(I,g){this._cells[I].setMetadata(g)}_changeCellInternalMetadata(I,g){this._cells[I].setInternalMetadata(g)}getCellFromApiCell(I){return this._cells.find(g=>g.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(g=>g.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=S}),define(ye[296],Ce([1,0,4,2,15,7]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(p,S,L,I={timeout:1500,errors:3}){this._logService=p,this._notebooksAndEditors=S,this._mainThreadBulkEdits=L,this._thresholds=I,this._onWillSaveNotebookDocumentEvent=new D.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(p){return(S,L,I)=>{const g=function(C){S.call(L,C)};return g.extension=p,this._onWillSaveNotebookDocumentEvent.event(g,void 0,I)}}async $participateInSave(p,S,L){const I=N.URI.revive(p),g=this._notebooksAndEditors.getNotebookDocument(I);if(!g)throw new Error("Unable to resolve notebook document");const w=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:g.apiNotebook,reason:m.TextDocumentSaveReason.to(S)},L,async(l,f)=>{const s=Date.now(),i=await await Promise.resolve(l);Date.now()-s>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof k.WorkspaceEdit?w.push(i):this._logService.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(w.length===0)return!0;const C={edits:[]};for(const l of w){const{edits:f}=m.WorkspaceEdit.from(l);C.edits=C.edits.concat(f)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(C)}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(ye[146],Ce([1,0,8,15,7]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{static{this.apiEditorsToExtHost=new WeakMap}constructor(v,p,S,L,I,g){this.id=v,this._proxy=p,this.notebookData=S,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=L,this._viewColumn=g}get apiEditor(){if(!this._editor){const v=this;this._editor={get notebook(){return v.notebookData.apiNotebook},get selection(){return v._selections[0]},set selection(p){this.selections=[p]},get selections(){return v._selections},set selections(p){if(!Array.isArray(p)||!p.every(m.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");v._selections=p,v._trySetSelections(p)},get visibleRanges(){return v._visibleRanges},revealRange(p,S){v._proxy.$tryRevealRange(v.id,N.NotebookRange.from(p),S??m.NotebookEditorRevealType.Default)},get viewColumn(){return v._viewColumn}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(v){this._visible=v}_acceptVisibleRanges(v){this._visibleRanges=v}_acceptSelections(v){this._selections=v}_trySetSelections(v){this._proxy.$trySetSelections(this.id,v.map(N.NotebookRange.from))}_acceptViewColumn(v){this._viewColumn=v}}e.ExtHostNotebookEditor=k}),define(ye[297],Ce([1,0,8,4,14,15]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(p,S){this._logService=p,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new N.Emitter({onListenerError:D.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new N.Emitter({onListenerError:D.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(p,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,S);const L=this._notebooksAndEditors.getEditorById(p);S.visibleRanges&&L._acceptVisibleRanges(S.visibleRanges.ranges.map(k.NotebookRange.to)),S.selections&&L._acceptSelections(S.selections.selections.map(k.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const S in p)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(k.ViewColumn.to(p[S]))}};e.ExtHostNotebookEditors=R,e.ExtHostNotebookEditors=R=Ge([We(0,m.ILogService)],R)}),define(ye[298],Ce([1,0,15,85,216,21,59,8]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class p{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,w,C){const l=this._handles++,{title:f,location:s,cancellable:i}=w,n={label:(0,m.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(l,{location:D.ProgressLocation.from(s),title:f,source:n,cancellable:i},g.isUnderDevelopment?void 0:g.identifier.value).catch(v.onUnexpectedExternalError),this._withProgress(l,C,!!i)}_withProgress(g,w,C){let l;C&&(l=new k.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,l));const f=i=>{this._proxy.$progressEnd(i),this._mapHandleToCancellationSource.delete(i),l?.dispose()};let s;try{s=w(new L(this._proxy,g),C&&l?l.token:k.CancellationToken.None)}catch(i){throw f(g),i}return s.then(i=>f(g),i=>f(g)),s}$acceptProgressCanceled(g){const w=this._mapHandleToCancellationSource.get(g);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=p;function S(I,g){return I.message=g.message,typeof g.increment=="number"&&(typeof I.increment=="number"?I.increment+=g.increment:I.increment=g.increment),I}class L extends N.Progress{constructor(g,w){super(C=>this.throttledReport(C)),this._proxy=g,this._handle=w}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}Ge([(0,R.throttle)(100,(I,g)=>S(I,g),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[147],Ce([1,0,29,142,67,112,89,15,2]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const S=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(h){if(!a(r,h)){const u=r;r=h,n.listener?.(t(h,u))}}}},L=(n,o)=>n===o,I={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},g=n=>o=>({op:4,update:n(o)}),w=(n,o)=>({range:(()=>{let a;const t=g(r=>({range:D.Range.lift(v.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),I.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:S(n,o,I.label,g(a=>({label:a}))),description:S(n,void 0,I.description,g(a=>({description:a}))),sortText:S(n,void 0,I.sortText,g(a=>({sortText:a}))),canResolveChildren:S(n,!1,I.canResolveChildren,a=>({op:2,state:a})),busy:S(n,!1,I.busy,g(a=>({busy:a}))),error:S(n,void 0,I.error,g(a=>({error:v.MarkdownString.fromStrict(a)||null}))),tags:S(n,[],I.tags,(a,t)=>({op:1,new:a.map(v.TestTag.from),old:t.map(v.TestTag.from)}))}),C=n=>{const o=m.TestId.fromString(n.extId),a=new f(o.controllerId,o.localId,n.label,p.URI.revive(n.uri)||void 0);return a.range=v.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>v.TestTag.to({id:(0,R.denamespaceTestTag)(t).tagId})),a},l=n=>{let o;for(const a of n.tests){const t=C(a.item);(0,N.getPrivateApiFor)(t).parent=o,o=t}return o};e.toItemFromContext=l;class f{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const h=(0,N.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof s?void 0:h.parent}},children:{value:(0,k.createTestItemChildren)(h,N.getPrivateApiFor,f),enumerable:!0,writable:!1},...w(h,t)})}}e.TestItemImpl=f;class s extends f{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.TestItemRootImpl=s;class i extends k.TestItemCollection{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:N.getPrivateApiFor,getChildren:r=>r.children,root:new s(o,a),toITestItem:v.TestItem.from})}}e.ExtHostTestItemCollection=i}),define(ye[148],Ce([1,0,60,8,121,15,7]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class v{static{this._Keys=new m.IdGenerator("TextEditorDecorationType")}constructor(g,w,C){const l=v._Keys.nextId();g.$registerTextEditorDecorationType(w.identifier,l,k.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:l,dispose(){g.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=v;class p{constructor(g,w){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=w.undoStopBefore,this._undoStopAfter=w.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,w){this._throwIfFinalized();let C=null;if(g instanceof R.Position)C=new R.Range(g,g);else if(g instanceof R.Range)C=g;else throw new Error("Unrecognized location");this._pushEdit(C,w,!1)}insert(g,w){this._throwIfFinalized(),this._pushEdit(new R.Range(g,g),w,!0)}delete(g){this._throwIfFinalized();let w=null;if(g instanceof R.Range)w=g;else throw new Error("Unrecognized location");this._pushEdit(w,null,!0)}_pushEdit(g,w,C){const l=this._document.validateRange(g);this._collectedEdits.push({range:l,text:w,forceMoveMarkers:C})}setEndOfLine(g){if(this._throwIfFinalized(),g!==R.EndOfLine.LF&&g!==R.EndOfLine.CRLF)throw(0,N.illegalArgument)("endOfLine");this._setEndOfLine=g}}class S{constructor(g,w,C,l){this._proxy=g,this._id=w,this._accept(C),this._logService=l;const f=this;this.value={get tabSize(){return f._tabSize},set tabSize(s){f._setTabSize(s)},get indentSize(){return f._indentSize},set indentSize(s){f._setIndentSize(s)},get insertSpaces(){return f._insertSpaces},set insertSpaces(s){f._setInsertSpaces(s)},get cursorStyle(){return f._cursorStyle},set cursorStyle(s){f._setCursorStyle(s)},get lineNumbers(){return f._lineNumbers},set lineNumbers(s){f._setLineNumbers(s)}}}_accept(g){this._tabSize=g.tabSize,this._indentSize=g.indentSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=k.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const w=Math.floor(g);return w>0?w:null}if(typeof g=="string"){const w=parseInt(g,10);return isNaN(w)?null:w>0?w:null}return null}_setTabSize(g){const w=this._validateTabSize(g);if(w!==null){if(typeof w=="number"){if(this._tabSize===w)return;this._tabSize=w}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:w}))}}_validateIndentSize(g){if(g==="tabSize")return"tabSize";if(typeof g=="number"){const w=Math.floor(g);return w>0?w:null}if(typeof g=="string"){const w=parseInt(g,10);return isNaN(w)?null:w>0?w:null}return null}_setIndentSize(g){const w=this._validateIndentSize(g);if(w!==null){if(typeof w=="number"){if(this._indentSize===w)return;this._indentSize=w}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:w}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:!!g}_setInsertSpaces(g){const w=this._validateInsertSpaces(g);if(typeof w=="boolean"){if(this._insertSpaces===w)return;this._insertSpaces=w}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:w}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:k.TextEditorLineNumbersStyle.from(g)})))}assign(g){const w={};let C=!1;if(typeof g.tabSize<"u"){const l=this._validateTabSize(g.tabSize);l==="auto"?(C=!0,w.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,C=!0,w.tabSize=l)}if(typeof g.indentSize<"u"){const l=this._validateIndentSize(g.indentSize);l==="tabSize"?(C=!0,w.indentSize=l):typeof l=="number"&&this._indentSize!==l&&(this._indentSize=l,C=!0,w.indentSize=l)}if(typeof g.insertSpaces<"u"){const l=this._validateInsertSpaces(g.insertSpaces);l==="auto"?(C=!0,w.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,C=!0,w.insertSpaces=l)}typeof g.cursorStyle<"u"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,C=!0,w.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,C=!0,w.lineNumbers=k.TextEditorLineNumbersStyle.from(g.lineNumbers)),C&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,w))}_warnOnError(g,w){w.catch(C=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(C)})}}e.ExtHostTextEditorOptions=S;class L{constructor(g,w,C,l,f,s,i,n){this.id=g,this._proxy=w,this._logService=C,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=f,this._options=new S(this._proxy,this.id,s,C),this._visibleRanges=i,this._viewColumn=n;const o=this;this.value=Object.freeze({get document(){return l.value},set document(a){throw new N.ReadonlyError("document")},get selection(){return o._selections&&o._selections[0]},set selection(a){if(!(a instanceof R.Selection))throw(0,N.illegalArgument)("selection");o._selections=[a],o._trySetSelection()},get selections(){return o._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.Selection)))throw(0,N.illegalArgument)("selections");o._selections=a,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(a){throw new N.ReadonlyError("visibleRanges")},get options(){return o._options.value},set options(a){o._disposed||o._options.assign(a)},get viewColumn(){return o._viewColumn},set viewColumn(a){throw new N.ReadonlyError("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new p(l.value,t);return a(r),o._applyEdit(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=o._selections.map(u=>k.Range.from(u));else if(t instanceof R.Position){const{lineNumber:u,column:c}=k.Position.from(t);h=[{startLineNumber:u,startColumn:c,endLineNumber:u,endColumn:c}]}else if(t instanceof R.Range)h=[k.Range.from(t)];else{h=[];for(const u of t)if(u instanceof R.Range)h.push(k.Range.from(u));else{const{lineNumber:c,column:d}=k.Position.from(u);h.push({startLineNumber:c,startColumn:d,endLineNumber:c,endColumn:d})}}return w.$tryInsertSnippet(g,l.value.version,a.value,h,r)},setDecorations(a,t){const r=t.length===0;r&&!o._hasDecorationsForKey.has(a.key)||(r?o._hasDecorationsForKey.delete(a.key):o._hasDecorationsForKey.add(a.key),o._runOnProxy(()=>{if(k.isDecorationOptionsArr(t))return w.$trySetDecorations(g,a.key,k.fromRangeOrRangeWithMessage(t));{const h=new Array(4*t.length);for(let u=0,c=t.length;u<c;u++){const d=t[u];h[4*u]=d.start.line+1,h[4*u+1]=d.start.character+1,h[4*u+2]=d.end.line+1,h[4*u+3]=d.end.character+1}return w.$trySetDecorationsFast(g,a.key,h)}}))},revealRange(a,t){o._runOnProxy(()=>w.$tryRevealRange(g,k.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){w.$tryShowEditor(g,k.ViewColumn.from(a))},hide(){w.$tryHideEditor(g)}})}dispose(){(0,D.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,D.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,D.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,D.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,D.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(k.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const w=g.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const C=w.edits.map(f=>f.range);C.sort((f,s)=>f.end.line===s.end.line?f.end.character===s.end.character?f.start.line===s.start.line?f.start.character-s.start.character:f.start.line-s.start.line:f.end.character-s.end.character:f.end.line-s.end.line);for(let f=0,s=C.length-1;f<s;f++){const i=C[f].end;if(C[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=w.edits.map(f=>({range:k.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,l,{setEndOfLine:typeof w.setEndOfLine=="number"?k.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this._logService.warn(w),null))}}e.ExtHostTextEditor=L}),define(ye[299],Ce([1,0,220,23,2,4,3,279,12,7,18,19,15,80,21,177,25]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(o,a){if((0,L.isString)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.Disposable{constructor(a,t,r){super(),this._proxy=a,this.commands=t,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeViewsDnDService;function h(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>h(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(c=>h(c)?this.convertArgument(c):c):u})}registerTreeDataProvider(a,t,r){const h=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>h.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,y=this.createExtHostTreeView(a,t,r),A={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:u,hasHandleDrag:c,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},E=this._proxy.$registerTreeViewDataProvider(a,A),b={get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,f.checkProposedApiEnabled)(r,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,f.checkProposedApiEnabled)(r,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(_){(0,w.isMarkdownString)(_)&&(0,f.checkProposedApiEnabled)(r,"treeViewMarkdownMessage"),y.message=_},get title(){return y.title},set title(_){y.title=_},get description(){return y.description},set description(_){y.description=_},get badge(){return y.badge},set badge(_){_!==void 0&&S.ViewBadge.isViewBadge(_)?y.badge={value:Math.floor(Math.abs(_.value)),tooltip:_.tooltip}:_===void 0&&(y.badge=void 0)},reveal:(_,T)=>y.reveal(_,T),dispose:async()=>{await E,this.treeViews.delete(a),y.dispose()}};return this._register(b),b}$getChildren(a,t){const r=this.treeViews.get(a);return r?r.getChildren(t):Promise.reject(new v.NoTreeViewError(a))}async $handleDrop(a,t,r,h,u,c,d,y){const A=this.treeViews.get(a);if(!A)return Promise.reject(new v.NoTreeViewError(a));const E=g.DataTransfer.toDataTransfer(r,async b=>(await this._proxy.$resolveDropFileData(a,t,b)).buffer);return d===a&&y&&await this.addAdditionalTransferItems(E,A,y,u,c),A.onDrop(E,h,u)}async addAdditionalTransferItems(a,t,r,h,u){const c=this.treeDragAndDropService.removeDragOperationTransfer(u);if(c)(await c)?.forEach((d,y)=>{d&&a.set(y,d)});else if(u&&t.handleDrag){const d=t.handleDrag(r,a,h);this.treeDragAndDropService.addDragOperationTransfer(u,d),await d}return a}async $handleDrag(a,t,r,h){const u=this.treeViews.get(a);if(!u)return Promise.reject(new v.NoTreeViewError(a));const c=await this.addAdditionalTransferItems(new S.DataTransfer,u,t,h,r);if(!(!c||h.isCancellationRequested))return g.DataTransfer.from(c)}async $hasResolve(a){const t=this.treeViews.get(a);if(!t)throw new v.NoTreeViewError(a);return t.hasResolve}$resolve(a,t,r){const h=this.treeViews.get(a);if(!h)throw new v.NoTreeViewError(a);return h.resolveTreeItem(t,r)}$setExpanded(a,t,r){const h=this.treeViews.get(a);if(!h)throw new v.NoTreeViewError(a);h.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const h=this.treeViews.get(a);if(!h)throw new v.NoTreeViewError(a);h.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.treeViews.get(a);if(!r){if(!t)return;throw new v.NoTreeViewError(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.treeViews.get(a);if(!r)throw new v.NoTreeViewError(a);r.setCheckboxState(t)}createExtHostTreeView(a,t,r){const h=this._register(new n(a,t,this._proxy,this.commands.converter,this.logService,r));return this.treeViews.set(a,h),h}convertArgument(a){const t=this.treeViews.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=i;class n extends R.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.isUndefinedOrNull)(a))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(a,t,r,h,u,c){if(super(),this.viewId=a,this.proxy=r,this.commands=h,this.logService=u,this.extension=c,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new k.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new k.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new k.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new k.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new k.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new k.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new C.CancellationTokenSource,c.contributes&&c.contributes.views)for(const E in c.contributes.views)for(const b of c.contributes.views[E])b.id===a&&(this._title=b.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(E=>this._onDidChangeData.fire({message:!1,element:E})));let d,y;const A=k.Event.debounce(this._onDidChangeData.event,(E,b)=>(E||(E={message:!1,elements:[]}),b.element!==!1&&(d||(d=new Promise(_=>y=_),this.refreshPromise=this.refreshPromise.then(()=>d)),Array.isArray(b.element)?E.elements.push(...b.element):E.elements.push(b.element)),b.message&&(E.message=!0),E),200,!0);this._register(A(({message:E,elements:b})=>{b.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const _=y;return d=null,this.refresh(b).then(()=>_())})),E&&this.proxy.$setMessage(this.viewId,g.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(a);return r||(r=await this.fetchChildrenNodes(t)),r?r.map(h=>h.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,L.isUndefinedOrNull)(t.select)?!0:t.select,h=(0,L.isUndefinedOrNull)(t.focus)?!1:t.focus,u=(0,L.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(c=>this.resolveTreeNode(a,c[c.length-1]).then(d=>this.proxy.$reveal(this.viewId,{item:d.item,parentChain:c.map(y=>y.item)},{select:r,focus:h,expand:u})),c=>this.logService.error(c)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:h,expand:u})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=g.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,I.equals)(this._selectedHandles,a);this._selectedHandles=a;const h=this._focusedHandle!==t;this._focusedHandle=t,r&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),h&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const h=this.getExtensionElement(r.treeItemHandle);return h?{extensionItem:h,treeItem:await this.dataProvider.getTreeItem(h),newState:r.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const h=[];for(const u of a){const c=this.getExtensionElement(u);c&&h.push(c)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,t,r),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,t,r){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.dndController?.handleDrop))return(0,p.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,a,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,t){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(a);if(r){const h=this.nodes.get(r);if(h){const u=await this.dataProvider.resolveTreeItem(h.extensionItem,r,t)??h.extensionItem;return this.validateTreeItem(u),h.item.tooltip=this.getTooltip(u.tooltip),h.item.command=this.getCommand(h.disposableStore,u.command),h.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(t=>t?this.resolveUnknownParentChain(t).then(r=>this.resolveTreeNode(t,r[r.length-1]).then(h=>(r.push(h),r))):Promise.resolve([]))}resolveParent(a){const t=this.nodes.get(a);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,p.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,t){const r=this.nodes.get(a);return r?Promise.resolve(r):(0,p.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(h=>this.createHandle(a,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(h);if(u){const c=this.nodes.get(u);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.nodes.get(r):void 0}else t=a;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const t=new C.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=a?this.nodes.get(a):void 0,h=await this.dataProvider.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,I.coalesce)(h||[]).map(async c=>{const d=await this.dataProvider.getTreeItem(c);return d&&!t.token.isCancellationRequested?this.createAndRegisterTreeNode(c,d,r):null}));return t.token.isCancellationRequested?void 0:(0,I.coalesce)(u)}finally{t.dispose()}}refresh(a){if(a.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new C.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(a);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const t=new Set,r=a.map(u=>this.nodes.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let c=u;for(;c&&c.parent&&r.findIndex(d=>c&&c.parent&&d&&d.item.handle===c.parent.item.handle)===-1;){const d=this.elements.get(c.parent.item.handle);c=d?this.nodes.get(d):void 0}c&&!c.parent&&t.add(u.item.handle)}const h=[];return t.forEach(u=>{const c=this.elements.get(u);if(c){const d=this.nodes.get(c);d&&(!d.parent||!t.has(d.parent.item.handle))&&h.push(u)}}),h}refreshHandles(a){const t={};return Promise.all(a.map(r=>this.refreshNode(r).then(h=>{h&&(t[r]=h.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(a){const t=this.getExtensionElement(a);if(t){const r=this.nodes.get(t);if(r)return this.clearChildren(t),(0,p.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(h=>{if(h){const u=this.createTreeNode(t,h,r.parent);return this.updateNodeCache(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,t,r){const h=this.createTreeNode(a,t,r);if(t.id&&this.elements.has(h.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.addNodeToCache(a,h),this.addNodeToParentCache(h,r),h}getTooltip(a){return S.MarkdownString.isMarkdownString(a)?g.MarkdownString.from(a):a}getCommand(a,t){return t?{...this.commands.toInternal(t,a),originalId:t.command}:void 0}getCheckbox(a){if(a.checkboxState===void 0)return;let t,r,h;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,h=a.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:h}}validateTreeItem(a){if(!S.TreeItem.isTreeItem(a,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(a,t,r){this.validateTreeItem(t);const h=this._register(new R.DisposableStore),u=this.createHandle(a,t,r),c=this.getLightIconPath(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(h,t.command),contextValue:t.contextValue,icon:c,iconDark:this.getDarkIconPath(t)||c,themeIcon:this.getThemeIcon(t),collapsibleState:(0,L.isUndefinedOrNull)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:r,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(a){return a.iconPath instanceof S.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:t,label:r,resourceUri:h},u,c){if(t)return`${n.ID_HANDLE_PREFIX}/${t}`;const d=s(r,this.extension),y=u?u.item.handle:n.LABEL_HANDLE_PREFIX;let A=d?d.label:h?(0,N.basename)(h):"";A=A.indexOf("/")!==-1?A.replace("/","//"):A;const E=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,b=this.getChildrenNodes(u)||[];let _,T=0;do{if(_=`${y}/${T}:${A}`,c||!this.elements.has(_)||E===_)break;T++}while(T<=b.length);return _}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof S.ThemeIcon))return typeof a.iconPath=="string"||m.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof S.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return m.URI.isUri(a)?a:m.URI.file(a)}addNodeToCache(a,t){this.elements.set(t.item.handle,a),this.nodes.set(a,t)}updateNodeCache(a,t,r,h){this.elements.delete(t.item.handle),this.nodes.delete(a),t.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(a,t);const u=this.getChildrenNodes(h)||[],c=u.filter(d=>d.item.handle===r.item.handle)[0];c&&u.splice(u.indexOf(c),1,t)}addNodeToParentCache(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const t=this.nodes.get(a);if(t){if(t.children)for(const r of t.children){const h=this.elements.get(r.item.handle);h&&this.clear(h)}t.children=void 0}}else this.clearAll()}clear(a){const t=this.nodes.get(a);if(t){if(t.children)for(const r of t.children){const h=this.elements.get(r.item.handle);h&&this.clear(h)}this.nodes.delete(a),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(ye[300],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[301],Ce([1,0,234,8,39,134,108,37,26,300,136,137]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const g=v.Registry.as(R.Extensions.JSONContribution);class w{constructor(a,t,r){this._messageHandler=a,this._extension=t,this._extensionPointId=r}_msg(a,t){this._messageHandler({type:a,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(m.default.Error,a)}warn(a){this._msg(m.default.Warning,a)}info(a){this._msg(m.default.Info,a)}}e.ExtensionMessageCollector=w;class C{static _toSet(a){const t=new p.ExtensionIdentifierSet;for(let r=0,h=a.length;r<h;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new C(t,[]);if(!t||!t.length)return new C([],a);const r=this._toSet(a),h=this._toSet(t),u=t.filter(d=>!r.has(d.description.identifier)),c=a.filter(d=>!h.has(d.description.identifier));return new C(u,c)}constructor(a,t){this.added=a,this.removed=t}}e.ExtensionPointUserDelta=C;class l{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=C.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,N.onUnexpectedError)(a)}}}e.ExtensionPoint=l;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new l(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,t),a.activationEventsGenerator&&I.ImplicitActivationEvents.register(a.extensionPoint,a.activationEventsGenerator),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,g.registerSchema(s,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};v.Registry.add(n.ExtensionsRegistry,new i),e.ExtensionsRegistry=v.Registry.as(n.ExtensionsRegistry),g.registerSchema(s,e.schema),g.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ye[302],Ce([1,0,230,18,24,301,46,4]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var S;(function(g){function w(C,l,f){if(!C)return;const s=N.isString(C.type)?C.type:void 0;if(!s||s.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(C.required))for(const n of C.required)N.isString(n)&&i.push(n);return{extensionId:l.value,taskType:s,required:i,properties:C.properties?m.deepClone(C.properties):{},when:C.when?R.ContextKeyExpr.deserialize(C.when):void 0}}g.from=w})(S||(S={}));const L=k.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(g,w)=>{for(const C of g)C.type&&w.push(`onTaskType:${C.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:p}});class I{constructor(){this._onDefinitionsChanged=new v.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((w,C)=>{L.setHandler((l,f)=>{this._schema=void 0;try{for(const s of f.removed){const i=s.value;for(const n of i)this.taskTypes&&n.type&&this.taskTypes[n.type]&&delete this.taskTypes[n.type]}for(const s of f.added){const i=s.value;for(const n of i){const o=S.from(n,s.description.identifier,s.collector);o&&(this.taskTypes[o.taskType]=o)}}(f.removed.length>0||f.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}w(void 0)})})}onReady(){return this.readyPromise}get(w){return this.taskTypes[w]}all(){return Object.keys(this.taskTypes).map(w=>this.taskTypes[w])}getJsonSchema(){if(this._schema===void 0){const w=[];for(const C of this.all()){const l={type:"object",additionalProperties:!1};C.required.length>0&&(l.required=C.required.slice(0)),C.properties!==void 0?l.properties=m.deepClone(C.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[C.taskType]},w.push(l)}this._schema={oneOf:w}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(ye[303],Ce([1,0,231,18,23,24,46,302]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,D.localize(0,null)),e.TASKS_CATEGORY={value:D.localize(1,null),original:"Tasks"};var p;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function O(W){if(!W)return F.Strong;switch(W.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=O}(p||(e.ShellQuoting=p={}));var S;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var L;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(L||(e.RevealKind=L={})),function(F){function O(W){switch(W.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=O}(L||(e.RevealKind=L={}));var I;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(F){function O(W){switch(W.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=O}(I||(e.RevealProblemKind=I={}));var g;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(g||(e.PanelKind=g={})),function(F){function O(W){switch(W.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=O}(g||(e.PanelKind=g={}));var w;(function(F){F.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var C;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(F){function O(J){switch(J.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=O;function W(J){switch(J){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=W}(C||(e.RuntimeType=C={}));var l;(function(F){function O(W){return N.isString(W)?W:W.value}F.value=O})(l||(e.CommandString=l={}));var f;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function O(J){return J===F.Clean._id||J===F.Build._id||J===F.Rebuild._id||J===F.Test._id}F.is=O;function W(J){if(J!==void 0)return N.isString(J)?O(J)?{_id:J,isDefault:!1}:void 0:J}F.from=W})(f||(e.TaskGroup=f={}));var s;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function O(W){switch(W){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(F){F.parallel="parallel",F.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,W,J,ce,G,X){this._label="",this._id=O,W&&(this._label=W),J&&(this.type=J),this.runOptions=ce,this.configurationProperties=G,this._source=X}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.getFolderId(),id:this._id};return JSON.stringify(O)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,W=!1){if(O===void 0)return!1;if(N.isString(O))return O===this._label||O===this.configurationProperties.identifier||W&&O===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),O&&(this._taskLoadMessages=this._taskLoadMessages.concat(O))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class r extends t{constructor(O,W,J,ce,G,X,Y,se){super(O,J,void 0,Y,se,W),this.command={},this._source=W,this.hasDefinedMatchers=X,G&&(this.command=G)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case C.Shell:W="shell";break;case C.Process:W="process";break;case C.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(O){return O instanceof r}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.getFolderId();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const J={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:W};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(O){return new r(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.CustomTask=r;class h extends t{constructor(O,W,J,ce,G,X,Y){super(O,J,ce,X,Y,W),this._source=W,this.configures=G}static is(O){return O instanceof h}fromObject(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.getFolderId();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const J={type:e.CUSTOMIZED_TASK_TYPE,folder:O,id:W};return JSON.stringify(J)}}e.ConfiguringTask=h;class u extends t{constructor(O,W,J,ce,G,X,Y,se,Q){super(O,J,ce,se,Q,W),this.defines=G,this.hasDefinedMatchers=Y,this.command=X,this.icon=Q.icon,this.hide=Q.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof u}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.getFolderId(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(O){return new u(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.ContributedTask=u;class c extends t{constructor(O,W,J,ce,G,X){super(O,J,ce,G,X,W),this._source=W}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(O){return new c(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.InMemoryTask=c;var d;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(F){F._default=F.Terminal}(d||(e.ExecutionEngine=d={}));var y;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class A{constructor(O){this._order=new Map;for(let W=0;W<O.length;W++)this._order.set(O[W].uri.toString(),W)}compare(O,W){const J=O.getWorkspaceFolder(),ce=W.getWorkspaceFolder();if(J&&ce){let G=this._order.get(J.uri.toString());G=G===void 0?0:G+1;let X=this._order.get(ce.uri.toString());return X=X===void 0?0:X+1,G===X?O._label.localeCompare(W._label):G-X}else return!J&&ce?-1:J&&!ce?1:0}}e.TaskSorter=A;var E;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(E||(e.TaskEventKind=E={}));var b;(function(F){F.SingleRun="singleRun",F.Background="background"})(b||(e.TaskRunType=b={}));var _;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(_||(e.TaskRunSource=_={}));var T;(function(F){function O(se){return{taskId:se._id,taskName:se.configurationProperties.name,runType:se.configurationProperties.isBackground?"background":"singleRun",group:se.configurationProperties.group,__task:se}}function W(se,Q,we){return{...O(se),kind:"start",terminalId:Q,resolvedVariables:we}}F.start=W;function J(se,Q,we){return{...O(se),kind:"processStarted",terminalId:Q,processId:we}}F.processStarted=J;function ce(se,Q,we){return{...O(se),kind:"processEnded",terminalId:Q,exitCode:we}}F.processEnded=ce;function G(se,Q,we){return{...O(se),kind:"terminated",exitReason:we,terminalId:Q}}F.terminated=G;function X(se,Q,we){return{...O(Q),kind:se,terminalId:we}}F.general=X;function Y(){return{kind:"changed"}}F.changed=Y})(T||(e.TaskEvent=T={}));var U;(function(F){function O(J){const ce=Object.keys(J).sort();let G="";for(const X of ce){let Y=J[X];Y instanceof Object?Y=O(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),G+=X+","+Y+","}return G}function W(J){const G={_key:O(J),type:J.taskType};return Object.assign(G,J),G}F.create=W})(U||(e.KeyedTaskIdentifier=U={}));var M;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var P;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(P||(e.TasksSchemaProperties=P={}));var x;(function(F){function O(W,J){const ce=v.TaskDefinitionRegistry.get(W.type);if(ce===void 0){const se=k.deepClone(W);return delete se._key,U.create(se)}const G=Object.create(null);G.type=ce.taskType;const X=new Set;ce.required.forEach(se=>X.add(se));const Y=ce.properties;for(const se of Object.keys(Y)){const Q=W[se];if(Q!=null)G[se]=Q;else if(X.has(se)){const we=Y[se];if(we.default!==void 0)G[se]=k.deepClone(we.default);else switch(we.type){case"boolean":G[se]=!1;break;case"number":case"integer":G[se]=0;break;case"string":G[se]="";break;default:J.error(D.localize(2,null,JSON.stringify(W,void 0,0),se));return}}}return U.create(G)}F.createTaskIdentifier=O})(x||(e.TaskDefinition=x={}))}),define(ye[304],Ce([1,0,8]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class N{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,v)=>{this._actualOk=R,this._actualErr=v,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,D.onUnexpectedError)(R))}then(R,v){return this._ensureActual().then(R,v)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=N;class m extends N{constructor(){super(),this._hasErr=!0,this._err=new D.CancellationError}}e.CanceledLazyPromise=m}),define(ye[68],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class D{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++D.count}}e.ProxyIdentifier=D;const N=[];function m(v){const p=new D(v);return N[p.nid]=p,p}e.createProxyIdentifier=m;function k(v){return N[v].sid}e.getStringIdentifierForProxy=k;class R{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=R}),define(ye[6],Ce([1,0,68]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var m;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput"})(m||(e.TabInputKind=m={}));var k;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(k||(e.TabModelOperationKind=k={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var v;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(v||(e.WebviewMessageArrayBufferViewType=v={}));var p;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var S;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var L;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class I{static{this._n=0}static mixin(f){return f._id=I._n++,f}}e.IdObject=I;var g;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(g||(e.ISuggestDataDtoField=g={}));var w;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var C;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.MainContext={MainThreadAuthentication:(0,D.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,D.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,D.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,D.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,D.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,D.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,D.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,D.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,D.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,D.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,D.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,D.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,D.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,D.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,D.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,D.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,D.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.createProxyIdentifier)("ExtHostIssueReporter")}}),define(ye[305],Ce([1,0,6,7]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class m{constructor(R){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(D.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,v,p){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const S=this._relatedInformationProviders.get(R);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(v,p)??[]}getRelatedInformation(R,v,p){return this._proxy.$getAiRelatedInformation(v,p)}registerRelatedInformationProvider(R,v,p){const S=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(S,p),this._proxy.$registerAiRelatedInformationProvider(S,v),new N.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(S),this._relatedInformationProviders.delete(S)})}}e.ExtHostRelatedInformation=m}),define(ye[91],Ce([1,0,5,14,6,20]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,D.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(p,S){this._extHostLogService=S,this._reportedUsages=new Set,this._telemetryShape=p.getProxy(m.MainContext.MainThreadTelemetry)}report(p,S,L){const I=this.getUsageKey(p,S);this._reportedUsages.has(I)||(this._reportedUsages.add(I),S.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${p}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:p}))}getUsageKey(p,S){return`${p}-${S.identifier.value}`}};e.ExtHostApiDeprecationService=R,e.ExtHostApiDeprecationService=R=Ge([We(0,k.IExtHostRpcService),We(1,N.ILogService)],R),e.NullApiDeprecationService=Object.freeze(new class{report(v,p,S){}})}),define(ye[306],Ce([1,0,4,6,7,26]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new D.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new v,this._getSessionsTaskSingler=new v,this._proxy=S.getProxy(N.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,L,I,g={}){const w=k.ExtensionIdentifier.toKey(S.identifier),C=[...I].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${w} ${L} ${C}`,async()=>{await this._proxy.$ensureProvider(L);const l=S.displayName||S.name;return this._proxy.$getSession(L,I,w,l,g)})}async getSessions(S,L,I){const g=k.ExtensionIdentifier.toKey(S.identifier),w=[...I].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${g} ${w}`,async()=>{await this._proxy.$ensureProvider(L);const C=S.displayName||S.name;return this._proxy.$getSessions(L,I,g,C)})}async removeSession(S,L){const I=this._authenticationProviders.get(S);return I?I.provider.removeSession(L):this._proxy.$removeSession(S,L)}registerAuthenticationProvider(S,L,I,g){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:L,provider:I,options:g??{supportsMultipleAccounts:!1}}),this._providers.find(C=>C.id===S)||this._providers.push({id:S,label:L});const w=I.onDidChangeSessions(C=>{this._proxy.$sendDidChangeSessions(S,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,L,g?.supportsMultipleAccounts??!1),new m.Disposable(()=>{w.dispose(),this._authenticationProviders.delete(S);const C=this._providers.findIndex(l=>l.id===S);C>-1&&this._providers.splice(C),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,L,I){const g=this._authenticationProviders.get(S);if(g)return Promise.resolve(g.provider.createSession(L,I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,L){const I=this._authenticationProviders.get(S);if(I)return Promise.resolve(I.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,L){const I=this._authenticationProviders.get(S);if(I)return Promise.resolve(I.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,L){return this._onDidChangeSessions.fire({provider:{id:S,label:L}}),Promise.resolve()}}e.ExtHostAuthentication=R;class v{constructor(){this._inFlightPromises=new Map}getOrCreate(S,L){const I=this._inFlightPromises.get(S);if(I)return I;const g=L().finally(()=>this._inFlightPromises.delete(S));return this._inFlightPromises.set(S,g),g}}}),define(ye[307],Ce([1,0,6,20,15]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let k=class{constructor(v,p){this._proxy=v.getProxy(D.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:S=>p.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,p,S){const L=m.WorkspaceEdit.from(v,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,S?.isRefactoring??!1)}};e.ExtHostBulkEdits=k,e.ExtHostBulkEdits=k=Ge([We(0,N.IExtHostRpcService)],k)}),define(ye[308],Ce([1,0,4,52,3,6,15]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class v{static{this._pool=0}constructor(L,I){this.extension=L,this.provider=I,this.handle=v._pool++}}class p{static{this._nextId=0}constructor(L){this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new D.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=L.getProxy(k.MainContext.MainThreadChat)}registerChatProvider(L,I,g){const w=new v(L,g);return this._chatProvider.set(w.handle,w),this._proxy.$registerChatProvider(w.handle,I),(0,m.toDisposable)(()=>{this._proxy.$unregisterChatProvider(w.handle),this._chatProvider.delete(w.handle)})}transferChatSession(L,I){const g=N.Iterable.find(this._chatSessions.keys(),w=>this._chatSessions.get(w)===L)??0;typeof g=="number"&&this._proxy.$transferChatSession(g,I)}sendInteractiveRequestToProvider(L,I){this._proxy.$sendRequestToProvider(L,I)}async $prepareChat(L,I){const g=this._chatProvider.get(L);if(!g)return;const w=await g.provider.prepareSession(I);if(!w)return;const C=p._nextId++;return this._chatSessions.set(C,w),{id:C,requesterUsername:w.requester?.name,requesterAvatarIconUri:w.requester?.icon,responderUsername:w.responder?.name,responderAvatarIconUri:w.responder?.icon,inputPlaceholder:w.inputPlaceholder}}async $provideWelcomeMessage(L,I){const g=this._chatProvider.get(L);if(!g||!g.provider.provideWelcomeMessage)return;const w=await g.provider.provideWelcomeMessage(I);if(w)return w.map(C=>typeof C=="string"?C:Array.isArray(C)?C.map(l=>R.ChatReplyFollowup.from(l)):R.MarkdownString.from(C))}async $provideSampleQuestions(L,I){const g=this._chatProvider.get(L);if(!g||!g.provider.provideSampleQuestions)return;const w=await g.provider.provideSampleQuestions(I);if(w)return w?.map(C=>R.ChatReplyFollowup.from(C))}$releaseSession(L){this._chatSessions.delete(L)}async $onDidPerformUserAction(L){this._onDidPerformUserAction.fire(L)}}e.ExtHostChat=p}),define(ye[309],Ce([1,0,12,21,44,4,38,18,2,210,85,6,15,7,280,25]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class f{static{this._idPool=0}constructor(n,o,a){this._extHostChatProvider=o,this._logService=a,this._agents=new Map,this._previousResultMap=new Map,this._resultsBySessionAndRequestId=new Map,this._proxy=n.getProxy(I.MainContext.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=f._idPool++,r=new s(n,o,this._proxy,t,a);return this._agents.set(t,r),this._proxy.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,h){this._previousResultMap.delete(o);const u=this._agents.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let c=!1;function d(){if(c)throw new Error("Only valid while executing the command")}const y=new D.DeferredPromise;h.onCancellationRequested(()=>y.complete()),setTimeout(()=>y.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(u.extension.identifier,y.p);const A=t.command?await u.validateSlashCommand(t.command):void 0,E=R.StopWatch.create(!1);let b;try{const _=u.invoke({prompt:t.message,variables:g.ChatVariable.objectTo(t.variables),slashCommand:A},{history:r.history.map(g.ChatMessage.to)},new L.Progress(T=>{d(),typeof b>"u"&&"content"in T&&(b=E.elapsed());const U=g.ChatResponseProgress.from(u.extension,T);if(!U){this._logService.error("Unknown progress type: "+JSON.stringify(T));return}if("placeholder"in T&&"resolvedContent"in T){const M=Promise.all([this._proxy.$handleProgressChunk(a,U),T.resolvedContent]);(0,D.raceCancellation)(M,h).then(P=>{if(!P)return;const[x,F]=P,O=g.ChatResponseProgress.from(u.extension,F);if(!O){this._logService.error("Unknown progress type: "+JSON.stringify(F));return}this._proxy.$handleProgressChunk(a,O,x??void 0)})}else this._proxy.$handleProgressChunk(a,U)}),h);return await(0,D.raceCancellation)(Promise.resolve(_).then(T=>{if(T){this._previousResultMap.set(o,T);let U=this._resultsBySessionAndRequestId.get(o);U||(U=new Map,this._resultsBySessionAndRequestId.set(o,U)),U.set(a,T);const M={firstProgress:b,totalElapsed:E.elapsed()};return{errorDetails:T.errorDetails,timings:M}}else this._previousResultMap.delete(o)}),h)}catch(_){return this._logService.error(_,u.extension),{errorDetails:{message:(0,S.localize)(0,null,(0,m.toErrorMessage)(_)),responseIsIncomplete:!0}}}finally{c=!0,y.complete()}}$releaseSession(n){this._previousResultMap.delete(n),this._resultsBySessionAndRequestId.delete(n)}async $provideSlashCommands(n,o){const a=this._agents.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this._agents.get(n);if(!t)return Promise.resolve([]);const r=this._previousResultMap.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t,r){const h=this._agents.get(n);if(!h)return;const u=this._resultsBySessionAndRequestId.get(o)?.get(a);if(!u)return;let c;switch(t){case C.InteractiveSessionVoteDirection.Down:c=w.ChatAgentResultFeedbackKind.Unhelpful;break;case C.InteractiveSessionVoteDirection.Up:c=w.ChatAgentResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(r?{result:u,kind:c,reportIssue:r}:{result:u,kind:c}))}$acceptAction(n,o,a,t){const r=this._agents.get(n);if(!r)return;const h=this._resultsBySessionAndRequestId.get(o)?.get(a);h&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:h}))}async $invokeCompletionProvider(n,o,a){const t=this._agents.get(n);return t?(await t.invokeCompletionProvider(o,a)).map(g.ChatAgentCompletionItem.from):[]}}e.ExtHostChatAgents2=f;class s{constructor(n,o,a,t,r){this.extension=n,this._id=o,this._proxy=a,this._handle=t,this._callback=r,this._onDidReceiveFeedback=new k.Emitter,this._onDidPerformAction=new k.Emitter}acceptFeedback(n){this._onDidReceiveFeedback.fire(n)}acceptAction(n){this._onDidPerformAction.fire(n)}async invokeCompletionProvider(n,o){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(n,o)??[]:[]}async validateSlashCommand(n){this._lastSlashCommands||(await this.provideSlashCommand(N.CancellationToken.None),(0,v.assertType)(this._lastSlashCommands));const o=this._lastSlashCommands.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this._slashCommandProvider)return[];const o=await this._slashCommandProvider.provideSlashCommands(n);return o?(this._lastSlashCommands=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,o){if(!this._followupProvider)return[];const a=await this._followupProvider.provideFollowups(n,o);return a?a.map(t=>g.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof p.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof w.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._slashCommandProvider!==void 0,hasFollowups:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:g.MarkdownString.from(this._helpTextPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:g.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting}),o=!1}))},t=this;return{get name(){return t._id},get description(){return t._description??""},set description(r){t._description=r,a()},get fullName(){return t._fullName??t.extension.displayName??t.extension.name},set fullName(r){t._fullName=r,a()},get iconPath(){return t._iconPath},set iconPath(r){t._iconPath=r,a()},get slashCommandProvider(){return t._slashCommandProvider},set slashCommandProvider(r){t._slashCommandProvider=r,a()},get followupProvider(){return t._followupProvider},set followupProvider(r){t._followupProvider=r,a()},get isDefault(){return(0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isDefault},set isDefault(r){(0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isDefault=r,a()},get helpTextPrefix(){return(0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._helpTextPrefix},set helpTextPrefix(r){if((0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),!t._isDefault)throw new Error("helpTextPrefix is only available on the default chat agent");t._helpTextPrefix=r,a()},get helpTextPostfix(){return(0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._helpTextPostfix},set helpTextPostfix(r){if((0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),!t._isDefault)throw new Error("helpTextPostfix is only available on the default chat agent");t._helpTextPostfix=r,a()},get isSecondary(){return(0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isSecondary},set isSecondary(r){(0,l.checkProposedApiEnabled)(t.extension,"defaultChatAgent"),t._isSecondary=r,a()},get sampleRequest(){return t._sampleRequest},set sampleRequest(r){t._sampleRequest=r,a()},get supportIssueReporting(){return(0,l.checkProposedApiEnabled)(t.extension,"chatAgents2Additions"),t._supportIssueReporting},set supportIssueReporting(r){(0,l.checkProposedApiEnabled)(t.extension,"chatAgents2Additions"),t._supportIssueReporting=r,a()},get onDidReceiveFeedback(){return t._onDidReceiveFeedback.event},set agentVariableProvider(r){if(t._agentVariableProvider=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t._proxy.$registerAgentCompletionsProvider(t._handle,r.triggerCharacters)}else t._proxy.$unregisterAgentCompletionsProvider(t._handle)},get agentVariableProvider(){return t._agentVariableProvider},onDidPerformAction:(0,l.isProposedApiEnabled)(this.extension,"chatAgents2Additions")?this._onDidPerformAction.event:void 0,dispose(){n=!0,t._slashCommandProvider=void 0,t._followupProvider=void 0,t._onDidReceiveFeedback.dispose(),t._proxy.$unregisterAgent(t._handle)}}}invoke(n,o,a,t){return this._callback(n,o,a,t)}}}),define(ye[310],Ce([1,0,21,3,6,15,85,26,12,4]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class L{constructor(C,l){this.stream=new p.AsyncIterableSource,this.stream=l??new p.AsyncIterableSource;const f=this;this.apiObj={option:C,response:f.stream.asyncIterable}}}class I{constructor(C,l){this._onDidStart=new S.Emitter,this._responseStreams=new Map,this._defaultStream=new p.AsyncIterableSource,this._isDone=!1;const f=this;this.apiObject={result:C,response:f._defaultStream.asyncIterable,onDidStartResponseStream:f._onDidStart.event,cancel(){l.cancel()}},C.finally(()=>{if(this._isDone=!0,this._responseStreams.size>0)for(const[,s]of this._responseStreams)s.stream.resolve();else this._defaultStream.resolve()})}handleFragment(C){if(this._isDone)return;let l=this._responseStreams.get(C.index);l||(this._responseStreams.size===0?l=new L(C.index,this._defaultStream):l=new L(C.index),this._responseStreams.set(C.index,l),this._onDidStart.fire(l.apiObj)),l.stream.emitOne(C.part)}}class g{static{this._idPool=1}constructor(C,l){this._logService=l,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new v.ExtensionIdentifierMap,this._proxy=C.getProxy(m.MainContext.MainThreadChatProvider)}registerProvider(C,l,f,s){const i=g._idPool++;return this._providers.set(i,{extension:C,provider:f}),this._proxy.$registerProvider(i,l,{extension:C,model:s.name??""}),(0,N.toDisposable)(()=>{this._proxy.$unregisterProvider(i),this._providers.delete(i)})}async $provideChatResponse(C,l,f,s,i){const n=this._providers.get(C);if(!n)return;const o=new R.Progress(async a=>{if(i.isCancellationRequested){this._logService.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(l,{index:a.index,part:a.part})});return n.provider.provideChatResponse(f.map(k.ChatMessage.to),s,o,i)}allowListExtensionWhile(C,l){this._chatAccessAllowList.set(C,l),l.finally(()=>this._chatAccessAllowList.delete(C))}async requestChatResponseProvider(C,l){if(!this._chatAccessAllowList.has(C))throw new Error("Extension is NOT allowed to make chat requests");const f=await this._proxy.$prepareChatAccess(l);if(!f)throw new Error(`ChatAccess '${l}' NOT found`);const s=this;return{get model(){return f.model},get isRevoked(){return!s._chatAccessAllowList.has(C)},makeRequest(i,n,o){if(!s._chatAccessAllowList.has(C))throw new Error("Access to chat has been revoked");const a=new D.CancellationTokenSource(o),t=Math.random()*1e6|0,r=s._proxy.$fetchResponse(C,l,t,i.map(k.ChatMessage.from),n??{},a.token),h=new I(r,a);return s._pendingRequest.set(t,{res:h}),r.finally(()=>{s._pendingRequest.delete(t)}),h.apiObject}}}async $handleResponseFragment(C,l){const f=this._pendingRequest.get(C);f&&f.res.handleFragment(l)}}e.ExtHostChatProvider=g}),define(ye[311],Ce([1,0,3,6,8,15]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class R{static{this._idPool=0}constructor(p){this._resolver=new Map,this._proxy=p.getProxy(N.MainContext.MainThreadChatVariables)}async $resolveVariable(p,S,L){const I=this._resolver.get(p);if(I)try{const g=await I.resolver.resolve(I.data.name,{message:S},L);if(g)return g.map(k.ChatVariable.from)}catch(g){(0,m.onUnexpectedExternalError)(g)}}registerVariableResolver(p,S,L,I){const g=R._idPool++;return this._resolver.set(g,{extension:p.identifier,data:{name:S,description:L},resolver:I}),this._proxy.$registerVariable(g,{name:S,description:L}),(0,D.toDisposable)(()=>{this._resolver.delete(g),this._proxy.$unregisterVariable(g)})}}e.ExtHostChatVariables=R}),define(ye[312],Ce([1,0,6]),function(ge,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class N{constructor(k){const R=k.getProxy(D.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(v){return R.$writeText(v)}})}}e.ExtHostClipboard=N}),define(ye[35],Ce([1,0,18,7,15,24,6,19,14,54,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{#e;#t;#i;constructor(E,b,_){this._commands=new Map,this._apiCommands=new Map,this.#e=E.getProxy(R.MainContext.MainThreadCommands),this._logService=b,this.#i=_,this.#t=E.getProxy(R.MainContext.MainThreadTelemetry),this.converter=new u(this,T=>{const U=this._apiCommands.get(T);return U?.result===d.Void?U:void 0},b),this._argumentProcessors=[{processArgument(T){return(0,S.revive)(T)}},{processArgument(T){return(0,k.cloneAndChange)(T,function(U){if(L.Range.isIRange(U))return m.Range.to(U);if(I.Position.isIPosition(U))return m.Position.to(U);if(L.Range.isIRange(U.range)&&g.URI.isUri(U.uri))return m.location.to(U);if(U instanceof s.VSBuffer)return U.buffer.buffer;if(!Array.isArray(U))return U})}}]}registerArgumentProcessor(E){this._argumentProcessors.push(E)}registerApiCommand(E){const b=this.registerCommand(!1,E.id,async(..._)=>{const T=E.args.map((M,P)=>{if(!M.validate(_[P]))throw new Error(`Invalid argument '${M.name}' when running '${E.id}', received: ${typeof _[P]=="object"?JSON.stringify(_[P],null,"	"):_[P]} `);return M.convert(_[P])}),U=await this.executeCommand(E.internalId,...T);return E.result.convert(U,_,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this._apiCommands.set(E.id,E),new N.Disposable(()=>{b.dispose(),this._apiCommands.delete(E.id)})}registerCommand(E,b,_,T,U,M){if(this._logService.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this._commands.has(b))throw new Error(`command '${b}' already exists`);return this._commands.set(b,{callback:_,thisArg:T,metadata:U,extension:M}),E&&this.#e.$registerCommand(b),new N.Disposable(()=>{this._commands.delete(b)&&E&&this.#e.$unregisterCommand(b)})}executeCommand(E,...b){return this._logService.trace("ExtHostCommands#executeCommand",E),this._doExecuteCommand(E,b,!0)}async _doExecuteCommand(E,b,_){if(this._commands.has(E))return this.#e.$fireCommandActivationEvent(E),this._executeContributedCommand(E,b,!1);{let T=!1;const U=(0,k.cloneAndChange)(b,function(M){if(M instanceof N.Position)return m.Position.from(M);if(M instanceof N.Range)return m.Range.from(M);if(M instanceof N.Location)return m.location.from(M);if(N.NotebookRange.isNotebookRange(M))return m.NotebookRange.from(M);if(M instanceof ArrayBuffer)return T=!0,s.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return T=!0,s.VSBuffer.wrap(M);if(M instanceof s.VSBuffer)return T=!0,M;if(!Array.isArray(M))return M});try{const M=await this.#e.$executeCommand(E,T?new i.SerializableObjectWithBuffers(U):U,_);return(0,S.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(E,b,!1);throw M}}}async _executeContributedCommand(E,b,_){const T=this._commands.get(E);if(!T)throw new Error("Unknown command");const{callback:U,thisArg:M,metadata:P}=T;if(P?.args)for(let F=0;F<P.args.length;F++)try{(0,D.validateConstraint)(b[F],P.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${P.args[F].name}' - ${P.args[F].description}`)}const x=o.StopWatch.create();try{return await U.apply(M,b)}catch(F){if(E===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...b);O&&(E=O.command)}if(this._logService.error(F,E,T.extension?.identifier),!_)throw F;if(T.extension?.identifier){const O=this.#i.onExtensionError(T.extension.identifier,F);this._logService.trace("forwarded error to extension?",O,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.toErrorMessage)(F)),this.id=E,this.source=T.extension?.displayName??T.extension?.name}}}finally{this._reportTelemetry(T,E,x.elapsed())}}_reportTelemetry(E,b,_){E.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new a.TelemetryTrustedValue(b),duration:_})}$executeContributedCommand(E,...b){this._logService.trace("ExtHostCommands#$executeContributedCommand",E);const _=this._commands.get(E);return _?(b=b.map(T=>this._argumentProcessors.reduce((U,M)=>M.processArgument(U,_.extension?.identifier),T)),this._executeContributedCommand(E,b,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this._logService.trace("ExtHostCommands#getCommands",E),this.#e.$getCommands().then(b=>(E&&(b=b.filter(_=>_[0]!=="_")),b))}$getContributedCommandMetadata(){const E=Object.create(null);for(const[b,_]of this._commands){const{metadata:T}=_;T&&(E[b]=T)}return Promise.resolve(E)}};e.ExtHostCommands=h,e.ExtHostCommands=h=Ge([We(0,l.IExtHostRpcService),We(1,p.ILogService),We(2,t.IExtHostTelemetry)],h),e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class u{constructor(E,b,_){this._commands=E,this._lookupApiCommand=b,this._logService=_,this.delegatingCommandId=`__vsc${(0,r.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(E,b){if(!E)return;const _={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return _;const T=this._lookupApiCommand(E.command);if(T)_.id=T.internalId,_.arguments=T.args.map((U,M)=>U.convert(E.arguments&&E.arguments[M]));else if((0,v.isNonEmptyArray)(E.arguments)){const U=`${E.command} /${++this._cachIdPool}`;this._cache.set(U,E),b.add((0,w.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),_.$ident=U,_.id=this.delegatingCommandId,_.arguments=[U],this._logService.trace("CommandsConverter#CREATE",E.command,U)}return _}fromInternal(E){return typeof E.$ident=="string"?this._cache.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this._cache.get(E[0])}_executeConvertedCommand(...E){const b=this.getActualCommand(...E);return this._logService.trace("CommandsConverter#EXECUTE",E[0],b?b.command:"MISSING"),b?this._commands.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.CommandsConverter=u;class c{static{this.Uri=new c("uri","Uri of a text document",E=>g.URI.isUri(E),E=>E)}static{this.Position=new c("position","A position in a text document",E=>N.Position.isPosition(E),m.Position.from)}static{this.Range=new c("range","A range in a text document",E=>N.Range.isRange(E),m.Range.from)}static{this.Selection=new c("selection","A selection in a text document",E=>N.Selection.isSelection(E),m.Selection.from)}static{this.Number=new c("number","",E=>typeof E=="number",E=>E)}static{this.String=new c("string","",E=>typeof E=="string",E=>E)}static{this.StringArray=c.Arr(c.String)}static Arr(E){return new c(`${E.name}_array`,`Array of ${E.name}, ${E.description}`,b=>Array.isArray(b)&&b.every(_=>E.validate(_)),b=>b.map(_=>E.convert(_)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",E=>E instanceof N.CallHierarchyItem,m.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",E=>E instanceof N.TypeHierarchyItem,m.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VSCodium TestItem",E=>E instanceof f.TestItemImpl,m.TestItem.from)}constructor(E,b,_,T){this.name=E,this.description=b,this.validate=_,this.convert=T}optional(){return new c(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,b){return new c(E??this.name,b??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c;class d{static{this.Void=new d("no result",E=>E)}constructor(E,b){this.description=E,this.convert=b}}e.ApiCommandResult=d;class y{constructor(E,b,_,T,U){this.id=E,this.internalId=b,this.description=_,this.args=T,this.result=U}}e.ApiCommand=y}),define(ye[313],Ce([1,0,19,17,2,83,131,46,35,15,7]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",w(S.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,D.isFalsyOrEmpty)(l))return;class s extends L.SymbolInformation{static to(n){const o=new s(n.name,S.SymbolKind.to(n.kind),n.containerName||"",new L.Location(f[0],S.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=S.Range.to(n.selectionRange),o.children=n.children?n.children.map(s.to):[],o}}return l.map(s.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(S.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(S.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new p.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(S.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(S.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(S.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>L.Position.isPosition(f)),l=>l.map(S.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(f=>{let s;for(const i of f.reverse())s=new L.SelectionRange(S.Range.to(i),s);return s}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(S.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(S.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(S.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(S.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:S.Range.to(l.range),placeholder:l.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return S.WorkspaceEdit.to(l)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(S.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.decodeSemanticTokensDto)(l);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.decodeSemanticTokensDto)(l);if(f.type==="full")return new L.SemanticTokens(f.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,f,s)=>{if(!l)return new L.CompletionList([]);const i=l.suggestions.map(n=>S.CompletionItem.to(n,s));return new L.CompletionList(i,l.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return S.SignatureHelp.to(l)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,f,s)=>w(i=>new L.CodeLens(S.Range.to(i.range),i.command&&s.fromInternal(i.command)))(l))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>L.Range.isRange(l),l=>L.Selection.isSelection(l)?S.Selection.from(l):S.Range.from(l)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,f,s)=>w(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new L.CodeAction(i.title,i.kind?new L.CodeActionKind(i.kind):void 0);return i.edit&&(n.edit=S.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(l))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new L.ColorInformation(S.Range.to(f.range),S.Color.to(f.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",l=>l instanceof L.Color,S.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:S.Range.from(l.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(S.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,f,s)=>l.map(S.InlayHint.to.bind(void 0,s)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(l,f)=>{if(l)return l.map(S.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>S.NotebookExclusiveDocumentPattern.to(f))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof L.Range,l=>S.InlineValueContext.from(l))],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(S.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",l=>m.URI.isUri(l)||typeof l=="string"&&(0,N.matchesSomeScheme)(l,N.Schemas.http,N.Schemas.https),l=>l),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[S.ViewColumn.from(l),void 0]:[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[S.ViewColumn.from(l),void 0]:[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[S.ViewColumn.from(l.viewColumn),S.TextEditorOpenOptions.from(l)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new p.ApiCommandArgument("resourceList","List of resources to compare",l=>{for(const f of l){if(f.length!==3)return!1;const[s,i,n]=f;if(!m.URI.isUri(s)||!m.URI.isUri(i)&&i!==void 0&&i!==null||!m.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(S.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,l=>l)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.StringArray,new p.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",l=>S.MappedEditsContext.is(l),l=>S.MappedEditsContext.from(l))],new p.ApiCommandResult("A promise that resolves to a workspace edit or null",l=>l?S.WorkspaceEdit.to(l):null))];class g{static register(f){I.forEach(f.registerApiCommand,f),this._registerValidateWhenClausesCommand(f)}static _registerValidateWhenClausesCommand(f){f.registerCommand(!1,"_validateWhenClauses",v.validateWhenClauses)}}e.ExtHostApiCommands=g;function w(l){return f=>{if(Array.isArray(f))return f.map(l)}}function C(l){if(!Array.isArray(l))return;const f=[];for(const s of l)k.isLocationLink(s)?f.push(S.DefinitionLink.to(s)):f.push(S.location.to(s));return f}}),define(ye[314],Ce([1,0,12,59,4,3,2,83,26,15,7,6,25]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function w(C,l,f){const s=C.getProxy(I.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new p.ExtensionIdentifierMap,l.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const y=this._commentControllers.get(d.handle);return y?y.value:d}else if(d&&d.$mid===7){const y=this._commentControllers.get(d.commentControlHandle);if(!y)return d;const A=y.getCommentThread(d.commentThreadHandle);return A?A.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const y=this._commentControllers.get(d.thread.commentControlHandle);if(!y)return d;const A=y.getCommentThread(d.thread.commentThreadHandle);return A?d.$mid===8?A.value:{thread:A.value,text:d.text}:d}else if(d&&d.$mid===10){const y=this._commentControllers.get(d.thread.commentControlHandle);if(!y)return d;const A=y.getCommentThread(d.thread.commentThreadHandle);if(!A)return d;const E=d.commentUniqueId,b=A.getCommentByUniqueId(E);return b||d}else if(d&&d.$mid===11){const y=this._commentControllers.get(d.thread.commentControlHandle);if(!y)return d;const A=y.getCommentThread(d.thread.commentThreadHandle);if(!A)return d;const E=d.text,b=d.commentUniqueId,_=A.getCommentByUniqueId(b);return _?(typeof _.body=="string"?_.body=E:_.body=new L.MarkdownString(E),_):d}return d}})}createCommentController(d,y,A){const E=i.handlePool++,b=new o(d,E,y,A);this._commentControllers.set(b.handle,b);const _=this._commentControllersByExtension.get(d.identifier)||[];return _.push(b),this._commentControllersByExtension.set(d.identifier,_),b.value}async $createCommentThreadTemplate(d,y,A){const E=this._commentControllers.get(d);E&&E.$createCommentThreadTemplate(y,A)}async $updateCommentThreadTemplate(d,y,A){const E=this._commentControllers.get(d);E&&E.$updateCommentThreadTemplate(y,A)}$deleteCommentThread(d,y){this._commentControllers.get(d)?.$deleteCommentThread(y)}$provideCommentingRanges(d,y,A){const E=this._commentControllers.get(d);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const b=f.getDocument(R.URI.revive(y));return(0,D.asPromise)(async()=>{const _=await E.commentingRangeProvider.provideCommentingRanges(b,A);let T;return Array.isArray(_)?T={ranges:_,fileComments:!1}:_?T={ranges:_.ranges||[],fileComments:_.fileComments||!1}:T=_??void 0,T}).then(_=>{let T;return _&&(T={ranges:_.ranges.map(U=>S.Range.from(U)),fileComments:_.fileComments}),T})}$toggleReaction(d,y,A,E,b){const _=this._commentControllers.get(d);return!_||!_.reactionHandler?Promise.resolve(void 0):(0,D.asPromise)(()=>{const T=_.getCommentThread(y);if(T){const U=T.getCommentByUniqueId(E.uniqueIdInThread);if(_!==void 0&&U&&_.reactionHandler)return _.reactionHandler(U,r(b))}return Promise.resolve(void 0)})}}class n{static{this._handlePool=0}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){(d===void 0!=(this._range===void 0)||!d||!this._range||!d.isEqual(this._range))&&(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(d){this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,y,A,E,b,_,T,U){this._commentControllerHandle=y,this._id=A,this._uri=E,this._range=b,this._comments=_,this.extensionDescription=T,this._isTemplate=U,this.handle=n._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new m.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputDisposables.value=new k.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),s.$createCommentThread(y,this.handle,this._id,this._uri,S.Range.from(this._range),T.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=_,this._localDisposables.push({dispose:()=>{s.$deleteCommentThread(y,this.handle)}});const M=this;this.value={get uri(){return M.uri},get range(){return M.range},set range(P){M.range=P},get comments(){return M.comments},set comments(P){M.comments=P},get collapsibleState(){return M.collapsibleState},set collapsibleState(P){M.collapsibleState=P},get canReply(){return M.canReply},set canReply(P){M.canReply=P},get contextValue(){return M.contextValue},set contextValue(P){M.contextValue=P},get label(){return M.label},set label(P){M.label=P},get state(){return M.state},set state(P){M.state=P},dispose:()=>{M.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new k.DisposableStore);const d=A=>Object.prototype.hasOwnProperty.call(this.modifications,A),y={};d("range")&&(y.range=S.Range.from(this._range)),d("label")&&(y.label=this.label),d("contextValue")&&(y.contextValue=this.contextValue??null),d("comments")&&(y.comments=this._comments.map(A=>a(this,A,this._commentsMap,this.extensionDescription))),d("collapsibleState")&&(y.collapseState=h(this._collapseState)),d("canReply")&&(y.canReply=this.canReply),d("state")&&(y.state=u(this._state)),d("isTemplate")&&(y.isTemplate=this._isTemplate),this.modifications={},s.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,y)}getCommentByUniqueId(d){for(const y of this._commentsMap){const A=y[0],E=y[1];if(d===E)return A}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}Ge([(0,N.debounce)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,s.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,y,A,E){this._extension=d,this._handle=y,this._id=A,this._label=E,this._threads=new Map,s.$registerCommentController(this.handle,A,E,this._extension.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(_){b.options=_},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(_){b.commentingRangeProvider=_},get reactionHandler(){return b.reactionHandler},set reactionHandler(_){b.reactionHandler=_},createCommentThread(_,T,U){return b.createCommentThread(_,T,U).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(d,y,A){y===void 0&&(0,g.checkProposedApiEnabled)(this._extension,"fileComments");const E=new n(this.id,this.handle,void 0,d,y,A,this._extension,!1);return this._threads.set(E.handle,E),E}$createCommentThreadTemplate(d,y){const A=new n(this.id,this.handle,void 0,R.URI.revive(d),S.Range.to(y),[],this._extension,!0);return A.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this._threads.set(A.handle,A),A}$updateCommentThreadTemplate(d,y){const A=this._threads.get(d);A&&(A.range=S.Range.to(y))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function a(c,d,y,A){let E=y.get(d);return E||(E=++c.commentHandle,y.set(d,E)),d.state!==void 0&&(0,g.checkProposedApiEnabled)(A,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:E,body:typeof d.body=="string"?d.body:S.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(b=>t(b)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?S.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function h(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function u(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}return new i}e.createExtHostComments=w}),define(ye[315],Ce([1,0,24,6,27,20]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=class{constructor(L,I){this._mainThreadConsole=L.getProxy(N.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,I){const g=this,w=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){g._handleConsoleCall(L,I,w,arguments)}})}_handleConsoleCall(L,I,g,w){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:p(w,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,g,w)}};e.AbstractExtHostConsoleForwarder=R,e.AbstractExtHostConsoleForwarder=R=Ge([We(0,k.IExtHostRpcService),We(1,m.IExtHostInitDataService)],R);const v=1e5;function p(S,L){const I=[];if(S.length)for(let g=0;g<S.length;g++){let w=S[g];if(typeof w>"u")w="undefined";else if(w instanceof Error){const C=w;C.stack?w=C.stack:w=C.toString()}I.push(w)}if(L){const g=new Error().stack;g&&I.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,D.safeStringify)(I);return g.length>v?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(ye[149],Ce([1,0,2,6,7,5,20,14,19,13,16,25]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class{static{g=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(l,f){this._logService=f,this._provider=new Map,this._proxy=l.getProxy(N.MainContext.MainThreadDecorations)}registerFileDecorationProvider(l,f){const s=g._handlePool++;this._provider.set(s,{provider:l,extensionDescription:f}),this._proxy.$registerDecorationProvider(s,f.identifier.value);const i=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this._proxy.$onDidChange(s,null);return}const o=(0,p.asArray)(n);if(o.length<=g._maxEventSize){this._proxy.$onDidChange(s,o);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,o.length);const a=o.map(h=>({uri:h,rank:(0,S.count)(h.path,"/")})),t=(0,p.groupBy)(a,(h,u)=>h.rank-u.rank||(0,S.compare)(h.uri.path,u.uri.path)),r=[];e:for(const h of t){let u;for(const c of h){const d=(0,L.dirname)(c.uri.path);if(u!==d&&(u=d,r.push(c.uri)>=g._maxEventSize))break e}}this._proxy.$onDidChange(s,r)});return new m.Disposable(()=>{i?.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(l,f,s){if(!this._provider.has(l))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this._provider.get(l);return await Promise.all(f.map(async a=>{try{const{uri:t,id:r}=a,h=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),s));if(!h)return;try{m.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,I.checkProposedApiEnabled)(o,"codiconDecoration"),i[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this._logService.error(t)}})),i}};e.ExtHostDecorations=w,e.ExtHostDecorations=w=g=Ge([We(0,R.IExtHostRpcService),We(1,v.ILogService)],w),e.IExtHostDecorations=(0,k.createDecorator)("IExtHostDecorations")}),define(ye[316],Ce([1,0,211,135,2,6,7,15,4,14,28,57]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{#e;#t;#i;constructor(f,s,i,n,o,a,t,r){this._name=f,this._owner=s,this._maxDiagnosticsTotal=i,this._maxDiagnosticsPerFile=n,this._modelVersionIdProvider=o,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(n,i),this.#i=new L.ResourceMap(h=>a.getComparisonKey(h)),this.#e=t,this.#t=r}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(f,s){if(!f){this.clear();return}this._checkDisposed();let i=[];if(m.URI.isUri(f)){if(!s){this.delete(f);return}this.#i.set(f,s.slice()),i=[f]}else if(Array.isArray(f)){i=[];let a;f=[...f].sort(w._compareIndexedTuplesByUri);for(const t of f){const[r,h]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),h)this.#i.get(r)?.push(...h);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this._maxDiagnosticsPerFile){t=[];const h=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const c of r)if(c.severity===h[u]&&t.push({...v.Diagnostic.from(c),modelVersionId:this._modelVersionIdProvider(a)})===this._maxDiagnosticsPerFile)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(h=>({...v.Diagnostic.from(h),modelVersionId:this._modelVersionIdProvider(a)}));if(n.push([a,t]),o+=t.length,o>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,n)}delete(f){this._checkDisposed(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this._owner,[[f,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(f,s){this._checkDisposed();for(const[i,n]of this)f.call(s,i,n,this)}*[Symbol.iterator](){this._checkDisposed();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this._checkDisposed();const s=this.#i.get(f);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(f){return this._checkDisposed(),Array.isArray(this.#i.get(f))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(f,s){return f[0].toString()<s[0].toString()?-1:f[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=w;let C=class{static{g=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*g._maxDiagnosticsPerFile}static _mapper(f){const s=new L.ResourceMap;for(const i of f)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(f,s,i,n){this._logService=s,this._fileSystemInfoService=i,this._extHostDocumentsAndEditors=n,this._collections=new Map,this._onDidChangeDiagnostics=new p.DebounceEmitter({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this._onDidChangeDiagnostics.event,g._mapper),this._proxy=f.getProxy(k.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(f,s){const{_collections:i,_proxy:n,_onDidChangeDiagnostics:o,_logService:a,_fileSystemInfoService:t,_extHostDocumentsAndEditors:r}=this,h=new class{$changeMany(d,y){n.$changeMany(d,y),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,d,y.length===0?"CLEARING":y)}$clear(d){n.$clear(d),a.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,d)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+g._idPool++,u=s;else if(!i.has(s))u=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+g._idPool++;while(i.has(u))}return new class extends w{constructor(){super(s,u,g._maxDiagnosticsTotal,g._maxDiagnosticsPerFile,d=>r.getDocument(d)?.version,t.extUri,h,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(f){if(f)return this._getDiagnostics(f);{const s=new Map,i=[];for(const n of this._collections.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}_getDiagnostics(f){let s=[];for(const i of this._collections.values())i.has(f)&&(s=s.concat(i.get(f)));return s}$acceptMarkersChange(f){if(!this._mirrorCollection){const s="_generated_mirror",i=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,i),this._mirrorCollection=i}for(const[s,i]of f)this._mirrorCollection.set(m.URI.revive(s),i.map(v.Diagnostic.to))}};e.ExtHostDiagnostics=C,e.ExtHostDiagnostics=C=g=Ge([We(1,S.ILogService),We(2,I.IExtHostFileSystemInfo)],C)}),define(ye[317],Ce([1,0,2,6,25]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(v){this._proxy=v.getProxy(N.MainContext.MainThreadDialogs)}showOpenDialog(v,p){return p?.allowUIResources&&(0,m.checkProposedApiEnabled)(v,"showLocal"),this._proxy.$showOpenDialog(p).then(S=>S?S.map(L=>D.URI.revive(L)):void 0)}showSaveDialog(v){return this._proxy.$showSaveDialog(v).then(p=>p?D.URI.revive(p):void 0)}}e.ExtHostDialogs=k}),define(ye[318],Ce([1,0,8,2,7,6,17,21,13]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class S{static{this._handlePool=0}constructor(I,g,w){this._documentsAndEditors=g,this._logService=w,this._documentContentProviders=new Map,this._proxy=I.getProxy(k.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,g){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const w=S._handlePool++;this._documentContentProviders.set(w,g),this._proxy.$registerTextContentProvider(w,I);let C;return typeof g.onDidChange=="function"&&(C=g.onDidChange(l=>{if(l.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(w,l).then(f=>{if(!f&&typeof f!="string")return;const s=this._documentsAndEditors.getDocument(l);if(!s)return;const i=(0,p.splitLines)(f);if(!s.equalLines(i))return this._proxy.$onVirtualDocumentChange(l,f)},D.onUnexpectedError)})),new m.Disposable(()=>{this._documentContentProviders.delete(w)&&this._proxy.$unregisterTextContentProvider(w),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(I,g){const w=this._documentContentProviders.get(I);return w?Promise.resolve(w.provideTextDocumentContent(N.URI.revive(g),v.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=S}),define(ye[319],Ce([1,0,4,3,2,6,141,15,18,24,7,8]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class g{constructor(C,l){this._onDidAddDocument=new D.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidRemoveDocument=new D.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidChangeDocument=new D.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidSaveDocument=new D.Emitter({onListenerError:I.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new N.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(k.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(f=>{for(const s of f)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(f=>{for(const s of f)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const l=this._documentsAndEditors.getDocument(C);if(l)return l}getDocument(C){const l=this.getDocumentData(C);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return l.document}ensureDocumentData(C){const l=this._documentsAndEditors.getDocument(C);if(l)return Promise.resolve(l);let f=this._documentLoader.get(C.toString());return f||(f=this._proxy.$tryOpenDocument(C).then(s=>{this._documentLoader.delete(C.toString());const i=m.URI.revive(s);return(0,p.assertIsDefined)(this._documentsAndEditors.getDocument(i))},s=>(this._documentLoader.delete(C.toString()),Promise.reject(s))),this._documentLoader.set(C.toString(),f)),f}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(l=>m.URI.revive(l))}$acceptModelLanguageChanged(C,l){const f=m.URI.revive(C),s=this._documentsAndEditors.getDocument(f);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(l),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(C){const l=m.URI.revive(C),f=this._documentsAndEditors.getDocument(l);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(f.document)}$acceptDirtyStateChanged(C,l){const f=m.URI.revive(C),s=this._documentsAndEditors.getDocument(f);if(!s)throw new Error("unknown document");s._acceptIsDirty(l),this._onDidChangeDocument.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,l,f){const s=m.URI.revive(C),i=this._documentsAndEditors.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),i.onEvents(l);let n;l.isUndoing?n=L.TextDocumentChangeReason.Undo:l.isRedoing&&(n=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,S.deepFreeze)({document:i.document,contentChanges:l.changes.map(o=>({range:v.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(C,l){(0,R.setWordDefinitionFor)(C,l)}}e.ExtHostDocuments=g}),define(ye[69],Ce([1,0,60,4,3,2,5,6,141,20,148,15,14,28,17,52,43]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class s{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let i=class{constructor(o,a){this._extHostRpc=o,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new w.ResourceMap,this._onDidAddDocuments=new N.Emitter,this._onDidRemoveDocuments=new N.Emitter,this._onDidChangeVisibleTextEditors=new N.Emitter,this._onDidChangeActiveTextEditor=new N.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const h of o.removedDocuments){const u=k.URI.revive(h),c=this._documents.get(u);c?.unref()&&(this._documents.delete(u),a.push(c.value))}if(o.addedDocuments)for(const h of o.addedDocuments){const u=k.URI.revive(h.uri);let c=this._documents.get(u);if(c&&u.scheme!==C.Schemas.vscodeNotebookCell&&u.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);c||(c=new s(new p.ExtHostDocumentData(this._extHostRpc.getProxy(v.MainContext.MainThreadDocuments),u,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty,h.notebook)),this._documents.set(u,c),t.push(c.value)),c.ref()}if(o.removedEditors)for(const h of o.removedEditors){const u=this._editors.get(h);this._editors.delete(h),u&&r.push(u)}if(o.addedEditors)for(const h of o.addedEditors){const u=k.URI.revive(h.documentUri);D.ok(this._documents.has(u),`document '${u}' does not exist`),D.ok(!this._editors.has(h.id),`editor '${h.id}' already exists!`);const c=this._documents.get(u).value,d=new L.ExtHostTextEditor(h.id,this._extHostRpc.getProxy(v.MainContext.MainThreadTextEditors),this._logService,new f.Lazy(()=>c.document),h.selections.map(I.Selection.to),h.options,h.visibleRanges.map(y=>I.Range.to(y)),typeof h.editorPosition=="number"?I.ViewColumn.to(h.editorPosition):void 0);this._editors.set(h.id,d)}o.newActiveEditor!==void 0&&(D.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,m.dispose)(a),(0,m.dispose)(r),o.removedDocuments&&this._onDidRemoveDocuments.fire(a),o.addedDocuments&&this._onDidAddDocuments.fire(t),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(h=>h.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const a=this._editors.get(this._activeEditorId);return o?a:a?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=i,e.ExtHostDocumentsAndEditors=i=Ge([We(0,S.IExtHostRpcService),We(1,g.ILogService)],i),e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[70],Ce([1,0,73,4,18,2,5,6,20,15,7]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class I{constructor(f,s,i){this._activeTabIdGetter=i,this._parentGroup=s,this.acceptDtoUpdate(f)}get apiObject(){if(!this._apiObject){const f=this,s={get isActive(){return f._dto.id===f._activeTabIdGetter()},get label(){return f._dto.label},get input(){return f._input},get isDirty(){return f._dto.isDirty},get isPinned(){return f._dto.isPinned},get isPreview(){return f._dto.isPreview},get group(){return f._parentGroup.apiObject}};this._apiObject=Object.freeze(s)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(f){this._dto=f,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new L.TextTabInput(k.URI.revive(this._dto.input.uri));case 2:return new L.TextDiffTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified));case 3:return new L.TextMergeTabInput(k.URI.revive(this._dto.input.base),k.URI.revive(this._dto.input.input1),k.URI.revive(this._dto.input.input2),k.URI.revive(this._dto.input.result));case 6:return new L.CustomEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new L.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new L.NotebookEditorTabInput(k.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new L.NotebookDiffEditorTabInput(k.URI.revive(this._dto.input.original),k.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new L.TerminalEditorTabInput;case 9:return new L.InteractiveWindowInput(k.URI.revive(this._dto.input.uri),k.URI.revive(this._dto.input.inputBoxUri));case 10:return new L.ChatEditorTabInput(this._dto.input.providerId);default:return}}}class g{constructor(f,s){this._tabs=[],this._activeTabId="",this._dto=f,this._activeGroupIdGetter=s;for(const i of f.tabs)i.isActive&&(this._activeTabId=i.id),this._tabs.push(new I(i,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const f=this,s={get isActive(){return f._dto.groupId===f._activeGroupIdGetter()},get viewColumn(){return S.ViewColumn.to(f._dto.viewColumn)},get activeTab(){return f._tabs.find(i=>i.tabId===f._activeTabId)?.apiObject},get tabs(){return Object.freeze(f._tabs.map(i=>i.apiObject))}};this._apiObject=Object.freeze(s)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(f){this._dto=f}acceptTabOperation(f){if(f.kind===0){const i=new I(f.tabDto,this,()=>this.activeTabId());return this._tabs.splice(f.index,0,i),f.tabDto.isActive&&(this._activeTabId=i.tabId),i}else if(f.kind===1){const i=this._tabs.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this._activeTabId&&(this._activeTabId=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this._tabs.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this._tabs.splice(f.index,0,i),i}const s=this._tabs.find(i=>i.tabId===f.tabDto.id);if(!s)throw new Error("INVALID tab");return f.tabDto.isActive?this._activeTabId=f.tabDto.id:this._activeTabId===f.tabDto.id&&!f.tabDto.isActive&&(this._activeTabId=""),s.acceptDtoUpdate(f.tabDto),s}activeTabId(){return this._activeTabId}}let w=class{constructor(f){this._onDidChangeTabs=new N.Emitter,this._onDidChangeTabGroups=new N.Emitter,this._extHostTabGroups=[],this._proxy=f.getProxy(v.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const f=this,s={onDidChangeTabGroups:f._onDidChangeTabGroups.event,onDidChangeTabs:f._onDidChangeTabs.event,get all(){return Object.freeze(f._extHostTabGroups.map(i=>i.apiObject))},get activeTabGroup(){const i=f._activeGroupId;return(0,m.assertIsDefined)(f._extHostTabGroups.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?C(o[0])?this._closeGroups(o,n):this._closeTabs(o,n):!0}};this._apiObject=Object.freeze(s)}return this._apiObject}$acceptEditorTabModel(f){const s=new Set(this._extHostTabGroups.map(h=>h.groupId)),i=new Set(f.map(h=>h.groupId)),n=(0,D.diffSets)(s,i),o=this._extHostTabGroups.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),a=[],t=[];this._extHostTabGroups=f.map(h=>{const u=new g(h,()=>this._activeGroupId);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,m.assertIsDefined)(f.find(h=>h.isActive===!0)?.groupId);r!==void 0&&this._activeGroupId!==r&&(this._activeGroupId=r),this._onDidChangeTabGroups.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(f){const s=this._extHostTabGroups.find(i=>i.groupId===f.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(f),f.isActive&&(this._activeGroupId=f.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const s=this._extHostTabGroups.find(n=>n.groupId===f.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(f);switch(f.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}_findExtHostTabFromApi(f){for(const s of this._extHostTabGroups)for(const i of s.tabs)if(i.apiObject===f)return i}_findExtHostTabGroupFromApi(f){return this._extHostTabGroups.find(s=>s.apiObject===f)}async _closeTabs(f,s){const i=[];for(const n of f){const o=this._findExtHostTabFromApi(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this._proxy.$closeTab(i,s)}async _closeGroups(f,s){const i=[];for(const n of f){const o=this._findExtHostTabGroupFromApi(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this._proxy.$closeGroup(i,s)}};e.ExtHostEditorTabs=w,e.ExtHostEditorTabs=w=Ge([We(0,p.IExtHostRpcService)],w);function C(l){return l.tabs!==void 0}}),define(ye[320],Ce([1,0,6,7]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class m{constructor(R){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(D.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,v,p){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const S=this._AiEmbeddingVectorProviders.get(R);if(!S)throw new Error("Embedding vector provider not found");const L=await S.provideEmbeddingVector(v,p);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,v,p){const S=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(S,p),this._proxy.$registerAiEmbeddingVectorProvider(v,S),new N.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(S),this._AiEmbeddingVectorProviders.delete(S)})}}e.ExtHostAiEmbeddingVector=m}),define(ye[321],Ce([1,0,2,6,3,7,15,173,13,22,25,80]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class g{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const f=this._schemes.indexOf(l);f>=0&&(this._schemes.splice(f,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),f=[];let s,i,n=14,o=14;for(const a of l){let t=s?(0,p.commonPrefixLength)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,f.push([i,a.toUpperCase().charCodeAt(t),o]),f.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}f.push([9,58,10]),f.push([10,47,12]),this._stateMachine=new v.StateMachine(f)}}provideDocumentLinks(l){this._initStateMachine();const f=[],s=v.LinkComputer.computeLinks({getLineContent(i){return l.lineAt(i-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const i of s){const n=R.DocumentLink.to(i);n.target&&f.push(n)}return f}}class w{constructor(l,f){this._extHostLanguageFeatures=f,this._linkProvider=new g,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(N.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,f,s,i={}){if(w._validateFileSystemProvider(s),this._registeredSchemes.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const n=this._handlePool++;this._linkProvider.add(f),this._registeredSchemes.add(f),this._fsProvider.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,L.checkProposedApiEnabled)(l,"fsChunks"),o+=4);let a;i.isReadonly&&(0,I.isMarkdownString)(i.isReadonly)&&((0,L.checkProposedApiEnabled)(l,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this._proxy.$registerFileSystemProvider(n,f,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${f}`),console.error(r)});const t=s.onDidChangeFile(r=>{const h=[];for(const u of r){const{uri:c,type:d}=u;if(c.scheme!==f)continue;let y;switch(d){case k.FileChangeType.Changed:y=0;break;case k.FileChangeType.Created:y=1;break;case k.FileChangeType.Deleted:y=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:c,type:y})}this._proxy.$onFileSystemChange(n,h)});return(0,m.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(f),this._registeredSchemes.delete(f),this._fsProvider.delete(n),this._proxy.$unregisterProvider(n)})}static _validateFileSystemProvider(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(l){const{type:f,ctime:s,mtime:i,size:n,permissions:o}=l;return{type:f,ctime:s,mtime:i,size:n,permissions:o}}$stat(l,f){return Promise.resolve(this._getFsProvider(l).stat(D.URI.revive(f))).then(s=>w._asIStat(s))}$readdir(l,f){return Promise.resolve(this._getFsProvider(l).readDirectory(D.URI.revive(f)))}$readFile(l,f){return Promise.resolve(this._getFsProvider(l).readFile(D.URI.revive(f))).then(s=>S.VSBuffer.wrap(s))}$writeFile(l,f,s,i){return Promise.resolve(this._getFsProvider(l).writeFile(D.URI.revive(f),s.buffer,i))}$delete(l,f,s){return Promise.resolve(this._getFsProvider(l).delete(D.URI.revive(f),s))}$rename(l,f,s,i){return Promise.resolve(this._getFsProvider(l).rename(D.URI.revive(f),D.URI.revive(s),i))}$copy(l,f,s,i){const n=this._getFsProvider(l);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(f),D.URI.revive(s),i))}$mkdir(l,f){return Promise.resolve(this._getFsProvider(l).createDirectory(D.URI.revive(f)))}$watch(l,f,s,i){const n=this._getFsProvider(l).watch(D.URI.revive(s),i);this._watches.set(f,n)}$unwatch(l,f){const s=this._watches.get(f);s&&(s.dispose(),this._watches.delete(f))}$open(l,f,s){const i=this._getFsProvider(l);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),s))}$close(l,f){const s=this._getFsProvider(l);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(f))}$read(l,f,s,i){const n=this._getFsProvider(l);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=S.VSBuffer.alloc(i);return Promise.resolve(n.read(f,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(l,f,s,i){const n=this._getFsProvider(l);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(f,s,i.buffer,0,i.byteLength))}_getFsProvider(l){const f=this._fsProvider.get(l);if(!f){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return f}}e.ExtHostFileSystem=w}),define(ye[71],Ce([1,0,6,32,7,22,5,20,57,3,12,23,17]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=w=class{constructor(f,s){this._fileSystemProvider=new Map,this._writeQueue=new L.ResourceQueue,this._proxy=f.getProxy(D.MainContext.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i._fileSystemProvider.get(n.scheme);return a?(await i._proxy.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i._proxy.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===N.FilePermission.Readonly?1:void 0}}catch(o){w._handleError(o)}},async readDirectory(n){try{const o=i._fileSystemProvider.get(n.scheme);return o?(await i._proxy.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i._proxy.$readdir(n)}catch(o){return w._handleError(o)}},async createDirectory(n){try{const o=i._fileSystemProvider.get(n.scheme);return o&&!o.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(o.impl,o.extUri,n)):await i._proxy.$mkdir(n)}catch(o){return w._handleError(o)}},async readFile(n){try{const o=i._fileSystemProvider.get(n.scheme);return o?(await i._proxy.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i._proxy.$readFile(n)).buffer}catch(o){return w._handleError(o)}},async writeFile(n,o){try{const a=i._fileSystemProvider.get(n.scheme);return a&&!a.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(a.impl,a.extUri,a.extUri.dirname(n)),await i._writeQueue.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i._proxy.$writeFile(n,k.VSBuffer.wrap(o))}catch(a){return w._handleError(a)}},async delete(n,o){try{const a=i._fileSystemProvider.get(n.scheme);return a&&!a.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i._proxy.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return w._handleError(a)}},async rename(n,o,a){try{return await i._proxy.$rename(n,o,{overwrite:!1,...a})}catch(t){return w._handleError(t)}},async copy(n,o,a){try{return await i._proxy.$copy(n,o,{overwrite:!1,...a})}catch(t){return w._handleError(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async mkdirp(f,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await f.stat(i)).type&N.FileType.Directory))throw m.FileSystemError.FileExists(`Unable to create folder '${i.scheme===g.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(N.toFileSystemProviderErrorCode(o)!==N.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await f.createDirectory(i)}catch(a){if(N.toFileSystemProviderErrorCode(a)!==N.FileSystemProviderErrorCode.FileExists)throw a}}}static _handleError(f){if(f instanceof m.FileSystemError)throw f;if(f instanceof N.FileSystemProviderError)switch(f.code){case N.FileSystemProviderErrorCode.FileExists:throw m.FileSystemError.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw m.FileSystemError.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw m.FileSystemError.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw m.FileSystemError.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw m.FileSystemError.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw m.FileSystemError.Unavailable(f.message);default:throw new m.FileSystemError(f.message,f.name)}if(!(f instanceof Error))throw new m.FileSystemError(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw m.FileSystemError.Unavailable(f.message);switch(f.name){case N.FileSystemProviderErrorCode.FileExists:throw m.FileSystemError.FileExists(f.message);case N.FileSystemProviderErrorCode.FileNotFound:throw m.FileSystemError.FileNotFound(f.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw m.FileSystemError.FileNotADirectory(f.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw m.FileSystemError.FileIsADirectory(f.message);case N.FileSystemProviderErrorCode.NoPermissions:throw m.FileSystemError.NoPermissions(f.message);case N.FileSystemProviderErrorCode.Unavailable:throw m.FileSystemError.Unavailable(f.message);default:throw new m.FileSystemError(f.message,f.name)}}addFileSystemProvider(f,s,i){return this._fileSystemProvider.set(f,{impl:s,extUri:i?.isCaseSensitive?I.extUri:I.extUriIgnorePathCase,isReadonly:!!i?.isReadonly}),(0,S.toDisposable)(()=>this._fileSystemProvider.delete(f))}getFileSystemProviderExtUri(f){return this._fileSystemProvider.get(f)?.extUri??I.extUri}};e.ExtHostConsumerFileSystem=C,e.ExtHostConsumerFileSystem=C=w=Ge([We(0,v.IExtHostRpcService),We(1,p.IExtHostFileSystemInfo)],C),e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[322],Ce([1,0,4,34,2,6,15,7,43]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(w,C,l,f,s,i){this.session=Math.random(),this._onDidCreate=new D.Emitter,this._onDidChange=new D.Emitter,this._onDidDelete=new D.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const n=(0,N.parse)(s),o=typeof s=="string",a=i?.correlate,t=f(r=>{if(!(typeof r.session=="number"&&r.session!==this.session)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const h of r.created){const u=m.URI.revive(h);n(u.fsPath)&&(!o||C.getWorkspaceFolder(u))&&this._onDidCreate.fire(u)}if(!i?.ignoreChangeEvents)for(const h of r.changed){const u=m.URI.revive(h);n(u.fsPath)&&(!o||C.getWorkspaceFolder(u))&&this._onDidChange.fire(u)}if(!i?.ignoreDeleteEvents)for(const h of r.deleted){const u=m.URI.revive(h);n(u.fsPath)&&(!o||C.getWorkspaceFolder(u))&&this._onDidDelete.fire(u)}}});this._disposable=v.Disposable.from(this.ensureWatching(w,l,s,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(w,C,l,f,s){const i=v.Disposable.from();if(typeof l=="string")return i;const n=w.getProxy(k.MainContext.MainThreadFileSystemEventService);let o=!1;return(l.pattern.includes(N.GLOBSTAR)||l.pattern.includes(N.GLOB_SPLIT))&&(o=!0),n.$watch(C.identifier.value,this.session,l.baseUri,{recursive:o,excludes:f?.excludes??[]},!!s),v.Disposable.from({dispose:()=>n.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class L{constructor(w){this._events=w,this.session=this._events.session,this._created=new p.Lazy(()=>this._events.created.map(m.URI.revive)),this._changed=new p.Lazy(()=>this._events.changed.map(m.URI.revive)),this._deleted=new p.Lazy(()=>this._events.deleted.map(m.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class I{constructor(w,C,l){this._mainContext=w,this._logService=C,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new D.Emitter,this._onDidRenameFile=new D.Emitter,this._onDidCreateFile=new D.Emitter,this._onDidDeleteFile=new D.Emitter,this._onWillRenameFile=new D.AsyncEmitter,this._onWillCreateFile=new D.AsyncEmitter,this._onWillDeleteFile=new D.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,C,l,f){return new S(this._mainContext,w,C,this._onFileSystemEvent.event,R.GlobPattern.from(l),f)}$onFileEvent(w){this._onFileSystemEvent.fire(new L(w))}$onDidRunFileOperation(w,C){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:C.map(l=>({oldUri:m.URI.revive(l.source),newUri:m.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:C.map(l=>m.URI.revive(l.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:C.map(l=>m.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,C){return(l,f,s)=>{const i=function(o){l.call(f,o)};return i.extension=w,C.event(i,void 0,s)}}async $onWillRunFileOperation(w,C,l,f){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:C.map(s=>({oldUri:m.URI.revive(s.source),newUri:m.URI.revive(s.target)}))},l,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:C.map(s=>m.URI.revive(s.target))},l,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:C.map(s=>m.URI.revive(s.target))},l,f)}}async _fireWillEvent(w,C,l,f){const s=new Set,i=[];if(await w.fireAsync(C,f,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof v.WorkspaceEdit&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>l&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=I}),define(ye[323],Ce([1,0,3,2,6,15,7,35,12]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class S{static{this._pool=0}constructor(w,C){this.extension=w,this.provider=C,this.handle=S._pool++}}class L{constructor(w){this.session=w,this.responses=[]}}class I{static{this._nextId=0}constructor(w,C,l,f){this._documents=l,this._logService=f,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=w.getProxy(m.MainContext.MainThreadInlineChat),C.registerApiCommand(new v.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.ApiCommandArgument("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?k.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?k.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?k.Position.from(s.position):void 0}})],v.ApiCommandResult.Void))}registerProvider(w,C,l){const f=new S(w,C);return this._inputProvider.set(f.handle,f),this._proxy.$registerInteractiveEditorProvider(f.handle,l?.label??w.displayName??w.name,w.identifier.value,typeof C.handleInteractiveEditorResponseFeedback=="function",typeof C.provideFollowups=="function",l?.supportReportIssue??!1),(0,D.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(f.handle),this._inputProvider.delete(f.handle)})}async $prepareSession(w,C,l,f){const s=this._inputProvider.get(w);if(!s){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(N.URI.revive(C)),n=k.Selection.to(l),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},f);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=I._nextId++;return this._inputSessions.set(a,new L(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:k.Range.from(o.wholeRange),message:o.message}}async $provideResponse(w,C,l,f){const s=this._inputProvider.get(w);if(!s)return;const i=this._inputSessions.get(C.id);if(!i)return;const n={prompt:l.prompt,selection:k.Selection.to(l.selection),wholeRange:k.Range.to(l.wholeRange),attempt:l.attempt,live:l.live};let o=!1;const a={report:async c=>{if(!l.live&&c.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||f.isCancellationRequested||await this._proxy.$handleProgressChunk(l.requestId,{message:c.message,edits:c.edits?.map(k.TextEdit.from),editsShouldBeInstant:c.editsShouldBeInstant,slashCommand:c.slashCommand?.command,markdownFragment:R.MarkdownString.isMarkdownString(c.content)?c.content.value:c.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,f));let r;try{r=await(0,p.raceCancellation)(t,f)}finally{o=!0}if(!r)return;const h=i.responses.push(r)-1,u={wholeRange:k.Range.from(r.wholeRange),placeholder:r.placeholder};if(I._isEditResponse(r)){const{edits:c,contents:d}=r,y=d!==void 0?k.MarkdownString.from(d):void 0;return c instanceof R.WorkspaceEdit?{...u,id:h,type:"bulkEdit",edits:k.WorkspaceEdit.from(c),message:y}:{...u,id:h,type:"editorEdit",edits:c.map(k.TextEdit.from),message:y}}return{...u,id:h,type:"message",message:k.MarkdownString.from(r.contents)}}async $provideFollowups(w,C,l,f){const s=this._inputProvider.get(w),i=this._inputSessions.get(C),n=i?.responses[l];if(s&&n&&s.provider.provideFollowups){const o=Promise.resolve(s.provider.provideFollowups(i.session,n,f));return(await(0,p.raceCancellation)(o,f))?.map(k.ChatReplyFollowup.from)}}$handleFeedback(w,C,l,f){const s=this._inputProvider.get(w),i=this._inputSessions.get(C),n=i?.responses[l];if(s&&n){const o=k.InteractiveEditorResponseFeedbackKind.to(f);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(w,C){}static _isEditResponse(w){return typeof w=="object"&&typeof w.edits=="object"}}e.ExtHostInteractiveEditor=I}),define(ye[324],Ce([1,0,2,35]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class m{constructor(R,v,p,S,L){this._extHostNotebooks=v,this._textDocumentsAndEditors=p,this._commands=S;const I=new N.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new N.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new N.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new N.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new N.ApiCommandResult("Notebook and input URI",g=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const w=this._extHostNotebooks.getEditorById(g.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:D.URI.revive(g.notebookUri),inputUri:D.URI.revive(g.inputUri),notebookEditor:w.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:D.URI.revive(g.notebookUri),inputUri:D.URI.revive(g.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(R,v,p,S){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:v,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(D.URI.revive(S))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,v){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=m}),define(ye[325],Ce([1,0,6,7]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class m{constructor(R){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=R.getProxy(D.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(R,v){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const p=this._IssueUriRequestHandlers.get(R);if(!p)throw new Error("Issue request handler not found");const S=await p.handleIssueUrlRequest();if(!S)throw new Error("Issue request handler returned no result");return S}async $getIssueReporterData(R,v){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const p=this._IssueDataProviders.get(R);if(!p)throw new Error("Issue data provider not found");const S=await p.provideIssueData(v);if(!S)throw new Error("Issue data provider returned no result");return S}async $getIssueReporterTemplate(R,v){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const p=this._IssueDataProviders.get(R);if(!p)throw new Error("Issue data provider not found");const S=await p.provideIssueTemplate(v);if(!S)throw new Error("Issue template provider returned no result");return S}registerIssueUriRequestHandler(R,v){const p=R.identifier.value;return this._IssueUriRequestHandlers.set(p,v),this._proxy.$registerIssueUriRequestHandler(p),new N.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(p),this._IssueUriRequestHandlers.delete(p)})}registerIssueDataProvider(R,v){const p=R.identifier.value;return this._IssueDataProviders.set(p,v),this._proxy.$registerIssueDataProvider(p),new N.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(p),this._IssueDataProviders.delete(p)})}}e.ExtHostIssueReporter=m}),define(ye[326],Ce([1,0,3,6]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class m{constructor(R){this._handlePool=0,this._proxy=R.getProxy(N.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const v=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(v,R),(0,D.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(v)})}}e.ExtHostLabelService=m}),define(ye[327],Ce([1,0,2,24,15,7,83,6,13,29,19,18,169,21,26,3,131,121,110,38,8,12,25,213]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class h{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentSymbols(B,K){const ee=this._documents.getDocument(B),H=await this._provider.provideDocumentSymbols(ee,K);if(!(0,L.isFalsyOrEmpty)(H))return H[0]instanceof k.DocumentSymbol?H.map(m.DocumentSymbol.from):h._asDocumentSymbolTree(H)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((H,ae)=>{let ue=H.location.range.start.compareTo(ae.location.range.start);return ue===0&&(ue=ae.location.range.end.compareTo(H.location.range.end)),ue});const K=[],ee=[];for(const H of B){const ae={name:H.name||"!!MISSING: name!!",kind:m.SymbolKind.from(H.kind),tags:H.tags?.map(m.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:m.Range.from(H.location.range),selectionRange:m.Range.from(H.location.range),children:[]};for(;;){if(ee.length===0){ee.push(ae),K.push(ae);break}const ue=ee[ee.length-1];if(S.Range.containsRange(ue.range,ae.range)&&!S.Range.equalsRange(ue.range,ae.range)){ue.children?.push(ae),ee.push(ae);break}ee.pop()}}return K}}class u{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(B,K,ee){this._documents=B,this._commands=K,this._provider=ee,this._cache=new i.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,K){const ee=this._documents.getDocument(B),H=await this._provider.provideCodeLenses(ee,K);if(!H||K.isCancellationRequested)return;const ae=this._cache.add(H),ue=new l.DisposableStore;this._disposables.set(ae,ue);const Ae={cacheId:ae,lenses:[]};for(let xe=0;xe<H.length;xe++)Ae.lenses.push({cacheId:[ae,xe],range:m.Range.from(H[xe].range),command:this._commands.toInternal(H[xe].command,ue)});return Ae}async resolveCodeLens(B,K){const ee=B.cacheId&&this._cache.get(...B.cacheId);if(!ee)return;let H;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?H=ee:H=await this._provider.resolveCodeLens(ee,K),H||(H=ee),K.isCancellationRequested)return;const ae=B.cacheId&&this._disposables.get(B.cacheId[0]);if(ae)return B.command=this._commands.toInternal(H.command??u._badCmd,ae),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}function c(De){return Array.isArray(De)?De.map(m.DefinitionLink.from):De?[m.DefinitionLink.from(De)]:[]}class d{constructor(B,K){this._documents=B,this._provider=K}async provideDefinition(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideDefinition(H,ae,ee);return c(ue)}}class y{constructor(B,K){this._documents=B,this._provider=K}async provideDeclaration(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideDeclaration(H,ae,ee);return c(ue)}}class A{constructor(B,K){this._documents=B,this._provider=K}async provideImplementation(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideImplementation(H,ae,ee);return c(ue)}}class E{constructor(B,K){this._documents=B,this._provider=K}async provideTypeDefinition(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideTypeDefinition(H,ae,ee);return c(ue)}}class b{constructor(B,K){this._documents=B,this._provider=K}async provideHover(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideHover(H,ae,ee);if(!(!ue||(0,L.isFalsyOrEmpty)(ue.contents)))return ue.range||(ue.range=H.getWordRangeAtPosition(ae)),ue.range||(ue.range=new k.Range(ae,ae)),m.Hover.from(ue)}}class _{constructor(B,K){this._documents=B,this._provider=K}async provideEvaluatableExpression(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideEvaluatableExpression(H,ae,ee);if(ue)return m.EvaluatableExpression.from(ue)}}class T{constructor(B,K){this._documents=B,this._provider=K}async provideInlineValues(B,K,ee,H){const ae=this._documents.getDocument(B),ue=await this._provider.provideInlineValues(ae,m.Range.to(K),m.InlineValueContext.to(ee),H);if(Array.isArray(ue))return ue.map(Ae=>m.InlineValue.from(Ae))}}class U{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentHighlights(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideDocumentHighlights(H,ae,ee);if(Array.isArray(ue))return ue.map(m.DocumentHighlight.from)}}class M{constructor(B,K){this._documents=B,this._provider=K}async provideMultiDocumentHighlights(B,K,ee,H){const ae=this._documents.getDocument(B),ue=ee.map(je=>this._documents.getDocument(je)),Ae=m.Position.to(K),xe=await this._provider.provideMultiDocumentHighlights(ae,Ae,ue,H);if(Array.isArray(xe))return xe.map(m.MultiDocumentHighlight.from)}}class P{constructor(B,K){this._documents=B,this._provider=K}async provideLinkedEditingRanges(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.provideLinkedEditingRanges(H,ae,ee);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,L.coalesce)(ue.ranges.map(m.Range.from)),wordPattern:ue.wordPattern}}}class x{constructor(B,K){this._documents=B,this._provider=K}async provideReferences(B,K,ee,H){const ae=this._documents.getDocument(B),ue=m.Position.to(K),Ae=await this._provider.provideReferences(ae,ue,ee,H);if(Array.isArray(Ae))return Ae.map(m.location.from)}}class F{static{this._maxCodeActionsPerFile=1e3}constructor(B,K,ee,H,ae,ue,Ae){this._documents=B,this._commands=K,this._diagnostics=ee,this._provider=H,this._logService=ae,this._extension=ue,this._apiDeprecation=Ae,this._cache=new i.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,K,ee,H){const ae=this._documents.getDocument(B),ue=g.Selection.isISelection(K)?m.Selection.to(K):m.Range.to(K),Ae=[];for(const ot of this._diagnostics.getDiagnostics(B))if(ue.intersection(ot.range)&&Ae.push(ot)>F._maxCodeActionsPerFile)break;const xe={diagnostics:Ae,only:ee.only?new k.CodeActionKind(ee.only):void 0,triggerKind:m.CodeActionTriggerKind.to(ee.trigger)},je=await this._provider.provideCodeActions(ae,ue,xe,H);if(!(0,L.isNonEmptyArray)(je)||H.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new l.DisposableStore;this._disposables.set(Ke,Ze);const at=[];for(let ot=0;ot<je.length;ot++){const ke=je[ot];ke&&(F._isCommand(ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:ke.title,command:this._commands.toInternal(ke,Ze)})):(xe.only&&(ke.kind?xe.only.contains(ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action is of kind '${ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),at.push({cacheId:[Ke,ot],title:ke.title,command:ke.command&&this._commands.toInternal(ke.command,Ze),diagnostics:ke.diagnostics&&ke.diagnostics.map(m.Diagnostic.from),edit:ke.edit&&m.WorkspaceEdit.from(ke.edit,void 0),kind:ke.kind&&ke.kind.value,isPreferred:ke.isPreferred,isAI:(0,t.isProposedApiEnabled)(this._extension,"codeActionAI")?ke.isAI:!1,disabled:ke.disabled?.reason})))}return{cacheId:Ke,actions:at}}async resolveCodeAction(B,K){const[ee,H]=B,ae=this._cache.get(ee,H);if(!ae||F._isCommand(ae))return{};if(!this._provider.resolveCodeAction)return{};const ue=await this._provider.resolveCodeAction(ae,K)??ae;let Ae;ue.edit&&(Ae=m.WorkspaceEdit.from(ue.edit,void 0));let xe;if(ue.command){const je=this._disposables.get(ee);je&&(xe=this._commands.toInternal(ue.command,je))}return{edit:Ae,command:xe}}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}class O{static toInternalProviderId(B,K){return B+"."+K}constructor(B,K,ee,H,ae){this._proxy=B,this._documents=K,this._provider=ee,this._handle=H,this._extension=ae}async prepareDocumentPaste(B,K,ee,H){if(!this._provider.prepareDocumentPaste)return;const ae=this._documents.getDocument(B),ue=K.map(je=>m.Range.to(je)),Ae=m.DataTransfer.toDataTransfer(ee,()=>{throw new o.NotImplementedError});if(await this._provider.prepareDocumentPaste(ae,ue,Ae,H),H.isCancellationRequested)return;const xe=Array.from(Ae).filter(([,je])=>!(je instanceof k.InternalDataTransferItem));return m.DataTransfer.from(xe)}async providePasteEdits(B,K,ee,H,ae){if(!this._provider.provideDocumentPasteEdits)return;const ue=this._documents.getDocument(K),Ae=ee.map(Ke=>m.Range.to(Ke)),xe=m.DataTransfer.toDataTransfer(H,async Ke=>(await this._proxy.$resolvePasteFileData(this._handle,B,Ke)).buffer),je=await this._provider.provideDocumentPasteEdits(ue,Ae,xe,ae);if(je)return{label:je.label??(0,r.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:je.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:O.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?m.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class W{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentFormattingEdits(B,K,ee){const H=this._documents.getDocument(B),ae=await this._provider.provideDocumentFormattingEdits(H,K,ee);if(Array.isArray(ae))return ae.map(m.TextEdit.from)}}class J{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentRangeFormattingEdits(B,K,ee,H){const ae=this._documents.getDocument(B),ue=m.Range.to(K),Ae=await this._provider.provideDocumentRangeFormattingEdits(ae,ue,ee,H);if(Array.isArray(Ae))return Ae.map(m.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,K,ee,H){(0,I.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this._documents.getDocument(B),ue=K.map(m.Range.to),Ae=await this._provider.provideDocumentRangesFormattingEdits(ae,ue,ee,H);if(Array.isArray(Ae))return Ae.map(m.TextEdit.from)}}class ce{constructor(B,K){this._documents=B,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,K,ee,H,ae){const ue=this._documents.getDocument(B),Ae=m.Position.to(K),xe=await this._provider.provideOnTypeFormattingEdits(ue,Ae,ee,H,ae);if(Array.isArray(xe))return xe.map(m.TextEdit.from)}}class G{constructor(B,K){this._provider=B,this._logService=K,this._cache=new i.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,K){const ee=await this._provider.provideWorkspaceSymbols(B,K);if(!(0,L.isNonEmptyArray)(ee))return{symbols:[]};const H=this._cache.add(ee),ae={cacheId:H,symbols:[]};for(let ue=0;ue<ee.length;ue++){const Ae=ee[ue];if(!Ae||!Ae.name){this._logService.warn("INVALID SymbolInformation",Ae);continue}ae.symbols.push({...m.WorkspaceSymbol.from(Ae),cacheId:[H,ue]})}return ae}async resolveWorkspaceSymbol(B,K){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ee=this._cache.get(...B.cacheId);if(ee){const H=await this._provider.resolveWorkspaceSymbol(ee,K);return H&&(0,N.mixin)(B,m.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,K,ee){this._documents=B,this._provider=K,this._logService=ee}async provideRenameEdits(B,K,ee,H){const ae=this._documents.getDocument(B),ue=m.Position.to(K);try{const Ae=await this._provider.provideRenameEdits(ae,ue,ee,H);return Ae?m.WorkspaceEdit.from(Ae):void 0}catch(Ae){const xe=X._asMessage(Ae);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(B,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const H=this._documents.getDocument(B),ae=m.Position.to(K);try{const ue=await this._provider.prepareRename(H,ae,ee);let Ae,xe;if(k.Range.isRange(ue)?(Ae=ue,xe=H.getText(ue)):(0,I.isObject)(ue)&&(Ae=ue.range,xe=ue.placeholder),!Ae||!xe)return;if(Ae.start.line>ae.line||Ae.end.line<ae.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:m.Range.from(Ae),text:xe}}catch(ue){const Ae=X._asMessage(ue);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(ue)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Y{constructor(B,K){this.resultId=B,this.tokens=K}}class se{constructor(B,K){this._documents=B,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,K,ee){const H=this._documents.getDocument(B),ae=K!==0?this._previousResults.get(K):null;let ue=typeof ae?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(H,ae.resultId,ee):await this._provider.provideDocumentSemanticTokens(H,ee);return ae&&this._previousResults.delete(K),ue?(ue=se._fixProvidedSemanticTokens(ue),this._send(se._convertToEdits(ae,ue),ue)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return se._isSemanticTokens(B)?se._isCorrectSemanticTokens(B)?B:new k.SemanticTokens(new Uint32Array(B.data),B.resultId):se._isSemanticTokensEdits(B)?se._isCorrectSemanticTokensEdits(B)?B:new k.SemanticTokensEdits(B.edits.map(K=>new k.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const K of B.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,K){if(!se._isSemanticTokens(K)||!B||!B.tokens)return K;const ee=B.tokens,H=ee.length,ae=K.data,ue=ae.length;let Ae=0;const xe=Math.min(H,ue);for(;Ae<xe&&ee[Ae]===ae[Ae];)Ae++;if(Ae===H&&Ae===ue)return new k.SemanticTokensEdits([],K.resultId);let je=0;const Ke=xe-Ae;for(;je<Ke&&ee[H-je-1]===ae[ue-je-1];)je++;return new k.SemanticTokensEdits([{start:Ae,deleteCount:H-Ae-je,data:ae.subarray(Ae,ue-je)}],K.resultId)}_send(B,K){if(se._isSemanticTokens(B)){const ee=this._nextResultId++;return this._previousResults.set(ee,new Y(B.resultId,B.data)),(0,f.encodeSemanticTokensDto)({id:ee,type:"full",data:B.data})}if(se._isSemanticTokensEdits(B)){const ee=this._nextResultId++;return se._isSemanticTokens(K)?this._previousResults.set(ee,new Y(K.resultId,K.data)):this._previousResults.set(ee,new Y(B.resultId)),(0,f.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(B.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Q{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentRangeSemanticTokens(B,K,ee){const H=this._documents.getDocument(B),ae=await this._provider.provideDocumentRangeSemanticTokens(H,m.Range.to(K),ee);return ae?this._send(ae):null}_send(B){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}class we{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,K,ee,H,ae){this._documents=B,this._commands=K,this._provider=ee,this._apiDeprecation=H,this._extension=ae,this._cache=new i.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(B,K,ee,H){const ae=this._documents.getDocument(B),ue=m.Position.to(K),Ae=ae.getWordRangeAtPosition(ue)||new k.Range(ue,ue),xe=Ae.with({end:ue}),je=new n.StopWatch,Ke=await this._provider.provideCompletionItems(ae,ue,H,m.CompletionContext.to(ee));if(!Ke||H.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new k.CompletionList(Ke):Ke,at=we.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ot=new l.DisposableStore;this._disposables.set(at,ot);const ke=[],Ue={x:at,b:ke,a:{replace:m.Range.from(Ae),insert:m.Range.from(xe)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let $e=0;$e<Ze.items.length;$e++){const Re=Ze.items[$e],et=this._convertCompletionItem(Re,[at,$e],xe,Ae);ke.push(et)}return Ue}async resolveCompletionItem(B,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...B);if(!ee)return;const H=this._convertCompletionItem(ee,B),ae=await this._provider.resolveCompletionItem(ee,K);if(!ae)return;const ue=this._convertCompletionItem(ae,B);return(H.h!==ue.h||H.i!==ue.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==ue.n||H.o!==ue.o||!(0,N.equals)(H.p,ue.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:ue.d,c:ue.c,l:ue.l,h:ue.h,i:ue.i,n:ue.n,o:ue.o,p:ue.p}}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,K,ee,H){const ae=this._disposables.get(K[0]);if(!ae)throw Error("DisposableStore is missing...");const ue=this._commands.toInternal(B.command,ae),Ae={x:K,a:B.label,b:B.kind!==void 0?m.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(m.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:m.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(m.TextEdit.from),n:ue?.$ident,o:ue?.id,p:ue?.$ident?void 0:ue?.arguments};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=B.textEdit.newText):typeof B.insertText=="string"?Ae.h=B.insertText:B.insertText instanceof k.SnippetString&&(Ae.h=B.insertText.value,Ae.i|=4);let xe;return B.textEdit?xe=B.textEdit.range:B.range&&(xe=B.range),k.Range.isRange(xe)?Ae.j=m.Range.from(xe):xe&&(!ee?.isEqual(xe.inserting)||!H?.isEqual(xe.replacing))&&(Ae.j={insert:m.Range.from(xe.inserting),replace:m.Range.from(xe.replacing)}),Ae}}class he{async provideInlineCompletions(B,K,ee,H){}disposeCompletions(B){}handleDidShowCompletionItem(B,K,ee){}handlePartialAccept(B,K,ee){}}class j extends he{constructor(B,K,ee,H){super(),this._extension=B,this._documents=K,this._provider=ee,this._commands=H,this._references=new z,this._isAdditionsProposedApiEnabled=(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[R.InlineCompletionTriggerKind.Automatic]:k.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:k.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,K,ee,H){const ae=this._documents.getDocument(B),ue=m.Position.to(K),Ae=await this._provider.provideInlineCompletionItems(ae,ue,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:m.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[ee.triggerKind]},H);if(!Ae||H.isCancellationRequested)return;const xe=Array.isArray(Ae)?Ae:Ae.items,je=this._isAdditionsProposedApiEnabled?Array.isArray(Ae)?[]:Ae.commands||[]:[],Ke=this._isAdditionsProposedApiEnabled&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let Ze;return{pid:this._references.createReferenceId({dispose(){Ze?.dispose()},items:xe}),items:xe.map((ot,ke)=>{let Ue;ot.command&&(Ze||(Ze=new l.DisposableStore),Ue=this._commands.toInternal(ot.command,Ze));const $e=ot.insertText;return{insertText:typeof $e=="string"?$e:{snippet:$e.value},filterText:ot.filterText,range:ot.range?m.Range.from(ot.range):void 0,command:Ue,idx:ke,completeBracketPairs:this._isAdditionsProposedApiEnabled?ot.completeBracketPairs:!1}}),commands:je.map(ot=>(Ze||(Ze=new l.DisposableStore),this._commands.toInternal(ot,Ze))),suppressSuggestions:!1,enableForwardStability:Ke}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,K,ee){const H=this._references.get(B)?.items[K];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H,ee)}handlePartialAccept(B,K,ee){const H=this._references.get(B)?.items[K];H&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(H,ee)}}class z{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const K=this._idPool++;return this._references.set(K,B),K}disposeReferenceId(B){const K=this._references.get(B);return this._references.delete(B),K}get(B){return this._references.get(B)}}class ne{constructor(B,K){this._documents=B,this._provider=K,this._cache=new i.Cache("SignatureHelp")}async provideSignatureHelp(B,K,ee,H){const ae=this._documents.getDocument(B),ue=m.Position.to(K),Ae=this.reviveContext(ee),xe=await this._provider.provideSignatureHelp(ae,ue,H,Ae);if(xe){const je=this._cache.add([xe]);return{...m.SignatureHelp.from(xe),id:je}}}reviveContext(B){let K;if(B.activeSignatureHelp){const ee=m.SignatureHelp.to(B.activeSignatureHelp),H=this._cache.get(B.activeSignatureHelp.id,0);H?(K=H,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return{...B,activeSignatureHelp:K}}releaseSignatureHelp(B){this._cache.delete(B)}}class Se{constructor(B,K,ee,H,ae){this._documents=B,this._commands=K,this._provider=ee,this._logService=H,this._extension=ae,this._cache=new i.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,K,ee){const H=this._documents.getDocument(B),ae=m.Range.to(K),ue=await this._provider.provideInlayHints(H,ae,ee);if(!Array.isArray(ue)||ue.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(K)}`);return}if(ee.isCancellationRequested)return;const Ae=this._cache.add(ue);this._disposables.set(Ae,new l.DisposableStore);const xe={hints:[],cacheId:Ae};for(let je=0;je<ue.length;je++)this._isValidInlayHint(ue[je],ae)&&xe.hints.push(this._convertInlayHint(ue[je],[Ae,je]));return this._logService.trace(`[InlayHints] ${xe.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(K)}`),xe}async resolveInlayHint(B,K){if(typeof this._provider.resolveInlayHint!="function")return;const ee=this._cache.get(...B);if(!ee)return;const H=await this._provider.resolveInlayHint(ee,K);if(H&&this._isValidInlayHint(H))return this._convertInlayHint(H,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,K){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(K&&!K.contains(B.position))}_convertInlayHint(B,K){const ee=this._disposables.get(K[0]);if(!ee)throw Error("DisposableStore is missing...");const H={label:"",cacheId:K,tooltip:m.MarkdownString.fromStrict(B.tooltip),position:m.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(m.TextEdit.from),kind:B.kind&&m.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?H.label=B.label:H.label=B.label.map(ae=>{const ue={label:ae.value};return ue.tooltip=m.MarkdownString.fromStrict(ae.tooltip),k.Location.isLocation(ae.location)&&(ue.location=m.location.from(ae.location)),ae.command&&(ue.command=this._commands.toInternal(ae.command,ee)),ue}),H}}class de{constructor(B,K){this._documents=B,this._provider=K,this._cache=new i.Cache("DocumentLink")}async provideLinks(B,K){const ee=this._documents.getDocument(B),H=await this._provider.provideDocumentLinks(ee,K);if(!(!Array.isArray(H)||H.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:H.filter(de._validateLink).map(m.DocumentLink.from)};{const ae=this._cache.add(H),ue={links:[],cacheId:ae};for(let Ae=0;Ae<H.length;Ae++){if(!de._validateLink(H[Ae]))continue;const xe=m.DocumentLink.from(H[Ae]);xe.cacheId=[ae,Ae],ue.links.push(xe)}return ue}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...B);if(!ee)return;const H=await this._provider.resolveDocumentLink(ee,K);if(!(!H||!de._validateLink(H)))return m.DocumentLink.from(H)}releaseLinks(B){this._cache.delete(B)}}class me{constructor(B,K){this._documents=B,this._provider=K}async provideColors(B,K){const ee=this._documents.getDocument(B),H=await this._provider.provideDocumentColors(ee,K);return Array.isArray(H)?H.map(ue=>({color:m.Color.from(ue.color),range:m.Range.from(ue.range)})):[]}async provideColorPresentations(B,K,ee){const H=this._documents.getDocument(B),ae=m.Range.to(K.range),ue=m.Color.to(K.color),Ae=await this._provider.provideColorPresentations(ue,{document:H,range:ae},ee);if(Array.isArray(Ae))return Ae.map(m.ColorPresentation.from)}}class Z{constructor(B,K){this._documents=B,this._provider=K}async provideFoldingRanges(B,K,ee){const H=this._documents.getDocument(B),ae=await this._provider.provideFoldingRanges(H,K,ee);if(Array.isArray(ae))return ae.map(m.FoldingRange.from)}}class ie{constructor(B,K,ee){this._documents=B,this._provider=K,this._logService=ee}async provideSelectionRanges(B,K,ee){const H=this._documents.getDocument(B),ae=K.map(m.Position.to),ue=await this._provider.provideSelectionRanges(H,ae,ee);if(!(0,L.isNonEmptyArray)(ue))return[];if(ue.length!==ae.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let xe=0;xe<ae.length;xe++){const je=[];Ae.push(je);let Ke=ae[xe],Ze=ue[xe];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(m.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return Ae}}class q{constructor(B,K){this._documents=B,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.prepareCallHierarchy(H,ae,ee);if(!ue)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(ue)?ue.map(xe=>this._cacheAndConvertItem(Ae,xe)):[this._cacheAndConvertItem(Ae,ue)]}async provideCallsTo(B,K,ee){const H=this._itemFromCache(B,K);if(!H)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyIncomingCalls(H,ee);if(ae)return ae.map(ue=>({from:this._cacheAndConvertItem(B,ue.from),fromRanges:ue.fromRanges.map(Ae=>m.Range.from(Ae))}))}async provideCallsFrom(B,K,ee){const H=this._itemFromCache(B,K);if(!H)throw new Error("missing call hierarchy item");const ae=await this._provider.provideCallHierarchyOutgoingCalls(H,ee);if(ae)return ae.map(ue=>({to:this._cacheAndConvertItem(B,ue.to),fromRanges:ue.fromRanges.map(Ae=>m.Range.from(Ae))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,K){const ee=this._cache.get(B),H=m.CallHierarchyItem.from(K,B,ee.size.toString(36));return ee.set(H._itemId,K),H}_itemFromCache(B,K){return this._cache.get(B)?.get(K)}}class te{constructor(B,K){this._documents=B,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(B,K,ee){const H=this._documents.getDocument(B),ae=m.Position.to(K),ue=await this._provider.prepareTypeHierarchy(H,ae,ee);if(!ue)return;const Ae=this._idPool.nextId();return this._cache.set(Ae,new Map),Array.isArray(ue)?ue.map(xe=>this._cacheAndConvertItem(Ae,xe)):[this._cacheAndConvertItem(Ae,ue)]}async provideSupertypes(B,K,ee){const H=this._itemFromCache(B,K);if(!H)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySupertypes(H,ee);if(ae)return ae.map(ue=>this._cacheAndConvertItem(B,ue))}async provideSubtypes(B,K,ee){const H=this._itemFromCache(B,K);if(!H)throw new Error("missing type hierarchy item");const ae=await this._provider.provideTypeHierarchySubtypes(H,ee);if(ae)return ae.map(ue=>this._cacheAndConvertItem(B,ue))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,K){const ee=this._cache.get(B),H=m.TypeHierarchyItem.from(K,B,ee.size.toString(36));return ee.set(H._itemId,K),H}_itemFromCache(B,K){return this._cache.get(B)?.get(K)}}class fe{static toInternalProviderId(B,K){return B+"."+K}constructor(B,K,ee,H,ae){this._proxy=B,this._documents=K,this._provider=ee,this._handle=H,this._extension=ae}async provideDocumentOnDropEdits(B,K,ee,H,ae){const ue=this._documents.getDocument(K),Ae=m.Position.to(ee),xe=m.DataTransfer.toDataTransfer(H,async Ke=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,B,Ke)).buffer),je=await this._provider.provideDocumentDropEdits(ue,Ae,xe,ae);if(je)return{label:je.label??(0,r.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:je.yieldTo?.map(Ke=>"mimeType"in Ke?Ke:{providerId:fe.toInternalProviderId(Ke.extensionId,Ke.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?m.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class Ee{constructor(B,K){this._documents=B,this._provider=K}async provideMappedEdits(B,K,ee,H){const ae=D.URI.revive(B),ue=this._documents.getDocument(ae),Ae=ee.documents.map(Ke=>Ke.map(Ze=>({uri:D.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(at=>m.Range.to(at))}))),xe={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},je=await this._provider.provideMappedEdits(ue,K,xe,H);return je?m.WorkspaceEdit.from(je):null}}class Te{constructor(B,K){this.adapter=B,this.extension=K}}class ve{static{this._handlePool=0}constructor(B,K,ee,H,ae,ue,Ae,xe){this._uriTransformer=K,this._documents=ee,this._commands=H,this._diagnostics=ae,this._logService=ue,this._apiDeprecation=Ae,this._extensionTelemetry=xe,this._adapter=new Map,this._proxy=B.getProxy(v.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(B,K){return m.DocumentSelector.from(B,this._uriTransformer,K)}_createDisposable(B){return new k.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return ve._handlePool++}async _withAdapter(B,K,ee,H,ae,ue=!1){const Ae=this._adapter.get(B);if(!Ae||!(Ae.adapter instanceof K))return H;const xe=Date.now();ue||this._logService.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const je=ee(Ae.adapter,Ae.extension);return Promise.resolve(je).catch(Ke=>{(0,o.isCancellationError)(Ke)||(this._logService.error(`[${Ae.extension.identifier.value}] provider FAILED`),this._logService.error(Ke),this._extensionTelemetry.onExtensionError(Ae.extension.identifier,Ke))}).finally(()=>{ue||this._logService.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-xe}ms`)}),w.CancellationToken.isCancellationToken(ae)?(0,a.raceCancellationError)(je,ae):je}_addNewAdapter(B,K){const ee=this._nextHandle();return this._adapter.set(ee,new Te(B,K)),ee}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,K,ee,H){const ae=this._addNewAdapter(new h(this._documents,ee),B),ue=H&&H.label||ve._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(ae,this._transformDocumentSelector(K,B),ue),this._createDisposable(ae)}$provideDocumentSymbols(B,K,ee){return this._withAdapter(B,h,H=>H.provideDocumentSymbols(D.URI.revive(K),ee),void 0,ee)}registerCodeLensProvider(B,K,ee){const H=this._nextHandle(),ae=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(H,new Te(new u(this._documents,this._commands.converter,ee),B)),this._proxy.$registerCodeLensSupport(H,this._transformDocumentSelector(K,B),ae);let ue=this._createDisposable(H);if(ae!==void 0){const Ae=ee.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(ae));ue=k.Disposable.from(ue,Ae)}return ue}$provideCodeLenses(B,K,ee){return this._withAdapter(B,u,H=>H.provideCodeLenses(D.URI.revive(K),ee),void 0,ee)}$resolveCodeLens(B,K,ee){return this._withAdapter(B,u,H=>H.resolveCodeLens(K,ee),void 0,void 0)}$releaseCodeLenses(B,K){this._withAdapter(B,u,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(B,K,ee){const H=this._addNewAdapter(new d(this._documents,ee),B);return this._proxy.$registerDefinitionSupport(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideDefinition(B,K,ee,H){return this._withAdapter(B,d,ae=>ae.provideDefinition(D.URI.revive(K),ee,H),[],H)}registerDeclarationProvider(B,K,ee){const H=this._addNewAdapter(new y(this._documents,ee),B);return this._proxy.$registerDeclarationSupport(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideDeclaration(B,K,ee,H){return this._withAdapter(B,y,ae=>ae.provideDeclaration(D.URI.revive(K),ee,H),[],H)}registerImplementationProvider(B,K,ee){const H=this._addNewAdapter(new A(this._documents,ee),B);return this._proxy.$registerImplementationSupport(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideImplementation(B,K,ee,H){return this._withAdapter(B,A,ae=>ae.provideImplementation(D.URI.revive(K),ee,H),[],H)}registerTypeDefinitionProvider(B,K,ee){const H=this._addNewAdapter(new E(this._documents,ee),B);return this._proxy.$registerTypeDefinitionSupport(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideTypeDefinition(B,K,ee,H){return this._withAdapter(B,E,ae=>ae.provideTypeDefinition(D.URI.revive(K),ee,H),[],H)}registerHoverProvider(B,K,ee,H){const ae=this._addNewAdapter(new b(this._documents,ee),B);return this._proxy.$registerHoverProvider(ae,this._transformDocumentSelector(K,B)),this._createDisposable(ae)}$provideHover(B,K,ee,H){return this._withAdapter(B,b,ae=>ae.provideHover(D.URI.revive(K),ee,H),void 0,H)}registerEvaluatableExpressionProvider(B,K,ee,H){const ae=this._addNewAdapter(new _(this._documents,ee),B);return this._proxy.$registerEvaluatableExpressionProvider(ae,this._transformDocumentSelector(K,B)),this._createDisposable(ae)}$provideEvaluatableExpression(B,K,ee,H){return this._withAdapter(B,_,ae=>ae.provideEvaluatableExpression(D.URI.revive(K),ee,H),void 0,H)}registerInlineValuesProvider(B,K,ee,H){const ae=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new T(this._documents,ee),B);this._proxy.$registerInlineValuesProvider(ue,this._transformDocumentSelector(K,B),ae);let Ae=this._createDisposable(ue);if(ae!==void 0){const xe=ee.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(ae));Ae=k.Disposable.from(Ae,xe)}return Ae}$provideInlineValues(B,K,ee,H,ae){return this._withAdapter(B,T,ue=>ue.provideInlineValues(D.URI.revive(K),ee,H,ae),void 0,ae)}registerDocumentHighlightProvider(B,K,ee){const H=this._addNewAdapter(new U(this._documents,ee),B);return this._proxy.$registerDocumentHighlightProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}registerMultiDocumentHighlightProvider(B,K,ee){const H=this._addNewAdapter(new M(this._documents,ee),B);return this._proxy.$registerMultiDocumentHighlightProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideDocumentHighlights(B,K,ee,H){return this._withAdapter(B,U,ae=>ae.provideDocumentHighlights(D.URI.revive(K),ee,H),void 0,H)}$provideMultiDocumentHighlights(B,K,ee,H,ae){return this._withAdapter(B,M,ue=>ue.provideMultiDocumentHighlights(D.URI.revive(K),ee,H.map(Ae=>D.URI.revive(Ae)),ae),void 0,ae)}registerLinkedEditingRangeProvider(B,K,ee){const H=this._addNewAdapter(new P(this._documents,ee),B);return this._proxy.$registerLinkedEditingRangeProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideLinkedEditingRanges(B,K,ee,H){return this._withAdapter(B,P,async ae=>{const ue=await ae.provideLinkedEditingRanges(D.URI.revive(K),ee,H);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?ve._serializeRegExp(ue.wordPattern):void 0}},void 0,H)}registerReferenceProvider(B,K,ee){const H=this._addNewAdapter(new x(this._documents,ee),B);return this._proxy.$registerReferenceSupport(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideReferences(B,K,ee,H,ae){return this._withAdapter(B,x,ue=>ue.provideReferences(D.URI.revive(K),ee,H,ae),void 0,ae)}registerCodeActionProvider(B,K,ee,H){const ae=new l.DisposableStore,ue=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(ue,this._transformDocumentSelector(K,B),{providedKinds:H?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:H?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this._commands.converter.toInternal(Ae.command,ae)}))},ve._extLabel(B),!!ee.resolveCodeAction),ae.add(this._createDisposable(ue)),ae}$provideCodeActions(B,K,ee,H,ae){return this._withAdapter(B,F,ue=>ue.provideCodeActions(D.URI.revive(K),ee,H,ae),void 0,ae)}$resolveCodeAction(B,K,ee){return this._withAdapter(B,F,H=>H.resolveCodeAction(K,ee),{},void 0)}$releaseCodeActions(B,K){this._withAdapter(B,F,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(B,K,ee){const H=this._addNewAdapter(new W(this._documents,ee),B);return this._proxy.$registerDocumentFormattingSupport(H,this._transformDocumentSelector(K,B),B.identifier,B.displayName||B.name),this._createDisposable(H)}$provideDocumentFormattingEdits(B,K,ee,H){return this._withAdapter(B,W,ae=>ae.provideDocumentFormattingEdits(D.URI.revive(K),ee,H),void 0,H)}registerDocumentRangeFormattingEditProvider(B,K,ee){const H=typeof ee.provideDocumentRangesFormattingEdits=="function",ae=this._addNewAdapter(new J(this._documents,ee),B);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(K,B),B.identifier,B.displayName||B.name,H),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(B,K,ee,H,ae){return this._withAdapter(B,J,ue=>ue.provideDocumentRangeFormattingEdits(D.URI.revive(K),ee,H,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(B,K,ee,H,ae){return this._withAdapter(B,J,ue=>ue.provideDocumentRangesFormattingEdits(D.URI.revive(K),ee,H,ae),void 0,ae)}registerOnTypeFormattingEditProvider(B,K,ee,H){const ae=this._addNewAdapter(new ce(this._documents,ee),B);return this._proxy.$registerOnTypeFormattingSupport(ae,this._transformDocumentSelector(K,B),H,B.identifier),this._createDisposable(ae)}$provideOnTypeFormattingEdits(B,K,ee,H,ae,ue){return this._withAdapter(B,ce,Ae=>Ae.provideOnTypeFormattingEdits(D.URI.revive(K),ee,H,ae,ue),void 0,ue)}registerWorkspaceSymbolProvider(B,K){const ee=this._addNewAdapter(new G(K,this._logService),B);return this._proxy.$registerNavigateTypeSupport(ee,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(ee)}$provideWorkspaceSymbols(B,K,ee){return this._withAdapter(B,G,H=>H.provideWorkspaceSymbols(K,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(B,K,ee){return this._withAdapter(B,G,H=>H.resolveWorkspaceSymbol(K,ee),void 0,void 0)}$releaseWorkspaceSymbols(B,K){this._withAdapter(B,G,ee=>ee.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(B,K,ee){const H=this._addNewAdapter(new X(this._documents,ee,this._logService),B);return this._proxy.$registerRenameSupport(H,this._transformDocumentSelector(K,B),X.supportsResolving(ee)),this._createDisposable(H)}$provideRenameEdits(B,K,ee,H,ae){return this._withAdapter(B,X,ue=>ue.provideRenameEdits(D.URI.revive(K),ee,H,ae),void 0,ae)}$resolveRenameLocation(B,K,ee,H){return this._withAdapter(B,X,ae=>ae.resolveRenameLocation(D.URI.revive(K),ee,H),void 0,H)}registerDocumentSemanticTokensProvider(B,K,ee,H){const ae=this._addNewAdapter(new se(this._documents,ee),B),ue=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ae,this._transformDocumentSelector(K,B),H,ue);let Ae=this._createDisposable(ae);if(ue){const xe=ee.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(ue));Ae=k.Disposable.from(Ae,xe)}return Ae}$provideDocumentSemanticTokens(B,K,ee,H){return this._withAdapter(B,se,ae=>ae.provideDocumentSemanticTokens(D.URI.revive(K),ee,H),null,H)}$releaseDocumentSemanticTokens(B,K){this._withAdapter(B,se,ee=>ee.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,K,ee,H){const ae=this._addNewAdapter(new Q(this._documents,ee),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ae,this._transformDocumentSelector(K,B),H),this._createDisposable(ae)}$provideDocumentRangeSemanticTokens(B,K,ee,H){return this._withAdapter(B,Q,ae=>ae.provideDocumentRangeSemanticTokens(D.URI.revive(K),ee,H),null,H)}registerCompletionItemProvider(B,K,ee,H){const ae=this._addNewAdapter(new we(this._documents,this._commands.converter,ee,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(ae,this._transformDocumentSelector(K,B),H,we.supportsResolving(ee),B.identifier),this._createDisposable(ae)}$provideCompletionItems(B,K,ee,H,ae){return this._withAdapter(B,we,ue=>ue.provideCompletionItems(D.URI.revive(K),ee,H,ae),void 0,ae)}$resolveCompletionItem(B,K,ee){return this._withAdapter(B,we,H=>H.resolveCompletionItem(K,ee),void 0,ee)}$releaseCompletionItems(B,K){this._withAdapter(B,we,ee=>ee.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(B,K,ee,H){const ae=new j(B,this._documents,ee,this._commands.converter),ue=this._addNewAdapter(ae,B);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(K,B),ae.supportsHandleEvents,C.ExtensionIdentifier.toKey(B.identifier.value),H?.yieldTo?.map(Ae=>C.ExtensionIdentifier.toKey(Ae))||[]),this._createDisposable(ue)}$provideInlineCompletions(B,K,ee,H,ae){return this._withAdapter(B,he,ue=>ue.provideInlineCompletions(D.URI.revive(K),ee,H,ae),void 0,ae)}$handleInlineCompletionDidShow(B,K,ee,H){this._withAdapter(B,he,async ae=>{ae.handleDidShowCompletionItem(K,ee,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,K,ee,H){this._withAdapter(B,he,async ae=>{ae.handlePartialAccept(K,ee,H)},void 0,void 0)}$freeInlineCompletionsList(B,K){this._withAdapter(B,he,async ee=>{ee.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(B,K,ee,H){const ae=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,ue=this._addNewAdapter(new ne(this._documents,ee),B);return this._proxy.$registerSignatureHelpProvider(ue,this._transformDocumentSelector(K,B),ae),this._createDisposable(ue)}$provideSignatureHelp(B,K,ee,H,ae){return this._withAdapter(B,ne,ue=>ue.provideSignatureHelp(D.URI.revive(K),ee,H,ae),void 0,ae)}$releaseSignatureHelp(B,K){this._withAdapter(B,ne,ee=>ee.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(B,K,ee){const H=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new Se(this._documents,this._commands.converter,ee,this._logService,B),B);this._proxy.$registerInlayHintsProvider(ae,this._transformDocumentSelector(K,B),typeof ee.resolveInlayHint=="function",H,ve._extLabel(B));let ue=this._createDisposable(ae);if(H!==void 0){const Ae=ee.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(H));ue=k.Disposable.from(ue,Ae)}return ue}$provideInlayHints(B,K,ee,H){return this._withAdapter(B,Se,ae=>ae.provideInlayHints(D.URI.revive(K),ee,H),void 0,H)}$resolveInlayHint(B,K,ee){return this._withAdapter(B,Se,H=>H.resolveInlayHint(K,ee),void 0,ee)}$releaseInlayHints(B,K){this._withAdapter(B,Se,ee=>ee.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(B,K,ee){const H=this._addNewAdapter(new de(this._documents,ee),B);return this._proxy.$registerDocumentLinkProvider(H,this._transformDocumentSelector(K,B),typeof ee.resolveDocumentLink=="function"),this._createDisposable(H)}$provideDocumentLinks(B,K,ee){return this._withAdapter(B,de,H=>H.provideLinks(D.URI.revive(K),ee),void 0,ee,K.scheme==="output")}$resolveDocumentLink(B,K,ee){return this._withAdapter(B,de,H=>H.resolveLink(K,ee),void 0,void 0,!0)}$releaseDocumentLinks(B,K){this._withAdapter(B,de,ee=>ee.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(B,K,ee){const H=this._addNewAdapter(new me(this._documents,ee),B);return this._proxy.$registerDocumentColorProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideDocumentColors(B,K,ee){return this._withAdapter(B,me,H=>H.provideColors(D.URI.revive(K),ee),[],ee)}$provideColorPresentations(B,K,ee,H){return this._withAdapter(B,me,ae=>ae.provideColorPresentations(D.URI.revive(K),ee,H),void 0,H)}registerFoldingRangeProvider(B,K,ee){const H=this._nextHandle(),ae=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(H,new Te(new Z(this._documents,ee),B)),this._proxy.$registerFoldingRangeProvider(H,this._transformDocumentSelector(K,B),B.identifier,ae);let ue=this._createDisposable(H);if(ae!==void 0){const Ae=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ae));ue=k.Disposable.from(ue,Ae)}return ue}$provideFoldingRanges(B,K,ee,H){return this._withAdapter(B,Z,ae=>ae.provideFoldingRanges(D.URI.revive(K),ee,H),void 0,H)}registerSelectionRangeProvider(B,K,ee){const H=this._addNewAdapter(new ie(this._documents,ee,this._logService),B);return this._proxy.$registerSelectionRangeProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideSelectionRanges(B,K,ee,H){return this._withAdapter(B,ie,ae=>ae.provideSelectionRanges(D.URI.revive(K),ee,H),[],H)}registerCallHierarchyProvider(B,K,ee){const H=this._addNewAdapter(new q(this._documents,ee),B);return this._proxy.$registerCallHierarchyProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$prepareCallHierarchy(B,K,ee,H){return this._withAdapter(B,q,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(K),ee,H)),void 0,H)}$provideCallHierarchyIncomingCalls(B,K,ee,H){return this._withAdapter(B,q,ae=>ae.provideCallsTo(K,ee,H),void 0,H)}$provideCallHierarchyOutgoingCalls(B,K,ee,H){return this._withAdapter(B,q,ae=>ae.provideCallsFrom(K,ee,H),void 0,H)}$releaseCallHierarchy(B,K){this._withAdapter(B,q,ee=>Promise.resolve(ee.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(B,K,ee){const H=this._addNewAdapter(new te(this._documents,ee),B);return this._proxy.$registerTypeHierarchyProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$prepareTypeHierarchy(B,K,ee,H){return this._withAdapter(B,te,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(K),ee,H)),void 0,H)}$provideTypeHierarchySupertypes(B,K,ee,H){return this._withAdapter(B,te,ae=>ae.provideSupertypes(K,ee,H),void 0,H)}$provideTypeHierarchySubtypes(B,K,ee,H){return this._withAdapter(B,te,ae=>ae.provideSubtypes(K,ee,H),void 0,H)}$releaseTypeHierarchy(B,K){this._withAdapter(B,te,ee=>Promise.resolve(ee.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(B,K,ee,H){const ae=this._nextHandle();this._adapter.set(ae,new Te(new fe(this._proxy,this._documents,ee,ae,B),B));const ue=(0,t.isProposedApiEnabled)(B,"dropMetadata")&&H?fe.toInternalProviderId(B.identifier.value,H.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(ae,this._transformDocumentSelector(K,B),ue,(0,t.isProposedApiEnabled)(B,"dropMetadata")?H:void 0),this._createDisposable(ae)}$provideDocumentOnDropEdits(B,K,ee,H,ae,ue){return this._withAdapter(B,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(K,D.URI.revive(ee),H,ae,ue)),void 0,void 0)}registerMappedEditsProvider(B,K,ee){const H=this._addNewAdapter(new Ee(this._documents,ee),B);return this._proxy.$registerMappedEditsProvider(H,this._transformDocumentSelector(K,B)),this._createDisposable(H)}$provideMappedEdits(B,K,ee,H,ae){return this._withAdapter(B,Ee,ue=>Promise.resolve(ue.provideMappedEdits(K,ee,H,ae)),null,ae)}registerDocumentPasteEditProvider(B,K,ee,H){const ae=this._nextHandle();this._adapter.set(ae,new Te(new O(this._proxy,this._documents,ee,ae,B),B));const ue=O.toInternalProviderId(B.identifier.value,H.id);return this._proxy.$registerPasteEditProvider(ae,this._transformDocumentSelector(K,B),ue,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this._createDisposable(ae)}$prepareDocumentPaste(B,K,ee,H,ae){return this._withAdapter(B,O,ue=>ue.prepareDocumentPaste(D.URI.revive(K),ee,H,ae),void 0,ae)}$providePasteEdits(B,K,ee,H,ae,ue){return this._withAdapter(B,O,Ae=>Ae.providePasteEdits(K,D.URI.revive(ee),H,ae,ue),void 0,ue)}static _serializeRegExp(B){return{pattern:B.source,flags:B.flags}}static _serializeIndentationRule(B){return{decreaseIndentPattern:ve._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:ve._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ve._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ve._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:ve._serializeRegExp(B.beforeText),afterText:B.afterText?ve._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?ve._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(ve._serializeOnEnterRule)}static _serializeAutoClosingPair(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(K=>k.SyntaxTokenType.toString(K)):void 0}}static _serializeAutoClosingPairs(B){return B.map(ve._serializeAutoClosingPair)}setLanguageConfiguration(B,K,ee){const{wordPattern:H}=ee;if(H&&(0,p.regExpLeadsToEndlessLoop)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this._documents.setWordDefinitionFor(K,H):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ae=this._nextHandle(),ue={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ve._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ve._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ve._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?ve._serializeAutoClosingPairs(ee.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(ae,K,ue),this._createDisposable(ae)}$setWordDefinitions(B){for(const K of B)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=ve}),define(ye[328],Ce([1,0,6,15,7,39,12,3,25]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(I,g,w,C){this._documents=g,this._commands=w,this._uriTransformer=C,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=I.getProxy(D.MainContext.MainThreadLanguages)}$acceptLanguageIds(I){this._languageIds=I}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(I,g){await this._proxy.$changeLanguage(I,g);const w=this._documents.getDocumentData(I);if(!w)throw new Error(`document '${I.toString()}' NOT found`);return w.document}async tokenAtPosition(I,g){const w=I.version,C=N.Position.from(g),l=await this._proxy.$tokensAtPosition(I.uri,C),f={type:m.StandardTokenType.Other,range:I.getWordRangeAtPosition(g)??new m.Range(g.line,g.character,g.line,g.character)};if(!l)return f;const s={range:N.Range.to(l.range),type:N.TokenType.to(l.type)};return!s.range.contains(g)||w!==I.version?f:s}createLanguageStatusItem(I,g,w){const C=this._handlePool++,l=this._proxy,f=this._ids,s=`${I.identifier.value}/${g}`;if(f.has(s))throw new Error(`LanguageStatusItem with id '${g}' ALREADY exists`);f.add(s);const i={selector:w,id:g,name:I.displayName??I.name,severity:m.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new v.DisposableStore,a=()=>{if(n?.dispose(),!f.has(s)){console.warn(`LanguageStatusItem (${g}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(C,{id:s,name:i.name??I.displayName??I.name,source:I.displayName??I.name,selector:N.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===m.LanguageStatusSeverity.Error?k.default.Error:i.severity===m.LanguageStatusSeverity.Warning?k.default.Warning:k.default.Info,command:i.command&&this._commands.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),l.$removeLanguageStatus(C),f.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,p.checkProposedApiEnabled)(I,"languageStatusText"),i.text=r,a()},get text2(){return(0,p.checkProposedApiEnabled)(I,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.ExtHostLanguages=S}),define(ye[115],Ce([1,0,11,13,2,5,14,6,27,20]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(g,w,C){this.logService=C,this.bundleCache=new Map,this._proxy=w.getProxy(v.MainContext.MainThreadLocalization),this.currentLanguage=g.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===D.LANGUAGE_DEFAULT}getMessage(g,w){const{message:C,args:l,comment:f}=w;if(this.isDefaultLanguage)return(0,N.format2)(C,l??{});let s=C;f&&f.length>0&&(s+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.bundleCache.get(g)?.contents[s];return i||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.format2)(i??C,l??{})}getBundle(g){return this.bundleCache.get(g)?.contents}getBundleUri(g){return this.bundleCache.get(g)?.uri}async initializeLocalizedMessages(g){if(this.isDefaultLanguage||!g.l10n&&!g.isBuiltin||this.bundleCache.has(g.identifier.value))return;let w;const C=await this.getBundleLocation(g);if(!C){this.logService.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const l=await this._proxy.$fetchBundleContents(C),f=JSON.parse(l);w=g.isBuiltin?f.contents?.bundle:f}catch(l){this.logService.error(`Failed to load translations for ${g.identifier.value} from ${C}: ${l.message}`);return}w&&this.bundleCache.set(g.identifier.value,{contents:w,uri:C})}async getBundleLocation(g){if(g.isBuiltin){const w=await this._proxy.$fetchBuiltInBundleUri(g.identifier.value,this.currentLanguage);return m.URI.revive(w)}return g.l10n?m.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=L,e.ExtHostLocalizationService=L=Ge([We(0,p.IExtHostInitDataService),We(1,S.IExtHostRpcService),We(2,R.ILogService)],L),e.IExtHostLocalizationService=(0,k.createDecorator)("IExtHostLocalizationService")}),define(ye[150],Ce([1,0,14,6,27,20,2,54]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let p=class extends D.AbstractLoggerService{constructor(I,g){super(g.logLevel,g.logsLocation,g.loggers.map(w=>(0,v.revive)(w))),this._proxy=I.getProxy(N.MainContext.MainThreadLogger)}$setLogLevel(I,g){g?this.setLogLevel(R.URI.revive(g),I):this.setLogLevel(I)}setVisibility(I,g){super.setVisibility(I,g),this._proxy.$setVisibility(I,g)}doCreateLogger(I,g,w){return new S(this._proxy,I,g,w)}};e.ExtHostLoggerService=p,e.ExtHostLoggerService=p=Ge([We(0,k.IExtHostRpcService),We(1,m.IExtHostInitDataService)],p);class S extends D.AbstractMessageLogger{constructor(I,g,w,C){super(C?.logLevel==="always"),this.proxy=I,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.proxy.$createLogger(g,C).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,g){const w=[[I,g]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(I){this.proxy.$log(this.file,I)}flush(){this.proxy.$flush(this.file)}}}),define(ye[116],Ce([1,0,6,5,3,20,22]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,N.createDecorator)("IExtHostManagedSockets");let v=class{constructor(I){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=I.getProxy(D.MainContext.MainThreadManagedSockets)}setFactory(I,g){for(const w of this._managedRemoteSockets.values())w.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new p(I,g),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(I){if(!this._factory||this._factory.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const g=++this._remoteSocketIdCounter,w=await this._factory.makeConnection(),C=new m.DisposableStore;return this._managedRemoteSockets.set(g,new S(g,w,C)),C.add((0,m.toDisposable)(()=>this._managedRemoteSockets.delete(g))),C.add(w.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(g),C.dispose()})),C.add(w.onDidClose(l=>{this._proxy.$onDidManagedSocketClose(g,l?.stack??l?.message),C.dispose()})),C.add(w.onDidReceiveMessage(l=>this._proxy.$onDidManagedSocketHaveData(g,R.VSBuffer.wrap(l)))),g}$remoteSocketWrite(I,g){this._managedRemoteSockets.get(I)?.actual.send(g.buffer)}$remoteSocketEnd(I){const g=this._managedRemoteSockets.get(I);g&&(g.actual.end(),g.dispose())}async $remoteSocketDrain(I){await this._managedRemoteSockets.get(I)?.actual.drain?.()}};e.ExtHostManagedSockets=v,e.ExtHostManagedSockets=v=Ge([We(0,k.IExtHostRpcService)],v);class p{constructor(I,g){this.socketFactoryId=I,this.makeConnection=g}}class S extends m.Disposable{constructor(I,g,w){super(),this.socketId=I,this.actual=g,this._register(w)}}}),define(ye[329],Ce([1,0,6,14,25]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function k(v){return v&&v.title}let R=class{constructor(p,S){this._logService=S,this._proxy=p.getProxy(D.MainContext.MainThreadMessageService)}showMessage(p,S,L,I,g){const w={source:{identifier:p.identifier,label:p.displayName||p.name}};let C;typeof I=="string"||k(I)?C=[I,...g]:(w.modal=I?.modal,w.useCustom=I?.useCustom,w.detail=I?.detail,C=g),w.useCustom&&(0,m.checkProposedApiEnabled)(p,"resolvers");const l=[];for(let f=0;f<C.length;f++){const s=C[f];if(typeof s=="string")l.push({title:s,handle:f,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;l.push({title:i,isCloseAffordance:!!n,handle:f})}else this._logService.warn("Invalid message item:",s)}return this._proxy.$showMessage(S,L,w,l).then(f=>{if(typeof f=="number")return C[f]})}};e.ExtHostMessageService=R,e.ExtHostMessageService=R=Ge([We(1,N.ILogService)],R)}),define(ye[330],Ce([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let n=class{constructor(d,y,A,E,b){this._initData=y,this._extHostNotebook=A,this._commands=E,this._logService=b,this._activeExecutions=new v.ResourceMap,this._activeNotebookExecutions=new v.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=d.getProxy(I.MainContext.MainThreadNotebookKernels);const _=new g.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const U=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:U}}else if(T&&"notebookEditor"in T){const U=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return T})],g.ApiCommandResult.Void);this._commands.registerApiCommand(_)}createNotebookController(d,y,A,E,b,_){for(const Q of this._kernelData.values())if(Q.controller.id===y&&S.ExtensionIdentifier.equals(d.identifier,Q.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const T=this._handlePool++,U=this;this._logService.trace(`NotebookController[${T}], CREATED by ${d.identifier.value}, ${y}`);const M=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${d.identifier}'`);let P=!1;const x=new k.Emitter,F=new k.Emitter,O={id:u(d.identifier,y),notebookType:A,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:E||d.identifier.value,preloads:_?_.map(w.NotebookRendererScript.from):[]};let W=b??M,J,ce;this._proxy.$addKernel(T,O).catch(Q=>{console.log(Q),P=!0});let G=0;const X=()=>{if(P)return;const Q=++G;Promise.resolve().then(()=>{Q===G&&this._proxy.$updateKernel(T,O)})},Y=new v.ResourceMap,se={get id(){return y},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return O.label},set label(Q){O.label=Q??d.displayName??d.name,X()},get detail(){return O.detail??""},set detail(Q){O.detail=Q,X()},get description(){return O.description??""},set description(Q){O.description=Q,X()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(Q){O.supportedLanguages=Q,X()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){O.supportsExecutionOrder=Q,X()},get rendererScripts(){return O.preloads?O.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Q){W=Q??M},get interruptHandler(){return J},set interruptHandler(Q){J=Q,O.supportsInterrupt=!!Q,X()},set variableProvider(Q){(0,s.checkProposedApiEnabled)(d,"notebookVariableProvider"),ce=Q,O.hasVariableProvider=!!Q,Q?.onDidChangeVariables(we=>U._proxy.$variablesUpdated(we.uri)),X()},get variableProvider(){return ce},createNotebookCellExecution(Q){if(P)throw new Error("notebook controller is DISPOSED");if(!Y.has(Q.notebook.uri))throw U._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return U._createNotebookCellExecution(Q,u(d.identifier,this.id))},createNotebookExecution(Q){if((0,s.checkProposedApiEnabled)(d,"notebookExecution"),P)throw new Error("notebook controller is DISPOSED");if(!Y.has(Q.uri))throw U._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.uri.toString()}`);return U._createNotebookExecution(Q,u(d.identifier,this.id))},dispose:()=>{P||(this._logService.trace(`NotebookController[${T}], DISPOSED`),P=!0,this._kernelData.delete(T),x.dispose(),F.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(Q,we){we===C.NotebookControllerAffinity2.Hidden&&(0,s.checkProposedApiEnabled)(d,"notebookControllerAffinityHidden"),U._proxy.$updateNotebookPriority(T,Q.uri,we)},onDidReceiveMessage:F.event,postMessage(Q,we){return(0,s.checkProposedApiEnabled)(d,"notebookMessaging"),U._proxy.$postMessage(T,we&&U._extHostNotebook.getIdByEditor(we),Q)},asWebviewUri(Q){return(0,s.checkProposedApiEnabled)(d,"notebookMessaging"),(0,l.asWebviewUri)(Q,U._initData.remote)}};return this._kernelData.set(T,{extensionId:d.identifier,controller:se,onDidReceiveMessage:F,onDidChangeSelection:x,associatedNotebooks:Y}),se}getIdByController(d){for(const[y,A]of this._kernelData)if(A.controller===d)return u(A.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,y){const A=this._kernelDetectionTaskHandlePool++,E=this;this._logService.trace(`NotebookControllerDetectionTask[${A}], CREATED by ${d.identifier.value}`),this._proxy.$addKernelDetectionTask(A,y);const b={dispose:()=>{this._kernelDetectionTask.delete(A),E._proxy.$removeKernelDetectionTask(A)}};return this._kernelDetectionTask.set(A,b),b}registerKernelSourceActionProvider(d,y,A){const E=this._kernelSourceActionProviderHandlePool++,b=typeof A.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,_=this;this._kernelSourceActionProviders.set(E,A),this._logService.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${d.identifier.value}`),this._proxy.$addKernelSourceActionProvider(E,E,y);let T;return b!==void 0&&(T=A.onDidChangeNotebookKernelSourceActions(U=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this._kernelSourceActionProviders.delete(E),_._proxy.$removeKernelSourceActionProvider(E,E),T?.dispose()}}}async $provideKernelSourceActions(d,y){const A=this._kernelSourceActionProviders.get(d);if(A){const E=new R.DisposableStore;return(await A.provideNotebookKernelSourceActions(y)??[]).map(_=>w.NotebookKernelSourceAction.from(_,this._commands.converter,E))}return[]}$acceptNotebookAssociation(d,y,A){const E=this._kernelData.get(d);if(E){const b=this._extHostNotebook.getNotebookDocument(p.URI.revive(y));A?E.associatedNotebooks.set(b.uri,!0):E.associatedNotebooks.delete(b.uri),this._logService.trace(`NotebookController[${d}] ASSOCIATE notebook`,b.uri.toString(),A),E.onDidChangeSelection.fire({selected:A,notebook:b.apiNotebook})}}async $executeCells(d,y,A){const E=this._kernelData.get(d);if(!E)return;const b=this._extHostNotebook.getNotebookDocument(p.URI.revive(y)),_=[];for(const T of A){const U=b.getCell(T);U&&_.push(U.apiCell)}try{this._logService.trace(`NotebookController[${d}] EXECUTE cells`,b.uri.toString(),_.length),await E.controller.executeHandler.call(E.controller,_,b.apiNotebook,E.controller)}catch(T){this._logService.error(`NotebookController[${d}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(d,y,A){const E=this._kernelData.get(d);if(!E)return;const b=this._extHostNotebook.getNotebookDocument(p.URI.revive(y));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,b.apiNotebook);else for(const _ of A){const T=b.getCell(_);T&&this._activeExecutions.get(T.uri)?.cancel()}if(E.controller.interruptHandler){const _=this._activeNotebookExecutions.get(b.uri);A.length&&Array.isArray(_)&&_.length&&_.forEach(T=>T.dispose())}}async $provideVariables(d,y,A,E,b,_,T){const U=this._kernelData.get(d);if(!U)return;const M=this._extHostNotebook.getNotebookDocument(p.URI.revive(A)),P=U.controller.variableProvider;if(!P)return;const x=E?{name:E,value:""}:void 0,F=b==="named"?C.NotebookVariablesRequestKind.Named:C.NotebookVariablesRequestKind.Indexed,O=P.provideVariables(M.apiNotebook,x,F,_,T);for await(const W of O){if(T.isCancellationRequested)return;this._proxy.$receiveVariable(y,W)}}$acceptKernelMessageFromRenderer(d,y,A){const E=this._kernelData.get(d);if(!E)return;const b=this._extHostNotebook.getEditorById(y);E.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:A}))}$cellExecutionChanged(d,y,A){const b=this._extHostNotebook.getNotebookDocument(p.URI.revive(d)).getCell(y);if(b){const _=A?w.NotebookCellExecutionState.to(A):C.NotebookCellExecutionState.Idle;_!==void 0&&this._onDidChangeCellExecutionState.fire({cell:b.apiCell,state:_})}}_createNotebookCellExecution(d,y){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this._extHostNotebook.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!E)throw new Error("invalid cell");if(this._activeExecutions.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const b=new a(y,E,this._proxy);this._activeExecutions.set(E.uri,b);const _=b.onDidChangeState(()=>{b.state===o.Resolved&&(b.dispose(),_.dispose(),this._activeExecutions.delete(E.uri))});return b.asApiObject()}_createNotebookExecution(d,y){const A=this._extHostNotebook.getNotebookDocument(d.uri),E=d.getCells().find(T=>{const U=A.getCellFromApiCell(T);return U&&this._activeExecutions.has(U.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this._activeNotebookExecutions.has(A.uri))throw new Error(`duplicate notebook execution for ${A.uri}`);const b=new r(y,A,this._proxy),_=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),_.dispose(),this._activeNotebookExecutions.delete(A.uri))});return this._activeNotebookExecutions.set(A.uri,[b,_]),b.asApiObject()}};e.ExtHostNotebookKernels=n,e.ExtHostNotebookKernels=n=Ge([We(4,L.ILogService)],n);var o;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(o||(o={}));class a extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(d,y,A){super(),this._cell=y,this._proxy=A,this._handle=a.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new m.CancellationTokenSource),this._collector=new h(10,E=>this.update(E)),this._executionOrder=y.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,d,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(d){await this._collector.addItem(d)}async update(d){const y=Array.isArray(d)?d:[d];return this._proxy.$updateExecution(this._handle,new i.SerializableObjectWithBuffers(y))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(d){let y=this._cell;if(d&&(y=this._cell.notebook.getCellFromApiCell(d)),!y)throw new Error("INVALID cell");return y.handle}validateAndConvertOutputs(d){return d.map(y=>{const A=C.NotebookCellOutput.ensureUniqueMimeTypes(y.items,!0);return A===y.items?w.NotebookCellOutput.from(y):w.NotebookCellOutput.from({items:A,id:y.id,metadata:y.metadata})})}async updateOutputs(d,y,A){const E=this.cellIndexToHandle(y),b=this.validateAndConvertOutputs((0,D.asArray)(d));return this.updateSoon({editType:f.CellExecutionUpdateType.Output,cellHandle:E,append:A,outputs:b})}async updateOutputItems(d,y,A){return d=C.NotebookCellOutput.ensureUniqueMimeTypes((0,D.asArray)(d),!0),this.updateSoon({editType:f.CellExecutionUpdateType.OutputItems,items:d.map(w.NotebookCellOutputItem.from),outputId:y.id,append:A})}asApiObject(){const d=this;return Object.freeze({get token(){return d._tokenSource.token},get cell(){return d._cell.apiCell},get executionOrder(){return d._executionOrder},set executionOrder(A){d._executionOrder=A,d.update([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:d._executionOrder}])},start(A){if(d._state===o.Resolved||d._state===o.Started)throw new Error("Cannot call start again");d._state=o.Started,d._onDidChangeState.fire(),d.update({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:A})},end(A,E){if(d._state===o.Resolved)throw new Error("Cannot call resolve twice");d._state=o.Resolved,d._onDidChangeState.fire(),d._collector.flush(),d._proxy.$completeExecution(d._handle,new i.SerializableObjectWithBuffers({runEndTime:E,lastRunSuccess:A}))},clearOutput(A){return d.verifyStateForOutput(),d.updateOutputs([],A,!1)},appendOutput(A,E){return d.verifyStateForOutput(),d.updateOutputs(A,E,!0)},replaceOutput(A,E){return d.verifyStateForOutput(),d.updateOutputs(A,E,!1)},appendOutputItems(A,E){return d.verifyStateForOutput(),d.updateOutputItems(A,E,!0)},replaceOutputItems(A,E){return d.verifyStateForOutput(),d.updateOutputItems(A,E,!1)}})}}var t;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(t||(t={}));class r extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(d,y,A){super(),this._notebook=y,this._proxy=A,this._handle=r.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new m.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,d,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===t.Resolved||this._state===t.Started)throw new Error("Cannot call start again");this._state=t.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===t.Resolved)throw new Error("Cannot call resolve twice");this._state=t.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class h{constructor(d,y){this.delay=d,this.callback=y,this.batch=[],this.startedTimer=Date.now()}addItem(d){return this.batch.push(d),this.currentDeferred||(this.currentDeferred=new N.DeferredPromise,this.startedTimer=Date.now(),(0,N.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const d=this.currentDeferred;this.currentDeferred=void 0;const y=this.batch;return this.batch=[],this.callback(y).finally(()=>d.complete())}}function u(c,d){return`${c.value}/${d}`}e.createKernelId=u}),define(ye[331],Ce([1,0,4,6,146]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(v,p){this._extHostNotebook=p,this._rendererMessageEmitters=new Map,this.proxy=v.getProxy(N.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(v,p,S){const L=this._extHostNotebook.getEditorById(v);this._rendererMessageEmitters.get(p)?.fire({editor:L.apiEditor,message:S})}createRendererMessaging(v,p){if(!v.contributes?.notebookRenderer?.some(L=>L.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(L,I,g)=>this.getOrCreateEmitterFor(p).event(L,I,g),postMessage:(L,I)=>{m.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const g=I&&m.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(g?.id,p,L)}}}getOrCreateEmitterFor(v){let p=this._rendererMessageEmitters.get(v);return p||(p=new D.Emitter({onDidRemoveLastListener:()=>{p?.dispose(),this._rendererMessageEmitters.delete(v)}}),this._rendererMessageEmitters.set(v,p),p)}}e.ExtHostNotebookRenderers=k}),define(ye[332],Ce([1,0,3,18,2,25,6]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class v{constructor(S){this.handlers=new Map,this.proxy=S.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,L,I){if((0,k.checkProposedApiEnabled)(S,"profileContentHandlers"),this.handlers.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.handlers.set(L,I),this.proxy.$registerProfileContentHandler(L,I.name,I.description,S.identifier.value),(0,D.toDisposable)(()=>{this.handlers.delete(L),this.proxy.$unregisterProfileContentHandler(L)})}async $saveProfile(S,L,I,g){const w=this.handlers.get(S);if(!w)throw new Error(`Unknown handler with id: ${S}`);return w.saveProfile(L,I,g)}async $readProfile(S,L,I){const g=this.handlers.get(S);if(!g)throw new Error(`Unknown handler with id: ${S}`);return g.readProfile((0,N.isString)(L)?L:m.URI.revive(L),I)}}e.ExtHostProfileContentHandlers=v}),define(ye[333],Ce([1,0,2,6,12,15]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{static{this.handlePool=0}constructor(p,S){this.uriTransformer=S,this.providers=new Map,this.proxy=p.getProxy(N.MainContext.MainThreadQuickDiff)}$provideOriginalResource(p,S,L){const I=D.URI.revive(S),g=this.providers.get(p);return g?(0,m.asPromise)(()=>g.provideOriginalResource(I,L)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(p,S,L,I){const g=R.handlePool++;return this.providers.set(g,S),this.proxy.$registerQuickDiffProvider(g,k.DocumentSelector.from(p,this.uriTransformer),L,I),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(g),this.providers.delete(g)}}}}e.ExtHostQuickDiff=R}),define(ye[334],Ce([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(l,f,s){const i=l.getProxy(k.MainContext.MainThreadQuickOpen);class n{constructor(y,A){this._sessions=new Map,this._instances=0,this._workspace=y,this._commands=A}showQuickPick(y,A,E,b=D.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(A),T=++this._instances,U=i.$show(T,{title:E?.title,placeHolder:E?.placeHolder,matchOnDescription:E?.matchOnDescription,matchOnDetail:E?.matchOnDetail,ignoreFocusLost:E?.ignoreFocusOut,canPickMany:E?.canPickMany},b),M={},P=U.then(()=>M);return Promise.race([P,_]).then(x=>{if(x===M)return;const F=(0,g.isProposedApiEnabled)(y,"quickPickItemTooltip");return _.then(O=>{const W=[];for(let J=0;J<O.length;J++){const ce=O[J];if(typeof ce=="string")W.push({label:ce,handle:J});else if(ce.kind===v.QuickPickItemKind.Separator)W.push({type:"separator",label:ce.label});else{ce.tooltip&&!F&&console.warn(`Extension '${y.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${y.identifier.value}`);const G=ce.iconPath?h(ce.iconPath):void 0;W.push({label:ce.label,iconPath:G?.iconPath,iconClass:G?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:F?w.MarkdownString.fromStrict(ce.tooltip):void 0,handle:J})}}return E&&typeof E.onDidSelectItem=="function"&&(this._onDidSelectItem=J=>{E.onDidSelectItem(O[J])}),i.$setItems(T,W),U.then(J=>{if(typeof J=="number")return O[J];if(Array.isArray(J))return J.map(ce=>O[ce])})})}).then(void 0,x=>{if(!(0,p.isCancellationError)(x))return i.$setError(T,x),Promise.reject(x)})}$onItemSelected(y){this._onDidSelectItem?.(y)}showInput(y,A=D.CancellationToken.None){return this._validateInput=y?.validateInput,i.$input(y,typeof this._validateInput=="function",A).then(void 0,E=>{if(!(0,p.isCancellationError)(E))return Promise.reject(E)})}async $validateInput(y){if(!this._validateInput)return;const A=await this._validateInput(y);if(!A||typeof A=="string")return A;let E;switch(A.severity){case v.InputBoxValidationSeverity.Info:E=L.default.Info;break;case v.InputBoxValidationSeverity.Warning:E=L.default.Warning;break;case v.InputBoxValidationSeverity.Error:E=L.default.Error;break;default:E=A.message?L.default.Error:L.default.Ignore;break}return{content:A.message,severity:E}}async showWorkspaceFolderPick(y,A=D.CancellationToken.None){const E=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[y]);if(!E)return;const b=await this._workspace.getWorkspaceFolders2();if(b)return b.find(_=>_.uri.toString()===E.uri.toString())}createQuickPick(y){const A=new u(y,()=>this._sessions.delete(A._id));return this._sessions.set(A._id,A),A}createInputBox(y){const A=new c(y,()=>this._sessions.delete(A._id));return this._sessions.set(A._id,A),A}$onDidChangeValue(y,A){this._sessions.get(y)?._fireDidChangeValue(A)}$onDidAccept(y){this._sessions.get(y)?._fireDidAccept()}$onDidChangeActive(y,A){const E=this._sessions.get(y);E instanceof u&&E._fireDidChangeActive(A)}$onDidChangeSelection(y,A){const E=this._sessions.get(y);E instanceof u&&E._fireDidChangeSelection(A)}$onDidTriggerButton(y,A){this._sessions.get(y)?._fireDidTriggerButton(A)}$onDidTriggerItemButton(y,A,E){const b=this._sessions.get(y);b instanceof u&&b._fireDidTriggerItemButton(A,E)}$onDidHide(y){this._sessions.get(y)?._fireDidHide()}}class o{static{this._nextId=1}constructor(y,A){this._extensionId=y,this._onDidDispose=A,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new N.Emitter,this._onDidChangeValueEmitter=new N.Emitter,this._onDidTriggerButtonEmitter=new N.Emitter,this._onDidHideEmitter=new N.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(y){this._title=y,this.update({title:y})}get step(){return this._steps}set step(y){this._steps=y,this.update({step:y})}get totalSteps(){return this._totalSteps}set totalSteps(y){this._totalSteps=y,this.update({totalSteps:y})}get enabled(){return this._enabled}set enabled(y){this._enabled=y,this.update({enabled:y})}get busy(){return this._busy}set busy(y){this._busy=y,this.update({busy:y})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(y){this._ignoreFocusOut=y,this.update({ignoreFocusOut:y})}get value(){return this._value}set value(y){this._value=y,this.update({value:y})}get placeholder(){return this._placeholder}set placeholder(y){this._placeholder=y,this.update({placeholder:y})}get buttons(){return this._buttons}set buttons(y){this._buttons=y.slice(),this._handlesToButtons.clear(),y.forEach((A,E)=>{const b=A===v.QuickInputButtons.Back?-1:E;this._handlesToButtons.set(b,A)}),this.update({buttons:y.map((A,E)=>({...h(A.iconPath),tooltip:A.tooltip,handle:A===v.QuickInputButtons.Back?-1:E}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(y){this._value=y,this._onDidChangeValueEmitter.fire(y)}_fireDidTriggerButton(y){const A=this._handlesToButtons.get(y);A&&this._onDidTriggerButtonEmitter.fire(A)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,m.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),i.$dispose(this._id))}update(y){if(!this._disposed){for(const A of Object.keys(y)){const E=y[A];this._pendingUpdate[A]=E===void 0?null:E}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){i.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function a(d){if(d instanceof v.ThemeIcon)return{id:d.id};const y=r(d),A=t(d);return{dark:typeof y=="string"?R.URI.file(y):y,light:typeof A=="string"?R.URI.file(A):A}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function r(d){return typeof d=="object"&&"dark"in d?d.dark:d}function h(d){const y=a(d);let A,E;return"id"in y?E=I.ThemeIcon.asClassName(y):A=y,{iconPath:A,iconClass:E}}class u extends o{constructor(y,A){super(y.identifier,A),this.extension=y,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new N.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new N.Emitter,this._onDidTriggerItemButtonEmitter=new N.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(y){this._items=y.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),y.forEach((b,_)=>{this._handlesToItems.set(_,b),this._itemsToHandles.set(b,_)});const A=(0,g.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),E=[];for(let b=0;b<y.length;b++){const _=y[b];if(_.kind===v.QuickPickItemKind.Separator)E.push({type:"separator",label:_.label});else{_.tooltip&&!A&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const T=_.iconPath?h(_.iconPath):void 0;E.push({handle:b,label:_.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,tooltip:A?w.MarkdownString.fromStrict(_.tooltip):void 0,buttons:_.buttons?.map((U,M)=>({...h(U.iconPath),tooltip:U.tooltip,handle:M}))})}}this.update({items:E})}get canSelectMany(){return this._canSelectMany}set canSelectMany(y){this._canSelectMany=y,this.update({canSelectMany:y})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(y){this._matchOnDescription=y,this.update({matchOnDescription:y})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(y){this._matchOnDetail=y,this.update({matchOnDetail:y})}get sortByLabel(){return this._sortByLabel}set sortByLabel(y){this._sortByLabel=y,this.update({sortByLabel:y})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(y){this._keepScrollPosition=y,this.update({keepScrollPosition:y})}get activeItems(){return this._activeItems}set activeItems(y){this._activeItems=y.filter(A=>this._itemsToHandles.has(A)),this.update({activeItems:this._activeItems.map(A=>this._itemsToHandles.get(A))})}get selectedItems(){return this._selectedItems}set selectedItems(y){this._selectedItems=y.filter(A=>this._itemsToHandles.has(A)),this.update({selectedItems:this._selectedItems.map(A=>this._itemsToHandles.get(A))})}_fireDidChangeActive(y){const A=(0,S.coalesce)(y.map(E=>this._handlesToItems.get(E)));this._activeItems=A,this._onDidChangeActiveEmitter.fire(A)}_fireDidChangeSelection(y){const A=(0,S.coalesce)(y.map(E=>this._handlesToItems.get(E)));this._selectedItems=A,this._onDidChangeSelectionEmitter.fire(A)}_fireDidTriggerItemButton(y,A){const E=this._handlesToItems.get(y);if(!E||!E.buttons||!E.buttons.length)return;const b=E.buttons[A];b&&this._onDidTriggerItemButtonEmitter.fire({button:b,item:E})}}class c extends o{constructor(y,A){super(y.identifier,A),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(y){this._password=y,this.update({password:y})}get prompt(){return this._prompt}set prompt(y){this._prompt=y,this.update({prompt:y})}get valueSelection(){return this._valueSelection}set valueSelection(y){this._valueSelection=y,this.update({valueSelection:y})}get validationMessage(){return this._validationMessage}set validationMessage(y){this._validationMessage=y,y?typeof y=="string"?this.update({validationMessage:y,severity:L.default.Error}):this.update({validationMessage:y.message,severity:y.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new n(f,s)}e.createExtHostQuickOpen=C}),define(ye[335],Ce([1,0,2,4,59,3,12,6,19,128,14,26,61,15,25,17,11]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(M){return M instanceof D.URI}function n(M,P){return M.scheme===l.Schemas.file&&P.scheme===l.Schemas.file&&f.isLinux?M.toString()===P.toString():M.toString().toLowerCase()===P.toString().toLowerCase()}function o(M){if(M)return typeof M.iconPath=="string"?D.URI.file(M.iconPath):D.URI.isUri(M.iconPath)||g.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function a(M){if(M?.icon){if(D.URI.isUri(M.icon))return M.icon;if(g.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const P=M.icon;return{light:P.light,dark:P.dark}}}else return}function t(M){if(M.icon){if(D.URI.isUri(M.icon))return M.icon;if(g.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const P=M.icon;return{light:P.light,dark:P.dark}}}else return}function r(M){if(M.icon){if(D.URI.isUri(M.icon))return M.icon;if(g.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const P=M.icon;return{light:P.light,dark:P.dark}}}else return}function h(M,P){if(!M.iconPath&&!P.iconPath)return 0;if(M.iconPath){if(!P.iconPath)return 1}else return-1;const x=typeof M.iconPath=="string"?M.iconPath:D.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,F=typeof P.iconPath=="string"?P.iconPath:D.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,S.comparePaths)(x,F)}function u(M,P){let x=0;if(M.strikeThrough!==P.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==P.faded)return M.faded?1:-1;if(M.tooltip!==P.tooltip)return(M.tooltip||"").localeCompare(P.tooltip||"");if(x=h(M,P),x!==0)return x;if(M.light&&P.light)x=h(M.light,P.light);else{if(M.light)return 1;if(P.light)return-1}if(x!==0)return x;if(M.dark&&P.dark)x=h(M.dark,P.dark);else{if(M.dark)return 1;if(P.dark)return-1}return x}function c(M,P){if(M.command!==P.command)return M.command<P.command?-1:1;if(M.title!==P.title)return M.title<P.title?-1:1;if(M.tooltip!==P.tooltip){if(M.tooltip!==void 0&&P.tooltip!==void 0)return M.tooltip<P.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(M.arguments===P.arguments)return 0;if(M.arguments)if(P.arguments){if(M.arguments.length!==P.arguments.length)return M.arguments.length-P.arguments.length}else return 1;else return-1;for(let x=0;x<M.arguments.length;x++){const F=M.arguments[x],O=P.arguments[x];if(F!==O&&!(i(F)&&i(O)&&n(F,O)))return F<O?-1:1}return 0}function d(M,P){let x=(0,S.comparePaths)(M.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(x!==0)return x;if(M.command&&P.command)x=c(M.command,P.command);else{if(M.command)return 1;if(P.command)return-1}if(x!==0)return x;if(M.decorations&&P.decorations)x=u(M.decorations,P.decorations);else{if(M.decorations)return 1;if(P.decorations)return-1}return x}function y(M,P){for(let x=0;x<M.length;x++)if(M[x]!==P[x])return!1;return!0}function A(M,P){return M.command===P.command&&M.title===P.title&&M.tooltip===P.tooltip&&(M.arguments&&P.arguments?y(M.arguments,P.arguments):M.arguments===P.arguments)}function E(M,P){return(0,p.equals)(M,P,A)}class b{#e;#t;get value(){return this._value}set value(P){P=P??"",this.#e.$setInputBoxValue(this._sourceControlHandle,P),this.updateValue(P)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(P){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,P),this._placeholder=P}get validateInput(){return(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(P){if((0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=P,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!P)}get enabled(){return this._enabled}set enabled(P){P=!!P,this._enabled!==P&&(this._enabled=P,this.#e.$setInputBoxEnablement(this._sourceControlHandle,P))}get visible(){return this._visible}set visible(P){P=!!P,this._visible!==P&&(this._visible=P,this.#e.$setInputBoxVisibility(this._sourceControlHandle,P))}get actionButton(){return(0,C.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButton}set actionButton(P){(0,C.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButtonDisposables.value=new k.DisposableStore,this._actionButton=P;const x=P!==void 0?{command:this._commands.converter.toInternal(P.command,this._actionButtonDisposables.value),icon:a(P),enabled:P.enabled}:void 0;this.#e.$setInputBoxActionButton(this._sourceControlHandle,x??null)}get document(){return(0,C.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(P,x,F,O,W,J){this._extension=P,this._commands=x,this._sourceControlHandle=W,this._documentUri=J,this._value="",this._onDidChange=new N.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this._actionButtonDisposables=new k.MutableDisposable,this.#t=F,this.#e=O}showValidationMessage(P,x){(0,C.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,P,x)}$onInputBoxValueChange(P){this.updateValue(P)}updateValue(P){this._value=P,this._onDidChange.fire(P)}}e.ExtHostSCMInputBox=b;class _{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(P){this._label=P,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,P)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(P){this._hideWhenEmpty=P,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(P){this._resourceStates=[...P],this._onDidUpdateResourceStates.fire()}constructor(P,x,F,O,W){this._proxy=P,this._commands=x,this._sourceControlHandle=F,this._id=O,this._label=W,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new N.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new N.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=_._handlePool++}getResourceState(P){return this._resourceStatesMap.get(P)}$executeResourceCommand(P,x){const F=this._resourceStatesCommandsMap.get(P);return F?(0,R.asPromise)(()=>this._commands.executeCommand(F.command,...F.arguments||[],x)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this._resourceStates].sort(d),F=(0,p.sortedDiff)(this._resourceSnapshot,P,d).map(J=>{const ce=J.toInsert.map(G=>{const X=this._resourceHandlePool++;this._resourceStatesMap.set(X,G);const Y=G.resourceUri;let se;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const Z=new k.DisposableStore;se=this._commands.converter.toInternal(G.command,Z),this._resourceStatesDisposablesMap.set(X,Z)}else this._resourceStatesCommandsMap.set(X,G.command);const Q=o(G.decorations),we=G.decorations&&o(G.decorations.light)||Q,he=G.decorations&&o(G.decorations.dark)||Q,j=[we,he],z=G.decorations&&G.decorations.tooltip||"",ne=G.decorations&&!!G.decorations.strikeThrough,Se=G.decorations&&!!G.decorations.faded,de=G.contextValue||"";return{rawResource:[X,Y,j,z,ne,Se,de,se],handle:X}});return{start:J.start,deleteCount:J.deleteCount,toInsert:ce}}),O=F.map(({start:J,deleteCount:ce,toInsert:G})=>[J,ce,G.map(X=>X.rawResource)]),W=F.reverse();for(const{start:J,deleteCount:ce,toInsert:G}of W){const X=G.map(se=>se.handle),Y=this._handlesSnapshot.splice(J,ce,...X);for(const se of Y)this._resourceStatesMap.delete(se),this._resourceStatesCommandsMap.delete(se),this._resourceStatesDisposablesMap.get(se)?.dispose(),this._resourceStatesDisposablesMap.delete(se)}return this._resourceSnapshot=P,O}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class T{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(P){this._count!==P&&(this._count=P,this.#e.$updateSourceControl(this.handle,{count:P}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(P){this._quickDiffProvider=P;let x;(0,C.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(x=P?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!P,quickDiffLabel:x})}get historyProvider(){return(0,C.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(P){(0,C.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=P,this._historyProviderDisposable.value=new k.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!P}),P&&(this._historyProviderDisposable.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)})),this._historyProviderDisposable.value.add(P.onDidChangeActionButton(()=>{(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new k.DisposableStore;const x=P.actionButton!==void 0?{command:this._commands.converter.toInternal(P.actionButton.command,this._historyProviderActionButtonDisposable.value),description:P.actionButton.description,enabled:P.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,x??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(P){P!==this._commitTemplate&&(this._commitTemplate=P,this.#e.$updateSourceControl(this.handle,{commitTemplate:P}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(P){this._acceptInputDisposables.value=new k.DisposableStore,this._acceptInputCommand=P;const x=this._commands.converter.toInternal(P,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:x})}get actionButton(){return(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(P){(0,C.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new k.DisposableStore,this._actionButton=P;const x=P!==void 0?{command:this._commands.converter.toInternal(P.command,this._actionButtonDisposables.value),secondaryCommands:P.secondaryCommands?.map(F=>F.map(O=>this._commands.converter.toInternal(O,this._actionButtonDisposables.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:x??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(P){if(this._statusBarCommands&&P&&E(this._statusBarCommands,P))return;this._statusBarDisposables.value=new k.DisposableStore,this._statusBarCommands=P;const x=(P||[]).map(F=>this._commands.converter.toInternal(F,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:x})}get selected(){return this._selected}constructor(P,x,F,O,W,J,ce){this._extension=P,this._commands=O,this._id=W,this._label=J,this._rootUri=ce,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new k.MutableDisposable,this._historyProviderActionButtonDisposable=new k.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new k.MutableDisposable,this._statusBarDisposables=new k.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new N.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=T._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=F;const G=D.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${W}/scm${this.handle}/input`,query:ce?`rootUri=${encodeURIComponent(ce.toString())}`:void 0});this._inputBox=new b(P,O,x,this.#e,this.handle,G),this.#e.$registerSourceControl(this.handle,W,J,ce,G)}createResourceGroup(P,x){const F=new _(this.#e,this._commands,this.handle,P,x),O=N.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,O),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const P=[],x=[];for(const[F,O]of this.createdResourceGroups){O.dispose();const W=F.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(F),this.eventuallyUpdateResourceStates()});N.Event.once(F.onDidDispose)(()=>{this.updatedResourceGroups.delete(F),W.dispose(),this._groups.delete(F.handle),this.#e.$unregisterGroup(this.handle,F.handle)}),P.push([F.handle,F.id,F.label,F.features]);const J=F._takeResourceStateSnapshot();J.length>0&&x.push([F.handle,J]),this._groups.set(F.handle,F)}this.#e.$registerGroups(this.handle,P,x),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const P=[];this.updatedResourceGroups.forEach(x=>{const F=x._takeResourceStateSnapshot();F.length!==0&&P.push([x.handle,F])}),P.length>0&&this.#e.$spliceResourceStates(this.handle,P),this.updatedResourceGroups.clear()}getResourceGroup(P){return this._groups.get(P)}setSelectionState(P){this._selected=P,this._onDidChangeSelection.fire(P)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ge([(0,m.debounce)(100)],T.prototype,"eventuallyAddResourceGroups",null),Ge([(0,m.debounce)(100)],T.prototype,"eventuallyUpdateResourceStates",null);let U=class{static{s=this}static{this._handlePool=0}static{this._inputBoxValueProviderHandlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(P,x,F,O){this._commands=x,this._extHostDocuments=F,this.logService=O,this._sourceControls=new Map,this._sourceControlsByExtension=new I.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new N.Emitter,this._inputBoxValueProviders=new Map,this._proxy=P.getProxy(v.MainContext.MainThreadSCM),this._telemetry=P.getProxy(v.MainContext.MainThreadTelemetry),x.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const J=this._sourceControls.get(W.sourceControlHandle);if(!J)return W;const ce=J.getResourceGroup(W.groupHandle);return ce?ce.getResourceState(W.handle):W}else if(W&&W.$mid===4){const J=this._sourceControls.get(W.sourceControlHandle);return J?J.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const J=this._sourceControls.get(W.handle);return J||W}return W}})}createSourceControl(P,x,F,O){this.logService.trace("ExtHostSCM#createSourceControl",P.identifier.value,x,F,O),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const W=s._handlePool++,J=new T(P,this._extHostDocuments,this._proxy,this._commands,x,F,O);this._sourceControls.set(W,J);const ce=this._sourceControlsByExtension.get(P.identifier)||[];return ce.push(J),this._sourceControlsByExtension.set(P.identifier,ce),J}registerSourceControlInputBoxValueProvider(P,x,F){this.logService.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",P.identifier.value,F.label);const O=s._inputBoxValueProviderHandlePool++;return this._inputBoxValueProviders.set(O,F),this._proxy.$registerSourceControlInputBoxValueProvider(O,x,F.label,r(F)),(0,k.toDisposable)(()=>{this._proxy.$unregisterSourceControlInputBoxValueProvider(O),this._inputBoxValueProviders.delete(O)})}async $provideInputBoxValue(P,x,F,O){const W=this._inputBoxValueProviders.get(P);if(W)return await W.provideValue(D.URI.revive(x),F,O)??void 0}getLastInputBox(P){this.logService.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const x=this._sourceControlsByExtension.get(P.identifier),F=x&&x[x.length-1];return F&&F.inputBox}$provideOriginalResource(P,x,F){const O=D.URI.revive(x);this.logService.trace("ExtHostSCM#$provideOriginalResource",P,O.toString());const W=this._sourceControls.get(P);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>W.quickDiffProvider.provideOriginalResource(O,F)).then(J=>J||null)}$onInputBoxValueChange(P,x){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",P);const F=this._sourceControls.get(P);return F&&F.inputBox.$onInputBoxValueChange(x),Promise.resolve(void 0)}$executeResourceCommand(P,x,F,O){this.logService.trace("ExtHostSCM#$executeResourceCommand",P,x,F);const W=this._sourceControls.get(P);if(!W)return Promise.resolve(void 0);const J=W.getResourceGroup(x);return J?J.$executeResourceCommand(F,O):Promise.resolve(void 0)}$validateInput(P,x,F){this.logService.trace("ExtHostSCM#$validateInput",P);const O=this._sourceControls.get(P);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>O.inputBox.validateInput(x,F)).then(W=>{if(!W)return Promise.resolve(void 0);const J=w.MarkdownString.fromStrict(W.message);return J?Promise.resolve([J,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this._sourceControls.get(P)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(P,x,F){return await this._sourceControls.get(P)?.historyProvider?.resolveHistoryItemGroupBase(x,F)??void 0}async $resolveHistoryItemGroupCommonAncestor(P,x,F,O){return await this._sourceControls.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(x,F,O)??void 0}async $provideHistoryItems(P,x,F,O){return(await this._sourceControls.get(P)?.historyProvider?.provideHistoryItems(x,F,O))?.map(ce=>({...ce,icon:t(ce)}))??void 0}async $provideHistoryItemChanges(P,x,F){return await this._sourceControls.get(P)?.historyProvider?.provideHistoryItemChanges(x,F)??void 0}};e.ExtHostSCM=U,e.ExtHostSCM=U=s=Ge([We(3,L.ILogService)],U)}),define(ye[117],Ce([1,0,6,4,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class k{constructor(v){this._onDidChangePassword=new N.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=v.getProxy(D.MainContext.MainThreadSecretState)}async $onDidChangePassword(v){this._onDidChangePassword.fire(v)}get(v,p){return this._proxy.$getPassword(v,p)}store(v,p,S){return this._proxy.$setPassword(v,p,S)}delete(v,p){return this._proxy.$deletePassword(v,p)}}e.ExtHostSecretState=k,e.IExtHostSecretState=(0,m.createDecorator)("IExtHostSecretState")}),define(ye[336],Ce([1,0,6,15,2]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class k{static{this.handlePool=0}constructor(v,p){this.uriTransformer=p,this.providers=new Map,this.proxy=v.getProxy(D.MainContext.MainThreadShare)}async $provideShare(v,p,S){return await this.providers.get(v)?.provideShare({selection:N.Range.to(p.selection),resourceUri:m.URI.revive(p.resourceUri)},S)??void 0}registerShareProvider(v,p){const S=k.handlePool++;return this.providers.set(S,p),this.proxy.$registerShareProvider(S,N.DocumentSelector.from(v,this.uriTransformer),p.id,p.label,p.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(S),this.providers.delete(S)}}}}e.ExtHostShare=k}),define(ye[337],Ce([1,0,21,3,6]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class k{static{this.ID_POOL=1}constructor(v){this.providers=new Map,this.sessions=new Map,this.proxy=v.getProxy(m.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(v,p){const S=this.providers.get(v);if(!S)return;const L=new N.DisposableStore,I=new D.CancellationTokenSource;this.sessions.set(p,I);const g=L.add(S.provideSpeechToTextSession(I.token));L.add(g.onDidChange(w=>{I.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(p,w)})),L.add(I.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(v){this.sessions.get(v)?.dispose(!0),this.sessions.delete(v)}registerProvider(v,p,S){const L=k.ID_POOL++;return this.providers.set(L,S),this.proxy.$registerProvider(L,p,{extension:v,displayName:v.value}),(0,N.toDisposable)(()=>{this.proxy.$unregisterProvider(L),this.providers.delete(L)})}}e.ExtHostSpeech=k}),define(ye[338],Ce([1,0,7,6,217,3,15,18]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class p{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new D.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(g,w,C,l,f,s=D.StatusBarAlignment.Left,i){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new k.DisposableStore,this.#e=g,this.#t=w,f&&l){this._entryId=(0,D.asStatusBarItemIdentifier)(l.identifier,f);const n=C.get(this._entryId);n&&(s=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this._visible=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this._entryId=String(p.ID_GEN++);this._extension=l,this._id=f,this._alignment=s,this._priority=this.validatePriority(i)}validatePriority(g){if((0,v.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!p.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new k.DisposableStore,typeof g=="string"?this._command={fromApi:g,internal:this.#t.toInternal({title:"",command:g},this._latestCommandRegistration)}:g?this._command={fromApi:g,internal:this.#t.toInternal(g,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let w;this._name?w=this._name:w=(0,m.localize)(0,null,this._extension.displayName||this._extension.name);let C=this._color;this._backgroundColor&&(C=p.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const l=R.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,g,this._extension?.identifier.value,w,this._text,l,this._command?.internal,C,this._backgroundColor,this._alignment===D.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=p;class S{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,m.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const w={message:g};return this._messages.unshift(w),this._update(),new D.Disposable(()=>{const C=this._messages.indexOf(w);C>=0&&(this._messages.splice(C,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class L{constructor(g,w){this._existingItems=new Map,this._proxy=g.getProxy(N.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new S(this)}$acceptStaticEntries(g){for(const w of g)this._existingItems.set(w.entryId,w)}createStatusBarEntry(g,w,C,l){return new p(this._proxy,this._commands,this._existingItems,g,w,C,l)}setStatusBarMessage(g,w){const C=this._statusMessage.setMessage(g);let l;return typeof w=="number"?l=setTimeout(()=>C.dispose(),w):typeof w<"u"&&w.then(()=>C.dispose(),()=>C.dispose()),new D.Disposable(()=>{C.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=L}),define(ye[118],Ce([1,0,6,4,5]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class k{constructor(v,p){this._logService=p,this._onDidChangeStorage=new N.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=v.getProxy(D.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(v,p){this._proxy.$registerExtensionStorageKeysToSync(v,p)}async initializeExtensionStorage(v,p,S){const L=await this._proxy.$initializeExtensionStorage(v,p);let I;return L&&(I=this.safeParseValue(v,p,L)),I||S}setValue(v,p,S){return this._proxy.$setValue(v,p,S)}$acceptValue(v,p,S){const L=this.safeParseValue(v,p,S);L&&this._onDidChangeStorage.fire({shared:v,key:p,value:L})}safeParseValue(v,p,S){try{return JSON.parse(S)}catch(L){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${v}): ${L}`)}}}e.ExtHostStorage=k,e.IExtHostStorage=(0,m.createDecorator)("IExtHostStorage")}),define(ye[92],Ce([1,0,5,27,14,71,2]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,D.createDecorator)("IExtensionStoragePaths");let v=class{constructor(S,L,I){this._logService=L,this._extHostFileSystem=I,this._workspace=S.workspace??void 0,this._environment=S.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(S){return R.URI.joinPath(this._environment.workspaceStorageHome,S)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const S=this._workspace.id,L=await this._getWorkspaceStorageURI(S);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(S){if(this._value)return R.URI.joinPath(this._value,S.identifier.value)}globalValue(S){return R.URI.joinPath(this._environment.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=v,e.ExtensionStoragePaths=v=Ge([We(0,N.IExtHostInitDataService),We(1,m.ILogService),We(2,k.IExtHostConsumerFileSystem)],v)}),define(ye[47],Ce([1,0,4,6,5,2,20,3,7,219,8,263,21,30,264,61,12,15,35]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,m.createDecorator)("IExtHostTerminalService");class n{constructor(E,b,_,T){this._proxy=E,this._id=b,this._creationOptions=_,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const U=this;this.value={get name(){return U._name||""},get processId(){return U._pidPromise},get creationOptions(){return U._creationOptions},get exitStatus(){return U._exitStatus},get state(){return U._state},get selection(){return U._selection},sendText(M,P=!0){U._checkDisposed(),U._proxy.$sendText(U._id,M,P)},show(M){U._checkDisposed(),U._proxy.$show(U._id,M)},hide(){U._checkDisposed(),U._proxy.$hide(U._id)},dispose(){U._disposed||(U._disposed=!0,U._proxy.$dispose(U._id))},get dimensions(){if(!(U._cols===void 0||U._rows===void 0))return{columns:U._cols,rows:U._rows}}}}async create(E,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:E.name,shellPath:E.shellPath??void 0,shellArgs:E.shellArgs??void 0,cwd:E.cwd??b?.cwd??void 0,env:E.env??void 0,icon:c(E.iconPath)??void 0,color:l.ThemeColor.isThemeColor(E.color)?E.color.id:void 0,initialText:E.message??void 0,strictEnv:E.strictEnv??void 0,hideFromUser:E.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this._serializeParentTerminal(E.location,b?.resolvedExtHostIdentifier),isTransient:E.isTransient??void 0})}async createExtensionTerminal(E,b,_,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:_,color:l.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(E,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(E,b){return typeof E=="object"?"parentTerminal"in E&&E.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in E?{viewColumn:s.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus}:void 0:E}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(E){this._name=E}setExitStatus(E,b){this._exitStatus=Object.freeze({code:E,reason:b})}setDimensions(E,b){return E===this._cols&&b===this._rows||E===0||b===0?!1:(this._cols=E,this._rows=b,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(E){this._selection=E}_setProcessId(E){this._pidPromiseComplete?(this._pidPromiseComplete(E),this._pidPromiseComplete=void 0):this._pidPromise.then(b=>{b!==E&&(this._pidPromise=Promise.resolve(E))})}}e.ExtHostTerminal=n;class o{get onProcessReady(){return this._onProcessReady.event}constructor(E){this._pty=E,this.id=0,this.shouldPersist=!1,this._onProcessData=new D.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new D.Emitter,this._onDidChangeProperty=new D.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new D.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(E){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${E}`)}updateProperty(E,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${E}, value: ${b}`)}async start(){}shutdown(){this._pty.close()}input(E){this._pty.handleInput?.(E)}resize(E,b){this._pty.setDimensions?.({columns:E,rows:b})}clearBuffer(){}async processBinary(E){}acknowledgeDataEvent(E){}async setUnicodeVersion(E){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(E){this._pty.onDidWrite(b=>this._onProcessData.fire(b)),this._pty.onDidClose?.((b=void 0)=>{this._onProcessExit.fire(b===void 0?void 0:b)}),this._pty.onDidOverrideDimensions?.(b=>{b&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this._pty.onDidChangeName?.(b=>{this._onDidChangeProperty.fire({type:"title",value:b})}),this._pty.open(E||void 0),E&&this._pty.setDimensions?.(E),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends v.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(E=>E.value)}constructor(E,b,_){super(),this._extHostCommands=b,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new v.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new D.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new D.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new D.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new D.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new D.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new D.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new D.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new D.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=_.getProxy(N.MainContext.MainThreadTerminalService),this._bufferer=new C.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(E),this._extHostCommands.registerArgumentProcessor({processArgument:T=>{const U=M=>{const P=M;return this._getTerminalById(P.instanceId)?.value};switch(T?.$mid){case 15:return U(T);default:{if(Array.isArray(T))for(let M=0;M<T.length&&T[M].$mid===15;M++)T[M]=U(T[M]);return T}}}}),this._register({dispose:()=>{for(const[T,U]of this._terminalProcesses)U.shutdown(!0)}})}getDefaultShell(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(E,b){const _=new n(this._proxy,(0,w.generateUuid)(),E,E.name),T=new o(E.pty);return _.createExtensionTerminal(E.location,this._serializeParentTerminal(E,b).resolvedExtHostIdentifier,c(E.iconPath),d(E.color)).then(U=>{const M=this._setupExtHostProcessListeners(U,T);this._terminalProcessDisposables[U]=M}),this._terminals.push(_),_.value}_serializeParentTerminal(E,b){if(b=b||{},E.location&&typeof E.location=="object"&&"parentTerminal"in E.location){const _=E.location.parentTerminal;if(_){const T=this._terminals.find(U=>U.value===_);T&&(b.resolvedExtHostIdentifier=T._id)}}else E.location&&typeof E.location!="object"?b.location=E.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(E,b){if(!this._getTerminalById(E))throw new Error(`Cannot resolve terminal with id ${E} for virtual process`);const T=new o(b),U=this._setupExtHostProcessListeners(E,T);this._terminalProcessDisposables[E]=U}async $acceptActiveTerminalChanged(E){const b=this._activeTerminal;if(E===null){this._activeTerminal=void 0,b!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const _=this._getTerminalById(E);_&&(this._activeTerminal=_,b!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(E,b){const _=this._getTerminalById(E);_&&this._onDidWriteTerminalData.fire({terminal:_.value,data:b})}async $acceptTerminalDimensions(E,b,_){const T=this._getTerminalById(E);T&&T.setDimensions(b,_)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(E,b){const _=this._getTerminalById(E);_&&this._onDidExecuteCommand.fire({terminal:_.value,...b})}async $acceptTerminalMaximumDimensions(E,b,_){this._terminalProcesses.get(E)?.resize(b,_)}async $acceptTerminalTitleChange(E,b){const _=this._getTerminalById(E);_&&(_.name=b)}async $acceptTerminalClosed(E,b,_){const T=this._getTerminalObjectIndexById(this._terminals,E);if(T!==null){const U=this._terminals.splice(T,1)[0];U.setExitStatus(b,_),this._onDidCloseTerminal.fire(U.value)}}$acceptTerminalOpened(E,b,_,T){if(b){const P=this._getTerminalObjectIndexById(this._terminals,b);if(P!==null){this._terminals[P]._id=E,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const U={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:k.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},M=new n(this._proxy,E,U,_);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(E,b){this._getTerminalById(E)?._setProcessId(b)}async $startExtensionTerminal(E,b){const _=this._getTerminalById(E);if(!_)return{message:(0,S.localize)(0,null,E)};_.isOpen||await new Promise(U=>{const M=this.onDidOpenTerminal(async P=>{P===_.value&&(M.dispose(),U())})});const T=this._terminalProcesses.get(E);T?T.startSendingEvents(b):this._extensionTerminalAwaitingStart[E]={initialDimensions:b}}_setupExtHostProcessListeners(E,b){const _=new v.DisposableStore;_.add(b.onProcessReady(U=>this._proxy.$sendProcessReady(E,U.pid,U.cwd,U.windowsPty))),_.add(b.onDidChangeProperty(U=>this._proxy.$sendProcessProperty(E,U))),this._bufferer.startBuffering(E,b.onProcessData),_.add(b.onProcessExit(U=>this._onProcessExit(E,U))),this._terminalProcesses.set(E,b);const T=this._extensionTerminalAwaitingStart[E];return T&&b instanceof o&&(b.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[E]),_}$acceptProcessAckDataEvent(E,b){this._terminalProcesses.get(E)?.acknowledgeDataEvent(b)}$acceptProcessInput(E,b){this._terminalProcesses.get(E)?.input(b)}$acceptTerminalInteraction(E){const b=this._getTerminalById(E);b?.setInteractedWith()&&this._onDidChangeTerminalState.fire(b.value)}$acceptTerminalSelection(E,b){this._getTerminalById(E)?.setSelection(b)}$acceptProcessResize(E,b,_){try{this._terminalProcesses.get(E)?.resize(b,_)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(E,b){this._terminalProcesses.get(E)?.shutdown(b)}$acceptProcessRequestInitialCwd(E){this._terminalProcesses.get(E)?.getInitialCwd().then(b=>this._proxy.$sendProcessProperty(E,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd(E){this._terminalProcesses.get(E)?.getCwd().then(b=>this._proxy.$sendProcessProperty(E,{type:"cwd",value:b}))}$acceptProcessRequestLatency(E){return Promise.resolve(E)}registerLinkProvider(E){return this._linkProviders.add(E),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new p.Disposable(()=>{this._linkProviders.delete(E),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(E,b,_){if(this._profileProviders.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this._profileProviders.set(b,_),this._proxy.$registerProfileProvider(b,E.identifier.value),new p.Disposable(()=>{this._profileProviders.delete(b),this._proxy.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(E,b,_){if(this._quickFixProviders.has(E))throw new Error(`Terminal quick fix provider "${E}" is already registered`);return this._quickFixProviders.set(E,_),this._proxy.$registerQuickFixProvider(E,b),new p.Disposable(()=>{this._quickFixProviders.delete(E),this._proxy.$unregisterQuickFixProvider(E)})}async $provideTerminalQuickFixes(E,b){const _=new g.CancellationTokenSource().token;if(_.isCancellationRequested)return;const T=this._quickFixProviders.get(E);if(!T)return;const U=await T.provideTerminalQuickFixes(b,_);if(U===null||Array.isArray(U)&&U.length===0)return;const M=new v.DisposableStore;if(this._lastQuickFixCommands.value=M,!Array.isArray(U))return U?s.TerminalQuickFix.from(U,this._extHostCommands.converter,M):void 0;const P=[];for(const x of U){const F=s.TerminalQuickFix.from(x,this._extHostCommands.converter,M);F&&P.push(F)}return P}async $createContributedProfileTerminal(E,b){const _=new g.CancellationTokenSource().token;let T=await this._profileProviders.get(E)?.provideTerminalProfile(_);if(!_.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${E}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,b);return}this.createTerminalFromOptions(T.options,b)}}async $provideLinks(E,b){const _=this._getTerminalById(E);if(!_)return[];this._terminalLinkCache.delete(E),this._terminalLinkCancellationSource.get(E)?.dispose(!0);const U=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(E,U);const M=[],P={terminal:_.value,line:b},x=[];for(const W of this._linkProviders)x.push(f.Promises.withAsyncBody(async J=>{U.token.onCancellationRequested(()=>J({provider:W,links:[]}));const ce=await W.provideTerminalLinks(P,U.token)||[];U.token.isCancellationRequested||J({provider:W,links:ce})}));const F=await Promise.all(x);if(U.token.isCancellationRequested)return[];const O=new Map;for(const W of F)W&&W.links.length>0&&M.push(...W.links.map(J=>{const ce={id:a++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return O.set(ce.id,{provider:W.provider,link:J}),ce}));return this._terminalLinkCache.set(E,O),M}$activateLink(E,b){const _=this._terminalLinkCache.get(E)?.get(b);_&&_.provider.handleTerminalLink(_.link)}_onProcessExit(E,b){this._bufferer.stopBuffering(E),this._terminalProcesses.delete(E),delete this._extensionTerminalAwaitingStart[E];const _=this._terminalProcessDisposables[E];_&&(_.dispose(),delete this._terminalProcessDisposables[E]),this._proxy.$sendProcessExit(E,b)}_getTerminalById(E){return this._getTerminalObjectById(this._terminals,E)}_getTerminalObjectById(E,b){const _=this._getTerminalObjectIndexById(E,b);return _!==null?E[_]:null}_getTerminalObjectIndexById(E,b){const _=E.findIndex(T=>T._id===b);return _===-1?null:_}getEnvironmentVariableCollection(E){let b=this._environmentVariableCollections.get(E.identifier.value);return b||(b=new r,this._setEnvironmentVariableCollection(E.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(E,b){const _=(0,I.serializeEnvironmentVariableCollection)(b.map),T=(0,I.serializeEnvironmentDescriptionMap)(b.descriptionMap);this._proxy.$setEnvironmentVariableCollection(E,b.persistent,_.length===0?void 0:_,T)}$initEnvironmentVariableCollections(E){E.forEach(b=>{const _=b[0],T=new r(b[1]);this._setEnvironmentVariableCollection(_,T)})}$acceptDefaultProfile(E,b){const _=this._defaultProfile;this._defaultProfile=E,this._defaultAutomationProfile=b,_?.path!==E.path&&this._onDidChangeShell.fire(E.path)}_setEnvironmentVariableCollection(E,b){this._environmentVariableCollections.set(E,b),b.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(E,b)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=Ge([We(1,i.IExtHostCommands),We(2,R.IExtHostRpcService)],t);class r{get persistent(){return this._persistent}set persistent(E){this._persistent=E,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new D.Emitter,this.map=new Map(E)}getScopedEnvironmentVariableCollection(E){const b=this.getScopeKey(E);let _=this.scopedCollections.get(b);return _||(_=new h(this,E),this.scopedCollections.set(b,_),_.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),_}replace(E,b,_,T){this._setIfDiffers(E,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:_??{applyAtProcessCreation:!0},scope:T})}append(E,b,_,T){this._setIfDiffers(E,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:_??{applyAtProcessCreation:!0},scope:T})}prepend(E,b,_,T){this._setIfDiffers(E,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:_??{applyAtProcessCreation:!0},scope:T})}_setIfDiffers(E,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const _=this.getKey(E,b.scope),T=this.map.get(_),U=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==b.value||T.type!==b.type||T.options?.applyAtProcessCreation!==U.applyAtProcessCreation||T.options?.applyAtShellIntegration!==U.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const M=this.getKey(E,b.scope),P={variable:E,...b,options:U};this.map.set(M,P),this._onDidChangeCollection.fire()}}get(E,b){const _=this.getKey(E,b),T=this.map.get(_);return T?y(T):void 0}getKey(E,b){const _=this.getScopeKey(b);return _.length?`${E}:::${_}`:E}getScopeKey(E){return this.getWorkspaceKey(E?.workspaceFolder)??""}getWorkspaceKey(E){return E?E.uri.toString():void 0}getVariableMap(E){const b=new Map;for(const[_,T]of this.map)this.getScopeKey(T.scope)===this.getScopeKey(E)&&b.set(T.variable,y(T));return b}delete(E,b){const _=this.getKey(E,b);this.map.delete(_),this._onDidChangeCollection.fire()}clear(E){if(E?.workspaceFolder){for(const[b,_]of this.map)_.scope?.workspaceFolder?.index===E.workspaceFolder.index&&this.map.delete(b);this.clearDescription(E)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(E,b){const _=this.getScopeKey(b),T=this.descriptionMap.get(_);if(!T||T.description!==E){let U;typeof E=="string"?U=E:U=E?.value.split(`

`)[0];const M={description:U,scope:b};this.descriptionMap.set(_,M),this._onDidChangeCollection.fire()}}getDescription(E){const b=this.getScopeKey(E);return this.descriptionMap.get(b)?.description}clearDescription(E){const b=this.getScopeKey(E);this.descriptionMap.delete(b)}}class h{get persistent(){return this.collection.persistent}set persistent(E){this.collection.persistent=E}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E,b){this.collection=E,this.scope=b,this._onDidChangeCollection=new D.Emitter}getScoped(E){return this.collection.getScopedEnvironmentVariableCollection(E)}replace(E,b,_){this.collection.replace(E,b,_,this.scope)}append(E,b,_){this.collection.append(E,b,_,this.scope)}prepend(E,b,_){this.collection.prepend(E,b,_,this.scope)}get(E){return this.collection.get(E,this.scope)}forEach(E,b){this.collection.getVariableMap(this.scope).forEach((_,T)=>E.call(b,T,_,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(E){this.collection.delete(E,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(E){this.collection.setDescription(E,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let u=class extends t{constructor(E,b){super(!1,E,b)}createTerminal(E,b,_){throw new L.NotSupportedError}createTerminalFromOptions(E,b){throw new L.NotSupportedError}};e.WorkerExtHostTerminalService=u,e.WorkerExtHostTerminalService=u=Ge([We(0,i.IExtHostCommands),We(1,R.IExtHostRpcService)],u);function c(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function d(A){return l.ThemeColor.isThemeColor(A)?A:void 0}function y(A){const E={...A};return delete E.scope,E.options=E.options??void 0,delete E.variable,E}}),define(ye[339],Ce([1,0,12,22,21,4,74,53,3,24,18,30,6,20,147,15,7,67,112,89,25]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class extends p.Disposable{constructor(M,P,x){super(),this.editors=x,this.resultsChangedEmitter=this._register(new k.Emitter),this.controllers=new Map,this.activeProfilesChangedEmitter=this._register(new k.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(g.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new u(this.proxy),P.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 16:{const O=F,W=O.tests[O.tests.length-1].item.extId;return this.controllers.get(s.TestId.root(W))?.collection.tree.get(W)?.actual??(0,C.toItemFromContext)(F)}case 18:{const{extId:O,message:W}=F;return{test:this.controllers.get(s.TestId.root(O))?.collection.tree.get(O)?.actual,message:l.TestMessage.to(W)}}default:return F}}}),P.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await P.executeCommand("_testing.getExplorerSelection"),O=W=>{const J=this.controllers.get(s.TestId.root(W));if(J)return s.TestId.isRoot(W)?J.controller:J.collection.tree.get(W)?.actual};return{include:F?.include.map(O).filter(L.isDefined)||[],exclude:F?.exclude.map(O).filter(L.isDefined)||[]}})}createTestController(M,P,x,F){if(this.controllers.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const O=new p.DisposableStore,W=O.add(new C.ExtHostTestItemCollection(P,x,this.editors));W.root.label=x;const J=new Map,ce=new Set,G=this.proxy,X={items:W.root.children,get label(){return x},set label(se){x=se,W.root.label=se,G.$updateController(P,{label:x})},get refreshHandler(){return F},set refreshHandler(se){F=se,G.$updateController(P,{canRefresh:!!se})},get id(){return P},createRunProfile:(se,Q,we,he,j,z)=>{let ne=(0,v.hash)(se);for(;J.has(ne);)ne++;return new _(this.proxy,J,M,ce,this.activeProfilesChangedEmitter.event,P,ne,se,Q,we,he,j,z)},createTestItem(se,Q,we){return new C.TestItemImpl(P,se,Q,we)},createTestRun:(se,Q,we=!0)=>this.runTracker.createTestRun(M,P,W,se,Q,we),invalidateTestResults:se=>{if(se===void 0)this.proxy.$markTestRetired(void 0);else{const Q=se instanceof Array?se:[se];this.proxy.$markTestRetired(Q.map(we=>s.TestId.fromExtHostTestItem(we,P).toString()))}},set resolveHandler(se){W.resolveHandler=se},get resolveHandler(){return W.resolveHandler},dispose:()=>{O.dispose()}};G.$registerTestController(P,x,!!F),O.add((0,p.toDisposable)(()=>G.$unregisterTestController(P)));const Y={controller:X,collection:W,profiles:J,extension:M,activeProfiles:ce};return this.controllers.set(P,Y),O.add((0,p.toDisposable)(()=>this.controllers.delete(P))),O.add(W.onDidGenerateDiff(se=>G.$publishDiff(P,se.map(n.TestsDiffOp.serialize)))),X}createTestObserver(){return this.observer.checkout()}async runTests(M,P=m.CancellationToken.None){const x=c(M);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(O=>s.TestId.fromExtHostTestItem(O,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:T[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:M.exclude?.map(O=>O.id)},P)}$syncTests(){for(const{collection:M}of this.controllers.values())M.flushDiff();return Promise.resolve()}async $provideFileCoverage(M,P,x){return await this.runTracker.getCoverageReport(M,P)?.provideFileCoverage(x)??[]}async $resolveFileCoverage(M,P,x,F){return await this.runTracker.getCoverageReport(M,P)?.resolveFileCoverage(x,F)??[]}$configureRunProfile(M,P){this.controllers.get(M)?.profiles.get(P)?.configureHandler?.()}$setActiveRunProfiles(M){const P=new Map;for(const[x,F]of Object.entries(M)){const O=this.controllers.get(x);if(!O)continue;const W=new Map,J=F.filter(G=>!O.activeProfiles.has(G)),ce=[...O.activeProfiles].filter(G=>!F.includes(G));for(const G of J)W.set(G,!0),O.activeProfiles.add(G);for(const G of ce)W.set(G,!1),O.activeProfiles.delete(G);W.size&&P.set(x,W)}this.activeProfilesChangedEmitter.fire(P)}async $refreshTests(M,P){await this.controllers.get(M)?.controller.refreshHandler?.(P)}$publishTestResults(M){this.results=Object.freeze(M.map(P=>(0,S.deepFreeze)(l.TestResults.to(P))).concat(this.results).sort((P,x)=>x.completedAt-P.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,P){const x=this.controllers.get(s.TestId.fromString(M).controllerId)?.collection;x&&(await x.expand(M,P<0?1/0:P),x.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(n.TestsDiffOp.deserialize))}async $runControllerTests(M,P){return Promise.all(M.map(x=>this.runControllerTestRequest(x,!1,P)))}async $startContinuousRun(M,P){const x=new m.CancellationTokenSource(P),F=await Promise.all(M.map(O=>this.runControllerTestRequest(O,!0,x.token)));return!P.isCancellationRequested&&!F.some(O=>O.error)&&await new Promise(O=>P.onCancellationRequested(O)),x.dispose(!0),F}async runControllerTestRequest(M,P,x){const F=this.controllers.get(M.controllerId);if(!F)return{};const{collection:O,profiles:W,extension:J}=F,ce=W.get(M.profileId);if(!ce)return{};const G=M.testIds.map(Q=>O.tree.get(Q)).filter(L.isDefined),X=M.excludeExtIds.map(Q=>F.collection.tree.get(Q)).filter(L.isDefined).filter(Q=>G.some(we=>we.fullId.compare(Q.fullId)===2));if(!G.length)return{};const Y=new f.TestRunRequest(G.some(Q=>Q.actual instanceof C.TestItemRootImpl)?void 0:G.map(Q=>Q.actual),X.map(Q=>Q.actual),ce,P),se=(0,n.isStartControllerTests)(M)&&this.runTracker.prepareForMainThreadTestRun(Y,d.fromInternal(M,F.collection),J,x);try{return await ce.runHandler(Y,x),{}}catch(Q){return{error:String(Q)}}finally{se&&(se.hasRunningTasks&&!x.isCancellationRequested&&await k.Event.toPromise(se.onEnd),se.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};e.ExtHostTesting=a,e.ExtHostTesting=a=Ge([We(0,w.IExtHostRpcService)],a);const t=1e4;var r;(function(U){U[U.Running=0]="Running",U[U.Cancelling=1]="Cancelling",U[U.Ended=2]="Ended"})(r||(r={}));class h extends p.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor(M,P,x,F){super(),this.dto=M,this.proxy=P,this.extension=x,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.coverageEmitter=this._register(new k.Emitter),this.onDidCoverage=this.coverageEmitter.event,this.onEnd=this.endEmitter.event,this.cts=this._register(new m.CancellationTokenSource(F));const O=this._register(new D.RunOnceScheduler(()=>this.forciblyEndTasks(),t));this._register(this.cts.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}createRun(M){const P=this.dto.id,x=this.dto.controllerId,F=(0,I.generateUuid)(),O=this.extension,W=this.coverageEmitter;let J;const ce=se=>(Q,...we)=>{if(X){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(Q)&&(this.ensureTestIsKnown(Q),se(Q,...we))},G=(se,Q)=>{const we=Q instanceof Array?Q.map(l.TestMessage.from):[l.TestMessage.from(Q)];if(se.uri&&se.range){const he={range:l.Range.from(se.range),uri:se.uri};for(const j of we)j.location=j.location||he}this.proxy.$appendTestMessagesInRun(P,F,s.TestId.fromExtHostTestItem(se,x).toString(),we)};let X=!1;const Y={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return J?.provider},set coverageProvider(se){(0,o.checkProposedApiEnabled)(O,"testCoverage"),J=se&&new y(se),W.fire({taskId:F,runId:P,coverage:J})},enqueued:ce(se=>{this.proxy.$updateTestStateInRun(P,F,s.TestId.fromExtHostTestItem(se,x).toString(),1)}),skipped:ce(se=>{this.proxy.$updateTestStateInRun(P,F,s.TestId.fromExtHostTestItem(se,x).toString(),5)}),started:ce(se=>{this.proxy.$updateTestStateInRun(P,F,s.TestId.fromExtHostTestItem(se,x).toString(),2)}),errored:ce((se,Q,we)=>{G(se,Q),this.proxy.$updateTestStateInRun(P,F,s.TestId.fromExtHostTestItem(se,x).toString(),6,we)}),failed:ce((se,Q,we)=>{G(se,Q),this.proxy.$updateTestStateInRun(P,F,s.TestId.fromExtHostTestItem(se,x).toString(),4,we)}),passed:ce((se,Q)=>{this.proxy.$updateTestStateInRun(P,F,s.TestId.fromExtHostTestItem(se,this.dto.controllerId).toString(),3,Q)}),appendOutput:(se,Q,we)=>{X||(we&&(this.dto.isIncluded(we)?this.ensureTestIsKnown(we):we=void 0),this.proxy.$appendOutputToRun(P,F,N.VSBuffer.fromString(se),Q&&l.location.from(Q),we&&s.TestId.fromExtHostTestItem(we,x).toString()))},end:()=>{X||(X=!0,this.proxy.$finishedTestRunTask(P,F),this.tasks.delete(F),this.tasks.size||this.markEnded())}};return this.tasks.set(F,{run:Y}),this.proxy.$startedTestRunTask(P,{id:F,name:M,running:!0}),Y}forciblyEndTasks(){for(const{run:M}of this.tasks.values())M.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(M){if(!(M instanceof C.TestItemImpl))throw new i.InvalidTestItemError(M.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const P=[],x=this.dto.colllection.root;for(;;){const F=l.TestItem.from(M);if(P.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),M===x))break;M=M.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,P)}dispose(){this.markEnded(),super.dispose()}}class u{get trackers(){return this.tracked.values()}constructor(M){this.proxy=M,this.tracked=new Map,this.coverageReports=[]}getCoverageReport(M,P){return this.coverageReports.find(x=>x.runId===M)?.coverage.get(P)}prepareForMainThreadTestRun(M,P,x,F){return this.getTracker(M,P,x,F)}cancelRunById(M){for(const P of this.tracked.values())if(P.id===M){P.cancel();return}}cancelAllRuns(){for(const M of this.tracked.values())M.cancel()}createTestRun(M,P,x,F,O,W){const J=this.tracked.get(F);if(J)return J.createRun(O);const ce=d.fromPublic(P,x,F,W),G=c(F);this.proxy.$startedExtensionTestRun({controllerId:P,continuous:!!F.continuous,profile:G&&{group:T[G.kind],id:G.profileId},exclude:F.exclude?.map(Y=>s.TestId.fromExtHostTestItem(Y,x.root.id).toString())??[],id:ce.id,include:F.include?.map(Y=>s.TestId.fromExtHostTestItem(Y,x.root.id).toString())??[x.root.id],persist:W});const X=this.getTracker(F,ce,M);return k.Event.once(X.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(ce.id),X.dispose()}),X.createRun(O)}getTracker(M,P,x,F){const O=new h(P,this.proxy,x,F);this.tracked.set(M,O);let W;const J=O.onDidCoverage(({runId:ce,taskId:G,coverage:X})=>{W||(W={runId:ce,coverage:new Map},this.coverageReports.unshift(W),this.coverageReports.length>n.KEEP_N_LAST_COVERAGE_REPORTS&&this.coverageReports.pop()),W.coverage.set(G,X),this.proxy.$signalCoverageAvailable(ce,G,!!X)});return k.Event.once(O.onEnd)(()=>{this.tracked.delete(M),J.dispose()}),O}}e.TestRunCoordinator=u;const c=U=>{if(U.profile){if(!(U.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class d{static fromPublic(M,P,x,F){return new d(M,(0,I.generateUuid)(),x.include?.map(O=>s.TestId.fromExtHostTestItem(O,M).toString())??[M],x.exclude?.map(O=>s.TestId.fromExtHostTestItem(O,M).toString())??[],F,P)}static fromInternal(M,P){return new d(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,P)}constructor(M,P,x,F,O,W){this.controllerId=M,this.id=P,this.isPersisted=O,this.colllection=W,this.includePrefix=x.map(J=>J+"\0"),this.excludePrefix=F.map(J=>J+"\0")}isIncluded(M){const P=s.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(P===x||P.startsWith(x))return!1;for(const x of this.includePrefix)if(P===x||P.startsWith(x))return!0;return!1}}e.TestRunDto=d;class y{constructor(M){this.provider=M}async provideFileCoverage(M){this.fileCoverage||(this.fileCoverage=(async()=>this.provider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(P){throw this.fileCoverage=void 0,P}}async resolveFileCoverage(M,P){const x=await this.fileCoverage;let F=x?.[M];return!this.provider||!x||!F?[]:(F.detailedCoverage||(F=x[M]=await this.provider.resolveFileCoverage?.(F,P)??F),F.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class A{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(M){this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(M){this.added.add(M)}update(M){Object.assign(M.revived,l.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}this.updated.delete(M);const P=s.TestId.parentId(M.item.extId);if(P&&this.alreadyRemoved.has(P.toString())){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:P,removed:x}=this;return{get added(){return[...M].map(F=>F.revived)},get updated(){return[...P].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class E extends n.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,P){return{...M,revived:l.TestItem.toPlain(M.item),depth:P?P.depth+1:0,children:new Set}}createChangeCollector(){return new A(this.changeEmitter)}}class b{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(P=>P.revived)},dispose:(0,R.createSingleCallFunction)(()=>{--M.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new E;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class _{#e;#t;#i;#o;#r;get label(){return this._label}set label(M){M!==this._label&&(this._label=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(M){M!==this._supportsContinuousRun&&(this._supportsContinuousRun=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?l.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,o.checkProposedApiEnabled)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,o.checkProposedApiEnabled)(this.#t,"testingActiveProfile"),k.Event.chain(this.#o,M=>M.map(P=>P.get(this.controllerId)?.get(this.profileId)).filter(L.isDefined))}constructor(M,P,x,F,O,W,J,ce,G,X,Y=!1,se=void 0,Q=!1){this.controllerId=W,this.profileId=J,this._label=ce,this.kind=G,this.runHandler=X,this._isDefault=Y,this._tag=se,this._supportsContinuousRun=Q,this.#e=M,this.#r=P,this.#t=x,this.#i=F,this.#o=O,P.set(J,this);const we=T[G];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);this.#e.$publishTestRunProfile({profileId:J,controllerId:W,tag:se?l.TestTag.namespace(this.controllerId,se.id):null,label:ce,group:we,isDefault:Y,hasConfigurationHandler:!1,supportsContinuousRun:Q})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_;const T={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ye[340],Ce([1,0,19,8,4,6,148,15,7]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(I,g){this._extHostDocumentsAndEditors=g,this._onDidChangeTextEditorSelection=new m.Emitter({onListenerError:N.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new m.Emitter({onListenerError:N.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new m.Emitter({onListenerError:N.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new m.Emitter({onListenerError:N.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new m.Emitter({onListenerError:N.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new m.Emitter({onListenerError:N.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=I.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(w=>this._onDidChangeVisibleTextEditors.fire(w)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(w=>this._onDidChangeActiveTextEditor.fire(w))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(I){const g=this._extHostDocumentsAndEditors.allEditors();return I?g:g.map(w=>w.value)}async showTextDocument(I,g,w){let C;typeof g=="number"?C={position:v.ViewColumn.from(g),preserveFocus:w}:typeof g=="object"?C={position:v.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?v.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:C={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(I.uri,C),f=l&&this._extHostDocumentsAndEditors.getEditor(l);if(f)return f.value;throw l?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,g){return new R.TextEditorDecorationType(this._proxy,I,g).value}$acceptEditorPropertiesChanged(I,g){const w=this._extHostDocumentsAndEditors.getEditor(I);if(!w)throw new Error("unknown text editor");if(g.options&&w._acceptOptions(g.options),g.selections){const C=g.selections.selections.map(v.Selection.to);w._acceptSelections(C)}if(g.visibleRanges){const C=D.coalesce(g.visibleRanges.map(v.Range.to));w._acceptVisibleRanges(C)}if(g.options&&this._onDidChangeTextEditorOptions.fire({textEditor:w.value,options:{...g.options,lineNumbers:v.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const C=p.TextEditorSelectionChangeKind.fromValue(g.selections.source),l=g.selections.selections.map(v.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:w.value,selections:l,kind:C})}if(g.visibleRanges){const C=D.coalesce(g.visibleRanges.map(v.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:w.value,visibleRanges:C})}}$acceptEditorPositionData(I){for(const g in I){const w=this._extHostDocumentsAndEditors.getEditor(g);if(!w)throw new Error("Unknown text editor");const C=v.ViewColumn.to(I[g]);w.value.viewColumn!==C&&(w._acceptViewColumn(C),this._onDidChangeTextEditorViewColumn.fire({textEditor:w.value,viewColumn:C}))}}getDiffInformation(I){return Promise.resolve(this._proxy.$getDiffInformation(I))}}e.ExtHostEditors=S}),define(ye[341],Ce([1,0,2,5,6,3,7,15,26,18]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,N.createDecorator)("IExtHostTimeline");class L{constructor(w,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=w.getProxy(m.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(l,f)=>{if(l&&l.$mid===12)if(this._providers.get(l.source)&&p.ExtensionIdentifier.equals(f,this._providers.get(l.source)?.extension)){const s=l.uri===void 0?void 0:D.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(I(s))?.get(l.handle)}else return;return l}})}async $getTimeline(w,C,l,f){return this._providers.get(w)?.provider.provideTimeline(D.URI.revive(C),l,f)}registerTimelineProvider(w,C,l,f){const s=new k.DisposableStore,i=this.convertTimelineItem(C.id,f,s).bind(this);let n;C.onDidChange&&(n=C.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:C.id}),this));const o=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...C,scheme:w,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(C.id)?.clear());const h=await C.provideTimeline(a,t,r);if(h==null)return;const u=i(a,t);return{...h,source:C.id,items:h.items.map(u)}},dispose(){for(const a of o.values())a.get(C.id)?.clear();n?.dispose(),s.dispose()}},l)}convertTimelineItem(w,C,l){return(f,s)=>{let i;if(s?.cacheResults){let n=this._itemsBySourceAndUriMap.get(w);n===void 0&&(n=new Map,this._itemsBySourceAndUriMap.set(w,n));const o=I(f);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${w}|${n.id??n.timestamp}`;i?.set(t,n);let r,h,u;n.iconPath&&(o instanceof R.ThemeIcon?u={id:o.id,color:o.color}:D.URI.isUri(o)?(r=o,h=o):{light:r,dark:h}=o);let c;return R.MarkdownString.isMarkdownString(a.tooltip)?c=v.MarkdownString.from(a.tooltip):(0,S.isString)(a.tooltip)?c=a.tooltip:R.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=v.MarkdownString.from(a.detail)):(0,S.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:w,command:n.command?C.toInternal(n.command,l):void 0,icon:r,iconDark:h,themeIcon:u,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}registerTimelineProviderCore(w,C){if(this._providers.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this._proxy.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this._providers.set(w.id,{provider:w,extension:C}),(0,k.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(w.id)?.clear();this._providers.delete(w.id),this._proxy.$unregisterTimelineProvider(w.id),w.dispose()})}}e.ExtHostTimeline=L;function I(g){return g?.toString()}}),define(ye[72],Ce([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class w extends p.DisposableTunnel{}var C;(function(f){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}f.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}f.fromServiceTunnel=i})(C||(e.TunnelDtoConverter=C={})),e.IExtHostTunnelService=(0,R.createDecorator)("IExtHostTunnelService");let l=class extends m.Disposable{constructor(s,i,n){super(),this.logService=n,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new N.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=s.getProxy(S.MainContext.MainThreadTunnelService)}async openTunnel(s,i){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this._proxy.$openTunnel(i,s.displayName);if(n){const o=new w(n.remoteAddress,n.localAddress,()=>this._proxy.$closeTunnel(n.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(s,i){const n=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(n,{selector:s,provider:i}),this._proxy.$registerPortsAttributesProvider(s,n),new g.Disposable(()=>{this._portAttributesProviders.delete(n),this._proxy.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const h of s){const u=this._portAttributesProviders.get(h);if(!u)return[];t.push(...await Promise.all(i.map(async c=>{let d;try{d=await u.provider.providePortAttributes({port:c,pid:n,commandLine:o},a)}catch{d=await u.provider.providePortAttributes(c,n,o,a)}return{providedAttributes:d,port:c}})))}const r=t.filter(h=>!!h.providedAttributes);return r.length>0?r.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(o,a)=>await s.provideTunnel(o,a,new D.CancellationTokenSource().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(n),Promise.resolve((0,m.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this._showCandidatePort=s.showCandidatePort,this._proxy.$setCandidateFilter());const n=s.tunnelFactory??(i?this.makeManagedTunnelFactory(i):void 0);if(n){this._forwardPortProvider=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this._proxy.$setTunnelProvider(a)}}else this._forwardPortProvider=void 0;return(0,m.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(s){}async $closeTunnel(s,i){if(this._extensionTunnels.has(s.host)){const n=this._extensionTunnels.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(s,i){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this._forwardPortProvider(s,i);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(s.remoteAddress.host)||this._extensionTunnels.set(s.remoteAddress.host,new Map);const a=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),C.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.ExtHostTunnelService=l,e.ExtHostTunnelService=l=Ge([We(0,I.IExtHostRpcService),We(1,L.IExtHostInitDataService),We(2,v.ILogService)],l)}),define(ye[342],Ce([1,0,3,17,2,6]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{static{this.supportedSchemes=new Set([N.Schemas.http,N.Schemas.https])}constructor(p){this._openers=new Map,this._proxy=p.getProxy(k.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(p,S,L,I){if(this._openers.has(S))throw new Error(`Opener with id '${S}' already registered`);const g=I.schemes.find(w=>!R.supportedSchemes.has(w));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(S,L),this._proxy.$registerUriOpener(S,I.schemes,p,I.label),(0,D.toDisposable)(()=>{this._openers.delete(S),this._proxy.$unregisterUriOpener(S)})}async $canOpenUri(p,S,L){const I=this._openers.get(p);if(!I)throw new Error(`Unknown opener with id: ${p}`);const g=m.URI.revive(S);return I.canOpenExternalUri(g,L)}async $openUri(p,S,L){const I=this._openers.get(p);if(!I)throw new Error(`Unknown opener id: '${p}'`);return I.openExternalUri(m.URI.revive(S.resolvedUri),{sourceUri:m.URI.revive(S.sourceUri)},L)}}e.ExtHostUriOpeners=R}),define(ye[343],Ce([1,0,6,2,3,8,26]),function(ge,e,D,N,m,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class v{static{this.HandlePool=0}constructor(S){this.handles=new R.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=S.getProxy(D.MainContext.MainThreadUrls)}registerUriHandler(S,L){const I=S.identifier;if(this.handles.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const g=v.HandlePool++;return this.handles.add(I),this.handlers.set(g,L),this._proxy.$registerUriHandler(g,I,S.displayName||S.name),(0,m.toDisposable)(()=>{this.handles.delete(I),this.handlers.delete(g),this._proxy.$unregisterUriHandler(g)})}$handleExternalUri(S,L){const I=this.handlers.get(S);if(!I)return Promise.resolve(void 0);try{I.handleUri(N.URI.revive(L))}catch(g){(0,k.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(S){return N.URI.revive(await this._proxy.$createAppUri(S))}}e.ExtHostUrls=v}),define(ye[93],Ce([1,0,4,3,17,24,2,238,275,113,6]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class I{#e;#t;#i;#o;#r;#n;#a;#s;#c;#l;#u;#h;constructor(o,a,t,r,h,u,c){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new D.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new D.Emitter,this._onDidDispose=this.#d.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=h,this.#n=u,this.#u=g(u),this.#h=w(u),this.#i=c}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,S.asWebviewUri)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===m.Schemas.https||o.scheme===m.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(o){this.assertNotDisposed(),this.#a!==o&&(this.#a=o,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(o)))}get options(){return this.assertNotDisposed(),this.#s}set options(o){this.assertNotDisposed(),k.equals(this.#s,o)||this.#t.$setOptions(this.#e,f(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,p.serializeWebviewMessage)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(o){if(!this.#h)return o;const a=this.#n.extensionLocation?.scheme===m.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===m.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,d,y)=>{const A=R.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),E=(0,S.asWebviewUri)(A,{isRemote:a,authority:t}).toString();return`${h}${E}${y}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,d,y)=>{const A=R.URI.from({scheme:c||"file",path:decodeURIComponent(d)}),E=(0,S.asWebviewUri)(A,{isRemote:a,authority:t}).toString();return`${h}${E}${y}`})}}e.ExtHostWebview=I;function g(n){try{const o=(0,v.normalizeVersion)((0,v.parseVersion)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=g;function w(n){try{const o=(0,v.normalizeVersion)((0,v.parseVersion)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class C extends N.Disposable{constructor(o,a,t,r,h){super(),this.remoteInfo=a,this.workspace=t,this._logService=r,this._deprecationService=h,this._webviews=new Map,this._webviewProxy=o.getProxy(L.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const o of this._webviews.values())o.dispose();this._webviews.clear()}$onMessage(o,a,t){const r=this.getWebview(o);if(r){const{message:h}=(0,p.deserializeWebviewMessage)(a,t.value);r._onMessageEmitter.fire(h)}}$onMissingCsp(o,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new I(o,this._webviewProxy,s(a),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(o,r);const h=r._onDidDispose(()=>{h.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=C;function l(n){return{id:n.identifier,location:n.extensionLocation}}e.toExtensionData=l;function f(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.serializeWebviewOptions=f;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ye[344],Ce([1,0,21,53,3,17,23,2,15,93,110,6,7]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(r,h){this.document=r,this._storagePath=h,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,h){await this.getEdit(r).undo(),h||this.disposeBackup()}async redo(r,h){await this.getEdit(r).redo(),h||this.disposeBackup()}disposeEdits(r){for(const h of r)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const h=this._edits.get(r,0);if(!h)throw new Error("No edit found");return h}}class C{constructor(){this._documents=new Map}get(r,h){return this._documents.get(this.key(r,h))}add(r,h,u){const c=this.key(r,h.uri);if(this._documents.has(c))throw new Error(`Document already exists for viewType:${r} resource:${h.uri}`);const d=new w(h,u);return this._documents.set(c,d),d}delete(r,h){const u=this.key(r,h.uri);this._documents.delete(u)}key(r,h){return`${r}@@@${h}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class f{constructor(){this._providers=new Map}addTextProvider(r,h,u){return this.add(0,r,h,u)}addCustomProvider(r,h,u){return this.add(1,r,h,u)}get(r){return this._providers.get(r)}add(r,h,u,c){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:r,extension:u,provider:c}),new g.Disposable(()=>this._providers.delete(h))}}class s{constructor(r,h,u,c,d){this._extHostDocuments=h,this._extensionStoragePaths=u,this._extHostWebview=c,this._extHostWebviewPanels=d,this._editorProviders=new f,this._documents=new C,this._proxy=r.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,h,u,c){const d=new m.DisposableStore;return n(u)?(d.add(this._editorProviders.addTextProvider(h,r,u)),this._proxy.$registerTextEditorProvider((0,S.toExtensionData)(r),h,c.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,S.shouldSerializeBuffersForPostMessage)(r))):(d.add(this._editorProviders.addCustomProvider(h,r,u)),i(u)&&d.add(u.onDidChangeCustomDocument(y=>{const A=this.getCustomDocumentEntry(h,y.document.uri);if(o(y)){const E=A.addEdit(y);this._proxy.$onDidEdit(y.document.uri,h,E,y.label)}else this._proxy.$onContentChange(y.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,S.toExtensionData)(r),h,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,S.shouldSerializeBuffersForPostMessage)(r))),g.Disposable.from(d,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(r,h,u,c,d){const y=this._editorProviders.get(h);if(!y)throw new Error(`No provider found for '${h}'`);if(y.type!==1)throw new Error(`Invalid provide type for '${h}'`);const A=v.URI.revive(r),E=await y.provider.openCustomDocument(A,{backupId:u,untitledDocumentData:c?.buffer},d);let b;return i(y.provider)&&this._extensionStoragePaths&&(b=this._extensionStoragePaths.workspaceValue(y.extension)??this._extensionStoragePaths.globalValue(y.extension)),this._documents.add(h,E,b),{editable:i(y.provider)}}async $disposeCustomDocument(r,h){const u=this._editorProviders.get(h);if(!u)throw new Error(`No provider found for '${h}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${h}'`);const c=v.URI.revive(r),{document:d}=this.getCustomDocumentEntry(h,c);this._documents.delete(h,d),d.dispose()}async $resolveCustomEditor(r,h,u,c,d,y){const A=this._editorProviders.get(u);if(!A)throw new Error(`No provider found for '${u}'`);const E=p.ViewColumn.to(d),b=this._extHostWebview.createNewWebview(h,c.contentOptions,A.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(h,u,c.title,E,c.options,b,c.active),T=v.URI.revive(r);switch(A.type){case 1:{const{document:U}=this.getCustomDocumentEntry(u,T);return A.provider.resolveCustomEditor(U,_,y)}case 0:{const U=this._extHostDocuments.getDocument(T);return A.provider.resolveCustomTextEditor(U,_,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,h,u){this.getCustomDocumentEntry(h,r).disposeEdits(u)}async $onMoveCustomEditor(r,h,u){const c=this._editorProviders.get(u);if(!c)throw new Error(`No provider found for '${u}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const d=this._extHostWebviewPanels.getWebviewPanel(r);if(!d)throw new Error("No webview found");const y=v.URI.revive(h),A=this._extHostDocuments.getDocument(y);await c.provider.moveCustomTextEditor(A,d,D.CancellationToken.None)}async $undo(r,h,u,c){return this.getCustomDocumentEntry(h,r).undo(u,c)}async $redo(r,h,u,c){return this.getCustomDocumentEntry(h,r).redo(u,c)}async $revert(r,h,u){const c=this.getCustomDocumentEntry(h,r);await this.getCustomEditorProvider(h).revertCustomDocument(c.document,u),c.disposeBackup()}async $onSave(r,h,u){const c=this.getCustomDocumentEntry(h,r);await this.getCustomEditorProvider(h).saveCustomDocument(c.document,u),c.disposeBackup()}async $onSaveAs(r,h,u,c){const d=this.getCustomDocumentEntry(h,r);return this.getCustomEditorProvider(h).saveCustomDocumentAs(d.document,v.URI.revive(u),c)}async $backup(r,h,u){const c=this.getCustomDocumentEntry(h,r),y=await this.getCustomEditorProvider(h).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},u);return c.updateBackup(y),y.id}getCustomDocumentEntry(r,h){const u=this._documents.get(r,v.URI.revive(h));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(r){const u=this._editorProviders.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===k.Schemas.file||t.scheme===k.Schemas.untitled?t.fsPath:t.toString();return(0,N.hash)(r)+""}}),define(ye[345],Ce([1,0,4,3,2,30,15,93,6,7]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class L extends N.Disposable{#e;#t;#i;#o;#r;#n;#a;#s;#c;#l;#u;#h;#d;constructor(C,l,f,s){super(),this.#s=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new D.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new D.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=C,this.#t=l,this.#o=f,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#l=s.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#o}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(C){this.assertNotDisposed(),this.#n!==C&&(this.#n=C,this.#t.$setTitle(this.#e,C))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(C){this.assertNotDisposed(),this.#a!==C&&(this.#a=C,this.#t.$setIconPath(this.#e,m.URI.isUri(C)?{light:C,dark:C}:C))}get options(){return this.#r}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(C){this.#u||(this.active!==C.active||this.visible!==C.visible||this.viewColumn!==C.viewColumn)&&(this.#l=C.active,this.#c=C.visible,this.#s=C.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(C,l){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof C>"u"?void 0:R.ViewColumn.from(C),preserveFocus:!!l})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class I extends N.Disposable{static newHandle(){return(0,k.generateUuid)()}constructor(C,l,f){super(),this.webviews=l,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=C.getProxy(p.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(C=>C.dispose()),this._webviewPanels.clear()}createWebviewPanel(C,l,f,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,v.shouldSerializeBuffersForPostMessage)(C),t=I.newHandle();this._proxy.$createWebviewPanel((0,v.toExtensionData)(C),t,l,{title:f,panelOptions:g(i),webviewOptions:(0,v.serializeWebviewOptions)(C,this.workspace,i),serializeBuffersForPostMessage:a},o);const r=this.webviews.createNewWebview(t,i,C);return this.createNewWebviewPanel(t,l,f,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(C){const l=Object.keys(C);l.sort((f,s)=>{const i=C[f],n=C[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const f of l){const s=this.getWebviewPanel(f);if(!s)continue;const i=C[f];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(C){this.getWebviewPanel(C)?.dispose(),this._webviewPanels.delete(C),this.webviews.deleteWebview(C)}registerWebviewPanelSerializer(C,l,f){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:f,extension:C}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,v.shouldSerializeBuffersForPostMessage)(C)}),new S.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(C,l,f,s){const i=this._serializers.get(l);if(!i)throw new Error(`No serializer found for '${l}'`);const{serializer:n,extension:o}=i,a=this.webviews.createNewWebview(C,f.webviewOptions,o),t=this.createNewWebviewPanel(C,l,f.title,s,f.panelOptions,a,f.active);await n.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(C,l,f,s,i,n,o){const a=new L(C,this._proxy,n,{viewType:l,title:f,viewColumn:s,panelOptions:i,active:o});return this._webviewPanels.set(C,a),a}getWebviewPanel(C){return this._webviewPanels.get(C)}}e.ExtHostWebviewPanels=I;function g(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(ye[346],Ce([1,0,4,3,93,15,6,7]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends N.Disposable{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(I,g,w,C,l,f){super(),this.#r=!1,this.#l=this._register(new D.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new D.Emitter),this.onDidDispose=this.#u.event,this.#i=w,this.#a=C,this.#e=I,this.#t=g,this.#o=l,this.#n=f}dispose(){this.#r||(this.#r=!0,this.#u.fire(),this.#o.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(I){this.assertNotDisposed(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.assertNotDisposed(),this.#s}set description(I){this.assertNotDisposed(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#r||(this.#n=I,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(I){this.assertNotDisposed(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=k.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.assertNotDisposed(),this.#t.$show(this.#e,!!I)}assertNotDisposed(){if(this.#r)throw new Error("Webview is disposed")}}class S{constructor(I,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=I.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(I,g,w,C){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:w,extension:I}),this._proxy.$registerWebviewViewProvider((0,m.toExtensionData)(I),g,{retainContextWhenHidden:C?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,m.shouldSerializeBuffersForPostMessage)(I)}),new v.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(I,g,w,C,l){const f=this._viewProviders.get(g);if(!f)throw new Error(`No view provider found for '${g}'`);const{provider:s,extension:i}=f,n=this._extHostWebview.createNewWebview(I,{},i),o=new p(I,this._proxy,g,w,n,!0);this._webviewViews.set(I,o),await s.resolveWebviewView(o,{state:C},l)}async $onDidChangeWebviewViewVisibility(I,g){this.getWebviewView(I)._setVisible(g)}async $disposeWebviewView(I){const g=this.getWebviewView(I);this._webviewViews.delete(I),g.dispose(),this._extHostWebview.deleteWebview(I)}getWebviewView(I){const g=this._webviewViews.get(I);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=S}),define(ye[151],Ce([1,0,4,6,2,17,13,5,20,25]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{L=this}static{this.InitialState={focused:!0,active:!0}}getState(w){const C=this._state;return{get focused(){return C.focused},get active(){return(0,S.checkProposedApiEnabled)(w,"windowActivity"),C.active}}}constructor(w){this._onDidChangeWindowState=new D.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=L.InitialState,this._proxy=w.getProxy(N.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:C,isActive:l})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,C){C!==this._state[w]&&(this._state={...this._state,[w]:C},this._onDidChangeWindowState.fire(this._state))}openUri(w,C){let l;if(typeof w=="string"){l=w;try{w=m.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,l,C)}async asExternalUri(w,C){if((0,R.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this._proxy.$asExternalUri(w,C);return m.URI.from(l)}};e.ExtHostWindow=I,e.ExtHostWindow=I=L=Ge([We(0,p.IExtHostRpcService)],I),e.IExtHostWindow=(0,v.createDecorator)("IExtHostWindow")}),define(ye[347],Ce([1,0,315,27,20]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const k=1024*1024;let R=class extends D.AbstractExtHostConsoleForwarder{constructor(p,S){super(p,S),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(p,S,L){const I=p==="error"||p==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),S.apply(console,L),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(p,S){const L=process[p],I=L.write;let g="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(w,C,l)=>{if(!this._isMakingConsoleCall){g+=w.toString(C);const f=g.length>k?g.length:g.lastIndexOf(`
`);f!==-1&&(console[S](g.slice(0,f)),g=g.slice(f+1))}I.call(L,w,C,l)}})}};e.ExtHostConsoleForwarder=R,e.ExtHostConsoleForwarder=R=Ge([We(0,m.IExtHostRpcService),We(1,N.IExtHostInitDataService)],R)}),define(ye[348],Ce([1,0,71,17,14,250,32,11]),function(ge,e,D,N,m,k,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let p=class{constructor(I,g){I.addFileSystemProvider(N.Schemas.file,new S(g),{isCaseSensitive:v.isLinux})}};e.ExtHostDiskFileSystemProvider=p,e.ExtHostDiskFileSystemProvider=p=Ge([We(0,D.IExtHostConsumerFileSystem),We(1,m.ILogService)],p);class S{constructor(I){this.logService=I,this.impl=new k.DiskFileSystemProvider(this.logService)}async stat(I){const g=await this.impl.stat(I);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.impl.readdir(I)}createDirectory(I){return this.impl.mkdir(I)}readFile(I){return this.impl.readFile(I)}writeFile(I,g,w){return this.impl.writeFile(I,g,{...w,unlock:!1,atomic:!1})}delete(I,g){return this.impl.delete(I,{...g,useTrash:!1,atomic:!1})}rename(I,g,w){return this.impl.rename(I,g,w)}copy(I,g,w){return this.impl.copy(I,g,w)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,g){throw new Error("Method not implemented.")}}}),define(ye[349],Ce([1,0,16,63,30,35,3,6,2,20]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends R.Disposable{constructor(g,w){super();const C=g.getProxy(v.MainContext.MainThreadDownloadService);w.registerCommand(!1,"_workbench.downloadResource",async l=>{const f=p.URI.file((0,D.join)((0,N.tmpdir)(),(0,m.generateUuid)()));return await C.$download(l,f),f})}};e.ExtHostDownloadService=L,e.ExtHostDownloadService=L=Ge([We(0,S.IExtHostRpcService),We(1,k.IExtHostCommands)],L)}),define(ye[350],Ce([1,0,150,17,252,30]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class R extends D.ExtHostLoggerService{doCreateLogger(p,S,L){return p.scheme===N.Schemas.file?new m.SpdLogLogger(L?.name||(0,k.generateUuid)(),p.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,S):super.doCreateLogger(p,S,L)}registerLogger(p){super.registerLogger(p),this._proxy.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this._proxy.$deregisterLogger(p)}}e.ExtHostLoggerService=R}),define(ye[351],Ce([1,0,55,16,2,92,3,17,12,31]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends k.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const r=await super._getWorkspaceStorageURI(t);if(r.scheme!==v.Schemas.file)return r;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const h=r.fsPath;let u=0;do{let c;u===0?c=h:c=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${u}`:`${h}-${u}`,await I(c);const d=N.join(c,"vscode.lock"),y=await l(this._logService,d,!1);if(y)return this._workspaceStorageLock=y,process.on("exit",()=>{y.dispose()}),m.URI.file(c);u++}while(u<10);return r}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function I(a){try{await S.Promises.stat(a);return}catch{}try{await S.Promises.mkdir(a,{recursive:!0})}catch{}}const g=1e3,w=10*60*1e3;class C extends R.Disposable{constructor(t,r){super(),this.logService=t,this.filename=r,this._timer=this._register(new p.IntervalTimer),this._timer.cancelAndSet(async()=>{const h=await f(t,r);(!h||h.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this._timer.cancel());try{await S.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},g)}dispose(){super.dispose();try{D.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.filename,JSON.stringify(r),{flag:"w"})}catch(r){this.logService.error(r)}}}async function l(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const h=await f(a,t);return!h||h.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new C(a,t))}async function f(a,t){let r;try{r=await S.Promises.readFile(t)}catch(h){return a.error(h),null}try{return JSON.parse(String(r))}catch(h){return a.error(h),null}}async function s(a,t){let r;try{r=await S.Promises.stat(t)}catch(h){return a.error(h),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await f(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let y=r.willReleaseAt-Date.now();if(y<5e3){for(y>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${y} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);y>0;){if(await(0,p.timeout)(Math.min(100,y)),await s(a,t)===0)return o(a,t);y=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const h=await s(a,t),u=Date.now()-h;if(u<=w)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.timeout)(2e3);const c=await s(a,t),d=Date.now()-c;return d<=w?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return l(a,t,!0)}}),define(ye[352],Ce([1,0,30,20,47,35]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends m.BaseExtHostTerminalService{constructor(p,S){super(!0,p,S)}createTerminal(p,S,L){return this.createTerminalFromOptions({name:p,shellPath:S,shellArgs:L})}createTerminalFromOptions(p,S){const L=new m.ExtHostTerminal(this._proxy,(0,D.generateUuid)(),p,p.name);return this._terminals.push(L),L.create(p,this._serializeParentTerminal(p,S)),L.value}};e.ExtHostTerminalService=R,e.ExtHostTerminalService=R=Ge([We(0,k.IExtHostCommands),We(1,N.IExtHostRpcService)],R)}),define(ye[353],Ce([1,0,12,22,21,8,4,3,130,304,68]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(_,T){try{return JSON.stringify(_,T)}catch{return"null"}}const w="$$ref$$",C={[w]:-1};class l{constructor(T,U){this.jsonString=T,this.referencedBuffers=U}}function f(_,T=null,U=!1){const M=[];return{jsonString:(U?g:JSON.stringify)(_,(x,F)=>{if(typeof F>"u")return C;if(typeof F=="object"){if(F instanceof N.VSBuffer){const O=M.push(F)-1;return{[w]:O}}if(T)return T(x,F)}return F}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=f;function s(_,T,U){return JSON.parse(_,(M,P)=>{if(P){const x=P[w];if(typeof x=="number")return T[x];if(U&&P.$mid===1)return U.transformIncoming(P)}return P})}e.parseJsonAndRestoreBufferRefs=s;function i(_,T){return JSON.stringify(_,T)}function n(_){return _?(T,U)=>U&&U.$mid===1?_.transformOutgoing(U):U:null}var o;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class u extends v.Disposable{static{I=r}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(T,U=null,M=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=U,this._uriTransformer=M,this._uriReplacer=n(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,x=L.ProxyIdentifier.count;P<x;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new D.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{const U=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],U.resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,p.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:U,sid:M}=T;return this._proxies[U]||(this._proxies[U]=this._createProxy(U,M)),this._proxies[U]}_createProxy(T,U){const M={get:(P,x)=>(typeof x=="string"&&!P[x]&&x.charCodeAt(0)===36&&(P[x]=(...F)=>this._remoteCall(T,x,F)),x===h?U:P[x])};return new Proxy(Object.create(null),M)}set(T,U){return this._locals[T.nid]=U,U}assertRegistered(T){for(let U=0,M=T.length;U<M;U++){const P=T[U];if(!this._locals[P.nid])throw new Error(`Missing proxy instance ${P.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const U=T.byteLength,M=d.read(T,0),P=M.readUInt8(),x=M.readUInt32();switch(P){case 1:case 2:{let{rpcId:F,method:O,args:W}=A.deserializeRequestJSONArgs(M);this._uriTransformer&&(W=(0,p.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(U,x,F,O,W,P===2);break}case 3:case 4:{let{rpcId:F,method:O,args:W}=A.deserializeRequestMixedArgs(M);this._uriTransformer&&(W=(0,p.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(U,x,F,O,W,P===4);break}case 5:{this._logger?.logIncoming(U,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(U,x);break}case 7:{this._receiveReply(U,x,void 0);break}case 9:{let F=A.deserializeReplyOKJSON(M);this._uriTransformer&&(F=(0,p.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReply(U,x,F);break}case 10:{const F=A.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(U,x,F);break}case 8:{const F=A.deserializeReplyOKVSBuffer(M);this._receiveReply(U,x,F);break}case 11:{let F=A.deserializeReplyErrError(M);this._uriTransformer&&(F=(0,p.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReplyErr(U,x,F);break}case 12:{this._receiveReplyErr(U,x,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,U,M,P,x,F){this._logger?.logIncoming(T,U,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(M)}.${P}(`,x);const O=String(U);let W,J;if(F){const G=new m.CancellationTokenSource;x.push(G.token),W=this._invokeHandler(M,P,x),J=()=>G.cancel()}else W=this._invokeHandler(M,P,x),J=t;this._cancelInvokedHandlers[O]=J;const ce=A.serializeAcknowledged(U);this._logger?.logOutgoing(ce.byteLength,U,1,"ack"),this._protocol.send(ce),W.then(G=>{delete this._cancelInvokedHandlers[O];const X=A.serializeReplyOK(U,G,this._uriReplacer);this._logger?.logOutgoing(X.byteLength,U,1,"reply:",G),this._protocol.send(X)},G=>{delete this._cancelInvokedHandlers[O];const X=A.serializeReplyErr(U,G);this._logger?.logOutgoing(X.byteLength,U,1,"replyErr:",G),this._protocol.send(X)})}_receiveCancel(T,U){this._logger?.logIncoming(T,U,1,"receiveCancel");const M=String(U);this._cancelInvokedHandlers[M]?.()}_receiveReply(T,U,M){this._logger?.logIncoming(T,U,0,"receiveReply:",M);const P=String(U);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const x=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],x.resolveOk(M)}_receiveReplyErr(T,U,M){this._logger?.logIncoming(T,U,0,"receiveReplyErr:",M);const P=String(U);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const x=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let F;M&&(M.$isError?(F=new Error,F.name=M.name,F.message=M.message,F.stack=M.stack):F=M),x.resolveErr(F)}_invokeHandler(T,U,M){try{return Promise.resolve(this._doInvokeHandler(T,U,M))}catch(P){return Promise.reject(P)}}_doInvokeHandler(T,U,M){const P=this._locals[T];if(!P)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(T));const x=P[U];if(typeof x!="function")throw new Error("Unknown method "+U+" on actor "+(0,L.getStringIdentifierForProxy)(T));return x.apply(P,M)}_remoteCall(T,U,M){if(this._isDisposed)return new S.CanceledLazyPromise;let P=null;if(M.length>0&&m.CancellationToken.isCancellationToken(M[M.length-1])&&(P=M.pop()),P&&P.isCancellationRequested)return Promise.reject(k.canceled());const x=A.serializeRequestArguments(M,this._uriReplacer),F=++this._lastMessageId,O=String(F),W=new S.LazyPromise,J=new v.DisposableStore;P&&J.add(P.onCancellationRequested(()=>{const G=A.serializeCancel(F);this._logger?.logOutgoing(G.byteLength,F,0,"cancel"),this._protocol.send(A.serializeCancel(F))})),this._pendingRPCReplies[O]=new c(W,J),this._onWillSendRequest(F);const ce=A.serializeRequest(F,T,U,x,!!P);return this._logger?.logOutgoing(ce.byteLength,F,0,`request: ${(0,L.getStringIdentifierForProxy)(T)}.${U}(`,M),this._protocol.send(ce),W}}e.RPCProtocol=u;class c{constructor(T,U){this._promise=T,this._disposable=U}resolveOk(T){this._promise.resolveOk(T),this._disposable.dispose()}resolveErr(T){this._promise.resolveErr(T),this._disposable.dispose()}}class d{static alloc(T,U,M){const P=new d(N.VSBuffer.alloc(M+1+4),0);return P.writeUInt8(T),P.writeUInt32(U),P}static read(T,U){return new d(T,U)}get buffer(){return this._buff}constructor(T,U){this._buff=T,this._offset=U}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,M}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,M}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,U}static sizeMixedArray(T){let U=0;U+=1;for(let M=0,P=T.length;M<P;M++){const x=T[M];switch(U+=1,x.type){case 1:U+=this.sizeLongString(x.value);break;case 2:U+=this.sizeVSBuffer(x.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(x.value);for(let F=0;F<x.buffers.length;++F)U+=this.sizeVSBuffer(x.buffers[F]);break;case 4:break}}return U}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let U=0,M=T.length;U<M;U++){const P=T[U];switch(P.type){case 1:this.writeUInt8(1),this.writeLongString(P.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(P.value);break;case 3:this.writeUInt8(3),this.writeUInt32(P.buffers.length),this.writeLongString(P.value);for(let x=0;x<P.buffers.length;++x)this.writeBuffer(P.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const U=new Array(T);for(let M=0;M<T;M++)switch(this.readUInt8()){case 1:U[M]=this.readLongString();break;case 2:U[M]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),F=this.readLongString(),O=[];for(let W=0;W<x;++W)O.push(this.readVSBuffer());U[M]=new L.SerializableObjectWithBuffers(s(F,O,null));break}case 4:U[M]=void 0;break}return U}}var y;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(y||(y={}));class A{static _useMixedArgSerialization(T){for(let U=0,M=T.length;U<M;U++)if(T[U]instanceof N.VSBuffer||T[U]instanceof L.SerializableObjectWithBuffers||typeof T[U]>"u")return!0;return!1}static serializeRequestArguments(T,U){if(this._useMixedArgSerialization(T)){const M=[];for(let P=0,x=T.length;P<x;P++){const F=T[P];if(F instanceof N.VSBuffer)M[P]={type:2,value:F};else if(typeof F>"u")M[P]={type:4};else if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:W}=f(F.value,U);M[P]={type:3,value:N.VSBuffer.fromString(O),buffers:W}}else M[P]={type:1,value:N.VSBuffer.fromString(i(F,U))}}return{type:1,args:M}}return{type:0,args:i(T,U)}}static serializeRequest(T,U,M,P,x){switch(P.type){case 0:return this._requestJSONArgs(T,U,M,P.args,x);case 1:return this._requestMixedArgs(T,U,M,P.args,x)}}static _requestJSONArgs(T,U,M,P,x){const F=N.VSBuffer.fromString(M),O=N.VSBuffer.fromString(P);let W=0;W+=d.sizeUInt8(),W+=d.sizeShortString(F),W+=d.sizeLongString(O);const J=d.alloc(x?2:1,T,W);return J.writeUInt8(U),J.writeShortString(F),J.writeLongString(O),J.buffer}static deserializeRequestJSONArgs(T){const U=T.readUInt8(),M=T.readShortString(),P=T.readLongString();return{rpcId:U,method:M,args:JSON.parse(P)}}static _requestMixedArgs(T,U,M,P,x){const F=N.VSBuffer.fromString(M);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(F),O+=d.sizeMixedArray(P);const W=d.alloc(x?4:3,T,O);return W.writeUInt8(U),W.writeShortString(F),W.writeMixedArray(P),W.buffer}static deserializeRequestMixedArgs(T){const U=T.readUInt8(),M=T.readShortString(),P=T.readMixedArray(),x=new Array(P.length);for(let F=0,O=P.length;F<O;F++){const W=P[F];typeof W=="string"?x[F]=JSON.parse(W):x[F]=W}return{rpcId:U,method:M,args:x}}static serializeAcknowledged(T){return d.alloc(5,T,0).buffer}static serializeCancel(T){return d.alloc(6,T,0).buffer}static serializeReplyOK(T,U,M){if(typeof U>"u")return this._serializeReplyOKEmpty(T);if(U instanceof N.VSBuffer)return this._serializeReplyOKVSBuffer(T,U);if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:P,referencedBuffers:x}=f(U.value,M,!0);return this._serializeReplyOKJSONWithBuffers(T,P,x)}else return this._serializeReplyOKJSON(T,g(U,M))}static _serializeReplyOKEmpty(T){return d.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,U){let M=0;M+=d.sizeVSBuffer(U);const P=d.alloc(8,T,M);return P.writeVSBuffer(U),P.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,U){const M=N.VSBuffer.fromString(U);let P=0;P+=d.sizeLongString(M);const x=d.alloc(9,T,P);return x.writeLongString(M),x.buffer}static _serializeReplyOKJSONWithBuffers(T,U,M){const P=N.VSBuffer.fromString(U);let x=0;x+=d.sizeUInt32,x+=d.sizeLongString(P);for(const O of M)x+=d.sizeVSBuffer(O);const F=d.alloc(10,T,x);F.writeUInt32(M.length),F.writeLongString(P);for(const O of M)F.writeBuffer(O);return F.buffer}static deserializeReplyOKJSON(T){const U=T.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(T,U){const M=T.readUInt32(),P=T.readLongString(),x=[];for(let F=0;F<M;++F)x.push(T.readVSBuffer());return new L.SerializableObjectWithBuffers(s(P,x,U))}static serializeReplyErr(T,U){const M=U?g(k.transformErrorForSerialization(U),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(T);const P=N.VSBuffer.fromString(M);let x=0;x+=d.sizeLongString(P);const F=d.alloc(11,T,x);return F.writeLongString(P),F.buffer}static deserializeReplyErrError(T){const U=T.readLongString();return JSON.parse(U)}static _serializeReplyErrEmpty(T){return d.alloc(12,T,0).buffer}}var E;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var b;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(b||(b={}))}),define(ye[354],Ce([1,0,4,37,46,5]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new m.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new m.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new m.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,k.createDecorator)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class v{constructor(){this.channels=new Map,this._onDidRegisterChannel=new D.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new D.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(S){this.channels.has(S.id)||(this.channels.set(S.id,S),this._onDidRegisterChannel.fire(S.id))}getChannels(){const S=[];return this.channels.forEach(L=>S.push(L)),S}getChannel(S){return this.channels.get(S)}removeChannel(S){this.channels.delete(S),this._onDidRemoveChannel.fire(S)}}N.Registry.add(e.Extensions.OutputChannels,new v),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new m.RawContextKey("activeOutputChannel","")}),define(ye[152],Ce([1,0,6,5,20,26,14,354,71,27,57,182,22,18,32,4,3]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class s extends R.AbstractMessageLogger{get disposed(){return this._disposed}constructor(a,t,r,h,u){super(),this.id=a,this.name=t,this.logger=r,this.proxy=h,this.extension=u,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(r.getLevel()),this._register(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.offset;this.logger.flush(),this.proxy.$update(this.id,v.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.offset;this.info(a),this.proxy.$update(this.id,v.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(a,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.proxy.$close(this.id)}log(a,t){this.offset+=g.VSBuffer.fromString(t).byteLength,(0,R.log)(this.logger,a,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,v.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,h,u,c){this.initData=t,this.extHostFileSystem=r,this.extHostFileSystemInfo=h,this.loggerService=u,this.logService=c,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=a.getProxy(D.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.visibleChannelId=a;for(const[t,r]of this.channels)r.visible=t===this.visibleChannelId}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,u=(0,w.isString)(t)?t:void 0;if((0,w.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const d=this.initData.environment.extensionLogLevel?.find(([A])=>k.ExtensionIdentifier.equals(r.identifier,A))?.[1];d&&(c=(0,R.parseLogLevel)(d));const y=h?this.doCreateLogOutputChannel(a,c,r):this.doCreateOutputChannel(a,u,r);return y.then(A=>{this.channels.set(A.id,A),A.visible=A.id===this.visibleChannelId}),h?this.createExtHostLogOutputChannel(a,c??this.logService.getLevel(),y):this.createExtHostOutputChannel(a,y)}async doCreateOutputChannel(a,t,r){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const h=await this.outputDirectoryPromise,u=this.extHostFileSystemInfo.extUri.joinPath(h,`${this.namePool++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.proxy.$register(a,u,t,r.identifier.value);return new s(d,a,c,this.proxy,r)}async doCreateLogOutputChannel(a,t,r){const h=await this.createExtensionLogDirectory(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.extHostFileSystemInfo.extUri.joinPath(h,`${u}.log`),d=`${r.identifier.value}.${u}`,y=this.loggerService.createLogger(c,{id:d,name:a,logLevel:t,extensionId:r.identifier.value});return new i(d,a,y,this.proxy,r)}createExtensionLogDirectory(a){let t=this.extensionLogDirectoryPromise.get(a.identifier.value);if(!t){const r=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,a.identifier.value);this.extensionLogDirectoryPromise.set(a.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(r)}catch(h){if((0,C.toFileSystemProviderErrorCode)(h)!==C.FileSystemProviderErrorCode.FileExists)throw h}return r})())}return t}createExtHostOutputChannel(a,t){let r=!1;const h=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){h(),t.then(c=>c.append(u))},appendLine(u){h(),t.then(c=>c.appendLine(u))},clear(){h(),t.then(u=>u.clear())},replace(u){h(),t.then(c=>c.replace(u))},show(u,c){h(),t.then(d=>d.show(u,c))},hide(){h(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}createExtHostLogOutputChannel(a,t,r){const h=new f.DisposableStore,u=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},c=h.add(new l.Emitter);function d(y){t=y,c.fire(y)}return r.then(y=>{h.add(y),y.logLevel!==t&&d(y.logLevel),h.add(y.onDidChangeLogLevel(A=>d(A)))}),{...this.createExtHostOutputChannel(a,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(y,...A){u(),r.then(E=>E.trace(y,...A))},debug(y,...A){u(),r.then(E=>E.debug(y,...A))},info(y,...A){u(),r.then(E=>E.info(y,...A))},warn(y,...A){u(),r.then(E=>E.warn(y,...A))},error(y,...A){u(),r.then(E=>E.error(y,...A))},dispose(){h.dispose()}}}};e.ExtHostOutputService=n,e.ExtHostOutputService=n=Ge([We(0,m.IExtHostRpcService),We(1,S.IExtHostInitDataService),We(2,p.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,R.ILoggerService),We(5,R.ILogService)],n),e.IExtHostOutputService=(0,N.createDecorator)("IExtHostOutputService")}),define(ye[153],Ce([1,0,5,12]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,D.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(m){let k=1/0;for(let v=0;v<this.maxSampleCount;v++){const p=await m.getRoundTripTime();if(p===void 0)return;k=Math.min(k,p/2),await(0,N.timeout)(this.sampleDelay)}this.average.push(k),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(k):R=this.initial.reduce((v,p)=>v+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:k,average:this.average.reduce((v,p)=>v+p,0)/this.average.length,high:(()=>typeof R>"u"?!1:k>this.highLatencyMaxThreshold||k>this.highLatencyMinThreshold&&k>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ye[355],Ce([1,0,224,86,37,40,45,3,4,153,11,24]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchConfigurationWorkbenchContribution=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class g{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new p.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const w=new g;m.Registry.add(e.Extensions.ConfigurationMigration,w);let C=class extends v.Disposable{constructor(s,i){super(),this.configurationService=s,this.workspaceService=i,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.migrateConfigurationsForFolder(o,w.migrations)})),this.migrateConfigurations(w.migrations),this._register(w.onDidRegisterConfigurationMigration(n=>this.migrateConfigurations(n)))}async migrateConfigurations(s){await this.migrateConfigurationsForFolder(void 0,s);for(const i of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(i,s)}async migrateConfigurationsForFolder(s,i){await Promise.all([i.map(n=>this.migrateConfigurationsForFolderAndOverride(n,s?.uri))])}async migrateConfigurationsForFolderAndOverride(s,i){const n=this.configurationService.inspect(s.key,{resource:i}),o=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[a,t]of o){const r=[];for(const u of n.overrideIdentifiers??[]){const c=await this.runMigration(s,{resource:i,overrideIdentifier:u},a);for(const d of c??[]){let y=r.find(([[A,E]])=>A===d[0]&&(0,I.equals)(E.value,d[1].value));y||r.push(y=[d,[]]),y[1].push(u)}}const h=await this.runMigration(s,{resource:i},a,n);for(const u of h??[])r.push([u,[]]);r.length&&await Promise.allSettled(r.map(async([[u,c],d])=>this.configurationService.updateValue(u,c.value,{resource:i,overrideIdentifiers:d},t)))}}async runMigration(s,i,n,o){const a=u=>t(this.configurationService.inspect(u,i)),t=u=>{const c=u[n];return i.overrideIdentifier?c?.override:c?.value},r=o?t(o):a(s.key);if(r===void 0)return;const h=await s.migrateFn(r,a);return Array.isArray(h)?h:[[s.key,h]]}};e.ConfigurationMigrationWorkbenchContribution=C,e.ConfigurationMigrationWorkbenchContribution=C=Ge([We(0,R.IConfigurationService),We(1,k.IWorkspaceContextService)],C);let l=class extends v.Disposable{constructor(s){super(),(async()=>{if(!L.isWindows&&(await s.getEnvironment())?.os!==1)return;m.Registry.as(N.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.DynamicWorkbenchConfigurationWorkbenchContribution=l,e.DynamicWorkbenchConfigurationWorkbenchContribution=l=Ge([We(0,S.IRemoteAgentService)],l)}),define(ye[356],Ce([1,0,34,17,16,23,233,355,86,5,37]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.globMatchesResource=e.priorityToRank=e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.IEditorResolverService=(0,S.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const I=L.Registry.as(p.Extensions.Configuration),g={...v.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(g);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var C;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(C||(e.ResolvedStatus=C={}));function l(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}e.priorityToRank=l;function f(s,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(m.posix.sep)>=0?`${i.scheme}:${i.path}`:(0,k.basename)(i);return D.match(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.globMatchesResource=f}),define(ye[357],Ce([1,0,33,17,16,11,23,2,5,268,40,144,153]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,p.createDecorator)("pathService");let C=w=class{constructor(f,s,i,n){this.localUserHome=f,this.remoteAgentService=s,this.environmentService=i,this.contextService=n,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const o=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=o?.userHome??f})()}hasValidBasename(f,s,i){return typeof s=="string"||typeof s>"u"?this.resolveOS.then(n=>this.doHasValidBasename(f,n,s)):this.doHasValidBasename(f,s,i)}doHasValidBasename(f,s,i){return f.scheme===N.Schemas.file||f.scheme===N.Schemas.vscodeRemote?(0,D.isValidBasename)(i??(0,R.basename)(f),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,s){if(f.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,S.getVirtualWorkspaceScheme)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:N.Schemas.file}userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?m.win32:m.posix)}async fileURI(f){let s="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const n=f.indexOf("/",2);n===-1?(s=f.substring(2),f="/"):(s=f.substring(2,n),f=f.substring(n)||"/")}return v.URI.from({scheme:N.Schemas.file,authority:s,path:f,query:"",fragment:""})}};e.AbstractPathService=C,e.AbstractPathService=C=w=Ge([We(1,g.IRemoteAgentService),We(2,I.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],C)}),define(ye[358],Ce([1,0,235,19,59,4,53,3,2,45,240,14,64,270,88,40,144,25,21,18,24,46]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.isCandidatePort=e.OnPortForward=e.makeAddress=e.mapHasAddressLocalhostOrAllInterfaces=e.mapHasAddress=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.parseAddress=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new a.RawContextKey("forwardedPortsViewEnabled",!1,D.localize(0,null));function h(U){const M=U.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}e.parseAddress=h;var u;(function(U){U.Other="Other",U.User="User",U.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var c;(function(U){U[U.User=0]="User",U[U.Auto=1]="Auto",U[U.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.UserTunnelSource={source:c.User,description:D.localize(1,null)},e.AutoTunnelSource={source:c.Auto,description:D.localize(2,null)};function d(U,M,P){const x=U.get(A(M,P));if(x)return x;if((0,C.isLocalhost)(M))for(const F of C.LOCALHOST_ADDRESSES){const O=A(F,P);if(U.has(O))return U.get(O)}else if((0,C.isAllInterfaces)(M))for(const F of C.ALL_INTERFACES_ADDRESSES){const O=A(F,P);if(U.has(O))return U.get(O)}}e.mapHasAddress=d;function y(U,M,P){const x=d(U,M,P);if(x)return x;const F=(0,C.isAllInterfaces)(M)?"localhost":(0,C.isLocalhost)(M)?"0.0.0.0":void 0;if(F)return d(U,F,P)}e.mapHasAddressLocalhostOrAllInterfaces=y;function A(U,M){return U+":"+M}e.makeAddress=A;var E;(function(U){U.Notify="notify",U.OpenBrowser="openBrowser",U.OpenBrowserOnce="openBrowserOnce",U.OpenPreview="openPreview",U.Silent="silent",U.Ignore="ignore"})(E||(e.OnPortForward=E={}));function b(U){return U&&"host"in U&&typeof U.host=="string"&&"port"in U&&typeof U.port=="number"&&(!("detail"in U)||typeof U.detail=="string")&&(!("pid"in U)||typeof U.pid=="string")}e.isCandidatePort=b;class _ extends v.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.configurationService=M,this.portsAttributes=[],this._onDidChangeAttributes=new k.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(M.onDidChangeConfiguration(P=>{(P.affectsConfiguration(_.SETTING)||P.affectsConfiguration(_.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(M,P,x){let F=this.findNextIndex(M,P,x,this.portsAttributes,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const W=this.portsAttributes[F];W.key===M?(O.onAutoForward=W.onAutoForward??O.onAutoForward,O.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:O.elevateIfNeeded,O.label=W.label??O.label,O.requireLocalPort=W.requireLocalPort,O.protocol=W.protocol):(O.onAutoForward=O.onAutoForward??W.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:W.elevateIfNeeded,O.label=O.label??W.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??W.protocol),F=this.findNextIndex(M,P,x,this.portsAttributes,F+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.getOtherAttributes()}hasStartEnd(M){return M.start!==void 0&&M.end!==void 0}hasHostAndPort(M){return M.host!==void 0&&M.port!==void 0&&(0,n.isString)(M.host)&&(0,n.isNumber)(M.port)}findNextIndex(M,P,x,F,O){if(O>=F.length)return-1;const W=!(0,C.isLocalhost)(P)&&!(0,C.isAllInterfaces)(P),ce=F.slice(O).findIndex(G=>(0,n.isNumber)(G.key)?W?!1:G.key===M:this.hasStartEnd(G.key)?W?!1:M>=G.key.start&&M<=G.key.end:this.hasHostAndPort(G.key)?M===G.key.port&&P===G.key.host:x?G.key.test(x):!1);return ce>=0?ce+O:-1}readSetting(){const M=this.configurationService.getValue(_.SETTING);if(!M||!(0,n.isObject)(M))return[];const P=[];for(const F in M){if(F===void 0)continue;const O=M[F];let W;if(Number(F))W=Number(F);else if((0,n.isString)(F))if(_.RANGE.test(F)){const J=F.match(_.RANGE);W={start:Number(J[1]),end:Number(J[2])}}else if(_.HOST_AND_PORT.test(F)){const J=F.match(_.HOST_AND_PORT);W={host:J[1],port:Number(J[2])}}else{let J;try{J=RegExp(F)}catch{}J&&(W=J)}W&&P.push({key:W,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const x=this.configurationService.getValue(_.DEFAULTS);return x&&(this.defaultPortAttributes={elevateIfNeeded:x.elevateIfNeeded,label:x.label,onAutoForward:x.onAutoForward,requireLocalPort:x.requireLocalPort,protocol:x.protocol}),this.sortAttributes(P)}sortAttributes(M){function P(x,F){return(0,n.isNumber)(x.key)?x.key:F.hasStartEnd(x.key)?x.key.start:F.hasHostAndPort(x.key)?x.key.port:Number.MAX_VALUE}return M.sort((x,F)=>P(x,this)-P(F,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(M){switch(M){case C.ProvidedOnAutoForward.Notify:return E.Notify;case C.ProvidedOnAutoForward.OpenBrowser:return E.OpenBrowser;case C.ProvidedOnAutoForward.OpenBrowserOnce:return E.OpenBrowserOnce;case C.ProvidedOnAutoForward.OpenPreview:return E.OpenPreview;case C.ProvidedOnAutoForward.Silent:return E.Silent;case C.ProvidedOnAutoForward.Ignore:return E.Ignore;default:return}}async addAttributes(M,P,x){const O=this.configurationService.inspect(_.SETTING).userRemoteValue;let W;!O||!(0,n.isObject)(O)?W={}:W=(0,o.deepClone)(O),W[`${M}`]||(W[`${M}`]={});for(const J in P)W[`${M}`][J]=P[J];return this.configurationService.updateValue(_.SETTING,W,x)}}e.PortsAttributes=_;let T=class extends v.Disposable{constructor(M,P,x,F,O,W,J,ce,G,X){super(),this.tunnelService=M,this.storageService=P,this.configurationService=x,this.environmentService=F,this.remoteAuthorityResolverService=O,this.workspaceContextService=W,this.logService=J,this.dialogService=ce,this.extensionService=G,this.contextKeyService=X,this.inProgress=new Map,this._onForwardPort=new k.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new k.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new k.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new k.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new k.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new k.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new _(x),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async Y=>{const se=await this.getAttributes(Y.map(Q=>({port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost})));for(const Q of Y)if(Q.localAddress){const we=A(Q.tunnelRemoteHost,Q.tunnelRemotePort),he=y(this._candidates??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort);this.forwarded.set(we,{remotePort:Q.tunnelRemotePort,remoteHost:Q.tunnelRemoteHost,localAddress:Q.localAddress,protocol:se?.get(Q.tunnelRemotePort)?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(Q.localAddress,se?.get(Q.tunnelRemotePort)),localPort:Q.tunnelLocalPort,runningProcess:he?.detail,hasRunningProcess:!!he,pid:he?.pid,privacy:Q.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(we,Q)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async Y=>{const se=A(Y.tunnelRemoteHost,Y.tunnelRemotePort);if(!y(this.forwarded,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&!y(this.detected,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&!y(this.inProgress,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&Y.localAddress){const Q=y(this._candidates??new Map,Y.tunnelRemoteHost,Y.tunnelRemotePort),we=(await this.getAttributes([{port:Y.tunnelRemotePort,host:Y.tunnelRemoteHost}]))?.get(Y.tunnelRemotePort);this.forwarded.set(se,{remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localAddress:Y.localAddress,protocol:we?.protocol??C.TunnelProtocol.Http,localUri:await this.makeLocalUri(Y.localAddress,we),localPort:Y.tunnelLocalPort,closeable:!0,runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,privacy:Y.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(se,Y),this._onForwardPort.fire(this.forwarded.get(se))})),this._register(this.tunnelService.onTunnelClosed(Y=>this.onTunnelClosed(Y,u.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(M=>M.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const M=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&M.dispose()}))}async onTunnelClosed(M,P){const x=A(M.host,M.port);this.forwarded.has(x)&&(this.forwarded.delete(x),await this.storeForwarded(),this._onClosePort.fire(M))}makeLocalUri(M,P){if(M.startsWith("http"))return p.URI.parse(M);const x=P?.protocol??"http";return p.URI.parse(`${x}://${M}`)}async getStorageKey(){const M=this.workspaceContextService.getWorkspace(),P=M.configuration?(0,R.hash)(M.configuration.path):M.folders.length>0?(0,R.hash)(M.folders[0].uri.path):void 0;if(P===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.environmentService.remoteAuthority}.${P}`}async getTunnelRestoreValue(){const M=this.storageService.get(r,1);if(M)return this.storageService.remove(r,1),await this.storeForwarded(),M;const P=await this.getStorageKey();if(P)return this.storageService.get(P,0)}async restoreForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const M=await this.tunnelRestoreValue;if(M&&M!==this.knownPortsRestoreValue){const P=JSON.parse(M)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${P.map(x=>x.remotePort).join(", ")}`);for(const x of P){const F=y(this.detected,x.remoteHost,x.remotePort);x.source.source!==c.Extension&&!F||x.source.source===c.Extension&&F?await this.doForward({remote:{host:x.remoteHost,port:x.remotePort},local:x.localPort,name:x.name,privacy:x.privacy,elevateIfNeeded:!0,source:x.source}):x.source.source===c.Extension&&!F&&this.unrestoredExtensionTunnels.set(A(x.remoteHost,x.remotePort),x)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const M=await this.getStorageKey();this.restoreListener=this._register(new v.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async P=>{P.key===M&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(M,0)),await this.restoreForwarded())}))}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const M=JSON.stringify(Array.from(this.forwarded.values()));if(M!==this.knownPortsRestoreValue){this.knownPortsRestoreValue=M;const P=await this.getStorageKey();P&&this.storageService.store(P,this.knownPortsRestoreValue,0,0)}}}async showPortMismatchModalIfNeeded(M,P,x){if(!M.tunnelLocalPort||!x?.requireLocalPort||M.tunnelLocalPort===P)return;const F=new Date;if(this.mismatchCooldown.getTime()+t>F.getTime())return;this.mismatchCooldown=F;const O=D.localize(3,null,P,M.tunnelRemotePort,M.tunnelLocalPort);return this.dialogService.info(O)}async forward(M,P){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await k.Event.toPromise(this.onRestoreComplete.event),this.doForward(M,P)}async doForward(M,P){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const x=y(this.forwarded,M.remote.host,M.remote.port);P=P??(P!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const F=M.local!==void 0?M.local:M.remote.port;let O;if(x)return this.mergeAttributesIntoExistingTunnel(x,M,P);{const W=this.environmentService.remoteAuthority,J=W?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(W)).authority}:void 0,ce=A(M.remote.host,M.remote.port);this.inProgress.set(ce,!0),M=this.mergeCachedAndUnrestoredProperties(ce,M);const G=await this.tunnelService.openTunnel(J,M.remote.host,M.remote.port,void 0,F,M.elevateIfNeeded?M.elevateIfNeeded:P?.elevateIfNeeded,M.privacy,P?.protocol);if(typeof G=="string")O=G;else if(G&&G.localAddress){const X=y(this._candidates??new Map,M.remote.host,M.remote.port),Y=G.protocol?G.protocol===C.TunnelProtocol.Https?C.TunnelProtocol.Https:C.TunnelProtocol.Http:P?.protocol??C.TunnelProtocol.Http,se={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:P?.label??M.name,closeable:!0,localAddress:G.localAddress,protocol:Y,localUri:await this.makeLocalUri(G.localAddress,P),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:M.source??e.UserTunnelSource,privacy:G.privacy};return this.forwarded.set(ce,se),this.remoteTunnels.set(ce,G),this.inProgress.delete(ce),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(G,F,P),this._onForwardPort.fire(se),G}this.inProgress.delete(ce)}return O}mergeCachedAndUnrestoredProperties(M,P){const x=this.unrestoredExtensionTunnels.has(M)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(M)?this.sessionCachedProperties:void 0;if(x){const F=x.get(M);x.delete(M),F&&(P.name=F.name??P.name,P.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??P.local,P.privacy=F.privacy??P.privacy)}return P}async mergeAttributesIntoExistingTunnel(M,P,x){const F=x?.label??P.name;let O;(function(J){J[J.None=0]="None",J[J.Fire=1]="Fire",J[J.Reopen=2]="Reopen"})(O||(O={}));let W=O.None;switch(F!==M.name&&(M.name=F,W=O.Fire),(x?.protocol||M.protocol!==C.TunnelProtocol.Http)&&x?.protocol!==M.protocol&&(P.source=M.source,W=O.Reopen),P.privacy&&M.privacy!==P.privacy&&(W=O.Reopen),W){case O.Fire:{this._onForwardPort.fire();break}case O.Reopen:await this.close(M.remoteHost,M.remotePort,u.User),await this.doForward(P,x)}return y(this.remoteTunnels,P.remote.host,P.remote.port)}async name(M,P,x){const F=y(this.forwarded,M,P),O=A(M,P);if(F){F.name=x,await this.storeForwarded(),this._onPortName.fire({host:M,port:P});return}else this.detected.has(O)&&(this.detected.get(O).name=x,this._onPortName.fire({host:M,port:P}))}async close(M,P,x){const F=A(M,P),O=this.forwarded.get(F);return x===u.AutoForwardEnd&&O&&O.source.source===c.Auto&&this.sessionCachedProperties.set(F,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.tunnelService.closeTunnel(M,P),this.onTunnelClosed({host:M,port:P},x)}address(M,P){const x=A(M,P);return(this.forwarded.get(x)||this.detected.get(x))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(M){if(M)for(const P of M){const x=y(this._candidates??new Map,P.remoteAddress.host,P.remoteAddress.port),F=typeof P.localAddress=="string"?P.localAddress:A(P.localAddress.host,P.localAddress.port);this.detected.set(A(P.remoteAddress.host,P.remoteAddress.port),{remoteHost:P.remoteAddress.host,remotePort:P.remoteAddress.port,localAddress:F,protocol:C.TunnelProtocol.Http,localUri:this.makeLocalUri(F),closeable:!1,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:C.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(P.remoteAddress.host,P.remoteAddress.port,F,C.TunnelPrivacyId.ConstantPrivate,C.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(M){this._candidateFilter=M}async setCandidates(M){let P=M;this._candidateFilter&&(P=await this._candidateFilter(M));const x=this.updateInResponseToCandidates(P);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(x.values()).map(F=>F.port).join(", ")}`),this._onCandidatesChanged.fire(x)}updateInResponseToCandidates(M){const P=this._candidates??new Map,x=new Map;return this._candidates=x,M.forEach(F=>{const O=A(F.host,F.port);x.set(O,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),P.has(O)&&P.delete(O);const W=y(this.forwarded,F.host,F.port);W&&(W.runningProcess=F.detail,W.hasRunningProcess=!0,W.pid=F.pid)}),P.forEach((F,O)=>{const W=h(O);if(!W)return;const J=y(this.forwarded,W.host,W.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0);const ce=y(this.detected,W.host,W.port);ce&&(ce.runningProcess=void 0,ce.hasRunningProcess=!1,ce.pid=void 0)}),P}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const M=Array.from(this.forwarded.values()),P=await this.getAttributes(M.map(x=>({port:x.remotePort,host:x.remoteHost})),!1);if(P)for(const x of M){const F=P.get(x.remotePort);(F?.protocol||x.protocol!==C.TunnelProtocol.Http)&&F?.protocol!==x.protocol&&await this.doForward({remote:{host:x.remoteHost,port:x.remotePort},local:x.localPort,name:x.name,source:x.source},F),F&&F.label&&F.label!==x.name&&await this.name(x.remoteHost,x.remotePort,F.label)}}async getAttributes(M,P=!0){const x=new Map,F=new Map;M.forEach(G=>{const X=y(this._candidates??new Map,C.LOCALHOST_ADDRESSES[0],G.port)??G;if(X){x.set(G.port,X);const Y=b(X)?X.pid:void 0;F.has(Y)||F.set(Y,[]),F.get(Y)?.push(G.port)}});const O=new Map;if(M.forEach(G=>{const X=this.configPortsAttributes.getAttributes(G.port,G.host,x.get(G.port)?.detail);X&&O.set(G.port,X)}),this.portAttributesProviders.length===0||!P)return O.size>0?O:void 0;const W=await Promise.all((0,N.flatten)(this.portAttributesProviders.map(G=>Array.from(F.entries()).map(X=>{const Y=X[1],se=x.get(Y[0]);return G.providePortAttributes(Y,se?.pid,se?.detail,new i.CancellationTokenSource().token)})))),J=new Map;if(W.forEach(G=>G.forEach(X=>{X&&J.set(X.port,X)})),!O&&!J)return;const ce=new Map;return M.forEach(G=>{const X=O.get(G.port),Y=J.get(G.port);ce.set(G.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??_.providedActionToAction(Y?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),ce}addAttributesProvider(M){this.portAttributesProviders.push(M)}};e.TunnelModel=T,Ge([(0,m.debounce)(1e3)],T.prototype,"storeForwarded",null),e.TunnelModel=T=Ge([We(0,C.ITunnelService),We(1,w.IStorageService),We(2,S.IConfigurationService),We(3,f.IWorkbenchEnvironmentService),We(4,g.IRemoteAuthorityResolverService),We(5,l.IWorkspaceContextService),We(6,I.ILogService),We(7,L.IDialogService),We(8,s.IExtensionService),We(9,a.IContextKeyService)],T)}),define(ye[94],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class D{constructor(R,v){this.line=R,this.character=v}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,v){return new D(0,0)}with(R){return new D(0,0)}}e.Position=D;class N{constructor(R,v,p,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,v),this.end=new D(p,S)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new N(0,0,0,0)}with(R){return new N(0,0,0,0)}}e.Range=N;var m;(function(k){k[k.Information=1]="Information",k[k.Warning=2]="Warning"})(m||(e.TextSearchCompleteMessageType=m={}))}),define(ye[36],Ce([1,0,19,34,24,33,13,5,16,8,94,12]),function(ge,e,D,N,m,k,R,v,p,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",w=" characters skipped \u27EB",C=(g.length+w.length+5)*2;e.ISearchService=(0,v.createDecorator)("searchService");var l;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(l||(e.SearchProviderType=l={}));var f;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(f||(e.QueryType=f={}));function s(Y){return!!Y.preview}e.resultIsMatch=s;function i(Y){return!!Y.resource}e.isFileMatch=i;function n(Y){return!!Y.message}e.isProgressMessage=n;var o;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(se){this.resource=se,this.results=[]}}e.FileMatch=a;class t{constructor(se,Q,we,he){this.ranges=Q,this.webviewIndex=he;const j=Array.isArray(Q)?Q:[Q];if(we&&we.matchLines===1&&r(j)){se=(0,R.getNLines)(se,we.matchLines);let z="",ne=0,Se=0;const de=Math.floor(we.charsPerLine/5),me=[];for(const Z of j){const ie=Math.max(Z.startColumn-de,0),q=Z.startColumn+we.charsPerLine;if(ie>Se+de+C){const te=g+(ie-Se)+w;z+=te+se.slice(ie,q),ne+=ie-(Se+te.length)}else z+=se.slice(Se,q);me.push(new u(0,Z.startColumn-ne,Z.endColumn-ne)),Se=q}this.preview={text:z,matches:Array.isArray(this.ranges)?me:me[0]}}else{const z=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:se,matches:(0,D.mapArrayOrNot)(Q,ne=>new h(ne.startLineNumber-z,ne.startColumn,ne.endLineNumber-z,ne.endColumn))}}}}e.TextSearchMatch=t;function r(Y){const se=Y[0].startLineNumber;for(const Q of Y)if(Q.startLineNumber!==se||Q.endLineNumber!==se)return!1;return!0}class h{constructor(se,Q,we,he){this.startLineNumber=se,this.startColumn=Q,this.endLineNumber=we,this.endColumn=he}}e.SearchRange=h;class u extends h{constructor(se,Q,we){super(se,Q,se,we)}}e.OneLineRange=u;var c;(function(Y){Y.List="list",Y.Tree="tree"})(c||(e.ViewMode=c={}));var d;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function y(Y,se=!0){const Q=Y&&Y.files&&Y.files.exclude,we=se&&Y&&Y.search&&Y.search.exclude;if(!Q&&!we)return;if(!Q||!we)return Q||we;let he=Object.create(null);return he=m.mixin(he,m.deepClone(Q)),he=m.mixin(he,m.deepClone(we),!0),he}e.getExcludes=y;function A(Y,se){return Y.excludePattern&&N.match(Y.excludePattern,se)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&N.match(Y.includePattern,se)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(Q=>{const we=Q.folder.fsPath;if(k.isEqualOrParent(se,we)){const he=p.relative(we,se);return!Q.includePattern||!!N.match(Q.includePattern,he)}else return!1}):!1:!0}e.pathIncludedInQuery=A;var E;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(E||(e.SearchErrorCode=E={}));class b extends Error{constructor(se,Q){super(se),this.code=Q}}e.SearchError=b;function _(Y){const se=Y.message;if((0,S.isCancellationError)(Y))return new b(se,E.canceled);try{const Q=JSON.parse(se);return new b(Q.message,Q.code)}catch{return new b(se,E.other)}}e.deserializeSearchError=_;function T(Y){const se={message:Y.message,code:Y.code};return new Error(JSON.stringify(se))}e.serializeSearchError=T;function U(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=U;function M(Y){return Y.type==="success"}e.isSerializedSearchSuccess=M;function P(Y){return!!Y.path}e.isSerializedFileMatch=P;function x(Y,se){const Q=Y.searchPath?Y.searchPath:Y.relativePath;return(0,R.fuzzyContains)(Q,se)}e.isFilePatternMatch=x;class F{constructor(se){this.path=se,this.results=[]}addMatch(se){this.results.push(se)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function O(Y,se){const Q={...Y||{},...se||{}};return Object.keys(Q).filter(we=>{const he=Q[we];return typeof he=="boolean"&&he})}e.resolvePatternsForProvider=O;class W{constructor(se,Q){this._parsedIncludeExpression=null,this._excludeExpression={...se.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=N.parse(this._excludeExpression);let we=se.includePattern;Q.includePattern&&(we?we={...we,...Q.includePattern}:we=Q.includePattern),we&&(this._parsedIncludeExpression=N.parse(we))}matchesExcludesSync(se,Q,we){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(se,Q,we))}includedInQuerySync(se,Q,we){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(se,Q,we)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(se,Q,we))}includedInQuery(se,Q,we){const he=this._parsedExcludeExpression(se,Q,we),j=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(se,Q,we):!0;return(0,I.isThenable)(he)?he.then(z=>z?!1:j()):j()}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=W;function J(Y){for(const se in Y)if(typeof Y[se]!="boolean")return!0;return!1}function ce(Y){if(!Y)return;let se;return Q=>(se||(se=(Y()||Promise.resolve([])).then(we=>we?X(we):{})),se.then(we=>!!we[Q]))}e.hasSiblingPromiseFn=ce;function G(Y){if(!Y)return;let se;return Q=>{if(!se){const we=Y();se=we?X(we):{}}return!!se[Q]}}e.hasSiblingFn=G;function X(Y){const se={};for(const Q of Y)se[Q]=!0;return se}}),define(ye[41],Ce([1,0,19,12,21,4,3,77,17,122,23,13,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(M,P,x){return new L.ExtUri(F=>b(F,x)).isEqual(M,P)}function y(M,P,x){return d(M.uri,P.uri,x)?0:(0,I.compare)(M.uri.toString(),P.uri.toString())}function A(M,P,x){return M.index!==P.index?M.index<P.index?-1:1:d(M.uri,P.uri,x)?(0,I.compare)(M.name,P.name):(0,I.compare)(M.uri.toString(),P.uri.toString())}function E(M,P,x,F){const O=M.slice(0).sort((J,ce)=>x(J,ce,F)),W=P.slice(0).sort((J,ce)=>x(J,ce,F));return(0,D.delta)(O,W,(J,ce)=>x(J,ce,F))}function b(M,P){const x=P.getCapabilities(M.scheme);return!(x&&x&1024)}class _ extends s.Workspace{static toExtHostWorkspace(P,x,F,O){if(!P)return{workspace:null,added:[],removed:[]};const{id:W,name:J,folders:ce,configuration:G,transient:X,isUntitled:Y}=P,se=[],Q=x;x?ce.forEach((z,ne)=>{const Se=g.URI.revive(z.uri),de=_._findFolder(F||x,Se,O);de?(de.name=z.name,de.index=z.index,se.push(de)):se.push({uri:Se,name:z.name,index:ne})}):se.push(...ce.map(({uri:z,name:ne,index:Se})=>({uri:g.URI.revive(z),name:ne,index:Se}))),se.sort((z,ne)=>z.index<ne.index?-1:1);const we=new _(W,J,se,!!X,G?g.URI.revive(G):null,!!Y,z=>b(z,O)),{added:he,removed:j}=E(Q?Q.workspaceFolders:[],we.workspaceFolders,y,O);return{workspace:we,added:he,removed:j}}static _findFolder(P,x,F){for(let O=0;O<P.folders.length;O++){const W=P.workspaceFolders[O];if(d(W.uri,x,F))return W}}constructor(P,x,F,O,W,J,ce){super(P,F.map(G=>new s.WorkspaceFolder(G)),O,W,ce),this._name=x,this._isUntitled=J,this._workspaceFolders=[],this._structure=v.TernarySearchTree.forUris(ce),F.forEach(G=>{this._workspaceFolders.push(G),this._structure.set(G.uri,G)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(P,x){return x&&this._structure.get(P)&&(P=(0,L.dirname)(P)),this._structure.findSubstr(P)}resolveWorkspaceFolder(P){return this._structure.get(P)}}let T=class{constructor(P,x,F,O,W){this._onDidChangeWorkspace=new k.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new k.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new k.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=O,this._extHostFileSystemInfo=F,this._uriTransformerService=W,this._requestIdProvider=new S.Counter,this._barrier=new N.Barrier,this._proxy=P.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=P.getProxy(u.MainContext.MainThreadMessageService);const J=x.workspace;this._confirmedWorkspace=J?new _(J.id,J.name,[],!!J.transient,J.configuration?g.URI.revive(J.configuration):null,!!J.isUntitled,ce=>b(ce,F)):void 0}$initializeWorkspace(P,x){this._trusted=x,this.$acceptWorkspaceData(P),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:p.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(P,x,F,...O){const W=[];if(Array.isArray(O)&&O.forEach(Y=>{g.URI.isUri(Y.uri)&&!W.some(se=>d(se.uri,Y.uri,this._extHostFileSystemInfo))&&W.push({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri)})}),this._unconfirmedWorkspace||[x,F].some(Y=>typeof Y!="number"||Y<0)||F===0&&W.length===0)return!1;const J=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+F>J.length)return!1;const ce=J.slice(0);ce.splice(x,F,...W.map(Y=>({uri:Y.uri,name:Y.name||(0,L.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<ce.length;Y++){const se=ce[Y];if(ce.some((Q,we)=>we!==Y&&d(se.uri,Q.uri,this._extHostFileSystemInfo)))return!1}ce.forEach((Y,se)=>Y.index=se);const{added:G,removed:X}=E(J,ce,A,this._extHostFileSystemInfo);if(G.length===0&&X.length===0)return!1;if(this._proxy){const Y=P.displayName||P.name;this._proxy.$updateWorkspaceFolders(Y,x,F,W).then(void 0,se=>{this._unconfirmedWorkspace=void 0;const Q={source:{identifier:P.identifier,label:P.displayName||P.name}};this._messageService.$showMessage(f.Severity.Error,(0,w.localize)(0,null,Y,se.toString()),Q,[])})}return this.trySetWorkspaceFolders(ce),!0}getWorkspaceFolder(P,x){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,x)}async getWorkspaceFolder2(P,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,x)}async resolveWorkspaceFolder(P){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(P)}getPath(){if(!this._actualWorkspace)return;const{folders:P}=this._actualWorkspace;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,x){let F,O="";if(typeof P=="string"?(F=g.URI.file(P),O=P):typeof P<"u"&&(F=P,O=P.fsPath),!F)return O;const W=this.getWorkspaceFolder(F,!0);if(!W)return O;typeof x>"u"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let J=(0,L.relativePath)(W.uri,F);return x&&W.name&&(J=`${W.name}/${J}`),J}trySetWorkspaceFolders(P){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:P,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:x,added:F,removed:O}=_.toExtHostWorkspace(P,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:O}))}findFiles(P,x,F,O,W=m.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let J;if(x===null?J=!1:x&&(typeof x=="string"?J=x:J=x.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ce,folder:G}=U(a.GlobPattern.from(P));return this._proxy.$startFileSearch(ce??null,G??null,J??null,F??null,W).then(X=>Array.isArray(X)?X.map(Y=>g.URI.revive(Y)):[])}async findTextInFiles(P,x,F,O,W=m.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const J=this._requestIdProvider.getNext(),ce=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:G,folder:X}=U(a.GlobPattern.from(x.include)),Y=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,se={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:ce,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:G,excludePattern:Y},Q=!1;if(this._activeSearchCallbacks[J]=we=>{if(Q)return;const he=g.URI.revive(we.resource);we.results.forEach(j=>{const z=(0,c.revive)(j);(0,h.resultIsMatch)(z)?F({uri:he,preview:{text:z.preview.text,matches:(0,D.mapArrayOrNot)(z.preview.matches,ne=>new t.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.mapArrayOrNot)(z.ranges,ne=>new t.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):F({uri:he,text:z.text,lineNumber:z.lineNumber})})},W.isCancellationRequested)return{};try{const we=await this._proxy.$startTextSearch(P,X??null,se,J,W);return delete this._activeSearchCallbacks[J],we||{}}catch(we){throw delete this._activeSearchCallbacks[J],we}}$handleTextSearchResult(P,x){this._activeSearchCallbacks[x]?.(P)}async save(P){const x=await this._proxy.$save(P,{saveAs:!1});return g.URI.revive(x)}async saveAs(P){const x=await this._proxy.$save(P,{saveAs:!0});return g.URI.revive(x)}saveAll(P){return this._proxy.$saveAll(P)}resolveProxy(P){return this._proxy.$resolveProxy(P)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(P){return this._proxy.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(P,x){if(this._editSessionIdentityProviders.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this._editSessionIdentityProviders.set(P,x);const F=this._uriTransformerService.transformOutgoingScheme(P),O=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(O,F),(0,R.toDisposable)(()=>{this._editSessionIdentityProviders.delete(P),this._proxy.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(P,x){this._logService.info("Getting edit session identifier for workspaceFolder",P);const F=await this.resolveWorkspaceFolder(g.URI.revive(P));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const O=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!O),!O)return;const W=await O.provideEditSessionIdentity(F,x);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(P,x,F,O){this._logService.info("Getting edit session identifier for workspaceFolder",P);const W=await this.resolveWorkspaceFolder(g.URI.revive(P));if(!W){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const J=this._editSessionIdentityProviders.get(W.uri.scheme);if(this._logService.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!J),!J)return;const ce=await J.provideEditSessionIdentityMatch?.(x,F,O);if(this._logService.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(P){return(x,F,O)=>{const W=function(ce){x.call(F,ce)};return W.extension=P,this._onWillCreateEditSessionIdentityEvent.event(W,void 0,O)}}async $onWillCreateEditSessionIdentity(P,x,F){const O=await this.resolveWorkspaceFolder(g.URI.revive(P));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:O},x,async(W,J)=>{const ce=Date.now();await Promise.resolve(W),Date.now()-ce>F&&this._logService.warn("SLOW edit session create-participant",J.extension.identifier)}),x.isCancellationRequested}registerCanonicalUriProvider(P,x){if(this._canonicalUriProviders.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this._canonicalUriProviders.set(P,x);const F=this._uriTransformerService.transformOutgoingScheme(P),O=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(O,F),(0,R.toDisposable)(()=>{this._canonicalUriProviders.delete(P),this._proxy.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(P,x,F){const O=this._canonicalUriProviders.get(P.scheme);if(!O)return;const W=await O.provideCanonicalUri?.(g.URI.revive(P),x,F);if(W)return W}async $provideCanonicalUri(P,x,F){return this.provideCanonicalUri(g.URI.revive(P),{targetScheme:x},F)}};e.ExtHostWorkspace=T,e.ExtHostWorkspace=T=Ge([We(0,o.IExtHostRpcService),We(1,n.IExtHostInitDataService),We(2,i.IExtHostFileSystemInfo),We(3,l.ILogService),We(4,r.IURITransformerService)],T),e.IExtHostWorkspace=(0,C.createDecorator)("IExtHostWorkspace");function U(M){let P,x;return M&&(typeof M=="string"?P=M:(P=M.pattern,x=g.URI.revive(M.baseUri))),{includePattern:P,folder:x}}}),define(ye[42],Ce([1,0,24,4,41,6,7,255,86,18,12,5,20,14,2]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(r,h){if(h){const u=h.split(".");let c=r;for(let d=0;c&&d<u.length;d++)c=c[u[d]];return c}}function f(r){return r instanceof C.URI}function s(r){return r&&r.uri instanceof C.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof C.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(f(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(h,u,c){this._proxy=h.getProxy(k.MainContext.MainThreadConfiguration),this._extHostWorkspace=u,this._logService=c,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(h=>this._actual)}$initializeConfiguration(h){this._actual=new t(this._proxy,this._extHostWorkspace,h,this._logService),this._barrier.open()}$acceptConfigurationChanged(h,u){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(h,u))}};e.ExtHostConfiguration=a,e.ExtHostConfiguration=a=Ge([We(0,g.IExtHostRpcService),We(1,m.IExtHostWorkspace),We(2,w.ILogService)],a);class t{constructor(h,u,c,d){this._onDidChangeConfiguration=new N.Emitter,this._proxy=h,this._logService=d,this._extHostWorkspace=u,this._configuration=v.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(h,u){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=v.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(u,c))}getConfiguration(h,u,c){const d=o(u)||{},y=this._toReadonlyValue(h?l(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),h):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));h&&this._validateConfigurationAccess(h,d,c?.identifier);function A(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const E={has(b){return typeof l(y,b)<"u"},get:(b,_)=>{this._validateConfigurationAccess(h?`${h}.${b}`:b,d,c?.identifier);let T=l(y,b);if(typeof T>"u")T=_;else{let U;const M=(P,x)=>{if((0,S.isObject)(P)){let F;const O=()=>{U=U||(0,D.deepClone)(y),F=F||l(U,x)};return new Proxy(P,{get:(W,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return O(),()=>F;if(U)return F=F||l(U,x),F[J];const ce=W[J];return typeof J=="string"?M(ce,`${x}.${J}`):ce},set:(W,J,ce)=>(O(),F&&(F[J]=ce),!0),deleteProperty:(W,J)=>(O(),F&&delete F[J],!0),defineProperty:(W,J,ce)=>(O(),F&&Object.defineProperty(F,J,ce),!0)})}return Array.isArray(P)?(0,D.deepClone)(P):P};T=M(T,b)}return T},update:(b,_,T,U)=>{b=h?`${h}.${b}`:b;const M=A(T);return _!==void 0?this._proxy.$updateConfigurationOption(M,b,_,d,U):this._proxy.$removeConfigurationOption(M,b,d,U)},inspect:b=>{b=h?`${h}.${b}`:b;const _=this._configuration.inspect(b,d,this._extHostWorkspace.workspace);if(_)return{key:b,defaultValue:(0,D.deepClone)(_.policy?.value??_.default?.value),globalValue:(0,D.deepClone)(_.user?.value??_.application?.value),workspaceValue:(0,D.deepClone)(_.workspace?.value),workspaceFolderValue:(0,D.deepClone)(_.workspaceFolder?.value),defaultLanguageValue:(0,D.deepClone)(_.default?.override),globalLanguageValue:(0,D.deepClone)(_.user?.override??_.application?.override),workspaceLanguageValue:(0,D.deepClone)(_.workspace?.override),workspaceFolderLanguageValue:(0,D.deepClone)(_.workspaceFolder?.override),languageIds:(0,D.deepClone)(_.overrideIdentifiers)}}};return typeof y=="object"&&(0,D.mixin)(E,y,!1),Object.freeze(E)}_toReadonlyValue(h){const u=c=>(0,S.isObject)(c)?new Proxy(c,{get:(d,y)=>u(d[y]),set:(d,y,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(d,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(d,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return u(h)}_validateConfigurationAccess(h,u,c){const d=p.OVERRIDE_PROPERTY_REGEX.test(h)?4:this._configurationScopes.get(h),y=c?`[${c.value}] `:"";if(d===4){typeof u?.resource>"u"&&this._logService.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){u?.resource&&this._logService.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(h,u){const c=new v.ConfigurationChangeEvent(h,u,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,y)=>c.affectsConfiguration(d,o(y))})}_toMap(h){return h.reduce((u,c)=>(u.set(c[0],c[1]),u),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")}),define(ye[95],Ce([1,0,2,12,4,6,7,41,69,42,21,47,20,27,5,17,11,14,91,303,8]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(M){function P(F){if(F!=null)return F}M.from=P;function x(F){if(F!=null)return F}M.to=x})(a||(a={}));var t;(function(M){function P(F){if(F!=null)return F}M.from=P;function x(F){if(F!=null)return F}M.to=x})(t||(t={}));var r;(function(M){function P(F){if(F!=null)return F}M.from=P;function x(F){if(F!=null)return F}M.to=x})(r||(r={}));var h;(function(M){function P(O){if(O){const W=O;return W&&!!W.process}else return!1}M.is=P;function x(O){if(O==null)return;const W={process:O.process,args:O.args};return O.options&&(W.options=r.from(O.options)),W}M.from=x;function F(O){if(O!=null)return new R.ProcessExecution(O.process,O.args,O.options)}M.to=F})(h||(h={}));var u;(function(M){function P(F){if(F!=null)return F}M.from=P;function x(F){if(F!=null)return F}M.to=x})(u||(u={}));var c;(function(M){function P(O){if(O){const W=O;return W&&(!!W.commandLine||!!W.command)}else return!1}M.is=P;function x(O){if(O==null)return;const W={};return O.commandLine!==void 0?W.commandLine=O.commandLine:(W.command=O.command,W.args=O.args),O.options&&(W.options=u.from(O.options)),W}M.from=x;function F(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.ShellExecution(O.commandLine,O.options):new R.ShellExecution(O.command,O.args?O.args:[],O.options)}M.to=F})(c||(c={}));var d;(function(M){function P(O){if(O){const W=O;return W&&W.customExecution==="customExecution"}else return!1}M.is=P;function x(O){return{customExecution:"customExecution"}}M.from=x;function F(O,W){return W.get(O)}M.to=F})(d||(e.CustomExecutionDTO=d={}));var y;(function(M){function P(x,F){let O;return x.scope!==void 0&&typeof x.scope!="number"?O=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===R.TaskScope.Workspace&&F&&F.workspaceFile?O=F.workspaceFile:O=n.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:O}}M.from=P})(y||(e.TaskHandleDTO=y={}));var A;(function(M){function P(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}M.from=P})(A||(A={}));var E;(function(M){function P(O,W){if(O==null)return[];const J=[];for(const ce of O){const G=x(ce,W);G&&J.push(G)}return J}M.fromMany=P;function x(O,W){if(O==null)return;let J;O.execution instanceof R.ProcessExecution?J=h.from(O.execution):O.execution instanceof R.ShellExecution?J=c.from(O.execution):O.execution&&O.execution instanceof R.CustomExecution&&(J=d.from(O.execution));const ce=a.from(O.definition);let G;return O.scope?typeof O.scope=="number"?G=O.scope:G=O.scope.uri:G=R.TaskScope.Workspace,!ce||!G?void 0:{_id:O._id,definition:ce,name:O.name,source:{extensionId:W.identifier.value,label:O.source,scope:G},execution:J,isBackground:O.isBackground,group:A.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}M.from=x;async function F(O,W,J){if(O==null)return;let ce;h.is(O.execution)?ce=h.to(O.execution):c.is(O.execution)?ce=c.to(O.execution):d.is(O.execution)&&(ce=d.to(O._id,J));const G=a.to(O.definition);let X;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?X=O.source.scope:X=await W.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):X=R.TaskScope.Workspace),!G||!X)return;const Y=new R.Task(G,X,O.name,O.source.label,ce,O.problemMatchers);return O.isBackground!==void 0&&(Y.isBackground=O.isBackground),O.group!==void 0&&(Y.group=R.TaskGroup.from(O.group._id),Y.group&&O.group.isDefault&&(Y.group=new R.TaskGroup(Y.group.id,Y.group.label),O.group.isDefault===!0&&(Y.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Y.presentationOptions=t.to(O.presentationOptions)),O._id&&(Y._id=O._id),O.detail&&(Y.detail=O.detail),Y}M.to=F})(E||(e.TaskDTO=E={}));var b;(function(M){function P(F){return F}M.from=P;function x(F){if(F)return Object.assign(Object.create(null),F)}M.to=x})(b||(b={}));class _{#e;constructor(P,x,F){this._id=x,this._task=F,this.#e=P}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(P){}fireDidEndProcess(P){}}let T=class{constructor(P,x,F,O,W,J,ce,G){this._onDidExecuteTask=new m.Emitter,this._onDidTerminateTask=new m.Emitter,this._onDidTaskProcessStarted=new m.Emitter,this._onDidTaskProcessEnded=new m.Emitter,this._proxy=P.getProxy(k.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=O,this._configurationService=W,this._terminalService=J,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ce,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(P,x,F){if(!F)return new R.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:x,provider:F,extension:P}),this._proxy.$registerTaskProvider(O,x),new R.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(P,x){this._proxy.$registerTaskSystem(P,x)}fetchTasks(P){return this._proxy.$fetchTasks(b.from(P)).then(async x=>{const F=[];for(const O of x){const W=await E.to(O,this._workspaceProvider,this._providedCustomExecutions2);W&&F.push(W)}return F})}get taskExecutions(){const P=[];return this._taskExecutions.forEach(x=>P.push(x)),P}terminateTask(P){if(!(P instanceof _))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(P._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(P,x,F){const O=this._providedCustomExecutions2.get(P.id);O&&(this._activeCustomExecutions2.set(P.id,O),this._terminalService.attachPtyToTerminal(x,await O.callback(F))),this._lastStartedTask=P.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(P)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(P){const x=await this.getTaskExecution(P);this._taskExecutionPromises.delete(P.id),this._taskExecutions.delete(P.id),this.customExecutionComplete(P),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(P){const x=await this.getTaskExecution(P.id);this._onDidTaskProcessStarted.fire({execution:x,processId:P.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(P){const x=await this.getTaskExecution(P.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:P.exitCode})}$provideTasks(P,x){const F=this._handlers.get(P);if(!F)return Promise.reject(new Error("no handler found"));const O=[],W=(0,N.asPromise)(()=>F.provider.provideTasks(L.CancellationToken.None)).then(J=>this.provideTasksInternal(x,O,F,J));return new Promise(J=>{W.then(ce=>{Promise.all(O).then(()=>{J(ce)})})})}async $resolveTask(P,x){const F=this._handlers.get(P);if(!F)return Promise.reject(new Error("no handler found"));if(x.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${F.type}].`);const O=await E.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const W=await F.provider.resolveTask(O,L.CancellationToken.None);if(!W)return;this.checkDeprecation(W,F);const J=E.from(W,F.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(J.execution)&&await this.addCustomExecution(J,W,!0),await this.resolveTaskInternal(J)}nextHandle(){return this._handleCounter++}async addCustomExecution(P,x,F){const O=await this._proxy.$createTaskId(P);!F&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,x.execution)),this._providedCustomExecutions2.set(O,x.execution)}async getTaskExecution(P,x){if(typeof P=="string"){const W=this._taskExecutionPromises.get(P);if(!W)throw new o.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return W}const F=this._taskExecutionPromises.get(P.id);if(F)return F;const O=new Promise((W,J)=>{function ce(G,X,Y){Y?W(new _(G,X.id,Y)):J("Unexpected: Task does not exist.")}x?ce(this,P,x):E.to(P.task,this._workspaceProvider,this._providedCustomExecutions2).then(G=>ce(this,P,G))});return this._taskExecutionPromises.set(P.id,O),O.then(W=>(this._taskExecutions.set(P.id,W),W),W=>Promise.reject(W))}checkDeprecation(P,x){P._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(P){this._activeCustomExecutions2.get(P.id)&&this._activeCustomExecutions2.delete(P.id),this._notProvidedCustomExecutions.has(P.id)&&this._lastStartedTask!==P.id&&(this._providedCustomExecutions2.delete(P.id),this._notProvidedCustomExecutions.delete(P.id));const F=this._notProvidedCustomExecutions.values();let O=F.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=F.next()}};e.ExtHostTaskBase=T,e.ExtHostTaskBase=T=Ge([We(0,g.IExtHostRpcService),We(1,w.IExtHostInitDataService),We(2,v.IExtHostWorkspace),We(3,p.IExtHostDocumentsAndEditors),We(4,S.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,s.ILogService),We(7,i.IExtHostApiDeprecationService)],T);let U=class extends T{constructor(P,x,F,O,W,J,ce,G){super(P,x,F,O,W,J,ce,G),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:f.PlatformToString(0)})}async executeTask(P,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const F=E.from(x,P);if(F===void 0)throw new Error("Task is not valid");if(d.is(F.execution))await this.addCustomExecution(F,x,!1);else throw new o.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),x);return this._proxy.$executeTask(F).catch(W=>{throw new Error(W)}),O}provideTasksInternal(P,x,F,O){const W=[];if(O)for(const J of O){if(this.checkDeprecation(J,F),!J.definition||!P[J.definition.type]){const G=J.source?J.source:"No task source";this._logService.warn(`The task [${G}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=E.from(J,F.extension);ce&&d.is(ce.execution)?(W.push(ce),x.push(this.addCustomExecution(ce,J,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:F.extension}}async resolveTaskInternal(P){if(d.is(P.execution))return P;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(P,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(P,x,F){}};e.WorkerExtHostTask=U,e.WorkerExtHostTask=U=Ge([We(0,g.IExtHostRpcService),We(1,w.IExtHostInitDataService),We(2,v.IExtHostWorkspace),We(3,p.IExtHostDocumentsAndEditors),We(4,S.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,s.ILogService),We(7,i.IExtHostApiDeprecationService)],U),e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(ye[359],Ce([1,0,36,29]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.genericCellMatchesToTextSearchMatches=e.rawCellPrefix=e.isINotebookFileMatchNoModel=void 0;function m(R){return"cellResults"in R}e.isINotebookFileMatchNoModel=m,e.rawCellPrefix="rawCell#";function k(R,v){let p=-1;const S=[];let L=[];return R.forEach(g=>{g.range.startLineNumber!==p&&L.length>0&&(S.push([...L]),L=[]),L.push(g),p=g.range.endLineNumber}),L.length>0&&S.push([...L]),S.map(g=>{const w=[],C=g[0].range.startLineNumber,l=g[g.length-1].range.endLineNumber;for(let f=C;f<=l;f++)w.push(v.getLineContent(f));return new D.TextSearchMatch(w.join(`
`)+`
`,g.map(f=>new N.Range(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.genericCellMatchesToTextSearchMatches=k}),define(ye[360],Ce([1,0,215,22,4,3,28,13,18,2,32,110,6,35,15,7,68,295,146,8,24,17,287,359,356]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(d=>d.apiEditor)}constructor(d,y,A,E,b,_){this._textDocumentsAndEditors=A,this._textDocuments=E,this._extHostFileSystem=b,this._extHostSearch=_,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new m.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new m.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new m.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new m.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=d.getProxy(g.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=d.getProxy(g.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=d.getProxy(g.MainContext.MainThreadNotebookEditors),this._commandsConverter=y.converter,y.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===13){const U=T.notebookEditor?.notebookUri,M=T.cell.handle,x=this._documents.get(U)?.getCell(M);if(x)return x.apiCell}if(T&&T.$mid===14){const U=T.uri,M=this._documents.get(U);if(M)return M.apiNotebook}return T}}),u._registerApiCommands(y)}getEditorById(d){const y=this._editors.get(d);if(!y)throw new Error(`unknown text editor: ${d}. known editors: ${[...this._editors.keys()]} `);return y}getIdByEditor(d){for(const[y,A]of this._editors)if(A.apiEditor===d)return y}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(d,y){const A=this._documents.get(d);if(!A&&!y)throw new Error(`NO notebook document for '${d}'`);return A}static _convertNotebookRegistrationData(d,y){if(!y)return;const A=y.filenamePattern.map(E=>C.NotebookExclusiveDocumentPattern.from(E)).filter(E=>E!==void 0);if(y.filenamePattern&&!A){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:y.displayName,filenamePattern:A,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,y,A){const E=u._notebookStatusBarItemProviderHandlePool++,b=typeof A.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(E,A),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(E,b,y);let _;return b!==void 0&&(_=A.onDidChangeCellStatusBarItems(T=>this._notebookProxy.$emitCellStatusBarEvent(b))),new l.Disposable(()=>{this._notebookStatusBarItemProviders.delete(E),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(E,b),_?.dispose()})}async createNotebookDocument(d){const y=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:d.viewType,content:d.content&&C.NotebookData.from(d.content)});return S.URI.revive(y)}async openNotebookDocument(d){const y=this._documents.get(d);if(y)return y.apiNotebook;const A=await this._notebookDocumentsProxy.$tryOpenNotebook(d),E=this._documents.get(S.URI.revive(A));return(0,p.assertIsDefined)(E?.apiNotebook)}async showNotebookDocument(d,y){S.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let A;typeof y=="object"?A={position:C.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(C.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:A={preserveFocus:!1};const E=await this._notebookEditorsProxy.$tryShowNotebookDocument(d.uri,d.notebookType,A),b=E&&this._editors.get(E)?.apiEditor;if(b)return b;throw E?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,y,A,E){const b=this._notebookStatusBarItemProviders.get(d),_=S.URI.revive(y),T=this._documents.get(_);if(!T||!b)return;const U=T.getCellFromIndex(A);if(!U)return;const M=await b.provideCellStatusBarItems(U.apiCell,E);if(!M)return;const P=new k.DisposableStore,x=this._statusBarCache.add([P]),O=(Array.isArray(M)?M:[M]).map(W=>C.NotebookStatusBarItem.from(W,this._commandsConverter,P));return{cacheId:x,items:O}}$releaseNotebookCellStatusBarItems(d){this._statusBarCache.delete(d)}registerNotebookSerializer(d,y,A,E,b){if((0,v.isFalsyOrWhitespace)(y))throw new Error("viewType cannot be empty or just whitespace");const _=this._handlePool++;return this._notebookSerializer.set(_,{viewType:y,serializer:A,options:E}),this._notebookProxy.$registerNotebookSerializer(_,{id:d.identifier,location:d.extensionLocation},y,C.NotebookDocumentContentOptions.from(E),u._convertNotebookRegistrationData(d,b)),(0,k.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(_)})}async $dataToNotebook(d,y,A){const E=this._notebookSerializer.get(d);if(!E)throw new Error("NO serializer found");const b=await E.serializer.deserializeNotebook(y.buffer,A);return new f.SerializableObjectWithBuffers(C.NotebookData.from(b))}async $notebookToData(d,y,A){const E=this._notebookSerializer.get(d);if(!E)throw new Error("NO serializer found");const b=await E.serializer.serializeNotebook(C.NotebookData.to(y.value),A);return N.VSBuffer.wrap(b)}async $saveNotebook(d,y,A,E,b){const _=S.URI.revive(y),T=this._notebookSerializer.get(d);if(!T)throw new Error("NO serializer found");const U=this._documents.get(_);if(!U)throw new Error("Document NOT found");if(U.versionId!==A)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(_.scheme))throw new L.FileOperationError((0,D.localize)(0,null,this._resourceForError(_)),6);await this._validateWriteFile(_,E);const M={metadata:(0,o.filter)(U.apiNotebook.metadata,W=>!(T.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of U.apiNotebook.getCells()){const J=new l.NotebookCellData(W.kind,W.document.getText(),W.document.languageId,W.mime,T.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);J.metadata=(0,o.filter)(W.metadata,ce=>!(T.options?.transientCellMetadata??{})[ce]),M.cells.push(J)}const P=await T.serializer.serializeNotebook(M,b);await this._extHostFileSystem.value.writeFile(_,P);const x=this._extHostFileSystem.getFileSystemProviderExtUri(_.scheme),F=await this._extHostFileSystem.value.stat(_);return{name:x.basename(_),isFile:(F.type&L.FileType.File)!==0,isDirectory:(F.type&L.FileType.Directory)!==0,isSymbolicLink:(F.type&L.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&L.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(_.scheme),locked:!!((F.permissions??0)&L.FilePermission.Locked),etag:L.etag({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(d,y,A,E,b){const _=this._notebookSerializer.get(d)?.serializer;if(!_)return{limitHit:!1,results:[]};const T=new R.ResourceSet;await(async(F,O,W)=>{await Promise.all(F.map(async J=>await Promise.all(J.filenamePatterns.map(ce=>{const G={...W,type:1,filePattern:ce};return this._extHostSearch.doInternalFileSearchWithCustomCallback(G,O,X=>{X.forEach(Y=>{T.has(Y)||E.some(Q=>J.isFromSettings&&!Q.isFromSettings?!1:Q.filenamePatterns.some(we=>(0,h.globMatchesResource)(we,Y)))||T.add(Y)})})}))))})(A,b,y);const M=new R.ResourceMap;let P=!1;const x=Array.from(T).map(async F=>{const O=[];try{if(b.isCancellationRequested)return;if(y.maxResults&&[...M.values()].reduce((G,X)=>G+X.cellResults.length,0)>y.maxResults){P=!0;return}const W=[],J=this._documents.get(F);if(J)J.apiNotebook.getCells().forEach(X=>W.push({input:X.document.getText(),outputs:X.outputs.flatMap(Y=>Y.items.map(se=>se.data.toString()))}));else{const G=await this._extHostFileSystem.value.readFile(F),X=N.VSBuffer.fromString(G.toString()),Y=await _.deserializeNotebook(X.buffer,b);if(b.isCancellationRequested)return;C.NotebookData.from(Y).cells.forEach(Q=>W.push({input:Q.source,outputs:Q.outputs.flatMap(we=>we.items.map(he=>he.valueBytes.toString()))}))}if(b.isCancellationRequested)return;W.forEach((G,X)=>{const Y=y.contentPattern.pattern,se=new t.CellSearchModel(G.input,void 0,G.outputs),Q=se.findInInputs(Y),we=se.findInOutputs(Y),he=we.flatMap(j=>(0,r.genericCellMatchesToTextSearchMatches)(j.matches,j.textBuffer)).map((j,z)=>(j.webviewIndex=z,j));if(Q.length>0||we.length>0){const j={index:X,contentResults:(0,r.genericCellMatchesToTextSearchMatches)(Q,se.inputTextBuffer),webviewResults:he};O.push(j)}});const ce={resource:F,cellResults:O};M.set(F,ce);return}catch{return}});return await Promise.all(x),{limitHit:P,results:[...M.values()]}}async _validateWriteFile(d,y){const A=await this._extHostFileSystem.value.stat(d);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==L.ETAG_DISABLED&&typeof A.mtime=="number"&&typeof A.size=="number"&&y.mtime<A.mtime&&y.etag!==L.etag({mtime:y.mtime,size:A.size}))throw new L.FileOperationError((0,D.localize)(1,null),3,y)}_resourceForError(d){return d.scheme===a.Schemas.file?d.fsPath:d.toString()}_createExtHostEditor(d,y,A){if(this._editors.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const E=new i.ExtHostNotebookEditor(y,this._notebookEditorsProxy,d,A.visibleRanges.map(C.NotebookRange.to),A.selections.map(C.NotebookRange.to),typeof A.viewColumn=="number"?C.ViewColumn.to(A.viewColumn):void 0);this._editors.set(y,E)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const A of d.value.removedDocuments){const E=S.URI.revive(A),b=this._documents.get(E);b&&(b.dispose(),this._documents.delete(E),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===E.toString()&&this._editors.delete(_.id)}if(d.value.addedDocuments){const A=[];for(const E of d.value.addedDocuments){const b=S.URI.revive(E.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const _=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,b,E);A.push(...E.cells.map(T=>s.ExtHostCell.asModelAddData(_.apiNotebook,T))),this._documents.get(b)?.dispose(),this._documents.set(b,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:A}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(d.value.addedEditors)for(const A of d.value.addedEditors){if(this._editors.has(A.id))return;const E=S.URI.revive(A.documentUri),b=this._documents.get(E);b&&this._createExtHostEditor(b,A.id,A)}const y=[];if(d.value.removedEditors)for(const A of d.value.removedEditors){const E=this._editors.get(A);E&&(this._editors.delete(A),this._activeNotebookEditor?.id===E.id&&(this._activeNotebookEditor=void 0),y.push(E))}if(d.value.visibleEditors){this._visibleNotebookEditors=d.value.visibleEditors.map(E=>this._editors.get(E)).filter(E=>!!E);const A=new Set;this._visibleNotebookEditors.forEach(E=>A.add(E.id));for(const E of this._editors.values()){const b=A.has(E.id);E._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(E=>E).filter(E=>E.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this._activeNotebookEditor=void 0:d.value.newActiveEditor&&(this._editors.get(d.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${d.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(d){const y=w.ApiCommandArgument.String.with("notebookType","A notebook type"),A=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new w.ApiCommandArgument("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>N.VSBuffer.wrap(b))],new w.ApiCommandResult("Notebook Data",b=>C.NotebookData.to(b.value))),E=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new f.SerializableObjectWithBuffers(C.NotebookData.from(b)))],new w.ApiCommandResult("Bytes",b=>b.buffer));d.registerApiCommand(A),d.registerApiCommand(E)}}e.ExtHostNotebookController=u}),define(ye[361],Ce([1,0,16,21,44,34,23,38,36]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class S{constructor(g,w,C){this.config=g,this.provider=w,this.sessionToken=C,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&k.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&k.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const w=this.config.folderQueries||[];return new Promise((C,l)=>{const f=s=>{this.resultCount++,g(s)};if(this.isCanceled)return C({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(s=>{const i=s.toString(),n=D.basename(i);this.globalExcludePattern&&this.globalExcludePattern(i,n)||this.matchFile(f,{base:s,basename:n})}),Promise.all(w.map(s=>this.searchInFolder(s,f))).then(s=>{C({limitHit:this.isLimitHit,stats:s[0]||void 0})},s=>{l(new Error((0,m.toErrorMessage)(s)))})})}async searchInFolder(g,w){const C=new N.CancellationTokenSource,l=this.getSearchOptionsForFolder(g),f=this.initDirectoryTree(),s=new p.QueryGlobTester(this.config,g),i=!s.hasSiblingExcludeClauses();let n;try{this.activeCancellationTokens.add(C),n=v.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,C.token),a=n.elapsed(),t=v.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(r=>{const h=D.posix.relative(g.folder.path,r.path);if(i){const u=D.basename(r.path);this.matchFile(w,{base:g.folder,relativePath:h,basename:u});return}this.addDirectoryEntries(f,g.folder,h,w)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(f,s,w),{providerTime:a,postProcessTime:t.elapsed()})}finally{C.dispose(),this.activeCancellationTokens.delete(C)}}getSearchOptionsForFolder(g){const w=(0,p.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),C=(0,p.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:C,includes:w,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},w,C,l){if(C===this.filePattern){const s=D.basename(this.filePattern);this.matchFile(l,{base:w,relativePath:this.filePattern,basename:s})}function f(s){const i=D.basename(s),n=D.dirname(s);let o=g[n];o||(o=g[n]=[],f(n)),o.push({base:w,relativePath:s,basename:i})}f(C)}matchDirectoryTree({rootEntries:g,pathToEntries:w},C,l){const f=this,s=this.filePattern;function i(n){const o=(0,p.hasSiblingFn)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:h,basename:u}=r;if(C.matchesExcludesSync(h,u,s!==u?o:void 0))continue;const c=w[h];if(c)i(c);else{if(h===s)continue;f.matchFile(l,r)}if(f.isLimitHit)break}}i(g)}matchFile(g,w){(!this.includePattern||w.relativePath&&this.includePattern(w.relativePath,w.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(w))}}class L{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(g,w,C,l){const f=this.getSessionTokenSource(g.cacheKey),s=new S(g,w,f&&f.token);let i=0;const n=o=>{i+=o.length,C(o.map(a=>this.rawMatchToSearchItem(a)))};return this.doSearch(s,L.BATCH_SIZE,n,l).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(g){this.getSessionTokenSource(g)?.cancel()}getSessionTokenSource(g){if(g)return this.sessions.has(g)||this.sessions.set(g,new N.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:R.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,w,C,l){const f=l.onCancellationRequested(()=>{g.cancel()}),s=n=>{n&&(i.push(n),w>0&&i.length>=w&&(C(i),i=[]))};let i=[];return g.search(s).then(n=>(i.length&&C(i),f.dispose(),n),n=>(i.length&&C(i),f.dispose(),Promise.reject(n)))}}e.FileSearchManager=L}),define(ye[362],Ce([1,0,19,73,34,102,28,17,16,23,13,18,2,99,236,45,14,40,143,357,36]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(b,_,T,U,M){this.configurationService=b,this.workspaceContextService=_,this.editorGroupsService=T,this.logService=U,this.pathService=M}text(b,_,T={}){b=this.getContentPattern(b,T);const U=this.configurationService.getValue(),M=_&&_.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(_?.map(s.toWorkspaceFolder),T),type:2,contentPattern:b,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:U.search.usePCRE2||M||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}getContentPattern(b,_){const T=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const U={...b,wordSeparators:T.editor.wordSeparators};return this.isCaseSensitive(b,_)&&(U.isCaseSensitive=!0),this.isMultiline(b)&&(U.isMultiline=!0),_.notebookSearchConfig?.includeMarkupInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownInput=_.notebookSearchConfig.includeMarkupInput),_.notebookSearchConfig?.includeMarkupPreview&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownPreview=_.notebookSearchConfig.includeMarkupPreview),_.notebookSearchConfig?.includeCodeInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellInput=_.notebookSearchConfig.includeCodeInput),_.notebookSearchConfig?.includeOutput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellOutput=_.notebookSearchConfig.includeOutput),U}file(b,_={}){return{...this.commonQuery(b,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(b,_){return b?(b=Array.isArray(b)?b.map(c):c(b),_?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],_={}){const T=this.handleIncludeExclude(_.includePattern,_.expandPatterns),U=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),M=b.length>1,P=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,_,U)):b.map(O=>this.getFolderQueryForRoot(O,_,U,M))).filter(O=>!!O),x={_reason:_._reason,folderQueries:P,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:U.pattern,includePattern:T.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const O=D.coalesce(D.flatten(this.editorGroupsService.groups.map(ce=>ce.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const W=O.filter(ce=>(0,o.pathIncludedInQuery)(x,ce.fsPath)),J=this.commonQueryFromFileList(W);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...x,...J}}const F=_.extraFileResources&&_.extraFileResources.filter(O=>(0,o.pathIncludedInQuery)(x,O.fsPath));return x.extraFileResources=F&&F.length?F:void 0,x}commonQueryFromFileList(b){const _=[],T=new R.ResourceMap,U={};let M=!1;return b.forEach(P=>{if(P.scheme===v.Schemas.walkThrough)return;if((0,S.isAbsolutePath)(P)){const F=this.workspaceContextService.getWorkspaceFolder(P)?.uri??P.with({path:p.dirname(P.fsPath)});let O=T.get(F);O||(M=!0,O={folder:F,includePattern:{}},_.push(O),T.set(F,O));const W=p.relative(F.fsPath,P.fsPath);(0,I.assertIsDefined)(O.includePattern)[W.replace(/\\/g,"/")]=!0}else P.fsPath&&(M=!0,U[P.fsPath]=!0)}),{folderQueries:_,includePattern:U,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(b,_){if(_.isSmartCase){if(b.isRegExp){if(L.containsUppercaseCharacter(b.pattern,!0))return!0}else if(L.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,w.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const _=J=>p.isAbsolute(J)||/^\.\.?([\/\\]|$)/.test(J),U=(Array.isArray(b)?b:h(b)).map(J=>{const ce=this.pathService.resolvedUserHome;return ce?(0,k.untildify)(J,ce.scheme===v.Schemas.file?ce.fsPath:ce.path):J}),M=N.groupBy(U,J=>_(J)?"searchPaths":"exprSegments"),P=(M.exprSegments||[]).map(J=>L.rtrim(J,"/")).map(J=>L.rtrim(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),u(J))),x={},F=this.expandSearchPathPatterns(M.searchPaths||[]);F&&F.length&&(x.searchPaths=F);const O=D.flatten(P),W=r(...O);return W&&(x.pattern=W),x}getExcludesForFolder(b,_){return _.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const _=b.flatMap(U=>{let{pathPortion:M,globPortion:P}=t(U);return P&&(P=d(P)),this.expandOneSearchPath(M).flatMap(F=>this.resolveOneSearchPathPattern(F,P))}),T=new Map;return _.forEach(U=>{const M=U.searchPath.toString(),P=T.get(M);P?U.pattern&&(P.pattern=P.pattern||{},P.pattern[U.pattern]=!0):T.set(M,{searchPath:U.searchPath,pattern:U.pattern?r(U.pattern):void 0})}),Array.from(T.values())}expandOneSearchPath(b){if(p.isAbsolute(b)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==v.Schemas.file?[{searchPath:_[0].uri.with({path:b})}]:[{searchPath:g.URI.file(p.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=c(b),b.startsWith("../")||b===".."){const U=p.posix.resolve(_.path,b);return[{searchPath:_.with({path:U})}]}const T=d(b);return[{searchPath:_,pattern:T}]}else{if(b==="./"||b===".\\")return[];{const _=b.replace(/^\.[\/\\]/,""),U=this.workspaceContextService.getWorkspace().folders.map(M=>{const P=_.match(new RegExp(`^${L.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return P?{match:P,folder:M}:null}).filter(I.isDefined);if(U.length)return U.map(M=>{const P=M.match[1];return{searchPath:M.folder.uri,pattern:P&&d(P)}});{const M=b.match(/\.[\/\\](.+)[\/\\]?/),P=M?M[1]:b,x=C.localize(0,null,P);throw new Error(x)}}}}resolveOneSearchPathPattern(b,_){const T=b.pattern&&_?`${b.pattern}/${_}`:b.pattern||_,U=[{searchPath:b.searchPath,pattern:T}];return T&&!T.endsWith("**")&&U.push({searchPath:b.searchPath,pattern:T+"/**"}),U}getFolderQueryForSearchPath(b,_,T){const U=this.getFolderQueryForRoot((0,s.toWorkspaceFolder)(b.searchPath),_,T,!1);return U?{...U,includePattern:b.pattern}:null}getFolderQueryForRoot(b,_,T,U){let M;const P=g.URI.isUri(b)?b:b.uri;if(T.searchPaths){const J=T.searchPaths.filter(ce=>(0,S.isEqual)(ce.searchPath,P))[0];if(J&&!J.pattern)return null;J&&(M=J.pattern)}const x=this.configurationService.getValue({resource:P}),O={...this.getExcludesForFolder(x,_)||{},...M||{}},W=g.URI.isUri(b)?(0,S.basename)(b):b.name;return{folder:P,folderName:U?W:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!x.search.followSymlinks}}};e.QueryBuilder=a,e.QueryBuilder=a=Ge([We(0,l.IConfigurationService),We(1,s.IWorkspaceContextService),We(2,i.IEditorGroupsService),We(3,f.ILogService),We(4,n.IPathService)],a);function t(E){const b=E.match(/[\*\{\}\(\)\[\]\?]/);if(b){const _=b.index,T=E.substr(0,_).match(/[/|\\][^/\\]*$/);if(T){let U=E.substr(0,T.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:E.substr((T.index||0)+1)}}}return{pathPortion:E}}function r(...E){return E.length?E.reduce((b,_)=>(b[_]=!0,b),Object.create(null)):void 0}function h(E){return m.splitGlobAware(E,",").map(b=>b.trim()).filter(b=>!!b.length)}function u(E){return[`**/${E}/**`,`**/${E}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function c(E){return E.replace(/\\/g,"/")}function d(E){return c(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function y(E){return E.replace(/([?*[\]])/g,"[$1]")}function A(E,b){E=D.distinct(E,U=>U.toString());const _=[],T=b.getWorkspace();return E&&E.forEach(U=>{let M;if(b.getWorkbenchState()===2)M=(0,S.relativePath)(T.folders[0].uri,U),M&&M!=="."&&(M="./"+M);else{const P=b.getWorkspaceFolder(U);if(P){const x=P.name;if(T.folders.filter(O=>O.name===x).length===1){const O=(0,S.relativePath)(P.uri,U);O===""?M=`./${P.name}`:M=`./${P.name}/${O}`}else M=U.fsPath}}M&&_.push(y(M))}),_}e.resolveResourcesForSearchIncludes=A}),define(ye[363],Ce([1,0,23,2,21,8,5,362,36,40]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function I(l,f){const s=f.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const c=u.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||l.forceUsingSearch?n.push(c):i.push(c)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((u,c)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>g(l,u,t))).then(()=>{}),h=w(l,f.identifier,n,t);return Promise.all([r,h]).then(()=>{o(void 0)}),a}e.checkActivateWorkspaceContainsExtension=I;async function g(l,f,s){for(const i of l.folders)if(await l.exists(D.joinPath(N.URI.revive(i),f))){s(`workspaceContains:${f}`);return}}async function w(l,f,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new m.CancellationTokenSource,o=l.checkExists(l.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),l.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},L);let t=!1;try{t=await o}catch(r){k.isCancellationError(r)||k.onUnexpectedError(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function C(l,f,s,i){const n=l.get(R.IInstantiationService),o=l.get(p.ISearchService),t=n.createInstance(v.QueryBuilder).file(f.map(r=>(0,S.toWorkspaceFolder)(N.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>k.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=C}),define(ye[48],Ce([1,0,212,16,56,23,12,3,77,2,14,6,42,293,118,41,25,145,8,26,22,272,7,64,5,27,92,20,107,72,47,4,363,117,274,17,115,38,11,116]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r,h,u,c,d,y,A,E,b,_,T,U,M,P,x,F,O){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,h.createDecorator)("IHostUtils");let J=W=class extends v.Disposable{constructor(j,z,ne,Se,de,me,Z,ie,q,te,fe,Ee){super(),this._extHostManagedSockets=Ee,this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=z,this._extHostContext=ne,this._initData=Z,this._extHostWorkspace=Se,this._extHostConfiguration=de,this._logService=me,this._extHostTunnelService=q,this._extHostTerminalService=te,this._extHostLocalizationService=fe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._activationEventsReader=new we(this._initData.extensions.activationEvents),this._globalRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Te=new n.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,se(this._globalRegistry,Te)),F.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${X(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${X(this._myRegistry)}`)),this._storage=new C.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=ie,this._instaService=j.createChild(new y.ServiceCollection([C.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState])),this._activator=this._register(new w.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ve,De,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ve,i.transformErrorForSerialization(De),B)},actualActivateExtension:async(ve,De)=>{if(s.ExtensionDescriptionRegistry.isHostExtension(ve,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ve,De),new w.HostExtension;const B=this._myRegistry.getExtensionDescription(ve);return this._activateExtension(B,De)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),m.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){i.onUnexpectedError(j)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._myRegistry.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this._deactivate(de))}catch{}await Promise.all(j)}terminate(j,z=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${j}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),i.setUnexpectedErrorHandler(Se=>{this._logService.error(Se)}),this._extHostContext.dispose();const ne=this._deactivateAll();Promise.race([(0,R.timeout)(5e3),ne]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${z}`):this._logService.info(`Extension host exiting with code ${z}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(z)})}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}async getExtension(j){const z=await this._mainThreadExtensionsProxy.$getExtension(j);return z&&{...z,identifier:new n.ExtensionIdentifier(z.identifier.value),extensionLocation:S.URI.revive(z.extensionLocation)}}_activateByEvent(j,z){return this._activator.activateByEvent(j,z)}_activateById(j,z){return this._activator.activateById(j,z)}activateByIdWithErrors(j,z){return this._activateById(j,z).then(()=>{const ne=this._activator.getActivatedExtension(j);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._myRegistry)}getExtensionExports(j){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(j).exports;try{return this._activator.getActivatedExtension(j).exports}catch{return null}}async _realPathExtensionUri(j){if(j.scheme===M.Schemas.file&&this._hostUtils.fsRealpath){const z=await this._hostUtils.fsRealpath(j.fsPath);return S.URI.file(z)}return j}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(j=>new Q(j))),this._extensionPathIndex}async _createExtensionPathIndex(j){const z=p.TernarySearchTree.forUris(ne=>k.extUriBiasedIgnorePathCase.ignorePathCasing(ne));return await Promise.all(j.map(async ne=>{if(this._getEntryPoint(ne)){const Se=await this._realPathExtensionUri(ne.extensionLocation);z.set(Se,ne)}})),z}_deactivate(j){let z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return z;const ne=this._activator.getActivatedExtension(j);if(!ne)return z;try{typeof ne.module.deactivate=="function"&&(z=Promise.resolve(ne.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${j.value}':`),this._logService.error(Se)}try{(0,v.dispose)(ne.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this._logService.error(Se)}return z}async _activateExtension(j,z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,z).then(ne=>{const Se=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,z),this._logExtensionActivationTimes(j,z,"success",Se),ne},ne=>{throw this._logExtensionActivationTimes(j,z,"failure"),ne})}_logExtensionActivationTimes(j,z,ne,Se){const de=G(j,z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...de,...Se||{},outcome:ne})}_doActivateExtension(j,z){const ne=G(j,z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const Se=this._getEntryPoint(j);if(!Se)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${j.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this._logService.flush();const de=new w.ExtensionActivationTimesBuilder(z.startup);return Promise.all([this._loadCommonJSModule(j,(0,k.joinPath)(j.extensionLocation,Se),de),this._loadExtensionContext(j)]).then(me=>(m.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),W._callActivate(this._logService,j.identifier,me[0],me[1],de))).then(me=>(m.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),me))}_loadExtensionContext(j){const z=new a.ExtensionGlobalMemento(j,this._storage),ne=new a.ExtensionMemento(j.identifier.value,!1,this._storage),Se=new U.ExtensionSecrets(j,this._secretState),de=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([z.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const Z=this;let ie,q;const te=(0,f.isProposedApiEnabled)(j,"ipc")?this._initData.messagePorts?.get(n.ExtensionIdentifier.toKey(j.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:ne,secrets:Se,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(fe){return N.join(j.extensionLocation.fsPath,fe)},get storagePath(){return Z._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Z._storagePath.globalValue(j).fsPath},get logPath(){return N.join(Z._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return S.URI.joinPath(Z._initData.logsLocation,j.identifier.value)},get storageUri(){return Z._storagePath.workspaceValue(j)},get globalStorageUri(){return Z._storagePath.globalValue(j)},get extensionMode(){return de},get extension(){return ie===void 0&&(ie=new Y(Z,j.identifier,j,me,!1)),ie},get extensionRuntime(){return(0,f.checkProposedApiEnabled)(j,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z._extHostTerminalService.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!q){if(!te)return;const fe=b.Event.buffer(b.Event.fromDOMEventEmitter(te,"message",Ee=>Ee.data));te.start(),q={onDidReceiveMessage:fe,postMessage:te.postMessage.bind(te)}}return q}})})}static _callActivate(j,z,ne,Se,de){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,z,ne,Se,de).then(me=>new w.ActivatedExtension(!1,null,de.build(),ne,me,Se.subscriptions))}static _callActivateOptional(j,z,ne,Se,de){if(typeof ne.activate=="function")try{de.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${z.value}`);const me=typeof global=="object"?global:self,Z=ne.activate.apply(me,[Se]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(Z).then(ie=>(de.activateResolveStop(),ie))}catch(me){return Promise.reject(me)}else return Promise.resolve(ne)}_activateOneStartupFinished(j,z){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:z}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinishedDeferred(j,z=0){const Se=Date.now();(0,F.setTimeout0)(()=>{for(let de=z;de<j.length;de+=1){const me=j[de];for(const Z of me.activationEvents??[])if(Z==="onStartupFinished")if(Date.now()-Se>50){this._activateAllStartupFinishedDeferred(j,de);break}else this._activateOneStartupFinished(me,Z)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(m.getMarks()),this._extHostConfiguration.getConfigProvider().then(j=>{const z=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this._myRegistry.getAllExtensionDescriptions();if(z)this._activateAllStartupFinishedDeferred(ne);else for(const Se of ne)if(Se.activationEvents)for(const de of Se.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(Se,de)})}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,me=>{this._logService.error(me)});this._register(this._extHostWorkspace.onDidChangeWorkspace(me=>this._handleWorkspaceContainsEagerExtensions(me.added)));const z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(z),Se=this._handleRemoteResolverEagerExtensions(),de=Promise.all([Se,j,ne]).then(()=>{});return Promise.race([de,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),de}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(z=>this._handleWorkspaceContainsEagerExtension(j,z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,z){if(this.isActivated(z.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:j.map(me=>me.uri),forceUsingSearch:ne||!this._hostUtils.fsExists,exists:me=>this._hostUtils.fsExists(me.fsPath),checkExists:(me,Z,ie)=>this._mainThreadWorkspaceProxy.$checkExists(me,Z,ie)},de=await(0,_.checkActivateWorkspaceContainsExtension)(Se,z);if(de)return this._activateById(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:de.activationEvent}).then(void 0,me=>this._logService.error(me))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:z}=this._initData.environment;if(!j||!z)throw new Error(D.localize(0,null));const ne=await this._loadCommonJSModule(null,z,new w.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,z.toString()));return new Promise((Se,de)=>{const me=(q,te)=>{q?(F.isCI&&this._logService.error("Test runner called back with error",q),de(q)):(F.isCI&&(te?this._logService.info(`Test runner called back with ${te} failures.`):this._logService.info("Test runner called back with successful outcome.")),Se(typeof te=="number"&&te>0?1:0))},Z=(0,k.originalFSPath)(z),ie=ne.run(Z,me);ie&&ie.then&&ie.then(()=>{F.isCI&&this._logService.info("Test runner finished successfully."),Se(0)}).catch(q=>{F.isCI&&this._logService.error("Test runner finished with error",q),de(q instanceof Error&&q.stack?q.stack:String(q))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,z){return this._resolvers[j]=z,(0,v.toDisposable)(()=>{delete this._resolvers[j]})}async getRemoteExecServer(j){const{resolver:z}=await this._activateAndGetResolver(j);return z?.resolveExecServer?.(j,{resolveAttempt:0})}async _activateAndGetResolver(j){const z=j.indexOf("+");if(z===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=j.substr(0,z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(j,z){const ne=x.StopWatch.create(!1),Se=()=>`[resolveAuthority(${(0,r.getRemoteAuthorityPrefix)(j)},${z})][${ne.elapsed()}ms] `,de=ee=>this._logService.info(`${Se()}${ee}`),me=ee=>this._logService.warn(`${Se()}${ee}`),Z=(ee,H=void 0)=>this._logService.error(`${Se()}${ee}`,H),ie=ee=>{if(ee instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},q=async ee=>{de(`activating resolver for ${ee}...`);const{resolver:H,authorityPrefix:ae}=await this._activateAndGetResolver(ee);if(!H)throw Z(`no resolver for ${ae}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${ae}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:ae,remoteAuthority:ee}},te=j.split(/@|%40/g).reverse();de(`activating remote resolvers ${te.join(" -> ")}`);let fe;try{fe=await Promise.all(te.map(q)).catch(async ee=>{if(!(ee instanceof t.RemoteAuthorityResolverError)||ee._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return me(`resolving nested authorities failed: ${ee.message}`),[await q(j)]})}catch(ee){return ie(ee)}const Ee=new R.IntervalTimer;Ee.cancelAndSet(()=>de("waiting..."),1e3);let Te,ve;for(const[ee,{authorityPrefix:H,resolver:ae,remoteAuthority:ue}]of fe.entries())try{if(ee===fe.length-1)de("invoking final resolve()..."),m.mark(`code/extHost/willResolveAuthority/${H}`),Te=await ae.resolve(ue,{resolveAttempt:z,execServer:ve}),m.mark(`code/extHost/didResolveAuthorityOK/${H}`),de("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(ae,t.ManagedResolvedAuthority.isManagedResolvedAuthority(Te)?Te:void 0));else{if(de(`invoking resolveExecServer() for ${ue}`),m.mark(`code/extHost/willResolveExecServer/${H}`),ve=await ae.resolveExecServer?.(ue,{resolveAttempt:z,execServer:ve}),!ve)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${ue}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);m.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Ae){return m.mark(`code/extHost/didResolveAuthorityError/${H}`),Z("returned an error",Ae),Ee.dispose(),ie(Ae)}Ee.dispose();const De={environmentTunnels:Te.environmentTunnels,features:Te.tunnelFeatures},B={extensionHostEnv:Te.extensionHostEnv,isTrusted:Te.isTrusted,authenticationSession:Te.authenticationSessionForInitializingExtensions?{id:Te.authenticationSessionForInitializingExtensions.id,providerId:Te.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(Te)?"managed authority":`${Te.host}:${Te.port}`}`);let K;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(Te)){const ee=z;this._extHostManagedSockets.setFactory(ee,Te.makeConnection),K={authority:j,connectTo:new r.ManagedRemoteConnection(ee),connectionToken:Te.connectionToken}}else K={authority:j,connectTo:new r.WebSocketRemoteConnection(Te.host,Te.port),connectionToken:Te.connectionToken};return{type:"ok",value:{authority:K,options:B,tunnelInformation:De}}}async $getCanonicalURI(j,z){this._logService.info(`$getCanonicalURI invoked for authority (${(0,r.getRemoteAuthorityPrefix)(j)})`);const{resolver:ne}=await this._activateAndGetResolver(j);if(!ne)return null;const Se=S.URI.revive(z);if(typeof ne.getCanonicalURI>"u")return Se;const de=await(0,R.asPromise)(()=>ne.getCanonicalURI(Se));return de||Se}$startExtensionHost(j){j.toAdd.forEach(Se=>Se.extensionLocation=S.URI.revive(Se.extensionLocation));const{globalRegistry:z,myExtensions:ne}=ce(this._activationEventsReader,this._globalRegistry,this._myRegistry,j);return this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(ne),F.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${X(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(j,z){return z===1?this._almostReadyToRunExtensions.wait().then(ne=>this._activateByEvent(j,!1)):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(j,!1))}async $activate(j,z){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(j)?(await this._activateById(j,z),!0):!1}async $deltaExtensions(j){j.toAdd.forEach(me=>me.extensionLocation=S.URI.revive(me.extensionLocation));const{globalRegistry:z,myExtensions:ne}=ce(this._activationEventsReader,this._globalRegistry,this._myRegistry,j),Se=await this._createExtensionPathIndex(ne);return(await this.getExtensionPathIndex()).setSearchTree(Se),this._globalRegistry.set(z.getAllExtensionDescriptions()),this._myRegistry.set(ne),F.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${X(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${X(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const z=o.VSBuffer.alloc(j),ne=Math.random()%256;for(let Se=0;Se<j;Se++)z.writeUInt8(ne,Se);return z}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=J,e.AbstractExtHostExtensionService=J=W=Ge([We(0,h.IInstantiationService),We(1,e.IHostUtils),We(2,d.IExtHostRpcService),We(3,l.IExtHostWorkspace),We(4,g.IExtHostConfiguration),We(5,L.ILogService),We(6,u.IExtHostInitDataService),We(7,c.IExtensionStoragePaths),We(8,A.IExtHostTunnelService),We(9,E.IExtHostTerminalService),We(10,P.IExtHostLocalizationService),We(11,O.IExtHostManagedSockets)],J);function ce(he,j,z,ne){he.addActivationEvents(ne.addActivationEvents);const Se=new s.ExtensionDescriptionRegistry(he,j.getAllExtensionDescriptions());Se.deltaExtensions(ne.toAdd,ne.toRemove);const de=new n.ExtensionIdentifierSet(z.getAllExtensionDescriptions().map(Z=>Z.identifier));for(const Z of ne.myToRemove)de.delete(Z);for(const Z of ne.myToAdd)de.add(Z);const me=se(Se,de);return{globalRegistry:Se,myExtensions:me}}function G(he,j){return{id:he.identifier.value,name:he.name,extensionVersion:he.version,publisherDisplayName:he.publisher,activationEvents:he.activationEvents?he.activationEvents.join(","):null,isBuiltin:he.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}function X(he){return he.getAllExtensionDescriptions().map(j=>j.identifier.value).join(",")}e.IExtHostExtensionService=(0,h.createDecorator)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(j,z,ne,Se,de){this.#e=j,this.#t=z,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=N.normalize((0,k.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Se,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=Y;function se(he,j){return he.getAllExtensionDescriptions().filter(z=>j.has(z.identifier))}class Q{constructor(j){this._searchTree=j}setSearchTree(j){this._searchTree=j}findSubstr(j){return this._searchTree.findSubstr(j)}forEach(j){return this._searchTree.forEach(j)}}e.ExtensionPaths=Q;class we{constructor(j){this._map=new n.ExtensionIdentifierMap,this.addActivationEvents(j)}readActivationEvents(j){return this._map.get(j.identifier)??[]}addActivationEvents(j){for(const z of Object.keys(j))this._map.set(z,j[z])}}}),define(ye[364],Ce([1,0,56,2,6,42,25,26,20,27,5,48,14,13]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(o,a,t,r,h,u,c){this._apiFactory=o,this._extensionRegistry=a,this._instaService=t,this._extHostConfiguration=r,this._extHostExtensionService=h,this._initData=u,this._logService=c,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),D.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,a,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(i,a,this._initData.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this._factories.set(a,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(a=>o.alternativeModuleName(a))}};e.RequireInterceptor=l,e.RequireInterceptor=l=Ge([We(2,L.IInstantiationService),We(3,k.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,S.IExtHostInitDataService),We(6,g.ILogService)],l);let f=class{static{C=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&C.aliased.size){const a=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${h}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(o));if(!a)return;const[,t,r,h]=a,u=C.aliased.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+h}forceForwardSlashes(o){return o.replace(/\\/g,"/")}};f=C=Ge([We(0,S.IExtHostInitDataService)],f);class s{constructor(o,a,t,r,h){this._apiFactory=o,this._extensionPaths=a,this._extensionRegistry=t,this._configProvider=r,this._logService=h,this.nodeModuleName="vscode",this._extApiImpl=new v.ExtensionIdentifierMap}load(o,a){const t=this._extensionPaths.findSubstr(a);if(t){let r=this._extApiImpl.get(t.identifier);return r||(r=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((h,u)=>r+=`	${u} -> ${h.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let i=class{constructor(o,a,t){this._extensionPaths=o,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(m.MainContext.MainThreadTelemetry);const r=t.getProxy(m.MainContext.MainThreadWindow);this._impl=(h,u)=>{const c=N.URI.parse(h);return u?this.callOriginal(h,u):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,h,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this._appUriScheme?r.$openUri(c,h,{}):this.callOriginal(h,u)}}load(o,a,t){const r=this._extensionPaths.findSubstr(a);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=t(o),this._impl}callOriginal(o,a){return this.sendNoForwardTelemetry(),this._original(o,a)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};i=Ge([We(2,p.IExtHostRpcService)],i)}),define(ye[58],Ce([1,0,43,3,16,50,5,69,70,48,7,41,290,42]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class C extends g.AbstractVariableResolverService{constructor(s,i,n,o,a,t,r){function h(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const c=o.tabGroups.all.find(d=>d.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof L.TextDiffTabInput||c.input instanceof L.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof L.TextTabInput||c.input instanceof L.NotebookEditorTabInput||c.input instanceof L.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:u=>{const c=t.folders.filter(d=>d.name===u);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,c)=>a.getConfiguration(void 0,u).get(c),getAppRoot:()=>k.cwd(),getExecPath:()=>k.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=h();if(u)return m.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=h();if(u){const c=i.getWorkspaceFolder(u);if(c)return m.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(k.env))}}let l=class extends N.Disposable{constructor(s,i,n,o,a){super(),this.extensionService=s,this.workspaceService=i,this.editorService=n,this.configurationService=o,this.editorTabs=a,this._resolver=new D.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),h={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async u=>{h.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new C(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,h,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=l,e.ExtHostVariableResolverProviderService=l=Ge([We(0,S.IExtHostExtensionService),We(1,I.IExtHostWorkspace),We(2,v.IExtHostDocumentsAndEditors),We(3,w.IExtHostConfiguration),We(4,p.IExtHostEditorTabs)],l)}),define(ye[96],Ce([1,0,12,4,2,5,6,70,48,20,7,41,140,282,42,58]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,k.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(r,h,u,c,d,y){this._workspaceService=h,this._extensionService=u,this._configurationService=c,this._editorTabs=d,this._variableResolver=y,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new N.Emitter,this._onDidTerminateDebugSession=new N.Emitter,this._onDidChangeActiveDebugSession=new N.Emitter,this._onDidReceiveDebugSessionCustomEvent=new N.Emitter,this._debugServiceProxy=r.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new N.Emitter,this._onDidChangeStackFrameFocus=new N.Emitter,this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(E=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}asDebugSourceUri(r,h){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let c=`debug:${encodeURIComponent(u.path||"")}`,d="?";return h&&(c+=`${d}session=${encodeURIComponent(h.id)}`,d="&"),c+=`${d}ref=${u.sourceReference}`,m.URI.parse(c)}else{if(u.path)return m.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const h=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const c=u.contributes.debuggers;if(c&&c.length>0)for(const d of c)(0,w.isDebuggerMainContribution)(d)&&h.push(d.type)}this._debugServiceProxy.$registerDebugTypes(h)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const r=[];return this._breakpoints.forEach(h=>r.push(h)),r}addBreakpoints(r){const h=r.filter(d=>{const y=d.id;return this._breakpoints.has(y)?!1:(this._breakpoints.set(y,d),!0)});this.fireBreakpointChanges(h,[],[]);const u=[],c=new Map;for(const d of h)if(d instanceof L.SourceBreakpoint){let y=c.get(d.location.uri.toString());y||(y={type:"sourceMulti",uri:d.location.uri,lines:[]},c.set(d.location.uri.toString(),y),u.push(y)),y.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof L.FunctionBreakpoint&&u.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(r){const h=r.filter(y=>this._breakpoints.delete(y.id));this.fireBreakpointChanges([],h,[]);const u=h.filter(y=>y instanceof L.SourceBreakpoint).map(y=>y.id),c=h.filter(y=>y instanceof L.FunctionBreakpoint).map(y=>y.id),d=h.filter(y=>y instanceof L.DataBreakpoint).map(y=>y.id);return this._debugServiceProxy.$unregisterBreakpoints(u,c,d)}startDebugging(r,h,u){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,h,u){if(!h)return new L.Disposable(()=>{});const c=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:c,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,c),new L.Disposable(()=>{this._configProviders=this._configProviders.filter(d=>d.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,h,u){if(!u)return new L.Disposable(()=>{});if(!this.definesDebugType(r,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:c,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,c),new L.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(d=>d.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,h){if(!h)return new L.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:u,factory:h}),new L.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(c=>c.factory!==h)})}async $runInTerminal(r,h){return Promise.resolve(void 0)}async $substituteVariables(r,h){let u;const c=await this.getFolder(r);return c&&(u={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(u,h)}createDebugAdapter(r,h){if(r.type==="implementation")return new o(r.implementation)}createSignService(){}async $startDASession(r,h){const u=this,c=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(c.type),c).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const y=this.convertToDto(d),A=this.createDebugAdapter(y,c);if(!A)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const E=A;return this._debugAdapters.set(r,E),this.getDebugAdapterTrackers(c).then(b=>(b&&this._debugAdaptersTrackers.set(r,b),E.onMessage(async _=>{if(_.type==="request"&&_.command==="handshake"){const T=_,U={type:"response",seq:0,command:T.command,request_seq:T.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(T.arguments.value);U.body={signature:M},E.sendResponse(U)}else throw new Error("no signer")}catch(M){U.success=!1,U.message=M.message,E.sendResponse(U)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(_),_=(0,w.convertToVSCPaths)(_,!0),u._debugServiceProxy.$acceptDAMessage(r,_)}),E.onError(_=>{b&&b.onError&&b.onError(_),this._debugServiceProxy.$acceptDAError(r,_.name,_.message,_.stack)}),E.onExit(_=>{b&&b.onExit&&b.onExit(_??void 0,void 0),this._debugServiceProxy.$acceptDAExit(r,_??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),E.startSession()))})}$sendDAMessage(r,h){h=(0,w.convertToDAPaths)(h,!1);const u=this._debugAdaptersTrackers.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h),this._debugAdapters.get(r)?.sendMessage(h)}$stopDASession(r){const h=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),h&&h.onWillStopSession&&h.onWillStopSession();const u=this._debugAdapters.get(r);return this._debugAdapters.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const h=[],u=[],c=[];if(r.added)for(const d of r.added){const y=d.id;if(y&&!this._breakpoints.has(y)){let A;if(d.type==="function")A=new L.FunctionBreakpoint(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")A=new L.DataBreakpoint(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const E=m.URI.revive(d.uri);A=new L.SourceBreakpoint(new L.Location(E,new L.Position(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,L.setBreakpointId)(A,y),this._breakpoints.set(y,A),h.push(A)}}if(r.removed)for(const d of r.removed){const y=this._breakpoints.get(d);y&&(this._breakpoints.delete(d),u.push(y))}if(r.changed){for(const d of r.changed)if(d.id){const y=this._breakpoints.get(d.id);if(y){if(y instanceof L.FunctionBreakpoint&&d.type==="function"){const A=y;A.enabled=d.enabled,A.condition=d.condition,A.hitCondition=d.hitCondition,A.logMessage=d.logMessage,A.functionName=d.functionName}else if(y instanceof L.SourceBreakpoint&&d.type==="source"){const A=y;A.enabled=d.enabled,A.condition=d.condition,A.hitCondition=d.hitCondition,A.logMessage=d.logMessage,A.location=new L.Location(m.URI.revive(d.uri),new L.Position(d.line,d.character))}c.push(y)}}}this.fireBreakpointChanges(h,u,c)}async $acceptStackFrameFocus(r){let h;const u=r.sessionId?await this.getSession(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?h=new L.ThreadFocus(u,r.threadId):h=new L.StackFrameFocus(u,r.threadId,r.frameId),this._stackFrameFocus=h,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(r,h,u){return(0,D.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.getFolder(h);return c.provideDebugConfigurations(d,u)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,h,u,c){return(0,D.asPromise)(async()=>{const d=this.getConfigProviderByHandle(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.getFolder(h);return d.resolveDebugConfiguration(y,u,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,h,u,c){return(0,D.asPromise)(async()=>{const d=this.getConfigProviderByHandle(r);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.getFolder(h);return d.resolveDebugConfigurationWithSubstitutedVariables(y,u,c)})}async $provideDebugAdapter(r,h){const u=this.getAdapterDescriptorFactoryByHandle(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.getSession(h);return this.getAdapterDescriptor(u,c).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.convertToDto(d)})}async $acceptDebugSessionStarted(r){const h=await this.getSession(r);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(r){const h=await this.getSession(r);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,h){(await this.getSession(r))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(r,h){const c={session:await this.getSession(r),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(c)}convertToDto(r){if(r instanceof L.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof L.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof L.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof L.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const h=this._adapterFactories.filter(u=>u.type===r);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(r){const h=this._adapterFactories.filter(u=>u.handle===r);if(h.length>0)return h[0].factory}getConfigProviderByHandle(r){const h=this._configProviders.filter(u=>u.handle===r);if(h.length>0)return h[0].provider}definesDebugType(r,h){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const c of u)if(c.label&&c.type&&c.type===h)return!0}}return!1}getDebugAdapterTrackers(r){const u=r.configuration.type,c=this._trackerFactories.filter(d=>d.type===u||d.type==="*").map(d=>(0,D.asPromise)(()=>d.factory.createDebugAdapterTracker(r)).then(y=>y,y=>null));return Promise.race([Promise.all(c).then(d=>{const y=d.filter(A=>!!A);if(y.length>0)return new n(y)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async getAdapterDescriptor(r,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new L.DebugAdapterServer(u));if(r){const d=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>r.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,d))).then(y=>{if(y)return y})}const c=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,c))}daExecutableFromPackage(r,h){}fireBreakpointChanges(r,h,u){(r.length>0||h.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:h,changed:u}))}async getSession(r){if(r)if(typeof r=="string"){const h=this._debugSessions.get(r);if(h)return h}else{let h=this._debugSessions.get(r.id);if(!h){const u=await this.getFolder(r.folderUri),c=r.parent?this._debugSessions.get(r.parent):void 0;h=new s(this._debugServiceProxy,r.id,r.type,r.name,u,r.configuration,c),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(r){if(r){const h=m.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=f,e.ExtHostDebugServiceBase=f=Ge([We(0,S.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,C.IExtHostConfiguration),We(4,v.IExtHostEditorTabs),We(5,l.IExtHostVariableResolverProvider)],f);class s{constructor(r,h,u,c,d,y,A){this._debugServiceProxy=r,this._id=h,this._type=u,this._name=c,this._workspaceFolder=d,this._configuration=y,this._parentSession=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,h)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=s;class i{constructor(r){this.value=Object.freeze({append(h){r.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=i;class n{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(h=>h.onError?h.onError(r):void 0)}onExit(r,h){this.trackers.forEach(u=>u.onExit?u.onExit(r,h):void 0)}}class o extends g.AbstractDebugAdapter{constructor(r){super(),this.implementation=r,r.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(r,h,u,c,d,y){super(r,h,u,c,d,y)}};e.WorkerExtHostDebugService=a,e.WorkerExtHostDebugService=a=Ge([We(0,S.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,C.IExtHostConfiguration),We(4,v.IExtHostEditorTabs),We(5,l.IExtHostVariableResolverProvider)],a)}),define(ye[365],Ce([1,0,8,56,2,6,353,14,106,107,27,248,20,66,48,90]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class f{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(v.ILogService),t=n.get(g.IExtHostRpcService).getProxy(k.MainContext.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{o.error(r);const h=D.transformErrorForSerialization(r);t.$onUnexpectedError(h)})}static async installFullHandler(n){const o=n.get(v.ILogService),a=n.get(g.IExtHostRpcService),t=n.get(C.IExtHostExtensionService),r=n.get(l.IExtHostTelemetry),h=a.getProxy(k.MainContext.MainThreadExtensionService),u=a.getProxy(k.MainContext.MainThreadErrors),c=await t.getExtensionPathIndex(),d=new WeakMap;function y(b,_){if(d.has(b))return d.get(b).stack;let T="",U,M;for(const x of _)T+=`
	at ${x.toString()}`,M=x.getFileName(),!U&&M&&(U=c.findSubstr(m.URI.file(M)));const P=`${b.name||"Error"}: ${b.message||""}${T}`;return d.set(b,{extensionIdentifier:U?.identifier,stack:P}),P}const A=Symbol("prepareStackTrace wrapped");let E=y;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return E},set(b){if(b===y||!b||b[A]){E=b||y;return}E=function(_,T){return y(_,T),b.call(Error,_,T)},Object.assign(E,{[A]:!0})}}),D.setUnexpectedErrorHandler(b=>{o.error(b);const _=D.transformErrorForSerialization(b),T=d.get(b);if(!T?.extensionIdentifier){u.$onUnexpectedError(_);return}h.$onExtensionRuntimeError(T.extensionIdentifier,_);const U=r.onExtensionError(T.extensionIdentifier,b);o.trace("forwarded error to extension?",U,T)})}}e.ErrorHandler=f;class s{constructor(n,o,a,t,r){this._hostUtils=a,this._rpcProtocol=new R.RPCProtocol(n,null,t),o=s._transform(o,this._rpcProtocol);const h=new S.ServiceCollection(...(0,p.getSingletonServiceDescriptors)());h.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...o,messagePorts:r}),h.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),h.set(w.IURITransformerService,new w.URITransformerService(t)),h.set(C.IHostUtils,a);const u=new I.InstantiationService(h,!0);u.invokeFunction(f.installEarlyHandler),this._logService=u.invokeFunction(c=>c.get(v.ILogService)),N.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",o),this._extensionService=u.invokeFunction(c=>c.get(C.IExtHostExtensionService)),this._extensionService.initialize(),u.invokeFunction(f.installFullHandler)}async asBrowserUri(n){const o=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService);return m.URI.revive(await o.$asBrowserUri(n))}terminate(n){this._extensionService.terminate(n)}static _transform(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=m.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=m.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>m.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=m.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=m.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=m.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=m.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=m.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=m.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.ExtensionHostMain=s}),define(ye[366],Ce([1,0,12,11,223,242,138,96,70,48,20,47,7,58,41,283,284,42]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let i=class extends v.ExtHostDebugServiceBase{constructor(r,h,u,c,d,y,A){super(r,h,u,c,y,A),this._terminalService=d,this._integratedTerminalInstances=new a}createDebugAdapter(r,h){switch(r.type){case"server":return new l.SocketDebugAdapter(r);case"pipeServer":return new l.NamedPipeDebugAdapter(r);case"executable":return new l.ExecutableDebugAdapter(r,h.type)}return super.createDebugAdapter(r,h)}daExecutableFromPackage(r,h){const u=l.ExecutableDebugAdapter.platformAdapterExecutable(h.getAllExtensionDescriptions(),r.type);if(u)return new g.DebugAdapterExecutable(u.command,u.args,u.options)}createSignService(){return new R.SignService}async $runInTerminal(r,h){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(P=>{this._integratedTerminalInstances.onTerminalClosed(P)}));const u=await this._configurationService.getConfigProvider(),c=this._terminalService.getDefaultShell(!0),d=this._terminalService.getDefaultShellArgs(!0),y=r.title||m.localize(0,null),A=JSON.stringify({shell:c,shellArgs:d});let E=await this._integratedTerminalInstances.checkout(A,y),b,_=!1;if(E)b=r.cwd;else{const P={shellPath:c,shellArgs:d,cwd:r.cwd,name:y,iconPath:new g.ThemeIcon("debug")};_=!0,E=this._terminalService.createTerminalFromOptions(P,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(E,A)}E.show(!0);const T=await E.processId;_?await new Promise(P=>setTimeout(P,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?E.sendText("cls"):c.indexOf("bash")>=0?E.sendText("clear"):N.isWindows?E.sendText("cls"):E.sendText("clear"));const U=(0,f.prepareCommand)(c,r.args,!!r.argsCanBeInterpretedByShell,b,r.env);E.sendText(U);const M=this.onDidTerminateDebugSession(P=>{P.id===h&&(this._integratedTerminalInstances.free(E),M.dispose())});return T}else if(r.kind==="external")return o(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,h)}};e.ExtHostDebugService=i,e.ExtHostDebugService=i=Ge([We(0,L.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,S.IExtHostExtensionService),We(3,s.IExtHostConfiguration),We(4,I.IExtHostTerminalService),We(5,p.IExtHostEditorTabs),We(6,w.IExtHostVariableResolverProvider)],i);let n;function o(t,r){if(!n)if(N.isWindows)n=new k.WindowsExternalTerminalService;else if(N.isMacintosh)n=new k.MacExternalTerminalService;else if(N.isLinux)n=new k.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},h.external||{})}class a{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(r,h){const c=[...this._terminalInstances.entries()].map(([d,y])=>(0,D.createCancelablePromise)(async A=>{if(d.name!==h||y.lastUsedAt!==-1&&await(0,f.hasChildProcesses)(await d.processId))return null;const E=Date.now();return y.lastUsedAt+a.minUseDelay>E||A.isCancellationRequested||y.config!==r?null:(y.lastUsedAt=E,d)}));return await(0,D.firstParallel)(c,d=>!!d)}insert(r,h){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:h})}free(r){const h=this._terminalInstances.get(r);h&&(h.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}}),define(ye[367],Ce([1,0,16,2,104,41,69,42,40,47,20,27,95,17,14,91,23,63,58]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let n=class extends g.ExtHostTaskBase{constructor(a,t,r,h,u,c,d,y,A){super(a,t,r,h,u,c,d,y),this.workspaceService=r,this.variableResolver=A,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(w.Schemas.file,{scheme:w.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const h=g.TaskHandleDTO.from(r,this.workspaceService),u=await this._proxy.$getTaskExecution(h);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(u,t);return this._proxy.$executeTask(h).catch(()=>{}),c}else{const h=g.TaskDTO.from(t,a);if(h===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(h.execution)&&await this.addCustomExecution(h,t,!1);const u=await this.getTaskExecution(await this._proxy.$getTaskExecution(h),t);return this._proxy.$executeTask(h).catch(()=>{}),u}}provideTasksInternal(a,t,r,h){const u=[];if(h)for(const c of h){this.checkDeprecation(c,r),(!c.definition||!a[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const d=g.TaskDTO.from(c,r.extension);d&&(u.push(d),g.CustomExecutionDTO.is(d.execution)&&t.push(this.addCustomExecution(d,c,!0)))}return{tasks:u,extension:r.extension}}async resolveTaskInternal(a){return a}async getAFolder(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=N.URI.file((0,s.homedir)());t=new p.WorkspaceFolder({uri:r,name:f.basename(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=N.URI.revive(a),h={process:void 0,variables:Object.create(null)},u=await this._workspaceProvider.resolveWorkspaceFolder(r),c=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),y=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(const A of t.variables)h.variables[A]=await d.resolveAsync(y,A);if(t.process!==void 0){let A;if(t.process.path!==void 0){A=t.process.path.split(D.delimiter);for(let E=0;E<A.length;E++)A[E]=await d.resolveAsync(y,A[E])}h.process=await m.win32.findExecutable(await d.resolveAsync(y,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(y,t.process.cwd):void 0,A)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return m.win32.findExecutable(a,t,r)}};e.ExtHostTask=n,e.ExtHostTask=n=Ge([We(0,L.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,R.IExtHostDocumentsAndEditors),We(4,v.IExtHostConfiguration),We(5,S.IExtHostTerminalService),We(6,C.ILogService),We(7,l.IExtHostApiDeprecationService),We(8,i.IExtHostVariableResolverProvider)],n)}),define(ye[368],Ce([1,0,63,58]),function(ge,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class m extends N.ExtHostVariableResolverProviderService{homeDir(){return(0,D.homedir)()}}e.NodeExtHostVariableResolverProviderService=m}),define(ye[154],Ce([1,0,19,12,21,44,17,16,23,2,36]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(i,n,o,a){this.query=i,this.provider=n,this.fileUtils=o,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(i,n){const o=this.query.folderQueries||[],a=new m.CancellationTokenSource(n);return new Promise((t,r)=>{this.collector=new w(i);let h=!1;const u=(c,d)=>{if(!h&&!this.isLimitHit){const y=this.resultSize(c);l(c)&&typeof this.query.maxResults=="number"&&this.resultCount+y>this.query.maxResults&&(this.isLimitHit=!0,h=!0,a.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const A=this.resultSize(c);this.resultCount+=A,(A>0||!l(c))&&this.collector.add(c,d)}};Promise.all(o.map((c,d)=>this.searchInFolder(c,y=>u(y,d),a.token))).then(c=>{a.dispose(),this.collector.flush();const d=c.some(y=>!!y&&!!y.limitHit);t({limitHit:this.isLimitHit||d,messages:(0,D.flatten)(c.map(y=>y?.message?Array.isArray(y.message)?y.message:[y.message]:[])),stats:{type:this.processType}})},c=>{a.dispose();const d=(0,k.toErrorMessage)(c);r(new Error(d))})})}resultSize(i){return l(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}trimResultToSize(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async searchInFolder(i,n,o){const a=new L.QueryGlobTester(this.query,i),t=[],r={report:c=>{if(!this.validateProviderResult(c))return;const d=i.folder.scheme===R.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(p.dirname(c.uri))):void 0,y=p.relativePath(i.folder,c.uri);if(y){const A=a.includedInQuery(y,v.basename(y),d);(0,N.isThenable)(A)?t.push(A.then(E=>{E&&n(c)})):A&&n(c)}}},h=this.getSearchOptionsForFolder(i),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),h,r,o);return t.length&&await Promise.all(t),u}validateProviderResult(i){if(l(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(i){const n=(0,L.resolvePatternsForProvider)(this.query.includePattern,i.includePattern),o=(0,L.resolvePatternsForProvider)(this.query.excludePattern,i.excludePattern),a={folder:S.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.fileUtils.toCanonicalName(i.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=I;function g(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(i){this._onResult=i,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new f(512,n=>this.sendItems(n))}add(i,n){this._currentFileMatch&&(this._currentFolderIdx!==n||!p.isEqual(this._currentUri,i.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=n,this._currentFileMatch={resource:i.uri,results:[]}),this._currentFileMatch.results.push(C(i))}pushToCollector(){const i=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,i)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(i){this._onResult(i)}}e.TextSearchResultsCollector=w;function C(s){return l(s)?{preview:{matches:(0,D.mapArrayOrNot)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,D.mapArrayOrNot)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function l(s){return!!s.preview}e.extensionResultIsMatch=l;class f{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(i,n){this.maxBatchSize=i,this.cb=n,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(i,n){i&&this.addItemToBatch(i,n)}addItems(i,n){i&&this.addItemsToBatch(i,n)}addItemToBatch(i,n){this.batch.push(i),this.batchSize+=n,this.onUpdate()}addItemsToBatch(i,n){this.batch=this.batch.concat(i),this.batchSize+=n,this.onUpdate()}onUpdate(){this.totalNumberCompleted<f.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},f.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=f}),define(ye[97],Ce([1,0,3,6,5,361,20,66,14,2,154]),function(ge,e,D,N,m,k,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,m.createDecorator)("IExtHostSearch");let I=class{constructor(l,f,s){this.extHostRpc=l,this._uriTransformer=f,this._logService=s,this._proxy=this.extHostRpc.getProxy(N.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new k.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,f){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const s=this._handlePool++;return this._textSearchProvider.set(s,f),this._proxy.$registerTextSearchProvider(s,this._transformScheme(l)),(0,D.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}registerFileSearchProvider(l,f){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const s=this._handlePool++;return this._fileSearchProvider.set(s,f),this._proxy.$registerFileSearchProvider(s,this._transformScheme(l)),(0,D.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(l,f,s,i){const n=g(s),o=this._fileSearchProvider.get(l);if(o)return this._fileSearchManager.fileSearch(n,o,a=>{this._proxy.$handleFileMatch(l,f,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,f,s){return{messages:[]}}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,f,s,i){const n=this._textSearchProvider.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const o=g(s);return this.createTextSearchManager(o,n).search(t=>this._proxy.$handleTextMatch(l,f,t),i)}$enableExtensionHostSearch(){}createTextSearchManager(l,f){return new L.TextSearchManager(l,f,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.ExtHostSearch=I,e.ExtHostSearch=I=Ge([We(0,R.IExtHostRpcService),We(1,v.IURITransformerService),We(2,p.ILogService)],I);function g(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(w),extraFileResources:C.extraFileResources&&C.extraFileResources.map(l=>S.URI.revive(l))}}e.reviveQuery=g;function w(C){return{...C,folder:S.URI.revive(C.folder)}}}),define(ye[369],Ce([1,0,21,8,4,3,17,39,2,132,191,172,79,26,32,14,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,149,316,317,318,294,319,69,70,320,48,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,152,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,47,339,340,285,341,299,72,15,7,342,66,343,93,345,346,151,41,281,114,25,94]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r,h,u,c,d,y,A,E,b,_,T,U,M,P,x,F,O,W,J,ce,G,X,Y,se,Q,we,he,j,z,ne,Se,de,me,Z,ie,q,te,fe,Ee,Te,ve,De,B,K,ee,H,ae,ue,Ae,xe,je,Ke,Ze,at,ot,ke,Ue,$e,Re,et,oe,le,Pe,Ve,Qe,it,st,Me,wt,Dt,Vt,Bt,St,Ht,Ot,Kt,Mt,Pt,tt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function qt(ut){const pt=ut.get(j.IExtHostInitDataService),xt=ut.get(he.IExtHostFileSystemInfo),zt=ut.get(Q.IExtHostConsumerFileSystem),yt=ut.get(Y.IExtHostExtensionService),ht=ut.get(Kt.IExtHostWorkspace),Tt=ut.get(Re.IExtHostTelemetry),Yt=ut.get(T.IExtHostConfiguration),Ct=ut.get(Dt.IURITransformerService),Xe=ut.get(Ae.IExtHostRpcService),Rt=ut.get(ke.IExtHostStorage),Wt=ut.get(Ue.IExtensionStoragePaths),Gt=ut.get(l.ILoggerService),mt=ut.get(l.ILogService),Lt=ut.get(it.IExtHostTunnelService),Le=ut.get(t.IExtHostApiDeprecationService),Ne=ut.get(Ot.IExtHostWindow),Ie=ut.get(Ke.IExtHostSecretState),re=ut.get(G.IExtHostEditorTabs),Fe=ut.get(q.IExtHostManagedSockets);Xe.set(n.ExtHostContext.ExtHostFileSystemInfo,xt),Xe.set(n.ExtHostContext.ExtHostLogLevelServiceShape,Gt),Xe.set(n.ExtHostContext.ExtHostWorkspace,ht),Xe.set(n.ExtHostContext.ExtHostConfiguration,Yt),Xe.set(n.ExtHostContext.ExtHostExtensionService,yt),Xe.set(n.ExtHostContext.ExtHostStorage,Rt),Xe.set(n.ExtHostContext.ExtHostTunnelService,Lt),Xe.set(n.ExtHostContext.ExtHostWindow,Ne),Xe.set(n.ExtHostContext.ExtHostSecretState,Ie),Xe.set(n.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(n.ExtHostContext.ExtHostEditorTabs,re),Xe.set(n.ExtHostContext.ExtHostManagedSockets,Fe);const He=Xe.set(n.ExtHostContext.ExtHostDecorations,ut.get(P.IExtHostDecorations)),Je=Xe.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(ce.IExtHostDocumentsAndEditors)),qe=Xe.set(n.ExtHostContext.ExtHostCommands,ut.get(b.IExtHostCommands)),rt=Xe.set(n.ExtHostContext.ExtHostTerminalService,ut.get(et.IExtHostTerminalService)),gt=Xe.set(n.ExtHostContext.ExtHostDebugService,ut.get(M.IExtHostDebugService)),Ut=Xe.set(n.ExtHostContext.ExtHostSearch,ut.get(je.IExtHostSearch)),_t=Xe.set(n.ExtHostContext.ExtHostTask,ut.get($e.IExtHostTask)),It=Xe.set(n.ExtHostContext.ExtHostOutputService,ut.get(K.IExtHostOutputService)),Et=Xe.set(n.ExtHostContext.ExtHostLocalization,ut.get(ie.IExtHostLocalizationService)),gi=Xe.set(n.ExtHostContext.ExtHostUrls,new Vt.ExtHostUrls(Xe)),At=Xe.set(n.ExtHostContext.ExtHostDocuments,new J.ExtHostDocuments(Xe,Je)),Ci=Xe.set(n.ExtHostContext.ExtHostDocumentContentProviders,new O.ExtHostDocumentContentProvider(Xe,Je,mt)),$i=Xe.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new W.ExtHostDocumentSaveParticipant(mt,At,Xe.getProxy(n.MainContext.MainThreadBulkEdits))),kt=Xe.set(n.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(Xe,qe,Je,At,zt,Ut)),ni=Xe.set(n.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(kt)),pi=Xe.set(n.ExtHostContext.ExtHostNotebookEditors,new ve.ExtHostNotebookEditors(mt,kt)),ai=Xe.set(n.ExtHostContext.ExtHostNotebookKernels,new De.ExtHostNotebookKernels(Xe,pt,kt,qe,mt)),Di=Xe.set(n.ExtHostContext.ExtHostNotebookRenderers,new B.ExtHostNotebookRenderers(Xe,kt)),Ii=Xe.set(n.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Ee.ExtHostNotebookDocumentSaveParticipant(mt,kt,Xe.getProxy(n.MainContext.MainThreadBulkEdits))),Ft=Xe.set(n.ExtHostContext.ExtHostEditors,new le.ExtHostEditors(Xe,Je)),vi=Xe.set(n.ExtHostContext.ExtHostTreeViews,new Qe.ExtHostTreeViews(Xe.getProxy(n.MainContext.MainThreadTreeViews),qe,mt)),ki=Xe.set(n.ExtHostContext.ExtHostEditorInsets,new E.ExtHostEditorInsets(Xe.getProxy(n.MainContext.MainThreadEditorInsets),Ft,pt.remote)),ci=Xe.set(n.ExtHostContext.ExtHostDiagnostics,new x.ExtHostDiagnostics(Xe,mt,xt,Je)),li=Xe.set(n.ExtHostContext.ExtHostLanguages,new Z.ExtHostLanguages(Xe,At,qe.converter,Ct)),dt=Xe.set(n.ExtHostContext.ExtHostLanguageFeatures,new me.ExtHostLanguageFeatures(Xe,Ct,At,qe,ci,mt,Le,Tt)),Hi=Xe.set(n.ExtHostContext.ExtHostFileSystem,new se.ExtHostFileSystem(Xe,dt)),Jt=Xe.set(n.ExtHostContext.ExtHostFileSystemEventService,new we.ExtHostFileSystemEventService(Xe,mt,Je)),ri=Xe.set(n.ExtHostContext.ExtHostQuickOpen,(0,ue.createExtHostQuickOpen)(Xe,ht,qe)),hi=Xe.set(n.ExtHostContext.ExtHostSCM,new xe.ExtHostSCM(Xe,qe,At,mt)),Pi=Xe.set(n.ExtHostContext.ExtHostQuickDiff,new ae.ExtHostQuickDiff(Xe,Ct)),Vi=Xe.set(n.ExtHostContext.ExtHostShare,new Ze.ExtHostShare(Xe,Ct)),Ti=Xe.set(n.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(Xe,qe,At)),bi=Xe.set(n.ExtHostContext.ExtHostProgress,new H.ExtHostProgress(Xe.getProxy(n.MainContext.MainThreadProgress))),ji=Xe.set(n.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(Xe)),Ai=Xe.set(n.ExtHostContext.ExtHostTheming,new Pe.ExtHostTheming(Xe)),ui=Xe.set(n.ExtHostContext.ExtHostAuthentication,new r.ExtHostAuthentication(Xe)),qi=Xe.set(n.ExtHostContext.ExtHostTimeline,new Ve.ExtHostTimeline(Xe,qe)),Ei=Xe.set(n.ExtHostContext.ExtHostWebviews,new Bt.ExtHostWebviews(Xe,pt.remote,ht,mt,Le)),Ri=Xe.set(n.ExtHostContext.ExtHostWebviewPanels,new St.ExtHostWebviewPanels(Xe,Ei,ht)),cn=Xe.set(n.ExtHostContext.ExtHostCustomEditors,new U.ExtHostCustomEditors(Xe,At,Wt,Ei,Ri)),Li=Xe.set(n.ExtHostContext.ExtHostWebviewViews,new Ht.ExtHostWebviewViews(Xe,Ei)),si=Xe.set(n.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(Xe,qe,Je)),ln=Xe.set(n.ExtHostContext.ExtHostUriOpeners,new wt.ExtHostUriOpeners(Xe)),un=Xe.set(n.ExtHostContext.ExtHostProfileContentHandlers,new ee.ExtHostProfileContentHandlers(Xe));Xe.set(n.ExtHostContext.ExtHostInteractive,new ne.ExtHostInteractive(Xe,kt,Je,qe,mt));const Gi=Xe.set(n.ExtHostContext.ExtHostInlineChat,new z.ExtHostInteractiveEditor(Xe,qe,At,mt)),fi=Xe.set(n.ExtHostContext.ExtHostChatProvider,new d.ExtHostChatProvider(Xe,mt)),Ki=Xe.set(n.ExtHostContext.ExtHostChatAgents2,new c.ExtHostChatAgents2(Xe,fi,mt)),Xi=Xe.set(n.ExtHostContext.ExtHostChatVariables,new y.ExtHostChatVariables(Xe)),mi=Xe.set(n.ExtHostContext.ExtHostChat,new u.ExtHostChat(Xe)),Qi=Xe.set(n.ExtHostContext.ExtHostAiRelatedInformation,new o.ExtHostRelatedInformation(Xe)),Oi=Xe.set(n.ExtHostContext.ExtHostAiEmbeddingVector,new X.ExtHostAiEmbeddingVector(Xe)),Fi=Xe.set(n.ExtHostContext.ExtHostIssueReporter,new Se.ExtHostIssueReporter(Xe)),Zt=Xe.set(n.ExtHostContext.ExtHostStatusBar,new ot.ExtHostStatusBar(Xe,qe.converter)),wi=Xe.set(n.ExtHostContext.ExtHostSpeech,new at.ExtHostSpeech(Xe)),dn=Object.values(n.ExtHostContext);Xe.assertRegistered(dn);const Xt=new h.ExtHostBulkEdits(Xe,Je),Si=new A.ExtHostClipboard(Xe),_i=new te.ExtHostMessageService(Xe,mt),Ni=new F.ExtHostDialogs(Xe);return a.ExtHostApiCommands.register(qe),function(ze,ei,Yi){const vt=function(){let pe=!ze.isUnderDevelopment;function _e(){pe||(mt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Be(ct){if(Array.isArray(ct))ct.forEach(Be);else if(typeof ct=="string")_e();else{const bt=ct;typeof bt.scheme>"u"&&_e(),typeof bt.exclusive=="boolean"&&(0,tt.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ct}}(),Ji={getSession(pe,_e,Be){return ui.getSession(ze,pe,_e,Be)},getSessions(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"authGetSessions"),ui.getSessions(ze,pe,_e)},async hasSession(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"authSession"),!!await ui.getSession(ze,pe,_e,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(pe,_e,Be,ct){return ui.registerAuthenticationProvider(pe,_e,Be,ct)}},hn={registerCommand(pe,_e,Be){return qe.registerCommand(!0,pe,_e,Be,void 0,ze)},registerTextEditorCommand(pe,_e,Be){return qe.registerCommand(!0,pe,(...ct)=>{const bt=Ft.getActiveTextEditor();if(!bt){mt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return bt.edit(Nt=>{_e.apply(Be,[bt,Nt,...ct])}).then(Nt=>{Nt||mt.warn("Edits from command "+pe+" were not applied.")},Nt=>{mt.warn("An error occurred while running command "+pe,Nt)})},void 0,void 0,ze)},registerDiffInformationCommand:(pe,_e,Be)=>((0,tt.checkProposedApiEnabled)(ze,"diffCommand"),qe.registerCommand(!0,pe,async(...ct)=>{const bt=Je.activeEditor(!0);if(!bt){mt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Nt=await Ft.getDiffInformation(bt.id);_e.apply(Be,[Nt,...ct])},void 0,void 0,ze)),executeCommand(pe,..._e){return qe.executeCommand(pe,..._e)},getCommands(pe=!1){return qe.getCommands(pe)}},Zi={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Si.value},get shell(){return rt.getDefaultShell(!1)},get onDidChangeShell(){return rt.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.checkProposedApiEnabled)(ze,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.checkProposedApiEnabled)(ze,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Re.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,_e){return Re.ExtHostTelemetryLogger.validateSender(pe),Tt.instantiateLogger(ze,pe,_e)},openExternal(pe,_e){return Ne.openUri(pe,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===pt.environment.appUriScheme)return gi.createAppUri(pe);try{return await Ne.asExternalUri(pe,{allowTunneling:!!pt.remote.authority})}catch(_e){if((0,R.matchesScheme)(pe,R.Schemas.http)||(0,R.matchesScheme)(pe,R.Schemas.https))return pe;throw _e}},get remoteName(){return(0,f.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,tt.checkProposedApiEnabled)(ze,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,tt.checkProposedApiEnabled)(ze,"handleIssueUri"),Fi.registerIssueUriRequestHandler(ze,pe)},registerIssueDataProvider(pe){return(0,tt.checkProposedApiEnabled)(ze,"handleIssueUri"),Fi.registerIssueDataProvider(ze,pe)},get appQuality(){return(0,tt.checkProposedApiEnabled)(ze,"resolvers"),pt.quality},get appCommit(){return(0,tt.checkProposedApiEnabled)(ze,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Zi);const en={createTestController(pe,_e,Be){return si.createTestController(ze,pe,_e,Be)},createTestObserver(){return(0,tt.checkProposedApiEnabled)(ze,"testObserver"),si.createTestObserver()},runTests(pe){return(0,tt.checkProposedApiEnabled)(ze,"testObserver"),si.runTests(pe)},get onDidChangeTestResults(){return(0,tt.checkProposedApiEnabled)(ze,"testObserver"),si.onResultsChanged},get testResults(){return(0,tt.checkProposedApiEnabled)(ze,"testObserver"),si.results}},di=pt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,tn={getExtension(pe,_e){(0,tt.isProposedApiEnabled)(ze,"extensionsAny")||(_e=!1);const Be=ei.mine.getExtensionDescription(pe);if(Be)return new Y.Extension(yt,ze.identifier,Be,di,!1);if(_e){const ct=ei.all.getExtensionDescription(pe);if(ct)return new Y.Extension(yt,ze.identifier,ct,di,!0)}},get all(){const pe=[];for(const _e of ei.mine.getAllExtensionDescriptions())pe.push(new Y.Extension(yt,ze.identifier,_e,di,!1));return pe},get allAcrossExtensionHosts(){(0,tt.checkProposedApiEnabled)(ze,"extensionsAny");const pe=new w.ExtensionIdentifierSet(ei.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),_e=[];for(const Be of ei.all.getAllExtensionDescriptions()){const ct=!pe.has(Be.identifier);_e.push(new Y.Extension(yt,ze.identifier,Be,di,ct))}return _e},get onDidChange(){return(0,tt.isProposedApiEnabled)(ze,"extensionsAny")?m.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(pe){return ci.createDiagnosticCollection(ze.identifier,pe)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:pe=>ci.getDiagnostics(pe),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(pe,_e){return li.changeLanguage(pe.uri,_e)},match(pe,_e){const Be=At.getDocumentData(_e.uri)?.notebook;return(0,L.score)(st.LanguageSelector.from(pe),_e.uri,_e.languageId,!0,Be?.uri,Be?.notebookType)},registerCodeActionsProvider(pe,_e,Be){return dt.registerCodeActionProvider(ze,vt(pe),_e,Be)},registerDocumentPasteEditProvider(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"documentPaste"),dt.registerDocumentPasteEditProvider(ze,vt(pe),_e,Be)},registerCodeLensProvider(pe,_e){return dt.registerCodeLensProvider(ze,vt(pe),_e)},registerDefinitionProvider(pe,_e){return dt.registerDefinitionProvider(ze,vt(pe),_e)},registerDeclarationProvider(pe,_e){return dt.registerDeclarationProvider(ze,vt(pe),_e)},registerImplementationProvider(pe,_e){return dt.registerImplementationProvider(ze,vt(pe),_e)},registerTypeDefinitionProvider(pe,_e){return dt.registerTypeDefinitionProvider(ze,vt(pe),_e)},registerHoverProvider(pe,_e){return dt.registerHoverProvider(ze,vt(pe),_e,ze.identifier)},registerEvaluatableExpressionProvider(pe,_e){return dt.registerEvaluatableExpressionProvider(ze,vt(pe),_e,ze.identifier)},registerInlineValuesProvider(pe,_e){return dt.registerInlineValuesProvider(ze,vt(pe),_e,ze.identifier)},registerDocumentHighlightProvider(pe,_e){return dt.registerDocumentHighlightProvider(ze,vt(pe),_e)},registerMultiDocumentHighlightProvider(pe,_e){return dt.registerMultiDocumentHighlightProvider(ze,vt(pe),_e)},registerLinkedEditingRangeProvider(pe,_e){return dt.registerLinkedEditingRangeProvider(ze,vt(pe),_e)},registerReferenceProvider(pe,_e){return dt.registerReferenceProvider(ze,vt(pe),_e)},registerRenameProvider(pe,_e){return dt.registerRenameProvider(ze,vt(pe),_e)},registerDocumentSymbolProvider(pe,_e,Be){return dt.registerDocumentSymbolProvider(ze,vt(pe),_e,Be)},registerWorkspaceSymbolProvider(pe){return dt.registerWorkspaceSymbolProvider(ze,pe)},registerDocumentFormattingEditProvider(pe,_e){return dt.registerDocumentFormattingEditProvider(ze,vt(pe),_e)},registerDocumentRangeFormattingEditProvider(pe,_e){return dt.registerDocumentRangeFormattingEditProvider(ze,vt(pe),_e)},registerOnTypeFormattingEditProvider(pe,_e,Be,...ct){return dt.registerOnTypeFormattingEditProvider(ze,vt(pe),_e,[Be].concat(ct))},registerDocumentSemanticTokensProvider(pe,_e,Be){return dt.registerDocumentSemanticTokensProvider(ze,vt(pe),_e,Be)},registerDocumentRangeSemanticTokensProvider(pe,_e,Be){return dt.registerDocumentRangeSemanticTokensProvider(ze,vt(pe),_e,Be)},registerSignatureHelpProvider(pe,_e,Be,...ct){return typeof Be=="object"?dt.registerSignatureHelpProvider(ze,vt(pe),_e,Be):dt.registerSignatureHelpProvider(ze,vt(pe),_e,typeof Be>"u"?[]:[Be,...ct])},registerCompletionItemProvider(pe,_e,...Be){return dt.registerCompletionItemProvider(ze,vt(pe),_e,Be)},registerInlineCompletionItemProvider(pe,_e,Be){return _e.handleDidShowCompletionItem&&(0,tt.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),_e.handleDidPartiallyAcceptCompletionItem&&(0,tt.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),Be&&(0,tt.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(ze,vt(pe),_e,Be)},registerDocumentLinkProvider(pe,_e){return dt.registerDocumentLinkProvider(ze,vt(pe),_e)},registerColorProvider(pe,_e){return dt.registerColorProvider(ze,vt(pe),_e)},registerFoldingRangeProvider(pe,_e){return dt.registerFoldingRangeProvider(ze,vt(pe),_e)},registerSelectionRangeProvider(pe,_e){return dt.registerSelectionRangeProvider(ze,pe,_e)},registerCallHierarchyProvider(pe,_e){return dt.registerCallHierarchyProvider(ze,pe,_e)},registerTypeHierarchyProvider(pe,_e){return dt.registerTypeHierarchyProvider(ze,pe,_e)},setLanguageConfiguration:(pe,_e)=>dt.setLanguageConfiguration(ze,pe,_e),getTokenInformationAtPosition(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"tokenInformation"),li.tokenAtPosition(pe,_e)},registerInlayHintsProvider(pe,_e){return dt.registerInlayHintsProvider(ze,pe,_e)},createLanguageStatusItem(pe,_e){return li.createLanguageStatusItem(ze,pe,_e)},registerDocumentDropEditProvider(pe,_e,Be){return dt.registerDocumentOnDropEditProvider(ze,pe,_e,(0,tt.isProposedApiEnabled)(ze,"dropMetadata")?Be:void 0)}},rn={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return rt.activeTerminal},get terminals(){return rt.terminals},async showTextDocument(pe,_e,Be){const ct=await(p.URI.isUri(pe)?Promise.resolve(sn.openTextDocument(pe)):Promise.resolve(pe));return Ft.showTextDocument(ct,_e,Be)},createTextEditorDecorationType(pe){return Ft.createTextEditorDecorationType(ze,pe)},onDidChangeActiveTextEditor(pe,_e,Be){return Ft.onDidChangeActiveTextEditor(pe,_e,Be)},onDidChangeVisibleTextEditors(pe,_e,Be){return Ft.onDidChangeVisibleTextEditors(pe,_e,Be)},onDidChangeTextEditorSelection(pe,_e,Be){return Ft.onDidChangeTextEditorSelection(pe,_e,Be)},onDidChangeTextEditorOptions(pe,_e,Be){return Ft.onDidChangeTextEditorOptions(pe,_e,Be)},onDidChangeTextEditorVisibleRanges(pe,_e,Be){return Ft.onDidChangeTextEditorVisibleRanges(pe,_e,Be)},onDidChangeTextEditorViewColumn(pe,_e,Be){return Ft.onDidChangeTextEditorViewColumn(pe,_e,Be)},onDidCloseTerminal(pe,_e,Be){return rt.onDidCloseTerminal(pe,_e,Be)},onDidOpenTerminal(pe,_e,Be){return rt.onDidOpenTerminal(pe,_e,Be)},onDidChangeActiveTerminal(pe,_e,Be){return rt.onDidChangeActiveTerminal(pe,_e,Be)},onDidChangeTerminalDimensions(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"terminalDimensions"),rt.onDidChangeTerminalDimensions(pe,_e,Be)},onDidChangeTerminalState(pe,_e,Be){return rt.onDidChangeTerminalState(pe,_e,Be)},onDidWriteTerminalData(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),rt.onDidWriteTerminalData(pe,_e,Be)},onDidExecuteTerminalCommand(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"terminalExecuteCommandEvent"),rt.onDidExecuteTerminalCommand(pe,_e,Be)},get state(){return Ne.getState(ze)},onDidChangeWindowState(pe,_e,Be){return Ne.onDidChangeWindowState(pe,_e,Be)},showInformationMessage(pe,..._e){return _i.showMessage(ze,v.default.Info,pe,_e[0],_e.slice(1))},showWarningMessage(pe,..._e){return _i.showMessage(ze,v.default.Warning,pe,_e[0],_e.slice(1))},showErrorMessage(pe,..._e){return _i.showMessage(ze,v.default.Error,pe,_e[0],_e.slice(1))},showQuickPick(pe,_e,Be){return ri.showQuickPick(ze,pe,_e,Be)},showWorkspaceFolderPick(pe){return ri.showWorkspaceFolderPick(pe)},showInputBox(pe,_e){return ri.showInput(pe,_e)},showOpenDialog(pe){return Ni.showOpenDialog(ze,pe)},showSaveDialog(pe){return Ni.showSaveDialog(pe)},createStatusBarItem(pe,_e,Be){let ct,bt,Nt;return typeof pe=="string"?(ct=pe,bt=_e,Nt=Be):(bt=pe,Nt=_e),Zt.createStatusBarEntry(ze,ct,bt,Nt)},setStatusBarMessage(pe,_e){return Zt.setStatusBarMessage(pe,_e)},withScmProgress(pe){return Le.report("window.withScmProgress",ze,"Use 'withProgress' instead."),bi.withProgress(ze,{location:Me.ProgressLocation.SourceControl},(_e,Be)=>pe({report(ct){}}))},withProgress(pe,_e){return bi.withProgress(ze,pe,_e)},createOutputChannel(pe,_e){return It.createOutputChannel(pe,_e,ze)},createWebviewPanel(pe,_e,Be,ct){return Ri.createWebviewPanel(ze,pe,_e,Be,ct)},createWebviewTextEditorInset(pe,_e,Be,ct){return(0,tt.checkProposedApiEnabled)(ze,"editorInsets"),ki.createWebviewEditorInset(pe,_e,Be,ct,ze)},createTerminal(pe,_e,Be){return typeof pe=="object"?"pty"in pe?rt.createExtensionTerminal(pe):rt.createTerminalFromOptions(pe):rt.createTerminal(pe,_e,Be)},registerTerminalLinkProvider(pe){return rt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,_e){return rt.registerProfileProvider(ze,pe,_e)},registerTerminalQuickFixProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),rt.registerTerminalQuickFixProvider(pe,ze.identifier.value,_e)},registerTreeDataProvider(pe,_e){return vi.registerTreeDataProvider(pe,_e,ze)},createTreeView(pe,_e){return vi.createTreeView(pe,_e,ze)},registerWebviewPanelSerializer:(pe,_e)=>Ri.registerWebviewPanelSerializer(ze,pe,_e),registerCustomEditorProvider:(pe,_e,Be={})=>cn.registerCustomEditorProvider(ze,pe,_e,Be),registerFileDecorationProvider(pe){return He.registerFileDecorationProvider(pe,ze)},registerUriHandler(pe){return gi.registerUriHandler(ze,pe)},createQuickPick(){return ri.createQuickPick(ze)},createInputBox(){return ri.createInputBox(ze)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(pe,_e,Be){return Ai.onDidChangeActiveColorTheme(pe,_e,Be)},registerWebviewViewProvider(pe,_e,Be){return Li.registerWebviewViewProvider(ze,pe,_e,Be?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,_e,Be){return kt.onDidChangeActiveNotebookEditor(pe,_e,Be)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,_e,Be){return pi.onDidChangeNotebookEditorSelection(pe,_e,Be)},onDidChangeNotebookEditorVisibleRanges(pe,_e,Be){return pi.onDidChangeNotebookEditorVisibleRanges(pe,_e,Be)},showNotebookDocument(pe,_e){return kt.showNotebookDocument(pe,_e)},registerExternalUriOpener(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"externalUriOpener"),ln.registerExternalUriOpener(ze.identifier,pe,_e,Be)},registerProfileContentHandler(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"profileContentHandlers"),un.registrProfileContentHandler(ze,pe,_e)},registerQuickDiffProvider(pe,_e,Be,ct){return(0,tt.checkProposedApiEnabled)(ze,"quickDiffProvider"),Pi.registerQuickDiffProvider(vt(pe),_e,Be,ct)},get tabGroups(){return re.tabGroups},registerShareProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"shareProvider"),Vi.registerShareProvider(vt(pe),_e)}},sn={get rootPath(){return Le.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(pe){throw new N.ReadonlyError("rootPath")},getWorkspaceFolder(pe){return ht.getWorkspaceFolder(pe)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(pe){throw new N.ReadonlyError("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(pe){throw new N.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(pe,_e,...Be)=>ht.updateWorkspaceFolders(ze,pe,_e||0,...Be),onDidChangeWorkspaceFolders:function(pe,_e,Be){return ht.onDidChangeWorkspace(pe,_e,Be)},asRelativePath:(pe,_e)=>ht.getRelativePath(pe,_e),findFiles:(pe,_e,Be,ct)=>ht.findFiles(pe,_e,Be,ze.identifier,ct),findTextInFiles:(pe,_e,Be,ct)=>{(0,tt.checkProposedApiEnabled)(ze,"findTextInFiles");let bt,Nt;return typeof _e=="object"?(bt=_e,Nt=Be):(bt={},Nt=_e,ct=Be),ht.findTextInFiles(pe,bt||{},Nt,ze.identifier,ct)},save:pe=>((0,tt.checkProposedApiEnabled)(ze,"saveEditor"),ht.save(pe)),saveAs:pe=>((0,tt.checkProposedApiEnabled)(ze,"saveEditor"),ht.saveAs(pe)),saveAll:pe=>ht.saveAll(pe),applyEdit(pe,_e){return Xt.applyWorkspaceEdit(pe,ze,_e)},createFileSystemWatcher:(pe,_e,Be,ct)=>{let bt;return typeof _e=="boolean"?bt={ignoreCreateEvents:!!_e,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ct,correlate:!1}:_e&&((0,tt.checkProposedApiEnabled)(ze,"createFileSystemWatcher"),bt={..._e,correlate:!0}),Jt.createFileSystemWatcher(ht,ze,pe,bt)},get textDocuments(){return At.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new N.ReadonlyError("textDocuments")},openTextDocument(pe){let _e;const Be=pe;if(typeof pe=="string")_e=Promise.resolve(p.URI.file(pe));else if(p.URI.isUri(pe))_e=Promise.resolve(pe);else if(!Be||typeof Be=="object")_e=At.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(ct=>At.ensureDocumentData(ct).then(bt=>bt.document))},onDidOpenTextDocument:(pe,_e,Be)=>At.onDidAddDocument(pe,_e,Be),onDidCloseTextDocument:(pe,_e,Be)=>At.onDidRemoveDocument(pe,_e,Be),onDidChangeTextDocument:(pe,_e,Be)=>At.onDidChangeDocument(pe,_e,Be),onDidSaveTextDocument:(pe,_e,Be)=>At.onDidSaveDocument(pe,_e,Be),onWillSaveTextDocument:(pe,_e,Be)=>$i.getOnWillSaveTextDocumentEvent(ze)(pe,_e,Be),get notebookDocuments(){return kt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,_e){let Be;if(p.URI.isUri(pe))Be=pe,await kt.openNotebookDocument(pe);else if(typeof pe=="string")Be=p.URI.revive(await kt.createNotebookDocument({viewType:pe,content:_e}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(pe,_e,Be){return ni.onDidSaveNotebookDocument(pe,_e,Be)},onDidChangeNotebookDocument(pe,_e,Be){return ni.onDidChangeNotebookDocument(pe,_e,Be)},onWillSaveNotebookDocument(pe,_e,Be){return Ii.getOnWillSaveNotebookDocumentEvent(ze)(pe,_e,Be)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,_e,Be,ct){return kt.registerNotebookSerializer(ze,pe,_e,Be,(0,tt.isProposedApiEnabled)(ze,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(pe,_e,Be)=>Yi.onDidChangeConfiguration(pe,_e,Be),getConfiguration(pe,_e){return _e=arguments.length===1?void 0:_e,Yi.getConfiguration(pe,_e,ze)},registerTextDocumentContentProvider(pe,_e){return Ci.registerTextDocumentContentProvider(pe,_e)},registerTaskProvider:(pe,_e)=>(Le.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(ze,pe,_e)),registerFileSystemProvider(pe,_e,Be){return(0,k.combinedDisposable)(Hi.registerFileSystemProvider(ze,pe,_e,Be),zt.addFileSystemProvider(pe,_e,Be))},get fs(){return zt.value},registerFileSearchProvider:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"fileSearchProvider"),Ut.registerFileSearchProvider(pe,_e)),registerTextSearchProvider:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"textSearchProvider"),Ut.registerTextSearchProvider(pe,_e)),registerRemoteAuthorityResolver:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"resolvers"),yt.registerRemoteAuthorityResolver(pe,_e)),registerResourceLabelFormatter:pe=>((0,tt.checkProposedApiEnabled)(ze,"resolvers"),ji.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,tt.checkProposedApiEnabled)(ze,"resolvers"),yt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,_e,Be)=>Jt.onDidCreateFile(pe,_e,Be),onDidDeleteFiles:(pe,_e,Be)=>Jt.onDidDeleteFile(pe,_e,Be),onDidRenameFiles:(pe,_e,Be)=>Jt.onDidRenameFile(pe,_e,Be),onWillCreateFiles:(pe,_e,Be)=>Jt.getOnWillCreateFileEvent(ze)(pe,_e,Be),onWillDeleteFiles:(pe,_e,Be)=>Jt.getOnWillDeleteFileEvent(ze)(pe,_e,Be),onWillRenameFiles:(pe,_e,Be)=>Jt.getOnWillRenameFileEvent(ze)(pe,_e,Be),openTunnel:pe=>((0,tt.checkProposedApiEnabled)(ze,"tunnels"),Lt.openTunnel(ze,pe).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,tt.checkProposedApiEnabled)(ze,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(pe,_e,Be)=>((0,tt.checkProposedApiEnabled)(ze,"tunnels"),Lt.onDidChangeTunnels(pe,_e,Be)),registerPortAttributesProvider:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"portsAttributes"),Lt.registerPortsAttributesProvider(pe,_e)),registerTunnelProvider:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"tunnelFactory"),Lt.registerTunnelProvider(pe,_e)),registerTimelineProvider:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"timeline"),qi.registerTimelineProvider(pe,_e,ze.identifier,qe.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:pe=>((0,tt.checkProposedApiEnabled)(ze,"workspaceTrust"),ht.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,_e,Be)=>ht.onDidGrantWorkspaceTrust(pe,_e,Be),registerEditSessionIdentityProvider:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(pe,_e)),onWillCreateEditSessionIdentity:(pe,_e,Be)=>((0,tt.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(ze)(pe,_e,Be)),registerCanonicalUriProvider:(pe,_e)=>((0,tt.checkProposedApiEnabled)(ze,"canonicalUriProvider"),ht.registerCanonicalUriProvider(pe,_e)),getCanonicalUri:(pe,_e,Be)=>((0,tt.checkProposedApiEnabled)(ze,"canonicalUriProvider"),ht.provideCanonicalUri(pe,_e,Be))},fn={get inputBox(){return Le.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(ze)},createSourceControl(pe,_e,Be){return hi.createSourceControl(ze,pe,_e,Be)},registerSourceControlInputBoxValueProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"scmInputBoxValueProvider"),hi.registerSourceControlInputBoxValueProvider(ze,pe,_e)}},on={createCommentController(pe,_e){return Ti.createCommentController(ze,pe,_e)}},an={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(pe,_e,Be){return gt.onDidStartDebugSession(pe,_e,Be)},onDidTerminateDebugSession(pe,_e,Be){return gt.onDidTerminateDebugSession(pe,_e,Be)},onDidChangeActiveDebugSession(pe,_e,Be){return gt.onDidChangeActiveDebugSession(pe,_e,Be)},onDidReceiveDebugSessionCustomEvent(pe,_e,Be){return gt.onDidReceiveDebugSessionCustomEvent(pe,_e,Be)},onDidChangeBreakpoints(pe,_e,Be){return gt.onDidChangeBreakpoints(pe,_e,Be)},onDidChangeStackFrameFocus(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"debugFocus"),gt.onDidChangeStackFrameFocus(pe,_e,Be)},registerDebugConfigurationProvider(pe,_e,Be){return gt.registerDebugConfigurationProvider(pe,_e,Be||Mt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,_e){return gt.registerDebugAdapterDescriptorFactory(ze,pe,_e)},registerDebugAdapterTrackerFactory(pe,_e){return gt.registerDebugAdapterTrackerFactory(pe,_e)},startDebugging(pe,_e,Be){return!Be||typeof Be=="object"&&"configuration"in Be?gt.startDebugging(pe,_e,{parentSession:Be}):gt.startDebugging(pe,_e,Be||{})},stopDebugging(pe){return gt.stopDebugging(pe)},addBreakpoints(pe){return gt.addBreakpoints(pe)},removeBreakpoints(pe){return gt.removeBreakpoints(pe)},asDebugSourceUri(pe,_e){return gt.asDebugSourceUri(pe,_e)}},Mi={registerTaskProvider:(pe,_e)=>_t.registerTaskProvider(ze,pe,_e),fetchTasks:pe=>_t.fetchTasks(pe),executeTask:pe=>_t.executeTask(ze,pe),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(pe,_e,Be)=>_t.onDidStartTask(pe,_e,Be),onDidEndTask:(pe,_e,Be)=>_t.onDidEndTask(pe,_e,Be),onDidStartTaskProcess:(pe,_e,Be)=>_t.onDidStartTaskProcess(pe,_e,Be),onDidEndTaskProcess:(pe,_e,Be)=>_t.onDidEndTaskProcess(pe,_e,Be)},xi={createNotebookController(pe,_e,Be,ct,bt){return ai.createNotebookController(ze,pe,_e,Be,ct,(0,tt.isProposedApiEnabled)(ze,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,_e)=>kt.registerNotebookCellStatusBarItemProvider(ze,pe,_e),createRendererMessaging(pe){return Di.createRendererMessaging(ze,pe)},createNotebookControllerDetectionTask(pe){return(0,tt.checkProposedApiEnabled)(ze,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(ze,pe)},registerKernelSourceActionProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"notebookKernelSource"),ai.registerKernelSourceActionProvider(ze,pe,_e)},onDidChangeNotebookCellExecutionState(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(pe,_e,Be)}},Ui={t(...pe){if(typeof pe[0]=="string"){const _e=pe.shift(),Be=!pe||typeof pe[0]!="object"?pe:pe[0];return Et.getMessage(ze.identifier.value,{message:_e,args:Be})}return Et.getMessage(ze.identifier.value,pe[0])},get bundle(){return Et.getBundle(ze.identifier.value)},get uri(){return Et.getBundleUri(ze.identifier.value)}},yi={_version:1,registerInteractiveEditorSessionProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"interactive"),Gi.registerProvider(ze,pe,_e)},registerInteractiveSessionProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"interactive"),mi.registerChatProvider(ze,pe,_e)},sendInteractiveRequestToProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"interactive"),mi.sendInteractiveRequestToProvider(pe,_e)},get onDidPerformUserAction(){return(0,tt.checkProposedApiEnabled)(ze,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"interactive"),mi.transferChatSession(pe,_e)}},Bi={getRelatedInformation(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"aiRelatedInformation"),Qi.getRelatedInformation(ze,pe,_e)},registerRelatedInformationProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(ze,pe,_e)},registerEmbeddingVectorProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"aiRelatedInformation"),Oi.registerEmbeddingVectorProvider(ze,pe,_e)}},mn={registerChatResponseProvider(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"chatProvider"),fi.registerProvider(ze.identifier,pe,_e,Be)},requestChatAccess(pe){return(0,tt.checkProposedApiEnabled)(ze,"chatRequestAccess"),fi.requestChatResponseProvider(ze.identifier,pe)},registerVariable(pe,_e,Be){return(0,tt.checkProposedApiEnabled)(ze,"chatVariables"),Xi.registerVariableResolver(ze,pe,_e,Be)},registerMappedEditsProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"mappedEditsProvider"),dt.registerMappedEditsProvider(ze,pe,_e)},createChatAgent(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"chatAgents2"),Ki.createChatAgent(ze,pe,_e)}},gn={registerSpeechProvider(pe,_e){return(0,tt.checkProposedApiEnabled)(ze,"speech"),wi.registerProvider(ze.identifier,pe,_e)}};return{version:pt.version,ai:Bi,authentication:Ji,commands:hn,comments:on,chat:mn,debug:an,env:Zi,extensions:tn,interactive:yi,l10n:Ui,languages:nn,notebooks:xi,scm:fn,speech:gn,tasks:Mi,tests:en,window:rn,workspace:sn,Breakpoint:Me.Breakpoint,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Me.ChatAgentResultFeedbackKind,ChatMessage:Me.ChatMessage,ChatMessageRole:Me.ChatMessageRole,ChatVariableLevel:Me.ChatVariableLevel,ChatAgentCompletionItem:Me.ChatAgentCompletionItem,CallHierarchyIncomingCall:Me.CallHierarchyIncomingCall,CallHierarchyItem:Me.CallHierarchyItem,CallHierarchyOutgoingCall:Me.CallHierarchyOutgoingCall,CancellationError:N.CancellationError,CancellationTokenSource:D.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:Me.CodeAction,CodeActionKind:Me.CodeActionKind,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.CodeLens,Color:Me.Color,ColorInformation:Me.ColorInformation,ColorPresentation:Me.ColorPresentation,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CompletionItem:Me.CompletionItem,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.CompletionList,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.CustomExecution,DebugAdapterExecutable:Me.DebugAdapterExecutable,DebugAdapterInlineImplementation:Me.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Me.DebugAdapterNamedPipeServer,DebugAdapterServer:Me.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Mt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.Diagnostic,DiagnosticRelatedInformation:Me.DiagnosticRelatedInformation,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.Disposable,DocumentHighlight:Me.DocumentHighlight,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.MultiDocumentHighlight,DocumentLink:Me.DocumentLink,DocumentSymbol:Me.DocumentSymbol,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.EvaluatableExpression,InlineValueText:Me.InlineValueText,InlineValueVariableLookup:Me.InlineValueVariableLookup,InlineValueEvaluatableExpression:Me.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:m.Emitter,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.FileDecoration,FileDecoration2:Me.FileDecoration,FileSystemError:Me.FileSystemError,FileType:C.FileType,FilePermission:C.FilePermission,FoldingRange:Me.FoldingRange,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.FunctionBreakpoint,InlineCompletionItem:Me.InlineSuggestion,InlineCompletionList:Me.InlineSuggestionList,Hover:Me.Hover,IndentAction:I.IndentAction,Location:Me.Location,MarkdownString:Me.MarkdownString,OverviewRulerLane:g.OverviewRulerLane,ParameterInformation:Me.ParameterInformation,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.Position,ProcessExecution:Me.ProcessExecution,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.QuickInputButtons,Range:Me.Range,RelativePattern:Me.RelativePattern,Selection:Me.Selection,SelectionRange:Me.SelectionRange,SemanticTokens:Me.SemanticTokens,SemanticTokensBuilder:Me.SemanticTokensBuilder,SemanticTokensEdit:Me.SemanticTokensEdit,SemanticTokensEdits:Me.SemanticTokensEdits,SemanticTokensLegend:Me.SemanticTokensLegend,ShellExecution:Me.ShellExecution,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.SignatureHelp,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.SignatureInformation,SnippetString:Me.SnippetString,SourceBreakpoint:Me.SourceBreakpoint,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.SymbolInformation,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.Task,TaskGroup:Me.TaskGroup,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.TerminalLink,TerminalQuickFixTerminalCommand:Me.TerminalQuickFixCommand,TerminalQuickFixOpener:Me.TerminalQuickFixOpener,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.TerminalProfile,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.TextEdit,SnippetTextEdit:Me.SnippetTextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.ThemeColor,ThemeIcon:Me.ThemeIcon,TreeItem:Me.TreeItem,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.TypeHierarchyItem,UIKind:Pt.UIKind,Uri:p.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.WorkspaceEdit,DocumentDropEdit:Me.DocumentDropEdit,DocumentPasteEdit:Me.DocumentPasteEdit,InlayHint:Me.InlayHint,InlayHintLabelPart:Me.InlayHintLabelPart,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.RemoteAuthorityResolverError,ResolvedAuthority:Me.ResolvedAuthority,ManagedResolvedAuthority:Me.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.TimelineItem,NotebookRange:Me.NotebookRange,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.NotebookCellData,NotebookData:Me.NotebookData,NotebookRendererScript:Me.NotebookRendererScript,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.NotebookCellOutput,NotebookCellOutputItem:Me.NotebookCellOutputItem,NotebookCellStatusBarItem:Me.NotebookCellStatusBarItem,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.NotebookEdit,NotebookKernelSourceAction:Me.NotebookKernelSourceAction,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.PortAttributes,LinkedEditingRanges:Me.LinkedEditingRanges,TestResultState:Me.TestResultState,TestRunRequest:Me.TestRunRequest,TestMessage:Me.TestMessage,TestMessage2:Me.TestMessage,TestTag:Me.TestTag,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:Me.DataTransfer,DataTransferItem:Me.DataTransferItem,CoveredCount:Me.CoveredCount,FileCoverage:Me.FileCoverage,StatementCoverage:Me.StatementCoverage,BranchCoverage:Me.BranchCoverage,FunctionCoverage:Me.FunctionCoverage,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.TextTabInput,TabInputTextDiff:Me.TextDiffTabInput,TabInputTextMerge:Me.TextMergeTabInput,TabInputCustom:Me.CustomEditorTabInput,TabInputNotebook:Me.NotebookEditorTabInput,TabInputNotebookDiff:Me.NotebookDiffEditorTabInput,TabInputWebview:Me.WebviewEditorTabInput,TabInputTerminal:Me.TerminalEditorTabInput,TabInputInteractiveWindow:Me.InteractiveWindowInput,TabInputChat:Me.ChatEditorTabInput,TelemetryTrustedValue:s.TelemetryTrustedValue,LogLevel:l.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Me.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Me.StackFrameFocus,ThreadFocus:Me.ThreadFocus,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus}}}e.createApiFactoryAndRegisterActors=qt}),define(ye[370],Ce([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,57,117,90,70,150,14,58,115,116]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.registerSingleton)(u.IExtHostLocalizationService,u.ExtHostLocalizationService,1),(0,D.registerSingleton)(r.ILoggerService,t.ExtHostLoggerService,1),(0,D.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,1),(0,D.registerSingleton)(v.IExtHostCommands,v.ExtHostCommands,0),(0,D.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,D.registerSingleton)(s.IExtHostConsumerFileSystem,s.ExtHostConsumerFileSystem,0),(0,D.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,D.registerSingleton)(k.IExtHostDecorations,k.ExtHostDecorations,0),(0,D.registerSingleton)(p.IExtHostDocumentsAndEditors,p.ExtHostDocumentsAndEditors,0),(0,D.registerSingleton)(c.IExtHostManagedSockets,c.ExtHostManagedSockets,0),(0,D.registerSingleton)(i.IExtHostFileSystemInfo,i.ExtHostFileSystemInfo,0),(0,D.registerSingleton)(N.IExtHostOutputService,N.ExtHostOutputService,1),(0,D.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,0),(0,D.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage,0),(0,D.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,D.registerSingleton)(S.IExtHostTerminalService,S.WorkerExtHostTerminalService,0),(0,D.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,D.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow,0),(0,D.registerSingleton)(m.IExtHostWorkspace,m.ExtHostWorkspace,0),(0,D.registerSingleton)(n.IExtHostSecretState,n.ExtHostSecretState,0),(0,D.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry,0),(0,D.registerSingleton)(a.IExtHostEditorTabs,a.ExtHostEditorTabs,0),(0,D.registerSingleton)(h.IExtHostVariableResolverProvider,h.ExtHostVariableResolverProviderService,0)}),define(ye[119],Ce([1,0,19,14,36,94]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=R;function v(I,g,w,C){const l=(0,D.mapArrayOrNot)(w,p),f=new m.TextSearchMatch(g,l,C),s=f.preview.matches;return{ranges:(0,D.mapArrayOrNot)(l,S),uri:I,preview:{text:f.preview.text,matches:(0,D.mapArrayOrNot)(s,S)}}}e.createTextSearchResult=v;function p(I){return new m.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function S(I){return new k.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=class{constructor(g,w){this.prefix=g,this.logService=w}appendLine(g){this.logService.debug(`${this.prefix}#search`,g)}};e.OutputChannel=L,e.OutputChannel=L=Ge([We(1,N.ILogService)],L)}),define(ye[371],Ce([1,0,51,16,76,33,11,13,119,372]),function(ge,e,D,N,m,k,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(n,o,a,t){const r=g(n,o,a,t),h=o.folder.fsPath;return{cmd:D.spawn(L,r.args,{cwd:h}),rgDiskPath:L,siblingClauses:r.siblingClauses,rgArgs:r,cwd:h}}e.spawnRipgrepCmd=I;function g(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];C([o],a,!1).forEach(u=>{const c=(0,p.anchorGlob)(u);if(r.push("-g",c),R.isMacintosh){const d=(0,m.normalizeNFD)(c);d!==c&&r.push("-g",d)}});const h=w([o],t,void 0,!1);return h.globArgs.forEach(u=>{const c=`!${(0,p.anchorGlob)(u)}`;if(r.push("-g",c),R.isMacintosh){const d=(0,m.normalizeNFD)(c);d!==c&&r.push("-g",d)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:h.siblingClauses}}function w(n,o,a,t=!0){const r=[];let h={};return n.forEach(u=>{const c=Object.assign({},u.excludePattern||{},o||{}),d=l(c,t?u.folder.fsPath:void 0,a);r.push(...d.globArgs),d.siblingClauses&&(h=Object.assign(h,d.siblingClauses))}),{globArgs:r,siblingClauses:h}}function C(n,o,a=!0){const t=[];return n.forEach(r=>{const h=Object.assign({},o||{},r.includePattern||{}),u=l(h,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function l(n,o,a){const t=[],r={};return Object.keys(n).forEach(h=>{if(a&&a.has(h)||!h)return;const u=n[h];h=s(o?f(o,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof u=="boolean"&&u?(h.startsWith("\\\\")&&(h+="**"),t.push(i(h))):u&&u.when&&(r[h]=u)}),{globArgs:t,siblingClauses:r}}function f(n,o){return N.isAbsolute(o)?o:N.join(n,o)}e.getAbsoluteGlob=f;function s(n){return n=v.rtrim(n,"\\"),v.rtrim(n,"/")}function i(n){return k.getRoot(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.fixDriveC=i}),define(ye[373],Ce([1,0,51,55,16,374,19,44,34,76,33,11,38,13,18,31,36,371,129]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class o{constructor(u){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=u,this.filePattern=u.filePattern||"",this.includePattern=u.includePattern&&p.parse(u.includePattern),this.maxResults=u.maxResults||null,this.exists=!!u.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,i.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=u.excludePattern&&p.parse(u.excludePattern),this.folderExcludePatterns=new Map,u.folderQueries.forEach(c=>{const d=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),y=c.folder.fsPath;u.folderQueries.map(A=>A.folder.fsPath).filter(A=>A!==y).forEach(A=>{(0,L.isEqualOrParent)(A,y)&&(d[m.relative(y,A)]=!0)}),this.folderExcludePatterns.set(y,new t(d,y))})}cancel(){this.isCanceled=!0,n.forEach(u=>u())}walk(u,c,d,y,A){if(this.fileWalkSW=g.StopWatch.create(!1),this.isCanceled)return A(null,this.isLimitHit);c.forEach(E=>{const b=m.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,b)||this.matchFile(d,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=g.StopWatch.create(!1),this.parallel(u,(E,b)=>{this.call(this.cmdTraversal,this,E,d,y,_=>{if(_){const T=(0,v.toErrorMessage)(_);console.error(T),this.errors.push(T),b(_,void 0)}else b(null,void 0)})},(E,b)=>{this.fileWalkSW.stop();const _=E?R.coalesce(E)[0]:null;A(_,this.isLimitHit)})}parallel(u,c,d){const y=new Array(u.length),A=new Array(u.length);let E=!1,b=0;if(u.length===0)return d(null,[]);u.forEach((_,T)=>{c(_,(U,M)=>{if(U?(E=!0,y[T]=null,A[T]=U):(y[T]=M,A[T]=null),++b===u.length)return d(E?A:null,y)})})}call(u,c,...d){try{u.apply(c,d)}catch(y){d[d.length-1](y)}}cmdTraversal(u,c,d,y){const A=u.folder.fsPath,E=I.isMacintosh,b=()=>P&&P.kill();n.add(b);let _=W=>{n.delete(b),_=()=>{},y(W)},T="";const U=this.initDirectoryTree(),M=(0,s.spawnRipgrepCmd)(this.config,u,this.config.includePattern,this.folderExcludePatterns.get(u.folder.fsPath).expression),P=M.cmd,x=!Object.keys(M.siblingClauses).length,F=M.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let O=`${M.rgDiskPath} ${F}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),d({message:O}),this.cmdResultCount=0,this.collectStdout(P,"utf8",d,(W,J,ce)=>{if(W){_(W);return}if(this.isLimitHit){_();return}const X=(T+(E?S.normalizeNFC(J||""):J)).split(`
`);if(ce){const Y=X.length;X[Y-1]=X[Y-1].trim(),X[Y-1]||X.pop()}else T=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){_(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=X.length,x){for(const Y of X)if(this.matchFile(c,{base:A,relativePath:Y,searchPath:this.getSearchPath(u,Y)}),this.isLimitHit){b();break}(ce||this.isLimitHit)&&_();return}this.addDirectoryEntries(u,U,A,X,c),ce&&(this.matchDirectoryTree(U,A,c),_())})}spawnFindCmd(u){const c=this.folderExcludePatterns.get(u.folder.fsPath),d=c.getBasenameTerms(),y=c.getPathTerms(),A=["-L","."];if(d.length||y.length){A.push("-not","(","(");for(const E of d)A.push("-name",E),A.push("-o");for(const E of y)A.push("-path",E),A.push("-o");A.pop(),A.push(")","-prune",")")}return A.push("-type","f"),D.spawn("find",A,{cwd:u.folder.fsPath})}readStdout(u,c,d){let y="";this.collectStdout(u,c,()=>{},(A,E,b)=>{if(A){d(A);return}y+=E,b&&d(null,y)})}collectStdout(u,c,d,y){let A=(_,T,U)=>{(_||U)&&(A=()=>{},this.cmdSW?.stop()),y(_,T,U)},E=!1;u.stdout?(this.forwardData(u.stdout,c,A),u.stdout.once("data",()=>E=!0)):d({message:"stdout is null"});let b;u.stderr?b=this.collectData(u.stderr):d({message:"stderr is null"}),u.on("error",_=>{A(_)}),u.on("close",_=>{let T;!E&&(T=this.decodeData(b,c))&&r(T)?A(new Error(`command failed with error code ${_}: ${this.decodeData(b,c)}`)):(this.exists&&_===0&&(this.isLimitHit=!0),A(null,"",!0))})}forwardData(u,c,d){const y=new k.StringDecoder(c);return u.on("data",A=>{d(null,y.write(A))}),y}collectData(u){const c=[];return u.on("data",d=>{c.push(d)}),c}decodeData(u,c){const d=new k.StringDecoder(c);return u.map(y=>d.write(y)).join("")}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries(u,{pathToEntries:c},d,y,A){y.indexOf(this.filePattern)!==-1&&this.matchFile(A,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(u,this.filePattern)});const E=b=>{const _=m.basename(b),T=m.dirname(b);let U=c[T];U||(U=c[T]=[],E(T)),U.push({base:d,relativePath:b,basename:_,searchPath:this.getSearchPath(u,b)})};y.forEach(E)}matchDirectoryTree({rootEntries:u,pathToEntries:c},d,y){const A=this,E=this.folderExcludePatterns.get(d),b=this.filePattern;function _(T){A.directoriesWalked++;const U=(0,f.hasSiblingFn)(()=>T.map(M=>M.basename));for(let M=0,P=T.length;M<P;M++){const x=T[M],{relativePath:F,basename:O}=x;if(E.test(F,O,b!==O?U:void 0))continue;const W=c[F];if(W)_(W);else{if(A.filesWalked++,F===b)continue;A.matchFile(y,x)}if(A.isLimitHit)break}}_(u)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(u,c,d,y,A){const E=u.folder,b=(0,f.hasSiblingFn)(()=>d);this.parallel(d,(_,T)=>{if(this.isCanceled||this.isLimitHit)return T(null);const U=c?[c,_].join(m.sep):_;if(this.folderExcludePatterns.get(u.folder.fsPath).test(U,_,this.config.filePattern!==_?b:void 0))return T(null);const M=[E.fsPath,U].join(m.sep);N.lstat(M,(P,x)=>{if(P||this.isCanceled||this.isLimitHit)return T(null);this.statLinkIfNeeded(M,x,(F,O)=>F||this.isCanceled||this.isLimitHit?T(null):O.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(M,x,(W,J)=>W||this.isCanceled||this.isLimitHit||(J=J||"",this.walkedPaths[J])?T(null):(this.walkedPaths[J]=!0,l.Promises.readdir(M).then(ce=>{if(this.isCanceled||this.isLimitHit)return T(null);this.doWalk(u,U,ce,y,G=>T(G||null))},ce=>{T(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&C.isNumber(O.size)&&O.size>this.maxFilesize||this.matchFile(y,{base:E.fsPath,relativePath:U,searchPath:this.getSearchPath(u,U)}),T(null,void 0)))})},_=>{const T=_&&R.coalesce(_);return A(T&&T.length>0?T[0]:void 0)})}matchFile(u,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,m.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||u(c))}isFileMatch(u){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,f.isFilePatternMatch)(u,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(u,c,d){return c.isSymbolicLink()?N.stat(u,d):d(null,c)}realPathIfNeeded(u,c,d){return c.isSymbolicLink()?N.realpath(u,(y,A)=>y?d(y):d(null,A)):d(null,u)}getSearchPath(u,c){return u.folderName?m.join(u.folderName,c):c}}e.FileWalker=o;class a{constructor(u){this.folderQueries=u.folderQueries,this.extraFiles=u.extraFileResources||[],this.walker=new o(u)}search(u,c,d){this.walker.walk(this.folderQueries,this.extraFiles,u,c,(y,A)=>{d(y,{limitHit:A,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=a;class t{constructor(u,c){this.expression=u,this.root=c,this.init(u)}init(u){let c,d;Object.keys(u).filter(y=>u[y]).forEach(y=>{m.isAbsolute(y)?(c=c||p.getEmptyExpression(),c[y]=u[y]):(d=d||p.getEmptyExpression(),d[y]=u[y])}),this.absoluteParsedExpr=c&&p.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=d&&p.parse(d,{trimForExclusions:!0})}test(u,c,d){return this.relativeParsedExpr&&this.relativeParsedExpr(u,c,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(m.join(this.root,u),c,d)}getBasenameTerms(){const u=[];return this.absoluteParsedExpr&&u.push(...p.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&u.push(...p.getBasenameTerms(this.relativeParsedExpr)),u}getPathTerms(){const u=[];return this.absoluteParsedExpr&&u.push(...p.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&u.push(...p.getPathTerms(this.relativeParsedExpr)),u}}function r(h){const u=h.trim().split(`
`),c=u[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return w.uppercaseFirstLetter(u[u.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ye[375],Ce([1,0,98,22,186,21]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(c){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(d=>d===c)}e.isUTFEncoding=R,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const v=512,p=512,S=512*8,L=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class g extends Error{constructor(d,y){super(d),this.decodeStreamErrorKind=y}}e.DecodeStreamError=g;class w{static async create(d){let y;if(d!==e.UTF8)y=(await(0,m.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(d));else{const A=new TextDecoder;y={write(E){return A.decode(E,{stream:!0})},end(){return A.decode()}}}return new w(y)}constructor(d){this.iconvLiteDecoder=d}write(d){return this.iconvLiteDecoder.write(d)}end(){return this.iconvLiteDecoder.end()}}function C(c,d){const y=d.minBytesRequiredForDetection??d.guessEncoding?S:p;return new Promise((A,E)=>{const b=(0,D.newWriteableStream)(x=>x.join("")),_=[];let T=0,U;const M=new k.CancellationTokenSource,P=async()=>{try{const x=await u({buffer:N.VSBuffer.concat(_),bytesRead:T},d.guessEncoding);if(x.seemsBinary&&d.acceptTextOnly)throw new g("Stream is binary but only text is accepted for decoding",1);x.encoding=await d.overwriteEncoding(x.encoding),U=await w.create(x.encoding);const F=U.write(N.VSBuffer.concat(_).buffer);b.write(F),_.length=0,T=0,A({stream:b,detected:x})}catch(x){M.cancel(),b.destroy(),E(x)}};(0,D.listenStream)(c,{onData:async x=>{U?b.write(U.write(x.buffer)):(_.push(x),T+=x.byteLength,T>=y&&(c.pause(),await P(),setTimeout(()=>c.resume())))},onError:x=>b.error(x),onEnd:async()=>{U||await P(),b.end(U?.end())}},M.token)})}e.toDecodeStream=C;async function l(c,d,y){const E=(await(0,m.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(d),y);let b=!1,_=!1;return{read(){if(_)return null;const T=c.read();if(typeof T!="string"){if(_=!0,!b&&y?.addBOM)switch(d){case e.UTF8:case e.UTF8_with_bom:return N.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return N.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return N.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const U=E.end();return U&&U.length>0?(b=!0,N.VSBuffer.wrap(U)):null}return b=!0,N.VSBuffer.wrap(E.write(T))}}}e.toEncodeReadable=l;async function f(c){return(await(0,m.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(c))}e.encodingExists=f;function s(c){return c===e.UTF8_with_bom||c===null?e.UTF8:c}e.toNodeEncoding=s;function i(c,d){if(!c||d<e.UTF16be_BOM.length)return null;const y=c.readUInt8(0),A=c.readUInt8(1);if(y===e.UTF16be_BOM[0]&&A===e.UTF16be_BOM[1])return e.UTF16be;if(y===e.UTF16le_BOM[0]&&A===e.UTF16le_BOM[1])return e.UTF16le;if(d<e.UTF8_BOM.length)return null;const E=c.readUInt8(2);return y===e.UTF8_BOM[0]&&A===e.UTF8_BOM[1]&&E===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=i;const n=["ascii","utf-16","utf-32"];async function o(c){const d=await(0,m.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),y=c.slice(0,L),A=r(y.buffer),E=d.detect(A);if(!E||!E.encoding)return null;const b=E.encoding.toLowerCase();return 0<=n.indexOf(b)?null:t(E.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const d=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[d]||d}function r(c){let d="";for(let y=0;y<c.length;y++)d+=String.fromCharCode(c[y]);return d}function h(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=c.match(/windows(\d+)/);return d?"windows-"+d[1]:c}}}e.toCanonicalName=h;function u({buffer:c,bytesRead:d},y){let A=i(c,d),E=!1;if(A!==e.UTF16be&&A!==e.UTF16le&&c){let b=!0,_=!0,T=!1;for(let U=0;U<d&&U<v;U++){const M=U%2===1,P=c.readUInt8(U)===0;if(P&&(T=!0),b&&(M&&!P||!M&&P)&&(b=!1),_&&(M&&P||!M&&!P)&&(_=!1),P&&!b&&!_)break}T&&(b?A=e.UTF16le:_?A=e.UTF16be:E=!0)}return y&&!E&&!A&&c?o(c.slice(0,d)).then(b=>({seemsBinary:!1,encoding:b})):{seemsBinary:E,encoding:A}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[155],Ce([1,0,375,31,154]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class k extends m.TextSearchManager{constructor(v,p,S=N,L="searchProcess"){super(v,p,{readdir:I=>S.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.toCanonicalName)(I)},L)}}e.NativeTextSearchManager=k}),define(ye[156],Ce([1,0,51,391,374,19,73,34,16,13,2,36,94,392,372,119]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const f=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(_){this.outputChannel=_}provideTextSearchResults(_,T,U,M){return this.outputChannel.appendLine(`provideTextSearchResults ${_.pattern}, ${JSON.stringify({...T,folder:T.folder.toString()})}`),new Promise((P,x)=>{M.onCancellationRequested(()=>Y());const F=r(_,T),O=T.folder.fsPath,W=F.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");this.outputChannel.appendLine(`${f} ${W}
 - cwd: ${O}`);let J=D.spawn(f,F,{cwd:O});J.on("error",j=>{console.error(j),this.outputChannel.appendLine("Error: "+(j&&j.message)),x((0,I.serializeSearchError)(new I.SearchError(j&&j.message,I.SearchErrorCode.rgProcessError)))});let ce=!1;const G=new o(T.maxResults,O,T.previewOptions);G.on("result",j=>{ce=!0,Q="",U.report(j)});let X=!1;const Y=()=>{X=!0,J?.kill(),G?.cancel()};let se=!1;G.on("hitLimit",()=>{se=!0,Y()});let Q="";J.stdout.on("data",j=>{G.handleData(j),ce||(Q+=j)});let we=!1;J.stdout.once("data",()=>we=!0);let he="";J.stderr.on("data",j=>{const z=j.toString();this.outputChannel.appendLine(z),he.length+z.length<1e6&&(he+=z)}),J.on("close",()=>{if(this.outputChannel.appendLine(we?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(ce?"Got result from parser":"No result from parser"),Q&&this.outputChannel.appendLine(`Got data without result: ${Q}`),this.outputChannel.appendLine(""),X)P({limitHit:se});else{G.flush(),J=null;let j;he&&!we&&(j=i(he))?x((0,I.serializeSearchError)(new I.SearchError(j.message,j.code))):P({limitHit:se})}})})}}e.RipgrepTextSearchEngine=s;function i(b){const _=b.split(`
`),T=_[0].trim();if(_.some(M=>M.startsWith("regex parse error")))return new I.SearchError(n(_),I.SearchErrorCode.regexParseError);const U=T.match(/grep config error: unknown encoding: (.*)/);if(U)return new I.SearchError(`Unknown encoding: ${U[1]}`,I.SearchErrorCode.unknownEncoding);if(T.startsWith("error parsing glob"))return new I.SearchError(T.charAt(0).toUpperCase()+T.substr(1),I.SearchErrorCode.globParseError);if(T.startsWith("the literal"))return new I.SearchError(T.charAt(0).toUpperCase()+T.substr(1),I.SearchErrorCode.invalidLiteral);if(T.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(T,I.SearchErrorCode.regexParseError)}function n(b){const _=["Regex parse error"],T=b.filter(U=>U.startsWith("PCRE2:"));if(T.length>=1){const U=T[0].replace("PCRE2:","");if(U.indexOf(":")!==-1&&U.split(":").length>=2){const M=U.split(":")[1];_.push(":"+M)}}return _.join("")}class o extends N.EventEmitter{constructor(_,T,U){super(),this.maxResults=_,this.rootFolder=T,this.previewOptions=U,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new m.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(_,T){return super.on(_,T),this}handleData(_){if(this.isDone)return;const T=typeof _=="string"?_:this.stringDecoder.write(_);this.handleDecodedData(T)}handleDecodedData(_){let T=_.indexOf(`
`);const U=this.remainder+_;if(T>=0)T+=this.remainder.length;else{this.remainder=U;return}let M=0;for(;T>=0;)this.handleLine(U.substring(M,T).trim()),M=T+1,T=U.indexOf(`
`,M);this.remainder=U.substring(M)}handleLine(_){if(this.isDone||!_)return;let T;try{T=JSON.parse(_)}catch{throw new Error(`malformed line from rg: ${_}`)}if(T.type==="match"){const U=a(T.data.path),M=L.URI.file(p.join(this.rootFolder,U)),P=this.createTextSearchMatch(T.data,M);this.onResult(P),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(T.type==="context"){const U=a(T.data.path),M=L.URI.file(p.join(this.rootFolder,U));this.createTextSearchContext(T.data,M).forEach(x=>this.onResult(x))}}createTextSearchMatch(_,T){const U=_.line_number-1,M=a(_.lines),P=Buffer.from(M);let x=0,F=0,O=U;_.submatches.length===0&&_.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const W=(0,k.coalesce)(_.submatches.map((J,ce)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const G=a(J.match),X=P.slice(x,J.start).toString(),Y=t(X),se=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+F,Q=t(G),we=Y.numLines+O,he=Q.numLines+we,j=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+se;return x=J.end,F=j,O=he,new g.Range(we,se,he,j)}));return(0,l.createTextSearchResult)(T,M,W,this.previewOptions)}createTextSearchContext(_,T){const U=a(_.lines),M=_.line_number;return U.replace(/\r?\n$/,"").split(`
`).map((P,x)=>({text:P,uri:T,lineNumber:M+x}))}onResult(_){this.emit("result",_)}}e.RipgrepParser=o;function a(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const _=/\n/g;let T=0,U=-1,M;for(;M=_.exec(b);)T++,U=M.index;const P=U>=0?b.length-U-1:b.length;return{numLines:T,lastLineLength:P}}function r(b,_){const T=["--hidden","--no-require-git"];T.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:U,otherIncludes:M}=(0,R.groupBy)(_.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const x=new Set;M.forEach(F=>{x.add(F)}),T.push("-g","!*"),x.forEach(F=>{h(F).map(l.anchorGlob).forEach(O=>{T.push("-g",O)})})}U&&U.length&&U.forEach(x=>{T.push("-g",x)}),_.excludes.map(l.anchorGlob).forEach(x=>T.push("-g",`!${x}`)),_.maxFileSize&&T.push("--max-filesize",_.maxFileSize+""),_.useIgnoreFiles?_.useParentIgnoreFiles||T.push("--no-ignore-parent"):T.push("--no-ignore"),_.followSymlinks&&T.push("--follow"),_.encoding&&_.encoding!=="utf8"&&T.push("--encoding",_.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,S.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),_.usePCRE2&&T.push("--pcre2"),T.push("--crlf"),b.isRegExp&&(b.pattern=u(b.pattern),T.push("--engine","auto"));let P;if(b.isWordMatch){const F=(0,S.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");T.push("--regexp",F)}else if(b.isRegExp){let x=d(b.pattern);x=y(x),T.push("--regexp",x)}else P=b.pattern,T.push("--fixed-strings");return T.push("--no-config"),_.useGlobalIgnoreFiles||T.push("--no-ignore-global"),T.push("--json"),b.isMultiline&&T.push("--multiline"),_.beforeContext&&T.push("--before-context",_.beforeContext+""),_.afterContext&&T.push("--after-context",_.afterContext+""),T.push("--"),P&&T.push(P),T.push("."),T}e.getRgArgs=r;function h(b){return E(b).flatMap(T=>{const U=(0,v.splitGlobAware)(T,"/");return U.map((M,P)=>U.slice(0,P+1).join("/"))})}function u(b){const _=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(_);)b=b.replace(_,"$1\\x{$2}");const T=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(T);)b=b.replace(T,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=u;const c=b=>b.type==="Assertion"&&b.kind==="lookbehind";function d(b){let _;try{_=new w.RegExpParser().parsePattern(b)}catch{return b}let T="",U=0;const M=(F,O,W)=>{T+=b.slice(U,F)+W,U=O},P=[];return new w.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const O=P[0];if(!O)M(F.start,F.end,"\\r?\\n");else if(!P.some(c))if(O.type==="CharacterClass")if(O.negate){const W=b.slice(O.start+2,F.start)+b.slice(F.end,O.end-1);O.parent?.type==="Quantifier"?M(O.start,O.end,W?`[^${W}]`:"."):M(O.start,O.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=b.slice(O.start+1,F.start)+b.slice(F.end,O.end-1);M(O.start,O.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else O.type==="Quantifier"&&M(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){P.unshift(F)},onQuantifierLeave(){P.shift()},onCharacterClassRangeEnter(F){P.unshift(F)},onCharacterClassRangeLeave(){P.shift()},onCharacterClassEnter(F){P.unshift(F)},onCharacterClassLeave(){P.shift()},onAssertionEnter(F){c(F)&&P.push(F)},onAssertionLeave(F){P[0]===F&&P.shift()}}).visit(_),T+=b.slice(U),T}e.fixRegexNewline=d;function y(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=y;function A(b){let _=!1,T=!1,U="",M="";for(let P=0;P<b.length;P++){const x=b[P];switch(x){case"\\":T?(_?M+="\\"+x:U+="\\"+x,T=!1):T=!0;break;case"{":if(T)_?M+=x:U+=x,T=!1;else{if(_)return{strInBraces:U+"{"+M+"{"+b.substring(P+1)};_=!0}break;case"}":if(T)_?M+=x:U+=x,T=!1;else{if(_)return{fixedStart:U,strInBraces:M,fixedEnd:b.substring(P+1)};U+=x}break;default:_?M+=(T?"\\":"")+x:U+=(T?"\\":"")+x,T=!1;break}}return{strInBraces:U+(_?"{"+M:"")}}function E(b){const{fixedStart:_,strInBraces:T,fixedEnd:U}=A(b);if(_===void 0||U===void 0)return[T];let M=(0,v.splitGlobAware)(T,",");M.length||(M=[""]);const P=E(U);return M.flatMap(x=>{const F=_+x;return P.map(O=>F+O)})}e.performBraceExpansionForRipgrep=E}),define(ye[376],Ce([1,0,21,156,85,17]),function(ge,e,D,N,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(S){this.outputChannel=S,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(S,L,I,g){const w=new N.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===k.Schemas.vscodeUserData){const C={...L,folder:L.folder.with({scheme:k.Schemas.file})},l=new m.Progress(f=>I.report({...f,uri:f.uri.with({scheme:L.folder.scheme})}));return this.withToken(g,f=>w.provideTextSearchResults(S,C,l,f))}else return this.withToken(g,C=>w.provideTextSearchResults(S,L,I,C))}async withToken(S,L){const I=v(S);this.inProgress.add(I);const g=await L(I.token);return this.inProgress.delete(I),g}dispose(){this.inProgress.forEach(S=>S.cancel())}}e.RipgrepSearchProvider=R;function v(p){const S=new D.CancellationTokenSource;return p.onCancellationRequested(()=>S.cancel()),S}}),define(ye[377],Ce([1,0,31,156,155]),function(ge,e,D,N,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class k{constructor(p){this.query=p}search(p,S,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(w){L({message:w})}},g=new m.NativeTextSearchManager(this.query,new N.RipgrepTextSearchEngine(I),D);return new Promise((w,C)=>g.search(l=>{S(l.map(R))},p).then(l=>w({limitHit:l.limitHit,type:"success",stats:l.stats}),C))}}e.TextSearchEngineAdapter=k;function R(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce((p,S)=>{if(S.ranges){const L=S;return p+(Array.isArray(L.ranges)?L.ranges.length:1)}else return p+1},0)}}}),define(ye[378],Ce([1,0,19,12,8,4,129,16,38,2,32,36,373,377]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{static{this.BATCH_SIZE=512}constructor(o="searchProcess"){this.processType=o,this.caches=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new k.Emitter({onDidAddFirstListener:()=>{a=(0,N.createCancelablePromise)(h=>this.doFileSearchWithEngine(g.Engine,t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new k.Emitter({onDidAddFirstListener:()=>{a=(0,N.createCancelablePromise)(h=>this.ripgrepTextSearch(t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}ripgrepTextSearch(o,a,t){return o.maxFileSize=this.getPlatformFileLimits().maxFileSize,new w.TextSearchEngineAdapter(o).search(t,a,a)}getPlatformFileLimits(){return{maxFileSize:16*L.ByteSize.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(g.Engine,o,a,t)}doFileSearchWithEngine(o,a,t,r,h=C.BATCH_SIZE){let u=0;const c=y=>{Array.isArray(y)?(u+=y.length,t(y.map(A=>this.rawMatchToSearchItem(A)))):y.relativePath?(u++,t(this.rawMatchToSearchItem(y))):t(y)};if(a.sortByScore){let y=this.trySortedSearchFromCache(a,c,r);if(!y){const A=a.maxResults?Object.assign({},a,{maxResults:null}):a,E=new o(A);y=this.doSortedSearch(E,a,t,c,r)}return new Promise((A,E)=>{y.then(([b,_])=>{const T=_.map(U=>this.rawMatchToSearchItem(U));this.sendProgress(T,t,h),A(b)},E)})}const d=new o(a);return this.doSearch(d,c,h,r).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.processType,fromCache:!1,resultCount:u,sortingTime:void 0}}))}rawMatchToSearchItem(o){return{path:o.base?(0,v.join)(o.base,o.relativePath):o.relativePath}}doSortedSearch(o,a,t,r,h){const u=new k.Emitter;let c=(0,N.createCancelablePromise)(y=>{let A=[];const E=b=>{Array.isArray(b)?A=b:(r(b),u.fire(b))};return this.doSearch(o,E,-1,y).then(b=>[b,A])}),d;if(a.cacheKey){d=this.getOrCreateCache(a.cacheKey);const y={promise:c,event:u.event,resolved:!1};d.resultsToSearchCache[a.filePattern||""]=y,c.then(()=>{y.resolved=!0},A=>{delete d.resultsToSearchCache[a.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([y,A])=>{const E=d?d.scorerCache:Object.create(null),b=(typeof a.maxResults!="number"||a.maxResults>0)&&p.StopWatch.create(!1);return this.sortResults(a,A,E,h).then(_=>{const T=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:T,fromCache:!1,type:this.processType,workspaceFolderCount:a.folderQueries.length,resultCount:_.length},messages:y.messages,limitHit:y.limitHit||typeof a.maxResults=="number"&&A.length>a.maxResults},_]})})}getOrCreateCache(o){const a=this.caches[o];return a||(this.caches[o]=new l)}trySortedSearchFromCache(o,a,t){const r=o.cacheKey&&this.caches[o.cacheKey];if(!r)return;const h=this.getResultsFromCache(r,o.filePattern||"",a,t);if(h)return h.then(([u,c,d])=>{const y=p.StopWatch.create(!1);return this.sortResults(o,c,r.scorerCache,t).then(A=>{const E=y.elapsed(),b={fromCache:!0,detailStats:d,type:this.processType,resultCount:c.length,sortingTime:E};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&c.length>o.maxResults,stats:b},A]})})}sortResults(o,a,t,r){const h=(0,R.prepareQuery)(o.filePattern||""),u=(d,y)=>(0,R.compareItemsByFuzzyScore)(d,y,h,!0,f,t),c=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return D.topAsync(a,u,c,1e4,r)}sendProgress(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}getResultsFromCache(o,a,t,r){const h=p.StopWatch.create(!1),u=a.indexOf(v.sep)>=0;let c;for(const E in o.resultsToSearchCache)if(a.startsWith(E)){if(u&&E.indexOf(v.sep)<0&&E!=="")continue;const b=o.resultsToSearchCache[E];c={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!c)return null;const d=h.elapsed(),y=p.StopWatch.create(!1),A=c.event(t);return r&&r.onCancellationRequested(()=>{A.dispose()}),c.promise.then(([E,b])=>{if(r&&r.isCancellationRequested)throw(0,m.canceled)();const _=[],T=(0,R.prepareQuery)(a).normalizedLowercase;for(const U of b)(0,I.isFilePatternMatch)(U,T)&&_.push(U);return[E,_,{cacheWasResolved:c.resolved,cacheLookupTime:d,cacheFilterTime:y.elapsed(),cacheEntryCount:b.length}]})}doSearch(o,a,t,r){return new Promise((h,u)=>{let c=[];r?.onCancellationRequested(()=>o.cancel()),o.search(d=>{d&&(t?(c.push(d),t>0&&c.length>=t&&(a(c),c=[])):a(d))},d=>{a(d)},(d,y)=>{c.length&&a(c),d?u(d):h(y)})})}clearCache(o){return delete this.caches[o],Promise.resolve(void 0)}preventCancellation(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.SearchService=C;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(n){return(0,v.basename)(n.relativePath)}getItemDescription(n){return(0,v.dirname)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>S.URI.revive(o))}}function i(n){return{...n,folder:S.URI.revive(n.folder)}}}),define(ye[379],Ce([1,0,3,17,2,31,14,27,20,97,66,36,378,376,119,155]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let f=class extends S.ExtHostSearch{constructor(i,n,o,a){super(i,o,a),this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new D.DisposableStore;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new w.RipgrepSearchProvider(t))),n.remote.isRemote&&n.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const i=new C.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(N.Schemas.file,new w.RipgrepSearchProvider(i))),this._disposables.add(this.registerInternalFileSearchProvider(N.Schemas.file,new g.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(i,n){const o=this._handlePool++;return this._internalFileSearchProvider=n,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(i)),(0,D.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,S.reviveQuery)(o);return i===this._internalFileSearchHandle?this.doInternalFileSearch(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,I.isSerializedFileMatch)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>m.URI.file(r.path)));return}t.message&&this._logService.debug("ExtHostSearch",t.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(i,a,n)}async doInternalFileSearch(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this._proxy.$handleFileMatch(i,n,t)})}$clearCache(i){return this._internalFileSearchProvider?.clearCache(i),super.$clearCache(i)}createTextSearchManager(i,n){return new l.NativeTextSearchManager(i,n,void 0,"textSearchProvider")}};e.NativeExtHostSearch=f,e.NativeExtHostSearch=f=Ge([We(0,p.IExtHostRpcService),We(1,v.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,R.ILogService)],f)}),define(ye[120],Ce([1,0,393,62,63,394,22,8,4,3,16,11,30,81,82]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class l{traceSocketEvent(b,_){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,_)}constructor(b,_=""){this._canWrite=!0,this.debugLabel=_,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,v.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener),this._closeListener=T=>{this.traceSocketEvent("close",{hadError:T}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(b){const _=T=>{this.traceSocketEvent("read",T),b(R.VSBuffer.wrap(T))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(b){const _=T=>{b({type:0,hadError:T,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(b){const _=()=>{b()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(b){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,v.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,v.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=l;var f;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var s;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(s||(s={}));class i extends S.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,_){this.socket.traceSocketEvent(b,_)}constructor(b,_,T,U){super(),this._onData=this._register(new p.Emitter),this._onClose=this._register(new p.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:T?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new n(this,_,T,U,this._onData,(M,P)=>this._write(M,P))),this._register(this._flowManager.onError(M=>{console.error(M),(0,v.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(async M=>{this._flowManager.isProcessingReadQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(M)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let _=0;for(;_<b.byteLength;)this._flowManager.writeMessage(b.slice(_,Math.min(_+262144,b.byteLength)),{compressed:!0,opcode:2}),_+=262144}_write(b,{compressed:_,opcode:T}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let U=2;b.byteLength<126?U+=0:b.byteLength<2**16?U+=2:U+=8;const M=R.VSBuffer.alloc(U),P=_?64:0,x=T&15;if(M.writeUInt8(128|P|x,0),b.byteLength<126)M.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(b.byteLength>>>8&255,++F),M.writeUInt8(b.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(b.byteLength>>>24&255,++F),M.writeUInt8(b.byteLength>>>16&255,++F),M.writeUInt8(b.byteLength>>>8&255,++F),M.writeUInt8(b.byteLength>>>0&255,++F)}this.socket.write(R.VSBuffer.concat([M,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),T=_.readUInt8(0),U=(T&128)>>>7,M=(T&64)>>>6,P=T&15,x=_.readUInt8(1),F=(x&128)>>>7,O=x&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=!!M),this._state.firstFrameOfMessage=!!U,this._state.mask=0,this._state.opcode=P,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),T=_.readUInt8(1),U=(T&128)>>>7;let M=T&127,P=1;M===126?M=_.readUInt8(++P)*2**8+_.readUInt8(++P):M===127&&(M=_.readUInt8(++P)*0+_.readUInt8(++P)*0+_.readUInt8(++P)*0+_.readUInt8(++P)*0+_.readUInt8(++P)*2**24+_.readUInt8(++P)*2**16+_.readUInt8(++P)*2**8+_.readUInt8(++P));let x=0;U&&(x=_.readUInt8(++P)*2**24+_.readUInt8(++P)*2**16+_.readUInt8(++P)*2**8+_.readUInt8(++P)),this._state.state=3,this._state.readLen=M,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),t(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(_,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=i;class n extends S.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(b,_,T,U,M,P){super(),this._tracer=b,this._onData=M,this._writeFn=P,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new p.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new p.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new o(this._tracer,U,T,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(b,_){this._writeQueue.push({data:b,options:_}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:b,options:_}=this._writeQueue.shift();if(this._zlibDeflateStream&&_.compressed){const T=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(T,_)}else this._writeFn(b,{..._,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,_){return new Promise((T,U)=>{b.write(_),b.flush(M=>T(M))})}acceptFrame(b,_,T){this._readQueue.push({data:b,isCompressed:_,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(b,_,T){return new Promise((U,M)=>{b.write(_),T&&b.write(R.VSBuffer.fromByteArray([0,0,255,255])),b.flush(P=>U(P))})}}class o extends S.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(b,_,T,U){super(),this._tracer=b,this._recordInflateBytes=_,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,k.createInflateRaw)(U),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(R.VSBuffer.wrap(M))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(_)})}}class a extends S.Disposable{constructor(b,_){super(),this._tracer=b,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,k.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(R.VSBuffer.wrap(T))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),b(_)})}}function t(E,b){if(b===0)return;const _=E.byteLength>>>2;for(let F=0;F<_;F++){const O=E.readUInt32BE(F*4);E.writeUInt32BE(O^b,F*4)}const T=_*4,U=E.byteLength-T,M=b>>>24&255,P=b>>>16&255,x=b>>>8&255;U>=1&&E.writeUInt8(E.readUInt8(T)^M,T),U>=2&&E.writeUInt8(E.readUInt8(T+1)^P,T+1),U>=3&&E.writeUInt8(E.readUInt8(T+2)^x,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function h(){const E=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const b=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,m.tmpdir)(),_=(0,L.join)(b,`vscode-ipc-${E}.sock`);return c(_),_}e.createRandomIPCHandle=h;function u(E,b,_){const T=(0,D.createHash)("md5").update(E).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${_}-${b}-sock`;const U=_.substr(0,4),M=b.substr(0,6),P=T.substr(0,8);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${P}-${U}-${M}.sock`):x=(0,L.join)(E,`${U}-${M}.sock`),c(x),x}e.createStaticIPCHandle=u;function c(E){const b=r[I.platform];typeof b=="number"&&E.length>=b&&console.warn(`WARNING: IPC handle "${E}" is longer than ${b} chars, try a shorter --user-data-dir`)}class d extends w.IPCServer{static toClientConnectionEvent(b){const _=p.Event.fromNodeEventEmitter(b,"connection");return p.Event.map(_,T=>({protocol:new C.Protocol(new l(T,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(T,"close"))}))}constructor(b){super(d.toClientConnectionEvent(b)),this.server=b}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function y(E){return new Promise((b,_)=>{const T=(0,N.createServer)();T.on("error",_),T.listen(E,()=>{T.removeListener("error",_),b(new d(T))})})}e.serve=y;function A(E,b){return new Promise((_,T)=>{const U=(0,N.createConnection)(E,()=>{U.removeListener("error",T),_(C.Client.fromSocket(new l(U,`ipc-client${b}`),b))});U.once("error",T)})}e.connect=A}),define(ye[380],Ce([1,0,62,63,166,120,12,3,11,45,14,136,257,258,109,88,22]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function s(t,r,h,u,c){let d;for(let y=3;y&&(d?.dispose(),d=await new i(t,r,h,u,c).waitForReady(),!(c&&m.BROWSER_RESTRICTED_PORTS[c]||!m.BROWSER_RESTRICTED_PORTS[d.tunnelLocalPort]));y--);return d}class i extends v.Disposable{constructor(r,h,u,c,d){super(),this.defaultTunnelHost=h,this.suggestedLocalPort=d,this.privacy=l.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=r,this._server=D.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=y=>this._onConnection(y),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){const r=this.suggestedLocalPort??this.tunnelRemotePort,h=(0,l.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let u=await(0,m.findFreePortFaster)(r,2,1e3,h),c=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(r){r.pause();const h=(0,l.isLocalhost)(this.tunnelRemoteHost)||(0,l.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,g.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),c=u.getSocket(),d=u.readEntireBuffer();u.dispose(),d.byteLength>0&&r.write(d.buffer),r.on("end",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),c instanceof k.NodeSocket?c.socket.destroy():c.end()}),c instanceof k.NodeSocket?this._mirrorNodeSocket(r,c):this._mirrorGenericSocket(r,c),r.localAddress&&this._socketsDispose.set(r.localAddress,()=>{r.end(),c.end()})}_mirrorGenericSocket(r,h){h.onClose(()=>r.destroy()),h.onEnd(()=>r.end()),h.onData(u=>r.write(u.buffer)),r.on("data",u=>h.write(f.VSBuffer.wrap(u))),r.resume()}_mirrorNodeSocket(r,h){const u=h.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.NodeRemoteTunnel=i;let n=class extends l.AbstractTunnelService{constructor(r,h,u,c,d){super(h,d),this.remoteSocketFactoryService=r,this.signService=u,this.productService=c}isPortPrivileged(r){return(0,l.isPortPrivileged)(r,this.defaultTunnelHost,p.OS,N.release())}retainOrCreateTunnel(r,h,u,c,d,y,A,E){const b=this.getTunnelFromMap(h,u);if(b)return++b.refcount,b.value;if((0,l.isTunnelProvider)(r))return this.createWithProvider(r,h,u,d,y,A,E);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${u} on local port ${d}.`);const _={commit:this.productService.commit,quality:this.productService.quality,addressProvider:r,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},T=s(_,c,h,u,d);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,u,T),T}}};e.BaseTunnelService=n,e.BaseTunnelService=n=Ge([We(0,w.IRemoteSocketFactoryService),We(1,L.ILogService),We(2,C.ISignService),We(3,I.IProductService),We(4,S.IConfigurationService)],n);let o=class extends n{constructor(r,h,u,c,d){super(r,h,u,c,d)}};e.TunnelService=o,e.TunnelService=o=Ge([We(0,w.IRemoteSocketFactoryService),We(1,L.ILogService),We(2,C.ISignService),We(3,I.IProductService),We(4,S.IConfigurationService)],o);let a=class extends v.Disposable{constructor(r,h,u,c,d){super(),this.remoteSocketFactoryService=r,this.logService=h,this.productService=u,this.signService=c,this.configurationService=d,this._tunnelServices=new Map}async openTunnel(r,h,u,c,d,y,A,E,b){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${c} on local port ${y}.`),!this._tunnelServices.has(r)){const _=new o(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(_),this._tunnelServices.set(r,_),_.onTunnelClosed(async()=>{(await _.tunnels).length===0&&(_.dispose(),this._tunnelServices.delete(r))})}return this._tunnelServices.get(r).openTunnel(h,u,c,d,y,A,E,b)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=Ge([We(0,w.IRemoteSocketFactoryService),We(1,L.ILogService),We(2,I.IProductService),We(3,C.ISignService),We(4,S.IConfigurationService)],a)}),define(ye[381],Ce([1,0,120,277,55,35,2,14,40]),function(ge,e,D,N,m,k,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class S{constructor(g,w,C){this._commands=g,this.logService=w,this._ipcHandlePath=C,this._server=N.createServer((l,f)=>this.onRequest(l,f)),this.setup().catch(l=>(w.error(l),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",g=>this.logService.error(g))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(g,w){const C=(f,s)=>{w.writeHead(f,{"content-type":"application/json"}),w.end(JSON.stringify(s||null),i=>i&&this.logService.error(i))},l=[];g.setEncoding("utf8"),g.on("data",f=>l.push(f)),g.on("end",async()=>{try{const f=JSON.parse(l.join(""));let s;switch(f.type){case"open":s=await this.open(f);break;case"openExternal":s=await this.openExternal(f);break;case"status":s=await this.getStatus(f);break;case"extensionManagement":s=await this.manageExtensions(f);break;default:C(404,`Unknown message type: ${f.type}`);break}C(200,s)}catch(f){const s=f instanceof Error?f.message:JSON.stringify(f);C(500,s),this.logService.error("Error while processing pipe request",f)}})}async open(g){const{fileURIs:w,folderURIs:C,forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=g,r=[];if(Array.isArray(C))for(const d of C)try{r.push({folderUri:R.URI.parse(d)})}catch{}if(Array.isArray(w))for(const d of w)try{(0,p.hasWorkspaceFileExtension)(d)?r.push({workspaceUri:R.URI.parse(d)}):r.push({fileUri:R.URI.parse(d)})}catch{}const h=a?R.URI.file(a):void 0,c={forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!h&&!i,waitMarkerFileURI:h,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",r,c)}async openExternal(g){for(const w of g.uris){const C=R.URI.parse(w),l=C.scheme==="file"?C:w;await this._commands.executeCommand("_remoteCLI.openExternal",l)}}async manageExtensions(g){const w=l=>l?.map(f=>/\.vsix$/i.test(f)?R.URI.parse(f):f),C={list:g.list,install:w(g.install),uninstall:w(g.uninstall),force:g.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",C)}async getStatus(g){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&m.existsSync(this._ipcHandlePath)&&m.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=S;let L=class extends S{constructor(g,w){super(g,w,(0,D.createRandomIPCHandle)())}};e.CLIServer=L,e.CLIServer=L=Ge([We(0,k.IExtHostCommands),We(1,v.ILogService)],L)}),define(ye[382],Ce([1,0,56,369,364,276,48,349,2,17,7,381,103,347,348]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends m.RequireInterceptor{_installInterceptor(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(h,u,c){return h=t(h),i._factories.has(h)?i._factories.get(h).load(h,p.URI.file((0,g.realpathSync)(u.filename)),d=>o.apply(this,[d,u,c])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,h)=>a.call(this,t(r),h);const t=r=>{for(const h of i._alternatives){const u=h(r);if(u){r=u;break}}return r}}}class f extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(w.ExtHostConsoleForwarder);const i=this._instaService.invokeFunction(N.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(v.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this._instaService.createInstance(C.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(l,i,{mine:this._myRegistry,all:this._globalRegistry}).install(),D.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,k.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),D.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(i){return i.main}async _loadCommonJSModule(i,n,o){if(n.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this._logService.flush();const t=i?.identifier.value;i&&await this._extHostLocalizationService.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),a=ge.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this._initData.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.ExtHostExtensionService=f}),define(ye[383],Ce([1,0,51,22,4,3,122,11,23,2,31,14,256,64,109,88,380,27,20,72,358]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;function a(b){const _=b.trim().split(`
`),T=[];return _.forEach(M=>{const P=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);P&&P.length>=3&&T.push({pid:parseInt(P[1],10),socket:parseInt(P[2],10)})}),T.reduce((M,P)=>(M[P.socket]=P,M),{})}e.getSockets=a;function t(...b){const _=[].concat(...b.map(h));return[...new Map(_.filter(T=>T.st==="0A").map(T=>{const U=T.local_address.split(":");return{socket:parseInt(T.inode,10),ip:r(U[0]),port:parseInt(U[1],16)}}).map(T=>[T.ip+":"+T.port,T])).values()]}e.loadListeningPorts=t;function r(b){let _="";if(b.length===8)for(let T=b.length-2;T>=0;T-=2)_+=parseInt(b.substr(T,2),16),T!==0&&(_+=".");else for(let T=0;T<b.length;T+=8){const U=b.substring(T,T+8);let M="";for(let P=8;P>=2;P-=2)M+=U.substring(P-2,P),(P===6||P===2)&&(M=parseInt(M,16).toString(16),_+=`${M}`,M="",T+P!==b.length-6&&(_+=":"))}return _}e.parseIpAddress=r;function h(b){const _=b.trim().split(`
`),T=_.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return _.map(M=>M.trim().split(/\s+/).reduce((P,x,F)=>(P[T[F]||F]=x,P),{}))}e.loadConnectionTable=h;function u(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function c(b){const _=b.trim().split(`
`),T=[];return _.forEach(U=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(U);M&&M.length>=4&&T.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),T}e.getRootProcesses=c;async function d(b,_,T){const U=T.reduce((P,x)=>(P[x.pid]=x,P),{}),M=[];return b.forEach(({socket:P,ip:x,port:F})=>{const O=_[P]?_[P].pid:void 0,W=O?U[O]?.cmd:void 0;O&&W&&!u(W)&&M.push({host:x,port:F,detail:W,pid:O})}),M}e.findPorts=d;function y(b,_,T){const U=new Map,M=c(_);for(const P of b){const x=T.get(P.port);if(x){U.set(P.port,x);continue}const F=M.find(O=>O.cmd.includes(`${P.port}`));if(F){let O=F,W;do W=M.find(J=>J.ppid===O.pid),W&&(O=W);while(W);U.set(P.port,{host:P.ip,port:P.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else U.set(P.port,{host:P.ip,port:P.port,ppid:Number.MAX_VALUE})}return U}e.tryFindRootPorts=y;let A=class extends n.ExtHostTunnelService{constructor(_,T,U,M){super(_,T,U),this.initData=T,this.signService=M,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,v.isLinux&&T.remote.isRemote&&T.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(_){if(_&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=_;let T;this._initialCandidates&&(T=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const U=new R.MovingAverage;let M=0;for(;this._candidateFindingEnabled;){const P=new Date().getTime(),x=(await this.findCandidatePorts()).filter(W=>(0,l.isLocalhost)(W.host)||(0,l.isAllInterfaces)(W.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${x.map(W=>W.port).join(", ")}`);const F=new Date().getTime()-P;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),M++>3&&U.update(F),(!T||JSON.stringify(T)!==JSON.stringify(x))&&(T=x,await this._proxy.$onFoundNewCandidates(T));const O=this.calculateDelay(U.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(W=>setTimeout(()=>W(),O))}}calculateDelay(_){return Math.max(_*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(_=>_.port).join(", ")}`)}async findCandidatePorts(){let _="",T="";try{_=await L.Promises.readFile("/proc/net/tcp","utf8"),T=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const U=t(_,T),M=await new Promise(G=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,Y,se)=>{G(Y)})}),P=a(M),x=await L.Promises.readdir("/proc"),F=[];for(const G of x)try{const X=Number(G),Y=p.joinPath(S.URI.file("/proc"),G);if((await L.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(X)){const Q=await L.Promises.readlink(p.joinPath(Y,"cwd").fsPath),we=await L.Promises.readFile(p.joinPath(Y,"cmdline").fsPath,"utf8");F.push({pid:X,cwd:Q,cmd:we})}}catch{}const O=[],W=U.filter(G=>{const X=P[G.socket];return X||O.push(G),X}),J=d(W,P,F);let ce;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const G=await new Promise(X=>{(0,D.exec)("ps -F -A -l | grep root",(Y,se,Q)=>{X(se)})});this._foundRootPorts=y(O,G,this._foundRootPorts),ce=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ce.map(X=>X.port).join(", ")}`)}return J.then(G=>ce?G.concat(ce):G)}makeManagedTunnelFactory(_){return async T=>{const U=new f.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(P,x,F,O){const W=await _.makeConnection();return E.connect(W,x,F,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new w.ManagedRemoteConnection(0),connectionToken:_.connectionToken})}},signService:this.signService},"localhost",T.remoteAddress.host||"localhost",T.remoteAddress.port,T.localAddressPort);await U.waitForReady();const M=new m.Emitter;return{localAddress:(0,o.parseAddress)(U.localAddress)??U.localAddress,remoteAddress:{port:U.tunnelRemotePort,host:U.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{U.dispose(),M.fire(),M.dispose()}}}}};e.NodeExtHostTunnelService=A,e.NodeExtHostTunnelService=A=Ge([We(0,i.IExtHostRpcService),We(1,s.IExtHostInitDataService),We(2,I.ILogService),We(3,C.ISignService)],A);class E extends g.ManagedSocket{static connect(_,T,U,M){const P=new k.DisposableStore,x={onClose:P.add(new m.Emitter),onData:P.add(new m.Emitter),onEnd:P.add(new m.Emitter)};P.add(_.onDidReceiveMessage(O=>x.onData.fire(N.VSBuffer.wrap(O)))),P.add(_.onDidEnd(()=>x.onEnd.fire())),P.add(_.onDidClose(O=>x.onClose.fire({type:0,error:O,hadError:!!O})));const F=new E(_,M,x);return F._register(P),(0,g.connectManagedSocket)(F,T,U,M,x)}constructor(_,T,U){super(T,U),this.passing=_}write(_){this.passing.send(_.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(ye[384],Ce([1,0,106,352,367,366,379,382,383,96,48,97,95,47,72,92,351,350,14,368,58,271,105,109,138]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.registerSingleton)(L.IExtHostExtensionService,v.ExtHostExtensionService,0),(0,D.registerSingleton)(i.ILoggerService,s.ExtHostLoggerService,1),(0,D.registerSingleton)(i.ILogService,new t.SyncDescriptor(a.ExtHostLogService,[!1],!0)),(0,D.registerSingleton)(r.ISignService,h.SignService,1),(0,D.registerSingleton)(l.IExtensionStoragePaths,f.ExtensionStoragePaths,0),(0,D.registerSingleton)(S.IExtHostDebugService,k.ExtHostDebugService,0),(0,D.registerSingleton)(I.IExtHostSearch,R.NativeExtHostSearch,0),(0,D.registerSingleton)(g.IExtHostTask,m.ExtHostTask,0),(0,D.registerSingleton)(w.IExtHostTerminalService,N.ExtHostTerminalService,0),(0,D.registerSingleton)(C.IExtHostTunnelService,p.NodeExtHostTunnelService,0),(0,D.registerSingleton)(o.IExtHostVariableResolverProvider,n.NodeExtHostVariableResolverProviderService,0)}),define(ye[395],Ce([1,0,62,396,56,8,82,120,254,114,365,22,31,103,12,132,278,292,370,384]),function(ge,e,D,N,m,k,R,v,p,S,L,I,g,w,C,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,d=c._load;c._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const n=process.exit.bind(process);function o(c){process.exit=function(d){if(c)n(d);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(c){n()};function t(){const c=(0,s.readExtHostConnection)(process.env);if(c.type===3)return new Promise((d,y)=>{const A=E=>{const b=E[0],_=new R.BufferedEmitter;b.on("message",T=>_.fire(I.VSBuffer.wrap(T.data))),b.on("close",()=>{a("renderer closed the MessagePort")}),b.start(),d({onMessage:_.event,send:T=>b.postMessage(T.buffer)})};process.parentPort.on("message",E=>A(E.ports))});if(c.type===2)return new Promise((d,y)=>{let A=null;const E=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,_=3e5,T=new C.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (1)"),b),U=new C.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (2)"),_);process.on("message",(P,x)=>{if(P&&P.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const F=I.VSBuffer.wrap(Buffer.from(P.initialDataChunk,"base64"));let O;if(P.skipWebSocketFrames)O=new v.NodeSocket(x,"extHost-socket");else{const W=I.VSBuffer.wrap(Buffer.from(P.inflateBytes,"base64"));O=new v.WebSocketNodeSocket(new v.NodeSocket(x,"extHost-socket"),P.permessageDeflate,W,!1)}A?(T.cancel(),U.cancel(),A.beginAcceptReconnection(O,F),A.endAcceptReconnection(),A.sendResume()):(clearTimeout(E),A=new R.PersistentProtocol({socket:O,initialChunk:F}),A.sendResume(),A.onDidDispose(()=>a("renderer disconnected")),d(A),A.onSocketClose(()=>{T.schedule()}))}if(P&&P.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;T.isScheduled()&&U.schedule()}});const M={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(M)});{const d=c.pipeName;return new Promise((y,A)=>{const E=D.createConnection(d,()=>{E.removeListener("error",A);const b=new R.PersistentProtocol({socket:new v.NodeSocket(E,"extHost-renderer")});b.sendResume(),y(b)});E.once("error",A),E.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,c.onMessage(d=>{(0,S.isMessageOfType)(d,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||c.send(d)}async drain(){if(c.drain)return c.drain()}}}function h(c){return new Promise(d=>{const y=c.onMessage(A=>{y.dispose();const E=JSON.parse(A.toString()),b=E.commit,_=p.default.commit;if(b&&_&&b!==_&&n(55),E.parentPid){let T=0;setInterval(function(){try{process.kill(E.parentPid,0),T=0}catch(M){M&&M.code==="EPERM"?(T++,T>=3&&a(`parent process ${E.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):a(`parent process ${E.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(E.parentPid)}catch(M){(0,k.onUnexpectedError)(M)}}c.send((0,S.createMessageOfType)(0)),d({protocol:c,initData:E})});c.send((0,S.createMessageOfType)(1))})}async function u(){const c=[];process.on("unhandledRejection",(T,U)=>{c.push(U),setTimeout(()=>{const M=c.indexOf(U);M>=0&&U.catch(P=>{c.splice(M,1),(0,k.isCancellationError)(P)||(console.warn(`rejected promise not handled within 1 second: ${P}`),P&&P.stack&&console.warn(`stack trace: ${P.stack}`),T&&(0,k.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const U=c.indexOf(T);U>=0&&c.splice(U,1)}),process.on("uncaughtException",function(T){(0,k.isSigPipeError)(T)||(0,k.onUnexpectedError)(T)}),m.mark("code/extHost/willConnectToRenderer");const d=await r();m.mark("code/extHost/didConnectToRenderer");const y=await h(d);m.mark("code/extHost/didWaitForInitData");const{initData:A}=y;o(!!A.environment.extensionTestsLocationURI),A.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,A.environment.skipWorkspaceStorageLock=(0,l.boolean)(i.skipWorkspaceStorageLock,!1);const E=new class{constructor(){this.pid=process.pid}exit(U){n(U)}fsExists(U){return g.Promises.exists(U)}fsRealpath(U){return(0,w.realpath)(U)}};let b=null;A.remote.authority&&i.transformURIs&&(b=(0,f.createURITransformer)(A.remote.authority));const _=new L.ExtensionHostMain(y.protocol,A,E,b);a=T=>_.terminate(T)}u().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c8a36a69377856369f139f39ee56dd3838130fbf/core/vs/workbench/api/node/extensionHostProcess.js.map
