/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Te=function(ge){for(var e=[],S=0,F=ge.length;S<F;S++)e[S]=Pe[ge[S]];return e};define(Pe[66],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function S(T){return(g,m,w)=>{let A=null,I=null;if(typeof w.value=="function"?(A="value",I=w.value):typeof w.get=="function"&&(A="get",I=w.get),!I)throw new Error("not supported");w[A]=T(I,m)}}function F(T,g,m){let w=null,A=null;if(typeof m.value=="function"?(w="value",A=m.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(w="get",A=m.get),!A)throw new Error("not supported");const I=`$memoize$${g}`;m[w]=function(...u){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,u)}),this[I]}}e.memoize=F;function D(T,g,m){return S((w,A)=>{const I=`$debounce$${A}`,u=`$debounce$result$${A}`;return function(...p){this[u]||(this[u]=m?m():void 0),clearTimeout(this[I]),g&&(this[u]=g(this[u],...p),p=[this[u]]),this[I]=setTimeout(()=>{w.apply(this,p),this[u]=m?m():void 0},T)}})}e.debounce=D;function R(T,g,m){return S((w,A)=>{const I=`$throttle$timer$${A}`,u=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,E=`$throttle$pending$${A}`;return function(...n){if(this[u]||(this[u]=m?m():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),g&&(this[u]=g(this[u],...n)),this[E])return;const o=this[p]+T;o<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[u]]),this[u]=m?m():void 0):(this[E]=!0,this[I]=setTimeout(()=>{this[E]=!1,this[p]=Date.now(),w.apply(this,[this[u]]),this[u]=m?m():void 0},o-Date.now()))}})}e.throttle=R}),define(Pe[89],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class S{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=S,e.defaultGenerator=new S("id#")}),define(Pe[119],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(i,s=!1){let l=0;const h=i.length;let b="",f=0,C=16,O=0;function v(U){let k=0,P=0;for(;k<U;){const Q=i.charCodeAt(l);if(Q>=48&&Q<=57)P=P*16+Q-48;else if(Q>=65&&Q<=70)P=P*16+Q-65+10;else if(Q>=97&&Q<=102)P=P*16+Q-97+10;else break;l++,k++}return k<U&&(P=-1),P}function _(U){l=U,b="",f=0,C=16,O=0}function y(){const U=l;if(i.charCodeAt(l)===48)l++;else for(l++;l<i.length&&w(i.charCodeAt(l));)l++;if(l<i.length&&i.charCodeAt(l)===46)if(l++,l<i.length&&w(i.charCodeAt(l)))for(l++;l<i.length&&w(i.charCodeAt(l));)l++;else return O=3,i.substring(U,l);let k=l;if(l<i.length&&(i.charCodeAt(l)===69||i.charCodeAt(l)===101))if(l++,(l<i.length&&i.charCodeAt(l)===43||i.charCodeAt(l)===45)&&l++,l<i.length&&w(i.charCodeAt(l))){for(l++;l<i.length&&w(i.charCodeAt(l));)l++;k=l}else O=3;return i.substring(U,k)}function M(){let U="",k=l;for(;;){if(l>=h){U+=i.substring(k,l),O=2;break}const P=i.charCodeAt(l);if(P===34){U+=i.substring(k,l),l++;break}if(P===92){if(U+=i.substring(k,l),l++,l>=h){O=2;break}switch(i.charCodeAt(l++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ae=v(4);ae>=0?U+=String.fromCharCode(ae):O=4;break}default:O=5}k=l;continue}if(P>=0&&P<=31)if(m(P)){U+=i.substring(k,l),O=2;break}else O=6;l++}return U}function V(){if(b="",O=0,f=l,l>=h)return f=h,C=17;let U=i.charCodeAt(l);if(g(U)){do l++,b+=String.fromCharCode(U),U=i.charCodeAt(l);while(g(U));return C=15}if(m(U))return l++,b+=String.fromCharCode(U),U===13&&i.charCodeAt(l)===10&&(l++,b+=`
`),C=14;switch(U){case 123:return l++,C=1;case 125:return l++,C=2;case 91:return l++,C=3;case 93:return l++,C=4;case 58:return l++,C=6;case 44:return l++,C=5;case 34:return l++,b=M(),C=10;case 47:{const k=l-1;if(i.charCodeAt(l+1)===47){for(l+=2;l<h&&!m(i.charCodeAt(l));)l++;return b=i.substring(k,l),C=12}if(i.charCodeAt(l+1)===42){l+=2;const P=h-1;let Q=!1;for(;l<P;){if(i.charCodeAt(l)===42&&i.charCodeAt(l+1)===47){l+=2,Q=!0;break}l++}return Q||(l++,O=1),b=i.substring(k,l),C=13}return b+=String.fromCharCode(U),l++,C=16}case 45:if(b+=String.fromCharCode(U),l++,l===h||!w(i.charCodeAt(l)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=y(),C=11;default:for(;l<h&&$(U);)l++,U=i.charCodeAt(l);if(f!==l){switch(b=i.substring(f,l),b){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return b+=String.fromCharCode(U),l++,C=16}}function $(U){if(g(U)||m(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let U;do U=V();while(U>=12&&U<=15);return U}return{setPosition:_,getPosition:()=>l,scan:s?L:V,getToken:()=>C,getTokenValue:()=>b,getTokenOffset:()=>f,getTokenLength:()=>l-f,getTokenError:()=>O}}e.createScanner=T;function g(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function m(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function I(i,s){const l=[],h=new Object;let b;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function O(v,_,y,M){f.value=v,f.offset=_,f.length=y,f.type=M,f.colonOffset=void 0,b=f}try{a(i,{onObjectBegin:(v,_)=>{if(s<=v)throw h;b=void 0,C=s>v,l.push("")},onObjectProperty:(v,_,y)=>{if(s<_||(O(v,_,y,"property"),l[l.length-1]=v,s<=_+y))throw h},onObjectEnd:(v,_)=>{if(s<=v)throw h;b=void 0,l.pop()},onArrayBegin:(v,_)=>{if(s<=v)throw h;b=void 0,l.push(0)},onArrayEnd:(v,_)=>{if(s<=v)throw h;b=void 0,l.pop()},onLiteralValue:(v,_,y)=>{if(s<_||(O(v,_,y,d(v)),s<=_+y))throw h},onSeparator:(v,_,y)=>{if(s<=_)throw h;if(v===":"&&b&&b.type==="property")b.colonOffset=_,C=!1,b=void 0;else if(v===","){const M=l[l.length-1];typeof M=="number"?l[l.length-1]=M+1:(C=!0,l[l.length-1]=""),b=void 0}}})}catch(v){if(v!==h)throw v}return{path:l,previousNode:b,isAtPropertyKey:C,matches:v=>{let _=0;for(let y=0;_<v.length&&y<l.length;y++)if(v[_]===l[y]||v[_]==="*")_++;else if(v[_]!=="**")return!1;return _===v.length}}}e.getLocation=I;function u(i,s=[],l=R.DEFAULT){let h=null,b=[];const f=[];function C(v){Array.isArray(b)?b.push(v):h!==null&&(b[h]=v)}return a(i,{onObjectBegin:()=>{const v={};C(v),f.push(b),b=v,h=null},onObjectProperty:v=>{h=v},onObjectEnd:()=>{b=f.pop()},onArrayBegin:()=>{const v=[];C(v),f.push(b),b=v,h=null},onArrayEnd:()=>{b=f.pop()},onLiteralValue:C,onError:(v,_,y)=>{s.push({error:v,offset:_,length:y})}},l),b[0]}e.parse=u;function p(i,s=[],l=R.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(v){h.type==="property"&&(h.length=v-h.offset,h=h.parent)}function f(v){return h.children.push(v),v}a(i,{onObjectBegin:v=>{h=f({type:"object",offset:v,length:-1,parent:h,children:[]})},onObjectProperty:(v,_,y)=>{h=f({type:"property",offset:_,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:v,offset:_,length:y,parent:h})},onObjectEnd:(v,_)=>{h.length=v+_-h.offset,h=h.parent,b(v+_)},onArrayBegin:(v,_)=>{h=f({type:"array",offset:v,length:-1,parent:h,children:[]})},onArrayEnd:(v,_)=>{h.length=v+_-h.offset,h=h.parent,b(v+_)},onLiteralValue:(v,_,y)=>{f({type:d(v),offset:_,length:y,parent:h,value:v}),b(_+y)},onSeparator:(v,_,y)=>{h.type==="property"&&(v===":"?h.colonOffset=_:v===","&&b(_))},onError:(v,_,y)=>{s.push({error:v,offset:_,length:y})}},l);const O=h.children[0];return O&&delete O.parent,O}e.parseTree=p;function E(i,s){if(!i)return;let l=i;for(const h of s)if(typeof h=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let b=!1;for(const f of l.children)if(Array.isArray(f.children)&&f.children[0].value===h){l=f.children[1],b=!0;break}if(!b)return}else{const b=h;if(l.type!=="array"||b<0||!Array.isArray(l.children)||b>=l.children.length)return;l=l.children[b]}return l}e.findNodeAtLocation=E;function n(i){if(!i.parent||!i.parent.children)return[];const s=n(i.parent);if(i.parent.type==="property"){const l=i.parent.children[0].value;s.push(l)}else if(i.parent.type==="array"){const l=i.parent.children.indexOf(i);l!==-1&&s.push(l)}return s}e.getNodePath=n;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const s=Object.create(null);for(const l of i.children){const h=l.children[1];h&&(s[l.children[0].value]=o(h))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=o;function t(i,s,l=!1){return s>=i.offset&&s<i.offset+i.length||l&&s===i.offset+i.length}e.contains=t;function r(i,s,l=!1){if(t(i,s,l)){const h=i.children;if(Array.isArray(h))for(let b=0;b<h.length&&h[b].offset<=s;b++){const f=r(h[b],s,l);if(f)return f}return i}}e.findNodeAtOffset=r;function a(i,s,l=R.DEFAULT){const h=T(i,!1);function b(te){return te?()=>te(h.getTokenOffset(),h.getTokenLength()):()=>!0}function f(te){return te?Ie=>te(Ie,h.getTokenOffset(),h.getTokenLength()):()=>!0}const C=b(s.onObjectBegin),O=f(s.onObjectProperty),v=b(s.onObjectEnd),_=b(s.onArrayBegin),y=b(s.onArrayEnd),M=f(s.onLiteralValue),V=f(s.onSeparator),$=b(s.onComment),L=f(s.onError),U=l&&l.disallowComments,k=l&&l.allowTrailingComma;function P(){for(;;){const te=h.scan();switch(h.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:U||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(te){case 12:case 13:U?Q(10):$();break;case 16:Q(1);break;case 15:case 14:break;default:return te}}}function Q(te,Ie=[],oe=[]){if(L(te),Ie.length+oe.length>0){let Y=h.getToken();for(;Y!==17;){if(Ie.indexOf(Y)!==-1){P();break}else if(oe.indexOf(Y)!==-1)break;Y=P()}}}function ae(te){const Ie=h.getTokenValue();return te?M(Ie):O(Ie),P(),!0}function me(){switch(h.getToken()){case 11:{let te=0;try{te=JSON.parse(h.getTokenValue()),typeof te!="number"&&(Q(2),te=0)}catch{Q(2)}M(te);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return P(),!0}function Ee(){return h.getToken()!==10?(Q(3,[],[2,5]),!1):(ae(!1),h.getToken()===6?(V(":"),P(),de()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function Ce(){C(),P();let te=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(te||Q(4,[],[]),V(","),P(),h.getToken()===2&&k)break}else te&&Q(6,[],[]);Ee()||Q(4,[],[2,5]),te=!0}return v(),h.getToken()!==2?Q(7,[2],[]):P(),!0}function he(){_(),P();let te=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(te||Q(4,[],[]),V(","),P(),h.getToken()===4&&k)break}else te&&Q(6,[],[]);de()||Q(4,[],[4,5]),te=!0}return y(),h.getToken()!==4?Q(8,[4],[]):P(),!0}function de(){switch(h.getToken()){case 3:return he();case 1:return Ce();case 10:return ae(!0);default:return me()}}return P(),h.getToken()===17?l.allowEmptyContent?!0:(Q(4,[],[]),!1):de()?(h.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=a;function c(i,s){const l=T(i),h=[];let b,f=0,C;do switch(C=l.getPosition(),b=l.scan(),b){case 12:case 13:case 17:f!==C&&h.push(i.substring(f,C)),s!==void 0&&h.push(l.getTokenValue().replace(/[^\r\n]/g,s)),f=l.getPosition();break}while(b!==17);return h.join("")}e.stripComments=c;function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),function(ge,e){typeof define=="function"&&define.amd?define(Pe[120],Te([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(ke,ce){for(var ie=0;ie<ce.length;ie++){var G=ce[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ke,G.key,G)}}function S(ke,ce,ie){return ce&&e(ke.prototype,ce),ie&&e(ke,ie),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function F(ke,ce){if(ke){if(typeof ke=="string")return D(ke,ce);var ie=Object.prototype.toString.call(ke).slice(8,-1);if(ie==="Object"&&ke.constructor&&(ie=ke.constructor.name),ie==="Map"||ie==="Set")return Array.from(ke);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return D(ke,ce)}}function D(ke,ce){(ce==null||ce>ke.length)&&(ce=ke.length);for(var ie=0,G=new Array(ce);ie<ce;ie++)G[ie]=ke[ie];return G}function R(ke,ce){var ie=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(ie)return(ie=ie.call(ke)).next.bind(ie);if(Array.isArray(ke)||(ie=F(ke))||ce&&ke&&typeof ke.length=="number"){ie&&(ke=ie);var G=0;return function(){return G>=ke.length?{done:!0}:{done:!1,value:ke[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=T();function g(ke){ge.defaults=ke}var m=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ce){return u[ce]};function E(ke,ce){if(ce){if(m.test(ke))return ke.replace(w,p)}else if(A.test(ke))return ke.replace(I,p);return ke}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ke){return ke.replace(n,function(ce,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var t=/(^|[^\[])\^/g;function r(ke,ce){ke=typeof ke=="string"?ke:ke.source,ce=ce||"";var ie={replace:function(ee,pe){return pe=pe.source||pe,pe=pe.replace(t,"$1"),ke=ke.replace(ee,pe),ie},getRegex:function(){return new RegExp(ke,ce)}};return ie}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(ke,ce,ie){if(ke){var G;try{G=decodeURIComponent(o(ie)).replace(a,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}ce&&!c.test(ie)&&(ie=b(ce,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var i={},s=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(ke,ce){i[" "+ke]||(s.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=v(ke,"/",!0)),ke=i[" "+ke];var ie=ke.indexOf(":")===-1;return ce.substring(0,2)==="//"?ie?ce:ke.replace(l,"$1")+ce:ce.charAt(0)==="/"?ie?ce:ke.replace(h,"$1")+ce:ke+ce}var f={exec:function(){}};function C(ke){for(var ce=1,ie,G;ce<arguments.length;ce++){ie=arguments[ce];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(ke[G]=ie[G])}return ke}function O(ke,ce){var ie=ke.replace(/\|/g,function(pe,be,Le){for(var ue=!1,we=be;--we>=0&&Le[we]==="\\";)ue=!ue;return ue?"|":" |"}),G=ie.split(/ \|/),ee=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>ce)G.splice(ce);else for(;G.length<ce;)G.push("");for(;ee<G.length;ee++)G[ee]=G[ee].trim().replace(/\\\|/g,"|");return G}function v(ke,ce,ie){var G=ke.length;if(G===0)return"";for(var ee=0;ee<G;){var pe=ke.charAt(G-ee-1);if(pe===ce&&!ie)ee++;else if(pe!==ce&&ie)ee++;else break}return ke.slice(0,G-ee)}function _(ke,ce){if(ke.indexOf(ce[1])===-1)return-1;for(var ie=ke.length,G=0,ee=0;ee<ie;ee++)if(ke[ee]==="\\")ee++;else if(ke[ee]===ce[0])G++;else if(ke[ee]===ce[1]&&(G--,G<0))return ee;return-1}function y(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(ke,ce){if(ce<1)return"";for(var ie="";ce>1;)ce&1&&(ie+=ke),ce>>=1,ke+=ke;return ie+ke}function V(ke,ce,ie,G){var ee=ce.href,pe=ce.title?E(ce.title):null,be=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){G.state.inLink=!0;var Le={type:"link",raw:ie,href:ee,title:pe,text:be,tokens:G.inlineTokens(be)};return G.state.inLink=!1,Le}return{type:"image",raw:ie,href:ee,title:pe,text:E(be)}}function $(ke,ce){var ie=ke.match(/^(\s+)(?:```)/);if(ie===null)return ce;var G=ie[1];return ce.split(`
`).map(function(ee){var pe=ee.match(/^\s+/);if(pe===null)return ee;var be=pe[0];return be.length>=G.length?ee.slice(G.length):ee}).join(`
`)}var L=function(){function ke(ie){this.options=ie||ge.defaults}var ce=ke.prototype;return ce.space=function(G){var ee=this.rules.block.newline.exec(G);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ce.code=function(G){var ee=this.rules.block.code.exec(G);if(ee){var pe=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:v(pe,`
`)}}},ce.fences=function(G){var ee=this.rules.block.fences.exec(G);if(ee){var pe=ee[0],be=$(pe,ee[3]||"");return{type:"code",raw:pe,lang:ee[2]?ee[2].trim():ee[2],text:be}}},ce.heading=function(G){var ee=this.rules.block.heading.exec(G);if(ee){var pe=ee[2].trim();if(/#$/.test(pe)){var be=v(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ce.hr=function(G){var ee=this.rules.block.hr.exec(G);if(ee)return{type:"hr",raw:ee[0]}},ce.blockquote=function(G){var ee=this.rules.block.blockquote.exec(G);if(ee){var pe=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ce.list=function(G){var ee=this.rules.block.list.exec(G);if(ee){var pe,be,Le,ue,we,N,W,q,B,K,Z,_e,Fe=ee[1].trim(),ze=Fe.length>1,qe={type:"list",raw:"",ordered:ze,start:ze?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=ze?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=ze?Fe:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(_e=!1,!(!(ee=Qe.exec(G))||this.rules.block.hr.test(G)));){if(pe=ee[0],G=G.substring(pe.length),q=ee[2].split(`
`,1)[0],B=G.split(`
`,1)[0],this.options.pedantic?(ue=2,Z=q.trimLeft()):(ue=ee[2].search(/[^ ]/),ue=ue>4?1:ue,Z=q.slice(ue),ue+=ee[1].length),N=!1,!q&&/^ *$/.test(B)&&(pe+=B+`
`,G=G.substring(B.length+1),_e=!0),!_e)for(var rt=new RegExp("^ {0,"+Math.min(3,ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,ue-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,ue-1)+"}#");G&&(K=G.split(`
`,1)[0],q=K,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(q)||ot.test(q)||rt.test(q)||it.test(G)));){if(q.search(/[^ ]/)>=ue||!q.trim())Z+=`
`+q.slice(ue);else if(!N)Z+=`
`+q;else break;!N&&!q.trim()&&(N=!0),pe+=K+`
`,G=G.substring(K.length+1)}qe.loose||(W?qe.loose=!0:/\n *\n *$/.test(pe)&&(W=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(Z),be&&(Le=be[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:pe,task:!!be,checked:Le,loose:!1,text:Z}),qe.raw+=pe}qe.items[qe.items.length-1].raw=pe.trimRight(),qe.items[qe.items.length-1].text=Z.trimRight(),qe.raw=qe.raw.trimRight();var at=qe.items.length;for(we=0;we<at;we++){this.lexer.state.top=!1,qe.items[we].tokens=this.lexer.blockTokens(qe.items[we].text,[]);var Ue=qe.items[we].tokens.filter(function(X){return X.type==="space"}),vt=Ue.every(function(X){for(var J=X.raw.split(""),ve=0,$e=R(J),Ge;!(Ge=$e()).done;){var tt=Ge.value;if(tt===`
`&&(ve+=1),ve>1)return!0}return!1});!qe.loose&&Ue.length&&vt&&(qe.loose=!0,qe.items[we].loose=!0)}return qe}},ce.html=function(G){var ee=this.rules.block.html.exec(G);if(ee){var pe={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ee[0]):E(ee[0]);pe.type="paragraph",pe.text=be,pe.tokens=this.lexer.inline(be)}return pe}},ce.def=function(G){var ee=this.rules.block.def.exec(G);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var pe=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ee[0],href:ee[2],title:ee[3]}}},ce.table=function(G){var ee=this.rules.block.table.exec(G);if(ee){var pe={type:"table",header:O(ee[1]).map(function(W){return{text:W}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ee[0];var be=pe.align.length,Le,ue,we,N;for(Le=0;Le<be;Le++)/^ *-+: *$/.test(pe.align[Le])?pe.align[Le]="right":/^ *:-+: *$/.test(pe.align[Le])?pe.align[Le]="center":/^ *:-+ *$/.test(pe.align[Le])?pe.align[Le]="left":pe.align[Le]=null;for(be=pe.rows.length,Le=0;Le<be;Le++)pe.rows[Le]=O(pe.rows[Le],pe.header.length).map(function(W){return{text:W}});for(be=pe.header.length,ue=0;ue<be;ue++)pe.header[ue].tokens=this.lexer.inline(pe.header[ue].text);for(be=pe.rows.length,ue=0;ue<be;ue++)for(N=pe.rows[ue],we=0;we<N.length;we++)N[we].tokens=this.lexer.inline(N[we].text);return pe}}},ce.lheading=function(G){var ee=this.rules.block.lheading.exec(G);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ce.paragraph=function(G){var ee=this.rules.block.paragraph.exec(G);if(ee){var pe=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:pe,tokens:this.lexer.inline(pe)}}},ce.text=function(G){var ee=this.rules.block.text.exec(G);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ce.escape=function(G){var ee=this.rules.inline.escape.exec(G);if(ee)return{type:"escape",raw:ee[0],text:E(ee[1])}},ce.tag=function(G){var ee=this.rules.inline.tag.exec(G);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):E(ee[0]):ee[0]}},ce.link=function(G){var ee=this.rules.inline.link.exec(G);if(ee){var pe=ee[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=v(pe.slice(0,-1),"\\");if((pe.length-be.length)%2===0)return}else{var Le=_(ee[2],"()");if(Le>-1){var ue=ee[0].indexOf("!")===0?5:4,we=ue+ee[1].length+Le;ee[2]=ee[2].substring(0,Le),ee[0]=ee[0].substring(0,we).trim(),ee[3]=""}}var N=ee[2],W="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(N);q&&(N=q[1],W=q[3])}else W=ee[3]?ee[3].slice(1,-1):"";return N=N.trim(),/^</.test(N)&&(this.options.pedantic&&!/>$/.test(pe)?N=N.slice(1):N=N.slice(1,-1)),V(ee,{href:N&&N.replace(this.rules.inline._escapes,"$1"),title:W&&W.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ce.reflink=function(G,ee){var pe;if((pe=this.rules.inline.reflink.exec(G))||(pe=this.rules.inline.nolink.exec(G))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ee[be.toLowerCase()],!be||!be.href){var Le=pe[0].charAt(0);return{type:"text",raw:Le,text:Le}}return V(pe,be,pe[0],this.lexer)}},ce.emStrong=function(G,ee,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(G);if(be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=be[1]||be[2]||"";if(!Le||Le&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ue=be[0].length-1,we,N,W=ue,q=0,B=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,ee=ee.slice(-1*G.length+ue);(be=B.exec(ee))!=null;)if(we=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!we){if(N=we.length,be[3]||be[4]){W+=N;continue}else if((be[5]||be[6])&&ue%3&&!((ue+N)%3)){q+=N;continue}if(W-=N,!(W>0)){if(N=Math.min(N,N+W+q),Math.min(ue,N)%2){var K=G.slice(1,ue+be.index+N);return{type:"em",raw:G.slice(0,ue+be.index+N+1),text:K,tokens:this.lexer.inlineTokens(K)}}var Z=G.slice(2,ue+be.index+N-1);return{type:"strong",raw:G.slice(0,ue+be.index+N+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},ce.codespan=function(G){var ee=this.rules.inline.code.exec(G);if(ee){var pe=ee[2].replace(/\n/g," "),be=/[^ ]/.test(pe),Le=/^ /.test(pe)&&/ $/.test(pe);return be&&Le&&(pe=pe.substring(1,pe.length-1)),pe=E(pe,!0),{type:"codespan",raw:ee[0],text:pe}}},ce.br=function(G){var ee=this.rules.inline.br.exec(G);if(ee)return{type:"br",raw:ee[0]}},ce.del=function(G){var ee=this.rules.inline.del.exec(G);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ce.autolink=function(G,ee){var pe=this.rules.inline.autolink.exec(G);if(pe){var be,Le;return pe[2]==="@"?(be=E(this.options.mangle?ee(pe[1]):pe[1]),Le="mailto:"+be):(be=E(pe[1]),Le=be),{type:"link",raw:pe[0],text:be,href:Le,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(G,ee){var pe;if(pe=this.rules.inline.url.exec(G)){var be,Le;if(pe[2]==="@")be=E(this.options.mangle?ee(pe[0]):pe[0]),Le="mailto:"+be;else{var ue;do ue=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ue!==pe[0]);be=E(pe[0]),pe[1]==="www."?Le="http://"+be:Le=be}return{type:"link",raw:pe[0],text:be,href:Le,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(G,ee){var pe=this.rules.inline.text.exec(G);if(pe){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):E(pe[0]):pe[0]:be=E(this.options.smartypants?ee(pe[0]):pe[0]),{type:"text",raw:pe[0],text:be}}},ke}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=r(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=r(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=r(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=r(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=r(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=r(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=C({},U),U.gfm=C({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=r(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=r(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=C({},U.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:r(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var k={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};k._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",k.punctuation=r(k.punctuation).replace(/punctuation/g,k._punctuation).getRegex(),k.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,k.escapedEmSt=/\\\*|\\_/g,k._comment=r(U._comment).replace("(?:-->|$)","-->").getRegex(),k.emStrong.lDelim=r(k.emStrong.lDelim).replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimAst=r(k.emStrong.rDelimAst,"g").replace(/punct/g,k._punctuation).getRegex(),k.emStrong.rDelimUnd=r(k.emStrong.rDelimUnd,"g").replace(/punct/g,k._punctuation).getRegex(),k._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,k._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,k._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,k.autolink=r(k.autolink).replace("scheme",k._scheme).replace("email",k._email).getRegex(),k._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,k.tag=r(k.tag).replace("comment",k._comment).replace("attribute",k._attribute).getRegex(),k._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,k._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,k._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,k.link=r(k.link).replace("label",k._label).replace("href",k._href).replace("title",k._title).getRegex(),k.reflink=r(k.reflink).replace("label",k._label).replace("ref",U._label).getRegex(),k.nolink=r(k.nolink).replace("ref",U._label).getRegex(),k.reflinkSearch=r(k.reflinkSearch,"g").replace("reflink",k.reflink).replace("nolink",k.nolink).getRegex(),k.normal=C({},k),k.pedantic=C({},k.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",k._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",k._label).getRegex()}),k.gfm=C({},k.normal,{escape:r(k.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),k.gfm.url=r(k.gfm.url,"i").replace("email",k.gfm._extended_email).getRegex(),k.breaks=C({},k.gfm,{br:r(k.br).replace("{2,}","*").getRegex(),text:r(k.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function P(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(ke){var ce="",ie,G,ee=ke.length;for(ie=0;ie<ee;ie++)G=ke.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),ce+="&#"+G+";";return ce}var ae=function(){function ke(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||ge.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:U.normal,inline:k.normal};this.options.pedantic?(G.block=U.pedantic,G.inline=k.pedantic):this.options.gfm&&(G.block=U.gfm,this.options.breaks?G.inline=k.breaks:G.inline=k.gfm),this.tokenizer.rules=G}ke.lex=function(G,ee){var pe=new ke(ee);return pe.lex(G)},ke.lexInline=function(G,ee){var pe=new ke(ee);return pe.inlineTokens(G)};var ce=ke.prototype;return ce.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ce.blockTokens=function(G,ee){var pe=this;ee===void 0&&(ee=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(W,q,B){return q+"    ".repeat(B.length)});for(var be,Le,ue,we;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(W){return(be=W.call({lexer:pe},G,ee))?(G=G.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.space(G)){G=G.substring(be.raw.length),be.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(be);continue}if(be=this.tokenizer.code(G)){G=G.substring(be.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be);continue}if(be=this.tokenizer.fences(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.heading(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.hr(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.blockquote(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.list(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.html(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.def(G)){G=G.substring(be.raw.length),Le=ee[ee.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.lheading(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(ue=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var W=1/0,q=G.slice(1),B=void 0;pe.options.extensions.startBlock.forEach(function(K){B=K.call({lexer:this},q),typeof B=="number"&&B>=0&&(W=Math.min(W,B))}),W<1/0&&W>=0&&(ue=G.substring(0,W+1))}(),this.state.top&&(be=this.tokenizer.paragraph(ue))){Le=ee[ee.length-1],we&&Le.type==="paragraph"?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be),we=ue.length!==G.length,G=G.substring(be.raw.length);continue}if(be=this.tokenizer.text(G)){G=G.substring(be.raw.length),Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+be.raw,Le.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):ee.push(be);continue}if(G){var N="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(N);break}else throw new Error(N)}}return this.state.top=!0,ee},ce.inline=function(G,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:G,tokens:ee}),ee},ce.inlineTokens=function(G,ee){var pe=this;ee===void 0&&(ee=[]);var be,Le,ue,we=G,N,W,q;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(N=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)B.includes(N[0].slice(N[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,N.index)+"["+M("a",N[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(N=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,N.index)+"["+M("a",N[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(N=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,N.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(W||(q=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(be=Z.call({lexer:pe},G,ee))?(G=G.substring(be.raw.length),ee.push(be),!0):!1}))){if(be=this.tokenizer.escape(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.tag(G)){G=G.substring(be.raw.length),Le=ee[ee.length-1],Le&&be.type==="text"&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.link(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(be.raw.length),Le=ee[ee.length-1],Le&&be.type==="text"&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(be=this.tokenizer.emStrong(G,we,q)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.codespan(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.br(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.del(G)){G=G.substring(be.raw.length),ee.push(be);continue}if(be=this.tokenizer.autolink(G,Q)){G=G.substring(be.raw.length),ee.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(G,Q))){G=G.substring(be.raw.length),ee.push(be);continue}if(ue=G,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,_e=G.slice(1),Fe=void 0;pe.options.extensions.startInline.forEach(function(ze){Fe=ze.call({lexer:this},_e),typeof Fe=="number"&&Fe>=0&&(Z=Math.min(Z,Fe))}),Z<1/0&&Z>=0&&(ue=G.substring(0,Z+1))}(),be=this.tokenizer.inlineText(ue,P)){G=G.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(q=be.raw.slice(-1)),W=!0,Le=ee[ee.length-1],Le&&Le.type==="text"?(Le.raw+=be.raw,Le.text+=be.text):ee.push(be);continue}if(G){var K="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return ee},S(ke,null,[{key:"rules",get:function(){return{block:U,inline:k}}}]),ke}(),me=function(){function ke(ie){this.options=ie||ge.defaults}var ce=ke.prototype;return ce.code=function(G,ee,pe){var be=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(G,be);Le!=null&&Le!==G&&(pe=!0,G=Le)}return G=G.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+E(be,!0)+'">'+(pe?G:E(G,!0))+`</code></pre>
`:"<pre><code>"+(pe?G:E(G,!0))+`</code></pre>
`},ce.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},ce.html=function(G){return G},ce.heading=function(G,ee,pe,be){if(this.options.headerIds){var Le=this.options.headerPrefix+be.slug(pe);return"<h"+ee+' id="'+Le+'">'+G+"</h"+ee+`>
`}return"<h"+ee+">"+G+"</h"+ee+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(G,ee,pe){var be=ee?"ol":"ul",Le=ee&&pe!==1?' start="'+pe+'"':"";return"<"+be+Le+`>
`+G+"</"+be+`>
`},ce.listitem=function(G){return"<li>"+G+`</li>
`},ce.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(G){return"<p>"+G+`</p>
`},ce.table=function(G,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ee+`</table>
`},ce.tablerow=function(G){return`<tr>
`+G+`</tr>
`},ce.tablecell=function(G,ee){var pe=ee.header?"th":"td",be=ee.align?"<"+pe+' align="'+ee.align+'">':"<"+pe+">";return be+G+("</"+pe+`>
`)},ce.strong=function(G){return"<strong>"+G+"</strong>"},ce.em=function(G){return"<em>"+G+"</em>"},ce.codespan=function(G){return"<code>"+G+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(G){return"<del>"+G+"</del>"},ce.link=function(G,ee,pe){if(G=d(this.options.sanitize,this.options.baseUrl,G),G===null)return pe;var be='<a href="'+E(G)+'"';return ee&&(be+=' title="'+ee+'"'),be+=">"+pe+"</a>",be},ce.image=function(G,ee,pe){if(G=d(this.options.sanitize,this.options.baseUrl,G),G===null)return pe;var be='<img src="'+G+'" alt="'+pe+'"';return ee&&(be+=' title="'+ee+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(G){return G},ke}(),Ee=function(){function ke(){}var ce=ke.prototype;return ce.strong=function(G){return G},ce.em=function(G){return G},ce.codespan=function(G){return G},ce.del=function(G){return G},ce.html=function(G){return G},ce.text=function(G){return G},ce.link=function(G,ee,pe){return""+pe},ce.image=function(G,ee,pe){return""+pe},ce.br=function(){return""},ke}(),Ce=function(){function ke(){this.seen={}}var ce=ke.prototype;return ce.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(G,ee){var pe=G,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[G];do be++,pe=G+"-"+be;while(this.seen.hasOwnProperty(pe))}return ee||(this.seen[G]=be,this.seen[pe]=0),pe},ce.slug=function(G,ee){ee===void 0&&(ee={});var pe=this.serialize(G);return this.getNextSafeSlug(pe,ee.dryrun)},ke}(),he=function(){function ke(ie){this.options=ie||ge.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new Ce}ke.parse=function(G,ee){var pe=new ke(ee);return pe.parse(G)},ke.parseInline=function(G,ee){var pe=new ke(ee);return pe.parseInline(G)};var ce=ke.prototype;return ce.parse=function(G,ee){ee===void 0&&(ee=!0);var pe="",be,Le,ue,we,N,W,q,B,K,Z,_e,Fe,ze,qe,Qe,rt,it,et,ot,at=G.length;for(be=0;be<at;be++){if(Z=G[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(ot=this.options.extensions.renderers[Z.type].call({parser:this},Z),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){pe+=ot||"";continue}switch(Z.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,o(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(B="",q="",we=Z.header.length,Le=0;Le<we;Le++)q+=this.renderer.tablecell(this.parseInline(Z.header[Le].tokens),{header:!0,align:Z.align[Le]});for(B+=this.renderer.tablerow(q),K="",we=Z.rows.length,Le=0;Le<we;Le++){for(W=Z.rows[Le],q="",N=W.length,ue=0;ue<N;ue++)q+=this.renderer.tablecell(this.parseInline(W[ue].tokens),{header:!1,align:Z.align[ue]});K+=this.renderer.tablerow(q)}pe+=this.renderer.table(B,K);continue}case"blockquote":{K=this.parse(Z.tokens),pe+=this.renderer.blockquote(K);continue}case"list":{for(_e=Z.ordered,Fe=Z.start,ze=Z.loose,we=Z.items.length,K="",Le=0;Le<we;Le++)Qe=Z.items[Le],rt=Qe.checked,it=Qe.task,qe="",Qe.task&&(et=this.renderer.checkbox(rt),ze?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=et+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=et+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:et}):qe+=et),qe+=this.parse(Qe.tokens,ze),K+=this.renderer.listitem(qe,it,rt);pe+=this.renderer.list(K,_e,Fe);continue}case"html":{pe+=this.renderer.html(Z.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(K=Z.tokens?this.parseInline(Z.tokens):Z.text;be+1<at&&G[be+1].type==="text";)Z=G[++be],K+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);pe+=ee?this.renderer.paragraph(K):K;continue}default:{var Ue='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(Ue);return}else throw new Error(Ue)}}}return pe},ce.parseInline=function(G,ee){ee=ee||this.renderer;var pe="",be,Le,ue,we=G.length;for(be=0;be<we;be++){if(Le=G[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(ue=this.options.extensions.renderers[Le.type].call({parser:this},Le),ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){pe+=ue||"";continue}switch(Le.type){case"escape":{pe+=ee.text(Le.text);break}case"html":{pe+=ee.html(Le.text);break}case"link":{pe+=ee.link(Le.href,Le.title,this.parseInline(Le.tokens,ee));break}case"image":{pe+=ee.image(Le.href,Le.title,Le.text);break}case"strong":{pe+=ee.strong(this.parseInline(Le.tokens,ee));break}case"em":{pe+=ee.em(this.parseInline(Le.tokens,ee));break}case"codespan":{pe+=ee.codespan(Le.text);break}case"br":{pe+=ee.br();break}case"del":{pe+=ee.del(this.parseInline(Le.tokens,ee));break}case"text":{pe+=ee.text(Le.text);break}default:{var N='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(N);return}else throw new Error(N)}}}return pe},ke}();function de(ke,ce,ie){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ce=="function"&&(ie=ce,ce=null),ce=C({},de.defaults,ce||{}),y(ce),ie){var G=ce.highlight,ee;try{ee=ae.lex(ke,ce)}catch(we){return ie(we)}var pe=function(N){var W;if(!N)try{ce.walkTokens&&de.walkTokens(ee,ce.walkTokens),W=he.parse(ee,ce)}catch(q){N=q}return ce.highlight=G,N?ie(N):ie(null,W)};if(!G||G.length<3||(delete ce.highlight,!ee.length))return pe();var be=0;de.walkTokens(ee,function(we){we.type==="code"&&(be++,setTimeout(function(){G(we.text,we.lang,function(N,W){if(N)return pe(N);W!=null&&W!==we.text&&(we.text=W,we.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}function Le(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+E(we.message+"",!0)+"</pre>";throw we}try{var ue=ae.lex(ke,ce);if(ce.walkTokens){if(ce.async)return Promise.all(de.walkTokens(ue,ce.walkTokens)).then(function(){return he.parse(ue,ce)}).catch(Le);de.walkTokens(ue,ce.walkTokens)}return he.parse(ue,ce)}catch(we){Le(we)}}de.options=de.setOptions=function(ke){return C(de.defaults,ke),g(de.defaults),de},de.getDefaults=T,de.defaults=ge.defaults,de.use=function(){for(var ke=arguments.length,ce=new Array(ke),ie=0;ie<ke;ie++)ce[ie]=arguments[ie];var G=C.apply(void 0,[{}].concat(ce)),ee=de.defaults.extensions||{renderers:{},childTokens:{}},pe;ce.forEach(function(be){if(be.extensions&&(pe=!0,be.extensions.forEach(function(ue){if(!ue.name)throw new Error("extension name required");if(ue.renderer){var we=ee.renderers?ee.renderers[ue.name]:null;we?ee.renderers[ue.name]=function(){for(var N=arguments.length,W=new Array(N),q=0;q<N;q++)W[q]=arguments[q];var B=ue.renderer.apply(this,W);return B===!1&&(B=we.apply(this,W)),B}:ee.renderers[ue.name]=ue.renderer}if(ue.tokenizer){if(!ue.level||ue.level!=="block"&&ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[ue.level]?ee[ue.level].unshift(ue.tokenizer):ee[ue.level]=[ue.tokenizer],ue.start&&(ue.level==="block"?ee.startBlock?ee.startBlock.push(ue.start):ee.startBlock=[ue.start]:ue.level==="inline"&&(ee.startInline?ee.startInline.push(ue.start):ee.startInline=[ue.start]))}ue.childTokens&&(ee.childTokens[ue.name]=ue.childTokens)})),be.renderer&&function(){var ue=de.defaults.renderer||new me,we=function(q){var B=ue[q];ue[q]=function(){for(var K=arguments.length,Z=new Array(K),_e=0;_e<K;_e++)Z[_e]=arguments[_e];var Fe=be.renderer[q].apply(ue,Z);return Fe===!1&&(Fe=B.apply(ue,Z)),Fe}};for(var N in be.renderer)we(N);G.renderer=ue}(),be.tokenizer&&function(){var ue=de.defaults.tokenizer||new L,we=function(q){var B=ue[q];ue[q]=function(){for(var K=arguments.length,Z=new Array(K),_e=0;_e<K;_e++)Z[_e]=arguments[_e];var Fe=be.tokenizer[q].apply(ue,Z);return Fe===!1&&(Fe=B.apply(ue,Z)),Fe}};for(var N in be.tokenizer)we(N);G.tokenizer=ue}(),be.walkTokens){var Le=de.defaults.walkTokens;G.walkTokens=function(ue){var we=[];return we.push(be.walkTokens.call(this,ue)),Le&&(we=we.concat(Le.call(this,ue))),we}}pe&&(G.extensions=ee),de.setOptions(G)})},de.walkTokens=function(ke,ce){for(var ie=[],G=function(){var Le=pe.value;switch(ie=ie.concat(ce.call(de,Le)),Le.type){case"table":{for(var ue=R(Le.header),we;!(we=ue()).done;){var N=we.value;ie=ie.concat(de.walkTokens(N.tokens,ce))}for(var W=R(Le.rows),q;!(q=W()).done;)for(var B=q.value,K=R(B),Z;!(Z=K()).done;){var _e=Z.value;ie=ie.concat(de.walkTokens(_e.tokens,ce))}break}case"list":{ie=ie.concat(de.walkTokens(Le.items,ce));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[Le.type]?de.defaults.extensions.childTokens[Le.type].forEach(function(Fe){ie=ie.concat(de.walkTokens(Le[Fe],ce))}):Le.tokens&&(ie=ie.concat(de.walkTokens(Le.tokens,ce)))}},ee=R(ke),pe;!(pe=ee()).done;)G();return ie},de.parseInline=function(ke,ce){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ce=C({},de.defaults,ce||{}),y(ce);try{var ie=ae.lexInline(ke,ce);return ce.walkTokens&&de.walkTokens(ie,ce.walkTokens),he.parseInline(ie,ce)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+E(G.message+"",!0)+"</pre>";throw G}},de.Parser=he,de.parser=he.parse,de.Renderer=me,de.TextRenderer=Ee,de.Lexer=ae,de.lexer=ae.lex,de.Tokenizer=L,de.Slugger=Ce,de.parse=de;var te=de.options,Ie=de.setOptions,oe=de.use,Y=de.walkTokens,H=de.parseInline,ne=de,De=he.parse,Re=ae.lex;ge.Lexer=ae,ge.Parser=he,ge.Renderer=me,ge.Slugger=Ce,ge.TextRenderer=Ee,ge.Tokenizer=L,ge.getDefaults=T,ge.lexer=Re,ge.marked=de,ge.options=te,ge.parse=ne,ge.parseInline=H,ge.parser=De,ge.setOptions=Ie,ge.use=oe,ge.walkTokens=Y,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Pe[121],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=void 0;function S(n){const o=R(n);if(o&&o.length>0)return new Uint32Array(o)}e.getKoreanAltChars=S;let F=0;const D=new Uint32Array(10);function R(n){if(F=0,T(n,I,4352),F>0||(T(n,u,4449),F>0)||(T(n,p,4520),F>0)||(T(n,E,12593),F))return D.subarray(0,F);if(n>=44032&&n<=55203){const o=n-44032,t=o%588,r=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(r<I.length?T(r,I,0):4352+r-12593<E.length&&T(4352+r,E,12593),a<u.length?T(a,u,0):4449+a-12593<E.length&&T(4449+a-12593,E,12593),c>=0&&(c<p.length?T(c,p,0):4520+c-12593<E.length&&T(4520+c-12593,E,12593)),F>0)return D.subarray(0,F)}}function T(n,o,t){n>=t&&n<t+o.length&&g(o[n-t])}function g(n){n!==0&&(D[F++]=n&255,n>>8&&(D[F++]=n>>8&255),n>>16&&(D[F++]=n>>16&255))}var m;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var w;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(w||(w={}));var A;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(A||(A={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),E=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[122],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(g,m,w){return Math.min(Math.max(g,m),w)}e.clamp=S;function F(g,m){return(m+g%m)%m}e.rot=F;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class R{constructor(){this._n=1,this._val=0}update(m){return this._val=this._val+(m-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=R;class T{constructor(m){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(m),this._values.fill(0,0,m)}update(m){const w=this._values[this._index];return this._values[this._index]=m,this._index=(this._index+1)%this._values.length,this._sum-=w,this._sum+=m,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function ge(D){const R=[];typeof D=="number"&&R.push("code/timeOrigin",D);function T(m){R.push(m,Date.now())}function g(){const m=[];for(let w=0;w<R.length;w+=2)m.push({name:R[w],startTime:R[w+1]});return m}return{mark:T,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(D+T.startTime)});return R}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function S(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=S(F))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var F in S)(typeof exports=="object"?exports:ge)[F]=S[F]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function S(F){if(e[F])return e[F].exports;var D=e[F]={i:F,l:!1,exports:{}};return ge[F].call(D.exports,D,D.exports,S),D.l=!0,D.exports}return S.m=ge,S.c=e,S.d=function(F,D,R){S.o(F,D)||Object.defineProperty(F,D,{enumerable:!0,get:R})},S.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},S.t=function(F,D){if(1&D&&(F=S(F)),8&D||4&D&&typeof F=="object"&&F&&F.__esModule)return F;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:F}),2&D&&typeof F!="string")for(var T in F)S.d(R,T,function(g){return F[g]}.bind(null,T));return R},S.n=function(F){var D=F&&F.__esModule?function(){return F.default}:function(){return F};return S.d(D,"a",D),D},S.o=function(F,D){return Object.prototype.hasOwnProperty.call(F,D)},S.p="",S(S.s=0)}([function(ge,e,S){(function(F){var D;e=ge.exports=oe,D=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],m=e.src=[],w=0,A=w++;m[A]="0|[1-9]\\d*";var I=w++;m[I]="[0-9]+";var u=w++;m[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;m[p]="("+m[A]+")\\.("+m[A]+")\\.("+m[A]+")";var E=w++;m[E]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var n=w++;m[n]="(?:"+m[A]+"|"+m[u]+")";var o=w++;m[o]="(?:"+m[I]+"|"+m[u]+")";var t=w++;m[t]="(?:-("+m[n]+"(?:\\."+m[n]+")*))";var r=w++;m[r]="(?:-?("+m[o]+"(?:\\."+m[o]+")*))";var a=w++;m[a]="[0-9A-Za-z-]+";var c=w++;m[c]="(?:\\+("+m[a]+"(?:\\."+m[a]+")*))";var d=w++,i="v?"+m[p]+m[t]+"?"+m[c]+"?";m[d]="^"+i+"$";var s="[v=\\s]*"+m[E]+m[r]+"?"+m[c]+"?",l=w++;m[l]="^"+s+"$";var h=w++;m[h]="((?:<|>)?=?)";var b=w++;m[b]=m[I]+"|x|X|\\*";var f=w++;m[f]=m[A]+"|x|X|\\*";var C=w++;m[C]="[v=\\s]*("+m[f]+")(?:\\.("+m[f]+")(?:\\.("+m[f]+")(?:"+m[t]+")?"+m[c]+"?)?)?";var O=w++;m[O]="[v=\\s]*("+m[b]+")(?:\\.("+m[b]+")(?:\\.("+m[b]+")(?:"+m[r]+")?"+m[c]+"?)?)?";var v=w++;m[v]="^"+m[h]+"\\s*"+m[C]+"$";var _=w++;m[_]="^"+m[h]+"\\s*"+m[O]+"$";var y=w++;m[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=w++;m[M]="(?:~>?)";var V=w++;m[V]="(\\s*)"+m[M]+"\\s+",g[V]=new RegExp(m[V],"g");var $=w++;m[$]="^"+m[M]+m[C]+"$";var L=w++;m[L]="^"+m[M]+m[O]+"$";var U=w++;m[U]="(?:\\^)";var k=w++;m[k]="(\\s*)"+m[U]+"\\s+",g[k]=new RegExp(m[k],"g");var P=w++;m[P]="^"+m[U]+m[C]+"$";var Q=w++;m[Q]="^"+m[U]+m[O]+"$";var ae=w++;m[ae]="^"+m[h]+"\\s*("+s+")$|^$";var me=w++;m[me]="^"+m[h]+"\\s*("+i+")$|^$";var Ee=w++;m[Ee]="(\\s*)"+m[h]+"\\s*("+s+"|"+m[C]+")",g[Ee]=new RegExp(m[Ee],"g");var Ce=w++;m[Ce]="^\\s*("+m[C]+")\\s+-\\s+("+m[C]+")\\s*$";var he=w++;m[he]="^\\s*("+m[O]+")\\s+-\\s+("+m[O]+")\\s*$";var de=w++;m[de]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)D(te,m[te]),g[te]||(g[te]=new RegExp(m[te]));function Ie(B,K){if(B instanceof oe)return B;if(typeof B!="string"||B.length>R||!(K?g[l]:g[d]).test(B))return null;try{return new oe(B,K)}catch{return null}}function oe(B,K){if(B instanceof oe){if(B.loose===K)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof oe))return new oe(B,K);D("SemVer",B,K),this.loose=K;var Z=B.trim().match(K?g[l]:g[d]);if(!Z)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(_e){if(/^[0-9]+$/.test(_e)){var Fe=+_e;if(Fe>=0&&Fe<T)return Fe}return _e}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=Ie,e.valid=function(B,K){var Z=Ie(B,K);return Z?Z.version:null},e.clean=function(B,K){var Z=Ie(B.trim().replace(/^[=v]+/,""),K);return Z?Z.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(B){return D("SemVer.compare",this.version,this.loose,B),B instanceof oe||(B=new oe(B,this.loose)),this.compareMain(B)||this.comparePre(B)},oe.prototype.compareMain=function(B){return B instanceof oe||(B=new oe(B,this.loose)),H(this.major,B.major)||H(this.minor,B.minor)||H(this.patch,B.patch)},oe.prototype.comparePre=function(B){if(B instanceof oe||(B=new oe(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var K=0;do{var Z=this.prerelease[K],_e=B.prerelease[K];if(D("prerelease compare",K,Z,_e),Z===void 0&&_e===void 0)return 0;if(_e===void 0)return 1;if(Z===void 0)return-1;if(Z!==_e)return H(Z,_e)}while(++K)},oe.prototype.inc=function(B,K){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,K,Z,_e){typeof Z=="string"&&(_e=Z,Z=void 0);try{return new oe(B,Z).inc(K,_e).version}catch{return null}},e.diff=function(B,K){if(ke(B,K))return null;var Z=Ie(B),_e=Ie(K);if(Z.prerelease.length||_e.prerelease.length){for(var Fe in Z)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&Z[Fe]!==_e[Fe])return"pre"+Fe;return"prerelease"}for(var Fe in Z)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&Z[Fe]!==_e[Fe])return Fe},e.compareIdentifiers=H;var Y=/^[0-9]+$/;function H(B,K){var Z=Y.test(B),_e=Y.test(K);return Z&&_e&&(B=+B,K=+K),Z&&!_e?-1:_e&&!Z?1:B<K?-1:B>K?1:0}function ne(B,K,Z){return new oe(B,Z).compare(new oe(K,Z))}function De(B,K,Z){return ne(B,K,Z)>0}function Re(B,K,Z){return ne(B,K,Z)<0}function ke(B,K,Z){return ne(B,K,Z)===0}function ce(B,K,Z){return ne(B,K,Z)!==0}function ie(B,K,Z){return ne(B,K,Z)>=0}function G(B,K,Z){return ne(B,K,Z)<=0}function ee(B,K,Z,_e){var Fe;switch(K){case"===":typeof B=="object"&&(B=B.version),typeof Z=="object"&&(Z=Z.version),Fe=B===Z;break;case"!==":typeof B=="object"&&(B=B.version),typeof Z=="object"&&(Z=Z.version),Fe=B!==Z;break;case"":case"=":case"==":Fe=ke(B,Z,_e);break;case"!=":Fe=ce(B,Z,_e);break;case">":Fe=De(B,Z,_e);break;case">=":Fe=ie(B,Z,_e);break;case"<":Fe=Re(B,Z,_e);break;case"<=":Fe=G(B,Z,_e);break;default:throw new TypeError("Invalid operator: "+K)}return Fe}function pe(B,K){if(B instanceof pe){if(B.loose===K)return B;B=B.value}if(!(this instanceof pe))return new pe(B,K);D("comparator",B,K),this.loose=K,this.parse(B),this.semver===be?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(B,K){return H(K,B)},e.major=function(B,K){return new oe(B,K).major},e.minor=function(B,K){return new oe(B,K).minor},e.patch=function(B,K){return new oe(B,K).patch},e.compare=ne,e.compareLoose=function(B,K){return ne(B,K,!0)},e.rcompare=function(B,K,Z){return ne(K,B,Z)},e.sort=function(B,K){return B.sort(function(Z,_e){return e.compare(Z,_e,K)})},e.rsort=function(B,K){return B.sort(function(Z,_e){return e.rcompare(Z,_e,K)})},e.gt=De,e.lt=Re,e.eq=ke,e.neq=ce,e.gte=ie,e.lte=G,e.cmp=ee,e.Comparator=pe;var be={};function Le(B,K){if(B instanceof Le)return B.loose===K?B:new Le(B.raw,K);if(B instanceof pe)return new Le(B.value,K);if(!(this instanceof Le))return new Le(B,K);if(this.loose=K,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function ue(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,K,Z,_e,Fe,ze,qe,Qe,rt,it,et,ot,at){return((K=ue(Z)?"":ue(_e)?">="+Z+".0.0":ue(Fe)?">="+Z+"."+_e+".0":">="+K)+" "+(Qe=ue(rt)?"":ue(it)?"<"+(+rt+1)+".0.0":ue(et)?"<"+rt+"."+(+it+1)+".0":ot?"<="+rt+"."+it+"."+et+"-"+ot:"<="+Qe)).trim()}function N(B,K){for(var Z=0;Z<B.length;Z++)if(!B[Z].test(K))return!1;if(K.prerelease.length){for(Z=0;Z<B.length;Z++)if(D(B[Z].semver),B[Z].semver!==be&&B[Z].semver.prerelease.length>0){var _e=B[Z].semver;if(_e.major===K.major&&_e.minor===K.minor&&_e.patch===K.patch)return!0}return!1}return!0}function W(B,K,Z){try{K=new Le(K,Z)}catch{return!1}return K.test(B)}function q(B,K,Z,_e){var Fe,ze,qe,Qe,rt;switch(B=new oe(B,_e),K=new Le(K,_e),Z){case">":Fe=De,ze=G,qe=Re,Qe=">",rt=">=";break;case"<":Fe=Re,ze=ie,qe=De,Qe="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(W(B,K,_e))return!1;for(var it=0;it<K.set.length;++it){var et=K.set[it],ot=null,at=null;if(et.forEach(function(Ue){Ue.semver===be&&(Ue=new pe(">=0.0.0")),ot=ot||Ue,at=at||Ue,Fe(Ue.semver,ot.semver,_e)?ot=Ue:qe(Ue.semver,at.semver,_e)&&(at=Ue)}),ot.operator===Qe||ot.operator===rt||(!at.operator||at.operator===Qe)&&ze(B,at.semver)||at.operator===rt&&qe(B,at.semver))return!1}return!0}pe.prototype.parse=function(B){var K=this.loose?g[ae]:g[me],Z=B.match(K);if(!Z)throw new TypeError("Invalid comparator: "+B);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new oe(Z[2],this.loose):this.semver=be},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(B){return D("Comparator.test",B,this.loose),this.semver===be||(typeof B=="string"&&(B=new oe(B,this.loose)),ee(B,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(B,K){if(!(B instanceof pe))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Le(B.value,K),W(this.value,Z,K);if(B.operator==="")return Z=new Le(this.value,K),W(B.semver,Z,K);var _e=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Fe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),ze=this.semver.version===B.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=ee(this.semver,"<",B.semver,K)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),rt=ee(this.semver,">",B.semver,K)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return _e||Fe||ze&&qe||Qe||rt},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(B){var K=this.loose;B=B.trim(),D("range",B,K);var Z=K?g[he]:g[Ce];B=B.replace(Z,we),D("hyphen replace",B),B=B.replace(g[Ee],"$1$2$3"),D("comparator trim",B,g[Ee]),B=(B=(B=B.replace(g[V],"$1~")).replace(g[k],"$1^")).split(/\s+/).join(" ");var _e=K?g[ae]:g[me],Fe=B.split(" ").map(function(ze){return function(qe,Qe){return D("comp",qe),qe=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){D("caret",ot,at);var Ue=at?g[Q]:g[P];return ot.replace(Ue,function(vt,X,J,ve,$e){var Ge;return D("caret",ot,vt,X,J,ve,$e),ue(X)?Ge="":ue(J)?Ge=">="+X+".0.0 <"+(+X+1)+".0.0":ue(ve)?Ge=X==="0"?">="+X+"."+J+".0 <"+X+"."+(+J+1)+".0":">="+X+"."+J+".0 <"+(+X+1)+".0.0":$e?(D("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ge=X==="0"?J==="0"?">="+X+"."+J+"."+ve+$e+" <"+X+"."+J+"."+(+ve+1):">="+X+"."+J+"."+ve+$e+" <"+X+"."+(+J+1)+".0":">="+X+"."+J+"."+ve+$e+" <"+(+X+1)+".0.0"):(D("no pr"),Ge=X==="0"?J==="0"?">="+X+"."+J+"."+ve+" <"+X+"."+J+"."+(+ve+1):">="+X+"."+J+"."+ve+" <"+X+"."+(+J+1)+".0":">="+X+"."+J+"."+ve+" <"+(+X+1)+".0.0"),D("caret return",Ge),Ge})}(et,it)}).join(" ")}(qe,Qe),D("caret",qe),qe=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){var Ue=at?g[L]:g[$];return ot.replace(Ue,function(vt,X,J,ve,$e){var Ge;return D("tilde",ot,vt,X,J,ve,$e),ue(X)?Ge="":ue(J)?Ge=">="+X+".0.0 <"+(+X+1)+".0.0":ue(ve)?Ge=">="+X+"."+J+".0 <"+X+"."+(+J+1)+".0":$e?(D("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),Ge=">="+X+"."+J+"."+ve+$e+" <"+X+"."+(+J+1)+".0"):Ge=">="+X+"."+J+"."+ve+" <"+X+"."+(+J+1)+".0",D("tilde return",Ge),Ge})}(et,it)}).join(" ")}(qe,Qe),D("tildes",qe),qe=function(rt,it){return D("replaceXRanges",rt,it),rt.split(/\s+/).map(function(et){return function(ot,at){ot=ot.trim();var Ue=at?g[_]:g[v];return ot.replace(Ue,function(vt,X,J,ve,$e,Ge){D("xRange",ot,vt,X,J,ve,$e,Ge);var tt=ue(J),nt=tt||ue(ve),Ne=nt||ue($e);return X==="="&&Ne&&(X=""),tt?vt=X===">"||X==="<"?"<0.0.0":"*":X&&Ne?(nt&&(ve=0),Ne&&($e=0),X===">"?(X=">=",nt?(J=+J+1,ve=0,$e=0):Ne&&(ve=+ve+1,$e=0)):X==="<="&&(X="<",nt?J=+J+1:ve=+ve+1),vt=X+J+"."+ve+"."+$e):nt?vt=">="+J+".0.0 <"+(+J+1)+".0.0":Ne&&(vt=">="+J+"."+ve+".0 <"+J+"."+(+ve+1)+".0"),D("xRange return",vt),vt})}(et,it)}).join(" ")}(qe,Qe),D("xrange",qe),qe=function(rt,it){return D("replaceStars",rt,it),rt.trim().replace(g[de],"")}(qe,Qe),D("stars",qe),qe}(ze,K)}).join(" ").split(/\s+/);return this.loose&&(Fe=Fe.filter(function(ze){return!!ze.match(_e)})),Fe=Fe.map(function(ze){return new pe(ze,K)})},Le.prototype.intersects=function(B,K){if(!(B instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(_e){return B.set.some(function(Fe){return Fe.every(function(ze){return _e.intersects(ze,K)})})})})},e.toComparators=function(B,K){return new Le(B,K).set.map(function(Z){return Z.map(function(_e){return _e.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new oe(B,this.loose));for(var K=0;K<this.set.length;K++)if(N(this.set[K],B))return!0;return!1},e.satisfies=W,e.maxSatisfying=function(B,K,Z){var _e=null,Fe=null;try{var ze=new Le(K,Z)}catch{return null}return B.forEach(function(qe){ze.test(qe)&&(_e&&Fe.compare(qe)!==-1||(Fe=new oe(_e=qe,Z)))}),_e},e.minSatisfying=function(B,K,Z){var _e=null,Fe=null;try{var ze=new Le(K,Z)}catch{return null}return B.forEach(function(qe){ze.test(qe)&&(_e&&Fe.compare(qe)!==1||(Fe=new oe(_e=qe,Z)))}),_e},e.validRange=function(B,K){try{return new Le(B,K).range||"*"}catch{return null}},e.ltr=function(B,K,Z){return q(B,K,"<",Z)},e.gtr=function(B,K,Z){return q(B,K,">",Z)},e.outside=q,e.prerelease=function(B,K){var Z=Ie(B,K);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(B,K,Z){return B=new Le(B,Z),K=new Le(K,Z),B.intersects(K)},e.coerce=function(B){if(B instanceof oe)return B;if(typeof B!="string")return null;var K=B.match(g[y]);return K==null?null:Ie((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,S(1))},function(ge,e){var S,F,D=ge.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function g(o){if(S===setTimeout)return setTimeout(o,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(o,0);try{return S(o,0)}catch{try{return S.call(null,o,0)}catch{return S.call(this,o,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{F=typeof clearTimeout=="function"?clearTimeout:T}catch{F=T}})();var m,w=[],A=!1,I=-1;function u(){A&&m&&(A=!1,m.length?w=m.concat(w):I=-1,w.length&&p())}function p(){if(!A){var o=g(u);A=!0;for(var t=w.length;t;){for(m=w,w=[];++I<t;)m&&m[I].run();I=-1,t=w.length}m=null,A=!1,function(r){if(F===clearTimeout)return clearTimeout(r);if((F===T||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(r);try{F(r)}catch{try{return F.call(null,r)}catch{return F.call(this,r)}}}(o)}}function E(o,t){this.fun=o,this.array=t}function n(){}D.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)t[r-1]=arguments[r];w.push(new E(o,t)),w.length!==1||A||g(p)},E.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=n,D.addListener=n,D.once=n,D.off=n,D.removeListener=n,D.removeAllListeners=n,D.emit=n,D.prependListener=n,D.prependOnceListener=n,D.listeners=function(o){return[]},D.binding=function(o){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(o){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Pe[123],Te([1,0,11,6]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(c){const d=c;return d?typeof d.read=="function":!1}e.isReadable=D;function R(c){const d=c;return d?[d.on,d.pause,d.resume,d.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function T(c){const d=c;return d?R(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function g(c,d){return new m(c,d)}e.newWriteableStream=g;class m{constructor(d,i){this.reducer=d,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d<"u"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(i=>i(d))}emitError(d){this.listeners.error.length===0?(0,S.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(i=>i(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,i){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(d,i){if(this.state.destroyed)return;let s;switch(d){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const l=s.indexOf(i);l>=0&&s.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(c,d){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return d(i)}e.consumeReadable=w;function A(c,d,i){const s=[];let l;for(;(l=c.read())!==null&&s.length<i;)s.push(l);return l===null&&s.length>0?d(s):{read:()=>{if(s.length>0)return s.shift();if(typeof l<"u"){const h=l;return l=void 0,h}return c.read()}}}e.peekReadable=A;function I(c,d){return new Promise((i,s)=>{const l=[];u(c,{onData:h=>{d&&l.push(h)},onError:h=>{d?s(h):i(void 0)},onEnd:()=>{i(d?d(l):void 0)}})})}e.consumeStream=I;function u(c,d,i){c.on("error",s=>{i?.isCancellationRequested||d.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||d.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||d.onData(s)})}e.listenStream=u;function p(c,d){return new Promise((i,s)=>{const l=new F.DisposableStore,h=[],b=O=>{if(h.push(O),h.length>d)return l.dispose(),c.pause(),i({stream:c,buffer:h,ended:!1})},f=O=>(l.dispose(),s(O)),C=()=>(l.dispose(),i({stream:c,buffer:h,ended:!0}));l.add((0,F.toDisposable)(()=>c.removeListener("error",f))),c.on("error",f),l.add((0,F.toDisposable)(()=>c.removeListener("end",C))),c.on("end",C),l.add((0,F.toDisposable)(()=>c.removeListener("data",b))),c.on("data",b)})}e.peekStream=p;function E(c,d){const i=g(d);return i.end(c),i}e.toStream=E;function n(){const c=g(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=n;function o(c){let d=!1;return{read:()=>d?null:(d=!0,c)}}e.toReadable=o;function t(c,d,i){const s=g(i);return u(c,{onData:l=>s.write(d.data(l)),onError:l=>s.error(d.error?d.error(l):l),onEnd:()=>s.end()}),s}e.transform=t;function r(c,d,i){let s=!1;return{read:()=>{const l=d.read();return s?l:(s=!0,l!==null?i([c,l]):c)}}}e.prefixedReadable=r;function a(c,d,i){let s=!1;const l=g(i);return u(d,{onData:h=>s?l.write(h):(s=!0,l.write(i([c,h]))),onError:h=>l.error(h),onEnd:()=>{s||(s=!0,l.write(c)),l.end()}}),l}e.prefixedStream=a}),define(Pe[24],Te([1,0,39,123]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const D=typeof Buffer<"u",R=new S.Lazy(()=>new Uint8Array(256));let T,g;class m{static alloc(y){return D?new m(Buffer.allocUnsafe(y)):new m(new Uint8Array(y))}static wrap(y){return D&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new m(y)}static fromString(y,M){return!(M?.dontUseNodeBuffer||!1)&&D?new m(Buffer.from(y)):(T||(T=new TextEncoder),new m(T.encode(y)))}static fromByteArray(y){const M=m.alloc(y.length);for(let V=0,$=y.length;V<$;V++)M.buffer[V]=y[V];return M}static concat(y,M){if(typeof M>"u"){M=0;for(let L=0,U=y.length;L<U;L++)M+=y[L].byteLength}const V=m.alloc(M);let $=0;for(let L=0,U=y.length;L<U;L++){const k=y[L];V.set(k,$),$+=k.byteLength}return V}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=m.alloc(this.byteLength);return y.set(this),y}toString(){return D?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(y,M){return new m(this.buffer.subarray(y,M))}set(y,M){if(y instanceof m)this.buffer.set(y.buffer,M);else if(y instanceof Uint8Array)this.buffer.set(y,M);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),M);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,M){p(this.buffer,y,M)}readUInt32LE(y){return E(this.buffer,y)}writeUInt32LE(y,M){n(this.buffer,y,M)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,M){t(this.buffer,y,M)}indexOf(y,M=0){return w(this.buffer,y instanceof m?y.buffer:y,M)}}e.VSBuffer=m;function w(_,y,M=0){const V=y.byteLength,$=_.byteLength;if(V===0)return 0;if(V===1)return _.indexOf(y[0]);if(V>$-M)return-1;const L=R.value;L.fill(y.length);for(let Q=0;Q<y.length;Q++)L[y[Q]]=y.length-Q-1;let U=M+y.length-1,k=U,P=-1;for(;U<$;)if(_[U]===y[k]){if(k===0){P=U;break}U--,k--}else U+=Math.max(y.length-k,L[_[U]]),k=y.length-1;return P}e.binaryIndexOf=w;function A(_,y){return _[y+0]<<0>>>0|_[y+1]<<8>>>0}e.readUInt16LE=A;function I(_,y,M){_[M+0]=y&255,y=y>>>8,_[M+1]=y&255}e.writeUInt16LE=I;function u(_,y){return _[y]*2**24+_[y+1]*2**16+_[y+2]*2**8+_[y+3]}e.readUInt32BE=u;function p(_,y,M){_[M+3]=y,y=y>>>8,_[M+2]=y,y=y>>>8,_[M+1]=y,y=y>>>8,_[M]=y}e.writeUInt32BE=p;function E(_,y){return _[y+0]<<0>>>0|_[y+1]<<8>>>0|_[y+2]<<16>>>0|_[y+3]<<24>>>0}e.readUInt32LE=E;function n(_,y,M){_[M+0]=y&255,y=y>>>8,_[M+1]=y&255,y=y>>>8,_[M+2]=y&255,y=y>>>8,_[M+3]=y&255}e.writeUInt32LE=n;function o(_,y){return _[y]}e.readUInt8=o;function t(_,y,M){_[M]=y}e.writeUInt8=t;function r(_){return F.consumeReadable(_,y=>m.concat(y))}e.readableToBuffer=r;function a(_){return F.toReadable(_)}e.bufferToReadable=a;function c(_){return F.consumeStream(_,y=>m.concat(y))}e.streamToBuffer=c;async function d(_){return _.ended?m.concat(_.buffer):m.concat([..._.buffer,await c(_.stream)])}e.bufferedStreamToBuffer=d;function i(_){return F.toStream(_,y=>m.concat(y))}e.bufferToStream=i;function s(_){return F.transform(_,{data:y=>typeof y=="string"?m.fromString(y):m.wrap(y)},y=>m.concat(y))}e.streamToBufferReadableStream=s;function l(_){return F.newWriteableStream(y=>m.concat(y),_)}e.newWriteableBufferStream=l;function h(_,y){return F.prefixedReadable(_,y,M=>m.concat(M))}e.prefixedBufferReadable=h;function b(_,y){return F.prefixedStream(_,y,M=>m.concat(M))}e.prefixedBufferStream=b;function f(_){let y=0,M=0,V=0;const $=new Uint8Array(Math.floor(_.length/4*3)),L=k=>{switch(M){case 3:$[V++]=y|k,M=0;break;case 2:$[V++]=y|k>>>2,y=k<<6,M=3;break;case 1:$[V++]=y|k>>>4,y=k<<4,M=2;break;default:y=k<<2,M=1}};for(let k=0;k<_.length;k++){const P=_.charCodeAt(k);if(P>=65&&P<=90)L(P-65);else if(P>=97&&P<=122)L(P-97+26);else if(P>=48&&P<=57)L(P-48+52);else if(P===43||P===45)L(62);else if(P===47||P===95)L(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${_[k]}`)}}const U=V;for(;M>0;)L(0);return m.wrap($).slice(0,U)}e.decodeBase64=f;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:_},y=!0,M=!1){const V=M?O:C;let $="";const L=_.byteLength%3;let U=0;for(;U<_.byteLength-L;U+=3){const k=_[U+0],P=_[U+1],Q=_[U+2];$+=V[k>>>2],$+=V[(k<<4|P>>>4)&63],$+=V[(P<<2|Q>>>6)&63],$+=V[Q&63]}if(L===1){const k=_[U+0];$+=V[k>>>2],$+=V[k<<4&63],y&&($+="==")}else if(L===2){const k=_[U+0],P=_[U+1];$+=V[k>>>2],$+=V[(k<<4|P>>>4)&63],$+=V[P<<2&63],y&&($+="=")}return $}e.encodeBase64=v}),define(Pe[124],Te([1,0,28,121,12]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...ue){return function(we,N){for(let W=0,q=ue.length;W<q;W++){const B=ue[W](we,N);if(B)return B}return null}}e.or=R,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ue,we,N){if(!N||N.length<we.length)return null;let W;return ue?W=D.startsWithIgnoreCase(N,we):W=N.indexOf(we)===0,W?we.length>0?[{start:0,end:we.length}]:[]:null}function g(ue,we){const N=we.toLowerCase().indexOf(ue.toLowerCase());return N===-1?null:[{start:N,end:N+ue.length}]}e.matchesContiguousSubString=g;function m(ue,we){return w(ue.toLowerCase(),we.toLowerCase(),0,0)}e.matchesSubString=m;function w(ue,we,N,W){if(N===ue.length)return[];if(W===we.length)return null;if(ue[N]===we[W]){let q=null;return(q=w(ue,we,N+1,W+1))?c({start:W,end:W+1},q):null}return w(ue,we,N,W+1)}function A(ue){return 97<=ue&&ue<=122}function I(ue){return 65<=ue&&ue<=90}e.isUpper=I;function u(ue){return 48<=ue&&ue<=57}function p(ue){return ue===32||ue===9||ue===10||ue===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ue=>E.add(ue.charCodeAt(0)));function n(ue){return p(ue)||E.has(ue)}function o(ue,we){return ue===we||n(ue)&&n(we)}const t=new Map;function r(ue){if(t.has(ue))return t.get(ue);let we;const N=(0,F.getKoreanAltChars)(ue);return N&&(we=N),t.set(ue,we),we}function a(ue){return A(ue)||I(ue)||u(ue)}function c(ue,we){return we.length===0?we=[ue]:ue.end===we[0].start?we[0].start=ue.start:we.unshift(ue),we}function d(ue,we){for(let N=we;N<ue.length;N++){const W=ue.charCodeAt(N);if(I(W)||u(W)||N>0&&!a(ue.charCodeAt(N-1)))return N}return ue.length}function i(ue,we,N,W){if(N===ue.length)return[];if(W===we.length)return null;if(ue[N]!==we[W].toLowerCase())return null;{let q=null,B=W+1;for(q=i(ue,we,N+1,W+1);!q&&(B=d(we,B))<we.length;)q=i(ue,we,N+1,B),B++;return q===null?null:c({start:W,end:W+1},q)}}function s(ue){let we=0,N=0,W=0,q=0,B=0;for(let ze=0;ze<ue.length;ze++)B=ue.charCodeAt(ze),I(B)&&we++,A(B)&&N++,a(B)&&W++,u(B)&&q++;const K=we/ue.length,Z=N/ue.length,_e=W/ue.length,Fe=q/ue.length;return{upperPercent:K,lowerPercent:Z,alphaPercent:_e,numericPercent:Fe}}function l(ue){const{upperPercent:we,lowerPercent:N}=ue;return N===0&&we>.6}function h(ue){const{upperPercent:we,lowerPercent:N,alphaPercent:W,numericPercent:q}=ue;return N>.2&&we<.8&&W>.6&&q<.2}function b(ue){let we=0,N=0,W=0,q=0;for(let B=0;B<ue.length;B++)W=ue.charCodeAt(B),I(W)&&we++,A(W)&&N++,p(W)&&q++;return(we===0||N===0)&&q===0?ue.length<=30:we<=5}function f(ue,we){if(!we||(we=we.trim(),we.length===0)||!b(ue)||we.length>60)return null;const N=s(we);if(!h(N)){if(!l(N))return null;we=we.toLowerCase()}let W=null,q=0;for(ue=ue.toLowerCase();q<we.length&&(W=i(ue,we,0,q))===null;)q=d(we,q+1);return W}e.matchesCamelCase=f;function C(ue,we,N=!1){if(!we||we.length===0)return null;let W=null,q=0;for(ue=ue.toLowerCase(),we=we.toLowerCase();q<we.length&&(W=O(ue,we,0,q,N),W===null);)q=v(we,q+1);return W}e.matchesWords=C;function O(ue,we,N,W,q){let B=0;if(N===ue.length)return[];if(W===we.length)return null;if(!o(ue.charCodeAt(N),we.charCodeAt(W))){const _e=r(ue.charCodeAt(N));if(!_e)return null;for(let Fe=0;Fe<_e.length;Fe++)if(!o(_e[Fe],we.charCodeAt(W+Fe)))return null;B+=_e.length-1}let K=null,Z=W+B+1;if(K=O(ue,we,N+1,Z,q),!q)for(;!K&&(Z=v(we,Z))<we.length;)K=O(ue,we,N+1,Z,q),Z++;if(!K)return null;if(ue.charCodeAt(N)!==we.charCodeAt(W)){const _e=r(ue.charCodeAt(N));if(!_e)return K;for(let Fe=0;Fe<_e.length;Fe++)if(_e[Fe]!==we.charCodeAt(W+Fe))return K}return c({start:W,end:W+B+1},K)}function v(ue,we){for(let N=we;N<ue.length;N++)if(n(ue.charCodeAt(N))||N>0&&n(ue.charCodeAt(N-1)))return N;return ue.length}const _=R(e.matchesPrefix,f,g),y=R(e.matchesPrefix,f,m),M=new S.LRUCache(1e4);function V(ue,we,N=!1){if(typeof ue!="string"||typeof we!="string")return null;let W=M.get(ue);W||(W=new RegExp(D.convertSimple2RegExpPattern(ue),"i"),M.set(ue,W));const q=W.exec(we);return q?[{start:q.index,end:q.index+q[0].length}]:N?y(ue,we):_(ue,we)}e.matchesFuzzy=V;function $(ue,we){const N=ce(ue,ue.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?U(N):null}e.matchesFuzzy2=$;function L(ue,we,N,W,q,B){const K=Math.min(13,ue.length);for(;N<K;N++){const Z=ce(ue,we,N,W,q,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,B]}e.anyScore=L;function U(ue){if(typeof ue>"u")return[];const we=[],N=ue[1];for(let W=ue.length-1;W>1;W--){const q=ue[W]+N,B=we[we.length-1];B&&B.end===q?B.end=q+1:we.push({start:q,end:q+1})}return we}e.createMatches=U;const k=128;function P(){const ue=[],we=[];for(let N=0;N<=k;N++)we[N]=0;for(let N=0;N<=k;N++)ue.push(we.slice(0));return ue}function Q(ue){const we=[];for(let N=0;N<=ue;N++)we[N]=0;return we}const ae=Q(2*k),me=Q(2*k),Ee=P(),Ce=P(),he=P(),de=!1;function te(ue,we,N,W,q){function B(Z,_e,Fe=" "){for(;Z.length<_e;)Z=Fe+Z;return Z}let K=` |   |${W.split("").map(Z=>B(Z,3)).join("|")}
`;for(let Z=0;Z<=N;Z++)Z===0?K+=" |":K+=`${we[Z-1]}|`,K+=ue[Z].slice(0,q+1).map(_e=>B(_e.toString(),3)).join("|")+`
`;return K}function Ie(ue,we,N,W){ue=ue.substr(we),N=N.substr(W),console.log(te(Ce,ue,ue.length,N,N.length)),console.log(te(he,ue,ue.length,N,N.length)),console.log(te(Ee,ue,ue.length,N,N.length))}function oe(ue,we){if(we<0||we>=ue.length)return!1;const N=ue.codePointAt(we);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(N)}}function Y(ue,we){if(we<0||we>=ue.length)return!1;switch(ue.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function H(ue,we,N){return we[ue]!==N[ue]}function ne(ue,we,N,W,q,B,K=!1){for(;we<N&&q<B;)ue[we]===W[q]&&(K&&(ae[we]=q),we+=1),q+=1;return we===N}e.isPatternInWord=ne;var De;(function(ue){ue[ue.Diag=1]="Diag",ue[ue.Left=2]="Left",ue[ue.LeftLeft=3]="LeftLeft"})(De||(De={}));var Re;(function(ue){ue.Default=[-100,0];function we(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}ue.isDefault=we})(Re||(e.FuzzyScore=Re={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(we,N){this.firstMatchCanBeWeak=we,this.boostFullMatch=N}}e.FuzzyScoreOptions=ke;function ce(ue,we,N,W,q,B,K=ke.default){const Z=ue.length>k?k:ue.length,_e=W.length>k?k:W.length;if(N>=Z||B>=_e||Z-N>_e-B||!ne(we,N,Z,q,B,_e,!0))return;ie(Z,_e,N,B,we,q);let Fe=1,ze=1,qe=N,Qe=B;const rt=[!1];for(Fe=1,qe=N;qe<Z;Fe++,qe++){const Ue=ae[qe],vt=me[qe],X=qe+1<Z?me[qe+1]:_e;for(ze=Ue-B+1,Qe=Ue;Qe<X;ze++,Qe++){let J=Number.MIN_SAFE_INTEGER,ve=!1;Qe<=vt&&(J=G(ue,we,qe,N,W,q,Qe,_e,B,Ee[Fe-1][ze-1]===0,rt));let $e=0;J!==Number.MAX_SAFE_INTEGER&&(ve=!0,$e=J+Ce[Fe-1][ze-1]);const Ge=Qe>Ue,tt=Ge?Ce[Fe][ze-1]+(Ee[Fe][ze-1]>0?-5:0):0,nt=Qe>Ue+1&&Ee[Fe][ze-1]>0,Ne=nt?Ce[Fe][ze-2]+(Ee[Fe][ze-2]>0?-5:0):0;if(nt&&(!Ge||Ne>=tt)&&(!ve||Ne>=$e))Ce[Fe][ze]=Ne,he[Fe][ze]=3,Ee[Fe][ze]=0;else if(Ge&&(!ve||tt>=$e))Ce[Fe][ze]=tt,he[Fe][ze]=2,Ee[Fe][ze]=0;else if(ve)Ce[Fe][ze]=$e,he[Fe][ze]=1,Ee[Fe][ze]=Ee[Fe-1][ze-1]+1;else throw new Error("not possible")}}if(de&&Ie(ue,N,W,B),!rt[0]&&!K.firstMatchCanBeWeak)return;Fe--,ze--;const it=[Ce[Fe][ze],B];let et=0,ot=0;for(;Fe>=1;){let Ue=ze;do{const vt=he[Fe][Ue];if(vt===3)Ue=Ue-2;else if(vt===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&we[N+Fe-1]===q[B+ze-1]&&!H(Ue+B-1,W,q)&&et+1>Ee[Fe][Ue]&&(Ue=ze),Ue===ze?et++:et=1,ot||(ot=Ue),Fe--,ze=Ue-1,it.push(ze)}_e===Z&&K.boostFullMatch&&(it[0]+=2);const at=ot-Z;return it[0]-=at,it}e.fuzzyScore=ce;function ie(ue,we,N,W,q,B){let K=ue-1,Z=we-1;for(;K>=N&&Z>=W;)q[K]===B[Z]&&(me[K]=Z,K--),Z--}function G(ue,we,N,W,q,B,K,Z,_e,Fe,ze){if(we[N]!==B[K])return Number.MIN_SAFE_INTEGER;let qe=1,Qe=!1;return K===N-W?qe=ue[N]===q[K]?7:5:H(K,q,B)&&(K===0||!H(K-1,q,B))?(qe=ue[N]===q[K]?7:5,Qe=!0):oe(B,K)&&(K===0||!oe(B,K-1))?qe=5:(oe(B,K-1)||Y(B,K-1))&&(qe=5,Qe=!0),qe>1&&N===W&&(ze[0]=!0),Qe||(Qe=H(K,q,B)||oe(B,K-1)||Y(B,K-1)),N===W?K>_e&&(qe-=Qe?3:5):Fe?qe+=Qe?2:0:qe+=Qe?0:1,K+1===Z&&(qe-=Qe?3:5),qe}function ee(ue,we,N,W,q,B,K){return be(ue,we,N,W,q,B,!0,K)}e.fuzzyScoreGracefulAggressive=ee;function pe(ue,we,N,W,q,B,K){return be(ue,we,N,W,q,B,!1,K)}e.fuzzyScoreGraceful=pe;function be(ue,we,N,W,q,B,K,Z){let _e=ce(ue,we,N,W,q,B,Z);if(_e&&!K)return _e;if(ue.length>=3){const Fe=Math.min(7,ue.length-1);for(let ze=N+1;ze<Fe;ze++){const qe=Le(ue,ze);if(qe){const Qe=ce(qe,qe.toLowerCase(),N,W,q,B,Z);Qe&&(Qe[0]-=3,(!_e||Qe[0]>_e[0])&&(_e=Qe))}}}return _e}function Le(ue,we){if(we+1>=ue.length)return;const N=ue[we],W=ue[we+1];if(N!==W)return ue.slice(0,we)+W+N+ue.slice(we+2)}}),define(Pe[31],Te([1,0,12]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(F||(F={})),function(D){const R="error",T="warning",g="warn",m="info",w="ignore";function A(u){return u?S.equalsIgnoreCase(R,u)?D.Error:S.equalsIgnoreCase(T,u)||S.equalsIgnoreCase(g,u)?D.Warning:S.equalsIgnoreCase(m,u)?D.Info:D.Ignore:D.Ignore}D.fromValue=A;function I(u){switch(u){case D.Error:return R;case D.Warning:return T;case D.Info:return m;default:return w}}D.toString=I}(F||(F={})),e.default=F}),define(Pe[125],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[50],Te([1,0,18,12]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this._value="",this._pos=0}reset(p){return this._value=p,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(p){const E=p.charCodeAt(0),n=this._value.charCodeAt(this._pos);return E-n}value(){return this._value[this._pos]}}e.StringIterator=D;class R{constructor(p=!0){this._caseSensitive=p}reset(p){return this._value=p,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let p=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(p)this._from++;else break;else p=!1;return this}cmp(p){return this._caseSensitive?(0,F.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class T{constructor(p=!0,E=!0){this._splitOnBackslash=p,this._caseSensitive=E}reset(p){this._from=0,this._to=0,this._value=p,this._valueLen=p.length;for(let E=p.length-1;E>=0;E--,this._valueLen--){const n=this._value.charCodeAt(E);if(!(n===47||this._splitOnBackslash&&n===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let p=!0;for(;this._to<this._valueLen;this._to++){const E=this._value.charCodeAt(this._to);if(E===47||this._splitOnBackslash&&E===92)if(p)this._from++;else break;else p=!1}return this}cmp(p){return this._caseSensitive?(0,F.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var g;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(g||(g={}));class m{constructor(p,E){this._ignorePathCasing=p,this._ignoreQueryAndFragment=E,this._states=[],this._stateIdx=0}reset(p){return this._value=p,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(p)),this._pathIterator.reset(p.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(p)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(p){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(p,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(p,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(p);if(this._states[this._stateIdx]===4)return(0,F.compare)(p,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(p,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(A||(A={}));class I{static forUris(p=()=>!1,E=()=>!1){return new I(new m(p,E))}static forPaths(p=!1){return new I(new T(void 0,!p))}static forStrings(){return new I(new D)}static forConfigKeys(){return new I(new R)}constructor(p){this._iter=p}clear(){this._root=void 0}fill(p,E){if(E){const n=E.slice(0);(0,S.shuffle)(n);for(const o of n)this.set(o,p)}else{const n=p.slice(0);(0,S.shuffle)(n);for(const o of n)this.set(o[0],o[1])}}set(p,E){const n=this._iter.reset(p);let o;this._root||(this._root=new w,this._root.segment=n.value());const t=[];for(o=this._root;;){const a=n.cmp(o.segment);if(a>0)o.left||(o.left=new w,o.left.segment=n.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new w,o.right.segment=n.value()),t.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new w,o.mid.segment=n.value()),t.push([0,o]),o=o.mid;else break}const r=o.value;o.value=E,o.key=p;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const d=c.balanceFactor();if(d<-1||d>1){const i=t[a][0],s=t[a+1][0];if(i===1&&s===1)t[a][1]=c.rotateLeft();else if(i===-1&&s===-1)t[a][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this._root=t[0][1]}}return r}get(p){return this._getNode(p)?.value}_getNode(p){const E=this._iter.reset(p);let n=this._root;for(;n;){const o=E.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(E.hasNext())E.next(),n=n.mid;else break}return n}has(p){const E=this._getNode(p);return!(E?.value===void 0&&E?.mid===void 0)}delete(p){return this._delete(p,!1)}deleteSuperstr(p){return this._delete(p,!0)}_delete(p,E){const n=this._iter.reset(p),o=[];let t=this._root;for(;t;){const r=n.cmp(t.segment);if(r>0)o.push([-1,t]),t=t.left;else if(r<0)o.push([1,t]),t=t.right;else if(n.hasNext())n.next(),o.push([0,t]),t=t.mid;else break}if(t){if(E?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const r=this._min(t.right);if(r.key){const{key:a,value:c,segment:d}=r;this._delete(r.key,!1),t.key=a,t.value=c,t.segment=d}}else{const r=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=r;break;case 0:c.mid=r;break;case 1:c.right=r;break}}else this._root=r}for(let r=o.length-1;r>=0;r--){const a=o[r][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[r][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[r][1]=a.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this._root=o[0][1]}}}_min(p){for(;p.left;)p=p.left;return p}findSubstr(p){const E=this._iter.reset(p);let n=this._root,o;for(;n;){const t=E.cmp(n.segment);if(t>0)n=n.left;else if(t<0)n=n.right;else if(E.hasNext())E.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(p){return this._findSuperstrOrElement(p,!1)}_findSuperstrOrElement(p,E){const n=this._iter.reset(p);let o=this._root;for(;o;){const t=n.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this._entries(o.mid):E?o.value:void 0}}hasElementOrSubtree(p){return this._findSuperstrOrElement(p,!0)!==void 0}forEach(p){for(const[E,n]of this)p(n,E)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(p){const E=[];return this._dfsEntries(p,E),E[Symbol.iterator]()}_dfsEntries(p,E){p&&(p.left&&this._dfsEntries(p.left,E),p.value&&E.push([p.key,p.value]),p.mid&&this._dfsEntries(p.mid,E),p.right&&this._dfsEntries(p.right,E))}_isBalanced(){const p=E=>{if(!E)return!0;const n=E.balanceFactor();return n<-1||n>1?!1:p(E.left)&&p(E.right)};return p(this._root)}}e.TernarySearchTree=I}),define(Pe[45],Te([1,0,90]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var F;(function(T){function g(m){return m&&typeof m=="object"&&typeof m.id=="string"}T.isThemeColor=g})(F||(e.ThemeColor=F={}));function D(T){return{id:T}}e.themeColorFromId=D;var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function m(r){const a=g.exec(r.id);if(!a)return m(S.Codicon.error);const[,c,d]=a,i=["codicon","codicon-"+c];return d&&i.push("codicon-modifier-"+d.substring(1)),i}T.asClassNameArray=m;function w(r){return m(r).join(" ")}T.asClassName=w;function A(r){return"."+m(r).join(".")}T.asCSSSelector=A;function I(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||F.isThemeColor(r.color))}T.isThemeIcon=I;const u=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function p(r){const a=u.exec(r);if(!a)return;const[,c]=a;return{id:c}}T.fromString=p;function E(r){return{id:r}}T.fromId=E;function n(r,a){let c=r.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),a&&(c=`${c}~${a}`),{id:c}}T.modify=n;function o(r){const a=r.id.lastIndexOf("~");if(a!==-1)return r.id.substring(a+1)}T.getModifier=o;function t(r,a){return r.id===a.id&&r.color?.id===a.color?.id}T.isEqual=t})(R||(e.ThemeIcon=R={}))}),define(Pe[126],Te([1,0,124,12,45]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",T=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${T.source}`,"g");function m(t){return t.replace(g,(r,a)=>a?r:`\\${r}`)}e.escapeIcons=m;const w=new RegExp(`\\\\${T.source}`,"g");function A(t){return t.replace(w,r=>`\\${r}`)}e.markdownEscapeEscapedIcons=A;const I=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function u(t){return t.indexOf(R)===-1?t:t.replace(I,(r,a,c,d)=>c?r:a||d||"")}e.stripIcons=u;function p(t){return t?t.replace(/\$\((.*?)\)/g,(r,a)=>` ${a} `).trim():""}e.getCodiconAriaLabel=p;const E=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(t){E.lastIndex=0;let r="";const a=[];let c=0;for(;;){const d=E.lastIndex,i=E.exec(t),s=t.substring(d,i?.index);if(s.length>0){r+=s;for(let l=0;l<s.length;l++)a.push(c)}if(!i)break;c+=i[0].length}return{text:r,iconOffsets:a}}e.parseLabelWithIcons=n;function o(t,r,a=!1){const{text:c,iconOffsets:d}=r;if(!d||d.length===0)return(0,S.matchesFuzzy)(t,c,a);const i=(0,F.ltrim)(c," "),s=c.length-i.length,l=(0,S.matchesFuzzy)(t,i,a);if(l)for(const h of l){const b=d[h.start+s]+s;h.start+=b,h.end+=b}return l}e.matchesFuzzyIconAware=o}),define(Pe[33],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(D){return S.test(D)}e.isUUID=F,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(g){for(let m=0;m<g.length;m++)g[m]=Math.floor(Math.random()*256);return g};const R=new Uint8Array(16),T=[];for(let g=0;g<256;g++)T.push(g.toString(16).padStart(2,"0"));return function(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,w="";return w+=T[R[m++]],w+=T[R[m++]],w+=T[R[m++]],w+=T[R[m++]],w+="-",w+=T[R[m++]],w+=T[R[m++]],w+="-",w+=T[R[m++]],w+=T[R[m++]],w+="-",w+=T[R[m++]],w+=T[R[m++]],w+="-",w+=T[R[m++]],w+=T[R[m++]],w+=T[R[m++]],w+=T[R[m++]],w+=T[R[m++]],w+=T[R[m++]],w}}()}),define(Pe[127],Te([1,0,18,67,33]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.createStringDataTransferItem=R;function T(I,u,p){const E={id:(0,D.generateUuid)(),name:I,uri:u,data:p};return{asString:async()=>"",asFile:()=>E,value:void 0}}e.createFileDataTransferItem=T;class g{constructor(){this._entries=new Map}get size(){let u=0;for(const p of this._entries)u++;return u}has(u){return this._entries.has(this.toKey(u))}matches(u){const p=[...this._entries.keys()];return F.Iterable.some(this,([E,n])=>n.asFile())&&p.push("files"),A(m(u),p)}get(u){return this._entries.get(this.toKey(u))?.[0]}append(u,p){const E=this._entries.get(u);E?E.push(p):this._entries.set(this.toKey(u),[p])}replace(u,p){this._entries.set(this.toKey(u),[p])}delete(u){this._entries.delete(this.toKey(u))}*[Symbol.iterator](){for(const[u,p]of this._entries)for(const E of p)yield[u,E]}toKey(u){return m(u)}}e.VSDataTransfer=g;function m(I){return I.toLowerCase()}function w(I,u){return A(m(I),u.map(m))}e.matchesMimeType=w;function A(I,u){if(I==="*/*")return u.length>0;if(u.includes(I))return!0;const p=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[E,n,o]=p;return o==="*"?u.some(t=>t.startsWith(n+"/")):!1}e.UriList=Object.freeze({create:I=>(0,S.distinct)(I.map(u=>u.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.UriList.split(I).filter(u=>!u.startsWith("#"))})}),define(Pe[128],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var S;(function(D){D[D.Unknown=0]="Unknown",D[D.Invalid=3]="Invalid",D[D.LF=1]="LF",D[D.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function F(D){let R=0,T=0,g=0,m=0;for(let w=0,A=D.length;w<A;w++){const I=D.charCodeAt(w);I===13?(R===0&&(T=w),R++,w+1<A&&D.charCodeAt(w+1)===10?(m|=2,w++):m|=3,g=w+1):I===10&&(m|=1,R===0&&(T=w),R++,g=w+1)}return R===0&&(T=D.length),[R,T,D.length-g,m]}e.countEOL=F}),define(Pe[129],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[130],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var S;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class F{constructor(g){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=g.open,this.close=g.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(g.notIn))for(let m=0,w=g.notIn.length;m<w;m++)switch(g.notIn[m]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(g,m){if(g.getTokenCount()===0)return!0;const w=g.findTokenIndexAtOffset(m-2),A=g.getStandardTokenType(w);return this.isOK(A)}_findNeutralCharacterInRange(g,m){for(let w=g;w<=m;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class D{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of g)R(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),R(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),R(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),R(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&R(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.AutoClosingPairs=D;function R(T,g,m){T.has(g)?T.get(g).push(m):T.set(g,[m])}}),define(Pe[131],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.recomputeTreeMetadata=e.updateTreeMetadata=e.fixInsert=e.rbDelete=e.rightRotate=e.leftRotate=e.righttest=e.leftest=e.SENTINEL=e.NodeColor=e.TreeNode=void 0;class S{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return D(this.right);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.left!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}prev(){if(this.left!==e.SENTINEL)return R(this.left);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.right!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=S;var F;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(F||(e.NodeColor=F={})),e.SENTINEL=new S(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function D(n){for(;n.left!==e.SENTINEL;)n=n.left;return n}e.leftest=D;function R(n){for(;n.right!==e.SENTINEL;)n=n.right;return n}e.righttest=R;function T(n){return n===e.SENTINEL?0:n.size_left+n.piece.length+T(n.right)}function g(n){return n===e.SENTINEL?0:n.lf_left+n.piece.lineFeedCnt+g(n.right)}function m(){e.SENTINEL.parent=e.SENTINEL}function w(n,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.SENTINEL&&(t.left.parent=o),t.parent=o.parent,o.parent===e.SENTINEL?n.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.leftRotate=w;function A(n,o){const t=o.left;o.left=t.right,t.right!==e.SENTINEL&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.SENTINEL?n.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.rightRotate=A;function I(n,o){let t,r;if(o.left===e.SENTINEL?(r=o,t=r.right):o.right===e.SENTINEL?(r=o,t=r.left):(r=D(o.right),t=r.right),r===n.root){n.root=t,t.color=0,o.detach(),m(),n.root.parent=e.SENTINEL;return}const a=r.color===1;if(r===r.parent.left?r.parent.left=t:r.parent.right=t,r===o?(t.parent=r.parent,E(n,t)):(r.parent===o?t.parent=r:t.parent=r.parent,E(n,t),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===n.root?n.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.SENTINEL&&(r.left.parent=r),r.right!==e.SENTINEL&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,E(n,r)),o.detach(),t.parent.left===t){const d=T(t),i=g(t);if(d!==t.parent.size_left||i!==t.parent.lf_left){const s=d-t.parent.size_left,l=i-t.parent.lf_left;t.parent.size_left=d,t.parent.lf_left=i,p(n,t.parent,s,l)}}if(E(n,t.parent),a){m();return}let c;for(;t!==n.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(n,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(n,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(n,t.parent),t=n.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(n,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(n,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(n,t.parent),t=n.root));t.color=0,m()}e.rbDelete=I;function u(n,o){for(E(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,w(n,o)),o.parent.color=0,o.parent.parent.color=1,A(n,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(n,o)),o.parent.color=0,o.parent.parent.color=1,w(n,o.parent.parent))}n.root.color=0}e.fixInsert=u;function p(n,o,t,r){for(;o!==n.root&&o!==e.SENTINEL;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=r),o=o.parent}e.updateTreeMetadata=p;function E(n,o){let t=0,r=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,t=T(o.left)-o.size_left,r=g(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=r;o!==n.root&&(t!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=r),o=o.parent}}e.recomputeTreeMetadata=E}),define(Pe[91],Te([1,0,92,29,93,131,94]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=e.createLineStarts=e.createLineStartsFast=void 0;const g=65535;function m(t){let r;return t[t.length-1]<65536?r=new Uint16Array(t.length):r=new Uint32Array(t.length),r.set(t,0),r}class w{constructor(r,a,c,d,i){this.lineStarts=r,this.cr=a,this.lf=c,this.crlf=d,this.isBasicASCII=i}}function A(t,r=!0){const a=[0];let c=1;for(let d=0,i=t.length;d<i;d++){const s=t.charCodeAt(d);s===13?d+1<i&&t.charCodeAt(d+1)===10?(a[c++]=d+2,d++):a[c++]=d+1:s===10&&(a[c++]=d+1)}return r?m(a):a}e.createLineStartsFast=A;function I(t,r){t.length=0,t[0]=0;let a=1,c=0,d=0,i=0,s=!0;for(let h=0,b=r.length;h<b;h++){const f=r.charCodeAt(h);f===13?h+1<b&&r.charCodeAt(h+1)===10?(i++,t[a++]=h+2,h++):(c++,t[a++]=h+1):f===10?(d++,t[a++]=h+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const l=new w(m(t),c,d,i,s);return t.length=0,l}e.createLineStarts=I;class u{constructor(r,a,c,d,i){this.bufferIndex=r,this.start=a,this.end=c,this.lineFeedCnt=d,this.length=i}}e.Piece=u;class p{constructor(r,a){this.buffer=r,this.lineStarts=a}}e.StringBuffer=p;class E{constructor(r,a){this._pieces=[],this._tree=r,this._BOM=a,this._index=0,r.root!==R.SENTINEL&&r.iterate(r.root,c=>(c!==R.SENTINEL&&this._pieces.push(c.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class n{constructor(r){this._limit=r,this._cache=[]}get(r){for(let a=this._cache.length-1;a>=0;a--){const c=this._cache[a];if(c.nodeStartOffset<=r&&c.nodeStartOffset+c.node.piece.length>=r)return c}return null}get2(r){for(let a=this._cache.length-1;a>=0;a--){const c=this._cache[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<r&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=r)return c}return null}set(r){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(r)}validate(r){let a=!1;const c=this._cache;for(let d=0;d<c.length;d++){const i=c[d];if(i.node.parent===null||i.nodeStartOffset>=r){c[d]=null,a=!0;continue}}if(a){const d=[];for(const i of c)i!==null&&d.push(i);this._cache=d}}}class o{constructor(r,a,c){this.create(r,a,c)}create(r,a,c){this._buffers=[new p("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=R.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=a,this._EOLLength=a.length,this._EOLNormalized=c;let d=null;for(let i=0,s=r.length;i<s;i++)if(r[i].buffer.length>0){r[i].lineStarts||(r[i].lineStarts=A(r[i].buffer));const l=new u(i+1,{line:0,column:0},{line:r[i].lineStarts.length-1,column:r[i].buffer.length-r[i].lineStarts[r[i].lineStarts.length-1]},r[i].lineStarts.length-1,r[i].buffer.length);this._buffers.push(r[i]),d=this.rbInsertRight(d,l)}this._searchCache=new n(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(r){const a=g,c=a-Math.floor(a/3),d=c*2;let i="",s=0;const l=[];if(this.iterate(this.root,h=>{const b=this.getNodeContent(h),f=b.length;if(s<=c||s+f<d)return i+=b,s+=f,!0;const C=i.replace(/\r\n|\r|\n/g,r);return l.push(new p(C,A(C))),i=b,s=f,!0}),s>0){const h=i.replace(/\r\n|\r|\n/g,r);l.push(new p(h,A(h)))}this.create(l,r,!0)}getEOL(){return this._EOL}setEOL(r){this._EOL=r,this._EOLLength=this._EOL.length,this.normalizeEOL(r)}createSnapshot(r){return new E(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let a=0;return this.iterate(this.root,d=>{if(d===R.SENTINEL)return!0;const i=this.getNodeContent(d),s=i.length,l=r.nodeAt(a),h=r.nodeAt(a+s),b=r.getValueInRange2(l,h);return a+=s,i===b})}getOffsetAt(r,a){let c=0,d=this.root;for(;d!==R.SENTINEL;)if(d.left!==R.SENTINEL&&d.lf_left+1>=r)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=r){c+=d.size_left;const i=this.getAccumulatedValue(d,r-d.lf_left-2);return c+=i+a-1}else r-=d.lf_left+d.piece.lineFeedCnt,c+=d.size_left+d.piece.length,d=d.right;return c}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let a=this.root,c=0;const d=r;for(;a!==R.SENTINEL;)if(a.size_left!==0&&a.size_left>=r)a=a.left;else if(a.size_left+a.piece.length>=r){const i=this.getIndexOf(a,r-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),l=d-s;return new S.Position(c+1,l+1)}return new S.Position(c+1,i.remainder+1)}else if(r-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===R.SENTINEL){const i=this.getOffsetAt(c+1,1),s=d-r-i;return new S.Position(c+1,s+1)}else a=a.right;return new S.Position(1,1)}getValueInRange(r,a){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const c=this.nodeAt2(r.startLineNumber,r.startColumn),d=this.nodeAt2(r.endLineNumber,r.endColumn),i=this.getValueInRange2(c,d);return a?a!==this._EOL||!this._EOLNormalized?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this._EOLNormalized?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(r,a){if(r.node===a.node){const l=r.node,h=this._buffers[l.piece.bufferIndex].buffer,b=this.offsetInBuffer(l.piece.bufferIndex,l.piece.start);return h.substring(b+r.remainder,b+a.remainder)}let c=r.node;const d=this._buffers[c.piece.bufferIndex].buffer,i=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);let s=d.substring(i+r.remainder,i+c.piece.length);for(c=c.next();c!==R.SENTINEL;){const l=this._buffers[c.piece.bufferIndex].buffer,h=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);if(c===a.node){s+=l.substring(h,h+a.remainder);break}else s+=l.substr(h,c.piece.length);c=c.next()}return s}getLinesContent(){const r=[];let a=0,c="",d=!1;return this.iterate(this.root,i=>{if(i===R.SENTINEL)return!0;const s=i.piece;let l=s.length;if(l===0)return!0;const h=this._buffers[s.bufferIndex].buffer,b=this._buffers[s.bufferIndex].lineStarts,f=s.start.line,C=s.end.line;let O=b[f]+s.start.column;if(d&&(h.charCodeAt(O)===10&&(O++,l--),r[a++]=c,c="",d=!1,l===0))return!0;if(f===C)return!this._EOLNormalized&&h.charCodeAt(O+l-1)===13?(d=!0,c+=h.substr(O,l-1)):c+=h.substr(O,l),!0;c+=this._EOLNormalized?h.substring(O,Math.max(O,b[f+1]-this._EOLLength)):h.substring(O,b[f+1]).replace(/(\r\n|\r|\n)$/,""),r[a++]=c;for(let v=f+1;v<C;v++)c=this._EOLNormalized?h.substring(b[v],b[v+1]-this._EOLLength):h.substring(b[v],b[v+1]).replace(/(\r\n|\r|\n)$/,""),r[a++]=c;return!this._EOLNormalized&&h.charCodeAt(b[C]+s.end.column-1)===13?(d=!0,s.end.column===0?a--:c=h.substr(b[C],s.end.column-1)):c=h.substr(b[C],s.end.column),!0}),d&&(r[a++]=c,c=""),r[a++]=c,r}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(r){return this._lastVisitedLine.lineNumber===r?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=r,r===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(r):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(r,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(r){if(r.remainder===r.node.piece.length){const a=r.node.next();if(!a)return 0;const c=this._buffers[a.piece.bufferIndex],d=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(d)}else{const a=this._buffers[r.node.piece.bufferIndex],d=this.offsetInBuffer(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return a.buffer.charCodeAt(d)}}getLineCharCode(r,a){const c=this.nodeAt2(r,a+1);return this._getCharCode(c)}getLineLength(r){if(r===this.getLineCount()){const a=this.getOffsetAt(r,1);return this.getLength()-a}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this._EOLLength}getCharCode(r){const a=this.nodeAt(r);return this._getCharCode(a)}findMatchesInNode(r,a,c,d,i,s,l,h,b,f,C){const O=this._buffers[r.piece.bufferIndex],v=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start),_=this.offsetInBuffer(r.piece.bufferIndex,i),y=this.offsetInBuffer(r.piece.bufferIndex,s);let M;const V={line:0,column:0};let $,L;a._wordSeparators?($=O.buffer.substring(_,y),L=U=>U+_,a.reset(0)):($=O.buffer,L=U=>U,a.reset(_));do if(M=a.next($),M){if(L(M.index)>=y)return f;this.positionInBuffer(r,L(M.index)-v,V);const U=this.getLineFeedCnt(r.piece.bufferIndex,i,V),k=V.line===i.line?V.column-i.column+d:V.column+1,P=k+M[0].length;if(C[f++]=(0,T.createFindMatch)(new F.Range(c+U,k,c+U,P),M,h),L(M.index)+M[0].length>=y||f>=b)return f}while(M);return f}findMatchesLineByLine(r,a,c,d){const i=[];let s=0;const l=new T.Searcher(a.wordSeparators,a.regex);let h=this.nodeAt2(r.startLineNumber,r.startColumn);if(h===null)return[];const b=this.nodeAt2(r.endLineNumber,r.endColumn);if(b===null)return[];let f=this.positionInBuffer(h.node,h.remainder);const C=this.positionInBuffer(b.node,b.remainder);if(h.node===b.node)return this.findMatchesInNode(h.node,l,r.startLineNumber,r.startColumn,f,C,a,c,d,s,i),i;let O=r.startLineNumber,v=h.node;for(;v!==b.node;){const y=this.getLineFeedCnt(v.piece.bufferIndex,f,v.piece.end);if(y>=1){const V=this._buffers[v.piece.bufferIndex].lineStarts,$=this.offsetInBuffer(v.piece.bufferIndex,v.piece.start),L=V[f.line+y],U=O===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(v,l,O,U,f,this.positionInBuffer(v,L-$),a,c,d,s,i),s>=d)return i;O+=y}const M=O===r.startLineNumber?r.startColumn-1:0;if(O===r.endLineNumber){const V=this.getLineContent(O).substring(M,r.endColumn-1);return s=this._findMatchesInLine(a,l,V,r.endLineNumber,M,s,i,c,d),i}if(s=this._findMatchesInLine(a,l,this.getLineContent(O).substr(M),O,M,s,i,c,d),s>=d)return i;O++,h=this.nodeAt2(O,1),v=h.node,f=this.positionInBuffer(h.node,h.remainder)}if(O===r.endLineNumber){const y=O===r.startLineNumber?r.startColumn-1:0,M=this.getLineContent(O).substring(y,r.endColumn-1);return s=this._findMatchesInLine(a,l,M,r.endLineNumber,y,s,i,c,d),i}const _=O===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(b.node,l,O,_,f,C,a,c,d,s,i),i}_findMatchesInLine(r,a,c,d,i,s,l,h,b){const f=r.wordSeparators;if(!h&&r.simpleSearch){const O=r.simpleSearch,v=O.length,_=c.length;let y=-v;for(;(y=c.indexOf(O,y+v))!==-1;)if((!f||(0,T.isValidMatch)(f,c,_,y,v))&&(l[s++]=new D.FindMatch(new F.Range(d,y+1+i,d,y+1+v+i),null),s>=b))return s;return s}let C;a.reset(0);do if(C=a.next(c),C&&(l[s++]=(0,T.createFindMatch)(new F.Range(d,C.index+1+i,d,C.index+1+C[0].length+i),C,h),s>=b))return s;while(C);return s}insert(r,a,c=!1){if(this._EOLNormalized=this._EOLNormalized&&c,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==R.SENTINEL){const{node:d,remainder:i,nodeStartOffset:s}=this.nodeAt(r),l=d.piece,h=l.bufferIndex,b=this.positionInBuffer(d,i);if(d.piece.bufferIndex===0&&l.end.line===this._lastChangeBufferPos.line&&l.end.column===this._lastChangeBufferPos.column&&s+l.length===r&&a.length<g){this.appendToNode(d,a),this.computeBufferMetadata();return}if(s===r)this.insertContentToNodeLeft(a,d),this._searchCache.validate(r);else if(s+d.piece.length>r){const f=[];let C=new u(l.bufferIndex,b,l.end,this.getLineFeedCnt(l.bufferIndex,b,l.end),this.offsetInBuffer(h,l.end)-this.offsetInBuffer(h,b));if(this.shouldCheckCRLF()&&this.endWithCR(a)&&this.nodeCharCodeAt(d,i)===10){const y={line:C.start.line+1,column:0};C=new u(C.bufferIndex,y,C.end,this.getLineFeedCnt(C.bufferIndex,y,C.end),C.length-1),a+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(a))if(this.nodeCharCodeAt(d,i-1)===13){const y=this.positionInBuffer(d,i-1);this.deleteNodeTail(d,y),a="\r"+a,d.piece.length===0&&f.push(d)}else this.deleteNodeTail(d,b);else this.deleteNodeTail(d,b);const O=this.createNewPieces(a);C.length>0&&this.rbInsertRight(d,C);let v=d;for(let _=0;_<O.length;_++)v=this.rbInsertRight(v,O[_]);this.deleteNodes(f)}else this.insertContentToNodeRight(a,d)}else{const d=this.createNewPieces(a);let i=this.rbInsertLeft(null,d[0]);for(let s=1;s<d.length;s++)i=this.rbInsertRight(i,d[s])}this.computeBufferMetadata()}delete(r,a){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",a<=0||this.root===R.SENTINEL)return;const c=this.nodeAt(r),d=this.nodeAt(r+a),i=c.node,s=d.node;if(i===s){const O=this.positionInBuffer(i,c.remainder),v=this.positionInBuffer(i,d.remainder);if(c.nodeStartOffset===r){if(a===i.piece.length){const _=i.next();(0,R.rbDelete)(this,i),this.validateCRLFWithPrevNode(_),this.computeBufferMetadata();return}this.deleteNodeHead(i,v),this._searchCache.validate(r),this.validateCRLFWithPrevNode(i),this.computeBufferMetadata();return}if(c.nodeStartOffset+i.piece.length===r+a){this.deleteNodeTail(i,O),this.validateCRLFWithNextNode(i),this.computeBufferMetadata();return}this.shrinkNode(i,O,v),this.computeBufferMetadata();return}const l=[],h=this.positionInBuffer(i,c.remainder);this.deleteNodeTail(i,h),this._searchCache.validate(r),i.piece.length===0&&l.push(i);const b=this.positionInBuffer(s,d.remainder);this.deleteNodeHead(s,b),s.piece.length===0&&l.push(s);const f=i.next();for(let O=f;O!==R.SENTINEL&&O!==s;O=O.next())l.push(O);const C=i.piece.length===0?i.prev():i;this.deleteNodes(l),this.validateCRLFWithNextNode(C),this.computeBufferMetadata()}insertContentToNodeLeft(r,a){const c=[];if(this.shouldCheckCRLF()&&this.endWithCR(r)&&this.startWithLF(a)){const s=a.piece,l={line:s.start.line+1,column:0},h=new u(s.bufferIndex,l,s.end,this.getLineFeedCnt(s.bufferIndex,l,s.end),s.length-1);a.piece=h,r+=`
`,(0,R.updateTreeMetadata)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const d=this.createNewPieces(r);let i=this.rbInsertLeft(a,d[d.length-1]);for(let s=d.length-2;s>=0;s--)i=this.rbInsertLeft(i,d[s]);this.validateCRLFWithPrevNode(i),this.deleteNodes(c)}insertContentToNodeRight(r,a){this.adjustCarriageReturnFromNext(r,a)&&(r+=`
`);const c=this.createNewPieces(r),d=this.rbInsertRight(a,c[0]);let i=d;for(let s=1;s<c.length;s++)i=this.rbInsertRight(i,c[s]);this.validateCRLFWithPrevNode(d)}positionInBuffer(r,a,c){const d=r.piece,i=r.piece.bufferIndex,s=this._buffers[i].lineStarts,h=s[d.start.line]+d.start.column+a;let b=d.start.line,f=d.end.line,C=0,O=0,v=0;for(;b<=f&&(C=b+(f-b)/2|0,v=s[C],C!==f);)if(O=s[C+1],h<v)f=C-1;else if(h>=O)b=C+1;else break;return c?(c.line=C,c.column=h-v,null):{line:C,column:h-v}}getLineFeedCnt(r,a,c){if(c.column===0)return c.line-a.line;const d=this._buffers[r].lineStarts;if(c.line===d.length-1)return c.line-a.line;const i=d[c.line+1],s=d[c.line]+c.column;if(i>s+1)return c.line-a.line;const l=s-1;return this._buffers[r].buffer.charCodeAt(l)===13?c.line-a.line+1:c.line-a.line}offsetInBuffer(r,a){return this._buffers[r].lineStarts[a.line]+a.column}deleteNodes(r){for(let a=0;a<r.length;a++)(0,R.rbDelete)(this,r[a])}createNewPieces(r){if(r.length>g){const f=[];for(;r.length>g;){const O=r.charCodeAt(g-1);let v;O===13||O>=55296&&O<=56319?(v=r.substring(0,g-1),r=r.substring(g-1)):(v=r.substring(0,g),r=r.substring(g));const _=A(v);f.push(new u(this._buffers.length,{line:0,column:0},{line:_.length-1,column:v.length-_[_.length-1]},_.length-1,v.length)),this._buffers.push(new p(v,_))}const C=A(r);return f.push(new u(this._buffers.length,{line:0,column:0},{line:C.length-1,column:r.length-C[C.length-1]},C.length-1,r.length)),this._buffers.push(new p(r,C)),f}let a=this._buffers[0].buffer.length;const c=A(r,!1);let d=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===a&&a!==0&&this.startWithLF(r)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},d=this._lastChangeBufferPos;for(let f=0;f<c.length;f++)c[f]+=a+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1)),this._buffers[0].buffer+="_"+r,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1)),this._buffers[0].buffer+=r}const i=this._buffers[0].buffer.length,s=this._buffers[0].lineStarts.length-1,l=i-this._buffers[0].lineStarts[s],h={line:s,column:l},b=new u(0,d,h,this.getLineFeedCnt(0,d,h),i-a);return this._lastChangeBufferPos=h,[b]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(r,a=0){let c=this.root,d="";const i=this._searchCache.get2(r);if(i){c=i.node;const s=this.getAccumulatedValue(c,r-i.nodeStartLineNumber-1),l=this._buffers[c.piece.bufferIndex].buffer,h=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===r)d=l.substring(h+s,h+c.piece.length);else{const b=this.getAccumulatedValue(c,r-i.nodeStartLineNumber);return l.substring(h+s,h+b-a)}}else{let s=0;const l=r;for(;c!==R.SENTINEL;)if(c.left!==R.SENTINEL&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const h=this.getAccumulatedValue(c,r-c.lf_left-2),b=this.getAccumulatedValue(c,r-c.lf_left-1),f=this._buffers[c.piece.bufferIndex].buffer,C=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this._searchCache.set({node:c,nodeStartOffset:s,nodeStartLineNumber:l-(r-1-c.lf_left)}),f.substring(C+h,C+b-a)}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const h=this.getAccumulatedValue(c,r-c.lf_left-2),b=this._buffers[c.piece.bufferIndex].buffer,f=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);d=b.substring(f+h,f+c.piece.length);break}else r-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==R.SENTINEL;){const s=this._buffers[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const l=this.getAccumulatedValue(c,0),h=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return d+=s.substring(h,h+l-a),d}else{const l=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);d+=s.substr(l,c.piece.length)}c=c.next()}return d}computeBufferMetadata(){let r=this.root,a=1,c=0;for(;r!==R.SENTINEL;)a+=r.lf_left+r.piece.lineFeedCnt,c+=r.size_left+r.piece.length,r=r.right;this._lineCnt=a,this._length=c,this._searchCache.validate(this._length)}getIndexOf(r,a){const c=r.piece,d=this.positionInBuffer(r,a),i=d.line-c.start.line;if(this.offsetInBuffer(c.bufferIndex,c.end)-this.offsetInBuffer(c.bufferIndex,c.start)===a){const s=this.getLineFeedCnt(r.piece.bufferIndex,c.start,d);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:d.column}}getAccumulatedValue(r,a){if(a<0)return 0;const c=r.piece,d=this._buffers[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?d[c.end.line]+c.end.column-d[c.start.line]-c.start.column:d[i]-d[c.start.line]-c.start.column}deleteNodeTail(r,a){const c=r.piece,d=c.lineFeedCnt,i=this.offsetInBuffer(c.bufferIndex,c.end),s=a,l=this.offsetInBuffer(c.bufferIndex,s),h=this.getLineFeedCnt(c.bufferIndex,c.start,s),b=h-d,f=l-i,C=c.length+f;r.piece=new u(c.bufferIndex,c.start,s,h,C),(0,R.updateTreeMetadata)(this,r,f,b)}deleteNodeHead(r,a){const c=r.piece,d=c.lineFeedCnt,i=this.offsetInBuffer(c.bufferIndex,c.start),s=a,l=this.getLineFeedCnt(c.bufferIndex,s,c.end),h=this.offsetInBuffer(c.bufferIndex,s),b=l-d,f=i-h,C=c.length+f;r.piece=new u(c.bufferIndex,s,c.end,l,C),(0,R.updateTreeMetadata)(this,r,f,b)}shrinkNode(r,a,c){const d=r.piece,i=d.start,s=d.end,l=d.length,h=d.lineFeedCnt,b=a,f=this.getLineFeedCnt(d.bufferIndex,d.start,b),C=this.offsetInBuffer(d.bufferIndex,a)-this.offsetInBuffer(d.bufferIndex,i);r.piece=new u(d.bufferIndex,d.start,b,f,C),(0,R.updateTreeMetadata)(this,r,C-l,f-h);const O=new u(d.bufferIndex,c,s,this.getLineFeedCnt(d.bufferIndex,c,s),this.offsetInBuffer(d.bufferIndex,s)-this.offsetInBuffer(d.bufferIndex,c)),v=this.rbInsertRight(r,O);this.validateCRLFWithPrevNode(v)}appendToNode(r,a){this.adjustCarriageReturnFromNext(a,r)&&(a+=`
`);const c=this.shouldCheckCRLF()&&this.startWithLF(a)&&this.endWithCR(r),d=this._buffers[0].buffer.length;this._buffers[0].buffer+=a;const i=A(a,!1);for(let v=0;v<i.length;v++)i[v]+=d;if(c){const v=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:d-v}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(i.slice(1));const s=this._buffers[0].lineStarts.length-1,l=this._buffers[0].buffer.length-this._buffers[0].lineStarts[s],h={line:s,column:l},b=r.piece.length+a.length,f=r.piece.lineFeedCnt,C=this.getLineFeedCnt(0,r.piece.start,h),O=C-f;r.piece=new u(r.piece.bufferIndex,r.piece.start,h,C,b),this._lastChangeBufferPos=h,(0,R.updateTreeMetadata)(this,r,a.length,O)}nodeAt(r){let a=this.root;const c=this._searchCache.get(r);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:r-c.nodeStartOffset};let d=0;for(;a!==R.SENTINEL;)if(a.size_left>r)a=a.left;else if(a.size_left+a.piece.length>=r){d+=a.size_left;const i={node:a,remainder:r-a.size_left,nodeStartOffset:d};return this._searchCache.set(i),i}else r-=a.size_left+a.piece.length,d+=a.size_left+a.piece.length,a=a.right;return null}nodeAt2(r,a){let c=this.root,d=0;for(;c!==R.SENTINEL;)if(c.left!==R.SENTINEL&&c.lf_left>=r-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>r-1){const i=this.getAccumulatedValue(c,r-c.lf_left-2),s=this.getAccumulatedValue(c,r-c.lf_left-1);return d+=c.size_left,{node:c,remainder:Math.min(i+a-1,s),nodeStartOffset:d}}else if(c.lf_left+c.piece.lineFeedCnt===r-1){const i=this.getAccumulatedValue(c,r-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:d};a-=c.piece.length-i;break}else r-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==R.SENTINEL;){if(c.piece.lineFeedCnt>0){const i=this.getAccumulatedValue(c,0),s=this.offsetOfNode(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:s}}else if(c.piece.length>=a-1){const i=this.offsetOfNode(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}nodeCharCodeAt(r,a){if(r.piece.lineFeedCnt<1)return-1;const c=this._buffers[r.piece.bufferIndex],d=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start)+a;return c.buffer.charCodeAt(d)}offsetOfNode(r){if(!r)return 0;let a=r.size_left;for(;r!==this.root;)r.parent.right===r&&(a+=r.parent.size_left+r.parent.piece.length),r=r.parent;return a}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===R.SENTINEL||r.piece.lineFeedCnt===0)return!1;const a=r.piece,c=this._buffers[a.bufferIndex].lineStarts,d=a.start.line,i=c[d]+a.start.column;return d===c.length-1||c[d+1]>i+1?!1:this._buffers[a.bufferIndex].buffer.charCodeAt(i)===10}endWithCR(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===R.SENTINEL||r.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(r,r.piece.length-1)===13}validateCRLFWithPrevNode(r){if(this.shouldCheckCRLF()&&this.startWithLF(r)){const a=r.prev();this.endWithCR(a)&&this.fixCRLF(a,r)}}validateCRLFWithNextNode(r){if(this.shouldCheckCRLF()&&this.endWithCR(r)){const a=r.next();this.startWithLF(a)&&this.fixCRLF(r,a)}}fixCRLF(r,a){const c=[],d=this._buffers[r.piece.bufferIndex].lineStarts;let i;r.piece.end.column===0?i={line:r.piece.end.line-1,column:d[r.piece.end.line]-d[r.piece.end.line-1]-1}:i={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,l=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,i,l,s),(0,R.updateTreeMetadata)(this,r,-1,-1),r.piece.length===0&&c.push(r);const h={line:a.piece.start.line+1,column:0},b=a.piece.length-1,f=this.getLineFeedCnt(a.piece.bufferIndex,h,a.piece.end);a.piece=new u(a.piece.bufferIndex,h,a.piece.end,f,b),(0,R.updateTreeMetadata)(this,a,-1,-1),a.piece.length===0&&c.push(a);const C=this.createNewPieces(`\r
`);this.rbInsertRight(r,C[0]);for(let O=0;O<c.length;O++)(0,R.rbDelete)(this,c[O])}adjustCarriageReturnFromNext(r,a){if(this.shouldCheckCRLF()&&this.endWithCR(r)){const c=a.next();if(this.startWithLF(c)){if(r+=`
`,c.piece.length===1)(0,R.rbDelete)(this,c);else{const d=c.piece,i={line:d.start.line+1,column:0},s=d.length-1,l=this.getLineFeedCnt(d.bufferIndex,i,d.end);c.piece=new u(d.bufferIndex,i,d.end,l,s),(0,R.updateTreeMetadata)(this,c,-1,-1)}return!0}}return!1}iterate(r,a){if(r===R.SENTINEL)return a(R.SENTINEL);const c=this.iterate(r.left,a);return c&&a(r)&&this.iterate(r.right,a)}getNodeContent(r){if(r===R.SENTINEL)return"";const a=this._buffers[r.piece.bufferIndex],c=r.piece,d=this.offsetInBuffer(c.bufferIndex,c.start),i=this.offsetInBuffer(c.bufferIndex,c.end);return a.buffer.substring(d,i)}getPieceContent(r){const a=this._buffers[r.bufferIndex],c=this.offsetInBuffer(r.bufferIndex,r.start),d=this.offsetInBuffer(r.bufferIndex,r.end);return a.buffer.substring(c,d)}rbInsertRight(r,a){const c=new R.TreeNode(a,1);if(c.left=R.SENTINEL,c.right=R.SENTINEL,c.parent=R.SENTINEL,c.size_left=0,c.lf_left=0,this.root===R.SENTINEL)this.root=c,c.color=0;else if(r.right===R.SENTINEL)r.right=c,c.parent=r;else{const i=(0,R.leftest)(r.right);i.left=c,c.parent=i}return(0,R.fixInsert)(this,c),c}rbInsertLeft(r,a){const c=new R.TreeNode(a,1);if(c.left=R.SENTINEL,c.right=R.SENTINEL,c.parent=R.SENTINEL,c.size_left=0,c.lf_left=0,this.root===R.SENTINEL)this.root=c,c.color=0;else if(r.left===R.SENTINEL)r.left=c,c.parent=r;else{const d=(0,R.righttest)(r.left);d.right=c,c.parent=d}return(0,R.fixInsert)(this,c),c}getContentOfSubTree(r){let a="";return this.iterate(r,c=>(a+=this.getNodeContent(c),!0)),a}}e.PieceTreeBase=o}),define(Pe[132],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class S{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(R){if(R&&this._dragOperations.has(R)){const T=this._dragOperations.get(R);return this._dragOperations.delete(R),T}}addDragOperationTransfer(R,T){this._dragOperations.set(R,T)}}e.TreeViewsDnDService=S;class F{constructor(R){this.identifier=R}}e.DraggedTreeItemsIdentifier=F}),define(Pe[133],Te([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Pe[134],Te([1,0,5,6,133]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends F.Disposable{constructor(u,p="",E="",n=!0,o){super(),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=u,this._label=p,this._cssClass=E,this._enabled=n,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(u){this._setLabel(u)}_setLabel(u){this._label!==u&&(this._label=u,this._onDidChange.fire({label:u}))}get tooltip(){return this._tooltip||""}set tooltip(u){this._setTooltip(u)}_setTooltip(u){this._tooltip!==u&&(this._tooltip=u,this._onDidChange.fire({tooltip:u}))}get class(){return this._cssClass}set class(u){this._setClass(u)}_setClass(u){this._cssClass!==u&&(this._cssClass=u,this._onDidChange.fire({class:u}))}get enabled(){return this._enabled}set enabled(u){this._setEnabled(u)}_setEnabled(u){this._enabled!==u&&(this._enabled=u,this._onDidChange.fire({enabled:u}))}get checked(){return this._checked}set checked(u){this._setChecked(u)}_setChecked(u){this._checked!==u&&(this._checked=u,this._onDidChange.fire({checked:u}))}async run(u,p){this._actionCallback&&await this._actionCallback(u)}}e.Action=R;class T extends F.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new S.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new S.Emitter),this.onDidRun=this._onDidRun.event}async run(u,p){if(!u.enabled)return;this._onWillRun.fire({action:u});let E;try{await this.runAction(u,p)}catch(n){E=n}this._onDidRun.fire({action:u,error:E})}async runAction(u,p){await u.run(p)}}e.ActionRunner=T;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let p=[];for(const E of u)E.length&&(p.length?p=[...p,new g,...E]:p=E);return p}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=g;class m{get actions(){return this._actions}constructor(u,p,E,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=p,this.class=n,this._actions=E}async run(){}}e.SubmenuAction=m;class w extends R{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,D.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=w;function A(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...u)=>I.run(...u),tooltip:I.label}}e.toAction=A}),define(Pe[135],Te([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Pe[136],Te([1,0,135]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,D=F*60,R=D*24,T=R*7,g=R*30,m=R*365;function w(I,u,p,E){typeof I!="number"&&(I=I.getTime());const n=Math.round((new Date().getTime()-I)/1e3);if(n<-30)return(0,S.localize)(0,null,w(new Date().getTime()+n*1e3,!1));if(!E&&n<30)return(0,S.localize)(1,null);let o;return n<F?(o=n,u?o===1?p?(0,S.localize)(2,null,o):(0,S.localize)(3,null,o):p?(0,S.localize)(4,null,o):(0,S.localize)(5,null,o):o===1?p?(0,S.localize)(6,null,o):(0,S.localize)(7,null,o):p?(0,S.localize)(8,null,o):(0,S.localize)(9,null,o)):n<D?(o=Math.floor(n/F),u?o===1?p?(0,S.localize)(10,null,o):(0,S.localize)(11,null,o):p?(0,S.localize)(12,null,o):(0,S.localize)(13,null,o):o===1?p?(0,S.localize)(14,null,o):(0,S.localize)(15,null,o):p?(0,S.localize)(16,null,o):(0,S.localize)(17,null,o)):n<R?(o=Math.floor(n/D),u?o===1?p?(0,S.localize)(18,null,o):(0,S.localize)(19,null,o):p?(0,S.localize)(20,null,o):(0,S.localize)(21,null,o):o===1?p?(0,S.localize)(22,null,o):(0,S.localize)(23,null,o):p?(0,S.localize)(24,null,o):(0,S.localize)(25,null,o)):n<T?(o=Math.floor(n/R),u?o===1?(0,S.localize)(26,null,o):(0,S.localize)(27,null,o):o===1?(0,S.localize)(28,null,o):(0,S.localize)(29,null,o)):n<g?(o=Math.floor(n/T),u?o===1?p?(0,S.localize)(30,null,o):(0,S.localize)(31,null,o):p?(0,S.localize)(32,null,o):(0,S.localize)(33,null,o):o===1?p?(0,S.localize)(34,null,o):(0,S.localize)(35,null,o):p?(0,S.localize)(36,null,o):(0,S.localize)(37,null,o)):n<m?(o=Math.floor(n/g),u?o===1?p?(0,S.localize)(38,null,o):(0,S.localize)(39,null,o):p?(0,S.localize)(40,null,o):(0,S.localize)(41,null,o):o===1?p?(0,S.localize)(42,null,o):(0,S.localize)(43,null,o):p?(0,S.localize)(44,null,o):(0,S.localize)(45,null,o)):(o=Math.floor(n/m),u?o===1?p?(0,S.localize)(46,null,o):(0,S.localize)(47,null,o):p?(0,S.localize)(48,null,o):(0,S.localize)(49,null,o):o===1?p?(0,S.localize)(50,null,o):(0,S.localize)(51,null,o):p?(0,S.localize)(52,null,o):(0,S.localize)(53,null,o))}e.fromNow=w;function A(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(Pe[137],Te([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Pe[40],Te([1,0,18,16,137]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(I,u){return u&&(I.stack||I.stacktrace)?D.localize(0,null,g(I),T(I.stack)||T(I.stacktrace)):g(I)}function T(I){return Array.isArray(I)?I.join(`
`):I}function g(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function m(I=null,u=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const p=S.coalesce(I),E=m(p[0],u);return p.length>1?D.localize(4,null,E,p.length):E}if(F.isString(I))return I;if(I.detail){const p=I.detail;if(p.error)return R(p.error,u);if(p.exception)return R(p.exception,u)}return I.stack?R(I,u):I.message?I.message:D.localize(5,null)}e.toErrorMessage=m;function w(I){const u=I;return u instanceof Error&&Array.isArray(u.actions)}e.isErrorWithActions=w;function A(I,u){let p;return typeof I=="string"?p=new Error(I):p=I,p.actions=u,p}e.createErrorWithActions=A}),define(Pe[138],Te([1,0,39,19]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new S.Lazy(()=>{const O=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:O,collatorIsNumeric:O.resolvedOptions().numeric}}),R=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new S.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(O,v,_=!1){const y=O||"",M=v||"",V=D.value.collator.compare(y,M);return D.value.collatorIsNumeric&&V===0&&y!==M?y<M?-1:1:V}e.compareFileNames=g;function m(O,v){const _=R.value.collator;return O=O||"",v=v||"",c(_,O,v)}e.compareFileNamesDefault=m;function w(O,v){const _=R.value.collator;return O=O||"",v=v||"",l(O,v)||c(_,O,v)}e.compareFileNamesUpper=w;function A(O,v){const _=R.value.collator;return O=O||"",v=v||"",s(O,v)||c(_,O,v)}e.compareFileNamesLower=A;function I(O,v){return O=O||"",v=v||"",O===v?0:O<v?-1:1}e.compareFileNamesUnicode=I;function u(O,v){const[_,y]=r(O),[M,V]=r(v);let $=D.value.collator.compare(y,V);if($===0){if(D.value.collatorIsNumeric&&y!==V)return y<V?-1:1;if($=D.value.collator.compare(_,M),D.value.collatorIsNumeric&&$===0&&_!==M)return _<M?-1:1}return $}e.compareFileExtensions=u;function p(O,v){O=O||"",v=v||"";const _=a(O),y=a(v),M=R.value.collator,V=T.value.collator;return c(V,_,y)||c(M,O,v)}e.compareFileExtensionsDefault=p;function E(O,v){O=O||"",v=v||"";const _=a(O),y=a(v),M=R.value.collator,V=T.value.collator;return c(V,_,y)||l(O,v)||c(M,O,v)}e.compareFileExtensionsUpper=E;function n(O,v){O=O||"",v=v||"";const _=a(O),y=a(v),M=R.value.collator,V=T.value.collator;return c(V,_,y)||s(O,v)||c(M,O,v)}e.compareFileExtensionsLower=n;function o(O,v){O=O||"",v=v||"";const _=a(O).toLowerCase(),y=a(v).toLowerCase();return _!==y?_<y?-1:1:O!==v?O<v?-1:1:0}e.compareFileExtensionsUnicode=o;const t=/^(.*?)(\.([^.]*))?$/;function r(O,v=!1){const _=O?t.exec(O):[];let y=[_&&_[1]||"",_&&_[3]||""];return v&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function a(O){const v=O?t.exec(O):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(O,v,_){const y=O.compare(v,_);return y!==0?y:v.length!==_.length?v.length<_.length?-1:1:0}function d(O){const v=O.charAt(0);return v.toLocaleUpperCase()!==v}function i(O){const v=O.charAt(0);return v.toLocaleLowerCase()!==v}function s(O,v){return d(O)&&i(v)?-1:i(O)&&d(v)?1:0}function l(O,v){return i(O)&&d(v)?-1:d(O)&&i(v)?1:0}function h(O,v,_=!1){return _||(O=O&&O.toLowerCase(),v=v&&v.toLowerCase()),O===v?0:O<v?-1:1}function b(O,v,_=!1){const y=O.split(F.sep),M=v.split(F.sep),V=y.length-1,$=M.length-1;let L,U;for(let k=0;;k++){if(L=V===k,U=$===k,L&&U)return g(y[k],M[k],_);if(L)return-1;if(U)return 1;const P=h(y[k],M[k],_);if(P!==0)return P}}e.comparePaths=b;function f(O,v,_){const y=O.toLowerCase(),M=v.toLowerCase(),V=C(O,v,_);if(V)return V;const $=y.endsWith(_),L=M.endsWith(_);if($!==L)return $?-1:1;const U=g(y,M);return U!==0?U:y.localeCompare(M)}e.compareAnything=f;function C(O,v,_){const y=O.toLowerCase(),M=v.toLowerCase(),V=y.startsWith(_),$=M.startsWith(_);if(V!==$)return V?-1:1;if(V&&$){if(y.length<M.length)return-1;if(y.length>M.length)return 1}return 0}e.compareByPrefix=C}),define(Pe[46],Te([1,0,19,21,12,16]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(f){return f===47||f===92}e.isPathSeparator=T;function g(f){return f.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=g;function m(f){return f.indexOf("/")===-1&&(f=g(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.toPosixPath=m;function w(f,C=S.posix.sep){if(!f)return"";const O=f.length,v=f.charCodeAt(0);if(T(v)){if(T(f.charCodeAt(1))&&!T(f.charCodeAt(2))){let y=3;const M=y;for(;y<O&&!T(f.charCodeAt(y));y++);if(M!==y&&!T(f.charCodeAt(y+1))){for(y+=1;y<O;y++)if(T(f.charCodeAt(y)))return f.slice(0,y+1).replace(/[\\/]/g,C)}}return C}else if(t(v)&&f.charCodeAt(1)===58)return T(f.charCodeAt(2))?f.slice(0,2)+C:f.slice(0,2);let _=f.indexOf("://");if(_!==-1){for(_+=3;_<O;_++)if(T(f.charCodeAt(_)))return f.slice(0,_+1)}return""}e.getRoot=w;function A(f){if(!F.isWindows||!f||f.length<5)return!1;let C=f.charCodeAt(0);if(C!==92||(C=f.charCodeAt(1),C!==92))return!1;let O=2;const v=O;for(;O<f.length&&(C=f.charCodeAt(O),C!==92);O++);return!(v===O||(C=f.charCodeAt(O+1),isNaN(C)||C===92))}e.isUNC=A;const I=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(f,C=F.isWindows){const O=C?I:u;return!(!f||f.length===0||/^\s+$/.test(f)||(O.lastIndex=0,O.test(f))||C&&p.test(f)||f==="."||f===".."||C&&f[f.length-1]==="."||C&&f.length!==f.trim().length||f.length>255)}e.isValidBasename=E;function n(f,C,O){const v=f===C;return!O||v?v:!f||!C?!1:(0,D.equalsIgnoreCase)(f,C)}e.isEqual=n;function o(f,C,O,v=S.sep){if(f===C)return!0;if(!f||!C||C.length>f.length)return!1;if(O){if(!(0,D.startsWithIgnoreCase)(f,C))return!1;if(C.length===f.length)return!0;let y=C.length;return C.charAt(C.length-1)===v&&y--,f.charAt(y)===v}return C.charAt(C.length-1)!==v&&(C+=v),f.indexOf(C)===0}e.isEqualOrParent=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.isWindowsDriveLetter=t;function r(f,C){return F.isWindows&&f.endsWith(":")&&(f+=S.sep),(0,S.isAbsolute)(f)||(f=(0,S.join)(C,f)),f=(0,S.normalize)(f),F.isWindows?(f=(0,D.rtrim)(f,S.sep),f.endsWith(":")&&(f+=S.sep)):(f=(0,D.rtrim)(f,S.sep),f||(f=S.sep)),f}e.sanitizeFilePath=r;function a(f){const C=(0,S.normalize)(f);return F.isWindows?f.length>3?!1:c(C)&&(f.length===2||C.charCodeAt(2)===92):C===S.posix.sep}e.isRootOrDriveLetter=a;function c(f,C=F.isWindows){return C?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function d(f,C=F.isWindows){return c(f,C)?f[0]:void 0}e.getDriveLetter=d;function i(f,C,O){return C.length>f.length?-1:f===C?0:(O&&(f=f.toLowerCase(),C=C.toLowerCase()),f.indexOf(C))}e.indexOfPath=i;function s(f){const C=f.split(":");let O,v,_;for(const y of C){const M=Number(y);(0,R.isNumber)(M)?v===void 0?v=M:_===void 0&&(_=M):O=O?[O,y].join(":"):y}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:v!==void 0?v:void 0,column:_!==void 0?_:v!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(f,C,O=8){let v="";for(let y=0;y<O;y++){let M;y===0&&F.isWindows&&!C&&(O===3||O===4)?M=h:M=l,v+=M.charAt(Math.floor(Math.random()*M.length))}let _;return C?_=`${C}-${v}`:_=v,f?(0,S.join)(f,_):_}e.randomPath=b}),define(Pe[68],Te([1,0,19]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const I=(0,S.extname)(A),u=F[I.toLowerCase()];return u!==void 0?u:T(A)}e.getMediaOrTextMime=R;function T(A){const I=(0,S.extname)(A);return D[I.toLowerCase()]}e.getMediaMime=T;function g(A){for(const I in D)if(D[I]===A)return I}e.getExtensionForMimeType=g;const m=/^(.+)\/(.+?)(;.+)?$/;function w(A,I){const u=m.exec(A);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:I?void 0:A}e.normalizeMimeType=w}),define(Pe[51],Te([1,0,24,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(m){return JSON.stringify(m,T)}e.stringify=D;function R(m){let w=JSON.parse(m);return w=g(w),w}e.parse=R;function T(m,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function g(m,w=0){if(!m||w>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return F.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof S.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let A=0;A<m.length;++A)m[A]=g(m[A],w+1);else for(const A in m)Object.hasOwnProperty.call(m,A)&&(m[A]=g(m[A],w+1))}return m}e.revive=g}),define(Pe[13],Te([1,0,11,21,12,2]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var T;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={}));function g(u,p){return R.URI.isUri(u)?(0,D.equalsIgnoreCase)(u.scheme,p):(0,D.startsWithIgnoreCase)(u,p+":")}e.matchesScheme=g;function m(u,...p){return p.some(E=>g(u,E))}e.matchesSomeScheme=m,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${T.vscodeRemoteResource}`}set(p,E,n){this._hosts[p]=E,this._ports[p]=n}setConnectionToken(p,E){this._connectionTokens[p]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)try{return this._delegate(p)}catch(a){return S.onUnexpectedError(a),p}const E=p.authority;let n=this._hosts[E];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const o=this._ports[E],t=this._connectionTokens[E];let r=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(r+=`&${e.connectionTokenQueryName}=${encodeURIComponent(t)}`),R.URI.from({scheme:F.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${n}:${o}`,path:this._remoteResourcesPath,query:r})}}e.RemoteAuthorities=new w,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class A{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(p){const E=this.toUri(p,ge);return this.uriToBrowserUri(E)}uriToBrowserUri(p){return p.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===T.file&&(F.isNative||F.webWorkerOrigin===`${T.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?p.with({scheme:T.vscodeFileResource,authority:p.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(p){const E=this.toUri(p,ge);return this.uriToFileUri(E)}uriToFileUri(p){return p.scheme===T.vscodeFileResource?p.with({scheme:T.file,authority:p.authority!==A.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(p,E){return R.URI.isUri(p)?p:R.URI.parse(E.toUrl(p))}}e.FileAccess=new A;var I;(function(u){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(p.get("3"));const E="vscode-coi";function n(t){let r;typeof t=="string"?r=new URL(t).searchParams:t instanceof URL?r=t.searchParams:R.URI.isUri(t)&&(r=new URL(t.toString(!0)).searchParams);const a=r?.get(E);if(a)return p.get(a)}u.getHeadersFromQuery=n;function o(t,r,a){if(!globalThis.crossOriginIsolated)return;const c=r&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(E,c):t[E]=c}u.addSearchParam=o})(I||(e.COI=I={}))}),define(Pe[25],Te([1,0,46,13,19,21,12,2]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(p){return(0,g.uriToFsPath)(p,!0)}e.originalFSPath=m;class w{constructor(E){this._ignorePathCasing=E}compare(E,n,o=!1){return E===n?0:(0,T.compare)(this.getComparisonKey(E,o),this.getComparisonKey(n,o))}isEqual(E,n,o=!1){return E===n?!0:!E||!n?!1:this.getComparisonKey(E,o)===this.getComparisonKey(n,o)}getComparisonKey(E,n=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,n,o=!1){if(E.scheme===n.scheme){if(E.scheme===F.Schemas.file)return S.isEqualOrParent(m(E),m(n),this._ignorePathCasing(E))&&E.query===n.query&&(o||E.fragment===n.fragment);if((0,e.isEqualAuthority)(E.authority,n.authority))return S.isEqualOrParent(E.path,n.path,this._ignorePathCasing(E),"/")&&E.query===n.query&&(o||E.fragment===n.fragment)}return!1}joinPath(E,...n){return g.URI.joinPath(E,...n)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return D.posix.basename(E.path)}extname(E){return D.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let n;return E.scheme===F.Schemas.file?n=g.URI.file(D.dirname(m(E))).path:(n=D.posix.dirname(E.path),E.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),n="/")),E.with({path:n})}normalizePath(E){if(!E.path.length)return E;let n;return E.scheme===F.Schemas.file?n=g.URI.file(D.normalize(m(E))).path:n=D.posix.normalize(E.path),E.with({path:n})}relativePath(E,n){if(E.scheme!==n.scheme||!(0,e.isEqualAuthority)(E.authority,n.authority))return;if(E.scheme===F.Schemas.file){const r=D.relative(m(E),m(n));return R.isWindows?S.toSlashes(r):r}let o=E.path||"/";const t=n.path||"/";if(this._ignorePathCasing(E)){let r=0;for(const a=Math.min(o.length,t.length);r<a&&!(o.charCodeAt(r)!==t.charCodeAt(r)&&o.charAt(r).toLowerCase()!==t.charAt(r).toLowerCase());r++);o=t.substr(0,r)+o.substr(r)}return D.posix.relative(o,t)}resolvePath(E,n){if(E.scheme===F.Schemas.file){const o=g.URI.file(D.resolve(m(E),n));return E.with({authority:o.authority,path:o.path})}return n=S.toPosixPath(n),E.with({path:D.posix.resolve(E.path,n)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,n){return E===n||E!==void 0&&n!==void 0&&(0,T.equalsIgnoreCase)(E,n)}hasTrailingPathSeparator(E,n=D.sep){if(E.scheme===F.Schemas.file){const o=m(E);return o.length>S.getRoot(o).length&&o[o.length-1]===n}else{const o=E.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,n=D.sep){return(0,e.hasTrailingPathSeparator)(E,n)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,n=D.sep){let o=!1;if(E.scheme===F.Schemas.file){const t=m(E);o=t!==void 0&&t.length===S.getRoot(t).length&&t[t.length-1]===n}else{n="/";const t=E.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(E,n)?E.with({path:E.path+"/"}):E}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(p=>p.scheme===F.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(p,E){const n=[];for(let o=0;o<p.length;o++){const t=E(p[o]);p.some((r,a)=>a===o?!1:(0,e.isEqualOrParent)(t,E(r)))||n.push(p[o])}return n}e.distinctParents=A;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function E(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,d]=a.split(":");c&&d&&o.set(c,d)});const r=n.path.substring(0,n.path.indexOf(";"));return r&&o.set(p.META_DATA_MIME,r),o}p.parseMetaData=E})(I||(e.DataUri=I={}));function u(p,E,n){if(E){let o=p.path;return o&&o[0]!==D.posix.sep&&(o=D.posix.sep+o),p.with({scheme:n,authority:E,path:o})}return p.with({scheme:n})}e.toLocalResource=u}),define(Pe[14],Te([1,0,20,11,5,6,25,21,125,39]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function A(ce){return!!ce&&typeof ce.then=="function"}e.isThenable=A;function I(ce){const ie=new S.CancellationTokenSource,G=ce(ie.token),ee=new Promise((pe,be)=>{const Le=ie.token.onCancellationRequested(()=>{Le.dispose(),ie.dispose(),be(new F.CancellationError)});Promise.resolve(G).then(ue=>{Le.dispose(),ie.dispose(),pe(ue)},ue=>{Le.dispose(),ie.dispose(),be(ue)})});return new class{cancel(){ie.cancel()}then(pe,be){return ee.then(pe,be)}catch(pe){return this.then(void 0,pe)}finally(pe){return ee.finally(pe)}}}e.createCancelablePromise=I;function u(ce,ie,G){return new Promise((ee,pe)=>{const be=ie.onCancellationRequested(()=>{be.dispose(),ee(G)});ce.then(ee,pe).finally(()=>be.dispose())})}e.raceCancellation=u;function p(ce,ie){return new Promise((G,ee)=>{const pe=ie.onCancellationRequested(()=>{pe.dispose(),ee(new F.CancellationError)});ce.then(G,ee).finally(()=>pe.dispose())})}e.raceCancellationError=p;async function E(ce){let ie=-1;const G=ce.map((ee,pe)=>ee.then(be=>(ie=pe,be)));try{return await Promise.race(G)}finally{ce.forEach((ee,pe)=>{pe!==ie&&ee.cancel()})}}e.raceCancellablePromises=E;function n(ce,ie,G){let ee;const pe=setTimeout(()=>{ee?.(void 0),G?.()},ie);return Promise.race([ce.finally(()=>clearTimeout(pe)),new Promise(be=>ee=be)])}e.raceTimeout=n;function o(ce){return new Promise((ie,G)=>{const ee=ce();A(ee)?ee.then(ie,G):ie(ee)})}e.asPromise=o;class t{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ie){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=ie,!this.queuedPromise){const G=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then(G,G).then(ee)})}return new Promise((G,ee)=>{this.queuedPromise.then(G,ee)})}return this.activePromise=ie(),new Promise((G,ee)=>{this.activePromise.then(pe=>{this.activePromise=null,G(pe)},pe=>{this.activePromise=null,ee(pe)})})}dispose(){this.isDisposed=!0}}e.Throttler=t;class r{constructor(){this.current=Promise.resolve(null)}queue(ie){return this.current=this.current.then(()=>ie(),()=>ie())}}e.Sequencer=r;class a{constructor(){this.promiseMap=new Map}queue(ie,G){const pe=(this.promiseMap.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.promiseMap.get(ie)===pe&&this.promiseMap.delete(ie)});return this.promiseMap.set(ie,pe),pe}}e.SequencerByKey=a;const c=(ce,ie)=>{let G=!0;const ee=setTimeout(()=>{G=!1,ie()},ce);return{isTriggered:()=>G,dispose:()=>{clearTimeout(ee),G=!1}}},d=ce=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,ce())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class i{constructor(ie){this.defaultDelay=ie,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ie,G=this.defaultDelay){this.task=ie,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((pe,be)=>{this.doResolve=pe,this.doReject=be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const pe=this.task;return this.task=null,pe()}}));const ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=G===m.MicrotaskDelay?d(ee):c(G,ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new F.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class s{constructor(ie){this.delayer=new i(ie),this.throttler=new t}trigger(ie,G){return this.delayer.trigger(()=>this.throttler.queue(ie),G)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class l{constructor(){this._isOpen=!1,this._promise=new Promise((ie,G)=>{this._completePromise=ie})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class h extends l{constructor(ie){super(),this._timeout=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function b(ce,ie){return ie?new Promise((G,ee)=>{const pe=setTimeout(()=>{be.dispose(),G()},ce),be=ie.onCancellationRequested(()=>{clearTimeout(pe),be.dispose(),ee(new F.CancellationError)})}):I(G=>b(ce,G))}e.timeout=b;function f(ce,ie=0,G){const ee=setTimeout(()=>{ce(),G&&pe.dispose()},ie),pe=(0,R.toDisposable)(()=>{clearTimeout(ee),G?.deleteAndLeak(pe)});return G?.add(pe),pe}e.disposableTimeout=f;function C(ce){const ie=[];let G=0;const ee=ce.length;function pe(){return G<ee?ce[G++]():null}function be(Le){Le!=null&&ie.push(Le);const ue=pe();return ue?ue.then(be):Promise.resolve(ie)}return Promise.resolve(null).then(be)}e.sequence=C;function O(ce,ie=ee=>!!ee,G=null){let ee=0;const pe=ce.length,be=()=>{if(ee>=pe)return Promise.resolve(G);const Le=ce[ee++];return Promise.resolve(Le()).then(we=>ie(we)?Promise.resolve(we):be())};return be()}e.first=O;function v(ce,ie=ee=>!!ee,G=null){if(ce.length===0)return Promise.resolve(G);let ee=ce.length;const pe=()=>{ee=-1;for(const be of ce)be.cancel?.()};return new Promise((be,Le)=>{for(const ue of ce)ue.then(we=>{--ee>=0&&ie(we)?(pe(),be(we)):ee===0&&be(G)}).catch(we=>{--ee>=0&&(pe(),Le(we))})})}e.firstParallel=v;class _{constructor(ie){this._size=0,this.maxDegreeOfParalellism=ie,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ie){return this._size++,new Promise((G,ee)=>{this.outstandingPromises.push({factory:ie,c:G,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ie=this.outstandingPromises.shift();this.runningPromises++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=_;class y extends _{constructor(){super(1)}}e.Queue=y;class M{constructor(){this.sequentializer=new Ce,this.tasks=0}queue(ie){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,ie())):this.sequentializer.run(this.tasks++,ie())}}e.LimitedQueue=M;class V{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const ie=new te;return this.drainers.add(ie),ie.p}isDrained(){for(const[,ie]of this.queues)if(ie.size>0)return!1;return!0}queueFor(ie,G=T.extUri){const ee=G.getComparisonKey(ie);let pe=this.queues.get(ee);if(!pe){pe=new y;const be=this.drainListenerCount++,Le=D.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(ee),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(be),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new R.DisposableMap),this.drainListeners.set(be,Le),this.queues.set(ee,pe)}return pe}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const ie of this.drainers)ie.complete();this.drainers.clear()}dispose(){for(const[,ie]of this.queues)ie.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=V;class ${constructor(ie,G){this._token=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ie,G){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ie()},G)}setIfNotSet(ie,G){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ie()},G))}}e.TimeoutTimer=$;class L{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(ie,G,ee=globalThis){this.cancel();const pe=ee.setInterval(()=>{ie()},G);this.disposable=(0,R.toDisposable)(()=>{ee.clearInterval(pe),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=L;class U{constructor(ie,G){this.timeoutToken=-1,this.runner=ie,this.timeout=G,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ie=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ie)}get delay(){return this.timeout}set delay(ie){this.timeout=ie}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class k{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.runner=ie,this.timeout=G,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ie=this.timeout){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ie/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class P extends U{constructor(ie,G){super(ie,G),this.units=[]}work(ie){this.units.push(ie),this.isScheduled()||this.schedule()}doRun(){const ie=this.units;this.units=[],this.runner?.(ie)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=P;class Q extends R.Disposable{constructor(ie,G){super(),this.options=ie,this.handler=G,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ie){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ie.length>this.options.maxBufferedWork)return!1}else if(this.pending+ie.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const G of ie)this.pendingWork.push(G);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ce,ie)=>{(0,g.setTimeout0)(()=>{if(G)return;const ee=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e._runWhenIdle=(ce,ie,G)=>{const ee=ce.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,ce.cancelIdleCallback(ee))}}},e.runWhenGlobalIdle=ce=>(0,e._runWhenIdle)(globalThis,ce)}();class ae{constructor(ie,G){this._didRun=!1,this._executor=()=>{try{this._value=G()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(ie,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ae;class me extends ae{constructor(ie){super(globalThis,ie)}}e.GlobalIdleValue=me;async function Ee(ce,ie,G){let ee;for(let pe=0;pe<G;pe++)try{return await ce()}catch(be){ee=be,await b(ie)}throw ee}e.retry=Ee;class Ce{isRunning(ie){return typeof ie=="number"?this._running?.taskId===ie:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(ie,G,ee){return this._running={taskId:ie,cancel:()=>ee?.(),promise:G},G.then(()=>this.doneRunning(ie),()=>this.doneRunning(ie)),G}doneRunning(ie){this._running&&ie===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const ie=this._queued;this._queued=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this._queued)this._queued.run=ie;else{let G,ee;const pe=new Promise((be,Le)=>{G=be,ee=Le});this._queued={run:ie,promise:pe,promiseResolve:G,promiseReject:ee}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Ce;class he{constructor(ie,G=()=>Date.now()){this.interval=ie,this.nowFn=G,this.lastIncrementTime=0,this.value=0}increment(){const ie=this.nowFn();return ie-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ie,this.value=0),this.value++,this.value}}e.IntervalCounter=he;var de;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(de||(de={}));class te{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.completeCallback=ie,this.errorCallback=G})}complete(ie){return new Promise(G=>{this.completeCallback(ie),this.outcome={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.errorCallback(ie),this.outcome={outcome:1,value:ie},G()})}cancel(){return this.error(new F.CancellationError)}}e.DeferredPromise=te;var Ie;(function(ce){async function ie(ee){let pe;const be=await Promise.all(ee.map(Le=>Le.then(ue=>ue,ue=>{pe||(pe=ue)})));if(typeof pe<"u")throw pe;return be}ce.settled=ie;function G(ee){return new Promise(async(pe,be)=>{try{await ee(pe,be)}catch(Le){be(Le)}})}ce.withAsyncBody=G})(Ie||(e.Promises=Ie={}));class oe{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(ie){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=ie.then(G=>(this._value=G,this._isResolved=!0,G),G=>{throw this._error=G,this._isResolved=!0,G})}requireValue(){if(!this._isResolved)throw new F.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=oe;class Y{constructor(ie){this._compute=ie,this._promise=new w.Lazy(()=>new oe(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}}e.LazyStatefulPromise=Y;var H;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(H||(H={}));class ne{static fromArray(ie){return new ne(G=>{G.emitMany(ie)})}static fromPromise(ie){return new ne(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new ne(async G=>{await Promise.all(ie.map(async ee=>G.emitOne(await ee)))})}static merge(ie){return new ne(async G=>{await Promise.all(ie.map(async ee=>{for await(const pe of ee)G.emitOne(pe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const G={emitOne:ee=>this.emitOne(ee),emitMany:ee=>this.emitMany(ee),reject:ee=>this.reject(ee)};try{await Promise.resolve(ie(G)),this.resolve()}catch(ee){this.reject(ee)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ie<this._results.length)return{done:!1,value:this._results[ie++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ie,G){return new ne(async ee=>{for await(const pe of ie)ee.emitOne(G(pe))})}map(ie){return ne.map(this,ie)}static filter(ie,G){return new ne(async ee=>{for await(const pe of ie)G(pe)&&ee.emitOne(pe)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,G=>!!G)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const G=[];for await(const ee of ie)G.push(ee);return G}toPromise(){return ne.toPromise(this)}emitOne(ie){this._state===0&&(this._results.push(ie),this._onStateChanged.fire())}emitMany(ie){this._state===0&&(this._results=this._results.concat(ie),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ie){this._state===0&&(this._state=2,this._error=ie,this._onStateChanged.fire())}}e.AsyncIterableObject=ne;class De extends ne{constructor(ie,G){super(G),this._source=ie}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=De;function Re(ce){const ie=new S.CancellationTokenSource,G=ce(ie.token);return new De(ie,async ee=>{const pe=ie.token.onCancellationRequested(()=>{pe.dispose(),ie.dispose(),ee.reject(new F.CancellationError)});try{for await(const be of G){if(ie.token.isCancellationRequested)return;ee.emitOne(be)}pe.dispose(),ie.dispose()}catch(be){pe.dispose(),ie.dispose(),ee.reject(be)}})}e.createCancelableAsyncIterable=Re;class ke{constructor(){this._deferred=new te,this._asyncIterable=new ne(ee=>{if(ie){ee.reject(ie);return}return G&&ee.emitMany(G),this._errorFn=pe=>ee.reject(pe),this._emitFn=pe=>ee.emitOne(pe),this._deferred.p});let ie,G;this._emitFn=ee=>{G||(G=[]),G.push(ee)},this._errorFn=ee=>{ie||(ie=ee)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(ie){this._errorFn(ie),this._deferred.complete()}emitOne(ie){this._emitFn(ie)}}e.AsyncIterableSource=ke}),define(Pe[34],Te([1,0,18,14,46,28,19,21,12]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",I="[^/\\\\]",u=/\//g;function p(me,Ee){switch(me){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${Ee?`|${A}${I}+`:""})*?`}}function E(me,Ee){if(!me)return[];const Ce=[];let he=!1,de=!1,te="";for(const Ie of me){switch(Ie){case Ee:if(!he&&!de){Ce.push(te),te="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":de=!0;break;case"]":de=!1;break}te+=Ie}return te&&Ce.push(te),Ce}e.splitGlobAware=E;function n(me){if(!me)return"";let Ee="";const Ce=E(me,e.GLOB_SPLIT);if(Ce.every(he=>he===e.GLOBSTAR))Ee=".*";else{let he=!1;Ce.forEach((de,te)=>{if(de===e.GLOBSTAR){if(he)return;Ee+=p(2,te===Ce.length-1)}else{let Ie=!1,oe="",Y=!1,H="";for(const ne of de){if(ne!=="}"&&Ie){oe+=ne;continue}if(Y&&(ne!=="]"||!H)){let De;ne==="-"?De=ne:(ne==="^"||ne==="!")&&!H?De="^":ne===e.GLOB_SPLIT?De="":De=(0,m.escapeRegExpCharacters)(ne),H+=De;continue}switch(ne){case"{":Ie=!0;continue;case"[":Y=!0;continue;case"}":{const Re=`(?:${E(oe,",").map(ke=>n(ke)).join("|")})`;Ee+=Re,Ie=!1,oe="";break}case"]":{Ee+="["+H+"]",Y=!1,H="";break}case"?":Ee+=I;continue;case"*":Ee+=p(1);continue;default:Ee+=(0,m.escapeRegExpCharacters)(ne)}}te<Ce.length-1&&(Ce[te+1]!==e.GLOBSTAR||te+2<Ce.length)&&(Ee+=A)}he=de===e.GLOBSTAR})}return Ee}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},l=function(){return null};function h(me,Ee){if(!me)return l;let Ce;typeof me!="string"?Ce=me.pattern:Ce=me,Ce=Ce.trim();const he=`${Ce}_${!!Ee.trimForExclusions}`;let de=i.get(he);if(de)return b(de,me);let te;return o.test(Ce)?de=C(Ce.substr(4),Ce):(te=t.exec(f(Ce,Ee)))?de=O(te[1],Ce):(Ee.trimForExclusions?a:r).test(Ce)?de=v(Ce,Ee):(te=c.exec(f(Ce,Ee)))?de=_(te[1].substr(1),Ce,!0):(te=d.exec(f(Ce,Ee)))?de=_(te[1],Ce,!1):de=y(Ce),i.set(he,de),b(de,me)}function b(me,Ee){if(typeof Ee=="string")return me;const Ce=function(he,de){return(0,D.isEqualOrParent)(he,Ee.base,!g.isLinux)?me((0,m.ltrim)(he.substr(Ee.base.length),T.sep),de):null};return Ce.allBasenames=me.allBasenames,Ce.allPaths=me.allPaths,Ce.basenames=me.basenames,Ce.patterns=me.patterns,Ce}function f(me,Ee){return Ee.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function C(me,Ee){return function(Ce,he){return typeof Ce=="string"&&Ce.endsWith(me)?Ee:null}}function O(me,Ee){const Ce=`/${me}`,he=`\\${me}`,de=function(Ie,oe){return typeof Ie!="string"?null:oe?oe===me?Ee:null:Ie===me||Ie.endsWith(Ce)||Ie.endsWith(he)?Ee:null},te=[me];return de.basenames=te,de.patterns=[Ee],de.allBasenames=te,de}function v(me,Ee){const Ce=Q(me.slice(1,-1).split(",").map(oe=>h(oe,Ee)).filter(oe=>oe!==l),me),he=Ce.length;if(!he)return l;if(he===1)return Ce[0];const de=function(oe,Y){for(let H=0,ne=Ce.length;H<ne;H++)if(Ce[H](oe,Y))return me;return null},te=Ce.find(oe=>!!oe.allBasenames);te&&(de.allBasenames=te.allBasenames);const Ie=Ce.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return Ie.length&&(de.allPaths=Ie),de}function _(me,Ee,Ce){const he=T.sep===T.posix.sep,de=he?me:me.replace(u,T.sep),te=T.sep+de,Ie=T.posix.sep+me;let oe;return Ce?oe=function(Y,H){return typeof Y=="string"&&(Y===de||Y.endsWith(te)||!he&&(Y===me||Y.endsWith(Ie)))?Ee:null}:oe=function(Y,H){return typeof Y=="string"&&(Y===de||!he&&Y===me)?Ee:null},oe.allPaths=[(Ce?"*/":"./")+me],oe}function y(me){try{const Ee=new RegExp(`^${n(me)}$`);return function(Ce){return Ee.lastIndex=0,typeof Ce=="string"&&Ee.test(Ce)?me:null}}catch{return l}}function M(me,Ee,Ce){return!me||typeof Ee!="string"?!1:V(me)(Ee,void 0,Ce)}e.match=M;function V(me,Ee={}){if(!me)return s;if(typeof me=="string"||$(me)){const Ce=h(me,Ee);if(Ce===l)return s;const he=function(de,te){return!!Ce(de,te)};return Ce.allBasenames&&(he.allBasenames=Ce.allBasenames),Ce.allPaths&&(he.allPaths=Ce.allPaths),he}return k(me,Ee)}e.parse=V;function $(me){const Ee=me;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.isRelativePattern=$;function L(me){return me.allBasenames||[]}e.getBasenameTerms=L;function U(me){return me.allPaths||[]}e.getPathTerms=U;function k(me,Ee){const Ce=Q(Object.getOwnPropertyNames(me).map(oe=>P(oe,me[oe],Ee)).filter(oe=>oe!==l)),he=Ce.length;if(!he)return l;if(!Ce.some(oe=>!!oe.requiresSiblings)){if(he===1)return Ce[0];const oe=function(ne,De){let Re;for(let ke=0,ce=Ce.length;ke<ce;ke++){const ie=Ce[ke](ne,De);if(typeof ie=="string")return ie;(0,F.isThenable)(ie)&&(Re||(Re=[]),Re.push(ie))}return Re?(async()=>{for(const ke of Re){const ce=await ke;if(typeof ce=="string")return ce}return null})():null},Y=Ce.find(ne=>!!ne.allBasenames);Y&&(oe.allBasenames=Y.allBasenames);const H=Ce.reduce((ne,De)=>De.allPaths?ne.concat(De.allPaths):ne,[]);return H.length&&(oe.allPaths=H),oe}const de=function(oe,Y,H){let ne,De;for(let Re=0,ke=Ce.length;Re<ke;Re++){const ce=Ce[Re];ce.requiresSiblings&&H&&(Y||(Y=(0,T.basename)(oe)),ne||(ne=Y.substr(0,Y.length-(0,T.extname)(oe).length)));const ie=ce(oe,Y,ne,H);if(typeof ie=="string")return ie;(0,F.isThenable)(ie)&&(De||(De=[]),De.push(ie))}return De?(async()=>{for(const Re of De){const ke=await Re;if(typeof ke=="string")return ke}return null})():null},te=Ce.find(oe=>!!oe.allBasenames);te&&(de.allBasenames=te.allBasenames);const Ie=Ce.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return Ie.length&&(de.allPaths=Ie),de}function P(me,Ee,Ce){if(Ee===!1)return l;const he=h(me,Ce);if(he===l)return l;if(typeof Ee=="boolean")return he;if(Ee){const de=Ee.when;if(typeof de=="string"){const te=(Ie,oe,Y,H)=>{if(!H||!he(Ie,oe))return null;const ne=de.replace("$(basename)",()=>Y),De=H(ne);return(0,F.isThenable)(De)?De.then(Re=>Re?me:null):De?me:null};return te.requiresSiblings=!0,te}}return he}function Q(me,Ee){const Ce=me.filter(oe=>!!oe.basenames);if(Ce.length<2)return me;const he=Ce.reduce((oe,Y)=>{const H=Y.basenames;return H?oe.concat(H):oe},[]);let de;if(Ee){de=[];for(let oe=0,Y=he.length;oe<Y;oe++)de.push(Ee)}else de=Ce.reduce((oe,Y)=>{const H=Y.patterns;return H?oe.concat(H):oe},[]);const te=function(oe,Y){if(typeof oe!="string")return null;if(!Y){let ne;for(ne=oe.length;ne>0;ne--){const De=oe.charCodeAt(ne-1);if(De===47||De===92)break}Y=oe.substr(ne)}const H=he.indexOf(Y);return H!==-1?de[H]:null};te.basenames=he,te.patterns=de,te.allBasenames=he;const Ie=me.filter(oe=>!oe.basenames);return Ie.push(te),Ie}function ae(me,Ee){return(0,S.equals)(me,Ee,(Ce,he)=>typeof Ce=="string"&&typeof he=="string"?Ce===he:typeof Ce!="string"&&typeof he!="string"?Ce.base===he.base&&Ce.pattern===he.pattern:!1)}e.patternsEquals=ae}),define(Pe[52],Te([1,0,11,126,25,12,2]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class m{constructor(t="",r=!1){if(this.value=t,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(t,r=0){return this.value+=u(this.supportThemeIcons?(0,F.escapeIcons)(t):t).replace(/([ \t]+)/g,(a,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,r){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(t,r,a){return this.value+="[",this.value+=this._escape(r,"]"),this.value+="](",this.value+=this._escape(String(t),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(t,r){const a=new RegExp((0,R.escapeRegExpCharacters)(r),"g");return t.replace(a,(c,d)=>t.charAt(d-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=m;function w(o){return A(o)?!o.value:Array.isArray(o)?o.every(w):!0}e.isEmptyMarkdownString=w;function A(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function I(o,t){return o===t?!0:!o||!t?!1:o.value===t.value&&o.isTrusted===t.isTrusted&&o.supportThemeIcons===t.supportThemeIcons&&o.supportHtml===t.supportHtml&&(o.baseUri===t.baseUri||!!o.baseUri&&!!t.baseUri&&(0,D.isEqual)(T.URI.from(o.baseUri),T.URI.from(t.baseUri)))}e.markdownStringEqual=I;function u(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=u;function p(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function E(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=E;function n(o){const t=[],r=o.split("|").map(c=>c.trim());o=r[0];const a=r[1];if(a){const c=/height=(\d+)/.exec(a),d=/width=(\d+)/.exec(a),i=c?c[1]:"",s=d?d[1]:"",l=isFinite(parseInt(s)),h=isFinite(parseInt(i));l&&t.push(`width="${s}"`),h&&t.push(`height="${i}"`)}return{href:o,dimensions:t}}e.parseHrefAndDimensions=n}),define(Pe[95],Te([1,0,18,46,19,21,25,12]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function m(h,b){const{os:f,tildify:C,relative:O}=b;if(O){const y=w(h,O,f);if(typeof y=="string")return y}let v=h.fsPath;if(f===1&&!R.isWindows?v=v.replace(/\//g,"\\"):f!==1&&R.isWindows&&(v=v.replace(/\\/g,"/")),f!==1&&C?.userHome){const y=C.userHome.fsPath;let M;h.scheme!==C.userHome.scheme&&h.path[0]===D.posix.sep&&h.path[1]!==D.posix.sep?M=C.userHome.with({path:h.path}).fsPath:M=v,v=u(M,y,f)}return(f===1?D.win32:D.posix).normalize(A(v,f===1))}e.getPathLabel=m;function w(h,b,f){const C=f===1?D.win32:D.posix,O=f===3?T.extUri:T.extUriIgnorePathCase,v=b.getWorkspace(),_=(0,S.firstOrDefault)(v.folders);if(!_)return;h.scheme!==_.uri.scheme&&h.path[0]===D.posix.sep&&h.path[1]!==D.posix.sep&&(h=_.uri.with({path:h.path}));const y=b.getWorkspaceFolder(h);if(!y)return;let M;if(O.isEqual(y.uri,h)?M="":M=O.relativePath(y.uri,h)??"",M&&(M=C.normalize(M)),v.folders.length>1&&!b.noPrefix){const V=y.name?y.name:O.basenameOrAuthority(y.uri);M=M?`${V} \u2022 ${M}`:V}return M}function A(h,b=R.isWindows){return(0,F.hasDriveLetter)(h,b)?h.charAt(0).toUpperCase()+h.slice(1):h}e.normalizeDriveLetter=A;let I=Object.create(null);function u(h,b,f=R.OS){if(f===1||!h||!b)return h;let C=I.original===b?I.normalized:void 0;C||(C=b,R.isWindows&&(C=(0,F.toSlashes)(C)),C=`${(0,g.rtrim)(C,D.posix.sep)}${D.posix.sep}`,I={original:b,normalized:C});let O=h;return R.isWindows&&(O=(0,F.toSlashes)(O)),(f===3?O.startsWith(C):(0,g.startsWithIgnoreCase)(O,C))?`~/${O.substr(C.length)}`:h}e.tildify=u;function p(h,b){return h.replace(/^~($|\/|\\)/,`${b}$1`)}e.untildify=p;const E="\u2026",n="\\\\",o="~";function t(h,b=D.sep){const f=new Array(h.length);let C=!1;for(let O=0;O<h.length;O++){const v=h[O];if(v===""){f[O]=`.${b}`;continue}if(!v){f[O]=v;continue}C=!0;let _="",y=v;y.indexOf(n)===0?(_=y.substr(0,y.indexOf(n)+n.length),y=y.substr(y.indexOf(n)+n.length)):y.indexOf(b)===0?(_=y.substr(0,y.indexOf(b)+b.length),y=y.substr(y.indexOf(b)+b.length)):y.indexOf(o)===0&&(_=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const M=y.split(b);for(let V=1;C&&V<=M.length;V++)for(let $=M.length-V;C&&$>=0;$--){C=!1;let L=M.slice($,$+V).join(b);for(let U=0;!C&&U<h.length;U++)if(U!==O&&h[U]&&h[U].indexOf(L)>-1){const k=$+V===M.length,P=$>0&&h[U].indexOf(b)>-1?b+L:L,Q=h[U].endsWith(P);C=!k||Q}if(!C){let U="";(M[0].endsWith(":")||_!=="")&&($===1&&($=0,V++,L=M[0]+b+L),$>0&&(U=M[0]+b),U=_+U),$>0&&(U=U+E+b),U=U+L,$+V<M.length&&(U=U+b+E),f[O]=U}}C&&(f[O]=v)}return f}e.shorten=t;var r;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function a(h,b=Object.create(null)){const f=[];let C=!1,O="";for(const v of h)if(v==="$"||C&&v==="{")O&&f.push({value:O,type:r.TEXT}),O="",C=!0;else if(v==="}"&&C){const _=b[O];if(typeof _=="string")_.length&&f.push({value:_,type:r.VARIABLE});else if(_){const y=f[f.length-1];(!y||y.type!==r.SEPARATOR)&&f.push({value:_.label,type:r.SEPARATOR})}O="",C=!1}else O+=v;return O&&!C&&f.push({value:O,type:r.TEXT}),f.filter((v,_)=>{if(v.type===r.SEPARATOR){const y=f[_-1],M=f[_+1];return[y,M].every(V=>V&&(V.type===r.VARIABLE||V.type===r.TEXT)&&V.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=a;function c(h,b){return R.isMacintosh||b?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):h.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function d(h,b){return R.isMacintosh||b?h.replace(/\(&&\w\)|&&/g,""):R.isWindows?h.replace(/&&|&/g,f=>f==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.mnemonicButtonLabel=d;function i(h){return h.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(h){if(h.endsWith("]")){const b=h.lastIndexOf(" [",h.length-2);if(b!==-1){const f=l(h.substring(0,b));return{name:f.name,parentPath:f.parentPath+h.substring(b)}}}return l(h)}e.splitRecentLabel=s;function l(h){const b=h.indexOf("/")!==-1?D.posix:D.win32,f=b.basename(h),C=b.dirname(h);return f.length?{name:f,parentPath:C}:{name:C,parentPath:""}}}),define(Pe[139],Te([1,0,24,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(I){return I.toJSON()}class R{constructor(u){this._uriTransformer=u}transformIncoming(u){const p=this._uriTransformer.transformIncoming(u);return p===u?u:D(F.URI.from(p))}transformOutgoing(u){const p=this._uriTransformer.transformOutgoing(u);return p===u?u:D(F.URI.from(p))}transformOutgoingURI(u){const p=this._uriTransformer.transformOutgoing(u);return p===u?u:F.URI.from(p)}transformOutgoingScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function T(I,u,p){if(!I||p>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return u.transformOutgoing(I);for(const E in I)if(Object.hasOwnProperty.call(I,E)){const n=T(I[E],u,p+1);n!==null&&(I[E]=n)}}return null}function g(I,u){const p=T(I,u,0);return p===null?I:p}e.transformOutgoingURIs=g;function m(I,u,p,E){if(!I||E>200)return null;if(typeof I=="object"){if(I.$mid===1)return p?F.URI.revive(u.transformIncoming(I)):u.transformIncoming(I);if(I instanceof S.VSBuffer)return null;for(const n in I)if(Object.hasOwnProperty.call(I,n)){const o=m(I[n],u,p,E+1);o!==null&&(I[n]=o)}}return null}function w(I,u){const p=m(I,u,!1,0);return p===null?I:p}e.transformIncomingURIs=w;function A(I,u){const p=m(I,u,!0,0);return p===null?I:p}e.transformAndReviveIncomingURIs=A}),define(Pe[140],Te([1,0,12,21,24]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=e.decodeUTF16LE=e.getPlatformTextDecoder=void 0;let R;function T(){return R||(R=new TextDecoder("UTF-16LE")),R}let g;function m(){return g||(g=new TextDecoder("UTF-16BE")),g}let w;function A(){return w||(w=F.isLittleEndian()?T():m()),w}e.getPlatformTextDecoder=A;function I(E,n,o){const t=new Uint16Array(E.buffer,n,o);return o>0&&(t[0]===65279||t[0]===65534)?u(E,n,o):T().decode(t)}e.decodeUTF16LE=I;function u(E,n,o){const t=[];let r=0;for(let a=0;a<o;a++){const c=D.readUInt16LE(E,n);n+=2,t[r++]=String.fromCharCode(c)}return t.join("")}class p{constructor(n){this._capacity=n|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const n=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return A().decode(n)}_flushBuffer(){const n=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[n]:this._completedStrings[this._completedStrings.length]=n}appendCharCode(n){const o=this._capacity-this._bufferLength;o<=1&&(o===0||S.isHighSurrogate(n))&&this._flushBuffer(),this._buffer[this._bufferLength++]=n}appendASCIICharCode(n){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=n}appendString(n){const o=n.length;if(this._bufferLength+o>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=n;return}for(let t=0;t<o;t++)this._buffer[this._bufferLength++]=n.charCodeAt(t)}}e.StringBuilder=p}),define(Pe[141],Te([1,0,24,140]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressConsecutiveTextChanges=e.TextChange=void 0;function D(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,I,u){this.oldPosition=w,this.oldText=A,this.newPosition=I,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${D(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${D(this.oldText)}")`:`(replace@${this.oldPosition} "${D(this.oldText)}" with "${D(this.newText)}")`}static _writeStringSize(w){return 4+2*w.length}static _writeString(w,A,I){const u=A.length;S.writeUInt32BE(w,u,I),I+=4;for(let p=0;p<u;p++)S.writeUInt16LE(w,A.charCodeAt(p),I),I+=2;return I}static _readString(w,A){const I=S.readUInt32BE(w,A);return A+=4,(0,F.decodeUTF16LE)(w,A,I)}writeSize(){return 4+4+R._writeStringSize(this.oldText)+R._writeStringSize(this.newText)}write(w,A){return S.writeUInt32BE(w,this.oldPosition,A),A+=4,S.writeUInt32BE(w,this.newPosition,A),A+=4,A=R._writeString(w,this.oldText,A),A=R._writeString(w,this.newText,A),A}static read(w,A,I){const u=S.readUInt32BE(w,A);A+=4;const p=S.readUInt32BE(w,A);A+=4;const E=R._readString(w,A);A+=R._writeStringSize(E);const n=R._readString(w,A);return A+=R._writeStringSize(n),I.push(new R(u,E,p,n)),A}}e.TextChange=R;function T(m,w){return m===null||m.length===0?w:new g(m,w).compress()}e.compressConsecutiveTextChanges=T;class g{constructor(w,A){this._prevEdits=w,this._currEdits=A,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let w=0,A=0,I=this._getPrev(w),u=this._getCurr(A);for(;w<this._prevLen||A<this._currLen;){if(I===null){this._acceptCurr(u),u=this._getCurr(++A);continue}if(u===null){this._acceptPrev(I),I=this._getPrev(++w);continue}if(u.oldEnd<=I.newPosition){this._acceptCurr(u),u=this._getCurr(++A);continue}if(I.newEnd<=u.oldPosition){this._acceptPrev(I),I=this._getPrev(++w);continue}if(u.oldPosition<I.newPosition){const[t,r]=g._splitCurr(u,I.newPosition-u.oldPosition);this._acceptCurr(t),u=r;continue}if(I.newPosition<u.oldPosition){const[t,r]=g._splitPrev(I,u.oldPosition-I.newPosition);this._acceptPrev(t),I=r;continue}let n,o;if(u.oldEnd===I.newEnd)n=I,o=u,I=this._getPrev(++w),u=this._getCurr(++A);else if(u.oldEnd<I.newEnd){const[t,r]=g._splitPrev(I,u.oldLength);n=t,o=u,I=r,u=this._getCurr(++A)}else{const[t,r]=g._splitCurr(u,I.newLength);n=I,o=t,I=this._getPrev(++w),u=r}this._result[this._resultLen++]=new R(n.oldPosition,n.oldText,o.newPosition,o.newText),this._prevDeltaOffset+=n.newLength-n.oldLength,this._currDeltaOffset+=o.newLength-o.oldLength}const p=g._merge(this._result);return g._removeNoOps(p)}_acceptCurr(w){this._result[this._resultLen++]=g._rebaseCurr(this._prevDeltaOffset,w),this._currDeltaOffset+=w.newLength-w.oldLength}_getCurr(w){return w<this._currLen?this._currEdits[w]:null}_acceptPrev(w){this._result[this._resultLen++]=g._rebasePrev(this._currDeltaOffset,w),this._prevDeltaOffset+=w.newLength-w.oldLength}_getPrev(w){return w<this._prevLen?this._prevEdits[w]:null}static _rebaseCurr(w,A){return new R(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static _rebasePrev(w,A){return new R(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static _splitPrev(w,A){const I=w.newText.substr(0,A),u=w.newText.substr(A);return[new R(w.oldPosition,w.oldText,w.newPosition,I),new R(w.oldEnd,"",w.newPosition+A,u)]}static _splitCurr(w,A){const I=w.oldText.substr(0,A),u=w.oldText.substr(A);return[new R(w.oldPosition,I,w.newPosition,w.newText),new R(w.oldPosition+A,u,w.newEnd,"")]}static _merge(w){if(w.length===0)return w;const A=[];let I=0,u=w[0];for(let p=1;p<w.length;p++){const E=w[p];u.oldEnd===E.oldPosition?u=new R(u.oldPosition,u.oldText+E.oldText,u.newPosition,u.newText+E.newText):(A[I++]=u,u=E)}return A[I++]=u,A}static _removeNoOps(w){if(w.length===0)return w;const A=[];let I=0;for(let u=0;u<w.length;u++){const p=w[u];p.oldText!==p.newText&&(A[I++]=p)}return A}}}),define(Pe[142],Te([1,0,34,19]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(R,T,g,m,w,A){if(Array.isArray(R)){let I=0;for(const u of R){const p=D(u,T,g,m,w,A);if(p===10)return p;p>I&&(I=p)}return I}else{if(typeof R=="string")return m?R==="*"?5:R===g?10:0:0;if(R){const{language:I,pattern:u,scheme:p,hasAccessToAllModels:E,notebookType:n}=R;if(!m&&!E)return 0;n&&w&&(T=w);let o=0;if(p)if(p===T.scheme)o=10;else if(p==="*")o=5;else return 0;if(I)if(I===g)o=10;else if(I==="*")o=Math.max(o,5);else return 0;if(n)if(n===A)o=10;else if(n==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(u){let t;if(typeof u=="string"?t=u:t={...u,base:(0,F.normalize)(u.base)},t===T.fsPath||(0,S.match)(t,T.fsPath))o=10;else return 0}return o}else return 0}}e.score=D}),define(Pe[143],Te([1,0,5,12,29,93,91,128,141,6]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class A extends w.Disposable{constructor(u,p,E,n,o,t,r){super(),this._onDidChangeContent=this._register(new S.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=p,this._mightContainNonBasicASCII=!t,this._mightContainRTL=n,this._mightContainUnusualLineTerminators=o,this._pieceTree=new T.PieceTreeBase(u,E,r)}equals(u){return!(u instanceof A)||this._BOM!==u._BOM||this.getEOL()!==u.getEOL()?!1:this._pieceTree.equal(u._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(u){return this._pieceTree.createSnapshot(u?this._BOM:"")}getOffsetAt(u,p){return this._pieceTree.getOffsetAt(u,p)}getPositionAt(u){return this._pieceTree.getPositionAt(u)}getRangeAt(u,p){const E=u+p,n=this.getPositionAt(u),o=this.getPositionAt(E);return new D.Range(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(u,p=0){if(u.isEmpty())return"";const E=this._getEndOfLine(p);return this._pieceTree.getValueInRange(u,E)}getValueLengthInRange(u,p=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const E=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const t=this._getEndOfLine(p),r=this.getEOL();if(t.length!==r.length){const a=t.length-r.length,c=u.endLineNumber-u.startLineNumber;o=a*c}return n-E+o}getCharacterCountInRange(u,p=0){if(this._mightContainNonBasicASCII){let E=0;const n=u.startLineNumber,o=u.endLineNumber;for(let t=n;t<=o;t++){const r=this.getLineContent(t),a=t===n?u.startColumn-1:0,c=t===o?u.endColumn-1:r.length;for(let d=a;d<c;d++)F.isHighSurrogate(r.charCodeAt(d))?(E=E+1,d=d+1):E=E+1}return E+=this._getEndOfLine(p).length*(o-n),E}return this.getValueLengthInRange(u,p)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(u){return this._pieceTree.getLineContent(u)}getLineCharCode(u,p){return this._pieceTree.getLineCharCode(u,p)}getCharCode(u){return this._pieceTree.getCharCode(u)}getLineLength(u){return this._pieceTree.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const p=F.firstNonWhitespaceIndex(this.getLineContent(u));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(u){const p=F.lastNonWhitespaceIndex(this.getLineContent(u));return p===-1?0:p+2}_getEndOfLine(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this._pieceTree.setEOL(u)}applyEdits(u,p,E){let n=this._mightContainRTL,o=this._mightContainUnusualLineTerminators,t=this._mightContainNonBasicASCII,r=!0,a=[];for(let b=0;b<u.length;b++){const f=u[b];r&&f._isTracked&&(r=!1);const C=f.range;if(f.text){let M=!0;t||(M=!F.isBasicASCII(f.text),t=M),!n&&M&&(n=F.containsRTL(f.text)),!o&&M&&(o=F.containsUnusualLineTerminators(f.text))}let O="",v=0,_=0,y=0;if(f.text){let M;[v,_,y,M]=(0,g.countEOL)(f.text);const V=this.getEOL();M===0||M===(V===`\r
`?2:1)?O=f.text:O=f.text.replace(/\r\n|\r|\n/g,V)}a[b]={sortIndex:b,identifier:f.identifier||null,range:C,rangeOffset:this.getOffsetAt(C.startLineNumber,C.startColumn),rangeLength:this.getValueLengthInRange(C),text:O,eolCount:v,firstLineLength:_,lastLineLength:y,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(A._sortOpsAscending);let c=!1;for(let b=0,f=a.length-1;b<f;b++){const C=a[b].range.getEndPosition(),O=a[b+1].range.getStartPosition();if(O.isBeforeOrEqual(C)){if(O.isBefore(C))throw new Error("Overlapping ranges are not allowed!");c=!0}}r&&(a=this._reduceOperations(a));const d=E||p?A._getInverseEditRanges(a):[],i=[];if(p)for(let b=0;b<a.length;b++){const f=a[b],C=d[b];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let O=C.startLineNumber;O<=C.endLineNumber;O++){let v="";O===C.startLineNumber&&(v=this.getLineContent(f.range.startLineNumber),F.firstNonWhitespaceIndex(v)!==-1)||i.push({lineNumber:O,oldContent:v})}}let s=null;if(E){let b=0;s=[];for(let f=0;f<a.length;f++){const C=a[f],O=d[f],v=this.getValueInRange(C.range),_=C.rangeOffset+b;b+=C.text.length-v.length,s[f]={sortIndex:C.sortIndex,identifier:C.identifier,range:O,text:v,textChange:new m.TextChange(C.rangeOffset,v,_,C.text)}}c||s.sort((f,C)=>f.sortIndex-C.sortIndex)}this._mightContainRTL=n,this._mightContainUnusualLineTerminators=o,this._mightContainNonBasicASCII=t;const l=this._doApplyEdits(a);let h=null;if(p&&i.length>0){i.sort((b,f)=>f.lineNumber-b.lineNumber),h=[];for(let b=0,f=i.length;b<f;b++){const C=i[b].lineNumber;if(b>0&&i[b-1].lineNumber===C)continue;const O=i[b].oldContent,v=this.getLineContent(C);v.length===0||v===O||F.firstNonWhitespaceIndex(v)!==-1||h.push(C)}}return this._onDidChangeContent.fire(),new R.ApplyEditsResult(s,l,h)}_reduceOperations(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let p=!1;const E=u[0].range,n=u[u.length-1].range,o=new D.Range(E.startLineNumber,E.startColumn,n.endLineNumber,n.endColumn);let t=E.startLineNumber,r=E.startColumn;const a=[];for(let l=0,h=u.length;l<h;l++){const b=u[l],f=b.range;p=p||b.forceMoveMarkers,a.push(this.getValueInRange(new D.Range(t,r,f.startLineNumber,f.startColumn))),b.text.length>0&&a.push(b.text),t=f.endLineNumber,r=f.endColumn}const c=a.join(""),[d,i,s]=(0,g.countEOL)(c);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:d,firstLineLength:i,lastLineLength:s,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}_doApplyEdits(u){u.sort(A._sortOpsDescending);const p=[];for(let E=0;E<u.length;E++){const n=u[E],o=n.range.startLineNumber,t=n.range.startColumn,r=n.range.endLineNumber,a=n.range.endColumn;if(o===r&&t===a&&n.text.length===0)continue;n.text?(this._pieceTree.delete(n.rangeOffset,n.rangeLength),this._pieceTree.insert(n.rangeOffset,n.text,!0)):this._pieceTree.delete(n.rangeOffset,n.rangeLength);const c=new D.Range(o,t,r,a);p.push({range:c,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return p}findMatchesLineByLine(u,p,E,n){return this._pieceTree.findMatchesLineByLine(u,p,E,n)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(u,p){const E=u.startLineNumber,n=u.startColumn,[o,t,r]=(0,g.countEOL)(p);let a;if(p.length>0){const c=o+1;c===1?a=new D.Range(E,n,E,n+t):a=new D.Range(E,n,E+c-1,r+1)}else a=new D.Range(E,n,E,n);return a}static _getInverseEditRanges(u){const p=[];let E=0,n=0,o=null;for(let t=0,r=u.length;t<r;t++){const a=u[t];let c,d;o?o.range.endLineNumber===a.range.startLineNumber?(c=E,d=n+(a.range.startColumn-o.range.endColumn)):(c=E+(a.range.startLineNumber-o.range.endLineNumber),d=a.range.startColumn):(c=a.range.startLineNumber,d=a.range.startColumn);let i;if(a.text.length>0){const s=a.eolCount+1;s===1?i=new D.Range(c,d,c,d+a.firstLineLength):i=new D.Range(c,d,c+s-1,a.lastLineLength+1)}else i=new D.Range(c,d,c,d);E=i.endLineNumber,n=i.endColumn,p.push(i),o=a}return p}static _sortOpsAscending(u,p){const E=D.Range.compareRangesUsingEnds(u.range,p.range);return E===0?u.sortIndex-p.sortIndex:E}static _sortOpsDescending(u,p){const E=D.Range.compareRangesUsingEnds(u.range,p.range);return E===0?p.sortIndex-u.sortIndex:-E}}e.PieceTreeTextBuffer=A}),define(Pe[144],Te([1,0,12,91,143]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class R{constructor(m,w,A,I,u,p,E,n,o){this._chunks=m,this._bom=w,this._cr=A,this._lf=I,this._crlf=u,this._containsRTL=p,this._containsUnusualLineTerminators=E,this._isBasicASCII=n,this._normalizeEOL=o}_getEOL(m){const w=this._cr+this._lf+this._crlf,A=this._cr+this._crlf;return w===0?m===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create(m){const w=this._getEOL(m),A=this._chunks;if(this._normalizeEOL&&(w===`\r
`&&(this._cr>0||this._lf>0)||w===`
`&&(this._cr>0||this._crlf>0)))for(let u=0,p=A.length;u<p;u++){const E=A[u].buffer.replace(/\r\n|\r|\n/g,w),n=(0,F.createLineStartsFast)(E);A[u]=new F.StringBuffer(E,n)}const I=new D.PieceTreeTextBuffer(A,this._bom,w,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:I,disposable:I}}getFirstLineText(m){return this._chunks[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class T{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(m){if(m.length===0)return;this.chunks.length===0&&S.startsWithUTF8BOM(m)&&(this.BOM=S.UTF8_BOM_CHARACTER,m=m.substr(1));const w=m.charCodeAt(m.length-1);w===13||w>=55296&&w<=56319?(this._acceptChunk1(m.substr(0,m.length-1),!1),this._hasPreviousChar=!0,this._previousChar=w):(this._acceptChunk1(m,!1),this._hasPreviousChar=!1,this._previousChar=w)}_acceptChunk1(m,w){!w&&m.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+m):this._acceptChunk2(m))}_acceptChunk2(m){const w=(0,F.createLineStarts)(this._tmpLineStarts,m);this.chunks.push(new F.StringBuffer(m,w.lineStarts)),this.cr+=w.cr,this.lf+=w.lf,this.crlf+=w.crlf,w.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=S.containsRTL(m)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=S.containsUnusualLineTerminators(m)))}finish(m=!0){return this._finish(),new R(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,m)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const m=this.chunks[this.chunks.length-1];m.buffer+=String.fromCharCode(this._previousChar);const w=(0,F.createLineStartsFast)(m.buffer);m.lineStarts=w,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=T}),define(Pe[96],Te([1,0,24,21]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function R(I){for(let u=0,p=I.length;u<p;u+=4){const E=I[u+0],n=I[u+1],o=I[u+2],t=I[u+3];I[u+0]=t,I[u+1]=o,I[u+2]=n,I[u+3]=E}}function T(I){const u=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.isLittleEndian()||R(u),S.VSBuffer.wrap(u)}function g(I){const u=I.buffer;if(F.isLittleEndian()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function m(I){const u=new Uint32Array(w(I));let p=0;if(u[p++]=I.id,I.type==="full")u[p++]=1,u[p++]=I.data.length,u.set(I.data,p),p+=I.data.length;else{u[p++]=2,u[p++]=I.deltas.length;for(const E of I.deltas)u[p++]=E.start,u[p++]=E.deleteCount,E.data?(u[p++]=E.data.length,u.set(E.data,p),p+=E.data.length):u[p++]=0}return T(u)}e.encodeSemanticTokensDto=m;function w(I){let u=0;if(u+=1+1,I.type==="full")u+=1+I.data.length;else{u+=1,u+=(1+1+1)*I.deltas.length;for(const p of I.deltas)p.data&&(u+=p.data.length)}return u}function A(I){const u=g(I);let p=0;const E=u[p++];if(u[p++]===1){const r=u[p++],a=u.subarray(p,p+r);return p+=r,{id:E,type:"full",data:a}}const o=u[p++],t=[];for(let r=0;r<o;r++){const a=u[p++],c=u[p++],d=u[p++];let i;d>0&&(i=u.subarray(p,p+d),p+=d),t[r]={start:a,deleteCount:c,data:i}}return{id:E,type:"delta",deltas:t}}e.decodeSemanticTokensDto=A}),define(Pe[145],Te([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Te([1,0,18,26,21,129,147,145]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var m;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(J,ve,$e,Ge){this.id=J,this.name=ve,this.defaultValue=$e,this.schema=Ge}applyUpdate(J,ve){return p(J,ve)}compute(J,ve,$e){return $e}}class u{constructor(J,ve){this.newValue=J,this.didChange=ve}}e.ApplyUpdateResult=u;function p(X,J){if(typeof X!="object"||typeof J!="object"||!X||!J)return new u(J,X!==J);if(Array.isArray(X)||Array.isArray(J)){const $e=Array.isArray(X)&&Array.isArray(J)&&S.equals(X,J);return new u(J,!$e)}let ve=!1;for(const $e in J)if(J.hasOwnProperty($e)){const Ge=p(X[$e],J[$e]);Ge.didChange&&(X[$e]=Ge.newValue,ve=!0)}return new u(X,ve)}class E{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,ve){return p(J,ve)}validate(J){return this.defaultValue}}class n{constructor(J,ve,$e,Ge){this.id=J,this.name=ve,this.defaultValue=$e,this.schema=Ge}applyUpdate(J,ve){return p(J,ve)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,ve,$e){return $e}}function o(X,J){return typeof X>"u"?J:X==="false"?!1:!!X}e.boolean=o;class t extends n{constructor(J,ve,$e,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=$e),super(J,ve,$e,Ge)}validate(J){return o(J,this.defaultValue)}}function r(X,J,ve,$e){if(typeof X>"u")return J;let Ge=parseInt(X,10);return isNaN(Ge)?J:(Ge=Math.max(ve,Ge),Ge=Math.min($e,Ge),Ge|0)}e.clampedInt=r;class a extends n{static clampedInt(J,ve,$e,Ge){return r(J,ve,$e,Ge)}constructor(J,ve,$e,Ge,tt,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=$e,nt.minimum=Ge,nt.maximum=tt),super(J,ve,$e,nt),this.minimum=Ge,this.maximum=tt}validate(J){return a.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function c(X,J,ve,$e){if(typeof X>"u")return J;const Ge=d.float(X,J);return d.clamp(Ge,ve,$e)}e.clampedFloat=c;class d extends n{static clamp(J,ve,$e){return J<ve?ve:J>$e?$e:J}static float(J,ve){if(typeof J=="number")return J;if(typeof J>"u")return ve;const $e=parseFloat(J);return isNaN($e)?ve:$e}constructor(J,ve,$e,Ge,tt){typeof tt<"u"&&(tt.type="number",tt.default=$e),super(J,ve,$e,tt),this.validationFn=Ge}validate(J){return this.validationFn(d.float(J,this.defaultValue))}}class i extends n{static string(J,ve){return typeof J!="string"?ve:J}constructor(J,ve,$e,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=$e),super(J,ve,$e,Ge)}validate(J){return i.string(J,this.defaultValue)}}function s(X,J,ve,$e){return typeof X!="string"?J:$e&&X in $e?$e[X]:ve.indexOf(X)===-1?J:X}e.stringSet=s;class l extends n{constructor(J,ve,$e,Ge,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Ge,tt.default=$e),super(J,ve,$e,tt),this._allowedValues=Ge}validate(J){return s(J,this.defaultValue,this._allowedValues)}}class h extends I{constructor(J,ve,$e,Ge,tt,nt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=tt,Ne.default=Ge),super(J,ve,$e,Ne),this._allowedValues=tt,this._convert=nt}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function b(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,ve,$e){return $e===0?J.accessibilitySupport:$e}}class C extends I{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:g.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{insertSpace:o(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var O;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(O||(e.TextEditorCursorBlinkingStyle=O={}));function v(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var _;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(_||(e.TextEditorCursorStyle=_={}));function y(X){switch(X){case _.Line:return"line";case _.Block:return"block";case _.Underline:return"underline";case _.LineThin:return"line-thin";case _.BlockOutline:return"block-outline";case _.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function M(X){switch(X){case"line":return _.Line;case"block":return _.Block;case"underline":return _.Underline;case"line-thin":return _.LineThin;case"block-outline":return _.BlockOutline;case"underline-thin":return _.UnderlineThin}}class V extends E{constructor(){super(140)}compute(J,ve,$e){const Ge=["monaco-editor"];return ve.get(39)&&Ge.push(ve.get(39)),J.extraEditorClassName&&Ge.push(J.extraEditorClassName),ve.get(73)==="default"?Ge.push("mouse-default"):ve.get(73)==="copy"&&Ge.push("mouse-copy"),ve.get(110)&&Ge.push("showUnused"),ve.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class $ extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(J,ve,$e){return $e&&J.emptySelectionClipboard}}class L extends I{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:g.localize(16,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:g.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{cursorMoveOnType:o(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":s(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":s(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ve.loop,this.defaultValue.loop)}}}class U extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?U.OFF:J==="true"?U.ON:J:J?U.ON:U.OFF}}e.EditorFontLigatures=U;class k extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",k.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?k.OFF:J==="true"?k.TRANSLATE:J:J?k.TRANSLATE:k.OFF}compute(J,ve,$e){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=k;class P extends E{constructor(){super(50)}compute(J,ve,$e){return J.fontInfo}}class Q extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(J){const ve=d.float(J,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ve,6,100)}compute(J,ve,$e){return J.fontInfo.fontSize}}class ae extends I{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ae.MINIMUM_VALUE,maximum:ae.MAXIMUM_VALUE,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ae.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(a.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,ae.MINIMUM_VALUE,ae.MAXIMUM_VALUE))}}class me extends I{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:$e,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:$e,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:$e,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:$e,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:$e,description:g.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{multiple:s(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??s(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??s(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??s(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??s(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??s(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ee extends I{constructor(){const J={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:J.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:J.above,description:g.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),delay:a.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:o(ve.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(ve.above,this.defaultValue.above)}}}var Ce;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ce||(e.RenderMinimap=Ce={}));class he extends E{constructor(){super(143)}compute(J,ve,$e){return he.computeLayout(ve,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const ve=J.height/J.lineHeight,$e=Math.floor(J.paddingTop/J.lineHeight);let Ge=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(Ge=Math.max(Ge,ve-1));const tt=($e+J.viewLineCount+Ge)/(J.pixelRatio*J.height),nt=Math.floor(J.viewLineCount/tt);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:$e,extraLinesBeyondLastLine:Ge,desiredRatio:tt,minimapLineCount:nt}}static _computeMinimapLayout(J,ve){const $e=J.outerWidth,Ge=J.outerHeight,tt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const nt=ve.stableMinimapLayoutInput,Ne=nt&&J.outerHeight===nt.outerHeight&&J.lineHeight===nt.lineHeight&&J.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&J.pixelRatio===nt.pixelRatio&&J.scrollBeyondLastLine===nt.scrollBeyondLastLine&&J.paddingTop===nt.paddingTop&&J.paddingBottom===nt.paddingBottom&&J.minimap.enabled===nt.minimap.enabled&&J.minimap.side===nt.minimap.side&&J.minimap.size===nt.minimap.size&&J.minimap.showSlider===nt.minimap.showSlider&&J.minimap.renderCharacters===nt.minimap.renderCharacters&&J.minimap.maxColumn===nt.minimap.maxColumn&&J.minimap.scale===nt.minimap.scale&&J.verticalScrollbarWidth===nt.verticalScrollbarWidth&&J.isViewportWrapping===nt.isViewportWrapping,Dt=J.lineHeight,Lt=J.typicalHalfwidthCharacterWidth,Vt=J.scrollBeyondLastLine,Bt=J.minimap.renderCharacters;let wt=tt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Wt=J.minimap.maxColumn,Ot=J.minimap.size,Gt=J.minimap.side,Mt=J.verticalScrollbarWidth,kt=J.viewLineCount,Ye=J.remainingWidth,qt=J.isViewportWrapping,jt=Bt?2:3;let lt=Math.floor(tt*Ge);const gt=lt/tt;let xt=!1,$t=!1,St=jt*wt,dt=wt/tt,Pt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Rt,extraLinesBeyondLastLine:Se,desiredRatio:Oe,minimapLineCount:fe}=he.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Vt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:Ge,lineHeight:Dt,pixelRatio:tt});if(kt/fe>1)xt=!0,$t=!0,wt=1,St=1,dt=wt/tt;else{let Ae=!1,Be=wt+1;if(Ot==="fit"){const Xe=Math.ceil((Rt+kt+Se)*St);qt&&Ne&&Ye<=ve.stableFitRemainingWidth?(Ae=!0,Be=ve.stableFitMaxMinimapScale):Ae=Xe>lt}if(Ot==="fill"||Ae){xt=!0;const Xe=wt;St=Math.min(Dt*tt,Math.max(1,Math.floor(1/Oe))),qt&&Ne&&Ye<=ve.stableFitRemainingWidth&&(Be=ve.stableFitMaxMinimapScale),wt=Math.min(Be,Math.max(1,Math.floor(St/jt))),wt>Xe&&(Pt=Math.min(2,wt/Xe)),dt=wt/tt/Pt,lt=Math.ceil(Math.max(ft,Rt+kt+Se)*St),qt?(ve.stableMinimapLayoutInput=J,ve.stableFitRemainingWidth=Ye,ve.stableFitMaxMinimapScale=wt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Yt=Math.floor(Wt*dt),yt=Math.min(Yt,Math.max(0,Math.floor((Ye-Mt-2)*dt/(Lt+dt)))+e.MINIMAP_GUTTER_WIDTH);let We=Math.floor(tt*yt);const At=We/tt;We=Math.floor(We*Pt);const zt=Bt?1:2,Kt=Gt==="left"?0:$e-yt-Mt;return{renderMinimap:zt,minimapLeft:Kt,minimapWidth:yt,minimapHeightIsEditorHeight:xt,minimapIsSampling:$t,minimapScale:wt,minimapLineHeight:St,minimapCanvasInnerWidth:We,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:At,minimapCanvasOuterHeight:gt}}static computeLayout(J,ve){const $e=ve.outerWidth|0,Ge=ve.outerHeight|0,tt=ve.lineHeight|0,nt=ve.lineNumbersDigitCount|0,Ne=ve.typicalHalfwidthCharacterWidth,Dt=ve.maxDigitWidth,Lt=ve.pixelRatio,Vt=ve.viewLineCount,Bt=J.get(135),wt=Bt==="inherit"?J.get(134):Bt,Wt=wt==="inherit"?J.get(130):wt,Ot=J.get(133),Gt=ve.isDominatedByLongLines,Mt=J.get(57),kt=J.get(67).renderType!==0,Ye=J.get(68),qt=J.get(104),jt=J.get(83),lt=J.get(72),gt=J.get(102),xt=gt.verticalScrollbarSize,$t=gt.verticalHasArrows,St=gt.arrowSize,dt=gt.horizontalScrollbarSize,Pt=J.get(43),Yt=J.get(109)!=="never";let yt=J.get(65);Pt&&Yt&&(yt+=16);let We=0;if(kt){const Ze=Math.max(nt,Ye);We=Math.round(Ze*Dt)}let At=0;Mt&&(At=tt*ve.glyphMarginDecorationLaneCount);let zt=0,Kt=zt+At,ft=Kt+We,Rt=ft+yt;const Se=$e-At-We-yt;let Oe=!1,fe=!1,j=-1;wt==="inherit"&&Gt?(Oe=!0,fe=!0):Wt==="on"||Wt==="bounded"?fe=!0:Wt==="wordWrapColumn"&&(j=Ot);const Ae=he._computeMinimapLayout({outerWidth:$e,outerHeight:Ge,lineHeight:tt,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Lt,scrollBeyondLastLine:qt,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:lt,verticalScrollbarWidth:xt,viewLineCount:Vt,remainingWidth:Se,isViewportWrapping:fe},ve.memory||new A);Ae.renderMinimap!==0&&Ae.minimapLeft===0&&(zt+=Ae.minimapWidth,Kt+=Ae.minimapWidth,ft+=Ae.minimapWidth,Rt+=Ae.minimapWidth);const Be=Se-Ae.minimapWidth,Xe=Math.max(1,Math.floor((Be-xt-2)/Ne)),He=$t?St:0;return fe&&(j=Math.max(1,Xe),Wt==="bounded"&&(j=Math.min(j,Ot))),{width:$e,height:Ge,glyphMarginLeft:zt,glyphMarginWidth:At,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:Kt,lineNumbersWidth:We,decorationsLeft:ft,decorationsWidth:yt,contentLeft:Rt,contentWidth:Be,minimap:Ae,viewportColumn:Xe,isWordWrapMinified:Oe,isViewportWrapping:fe,wrappingColumn:j,verticalScrollbarWidth:xt,horizontalScrollbarHeight:dt,overviewRuler:{top:He,width:xt,height:Ge-2*He,right:0}}}}e.EditorLayoutInfoComputer=he;class de extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(J){return s(J,"simple",["simple","advanced"])}compute(J,ve,$e){return ve.get(2)===2?"advanced":$e}}var te;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(te||(e.ShowAiIconMode=te={}));class Ie extends I{constructor(){const J={enabled:!0,experimental:{showAiIcon:te.Off}};super(64,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:g.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[te.Off,te.OnCode,te.On],default:J.experimental.showAiIcon,enumDescriptions:[g.localize(51,null),g.localize(52,null),g.localize(53,null)],description:g.localize(54,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),experimental:{showAiIcon:s(ve.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[te.Off,te.OnCode,te.On])}}}}class oe extends I{constructor(){const J={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:g.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:10,description:g.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:g.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:J.scrollWithEditor,description:g.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends I{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:g.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(60,null),g.localize(61,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),g.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:g.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:g.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:g.localize(66,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:s(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),padding:o(ve.padding,this.defaultValue.padding)}}}class H extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):a.clampedInt(J,this.defaultValue,0,1e3)}compute(J,ve,$e){return $e<0?a.clampedInt(-$e*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):$e}}class ne extends d{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>d.clamp(J,0,150),{markdownDescription:g.localize(67,null)})}compute(J,ve,$e){return J.fontInfo.lineHeight}}class De extends I{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:g.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:g.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(70,null),g.localize(71,null),g.localize(72,null)],default:J.size,description:g.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:g.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:g.localize(75,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:g.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:g.localize(78,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),autohide:o(ve.autohide,this.defaultValue.autohide),size:s(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ve.side,this.defaultValue.side,["right","left"]),showSlider:s(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ve.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(ve.scale,1,1,3),maxColumn:a.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Re(X){return X==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(80,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{top:a.clampedInt(ve.top,0,0,1e3),bottom:a.clampedInt(ve.bottom,0,0,1e3)}}}class ce extends I{constructor(){const J={enabled:!0,cycle:!0};super(85,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:g.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:g.localize(82,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),cycle:o(ve.cycle,this.defaultValue.cycle)}}}class ie extends E{constructor(){super(141)}compute(J,ve,$e){return J.pixelRatio}}class G extends I{constructor(){const J={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(83,null),g.localize(84,null),g.localize(85,null)]}];super(88,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:J.strings,description:g.localize(86,null)},comments:{anyOf:ve,default:J.comments,description:g.localize(87,null)},other:{anyOf:ve,default:J.other,description:g.localize(88,null)}},default:J,markdownDescription:g.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const Lt=J?"on":"off";return{comments:Lt,strings:Lt,other:Lt}}if(!J||typeof J!="object")return this.defaultValue;const{other:ve,comments:$e,strings:Ge}=J,tt=["on","inline","off"];let nt,Ne,Dt;return typeof ve=="boolean"?nt=ve?"on":"off":nt=s(ve,this.defaultValue.other,tt),typeof $e=="boolean"?Ne=$e?"on":"off":Ne=s($e,this.defaultValue.comments,tt),typeof Ge=="boolean"?Dt=Ge?"on":"off":Dt=s(Ge,this.defaultValue.strings,tt),{other:nt,comments:Ne,strings:Dt}}}var ee;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class pe extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(90,null),g.localize(91,null),g.localize(92,null),g.localize(93,null)],default:"on",description:g.localize(94,null)})}validate(J){let ve=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(ve=4,$e=J):J==="interval"?ve=3:J==="relative"?ve=2:J==="on"?ve=1:ve=0),{renderType:ve,renderFn:$e}}}function be(X){const J=X.get(97);return J==="editable"?X.get(90):J!=="on"}e.filterValidationDecorations=be;class Le extends I{constructor(){const J=[],ve={type:"number",description:g.localize(95,null)};super(101,"rulers",J,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:g.localize(96,null),format:"color-hex"}}}]},default:J,description:g.localize(97,null)})}validate(J){if(Array.isArray(J)){const ve=[];for(const $e of J)if(typeof $e=="number")ve.push({column:a.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const Ge=$e;ve.push({column:a.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return ve.sort(($e,Ge)=>$e.column-Ge.column),ve}return this.defaultValue}}class ue extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(J){return!J||typeof J!="object"?this.defaultValue:J}}function we(X,J){if(typeof X!="string")return J;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class N extends I{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(98,null),g.localize(99,null),g.localize(100,null)],default:"auto",description:g.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(102,null),g.localize(103,null),g.localize(104,null)],default:"auto",description:g.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:g.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:g.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:J.ignoreHorizontalScrollbarInContentHeight,description:g.localize(109,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J,$e=a.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=a.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we(ve.vertical,this.defaultValue.vertical),horizontal:we(ve.horizontal,this.defaultValue.horizontal),useShadows:o(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:a.clampedInt(ve.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:a.clampedInt(ve.verticalSliderSize,Ge,0,1e3),scrollByPage:o(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends I{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:g.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:g.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:g.localize(116,null)}})}applyUpdate(J,ve){let $e=!1;ve.allowedCharacters&&J&&(F.equals(J.allowedCharacters,ve.allowedCharacters)||(J={...J,allowedCharacters:ve.allowedCharacters},$e=!0)),ve.allowedLocales&&J&&(F.equals(J.allowedLocales,ve.allowedLocales)||(J={...J,allowedLocales:ve.allowedLocales},$e=!0));const Ge=super.applyUpdate(J,ve);return $e?new u(Ge.newValue,!0):Ge}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{nonBasicASCII:Z(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(J.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(J,ve){if(typeof J!="object"||!J)return ve;const $e={};for(const[Ge,tt]of Object.entries(J))tt===!0&&($e[Ge]=!0);return $e}}class q extends I{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:g.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(118,null),g.localize(119,null),g.localize(120,null)],description:g.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:g.localize(122,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),mode:s(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class B extends I{constructor(){const J={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:g.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:g.localize(124,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends I{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(125,null),g.localize(126,null),g.localize(127,null)],default:J.bracketPairs,description:g.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(129,null),g.localize(130,null),g.localize(131,null)],default:J.bracketPairsHorizontal,description:g.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:g.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:g.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null)],default:J.highlightActiveIndentation,description:g.localize(138,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{bracketPairs:Z(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(X,J,ve){const $e=ve.indexOf(X);return $e===-1?J:ve[$e]}class _e extends I{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(139,null),g.localize(140,null)],default:J.insertMode,description:g.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:g.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:g.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:g.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(145,null),g.localize(146,null),g.localize(147,null),g.localize(148,null)],default:J.selectionMode,markdownDescription:g.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:g.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:g.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:g.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:g.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:g.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{insertMode:s(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ve.showIcons,this.defaultValue.showIcons),showStatusBar:o(ve.showStatusBar,this.defaultValue.showStatusBar),preview:o(ve.preview,this.defaultValue.preview),previewMode:s(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ve.showMethods,this.defaultValue.showMethods),showFunctions:o(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ve.showFields,this.defaultValue.showFields),showVariables:o(ve.showVariables,this.defaultValue.showVariables),showClasses:o(ve.showClasses,this.defaultValue.showClasses),showStructs:o(ve.showStructs,this.defaultValue.showStructs),showInterfaces:o(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ve.showModules,this.defaultValue.showModules),showProperties:o(ve.showProperties,this.defaultValue.showProperties),showEvents:o(ve.showEvents,this.defaultValue.showEvents),showOperators:o(ve.showOperators,this.defaultValue.showOperators),showUnits:o(ve.showUnits,this.defaultValue.showUnits),showValues:o(ve.showValues,this.defaultValue.showValues),showConstants:o(ve.showConstants,this.defaultValue.showConstants),showEnums:o(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ve.showKeywords,this.defaultValue.showKeywords),showWords:o(ve.showWords,this.defaultValue.showWords),showColors:o(ve.showColors,this.defaultValue.showColors),showFiles:o(ve.showFiles,this.defaultValue.showFiles),showReferences:o(ve.showReferences,this.defaultValue.showReferences),showFolders:o(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ve.showSnippets,this.defaultValue.showSnippets),showUsers:o(ve.showUsers,this.defaultValue.showUsers),showIssues:o(ve.showIssues,this.defaultValue.showIssues)}}}class Fe extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(188,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(J.selectSubwords,this.defaultValue.selectSubwords)}}}var ze;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(ze||(e.WrappingIndent=ze={}));class qe extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(189,null),g.localize(190,null),g.localize(191,null),g.localize(192,null)],description:g.localize(193,null),default:"same"}})}validate(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(J,ve,$e){return ve.get(2)===2?0:$e}}class Qe extends E{constructor(){super(144)}compute(J,ve,$e){const Ge=ve.get(143);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class rt extends I{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:g.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(196,null),g.localize(197,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),showDropSelector:s(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends I{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:g.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(200,null),g.localize(201,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ve=J;return{enabled:o(ve.enabled,this.defaultValue.enabled),showPasteSelector:s(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",at="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?ot:D.isLinux?at:et,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(X){return e.editorOptionsRegistry[X.id]=X,X}var vt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(202,null)})),acceptSuggestionOnEnter:Ue(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(203,null),""],markdownDescription:g.localize(204,null)})),accessibilitySupport:Ue(new f),accessibilityPageSize:Ue(new a(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(205,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",g.localize(206,null))),ariaRequired:Ue(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new l(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(208,null),g.localize(209,null),""],description:g.localize(210,null)})),autoClosingComments:Ue(new l(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(211,null),g.localize(212,null),""],description:g.localize(213,null)})),autoClosingDelete:Ue(new l(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(214,null),""],description:g.localize(215,null)})),autoClosingOvertype:Ue(new l(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(216,null),""],description:g.localize(217,null)})),autoClosingQuotes:Ue(new l(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoIndent:Ue(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[g.localize(221,null),g.localize(222,null),g.localize(223,null),g.localize(224,null),g.localize(225,null)],description:g.localize(226,null)})),automaticLayout:Ue(new t(13,"automaticLayout",!1)),autoSurround:Ue(new l(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(227,null),g.localize(228,null),g.localize(229,null),""],description:g.localize(230,null)})),bracketPairColorization:Ue(new B),bracketPairGuides:Ue(new K),stickyTabStops:Ue(new t(115,"stickyTabStops",!1,{description:g.localize(231,null)})),codeLens:Ue(new t(17,"codeLens",!0,{description:g.localize(232,null)})),codeLensFontFamily:Ue(new i(18,"codeLensFontFamily","",{description:g.localize(233,null)})),codeLensFontSize:Ue(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(234,null)})),colorDecorators:Ue(new t(20,"colorDecorators",!0,{description:g.localize(235,null)})),colorDecoratorActivatedOn:Ue(new l(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),colorDecoratorsLimit:Ue(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(240,null)})),columnSelection:Ue(new t(22,"columnSelection",!1,{description:g.localize(241,null)})),comments:Ue(new C),contextmenu:Ue(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new t(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(242,null)})),cursorBlinking:Ue(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:g.localize(243,null)})),cursorSmoothCaretAnimation:Ue(new l(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),cursorStyle:Ue(new h(28,"cursorStyle",_.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:g.localize(248,null)})),cursorSurroundingLines:Ue(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(249,null)})),cursorSurroundingLinesStyle:Ue(new l(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(250,null),g.localize(251,null)],markdownDescription:g.localize(252,null)})),cursorWidth:Ue(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(253,null)})),disableLayerHinting:Ue(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new t(34,"domReadOnly",!1)),dragAndDrop:Ue(new t(35,"dragAndDrop",!0,{description:g.localize(254,null)})),emptySelectionClipboard:Ue(new $),dropIntoEditor:Ue(new rt),stickyScroll:Ue(new oe),experimentalWhitespaceRendering:Ue(new l(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),extraEditorClassName:Ue(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new d(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(259,null)})),find:Ue(new L),fixedOverflowWidgets:Ue(new t(42,"fixedOverflowWidgets",!1)),folding:Ue(new t(43,"folding",!0,{description:g.localize(260,null)})),foldingStrategy:Ue(new l(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),foldingHighlight:Ue(new t(45,"foldingHighlight",!0,{description:g.localize(264,null)})),foldingImportsByDefault:Ue(new t(46,"foldingImportsByDefault",!1,{description:g.localize(265,null)})),foldingMaximumRegions:Ue(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ue(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(267,null)})),fontFamily:Ue(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(268,null)})),fontInfo:Ue(new P),fontLigatures2:Ue(new U),fontSize:Ue(new Q),fontWeight:Ue(new ae),fontVariations:Ue(new k),formatOnPaste:Ue(new t(55,"formatOnPaste",!1,{description:g.localize(269,null)})),formatOnType:Ue(new t(56,"formatOnType",!1,{description:g.localize(270,null)})),glyphMargin:Ue(new t(57,"glyphMargin",!0,{description:g.localize(271,null)})),gotoLocation:Ue(new me),hideCursorInOverviewRuler:Ue(new t(59,"hideCursorInOverviewRuler",!1,{description:g.localize(272,null)})),hover:Ue(new Ee),inDiffEditor:Ue(new t(61,"inDiffEditor",!1)),letterSpacing:Ue(new d(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:g.localize(273,null)})),lightbulb:Ue(new Ie),lineDecorationsWidth:Ue(new H),lineHeight:Ue(new ne),lineNumbers:Ue(new pe),lineNumbersMinChars:Ue(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new t(69,"linkedEditing",!1,{description:g.localize(274,null)})),links:Ue(new t(70,"links",!0,{description:g.localize(275,null)})),matchBrackets:Ue(new l(71,"matchBrackets","always",["always","near","never"],{description:g.localize(276,null)})),minimap:Ue(new De),mouseStyle:Ue(new l(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new d(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(277,null)})),mouseWheelZoom:Ue(new t(75,"mouseWheelZoom",!1,{markdownDescription:g.localize(278,null)})),multiCursorMergeOverlapping:Ue(new t(76,"multiCursorMergeOverlapping",!0,{description:g.localize(279,null)})),multiCursorModifier:Ue(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Re,{markdownEnumDescriptions:[g.localize(280,null),g.localize(281,null)],markdownDescription:g.localize(282,null)})),multiCursorPaste:Ue(new l(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(283,null),g.localize(284,null)],markdownDescription:g.localize(285,null)})),multiCursorLimit:Ue(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(286,null)})),occurrencesHighlight:Ue(new l(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(287,null),g.localize(288,null),g.localize(289,null)],markdownDescription:g.localize(290,null)})),overviewRulerBorder:Ue(new t(81,"overviewRulerBorder",!0,{description:g.localize(291,null)})),overviewRulerLanes:Ue(new a(82,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),pasteAs:Ue(new it),parameterHints:Ue(new ce),peekWidgetDefaultFocus:Ue(new l(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(292,null),g.localize(293,null)],description:g.localize(294,null)})),definitionLinkOpensInPeek:Ue(new t(87,"definitionLinkOpensInPeek",!1,{description:g.localize(295,null)})),quickSuggestions:Ue(new G),quickSuggestionsDelay:Ue(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(296,null)})),readOnly:Ue(new t(90,"readOnly",!1)),readOnlyMessage:Ue(new ue),renameOnType:Ue(new t(92,"renameOnType",!1,{description:g.localize(297,null),markdownDeprecationMessage:g.localize(298,null)})),renderControlCharacters:Ue(new t(93,"renderControlCharacters",!0,{description:g.localize(299,null),restricted:!0})),renderFinalNewline:Ue(new l(94,"renderFinalNewline",D.isLinux?"dimmed":"on",["off","on","dimmed"],{description:g.localize(300,null)})),renderLineHighlight:Ue(new l(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(301,null)],description:g.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Ue(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(303,null)})),renderValidationDecorations:Ue(new l(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new l(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(304,null),g.localize(305,null),g.localize(306,null),""],description:g.localize(307,null)})),revealHorizontalRightPadding:Ue(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new t(100,"roundedSelection",!0,{description:g.localize(308,null)})),rulers:Ue(new Le),scrollbar:Ue(new N),scrollBeyondLastColumn:Ue(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(309,null)})),scrollBeyondLastLine:Ue(new t(104,"scrollBeyondLastLine",!0,{description:g.localize(310,null)})),scrollPredominantAxis:Ue(new t(105,"scrollPredominantAxis",!0,{description:g.localize(311,null)})),selectionClipboard:Ue(new t(106,"selectionClipboard",!0,{description:g.localize(312,null),included:D.isLinux})),selectionHighlight:Ue(new t(107,"selectionHighlight",!0,{description:g.localize(313,null)})),selectOnLineNumbers:Ue(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new l(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(314,null),g.localize(315,null),g.localize(316,null)],description:g.localize(317,null)})),showUnused:Ue(new t(110,"showUnused",!0,{description:g.localize(318,null)})),showDeprecated:Ue(new t(138,"showDeprecated",!0,{description:g.localize(319,null)})),inlayHints:Ue(new Y),snippetSuggestions:Ue(new l(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(320,null),g.localize(321,null),g.localize(322,null),g.localize(323,null)],description:g.localize(324,null)})),smartSelect:Ue(new Fe),smoothScrolling:Ue(new t(113,"smoothScrolling",!1,{description:g.localize(325,null)})),stopRenderingLineAfter:Ue(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new _e),inlineSuggest:Ue(new q),inlineCompletionsAccessibilityVerbose:Ue(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(326,null)})),suggestFontSize:Ue(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new t(120,"suggestOnTriggerCharacters",!0,{description:g.localize(329,null)})),suggestSelection:Ue(new l(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(330,null),g.localize(331,null),g.localize(332,null)],description:g.localize(333,null)})),tabCompletion:Ue(new l(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(334,null),g.localize(335,null),g.localize(336,null)],description:g.localize(337,null)})),tabIndex:Ue(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new W),unusualLineTerminators:Ue(new l(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(338,null),g.localize(339,null),g.localize(340,null)],description:g.localize(341,null)})),useShadowDOM:Ue(new t(126,"useShadowDOM",!0)),useTabStops:Ue(new t(127,"useTabStops",!0,{description:g.localize(342,null)})),wordBreak:Ue(new l(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(343,null),g.localize(344,null)],description:g.localize(345,null)})),wordSeparators:Ue(new i(129,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:g.localize(346,null)})),wordWrap:Ue(new l(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(347,null),g.localize(348,null),g.localize(349,null),g.localize(350,null)],description:g.localize(351,null)})),wordWrapBreakAfterCharacters:Ue(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(352,null)})),wordWrapOverride1:Ue(new l(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new l(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new V),defaultColorDecorators:Ue(new t(145,"defaultColorDecorators",!1,{markdownDescription:g.localize(353,null)})),pixelRatio:Ue(new ie),tabFocusMode:Ue(new t(142,"tabFocusMode",!1,{markdownDescription:g.localize(354,null)})),layoutInfo:Ue(new he),wrappingInfo:Ue(new Qe),wrappingIndent:Ue(new qe),wrappingStrategy:Ue(new de)}}),define(Pe[148],Te([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Te([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Te([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Te([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Te([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Te([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Pe[154],Te([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Te([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Te([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[164],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[165],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[166],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[167],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[168],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[169],Te([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[170],Te([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Pe[171],Te([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Pe[172],Te([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Pe[173],Te([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[174],Te([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[175],Te([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[176],Te([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[177],Te([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[178],Te([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[179],Te([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[180],Te([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[181],Te([1,0,11,150]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var D;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(D||(e.TokenType=D={}));function R(...w){switch(w.length){case 1:return(0,F.localize)(0,null,w[0]);case 2:return(0,F.localize)(1,null,w[0],w[1]);case 3:return(0,F.localize)(2,null,w[0],w[1],w[2]);default:return}}const T=(0,F.localize)(3,null),g=(0,F.localize)(4,null);class m{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,S.illegalState)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(A){return this._input=A,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(R("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(R("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(A){return this._isAtEnd()||this._input.charCodeAt(this._current)!==A?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(A){this._tokens.push({type:A,offset:this._start})}_error(A){const I=this._start,u=this._input.substring(this._start,this._current),p={type:19,offset:this._start,lexeme:u};this._errors.push({offset:I,lexeme:u,additionalInfo:A}),this._tokens.push(p)}_string(){this.stringRe.lastIndex=this._start;const A=this.stringRe.exec(this._input);if(A){this._current=this._start+A[0].length;const I=this._input.substring(this._start,this._current),u=m._keywords.get(I);u?this._addToken(u):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let A=this._current,I=!1,u=!1;for(;;){if(A>=this._input.length){this._current=A,this._error(g);return}const E=this._input.charCodeAt(A);if(I)I=!1;else if(E===47&&!u){A++;break}else E===91?u=!0:E===92?I=!0:E===93&&(u=!1);A++}for(;A<this._input.length&&m._regexFlags.has(this._input.charCodeAt(A));)A++;this._current=A;const p=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:p,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=m}),define(Pe[182],Te([1,0,25,31,152,294]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function m(t){return t=t.trim(),t==="*"||T.test(t)}e.isValidVersionStr=m;function w(t){if(!m(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=t.match(T);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.parseVersion=w;function A(t){if(!t)return null;const r=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let d=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(r===0||(d=!1),s=!1);let l=0;if(t.preRelease){const h=g.exec(t.preRelease);if(h){const[,b,f,C]=h;l=Date.UTC(Number(b),Number(f)-1,Number(C))}}return{majorBase:r,majorMustEqual:a,minorBase:c,minorMustEqual:d,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:l}}e.normalizeVersion=A;function I(t,r,a){let c;typeof t=="string"?c=A(w(t)):c=t;let d;r instanceof Date?d=r.getTime():typeof r=="string"&&(d=new Date(r).getTime());let i;if(typeof a=="string"?i=A(w(a)):i=a,!c||!i)return!1;const s=c.majorBase,l=c.minorBase,h=c.patchBase;let b=i.majorBase,f=i.minorBase,C=i.patchBase;const O=i.notBefore;let v=i.majorMustEqual,_=i.minorMustEqual,y=i.patchMustEqual;return i.isMinimum?s>b?!0:s<b?!1:l>f?!0:l<f||d&&d<O?!1:h>=C:(s===1&&b===0&&(!v||!_||!y)&&(b=1,f=0,C=0,v=!0,_=!1,y=!1),s<b?!1:s>b?!v:l<f?!1:l>f?!_:h<C?!1:h>C?!y:!(d&&d<O))}e.isValidVersion=I;function u(t,r,a,c,d){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([F.default.Error,D.localize(0,null)]),i;if(typeof c.name!="string")return i.push([F.default.Error,D.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([F.default.Error,D.localize(2,null,"version")]),i;if(!c.engines)return i.push([F.default.Error,D.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([F.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([F.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([F.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([F.default.Error,D.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([F.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([F.default.Error,D.localize(9,null,"main")]),i;{const h=(0,S.joinPath)(a,c.main);(0,S.isEqualOrParent)(h,a)||i.push([F.default.Warning,D.localize(10,null,h.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([F.default.Error,D.localize(11,null,"browser")]),i;{const h=(0,S.joinPath)(a,c.browser);(0,S.isEqualOrParent)(h,a)||i.push([F.default.Warning,D.localize(12,null,h.path,a.path)])}}if(!R.valid(c.version))return i.push([F.default.Error,D.localize(13,null)]),i;const s=[];if(!p(t,r,c,d,s))for(const h of s)i.push([F.default.Error,h]);return i}e.validateExtensionManifest=u;function p(t,r,a,c,d){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:n(t,r,a.engines.vscode,d)}e.isValidExtensionVersion=p;function E(t,r,a){return t==="*"||n(r,a,t)}e.isEngineValid=E;function n(t,r,a,c=[]){const d=A(w(a));if(!d)return c.push(D.localize(14,null,a)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return c.push(D.localize(15,null,a)),!1}else if(!d.majorMustEqual)return c.push(D.localize(16,null,a)),!1;return I(t,r,d)?!0:(c.push(D.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let r=0,a=t.length;r<a;r++)if(typeof t[r]!="string")return!1;return!0}}),define(Pe[69],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(D,R=[],T=!1){this.ctor=D,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=S}),define(Pe[70],Te([1,0,69]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const F=[];var D;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function R(g,m,w){m instanceof S.SyncDescriptor||(m=new S.SyncDescriptor(m,[],!!w)),F.push([g,m])}e.registerSingleton=R;function T(){return F}e.getSingletonServiceDescriptors=T}),define(Pe[183],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class F{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const g=this.lookupOrInsertNode(R),m=this.lookupOrInsertNode(T);g.outgoing.set(m.key,m),m.incoming.set(g.key,g)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(const g of this._nodes.values())g.outgoing.delete(T),g.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let g=this._nodes.get(T);return g||(g=new S(T,R),this._nodes.set(T,g)),g}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[T,g]of this._nodes)R.push(`${T}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this._nodes){const g=new Set([R]),m=this._findCycle(T,g);if(m)return m}}_findCycle(R,T){for(const[g,m]of R.outgoing){if(T.has(g))return[...T,g].join(" -> ");T.add(g);const w=this._findCycle(m,T);if(w)return w;T.delete(g)}}}e.Graph=F}),define(Pe[4],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function g(m){return m[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=g})(S||(e._util=S={})),e.IInstantiationService=D("instantiationService");function F(T,g,m){g[S.DI_TARGET]===g?g[S.DI_DEPENDENCIES].push({id:T,index:m}):(g[S.DI_DEPENDENCIES]=[{id:T,index:m}],g[S.DI_TARGET]=g)}function D(T){if(S.serviceIds.has(T))return S.serviceIds.get(T);const g=function(m,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(g,m,A)};return g.toString=()=>T,S.serviceIds.set(T,g),g}e.createDecorator=D;function R(T){return T}e.refineServiceDecorator=R}),define(Pe[41],Te([1,0,16,2,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.isConfigured=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof F.URI)}e.isConfigurationOverrides=R;function T(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=T;var g;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function m(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=m;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.isConfigured=w;function A(t,r){const a=Object.create(null);for(const c in t)I(a,c,t[c],r);return a}e.toValuesTree=A;function I(t,r,a,c){const d=r.split("."),i=d.pop();let s=t;for(let l=0;l<d.length;l++){const h=d[l];let b=s[h];switch(typeof b){case"undefined":b=s[h]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${d.slice(0,l+1).join(".")} is ${JSON.stringify(b)}`);return}s=b}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{c(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${r} as ${d.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=I;function u(t,r){const a=r.split(".");p(t,a)}e.removeFromValueTree=u;function p(t,r){const a=r.shift();if(r.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&(p(c,r),Object.keys(c).length===0&&delete t[a])}}function E(t,r,a){function c(s,l){let h=s;for(const b of l){if(typeof h!="object"||h===null)return;h=h[b]}return h}const d=r.split("."),i=c(t,d);return typeof i>"u"?a:i}e.getConfigurationValue=E;function n(t,r,a){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in t?S.isObject(t[c])&&S.isObject(r[c])?n(t[c],r[c],a):a&&(t[c]=r[c]):t[c]=r[c])})}e.merge=n;function o(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Pe[35],Te([1,0,21,12,181,4,149,11]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",S.isMacintosh),m.set("isLinux",S.isLinux),m.set("isWindows",S.isWindows),m.set("isWeb",S.isWeb),m.set("isMacNative",S.isMacintosh&&!S.isWeb),m.set("isEdge",S.isEdge),m.set("isFirefox",S.isFirefox),m.set("isChrome",S.isChrome),m.set("isSafari",S.isSafari);function w(Y,H){if(m.get(Y)!==void 0)throw(0,g.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(Y,H)}e.setConstant=w;const A=Object.prototype.hasOwnProperty;var I;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const u={regexParsingWithErrorRecovery:!0},p=(0,T.localize)(0,null),E=(0,T.localize)(1,null),n=(0,T.localize)(2,null),o=(0,T.localize)(3,null),t=(0,T.localize)(4,null),r=(0,T.localize)(5,null),a=(0,T.localize)(6,null),c=(0,T.localize)(7,null);class d{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(H=u){this._config=H,this._scanner=new D.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(H){if(H===""){this._parsingErrors.push({message:p,offset:0,lexeme:"",additionalInfo:E});return}this._tokens=this._scanner.reset(H).scan(),this._current=0,this._parsingErrors=[];try{const ne=this._expr();if(!this._isAtEnd()){const De=this._peek(),Re=De.type===17?r:void 0;throw this._parsingErrors.push({message:t,offset:De.offset,lexeme:D.Scanner.getLexeme(De),additionalInfo:Re}),d._parseError}return ne}catch(ne){if(ne!==d._parseError)throw ne;return}}_expr(){return this._or()}_or(){const H=[this._and()];for(;this._matchOne(16);){const ne=this._and();H.push(ne)}return H.length===1?H[0]:i.or(...H)}_and(){const H=[this._term()];for(;this._matchOne(15);){const ne=this._term();H.push(ne)}return H.length===1?H[0]:i.and(...H)}_term(){if(this._matchOne(2)){const H=this._peek();switch(H.type){case 11:return this._advance(),b.INSTANCE;case 12:return this._advance(),f.INSTANCE;case 0:{this._advance();const ne=this._expr();return this._consume(1,o),ne?.negate()}case 17:return this._advance(),M.create(H.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",H)}}return this._primary()}_primary(){const H=this._peek();switch(H.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const ne=this._expr();return this._consume(1,o),ne}case 17:{const ne=H.lexeme;if(this._advance(),this._matchOne(9)){const Re=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Re.type!==10)throw this._errExpectedButGot("REGEX",Re);const ke=Re.lexeme,ce=ke.lastIndexOf("/"),ie=ce===ke.length-1?void 0:this._removeFlagsGY(ke.substring(ce+1));let G;try{G=new RegExp(ke.substring(1,ce),ie)}catch{throw this._errExpectedButGot("REGEX",Re)}return P.create(ne,G)}switch(Re.type){case 10:case 19:{const ke=[Re.lexeme];this._advance();let ce=this._peek(),ie=0;for(let Le=0;Le<Re.lexeme.length;Le++)Re.lexeme.charCodeAt(Le)===40?ie++:Re.lexeme.charCodeAt(Le)===41&&ie--;for(;!this._isAtEnd()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Le=0;Le<ce.lexeme.length;Le++)ce.lexeme.charCodeAt(Le)===40?ie++:Re.lexeme.charCodeAt(Le)===41&&ie--}if(ie<0)break;ke.push(D.Scanner.getLexeme(ce)),this._advance(),ce=this._peek()}const G=ke.join(""),ee=G.lastIndexOf("/"),pe=ee===G.length-1?void 0:this._removeFlagsGY(G.substring(ee+1));let be;try{be=new RegExp(G.substring(1,ee),pe)}catch{throw this._errExpectedButGot("REGEX",Re)}return i.regex(ne,be)}case 18:{const ke=Re.lexeme;this._advance();let ce=null;if(!(0,F.isFalsyOrWhitespace)(ke)){const ie=ke.indexOf("/"),G=ke.lastIndexOf("/");if(ie!==G&&ie>=0){const ee=ke.slice(ie+1,G),pe=ke[G+1]==="i"?"i":"";try{ce=new RegExp(ee,pe)}catch{throw this._errExpectedButGot("REGEX",Re)}}}if(ce===null)throw this._errExpectedButGot("REGEX",Re);return P.create(ne,ce)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,n);const Re=this._value();return i.notIn(ne,Re)}switch(this._peek().type){case 3:{this._advance();const Re=this._value();if(this._previous().type===18)return i.equals(ne,Re);switch(Re){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Re)}}case 4:{this._advance();const Re=this._value();if(this._previous().type===18)return i.notEquals(ne,Re);switch(Re){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Re)}}case 5:return this._advance(),U.create(ne,this._value());case 6:return this._advance(),k.create(ne,this._value());case 7:return this._advance(),$.create(ne,this._value());case 8:return this._advance(),L.create(ne,this._value());case 13:return this._advance(),i.in(ne,this._value());default:return i.has(ne)}}case 20:throw this._parsingErrors.push({message:a,offset:H.offset,lexeme:"",additionalInfo:c}),d._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const H=this._peek();switch(H.type){case 17:case 18:return this._advance(),H.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(H){return H.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(H){return this._check(H)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(H,ne){if(this._check(H))return this._advance();throw this._errExpectedButGot(ne,this._peek())}_errExpectedButGot(H,ne,De){const Re=(0,T.localize)(8,null,H,D.Scanner.getLexeme(ne)),ke=ne.offset,ce=D.Scanner.getLexeme(ne);return this._parsingErrors.push({message:Re,offset:ke,lexeme:ce,additionalInfo:De}),d._parseError}_check(H){return this._peek().type===H}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=d;class i{static false(){return b.INSTANCE}static true(){return f.INSTANCE}static has(H){return C.create(H)}static equals(H,ne){return O.create(H,ne)}static notEquals(H,ne){return y.create(H,ne)}static regex(H,ne){return P.create(H,ne)}static in(H,ne){return v.create(H,ne)}static notIn(H,ne){return _.create(H,ne)}static not(H){return M.create(H)}static and(...H){return me.create(H,null,!0)}static or(...H){return Ee.create(H,null,!0)}static greater(H,ne){return $.create(H,ne)}static greaterEquals(H,ne){return L.create(H,ne)}static smaller(H,ne){return U.create(H,ne)}static smallerEquals(H,ne){return k.create(H,ne)}static{this._parser=new d({regexParsingWithErrorRecovery:!1})}static deserialize(H){return H==null?void 0:this._parser.parse(H)}}e.ContextKeyExpr=i;function s(Y){const H=new d({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(H.parse(ne),H.lexingErrors.length>0?H.lexingErrors.map(De=>({errorMessage:De.additionalInfo?(0,T.localize)(9,null,De.additionalInfo):(0,T.localize)(10,null),offset:De.offset,length:De.lexeme.length})):H.parsingErrors.length>0?H.parsingErrors.map(De=>({errorMessage:De.additionalInfo?`${De.message}. ${De.additionalInfo}`:De.message,offset:De.offset,length:De.lexeme.length})):[]))}e.validateWhenClauses=s;function l(Y,H){const ne=Y?Y.substituteConstants():void 0,De=H?H.substituteConstants():void 0;return!ne&&!De?!0:!ne||!De?!1:ne.equals(De)}e.expressionsAreEqualWithConstantSubstitution=l;function h(Y,H){return Y.cmp(H)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!1}serialize(){return"false"}keys(){return[]}map(H){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=b;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!0}serialize(){return"true"}keys(){return[]}map(H){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=f;class C{static create(H,ne=null){const De=m.get(H);return typeof De=="boolean"?De?f.INSTANCE:b.INSTANCE:new C(H,ne)}constructor(H,ne){this.key=H,this.negated=ne,this.type=2}cmp(H){return H.type!==this.type?this.type-H.type:he(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=m.get(this.key);return typeof H=="boolean"?H?f.INSTANCE:b.INSTANCE:this}evaluate(H){return!!H.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(H){return H.mapDefined(this.key)}negate(){return this.negated||(this.negated=M.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=C;class O{static create(H,ne,De=null){if(typeof ne=="boolean")return ne?C.create(H,De):M.create(H,De);const Re=m.get(H);return typeof Re=="boolean"?ne===(Re?"true":"false")?f.INSTANCE:b.INSTANCE:new O(H,ne,De)}constructor(H,ne,De){this.key=H,this.value=ne,this.negated=De,this.type=4}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){const H=m.get(this.key);if(typeof H=="boolean"){const ne=H?"true":"false";return this.value===ne?f.INSTANCE:b.INSTANCE}return this}evaluate(H){return H.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(H){return H.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=O;class v{static create(H,ne){return new v(H,ne)}constructor(H,ne){this.key=H,this.valueKey=ne,this.type=10,this.negated=null}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,this.valueKey,H.key,H.valueKey)}equals(H){return H.type===this.type?this.key===H.key&&this.valueKey===H.valueKey:!1}substituteConstants(){return this}evaluate(H){const ne=H.getValue(this.valueKey),De=H.getValue(this.key);return Array.isArray(ne)?ne.includes(De):typeof De=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,De):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(H){return H.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=v;class _{static create(H,ne){return new _(H,ne)}constructor(H,ne){this.key=H,this.valueKey=ne,this.type=11,this._negated=v.create(H,ne)}cmp(H){return H.type!==this.type?this.type-H.type:this._negated.cmp(H._negated)}equals(H){return H.type===this.type?this._negated.equals(H._negated):!1}substituteConstants(){return this}evaluate(H){return!this._negated.evaluate(H)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(H){return H.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=_;class y{static create(H,ne,De=null){if(typeof ne=="boolean")return ne?M.create(H,De):C.create(H,De);const Re=m.get(H);return typeof Re=="boolean"?ne===(Re?"true":"false")?b.INSTANCE:f.INSTANCE:new y(H,ne,De)}constructor(H,ne,De){this.key=H,this.value=ne,this.negated=De,this.type=5}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){const H=m.get(this.key);if(typeof H=="boolean"){const ne=H?"true":"false";return this.value===ne?b.INSTANCE:f.INSTANCE}return this}evaluate(H){return H.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(H){return H.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class M{static create(H,ne=null){const De=m.get(H);return typeof De=="boolean"?De?b.INSTANCE:f.INSTANCE:new M(H,ne)}constructor(H,ne){this.key=H,this.negated=ne,this.type=3}cmp(H){return H.type!==this.type?this.type-H.type:he(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=m.get(this.key);return typeof H=="boolean"?H?b.INSTANCE:f.INSTANCE:this}evaluate(H){return!H.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(H){return H.mapNot(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=M;function V(Y,H){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?H(Y):b.INSTANCE}class ${static create(H,ne,De=null){return V(ne,Re=>new $(H,Re,De))}constructor(H,ne,De){this.key=H,this.value=ne,this.negated=De,this.type=12}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(H){return H.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=$;class L{static create(H,ne,De=null){return V(ne,Re=>new L(H,Re,De))}constructor(H,ne,De){this.key=H,this.value=ne,this.negated=De,this.type=13}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(H){return H.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=L;class U{static create(H,ne,De=null){return V(ne,Re=>new U(H,Re,De))}constructor(H,ne,De){this.key=H,this.value=ne,this.negated=De,this.type=14}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(H){return H.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=L.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=U;class k{static create(H,ne,De=null){return V(ne,Re=>new k(H,Re,De))}constructor(H,ne,De){this.key=H,this.value=ne,this.negated=De,this.type=15}cmp(H){return H.type!==this.type?this.type-H.type:de(this.key,this.value,H.key,H.value)}equals(H){return H.type===this.type?this.key===H.key&&this.value===H.value:!1}substituteConstants(){return this}evaluate(H){return typeof this.value=="string"?!1:parseFloat(H.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(H){return H.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=k;class P{static create(H,ne){return new P(H,ne)}constructor(H,ne){this.key=H,this.regexp=ne,this.type=7,this.negated=null}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.key<H.key)return-1;if(this.key>H.key)return 1;const ne=this.regexp?this.regexp.source:"",De=H.regexp?H.regexp.source:"";return ne<De?-1:ne>De?1:0}equals(H){if(H.type===this.type){const ne=this.regexp?this.regexp.source:"",De=H.regexp?H.regexp.source:"";return this.key===H.key&&ne===De}return!1}substituteConstants(){return this}evaluate(H){const ne=H.getValue(this.key);return this.regexp?this.regexp.test(ne):!1}serialize(){const H=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${H}`}keys(){return[this.key]}map(H){return H.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Q.create(this)),this.negated}}e.ContextKeyRegexExpr=P;class Q{static create(H){return new Q(H)}constructor(H){this._actual=H,this.type=8}cmp(H){return H.type!==this.type?this.type-H.type:this._actual.cmp(H._actual)}equals(H){return H.type===this.type?this._actual.equals(H._actual):!1}substituteConstants(){return this}evaluate(H){return!this._actual.evaluate(H)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(H){return new Q(this._actual.map(H))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Q;function ae(Y){let H=null;for(let ne=0,De=Y.length;ne<De;ne++){const Re=Y[ne].substituteConstants();if(Y[ne]!==Re&&H===null){H=[];for(let ke=0;ke<ne;ke++)H[ke]=Y[ke]}H!==null&&(H[ne]=Re)}return H===null?Y:H}class me{static create(H,ne,De){return me._normalizeArr(H,ne,De)}constructor(H,ne){this.expr=H,this.negated=ne,this.type=6}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let ne=0,De=this.expr.length;ne<De;ne++){const Re=h(this.expr[ne],H.expr[ne]);if(Re!==0)return Re}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let ne=0,De=this.expr.length;ne<De;ne++)if(!this.expr[ne].equals(H.expr[ne]))return!1;return!0}return!1}substituteConstants(){const H=ae(this.expr);return H===this.expr?this:me.create(H,this.negated,!1)}evaluate(H){for(let ne=0,De=this.expr.length;ne<De;ne++)if(!this.expr[ne].evaluate(H))return!1;return!0}static _normalizeArr(H,ne,De){const Re=[];let ke=!1;for(const ce of H)if(ce){if(ce.type===1){ke=!0;continue}if(ce.type===0)return b.INSTANCE;if(ce.type===6){Re.push(...ce.expr);continue}Re.push(ce)}if(Re.length===0&&ke)return f.INSTANCE;if(Re.length!==0){if(Re.length===1)return Re[0];Re.sort(h);for(let ce=1;ce<Re.length;ce++)Re[ce-1].equals(Re[ce])&&(Re.splice(ce,1),ce--);if(Re.length===1)return Re[0];for(;Re.length>1;){const ce=Re[Re.length-1];if(ce.type!==9)break;Re.pop();const ie=Re.pop(),G=Re.length===0,ee=Ee.create(ce.expr.map(pe=>me.create([pe,ie],null,De)),null,G);ee&&(Re.push(ee),Re.sort(h))}if(Re.length===1)return Re[0];if(De){for(let ce=0;ce<Re.length;ce++)for(let ie=ce+1;ie<Re.length;ie++)if(Re[ce].negate().equals(Re[ie]))return b.INSTANCE;if(Re.length===1)return Re[0]}return new me(Re,ne)}}serialize(){return this.expr.map(H=>H.serialize()).join(" && ")}keys(){const H=[];for(const ne of this.expr)H.push(...ne.keys());return H}map(H){return new me(this.expr.map(ne=>ne.map(H)),null)}negate(){if(!this.negated){const H=[];for(const ne of this.expr)H.push(ne.negate());this.negated=Ee.create(H,this,!0)}return this.negated}}e.ContextKeyAndExpr=me;class Ee{static create(H,ne,De){return Ee._normalizeArr(H,ne,De)}constructor(H,ne){this.expr=H,this.negated=ne,this.type=9}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let ne=0,De=this.expr.length;ne<De;ne++){const Re=h(this.expr[ne],H.expr[ne]);if(Re!==0)return Re}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let ne=0,De=this.expr.length;ne<De;ne++)if(!this.expr[ne].equals(H.expr[ne]))return!1;return!0}return!1}substituteConstants(){const H=ae(this.expr);return H===this.expr?this:Ee.create(H,this.negated,!1)}evaluate(H){for(let ne=0,De=this.expr.length;ne<De;ne++)if(this.expr[ne].evaluate(H))return!0;return!1}static _normalizeArr(H,ne,De){let Re=[],ke=!1;if(H){for(let ce=0,ie=H.length;ce<ie;ce++){const G=H[ce];if(G){if(G.type===0){ke=!0;continue}if(G.type===1)return f.INSTANCE;if(G.type===9){Re=Re.concat(G.expr);continue}Re.push(G)}}if(Re.length===0&&ke)return b.INSTANCE;Re.sort(h)}if(Re.length!==0){if(Re.length===1)return Re[0];for(let ce=1;ce<Re.length;ce++)Re[ce-1].equals(Re[ce])&&(Re.splice(ce,1),ce--);if(Re.length===1)return Re[0];if(De){for(let ce=0;ce<Re.length;ce++)for(let ie=ce+1;ie<Re.length;ie++)if(Re[ce].negate().equals(Re[ie]))return f.INSTANCE;if(Re.length===1)return Re[0]}return new Ee(Re,ne)}}serialize(){return this.expr.map(H=>H.serialize()).join(" || ")}keys(){const H=[];for(const ne of this.expr)H.push(...ne.keys());return H}map(H){return new Ee(this.expr.map(ne=>ne.map(H)),null)}negate(){if(!this.negated){const H=[];for(const ne of this.expr)H.push(ne.negate());for(;H.length>1;){const ne=H.shift(),De=H.shift(),Re=[];for(const ke of oe(ne))for(const ce of oe(De))Re.push(me.create([ke,ce],null,!1));H.unshift(Ee.create(Re,null,!1))}this.negated=Ee.create(H,this,!0)}return this.negated}}e.ContextKeyOrExpr=Ee;class Ce extends C{static{this._info=[]}static all(){return Ce._info.values()}constructor(H,ne,De){super(H,null),this._defaultValue=ne,typeof De=="object"?Ce._info.push({...De,key:H}):De!==!0&&Ce._info.push({key:H,description:De,type:ne!=null?typeof ne:void 0})}bindTo(H){return H.createKey(this.key,this._defaultValue)}getValue(H){return H.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(H){return O.create(this.key,H)}notEqualsTo(H){return y.create(this.key,H)}}e.RawContextKey=Ce,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function he(Y,H){return Y<H?-1:Y>H?1:0}function de(Y,H,ne,De){return Y<ne?-1:Y>ne?1:H<De?-1:H>De?1:0}function te(Y,H){if(Y.type===0||H.type===1)return!0;if(Y.type===9)return H.type===9?Ie(Y.expr,H.expr):!1;if(H.type===9){for(const ne of H.expr)if(te(Y,ne))return!0;return!1}if(Y.type===6){if(H.type===6)return Ie(H.expr,Y.expr);for(const ne of Y.expr)if(te(ne,H))return!0;return!1}return Y.equals(H)}e.implies=te;function Ie(Y,H){let ne=0,De=0;for(;ne<Y.length&&De<H.length;){const Re=Y[ne].cmp(H[De]);if(Re<0)return!1;Re===0&&ne++,De++}return ne===Y.length}function oe(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[184],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[97],Te([1,0,151,4]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function D(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function R(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function T(t,r){switch(t){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":r==="ppc64le"?"linux-ppc64le":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function g(t,r){return r==="web"&&!t.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function m(t,r,a){return g(r,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.isTargetPlatformCompatible=m;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=w;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var I;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var u;(function(t){t.Install="install",t.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,F.createDecorator)("extensionGalleryService");var E;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var n;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,F.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,F.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,F.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,S.localize)(1,null),original:"Preferences"}}),define(Pe[42],Te([1,0,50,19,12,16,2,153,4,21,13,39]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasReadonlyCapability=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.isFileSystemWatcher=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function u(te){return te.create===!0}e.isFileOpenForWriteOptions=u;var p;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var E;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(E||(e.FilePermission=E={}));function n(te){const Ie=te;return!!Ie&&typeof Ie.onDidChange=="function"}e.isFileSystemWatcher=n;var o;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(te){return!!(te.capabilities&2)}e.hasReadWriteCapability=t;function r(te){return!!(te.capabilities&8)}e.hasFileFolderCopyCapability=r;function a(te){return!!(te.capabilities&131072)}e.hasFileCloneCapability=a;function c(te){return!!(te.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function d(te){return!!(te.capabilities&16)}e.hasFileReadStreamCapability=d;function i(te){return t(te)?!!(te.capabilities&16384):!1}e.hasFileAtomicReadCapability=i;function s(te){return t(te)?!!(te.capabilities&32768):!1}e.hasFileAtomicWriteCapability=s;function l(te){return!!(te.capabilities&65536)}e.hasFileAtomicDeleteCapability=l;function h(te){return!!(te.capabilities&2048)}e.hasReadonlyCapability=h;var b;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class f extends Error{static create(Ie,oe){const Y=new f(Ie.toString(),oe);return v(Y,oe),Y}constructor(Ie,oe){super(Ie),this.code=oe}}e.FileSystemProviderError=f;function C(te,Ie){return f.create(te,Ie)}e.createFileSystemProviderError=C;function O(te){return te||C((0,g.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=O;function v(te,Ie){return te.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",te}e.markAsFileSystemProviderError=v;function _(te){if(!te)return b.Unknown;if(te instanceof f)return te.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Ie)return b.Unknown;switch(Ie[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=_;function y(te){if(te instanceof k)return te.fileOperationResult;switch(_(te)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=y;var M;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class V{constructor(Ie,oe,Y){this.resource=Ie,this.operation=oe,this.target=Y}isOperation(Ie){return this.operation===Ie}}e.FileOperationEvent=V;var $;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})($||(e.FileChangeType=$={}));class L{static{this.MIXED_CORRELATION=null}constructor(Ie,oe){this.ignorePathCasing=oe,this.correlationId=void 0,this.added=new I.Lazy(()=>{const Y=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawAdded.map(H=>[H,!0])),Y}),this.updated=new I.Lazy(()=>{const Y=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawUpdated.map(H=>[H,!0])),Y}),this.deleted=new I.Lazy(()=>{const Y=S.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Y.fill(this.rawDeleted.map(H=>[H,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Ie){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.correlationId!==L.MIXED_CORRELATION&&(typeof Y.cId=="number"?this.correlationId===void 0?this.correlationId=Y.cId:this.correlationId!==Y.cId&&(this.correlationId=L.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=L.MIXED_CORRELATION))}}contains(Ie,...oe){return this.doContains(Ie,{includeChildren:!1},...oe)}affects(Ie,...oe){return this.doContains(Ie,{includeChildren:!0},...oe)}doContains(Ie,oe,...Y){if(!Ie)return!1;const H=Y.length>0;return!!((!H||Y.includes(1))&&(this.added.value.get(Ie)||oe.includeChildren&&this.added.value.findSuperstr(Ie))||(!H||Y.includes(0))&&(this.updated.value.get(Ie)||oe.includeChildren&&this.updated.value.findSuperstr(Ie))||(!H||Y.includes(2))&&(this.deleted.value.findSubstr(Ie)||oe.includeChildren&&this.deleted.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.correlationId===Ie}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=L;function U(te,Ie,oe){return!te||!Ie||te===Ie||Ie.length>te.length?!1:(Ie.charAt(Ie.length-1)!==F.sep&&(Ie+=F.sep),oe?(0,D.startsWithIgnoreCase)(te,Ie):te.indexOf(Ie)===0)}e.isParent=U;class k extends Error{constructor(Ie,oe,Y){super(Ie),this.fileOperationResult=oe,this.options=Y}}e.FileOperationError=k;class P extends k{constructor(Ie,oe,Y,H){super(Ie,oe,H),this.fileOperationResult=oe,this.size=Y}}e.TooLargeFileOperationError=P;class Q extends k{constructor(Ie,oe,Y){super(Ie,2,Y),this.stat=oe}}e.NotModifiedSinceFileOperationError=Q;var ae;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var me;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.ETAG_DISABLED="";function Ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.etag=Ee;async function Ce(te,Ie){if(!Ie.hasProvider(T.URI.from({scheme:te.scheme})))return new Promise(oe=>{const Y=Ie.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===te.scheme&&H.added&&(Y.dispose(),oe())})})}e.whenProviderRegistered=Ce;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize(Ie){return(0,R.isNumber)(Ie)||(Ie=0),Ie<he.KB?(0,g.localize)(1,null,Ie.toFixed(0)):Ie<he.MB?(0,g.localize)(2,null,(Ie/he.KB).toFixed(2)):Ie<he.GB?(0,g.localize)(3,null,(Ie/he.MB).toFixed(2)):Ie<he.TB?(0,g.localize)(4,null,(Ie/he.GB).toFixed(2)):(0,g.localize)(5,null,(Ie/he.TB).toFixed(2))}}e.ByteSize=he;function de(te){const Ie=typeof te=="string"||te?.scheme===A.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===A.Schemas.file?1024*he.MB:Ie?10*he.MB:w.isWeb?50*he.MB:1024*he.MB}e.getLargeFileConfirmationLimit=de}),define(Pe[71],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...D){this._entries=new Map;for(const[R,T]of D)this.set(R,T)}set(D,R){const T=this._entries.get(D);return this._entries.set(D,R),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=S}),define(Pe[185],Te([1,0,14,11,6,69,183,4,71,186]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class I extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new m.ServiceCollection,t=!1,r,a=A){this._services=o,this._strict=t,this._parent=r,this._enableTracing=a,this._activeInstantiations=new Set,this._services.set(g.IInstantiationService,this),this._globalGraph=a?r?._globalGraph??new T.Graph(c=>c):void 0}createChild(o){return new u(o,this._strict,this,this._enableTracing)}invokeFunction(o,...t){const r=E.traceInvocation(this._enableTracing,o);let a=!1;try{return o({get:d=>{if(a)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(d,r);if(!i)throw new Error(`[invokeFunction] unknown service '${d}'`);return i}},...t)}finally{a=!0,r.stop()}}createInstance(o,...t){let r,a;return o instanceof R.SyncDescriptor?(r=E.traceCreation(this._enableTracing,o.ctor),a=this._createInstance(o.ctor,o.staticArguments.concat(t),r)):(r=E.traceCreation(this._enableTracing,o),a=this._createInstance(o,t,r)),r.stop(),a}_createInstance(o,t=[],r){const a=g._util.getServiceDependencies(o).sort((i,s)=>i.index-s.index),c=[];for(const i of a){const s=this._getOrCreateServiceInstance(i.id,r);s||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const d=a.length>0?a[0].index:t.length;if(t.length!==d){console.trace(`[createInstance] First service dependency of ${o.name} at position ${d+1} conflicts with ${t.length} static arguments`);const i=d-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,d)}return Reflect.construct(o,t.concat(c))}_setServiceInstance(o,t){if(this._services.get(o)instanceof R.SyncDescriptor)this._services.set(o,t);else if(this._parent)this._parent._setServiceInstance(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const t=this._services.get(o);return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):t}_getOrCreateServiceInstance(o,t){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const r=this._getServiceInstanceOrDescriptor(o);return r instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,r,t.branch(o,!0)):(t.branch(o,!1),r)}_safeCreateAndCacheServiceInstance(o,t,r){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,t,r)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,t,r){const a=new T.Graph(i=>i.id.toString());let c=0;const d=[{id:o,desc:t,_trace:r}];for(;d.length;){const i=d.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new I(a);for(const s of g._util.getServiceDependencies(i.desc.ctor)){const l=this._getServiceInstanceOrDescriptor(s.id);if(l||this._throwIfStrict(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),l instanceof R.SyncDescriptor){const h={id:s.id,desc:l,_trace:i._trace.branch(s.id,!0)};a.insertEdge(i,h),d.push(h)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new I(a);break}for(const{data:s}of i){if(this._getServiceInstanceOrDescriptor(s.id)instanceof R.SyncDescriptor){const h=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,h)}a.removeNode(s)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,t,r=[],a,c){if(this._services.get(o)instanceof R.SyncDescriptor)return this._createServiceInstance(o,t,r,a,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,t,r,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(o,t,r=[],a,c){if(a){const d=new u(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(o);const i=new Map,s=new S.GlobalIdleValue(()=>{const l=d._createInstance(t,r,c);for(const[h,b]of i){const f=l[h];if(typeof f=="function")for(const C of b)f.apply(l,C)}return i.clear(),l});return new Proxy(Object.create(null),{get(l,h){if(!s.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let C=i.get(h);return C||(C=new w.LinkedList,i.set(h,C)),(v,_,y)=>{const M=C.push([v,_,y]);return(0,D.toDisposable)(M)}}if(h in l)return l[h];const b=s.value;let f=b[h];return typeof f!="function"||(f=f.bind(b),l[h]=f),f},set(l,h,b){return s.value[h]=b,!0},getPrototypeOf(l){return t.prototype}})}else return this._createInstance(t,r,c)}_throwIfStrict(o,t){if(t&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=u;var p;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(p||(p={}));class E{static{this.all=new Set}static{this._None=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new E(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E._None}static traceCreation(o,t){return o?new E(1,t.name):E._None}static{this._totals=0}constructor(o,t){this.type=o,this.name=t,this._start=Date.now(),this._dep=[]}branch(o,t){const r=new E(3,o.toString());return this._dep.push([o,t,r]),r}stop(){const o=Date.now()-this._start;E._totals+=o;let t=!1;function r(c,d){const i=[],s=new Array(c+1).join("	");for(const[l,h,b]of d._dep)if(h&&b){t=!0,i.push(`${s}CREATES -> ${l}`);const f=r(c+1,b);f&&i.push(f)}else i.push(`${s}uses -> ${l}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(o>2||t)&&E.all.add(a.join(`
`))}}e.Trace=E}),define(Pe[15],Te([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function p(){return new Date().toISOString()}function E(v){return(0,w.isNumber)(v)}e.isLogLevel=E;var n;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(n||(e.LogLevel=n={})),e.DEFAULT_LOG_LEVEL=n.Info;function o(v,_,y){switch(_){case n.Trace:v.trace(y);break;case n.Debug:v.debug(y);break;case n.Info:v.info(y);break;case n.Warning:v.warn(y);break;case n.Error:v.error(y);break;case n.Off:break;default:throw new Error(`Invalid log level ${_}`)}}e.log=o;function t(v,_=!1){let y="";for(let M=0;M<v.length;M++){let V=v[M];if(V instanceof Error&&(V=(0,S.toErrorMessage)(V,_)),typeof V=="object")try{V=JSON.stringify(V)}catch{}y+=(M>0?" ":"")+V}return y}class r extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(_){this.level!==_&&(this.level=_,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(_){return this.level!==n.Off&&this.level<=_}}e.AbstractLogger=r;class a extends r{constructor(_){super(),this.logAlways=_}checkLogLevel(_){return this.logAlways||super.checkLogLevel(_)}trace(_,...y){this.checkLogLevel(n.Trace)&&this.log(n.Trace,t([_,...y],!0))}debug(_,...y){this.checkLogLevel(n.Debug)&&this.log(n.Debug,t([_,...y]))}info(_,...y){this.checkLogLevel(n.Info)&&this.log(n.Info,t([_,...y]))}warn(_,...y){this.checkLogLevel(n.Warning)&&this.log(n.Warning,t([_,...y]))}error(_,...y){if(this.checkLogLevel(n.Error))if(_ instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=_.stack,this.log(n.Error,t(M))}else this.log(n.Error,t([_,...y]))}flush(){}}e.AbstractMessageLogger=a;class c extends r{constructor(_=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(_),this.useColors=!g.isWindows}trace(_,...y){this.checkLogLevel(n.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,_,...y):console.log(`[main ${p()}]`,_,...y))}debug(_,...y){this.checkLogLevel(n.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,_,...y):console.log(`[main ${p()}]`,_,...y))}info(_,...y){this.checkLogLevel(n.Info)&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,_,...y):console.log(`[main ${p()}]`,_,...y))}warn(_,...y){this.checkLogLevel(n.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,_,...y):console.warn(`[main ${p()}]`,_,...y))}error(_,...y){this.checkLogLevel(n.Error)&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,_,...y):console.error(`[main ${p()}]`,_,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=c;class d extends r{constructor(_=e.DEFAULT_LOG_LEVEL,y=!0){super(),this.useColors=y,this.setLevel(_)}trace(_,...y){this.checkLogLevel(n.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",_,...y):console.log(_,...y))}debug(_,...y){this.checkLogLevel(n.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",_,...y):console.log(_,...y))}info(_,...y){this.checkLogLevel(n.Info)&&(this.useColors?console.log("%c INFO","color: #33f",_,...y):console.log(_,...y))}warn(_,...y){this.checkLogLevel(n.Warning)&&(this.useColors?console.log("%c WARN","color: #993",_,...y):console.log(_,...y))}error(_,...y){this.checkLogLevel(n.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",_,...y):console.error(_,...y))}dispose(){}flush(){}}e.ConsoleLogger=d;class i extends r{constructor(_,y=e.DEFAULT_LOG_LEVEL){super(),this.adapter=_,this.setLevel(y)}trace(_,...y){this.checkLogLevel(n.Trace)&&this.adapter.log(n.Trace,[this.extractMessage(_),...y])}debug(_,...y){this.checkLogLevel(n.Debug)&&this.adapter.log(n.Debug,[this.extractMessage(_),...y])}info(_,...y){this.checkLogLevel(n.Info)&&this.adapter.log(n.Info,[this.extractMessage(_),...y])}warn(_,...y){this.checkLogLevel(n.Warning)&&this.adapter.log(n.Warning,[this.extractMessage(_),...y])}error(_,...y){this.checkLogLevel(n.Error)&&this.adapter.log(n.Error,[this.extractMessage(_),...y])}extractMessage(_){return typeof _=="string"?_:(0,S.toErrorMessage)(_,this.checkLogLevel(n.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class s extends r{constructor(_){super(),this.loggers=_,_.length&&this.setLevel(_[0].getLevel())}setLevel(_){for(const y of this.loggers)y.setLevel(_);super.setLevel(_)}trace(_,...y){for(const M of this.loggers)M.trace(_,...y)}debug(_,...y){for(const M of this.loggers)M.debug(_,...y)}info(_,...y){for(const M of this.loggers)M.info(_,...y)}warn(_,...y){for(const M of this.loggers)M.warn(_,...y)}error(_,...y){for(const M of this.loggers)M.error(_,...y)}flush(){for(const _ of this.loggers)_.flush()}dispose(){for(const _ of this.loggers)_.dispose()}}e.MultiplexLogger=s;class l extends R.Disposable{constructor(_,y,M){if(super(),this.logLevel=_,this.logsHome=y,this._loggers=new T.ResourceMap,this._onDidChangeLoggers=this._register(new F.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new F.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,M)for(const V of M)this._loggers.set(V.resource,{logger:void 0,info:V})}getLoggerEntry(_){return(0,w.isString)(_)?[...this._loggers.values()].find(y=>y.info.id===_):this._loggers.get(_)}getLogger(_){return this.getLoggerEntry(_)?.logger}createLogger(_,y){const M=this.toResource(_),V=(0,w.isString)(_)?_:y?.id??(0,D.hash)(M.toString()).toString(16);let $=this._loggers.get(M)?.logger;const L=y?.logLevel==="always"?n.Trace:y?.logLevel;$||($=this.doCreateLogger(M,L??this.getLogLevel(M)??this.logLevel,{...y,id:V}));const U={logger:$,info:{resource:M,id:V,logLevel:L,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(U.info),this._loggers.set(M,U),$}toResource(_){return(0,w.isString)(_)?(0,m.joinPath)(this.logsHome,`${_}.log`):_}setLogLevel(_,y){if(A.URI.isUri(_)){const M=_,V=y,$=this._loggers.get(M);$&&V!==$.info.logLevel&&($.info.logLevel=V===this.logLevel?void 0:V,$.logger?.setLevel(V),this._loggers.set($.info.resource,$),this._onDidChangeLogLevel.fire([M,V]))}else{this.logLevel=_;for(const[M,V]of this._loggers.entries())this._loggers.get(M)?.info.logLevel===void 0&&V.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(_,y){const M=this.getLoggerEntry(_);M&&y!==!M.info.hidden&&(M.info.hidden=!y,this._loggers.set(M.info.resource,M),this._onDidChangeVisibility.fire([M.info.resource,y]))}getLogLevel(_){let y;return _&&(y=this._loggers.get(_)?.info.logLevel),y??this.logLevel}registerLogger(_){const y=this._loggers.get(_.resource);y?y.info.hidden!==_.hidden&&this.setVisibility(_.resource,!_.hidden):(this._loggers.set(_.resource,{info:_,logger:void 0}),this._onDidChangeLoggers.fire({added:[_],removed:[]}))}deregisterLogger(_){const y=this._loggers.get(_);y&&(y.logger&&y.logger.dispose(),this._loggers.delete(_),this._onDidChangeLoggers.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const _ of this._loggers.values())yield _.info}getRegisteredLogger(_){return this._loggers.get(_)?.info}dispose(){this._loggers.forEach(_=>_.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=l;class h{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(_){}getLevel(){return n.Info}trace(_,...y){}debug(_,...y){}info(_,...y){}warn(_,...y){}error(_,...y){}critical(_,...y){}dispose(){}flush(){}}e.NullLogger=h;class b extends h{}e.NullLogService=b;function f(v){if(v.verbose)return n.Trace;if(typeof v.logLevel=="string"){const _=O(v.logLevel.toLowerCase());if(_!==void 0)return _}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function C(v){switch(v){case n.Trace:return"trace";case n.Debug:return"debug";case n.Info:return"info";case n.Warning:return"warn";case n.Error:return"error";case n.Off:return"off"}}e.LogLevelToString=C;function O(v){switch(v){case"trace":return n.Trace;case"debug":return n.Debug;case"info":return n.Info;case"warn":return n.Warning;case"error":return n.Error;case"critical":return n.Error;case"off":return n.Off}}e.parseLogLevel=O,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",C(n.Info))}),define(Pe[187],Te([1,0,6,15]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends S.Disposable{constructor(T,g=[]){super(),this.logger=new F.MultiplexLogger([T,...g]),this._register(T.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...g){this.logger.trace(T,...g)}debug(T,...g){this.logger.debug(T,...g)}info(T,...g){this.logger.info(T,...g)}warn(T,...g){this.logger.warn(T,...g)}error(T,...g){this.logger.error(T,...g)}flush(){this.logger.flush()}}e.LogService=D}),define(Pe[99],Te([1,0,31,154,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var T;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(m){function w(E,n){return n-E}m.compare=w;const A=Object.create(null);A[m.Error]=(0,F.localize)(0,null),A[m.Warning]=(0,F.localize)(1,null),A[m.Info]=(0,F.localize)(2,null);function I(E){return A[E]||""}m.toString=I;function u(E){switch(E){case S.default.Error:return m.Error;case S.default.Warning:return m.Warning;case S.default.Info:return m.Info;case S.default.Ignore:return m.Hint}}m.fromSeverity=u;function p(E){switch(E){case m.Error:return S.default.Error;case m.Warning:return S.default.Warning;case m.Info:return S.default.Info;case m.Hint:return S.default.Ignore}}m.toSeverity=p}(T||(e.MarkerSeverity=T={}));var g;(function(m){const w="";function A(u){return I(u,!0)}m.makeKey=A;function I(u,p){const E=[w];return u.source?E.push(u.source.replace("\xA6","\\\xA6")):E.push(w),u.code?typeof u.code=="string"?E.push(u.code.replace("\xA6","\\\xA6")):E.push(u.code.value.replace("\xA6","\\\xA6")):E.push(w),u.severity!==void 0&&u.severity!==null?E.push(T.toString(u.severity)):E.push(w),u.message&&p?E.push(u.message.replace("\xA6","\\\xA6")):E.push(w),u.startLineNumber!==void 0&&u.startLineNumber!==null?E.push(u.startLineNumber.toString()):E.push(w),u.startColumn!==void 0&&u.startColumn!==null?E.push(u.startColumn.toString()):E.push(w),u.endLineNumber!==void 0&&u.endLineNumber!==null?E.push(u.endLineNumber.toString()):E.push(w),u.endColumn!==void 0&&u.endColumn!==null?E.push(u.endColumn.toString()):E.push(w),E.push(w),E.join("\xA6")}m.makeKeyOptionalMessage=I})(g||(e.IMarkerData=g={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Pe[188],Te([1,0,5,31,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,D.createDecorator)("notificationService");var R;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var T;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));var g;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(g||(e.NotificationsFilter=g={}));class m{constructor(){this.progress=new w,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.NoOpNotification=m;class w{infinite(){}done(){}total(I){}worked(I){}}e.NoOpProgress=w}),define(Pe[189],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__decorate||function(ge,e,S,F){var D=arguments.length,R=D<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ge,e,S,F);else for(var g=ge.length-1;g>=0;g--)(T=ge[g])&&(R=(D<3?T(R):D>3?T(e,S,R):T(e,S))||R);return D>3&&R&&Object.defineProperty(e,S,R),R},Ve=this&&this.__param||function(ge,e){return function(S,F){e(S,F,ge)}};define(Pe[72],Te([1,0,14,20,6,4]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var T;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(u){this.callback=u}report(u){this._value=u,this.callback(this._value)}}e.Progress=g;class m{get value(){return this._value}constructor(u){this.callback=u}report(u){this._asyncQueue?this._asyncQueue.push(u):this._asyncQueue=[u],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const u=this._asyncQueue.shift();this._value=u,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const u=this._drainListener;this._drainListener=void 0,u?.()}}drain(){return this._processingAsyncQueue?new Promise(u=>{const p=this._drainListener;this._drainListener=()=>{p?.(),u()}}):Promise.resolve()}}e.AsyncProgress=m;let w=class extends D.Disposable{constructor(u,p){super(),this.deferred=new S.DeferredPromise,p.withProgress(u,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(u){this.reporter?this.reporter.report(u):this.lastStep=u}};e.UnmanagedProgress=w,e.UnmanagedProgress=w=je([Ve(1,e.IProgressService)],w);class A extends D.Disposable{constructor(u){super(),this.progressIndicator=u,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(u){this.stop();const p=++this.currentOperationId,E=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},u),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:E.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(u){this.currentOperationId===u&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(Pe[30],Te([1,0,53,16]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,g){S.ok(F.isString(T)),S.ok(F.isObject(g)),S.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,g)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(Pe[73],Te([1,0,5,30]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class R{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,w){this.schemasById[D(m)]=w,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;F.Registry.add(e.Extensions.JSONContribution,T)}),define(Pe[54],Te([1,0,18,5,16,148,41,73,30]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=m.Registry.as(g.Extensions.JSONContribution);class u{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const l=new Set;this.doRegisterConfigurations(i,s,l),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(i){const s=new Set;this.doDeregisterConfigurations(i,s),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const l=new Set;this.doDeregisterConfigurations(s,l),this.doRegisterConfigurations(i,!1,l),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}registerDefaultConfigurations(i){const s=new Set;this.doRegisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,s){const l=[];for(const{overrides:h,source:b}of i)for(const f in h)if(s.add(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const C=this.configurationDefaultsOverrides.get(f),O=C?.valuesSources??new Map;if(b)for(const M of Object.keys(h[f]))O.set(M,b);const v={...C?.value||{},...h[f]};this.configurationDefaultsOverrides.set(f,{source:b,value:v,valuesSources:O});const _=(0,T.getLanguageTagSettingPlainKey)(f),y={type:"object",default:v,description:R.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:D.isString(b)?void 0:b,defaultValueSource:b};l.push(...n(f)),this.configurationProperties[f]=y,this.defaultLanguageConfigurationOverridesNode.properties[f]=y}else{this.configurationDefaultsOverrides.set(f,{value:h[f],source:b});const C=this.configurationProperties[f];C&&(this.updatePropertyDefaultValue(f,C),this.updateSchema(f,C))}this.doRegisterOverrideIdentifiers(l)}deregisterDefaultConfigurations(i){const s=new Set;this.doDeregisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,s){for(const{overrides:l,source:h}of i)for(const b in l){const f=this.configurationDefaultsOverrides.get(b),C=D.isString(h)?h:h?.id,O=D.isString(f?.source)?f?.source:f?.source?.id;if(C===O)if(s.add(b),this.configurationDefaultsOverrides.delete(b),e.OVERRIDE_PROPERTY_REGEX.test(b))delete this.configurationProperties[b],delete this.defaultLanguageConfigurationOverridesNode.properties[b];else{const v=this.configurationProperties[b];v&&(this.updatePropertyDefaultValue(b,v),this.updateSchema(b,v))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let s=!1;const l=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,l),s=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,l),s=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,l),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s,l){i.forEach(h=>{this.validateAndRegisterProperties(h,s,h.extensionInfo,h.restrictedProperties,void 0,l),this.configurationContributors.push(h),this.registerJSONConfiguration(h)})}doDeregisterConfigurations(i,s){const l=h=>{if(h.properties)for(const b in h.properties){s.add(b);const f=this.configurationProperties[b];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[b],this.removeFromSchema(b,h.properties[b])}h.allOf?.forEach(b=>l(b))};for(const h of i){l(h);const b=this.configurationContributors.indexOf(h);b!==-1&&this.configurationContributors.splice(b,1)}}validateAndRegisterProperties(i,s=!0,l,h,b=3,f){b=D.isUndefinedOrNull(i.scope)?b:i.scope;const C=i.properties;if(C)for(const v in C){const _=C[v];if(s&&a(v,_)){delete C[v];continue}if(_.source=l,_.defaultDefaultValue=C[v].default,this.updatePropertyDefaultValue(v,_),e.OVERRIDE_PROPERTY_REGEX.test(v)?_.scope=void 0:(_.scope=D.isUndefinedOrNull(_.scope)?b:_.scope,_.restricted=D.isUndefinedOrNull(_.restricted)?!!h?.includes(v):_.restricted),C[v].hasOwnProperty("included")&&!C[v].included){this.excludedConfigurationProperties[v]=C[v],delete C[v];continue}else this.configurationProperties[v]=C[v],C[v].policy?.name&&this.policyConfigurations.set(C[v].policy.name,v);!C[v].deprecationMessage&&C[v].markdownDeprecationMessage&&(C[v].deprecationMessage=C[v].markdownDeprecationMessage),f.add(v)}const O=i.allOf;if(O)for(const v of O)this.validateAndRegisterProperties(v,s,l,h,b,f)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=l=>{const h=l.properties;if(h)for(const f in h)this.updateSchema(f,h[f]);l.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,l={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,l),e.allSettings.properties[s]=l,e.applicationSettings.properties[s]=l,e.machineSettings.properties[s]=l,e.machineOverridableSettings.properties[s]=l,e.windowSettings.properties[s]=l,e.resourceSettings.properties[s]=l}}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const l=this.configurationDefaultsOverrides.get(i);let h=l?.value,b=l?.source;D.isUndefined(h)&&(h=s.defaultDefaultValue,b=void 0),D.isUndefined(h)&&(h=t(s.type)),s.default=h,s.defaultValueSource=b}}const p="\\[([^\\]]+)\\]",E=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function n(d){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let s=E.exec(d);for(;s?.length;){const l=s[1].trim();l&&i.push(l),s=E.exec(d)}}return(0,S.distinct)(i)}e.overrideIdentifiersFromKey=n;function o(d){return d.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=o;function t(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const r=new u;m.Registry.add(e.Extensions.Configuration,r);function a(d,i){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?R.localize(7,null,d):r.getConfigurationProperties()[d]!==void 0?R.localize(8,null,d):i.policy?.name&&r.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,d,i.policy?.name,r.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=a;function c(){const d=[],i=r.getConfigurationProperties();for(const s of Object.keys(i))d.push([s,i[s].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=c}),define(Pe[190],Te([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function p(s){return Object.isFrozen(s)?s:g.deepFreeze(s)}class E{constructor(l={},h=[],b=[],f){this._contents=l,this._keys=h,this._overrides=b,this.raw=f,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const l=this.raw.map(h=>{if(h instanceof E)return h;const b=new n("");return b.parseRaw(h),b.configurationModel});this._rawConfiguration=l.reduce((h,b)=>b===h?b:h.merge(b),l[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(l){return l?(0,A.getConfigurationValue)(this.contents,l):this.contents}inspect(l,h){const b=this.rawConfiguration.getValue(l),f=h?this.rawConfiguration.getOverrideValue(l,h):void 0,C=h?this.rawConfiguration.override(h).getValue(l):b;return{value:b,override:f,merged:C}}getOverrideValue(l,h){const b=this.getContentsForOverrideIdentifer(h);return b?l?(0,A.getConfigurationValue)(b,l):b:void 0}getKeysForOverrideIdentifier(l){const h=[];for(const b of this.overrides)b.identifiers.includes(l)&&h.push(...b.keys);return S.distinct(h)}getAllOverrideIdentifiers(){const l=[];for(const h of this.overrides)l.push(...h.identifiers);return S.distinct(l)}override(l){let h=this.overrideConfigurations.get(l);return h||(h=this.createOverrideConfigurationModel(l),this.overrideConfigurations.set(l,h)),h}merge(...l){const h=g.deepClone(this.contents),b=g.deepClone(this.overrides),f=[...this.keys],C=this.raw?.length?[...this.raw]:[this];for(const O of l)if(C.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.mergeContents(h,O.contents);for(const v of O.overrides){const[_]=b.filter(y=>S.equals(y.identifiers,v.identifiers));_?(this.mergeContents(_.contents,v.contents),_.keys.push(...v.keys),_.keys=S.distinct(_.keys)):b.push(g.deepClone(v))}for(const v of O.keys)f.indexOf(v)===-1&&f.push(v)}return new E(h,f,b,C.every(O=>O instanceof E)?void 0:C)}createOverrideConfigurationModel(l){const h=this.getContentsForOverrideIdentifer(l);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const b={};for(const f of S.distinct([...Object.keys(this.contents),...Object.keys(h)])){let C=this.contents[f];const O=h[f];O&&(typeof C=="object"&&typeof O=="object"?(C=g.deepClone(C),this.mergeContents(C,O)):C=O),b[f]=C}return new E(b,this.keys,this.overrides)}mergeContents(l,h){for(const b of Object.keys(h)){if(b in l&&m.isObject(l[b])&&m.isObject(h[b])){this.mergeContents(l[b],h[b]);continue}l[b]=g.deepClone(h[b])}}getContentsForOverrideIdentifer(l){let h=null,b=null;const f=C=>{C&&(b?this.mergeContents(b,C):b=g.deepClone(C))};for(const C of this.overrides)C.identifiers.length===1&&C.identifiers[0]===l?h=C.contents:C.identifiers.includes(l)&&f(C.contents);return f(h),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,h){this.updateValue(l,h,!0)}setValue(l,h){this.updateValue(l,h,!1)}removeValue(l){const h=this.keys.indexOf(l);h!==-1&&(this.keys.splice(h,1),(0,A.removeFromValueTree)(this.contents,l),I.OVERRIDE_PROPERTY_REGEX.test(l)&&this.overrides.splice(this.overrides.findIndex(b=>S.equals(b.identifiers,(0,I.overrideIdentifiersFromKey)(l))),1))}updateValue(l,h,b){(0,A.addToValueTree)(this.contents,l,h,f=>console.error(f)),b=b||this.keys.indexOf(l)===-1,b&&this.keys.push(l),I.OVERRIDE_PROPERTY_REGEX.test(l)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(l),keys:Object.keys(this.contents[l]),contents:(0,A.toValuesTree)(this.contents[l],f=>console.error(f))})}}e.ConfigurationModel=E;class n{constructor(l){this._name=l,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(l,h){if(!m.isUndefinedOrNull(l)){const b=this.doParseContent(l);this.parseRaw(b,h)}}reparse(l){this._raw&&this.parseRaw(this._raw,l)}parseRaw(l,h){this._raw=l;const{contents:b,keys:f,overrides:C,restricted:O,hasExcludedProperties:v}=this.doParseRaw(l,h);this._configurationModel=new E(b,f,C,v?[l]:void 0),this._restrictedConfigurations=O||[]}doParseContent(l){let h={},b=null,f=[];const C=[],O=[];function v(y){Array.isArray(f)?f.push(y):b!==null&&(f[b]=y)}const _={onObjectBegin:()=>{const y={};v(y),C.push(f),f=y,b=null},onObjectProperty:y=>{b=y},onObjectEnd:()=>{f=C.pop()},onArrayBegin:()=>{const y=[];v(y),C.push(f),f=y,b=null},onArrayEnd:()=>{f=C.pop()},onLiteralValue:v,onError:(y,M,V)=>{O.push({error:y,offset:M,length:V})}};if(l)try{D.visit(l,_),h=f[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return h}doParseRaw(l,h){const b=u.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),f=this.filter(l,b,!0,h);l=f.raw;const C=(0,A.toValuesTree)(l,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),O=Object.keys(l),v=this.toOverrides(l,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:C,keys:O,overrides:v,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}filter(l,h,b,f){let C=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:C};const O={},v=[];for(const _ in l)if(I.OVERRIDE_PROPERTY_REGEX.test(_)&&b){const y=this.filter(l[_],h,!1,f);O[_]=y.raw,C=C||y.hasExcludedProperties,v.push(...y.restricted)}else{const y=h[_],M=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&v.push(_),!f.exclude?.includes(_)&&(f.include?.includes(_)||(M===void 0||f.scopes===void 0||f.scopes.includes(M))&&!(f.skipRestricted&&y?.restricted))?O[_]=l[_]:C=!0}return{raw:O,restricted:v,hasExcludedProperties:C}}toOverrides(l,h){const b=[];for(const f of Object.keys(l))if(I.OVERRIDE_PROPERTY_REGEX.test(f)){const C={};for(const O in l[f])C[O]=l[f][O];b.push({identifiers:(0,I.overrideIdentifiersFromKey)(f),keys:Object.keys(C),contents:(0,A.toValuesTree)(C,h)})}return b}}e.ConfigurationModelParser=n;class o extends R.Disposable{constructor(l,h,b,f){super(),this.userSettingsResource=l,this.parseOptions=h,this.fileService=f,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new n(this.userSettingsResource.toString()),this._register(this.fileService.watch(b.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.any(F.Event.filter(this.fileService.onDidFilesChange,C=>C.contains(this.userSettingsResource)),F.Event.filter(this.fileService.onDidRunOperation,C=>(C.isOperation(0)||C.isOperation(3)||C.isOperation(1)||C.isOperation(4))&&b.isEqual(C.resource,l)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const l=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(l.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(l){return l&&(this.parseOptions=l),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class t{constructor(l,h,b,f,C,O,v,_,y,M,V,$,L){this.key=l,this.overrides=h,this._value=b,this.overrideIdentifiers=f,this.defaultConfiguration=C,this.policyConfiguration=O,this.applicationConfiguration=v,this.userConfiguration=_,this.localUserConfiguration=y,this.remoteUserConfiguration=M,this.workspaceConfiguration=V,this.folderConfigurationModel=$,this.memoryConfigurationModel=L}get value(){return p(this._value)}inspect(l,h,b){const f=l.inspect(h,b);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.inspect(this.defaultConfiguration,this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.inspect(this.policyConfiguration,this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.inspect(this.applicationConfiguration,this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.inspect(this.userConfiguration,this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.inspect(this.localUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.inspect(this.remoteUserConfiguration,this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.inspect(this.workspaceConfiguration,this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.inspect(this.folderConfigurationModel,this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.inspect(this.memoryConfigurationModel,this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class r{constructor(l,h,b,f,C=new E,O=new E,v=new T.ResourceMap,_=new E,y=new T.ResourceMap){this._defaultConfiguration=l,this._policyConfiguration=h,this._applicationConfiguration=b,this._localUserConfiguration=f,this._remoteUserConfiguration=C,this._workspaceConfiguration=O,this._folderConfigurations=v,this._memoryConfiguration=_,this._memoryConfigurationByResource=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(l,h,b){return this.getConsolidatedConfigurationModel(l,h,b).getValue(l)}updateValue(l,h,b={}){let f;b.resource?(f=this._memoryConfigurationByResource.get(b.resource),f||(f=new E,this._memoryConfigurationByResource.set(b.resource,f))):f=this._memoryConfiguration,h===void 0?f.removeValue(l):f.setValue(l,h),b.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(l,h,b){const f=this.getConsolidatedConfigurationModel(l,h,b),C=this.getFolderConfigurationModelForResource(h.resource,b),O=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,v=new Set;for(const _ of f.overrides)for(const y of _.identifiers)f.getOverrideValue(l,y)!==void 0&&v.add(y);return new t(l,h,f.getValue(l),v.size?[...v]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this._workspaceConfiguration:void 0,C||void 0,O)}keys(l){const h=this.getFolderConfigurationModelForResource(void 0,l);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(l){this._defaultConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(l){this._policyConfiguration=l}updateApplicationConfiguration(l){this._applicationConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(l){this._localUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(l){this._remoteUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(l){this._workspaceConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(l,h){this._folderConfigurations.set(l,h),this._foldersConsolidatedConfigurations.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this._foldersConsolidatedConfigurations.delete(l)}compareAndUpdateDefaultConfiguration(l,h){const b=[];if(!h){const{added:f,updated:C,removed:O}=d(this._defaultConfiguration,l);h=[...f,...C,...O]}for(const f of h)for(const C of(0,I.overrideIdentifiersFromKey)(f)){const O=this._defaultConfiguration.getKeysForOverrideIdentifier(C),v=l.getKeysForOverrideIdentifier(C),_=[...v.filter(y=>O.indexOf(y)===-1),...O.filter(y=>v.indexOf(y)===-1),...O.filter(y=>!g.equals(this._defaultConfiguration.override(C).getValue(y),l.override(C).getValue(y)))];b.push([C,_])}return this.updateDefaultConfiguration(l),{keys:h,overrides:b}}compareAndUpdatePolicyConfiguration(l){const{added:h,updated:b,removed:f}=d(this._policyConfiguration,l),C=[...h,...b,...f];return C.length&&this.updatePolicyConfiguration(l),{keys:C,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:h,updated:b,removed:f,overrides:C}=d(this.applicationConfiguration,l),O=[...h,...b,...f];return O.length&&this.updateApplicationConfiguration(l),{keys:O,overrides:C}}compareAndUpdateLocalUserConfiguration(l){const{added:h,updated:b,removed:f,overrides:C}=d(this.localUserConfiguration,l),O=[...h,...b,...f];return O.length&&this.updateLocalUserConfiguration(l),{keys:O,overrides:C}}compareAndUpdateRemoteUserConfiguration(l){const{added:h,updated:b,removed:f,overrides:C}=d(this.remoteUserConfiguration,l),O=[...h,...b,...f];return O.length&&this.updateRemoteUserConfiguration(l),{keys:O,overrides:C}}compareAndUpdateWorkspaceConfiguration(l){const{added:h,updated:b,removed:f,overrides:C}=d(this.workspaceConfiguration,l),O=[...h,...b,...f];return O.length&&this.updateWorkspaceConfiguration(l),{keys:O,overrides:C}}compareAndUpdateFolderConfiguration(l,h){const b=this.folderConfigurations.get(l),{added:f,updated:C,removed:O,overrides:v}=d(b,h),_=[...f,...C,...O];return(_.length||!b)&&this.updateFolderConfiguration(l,h),{keys:_,overrides:v}}compareAndDeleteFolderConfiguration(l){const h=this.folderConfigurations.get(l);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:b,updated:f,removed:C,overrides:O}=d(h,void 0);return{keys:[...b,...f,...C],overrides:O}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(l,h,b){let f=this.getConsolidatedConfigurationModelForResource(h,b);return h.overrideIdentifier&&(f=f.override(h.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(l)!==void 0&&(f=f.merge(this._policyConfiguration)),f}getConsolidatedConfigurationModelForResource({resource:l},h){let b=this.getWorkspaceConsolidatedConfiguration();if(h&&l){const f=h.getFolder(l);f&&(b=this.getFolderConsolidatedConfiguration(f.uri)||b);const C=this._memoryConfigurationByResource.get(l);C&&(b=b.merge(C))}return b}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(l){let h=this._foldersConsolidatedConfigurations.get(l);if(!h){const b=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(l);f?(h=b.merge(f),this._foldersConsolidatedConfigurations.set(l,h)):h=b}return h}getFolderConfigurationModelForResource(l,h){if(h&&l){const b=h.getFolder(l);if(b)return this._folderConfigurations.get(b.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((l,h)=>{const{contents:b,overrides:f,keys:C}=this._folderConfigurations.get(h);return l.push([h,{contents:b,overrides:f,keys:C}]),l},[])}}allKeys(){const l=new Set;return this._defaultConfiguration.keys.forEach(h=>l.add(h)),this.userConfiguration.keys.forEach(h=>l.add(h)),this._workspaceConfiguration.keys.forEach(h=>l.add(h)),this._folderConfigurations.forEach(h=>h.keys.forEach(b=>l.add(b))),[...l.values()]}allOverrideIdentifiers(){const l=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(h=>l.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>l.add(h)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(h=>l.add(h)),this._folderConfigurations.forEach(h=>h.getAllOverrideIdentifiers().forEach(b=>l.add(b))),[...l.values()]}getAllKeysForOverrideIdentifier(l){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(l).forEach(b=>h.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(b=>h.add(b)),this._workspaceConfiguration.getKeysForOverrideIdentifier(l).forEach(b=>h.add(b)),this._folderConfigurations.forEach(b=>b.getKeysForOverrideIdentifier(l).forEach(f=>h.add(f))),[...h.values()]}static parse(l){const h=this.parseConfigurationModel(l.defaults),b=this.parseConfigurationModel(l.policy),f=this.parseConfigurationModel(l.application),C=this.parseConfigurationModel(l.user),O=this.parseConfigurationModel(l.workspace),v=l.folders.reduce((_,y)=>(_.set(w.URI.revive(y[0]),this.parseConfigurationModel(y[1])),_),new T.ResourceMap);return new r(h,b,f,C,new E,O,v,new E,new T.ResourceMap)}static parseConfigurationModel(l){return new E(l.contents,l.keys,l.overrides)}}e.Configuration=r;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const l=new Set,h=new Map;for(const f of s)f.keys.forEach(C=>l.add(C)),f.overrides.forEach(([C,O])=>{const v=(0,T.getOrSet)(h,C,new Set);O.forEach(_=>v.add(_))});const b=[];return h.forEach((f,C)=>b.push([C,[...f.values()]])),{keys:[...l.values()],overrides:b}}e.mergeChanges=a;class c{constructor(l,h,b,f){this.change=l,this.previous=h,this.currentConfiguraiton=b,this.currentWorkspace=f,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const C of l.keys)this.affectedKeys.add(C);for(const[,C]of l.overrides)for(const O of C)this.affectedKeys.add(O);this._affectsConfigStr=this._marker;for(const C of this.affectedKeys)this._affectsConfigStr+=C+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=r.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(l,h){const b=this._marker+l,f=this._affectsConfigStr.indexOf(b);if(f<0)return!1;const C=f+b.length;if(C>=this._affectsConfigStr.length)return!1;const O=this._affectsConfigStr.charCodeAt(C);if(O!==this._markerCode1&&O!==this._markerCode2)return!1;if(h){const v=this.previousConfiguration?this.previousConfiguration.getValue(l,h,this.previous?.workspace):void 0,_=this.currentConfiguraiton.getValue(l,h,this.currentWorkspace);return!g.equals(v,_)}return!0}}e.ConfigurationChangeEvent=c;function d(s,l){const{added:h,removed:b,updated:f}=i(l?.rawConfiguration,s?.rawConfiguration),C=[],O=s?.getAllOverrideIdentifiers()||[],v=l?.getAllOverrideIdentifiers()||[];if(l){const _=v.filter(y=>!O.includes(y));for(const y of _)C.push([y,l.getKeysForOverrideIdentifier(y)])}if(s){const _=O.filter(y=>!v.includes(y));for(const y of _)C.push([y,s.getKeysForOverrideIdentifier(y)])}if(l&&s){for(const _ of O)if(v.includes(_)){const y=i({contents:s.getOverrideValue(void 0,_)||{},keys:s.getKeysForOverrideIdentifier(_)},{contents:l.getOverrideValue(void 0,_)||{},keys:l.getKeysForOverrideIdentifier(_)});C.push([_,[...y.added,...y.removed,...y.updated]])}}return{added:h,removed:b,updated:f,overrides:C}}function i(s,l){const h=s?l?s.keys.filter(C=>l.keys.indexOf(C)===-1):[...s.keys]:[],b=l?s?l.keys.filter(C=>s.keys.indexOf(C)===-1):[...l.keys]:[],f=[];if(s&&l){for(const C of l.keys)if(s.keys.indexOf(C)!==-1){const O=(0,A.getConfigurationValue)(l.contents,C),v=(0,A.getConfigurationValue)(s.contents,C);g.equals(O,v)||f.push(C)}}return{added:h,removed:b,updated:f}}}),define(Pe[100],Te([1,0,11,4]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,F.createDecorator)("remoteAuthorityResolverService");var D;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=R;class T{constructor(I,u){this.host=I,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=T;var g;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class m extends S.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof m&&I._code===g.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof m&&I._code===g.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof m&&I._code===g.NoResolverFound}static isInvalidAuthority(I){return I instanceof m&&I._code===g.InvalidAuthority}static isHandled(I){return I instanceof m&&I.isHandled}constructor(I,u=g.Unknown,p){super(I),this._message=I,this._code=u,this._detail=p,this.isHandled=u===g.NotAvailable&&p===!0,Object.setPrototypeOf(this,m.prototype)}}e.RemoteAuthorityResolverError=m;function w(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}e.getRemoteAuthorityPrefix=w}),define(Pe[55],Te([1,0,13]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function F(w){return w.scheme===S.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=F;function D(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.getRemoteName=D;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=R;function T(w){const{host:A,port:I}=m(w);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:I}}e.parseAuthorityWithPort=T;function g(w,A){let{host:I,port:u}=m(w);return typeof u>"u"&&(u=A),{host:I,port:u}}e.parseAuthorityWithOptionalPort=g;function m(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const I=w.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const u=w.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:w,port:void 0}}}),define(Pe[22],Te([1,0,12,4,55]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T||(e.ExtensionType=T={}));var g;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.LINUX_PPC64LE="linux-ppc64le",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class m{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const r=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return S.equalsIgnoreCase(r,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.ExtensionIdentifier=m;class w{get size(){return this._set.size}constructor(o){if(this._set=new Set,o)for(const t of o)this.add(t)}add(o){this._set.add(m.toKey(o))}delete(o){return this._set.delete(m.toKey(o))}has(o){return this._set.has(m.toKey(o))}}e.ExtensionIdentifierSet=w;class A{constructor(){this._map=new Map}clear(){this._map.clear()}delete(o){this._map.delete(m.toKey(o))}get(o){return this._map.get(m.toKey(o))}has(o){return this._map.has(m.toKey(o))}set(o,t){this._map.set(m.toKey(o),t)}values(){return this._map.values()}forEach(o){this._map.forEach(o)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=A;function I(n){return u(n)}e.isApplicationScopedExtension=I;function u(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=u;function p(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function E(n,o){if(o){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(o)}`;return!!n.activationEvents?.includes(t)}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[101],Te([1,0,11,22]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this._generators=new Map,this._cache=new WeakMap}register(T,g){this._generators.set(T,g)}readActivationEvents(T){return this._cache.has(T)||this._cache.set(T,this._readActivationEvents(T)),this._cache.get(T)}createActivationEventsMap(T){const g=Object.create(null);for(const m of T){const w=this.readActivationEvents(m);w.length>0&&(g[F.ExtensionIdentifier.toKey(m.identifier)]=w)}return g}_readActivationEvents(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const g=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let m=0;m<g.length;m++)g[m]==="onUri"&&(g[m]=`onUri:${F.ExtensionIdentifier.toKey(T.identifier)}`);if(!T.contributes)return g;for(const m in T.contributes){const w=this._generators.get(m);if(!w)continue;const A=T.contributes[m],I=Array.isArray(A)?A:[A];try{w(I,g)}catch(u){(0,S.onUnexpectedError)(u)}}return g}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Pe[191],Te([1,0,21,74,33]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function R(m){if(S.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function T(m,w,A,I,u,p,E,n,o){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=E,t.sessionID=(0,D.generateUuid)()+Date.now(),t.commitHash=I,t.version=u,t["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,S.PlatformToString)(S.platform),t["common.nodePlatform"]=F.platform,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",n&&(t["common.msftInternal"]=n);let r=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),S.isLinuxSnap&&(t["common.snap"]="true");const c=R(w);return c&&(t["common.platformDetail"]=c),t}e.resolveCommonProperties=T;function g(m){const w=F.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return m.some(I=>A===I)}e.verifyMicrosoftInternalDomain=g}),define(Pe[192],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var F;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var D;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(Pe[56],Te([1,0,26,16,5,41,55,191,192]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class w{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class I{async publicLog(b,f,C){}async publicLogError(b,f,C){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(h,b){return D.Event.debounce(b.onDidChangeConfiguration,(C,O)=>{const v=C?new Set([...C.affectedKeys,...O.affectedKeys]):O.affectedKeys;return{...O,affectedKeys:v}},1e3,!0)(C=>{C.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(C.source),configurationKeys:Array.from(C.affectedKeys)})})}e.configurationTelemetry=u;function p(h,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!h.enableTelemetry)}e.supportsTelemetry=p;function E(h,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.isLoggingOnly=E;function n(h){const b=h.getValue(m.TELEMETRY_SETTING_ID),f=h.getValue(m.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(h.getValue(m.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=n;function o(h){const b={},f={},C={};a(h,C);for(let O in C){O=O.length>150?O.substr(O.length-149):O;const v=C[O];typeof v=="number"?f[O]=v:typeof v=="boolean"?f[O]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${O} has been trimmed to 8192, the original length is ${v.length}`),b[O]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(b[O]=v)}return{properties:b,measurements:f}}e.validateTelemetryData=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(h){if(!h)return"none";const b=(0,T.getRemoteName)(h);return t.has(b)?b:"other"}e.cleanRemoteAuthority=r;function a(h,b,f=0,C){if(h)for(const O of Object.getOwnPropertyNames(h)){const v=h[O],_=C?C+O:O;Array.isArray(v)?b[_]=(0,S.safeStringify)(v):v instanceof Date?b[_]=v.toISOString():(0,F.isObject)(v)?f<2?a(v,b,f+1,_+"."):b[_]=(0,S.safeStringify)(v):b[_]=v}}function c(h,b){const f=h.msftInternalDomains||[],C=b.getValue("telemetry.internalTesting");return(0,g.verifyMicrosoftInternalDomain)(f)||C}e.isInternalTelemetry=c;function d(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=d;function i(h,b){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let f=h;const C=[];for(const y of b)for(;;){const M=y.exec(h);if(!M)break;C.push([M.index,y.lastIndex])}const O=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let _=0;for(f="";;){const y=v.exec(h);if(!y)break;const M=C.some(([V,$])=>y.index<$&&V<v.lastIndex);!O.test(y[0])&&!M&&(f+=h.substring(_,y.index)+"<REDACTED: user-file-path>",_=v.lastIndex)}return _<h.length&&(f+=h.substr(_)),f}function s(h){if(!h)return h;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of b)if(f.regex.test(h))return`<REDACTED: ${f.label}>`;return h}function l(h,b){return(0,S.cloneAndChange)(h,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let C=f.replaceAll("%20"," ");C=i(C,b);for(const O of b)C=C.replace(O,"");return C=s(C),C}})}e.cleanData=l}),define(Pe[193],Te([1,0,12,97,22,21,2,11,74,56]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(l,h){return l.uuid&&h.uuid?l.uuid===h.uuid:l.id===h.id?!0:(0,S.compareIgnoreCase)(l.id,h.id)===0}e.areSameExtensions=A;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(h){const b=h.manifest?h.manifest.version:h.version,f=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new u(h.identifier,b,f)}static parse(h){const b=I.exec(h);return b&&b[1]&&b[2]?new u({id:b[1]},b[2],b[4]||void 0):null}constructor(h,b,f="undefined"){this.version=b,this.targetPlatform=f,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof u?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.ExtensionKey=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(l){const h=p.exec(l);return h&&h[1]?[o(h[1]),h[2]]:[o(l),void 0]}e.getIdAndVersion=E;function n(l,h){return`${l}.${h}`}e.getExtensionId=n;function o(l){return l.toLowerCase()}e.adoptToGalleryExtensionId=o;function t(l,h){return o(n(l??D.UNDEFINED_PUBLISHER,h))}e.getGalleryExtensionId=t;function r(l,h){const b=[],f=C=>{for(const O of b)if(O.some(v=>A(h(v),h(C))))return O;return null};for(const C of l){const O=f(C);O?O.push(C):b.push([C])}return b}e.groupByExtension=r;function a(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=a;function c(l){return{id:new w.TelemetryTrustedValue(l.identifier.id),name:new w.TelemetryTrustedValue(l.name),galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),isSigned:l.isSigned,...l.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function d(l,h){const b=[],f=h.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const C=f.shift();if(C&&b.every(O=>!A(O.identifier,{id:C}))){const O=l.filter(v=>A(v.identifier,{id:C}));O.length===1&&(b.push(O[0]),f.push(...O[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=d;async function i(l,h){if(!R.isLinux)return!1;let b;try{b=(await l.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await l.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(C){h.debug("Error while getting the os-release file.",(0,g.getErrorMessage)(C))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(l,h){const b=await i(l,h),f=(0,F.getTargetPlatform)(b?"alpine":R.platform,m.arch);return h.debug("ComputeTargetPlatform:",f),f}e.computeTargetPlatform=s}),define(Pe[194],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function S(m){return[...m.entries()]}e.serializeEnvironmentVariableCollection=S;function F(m){return m?[...m.entries()]:[]}e.serializeEnvironmentDescriptionMap=F;function D(m){return new Map(m)}e.deserializeEnvironmentVariableCollection=D;function R(m){return new Map(m??[])}e.deserializeEnvironmentDescriptionMap=R;function T(m){return Array.from(m.entries()).map(w=>[w[0],S(w[1].map),F(w[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function g(m){return new Map(m.map(w=>[w[0],{map:D(w[1]),descriptionMap:R(w[2])}]))}e.deserializeEnvironmentVariableCollections=g}),define(Pe[195],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class S{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,R,T=5){const g=R(m=>{const w=typeof m=="string"?m:m.data;let A=this._terminalBufferMap.get(D);if(A){A.data.push(w);return}const I=setTimeout(()=>this.flushBuffer(D),T);A={data:[w],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),g.dispose()}},this._terminalBufferMap.set(D,A)});return g}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const R=this._terminalBufferMap.get(D);R&&(this._terminalBufferMap.delete(D),this._callback(D,R.data.join("")))}}e.TerminalDataBufferer=S}),define(Pe[196],Te([1,0,14,90,45,5,16,2,155,73,30]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var I;(function(c){function d(i,s){let l=i.defaults;for(;D.ThemeIcon.isThemeIcon(l);){const h=E.getIcon(l.id);if(!h)return;l=h.defaults}return l}c.getDefinition=d})(I||(e.IconContribution=I={}));var u;(function(c){function d(s){return{weight:s.weight,style:s.style,src:s.src.map(l=>({format:l.format,location:l.location.toString()}))}}c.toJSONObject=d;function i(s){const l=h=>(0,T.isString)(h)?h:void 0;if(s&&Array.isArray(s.src)&&s.src.every(h=>(0,T.isString)(h.format)&&(0,T.isString)(h.location)))return{weight:l(s.weight),style:l(s.style),src:s.src.map(h=>({format:h.format,location:g.URI.parse(h.location)}))}}c.fromJSONObject=i})(u||(e.IconFontDefinition=u={}));class p{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(d,i,s,l){const h=this.iconsById[d];if(h){if(s&&!h.description){h.description=s,this.iconSchema.properties[d].markdownDescription=`${s} $(${d})`;const C=this.iconReferenceSchema.enum.indexOf(d);C!==-1&&(this.iconReferenceSchema.enumDescriptions[C]=s),this._onDidChange.fire()}return h}const b={id:d,description:s,defaults:i,deprecationMessage:l};this.iconsById[d]=b;const f={$ref:"#/definitions/icons"};return l&&(f.deprecationMessage=l),s&&(f.markdownDescription=`${s}: $(${d})`),this.iconSchema.properties[d]=f,this.iconReferenceSchema.enum.push(d),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:d}}deregisterIcon(d){delete this.iconsById[d],delete this.iconSchema.properties[d];const i=this.iconReferenceSchema.enum.indexOf(d);i!==-1&&(this.iconReferenceSchema.enum.splice(i,1),this.iconReferenceSchema.enumDescriptions.splice(i,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(d=>this.iconsById[d])}getIcon(d){return this.iconsById[d]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(d,i){const s=this.iconFontsById[d];return s||(this.iconFontsById[d]=i,this._onDidChange.fire(),i)}deregisterIconFont(d){delete this.iconFontsById[d]}getIconFont(d){return this.iconFontsById[d]}toString(){const d=(h,b)=>h.id.localeCompare(b.id),i=h=>{for(;D.ThemeIcon.isThemeIcon(h.defaults);)h=this.iconsById[h.defaults.id];return`codicon codicon-${h?h.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(h=>this.iconsById[h]);for(const h of l.filter(b=>!!b.description).sort(d))s.push(`|<i class="${i(h)}"></i>|${h.id}|${D.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const h of l.filter(b=>!D.ThemeIcon.isThemeIcon(b.defaults)).sort(d))s.push(`|<i class="${i(h)}"></i>|${h.id}|`);return s.join(`
`)}}const E=new p;A.Registry.add(e.Extensions.IconContribution,E);function n(c,d,i,s){return E.registerIcon(c,d,i,s)}e.registerIcon=n;function o(){return E}e.getIconRegistry=o;function t(){const c=(0,F.getCodiconFontCharacters)();for(const d in c){const i="\\"+c[d].toString(16);E.registerIcon(d,{fontCharacter:i})}}t(),e.iconsSchemaId="vscode://schemas/icons";const r=A.Registry.as(w.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,E.getIconSchema());const a=new S.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);E.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=n("widget-close",F.Codicon.close,(0,m.localize)(2,null)),e.gotoPreviousLocation=n("goto-previous-location",F.Codicon.arrowUp,(0,m.localize)(3,null)),e.gotoNextLocation=n("goto-next-location",F.Codicon.arrowDown,(0,m.localize)(4,null)),e.syncing=D.ThemeIcon.modify(F.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(F.Codicon.loading,"spin")}),define(Pe[197],Te([1,0,5,41,4,15]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.isTunnelProvider=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var T;(function(o){o.Http="http",o.Https="https"})(T||(e.TunnelProtocol=T={}));var g;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(g||(e.TunnelPrivacyId=g={}));function m(o){return!!o.forwardPort}e.isTunnelProvider=m;var w;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=u;function p(o,t,r,a){if(r===1)return!1;if(r===2&&u(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.isPortPrivileged=p;class E{constructor(t,r,a){this.remoteAddress=t,this.localAddress=r,this._dispose=a,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let n=class{constructor(t,r){this.logService=t,this.configurationService=r,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const t=this.configurationService.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this._tunnelProvider=t,t?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this._canElevate=t.elevation,this._privacyOptions=t.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const t=[],r=Array.from(this._tunnels.values());for(const a of r){const c=Array.from(a.values());for(const d of c){const i=await d.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this._tunnels.values()){for(const{value:r}of t.values())await r.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this._tunnels.clear()}setEnvironmentTunnel(t,r,a,c,d){this.addTunnelToMap(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:a,privacy:c,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(u(t)||I(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const a=this.getTunnelFromMap(t,r);if(a)return++a.refcount,a.value}openTunnel(t,r,a,c,d,i=!1,s,l){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${a} on local port ${d}.`);const h=this._tunnelProvider??t;if(!h)return;if(r||(r="localhost"),c||(c=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(a)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.retainOrCreateTunnel(h,r,a,c,d,i,s,l);return b?b.then(f=>{if(f){if(typeof f=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(r,a),f}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(r,a);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.makeTunnel(f);return(f.tunnelRemoteHost!==r||f.tunnelRemotePort!==a)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(C),C}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}makeTunnel(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this._tunnels.get(t.tunnelRemoteHost);if(r){const a=r.get(t.tunnelRemotePort);a&&(a.refcount--,await this.tryDisposeTunnel(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async tryDisposeTunnel(t,r,a){if(a.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const c=a.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(t)&&this._tunnels.get(t).delete(r),c}}async closeTunnel(t,r){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const a=this._tunnels.get(t);if(a&&a.has(r)){const c=a.get(r);c.refcount=0,await this.tryDisposeTunnel(t,r,c)}}addTunnelToMap(t,r,a){this._tunnels.has(t)||this._tunnels.set(t,new Map),this._tunnels.get(t).set(r,{refcount:1,value:a})}async removeEmptyOrErrorTunnelFromMap(t,r){const a=this._tunnels.get(t);if(a){const c=a.get(r),d=c?await c.value:void 0;(!d||typeof d=="string")&&a.delete(r),a.size===0&&this._tunnels.delete(t)}}getTunnelFromMap(t,r){const a=[t];I(t)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):u(t)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const c=a.map(d=>this._tunnels.get(d));for(const d of c){const i=d?.get(r);if(i)return i}}canTunnel(t){return!!A(t)}createWithProvider(t,r,a,c,d,i,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${a} on local port ${c}.`);const l=a;this._factoryInProgress.add(l);const h=c===void 0?a:c,b={elevationRequired:d?this.isPortPrivileged(h):!1},f={remoteAddress:{host:r,port:a},localAddressPort:c,privacy:i,public:i?i!==g.Private:void 0,protocol:s},C=t.forwardPort(f,b);return C?(this.addTunnelToMap(r,a,C),C.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),C}};e.AbstractTunnelService=n,e.AbstractTunnelService=n=je([Ve(0,R.ILogService),Ve(1,F.IConfigurationService)],n)}),define(Pe[198],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,S.createDecorator)("editSessionIdentityService");var F;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Pe[199],Te([1,0,13]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function F(m){return m.scheme!==S.Schemas.file&&m.scheme!==S.Schemas.vscodeRemote}e.isVirtualResource=F;function D(m){if(m.folders.length)return m.folders.every(w=>F(w.uri))?m.folders[0].uri:void 0;if(m.configuration&&F(m.configuration))return m.configuration}e.getVirtualWorkspaceLocation=D;function R(m){return D(m)?.scheme}e.getVirtualWorkspaceScheme=R;function T(m){return D(m)?.authority}e.getVirtualWorkspaceAuthority=T;function g(m){return D(m)!==void 0}e.isVirtualWorkspace=g}),define(Pe[47],Te([1,0,156,19,50,25,2,4,13]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,g.createDecorator)("contextService");function w(h){const b=h;return typeof b?.id=="string"&&T.URI.isUri(b.uri)}e.isSingleFolderWorkspaceIdentifier=w;function A(h){return typeof h?.id=="string"&&!w(h)&&!u(h)}e.isEmptyWorkspaceIdentifier=A,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(h,b){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,F.basename)(h)}:b?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const f=h;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.toWorkspaceIdentifier=I;function u(h){const b=h;return typeof b?.id=="string"&&T.URI.isUri(b.configPath)}e.isWorkspaceIdentifier=u;function p(h){const b=h;if(b?.uri)return{id:b.id,uri:T.URI.revive(b.uri)};const f=h;if(f?.configPath)return{id:f.id,configPath:T.URI.revive(f.configPath)};if(h?.id)return{id:h.id}}e.reviveIdentifier=p;var E;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function n(h){const b=h;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=n;function o(h){const b=h;return!!(b&&typeof b=="object"&&T.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=o;class t{constructor(b,f,C,O,v){this._id=b,this._transient=C,this._configuration=O,this._ignorePathCasing=v,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=f}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=t;class r{constructor(b,f){this.raw=f,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,R.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function a(h){return new r({uri:h,index:0,name:(0,R.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=a,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(h,b){return R.extUriBiasedIgnorePathCase.isEqualOrParent(h,b.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function d(h){let b;return T.URI.isUri(h)?b=h:b=h.configuration,b?.scheme===m.Schemas.tmp}e.isTemporaryWorkspace=d,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(h){return h.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function s(h,b){return!c(h,b)&&!d(h)}e.isSavedWorkspace=s;function l(h){return(typeof h=="string"?(0,F.extname)(h):(0,R.extname)(h))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=l}),define(Pe[75],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class S{static{this.enableDebugLogging=!1}constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const R=this._idPool++;return this._data.set(R,D),this.logDebugInfo(),R}get(D,R){return this._data.has(D)?this._data.get(D)[R]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){S.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=S}),define(Pe[43],Te([1,0,13,25,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(S.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(g=>{const m=this._providerInfo.get(g.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(g,m){m===null?this._providerInfo.delete(g.scheme):this._providerInfo.set(g.scheme,m)}isFreeScheme(g){return!this._providerInfo.has(g)&&!this._systemSchemes.has(g)}getCapabilities(g){return this._providerInfo.get(g)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,S.createDecorator)("IExtHostInitDataService")}),define(Pe[200],Te([1,0,161,15,187,27]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends D.LogService{constructor(m,w,A){const I=A.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",u=A.remote.isRemote?(0,S.localize)(0,null):m?(0,S.localize)(1,null):(0,S.localize)(2,null);super(w.createLogger(I,{name:u}))}};e.ExtHostLogService=T,e.ExtHostLogService=T=je([Ve(1,F.ILoggerService),Ve(2,R.IExtHostInitDataService)],T)}),define(Pe[201],Te([1,0,14]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(T,g,m){this._deferredPromises=new Map,this._id=T,this._shared=g,this._storage=m,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(w=>(this._value=w,this)),this._storageListener=this._storage.onDidChangeStorage(w=>{w.shared===this._shared&&w.key===this._id&&(this._value=w.value)}),this._scheduler=new S.RunOnceScheduler(()=>{const w=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of w.values())A.complete()}catch(A){for(const I of w.values())I.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,g){let m=this._value[T];return typeof m>"u"&&(m=g),m}update(T,g){this._value[T]=g;const m=this._deferredPromises.get(T);if(m!==void 0)return m.p;const w=new S.DeferredPromise;return this._deferredPromises.set(T,w),this._scheduler.isScheduled()||this._scheduler.schedule(),w.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class D extends F{setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}constructor(T,g){super(T.identifier.value,!0,g),this._extension=T}}e.ExtensionGlobalMemento=D}),define(Pe[202],Te([1,0,5,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new S.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,g,m,w){const I=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T)).acceptModelChanged(g.value,m,w);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(T,g){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T)).acceptDirty(g)}$acceptModelSaved(T){const g=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(T));this._onDidSaveNotebookDocument.fire(g.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Pe[17],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class F{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=F}),define(Pe[203],Te([1,0,22,5]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class D{#e;constructor(T,g){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=S.ExtensionIdentifier.toKey(T.identifier),this.#e=g,this.#e.onDidChangePassword(m=>{m.extensionId===this._id&&this._onDidChange.fire({key:m.key})})}get(T){return this.#e.get(this._id,T)}store(T,g){return this.#e.store(this._id,T,g)}delete(T){return this.#e.delete(this._id,T)}}e.ExtensionSecrets=D}),define(Pe[57],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,S.createDecorator)("IURITransformerService");class F{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=F}),define(Pe[204],Te([1,0,24]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(m){let w=this.buffers.indexOf(m);return w<0&&(w=this.buffers.length,this.buffers.push(m)),w}}function D(g,m){if(m.serializeBuffersForPostMessage){const w=new F,I=JSON.stringify(g,(p,E)=>{if(E instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(E)};if(ArrayBuffer.isView(E)){const n=R(E);if(n)return{$$vscode_array_buffer_reference$$:!0,index:w.add(E.buffer),view:{type:n,byteLength:E.byteLength,byteOffset:E.byteOffset}}}return E}),u=w.buffers.map(p=>{const E=new Uint8Array(p);return S.VSBuffer.wrap(E)});return{message:I,buffers:u}}else return{message:JSON.stringify(g),buffers:[]}}e.serializeWebviewMessage=D;function R(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(g,m){const w=m.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),A=m.length?(u,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const E=p,{index:n}=E,o=w[n];if(E.view)switch(E.view.type){case 1:return new Int8Array(o,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse(g,A),arrayBuffers:w}}e.deserializeWebviewMessage=T}),define(Pe[102],Te([1,0,171,16,2,6,4,30,42,13,40,134,31]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.preventEditorClose=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffListEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var p;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var E;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(E||(e.EditorPaneSelectionCompareResult=E={}));function n(oe){const Y=oe;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.isEditorPaneWithSelection=n;function o(oe,Y,H){for(const ne of H.visibleEditorPanes)if(ne.group.id===Y&&oe.matches(ne.input))return ne.getViewState()}e.findViewStateForEditor=o;function t(oe){if(C(oe))return!1;const Y=oe;return D.URI.isUri(Y?.resource)}e.isResourceEditorInput=t;function r(oe){if(C(oe))return!1;const Y=oe;return Y?.original!==void 0&&Y.modified!==void 0}e.isResourceDiffEditorInput=r;function a(oe){if(C(oe))return!1;const Y=oe;return Array.isArray(Y?.resources)}e.isResourceDiffListEditorInput=a;function c(oe){if(C(oe)||r(oe))return!1;const Y=oe;return Y?.primary!==void 0&&Y.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function d(oe){if(C(oe))return!1;const Y=oe;return Y?Y.resource===void 0||Y.resource.scheme===w.Schemas.untitled||Y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;function i(oe){if(C(oe))return!1;const Y=oe;return D.URI.isUri(Y?.base?.resource)&&D.URI.isUri(Y?.input1?.resource)&&D.URI.isUri(Y?.input2?.resource)&&D.URI.isUri(Y?.result?.resource)}e.isResourceMergeEditorInput=i;var s;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var l;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class h{constructor(){this.mapIdToSaveSource=new Map}registerSource(Y,H){let ne=this.mapIdToSaveSource.get(Y);return ne||(ne={source:Y,label:H},this.mapIdToSaveSource.set(Y,ne)),ne.source}getSourceLabel(Y){return this.mapIdToSaveSource.get(Y)?.label??Y}}e.SaveSourceRegistry=new h;var b;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(b||(e.EditorInputCapabilities=b={}));class f extends R.Disposable{}e.AbstractEditorInput=f;function C(oe){return oe instanceof f}e.isEditorInput=C;function O(oe){const Y=oe;return D.URI.isUri(Y?.preferredResource)}function v(oe){const Y=oe;return C(Y?.primary)&&C(Y?.secondary)}e.isSideBySideEditorInput=v;function _(oe){const Y=oe;return C(Y?.modified)&&C(Y?.original)}e.isDiffEditorInput=_;function y(oe,Y,H,ne,De){return Ie(ne,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Re={...H,limits:{size:Number.MAX_VALUE}};oe.openEditor(Y,Re)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>De.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.createTooLargeFileError=y;function M(oe){return C(oe?.editor)}e.isEditorInputWithOptions=M;function V(oe){const Y=oe;return M(oe)&&Y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function $(oe){const Y=oe;return typeof Y?.groupId=="number"&&C(Y.editor)}e.isEditorIdentifier=$;var L;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(L||(e.EditorCloseContext=L={}));var U;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var k;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(k||(e.SideBySideEditor=k={}));class P{getOriginalUri(Y,H){if(!Y)return;if(i(Y))return e.EditorResourceAccessor.getOriginalUri(Y.result,H);if(H?.supportSideBySide){const{primary:De,secondary:Re}=this.getSideEditors(Y);if(De&&Re){if(H?.supportSideBySide===k.BOTH)return{primary:this.getOriginalUri(De,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(Re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===k.ANY)return this.getOriginalUri(De,{filterByScheme:H.filterByScheme})??this.getOriginalUri(Re,{filterByScheme:H.filterByScheme});Y=H.supportSideBySide===k.PRIMARY?De:Re}}if(r(Y)||a(Y)||c(Y)||i(Y))return;const ne=O(Y)?Y.preferredResource:Y.resource;return!ne||!H||!H.filterByScheme?ne:this.filterUri(ne,H.filterByScheme)}getSideEditors(Y){return v(Y)||c(Y)?{primary:Y.primary,secondary:Y.secondary}:_(Y)||r(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,H){if(!Y)return;if(i(Y))return e.EditorResourceAccessor.getCanonicalUri(Y.result,H);if(H?.supportSideBySide){const{primary:De,secondary:Re}=this.getSideEditors(Y);if(De&&Re){if(H?.supportSideBySide===k.BOTH)return{primary:this.getCanonicalUri(De,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(Re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===k.ANY)return this.getCanonicalUri(De,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(Re,{filterByScheme:H.filterByScheme});Y=H.supportSideBySide===k.PRIMARY?De:Re}}if(r(Y)||a(Y)||c(Y)||i(Y))return;const ne=Y.resource;return!ne||!H||!H.filterByScheme?ne:this.filterUri(ne,H.filterByScheme)}filterUri(Y,H){if(Array.isArray(H)){if(H.some(ne=>Y.scheme===ne))return Y}else if(H===Y.scheme)return Y}}var Q;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(Q||(e.EditorCloseMethod=Q={}));function ae(oe,Y,H,ne){if(!oe.isSticky(Y))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return H===Q.MOUSE||H===Q.KEYBOARD;case"mouse":return H===Q.MOUSE;case"keyboard":return H===Q.KEYBOARD}return!1}e.preventEditorClose=ae,e.EditorResourceAccessor=new P;var me;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class Ee{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Y){const H=this.instantiationService=Y.get(T.IInstantiationService);for(const[ne,De]of this.editorSerializerConstructors)this.createEditorSerializer(ne,De,H);this.editorSerializerConstructors.clear()}createEditorSerializer(Y,H,ne){const De=ne.createInstance(H);this.editorSerializerInstances.set(Y,De)}registerFileEditorFactory(Y){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Y}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Y,H){if(this.editorSerializerConstructors.has(Y)||this.editorSerializerInstances.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Y,H,this.instantiationService):this.editorSerializerConstructors.set(Y,H),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(Y),this.editorSerializerInstances.delete(Y)})}getEditorSerializer(Y){return this.editorSerializerInstances.get(typeof Y=="string"?Y:Y.typeId)}}g.Registry.add(e.EditorExtensions.EditorFactory,new Ee);async function Ce(oe,Y,H){return!oe||!oe.length?[]:await Promise.all(oe.map(async ne=>{const De=D.URI.revive(ne.fileUri);if(!De){H.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Y.canHandleResource(De)){H.info("Cannot resolve the path because it cannot be handled",ne);return}let ke=ne.exists,ce=ne.type;if(typeof ke!="boolean"||typeof ce!="number")try{ce=(await Y.stat(De)).isDirectory?m.FileType.Directory:m.FileType.Unknown,ke=!0}catch(G){H.error(G),ke=!1}if(!ke&&ne.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",ne);return}if(ce===m.FileType.Directory){H.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return ke?{resource:De,options:ie}:{resource:De,options:ie,forceUntitled:!0}}))}e.pathsToEditors=Ce;var he;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function de(oe){const Y=oe;if(!Y)return!1;const H=Y;if(H.modified)return de(H.modified);const ne=Y;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.isTextEditorViewState=de;function te(oe){return(0,A.isErrorWithActions)(oe)}e.isEditorOpenError=te;function Ie(oe,Y,H){const ne=(0,A.createErrorWithActions)(oe,Y);return ne.forceMessage=H?.forceMessage,ne.forceSeverity=H?.forceSeverity,ne.allowDialog=H?.allowDialog,ne}e.createEditorOpenError=Ie}),define(Pe[205],Te([1,0,5,172,4,6,28,30,18,26,90,196]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,F.localize)(0,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",A.Codicon.window,(0,F.localize)(1,null));var u;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.ViewContainerLocations=[0,1,2];function E(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;class n extends R.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new S.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new S.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,m.flatten)([...this.viewContainers.values()])}registerViewContainer(l,h,b){const f=this.get(l.id);if(f)return f;const C=l;return C.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,T.getOrSet)(this.viewContainers,h,[]).push(C),b?.isDefault&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:h}),C}deregisterViewContainer(l){for(const h of this.viewContainers.keys()){const b=this.viewContainers.get(h),f=b?.indexOf(l);if(f!==-1){b?.splice(f,1),b.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:h});return}}}get(l){return this.all.filter(h=>h.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===l)}}g.Registry.add(u.ViewContainersRegistry,new n);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(s,l){const h=s.group??o.More,b=l.group??o.More;return h!==b?h.localeCompare(b):(s.order??5)-(l.order??5)}class r extends R.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new S.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new S.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new S.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new S.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(l,h){this.registerViews2([{views:l,viewContainer:h}])}registerViews2(l){l.forEach(({views:h,viewContainer:b})=>this.addViews(h,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,h){const b=this.removeViews(l,h);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:h})}moveViews(l,h){for(const b of this._views.keys())if(b!==h){const f=this.removeViews(l,b);f.length&&(this.addViews(f,h),this._onDidChangeContainer.fire({views:f,from:b,to:h}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const h of this._viewContainers){const b=(this._views.get(h)||[]).filter(f=>f.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(f=>f.id===l)[0])return h;return null}registerViewWelcomeContent(l,h){return this._viewWelcomeContents.add(l,h),this._onDidChangeViewWelcomeContent.fire(l),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(l,h),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,h){const b=new Map;for(const[f,C]of h)this._viewWelcomeContents.add(l,C),b.set(f,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(l,C),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const h=[];return this._viewWelcomeContents.forEach(l,b=>h.push(b)),h.sort(t)}addViews(l,h){let b=this._views.get(h);b||(b=[],this._views.set(h,b),this._viewContainers.push(h));for(const f of l){if(this.getView(f.id)!==null)throw new Error((0,F.localize)(2,null,f.id));b.push(f)}}removeViews(l,h){const b=this._views.get(h);if(!b)return[];const f=[],C=[];for(const O of b)l.includes(O)?f.push(O):C.push(O);return f.length&&(C.length?this._views.set(h,C):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),f}}g.Registry.add(u.ViewsRegistry,new r),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var a;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class d{constructor(l,h){this.resolved=!1,this._hasResolve=!1,(0,w.mixin)(this,l),this._hasResolve=!!h,this.resolve=async b=>{if(h&&!this.resolved){const f=await h(b);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=d;class i extends Error{constructor(l){super((0,F.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.NoTreeViewError=i}),define(Pe[206],Te([1,0,2,29,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChatService=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.isIUsedContext=e.isIDocumentContext=void 0;function R(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof S.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(F.Range.isIRange)}e.isIDocumentContext=R;function T(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(R)}e.isIUsedContext=T;var g;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var m;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(m||(e.InteractiveSessionCopyKind=m={})),e.IChatService=(0,D.createDecorator)("IChatService")}),define(Pe[207],Te([1,0,5,14,173]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new S.Emitter,this._onExit=new S.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(g){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=g}onEvent(g){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=g}onRequest(g){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=g}sendResponse(g){g.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.internalSend("response",g)}sendRequest(g,m,w,A){const I={command:g};if(m&&Object.keys(m).length>0&&(I.arguments=m),this.internalSend("request",I),typeof A=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.pendingRequests.get(I.seq);if(p){this.pendingRequests.delete(I.seq);const E={type:"response",seq:0,request_seq:I.seq,success:!1,command:g,message:(0,D.localize)(0,null,A,g)};p(E)}},A)}return w&&this.pendingRequests.set(I.seq,w),I.seq}acceptMessage(g){this.messageCallback?this.messageCallback(g):(this.queue.push(g),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(g,m){return g.type!=="event"||m.type!=="event"}async processQueue(){let g;for(;this.queue.length;){if((!g||this.needsTaskBoundaryBetween(this.queue[0],g))&&await(0,F.timeout)(0),g=this.queue.shift(),!g)return;switch(g.type){case"event":this.eventCallback?.(g);break;case"request":this.requestCallback?.(g);break;case"response":{const m=g,w=this.pendingRequests.get(m.request_seq);w&&(this.pendingRequests.delete(m.request_seq),w(m));break}}}}internalSend(g,m){m.type=g,m.seq=this.sequence++,this.sendMessage(m)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const g=new Map;this.pendingRequests.forEach((m,w)=>g.set(w,m)),await(0,F.timeout)(500),g.forEach((m,w)=>{m({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(w)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(Pe[208],Te([1,0,174,35,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new F.RawContextKey("debugType",void 0,{type:"string",description:S.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new F.RawContextKey("debugConfigurationType",void 0,{type:"string",description:S.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new F.RawContextKey("debugState","inactive",{type:"string",description:S.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new F.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:S.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new F.RawContextKey("hasDebugged",!1,{type:"boolean",description:S.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new F.RawContextKey("inDebugMode",!1,{type:"boolean",description:S.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new F.RawContextKey("inDebugRepl",!1,{type:"boolean",description:S.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new F.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:S.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new F.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:S.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new F.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:S.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new F.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:S.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new F.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:S.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new F.RawContextKey("variablesFocused",!0,{type:"boolean",description:S.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new F.RawContextKey("expressionSelected",!1,{type:"boolean",description:S.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new F.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:S.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new F.RawContextKey("callStackItemType",void 0,{type:"string",description:S.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new F.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:S.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new F.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:S.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new F.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:S.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new F.RawContextKey("watchItemType",void 0,{type:"string",description:S.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new F.RawContextKey("canViewMemory",void 0,{type:"boolean",description:S.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new F.RawContextKey("breakpointItemType",void 0,{type:"string",description:S.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new F.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:S.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new F.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:S.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new F.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:S.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new F.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:S.localize(25,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new F.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:S.localize(26,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new F.RawContextKey("stepBackSupported",!1,{type:"boolean",description:S.localize(27,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new F.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:S.localize(28,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new F.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:S.localize(29,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new F.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:S.localize(30,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new F.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:S.localize(31,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new F.RawContextKey("breakpointsExist",!1,{type:"boolean",description:S.localize(32,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new F.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:S.localize(33,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new F.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:S.localize(34,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new F.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:S.localize(35,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new F.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:S.localize(36,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new F.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:S.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new F.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:S.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new F.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:S.localize(39,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new F.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:S.localize(40,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new F.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:S.localize(41,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new F.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:S.localize(42,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new F.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:S.localize(43,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new F.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:S.localize(44,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new F.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:S.localize(45,null)}),e.CONTEXT_MULTI_SESSION_REPL=new F.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:S.localize(46,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new F.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:S.localize(47,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new F.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:S.localize(48,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new F.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:S.localize(49,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new F.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:S.localize(50,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new F.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:S.localize(51,null)});const R=u=>S.localize(52,null,u);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:S.localize(53,null)};var T;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(T||(e.State=T={}));function g(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=g;var m;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(m||(e.MemoryRangeType=m={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var w;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var A;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.IDebugService=(0,D.createDecorator)("debugService");var I;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(Pe[209],Te([1,0,12,2,19,26,13,29,20,18]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function I(O,v,_){return O.replace(A,function(y,M){return v&&M.length>0&&M[0]!=="_"?y:_&&_.hasOwnProperty(M)?_[M]:y})}e.formatPII=I;function u(O){const v={};for(const _ of Object.keys(O))_.startsWith("!")||(v[_]=O[_]);return v}e.filterExceptionsFromTelemetry=u;function p(O){return O.configuration.request==="attach"&&!E(O)&&(!O.parentSession||p(O.parentSession))}e.isSessionAttach=p;function E(O){let v=O.configuration.type;if(v)return v==="vslsShare"&&(v=O.configuration.adapterProxy.configuration.type),(0,S.equalsIgnoreCase)(v,"extensionhost")||(0,S.equalsIgnoreCase)(v,"pwa-extensionhost")?O:O.parentSession?E(O.parentSession):void 0}e.getExtensionHostDebugSession=E;function n(O){return O.type&&(O.label||O.program||O.runtime)}e.isDebuggerMainContribution=n;function o(O,v,_){let y,M=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let $=null;for(;$=V.exec(O);){const L=$.index+1,U=L+$[0].length;if(L<=v&&U>=_){y=$[0],M=L;break}}if(y){const L=/\w+/g;let U=null;for(;(U=L.exec(y))&&!(U.index+1+M+U[0].length>=_););U&&(y=y.substring(0,L.lastIndex))}return y?{start:M,end:M+y.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=o;async function t(O,v,_,y){if(O.evaluatableExpressionProvider.has(v)){const M=O.evaluatableExpressionProvider.ordered(v),V=(0,w.coalesce)(await Promise.all(M.map(async $=>{try{return await $.provideEvaluatableExpression(v,_,y??m.CancellationToken.None)}catch{return}})));if(V.length>0){let $=V[0].expression;const L=V[0].range;return $||($=v.getLineContent(_.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:$}}}else{const M=v.getLineContent(_.lineNumber),{start:V,end:$}=o(M,_.column,_.column),L=M.substring(V-1,$);return{matchingExpression:L,range:new g.Range(_.lineNumber,V,_.lineNumber,V+L.length)}}return null}e.getEvaluatableExpressionAtPosition=t;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(O){return!!(O&&O.match(r))}e.isUri=a;function c(O){if(typeof O.path=="string"&&!(typeof O.sourceReference=="number"&&O.sourceReference>0)){if(a(O.path))return F.URI.parse(O.path);if((0,D.isAbsolute)(O.path))return F.URI.file(O.path)}return O.path}function d(O){if(typeof O.path=="object"){const v=F.URI.revive(O.path);if(v)return v.scheme===T.Schemas.file?v.fsPath:v.toString()}return O.path}function i(O,v){const _=v?c:d,y=(0,R.deepClone)(O);return l(y,(M,V)=>{M&&V&&(V.path=_(V))}),y}e.convertToDAPaths=i;function s(O,v){const _=v?c:d,y=(0,R.deepClone)(O);return l(y,(M,V)=>{!M&&V&&(V.path=_(V))}),y}e.convertToVSCPaths=s;function l(O,v){switch(O.type){case"event":{const _=O;switch(_.event){case"output":v(!1,_.body.source);break;case"loadedSource":v(!1,_.body.source);break;case"breakpoint":v(!1,_.body.breakpoint.source);break;default:break}break}case"request":{const _=O;switch(_.command){case"setBreakpoints":v(!0,_.arguments.source);break;case"breakpointLocations":v(!0,_.arguments.source);break;case"source":v(!0,_.arguments.source);break;case"gotoTargets":v(!0,_.arguments.source);break;case"launchVSCode":_.arguments.args.forEach(y=>v(!1,y));break;default:break}break}case"response":{const _=O;if(_.success&&_.body)switch(_.command){case"stackTrace":_.body.stackFrames.forEach(y=>v(!1,y.source));break;case"loadedSources":_.body.sources.forEach(y=>v(!1,y));break;case"scopes":_.body.scopes.forEach(y=>v(!1,y.source));break;case"setFunctionBreakpoints":_.body.breakpoints.forEach(y=>v(!1,y.source));break;case"setBreakpoints":_.body.breakpoints.forEach(y=>v(!1,y.source));break;case"disassemble":_.body?.instructions.forEach(M=>v(!1,M.location));break;default:break}break}}}function h(O){return O.filter(v=>!v.presentation?.hidden).sort((v,_)=>v.presentation?_.presentation?v.presentation.group?_.presentation.group?v.presentation.group!==_.presentation.group?v.presentation.group.localeCompare(_.presentation.group):b(v.presentation.order,_.presentation.order):-1:_.presentation.group?1:b(v.presentation.order,_.presentation.order):-1:_.presentation?1:0)}e.getVisibleAndSorted=h;function b(O,v){return typeof O!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:O-v}async function f(O,v){const _=O.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(_!=="none"&&(await v.saveAll(),_==="allEditorsInActiveGroup")){const y=v.activeEditorPane;y&&y.input.resource?.scheme===T.Schemas.untitled&&await v.save({editor:y.input,groupId:y.group.id})}await O.reloadConfiguration()}e.saveAllBeforeDebugStart=f;const C=(O,v)=>!O||!v?O===v:O.name===v.name&&O.path===v.path&&O.sourceReference===v.sourceReference;e.sourcesEqual=C}),define(Pe[76],Te([1,0,24,34,67,68,13,19,21,35]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var A;(function(P){P[P.Markup=1]="Markup",P[P.Code=2]="Code"})(A||(e.CellKind=A={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var u;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var p;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var E;(function(P){P[P.WithHardKernelDependency=0]="WithHardKernelDependency",P[P.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",P[P.Pure=2]="Pure",P[P.Never=3]="Never"})(E||(e.NotebookRendererMatch=E={}));var n;(function(P){P.Always="always",P.Never="never",P.Optional="optional"})(n||(e.RendererMessagingSpec=n={}));var o;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.ChangeCellLanguage=5]="ChangeCellLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",P[P.ChangeCellMime=13]="ChangeCellMime",P[P.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var r;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.Move=6]="Move",P[P.OutputItems=7]="OutputItems",P[P.PartialMetadata=8]="PartialMetadata",P[P.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var a;(function(P){P.scheme=T.Schemas.vscodeNotebookCell;const Q=["W","X","Y","Z","a","b","c","d","e","f"],ae=new RegExp(`^[${Q.join("")}]+`),me=7;function Ee(oe,Y){const H=Y.toString(me),De=`${H.length<Q.length?Q[H.length-1]:"z"}${H}s${(0,S.encodeBase64)(S.VSBuffer.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:P.scheme,fragment:De})}P.generate=Ee;function Ce(oe){if(oe.scheme!==P.scheme)return;const Y=oe.fragment.indexOf("s");if(Y<0)return;const H=parseInt(oe.fragment.substring(0,Y).replace(ae,""),me),ne=(0,S.decodeBase64)(oe.fragment.substring(Y+1)).toString();if(!isNaN(H))return{handle:H,notebook:oe.with({scheme:ne,fragment:null})}}P.parse=Ce;function he(oe,Y){return oe.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${oe.scheme!==T.Schemas.file?oe.scheme:""}`})}P.generateCellOutputUri=he;function de(oe){if(oe.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Y)return;const H=Y[1]&&Y[1]!==""?Y[1]:void 0,ne=Y[2];return{outputId:H,notebook:oe.with({scheme:ne||T.Schemas.file,fragment:null})}}P.parseCellOutputUri=de;function te(oe,Y,H){return P.generate(oe,Y).with({scheme:H})}P.generateCellPropertyUri=te;function Ie(oe,Y){if(oe.scheme===Y)return P.parse(oe.with({scheme:P.scheme}))}P.parseCellPropertyUri=Ie})(a||(e.CellUri=a={}));const c=P=>m.isWindows?P.replace(/\//g,"\\"):P;class d{constructor(Q=[],ae=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=ae,this.order=[...new Set(Q)].map(me=>({pattern:me,matches:F.parse(c(me))}))}sort(Q){const ae=new Map(D.Iterable.map(Q,Ee=>[Ee,c(Ee)]));let me=[];for(const{matches:Ee}of this.order)for(const[Ce,he]of ae)if(Ee(he)){me.push(Ce),ae.delete(Ce);break}return ae.size&&(me=me.concat([...ae.keys()].sort((Ee,Ce)=>this.defaultOrder.indexOf(Ee)-this.defaultOrder.indexOf(Ce)))),me}prioritize(Q,ae){const me=this.findIndex(Q);if(me===-1){this.order.unshift({pattern:Q,matches:F.parse(c(Q))});return}const Ee=new Set(ae.map(he=>this.findIndex(he,me)));Ee.delete(-1);const Ce=Array.from(Ee).sort();this.order.splice(me+1,0,...Ce.map(he=>this.order[he]));for(let he=Ce.length-1;he>=0;he--)this.order.splice(Ce[he],1)}toArray(){return this.order.map(Q=>Q.pattern)}findIndex(Q,ae=this.order.length){const me=c(Q);for(let Ee=0;Ee<ae;Ee++)if(this.order[Ee].matches(me))return Ee;return-1}}e.MimeTypeDisplayOrder=d;function i(P,Q,ae,me=(Ee,Ce)=>Ee===Ce){const Ee=[];function Ce(te,Ie,oe){if(Ie===0&&oe.length===0)return;const Y=Ee[Ee.length-1];Y&&Y.start+Y.deleteCount===te?(Y.deleteCount+=Ie,Y.toInsert.push(...oe)):Ee.push({start:te,deleteCount:Ie,toInsert:oe})}let he=0,de=0;for(;;){if(he===P.length){Ce(he,0,Q.slice(de));break}if(de===Q.length){Ce(he,P.length-he,[]);break}const te=P[he],Ie=Q[de];if(me(te,Ie)){he+=1,de+=1;continue}ae(Ie)?(Ce(he,1,[]),he+=1):(Ce(he,0,[Ie]),de+=1)}return Ee}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new w.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new w.RawContextKey("notebookEditorCursorAtLineBoundary","none");var s;(function(P){P.default="default",P.option="option"})(s||(e.NotebookEditorPriority=s={}));function l(P){const Q=P;return!!((typeof Q.include=="string"||F.isRelativePattern(Q.include))&&(typeof Q.exclude=="string"||F.isRelativePattern(Q.exclude)))}e.isDocumentExcludePattern=l;function h(P,Q,ae){if(Array.isArray(P.viewType)&&P.viewType.indexOf(Q)>=0||P.viewType===Q)return!0;if(P.filenamePattern){const me=l(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,Ee=l(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(F.match(me,(0,g.basename)(ae.fsPath).toLowerCase()))return!(Ee&&F.match(Ee,(0,g.basename)(ae.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var b;(function(P){P[P.Left=1]="Left",P[P.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class f{static{this._prefix="notebook/"}static create(Q){return`${f._prefix}${Q}`}static parse(Q){if(Q.startsWith(f._prefix))return Q.substring(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f;function C(P){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(P)}e.isTextStreamMime=C;const O=new TextDecoder;function v(P){const Q=[];let ae=!1;for(const he of P)(Q.length===0||ae)&&(Q.push(he),ae=!0);let me=M(Q);const Ee=S.VSBuffer.concat(Q.map(he=>S.VSBuffer.wrap(he))),Ce=k(Ee);return me=me||Ce.byteLength!==Ee.byteLength,{data:Ce,didCompression:me}}e.compressOutputItemStreams=v,e.MOVE_CURSOR_1_LINE_COMMAND=`${String.fromCharCode(27)}[A`;const _=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(P=>P.charCodeAt(0)),y=10;function M(P){let Q=!1;return P.forEach((ae,me)=>{if(me===0||ae.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const Ee=P[me-1],Ce=ae.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Ce[0]===_[0]&&Ce[1]===_[1]&&Ce[2]===_[2]){const he=Ee.lastIndexOf(y);if(he===-1)return;Q=!0,P[me-1]=Ee.subarray(0,he),P[me]=ae.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),Q}function V(P){let Q=P;do P=Q,Q=P.replace(/[^\n]\x08/gm,"");while(Q.length<P.length);return P}function $(P){for(P=P.replace(/\r+\n/gm,`
`);P.search(/\r[^$]/g)>-1;){const Q=P.match(/^(.*)\r+/m)[1];let ae=P.match(/\r+(.*)$/m)[1];ae=ae+Q.slice(ae.length,Q.length),P=P.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return P}const L="\b".charCodeAt(0),U="\r".charCodeAt(0);function k(P){return!P.buffer.includes(L)&&!P.buffer.includes(U)?P:S.VSBuffer.fromString($(V(O.decode(P.buffer))))}}),define(Pe[7],Te([1,0,18,11,52,28,68,12,16,2,33,22,42,100,76]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E){"use strict";var n,o,t,r,a,c,d,i,s,l,h,b,f,C,O,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.ChatMessage=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.ChatAgentCompletionItem=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(z){return Object.assign(z,{apply:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const ye=se.length===1?[]:se[1];return Reflect.construct(z,ye,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(z,[]);{const[ye,...Ke]=se;return Reflect.construct(z,Ke,ye.constructor)}}})}var M;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var V;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let $=n=class{static from(...x){let se=x;return new n(function(){if(se){for(const ye of se)ye&&typeof ye.dispose=="function"&&ye.dispose();se=void 0}})}#e;constructor(x){this.#e=x}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=$,e.Disposable=$=n=je([y],$);let L=o=class{static Min(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ye=1;ye<x.length;ye++){const Ke=x[ye];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ye=1;ye<x.length;ye++){const Ke=x[ye];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition(x){if(!x)return!1;if(x instanceof o)return!0;const{line:se,character:ye}=x;return typeof se=="number"&&typeof ye=="number"}static of(x){if(x instanceof o)return x;if(this.isPosition(x))return new o(x.line,x.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(x,se){if(x<0)throw(0,F.illegalArgument)("line must be non-negative");if(se<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=x,this._character=se}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,se=0){if(x===null||se===null)throw(0,F.illegalArgument)();let ye;return typeof x>"u"?ye=0:typeof x=="number"?ye=x:(ye=typeof x.lineDelta=="number"?x.lineDelta:0,se=typeof x.characterDelta=="number"?x.characterDelta:0),ye===0&&se===0?this:new o(this.line+ye,this.character+se)}with(x,se=this.character){if(x===null||se===null)throw(0,F.illegalArgument)();let ye;return typeof x>"u"?ye=this.line:typeof x=="number"?ye=x:(ye=typeof x.line=="number"?x.line:this.line,se=typeof x.character=="number"?x.character:this.character),ye===this.line&&se===this.character?this:new o(ye,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=L,e.Position=L=o=je([y],L);let U=t=class{static isRange(x){return x instanceof t?!0:x?L.isPosition(x.start)&&L.isPosition(x.end):!1}static of(x){if(x instanceof t)return x;if(this.isRange(x))return new t(x.start,x.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(x,se,ye,Ke){let Je,ct;if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ke=="number"?(Je=new L(x,se),ct=new L(ye,Ke)):L.isPosition(x)&&L.isPosition(se)&&(Je=L.of(x),ct=L.of(se)),!Je||!ct)throw new Error("Invalid arguments");Je.isBefore(ct)?(this._start=Je,this._end=ct):(this._start=ct,this._end=Je)}contains(x){return t.isRange(x)?this.contains(x.start)&&this.contains(x.end):L.isPosition(x)?!(L.of(x).isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const se=L.Max(x.start,this._start),ye=L.Min(x.end,this._end);if(!se.isAfter(ye))return new t(se,ye)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const se=L.Min(x.start,this._start),ye=L.Max(x.end,this.end);return new t(se,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,se=this.end){if(x===null||se===null)throw(0,F.illegalArgument)();let ye;return x?L.isPosition(x)?ye=x:(ye=x.start||this.start,se=x.end||this.end):ye=this.start,ye.isEqual(this._start)&&se.isEqual(this.end)?this:new t(ye,se)}toJSON(){return[this.start,this.end]}};e.Range=U,e.Range=U=t=je([y],U);let k=r=class extends U{static isSelection(x){return x instanceof r?!0:x?U.isRange(x)&&L.isPosition(x.anchor)&&L.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(x,se,ye,Ke){let Je,ct;if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ke=="number"?(Je=new L(x,se),ct=new L(ye,Ke)):L.isPosition(x)&&L.isPosition(se)&&(Je=L.of(x),ct=L.of(se)),!Je||!ct)throw new Error("Invalid arguments");super(Je,ct),this._anchor=Je,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=k,e.Selection=k=r=je([y],k);const P=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,F.illegalArgument)("connectionToken")};class Q{static isResolvedAuthority(x){return x&&typeof x=="object"&&typeof x.host=="string"&&typeof x.port=="number"&&(x.connectionToken===void 0||typeof x.connectionToken=="string")}constructor(x,se,ye){if(typeof x!="string"||x.length===0)throw(0,F.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,F.illegalArgument)("port");typeof ye<"u"&&P(ye),this.host=x,this.port=Math.round(se),this.connectionToken=ye}}e.ResolvedAuthority=Q;class ae{static isManagedResolvedAuthority(x){return x&&typeof x=="object"&&typeof x.makeConnection=="function"&&(x.connectionToken===void 0||typeof x.connectionToken=="string")}constructor(x,se){this.makeConnection=x,this.connectionToken=se,typeof se<"u"&&P(se)}}e.ManagedResolvedAuthority=ae;class me extends Error{static NotAvailable(x,se){return new me(x,p.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(x){return new me(x,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(x,se=p.RemoteAuthorityResolverErrorCode.Unknown,ye){super(x),this._message=x,this._code=se,this._detail=ye,Object.setPrototypeOf(this,me.prototype)}}e.RemoteAuthorityResolverError=me;var Ee;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(Ee||(e.EndOfLine=Ee={}));var Ce;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(Ce||(e.EnvironmentVariableMutatorType=Ce={}));let he=a=class{static isTextEdit(x){return x instanceof a?!0:x?U.isRange(x)&&typeof x.newText=="string":!1}static replace(x,se){return new a(x,se)}static insert(x,se){return a.replace(new U(x,x),se)}static delete(x){return a.replace(x,"")}static setEndOfLine(x){const se=new a(new U(new L(0,0),new L(0,0)),"");return se.newEol=x,se}get range(){return this._range}set range(x){if(x&&!U.isRange(x))throw(0,F.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,F.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,F.illegalArgument)("newEol");this._newEol=x}constructor(x,se){this._range=x,this._newText=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=he,e.TextEdit=he=a=je([y],he);let de=c=class{static isNotebookCellEdit(x){return x instanceof c?!0:x?Zt.isNotebookRange(x)&&Array.isArray(x.newCells):!1}static replaceCells(x,se){return new c(x,se)}static insertCells(x,se){return new c(new Zt(x,x),se)}static deleteCells(x){return new c(x,[])}static updateCellMetadata(x,se){const ye=new c(new Zt(x,x),[]);return ye.newCellMetadata=se,ye}static updateNotebookMetadata(x){const se=new c(new Zt(0,0),[]);return se.newNotebookMetadata=x,se}constructor(x,se){this.range=x,this.newCells=se}};e.NotebookEdit=de,e.NotebookEdit=de=c=je([y],de);class te{static isSnippetTextEdit(x){return x instanceof te?!0:x?U.isRange(x.range)&&Y.isSnippetString(x.snippet):!1}static replace(x,se){return new te(x,se)}static insert(x,se){return te.replace(new U(x,x),se)}constructor(x,se){this.range=x,this.snippet=se}}e.SnippetTextEdit=te;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let oe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,se,ye,Ke){this._edits.push({_type:1,from:x,to:se,options:ye,metadata:Ke})}createFile(x,se,ye){this._edits.push({_type:1,from:void 0,to:x,options:se,metadata:ye})}deleteFile(x,se,ye){this._edits.push({_type:1,from:x,to:void 0,options:se,metadata:ye})}replaceNotebookMetadata(x,se,ye){this._edits.push({_type:3,metadata:ye,uri:x,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(x,se,ye,Ke){const Je=se.start,ct=se.end;(Je!==ct||ye.length>0)&&this._edits.push({_type:5,uri:x,index:Je,count:ct-Je,cells:ye,metadata:Ke})}replaceNotebookCellMetadata(x,se,ye,Ke){this._edits.push({_type:3,metadata:Ke,uri:x,edit:{editType:3,index:se,metadata:ye}})}replace(x,se,ye,Ke){this._edits.push({_type:2,uri:x,edit:new he(se,ye),metadata:Ke})}insert(x,se,ye,Ke){this.replace(x,new U(se,se),ye,Ke)}delete(x,se,ye){this.replace(x,se,"",ye)}has(x){return this._edits.some(se=>se._type===2&&se.uri.toString()===x.toString())}set(x,se){if(se)for(const ye of se){if(!ye)continue;let Ke,Je;Array.isArray(ye)?(Ke=ye[0],Je=ye[1]):Ke=ye,de.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.replaceNotebookCellMetadata(x,Ke.range.start,Ke.newCellMetadata,Je):Ke.newNotebookMetadata?this.replaceNotebookMetadata(x,Ke.newNotebookMetadata,Je):this.replaceNotebookCells(x,Ke.range,Ke.newCells,Je):te.isSnippetTextEdit(Ke)?this._edits.push({_type:6,uri:x,range:Ke.range,edit:Ke.snippet,metadata:Je}):this._edits.push({_type:2,uri:x,edit:Ke,metadata:Je})}else{for(let ye=0;ye<this._edits.length;ye++){const Ke=this._edits[ye];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===x.toString()&&(this._edits[ye]=void 0);break}}(0,S.coalesceInPlace)(this._edits)}}get(x){const se=[];for(const ye of this._edits)ye._type===2&&ye.uri.toString()===x.toString()&&se.push(ye.edit);return se}entries(){const x=new R.ResourceMap;for(const se of this._edits)if(se._type===2){let ye=x.get(se.uri);ye||(ye=[se.uri,[]],x.set(se.uri,ye)),ye[1].push(se.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=oe,e.WorkspaceEdit=oe=je([y],oe);let Y=d=class{static isSnippetString(x){return x instanceof d?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}constructor(x){this._tabstop=1,this.value=x||""}appendText(x){return this.value+=d._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,se=this._tabstop++){if(typeof x=="function"){const ye=new d;ye._tabstop=this._tabstop,x(ye),this._tabstop=ye._tabstop,x=ye.value}else x=d._escape(x);return this.value+="${",this.value+=se,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,se=this._tabstop++){const ye=x.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(x,se){if(typeof se=="function"){const ye=new d;ye._tabstop=this._tabstop,se(ye),this._tabstop=ye._tabstop,se=ye.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=Y,e.SnippetString=Y=d=je([y],Y);var H;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var ne;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let De=i=class{static isLocation(x){return x instanceof i?!0:x?U.isRange(x.range)&&w.URI.isUri(x.uri):!1}constructor(x,se){if(this.uri=x,se)if(U.isRange(se))this.range=U.of(se);else if(L.isPosition(se))this.range=new U(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=De,e.Location=De=i=je([y],De);let Re=class{static is(x){return x?typeof x.message=="string"&&x.location&&U.isRange(x.location.range)&&w.URI.isUri(x.location.uri):!1}constructor(x,se){this.location=x,this.message=se}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.location.range.isEqual(se.location.range)&&x.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=Re,e.DiagnosticRelatedInformation=Re=je([y],Re);let ke=class{constructor(x,se,ye=ne.Error){if(!U.isRange(x))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=x,this.message=se,this.severity=ye}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.severity===se.severity&&x.code===se.code&&x.severity===se.severity&&x.source===se.source&&x.range.isEqual(se.range)&&(0,S.equals)(x.tags,se.tags)&&(0,S.equals)(x.relatedInformation,se.relatedInformation,Re.isEqual)}};e.Diagnostic=ke,e.Diagnostic=ke=je([y],ke);let ce=class{constructor(x,se){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=se}};e.Hover=ce,e.Hover=ce=je([y],ce);var ie;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(x,se=ie.Text){this.range=x,this.kind=se}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.DocumentHighlight=G,e.DocumentHighlight=G=je([y],G);let ee=class{constructor(x,se){this.uri=x,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(x=>x.toJSON())}}};e.MultiDocumentHighlight=ee,e.MultiDocumentHighlight=ee=je([y],ee);var pe;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(pe||(e.SymbolKind=pe={}));var be;(function(z){z[z.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Le=s=class{static validate(x){if(!x.name)throw new Error("name must not be falsy")}constructor(x,se,ye,Ke,Je){this.name=x,this.kind=se,this.containerName=Je,typeof ye=="string"&&(this.containerName=ye),Ke instanceof De?this.location=Ke:ye instanceof U&&(this.location=new De(Ke,ye)),s.validate(this)}toJSON(){return{name:this.name,kind:pe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Le,e.SymbolInformation=Le=s=je([y],Le);let ue=l=class{static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children?.forEach(l.validate)}constructor(x,se,ye,Ke,Je){this.name=x,this.detail=se,this.kind=ye,this.range=Ke,this.selectionRange=Je,this.children=[],l.validate(this)}};e.DocumentSymbol=ue,e.DocumentSymbol=ue=l=je([y],ue);var we;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let N=class{constructor(x,se){this.title=x,this.kind=se}};e.CodeAction=N,e.CodeAction=N=je([y],N);let W=class{static{h=this}static{this.sep="."}constructor(x){this.value=x}append(x){return new h(this.value?this.value+h.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+h.sep)}};e.CodeActionKind=W,e.CodeActionKind=W=h=je([y],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let q=class{constructor(x,se){if(this.range=x,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=q,e.SelectionRange=q=je([y],q);class B{constructor(x,se,ye,Ke,Je,ct){this.kind=x,this.name=se,this.detail=ye,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.CallHierarchyItem=B;class K{constructor(x,se){this.fromRanges=se,this.from=x}}e.CallHierarchyIncomingCall=K;class Z{constructor(x,se){this.fromRanges=se,this.to=x}}e.CallHierarchyOutgoingCall=Z;var _e;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(_e||(e.LanguageStatusSeverity=_e={}));let Fe=class{constructor(x,se){this.range=x,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=Fe,e.CodeLens=Fe=je([y],Fe);let ze=b=class{#e;static isMarkdownString(x){return x instanceof b?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}constructor(x,se=!1){this.#e=new D.MarkdownString(x,{supportThemeIcons:se})}get value(){return this.#e.value}set value(x){this.#e.value=x}get isTrusted(){return this.#e.isTrusted}set isTrusted(x){this.#e.isTrusted=x}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(x){this.#e.supportThemeIcons=x}get supportHtml(){return this.#e.supportHtml}set supportHtml(x){this.#e.supportHtml=x}get baseUri(){return this.#e.baseUri}set baseUri(x){this.#e.baseUri=x}appendText(x){return this.#e.appendText(x),this}appendMarkdown(x){return this.#e.appendMarkdown(x),this}appendCodeblock(x,se){return this.#e.appendCodeblock(se??"",x),this}};e.MarkdownString=ze,e.MarkdownString=ze=b=je([y],ze);let qe=class{constructor(x,se){this.label=x,this.documentation=se}};e.ParameterInformation=qe,e.ParameterInformation=qe=je([y],qe);let Qe=class{constructor(x,se){this.label=x,this.documentation=se,this.parameters=[]}};e.SignatureInformation=Qe,e.SignatureInformation=Qe=je([y],Qe);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=rt,e.SignatureHelp=rt=je([y],rt);var it;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let ot=class{constructor(x){this.value=x}};e.InlayHintLabelPart=ot,e.InlayHintLabelPart=ot=je([y],ot);let at=class{constructor(x,se,ye){this.position=x,this.label=se,this.kind=ye}};e.InlayHint=at,e.InlayHint=at=je([y],at);var Ue;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var vt;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var X;(function(z){z[z.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let J=class{constructor(x,se){this.label=x,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=J,e.CompletionItem=J=je([y],J);let ve=class{constructor(x=[],se=!1){this.items=x,this.isIncomplete=se}};e.CompletionList=ve,e.CompletionList=ve=je([y],ve);let $e=class{constructor(x,se,ye){this.insertText=x,this.range=se,this.command=ye}};e.InlineSuggestion=$e,e.InlineSuggestion=$e=je([y],$e);let Ge=class{constructor(x){this.commands=void 0,this.suppressSuggestions=void 0,this.items=x}};e.InlineSuggestionList=Ge,e.InlineSuggestionList=Ge=je([y],Ge);var tt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var nt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Ne(z,x){return`${I.ExtensionIdentifier.toKey(z)}.${x}`}e.asStatusBarItemIdentifier=Ne;var Dt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Lt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var Vt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var Bt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var wt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(wt||(e.TextDocumentChangeReason=wt={}));var Wt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Wt||(e.DecorationRangeBehavior=Wt={})),function(z){function x(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=x}(Bt||(e.TextEditorSelectionChangeKind=Bt={}));var Ot;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(z){function x(se){switch(se){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=x}(Ot||(e.SyntaxTokenType=Ot={}));let Gt=class{constructor(x,se){if(se&&!w.URI.isUri(se))throw(0,F.illegalArgument)("target");if(!U.isRange(x)||x.isEmpty)throw(0,F.illegalArgument)("range");this.range=x,this.target=se}};e.DocumentLink=Gt,e.DocumentLink=Gt=je([y],Gt);let Mt=class{constructor(x,se,ye,Ke){this.red=x,this.green=se,this.blue=ye,this.alpha=Ke}};e.Color=Mt,e.Color=Mt=je([y],Mt);let kt=class{constructor(x,se){if(se&&!(se instanceof Mt))throw(0,F.illegalArgument)("color");if(!U.isRange(x)||x.isEmpty)throw(0,F.illegalArgument)("range");this.range=x,this.color=se}};e.ColorInformation=kt,e.ColorInformation=kt=je([y],kt);let Ye=class{constructor(x){if(!x||typeof x!="string")throw(0,F.illegalArgument)("label");this.label=x}};e.ColorPresentation=Ye,e.ColorPresentation=Ye=je([y],Ye);var qt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var jt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(jt||(e.SourceControlInputBoxValidationType=jt={}));var lt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class gt{constructor(x,se,ye){if(this.startIndex=x,this.length=se,this.tooltip=ye,typeof x!="number"||x<0)throw(0,F.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,F.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=gt;class xt{constructor(x){this.uri=x}}e.TerminalQuickFixOpener=xt;class $t{constructor(x){this.terminalCommand=x}}e.TerminalQuickFixCommand=$t;var St;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(St||(e.TerminalLocation=St={}));class dt{constructor(x){if(this.options=x,typeof x!="object")throw(0,F.illegalArgument)("options")}}e.TerminalProfile=dt;var Pt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Yt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Yt||(e.TaskPanelKind=Yt={}));let yt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(x){switch(x){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(x,se){if(this.label=se,typeof x!="string"||typeof se!="string")throw(0,F.illegalArgument)("name");this._id=x}get id(){return this._id}};e.TaskGroup=yt,e.TaskGroup=yt=f=je([y],yt);function We(z){let x="";for(let se=0;se<z.length;se++)x+=z[se].replace(/,/g,",,")+",";return x}let At=class{constructor(x,se,ye){if(typeof x!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=x,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ye):this._options=se)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,F.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(const se of this._args)x.push(se);return We(x)}};e.ProcessExecution=At,e.ProcessExecution=At=je([y],At);let zt=class{constructor(x,se,ye){if(this._args=[],Array.isArray(se)){if(!x)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,F.illegalArgument)("command");this._command=x,this._args=se,this._options=ye}else{if(typeof x!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=x,this._options=se}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,F.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)x.push(typeof se=="string"?se:se.value);return We(x)}};e.ShellExecution=zt,e.ShellExecution=zt=je([y],zt);var Kt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Kt||(e.ShellQuoting=Kt={}));var ft;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Rt{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Rt;let Se=class{static{C=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(x,se,ye,Ke,Je,ct){this.__deprecated=!1,this._definition=this.definition=x;let ht;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ye,this.execution=Ke,ht=Je,this.__deprecated=!0):se===ft.Global||se===ft.Workspace?(this.target=se,this._name=this.name=ye,this._source=this.source=Ke,this.execution=Je,ht=ct):(this.target=se,this._name=this.name=ye,this._source=this.source=Ke,this.execution=Je,ht=ct),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof At?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof zt?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof Rt?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const se=this._definition.type;(C.EmptyType===se||C.ProcessType===se||C.ShellType===se||C.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};e.Task=Se,e.Task=Se=C=je([y],Se);var Oe;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Oe||(e.ProgressLocation=Oe={}));var fe;(function(z){function x(se){const ye=se;return(0,m.isNumber)(ye.value)?ye.tooltip&&!(0,m.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}z.isViewBadge=x})(fe||(e.ViewBadge=fe={}));let j=O=class{static isTreeItem(x,se){const ye=x;if(ye.checkboxState!==void 0){const Ke=(0,m.isNumber)(ye.checkboxState)?ye.checkboxState:(0,m.isObject)(ye.checkboxState)&&(0,m.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,Je=!(0,m.isNumber)(ye.checkboxState)&&(0,m.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Be.Checked&&Ke!==Be.Unchecked||Je!==void 0&&!(0,m.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(x instanceof O)return!0;if(ye.label!==void 0&&!(0,m.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,m.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,m.isString)(ye.iconPath)&&!w.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,m.isString)(ye.iconPath.id))){const Ke=ye.iconPath;if(!Ke||!(0,m.isString)(Ke.light)&&!w.URI.isUri(Ke.light)&&!(0,m.isString)(Ke.dark)&&!w.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,m.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!w.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,m.isString)(ye.tooltip)&&!(ye.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<Ae.None&&ye.collapsibleState>Ae.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,m.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(x,se=Ae.None){this.collapsibleState=se,w.URI.isUri(x)?this.resourceUri=x:this.label=x}};e.TreeItem=j,e.TreeItem=j=O=je([y],j);var Ae;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Ae||(e.TreeItemCollapsibleState=Ae={}));var Be;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Be||(e.TreeItemCheckboxState=Be={}));let Xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(x){this.value=x}};e.DataTransferItem=Xe,e.DataTransferItem=Xe=je([y],Xe);class He extends Xe{}e.InternalDataTransferItem=He;class Ze extends He{#e;constructor(x){super(""),this.#e=x}asFile(){return this.#e}}e.InternalFileDataTransferItem=Ze;class mt{constructor(x,se,ye,Ke){this.name=x,this.uri=se,this._itemId=ye,this._getData=Ke}data(){return this._getData()}}e.DataTransferFile=mt;let Ut=class{#e=new Map;constructor(x){for(const[se,ye]of x??[]){const Ke=this.#e.get(this.#t(se));Ke?Ke.push(ye):this.#e.set(this.#t(se),[ye])}}get(x){return this.#e.get(this.#t(x))?.[0]}set(x,se){this.#e.set(this.#t(x),[se])}forEach(x,se){for(const[ye,Ke]of this.#e)for(const Je of Ke)x.call(se,Je,ye,this)}*[Symbol.iterator](){for(const[x,se]of this.#e)for(const ye of se)yield[x,ye]}#t(x){return x.toLowerCase()}};e.DataTransfer=Ut,e.DataTransfer=Ut=je([y],Ut);let _t=class{constructor(x){this.insertText=x}};e.DocumentDropEdit=_t,e.DocumentDropEdit=_t=je([y],_t);let Ct=class{constructor(x,se){this.label=se,this.insertText=x}};e.DocumentPasteEdit=Ct,e.DocumentPasteEdit=Ct=je([y],Ct);let bt=class{constructor(x,se){this.id=x,this.color=se}static isThemeIcon(x){return typeof x.id!="string"?(console.log("INVALID ThemeIcon, invalid id",x.id),!1):!0}};e.ThemeIcon=bt,e.ThemeIcon=bt=je([y],bt),bt.File=new bt("file"),bt.Folder=new bt("folder");let gi=class{constructor(x){this.id=x}};e.ThemeColor=gi,e.ThemeColor=gi=je([y],gi);var Tt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Tt||(e.ConfigurationTarget=Tt={}));let Ci=class{get base(){return this._base}set base(x){this._base=x,this._baseUri=w.URI.file(x)}get baseUri(){return this._baseUri}set baseUri(x){this._baseUri=x,this._base=x.fsPath}constructor(x,se){if(typeof x!="string"&&(!x||!w.URI.isUri(x)&&!w.URI.isUri(x.uri)))throw(0,F.illegalArgument)("base");if(typeof se!="string")throw(0,F.illegalArgument)("pattern");typeof x=="string"?this.baseUri=w.URI.file(x):w.URI.isUri(x)?this.baseUri=x:this.baseUri=x.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Ci,e.RelativePattern=Ci=je([y],Ci);const Hi=new WeakMap;function It(z,x){Hi.set(z,x)}e.setBreakpointId=It;let ni=class{constructor(x,se,ye,Ke){this.enabled=typeof x=="boolean"?x:!0,typeof se=="string"&&(this.condition=se),typeof ye=="string"&&(this.hitCondition=ye),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=Hi.get(this)??(0,A.generateUuid)()),this._id}};e.Breakpoint=ni,e.Breakpoint=ni=je([y],ni);let pi=class extends ni{constructor(x,se,ye,Ke,Je){if(super(se,ye,Ke,Je),x===null)throw(0,F.illegalArgument)("location");this.location=x}};e.SourceBreakpoint=pi,e.SourceBreakpoint=pi=je([y],pi);let ai=class extends ni{constructor(x,se,ye,Ke,Je){super(se,ye,Ke,Je),this.functionName=x}};e.FunctionBreakpoint=ai,e.FunctionBreakpoint=ai=je([y],ai);let Ii=class extends ni{constructor(x,se,ye,Ke,Je,ct,ht){if(super(Ke,Je,ct,ht),!se)throw(0,F.illegalArgument)("dataId");this.label=x,this.dataId=se,this.canPersist=ye}};e.DataBreakpoint=Ii,e.DataBreakpoint=Ii=je([y],Ii);let Di=class{constructor(x,se,ye){this.command=x,this.args=se||[],this.options=ye}};e.DebugAdapterExecutable=Di,e.DebugAdapterExecutable=Di=je([y],Di);let Ft=class{constructor(x,se){this.port=x,this.host=se}};e.DebugAdapterServer=Ft,e.DebugAdapterServer=Ft=je([y],Ft);let vi=class{constructor(x){this.path=x}};e.DebugAdapterNamedPipeServer=vi,e.DebugAdapterNamedPipeServer=vi=je([y],vi);let ki=class{constructor(x){this.implementation=x}};e.DebugAdapterInlineImplementation=ki,e.DebugAdapterInlineImplementation=ki=je([y],ki);let ci=class{constructor(x,se,ye){this.session=x,this.threadId=se,this.frameId=ye}};e.StackFrameFocus=ci,e.StackFrameFocus=ci=je([y],ci);let li=class{constructor(x,se){this.session=x,this.threadId=se}};e.ThreadFocus=li,e.ThreadFocus=li=je([y],li);let ut=class{constructor(x,se){this.range=x,this.expression=se}};e.EvaluatableExpression=ut,e.EvaluatableExpression=ut=je([y],ut);var Wi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Wi||(e.InlineCompletionTriggerKind=Wi={}));let Jt=class{constructor(x,se){this.range=x,this.text=se}};e.InlineValueText=Jt,e.InlineValueText=Jt=je([y],Jt);let ri=class{constructor(x,se,ye=!0){this.range=x,this.variableName=se,this.caseSensitiveLookup=ye}};e.InlineValueVariableLookup=ri,e.InlineValueVariableLookup=ri=je([y],ri);let hi=class{constructor(x,se){this.range=x,this.expression=se}};e.InlineValueEvaluatableExpression=hi,e.InlineValueEvaluatableExpression=hi=je([y],hi);let Pi=class{constructor(x,se){this.frameId=x,this.stoppedLocation=se}};e.InlineValueContext=Pi,e.InlineValueContext=Pi=je([y],Pi);var Vi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Vi||(e.FileChangeType=Vi={}));let Ti=v=class extends Error{static FileExists(x){return new v(x,u.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(x){return new v(x,u.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(x){return new v(x,u.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(x){return new v(x,u.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(x){return new v(x,u.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(x){return new v(x,u.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(x,se=u.FileSystemProviderErrorCode.Unknown,ye){super(w.URI.isUri(x)?x.toString(!0):x),this.code=ye?.name??"Unknown",(0,u.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.FileSystemError=Ti,e.FileSystemError=Ti=v=je([y],Ti);let Ei=class{constructor(x,se,ye){this.start=x,this.end=se,this.kind=ye}};e.FoldingRange=Ei,e.FoldingRange=Ei=je([y],Ei);var qi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(qi||(e.FoldingRangeKind=qi={}));var Ai;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var ji;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var bi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Ri{constructor(x,se=[]){this.tokenTypes=x,this.tokenModifiers=se}}e.SemanticTokensLegend=Ri;function cn(z){return typeof z>"u"||(0,m.isStringArray)(z)}class Li{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let se=0,ye=x.tokenTypes.length;se<ye;se++)this._tokenTypeStrToInt.set(x.tokenTypes[se],se);for(let se=0,ye=x.tokenModifiers.length;se<ye;se++)this._tokenModifierStrToInt.set(x.tokenModifiers[se],se)}}push(x,se,ye,Ke,Je){if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ke=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this._pushEncoded(x,se,ye,Ke,Je);if(U.isRange(x)&&typeof se=="string"&&cn(ye))return this._push(x,se,ye);throw(0,F.illegalArgument)()}_push(x,se,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=x.start.line,Je=x.start.character,ct=x.end.character-x.start.character,ht=this._tokenTypeStrToInt.get(se);let Ht=0;if(ye)for(const Qt of ye){if(!this._tokenModifierStrToInt.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this._tokenModifierStrToInt.get(Qt);Ht|=1<<ti>>>0}this._pushEncoded(Ke,Je,ct,ht,Ht)}_pushEncoded(x,se,ye,Ke,Je){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ht=this._data.length/5|0;let Qt=0,ti=0;for(let ii=0;ii<Ht;ii++){let oi=this._data[5*ii],$i=this._data[5*ii+1];oi===0?(oi=Qt,$i+=ti):oi+=Qt,this._data[5*ii]=oi,this._data[5*ii+1]=$i,Qt=oi,ti=$i}}let ct=x,ht=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=Je,this._prevLine=x,this._prevChar=se}static _sortAndDeltaEncode(x){const se=[],ye=x.length/5|0;for(let ht=0;ht<ye;ht++)se[ht]=ht;se.sort((ht,Ht)=>{const Qt=x[5*ht],ti=x[5*Ht];if(Qt===ti){const ii=x[5*ht+1],oi=x[5*Ht+1];return ii-oi}return Qt-ti});const Ke=new Uint32Array(x.length);let Je=0,ct=0;for(let ht=0;ht<ye;ht++){const Ht=5*se[ht],Qt=x[Ht+0],ti=x[Ht+1],ii=x[Ht+2],oi=x[Ht+3],$i=x[Ht+4],Cn=Qt-Je,Mn=Cn===0?ti-ct:ti,zi=5*ht;Ke[zi+0]=Cn,Ke[zi+1]=Mn,Ke[zi+2]=ii,Ke[zi+3]=oi,Ke[zi+4]=$i,Je=Qt,ct=ti}return Ke}build(x){return this._dataIsSortedAndDeltaEncoded?new si(new Uint32Array(this._data),x):new si(Li._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Li;class si{constructor(x,se){this.resultId=se,this.data=x}}e.SemanticTokens=si;class ln{constructor(x,se,ye){this.start=x,this.deleteCount=se,this.data=ye}}e.SemanticTokensEdit=ln;class un{constructor(x,se){this.resultId=se,this.edits=x}}e.SemanticTokensEdits=un;var Ki;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Ki||(e.DebugConsoleMode=Ki={}));let fi=class{static{this.Back={iconPath:new bt("arrow-left")}}constructor(){}};e.QuickInputButtons=fi,e.QuickInputButtons=fi=je([y],fi);var Gi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Gi||(e.QuickPickItemKind=Gi={}));var Xi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var mi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(mi||(e.ExtensionKind=mi={}));class Qi{static validate(x){if(typeof x.badge=="string"){let se=(0,g.nextCharLength)(x.badge,0);if(se<x.badge.length&&(se+=(0,g.nextCharLength)(x.badge,se)),x.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(x.badge&&!bt.isThemeIcon(x.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty");return!0}constructor(x,se,ye){this.badge=x,this.tooltip=se,this.color=ye}}e.FileDecoration=Qi;let Oi=class{constructor(x){this.kind=x}};e.ColorTheme=Oi,e.ColorTheme=Oi=je([y],Oi);var Fi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Fi||(e.ColorThemeKind=Fi={}));class Zt{static isNotebookRange(x){return x instanceof Zt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(x,se){if(x<0)throw(0,F.illegalArgument)("start must be positive");if(se<0)throw(0,F.illegalArgument)("end must be positive");x<=se?(this._start=x,this._end=se):(this._start=se,this._end=x)}with(x){let se=this._start,ye=this._end;return x.start!==void 0&&(se=x.start),x.end!==void 0&&(ye=x.end),se===this._start&&ye===this._end?this:new Zt(se,ye)}}e.NotebookRange=Zt;class wi{static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(x){return!0}constructor(x,se,ye,Ke,Je,ct,ht){this.kind=x,this.value=se,this.languageId=ye,this.mime=Ke,this.outputs=Je??[],this.metadata=ct,this.executionSummary=ht,wi.validate(this)}}e.NotebookCellData=wi;class dn{constructor(x){this.cells=x}}e.NotebookData=dn;class Xt{static isNotebookCellOutputItem(x){return x instanceof Xt?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const se={name:x.name,message:x.message,stack:x.stack};return Xt.json(se,"application/vnd.code.notebook.error")}static stdout(x){return Xt.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return Xt.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,se="application/octet-stream"){return new Xt(x,se)}static#e=new TextEncoder;static text(x,se=T.Mimes.text){const ye=Xt.#e.encode(String(x));return new Xt(ye,se)}static json(x,se="text/x-json"){const ye=JSON.stringify(x,void 0,"	");return Xt.text(ye,se)}constructor(x,se){this.data=x,this.mime=se;const ye=(0,T.normalizeMimeType)(se,!0);if(!ye)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.NotebookCellOutputItem=Xt;class _i{static isNotebookCellOutput(x){return x instanceof _i?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&Array.isArray(x.items)}static ensureUniqueMimeTypes(x,se=!1){const ye=new Set,Ke=new Set;for(let Je=0;Je<x.length;Je++){const ct=x[Je],ht=(0,T.normalizeMimeType)(ct.mime);if(!ye.has(ht)||(0,E.isTextStreamMime)(ht)){ye.add(ht);continue}Ke.add(Je),se&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?x:x.filter((Je,ct)=>!Ke.has(ct))}constructor(x,se,ye){this.items=_i.ensureUniqueMimeTypes(x,!0),typeof se=="string"?(this.id=se,this.metadata=ye):(this.id=(0,A.generateUuid)(),this.metadata=se??ye)}}e.NotebookCellOutput=_i;var Si;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Si||(e.NotebookCellKind=Si={}));var Ni;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Ni||(e.NotebookCellExecutionState=Ni={}));var xe;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(xe||(e.NotebookCellStatusBarAlignment=xe={}));var ei;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Yi{constructor(x,se){this.text=x,this.alignment=se}}e.NotebookCellStatusBarItem=Yi;var pt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(pt||(e.NotebookControllerAffinity=pt={}));var Ji;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Ji||(e.NotebookControllerAffinity2=Ji={}));class hn{constructor(x,se=[]){this.uri=x,this.provides=(0,S.asArray)(se)}}e.NotebookRendererScript=hn;class Zi{constructor(x){this.label=x}}e.NotebookKernelSourceAction=Zi;var en;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let di=class{constructor(x,se){this.label=x,this.timestamp=se}};e.TimelineItem=di,e.TimelineItem=di=je([y],di);var tn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(x,se){this.ranges=x,this.wordPattern=se}}e.LinkedEditingRanges=sn;class fn{constructor(x){this._autoForwardAction=x}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=fn;var on;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Mi=class{constructor(x=void 0,se=void 0,ye=void 0,Ke=!1){this.include=x,this.exclude=se,this.profile=ye,this.continuous=Ke}};e.TestRunRequest=Mi,e.TestRunRequest=Mi=je([y],Mi);let xi=_=class{static diff(x,se,ye){const Ke=new _(x);return Ke.expectedOutput=se,Ke.actualOutput=ye,Ke}constructor(x){this.message=x}};e.TestMessage=xi,e.TestMessage=xi=_=je([y],xi);let Ui=class{constructor(x){this.id=x}};e.TestTag=Ui,e.TestTag=Ui=je([y],Ui);class yi{constructor(x,se){this.covered=x,this.total=se}}e.CoveredCount=yi;class Bi{static fromDetails(x,se){const ye=new yi(0,0),Ke=new yi(0,0),Je=new yi(0,0);for(const ht of se)if("branches"in ht){ye.total+=1,ye.covered+=ht.executionCount>0?1:0;for(const Ht of ht.branches)Ke.total+=1,Ke.covered+=Ht.executionCount>0?1:0}else Je.total+=1,Je.covered+=ht.executionCount>0?1:0;const ct=new Bi(x,ye,Ke.total>0?Ke:void 0,Je.total>0?Je:void 0);return ct.detailedCoverage=se,ct}constructor(x,se,ye,Ke){this.uri=x,this.statementCoverage=se,this.branchCoverage=ye,this.functionCoverage=Ke}}e.FileCoverage=Bi;class mn{constructor(x,se,ye=[]){this.executionCount=x,this.location=se,this.branches=ye}}e.StatementCoverage=mn;class gn{constructor(x,se){this.executionCount=x,this.location=se}}e.BranchCoverage=gn;class re{constructor(x,se,ye){this.name=x,this.executionCount=se,this.location=ye}}e.FunctionCoverage=re;var le;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(le||(e.ExternalUriOpenerPriority=le={}));var Me;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Me||(e.WorkspaceTrustState=Me={}));var st;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(st||(e.PortAutoForwardAction=st={}));class Et{constructor(x,se,ye,Ke,Je,ct){this.kind=x,this.name=se,this.detail=ye,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.TypeHierarchyItem=Et;class Nt{constructor(x){this.uri=x}}e.TextTabInput=Nt;class In{constructor(x,se){this.original=x,this.modified=se}}e.TextDiffTabInput=In;class Dn{constructor(x,se,ye,Ke){this.base=x,this.input1=se,this.input2=ye,this.result=Ke}}e.TextMergeTabInput=Dn;class kn{constructor(x,se){this.uri=x,this.viewType=se}}e.CustomEditorTabInput=kn;class Pn{constructor(x){this.viewType=x}}e.WebviewEditorTabInput=Pn;class Tn{constructor(x,se){this.uri=x,this.notebookType=se}}e.NotebookEditorTabInput=Tn;class An{constructor(x,se,ye){this.original=x,this.modified=se,this.notebookType=ye}}e.NotebookDiffEditorTabInput=An;class Rn{constructor(){}}e.TerminalEditorTabInput=Rn;class Ln{constructor(x,se){this.uri=x,this.inputBoxUri=se}}e.InteractiveWindowInput=Ln;class On{constructor(x){this.providerId=x}}e.ChatEditorTabInput=On;var pn;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var En;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Fn{constructor(x,se){this.label=x,this.values=se}}e.ChatAgentCompletionItem=Fn;var bn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));class Nn{constructor(x,se){this.role=x,this.content=se}}e.ChatMessage=Nn;var _n;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(_n||(e.ChatAgentResultFeedbackKind=_n={}));var Sn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var yn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped"})(yn||(e.SpeechToTextStatus=yn={}))}),define(Pe[103],Te([1,0,53,13,12,295,147,7,18]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const w=new Map;function A(E,n){n?w.set(E,n):w.delete(E)}e.setWordDefinitionFor=A;function I(E){return w.get(E)}class u extends R.MirrorTextModel{constructor(n,o,t,r,a,c,d,i){super(o,t,r,a),this._proxy=n,this._languageId=c,this._isDirty=d,this.notebook=i,this._isDisposed=!1}dispose(){(0,S.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(n){return(0,m.equals)(this._lines,n)}get document(){if(!this._document){const n=this;this._document={get uri(){return n._uri},get fileName(){return n._uri.fsPath},get isUntitled(){return n._uri.scheme===F.Schemas.untitled},get languageId(){return n._languageId},get version(){return n._versionId},get isClosed(){return n._isDisposed},get isDirty(){return n._isDirty},save(){return n._save()},getText(o){return o?n._getTextInRange(o):n.getText()},get eol(){return n._eol===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return n._lines.length},lineAt(o){return n._lineAt(o)},offsetAt(o){return n._offsetAt(o)},positionAt(o){return n._positionAt(o)},validateRange(o){return n._validateRange(o)},validatePosition(o){return n._validatePosition(o)},getWordRangeAtPosition(o,t){return n._getWordRangeAtPosition(o,t)}}}return Object.freeze(this._document)}_acceptLanguageId(n){(0,S.ok)(!this._isDisposed),this._languageId=n}_acceptIsDirty(n){(0,S.ok)(!this._isDisposed),this._isDirty=n}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(n){const o=this._validateRange(n);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const t=this._eol,r=o.start.line,a=o.end.line,c=[];c.push(this._lines[r].substring(o.start.character));for(let d=r+1;d<a;d++)c.push(this._lines[d]);return c.push(this._lines[a].substring(0,o.end.character)),c.join(t)}_lineAt(n){let o;if(n instanceof g.Position?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this._lines[o],o===this._lines.length-1)}_offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.line-1)+n.character}_positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(n),t=this._lines[o.index].length;return new g.Position(o.index,Math.min(o.remainder,t))}_validateRange(n){if(!(n instanceof g.Range))throw new Error("Invalid argument");const o=this._validatePosition(n.start),t=this._validatePosition(n.end);return o===n.start&&t===n.end?n:new g.Range(o.line,o.character,t.line,t.character)}_validatePosition(n){if(!(n instanceof g.Position))throw new Error("Invalid argument");if(this._lines.length===0)return n.with(0,0);let{line:o,character:t}=n,r=!1;if(o<0)o=0,t=0,r=!0;else if(o>=this._lines.length)o=this._lines.length-1,t=this._lines[o].length,r=!0;else{const a=this._lines[o].length;t<0?(t=0,r=!0):t>a&&(t=a,r=!0)}return r?new g.Position(o,t):n}_getWordRangeAtPosition(n,o){const t=this._validatePosition(n);if(!o)o=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,T.getWordAtText)(t.character+1,(0,T.ensureValidWordDefinition)(o),this._lines[t.line],0);if(r)return new g.Range(t.line,r.startColumn-1,t.line,r.endColumn-1)}}e.ExtHostDocumentData=u;class p{constructor(n,o,t){this._line=n,this._text=o,this._isLastLine=t}get lineNumber(){return this._line}get text(){return this._text}get range(){return new g.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new g.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(Pe[210],Te([1,0,7,17,5]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(g){this._actual=new S.ColorTheme(S.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(g){let m;switch(g){case"light":m=S.ColorThemeKind.Light;break;case"hcDark":m=S.ColorThemeKind.HighContrast;break;case"hcLight":m=S.ColorThemeKind.HighContrastLight;break;default:m=S.ColorThemeKind.Dark}this._actual=new S.ColorTheme(m),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=R,e.ExtHostTheming=R=je([Ve(0,F.IExtHostRpcService)],R)}),define(Pe[211],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.INotebookExecutionService=(0,S.createDecorator)("INotebookExecutionService")}),define(Pe[212],Te([1,0,6,29,144,94]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class T extends S.Disposable{constructor(m,w,A){super(),this._source=m,this._inputTextBuffer=w,this._outputs=A,this._outputTextBuffers=void 0}_getFullModelRange(m){const w=m.getLineCount();return new F.Range(1,1,w,this._getLineMaxColumn(m,w))}_getLineMaxColumn(m,w){if(w<1||w>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(w)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const m=new D.PieceTreeTextBufferBuilder;m.acceptChunk(this._source);const w=m.finish(!0),{textBuffer:A,disposable:I}=w.create(1);this._inputTextBuffer=A,this._register(I)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(m=>{const w=new D.PieceTreeTextBufferBuilder;w.acceptChunk(m);const A=w.finish(!0),{textBuffer:I,disposable:u}=A.create(1);return this._register(u),I})),this._outputTextBuffers}findInInputs(m){const A=new R.SearchParams(m,!1,!1,null).parseSearchRequest();if(!A)return[];const I=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,A,!0,5e3)}findInOutputs(m){const A=new R.SearchParams(m,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(I=>{const u=I.findMatchesLineByLine(this._getFullModelRange(I),A,!0,5e3);if(u.length!==0)return{textBuffer:I,matches:u}}).filter(I=>!!I):[]}}e.CellSearchModel=T}),define(Pe[48],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(R){R.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var F;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class D{static fromExtHostTestItem(T,g,m=T.parent){if(T._isRoot)return new D([g]);const w=[T.id];for(let A=m;A&&A.id!==g;A=A.parent)w.push(A.id);return w.push(g),new D(w.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const g=T.indexOf("\0");return g===-1?T:T.slice(0,g)}static fromString(T){return new D(T.split("\0"))}static join(T,g){return new D([...T.path,g])}static joinToString(T,g){return T.toString()+"\0"+g}static parentId(T){const g=T.lastIndexOf("\0");return g===-1?void 0:T.slice(0,g)}static localId(T){const g=T.lastIndexOf("\0");return g===-1?T:T.slice(g+1)}static isChild(T,g){return g.startsWith(T)&&g[T.length]==="\0"}static compare(T,g){return T===g?0:D.isChild(T,g)?2:D.isChild(g,T)?3:1}constructor(T,g=T.length){if(this.path=T,this.viewEnd=g,T.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new D(this.path,1)}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new D(this.path,T)}*idsToRoot(){for(let T=this.viewEnd;T>0;T--)yield new D(this.path,T)}compare(T){if(typeof T=="string")return D.compare(this.toString(),T);for(let g=0;g<T.viewEnd&&g<this.viewEnd;g++)if(T.path[g]!==this.path[g])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=D}),define(Pe[58],Te([1,0,2,92,29,48]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var g;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var m;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const w=k=>"runId"in k;e.isStartControllerTests=w;var A;(function(k){k.serialize=P=>({range:P.range.toJSON(),uri:P.uri.toJSON()}),k.deserialize=P=>({range:D.Range.lift(P.range),uri:S.URI.revive(P.uri)})})(A||(e.IRichLocation=A={}));var I;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(I||(e.TestMessageType=I={}));var u;(function(k){k.serialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,contextValue:P.contextValue,location:P.location&&A.serialize(P.location)}),k.deserialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,contextValue:P.contextValue,location:P.location&&A.deserialize(P.location)})})(u||(e.ITestErrorMessage=u={}));const p=(k,P)=>`${P?"s":"e"}${k}`;e.getMarkId=p;var E;(function(k){k.serialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&A.serialize(P.location)}),k.deserialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&A.deserialize(P.location)})})(E||(e.ITestOutputMessage=E={}));var n;(function(k){k.serialize=P=>P.type===0?u.serialize(P):E.serialize(P),k.deserialize=P=>P.type===0?u.deserialize(P):E.deserialize(P)})(n||(e.ITestMessage=n={}));var o;(function(k){k.serializeWithoutMessages=P=>({state:P.state,duration:P.duration,messages:[]}),k.serialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(n.serialize)}),k.deserialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(n.deserialize)})})(o||(e.ITestTaskState=o={}));const t="\0",r=(k,P)=>k+t+P;e.namespaceTestTag=r;const a=k=>{const P=k.indexOf(t);return{ctrlId:k.slice(0,P),tagId:k.slice(P+1)}};e.denamespaceTestTag=a;var c;(function(k){k.serialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?.toJSON(),range:P.range?.toJSON()||null,description:P.description,error:P.error,sortText:P.sortText}),k.deserialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?S.URI.revive(P.uri):void 0,range:P.range?D.Range.lift(P.range):null,description:P.description,error:P.error,sortText:P.sortText})})(c||(e.ITestItem=c={}));var d;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var i;(function(k){k.serialize=P=>({expand:P.expand,item:c.serialize(P.item)}),k.deserialize=P=>({controllerId:R.TestId.root(P.item.extId),expand:P.expand,item:c.deserialize(P.item)})})(i||(e.InternalTestItem=i={}));var s;(function(k){k.serialize=P=>{let Q;return P.item&&(Q={},P.item.label!==void 0&&(Q.label=P.item.label),P.item.tags!==void 0&&(Q.tags=P.item.tags),P.item.busy!==void 0&&(Q.busy=P.item.busy),P.item.uri!==void 0&&(Q.uri=P.item.uri?.toJSON()),P.item.range!==void 0&&(Q.range=P.item.range?.toJSON()),P.item.description!==void 0&&(Q.description=P.item.description),P.item.error!==void 0&&(Q.error=P.item.error),P.item.sortText!==void 0&&(Q.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:Q}},k.deserialize=P=>{let Q;return P.item&&(Q={},P.item.label!==void 0&&(Q.label=P.item.label),P.item.tags!==void 0&&(Q.tags=P.item.tags),P.item.busy!==void 0&&(Q.busy=P.item.busy),P.item.range!==void 0&&(Q.range=P.item.range?D.Range.lift(P.item.range):null),P.item.description!==void 0&&(Q.description=P.item.description),P.item.error!==void 0&&(Q.error=P.item.error),P.item.sortText!==void 0&&(Q.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:Q}}})(s||(e.ITestItemUpdate=s={}));const l=(k,P)=>{P.expand!==void 0&&(k.expand=P.expand),P.item!==void 0&&(k.item=k.item?Object.assign(k.item,P.item):P.item)};e.applyTestItemUpdate=l;var h;(function(k){k.serializeWithoutMessages=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serializeWithoutMessages)}),k.serialize=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serialize)}),k.deserialize=P=>({...i.deserialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.deserialize),retired:!0})})(h||(e.TestResultItem=h={}));var b;(function(k){k.empty=()=>({covered:0,total:0}),k.sum=(P,Q)=>{P.covered+=Q.covered,P.total+=Q.total}})(b||(e.ICoveredCount=b={}));var f;(function(k){k.serialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(_.serialize),uri:P.uri.toJSON()}),k.deserialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(_.deserialize),uri:S.URI.from(P.uri)})})(f||(e.IFileCoverage=f={}));function C(k){return{...k,location:k.location?.toJSON()}}function O(k){return k.location=k.location?F.Position.isIPosition(k.location)?F.Position.lift(k.location):D.Range.lift(k.location):void 0,k}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var v;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(v||(e.DetailType=v={}));var _;(function(k){k.serialize=P=>P.type===0?M.serialize(P):V.serialize(P),k.deserialize=P=>P.type===0?M.deserialize(P):V.deserialize(P)})(_||(e.CoverageDetails=_={}));var y;(function(k){k.serialize=C,k.deserialize=O})(y||(e.IBranchCoverage=y={}));var M;(function(k){k.serialize=C,k.deserialize=O})(M||(e.IFunctionCoverage=M={}));var V;(function(k){k.serialize=P=>({...C(P),branches:P.branches?.map(y.serialize)}),k.deserialize=P=>({...O(P),branches:P.branches?.map(y.deserialize)})})(V||(e.IStatementCoverage=V={}));var $;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})($||(e.TestDiffOpType=$={}));var L;(function(k){k.deserialize=P=>P.op===0?{op:P.op,item:i.deserialize(P.item)}:P.op===1?{op:P.op,item:s.deserialize(P.item)}:P.op===2?{op:P.op,uri:S.URI.revive(P.uri),docv:P.docv}:P,k.serialize=P=>P.op===0?{op:P.op,item:i.serialize(P.item)}:P.op===1?{op:P.op,item:s.serialize(P.item)}:P})(L||(e.TestsDiffOp=L={}));class U{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(P){const Q=this.createChangeCollector();for(const ae of P)switch(ae.op){case 0:this.add(i.deserialize(ae.item),Q);break;case 1:this.update(s.deserialize(ae.item),Q);break;case 3:this.remove(ae.itemId,Q);break;case 5:this.retireTest(ae.itemId);break;case 4:this.updatePendingRoots(ae.amount);break;case 6:this._tags.set(ae.tag.id,ae.tag);break;case 7:this._tags.delete(ae.id);break}Q.complete?.()}add(P,Q){const ae=R.TestId.parentId(P.item.extId)?.toString();let me;if(!ae)me=this.createItem(P),this.roots.add(me),this.items.set(P.item.extId,me);else if(this.items.has(ae)){const Ee=this.items.get(ae);Ee.children.add(P.item.extId),me=this.createItem(P,Ee),this.items.set(P.item.extId,me)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(P)}`);return}return Q.add?.(me),P.expand===2&&this.busyControllerCount++,me}update(P,Q){const ae=this.items.get(P.extId);if(ae)return P.expand!==void 0&&(ae.expand===2&&this.busyControllerCount--,P.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(ae,P),Q.update?.(ae),ae}remove(P,Q){const ae=this.items.get(P);if(!ae)return;const me=R.TestId.parentId(ae.item.extId)?.toString();me?this.items.get(me).children.delete(ae.item.extId):this.roots.delete(ae);const Ee=[[P]];for(;Ee.length;)for(const Ce of Ee.pop()){const he=this.items.get(Ce);he&&(Ee.push(he.children),this.items.delete(Ce),Q.remove?.(he,he!==ae),he.expand===2&&this.busyControllerCount--)}}retireTest(P){}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=U}),define(Pe[77],Te([1,0,14,5,6,53,58,48]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var m;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const w=(r,a)=>r===a,I=Object.entries({range:(r,a)=>r===a?!0:!r||!a?!1:r.equalsRange(a),busy:w,label:w,description:w,error:w,sortText:w,tags:(r,a)=>!(r.length!==a.length||r.some(c=>!a.includes(c)))}),u=(r,a)=>{let c;for(const[d,i]of I)i(r[d],a[d])||(c?c[d]=a[d]:c={[d]:a[d]});return c};class p extends D.Disposable{get root(){return this.options.root}constructor(a){super(),this.options=a,this.debounceSendDiff=this._register(new S.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const c of this.tree.values())this.updateExpandability(c)}get resolveHandler(){return this._resolveHandler}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.diff)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.diff[this.diff.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,T.applyTestItemUpdate)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,T.applyTestItemUpdate)(c.item,a.item);return}}break}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,c){const d=this.tree.get(a);if(d){if((d.expandLevels===void 0||c>d.expandLevels)&&(d.expandLevels=c),d.expand===1){const i=this.resolveChildren(d);return i.isOpen()?this.expandChildren(d,c-1):i.wait().then(()=>this.expandChildren(d,c-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,c-1)):this.expandChildren(d,c-1)}}dispose(){for(const a of this.tree.values())this.options.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,c){switch(c.op){case 3:this.removeItem(g.TestId.joinToString(a.fullId,c.id));break;case 0:this.upsertItem(c.item,a);break;case 5:for(const d of c.ops)this.onTestItemEvent(a,d);break;case 1:this.diffTagRefs(c.new,c.old,a.fullId.toString());break;case 2:this.updateExpandability(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.documentSynced(a.actual.uri);break;default:(0,R.assertNever)(c)}}documentSynced(a){a&&this.pushDiff({op:2,uri:a,docv:this.options.getDocumentVersion(a)})}upsertItem(a,c){const d=g.TestId.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.options.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.options.getChildren(i.parent).delete(a.id);let s=this.tree.get(d.toString());if(!s){s={fullId:d,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(a,c),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(a)}}),this.connectItemAndChildren(a,s,c);return}if(s.actual===a){this.connectItem(a,s,c);return}if(s.actual.uri?.toString()!==a.uri?.toString())return this.removeItem(d.toString()),this.upsertItem(a,c);const l=this.options.getChildren(s.actual),h=s.actual,b=u(this.options.toITestItem(h),this.options.toITestItem(a));this.options.getApiFor(h).listener=void 0,s.actual=a,s.expand=0,b&&(b.hasOwnProperty("tags")&&(this.diffTagRefs(a.tags,h.tags,d.toString()),delete b.tags),this.onTestItemEvent(s,{op:4,update:b})),this.connectItemAndChildren(a,s,c);for(const[f,C]of l)this.options.getChildren(a).get(C.id)||this.removeItem(g.TestId.joinToString(d,C.id));this.documentSynced(s.actual.uri)}diffTagRefs(a,c,d){const i=new Set(c.map(s=>s.id));for(const s of a)i.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:d,item:{tags:a.map(s=>(0,T.namespaceTestTag)(this.options.controllerId,s.id))}}}),i.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const c=this.tags.get(a.id);c?c.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,a.id)}}))}decrementTagRefs(a){const c=this.tags.get(a);c&&!--c.refCount&&(this.tags.delete(a),this.pushDiff({op:7,id:(0,T.namespaceTestTag)(this.options.controllerId,a)}))}setItemParent(a,c){this.options.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}connectItem(a,c,d){this.setItemParent(a,d);const i=this.options.getApiFor(a);i.parent=d?.actual,i.listener=s=>this.onTestItemEvent(c,s),this.updateExpandability(c)}connectItemAndChildren(a,c,d){this.connectItem(a,c,d);for(const[i,s]of this.options.getChildren(a))this.upsertItem(s,c)}updateExpandability(a){let c;this._resolveHandler?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,c){if(c<0)return;const d=[];for(const[i,s]of this.options.getChildren(a.actual)){const l=this.expand(g.TestId.joinToString(a.fullId,s.id),c);(0,S.isThenable)(l)&&d.push(l)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const s=new S.Barrier;return s.open(),s}a.expand=2,this.pushExpandStateUpdate(a);const c=a.resolveBarrier=new S.Barrier,d=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let i;try{i=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(s){d(s)}return(0,S.isThenable)(i)?i.catch(d).then(()=>{c.open(),this.updateExpandability(a)}):(c.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}removeItem(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const d=[c];for(;d.length;){const i=d.pop();if(i){this.options.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(i.fullId.toString());for(const[s,l]of this.options.getChildren(i.actual))d.push(this.tree.get(g.TestId.joinToString(i.fullId,l.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.TestItemCollection=p;class E extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=E;class n extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=n;class o extends Error{constructor(a,c,d){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=o;const t=(r,a,c)=>{let d=new Map;return{get size(){return d.size},forEach(i,s){for(const l of d.values())i.call(s,l,this)},[Symbol.iterator](){return d.entries()},replace(i){const s=new Map,l=new Set(d.keys()),h={op:5,ops:[]};for(const b of i){if(!(b instanceof c))throw new n(b.id);const f=a(b).controllerId;if(f!==r.controllerId)throw new o(b.id,f,r.controllerId);if(s.has(b.id))throw new E(b.id);s.set(b.id,b),l.delete(b.id),h.ops.push({op:0,item:b})}for(const b of l.keys())h.ops.push({op:3,id:b});r.listener?.(h),d=s},add(i){if(!(i instanceof c))throw new n(i.id);d.set(i.id,i),r.listener?.({op:0,item:i})},delete(i){d.delete(i)&&r.listener?.({op:3,id:i})},get(i){return d.get(i)},toJSON(){return Array.from(d.values())}}};e.createTestItemChildren=t}),define(Pe[104],Te([1,0,77]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const F=new WeakMap,D=(T,g)=>{const m={controllerId:g};return F.set(T,m),m};e.createPrivateApiFor=D;const R=T=>{const g=F.get(T);if(!g)throw new S.InvalidTestItemError(T?.id||"<unknown>");return g};e.getPrivateApiFor=R}),define(Pe[78],Te([1,0,13,2]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(g,m){return g.scheme===S.Schemas.http||g.scheme===S.Schemas.https?g:(m&&m.authority&&m.isRemote&&g.scheme===S.Schemas.file&&(g=F.URI.from({scheme:S.Schemas.vscodeRemote,authority:m.authority,path:g.path})),F.URI.from({scheme:S.Schemas.https,authority:`${g.scheme}+${R(g.authority)}.${e.webviewRootResourceAuthority}`,path:g.path,fragment:g.fragment,query:g.query}))}e.asWebviewUri=D;function R(g){return g.replace(/./g,m=>{const w=m.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?m:"-"+w.toString(16).padStart(4,"0")})}function T(g){return g.replace(/-([0-9a-f]{4})/g,(m,w)=>String.fromCharCode(parseInt(w,16)))}e.decodeAuthority=T}),define(Pe[213],Te([1,0,5,6,78]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(g,m,w){this._proxy=g,this._editors=m,this._remoteInfo=w,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(m.onDidChangeVisibleTextEditors(()=>{const A=m.getVisibleTextEditors();for(const I of this._insets.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(g=>g.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(g,m,w,A,I){let u;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===g){u=a;break}if(!u)throw new Error("not a visible editor");const p=this,E=this._handlePool++,n=new S.Emitter,o=new S.Emitter,t=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,D.asWebviewUri)(a,p._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(a){this._options=a,p._proxy.$setOptions(E,a)}get options(){return this._options}set html(a){this._html=a,p._proxy.$setHtml(E,a)}get html(){return this._html}get onDidReceiveMessage(){return n.event}postMessage(a){return p._proxy.$postMessage(E,a)}},r=new class{constructor(){this.editor=g,this.line=m,this.height=w,this.webview=t,this.onDidDispose=o.event}dispose(){p._insets.has(E)&&(p._insets.delete(E),p._proxy.$disposeEditorInset(E),o.fire(),o.dispose(),n.dispose())}};return this._proxy.$createEditorInset(E,u.id,u.value.document.uri,m+1,w,A||{},I.identifier,I.extensionLocation),this._insets.set(E,{editor:g,inset:r,onDidReceiveMessage:n}),r}$onDidDispose(g){const m=this._insets.get(g);m&&m.inset.dispose()}$onDidReceiveMessage(g,m){this._insets.get(g)?.onDidReceiveMessage.fire(m)}}e.ExtHostEditorInsets=R}),define(Pe[214],Te([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService");var F;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class D extends Error{constructor(T,g){super(g),this.variable=T}}e.VariableError=D}),define(Pe[215],Te([1,0,19,74,16,26,21,95,177,214,12]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,E,n,o){this._contributedVariables=new Map,this._context=p,this._labelService=E,this._userHomePromise=n,o&&(this._envVariablesPromise=o.then(t=>this.prepareEnv(t)))}prepareEnv(p){if(T.isWindows){const E=Object.create(null);return Object.keys(p).forEach(n=>{E[n.toLowerCase()]=p[n]}),E}return p}resolveWithEnvironment(p,E,n){return this.recursiveResolve({env:this.prepareEnv(p),userHome:void 0},E?E.uri:void 0,n)}async resolveAsync(p,E){const n={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(n,p?p.uri:void 0,E)}async resolveAnyBase(p,E,n,o){const t=R.deepClone(E);T.isWindows&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):T.isMacintosh&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):T.isLinux&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const r={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(r,p?p.uri:void 0,t,n,o)}async resolveAnyAsync(p,E,n){return this.resolveAnyBase(p,E,n)}async resolveAnyMap(p,E,n){const o=new Map;return{newConfig:await this.resolveAnyBase(p,E,n,o),resolvedVariables:o}}resolveWithInteractionReplace(p,E,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,E,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,E){if(this._contributedVariables.has(p))throw new Error("Variable "+p+" is contributed twice.");this._contributedVariables.set(p,E)}async recursiveResolve(p,E,n,o,t){if(D.isString(n))return this.resolveString(p,E,n,o,t);if(Array.isArray(n))return Promise.all(n.map(r=>this.recursiveResolve(p,E,r,o,t)));if(D.isObject(n)){const r=Object.create(null),a=await Promise.all(Object.keys(n).map(async c=>[await this.resolveString(p,E,c,o,t),await this.recursiveResolve(p,E,n[c],o,t)]));for(const[c,d]of a)r[c]=d;return r}return n}resolveString(p,E,n,o,t){return(0,A.replaceAsync)(n,I.VARIABLE_REGEXP,async(r,a)=>{if(a.includes(I.VARIABLE_LHS))return r;let c=await this.evaluateSingleVariable(p,r,a,E,o);return t?.set(a,c),c!==r&&D.isString(c)&&c.match(I.VARIABLE_REGEXP)&&(c=await this.resolveString(p,E,c,o,t)),c})}fsPath(p){return this._labelService?this._labelService.getUriLabel(p,{noPrefix:!0}):p.fsPath}async evaluateSingleVariable(p,E,n,o,t){let r;const a=n.split(":");a.length>1&&(n=a[0],r=a[1]);const c=s=>{const l=this._context.getFilePath();if(l)return(0,g.normalizeDriveLetter)(l);throw new w.VariableError(s,(0,m.localize)(0,null,E))},d=s=>{const l=c(s);if(this._context.getWorkspaceFolderPathForFile){const h=this._context.getWorkspaceFolderPathForFile();if(h)return(0,g.normalizeDriveLetter)(h)}throw new w.VariableError(s,(0,m.localize)(1,null,E,S.basename(l)))},i=s=>{if(r){const l=this._context.getFolderUri(r);if(l)return l;throw new w.VariableError(s,(0,m.localize)(2,null,E,r))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new w.VariableError(s,(0,m.localize)(3,null,E)):new w.VariableError(s,(0,m.localize)(4,null,E))};switch(n){case"env":if(r){if(p.env){const s=p.env[T.isWindows?r.toLowerCase():r];if(D.isString(s))return s}return""}throw new w.VariableError(w.VariableKind.Env,(0,m.localize)(5,null,E));case"config":if(r){const s=this._context.getConfigurationValue(o,r);if(D.isUndefinedOrNull(s))throw new w.VariableError(w.VariableKind.Config,(0,m.localize)(6,null,E,r));if(D.isObject(s))throw new w.VariableError(w.VariableKind.Config,(0,m.localize)(7,null,E,r));return s}throw new w.VariableError(w.VariableKind.Config,(0,m.localize)(8,null,E));case"command":return this.resolveFromMap(w.VariableKind.Command,E,r,t,"command");case"input":return this.resolveFromMap(w.VariableKind.Input,E,r,t,"input");case"extensionInstallFolder":if(r){const s=await this._context.getExtension(r);if(!s)throw new w.VariableError(w.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,E,r));return this.fsPath(s.extensionLocation)}throw new w.VariableError(w.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,E));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,g.normalizeDriveLetter)(this.fsPath(i(w.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,g.normalizeDriveLetter)(this.fsPath(i(w.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.normalizeDriveLetter)(S.basename(this.fsPath(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new w.VariableError(w.VariableKind.UserHome,(0,m.localize)(11,null,E))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new w.VariableError(w.VariableKind.LineNumber,(0,m.localize)(12,null,E))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new w.VariableError(w.VariableKind.SelectedText,(0,m.localize)(13,null,E))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return d(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.basename(d(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?S.relative(this.fsPath(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const s=S.dirname(c(w.VariableKind.RelativeFileDirname));if(o||r){const l=S.relative(this.fsPath(i(w.VariableKind.RelativeFileDirname)),s);return l.length===0?".":l}return s}case"fileDirname":return S.dirname(c(w.VariableKind.FileDirname));case"fileExtname":return S.extname(c(w.VariableKind.FileExtname));case"fileBasename":return S.basename(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=S.basename(c(w.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-S.extname(s).length)}case"fileDirnameBasename":return S.basename(S.dirname(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const s=this._context.getExecPath();return s||E}case"execInstallFolder":{const s=this._context.getAppRoot();return s||E}case"pathSeparator":return S.sep;default:try{const s=r?`${n}:${r}`:n;return this.resolveFromMap(w.VariableKind.Unknown,E,s,t,void 0)}catch{return E}}}}resolveFromMap(p,E,n,o,t){if(n&&o){const r=t===void 0?o[n]:o[t+":"+n];if(typeof r=="string")return r;throw new w.VariableError(p,(0,m.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=I}),define(Pe[105],Te([1,0,4,102]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var D;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var R;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var T;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var g;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EXPAND=1]="EXPAND",E[E.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var m;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function w(E){const n=E;return(0,F.isEditorInput)(n?.editor)&&(0,F.isEditorInput)(n?.replacement)}e.isEditorReplacement=w;var A;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function u(E){const n=E;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.isEditorGroup=u;function p(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(Pe[216],Te([1,0,4,105]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(R){const T=R;return typeof R=="number"||(0,F.isEditorGroup)(T)}e.isPreferredGroup=D}),define(Pe[217],Te([1,0,4,184]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,S.refineServiceDecorator)(F.IEnvironmentService)}),define(Pe[106],Te([1,0,22,5,19,6]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(t,r){this.versionId=t,this.removedDueToLooping=r}}e.DeltaExtensionsResult=T;class g{static isHostExtension(t,r,a){if(r.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,r){this._activationEventsReader=t,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new S.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this._extensionsMap.set(t.identifier,t),this._extensionsArr.push(t);const r=this._activationEventsReader.readActivationEvents(t);for(const a of r)this._activationMap.has(a)||this._activationMap.set(a,[]),this._activationMap.get(a).push(t)}}set(t){return this._extensionDescriptions=t,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(t,r){this._extensionDescriptions=n(this._extensionDescriptions,r),this._extensionDescriptions=this._extensionDescriptions.concat(t);const a=g._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=n(this._extensionDescriptions,a.map(c=>c.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new T(this._versionId,a)}static _findLoopingExtensions(t){const r=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(s){this._nodesSet.has(s)||(this._nodesSet.add(s),this._nodesArr.push(s))}addArc(s,l){this.addNode(s),this.addNode(l),this._arcs.has(s)?this._arcs.get(s).push(l):this._arcs.set(s,[l])}getArcs(s){return this._arcs.has(s)?this._arcs.get(s):[]}hasOnlyGoodArcs(s,l){const h=r.getArcs(s);for(let b=0;b<h.length;b++)if(!l.has(h[b]))return!1;return!0}getNodes(){return this._nodesArr}},a=new S.ExtensionIdentifierMap;for(const s of t)if(a.set(s.identifier,s),s.extensionDependencies)for(const l of s.extensionDependencies)r.addArc(S.ExtensionIdentifier.toKey(s.identifier),S.ExtensionIdentifier.toKey(l));const c=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>c.add(s));const d=r.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<d.length;s++){const l=d[s];r.hasOnlyGoodArcs(l,c)&&(d.splice(s,1),s--,c.add(l),i=!0)}}while(i);return d.map(s=>a.get(s))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(t)}getExtensionDescriptionsForActivationEvent(t){const r=this._activationMap.get(t);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new m(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(t){const r=this._extensionsMap.get(t);return r||void 0}getExtensionDescriptionByUUID(t){for(const r of this._extensionsArr)if(r.uuid===t)return r}getExtensionDescriptionByIdOrUUID(t,r){return this.getExtensionDescription(t)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.ExtensionDescriptionRegistry=g;class m{constructor(t,r){this.versionId=t,this.extensions=r}}e.ExtensionDescriptionRegistrySnapshot=m;class w{constructor(t){this._lock=new u,this._actual=new g(t,[])}async acquireLock(t){const r=await this._lock.acquire(t);return new A(this,r)}deltaExtensions(t,r,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(r,a)}containsActivationEvent(t){return this._actual.containsActivationEvent(t)}containsExtension(t){return this._actual.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this._actual.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(t){return this._actual.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this._actual.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,r){return this._actual.getExtensionDescriptionByIdOrUUID(t,r)}}e.LockableExtensionDescriptionRegistry=w;class A extends R.Disposable{constructor(t,r){super(),this._registry=t,this._isDisposed=!1,this._register(r)}isAcquiredFor(t){return!this._isDisposed&&this._registry===t}}e.ExtensionDescriptionRegistryLock=A;class I{constructor(t){this.name=t,this.promise=new Promise((r,a)=>{this._resolve=r})}resolve(t){this._resolve(t)}}class u{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(t){const r=new I(t);return this._pendingCustomers.push(r),this._advance(),r.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const t=this._pendingCustomers.shift();this._isLocked=!0;let r=!0;const a=setTimeout(()=>{r&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{r&&(clearTimeout(a),r=!1,this._isLocked=!1,this._advance())};t.resolve((0,R.toDisposable)(c))}}var p;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(p||(p={}));function E(o,t){const r=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(r!==a)return r-a;const c=D.posix.basename(o.extensionLocation.path),d=D.posix.basename(t.extensionLocation.path);return c<d?-1:c>d?1:0}function n(o,t){const r=new S.ExtensionIdentifierSet(t);return o.filter(a=>!r.has(a.identifier))}}),define(Pe[79],Te([1,0,24]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(F||(e.UIKind=F={}));var D;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var R;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function T(w){const A=S.VSBuffer.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=T;function g(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=g;var m;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Pe[59],Te([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let p=class extends I.Disposable{constructor(t,r){super(),this.initData=t,this.loggerService=r,this._onDidChangeTelemetryEnabled=this._register(new F.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new F.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=A.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=r.createLogger(this.extHostTelemetryLogFile,{id:m.extensionTelemetryLogChannelId,name:(0,u.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(r.onDidChangeLogLevel(a=>{(0,D.isLogLevel)(a)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(t,r,a){const c=this.getTelemetryDetails(),d=new E(r,a,t,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this._telemetryLoggers.get(t.identifier.value)??[];return this._telemetryLoggers.set(t.identifier.value,[...i,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(t,r,a){this._level=t,this._telemetryIsSupported=r,this._productConfig=a??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(t){const r=Object.create(null);switch(r["common.extname"]=`${t.publisher}.${t.name}`,r["common.extversion"]=t.version,r["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,r["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,r["common.sqmid"]=this.initData.telemetryInfo.sqmId,r["common.vscodeversion"]=this.initData.version,r["common.isnewappinstall"]=n(this.initData.telemetryInfo.firstSessionDate),r["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case T.UIKind.Web:r["common.uikind"]="web";break;case T.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,g.getRemoteName)((0,m.cleanRemoteAuthority)(this.initData.remote.authority)),r}$onDidChangeTelemetryLevel(t){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=t;const r=this.getTelemetryDetails();this._telemetryLoggers.forEach((a,c)=>{const d=a.filter(i=>!i.isDisposed);d.length===0?this._telemetryLoggers.delete(c):this._telemetryLoggers.set(c,d)}),this._telemetryLoggers.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(t,r){const c=this._telemetryLoggers.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this._telemetryLoggers.delete(t.value),!1;let d=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(r),d=!0);return d}};e.ExtHostTelemetry=p,e.ExtHostTelemetry=p=je([Ve(0,R.IExtHostInitDataService),Ve(1,D.ILoggerService)],p);class E{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,r,a,c,d,i,s){this._extension=a,this._logger=c,this._inLoggingOnlyMode=d,this._commonProperties=i,this._onDidChangeEnableStates=new F.Emitter,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=r?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=r?.additionalCommonProperties,this._sender=t,this._telemetryEnablements={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,r){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:t,isErrorsEnabled:r},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(t){let r="properties"in t?t.properties??{}:t;return r=(0,m.cleanData)(r,[]),this._additionalCommonProperties&&(r=(0,w.mixin)(r,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(r=(0,w.mixin)(r,this._commonProperties)),"properties"in t?t.properties=r:t=r,t}logEvent(t,r){this._sender&&(this._extension.publisher==="vscode"?t=this._extension.name+"/"+t:t=this._extension.identifier.value+"/"+t,r=this.mixInCommonPropsAndCleanData(r||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(t,r),this._logger.trace(t,r))}logUsage(t,r){this._telemetryEnablements.isUsageEnabled&&this.logEvent(t,r)}logError(t,r){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof t=="string")this.logEvent(t,r);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,m.cleanData)(a,[]),d=new Error(c.message,{cause:c.cause});d.stack=c.stack,d.name=c.name,r=this.mixInCommonPropsAndCleanData(r||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(d,r),this._logger.trace("exception",r)}}get apiTelemetryLogger(){if(!this._apiObject){const t=this,r={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return t._telemetryEnablements.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t._onDidChangeEnableStates.event.bind(t)};this._apiObject=Object.freeze(r)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let t=this._sender;this._sender=void 0,Promise.resolve(t.flush()).then(t=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=E;function n(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=n,e.IExtHostTelemetry=(0,S.createDecorator)("IExtHostTelemetry")}),define(Pe[23],Te([1,0,5,2,193,101,22,4]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,g.createDecorator)("extensionService");class m{constructor(d){this.dependency=d}}e.MissingExtensionDependency=m;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(d,i,s){this._versionId=d,this._allExtensions=i.slice(0),this._myExtensions=s.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:R.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(d,i,s){if(this._versionId>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this._versionId})`);const l=[],h=[],b=[],f=[],C=I(this._allExtensions),O=I(i),v=($,L)=>$.extensionLocation.toString()===L.extensionLocation.toString()||$.isBuiltin===L.isBuiltin||$.isUserBuiltin===L.isUserBuiltin||$.isUnderDevelopment===L.isUnderDevelopment;for(const $ of this._allExtensions){const L=O.get($.identifier);if(!L){l.push($.identifier),C.delete($.identifier);continue}if(!v($,L)){l.push($.identifier),C.delete($.identifier);continue}}for(const $ of i){const L=C.get($.identifier);if(!L){h.push($);continue}if(!v(L,$)){l.push(L.identifier),C.delete(L.identifier);continue}}const _=new T.ExtensionIdentifierSet(this._myExtensions),y=new T.ExtensionIdentifierSet(s);for(const $ of this._myExtensions)y.has($)||b.push($);for(const $ of s)_.has($)||f.push($);const M=R.ImplicitActivationEvents.createActivationEventsMap(h),V={versionId:d,toRemove:l,toAdd:h,addActivationEvents:M,myToRemove:b,myToAdd:f};return this.delta(V),V}delta(d){if(this._versionId>=d.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:l,myToAdd:h}=d,b=new T.ExtensionIdentifierSet(i),f=new T.ExtensionIdentifierSet(l);for(let C=0;C<this._allExtensions.length;C++)b.has(this._allExtensions[C].identifier)&&(this._allExtensions.splice(C,1),C--);for(let C=0;C<this._myExtensions.length;C++)f.has(this._myExtensions[C])&&(this._myExtensions.splice(C,1),C--);for(const C of s)this._allExtensions.push(C);for(const C of h)this._myExtensions.push(C);return this._myActivationEvents=null,d}containsExtension(d){for(const i of this._myExtensions)if(T.ExtensionIdentifier.equals(i,d))return!0;return!1}containsActivationEvent(d){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(d)}_readMyActivationEvents(){const d=new Set;for(const i of this._allExtensions){if(!this.containsExtension(i.identifier))continue;const s=R.ImplicitActivationEvents.readActivationEvents(i);for(const l of s)d.add(l)}return d}}e.ExtensionHostExtensions=A;function I(c){const d=new T.ExtensionIdentifierMap;for(const i of c)d.set(i.identifier,i);return d}function u(c,d){return c.enabledApiProposals?c.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=u;function p(c,d){if(!u(c,d))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=p;class E{constructor(d,i,s,l){this.codeLoadingTime=d,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=l}}e.ActivationTimes=E;class n{constructor(d,i){this.description=d,this.value=i}}e.ExtensionPointContribution=n;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=t;function r(c,d){return{identifier:new T.ExtensionIdentifier((0,D.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!d,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.toExtensionDescription=r;class a{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,i){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=a}),define(Pe[218],Te([1,0,11,106,22,23,15,14]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(t,r,a,c){this.startup=t,this.codeLoadingTime=r,this.activateCallTime=a,this.activateResolvedTime=c}}e.ExtensionActivationTimes=m;class w{constructor(t){this._startup=t,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(t,r){return t===-1||r===-1?-1:r-t}build(){return new m(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class A{constructor(t,r,a,c,d,i){this.activationFailed=t,this.activationFailedError=r,this.activationTimes=a,this.module=c,this.exports=d,this.subscriptions=i}}e.ActivatedExtension=A;class I extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class u extends A{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=u;class p extends A{constructor(t){super(!0,t,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(t,r,a,c){this._logService=c,this._registry=t,this._globalRegistry=r,this._host=a,this._operations=new D.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[t,r]of this._operations)r.dispose()}async waitForActivatingExtensions(){const t=[];for(const[r,a]of this._operations)t.push(a.wait());await Promise.all(t)}isActivated(t){const r=this._operations.get(t);return!!(r&&r.value)}getActivatedExtension(t){const r=this._operations.get(t);if(!r||!r.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return r.value}async activateByEvent(t,r){if(this._alreadyActivatedEvents[t])return;const a=this._registry.getExtensionDescriptionsForActivationEvent(t);await this._activateExtensions(a.map(c=>({id:c.identifier,reason:{startup:r,extensionId:c.identifier,activationEvent:t}}))),this._alreadyActivatedEvents[t]=!0}activateById(t,r){const a=this._registry.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this._activateExtensions([{id:a.identifier,reason:r}])}async _activateExtensions(t){const r=t.filter(a=>!this.isActivated(a.id)).map(a=>this._handleActivationRequest(a));await Promise.all(r.map(a=>a.wait()))}_handleActivationRequest(t){if(this._operations.has(t.id))return this._operations.get(t.id);if(this._isHostExtension(t.id))return this._createAndSaveOperation(t,null,[],null);const r=this._registry.getExtensionDescription(t.id);if(!r){const d=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this._createAndSaveOperation(t,null,[],new p(d));return this._host.onExtensionActivationError(t.id,d,new R.MissingExtensionDependency(t.id.value)),i}const a=[],c=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const d of c){if(this._isResolvedExtension(d))continue;const i=this._operations.get(d);if(i){a.push(i);continue}if(this._isHostExtension(d)){a.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(d).identifier,reason:t.reason}));continue}const s=this._registry.getExtensionDescription(d);if(s){if(!s.main&&!s.browser)continue;a.push(this._handleActivationRequest({id:s.identifier,reason:t.reason}));continue}const l=r.displayName||r.identifier.value,h=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${d}'`),b=this._createAndSaveOperation(t,r.displayName,[],new p(h));return this._host.onExtensionActivationError(r.identifier,h,new R.MissingExtensionDependency(d)),b}return this._createAndSaveOperation(t,r.displayName,a,null)}_createAndSaveOperation(t,r,a,c){const d=new n(t.id,r,t.reason,a,c,this._host,this._logService);return this._operations.set(t.id,d),d}_isHostExtension(t){return F.ExtensionDescriptionRegistry.isHostExtension(t,this._registry,this._globalRegistry)}_isResolvedExtension(t){const r=this._globalRegistry.getExtensionDescription(t);return r?!r.main&&!r.browser:!1}};e.ExtensionsActivator=E,e.ExtensionsActivator=E=je([Ve(3,T.ILogService)],E);let n=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(t,r,a,c,d,i,s){this._id=t,this._displayName=r,this._reason=a,this._deps=c,this._value=d,this._host=i,this._logService=s,this._barrier=new g.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let t=0;t<this._deps.length;t++){const r=this._deps[t];if(r.value&&!r.value.activationFailed){this._deps.splice(t,1),t--;continue}if(r.value&&r.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);a.detail=r.value.activationFailedError,this._value=new p(a),this._host.onExtensionActivationError(this._id,a,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(t=>t.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(t){const r=new Error;if(t&&t.name&&(r.name=t.name),t&&t.message?r.message=`Activating extension '${this._id.value}' failed: ${t.message}.`:r.message=`Activating extension '${this._id.value}' failed: ${t}.`,t&&t.stack&&(r.stack=t.stack),this._value=new p(r),this._isDisposed&&S.isCancellationError(t))return;this._host.onExtensionActivationError(this._id,r,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(t)}}};n=je([Ve(6,T.ILogService)],n)}),define(Pe[8],Te([1,0,18,24,127,219,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,216,7,23]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Se){function Oe(j){const{selectionStartLineNumber:Ae,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:He}=j,Ze=new s.Position(Ae-1,Be-1),mt=new s.Position(Xe-1,He-1);return new s.Selection(Ze,mt)}Se.to=Oe;function fe(j){const{anchor:Ae,active:Be}=j;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Se.from=fe})(h||(e.Selection=h={}));var b;(function(Se){function Oe(j){if(!j)return;const{start:Ae,end:Be}=j;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Se.from=Oe;function fe(j){if(!j)return;const{startLineNumber:Ae,startColumn:Be,endLineNumber:Xe,endColumn:He}=j;return new s.Range(Ae-1,Be-1,Xe-1,He-1)}Se.to=fe})(b||(e.Range=b={}));var f;(function(Se){function Oe(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Se.to=Oe})(f||(e.TokenType=f={}));var C;(function(Se){function Oe(j){return new s.Position(j.lineNumber-1,j.column-1)}Se.to=Oe;function fe(j){return{lineNumber:j.line+1,column:j.character+1}}Se.from=fe})(C||(e.Position=C={}));var O;(function(Se){function Oe(Ae,Be,Xe){return(0,S.coalesce)((0,S.asArray)(Ae).map(He=>fe(He,Be,Xe)))}Se.from=Oe;function fe(Ae,Be,Xe){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:Xe?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:j(Ae.scheme,Be),pattern:X.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:Xe?.isBuiltin}}function j(Ae,Be){return Be&&typeof Ae=="string"?Be.transformOutgoingScheme(Ae):Ae}})(O||(e.DocumentSelector=O={}));var v;(function(Se){function Oe(j){switch(j){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Se.from=Oe;function fe(j){switch(j){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(v||(e.DiagnosticTag=v={}));var _;(function(Se){function Oe(j){let Ae;return j.code&&((0,u.isString)(j.code)||(0,u.isNumber)(j.code)?Ae=String(j.code):Ae={value:String(j.code.value),target:j.code.target}),{...b.from(j.range),message:j.message,source:j.source,code:Ae,severity:M.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(y.from),tags:Array.isArray(j.tags)?(0,S.coalesce)(j.tags.map(v.from)):void 0}}Se.from=Oe;function fe(j){const Ae=new s.Diagnostic(b.to(j),j.message,M.to(j.severity));return Ae.source=j.source,Ae.code=(0,u.isString)(j.code)?j.code:j.code?.value,Ae.relatedInformation=j.relatedInformation&&j.relatedInformation.map(y.to),Ae.tags=j.tags&&(0,S.coalesce)(j.tags.map(v.to)),Ae}Se.to=fe})(_||(e.Diagnostic=_={}));var y;(function(Se){function Oe(j){return{...b.from(j.location.range),message:j.message,resource:j.location.uri}}Se.from=Oe;function fe(j){return new s.DiagnosticRelatedInformation(new s.Location(j.resource,b.to(j)),j.message)}Se.to=fe})(y||(e.DiagnosticRelatedInformation=y={}));var M;(function(Se){function Oe(j){switch(j){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Se.from=Oe;function fe(j){switch(j){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Se.to=fe})(M||(e.DiagnosticSeverity=M={}));var V;(function(Se){function Oe(j){return typeof j=="number"&&j>=s.ViewColumn.One?j-1:j===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Se.from=Oe;function fe(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(V||(e.ViewColumn=V={}));function $(Se){return typeof Se.range<"u"}function L(Se){return Se.length===0?!0:!!$(Se[0])}e.isDecorationOptionsArr=L;var U;(function(Se){function Oe(He){return He.map(Se.from)}Se.fromMany=Oe;function fe(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function j(He){let Ze;if(fe(He)){const{language:Ct,value:bt}=He;Ze={value:"```"+Ct+`
`+bt+"\n```\n"}}else s.MarkdownString.isMarkdownString(He)?Ze={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?Ze={value:He}:Ze={value:""};const mt=Object.create(null);Ze.uris=mt;const Ut=Ct=>{try{let bt=p.URI.parse(Ct,!0);bt=bt.with({query:Ae(bt.query,mt)}),mt[Ct]=bt}catch{}return""},_t=new m.marked.Renderer;return _t.link=Ut,_t.image=Ct=>typeof Ct=="string"?Ut(T.parseHrefAndDimensions(Ct).href):"",(0,m.marked)(Ze.value,{renderer:_t}),Ze}Se.from=j;function Ae(He,Ze){if(!He)return He;let mt;try{mt=(0,w.parse)(He)}catch{}if(!mt)return He;let Ut=!1;return mt=(0,I.cloneAndChange)(mt,_t=>{if(p.URI.isUri(_t)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Ct]=_t,Ut=!0,Ct}else return}),Ut?JSON.stringify(mt):He}function Be(He){const Ze=new s.MarkdownString(He.value,He.supportThemeIcons);return Ze.isTrusted=He.isTrusted,Ze.supportHtml=He.supportHtml,Ze.baseUri=He.baseUri?p.URI.from(He.baseUri):void 0,Ze}Se.to=Be;function Xe(He){if(He)return typeof He=="string"?He:Se.from(He)}Se.fromStrict=Xe})(U||(e.MarkdownString=U={}));function k(Se){return L(Se)?Se.map(Oe=>({range:b.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?U.fromMany(Oe.hoverMessage):Oe.hoverMessage?U.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Se.map(Oe=>({range:b.from(Oe)}))}e.fromRangeOrRangeWithMessage=k;function P(Se){return typeof Se>"u"?Se:typeof Se=="string"?p.URI.file(Se):Se}e.pathOrURIToURI=P;var Q;(function(Se){function Oe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?P(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Oe})(Q||(e.ThemableDecorationAttachmentRenderOptions=Q={}));var ae;(function(Se){function Oe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Q.from(fe.before):void 0,after:fe.after?Q.from(fe.after):void 0}}Se.from=Oe})(ae||(e.ThemableDecorationRenderOptions=ae={}));var me;(function(Se){function Oe(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Oe})(me||(e.DecorationRangeBehavior=me={}));var Ee;(function(Se){function Oe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?me.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ae.from(fe.light):void 0,dark:fe.dark?ae.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Q.from(fe.before):void 0,after:fe.after?Q.from(fe.after):void 0}}Se.from=Oe})(Ee||(e.DecorationRenderOptions=Ee={}));var Ce;(function(Se){function Oe(j){return{text:j.newText,eol:j.newEol&&et.from(j.newEol),range:b.from(j.range)}}Se.from=Oe;function fe(j){const Ae=new s.TextEdit(b.to(j.range),j.text);return Ae.newEol=typeof j.eol>"u"?void 0:et.to(j.eol),Ae}Se.to=fe})(Ce||(e.TextEdit=Ce={}));var he;(function(Se){function Oe(j,Ae){const Be={edits:[]};if(j instanceof s.WorkspaceEdit){const Xe=new g.ResourceSet;for(const He of j._allEntries())He._type===1&&p.URI.isUri(He.to)&&He.from===void 0&&Xe.add(He.to);for(const He of j._allEntries())if(He._type===1){let Ze;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?Ze={type:"base64",value:(0,F.encodeBase64)(F.VSBuffer.wrap(He.options.contents))}:Ze={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:Ze},metadata:He.metadata})}else He._type===2?Be.edits.push({resource:He.uri,textEdit:Ce.from(He.edit),versionId:Xe.has(He.uri)?void 0:Ae?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?Be.edits.push({resource:He.uri,textEdit:{range:b.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Xe.has(He.uri)?void 0:Ae?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(He.uri)}):He._type===5&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(Dt.from)}})}return Be}Se.from=Oe;function fe(j){const Ae=new s.WorkspaceEdit,Be=new g.ResourceMap;for(const Xe of j.edits)if(Xe.textEdit){const He=Xe,Ze=p.URI.revive(He.resource),mt=b.to(He.textEdit.range),Ut=He.textEdit.text,_t=He.textEdit.insertAsSnippet;let Ct;_t?Ct=s.SnippetTextEdit.replace(mt,new s.SnippetString(Ut)):Ct=s.TextEdit.replace(mt,Ut);const bt=Be.get(Ze);bt?bt.push(Ct):Be.set(Ze,[Ct])}else Ae.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,He]of Be)Ae.set(Xe,He);return Ae}Se.to=fe})(he||(e.WorkspaceEdit=he={}));var de;(function(Se){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function fe(Ae){return typeof Oe[Ae]=="number"?Oe[Ae]:6}Se.from=fe;function j(Ae){for(const Be in Oe)if(Oe[Be]===Ae)return Number(Be);return s.SymbolKind.Property}Se.to=j})(de||(e.SymbolKind=de={}));var te;(function(Se){function Oe(j){switch(j){case s.SymbolTag.Deprecated:return 1}}Se.from=Oe;function fe(j){switch(j){case 1:return s.SymbolTag.Deprecated}}Se.to=fe})(te||(e.SymbolTag=te={}));var Ie;(function(Se){function Oe(j){return{name:j.name,kind:de.from(j.kind),tags:j.tags&&j.tags.map(te.from),containerName:j.containerName,location:De.from(j.location)}}Se.from=Oe;function fe(j){const Ae=new s.SymbolInformation(j.name,de.to(j.kind),j.containerName,De.to(j.location));return Ae.tags=j.tags&&j.tags.map(te.to),Ae}Se.to=fe})(Ie||(e.WorkspaceSymbol=Ie={}));var oe;(function(Se){function Oe(j){const Ae={name:j.name||"!!MISSING: name!!",detail:j.detail,range:b.from(j.range),selectionRange:b.from(j.selectionRange),kind:de.from(j.kind),tags:j.tags?.map(te.from)??[]};return j.children&&(Ae.children=j.children.map(Oe)),Ae}Se.from=Oe;function fe(j){const Ae=new s.DocumentSymbol(j.name,j.detail,de.to(j.kind),b.to(j.range),b.to(j.selectionRange));return(0,S.isNonEmptyArray)(j.tags)&&(Ae.tags=j.tags.map(te.to)),j.children&&(Ae.children=j.children.map(fe)),Ae}Se.to=fe})(oe||(e.DocumentSymbol=oe={}));var Y;(function(Se){function Oe(j){const Ae=new s.CallHierarchyItem(de.to(j.kind),j.name,j.detail||"",p.URI.revive(j.uri),b.to(j.range),b.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}Se.to=Oe;function fe(j,Ae,Be){if(Ae=Ae??j._sessionId,Be=Be??j._itemId,Ae===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Be,name:j.name,detail:j.detail,kind:de.from(j.kind),uri:j.uri,range:b.from(j.range),selectionRange:b.from(j.selectionRange),tags:j.tags?.map(te.from)}}Se.from=fe})(Y||(e.CallHierarchyItem=Y={}));var H;(function(Se){function Oe(fe){return new s.CallHierarchyIncomingCall(Y.to(fe.from),fe.fromRanges.map(j=>b.to(j)))}Se.to=Oe})(H||(e.CallHierarchyIncomingCall=H={}));var ne;(function(Se){function Oe(fe){return new s.CallHierarchyOutgoingCall(Y.to(fe.to),fe.fromRanges.map(j=>b.to(j)))}Se.to=Oe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var De;(function(Se){function Oe(j){return{range:j.range&&b.from(j.range),uri:j.uri}}Se.from=Oe;function fe(j){return new s.Location(p.URI.revive(j.uri),b.to(j.range))}Se.to=fe})(De||(e.location=De={}));var Re;(function(Se){function Oe(j){const Ae=j,Be=j;return{originSelectionRange:Ae.originSelectionRange?b.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Be.uri,range:b.from(Ae.targetRange?Ae.targetRange:Be.range),targetSelectionRange:Ae.targetSelectionRange?b.from(Ae.targetSelectionRange):void 0}}Se.from=Oe;function fe(j){return{targetUri:p.URI.revive(j.uri),targetRange:b.to(j.range),targetSelectionRange:j.targetSelectionRange?b.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?b.to(j.originSelectionRange):void 0}}Se.to=fe})(Re||(e.DefinitionLink=Re={}));var ke;(function(Se){function Oe(j){return{range:b.from(j.range),contents:U.fromMany(j.contents)}}Se.from=Oe;function fe(j){return new s.Hover(j.contents.map(U.to),b.to(j.range))}Se.to=fe})(ke||(e.Hover=ke={}));var ce;(function(Se){function Oe(j){return{range:b.from(j.range),expression:j.expression}}Se.from=Oe;function fe(j){return new s.EvaluatableExpression(b.to(j.range),j.expression)}Se.to=fe})(ce||(e.EvaluatableExpression=ce={}));var ie;(function(Se){function Oe(j){if(j instanceof s.InlineValueText)return{type:"text",range:b.from(j.range),text:j.text};if(j instanceof s.InlineValueVariableLookup)return{type:"variable",range:b.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Oe;function fe(j){switch(j.type){case"text":return{range:b.to(j.range),text:j.text};case"variable":return{range:b.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:b.to(j.range),expression:j.expression}}}Se.to=fe})(ie||(e.InlineValue=ie={}));var G;(function(Se){function Oe(j){return{frameId:j.frameId,stoppedLocation:b.from(j.stoppedLocation)}}Se.from=Oe;function fe(j){return new s.InlineValueContext(j.frameId,b.to(j.stoppedLocation))}Se.to=fe})(G||(e.InlineValueContext=G={}));var ee;(function(Se){function Oe(j){return{range:b.from(j.range),kind:j.kind}}Se.from=Oe;function fe(j){return new s.DocumentHighlight(b.to(j.range),j.kind)}Se.to=fe})(ee||(e.DocumentHighlight=ee={}));var pe;(function(Se){function Oe(j){return{uri:j.uri,highlights:j.highlights.map(ee.from)}}Se.from=Oe;function fe(j){return new s.MultiDocumentHighlight(p.URI.revive(j.uri),j.highlights.map(ee.to))}Se.to=fe})(pe||(e.MultiDocumentHighlight=pe={}));var be;(function(Se){function Oe(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Se.to=Oe})(be||(e.CompletionTriggerKind=be={}));var Le;(function(Se){function Oe(fe){return{triggerKind:be.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Oe})(Le||(e.CompletionContext=Le={}));var ue;(function(Se){function Oe(j){switch(j){case s.CompletionItemTag.Deprecated:return 1}}Se.from=Oe;function fe(j){switch(j){case 1:return s.CompletionItemTag.Deprecated}}Se.to=fe})(ue||(e.CompletionItemTag=ue={}));var we;(function(Se){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Be){return Oe.get(Be)??9}Se.from=fe;const j=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ae(Be){return j.get(Be)??s.CompletionItemKind.Property}Se.to=Ae})(we||(e.CompletionItemKind=we={}));var N;(function(Se){function Oe(fe,j){const Ae=new s.CompletionItem(fe.label);return Ae.insertText=fe.insertText,Ae.kind=we.to(fe.kind),Ae.tags=fe.tags?.map(ue.to),Ae.detail=fe.detail,Ae.documentation=T.isMarkdownString(fe.documentation)?U.to(fe.documentation):fe.documentation,Ae.sortText=fe.sortText,Ae.filterText=fe.filterText,Ae.preselect=fe.preselect,Ae.commitCharacters=fe.commitCharacters,E.Range.isIRange(fe.range)?Ae.range=b.to(fe.range):typeof fe.range=="object"&&(Ae.range={inserting:b.to(fe.range.insert),replacing:b.to(fe.range.replace)}),Ae.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ae.insertText=new s.SnippetString(fe.insertText):(Ae.insertText=fe.insertText,Ae.textEdit=Ae.range instanceof s.Range?new s.TextEdit(Ae.range,Ae.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ae.additionalTextEdits=fe.additionalTextEdits.map(Be=>Ce.to(Be))),Ae.command=j&&fe.command?j.fromInternal(fe.command):void 0,Ae}Se.to=Oe})(N||(e.CompletionItem=N={}));var W;(function(Se){function Oe(j){if(typeof j.label!="string"&&!Array.isArray(j.label))throw new TypeError("Invalid label");return{label:j.label,documentation:U.fromStrict(j.documentation)}}Se.from=Oe;function fe(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?U.to(j.documentation):j.documentation}}Se.to=fe})(W||(e.ParameterInformation=W={}));var q;(function(Se){function Oe(j){return{label:j.label,documentation:U.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(W.from):[],activeParameter:j.activeParameter}}Se.from=Oe;function fe(j){return{label:j.label,documentation:T.isMarkdownString(j.documentation)?U.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(W.to):[],activeParameter:j.activeParameter}}Se.to=fe})(q||(e.SignatureInformation=q={}));var B;(function(Se){function Oe(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(q.from):[]}}Se.from=Oe;function fe(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(q.to):[]}}Se.to=fe})(B||(e.SignatureHelp=B={}));var K;(function(Se){function Oe(fe,j){const Ae=new s.InlayHint(C.to(j.position),typeof j.label=="string"?j.label:j.label.map(Z.to.bind(void 0,fe)),j.kind&&_e.to(j.kind));return Ae.textEdits=j.textEdits&&j.textEdits.map(Ce.to),Ae.tooltip=T.isMarkdownString(j.tooltip)?U.to(j.tooltip):j.tooltip,Ae.paddingLeft=j.paddingLeft,Ae.paddingRight=j.paddingRight,Ae}Se.to=Oe})(K||(e.InlayHint=K={}));var Z;(function(Se){function Oe(fe,j){const Ae=new s.InlayHintLabelPart(j.label);return Ae.tooltip=T.isMarkdownString(j.tooltip)?U.to(j.tooltip):j.tooltip,n.Command.is(j.command)&&(Ae.command=fe.fromInternal(j.command)),j.location&&(Ae.location=De.to(j.location)),Ae}Se.to=Oe})(Z||(e.InlayHintLabelPart=Z={}));var _e;(function(Se){function Oe(j){return j}Se.from=Oe;function fe(j){return j}Se.to=fe})(_e||(e.InlayHintKind=_e={}));var Fe;(function(Se){function Oe(j){return{range:b.from(j.range),url:j.target,tooltip:j.tooltip}}Se.from=Oe;function fe(j){let Ae;if(j.url)try{Ae=typeof j.url=="string"?p.URI.parse(j.url,!0):p.URI.revive(j.url)}catch{}return new s.DocumentLink(b.to(j.range),Ae)}Se.to=fe})(Fe||(e.DocumentLink=Fe={}));var ze;(function(Se){function Oe(j){const Ae=new s.ColorPresentation(j.label);return j.textEdit&&(Ae.textEdit=Ce.to(j.textEdit)),j.additionalTextEdits&&(Ae.additionalTextEdits=j.additionalTextEdits.map(Be=>Ce.to(Be))),Ae}Se.to=Oe;function fe(j){return{label:j.label,textEdit:j.textEdit?Ce.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ae=>Ce.from(Ae)):void 0}}Se.from=fe})(ze||(e.ColorPresentation=ze={}));var qe;(function(Se){function Oe(j){return new s.Color(j[0],j[1],j[2],j[3])}Se.to=Oe;function fe(j){return[j.red,j.green,j.blue,j.alpha]}Se.from=fe})(qe||(e.Color=qe={}));var Qe;(function(Se){function Oe(j){return{range:b.from(j.range)}}Se.from=Oe;function fe(j){return new s.SelectionRange(b.to(j.range))}Se.to=fe})(Qe||(e.SelectionRange=Qe={}));var rt;(function(Se){function Oe(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Se.to=Oe})(rt||(e.TextDocumentSaveReason=rt={}));var it;(function(Se){function Oe(j){switch(j){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Oe;function fe(j){switch(j){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Se.to=fe})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Se){function Oe(j){if(j===s.EndOfLine.CRLF)return 1;if(j===s.EndOfLine.LF)return 0}Se.from=Oe;function fe(j){if(j===1)return s.EndOfLine.CRLF;if(j===0)return s.EndOfLine.LF}Se.to=fe})(et||(e.EndOfLine=et={}));var ot;(function(Se){function Oe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Oe})(ot||(e.ProgressLocation=ot={}));var at;(function(Se){function Oe(j){const Ae={start:j.start+1,end:j.end+1};return j.kind&&(Ae.kind=Ue.from(j.kind)),Ae}Se.from=Oe;function fe(j){const Ae={start:j.start-1,end:j.end-1};return j.kind&&(Ae.kind=Ue.to(j.kind)),Ae}Se.to=fe})(at||(e.FoldingRange=at={}));var Ue;(function(Se){function Oe(j){if(j)switch(j){case s.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}Se.from=Oe;function fe(j){if(j)switch(j.value){case n.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Se.to=fe})(Ue||(e.FoldingRangeKind=Ue={}));var vt;(function(Se){function Oe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?b.from(fe.selection):void 0,override:typeof fe.override=="boolean"?r.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Oe})(vt||(e.TextEditorOpenOptions=vt={}));var X;(function(Se){function Oe(Be){return Be instanceof s.RelativePattern?Be.toJSON():typeof Be=="string"?Be:fe(Be)||j(Be)?new s.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Se.from=Oe;function fe(Be){const Xe=Be;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function j(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Be){return typeof Be=="string"?Be:new s.RelativePattern(p.URI.revive(Be.baseUri),Be.pattern)}Se.to=Ae})(X||(e.GlobPattern=X={}));var J;(function(Se){function Oe(fe){if(fe){if(Array.isArray(fe))return fe.map(Oe);if(typeof fe=="string")return fe;{const j=fe;return{language:j.language,scheme:j.scheme,pattern:X.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}Se.from=Oe})(J||(e.LanguageSelector=J={}));var ve;(function(Se){function Oe(j){return!!j&&typeof j=="object"&&"documents"in j&&Array.isArray(j.documents)&&j.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&p.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Xe=>Xe instanceof s.Range)))}Se.is=Oe;function fe(j){return{documents:j.documents.map(Ae=>Ae.map(Be=>({uri:p.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>b.from(Xe))})))}}Se.from=fe})(ve||(e.MappedEditsContext=ve={}));var $e;(function(Se){function Oe(j){return{start:j.start,end:j.end}}Se.from=Oe;function fe(j){return new s.NotebookRange(j.start,j.end)}Se.to=fe})($e||(e.NotebookRange=$e={}));var Ge;(function(Se){function Oe(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}Se.to=Oe;function fe(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}Se.from=fe})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var tt;(function(Se){function Oe(fe){if(fe===a.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===a.NotebookCellExecutionState.Pending)return;if(fe===a.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Oe})(tt||(e.NotebookCellExecutionState=tt={}));var nt;(function(Se){function Oe(j){switch(j){case s.NotebookCellKind.Markup:return a.CellKind.Markup;case s.NotebookCellKind.Code:default:return a.CellKind.Code}}Se.from=Oe;function fe(j){switch(j){case a.CellKind.Markup:return s.NotebookCellKind.Markup;case a.CellKind.Code:default:return s.NotebookCellKind.Code}}Se.to=fe})(nt||(e.NotebookCellKind=nt={}));var Ne;(function(Se){function Oe(j){const Ae={metadata:j.metadata??Object.create(null),cells:[]};for(const Be of j.cells)s.NotebookCellData.validate(Be),Ae.cells.push(Dt.from(Be));return Ae}Se.from=Oe;function fe(j){const Ae=new s.NotebookData(j.cells.map(Dt.to));return(0,u.isEmptyObject)(j.metadata)||(Ae.metadata=j.metadata),Ae}Se.to=fe})(Ne||(e.NotebookData=Ne={}));var Dt;(function(Se){function Oe(j){return{cellKind:nt.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Ge.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(Vt.from):[]}}Se.from=Oe;function fe(j){return new s.NotebookCellData(nt.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(Vt.to):void 0,j.metadata,j.internalMetadata?Ge.to(j.internalMetadata):void 0)}Se.to=fe})(Dt||(e.NotebookCellData=Dt={}));var Lt;(function(Se){function Oe(j){return{mime:j.mime,valueBytes:F.VSBuffer.wrap(j.data)}}Se.from=Oe;function fe(j){return new s.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}Se.to=fe})(Lt||(e.NotebookCellOutputItem=Lt={}));var Vt;(function(Se){function Oe(j){return{outputId:j.id,items:j.items.map(Lt.from),metadata:j.metadata}}Se.from=Oe;function fe(j){const Ae=j.items.map(Lt.to);return new s.NotebookCellOutput(Ae,j.outputId,j.metadata)}Se.to=fe})(Vt||(e.NotebookCellOutput=Vt={}));var Bt;(function(Se){function Oe(Ae){return j(Ae)?{include:X.from(Ae.include)??void 0,exclude:X.from(Ae.exclude)??void 0}:X.from(Ae)??void 0}Se.from=Oe;function fe(Ae){return j(Ae)?{include:X.to(Ae.include),exclude:X.to(Ae.exclude)}:X.to(Ae)}Se.to=fe;function j(Ae){const Be=Ae;return Be?!(0,u.isUndefinedOrNull)(Be.include)&&!(0,u.isUndefinedOrNull)(Be.exclude):!1}})(Bt||(e.NotebookExclusiveDocumentPattern=Bt={}));var wt;(function(Se){function Oe(fe,j,Ae){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Be,Ae),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Oe})(wt||(e.NotebookStatusBarItem=wt={}));var Wt;(function(Se){function Oe(fe,j,Ae){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:j.toInternal(Be,Ae),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Se.from=Oe})(Wt||(e.NotebookKernelSourceAction=Wt={}));var Ot;(function(Se){function Oe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Oe})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Se){function Oe(j){return{uri:j.uri,provides:j.provides}}Se.from=Oe;function fe(j){return new s.NotebookRendererScript(p.URI.revive(j.uri),j.provides)}Se.to=fe})(Gt||(e.NotebookRendererScript=Gt={}));var Mt;(function(Se){function Oe(j){return{message:U.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,contextValue:j.contextValue,location:j.location&&{range:b.from(j.location.range),uri:j.location.uri}}}Se.from=Oe;function fe(j){const Ae=new s.TestMessage(typeof j.message=="string"?j.message:U.to(j.message));return Ae.actualOutput=j.actual,Ae.expectedOutput=j.expected,Ae.contextValue=j.contextValue,Ae.location=j.location?De.to(j.location):void 0,Ae}Se.to=fe})(Mt||(e.TestMessage=Mt={}));var kt;(function(Se){Se.namespace=d.namespaceTestTag,Se.denamespace=d.denamespaceTestTag})(kt||(e.TestTag=kt={}));var Ye;(function(Se){function Oe(j){const Ae=(0,t.getPrivateApiFor)(j).controllerId;return{extId:c.TestId.fromExtHostTestItem(j,Ae).toString(),label:j.label,uri:p.URI.revive(j.uri),busy:j.busy,tags:j.tags.map(Be=>kt.namespace(Ae,Be.id)),range:E.Range.lift(b.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&U.fromStrict(j.error)||null}}Se.from=Oe;function fe(j){return{parent:void 0,error:void 0,id:c.TestId.fromString(j.extId).localId,label:j.label,uri:p.URI.revive(j.uri),tags:(j.tags||[]).map(Ae=>{const{tagId:Be}=kt.denamespace(Ae);return new s.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(j.range||void 0),canResolveChildren:!1,busy:j.busy,description:j.description||void 0,sortText:j.sortText||void 0}}Se.toPlain=fe})(Ye||(e.TestItem=Ye={})),function(Se){function Oe(j){return{id:j.id}}Se.from=Oe;function fe(j){return new s.TestTag(j.id)}Se.to=fe}(kt||(e.TestTag=kt={}));var qt;(function(Se){const Oe=(j,Ae)=>{const Be=[];for(const[He,Ze]of Ae)c.TestId.compare(Ze.item.extId,He)===2&&(Ae.delete(He),Be.push(Ze));const Xe={...Ye.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(Ze=>Ze.type===0).map(Mt.to)})),children:Be.map(He=>Oe(He,Ae))};for(const He of Xe.children)He.parent=Xe;return Xe};function fe(j){const Ae=[],Be=new Map;for(const Xe of j.items){Be.set(Xe.item.extId,Xe);const He=c.TestId.root(Xe.item.extId);j.request.targets.some(Ze=>Ze.controllerId===He&&Ze.testIds.includes(Xe.item.extId))&&Ae.push(Xe)}return{completedAt:j.completedAt,results:Ae.map(Xe=>Oe(Xe,Be))}}Se.to=fe})(qt||(e.TestResults=qt={}));var jt;(function(Se){function Oe(Be){return{covered:Be.covered,total:Be.total}}function fe(Be){return"line"in Be?C.from(Be):b.from(Be)}function j(Be){return"branches"in Be?{count:Be.executionCount,location:fe(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location)})):void 0}:{type:0,name:Be.name,count:Be.executionCount,location:fe(Be.location)}}Se.fromDetailed=j;function Ae(Be){return{uri:Be.uri,statement:Oe(Be.statementCoverage),branch:Be.branchCoverage&&Oe(Be.branchCoverage),function:Be.functionCoverage&&Oe(Be.functionCoverage),details:Be.detailedCoverage?.map(j)}}Se.fromFile=Ae})(jt||(e.TestCoverage=jt={}));var lt;(function(Se){function Oe(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Se.to=Oe})(lt||(e.CodeActionTriggerKind=lt={}));var gt;(function(Se){function Oe(j){const Ae=new s.TypeHierarchyItem(de.to(j.kind),j.name,j.detail||"",p.URI.revive(j.uri),b.to(j.range),b.to(j.selectionRange));return Ae._sessionId=j._sessionId,Ae._itemId=j._itemId,Ae}Se.to=Oe;function fe(j,Ae,Be){if(Ae=Ae??j._sessionId,Be=Be??j._itemId,Ae===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Be,kind:de.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:b.from(j.range),selectionRange:b.from(j.selectionRange),tags:j.tags?.map(te.from)}}Se.from=fe})(gt||(e.TypeHierarchyItem=gt={}));var xt;(function(Se){function Oe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Oe})(xt||(e.ViewBadge=xt={}));var $t;(function(Se){function Oe(Be,Xe,He){const Ze=Xe.fileData;return Ze?new s.InternalFileDataTransferItem(new s.DataTransferFile(Ze.name,p.URI.revive(Ze.uri),Ze.id,(0,R.createSingleCallFunction)(()=>He(Ze.id)))):Be===A.Mimes.uriList&&Xe.uriListData?new s.InternalDataTransferItem(Ae(Xe.uriListData)):new s.InternalDataTransferItem(Xe.asString)}Se.to=Oe;async function fe(Be,Xe){const He=await Xe.asString();if(Be===A.Mimes.uriList)return{asString:He,fileData:void 0,uriListData:j(He)};const Ze=Xe.asFile();return{asString:He,fileData:Ze?{name:Ze.name,uri:Ze.uri,id:Ze._itemId??Ze.id}:void 0}}Se.from=fe;function j(Be){return D.UriList.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function Ae(Be){return D.UriList.create(Be.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})($t||(e.DataTransferItem=$t={}));var St;(function(Se){function Oe(j,Ae){const Be=j.items.map(([Xe,He])=>[Xe,$t.to(Xe,He,Ae)]);return new s.DataTransfer(Be)}Se.toDataTransfer=Oe;async function fe(j){const Ae={items:[]},Be=[];for(const[Xe,He]of j)Be.push((async()=>{Ae.items.push([Xe,await $t.from(Xe,He)])})());return await Promise.all(Be),Ae}Se.from=fe})(St||(e.DataTransfer=St={}));var dt;(function(Se){function Oe(fe){return{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}Se.from=Oe})(dt||(e.ChatReplyFollowup=dt={}));var Pt;(function(Se){function Oe(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:dt.from(fe)}Se.from=Oe})(Pt||(e.ChatFollowup=Pt={}));var Yt;(function(Se){function Oe(j){const Ae=new s.ChatMessage(yt.to(j.role),j.content);return Ae.name=j.name,Ae}Se.to=Oe;function fe(j){return{role:yt.from(j.role),content:j.content,name:j.name}}Se.from=fe})(Yt||(e.ChatMessage=Yt={}));var yt;(function(Se){function Oe(j){switch(j){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Se.to=Oe;function fe(j){switch(j){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Se.from=fe})(yt||(e.ChatMessageRole=yt={}));var We;(function(Se){function Oe(Ae){const Be={};for(const Xe of Object.keys(Ae))Be[Xe]=Ae[Xe].map(Se.to);return Be}Se.objectTo=Oe;function fe(Ae){return{level:At.to(Ae.level),kind:Ae.kind,value:(0,w.revive)(Ae.value),description:Ae.description}}Se.to=fe;function j(Ae){return{level:At.from(Ae.level),kind:Ae.kind,value:Ae.value,description:Ae.description}}Se.from=j})(We||(e.ChatVariable=We={}));var At;(function(Se){function Oe(j){switch(j){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Se.to=Oe;function fe(j){switch(j){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Se.from=fe})(At||(e.ChatVariableLevel=At={}));var zt;(function(Se){function Oe(fe){switch(fe){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Se.to=Oe})(zt||(e.InteractiveEditorResponseFeedbackKind=zt={}));var Kt;(function(Se){function Oe(fe,j){return"placeholder"in j&&"resolvedContent"in j?{content:j.placeholder,kind:"asyncContent"}:"markdownContent"in j?((0,l.checkProposedApiEnabled)(fe,"chatAgents2Additions"),{content:U.from(j.markdownContent),kind:"markdownContent"}):"content"in j?"vulnerabilities"in j&&j.vulnerabilities?((0,l.checkProposedApiEnabled)(fe,"chatAgents2Additions"),{content:j.content,vulnerabilities:j.vulnerabilities,kind:"vulnerability"}):typeof j.content=="string"?{content:j.content,kind:"content"}:((0,l.checkProposedApiEnabled)(fe,"chatAgents2Additions"),{content:U.from(j.content),kind:"markdownContent"}):"documents"in j?{documents:j.documents.map(Ae=>({uri:Ae.uri,version:Ae.version,ranges:Ae.ranges.map(Be=>b.from(Be))})),kind:"usedContext"}:"reference"in j?{reference:"uri"in j.reference?{uri:j.reference.uri,range:b.from(j.reference.range)}:j.reference,kind:"reference"}:"inlineReference"in j?{inlineReference:"uri"in j.inlineReference?{uri:j.inlineReference.uri,range:b.from(j.inlineReference.range)}:j.inlineReference,name:j.title,kind:"inlineReference"}:"agentName"in j?((0,l.checkProposedApiEnabled)(fe,"chatAgents2Additions"),{agentName:j.agentName,command:j.command,kind:"agentDetection"}):"treeData"in j?{treeData:j.treeData,kind:"treeData"}:"message"in j?{content:j.message,kind:"progressMessage"}:void 0}Se.from=Oe})(Kt||(e.ChatResponseProgress=Kt={}));var ft;(function(Se){function Oe(fe){return{label:fe.label,values:fe.values.map(We.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation}}Se.from=Oe})(ft||(e.ChatAgentCompletionItem=ft={}));var Rt;(function(Se){function Oe(fe,j,Ae){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:j.toInternal(fe,Ae)}Se.from=Oe})(Rt||(e.TerminalQuickFix=Rt={}))}),define(Pe[220],Te([1,0,2,11,7,8,186]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class g{constructor(w,A,I,u={timeout:1500,errors:3}){this._logService=w,this._documents=A,this._mainThreadBulkEdits=I,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(w){return(A,I,u)=>{const E={dispose:this._callbacks.push([A,I,w])};return Array.isArray(u)&&u.push(E),E}}async $participateInSave(w,A){const I=S.URI.revive(w);let u=!1;const p=setTimeout(()=>u=!0,this._thresholds.timeout),E=[];try{for(const n of[...this._callbacks]){if(u)break;const o=this._documents.getDocument(I),t=await this._deliverEventAsyncAndBlameBadListeners(n,{document:o,reason:R.TextDocumentSaveReason.to(A)});E.push(t)}}finally{clearTimeout(p)}return E}_deliverEventAsyncAndBlameBadListeners([w,A,I],u){const p=this._badListeners.get(w);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,w,A,u).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const n=this._badListeners.get(w);this._badListeners.set(w,n?n+1:1),typeof n=="number"&&n>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(w,A,I,u){const p=[],E=Date.now(),{document:n,reason:o}=u,{version:t}=n,r=Object.freeze({document:n,reason:o,waitUntil(a){if(Object.isFrozen(p))throw(0,F.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(a))}});try{A.apply(I,[r])}catch(a){return Promise.reject(a)}return Object.freeze(p),new Promise((a,c)=>{const d=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(d),a(i)}).catch(i=>{clearTimeout(d),c(i)})}).then(a=>{const c={edits:[]};for(const d of a)if(Array.isArray(d)&&d.every(i=>i instanceof D.TextEdit))for(const{newText:i,newEol:s,range:l}of d)c.edits.push({resource:n.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:i,eol:s&&R.EndOfLine.from(s)}});if(c.edits.length!==0)return t===n.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=g}),define(Pe[221],Te([1,0,13,2,8,7,76]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class g{constructor(I,u,p,E){this.start=I,this.deletedCount=u,this.deletedItems=p,this.items=E}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(I,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,u,p){this.notebook=I,this._extHostDocument=u,this._cellData=p,this.handle=p.handle,this.uri=F.URI.revive(p.uri),this.cellKind=p.cellKind,this._outputs=p.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=p.internalMetadata??{},this._metadata=Object.freeze(p.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return I._mime},set mime(E){I._mime=E},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(p)}return this._apiCell}setOutputs(I){this._outputs=I.map(D.NotebookCellOutput.to)}setOutputItems(I,u,p){const E=p.map(D.NotebookCellOutputItem.to),n=this._outputs.find(o=>o.id===I);if(n&&(u||(n.items.length=0),n.items.push(...E),n.items.length>1&&n.items.every(o=>T.isTextStreamMime(o.mime)))){const o=new Map,t=[];n.items.forEach(r=>{let a;o.has(r.mime)?a=o.get(r.mime):(a=[],o.set(r.mime,a),t.push(r.mime)),a.push(r.data)}),n.items.length=0,t.forEach(r=>{const a=T.compressOutputItemStreams(o.get(r));n.items.push({mime:r,data:a.data.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=m;class w{static{this._handlePool=0}constructor(I,u,p,E,n){this._proxy=I,this._textDocumentsAndEditors=u,this._textDocuments=p,this.uri=E,this.handle=w._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=n.viewType,this._metadata=Object.freeze(n.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,n.cells]],!0,void 0),this._versionId=n.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const I=this,u={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===S.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(p){return p=I._validateIndex(p),I._cells[p].apiCell},getCells(p){return(p?I._getCells(p):I._cells).map(n=>n.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(u)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,u,p){this._versionId=I.versionId,this._isDirty=u,this.acceptDocumentPropertiesChanged({metadata:p});const E={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},n=[];for(const t of I.rawEvents)t.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(t.changes,!1,E.contentChanges):t.kind===T.NotebookCellsChangeType.Move?this._moveCells(t.index,t.length,t.newIdx,E.contentChanges):t.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(t.index,t.outputs),n.push({cell:this._cells[t.index].apiCell,outputs:this._cells[t.index].apiCell.outputs})):t.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(t.index,t.outputId,t.append,t.outputItems),n.push({cell:this._cells[t.index].apiCell,outputs:this._cells[t.index].apiCell.outputs})):t.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(t.index,t.language),n.push({cell:this._cells[t.index].apiCell,document:this._cells[t.index].apiCell.document})):t.kind===T.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this._cells[t.index].apiCell,document:this._cells[t.index].apiCell.document}):t.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(t.index,t.mime):t.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(t.index,t.metadata),n.push({cell:this._cells[t.index].apiCell,metadata:this._cells[t.index].apiCell.metadata})):t.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(t.index,t.internalMetadata),n.push({cell:this._cells[t.index].apiCell,executionSummary:this._cells[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<n.length;t++){const r=n[t],a=o.get(r.cell);if(a===void 0){const c=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,c-1)}else E.cellChanges[a]={...E.cellChanges[a],...r}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let u=I.start|0,p=I.end|0;return u<0&&(u=0),p>this._cells.length&&(p=this._cells.length),I.with({start:u,end:p})}_getCells(I){I=this._validateRange(I);const u=[];for(let p=I.start;p<I.end;p++)u.push(this._cells[p]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,u,p){if(this._disposed)return;const E=[],n=[],o=[];if(I.reverse().forEach(t=>{const a=t[2].map(i=>{const s=new m(this,this._textDocumentsAndEditors,i);return u||n.push(m.asModelAddData(this.apiNotebook,i)),s}),c=new g(t[0],t[1],[],a),d=this._cells.splice(t[0],t[1],...a);for(const i of d)o.push(i.uri),c.deletedItems.push(i.apiCell);E.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),p)for(const t of E)p.push(t.asApiEvent())}_moveCells(I,u,p,E){const n=this._cells.splice(I,u);this._cells.splice(p,0,...n);const o=[new g(I,u,n.map(t=>t.apiCell),[]),new g(p,0,[],n)];for(const t of o)E.push(t.asApiEvent())}_setCellOutputs(I,u){this._cells[I].setOutputs(u)}_setCellOutputItems(I,u,p,E){this._cells[I].setOutputItems(u,p,E)}_changeCellLanguage(I,u){const p=this._cells[I];p.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelLanguageChanged(p.uri,u)}_changeCellMime(I,u){const p=this._cells[I];p.apiCell.mime=u}_changeCellMetadata(I,u){this._cells[I].setMetadata(u)}_changeCellInternalMetadata(I,u){this._cells[I].setInternalMetadata(u)}getCellFromApiCell(I){return this._cells.find(u=>u.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(u=>u.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=w}),define(Pe[222],Te([1,0,5,2,8,7]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class T{constructor(m,w,A,I={timeout:1500,errors:3}){this._logService=m,this._notebooksAndEditors=w,this._mainThreadBulkEdits=A,this._thresholds=I,this._onWillSaveNotebookDocumentEvent=new S.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(m){return(w,A,I)=>{const u=function(E){w.call(A,E)};return u.extension=m,this._onWillSaveNotebookDocumentEvent.event(u,void 0,I)}}async $participateInSave(m,w,A){const I=F.URI.revive(m),u=this._notebooksAndEditors.getNotebookDocument(I);if(!u)throw new Error("Unable to resolve notebook document");const p=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:u.apiNotebook,reason:D.TextDocumentSaveReason.to(w)},A,async(n,o)=>{const t=Date.now(),r=await await Promise.resolve(n);Date.now()-t>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&r&&(r instanceof R.WorkspaceEdit?p.push(r):this._logService.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const E={edits:[]};for(const n of p){const{edits:o}=D.WorkspaceEdit.from(n);E.edits=E.edits.concat(o)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(E)}}e.ExtHostNotebookDocumentSaveParticipant=T}),define(Pe[107],Te([1,0,11,8,7]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,m,w,A,I,u){this.id=g,this._proxy=m,this.notebookData=w,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=A,this._viewColumn=u}get apiEditor(){if(!this._editor){const g=this;this._editor={get notebook(){return g.notebookData.apiNotebook},get selection(){return g._selections[0]},set selection(m){this.selections=[m]},get selections(){return g._selections},set selections(m){if(!Array.isArray(m)||!m.every(D.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");g._selections=m,g._trySetSelections(m)},get visibleRanges(){return g._visibleRanges},revealRange(m,w){g._proxy.$tryRevealRange(g.id,F.NotebookRange.from(m),w??D.NotebookEditorRevealType.Default)},get viewColumn(){return g._viewColumn}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(g){this._visible=g}_acceptVisibleRanges(g){this._visibleRanges=g}_acceptSelections(g){this._selections=g}_trySetSelections(g){this._proxy.$trySetSelections(this.id,g.map(F.NotebookRange.from))}_acceptViewColumn(g){this._viewColumn=g}}e.ExtHostNotebookEditor=R}),define(Pe[223],Te([1,0,11,5,15,8]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(m,w){this._logService=m,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new F.Emitter({onListenerError:S.onUnexpectedExternalError}),this._onDidChangeNotebookEditorVisibleRanges=new F.Emitter({onListenerError:S.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(m,w){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,w);const A=this._notebooksAndEditors.getEditorById(m);w.visibleRanges&&A._acceptVisibleRanges(w.visibleRanges.ranges.map(R.NotebookRange.to)),w.selections&&A._acceptSelections(w.selections.selections.map(R.NotebookRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const w in m)this._notebooksAndEditors.getEditorById(w)._acceptViewColumn(R.ViewColumn.to(m[w]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=je([Ve(0,D.ILogService)],T)}),define(Pe[224],Te([1,0,8,72,163,20,66,11]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class m{constructor(u){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=u}async withProgress(u,p,E){const n=this._handles++,{title:o,location:t,cancellable:r}=p,a={label:(0,D.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this._proxy.$startProgress(n,{location:S.ProgressLocation.from(t),title:o,source:a,cancellable:r},u.isUnderDevelopment?void 0:u.identifier.value).catch(g.onUnexpectedExternalError),this._withProgress(n,E,!!r)}_withProgress(u,p,E){let n;E&&(n=new R.CancellationTokenSource,this._mapHandleToCancellationSource.set(u,n));const o=r=>{this._proxy.$progressEnd(r),this._mapHandleToCancellationSource.delete(r),n?.dispose()};let t;try{t=p(new A(this._proxy,u),E&&n?n.token:R.CancellationToken.None)}catch(r){throw o(u),r}return t.then(r=>o(u),r=>o(u)),t}$acceptProgressCanceled(u){const p=this._mapHandleToCancellationSource.get(u);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(u))}}e.ExtHostProgress=m;function w(I,u){return I.message=u.message,typeof u.increment=="number"&&(typeof I.increment=="number"?I.increment+=u.increment:I.increment=u.increment),I}class A extends F.Progress{constructor(u,p){super(E=>this.throttledReport(E)),this._proxy=u,this._handle=p}throttledReport(u){this._proxy.$progressReport(this._handle,u)}}je([(0,T.throttle)(100,(I,u)=>w(I,u),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Pe[108],Te([1,0,29,104,48,77,58,8,2]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const w=(a,c,d,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(l){if(!d(s,l)){const h=s;s=l,a.listener?.(i(l,h))}}}},A=(a,c)=>a===c,I={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,c)=>!(a.length!==c.length||a.some(d=>!c.find(i=>d.id===i.id)))},u=a=>c=>({op:4,update:a(c)}),p=(a,c)=>({range:(()=>{let d;const i=u(s=>({range:S.Range.lift(g.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return d},set(s){a.listener?.({op:6}),I.range(d,s)||(d=s,a.listener?.(i(s)))}}})(),label:w(a,c,I.label,u(d=>({label:d}))),description:w(a,void 0,I.description,u(d=>({description:d}))),sortText:w(a,void 0,I.sortText,u(d=>({sortText:d}))),canResolveChildren:w(a,!1,I.canResolveChildren,d=>({op:2,state:d})),busy:w(a,!1,I.busy,u(d=>({busy:d}))),error:w(a,void 0,I.error,u(d=>({error:g.MarkdownString.fromStrict(d)||null}))),tags:w(a,[],I.tags,(d,i)=>({op:1,new:d.map(g.TestTag.from),old:i.map(g.TestTag.from)}))}),E=a=>{const c=D.TestId.fromString(a.extId),d=new o(c.controllerId,c.localId,a.label,m.URI.revive(a.uri)||void 0);return d.range=g.Range.to(a.range||void 0),d.description=a.description||void 0,d.sortText=a.sortText||void 0,d.tags=a.tags.map(i=>g.TestTag.to({id:(0,T.denamespaceTestTag)(i).tagId})),d},n=a=>{let c;for(const d of a.tests){const i=E(d.item);(0,F.getPrivateApiFor)(i).parent=c,c=i}return c};e.toItemFromContext=n;class o{constructor(c,d,i,s){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const l=(0,F.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof t?void 0:l.parent}},children:{value:(0,R.createTestItemChildren)(l,F.getPrivateApiFor,o),enumerable:!0,writable:!1},...p(l,i)})}}e.TestItemImpl=o;class t extends o{constructor(c,d){super(c,c,d,void 0),this._isRoot=!0}}e.TestItemRootImpl=t;class r extends R.TestItemCollection{constructor(c,d,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:F.getPrivateApiFor,getChildren:s=>s.children,root:new t(c,d),toITestItem:g.TestItem.from})}}e.ExtHostTestItemCollection=r}),define(Pe[109],Te([1,0,53,11,89,8,7]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class g{static{this._Keys=new D.IdGenerator("TextEditorDecorationType")}constructor(u,p,E){const n=g._Keys.nextId();u.$registerTextEditorDecorationType(p.identifier,n,R.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=g;class m{constructor(u,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,p){this._throwIfFinalized();let E=null;if(u instanceof T.Position)E=new T.Range(u,u);else if(u instanceof T.Range)E=u;else throw new Error("Unrecognized location");this._pushEdit(E,p,!1)}insert(u,p){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),p,!0)}delete(u){this._throwIfFinalized();let p=null;if(u instanceof T.Range)p=u;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(u,p,E){const n=this._document.validateRange(u);this._collectedEdits.push({range:n,text:p,forceMoveMarkers:E})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=u}}class w{constructor(u,p,E,n){this._proxy=u,this._id=p,this._accept(E),this._logService=n;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(t){o._setTabSize(t)},get indentSize(){return o._indentSize},set indentSize(t){o._setIndentSize(t)},get insertSpaces(){return o._insertSpaces},set insertSpaces(t){o._setInsertSpaces(t)},get cursorStyle(){return o._cursorStyle},set cursorStyle(t){o._setCursorStyle(t)},get lineNumbers(){return o._lineNumbers},set lineNumbers(t){o._setLineNumbers(t)}}}_accept(u){this._tabSize=u.tabSize,this._indentSize=u.indentSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(u){const p=this._validateTabSize(u);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateIndentSize(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}_setIndentSize(u){const p=this._validateIndentSize(u);if(p!==null){if(typeof p=="number"){if(this._indentSize===p)return;this._indentSize=p}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:p}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:!!u}_setInsertSpaces(u){const p=this._validateInsertSpaces(u);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let E=!1;if(typeof u.tabSize<"u"){const n=this._validateTabSize(u.tabSize);n==="auto"?(E=!0,p.tabSize=n):typeof n=="number"&&this._tabSize!==n&&(this._tabSize=n,E=!0,p.tabSize=n)}if(typeof u.indentSize<"u"){const n=this._validateIndentSize(u.indentSize);n==="tabSize"?(E=!0,p.indentSize=n):typeof n=="number"&&this._indentSize!==n&&(this._indentSize=n,E=!0,p.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this._validateInsertSpaces(u.insertSpaces);n==="auto"?(E=!0,p.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,E=!0,p.insertSpaces=n)}typeof u.cursorStyle<"u"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,E=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,E=!0,p.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,p))}_warnOnError(u,p){p.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=w;class A{constructor(u,p,E,n,o,t,r,a){this.id=u,this._proxy=p,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new w(this._proxy,this.id,t,E),this._visibleRanges=r,this._viewColumn=a;const c=this;this.value=Object.freeze({get document(){return n.value},set document(d){throw new F.ReadonlyError("document")},get selection(){return c._selections&&c._selections[0]},set selection(d){if(!(d instanceof T.Selection))throw(0,F.illegalArgument)("selection");c._selections=[d],c._trySetSelection()},get selections(){return c._selections},set selections(d){if(!Array.isArray(d)||d.some(i=>!(i instanceof T.Selection)))throw(0,F.illegalArgument)("selections");c._selections=d,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(d){throw new F.ReadonlyError("visibleRanges")},get options(){return c._options.value},set options(d){c._disposed||c._options.assign(d)},get viewColumn(){return c._viewColumn},set viewColumn(d){throw new F.ReadonlyError("viewColumn")},edit(d,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new m(n.value,i);return d(s),c._applyEdit(s)},insertSnippet(d,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!i||Array.isArray(i)&&i.length===0)l=c._selections.map(h=>R.Range.from(h));else if(i instanceof T.Position){const{lineNumber:h,column:b}=R.Position.from(i);l=[{startLineNumber:h,startColumn:b,endLineNumber:h,endColumn:b}]}else if(i instanceof T.Range)l=[R.Range.from(i)];else{l=[];for(const h of i)if(h instanceof T.Range)l.push(R.Range.from(h));else{const{lineNumber:b,column:f}=R.Position.from(h);l.push({startLineNumber:b,startColumn:f,endLineNumber:b,endColumn:f})}}return p.$tryInsertSnippet(u,n.value.version,d.value,l,s)},setDecorations(d,i){const s=i.length===0;s&&!c._hasDecorationsForKey.has(d.key)||(s?c._hasDecorationsForKey.delete(d.key):c._hasDecorationsForKey.add(d.key),c._runOnProxy(()=>{if(R.isDecorationOptionsArr(i))return p.$trySetDecorations(u,d.key,R.fromRangeOrRangeWithMessage(i));{const l=new Array(4*i.length);for(let h=0,b=i.length;h<b;h++){const f=i[h];l[4*h]=f.start.line+1,l[4*h+1]=f.start.character+1,l[4*h+2]=f.end.line+1,l[4*h+3]=f.end.character+1}return p.$trySetDecorationsFast(u,d.key,l)}}))},revealRange(d,i){c._runOnProxy(()=>p.$tryRevealRange(u,R.Range.from(d),i||T.TextEditorRevealType.Default))},show(d){p.$tryShowEditor(u,R.ViewColumn.from(d))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,S.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,S.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,S.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,S.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,S.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const E=p.edits.map(o=>o.range);E.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=E.length-1;o<t;o++){const r=E[o].end;if(E[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=p.edits.map(o=>({range:R.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,n,{setEndOfLine:typeof p.setEndOfLine=="number"?R.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=A}),define(Pe[225],Te([1,0,167,25,2,5,6,205,14,7,16,18,8,52,20,132,23]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function t(c,d){if((0,A.isString)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class r extends T.Disposable{constructor(d,i,s){super(),this._proxy=d,this.commands=i,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new n.TreeViewsDnDService;function l(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:h=>l(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(b=>l(b)?this.convertArgument(b):b):h})}registerTreeDataProvider(d,i,s){const l=this.createTreeView(d,{treeDataProvider:i},s);return{dispose:()=>l.dispose()}}createTreeView(d,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=i.dragAndDropController?.dropMimeTypes??[],h=i.dragAndDropController?.dragMimeTypes??[],b=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,C=this.createExtHostTreeView(d,i,s),O={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:l,dragMimeTypes:h,hasHandleDrag:b,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},v=this._proxy.$registerTreeViewDataProvider(d,O),_={get onDidCollapseElement(){return C.onDidCollapseElement},get onDidExpandElement(){return C.onDidExpandElement},get selection(){return C.selectedElements},get onDidChangeSelection(){return C.onDidChangeSelection},get activeItem(){return(0,o.checkProposedApiEnabled)(s,"treeViewActiveItem"),C.focusedElement},get onDidChangeActiveItem(){return(0,o.checkProposedApiEnabled)(s,"treeViewActiveItem"),C.onDidChangeActiveItem},get visible(){return C.visible},get onDidChangeVisibility(){return C.onDidChangeVisibility},get onDidChangeCheckboxState(){return C.onDidChangeCheckboxState},get message(){return C.message},set message(y){(0,p.isMarkdownString)(y)&&(0,o.checkProposedApiEnabled)(s,"treeViewMarkdownMessage"),C.message=y},get title(){return C.title},set title(y){C.title=y},get description(){return C.description},set description(y){C.description=y},get badge(){return C.badge},set badge(y){y!==void 0&&w.ViewBadge.isViewBadge(y)?C.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(C.badge=void 0)},reveal:(y,M)=>C.reveal(y,M),dispose:async()=>{await v,this.treeViews.delete(d),C.dispose()}};return this._register(_),_}$getChildren(d,i){const s=this.treeViews.get(d);return s?s.getChildren(i):Promise.reject(new g.NoTreeViewError(d))}async $handleDrop(d,i,s,l,h,b,f,C){const O=this.treeViews.get(d);if(!O)return Promise.reject(new g.NoTreeViewError(d));const v=u.DataTransfer.toDataTransfer(s,async _=>(await this._proxy.$resolveDropFileData(d,i,_)).buffer);return f===d&&C&&await this.addAdditionalTransferItems(v,O,C,h,b),O.onDrop(v,l,h)}async addAdditionalTransferItems(d,i,s,l,h){const b=this.treeDragAndDropService.removeDragOperationTransfer(h);if(b)(await b)?.forEach((f,C)=>{f&&d.set(C,f)});else if(h&&i.handleDrag){const f=i.handleDrag(s,d,l);this.treeDragAndDropService.addDragOperationTransfer(h,f),await f}return d}async $handleDrag(d,i,s,l){const h=this.treeViews.get(d);if(!h)return Promise.reject(new g.NoTreeViewError(d));const b=await this.addAdditionalTransferItems(new w.DataTransfer,h,i,l,s);if(!(!b||l.isCancellationRequested))return u.DataTransfer.from(b)}async $hasResolve(d){const i=this.treeViews.get(d);if(!i)throw new g.NoTreeViewError(d);return i.hasResolve}$resolve(d,i,s){const l=this.treeViews.get(d);if(!l)throw new g.NoTreeViewError(d);return l.resolveTreeItem(i,s)}$setExpanded(d,i,s){const l=this.treeViews.get(d);if(!l)throw new g.NoTreeViewError(d);l.setExpanded(i,s)}$setSelectionAndFocus(d,i,s){const l=this.treeViews.get(d);if(!l)throw new g.NoTreeViewError(d);l.setSelectionAndFocus(i,s)}$setVisible(d,i){const s=this.treeViews.get(d);if(!s){if(!i)return;throw new g.NoTreeViewError(d)}s.setVisible(i)}$changeCheckboxState(d,i){const s=this.treeViews.get(d);if(!s)throw new g.NoTreeViewError(d);s.setCheckboxState(i)}createExtHostTreeView(d,i,s){const l=this._register(new a(d,i,this._proxy,this.commands.converter,this.logService,s));return this.treeViews.set(d,l),l}convertArgument(d){const i=this.treeViews.get(d.$treeViewId);return i&&"$treeItemHandle"in d?i.getExtensionElement(d.$treeItemHandle):i&&"$focusedTreeItem"in d&&d.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=r;class a extends T.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,A.isUndefinedOrNull)(d))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(d,i,s,l,h,b){if(super(),this.viewId=d,this.proxy=s,this.commands=l,this.logService=h,this.extension=b,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new R.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new R.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,b.contributes&&b.contributes.views)for(const v in b.contributes.views)for(const _ of b.contributes.views[v])_.id===d&&(this._title=_.name);this.dataProvider=i.treeDataProvider,this.dndController=i.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(v=>this._onDidChangeData.fire({message:!1,element:v})));let f,C;const O=R.Event.debounce(this._onDidChangeData.event,(v,_)=>(v||(v={message:!1,elements:[]}),_.element!==!1&&(f||(f=new Promise(y=>C=y),this.refreshPromise=this.refreshPromise.then(()=>f)),Array.isArray(_.element)?v.elements.push(..._.element):v.elements.push(_.element)),_.message&&(v.message=!0),v),200,!0);this._register(O(({message:v,elements:_})=>{_.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const y=C;return f=null,this.refresh(_).then(()=>y())})),v&&this.proxy.$setMessage(this.viewId,u.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(d){const i=d?this.getExtensionElement(d):void 0;if(d&&!i)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(d);return s||(s=await this.fetchChildrenNodes(i)),s?s.map(l=>l.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,i){i=i||{select:!0,focus:!1};const s=(0,A.isUndefinedOrNull)(i.select)?!0:i.select,l=(0,A.isUndefinedOrNull)(i.focus)?!1:i.focus,h=(0,A.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(b=>this.resolveTreeNode(d,b[b.length-1]).then(f=>this.proxy.$reveal(this.viewId,{item:f.item,parentChain:b.map(C=>C.item)},{select:s,focus:l,expand:h})),b=>this.logService.error(b)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:l,expand:h})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}get badge(){return this._badge}set badge(d){this._badge?.value===d?.value&&this._badge?.tooltip===d?.tooltip||(this._badge=u.ViewBadge.from(d),this.proxy.$setBadge(this.viewId,d))}setExpanded(d,i){const s=this.getExtensionElement(d);s&&(i?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelectionAndFocus(d,i){const s=!(0,I.equals)(this._selectedHandles,d);this._selectedHandles=d;const l=this._focusedHandle!==i;this._focusedHandle=i,s&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),l&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(d){const i=(await Promise.all(d.map(async s=>{const l=this.getExtensionElement(s.treeItemHandle);return l?{extensionItem:l,treeItem:await this.dataProvider.getTreeItem(l),newState:s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(d,i,s){const l=[];for(const h of d){const b=this.getExtensionElement(h);b&&l.push(b)}if(!(!this.dndController?.handleDrag||l.length===0))return await this.dndController.handleDrag(l,i,s),i}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,i,s){const l=i?this.getExtensionElement(i):void 0;if(!(!l&&i||!this.dndController?.handleDrop))return(0,m.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(l,d,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,i){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(d);if(s){const l=this.nodes.get(s);if(l){const h=await this.dataProvider.resolveTreeItem(l.extensionItem,s,i)??l.extensionItem;return this.validateTreeItem(h),l.item.tooltip=this.getTooltip(h.tooltip),l.item.command=this.getCommand(l.disposableStore,h.command),l.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(i=>i?this.resolveUnknownParentChain(i).then(s=>this.resolveTreeNode(i,s[s.length-1]).then(l=>(s.push(l),s))):Promise.resolve([]))}resolveParent(d){const i=this.nodes.get(d);return i?Promise.resolve(i.parent?this.elements.get(i.parent.item.handle):void 0):(0,m.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,i){const s=this.nodes.get(d);return s?Promise.resolve(s):(0,m.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(l=>this.createHandle(d,l,i,!0)).then(l=>this.getChildren(i?i.item.handle:void 0).then(()=>{const h=this.getExtensionElement(l);if(h){const b=this.nodes.get(h);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${l} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(d){if(d){let i;if(typeof d=="string"){const s=this.getExtensionElement(d);i=s?this.nodes.get(s):void 0}else i=d;return i&&i.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const i=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=d?this.nodes.get(d):void 0,l=await this.dataProvider.getChildren(d);if(i.token.isCancellationRequested)return;const h=await Promise.all((0,I.coalesce)(l||[]).map(async b=>{const f=await this.dataProvider.getTreeItem(b);return f&&!i.token.isCancellationRequested?this.createAndRegisterTreeNode(b,f,s):null}));return i.token.isCancellationRequested?void 0:(0,I.coalesce)(h)}finally{i.dispose()}}refresh(d){if(d.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(d);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const i=new Set,s=d.map(h=>this.nodes.get(h));for(const h of s)if(h&&!i.has(h.item.handle)){let b=h;for(;b&&b.parent&&s.findIndex(f=>b&&b.parent&&f&&f.item.handle===b.parent.item.handle)===-1;){const f=this.elements.get(b.parent.item.handle);b=f?this.nodes.get(f):void 0}b&&!b.parent&&i.add(h.item.handle)}const l=[];return i.forEach(h=>{const b=this.elements.get(h);if(b){const f=this.nodes.get(b);f&&(!f.parent||!i.has(f.parent.item.handle))&&l.push(h)}}),l}refreshHandles(d){const i={};return Promise.all(d.map(s=>this.refreshNode(s).then(l=>{l&&(i[s]=l.item)}))).then(()=>Object.keys(i).length?this.proxy.$refresh(this.viewId,i):void 0)}refreshNode(d){const i=this.getExtensionElement(d);if(i){const s=this.nodes.get(i);if(s)return this.clearChildren(i),(0,m.asPromise)(()=>this.dataProvider.getTreeItem(i)).then(l=>{if(l){const h=this.createTreeNode(i,l,s.parent);return this.updateNodeCache(i,h,s,s.parent),s.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,i,s){const l=this.createTreeNode(d,i,s);if(i.id&&this.elements.has(l.item.handle))throw new Error((0,S.localize)(0,null,i.id));return this.addNodeToCache(d,l),this.addNodeToParentCache(l,s),l}getTooltip(d){return w.MarkdownString.isMarkdownString(d)?u.MarkdownString.from(d):d}getCommand(d,i){return i?{...this.commands.toInternal(i,d),originalId:i.command}:void 0}getCheckbox(d){if(d.checkboxState===void 0)return;let i,s,l;return typeof d.checkboxState=="number"?i=d.checkboxState:(i=d.checkboxState.state,s=d.checkboxState.tooltip,l=d.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:l}}validateTreeItem(d){if(!w.TreeItem.isTreeItem(d,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(d,i,s){this.validateTreeItem(i);const l=this._register(new T.DisposableStore),h=this.createHandle(d,i,s),b=this.getLightIconPath(i);return{item:{handle:h,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.extension),description:i.description,resourceUri:i.resourceUri,tooltip:this.getTooltip(i.tooltip),command:this.getCommand(l,i.command),contextValue:i.contextValue,icon:b,iconDark:this.getDarkIconPath(i)||b,themeIcon:this.getThemeIcon(i),collapsibleState:(0,A.isUndefinedOrNull)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.getCheckbox(i)},extensionItem:i,parent:s,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(d){return d.iconPath instanceof w.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:i,label:s,resourceUri:l},h,b){if(i)return`${a.ID_HANDLE_PREFIX}/${i}`;const f=t(s,this.extension),C=h?h.item.handle:a.LABEL_HANDLE_PREFIX;let O=f?f.label:l?(0,F.basename)(l):"";O=O.indexOf("/")!==-1?O.replace("/","//"):O;const v=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,_=this.getChildrenNodes(h)||[];let y,M=0;do{if(y=`${C}/${M}:${O}`,b||!this.elements.has(y)||v===y)break;M++}while(M<=_.length);return y}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof w.ThemeIcon))return typeof d.iconPath=="string"||D.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof w.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return D.URI.isUri(d)?d:D.URI.file(d)}addNodeToCache(d,i){this.elements.set(i.item.handle,d),this.nodes.set(d,i)}updateNodeCache(d,i,s,l){this.elements.delete(i.item.handle),this.nodes.delete(d),i.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(d,i);const h=this.getChildrenNodes(l)||[],b=h.filter(f=>f.item.handle===s.item.handle)[0];b&&h.splice(h.indexOf(b),1,i)}addNodeToParentCache(d,i){i?(i.children||(i.children=[]),i.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const i=this.nodes.get(d);if(i){if(i.children)for(const s of i.children){const l=this.elements.get(s.item.handle);l&&this.clear(l)}i.children=void 0}}else this.clearAll()}clear(d){const i=this.nodes.get(d);if(i){if(i.children)for(const s of i.children){const l=this.elements.get(s.item.handle);l&&this.clear(l)}this.nodes.delete(d),this.elements.delete(i.item.handle),i.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Pe[226],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Te([1,0,179,11,31,97,73,30,22,226,189,101]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const u=g.Registry.as(T.Extensions.JSONContribution);class p{constructor(d,i,s){this._messageHandler=d,this._extension=i,this._extensionPointId=s}_msg(d,i){this._messageHandler({type:d,message:i,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(d){this._msg(D.default.Error,d)}warn(d){this._msg(D.default.Warning,d)}info(d){this._msg(D.default.Info,d)}}e.ExtensionMessageCollector=p;class E{static _toSet(d){const i=new m.ExtensionIdentifierSet;for(let s=0,l=d.length;s<l;s++)i.add(d[s].description.identifier);return i}static compute(d,i){if(!d||!d.length)return new E(i,[]);if(!i||!i.length)return new E([],d);const s=this._toSet(d),l=this._toSet(i),h=i.filter(f=>!s.has(f.description.identifier)),b=d.filter(f=>!l.has(f.description.identifier));return new E(h,b)}constructor(d,i){this.added=d,this.removed=i}}e.ExtensionPointUserDelta=E;class n{constructor(d,i){this.name=d,this.defaultExtensionKind=i,this._handler=null,this._users=null,this._delta=null}setHandler(d){if(this._handler!==null)throw new Error("Handler already set!");this._handler=d,this._handle()}acceptUsers(d){this._delta=E.compute(this._users,d),this._users=d,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(d){(0,F.onUnexpectedError)(d)}}}e.ExtensionPoint=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:S.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this._extensionPoints=new Map}registerExtensionPoint(d){if(this._extensionPoints.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const i=new n(d.extensionPoint,d.defaultExtensionKind);return this._extensionPoints.set(d.extensionPoint,i),d.activationEventsGenerator&&I.ImplicitActivationEvents.register(d.extensionPoint,d.activationEventsGenerator),e.schema.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,u.registerSchema(t,e.schema),i}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=r;const a={ExtensionsRegistry:"ExtensionsRegistry"};g.Registry.add(a.ExtensionsRegistry,new r),e.ExtensionsRegistry=g.Registry.as(a.ExtensionsRegistry),u.registerSchema(t,e.schema),u.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[228],Te([1,0,175,16,26,227,35,5]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var w;(function(u){function p(E,n,o){if(!E)return;const t=F.isString(E.type)?E.type:void 0;if(!t||t.length===0){o.error(S.localize(3,null));return}const r=[];if(Array.isArray(E.required))for(const a of E.required)F.isString(a)&&r.push(a);return{extensionId:n.value,taskType:t,required:r,properties:E.properties?D.deepClone(E.properties):{},when:E.when?T.ContextKeyExpr.deserialize(E.when):void 0}}u.from=p})(w||(w={}));const A=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,p)=>{for(const E of u)E.type&&p.push(`onTaskType:${E.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:m}});class I{constructor(){this._onDefinitionsChanged=new g.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((p,E)=>{A.setHandler((n,o)=>{this._schema=void 0;try{for(const t of o.removed){const r=t.value;for(const a of r)this.taskTypes&&a.type&&this.taskTypes[a.type]&&delete this.taskTypes[a.type]}for(const t of o.added){const r=t.value;for(const a of r){const c=w.from(a,t.description.identifier,t.collector);c&&(this.taskTypes[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}p(void 0)})})}onReady(){return this.readyPromise}get(p){return this.taskTypes[p]}all(){return Object.keys(this.taskTypes).map(p=>this.taskTypes[p])}getJsonSchema(){if(this._schema===void 0){const p=[];for(const E of this.all()){const n={type:"object",additionalProperties:!1};E.required.length>0&&(n.required=E.required.slice(0)),E.properties!==void 0?n.properties=D.deepClone(E.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[E.taskType]},p.push(n)}this._schema={oneOf:p}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(Pe[229],Te([1,0,176,16,25,26,35,228]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,S.localize(0,null)),e.TASKS_CATEGORY={value:S.localize(1,null),original:"Tasks"};var m;(function(k){k[k.Escape=1]="Escape",k[k.Strong=2]="Strong",k[k.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(k){function P(Q){if(!Q)return k.Strong;switch(Q.toLowerCase()){case"escape":return k.Escape;case"strong":return k.Strong;case"weak":return k.Weak;default:return k.Strong}}k.from=P}(m||(e.ShellQuoting=m={}));var w;(function(k){k.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(k){k[k.Always=1]="Always",k[k.Silent=2]="Silent",k[k.Never=3]="Never"})(A||(e.RevealKind=A={})),function(k){function P(Q){switch(Q.toLowerCase()){case"always":return k.Always;case"silent":return k.Silent;case"never":return k.Never;default:return k.Always}}k.fromString=P}(A||(e.RevealKind=A={}));var I;(function(k){k[k.Never=1]="Never",k[k.OnProblem=2]="OnProblem",k[k.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(k){function P(Q){switch(Q.toLowerCase()){case"always":return k.Always;case"never":return k.Never;case"onproblem":return k.OnProblem;default:return k.OnProblem}}k.fromString=P}(I||(e.RevealProblemKind=I={}));var u;(function(k){k[k.Shared=1]="Shared",k[k.Dedicated=2]="Dedicated",k[k.New=3]="New"})(u||(e.PanelKind=u={})),function(k){function P(Q){switch(Q.toLowerCase()){case"shared":return k.Shared;case"dedicated":return k.Dedicated;case"new":return k.New;default:return k.Shared}}k.fromString=P}(u||(e.PanelKind=u={}));var p;(function(k){k.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var E;(function(k){k[k.Shell=1]="Shell",k[k.Process=2]="Process",k[k.CustomExecution=3]="CustomExecution"})(E||(e.RuntimeType=E={})),function(k){function P(ae){switch(ae.toLowerCase()){case"shell":return k.Shell;case"process":return k.Process;case"customExecution":return k.CustomExecution;default:return k.Process}}k.fromString=P;function Q(ae){switch(ae){case k.Shell:return"shell";case k.Process:return"process";case k.CustomExecution:return"customExecution";default:return"process"}}k.toString=Q}(E||(e.RuntimeType=E={}));var n;(function(k){function P(Q){return F.isString(Q)?Q:Q.value}k.value=P})(n||(e.CommandString=n={}));var o;(function(k){k.Clean={_id:"clean",isDefault:!1},k.Build={_id:"build",isDefault:!1},k.Rebuild={_id:"rebuild",isDefault:!1},k.Test={_id:"test",isDefault:!1};function P(ae){return ae===k.Clean._id||ae===k.Build._id||ae===k.Rebuild._id||ae===k.Test._id}k.is=P;function Q(ae){if(ae!==void 0)return F.isString(ae)?P(ae)?{_id:ae,isDefault:!1}:void 0:ae}k.from=Q})(o||(e.TaskGroup=o={}));var t;(function(k){k[k.Global=1]="Global",k[k.Workspace=2]="Workspace",k[k.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var r;(function(k){k.Workspace="workspace",k.Extension="extension",k.InMemory="inMemory",k.WorkspaceFile="workspaceFile",k.User="user";function P(Q){switch(Q){case k.User:return 2;case k.WorkspaceFile:return 5;default:return 6}}k.toConfigurationTarget=P})(r||(e.TaskSourceKind=r={}));var a;(function(k){k.parallel="parallel",k.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(k){k[k.default=1]="default",k[k.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var d;(function(k){k.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class i{constructor(P,Q,ae,me,Ee,Ce){this._label="",this._id=P,Q&&(this._label=Q),ae&&(this.type=ae),this.runOptions=me,this.configurationProperties=Ee,this._source=Ce}getDefinition(P){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const P={folder:this.getFolderId(),id:this._id};return JSON.stringify(P)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(P,Q=!1){if(P===void 0)return!1;if(F.isString(P))return P===this._label||P===this.configurationProperties.identifier||Q&&P===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===P._key}getQualifiedLabel(){const P=this.getWorkspaceFolder();return P?`${this._label} (${P.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(P){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),P&&(this._taskLoadMessages=this._taskLoadMessages.concat(P))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class s extends i{constructor(P,Q,ae,me,Ee,Ce,he,de){super(P,ae,void 0,he,de,Q),this.command={},this._source=Q,this.hasDefinedMatchers=Ce,Ee&&(this.command=Ee)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(P=!1){if(P&&this._source.customizes!==void 0)return this._source.customizes;{let Q;switch(this.command?this.command.runtime:void 0){case E.Shell:Q="shell";break;case E.Process:Q="process";break;case E.CustomExecution:Q="customExecution";break;case void 0:Q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Q,_key:this._id,id:this._id}}}static is(P){return P instanceof s}getMapKey(){const P=this._source.config.workspaceFolder;return P?`${P.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===r.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const P=this.getFolderId();if(!P)return;let Q=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Q+=this._source.kind);const ae={type:e.CUSTOMIZED_TASK_TYPE,folder:P,id:Q};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(P){return new s(P._id,P._source,P._label,P.type,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.CustomTask=s;class l extends i{constructor(P,Q,ae,me,Ee,Ce,he){super(P,ae,me,Ce,he,Q),this._source=Q,this.configures=Ee}static is(P){return P instanceof l}fromObject(P){return P}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===r.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const P=this.getFolderId();if(!P)return;let Q=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Q+=this._source.kind);const ae={type:e.CUSTOMIZED_TASK_TYPE,folder:P,id:Q};return JSON.stringify(ae)}}e.ConfiguringTask=l;class h extends i{constructor(P,Q,ae,me,Ee,Ce,he,de,te){super(P,ae,me,de,te,Q),this.defines=Ee,this.hasDefinedMatchers=he,this.command=Ce,this.icon=te.icon,this.hide=te.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(P){return P instanceof h}getMapKey(){const P=this._source.workspaceFolder;return P?`${this._source.scope.toString()}|${P.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const P={type:"contributed",scope:this._source.scope,id:this._id};return P.folder=this.getFolderId(),JSON.stringify(P)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(P){return new h(P._id,P._source,P._label,P.type,P.defines,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.ContributedTask=h;class b extends i{constructor(P,Q,ae,me,Ee,Ce){super(P,ae,me,Ee,Ce,Q),this._source=Q}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(P){return P instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(P){return new b(P._id,P._source,P._label,P.type,P.runOptions,P.configurationProperties)}}e.InMemoryTask=b;var f;(function(k){k[k.Process=1]="Process",k[k.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(k){k._default=k.Terminal}(f||(e.ExecutionEngine=f={}));var C;(function(k){k[k.V0_1_0=1]="V0_1_0",k[k.V2_0_0=2]="V2_0_0"})(C||(e.JsonSchemaVersion=C={}));class O{constructor(P){this._order=new Map;for(let Q=0;Q<P.length;Q++)this._order.set(P[Q].uri.toString(),Q)}compare(P,Q){const ae=P.getWorkspaceFolder(),me=Q.getWorkspaceFolder();if(ae&&me){let Ee=this._order.get(ae.uri.toString());Ee=Ee===void 0?0:Ee+1;let Ce=this._order.get(me.uri.toString());return Ce=Ce===void 0?0:Ce+1,Ee===Ce?P._label.localeCompare(Q._label):Ee-Ce}else return!ae&&me?-1:ae&&!me?1:0}}e.TaskSorter=O;var v;(function(k){k.DependsOnStarted="dependsOnStarted",k.AcquiredInput="acquiredInput",k.Start="start",k.ProcessStarted="processStarted",k.Active="active",k.Inactive="inactive",k.Changed="changed",k.Terminated="terminated",k.ProcessEnded="processEnded",k.End="end"})(v||(e.TaskEventKind=v={}));var _;(function(k){k.SingleRun="singleRun",k.Background="background"})(_||(e.TaskRunType=_={}));var y;(function(k){k[k.System=0]="System",k[k.User=1]="User",k[k.FolderOpen=2]="FolderOpen",k[k.ConfigurationChange=3]="ConfigurationChange",k[k.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var M;(function(k){function P(de){return{taskId:de._id,taskName:de.configurationProperties.name,runType:de.configurationProperties.isBackground?"background":"singleRun",group:de.configurationProperties.group,__task:de}}function Q(de,te,Ie){return{...P(de),kind:"start",terminalId:te,resolvedVariables:Ie}}k.start=Q;function ae(de,te,Ie){return{...P(de),kind:"processStarted",terminalId:te,processId:Ie}}k.processStarted=ae;function me(de,te,Ie){return{...P(de),kind:"processEnded",terminalId:te,exitCode:Ie}}k.processEnded=me;function Ee(de,te,Ie){return{...P(de),kind:"terminated",exitReason:Ie,terminalId:te}}k.terminated=Ee;function Ce(de,te,Ie){return{...P(te),kind:de,terminalId:Ie}}k.general=Ce;function he(){return{kind:"changed"}}k.changed=he})(M||(e.TaskEvent=M={}));var V;(function(k){function P(ae){const me=Object.keys(ae).sort();let Ee="";for(const Ce of me){let he=ae[Ce];he instanceof Object?he=P(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),Ee+=Ce+","+he+","}return Ee}function Q(ae){const Ee={_key:P(ae),type:ae.taskType};return Object.assign(Ee,ae),Ee}k.create=Q})(V||(e.KeyedTaskIdentifier=V={}));var $;(function(k){k.AutoDetect="task.autoDetect",k.SaveBeforeRun="task.saveBeforeRun",k.ShowDecorations="task.showDecorations",k.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",k.SlowProviderWarning="task.slowProviderWarning",k.QuickOpenHistory="task.quickOpen.history",k.QuickOpenDetail="task.quickOpen.detail",k.QuickOpenSkip="task.quickOpen.skip",k.QuickOpenShowAll="task.quickOpen.showAll",k.AllowAutomaticTasks="task.allowAutomaticTasks",k.Reconnection="task.reconnection",k.VerboseLogging="task.verboseLogging"})($||(e.TaskSettingId=$={}));var L;(function(k){k.Tasks="tasks",k.SuppressTaskName="tasks.suppressTaskName",k.Windows="tasks.windows",k.Osx="tasks.osx",k.Linux="tasks.linux",k.ShowOutput="tasks.showOutput",k.IsShellCommand="tasks.isShellCommand",k.ServiceTestSetting="tasks.service.testSetting"})(L||(e.TasksSchemaProperties=L={}));var U;(function(k){function P(Q,ae){const me=g.TaskDefinitionRegistry.get(Q.type);if(me===void 0){const de=R.deepClone(Q);return delete de._key,V.create(de)}const Ee=Object.create(null);Ee.type=me.taskType;const Ce=new Set;me.required.forEach(de=>Ce.add(de));const he=me.properties;for(const de of Object.keys(he)){const te=Q[de];if(te!=null)Ee[de]=te;else if(Ce.has(de)){const Ie=he[de];if(Ie.default!==void 0)Ee[de]=R.deepClone(Ie.default);else switch(Ie.type){case"boolean":Ee[de]=!1;break;case"number":case"integer":Ee[de]=0;break;case"string":Ee[de]="";break;default:ae.error(S.localize(2,null,JSON.stringify(Q,void 0,0),de));return}}}return V.create(Ee)}k.createTaskIdentifier=P})(U||(e.TaskDefinition=U={}))}),define(Pe[230],Te([1,0,11]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,g)=>{this._actualOk=T,this._actualErr=g,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,S.onUnexpectedError)(T))}then(T,g){return this._ensureActual().then(T,g)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=F;class D extends F{constructor(){super(),this._hasErr=!0,this._err=new S.CancellationError}}e.CanceledLazyPromise=D}),define(Pe[49],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class S{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++S.count}}e.ProxyIdentifier=S;const F=[];function D(g){const m=new S(g);return F[m.nid]=m,m}e.createProxyIdentifier=D;function R(g){return F[g].sid}e.getStringIdentifierForProxy=R;class T{constructor(m){this.value=m}}e.SerializableObjectWithBuffers=T}),define(Pe[3],Te([1,0,49]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var D;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput"})(D||(e.TabInputKind=D={}));var R;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var T;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var g;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var m;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var w;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this._n=0}static mixin(o){return o._id=I._n++,o}}e.IdObject=I;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var p;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var E;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(E||(e.ExtHostTestingResource=E={})),e.MainContext={MainThreadAuthentication:(0,S.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.createProxyIdentifier)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,S.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,S.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,S.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,S.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,S.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,S.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,S.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,S.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,S.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,S.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,S.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,S.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,S.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,S.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,S.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,S.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,S.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,S.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Pe[231],Te([1,0,3,7]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class D{constructor(T){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(S.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,g,m){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const w=this._relatedInformationProviders.get(T);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(g,m)??[]}getRelatedInformation(T,g,m){return this._proxy.$getAiRelatedInformation(g,m)}registerRelatedInformationProvider(T,g,m){const w=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(w,m),this._proxy.$registerAiRelatedInformationProvider(w,g),new F.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(w),this._relatedInformationProviders.delete(w)})}}e.ExtHostRelatedInformation=D}),define(Pe[81],Te([1,0,4,15,3,17]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,S.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(m,w){this._extHostLogService=w,this._reportedUsages=new Set,this._telemetryShape=m.getProxy(D.MainContext.MainThreadTelemetry)}report(m,w,A){const I=this.getUsageKey(m,w);this._reportedUsages.has(I)||(this._reportedUsages.add(I),w.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${m}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:m}))}getUsageKey(m,w){return`${m}-${w.identifier.value}`}};e.ExtHostApiDeprecationService=T,e.ExtHostApiDeprecationService=T=je([Ve(0,R.IExtHostRpcService),Ve(1,F.ILogService)],T),e.NullApiDeprecationService=Object.freeze(new class{report(g,m,w){}})}),define(Pe[232],Te([1,0,5,3,7,22]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new S.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new g,this._getSessionsTaskSingler=new g,this._proxy=w.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,A,I,u={}){const p=R.ExtensionIdentifier.toKey(w.identifier),E=[...I].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${p} ${A} ${E}`,async()=>{await this._proxy.$ensureProvider(A);const n=w.displayName||w.name;return this._proxy.$getSession(A,I,p,n,u)})}async getSessions(w,A,I){const u=R.ExtensionIdentifier.toKey(w.identifier),p=[...I].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${u} ${p}`,async()=>{await this._proxy.$ensureProvider(A);const E=w.displayName||w.name;return this._proxy.$getSessions(A,I,u,E)})}async removeSession(w,A){const I=this._authenticationProviders.get(w);return I?I.provider.removeSession(A):this._proxy.$removeSession(w,A)}registerAuthenticationProvider(w,A,I,u){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:A,provider:I,options:u??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===w)||this._providers.push({id:w,label:A});const p=I.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(w,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,A,u?.supportsMultipleAccounts??!1),new D.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(w);const E=this._providers.findIndex(n=>n.id===w);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,A,I){const u=this._authenticationProviders.get(w);if(u)return Promise.resolve(u.provider.createSession(A,I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const I=this._authenticationProviders.get(w);if(I)return Promise.resolve(I.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const I=this._authenticationProviders.get(w);if(I)return Promise.resolve(I.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this._onDidChangeSessions.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T;class g{constructor(){this._inFlightPromises=new Map}getOrCreate(w,A){const I=this._inFlightPromises.get(w);if(I)return I;const u=A().finally(()=>this._inFlightPromises.delete(w));return this._inFlightPromises.set(w,u),u}}}),define(Pe[233],Te([1,0,3,17,8]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(g,m){this._proxy=g.getProxy(S.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:w=>m.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,m,w){const A=D.WorkspaceEdit.from(g,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.ExtHostBulkEdits=R,e.ExtHostBulkEdits=R=je([Ve(0,F.IExtHostRpcService)],R)}),define(Pe[234],Te([1,0,5,67,6,3,8]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class g{static{this._pool=0}constructor(A,I){this.extension=A,this.provider=I,this.handle=g._pool++}}class m{static{this._nextId=0}constructor(A){this._chatProvider=new Map,this._chatSessions=new Map,this._onDidPerformUserAction=new S.Emitter,this.onDidPerformUserAction=this._onDidPerformUserAction.event,this._proxy=A.getProxy(R.MainContext.MainThreadChat)}registerChatProvider(A,I,u){const p=new g(A,u);return this._chatProvider.set(p.handle,p),this._proxy.$registerChatProvider(p.handle,I),(0,D.toDisposable)(()=>{this._proxy.$unregisterChatProvider(p.handle),this._chatProvider.delete(p.handle)})}transferChatSession(A,I){const u=F.Iterable.find(this._chatSessions.keys(),p=>this._chatSessions.get(p)===A)??0;typeof u=="number"&&this._proxy.$transferChatSession(u,I)}sendInteractiveRequestToProvider(A,I){this._proxy.$sendRequestToProvider(A,I)}async $prepareChat(A,I){const u=this._chatProvider.get(A);if(!u)return;const p=await u.provider.prepareSession(I);if(!p)return;const E=m._nextId++;return this._chatSessions.set(E,p),{id:E,requesterUsername:p.requester?.name,requesterAvatarIconUri:p.requester?.icon,responderUsername:p.responder?.name,responderAvatarIconUri:p.responder?.icon,inputPlaceholder:p.inputPlaceholder}}async $provideWelcomeMessage(A,I){const u=this._chatProvider.get(A);if(!u||!u.provider.provideWelcomeMessage)return;const p=await u.provider.provideWelcomeMessage(I);if(p)return p.map(E=>typeof E=="string"?E:Array.isArray(E)?E.map(n=>T.ChatReplyFollowup.from(n)):T.MarkdownString.from(E))}async $provideSampleQuestions(A,I){const u=this._chatProvider.get(A);if(!u||!u.provider.provideSampleQuestions)return;const p=await u.provider.provideSampleQuestions(I);if(p)return p?.map(E=>T.ChatReplyFollowup.from(E))}$releaseSession(A){this._chatSessions.delete(A)}async $onDidPerformUserAction(A){this._onDidPerformUserAction.fire(A)}}e.ExtHostChat=m}),define(Pe[235],Te([1,0,14,20,40,5,60,16,2,157,72,3,8,7,206,23]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class o{static{this._idPool=0}constructor(a,c,d){this._extHostChatProvider=c,this._logService=d,this._agents=new Map,this._previousResultMap=new Map,this._resultsBySessionAndRequestId=new Map,this._proxy=a.getProxy(I.MainContext.MainThreadChatAgents2)}createChatAgent(a,c,d){const i=o._idPool++,s=new t(a,c,this._proxy,i,d);return this._agents.set(i,s),this._proxy.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(a,c,d,i,s,l){this._previousResultMap.delete(c);const h=this._agents.get(a);if(!h)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let b=!1;function f(){if(b)throw new Error("Only valid while executing the command")}const C=new S.DeferredPromise;l.onCancellationRequested(()=>C.complete()),setTimeout(()=>C.complete(),10*1e3),this._extHostChatProvider.allowListExtensionWhile(h.extension.identifier,C.p);const O=i.command?await h.validateSlashCommand(i.command):void 0,v=T.StopWatch.create(!1);let _;try{const y=h.invoke({prompt:i.message,variables:u.ChatVariable.objectTo(i.variables),slashCommand:O},{history:s.history.map(u.ChatMessage.to)},new A.Progress(M=>{f(),typeof _>"u"&&"content"in M&&(_=v.elapsed());const V=u.ChatResponseProgress.from(h.extension,M);if(!V){this._logService.error("Unknown progress type: "+JSON.stringify(M));return}if("placeholder"in M&&"resolvedContent"in M){const $=Promise.all([this._proxy.$handleProgressChunk(d,V),M.resolvedContent]);(0,S.raceCancellation)($,l).then(L=>{if(!L)return;const[U,k]=L,P=u.ChatResponseProgress.from(h.extension,k);if(!P){this._logService.error("Unknown progress type: "+JSON.stringify(k));return}this._proxy.$handleProgressChunk(d,P,U??void 0)})}else this._proxy.$handleProgressChunk(d,V)}),l);return await(0,S.raceCancellation)(Promise.resolve(y).then(M=>{if(M){this._previousResultMap.set(c,M);let V=this._resultsBySessionAndRequestId.get(c);V||(V=new Map,this._resultsBySessionAndRequestId.set(c,V)),V.set(d,M);const $={firstProgress:_,totalElapsed:v.elapsed()};return{errorDetails:M.errorDetails,timings:$}}else this._previousResultMap.delete(c)}),l)}catch(y){return this._logService.error(y,h.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,D.toErrorMessage)(y)),responseIsIncomplete:!0}}}finally{b=!0,C.complete()}}$releaseSession(a){this._previousResultMap.delete(a),this._resultsBySessionAndRequestId.delete(a)}async $provideSlashCommands(a,c){const d=this._agents.get(a);return d?d.provideSlashCommand(c):[]}$provideFollowups(a,c,d){const i=this._agents.get(a);if(!i)return Promise.resolve([]);const s=this._previousResultMap.get(c);return s?i.provideFollowups(s,d):Promise.resolve([])}$acceptFeedback(a,c,d,i,s){const l=this._agents.get(a);if(!l)return;const h=this._resultsBySessionAndRequestId.get(c)?.get(d);if(!h)return;let b;switch(i){case E.InteractiveSessionVoteDirection.Down:b=p.ChatAgentResultFeedbackKind.Unhelpful;break;case E.InteractiveSessionVoteDirection.Up:b=p.ChatAgentResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(s?{result:h,kind:b,reportIssue:s}:{result:h,kind:b}))}$acceptAction(a,c,d,i){const s=this._agents.get(a);if(!s)return;const l=this._resultsBySessionAndRequestId.get(c)?.get(d);l&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:l}))}async $invokeCompletionProvider(a,c,d){const i=this._agents.get(a);return i?(await i.invokeCompletionProvider(c,d)).map(u.ChatAgentCompletionItem.from):[]}}e.ExtHostChatAgents2=o;class t{constructor(a,c,d,i,s){this.extension=a,this._id=c,this._proxy=d,this._handle=i,this._callback=s,this._onDidReceiveFeedback=new R.Emitter,this._onDidPerformAction=new R.Emitter}acceptFeedback(a){this._onDidReceiveFeedback.fire(a)}acceptAction(a){this._onDidPerformAction.fire(a)}async invokeCompletionProvider(a,c){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this._lastSlashCommands||(await this.provideSlashCommand(F.CancellationToken.None),(0,g.assertType)(this._lastSlashCommands));const c=this._lastSlashCommands.find(d=>d.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this._slashCommandProvider)return[];const c=await this._slashCommandProvider.provideSlashCommands(a);return c?(this._lastSlashCommands=c,c.map(d=>({name:d.name,description:d.description,followupPlaceholder:d.followupPlaceholder,shouldRepopulate:d.shouldRepopulate,sampleRequest:d.sampleRequest}))):[]}async provideFollowups(a,c){if(!this._followupProvider)return[];const d=await this._followupProvider.provideFollowups(a,c);return d?d.map(i=>u.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const d=()=>{a||c||(c=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{description:this._description??"",fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof m.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof p.ThemeIcon?this._iconPath:void 0,hasSlashCommands:this._slashCommandProvider!==void 0,hasFollowups:this._followupProvider!==void 0,isDefault:this._isDefault,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:u.MarkdownString.from(this._helpTextPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:u.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting}),c=!1}))},i=this;return{get name(){return i._id},get description(){return i._description??""},set description(s){i._description=s,d()},get fullName(){return i._fullName??i.extension.displayName??i.extension.name},set fullName(s){i._fullName=s,d()},get iconPath(){return i._iconPath},set iconPath(s){i._iconPath=s,d()},get slashCommandProvider(){return i._slashCommandProvider},set slashCommandProvider(s){i._slashCommandProvider=s,d()},get followupProvider(){return i._followupProvider},set followupProvider(s){i._followupProvider=s,d()},get isDefault(){return(0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),i._isDefault},set isDefault(s){(0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),i._isDefault=s,d()},get helpTextPrefix(){return(0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),i._helpTextPrefix},set helpTextPrefix(s){if((0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),!i._isDefault)throw new Error("helpTextPrefix is only available on the default chat agent");i._helpTextPrefix=s,d()},get helpTextPostfix(){return(0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),i._helpTextPostfix},set helpTextPostfix(s){if((0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),!i._isDefault)throw new Error("helpTextPostfix is only available on the default chat agent");i._helpTextPostfix=s,d()},get isSecondary(){return(0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),i._isSecondary},set isSecondary(s){(0,n.checkProposedApiEnabled)(i.extension,"defaultChatAgent"),i._isSecondary=s,d()},get sampleRequest(){return i._sampleRequest},set sampleRequest(s){i._sampleRequest=s,d()},get supportIssueReporting(){return(0,n.checkProposedApiEnabled)(i.extension,"chatAgents2Additions"),i._supportIssueReporting},set supportIssueReporting(s){(0,n.checkProposedApiEnabled)(i.extension,"chatAgents2Additions"),i._supportIssueReporting=s,d()},get onDidReceiveFeedback(){return i._onDidReceiveFeedback.event},set agentVariableProvider(s){if(i._agentVariableProvider=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i._proxy.$registerAgentCompletionsProvider(i._handle,s.triggerCharacters)}else i._proxy.$unregisterAgentCompletionsProvider(i._handle)},get agentVariableProvider(){return i._agentVariableProvider},onDidPerformAction:(0,n.isProposedApiEnabled)(this.extension,"chatAgents2Additions")?this._onDidPerformAction.event:void 0,dispose(){a=!0,i._slashCommandProvider=void 0,i._followupProvider=void 0,i._onDidReceiveFeedback.dispose(),i._proxy.$unregisterAgent(i._handle)}}}invoke(a,c,d,i){return this._callback(a,c,d,i)}}}),define(Pe[236],Te([1,0,20,6,3,8,72,22,14,5]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatProvider=void 0;class A{constructor(E,n){this.stream=new m.AsyncIterableSource,this.stream=n??new m.AsyncIterableSource;const o=this;this.apiObj={option:E,response:o.stream.asyncIterable}}}class I{constructor(E,n){this._onDidStart=new w.Emitter,this._responseStreams=new Map,this._defaultStream=new m.AsyncIterableSource,this._isDone=!1;const o=this;this.apiObject={result:E,response:o._defaultStream.asyncIterable,onDidStartResponseStream:o._onDidStart.event,cancel(){n.cancel()}},E.finally(()=>{if(this._isDone=!0,this._responseStreams.size>0)for(const[,t]of this._responseStreams)t.stream.resolve();else this._defaultStream.resolve()})}handleFragment(E){if(this._isDone)return;let n=this._responseStreams.get(E.index);n||(this._responseStreams.size===0?n=new A(E.index,this._defaultStream):n=new A(E.index),this._responseStreams.set(E.index,n),this._onDidStart.fire(n.apiObj)),n.stream.emitOne(E.part)}}class u{static{this._idPool=1}constructor(E,n){this._logService=n,this._providers=new Map,this._pendingRequest=new Map,this._chatAccessAllowList=new g.ExtensionIdentifierMap,this._proxy=E.getProxy(D.MainContext.MainThreadChatProvider)}registerProvider(E,n,o,t){const r=u._idPool++;return this._providers.set(r,{extension:E,provider:o}),this._proxy.$registerProvider(r,n,{extension:E,model:t.name??""}),(0,F.toDisposable)(()=>{this._proxy.$unregisterProvider(r),this._providers.delete(r)})}async $provideChatResponse(E,n,o,t,r){const a=this._providers.get(E);if(!a)return;const c=new T.Progress(async d=>{if(r.isCancellationRequested){this._logService.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(n,{index:d.index,part:d.part})});return a.provider.provideChatResponse(o.map(R.ChatMessage.to),t,c,r)}allowListExtensionWhile(E,n){this._chatAccessAllowList.set(E,n),n.finally(()=>this._chatAccessAllowList.delete(E))}async requestChatResponseProvider(E,n){if(!this._chatAccessAllowList.has(E))throw new Error("Extension is NOT allowed to make chat requests");const o=await this._proxy.$prepareChatAccess(n);if(!o)throw new Error(`ChatAccess '${n}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t._chatAccessAllowList.has(E)},makeRequest(r,a,c){if(!t._chatAccessAllowList.has(E))throw new Error("Access to chat has been revoked");const d=new S.CancellationTokenSource(c),i=Math.random()*1e6|0,s=t._proxy.$fetchResponse(E,n,i,r.map(R.ChatMessage.from),a??{},d.token),l=new I(s,d);return t._pendingRequest.set(i,{res:l}),s.finally(()=>{t._pendingRequest.delete(i)}),l.apiObject}}}async $handleResponseFragment(E,n){const o=this._pendingRequest.get(E);o&&o.res.handleFragment(n)}}e.ExtHostChatProvider=u}),define(Pe[237],Te([1,0,6,3,11,8]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class T{static{this._idPool=0}constructor(m){this._resolver=new Map,this._proxy=m.getProxy(F.MainContext.MainThreadChatVariables)}async $resolveVariable(m,w,A){const I=this._resolver.get(m);if(I)try{const u=await I.resolver.resolve(I.data.name,{message:w},A);if(u)return u.map(R.ChatVariable.from)}catch(u){(0,D.onUnexpectedExternalError)(u)}}registerVariableResolver(m,w,A,I){const u=T._idPool++;return this._resolver.set(u,{extension:m.identifier,data:{name:w,description:A},resolver:I}),this._proxy.$registerVariable(u,{name:w,description:A}),(0,S.toDisposable)(()=>{this._resolver.delete(u),this._proxy.$unregisterVariable(u)})}}e.ExtHostChatVariables=T}),define(Pe[238],Te([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(R){const T=R.getProxy(S.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(g){return T.$writeText(g)}})}}e.ExtHostClipboard=F}),define(Pe[32],Te([1,0,16,7,8,26,3,18,15,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{#e;#t;#i;constructor(v,_,y){this._commands=new Map,this._apiCommands=new Map,this.#e=v.getProxy(T.MainContext.MainThreadCommands),this._logService=_,this.#i=y,this.#t=v.getProxy(T.MainContext.MainThreadTelemetry),this.converter=new h(this,M=>{const V=this._apiCommands.get(M);return V?.result===f.Void?V:void 0},_),this._argumentProcessors=[{processArgument(M){return(0,w.revive)(M)}},{processArgument(M){return(0,R.cloneAndChange)(M,function(V){if(A.Range.isIRange(V))return D.Range.to(V);if(I.Position.isIPosition(V))return D.Position.to(V);if(A.Range.isIRange(V.range)&&u.URI.isUri(V.uri))return D.location.to(V);if(V instanceof t.VSBuffer)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const _=this.registerCommand(!1,v.id,async(...y)=>{const M=v.args.map(($,L)=>{if(!$.validate(y[L]))throw new Error(`Invalid argument '${$.name}' when running '${v.id}', received: ${typeof y[L]=="object"?JSON.stringify(y[L],null,"	"):y[L]} `);return $.convert(y[L])}),V=await this.executeCommand(v.internalId,...M);return v.result.convert(V,y,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new F.Disposable(()=>{_.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,_,y,M,V,$){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:y,thisArg:M,metadata:V,extension:$}),v&&this.#e.$registerCommand(_),new F.Disposable(()=>{this._commands.delete(_)&&v&&this.#e.$unregisterCommand(_)})}executeCommand(v,..._){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,_,!0)}async _doExecuteCommand(v,_,y){if(this._commands.has(v))return this.#e.$fireCommandActivationEvent(v),this._executeContributedCommand(v,_,!1);{let M=!1;const V=(0,R.cloneAndChange)(_,function($){if($ instanceof F.Position)return D.Position.from($);if($ instanceof F.Range)return D.Range.from($);if($ instanceof F.Location)return D.location.from($);if(F.NotebookRange.isNotebookRange($))return D.NotebookRange.from($);if($ instanceof ArrayBuffer)return M=!0,t.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return M=!0,t.VSBuffer.wrap($);if($ instanceof t.VSBuffer)return M=!0,$;if(!Array.isArray($))return $});try{const $=await this.#e.$executeCommand(v,M?new r.SerializableObjectWithBuffers(V):V,y);return(0,w.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this._doExecuteCommand(v,_,!1);throw $}}}async _executeContributedCommand(v,_,y){const M=this._commands.get(v);if(!M)throw new Error("Unknown command");const{callback:V,thisArg:$,metadata:L}=M;if(L?.args)for(let k=0;k<L.args.length;k++)try{(0,S.validateConstraint)(_[k],L.args[k].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${L.args[k].name}' - ${L.args[k].description}`)}const U=c.StopWatch.create();try{return await V.apply($,_)}catch(k){if(v===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(..._);P&&(v=P.command)}if(this._logService.error(k,v,M.extension?.identifier),!y)throw k;if(M.extension?.identifier){const P=this.#i.onExtensionError(M.extension.identifier,k);this._logService.trace("forwarded error to extension?",P,M.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.toErrorMessage)(k)),this.id=v,this.source=M.extension?.displayName??M.extension?.name}}}finally{this._reportTelemetry(M,v,U.elapsed())}}_reportTelemetry(v,_,y){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new d.TelemetryTrustedValue(_),duration:y})}$executeContributedCommand(v,..._){this._logService.trace("ExtHostCommands#$executeContributedCommand",v);const y=this._commands.get(v);return y?(_=_.map(M=>this._argumentProcessors.reduce((V,$)=>$.processArgument(V,y.extension?.identifier),M)),this._executeContributedCommand(v,_,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(_=>(v&&(_=_.filter(y=>y[0]!=="_")),_))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[_,y]of this._commands){const{metadata:M}=y;M&&(v[_]=M)}return Promise.resolve(v)}};e.ExtHostCommands=l,e.ExtHostCommands=l=je([Ve(0,n.IExtHostRpcService),Ve(1,m.ILogService),Ve(2,i.IExtHostTelemetry)],l),e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class h{constructor(v,_,y){this._commands=v,this._lookupApiCommand=_,this._logService=y,this.delegatingCommandId=`__vsc${(0,s.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,_){if(!v)return;const y={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return y;const M=this._lookupApiCommand(v.command);if(M)y.id=M.internalId,y.arguments=M.args.map((V,$)=>V.convert(v.arguments&&v.arguments[$]));else if((0,g.isNonEmptyArray)(v.arguments)){const V=`${v.command} /${++this._cachIdPool}`;this._cache.set(V,v),_.add((0,p.toDisposable)(()=>{this._cache.delete(V),this._logService.trace("CommandsConverter#DISPOSE",V)})),y.$ident=V,y.id=this.delegatingCommandId,y.arguments=[V],this._logService.trace("CommandsConverter#CREATE",v.command,V)}return y}fromInternal(v){return typeof v.$ident=="string"?this._cache.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const _=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.CommandsConverter=h;class b{static{this.Uri=new b("uri","Uri of a text document",v=>u.URI.isUri(v),v=>v)}static{this.Position=new b("position","A position in a text document",v=>F.Position.isPosition(v),D.Position.from)}static{this.Range=new b("range","A range in a text document",v=>F.Range.isRange(v),D.Range.from)}static{this.Selection=new b("selection","A selection in a text document",v=>F.Selection.isSelection(v),D.Selection.from)}static{this.Number=new b("number","",v=>typeof v=="number",v=>v)}static{this.String=new b("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=b.Arr(b.String)}static Arr(v){return new b(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,_=>Array.isArray(_)&&_.every(y=>v.validate(y)),_=>_.map(y=>v.convert(y)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",v=>v instanceof F.CallHierarchyItem,D.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",v=>v instanceof F.TypeHierarchyItem,D.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VSCodium TestItem",v=>v instanceof o.TestItemImpl,D.TestItem.from)}constructor(v,_,y,M){this.name=v,this.description=_,this.validate=y,this.convert=M}optional(){return new b(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,_){return new b(v??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b;class f{static{this.Void=new f("no result",v=>v)}constructor(v,_){this.description=v,this.convert=_}}e.ApiCommandResult=f;class C{constructor(v,_,y,M,V){this.id=v,this.internalId=_,this.description=y,this.args=M,this.result=V}}e.ApiCommand=C}),define(Pe[239],Te([1,0,18,13,2,80,96,35,32,8,7]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new m.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(w.DocumentHighlight.to))),new m.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,S.isFalsyOrEmpty)(n))return;class t extends A.SymbolInformation{static to(a){const c=new t(a.name,w.SymbolKind.to(a.kind),a.containerName||"",new A.Location(o[0],w.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=w.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return n.map(t.to)})),new m.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new m.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new m.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,new m.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new m.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new m.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new m.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new m.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(w.location.to))),new m.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(w.Hover.to))),new m.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>A.Position.isPosition(o)),n=>n.map(w.Position.from))],new m.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(o=>{let t;for(const r of o.reverse())t=new A.SelectionRange(w.Range.to(r),t);return t}))),new m.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.ApiCommandArgument.String.with("query","Search string")],new m.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(w.WorkspaceSymbol.to))),new m.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(w.CallHierarchyItem.to))),new m.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(w.CallHierarchyIncomingCall.to))),new m.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.ApiCommandArgument.CallHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(w.CallHierarchyOutgoingCall.to))),new m.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:w.Range.to(n.range),placeholder:n.text}})),new m.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("newName","The new symbol name")],new m.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return w.WorkspaceEdit.to(n)}})),new m.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(w.DocumentLink.to))),new m.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,T.decodeSemanticTokensDto)(n);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range.optional()],new m.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new m.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,T.decodeSemanticTokensDto)(n);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)})),new m.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,o,t)=>{if(!n)return new A.CompletionList([]);const r=n.suggestions.map(a=>w.CompletionItem.to(a,t));return new A.CompletionList(r,n.incomplete)})),new m.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position,m.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return w.SignatureHelp.to(n)})),new m.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,o,t)=>p(r=>new A.CodeLens(w.Range.to(r.range),r.command&&t.fromInternal(r.command)))(n))),new m.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.ApiCommandArgument.Uri,new m.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>A.Range.isRange(n),n=>A.Selection.isSelection(n)?w.Selection.from(n):w.Range.from(n)),m.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),m.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,o,t)=>p(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(r.command)}else{const a=new A.CodeAction(r.title,r.kind?new A.CodeActionKind(r.kind):void 0);return r.edit&&(a.edit=w.WorkspaceEdit.to(r.edit)),r.command&&(a.command=t.fromInternal(r.command)),a.isPreferred=r.isPreferred,a}})(n))),new m.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new A.ColorInformation(w.Range.to(o.range),w.Color.to(o.color))):[])),new m.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.ApiCommandArgument("color","The color to show and insert",n=>n instanceof A.Color,w.Color.from),new m.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:w.Range.from(n.range)}))],new m.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(w.ColorPresentation.to):[])),new m.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range],new m.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,o,t)=>n.map(w.InlayHint.to.bind(void 0,t)))),new m.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.ApiCommandArgument.Uri],new m.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(w.FoldingRange.to)})),new m.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>w.NotebookExclusiveDocumentPattern.to(o))})))),new m.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Range,new m.ApiCommandArgument("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof A.Range,n=>w.InlineValueContext.from(n))],new m.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(w.InlineValue.to))),new m.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>D.URI.isUri(n)||typeof n=="string"&&(0,F.matchesSomeScheme)(n,F.Schemas.http,F.Schemas.https),n=>n),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[w.ViewColumn.from(n),void 0]:[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)])).optional(),m.ApiCommandArgument.String.with("label","").optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.ApiCommandArgument.Uri.with("resource","Resource to open"),m.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[w.ViewColumn.from(n),void 0]:[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)])).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),m.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),m.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new m.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[w.ViewColumn.from(n.viewColumn),w.TextEditorOpenOptions.from(n)]).optional()],m.ApiCommandResult.Void),new m.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new m.ApiCommandArgument("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[t,r,a]=o;if(!D.URI.isUri(t)||!D.URI.isUri(r)&&r!==void 0&&r!==null||!D.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},n=>n)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.Position],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new m.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.ApiCommandArgument.TypeHierarchyItem],new m.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(w.TypeHierarchyItem.to))),new m.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.ApiCommandArgument.TestItem],m.ApiCommandResult.Void),new m.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.ApiCommandResult.Void),new m.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.ApiCommandArgument.String.with("name","The context key name"),new m.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],m.ApiCommandResult.Void),new m.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.ApiCommandArgument.Uri,m.ApiCommandArgument.StringArray,new m.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",n=>w.MappedEditsContext.is(n),n=>w.MappedEditsContext.from(n))],new m.ApiCommandResult("A promise that resolves to a workspace edit or null",n=>n?w.WorkspaceEdit.to(n):null))];class u{static register(o){I.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",g.validateWhenClauses)}}e.ExtHostApiCommands=u;function p(n){return o=>{if(Array.isArray(o))return o.map(n)}}function E(n){if(!Array.isArray(n))return;const o=[];for(const t of n)R.isLocationLink(t)?o.push(w.DefinitionLink.to(t)):o.push(w.location.to(t));return o}}),define(Pe[240],Te([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(E,n,o){const t=E.getProxy(I.MainContext.MainThreadComments);class r{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new m.ExtensionIdentifierMap,n.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const C=this._commentControllers.get(f.handle);return C?C.value:f}else if(f&&f.$mid===7){const C=this._commentControllers.get(f.commentControlHandle);if(!C)return f;const O=C.getCommentThread(f.commentThreadHandle);return O?O.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const C=this._commentControllers.get(f.thread.commentControlHandle);if(!C)return f;const O=C.getCommentThread(f.thread.commentThreadHandle);return O?f.$mid===8?O.value:{thread:O.value,text:f.text}:f}else if(f&&f.$mid===10){const C=this._commentControllers.get(f.thread.commentControlHandle);if(!C)return f;const O=C.getCommentThread(f.thread.commentThreadHandle);if(!O)return f;const v=f.commentUniqueId,_=O.getCommentByUniqueId(v);return _||f}else if(f&&f.$mid===11){const C=this._commentControllers.get(f.thread.commentControlHandle);if(!C)return f;const O=C.getCommentThread(f.thread.commentThreadHandle);if(!O)return f;const v=f.text,_=f.commentUniqueId,y=O.getCommentByUniqueId(_);return y?(typeof y.body=="string"?y.body=v:y.body=new A.MarkdownString(v),y):f}return f}})}createCommentController(f,C,O){const v=r.handlePool++,_=new c(f,v,C,O);this._commentControllers.set(_.handle,_);const y=this._commentControllersByExtension.get(f.identifier)||[];return y.push(_),this._commentControllersByExtension.set(f.identifier,y),_.value}async $createCommentThreadTemplate(f,C,O){const v=this._commentControllers.get(f);v&&v.$createCommentThreadTemplate(C,O)}async $updateCommentThreadTemplate(f,C,O){const v=this._commentControllers.get(f);v&&v.$updateCommentThreadTemplate(C,O)}$deleteCommentThread(f,C){this._commentControllers.get(f)?.$deleteCommentThread(C)}$provideCommentingRanges(f,C,O){const v=this._commentControllers.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const _=o.getDocument(T.URI.revive(C));return(0,S.asPromise)(async()=>{const y=await v.commentingRangeProvider.provideCommentingRanges(_,O);let M;return Array.isArray(y)?M={ranges:y,fileComments:!1}:y?M={ranges:y.ranges||[],fileComments:y.fileComments||!1}:M=y??void 0,M}).then(y=>{let M;return y&&(M={ranges:y.ranges.map(V=>w.Range.from(V)),fileComments:y.fileComments}),M})}$toggleReaction(f,C,O,v,_){const y=this._commentControllers.get(f);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,S.asPromise)(()=>{const M=y.getCommentThread(C);if(M){const V=M.getCommentByUniqueId(v.uniqueIdInThread);if(y!==void 0&&V&&y.reactionHandler)return y.reactionHandler(V,s(_))}return Promise.resolve(void 0)})}}class a{static{this._handlePool=0}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){(f===void 0!=(this._range===void 0)||!f||!this._range||!f.isEqual(this._range))&&(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(f){this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,C,O,v,_,y,M,V){this._commentControllerHandle=C,this._id=O,this._uri=v,this._range=_,this._comments=y,this.extensionDescription=M,this._isTemplate=V,this.handle=a._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),t.$createCommentThread(C,this.handle,this._id,this._uri,w.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{t.$deleteCommentThread(C,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(L){$.range=L},get comments(){return $.comments},set comments(L){$.comments=L},get collapsibleState(){return $.collapsibleState},set collapsibleState(L){$.collapsibleState=L},get canReply(){return $.canReply},set canReply(L){$.canReply=L},get contextValue(){return $.contextValue},set contextValue(L){$.contextValue=L},get label(){return $.label},set label(L){$.label=L},get state(){return $.state},set state(L){$.state=L},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const f=O=>Object.prototype.hasOwnProperty.call(this.modifications,O),C={};f("range")&&(C.range=w.Range.from(this._range)),f("label")&&(C.label=this.label),f("contextValue")&&(C.contextValue=this.contextValue??null),f("comments")&&(C.comments=this._comments.map(O=>d(this,O,this._commentsMap,this.extensionDescription))),f("collapsibleState")&&(C.collapseState=l(this._collapseState)),f("canReply")&&(C.canReply=this.canReply),f("state")&&(C.state=h(this._state)),f("isTemplate")&&(C.isTemplate=this._isTemplate),this.modifications={},t.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,C)}getCommentByUniqueId(f){for(const C of this._commentsMap){const O=C[0],v=C[1];if(f===v)return O}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}je([(0,F.debounce)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,t.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,C,O,v){this._extension=f,this._handle=C,this._id=O,this._label=v,this._threads=new Map,t.$registerCommentController(this.handle,O,v,this._extension.identifier.value);const _=this;this.value=Object.freeze({id:_.id,label:_.label,get options(){return _.options},set options(y){_.options=y},get commentingRangeProvider(){return _.commentingRangeProvider},set commentingRangeProvider(y){_.commentingRangeProvider=y},get reactionHandler(){return _.reactionHandler},set reactionHandler(y){_.reactionHandler=y},createCommentThread(y,M,V){return _.createCommentThread(y,M,V).value},dispose:()=>{_.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,C,O){C===void 0&&(0,u.checkProposedApiEnabled)(this._extension,"fileComments");const v=new a(this.id,this.handle,void 0,f,C,O,this._extension,!1);return this._threads.set(v.handle,v),v}$createCommentThreadTemplate(f,C){const O=new a(this.id,this.handle,void 0,T.URI.revive(f),w.Range.to(C),[],this._extension,!0);return O.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this._threads.set(O.handle,O),O}$updateCommentThreadTemplate(f,C){const O=this._threads.get(f);O&&(O.range=w.Range.to(C))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function d(b,f,C,O){let v=C.get(f);return v||(v=++b.commentHandle,C.set(f,v)),f.state!==void 0&&(0,u.checkProposedApiEnabled)(O,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:v,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(_=>i(_)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(b){return{label:b.label,iconPath:b.iconPath?w.pathOrURIToURI(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function s(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?T.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function l(b){if(b!==void 0)switch(b){case A.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function h(b){if(b!==void 0)switch(b){case A.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new r}e.createExtHostComments=p}),define(Pe[241],Te([1,0,26,3,27,17]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let T=class{constructor(A,I){this._mainThreadConsole=A.getProxy(F.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,I){const u=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){u._handleConsoleCall(A,I,p,arguments)}})}_handleConsoleCall(A,I,u,p){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:m(p,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,u,p)}};e.AbstractExtHostConsoleForwarder=T,e.AbstractExtHostConsoleForwarder=T=je([Ve(0,R.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],T);const g=1e5;function m(w,A){const I=[];if(w.length)for(let u=0;u<w.length;u++){let p=w[u];if(typeof p>"u")p="undefined";else if(p instanceof Error){const E=p;E.stack?p=E.stack:p=E.toString()}I.push(p)}if(A){const u=new Error().stack;u&&I.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,S.safeStringify)(I);return u.length>g?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[110],Te([1,0,2,3,7,4,17,15,18,12,19,23]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let p=class{static{u=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(n,o){this._logService=o,this._provider=new Map,this._proxy=n.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(n,o){const t=u._handlePool++;this._provider.set(t,{provider:n,extensionDescription:o}),this._proxy.$registerDecorationProvider(t,o.identifier.value);const r=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(a=>{if(!a){this._proxy.$onDidChange(t,null);return}const c=(0,m.asArray)(a);if(c.length<=u._maxEventSize){this._proxy.$onDidChange(t,c);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const d=c.map(l=>({uri:l,rank:(0,w.count)(l.path,"/")})),i=(0,m.groupBy)(d,(l,h)=>l.rank-h.rank||(0,w.compare)(l.uri.path,h.uri.path)),s=[];e:for(const l of i){let h;for(const b of l){const f=(0,A.dirname)(b.uri.path);if(h!==f&&(h=f,s.push(b.uri)>=u._maxEventSize))break e}}this._proxy.$onDidChange(t,s)});return new D.Disposable(()=>{r?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(n,o,t){if(!this._provider.has(n))return Object.create(null);const r=Object.create(null),{provider:a,extensionDescription:c}=this._provider.get(n);return await Promise.all(o.map(async d=>{try{const{uri:i,id:s}=d,l=await Promise.resolve(a.provideFileDecoration(S.URI.revive(i),t));if(!l)return;try{D.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,I.checkProposedApiEnabled)(c,"codiconDecoration"),r[s]=[l.propagate,l.tooltip,l.badge,l.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${c.identifier.value}': ${h}`)}}catch(i){this._logService.error(i)}})),r}};e.ExtHostDecorations=p,e.ExtHostDecorations=p=u=je([Ve(0,T.IExtHostRpcService),Ve(1,g.ILogService)],p),e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")}),define(Pe[242],Te([1,0,158,99,2,3,7,8,5,15,28,43]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{#e;#t;#i;constructor(o,t,r,a,c,d,i,s){this._name=o,this._owner=t,this._maxDiagnosticsTotal=r,this._maxDiagnosticsPerFile=a,this._modelVersionIdProvider=c,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(a,r),this.#i=new A.ResourceMap(l=>d.getComparisonKey(l)),this.#e=i,this.#t=s}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,t){if(!o){this.clear();return}this._checkDisposed();let r=[];if(D.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),r=[o]}else if(Array.isArray(o)){r=[];let d;o=[...o].sort(p._compareIndexedTuplesByUri);for(const i of o){const[s,l]=i;if((!d||s.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=s,r.push(s),this.#i.set(s,[])),l)this.#i.get(s)?.push(...l);else{const h=this.#i.get(s);h&&(h.length=0)}}}if(this.#t.fire(r),!this.#e)return;const a=[];let c=0;for(const d of r){let i=[];const s=this.#i.get(d);if(s)if(s.length>this._maxDiagnosticsPerFile){i=[];const l=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const b of s)if(b.severity===l[h]&&i.push({...g.Diagnostic.from(b),modelVersionId:this._modelVersionIdProvider(d)})===this._maxDiagnosticsPerFile)break e;i.push({severity:F.MarkerSeverity.Info,message:(0,S.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(l=>({...g.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(d)}));if(a.push([d,i]),c+=i.length,c>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,a)}delete(o){this._checkDisposed(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(o,t){this._checkDisposed();for(const[r,a]of this)o.call(t,r,a,this)}*[Symbol.iterator](){this._checkDisposed();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this._checkDisposed();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this.#i.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.DiagnosticCollection=p;let E=class{static{u=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*u._maxDiagnosticsPerFile}static _mapper(o){const t=new A.ResourceMap;for(const r of o)t.set(r,r);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,r,a){this._logService=t,this._fileSystemInfoService=r,this._extHostDocumentsAndEditors=a,this._collections=new Map,this._onDidChangeDiagnostics=new m.DebounceEmitter({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this._onDidChangeDiagnostics.event,u._mapper),this._proxy=o.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{_collections:r,_proxy:a,_onDidChangeDiagnostics:c,_logService:d,_fileSystemInfoService:i,_extHostDocumentsAndEditors:s}=this,l=new class{$changeMany(f,C){a.$changeMany(f,C),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,C.length===0?"CLEARING":C)}$clear(f){a.$clear(f),d.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let h;if(!t)t="_generated_diagnostic_collection_name_#"+u._idPool++,h=t;else if(!r.has(t))h=t;else{this._logService.warn(`DiagnosticCollection with name '${t}' does already exist.`);do h=t+u._idPool++;while(r.has(h))}return new class extends p{constructor(){super(t,h,u._maxDiagnosticsTotal,u._maxDiagnosticsPerFile,f=>s.getDocument(f)?.version,i.extUri,l,c),r.set(h,this)}dispose(){super.dispose(),r.delete(h)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const t=new Map,r=[];for(const a of this._collections.values())a.forEach((c,d)=>{let i=t.get(c.toString());typeof i>"u"&&(i=r.length,t.set(c.toString(),i),r.push([c,[]])),r[i][1]=r[i][1].concat(...d)});return r}}_getDiagnostics(o){let t=[];for(const r of this._collections.values())r.has(o)&&(t=t.concat(r.get(o)));return t}$acceptMarkersChange(o){if(!this._mirrorCollection){const t="_generated_mirror",r=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(t,r),this._mirrorCollection=r}for(const[t,r]of o)this._mirrorCollection.set(D.URI.revive(t),r.map(g.Diagnostic.to))}};e.ExtHostDiagnostics=E,e.ExtHostDiagnostics=E=u=je([Ve(1,w.ILogService),Ve(2,I.IExtHostFileSystemInfo)],E)}),define(Pe[243],Te([1,0,2,3,23]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(g){this._proxy=g.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(g,m){return m?.allowUIResources&&(0,D.checkProposedApiEnabled)(g,"showLocal"),this._proxy.$showOpenDialog(m).then(w=>w?w.map(A=>S.URI.revive(A)):void 0)}showSaveDialog(g){return this._proxy.$showSaveDialog(g).then(m=>m?S.URI.revive(m):void 0)}}e.ExtHostDialogs=R}),define(Pe[244],Te([1,0,11,2,7,3,13,20,12]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class w{static{this._handlePool=0}constructor(I,u,p){this._documentsAndEditors=u,this._logService=p,this._documentContentProviders=new Map,this._proxy=I.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,u){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const p=w._handlePool++;this._documentContentProviders.set(p,u),this._proxy.$registerTextContentProvider(p,I);let E;return typeof u.onDidChange=="function"&&(E=u.onDidChange(n=>{if(n.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(n)&&this.$provideTextDocumentContent(p,n).then(o=>{if(!o&&typeof o!="string")return;const t=this._documentsAndEditors.getDocument(n);if(!t)return;const r=(0,m.splitLines)(o);if(!t.equalLines(r))return this._proxy.$onVirtualDocumentChange(n,o)},S.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(I,u){const p=this._documentContentProviders.get(I);return p?Promise.resolve(p.provideTextDocumentContent(F.URI.revive(u),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=w}),define(Pe[245],Te([1,0,5,6,2,3,103,8,16,26,7,11]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class u{constructor(E,n){this._onDidAddDocument=new S.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidRemoveDocument=new S.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidChangeDocument=new S.Emitter({onListenerError:I.onUnexpectedExternalError}),this._onDidSaveDocument=new S.Emitter({onListenerError:I.onUnexpectedExternalError}),this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=n,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const t of o)this._onDidRemoveDocument.fire(t.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const t of o)this._onDidAddDocument.fire(t.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const n=this._documentsAndEditors.getDocument(E);if(n)return n}getDocument(E){const n=this.getDocumentData(E);if(!n?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return n.document}ensureDocumentData(E){const n=this._documentsAndEditors.getDocument(E);if(n)return Promise.resolve(n);let o=this._documentLoader.get(E.toString());return o||(o=this._proxy.$tryOpenDocument(E).then(t=>{this._documentLoader.delete(E.toString());const r=D.URI.revive(t);return(0,m.assertIsDefined)(this._documentsAndEditors.getDocument(r))},t=>(this._documentLoader.delete(E.toString()),Promise.reject(t))),this._documentLoader.set(E.toString(),o)),o}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(n=>D.URI.revive(n))}$acceptModelLanguageChanged(E,n){const o=D.URI.revive(E),t=this._documentsAndEditors.getDocument(o);if(!t)throw new Error("unknown document");this._onDidRemoveDocument.fire(t.document),t._acceptLanguageId(n),this._onDidAddDocument.fire(t.document)}$acceptModelSaved(E){const n=D.URI.revive(E),o=this._documentsAndEditors.getDocument(n);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(E,n){const o=D.URI.revive(E),t=this._documentsAndEditors.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(n),this._onDidChangeDocument.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,n,o){const t=D.URI.revive(E),r=this._documentsAndEditors.getDocument(t);if(!r)throw new Error("unknown document");r._acceptIsDirty(o),r.onEvents(n);let a;n.isUndoing?a=A.TextDocumentChangeReason.Undo:n.isRedoing&&(a=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,w.deepFreeze)({document:r.document,contentChanges:n.changes.map(c=>({range:g.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:a}))}setWordDefinitionFor(E,n){(0,T.setWordDefinitionFor)(E,n)}}e.ExtHostDocuments=u}),define(Pe[61],Te([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,39]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class t{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let r=class{constructor(c,d){this._extHostRpc=c,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const d=[],i=[],s=[];if(c.removedDocuments)for(const l of c.removedDocuments){const h=R.URI.revive(l),b=this._documents.get(h);b?.unref()&&(this._documents.delete(h),d.push(b.value))}if(c.addedDocuments)for(const l of c.addedDocuments){const h=R.URI.revive(l.uri);let b=this._documents.get(h);if(b&&h.scheme!==E.Schemas.vscodeNotebookCell&&h.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);b||(b=new t(new m.ExtHostDocumentData(this._extHostRpc.getProxy(g.MainContext.MainThreadDocuments),h,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty,l.notebook)),this._documents.set(h,b),i.push(b.value)),b.ref()}if(c.removedEditors)for(const l of c.removedEditors){const h=this._editors.get(l);this._editors.delete(l),h&&s.push(h)}if(c.addedEditors)for(const l of c.addedEditors){const h=R.URI.revive(l.documentUri);S.ok(this._documents.has(h),`document '${h}' does not exist`),S.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const b=this._documents.get(h).value,f=new A.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(g.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>b.document),l.selections.map(I.Selection.to),l.options,l.visibleRanges.map(C=>I.Range.to(C)),typeof l.editorPosition=="number"?I.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,f)}c.newActiveEditor!==void 0&&(S.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,D.dispose)(d),(0,D.dispose)(s),c.removedDocuments&&this._onDidRemoveDocuments.fire(d),c.addedDocuments&&this._onDidAddDocuments.fire(i),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return n.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const d=this._editors.get(this._activeEditorId);return c?d:d?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=r,e.ExtHostDocumentsAndEditors=r=je([Ve(0,w.IExtHostRpcService),Ve(1,u.ILogService)],r),e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[62],Te([1,0,246,5,16,2,4,3,17,8,7]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class I{constructor(o,t,r){this._activeTabIdGetter=r,this._parentGroup=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,t={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(t)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(R.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(R.URI.revive(this._dto.input.original),R.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(R.URI.revive(this._dto.input.base),R.URI.revive(this._dto.input.input1),R.URI.revive(this._dto.input.input2),R.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(R.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(R.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(R.URI.revive(this._dto.input.original),R.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(R.URI.revive(this._dto.input.uri),R.URI.revive(this._dto.input.inputBoxUri));case 10:return new A.ChatEditorTabInput(this._dto.input.providerId);default:return}}}class u{constructor(o,t){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=t;for(const r of o.tabs)r.isActive&&(this._activeTabId=r.id),this._tabs.push(new I(r,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,t={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return w.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(r=>r.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(r=>r.apiObject))}};this._apiObject=Object.freeze(t)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const r=new I(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,r),o.tabDto.isActive&&(this._activeTabId=r.tabId),r}else if(o.kind===1){const r=this._tabs.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this._activeTabId&&(this._activeTabId=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this._tabs.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,r),r}const t=this._tabs.find(r=>r.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this._activeTabId}}let p=class{constructor(o){this._onDidChangeTabs=new F.Emitter,this._onDidChangeTabGroups=new F.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(g.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,t={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(r=>r.apiObject))},get activeTabGroup(){const r=o._activeGroupId;return(0,D.assertIsDefined)(o._extHostTabGroups.find(c=>c.groupId===r)?.apiObject)},close:async(r,a)=>{const c=Array.isArray(r)?r:[r];return c.length?E(c[0])?this._closeGroups(c,a):this._closeTabs(c,a):!0}};this._apiObject=Object.freeze(t)}return this._apiObject}$acceptEditorTabModel(o){const t=new Set(this._extHostTabGroups.map(l=>l.groupId)),r=new Set(o.map(l=>l.groupId)),a=(0,S.diffSets)(t,r),c=this._extHostTabGroups.filter(l=>a.removed.includes(l.groupId)).map(l=>l.apiObject),d=[],i=[];this._extHostTabGroups=o.map(l=>{const h=new u(l,()=>this._activeGroupId);return a.added.includes(h.groupId)?d.push(h.apiObject):i.push(h.apiObject),h});const s=(0,D.assertIsDefined)(o.find(l=>l.isActive===!0)?.groupId);s!==void 0&&this._activeGroupId!==s&&(this._activeGroupId=s),this._onDidChangeTabGroups.fire(Object.freeze({opened:d,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this._extHostTabGroups.find(r=>r.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this._extHostTabGroups.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const r=t.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}_findExtHostTabFromApi(o){for(const t of this._extHostTabGroups)for(const r of t.tabs)if(r.apiObject===o)return r}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(t=>t.apiObject===o)}async _closeTabs(o,t){const r=[];for(const a of o){const c=this._findExtHostTabFromApi(a);if(!c)throw new Error("Tab close: Invalid tab not found!");r.push(c.tabId)}return this._proxy.$closeTab(r,t)}async _closeGroups(o,t){const r=[];for(const a of o){const c=this._findExtHostTabGroupFromApi(a);if(!c)throw new Error("Group close: Invalid group not found!");r.push(c.groupId)}return this._proxy.$closeGroup(r,t)}};e.ExtHostEditorTabs=p,e.ExtHostEditorTabs=p=je([Ve(0,m.IExtHostRpcService)],p);function E(n){return n.tabs!==void 0}}),define(Pe[247],Te([1,0,3,7]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class D{constructor(T){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=T.getProxy(S.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,g,m){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const w=this._AiEmbeddingVectorProviders.get(T);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector(g,m);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(T,g,m){const w=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(w,m),this._proxy.$registerAiEmbeddingVectorProvider(g,w),new F.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(w),this._AiEmbeddingVectorProviders.delete(w)})}}e.ExtHostAiEmbeddingVector=D}),define(Pe[248],Te([1,0,2,3,6,7,8,296,12,24,23,52]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class u{constructor(){this._schemes=[]}add(n){this._stateMachine=void 0,this._schemes.push(n)}delete(n){const o=this._schemes.indexOf(n);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const n=this._schemes.sort(),o=[];let t,r,a=14,c=14;for(const d of n){let i=t?(0,m.commonPrefixLength)(t,d):0;for(i===0?r=1:r=c;i<d.length;i++)i+1===d.length?(a=c,c=9):c+=1,o.push([r,d.toUpperCase().charCodeAt(i),c]),o.push([r,d.toLowerCase().charCodeAt(i),c]),r=c;t=d,c=a}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new g.StateMachine(o)}}provideDocumentLinks(n){this._initStateMachine();const o=[],t=g.LinkComputer.computeLinks({getLineContent(r){return n.lineAt(r-1).text},getLineCount(){return n.lineCount}},this._stateMachine);for(const r of t){const a=T.DocumentLink.to(r);a.target&&o.push(a)}return o}}class p{constructor(n,o){this._extHostLanguageFeatures=o,this._linkProvider=new u,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=n.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(n,o,t,r={}){if(p._validateFileSystemProvider(t),this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(n,"*",this._linkProvider));const a=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(a,t);let c=2;r.isCaseSensitive&&(c+=1024),r.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.checkProposedApiEnabled)(n,"fsChunks"),c+=4);let d;r.isReadonly&&(0,I.isMarkdownString)(r.isReadonly)&&((0,A.checkProposedApiEnabled)(n,"readonlyMessage"),d={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this._proxy.$registerFileSystemProvider(a,o,c,d).catch(s=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(s)});const i=t.onDidChangeFile(s=>{const l=[];for(const h of s){const{uri:b,type:f}=h;if(b.scheme!==o)continue;let C;switch(f){case R.FileChangeType.Changed:C=0;break;case R.FileChangeType.Created:C=1;break;case R.FileChangeType.Deleted:C=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:b,type:C})}this._proxy.$onFileSystemChange(a,l)});return(0,D.toDisposable)(()=>{i.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(a),this._proxy.$unregisterProvider(a)})}static _validateFileSystemProvider(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(n){const{type:o,ctime:t,mtime:r,size:a,permissions:c}=n;return{type:o,ctime:t,mtime:r,size:a,permissions:c}}$stat(n,o){return Promise.resolve(this._getFsProvider(n).stat(S.URI.revive(o))).then(t=>p._asIStat(t))}$readdir(n,o){return Promise.resolve(this._getFsProvider(n).readDirectory(S.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this._getFsProvider(n).readFile(S.URI.revive(o))).then(t=>w.VSBuffer.wrap(t))}$writeFile(n,o,t,r){return Promise.resolve(this._getFsProvider(n).writeFile(S.URI.revive(o),t.buffer,r))}$delete(n,o,t){return Promise.resolve(this._getFsProvider(n).delete(S.URI.revive(o),t))}$rename(n,o,t,r){return Promise.resolve(this._getFsProvider(n).rename(S.URI.revive(o),S.URI.revive(t),r))}$copy(n,o,t,r){const a=this._getFsProvider(n);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(S.URI.revive(o),S.URI.revive(t),r))}$mkdir(n,o){return Promise.resolve(this._getFsProvider(n).createDirectory(S.URI.revive(o)))}$watch(n,o,t,r){const a=this._getFsProvider(n).watch(S.URI.revive(t),r);this._watches.set(o,a)}$unwatch(n,o){const t=this._watches.get(o);t&&(t.dispose(),this._watches.delete(o))}$open(n,o,t){const r=this._getFsProvider(n);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(S.URI.revive(o),t))}$close(n,o){const t=this._getFsProvider(n);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(n,o,t,r){const a=this._getFsProvider(n);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.VSBuffer.alloc(r);return Promise.resolve(a.read(o,t,c.buffer,0,r)).then(d=>c.slice(0,d))}$write(n,o,t,r){const a=this._getFsProvider(n);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,r.buffer,0,r.byteLength))}_getFsProvider(n){const o=this._fsProvider.get(n);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.ExtHostFileSystem=p}),define(Pe[63],Te([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let E=p=class{constructor(o,t){this._fileSystemProvider=new Map,this._writeQueue=new A.ResourceQueue,this._proxy=o.getProxy(S.MainContext.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(a){try{let c;const d=r._fileSystemProvider.get(a.scheme);return d?(await r._proxy.$ensureActivation(a.scheme),c=await d.impl.stat(a)):c=await r._proxy.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===F.FilePermission.Readonly?1:void 0}}catch(c){p._handleError(c)}},async readDirectory(a){try{const c=r._fileSystemProvider.get(a.scheme);return c?(await r._proxy.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await r._proxy.$readdir(a)}catch(c){return p._handleError(c)}},async createDirectory(a){try{const c=r._fileSystemProvider.get(a.scheme);return c&&!c.isReadonly?(await r._proxy.$ensureActivation(a.scheme),await r.mkdirp(c.impl,c.extUri,a)):await r._proxy.$mkdir(a)}catch(c){return p._handleError(c)}},async readFile(a){try{const c=r._fileSystemProvider.get(a.scheme);return c?(await r._proxy.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await r._proxy.$readFile(a)).buffer}catch(c){return p._handleError(c)}},async writeFile(a,c){try{const d=r._fileSystemProvider.get(a.scheme);return d&&!d.isReadonly?(await r._proxy.$ensureActivation(a.scheme),await r.mkdirp(d.impl,d.extUri,d.extUri.dirname(a)),await r._writeQueue.queueFor(a).queue(()=>Promise.resolve(d.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await r._proxy.$writeFile(a,R.VSBuffer.wrap(c))}catch(d){return p._handleError(d)}},async delete(a,c){try{const d=r._fileSystemProvider.get(a.scheme);return d&&!d.isReadonly?(await r._proxy.$ensureActivation(a.scheme),await d.impl.delete(a,{recursive:!1,...c})):await r._proxy.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(d){return p._handleError(d)}},async rename(a,c,d){try{return await r._proxy.$rename(a,c,{overwrite:!1,...d})}catch(i){return p._handleError(i)}},async copy(a,c,d){try{return await r._proxy.$copy(a,c,{overwrite:!1,...d})}catch(i){return p._handleError(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async mkdirp(o,t,r){const a=[];for(;!t.isEqual(r,t.dirname(r));)try{if(!((await o.stat(r)).type&F.FileType.Directory))throw D.FileSystemError.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(F.toFileSystemProviderErrorCode(c)!==F.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(r)),r=t.dirname(r)}for(let c=a.length-1;c>=0;c--){r=t.joinPath(r,a[c]);try{await o.createDirectory(r)}catch(d){if(F.toFileSystemProviderErrorCode(d)!==F.FileSystemProviderErrorCode.FileExists)throw d}}}static _handleError(o){if(o instanceof D.FileSystemError)throw o;if(o instanceof F.FileSystemProviderError)switch(o.code){case F.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(o.message);default:throw new D.FileSystemError(o.message,o.name)}if(!(o instanceof Error))throw new D.FileSystemError(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(o.message);switch(o.name){case F.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(o.message);default:throw new D.FileSystemError(o.message,o.name)}}addFileSystemProvider(o,t,r){return this._fileSystemProvider.set(o,{impl:t,extUri:r?.isCaseSensitive?I.extUri:I.extUriIgnorePathCase,isReadonly:!!r?.isReadonly}),(0,w.toDisposable)(()=>this._fileSystemProvider.delete(o))}getFileSystemProviderExtUri(o){return this._fileSystemProvider.get(o)?.extUri??I.extUri}};e.ExtHostConsumerFileSystem=E,e.ExtHostConsumerFileSystem=E=p=je([Ve(0,g.IExtHostRpcService),Ve(1,m.IExtHostFileSystemInfo)],E),e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[249],Te([1,0,5,34,2,3,8,7,39]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(p,E,n,o,t,r){this.session=Math.random(),this._onDidCreate=new S.Emitter,this._onDidChange=new S.Emitter,this._onDidDelete=new S.Emitter,this._config=0,r?.ignoreCreateEvents&&(this._config+=1),r?.ignoreChangeEvents&&(this._config+=2),r?.ignoreDeleteEvents&&(this._config+=4);const a=(0,F.parse)(t),c=typeof t=="string",d=r?.correlate,i=o(s=>{if(!(typeof s.session=="number"&&s.session!==this.session)&&!(d&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const l of s.created){const h=D.URI.revive(l);a(h.fsPath)&&(!c||E.getWorkspaceFolder(h))&&this._onDidCreate.fire(h)}if(!r?.ignoreChangeEvents)for(const l of s.changed){const h=D.URI.revive(l);a(h.fsPath)&&(!c||E.getWorkspaceFolder(h))&&this._onDidChange.fire(h)}if(!r?.ignoreDeleteEvents)for(const l of s.deleted){const h=D.URI.revive(l);a(h.fsPath)&&(!c||E.getWorkspaceFolder(h))&&this._onDidDelete.fire(h)}}});this._disposable=g.Disposable.from(this.ensureWatching(p,n,t,r,r?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,i)}ensureWatching(p,E,n,o,t){const r=g.Disposable.from();if(typeof n=="string")return r;const a=p.getProxy(R.MainContext.MainThreadFileSystemEventService);let c=!1;return(n.pattern.includes(F.GLOBSTAR)||n.pattern.includes(F.GLOB_SPLIT))&&(c=!0),a.$watch(E.identifier.value,this.session,n.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),g.Disposable.from({dispose:()=>a.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(p){this._events=p,this.session=this._events.session,this._created=new m.Lazy(()=>this._events.created.map(D.URI.revive)),this._changed=new m.Lazy(()=>this._events.changed.map(D.URI.revive)),this._deleted=new m.Lazy(()=>this._events.deleted.map(D.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class I{constructor(p,E,n){this._mainContext=p,this._logService=E,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new S.Emitter,this._onDidRenameFile=new S.Emitter,this._onDidCreateFile=new S.Emitter,this._onDidDeleteFile=new S.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(p,E,n,o){return new w(this._mainContext,p,E,this._onFileSystemEvent.event,T.GlobPattern.from(n),o)}$onFileEvent(p){this._onFileSystemEvent.fire(new A(p))}$onDidRunFileOperation(p,E){switch(p){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(n=>({oldUri:D.URI.revive(n.source),newUri:D.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(n=>D.URI.revive(n.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(n=>D.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(p){return this._createWillExecuteEvent(p,this._onWillRenameFile)}getOnWillCreateFileEvent(p){return this._createWillExecuteEvent(p,this._onWillCreateFile)}getOnWillDeleteFileEvent(p){return this._createWillExecuteEvent(p,this._onWillDeleteFile)}_createWillExecuteEvent(p,E){return(n,o,t)=>{const r=function(c){n.call(o,c)};return r.extension=p,E.event(r,void 0,t)}}async $onWillRunFileOperation(p,E,n,o){switch(p){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(t=>({oldUri:D.URI.revive(t.source),newUri:D.URI.revive(t.target)}))},n,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(t=>D.URI.revive(t.target))},n,o);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(t=>D.URI.revive(t.target))},n,o)}}async _fireWillEvent(p,E,n,o){const t=new Set,r=[];if(await p.fireAsync(E,o,async(c,d)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof g.WorkspaceEdit&&(r.push([d.extension,s]),t.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-i>n&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const a={edits:[]};for(const[,c]of r){const{edits:d}=T.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this._extHostDocumentsAndEditors.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(d)}return{edit:a,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=I}),define(Pe[250],Te([1,0,6,2,3,8,7,32,14]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class w{static{this._pool=0}constructor(p,E){this.extension=p,this.provider=E,this.handle=w._pool++}}class A{constructor(p){this.session=p,this.responses=[]}}class I{static{this._nextId=0}constructor(p,E,n,o){this._documents=n,this._logService=o,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=p.getProxy(D.MainContext.MainThreadInlineChat),E.registerApiCommand(new g.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.ApiCommandArgument("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?R.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?R.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?R.Position.from(t.position):void 0}})],g.ApiCommandResult.Void))}registerProvider(p,E,n){const o=new w(p,E);return this._inputProvider.set(o.handle,o),this._proxy.$registerInteractiveEditorProvider(o.handle,n?.label??p.displayName??p.name,p.identifier.value,typeof E.handleInteractiveEditorResponseFeedback=="function",typeof E.provideFollowups=="function",n?.supportReportIssue??!1),(0,S.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(o.handle),this._inputProvider.delete(o.handle)})}async $prepareSession(p,E,n,o){const t=this._inputProvider.get(p);if(!t){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this._documents.getDocument(F.URI.revive(E)),a=R.Selection.to(n),c=await t.provider.prepareInteractiveEditorSession({document:r,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=I._nextId++;return this._inputSessions.set(d,new A(c)),{id:d,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:R.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,E,n,o){const t=this._inputProvider.get(p);if(!t)return;const r=this._inputSessions.get(E.id);if(!r)return;const a={prompt:n.prompt,selection:R.Selection.to(n.selection),wholeRange:R.Range.to(n.wholeRange),attempt:n.attempt,live:n.live};let c=!1;const d={report:async b=>{if(!n.live&&b.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this._proxy.$handleProgressChunk(n.requestId,{message:b.message,edits:b.edits?.map(R.TextEdit.from),editsShouldBeInstant:b.editsShouldBeInstant,slashCommand:b.slashCommand?.command,markdownFragment:T.MarkdownString.isMarkdownString(b.content)?b.content.value:b.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(r.session,a,d,o));let s;try{s=await(0,m.raceCancellation)(i,o)}finally{c=!0}if(!s)return;const l=r.responses.push(s)-1,h={wholeRange:R.Range.from(s.wholeRange),placeholder:s.placeholder};if(I._isEditResponse(s)){const{edits:b,contents:f}=s,C=f!==void 0?R.MarkdownString.from(f):void 0;return b instanceof T.WorkspaceEdit?{...h,id:l,type:"bulkEdit",edits:R.WorkspaceEdit.from(b),message:C}:{...h,id:l,type:"editorEdit",edits:b.map(R.TextEdit.from),message:C}}return{...h,id:l,type:"message",message:R.MarkdownString.from(s.contents)}}async $provideFollowups(p,E,n,o){const t=this._inputProvider.get(p),r=this._inputSessions.get(E),a=r?.responses[n];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(r.session,a,o));return(await(0,m.raceCancellation)(c,o))?.map(R.ChatReplyFollowup.from)}}$handleFeedback(p,E,n,o){const t=this._inputProvider.get(p),r=this._inputSessions.get(E),a=r?.responses[n];if(t&&a){const c=R.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(r.session,a,c)}}$releaseSession(p,E){}static _isEditResponse(p){return typeof p=="object"&&typeof p.edits=="object"}}e.ExtHostInteractiveEditor=I}),define(Pe[251],Te([1,0,2,32]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(T,g,m,w,A){this._extHostNotebooks=g,this._textDocumentsAndEditors=m,this._commands=w;const I=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",u=>!0,u=>u),new F.ApiCommandArgument("resource","Interactive resource Uri",u=>!0,u=>u),new F.ApiCommandArgument("controllerId","Notebook controller Id",u=>!0,u=>u),new F.ApiCommandArgument("title","Interactive editor title",u=>!0,u=>u)],new F.ApiCommandResult("Notebook and input URI",u=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(u.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:S.URI.revive(u.notebookUri),inputUri:S.URI.revive(u.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:S.URI.revive(u.notebookUri),inputUri:S.URI.revive(u.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(T,g,m,w){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:m,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(S.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,g){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=D}),define(Pe[252],Te([1,0,3,7]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class D{constructor(T){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=T.getProxy(S.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(T,g){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const m=this._IssueUriRequestHandlers.get(T);if(!m)throw new Error("Issue request handler not found");const w=await m.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(T,g){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const m=this._IssueDataProviders.get(T);if(!m)throw new Error("Issue data provider not found");const w=await m.provideIssueData(g);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(T,g){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const m=this._IssueDataProviders.get(T);if(!m)throw new Error("Issue data provider not found");const w=await m.provideIssueTemplate(g);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(T,g){const m=T.identifier.value;return this._IssueUriRequestHandlers.set(m,g),this._proxy.$registerIssueUriRequestHandler(m),new F.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(m),this._IssueUriRequestHandlers.delete(m)})}registerIssueDataProvider(T,g){const m=T.identifier.value;return this._IssueDataProviders.set(m,g),this._proxy.$registerIssueDataProvider(m),new F.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(m),this._IssueDataProviders.delete(m)})}}e.ExtHostIssueReporter=D}),define(Pe[253],Te([1,0,6,3]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(T){this._handlePool=0,this._proxy=T.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const g=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(g,T),(0,S.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(g)})}}e.ExtHostLabelService=D}),define(Pe[254],Te([1,0,2,26,8,7,80,3,12,29,18,16,297,20,22,6,96,89,75,60,11,14,23,160]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class l{constructor(N,W){this._documents=N,this._provider=W}async provideDocumentSymbols(N,W){const q=this._documents.getDocument(N),B=await this._provider.provideDocumentSymbols(q,W);if(!(0,A.isFalsyOrEmpty)(B))return B[0]instanceof R.DocumentSymbol?B.map(D.DocumentSymbol.from):l._asDocumentSymbolTree(B)}static _asDocumentSymbolTree(N){N=N.slice(0).sort((B,K)=>{let Z=B.location.range.start.compareTo(K.location.range.start);return Z===0&&(Z=K.location.range.end.compareTo(B.location.range.end)),Z});const W=[],q=[];for(const B of N){const K={name:B.name||"!!MISSING: name!!",kind:D.SymbolKind.from(B.kind),tags:B.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:B.containerName,range:D.Range.from(B.location.range),selectionRange:D.Range.from(B.location.range),children:[]};for(;;){if(q.length===0){q.push(K),W.push(K);break}const Z=q[q.length-1];if(w.Range.containsRange(Z.range,K.range)&&!w.Range.equalsRange(Z.range,K.range)){Z.children?.push(K),q.push(K);break}q.pop()}}return W}}class h{static{this._badCmd={command:"missing",title:"!!MISSING: command!!"}}constructor(N,W,q){this._documents=N,this._commands=W,this._provider=q,this._cache=new r.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,W){const q=this._documents.getDocument(N),B=await this._provider.provideCodeLenses(q,W);if(!B||W.isCancellationRequested)return;const K=this._cache.add(B),Z=new n.DisposableStore;this._disposables.set(K,Z);const _e={cacheId:K,lenses:[]};for(let Fe=0;Fe<B.length;Fe++)_e.lenses.push({cacheId:[K,Fe],range:D.Range.from(B[Fe].range),command:this._commands.toInternal(B[Fe].command,Z)});return _e}async resolveCodeLens(N,W){const q=N.cacheId&&this._cache.get(...N.cacheId);if(!q)return;let B;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?B=q:B=await this._provider.resolveCodeLens(q,W),B||(B=q),W.isCancellationRequested)return;const K=N.cacheId&&this._disposables.get(N.cacheId[0]);if(K)return N.command=this._commands.toInternal(B.command??h._badCmd,K),N}releaseCodeLenses(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}}function b(we){return Array.isArray(we)?we.map(D.DefinitionLink.from):we?[D.DefinitionLink.from(we)]:[]}class f{constructor(N,W){this._documents=N,this._provider=W}async provideDefinition(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideDefinition(B,K,q);return b(Z)}}class C{constructor(N,W){this._documents=N,this._provider=W}async provideDeclaration(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideDeclaration(B,K,q);return b(Z)}}class O{constructor(N,W){this._documents=N,this._provider=W}async provideImplementation(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideImplementation(B,K,q);return b(Z)}}class v{constructor(N,W){this._documents=N,this._provider=W}async provideTypeDefinition(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideTypeDefinition(B,K,q);return b(Z)}}class _{constructor(N,W){this._documents=N,this._provider=W}async provideHover(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideHover(B,K,q);if(!(!Z||(0,A.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=B.getWordRangeAtPosition(K)),Z.range||(Z.range=new R.Range(K,K)),D.Hover.from(Z)}}class y{constructor(N,W){this._documents=N,this._provider=W}async provideEvaluatableExpression(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideEvaluatableExpression(B,K,q);if(Z)return D.EvaluatableExpression.from(Z)}}class M{constructor(N,W){this._documents=N,this._provider=W}async provideInlineValues(N,W,q,B){const K=this._documents.getDocument(N),Z=await this._provider.provideInlineValues(K,D.Range.to(W),D.InlineValueContext.to(q),B);if(Array.isArray(Z))return Z.map(_e=>D.InlineValue.from(_e))}}class V{constructor(N,W){this._documents=N,this._provider=W}async provideDocumentHighlights(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideDocumentHighlights(B,K,q);if(Array.isArray(Z))return Z.map(D.DocumentHighlight.from)}}class ${constructor(N,W){this._documents=N,this._provider=W}async provideMultiDocumentHighlights(N,W,q,B){const K=this._documents.getDocument(N),Z=q.map(ze=>this._documents.getDocument(ze)),_e=D.Position.to(W),Fe=await this._provider.provideMultiDocumentHighlights(K,_e,Z,B);if(Array.isArray(Fe))return Fe.map(D.MultiDocumentHighlight.from)}}class L{constructor(N,W){this._documents=N,this._provider=W}async provideLinkedEditingRanges(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.provideLinkedEditingRanges(B,K,q);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,A.coalesce)(Z.ranges.map(D.Range.from)),wordPattern:Z.wordPattern}}}class U{constructor(N,W){this._documents=N,this._provider=W}async provideReferences(N,W,q,B){const K=this._documents.getDocument(N),Z=D.Position.to(W),_e=await this._provider.provideReferences(K,Z,q,B);if(Array.isArray(_e))return _e.map(D.location.from)}}class k{static{this._maxCodeActionsPerFile=1e3}constructor(N,W,q,B,K,Z,_e){this._documents=N,this._commands=W,this._diagnostics=q,this._provider=B,this._logService=K,this._extension=Z,this._apiDeprecation=_e,this._cache=new r.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(N,W,q,B){const K=this._documents.getDocument(N),Z=u.Selection.isISelection(W)?D.Selection.to(W):D.Range.to(W),_e=[];for(const it of this._diagnostics.getDiagnostics(N))if(Z.intersection(it.range)&&_e.push(it)>k._maxCodeActionsPerFile)break;const Fe={diagnostics:_e,only:q.only?new R.CodeActionKind(q.only):void 0,triggerKind:D.CodeActionTriggerKind.to(q.trigger)},ze=await this._provider.provideCodeActions(K,Z,Fe,B);if(!(0,A.isNonEmptyArray)(ze)||B.isCancellationRequested)return;const qe=this._cache.add(ze),Qe=new n.DisposableStore;this._disposables.set(qe,Qe);const rt=[];for(let it=0;it<ze.length;it++){const et=ze[it];et&&(k._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Qe)})):(Fe.only&&(et.kind?Fe.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[qe,it],title:et.title,command:et.command&&this._commands.toInternal(et.command,Qe),diagnostics:et.diagnostics&&et.diagnostics.map(D.Diagnostic.from),edit:et.edit&&D.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,i.isProposedApiEnabled)(this._extension,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:qe,actions:rt}}async resolveCodeAction(N,W){const[q,B]=N,K=this._cache.get(q,B);if(!K||k._isCommand(K))return{};if(!this._provider.resolveCodeAction)return{};const Z=await this._provider.resolveCodeAction(K,W)??K;let _e;Z.edit&&(_e=D.WorkspaceEdit.from(Z.edit,void 0));let Fe;if(Z.command){const ze=this._disposables.get(q);ze&&(Fe=this._commands.toInternal(Z.command,ze))}return{edit:_e,command:Fe}}releaseCodeActions(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}class P{static toInternalProviderId(N,W){return N+"."+W}constructor(N,W,q,B,K){this._proxy=N,this._documents=W,this._provider=q,this._handle=B,this._extension=K}async prepareDocumentPaste(N,W,q,B){if(!this._provider.prepareDocumentPaste)return;const K=this._documents.getDocument(N),Z=W.map(ze=>D.Range.to(ze)),_e=D.DataTransfer.toDataTransfer(q,()=>{throw new c.NotImplementedError});if(await this._provider.prepareDocumentPaste(K,Z,_e,B),B.isCancellationRequested)return;const Fe=Array.from(_e).filter(([,ze])=>!(ze instanceof R.InternalDataTransferItem));return D.DataTransfer.from(Fe)}async providePasteEdits(N,W,q,B,K){if(!this._provider.provideDocumentPasteEdits)return;const Z=this._documents.getDocument(W),_e=q.map(qe=>D.Range.to(qe)),Fe=D.DataTransfer.toDataTransfer(B,async qe=>(await this._proxy.$resolvePasteFileData(this._handle,N,qe)).buffer),ze=await this._provider.provideDocumentPasteEdits(Z,_e,Fe,K);if(ze)return{label:ze.label??(0,s.localize)(0,null,this._extension.displayName||this._extension.name),detail:this._extension.displayName||this._extension.name,yieldTo:ze.yieldTo?.map(qe=>"mimeType"in qe?qe:{providerId:P.toInternalProviderId(qe.extensionId,qe.providerId)}),insertText:typeof ze.insertText=="string"?ze.insertText:{snippet:ze.insertText.value},additionalEdit:ze.additionalEdit?D.WorkspaceEdit.from(ze.additionalEdit,void 0):void 0}}}class Q{constructor(N,W){this._documents=N,this._provider=W}async provideDocumentFormattingEdits(N,W,q){const B=this._documents.getDocument(N),K=await this._provider.provideDocumentFormattingEdits(B,W,q);if(Array.isArray(K))return K.map(D.TextEdit.from)}}class ae{constructor(N,W){this._documents=N,this._provider=W}async provideDocumentRangeFormattingEdits(N,W,q,B){const K=this._documents.getDocument(N),Z=D.Range.to(W),_e=await this._provider.provideDocumentRangeFormattingEdits(K,Z,q,B);if(Array.isArray(_e))return _e.map(D.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,W,q,B){(0,I.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const K=this._documents.getDocument(N),Z=W.map(D.Range.to),_e=await this._provider.provideDocumentRangesFormattingEdits(K,Z,q,B);if(Array.isArray(_e))return _e.map(D.TextEdit.from)}}class me{constructor(N,W){this._documents=N,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,W,q,B,K){const Z=this._documents.getDocument(N),_e=D.Position.to(W),Fe=await this._provider.provideOnTypeFormattingEdits(Z,_e,q,B,K);if(Array.isArray(Fe))return Fe.map(D.TextEdit.from)}}class Ee{constructor(N,W){this._provider=N,this._logService=W,this._cache=new r.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,W){const q=await this._provider.provideWorkspaceSymbols(N,W);if(!(0,A.isNonEmptyArray)(q))return{symbols:[]};const B=this._cache.add(q),K={cacheId:B,symbols:[]};for(let Z=0;Z<q.length;Z++){const _e=q[Z];if(!_e||!_e.name){this._logService.warn("INVALID SymbolInformation",_e);continue}K.symbols.push({...D.WorkspaceSymbol.from(_e),cacheId:[B,Z]})}return K}async resolveWorkspaceSymbol(N,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const q=this._cache.get(...N.cacheId);if(q){const B=await this._provider.resolveWorkspaceSymbol(q,W);return B&&(0,F.mixin)(N,D.WorkspaceSymbol.from(B),!0)}}releaseWorkspaceSymbols(N){this._cache.delete(N)}}class Ce{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,W,q){this._documents=N,this._provider=W,this._logService=q}async provideRenameEdits(N,W,q,B){const K=this._documents.getDocument(N),Z=D.Position.to(W);try{const _e=await this._provider.provideRenameEdits(K,Z,q,B);return _e?D.WorkspaceEdit.from(_e):void 0}catch(_e){const Fe=Ce._asMessage(_e);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(_e)}}async resolveRenameLocation(N,W,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const B=this._documents.getDocument(N),K=D.Position.to(W);try{const Z=await this._provider.prepareRename(B,K,q);let _e,Fe;if(R.Range.isRange(Z)?(_e=Z,Fe=B.getText(Z)):(0,I.isObject)(Z)&&(_e=Z.range,Fe=Z.placeholder),!_e||!Fe)return;if(_e.start.line>K.line||_e.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(_e),text:Fe}}catch(Z){const _e=Ce._asMessage(Z);return _e?{rejectReason:_e,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class he{constructor(N,W){this.resultId=N,this.tokens=W}}class de{constructor(N,W){this._documents=N,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(N,W,q){const B=this._documents.getDocument(N),K=W!==0?this._previousResults.get(W):null;let Z=typeof K?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(B,K.resultId,q):await this._provider.provideDocumentSemanticTokens(B,q);return K&&this._previousResults.delete(W),Z?(Z=de._fixProvidedSemanticTokens(Z),this._send(de._convertToEdits(K,Z),Z)):null}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return de._isSemanticTokens(N)?de._isCorrectSemanticTokens(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):de._isSemanticTokensEdits(N)?de._isCorrectSemanticTokensEdits(N)?N:new R.SemanticTokensEdits(N.edits.map(W=>new R.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const W of N.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,W){if(!de._isSemanticTokens(W)||!N||!N.tokens)return W;const q=N.tokens,B=q.length,K=W.data,Z=K.length;let _e=0;const Fe=Math.min(B,Z);for(;_e<Fe&&q[_e]===K[_e];)_e++;if(_e===B&&_e===Z)return new R.SemanticTokensEdits([],W.resultId);let ze=0;const qe=Fe-_e;for(;ze<qe&&q[B-ze-1]===K[Z-ze-1];)ze++;return new R.SemanticTokensEdits([{start:_e,deleteCount:B-_e-ze,data:K.subarray(_e,Z-ze)}],W.resultId)}_send(N,W){if(de._isSemanticTokens(N)){const q=this._nextResultId++;return this._previousResults.set(q,new he(N.resultId,N.data)),(0,o.encodeSemanticTokensDto)({id:q,type:"full",data:N.data})}if(de._isSemanticTokensEdits(N)){const q=this._nextResultId++;return de._isSemanticTokens(W)?this._previousResults.set(q,new he(W.resultId,W.data)):this._previousResults.set(q,new he(N.resultId)),(0,o.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(N.edits||[]).map(B=>({start:B.start,deleteCount:B.deleteCount,data:B.data}))})}return null}}class te{constructor(N,W){this._documents=N,this._provider=W}async provideDocumentRangeSemanticTokens(N,W,q){const B=this._documents.getDocument(N),K=await this._provider.provideDocumentRangeSemanticTokens(B,D.Range.to(W),q);return K?this._send(K):null}_send(N){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class Ie{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,W,q,B,K){this._documents=N,this._commands=W,this._provider=q,this._apiDeprecation=B,this._extension=K,this._cache=new r.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(N,W,q,B){const K=this._documents.getDocument(N),Z=D.Position.to(W),_e=K.getWordRangeAtPosition(Z)||new R.Range(Z,Z),Fe=_e.with({end:Z}),ze=new a.StopWatch,qe=await this._provider.provideCompletionItems(K,Z,B,D.CompletionContext.to(q));if(!qe||B.isCancellationRequested)return;const Qe=Array.isArray(qe)?new R.CompletionList(qe):qe,rt=Ie.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),it=new n.DisposableStore;this._disposables.set(rt,it);const et=[],ot={x:rt,b:et,a:{replace:D.Range.from(_e),insert:D.Range.from(Fe)},c:Qe.isIncomplete||void 0,d:ze.elapsed()};for(let at=0;at<Qe.items.length;at++){const Ue=Qe.items[at],vt=this._convertCompletionItem(Ue,[rt,at],Fe,_e);et.push(vt)}return ot}async resolveCompletionItem(N,W){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...N);if(!q)return;const B=this._convertCompletionItem(q,N),K=await this._provider.resolveCompletionItem(q,W);if(!K)return;const Z=this._convertCompletionItem(K,N);return(B.h!==Z.h||B.i!==Z.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(B.n!==Z.n||B.o!==Z.o||!(0,F.equals)(B.p,Z.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...B,d:Z.d,c:Z.c,l:Z.l,h:Z.h,i:Z.i,n:Z.n,o:Z.o,p:Z.p}}releaseCompletionItems(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,W,q,B){const K=this._disposables.get(W[0]);if(!K)throw Error("DisposableStore is missing...");const Z=this._commands.toInternal(N.command,K),_e={x:W,a:N.label,b:N.kind!==void 0?D.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(D.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:D.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(D.TextEdit.from),n:Z?.$ident,o:Z?.id,p:Z?.$ident?void 0:Z?.arguments};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),_e.h=N.textEdit.newText):typeof N.insertText=="string"?_e.h=N.insertText:N.insertText instanceof R.SnippetString&&(_e.h=N.insertText.value,_e.i|=4);let Fe;return N.textEdit?Fe=N.textEdit.range:N.range&&(Fe=N.range),R.Range.isRange(Fe)?_e.j=D.Range.from(Fe):Fe&&(!q?.isEqual(Fe.inserting)||!B?.isEqual(Fe.replacing))&&(_e.j={insert:D.Range.from(Fe.inserting),replace:D.Range.from(Fe.replacing)}),_e}}class oe{async provideInlineCompletions(N,W,q,B){}disposeCompletions(N){}handleDidShowCompletionItem(N,W,q){}handlePartialAccept(N,W,q){}}class Y extends oe{constructor(N,W,q,B){super(),this._extension=N,this._documents=W,this._provider=q,this._commands=B,this._references=new H,this._isAdditionsProposedApiEnabled=(0,i.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,W,q,B){const K=this._documents.getDocument(N),Z=D.Position.to(W),_e=await this._provider.provideInlineCompletionItems(K,Z,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:D.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},B);if(!_e||B.isCancellationRequested)return;const Fe=Array.isArray(_e)?_e:_e.items,ze=this._isAdditionsProposedApiEnabled?Array.isArray(_e)?[]:_e.commands||[]:[],qe=this._isAdditionsProposedApiEnabled&&!Array.isArray(_e)?_e.enableForwardStability:void 0;let Qe;return{pid:this._references.createReferenceId({dispose(){Qe?.dispose()},items:Fe}),items:Fe.map((it,et)=>{let ot;it.command&&(Qe||(Qe=new n.DisposableStore),ot=this._commands.toInternal(it.command,Qe));const at=it.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:it.filterText,range:it.range?D.Range.from(it.range):void 0,command:ot,idx:et,completeBracketPairs:this._isAdditionsProposedApiEnabled?it.completeBracketPairs:!1}}),commands:ze.map(it=>(Qe||(Qe=new n.DisposableStore),this._commands.toInternal(it,Qe))),suppressSuggestions:!1,enableForwardStability:qe}}disposeCompletions(N){this._references.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,W,q){const B=this._references.get(N)?.items[W];B&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(B,q)}handlePartialAccept(N,W,q){const B=this._references.get(N)?.items[W];B&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidPartiallyAcceptCompletionItem(B,q)}}class H{constructor(){this._references=new Map,this._idPool=1}createReferenceId(N){const W=this._idPool++;return this._references.set(W,N),W}disposeReferenceId(N){const W=this._references.get(N);return this._references.delete(N),W}get(N){return this._references.get(N)}}class ne{constructor(N,W){this._documents=N,this._provider=W,this._cache=new r.Cache("SignatureHelp")}async provideSignatureHelp(N,W,q,B){const K=this._documents.getDocument(N),Z=D.Position.to(W),_e=this.reviveContext(q),Fe=await this._provider.provideSignatureHelp(K,Z,B,_e);if(Fe){const ze=this._cache.add([Fe]);return{...D.SignatureHelp.from(Fe),id:ze}}}reviveContext(N){let W;if(N.activeSignatureHelp){const q=D.SignatureHelp.to(N.activeSignatureHelp),B=this._cache.get(N.activeSignatureHelp.id,0);B?(W=B,W.activeSignature=q.activeSignature,W.activeParameter=q.activeParameter):W=q}return{...N,activeSignatureHelp:W}}releaseSignatureHelp(N){this._cache.delete(N)}}class De{constructor(N,W,q,B,K){this._documents=N,this._commands=W,this._provider=q,this._logService=B,this._extension=K,this._cache=new r.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(N,W,q){const B=this._documents.getDocument(N),K=D.Range.to(W),Z=await this._provider.provideInlayHints(B,K,q);if(!Array.isArray(Z)||Z.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(W)}`);return}if(q.isCancellationRequested)return;const _e=this._cache.add(Z);this._disposables.set(_e,new n.DisposableStore);const Fe={hints:[],cacheId:_e};for(let ze=0;ze<Z.length;ze++)this._isValidInlayHint(Z[ze],K)&&Fe.hints.push(this._convertInlayHint(Z[ze],[_e,ze]));return this._logService.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(W)}`),Fe}async resolveInlayHint(N,W){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...N);if(!q)return;const B=await this._provider.resolveInlayHint(q,W);if(B&&this._isValidInlayHint(B))return this._convertInlayHint(B,N)}releaseHints(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_isValidInlayHint(N,W){return N.label.length===0||Array.isArray(N.label)&&N.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(W&&!W.contains(N.position))}_convertInlayHint(N,W){const q=this._disposables.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const B={label:"",cacheId:W,tooltip:D.MarkdownString.fromStrict(N.tooltip),position:D.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(D.TextEdit.from),kind:N.kind&&D.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?B.label=N.label:B.label=N.label.map(K=>{const Z={label:K.value};return Z.tooltip=D.MarkdownString.fromStrict(K.tooltip),R.Location.isLocation(K.location)&&(Z.location=D.location.from(K.location)),K.command&&(Z.command=this._commands.toInternal(K.command,q)),Z}),B}}class Re{constructor(N,W){this._documents=N,this._provider=W,this._cache=new r.Cache("DocumentLink")}async provideLinks(N,W){const q=this._documents.getDocument(N),B=await this._provider.provideDocumentLinks(q,W);if(!(!Array.isArray(B)||B.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:B.filter(Re._validateLink).map(D.DocumentLink.from)};{const K=this._cache.add(B),Z={links:[],cacheId:K};for(let _e=0;_e<B.length;_e++){if(!Re._validateLink(B[_e]))continue;const Fe=D.DocumentLink.from(B[_e]);Fe.cacheId=[K,_e],Z.links.push(Fe)}return Z}}}static _validateLink(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,W){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...N);if(!q)return;const B=await this._provider.resolveDocumentLink(q,W);if(!(!B||!Re._validateLink(B)))return D.DocumentLink.from(B)}releaseLinks(N){this._cache.delete(N)}}class ke{constructor(N,W){this._documents=N,this._provider=W}async provideColors(N,W){const q=this._documents.getDocument(N),B=await this._provider.provideDocumentColors(q,W);return Array.isArray(B)?B.map(Z=>({color:D.Color.from(Z.color),range:D.Range.from(Z.range)})):[]}async provideColorPresentations(N,W,q){const B=this._documents.getDocument(N),K=D.Range.to(W.range),Z=D.Color.to(W.color),_e=await this._provider.provideColorPresentations(Z,{document:B,range:K},q);if(Array.isArray(_e))return _e.map(D.ColorPresentation.from)}}class ce{constructor(N,W){this._documents=N,this._provider=W}async provideFoldingRanges(N,W,q){const B=this._documents.getDocument(N),K=await this._provider.provideFoldingRanges(B,W,q);if(Array.isArray(K))return K.map(D.FoldingRange.from)}}class ie{constructor(N,W,q){this._documents=N,this._provider=W,this._logService=q}async provideSelectionRanges(N,W,q){const B=this._documents.getDocument(N),K=W.map(D.Position.to),Z=await this._provider.provideSelectionRanges(B,K,q);if(!(0,A.isNonEmptyArray)(Z))return[];if(Z.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const _e=[];for(let Fe=0;Fe<K.length;Fe++){const ze=[];_e.push(ze);let qe=K[Fe],Qe=Z[Fe];for(;;){if(!Qe.range.contains(qe))throw new Error("INVALID selection range, must contain the previous range");if(ze.push(D.SelectionRange.from(Qe)),!Qe.parent)break;qe=Qe.range,Qe=Qe.parent}}return _e}}class G{constructor(N,W){this._documents=N,this._provider=W,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.prepareCallHierarchy(B,K,q);if(!Z)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(Z)?Z.map(Fe=>this._cacheAndConvertItem(_e,Fe)):[this._cacheAndConvertItem(_e,Z)]}async provideCallsTo(N,W,q){const B=this._itemFromCache(N,W);if(!B)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(B,q);if(K)return K.map(Z=>({from:this._cacheAndConvertItem(N,Z.from),fromRanges:Z.fromRanges.map(_e=>D.Range.from(_e))}))}async provideCallsFrom(N,W,q){const B=this._itemFromCache(N,W);if(!B)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(B,q);if(K)return K.map(Z=>({to:this._cacheAndConvertItem(N,Z.to),fromRanges:Z.fromRanges.map(_e=>D.Range.from(_e))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,W){const q=this._cache.get(N),B=D.CallHierarchyItem.from(W,N,q.size.toString(36));return q.set(B._itemId,W),B}_itemFromCache(N,W){return this._cache.get(N)?.get(W)}}class ee{constructor(N,W){this._documents=N,this._provider=W,this._idPool=new t.IdGenerator(""),this._cache=new Map}async prepareSession(N,W,q){const B=this._documents.getDocument(N),K=D.Position.to(W),Z=await this._provider.prepareTypeHierarchy(B,K,q);if(!Z)return;const _e=this._idPool.nextId();return this._cache.set(_e,new Map),Array.isArray(Z)?Z.map(Fe=>this._cacheAndConvertItem(_e,Fe)):[this._cacheAndConvertItem(_e,Z)]}async provideSupertypes(N,W,q){const B=this._itemFromCache(N,W);if(!B)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySupertypes(B,q);if(K)return K.map(Z=>this._cacheAndConvertItem(N,Z))}async provideSubtypes(N,W,q){const B=this._itemFromCache(N,W);if(!B)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySubtypes(B,q);if(K)return K.map(Z=>this._cacheAndConvertItem(N,Z))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,W){const q=this._cache.get(N),B=D.TypeHierarchyItem.from(W,N,q.size.toString(36));return q.set(B._itemId,W),B}_itemFromCache(N,W){return this._cache.get(N)?.get(W)}}class pe{static toInternalProviderId(N,W){return N+"."+W}constructor(N,W,q,B,K){this._proxy=N,this._documents=W,this._provider=q,this._handle=B,this._extension=K}async provideDocumentOnDropEdits(N,W,q,B,K){const Z=this._documents.getDocument(W),_e=D.Position.to(q),Fe=D.DataTransfer.toDataTransfer(B,async qe=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,N,qe)).buffer),ze=await this._provider.provideDocumentDropEdits(Z,_e,Fe,K);if(ze)return{label:ze.label??(0,s.localize)(1,null,this._extension.displayName||this._extension.name),yieldTo:ze.yieldTo?.map(qe=>"mimeType"in qe?qe:{providerId:pe.toInternalProviderId(qe.extensionId,qe.providerId)}),insertText:typeof ze.insertText=="string"?ze.insertText:{snippet:ze.insertText.value},additionalEdit:ze.additionalEdit?D.WorkspaceEdit.from(ze.additionalEdit,void 0):void 0}}}class be{constructor(N,W){this._documents=N,this._provider=W}async provideMappedEdits(N,W,q,B){const K=S.URI.revive(N),Z=this._documents.getDocument(K),_e=q.documents.map(qe=>qe.map(Qe=>({uri:S.URI.revive(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(rt=>D.Range.to(rt))}))),Fe={documents:_e,selections:_e[0]?.[0]?.ranges??[]},ze=await this._provider.provideMappedEdits(Z,W,Fe,B);return ze?D.WorkspaceEdit.from(ze):null}}class Le{constructor(N,W){this.adapter=N,this.extension=W}}class ue{static{this._handlePool=0}constructor(N,W,q,B,K,Z,_e,Fe){this._uriTransformer=W,this._documents=q,this._commands=B,this._diagnostics=K,this._logService=Z,this._apiDeprecation=_e,this._extensionTelemetry=Fe,this._adapter=new Map,this._proxy=N.getProxy(g.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(N,W){return D.DocumentSelector.from(N,this._uriTransformer,W)}_createDisposable(N){return new R.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return ue._handlePool++}async _withAdapter(N,W,q,B,K,Z=!1){const _e=this._adapter.get(N);if(!_e||!(_e.adapter instanceof W))return B;const Fe=Date.now();Z||this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const ze=q(_e.adapter,_e.extension);return Promise.resolve(ze).catch(qe=>{(0,c.isCancellationError)(qe)||(this._logService.error(`[${_e.extension.identifier.value}] provider FAILED`),this._logService.error(qe),this._extensionTelemetry.onExtensionError(_e.extension.identifier,qe))}).finally(()=>{Z||this._logService.trace(`[${_e.extension.identifier.value}] provider DONE after ${Date.now()-Fe}ms`)}),p.CancellationToken.isCancellationToken(K)?(0,d.raceCancellationError)(ze,K):ze}_addNewAdapter(N,W){const q=this._nextHandle();return this._adapter.set(q,new Le(N,W)),q}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,W,q,B){const K=this._addNewAdapter(new l(this._documents,q),N),Z=B&&B.label||ue._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(W,N),Z),this._createDisposable(K)}$provideDocumentSymbols(N,W,q){return this._withAdapter(N,l,B=>B.provideDocumentSymbols(S.URI.revive(W),q),void 0,q)}registerCodeLensProvider(N,W,q){const B=this._nextHandle(),K=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(B,new Le(new h(this._documents,this._commands.converter,q),N)),this._proxy.$registerCodeLensSupport(B,this._transformDocumentSelector(W,N),K);let Z=this._createDisposable(B);if(K!==void 0){const _e=q.onDidChangeCodeLenses(Fe=>this._proxy.$emitCodeLensEvent(K));Z=R.Disposable.from(Z,_e)}return Z}$provideCodeLenses(N,W,q){return this._withAdapter(N,h,B=>B.provideCodeLenses(S.URI.revive(W),q),void 0,q)}$resolveCodeLens(N,W,q){return this._withAdapter(N,h,B=>B.resolveCodeLens(W,q),void 0,void 0)}$releaseCodeLenses(N,W){this._withAdapter(N,h,q=>Promise.resolve(q.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(N,W,q){const B=this._addNewAdapter(new f(this._documents,q),N);return this._proxy.$registerDefinitionSupport(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideDefinition(N,W,q,B){return this._withAdapter(N,f,K=>K.provideDefinition(S.URI.revive(W),q,B),[],B)}registerDeclarationProvider(N,W,q){const B=this._addNewAdapter(new C(this._documents,q),N);return this._proxy.$registerDeclarationSupport(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideDeclaration(N,W,q,B){return this._withAdapter(N,C,K=>K.provideDeclaration(S.URI.revive(W),q,B),[],B)}registerImplementationProvider(N,W,q){const B=this._addNewAdapter(new O(this._documents,q),N);return this._proxy.$registerImplementationSupport(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideImplementation(N,W,q,B){return this._withAdapter(N,O,K=>K.provideImplementation(S.URI.revive(W),q,B),[],B)}registerTypeDefinitionProvider(N,W,q){const B=this._addNewAdapter(new v(this._documents,q),N);return this._proxy.$registerTypeDefinitionSupport(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideTypeDefinition(N,W,q,B){return this._withAdapter(N,v,K=>K.provideTypeDefinition(S.URI.revive(W),q,B),[],B)}registerHoverProvider(N,W,q,B){const K=this._addNewAdapter(new _(this._documents,q),N);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(W,N)),this._createDisposable(K)}$provideHover(N,W,q,B){return this._withAdapter(N,_,K=>K.provideHover(S.URI.revive(W),q,B),void 0,B)}registerEvaluatableExpressionProvider(N,W,q,B){const K=this._addNewAdapter(new y(this._documents,q),N);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(W,N)),this._createDisposable(K)}$provideEvaluatableExpression(N,W,q,B){return this._withAdapter(N,y,K=>K.provideEvaluatableExpression(S.URI.revive(W),q,B),void 0,B)}registerInlineValuesProvider(N,W,q,B){const K=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new M(this._documents,q),N);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(W,N),K);let _e=this._createDisposable(Z);if(K!==void 0){const Fe=q.onDidChangeInlineValues(ze=>this._proxy.$emitInlineValuesEvent(K));_e=R.Disposable.from(_e,Fe)}return _e}$provideInlineValues(N,W,q,B,K){return this._withAdapter(N,M,Z=>Z.provideInlineValues(S.URI.revive(W),q,B,K),void 0,K)}registerDocumentHighlightProvider(N,W,q){const B=this._addNewAdapter(new V(this._documents,q),N);return this._proxy.$registerDocumentHighlightProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}registerMultiDocumentHighlightProvider(N,W,q){const B=this._addNewAdapter(new $(this._documents,q),N);return this._proxy.$registerMultiDocumentHighlightProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideDocumentHighlights(N,W,q,B){return this._withAdapter(N,V,K=>K.provideDocumentHighlights(S.URI.revive(W),q,B),void 0,B)}$provideMultiDocumentHighlights(N,W,q,B,K){return this._withAdapter(N,$,Z=>Z.provideMultiDocumentHighlights(S.URI.revive(W),q,B.map(_e=>S.URI.revive(_e)),K),void 0,K)}registerLinkedEditingRangeProvider(N,W,q){const B=this._addNewAdapter(new L(this._documents,q),N);return this._proxy.$registerLinkedEditingRangeProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideLinkedEditingRanges(N,W,q,B){return this._withAdapter(N,L,async K=>{const Z=await K.provideLinkedEditingRanges(S.URI.revive(W),q,B);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?ue._serializeRegExp(Z.wordPattern):void 0}},void 0,B)}registerReferenceProvider(N,W,q){const B=this._addNewAdapter(new U(this._documents,q),N);return this._proxy.$registerReferenceSupport(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideReferences(N,W,q,B,K){return this._withAdapter(N,U,Z=>Z.provideReferences(S.URI.revive(W),q,B,K),void 0,K)}registerCodeActionProvider(N,W,q,B){const K=new n.DisposableStore,Z=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,q,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(W,N),{providedKinds:B?.providedCodeActionKinds?.map(_e=>_e.value),documentation:B?.documentation?.map(_e=>({kind:_e.kind.value,command:this._commands.converter.toInternal(_e.command,K)}))},ue._extLabel(N),!!q.resolveCodeAction),K.add(this._createDisposable(Z)),K}$provideCodeActions(N,W,q,B,K){return this._withAdapter(N,k,Z=>Z.provideCodeActions(S.URI.revive(W),q,B,K),void 0,K)}$resolveCodeAction(N,W,q){return this._withAdapter(N,k,B=>B.resolveCodeAction(W,q),{},void 0)}$releaseCodeActions(N,W){this._withAdapter(N,k,q=>Promise.resolve(q.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(N,W,q){const B=this._addNewAdapter(new Q(this._documents,q),N);return this._proxy.$registerDocumentFormattingSupport(B,this._transformDocumentSelector(W,N),N.identifier,N.displayName||N.name),this._createDisposable(B)}$provideDocumentFormattingEdits(N,W,q,B){return this._withAdapter(N,Q,K=>K.provideDocumentFormattingEdits(S.URI.revive(W),q,B),void 0,B)}registerDocumentRangeFormattingEditProvider(N,W,q){const B=typeof q.provideDocumentRangesFormattingEdits=="function",K=this._addNewAdapter(new ae(this._documents,q),N);return this._proxy.$registerRangeFormattingSupport(K,this._transformDocumentSelector(W,N),N.identifier,N.displayName||N.name,B),this._createDisposable(K)}$provideDocumentRangeFormattingEdits(N,W,q,B,K){return this._withAdapter(N,ae,Z=>Z.provideDocumentRangeFormattingEdits(S.URI.revive(W),q,B,K),void 0,K)}$provideDocumentRangesFormattingEdits(N,W,q,B,K){return this._withAdapter(N,ae,Z=>Z.provideDocumentRangesFormattingEdits(S.URI.revive(W),q,B,K),void 0,K)}registerOnTypeFormattingEditProvider(N,W,q,B){const K=this._addNewAdapter(new me(this._documents,q),N);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(W,N),B,N.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits(N,W,q,B,K,Z){return this._withAdapter(N,me,_e=>_e.provideOnTypeFormattingEdits(S.URI.revive(W),q,B,K,Z),void 0,Z)}registerWorkspaceSymbolProvider(N,W){const q=this._addNewAdapter(new Ee(W,this._logService),N);return this._proxy.$registerNavigateTypeSupport(q,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(N,W,q){return this._withAdapter(N,Ee,B=>B.provideWorkspaceSymbols(W,q),{symbols:[]},q)}$resolveWorkspaceSymbol(N,W,q){return this._withAdapter(N,Ee,B=>B.resolveWorkspaceSymbol(W,q),void 0,void 0)}$releaseWorkspaceSymbols(N,W){this._withAdapter(N,Ee,q=>q.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(N,W,q){const B=this._addNewAdapter(new Ce(this._documents,q,this._logService),N);return this._proxy.$registerRenameSupport(B,this._transformDocumentSelector(W,N),Ce.supportsResolving(q)),this._createDisposable(B)}$provideRenameEdits(N,W,q,B,K){return this._withAdapter(N,Ce,Z=>Z.provideRenameEdits(S.URI.revive(W),q,B,K),void 0,K)}$resolveRenameLocation(N,W,q,B){return this._withAdapter(N,Ce,K=>K.resolveRenameLocation(S.URI.revive(W),q,B),void 0,B)}registerDocumentSemanticTokensProvider(N,W,q,B){const K=this._addNewAdapter(new de(this._documents,q),N),Z=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(W,N),B,Z);let _e=this._createDisposable(K);if(Z){const Fe=q.onDidChangeSemanticTokens(ze=>this._proxy.$emitDocumentSemanticTokensEvent(Z));_e=R.Disposable.from(_e,Fe)}return _e}$provideDocumentSemanticTokens(N,W,q,B){return this._withAdapter(N,de,K=>K.provideDocumentSemanticTokens(S.URI.revive(W),q,B),null,B)}$releaseDocumentSemanticTokens(N,W){this._withAdapter(N,de,q=>q.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,W,q,B){const K=this._addNewAdapter(new te(this._documents,q),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(W,N),B),this._createDisposable(K)}$provideDocumentRangeSemanticTokens(N,W,q,B){return this._withAdapter(N,te,K=>K.provideDocumentRangeSemanticTokens(S.URI.revive(W),q,B),null,B)}registerCompletionItemProvider(N,W,q,B){const K=this._addNewAdapter(new Ie(this._documents,this._commands.converter,q,this._apiDeprecation,N),N);return this._proxy.$registerCompletionsProvider(K,this._transformDocumentSelector(W,N),B,Ie.supportsResolving(q),N.identifier),this._createDisposable(K)}$provideCompletionItems(N,W,q,B,K){return this._withAdapter(N,Ie,Z=>Z.provideCompletionItems(S.URI.revive(W),q,B,K),void 0,K)}$resolveCompletionItem(N,W,q){return this._withAdapter(N,Ie,B=>B.resolveCompletionItem(W,q),void 0,q)}$releaseCompletionItems(N,W){this._withAdapter(N,Ie,q=>q.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(N,W,q,B){const K=new Y(N,this._documents,q,this._commands.converter),Z=this._addNewAdapter(K,N);return this._proxy.$registerInlineCompletionsSupport(Z,this._transformDocumentSelector(W,N),K.supportsHandleEvents,E.ExtensionIdentifier.toKey(N.identifier.value),B?.yieldTo?.map(_e=>E.ExtensionIdentifier.toKey(_e))||[]),this._createDisposable(Z)}$provideInlineCompletions(N,W,q,B,K){return this._withAdapter(N,oe,Z=>Z.provideInlineCompletions(S.URI.revive(W),q,B,K),void 0,K)}$handleInlineCompletionDidShow(N,W,q,B){this._withAdapter(N,oe,async K=>{K.handleDidShowCompletionItem(W,q,B)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,W,q,B){this._withAdapter(N,oe,async K=>{K.handlePartialAccept(W,q,B)},void 0,void 0)}$freeInlineCompletionsList(N,W){this._withAdapter(N,oe,async q=>{q.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(N,W,q,B){const K=Array.isArray(B)?{triggerCharacters:B,retriggerCharacters:[]}:B,Z=this._addNewAdapter(new ne(this._documents,q),N);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(W,N),K),this._createDisposable(Z)}$provideSignatureHelp(N,W,q,B,K){return this._withAdapter(N,ne,Z=>Z.provideSignatureHelp(S.URI.revive(W),q,B,K),void 0,K)}$releaseSignatureHelp(N,W){this._withAdapter(N,ne,q=>q.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(N,W,q){const B=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new De(this._documents,this._commands.converter,q,this._logService,N),N);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(W,N),typeof q.resolveInlayHint=="function",B,ue._extLabel(N));let Z=this._createDisposable(K);if(B!==void 0){const _e=q.onDidChangeInlayHints(Fe=>this._proxy.$emitInlayHintsEvent(B));Z=R.Disposable.from(Z,_e)}return Z}$provideInlayHints(N,W,q,B){return this._withAdapter(N,De,K=>K.provideInlayHints(S.URI.revive(W),q,B),void 0,B)}$resolveInlayHint(N,W,q){return this._withAdapter(N,De,B=>B.resolveInlayHint(W,q),void 0,q)}$releaseInlayHints(N,W){this._withAdapter(N,De,q=>q.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(N,W,q){const B=this._addNewAdapter(new Re(this._documents,q),N);return this._proxy.$registerDocumentLinkProvider(B,this._transformDocumentSelector(W,N),typeof q.resolveDocumentLink=="function"),this._createDisposable(B)}$provideDocumentLinks(N,W,q){return this._withAdapter(N,Re,B=>B.provideLinks(S.URI.revive(W),q),void 0,q,W.scheme==="output")}$resolveDocumentLink(N,W,q){return this._withAdapter(N,Re,B=>B.resolveLink(W,q),void 0,void 0,!0)}$releaseDocumentLinks(N,W){this._withAdapter(N,Re,q=>q.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(N,W,q){const B=this._addNewAdapter(new ke(this._documents,q),N);return this._proxy.$registerDocumentColorProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideDocumentColors(N,W,q){return this._withAdapter(N,ke,B=>B.provideColors(S.URI.revive(W),q),[],q)}$provideColorPresentations(N,W,q,B){return this._withAdapter(N,ke,K=>K.provideColorPresentations(S.URI.revive(W),q,B),void 0,B)}registerFoldingRangeProvider(N,W,q){const B=this._nextHandle(),K=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(B,new Le(new ce(this._documents,q),N)),this._proxy.$registerFoldingRangeProvider(B,this._transformDocumentSelector(W,N),N.identifier,K);let Z=this._createDisposable(B);if(K!==void 0){const _e=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));Z=R.Disposable.from(Z,_e)}return Z}$provideFoldingRanges(N,W,q,B){return this._withAdapter(N,ce,K=>K.provideFoldingRanges(S.URI.revive(W),q,B),void 0,B)}registerSelectionRangeProvider(N,W,q){const B=this._addNewAdapter(new ie(this._documents,q,this._logService),N);return this._proxy.$registerSelectionRangeProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideSelectionRanges(N,W,q,B){return this._withAdapter(N,ie,K=>K.provideSelectionRanges(S.URI.revive(W),q,B),[],B)}registerCallHierarchyProvider(N,W,q){const B=this._addNewAdapter(new G(this._documents,q),N);return this._proxy.$registerCallHierarchyProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$prepareCallHierarchy(N,W,q,B){return this._withAdapter(N,G,K=>Promise.resolve(K.prepareSession(S.URI.revive(W),q,B)),void 0,B)}$provideCallHierarchyIncomingCalls(N,W,q,B){return this._withAdapter(N,G,K=>K.provideCallsTo(W,q,B),void 0,B)}$provideCallHierarchyOutgoingCalls(N,W,q,B){return this._withAdapter(N,G,K=>K.provideCallsFrom(W,q,B),void 0,B)}$releaseCallHierarchy(N,W){this._withAdapter(N,G,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(N,W,q){const B=this._addNewAdapter(new ee(this._documents,q),N);return this._proxy.$registerTypeHierarchyProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$prepareTypeHierarchy(N,W,q,B){return this._withAdapter(N,ee,K=>Promise.resolve(K.prepareSession(S.URI.revive(W),q,B)),void 0,B)}$provideTypeHierarchySupertypes(N,W,q,B){return this._withAdapter(N,ee,K=>K.provideSupertypes(W,q,B),void 0,B)}$provideTypeHierarchySubtypes(N,W,q,B){return this._withAdapter(N,ee,K=>K.provideSubtypes(W,q,B),void 0,B)}$releaseTypeHierarchy(N,W){this._withAdapter(N,ee,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(N,W,q,B){const K=this._nextHandle();this._adapter.set(K,new Le(new pe(this._proxy,this._documents,q,K,N),N));const Z=(0,i.isProposedApiEnabled)(N,"dropMetadata")&&B?pe.toInternalProviderId(N.identifier.value,B.id):void 0;return this._proxy.$registerDocumentOnDropEditProvider(K,this._transformDocumentSelector(W,N),Z,(0,i.isProposedApiEnabled)(N,"dropMetadata")?B:void 0),this._createDisposable(K)}$provideDocumentOnDropEdits(N,W,q,B,K,Z){return this._withAdapter(N,pe,_e=>Promise.resolve(_e.provideDocumentOnDropEdits(W,S.URI.revive(q),B,K,Z)),void 0,void 0)}registerMappedEditsProvider(N,W,q){const B=this._addNewAdapter(new be(this._documents,q),N);return this._proxy.$registerMappedEditsProvider(B,this._transformDocumentSelector(W,N)),this._createDisposable(B)}$provideMappedEdits(N,W,q,B,K){return this._withAdapter(N,be,Z=>Promise.resolve(Z.provideMappedEdits(W,q,B,K)),null,K)}registerDocumentPasteEditProvider(N,W,q,B){const K=this._nextHandle();this._adapter.set(K,new Le(new P(this._proxy,this._documents,q,K,N),N));const Z=P.toInternalProviderId(N.identifier.value,B.id);return this._proxy.$registerPasteEditProvider(K,this._transformDocumentSelector(W,N),Z,{supportsCopy:!!q.prepareDocumentPaste,supportsPaste:!!q.provideDocumentPasteEdits,copyMimeTypes:B.copyMimeTypes,pasteMimeTypes:B.pasteMimeTypes}),this._createDisposable(K)}$prepareDocumentPaste(N,W,q,B,K){return this._withAdapter(N,P,Z=>Z.prepareDocumentPaste(S.URI.revive(W),q,B,K),void 0,K)}$providePasteEdits(N,W,q,B,K,Z){return this._withAdapter(N,P,_e=>_e.providePasteEdits(W,S.URI.revive(q),B,K,Z),void 0,Z)}static _serializeRegExp(N){return{pattern:N.source,flags:N.flags}}static _serializeIndentationRule(N){return{decreaseIndentPattern:ue._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:ue._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ue._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ue._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:ue._serializeRegExp(N.beforeText),afterText:N.afterText?ue._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?ue._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(ue._serializeOnEnterRule)}static _serializeAutoClosingPair(N){return{open:N.open,close:N.close,notIn:N.notIn?N.notIn.map(W=>R.SyntaxTokenType.toString(W)):void 0}}static _serializeAutoClosingPairs(N){return N.map(ue._serializeAutoClosingPair)}setLanguageConfiguration(N,W,q){const{wordPattern:B}=q;if(B&&(0,m.regExpLeadsToEndlessLoop)(B))throw new Error(`Invalid language configuration: wordPattern '${B}' is not allowed to match the empty string.`);B?this._documents.setWordDefinitionFor(W,B):this._documents.setWordDefinitionFor(W,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const K=this._nextHandle(),Z={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ue._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?ue._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ue._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport,autoClosingPairs:q.autoClosingPairs?ue._serializeAutoClosingPairs(q.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(K,W,Z),this._createDisposable(K)}$setWordDefinitions(N){for(const W of N)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ue}),define(Pe[255],Te([1,0,3,8,7,31,14,6,23]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(I,u,p,E){this._documents=u,this._commands=p,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=I.getProxy(S.MainContext.MainThreadLanguages)}$acceptLanguageIds(I){this._languageIds=I}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(I,u){await this._proxy.$changeLanguage(I,u);const p=this._documents.getDocumentData(I);if(!p)throw new Error(`document '${I.toString()}' NOT found`);return p.document}async tokenAtPosition(I,u){const p=I.version,E=F.Position.from(u),n=await this._proxy.$tokensAtPosition(I.uri,E),o={type:D.StandardTokenType.Other,range:I.getWordRangeAtPosition(u)??new D.Range(u.line,u.character,u.line,u.character)};if(!n)return o;const t={range:F.Range.to(n.range),type:F.TokenType.to(n.type)};return!t.range.contains(u)||p!==I.version?o:t}createLanguageStatusItem(I,u,p){const E=this._handlePool++,n=this._proxy,o=this._ids,t=`${I.identifier.value}/${u}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(t);const r={selector:p,id:u,name:I.displayName??I.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new g.DisposableStore,d=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${u}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,T.disposableTimeout)(()=>{c.clear(),this._proxy.$setLanguageStatus(E,{id:t,name:r.name??I.displayName??I.name,source:I.displayName??I.name,selector:F.DocumentSelector.from(r.selector,this._uriTransformer),label:r.text,detail:r.detail??"",severity:r.severity===D.LanguageStatusSeverity.Error?R.default.Error:r.severity===D.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:r.command&&this._commands.toInternal(r.command,c),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),n.$removeLanguageStatus(E),o.delete(t)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,d()},get selector(){return r.selector},set selector(s){r.selector=s,d()},get text(){return r.text},set text(s){r.text=s,d()},set text2(s){(0,m.checkProposedApiEnabled)(I,"languageStatusText"),r.text=s,d()},get text2(){return(0,m.checkProposedApiEnabled)(I,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,d()},get severity(){return r.severity},set severity(s){r.severity=s,d()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,d()},get command(){return r.command},set command(s){r.command=s,d()},get busy(){return r.busy},set busy(s){r.busy=s,d()}};return d(),i}}e.ExtHostLanguages=w}),define(Pe[82],Te([1,0,21,12,2,4,15,3,27,17]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(u,p,E){this.logService=E,this.bundleCache=new Map,this._proxy=p.getProxy(g.MainContext.MainThreadLocalization),this.currentLanguage=u.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===S.LANGUAGE_DEFAULT}getMessage(u,p){const{message:E,args:n,comment:o}=p;if(this.isDefaultLanguage)return(0,F.format2)(E,n??{});let t=E;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.bundleCache.get(u)?.contents[t];return r||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,F.format2)(r??E,n??{})}getBundle(u){return this.bundleCache.get(u)?.contents}getBundleUri(u){return this.bundleCache.get(u)?.uri}async initializeLocalizedMessages(u){if(this.isDefaultLanguage||!u.l10n&&!u.isBuiltin||this.bundleCache.has(u.identifier.value))return;let p;const E=await this.getBundleLocation(u);if(!E){this.logService.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this._proxy.$fetchBundleContents(E),o=JSON.parse(n);p=u.isBuiltin?o.contents?.bundle:o}catch(n){this.logService.error(`Failed to load translations for ${u.identifier.value} from ${E}: ${n.message}`);return}p&&this.bundleCache.set(u.identifier.value,{contents:p,uri:E})}async getBundleLocation(u){if(u.isBuiltin){const p=await this._proxy.$fetchBuiltInBundleUri(u.identifier.value,this.currentLanguage);return D.URI.revive(p)}return u.l10n?D.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=A,e.ExtHostLocalizationService=A=je([Ve(0,m.IExtHostInitDataService),Ve(1,w.IExtHostRpcService),Ve(2,T.ILogService)],A),e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(Pe[256],Te([1,0,15,3,27,17,2,51]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let m=class extends S.AbstractLoggerService{constructor(I,u){super(u.logLevel,u.logsLocation,u.loggers.map(p=>(0,g.revive)(p))),this._proxy=I.getProxy(F.MainContext.MainThreadLogger)}$setLogLevel(I,u){u?this.setLogLevel(T.URI.revive(u),I):this.setLogLevel(I)}setVisibility(I,u){super.setVisibility(I,u),this._proxy.$setVisibility(I,u)}doCreateLogger(I,u,p){return new w(this._proxy,I,u,p)}};e.ExtHostLoggerService=m,e.ExtHostLoggerService=m=je([Ve(0,R.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],m);class w extends S.AbstractMessageLogger{constructor(I,u,p,E){super(E?.logLevel==="always"),this.proxy=I,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(u,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,u){const p=[[I,u]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(I){this.proxy.$log(this.file,I)}flush(){this.proxy.$flush(this.file)}}}),define(Pe[83],Te([1,0,3,4,6,17,24]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,F.createDecorator)("IExtHostManagedSockets");let g=class{constructor(I){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadManagedSockets)}setFactory(I,u){for(const p of this._managedRemoteSockets.values())p.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new m(I,u),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(I){if(!this._factory||this._factory.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const u=++this._remoteSocketIdCounter,p=await this._factory.makeConnection(),E=new D.DisposableStore;return this._managedRemoteSockets.set(u,new w(u,p,E)),E.add((0,D.toDisposable)(()=>this._managedRemoteSockets.delete(u))),E.add(p.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(u),E.dispose()})),E.add(p.onDidClose(n=>{this._proxy.$onDidManagedSocketClose(u,n?.stack??n?.message),E.dispose()})),E.add(p.onDidReceiveMessage(n=>this._proxy.$onDidManagedSocketHaveData(u,T.VSBuffer.wrap(n)))),u}$remoteSocketWrite(I,u){this._managedRemoteSockets.get(I)?.actual.send(u.buffer)}$remoteSocketEnd(I){const u=this._managedRemoteSockets.get(I);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(I){await this._managedRemoteSockets.get(I)?.actual.drain?.()}};e.ExtHostManagedSockets=g,e.ExtHostManagedSockets=g=je([Ve(0,R.IExtHostRpcService)],g);class m{constructor(I,u){this.socketFactoryId=I,this.makeConnection=u}}class w extends D.Disposable{constructor(I,u,p){super(),this.socketId=I,this.actual=u,this._register(p)}}}),define(Pe[257],Te([1,0,3,15,23]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(g){return g&&g.title}let T=class{constructor(m,w){this._logService=w,this._proxy=m.getProxy(S.MainContext.MainThreadMessageService)}showMessage(m,w,A,I,u){const p={source:{identifier:m.identifier,label:m.displayName||m.name}};let E;typeof I=="string"||R(I)?E=[I,...u]:(p.modal=I?.modal,p.useCustom=I?.useCustom,p.detail=I?.detail,E=u),p.useCustom&&(0,D.checkProposedApiEnabled)(m,"resolvers");const n=[];for(let o=0;o<E.length;o++){const t=E[o];if(typeof t=="string")n.push({title:t,handle:o,isCloseAffordance:!1});else if(typeof t=="object"){const{title:r,isCloseAffordance:a}=t;n.push({title:r,isCloseAffordance:!!a,handle:o})}else this._logService.warn("Invalid message item:",t)}return this._proxy.$showMessage(w,A,p,n).then(o=>{if(typeof o=="number")return E[o]})}};e.ExtHostMessageService=T,e.ExtHostMessageService=T=je([Ve(1,F.ILogService)],T)}),define(Pe[258],Te([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let a=class{constructor(f,C,O,v,_){this._initData=C,this._extHostNotebook=O,this._commands=v,this._logService=_,this._activeExecutions=new g.ResourceMap,this._activeNotebookExecutions=new g.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=f.getProxy(I.MainContext.MainThreadNotebookKernels);const y=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const V=this._extHostNotebook.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:V}}else if(M&&"notebookEditor"in M){const V=this._extHostNotebook.getIdByEditor(M.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return M})],u.ApiCommandResult.Void);this._commands.registerApiCommand(y)}createNotebookController(f,C,O,v,_,y){for(const te of this._kernelData.values())if(te.controller.id===C&&w.ExtensionIdentifier.equals(f.identifier,te.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const M=this._handlePool++,V=this;this._logService.trace(`NotebookController[${M}], CREATED by ${f.identifier.value}, ${C}`);const $=()=>console.warn(`NO execute handler from notebook controller '${P.id}' of extension: '${f.identifier}'`);let L=!1;const U=new R.Emitter,k=new R.Emitter,P={id:h(f.identifier,C),notebookType:O,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:v||f.identifier.value,preloads:y?y.map(p.NotebookRendererScript.from):[]};let Q=_??$,ae,me;this._proxy.$addKernel(M,P).catch(te=>{console.log(te),L=!0});let Ee=0;const Ce=()=>{if(L)return;const te=++Ee;Promise.resolve().then(()=>{te===Ee&&this._proxy.$updateKernel(M,P)})},he=new g.ResourceMap,de={get id(){return C},get notebookType(){return P.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return P.label},set label(te){P.label=te??f.displayName??f.name,Ce()},get detail(){return P.detail??""},set detail(te){P.detail=te,Ce()},get description(){return P.description??""},set description(te){P.description=te,Ce()},get supportedLanguages(){return P.supportedLanguages},set supportedLanguages(te){P.supportedLanguages=te,Ce()},get supportsExecutionOrder(){return P.supportsExecutionOrder??!1},set supportsExecutionOrder(te){P.supportsExecutionOrder=te,Ce()},get rendererScripts(){return P.preloads?P.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(te){Q=te??$},get interruptHandler(){return ae},set interruptHandler(te){ae=te,P.supportsInterrupt=!!te,Ce()},set variableProvider(te){(0,t.checkProposedApiEnabled)(f,"notebookVariableProvider"),me=te,P.hasVariableProvider=!!te,te?.onDidChangeVariables(Ie=>V._proxy.$variablesUpdated(Ie.uri)),Ce()},get variableProvider(){return me},createNotebookCellExecution(te){if(L)throw new Error("notebook controller is DISPOSED");if(!he.has(te.notebook.uri))throw V._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return V._createNotebookCellExecution(te,h(f.identifier,this.id))},createNotebookExecution(te){if((0,t.checkProposedApiEnabled)(f,"notebookExecution"),L)throw new Error("notebook controller is DISPOSED");if(!he.has(te.uri))throw V._logService.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.uri.toString()}`);return V._createNotebookExecution(te,h(f.identifier,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${M}], DISPOSED`),L=!0,this._kernelData.delete(M),U.dispose(),k.dispose(),this._proxy.$removeKernel(M))},updateNotebookAffinity(te,Ie){Ie===E.NotebookControllerAffinity2.Hidden&&(0,t.checkProposedApiEnabled)(f,"notebookControllerAffinityHidden"),V._proxy.$updateNotebookPriority(M,te.uri,Ie)},onDidReceiveMessage:k.event,postMessage(te,Ie){return(0,t.checkProposedApiEnabled)(f,"notebookMessaging"),V._proxy.$postMessage(M,Ie&&V._extHostNotebook.getIdByEditor(Ie),te)},asWebviewUri(te){return(0,t.checkProposedApiEnabled)(f,"notebookMessaging"),(0,n.asWebviewUri)(te,V._initData.remote)}};return this._kernelData.set(M,{extensionId:f.identifier,controller:de,onDidReceiveMessage:k,onDidChangeSelection:U,associatedNotebooks:he}),de}getIdByController(f){for(const[C,O]of this._kernelData)if(O.controller===f)return h(O.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,C){const O=this._kernelDetectionTaskHandlePool++,v=this;this._logService.trace(`NotebookControllerDetectionTask[${O}], CREATED by ${f.identifier.value}`),this._proxy.$addKernelDetectionTask(O,C);const _={dispose:()=>{this._kernelDetectionTask.delete(O),v._proxy.$removeKernelDetectionTask(O)}};return this._kernelDetectionTask.set(O,_),_}registerKernelSourceActionProvider(f,C,O){const v=this._kernelSourceActionProviderHandlePool++,_=typeof O.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,y=this;this._kernelSourceActionProviders.set(v,O),this._logService.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${f.identifier.value}`),this._proxy.$addKernelSourceActionProvider(v,v,C);let M;return _!==void 0&&(M=O.onDidChangeNotebookKernelSourceActions(V=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(_))),{dispose:()=>{this._kernelSourceActionProviders.delete(v),y._proxy.$removeKernelSourceActionProvider(v,v),M?.dispose()}}}async $provideKernelSourceActions(f,C){const O=this._kernelSourceActionProviders.get(f);if(O){const v=new T.DisposableStore;return(await O.provideNotebookKernelSourceActions(C)??[]).map(y=>p.NotebookKernelSourceAction.from(y,this._commands.converter,v))}return[]}$acceptNotebookAssociation(f,C,O){const v=this._kernelData.get(f);if(v){const _=this._extHostNotebook.getNotebookDocument(m.URI.revive(C));O?v.associatedNotebooks.set(_.uri,!0):v.associatedNotebooks.delete(_.uri),this._logService.trace(`NotebookController[${f}] ASSOCIATE notebook`,_.uri.toString(),O),v.onDidChangeSelection.fire({selected:O,notebook:_.apiNotebook})}}async $executeCells(f,C,O){const v=this._kernelData.get(f);if(!v)return;const _=this._extHostNotebook.getNotebookDocument(m.URI.revive(C)),y=[];for(const M of O){const V=_.getCell(M);V&&y.push(V.apiCell)}try{this._logService.trace(`NotebookController[${f}] EXECUTE cells`,_.uri.toString(),y.length),await v.controller.executeHandler.call(v.controller,y,_.apiNotebook,v.controller)}catch(M){this._logService.error(`NotebookController[${f}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(f,C,O){const v=this._kernelData.get(f);if(!v)return;const _=this._extHostNotebook.getNotebookDocument(m.URI.revive(C));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,_.apiNotebook);else for(const y of O){const M=_.getCell(y);M&&this._activeExecutions.get(M.uri)?.cancel()}if(v.controller.interruptHandler){const y=this._activeNotebookExecutions.get(_.uri);O.length&&Array.isArray(y)&&y.length&&y.forEach(M=>M.dispose())}}async $provideVariables(f,C,O,v,_,y,M){const V=this._kernelData.get(f);if(!V)return;const $=this._extHostNotebook.getNotebookDocument(m.URI.revive(O)),L=V.controller.variableProvider;if(!L)return;const U=v?{name:v,value:""}:void 0,k=_==="named"?E.NotebookVariablesRequestKind.Named:E.NotebookVariablesRequestKind.Indexed,P=L.provideVariables($.apiNotebook,U,k,y,M);for await(const Q of P){if(M.isCancellationRequested)return;this._proxy.$receiveVariable(C,Q)}}$acceptKernelMessageFromRenderer(f,C,O){const v=this._kernelData.get(f);if(!v)return;const _=this._extHostNotebook.getEditorById(C);v.onDidReceiveMessage.fire(Object.freeze({editor:_.apiEditor,message:O}))}$cellExecutionChanged(f,C,O){const _=this._extHostNotebook.getNotebookDocument(m.URI.revive(f)).getCell(C);if(_){const y=O?p.NotebookCellExecutionState.to(O):E.NotebookCellExecutionState.Idle;y!==void 0&&this._onDidChangeCellExecutionState.fire({cell:_.apiCell,state:y})}}_createNotebookCellExecution(f,C){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const _=new d(C,v,this._proxy);this._activeExecutions.set(v.uri,_);const y=_.onDidChangeState(()=>{_.state===c.Resolved&&(_.dispose(),y.dispose(),this._activeExecutions.delete(v.uri))});return _.asApiObject()}_createNotebookExecution(f,C){const O=this._extHostNotebook.getNotebookDocument(f.uri),v=f.getCells().find(M=>{const V=O.getCellFromApiCell(M);return V&&this._activeExecutions.has(V.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this._activeNotebookExecutions.has(O.uri))throw new Error(`duplicate notebook execution for ${O.uri}`);const _=new s(C,O,this._proxy),y=_.onDidChangeState(()=>{_.state===i.Resolved&&(_.dispose(),y.dispose(),this._activeNotebookExecutions.delete(O.uri))});return this._activeNotebookExecutions.set(O.uri,[_,y]),_.asApiObject()}};e.ExtHostNotebookKernels=a,e.ExtHostNotebookKernels=a=je([Ve(4,A.ILogService)],a);var c;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(c||(c={}));class d extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(f,C,O){super(),this._cell=C,this._proxy=O,this._handle=d.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new l(10,v=>this.update(v)),this._executionOrder=C.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,f,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(f){await this._collector.addItem(f)}async update(f){const C=Array.isArray(f)?f:[f];return this._proxy.$updateExecution(this._handle,new r.SerializableObjectWithBuffers(C))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(f){let C=this._cell;if(f&&(C=this._cell.notebook.getCellFromApiCell(f)),!C)throw new Error("INVALID cell");return C.handle}validateAndConvertOutputs(f){return f.map(C=>{const O=E.NotebookCellOutput.ensureUniqueMimeTypes(C.items,!0);return O===C.items?p.NotebookCellOutput.from(C):p.NotebookCellOutput.from({items:O,id:C.id,metadata:C.metadata})})}async updateOutputs(f,C,O){const v=this.cellIndexToHandle(C),_=this.validateAndConvertOutputs((0,S.asArray)(f));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:v,append:O,outputs:_})}async updateOutputItems(f,C,O){return f=E.NotebookCellOutput.ensureUniqueMimeTypes((0,S.asArray)(f),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:C.id,append:O})}asApiObject(){const f=this;return Object.freeze({get token(){return f._tokenSource.token},get cell(){return f._cell.apiCell},get executionOrder(){return f._executionOrder},set executionOrder(O){f._executionOrder=O,f.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f._executionOrder}])},start(O){if(f._state===c.Resolved||f._state===c.Started)throw new Error("Cannot call start again");f._state=c.Started,f._onDidChangeState.fire(),f.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:O})},end(O,v){if(f._state===c.Resolved)throw new Error("Cannot call resolve twice");f._state=c.Resolved,f._onDidChangeState.fire(),f._collector.flush(),f._proxy.$completeExecution(f._handle,new r.SerializableObjectWithBuffers({runEndTime:v,lastRunSuccess:O}))},clearOutput(O){return f.verifyStateForOutput(),f.updateOutputs([],O,!1)},appendOutput(O,v){return f.verifyStateForOutput(),f.updateOutputs(O,v,!0)},replaceOutput(O,v){return f.verifyStateForOutput(),f.updateOutputs(O,v,!1)},appendOutputItems(O,v){return f.verifyStateForOutput(),f.updateOutputItems(O,v,!0)},replaceOutputItems(O,v){return f.verifyStateForOutput(),f.updateOutputItems(O,v,!1)}})}}var i;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(i||(i={}));class s extends T.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(f,C,O){super(),this._notebook=C,this._proxy=O,this._handle=s.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=i.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,f,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===i.Resolved||this._state===i.Started)throw new Error("Cannot call start again");this._state=i.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===i.Resolved)throw new Error("Cannot call resolve twice");this._state=i.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class l{constructor(f,C){this.delay=f,this.callback=C,this.batch=[],this.startedTimer=Date.now()}addItem(f){return this.batch.push(f),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const f=this.currentDeferred;this.currentDeferred=void 0;const C=this.batch;return this.batch=[],this.callback(C).finally(()=>f.complete())}}function h(b,f){return`${b.value}/${f}`}e.createKernelId=h}),define(Pe[259],Te([1,0,5,3,107]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(g,m){this._extHostNotebook=m,this._rendererMessageEmitters=new Map,this.proxy=g.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(g,m,w){const A=this._extHostNotebook.getEditorById(g);this._rendererMessageEmitters.get(m)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging(g,m){if(!g.contributes?.notebookRenderer?.some(A=>A.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(A,I,u)=>this.getOrCreateEmitterFor(m).event(A,I,u),postMessage:(A,I)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const u=I&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(u?.id,m,A)}}}getOrCreateEmitterFor(g){let m=this._rendererMessageEmitters.get(g);return m||(m=new S.Emitter({onDidRemoveLastListener:()=>{m?.dispose(),this._rendererMessageEmitters.delete(g)}}),this._rendererMessageEmitters.set(g,m),m)}}e.ExtHostNotebookRenderers=R}),define(Pe[260],Te([1,0,6,16,2,23,3]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class g{constructor(w){this.handlers=new Map,this.proxy=w.getProxy(T.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,A,I){if((0,R.checkProposedApiEnabled)(w,"profileContentHandlers"),this.handlers.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.handlers.set(A,I),this.proxy.$registerProfileContentHandler(A,I.name,I.description,w.identifier.value),(0,S.toDisposable)(()=>{this.handlers.delete(A),this.proxy.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,I,u){const p=this.handlers.get(w);if(!p)throw new Error(`Unknown handler with id: ${w}`);return p.saveProfile(A,I,u)}async $readProfile(w,A,I){const u=this.handlers.get(w);if(!u)throw new Error(`Unknown handler with id: ${w}`);return u.readProfile((0,F.isString)(A)?A:D.URI.revive(A),I)}}e.ExtHostProfileContentHandlers=g}),define(Pe[261],Te([1,0,2,3,14,8]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class T{static{this.handlePool=0}constructor(m,w){this.uriTransformer=w,this.providers=new Map,this.proxy=m.getProxy(F.MainContext.MainThreadQuickDiff)}$provideOriginalResource(m,w,A){const I=S.URI.revive(w),u=this.providers.get(m);return u?(0,D.asPromise)(()=>u.provideOriginalResource(I,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(m,w,A,I){const u=T.handlePool++;return this.providers.set(u,w),this.proxy.$registerQuickDiffProvider(u,R.DocumentSelector.from(m,this.uriTransformer),A,I),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(u),this.providers.delete(u)}}}}e.ExtHostQuickDiff=T}),define(Pe[262],Te([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(n,o,t){const r=n.getProxy(R.MainContext.MainThreadQuickOpen);class a{constructor(C,O){this._sessions=new Map,this._instances=0,this._workspace=C,this._commands=O}showQuickPick(C,O,v,_=S.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(O),M=++this._instances,V=r.$show(M,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},_),$={},L=V.then(()=>$);return Promise.race([L,y]).then(U=>{if(U===$)return;const k=(0,u.isProposedApiEnabled)(C,"quickPickItemTooltip");return y.then(P=>{const Q=[];for(let ae=0;ae<P.length;ae++){const me=P[ae];if(typeof me=="string")Q.push({label:me,handle:ae});else if(me.kind===g.QuickPickItemKind.Separator)Q.push({type:"separator",label:me.label});else{me.tooltip&&!k&&console.warn(`Extension '${C.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${C.identifier.value}`);const Ee=me.iconPath?l(me.iconPath):void 0;Q.push({label:me.label,iconPath:Ee?.iconPath,iconClass:Ee?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:k?p.MarkdownString.fromStrict(me.tooltip):void 0,handle:ae})}}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=ae=>{v.onDidSelectItem(P[ae])}),r.$setItems(M,Q),V.then(ae=>{if(typeof ae=="number")return P[ae];if(Array.isArray(ae))return ae.map(me=>P[me])})})}).then(void 0,U=>{if(!(0,m.isCancellationError)(U))return r.$setError(M,U),Promise.reject(U)})}$onItemSelected(C){this._onDidSelectItem?.(C)}showInput(C,O=S.CancellationToken.None){return this._validateInput=C?.validateInput,r.$input(C,typeof this._validateInput=="function",O).then(void 0,v=>{if(!(0,m.isCancellationError)(v))return Promise.reject(v)})}async $validateInput(C){if(!this._validateInput)return;const O=await this._validateInput(C);if(!O||typeof O=="string")return O;let v;switch(O.severity){case g.InputBoxValidationSeverity.Info:v=A.default.Info;break;case g.InputBoxValidationSeverity.Warning:v=A.default.Warning;break;case g.InputBoxValidationSeverity.Error:v=A.default.Error;break;default:v=O.message?A.default.Error:A.default.Ignore;break}return{content:O.message,severity:v}}async showWorkspaceFolderPick(C,O=S.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[C]);if(!v)return;const _=await this._workspace.getWorkspaceFolders2();if(_)return _.find(y=>y.uri.toString()===v.uri.toString())}createQuickPick(C){const O=new h(C,()=>this._sessions.delete(O._id));return this._sessions.set(O._id,O),O}createInputBox(C){const O=new b(C,()=>this._sessions.delete(O._id));return this._sessions.set(O._id,O),O}$onDidChangeValue(C,O){this._sessions.get(C)?._fireDidChangeValue(O)}$onDidAccept(C){this._sessions.get(C)?._fireDidAccept()}$onDidChangeActive(C,O){const v=this._sessions.get(C);v instanceof h&&v._fireDidChangeActive(O)}$onDidChangeSelection(C,O){const v=this._sessions.get(C);v instanceof h&&v._fireDidChangeSelection(O)}$onDidTriggerButton(C,O){this._sessions.get(C)?._fireDidTriggerButton(O)}$onDidTriggerItemButton(C,O,v){const _=this._sessions.get(C);_ instanceof h&&_._fireDidTriggerItemButton(O,v)}$onDidHide(C){this._sessions.get(C)?._fireDidHide()}}class c{static{this._nextId=1}constructor(C,O){this._extensionId=C,this._onDidDispose=O,this._id=h._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new F.Emitter,this._onDidChangeValueEmitter=new F.Emitter,this._onDidTriggerButtonEmitter=new F.Emitter,this._onDidHideEmitter=new F.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(C){this._title=C,this.update({title:C})}get step(){return this._steps}set step(C){this._steps=C,this.update({step:C})}get totalSteps(){return this._totalSteps}set totalSteps(C){this._totalSteps=C,this.update({totalSteps:C})}get enabled(){return this._enabled}set enabled(C){this._enabled=C,this.update({enabled:C})}get busy(){return this._busy}set busy(C){this._busy=C,this.update({busy:C})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(C){this._ignoreFocusOut=C,this.update({ignoreFocusOut:C})}get value(){return this._value}set value(C){this._value=C,this.update({value:C})}get placeholder(){return this._placeholder}set placeholder(C){this._placeholder=C,this.update({placeholder:C})}get buttons(){return this._buttons}set buttons(C){this._buttons=C.slice(),this._handlesToButtons.clear(),C.forEach((O,v)=>{const _=O===g.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(_,O)}),this.update({buttons:C.map((O,v)=>({...l(O.iconPath),tooltip:O.tooltip,handle:O===g.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(C){this._value=C,this._onDidChangeValueEmitter.fire(C)}_fireDidTriggerButton(C){const O=this._handlesToButtons.get(C);O&&this._onDidTriggerButtonEmitter.fire(O)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),r.$dispose(this._id))}update(C){if(!this._disposed){for(const O of Object.keys(C)){const v=C[O];this._pendingUpdate[O]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){r.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function d(f){if(f instanceof g.ThemeIcon)return{id:f.id};const C=s(f),O=i(f);return{dark:typeof C=="string"?T.URI.file(C):C,light:typeof O=="string"?T.URI.file(O):O}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function l(f){const C=d(f);let O,v;return"id"in C?v=I.ThemeIcon.asClassName(C):O=C,{iconPath:O,iconClass:v}}class h extends c{constructor(C,O){super(C.identifier,O),this.extension=C,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new F.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new F.Emitter,this._onDidTriggerItemButtonEmitter=new F.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(C){this._items=C.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),C.forEach((_,y)=>{this._handlesToItems.set(y,_),this._itemsToHandles.set(_,y)});const O=(0,u.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),v=[];for(let _=0;_<C.length;_++){const y=C[_];if(y.kind===g.QuickPickItemKind.Separator)v.push({type:"separator",label:y.label});else{y.tooltip&&!O&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const M=y.iconPath?l(y.iconPath):void 0;v.push({handle:_,label:y.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((V,$)=>({...l(V.iconPath),tooltip:V.tooltip,handle:$}))})}}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(C){this._canSelectMany=C,this.update({canSelectMany:C})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(C){this._matchOnDescription=C,this.update({matchOnDescription:C})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(C){this._matchOnDetail=C,this.update({matchOnDetail:C})}get sortByLabel(){return this._sortByLabel}set sortByLabel(C){this._sortByLabel=C,this.update({sortByLabel:C})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(C){this._keepScrollPosition=C,this.update({keepScrollPosition:C})}get activeItems(){return this._activeItems}set activeItems(C){this._activeItems=C.filter(O=>this._itemsToHandles.has(O)),this.update({activeItems:this._activeItems.map(O=>this._itemsToHandles.get(O))})}get selectedItems(){return this._selectedItems}set selectedItems(C){this._selectedItems=C.filter(O=>this._itemsToHandles.has(O)),this.update({selectedItems:this._selectedItems.map(O=>this._itemsToHandles.get(O))})}_fireDidChangeActive(C){const O=(0,w.coalesce)(C.map(v=>this._handlesToItems.get(v)));this._activeItems=O,this._onDidChangeActiveEmitter.fire(O)}_fireDidChangeSelection(C){const O=(0,w.coalesce)(C.map(v=>this._handlesToItems.get(v)));this._selectedItems=O,this._onDidChangeSelectionEmitter.fire(O)}_fireDidTriggerItemButton(C,O){const v=this._handlesToItems.get(C);if(!v||!v.buttons||!v.buttons.length)return;const _=v.buttons[O];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:v})}}class b extends c{constructor(C,O){super(C.identifier,O),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(C){this._password=C,this.update({password:C})}get prompt(){return this._prompt}set prompt(C){this._prompt=C,this.update({prompt:C})}get valueSelection(){return this._valueSelection}set valueSelection(C){this._valueSelection=C,this.update({valueSelection:C})}get validationMessage(){return this._validationMessage}set validationMessage(C){this._validationMessage=C,C?typeof C=="string"?this.update({validationMessage:C,severity:A.default.Error}):this.update({validationMessage:C.message,severity:C.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new a(o,t)}e.createExtHostQuickOpen=E}),define(Pe[263],Te([1,0,2,5,66,6,14,3,18,138,15,22,45,8,23,13,21]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function r($){return $ instanceof S.URI}function a($,L){return $.scheme===n.Schemas.file&&L.scheme===n.Schemas.file&&o.isLinux?$.toString()===L.toString():$.toString().toLowerCase()===L.toString().toLowerCase()}function c($){if($)return typeof $.iconPath=="string"?S.URI.file($.iconPath):S.URI.isUri($.iconPath)||u.ThemeIcon.isThemeIcon($.iconPath)?$.iconPath:void 0}function d($){if($?.icon){if(S.URI.isUri($.icon))return $.icon;if(u.ThemeIcon.isThemeIcon($.icon))return $.icon;{const L=$.icon;return{light:L.light,dark:L.dark}}}else return}function i($){if($.icon){if(S.URI.isUri($.icon))return $.icon;if(u.ThemeIcon.isThemeIcon($.icon))return $.icon;{const L=$.icon;return{light:L.light,dark:L.dark}}}else return}function s($){if($.icon){if(S.URI.isUri($.icon))return $.icon;if(u.ThemeIcon.isThemeIcon($.icon))return $.icon;{const L=$.icon;return{light:L.light,dark:L.dark}}}else return}function l($,L){if(!$.iconPath&&!L.iconPath)return 0;if($.iconPath){if(!L.iconPath)return 1}else return-1;const U=typeof $.iconPath=="string"?$.iconPath:S.URI.isUri($.iconPath)?$.iconPath.fsPath:$.iconPath.id,k=typeof L.iconPath=="string"?L.iconPath:S.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,w.comparePaths)(U,k)}function h($,L){let U=0;if($.strikeThrough!==L.strikeThrough)return $.strikeThrough?1:-1;if($.faded!==L.faded)return $.faded?1:-1;if($.tooltip!==L.tooltip)return($.tooltip||"").localeCompare(L.tooltip||"");if(U=l($,L),U!==0)return U;if($.light&&L.light)U=l($.light,L.light);else{if($.light)return 1;if(L.light)return-1}if(U!==0)return U;if($.dark&&L.dark)U=l($.dark,L.dark);else{if($.dark)return 1;if(L.dark)return-1}return U}function b($,L){if($.command!==L.command)return $.command<L.command?-1:1;if($.title!==L.title)return $.title<L.title?-1:1;if($.tooltip!==L.tooltip){if($.tooltip!==void 0&&L.tooltip!==void 0)return $.tooltip<L.tooltip?-1:1;if($.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if($.arguments===L.arguments)return 0;if($.arguments)if(L.arguments){if($.arguments.length!==L.arguments.length)return $.arguments.length-L.arguments.length}else return 1;else return-1;for(let U=0;U<$.arguments.length;U++){const k=$.arguments[U],P=L.arguments[U];if(k!==P&&!(r(k)&&r(P)&&a(k,P)))return k<P?-1:1}return 0}function f($,L){let U=(0,w.comparePaths)($.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(U!==0)return U;if($.command&&L.command)U=b($.command,L.command);else{if($.command)return 1;if(L.command)return-1}if(U!==0)return U;if($.decorations&&L.decorations)U=h($.decorations,L.decorations);else{if($.decorations)return 1;if(L.decorations)return-1}return U}function C($,L){for(let U=0;U<$.length;U++)if($[U]!==L[U])return!1;return!0}function O($,L){return $.command===L.command&&$.title===L.title&&$.tooltip===L.tooltip&&($.arguments&&L.arguments?C($.arguments,L.arguments):$.arguments===L.arguments)}function v($,L){return(0,m.equals)($,L,O)}class _{#e;#t;get value(){return this._value}set value(L){L=L??"",this.#e.$setInputBoxValue(this._sourceControlHandle,L),this.updateValue(L)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(L){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,L),this._placeholder=L}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(L){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=L,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!L)}get enabled(){return this._enabled}set enabled(L){L=!!L,this._enabled!==L&&(this._enabled=L,this.#e.$setInputBoxEnablement(this._sourceControlHandle,L))}get visible(){return this._visible}set visible(L){L=!!L,this._visible!==L&&(this._visible=L,this.#e.$setInputBoxVisibility(this._sourceControlHandle,L))}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButton}set actionButton(L){(0,E.checkProposedApiEnabled)(this._extension,"scmInputBoxActionButton"),this._actionButtonDisposables.value=new R.DisposableStore,this._actionButton=L;const U=L!==void 0?{command:this._commands.converter.toInternal(L.command,this._actionButtonDisposables.value),icon:d(L),enabled:L.enabled}:void 0;this.#e.$setInputBoxActionButton(this._sourceControlHandle,U??null)}get document(){return(0,E.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(L,U,k,P,Q,ae){this._extension=L,this._commands=U,this._sourceControlHandle=Q,this._documentUri=ae,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this._actionButtonDisposables=new R.MutableDisposable,this.#t=k,this.#e=P}showValidationMessage(L,U){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,L,U)}$onInputBoxValueChange(L){this.updateValue(L)}updateValue(L){this._value=L,this._onDidChange.fire(L)}}e.ExtHostSCMInputBox=_;class y{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(L){this._label=L,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,L)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(L){this._hideWhenEmpty=L,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(L){this._resourceStates=[...L],this._onDidUpdateResourceStates.fire()}constructor(L,U,k,P,Q){this._proxy=L,this._commands=U,this._sourceControlHandle=k,this._id=P,this._label=Q,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=y._handlePool++}getResourceState(L){return this._resourceStatesMap.get(L)}$executeResourceCommand(L,U){const k=this._resourceStatesCommandsMap.get(L);return k?(0,T.asPromise)(()=>this._commands.executeCommand(k.command,...k.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this._resourceStates].sort(f),k=(0,m.sortedDiff)(this._resourceSnapshot,L,f).map(ae=>{const me=ae.toInsert.map(Ee=>{const Ce=this._resourceHandlePool++;this._resourceStatesMap.set(Ce,Ee);const he=Ee.resourceUri;let de;if(Ee.command)if(Ee.command.command==="vscode.open"||Ee.command.command==="vscode.diff"||Ee.command.command==="vscode.changes"){const ce=new R.DisposableStore;de=this._commands.converter.toInternal(Ee.command,ce),this._resourceStatesDisposablesMap.set(Ce,ce)}else this._resourceStatesCommandsMap.set(Ce,Ee.command);const te=c(Ee.decorations),Ie=Ee.decorations&&c(Ee.decorations.light)||te,oe=Ee.decorations&&c(Ee.decorations.dark)||te,Y=[Ie,oe],H=Ee.decorations&&Ee.decorations.tooltip||"",ne=Ee.decorations&&!!Ee.decorations.strikeThrough,De=Ee.decorations&&!!Ee.decorations.faded,Re=Ee.contextValue||"";return{rawResource:[Ce,he,Y,H,ne,De,Re,de],handle:Ce}});return{start:ae.start,deleteCount:ae.deleteCount,toInsert:me}}),P=k.map(({start:ae,deleteCount:me,toInsert:Ee})=>[ae,me,Ee.map(Ce=>Ce.rawResource)]),Q=k.reverse();for(const{start:ae,deleteCount:me,toInsert:Ee}of Q){const Ce=Ee.map(de=>de.handle),he=this._handlesSnapshot.splice(ae,me,...Ce);for(const de of he)this._resourceStatesMap.delete(de),this._resourceStatesCommandsMap.delete(de),this._resourceStatesDisposablesMap.get(de)?.dispose(),this._resourceStatesDisposablesMap.delete(de)}return this._resourceSnapshot=L,P}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class M{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(L){this._count!==L&&(this._count=L,this.#e.$updateSourceControl(this.handle,{count:L}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(L){this._quickDiffProvider=L;let U;(0,E.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(U=L?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!L,quickDiffLabel:U})}get historyProvider(){return(0,E.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(L){(0,E.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=L,this._historyProviderDisposable.value=new R.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!L}),L&&(this._historyProviderDisposable.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)})),this._historyProviderDisposable.value.add(L.onDidChangeActionButton(()=>{(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._historyProviderActionButtonDisposable.value=new R.DisposableStore;const U=L.actionButton!==void 0?{command:this._commands.converter.toInternal(L.actionButton.command,this._historyProviderActionButtonDisposable.value),description:L.actionButton.description,enabled:L.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.handle,U??null)})))}get commitTemplate(){return this._commitTemplate}set commitTemplate(L){L!==this._commitTemplate&&(this._commitTemplate=L,this.#e.$updateSourceControl(this.handle,{commitTemplate:L}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(L){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=L;const U=this._commands.converter.toInternal(L,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:U})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(L){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new R.DisposableStore,this._actionButton=L;const U=L!==void 0?{command:this._commands.converter.toInternal(L.command,this._actionButtonDisposables.value),secondaryCommands:L.secondaryCommands?.map(k=>k.map(P=>this._commands.converter.toInternal(P,this._actionButtonDisposables.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:U??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(L){if(this._statusBarCommands&&L&&v(this._statusBarCommands,L))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=L;const U=(L||[]).map(k=>this._commands.converter.toInternal(k,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:U})}get selected(){return this._selected}constructor(L,U,k,P,Q,ae,me){this._extension=L,this._commands=P,this._id=Q,this._label=ae,this._rootUri=me,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new R.MutableDisposable,this._historyProviderActionButtonDisposable=new R.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new R.MutableDisposable,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=M._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=k;const Ee=S.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${Q}/scm${this.handle}/input`,query:me?`rootUri=${encodeURIComponent(me.toString())}`:void 0});this._inputBox=new _(L,P,U,this.#e,this.handle,Ee),this.#e.$registerSourceControl(this.handle,Q,ae,me,Ee)}createResourceGroup(L,U){const k=new y(this.#e,this._commands,this.handle,L,U),P=F.Event.once(k.onDidDispose)(()=>this.createdResourceGroups.delete(k));return this.createdResourceGroups.set(k,P),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const L=[],U=[];for(const[k,P]of this.createdResourceGroups){P.dispose();const Q=k.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(k),this.eventuallyUpdateResourceStates()});F.Event.once(k.onDidDispose)(()=>{this.updatedResourceGroups.delete(k),Q.dispose(),this._groups.delete(k.handle),this.#e.$unregisterGroup(this.handle,k.handle)}),L.push([k.handle,k.id,k.label,k.features]);const ae=k._takeResourceStateSnapshot();ae.length>0&&U.push([k.handle,ae]),this._groups.set(k.handle,k)}this.#e.$registerGroups(this.handle,L,U),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const L=[];this.updatedResourceGroups.forEach(U=>{const k=U._takeResourceStateSnapshot();k.length!==0&&L.push([U.handle,k])}),L.length>0&&this.#e.$spliceResourceStates(this.handle,L),this.updatedResourceGroups.clear()}getResourceGroup(L){return this._groups.get(L)}setSelectionState(L){this._selected=L,this._onDidChangeSelection.fire(L)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.handle)}}je([(0,D.debounce)(100)],M.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],M.prototype,"eventuallyUpdateResourceStates",null);let V=class{static{t=this}static{this._handlePool=0}static{this._inputBoxValueProviderHandlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(L,U,k,P){this._commands=U,this._extHostDocuments=k,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new I.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new F.Emitter,this._inputBoxValueProviders=new Map,this._proxy=L.getProxy(g.MainContext.MainThreadSCM),this._telemetry=L.getProxy(g.MainContext.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:Q=>{if(Q&&Q.$mid===3){const ae=this._sourceControls.get(Q.sourceControlHandle);if(!ae)return Q;const me=ae.getResourceGroup(Q.groupHandle);return me?me.getResourceState(Q.handle):Q}else if(Q&&Q.$mid===4){const ae=this._sourceControls.get(Q.sourceControlHandle);return ae?ae.getResourceGroup(Q.groupHandle):Q}else if(Q&&Q.$mid===5){const ae=this._sourceControls.get(Q.handle);return ae||Q}return Q}})}createSourceControl(L,U,k,P){this.logService.trace("ExtHostSCM#createSourceControl",L.identifier.value,U,k,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const Q=t._handlePool++,ae=new M(L,this._extHostDocuments,this._proxy,this._commands,U,k,P);this._sourceControls.set(Q,ae);const me=this._sourceControlsByExtension.get(L.identifier)||[];return me.push(ae),this._sourceControlsByExtension.set(L.identifier,me),ae}registerSourceControlInputBoxValueProvider(L,U,k){this.logService.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",L.identifier.value,k.label);const P=t._inputBoxValueProviderHandlePool++;return this._inputBoxValueProviders.set(P,k),this._proxy.$registerSourceControlInputBoxValueProvider(P,U,k.label,s(k)),(0,R.toDisposable)(()=>{this._proxy.$unregisterSourceControlInputBoxValueProvider(P),this._inputBoxValueProviders.delete(P)})}async $provideInputBoxValue(L,U,k,P){const Q=this._inputBoxValueProviders.get(L);if(Q)return await Q.provideValue(S.URI.revive(U),k,P)??void 0}getLastInputBox(L){this.logService.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const U=this._sourceControlsByExtension.get(L.identifier),k=U&&U[U.length-1];return k&&k.inputBox}$provideOriginalResource(L,U,k){const P=S.URI.revive(U);this.logService.trace("ExtHostSCM#$provideOriginalResource",L,P.toString());const Q=this._sourceControls.get(L);return!Q||!Q.quickDiffProvider||!Q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>Q.quickDiffProvider.provideOriginalResource(P,k)).then(ae=>ae||null)}$onInputBoxValueChange(L,U){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",L);const k=this._sourceControls.get(L);return k&&k.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(L,U,k,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",L,U,k);const Q=this._sourceControls.get(L);if(!Q)return Promise.resolve(void 0);const ae=Q.getResourceGroup(U);return ae?ae.$executeResourceCommand(k,P):Promise.resolve(void 0)}$validateInput(L,U,k){this.logService.trace("ExtHostSCM#$validateInput",L);const P=this._sourceControls.get(L);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>P.inputBox.validateInput(U,k)).then(Q=>{if(!Q)return Promise.resolve(void 0);const ae=p.MarkdownString.fromStrict(Q.message);return ae?Promise.resolve([ae,Q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this._sourceControls.get(L)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(L,U,k){return await this._sourceControls.get(L)?.historyProvider?.resolveHistoryItemGroupBase(U,k)??void 0}async $resolveHistoryItemGroupCommonAncestor(L,U,k,P){return await this._sourceControls.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,k,P)??void 0}async $provideHistoryItems(L,U,k,P){return(await this._sourceControls.get(L)?.historyProvider?.provideHistoryItems(U,k,P))?.map(me=>({...me,icon:i(me)}))??void 0}async $provideHistoryItemChanges(L,U,k){return await this._sourceControls.get(L)?.historyProvider?.provideHistoryItemChanges(U,k)??void 0}};e.ExtHostSCM=V,e.ExtHostSCM=V=t=je([Ve(3,A.ILogService)],V)}),define(Pe[84],Te([1,0,3,5,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(g){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=g.getProxy(S.MainContext.MainThreadSecretState)}async $onDidChangePassword(g){this._onDidChangePassword.fire(g)}get(g,m){return this._proxy.$getPassword(g,m)}store(g,m,w){return this._proxy.$setPassword(g,m,w)}delete(g,m){return this._proxy.$deletePassword(g,m)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Pe[264],Te([1,0,3,8,2]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class R{static{this.handlePool=0}constructor(g,m){this.uriTransformer=m,this.providers=new Map,this.proxy=g.getProxy(S.MainContext.MainThreadShare)}async $provideShare(g,m,w){return await this.providers.get(g)?.provideShare({selection:F.Range.to(m.selection),resourceUri:D.URI.revive(m.resourceUri)},w)??void 0}registerShareProvider(g,m){const w=R.handlePool++;return this.providers.set(w,m),this.proxy.$registerShareProvider(w,F.DocumentSelector.from(g,this.uriTransformer),m.id,m.label,m.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(w),this.providers.delete(w)}}}}e.ExtHostShare=R}),define(Pe[265],Te([1,0,20,6,3]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class R{static{this.ID_POOL=1}constructor(g){this.providers=new Map,this.sessions=new Map,this.proxy=g.getProxy(D.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(g,m){const w=this.providers.get(g);if(!w)return;const A=new F.DisposableStore,I=new S.CancellationTokenSource;this.sessions.set(m,I);const u=A.add(w.provideSpeechToTextSession(I.token));A.add(u.onDidChange(p=>{I.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(m,p)})),A.add(I.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(g){this.sessions.get(g)?.dispose(!0),this.sessions.delete(g)}registerProvider(g,m,w){const A=R.ID_POOL++;return this.providers.set(A,w),this.proxy.$registerProvider(A,m,{extension:g,displayName:g.value}),(0,F.toDisposable)(()=>{this.proxy.$unregisterProvider(A),this.providers.delete(A)})}}e.ExtHostSpeech=R}),define(Pe[266],Te([1,0,7,3,164,6,8,16]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class m{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new S.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(u,p,E,n,o,t=S.StatusBarAlignment.Left,r){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new R.DisposableStore,this.#e=u,this.#t=p,o&&n){this._entryId=(0,S.asStatusBarItemIdentifier)(n.identifier,o);const a=E.get(this._entryId);a&&(t=a.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,r=a.priority,this._visible=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this._entryId=String(m.ID_GEN++);this._extension=n,this._id=o,this._alignment=t,this._priority=this.validatePriority(r)}validatePriority(u){if((0,g.isNumber)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!m.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new R.DisposableStore,typeof u=="string"?this._command={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this._latestCommandRegistration)}:u?this._command={fromApi:u,internal:this.#t.toInternal(u,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let p;this._name?p=this._name:p=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=m.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const n=T.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,u,this._extension?.identifier.value,p,this._text,n,this._command?.internal,E,this._backgroundColor,this._alignment===S.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=m;class w{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const p={message:u};return this._messages.unshift(p),this._update(),new S.Disposable(()=>{const E=this._messages.indexOf(p);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(u,p){this._existingItems=new Map,this._proxy=u.getProxy(F.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new w(this)}$acceptStaticEntries(u){for(const p of u)this._existingItems.set(p.entryId,p)}createStatusBarEntry(u,p,E,n){return new m(this._proxy,this._commands,this._existingItems,u,p,E,n)}setStatusBarMessage(u,p){const E=this._statusMessage.setMessage(u);let n;return typeof p=="number"?n=setTimeout(()=>E.dispose(),p):typeof p<"u"&&p.then(()=>E.dispose(),()=>E.dispose()),new S.Disposable(()=>{E.dispose(),clearTimeout(n)})}}e.ExtHostStatusBar=A}),define(Pe[85],Te([1,0,3,5,4]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(g,m){this._logService=m,this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=g.getProxy(S.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(g,m){this._proxy.$registerExtensionStorageKeysToSync(g,m)}async initializeExtensionStorage(g,m,w){const A=await this._proxy.$initializeExtensionStorage(g,m);let I;return A&&(I=this.safeParseValue(g,m,A)),I||w}setValue(g,m,w){return this._proxy.$setValue(g,m,w)}$acceptValue(g,m,w){const A=this.safeParseValue(g,m,w);A&&this._onDidChangeStorage.fire({shared:g,key:m,value:A})}safeParseValue(g,m,w){try{return JSON.parse(w)}catch(A){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${g}): ${A}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Pe[86],Te([1,0,4,27,15,63,2]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,S.createDecorator)("IExtensionStoragePaths");let g=class{constructor(w,A,I){this._logService=A,this._extHostFileSystem=I,this._workspace=w.workspace??void 0,this._environment=w.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(w){return T.URI.joinPath(this._environment.workspaceStorageHome,w)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const w=this._workspace.id,A=await this._getWorkspaceStorageURI(w);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(w){if(this._value)return T.URI.joinPath(this._value,w.identifier.value)}globalValue(w){return T.URI.joinPath(this._environment.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=g,e.ExtensionStoragePaths=g=je([Ve(0,F.IExtHostInitDataService),Ve(1,D.ILogService),Ve(2,R.IExtHostConsumerFileSystem)],g)}),define(Pe[64],Te([1,0,5,3,4,2,17,6,7,166,11,194,20,33,195,45,14,8,32]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class a{constructor(v,_,y,M){this._proxy=v,this._id=_,this._creationOptions=y,this._name=M,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise($=>this._pidPromiseComplete=$);const V=this;this.value={get name(){return V._name||""},get processId(){return V._pidPromise},get creationOptions(){return V._creationOptions},get exitStatus(){return V._exitStatus},get state(){return V._state},get selection(){return V._selection},sendText($,L=!0){V._checkDisposed(),V._proxy.$sendText(V._id,$,L)},show($){V._checkDisposed(),V._proxy.$show(V._id,$)},hide(){V._checkDisposed(),V._proxy.$hide(V._id)},dispose(){V._disposed||(V._disposed=!0,V._proxy.$dispose(V._id))},get dimensions(){if(!(V._cols===void 0||V._rows===void 0))return{columns:V._cols,rows:V._rows}}}}async create(v,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??_?.cwd??void 0,env:v.env??void 0,icon:b(v.iconPath)??void 0,color:n.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:_?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:_?.useShellEnvironment??void 0,location:_?.location||this._serializeParentTerminal(v.location,_?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,_,y,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:y,color:n.ThemeColor.isThemeColor(M)?M.id:void 0,location:this._serializeParentTerminal(v,_),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(v,_){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&_?{parentTerminal:_}:"viewColumn"in v?{viewColumn:t.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(v){this._name=v}setExitStatus(v,_){this._exitStatus=Object.freeze({code:v,reason:_})}setDimensions(v,_){return v===this._cols&&_===this._rows||v===0||_===0?!1:(this._cols=v,this._rows=_,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(v){this._selection=v}_setProcessId(v){this._pidPromiseComplete?(this._pidPromiseComplete(v),this._pidPromiseComplete=void 0):this._pidPromise.then(_=>{_!==v&&(this._pidPromise=Promise.resolve(v))})}}e.ExtHostTerminal=a;class c{get onProcessReady(){return this._onProcessReady.event}constructor(v){this._pty=v,this.id=0,this.shouldPersist=!1,this._onProcessData=new S.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new S.Emitter,this._onDidChangeProperty=new S.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new S.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,_){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${_}`)}async start(){}shutdown(){this._pty.close()}input(v){this._pty.handleInput?.(v)}resize(v,_){this._pty.setDimensions?.({columns:v,rows:_})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this._pty.onDidWrite(_=>this._onProcessData.fire(_)),this._pty.onDidClose?.((_=void 0)=>{this._onProcessExit.fire(_===void 0?void 0:_)}),this._pty.onDidOverrideDimensions?.(_=>{_&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:_.columns,rows:_.rows}})}),this._pty.onDidChangeName?.(_=>{this._onDidChangeProperty.fire({type:"title",value:_})}),this._pty.open(v||void 0),v&&this._pty.setDimensions?.(v),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,i=class extends g.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(v=>v.value)}constructor(v,_,y){super(),this._extHostCommands=_,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new g.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new S.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new S.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new S.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new S.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new S.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new S.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new S.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=y.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(v),this._extHostCommands.registerArgumentProcessor({processArgument:M=>{const V=$=>{const L=$;return this._getTerminalById(L.instanceId)?.value};switch(M?.$mid){case 15:return V(M);default:{if(Array.isArray(M))for(let $=0;$<M.length&&M[$].$mid===15;$++)M[$]=V(M[$]);return M}}}}),this._register({dispose:()=>{for(const[M,V]of this._terminalProcesses)V.shutdown(!0)}})}getDefaultShell(v){return(v?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(v){return(v?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(v,_){const y=new a(this._proxy,(0,p.generateUuid)(),v,v.name),M=new c(v.pty);return y.createExtensionTerminal(v.location,this._serializeParentTerminal(v,_).resolvedExtHostIdentifier,b(v.iconPath),f(v.color)).then(V=>{const $=this._setupExtHostProcessListeners(V,M);this._terminalProcessDisposables[V]=$}),this._terminals.push(y),y.value}_serializeParentTerminal(v,_){if(_=_||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const y=v.location.parentTerminal;if(y){const M=this._terminals.find(V=>V.value===y);M&&(_.resolvedExtHostIdentifier=M._id)}}else v.location&&typeof v.location!="object"?_.location=v.location:_.location&&typeof _.location=="object"&&"splitActiveTerminal"in _.location&&(_.location={splitActiveTerminal:!0});return _}attachPtyToTerminal(v,_){if(!this._getTerminalById(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const M=new c(_),V=this._setupExtHostProcessListeners(v,M);this._terminalProcessDisposables[v]=V}async $acceptActiveTerminalChanged(v){const _=this._activeTerminal;if(v===null){this._activeTerminal=void 0,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const y=this._getTerminalById(v);y&&(this._activeTerminal=y,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(v,_){const y=this._getTerminalById(v);y&&this._onDidWriteTerminalData.fire({terminal:y.value,data:_})}async $acceptTerminalDimensions(v,_,y){const M=this._getTerminalById(v);M&&M.setDimensions(_,y)&&this._onDidChangeTerminalDimensions.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand(v,_){const y=this._getTerminalById(v);y&&this._onDidExecuteCommand.fire({terminal:y.value,..._})}async $acceptTerminalMaximumDimensions(v,_,y){this._terminalProcesses.get(v)?.resize(_,y)}async $acceptTerminalTitleChange(v,_){const y=this._getTerminalById(v);y&&(y.name=_)}async $acceptTerminalClosed(v,_,y){const M=this._getTerminalObjectIndexById(this._terminals,v);if(M!==null){const V=this._terminals.splice(M,1)[0];V.setExitStatus(_,y),this._onDidCloseTerminal.fire(V.value)}}$acceptTerminalOpened(v,_,y,M){if(_){const L=this._getTerminalObjectIndexById(this._terminals,_);if(L!==null){this._terminals[L]._id=v,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const V={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:R.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},$=new a(this._proxy,v,V,y);this._terminals.push($),this._onDidOpenTerminal.fire($.value),$.isOpen=!0}async $acceptTerminalProcessId(v,_){this._getTerminalById(v)?._setProcessId(_)}async $startExtensionTerminal(v,_){const y=this._getTerminalById(v);if(!y)return{message:(0,w.localize)(0,null,v)};y.isOpen||await new Promise(V=>{const $=this.onDidOpenTerminal(async L=>{L===y.value&&($.dispose(),V())})});const M=this._terminalProcesses.get(v);M?M.startSendingEvents(_):this._extensionTerminalAwaitingStart[v]={initialDimensions:_}}_setupExtHostProcessListeners(v,_){const y=new g.DisposableStore;y.add(_.onProcessReady(V=>this._proxy.$sendProcessReady(v,V.pid,V.cwd,V.windowsPty))),y.add(_.onDidChangeProperty(V=>this._proxy.$sendProcessProperty(v,V))),this._bufferer.startBuffering(v,_.onProcessData),y.add(_.onProcessExit(V=>this._onProcessExit(v,V))),this._terminalProcesses.set(v,_);const M=this._extensionTerminalAwaitingStart[v];return M&&_ instanceof c&&(_.startSendingEvents(M.initialDimensions),delete this._extensionTerminalAwaitingStart[v]),y}$acceptProcessAckDataEvent(v,_){this._terminalProcesses.get(v)?.acknowledgeDataEvent(_)}$acceptProcessInput(v,_){this._terminalProcesses.get(v)?.input(_)}$acceptTerminalInteraction(v){const _=this._getTerminalById(v);_?.setInteractedWith()&&this._onDidChangeTerminalState.fire(_.value)}$acceptTerminalSelection(v,_){this._getTerminalById(v)?.setSelection(_)}$acceptProcessResize(v,_,y){try{this._terminalProcesses.get(v)?.resize(_,y)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(v,_){this._terminalProcesses.get(v)?.shutdown(_)}$acceptProcessRequestInitialCwd(v){this._terminalProcesses.get(v)?.getInitialCwd().then(_=>this._proxy.$sendProcessProperty(v,{type:"initialCwd",value:_}))}$acceptProcessRequestCwd(v){this._terminalProcesses.get(v)?.getCwd().then(_=>this._proxy.$sendProcessProperty(v,{type:"cwd",value:_}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this._linkProviders.add(v),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new m.Disposable(()=>{this._linkProviders.delete(v),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(v,_,y){if(this._profileProviders.has(_))throw new Error(`Terminal profile provider "${_}" already registered`);return this._profileProviders.set(_,y),this._proxy.$registerProfileProvider(_,v.identifier.value),new m.Disposable(()=>{this._profileProviders.delete(_),this._proxy.$unregisterProfileProvider(_)})}registerTerminalQuickFixProvider(v,_,y){if(this._quickFixProviders.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this._quickFixProviders.set(v,y),this._proxy.$registerQuickFixProvider(v,_),new m.Disposable(()=>{this._quickFixProviders.delete(v),this._proxy.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,_){const y=new u.CancellationTokenSource().token;if(y.isCancellationRequested)return;const M=this._quickFixProviders.get(v);if(!M)return;const V=await M.provideTerminalQuickFixes(_,y);if(V===null||Array.isArray(V)&&V.length===0)return;const $=new g.DisposableStore;if(this._lastQuickFixCommands.value=$,!Array.isArray(V))return V?t.TerminalQuickFix.from(V,this._extHostCommands.converter,$):void 0;const L=[];for(const U of V){const k=t.TerminalQuickFix.from(U,this._extHostCommands.converter,$);k&&L.push(k)}return L}async $createContributedProfileTerminal(v,_){const y=new u.CancellationTokenSource().token;let M=await this._profileProviders.get(v)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,_);return}this.createTerminalFromOptions(M.options,_)}}async $provideLinks(v,_){const y=this._getTerminalById(v);if(!y)return[];this._terminalLinkCache.delete(v),this._terminalLinkCancellationSource.get(v)?.dispose(!0);const V=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(v,V);const $=[],L={terminal:y.value,line:_},U=[];for(const Q of this._linkProviders)U.push(o.Promises.withAsyncBody(async ae=>{V.token.onCancellationRequested(()=>ae({provider:Q,links:[]}));const me=await Q.provideTerminalLinks(L,V.token)||[];V.token.isCancellationRequested||ae({provider:Q,links:me})}));const k=await Promise.all(U);if(V.token.isCancellationRequested)return[];const P=new Map;for(const Q of k)Q&&Q.links.length>0&&$.push(...Q.links.map(ae=>{const me={id:d++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return P.set(me.id,{provider:Q.provider,link:ae}),me}));return this._terminalLinkCache.set(v,P),$}$activateLink(v,_){const y=this._terminalLinkCache.get(v)?.get(_);y&&y.provider.handleTerminalLink(y.link)}_onProcessExit(v,_){this._bufferer.stopBuffering(v),this._terminalProcesses.delete(v),delete this._extensionTerminalAwaitingStart[v];const y=this._terminalProcessDisposables[v];y&&(y.dispose(),delete this._terminalProcessDisposables[v]),this._proxy.$sendProcessExit(v,_)}_getTerminalById(v){return this._getTerminalObjectById(this._terminals,v)}_getTerminalObjectById(v,_){const y=this._getTerminalObjectIndexById(v,_);return y!==null?v[y]:null}_getTerminalObjectIndexById(v,_){const y=v.findIndex(M=>M._id===_);return y===-1?null:y}getEnvironmentVariableCollection(v){let _=this._environmentVariableCollections.get(v.identifier.value);return _||(_=new s,this._setEnvironmentVariableCollection(v.identifier.value,_)),_.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(v,_){const y=(0,I.serializeEnvironmentVariableCollection)(_.map),M=(0,I.serializeEnvironmentDescriptionMap)(_.descriptionMap);this._proxy.$setEnvironmentVariableCollection(v,_.persistent,y.length===0?void 0:y,M)}$initEnvironmentVariableCollections(v){v.forEach(_=>{const y=_[0],M=new s(_[1]);this._setEnvironmentVariableCollection(y,M)})}$acceptDefaultProfile(v,_){const y=this._defaultProfile;this._defaultProfile=v,this._defaultAutomationProfile=_,y?.path!==v.path&&this._onDidChangeShell.fire(v.path)}_setEnvironmentVariableCollection(v,_){this._environmentVariableCollections.set(v,_),_.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(v,_)})}};e.BaseExtHostTerminalService=i,e.BaseExtHostTerminalService=i=je([Ve(1,r.IExtHostCommands),Ve(2,T.IExtHostRpcService)],i);class s{get persistent(){return this._persistent}set persistent(v){this._persistent=v,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(v){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new S.Emitter,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const _=this.getScopeKey(v);let y=this.scopedCollections.get(_);return y||(y=new l(this,v),this.scopedCollections.set(_,y),y.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),y}replace(v,_,y,M){this._setIfDiffers(v,{value:_,type:m.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:M})}append(v,_,y,M){this._setIfDiffers(v,{value:_,type:m.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:M})}prepend(v,_,y,M){this._setIfDiffers(v,{value:_,type:m.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:M})}_setIfDiffers(v,_){if(_.options&&_.options.applyAtProcessCreation===!1&&!_.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.getKey(v,_.scope),M=this.map.get(y),V=_.options?{applyAtProcessCreation:_.options.applyAtProcessCreation??!1,applyAtShellIntegration:_.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==_.value||M.type!==_.type||M.options?.applyAtProcessCreation!==V.applyAtProcessCreation||M.options?.applyAtShellIntegration!==V.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==_.scope?.workspaceFolder?.index){const $=this.getKey(v,_.scope),L={variable:v,..._,options:V};this.map.set($,L),this._onDidChangeCollection.fire()}}get(v,_){const y=this.getKey(v,_),M=this.map.get(y);return M?C(M):void 0}getKey(v,_){const y=this.getScopeKey(_);return y.length?`${v}:::${y}`:v}getScopeKey(v){return this.getWorkspaceKey(v?.workspaceFolder)??""}getWorkspaceKey(v){return v?v.uri.toString():void 0}getVariableMap(v){const _=new Map;for(const[y,M]of this.map)this.getScopeKey(M.scope)===this.getScopeKey(v)&&_.set(M.variable,C(M));return _}delete(v,_){const y=this.getKey(v,_);this.map.delete(y),this._onDidChangeCollection.fire()}clear(v){if(v?.workspaceFolder){for(const[_,y]of this.map)y.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(_);this.clearDescription(v)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(v,_){const y=this.getScopeKey(_),M=this.descriptionMap.get(y);if(!M||M.description!==v){let V;typeof v=="string"?V=v:V=v?.value.split(`

`)[0];const $={description:V,scope:_};this.descriptionMap.set(y,$),this._onDidChangeCollection.fire()}}getDescription(v){const _=this.getScopeKey(v);return this.descriptionMap.get(_)?.description}clearDescription(v){const _=this.getScopeKey(v);this.descriptionMap.delete(_)}}class l{get persistent(){return this.collection.persistent}set persistent(v){this.collection.persistent=v}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(v,_){this.collection=v,this.scope=_,this._onDidChangeCollection=new S.Emitter}getScoped(v){return this.collection.getScopedEnvironmentVariableCollection(v)}replace(v,_,y){this.collection.replace(v,_,y,this.scope)}append(v,_,y){this.collection.append(v,_,y,this.scope)}prepend(v,_,y){this.collection.prepend(v,_,y,this.scope)}get(v){return this.collection.get(v,this.scope)}forEach(v,_){this.collection.getVariableMap(this.scope).forEach((y,M)=>v.call(_,M,y,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(v){this.collection.delete(v,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(v){this.collection.setDescription(v,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let h=class extends i{constructor(v,_){super(!1,v,_)}createTerminal(v,_,y){throw new A.NotSupportedError}createTerminalFromOptions(v,_){throw new A.NotSupportedError}};e.WorkerExtHostTerminalService=h,e.WorkerExtHostTerminalService=h=je([Ve(0,r.IExtHostCommands),Ve(1,T.IExtHostRpcService)],h);function b(O){if(!(!O||typeof O=="string"))return"id"in O?{id:O.id,color:O.color}:O}function f(O){return n.ThemeColor.isThemeColor(O)?O:void 0}function C(O){const v={...O};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Pe[267],Te([1,0,14,24,20,5,219,98,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let d=class extends m.Disposable{constructor($,L,U){super(),this.editors=U,this.resultsChangedEmitter=this._register(new R.Emitter),this.controllers=new Map,this.activeProfilesChangedEmitter=this._register(new R.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=$.getProxy(u.MainContext.MainThreadTesting),this.observer=new _(this.proxy),this.runTracker=new h(this.proxy),L.registerArgumentProcessor({processArgument:k=>{switch(k?.$mid){case 16:{const P=k,Q=P.tests[P.tests.length-1].item.extId;return this.controllers.get(t.TestId.root(Q))?.collection.tree.get(Q)?.actual??(0,E.toItemFromContext)(k)}case 18:{const{extId:P,message:Q}=k;return{test:this.controllers.get(t.TestId.root(P))?.collection.tree.get(P)?.actual,message:n.TestMessage.to(Q)}}default:return k}}}),L.registerCommand(!1,"testing.getExplorerSelection",async()=>{const k=await L.executeCommand("_testing.getExplorerSelection"),P=Q=>{const ae=this.controllers.get(t.TestId.root(Q));if(ae)return t.TestId.isRoot(Q)?ae.controller:ae.collection.tree.get(Q)?.actual};return{include:k?.include.map(P).filter(A.isDefined)||[],exclude:k?.exclude.map(P).filter(A.isDefined)||[]}})}createTestController($,L,U,k){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const P=new m.DisposableStore,Q=P.add(new E.ExtHostTestItemCollection(L,U,this.editors));Q.root.label=U;const ae=new Map,me=new Set,Ee=this.proxy,Ce={items:Q.root.children,get label(){return U},set label(de){U=de,Q.root.label=de,Ee.$updateController(L,{label:U})},get refreshHandler(){return k},set refreshHandler(de){k=de,Ee.$updateController(L,{canRefresh:!!de})},get id(){return L},createRunProfile:(de,te,Ie,oe,Y,H)=>{let ne=(0,g.hash)(de);for(;ae.has(ne);)ne++;return new y(this.proxy,ae,$,me,this.activeProfilesChangedEmitter.event,L,ne,de,te,Ie,oe,Y,H)},createTestItem(de,te,Ie){return new E.TestItemImpl(L,de,te,Ie)},createTestRun:(de,te,Ie=!0)=>this.runTracker.createTestRun($,L,Q,de,te,Ie),invalidateTestResults:de=>{if(de===void 0)this.proxy.$markTestRetired(void 0);else{const te=de instanceof Array?de:[de];this.proxy.$markTestRetired(te.map(Ie=>t.TestId.fromExtHostTestItem(Ie,L).toString()))}},set resolveHandler(de){Q.resolveHandler=de},get resolveHandler(){return Q.resolveHandler},dispose:()=>{P.dispose()}};Ee.$registerTestController(L,U,!!k),P.add((0,m.toDisposable)(()=>Ee.$unregisterTestController(L)));const he={controller:Ce,collection:Q,profiles:ae,extension:$,activeProfiles:me};return this.controllers.set(L,he),P.add((0,m.toDisposable)(()=>this.controllers.delete(L))),P.add(Q.onDidGenerateDiff(de=>Ee.$publishDiff(L,de.map(a.TestsDiffOp.serialize)))),Ce}createTestObserver(){return this.observer.checkout()}async runTests($,L=D.CancellationToken.None){const U=b($);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const k=this.controllers.get(U.controllerId);if(!k)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:$.include?.map(P=>t.TestId.fromExtHostTestItem(P,k.collection.root.id).toString())??[k.collection.root.id],profileGroup:M[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:$.exclude?.map(P=>P.id)},L)}$syncTests(){for(const{collection:$}of this.controllers.values())$.flushDiff();return Promise.resolve()}async $provideFileCoverage($,L,U){return await this.runTracker.getCoverageReport($,L)?.provideFileCoverage(U)??[]}async $resolveFileCoverage($,L,U,k){return await this.runTracker.getCoverageReport($,L)?.resolveFileCoverage(U,k)??[]}$configureRunProfile($,L){this.controllers.get($)?.profiles.get(L)?.configureHandler?.()}$setActiveRunProfiles($){const L=new Map;for(const[U,k]of Object.entries($)){const P=this.controllers.get(U);if(!P)continue;const Q=new Map,ae=k.filter(Ee=>!P.activeProfiles.has(Ee)),me=[...P.activeProfiles].filter(Ee=>!k.includes(Ee));for(const Ee of ae)Q.set(Ee,!0),P.activeProfiles.add(Ee);for(const Ee of me)Q.set(Ee,!1),P.activeProfiles.delete(Ee);Q.size&&L.set(U,Q)}this.activeProfilesChangedEmitter.fire(L)}async $refreshTests($,L){await this.controllers.get($)?.controller.refreshHandler?.(L)}$publishTestResults($){this.results=Object.freeze($.map(L=>(0,w.deepFreeze)(n.TestResults.to(L))).concat(this.results).sort((L,U)=>U.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest($,L){const U=this.controllers.get(t.TestId.fromString($).controllerId)?.collection;U&&(await U.expand($,L<0?1/0:L),U.flushDiff())}$acceptDiff($){this.observer.applyDiff($.map(a.TestsDiffOp.deserialize))}async $runControllerTests($,L){return Promise.all($.map(U=>this.runControllerTestRequest(U,!1,L)))}async $startContinuousRun($,L){const U=new D.CancellationTokenSource(L),k=await Promise.all($.map(P=>this.runControllerTestRequest(P,!0,U.token)));return!L.isCancellationRequested&&!k.some(P=>P.error)&&await new Promise(P=>L.onCancellationRequested(P)),U.dispose(!0),k}async runControllerTestRequest($,L,U){const k=this.controllers.get($.controllerId);if(!k)return{};const{collection:P,profiles:Q,extension:ae}=k,me=Q.get($.profileId);if(!me)return{};const Ee=$.testIds.map(te=>P.tree.get(te)).filter(A.isDefined),Ce=$.excludeExtIds.map(te=>k.collection.tree.get(te)).filter(A.isDefined).filter(te=>Ee.some(Ie=>Ie.fullId.compare(te.fullId)===2));if(!Ee.length)return{};const he=new o.TestRunRequest(Ee.some(te=>te.actual instanceof E.TestItemRootImpl)?void 0:Ee.map(te=>te.actual),Ce.map(te=>te.actual),me,L),de=(0,a.isStartControllerTests)($)&&this.runTracker.prepareForMainThreadTestRun(he,f.fromInternal($,k.collection),ae,U);try{return await me.runHandler(he,U),{}}catch(te){return{error:String(te)}}finally{de&&(de.hasRunningTasks&&!U.isCancellationRequested&&await R.Event.toPromise(de.onEnd),de.dispose())}}$cancelExtensionTestRun($){$===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById($)}};e.ExtHostTesting=d,e.ExtHostTesting=d=je([Ve(0,p.IExtHostRpcService)],d);const i=1e4;var s;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(s||(s={}));class l extends m.Disposable{get hasRunningTasks(){return this.tasks.size>0}get id(){return this.dto.id}constructor($,L,U,k){super(),this.dto=$,this.proxy=L,this.extension=U,this.state=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.coverageEmitter=this._register(new R.Emitter),this.onDidCoverage=this.coverageEmitter.event,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(k));const P=this._register(new S.RunOnceScheduler(()=>this.forciblyEndTasks(),i));this._register(this.cts.token.onCancellationRequested(()=>P.schedule()))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}createRun($){const L=this.dto.id,U=this.dto.controllerId,k=(0,I.generateUuid)(),P=this.extension,Q=this.coverageEmitter;let ae;const me=de=>(te,...Ie)=>{if(Ce){console.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(te)&&(this.ensureTestIsKnown(te),de(te,...Ie))},Ee=(de,te)=>{const Ie=te instanceof Array?te.map(n.TestMessage.from):[n.TestMessage.from(te)];if(de.uri&&de.range){const oe={range:n.Range.from(de.range),uri:de.uri};for(const Y of Ie)Y.location=Y.location||oe}this.proxy.$appendTestMessagesInRun(L,k,t.TestId.fromExtHostTestItem(de,U).toString(),Ie)};let Ce=!1;const he={isPersisted:this.dto.isPersisted,token:this.cts.token,name:$,get coverageProvider(){return ae?.provider},set coverageProvider(de){(0,c.checkProposedApiEnabled)(P,"testCoverage"),ae=de&&new C(de),Q.fire({taskId:k,runId:L,coverage:ae})},enqueued:me(de=>{this.proxy.$updateTestStateInRun(L,k,t.TestId.fromExtHostTestItem(de,U).toString(),1)}),skipped:me(de=>{this.proxy.$updateTestStateInRun(L,k,t.TestId.fromExtHostTestItem(de,U).toString(),5)}),started:me(de=>{this.proxy.$updateTestStateInRun(L,k,t.TestId.fromExtHostTestItem(de,U).toString(),2)}),errored:me((de,te,Ie)=>{Ee(de,te),this.proxy.$updateTestStateInRun(L,k,t.TestId.fromExtHostTestItem(de,U).toString(),6,Ie)}),failed:me((de,te,Ie)=>{Ee(de,te),this.proxy.$updateTestStateInRun(L,k,t.TestId.fromExtHostTestItem(de,U).toString(),4,Ie)}),passed:me((de,te)=>{this.proxy.$updateTestStateInRun(L,k,t.TestId.fromExtHostTestItem(de,this.dto.controllerId).toString(),3,te)}),appendOutput:(de,te,Ie)=>{Ce||(Ie&&(this.dto.isIncluded(Ie)?this.ensureTestIsKnown(Ie):Ie=void 0),this.proxy.$appendOutputToRun(L,k,F.VSBuffer.fromString(de),te&&n.location.from(te),Ie&&t.TestId.fromExtHostTestItem(Ie,U).toString()))},end:()=>{Ce||(Ce=!0,this.proxy.$finishedTestRunTask(L,k),this.tasks.delete(k),this.tasks.size||this.markEnded())}};return this.tasks.set(k,{run:he}),this.proxy.$startedTestRunTask(L,{id:k,name:$,running:!0}),he}forciblyEndTasks(){for(const{run:$}of this.tasks.values())$.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown($){if(!($ instanceof E.TestItemImpl))throw new r.InvalidTestItemError($.id);if(this.sharedTestIds.has(t.TestId.fromExtHostTestItem($,this.dto.controllerId).toString()))return;const L=[],U=this.dto.colllection.root;for(;;){const k=n.TestItem.from($);if(L.unshift(k),this.sharedTestIds.has(k.extId)||(this.sharedTestIds.add(k.extId),$===U))break;$=$.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}dispose(){this.markEnded(),super.dispose()}}class h{get trackers(){return this.tracked.values()}constructor($){this.proxy=$,this.tracked=new Map,this.coverageReports=[]}getCoverageReport($,L){return this.coverageReports.find(U=>U.runId===$)?.coverage.get(L)}prepareForMainThreadTestRun($,L,U,k){return this.getTracker($,L,U,k)}cancelRunById($){for(const L of this.tracked.values())if(L.id===$){L.cancel();return}}cancelAllRuns(){for(const $ of this.tracked.values())$.cancel()}createTestRun($,L,U,k,P,Q){const ae=this.tracked.get(k);if(ae)return ae.createRun(P);const me=f.fromPublic(L,U,k,Q),Ee=b(k);this.proxy.$startedExtensionTestRun({controllerId:L,continuous:!!k.continuous,profile:Ee&&{group:M[Ee.kind],id:Ee.profileId},exclude:k.exclude?.map(he=>t.TestId.fromExtHostTestItem(he,U.root.id).toString())??[],id:me.id,include:k.include?.map(he=>t.TestId.fromExtHostTestItem(he,U.root.id).toString())??[U.root.id],persist:Q});const Ce=this.getTracker(k,me,$);return R.Event.once(Ce.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(me.id),Ce.dispose()}),Ce.createRun(P)}getTracker($,L,U,k){const P=new l(L,this.proxy,U,k);this.tracked.set($,P);let Q;const ae=P.onDidCoverage(({runId:me,taskId:Ee,coverage:Ce})=>{Q||(Q={runId:me,coverage:new Map},this.coverageReports.unshift(Q),this.coverageReports.length>a.KEEP_N_LAST_COVERAGE_REPORTS&&this.coverageReports.pop()),Q.coverage.set(Ee,Ce),this.proxy.$signalCoverageAvailable(me,Ee,!!Ce)});return R.Event.once(P.onEnd)(()=>{this.tracked.delete($),ae.dispose()}),P}}e.TestRunCoordinator=h;const b=V=>{if(V.profile){if(!(V.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class f{static fromPublic($,L,U,k){return new f($,(0,I.generateUuid)(),U.include?.map(P=>t.TestId.fromExtHostTestItem(P,$).toString())??[$],U.exclude?.map(P=>t.TestId.fromExtHostTestItem(P,$).toString())??[],k,L)}static fromInternal($,L){return new f($.controllerId,$.runId,$.testIds,$.excludeExtIds,!0,L)}constructor($,L,U,k,P,Q){this.controllerId=$,this.id=L,this.isPersisted=P,this.colllection=Q,this.includePrefix=U.map(ae=>ae+"\0"),this.excludePrefix=k.map(ae=>ae+"\0")}isIncluded($){const L=t.TestId.fromExtHostTestItem($,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(L===U||L.startsWith(U))return!1;for(const U of this.includePrefix)if(L===U||L.startsWith(U))return!0;return!1}}e.TestRunDto=f;class C{constructor($){this.provider=$}async provideFileCoverage($){this.fileCoverage||(this.fileCoverage=(async()=>this.provider.provideFileCoverage($))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage($,L){const U=await this.fileCoverage;let k=U?.[$];return!this.provider||!U||!k?[]:(k.detailedCoverage||(k=U[$]=await this.provider.resolveFileCoverage?.(k,L)??k),k.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class O{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor($){this.emitter=$,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add($){this.added.add($)}update($){Object.assign($.revived,n.TestItem.toPlain($.item)),this.added.has($)||this.updated.add($)}remove($){if(this.added.has($)){this.added.delete($);return}this.updated.delete($);const L=t.TestId.parentId($.item.extId);if(L&&this.alreadyRemoved.has(L.toString())){this.alreadyRemoved.add($.item.extId);return}this.removed.add($)}getChangeEvent(){const{added:$,updated:L,removed:U}=this;return{get added(){return[...$].map(k=>k.revived)},get updated(){return[...L].map(k=>k.revived)},get removed(){return[...U].map(k=>k.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class v extends a.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById($){return this.items.get($)}getMirroredTestDataByReference($){return this.items.get($.id)}createItem($,L){return{...$,revived:n.TestItem.toPlain($.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new O(this.changeEmitter)}}class _{constructor($){this.proxy=$}checkout(){this.current||(this.current=this.createObserverData());const $=this.current;return $.observers++,{onDidChangeTest:$.tests.onDidChangeTests,get tests(){return[...$.tests.rootTests].map(L=>L.revived)},dispose:(0,T.createSingleCallFunction)(()=>{--$.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference($){return this.current?.tests.getMirroredTestDataByReference($)}applyDiff($){this.current?.tests.apply($)}createObserverData(){const $=new v;return this.proxy.$subscribeToDiffs(),{observers:0,tests:$}}}class y{#e;#t;#i;#o;#r;get label(){return this._label}set label($){$!==this._label&&(this._label=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:$}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun($){$!==this._supportsContinuousRun&&(this._supportsContinuousRun=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:$}))}get isDefault(){return this._isDefault}set isDefault($){$!==this._isDefault&&(this._isDefault=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:$}))}get tag(){return this._tag}set tag($){$?.id!==this._tag?.id&&(this._tag=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:$?n.TestTag.namespace(this.controllerId,$.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler($){$!==this._configureHandler&&(this._configureHandler=$,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!$}))}get isSelected(){return(0,c.checkProposedApiEnabled)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.checkProposedApiEnabled)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,$=>$.map(L=>L.get(this.controllerId)?.get(this.profileId)).filter(A.isDefined))}constructor($,L,U,k,P,Q,ae,me,Ee,Ce,he=!1,de=void 0,te=!1){this.controllerId=Q,this.profileId=ae,this._label=me,this.kind=Ee,this.runHandler=Ce,this._isDefault=he,this._tag=de,this._supportsContinuousRun=te,this.#e=$,this.#r=L,this.#t=U,this.#i=k,this.#o=P,L.set(ae,this);const Ie=M[Ee];if(typeof Ie!="number")throw new Error(`Unknown TestRunProfile.group ${Ee}`);this.#e.$publishTestRunProfile({profileId:ae,controllerId:Q,tag:de?n.TestTag.namespace(this.controllerId,de.id):null,label:me,group:Ie,isDefault:he,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=y;const M={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[268],Te([1,0,18,11,5,3,109,8,7]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(I,u){this._extHostDocumentsAndEditors=u,this._onDidChangeTextEditorSelection=new D.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorOptions=new D.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorVisibleRanges=new D.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeTextEditorViewColumn=new D.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeActiveTextEditor=new D.Emitter({onListenerError:F.onUnexpectedExternalError}),this._onDidChangeVisibleTextEditors=new D.Emitter({onListenerError:F.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=I.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(I){const u=this._extHostDocumentsAndEditors.allEditors();return I?u:u.map(p=>p.value)}async showTextDocument(I,u,p){let E;typeof u=="number"?E={position:g.ViewColumn.from(u),preserveFocus:p}:typeof u=="object"?E={position:g.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?g.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:E={preserveFocus:!1};const n=await this._proxy.$tryShowTextDocument(I.uri,E),o=n&&this._extHostDocumentsAndEditors.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,u){return new T.TextEditorDecorationType(this._proxy,I,u).value}$acceptEditorPropertiesChanged(I,u){const p=this._extHostDocumentsAndEditors.getEditor(I);if(!p)throw new Error("unknown text editor");if(u.options&&p._acceptOptions(u.options),u.selections){const E=u.selections.selections.map(g.Selection.to);p._acceptSelections(E)}if(u.visibleRanges){const E=S.coalesce(u.visibleRanges.map(g.Range.to));p._acceptVisibleRanges(E)}if(u.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...u.options,lineNumbers:g.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const E=m.TextEditorSelectionChangeKind.fromValue(u.selections.source),n=u.selections.selections.map(g.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:n,kind:E})}if(u.visibleRanges){const E=S.coalesce(u.visibleRanges.map(g.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:E})}}$acceptEditorPositionData(I){for(const u in I){const p=this._extHostDocumentsAndEditors.getEditor(u);if(!p)throw new Error("Unknown text editor");const E=g.ViewColumn.to(I[u]);p.value.viewColumn!==E&&(p._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:E}))}}getDiffInformation(I){return Promise.resolve(this._proxy.$getDiffInformation(I))}}e.ExtHostEditors=w}),define(Pe[269],Te([1,0,2,4,3,6,7,8,22,16]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class A{constructor(p,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(D.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this._providers.get(n.source)&&m.ExtensionIdentifier.equals(o,this._providers.get(n.source)?.extension)){const t=n.uri===void 0?void 0:S.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(I(t))?.get(n.handle)}else return;return n}})}async $getTimeline(p,E,n,o){return this._providers.get(p)?.provider.provideTimeline(S.URI.revive(E),n,o)}registerTimelineProvider(p,E,n,o){const t=new R.DisposableStore,r=this.convertTimelineItem(E.id,o,t).bind(this);let a;E.onDidChange&&(a=E.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:E.id}),this));const c=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:p,onDidChange:void 0,async provideTimeline(d,i,s){i?.resetCache&&(t.clear(),c.get(E.id)?.clear());const l=await E.provideTimeline(d,i,s);if(l==null)return;const h=r(d,i);return{...l,source:E.id,items:l.items.map(h)}},dispose(){for(const d of c.values())d.get(E.id)?.clear();a?.dispose(),t.dispose()}},n)}convertTimelineItem(p,E,n){return(o,t)=>{let r;if(t?.cacheResults){let a=this._itemsBySourceAndUriMap.get(p);a===void 0&&(a=new Map,this._itemsBySourceAndUriMap.set(p,a));const c=I(o);r=a.get(c),r===void 0&&(r=new Map,a.set(c,r))}return a=>{const{iconPath:c,...d}=a,i=`${p}|${a.id??a.timestamp}`;r?.set(i,a);let s,l,h;a.iconPath&&(c instanceof T.ThemeIcon?h={id:c.id,color:c.color}:S.URI.isUri(c)?(s=c,l=c):{light:s,dark:l}=c);let b;return T.MarkdownString.isMarkdownString(d.tooltip)?b=g.MarkdownString.from(d.tooltip):(0,w.isString)(d.tooltip)?b=d.tooltip:T.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=g.MarkdownString.from(d.detail)):(0,w.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=d.detail),{...d,id:d.id??void 0,handle:i,source:p,command:a.command?E.toInternal(a.command,n):void 0,icon:s,iconDark:l,themeIcon:h,tooltip:b,accessibilityInformation:a.accessibilityInformation}}}}registerTimelineProviderCore(p,E){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,{provider:p,extension:E}),(0,R.toDisposable)(()=>{for(const o of this._itemsBySourceAndUriMap.values())o.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=A;function I(u){return u?.toString()}}),define(Pe[87],Te([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class p extends m.DisposableTunnel{}var E;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function r(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==m.TunnelPrivacyId.ConstantPrivate&&a.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=r})(E||(e.TunnelDtoConverter=E={})),e.IExtHostTunnelService=(0,T.createDecorator)("IExtHostTunnelService");let n=class extends D.Disposable{constructor(t,r,a){super(),this.logService=a,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new F.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=t.getProxy(w.MainContext.MainThreadTunnelService)}async openTunnel(t,r){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const a=await this._proxy.$openTunnel(r,t.displayName);if(a){const c=new p(a.remoteAddress,a.localAddress,()=>this._proxy.$closeTunnel(a.remoteAddress));return this._register(c),c}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(t,r){const a=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(a,{selector:t,provider:r}),this._proxy.$registerPortsAttributesProvider(t,a),new u.Disposable(()=>{this._portAttributesProviders.delete(a),this._proxy.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,r,a,c,d){const i=[];for(const l of t){const h=this._portAttributesProviders.get(l);if(!h)return[];i.push(...await Promise.all(r.map(async b=>{let f;try{f=await h.provider.providePortAttributes({port:b,pid:a,commandLine:c},d)}catch{f=await h.provider.providePortAttributes(b,a,c,d)}return{providedAttributes:f,port:b}})))}const s=i.filter(l=>!!l.providedAttributes);return s.length>0?s.map(l=>({autoForwardAction:l.providedAttributes.autoForwardAction,port:l.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,r){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(c,d)=>await t.provideTunnel(c,d,new S.CancellationTokenSource().token)??void 0;const a=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this._proxy.$setTunnelProvider(a),Promise.resolve((0,D.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,r){if(t){t.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this._showCandidatePort=t.showCandidatePort,this._proxy.$setCandidateFilter());const a=t.tunnelFactory??(r?this.makeManagedTunnelFactory(r):void 0);if(a){this._forwardPortProvider=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const d=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this._proxy.$setTunnelProvider(d)}}else this._forwardPortProvider=void 0;return(0,D.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(t){}async $closeTunnel(t,r){if(this._extensionTunnels.has(t.host)){const a=this._extensionTunnels.get(t.host);a.has(t.port)&&(r&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(t,r){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this._forwardPortProvider(t,r);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(t.remoteAddress.host)||this._extensionTunnels.set(t.remoteAddress.host,new Map);const d=this._register(c.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(c.remoteAddress))));return this._extensionTunnels.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:d}),E.fromApiTunnel(c)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const r=await Promise.all(t.map(c=>this._showCandidatePort(c.host,c.port,c.detail??""))),a=t.filter((c,d)=>r[d]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.ExtHostTunnelService=n,e.ExtHostTunnelService=n=je([Ve(0,I.IExtHostRpcService),Ve(1,A.IExtHostInitDataService),Ve(2,g.ILogService)],n)}),define(Pe[270],Te([1,0,6,13,2,3]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{static{this.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}constructor(m){this._openers=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(m,w,A,I){if(this._openers.has(w))throw new Error(`Opener with id '${w}' already registered`);const u=I.schemes.find(p=>!T.supportedSchemes.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(w,A),this._proxy.$registerUriOpener(w,I.schemes,m,I.label),(0,S.toDisposable)(()=>{this._openers.delete(w),this._proxy.$unregisterUriOpener(w)})}async $canOpenUri(m,w,A){const I=this._openers.get(m);if(!I)throw new Error(`Unknown opener with id: ${m}`);const u=D.URI.revive(w);return I.canOpenExternalUri(u,A)}async $openUri(m,w,A){const I=this._openers.get(m);if(!I)throw new Error(`Unknown opener id: '${m}'`);return I.openExternalUri(D.URI.revive(w.resolvedUri),{sourceUri:D.URI.revive(w.sourceUri)},A)}}e.ExtHostUriOpeners=T}),define(Pe[271],Te([1,0,3,2,6,11,22]),function(ge,e,S,F,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class g{static{this.HandlePool=0}constructor(w){this.handles=new T.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=w.getProxy(S.MainContext.MainThreadUrls)}registerUriHandler(w,A){const I=w.identifier;if(this.handles.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const u=g.HandlePool++;return this.handles.add(I),this.handlers.set(u,A),this._proxy.$registerUriHandler(u,I,w.displayName||w.name),(0,D.toDisposable)(()=>{this.handles.delete(I),this.handlers.delete(u),this._proxy.$unregisterUriHandler(u)})}$handleExternalUri(w,A){const I=this.handlers.get(w);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(A))}catch(u){(0,R.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(w){return F.URI.revive(await this._proxy.$createAppUri(w))}}e.ExtHostUrls=g}),define(Pe[65],Te([1,0,5,6,13,26,2,182,204,78,3]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class I{#e;#t;#i;#o;#r;#n;#a;#s;#c;#l;#u;#h;constructor(c,d,i,s,l,h,b){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new S.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new S.Emitter,this._onDidDispose=this.#d.event,this.#e=c,this.#t=d,this.#s=i,this.#o=s,this.#r=l,this.#n=h,this.#u=u(h),this.#h=p(h),this.#i=b}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#l=!0,(0,w.asWebviewUri)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===D.Schemas.https||c.scheme===D.Schemas.http){let d=c.toString();return d.endsWith("/")||(d+="/"),d+" "+w.webviewGenericCspSource}return w.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(c){this.assertNotDisposed(),this.#a!==c&&(this.#a=c,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(c)))}get options(){return this.assertNotDisposed(),this.#s}set options(c){this.assertNotDisposed(),R.equals(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const d=(0,m.serializeWebviewMessage)(c,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(c){if(!this.#h)return c;const d=this.#n.extensionLocation?.scheme===D.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===D.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,l,h,b,f,C)=>{const O=T.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),v=(0,w.asWebviewUri)(O,{isRemote:d,authority:i}).toString();return`${l}${v}${C}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,l,h,b,f,C)=>{const O=T.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),v=(0,w.asWebviewUri)(O,{isRemote:d,authority:i}).toString();return`${l}${v}${C}`})}}e.ExtHostWebview=I;function u(a){try{const c=(0,g.normalizeVersion)((0,g.parseVersion)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function p(a){try{const c=(0,g.normalizeVersion)((0,g.parseVersion)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class E extends F.Disposable{constructor(c,d,i,s,l){super(),this.remoteInfo=d,this.workspace=i,this._logService=s,this._deprecationService=l,this._webviews=new Map,this._webviewProxy=c.getProxy(A.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const c of this._webviews.values())c.dispose();this._webviews.clear()}$onMessage(c,d,i){const s=this.getWebview(c);if(s){const{message:l}=(0,m.deserializeWebviewMessage)(d,i.value);s._onMessageEmitter.fire(l)}}$onMissingCsp(c,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,d,i){const s=new I(c,this._webviewProxy,t(d),this.remoteInfo,this.workspace,i,this._deprecationService);this._webviews.set(c,s);const l=s._onDidDispose(()=>{l.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this._webviews.delete(c)}getWebview(c){return this._webviews.get(c)}}e.ExtHostWebviews=E;function n(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=n;function o(a,c,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||r(a,c)}}e.serializeWebviewOptions=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>T.URI.from(c))}}function r(a,c){return[...(c?.getWorkspaceFolders()||[]).map(d=>d.uri),a.extensionLocation]}}),define(Pe[272],Te([1,0,20,98,6,13,25,2,8,65,75,3,7]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(s,l){this.document=s,this._storagePath=l,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,l){await this.getEdit(s).undo(),l||this.disposeBackup()}async redo(s,l){await this.getEdit(s).redo(),l||this.disposeBackup()}disposeEdits(s){for(const l of s)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=d(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const l=this._edits.get(s,0);if(!l)throw new Error("No edit found");return l}}class E{constructor(){this._documents=new Map}get(s,l){return this._documents.get(this.key(s,l))}add(s,l,h){const b=this.key(s,l.uri);if(this._documents.has(b))throw new Error(`Document already exists for viewType:${s} resource:${l.uri}`);const f=new p(l,h);return this._documents.set(b,f),f}delete(s,l){const h=this.key(s,l.uri);this._documents.delete(h)}key(s,l){return`${s}@@@${l}`}}var n;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this._providers=new Map}addTextProvider(s,l,h){return this.add(0,s,l,h)}addCustomProvider(s,l,h){return this.add(1,s,l,h)}get(s){return this._providers.get(s)}add(s,l,h,b){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:s,extension:h,provider:b}),new u.Disposable(()=>this._providers.delete(l))}}class t{constructor(s,l,h,b,f){this._extHostDocuments=l,this._extensionStoragePaths=h,this._extHostWebview=b,this._extHostWebviewPanels=f,this._editorProviders=new o,this._documents=new E,this._proxy=s.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,l,h,b){const f=new D.DisposableStore;return a(h)?(f.add(this._editorProviders.addTextProvider(l,s,h)),this._proxy.$registerTextEditorProvider((0,w.toExtensionData)(s),l,b.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,w.shouldSerializeBuffersForPostMessage)(s))):(f.add(this._editorProviders.addCustomProvider(l,s,h)),r(h)&&f.add(h.onDidChangeCustomDocument(C=>{const O=this.getCustomDocumentEntry(l,C.document.uri);if(c(C)){const v=O.addEdit(C);this._proxy.$onDidEdit(C.document.uri,l,v,C.label)}else this._proxy.$onContentChange(C.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,w.toExtensionData)(s),l,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,w.shouldSerializeBuffersForPostMessage)(s))),u.Disposable.from(f,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(s,l,h,b,f){const C=this._editorProviders.get(l);if(!C)throw new Error(`No provider found for '${l}'`);if(C.type!==1)throw new Error(`Invalid provide type for '${l}'`);const O=g.URI.revive(s),v=await C.provider.openCustomDocument(O,{backupId:h,untitledDocumentData:b?.buffer},f);let _;return r(C.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(C.extension)??this._extensionStoragePaths.globalValue(C.extension)),this._documents.add(l,v,_),{editable:r(C.provider)}}async $disposeCustomDocument(s,l){const h=this._editorProviders.get(l);if(!h)throw new Error(`No provider found for '${l}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${l}'`);const b=g.URI.revive(s),{document:f}=this.getCustomDocumentEntry(l,b);this._documents.delete(l,f),f.dispose()}async $resolveCustomEditor(s,l,h,b,f,C){const O=this._editorProviders.get(h);if(!O)throw new Error(`No provider found for '${h}'`);const v=m.ViewColumn.to(f),_=this._extHostWebview.createNewWebview(l,b.contentOptions,O.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(l,h,b.title,v,b.options,_,b.active),M=g.URI.revive(s);switch(O.type){case 1:{const{document:V}=this.getCustomDocumentEntry(h,M);return O.provider.resolveCustomEditor(V,y,C)}case 0:{const V=this._extHostDocuments.getDocument(M);return O.provider.resolveCustomTextEditor(V,y,C)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,l,h){this.getCustomDocumentEntry(l,s).disposeEdits(h)}async $onMoveCustomEditor(s,l,h){const b=this._editorProviders.get(h);if(!b)throw new Error(`No provider found for '${h}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const f=this._extHostWebviewPanels.getWebviewPanel(s);if(!f)throw new Error("No webview found");const C=g.URI.revive(l),O=this._extHostDocuments.getDocument(C);await b.provider.moveCustomTextEditor(O,f,S.CancellationToken.None)}async $undo(s,l,h,b){return this.getCustomDocumentEntry(l,s).undo(h,b)}async $redo(s,l,h,b){return this.getCustomDocumentEntry(l,s).redo(h,b)}async $revert(s,l,h){const b=this.getCustomDocumentEntry(l,s);await this.getCustomEditorProvider(l).revertCustomDocument(b.document,h),b.disposeBackup()}async $onSave(s,l,h){const b=this.getCustomDocumentEntry(l,s);await this.getCustomEditorProvider(l).saveCustomDocument(b.document,h),b.disposeBackup()}async $onSaveAs(s,l,h,b){const f=this.getCustomDocumentEntry(l,s);return this.getCustomEditorProvider(l).saveCustomDocumentAs(f.document,g.URI.revive(h),b)}async $backup(s,l,h){const b=this.getCustomDocumentEntry(l,s),C=await this.getCustomEditorProvider(l).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},h);return b.updateBackup(C),C.id}getCustomDocumentEntry(s,l){const h=this._documents.get(s,g.URI.revive(l));if(!h)throw new Error("No custom document found");return h}getCustomEditorProvider(s){const h=this._editorProviders.get(s)?.provider;if(!h||!r(h))throw new Error("Custom document is not editable");return h}}e.ExtHostCustomEditors=t;function r(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function d(i){const s=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,F.hash)(s)+""}}),define(Pe[273],Te([1,0,5,6,2,33,8,65,3,7]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class A extends F.Disposable{#e;#t;#i;#o;#r;#n;#a;#s;#c;#l;#u;#h;#d;constructor(E,n,o,t){super(),this.#s=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new S.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new S.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=E,this.#t=n,this.#o=o,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#l=t.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#o}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#n}set title(E){this.assertNotDisposed(),this.#n!==E&&(this.#n=E,this.#t.$setTitle(this.#e,E))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(E){this.assertNotDisposed(),this.#a!==E&&(this.#a=E,this.#t.$setIconPath(this.#e,D.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return this.#r}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(E){this.#u||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(this.#l=E.active,this.#c=E.visible,this.#s=E.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(E,n){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof E>"u"?void 0:T.ViewColumn.from(E),preserveFocus:!!n})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class I extends F.Disposable{static newHandle(){return(0,R.generateUuid)()}constructor(E,n,o){super(),this.webviews=n,this.workspace=o,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=E.getProxy(m.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(E=>E.dispose()),this._webviewPanels.clear()}createWebviewPanel(E,n,o,t,r={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:T.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},d=(0,g.shouldSerializeBuffersForPostMessage)(E),i=I.newHandle();this._proxy.$createWebviewPanel((0,g.toExtensionData)(E),i,n,{title:o,panelOptions:u(r),webviewOptions:(0,g.serializeWebviewOptions)(E,this.workspace,r),serializeBuffersForPostMessage:d},c);const s=this.webviews.createNewWebview(i,r,E);return this.createNewWebviewPanel(i,n,o,a,r,s,!0)}$onDidChangeWebviewPanelViewStates(E){const n=Object.keys(E);n.sort((o,t)=>{const r=E[o],a=E[t];return r.active?1:a.active?-1:+r.visible-+a.visible});for(const o of n){const t=this.getWebviewPanel(o);if(!t)continue;const r=E[o];t._updateViewState({active:r.active,visible:r.visible,viewColumn:T.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this._webviewPanels.delete(E),this.webviews.deleteWebview(E)}registerWebviewPanelSerializer(E,n,o){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:o,extension:E}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,g.shouldSerializeBuffersForPostMessage)(E)}),new w.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(E,n,o,t){const r=this._serializers.get(n);if(!r)throw new Error(`No serializer found for '${n}'`);const{serializer:a,extension:c}=r,d=this.webviews.createNewWebview(E,o.webviewOptions,c),i=this.createNewWebviewPanel(E,n,o.title,t,o.panelOptions,d,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(E,n,o,t,r,a,c){const d=new A(E,this._proxy,a,{viewType:n,title:o,viewColumn:t,panelOptions:r,active:c});return this._webviewPanels.set(E,d),d}getWebviewPanel(E){return this._webviewPanels.get(E)}}e.ExtHostWebviewPanels=I;function u(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[274],Te([1,0,5,6,65,8,3,7]),function(ge,e,S,F,D,R,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends F.Disposable{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(I,u,p,E,n,o){super(),this.#r=!1,this.#l=this._register(new S.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new S.Emitter),this.onDidDispose=this.#u.event,this.#i=p,this.#a=E,this.#e=I,this.#t=u,this.#o=n,this.#n=o}dispose(){this.#r||(this.#r=!0,this.#u.fire(),this.#o.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(I){this.assertNotDisposed(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.assertNotDisposed(),this.#s}set description(I){this.assertNotDisposed(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#r||(this.#n=I,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(I){this.assertNotDisposed(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.assertNotDisposed(),this.#t.$show(this.#e,!!I)}assertNotDisposed(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(I,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(I,u,p,E){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:p,extension:I}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(I),u,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(I)}),new g.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(I,u,p,E,n){const o=this._viewProviders.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:t,extension:r}=o,a=this._extHostWebview.createNewWebview(I,{},r),c=new m(I,this._proxy,u,p,a,!0);this._webviewViews.set(I,c),await t.resolveWebviewView(c,{state:E},n)}async $onDidChangeWebviewViewVisibility(I,u){this.getWebviewView(I)._setVisible(u)}async $disposeWebviewView(I){const u=this.getWebviewView(I);this._webviewViews.delete(I),u.dispose(),this._extHostWebview.deleteWebview(I)}getWebviewView(I){const u=this._webviewViews.get(I);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=w}),define(Pe[111],Te([1,0,5,3,2,13,12,4,17,23]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{A=this}static{this.InitialState={focused:!0,active:!0}}getState(p){const E=this._state;return{get focused(){return E.focused},get active(){return(0,w.checkProposedApiEnabled)(p,"windowActivity"),E.active}}}constructor(p){this._onDidChangeWindowState=new S.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=A.InitialState,this._proxy=p.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:E,isActive:n})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,E){E!==this._state[p]&&(this._state={...this._state,[p]:E},this._onDidChangeWindowState.fire(this._state))}openUri(p,E){let n;if(typeof p=="string"){n=p;try{p=D.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,T.isFalsyOrWhitespace)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this._proxy.$openUri(p,n,E)}async asExternalUri(p,E){if((0,T.isFalsyOrWhitespace)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this._proxy.$asExternalUri(p,E);return D.URI.from(n)}};e.ExtHostWindow=I,e.ExtHostWindow=I=A=je([Ve(0,m.IExtHostRpcService)],I),e.IExtHostWindow=(0,g.createDecorator)("IExtHostWindow")}),define(Pe[275],Te([1,0,241,27,17]),function(ge,e,S,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let R=class extends S.AbstractExtHostConsoleForwarder{constructor(g,m){super(g,m)}_nativeConsoleLogMessage(g,m,w){m.apply(console,w)}};e.ExtHostConsoleForwarder=R,e.ExtHostConsoleForwarder=R=je([Ve(0,D.IExtHostRpcService),Ve(1,F.IExtHostInitDataService)],R)}),define(Pe[276],Te([1,0,14,24,20,11,5,6,139,230,49]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(y,M){try{return JSON.stringify(y,M)}catch{return"null"}}const p="$$ref$$",E={[p]:-1};class n{constructor(M,V){this.jsonString=M,this.referencedBuffers=V}}function o(y,M=null,V=!1){const $=[];return{jsonString:(V?u:JSON.stringify)(y,(U,k)=>{if(typeof k>"u")return E;if(typeof k=="object"){if(k instanceof F.VSBuffer){const P=$.push(k)-1;return{[p]:P}}if(M)return M(U,k)}return k}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=o;function t(y,M,V){return JSON.parse(y,($,L)=>{if(L){const U=L[p];if(typeof U=="number")return M[U];if(V&&L.$mid===1)return V.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=t;function r(y,M){return JSON.stringify(y,M)}function a(y){return y?(M,V)=>V&&V.$mid===1?y.transformOutgoing(V):V:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var d;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const i=()=>{},s=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class h extends g.Disposable{static{I=s}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(M,V=null,$=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=M,this._logger=V,this._uriTransformer=$,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,U=A.ProxyIdentifier.count;L<U;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new S.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(M=>{const V=this._pendingRPCReplies[M];delete this._pendingRPCReplies[M],V.resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(M){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(M){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(M){this._responsiveState!==M&&(this._responsiveState=M,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(M){return this._uriTransformer?(0,m.transformIncomingURIs)(M,this._uriTransformer):M}getProxy(M){const{nid:V,sid:$}=M;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,$)),this._proxies[V]}_createProxy(M,V){const $={get:(L,U)=>(typeof U=="string"&&!L[U]&&U.charCodeAt(0)===36&&(L[U]=(...k)=>this._remoteCall(M,U,k)),U===l?V:L[U])};return new Proxy(Object.create(null),$)}set(M,V){return this._locals[M.nid]=V,V}assertRegistered(M){for(let V=0,$=M.length;V<$;V++){const L=M[V];if(!this._locals[L.nid])throw new Error(`Missing proxy instance ${L.sid}`)}}_receiveOneMessage(M){if(this._isDisposed)return;const V=M.byteLength,$=f.read(M,0),L=$.readUInt8(),U=$.readUInt32();switch(L){case 1:case 2:{let{rpcId:k,method:P,args:Q}=O.deserializeRequestJSONArgs($);this._uriTransformer&&(Q=(0,m.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(V,U,k,P,Q,L===2);break}case 3:case 4:{let{rpcId:k,method:P,args:Q}=O.deserializeRequestMixedArgs($);this._uriTransformer&&(Q=(0,m.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(V,U,k,P,Q,L===4);break}case 5:{this._logger?.logIncoming(V,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(V,U);break}case 7:{this._receiveReply(V,U,void 0);break}case 9:{let k=O.deserializeReplyOKJSON($);this._uriTransformer&&(k=(0,m.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReply(V,U,k);break}case 10:{const k=O.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(V,U,k);break}case 8:{const k=O.deserializeReplyOKVSBuffer($);this._receiveReply(V,U,k);break}case 11:{let k=O.deserializeReplyErrError($);this._uriTransformer&&(k=(0,m.transformIncomingURIs)(k,this._uriTransformer)),this._receiveReplyErr(V,U,k);break}case 12:{this._receiveReplyErr(V,U,void 0);break}default:console.error("received unexpected message"),console.error(M)}}_receiveRequest(M,V,$,L,U,k){this._logger?.logIncoming(M,V,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)($)}.${L}(`,U);const P=String(V);let Q,ae;if(k){const Ee=new D.CancellationTokenSource;U.push(Ee.token),Q=this._invokeHandler($,L,U),ae=()=>Ee.cancel()}else Q=this._invokeHandler($,L,U),ae=i;this._cancelInvokedHandlers[P]=ae;const me=O.serializeAcknowledged(V);this._logger?.logOutgoing(me.byteLength,V,1,"ack"),this._protocol.send(me),Q.then(Ee=>{delete this._cancelInvokedHandlers[P];const Ce=O.serializeReplyOK(V,Ee,this._uriReplacer);this._logger?.logOutgoing(Ce.byteLength,V,1,"reply:",Ee),this._protocol.send(Ce)},Ee=>{delete this._cancelInvokedHandlers[P];const Ce=O.serializeReplyErr(V,Ee);this._logger?.logOutgoing(Ce.byteLength,V,1,"replyErr:",Ee),this._protocol.send(Ce)})}_receiveCancel(M,V){this._logger?.logIncoming(M,V,1,"receiveCancel");const $=String(V);this._cancelInvokedHandlers[$]?.()}_receiveReply(M,V,$){this._logger?.logIncoming(M,V,0,"receiveReply:",$);const L=String(V);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const U=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],U.resolveOk($)}_receiveReplyErr(M,V,$){this._logger?.logIncoming(M,V,0,"receiveReplyErr:",$);const L=String(V);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const U=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let k;$&&($.$isError?(k=new Error,k.name=$.name,k.message=$.message,k.stack=$.stack):k=$),U.resolveErr(k)}_invokeHandler(M,V,$){try{return Promise.resolve(this._doInvokeHandler(M,V,$))}catch(L){return Promise.reject(L)}}_doInvokeHandler(M,V,$){const L=this._locals[M];if(!L)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(M));const U=L[V];if(typeof U!="function")throw new Error("Unknown method "+V+" on actor "+(0,A.getStringIdentifierForProxy)(M));return U.apply(L,$)}_remoteCall(M,V,$){if(this._isDisposed)return new w.CanceledLazyPromise;let L=null;if($.length>0&&D.CancellationToken.isCancellationToken($[$.length-1])&&(L=$.pop()),L&&L.isCancellationRequested)return Promise.reject(R.canceled());const U=O.serializeRequestArguments($,this._uriReplacer),k=++this._lastMessageId,P=String(k),Q=new w.LazyPromise,ae=new g.DisposableStore;L&&ae.add(L.onCancellationRequested(()=>{const Ee=O.serializeCancel(k);this._logger?.logOutgoing(Ee.byteLength,k,0,"cancel"),this._protocol.send(O.serializeCancel(k))})),this._pendingRPCReplies[P]=new b(Q,ae),this._onWillSendRequest(k);const me=O.serializeRequest(k,M,V,U,!!L);return this._logger?.logOutgoing(me.byteLength,k,0,`request: ${(0,A.getStringIdentifierForProxy)(M)}.${V}(`,$),this._protocol.send(me),Q}}e.RPCProtocol=h;class b{constructor(M,V){this._promise=M,this._disposable=V}resolveOk(M){this._promise.resolveOk(M),this._disposable.dispose()}resolveErr(M){this._promise.resolveErr(M),this._disposable.dispose()}}class f{static alloc(M,V,$){const L=new f(F.VSBuffer.alloc($+1+4),0);return L.writeUInt8(M),L.writeUInt32(V),L}static read(M,V){return new f(M,V)}get buffer(){return this._buff}constructor(M,V){this._buff=M,this._offset=V}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(M){this._buff.writeUInt8(M,this._offset),this._offset+=1}readUInt8(){const M=this._buff.readUInt8(this._offset);return this._offset+=1,M}writeUInt32(M){this._buff.writeUInt32BE(M,this._offset),this._offset+=4}readUInt32(){const M=this._buff.readUInt32BE(this._offset);return this._offset+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this._buff.writeUInt8(M.byteLength,this._offset),this._offset+=1,this._buff.set(M,this._offset),this._offset+=M.byteLength}readShortString(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,$}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readLongString(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,$}writeBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readVSBuffer(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+M);return this._offset+=M,V}static sizeMixedArray(M){let V=0;V+=1;for(let $=0,L=M.length;$<L;$++){const U=M[$];switch(V+=1,U.type){case 1:V+=this.sizeLongString(U.value);break;case 2:V+=this.sizeVSBuffer(U.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(U.value);for(let k=0;k<U.buffers.length;++k)V+=this.sizeVSBuffer(U.buffers[k]);break;case 4:break}}return V}writeMixedArray(M){this._buff.writeUInt8(M.length,this._offset),this._offset+=1;for(let V=0,$=M.length;V<$;V++){const L=M[V];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let U=0;U<L.buffers.length;++U)this.writeBuffer(L.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(M);for(let $=0;$<M;$++)switch(this.readUInt8()){case 1:V[$]=this.readLongString();break;case 2:V[$]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),k=this.readLongString(),P=[];for(let Q=0;Q<U;++Q)P.push(this.readVSBuffer());V[$]=new A.SerializableObjectWithBuffers(t(k,P,null));break}case 4:V[$]=void 0;break}return V}}var C;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(C||(C={}));class O{static _useMixedArgSerialization(M){for(let V=0,$=M.length;V<$;V++)if(M[V]instanceof F.VSBuffer||M[V]instanceof A.SerializableObjectWithBuffers||typeof M[V]>"u")return!0;return!1}static serializeRequestArguments(M,V){if(this._useMixedArgSerialization(M)){const $=[];for(let L=0,U=M.length;L<U;L++){const k=M[L];if(k instanceof F.VSBuffer)$[L]={type:2,value:k};else if(typeof k>"u")$[L]={type:4};else if(k instanceof A.SerializableObjectWithBuffers){const{jsonString:P,referencedBuffers:Q}=o(k.value,V);$[L]={type:3,value:F.VSBuffer.fromString(P),buffers:Q}}else $[L]={type:1,value:F.VSBuffer.fromString(r(k,V))}}return{type:1,args:$}}return{type:0,args:r(M,V)}}static serializeRequest(M,V,$,L,U){switch(L.type){case 0:return this._requestJSONArgs(M,V,$,L.args,U);case 1:return this._requestMixedArgs(M,V,$,L.args,U)}}static _requestJSONArgs(M,V,$,L,U){const k=F.VSBuffer.fromString($),P=F.VSBuffer.fromString(L);let Q=0;Q+=f.sizeUInt8(),Q+=f.sizeShortString(k),Q+=f.sizeLongString(P);const ae=f.alloc(U?2:1,M,Q);return ae.writeUInt8(V),ae.writeShortString(k),ae.writeLongString(P),ae.buffer}static deserializeRequestJSONArgs(M){const V=M.readUInt8(),$=M.readShortString(),L=M.readLongString();return{rpcId:V,method:$,args:JSON.parse(L)}}static _requestMixedArgs(M,V,$,L,U){const k=F.VSBuffer.fromString($);let P=0;P+=f.sizeUInt8(),P+=f.sizeShortString(k),P+=f.sizeMixedArray(L);const Q=f.alloc(U?4:3,M,P);return Q.writeUInt8(V),Q.writeShortString(k),Q.writeMixedArray(L),Q.buffer}static deserializeRequestMixedArgs(M){const V=M.readUInt8(),$=M.readShortString(),L=M.readMixedArray(),U=new Array(L.length);for(let k=0,P=L.length;k<P;k++){const Q=L[k];typeof Q=="string"?U[k]=JSON.parse(Q):U[k]=Q}return{rpcId:V,method:$,args:U}}static serializeAcknowledged(M){return f.alloc(5,M,0).buffer}static serializeCancel(M){return f.alloc(6,M,0).buffer}static serializeReplyOK(M,V,$){if(typeof V>"u")return this._serializeReplyOKEmpty(M);if(V instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(M,V);if(V instanceof A.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:U}=o(V.value,$,!0);return this._serializeReplyOKJSONWithBuffers(M,L,U)}else return this._serializeReplyOKJSON(M,u(V,$))}static _serializeReplyOKEmpty(M){return f.alloc(7,M,0).buffer}static _serializeReplyOKVSBuffer(M,V){let $=0;$+=f.sizeVSBuffer(V);const L=f.alloc(8,M,$);return L.writeVSBuffer(V),L.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static _serializeReplyOKJSON(M,V){const $=F.VSBuffer.fromString(V);let L=0;L+=f.sizeLongString($);const U=f.alloc(9,M,L);return U.writeLongString($),U.buffer}static _serializeReplyOKJSONWithBuffers(M,V,$){const L=F.VSBuffer.fromString(V);let U=0;U+=f.sizeUInt32,U+=f.sizeLongString(L);for(const P of $)U+=f.sizeVSBuffer(P);const k=f.alloc(10,M,U);k.writeUInt32($.length),k.writeLongString(L);for(const P of $)k.writeBuffer(P);return k.buffer}static deserializeReplyOKJSON(M){const V=M.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(M,V){const $=M.readUInt32(),L=M.readLongString(),U=[];for(let k=0;k<$;++k)U.push(M.readVSBuffer());return new A.SerializableObjectWithBuffers(t(L,U,V))}static serializeReplyErr(M,V){const $=V?u(R.transformErrorForSerialization(V),null):void 0;if(typeof $!="string")return this._serializeReplyErrEmpty(M);const L=F.VSBuffer.fromString($);let U=0;U+=f.sizeLongString(L);const k=f.alloc(11,M,U);return k.writeLongString(L),k.buffer}static deserializeReplyErrError(M){const V=M.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(M){return f.alloc(12,M,0).buffer}}var v;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var _;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(_||(_={}))}),define(Pe[277],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const S=function(R){const T=g=>{globalThis.removeEventListener("message",T);const m=g.data;Object.defineProperties(globalThis,{postMessage:{value(w,A){m.postMessage(w,A)}},onmessage:{get(){return m.onmessage},set(w){m.onmessage=w}}}),m.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(R)};globalThis.addEventListener("message",T)}.toString();class F extends EventTarget{constructor(R,T,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${S})('${T}'))`,w=new Blob([m],{type:"application/javascript"}),A=URL.createObjectURL(w),I=new MessageChannel,u=A,p={type:"_newWorker",id:u,port:I.port2,url:A,options:g};R(p,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{R({type:"_terminateWorker",id:u}),URL.revokeObjectURL(A),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(E){I.port1.onmessage=E}},onmessageerror:{get(){return I.port1.onmessageerror},set(E){I.port1.onmessageerror=E}}}),I.port1.addEventListener("messageerror",E=>{const n=new MessageEvent("messageerror",{data:E.data});this.dispatchEvent(n)}),I.port1.addEventListener("message",E=>{const n=new MessageEvent("message",{data:E.data});this.dispatchEvent(n)}),I.port1.start()}}e.NestedWorker=F}),define(Pe[278],Te([1,0,5,30,35,4]),function(ge,e,S,F,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var T;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.channels=new Map,this._onDidRegisterChannel=new S.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new S.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(A=>w.push(A)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}F.Registry.add(e.Extensions.OutputChannels,new g),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Pe[112],Te([1,0,3,4,17,22,15,278,63,27,43,136,24,16,42,5,6]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class t extends T.AbstractMessageLogger{get disposed(){return this._disposed}constructor(d,i,s,l,h){super(),this.id=d,this.name=i,this.logger=s,this.proxy=l,this.extension=h,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(s.getLevel()),this._register(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Clear,d)}replace(d){const i=this.offset;this.info(d),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Replace,i),this.visible&&this.logger.flush()}show(d,i){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:i))}hide(){this.proxy.$close(this.id)}log(d,i){this.offset+=u.VSBuffer.fromString(i).byteLength,(0,T.log)(this.logger,d,i),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class r extends t{appendLine(d){this.append(d)}}let a=class{constructor(d,i,s,l,h,b){this.initData=i,this.extHostFileSystem=s,this.extHostFileSystemInfo=l,this.loggerService=h,this.logService=b,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(S.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(i.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[i,s]of this.channels)s.visible=i===this.visibleChannelId}createOutputChannel(d,i,s){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const l=typeof i=="object"&&i.log,h=(0,p.isString)(i)?i:void 0;if((0,p.isString)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const f=this.initData.environment.extensionLogLevel?.find(([O])=>R.ExtensionIdentifier.equals(s.identifier,O))?.[1];f&&(b=(0,T.parseLogLevel)(f));const C=l?this.doCreateLogOutputChannel(d,b,s):this.doCreateOutputChannel(d,h,s);return C.then(O=>{this.channels.set(O.id,O),O.visible=O.id===this.visibleChannelId}),l?this.createExtHostLogOutputChannel(d,b??this.logService.getLevel(),C):this.createExtHostOutputChannel(d,C)}async doCreateOutputChannel(d,i,s){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const l=await this.outputDirectoryPromise,h=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.loggerService.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.proxy.$register(d,h,i,s.identifier.value);return new t(f,d,b,this.proxy,s)}async doCreateLogOutputChannel(d,i,s){const l=await this.createExtensionLogDirectory(s),h=d.replace(/[\\/:\*\?"<>\|]/g,""),b=this.extHostFileSystemInfo.extUri.joinPath(l,`${h}.log`),f=`${s.identifier.value}.${h}`,C=this.loggerService.createLogger(b,{id:f,name:d,logLevel:i,extensionId:s.identifier.value});return new r(f,d,C,this.proxy,s)}createExtensionLogDirectory(d){let i=this.extensionLogDirectoryPromise.get(d.identifier.value);if(!i){const s=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,d.identifier.value);this.extensionLogDirectoryPromise.set(d.identifier.value,i=(async()=>{try{await this.extHostFileSystem.value.createDirectory(s)}catch(l){if((0,E.toFileSystemProviderErrorCode)(l)!==E.FileSystemProviderErrorCode.FileExists)throw l}return s})())}return i}createExtHostOutputChannel(d,i){let s=!1;const l=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return d},append(h){l(),i.then(b=>b.append(h))},appendLine(h){l(),i.then(b=>b.appendLine(h))},clear(){l(),i.then(h=>h.clear())},replace(h){l(),i.then(b=>b.replace(h))},show(h,b){l(),i.then(f=>f.show(h,b))},hide(){l(),i.then(h=>h.hide())},dispose(){s=!0,i.then(h=>h.dispose())}}}createExtHostLogOutputChannel(d,i,s){const l=new o.DisposableStore,h=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},b=l.add(new n.Emitter);function f(C){i=C,b.fire(C)}return s.then(C=>{l.add(C),C.logLevel!==i&&f(C.logLevel),l.add(C.onDidChangeLogLevel(O=>f(O)))}),{...this.createExtHostOutputChannel(d,s),get logLevel(){return i},onDidChangeLogLevel:b.event,trace(C,...O){h(),s.then(v=>v.trace(C,...O))},debug(C,...O){h(),s.then(v=>v.debug(C,...O))},info(C,...O){h(),s.then(v=>v.info(C,...O))},warn(C,...O){h(),s.then(v=>v.warn(C,...O))},error(C,...O){h(),s.then(v=>v.error(C,...O))},dispose(){l.dispose()}}}};e.ExtHostOutputService=a,e.ExtHostOutputService=a=je([Ve(0,D.IExtHostRpcService),Ve(1,w.IExtHostInitDataService),Ve(2,m.IExtHostConsumerFileSystem),Ve(3,A.IExtHostFileSystemInfo),Ve(4,T.ILoggerService),Ve(5,T.ILogService)],a),e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(Pe[113],Te([1,0,4,14]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,S.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(D){let R=1/0;for(let g=0;g<this.maxSampleCount;g++){const m=await D.getRoundTripTime();if(m===void 0)return;R=Math.min(R,m/2),await(0,F.timeout)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(R):T=this.initial.reduce((g,m)=>g+m,0)/this.initial.length,this.lastMeasurement={initial:T,current:R,average:this.average.reduce((g,m)=>g+m,0)/this.average.length,high:(()=>typeof T>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>T*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Te([1,0,170,54,30,47,41,6,5,113,21,26]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchConfigurationWorkbenchContribution=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class u{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new m.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new u;D.Registry.add(e.Extensions.ConfigurationMigration,p);let E=class extends g.Disposable{constructor(t,r){super(),this.configurationService=t,this.workspaceService=r,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.migrateConfigurationsForFolder(c,p.migrations)})),this.migrateConfigurations(p.migrations),this._register(p.onDidRegisterConfigurationMigration(a=>this.migrateConfigurations(a)))}async migrateConfigurations(t){await this.migrateConfigurationsForFolder(void 0,t);for(const r of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(r,t)}async migrateConfigurationsForFolder(t,r){await Promise.all([r.map(a=>this.migrateConfigurationsForFolderAndOverride(a,t?.uri))])}async migrateConfigurationsForFolderAndOverride(t,r){const a=this.configurationService.inspect(t.key,{resource:r}),c=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[d,i]of c){const s=[];for(const h of a.overrideIdentifiers??[]){const b=await this.runMigration(t,{resource:r,overrideIdentifier:h},d);for(const f of b??[]){let C=s.find(([[O,v]])=>O===f[0]&&(0,I.equals)(v.value,f[1].value));C||s.push(C=[f,[]]),C[1].push(h)}}const l=await this.runMigration(t,{resource:r},d,a);for(const h of l??[])s.push([h,[]]);s.length&&await Promise.allSettled(s.map(async([[h,b],f])=>this.configurationService.updateValue(h,b.value,{resource:r,overrideIdentifiers:f},i)))}}async runMigration(t,r,a,c){const d=h=>i(this.configurationService.inspect(h,r)),i=h=>{const b=h[a];return r.overrideIdentifier?b?.override:b?.value},s=c?i(c):d(t.key);if(s===void 0)return;const l=await t.migrateFn(s,d);return Array.isArray(l)?l:[[t.key,l]]}};e.ConfigurationMigrationWorkbenchContribution=E,e.ConfigurationMigrationWorkbenchContribution=E=je([Ve(0,T.IConfigurationService),Ve(1,R.IWorkspaceContextService)],E);let n=class extends g.Disposable{constructor(t){super(),(async()=>{if(!A.isWindows&&(await t.getEnvironment())?.os!==1)return;D.Registry.as(F.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(3,null)},default:[],markdownDescription:(0,S.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(5,null),scope:2}}})})()}};e.DynamicWorkbenchConfigurationWorkbenchContribution=n,e.DynamicWorkbenchConfigurationWorkbenchContribution=n=je([Ve(0,w.IRemoteAgentService)],n)}),define(Pe[280],Te([1,0,34,13,19,25,178,279,54,4,30]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.globMatchesResource=e.priorityToRank=e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.IEditorResolverService=(0,w.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const I=A.Registry.as(m.Extensions.Configuration),u={...g.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(u);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var E;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(E||(e.ResolvedStatus=E={}));function n(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.priorityToRank=n;function o(t,r){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(r.scheme))return!1;const d=typeof t=="string"&&t.indexOf(D.posix.sep)>=0?`${r.scheme}:${r.path}`:(0,R.basename)(r);return S.match(typeof t=="string"?t.toLowerCase():t,d.toLowerCase())}e.globMatchesResource=o}),define(Pe[281],Te([1,0,46,13,19,21,25,2,4,199,47,217,113]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,m.createDecorator)("pathService");let E=p=class{constructor(o,t,r,a){this.localUserHome=o,this.remoteAgentService=t,this.environmentService=r,this.contextService=a,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||R.OS)(),this.resolveUserHome=(async()=>{const c=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=c?.userHome??o})()}hasValidBasename(o,t,r){return typeof t=="string"||typeof t>"u"?this.resolveOS.then(a=>this.doHasValidBasename(o,a,t)):this.doHasValidBasename(o,t,r)}doHasValidBasename(o,t,r){return o.scheme===F.Schemas.file||o.scheme===F.Schemas.vscodeRemote?(0,S.isValidBasename)(r??(0,T.basename)(o),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return F.Schemas.vscodeRemote;const r=(0,w.getVirtualWorkspaceScheme)(t.getWorkspace());if(r)return r;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:F.Schemas.file}userHome(o){return o?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(o=>o===1?D.win32:D.posix)}async fileURI(o){let t="";if(await this.resolveOS===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return g.URI.from({scheme:F.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.AbstractPathService=E,e.AbstractPathService=E=p=je([Ve(1,u.IRemoteAgentService),Ve(2,I.IWorkbenchEnvironmentService),Ve(3,A.IWorkspaceContextService)],E)}),define(Pe[114],Te([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class S{constructor(T,g){this.line=T,this.character=g}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,g){return new S(0,0)}with(T){return new S(0,0)}}e.Position=S;class F{constructor(T,g,m,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(T,g),this.end=new S(m,w)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new F(0,0,0,0)}with(T){return new F(0,0,0,0)}}e.Range=F;var D;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(D||(e.TextSearchCompleteMessageType=D={}))}),define(Pe[44],Te([1,0,18,34,26,46,12,4,19,11,114,14]),function(ge,e,S,F,D,R,T,g,m,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",p=" characters skipped \u27EB",E=(u.length+p.length+5)*2;e.ISearchService=(0,g.createDecorator)("searchService");var n;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(n||(e.SearchProviderType=n={}));var o;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(o||(e.QueryType=o={}));function t(he){return!!he.preview}e.resultIsMatch=t;function r(he){return!!he.resource}e.isFileMatch=r;function a(he){return!!he.message}e.isProgressMessage=a;var c;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class d{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=d;class i{constructor(de,te,Ie,oe){this.ranges=te,this.webviewIndex=oe;const Y=Array.isArray(te)?te:[te];if(Ie&&Ie.matchLines===1&&s(Y)){de=(0,T.getNLines)(de,Ie.matchLines);let H="",ne=0,De=0;const Re=Math.floor(Ie.charsPerLine/5),ke=[];for(const ce of Y){const ie=Math.max(ce.startColumn-Re,0),G=ce.startColumn+Ie.charsPerLine;if(ie>De+Re+E){const ee=u+(ie-De)+p;H+=ee+de.slice(ie,G),ne+=ie-(De+ee.length)}else H+=de.slice(De,G);ke.push(new h(0,ce.startColumn-ne,ce.endColumn-ne)),De=G}this.preview={text:H,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const H=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:de,matches:(0,S.mapArrayOrNot)(te,ne=>new l(ne.startLineNumber-H,ne.startColumn,ne.endLineNumber-H,ne.endColumn))}}}}e.TextSearchMatch=i;function s(he){const de=he[0].startLineNumber;for(const te of he)if(te.startLineNumber!==de||te.endLineNumber!==de)return!1;return!0}class l{constructor(de,te,Ie,oe){this.startLineNumber=de,this.startColumn=te,this.endLineNumber=Ie,this.endColumn=oe}}e.SearchRange=l;class h extends l{constructor(de,te,Ie){super(de,te,de,Ie)}}e.OneLineRange=h;var b;(function(he){he.List="list",he.Tree="tree"})(b||(e.ViewMode=b={}));var f;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function C(he,de=!0){const te=he&&he.files&&he.files.exclude,Ie=de&&he&&he.search&&he.search.exclude;if(!te&&!Ie)return;if(!te||!Ie)return te||Ie;let oe=Object.create(null);return oe=D.mixin(oe,D.deepClone(te)),oe=D.mixin(oe,D.deepClone(Ie),!0),oe}e.getExcludes=C;function O(he,de){return he.excludePattern&&F.match(he.excludePattern,de)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&F.match(he.includePattern,de)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(te=>{const Ie=te.folder.fsPath;if(R.isEqualOrParent(de,Ie)){const oe=m.relative(Ie,de);return!te.includePattern||!!F.match(te.includePattern,oe)}else return!1}):!1:!0}e.pathIncludedInQuery=O;var v;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class _ extends Error{constructor(de,te){super(de),this.code=te}}e.SearchError=_;function y(he){const de=he.message;if((0,w.isCancellationError)(he))return new _(de,v.canceled);try{const te=JSON.parse(de);return new _(te.message,te.code)}catch{return new _(de,v.other)}}e.deserializeSearchError=y;function M(he){const de={message:he.message,code:he.code};return new Error(JSON.stringify(de))}e.serializeSearchError=M;function V(he){return he.type==="error"?!0:he.type==="success"}e.isSerializedSearchComplete=V;function $(he){return he.type==="success"}e.isSerializedSearchSuccess=$;function L(he){return!!he.path}e.isSerializedFileMatch=L;function U(he,de){const te=he.searchPath?he.searchPath:he.relativePath;return(0,T.fuzzyContains)(te,de)}e.isFilePatternMatch=U;class k{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=k;function P(he,de){const te={...he||{},...de||{}};return Object.keys(te).filter(Ie=>{const oe=te[Ie];return typeof oe=="boolean"&&oe})}e.resolvePatternsForProvider=P;class Q{constructor(de,te){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let Ie=de.includePattern;te.includePattern&&(Ie?Ie={...Ie,...te.includePattern}:Ie=te.includePattern),Ie&&(this._parsedIncludeExpression=F.parse(Ie))}matchesExcludesSync(de,te,Ie){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,te,Ie))}includedInQuerySync(de,te,Ie){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,te,Ie)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,te,Ie))}includedInQuery(de,te,Ie){const oe=this._parsedExcludeExpression(de,te,Ie),Y=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,te,Ie):!0;return(0,I.isThenable)(oe)?oe.then(H=>H?!1:Y()):Y()}hasSiblingExcludeClauses(){return ae(this._excludeExpression)}}e.QueryGlobTester=Q;function ae(he){for(const de in he)if(typeof he[de]!="boolean")return!0;return!1}function me(he){if(!he)return;let de;return te=>(de||(de=(he()||Promise.resolve([])).then(Ie=>Ie?Ce(Ie):{})),de.then(Ie=>!!Ie[te]))}e.hasSiblingPromiseFn=me;function Ee(he){if(!he)return;let de;return te=>{if(!de){const Ie=he();de=Ie?Ce(Ie):{}}return!!de[te]}}e.hasSiblingFn=Ee;function Ce(he){const de={};for(const te of he)de[te]=!0;return de}}),define(Pe[36],Te([1,0,18,14,20,5,6,50,13,122,25,12,2,169,4,15,188,47,43,27,17,8,7,57,44,3,51]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s,l,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f($,L,U){return new A.ExtUri(k=>_(k,U)).isEqual($,L)}function C($,L,U){return f($.uri,L.uri,U)?0:(0,I.compare)($.uri.toString(),L.uri.toString())}function O($,L,U){return $.index!==L.index?$.index<L.index?-1:1:f($.uri,L.uri,U)?(0,I.compare)($.name,L.name):(0,I.compare)($.uri.toString(),L.uri.toString())}function v($,L,U,k){const P=$.slice(0).sort((ae,me)=>U(ae,me,k)),Q=L.slice(0).sort((ae,me)=>U(ae,me,k));return(0,S.delta)(P,Q,(ae,me)=>U(ae,me,k))}function _($,L){const U=L.getCapabilities($.scheme);return!(U&&U&1024)}class y extends t.Workspace{static toExtHostWorkspace(L,U,k,P){if(!L)return{workspace:null,added:[],removed:[]};const{id:Q,name:ae,folders:me,configuration:Ee,transient:Ce,isUntitled:he}=L,de=[],te=U;U?me.forEach((H,ne)=>{const De=u.URI.revive(H.uri),Re=y._findFolder(k||U,De,P);Re?(Re.name=H.name,Re.index=H.index,de.push(Re)):de.push({uri:De,name:H.name,index:ne})}):de.push(...me.map(({uri:H,name:ne,index:De})=>({uri:u.URI.revive(H),name:ne,index:De}))),de.sort((H,ne)=>H.index<ne.index?-1:1);const Ie=new y(Q,ae,de,!!Ce,Ee?u.URI.revive(Ee):null,!!he,H=>_(H,P)),{added:oe,removed:Y}=v(te?te.workspaceFolders:[],Ie.workspaceFolders,C,P);return{workspace:Ie,added:oe,removed:Y}}static _findFolder(L,U,k){for(let P=0;P<L.folders.length;P++){const Q=L.workspaceFolders[P];if(f(Q.uri,U,k))return Q}}constructor(L,U,k,P,Q,ae,me){super(L,k.map(Ee=>new t.WorkspaceFolder(Ee)),P,Q,me),this._name=U,this._isUntitled=ae,this._workspaceFolders=[],this._structure=g.TernarySearchTree.forUris(me),k.forEach(Ee=>{this._workspaceFolders.push(Ee),this._structure.set(Ee.uri,Ee)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,U){return U&&this._structure.get(L)&&(L=(0,A.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let M=class{constructor(L,U,k,P,Q){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new R.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=P,this._extHostFileSystemInfo=k,this._uriTransformerService=Q,this._requestIdProvider=new w.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(h.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(h.MainContext.MainThreadMessageService);const ae=U.workspace;this._confirmedWorkspace=ae?new y(ae.id,ae.name,[],!!ae.transient,ae.configuration?u.URI.revive(ae.configuration):null,!!ae.isUntitled,me=>_(me,k)):void 0}$initializeWorkspace(L,U){this._trusted=U,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:m.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,U,k,...P){const Q=[];if(Array.isArray(P)&&P.forEach(he=>{u.URI.isUri(he.uri)&&!Q.some(de=>f(de.uri,he.uri,this._extHostFileSystemInfo))&&Q.push({uri:he.uri,name:he.name||(0,A.basenameOrAuthority)(he.uri)})}),this._unconfirmedWorkspace||[U,k].some(he=>typeof he!="number"||he<0)||k===0&&Q.length===0)return!1;const ae=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+k>ae.length)return!1;const me=ae.slice(0);me.splice(U,k,...Q.map(he=>({uri:he.uri,name:he.name||(0,A.basenameOrAuthority)(he.uri),index:void 0})));for(let he=0;he<me.length;he++){const de=me[he];if(me.some((te,Ie)=>Ie!==he&&f(de.uri,te.uri,this._extHostFileSystemInfo)))return!1}me.forEach((he,de)=>he.index=de);const{added:Ee,removed:Ce}=v(ae,me,O,this._extHostFileSystemInfo);if(Ee.length===0&&Ce.length===0)return!1;if(this._proxy){const he=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(he,U,k,Q).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(o.Severity.Error,(0,p.localize)(0,null,he,de.toString()),te,[])})}return this.trySetWorkspaceFolders(me),!0}getWorkspaceFolder(L,U){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async getWorkspaceFolder2(L,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,U)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,U){let k,P="";if(typeof L=="string"?(k=u.URI.file(L),P=L):typeof L<"u"&&(k=L,P=L.fsPath),!k)return P;const Q=this.getWorkspaceFolder(k,!0);if(!Q)return P;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let ae=(0,A.relativePath)(Q.uri,k);return U&&Q.name&&(ae=`${Q.name}/${ae}`),ae}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=y.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:U,added:k,removed:P}=y.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:k,removed:P}))}findFiles(L,U,k,P,Q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${P.value}, entryPoint: findFiles`);let ae;if(U===null?ae=!1:U&&(typeof U=="string"?ae=U:ae=U.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:me,folder:Ee}=V(d.GlobPattern.from(L));return this._proxy.$startFileSearch(me??null,Ee??null,ae??null,k??null,Q).then(Ce=>Array.isArray(Ce)?Ce.map(he=>u.URI.revive(he)):[])}async findTextInFiles(L,U,k,P,Q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${P.value}, entryPoint: findTextInFiles`);const ae=this._requestIdProvider.getNext(),me=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Ee,folder:Ce}=V(d.GlobPattern.from(U.include)),he=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,de={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:me,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Ee,excludePattern:he},te=!1;if(this._activeSearchCallbacks[ae]=Ie=>{if(te)return;const oe=u.URI.revive(Ie.resource);Ie.results.forEach(Y=>{const H=(0,b.revive)(Y);(0,l.resultIsMatch)(H)?k({uri:oe,preview:{text:H.preview.text,matches:(0,S.mapArrayOrNot)(H.preview.matches,ne=>new i.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.mapArrayOrNot)(H.ranges,ne=>new i.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):k({uri:oe,text:H.text,lineNumber:H.lineNumber})})},Q.isCancellationRequested)return{};try{const Ie=await this._proxy.$startTextSearch(L,Ce??null,de,ae,Q);return delete this._activeSearchCallbacks[ae],Ie||{}}catch(Ie){throw delete this._activeSearchCallbacks[ae],Ie}}$handleTextSearchResult(L,U){this._activeSearchCallbacks[U]?.(L)}async save(L){const U=await this._proxy.$save(L,{saveAs:!1});return u.URI.revive(U)}async saveAs(L){const U=await this._proxy.$save(L,{saveAs:!0});return u.URI.revive(U)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,U){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,U);const k=this._uriTransformerService.transformOutgoingScheme(L),P=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(P,k),(0,T.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(P)})}async $getEditSessionIdentifier(L,U){this._logService.info("Getting edit session identifier for workspaceFolder",L);const k=await this.resolveWorkspaceFolder(u.URI.revive(L));if(!k){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",k);const P=this._editSessionIdentityProviders.get(k.uri.scheme);if(this._logService.info(`Provider for scheme ${k.uri.scheme} is defined: `,!!P),!P)return;const Q=await P.provideEditSessionIdentity(k,U);if(this._logService.info("Provider returned edit session identifier: ",Q),!!Q)return Q}async $provideEditSessionIdentityMatch(L,U,k,P){this._logService.info("Getting edit session identifier for workspaceFolder",L);const Q=await this.resolveWorkspaceFolder(u.URI.revive(L));if(!Q){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",Q);const ae=this._editSessionIdentityProviders.get(Q.uri.scheme);if(this._logService.info(`Provider for scheme ${Q.uri.scheme} is defined: `,!!ae),!ae)return;const me=await ae.provideEditSessionIdentityMatch?.(U,k,P);if(this._logService.info("Provider returned edit session identifier match result: ",me),!!me)return me}getOnWillCreateEditSessionIdentityEvent(L){return(U,k,P)=>{const Q=function(me){U.call(k,me)};return Q.extension=L,this._onWillCreateEditSessionIdentityEvent.event(Q,void 0,P)}}async $onWillCreateEditSessionIdentity(L,U,k){const P=await this.resolveWorkspaceFolder(u.URI.revive(L));if(P===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:P},U,async(Q,ae)=>{const me=Date.now();await Promise.resolve(Q),Date.now()-me>k&&this._logService.warn("SLOW edit session create-participant",ae.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(L,U){if(this._canonicalUriProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._canonicalUriProviders.set(L,U);const k=this._uriTransformerService.transformOutgoingScheme(L),P=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(P,k),(0,T.toDisposable)(()=>{this._canonicalUriProviders.delete(L),this._proxy.$unregisterCanonicalUriProvider(P)})}async provideCanonicalUri(L,U,k){const P=this._canonicalUriProviders.get(L.scheme);if(!P)return;const Q=await P.provideCanonicalUri?.(u.URI.revive(L),U,k);if(Q)return Q}async $provideCanonicalUri(L,U,k){return this.provideCanonicalUri(u.URI.revive(L),{targetScheme:U},k)}};e.ExtHostWorkspace=M,e.ExtHostWorkspace=M=je([Ve(0,c.IExtHostRpcService),Ve(1,a.IExtHostInitDataService),Ve(2,r.IExtHostFileSystemInfo),Ve(3,n.ILogService),Ve(4,s.IURITransformerService)],M),e.IExtHostWorkspace=(0,E.createDecorator)("IExtHostWorkspace");function V($){let L,U;return $&&(typeof $=="string"?L=$:(L=$.pattern,U=u.URI.revive($.baseUri))),{includePattern:L,folder:U}}}),define(Pe[37],Te([1,0,26,5,36,3,7,190,54,16,14,4,17,15,2]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function n(s,l){if(l){const h=l.split(".");let b=s;for(let f=0;b&&f<h.length;f++)b=b[h[f]];return b}}function o(s){return s instanceof E.URI}function t(s){return s&&s.uri instanceof E.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof E.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(o(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let d=class{constructor(l,h,b){this._proxy=l.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=h,this._logService=b,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new i(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,h){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(l,h))}};e.ExtHostConfiguration=d,e.ExtHostConfiguration=d=je([Ve(0,u.IExtHostRpcService),Ve(1,D.IExtHostWorkspace),Ve(2,p.ILogService)],d);class i{constructor(l,h,b,f){this._onDidChangeConfiguration=new F.Emitter,this._proxy=l,this._logService=f,this._extHostWorkspace=h,this._configuration=g.Configuration.parse(b),this._configurationScopes=this._toMap(b.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,h){const b={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=g.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(h,b))}getConfiguration(l,h,b){const f=c(h)||{},C=this._toReadonlyValue(l?n(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,f,b?.identifier);function O(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case T.ConfigurationTarget.Global:return 2;case T.ConfigurationTarget.Workspace:return 5;case T.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(_){return typeof n(C,_)<"u"},get:(_,y)=>{this._validateConfigurationAccess(l?`${l}.${_}`:_,f,b?.identifier);let M=n(C,_);if(typeof M>"u")M=y;else{let V;const $=(L,U)=>{if((0,w.isObject)(L)){let k;const P=()=>{V=V||(0,S.deepClone)(C),k=k||n(V,U)};return new Proxy(L,{get:(Q,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return P(),()=>k;if(V)return k=k||n(V,U),k[ae];const me=Q[ae];return typeof ae=="string"?$(me,`${U}.${ae}`):me},set:(Q,ae,me)=>(P(),k&&(k[ae]=me),!0),deleteProperty:(Q,ae)=>(P(),k&&delete k[ae],!0),defineProperty:(Q,ae,me)=>(P(),k&&Object.defineProperty(k,ae,me),!0)})}return Array.isArray(L)?(0,S.deepClone)(L):L};M=$(M,_)}return M},update:(_,y,M,V)=>{_=l?`${l}.${_}`:_;const $=O(M);return y!==void 0?this._proxy.$updateConfigurationOption($,_,y,f,V):this._proxy.$removeConfigurationOption($,_,f,V)},inspect:_=>{_=l?`${l}.${_}`:_;const y=this._configuration.inspect(_,f,this._extHostWorkspace.workspace);if(y)return{key:_,defaultValue:(0,S.deepClone)(y.policy?.value??y.default?.value),globalValue:(0,S.deepClone)(y.user?.value??y.application?.value),workspaceValue:(0,S.deepClone)(y.workspace?.value),workspaceFolderValue:(0,S.deepClone)(y.workspaceFolder?.value),defaultLanguageValue:(0,S.deepClone)(y.default?.override),globalLanguageValue:(0,S.deepClone)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,S.deepClone)(y.workspace?.override),workspaceFolderLanguageValue:(0,S.deepClone)(y.workspaceFolder?.override),languageIds:(0,S.deepClone)(y.overrideIdentifiers)}}};return typeof C=="object"&&(0,S.mixin)(v,C,!1),Object.freeze(v)}_toReadonlyValue(l){const h=b=>(0,w.isObject)(b)?new Proxy(b,{get:(f,C)=>h(f[C]),set:(f,C,O)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(C)}' of object`)},deleteProperty:(f,C)=>{throw new Error(`TypeError: Cannot delete read only property '${String(C)}' of object`)},defineProperty:(f,C)=>{throw new Error(`TypeError: Cannot define property '${String(C)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return h(l)}_validateConfigurationAccess(l,h,b){const f=m.OVERRIDE_PROPERTY_REGEX.test(l)?4:this._configurationScopes.get(l),C=b?`[${b.value}] `:"";if(f===4){typeof h?.resource>"u"&&this._logService.warn(`${C}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){h?.resource&&this._logService.warn(`${C}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,h){const b=new g.ConfigurationChangeEvent(l,h,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,C)=>b.affectsConfiguration(f,c(C))})}_toMap(l){return l.reduce((h,b)=>(h.set(b[0],b[1]),h),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")}),define(Pe[115],Te([1,0,2,14,5,3,7,36,61,37,20,64,17,27,4,13,21,15,81,229,11]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function($){function L(k){if(k!=null)return k}$.from=L;function U(k){if(k!=null)return k}$.to=U})(d||(d={}));var i;(function($){function L(k){if(k!=null)return k}$.from=L;function U(k){if(k!=null)return k}$.to=U})(i||(i={}));var s;(function($){function L(k){if(k!=null)return k}$.from=L;function U(k){if(k!=null)return k}$.to=U})(s||(s={}));var l;(function($){function L(P){if(P){const Q=P;return Q&&!!Q.process}else return!1}$.is=L;function U(P){if(P==null)return;const Q={process:P.process,args:P.args};return P.options&&(Q.options=s.from(P.options)),Q}$.from=U;function k(P){if(P!=null)return new T.ProcessExecution(P.process,P.args,P.options)}$.to=k})(l||(l={}));var h;(function($){function L(k){if(k!=null)return k}$.from=L;function U(k){if(k!=null)return k}$.to=U})(h||(h={}));var b;(function($){function L(P){if(P){const Q=P;return Q&&(!!Q.commandLine||!!Q.command)}else return!1}$.is=L;function U(P){if(P==null)return;const Q={};return P.commandLine!==void 0?Q.commandLine=P.commandLine:(Q.command=P.command,Q.args=P.args),P.options&&(Q.options=h.from(P.options)),Q}$.from=U;function k(P){if(!(P==null||P.command===void 0&&P.commandLine===void 0))return P.commandLine?new T.ShellExecution(P.commandLine,P.options):new T.ShellExecution(P.command,P.args?P.args:[],P.options)}$.to=k})(b||(b={}));var f;(function($){function L(P){if(P){const Q=P;return Q&&Q.customExecution==="customExecution"}else return!1}$.is=L;function U(P){return{customExecution:"customExecution"}}$.from=U;function k(P,Q){return Q.get(P)}$.to=k})(f||(e.CustomExecutionDTO=f={}));var C;(function($){function L(U,k){let P;return U.scope!==void 0&&typeof U.scope!="number"?P=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===T.TaskScope.Workspace&&k&&k.workspaceFile?P=k.workspaceFile:P=a.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:P}}$.from=L})(C||(e.TaskHandleDTO=C={}));var O;(function($){function L(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}$.from=L})(O||(O={}));var v;(function($){function L(P,Q){if(P==null)return[];const ae=[];for(const me of P){const Ee=U(me,Q);Ee&&ae.push(Ee)}return ae}$.fromMany=L;function U(P,Q){if(P==null)return;let ae;P.execution instanceof T.ProcessExecution?ae=l.from(P.execution):P.execution instanceof T.ShellExecution?ae=b.from(P.execution):P.execution&&P.execution instanceof T.CustomExecution&&(ae=f.from(P.execution));const me=d.from(P.definition);let Ee;return P.scope?typeof P.scope=="number"?Ee=P.scope:Ee=P.scope.uri:Ee=T.TaskScope.Workspace,!me||!Ee?void 0:{_id:P._id,definition:me,name:P.name,source:{extensionId:Q.identifier.value,label:P.source,scope:Ee},execution:ae,isBackground:P.isBackground,group:O.from(P.group),presentationOptions:i.from(P.presentationOptions),problemMatchers:P.problemMatchers,hasDefinedMatchers:P.hasDefinedMatchers,runOptions:P.runOptions?P.runOptions:{reevaluateOnRerun:!0},detail:P.detail}}$.from=U;async function k(P,Q,ae){if(P==null)return;let me;l.is(P.execution)?me=l.to(P.execution):b.is(P.execution)?me=b.to(P.execution):f.is(P.execution)&&(me=f.to(P._id,ae));const Ee=d.to(P.definition);let Ce;if(P.source&&(P.source.scope!==void 0?typeof P.source.scope=="number"?Ce=P.source.scope:Ce=await Q.resolveWorkspaceFolder(S.URI.revive(P.source.scope)):Ce=T.TaskScope.Workspace),!Ee||!Ce)return;const he=new T.Task(Ee,Ce,P.name,P.source.label,me,P.problemMatchers);return P.isBackground!==void 0&&(he.isBackground=P.isBackground),P.group!==void 0&&(he.group=T.TaskGroup.from(P.group._id),he.group&&P.group.isDefault&&(he.group=new T.TaskGroup(he.group.id,he.group.label),P.group.isDefault===!0&&(he.group.isDefault=P.group.isDefault))),P.presentationOptions&&(he.presentationOptions=i.to(P.presentationOptions)),P._id&&(he._id=P._id),P.detail&&(he.detail=P.detail),he}$.to=k})(v||(e.TaskDTO=v={}));var _;(function($){function L(k){return k}$.from=L;function U(k){if(k)return Object.assign(Object.create(null),k)}$.to=U})(_||(_={}));class y{#e;constructor(L,U,k){this._id=U,this._task=k,this.#e=L}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let M=class{constructor(L,U,k,P,Q,ae,me,Ee){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=L.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=k,this._editorService=P,this._configurationService=Q,this._terminalService=ae,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=me,this._deprecationService=Ee,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(L,U,k){if(!k)return new T.Disposable(()=>{});const P=this.nextHandle();return this._handlers.set(P,{type:U,provider:k,extension:L}),this._proxy.$registerTaskProvider(P,U),new T.Disposable(()=>{this._handlers.delete(P),this._proxy.$unregisterTaskProvider(P)})}registerTaskSystem(L,U){this._proxy.$registerTaskSystem(L,U)}fetchTasks(L){return this._proxy.$fetchTasks(_.from(L)).then(async U=>{const k=[];for(const P of U){const Q=await v.to(P,this._workspaceProvider,this._providedCustomExecutions2);Q&&k.push(Q)}return k})}get taskExecutions(){const L=[];return this._taskExecutions.forEach(U=>L.push(U)),L}terminateTask(L){if(!(L instanceof y))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(L._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(L,U,k){const P=this._providedCustomExecutions2.get(L.id);P&&(this._activeCustomExecutions2.set(L.id,P),this._terminalService.attachPtyToTerminal(U,await P.callback(k))),this._lastStartedTask=L.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(L)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(L){const U=await this.getTaskExecution(L);this._taskExecutionPromises.delete(L.id),this._taskExecutions.delete(L.id),this.customExecutionComplete(L),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(L){const U=await this.getTaskExecution(L.id);this._onDidTaskProcessStarted.fire({execution:U,processId:L.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(L){const U=await this.getTaskExecution(L.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:L.exitCode})}$provideTasks(L,U){const k=this._handlers.get(L);if(!k)return Promise.reject(new Error("no handler found"));const P=[],Q=(0,F.asPromise)(()=>k.provider.provideTasks(A.CancellationToken.None)).then(ae=>this.provideTasksInternal(U,P,k,ae));return new Promise(ae=>{Q.then(me=>{Promise.all(P).then(()=>{ae(me)})})})}async $resolveTask(L,U){const k=this._handlers.get(L);if(!k)return Promise.reject(new Error("no handler found"));if(U.definition.type!==k.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${k.type}].`);const P=await v.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!P)throw new Error("Unexpected: Task cannot be resolved.");const Q=await k.provider.resolveTask(P,A.CancellationToken.None);if(!Q)return;this.checkDeprecation(Q,k);const ae=v.from(Q,k.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(Q.definition!==P.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ae.execution)&&await this.addCustomExecution(ae,Q,!0),await this.resolveTaskInternal(ae)}nextHandle(){return this._handleCounter++}async addCustomExecution(L,U,k){const P=await this._proxy.$createTaskId(L);!k&&!this._providedCustomExecutions2.has(P)&&(this._notProvidedCustomExecutions.add(P),this._activeCustomExecutions2.set(P,U.execution)),this._providedCustomExecutions2.set(P,U.execution)}async getTaskExecution(L,U){if(typeof L=="string"){const Q=this._taskExecutionPromises.get(L);if(!Q)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return Q}const k=this._taskExecutionPromises.get(L.id);if(k)return k;const P=new Promise((Q,ae)=>{function me(Ee,Ce,he){he?Q(new y(Ee,Ce.id,he)):ae("Unexpected: Task does not exist.")}U?me(this,L,U):v.to(L.task,this._workspaceProvider,this._providedCustomExecutions2).then(Ee=>me(this,L,Ee))});return this._taskExecutionPromises.set(L.id,P),P.then(Q=>(this._taskExecutions.set(L.id,Q),Q),Q=>Promise.reject(Q))}checkDeprecation(L,U){L._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(L){this._activeCustomExecutions2.get(L.id)&&this._activeCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.has(L.id)&&this._lastStartedTask!==L.id&&(this._providedCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.delete(L.id));const k=this._notProvidedCustomExecutions.values();let P=k.next();for(;!P.done;)!this._activeCustomExecutions2.has(P.value)&&this._lastStartedTask!==P.value&&(this._providedCustomExecutions2.delete(P.value),this._notProvidedCustomExecutions.delete(P.value)),P=k.next()}};e.ExtHostTaskBase=M,e.ExtHostTaskBase=M=je([Ve(0,u.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,g.IExtHostWorkspace),Ve(3,m.IExtHostDocumentsAndEditors),Ve(4,w.IExtHostConfiguration),Ve(5,I.IExtHostTerminalService),Ve(6,t.ILogService),Ve(7,r.IExtHostApiDeprecationService)],M);let V=class extends M{constructor(L,U,k,P,Q,ae,me,Ee){super(L,U,k,P,Q,ae,me,Ee),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(L,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const k=v.from(U,L);if(k===void 0)throw new Error("Task is not valid");if(f.is(k.execution))await this.addCustomExecution(k,U,!1);else throw new c.NotSupportedError;const P=await this.getTaskExecution(await this._proxy.$getTaskExecution(k),U);return this._proxy.$executeTask(k).catch(Q=>{throw new Error(Q)}),P}provideTasksInternal(L,U,k,P){const Q=[];if(P)for(const ae of P){if(this.checkDeprecation(ae,k),!ae.definition||!L[ae.definition.type]){const Ee=ae.source?ae.source:"No task source";this._logService.warn(`The task [${Ee}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const me=v.from(ae,k.extension);me&&f.is(me.execution)?(Q.push(me),U.push(this.addCustomExecution(me,ae,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Q,extension:k.extension}}async resolveTaskInternal(L){if(f.is(L.execution))return L;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(L,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,U,k){}};e.WorkerExtHostTask=V,e.WorkerExtHostTask=V=je([Ve(0,u.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,g.IExtHostWorkspace),Ve(3,m.IExtHostDocumentsAndEditors),Ve(4,w.IExtHostConfiguration),Ve(5,I.IExtHostTerminalService),Ve(6,t.ILogService),Ve(7,r.IExtHostApiDeprecationService)],V),e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(Pe[282],Te([1,0,44,29]),function(ge,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.genericCellMatchesToTextSearchMatches=e.rawCellPrefix=e.isINotebookFileMatchNoModel=void 0;function D(T){return"cellResults"in T}e.isINotebookFileMatchNoModel=D,e.rawCellPrefix="rawCell#";function R(T,g){let m=-1;const w=[];let A=[];return T.forEach(u=>{u.range.startLineNumber!==m&&A.length>0&&(w.push([...A]),A=[]),A.push(u),m=u.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(u=>{const p=[],E=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let o=E;o<=n;o++)p.push(g.getLineContent(o));return new S.TextSearchMatch(p.join(`
`)+`
`,u.map(o=>new F.Range(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.genericCellMatchesToTextSearchMatches=R}),define(Pe[283],Te([1,0,162,24,5,6,28,12,16,2,42,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}constructor(f,C,O,v,_,y){this._textDocumentsAndEditors=O,this._textDocuments=v,this._extHostFileSystem=_,this._extHostSearch=y,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new D.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter({onListenerError:a.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=f.getProxy(u.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(u.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(u.MainContext.MainThreadNotebookEditors),this._commandsConverter=C.converter,C.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===13){const V=M.notebookEditor?.notebookUri,$=M.cell.handle,U=this._documents.get(V)?.getCell($);if(U)return U.apiCell}if(M&&M.$mid===14){const V=M.uri,$=this._documents.get(V);if($)return $.apiNotebook}return M}}),h._registerApiCommands(C)}getEditorById(f){const C=this._editors.get(f);if(!C)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);return C}getIdByEditor(f){for(const[C,O]of this._editors)if(O.apiEditor===f)return C}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,C){const O=this._documents.get(f);if(!O&&!C)throw new Error(`NO notebook document for '${f}'`);return O}static _convertNotebookRegistrationData(f,C){if(!C)return;const O=C.filenamePattern.map(v=>E.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(C.filenamePattern&&!O){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:C.displayName,filenamePattern:O,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,C,O){const v=h._notebookStatusBarItemProviderHandlePool++,_=typeof O.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,O),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,_,C);let y;return _!==void 0&&(y=O.onDidChangeCellStatusBarItems(M=>this._notebookProxy.$emitCellStatusBarEvent(_))),new n.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,_),y?.dispose()})}async createNotebookDocument(f){const C=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&E.NotebookData.from(f.content)});return w.URI.revive(C)}async openNotebookDocument(f){const C=this._documents.get(f);if(C)return C.apiNotebook;const O=await this._notebookDocumentsProxy.$tryOpenNotebook(f),v=this._documents.get(w.URI.revive(O));return(0,m.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(f,C){w.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let O;typeof C=="object"?O={position:E.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(E.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:O={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,O),_=v&&this._editors.get(v)?.apiEditor;if(_)return _;throw v?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,C,O,v){const _=this._notebookStatusBarItemProviders.get(f),y=w.URI.revive(C),M=this._documents.get(y);if(!M||!_)return;const V=M.getCellFromIndex(O);if(!V)return;const $=await _.provideCellStatusBarItems(V.apiCell,v);if(!$)return;const L=new R.DisposableStore,U=this._statusBarCache.add([L]),P=(Array.isArray($)?$:[$]).map(Q=>E.NotebookStatusBarItem.from(Q,this._commandsConverter,L));return{cacheId:U,items:P}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,C,O,v,_){if((0,g.isFalsyOrWhitespace)(C))throw new Error("viewType cannot be empty or just whitespace");const y=this._handlePool++;return this._notebookSerializer.set(y,{viewType:C,serializer:O,options:v}),this._notebookProxy.$registerNotebookSerializer(y,{id:f.identifier,location:f.extensionLocation},C,E.NotebookDocumentContentOptions.from(v),h._convertNotebookRegistrationData(f,_)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(y)})}async $dataToNotebook(f,C,O){const v=this._notebookSerializer.get(f);if(!v)throw new Error("NO serializer found");const _=await v.serializer.deserializeNotebook(C.buffer,O);return new o.SerializableObjectWithBuffers(E.NotebookData.from(_))}async $notebookToData(f,C,O){const v=this._notebookSerializer.get(f);if(!v)throw new Error("NO serializer found");const _=await v.serializer.serializeNotebook(E.NotebookData.to(C.value),O);return F.VSBuffer.wrap(_)}async $saveNotebook(f,C,O,v,_){const y=w.URI.revive(C),M=this._notebookSerializer.get(f);if(!M)throw new Error("NO serializer found");const V=this._documents.get(y);if(!V)throw new Error("Document NOT found");if(V.versionId!==O)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(y.scheme))throw new A.FileOperationError((0,S.localize)(0,null,this._resourceForError(y)),6);await this._validateWriteFile(y,v);const $={metadata:(0,c.filter)(V.apiNotebook.metadata,Q=>!(M.options?.transientDocumentMetadata??{})[Q]),cells:[]};for(const Q of V.apiNotebook.getCells()){const ae=new n.NotebookCellData(Q.kind,Q.document.getText(),Q.document.languageId,Q.mime,M.options?.transientOutputs?[]:[...Q.outputs],Q.metadata,Q.executionSummary);ae.metadata=(0,c.filter)(Q.metadata,me=>!(M.options?.transientCellMetadata??{})[me]),$.cells.push(ae)}const L=await M.serializer.serializeNotebook($,_);await this._extHostFileSystem.value.writeFile(y,L);const U=this._extHostFileSystem.getFileSystemProviderExtUri(y.scheme),k=await this._extHostFileSystem.value.stat(y);return{name:U.basename(y),isFile:(k.type&A.FileType.File)!==0,isDirectory:(k.type&A.FileType.Directory)!==0,isSymbolicLink:(k.type&A.FileType.SymbolicLink)!==0,mtime:k.mtime,ctime:k.ctime,size:k.size,readonly:!!((k.permissions??0)&A.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(y.scheme),locked:!!((k.permissions??0)&A.FilePermission.Locked),etag:A.etag({mtime:k.mtime,size:k.size}),children:void 0}}async $searchInNotebooks(f,C,O,v,_){const y=this._notebookSerializer.get(f)?.serializer;if(!y)return{limitHit:!1,results:[]};const M=new T.ResourceSet;await(async(k,P,Q)=>{await Promise.all(k.map(async ae=>await Promise.all(ae.filenamePatterns.map(me=>{const Ee={...Q,type:1,filePattern:me};return this._extHostSearch.doInternalFileSearchWithCustomCallback(Ee,P,Ce=>{Ce.forEach(he=>{M.has(he)||v.some(te=>ae.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(Ie=>(0,l.globMatchesResource)(Ie,he)))||M.add(he)})})}))))})(O,_,C);const $=new T.ResourceMap;let L=!1;const U=Array.from(M).map(async k=>{const P=[];try{if(_.isCancellationRequested)return;if(C.maxResults&&[...$.values()].reduce((Ee,Ce)=>Ee+Ce.cellResults.length,0)>C.maxResults){L=!0;return}const Q=[],ae=this._documents.get(k);if(ae)ae.apiNotebook.getCells().forEach(Ce=>Q.push({input:Ce.document.getText(),outputs:Ce.outputs.flatMap(he=>he.items.map(de=>de.data.toString()))}));else{const Ee=await this._extHostFileSystem.value.readFile(k),Ce=F.VSBuffer.fromString(Ee.toString()),he=await y.deserializeNotebook(Ce.buffer,_);if(_.isCancellationRequested)return;E.NotebookData.from(he).cells.forEach(te=>Q.push({input:te.source,outputs:te.outputs.flatMap(Ie=>Ie.items.map(oe=>oe.valueBytes.toString()))}))}if(_.isCancellationRequested)return;Q.forEach((Ee,Ce)=>{const he=C.contentPattern.pattern,de=new i.CellSearchModel(Ee.input,void 0,Ee.outputs),te=de.findInInputs(he),Ie=de.findInOutputs(he),oe=Ie.flatMap(Y=>(0,s.genericCellMatchesToTextSearchMatches)(Y.matches,Y.textBuffer)).map((Y,H)=>(Y.webviewIndex=H,Y));if(te.length>0||Ie.length>0){const Y={index:Ce,contentResults:(0,s.genericCellMatchesToTextSearchMatches)(te,de.inputTextBuffer),webviewResults:oe};P.push(Y)}});const me={resource:k,cellResults:P};$.set(k,me);return}catch{return}});return await Promise.all(U),{limitHit:L,results:[...$.values()]}}async _validateWriteFile(f,C){const O=await this._extHostFileSystem.value.stat(f);if(typeof C?.mtime=="number"&&typeof C.etag=="string"&&C.etag!==A.ETAG_DISABLED&&typeof O.mtime=="number"&&typeof O.size=="number"&&C.mtime<O.mtime&&C.etag!==A.etag({mtime:C.mtime,size:O.size}))throw new A.FileOperationError((0,S.localize)(1,null),3,C)}_resourceForError(f){return f.scheme===d.Schemas.file?f.fsPath:f.toString()}_createExtHostEditor(f,C,O){if(this._editors.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const v=new r.ExtHostNotebookEditor(C,this._notebookEditorsProxy,f,O.visibleRanges.map(E.NotebookRange.to),O.selections.map(E.NotebookRange.to),typeof O.viewColumn=="number"?E.ViewColumn.to(O.viewColumn):void 0);this._editors.set(C,v)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const O of f.value.removedDocuments){const v=w.URI.revive(O),_=this._documents.get(v);_&&(_.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:_.apiNotebook.getCells().map(y=>y.document.uri)}),this._onDidCloseNotebookDocument.fire(_.apiNotebook));for(const y of this._editors.values())y.notebookData.uri.toString()===v.toString()&&this._editors.delete(y.id)}if(f.value.addedDocuments){const O=[];for(const v of f.value.addedDocuments){const _=w.URI.revive(v.uri);if(this._documents.has(_))throw new Error(`adding EXISTING notebook ${_} `);const y=new t.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,_,v);O.push(...v.cells.map(M=>t.ExtHostCell.asModelAddData(y.apiNotebook,M))),this._documents.get(_)?.dispose(),this._documents.set(_,y),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:O}),this._onDidOpenNotebookDocument.fire(y.apiNotebook)}}if(f.value.addedEditors)for(const O of f.value.addedEditors){if(this._editors.has(O.id))return;const v=w.URI.revive(O.documentUri),_=this._documents.get(v);_&&this._createExtHostEditor(_,O.id,O)}const C=[];if(f.value.removedEditors)for(const O of f.value.removedEditors){const v=this._editors.get(O);v&&(this._editors.delete(O),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),C.push(v))}if(f.value.visibleEditors){this._visibleNotebookEditors=f.value.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const O=new Set;this._visibleNotebookEditors.forEach(v=>O.add(v.id));for(const v of this._editors.values()){const _=O.has(v.id);v._acceptVisibility(_)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this._activeNotebookEditor=void 0:f.value.newActiveEditor&&(this._editors.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(f){const C=p.ApiCommandArgument.String.with("notebookType","A notebook type"),O=new p.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new p.ApiCommandArgument("data","Bytes to convert to data",_=>_ instanceof Uint8Array,_=>F.VSBuffer.wrap(_))],new p.ApiCommandResult("Notebook Data",_=>E.NotebookData.to(_.value))),v=new p.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new p.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",_=>!0,_=>new o.SerializableObjectWithBuffers(E.NotebookData.from(_)))],new p.ApiCommandResult("Bytes",_=>_.buffer));f.registerApiCommand(O),f.registerApiCommand(v)}}e.ExtHostNotebookController=h}),define(Pe[284],Te([1,0,19,20,40,34,25,60,44]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class w{constructor(u,p,E){this.config=u,this.provider=p,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&R.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&R.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const p=this.config.folderQueries||[];return new Promise((E,n)=>{const o=t=>{this.resultCount++,u(t)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(t=>{const r=t.toString(),a=S.basename(r);this.globalExcludePattern&&this.globalExcludePattern(r,a)||this.matchFile(o,{base:t,basename:a})}),Promise.all(p.map(t=>this.searchInFolder(t,o))).then(t=>{E({limitHit:this.isLimitHit,stats:t[0]||void 0})},t=>{n(new Error((0,D.toErrorMessage)(t)))})})}async searchInFolder(u,p){const E=new F.CancellationTokenSource,n=this.getSearchOptionsForFolder(u),o=this.initDirectoryTree(),t=new m.QueryGlobTester(this.config,u),r=!t.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(E),a=g.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},n,E.token),d=a.elapsed(),i=g.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(s=>{const l=S.posix.relative(u.folder.path,s.path);if(r){const h=S.basename(s.path);this.matchFile(p,{base:u.folder,relativePath:l,basename:h});return}this.addDirectoryEntries(o,u.folder,l,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,t,p),{providerTime:d,postProcessTime:i.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(u){const p=(0,m.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),E=(0,m.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:E,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},p,E,n){if(E===this.filePattern){const t=S.basename(this.filePattern);this.matchFile(n,{base:p,relativePath:this.filePattern,basename:t})}function o(t){const r=S.basename(t),a=S.dirname(t);let c=u[a];c||(c=u[a]=[],o(a)),c.push({base:p,relativePath:t,basename:r})}o(E)}matchDirectoryTree({rootEntries:u,pathToEntries:p},E,n){const o=this,t=this.filePattern;function r(a){const c=(0,m.hasSiblingFn)(()=>a.map(d=>d.basename));for(let d=0,i=a.length;d<i;d++){const s=a[d],{relativePath:l,basename:h}=s;if(E.matchesExcludesSync(l,h,t!==h?c:void 0))continue;const b=p[l];if(b)r(b);else{if(l===t)continue;o.matchFile(n,s)}if(o.isLimitHit)break}}r(u)}matchFile(u,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(p))}}class A{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(u,p,E,n){const o=this.getSessionTokenSource(u.cacheKey),t=new w(u,p,o&&o.token);let r=0;const a=c=>{r+=c.length,E(c.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(t,A.BATCH_SIZE,a,n).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:c.stats}}))}clearCache(u){this.getSessionTokenSource(u)?.cancel()}getSessionTokenSource(u){if(u)return this.sessions.has(u)||this.sessions.set(u,new F.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,p,E,n){const o=n.onCancellationRequested(()=>{u.cancel()}),t=a=>{a&&(r.push(a),p>0&&r.length>=p&&(E(r),r=[]))};let r=[];return u.search(t).then(a=>(r.length&&E(r),o.dispose(),a),a=>(r.length&&E(r),o.dispose(),Promise.reject(a)))}}e.FileSearchManager=A}),define(Pe[285],Te([1,0,18,246,34,95,28,13,19,25,12,16,2,94,180,41,15,47,105,281,44]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(_,y,M,V,$){this.configurationService=_,this.workspaceContextService=y,this.editorGroupsService=M,this.logService=V,this.pathService=$}text(_,y,M={}){_=this.getContentPattern(_,M);const V=this.configurationService.getValue(),$=y&&y.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(y?.map(t.toWorkspaceFolder),M),type:2,contentPattern:_,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:V.search.usePCRE2||$||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}getContentPattern(_,y){const M=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const V={..._,wordSeparators:M.editor.wordSeparators};return this.isCaseSensitive(_,y)&&(V.isCaseSensitive=!0),this.isMultiline(_)&&(V.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),V}file(_,y={}){return{...this.commonQuery(_,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(_,y){return _?(_=Array.isArray(_)?_.map(b):b(_),y?this.parseSearchPaths(_):{pattern:s(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],y={}){const M=this.handleIncludeExclude(y.includePattern,y.expandPatterns),V=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),$=_.length>1,L=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(P=>this.getFolderQueryForSearchPath(P,y,V)):_.map(P=>this.getFolderQueryForRoot(P,y,V,$))).filter(P=>!!P),U={_reason:y._reason,folderQueries:L,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:V.pattern,includePattern:M.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const P=S.coalesce(S.flatten(this.editorGroupsService.groups.map(me=>me.editors.map(Ee=>Ee.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const Q=P.filter(me=>(0,c.pathIncludedInQuery)(U,me.fsPath)),ae=this.commonQueryFromFileList(Q);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ae)),{...U,...ae}}const k=y.extraFileResources&&y.extraFileResources.filter(P=>(0,c.pathIncludedInQuery)(U,P.fsPath));return U.extraFileResources=k&&k.length?k:void 0,U}commonQueryFromFileList(_){const y=[],M=new T.ResourceMap,V={};let $=!1;return _.forEach(L=>{if(L.scheme===g.Schemas.walkThrough)return;if((0,w.isAbsolutePath)(L)){const k=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:m.dirname(L.fsPath)});let P=M.get(k);P||($=!0,P={folder:k,includePattern:{}},y.push(P),M.set(k,P));const Q=m.relative(k.fsPath,L.fsPath);(0,I.assertIsDefined)(P.includePattern)[Q.replace(/\\/g,"/")]=!0}else L.fsPath&&($=!0,V[L.fsPath]=!0)}),{folderQueries:y,includePattern:V,usingSearchPaths:!0,excludePattern:$?void 0:{"**/*":!0}}}isCaseSensitive(_,y){if(y.isSmartCase){if(_.isRegExp){if(A.containsUppercaseCharacter(_.pattern,!0))return!0}else if(A.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,p.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const y=ae=>m.isAbsolute(ae)||/^\.\.?([\/\\]|$)/.test(ae),V=(Array.isArray(_)?_:l(_)).map(ae=>{const me=this.pathService.resolvedUserHome;return me?(0,R.untildify)(ae,me.scheme===g.Schemas.file?me.fsPath:me.path):ae}),$=F.groupBy(V,ae=>y(ae)?"searchPaths":"exprSegments"),L=($.exprSegments||[]).map(ae=>A.rtrim(ae,"/")).map(ae=>A.rtrim(ae,"\\")).map(ae=>(ae[0]==="."&&(ae="*"+ae),h(ae))),U={},k=this.expandSearchPathPatterns($.searchPaths||[]);k&&k.length&&(U.searchPaths=k);const P=S.flatten(L),Q=s(...P);return Q&&(U.pattern=Q),U}getExcludesForFolder(_,y){return y.disregardExcludeSettings?void 0:(0,c.getExcludes)(_,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const y=_.flatMap(V=>{let{pathPortion:$,globPortion:L}=i(V);return L&&(L=f(L)),this.expandOneSearchPath($).flatMap(k=>this.resolveOneSearchPathPattern(k,L))}),M=new Map;return y.forEach(V=>{const $=V.searchPath.toString(),L=M.get($);L?V.pattern&&(L.pattern=L.pattern||{},L.pattern[V.pattern]=!0):M.set($,{searchPath:V.searchPath,pattern:V.pattern?s(V.pattern):void 0})}),Array.from(M.values())}expandOneSearchPath(_){if(m.isAbsolute(_)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==g.Schemas.file?[{searchPath:y[0].uri.with({path:_})}]:[{searchPath:u.URI.file(m.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=b(_),_.startsWith("../")||_===".."){const V=m.posix.resolve(y.path,_);return[{searchPath:y.with({path:V})}]}const M=f(_);return[{searchPath:y,pattern:M}]}else{if(_==="./"||_===".\\")return[];{const y=_.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map($=>{const L=y.match(new RegExp(`^${A.escapeRegExpCharacters($.name)}(?:/(.*)|$)`));return L?{match:L,folder:$}:null}).filter(I.isDefined);if(V.length)return V.map($=>{const L=$.match[1];return{searchPath:$.folder.uri,pattern:L&&f(L)}});{const $=_.match(/\.[\/\\](.+)[\/\\]?/),L=$?$[1]:_,U=E.localize(0,null,L);throw new Error(U)}}}}resolveOneSearchPathPattern(_,y){const M=_.pattern&&y?`${_.pattern}/${y}`:_.pattern||y,V=[{searchPath:_.searchPath,pattern:M}];return M&&!M.endsWith("**")&&V.push({searchPath:_.searchPath,pattern:M+"/**"}),V}getFolderQueryForSearchPath(_,y,M){const V=this.getFolderQueryForRoot((0,t.toWorkspaceFolder)(_.searchPath),y,M,!1);return V?{...V,includePattern:_.pattern}:null}getFolderQueryForRoot(_,y,M,V){let $;const L=u.URI.isUri(_)?_:_.uri;if(M.searchPaths){const ae=M.searchPaths.filter(me=>(0,w.isEqual)(me.searchPath,L))[0];if(ae&&!ae.pattern)return null;ae&&($=ae.pattern)}const U=this.configurationService.getValue({resource:L}),P={...this.getExcludesForFolder(U,y)||{},...$||{}},Q=u.URI.isUri(_)?(0,w.basename)(_):_.name;return{folder:L,folderName:V?Q:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!U.search.followSymlinks}}};e.QueryBuilder=d,e.QueryBuilder=d=je([Ve(0,n.IConfigurationService),Ve(1,t.IWorkspaceContextService),Ve(2,r.IEditorGroupsService),Ve(3,o.ILogService),Ve(4,a.IPathService)],d);function i(v){const _=v.match(/[\*\{\}\(\)\[\]\?]/);if(_){const y=_.index,M=v.substr(0,y).match(/[/|\\][^/\\]*$/);if(M){let V=v.substr(0,M.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:v.substr((M.index||0)+1)}}}return{pathPortion:v}}function s(...v){return v.length?v.reduce((_,y)=>(_[y]=!0,_),Object.create(null)):void 0}function l(v){return D.splitGlobAware(v,",").map(_=>_.trim()).filter(_=>!!_.length)}function h(v){return[`**/${v}/**`,`**/${v}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function b(v){return v.replace(/\\/g,"/")}function f(v){return b(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function C(v){return v.replace(/([?*[\]])/g,"[$1]")}function O(v,_){v=S.distinct(v,V=>V.toString());const y=[],M=_.getWorkspace();return v&&v.forEach(V=>{let $;if(_.getWorkbenchState()===2)$=(0,w.relativePath)(M.folders[0].uri,V),$&&$!=="."&&($="./"+$);else{const L=_.getWorkspaceFolder(V);if(L){const U=L.name;if(M.folders.filter(P=>P.name===U).length===1){const P=(0,w.relativePath)(L.uri,V);P===""?$=`./${L.name}`:$=`./${L.name}/${P}`}else $=V.fsPath}}$&&y.push(C($))}),y}e.resolveResourcesForSearchIncludes=O}),define(Pe[286],Te([1,0,25,2,20,11,4,285,44,47]),function(ge,e,S,F,D,R,T,g,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function I(n,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const r=[],a=[];for(const h of t)if(/^workspaceContains:/.test(h)){const b=h.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||n.forceUsingSearch?a.push(b):r.push(b)}if(r.length===0&&a.length===0)return Promise.resolve(void 0);let c;const d=new Promise((h,b)=>{c=h}),i=h=>c({activationEvent:h}),s=Promise.all(r.map(h=>u(n,h,i))).then(()=>{}),l=p(n,o.identifier,a,i);return Promise.all([s,l]).then(()=>{c(void 0)}),d}e.checkActivateWorkspaceContainsExtension=I;async function u(n,o,t){for(const r of n.folders)if(await n.exists(S.joinPath(F.URI.revive(r),o))){t(`workspaceContains:${o}`);return}}async function p(n,o,t,r){if(t.length===0)return Promise.resolve(void 0);const a=new D.CancellationTokenSource,c=n.checkExists(n.folders,t,a.token),d=setTimeout(async()=>{a.cancel(),n.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}a.dispose(),clearTimeout(d),i&&r(`workspaceContains:${t.join(",")}`)}function E(n,o,t,r){const a=n.get(T.IInstantiationService),c=n.get(m.ISearchService),i=a.createInstance(g.QueryBuilder).file(o.map(s=>(0,w.toWorkspaceFolder)(F.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,r).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=E}),define(Pe[38],Te([1,0,159,19,88,25,14,6,50,2,15,3,37,218,85,36,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s,l,h,b,f,C,O,v,_,y,M,V,$,L,U,k,P){"use strict";var Q;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let ae=Q=class extends g.Disposable{constructor(Y,H,ne,De,Re,ke,ce,ie,G,ee,pe,be){super(),this._extHostManagedSockets=be,this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=H,this._extHostContext=ne,this._initData=ce,this._extHostWorkspace=De,this._extHostConfiguration=Re,this._logService=ke,this._extHostTunnelService=G,this._extHostTerminalService=ee,this._extHostLocalizationService=pe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._activationEventsReader=new Ie(this._initData.extensions.activationEvents),this._globalRegistry=new t.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Le=new a.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new t.ExtensionDescriptionRegistry(this._activationEventsReader,de(this._globalRegistry,Le)),k.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Ce(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Ce(this._myRegistry)}`)),this._storage=new E.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=ie,this._instaService=Y.createChild(new C.ServiceCollection([E.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState])),this._activator=this._register(new p.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(ue,we,N)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ue,r.transformErrorForSerialization(we),N)},actualActivateExtension:async(ue,we)=>{if(t.ExtensionDescriptionRegistry.isHostExtension(ue,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(ue,we),new p.HostExtension;const N=this._myRegistry.getExtensionDescription(ue);return this._activateExtension(N,we)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Y){r.onUnexpectedError(Y)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Y=[];try{Y=this._myRegistry.getAllExtensionDescriptions().map(Re=>Re.identifier).filter(Re=>this.isActivated(Re)).map(Re=>this._deactivate(Re))}catch{}await Promise.all(Y)}terminate(Y,H=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Y}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),r.setUnexpectedErrorHandler(De=>{this._logService.error(De)}),this._extHostContext.dispose();const ne=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),ne]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${H}`):this._logService.info(`Extension host exiting with code ${H}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(H)})}isActivated(Y){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Y):!1}async getExtension(Y){const H=await this._mainThreadExtensionsProxy.$getExtension(Y);return H&&{...H,identifier:new a.ExtensionIdentifier(H.identifier.value),extensionLocation:w.URI.revive(H.extensionLocation)}}_activateByEvent(Y,H){return this._activator.activateByEvent(Y,H)}_activateById(Y,H){return this._activator.activateById(Y,H)}activateByIdWithErrors(Y,H){return this._activateById(Y,H).then(()=>{const ne=this._activator.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Y=>this._myRegistry)}getExtensionExports(Y){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(Y).exports;try{return this._activator.getActivatedExtension(Y).exports}catch{return null}}async _realPathExtensionUri(Y){if(Y.scheme===$.Schemas.file&&this._hostUtils.fsRealpath){const H=await this._hostUtils.fsRealpath(Y.fsPath);return w.URI.file(H)}return Y}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Y=>new te(Y))),this._extensionPathIndex}async _createExtensionPathIndex(Y){const H=m.TernarySearchTree.forUris(ne=>R.extUriBiasedIgnorePathCase.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this._getEntryPoint(ne)){const De=await this._realPathExtensionUri(ne.extensionLocation);H.set(De,ne)}})),H}_deactivate(Y){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Y))return H;const ne=this._activator.getActivatedExtension(Y);if(!ne)return H;try{typeof ne.module.deactivate=="function"&&(H=Promise.resolve(ne.module.deactivate()).then(void 0,De=>(this._logService.error(De),Promise.resolve(void 0))))}catch(De){this._logService.error(`An error occurred when deactivating the extension '${Y.value}':`),this._logService.error(De)}try{(0,g.dispose)(ne.subscriptions)}catch(De){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this._logService.error(De)}return H}async _activateExtension(Y,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier),this._doActivateExtension(Y,H).then(ne=>{const De=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Y.identifier,De.codeLoadingTime,De.activateCallTime,De.activateResolvedTime,H),this._logExtensionActivationTimes(Y,H,"success",De),ne},ne=>{throw this._logExtensionActivationTimes(Y,H,"failure"),ne})}_logExtensionActivationTimes(Y,H,ne,De){const Re=Ee(Y,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Re,...De||{},outcome:ne})}_doActivateExtension(Y,H){const ne=Ee(Y,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const De=this._getEntryPoint(Y);if(!De)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${Y.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const Re=new p.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(Y,(0,R.joinPath)(Y.extensionLocation,De),Re),this._loadExtensionContext(Y)]).then(ke=>(D.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Q._callActivate(this._logService,Y.identifier,ke[0],ke[1],Re))).then(ke=>(D.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),ke))}_loadExtensionContext(Y){const H=new d.ExtensionGlobalMemento(Y,this._storage),ne=new d.ExtensionMemento(Y.identifier.value,!1,this._storage),De=new V.ExtensionSecrets(Y,this._secretState),Re=Y.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ke=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([H.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ce=this;let ie,G;const ee=(0,o.isProposedApiEnabled)(Y,"ipc")?this._initData.messagePorts?.get(a.ExtensionIdentifier.toKey(Y.identifier)):void 0;return Object.freeze({globalState:H,workspaceState:ne,secrets:De,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(pe){return F.join(Y.extensionLocation.fsPath,pe)},get storagePath(){return ce._storagePath.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ce._storagePath.globalValue(Y).fsPath},get logPath(){return F.join(ce._initData.logsLocation.fsPath,Y.identifier.value)},get logUri(){return w.URI.joinPath(ce._initData.logsLocation,Y.identifier.value)},get storageUri(){return ce._storagePath.workspaceValue(Y)},get globalStorageUri(){return ce._storagePath.globalValue(Y)},get extensionMode(){return Re},get extension(){return ie===void 0&&(ie=new he(ce,Y.identifier,Y,ke,!1)),ie},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(Y,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce._extHostTerminalService.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!G){if(!ee)return;const pe=_.Event.buffer(_.Event.fromDOMEventEmitter(ee,"message",be=>be.data));ee.start(),G={onDidReceiveMessage:pe,postMessage:ee.postMessage.bind(ee)}}return G}})})}static _callActivate(Y,H,ne,De,Re){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(Y,H,ne,De,Re).then(ke=>new p.ActivatedExtension(!1,null,Re.build(),ne,ke,De.subscriptions))}static _callActivateOptional(Y,H,ne,De,Re){if(typeof ne.activate=="function")try{Re.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${H.value}`);const ke=typeof global=="object"?global:self,ce=ne.activate.apply(ke,[De]);return Re.activateCallStop(),Re.activateResolveStart(),Promise.resolve(ce).then(ie=>(Re.activateResolveStop(),ie))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(ne)}_activateOneStartupFinished(Y,H){this._activateById(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:H}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinishedDeferred(Y,H=0){const De=Date.now();(0,k.setTimeout0)(()=>{for(let Re=H;Re<Y.length;Re+=1){const ke=Y[Re];for(const ce of ke.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-De>50){this._activateAllStartupFinishedDeferred(Y,Re);break}else this._activateOneStartupFinished(ke,ce)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks()),this._extHostConfiguration.getConfigProvider().then(Y=>{const H=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this._myRegistry.getAllExtensionDescriptions();if(H)this._activateAllStartupFinishedDeferred(ne);else for(const De of ne)if(De.activationEvents)for(const Re of De.activationEvents)Re==="onStartupFinished"&&this._activateOneStartupFinished(De,Re)})}_handleEagerExtensions(){const Y=this._activateByEvent("*",!0).then(void 0,ke=>{this._logService.error(ke)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ke=>this._handleWorkspaceContainsEagerExtensions(ke.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(H),De=this._handleRemoteResolverEagerExtensions(),Re=Promise.all([De,Y,ne]).then(()=>{});return Promise.race([Re,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Re}_handleWorkspaceContainsEagerExtensions(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(Y,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Y,H){if(this.isActivated(H.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,De={logService:this._logService,folders:Y.map(ke=>ke.uri),forceUsingSearch:ne||!this._hostUtils.fsExists,exists:ke=>this._hostUtils.fsExists(ke.fsPath),checkExists:(ke,ce,ie)=>this._mainThreadWorkspaceProxy.$checkExists(ke,ce,ie)},Re=await(0,y.checkActivateWorkspaceContainsExtension)(De,H);if(Re)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:Re.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Y){throw console.error(Y),Y}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:H}=this._initData.environment;if(!Y||!H)throw new Error(S.localize(0,null));const ne=await this._loadCommonJSModule(null,H,new p.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(1,null,H.toString()));return new Promise((De,Re)=>{const ke=(G,ee)=>{G?(k.isCI&&this._logService.error("Test runner called back with error",G),Re(G)):(k.isCI&&(ee?this._logService.info(`Test runner called back with ${ee} failures.`):this._logService.info("Test runner called back with successful outcome.")),De(typeof ee=="number"&&ee>0?1:0))},ce=(0,R.originalFSPath)(H),ie=ne.run(ce,ke);ie&&ie.then&&ie.then(()=>{k.isCI&&this._logService.info("Test runner finished successfully."),De(0)}).catch(G=>{k.isCI&&this._logService.error("Test runner finished with error",G),Re(G instanceof Error&&G.stack?G.stack:String(G))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,T.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,H){return this._resolvers[Y]=H,(0,g.toDisposable)(()=>{delete this._resolvers[Y]})}async getRemoteExecServer(Y){const{resolver:H}=await this._activateAndGetResolver(Y);return H?.resolveExecServer?.(Y,{resolveAttempt:0})}async _activateAndGetResolver(Y){const H=Y.indexOf("+");if(H===-1)throw new i.RemoteAuthorityResolverError("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(Y,H){const ne=U.StopWatch.create(!1),De=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(Y)},${H})][${ne.elapsed()}ms] `,Re=q=>this._logService.info(`${De()}${q}`),ke=q=>this._logService.warn(`${De()}${q}`),ce=(q,B=void 0)=>this._logService.error(`${De()}${q}`,B),ie=q=>{if(q instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},G=async q=>{Re(`activating resolver for ${q}...`);const{resolver:B,authorityPrefix:K}=await this._activateAndGetResolver(q);if(!B)throw ce(`no resolver for ${K}`),new i.RemoteAuthorityResolverError(`No remote extension installed to resolve ${K}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:B,authorityPrefix:K,remoteAuthority:q}},ee=Y.split(/@|%40/g).reverse();Re(`activating remote resolvers ${ee.join(" -> ")}`);let pe;try{pe=await Promise.all(ee.map(G)).catch(async q=>{if(!(q instanceof i.RemoteAuthorityResolverError)||q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return ke(`resolving nested authorities failed: ${q.message}`),[await G(Y)]})}catch(q){return ie(q)}const be=new T.IntervalTimer;be.cancelAndSet(()=>Re("waiting..."),1e3);let Le,ue;for(const[q,{authorityPrefix:B,resolver:K,remoteAuthority:Z}]of pe.entries())try{if(q===pe.length-1)Re("invoking final resolve()..."),D.mark(`code/extHost/willResolveAuthority/${B}`),Le=await K.resolve(Z,{resolveAttempt:H,execServer:ue}),D.mark(`code/extHost/didResolveAuthorityOK/${B}`),Re("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(K,i.ManagedResolvedAuthority.isManagedResolvedAuthority(Le)?Le:void 0));else{if(Re(`invoking resolveExecServer() for ${Z}`),D.mark(`code/extHost/willResolveExecServer/${B}`),ue=await K.resolveExecServer?.(Z,{resolveAttempt:H,execServer:ue}),!ue)throw new i.RemoteAuthorityResolverError(`Exec server was not available for ${Z}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);D.mark(`code/extHost/didResolveExecServerOK/${B}`)}}catch(_e){return D.mark(`code/extHost/didResolveAuthorityError/${B}`),ce("returned an error",_e),be.dispose(),ie(_e)}be.dispose();const we={environmentTunnels:Le.environmentTunnels,features:Le.tunnelFeatures},N={extensionHostEnv:Le.extensionHostEnv,isTrusted:Le.isTrusted,authenticationSession:Le.authenticationSessionForInitializingExtensions?{id:Le.authenticationSessionForInitializingExtensions.id,providerId:Le.authenticationSessionForInitializingExtensions.providerId}:void 0};Re(`returned ${i.ManagedResolvedAuthority.isManagedResolvedAuthority(Le)?"managed authority":`${Le.host}:${Le.port}`}`);let W;if(i.ManagedResolvedAuthority.isManagedResolvedAuthority(Le)){const q=H;this._extHostManagedSockets.setFactory(q,Le.makeConnection),W={authority:Y,connectTo:new s.ManagedRemoteConnection(q),connectionToken:Le.connectionToken}}else W={authority:Y,connectTo:new s.WebSocketRemoteConnection(Le.host,Le.port),connectionToken:Le.connectionToken};return{type:"ok",value:{authority:W,options:N,tunnelInformation:we}}}async $getCanonicalURI(Y,H){this._logService.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(Y)})`);const{resolver:ne}=await this._activateAndGetResolver(Y);if(!ne)return null;const De=w.URI.revive(H);if(typeof ne.getCanonicalURI>"u")return De;const Re=await(0,T.asPromise)(()=>ne.getCanonicalURI(De));return Re||De}$startExtensionHost(Y){Y.toAdd.forEach(De=>De.extensionLocation=w.URI.revive(De.extensionLocation));const{globalRegistry:H,myExtensions:ne}=me(this._activationEventsReader,this._globalRegistry,this._myRegistry,Y);return this._globalRegistry.set(H.getAllExtensionDescriptions()),this._myRegistry.set(ne),k.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Ce(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Ce(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(Y,H){return H===1?this._almostReadyToRunExtensions.wait().then(ne=>this._activateByEvent(Y,!1)):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(Y,!1))}async $activate(Y,H){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Y)?(await this._activateById(Y,H),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ke=>ke.extensionLocation=w.URI.revive(ke.extensionLocation));const{globalRegistry:H,myExtensions:ne}=me(this._activationEventsReader,this._globalRegistry,this._myRegistry,Y),De=await this._createExtensionPathIndex(ne);return(await this.getExtensionPathIndex()).setSearchTree(De),this._globalRegistry.set(H.getAllExtensionDescriptions()),this._myRegistry.set(ne),k.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Ce(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Ce(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const H=c.VSBuffer.alloc(Y),ne=Math.random()%256;for(let De=0;De<Y;De++)H.writeUInt8(ne,De);return H}async $updateRemoteConnectionData(Y){this._remoteConnectionData=Y,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ae,e.AbstractExtHostExtensionService=ae=Q=je([Ve(0,l.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,f.IExtHostRpcService),Ve(3,n.IExtHostWorkspace),Ve(4,u.IExtHostConfiguration),Ve(5,A.ILogService),Ve(6,h.IExtHostInitDataService),Ve(7,b.IExtensionStoragePaths),Ve(8,O.IExtHostTunnelService),Ve(9,v.IExtHostTerminalService),Ve(10,L.IExtHostLocalizationService),Ve(11,P.IExtHostManagedSockets)],ae);function me(oe,Y,H,ne){oe.addActivationEvents(ne.addActivationEvents);const De=new t.ExtensionDescriptionRegistry(oe,Y.getAllExtensionDescriptions());De.deltaExtensions(ne.toAdd,ne.toRemove);const Re=new a.ExtensionIdentifierSet(H.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)Re.delete(ce);for(const ce of ne.myToAdd)Re.add(ce);const ke=de(De,Re);return{globalRegistry:De,myExtensions:ke}}function Ee(oe,Y){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function Ce(oe){return oe.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class he{#e;#t;#i;constructor(Y,H,ne,De,Re){this.#e=Y,this.#t=H,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=F.normalize((0,R.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=De,this.isFromDifferentExtensionHost=Re}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=he;function de(oe,Y){return oe.getAllExtensionDescriptions().filter(H=>Y.has(H.identifier))}class te{constructor(Y){this._searchTree=Y}setSearchTree(Y){this._searchTree=Y}findSubstr(Y){return this._searchTree.findSubstr(Y)}forEach(Y){return this._searchTree.forEach(Y)}}e.ExtensionPaths=te;class Ie{constructor(Y){this._map=new a.ExtensionIdentifierMap,this.addActivationEvents(Y)}readActivationEvents(Y){return this._map.get(Y.identifier)??[]}addActivationEvents(Y){for(const H of Object.keys(Y))this._map.set(H,Y[H])}}}),define(Pe[287],Te([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(c,d,i,s,l,h,b){this._apiFactory=c,this._extensionRegistry=d,this._instaService=i,this._extHostConfiguration=s,this._extHostExtensionService=l,this._initData=h,this._logService=b,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),S.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new t(this._apiFactory,d,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(r,d,this._initData.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const d of c.nodeModuleName)this._factories.set(d,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(d=>c.alternativeModuleName(d))}};e.RequireInterceptor=n,e.RequireInterceptor=n=je([Ve(2,A.IInstantiationService),Ve(3,R.IExtHostConfiguration),Ve(4,I.IExtHostExtensionService),Ve(5,w.IExtHostInitDataService),Ve(6,u.ILogService)],n);let o=class{static{E=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&E.aliased.size){const d=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${d}/${l}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.re)return;const d=this.re.exec(this.forceForwardSlashes(c));if(!d)return;const[,i,s,l]=d,h=E.aliased.get(s);if(h!==void 0)return console.warn(`${s} as been renamed to ${h}, please update your imports`),i+h+l}forceForwardSlashes(c){return c.replace(/\\/g,"/")}};o=E=je([Ve(0,w.IExtHostInitDataService)],o);class t{constructor(c,d,i,s,l){this._apiFactory=c,this._extensionPaths=d,this._extensionRegistry=i,this._configProvider=s,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new g.ExtensionIdentifierMap}load(c,d){const i=this._extensionPaths.findSubstr(d);if(i){let s=this._extApiImpl.get(i.identifier);return s||(s=this._apiFactory(i,this._extensionRegistry,this._configProvider),this._extApiImpl.set(i.identifier,s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((l,h)=>s+=`	${h} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let r=class{constructor(c,d,i){this._extensionPaths=c,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=i.getProxy(D.MainContext.MainThreadTelemetry);const s=i.getProxy(D.MainContext.MainThreadWindow);this._impl=(l,h)=>{const b=F.URI.parse(l);return h?this.callOriginal(l,h):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,l,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this._appUriScheme?s.$openUri(b,l,{}):this.callOriginal(l,h)}}load(c,d,i){const s=this._extensionPaths.findSubstr(d);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=i(c),this._impl}callOriginal(c,d){return this.sendNoForwardTelemetry(),this._original(c,d)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};r=je([Ve(2,m.IExtHostRpcService)],r)}),define(Pe[116],Te([1,0,39,6,19,74,4,61,62,38,7,36,215,37]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class E extends u.AbstractVariableResolverService{constructor(t,r,a,c,d,i,s){function l(){if(a){const h=a.activeEditor();if(h)return h.document.uri;const b=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof A.TextDiffTabInput||b.input instanceof A.NotebookDiffEditorTabInput)return b.input.modified;if(b.input instanceof A.TextTabInput||b.input instanceof A.NotebookEditorTabInput||b.input instanceof A.CustomEditorTabInput)return b.input.uri}}}super({getFolderUri:h=>{const b=i.folders.filter(f=>f.name===h);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(h,b)=>d.getConfiguration(void 0,h).get(b),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=l();if(h)return D.normalize(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const h=l();if(h){const b=r.getWorkspaceFolder(h);if(b)return D.normalize(b.uri.fsPath)}}},getSelectedText:()=>{if(a){const h=a.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(a){const h=a.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>t.getExtension(h)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let n=class extends F.Disposable{constructor(t,r,a,c,d){super(),this.extensionService=t,this.workspaceService=r,this.editorService=a,this.configurationService=c,this.editorTabs=d,this._resolver=new S.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),l={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async h=>{l.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,l,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=n,e.ExtHostVariableResolverProviderService=n=je([Ve(0,w.IExtHostExtensionService),Ve(1,I.IExtHostWorkspace),Ve(2,g.IExtHostDocumentsAndEditors),Ve(3,p.IExtHostConfiguration),Ve(4,m.IExtHostEditorTabs)],n)}),define(Pe[117],Te([1,0,14,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,l,h,b,f,C){this._workspaceService=l,this._extensionService=h,this._configurationService=b,this._editorTabs=f,this._variableResolver=C,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new F.Emitter,this._onDidTerminateDebugSession=new F.Emitter,this._onDidChangeActiveDebugSession=new F.Emitter,this._onDidReceiveDebugSessionCustomEvent=new F.Emitter,this._debugServiceProxy=s.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new F.Emitter,this._onDidChangeStackFrameFocus=new F.Emitter,this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(v=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}asDebugSourceUri(s,l){const h=s;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let b=`debug:${encodeURIComponent(h.path||"")}`,f="?";return l&&(b+=`${f}session=${encodeURIComponent(l.id)}`,f="&"),b+=`${f}ref=${h.sourceReference}`,D.URI.parse(b)}else{if(h.path)return D.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const l=[];for(const h of s.getAllExtensionDescriptions())if(h.contributes){const b=h.contributes.debuggers;if(b&&b.length>0)for(const f of b)(0,p.isDebuggerMainContribution)(f)&&l.push(f.type)}this._debugServiceProxy.$registerDebugTypes(l)}get stackFrameFocus(){return this._stackFrameFocus}get onDidChangeStackFrameFocus(){return this._onDidChangeStackFrameFocus.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const s=[];return this._breakpoints.forEach(l=>s.push(l)),s}addBreakpoints(s){const l=s.filter(f=>{const C=f.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,f),!0)});this.fireBreakpointChanges(l,[],[]);const h=[],b=new Map;for(const f of l)if(f instanceof A.SourceBreakpoint){let C=b.get(f.location.uri.toString());C||(C={type:"sourceMulti",uri:f.location.uri,lines:[]},b.set(f.location.uri.toString(),C),h.push(C)),C.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.FunctionBreakpoint&&h.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(s){const l=s.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],l,[]);const h=l.filter(C=>C instanceof A.SourceBreakpoint).map(C=>C.id),b=l.filter(C=>C instanceof A.FunctionBreakpoint).map(C=>C.id),f=l.filter(C=>C instanceof A.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(h,b,f)}startDebugging(s,l,h){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,l,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,l,h){if(!l)return new A.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:b,provider:l}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,h,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,b),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(f=>f.provider!==l),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(s,l,h){if(!h)return new A.Disposable(()=>{});if(!this.definesDebugType(s,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.getAdapterDescriptorFactoryByType(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:l,handle:b,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(l,b),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(f=>f.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(s,l){if(!l)return new A.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:h,factory:l}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==l)})}async $runInTerminal(s,l){return Promise.resolve(void 0)}async $substituteVariables(s,l){let h;const b=await this.getFolder(s);return b&&(h={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(h,l)}createDebugAdapter(s,l){if(s.type==="implementation")return new c(s.implementation)}createSignService(){}async $startDASession(s,l){const h=this,b=await this.getSession(l);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const C=this.convertToDto(f),O=this.createDebugAdapter(C,b);if(!O)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const v=O;return this._debugAdapters.set(s,v),this.getDebugAdapterTrackers(b).then(_=>(_&&this._debugAdaptersTrackers.set(s,_),v.onMessage(async y=>{if(y.type==="request"&&y.command==="handshake"){const M=y,V={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(M.arguments.value);V.body={signature:$},v.sendResponse(V)}else throw new Error("no signer")}catch($){V.success=!1,V.message=$.message,v.sendResponse(V)}}else _&&_.onDidSendMessage&&_.onDidSendMessage(y),y=(0,p.convertToVSCPaths)(y,!0),h._debugServiceProxy.$acceptDAMessage(s,y)}),v.onError(y=>{_&&_.onError&&_.onError(y),this._debugServiceProxy.$acceptDAError(s,y.name,y.message,y.stack)}),v.onExit(y=>{_&&_.onExit&&_.onExit(y??void 0,void 0),this._debugServiceProxy.$acceptDAExit(s,y??void 0,void 0)}),_&&_.onWillStartSession&&_.onWillStartSession(),v.startSession()))})}$sendDAMessage(s,l){l=(0,p.convertToDAPaths)(l,!1);const h=this._debugAdaptersTrackers.get(s);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(l),this._debugAdapters.get(s)?.sendMessage(l)}$stopDASession(s){const l=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),l&&l.onWillStopSession&&l.onWillStopSession();const h=this._debugAdapters.get(s);return this._debugAdapters.delete(s),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const l=[],h=[],b=[];if(s.added)for(const f of s.added){const C=f.id;if(C&&!this._breakpoints.has(C)){let O;if(f.type==="function")O=new A.FunctionBreakpoint(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")O=new A.DataBreakpoint(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const v=D.URI.revive(f.uri);O=new A.SourceBreakpoint(new A.Location(v,new A.Position(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.setBreakpointId)(O,C),this._breakpoints.set(C,O),l.push(O)}}if(s.removed)for(const f of s.removed){const C=this._breakpoints.get(f);C&&(this._breakpoints.delete(f),h.push(C))}if(s.changed){for(const f of s.changed)if(f.id){const C=this._breakpoints.get(f.id);if(C){if(C instanceof A.FunctionBreakpoint&&f.type==="function"){const O=C;O.enabled=f.enabled,O.condition=f.condition,O.hitCondition=f.hitCondition,O.logMessage=f.logMessage,O.functionName=f.functionName}else if(C instanceof A.SourceBreakpoint&&f.type==="source"){const O=C;O.enabled=f.enabled,O.condition=f.condition,O.hitCondition=f.hitCondition,O.logMessage=f.logMessage,O.location=new A.Location(D.URI.revive(f.uri),new A.Position(f.line,f.character))}b.push(C)}}}this.fireBreakpointChanges(l,h,b)}async $acceptStackFrameFocus(s){let l;const h=s.sessionId?await this.getSession(s.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?l=new A.ThreadFocus(h,s.threadId):l=new A.StackFrameFocus(h,s.threadId,s.frameId),this._stackFrameFocus=l,this._onDidChangeStackFrameFocus.fire(this._stackFrameFocus)}$provideDebugConfigurations(s,l,h){return(0,S.asPromise)(async()=>{const b=this.getConfigProviderByHandle(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.getFolder(l);return b.provideDebugConfigurations(f,h)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(s,l,h,b){return(0,S.asPromise)(async()=>{const f=this.getConfigProviderByHandle(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(l);return f.resolveDebugConfiguration(C,h,b)})}$resolveDebugConfigurationWithSubstitutedVariables(s,l,h,b){return(0,S.asPromise)(async()=>{const f=this.getConfigProviderByHandle(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(l);return f.resolveDebugConfigurationWithSubstitutedVariables(C,h,b)})}async $provideDebugAdapter(s,l){const h=this.getAdapterDescriptorFactoryByHandle(s);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(l);return this.getAdapterDescriptor(h,b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(f)})}async $acceptDebugSessionStarted(s){const l=await this.getSession(s);this._onDidStartDebugSession.fire(l)}async $acceptDebugSessionTerminated(s){const l=await this.getSession(s);l&&(this._onDidTerminateDebugSession.fire(l),this._debugSessions.delete(l.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,l){(await this.getSession(s))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(s,l){const b={session:await this.getSession(s),event:l.event,body:l.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(s){if(s instanceof A.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const l=this._adapterFactories.filter(h=>h.type===s);if(l.length>0)return l[0].factory}getAdapterDescriptorFactoryByHandle(s){const l=this._adapterFactories.filter(h=>h.handle===s);if(l.length>0)return l[0].factory}getConfigProviderByHandle(s){const l=this._configProviders.filter(h=>h.handle===s);if(l.length>0)return l[0].provider}definesDebugType(s,l){if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0){for(const b of h)if(b.label&&b.type&&b.type===l)return!0}}return!1}getDebugAdapterTrackers(s){const h=s.configuration.type,b=this._trackerFactories.filter(f=>f.type===h||f.type==="*").map(f=>(0,S.asPromise)(()=>f.factory.createDebugAdapterTracker(s)).then(C=>C,C=>null));return Promise.race([Promise.all(b).then(f=>{const C=f.filter(O=>!!O);if(C.length>0)return new a(C)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async getAdapterDescriptor(s,l){const h=l.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.DebugAdapterServer(h));if(s){const f=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>s.createDebugAdapterDescriptor(l,this.daExecutableFromPackage(l,f))).then(C=>{if(C)return C})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(l,b))}daExecutableFromPackage(s,l){}fireBreakpointChanges(s,l,h){(s.length>0||l.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:l,changed:h}))}async getSession(s){if(s)if(typeof s=="string"){const l=this._debugSessions.get(s);if(l)return l}else{let l=this._debugSessions.get(s.id);if(!l){const h=await this.getFolder(s.folderUri),b=s.parent?this._debugSessions.get(s.parent):void 0;l=new t(this._debugServiceProxy,s.id,s.type,s.name,h,s.configuration,b),this._debugSessions.set(l.id,l),this._debugServiceProxy.$sessionCached(l.id)}return l}throw new Error("cannot find session")}getFolder(s){if(s){const l=D.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=o,e.ExtHostDebugServiceBase=o=je([Ve(0,w.IExtHostRpcService),Ve(1,I.IExtHostWorkspace),Ve(2,m.IExtHostExtensionService),Ve(3,E.IExtHostConfiguration),Ve(4,g.IExtHostEditorTabs),Ve(5,n.IExtHostVariableResolverProvider)],o);class t{constructor(s,l,h,b,f,C,O){this._debugServiceProxy=s,this._id=l,this._type=h,this._name=b,this._workspaceFolder=f,this._configuration=C,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,l){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,l)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=t;class r{constructor(s){this.value=Object.freeze({append(l){s.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=r;class a{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(l=>l.onError?l.onError(s):void 0)}onExit(s,l){this.trackers.forEach(h=>h.onExit?h.onExit(s,l):void 0)}}class c extends u.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let d=class extends o{constructor(s,l,h,b,f,C){super(s,l,h,b,f,C)}};e.WorkerExtHostDebugService=d,e.WorkerExtHostDebugService=d=je([Ve(0,w.IExtHostRpcService),Ve(1,I.IExtHostWorkspace),Ve(2,m.IExtHostExtensionService),Ve(3,E.IExtHostConfiguration),Ve(4,g.IExtHostEditorTabs),Ve(5,n.IExtHostVariableResolverProvider)],d)}),define(Pe[288],Te([1,0,11,88,2,3,276,15,70,71,27,185,17,57,38,59]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get(g.ILogService),i=a.get(u.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(s=>{c.error(s);const l=S.transformErrorForSerialization(s);i.$onUnexpectedError(l)})}static async installFullHandler(a){const c=a.get(g.ILogService),d=a.get(u.IExtHostRpcService),i=a.get(E.IExtHostExtensionService),s=a.get(n.IExtHostTelemetry),l=d.getProxy(R.MainContext.MainThreadExtensionService),h=d.getProxy(R.MainContext.MainThreadErrors),b=await i.getExtensionPathIndex(),f=new WeakMap;function C(_,y){if(f.has(_))return f.get(_).stack;let M="",V,$;for(const U of y)M+=`
	at ${U.toString()}`,$=U.getFileName(),!V&&$&&(V=b.findSubstr(D.URI.file($)));const L=`${_.name||"Error"}: ${_.message||""}${M}`;return f.set(_,{extensionIdentifier:V?.identifier,stack:L}),L}const O=Symbol("prepareStackTrace wrapped");let v=C;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(_){if(_===C||!_||_[O]){v=_||C;return}v=function(y,M){return C(y,M),_.call(Error,y,M)},Object.assign(v,{[O]:!0})}}),S.setUnexpectedErrorHandler(_=>{c.error(_);const y=S.transformErrorForSerialization(_),M=f.get(_);if(!M?.extensionIdentifier){h.$onUnexpectedError(y);return}l.$onExtensionRuntimeError(M.extensionIdentifier,y);const V=s.onExtensionError(M.extensionIdentifier,_);c.trace("forwarded error to extension?",V,M)})}}e.ErrorHandler=o;class t{constructor(a,c,d,i,s){this._hostUtils=d,this._rpcProtocol=new T.RPCProtocol(a,null,i),c=t._transform(c,this._rpcProtocol);const l=new w.ServiceCollection(...(0,m.getSingletonServiceDescriptors)());l.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...c,messagePorts:s}),l.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),l.set(p.IURITransformerService,new p.URITransformerService(i)),l.set(E.IHostUtils,d);const h=new I.InstantiationService(l,!0);h.invokeFunction(o.installEarlyHandler),this._logService=h.invokeFunction(b=>b.get(g.ILogService)),F.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",c),this._extensionService=h.invokeFunction(b=>b.get(E.IExtHostExtensionService)),this._extensionService.initialize(),h.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService);return D.URI.revive(await c.$asBrowserUri(a))}terminate(a){this._extensionService.terminate(a)}static _transform(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=D.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=D.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const d=a.environment.extensionDevelopmentLocationURI;return d&&(a.environment.extensionDevelopmentLocationURI=d.map(i=>D.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=D.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=D.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=D.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=D.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=D.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=D.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=t}),define(Pe[289],Te([1,0,18,14,20,40,13,19,25,2,44]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(r,a,c,d){this.query=r,this.provider=a,this.fileUtils=c,this.processType=d,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(r,a){const c=this.query.folderQueries||[],d=new D.CancellationTokenSource(a);return new Promise((i,s)=>{this.collector=new p(r);let l=!1;const h=(b,f)=>{if(!l&&!this.isLimitHit){const C=this.resultSize(b);n(b)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,l=!0,d.cancel(),b=this.trimResultToSize(b,this.query.maxResults-this.resultCount));const O=this.resultSize(b);this.resultCount+=O,(O>0||!n(b))&&this.collector.add(b,f)}};Promise.all(c.map((b,f)=>this.searchInFolder(b,C=>h(C,f),d.token))).then(b=>{d.dispose(),this.collector.flush();const f=b.some(C=>!!C&&!!C.limitHit);i({limitHit:this.isLimitHit||f,messages:(0,S.flatten)(b.map(C=>C?.message?Array.isArray(C.message)?C.message:[C.message]:[])),stats:{type:this.processType}})},b=>{d.dispose();const f=(0,R.toErrorMessage)(b);s(new Error(f))})})}resultSize(r){return n(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}trimResultToSize(r,a){const c=Array.isArray(r.ranges)?r.ranges:[r.ranges],d=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:c.slice(0,a),preview:{matches:d.slice(0,a),text:r.preview.text},uri:r.uri}}async searchInFolder(r,a,c){const d=new A.QueryGlobTester(this.query,r),i=[],s={report:b=>{if(!this.validateProviderResult(b))return;const f=r.folder.scheme===T.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(m.dirname(b.uri))):void 0,C=m.relativePath(r.folder,b.uri);if(C){const O=d.includedInQuery(C,g.basename(C),f);(0,F.isThenable)(O)?i.push(O.then(v=>{v&&a(b)})):O&&a(b)}}},l=this.getSearchOptionsForFolder(r),h=await this.provider.provideTextSearchResults(u(this.query.contentPattern),l,s,c);return i.length&&await Promise.all(i),h}validateProviderResult(r){if(n(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(r){const a=(0,A.resolvePatternsForProvider)(this.query.includePattern,r.includePattern),c=(0,A.resolvePatternsForProvider)(this.query.excludePattern,r.excludePattern),d={folder:w.URI.from(r.folder),excludes:c,includes:a,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.fileUtils.toCanonicalName(r.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return d.usePCRE2=this.query.usePCRE2,d}}e.TextSearchManager=I;function u(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(r){this._onResult=r,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,a=>this.sendItems(a))}add(r,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!m.isEqual(this._currentUri,r.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:r.uri,results:[]}),this._currentFileMatch.results.push(E(r))}pushToCollector(){const r=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,r)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(r){this._onResult(r)}}e.TextSearchResultsCollector=p;function E(t){return n(t)?{preview:{matches:(0,S.mapArrayOrNot)(t.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:t.preview.text},ranges:(0,S.mapArrayOrNot)(t.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function n(t){return!!t.preview}e.extensionResultIsMatch=n;class o{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(r,a){this.maxBatchSize=r,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(r,a){r&&this.addItemToBatch(r,a)}addItems(r,a){r&&this.addItemsToBatch(r,a)}addItemToBatch(r,a){this.batch.push(r),this.batchSize+=a,this.onUpdate()}addItemsToBatch(r,a){this.batch=this.batch.concat(r),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=o}),define(Pe[118],Te([1,0,6,3,4,284,17,57,15,2,289]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(n,o,t){this.extHostRpc=n,this._uriTransformer=o,this._logService=t,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(n){return this._uriTransformer.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this._textSearchUsedSchemes.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this._textSearchUsedSchemes.add(n);const t=this._handlePool++;return this._textSearchProvider.set(t,o),this._proxy.$registerTextSearchProvider(t,this._transformScheme(n)),(0,S.toDisposable)(()=>{this._textSearchUsedSchemes.delete(n),this._textSearchProvider.delete(t),this._proxy.$unregisterProvider(t)})}registerFileSearchProvider(n,o){if(this._fileSearchUsedSchemes.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this._fileSearchUsedSchemes.add(n);const t=this._handlePool++;return this._fileSearchProvider.set(t,o),this._proxy.$registerFileSearchProvider(t,this._transformScheme(n)),(0,S.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(n),this._fileSearchProvider.delete(t),this._proxy.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,r){const a=u(t),c=this._fileSearchProvider.get(n);if(c)return this._fileSearchManager.fileSearch(a,c,d=>{this._proxy.$handleFileMatch(n,o,d.map(i=>i.resource))},r);throw new Error("unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,t){return{messages:[]}}$clearCache(n){return this._fileSearchManager.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,t,r){const a=this._textSearchProvider.get(n);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const c=u(t);return this.createTextSearchManager(c,a).search(i=>this._proxy.$handleTextMatch(n,o,i),r)}$enableExtensionHostSearch(){}createTextSearchManager(n,o){return new A.TextSearchManager(n,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.ExtHostSearch=I,e.ExtHostSearch=I=je([Ve(0,T.IExtHostRpcService),Ve(1,g.IURITransformerService),Ve(2,m.ILogService)],I);function u(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(p),extraFileResources:E.extraFileResources&&E.extraFileResources.map(n=>w.URI.revive(n))}}e.reviveQuery=u;function p(E){return{...E,folder:w.URI.revive(E.folder)}}}),define(Pe[290],Te([1,0,20,11,5,6,13,31,2,146,142,130,93,22,42,15,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,43,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s,l,h,b,f,C,O,v,_,y,M,V,$,L,U,k,P,Q,ae,me,Ee,Ce,he,de,te,Ie,oe,Y,H,ne,De,Re,ke,ce,ie,G,ee,pe,be,Le,ue,we,N,W,q,B,K,Z,_e,Fe,ze,qe,Qe,rt,it,et,ot,at,Ue,vt,X,J,ve,$e,Ge,tt,nt,Ne,Dt,Lt,Vt,Bt,wt,Wt,Ot,Gt,Mt,kt,Ye,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(lt){const gt=lt.get(Y.IExtHostInitDataService),xt=lt.get(oe.IExtHostFileSystemInfo),$t=lt.get(te.IExtHostConsumerFileSystem),St=lt.get(he.IExtHostExtensionService),dt=lt.get(Gt.IExtHostWorkspace),Pt=lt.get(Ue.IExtHostTelemetry),Yt=lt.get(M.IExtHostConfiguration),yt=lt.get(Lt.IURITransformerService),We=lt.get(_e.IExtHostRpcService),At=lt.get(et.IExtHostStorage),zt=lt.get(ot.IExtensionStoragePaths),Kt=lt.get(n.ILoggerService),ft=lt.get(n.ILogService),Rt=lt.get(tt.IExtHostTunnelService),Se=lt.get(i.IExtHostApiDeprecationService),Oe=lt.get(Ot.IExtHostWindow),fe=lt.get(qe.IExtHostSecretState),j=lt.get(Ee.IExtHostEditorTabs),Ae=lt.get(G.IExtHostManagedSockets);We.set(a.ExtHostContext.ExtHostFileSystemInfo,xt),We.set(a.ExtHostContext.ExtHostLogLevelServiceShape,Kt),We.set(a.ExtHostContext.ExtHostWorkspace,dt),We.set(a.ExtHostContext.ExtHostConfiguration,Yt),We.set(a.ExtHostContext.ExtHostExtensionService,St),We.set(a.ExtHostContext.ExtHostStorage,At),We.set(a.ExtHostContext.ExtHostTunnelService,Rt),We.set(a.ExtHostContext.ExtHostWindow,Oe),We.set(a.ExtHostContext.ExtHostSecretState,fe),We.set(a.ExtHostContext.ExtHostTelemetry,Pt),We.set(a.ExtHostContext.ExtHostEditorTabs,j),We.set(a.ExtHostContext.ExtHostManagedSockets,Ae);const Be=We.set(a.ExtHostContext.ExtHostDecorations,lt.get(L.IExtHostDecorations)),Xe=We.set(a.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(me.IExtHostDocumentsAndEditors)),He=We.set(a.ExtHostContext.ExtHostCommands,lt.get(_.IExtHostCommands)),Ze=We.set(a.ExtHostContext.ExtHostTerminalService,lt.get(vt.IExtHostTerminalService)),mt=We.set(a.ExtHostContext.ExtHostDebugService,lt.get($.IExtHostDebugService)),Ut=We.set(a.ExtHostContext.ExtHostSearch,lt.get(ze.IExtHostSearch)),_t=We.set(a.ExtHostContext.ExtHostTask,lt.get(at.IExtHostTask)),Ct=We.set(a.ExtHostContext.ExtHostOutputService,lt.get(W.IExtHostOutputService)),bt=We.set(a.ExtHostContext.ExtHostLocalization,lt.get(ie.IExtHostLocalizationService)),gi=We.set(a.ExtHostContext.ExtHostUrls,new Vt.ExtHostUrls(We)),Tt=We.set(a.ExtHostContext.ExtHostDocuments,new ae.ExtHostDocuments(We,Xe)),Ci=We.set(a.ExtHostContext.ExtHostDocumentContentProviders,new P.ExtHostDocumentContentProvider(We,Xe,ft)),Hi=We.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new Q.ExtHostDocumentSaveParticipant(ft,Tt,We.getProxy(a.MainContext.MainThreadBulkEdits))),It=We.set(a.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(We,He,Xe,Tt,$t,Ut)),ni=We.set(a.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(It)),pi=We.set(a.ExtHostContext.ExtHostNotebookEditors,new ue.ExtHostNotebookEditors(ft,It)),ai=We.set(a.ExtHostContext.ExtHostNotebookKernels,new we.ExtHostNotebookKernels(We,gt,It,He,ft)),Ii=We.set(a.ExtHostContext.ExtHostNotebookRenderers,new N.ExtHostNotebookRenderers(We,It)),Di=We.set(a.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new be.ExtHostNotebookDocumentSaveParticipant(ft,It,We.getProxy(a.MainContext.MainThreadBulkEdits))),Ft=We.set(a.ExtHostContext.ExtHostEditors,new J.ExtHostEditors(We,Xe)),vi=We.set(a.ExtHostContext.ExtHostTreeViews,new Ge.ExtHostTreeViews(We.getProxy(a.MainContext.MainThreadTreeViews),He,ft)),ki=We.set(a.ExtHostContext.ExtHostEditorInsets,new v.ExtHostEditorInsets(We.getProxy(a.MainContext.MainThreadEditorInsets),Ft,gt.remote)),ci=We.set(a.ExtHostContext.ExtHostDiagnostics,new U.ExtHostDiagnostics(We,ft,xt,Xe)),li=We.set(a.ExtHostContext.ExtHostLanguages,new ce.ExtHostLanguages(We,Tt,He.converter,yt)),ut=We.set(a.ExtHostContext.ExtHostLanguageFeatures,new ke.ExtHostLanguageFeatures(We,yt,Tt,He,ci,ft,Se,Pt)),Wi=We.set(a.ExtHostContext.ExtHostFileSystem,new de.ExtHostFileSystem(We,ut)),Jt=We.set(a.ExtHostContext.ExtHostFileSystemEventService,new Ie.ExtHostFileSystemEventService(We,ft,Xe)),ri=We.set(a.ExtHostContext.ExtHostQuickOpen,(0,Z.createExtHostQuickOpen)(We,dt,He)),hi=We.set(a.ExtHostContext.ExtHostSCM,new Fe.ExtHostSCM(We,He,Tt,ft)),Pi=We.set(a.ExtHostContext.ExtHostQuickDiff,new K.ExtHostQuickDiff(We,yt)),Vi=We.set(a.ExtHostContext.ExtHostShare,new Qe.ExtHostShare(We,yt)),Ti=We.set(a.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(We,He,Tt)),Ei=We.set(a.ExtHostContext.ExtHostProgress,new B.ExtHostProgress(We.getProxy(a.MainContext.MainThreadProgress))),qi=We.set(a.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService(We)),Ai=We.set(a.ExtHostContext.ExtHostTheming,new ve.ExtHostTheming(We)),ui=We.set(a.ExtHostContext.ExtHostAuthentication,new s.ExtHostAuthentication(We)),ji=We.set(a.ExtHostContext.ExtHostTimeline,new $e.ExtHostTimeline(We,He)),bi=We.set(a.ExtHostContext.ExtHostWebviews,new Bt.ExtHostWebviews(We,gt.remote,dt,ft,Se)),Ri=We.set(a.ExtHostContext.ExtHostWebviewPanels,new wt.ExtHostWebviewPanels(We,bi,dt)),cn=We.set(a.ExtHostContext.ExtHostCustomEditors,new V.ExtHostCustomEditors(We,Tt,zt,bi,Ri)),Li=We.set(a.ExtHostContext.ExtHostWebviewViews,new Wt.ExtHostWebviewViews(We,bi)),si=We.set(a.ExtHostContext.ExtHostTesting,new X.ExtHostTesting(We,He,Xe)),ln=We.set(a.ExtHostContext.ExtHostUriOpeners,new Dt.ExtHostUriOpeners(We)),un=We.set(a.ExtHostContext.ExtHostProfileContentHandlers,new q.ExtHostProfileContentHandlers(We));We.set(a.ExtHostContext.ExtHostInteractive,new ne.ExtHostInteractive(We,It,Xe,He,ft));const Ki=We.set(a.ExtHostContext.ExtHostInlineChat,new H.ExtHostInteractiveEditor(We,He,Tt,ft)),fi=We.set(a.ExtHostContext.ExtHostChatProvider,new f.ExtHostChatProvider(We,ft)),Gi=We.set(a.ExtHostContext.ExtHostChatAgents2,new b.ExtHostChatAgents2(We,fi,ft)),Xi=We.set(a.ExtHostContext.ExtHostChatVariables,new C.ExtHostChatVariables(We)),mi=We.set(a.ExtHostContext.ExtHostChat,new h.ExtHostChat(We)),Qi=We.set(a.ExtHostContext.ExtHostAiRelatedInformation,new c.ExtHostRelatedInformation(We)),Oi=We.set(a.ExtHostContext.ExtHostAiEmbeddingVector,new Ce.ExtHostAiEmbeddingVector(We)),Fi=We.set(a.ExtHostContext.ExtHostIssueReporter,new De.ExtHostIssueReporter(We)),Zt=We.set(a.ExtHostContext.ExtHostStatusBar,new it.ExtHostStatusBar(We,He.converter)),wi=We.set(a.ExtHostContext.ExtHostSpeech,new rt.ExtHostSpeech(We)),dn=Object.values(a.ExtHostContext);We.assertRegistered(dn);const Xt=new l.ExtHostBulkEdits(We,Xe),_i=new O.ExtHostClipboard(We),Si=new ee.ExtHostMessageService(We,ft),Ni=new k.ExtHostDialogs(We);return d.ExtHostApiCommands.register(He),function(xe,ei,Yi){const pt=function(){let re=!xe.isUnderDevelopment;function le(){re||(ft.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Me(st){if(Array.isArray(st))st.forEach(Me);else if(typeof st=="string")le();else{const Et=st;typeof Et.scheme>"u"&&le(),typeof Et.exclusive=="boolean"&&(0,Ye.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return st}}(),Ji={getSession(re,le,Me){return ui.getSession(xe,re,le,Me)},getSessions(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"authGetSessions"),ui.getSessions(xe,re,le)},async hasSession(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"authSession"),!!await ui.getSession(xe,re,le,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(re,le,Me,st){return ui.registerAuthenticationProvider(re,le,Me,st)}},hn={registerCommand(re,le,Me){return He.registerCommand(!0,re,le,Me,void 0,xe)},registerTextEditorCommand(re,le,Me){return He.registerCommand(!0,re,(...st)=>{const Et=Ft.getActiveTextEditor();if(!Et){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return Et.edit(Nt=>{le.apply(Me,[Et,Nt,...st])}).then(Nt=>{Nt||ft.warn("Edits from command "+re+" were not applied.")},Nt=>{ft.warn("An error occurred while running command "+re,Nt)})},void 0,void 0,xe)},registerDiffInformationCommand:(re,le,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"diffCommand"),He.registerCommand(!0,re,async(...st)=>{const Et=Xe.activeEditor(!0);if(!Et){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Nt=await Ft.getDiffInformation(Et.id);le.apply(Me,[Nt,...st])},void 0,void 0,xe)),executeCommand(re,...le){return He.executeCommand(re,...le)},getCommands(re=!1){return He.getCommands(re)}},Zi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return Ze.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(xe,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(xe,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ue.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,le){return Ue.ExtHostTelemetryLogger.validateSender(re),Pt.instantiateLogger(xe,re,le)},openExternal(re,le){return Oe.openUri(re,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===gt.environment.appUriScheme)return gi.createAppUri(re);try{return await Oe.asExternalUri(re,{allowTunneling:!!gt.remote.authority})}catch(le){if((0,T.matchesScheme)(re,T.Schemas.http)||(0,T.matchesScheme)(re,T.Schemas.https))return re;throw le}},get remoteName(){return(0,o.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ye.checkProposedApiEnabled)(xe,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,Ye.checkProposedApiEnabled)(xe,"handleIssueUri"),Fi.registerIssueUriRequestHandler(xe,re)},registerIssueDataProvider(re){return(0,Ye.checkProposedApiEnabled)(xe,"handleIssueUri"),Fi.registerIssueDataProvider(xe,re)},get appQuality(){return(0,Ye.checkProposedApiEnabled)(xe,"resolvers"),gt.quality},get appCommit(){return(0,Ye.checkProposedApiEnabled)(xe,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Zi);const en={createTestController(re,le,Me){return si.createTestController(xe,re,le,Me)},createTestObserver(){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),si.createTestObserver()},runTests(re){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),si.runTests(re)},get onDidChangeTestResults(){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),si.onResultsChanged},get testResults(){return(0,Ye.checkProposedApiEnabled)(xe,"testObserver"),si.results}},di=gt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,tn={getExtension(re,le){(0,Ye.isProposedApiEnabled)(xe,"extensionsAny")||(le=!1);const Me=ei.mine.getExtensionDescription(re);if(Me)return new he.Extension(St,xe.identifier,Me,di,!1);if(le){const st=ei.all.getExtensionDescription(re);if(st)return new he.Extension(St,xe.identifier,st,di,!0)}},get all(){const re=[];for(const le of ei.mine.getAllExtensionDescriptions())re.push(new he.Extension(St,xe.identifier,le,di,!1));return re},get allAcrossExtensionHosts(){(0,Ye.checkProposedApiEnabled)(xe,"extensionsAny");const re=new p.ExtensionIdentifierSet(ei.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),le=[];for(const Me of ei.all.getAllExtensionDescriptions()){const st=!re.has(Me.identifier);le.push(new he.Extension(St,xe.identifier,Me,di,st))}return le},get onDidChange(){return(0,Ye.isProposedApiEnabled)(xe,"extensionsAny")?D.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(re){return ci.createDiagnosticCollection(xe.identifier,re)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:re=>ci.getDiagnostics(re),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(re,le){return li.changeLanguage(re.uri,le)},match(re,le){const Me=Tt.getDocumentData(le.uri)?.notebook;return(0,A.score)(nt.LanguageSelector.from(re),le.uri,le.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(re,le,Me){return ut.registerCodeActionProvider(xe,pt(re),le,Me)},registerDocumentPasteEditProvider(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"documentPaste"),ut.registerDocumentPasteEditProvider(xe,pt(re),le,Me)},registerCodeLensProvider(re,le){return ut.registerCodeLensProvider(xe,pt(re),le)},registerDefinitionProvider(re,le){return ut.registerDefinitionProvider(xe,pt(re),le)},registerDeclarationProvider(re,le){return ut.registerDeclarationProvider(xe,pt(re),le)},registerImplementationProvider(re,le){return ut.registerImplementationProvider(xe,pt(re),le)},registerTypeDefinitionProvider(re,le){return ut.registerTypeDefinitionProvider(xe,pt(re),le)},registerHoverProvider(re,le){return ut.registerHoverProvider(xe,pt(re),le,xe.identifier)},registerEvaluatableExpressionProvider(re,le){return ut.registerEvaluatableExpressionProvider(xe,pt(re),le,xe.identifier)},registerInlineValuesProvider(re,le){return ut.registerInlineValuesProvider(xe,pt(re),le,xe.identifier)},registerDocumentHighlightProvider(re,le){return ut.registerDocumentHighlightProvider(xe,pt(re),le)},registerMultiDocumentHighlightProvider(re,le){return ut.registerMultiDocumentHighlightProvider(xe,pt(re),le)},registerLinkedEditingRangeProvider(re,le){return ut.registerLinkedEditingRangeProvider(xe,pt(re),le)},registerReferenceProvider(re,le){return ut.registerReferenceProvider(xe,pt(re),le)},registerRenameProvider(re,le){return ut.registerRenameProvider(xe,pt(re),le)},registerDocumentSymbolProvider(re,le,Me){return ut.registerDocumentSymbolProvider(xe,pt(re),le,Me)},registerWorkspaceSymbolProvider(re){return ut.registerWorkspaceSymbolProvider(xe,re)},registerDocumentFormattingEditProvider(re,le){return ut.registerDocumentFormattingEditProvider(xe,pt(re),le)},registerDocumentRangeFormattingEditProvider(re,le){return ut.registerDocumentRangeFormattingEditProvider(xe,pt(re),le)},registerOnTypeFormattingEditProvider(re,le,Me,...st){return ut.registerOnTypeFormattingEditProvider(xe,pt(re),le,[Me].concat(st))},registerDocumentSemanticTokensProvider(re,le,Me){return ut.registerDocumentSemanticTokensProvider(xe,pt(re),le,Me)},registerDocumentRangeSemanticTokensProvider(re,le,Me){return ut.registerDocumentRangeSemanticTokensProvider(xe,pt(re),le,Me)},registerSignatureHelpProvider(re,le,Me,...st){return typeof Me=="object"?ut.registerSignatureHelpProvider(xe,pt(re),le,Me):ut.registerSignatureHelpProvider(xe,pt(re),le,typeof Me>"u"?[]:[Me,...st])},registerCompletionItemProvider(re,le,...Me){return ut.registerCompletionItemProvider(xe,pt(re),le,Me)},registerInlineCompletionItemProvider(re,le,Me){return le.handleDidShowCompletionItem&&(0,Ye.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Ye.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),Me&&(0,Ye.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(xe,pt(re),le,Me)},registerDocumentLinkProvider(re,le){return ut.registerDocumentLinkProvider(xe,pt(re),le)},registerColorProvider(re,le){return ut.registerColorProvider(xe,pt(re),le)},registerFoldingRangeProvider(re,le){return ut.registerFoldingRangeProvider(xe,pt(re),le)},registerSelectionRangeProvider(re,le){return ut.registerSelectionRangeProvider(xe,re,le)},registerCallHierarchyProvider(re,le){return ut.registerCallHierarchyProvider(xe,re,le)},registerTypeHierarchyProvider(re,le){return ut.registerTypeHierarchyProvider(xe,re,le)},setLanguageConfiguration:(re,le)=>ut.setLanguageConfiguration(xe,re,le),getTokenInformationAtPosition(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"tokenInformation"),li.tokenAtPosition(re,le)},registerInlayHintsProvider(re,le){return ut.registerInlayHintsProvider(xe,re,le)},createLanguageStatusItem(re,le){return li.createLanguageStatusItem(xe,re,le)},registerDocumentDropEditProvider(re,le,Me){return ut.registerDocumentOnDropEditProvider(xe,re,le,(0,Ye.isProposedApiEnabled)(xe,"dropMetadata")?Me:void 0)}},rn={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(re,le,Me){const st=await(m.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Ft.showTextDocument(st,le,Me)},createTextEditorDecorationType(re){return Ft.createTextEditorDecorationType(xe,re)},onDidChangeActiveTextEditor(re,le,Me){return Ft.onDidChangeActiveTextEditor(re,le,Me)},onDidChangeVisibleTextEditors(re,le,Me){return Ft.onDidChangeVisibleTextEditors(re,le,Me)},onDidChangeTextEditorSelection(re,le,Me){return Ft.onDidChangeTextEditorSelection(re,le,Me)},onDidChangeTextEditorOptions(re,le,Me){return Ft.onDidChangeTextEditorOptions(re,le,Me)},onDidChangeTextEditorVisibleRanges(re,le,Me){return Ft.onDidChangeTextEditorVisibleRanges(re,le,Me)},onDidChangeTextEditorViewColumn(re,le,Me){return Ft.onDidChangeTextEditorViewColumn(re,le,Me)},onDidCloseTerminal(re,le,Me){return Ze.onDidCloseTerminal(re,le,Me)},onDidOpenTerminal(re,le,Me){return Ze.onDidOpenTerminal(re,le,Me)},onDidChangeActiveTerminal(re,le,Me){return Ze.onDidChangeActiveTerminal(re,le,Me)},onDidChangeTerminalDimensions(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(re,le,Me)},onDidChangeTerminalState(re,le,Me){return Ze.onDidChangeTerminalState(re,le,Me)},onDidWriteTerminalData(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(re,le,Me)},onDidExecuteTerminalCommand(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"terminalExecuteCommandEvent"),Ze.onDidExecuteTerminalCommand(re,le,Me)},get state(){return Oe.getState(xe)},onDidChangeWindowState(re,le,Me){return Oe.onDidChangeWindowState(re,le,Me)},showInformationMessage(re,...le){return Si.showMessage(xe,g.default.Info,re,le[0],le.slice(1))},showWarningMessage(re,...le){return Si.showMessage(xe,g.default.Warning,re,le[0],le.slice(1))},showErrorMessage(re,...le){return Si.showMessage(xe,g.default.Error,re,le[0],le.slice(1))},showQuickPick(re,le,Me){return ri.showQuickPick(xe,re,le,Me)},showWorkspaceFolderPick(re){return ri.showWorkspaceFolderPick(re)},showInputBox(re,le){return ri.showInput(re,le)},showOpenDialog(re){return Ni.showOpenDialog(xe,re)},showSaveDialog(re){return Ni.showSaveDialog(re)},createStatusBarItem(re,le,Me){let st,Et,Nt;return typeof re=="string"?(st=re,Et=le,Nt=Me):(Et=re,Nt=le),Zt.createStatusBarEntry(xe,st,Et,Nt)},setStatusBarMessage(re,le){return Zt.setStatusBarMessage(re,le)},withScmProgress(re){return Se.report("window.withScmProgress",xe,"Use 'withProgress' instead."),Ei.withProgress(xe,{location:Ne.ProgressLocation.SourceControl},(le,Me)=>re({report(st){}}))},withProgress(re,le){return Ei.withProgress(xe,re,le)},createOutputChannel(re,le){return Ct.createOutputChannel(re,le,xe)},createWebviewPanel(re,le,Me,st){return Ri.createWebviewPanel(xe,re,le,Me,st)},createWebviewTextEditorInset(re,le,Me,st){return(0,Ye.checkProposedApiEnabled)(xe,"editorInsets"),ki.createWebviewEditorInset(re,le,Me,st,xe)},createTerminal(re,le,Me){return typeof re=="object"?"pty"in re?Ze.createExtensionTerminal(re):Ze.createTerminalFromOptions(re):Ze.createTerminal(re,le,Me)},registerTerminalLinkProvider(re){return Ze.registerLinkProvider(re)},registerTerminalProfileProvider(re,le){return Ze.registerProfileProvider(xe,re,le)},registerTerminalQuickFixProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(re,xe.identifier.value,le)},registerTreeDataProvider(re,le){return vi.registerTreeDataProvider(re,le,xe)},createTreeView(re,le){return vi.createTreeView(re,le,xe)},registerWebviewPanelSerializer:(re,le)=>Ri.registerWebviewPanelSerializer(xe,re,le),registerCustomEditorProvider:(re,le,Me={})=>cn.registerCustomEditorProvider(xe,re,le,Me),registerFileDecorationProvider(re){return Be.registerFileDecorationProvider(re,xe)},registerUriHandler(re){return gi.registerUriHandler(xe,re)},createQuickPick(){return ri.createQuickPick(xe)},createInputBox(){return ri.createInputBox(xe)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(re,le,Me){return Ai.onDidChangeActiveColorTheme(re,le,Me)},registerWebviewViewProvider(re,le,Me){return Li.registerWebviewViewProvider(xe,re,le,Me?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,le,Me){return It.onDidChangeActiveNotebookEditor(re,le,Me)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,le,Me){return pi.onDidChangeNotebookEditorSelection(re,le,Me)},onDidChangeNotebookEditorVisibleRanges(re,le,Me){return pi.onDidChangeNotebookEditorVisibleRanges(re,le,Me)},showNotebookDocument(re,le){return It.showNotebookDocument(re,le)},registerExternalUriOpener(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"externalUriOpener"),ln.registerExternalUriOpener(xe.identifier,re,le,Me)},registerProfileContentHandler(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"profileContentHandlers"),un.registrProfileContentHandler(xe,re,le)},registerQuickDiffProvider(re,le,Me,st){return(0,Ye.checkProposedApiEnabled)(xe,"quickDiffProvider"),Pi.registerQuickDiffProvider(pt(re),le,Me,st)},get tabGroups(){return j.tabGroups},registerShareProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"shareProvider"),Vi.registerShareProvider(pt(re),le)}},sn={get rootPath(){return Se.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(re){throw new F.ReadonlyError("rootPath")},getWorkspaceFolder(re){return dt.getWorkspaceFolder(re)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(re){throw new F.ReadonlyError("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(re){throw new F.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(re,le,...Me)=>dt.updateWorkspaceFolders(xe,re,le||0,...Me),onDidChangeWorkspaceFolders:function(re,le,Me){return dt.onDidChangeWorkspace(re,le,Me)},asRelativePath:(re,le)=>dt.getRelativePath(re,le),findFiles:(re,le,Me,st)=>dt.findFiles(re,le,Me,xe.identifier,st),findTextInFiles:(re,le,Me,st)=>{(0,Ye.checkProposedApiEnabled)(xe,"findTextInFiles");let Et,Nt;return typeof le=="object"?(Et=le,Nt=Me):(Et={},Nt=le,st=Me),dt.findTextInFiles(re,Et||{},Nt,xe.identifier,st)},save:re=>((0,Ye.checkProposedApiEnabled)(xe,"saveEditor"),dt.save(re)),saveAs:re=>((0,Ye.checkProposedApiEnabled)(xe,"saveEditor"),dt.saveAs(re)),saveAll:re=>dt.saveAll(re),applyEdit(re,le){return Xt.applyWorkspaceEdit(re,xe,le)},createFileSystemWatcher:(re,le,Me,st)=>{let Et;return typeof le=="boolean"?Et={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!st,correlate:!1}:le&&((0,Ye.checkProposedApiEnabled)(xe,"createFileSystemWatcher"),Et={...le,correlate:!0}),Jt.createFileSystemWatcher(dt,xe,re,Et)},get textDocuments(){return Tt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new F.ReadonlyError("textDocuments")},openTextDocument(re){let le;const Me=re;if(typeof re=="string")le=Promise.resolve(m.URI.file(re));else if(m.URI.isUri(re))le=Promise.resolve(re);else if(!Me||typeof Me=="object")le=Tt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(st=>Tt.ensureDocumentData(st).then(Et=>Et.document))},onDidOpenTextDocument:(re,le,Me)=>Tt.onDidAddDocument(re,le,Me),onDidCloseTextDocument:(re,le,Me)=>Tt.onDidRemoveDocument(re,le,Me),onDidChangeTextDocument:(re,le,Me)=>Tt.onDidChangeDocument(re,le,Me),onDidSaveTextDocument:(re,le,Me)=>Tt.onDidSaveDocument(re,le,Me),onWillSaveTextDocument:(re,le,Me)=>Hi.getOnWillSaveTextDocumentEvent(xe)(re,le,Me),get notebookDocuments(){return It.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,le){let Me;if(m.URI.isUri(re))Me=re,await It.openNotebookDocument(re);else if(typeof re=="string")Me=m.URI.revive(await It.createNotebookDocument({viewType:re,content:le}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(re,le,Me){return ni.onDidSaveNotebookDocument(re,le,Me)},onDidChangeNotebookDocument(re,le,Me){return ni.onDidChangeNotebookDocument(re,le,Me)},onWillSaveNotebookDocument(re,le,Me){return Di.getOnWillSaveNotebookDocumentEvent(xe)(re,le,Me)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer(re,le,Me,st){return It.registerNotebookSerializer(xe,re,le,Me,(0,Ye.isProposedApiEnabled)(xe,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,le,Me)=>Yi.onDidChangeConfiguration(re,le,Me),getConfiguration(re,le){return le=arguments.length===1?void 0:le,Yi.getConfiguration(re,le,xe)},registerTextDocumentContentProvider(re,le){return Ci.registerTextDocumentContentProvider(re,le)},registerTaskProvider:(re,le)=>(Se.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(xe,re,le)),registerFileSystemProvider(re,le,Me){return(0,R.combinedDisposable)(Wi.registerFileSystemProvider(xe,re,le,Me),$t.addFileSystemProvider(re,le,Me))},get fs(){return $t.value},registerFileSearchProvider:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"fileSearchProvider"),Ut.registerFileSearchProvider(re,le)),registerTextSearchProvider:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"textSearchProvider"),Ut.registerTextSearchProvider(re,le)),registerRemoteAuthorityResolver:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"resolvers"),St.registerRemoteAuthorityResolver(re,le)),registerResourceLabelFormatter:re=>((0,Ye.checkProposedApiEnabled)(xe,"resolvers"),qi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ye.checkProposedApiEnabled)(xe,"resolvers"),St.getRemoteExecServer(re)),onDidCreateFiles:(re,le,Me)=>Jt.onDidCreateFile(re,le,Me),onDidDeleteFiles:(re,le,Me)=>Jt.onDidDeleteFile(re,le,Me),onDidRenameFiles:(re,le,Me)=>Jt.onDidRenameFile(re,le,Me),onWillCreateFiles:(re,le,Me)=>Jt.getOnWillCreateFileEvent(xe)(re,le,Me),onWillDeleteFiles:(re,le,Me)=>Jt.getOnWillDeleteFileEvent(xe)(re,le,Me),onWillRenameFiles:(re,le,Me)=>Jt.getOnWillRenameFileEvent(xe)(re,le,Me),openTunnel:re=>((0,Ye.checkProposedApiEnabled)(xe,"tunnels"),Rt.openTunnel(xe,re).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Ye.checkProposedApiEnabled)(xe,"tunnels"),Rt.getTunnels()},onDidChangeTunnels:(re,le,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"tunnels"),Rt.onDidChangeTunnels(re,le,Me)),registerPortAttributesProvider:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"portsAttributes"),Rt.registerPortsAttributesProvider(re,le)),registerTunnelProvider:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"tunnelFactory"),Rt.registerTunnelProvider(re,le)),registerTimelineProvider:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"timeline"),ji.registerTimelineProvider(re,le,xe.identifier,He.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:re=>((0,Ye.checkProposedApiEnabled)(xe,"workspaceTrust"),dt.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,le,Me)=>dt.onDidGrantWorkspaceTrust(re,le,Me),registerEditSessionIdentityProvider:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(re,le)),onWillCreateEditSessionIdentity:(re,le,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(xe)(re,le,Me)),registerCanonicalUriProvider:(re,le)=>((0,Ye.checkProposedApiEnabled)(xe,"canonicalUriProvider"),dt.registerCanonicalUriProvider(re,le)),getCanonicalUri:(re,le,Me)=>((0,Ye.checkProposedApiEnabled)(xe,"canonicalUriProvider"),dt.provideCanonicalUri(re,le,Me))},fn={get inputBox(){return Se.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(xe)},createSourceControl(re,le,Me){return hi.createSourceControl(xe,re,le,Me)},registerSourceControlInputBoxValueProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"scmInputBoxValueProvider"),hi.registerSourceControlInputBoxValueProvider(xe,re,le)}},on={createCommentController(re,le){return Ti.createCommentController(xe,re,le)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(re,le,Me){return mt.onDidStartDebugSession(re,le,Me)},onDidTerminateDebugSession(re,le,Me){return mt.onDidTerminateDebugSession(re,le,Me)},onDidChangeActiveDebugSession(re,le,Me){return mt.onDidChangeActiveDebugSession(re,le,Me)},onDidReceiveDebugSessionCustomEvent(re,le,Me){return mt.onDidReceiveDebugSessionCustomEvent(re,le,Me)},onDidChangeBreakpoints(re,le,Me){return mt.onDidChangeBreakpoints(re,le,Me)},onDidChangeStackFrameFocus(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"debugFocus"),mt.onDidChangeStackFrameFocus(re,le,Me)},registerDebugConfigurationProvider(re,le,Me){return mt.registerDebugConfigurationProvider(re,le,Me||Mt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,le){return mt.registerDebugAdapterDescriptorFactory(xe,re,le)},registerDebugAdapterTrackerFactory(re,le){return mt.registerDebugAdapterTrackerFactory(re,le)},startDebugging(re,le,Me){return!Me||typeof Me=="object"&&"configuration"in Me?mt.startDebugging(re,le,{parentSession:Me}):mt.startDebugging(re,le,Me||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,le){return mt.asDebugSourceUri(re,le)}},Mi={registerTaskProvider:(re,le)=>_t.registerTaskProvider(xe,re,le),fetchTasks:re=>_t.fetchTasks(re),executeTask:re=>_t.executeTask(xe,re),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(re,le,Me)=>_t.onDidStartTask(re,le,Me),onDidEndTask:(re,le,Me)=>_t.onDidEndTask(re,le,Me),onDidStartTaskProcess:(re,le,Me)=>_t.onDidStartTaskProcess(re,le,Me),onDidEndTaskProcess:(re,le,Me)=>_t.onDidEndTaskProcess(re,le,Me)},xi={createNotebookController(re,le,Me,st,Et){return ai.createNotebookController(xe,re,le,Me,st,(0,Ye.isProposedApiEnabled)(xe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(re,le)=>It.registerNotebookCellStatusBarItemProvider(xe,re,le),createRendererMessaging(re){return Ii.createRendererMessaging(xe,re)},createNotebookControllerDetectionTask(re){return(0,Ye.checkProposedApiEnabled)(xe,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(xe,re)},registerKernelSourceActionProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"notebookKernelSource"),ai.registerKernelSourceActionProvider(xe,re,le)},onDidChangeNotebookCellExecutionState(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(re,le,Me)}},Ui={t(...re){if(typeof re[0]=="string"){const le=re.shift(),Me=!re||typeof re[0]!="object"?re:re[0];return bt.getMessage(xe.identifier.value,{message:le,args:Me})}return bt.getMessage(xe.identifier.value,re[0])},get bundle(){return bt.getBundle(xe.identifier.value)},get uri(){return bt.getBundleUri(xe.identifier.value)}},yi={_version:1,registerInteractiveEditorSessionProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),Ki.registerProvider(xe,re,le)},registerInteractiveSessionProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),mi.registerChatProvider(xe,re,le)},sendInteractiveRequestToProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),mi.sendInteractiveRequestToProvider(re,le)},get onDidPerformUserAction(){return(0,Ye.checkProposedApiEnabled)(xe,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"interactive"),mi.transferChatSession(re,le)}},Bi={getRelatedInformation(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Qi.getRelatedInformation(xe,re,le)},registerRelatedInformationProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(xe,re,le)},registerEmbeddingVectorProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Oi.registerEmbeddingVectorProvider(xe,re,le)}},mn={registerChatResponseProvider(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"chatProvider"),fi.registerProvider(xe.identifier,re,le,Me)},requestChatAccess(re){return(0,Ye.checkProposedApiEnabled)(xe,"chatRequestAccess"),fi.requestChatResponseProvider(xe.identifier,re)},registerVariable(re,le,Me){return(0,Ye.checkProposedApiEnabled)(xe,"chatVariables"),Xi.registerVariableResolver(xe,re,le,Me)},registerMappedEditsProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"mappedEditsProvider"),ut.registerMappedEditsProvider(xe,re,le)},createChatAgent(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"chatAgents2"),Gi.createChatAgent(xe,re,le)}},gn={registerSpeechProvider(re,le){return(0,Ye.checkProposedApiEnabled)(xe,"speech"),wi.registerProvider(xe.identifier,re,le)}};return{version:gt.version,ai:Bi,authentication:Ji,commands:hn,comments:on,chat:mn,debug:an,env:Zi,extensions:tn,interactive:yi,l10n:Ui,languages:nn,notebooks:xi,scm:fn,speech:gn,tasks:Mi,tests:en,window:rn,workspace:sn,Breakpoint:Ne.Breakpoint,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.ChatMessage,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.ChatAgentCompletionItem,CallHierarchyIncomingCall:Ne.CallHierarchyIncomingCall,CallHierarchyItem:Ne.CallHierarchyItem,CallHierarchyOutgoingCall:Ne.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.CodeAction,CodeActionKind:Ne.CodeActionKind,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.CodeLens,Color:Ne.Color,ColorInformation:Ne.ColorInformation,ColorPresentation:Ne.ColorPresentation,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.CompletionItem,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.CompletionList,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.CustomExecution,DebugAdapterExecutable:Ne.DebugAdapterExecutable,DebugAdapterInlineImplementation:Ne.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Ne.DebugAdapterNamedPipeServer,DebugAdapterServer:Ne.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Mt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.Diagnostic,DiagnosticRelatedInformation:Ne.DiagnosticRelatedInformation,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.Disposable,DocumentHighlight:Ne.DocumentHighlight,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.MultiDocumentHighlight,DocumentLink:Ne.DocumentLink,DocumentSymbol:Ne.DocumentSymbol,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.EvaluatableExpression,InlineValueText:Ne.InlineValueText,InlineValueVariableLookup:Ne.InlineValueVariableLookup,InlineValueEvaluatableExpression:Ne.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.FileDecoration,FileDecoration2:Ne.FileDecoration,FileSystemError:Ne.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:Ne.FoldingRange,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.FunctionBreakpoint,InlineCompletionItem:Ne.InlineSuggestion,InlineCompletionList:Ne.InlineSuggestionList,Hover:Ne.Hover,IndentAction:I.IndentAction,Location:Ne.Location,MarkdownString:Ne.MarkdownString,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Ne.ParameterInformation,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.Position,ProcessExecution:Ne.ProcessExecution,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.QuickInputButtons,Range:Ne.Range,RelativePattern:Ne.RelativePattern,Selection:Ne.Selection,SelectionRange:Ne.SelectionRange,SemanticTokens:Ne.SemanticTokens,SemanticTokensBuilder:Ne.SemanticTokensBuilder,SemanticTokensEdit:Ne.SemanticTokensEdit,SemanticTokensEdits:Ne.SemanticTokensEdits,SemanticTokensLegend:Ne.SemanticTokensLegend,ShellExecution:Ne.ShellExecution,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.SignatureHelp,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.SignatureInformation,SnippetString:Ne.SnippetString,SourceBreakpoint:Ne.SourceBreakpoint,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.SymbolInformation,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.Task,TaskGroup:Ne.TaskGroup,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.TerminalLink,TerminalQuickFixTerminalCommand:Ne.TerminalQuickFixCommand,TerminalQuickFixOpener:Ne.TerminalQuickFixOpener,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.TerminalProfile,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.TextEdit,SnippetTextEdit:Ne.SnippetTextEdit,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.ThemeColor,ThemeIcon:Ne.ThemeIcon,TreeItem:Ne.TreeItem,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.TypeHierarchyItem,UIKind:kt.UIKind,Uri:m.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.WorkspaceEdit,DocumentDropEdit:Ne.DocumentDropEdit,DocumentPasteEdit:Ne.DocumentPasteEdit,InlayHint:Ne.InlayHint,InlayHintLabelPart:Ne.InlayHintLabelPart,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.RemoteAuthorityResolverError,ResolvedAuthority:Ne.ResolvedAuthority,ManagedResolvedAuthority:Ne.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.TimelineItem,NotebookRange:Ne.NotebookRange,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.NotebookCellData,NotebookData:Ne.NotebookData,NotebookRendererScript:Ne.NotebookRendererScript,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.NotebookCellOutput,NotebookCellOutputItem:Ne.NotebookCellOutputItem,NotebookCellStatusBarItem:Ne.NotebookCellStatusBarItem,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.NotebookEdit,NotebookKernelSourceAction:Ne.NotebookKernelSourceAction,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.PortAttributes,LinkedEditingRanges:Ne.LinkedEditingRanges,TestResultState:Ne.TestResultState,TestRunRequest:Ne.TestRunRequest,TestMessage:Ne.TestMessage,TestMessage2:Ne.TestMessage,TestTag:Ne.TestTag,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:qt.TextSearchCompleteMessageType,DataTransfer:Ne.DataTransfer,DataTransferItem:Ne.DataTransferItem,CoveredCount:Ne.CoveredCount,FileCoverage:Ne.FileCoverage,StatementCoverage:Ne.StatementCoverage,BranchCoverage:Ne.BranchCoverage,FunctionCoverage:Ne.FunctionCoverage,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.TextTabInput,TabInputTextDiff:Ne.TextDiffTabInput,TabInputTextMerge:Ne.TextMergeTabInput,TabInputCustom:Ne.CustomEditorTabInput,TabInputNotebook:Ne.NotebookEditorTabInput,TabInputNotebookDiff:Ne.NotebookDiffEditorTabInput,TabInputWebview:Ne.WebviewEditorTabInput,TabInputTerminal:Ne.TerminalEditorTabInput,TabInputInteractiveWindow:Ne.InteractiveWindowInput,TabInputChat:Ne.ChatEditorTabInput,TelemetryTrustedValue:t.TelemetryTrustedValue,LogLevel:n.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.StackFrameFocus,ThreadFocus:Ne.ThreadFocus,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.createApiFactoryAndRegisterActors=jt}),define(Pe[291],Te([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,256,15,116,82,83]),function(ge,e,S,F,D,R,T,g,m,w,A,I,u,p,E,n,o,t,r,a,c,d,i,s,l,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.registerSingleton)(h.IExtHostLocalizationService,h.ExtHostLocalizationService,1),(0,S.registerSingleton)(s.ILoggerService,i.ExtHostLoggerService,1),(0,S.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService,1),(0,S.registerSingleton)(g.IExtHostCommands,g.ExtHostCommands,0),(0,S.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration,0),(0,S.registerSingleton)(t.IExtHostConsumerFileSystem,t.ExtHostConsumerFileSystem,0),(0,S.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,S.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,S.registerSingleton)(m.IExtHostDocumentsAndEditors,m.ExtHostDocumentsAndEditors,0),(0,S.registerSingleton)(b.IExtHostManagedSockets,b.ExtHostManagedSockets,0),(0,S.registerSingleton)(r.IExtHostFileSystemInfo,r.ExtHostFileSystemInfo,0),(0,S.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService,1),(0,S.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch,0),(0,S.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,S.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,0),(0,S.registerSingleton)(w.IExtHostTerminalService,w.WorkerExtHostTerminalService,0),(0,S.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,S.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,S.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,S.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState,0),(0,S.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,0),(0,S.registerSingleton)(d.IExtHostEditorTabs,d.ExtHostEditorTabs,0),(0,S.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(Pe[292],Te([1,0,290,38,2,287,7,14,275]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends R.RequireInterceptor{_installInterceptor(){}getModule(p,E){for(const n of this._alternatives){const o=n(p);if(o){p=o;break}}if(this._factories.has(p))return this._factories.get(p).load(p,E,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends F.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(m.ExtHostConsoleForwarder);const p=this._instaService.invokeFunction(S.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(w,p,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(p){return p.browser}async _loadCommonJSModule(p,E,n){E=E.with({path:I(E.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=D.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(E)),r=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const a=await r.text(),c=`${E.toString(!0)}#vscode-extension`,d=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",d)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${E.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}p&&await this._extHostLocalizationService.initializeLocalizedMessages(p);const s={},l={exports:s},h=b=>{const f=this._fakeModules.getModule(b,E);if(f===void 0)throw new Error(`Cannot load module '${b}'`);return f};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(l,s,h),l.exports!==s?l.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(p){}async _waitForDebuggerAttachment(p=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const E=Date.now()+p;for(;Date.now()<E&&!("__jsDebugIsReady"in globalThis);)await(0,g.timeout)(10)}}e.ExtHostExtensionService=A;function I(u,p){return u.endsWith(p)?u:u+p}}),define(Pe[293],Te([1,0,69,70,15,38,200,86,292]),function(ge,e,S,F,D,R,T,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.registerSingleton)(D.ILogService,new S.SyncDescriptor(T.ExtHostLogService,[!0],!0)),(0,F.registerSingleton)(R.IExtHostExtensionService,m.ExtHostExtensionService,0),(0,F.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths,0)}),define(Pe[298],Te([1,0,24,5,79,288,277,19,88,13,2,291,293]),function(ge,e,S,F,D,R,T,g,m,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const I=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const E=fetch.bind(self);function n(i){self.fetch=async function(s,l){return s instanceof Request||p(String(s))&&(s=(await i(A.URI.parse(String(s)))).toString(!0)),E(s,l)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,l,h,b,f){(async()=>(p(l.toString())&&(l=(await i(A.URI.parse(l.toString()))).toString(!0)),super.open(s,l,h??!0,b,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,l){if(/^file:/i.test(s.toString()))s=w.FileAccess.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(v){function _(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const y=fetch.bind(self);self.fetch=function(V,$){return V instanceof Request?y(V,$):y(_(V),$)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,$,L,U,k){return super.open(V,_($),L??!0,U,k)}};const M=importScripts.bind(self);self.importScripts=(...V)=>{M(...V.map(_))},M(v)}.toString()}('${s}'))`;l=l||{},l.name=l.name||g.basename(s.toString());const f=new Blob([b],{type:"application/javascript"}),C=URL.createObjectURL(f);return new i(C,l)}}else self.Worker=class extends T.NestedWorker{constructor(i,s){super(u,i,{name:g.basename(i.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(i){I()}};class t{constructor(){const s=new MessageChannel,l=new F.Emitter;let h=!1;u(s.port2,[s.port2]),s.port1.onmessage=b=>{const{data:f}=b;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const C=S.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,D.isMessageOfType)(C,2)){h=!0,a("received terminate message from renderer");return}l.fire(C)},this.protocol={onMessage:l.event,send:b=>{if(!h){const f=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function r(i){return new Promise(s=>{const l=i.onMessage(h=>{l.dispose();const b=JSON.parse(h.toString());i.send((0,D.createMessageOfType)(0)),s({protocol:i,initData:b})});i.send((0,D.createMessageOfType)(1))})}let a=i=>I();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function d(){m.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&r(i.protocol).then(l=>{m.mark("code/extHost/didWaitForInitData");const h=new R.ExtensionHostMain(l.protocol,l.initData,o,null,s.data);n(b=>h.asBrowserUri(b)),a=b=>h.terminate(b)})}}}e.create=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c8a36a69377856369f139f39ee56dd3838130fbf/core/vs/workbench/api/worker/extensionHostWorker.js.map
