/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var j=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],$=function(q){for(var e=[],I=0,w=q.length;I<w;I++)e[I]=j[q[I]];return e};define(j[22],$([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class I{static get(){const k=new Map,P=new Map,r=new Map,c=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function l(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let g=[];typeof q=="function"&&typeof q.getStats=="function"&&(g=q.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of g)switch(a.type){case 10:t(k,a);break;case 11:case 12:l(k,a);break;case 21:t(P,a);break;case 22:l(P,a);break;case 33:t(r,a);break;case 34:l(r,a);break;case 31:t(c,a);break;case 32:l(c,a);break}let d=0;r.forEach(a=>d+=a);function o(a){const i=[];return a.forEach((n,s)=>i.push([s,n])),i}return{amdLoad:o(k),amdInvoke:o(P),nodeRequire:o(r),nodeEval:o(c),nodeRequireTotal:d}}static toMarkdownTable(k,P){let r="";const c=[];return k.forEach((t,l)=>{c[l]=t.length}),P.forEach(t=>{t.forEach((l,g)=>{typeof l>"u"&&(l=t[g]="-");const d=l.toString().length;c[g]=Math.max(d,c[g])})}),k.forEach((t,l)=>{r+=`| ${t+" ".repeat(c[l]-t.toString().length)} `}),r+=`|
`,k.forEach((t,l)=>{r+=`| ${"-".repeat(c[l])} `}),r+=`|
`,P.forEach(t=>{t.forEach((l,g)=>{typeof l<"u"&&(r+=`| ${l+" ".repeat(c[g]-l.toString().length)} `)}),r+=`|
`}),r}}e.LoaderStats=I}),define(j[4],$([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let I;function w(n){I=n}e.setLogger=w;function k(){return I}e.getLogger=k;class P{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(s){return r([c(a("|  ",this.indentation)),s])}formatInfo(s){return s.hadValue?s.didChange?[c(" "),l(g(s.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),l(g(s.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),l(g(s.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(s,b){console.log(...this.textToConsoleArgs([t("observable value changed"),l(s.debugName,{color:"BlueViolet"}),...this.formatInfo(b)]))}formatChanges(s){if(s.size!==0)return l(" (changed deps: "+[...s].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const b=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(O,A)=>(this.changedObservablesSets.get(s).add(O),b.apply(s,[O,A]))}handleDerivedRecomputed(s,b){const O=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([t("derived recomputed"),l(s.debugName,{color:"BlueViolet"}),...this.formatInfo(b),this.formatChanges(O),{data:[{fn:s._computeFn}]}])),O.clear()}handleFromEventObservableTriggered(s,b){console.log(...this.textToConsoleArgs([t("observable from event triggered"),l(s.debugName,{color:"BlueViolet"}),...this.formatInfo(b),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const b=s.handleChange;this.changedObservablesSets.set(s,new Set),s.handleChange=(O,A)=>(this.changedObservablesSets.get(s).add(O),b.apply(s,[O,A]))}handleAutorunTriggered(s){const b=this.changedObservablesSets.get(s);console.log(...this.textToConsoleArgs([t("autorun"),l(s.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:s._runFn}]}])),b.clear(),this.indentation++}handleAutorunFinished(s){this.indentation--}handleBeginTransaction(s){let b=s.getDebugName();b===void 0&&(b=""),console.log(...this.textToConsoleArgs([t("transaction"),l(b,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=P;function r(n){const s=new Array,b=[];let O="";function A(L){if("length"in L)for(const f of L)f&&A(f);else"text"in L?(O+=`%c${L.text}`,s.push(L.style),L.data&&b.push(...L.data)):"data"in L&&b.push(...L.data)}A(n);const R=[O,...s];return R.push(...b),R}function c(n){return l(n,{color:"black"})}function t(n){return l(i(`${n}: `,10),{color:"black",bold:!0})}function l(n,s={color:"black"}){function b(A){return Object.entries(A).reduce((R,[L,f])=>`${R}${L}:${f};`,"")}const O={color:s.color};return s.strikeThrough&&(O["text-decoration"]="line-through"),s.bold&&(O["font-weight"]="bold"),{text:n,style:b(O)}}function g(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?d(n,s):o(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function d(n,s){let b="[ ",O=!0;for(const A of n){if(O||(b+=", "),b.length-5>s){b+="...";break}O=!1,b+=`${g(A,s-b.length)}`}return b+=" ]",b}function o(n,s){let b="{ ",O=!0;for(const[A,R]of Object.entries(n)){if(O||(b+=", "),b.length-5>s){b+="...";break}O=!1,b+=`${A}: ${g(R,s-b.length)}`}return b+=" }",b}function a(n,s){let b="";for(let O=1;O<=s;O++)b+=n;return b}function i(n,s){for(;n.length<s;)n+=" ";return n}}),define(j[5],$([0,1,4]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.getDebugName=e.TransactionImpl=e.subtransaction=e.asyncTransaction=e.globalTransaction=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerivedOpts=e._setRecomputeInitiallyAndOnChange=void 0;let w;function k(v){w=v}e._setRecomputeInitiallyAndOnChange=k;let P;function r(v){P=v}e._setDerivedOpts=r;class c{get TChange(){return null}reportChanges(){this.get()}read(y){return y?y.readObservable(this):this.get()}map(y,z){const E=z===void 0?void 0:y,h=z===void 0?y:z;return P({owner:E,debugName:()=>{const N=S(h);if(N!==void 0)return N;const W=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(h.toString());if(W)return`${this.debugName}.${W[2]}`;if(!E)return`${this.debugName} (mapped)`}},N=>h(this.read(N),N))}recomputeInitiallyAndOnChange(y,z){return y.add(w(this,z)),this}}e.ConvenientObservable=c;class t extends c{constructor(){super(...arguments),this.observers=new Set}addObserver(y){const z=this.observers.size;this.observers.add(y),z===0&&this.onFirstObserverAdded()}removeObserver(y){this.observers.delete(y)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=t;function l(v,y){const z=new i(v,y);try{v(z)}finally{z.finish()}}e.transaction=l;let g;function d(v){if(g)v(g);else{const y=new i(v,void 0);g=y;try{v(y)}finally{y.finish(),g=void 0}}}e.globalTransaction=d;async function o(v,y){const z=new i(v,y);try{await v(z)}finally{z.finish()}}e.asyncTransaction=o;function a(v,y,z){v?y(v):l(y,z)}e.subtransaction=a;class i{constructor(y,z){this._fn=y,this._getDebugName=z,this.updatingObservers=[],(0,I.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():S(this._fn)}updateObserver(y,z){this.updatingObservers.push({observer:y,observable:z}),y.beginUpdate(z)}finish(){const y=this.updatingObservers;for(let z=0;z<y.length;z++){const{observer:E,observable:h}=y[z];E.endUpdate(h)}this.updatingObservers=null,(0,I.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=i;const n=new Map,s=new WeakMap;function b(v,y,z,E,h){const N=s.get(v);if(N)return N;const F=O(v,y,z,E,h);if(F){let W=n.get(F)??0;W++,n.set(F,W);const K=W===1?F:`${F}#${W}`;return s.set(v,K),K}}e.getDebugName=b;function O(v,y,z,E,h){const N=s.get(v);if(N)return N;const F=E?L(E)+".":"";let W;if(y!==void 0)if(typeof y=="function"){if(W=y(),W!==void 0)return F+W}else return F+y;if(z!==void 0&&(W=S(z),W!==void 0))return F+W;if(E!==void 0){for(const K in E)if(E[K]===h)return F+K}}const A=new Map,R=new WeakMap;function L(v){const y=R.get(v);if(y)return y;const z=f(v);let E=A.get(z)??0;E++,A.set(z,E);const h=E===1?z:`${z}#${E}`;return R.set(v,h),h}function f(v){const y=v.constructor;return y?y.name:"Object"}function S(v){const y=v.toString(),E=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(y);return(E?E[1]:void 0)?.trim()}e.getFunctionName=S;function _(v,y){return typeof v=="string"?new C(void 0,v,y):new C(v,void 0,y)}e.observableValue=_;class C extends t{get debugName(){return b(this,this._debugName,void 0,this._owner,this)??"ObservableValue"}constructor(y,z,E){super(),this._owner=y,this._debugName=z,this._value=E}get(){return this._value}set(y,z,E){if(this._value===y)return;let h;z||(z=h=new i(()=>{},()=>`Setting ${this.debugName}`));try{const N=this._value;this._setValue(y),(0,I.getLogger)()?.handleObservableChanged(this,{oldValue:N,newValue:y,change:E,didChange:!0,hadValue:!0});for(const F of this.observers)z.updateObserver(F,this),F.handleChange(this,E)}finally{h&&h.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(y){this._value=y}}e.ObservableValue=C;function U(v,y){return typeof v=="string"?new m(void 0,v,y):new m(v,void 0,y)}e.disposableObservableValue=U;class m extends C{_setValue(y){this._value!==y&&(this._value&&this._value.dispose(),this._value=y)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=m}),define(j[9],$([0,1,43,2,5,4]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunWithStoreHandleChanges=e.autorunHandleChanges=e.autorunOpts=e.autorun=void 0;function r(i){return new o(void 0,i,void 0,void 0)}e.autorun=r;function c(i,n){return new o(i.debugName,n,void 0,void 0)}e.autorunOpts=c;function t(i,n){return new o(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.autorunHandleChanges=t;function l(i,n){const s=new w.DisposableStore,b=t({debugName:i.debugName??(()=>(0,k.getFunctionName)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(O,A)=>{s.clear(),n(O,A,s)});return(0,w.toDisposable)(()=>{b.dispose(),s.dispose()})}e.autorunWithStoreHandleChanges=l;function g(i){const n=new w.DisposableStore,s=c({debugName:()=>(0,k.getFunctionName)(i)||"(anonymous)"},b=>{n.clear(),i(b,n)});return(0,w.toDisposable)(()=>{s.dispose(),n.dispose()})}e.autorunWithStore=g;var d;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(d||(d={}));class o{get debugName(){if(typeof this._debugName=="string")return this._debugName;if(typeof this._debugName=="function"){const s=this._debugName();if(s!==void 0)return s}const n=(0,k.getFunctionName)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,s,b,O){this._debugName=n,this._runFn=s,this.createChangeSummary=b,this._handleChange=O,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,P.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,w.trackDisposable)(this)}dispose(){this.disposed=!0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),(0,w.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n,this.state=3;const s=this.disposed;try{if(!s){(0,P.getLogger)()?.handleAutorunTriggered(this);const b=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,b)}}finally{s||(0,P.getLogger)()?.handleAutorunFinished(this);for(const b of this.dependenciesToBeRemoved)b.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,I.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(n){this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(this.state=1)}handleChange(n,s){this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)&&(!this._handleChange||this._handleChange({changedObservable:n,change:s,didChange:O=>O===n},this.changeSummary))&&(this.state=2)}readObservable(n){if(this.disposed)return n.get();n.addObserver(this);const s=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),s}}e.AutorunObserver=o,function(i){i.Observer=o}(r||(e.autorun=r={}));function a(i,n){let s;return c({debugName:()=>(0,k.getFunctionName)(n)},b=>{const O=i.read(b),A=s;s=O,n({lastValue:A,newValue:O})})}e.autorunDelta=a}),define(j[10],$([0,1,6,2,5,4]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derivedDisposable=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=void 0;const r=(i,n)=>i===n;function c(i,n){return n!==void 0?new a(i,void 0,n,void 0,void 0,void 0,r):new a(void 0,void 0,i,void 0,void 0,void 0,r)}e.derived=c;function t(i,n){return new a(i.owner,i.debugName,n,void 0,void 0,void 0,i.equalityComparer??r)}e.derivedOpts=t;function l(i,n){return new a(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??r)}e.derivedHandleChanges=l;function g(i,n){let s,b;n===void 0?(s=i,b=void 0):(b=i,s=n);const O=new w.DisposableStore;return new a(b,()=>(0,k.getFunctionName)(s)??"(anonymous)",A=>(O.clear(),s(A,O)),void 0,void 0,()=>O.dispose(),r)}e.derivedWithStore=g;function d(i,n){let s,b;n===void 0?(s=i,b=void 0):(b=i,s=n);const O=new w.DisposableStore;return new a(b,()=>(0,k.getFunctionName)(s)??"(anonymous)",A=>{O.clear();const R=s(A);return R&&O.add(R),R},void 0,void 0,()=>O.dispose(),r)}e.derivedDisposable=d,(0,k._setDerivedOpts)(t);var o;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(o||(o={}));class a extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this,this._debugName,this._computeFn,this._owner,this)??"(anonymous)"}constructor(n,s,b,O,A,R=void 0,L){super(),this._owner=n,this._debugName=s,this._computeFn=b,this.createChangeSummary=O,this._handleChange=A,this._handleLastObserverRemoved=R,this._equalityComparator=L,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,P.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const n of this.dependencies)n.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const n=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),n}else{do{if(this.state===1){for(const n of this.dependencies)if(n.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const n=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=n;const s=this.state!==0,b=this.value;this.state=3;const O=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,O)}finally{for(const R of this.dependenciesToBeRemoved)R.removeObserver(this);this.dependenciesToBeRemoved.clear()}const A=s&&!this._equalityComparator(b,this.value);if((0,P.getLogger)()?.handleDerivedRecomputed(this,{oldValue:b,newValue:this.value,change:void 0,didChange:A,hadValue:s}),A)for(const R of this.observers)R.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.updateCount++;const s=this.updateCount===1;if(this.state===3&&(this.state=1,!s))for(const b of this.observers)b.handlePossibleChange(this);if(s)for(const b of this.observers)b.beginUpdate(this)}endUpdate(n){if(this.updateCount--,this.updateCount===0){const s=[...this.observers];for(const b of s)b.endUpdate(this)}if(this.updateCount<0)throw new I.BugIndicatingError}handlePossibleChange(n){if(this.state===3&&this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){this.state=1;for(const s of this.observers)s.handlePossibleChange(this)}}handleChange(n,s){if(this.dependencies.has(n)&&!this.dependenciesToBeRemoved.has(n)){const b=this._handleChange?this._handleChange({changedObservable:n,change:s,didChange:A=>A===n},this.changeSummary):!0,O=this.state===3;if(b&&(this.state===1||O)&&(this.state=2,O))for(const A of this.observers)A.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const s=n.get();return this.dependencies.add(n),this.dependenciesToBeRemoved.delete(n),s}addObserver(n){const s=!this.observers.has(n)&&this.updateCount>0;super.addObserver(n),s&&n.beginUpdate(this)}removeObserver(n){const s=this.observers.has(n)&&this.updateCount>0;super.removeObserver(n),s&&n.endUpdate(this)}}e.Derived=a}),define(j[23],$([0,1,2,9,5,10,4]),function(q,e,I,w,k,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.recomputeInitiallyAndOnChange=e.keepObserved=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function c(_){return new t(_)}e.constObservable=c;class t extends k.ConvenientObservable{constructor(C){super(),this.value=C}get debugName(){return this.toString()}get(){return this.value}addObserver(C){}removeObserver(C){}toString(){return`Const: ${this.value}`}}function l(_){const C=(0,k.observableValue)("promiseValue",{});return _.then(U=>{C.set({value:U},void 0)}),C}e.observableFromPromise=l;function g(_,C){return new Promise(U=>{let m=!1,v=!1;const y=_.map(E=>({isFinished:C(E),state:E})),z=(0,w.autorun)(E=>{const{isFinished:h,state:N}=y.read(E);h&&(m?z.dispose():v=!0,U(N))});m=!0,v&&z.dispose()})}e.waitForState=g;function d(_,C){return new o(_,C)}e.observableFromEvent=d;class o extends k.BaseObservable{constructor(C,U){super(),this.event=C,this._getValue=U,this.hasValue=!1,this.handleEvent=m=>{const v=this._getValue(m),y=this.value,z=!this.hasValue||y!==v;let E=!1;z&&(this.value=v,this.hasValue&&(E=!0,(0,k.subtransaction)(o.globalTransaction,h=>{(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:y,newValue:v,change:void 0,didChange:z,hadValue:this.hasValue});for(const N of this.observers)h.updateObserver(N,this),N.handleChange(this,void 0)},()=>{const h=this.getDebugName();return"Event fired"+(h?`: ${h}`:"")})),this.hasValue=!0),E||(0,r.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:y,newValue:v,change:void 0,didChange:z,hadValue:this.hasValue})}}getDebugName(){return(0,k.getFunctionName)(this._getValue)}get debugName(){const C=this.getDebugName();return"From Event"+(C?`: ${C}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=o,function(_){_.Observer=o;function C(U,m){let v=!1;o.globalTransaction===void 0&&(o.globalTransaction=U,v=!0);try{m()}finally{v&&(o.globalTransaction=void 0)}}_.batchEventsGlobally=C}(d||(e.observableFromEvent=d={}));function a(_,C){return new i(_,C)}e.observableSignalFromEvent=a;class i extends k.BaseObservable{constructor(C,U){super(),this.debugName=C,this.event=U,this.handleEvent=()=>{(0,k.transaction)(m=>{for(const v of this.observers)m.updateObserver(v,this),v.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function n(_){return typeof _=="string"?new s(_):new s(void 0,_)}e.observableSignal=n;class s extends k.BaseObservable{get debugName(){return(0,k.getDebugName)(this,this._debugName,void 0,this._owner,this)??"Observable Signal"}constructor(C,U){super(),this._debugName=C,this._owner=U}trigger(C,U){if(!C){(0,k.transaction)(m=>{this.trigger(m,U)},()=>`Trigger signal ${this.debugName}`);return}for(const m of this.observers)C.updateObserver(m,this),m.handleChange(this,U)}get(){}}function b(_,C,U){const m=(0,k.observableValue)("debounced",void 0);let v;return U.add((0,w.autorun)(y=>{const z=_.read(y);v&&clearTimeout(v),v=setTimeout(()=>{(0,k.transaction)(E=>{m.set(z,E)})},C)})),m}e.debouncedObservable=b;function O(_,C,U){const m=(0,k.observableValue)("triggeredRecently",!1);let v;return U.add(_(()=>{m.set(!0,void 0),v&&clearTimeout(v),v=setTimeout(()=>{m.set(!1,void 0)},C)})),m}e.wasEventTriggeredRecently=O;function A(_){const C=new L(!1,void 0);return _.addObserver(C),(0,I.toDisposable)(()=>{_.removeObserver(C)})}e.keepObserved=A;function R(_,C){const U=new L(!0,C);return _.addObserver(U),C?C(_.get()):_.reportChanges(),(0,I.toDisposable)(()=>{_.removeObserver(U)})}e.recomputeInitiallyAndOnChange=R,(0,k._setRecomputeInitiallyAndOnChange)(R);class L{constructor(C,U){this._forceRecompute=C,this._handleValue=U,this._counter=0}beginUpdate(C){this._counter++}endUpdate(C){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(C.get()):C.reportChanges())}handlePossibleChange(C){}handleChange(C,U){}}function f(_){let C;return(0,P.derived)(m=>(C=_(m,C),C))}e.derivedObservableWithCache=f;function S(_,C){let U;const m=(0,k.observableValue)("derivedObservableWithWritableCache.counter",0),v=(0,P.derived)(_,y=>(m.read(y),U=C(y,U),U));return Object.assign(v,{clearCache:y=>{U=void 0,m.set(m.get()+1,y)}})}e.derivedObservableWithWritableCache=S}),define(j[11],$([0,1,5,10,9,23,4]),function(q,e,I,w,k,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return I.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return I.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return I.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return I.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return w.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return w.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return w.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return w.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return P.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return P.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return P.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return P.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return P.keepObserved}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return P.recomputeInitiallyAndOnChange}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return P.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return P.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return P.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return P.observableSignalFromEvent}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return P.waitForState}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return P.wasEventTriggeredRecently}}),!1&&(0,r.setLogger)(new r.ConsoleObservableLogger)}),define(j[24],$([0,1,6,2]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(R){const L=R;return L?typeof L.read=="function":!1}e.isReadable=k;function P(R){const L=R;return L?[L.on,L.pause,L.resume,L.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=P;function r(R){const L=R;return L?P(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=r;function c(R,L){return new t(R,L)}e.newWriteableStream=c;class t{constructor(L,f){this.reducer=L,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(L){if(!this.state.destroyed){if(this.state.flowing)this.emitData(L);else if(this.buffer.data.push(L),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(f=>this.pendingWritePromises.push(f))}}error(L){this.state.destroyed||(this.state.flowing?this.emitError(L):this.buffer.error.push(L))}end(L){this.state.destroyed||(typeof L<"u"&&this.write(L),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(L){this.listeners.data.slice(0).forEach(f=>f(L))}emitError(L){this.listeners.error.length===0?(0,I.onUnexpectedError)(L):this.listeners.error.slice(0).forEach(f=>f(L))}emitEnd(){this.listeners.end.slice(0).forEach(L=>L())}on(L,f){if(!this.state.destroyed)switch(L){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(L,f){if(this.state.destroyed)return;let S;switch(L){case"data":S=this.listeners.data;break;case"end":S=this.listeners.end;break;case"error":S=this.listeners.error;break}if(S){const _=S.indexOf(f);_>=0&&S.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const L=this.reducer(this.buffer.data);this.emitData(L),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(S=>S())}}flowErrors(){if(this.listeners.error.length>0){for(const L of this.buffer.error)this.emitError(L);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(R,L){const f=[];let S;for(;(S=R.read())!==null;)f.push(S);return L(f)}e.consumeReadable=l;function g(R,L,f){const S=[];let _;for(;(_=R.read())!==null&&S.length<f;)S.push(_);return _===null&&S.length>0?L(S):{read:()=>{if(S.length>0)return S.shift();if(typeof _<"u"){const C=_;return _=void 0,C}return R.read()}}}e.peekReadable=g;function d(R,L){return new Promise((f,S)=>{const _=[];o(R,{onData:C=>{L&&_.push(C)},onError:C=>{L?S(C):f(void 0)},onEnd:()=>{f(L?L(_):void 0)}})})}e.consumeStream=d;function o(R,L,f){R.on("error",S=>{f?.isCancellationRequested||L.onError(S)}),R.on("end",()=>{f?.isCancellationRequested||L.onEnd()}),R.on("data",S=>{f?.isCancellationRequested||L.onData(S)})}e.listenStream=o;function a(R,L){return new Promise((f,S)=>{const _=new w.DisposableStore,C=[],U=y=>{if(C.push(y),C.length>L)return _.dispose(),R.pause(),f({stream:R,buffer:C,ended:!1})},m=y=>(_.dispose(),S(y)),v=()=>(_.dispose(),f({stream:R,buffer:C,ended:!0}));_.add((0,w.toDisposable)(()=>R.removeListener("error",m))),R.on("error",m),_.add((0,w.toDisposable)(()=>R.removeListener("end",v))),R.on("end",v),_.add((0,w.toDisposable)(()=>R.removeListener("data",U))),R.on("data",U)})}e.peekStream=a;function i(R,L){const f=c(L);return f.end(R),f}e.toStream=i;function n(){const R=c(()=>{throw new Error("not supported")});return R.end(),R}e.emptyStream=n;function s(R){let L=!1;return{read:()=>L?null:(L=!0,R)}}e.toReadable=s;function b(R,L,f){const S=c(f);return o(R,{onData:_=>S.write(L.data(_)),onError:_=>S.error(L.error?L.error(_):_),onEnd:()=>S.end()}),S}e.transform=b;function O(R,L,f){let S=!1;return{read:()=>{const _=L.read();return S?_:(S=!0,_!==null?f([R,_]):R)}}}e.prefixedReadable=O;function A(R,L,f){let S=!1;const _=c(f);return o(L,{onData:C=>S?_.write(C):(S=!0,_.write(f([R,C]))),onError:C=>_.error(C),onEnd:()=>{S||(S=!0,_.write(R)),_.end()}}),_}e.prefixedStream=A}),define(j[12],$([0,1,25,24]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.binaryIndexOf=e.VSBuffer=void 0;const k=typeof Buffer<"u",P=new I.Lazy(()=>new Uint8Array(256));let r,c;class t{static alloc(h){return k?new t(Buffer.allocUnsafe(h)):new t(new Uint8Array(h))}static wrap(h){return k&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new t(h)}static fromString(h,N){return!(N?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(h)):(r||(r=new TextEncoder),new t(r.encode(h)))}static fromByteArray(h){const N=t.alloc(h.length);for(let F=0,W=h.length;F<W;F++)N.buffer[F]=h[F];return N}static concat(h,N){if(typeof N>"u"){N=0;for(let K=0,G=h.length;K<G;K++)N+=h[K].byteLength}const F=t.alloc(N);let W=0;for(let K=0,G=h.length;K<G;K++){const V=h[K];F.set(V,W),W+=V.byteLength}return F}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=t.alloc(this.byteLength);return h.set(this),h}toString(){return k?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(h,N){return new t(this.buffer.subarray(h,N))}set(h,N){if(h instanceof t)this.buffer.set(h.buffer,N);else if(h instanceof Uint8Array)this.buffer.set(h,N);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),N);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return o(this.buffer,h)}writeUInt32BE(h,N){a(this.buffer,h,N)}readUInt32LE(h){return i(this.buffer,h)}writeUInt32LE(h,N){n(this.buffer,h,N)}readUInt8(h){return s(this.buffer,h)}writeUInt8(h,N){b(this.buffer,h,N)}indexOf(h,N=0){return l(this.buffer,h instanceof t?h.buffer:h,N)}}e.VSBuffer=t;function l(E,h,N=0){const F=h.byteLength,W=E.byteLength;if(F===0)return 0;if(F===1)return E.indexOf(h[0]);if(F>W-N)return-1;const K=P.value;K.fill(h.length);for(let J=0;J<h.length;J++)K[h[J]]=h.length-J-1;let G=N+h.length-1,V=G,H=-1;for(;G<W;)if(E[G]===h[V]){if(V===0){H=G;break}G--,V--}else G+=Math.max(h.length-V,K[E[G]]),V=h.length-1;return H}e.binaryIndexOf=l;function g(E,h){return E[h+0]<<0>>>0|E[h+1]<<8>>>0}e.readUInt16LE=g;function d(E,h,N){E[N+0]=h&255,h=h>>>8,E[N+1]=h&255}e.writeUInt16LE=d;function o(E,h){return E[h]*2**24+E[h+1]*2**16+E[h+2]*2**8+E[h+3]}e.readUInt32BE=o;function a(E,h,N){E[N+3]=h,h=h>>>8,E[N+2]=h,h=h>>>8,E[N+1]=h,h=h>>>8,E[N]=h}e.writeUInt32BE=a;function i(E,h){return E[h+0]<<0>>>0|E[h+1]<<8>>>0|E[h+2]<<16>>>0|E[h+3]<<24>>>0}e.readUInt32LE=i;function n(E,h,N){E[N+0]=h&255,h=h>>>8,E[N+1]=h&255,h=h>>>8,E[N+2]=h&255,h=h>>>8,E[N+3]=h&255}e.writeUInt32LE=n;function s(E,h){return E[h]}e.readUInt8=s;function b(E,h,N){E[N]=h}e.writeUInt8=b;function O(E){return w.consumeReadable(E,h=>t.concat(h))}e.readableToBuffer=O;function A(E){return w.toReadable(E)}e.bufferToReadable=A;function R(E){return w.consumeStream(E,h=>t.concat(h))}e.streamToBuffer=R;async function L(E){return E.ended?t.concat(E.buffer):t.concat([...E.buffer,await R(E.stream)])}e.bufferedStreamToBuffer=L;function f(E){return w.toStream(E,h=>t.concat(h))}e.bufferToStream=f;function S(E){return w.transform(E,{data:h=>typeof h=="string"?t.fromString(h):t.wrap(h)},h=>t.concat(h))}e.streamToBufferReadableStream=S;function _(E){return w.newWriteableStream(h=>t.concat(h),E)}e.newWriteableBufferStream=_;function C(E,h){return w.prefixedReadable(E,h,N=>t.concat(N))}e.prefixedBufferReadable=C;function U(E,h){return w.prefixedStream(E,h,N=>t.concat(N))}e.prefixedBufferStream=U;function m(E){let h=0,N=0,F=0;const W=new Uint8Array(Math.floor(E.length/4*3)),K=V=>{switch(N){case 3:W[F++]=h|V,N=0;break;case 2:W[F++]=h|V>>>2,h=V<<6,N=3;break;case 1:W[F++]=h|V>>>4,h=V<<4,N=2;break;default:h=V<<2,N=1}};for(let V=0;V<E.length;V++){const H=E.charCodeAt(V);if(H>=65&&H<=90)K(H-65);else if(H>=97&&H<=122)K(H-97+26);else if(H>=48&&H<=57)K(H-48+52);else if(H===43||H===45)K(62);else if(H===47||H===95)K(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${E[V]}`)}}const G=F;for(;N>0;)K(0);return t.wrap(W).slice(0,G)}e.decodeBase64=m;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:E},h=!0,N=!1){const F=N?y:v;let W="";const K=E.byteLength%3;let G=0;for(;G<E.byteLength-K;G+=3){const V=E[G+0],H=E[G+1],J=E[G+2];W+=F[V>>>2],W+=F[(V<<4|H>>>4)&63],W+=F[(H<<2|J>>>6)&63],W+=F[J&63]}if(K===1){const V=E[G+0];W+=F[V>>>2],W+=F[V<<4&63],h&&(W+="==")}else if(K===2){const V=E[G+0],H=E[G+1];W+=F[V>>>2],W+=F[(V<<4|H>>>4)&63],W+=F[H<<2&63],h&&(W+="=")}return W}e.encodeBase64=z}),define(j[26],$([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(j[13],$([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var I;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function w(k){let P=0,r=0,c=0,t=0;for(let l=0,g=k.length;l<g;l++){const d=k.charCodeAt(l);d===13?(P===0&&(r=l),P++,l+1<g&&k.charCodeAt(l+1)===10?(t|=2,l++):t|=3,c=l+1):d===10&&(t|=1,P===0&&(r=l),P++,c=l+1)}return P===0&&(r=k.length),[P,r,k.length-c,t]}e.countEOL=w}),define(j[14],$([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(I||(e.LanguageId=I={}));var w;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(w||(e.FontStyle=w={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var P;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(P||(e.StandardTokenType=P={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class c{static getLanguageId(l){return(l&255)>>>0}static getTokenType(l){return(l&768)>>>8}static containsBalancedBrackets(l){return(l&1024)!==0}static getFontStyle(l){return(l&30720)>>>11}static getForeground(l){return(l&16744448)>>>15}static getBackground(l){return(l&4278190080)>>>24}static getClassNameFromMetadata(l){let d="mtk"+this.getForeground(l);const o=this.getFontStyle(l);return o&1&&(d+=" mtki"),o&2&&(d+=" mtkb"),o&4&&(d+=" mtku"),o&8&&(d+=" mtks"),d}static getInlineStyleFromMetadata(l,g){const d=this.getForeground(l),o=this.getFontStyle(l);let a=`color: ${g[d]};`;o&1&&(a+="font-style: italic;"),o&2&&(a+="font-weight: bold;");let i="";return o&4&&(i+=" underline"),o&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(l){const g=this.getForeground(l),d=this.getFontStyle(l);return{foreground:g,italic:!!(d&1),bold:!!(d&2),underline:!!(d&4),strikethrough:!!(d&8)}}}e.TokenMetadata=c}),define(j[27],$([0,1,28]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class w{constructor(r){this._default=r,this._store=[]}get(r){return r<this._store.length?this._store[r]:this._default}set(r,c){for(;r>=this._store.length;)this._store[this._store.length]=this._default;this._store[r]=c}replace(r,c,t){if(r>=this._store.length)return;if(c===0){this.insert(r,t);return}else if(t===0){this.delete(r,c);return}const l=this._store.slice(0,r),g=this._store.slice(r+c),d=k(t,this._default);this._store=l.concat(d,g)}delete(r,c){c===0||r>=this._store.length||this._store.splice(r,c)}insert(r,c){if(c===0||r>=this._store.length)return;const t=[];for(let l=0;l<c;l++)t[l]=this._default;this._store=(0,I.arrayInsert)(this._store,r,t)}}e.FixedArray=w;function k(P,r){const c=[];for(let t=0;t<P;t++)c[t]=r;return c}}),define(j[7],$([0,1,14]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class w{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,c){const t=w.defaultTokenMetadata,l=new Uint32Array(2);return l[0]=r.length,l[1]=t,new w(l,r,c)}constructor(r,c,t){this._lineTokensBrand=void 0,this._tokens=r,this._tokensCount=this._tokens.length>>>1,this._text=c,this._languageIdCodec=t}equals(r){return r instanceof w?this.slicedEquals(r,0,this._tokensCount):!1}slicedEquals(r,c,t){if(this._text!==r._text||this._tokensCount!==r._tokensCount)return!1;const l=c<<1,g=l+(t<<1);for(let d=l;d<g;d++)if(this._tokens[d]!==r._tokens[d])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(r){return r>0?this._tokens[r-1<<1]:0}getMetadata(r){return this._tokens[(r<<1)+1]}getLanguageId(r){const c=this._tokens[(r<<1)+1],t=I.TokenMetadata.getLanguageId(c);return this._languageIdCodec.decodeLanguageId(t)}getStandardTokenType(r){const c=this._tokens[(r<<1)+1];return I.TokenMetadata.getTokenType(c)}getForeground(r){const c=this._tokens[(r<<1)+1];return I.TokenMetadata.getForeground(c)}getClassName(r){const c=this._tokens[(r<<1)+1];return I.TokenMetadata.getClassNameFromMetadata(c)}getInlineStyle(r,c){const t=this._tokens[(r<<1)+1];return I.TokenMetadata.getInlineStyleFromMetadata(t,c)}getPresentation(r){const c=this._tokens[(r<<1)+1];return I.TokenMetadata.getPresentationFromMetadata(c)}getEndOffset(r){return this._tokens[r<<1]}findTokenIndexAtOffset(r){return w.findIndexInTokensArray(this._tokens,r)}inflate(){return this}sliceAndInflate(r,c,t){return new k(this,r,c,t)}static convertToEndOffset(r,c){const l=(r.length>>>1)-1;for(let g=0;g<l;g++)r[g<<1]=r[g+1<<1];r[l<<1]=c}static findIndexInTokensArray(r,c){if(r.length<=2)return 0;let t=0,l=(r.length>>>1)-1;for(;t<l;){const g=t+Math.floor((l-t)/2),d=r[g<<1];if(d===c)return g+1;d<c?t=g+1:d>c&&(l=g)}return t}withInserted(r){if(r.length===0)return this;let c=0,t=0,l="";const g=new Array;let d=0;for(;;){const o=c<this._tokensCount?this._tokens[c<<1]:-1,a=t<r.length?r[t]:null;if(o!==-1&&(a===null||o<=a.offset)){l+=this._text.substring(d,o);const i=this._tokens[(c<<1)+1];g.push(l.length,i),c++,d=o}else if(a){if(a.offset>d){l+=this._text.substring(d,a.offset);const i=this._tokens[(c<<1)+1];g.push(l.length,i),d=a.offset}l+=a.text,g.push(l.length,a.tokenMetadata),t++}else break}return new w(new Uint32Array(g),l,this._languageIdCodec)}}e.LineTokens=w;class k{constructor(r,c,t,l){this._source=r,this._startOffset=c,this._endOffset=t,this._deltaOffset=l,this._firstTokenIndex=r.findTokenIndexAtOffset(c),this._tokensCount=0;for(let g=this._firstTokenIndex,d=r.getCount();g<d&&!(r.getStartOffset(g)>=t);g++)this._tokensCount++}getMetadata(r){return this._source.getMetadata(this._firstTokenIndex+r)}getLanguageId(r){return this._source.getLanguageId(this._firstTokenIndex+r)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(r){return r instanceof k?this._startOffset===r._startOffset&&this._endOffset===r._endOffset&&this._deltaOffset===r._deltaOffset&&this._source.slicedEquals(r._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(r){return this._source.getForeground(this._firstTokenIndex+r)}getEndOffset(r){const c=this._source.getEndOffset(this._firstTokenIndex+r);return Math.min(this._endOffset,c)-this._startOffset+this._deltaOffset}getClassName(r){return this._source.getClassName(this._firstTokenIndex+r)}getInlineStyle(r,c){return this._source.getInlineStyle(this._firstTokenIndex+r,c)}getPresentation(r){return this._source.getPresentation(this._firstTokenIndex+r)}findTokenIndexAtOffset(r){return this._source.findTokenIndexAtOffset(r+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(j[29],$([0,1,7]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class w{static deleteBeginning(r,c){return r===null||r===e.EMPTY_LINE_TOKENS?r:w.delete(r,0,c)}static deleteEnding(r,c){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const t=k(r),l=t[t.length-2];return w.delete(r,c,l)}static delete(r,c,t){if(r===null||r===e.EMPTY_LINE_TOKENS||c===t)return r;const l=k(r),g=l.length>>>1;if(c===0&&l[l.length-2]===t)return e.EMPTY_LINE_TOKENS;const d=I.LineTokens.findIndexInTokensArray(l,c),o=d>0?l[d-1<<1]:0,a=l[d<<1];if(t<a){const O=t-c;for(let A=d;A<g;A++)l[A<<1]-=O;return r}let i,n;o!==c?(l[d<<1]=c,i=d+1<<1,n=c):(i=d<<1,n=o);const s=t-c;for(let O=d+1;O<g;O++){const A=l[O<<1]-s;A>n&&(l[i++]=A,l[i++]=l[(O<<1)+1],n=A)}if(i===l.length)return r;const b=new Uint32Array(i);return b.set(l.subarray(0,i),0),b.buffer}static append(r,c){if(c===e.EMPTY_LINE_TOKENS)return r;if(r===e.EMPTY_LINE_TOKENS)return c;if(r===null)return r;if(c===null)return null;const t=k(r),l=k(c),g=l.length>>>1,d=new Uint32Array(t.length+l.length);d.set(t,0);let o=t.length;const a=t[t.length-2];for(let i=0;i<g;i++)d[o++]=l[i<<1]+a,d[o++]=l[(i<<1)+1];return d.buffer}static insert(r,c,t){if(r===null||r===e.EMPTY_LINE_TOKENS)return r;const l=k(r),g=l.length>>>1;let d=I.LineTokens.findIndexInTokensArray(l,c);d>0&&l[d-1<<1]===c&&d--;for(let o=d;o<g;o++)l[o<<1]+=t;return r}}e.ContiguousTokensEditing=w;function k(P){return P instanceof Uint32Array?P:new Uint32Array(P)}e.toUint32Array=k}),define(j[30],$([0,1,28,12,44,13,29,15]),function(q,e,I,w,k,P,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(g,d,o){const a=new Uint32Array(g.buffer),i=(0,w.readUInt32BE)(g,d);d+=4;const n=(0,w.readUInt32BE)(g,d);d+=4;const s=[];for(let b=0;b<n;b++){const O=(0,w.readUInt32BE)(g,d);d+=4,s.push(a.subarray(d/4,d/4+O/4)),d+=O}return o.push(new t(i,s)),d}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(g,d){this._startLineNumber=g,this._tokens=d}getLineRange(){return new c.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(g){return this._tokens[g-this._startLineNumber]}appendLineTokens(g){this._tokens.push(g)}serializeSize(){let g=0;g+=4,g+=4;for(let d=0;d<this._tokens.length;d++){const o=this._tokens[d];if(!(o instanceof Uint32Array))throw new Error("Not supported!");g+=4,g+=o.byteLength}return g}serialize(g,d){(0,w.writeUInt32BE)(g,this._startLineNumber,d),d+=4,(0,w.writeUInt32BE)(g,this._tokens.length,d),d+=4;for(let o=0;o<this._tokens.length;o++){const a=this._tokens[o];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,w.writeUInt32BE)(g,a.byteLength,d),d+=4,g.set(new Uint8Array(a.buffer),d),d+=a.byteLength}return d}applyEdit(g,d){const[o,a]=(0,P.countEOL)(d);this._acceptDeleteRange(g),this._acceptInsertText(new k.Position(g.startLineNumber,g.startColumn),o,a)}_acceptDeleteRange(g){if(g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn)return;const d=g.startLineNumber-this._startLineNumber,o=g.endLineNumber-this._startLineNumber;if(o<0){const a=o-d;this._startLineNumber-=a;return}if(!(d>=this._tokens.length)){if(d<0&&o>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(d===o){this._tokens[d]=r.ContiguousTokensEditing.delete(this._tokens[d],g.startColumn-1,g.endColumn-1);return}if(d>=0)if(this._tokens[d]=r.ContiguousTokensEditing.deleteEnding(this._tokens[d],g.startColumn-1),o<this._tokens.length){const a=r.ContiguousTokensEditing.deleteBeginning(this._tokens[o],g.endColumn-1);this._tokens[d]=r.ContiguousTokensEditing.append(this._tokens[d],a),this._tokens.splice(d+1,o-d)}else this._tokens[d]=r.ContiguousTokensEditing.append(this._tokens[d],null),this._tokens=this._tokens.slice(0,d+1);else{const a=-d;this._startLineNumber-=a,this._tokens[o]=r.ContiguousTokensEditing.deleteBeginning(this._tokens[o],g.endColumn-1),this._tokens=this._tokens.slice(o)}}}_acceptInsertText(g,d,o){if(d===0&&o===0)return;const a=g.lineNumber-this._startLineNumber;if(a<0){this._startLineNumber+=d;return}if(!(a>=this._tokens.length)){if(d===0){this._tokens[a]=r.ContiguousTokensEditing.insert(this._tokens[a],g.column-1,o);return}this._tokens[a]=r.ContiguousTokensEditing.deleteEnding(this._tokens[a],g.column-1),this._tokens[a]=r.ContiguousTokensEditing.insert(this._tokens[a],g.column-1,o),this._insertLines(g.lineNumber,d)}}_insertLines(g,d){if(d===0)return;const o=[];for(let a=0;a<d;a++)o[a]=null;this._tokens=I.arrayInsert(this._tokens,g,o)}}e.ContiguousMultilineTokens=t}),define(j[16],$([0,1,12,30]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class k{static deserialize(r){let c=0;const t=(0,I.readUInt32BE)(r,c);c+=4;const l=[];for(let g=0;g<t;g++)c=w.ContiguousMultilineTokens.deserialize(r,c,l);return l}constructor(){this._tokens=[]}add(r,c){if(this._tokens.length>0){const t=this._tokens[this._tokens.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(c);return}}this._tokens.push(new w.ContiguousMultilineTokens(r,[c]))}finalize(){return this._tokens}serialize(){const r=this._serializeSize(),c=new Uint8Array(r);return this._serialize(c),c}_serializeSize(){let r=0;r+=4;for(let c=0;c<this._tokens.length;c++)r+=this._tokens[c].serializeSize();return r}_serialize(r){let c=0;(0,I.writeUInt32BE)(r,this._tokens.length,c),c+=4;for(let t=0;t<this._tokens.length;t++)c=this._tokens[t].serialize(r,c)}}e.ContiguousMultilineTokensBuilder=k}),define(j[31],$([0,1,32,3,17,45]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(m){return m===47||m===92}e.isPathSeparator=r;function c(m){return m.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=c;function t(m){return m.indexOf("/")===-1&&(m=c(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.toPosixPath=t;function l(m,v=I.posix.sep){if(!m)return"";const y=m.length,z=m.charCodeAt(0);if(r(z)){if(r(m.charCodeAt(1))&&!r(m.charCodeAt(2))){let h=3;const N=h;for(;h<y&&!r(m.charCodeAt(h));h++);if(N!==h&&!r(m.charCodeAt(h+1))){for(h+=1;h<y;h++)if(r(m.charCodeAt(h)))return m.slice(0,h+1).replace(/[\\/]/g,v)}}return v}else if(b(z)&&m.charCodeAt(1)===58)return r(m.charCodeAt(2))?m.slice(0,2)+v:m.slice(0,2);let E=m.indexOf("://");if(E!==-1){for(E+=3;E<y;E++)if(r(m.charCodeAt(E)))return m.slice(0,E+1)}return""}e.getRoot=l;function g(m){if(!w.isWindows||!m||m.length<5)return!1;let v=m.charCodeAt(0);if(v!==92||(v=m.charCodeAt(1),v!==92))return!1;let y=2;const z=y;for(;y<m.length&&(v=m.charCodeAt(y),v!==92);y++);return!(z===y||(v=m.charCodeAt(y+1),isNaN(v)||v===92))}e.isUNC=g;const d=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(m,v=w.isWindows){const y=v?d:o;return!(!m||m.length===0||/^\s+$/.test(m)||(y.lastIndex=0,y.test(m))||v&&a.test(m)||m==="."||m===".."||v&&m[m.length-1]==="."||v&&m.length!==m.trim().length||m.length>255)}e.isValidBasename=i;function n(m,v,y){const z=m===v;return!y||z?z:!m||!v?!1:(0,k.equalsIgnoreCase)(m,v)}e.isEqual=n;function s(m,v,y,z=I.sep){if(m===v)return!0;if(!m||!v||v.length>m.length)return!1;if(y){if(!(0,k.startsWithIgnoreCase)(m,v))return!1;if(v.length===m.length)return!0;let h=v.length;return v.charAt(v.length-1)===z&&h--,m.charAt(h)===z}return v.charAt(v.length-1)!==z&&(v+=z),m.indexOf(v)===0}e.isEqualOrParent=s;function b(m){return m>=65&&m<=90||m>=97&&m<=122}e.isWindowsDriveLetter=b;function O(m,v){return w.isWindows&&m.endsWith(":")&&(m+=I.sep),(0,I.isAbsolute)(m)||(m=(0,I.join)(v,m)),m=(0,I.normalize)(m),w.isWindows?(m=(0,k.rtrim)(m,I.sep),m.endsWith(":")&&(m+=I.sep)):(m=(0,k.rtrim)(m,I.sep),m||(m=I.sep)),m}e.sanitizeFilePath=O;function A(m){const v=(0,I.normalize)(m);return w.isWindows?m.length>3?!1:R(v)&&(m.length===2||v.charCodeAt(2)===92):v===I.posix.sep}e.isRootOrDriveLetter=A;function R(m,v=w.isWindows){return v?b(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.hasDriveLetter=R;function L(m,v=w.isWindows){return R(m,v)?m[0]:void 0}e.getDriveLetter=L;function f(m,v,y){return v.length>m.length?-1:m===v?0:(y&&(m=m.toLowerCase(),v=v.toLowerCase()),m.indexOf(v))}e.indexOfPath=f;function S(m){const v=m.split(":");let y,z,E;for(const h of v){const N=Number(h);(0,P.isNumber)(N)?z===void 0?z=N:E===void 0&&(E=N):y=y?[y,h].join(":"):h}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:z!==void 0?z:void 0,column:E!==void 0?E:z!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",C="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U(m,v,y=8){let z="";for(let h=0;h<y;h++){let N;h===0&&w.isWindows&&!v&&(y===3||y===4)?N=C:N=_,z+=N.charAt(Math.floor(Math.random()*N.length))}let E;return v?E=`${v}-${z}`:E=z,m?(0,I.join)(m,E):E}e.randomPath=U}),define(j[18],$([0,1,6,3,17,8]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.matchesSomeScheme=e.matchesScheme=e.Schemas=void 0;var r;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm"})(r||(e.Schemas=r={}));function c(o,a){return P.URI.isUri(o)?(0,k.equalsIgnoreCase)(o.scheme,a):(0,k.startsWithIgnoreCase)(o,a+":")}e.matchesScheme=c;function t(o,...a){return a.some(i=>c(o,i))}e.matchesSomeScheme=t,e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class l{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${r.vscodeRemoteResource}`}setPreferredWebSchema(a){this._preferredWebSchema=a}setDelegate(a){this._delegate=a}setServerRootPath(a){this._remoteResourcesPath=`${a}/${r.vscodeRemoteResource}`}set(a,i,n){this._hosts[a]=i,this._ports[a]=n}setConnectionToken(a,i){this._connectionTokens[a]=i}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(a){if(this._delegate)try{return this._delegate(a)}catch(A){return I.onUnexpectedError(A),a}const i=a.authority;let n=this._hosts[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this._ports[i],b=this._connectionTokens[i];let O=`path=${encodeURIComponent(a.path)}`;return typeof b=="string"&&(O+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),P.URI.from({scheme:w.isWeb?this._preferredWebSchema:r.vscodeRemoteResource,authority:`${n}:${s}`,path:this._remoteResourcesPath,query:O})}}e.RemoteAuthorities=new l,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class g{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(a){const i=this.toUri(a,q);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===r.vscodeRemote?e.RemoteAuthorities.rewrite(a):a.scheme===r.file&&(w.isNative||w.webWorkerOrigin===`${r.vscodeFileResource}://${g.FALLBACK_AUTHORITY}`)?a.with({scheme:r.vscodeFileResource,authority:a.authority||g.FALLBACK_AUTHORITY,query:null,fragment:null}):a}asFileUri(a){const i=this.toUri(a,q);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===r.vscodeFileResource?a.with({scheme:r.file,authority:a.authority!==g.FALLBACK_AUTHORITY?a.authority:null,query:null,fragment:null}):a}toUri(a,i){return P.URI.isUri(a)?a:P.URI.parse(i.toUrl(a))}}e.FileAccess=new g;var d;(function(o){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(b){let O;typeof b=="string"?O=new URL(b).searchParams:b instanceof URL?O=b.searchParams:P.URI.isUri(b)&&(O=new URL(b.toString(!0)).searchParams);const A=O?.get(i);if(A)return a.get(A)}o.getHeadersFromQuery=n;function s(b,O,A){if(!globalThis.crossOriginIsolated)return;const R=O&&A?"3":A?"2":"1";b instanceof URLSearchParams?b.set(i,R):b[i]=R}o.addSearchParam=s})(d||(e.COI=d={}))}),define(j[33],$([0,1,22,18,3,8]),function(q,e,I,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=void 0;class r{constructor(o,a,i){this.id=o,this.dependencies=a,this.callback=i}}class c{static{this.INSTANCE=new c}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(o,a,i)=>{typeof o!="string"&&(i=a,a=o,o=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this._defineCalls.push(new r(o,a,i))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){if(o.startsWith(window.location.origin)||o.startsWith("vscode-file://vscode-app"))return o;throw new Error(`[trusted_script_src] Invalid script url: ${o}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){return o}})))}async load(o){this._initialize();const a=await(this._isWebWorker?this._workerLoadScript(o):this._isRenderer?this._rendererLoadScript(o):this._nodeJSLoadScript(o));if(!a)throw new Error(`Did not receive a define call from script ${o}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${o}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}_rendererLoadScript(o){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const s=()=>{n.removeEventListener("load",b),n.removeEventListener("error",O)},b=A=>{s(),a(this._defineCalls.pop())},O=A=>{s(),i(A)};n.addEventListener("load",b),n.addEventListener("error",O),this._amdPolicy&&(o=this._amdPolicy.createScriptURL(o)),n.setAttribute("src",o),window.document.getElementsByTagName("head")[0].appendChild(n)})}_workerLoadScript(o){return new Promise((a,i)=>{try{this._amdPolicy&&(o=this._amdPolicy.createScriptURL(o)),importScripts(o),a(this._defineCalls.pop())}catch(n){i(n)}})}async _nodeJSLoadScript(o){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,s=P.URI.parse(o).fsPath,b=a.readFileSync(s).toString(),O=n.wrap(b.replace(/^#!.*/,""));return new i.Script(O).runInThisContext().apply(),this._defineCalls.pop()}catch(a){throw a}}}const t=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function g(d,o,a){if(I.isESM){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[d]&&(d=l[d]);const i=`${d}/${o}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const A=`${a&&!k.isWeb?w.nodeModulesAsarPath:w.nodeModulesPath}/${i}`;n=w.FileAccess.asBrowserUri(A).toString(!0)}const s=c.INSTANCE.load(n);return t.set(i,s),s}else return await new Promise((i,n)=>{q([d],i,n)})}e.importAMDNodeModule=g}),define(j[19],$([0,1,31,18,32,3,17,8]),function(q,e,I,w,k,P,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(a){return(0,c.uriToFsPath)(a,!0)}e.originalFSPath=t;class l{constructor(i){this._ignorePathCasing=i}compare(i,n,s=!1){return i===n?0:(0,r.compare)(this.getComparisonKey(i,s),this.getComparisonKey(n,s))}isEqual(i,n,s=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,s)===this.getComparisonKey(n,s)}getComparisonKey(i,n=!1){return i.with({path:this._ignorePathCasing(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this._ignorePathCasing(i)}isEqualOrParent(i,n,s=!1){if(i.scheme===n.scheme){if(i.scheme===w.Schemas.file)return I.isEqualOrParent(t(i),t(n),this._ignorePathCasing(i))&&i.query===n.query&&(s||i.fragment===n.fragment);if((0,e.isEqualAuthority)(i.authority,n.authority))return I.isEqualOrParent(i.path,n.path,this._ignorePathCasing(i),"/")&&i.query===n.query&&(s||i.fragment===n.fragment)}return!1}joinPath(i,...n){return c.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.basename)(i)||i.authority}basename(i){return k.posix.basename(i.path)}extname(i){return k.posix.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===w.Schemas.file?n=c.URI.file(k.dirname(t(i))).path:(n=k.posix.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===w.Schemas.file?n=c.URI.file(k.normalize(t(i))).path:n=k.posix.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.isEqualAuthority)(i.authority,n.authority))return;if(i.scheme===w.Schemas.file){const O=k.relative(t(i),t(n));return P.isWindows?I.toSlashes(O):O}let s=i.path||"/";const b=n.path||"/";if(this._ignorePathCasing(i)){let O=0;for(const A=Math.min(s.length,b.length);O<A&&!(s.charCodeAt(O)!==b.charCodeAt(O)&&s.charAt(O).toLowerCase()!==b.charAt(O).toLowerCase());O++);s=b.substr(0,O)+s.substr(O)}return k.posix.relative(s,b)}resolvePath(i,n){if(i.scheme===w.Schemas.file){const s=c.URI.file(k.resolve(t(i),n));return i.with({authority:s.authority,path:s.path})}return n=I.toPosixPath(n),i.with({path:k.posix.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,r.equalsIgnoreCase)(i,n)}hasTrailingPathSeparator(i,n=k.sep){if(i.scheme===w.Schemas.file){const s=t(i);return s.length>I.getRoot(s).length&&s[s.length-1]===n}else{const s=i.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=k.sep){return(0,e.hasTrailingPathSeparator)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=k.sep){let s=!1;if(i.scheme===w.Schemas.file){const b=t(i);s=b!==void 0&&b.length===I.getRoot(b).length&&b[b.length-1]===n}else{n="/";const b=i.path;s=b.length===1&&b.charCodeAt(b.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(i,n)?i.with({path:i.path+"/"}):i}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(a=>a.scheme===w.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new l(a=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function g(a,i){const n=[];for(let s=0;s<a.length;s++){const b=i(a[s]);a.some((O,A)=>A===s?!1:(0,e.isEqualOrParent)(b,i(O)))||n.push(a[s])}return n}e.distinctParents=g;var d;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const s=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(A=>{const[R,L]=A.split(":");R&&L&&s.set(R,L)});const O=n.path.substring(0,n.path.indexOf(";"));return O&&s.set(a.META_DATA_MIME,O),s}a.parseMetaData=i})(d||(e.DataUri=d={}));function o(a,i,n){if(i){let s=a.path;return s&&s[0]!==k.posix.sep&&(s=k.posix.sep+s),a.with({scheme:n,authority:i,path:s})}return a.with({scheme:n})}e.toLocalResource=o}),define(j[20],$([0,1,46,6,34,2,19,3,26,25]),function(q,e,I,w,k,P,r,c,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(M){return!!M&&typeof M.then=="function"}e.isThenable=g;function d(M){const u=new I.CancellationTokenSource,T=M(u.token),p=new Promise((D,B)=>{const Y=u.token.onCancellationRequested(()=>{Y.dispose(),u.dispose(),B(new w.CancellationError)});Promise.resolve(T).then(Z=>{Y.dispose(),u.dispose(),D(Z)},Z=>{Y.dispose(),u.dispose(),B(Z)})});return new class{cancel(){u.cancel()}then(D,B){return p.then(D,B)}catch(D){return this.then(void 0,D)}finally(D){return p.finally(D)}}}e.createCancelablePromise=d;function o(M,u,T){return new Promise((p,D)=>{const B=u.onCancellationRequested(()=>{B.dispose(),p(T)});M.then(p,D).finally(()=>B.dispose())})}e.raceCancellation=o;function a(M,u){return new Promise((T,p)=>{const D=u.onCancellationRequested(()=>{D.dispose(),p(new w.CancellationError)});M.then(T,p).finally(()=>D.dispose())})}e.raceCancellationError=a;async function i(M){let u=-1;const T=M.map((p,D)=>p.then(B=>(u=D,B)));try{return await Promise.race(T)}finally{M.forEach((p,D)=>{D!==u&&p.cancel()})}}e.raceCancellablePromises=i;function n(M,u,T){let p;const D=setTimeout(()=>{p?.(void 0),T?.()},u);return Promise.race([M.finally(()=>clearTimeout(D)),new Promise(B=>p=B)])}e.raceTimeout=n;function s(M){return new Promise((u,T)=>{const p=M();g(p)?p.then(u,T):u(p)})}e.asPromise=s;class b{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(u){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=u,!this.queuedPromise){const T=()=>{if(this.queuedPromise=null,this.isDisposed)return;const p=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,p};this.queuedPromise=new Promise(p=>{this.activePromise.then(T,T).then(p)})}return new Promise((T,p)=>{this.queuedPromise.then(T,p)})}return this.activePromise=u(),new Promise((T,p)=>{this.activePromise.then(D=>{this.activePromise=null,T(D)},D=>{this.activePromise=null,p(D)})})}dispose(){this.isDisposed=!0}}e.Throttler=b;class O{constructor(){this.current=Promise.resolve(null)}queue(u){return this.current=this.current.then(()=>u(),()=>u())}}e.Sequencer=O;class A{constructor(){this.promiseMap=new Map}queue(u,T){const D=(this.promiseMap.get(u)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(u)===D&&this.promiseMap.delete(u)});return this.promiseMap.set(u,D),D}}e.SequencerByKey=A;const R=(M,u)=>{let T=!0;const p=setTimeout(()=>{T=!1,u()},M);return{isTriggered:()=>T,dispose:()=>{clearTimeout(p),T=!1}}},L=M=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,M())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class f{constructor(u){this.defaultDelay=u,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(u,T=this.defaultDelay){this.task=u,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((D,B)=>{this.doResolve=D,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const D=this.task;return this.task=null,D()}}));const p=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===t.MicrotaskDelay?L(p):R(T,p),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new w.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class S{constructor(u){this.delayer=new f(u),this.throttler=new b}trigger(u,T){return this.delayer.trigger(()=>this.throttler.queue(u),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=S;class _{constructor(){this._isOpen=!1,this._promise=new Promise((u,T)=>{this._completePromise=u})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class C extends _{constructor(u){super(),this._timeout=setTimeout(()=>this.open(),u)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=C;function U(M,u){return u?new Promise((T,p)=>{const D=setTimeout(()=>{B.dispose(),T()},M),B=u.onCancellationRequested(()=>{clearTimeout(D),B.dispose(),p(new w.CancellationError)})}):d(T=>U(M,T))}e.timeout=U;function m(M,u=0,T){const p=setTimeout(()=>{M(),T&&D.dispose()},u),D=(0,P.toDisposable)(()=>{clearTimeout(p),T?.deleteAndLeak(D)});return T?.add(D),D}e.disposableTimeout=m;function v(M){const u=[];let T=0;const p=M.length;function D(){return T<p?M[T++]():null}function B(Y){Y!=null&&u.push(Y);const Z=D();return Z?Z.then(B):Promise.resolve(u)}return Promise.resolve(null).then(B)}e.sequence=v;function y(M,u=p=>!!p,T=null){let p=0;const D=M.length,B=()=>{if(p>=D)return Promise.resolve(T);const Y=M[p++];return Promise.resolve(Y()).then(X=>u(X)?Promise.resolve(X):B())};return B()}e.first=y;function z(M,u=p=>!!p,T=null){if(M.length===0)return Promise.resolve(T);let p=M.length;const D=()=>{p=-1;for(const B of M)B.cancel?.()};return new Promise((B,Y)=>{for(const Z of M)Z.then(X=>{--p>=0&&u(X)?(D(),B(X)):p===0&&B(T)}).catch(X=>{--p>=0&&(D(),Y(X))})})}e.firstParallel=z;class E{constructor(u){this._size=0,this.maxDegreeOfParalellism=u,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(u){return this._size++,new Promise((T,p)=>{this.outstandingPromises.push({factory:u,c:T,e:p}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const u=this.outstandingPromises.shift();this.runningPromises++;const T=u.factory();T.then(u.c,u.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=E;class h extends E{constructor(){super(1)}}e.Queue=h;class N{constructor(){this.sequentializer=new te,this.tasks=0}queue(u){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,u())):this.sequentializer.run(this.tasks++,u())}}e.LimitedQueue=N;class F{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const u=new x;return this.drainers.add(u),u.p}isDrained(){for(const[,u]of this.queues)if(u.size>0)return!1;return!0}queueFor(u,T=r.extUri){const p=T.getComparisonKey(u);let D=this.queues.get(p);if(!D){D=new h;const B=this.drainListenerCount++,Y=k.Event.once(D.onDrained)(()=>{D?.dispose(),this.queues.delete(p),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(B),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new P.DisposableMap),this.drainListeners.set(B,Y),this.queues.set(p,D)}return D}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const u of this.drainers)u.complete();this.drainers.clear()}dispose(){for(const[,u]of this.queues)u.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=F;class W{constructor(u,T){this._token=-1,typeof u=="function"&&typeof T=="number"&&this.setIfNotSet(u,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(u,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,u()},T)}setIfNotSet(u,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,u()},T))}}e.TimeoutTimer=W;class K{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(u,T,p=globalThis){this.cancel();const D=p.setInterval(()=>{u()},T);this.disposable=(0,P.toDisposable)(()=>{p.clearInterval(D),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=K;class G{constructor(u,T){this.timeoutToken=-1,this.runner=u,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(u=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,u)}get delay(){return this.timeout}set delay(u){this.timeout=u}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=G;class V{constructor(u,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=u,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(u=this.timeout){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(u/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class H extends G{constructor(u,T){super(u,T),this.units=[]}work(u){this.units.push(u),this.isScheduled()||this.schedule()}doRun(){const u=this.units;this.units=[],this.runner?.(u)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class J extends P.Disposable{constructor(u,T){super(),this.options=u,this.handler=T,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(u){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+u.length>this.options.maxBufferedWork)return!1}else if(this.pending+u.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of u)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(M,u)=>{(0,c.setTimeout0)(()=>{if(T)return;const p=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,p-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e._runWhenIdle=(M,u,T)=>{const p=M.requestIdleCallback(u,typeof T=="number"?{timeout:T}:void 0);let D=!1;return{dispose(){D||(D=!0,M.cancelIdleCallback(p))}}},e.runWhenGlobalIdle=M=>(0,e._runWhenIdle)(globalThis,M)}();class ee{constructor(u,T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(p){this._error=p}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(u,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class oe extends ee{constructor(u){super(globalThis,u)}}e.GlobalIdleValue=oe;async function ue(M,u,T){let p;for(let D=0;D<T;D++)try{return await M()}catch(B){p=B,await U(u)}throw p}e.retry=ue;class te{isRunning(u){return typeof u=="number"?this._running?.taskId===u:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(u,T,p){return this._running={taskId:u,cancel:()=>p?.(),promise:T},T.then(()=>this.doneRunning(u),()=>this.doneRunning(u)),T}doneRunning(u){this._running&&u===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const u=this._queued;this._queued=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this._queued)this._queued.run=u;else{let T,p;const D=new Promise((B,Y)=>{T=B,p=Y});this._queued={run:u,promise:D,promiseResolve:T,promiseReject:p}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=te;class le{constructor(u,T=()=>Date.now()){this.interval=u,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const u=this.nowFn();return u-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=u,this.value=0),this.value++,this.value}}e.IntervalCounter=le;var ne;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((u,T)=>{this.completeCallback=u,this.errorCallback=T})}complete(u){return new Promise(T=>{this.completeCallback(u),this.outcome={outcome:0,value:u},T()})}error(u){return new Promise(T=>{this.errorCallback(u),this.outcome={outcome:1,value:u},T()})}cancel(){return this.error(new w.CancellationError)}}e.DeferredPromise=x;var ie;(function(M){async function u(p){let D;const B=await Promise.all(p.map(Y=>Y.then(Z=>Z,Z=>{D||(D=Z)})));if(typeof D<"u")throw D;return B}M.settled=u;function T(p){return new Promise(async(D,B)=>{try{await p(D,B)}catch(Y){B(Y)}})}M.withAsyncBody=T})(ie||(e.Promises=ie={}));class re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(u){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=u.then(T=>(this._value=T,this._isResolved=!0,T),T=>{throw this._error=T,this._isResolved=!0,T})}requireValue(){if(!this._isResolved)throw new w.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=re;class de{constructor(u){this._compute=u,this._promise=new l.Lazy(()=>new re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}}e.LazyStatefulPromise=de;var se;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(se||(se={}));class Q{static fromArray(u){return new Q(T=>{T.emitMany(u)})}static fromPromise(u){return new Q(async T=>{T.emitMany(await u)})}static fromPromises(u){return new Q(async T=>{await Promise.all(u.map(async p=>T.emitOne(await p)))})}static merge(u){return new Q(async T=>{await Promise.all(u.map(async p=>{for await(const D of p)T.emitOne(D)}))})}static{this.EMPTY=Q.fromArray([])}constructor(u){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const T={emitOne:p=>this.emitOne(p),emitMany:p=>this.emitMany(p),reject:p=>this.reject(p)};try{await Promise.resolve(u(T)),this.resolve()}catch(p){this.reject(p)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(u<this._results.length)return{done:!1,value:this._results[u++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(u,T){return new Q(async p=>{for await(const D of u)p.emitOne(T(D))})}map(u){return Q.map(this,u)}static filter(u,T){return new Q(async p=>{for await(const D of u)T(D)&&p.emitOne(D)})}filter(u){return Q.filter(this,u)}static coalesce(u){return Q.filter(u,T=>!!T)}coalesce(){return Q.coalesce(this)}static async toPromise(u){const T=[];for await(const p of u)T.push(p);return T}toPromise(){return Q.toPromise(this)}emitOne(u){this._state===0&&(this._results.push(u),this._onStateChanged.fire())}emitMany(u){this._state===0&&(this._results=this._results.concat(u),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(u){this._state===0&&(this._state=2,this._error=u,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class ae extends Q{constructor(u,T){super(T),this._source=u}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function ce(M){const u=new I.CancellationTokenSource,T=M(u.token);return new ae(u,async p=>{const D=u.token.onCancellationRequested(()=>{D.dispose(),u.dispose(),p.reject(new w.CancellationError)});try{for await(const B of T){if(u.token.isCancellationRequested)return;p.emitOne(B)}D.dispose(),u.dispose()}catch(B){D.dispose(),u.dispose(),p.reject(B)}})}e.createCancelableAsyncIterable=ce;class he{constructor(){this._deferred=new x,this._asyncIterable=new Q(p=>{if(u){p.reject(u);return}return T&&p.emitMany(T),this._errorFn=D=>p.reject(D),this._emitFn=D=>p.emitOne(D),this._deferred.p});let u,T;this._emitFn=p=>{T||(T=[]),T.push(p)},this._errorFn=p=>{u||(u=p)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(u){this._errorFn(u),this._deferred.complete()}emitOne(u){this._emitFn(u)}}e.AsyncIterableSource=he}),define(j[21],$([0,1,35]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(P){return this===P}};function w(P,r){return new I.TokenizationResult([new I.Token(0,"",P)],r)}e.nullTokenize=w;function k(P,r){const c=new Uint32Array(2);return c[0]=0,c[1]=(P<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new I.EncodedTokenizationResult(c,r===null?e.NullState:r)}e.nullTokenizeEncoded=k}),define(j[36],$([0,1,20,6,3,37,13,15,47,21,27,16,7]),function(q,e,I,w,k,P,r,c,t,l,g,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var a;(function(L){L[L.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(f,S){this.tokenizationSupport=S,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=i;class n extends i{constructor(f,S,_,C){super(f,S),this._textModel=_,this._languageIdCodec=C}updateTokensUntilLine(f,S){const _=this._textModel.getLanguageId();for(;;){const C=this.getFirstInvalidLine();if(!C||C.lineNumber>S)break;const U=this._textModel.getLineContent(C.lineNumber),m=A(this._languageIdCodec,_,this.tokenizationSupport,U,!0,C.startState);f.add(C.lineNumber,m.tokens),this.store.setEndState(C.lineNumber,m.endState)}}getTokenTypeIfInsertingCharacter(f,S){const _=this.getStartState(f.lineNumber);if(!_)return 0;const C=this._textModel.getLanguageId(),U=this._textModel.getLineContent(f.lineNumber),m=U.substring(0,f.column-1)+S+U.substring(f.column-1),v=A(this._languageIdCodec,C,this.tokenizationSupport,m,!0,_),y=new o.LineTokens(v.tokens,m,this._languageIdCodec);if(y.getCount()===0)return 0;const z=y.findTokenIndexAtOffset(f.column-1);return y.getStandardTokenType(z)}tokenizeLineWithEdit(f,S,_){const C=f.lineNumber,U=f.column,m=this.getStartState(C);if(!m)return null;const v=this._textModel.getLineContent(C),y=v.substring(0,U-1)+_+v.substring(U-1+S),z=this._textModel.getLanguageIdAtPosition(C,0),E=A(this._languageIdCodec,z,this.tokenizationSupport,y,!0,m);return new o.LineTokens(E.tokens,y,this._languageIdCodec)}isCheapToTokenize(f){const S=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<S||f===S&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,S,_){if(_<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(S<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,_),{heuristicTokens:!1};let C=this.guessStartState(S);const U=this._textModel.getLanguageId();for(let m=S;m<=_;m++){const v=this._textModel.getLineContent(m),y=A(this._languageIdCodec,U,this.tokenizationSupport,v,!0,C);f.add(m,y.tokens),C=y.endState}return{heuristicTokens:!0}}guessStartState(f){let S=this._textModel.getLineFirstNonWhitespaceColumn(f);const _=[];let C=null;for(let v=f-1;S>1&&v>=1;v--){const y=this._textModel.getLineFirstNonWhitespaceColumn(v);if(y!==0&&y<S&&(_.push(this._textModel.getLineContent(v)),S=y,C=this.getStartState(v),C))break}C||(C=this.tokenizationSupport.getInitialState()),_.reverse();const U=this._textModel.getLanguageId();let m=C;for(const v of _)m=A(this._languageIdCodec,U,this.tokenizationSupport,v,!1,m).endState;return m}}e.TokenizerWithStateStoreAndTextModel=n;class s{constructor(f){this.lineCount=f,this._tokenizationStateStore=new b,this._invalidEndStatesLineNumbers=new O,this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(1,f+1))}getEndState(f){return this._tokenizationStateStore.getEndState(f)}setEndState(f,S){if(!S)throw new w.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(f);const _=this._tokenizationStateStore.setEndState(f,S);return _&&f<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f+1,f+2)),_}acceptChange(f,S){this.lineCount+=S-f.length,this._tokenizationStateStore.acceptChange(f,S),this._invalidEndStatesLineNumbers.addRangeAndResize(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive),S)}acceptChanges(f){for(const S of f){const[_]=(0,r.countEOL)(S.text);this.acceptChange(new c.LineRange(S.range.startLineNumber,S.range.endLineNumber+1),_+1)}}invalidateEndStateRange(f){this._invalidEndStatesLineNumbers.addRange(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(f,S){return f===1?S:this.getEndState(f-1)}getFirstInvalidLine(f){const S=this.getFirstInvalidEndStateLineNumber();if(S===null)return null;const _=this.getStartState(S,f);if(!_)throw new w.BugIndicatingError("Start state must be defined");return{lineNumber:S,startState:_}}}e.TrackingTokenizationStateStore=s;class b{constructor(){this._lineEndStates=new g.FixedArray(null)}getEndState(f){return this._lineEndStates.get(f)}setEndState(f,S){const _=this._lineEndStates.get(f);return _&&_.equals(S)?!1:(this._lineEndStates.set(f,S),!0)}acceptChange(f,S){let _=f.length;S>0&&_>0&&(_--,S--),this._lineEndStates.replace(f.startLineNumber,_,S)}acceptChanges(f){for(const S of f){const[_]=(0,r.countEOL)(S.text);this.acceptChange(new c.LineRange(S.range.startLineNumber,S.range.endLineNumber+1),_+1)}}}e.TokenizationStateStore=b;class O{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const f=this._ranges[0];return f.start+1===f.endExclusive?this._ranges.shift():this._ranges[0]=new t.OffsetRange(f.start+1,f.endExclusive),f.start}delete(f){const S=this._ranges.findIndex(_=>_.contains(f));if(S!==-1){const _=this._ranges[S];_.start===f?_.endExclusive===f+1?this._ranges.splice(S,1):this._ranges[S]=new t.OffsetRange(f+1,_.endExclusive):_.endExclusive===f+1?this._ranges[S]=new t.OffsetRange(_.start,f):this._ranges.splice(S,1,new t.OffsetRange(_.start,f),new t.OffsetRange(f+1,_.endExclusive))}}addRange(f){t.OffsetRange.addRange(f,this._ranges)}addRangeAndResize(f,S){let _=0;for(;!(_>=this._ranges.length||f.start<=this._ranges[_].endExclusive);)_++;let C=_;for(;!(C>=this._ranges.length||f.endExclusive<this._ranges[C].start);)C++;const U=S-f.length;for(let m=C;m<this._ranges.length;m++)this._ranges[m]=this._ranges[m].delta(U);if(_===C){const m=new t.OffsetRange(f.start,f.start+S);m.isEmpty||this._ranges.splice(_,0,m)}else{const m=Math.min(f.start,this._ranges[_].start),v=Math.max(f.endExclusive,this._ranges[C-1].endExclusive),y=new t.OffsetRange(m,v+U);y.isEmpty?this._ranges.splice(_,C-_):this._ranges.splice(_,C-_,y)}}toString(){return this._ranges.map(f=>f.toString()).join(" + ")}}e.RangePriorityQueueImpl=O;function A(L,f,S,_,C,U){let m=null;if(S)try{m=S.tokenizeEncoded(_,C,U.clone())}catch(v){(0,w.onUnexpectedError)(v)}return m||(m=(0,l.nullTokenizeEncoded)(L.encodeLanguageId(f),U)),o.LineTokens.convertToEndOffset(m.tokens,_.length),m}class R{constructor(f,S){this._tokenizerWithStateStore=f,this._backgroundTokenStore=S,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,I.runWhenGlobalIdle)(f=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(f)}))}_backgroundTokenizeWithDeadline(f){const S=Date.now()+f.timeRemaining(),_=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<S?(0,k.setTimeout0)(_):this._beginBackgroundTokenization())};_()}_backgroundTokenizeForAtLeast1ms(){const f=this._tokenizerWithStateStore._textModel.getLineCount(),S=new d.ContiguousMultilineTokensBuilder,_=P.StopWatch.create(!1);do if(_.elapsed()>1||this._tokenizeOneInvalidLine(S)>=f)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(S.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(f){const S=this._tokenizerWithStateStore?.getFirstInvalidLine();return S?(this._tokenizerWithStateStore.updateTokensUntilLine(f,S.lineNumber),S.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(f,S){this._tokenizerWithStateStore.store.invalidateEndStateRange(new c.LineRange(f,S))}}e.DefaultBackgroundTokenizer=R}),define(j[38],$([0,1,34,2,37,14,35]),function(q,e,I,w,k,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class c extends w.Disposable{constructor(l,g,d,o,a,i,n){super(),this._grammar=l,this._initialState=g,this._containsEmbeddedLanguages=d,this._createBackgroundTokenizer=o,this._backgroundTokenizerShouldOnlyVerifyTokens=a,this._reportTokenizationTime=i,this._reportSlowTokenization=n,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new I.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(l,g,d){throw new Error("Not supported!")}createBackgroundTokenizer(l,g){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(l,g)}tokenizeEncoded(l,g,d){const o=Math.random()*1e4<1,a=this._reportSlowTokenization||o,i=a?new k.StopWatch(!0):void 0,n=this._grammar.tokenizeLine2(l,d,500);if(a){const b=i.elapsed();(o||b>32)&&this._reportTokenizationTime(b,l.length,o)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${l.substring(0,100)}`),new r.EncodedTokenizationResult(n.tokens,d);if(this._containsEmbeddedLanguages){const b=this._seenLanguages,O=n.tokens;for(let A=0,R=O.length>>>1;A<R;A++){const L=O[(A<<1)+1],f=P.TokenMetadata.getLanguageId(L);b[f]||(b[f]=!0,this._onDidEncounterLanguage.fire(f))}}let s;return d.equals(n.ruleStack)?s=d:s=n.ruleStack,new r.EncodedTokenizationResult(n.tokens,s)}}e.TextMateTokenizationSupport=c}),define(j[39],$([0,1,21,2,11]),function(q,e,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class P extends w.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,t,l){super(),this._encodedLanguageId=c,this._actual=t,this._maxTokenizationLineLength=l,this._register((0,k.keepObserved)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(c,t,l){throw new Error("Not supported!")}tokenizeEncoded(c,t,l){return c.length>=this._maxTokenizationLineLength.get()?(0,I.nullTokenizeEncoded)(this._encodedLanguageId,l):this._actual.tokenizeEncoded(c,t,l)}createBackgroundTokenizer(c,t){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(c,t)}}e.TokenizationSupportWithLineLimit=P}),define(j[40],$([0,1,33,20,11,3,15,48,36,16,7,38,39]),function(q,e,I,w,k,P,r,c,t,l,g,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class a extends c.MirrorTextModel{constructor(s,b,O,A,R,L,f,S){super(s,b,O,A),this._host=R,this._languageId=L,this._encodedLanguageId=f,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,k.observableValue)(this,-1),this._tokenizeDebouncer=new w.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(S,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(s,b){this._languageId=s,this._encodedLanguageId=b,this._resetTokenization()}onEvents(s){super.onEvents(s),this._tokenizerWithStateStore?.store.acceptChanges(s.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(s){this._maxTokenizationLineLength.set(s,void 0)}retokenize(s,b){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new r.LineRange(s,b)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const s=this._languageId,b=this._encodedLanguageId,O=await this._host.getOrCreateGrammar(s,b);if(!(this._isDisposed||s!==this._languageId||b!==this._encodedLanguageId||!O)){if(O.grammar){const A=new o.TokenizationSupportWithLineLimit(this._encodedLanguageId,new d.TextMateTokenizationSupport(O.grammar,O.initialState,!1,void 0,()=>!1,(R,L,f)=>{this._host.reportTokenizationTime(R,s,O.sourceExtensionId,L,f)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new t.TokenizerWithStateStore(this._lines.length,A)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:b}=await(0,I.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=b}const s=new Date().getTime();for(;;){let b=0;const O=new l.ContiguousMultilineTokensBuilder,A=new i;for(;;){const f=this._tokenizerWithStateStore.getFirstInvalidLine();if(f===null||b>200)break;b++;const S=this._lines[f.lineNumber-1],_=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(S,!0,f.startState);if(this._tokenizerWithStateStore.store.setEndState(f.lineNumber,_.endState)){const U=this._diffStateStacksRefEqFn(f.startState,_.endState);A.setState(f.lineNumber,U)}else A.setState(f.lineNumber,null);if(g.LineTokens.convertToEndOffset(_.tokens,S.length),O.add(f.lineNumber,_.tokens),new Date().getTime()-s>20)break}if(b===0)break;const R=A.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,O.serialize(),R),new Date().getTime()-s>20){(0,P.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=a;class i{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(s,b){s===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(b):this._stateDeltas.push({startLineNumber:s,stateDeltas:[b]}),this._lastStartLineNumber=s}getStateDeltas(){return this._stateDeltas}}}),define(j[41],$([0,1,19]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class w{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(P){if(this._scopeNameToLanguageRegistration[P.scopeName]){const r=this._scopeNameToLanguageRegistration[P.scopeName];I.isEqual(r.location,P.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${P.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${P.location.toString()}`)}this._scopeNameToLanguageRegistration[P.scopeName]=P}getGrammarDefinition(P){return this._scopeNameToLanguageRegistration[P]||null}}e.TMScopeRegistry=w}),define(j[42],$([0,1,2,41]),function(q,e,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class k extends I.Disposable{constructor(r,c,t,l){super(),this._host=r,this._initialState=t.INITIAL,this._scopeRegistry=new w.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new t.Registry({onigLib:l,loadGrammar:async g=>{const d=this._scopeRegistry.getGrammarDefinition(g);if(!d)return this._host.logTrace(`No grammar found for scope ${g}`),null;const o=d.location;try{const a=await this._host.readFile(o);return t.parseRawGrammar(a,o.path)}catch(a){return this._host.logError(`Unable to load and parse grammar for scope ${g} from ${o}`,a),null}},getInjections:g=>{const d=g.split(".");let o=[];for(let a=1;a<=d.length;a++){const i=d.slice(0,a).join(".");o=[...o,...this._injections[i]||[]]}return o}}));for(const g of c){if(this._scopeRegistry.register(g),g.injectTo){for(const d of g.injectTo){let o=this._injections[d];o||(this._injections[d]=o=[]),o.push(g.scopeName)}if(g.embeddedLanguages)for(const d of g.injectTo){let o=this._injectedEmbeddedLanguages[d];o||(this._injectedEmbeddedLanguages[d]=o=[]),o.push(g.embeddedLanguages)}}g.language&&this._languageToScope.set(g.language,g.scopeName)}}has(r){return this._languageToScope.has(r)}setTheme(r,c){this._grammarRegistry.setTheme(r,c)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(r,c){const t=this._languageToScope.get(r);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const l=this._scopeRegistry.getGrammarDefinition(t);if(!l)throw new Error(e.missingTMGrammarErrorMessage);const g=l.embeddedLanguages;if(this._injectedEmbeddedLanguages[t]){const a=this._injectedEmbeddedLanguages[t];for(const i of a)for(const n of Object.keys(i))g[n]=i[n]}const d=Object.keys(g).length>0;let o;try{o=await this._grammarRegistry.loadGrammarWithConfiguration(t,c,{embeddedLanguages:g,tokenTypes:l.tokenTypes,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):a}return{languageId:r,grammar:o,initialState:this._initialState,containsEmbeddedLanguages:d,sourceExtensionId:l.sourceExtensionId}}}e.TMGrammarFactory=k}),define(j[49],$([0,1,8,42,40]),function(q,e,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function P(c,t){return new r(c,t)}e.create=P;class r{constructor(t,l){this._createData=l,this._models=new Map,this._grammarCache=[],this._host=t.host;const g=l.grammarDefinitions.map(d=>({location:I.URI.revive(d.location),language:d.language,scopeName:d.scopeName,embeddedLanguages:d.embeddedLanguages,tokenTypes:d.tokenTypes,injectTo:d.injectTo,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors,sourceExtensionId:d.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(g)}async _loadTMGrammarFactory(t){const l=this._createData.textmateMainUri,g=await new Promise((n,s)=>{q([l],n,s)}),d=await new Promise((n,s)=>{q([this._createData.onigurumaMainUri],n,s)}),a=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await d.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>d.createOnigScanner(n),createOnigString:n=>d.createOnigString(n)});return new w.TMGrammarFactory({logTrace:n=>{},logError:(n,s)=>console.error(n,s),readFile:n=>this._host.readFile(n)},t,g,i)}acceptNewModel(t){const l=I.URI.revive(t.uri),g=this;this._models.set(t.controllerId,new k.TextMateWorkerTokenizer(l,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(d,o){const a=await g._grammarFactory;return a?(g._grammarCache[o]||(g._grammarCache[o]=a.createGrammar(d,o)),g._grammarCache[o]):Promise.resolve(null)},setTokensAndStates(d,o,a){g._host.setTokensAndStates(t.controllerId,d,o,a)},reportTokenizationTime(d,o,a,i,n){g._host.reportTokenizationTime(d,o,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,l){this._models.get(t).onEvents(l)}retokenize(t,l,g){this._models.get(t).retokenize(l,g)}acceptModelLanguageChanged(t,l,g){this._models.get(t).onLanguageId(l,g)}acceptRemovedModel(t){const l=this._models.get(t);l&&(l.dispose(),this._models.delete(t))}async acceptTheme(t,l){(await this._grammarFactory)?.setTheme(t,l)}acceptMaxTokenizationLineLength(t,l){this._models.get(t).acceptMaxTokenizationLineLength(l)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c8a36a69377856369f139f39ee56dd3838130fbf/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
